/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/platform","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ee=function(V){for(var t=[],F=0,T=V.length;F<T;F++)t[F]=K[V[F]];return t};const qe=this,We=typeof global=="object"?global:{};var fe;(function(V){V.global=qe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})(fe||(fe={}));var fe;(function(V){class t{constructor(u,N,m){this.type=u,this.detail=N,this.timestamp=m}}V.LoaderEvent=t;class F{constructor(u){this._events=[new t(1,"",u)]}record(u,N){this._events.push(new t(u,N,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=F;class T{record(u,N){}getEvents(){return[]}}T.INSTANCE=new T,V.NullLoaderEventRecorder=T})(fe||(fe={}));var fe;(function(V){class t{static fileUriToFilePath(T,i){if(i=decodeURI(i).replace(/%23/g,"#"),T){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(T,i){return T.length>=i.length&&T.substr(0,i.length)===i}static endsWith(T,i){return T.length>=i.length&&T.substr(T.length-i.length)===i}static containsQueryString(T){return/^[^\#]*\?/gi.test(T)}static isAbsolutePath(T){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(T)}static forEachProperty(T,i){if(T){let u;for(u in T)T.hasOwnProperty(u)&&i(u,T[u])}}static isEmpty(T){let i=!0;return t.forEachProperty(T,()=>{i=!1}),i}static recursiveClone(T){if(!T||typeof T!="object"||T instanceof RegExp||!Array.isArray(T)&&Object.getPrototypeOf(T)!==Object.prototype)return T;let i=Array.isArray(T)?[]:{};return t.forEachProperty(T,(u,N)=>{N&&typeof N=="object"?i[u]=t.recursiveClone(N):i[u]=N}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(T){return t.startsWith(T,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})(fe||(fe={}));var fe;(function(V){function t(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}V.ensureError=t;class F{static validateConfigurationOptions(u){function N(m){if(m.phase==="loading"){console.error('Loading "'+m.moduleId+'" failed'),console.error(m),console.error("Here are the modules that depend on it:"),console.error(m.neededBy);return}if(m.phase==="factory"){console.error('The factory function of "'+m.moduleId+'" has thrown an exception'),console.error(m),console.error("Here are the modules that depend on it:"),console.error(m.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=N),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(V.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const m=t(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",u.onError(m),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,N=null){let m=V.Utilities.recursiveClone(N||{});return V.Utilities.forEachProperty(u,(s,l)=>{s==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules<"u"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(l):s==="paths"&&typeof m.paths<"u"?V.Utilities.forEachProperty(l,(g,M)=>m.paths[g]=M):s==="config"&&typeof m.config<"u"?V.Utilities.forEachProperty(l,(g,M)=>m.config[g]=M):m[s]=V.Utilities.recursiveClone(l)}),F.validateConfigurationOptions(m)}}V.ConfigurationOptionsUtil=F;class T{constructor(u,N){if(this._env=u,this.options=F.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let m=this.options.nodeRequire.main.filename,s=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(u,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:u,to:N}):this.sortedPathsRules.push({from:u,to:[N]})}),this.sortedPathsRules.sort((u,N)=>N.from.length-u.from.length)}cloneAndMerge(u){return new T(this._env,F.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let N;for(let m=0,s=this.sortedPathsRules.length;m<s;m++)if(N=this.sortedPathsRules[m],V.Utilities.startsWith(u,N.from)){let l=[];for(let g=0,M=N.to.length;g<M;g++)l.push(N.to[g]+u.substr(N.from.length));return l}return[u]}_addUrlArgsToUrl(u){return V.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let N=0,m=u.length;N<m;N++)u[N]=this._addUrlArgsToUrl(u[N]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let N=u,m;if(!V.Utilities.endsWith(N,".js")&&!V.Utilities.isAbsolutePath(N)){m=this._applyPaths(N);for(let s=0,l=m.length;s<l;s++)this.isBuild()&&m[s]==="empty:"||(V.Utilities.isAbsolutePath(m[s])||(m[s]=this.options.baseUrl+m[s]),!V.Utilities.endsWith(m[s],".js")&&!V.Utilities.containsQueryString(m[s])&&(m[s]=m[s]+".js"))}else!V.Utilities.endsWith(N,".js")&&!V.Utilities.containsQueryString(N)&&(N=N+".js"),m=[N];return this._addUrlArgsIfNecessaryToUrls(m)}requireToUrl(u){let N=u;return V.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],V.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}V.Configuration=T})(fe||(fe={}));var fe;(function(V){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,g,M,f){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new F;let d={callback:M,errorback:f};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(d);return}this._callbackMap[g]=[d],this._scriptLoader.load(l,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(l){let g=this._callbackMap[l];delete this._callbackMap[l];for(let M=0;M<g.length;M++)g[M].callback()}triggerErrorback(l,g){let M=this._callbackMap[l];delete this._callbackMap[l];for(let f=0;f<M.length;f++)M[f].errorback(g)}}class F{attachListeners(l,g,M){let f=()=>{l.removeEventListener("load",d),l.removeEventListener("error",e)},d=w=>{f(),g()},e=w=>{f(),M(w)};l.addEventListener("load",d),l.addEventListener("error",e)}load(l,g,M,f){if(/^node\|/.test(g)){let d=l.getConfig().getOptionsLiteral(),e=N(l.getRecorder(),d.nodeRequire||V.global.nodeRequire),w=g.split("|"),D=null;try{D=e(w[1])}catch(y){f(y);return}l.enqueueDefineAnonymousModule([],()=>D),M()}else{let d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript"),this.attachListeners(d,M,f);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),d.setAttribute("src",g);const{cspNonce:w}=l.getConfig().getOptionsLiteral();w&&d.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(d)}}}function T(s){const{trustedTypesPolicy:l}=s.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=T(l)),this._cachedCanUseEval}load(l,g,M,f){if(/^node\|/.test(g)){const d=l.getConfig().getOptionsLiteral(),e=N(l.getRecorder(),d.nodeRequire||V.global.nodeRequire),w=g.split("|");let D=null;try{D=e(w[1])}catch(y){f(y);return}l.enqueueDefineAnonymousModule([],function(){return D}),M()}else{const{trustedTypesPolicy:d}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(g).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${g}`,(d?self.eval(d.createScript("",w)):new Function(w)).call(self),M()}).then(void 0,f);return}try{d&&(g=d.createScriptURL(g)),importScripts(g),M()}catch(w){f(w)}}}}class u{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,g){const{nodeCachedData:M}=g.getConfig().getOptionsLiteral();if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const f=this,d=l("module");function e(w){const D=w.constructor;let y=function(R){try{return w.require(R)}finally{}};return y.resolve=function(R,b){return D._resolveFilename(R,w,!1,b)},y.resolve.paths=function(R){return D._resolveLookupPaths(R,w)},y.main=process.mainModule,y.extensions=D._extensions,y.cache=D._cache,y}d.prototype._compile=function(w,D){const y=d.wrap(w.replace(/^#!.*/,"")),v=g.getRecorder(),R=f._getCachedDataPath(M,D),b={filename:D};let _;try{const o=f._fs.readFileSync(R);_=o.slice(0,16),b.cachedData=o.slice(16),v.record(60,R)}catch{v.record(61,R)}const r=new f._vm.Script(y,b),a=r.runInThisContext(b),A=f._path.dirname(D),h=e(this),L=[this.exports,h,this,D,A,process,We,Buffer],c=a.apply(this.exports,L);return f._handleCachedData(r,y,R,!b.cachedData,g),f._verifyCachedData(r,y,R,_,g),c}}load(l,g,M,f){const d=l.getConfig().getOptionsLiteral(),e=N(l.getRecorder(),d.nodeRequire||V.global.nodeRequire),w=d.nodeInstrumenter||function(y){return y};this._init(e),this._initNodeRequire(e,l);let D=l.getRecorder();if(/^node\|/.test(g)){let y=g.split("|"),v=null;try{v=e(y[1])}catch(R){f(R);return}l.enqueueDefineAnonymousModule([],()=>v),M()}else{g=V.Utilities.fileUriToFilePath(this._env.isWindows,g);const y=this._path.normalize(g),v=this._getElectronRendererScriptPathOrUri(y),R=!!d.nodeCachedData,b=R?this._getCachedDataPath(d.nodeCachedData,g):void 0;this._readSourceAndCachedData(y,b,D,(_,r,a,A)=>{if(_){f(_);return}let h;r.charCodeAt(0)===u._BOM?h=u._PREFIX+r.substring(1)+u._SUFFIX:h=u._PREFIX+r+u._SUFFIX,h=w(h,y);const L={filename:v,cachedData:a},c=this._createAndEvalScript(l,h,L,M,f);this._handleCachedData(c,h,b,R&&!a,l),this._verifyCachedData(c,h,b,A,l)})}}_createAndEvalScript(l,g,M,f,d){const e=l.getRecorder();e.record(31,M.filename);const w=new this._vm.Script(g,M),D=w.runInThisContext(M),y=l.getGlobalAMDDefineFunc();let v=!1;const R=function(){return v=!0,y.apply(null,arguments)};return R.amd=y.amd,D.call(V.global,l.getGlobalAMDRequireFunc(),R,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),v?f():d(new Error(`Didn't receive define call in ${M.filename}!`)),w}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let g=l.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,g){const M=this._crypto.createHash("md5").update(g,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),f=this._path.basename(g).replace(/\.js$/,"");return this._path.join(l.path,`${f}-${M}.code`)}_handleCachedData(l,g,M,f,d){l.cachedDataRejected?this._fs.unlink(M,e=>{d.getRecorder().record(62,M),this._createAndWriteCachedData(l,g,M,d),e&&d.getConfig().onError(e)}):f&&this._createAndWriteCachedData(l,g,M,d)}_createAndWriteCachedData(l,g,M,f){let d=Math.ceil(f.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,w=0,D;const y=()=>{setTimeout(()=>{D||(D=this._crypto.createHash("md5").update(g,"utf8").digest());const v=l.createCachedData();if(!(v.length===0||v.length===e||w>=5)){if(v.length<e){y();return}e=v.length,this._fs.writeFile(M,Buffer.concat([D,v]),R=>{R&&f.getConfig().onError(R),f.getRecorder().record(63,M),y()})}},d*Math.pow(4,w++))};y()}_readSourceAndCachedData(l,g,M,f){if(!g)this._fs.readFile(l,{encoding:"utf8"},f);else{let d,e,w,D=2;const y=v=>{v?f(v):--D===0&&f(void 0,d,e,w)};this._fs.readFile(l,{encoding:"utf8"},(v,R)=>{d=R,y(v)}),this._fs.readFile(g,(v,R)=>{!v&&R&&R.length>0?(w=R.slice(0,16),e=R.slice(16),M.record(60,g)):M.record(61,g),y()})}}_verifyCachedData(l,g,M,f,d){f&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();f.equals(e)||(d.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${M}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(M,w=>{w&&d.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function N(s,l){if(l.__$__isRecorded)return l;const g=function(f){s.record(33,f);try{return l(f)}finally{s.record(34,f)}};return g.__$__isRecorded=!0,g}V.ensureRecordedNodeRequire=N;function m(s){return new t(s)}V.createScriptLoader=m})(fe||(fe={}));var fe;(function(V){class t{constructor(s){let l=s.lastIndexOf("/");l!==-1?this.fromModulePath=s.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(s){let l=s,g;for(g=/\/\.\//;g.test(l);)l=l.replace(g,"/");for(l=l.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(l);)l=l.replace(g,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(s){let l=s;return V.Utilities.isAbsolutePath(l)||(V.Utilities.startsWith(l,"./")||V.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),V.ModuleIdResolver=t;class F{constructor(s,l,g,M,f,d){this.id=s,this.strId=l,this.dependencies=g,this._callback=M,this._errorback=f,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,l){try{return{returnedValue:s.apply(V.global,l),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(s,l,g,M){return s.shouldInvokeFactory(l)?s.shouldCatchError()?this._safeInvokeFunction(g,M):{returnedValue:g.apply(V.global,M),producedError:null}:{returnedValue:null,producedError:null}}complete(s,l,g,M){this._isComplete=!0;let f=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let d=F._invokeFactory(l,this.strId,this._callback,g);f=d.producedError,s.record(22,this.strId),!f&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(f){let d=V.ensureError(f);d.phase="factory",d.moduleId=this.strId,d.neededBy=M(this.id),this.error=d,l.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}V.Module=F;class T{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let l=this._strModuleIdToIntModuleId.get(s);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(s,l),this._intModuleIdToStrModuleId[l]=s),l}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),V.RegularDependency=i;class u{constructor(s,l,g){this.id=s,this.pluginId=l,this.pluginParam=g}}V.PluginDependency=u;class N{constructor(s,l,g,M,f=0){this._env=s,this._scriptLoader=l,this._loaderAvailableTimestamp=f,this._defineFunc=g,this._requireFunc=M,this._moduleIdProvider=new T,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,l){let g=d=>d.replace(/\\/g,"/"),M=g(s),f=l.split(/\n/);for(let d=0;d<f.length;d++){let e=f[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){let w=e[1],D=e[2],y=e[3],v=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(v),w=g(w),w===M){let R={line:parseInt(D,10),col:parseInt(y,10)};return R.line===1&&(R.col-=53),R}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],l=0;for(let g=0,M=this._modules2.length;g<M;g++){let f=this._modules2[g];if(!f)continue;let d=this._buildInfoPath[f.id]||null,e=this._buildInfoDefineStack[f.id]||null,w=this._buildInfoDependencies[f.id];s[l++]={id:f.strId,path:d,defineLocation:d&&e?N._findRelevantLocationInStack(d,e):null,dependencies:w,shim:null,exports:f.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:s,callback:l}}defineModule(s,l,g,M,f,d=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let w=new F(e,s,this._normalizeDependencies(l,d),g,M,d);this._modules2[e]=w,this._config.isBuild()&&(this._buildInfoDefineStack[e]=f,this._buildInfoDependencies[e]=(w.dependencies||[]).map(D=>this._moduleIdProvider.getStrModuleId(D.id))),this._resolve(w)}_normalizeDependency(s,l){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let g=s.indexOf("!");if(g>=0){let M=l.resolveModule(s.substr(0,g)),f=l.resolveModule(s.substr(g+1)),d=this._moduleIdProvider.getModuleId(M+"!"+f),e=this._moduleIdProvider.getModuleId(M);return new u(d,e,f)}return new i(this._moduleIdProvider.getModuleId(l.resolveModule(s)))}_normalizeDependencies(s,l){let g=[],M=0;for(let f=0,d=s.length;f<d;f++)g[M++]=this._normalizeDependency(s[f],l);return g}_relativeRequire(s,l,g,M){if(typeof l=="string")return this.synchronousRequire(l,s);this.defineModule(V.Utilities.generateAnonymousModule(),l,g,M,null,s)}synchronousRequire(s,l=new t(s)){let g=this._normalizeDependency(s,l),M=this._modules2[g.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports}configure(s,l){let g=this._config.shouldRecordStats();l?this._config=new V.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),l.dependencies,l.callback,null,l.stack)}}_createLoadError(s,l){let g=this._moduleIdProvider.getStrModuleId(s),M=(this._inverseDependencies2[s]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));const f=V.ensureError(l);return f.phase="loading",f.moduleId=g,f.neededBy=M,f}_onLoadError(s,l){const g=this._createLoadError(s,l);this._modules2[s]||(this._modules2[s]=new F(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let M=[];for(let e=0,w=this._moduleIdProvider.getMaxModuleId();e<w;e++)M[e]=!1;let f=!1,d=[];for(d.push(s),M[s]=!0;d.length>0;){let e=d.shift(),w=this._modules2[e];w&&(f=w.onDependencyError(g)||f);let D=this._inverseDependencies2[e];if(D)for(let y=0,v=D.length;y<v;y++){let R=D[y];M[R]||(d.push(R),M[R]=!0)}}f||this._config.onError(g)}_hasDependencyPath(s,l){let g=this._modules2[s];if(!g)return!1;let M=[];for(let d=0,e=this._moduleIdProvider.getMaxModuleId();d<e;d++)M[d]=!1;let f=[];for(f.push(g),M[s]=!0;f.length>0;){let e=f.shift().dependencies;if(e)for(let w=0,D=e.length;w<D;w++){let y=e[w];if(y.id===l)return!0;let v=this._modules2[y.id];v&&!M[y.id]&&(M[y.id]=!0,f.push(v))}}return!1}_findCyclePath(s,l,g){if(s===l||g===50)return[s];let M=this._modules2[s];if(!M)return null;let f=M.dependencies;if(f)for(let d=0,e=f.length;d<e;d++){let w=this._findCyclePath(f[d].id,l,g+1);if(w!==null)return w.push(s),w}return null}_createRequire(s){let l=(g,M,f)=>this._relativeRequire(s,g,M,f);return l.toUrl=g=>this._config.requireToUrl(s.resolveModule(g)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(g,M=!1)=>{this.configure(g,M)},l.__$__nodeRequire=V.global.nodeRequire,l}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let l=this._moduleIdProvider.getStrModuleId(s),g=this._config.moduleIdToPaths(l),M=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||M.test(l))&&g.push("node|"+l);let f=-1,d=e=>{if(f++,f>=g.length)this._onLoadError(s,e);else{let w=g[f],D=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[s]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}D.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=w),D.record(11,w),this._onLoad(s)},y=>{D.record(12,w),d(y)})}};d(null)}_loadPluginDependency(s,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let g=M=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],M,null,null)};g.error=M=>{this._config.onError(this._createLoadError(l.id,M))},s.load(l.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(s){let l=s.dependencies;if(l)for(let g=0,M=l.length;g<M;g++){let f=l[g];if(f===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(f===i.MODULE){s.unresolvedDependenciesCount--;continue}if(f===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let d=this._modules2[f.id];if(d&&d.isComplete()){if(d.error){s.onDependencyError(d.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(f.id,s.id,0)||[];e.reverse(),e.push(f.id),console.warn(e.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(s.id),f instanceof u){let e=this._modules2[f.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,f);continue}let w=this._inversePluginDependencies2.get(f.pluginId);w||(w=[],this._inversePluginDependencies2.set(f.pluginId,w)),w.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let l=this.getRecorder();if(s.isComplete())return;let g=s.dependencies,M=[];if(g)for(let w=0,D=g.length;w<D;w++){let y=g[w];if(y===i.EXPORTS){M[w]=s.exports;continue}if(y===i.MODULE){M[w]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(y===i.REQUIRE){M[w]=this._createRequire(s.moduleIdResolver);continue}let v=this._modules2[y.id];if(v){M[w]=v.exports;continue}M[w]=null}const f=w=>(this._inverseDependencies2[w]||[]).map(D=>this._moduleIdProvider.getStrModuleId(D));s.complete(l,this._config,M,f);let d=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,d)for(let w=0,D=d.length;w<D;w++){let y=d[w],v=this._modules2[y];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let w=0,D=e.length;w<D;w++)this._loadPluginDependency(s.exports,e[w])}}}V.ModuleManager=N})(fe||(fe={}));var Z,fe;(function(V){const t=new V.Environment;let F=null;const T=function(m,s,l){typeof m!="string"&&(l=s,s=m,m=null),(typeof s!="object"||!Array.isArray(s))&&(l=s,s=null),s||(s=["require","exports","module"]),m?F.defineModule(m,s,l,null,null):F.enqueueDefineAnonymousModule(s,l)};T.amd={jQuery:!0};const i=function(m,s=!1){F.configure(m,s)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return F.getConfig().getOptionsLiteral()},u.reset=function(){F=F.reset()},u.getBuildInfo=function(){return F.getBuildInfo()},u.getStats=function(){return F.getLoaderEvents()},u.define=T;function N(){if(typeof V.global.require<"u"||typeof require<"u"){const m=V.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){const s=V.ensureRecordedNodeRequire(F.getRecorder(),m);V.global.nodeRequire=s,u.nodeRequire=s,u.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(V.global.define=T),V.global.require=u)}V.init=N,(typeof V.global.define!="function"||!V.global.define.amd)&&(F=new V.ModuleManager(t,V.createScriptLoader(t),T,u,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&u.config(V.global.require),Z=function(){return T.apply(null,arguments)},Z.amd=T.amd,typeof doNotInitLoader>"u"&&N())})(fe||(fe={})),Z(K[58],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(m,s,l,g){if(g=g||{},(g["vs/css"]||{}).disabled){l({});return}const f=s.toUrl(m+".css");T(m,f,()=>{l({})},d=>{typeof l.error=="function"&&l.error("Could not find "+f+".")})}t.load=F;function T(m,s,l,g){if(i(m,s)){l();return}u(m,s,l,g)}function i(m,s){const l=document.getElementsByTagName("link");for(let g=0,M=l.length;g<M;g++){const f=l[g].getAttribute("data-name"),d=l[g].getAttribute("href");if(f===m||d===s)return!0}return!1}function u(m,s,l,g){const M=document.createElement("link");M.setAttribute("rel","stylesheet"),M.setAttribute("type","text/css"),M.setAttribute("data-name",m),N(m,M,l,g),M.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(M)}function N(m,s,l,g){const M=()=>{s.removeEventListener("load",f),s.removeEventListener("error",d)},f=e=>{M(),l()},d=e=>{M(),g(e)};s.addEventListener("load",f),s.addEventListener("error",d)}}),Z("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const T="i-default";function i(e,w){let D;return w.length===0?D=e:D=e.replace(/\{(\d+)\}/g,(y,v)=>{const R=v[0],b=w[R];let _=y;return typeof b=="string"?_=b:(typeof b=="number"||typeof b=="boolean"||b===void 0||b===null)&&(_=String(b)),_}),F&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function u(e,w){let D=e[w];return D||(D=e["*"],D)?D:null}function N(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function m(e,w,D){const y=N(e)+N(w)+"vscode/"+N(D),v=await fetch(y);if(v.ok)return await v.json();throw new Error(`${v.status} - ${v.statusText}`)}function s(e){return function(w,D){const y=Array.prototype.slice.call(arguments,2);return i(e[w],y)}}function l(e,w,...D){return i(w,D)}t.localize=l;function g(e){}t.getConfiguredDefaultLocale=g;function M(e){F=e}t.setPseudoTranslation=M;function f(e,w){return{localize:s(w[e]),getConfiguredDefaultLocale:w.getConfiguredDefaultLocale??(D=>{})}}t.create=f;function d(e,w,D,y){const v=y["vs/nls"]??{};if(!e||e.length===0)return D({localize:l,getConfiguredDefaultLocale:()=>v.availableLanguages?.["*"]});const R=v.availableLanguages?u(v.availableLanguages,e):null,b=R===null||R===T;let _=".nls";b||(_=_+"."+R);const r=a=>{Array.isArray(a)?a.localize=s(a):a.localize=s(a[e]),a.getConfiguredDefaultLocale=()=>v.availableLanguages?.["*"],D(a)};typeof v.loadBundle=="function"?v.loadBundle(e,R,(a,A)=>{a?w([e+".nls"],r):r(A)}):v.translationServiceUrl&&!b?(async()=>{try{const a=await m(v.translationServiceUrl,R,e);return r(a)}catch(a){if(!R.includes("-"))return console.error(a),w([e+".nls"],r);try{const A=R.split("-")[0],h=await m(v.translationServiceUrl,A,e);return v.availableLanguages??={},v.availableLanguages["*"]=A,r(h)}catch(A){return console.error(A),w([e+".nls"],r)}}})():w([e+_],r,a=>{if(_===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${R}. Falling back to the default language:`,a),w([e+".nls"],r)})}t.load=d}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../",F=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:l=>l,createScript:(l,...g)=>{const M=g.slice(0,-1).join(","),f=g.pop().toString();return`(function anonymous(${M}) { ${f}
})`}}):void 0;function T(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function i(){return new Promise((l,g)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return l();const M=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(M)&&M.substring(0,globalThis.origin.length)!==globalThis.origin)&&T()){fetch(M).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${M}`,(F?globalThis.eval(F.createScript("",d)):new Function(d)).call(globalThis),l()}).then(void 0,g);return}F?importScripts(F.createScriptURL(M)):importScripts(M),l()})}function u(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function N(l){i().then(()=>{u(),require([l],function(g){setTimeout(function(){const M=g.create((f,d)=>{globalThis.postMessage(f,d)},null);for(globalThis.onmessage=f=>M.onmessage(f.data,f.ports);s.length>0;){const f=s.shift();M.onmessage(f.data,f.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&u();let m=!0;const s=[];globalThis.onmessage=l=>{if(!m){s.push(l);return}m=!1,N(l.data)}}(),Z(K[27],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function F(m,s){const l=Math.pow(10,s);return Math.round(m*l)/l}class T{constructor(s,l,g,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=F(Math.max(Math.min(1,M),0),3)}static equals(s,l){return s.r===l.r&&s.g===l.g&&s.b===l.b&&s.a===l.a}}t.RGBA=T;class i{constructor(s,l,g,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.l=F(Math.max(Math.min(1,g),0),3),this.a=F(Math.max(Math.min(1,M),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.l===l.l&&s.a===l.a}static fromRGBA(s){const l=s.r/255,g=s.g/255,M=s.b/255,f=s.a,d=Math.max(l,g,M),e=Math.min(l,g,M);let w=0,D=0;const y=(e+d)/2,v=d-e;if(v>0){switch(D=Math.min(y<=.5?v/(2*y):v/(2-2*y),1),d){case l:w=(g-M)/v+(g<M?6:0);break;case g:w=(M-l)/v+2;break;case M:w=(l-g)/v+4;break}w*=60,w=Math.round(w)}return new i(w,D,y,f)}static _hue2rgb(s,l,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?s+(l-s)*6*g:g<1/2?l:g<2/3?s+(l-s)*(2/3-g)*6:s}static toRGBA(s){const l=s.h/360,{s:g,l:M,a:f}=s;let d,e,w;if(g===0)d=e=w=M;else{const D=M<.5?M*(1+g):M+g-M*g,y=2*M-D;d=i._hue2rgb(y,D,l+1/3),e=i._hue2rgb(y,D,l),w=i._hue2rgb(y,D,l-1/3)}return new T(Math.round(d*255),Math.round(e*255),Math.round(w*255),f)}}t.HSLA=i;class u{constructor(s,l,g,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.v=F(Math.max(Math.min(1,g),0),3),this.a=F(Math.max(Math.min(1,M),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.v===l.v&&s.a===l.a}static fromRGBA(s){const l=s.r/255,g=s.g/255,M=s.b/255,f=Math.max(l,g,M),d=Math.min(l,g,M),e=f-d,w=f===0?0:e/f;let D;return e===0?D=0:f===l?D=((g-M)/e%6+6)%6:f===g?D=(M-l)/e+2:D=(l-g)/e+4,new u(Math.round(D*60),w,f,s.a)}static toRGBA(s){const{h:l,s:g,v:M,a:f}=s,d=M*g,e=d*(1-Math.abs(l/60%2-1)),w=M-d;let[D,y,v]=[0,0,0];return l<60?(D=d,y=e):l<120?(D=e,y=d):l<180?(y=d,v=e):l<240?(y=e,v=d):l<300?(D=e,v=d):l<=360&&(D=d,v=e),D=Math.round((D+w)*255),y=Math.round((y+w)*255),v=Math.round((v+w)*255),new T(D,y,v,f)}}t.HSVA=u;class N{static fromHex(s){return N.Format.CSS.parseHex(s)||N.red}static equals(s,l){return!s&&!l?!0:!s||!l?!1:s.equals(l)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:u.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof T)this.rgba=s;else if(s instanceof i)this._hsla=s,this.rgba=i.toRGBA(s);else if(s instanceof u)this._hsva=s,this.rgba=u.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&T.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&u.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=N._relativeLuminanceForComponent(this.rgba.r),l=N._relativeLuminanceForComponent(this.rgba.g),g=N._relativeLuminanceForComponent(this.rgba.b),M=.2126*s+.7152*l+.0722*g;return F(M,4)}static _relativeLuminanceForComponent(s){const l=s/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(s){const l=this.getRelativeLuminance(),g=s.getRelativeLuminance();return l>g?(l+.05)/(g+.05):(g+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const l=this.getRelativeLuminance(),g=s.getRelativeLuminance();return l>g}isDarkerThan(s){const l=this.getRelativeLuminance(),g=s.getRelativeLuminance();return l<g}lighten(s){return new N(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new N(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:l,g,b:M,a:f}=this.rgba;return new N(new T(l,g,M,f*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const l=s.rgba,g=this.rgba.a,M=l.a,f=g+M*(1-g);if(f<1e-6)return N.transparent;const d=this.rgba.r*g/f+l.r*M*(1-g)/f,e=this.rgba.g*g/f+l.g*M*(1-g)/f,w=this.rgba.b*g/f+l.b*M*(1-g)/f;return new N(new T(d,e,w,f))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:l,g,b:M,a:f}=this.rgba;return new N(new T(s.rgba.r-f*(s.rgba.r-l),s.rgba.g-f*(s.rgba.g-g),s.rgba.b-f*(s.rgba.b-M),1))}flatten(...s){const l=s.reduceRight((g,M)=>N._flatten(M,g));return N._flatten(this,l)}static _flatten(s,l){const g=1-s.rgba.a;return new N(new T(g*l.rgba.r+s.rgba.a*s.rgba.r,g*l.rgba.g+s.rgba.a*s.rgba.g,g*l.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this._toString||(this._toString=N.Format.CSS.format(this)),this._toString}static getLighterColor(s,l,g){if(s.isLighterThan(l))return s;g=g||.5;const M=s.getRelativeLuminance(),f=l.getRelativeLuminance();return g=g*(f-M)/f,s.lighten(g)}static getDarkerColor(s,l,g){if(s.isDarkerThan(l))return s;g=g||.5;const M=s.getRelativeLuminance(),f=l.getRelativeLuminance();return g=g*(M-f)/M,s.darken(g)}}t.Color=N,N.white=new N(new T(255,255,255,1)),N.black=new N(new T(0,0,0,1)),N.red=new N(new T(255,0,0,1)),N.blue=new N(new T(0,0,255,1)),N.green=new N(new T(0,255,0,1)),N.cyan=new N(new T(0,255,255,1)),N.lightgrey=new N(new T(211,211,211,1)),N.transparent=new N(new T(0,0,0,0)),function(m){let s;(function(l){let g;(function(M){function f(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:m.Format.CSS.formatRGBA(r)}M.formatRGB=f;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}M.formatRGBA=d;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:m.Format.CSS.formatHSLA(r)}M.formatHSL=e;function w(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}M.formatHSLA=w;function D(r){const a=r.toString(16);return a.length!==2?"0"+a:a}function y(r){return`#${D(r.rgba.r)}${D(r.rgba.g)}${D(r.rgba.b)}`}M.formatHex=y;function v(r,a=!1){return a&&r.rgba.a===1?m.Format.CSS.formatHex(r):`#${D(r.rgba.r)}${D(r.rgba.g)}${D(r.rgba.b)}${D(Math.round(r.rgba.a*255))}`}M.formatHexA=v;function R(r){return r.isOpaque()?m.Format.CSS.formatHex(r):m.Format.CSS.formatRGBA(r)}M.format=R;function b(r){const a=r.length;if(a===0||r.charCodeAt(0)!==35)return null;if(a===7){const A=16*_(r.charCodeAt(1))+_(r.charCodeAt(2)),h=16*_(r.charCodeAt(3))+_(r.charCodeAt(4)),L=16*_(r.charCodeAt(5))+_(r.charCodeAt(6));return new m(new T(A,h,L,1))}if(a===9){const A=16*_(r.charCodeAt(1))+_(r.charCodeAt(2)),h=16*_(r.charCodeAt(3))+_(r.charCodeAt(4)),L=16*_(r.charCodeAt(5))+_(r.charCodeAt(6)),c=16*_(r.charCodeAt(7))+_(r.charCodeAt(8));return new m(new T(A,h,L,c/255))}if(a===4){const A=_(r.charCodeAt(1)),h=_(r.charCodeAt(2)),L=_(r.charCodeAt(3));return new m(new T(16*A+A,16*h+h,16*L+L))}if(a===5){const A=_(r.charCodeAt(1)),h=_(r.charCodeAt(2)),L=_(r.charCodeAt(3)),c=_(r.charCodeAt(4));return new m(new T(16*A+A,16*h+h,16*L+L,(16*c+c)/255))}return null}M.parseHex=b;function _(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=l.CSS||(l.CSS={}))})(s=m.Format||(m.Format={}))}(N||(t.Color=N={}))}),Z(K[28],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class F{constructor(i,u,N,m){this.originalStart=i,this.originalLength=u,this.modifiedStart=N,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=F}),Z(K[3],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class F{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?b.isErrorNoTelemetry(a)?new b(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(A=>{A(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}t.ErrorHandler=F,t.errorHandler=new F;function T(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=T;function i(r){if(!r||typeof r!="object")return!1;const a=r;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){l(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function N(r){l(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=N;function m(r){if(r instanceof Error){const{name:a,message:A}=r,h=r.stacktrace||r.stack;return{$isError:!0,name:a,message:A,stack:h,noTelemetry:b.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=m;const s="Canceled";function l(r){return r instanceof g?!0:r instanceof Error&&r.name===s&&r.message===s}t.isCancellationError=l;class g extends Error{constructor(){super(s),this.name=this.message}}t.CancellationError=g;function M(){const r=new Error(s);return r.name=r.message,r}t.canceled=M;function f(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=f;function d(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=d;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function w(r){const a=new Error(`${r} has been disposed`);return a.name="DISPOSED",a}t.disposed=w;function D(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=D;class y extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.NotImplementedError=y;class v extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.NotSupportedError=v;class R extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=R;class b extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof b)return a;const A=new b;return A.message=a.message,A.stack=a.stack,A}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.ErrorNoTelemetry=b;class _ extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,_.prototype)}}t.BugIndicatingError=_}),Z(K[29],ee([0,1,3]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function T(C,U=0){return C[C.length-(1+U)]}t.tail=T;function i(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}t.tail2=i;function u(C,U,O=(x,z)=>x===z){if(C===U)return!0;if(!C||!U||C.length!==U.length)return!1;for(let x=0,z=C.length;x<z;x++)if(!O(C[x],U[x]))return!1;return!0}t.equals=u;function N(C,U){const O=C.length-1;U<O&&(C[U]=C[O]),C.pop()}t.removeFastWithoutKeepingOrder=N;function m(C,U,O){return s(C.length,x=>O(C[x],U))}t.binarySearch=m;function s(C,U){let O=0,x=C-1;for(;O<=x;){const z=(O+x)/2|0,ne=U(z);if(ne<0)O=z+1;else if(ne>0)x=z-1;else return z}return-(O+1)}t.binarySearch2=s;function l(C,U){let O=0,x=C.length;if(x===0)return 0;for(;O<x;){const z=Math.floor((O+x)/2);U(C[z])?x=z:O=z+1}return O}t.findFirstInSorted=l;function g(C,U,O){if(C=C|0,C>=U.length)throw new TypeError("invalid index");const x=U[Math.floor(U.length*Math.random())],z=[],ne=[],ie=[];for(const ae of U){const ce=O(ae,x);ce<0?z.push(ae):ce>0?ne.push(ae):ie.push(ae)}return C<z.length?g(C,z,O):C<z.length+ie.length?ie[0]:g(C-(z.length+ie.length),ne,O)}t.quickSelect=g;function M(C,U){const O=[];let x;for(const z of C.slice(0).sort(U))!x||U(x[0],z)!==0?(x=[z],O.push(x)):x.push(z);return O}t.groupBy=M;function f(C,U,O){const x=[];function z(ae,ce,he){if(ce===0&&he.length===0)return;const ve=x[x.length-1];ve&&ve.start+ve.deleteCount===ae?(ve.deleteCount+=ce,ve.toInsert.push(...he)):x.push({start:ae,deleteCount:ce,toInsert:he})}let ne=0,ie=0;for(;;){if(ne===C.length){z(ne,0,U.slice(ie));break}if(ie===U.length){z(ne,C.length-ne,[]);break}const ae=C[ne],ce=U[ie],he=O(ae,ce);he===0?(ne+=1,ie+=1):he<0?(z(ne,1,[]),ne+=1):he>0&&(z(ne,0,[ce]),ie+=1)}return x}t.sortedDiff=f;function d(C,U,O){const x=f(C,U,O),z=[],ne=[];for(const ie of x)z.push(...C.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:z,added:ne}}t.delta=d;function e(C,U,O){if(O===0)return[];const x=C.slice(0,O).sort(U);return D(C,U,x,O,C.length),x}t.top=e;function w(C,U,O,x,z){return O===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const ae=C.length,ce=C.slice(0,O).sort(U);for(let he=O,ve=Math.min(O+x,ae);he<ae;he=ve,ve=Math.min(ve+x,ae)){if(he>O&&await new Promise(De=>setTimeout(De)),z&&z.isCancellationRequested)throw new F.CancellationError;D(C,U,ce,he,ve)}return ce})().then(ne,ie)})}t.topAsync=w;function D(C,U,O,x,z){for(const ne=O.length;x<z;x++){const ie=C[x];if(U(ie,O[ne-1])<0){O.pop();const ae=l(O,ce=>U(ie,ce)<0);O.splice(ae,0,ie)}}}function y(C){return C.filter(U=>!!U)}t.coalesce=y;function v(C){let U=0;for(let O=0;O<C.length;O++)C[O]&&(C[U]=C[O],U+=1);C.length=U}t.coalesceInPlace=v;function R(C,U,O){C.splice(O,0,C.splice(U,1)[0])}t.move=R;function b(C){return!Array.isArray(C)||C.length===0}t.isFalsyOrEmpty=b;function _(C){return Array.isArray(C)&&C.length>0}t.isNonEmptyArray=_;function r(C,U=O=>O){const O=new Set;return C.filter(x=>{const z=U(x);return O.has(z)?!1:(O.add(z),!0)})}t.distinct=r;function a(C){const U=new Set;return O=>{const x=C(O);return U.has(x)?!1:(U.add(x),!0)}}t.uniqueFilter=a;function A(C,U){const O=h(C,U);if(O!==-1)return C[O]}t.findLast=A;function h(C,U){for(let O=C.length-1;O>=0;O--){const x=C[O];if(U(x))return O}return-1}t.lastIndex=h;function L(C,U){return C.length>0?C[0]:U}t.firstOrDefault=L;function c(C,U){return C.length>0?C[C.length-1]:U}t.lastOrDefault=c;function o(C,U,O=(x,z)=>x===z){let x=0;for(let z=0,ne=Math.min(C.length,U.length);z<ne&&O(C[z],U[z]);z++)x++;return x}t.commonPrefixLength=o;function p(C){return[].concat(...C)}t.flatten=p;function S(C,U){let O=typeof U=="number"?C:0;typeof U=="number"?O=C:(O=0,U=C);const x=[];if(O<=U)for(let z=O;z<U;z++)x.push(z);else for(let z=O;z>U;z--)x.push(z);return x}t.range=S;function P(C,U,O){return C.reduce((x,z)=>(x[U(z)]=O?O(z):z,x),Object.create(null))}t.index=P;function E(C,U){return C.push(U),()=>I(C,U)}t.insert=E;function I(C,U){const O=C.indexOf(U);if(O>-1)return C.splice(O,1),U}t.remove=I;function B(C,U,O){const x=C.slice(0,U),z=C.slice(U);return x.concat(O,z)}t.arrayInsert=B;function W(C,U){let O;if(typeof U=="number"){let x=U;O=()=>{const z=Math.sin(x++)*179426549;return z-Math.floor(z)}}else O=Math.random;for(let x=C.length-1;x>0;x-=1){const z=Math.floor(O()*(x+1)),ne=C[x];C[x]=C[z],C[z]=ne}}t.shuffle=W;function j(C,U){const O=C.indexOf(U);O>-1&&(C.splice(O,1),C.unshift(U))}t.pushToStart=j;function J(C,U){const O=C.indexOf(U);O>-1&&(C.splice(O,1),C.push(U))}t.pushToEnd=J;function X(C,U){for(const O of U)C.push(O)}t.pushMany=X;function G(C,U){return Array.isArray(C)?C.map(U):U(C)}t.mapArrayOrNot=G;function se(C){return Array.isArray(C)?C:[C]}t.asArray=se;function n(C){return C[Math.floor(Math.random()*C.length)]}t.getRandomElement=n;function me(C,U){for(const O of C){const x=U(O);if(x!==void 0)return x}}t.mapFind=me;function de(C,U,O){const x=_e(C,U),z=C.length,ne=O.length;C.length=z+ne;for(let ie=z-1;ie>=x;ie--)C[ie+ne]=C[ie];for(let ie=0;ie<ne;ie++)C[ie+x]=O[ie]}t.insertInto=de;function be(C,U,O,x){const z=_e(C,U),ne=C.splice(z,O);return de(C,z,x),ne}t.splice=be;function _e(C,U){return U<0?Math.max(U+C.length,0):Math.min(U,C.length)}var pe;(function(C){function U(z){return z<0}C.isLessThan=U;function O(z){return z>0}C.isGreaterThan=O;function x(z){return z===0}C.isNeitherLessOrGreaterThan=x,C.greaterThan=1,C.lessThan=-1,C.neitherLessOrGreaterThan=0})(pe||(t.CompareResult=pe={}));function le(C,U){return(O,x)=>U(C(O),C(x))}t.compareBy=le;function oe(...C){return(U,O)=>{for(const x of C){const z=x(U,O);if(!pe.isNeitherLessOrGreaterThan(z))return z}return pe.neitherLessOrGreaterThan}}t.tieBreakComparators=oe;const we=(C,U)=>C-U;t.numberComparator=we;function Le(C,U){if(C.length===0)return;let O=C[0];for(let x=1;x<C.length;x++){const z=C[x];U(z,O)>0&&(O=z)}return O}t.findMaxBy=Le;function ye(C,U){if(C.length===0)return;let O=C[0];for(let x=1;x<C.length;x++){const z=C[x];U(z,O)>=0&&(O=z)}return O}t.findLastMaxBy=ye;function Fe(C,U){return Le(C,(O,x)=>-U(O,x))}t.findMinBy=Fe;class te{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let O=this.firstIdx;for(;O<this.items.length&&U(this.items[O]);)O++;const x=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,x}takeFromEndWhile(U){let O=this.lastIdx;for(;O>=0&&U(this.items[O]);)O--;const x=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,x}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}removeLast(){const U=this.items[this.lastIdx];return this.lastIdx--,U}takeCount(U){const O=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,O}}t.ArrayQueue=te;class Q{constructor(U){this.iterate=U}forEach(U){this.iterate(O=>(U(O),!0))}toArray(){const U=[];return this.iterate(O=>(U.push(O),!0)),U}filter(U){return new Q(O=>this.iterate(x=>U(x)?O(x):!0))}map(U){return new Q(O=>this.iterate(x=>O(U(x))))}some(U){let O=!1;return this.iterate(x=>(O=U(x),!O)),O}findFirst(U){let O;return this.iterate(x=>U(x)?(O=x,!1):!0),O}findLast(U){let O;return this.iterate(x=>(U(x)&&(O=x),!0)),O}findLastMaxBy(U){let O,x=!0;return this.iterate(z=>((x||pe.isGreaterThan(U(z,O)))&&(x=!1,O=z),!0)),O}}t.CallbackIterable=Q,Q.empty=new Q(C=>{})}),Z(K[11],ee([0,1,3]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function T(s,l){if(!s)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=T;function i(s,l="Unreachable"){throw new Error(l)}t.assertNever=i;function u(s){if(!s)throw new F.BugIndicatingError("Assertion Failed")}t.assert=u;function N(s){if(!s()){debugger;s(),(0,F.onUnexpectedError)(new F.BugIndicatingError("Assertion Failed"))}}t.assertFn=N;function m(s,l){let g=0;for(;g<s.length-1;){const M=s[g],f=s[g+1];if(!l(M,f))return!1;g++}return!0}t.checkAdjacentItems=m}),Z(K[15],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function F(T){const i=this;let u=!1,N;return function(){return u||(u=!0,N=T.apply(i,arguments)),N}}t.once=F}),Z(K[16],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(T){function i(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}T.is=i;const u=Object.freeze([]);function N(){return u}T.empty=N;function*m(b){yield b}T.single=m;function s(b){return i(b)?b:m(b)}T.wrap=s;function l(b){return b||u}T.from=l;function g(b){return!b||b[Symbol.iterator]().next().done===!0}T.isEmpty=g;function M(b){return b[Symbol.iterator]().next().value}T.first=M;function f(b,_){for(const r of b)if(_(r))return!0;return!1}T.some=f;function d(b,_){for(const r of b)if(_(r))return r}T.find=d;function*e(b,_){for(const r of b)_(r)&&(yield r)}T.filter=e;function*w(b,_){let r=0;for(const a of b)yield _(a,r++)}T.map=w;function*D(...b){for(const _ of b)for(const r of _)yield r}T.concat=D;function y(b,_,r){let a=r;for(const A of b)a=_(a,A);return a}T.reduce=y;function*v(b,_,r=b.length){for(_<0&&(_+=b.length),r<0?r+=b.length:r>b.length&&(r=b.length);_<r;_++)yield b[_]}T.slice=v;function R(b,_=Number.POSITIVE_INFINITY){const r=[];if(_===0)return[r,b];const a=b[Symbol.iterator]();for(let A=0;A<_;A++){const h=a.next();if(h.done)return[r,T.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return a}}]}T.consume=R})(F||(t.Iterable=F={}))}),Z(K[30],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(F||(t.KeyCode=F={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,D){this._keyCodeToStr[w]=D,this._strToKeyCode[D.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const u=new i,N=new i,m=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const s=[],l=Object.create(null),g=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>l[e]||0,toString:e=>s[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],y=[];for(const v of w){const[R,b,_,r,a,A,h,L,c]=v;if(y[b]||(y[b]=!0,s[b]=_,l[_]=b,g[_.toLowerCase()]=b,R&&(t.IMMUTABLE_CODE_TO_KEY_CODE[b]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=b))),!D[r]){if(D[r]=!0,!a)throw new Error(`String representation missing for key code ${r} around scan code ${_}`);u.define(r,a),N.define(r,L||a),m.define(r,c||L||a)}A&&(t.EVENT_KEY_CODE_MAP[A]=r),h&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[h]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function w(_){return u.keyCodeToStr(_)}e.toString=w;function D(_){return u.strToKeyCode(_)}e.fromString=D;function y(_){return N.keyCodeToStr(_)}e.toUserSettingsUS=y;function v(_){return m.keyCodeToStr(_)}e.toUserSettingsGeneral=v;function R(_){return N.strToKeyCode(_)||m.strToKeyCode(_)}e.fromUserSettings=R;function b(_){if(_>=98&&_<=113)return null;switch(_){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(_)}e.toElectronAccelerator=b})(M||(t.KeyCodeUtils=M={}));var f;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(f||(t.KeyMod=f={}));function d(e,w){const D=(w&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=d}),Z(K[31],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class F{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=F}),Z(K[7],ee([0,1,15,16]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function N(c){u=c}if(t.setDisposableTracker=N,i){const c="__is_disposable_tracked__";N(new class{trackDisposable(o){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(p)},3e3)}setParent(o,p){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function m(c){return u?.trackDisposable(c),c}function s(c){u?.markAsDisposed(c)}function l(c,o){u?.setParent(c,o)}function g(c,o){if(u)for(const p of c)u.setParent(p,o)}function M(c){return u?.markAsSingleton(c),c}t.markAsSingleton=M;function f(c){return typeof c.dispose=="function"&&c.dispose.length===0}t.isDisposable=f;function d(c){if(T.Iterable.is(c)){const o=[];for(const p of c)if(p)try{p.dispose()}catch(S){o.push(S)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}t.dispose=d;function e(c){for(const o of c)f(o)&&o.dispose();return[]}t.disposeIfDisposable=e;function w(...c){const o=D(()=>d(c));return g(c,o),o}t.combinedDisposable=w;function D(c){const o=m({dispose:(0,F.once)(()=>{s(o),c()})});return o}t.toDisposable=D;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,m(this)}dispose(){this._isDisposed||(s(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return l(o,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}t.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new y,m(this),l(this._store,this)}dispose(){s(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}t.Disposable=v,v.None=Object.freeze({dispose(){}});class R{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&l(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,s(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&l(o,null),o}}t.MutableDisposable=R;class b{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=b;class _{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(o){let p=o;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,s(this))},this}}t.SafeDisposable=_;class r{constructor(){this.references=new Map}acquire(o,...p){let S=this.references.get(o);S||(S={counter:0,object:this.createReferencedObject(o,...p)},this.references.set(o,S));const{object:P}=S,E=(0,F.once)(()=>{--S.counter===0&&(this.destroyReferencedObject(o,S.object),this.references.delete(o))});return S.counter++,{object:P,dispose:E}}}t.ReferenceCollection=r;class a{constructor(o){this.referenceCollection=o}async acquire(o,...p){const S=this.referenceCollection.acquire(o,...p);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(P){throw S.dispose(),P}}}t.AsyncReferenceCollection=a;class A{constructor(o){this.object=o}dispose(){}}t.ImmortalReference=A;function h(c){const o=new y;try{c(o)}finally{o.dispose()}}t.disposeOnReturn=h;class L{constructor(){this._store=new Map,this._isDisposed=!1,m(this)}dispose(){s(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(o){return this._store.has(o)}get(o){return this._store.get(o)}set(o,p,S=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this._store.get(o)?.dispose(),this._store.set(o,p)}deleteAndDispose(o){this._store.get(o)?.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=L}),Z(K[17],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class F{constructor(u){this.element=u,this.next=F.Undefined,this.prev=F.Undefined}}F.Undefined=new F(void 0);class T{constructor(){this._first=F.Undefined,this._last=F.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===F.Undefined}clear(){let u=this._first;for(;u!==F.Undefined;){const N=u.next;u.prev=F.Undefined,u.next=F.Undefined,u=N}this._first=F.Undefined,this._last=F.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,N){const m=new F(u);if(this._first===F.Undefined)this._first=m,this._last=m;else if(N){const l=this._last;this._last=m,m.prev=l,l.next=m}else{const l=this._first;this._first=m,m.next=l,l.prev=m}this._size+=1;let s=!1;return()=>{s||(s=!0,this._remove(m))}}shift(){if(this._first!==F.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==F.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==F.Undefined&&u.next!==F.Undefined){const N=u.prev;N.next=u.next,u.next.prev=N}else u.prev===F.Undefined&&u.next===F.Undefined?(this._first=F.Undefined,this._last=F.Undefined):u.next===F.Undefined?(this._last=this._last.prev,this._last.next=F.Undefined):u.prev===F.Undefined&&(this._first=this._first.next,this._first.prev=F.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==F.Undefined;)yield u.element,u=u.next}}t.LinkedList=T}),Z(K[18],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function F(a){return typeof a=="string"}t.isString=F;function T(a){return Array.isArray(a)&&a.every(A=>F(A))}t.isStringArray=T;function i(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}t.isObject=i;function u(a){const A=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof A}t.isTypedArray=u;function N(a){return typeof a=="number"&&!isNaN(a)}t.isNumber=N;function m(a){return!!a&&typeof a[Symbol.iterator]=="function"}t.isIterable=m;function s(a){return a===!0||a===!1}t.isBoolean=s;function l(a){return typeof a>"u"}t.isUndefined=l;function g(a){return!M(a)}t.isDefined=g;function M(a){return l(a)||a===null}t.isUndefinedOrNull=M;function f(a,A){if(!a)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}t.assertType=f;function d(a){if(M(a))throw new Error("Assertion Failed: argument is undefined or null");return a}t.assertIsDefined=d;function e(...a){const A=[];for(let h=0;h<a.length;h++){const L=a[h];if(M(L))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);A.push(L)}return A}t.assertAllDefined=e;const w=Object.prototype.hasOwnProperty;function D(a){if(!i(a))return!1;for(const A in a)if(w.call(a,A))return!1;return!0}t.isEmptyObject=D;function y(a){return typeof a=="function"}t.isFunction=y;function v(...a){return a.length>0&&a.every(y)}t.areFunctions=v;function R(a,A){const h=Math.min(a.length,A.length);for(let L=0;L<h;L++)b(a[L],A[L])}t.validateConstraints=R;function b(a,A){if(F(A)){if(typeof a!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(y(A)){try{if(a instanceof A)return}catch{}if(!M(a)&&a.constructor===A||A.length===1&&A.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=b;function _(a){return a===null?void 0:a}t.withNullAsUndefined=_;function r(a){return typeof a>"u"?null:a}t.withUndefinedAsNull=r}),Z(K[32],ee([0,1,18]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const T=Object.create(null);function i(m,s){if((0,F.isString)(s)){const l=T[s];if(l===void 0)throw new Error(`${m} references an unknown codicon: ${s}`);s=l}return T[m]=s,{id:m}}function u(){return T}t.getCodiconFontCharacters=u;function N(){return Object.values(t.Codicon)}t.getAllCodicons=N,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Z(K[12],ee([0,1,18]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const v=Array.isArray(y)?[]:{};return Object.entries(y).forEach(([R,b])=>{v[R]=b&&typeof b=="object"?T(b):b}),v}t.deepClone=T;function i(y){if(!y||typeof y!="object")return y;const v=[y];for(;v.length>0;){const R=v.shift();Object.freeze(R);for(const b in R)if(u.call(R,b)){const _=R[b];typeof _=="object"&&!Object.isFrozen(_)&&!(0,F.isTypedArray)(_)&&v.push(_)}}return y}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function N(y,v){return m(y,v,new Set)}t.cloneAndChange=N;function m(y,v,R){if((0,F.isUndefinedOrNull)(y))return y;const b=v(y);if(typeof b<"u")return b;if(Array.isArray(y)){const _=[];for(const r of y)_.push(m(r,v,R));return _}if((0,F.isObject)(y)){if(R.has(y))throw new Error("Cannot clone recursive data-structure");R.add(y);const _={};for(const r in y)u.call(y,r)&&(_[r]=m(y[r],v,R));return R.delete(y),_}return y}function s(y,v,R=!0){return(0,F.isObject)(y)?((0,F.isObject)(v)&&Object.keys(v).forEach(b=>{b in y?R&&((0,F.isObject)(y[b])&&(0,F.isObject)(v[b])?s(y[b],v[b],R):y[b]=v[b]):y[b]=v[b]}),y):v}t.mixin=s;function l(y,v){if(y===v)return!0;if(y==null||v===null||v===void 0||typeof y!=typeof v||typeof y!="object"||Array.isArray(y)!==Array.isArray(v))return!1;let R,b;if(Array.isArray(y)){if(y.length!==v.length)return!1;for(R=0;R<y.length;R++)if(!l(y[R],v[R]))return!1}else{const _=[];for(b in y)_.push(b);_.sort();const r=[];for(b in v)r.push(b);if(r.sort(),!l(_,r))return!1;for(R=0;R<_.length;R++)if(!l(y[_[R]],v[_[R]]))return!1}return!0}t.equals=l;function g(y){const v=new Set;return JSON.stringify(y,(R,b)=>{if((0,F.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}t.safeStringify=g;function M(y,v){const R=Object.create(null);return!y||!v||Object.keys(v).forEach(_=>{const r=y[_],a=v[_];l(r,a)||(R[_]=a)}),R}t.distinct=M;function f(y,v){const R=v.toLowerCase(),b=Object.keys(y).find(_=>_.toLowerCase()===R);return b?y[b]:y[v]}t.getCaseInsensitive=f;function d(y,v){const R=Object.create(null);for(const[b,_]of Object.entries(y))v(b,_)&&(R[b]=_);return R}t.filter=d;function e(y){let v=[],R=Object.getPrototypeOf(y);for(;Object.prototype!==R;)v=v.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return v}t.getAllPropertyNames=e;function w(y){const v=[];for(const R of e(y))typeof y[R]=="function"&&v.push(R);return v}t.getAllMethodNames=w;function D(y,v){const R=_=>function(){const r=Array.prototype.slice.call(arguments,0);return v(_,r)},b={};for(const _ of y)b[_]=R(_);return b}t.createProxyObject=D}),Z(K[19],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var F;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F||(t.Constants=F={}));function T(u){return u<0?0:u>255?255:u|0}t.toUint8=T;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),Z(K[20],ee([0,1,19]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class T{constructor(m){const s=(0,F.toUint8)(m);this._defaultValue=s,this._asciiMap=T._createAsciiMap(s),this._map=new Map}static _createAsciiMap(m){const s=new Uint8Array(256);return s.fill(m),s}set(m,s){const l=(0,F.toUint8)(s);m>=0&&m<256?this._asciiMap[m]=l:this._map.set(m,l)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=T;var i;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(i||(i={}));class u{constructor(){this._actual=new T(0)}add(m){this._actual.set(m,1)}has(m){return this._actual.get(m)===1}clear(){return this._actual.clear()}}t.CharacterSet=u}),Z(K[6],ee([0,1,3]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=void 0;class T{static addRange(u,N){let m=0;for(;m<N.length&&N[m].endExclusive<u.start;)m++;let s=m;for(;s<N.length&&N[s].start<=u.endExclusive;)s++;if(m===s)N.splice(m,0,u);else{const l=Math.min(u.start,N[m].start),g=Math.max(u.endExclusive,N[s-1].endExclusive);N.splice(m,s-m,new T(l,g))}}static tryCreate(u,N){if(!(u>N))return new T(u,N)}constructor(u,N){if(this.start=u,this.endExclusive=N,u>N)throw new F.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(u){return new T(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(u){return this.start===u.start&&this.endExclusive===u.endExclusive}containsRange(u){return this.start<=u.start&&u.endExclusive<=this.endExclusive}contains(u){return this.start<=u&&u<this.endExclusive}join(u){return new T(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}intersect(u){const N=Math.max(this.start,u.start),m=Math.min(this.endExclusive,u.endExclusive);if(N<=m)return new T(N,m)}}t.OffsetRange=T}),Z(K[4],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class F{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new F(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return F.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return F.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return F.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const N=i.lineNumber|0,m=u.lineNumber|0;if(N===m){const s=i.column|0,l=u.column|0;return s-l}return N-m}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new F(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=F}),Z(K[2],ee([0,1,4]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class T{constructor(u,N,m,s){u>m||u===m&&N>s?(this.startLineNumber=m,this.startColumn=s,this.endLineNumber=u,this.endColumn=N):(this.startLineNumber=u,this.startColumn=N,this.endLineNumber=m,this.endColumn=s)}isEmpty(){return T.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return T.containsPosition(this,u)}static containsPosition(u,N){return!(N.lineNumber<u.startLineNumber||N.lineNumber>u.endLineNumber||N.lineNumber===u.startLineNumber&&N.column<u.startColumn||N.lineNumber===u.endLineNumber&&N.column>u.endColumn)}static strictContainsPosition(u,N){return!(N.lineNumber<u.startLineNumber||N.lineNumber>u.endLineNumber||N.lineNumber===u.startLineNumber&&N.column<=u.startColumn||N.lineNumber===u.endLineNumber&&N.column>=u.endColumn)}containsRange(u){return T.containsRange(this,u)}static containsRange(u,N){return!(N.startLineNumber<u.startLineNumber||N.endLineNumber<u.startLineNumber||N.startLineNumber>u.endLineNumber||N.endLineNumber>u.endLineNumber||N.startLineNumber===u.startLineNumber&&N.startColumn<u.startColumn||N.endLineNumber===u.endLineNumber&&N.endColumn>u.endColumn)}strictContainsRange(u){return T.strictContainsRange(this,u)}static strictContainsRange(u,N){return!(N.startLineNumber<u.startLineNumber||N.endLineNumber<u.startLineNumber||N.startLineNumber>u.endLineNumber||N.endLineNumber>u.endLineNumber||N.startLineNumber===u.startLineNumber&&N.startColumn<=u.startColumn||N.endLineNumber===u.endLineNumber&&N.endColumn>=u.endColumn)}plusRange(u){return T.plusRange(this,u)}static plusRange(u,N){let m,s,l,g;return N.startLineNumber<u.startLineNumber?(m=N.startLineNumber,s=N.startColumn):N.startLineNumber===u.startLineNumber?(m=N.startLineNumber,s=Math.min(N.startColumn,u.startColumn)):(m=u.startLineNumber,s=u.startColumn),N.endLineNumber>u.endLineNumber?(l=N.endLineNumber,g=N.endColumn):N.endLineNumber===u.endLineNumber?(l=N.endLineNumber,g=Math.max(N.endColumn,u.endColumn)):(l=u.endLineNumber,g=u.endColumn),new T(m,s,l,g)}intersectRanges(u){return T.intersectRanges(this,u)}static intersectRanges(u,N){let m=u.startLineNumber,s=u.startColumn,l=u.endLineNumber,g=u.endColumn;const M=N.startLineNumber,f=N.startColumn,d=N.endLineNumber,e=N.endColumn;return m<M?(m=M,s=f):m===M&&(s=Math.max(s,f)),l>d?(l=d,g=e):l===d&&(g=Math.min(g,e)),m>l||m===l&&s>g?null:new T(m,s,l,g)}equalsRange(u){return T.equalsRange(this,u)}static equalsRange(u,N){return!u&&!N?!0:!!u&&!!N&&u.startLineNumber===N.startLineNumber&&u.startColumn===N.startColumn&&u.endLineNumber===N.endLineNumber&&u.endColumn===N.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(u){return new F.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(u){return new F.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,N){return new T(this.startLineNumber,this.startColumn,u,N)}setStartPosition(u,N){return new T(u,N,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(u){return new T(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(u){return new T(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new T(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,N=u){return new T(u.lineNumber,u.column,N.lineNumber,N.column)}static lift(u){return u?new T(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,N){return!(u.endLineNumber<N.startLineNumber||u.endLineNumber===N.startLineNumber&&u.endColumn<N.startColumn||N.endLineNumber<u.startLineNumber||N.endLineNumber===u.startLineNumber&&N.endColumn<u.startColumn)}static areIntersecting(u,N){return!(u.endLineNumber<N.startLineNumber||u.endLineNumber===N.startLineNumber&&u.endColumn<=N.startColumn||N.endLineNumber<u.startLineNumber||N.endLineNumber===u.startLineNumber&&N.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,N){if(u&&N){const l=u.startLineNumber|0,g=N.startLineNumber|0;if(l===g){const M=u.startColumn|0,f=N.startColumn|0;if(M===f){const d=u.endLineNumber|0,e=N.endLineNumber|0;if(d===e){const w=u.endColumn|0,D=N.endColumn|0;return w-D}return d-e}return M-f}return l-g}return(u?1:0)-(N?1:0)}static compareRangesUsingEnds(u,N){return u.endLineNumber===N.endLineNumber?u.endColumn===N.endColumn?u.startLineNumber===N.startLineNumber?u.startColumn-N.startColumn:u.startLineNumber-N.startLineNumber:u.endColumn-N.endColumn:u.endLineNumber-N.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=T}),Z(K[13],ee([0,1,3,2]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class i{static fromRange(N){return new i(N.startLineNumber,N.endLineNumber)}static joinMany(N){if(N.length===0)return[];let m=N[0];for(let s=1;s<N.length;s++)m=this.join(m,N[s]);return m}static join(N,m){if(N.length===0)return m;if(m.length===0)return N;const s=[];let l=0,g=0,M=null;for(;l<N.length||g<m.length;){let f=null;if(l<N.length&&g<m.length){const d=N[l],e=m[g];d.startLineNumber<e.startLineNumber?(f=d,l++):(f=e,g++)}else l<N.length?(f=N[l],l++):(f=m[g],g++);M===null?M=f:M.endLineNumberExclusive>=f.startLineNumber?M=new i(M.startLineNumber,Math.max(M.endLineNumberExclusive,f.endLineNumberExclusive)):(s.push(M),M=f)}return M!==null&&s.push(M),s}static ofLength(N,m){return new i(N,N+m)}constructor(N,m){if(N>m)throw new F.BugIndicatingError(`startLineNumber ${N} cannot be after endLineNumberExclusive ${m}`);this.startLineNumber=N,this.endLineNumberExclusive=m}contains(N){return this.startLineNumber<=N&&N<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(N){return new i(this.startLineNumber+N,this.endLineNumberExclusive+N)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(N){return new i(Math.min(this.startLineNumber,N.startLineNumber),Math.max(this.endLineNumberExclusive,N.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(N){const m=Math.max(this.startLineNumber,N.startLineNumber),s=Math.min(this.endLineNumberExclusive,N.endLineNumberExclusive);if(m<=s)return new i(m,s)}intersectsStrict(N){return this.startLineNumber<N.endLineNumberExclusive&&N.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(N){return this.startLineNumber<=N.endLineNumberExclusive&&N.startLineNumber<=this.endLineNumberExclusive}equals(N){return this.startLineNumber===N.startLineNumber&&this.endLineNumberExclusive===N.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new T.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new T.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}}t.LineRange=i}),Z(K[33],ee([0,1,4,2]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class u extends T.Range{constructor(m,s,l,g){super(m,s,l,g),this.selectionStartLineNumber=m,this.selectionStartColumn=s,this.positionLineNumber=l,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return u.selectionsEqual(this,m)}static selectionsEqual(m,s){return m.selectionStartLineNumber===s.selectionStartLineNumber&&m.selectionStartColumn===s.selectionStartColumn&&m.positionLineNumber===s.positionLineNumber&&m.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,s){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,m,s):new u(m,s,this.startLineNumber,this.startColumn)}getPosition(){return new F.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,s){return this.getDirection()===0?new u(m,s,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,m,s)}static fromPositions(m,s=m){return new u(m.lineNumber,m.column,s.lineNumber,s.column)}static fromRange(m,s){return s===0?new u(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new u(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new u(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,s){if(m&&!s||!m&&s)return!1;if(!m&&!s)return!0;if(m.length!==s.length)return!1;for(let l=0,g=m.length;l<g;l++)if(!this.selectionsEqual(m[l],s[l]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,s,l,g,M){return M===0?new u(m,s,l,g):new u(l,g,m,s)}}t.Selection=u}),Z(K[34],ee([0,1,20]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var T;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(T||(t.WordCharacterClass=T={}));class i extends F.CharacterClassifier{constructor(m){super(0);for(let s=0,l=m.length;s<l;s++)this.set(m.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(N){const m={};return s=>(m.hasOwnProperty(s)||(m[s]=N(s)),m[s])}t.getMapForWordSeparators=u(N=>new i(N))}),Z(K[21],ee([0,1,16,7,17]),function(V,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(M=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const d of t.USUAL_WORD_SEPARATORS)M.indexOf(d)>=0||(f+="\\"+d);return f+="\\s]+)",new RegExp(f,"g")}t.DEFAULT_WORD_REGEXP=u();function N(M){let f=t.DEFAULT_WORD_REGEXP;if(M&&M instanceof RegExp)if(M.global)f=M;else{let d="g";M.ignoreCase&&(d+="i"),M.multiline&&(d+="m"),M.unicode&&(d+="u"),f=new RegExp(M.source,d)}return f.lastIndex=0,f}t.ensureValidWordDefinition=N;const m=new i.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(M){const f=m.unshift(M);return(0,T.toDisposable)(f)}t.setDefaultGetWordAtTextConfig=s;function l(M,f,d,e,w){if(w||(w=F.Iterable.first(m)),d.length>w.maxLen){let b=M-w.maxLen/2;return b<0?b=0:e+=b,d=d.substring(b,M+w.maxLen/2),l(M,f,d,e,w)}const D=Date.now(),y=M-1-e;let v=-1,R=null;for(let b=1;!(Date.now()-D>=w.timeBudget);b++){const _=y-w.windowSize*b;f.lastIndex=Math.max(0,_);const r=g(f,d,y,v);if(!r&&R||(R=r,_<=0))break;v=_}if(R){const b={word:R[0],startColumn:e+1+R.index,endColumn:e+1+R.index+R[0].length};return f.lastIndex=0,b}return null}t.getWordAtText=l;function g(M,f,d,e){let w;for(;w=M.exec(f);){const D=w.index||0;if(D<=d&&M.lastIndex>=d)return w;if(e>0&&D>e)return null}return null}}),Z(K[8],ee([0,1,3,6]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class i{static trivial(l,g){return new i([new u(new T.OffsetRange(0,l.length),new T.OffsetRange(0,g.length))],!1)}static trivialTimedOut(l,g){return new i([new u(new T.OffsetRange(0,l.length),new T.OffsetRange(0,g.length))],!0)}constructor(l,g){this.diffs=l,this.hitTimeout=g}}t.DiffAlgorithmResult=i;class u{constructor(l,g){this.seq1Range=l,this.seq2Range=g}reverse(){return new u(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(l){return new u(this.seq1Range.join(l.seq1Range),this.seq2Range.join(l.seq2Range))}}t.SequenceDiff=u;class N{isValid(){return!0}}t.InfiniteTimeout=N,N.instance=new N;class m{constructor(l){if(this.timeout=l,this.startTime=Date.now(),this.valid=!0,l<=0)throw new F.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=m}),Z(K[35],ee([0,1,6,8]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function i(l,g,M){let f=M;return f=N(l,g,f),f=m(l,g,f),f}t.optimizeSequenceDiffs=i;function u(l,g,M){const f=[];for(const d of M){const e=f[f.length-1];if(!e){f.push(d);continue}d.seq1Range.start-e.seq1Range.endExclusive<=2||d.seq2Range.start-e.seq2Range.endExclusive<=2?f[f.length-1]=new T.SequenceDiff(e.seq1Range.join(d.seq1Range),e.seq2Range.join(d.seq2Range)):f.push(d)}return f}t.smoothenSequenceDiffs=u;function N(l,g,M){const f=[];M.length>0&&f.push(M[0]);for(let d=1;d<M.length;d++){const e=f[f.length-1],w=M[d];if(w.seq1Range.isEmpty){let D=!0;const y=w.seq1Range.start-e.seq1Range.endExclusive;for(let v=1;v<=y;v++)if(g.getElement(w.seq2Range.start-v)!==g.getElement(w.seq2Range.endExclusive-v)){D=!1;break}if(D){f[f.length-1]=new T.SequenceDiff(e.seq1Range,new F.OffsetRange(e.seq2Range.start,w.seq2Range.endExclusive-y));continue}}f.push(w)}return f}t.joinSequenceDiffs=N;function m(l,g,M){if(!l.getBoundaryScore||!g.getBoundaryScore)return M;for(let f=0;f<M.length;f++){const d=M[f];if(d.seq1Range.isEmpty){const e=f>0?M[f-1].seq2Range.endExclusive:-1,w=f+1<M.length?M[f+1].seq2Range.start:g.length;M[f]=s(d,l,g,w,e)}else if(d.seq2Range.isEmpty){const e=f>0?M[f-1].seq1Range.endExclusive:-1,w=f+1<M.length?M[f+1].seq1Range.start:l.length;M[f]=s(d.reverse(),g,l,w,e).reverse()}}return M}t.shiftSequenceDiffs=m;function s(l,g,M,f,d){let w=1;for(;l.seq2Range.start-w>d&&M.getElement(l.seq2Range.start-w)===M.getElement(l.seq2Range.endExclusive-w)&&w<20;)w++;w--;let D=0;for(;l.seq2Range.start+D<f&&M.getElement(l.seq2Range.start+D)===M.getElement(l.seq2Range.endExclusive+D)&&D<20;)D++;if(w===0&&D===0)return l;let y=0,v=-1;for(let R=-w;R<=D;R++){const b=l.seq2Range.start+R,_=l.seq2Range.endExclusive+R,r=l.seq1Range.start+R,a=g.getBoundaryScore(r)+M.getBoundaryScore(b)+M.getBoundaryScore(_);a>v&&(v=a,y=R)}return y!==0?new T.SequenceDiff(l.seq1Range.delta(y),l.seq2Range.delta(y)):l}}),Z(K[36],ee([0,1,6,8]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class i{compute(l,g,M=T.InfiniteTimeout.instance){if(l.length===0||g.length===0)return T.DiffAlgorithmResult.trivial(l,g);function f(_,r){for(;_<l.length&&r<g.length&&l.getElement(_)===g.getElement(r);)_++,r++;return _}let d=0;const e=new N;e.set(0,f(0,0));const w=new m;w.set(0,e.get(0)===0?null:new u(null,0,0,e.get(0)));let D=0;e:for(;;)for(d++,D=-d;D<=d;D+=2){if(!M.isValid())return T.DiffAlgorithmResult.trivialTimedOut(l,g);const _=D===d?-1:e.get(D+1),r=D===-d?-1:e.get(D-1)+1,a=Math.min(Math.max(_,r),l.length),A=a-D,h=f(a,A);e.set(D,h);const L=a===_?w.get(D+1):w.get(D-1);if(w.set(D,h!==a?new u(L,a,A,h-a):L),e.get(D)===l.length&&e.get(D)-D===g.length)break e}let y=w.get(D);const v=[];let R=l.length,b=g.length;for(;;){const _=y?y.x+y.length:0,r=y?y.y+y.length:0;if((_!==R||r!==b)&&v.push(new T.SequenceDiff(new F.OffsetRange(_,R),new F.OffsetRange(r,b))),!y)break;R=y.x,b=y.y,y=y.prev}return v.reverse(),new T.DiffAlgorithmResult(v,!1)}}t.MyersDiffAlgorithm=i;class u{constructor(l,g,M,f){this.prev=l,this.x=g,this.y=M,this.length=f}}class N{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,g){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const M=this.negativeArr;this.negativeArr=new Int32Array(M.length*2),this.negativeArr.set(M)}this.negativeArr[l]=g}else{if(l>=this.positiveArr.length){const M=this.positiveArr;this.positiveArr=new Int32Array(M.length*2),this.positiveArr.set(M)}this.positiveArr[l]=g}}}class m{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,g){l<0?(l=-l-1,this.negativeArr[l]=g):this.positiveArr[l]=g}}}),Z(K[37],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class F{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,N){this.array[i+u*this.width]=N}}t.Array2D=F}),Z(K[38],ee([0,1,6,8,37]),function(V,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class u{compute(m,s,l=T.InfiniteTimeout.instance,g){if(m.length===0||s.length===0)return T.DiffAlgorithmResult.trivial(m,s);const M=new i.Array2D(m.length,s.length),f=new i.Array2D(m.length,s.length),d=new i.Array2D(m.length,s.length);for(let b=0;b<m.length;b++)for(let _=0;_<s.length;_++){if(!l.isValid())return T.DiffAlgorithmResult.trivialTimedOut(m,s);const r=b===0?0:M.get(b-1,_),a=_===0?0:M.get(b,_-1);let A;m.getElement(b)===s.getElement(_)?(b===0||_===0?A=0:A=M.get(b-1,_-1),b>0&&_>0&&f.get(b-1,_-1)===3&&(A+=d.get(b-1,_-1)),A+=g?g(b,_):1):A=-1;const h=Math.max(r,a,A);if(h===A){const L=b>0&&_>0?d.get(b-1,_-1):0;d.set(b,_,L+1),f.set(b,_,3)}else h===r?(d.set(b,_,0),f.set(b,_,1)):h===a&&(d.set(b,_,0),f.set(b,_,2));M.set(b,_,h)}const e=[];let w=m.length,D=s.length;function y(b,_){(b+1!==w||_+1!==D)&&e.push(new T.SequenceDiff(new F.OffsetRange(b+1,w),new F.OffsetRange(_+1,D))),w=b,D=_}let v=m.length-1,R=s.length-1;for(;v>=0&&R>=0;)f.get(v,R)===3?(y(v,R),v--,R--):f.get(v,R)===1?v--:R--;return y(-1,-1),e.reverse(),new T.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=u}),Z(K[22],ee([0,1,13]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.LineRangeMapping=t.LinesDiff=void 0;class T{constructor(m,s){this.changes=m,this.hitTimeout=s}}t.LinesDiff=T;class i{static inverse(m,s,l){const g=[];let M=1,f=1;for(const e of m){const w=new i(new F.LineRange(M,e.originalRange.startLineNumber),new F.LineRange(f,e.modifiedRange.startLineNumber),void 0);w.modifiedRange.isEmpty||g.push(w),M=e.originalRange.endLineNumberExclusive,f=e.modifiedRange.endLineNumberExclusive}const d=new i(new F.LineRange(M,s+1),new F.LineRange(f,l+1),void 0);return d.modifiedRange.isEmpty||g.push(d),g}constructor(m,s,l){this.originalRange=m,this.modifiedRange=s,this.innerChanges=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}}t.LineRangeMapping=i;class u{constructor(m,s){this.originalRange=m,this.modifiedRange=s}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=u}),Z(K[39],ee([0,1,11,13,6,4,2,8,38,35,36,22]),function(V,t,F,T,i,u,N,m,s,l,g,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class f{constructor(){this.dynamicProgrammingDiffing=new s.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new g.MyersDiffAlgorithm}computeDiff(o,p,S){const P=S.maxComputationTimeMs===0?m.InfiniteTimeout.instance:new m.DateTimeout(S.maxComputationTimeMs),E=!S.ignoreTrimWhitespace,I=new Map;function B(le){let oe=I.get(le);return oe===void 0&&(oe=I.size,I.set(le,oe)),oe}const W=o.map(le=>B(le.trim())),j=p.map(le=>B(le.trim())),J=new v(W,o),X=new v(j,p),G=(()=>J.length+X.length<1500?this.dynamicProgrammingDiffing.compute(J,X,P,(le,oe)=>o[le]===p[oe]?p[oe].length===0?.1:1+Math.log(1+p[oe].length):.99):this.myersDiffingAlgorithm.compute(J,X))();let se=G.diffs,n=G.hitTimeout;se=(0,l.optimizeSequenceDiffs)(J,X,se);const me=[],de=le=>{if(E)for(let oe=0;oe<le;oe++){const we=be+oe,Le=_e+oe;if(o[we]!==p[Le]){const ye=this.refineDiff(o,p,new m.SequenceDiff(new i.OffsetRange(we,we+1),new i.OffsetRange(Le,Le+1)),P,E);for(const Fe of ye.mappings)me.push(Fe);ye.hitTimeout&&(n=!0)}}};let be=0,_e=0;for(const le of se){(0,F.assertFn)(()=>le.seq1Range.start-be===le.seq2Range.start-_e);const oe=le.seq1Range.start-be;de(oe),be=le.seq1Range.endExclusive,_e=le.seq2Range.endExclusive;const we=this.refineDiff(o,p,le,P,E);we.hitTimeout&&(n=!0);for(const Le of we.mappings)me.push(Le)}de(o.length-be);const pe=w(me,o,p);return new M.LinesDiff(pe,n)}refineDiff(o,p,S,P,E){const I=new b(o,S.seq1Range,E),B=new b(p,S.seq2Range,E),W=I.length+B.length<500?this.dynamicProgrammingDiffing.compute(I,B,P):this.myersDiffingAlgorithm.compute(I,B,P);let j=W.diffs;return j=(0,l.optimizeSequenceDiffs)(I,B,j),j=d(I,B,j),j=(0,l.smoothenSequenceDiffs)(I,B,j),{mappings:j.map(X=>new M.RangeMapping(I.translateRange(X.seq1Range),B.translateRange(X.seq2Range))),hitTimeout:W.hitTimeout}}}t.StandardLinesDiffComputer=f;function d(c,o,p){const S=[];let P;function E(){if(!P)return;const B=P.s1Range.length-P.deleted,W=P.s2Range.length-P.added;Math.max(P.deleted,P.added)+(P.count-1)>B&&S.push(new m.SequenceDiff(P.s1Range,P.s2Range)),P=void 0}for(const B of p){let W=function(se,n){if(!P||!P.s1Range.containsRange(se)||!P.s2Range.containsRange(n))if(P&&!(P.s1Range.endExclusive<se.start&&P.s2Range.endExclusive<n.start)){const be=i.OffsetRange.tryCreate(P.s1Range.endExclusive,se.start),_e=i.OffsetRange.tryCreate(P.s2Range.endExclusive,n.start);P.deleted+=be?.length??0,P.added+=_e?.length??0,P.s1Range=P.s1Range.join(se),P.s2Range=P.s2Range.join(n)}else E(),P={added:0,deleted:0,count:0,s1Range:se,s2Range:n};const me=se.intersect(B.seq1Range),de=n.intersect(B.seq2Range);P.count++,P.deleted+=me?.length??0,P.added+=de?.length??0};const j=c.findWordContaining(B.seq1Range.start-1),J=o.findWordContaining(B.seq2Range.start-1),X=c.findWordContaining(B.seq1Range.endExclusive),G=o.findWordContaining(B.seq2Range.endExclusive);j&&X&&J&&G&&j.equals(X)&&J.equals(G)?W(j,J):(j&&J&&W(j,J),X&&G&&W(X,G))}return E(),e(p,S)}function e(c,o){const p=[];for(;c.length>0||o.length>0;){const S=c[0],P=o[0];let E;S&&(!P||S.seq1Range.start<P.seq1Range.start)?E=c.shift():E=o.shift(),p.length>0&&p[p.length-1].seq1Range.endExclusive>=E.seq1Range.start?p[p.length-1]=p[p.length-1].join(E):p.push(E)}return p}function w(c,o,p){const S=[];for(const P of y(c.map(E=>D(E,o,p)),(E,I)=>E.originalRange.overlapOrTouch(I.originalRange)||E.modifiedRange.overlapOrTouch(I.modifiedRange))){const E=P[0],I=P[P.length-1];S.push(new M.LineRangeMapping(E.originalRange.join(I.originalRange),E.modifiedRange.join(I.modifiedRange),P.map(B=>B.innerChanges[0])))}return(0,F.assertFn)(()=>(0,F.checkAdjacentItems)(S,(P,E)=>E.originalRange.startLineNumber-P.originalRange.endLineNumberExclusive===E.modifiedRange.startLineNumber-P.modifiedRange.endLineNumberExclusive&&P.originalRange.endLineNumberExclusive<E.originalRange.startLineNumber&&P.modifiedRange.endLineNumberExclusive<E.modifiedRange.startLineNumber)),S}t.lineRangeMappingFromRangeMappings=w;function D(c,o,p){let S=0,P=0;c.modifiedRange.startColumn-1>=p[c.modifiedRange.startLineNumber-1].length&&c.originalRange.startColumn-1>=o[c.originalRange.startLineNumber-1].length&&(S=1),c.modifiedRange.endColumn===1&&c.originalRange.endColumn===1&&c.originalRange.startLineNumber+S<=c.originalRange.endLineNumber&&c.modifiedRange.startLineNumber+S<=c.modifiedRange.endLineNumber&&(P=-1);const E=new T.LineRange(c.originalRange.startLineNumber+S,c.originalRange.endLineNumber+1+P),I=new T.LineRange(c.modifiedRange.startLineNumber+S,c.modifiedRange.endLineNumber+1+P);return new M.LineRangeMapping(E,I,[c])}t.getLineRangeMapping=D;function*y(c,o){let p,S;for(const P of c)S!==void 0&&o(S,P)?p.push(P):(p&&(yield p),p=[P]),S=P;p&&(yield p)}class v{constructor(o,p){this.trimmedHash=o,this.lines=p}getElement(o){return this.trimmedHash[o]}get length(){return this.trimmedHash.length}getBoundaryScore(o){const p=o===0?0:R(this.lines[o-1]),S=o===this.lines.length?0:R(this.lines[o]);return 1e3-(p+S)}}t.LineSequence=v;function R(c){let o=0;for(;o<c.length&&(c.charCodeAt(o)===32||c.charCodeAt(o)===9);)o++;return o}class b{constructor(o,p,S){this.lines=o,this.considerWhitespaceChanges=S,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let P=!1;p.start>0&&p.endExclusive>=o.length&&(p=new i.OffsetRange(p.start-1,p.endExclusive),P=!0),this.lineRange=p;for(let E=this.lineRange.start;E<this.lineRange.endExclusive;E++){let I=o[E],B=0;if(P)B=I.length,I="",P=!1;else if(!S){const W=I.trimStart();B=I.length-W.length,I=W.trimEnd()}this.offsetByLine.push(B);for(let W=0;W<I.length;W++)this.elements.push(I.charCodeAt(W));E<o.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[E-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.elements].map(o=>String.fromCharCode(o)).join("")}getElement(o){return this.elements[o]}get length(){return this.elements.length}getBoundaryScore(o){const p=h(o>0?this.elements[o-1]:-1),S=h(o<this.elements.length?this.elements[o]:-1);if(p===6&&S===7)return 0;let P=0;return p!==S&&(P+=10,S===1&&(P+=1)),P+=A(p),P+=A(S),P}translateOffset(o){if(this.lineRange.isEmpty)return new u.Position(this.lineRange.start+1,1);let p=0,S=this.firstCharOffsetByLineMinusOne.length;for(;p<S;){const E=Math.floor((p+S)/2);this.firstCharOffsetByLineMinusOne[E]>o?S=E:p=E+1}const P=p===0?0:this.firstCharOffsetByLineMinusOne[p-1];return new u.Position(this.lineRange.start+p+1,o-P+1+this.offsetByLine[p])}translateRange(o){return N.Range.fromPositions(this.translateOffset(o.start),this.translateOffset(o.endExclusive))}findWordContaining(o){if(o<0||o>=this.elements.length||!_(this.elements[o]))return;let p=o;for(;p>0&&_(this.elements[p-1]);)p--;let S=o;for(;S<this.elements.length&&_(this.elements[S]);)S++;return new i.OffsetRange(p,S)}}function _(c){return c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57}var r;(function(c){c[c.WordLower=0]="WordLower",c[c.WordUpper=1]="WordUpper",c[c.WordNumber=2]="WordNumber",c[c.End=3]="End",c[c.Other=4]="Other",c[c.Space=5]="Space",c[c.LineBreakCR=6]="LineBreakCR",c[c.LineBreakLF=7]="LineBreakLF"})(r||(r={}));const a={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(c){return a[c]}function h(c){return c===10?7:c===13?6:L(c)?5:c>=97&&c<=122?0:c>=65&&c<=90?1:c>=48&&c<=57?2:c===-1?3:4}function L(c){return c===32||c===9}}),Z(K[40],ee([0,1,27]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function T(f){const d=[];for(const e of f){const w=Number(e);(w||w===0&&e.replace(/\s/g,"")!=="")&&d.push(w)}return d}function i(f,d,e,w){return{red:f/255,blue:e/255,green:d/255,alpha:w}}function u(f,d){const e=d.index,w=d[0].length;if(!e)return;const D=f.positionAt(e);return{startLineNumber:D.lineNumber,startColumn:D.column,endLineNumber:D.lineNumber,endColumn:D.column+w}}function N(f,d){if(!f)return;const e=F.Color.Format.CSS.parseHex(d);if(e)return{range:f,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function m(f,d,e){if(!f||d.length!==1)return;const D=d[0].values(),y=T(D);return{range:f,color:i(y[0],y[1],y[2],e?y[3]:1)}}function s(f,d,e){if(!f||d.length!==1)return;const D=d[0].values(),y=T(D),v=new F.Color(new F.HSLA(y[0],y[1]/100,y[2]/100,e?y[3]:1));return{range:f,color:i(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function l(f,d){return typeof f=="string"?[...f.matchAll(d)]:f.findMatches(d)}function g(f){const d=[],w=l(f,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const D of w){const y=D.filter(_=>_!==void 0),v=y[1],R=y[2];if(!R)continue;let b;if(v==="rgb"){const _=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;b=m(u(f,D),l(R,_),!1)}else if(v==="rgba"){const _=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;b=m(u(f,D),l(R,_),!0)}else if(v==="hsl"){const _=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;b=s(u(f,D),l(R,_),!1)}else if(v==="hsla"){const _=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;b=s(u(f,D),l(R,_),!0)}else v==="#"&&(b=N(u(f,D),v+R));b&&d.push(b)}return d}function M(f){return!f||typeof f.getValue!="function"||typeof f.positionAt!="function"?[]:g(f)}t.computeDefaultDocumentColors=M}),Z(K[41],ee([0,1,20]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var T;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(T||(t.State=T={}));class i{constructor(e,w,D){const y=new Uint8Array(e*w);for(let v=0,R=e*w;v<R;v++)y[v]=D;this._data=y,this.rows=e,this.cols=w}get(e,w){return this._data[e*this.cols+w]}set(e,w,D){this._data[e*this.cols+w]=D}}class u{constructor(e){let w=0,D=0;for(let v=0,R=e.length;v<R;v++){const[b,_,r]=e[v];_>w&&(w=_),b>D&&(D=b),r>D&&(D=r)}w++,D++;const y=new i(D,w,0);for(let v=0,R=e.length;v<R;v++){const[b,_,r]=e[v];y.set(b,_,r)}this._states=y,this._maxCharCode=w}nextState(e,w){return w<0||w>=this._maxCharCode?0:this._states.get(e,w)}}t.StateMachine=u;let N=null;function m(){return N===null&&(N=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var s;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let l=null;function g(){if(l===null){l=new F.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<d.length;w++)l.set(d.charCodeAt(w),1);const e=".,;:";for(let w=0;w<e.length;w++)l.set(e.charCodeAt(w),2)}return l}class M{static _createLink(e,w,D,y,v){let R=v-1;do{const b=w.charCodeAt(R);if(e.get(b)!==2)break;R--}while(R>y);if(y>0){const b=w.charCodeAt(y-1),_=w.charCodeAt(R);(b===40&&_===41||b===91&&_===93||b===123&&_===125)&&R--}return{range:{startLineNumber:D,startColumn:y+1,endLineNumber:D,endColumn:R+2},url:w.substring(y,R+1)}}static computeLinks(e,w=m()){const D=g(),y=[];for(let v=1,R=e.getLineCount();v<=R;v++){const b=e.getLineContent(v),_=b.length;let r=0,a=0,A=0,h=1,L=!1,c=!1,o=!1,p=!1;for(;r<_;){let S=!1;const P=b.charCodeAt(r);if(h===13){let E;switch(P){case 40:L=!0,E=0;break;case 41:E=L?0:1;break;case 91:o=!0,c=!0,E=0;break;case 93:o=!1,E=c?0:1;break;case 123:p=!0,E=0;break;case 125:E=p?0:1;break;case 39:case 34:case 96:A===P?E=1:A===39||A===34||A===96?E=0:E=1;break;case 42:E=A===42?1:0;break;case 124:E=A===124?1:0;break;case 32:E=o?0:1;break;default:E=D.get(P)}E===1&&(y.push(M._createLink(D,b,v,a,r)),S=!0)}else if(h===12){let E;P===91?(c=!0,E=0):E=D.get(P),E===1?S=!0:h=13}else h=w.nextState(h,P),h===0&&(S=!0);S&&(h=1,L=!1,c=!1,p=!1,a=r+1,A=P),r++}h===13&&y.push(M._createLink(D,b,v,a,_))}return y}}t.LinkComputer=M;function f(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:M.computeLinks(d)}t.computeLinks=f}),Z(K[42],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class F{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,N,m,s){if(i&&u){const l=this.doNavigateValueSet(u,s);if(l)return{range:i,value:l}}if(N&&m){const l=this.doNavigateValueSet(m,s);if(l)return{range:N,value:l}}return null}doNavigateValueSet(i,u){const N=this.numberReplace(i,u);return N!==null?N:this.textReplace(i,u)}numberReplace(i,u){const N=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let m=Number(i);const s=parseFloat(i);return!isNaN(m)&&!isNaN(s)&&m===s?m===0&&!u?null:(m=Math.floor(m*N),m+=u?N:-N,String(m/N)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,N){let m=null;for(let s=0,l=i.length;m===null&&s<l;s++)m=this.valueSetReplace(i[s],u,N);return m}valueSetReplace(i,u,N){let m=i.indexOf(u);return m>=0?(m+=N?1:-1,m<0?m=i.length-1:m%=i.length,i[m]):null}}t.BasicInplaceReplace=F,F.INSTANCE=new F}),Z(K[43],ee([0,1,12]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var T;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(T||(t.OverviewRulerLane=T={}));var i;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var u;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(u||(t.MinimapPosition=u={}));var N;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var m;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(m||(t.EndOfLinePreference=m={}));var s;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var l;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class g{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),_.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,_.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!_.insertSpaces,this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=!!_.trimAutoWhitespace,this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this._indentSizeIsTabSize===_._indentSizeIsTabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,F.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}t.TextModelResolvedOptions=g;class M{constructor(_,r){this._findMatchBrand=void 0,this.range=_,this.matches=r}}t.FindMatch=M;var f;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(f||(t.TrackedRangeStickiness=f={}));function d(b){return b&&typeof b.read=="function"}t.isITextSnapshot=d;var e;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(t.ModelConstants=w={}));class D{constructor(_,r,a,A,h,L){this.identifier=_,this.range=r,this.text=a,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=h,this._isTracked=L}}t.ValidAnnotatedEditOperation=D;class y{constructor(_,r,a){this.regex=_,this.wordSeparators=r,this.simpleSearch=a}}t.SearchData=y;class v{constructor(_,r,a){this.reverseEdits=_,this.changes=r,this.trimAutoWhitespaceLineNumbers=a}}t.ApplyEditsResult=v;function R(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}t.shouldSynchronizeModel=R}),Z(K[44],ee([0,1,29,19]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(s){this.values=s,this.prefixSum=new Uint32Array(s.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(s,l){s=(0,T.toUint32)(s);const g=this.values,M=this.prefixSum,f=l.length;return f===0?!1:(this.values=new Uint32Array(g.length+f),this.values.set(g.subarray(0,s),0),this.values.set(g.subarray(s),s+f),this.values.set(l,s),s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(s,l){return s=(0,T.toUint32)(s),l=(0,T.toUint32)(l),this.values[s]===l?!1:(this.values[s]=l,s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),!0)}removeValues(s,l){s=(0,T.toUint32)(s),l=(0,T.toUint32)(l);const g=this.values,M=this.prefixSum;if(s>=g.length)return!1;const f=g.length-s;return l>=f&&(l=f),l===0?!1:(this.values=new Uint32Array(g.length-l),this.values.set(g.subarray(0,s),0),this.values.set(g.subarray(s+l),s),this.prefixSum=new Uint32Array(this.values.length),s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(s){return s<0?0:(s=(0,T.toUint32)(s),this._getPrefixSum(s))}_getPrefixSum(s){if(s<=this.prefixSumValidIndex[0])return this.prefixSum[s];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),s>=this.values.length&&(s=this.values.length-1);for(let g=l;g<=s;g++)this.prefixSum[g]=this.prefixSum[g-1]+this.values[g];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],s),this.prefixSum[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let l=0,g=this.values.length-1,M=0,f=0,d=0;for(;l<=g;)if(M=l+(g-l)/2|0,f=this.prefixSum[M],d=f-this.values[M],s<d)g=M-1;else if(s>=f)l=M+1;else break;return new N(M,s-d)}}t.PrefixSumComputer=i;class u{constructor(s){this._values=s,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(s){return this._ensureValid(),s===0?0:this._prefixSum[s-1]}getIndexOf(s){this._ensureValid();const l=this._indexBySum[s],g=l>0?this._prefixSum[l-1]:0;return new N(l,s-g)}removeValues(s,l){this._values.splice(s,l),this._invalidate(s)}insertValues(s,l){this._values=(0,F.arrayInsert)(this._values,s,l),this._invalidate(s)}_invalidate(s){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,s-1)}_ensureValid(){if(!this._isValid){for(let s=this._validEndIndex+1,l=this._values.length;s<l;s++){const g=this._values[s],M=s>0?this._prefixSum[s-1]:0;this._prefixSum[s]=M+g;for(let f=0;f<g;f++)this._indexBySum[M+f]=s}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(s,l){this._values[s]!==l&&(this._values[s]=l,this._invalidate(s))}}t.ConstantTimePrefixSumComputer=u;class N{constructor(s,l){this.index=s,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=l}}t.PrefixSumIndexOfResult=N}),Z(K[45],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(F||(t.AccessibilitySupport=F={}));var T;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(T||(t.CodeActionTriggerType=T={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u||(t.CompletionItemKind=u={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var m;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(t.CompletionTriggerKind=m={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var M;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(M||(t.DocumentHighlightKind=M={}));var f;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(f||(t.EditorAutoIndentStrategy=f={}));var d;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=7]="autoClosingDelete",n[n.autoClosingOvertype=8]="autoClosingOvertype",n[n.autoClosingQuotes=9]="autoClosingQuotes",n[n.autoIndent=10]="autoIndent",n[n.automaticLayout=11]="automaticLayout",n[n.autoSurround=12]="autoSurround",n[n.bracketPairColorization=13]="bracketPairColorization",n[n.guides=14]="guides",n[n.codeLens=15]="codeLens",n[n.codeLensFontFamily=16]="codeLensFontFamily",n[n.codeLensFontSize=17]="codeLensFontSize",n[n.colorDecorators=18]="colorDecorators",n[n.colorDecoratorsLimit=19]="colorDecoratorsLimit",n[n.columnSelection=20]="columnSelection",n[n.comments=21]="comments",n[n.contextmenu=22]="contextmenu",n[n.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",n[n.cursorBlinking=24]="cursorBlinking",n[n.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",n[n.cursorStyle=26]="cursorStyle",n[n.cursorSurroundingLines=27]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",n[n.cursorWidth=29]="cursorWidth",n[n.disableLayerHinting=30]="disableLayerHinting",n[n.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",n[n.domReadOnly=32]="domReadOnly",n[n.dragAndDrop=33]="dragAndDrop",n[n.dropIntoEditor=34]="dropIntoEditor",n[n.emptySelectionClipboard=35]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",n[n.extraEditorClassName=37]="extraEditorClassName",n[n.fastScrollSensitivity=38]="fastScrollSensitivity",n[n.find=39]="find",n[n.fixedOverflowWidgets=40]="fixedOverflowWidgets",n[n.folding=41]="folding",n[n.foldingStrategy=42]="foldingStrategy",n[n.foldingHighlight=43]="foldingHighlight",n[n.foldingImportsByDefault=44]="foldingImportsByDefault",n[n.foldingMaximumRegions=45]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=47]="fontFamily",n[n.fontInfo=48]="fontInfo",n[n.fontLigatures=49]="fontLigatures",n[n.fontSize=50]="fontSize",n[n.fontWeight=51]="fontWeight",n[n.fontVariations=52]="fontVariations",n[n.formatOnPaste=53]="formatOnPaste",n[n.formatOnType=54]="formatOnType",n[n.glyphMargin=55]="glyphMargin",n[n.gotoLocation=56]="gotoLocation",n[n.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",n[n.hover=58]="hover",n[n.inDiffEditor=59]="inDiffEditor",n[n.inlineSuggest=60]="inlineSuggest",n[n.letterSpacing=61]="letterSpacing",n[n.lightbulb=62]="lightbulb",n[n.lineDecorationsWidth=63]="lineDecorationsWidth",n[n.lineHeight=64]="lineHeight",n[n.lineNumbers=65]="lineNumbers",n[n.lineNumbersMinChars=66]="lineNumbersMinChars",n[n.linkedEditing=67]="linkedEditing",n[n.links=68]="links",n[n.matchBrackets=69]="matchBrackets",n[n.minimap=70]="minimap",n[n.mouseStyle=71]="mouseStyle",n[n.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=73]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",n[n.multiCursorModifier=75]="multiCursorModifier",n[n.multiCursorPaste=76]="multiCursorPaste",n[n.multiCursorLimit=77]="multiCursorLimit",n[n.occurrencesHighlight=78]="occurrencesHighlight",n[n.overviewRulerBorder=79]="overviewRulerBorder",n[n.overviewRulerLanes=80]="overviewRulerLanes",n[n.padding=81]="padding",n[n.pasteAs=82]="pasteAs",n[n.parameterHints=83]="parameterHints",n[n.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",n[n.quickSuggestions=86]="quickSuggestions",n[n.quickSuggestionsDelay=87]="quickSuggestionsDelay",n[n.readOnly=88]="readOnly",n[n.renameOnType=89]="renameOnType",n[n.renderControlCharacters=90]="renderControlCharacters",n[n.renderFinalNewline=91]="renderFinalNewline",n[n.renderLineHighlight=92]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=93]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=94]="renderValidationDecorations",n[n.renderWhitespace=95]="renderWhitespace",n[n.revealHorizontalRightPadding=96]="revealHorizontalRightPadding",n[n.roundedSelection=97]="roundedSelection",n[n.rulers=98]="rulers",n[n.scrollbar=99]="scrollbar",n[n.scrollBeyondLastColumn=100]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=101]="scrollBeyondLastLine",n[n.scrollPredominantAxis=102]="scrollPredominantAxis",n[n.selectionClipboard=103]="selectionClipboard",n[n.selectionHighlight=104]="selectionHighlight",n[n.selectOnLineNumbers=105]="selectOnLineNumbers",n[n.showFoldingControls=106]="showFoldingControls",n[n.showUnused=107]="showUnused",n[n.snippetSuggestions=108]="snippetSuggestions",n[n.smartSelect=109]="smartSelect",n[n.smoothScrolling=110]="smoothScrolling",n[n.stickyScroll=111]="stickyScroll",n[n.stickyTabStops=112]="stickyTabStops",n[n.stopRenderingLineAfter=113]="stopRenderingLineAfter",n[n.suggest=114]="suggest",n[n.suggestFontSize=115]="suggestFontSize",n[n.suggestLineHeight=116]="suggestLineHeight",n[n.suggestOnTriggerCharacters=117]="suggestOnTriggerCharacters",n[n.suggestSelection=118]="suggestSelection",n[n.tabCompletion=119]="tabCompletion",n[n.tabIndex=120]="tabIndex",n[n.unicodeHighlighting=121]="unicodeHighlighting",n[n.unusualLineTerminators=122]="unusualLineTerminators",n[n.useShadowDOM=123]="useShadowDOM",n[n.useTabStops=124]="useTabStops",n[n.wordBreak=125]="wordBreak",n[n.wordSeparators=126]="wordSeparators",n[n.wordWrap=127]="wordWrap",n[n.wordWrapBreakAfterCharacters=128]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=129]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=130]="wordWrapColumn",n[n.wordWrapOverride1=131]="wordWrapOverride1",n[n.wordWrapOverride2=132]="wordWrapOverride2",n[n.wrappingIndent=133]="wrappingIndent",n[n.wrappingStrategy=134]="wrappingStrategy",n[n.showDeprecated=135]="showDeprecated",n[n.inlayHints=136]="inlayHints",n[n.editorClassName=137]="editorClassName",n[n.pixelRatio=138]="pixelRatio",n[n.tabFocusMode=139]="tabFocusMode",n[n.layoutInfo=140]="layoutInfo",n[n.wrappingInfo=141]="wrappingInfo",n[n.defaultColorDecorators=142]="defaultColorDecorators"})(d||(t.EditorOption=d={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var w;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(w||(t.EndOfLineSequence=w={}));var D;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(D||(t.GlyphMarginLane=D={}));var y;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(y||(t.IndentAction=y={}));var v;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var R;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(R||(t.InlayHintKind=R={}));var b;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(b||(t.InlineCompletionTriggerKind=b={}));var _;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(_||(t.KeyCode=_={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var A;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(A||(t.MinimapPosition=A={}));var h;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(h||(t.MouseTargetType=h={}));var L;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(L||(t.OverlayWidgetPositionPreference=L={}));var c;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(c||(t.OverviewRulerLane=c={}));var o;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(o||(t.PositionAffinity=o={}));var p;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(p||(t.RenderLineNumbersType=p={}));var S;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(S||(t.RenderMinimap=S={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var E;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(E||(t.ScrollbarVisibility=E={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var B;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(B||(t.SignatureHelpTriggerKind=B={}));var W;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(W||(t.SymbolKind=W={}));var j;(function(n){n[n.Deprecated=1]="Deprecated"})(j||(t.SymbolTag=j={}));var J;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(J||(t.TextEditorCursorBlinkingStyle=J={}));var X;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(X||(t.TextEditorCursorStyle=X={}));var G;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G||(t.TrackedRangeStickiness=G={}));var se;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(se||(t.WrappingIndent=se={}))}),Z(K[46],ee([59,60]),function(V,t){return V.create("vs/base/common/platform",t)}),Z(K[9],ee([0,1,46]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let T=!1,i=!1,u=!1,N=!1,m=!1,s=!1,l=!1,g=!1,M=!1,f=!1,d,e=t.LANGUAGE_DEFAULT,w=t.LANGUAGE_DEFAULT,D,y;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?v=t.globals.vscode.process:typeof process<"u"&&(v=process);const R=typeof v?.versions?.electron=="string",b=R&&v?.type==="renderer";if(typeof navigator=="object"&&!b)y=navigator.userAgent,T=y.indexOf("Windows")>=0,i=y.indexOf("Macintosh")>=0,g=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=y.indexOf("Linux")>=0,f=y?.indexOf("Mobi")>=0,s=!0,d=F.getConfiguredDefaultLocale(F.localize(0,null))||t.LANGUAGE_DEFAULT,e=d,w=navigator.language;else if(typeof v=="object"){T=v.platform==="win32",i=v.platform==="darwin",u=v.platform==="linux",N=u&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,l=R,M=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const p=v.env.VSCODE_NLS_CONFIG;if(p)try{const S=JSON.parse(p),P=S.availableLanguages["*"];d=S.locale,w=S.osLocale,e=P||t.LANGUAGE_DEFAULT,D=S._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var _;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(_||(t.Platform=_={}));function r(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=r;let a=0;i?a=1:T?a=3:u&&(a=2),t.isWindows=T,t.isMacintosh=i,t.isLinux=u,t.isLinuxSnap=N,t.isNative=m,t.isElectron=l,t.isWeb=s,t.isWebWorker=s&&typeof t.globals.importScripts=="function",t.isIOS=g,t.isMobile=f,t.isCI=M,t.platform=a,t.userAgent=y,t.language=e;var A;(function(p){function S(){return t.language}p.value=S;function P(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}p.isDefaultVariant=P;function E(){return t.language==="en"}p.isDefault=E})(A||(t.Language=A={})),t.locale=d,t.platformLocale=w,t.translationsConfigFile=D,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];t.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let E=0,I=p.length;E<I;E++){const B=p[E];if(B.id===P.data.vscodeScheduleAsyncWork){p.splice(E,1),B.callback();return}}});let S=0;return P=>{const E=++S;p.push({id:E,callback:P}),t.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return p=>setTimeout(p)})();var h;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(h||(t.OperatingSystem=h={})),t.OS=i||g?2:T?1:3;let L=!0,c=!1;function o(){if(!c){c=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,L=new Uint16Array(p.buffer)[0]===(2<<8)+1}return L}t.isLittleEndian=o,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),Z(K[47],ee([0,1,9]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let T;if(typeof F.globals.vscode<"u"&&typeof F.globals.vscode.process<"u"){const i=F.globals.vscode.process;T={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return F.isWindows?"win32":F.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.platform=T.platform,t.arch=T.arch}),Z(K[48],ee([0,1,47]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const T=65,i=97,u=90,N=122,m=46,s=47,l=92,g=58,M=63;class f extends Error{constructor(a,A,h){let L;typeof A=="string"&&A.indexOf("not ")===0?(L="must not be",A=A.replace(/^not /,"")):L="must be";const c=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${c} ${L} of type ${A}`;o+=`. Received type ${typeof h}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,a){if(r===null||typeof r!="object")throw new f(a,"Object",r)}function e(r,a){if(typeof r!="string")throw new f(a,"string",r)}const w=F.platform==="win32";function D(r){return r===s||r===l}function y(r){return r===s}function v(r){return r>=T&&r<=u||r>=i&&r<=N}function R(r,a,A,h){let L="",c=0,o=-1,p=0,S=0;for(let P=0;P<=r.length;++P){if(P<r.length)S=r.charCodeAt(P);else{if(h(S))break;S=s}if(h(S)){if(!(o===P-1||p===1))if(p===2){if(L.length<2||c!==2||L.charCodeAt(L.length-1)!==m||L.charCodeAt(L.length-2)!==m){if(L.length>2){const E=L.lastIndexOf(A);E===-1?(L="",c=0):(L=L.slice(0,E),c=L.length-1-L.lastIndexOf(A)),o=P,p=0;continue}else if(L.length!==0){L="",c=0,o=P,p=0;continue}}a&&(L+=L.length>0?`${A}..`:"..",c=2)}else L.length>0?L+=`${A}${r.slice(o+1,P)}`:L=r.slice(o+1,P),c=P-o-1;o=P,p=0}else S===m&&p!==-1?++p:p=-1}return L}function b(r,a){d(a,"pathObject");const A=a.dir||a.root,h=a.base||`${a.name||""}${a.ext||""}`;return A?A===a.root?`${A}${h}`:`${A}${r}${h}`:h}t.win32={resolve(...r){let a="",A="",h=!1;for(let L=r.length-1;L>=-1;L--){let c;if(L>=0){if(c=r[L],e(c,"path"),c.length===0)continue}else a.length===0?c=F.cwd():(c=F.env[`=${a}`]||F.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==a.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${a}\\`));const o=c.length;let p=0,S="",P=!1;const E=c.charCodeAt(0);if(o===1)D(E)&&(p=1,P=!0);else if(D(E))if(P=!0,D(c.charCodeAt(1))){let I=2,B=I;for(;I<o&&!D(c.charCodeAt(I));)I++;if(I<o&&I!==B){const W=c.slice(B,I);for(B=I;I<o&&D(c.charCodeAt(I));)I++;if(I<o&&I!==B){for(B=I;I<o&&!D(c.charCodeAt(I));)I++;(I===o||I!==B)&&(S=`\\\\${W}\\${c.slice(B,I)}`,p=I)}}}else p=1;else v(E)&&c.charCodeAt(1)===g&&(S=c.slice(0,2),p=2,o>2&&D(c.charCodeAt(2))&&(P=!0,p=3));if(S.length>0)if(a.length>0){if(S.toLowerCase()!==a.toLowerCase())continue}else a=S;if(h){if(a.length>0)break}else if(A=`${c.slice(p)}\\${A}`,h=P,P&&a.length>0)break}return A=R(A,!h,"\\",D),h?`${a}\\${A}`:`${a}${A}`||"."},normalize(r){e(r,"path");const a=r.length;if(a===0)return".";let A=0,h,L=!1;const c=r.charCodeAt(0);if(a===1)return y(c)?"\\":r;if(D(c))if(L=!0,D(r.charCodeAt(1))){let p=2,S=p;for(;p<a&&!D(r.charCodeAt(p));)p++;if(p<a&&p!==S){const P=r.slice(S,p);for(S=p;p<a&&D(r.charCodeAt(p));)p++;if(p<a&&p!==S){for(S=p;p<a&&!D(r.charCodeAt(p));)p++;if(p===a)return`\\\\${P}\\${r.slice(S)}\\`;p!==S&&(h=`\\\\${P}\\${r.slice(S,p)}`,A=p)}}}else A=1;else v(c)&&r.charCodeAt(1)===g&&(h=r.slice(0,2),A=2,a>2&&D(r.charCodeAt(2))&&(L=!0,A=3));let o=A<a?R(r.slice(A),!L,"\\",D):"";return o.length===0&&!L&&(o="."),o.length>0&&D(r.charCodeAt(a-1))&&(o+="\\"),h===void 0?L?`\\${o}`:o:L?`${h}\\${o}`:`${h}${o}`},isAbsolute(r){e(r,"path");const a=r.length;if(a===0)return!1;const A=r.charCodeAt(0);return D(A)||a>2&&v(A)&&r.charCodeAt(1)===g&&D(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let a,A;for(let c=0;c<r.length;++c){const o=r[c];e(o,"path"),o.length>0&&(a===void 0?a=A=o:a+=`\\${o}`)}if(a===void 0)return".";let h=!0,L=0;if(typeof A=="string"&&D(A.charCodeAt(0))){++L;const c=A.length;c>1&&D(A.charCodeAt(1))&&(++L,c>2&&(D(A.charCodeAt(2))?++L:h=!1))}if(h){for(;L<a.length&&D(a.charCodeAt(L));)L++;L>=2&&(a=`\\${a.slice(L)}`)}return t.win32.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a)return"";const A=t.win32.resolve(r),h=t.win32.resolve(a);if(A===h||(r=A.toLowerCase(),a=h.toLowerCase(),r===a))return"";let L=0;for(;L<r.length&&r.charCodeAt(L)===l;)L++;let c=r.length;for(;c-1>L&&r.charCodeAt(c-1)===l;)c--;const o=c-L;let p=0;for(;p<a.length&&a.charCodeAt(p)===l;)p++;let S=a.length;for(;S-1>p&&a.charCodeAt(S-1)===l;)S--;const P=S-p,E=o<P?o:P;let I=-1,B=0;for(;B<E;B++){const j=r.charCodeAt(L+B);if(j!==a.charCodeAt(p+B))break;j===l&&(I=B)}if(B!==E){if(I===-1)return h}else{if(P>E){if(a.charCodeAt(p+B)===l)return h.slice(p+B+1);if(B===2)return h.slice(p+B)}o>E&&(r.charCodeAt(L+B)===l?I=B:B===2&&(I=3)),I===-1&&(I=0)}let W="";for(B=L+I+1;B<=c;++B)(B===c||r.charCodeAt(B)===l)&&(W+=W.length===0?"..":"\\..");return p+=I,W.length>0?`${W}${h.slice(p,S)}`:(h.charCodeAt(p)===l&&++p,h.slice(p,S))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const a=t.win32.resolve(r);if(a.length<=2)return r;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const A=a.charCodeAt(2);if(A!==M&&A!==m)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(v(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return r},dirname(r){e(r,"path");const a=r.length;if(a===0)return".";let A=-1,h=0;const L=r.charCodeAt(0);if(a===1)return D(L)?r:".";if(D(L)){if(A=h=1,D(r.charCodeAt(1))){let p=2,S=p;for(;p<a&&!D(r.charCodeAt(p));)p++;if(p<a&&p!==S){for(S=p;p<a&&D(r.charCodeAt(p));)p++;if(p<a&&p!==S){for(S=p;p<a&&!D(r.charCodeAt(p));)p++;if(p===a)return r;p!==S&&(A=h=p+1)}}}}else v(L)&&r.charCodeAt(1)===g&&(A=a>2&&D(r.charCodeAt(2))?3:2,h=A);let c=-1,o=!0;for(let p=a-1;p>=h;--p)if(D(r.charCodeAt(p))){if(!o){c=p;break}}else o=!1;if(c===-1){if(A===-1)return".";c=A}return r.slice(0,c)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let A=0,h=-1,L=!0,c;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===g&&(A=2),a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let o=a.length-1,p=-1;for(c=r.length-1;c>=A;--c){const S=r.charCodeAt(c);if(D(S)){if(!L){A=c+1;break}}else p===-1&&(L=!1,p=c+1),o>=0&&(S===a.charCodeAt(o)?--o===-1&&(h=c):(o=-1,h=p))}return A===h?h=p:h===-1&&(h=r.length),r.slice(A,h)}for(c=r.length-1;c>=A;--c)if(D(r.charCodeAt(c))){if(!L){A=c+1;break}}else h===-1&&(L=!1,h=c+1);return h===-1?"":r.slice(A,h)},extname(r){e(r,"path");let a=0,A=-1,h=0,L=-1,c=!0,o=0;r.length>=2&&r.charCodeAt(1)===g&&v(r.charCodeAt(0))&&(a=h=2);for(let p=r.length-1;p>=a;--p){const S=r.charCodeAt(p);if(D(S)){if(!c){h=p+1;break}continue}L===-1&&(c=!1,L=p+1),S===m?A===-1?A=p:o!==1&&(o=1):A!==-1&&(o=-1)}return A===-1||L===-1||o===0||o===1&&A===L-1&&A===h+1?"":r.slice(A,L)},format:b.bind(null,"\\"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const A=r.length;let h=0,L=r.charCodeAt(0);if(A===1)return D(L)?(a.root=a.dir=r,a):(a.base=a.name=r,a);if(D(L)){if(h=1,D(r.charCodeAt(1))){let I=2,B=I;for(;I<A&&!D(r.charCodeAt(I));)I++;if(I<A&&I!==B){for(B=I;I<A&&D(r.charCodeAt(I));)I++;if(I<A&&I!==B){for(B=I;I<A&&!D(r.charCodeAt(I));)I++;I===A?h=I:I!==B&&(h=I+1)}}}}else if(v(L)&&r.charCodeAt(1)===g){if(A<=2)return a.root=a.dir=r,a;if(h=2,D(r.charCodeAt(2))){if(A===3)return a.root=a.dir=r,a;h=3}}h>0&&(a.root=r.slice(0,h));let c=-1,o=h,p=-1,S=!0,P=r.length-1,E=0;for(;P>=h;--P){if(L=r.charCodeAt(P),D(L)){if(!S){o=P+1;break}continue}p===-1&&(S=!1,p=P+1),L===m?c===-1?c=P:E!==1&&(E=1):c!==-1&&(E=-1)}return p!==-1&&(c===-1||E===0||E===1&&c===p-1&&c===o+1?a.base=a.name=r.slice(o,p):(a.name=r.slice(o,c),a.base=r.slice(o,p),a.ext=r.slice(c,p))),o>0&&o!==h?a.dir=r.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const _=(()=>{if(w){const r=/\\/g;return()=>{const a=F.cwd().replace(r,"/");return a.slice(a.indexOf("/"))}}return()=>F.cwd()})();t.posix={resolve(...r){let a="",A=!1;for(let h=r.length-1;h>=-1&&!A;h--){const L=h>=0?r[h]:_();e(L,"path"),L.length!==0&&(a=`${L}/${a}`,A=L.charCodeAt(0)===s)}return a=R(a,!A,"/",y),A?`/${a}`:a.length>0?a:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s,A=r.charCodeAt(r.length-1)===s;return r=R(r,!a,"/",y),r.length===0?a?"/":A?"./":".":(A&&(r+="/"),a?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let a;for(let A=0;A<r.length;++A){const h=r[A];e(h,"path"),h.length>0&&(a===void 0?a=h:a+=`/${h}`)}return a===void 0?".":t.posix.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a||(r=t.posix.resolve(r),a=t.posix.resolve(a),r===a))return"";const A=1,h=r.length,L=h-A,c=1,o=a.length-c,p=L<o?L:o;let S=-1,P=0;for(;P<p;P++){const I=r.charCodeAt(A+P);if(I!==a.charCodeAt(c+P))break;I===s&&(S=P)}if(P===p)if(o>p){if(a.charCodeAt(c+P)===s)return a.slice(c+P+1);if(P===0)return a.slice(c+P)}else L>p&&(r.charCodeAt(A+P)===s?S=P:P===0&&(S=0));let E="";for(P=A+S+1;P<=h;++P)(P===h||r.charCodeAt(P)===s)&&(E+=E.length===0?"..":"/..");return`${E}${a.slice(c+S)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s;let A=-1,h=!0;for(let L=r.length-1;L>=1;--L)if(r.charCodeAt(L)===s){if(!h){A=L;break}}else h=!1;return A===-1?a?"/":".":a&&A===1?"//":r.slice(0,A)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let A=0,h=-1,L=!0,c;if(a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let o=a.length-1,p=-1;for(c=r.length-1;c>=0;--c){const S=r.charCodeAt(c);if(S===s){if(!L){A=c+1;break}}else p===-1&&(L=!1,p=c+1),o>=0&&(S===a.charCodeAt(o)?--o===-1&&(h=c):(o=-1,h=p))}return A===h?h=p:h===-1&&(h=r.length),r.slice(A,h)}for(c=r.length-1;c>=0;--c)if(r.charCodeAt(c)===s){if(!L){A=c+1;break}}else h===-1&&(L=!1,h=c+1);return h===-1?"":r.slice(A,h)},extname(r){e(r,"path");let a=-1,A=0,h=-1,L=!0,c=0;for(let o=r.length-1;o>=0;--o){const p=r.charCodeAt(o);if(p===s){if(!L){A=o+1;break}continue}h===-1&&(L=!1,h=o+1),p===m?a===-1?a=o:c!==1&&(c=1):a!==-1&&(c=-1)}return a===-1||h===-1||c===0||c===1&&a===h-1&&a===A+1?"":r.slice(a,h)},format:b.bind(null,"/"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const A=r.charCodeAt(0)===s;let h;A?(a.root="/",h=1):h=0;let L=-1,c=0,o=-1,p=!0,S=r.length-1,P=0;for(;S>=h;--S){const E=r.charCodeAt(S);if(E===s){if(!p){c=S+1;break}continue}o===-1&&(p=!1,o=S+1),E===m?L===-1?L=S:P!==1&&(P=1):L!==-1&&(P=-1)}if(o!==-1){const E=c===0&&A?1:c;L===-1||P===0||P===1&&L===o-1&&L===c+1?a.base=a.name=r.slice(E,o):(a.name=r.slice(E,L),a.base=r.slice(E,o),a.ext=r.slice(L,o))}return c>0?a.dir=r.slice(0,c-1):A&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=w?t.win32.normalize:t.posix.normalize,t.isAbsolute=w?t.win32.isAbsolute:t.posix.isAbsolute,t.join=w?t.win32.join:t.posix.join,t.resolve=w?t.win32.resolve:t.posix.resolve,t.relative=w?t.win32.relative:t.posix.relative,t.dirname=w?t.win32.dirname:t.posix.dirname,t.basename=w?t.win32.basename:t.posix.basename,t.extname=w?t.win32.extname:t.posix.extname,t.format=w?t.win32.format:t.posix.format,t.parse=w?t.win32.parse:t.posix.parse,t.toNamespacedPath=w?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=w?t.win32.sep:t.posix.sep,t.delimiter=w?t.win32.delimiter:t.posix.delimiter}),Z(K[23],ee([0,1,9]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const T=F.globals.performance&&typeof F.globals.performance.now=="function";class i{static create(N=!0){return new i(N)}constructor(N){this._highResolution=T&&N,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?F.globals.performance.now():Date.now()}}t.StopWatch=i}),Z(K[10],ee([0,1,3,15,7,17,23]),function(V,t,F,T,i,u,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const m=!1,s=!1;var l;(function(c){c.None=()=>i.Disposable.None;function o(te){if(s){const{onDidAddListener:Q}=te,C=e.create();let U=0;te.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),C.print()),Q?.()}}}function p(te,Q){return X(te,()=>{},0,void 0,!0,void 0,Q)}c.defer=p;function S(te){return(Q,C=null,U)=>{let O=!1,x;return x=te(z=>{if(!O)return x?x.dispose():O=!0,Q.call(C,z)},null,U),O&&x.dispose(),x}}c.once=S;function P(te,Q,C){return J((U,O=null,x)=>te(z=>U.call(O,Q(z)),null,x),C)}c.map=P;function E(te,Q,C){return J((U,O=null,x)=>te(z=>{Q(z),U.call(O,z)},null,x),C)}c.forEach=E;function I(te,Q,C){return J((U,O=null,x)=>te(z=>Q(z)&&U.call(O,z),null,x),C)}c.filter=I;function B(te){return te}c.signal=B;function W(...te){return(Q,C=null,U)=>(0,i.combinedDisposable)(...te.map(O=>O(x=>Q.call(C,x),null,U)))}c.any=W;function j(te,Q,C,U){let O=C;return P(te,x=>(O=Q(O,x),O),U)}c.reduce=j;function J(te,Q){let C;const U={onWillAddFirstListener(){C=te(O.fire,O)},onDidRemoveLastListener(){C?.dispose()}};Q||o(U);const O=new D(U);return Q?.add(O),O.event}function X(te,Q,C=100,U=!1,O=!1,x,z){let ne,ie,ae,ce=0,he;const ve={leakWarningThreshold:x,onWillAddFirstListener(){ne=te(Te=>{ce++,ie=Q(ie,Te),U&&!ae&&(De.fire(ie),ie=void 0),he=()=>{const Ie=ie;ie=void 0,ae=void 0,(!U||ce>1)&&De.fire(Ie),ce=0},typeof C=="number"?(clearTimeout(ae),ae=setTimeout(he,C)):ae===void 0&&(ae=0,queueMicrotask(he))})},onWillRemoveListener(){O&&ce>0&&he?.()},onDidRemoveLastListener(){he=void 0,ne.dispose()}};z||o(ve);const De=new D(ve);return z?.add(De),De.event}c.debounce=X;function G(te,Q=0,C){return c.debounce(te,(U,O)=>U?(U.push(O),U):[O],Q,void 0,!0,void 0,C)}c.accumulate=G;function se(te,Q=(U,O)=>U===O,C){let U=!0,O;return I(te,x=>{const z=U||!Q(x,O);return U=!1,O=x,z},C)}c.latch=se;function n(te,Q,C){return[c.filter(te,Q,C),c.filter(te,U=>!Q(U),C)]}c.split=n;function me(te,Q=!1,C=[]){let U=C.slice(),O=te(ne=>{U?U.push(ne):z.fire(ne)});const x=()=>{U?.forEach(ne=>z.fire(ne)),U=null},z=new D({onWillAddFirstListener(){O||(O=te(ne=>z.fire(ne)))},onDidAddFirstListener(){U&&(Q?setTimeout(x):x())},onDidRemoveLastListener(){O&&O.dispose(),O=null}});return z.event}c.buffer=me;class de{constructor(Q){this.event=Q,this.disposables=new i.DisposableStore}map(Q){return new de(P(this.event,Q,this.disposables))}forEach(Q){return new de(E(this.event,Q,this.disposables))}filter(Q){return new de(I(this.event,Q,this.disposables))}reduce(Q,C){return new de(j(this.event,Q,C,this.disposables))}latch(){return new de(se(this.event,void 0,this.disposables))}debounce(Q,C=100,U=!1,O=!1,x){return new de(X(this.event,Q,C,U,O,x,this.disposables))}on(Q,C,U){return this.event(Q,C,U)}once(Q,C,U){return S(this.event)(Q,C,U)}dispose(){this.disposables.dispose()}}function be(te){return new de(te)}c.chain=be;function _e(te,Q,C=U=>U){const U=(...ne)=>z.fire(C(...ne)),O=()=>te.on(Q,U),x=()=>te.removeListener(Q,U),z=new D({onWillAddFirstListener:O,onDidRemoveLastListener:x});return z.event}c.fromNodeEventEmitter=_e;function pe(te,Q,C=U=>U){const U=(...ne)=>z.fire(C(...ne)),O=()=>te.addEventListener(Q,U),x=()=>te.removeEventListener(Q,U),z=new D({onWillAddFirstListener:O,onDidRemoveLastListener:x});return z.event}c.fromDOMEventEmitter=pe;function le(te){return new Promise(Q=>S(te)(Q))}c.toPromise=le;function oe(te,Q){return Q(void 0),te(C=>Q(C))}c.runAndSubscribe=oe;function we(te,Q){let C=null;function U(x){C?.dispose(),C=new i.DisposableStore,Q(x,C)}U(void 0);const O=te(x=>U(x));return(0,i.toDisposable)(()=>{O.dispose(),C?.dispose()})}c.runAndSubscribeWithStore=we;class Le{constructor(Q,C){this._observable=Q,this._counter=0,this._hasChanged=!1;const U={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};C||o(U),this.emitter=new D(U),C&&C.add(this.emitter)}beginUpdate(Q){this._counter++}handlePossibleChange(Q){}handleChange(Q,C){this._hasChanged=!0}endUpdate(Q){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ye(te,Q){return new Le(te,Q).emitter.event}c.fromObservable=ye;function Fe(te){return Q=>{let C=0,U=!1;const O={beginUpdate(){C++},endUpdate(){C--,C===0&&(te.reportChanges(),U&&(U=!1,Q()))},handlePossibleChange(){},handleChange(){U=!0}};return te.addObserver(O),{dispose(){te.removeObserver(O)}}}}c.fromObservableLight=Fe})(l||(t.Event=l={}));class g{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${g._idPool++}`,g.all.add(this)}start(o){this._stopWatch=new N.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=g,g.all=new Set,g._idPool=0;let M=-1;function f(c){const o=M;return M=c,{dispose(){M=o}}}t.setGlobalLeakWarningThreshold=f;class d{constructor(o,p=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=p,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(o,p){const S=this.threshold;if(S<=0||p<S)return;this._stacks||(this._stacks=new Map);const P=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,P+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=S*.5;let E,I=0;for(const[B,W]of this._stacks)(!E||I<W)&&(E=B,I=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${I}):`),console.warn(E)}return()=>{const E=this._stacks.get(o.value)||0;this._stacks.set(o.value,E-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(o,p,S){this.callback=o,this.callbackThis=p,this.stack=S,this.subscription=new i.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class D{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=M>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??M):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(m){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const p of o)p.subscription.isset()&&(p.subscription.unset(),p.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,p,S)=>{if(this._listeners||(this._listeners=new u.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const P=this._listeners.isEmpty();P&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let E,I;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(I=e.create(),E=this._leakageMon.check(I,this._listeners.size+1)),m&&(I=I??e.create());const B=new w(o,p,I),W=this._listeners.push(B);P&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,o,p);const j=B.subscription.set(()=>{E?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),W(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return S instanceof i.DisposableStore?S.add(j):Array.isArray(S)&&S.push(j),j}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v(this._options?.onListenerError));for(const p of this._listeners)this._deliveryQueue.push(this,p,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=D;class y{constructor(o=F.onUnexpectedError){this._onListenerError=o,this._queue=new u.LinkedList}get size(){return this._queue.size}push(o,p,S){this._queue.push(new R(o,p,S))}clear(o){const p=new u.LinkedList;for(const S of this._queue)S.emitter!==o&&p.push(S);this._queue=p}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(p){this._onListenerError(p)}}}}t.EventDeliveryQueue=y;class v extends y{clear(o){this._queue.clear()}}class R{constructor(o,p,S){this.emitter=o,this.listener=p,this.event=S}}class b extends D{async fireAsync(o,p,S){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new u.LinkedList);for(const P of this._listeners)this._asyncDeliveryQueue.push([P,o]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[P,E]=this._asyncDeliveryQueue.shift(),I=[],B={...E,token:p,waitUntil:W=>{if(Object.isFrozen(I))throw new Error("waitUntil can NOT be called asynchronous");S&&(W=S(W,P.callback)),I.push(W)}};try{P.invoke(B)}catch(W){(0,F.onUnexpectedError)(W);continue}Object.freeze(I),await Promise.allSettled(I).then(W=>{for(const j of W)j.status==="rejected"&&(0,F.onUnexpectedError)(j.reason)})}}}}t.AsyncEmitter=b;class _ extends D{get isPaused(){return this._isPaused!==0}constructor(o){super(o),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}t.PauseableEmitter=_;class r extends _{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}t.DebounceEmitter=r;class a extends D{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this.hasListeners()&&(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(p=>super.fire(p)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=a;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new D({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const p={event:o,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const S=()=>{this.hasListeners&&this.unhook(p);const P=this.events.indexOf(p);this.events.splice(P,1)};return(0,i.toDisposable)((0,T.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(p=>this.emitter.fire(p))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=A;class h{constructor(){this.buffers=[]}wrapEvent(o){return(p,S,P)=>o(E=>{const I=this.buffers[this.buffers.length-1];I?I.push(()=>p.call(S,E)):p.call(S,E)},void 0,P)}bufferEvents(o){const p=[];this.buffers.push(p);const S=o();return this.buffers.pop(),p.forEach(P=>P()),S}}t.EventBufferer=h;class L{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=i.Disposable.None,this.emitter=new D({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=L}),Z(K[24],ee([0,1,10]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const T=Object.freeze(function(m,s){const l=setTimeout(m.bind(s),0);return{dispose(){clearTimeout(l)}}});var i;(function(m){function s(l){return l===m.None||l===m.Cancelled||l instanceof u?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}m.isCancellationToken=s,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(i||(t.CancellationToken=i={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new F.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class N{constructor(s){this._token=void 0,this._parentListener=void 0,this._parentListener=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(s=!1){s&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=N}),Z(K[49],ee([0,1,24]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class T{constructor(m){this.task=m,this.result=null}get(){if(this.result)return this.result;const m=new F.CancellationTokenSource,s=this.task(m.token);return this.result={promise:s,dispose:()=>{this.result=null,m.cancel(),m.dispose()}},this.result}}t.Cache=T;class i{constructor(m){this.fn=m,this.lastCache=void 0,this.lastArgKey=void 0}get(m){const s=JSON.stringify(m);return this.lastArgKey!==s&&(this.lastArgKey=s,this.lastCache=this.fn(m)),this.lastCache}}t.LRUCachedFunction=i;class u{get cachedValues(){return this._map}constructor(m){this.fn=m,this._map=new Map}get(m){if(this._map.has(m))return this._map.get(m);const s=this.fn(m);return this._map.set(m,s),s}}t.CachedFunction=u}),Z(K[5],ee([0,1,49,31]),function(V,t,F,T){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(k){return!k||typeof k!="string"?!0:k.trim().length===0}t.isFalsyOrWhitespace=u;const N=/{(\d+)}/g;function m(k,...q){return q.length===0?k:k.replace(N,function(H,$){const Y=parseInt($,10);return isNaN(Y)||Y<0||Y>=q.length?H:q[Y]})}t.format=m;const s=/{([^}]+)}/g;function l(k,q){return k.replace(s,(H,$)=>q[$]??H)}t.format2=l;function g(k){return k.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}t.escape=g;function M(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=M;function f(k,q){let H=0;const $=q.charCodeAt(0);for(let Y=k.length-1;Y>=0;Y--)k.charCodeAt(Y)===$&&H++;return H}t.count=f;function d(k,q,H="\u2026"){return k.length<=q?k:`${k.substr(0,q)}${H}`}t.truncate=d;function e(k,q=" "){const H=w(k,q);return D(H,q)}t.trim=e;function w(k,q){if(!k||!q)return k;const H=q.length;if(H===0||k.length===0)return k;let $=0;for(;k.indexOf(q,$)===$;)$=$+H;return k.substring($)}t.ltrim=w;function D(k,q){if(!k||!q)return k;const H=q.length,$=k.length;if(H===0||$===0)return k;let Y=$,re=-1;for(;re=k.lastIndexOf(q,Y-1),!(re===-1||re+H!==Y);){if(re===0)return"";Y=re}return k.substring(0,Y)}t.rtrim=D;function y(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=y;function v(k){return k.replace(/\*/g,"")}t.stripWildcards=v;function R(k,q,H={}){if(!k)throw new Error("Cannot create regex from empty string");q||(k=M(k)),H.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let $="";return H.global&&($+="g"),H.matchCase||($+="i"),H.multiline&&($+="m"),H.unicode&&($+="u"),new RegExp(k,$)}t.createRegExp=R;function b(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}t.regExpLeadsToEndlessLoop=b;function _(k){return!!k.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=_;function r(k){return(k.global?"g":"")+(k.ignoreCase?"i":"")+(k.multiline?"m":"")+(k.unicode?"u":"")}t.regExpFlags=r;function a(k){return k.split(/\r\n|\r|\n/)}t.splitLines=a;function A(k){for(let q=0,H=k.length;q<H;q++){const $=k.charCodeAt(q);if($!==32&&$!==9)return q}return-1}t.firstNonWhitespaceIndex=A;function h(k,q=0,H=k.length){for(let $=q;$<H;$++){const Y=k.charCodeAt($);if(Y!==32&&Y!==9)return k.substring(q,$)}return k.substring(q,H)}t.getLeadingWhitespace=h;function L(k,q=k.length-1){for(let H=q;H>=0;H--){const $=k.charCodeAt(H);if($!==32&&$!==9)return H}return-1}t.lastNonWhitespaceIndex=L;function c(k,q,H){const $=[];let Y=0;for(const re of k.matchAll(q)){if($.push(k.slice(Y,re.index)),re.index===void 0)throw new Error("match.index should be defined");Y=re.index+re[0].length,$.push(H(re[0],...re.slice(1),re.index,k,re.groups))}return $.push(k.slice(Y)),Promise.all($).then(re=>re.join(""))}t.replaceAsync=c;function o(k,q){return k<q?-1:k>q?1:0}t.compare=o;function p(k,q,H=0,$=k.length,Y=0,re=q.length){for(;H<$&&Y<re;H++,Y++){const Ee=k.charCodeAt(H),ue=q.charCodeAt(Y);if(Ee<ue)return-1;if(Ee>ue)return 1}const ge=$-H,Pe=re-Y;return ge<Pe?-1:ge>Pe?1:0}t.compareSubstring=p;function S(k,q){return P(k,q,0,k.length,0,q.length)}t.compareIgnoreCase=S;function P(k,q,H=0,$=k.length,Y=0,re=q.length){for(;H<$&&Y<re;H++,Y++){let Ee=k.charCodeAt(H),ue=q.charCodeAt(Y);if(Ee===ue)continue;if(Ee>=128||ue>=128)return p(k.toLowerCase(),q.toLowerCase(),H,$,Y,re);I(Ee)&&(Ee-=32),I(ue)&&(ue-=32);const Ae=Ee-ue;if(Ae!==0)return Ae}const ge=$-H,Pe=re-Y;return ge<Pe?-1:ge>Pe?1:0}t.compareSubstringIgnoreCase=P;function E(k){return k>=48&&k<=57}t.isAsciiDigit=E;function I(k){return k>=97&&k<=122}t.isLowerAsciiLetter=I;function B(k){return k>=65&&k<=90}t.isUpperAsciiLetter=B;function W(k,q){return k.length===q.length&&P(k,q)===0}t.equalsIgnoreCase=W;function j(k,q){const H=q.length;return q.length>k.length?!1:P(k,q,0,H)===0}t.startsWithIgnoreCase=j;function J(k,q){const H=Math.min(k.length,q.length);let $;for($=0;$<H;$++)if(k.charCodeAt($)!==q.charCodeAt($))return $;return H}t.commonPrefixLength=J;function X(k,q){const H=Math.min(k.length,q.length);let $;const Y=k.length-1,re=q.length-1;for($=0;$<H;$++)if(k.charCodeAt(Y-$)!==q.charCodeAt(re-$))return $;return H}t.commonSuffixLength=X;function G(k){return 55296<=k&&k<=56319}t.isHighSurrogate=G;function se(k){return 56320<=k&&k<=57343}t.isLowSurrogate=se;function n(k,q){return(k-55296<<10)+(q-56320)+65536}t.computeCodePoint=n;function me(k,q,H){const $=k.charCodeAt(H);if(G($)&&H+1<q){const Y=k.charCodeAt(H+1);if(se(Y))return n($,Y)}return $}t.getNextCodePoint=me;function de(k,q){const H=k.charCodeAt(q-1);if(se(H)&&q>1){const $=k.charCodeAt(q-2);if(G($))return n($,H)}return H}class be{get offset(){return this._offset}constructor(q,H=0){this._str=q,this._len=q.length,this._offset=H}setOffset(q){this._offset=q}prevCodePoint(){const q=de(this._str,this._offset);return this._offset-=q>=65536?2:1,q}nextCodePoint(){const q=me(this._str,this._len,this._offset);return this._offset+=q>=65536?2:1,q}eol(){return this._offset>=this._len}}t.CodePointIterator=be;class _e{get offset(){return this._iterator.offset}constructor(q,H=0){this._iterator=new be(q,H)}nextGraphemeLength(){const q=Re.getInstance(),H=this._iterator,$=H.offset;let Y=q.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const re=H.offset,ge=q.getGraphemeBreakType(H.nextCodePoint());if(Ue(Y,ge)){H.setOffset(re);break}Y=ge}return H.offset-$}prevGraphemeLength(){const q=Re.getInstance(),H=this._iterator,$=H.offset;let Y=q.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const re=H.offset,ge=q.getGraphemeBreakType(H.prevCodePoint());if(Ue(ge,Y)){H.setOffset(re);break}Y=ge}return $-H.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=_e;function pe(k,q){return new _e(k,q).nextGraphemeLength()}t.nextCharLength=pe;function le(k,q){return new _e(k,q).prevGraphemeLength()}t.prevCharLength=le;function oe(k,q){q>0&&se(k.charCodeAt(q))&&q--;const H=q+pe(k,q);return[H-le(k,H),H]}t.getCharContainingOffset=oe;function we(k){const q=new _e(k);let H=0;for(;!q.eol();)H++,q.nextGraphemeLength();return H}t.charCount=we;let Le;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(k){return Le||(Le=ye()),Le.test(k)}t.containsRTL=Fe;const te=/^[\t\n\r\x20-\x7E]*$/;function Q(k){return te.test(k)}t.isBasicASCII=Q,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function C(k){return t.UNUSUAL_LINE_TERMINATORS.test(k)}t.containsUnusualLineTerminators=C;function U(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}t.isFullWidthCharacter=U;function O(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}t.isEmojiImprecise=O;function x(k,q){if(k.length<q)return k;const H=/\b/g;let $=0;for(;H.test(k)&&!(k.length-H.lastIndex<q);)$=H.lastIndex,H.lastIndex+=1;return k.substring($).replace(/^\s/,"")}t.lcut=x;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function ie(k){return k&&(k=k.replace(z,"").replace(ne,"")),k}t.removeAnsiEscapeCodes=ie,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ae;function ce(k){return ae(k)?k.substr(1):k}t.stripUTF8BOM=ce;function he(k,q){if(!k||!q||k.length<q.length)return!1;const H=q.length,$=k.toLowerCase();let Y=0,re=-1;for(;Y<H;){const ge=$.indexOf(q[Y],re+1);if(ge<0)return!1;re=ge,Y++}return!0}t.fuzzyContains=he;function ve(k,q=!1){return k?(q&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}t.containsUppercaseCharacter=ve;function De(k){return k.charAt(0).toUpperCase()+k.slice(1)}t.uppercaseFirstLetter=De;function Te(k,q=1){if(q===0)return"";let H=-1;do H=k.indexOf(`
`,H+1),q--;while(q>0&&H>=0);return H===-1?k:(k[H-1]==="\r"&&H--,k.substr(0,H))}t.getNLines=Te;function Ie(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}t.singleLetterHash=Ie;function Ve(k){return Re.getInstance().getGraphemeBreakType(k)}t.getGraphemeBreakType=Ve;function Ue(k,q){return k===0?q!==5&&q!==7:k===2&&q===3?!1:k===4||k===2||k===3||q===4||q===2||q===3?!0:!(k===8&&(q===8||q===9||q===11||q===12)||(k===11||k===9)&&(q===9||q===10)||(k===12||k===10)&&q===10||q===5||q===13||q===7||k===1||k===13&&q===14||k===6&&q===6)}var Oe;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(t.GraphemeBreakType=Oe={}));class Re{static getInstance(){return Re._INSTANCE||(Re._INSTANCE=new Re),Re._INSTANCE}constructor(){this._data=xe()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const H=this._data,$=H.length/3;let Y=1;for(;Y<=$;)if(q<H[3*Y])Y=2*Y;else if(q>H[3*Y+1])Y=2*Y+1;else return H[3*Y+2];return 0}}Re._INSTANCE=null;function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(k,q){if(k===0)return 0;const H=ze(k,q);if(H!==void 0)return H;const $=new be(q,k);return $.prevCodePoint(),$.offset}t.getLeftDeleteOffset=He;function ze(k,q){const H=new be(q,k);let $=H.prevCodePoint();for(;je($)||$===65039||$===8419;){if(H.offset===0)return;$=H.prevCodePoint()}if(!O($))return;let Y=H.offset;return Y>0&&H.prevCodePoint()===8205&&(Y=H.offset),Y}function je(k){return 127995<=k&&k<=127999}var Be;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class Ne{static getInstance(q){return Ne.cache.get(Array.from(q))}static getLocales(){return Ne._locales.value}constructor(q){this.confusableDictionary=q}isAmbiguous(q){return this.confusableDictionary.has(q)}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Ne,i=Ne,Ne.ambiguousCharacterData=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.cache=new F.LRUCachedFunction(k=>{function q(ue){const Ae=new Map;for(let Me=0;Me<ue.length;Me+=2)Ae.set(ue[Me],ue[Me+1]);return Ae}function H(ue,Ae){const Me=new Map(ue);for(const[ke,Ce]of Ae)Me.set(ke,Ce);return Me}function $(ue,Ae){if(!ue)return Ae;const Me=new Map;for(const[ke,Ce]of ue)Ae.has(ke)&&Me.set(ke,Ce);return Me}const Y=i.ambiguousCharacterData.value;let re=k.filter(ue=>!ue.startsWith("_")&&ue in Y);re.length===0&&(re=["_default"]);let ge;for(const ue of re){const Ae=q(Y[ue]);ge=$(ge,Ae)}const Pe=q(Y._common),Ee=H(Pe,ge);return new Ne(Ee)}),Ne._locales=new T.Lazy(()=>Object.keys(Ne.ambiguousCharacterData.value).filter(k=>!k.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(q){return Se.getData().has(q)}static get codePoints(){return Se.getData()}}t.InvisibleCharacters=Se,Se._data=void 0}),Z(K[50],ee([0,1,5]),function(V,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function T(y){return i(y,0)}t.hash=T;function i(y,v){switch(typeof y){case"object":return y===null?u(349,v):Array.isArray(y)?s(y,v):l(y,v);case"string":return m(y,v);case"boolean":return N(y,v);case"number":return u(y,v);case"undefined":return u(937,v);default:return u(617,v)}}t.doHash=i;function u(y,v){return(v<<5)-v+y|0}t.numberHash=u;function N(y,v){return u(y?433:863,v)}function m(y,v){v=u(149417,v);for(let R=0,b=y.length;R<b;R++)v=u(y.charCodeAt(R),v);return v}t.stringHash=m;function s(y,v){return v=u(104579,v),y.reduce((R,b)=>i(b,R),v)}function l(y,v){return v=u(181387,v),Object.keys(y).sort().reduce((R,b)=>(R=m(b,R),i(y[b],R)),v)}class g{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=i(v,this._value),this._value}}t.Hasher=g;var M;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function f(y,v,R=32){const b=R-v,_=~((1<<b)-1);return(y<<v|(_&y)>>>b)>>>0}function d(y,v=0,R=y.byteLength,b=0){for(let _=0;_<R;_++)y[v+_]=b}function e(y,v,R="0"){for(;y.length<v;)y=R+y;return y}function w(y,v=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(R=>R.toString(16).padStart(2,"0")).join(""):e((y>>>0).toString(16),v/4)}t.toHexString=w;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const R=v.length;if(R===0)return;const b=this._buff;let _=this._buffLen,r=this._leftoverHighSurrogate,a,A;for(r!==0?(a=r,A=-1,r=0):(a=v.charCodeAt(0),A=0);;){let h=a;if(F.isHighSurrogate(a))if(A+1<R){const L=v.charCodeAt(A+1);F.isLowSurrogate(L)?(A++,h=F.computeCodePoint(a,L)):h=65533}else{r=a;break}else F.isLowSurrogate(a)&&(h=65533);if(_=this._push(b,_,h),A++,A<R)a=v.charCodeAt(A);else break}this._buffLen=_,this._leftoverHighSurrogate=r}_push(v,R,b){return b<128?v[R++]=b:b<2048?(v[R++]=192|(b&1984)>>>6,v[R++]=128|(b&63)>>>0):b<65536?(v[R++]=224|(b&61440)>>>12,v[R++]=128|(b&4032)>>>6,v[R++]=128|(b&63)>>>0):(v[R++]=240|(b&1835008)>>>18,v[R++]=128|(b&258048)>>>12,v[R++]=128|(b&4032)>>>6,v[R++]=128|(b&63)>>>0),R>=64&&(this._step(),R-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),R}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=D._bigBlock32,R=this._buffDV;for(let o=0;o<64;o+=4)v.setUint32(o,R.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,f(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let b=this._h0,_=this._h1,r=this._h2,a=this._h3,A=this._h4,h,L,c;for(let o=0;o<80;o++)o<20?(h=_&r|~_&a,L=1518500249):o<40?(h=_^r^a,L=1859775393):o<60?(h=_&r|_&a|r&a,L=2400959708):(h=_^r^a,L=3395469782),c=f(b,5)+h+A+L+v.getUint32(o*4,!1)&4294967295,A=a,a=r,r=f(_,30),_=b,b=c;this._h0=this._h0+b&4294967295,this._h1=this._h1+_&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+A&4294967295}}t.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),Z(K[25],ee([0,1,28,50]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(f){this.source=f}getElements(){const f=this.source,d=new Int32Array(f.length);for(let e=0,w=f.length;e<w;e++)d[e]=f.charCodeAt(e);return d}}t.StringDiffSequence=i;function u(M,f,d){return new g(new i(M),new i(f)).ComputeDiff(d).changes}t.stringDiff=u;class N{static Assert(f,d){if(!f)throw new Error(d)}}class m{static Copy(f,d,e,w,D){for(let y=0;y<D;y++)e[w+y]=f[d+y]}static Copy2(f,d,e,w,D){for(let y=0;y<D;y++)e[w+y]=f[d+y]}}var s;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new F.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(f,d){this.m_originalStart=Math.min(this.m_originalStart,f),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(f,d){this.m_originalStart=Math.min(this.m_originalStart,f),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class g{constructor(f,d,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=f,this._modifiedSequence=d;const[w,D,y]=g._getElements(f),[v,R,b]=g._getElements(d);this._hasStrings=y&&b,this._originalStringElements=w,this._originalElementsOrHash=D,this._modifiedStringElements=v,this._modifiedElementsOrHash=R,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(f){return f.length>0&&typeof f[0]=="string"}static _getElements(f){const d=f.getElements();if(g._isStringArray(d)){const e=new Int32Array(d.length);for(let w=0,D=d.length;w<D;w++)e[w]=(0,T.stringHash)(d[w],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(f,d){return this._originalElementsOrHash[f]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[f]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(f,d){if(!this.ElementsAreEqual(f,d))return!1;const e=g._getStrictElement(this._originalSequence,f),w=g._getStrictElement(this._modifiedSequence,d);return e===w}static _getStrictElement(f,d){return typeof f.getStrictElement=="function"?f.getStrictElement(d):null}OriginalElementsAreEqual(f,d){return this._originalElementsOrHash[f]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[f]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(f,d){return this._modifiedElementsOrHash[f]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[f]===this._modifiedStringElements[d]:!0}ComputeDiff(f){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,f)}_ComputeDiff(f,d,e,w,D){const y=[!1];let v=this.ComputeDiffRecursive(f,d,e,w,y);return D&&(v=this.PrettifyChanges(v)),{quitEarly:y[0],changes:v}}ComputeDiffRecursive(f,d,e,w,D){for(D[0]=!1;f<=d&&e<=w&&this.ElementsAreEqual(f,e);)f++,e++;for(;d>=f&&w>=e&&this.ElementsAreEqual(d,w);)d--,w--;if(f>d||e>w){let r;return e<=w?(N.Assert(f===d+1,"originalStart should only be one more than originalEnd"),r=[new F.DiffChange(f,0,e,w-e+1)]):f<=d?(N.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),r=[new F.DiffChange(f,d-f+1,e,0)]):(N.Assert(f===d+1,"originalStart should only be one more than originalEnd"),N.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const y=[0],v=[0],R=this.ComputeRecursionPoint(f,d,e,w,y,v,D),b=y[0],_=v[0];if(R!==null)return R;if(!D[0]){const r=this.ComputeDiffRecursive(f,b,e,_,D);let a=[];return D[0]?a=[new F.DiffChange(b+1,d-(b+1)+1,_+1,w-(_+1)+1)]:a=this.ComputeDiffRecursive(b+1,d,_+1,w,D),this.ConcatenateChanges(r,a)}return[new F.DiffChange(f,d-f+1,e,w-e+1)]}WALKTRACE(f,d,e,w,D,y,v,R,b,_,r,a,A,h,L,c,o,p){let S=null,P=null,E=new l,I=d,B=e,W=A[0]-c[0]-w,j=-1073741824,J=this.m_forwardHistory.length-1;do{const X=W+f;X===I||X<B&&b[X-1]<b[X+1]?(r=b[X+1],h=r-W-w,r<j&&E.MarkNextChange(),j=r,E.AddModifiedElement(r+1,h),W=X+1-f):(r=b[X-1]+1,h=r-W-w,r<j&&E.MarkNextChange(),j=r-1,E.AddOriginalElement(r,h+1),W=X-1-f),J>=0&&(b=this.m_forwardHistory[J],f=b[0],I=1,B=b.length-1)}while(--J>=-1);if(S=E.getReverseChanges(),p[0]){let X=A[0]+1,G=c[0]+1;if(S!==null&&S.length>0){const se=S[S.length-1];X=Math.max(X,se.getOriginalEnd()),G=Math.max(G,se.getModifiedEnd())}P=[new F.DiffChange(X,a-X+1,G,L-G+1)]}else{E=new l,I=y,B=v,W=A[0]-c[0]-R,j=1073741824,J=o?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const X=W+D;X===I||X<B&&_[X-1]>=_[X+1]?(r=_[X+1]-1,h=r-W-R,r>j&&E.MarkNextChange(),j=r+1,E.AddOriginalElement(r+1,h+1),W=X+1-D):(r=_[X-1],h=r-W-R,r>j&&E.MarkNextChange(),j=r,E.AddModifiedElement(r+1,h+1),W=X-1-D),J>=0&&(_=this.m_reverseHistory[J],D=_[0],I=1,B=_.length-1)}while(--J>=-1);P=E.getChanges()}return this.ConcatenateChanges(S,P)}ComputeRecursionPoint(f,d,e,w,D,y,v){let R=0,b=0,_=0,r=0,a=0,A=0;f--,e--,D[0]=0,y[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const h=d-f+(w-e),L=h+1,c=new Int32Array(L),o=new Int32Array(L),p=w-e,S=d-f,P=f-e,E=d-w,B=(S-p)%2===0;c[p]=f,o[S]=d,v[0]=!1;for(let W=1;W<=h/2+1;W++){let j=0,J=0;_=this.ClipDiagonalBound(p-W,W,p,L),r=this.ClipDiagonalBound(p+W,W,p,L);for(let G=_;G<=r;G+=2){G===_||G<r&&c[G-1]<c[G+1]?R=c[G+1]:R=c[G-1]+1,b=R-(G-p)-P;const se=R;for(;R<d&&b<w&&this.ElementsAreEqual(R+1,b+1);)R++,b++;if(c[G]=R,R+b>j+J&&(j=R,J=b),!B&&Math.abs(G-S)<=W-1&&R>=o[G])return D[0]=R,y[0]=b,se<=o[G]&&1447>0&&W<=1447+1?this.WALKTRACE(p,_,r,P,S,a,A,E,c,o,R,d,D,b,w,y,B,v):null}const X=(j-f+(J-e)-W)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(j,X))return v[0]=!0,D[0]=j,y[0]=J,X>0&&1447>0&&W<=1447+1?this.WALKTRACE(p,_,r,P,S,a,A,E,c,o,R,d,D,b,w,y,B,v):(f++,e++,[new F.DiffChange(f,d-f+1,e,w-e+1)]);a=this.ClipDiagonalBound(S-W,W,S,L),A=this.ClipDiagonalBound(S+W,W,S,L);for(let G=a;G<=A;G+=2){G===a||G<A&&o[G-1]>=o[G+1]?R=o[G+1]-1:R=o[G-1],b=R-(G-S)-E;const se=R;for(;R>f&&b>e&&this.ElementsAreEqual(R,b);)R--,b--;if(o[G]=R,B&&Math.abs(G-p)<=W&&R<=c[G])return D[0]=R,y[0]=b,se>=c[G]&&1447>0&&W<=1447+1?this.WALKTRACE(p,_,r,P,S,a,A,E,c,o,R,d,D,b,w,y,B,v):null}if(W<=1447){let G=new Int32Array(r-_+2);G[0]=p-_+1,m.Copy2(c,_,G,1,r-_+1),this.m_forwardHistory.push(G),G=new Int32Array(A-a+2),G[0]=S-a+1,m.Copy2(o,a,G,1,A-a+1),this.m_reverseHistory.push(G)}}return this.WALKTRACE(p,_,r,P,S,a,A,E,c,o,R,d,D,b,w,y,B,v)}PrettifyChanges(f){for(let d=0;d<f.length;d++){const e=f[d],w=d<f.length-1?f[d+1].originalStart:this._originalElementsOrHash.length,D=d<f.length-1?f[d+1].modifiedStart:this._modifiedElementsOrHash.length,y=e.originalLength>0,v=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<D&&(!y||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!v||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const R=[null];if(d<f.length-1&&this.ChangesOverlap(f[d],f[d+1],R)){f[d]=R[0],f.splice(d+1,1),d--;continue}}for(let d=f.length-1;d>=0;d--){const e=f[d];let w=0,D=0;if(d>0){const r=f[d-1];w=r.originalStart+r.originalLength,D=r.modifiedStart+r.modifiedLength}const y=e.originalLength>0,v=e.modifiedLength>0;let R=0,b=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const a=e.originalStart-r,A=e.modifiedStart-r;if(a<w||A<D||y&&!this.OriginalElementsAreEqual(a,a+e.originalLength)||v&&!this.ModifiedElementsAreEqual(A,A+e.modifiedLength))break;const L=(a===w&&A===D?5:0)+this._boundaryScore(a,e.originalLength,A,e.modifiedLength);L>b&&(b=L,R=r)}e.originalStart-=R,e.modifiedStart-=R;const _=[null];if(d>0&&this.ChangesOverlap(f[d-1],f[d],_)){f[d-1]=_[0],f.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,e=f.length;d<e;d++){const w=f[d-1],D=f[d],y=D.originalStart-w.originalStart-w.originalLength,v=w.originalStart,R=D.originalStart+D.originalLength,b=R-v,_=w.modifiedStart,r=D.modifiedStart+D.modifiedLength,a=r-_;if(y<5&&b<20&&a<20){const A=this._findBetterContiguousSequence(v,b,_,a,y);if(A){const[h,L]=A;(h!==w.originalStart+w.originalLength||L!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=h-w.originalStart,w.modifiedLength=L-w.modifiedStart,D.originalStart=h+y,D.modifiedStart=L+y,D.originalLength=R-D.originalStart,D.modifiedLength=r-D.modifiedStart)}}}return f}_findBetterContiguousSequence(f,d,e,w,D){if(d<D||w<D)return null;const y=f+d-D+1,v=e+w-D+1;let R=0,b=0,_=0;for(let r=f;r<y;r++)for(let a=e;a<v;a++){const A=this._contiguousSequenceScore(r,a,D);A>0&&A>R&&(R=A,b=r,_=a)}return R>0?[b,_]:null}_contiguousSequenceScore(f,d,e){let w=0;for(let D=0;D<e;D++){if(!this.ElementsAreEqual(f+D,d+D))return 0;w+=this._originalStringElements[f+D].length}return w}_OriginalIsBoundary(f){return f<=0||f>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[f])}_OriginalRegionIsBoundary(f,d){if(this._OriginalIsBoundary(f)||this._OriginalIsBoundary(f-1))return!0;if(d>0){const e=f+d;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(f){return f<=0||f>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[f])}_ModifiedRegionIsBoundary(f,d){if(this._ModifiedIsBoundary(f)||this._ModifiedIsBoundary(f-1))return!0;if(d>0){const e=f+d;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(f,d,e,w){const D=this._OriginalRegionIsBoundary(f,d)?1:0,y=this._ModifiedRegionIsBoundary(e,w)?1:0;return D+y}ConcatenateChanges(f,d){const e=[];if(f.length===0||d.length===0)return d.length>0?d:f;if(this.ChangesOverlap(f[f.length-1],d[0],e)){const w=new Array(f.length+d.length-1);return m.Copy(f,0,w,0,f.length-1),w[f.length-1]=e[0],m.Copy(d,1,w,f.length,d.length-1),w}else{const w=new Array(f.length+d.length);return m.Copy(f,0,w,0,f.length),m.Copy(d,0,w,f.length,d.length),w}}ChangesOverlap(f,d,e){if(N.Assert(f.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),N.Assert(f.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),f.originalStart+f.originalLength>=d.originalStart||f.modifiedStart+f.modifiedLength>=d.modifiedStart){const w=f.originalStart;let D=f.originalLength;const y=f.modifiedStart;let v=f.modifiedLength;return f.originalStart+f.originalLength>=d.originalStart&&(D=d.originalStart+d.originalLength-f.originalStart),f.modifiedStart+f.modifiedLength>=d.modifiedStart&&(v=d.modifiedStart+d.modifiedLength-f.modifiedStart),e[0]=new F.DiffChange(w,D,y,v),!0}else return e[0]=null,!1}ClipDiagonalBound(f,d,e,w){if(f>=0&&f<w)return f;const D=e,y=w-e-1,v=d%2===0;if(f<0){const R=D%2===0;return v===R?0:1}else{const R=y%2===0;return v===R?w-1:w-2}}}t.LcsDiff=g}),Z(K[14],ee([0,1,48,9]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,N=/^\/\//;function m(h,L){if(!h.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!i.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!u.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(h,L){return!h&&!L?"file":h}function l(h,L){switch(h){case"https":case"http":case"file":L?L[0]!==M&&(L=M+L):L=M;break}return L}const g="",M="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(L){return L instanceof d?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,c,o,p,S,P=!1){typeof L=="object"?(this.scheme=L.scheme||g,this.authority=L.authority||g,this.path=L.path||g,this.query=L.query||g,this.fragment=L.fragment||g):(this.scheme=s(L,P),this.authority=c||g,this.path=l(this.scheme,o||g),this.query=p||g,this.fragment=S||g,m(this,P))}get fsPath(){return b(this,!1)}with(L){if(!L)return this;let{scheme:c,authority:o,path:p,query:S,fragment:P}=L;return c===void 0?c=this.scheme:c===null&&(c=g),o===void 0?o=this.authority:o===null&&(o=g),p===void 0?p=this.path:p===null&&(p=g),S===void 0?S=this.query:S===null&&(S=g),P===void 0?P=this.fragment:P===null&&(P=g),c===this.scheme&&o===this.authority&&p===this.path&&S===this.query&&P===this.fragment?this:new D(c,o,p,S,P)}static parse(L,c=!1){const o=f.exec(L);return o?new D(o[2]||g,A(o[4]||g),A(o[5]||g),A(o[7]||g),A(o[9]||g),c):new D(g,g,g,g,g)}static file(L){let c=g;if(T.isWindows&&(L=L.replace(/\\/g,M)),L[0]===M&&L[1]===M){const o=L.indexOf(M,2);o===-1?(c=L.substring(2),L=M):(c=L.substring(2,o),L=L.substring(o)||M)}return new D("file",c,L,g,g)}static from(L,c){return new D(L.scheme,L.authority,L.path,L.query,L.fragment,c)}static joinPath(L,...c){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return T.isWindows&&L.scheme==="file"?o=d.file(F.win32.join(b(L,!0),...c)).path:o=F.posix.join(L.path,...c),L.with({path:o})}toString(L=!1){return _(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof d)return L;{const c=new D(L);return c._formatted=L.external??null,c._fsPath=L._sep===w?L.fsPath??null:null,c}}else return L}}t.URI=d;function e(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}t.isUriComponents=e;const w=T.isWindows?1:void 0;class D extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(L=!1){return L?_(this,!0):(this._formatted||(this._formatted=_(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=w),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(h,L,c){let o,p=-1;for(let S=0;S<h.length;S++){const P=h.charCodeAt(S);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||L&&P===47||c&&P===91||c&&P===93||c&&P===58)p!==-1&&(o+=encodeURIComponent(h.substring(p,S)),p=-1),o!==void 0&&(o+=h.charAt(S));else{o===void 0&&(o=h.substr(0,S));const E=y[P];E!==void 0?(p!==-1&&(o+=encodeURIComponent(h.substring(p,S)),p=-1),o+=E):p===-1&&(p=S)}}return p!==-1&&(o+=encodeURIComponent(h.substring(p))),o!==void 0?o:h}function R(h){let L;for(let c=0;c<h.length;c++){const o=h.charCodeAt(c);o===35||o===63?(L===void 0&&(L=h.substr(0,c)),L+=y[o]):L!==void 0&&(L+=h[c])}return L!==void 0?L:h}function b(h,L){let c;return h.authority&&h.path.length>1&&h.scheme==="file"?c=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?L?c=h.path.substr(1):c=h.path[1].toLowerCase()+h.path.substr(2):c=h.path,T.isWindows&&(c=c.replace(/\//g,"\\")),c}t.uriToFsPath=b;function _(h,L){const c=L?R:v;let o="",{scheme:p,authority:S,path:P,query:E,fragment:I}=h;if(p&&(o+=p,o+=":"),(S||p==="file")&&(o+=M,o+=M),S){let B=S.indexOf("@");if(B!==-1){const W=S.substr(0,B);S=S.substr(B+1),B=W.lastIndexOf(":"),B===-1?o+=c(W,!1,!1):(o+=c(W.substr(0,B),!1,!1),o+=":",o+=c(W.substr(B+1),!1,!0)),o+="@"}S=S.toLowerCase(),B=S.lastIndexOf(":"),B===-1?o+=c(S,!1,!0):(o+=c(S.substr(0,B),!1,!0),o+=S.substr(B))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const B=P.charCodeAt(1);B>=65&&B<=90&&(P=`/${String.fromCharCode(B+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const B=P.charCodeAt(0);B>=65&&B<=90&&(P=`${String.fromCharCode(B+32)}:${P.substr(2)}`)}o+=c(P,!0,!1)}return E&&(o+="?",o+=c(E,!1,!1)),I&&(o+="#",o+=L?I:v(I,!1,!1)),o}function r(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+r(h.substr(3)):h}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(h){return h.match(a)?h.replace(a,L=>r(L)):h}}),Z(K[61],ee([0,1,3,10,7,12,9,5]),function(V,t,F,T,i,u,N,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let l=!1;function g(A){N.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(A.message))}t.logOnceWebWorkerWarning=g;var M;(function(A){A[A.Request=0]="Request",A[A.Reply=1]="Reply",A[A.SubscribeEvent=2]="SubscribeEvent",A[A.Event=3]="Event",A[A.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class f{constructor(h,L,c,o){this.vsWorker=h,this.req=L,this.method=c,this.args=o,this.type=0}}class d{constructor(h,L,c,o){this.vsWorker=h,this.seq=L,this.res=c,this.err=o,this.type=1}}class e{constructor(h,L,c,o){this.vsWorker=h,this.req=L,this.eventName=c,this.arg=o,this.type=2}}class w{constructor(h,L,c){this.vsWorker=h,this.req=L,this.event=c,this.type=3}}class D{constructor(h,L){this.vsWorker=h,this.req=L,this.type=4}}class y{constructor(h){this._workerId=-1,this._handler=h,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(h){this._workerId=h}sendMessage(h,L){const c=String(++this._lastSentReq);return new Promise((o,p)=>{this._pendingReplies[c]={resolve:o,reject:p},this._send(new f(this._workerId,c,h,L))})}listen(h,L){let c=null;const o=new T.Emitter({onWillAddFirstListener:()=>{c=String(++this._lastSentReq),this._pendingEmitters.set(c,o),this._send(new e(this._workerId,c,h,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(c),this._send(new D(this._workerId,c)),c=null}});return o.event}handleMessage(h){!h||!h.vsWorker||this._workerId!==-1&&h.vsWorker!==this._workerId||this._handleMessage(h)}_handleMessage(h){switch(h.type){case 1:return this._handleReplyMessage(h);case 0:return this._handleRequestMessage(h);case 2:return this._handleSubscribeEventMessage(h);case 3:return this._handleEventMessage(h);case 4:return this._handleUnsubscribeEventMessage(h)}}_handleReplyMessage(h){if(!this._pendingReplies[h.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[h.seq];if(delete this._pendingReplies[h.seq],h.err){let c=h.err;h.err.$isError&&(c=new Error,c.name=h.err.name,c.message=h.err.message,c.stack=h.err.stack),L.reject(c);return}L.resolve(h.res)}_handleRequestMessage(h){const L=h.req;this._handler.handleMessage(h.method,h.args).then(o=>{this._send(new d(this._workerId,L,o,void 0))},o=>{o.detail instanceof Error&&(o.detail=(0,F.transformErrorForSerialization)(o.detail)),this._send(new d(this._workerId,L,void 0,(0,F.transformErrorForSerialization)(o)))})}_handleSubscribeEventMessage(h){const L=h.req,c=this._handler.handleEvent(h.eventName,h.arg)(o=>{this._send(new w(this._workerId,L,o))});this._pendingEvents.set(L,c)}_handleEventMessage(h){if(!this._pendingEmitters.has(h.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(h.req).fire(h.event)}_handleUnsubscribeEventMessage(h){if(!this._pendingEvents.has(h.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(h.req).dispose(),this._pendingEvents.delete(h.req)}_send(h){const L=[];if(h.type===0)for(let c=0;c<h.args.length;c++)h.args[c]instanceof ArrayBuffer&&L.push(h.args[c]);else h.type===1&&h.res instanceof ArrayBuffer&&L.push(h.res);this._handler.sendMessage(h,L)}}class v extends i.Disposable{constructor(h,L,c){super();let o=null;this._worker=this._register(h.create("vs/base/common/worker/simpleWorker",B=>{this._protocol.handleMessage(B)},B=>{o?.(B)})),this._protocol=new y({sendMessage:(B,W)=>{this._worker.postMessage(B,W)},handleMessage:(B,W)=>{if(typeof c[B]!="function")return Promise.reject(new Error("Missing method "+B+" on main thread host."));try{return Promise.resolve(c[B].apply(c,W))}catch(j){return Promise.reject(j)}},handleEvent:(B,W)=>{if(b(B)){const j=c[B].call(c,W);if(typeof j!="function")throw new Error(`Missing dynamic event ${B} on main thread host.`);return j}if(R(B)){const j=c[B];if(typeof j!="function")throw new Error(`Missing event ${B} on main thread host.`);return j}throw new Error(`Malformed event name ${B}`)}}),this._protocol.setWorkerId(this._worker.getId());let p=null;const S=globalThis.require;typeof S<"u"&&typeof S.getConfig=="function"?p=S.getConfig():typeof globalThis.requirejs<"u"&&(p=globalThis.requirejs.s.contexts._.config);const P=(0,u.getAllMethodNames)(c);this._onModuleLoaded=this._protocol.sendMessage(s,[this._worker.getId(),JSON.parse(JSON.stringify(p)),L,P]);const E=(B,W)=>this._request(B,W),I=(B,W)=>this._protocol.listen(B,W);this._lazyProxy=new Promise((B,W)=>{o=W,this._onModuleLoaded.then(j=>{B(_(j,E,I))},j=>{W(j),this._onError("Worker failed to load "+L,j)})})}getProxyObject(){return this._lazyProxy}_request(h,L){return new Promise((c,o)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(h,L).then(c,o)},o)})}_onError(h,L){console.error(h),console.info(L)}}t.SimpleWorkerClient=v;function R(A){return A[0]==="o"&&A[1]==="n"&&m.isUpperAsciiLetter(A.charCodeAt(2))}function b(A){return/^onDynamic/.test(A)&&m.isUpperAsciiLetter(A.charCodeAt(9))}function _(A,h,L){const c=S=>function(){const P=Array.prototype.slice.call(arguments,0);return h(S,P)},o=S=>function(P){return L(S,P)},p={};for(const S of A){if(b(S)){p[S]=o(S);continue}if(R(S)){p[S]=L(S,void 0);continue}p[S]=c(S)}return p}class r{constructor(h,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new y({sendMessage:(c,o)=>{h(c,o)},handleMessage:(c,o)=>this._handleMessage(c,o),handleEvent:(c,o)=>this._handleEvent(c,o)})}onmessage(h){this._protocol.handleMessage(h)}_handleMessage(h,L){if(h===s)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[h]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+h));try{return Promise.resolve(this._requestHandler[h].apply(this._requestHandler,L))}catch(c){return Promise.reject(c)}}_handleEvent(h,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(b(h)){const c=this._requestHandler[h].call(this._requestHandler,L);if(typeof c!="function")throw new Error(`Missing dynamic event ${h} on request handler.`);return c}if(R(h)){const c=this._requestHandler[h];if(typeof c!="function")throw new Error(`Missing event ${h} on request handler.`);return c}throw new Error(`Malformed event name ${h}`)}initialize(h,L,c,o){this._protocol.setWorkerId(h);const P=_(o,(E,I)=>this._protocol.sendMessage(E,I),(E,I)=>this._protocol.listen(E,I));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((E,I)=>{(globalThis.require||V)([c],W=>{if(this._requestHandler=W.create(P),!this._requestHandler){I(new Error("No RequestHandler!"));return}E((0,u.getAllMethodNames)(this._requestHandler))},I)}))}}t.SimpleWorkerServer=r;function a(A){return new r(A,null)}t.create=a}),Z(K[26],ee([0,1,25,22,5,2,11,13]),function(V,t,F,T,i,u,N,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const s=3;class l{computeDiff(_,r,a){const h=new D(_,r,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),L=[];let c=null;for(const o of h.changes){let p;o.originalEndLineNumber===0?p=new m.LineRange(o.originalStartLineNumber+1,o.originalStartLineNumber+1):p=new m.LineRange(o.originalStartLineNumber,o.originalEndLineNumber+1);let S;o.modifiedEndLineNumber===0?S=new m.LineRange(o.modifiedStartLineNumber+1,o.modifiedStartLineNumber+1):S=new m.LineRange(o.modifiedStartLineNumber,o.modifiedEndLineNumber+1);let P=new T.LineRangeMapping(p,S,o.charChanges?.map(E=>new T.RangeMapping(new u.Range(E.originalStartLineNumber,E.originalStartColumn,E.originalEndLineNumber,E.originalEndColumn),new u.Range(E.modifiedStartLineNumber,E.modifiedStartColumn,E.modifiedEndLineNumber,E.modifiedEndColumn))));c&&(c.modifiedRange.endLineNumberExclusive===P.modifiedRange.startLineNumber||c.originalRange.endLineNumberExclusive===P.originalRange.startLineNumber)&&(P=new T.LineRangeMapping(c.originalRange.join(P.originalRange),c.modifiedRange.join(P.modifiedRange),c.innerChanges&&P.innerChanges?c.innerChanges.concat(P.innerChanges):void 0),L.pop()),L.push(P),c=P}return(0,N.assertFn)(()=>(0,N.checkAdjacentItems)(L,(o,p)=>p.originalRange.startLineNumber-o.originalRange.endLineNumberExclusive===p.modifiedRange.startLineNumber-o.modifiedRange.endLineNumberExclusive&&o.originalRange.endLineNumberExclusive<p.originalRange.startLineNumber&&o.modifiedRange.endLineNumberExclusive<p.modifiedRange.startLineNumber)),new T.LinesDiff(L,h.quitEarly)}}t.SmartLinesDiffComputer=l;function g(b,_,r,a){return new F.LcsDiff(b,_,r).ComputeDiff(a)}class M{constructor(_){const r=[],a=[];for(let A=0,h=_.length;A<h;A++)r[A]=y(_[A],1),a[A]=v(_[A],1);this.lines=_,this._startColumns=r,this._endColumns=a}getElements(){const _=[];for(let r=0,a=this.lines.length;r<a;r++)_[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return _}getStrictElement(_){return this.lines[_]}getStartLineNumber(_){return _+1}getEndLineNumber(_){return _+1}createCharSequence(_,r,a){const A=[],h=[],L=[];let c=0;for(let o=r;o<=a;o++){const p=this.lines[o],S=_?this._startColumns[o]:1,P=_?this._endColumns[o]:p.length+1;for(let E=S;E<P;E++)A[c]=p.charCodeAt(E-1),h[c]=o+1,L[c]=E,c++;!_&&o<a&&(A[c]=10,h[c]=o+1,L[c]=p.length+1,c++)}return new f(A,h,L)}}class f{constructor(_,r,a){this._charCodes=_,this._lineNumbers=r,this._columns=a}toString(){return"["+this._charCodes.map((_,r)=>(_===10?"\\n":String.fromCharCode(_))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(_,r){if(_<0||_>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(_){return _>0&&_===this._lineNumbers.length?this.getEndLineNumber(_-1):(this._assertIndex(_,this._lineNumbers),this._lineNumbers[_])}getEndLineNumber(_){return _===-1?this.getStartLineNumber(_+1):(this._assertIndex(_,this._lineNumbers),this._charCodes[_]===10?this._lineNumbers[_]+1:this._lineNumbers[_])}getStartColumn(_){return _>0&&_===this._columns.length?this.getEndColumn(_-1):(this._assertIndex(_,this._columns),this._columns[_])}getEndColumn(_){return _===-1?this.getStartColumn(_+1):(this._assertIndex(_,this._columns),this._charCodes[_]===10?1:this._columns[_]+1)}}class d{constructor(_,r,a,A,h,L,c,o){this.originalStartLineNumber=_,this.originalStartColumn=r,this.originalEndLineNumber=a,this.originalEndColumn=A,this.modifiedStartLineNumber=h,this.modifiedStartColumn=L,this.modifiedEndLineNumber=c,this.modifiedEndColumn=o}static createFromDiffChange(_,r,a){const A=r.getStartLineNumber(_.originalStart),h=r.getStartColumn(_.originalStart),L=r.getEndLineNumber(_.originalStart+_.originalLength-1),c=r.getEndColumn(_.originalStart+_.originalLength-1),o=a.getStartLineNumber(_.modifiedStart),p=a.getStartColumn(_.modifiedStart),S=a.getEndLineNumber(_.modifiedStart+_.modifiedLength-1),P=a.getEndColumn(_.modifiedStart+_.modifiedLength-1);return new d(A,h,L,c,o,p,S,P)}}function e(b){if(b.length<=1)return b;const _=[b[0]];let r=_[0];for(let a=1,A=b.length;a<A;a++){const h=b[a],L=h.originalStart-(r.originalStart+r.originalLength),c=h.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(L,c)<s?(r.originalLength=h.originalStart+h.originalLength-r.originalStart,r.modifiedLength=h.modifiedStart+h.modifiedLength-r.modifiedStart):(_.push(h),r=h)}return _}class w{constructor(_,r,a,A,h){this.originalStartLineNumber=_,this.originalEndLineNumber=r,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=A,this.charChanges=h}static createFromDiffResult(_,r,a,A,h,L,c){let o,p,S,P,E;if(r.originalLength===0?(o=a.getStartLineNumber(r.originalStart)-1,p=0):(o=a.getStartLineNumber(r.originalStart),p=a.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(S=A.getStartLineNumber(r.modifiedStart)-1,P=0):(S=A.getStartLineNumber(r.modifiedStart),P=A.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),L&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&h()){const I=a.createCharSequence(_,r.originalStart,r.originalStart+r.originalLength-1),B=A.createCharSequence(_,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(I.getElements().length>0&&B.getElements().length>0){let W=g(I,B,h,!0).changes;c&&(W=e(W)),E=[];for(let j=0,J=W.length;j<J;j++)E.push(d.createFromDiffChange(W[j],I,B))}}return new w(o,p,S,P,E)}}class D{constructor(_,r,a){this.shouldComputeCharChanges=a.shouldComputeCharChanges,this.shouldPostProcessCharChanges=a.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=a.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=a.shouldMakePrettyDiff,this.originalLines=_,this.modifiedLines=r,this.original=new M(_),this.modified=new M(r),this.continueLineDiff=R(a.maxComputationTime),this.continueCharDiff=R(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const _=g(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=_.changes,a=_.quitEarly;if(this.shouldIgnoreTrimWhitespace){const c=[];for(let o=0,p=r.length;o<p;o++)c.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[o],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:a,changes:c}}const A=[];let h=0,L=0;for(let c=-1,o=r.length;c<o;c++){const p=c+1<o?r[c+1]:null,S=p?p.originalStart:this.originalLines.length,P=p?p.modifiedStart:this.modifiedLines.length;for(;h<S&&L<P;){const E=this.originalLines[h],I=this.modifiedLines[L];if(E!==I){{let B=y(E,1),W=y(I,1);for(;B>1&&W>1;){const j=E.charCodeAt(B-2),J=I.charCodeAt(W-2);if(j!==J)break;B--,W--}(B>1||W>1)&&this._pushTrimWhitespaceCharChange(A,h+1,1,B,L+1,1,W)}{let B=v(E,1),W=v(I,1);const j=E.length+1,J=I.length+1;for(;B<j&&W<J;){const X=E.charCodeAt(B-1),G=E.charCodeAt(W-1);if(X!==G)break;B++,W++}(B<j||W<J)&&this._pushTrimWhitespaceCharChange(A,h+1,B,j,L+1,W,J)}}h++,L++}p&&(A.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,p,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),h+=p.originalLength,L+=p.modifiedLength)}return{quitEarly:a,changes:A}}_pushTrimWhitespaceCharChange(_,r,a,A,h,L,c){if(this._mergeTrimWhitespaceCharChange(_,r,a,A,h,L,c))return;let o;this.shouldComputeCharChanges&&(o=[new d(r,a,r,A,h,L,h,c)]),_.push(new w(r,r,h,h,o))}_mergeTrimWhitespaceCharChange(_,r,a,A,h,L,c){const o=_.length;if(o===0)return!1;const p=_[o-1];return p.originalEndLineNumber===0||p.modifiedEndLineNumber===0?!1:p.originalEndLineNumber===r&&p.modifiedEndLineNumber===h?(this.shouldComputeCharChanges&&p.charChanges&&p.charChanges.push(new d(r,a,r,A,h,L,h,c)),!0):p.originalEndLineNumber+1===r&&p.modifiedEndLineNumber+1===h?(p.originalEndLineNumber=r,p.modifiedEndLineNumber=h,this.shouldComputeCharChanges&&p.charChanges&&p.charChanges.push(new d(r,a,r,A,h,L,h,c)),!0):!1}}t.DiffComputer=D;function y(b,_){const r=i.firstNonWhitespaceIndex(b);return r===-1?_:r+1}function v(b,_){const r=i.lastNonWhitespaceIndex(b);return r===-1?_:r+2}function R(b){if(b===0)return()=>!0;const _=Date.now();return()=>Date.now()-_<b}}),Z(K[51],ee([0,1,26,39]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={legacy:new F.SmartLinesDiffComputer,advanced:new T.StandardLinesDiffComputer}}),Z(K[52],ee([0,1,5,4,44]),function(V,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(m,s,l,g){this._uri=m,this._lines=s,this._eol=l,this._versionId=g,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(m){m.eol&&m.eol!==this._eol&&(this._eol=m.eol,this._lineStarts=null);const s=m.changes;for(const l of s)this._acceptDeleteRange(l.range),this._acceptInsertText(new T.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=m.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const m=this._eol.length,s=this._lines.length,l=new Uint32Array(s);for(let g=0;g<s;g++)l[g]=this._lines[g].length+m;this._lineStarts=new i.PrefixSumComputer(l)}}_setLineText(m,s){this._lines[m]=s,this._lineStarts&&this._lineStarts.setValue(m,this._lines[m].length+this._eol.length)}_acceptDeleteRange(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.startLineNumber-1].substring(m.endColumn-1));return}this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.endLineNumber-1].substring(m.endColumn-1)),this._lines.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}_acceptInsertText(m,s){if(s.length===0)return;const l=(0,F.splitLines)(s);if(l.length===1){this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+l[0]+this._lines[m.lineNumber-1].substring(m.column-1));return}l[l.length-1]+=this._lines[m.lineNumber-1].substring(m.column-1),this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+l[0]);const g=new Uint32Array(l.length-1);for(let M=1;M<l.length;M++)this._lines.splice(m.lineNumber+M-1,0,l[M]),g[M-1]=l[M].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(m.lineNumber,g)}}t.MirrorTextModel=u}),Z(K[53],ee([0,1,5,34,4,2,43]),function(V,t,F,T,i,u,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const m=999;class s{constructor(v,R,b,_){this.searchString=v,this.isRegex=R,this.matchCase=b,this.wordSeparators=_}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=l(this.searchString):v=this.searchString.indexOf(`
`)>=0;let R=null;try{R=F.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!R)return null;let b=!this.isRegex&&!v;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new N.SearchData(R,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}t.SearchParams=s;function l(y){if(!y||y.length===0)return!1;for(let v=0,R=y.length;v<R;v++){const b=y.charCodeAt(v);if(b===10)return!0;if(b===92){if(v++,v>=R)break;const _=y.charCodeAt(v);if(_===110||_===114||_===87)return!0}}return!1}t.isMultilineRegexSource=l;function g(y,v,R){if(!R)return new N.FindMatch(y,null);const b=[];for(let _=0,r=v.length;_<r;_++)b[_]=v[_];return new N.FindMatch(y,b)}t.createFindMatch=g;class M{constructor(v){const R=[];let b=0;for(let _=0,r=v.length;_<r;_++)v.charCodeAt(_)===10&&(R[b++]=_);this._lineFeedsOffsets=R}findLineFeedCountBeforeOffset(v){const R=this._lineFeedsOffsets;let b=0,_=R.length-1;if(_===-1||v<=R[0])return 0;for(;b<_;){const r=b+((_-b)/2>>0);R[r]>=v?_=r-1:R[r+1]>=v?(b=r,_=r):b=r+1}return b+1}}class f{static findMatches(v,R,b,_,r){const a=R.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(v,b,new D(a.wordSeparators,a.regex),_,r):this._doFindMatchesLineByLine(v,b,a,_,r):[]}static _getMultilineMatchRange(v,R,b,_,r,a){let A,h=0;_?(h=_.findLineFeedCountBeforeOffset(r),A=R+r+h):A=R+r;let L;if(_){const S=_.findLineFeedCountBeforeOffset(r+a.length)-h;L=A+a.length+S}else L=A+a.length;const c=v.getPositionAt(A),o=v.getPositionAt(L);return new u.Range(c.lineNumber,c.column,o.lineNumber,o.column)}static _doFindMatchesMultiline(v,R,b,_,r){const a=v.getOffsetAt(R.getStartPosition()),A=v.getValueInRange(R,1),h=v.getEOL()===`\r
`?new M(A):null,L=[];let c=0,o;for(b.reset(0);o=b.next(A);)if(L[c++]=g(this._getMultilineMatchRange(v,a,A,h,o.index,o[0]),o,_),c>=r)return L;return L}static _doFindMatchesLineByLine(v,R,b,_,r){const a=[];let A=0;if(R.startLineNumber===R.endLineNumber){const L=v.getLineContent(R.startLineNumber).substring(R.startColumn-1,R.endColumn-1);return A=this._findMatchesInLine(b,L,R.startLineNumber,R.startColumn-1,A,a,_,r),a}const h=v.getLineContent(R.startLineNumber).substring(R.startColumn-1);A=this._findMatchesInLine(b,h,R.startLineNumber,R.startColumn-1,A,a,_,r);for(let L=R.startLineNumber+1;L<R.endLineNumber&&A<r;L++)A=this._findMatchesInLine(b,v.getLineContent(L),L,0,A,a,_,r);if(A<r){const L=v.getLineContent(R.endLineNumber).substring(0,R.endColumn-1);A=this._findMatchesInLine(b,L,R.endLineNumber,0,A,a,_,r)}return a}static _findMatchesInLine(v,R,b,_,r,a,A,h){const L=v.wordSeparators;if(!A&&v.simpleSearch){const p=v.simpleSearch,S=p.length,P=R.length;let E=-S;for(;(E=R.indexOf(p,E+S))!==-1;)if((!L||w(L,R,P,E,S))&&(a[r++]=new N.FindMatch(new u.Range(b,E+1+_,b,E+1+S+_),null),r>=h))return r;return r}const c=new D(v.wordSeparators,v.regex);let o;c.reset(0);do if(o=c.next(R),o&&(a[r++]=g(new u.Range(b,o.index+1+_,b,o.index+1+o[0].length+_),o,A),r>=h))return r;while(o);return r}static findNextMatch(v,R,b,_){const r=R.parseSearchRequest();if(!r)return null;const a=new D(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(v,b,a,_):this._doFindNextMatchLineByLine(v,b,a,_)}static _doFindNextMatchMultiline(v,R,b,_){const r=new i.Position(R.lineNumber,1),a=v.getOffsetAt(r),A=v.getLineCount(),h=v.getValueInRange(new u.Range(r.lineNumber,r.column,A,v.getLineMaxColumn(A)),1),L=v.getEOL()===`\r
`?new M(h):null;b.reset(R.column-1);const c=b.next(h);return c?g(this._getMultilineMatchRange(v,a,h,L,c.index,c[0]),c,_):R.lineNumber!==1||R.column!==1?this._doFindNextMatchMultiline(v,new i.Position(1,1),b,_):null}static _doFindNextMatchLineByLine(v,R,b,_){const r=v.getLineCount(),a=R.lineNumber,A=v.getLineContent(a),h=this._findFirstMatchInLine(b,A,a,R.column,_);if(h)return h;for(let L=1;L<=r;L++){const c=(a+L-1)%r,o=v.getLineContent(c+1),p=this._findFirstMatchInLine(b,o,c+1,1,_);if(p)return p}return null}static _findFirstMatchInLine(v,R,b,_,r){v.reset(_-1);const a=v.next(R);return a?g(new u.Range(b,a.index+1,b,a.index+1+a[0].length),a,r):null}static findPreviousMatch(v,R,b,_){const r=R.parseSearchRequest();if(!r)return null;const a=new D(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(v,b,a,_):this._doFindPreviousMatchLineByLine(v,b,a,_)}static _doFindPreviousMatchMultiline(v,R,b,_){const r=this._doFindMatchesMultiline(v,new u.Range(1,1,R.lineNumber,R.column),b,_,10*m);if(r.length>0)return r[r.length-1];const a=v.getLineCount();return R.lineNumber!==a||R.column!==v.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(v,new i.Position(a,v.getLineMaxColumn(a)),b,_):null}static _doFindPreviousMatchLineByLine(v,R,b,_){const r=v.getLineCount(),a=R.lineNumber,A=v.getLineContent(a).substring(0,R.column-1),h=this._findLastMatchInLine(b,A,a,_);if(h)return h;for(let L=1;L<=r;L++){const c=(r+a-L-1)%r,o=v.getLineContent(c+1),p=this._findLastMatchInLine(b,o,c+1,_);if(p)return p}return null}static _findLastMatchInLine(v,R,b,_){let r=null,a;for(v.reset(0);a=v.next(R);)r=g(new u.Range(b,a.index+1,b,a.index+1+a[0].length),a,_);return r}}t.TextModelSearch=f;function d(y,v,R,b,_){if(b===0)return!0;const r=v.charCodeAt(b-1);if(y.get(r)!==0||r===13||r===10)return!0;if(_>0){const a=v.charCodeAt(b);if(y.get(a)!==0)return!0}return!1}function e(y,v,R,b,_){if(b+_===R)return!0;const r=v.charCodeAt(b+_);if(y.get(r)!==0||r===13||r===10)return!0;if(_>0){const a=v.charCodeAt(b+_-1);if(y.get(a)!==0)return!0}return!1}function w(y,v,R,b,_){return d(y,v,R,b,_)&&e(y,v,R,b,_)}t.isValidMatch=w;class D{constructor(v,R){this._wordSeparators=v,this._searchRegex=R,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const R=v.length;let b;do{if(this._prevMatchStartIndex+this._prevMatchLength===R||(b=this._searchRegex.exec(v),!b))return null;const _=b.index,r=b[0].length;if(_===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){F.getNextCodePoint(v,R,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=_,this._prevMatchLength=r,!this._wordSeparators||w(this._wordSeparators,v,R,_,r))return b}while(b);return null}}t.Searcher=D}),Z(K[54],ee([0,1,2,53,5,11,21]),function(V,t,F,T,i,u,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class m{static computeUnicodeHighlights(e,w,D){const y=D?D.startLineNumber:1,v=D?D.endLineNumber:e.getLineCount(),R=new g(w),b=R.getCandidateCodePoints();let _;b==="allNonBasicAscii"?_=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):_=new RegExp(`${s(Array.from(b))}`,"g");const r=new T.Searcher(null,_),a=[];let A=!1,h,L=0,c=0,o=0;e:for(let p=y,S=v;p<=S;p++){const P=e.getLineContent(p),E=P.length;r.reset(0);do if(h=r.next(P),h){let I=h.index,B=h.index+h[0].length;if(I>0){const X=P.charCodeAt(I-1);i.isHighSurrogate(X)&&I--}if(B+1<E){const X=P.charCodeAt(B-1);i.isHighSurrogate(X)&&B++}const W=P.substring(I,B);let j=(0,N.getWordAtText)(I+1,N.DEFAULT_WORD_REGEXP,P,0);j&&j.endColumn<=I+1&&(j=null);const J=R.shouldHighlightNonBasicASCII(W,j?j.word:null);if(J!==0){J===3?L++:J===2?c++:J===1?o++:(0,u.assertNever)(J);const X=1e3;if(a.length>=X){A=!0;break e}a.push(new F.Range(p,I+1,p,B+1))}}while(h)}return{ranges:a,hasMore:A,ambiguousCharacterCount:L,invisibleCharacterCount:c,nonBasicAsciiCharacterCount:o}}static computeUnicodeHighlightReason(e,w){const D=new g(w);switch(D.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const v=e.codePointAt(0),R=D.ambiguousCharacters.getPrimaryConfusable(v),b=i.AmbiguousCharacters.getLocales().filter(_=>!i.AmbiguousCharacters.getInstance(new Set([...w.allowedLocales,_])).isAmbiguous(v));return{kind:0,confusableWith:String.fromCodePoint(R),notAmbiguousInLocales:b}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=m;function s(d,e){return`[${i.escapeRegExpCharacters(d.map(D=>String.fromCodePoint(D)).join(""))}]`}var l;(function(d){d[d.Ambiguous=0]="Ambiguous",d[d.Invisible=1]="Invisible",d[d.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class g{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const w of i.InvisibleCharacters.codePoints)M(String.fromCodePoint(w))||e.add(w);if(this.options.ambiguousCharacters)for(const w of this.ambiguousCharacters.getConfusableCodePoints())e.add(w);for(const w of this.allowedCodePoints)e.delete(w);return e}shouldHighlightNonBasicASCII(e,w){const D=e.codePointAt(0);if(this.allowedCodePoints.has(D))return 0;if(this.options.nonBasicASCII)return 1;let y=!1,v=!1;if(w)for(const R of w){const b=R.codePointAt(0),_=i.isBasicASCII(R);y=y||_,!_&&!this.ambiguousCharacters.isAmbiguous(b)&&!i.InvisibleCharacters.isInvisibleCharacter(b)&&(v=!0)}return!y&&v?0:this.options.invisibleCharacters&&!M(e)&&i.InvisibleCharacters.isInvisibleCharacter(D)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(D)?3:0}}function M(d){return d===" "||d===`
`||d==="	"}var f;(function(d){d[d.None=0]="None",d[d.NonBasicASCII=1]="NonBasicASCII",d[d.Invisible=2]="Invisible",d[d.Ambiguous=3]="Ambiguous"})(f||(f={}))}),Z(K[55],ee([0,1,10,7]),function(V,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(m){this._onDidChange.fire({changedLanguages:m,changedColorMap:!1})}register(m,s){return this._tokenizationSupports.set(m,s),this.handleChange([m]),(0,T.toDisposable)(()=>{this._tokenizationSupports.get(m)===s&&(this._tokenizationSupports.delete(m),this.handleChange([m]))})}get(m){return this._tokenizationSupports.get(m)||null}registerFactory(m,s){this._factories.get(m)?.dispose();const l=new u(this,m,s);return this._factories.set(m,l),(0,T.toDisposable)(()=>{const g=this._factories.get(m);!g||g!==l||(this._factories.delete(m),g.dispose())})}async getOrCreate(m){const s=this.get(m);if(s)return s;const l=this._factories.get(m);return!l||l.isResolved?null:(await l.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const l=this._factories.get(m);return!!(!l||l.isResolved)}setColorMap(m){this._colorMap=m,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=i;class u extends T.Disposable{get isResolved(){return this._isResolved}constructor(m,s,l){super(),this._registry=m,this._languageId=s,this._factory=l,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const m=await this._factory.tokenizationSupport;this._isResolved=!0,m&&!this._isDisposed&&this._register(this._registry.register(this._languageId,m))}}}),Z(K[56],ee([0,1,32,14,2,55]),function(V,t,F,T,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class N{constructor(I,B,W){this.offset=I,this.type=B,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=N;class m{constructor(I,B){this.tokens=I,this.endState=B,this._tokenizationResultBrand=void 0}}t.TokenizationResult=m;class s{constructor(I,B){this.tokens=I,this.endState=B,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=s;var l;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(l||(t.CompletionItemKind=l={}));var g;(function(E){const I=new Map;I.set(0,F.Codicon.symbolMethod),I.set(1,F.Codicon.symbolFunction),I.set(2,F.Codicon.symbolConstructor),I.set(3,F.Codicon.symbolField),I.set(4,F.Codicon.symbolVariable),I.set(5,F.Codicon.symbolClass),I.set(6,F.Codicon.symbolStruct),I.set(7,F.Codicon.symbolInterface),I.set(8,F.Codicon.symbolModule),I.set(9,F.Codicon.symbolProperty),I.set(10,F.Codicon.symbolEvent),I.set(11,F.Codicon.symbolOperator),I.set(12,F.Codicon.symbolUnit),I.set(13,F.Codicon.symbolValue),I.set(15,F.Codicon.symbolEnum),I.set(14,F.Codicon.symbolConstant),I.set(15,F.Codicon.symbolEnum),I.set(16,F.Codicon.symbolEnumMember),I.set(17,F.Codicon.symbolKeyword),I.set(27,F.Codicon.symbolSnippet),I.set(18,F.Codicon.symbolText),I.set(19,F.Codicon.symbolColor),I.set(20,F.Codicon.symbolFile),I.set(21,F.Codicon.symbolReference),I.set(22,F.Codicon.symbolCustomColor),I.set(23,F.Codicon.symbolFolder),I.set(24,F.Codicon.symbolTypeParameter),I.set(25,F.Codicon.account),I.set(26,F.Codicon.issues);function B(J){let X=I.get(J);return X||(console.info("No codicon found for CompletionItemKind "+J),X=F.Codicon.symbolProperty),X}E.toIcon=B;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function j(J,X){let G=W.get(J);return typeof G>"u"&&!X&&(G=9),G}E.fromString=j})(g||(t.CompletionItemKinds=g={}));var M;(function(E){E[E.Deprecated=1]="Deprecated"})(M||(t.CompletionItemTag=M={}));var f;(function(E){E[E.None=0]="None",E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(f||(t.CompletionItemInsertTextRule=f={}));var d;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var e;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(e||(t.InlineCompletionTriggerKind=e={}));class w{constructor(I,B,W,j){this.range=I,this.text=B,this.completionKind=W,this.isSnippetText=j}equals(I){return i.Range.lift(this.range).equalsRange(I.range)&&this.text===I.text&&this.completionKind===I.completionKind&&this.isSnippetText===I.isSnippetText}}t.SelectedSuggestionInfo=w;var D;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var y;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(y||(t.SignatureHelpTriggerKind=y={}));var v;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(v||(t.DocumentHighlightKind=v={}));function R(E){return E&&T.URI.isUri(E.uri)&&i.Range.isIRange(E.range)&&(i.Range.isIRange(E.originSelectionRange)||i.Range.isIRange(E.targetSelectionRange))}t.isLocationLink=R;var b;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(b||(t.SymbolKind=b={}));var _;(function(E){E[E.Deprecated=1]="Deprecated"})(_||(t.SymbolTag=_={}));var r;(function(E){const I=new Map;I.set(0,F.Codicon.symbolFile),I.set(1,F.Codicon.symbolModule),I.set(2,F.Codicon.symbolNamespace),I.set(3,F.Codicon.symbolPackage),I.set(4,F.Codicon.symbolClass),I.set(5,F.Codicon.symbolMethod),I.set(6,F.Codicon.symbolProperty),I.set(7,F.Codicon.symbolField),I.set(8,F.Codicon.symbolConstructor),I.set(9,F.Codicon.symbolEnum),I.set(10,F.Codicon.symbolInterface),I.set(11,F.Codicon.symbolFunction),I.set(12,F.Codicon.symbolVariable),I.set(13,F.Codicon.symbolConstant),I.set(14,F.Codicon.symbolString),I.set(15,F.Codicon.symbolNumber),I.set(16,F.Codicon.symbolBoolean),I.set(17,F.Codicon.symbolArray),I.set(18,F.Codicon.symbolObject),I.set(19,F.Codicon.symbolKey),I.set(20,F.Codicon.symbolNull),I.set(21,F.Codicon.symbolEnumMember),I.set(22,F.Codicon.symbolStruct),I.set(23,F.Codicon.symbolEvent),I.set(24,F.Codicon.symbolOperator),I.set(25,F.Codicon.symbolTypeParameter);function B(W){let j=I.get(W);return j||(console.info("No codicon found for SymbolKind "+W),j=F.Codicon.symbolProperty),j}E.toIcon=B})(r||(t.SymbolKinds=r={}));class a{static fromValue(I){switch(I){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(I)}constructor(I){this.value=I}}t.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var A;(function(E){function I(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}E.is=I})(A||(t.Command=A={}));var h;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(h||(t.CommentThreadCollapsibleState=h={}));var L;(function(E){E[E.Unresolved=0]="Unresolved",E[E.Resolved=1]="Resolved"})(L||(t.CommentThreadState=L={}));var c;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(c||(t.CommentMode=c={}));var o;(function(E){E[E.Published=0]="Published",E[E.Draft=1]="Draft"})(o||(t.CommentState=o={}));var p;(function(E){E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(p||(t.InlayHintKind=p={}));class S{constructor(I){this.createSupport=I,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(I=>{I&&I.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=S,t.TokenizationRegistry=new u.TokenizationRegistry;var P;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(P||(t.ExternalUriOpenerPriority=P={}))}),Z(K[57],ee([0,1,24,10,30,14,4,2,33,56,45]),function(V,t,F,T,i,u,N,m,s,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class M{static chord(e,w){return(0,i.KeyChord)(e,w)}}t.KeyMod=M,M.CtrlCmd=2048,M.Shift=1024,M.Alt=512,M.WinCtrl=256;function f(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.CancellationTokenSource,Emitter:T.Emitter,KeyCode:g.KeyCode,KeyMod:M,Position:N.Position,Range:m.Range,Selection:s.Selection,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:u.URI,Token:l.Token}}t.createMonacoBaseAPI=f}),Z(K[62],ee([0,1,25,14,4,2,52,21,41,42,57,23,54,26,51,12,3,40]),function(V,t,F,T,i,u,N,m,s,l,g,M,f,d,e,w,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class v extends N.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(r){const a=[];for(let A=0;A<this._lines.length;A++){const h=this._lines[A],L=this.offsetAt(new i.Position(A+1,1)),c=h.matchAll(r);for(const o of c)(o.index||o.index===0)&&(o.index=o.index+L),a.push(o)}return a}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(r){return this._lines[r-1]}getWordAtPosition(r,a){const A=(0,m.getWordAtText)(r.column,(0,m.ensureValidWordDefinition)(a),this._lines[r.lineNumber-1],0);return A?new u.Range(r.lineNumber,A.startColumn,r.lineNumber,A.endColumn):null}getWordUntilPosition(r,a){const A=this.getWordAtPosition(r,a);return A?{word:this._lines[r.lineNumber-1].substring(A.startColumn-1,r.column-1),startColumn:A.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const a=this._lines,A=this._wordenize.bind(this);let h=0,L="",c=0,o=[];return{*[Symbol.iterator](){for(;;)if(c<o.length){const p=L.substring(o[c].start,o[c].end);c+=1,yield p}else if(h<a.length)L=a[h],o=A(L,r),c=0,h+=1;else break}}}getLineWords(r,a){const A=this._lines[r-1],h=this._wordenize(A,a),L=[];for(const c of h)L.push({word:A.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return L}_wordenize(r,a){const A=[];let h;for(a.lastIndex=0;(h=a.exec(r))&&h[0].length!==0;)A.push({start:h.index,end:h.index+h[0].length});return A}getValueInRange(r){if(r=this._validateRange(r),r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const a=this._eol,A=r.startLineNumber-1,h=r.endLineNumber-1,L=[];L.push(this._lines[A].substring(r.startColumn-1));for(let c=A+1;c<h;c++)L.push(this._lines[c]);return L.push(this._lines[h].substring(0,r.endColumn-1)),L.join(a)}offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const a=this._lineStarts.getIndexOf(r),A=this._lines[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,A)}}_validateRange(r){const a=this._validatePosition({lineNumber:r.startLineNumber,column:r.startColumn}),A=this._validatePosition({lineNumber:r.endLineNumber,column:r.endColumn});return a.lineNumber!==r.startLineNumber||a.column!==r.startColumn||A.lineNumber!==r.endLineNumber||A.column!==r.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:A.lineNumber,endColumn:A.column}:r}_validatePosition(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:a,column:A}=r,h=!1;if(a<1)a=1,A=1,h=!0;else if(a>this._lines.length)a=this._lines.length,A=this._lines[a-1].length+1,h=!0;else{const L=this._lines[a-1].length+1;A<1?(A=1,h=!0):A>L&&(A=L,h=!0)}return h?{lineNumber:a,column:A}:r}}class R{constructor(r,a){this._host=r,this._models=Object.create(null),this._foreignModuleFactory=a,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(r){return this._models[r]}_getModels(){const r=[];return Object.keys(this._models).forEach(a=>r.push(this._models[a])),r}acceptNewModel(r){this._models[r.url]=new v(T.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,a){if(!this._models[r])return;this._models[r].onEvents(a)}acceptRemovedModel(r){this._models[r]&&delete this._models[r]}async computeUnicodeHighlights(r,a,A){const h=this._getModel(r);return h?f.UnicodeTextModelHighlighter.computeUnicodeHighlights(h,a,A):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,a,A,h){const L=this._getModel(r),c=this._getModel(a);return!L||!c?null:R.computeDiff(L,c,A,h)}static computeDiff(r,a,A,h){const L=h==="advanced"?e.linesDiffComputers.advanced:e.linesDiffComputers.legacy,c=r.getLinesContent(),o=a.getLinesContent(),p=L.computeDiff(c,o,A);return{identical:p.changes.length>0?!1:this._modelsAreIdentical(r,a),quitEarly:p.hitTimeout,changes:p.changes.map(P=>[P.originalRange.startLineNumber,P.originalRange.endLineNumberExclusive,P.modifiedRange.startLineNumber,P.modifiedRange.endLineNumberExclusive,P.innerChanges?.map(E=>[E.originalRange.startLineNumber,E.originalRange.startColumn,E.originalRange.endLineNumber,E.originalRange.endColumn,E.modifiedRange.startLineNumber,E.modifiedRange.startColumn,E.modifiedRange.endLineNumber,E.modifiedRange.endColumn])])}}static _modelsAreIdentical(r,a){const A=r.getLineCount(),h=a.getLineCount();if(A!==h)return!1;for(let L=1;L<=A;L++){const c=r.getLineContent(L),o=a.getLineContent(L);if(c!==o)return!1}return!0}async computeDirtyDiff(r,a,A){const h=this._getModel(r),L=this._getModel(a);if(!h||!L)return null;const c=h.getLinesContent(),o=L.getLinesContent();return new d.DiffComputer(c,o,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:A,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,a,A){const h=this._getModel(r);if(!h)return a;const L=[];let c;a=a.slice(0).sort((o,p)=>{if(o.range&&p.range)return u.Range.compareRangesUsingStarts(o.range,p.range);const S=o.range?0:1,P=p.range?0:1;return S-P});for(let{range:o,text:p,eol:S}of a){if(typeof S=="number"&&(c=S),u.Range.isEmpty(o)&&!p)continue;const P=h.getValueInRange(o);if(p=p.replace(/\r\n|\n|\r/g,h.eol),P===p)continue;if(Math.max(p.length,P.length)>R._diffLimit){L.push({range:o,text:p});continue}const E=(0,F.stringDiff)(P,p,A),I=h.offsetAt(u.Range.lift(o).getStartPosition());for(const B of E){const W=h.positionAt(I+B.originalStart),j=h.positionAt(I+B.originalStart+B.originalLength),J={text:p.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:j.lineNumber,endColumn:j.column}};h.getValueInRange(J.range)!==J.text&&L.push(J)}}return typeof c=="number"&&L.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeHumanReadableDiff(r,a,A){const h=this._getModel(r);if(!h)return a;const L=[];let c;a=a.slice(0).sort((o,p)=>{if(o.range&&p.range)return u.Range.compareRangesUsingStarts(o.range,p.range);const S=o.range?0:1,P=p.range?0:1;return S-P});for(let{range:o,text:p,eol:S}of a){let j=function(X,G){return new i.Position(X.lineNumber+G.lineNumber-1,G.lineNumber===1?X.column+G.column-1:G.column)},J=function(X,G){const se=[];for(let n=G.startLineNumber;n<=G.endLineNumber;n++){const me=X[n-1];n===G.startLineNumber&&n===G.endLineNumber?se.push(me.substring(G.startColumn-1,G.endColumn-1)):n===G.startLineNumber?se.push(me.substring(G.startColumn-1)):n===G.endLineNumber?se.push(me.substring(0,G.endColumn-1)):se.push(me)}return se};if(typeof S=="number"&&(c=S),u.Range.isEmpty(o)&&!p)continue;const P=h.getValueInRange(o);if(p=p.replace(/\r\n|\n|\r/g,h.eol),P===p)continue;if(Math.max(p.length,P.length)>R._diffLimit){L.push({range:o,text:p});continue}const E=P.split(/\r\n|\n|\r/),I=p.split(/\r\n|\n|\r/),B=e.linesDiffComputers.advanced.computeDiff(E,I,A),W=u.Range.lift(o).getStartPosition();for(const X of B.changes)if(X.innerChanges)for(const G of X.innerChanges)L.push({range:u.Range.fromPositions(j(W,G.originalRange.getStartPosition()),j(W,G.originalRange.getEndPosition())),text:J(I,G.modifiedRange).join(h.eol)});else throw new D.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof c=="number"&&L.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(r){const a=this._getModel(r);return a?(0,s.computeLinks)(a):null}async computeDefaultDocumentColors(r){const a=this._getModel(r);return a?(0,y.computeDefaultDocumentColors)(a):null}async textualSuggest(r,a,A,h){const L=new M.StopWatch(!0),c=new RegExp(A,h),o=new Set;e:for(const p of r){const S=this._getModel(p);if(S){for(const P of S.words(c))if(!(P===a||!isNaN(Number(P)))&&(o.add(P),o.size>R._suggestionsLimit))break e}}return{words:Array.from(o),duration:L.elapsed()}}async computeWordRanges(r,a,A,h){const L=this._getModel(r);if(!L)return Object.create(null);const c=new RegExp(A,h),o=Object.create(null);for(let p=a.startLineNumber;p<a.endLineNumber;p++){const S=L.getLineWords(p,c);for(const P of S){if(!isNaN(Number(P.word)))continue;let E=o[P.word];E||(E=[],o[P.word]=E),E.push({startLineNumber:p,startColumn:P.startColumn,endLineNumber:p,endColumn:P.endColumn})}}return o}async navigateValueSet(r,a,A,h,L){const c=this._getModel(r);if(!c)return null;const o=new RegExp(h,L);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const p=c.getValueInRange(a),S=c.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},o);if(!S)return null;const P=c.getValueInRange(S);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(a,p,S,P,A)}loadForeignModule(r,a,A){const h=(o,p)=>this._host.fhr(o,p),c={host:(0,w.createProxyObject)(A,h),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(c,a),Promise.resolve((0,w.getAllMethodNames)(this._foreignModule))):new Promise((o,p)=>{V([r],S=>{this._foreignModule=S.create(c,a),o((0,w.getAllMethodNames)(this._foreignModule))},p)})}fmr(r,a){if(!this._foreignModule||typeof this._foreignModule[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this._foreignModule[r].apply(this._foreignModule,a))}catch(A){return Promise.reject(A)}}}t.EditorSimpleWorker=R,R._diffLimit=1e5,R._suggestionsLimit=1e4;function b(_){return new R(_,null)}t.create=b,typeof importScripts=="function"&&(globalThis.monaco=(0,g.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/base/worker/workerMain.js.map
