/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/base/common/json","vs/base/common/labels","child_process","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","net","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/parts/ipc/node/ipc.net","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(j){for(var e=[],E=0,L=j.length;E<L;E++)e[E]=te[j[E]];return e};define(te[133],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(I,h){const c=Math.pow(10,h);return Math.round(I*c)/c}class L{constructor(h,c,v,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=E(Math.max(Math.min(1,m),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.RGBA=L;class r{constructor(h,c,v,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,c),0),3),this.l=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,v=h.g/255,m=h.b/255,S=h.a,u=Math.max(c,v,m),y=Math.min(c,v,m);let p=0,s=0;const w=(y+u)/2,a=u-y;if(a>0){switch(s=Math.min(w<=.5?a/(2*w):a/(2-2*w),1),u){case c:p=(v-m)/a+(v<m?6:0);break;case v:p=(m-c)/a+2;break;case m:p=(c-v)/a+4;break}p*=60,p=Math.round(p)}return new r(p,s,w,S)}static _hue2rgb(h,c,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?h+(c-h)*6*v:v<1/2?c:v<2/3?h+(c-h)*(2/3-v)*6:h}static toRGBA(h){const c=h.h/360,{s:v,l:m,a:S}=h;let u,y,p;if(v===0)u=y=p=m;else{const s=m<.5?m*(1+v):m+v-m*v,w=2*m-s;u=r._hue2rgb(w,s,c+1/3),y=r._hue2rgb(w,s,c),p=r._hue2rgb(w,s,c-1/3)}return new L(Math.round(u*255),Math.round(y*255),Math.round(p*255),S)}}e.HSLA=r;class _{constructor(h,c,v,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,c),0),3),this.v=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,v=h.g/255,m=h.b/255,S=Math.max(c,v,m),u=Math.min(c,v,m),y=S-u,p=S===0?0:y/S;let s;return y===0?s=0:S===c?s=((v-m)/y%6+6)%6:S===v?s=(m-c)/y+2:s=(c-v)/y+4,new _(Math.round(s*60),p,S,h.a)}static toRGBA(h){const{h:c,s:v,v:m,a:S}=h,u=m*v,y=u*(1-Math.abs(c/60%2-1)),p=m-u;let[s,w,a]=[0,0,0];return c<60?(s=u,w=y):c<120?(s=y,w=u):c<180?(w=u,a=y):c<240?(w=y,a=u):c<300?(s=y,a=u):c<=360&&(s=u,a=y),s=Math.round((s+p)*255),w=Math.round((w+p)*255),a=Math.round((a+p)*255),new L(s,w,a,S)}}e.HSVA=_;class R{static fromHex(h){return R.Format.CSS.parseHex(h)||R.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:_.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof L)this.rgba=h;else if(h instanceof r)this._hsla=h,this.rgba=r.toRGBA(h);else if(h instanceof _)this._hsva=h,this.rgba=_.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&L.equals(this.rgba,h.rgba)&&r.equals(this.hsla,h.hsla)&&_.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=R._relativeLuminanceForComponent(this.rgba.r),c=R._relativeLuminanceForComponent(this.rgba.g),v=R._relativeLuminanceForComponent(this.rgba.b),m=.2126*h+.7152*c+.0722*v;return E(m,4)}static _relativeLuminanceForComponent(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),v=h.getRelativeLuminance();return c>v?(c+.05)/(v+.05):(v+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),v=h.getRelativeLuminance();return c>v}isDarkerThan(h){const c=this.getRelativeLuminance(),v=h.getRelativeLuminance();return c<v}lighten(h){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g:v,b:m,a:S}=this.rgba;return new R(new L(c,v,m,S*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,v=this.rgba.a,m=c.a,S=v+m*(1-v);if(S<1e-6)return R.transparent;const u=this.rgba.r*v/S+c.r*m*(1-v)/S,y=this.rgba.g*v/S+c.g*m*(1-v)/S,p=this.rgba.b*v/S+c.b*m*(1-v)/S;return new R(new L(u,y,p,S))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g:v,b:m,a:S}=this.rgba;return new R(new L(h.rgba.r-S*(h.rgba.r-c),h.rgba.g-S*(h.rgba.g-v),h.rgba.b-S*(h.rgba.b-m),1))}flatten(...h){const c=h.reduceRight((v,m)=>R._flatten(m,v));return R._flatten(this,c)}static _flatten(h,c){const v=1-h.rgba.a;return new R(new L(v*c.rgba.r+h.rgba.a*h.rgba.r,v*c.rgba.g+h.rgba.a*h.rgba.g,v*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=R.Format.CSS.format(this)),this._toString}static getLighterColor(h,c,v){if(h.isLighterThan(c))return h;v=v||.5;const m=h.getRelativeLuminance(),S=c.getRelativeLuminance();return v=v*(S-m)/S,h.lighten(v)}static getDarkerColor(h,c,v){if(h.isDarkerThan(c))return h;v=v||.5;const m=h.getRelativeLuminance(),S=c.getRelativeLuminance();return v=v*(m-S)/m,h.darken(v)}}e.Color=R,R.white=new R(new L(255,255,255,1)),R.black=new R(new L(0,0,0,1)),R.red=new R(new L(255,0,0,1)),R.blue=new R(new L(0,0,255,1)),R.green=new R(new L(0,255,0,1)),R.cyan=new R(new L(0,255,255,1)),R.lightgrey=new R(new L(211,211,211,1)),R.transparent=new R(new L(0,0,0,0)),function(I){let h;(function(c){let v;(function(m){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:I.Format.CSS.formatRGBA(t)}m.formatRGB=S;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}m.formatRGBA=u;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(t)}m.formatHSL=y;function p(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}m.formatHSLA=p;function s(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function w(t){return`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}`}m.formatHex=w;function a(t,l=!1){return l&&t.rgba.a===1?I.Format.CSS.formatHex(t):`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}${s(Math.round(t.rgba.a*255))}`}m.formatHexA=a;function f(t){return t.isOpaque()?I.Format.CSS.formatHex(t):I.Format.CSS.formatRGBA(t)}m.format=f;function P(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const n=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),i=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),o=16*C(t.charCodeAt(5))+C(t.charCodeAt(6));return new I(new L(n,i,o,1))}if(l===9){const n=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),i=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),o=16*C(t.charCodeAt(5))+C(t.charCodeAt(6)),d=16*C(t.charCodeAt(7))+C(t.charCodeAt(8));return new I(new L(n,i,o,d/255))}if(l===4){const n=C(t.charCodeAt(1)),i=C(t.charCodeAt(2)),o=C(t.charCodeAt(3));return new I(new L(16*n+n,16*i+i,16*o+o))}if(l===5){const n=C(t.charCodeAt(1)),i=C(t.charCodeAt(2)),o=C(t.charCodeAt(3)),d=C(t.charCodeAt(4));return new I(new L(16*n+n,16*i+i,16*o+o,(16*d+d)/255))}return null}m.parseHex=P;function C(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=c.CSS||(c.CSS={}))})(h=I.Format||(I.Format={}))}(R||(e.Color=R={}))}),define(te[55],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(R){return(I,h,c)=>{let v=null,m=null;if(typeof c.value=="function"?(v="value",m=c.value):typeof c.get=="function"&&(v="get",m=c.get),!m)throw new Error("not supported");c[v]=R(m,h)}}function L(R,I,h){let c=null,v=null;if(typeof h.value=="function"?(c="value",v=h.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",v=h.get),!v)throw new Error("not supported");const m=`$memoize$${I}`;h[c]=function(...S){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,S)}),this[m]}}e.memoize=L;function r(R,I,h){return E((c,v)=>{const m=`$debounce$${v}`,S=`$debounce$result$${v}`;return function(...u){this[S]||(this[S]=h?h():void 0),clearTimeout(this[m]),I&&(this[S]=I(this[S],...u),u=[this[S]]),this[m]=setTimeout(()=>{c.apply(this,u),this[S]=h?h():void 0},R)}})}e.debounce=r;function _(R,I,h){return E((c,v)=>{const m=`$throttle$timer$${v}`,S=`$throttle$result$${v}`,u=`$throttle$lastRun$${v}`,y=`$throttle$pending$${v}`;return function(...p){if(this[S]||(this[S]=h?h():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...p)),this[y])return;const s=this[u]+R;s<=Date.now()?(this[u]=Date.now(),c.apply(this,[this[S]]),this[S]=h?h():void 0):(this[y]=!0,this[m]=setTimeout(()=>{this[y]=!1,this[u]=Date.now(),c.apply(this,[this[S]]),this[S]=h?h():void 0},s-Date.now()))}})}e.throttle=_}),define(te[13],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?P.isErrorNoTelemetry(l)?new P(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(n=>{n(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}e.ErrorHandler=E,e.errorHandler=new E;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function r(t){if(!t||typeof t!="object")return!1;const l=t;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function _(t){c(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=_;function R(t){c(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=R;function I(t){if(t instanceof Error){const{name:l,message:n}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:l,message:n,stack:i,noTelemetry:P.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=I;const h="Canceled";function c(t){return t instanceof v?!0:t instanceof Error&&t.name===h&&t.message===h}e.isCancellationError=c;class v extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=v;function m(){const t=new Error(h);return t.name=t.message,t}e.canceled=m;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=u;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function p(t){const l=new Error(`${t} has been disposed`);return l.name="DISPOSED",l}e.disposed=p;function s(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=s;class w extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}e.NotImplementedError=w;class a extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}e.NotSupportedError=a;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class P extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof P)return l;const n=new P;return n.message=l.message,n.stack=l.stack,n}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}e.ErrorNoTelemetry=P;class C extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype)}}e.BugIndicatingError=C}),define(te[24],ie([0,1,13]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(B,$=0){return B[B.length-(1+$)]}e.tail=L;function r(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=r;function _(B,$,G=(se,ue)=>se===ue){if(B===$)return!0;if(!B||!$||B.length!==$.length)return!1;for(let se=0,ue=B.length;se<ue;se++)if(!G(B[se],$[se]))return!1;return!0}e.equals=_;function R(B,$){const G=B.length-1;$<G&&(B[$]=B[G]),B.pop()}e.removeFastWithoutKeepingOrder=R;function I(B,$,G){return h(B.length,se=>G(B[se],$))}e.binarySearch=I;function h(B,$){let G=0,se=B-1;for(;G<=se;){const ue=(G+se)/2|0,ye=$(ue);if(ye<0)G=ue+1;else if(ye>0)se=ue-1;else return ue}return-(G+1)}e.binarySearch2=h;function c(B,$){let G=0,se=B.length;if(se===0)return 0;for(;G<se;){const ue=Math.floor((G+se)/2);$(B[ue])?se=ue:G=ue+1}return G}e.findFirstInSorted=c;function v(B,$,G){if(B=B|0,B>=$.length)throw new TypeError("invalid index");const se=$[Math.floor($.length*Math.random())],ue=[],ye=[],Ce=[];for(const Re of $){const Le=G(Re,se);Le<0?ue.push(Re):Le>0?ye.push(Re):Ce.push(Re)}return B<ue.length?v(B,ue,G):B<ue.length+Ce.length?Ce[0]:v(B-(ue.length+Ce.length),ye,G)}e.quickSelect=v;function m(B,$){const G=[];let se;for(const ue of B.slice(0).sort($))!se||$(se[0],ue)!==0?(se=[ue],G.push(se)):se.push(ue);return G}e.groupBy=m;function S(B,$,G){const se=[];function ue(Re,Le,Te){if(Le===0&&Te.length===0)return;const we=se[se.length-1];we&&we.start+we.deleteCount===Re?(we.deleteCount+=Le,we.toInsert.push(...Te)):se.push({start:Re,deleteCount:Le,toInsert:Te})}let ye=0,Ce=0;for(;;){if(ye===B.length){ue(ye,0,$.slice(Ce));break}if(Ce===$.length){ue(ye,B.length-ye,[]);break}const Re=B[ye],Le=$[Ce],Te=G(Re,Le);Te===0?(ye+=1,Ce+=1):Te<0?(ue(ye,1,[]),ye+=1):Te>0&&(ue(ye,0,[Le]),Ce+=1)}return se}e.sortedDiff=S;function u(B,$,G){const se=S(B,$,G),ue=[],ye=[];for(const Ce of se)ue.push(...B.slice(Ce.start,Ce.start+Ce.deleteCount)),ye.push(...Ce.toInsert);return{removed:ue,added:ye}}e.delta=u;function y(B,$,G){if(G===0)return[];const se=B.slice(0,G).sort($);return s(B,$,se,G,B.length),se}e.top=y;function p(B,$,G,se,ue){return G===0?Promise.resolve([]):new Promise((ye,Ce)=>{(async()=>{const Re=B.length,Le=B.slice(0,G).sort($);for(let Te=G,we=Math.min(G+se,Re);Te<Re;Te=we,we=Math.min(we+se,Re)){if(Te>G&&await new Promise(ve=>setTimeout(ve)),ue&&ue.isCancellationRequested)throw new E.CancellationError;s(B,$,Le,Te,we)}return Le})().then(ye,Ce)})}e.topAsync=p;function s(B,$,G,se,ue){for(const ye=G.length;se<ue;se++){const Ce=B[se];if($(Ce,G[ye-1])<0){G.pop();const Re=c(G,Le=>$(Ce,Le)<0);G.splice(Re,0,Ce)}}}function w(B){return B.filter($=>!!$)}e.coalesce=w;function a(B){let $=0;for(let G=0;G<B.length;G++)B[G]&&(B[$]=B[G],$+=1);B.length=$}e.coalesceInPlace=a;function f(B,$,G){B.splice(G,0,B.splice($,1)[0])}e.move=f;function P(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=P;function C(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=C;function t(B,$=G=>G){const G=new Set;return B.filter(se=>{const ue=$(se);return G.has(ue)?!1:(G.add(ue),!0)})}e.distinct=t;function l(B){const $=new Set;return G=>{const se=B(G);return $.has(se)?!1:($.add(se),!0)}}e.uniqueFilter=l;function n(B,$){const G=i(B,$);if(G!==-1)return B[G]}e.findLast=n;function i(B,$){for(let G=B.length-1;G>=0;G--){const se=B[G];if($(se))return G}return-1}e.lastIndex=i;function o(B,$){return B.length>0?B[0]:$}e.firstOrDefault=o;function d(B,$){return B.length>0?B[B.length-1]:$}e.lastOrDefault=d;function g(B,$,G=(se,ue)=>se===ue){let se=0;for(let ue=0,ye=Math.min(B.length,$.length);ue<ye&&G(B[ue],$[ue]);ue++)se++;return se}e.commonPrefixLength=g;function D(B){return[].concat(...B)}e.flatten=D;function M(B,$){let G=typeof $=="number"?B:0;typeof $=="number"?G=B:(G=0,$=B);const se=[];if(G<=$)for(let ue=G;ue<$;ue++)se.push(ue);else for(let ue=G;ue>$;ue--)se.push(ue);return se}e.range=M;function b(B,$,G){return B.reduce((se,ue)=>(se[$(ue)]=G?G(ue):ue,se),Object.create(null))}e.index=b;function A(B,$){return B.push($),()=>O(B,$)}e.insert=A;function O(B,$){const G=B.indexOf($);if(G>-1)return B.splice(G,1),$}e.remove=O;function F(B,$,G){const se=B.slice(0,$),ue=B.slice($);return se.concat(G,ue)}e.arrayInsert=F;function q(B,$){let G;if(typeof $=="number"){let se=$;G=()=>{const ue=Math.sin(se++)*179426549;return ue-Math.floor(ue)}}else G=Math.random;for(let se=B.length-1;se>0;se-=1){const ue=Math.floor(G()*(se+1)),ye=B[se];B[se]=B[ue],B[ue]=ye}}e.shuffle=q;function re(B,$){const G=B.indexOf($);G>-1&&(B.splice(G,1),B.unshift($))}e.pushToStart=re;function Y(B,$){const G=B.indexOf($);G>-1&&(B.splice(G,1),B.push($))}e.pushToEnd=Y;function ne(B,$){for(const G of $)B.push(G)}e.pushMany=ne;function ce(B,$){return Array.isArray(B)?B.map($):$(B)}e.mapArrayOrNot=ce;function le(B){return Array.isArray(B)?B:[B]}e.asArray=le;function K(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=K;function V(B,$){for(const G of B){const se=$(G);if(se!==void 0)return se}}e.mapFind=V;function U(B,$,G){const se=x(B,$),ue=B.length,ye=G.length;B.length=ue+ye;for(let Ce=ue-1;Ce>=se;Ce--)B[Ce+ye]=B[Ce];for(let Ce=0;Ce<ye;Ce++)B[Ce+se]=G[Ce]}e.insertInto=U;function T(B,$,G,se){const ue=x(B,$),ye=B.splice(ue,G);return U(B,ue,se),ye}e.splice=T;function x(B,$){return $<0?Math.max($+B.length,0):Math.min($,B.length)}var Q;(function(B){function $(ue){return ue<0}B.isLessThan=$;function G(ue){return ue>0}B.isGreaterThan=G;function se(ue){return ue===0}B.isNeitherLessOrGreaterThan=se,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function Z(B,$){return(G,se)=>$(B(G),B(se))}e.compareBy=Z;function ae(...B){return($,G)=>{for(const se of B){const ue=se($,G);if(!Q.isNeitherLessOrGreaterThan(ue))return ue}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const oe=(B,$)=>B-$;e.numberComparator=oe;function N(B,$){if(B.length===0)return;let G=B[0];for(let se=1;se<B.length;se++){const ue=B[se];$(ue,G)>0&&(G=ue)}return G}e.findMaxBy=N;function k(B,$){if(B.length===0)return;let G=B[0];for(let se=1;se<B.length;se++){const ue=B[se];$(ue,G)>=0&&(G=ue)}return G}e.findLastMaxBy=k;function W(B,$){return N(B,(G,se)=>-$(G,se))}e.findMinBy=W;class z{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let G=this.firstIdx;for(;G<this.items.length&&$(this.items[G]);)G++;const se=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,se}takeFromEndWhile($){let G=this.lastIdx;for(;G>=0&&$(this.items[G]);)G--;const se=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,se}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const G=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,G}}e.ArrayQueue=z;class H{constructor($){this.iterate=$}forEach($){this.iterate(G=>($(G),!0))}toArray(){const $=[];return this.iterate(G=>($.push(G),!0)),$}filter($){return new H(G=>this.iterate(se=>$(se)?G(se):!0))}map($){return new H(G=>this.iterate(se=>G($(se))))}some($){let G=!1;return this.iterate(se=>(G=$(se),!G)),G}findFirst($){let G;return this.iterate(se=>$(se)?(G=se,!1):!0),G}findLast($){let G;return this.iterate(se=>($(se)&&(G=se),!0)),G}findLastMaxBy($){let G,se=!0;return this.iterate(ue=>((se||Q.isGreaterThan($(ue,G)))&&(se=!1,G=ue),!0)),G}}e.CallbackIterable=H,H.empty=new H(B=>{})}),define(te[134],ie([0,1,13]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=L;function r(h,c="Unreachable"){throw new Error(c)}e.assertNever=r;function _(h){if(!h)throw new E.BugIndicatingError("Assertion Failed")}e.assert=_;function R(h){if(!h()){debugger;h(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function I(h,c){let v=0;for(;v<h.length-1;){const m=h[v],S=h[v+1];if(!c(m,S))return!1;v++}return!0}e.checkAdjacentItems=I}),define(te[49],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(L){const r=this;let _=!1,R;return function(){return _||(_=!0,R=L.apply(r,arguments)),R}}e.once=E}),define(te[68],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(L){function r(P){return P&&typeof P=="object"&&typeof P[Symbol.iterator]=="function"}L.is=r;const _=Object.freeze([]);function R(){return _}L.empty=R;function*I(P){yield P}L.single=I;function h(P){return r(P)?P:I(P)}L.wrap=h;function c(P){return P||_}L.from=c;function v(P){return!P||P[Symbol.iterator]().next().done===!0}L.isEmpty=v;function m(P){return P[Symbol.iterator]().next().value}L.first=m;function S(P,C){for(const t of P)if(C(t))return!0;return!1}L.some=S;function u(P,C){for(const t of P)if(C(t))return t}L.find=u;function*y(P,C){for(const t of P)C(t)&&(yield t)}L.filter=y;function*p(P,C){let t=0;for(const l of P)yield C(l,t++)}L.map=p;function*s(...P){for(const C of P)for(const t of C)yield t}L.concat=s;function w(P,C,t){let l=t;for(const n of P)l=C(l,n);return l}L.reduce=w;function*a(P,C,t=P.length){for(C<0&&(C+=P.length),t<0?t+=P.length:t>P.length&&(t=P.length);C<t;C++)yield P[C]}L.slice=a;function f(P,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,P];const l=P[Symbol.iterator]();for(let n=0;n<C;n++){const i=l.next();if(i.done)return[t,L.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return l}}]}L.consume=f})(E||(e.Iterable=E={}))}),define(te[44],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_||(e.ParseOptions=_={}));function R(t,l=!1){let n=0;const i=t.length;let o="",d=0,g=16,D=0;function M(Y){let ne=0,ce=0;for(;ne<Y;){const le=t.charCodeAt(n);if(le>=48&&le<=57)ce=ce*16+le-48;else if(le>=65&&le<=70)ce=ce*16+le-65+10;else if(le>=97&&le<=102)ce=ce*16+le-97+10;else break;n++,ne++}return ne<Y&&(ce=-1),ce}function b(Y){n=Y,o="",d=0,g=16,D=0}function A(){const Y=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return D=3,t.substring(Y,n);let ne=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;ne=n}else D=3;return t.substring(Y,ne)}function O(){let Y="",ne=n;for(;;){if(n>=i){Y+=t.substring(ne,n),D=2;break}const ce=t.charCodeAt(n);if(ce===34){Y+=t.substring(ne,n),n++;break}if(ce===92){if(Y+=t.substring(ne,n),n++,n>=i){D=2;break}switch(t.charCodeAt(n++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const K=M(4);K>=0?Y+=String.fromCharCode(K):D=4;break}default:D=5}ne=n;continue}if(ce>=0&&ce<=31)if(h(ce)){Y+=t.substring(ne,n),D=2;break}else D=6;n++}return Y}function F(){if(o="",D=0,d=n,n>=i)return d=i,g=17;let Y=t.charCodeAt(n);if(I(Y)){do n++,o+=String.fromCharCode(Y),Y=t.charCodeAt(n);while(I(Y));return g=15}if(h(Y))return n++,o+=String.fromCharCode(Y),Y===13&&t.charCodeAt(n)===10&&(n++,o+=`
`),g=14;switch(Y){case 123:return n++,g=1;case 125:return n++,g=2;case 91:return n++,g=3;case 93:return n++,g=4;case 58:return n++,g=6;case 44:return n++,g=5;case 34:return n++,o=O(),g=10;case 47:{const ne=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!h(t.charCodeAt(n));)n++;return o=t.substring(ne,n),g=12}if(t.charCodeAt(n+1)===42){n+=2;const ce=i-1;let le=!1;for(;n<ce;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,le=!0;break}n++}return le||(n++,D=1),o=t.substring(ne,n),g=13}return o+=String.fromCharCode(Y),n++,g=16}case 45:if(o+=String.fromCharCode(Y),n++,n===i||!c(t.charCodeAt(n)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=A(),g=11;default:for(;n<i&&q(Y);)n++,Y=t.charCodeAt(n);if(d!==n){switch(o=t.substring(d,n),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(Y),n++,g=16}}function q(Y){if(I(Y)||h(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Y;do Y=F();while(Y>=12&&Y<=15);return Y}return{setPosition:b,getPosition:()=>n,scan:l?re:F,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>D}}e.createScanner=R;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var v;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(v||(v={}));function m(t,l){const n=[],i=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(M,b,A,O){d.value=M,d.offset=b,d.length=A,d.type=O,d.colonOffset=void 0,o=d}try{f(t,{onObjectBegin:(M,b)=>{if(l<=M)throw i;o=void 0,g=l>M,n.push("")},onObjectProperty:(M,b,A)=>{if(l<b||(D(M,b,A,"property"),n[n.length-1]=M,l<=b+A))throw i},onObjectEnd:(M,b)=>{if(l<=M)throw i;o=void 0,n.pop()},onArrayBegin:(M,b)=>{if(l<=M)throw i;o=void 0,n.push(0)},onArrayEnd:(M,b)=>{if(l<=M)throw i;o=void 0,n.pop()},onLiteralValue:(M,b,A)=>{if(l<b||(D(M,b,A,C(M)),l<=b+A))throw i},onSeparator:(M,b,A)=>{if(l<=b)throw i;if(M===":"&&o&&o.type==="property")o.colonOffset=b,g=!1,o=void 0;else if(M===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(g=!0,n[n.length-1]=""),o=void 0}}})}catch(M){if(M!==i)throw M}return{path:n,previousNode:o,isAtPropertyKey:g,matches:M=>{let b=0;for(let A=0;b<M.length&&A<n.length;A++)if(M[b]===n[A]||M[b]==="*")b++;else if(M[b]!=="**")return!1;return b===M.length}}}e.getLocation=m;function S(t,l=[],n=_.DEFAULT){let i=null,o=[];const d=[];function g(M){Array.isArray(o)?o.push(M):i!==null&&(o[i]=M)}return f(t,{onObjectBegin:()=>{const M={};g(M),d.push(o),o=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const M=[];g(M),d.push(o),o=M,i=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:g,onError:(M,b,A)=>{l.push({error:M,offset:b,length:A})}},n),o[0]}e.parse=S;function u(t,l=[],n=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){i.type==="property"&&(i.length=M-i.offset,i=i.parent)}function d(M){return i.children.push(M),M}f(t,{onObjectBegin:M=>{i=d({type:"object",offset:M,length:-1,parent:i,children:[]})},onObjectProperty:(M,b,A)=>{i=d({type:"property",offset:b,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:M,offset:b,length:A,parent:i})},onObjectEnd:(M,b)=>{i.length=M+b-i.offset,i=i.parent,o(M+b)},onArrayBegin:(M,b)=>{i=d({type:"array",offset:M,length:-1,parent:i,children:[]})},onArrayEnd:(M,b)=>{i.length=M+b-i.offset,i=i.parent,o(M+b)},onLiteralValue:(M,b,A)=>{d({type:C(M),offset:b,length:A,parent:i,value:M}),o(b+A)},onSeparator:(M,b,A)=>{i.type==="property"&&(M===":"?i.colonOffset=b:M===","&&o(b))},onError:(M,b,A)=>{l.push({error:M,offset:b,length:A})}},n);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=u;function y(t,l){if(!t)return;let n=t;for(const i of l)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===i){n=d.children[1],o=!0;break}if(!o)return}else{const o=i;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=y;function p(t){if(!t.parent||!t.parent.children)return[];const l=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;l.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&l.push(n)}return l}e.getNodePath=p;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const l=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(l[n.children[0].value]=s(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function w(t,l,n=!1){return l>=t.offset&&l<t.offset+t.length||n&&l===t.offset+t.length}e.contains=w;function a(t,l,n=!1){if(w(t,l,n)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=l;o++){const d=a(i[o],l,n);if(d)return d}return t}}e.findNodeAtOffset=a;function f(t,l,n=_.DEFAULT){const i=R(t,!1);function o(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(Z){return Z?ae=>Z(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=o(l.onObjectBegin),D=d(l.onObjectProperty),M=o(l.onObjectEnd),b=o(l.onArrayBegin),A=o(l.onArrayEnd),O=d(l.onLiteralValue),F=d(l.onSeparator),q=o(l.onComment),re=d(l.onError),Y=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function ce(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:Y||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(Z){case 12:case 13:Y?le(10):q();break;case 16:le(1);break;case 15:case 14:break;default:return Z}}}function le(Z,ae=[],oe=[]){if(re(Z),ae.length+oe.length>0){let N=i.getToken();for(;N!==17;){if(ae.indexOf(N)!==-1){ce();break}else if(oe.indexOf(N)!==-1)break;N=ce()}}}function K(Z){const ae=i.getTokenValue();return Z?O(ae):D(ae),ce(),!0}function V(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(le(2),Z=0)}catch{le(2)}O(Z);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return ce(),!0}function U(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(F(":"),ce(),Q()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function T(){g(),ce();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||le(4,[],[]),F(","),ce(),i.getToken()===2&&ne)break}else Z&&le(6,[],[]);U()||le(4,[],[2,5]),Z=!0}return M(),i.getToken()!==2?le(7,[2],[]):ce(),!0}function x(){b(),ce();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||le(4,[],[]),F(","),ce(),i.getToken()===4&&ne)break}else Z&&le(6,[],[]);Q()||le(4,[],[4,5]),Z=!0}return A(),i.getToken()!==4?le(8,[4],[]):ce(),!0}function Q(){switch(i.getToken()){case 3:return x();case 1:return T();case 10:return K(!0);default:return V()}}return ce(),i.getToken()===17?n.allowEmptyContent?!0:(le(4,[],[]),!1):Q()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=f;function P(t,l){const n=R(t),i=[];let o,d=0,g;do switch(g=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:d!==g&&i.push(t.substring(d,g)),l!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,l)),d=n.getPosition();break}while(o!==17);return i.join("")}e.stripComments=P;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(te[135],ie([0,1,44]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(c,v,m){let S,u,y,p,s;if(v){for(p=v.offset,s=p+v.length,y=p;y>0&&!h(c,y-1);)y--;let g=s;for(;g<c.length&&!h(c,g);)g++;u=c.substring(y,g),S=R(u,m)}else u=c,S=0,y=0,p=0,s=c.length;const w=I(m,c);let a=!1,f=0,P;m.insertSpaces?P=_(" ",m.tabSize||4):P="	";const C=(0,E.createScanner)(u,!1);let t=!1;function l(){return w+_(P,S+f)}function n(){let g=C.scan();for(a=!1;g===15||g===14;)a=a||g===14,g=C.scan();return t=g===16||C.getTokenError()!==0,g}const i=[];function o(g,D,M){!t&&D<s&&M>p&&c.substring(D,M)!==g&&i.push({offset:D,length:M-D,content:g})}let d=n();if(d!==17){const g=C.getTokenOffset()+y,D=_(P,S);o(D,y,g)}for(;d!==17;){let g=C.getTokenOffset()+C.getTokenLength()+y,D=n(),M="";for(;!a&&(D===12||D===13);){const A=C.getTokenOffset()+y;o(" ",g,A),g=C.getTokenOffset()+C.getTokenLength()+y,M=D===12?l():"",D=n()}if(D===2)d!==1&&(f--,M=l());else if(D===4)d!==3&&(f--,M=l());else{switch(d){case 3:case 1:f++,M=l();break;case 5:case 12:M=l();break;case 13:a?M=l():M=" ";break;case 6:M=" ";break;case 10:if(D===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?M=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}a&&(D===12||D===13)&&(M=l())}const b=C.getTokenOffset()+y;o(M,g,b),d=D}return i}e.format=L;function r(c,v){const m=JSON.stringify(c,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?m.replace(/\r\n|\r|\n/g,v.eol):m}e.toFormattedString=r;function _(c,v){let m="";for(let S=0;S<v;S++)m+=c;return m}function R(c,v){let m=0,S=0;const u=v.tabSize||4;for(;m<c.length;){const y=c.charAt(m);if(y===" ")S++;else if(y==="	")S+=u;else break;m++}return Math.floor(S/u)}function I(c,v){for(let m=0;m<v.length;m++){const S=v.charAt(m);if(S==="\r")return m+1<v.length&&v.charAt(m+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return c&&c.eol||`
`}e.getEOL=I;function h(c,v){return`\r
`.indexOf(c.charAt(v))!==-1}e.isEOL=h}),define(te[136],ie([0,1,44,135]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(c,v,m){return _(c,v,void 0,m)}e.removeProperty=r;function _(c,v,m,S,u){const y=v.slice(),p=[],s=(0,E.parseTree)(c,p);let w,a;for(;y.length>0&&(a=y.pop(),w=(0,E.findNodeAtLocation)(s,y),w===void 0&&m!==void 0);)typeof a=="string"?m={[a]:m}:m=[m];if(w)if(w.type==="object"&&typeof a=="string"&&Array.isArray(w.children)){const f=(0,E.findNodeAtLocation)(w,[a]);if(f!==void 0)if(m===void 0){if(!f.parent)throw new Error("Malformed AST");const P=w.children.indexOf(f.parent);let C,t=f.parent.offset+f.parent.length;if(P>0){const l=w.children[P-1];C=l.offset+l.length}else C=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return R(c,{offset:C,length:t-C,content:""},S)}else return R(c,{offset:f.offset,length:f.length,content:JSON.stringify(m)},S);else{if(m===void 0)return[];const P=`${JSON.stringify(a)}: ${JSON.stringify(m)}`,C=u?u(w.children.map(l=>l.children[0].value)):w.children.length;let t;if(C>0){const l=w.children[C-1];t={offset:l.offset+l.length,length:0,content:","+P}}else w.children.length===0?t={offset:w.offset+1,length:0,content:P}:t={offset:w.offset+1,length:0,content:P+","};return R(c,t,S)}}else if(w.type==="array"&&typeof a=="number"&&Array.isArray(w.children))if(m!==void 0){const f=`${JSON.stringify(m)}`;let P;if(w.children.length===0||a===0)P={offset:w.offset+1,length:0,content:w.children.length===0?f:f+","};else{const C=a===-1||a>w.children.length?w.children.length:a,t=w.children[C-1];P={offset:t.offset+t.length,length:0,content:","+f}}return R(c,P,S)}else{const f=a,P=w.children[f];let C;if(w.children.length===1)C={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===f){const t=w.children[f-1],l=t.offset+t.length,n=w.offset+w.length;C={offset:l,length:n-2-l,content:""}}else C={offset:P.offset,length:w.children[f+1].offset-P.offset,content:""};return R(c,C,S)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${w.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return R(c,{offset:s?s.offset:0,length:s?s.length:0,content:JSON.stringify(m)},S)}}e.setProperty=_;function R(c,v,m){let S=I(c,v),u=v.offset,y=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;u>0&&!(0,L.isEOL)(S,u-1);)u--;for(;y<S.length&&!(0,L.isEOL)(S,y);)y++}const p=(0,L.format)(S,{offset:u,length:y-u},m);for(let w=p.length-1;w>=0;w--){const a=p[w];S=I(S,a),u=Math.min(u,a.offset),y=Math.max(y,a.offset+a.length),y+=a.content.length-a.length}const s=c.length-(S.length-y)-u;return[{offset:u,length:s,content:S.substring(u,y)}]}e.withFormatting=R;function I(c,v){return c.substring(0,v.offset)+v.content+c.substring(v.offset+v.length)}e.applyEdit=I;function h(c,v){const m=v.slice(0).sort((u,y)=>{const p=u.offset-y.offset;return p===0?u.length-y.length:p});let S=c.length;for(let u=m.length-1;u>=0;u--){const y=m[u];if(y.offset+y.length<=S)c=I(c,y);else throw new Error("Overlapping edit");S=y.offset}return c}e.applyEdits=h}),define(te[100],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=E}),define(te[2],ie([0,1,49,68]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const r=!1;let _=null;function R(d){_=d}if(e.setDisposableTracker=R,r){const d="__is_disposable_tracked__";R(new class{trackDisposable(g){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[d]||console.log(D)},3e3)}setParent(g,D){if(g&&g!==a.None)try{g[d]=!0}catch{}}markAsDisposed(g){if(g&&g!==a.None)try{g[d]=!0}catch{}}markAsSingleton(g){}})}function I(d){return _?.trackDisposable(d),d}function h(d){_?.markAsDisposed(d)}function c(d,g){_?.setParent(d,g)}function v(d,g){if(_)for(const D of d)_.setParent(D,g)}function m(d){return _?.markAsSingleton(d),d}e.markAsSingleton=m;function S(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=S;function u(d){if(L.Iterable.is(d)){const g=[];for(const D of d)if(D)try{D.dispose()}catch(M){g.push(M)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.dispose=u;function y(d){for(const g of d)S(g)&&g.dispose();return[]}e.disposeIfDisposable=y;function p(...d){const g=s(()=>u(d));return v(d,g),g}e.combinedDisposable=p;function s(d){const g=I({dispose:(0,E.once)(()=>{h(g),d()})});return g}e.toDisposable=s;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return c(g,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new w,I(this),c(this._store,this)}dispose(){h(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){this._isDisposed||g===this._value||(this._value?.dispose(),g&&c(g,this),this._value=g)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const g=this._value;return this._value=void 0,g&&c(g,null),g}}e.MutableDisposable=f;class P{constructor(g){this._disposable=g,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=P;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(g){let D=g;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,h(this))},this}}e.SafeDisposable=C;class t{constructor(){this.references=new Map}acquire(g,...D){let M=this.references.get(g);M||(M={counter:0,object:this.createReferencedObject(g,...D)},this.references.set(g,M));const{object:b}=M,A=(0,E.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(g,M.object),this.references.delete(g))});return M.counter++,{object:b,dispose:A}}}e.ReferenceCollection=t;class l{constructor(g){this.referenceCollection=g}async acquire(g,...D){const M=this.referenceCollection.acquire(g,...D);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(b){throw M.dispose(),b}}}e.AsyncReferenceCollection=l;class n{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=n;function i(d){const g=new w;try{d(g)}finally{g.dispose()}}e.disposeOnReturn=i;class o{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(g){return this._store.has(g)}get(g){return this._store.get(g)}set(g,D,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(g)?.dispose(),this._store.set(g,D)}deleteAndDispose(g){this._store.get(g)?.dispose(),this._store.delete(g)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=o}),define(te[101],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(_){this.element=_,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class L{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let _=this._first;for(;_!==E.Undefined;){const R=_.next;_.prev=E.Undefined,_.next=E.Undefined,_=R}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,R){const I=new E(_);if(this._first===E.Undefined)this._first=I,this._last=I;else if(R){const c=this._last;this._last=I,I.prev=c,c.next=I}else{const c=this._first;this._first=I,I.next=c,c.prev=I}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(I))}}shift(){if(this._first!==E.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==E.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==E.Undefined&&_.next!==E.Undefined){const R=_.prev;R.next=_.next,_.next.prev=R}else _.prev===E.Undefined&&_.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):_.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):_.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==E.Undefined;)yield _.element,_=_.next}}e.LinkedList=L}),define(te[35],ie([0,1]),function(j,e){"use strict";var E,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function _(p,s,w){let a=p.get(s);return a===void 0&&(a=w,p.set(s,a)),a}e.getOrSet=_;function R(p){const s=[];return p.forEach((w,a)=>{s.push(`${a} => ${w}`)}),`Map(${p.size}) {${s.join(", ")}}`}e.mapToString=R;function I(p){const s=[];return p.forEach(w=>{s.push(w)}),`Set(${p.size}) {${s.join(", ")}}`}e.setToString=I;class h{constructor(s,w){this.uri=s,this.value=w}}class c{constructor(s,w){this[E]="ResourceMap",s instanceof c?(this.map=new Map(s.map),this.toKey=w??c.defaultToKey):(this.map=new Map,this.toKey=s??c.defaultToKey)}set(s,w){return this.map.set(this.toKey(s),new h(s,w)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,w){typeof w<"u"&&(s=s.bind(w));for(const[a,f]of this.map)s(f.value,f.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=c,c.defaultToKey=p=>p.toString();class v{constructor(s,w){this[L]="ResourceSet",!s||typeof s=="function"?this._map=new c(s):(this._map=new c(w),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,w){this._map.forEach((a,f)=>s.call(w,f,f,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=v;var m;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class S{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,w=0){const a=this._map.get(s);if(a)return w!==0&&this.touch(a,w),a.value}set(s,w,a=0){let f=this._map.get(s);if(f)f.value=w,a!==0&&this.touch(f,a);else{switch(f={key:s,value:w,next:void 0,previous:void 0},a){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(s,f),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const w=this._map.get(s);if(w)return this._map.delete(s),this.removeItem(w),this._size--,w.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,w){const a=this._state;let f=this._head;for(;f;){if(w?s.bind(w)(f.value,f.key,this):s(f.value,f.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const s=this,w=this._state;let a=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==w)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return f}values(){const s=this,w=this._state;let a=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==w)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return f}entries(){const s=this,w=this._state;let a=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==w)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return f}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let w=this._head,a=this.size;for(;w&&a>s;)this._map.delete(w.key),w=w.next,a--;this._head=w,this._size=a,w&&(w.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const w=s.next,a=s.previous;if(!w||!a)throw new Error("Invalid list");w.previous=a,a.next=w}s.next=void 0,s.previous=void 0,this._state++}touch(s,w){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(w!==1&&w!==2)){if(w===1){if(s===this._head)return;const a=s.next,f=s.previous;s===this._tail?(f.next=void 0,this._tail=f):(a.previous=f,f.next=a),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(w===2){if(s===this._tail)return;const a=s.next,f=s.previous;s===this._head?(a.previous=void 0,this._head=a):(a.previous=f,f.next=a),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((w,a)=>{s.push([a,w])}),s}fromJSON(s){this.clear();for(const[w,a]of s)this.set(w,a)}}e.LinkedMap=S;class u extends S{constructor(s,w=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,w),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,w=2){return super.get(s,w)}peek(s){return super.get(s,0)}set(s,w){return super.set(s,w,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class y{constructor(){this.map=new Map}add(s){return this.map.set(s,(this.map.get(s)||0)+1),this}delete(s){let w=this.map.get(s)||0;return w===0?!1:(w--,w===0?this.map.delete(s):this.map.set(s,w),!0)}has(s){return this.map.has(s)}}e.CounterSet=y}),define(te[83],ie([0,1,35]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new E.LRUCache(1e4);function r(c){return h(c,"NFC",L)}e.normalizeNFC=r;const _=new E.LRUCache(1e4);function R(c){return h(c,"NFD",_)}e.normalizeNFD=R;const I=/[^\u0000-\u0080]/;function h(c,v,m){if(!c)return c;const S=m.get(c);if(S)return S;let u;return I.test(c)?u=c.normalize(v):u=c,m.set(c,u),u}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(v){return R(v).replace(c,"")}}()}),define(te[137],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(I,h,c){return Math.min(Math.max(I,h),c)}e.clamp=E;function L(I,h){return(h+I%h)%h}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class _{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=_;class R{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const c=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function j(r){const _=[];typeof r=="number"&&_.push("code/timeOrigin",r);function R(h){_.push(h,Date.now())}function I(){const h=[];for(let c=0;c<_.length;c+=2)h.push({name:_[c],startTime:_[c+1]});return h}return{mark:R,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const R of performance.getEntriesByType("mark"))_.push({name:R.name,startTime:Math.round(r+R.startTime)});return _}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function E(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(j,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:j)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(j){var e={};function E(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return j[L].call(r.exports,r,r.exports,E),r.l=!0,r.exports}return E.m=j,E.c=e,E.d=function(L,r,_){E.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:_})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,r){if(1&r&&(L=E(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var _=Object.create(null);if(E.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var R in L)E.d(_,R,function(I){return L[I]}.bind(null,R));return _},E.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(r,"a",r),r},E.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},E.p="",E(E.s=0)}([function(j,e,E){(function(L){var r;e=j.exports=oe,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],h=e.src=[],c=0,v=c++;h[v]="0|[1-9]\\d*";var m=c++;h[m]="[0-9]+";var S=c++;h[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=c++;h[u]="("+h[v]+")\\.("+h[v]+")\\.("+h[v]+")";var y=c++;h[y]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var p=c++;h[p]="(?:"+h[v]+"|"+h[S]+")";var s=c++;h[s]="(?:"+h[m]+"|"+h[S]+")";var w=c++;h[w]="(?:-("+h[p]+"(?:\\."+h[p]+")*))";var a=c++;h[a]="(?:-?("+h[s]+"(?:\\."+h[s]+")*))";var f=c++;h[f]="[0-9A-Za-z-]+";var P=c++;h[P]="(?:\\+("+h[f]+"(?:\\."+h[f]+")*))";var C=c++,t="v?"+h[u]+h[w]+"?"+h[P]+"?";h[C]="^"+t+"$";var l="[v=\\s]*"+h[y]+h[a]+"?"+h[P]+"?",n=c++;h[n]="^"+l+"$";var i=c++;h[i]="((?:<|>)?=?)";var o=c++;h[o]=h[m]+"|x|X|\\*";var d=c++;h[d]=h[v]+"|x|X|\\*";var g=c++;h[g]="[v=\\s]*("+h[d]+")(?:\\.("+h[d]+")(?:\\.("+h[d]+")(?:"+h[w]+")?"+h[P]+"?)?)?";var D=c++;h[D]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[a]+")?"+h[P]+"?)?)?";var M=c++;h[M]="^"+h[i]+"\\s*"+h[g]+"$";var b=c++;h[b]="^"+h[i]+"\\s*"+h[D]+"$";var A=c++;h[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=c++;h[O]="(?:~>?)";var F=c++;h[F]="(\\s*)"+h[O]+"\\s+",I[F]=new RegExp(h[F],"g");var q=c++;h[q]="^"+h[O]+h[g]+"$";var re=c++;h[re]="^"+h[O]+h[D]+"$";var Y=c++;h[Y]="(?:\\^)";var ne=c++;h[ne]="(\\s*)"+h[Y]+"\\s+",I[ne]=new RegExp(h[ne],"g");var ce=c++;h[ce]="^"+h[Y]+h[g]+"$";var le=c++;h[le]="^"+h[Y]+h[D]+"$";var K=c++;h[K]="^"+h[i]+"\\s*("+l+")$|^$";var V=c++;h[V]="^"+h[i]+"\\s*("+t+")$|^$";var U=c++;h[U]="(\\s*)"+h[i]+"\\s*("+l+"|"+h[g]+")",I[U]=new RegExp(h[U],"g");var T=c++;h[T]="^\\s*("+h[g]+")\\s+-\\s+("+h[g]+")\\s*$";var x=c++;h[x]="^\\s*("+h[D]+")\\s+-\\s+("+h[D]+")\\s*$";var Q=c++;h[Q]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)r(Z,h[Z]),I[Z]||(I[Z]=new RegExp(h[Z]));function ae(ee,de){if(ee instanceof oe)return ee;if(typeof ee!="string"||ee.length>_||!(de?I[n]:I[C]).test(ee))return null;try{return new oe(ee,de)}catch{return null}}function oe(ee,de){if(ee instanceof oe){if(ee.loose===de)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof oe))return new oe(ee,de);r("SemVer",ee,de),this.loose=de;var fe=ee.trim().match(de?I[n]:I[C]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var De=+ke;if(De>=0&&De<R)return De}return ke}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ee,de){var fe=ae(ee,de);return fe?fe.version:null},e.clean=function(ee,de){var fe=ae(ee.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(ee){return r("SemVer.compare",this.version,this.loose,ee),ee instanceof oe||(ee=new oe(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},oe.prototype.compareMain=function(ee){return ee instanceof oe||(ee=new oe(ee,this.loose)),k(this.major,ee.major)||k(this.minor,ee.minor)||k(this.patch,ee.patch)},oe.prototype.comparePre=function(ee){if(ee instanceof oe||(ee=new oe(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],ke=ee.prerelease[de];if(r("prerelease compare",de,fe,ke),fe===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(fe===void 0)return-1;if(fe!==ke)return k(fe,ke)}while(++de)},oe.prototype.inc=function(ee,de){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,de,fe,ke){typeof fe=="string"&&(ke=fe,fe=void 0);try{return new oe(ee,fe).inc(de,ke).version}catch{return null}},e.diff=function(ee,de){if(B(ee,de))return null;var fe=ae(ee),ke=ae(de);if(fe.prerelease.length||ke.prerelease.length){for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==ke[De])return"pre"+De;return"prerelease"}for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==ke[De])return De},e.compareIdentifiers=k;var N=/^[0-9]+$/;function k(ee,de){var fe=N.test(ee),ke=N.test(de);return fe&&ke&&(ee=+ee,de=+de),fe&&!ke?-1:ke&&!fe?1:ee<de?-1:ee>de?1:0}function W(ee,de,fe){return new oe(ee,fe).compare(new oe(de,fe))}function z(ee,de,fe){return W(ee,de,fe)>0}function H(ee,de,fe){return W(ee,de,fe)<0}function B(ee,de,fe){return W(ee,de,fe)===0}function $(ee,de,fe){return W(ee,de,fe)!==0}function G(ee,de,fe){return W(ee,de,fe)>=0}function se(ee,de,fe){return W(ee,de,fe)<=0}function ue(ee,de,fe,ke){var De;switch(de){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),De=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),De=ee!==fe;break;case"":case"=":case"==":De=B(ee,fe,ke);break;case"!=":De=$(ee,fe,ke);break;case">":De=z(ee,fe,ke);break;case">=":De=G(ee,fe,ke);break;case"<":De=H(ee,fe,ke);break;case"<=":De=se(ee,fe,ke);break;default:throw new TypeError("Invalid operator: "+de)}return De}function ye(ee,de){if(ee instanceof ye){if(ee.loose===de)return ee;ee=ee.value}if(!(this instanceof ye))return new ye(ee,de);r("comparator",ee,de),this.loose=de,this.parse(ee),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(ee,de){return k(de,ee)},e.major=function(ee,de){return new oe(ee,de).major},e.minor=function(ee,de){return new oe(ee,de).minor},e.patch=function(ee,de){return new oe(ee,de).patch},e.compare=W,e.compareLoose=function(ee,de){return W(ee,de,!0)},e.rcompare=function(ee,de,fe){return W(de,ee,fe)},e.sort=function(ee,de){return ee.sort(function(fe,ke){return e.compare(fe,ke,de)})},e.rsort=function(ee,de){return ee.sort(function(fe,ke){return e.rcompare(fe,ke,de)})},e.gt=z,e.lt=H,e.eq=B,e.neq=$,e.gte=G,e.lte=se,e.cmp=ue,e.Comparator=ye;var Ce={};function Re(ee,de){if(ee instanceof Re)return ee.loose===de?ee:new Re(ee.raw,de);if(ee instanceof ye)return new Re(ee.value,de);if(!(this instanceof Re))return new Re(ee,de);if(this.loose=de,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Te(ee,de,fe,ke,De,_e,We,qe,$e,ze,He,Be,X){return((de=Le(fe)?"":Le(ke)?">="+fe+".0.0":Le(De)?">="+fe+"."+ke+".0":">="+de)+" "+(qe=Le($e)?"":Le(ze)?"<"+(+$e+1)+".0.0":Le(He)?"<"+$e+"."+(+ze+1)+".0":Be?"<="+$e+"."+ze+"."+He+"-"+Be:"<="+qe)).trim()}function we(ee,de){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ee.length;fe++)if(r(ee[fe].semver),ee[fe].semver!==Ce&&ee[fe].semver.prerelease.length>0){var ke=ee[fe].semver;if(ke.major===de.major&&ke.minor===de.minor&&ke.patch===de.patch)return!0}return!1}return!0}function ve(ee,de,fe){try{de=new Re(de,fe)}catch{return!1}return de.test(ee)}function Ee(ee,de,fe,ke){var De,_e,We,qe,$e;switch(ee=new oe(ee,ke),de=new Re(de,ke),fe){case">":De=z,_e=se,We=H,qe=">",$e=">=";break;case"<":De=H,_e=G,We=z,qe="<",$e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(ee,de,ke))return!1;for(var ze=0;ze<de.set.length;++ze){var He=de.set[ze],Be=null,X=null;if(He.forEach(function(he){he.semver===Ce&&(he=new ye(">=0.0.0")),Be=Be||he,X=X||he,De(he.semver,Be.semver,ke)?Be=he:We(he.semver,X.semver,ke)&&(X=he)}),Be.operator===qe||Be.operator===$e||(!X.operator||X.operator===qe)&&_e(ee,X.semver)||X.operator===$e&&We(ee,X.semver))return!1}return!0}ye.prototype.parse=function(ee){var de=this.loose?I[K]:I[V],fe=ee.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new oe(fe[2],this.loose):this.semver=Ce},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(ee){return r("Comparator.test",ee,this.loose),this.semver===Ce||(typeof ee=="string"&&(ee=new oe(ee,this.loose)),ue(ee,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(ee,de){if(!(ee instanceof ye))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Re(ee.value,de),ve(this.value,fe,de);if(ee.operator==="")return fe=new Re(this.value,de),ve(ee.semver,fe,de);var ke=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),qe=ue(this.semver,"<",ee.semver,de)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),$e=ue(this.semver,">",ee.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ke||De||_e&&We||qe||$e},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(ee){var de=this.loose;ee=ee.trim(),r("range",ee,de);var fe=de?I[x]:I[T];ee=ee.replace(fe,Te),r("hyphen replace",ee),ee=ee.replace(I[U],"$1$2$3"),r("comparator trim",ee,I[U]),ee=(ee=(ee=ee.replace(I[F],"$1~")).replace(I[ne],"$1^")).split(/\s+/).join(" ");var ke=de?I[K]:I[V],De=ee.split(" ").map(function(_e){return function(We,qe){return r("comp",We),We=function($e,ze){return $e.trim().split(/\s+/).map(function(He){return function(Be,X){r("caret",Be,X);var he=X?I[le]:I[ce];return Be.replace(he,function(ge,me,be,Ae,Ue){var Ge;return r("caret",Be,ge,me,be,Ae,Ue),Le(me)?Ge="":Le(be)?Ge=">="+me+".0.0 <"+(+me+1)+".0.0":Le(Ae)?Ge=me==="0"?">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":">="+me+"."+be+".0 <"+(+me+1)+".0.0":Ue?(r("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=me==="0"?be==="0"?">="+me+"."+be+"."+Ae+Ue+" <"+me+"."+be+"."+(+Ae+1):">="+me+"."+be+"."+Ae+Ue+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+Ae+Ue+" <"+(+me+1)+".0.0"):(r("no pr"),Ge=me==="0"?be==="0"?">="+me+"."+be+"."+Ae+" <"+me+"."+be+"."+(+Ae+1):">="+me+"."+be+"."+Ae+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+Ae+" <"+(+me+1)+".0.0"),r("caret return",Ge),Ge})}(He,ze)}).join(" ")}(We,qe),r("caret",We),We=function($e,ze){return $e.trim().split(/\s+/).map(function(He){return function(Be,X){var he=X?I[re]:I[q];return Be.replace(he,function(ge,me,be,Ae,Ue){var Ge;return r("tilde",Be,ge,me,be,Ae,Ue),Le(me)?Ge="":Le(be)?Ge=">="+me+".0.0 <"+(+me+1)+".0.0":Le(Ae)?Ge=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":Ue?(r("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=">="+me+"."+be+"."+Ae+Ue+" <"+me+"."+(+be+1)+".0"):Ge=">="+me+"."+be+"."+Ae+" <"+me+"."+(+be+1)+".0",r("tilde return",Ge),Ge})}(He,ze)}).join(" ")}(We,qe),r("tildes",We),We=function($e,ze){return r("replaceXRanges",$e,ze),$e.split(/\s+/).map(function(He){return function(Be,X){Be=Be.trim();var he=X?I[b]:I[M];return Be.replace(he,function(ge,me,be,Ae,Ue,Ge){r("xRange",Be,ge,me,be,Ae,Ue,Ge);var Je=Le(be),Ve=Je||Le(Ae),Ye=Ve||Le(Ue);return me==="="&&Ye&&(me=""),Je?ge=me===">"||me==="<"?"<0.0.0":"*":me&&Ye?(Ve&&(Ae=0),Ye&&(Ue=0),me===">"?(me=">=",Ve?(be=+be+1,Ae=0,Ue=0):Ye&&(Ae=+Ae+1,Ue=0)):me==="<="&&(me="<",Ve?be=+be+1:Ae=+Ae+1),ge=me+be+"."+Ae+"."+Ue):Ve?ge=">="+be+".0.0 <"+(+be+1)+".0.0":Ye&&(ge=">="+be+"."+Ae+".0 <"+be+"."+(+Ae+1)+".0"),r("xRange return",ge),ge})}(He,ze)}).join(" ")}(We,qe),r("xrange",We),We=function($e,ze){return r("replaceStars",$e,ze),$e.trim().replace(I[Q],"")}(We,qe),r("stars",We),We}(_e,de)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(_e){return!!_e.match(ke)})),De=De.map(function(_e){return new ye(_e,de)})},Re.prototype.intersects=function(ee,de){if(!(ee instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(ke){return ee.set.some(function(De){return De.every(function(_e){return ke.intersects(_e,de)})})})})},e.toComparators=function(ee,de){return new Re(ee,de).set.map(function(fe){return fe.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new oe(ee,this.loose));for(var de=0;de<this.set.length;de++)if(we(this.set[de],ee))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(ee,de,fe){var ke=null,De=null;try{var _e=new Re(de,fe)}catch{return null}return ee.forEach(function(We){_e.test(We)&&(ke&&De.compare(We)!==-1||(De=new oe(ke=We,fe)))}),ke},e.minSatisfying=function(ee,de,fe){var ke=null,De=null;try{var _e=new Re(de,fe)}catch{return null}return ee.forEach(function(We){_e.test(We)&&(ke&&De.compare(We)!==1||(De=new oe(ke=We,fe)))}),ke},e.validRange=function(ee,de){try{return new Re(ee,de).range||"*"}catch{return null}},e.ltr=function(ee,de,fe){return Ee(ee,de,"<",fe)},e.gtr=function(ee,de,fe){return Ee(ee,de,">",fe)},e.outside=Ee,e.prerelease=function(ee,de){var fe=ae(ee,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,de,fe){return ee=new Re(ee,fe),de=new Re(de,fe),ee.intersects(de)},e.coerce=function(ee){if(ee instanceof oe)return ee;if(typeof ee!="string")return null;var de=ee.match(I[A]);return de==null?null:ae((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,E(1))},function(j,e){var E,L,r=j.exports={};function _(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function I(s){if(E===setTimeout)return setTimeout(s,0);if((E===_||!E)&&setTimeout)return E=setTimeout,setTimeout(s,0);try{return E(s,0)}catch{try{return E.call(null,s,0)}catch{return E.call(this,s,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:_}catch{E=_}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var h,c=[],v=!1,m=-1;function S(){v&&h&&(v=!1,h.length?c=h.concat(c):m=-1,c.length&&u())}function u(){if(!v){var s=I(S);v=!0;for(var w=c.length;w;){for(h=c,c=[];++m<w;)h&&h[m].run();m=-1,w=c.length}h=null,v=!1,function(a){if(L===clearTimeout)return clearTimeout(a);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(a);try{L(a)}catch{try{return L.call(null,a)}catch{return L.call(this,a)}}}(s)}}function y(s,w){this.fun=s,this.array=w}function p(){}r.nextTick=function(s){var w=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)w[a-1]=arguments[a];c.push(new y(s,w)),c.length!==1||v||I(u)},y.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=p,r.addListener=p,r.once=p,r.off=p,r.removeListener=p,r.removeAllListeners=p,r.emit=p,r.prependListener=p,r.prependOnceListener=p,r.listeners=function(s){return[]},r.binding=function(s){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(s){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(te[138],ie([0,1]),function(j,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(I,h,c){this.level=I,this.key=h,this.value=c,this.forward=[]}}const r=void 0;class _{constructor(I,h=2**16){this.comparator=I,this[E]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r)}has(I){return!!_._search(this,I,this.comparator)}get(I){return _._search(this,I,this.comparator)?.value}set(I,h){return _._insert(this,I,h,this.comparator)&&(this._size+=1),this}delete(I){const h=_._delete(this,I,this.comparator);return h&&(this._size-=1),h}forEach(I,h){let c=this._header.forward[0];for(;c;)I.call(h,c.value,c.key,this),c=c.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",h=this._header.forward[0];for(;h;)I+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return I}static _search(I,h,c){let v=I._header;for(let m=I._level-1;m>=0;m--)for(;v.forward[m]&&c(v.forward[m].key,h)<0;)v=v.forward[m];if(v=v.forward[0],v&&c(v.key,h)===0)return v}static _insert(I,h,c,v){const m=[];let S=I._header;for(let u=I._level-1;u>=0;u--){for(;S.forward[u]&&v(S.forward[u].key,h)<0;)S=S.forward[u];m[u]=S}if(S=S.forward[0],S&&v(S.key,h)===0)return S.value=c,!1;{const u=_._randomLevel(I);if(u>I._level){for(let y=I._level;y<u;y++)m[y]=I._header;I._level=u}S=new L(u,h,c);for(let y=0;y<u;y++)S.forward[y]=m[y].forward[y],m[y].forward[y]=S;return!0}}static _randomLevel(I,h=.5){let c=1;for(;Math.random()<h&&c<I._maxLevel;)c+=1;return c}static _delete(I,h,c){const v=[];let m=I._header;for(let S=I._level-1;S>=0;S--){for(;m.forward[S]&&c(m.forward[S].key,h)<0;)m=m.forward[S];v[S]=m}if(m=m.forward[0],!m||c(m.key,h)!==0)return!1;for(let S=0;S<I._level&&v[S].forward[S]===m;S++)v[S].forward[S]=m.forward[S];for(;I._level>0&&I._header.forward[I._level-1]===r;)I._level-=1;return!0}}e.SkipList=_}),define(te[61],ie([0,1,13,2]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(P){const C=P;return C?typeof C.read=="function":!1}e.isReadable=r;function _(P){const C=P;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=_;function R(P){const C=P;return C?_(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=R;function I(P,C){return new h(P,C)}e.newWriteableStream=I;class h{constructor(C,t){this.reducer=C,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(t=>t(C))}emitError(C){this.listeners.error.length===0?(0,E.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(t=>t(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,t){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(C,t){if(this.state.destroyed)return;let l;switch(C){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const n=l.indexOf(t);n>=0&&l.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(P,C){const t=[];let l;for(;(l=P.read())!==null;)t.push(l);return C(t)}e.consumeReadable=c;function v(P,C,t){const l=[];let n;for(;(n=P.read())!==null&&l.length<t;)l.push(n);return n===null&&l.length>0?C(l):{read:()=>{if(l.length>0)return l.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return P.read()}}}e.peekReadable=v;function m(P,C){return new Promise((t,l)=>{const n=[];S(P,{onData:i=>{C&&n.push(i)},onError:i=>{C?l(i):t(void 0)},onEnd:()=>{t(C?C(n):void 0)}})})}e.consumeStream=m;function S(P,C){let t=!1;return P.on("error",l=>{t||C.onError(l)}),P.on("end",()=>{t||C.onEnd()}),P.on("data",l=>{t||C.onData(l)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=S;function u(P,C){return new Promise((t,l)=>{const n=new L.DisposableStore,i=[],o=D=>{if(i.push(D),i.length>C)return n.dispose(),P.pause(),t({stream:P,buffer:i,ended:!1})},d=D=>l(D),g=()=>t({stream:P,buffer:i,ended:!0});n.add((0,L.toDisposable)(()=>P.removeListener("error",d))),P.on("error",d),n.add((0,L.toDisposable)(()=>P.removeListener("end",g))),P.on("end",g),n.add((0,L.toDisposable)(()=>P.removeListener("data",o))),P.on("data",o)})}e.peekStream=u;function y(P,C){const t=I(C);return t.end(P),t}e.toStream=y;function p(){const P=I(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=p;function s(P){let C=!1;return{read:()=>C?null:(C=!0,P)}}e.toReadable=s;function w(P,C,t){const l=I(t);return S(P,{onData:n=>l.write(C.data(n)),onError:n=>l.error(C.error?C.error(n):n),onEnd:()=>l.end()}),l}e.transform=w;function a(P,C,t){let l=!1;return{read:()=>{const n=C.read();return l?n:(l=!0,n!==null?t([P,n]):P)}}}e.prefixedReadable=a;function f(P,C,t){let l=!1;const n=I(t);return S(C,{onData:i=>l?n.write(i):(l=!0,n.write(t([P,i]))),onError:i=>n.error(i),onEnd:()=>{l||(l=!0,n.write(P)),n.end()}}),n}e.prefixedStream=f}),define(te[17],ie([0,1,100,61]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u",_=new E.Lazy(()=>new Uint8Array(256));let R,I;class h{static alloc(b){return r?new h(Buffer.allocUnsafe(b)):new h(new Uint8Array(b))}static wrap(b){return r&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new h(b)}static fromString(b,A){return!(A?.dontUseNodeBuffer||!1)&&r?new h(Buffer.from(b)):(R||(R=new TextEncoder),new h(R.encode(b)))}static fromByteArray(b){const A=h.alloc(b.length);for(let O=0,F=b.length;O<F;O++)A.buffer[O]=b[O];return A}static concat(b,A){if(typeof A>"u"){A=0;for(let q=0,re=b.length;q<re;q++)A+=b[q].byteLength}const O=h.alloc(A);let F=0;for(let q=0,re=b.length;q<re;q++){const Y=b[q];O.set(Y,F),F+=Y.byteLength}return O}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=h.alloc(this.byteLength);return b.set(this),b}toString(){return r?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(b,A){return new h(this.buffer.subarray(b,A))}set(b,A){if(b instanceof h)this.buffer.set(b.buffer,A);else if(b instanceof Uint8Array)this.buffer.set(b,A);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),A);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return m(this.buffer,b)}writeUInt32BE(b,A){S(this.buffer,b,A)}readUInt32LE(b){return u(this.buffer,b)}writeUInt32LE(b,A){y(this.buffer,b,A)}readUInt8(b){return p(this.buffer,b)}writeUInt8(b,A){s(this.buffer,b,A)}indexOf(b){const A=b instanceof h?b.buffer:b,O=A.byteLength,F=this.buffer,q=F.byteLength;if(O===0)return 0;if(O===1)return F.indexOf(A[0]);if(O>q)return-1;const re=_.value;re.fill(A.length);for(let le=0;le<A.length;le++)re[A[le]]=A.length-le-1;let Y=A.length-1,ne=Y,ce=-1;for(;Y<q;)if(F[Y]===A[ne]){if(ne===0){ce=Y;break}Y--,ne--}else Y+=Math.max(A.length-ne,re[F[Y]]),ne=A.length-1;return ce}}e.VSBuffer=h;function c(M,b){return M[b+0]<<0>>>0|M[b+1]<<8>>>0}e.readUInt16LE=c;function v(M,b,A){M[A+0]=b&255,b=b>>>8,M[A+1]=b&255}e.writeUInt16LE=v;function m(M,b){return M[b]*2**24+M[b+1]*2**16+M[b+2]*2**8+M[b+3]}e.readUInt32BE=m;function S(M,b,A){M[A+3]=b,b=b>>>8,M[A+2]=b,b=b>>>8,M[A+1]=b,b=b>>>8,M[A]=b}e.writeUInt32BE=S;function u(M,b){return M[b+0]<<0>>>0|M[b+1]<<8>>>0|M[b+2]<<16>>>0|M[b+3]<<24>>>0}e.readUInt32LE=u;function y(M,b,A){M[A+0]=b&255,b=b>>>8,M[A+1]=b&255,b=b>>>8,M[A+2]=b&255,b=b>>>8,M[A+3]=b&255}e.writeUInt32LE=y;function p(M,b){return M[b]}e.readUInt8=p;function s(M,b,A){M[A]=b}e.writeUInt8=s;function w(M){return L.consumeReadable(M,b=>h.concat(b))}e.readableToBuffer=w;function a(M){return L.toReadable(M)}e.bufferToReadable=a;function f(M){return L.consumeStream(M,b=>h.concat(b))}e.streamToBuffer=f;async function P(M){return M.ended?h.concat(M.buffer):h.concat([...M.buffer,await f(M.stream)])}e.bufferedStreamToBuffer=P;function C(M){return L.toStream(M,b=>h.concat(b))}e.bufferToStream=C;function t(M){return L.transform(M,{data:b=>typeof b=="string"?h.fromString(b):h.wrap(b)},b=>h.concat(b))}e.streamToBufferReadableStream=t;function l(M){return L.newWriteableStream(b=>h.concat(b),M)}e.newWriteableBufferStream=l;function n(M,b){return L.prefixedReadable(M,b,A=>h.concat(A))}e.prefixedBufferReadable=n;function i(M,b){return L.prefixedStream(M,b,A=>h.concat(A))}e.prefixedBufferStream=i;function o(M){let b=0,A=0,O=0;const F=new Uint8Array(Math.floor(M.length/4*3)),q=Y=>{switch(A){case 3:F[O++]=b|Y,A=0;break;case 2:F[O++]=b|Y>>>2,b=Y<<6,A=3;break;case 1:F[O++]=b|Y>>>4,b=Y<<4,A=2;break;default:b=Y<<2,A=1}};for(let Y=0;Y<M.length;Y++){const ne=M.charCodeAt(Y);if(ne>=65&&ne<=90)q(ne-65);else if(ne>=97&&ne<=122)q(ne-97+26);else if(ne>=48&&ne<=57)q(ne-48+52);else if(ne===43||ne===45)q(62);else if(ne===47||ne===95)q(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${M[Y]}`)}}const re=O;for(;A>0;)q(0);return h.wrap(F).slice(0,re)}e.decodeBase64=o;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:M},b=!0,A=!1){const O=A?g:d;let F="";const q=M.byteLength%3;let re=0;for(;re<M.byteLength-q;re+=3){const Y=M[re+0],ne=M[re+1],ce=M[re+2];F+=O[Y>>>2],F+=O[(Y<<4|ne>>>4)&63],F+=O[(ne<<2|ce>>>6)&63],F+=O[ce&63]}if(q===1){const Y=M[re+0];F+=O[Y>>>2],F+=O[Y<<4&63],b&&(F+="==")}else if(q===2){const Y=M[re+0],ne=M[re+1];F+=O[Y>>>2],F+=O[(Y<<4|ne>>>4)&63],F+=O[ne<<2&63],b&&(F+="=")}return F}e.encodeBase64=D}),define(te[139],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(te[11],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(l){return typeof l=="string"}e.isString=E;function L(l){return Array.isArray(l)&&l.every(n=>E(n))}e.isStringArray=L;function r(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=r;function _(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}e.isTypedArray=_;function R(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=R;function I(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=I;function h(l){return l===!0||l===!1}e.isBoolean=h;function c(l){return typeof l>"u"}e.isUndefined=c;function v(l){return!m(l)}e.isDefined=v;function m(l){return c(l)||l===null}e.isUndefinedOrNull=m;function S(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=S;function u(l){if(m(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=u;function y(...l){const n=[];for(let i=0;i<l.length;i++){const o=l[i];if(m(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.assertAllDefined=y;const p=Object.prototype.hasOwnProperty;function s(l){if(!r(l))return!1;for(const n in l)if(p.call(l,n))return!1;return!0}e.isEmptyObject=s;function w(l){return typeof l=="function"}e.isFunction=w;function a(...l){return l.length>0&&l.every(w)}e.areFunctions=a;function f(l,n){const i=Math.min(l.length,n.length);for(let o=0;o<i;o++)P(l[o],n[o])}e.validateConstraints=f;function P(l,n){if(E(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(w(n)){try{if(l instanceof n)return}catch{}if(!m(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=P;function C(l){return l===null?void 0:l}e.withNullAsUndefined=C;function t(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=t}),define(te[69],ie([0,1,11]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(I,h){if((0,E.isString)(h)){const c=L[h];if(c===void 0)throw new Error(`${I} references an unknown codicon: ${h}`);h=c}return L[I]=h,{id:I}}function _(){return L}e.getCodiconFontCharacters=_;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,11]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const a=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([f,P])=>{a[f]=P&&typeof P=="object"?L(P):P}),a}e.deepClone=L;function r(w){if(!w||typeof w!="object")return w;const a=[w];for(;a.length>0;){const f=a.shift();Object.freeze(f);for(const P in f)if(_.call(f,P)){const C=f[P];typeof C=="object"&&!Object.isFrozen(C)&&!(0,E.isTypedArray)(C)&&a.push(C)}}return w}e.deepFreeze=r;const _=Object.prototype.hasOwnProperty;function R(w,a){return I(w,a,new Set)}e.cloneAndChange=R;function I(w,a,f){if((0,E.isUndefinedOrNull)(w))return w;const P=a(w);if(typeof P<"u")return P;if(Array.isArray(w)){const C=[];for(const t of w)C.push(I(t,a,f));return C}if((0,E.isObject)(w)){if(f.has(w))throw new Error("Cannot clone recursive data-structure");f.add(w);const C={};for(const t in w)_.call(w,t)&&(C[t]=I(w[t],a,f));return f.delete(w),C}return w}function h(w,a,f=!0){return(0,E.isObject)(w)?((0,E.isObject)(a)&&Object.keys(a).forEach(P=>{P in w?f&&((0,E.isObject)(w[P])&&(0,E.isObject)(a[P])?h(w[P],a[P],f):w[P]=a[P]):w[P]=a[P]}),w):a}e.mixin=h;function c(w,a){if(w===a)return!0;if(w==null||a===null||a===void 0||typeof w!=typeof a||typeof w!="object"||Array.isArray(w)!==Array.isArray(a))return!1;let f,P;if(Array.isArray(w)){if(w.length!==a.length)return!1;for(f=0;f<w.length;f++)if(!c(w[f],a[f]))return!1}else{const C=[];for(P in w)C.push(P);C.sort();const t=[];for(P in a)t.push(P);if(t.sort(),!c(C,t))return!1;for(f=0;f<C.length;f++)if(!c(w[C[f]],a[C[f]]))return!1}return!0}e.equals=c;function v(w){const a=new Set;return JSON.stringify(w,(f,P)=>{if((0,E.isObject)(P)||Array.isArray(P)){if(a.has(P))return"[Circular]";a.add(P)}return P})}e.safeStringify=v;function m(w,a){const f=Object.create(null);return!w||!a||Object.keys(a).forEach(C=>{const t=w[C],l=a[C];c(t,l)||(f[C]=l)}),f}e.distinct=m;function S(w,a){const f=a.toLowerCase(),P=Object.keys(w).find(C=>C.toLowerCase()===f);return P?w[P]:w[a]}e.getCaseInsensitive=S;function u(w,a){const f=Object.create(null);for(const[P,C]of Object.entries(w))a(P,C)&&(f[P]=C);return f}e.filter=u;function y(w){let a=[],f=Object.getPrototypeOf(w);for(;Object.prototype!==f;)a=a.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return a}e.getAllPropertyNames=y;function p(w){const a=[];for(const f of y(w))typeof w[f]=="function"&&a.push(f);return a}e.getAllMethodNames=p;function s(w,a){const f=C=>function(){const t=Array.prototype.slice.call(arguments,0);return a(C,t)},P={};for(const C of w)P[C]=f(C);return P}e.createProxyObject=s}),define(te[102],ie([0,1,69]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(R){function I(h){return h&&typeof h=="object"&&typeof h.id=="string"}R.isThemeColor=I})(L||(e.ThemeColor=L={}));function r(R){return{id:R}}e.themeColorFromId=r;var _;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function h(a){const f=I.exec(a.id);if(!f)return h(E.Codicon.error);const[,P,C]=f,t=["codicon","codicon-"+P];return C&&t.push("codicon-modifier-"+C.substring(1)),t}R.asClassNameArray=h;function c(a){return h(a).join(" ")}R.asClassName=c;function v(a){return"."+h(a).join(".")}R.asCSSSelector=v;function m(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||L.isThemeColor(a.color))}R.isThemeIcon=m;const S=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function u(a){const f=S.exec(a);if(!f)return;const[,P]=f;return{id:P}}R.fromString=u;function y(a){return{id:a}}R.fromId=y;function p(a,f){let P=a.id;const C=P.lastIndexOf("~");return C!==-1&&(P=P.substring(0,C)),f&&(P=`${P}~${f}`),{id:P}}R.modify=p;function s(a){const f=a.id.lastIndexOf("~");if(f!==-1)return a.id.substring(f+1)}R.getModifier=s;function w(a,f){return a.id===f.id&&a.color?.id===f.color?.id}R.isEqual=w})(_||(e.ThemeIcon=_={}))}),define(te[31],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return E.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(I){for(let h=0;h<I.length;h++)I[h]=Math.floor(Math.random()*256);return I};const _=new Uint8Array(16),R=[];for(let I=0;I<256;I++)R.push(I.toString(16).padStart(2,"0"));return function(){r(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let h=0,c="";return c+=R[_[h++]],c+=R[_[h++]],c+=R[_[h++]],c+=R[_[h++]],c+="-",c+=R[_[h++]],c+=R[_[h++]],c+="-",c+=R[_[h++]],c+=R[_[h++]],c+="-",c+=R[_[h++]],c+=R[_[h++]],c+="-",c+=R[_[h++]],c+=R[_[h++]],c+=R[_[h++]],c+=R[_[h++]],c+=R[_[h++]],c+=R[_[h++]],c}}()}),define(te[140],ie([0,1,70,42,49]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function _(R,I){if(await new Promise((v,m)=>{const S=L.createReadStream(R),u=E.createHash("sha1");S.pipe(u);const y=(0,r.once)((p,s)=>{S.removeAllListeners(),u.removeAllListeners(),p?m(p):v(s)});S.once("error",y),S.once("end",y),u.once("error",y),u.once("data",p=>y(void 0,p.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=_}),define(te[141],ie([0,1,27]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(R){const I=R.replace(/\-/g,":").toLowerCase();return!L.has(I)}function _(){const R=(0,E.networkInterfaces)();for(const I in R){const h=R[I];if(h){for(const{mac:c}of h)if(r(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(te[103],ie([0,1,84]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(I,h,c,v=1){let m=!1;return new Promise(S=>{const u=setTimeout(()=>{if(!m)return m=!0,S(0)},c);r(I,h,v,y=>{if(!m)return m=!0,clearTimeout(u),S(y)})})}e.findFreePort=L;function r(I,h,c,v){if(h===0)return v(0);const m=new E.Socket;m.once("connect",()=>(R(m),r(I+c,h-1,c,v))),m.once("data",()=>{}),m.once("error",S=>(R(m),S.code!=="ECONNREFUSED"?r(I+c,h-1,c,v):v(I))),m.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(I,h,c,v="127.0.0.1"){let m=!1,S,u=1;const y=E.createServer({pauseOnConnect:!0});function p(s,w){m||(m=!0,y.removeAllListeners(),y.close(),S&&clearTimeout(S),w(s))}return new Promise(s=>{S=setTimeout(()=>{p(0,s)},c),y.on("listening",()=>{p(I,s)}),y.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&u<h?(I++,u++,y.listen(I,v)):p(0,s)}),y.on("close",()=>{p(0,s)}),y.listen(I,v)})}e.findFreePortFaster=_;function R(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(h){console.error(h)}}}),function(){function j(){function e(){return process.uncHostAllowlist}function E(h){const c=new Set;if(Array.isArray(h))for(const v of h)typeof v=="string"&&c.add(v);return Array.from(c)}function L(){const h=e();return h?Array.from(h):[]}function r(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const v of E(h))r(v)}function _(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let v;for(const m of c){if(h.indexOf(m)!==0)continue;const u=h.indexOf("\\",m.length);if(u===-1)continue;const y=h.substring(m.length,u);if(y){v=y;break}}return v}function R(){process.platform==="win32"&&(process.enableUNCAccessChecks=!1)}function I(){return process.platform!=="win32"?!0:process.enableUNCAccessChecks===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:r,getUNCHost:_,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return j()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[142],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[143],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(r,_){this.sender=r,this.onMessage=_}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=E}),define(te[38],ie([0,1,15,13]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class r{constructor(){this.mapListenerToWrapper=new WeakMap}on(R,I){const h=(c,...v)=>{this.validateEvent(R,c)&&I(c,...v)};return this.mapListenerToWrapper.set(I,h),E.ipcMain.on(R,h),this}once(R,I){return E.ipcMain.once(R,(h,...c)=>{this.validateEvent(R,h)&&I(h,...c)}),this}handle(R,I){return E.ipcMain.handle(R,(h,...c)=>this.validateEvent(R,h)?I(h,...c):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return E.ipcMain.removeHandler(R),this}removeListener(R,I){const h=this.mapListenerToWrapper.get(I);return h&&(E.ipcMain.removeListener(R,h),this.mapListenerToWrapper.delete(I)),this}validateEvent(R,I){if(!R||!R.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const h=I.senderFrame,c=h.url;if(!c)return!0;let v="unknown";try{v=new URL(c).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${c}'.`),!1}return v!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${v}'.`),!1):h.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new r}),define(te[144],ie([0,1,15,38,11,142]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){L.validatedIpcMain.on(_.CONTEXT_MENU_CHANNEL,(h,c,v,m,S)=>{const u=I(h,m,v);u.popup({window:(0,r.withNullAsUndefined)(E.BrowserWindow.fromWebContents(h.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{u&&h.sender.send(_.CONTEXT_MENU_CLOSE_CHANNEL,c)}})})}e.registerContextMenuListener=R;function I(h,c,v){const m=new E.Menu;return v.forEach(S=>{let u;S.type==="separator"?u=new E.MenuItem({type:S.type}):Array.isArray(S.submenu)?u=new E.MenuItem({submenu:I(h,c,S.submenu),label:S.label}):u=new E.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(y,p,s)=>h.sender.send(c,S.id,s)}),m.append(u)}),m}}),define(te[145],ie([12,10]),function(j,e){return j.create("vs/base/common/date",e)}),define(te[146],ie([0,1,145]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,r=L*60,_=r*24,R=_*7,I=_*30,h=_*365;function c(m,S,u,y){typeof m!="number"&&(m=m.getTime());const p=Math.round((new Date().getTime()-m)/1e3);if(p<-30)return(0,E.localize)(0,null,c(new Date().getTime()+p*1e3,!1));if(!y&&p<30)return(0,E.localize)(1,null);let s;return p<L?(s=p,S?s===1?u?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):u?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s):s===1?u?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):u?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):p<r?(s=Math.floor(p/L),S?s===1?u?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):u?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s):s===1?u?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):u?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):p<_?(s=Math.floor(p/r),S?s===1?u?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):u?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s):s===1?u?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):u?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):p<R?(s=Math.floor(p/_),S?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s)):p<I?(s=Math.floor(p/R),S?s===1?u?(0,E.localize)(30,null,s):(0,E.localize)(31,null,s):u?(0,E.localize)(32,null,s):(0,E.localize)(33,null,s):s===1?u?(0,E.localize)(34,null,s):(0,E.localize)(35,null,s):u?(0,E.localize)(36,null,s):(0,E.localize)(37,null,s)):p<h?(s=Math.floor(p/I),S?s===1?u?(0,E.localize)(38,null,s):(0,E.localize)(39,null,s):u?(0,E.localize)(40,null,s):(0,E.localize)(41,null,s):s===1?u?(0,E.localize)(42,null,s):(0,E.localize)(43,null,s):u?(0,E.localize)(44,null,s):(0,E.localize)(45,null,s)):(s=Math.floor(p/h),S?s===1?u?(0,E.localize)(46,null,s):(0,E.localize)(47,null,s):u?(0,E.localize)(48,null,s):(0,E.localize)(49,null,s):s===1?u?(0,E.localize)(50,null,s):(0,E.localize)(51,null,s):u?(0,E.localize)(52,null,s):(0,E.localize)(53,null,s))}e.fromNow=c;function v(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=v}),define(te[147],ie([12,10]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,24,11,147]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function _(m,S){return S&&(m.stack||m.stacktrace)?r.localize(0,null,I(m),R(m.stack)||R(m.stacktrace)):I(m)}function R(m){return Array.isArray(m)?m.join(`
`):m}function I(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?r.localize(1,null,m.message):m.message||r.localize(2,null)}function h(m=null,S=!1){if(!m)return r.localize(3,null);if(Array.isArray(m)){const u=E.coalesce(m),y=h(u[0],S);return u.length>1?r.localize(4,null,y,u.length):y}if(L.isString(m))return m;if(m.detail){const u=m.detail;if(u.error)return _(u.error,S);if(u.exception)return _(u.exception,S)}return m.stack?_(m,S):m.message?m.message:r.localize(5,null)}e.toErrorMessage=h;function c(m){const S=m;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=c;function v(m,S){let u;return typeof m=="string"?u=new Error(m):u=m,u.actions=S,u}e.createErrorWithActions=v}),define(te[148],ie([12,10]),function(j,e){return j.create("vs/base/common/jsonErrorMessages",e)}),define(te[149],ie([0,1,148]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(te[150],ie([12,10]),function(j,e){return j.create("vs/base/common/platform",e)}),define(te[3],ie([0,1,150]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,_=!1,R=!1,I=!1,h=!1,c=!1,v=!1,m=!1,S=!1,u,y=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,s,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?a=e.globals.vscode.process:typeof process<"u"&&(a=process);const f=typeof a?.versions?.electron=="string",P=f&&a?.type==="renderer";if(typeof navigator=="object"&&!P)w=navigator.userAgent,L=w.indexOf("Windows")>=0,r=w.indexOf("Macintosh")>=0,v=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=w.indexOf("Linux")>=0,S=w?.indexOf("Mobi")>=0,h=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,y=u,p=navigator.language;else if(typeof a=="object"){L=a.platform==="win32",r=a.platform==="darwin",_=a.platform==="linux",R=_&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,c=f,m=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const D=a.env.VSCODE_NLS_CONFIG;if(D)try{const M=JSON.parse(D),b=M.availableLanguages["*"];u=M.locale,p=M.osLocale,y=b||e.LANGUAGE_DEFAULT,s=M._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var C;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(C||(e.Platform=C={}));function t(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let l=0;r?l=1:L?l=3:_&&(l=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=_,e.isLinuxSnap=R,e.isNative=I,e.isElectron=c,e.isWeb=h,e.isWebWorker=h&&typeof e.globals.importScripts=="function",e.isIOS=v,e.isMobile=S,e.isCI=m,e.platform=l,e.userAgent=w,e.language=y;var n;(function(D){function M(){return e.language}D.value=M;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=b;function A(){return e.language==="en"}D.isDefault=A})(n||(e.Language=n={})),e.locale=u,e.platformLocale=p,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let A=0,O=D.length;A<O;A++){const F=D[A];if(F.id===b.data.vscodeScheduleAsyncWork){D.splice(A,1),F.callback();return}}});let M=0;return b=>{const A=++M;D.push({id:A,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return D=>setTimeout(D)})();var i;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||v?2:L?1:3;let o=!0,d=!1;function g(){if(!d){d=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,o=new Uint16Array(D.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=g,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[36],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const r=E.globals.vscode.process;L={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(te[9],ie([0,1,36]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,_=90,R=122,I=46,h=47,c=92,v=58,m=63;class S extends Error{constructor(l,n,i){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const d=l.indexOf(".")!==-1?"property":"argument";let g=`The "${l}" ${d} ${o} of type ${n}`;g+=`. Received type ${typeof i}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,l){if(t===null||typeof t!="object")throw new S(l,"Object",t)}function y(t,l){if(typeof t!="string")throw new S(l,"string",t)}const p=E.platform==="win32";function s(t){return t===h||t===c}function w(t){return t===h}function a(t){return t>=L&&t<=_||t>=r&&t<=R}function f(t,l,n,i){let o="",d=0,g=-1,D=0,M=0;for(let b=0;b<=t.length;++b){if(b<t.length)M=t.charCodeAt(b);else{if(i(M))break;M=h}if(i(M)){if(!(g===b-1||D===1))if(D===2){if(o.length<2||d!==2||o.charCodeAt(o.length-1)!==I||o.charCodeAt(o.length-2)!==I){if(o.length>2){const A=o.lastIndexOf(n);A===-1?(o="",d=0):(o=o.slice(0,A),d=o.length-1-o.lastIndexOf(n)),g=b,D=0;continue}else if(o.length!==0){o="",d=0,g=b,D=0;continue}}l&&(o+=o.length>0?`${n}..`:"..",d=2)}else o.length>0?o+=`${n}${t.slice(g+1,b)}`:o=t.slice(g+1,b),d=b-g-1;g=b,D=0}else M===I&&D!==-1?++D:D=-1}return o}function P(t,l){u(l,"pathObject");const n=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return n?n===l.root?`${n}${i}`:`${n}${t}${i}`:i}e.win32={resolve(...t){let l="",n="",i=!1;for(let o=t.length-1;o>=-1;o--){let d;if(o>=0){if(d=t[o],y(d,"path"),d.length===0)continue}else l.length===0?d=E.cwd():(d=E.env[`=${l}`]||E.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==l.toLowerCase()&&d.charCodeAt(2)===c)&&(d=`${l}\\`));const g=d.length;let D=0,M="",b=!1;const A=d.charCodeAt(0);if(g===1)s(A)&&(D=1,b=!0);else if(s(A))if(b=!0,s(d.charCodeAt(1))){let O=2,F=O;for(;O<g&&!s(d.charCodeAt(O));)O++;if(O<g&&O!==F){const q=d.slice(F,O);for(F=O;O<g&&s(d.charCodeAt(O));)O++;if(O<g&&O!==F){for(F=O;O<g&&!s(d.charCodeAt(O));)O++;(O===g||O!==F)&&(M=`\\\\${q}\\${d.slice(F,O)}`,D=O)}}}else D=1;else a(A)&&d.charCodeAt(1)===v&&(M=d.slice(0,2),D=2,g>2&&s(d.charCodeAt(2))&&(b=!0,D=3));if(M.length>0)if(l.length>0){if(M.toLowerCase()!==l.toLowerCase())continue}else l=M;if(i){if(l.length>0)break}else if(n=`${d.slice(D)}\\${n}`,i=b,b&&l.length>0)break}return n=f(n,!i,"\\",s),i?`${l}\\${n}`:`${l}${n}`||"."},normalize(t){y(t,"path");const l=t.length;if(l===0)return".";let n=0,i,o=!1;const d=t.charCodeAt(0);if(l===1)return w(d)?"\\":t;if(s(d))if(o=!0,s(t.charCodeAt(1))){let D=2,M=D;for(;D<l&&!s(t.charCodeAt(D));)D++;if(D<l&&D!==M){const b=t.slice(M,D);for(M=D;D<l&&s(t.charCodeAt(D));)D++;if(D<l&&D!==M){for(M=D;D<l&&!s(t.charCodeAt(D));)D++;if(D===l)return`\\\\${b}\\${t.slice(M)}\\`;D!==M&&(i=`\\\\${b}\\${t.slice(M,D)}`,n=D)}}}else n=1;else a(d)&&t.charCodeAt(1)===v&&(i=t.slice(0,2),n=2,l>2&&s(t.charCodeAt(2))&&(o=!0,n=3));let g=n<l?f(t.slice(n),!o,"\\",s):"";return g.length===0&&!o&&(g="."),g.length>0&&s(t.charCodeAt(l-1))&&(g+="\\"),i===void 0?o?`\\${g}`:g:o?`${i}\\${g}`:`${i}${g}`},isAbsolute(t){y(t,"path");const l=t.length;if(l===0)return!1;const n=t.charCodeAt(0);return s(n)||l>2&&a(n)&&t.charCodeAt(1)===v&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,n;for(let d=0;d<t.length;++d){const g=t[d];y(g,"path"),g.length>0&&(l===void 0?l=n=g:l+=`\\${g}`)}if(l===void 0)return".";let i=!0,o=0;if(typeof n=="string"&&s(n.charCodeAt(0))){++o;const d=n.length;d>1&&s(n.charCodeAt(1))&&(++o,d>2&&(s(n.charCodeAt(2))?++o:i=!1))}if(i){for(;o<l.length&&s(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l)return"";const n=e.win32.resolve(t),i=e.win32.resolve(l);if(n===i||(t=n.toLowerCase(),l=i.toLowerCase(),t===l))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===c;)o++;let d=t.length;for(;d-1>o&&t.charCodeAt(d-1)===c;)d--;const g=d-o;let D=0;for(;D<l.length&&l.charCodeAt(D)===c;)D++;let M=l.length;for(;M-1>D&&l.charCodeAt(M-1)===c;)M--;const b=M-D,A=g<b?g:b;let O=-1,F=0;for(;F<A;F++){const re=t.charCodeAt(o+F);if(re!==l.charCodeAt(D+F))break;re===c&&(O=F)}if(F!==A){if(O===-1)return i}else{if(b>A){if(l.charCodeAt(D+F)===c)return i.slice(D+F+1);if(F===2)return i.slice(D+F)}g>A&&(t.charCodeAt(o+F)===c?O=F:F===2&&(O=3)),O===-1&&(O=0)}let q="";for(F=o+O+1;F<=d;++F)(F===d||t.charCodeAt(F)===c)&&(q+=q.length===0?"..":"\\..");return D+=O,q.length>0?`${q}${i.slice(D,M)}`:(i.charCodeAt(D)===c&&++D,i.slice(D,M))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.win32.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===c){if(l.charCodeAt(1)===c){const n=l.charCodeAt(2);if(n!==m&&n!==I)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(a(l.charCodeAt(0))&&l.charCodeAt(1)===v&&l.charCodeAt(2)===c)return`\\\\?\\${l}`;return t},dirname(t){y(t,"path");const l=t.length;if(l===0)return".";let n=-1,i=0;const o=t.charCodeAt(0);if(l===1)return s(o)?t:".";if(s(o)){if(n=i=1,s(t.charCodeAt(1))){let D=2,M=D;for(;D<l&&!s(t.charCodeAt(D));)D++;if(D<l&&D!==M){for(M=D;D<l&&s(t.charCodeAt(D));)D++;if(D<l&&D!==M){for(M=D;D<l&&!s(t.charCodeAt(D));)D++;if(D===l)return t;D!==M&&(n=i=D+1)}}}}else a(o)&&t.charCodeAt(1)===v&&(n=l>2&&s(t.charCodeAt(2))?3:2,i=n);let d=-1,g=!0;for(let D=l-1;D>=i;--D)if(s(t.charCodeAt(D))){if(!g){d=D;break}}else g=!1;if(d===-1){if(n===-1)return".";d=n}return t.slice(0,d)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let n=0,i=-1,o=!0,d;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===v&&(n=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let g=l.length-1,D=-1;for(d=t.length-1;d>=n;--d){const M=t.charCodeAt(d);if(s(M)){if(!o){n=d+1;break}}else D===-1&&(o=!1,D=d+1),g>=0&&(M===l.charCodeAt(g)?--g===-1&&(i=d):(g=-1,i=D))}return n===i?i=D:i===-1&&(i=t.length),t.slice(n,i)}for(d=t.length-1;d>=n;--d)if(s(t.charCodeAt(d))){if(!o){n=d+1;break}}else i===-1&&(o=!1,i=d+1);return i===-1?"":t.slice(n,i)},extname(t){y(t,"path");let l=0,n=-1,i=0,o=-1,d=!0,g=0;t.length>=2&&t.charCodeAt(1)===v&&a(t.charCodeAt(0))&&(l=i=2);for(let D=t.length-1;D>=l;--D){const M=t.charCodeAt(D);if(s(M)){if(!d){i=D+1;break}continue}o===-1&&(d=!1,o=D+1),M===I?n===-1?n=D:g!==1&&(g=1):n!==-1&&(g=-1)}return n===-1||o===-1||g===0||g===1&&n===o-1&&n===i+1?"":t.slice(n,o)},format:P.bind(null,"\\"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const n=t.length;let i=0,o=t.charCodeAt(0);if(n===1)return s(o)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(s(o)){if(i=1,s(t.charCodeAt(1))){let O=2,F=O;for(;O<n&&!s(t.charCodeAt(O));)O++;if(O<n&&O!==F){for(F=O;O<n&&s(t.charCodeAt(O));)O++;if(O<n&&O!==F){for(F=O;O<n&&!s(t.charCodeAt(O));)O++;O===n?i=O:O!==F&&(i=O+1)}}}}else if(a(o)&&t.charCodeAt(1)===v){if(n<=2)return l.root=l.dir=t,l;if(i=2,s(t.charCodeAt(2))){if(n===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let d=-1,g=i,D=-1,M=!0,b=t.length-1,A=0;for(;b>=i;--b){if(o=t.charCodeAt(b),s(o)){if(!M){g=b+1;break}continue}D===-1&&(M=!1,D=b+1),o===I?d===-1?d=b:A!==1&&(A=1):d!==-1&&(A=-1)}return D!==-1&&(d===-1||A===0||A===1&&d===D-1&&d===g+1?l.base=l.name=t.slice(g,D):(l.name=t.slice(g,d),l.base=t.slice(g,D),l.ext=t.slice(d,D))),g>0&&g!==i?l.dir=t.slice(0,g-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(p){const t=/\\/g;return()=>{const l=E.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let l="",n=!1;for(let i=t.length-1;i>=-1&&!n;i--){const o=i>=0?t[i]:C();y(o,"path"),o.length!==0&&(l=`${o}/${l}`,n=o.charCodeAt(0)===h)}return l=f(l,!n,"/",w),n?`/${l}`:l.length>0?l:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h,n=t.charCodeAt(t.length-1)===h;return t=f(t,!l,"/",w),t.length===0?l?"/":n?"./":".":(n&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let l;for(let n=0;n<t.length;++n){const i=t[n];y(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.posix.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l||(t=e.posix.resolve(t),l=e.posix.resolve(l),t===l))return"";const n=1,i=t.length,o=i-n,d=1,g=l.length-d,D=o<g?o:g;let M=-1,b=0;for(;b<D;b++){const O=t.charCodeAt(n+b);if(O!==l.charCodeAt(d+b))break;O===h&&(M=b)}if(b===D)if(g>D){if(l.charCodeAt(d+b)===h)return l.slice(d+b+1);if(b===0)return l.slice(d+b)}else o>D&&(t.charCodeAt(n+b)===h?M=b:b===0&&(M=0));let A="";for(b=n+M+1;b<=i;++b)(b===i||t.charCodeAt(b)===h)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(d+M)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h;let n=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===h){if(!i){n=o;break}}else i=!1;return n===-1?l?"/":".":l&&n===1?"//":t.slice(0,n)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let n=0,i=-1,o=!0,d;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let g=l.length-1,D=-1;for(d=t.length-1;d>=0;--d){const M=t.charCodeAt(d);if(M===h){if(!o){n=d+1;break}}else D===-1&&(o=!1,D=d+1),g>=0&&(M===l.charCodeAt(g)?--g===-1&&(i=d):(g=-1,i=D))}return n===i?i=D:i===-1&&(i=t.length),t.slice(n,i)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===h){if(!o){n=d+1;break}}else i===-1&&(o=!1,i=d+1);return i===-1?"":t.slice(n,i)},extname(t){y(t,"path");let l=-1,n=0,i=-1,o=!0,d=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===h){if(!o){n=g+1;break}continue}i===-1&&(o=!1,i=g+1),D===I?l===-1?l=g:d!==1&&(d=1):l!==-1&&(d=-1)}return l===-1||i===-1||d===0||d===1&&l===i-1&&l===n+1?"":t.slice(l,i)},format:P.bind(null,"/"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const n=t.charCodeAt(0)===h;let i;n?(l.root="/",i=1):i=0;let o=-1,d=0,g=-1,D=!0,M=t.length-1,b=0;for(;M>=i;--M){const A=t.charCodeAt(M);if(A===h){if(!D){d=M+1;break}continue}g===-1&&(D=!1,g=M+1),A===I?o===-1?o=M:b!==1&&(b=1):o!==-1&&(b=-1)}if(g!==-1){const A=d===0&&n?1:d;o===-1||b===0||b===1&&o===g-1&&o===d+1?l.base=l.name=t.slice(A,g):(l.name=t.slice(A,o),l.base=t.slice(A,g),l.ext=t.slice(o,g))}return d>0?l.dir=t.slice(0,d-1):n&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(te[71],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function _(I,...h){const c=h.reduce((S,u)=>(S[u]=!0,S),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(S=>!c[S]).forEach(S=>{for(let u=0;u<v.length;u++)if(S.search(v[u])!==-1){delete I[S];break}})}e.sanitizeProcessEnvironment=_;function R(I){I&&(delete I.DEBUG,E.isMacintosh&&delete I.DYLD_LIBRARY_PATH,E.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(te[85],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=E.globals.performance&&typeof E.globals.performance.now=="function";class r{static create(R=!0){return new r(R)}constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=r}),define(te[4],ie([0,1,13,49,2,101,85]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,h=!1;var c;(function(d){d.None=()=>r.Disposable.None;function g(z){if(h){const{onDidAddListener:H}=z,B=y.create();let $=0;z.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),H?.()}}}function D(z,H){return ne(z,()=>{},0,void 0,!0,void 0,H)}d.defer=D;function M(z){return(H,B=null,$)=>{let G=!1,se;return se=z(ue=>{if(!G)return se?se.dispose():G=!0,H.call(B,ue)},null,$),G&&se.dispose(),se}}d.once=M;function b(z,H,B){return Y(($,G=null,se)=>z(ue=>$.call(G,H(ue)),null,se),B)}d.map=b;function A(z,H,B){return Y(($,G=null,se)=>z(ue=>{H(ue),$.call(G,ue)},null,se),B)}d.forEach=A;function O(z,H,B){return Y(($,G=null,se)=>z(ue=>H(ue)&&$.call(G,ue),null,se),B)}d.filter=O;function F(z){return z}d.signal=F;function q(...z){return(H,B=null,$)=>(0,r.combinedDisposable)(...z.map(G=>G(se=>H.call(B,se),null,$)))}d.any=q;function re(z,H,B,$){let G=B;return b(z,se=>(G=H(G,se),G),$)}d.reduce=re;function Y(z,H){let B;const $={onWillAddFirstListener(){B=z(G.fire,G)},onDidRemoveLastListener(){B?.dispose()}};H||g($);const G=new s($);return H?.add(G),G.event}function ne(z,H,B=100,$=!1,G=!1,se,ue){let ye,Ce,Re,Le=0,Te;const we={leakWarningThreshold:se,onWillAddFirstListener(){ye=z(Ee=>{Le++,Ce=H(Ce,Ee),$&&!Re&&(ve.fire(Ce),Ce=void 0),Te=()=>{const ee=Ce;Ce=void 0,Re=void 0,(!$||Le>1)&&ve.fire(ee),Le=0},typeof B=="number"?(clearTimeout(Re),Re=setTimeout(Te,B)):Re===void 0&&(Re=0,queueMicrotask(Te))})},onWillRemoveListener(){G&&Le>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,ye.dispose()}};ue||g(we);const ve=new s(we);return ue?.add(ve),ve.event}d.debounce=ne;function ce(z,H=0,B){return d.debounce(z,($,G)=>$?($.push(G),$):[G],H,void 0,!0,void 0,B)}d.accumulate=ce;function le(z,H=($,G)=>$===G,B){let $=!0,G;return O(z,se=>{const ue=$||!H(se,G);return $=!1,G=se,ue},B)}d.latch=le;function K(z,H,B){return[d.filter(z,H,B),d.filter(z,$=>!H($),B)]}d.split=K;function V(z,H=!1,B=[]){let $=B.slice(),G=z(ye=>{$?$.push(ye):ue.fire(ye)});const se=()=>{$?.forEach(ye=>ue.fire(ye)),$=null},ue=new s({onWillAddFirstListener(){G||(G=z(ye=>ue.fire(ye)))},onDidAddFirstListener(){$&&(H?setTimeout(se):se())},onDidRemoveLastListener(){G&&G.dispose(),G=null}});return ue.event}d.buffer=V;class U{constructor(H){this.event=H,this.disposables=new r.DisposableStore}map(H){return new U(b(this.event,H,this.disposables))}forEach(H){return new U(A(this.event,H,this.disposables))}filter(H){return new U(O(this.event,H,this.disposables))}reduce(H,B){return new U(re(this.event,H,B,this.disposables))}latch(){return new U(le(this.event,void 0,this.disposables))}debounce(H,B=100,$=!1,G=!1,se){return new U(ne(this.event,H,B,$,G,se,this.disposables))}on(H,B,$){return this.event(H,B,$)}once(H,B,$){return M(this.event)(H,B,$)}dispose(){this.disposables.dispose()}}function T(z){return new U(z)}d.chain=T;function x(z,H,B=$=>$){const $=(...ye)=>ue.fire(B(...ye)),G=()=>z.on(H,$),se=()=>z.removeListener(H,$),ue=new s({onWillAddFirstListener:G,onDidRemoveLastListener:se});return ue.event}d.fromNodeEventEmitter=x;function Q(z,H,B=$=>$){const $=(...ye)=>ue.fire(B(...ye)),G=()=>z.addEventListener(H,$),se=()=>z.removeEventListener(H,$),ue=new s({onWillAddFirstListener:G,onDidRemoveLastListener:se});return ue.event}d.fromDOMEventEmitter=Q;function Z(z){return new Promise(H=>M(z)(H))}d.toPromise=Z;function ae(z,H){return H(void 0),z(B=>H(B))}d.runAndSubscribe=ae;function oe(z,H){let B=null;function $(se){B?.dispose(),B=new r.DisposableStore,H(se,B)}$(void 0);const G=z(se=>$(se));return(0,r.toDisposable)(()=>{G.dispose(),B?.dispose()})}d.runAndSubscribeWithStore=oe;class N{constructor(H,B){this._observable=H,this._counter=0,this._hasChanged=!1;const $={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};B||g($),this.emitter=new s($),B&&B.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,B){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function k(z,H){return new N(z,H).emitter.event}d.fromObservable=k;function W(z){return H=>{let B=0,$=!1;const G={beginUpdate(){B++},endUpdate(){B--,B===0&&(z.reportChanges(),$&&($=!1,H()))},handlePossibleChange(){},handleChange(){$=!0}};return z.addObserver(G),{dispose(){z.removeObserver(G)}}}}d.fromObservableLight=W})(c||(e.Event=c={}));class v{constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${v._idPool++}`,v.all.add(this)}start(g){this._stopWatch=new R.StopWatch(!0),this.listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=v,v.all=new Set,v._idPool=0;let m=-1;function S(d){const g=m;return m=d,{dispose(){m=g}}}e.setGlobalLeakWarningThreshold=S;class u{constructor(g,D=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=D,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(g,D){const M=this.threshold;if(M<=0||D<M)return;this._stacks||(this._stacks=new Map);const b=this._stacks.get(g.value)||0;if(this._stacks.set(g.value,b+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let A,O=0;for(const[F,q]of this._stacks)(!A||O<q)&&(A=F,O=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${O}):`),console.warn(A)}return()=>{const A=this._stacks.get(g.value)||0;this._stacks.set(g.value,A-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(g,D,M){this.callback=g,this.callbackThis=D,this.stack=M,this.subscription=new r.SafeDisposable}invoke(g){this.callback.call(this.callbackThis,g)}}class s{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=m>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??m):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const g=Array.from(this._listeners);queueMicrotask(()=>{for(const D of g)D.subscription.isset()&&(D.subscription.unset(),D.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(g,D,M)=>{if(this._listeners||(this._listeners=new _.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;const b=this._listeners.isEmpty();b&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let A,O;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(O=y.create(),A=this._leakageMon.check(O,this._listeners.size+1)),I&&(O=O??y.create());const F=new p(g,D,O),q=this._listeners.push(F);b&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,g,D);const re=F.subscription.set(()=>{A?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),q(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return M instanceof r.DisposableStore?M.add(re):Array.isArray(M)&&M.push(re),re}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new a(this._options?.onListenerError));for(const D of this._listeners)this._deliveryQueue.push(this,D,g);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=s;class w{constructor(g=E.onUnexpectedError){this._onListenerError=g,this._queue=new _.LinkedList}get size(){return this._queue.size}push(g,D,M){this._queue.push(new f(g,D,M))}clear(g){const D=new _.LinkedList;for(const M of this._queue)M.emitter!==g&&D.push(M);this._queue=D}deliver(){for(;this._queue.size>0;){const g=this._queue.shift();try{g.listener.invoke(g.event)}catch(D){this._onListenerError(D)}}}}e.EventDeliveryQueue=w;class a extends w{clear(g){this._queue.clear()}}class f{constructor(g,D,M){this.emitter=g,this.listener=D,this.event=M}}class P extends s{async fireAsync(g,D,M){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const b of this._listeners)this._asyncDeliveryQueue.push([b,g]);for(;this._asyncDeliveryQueue.size>0&&!D.isCancellationRequested;){const[b,A]=this._asyncDeliveryQueue.shift(),O=[],F={...A,token:D,waitUntil:q=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");M&&(q=M(q,b.callback)),O.push(q)}};try{b.invoke(F)}catch(q){(0,E.onUnexpectedError)(q);continue}Object.freeze(O),await Promise.allSettled(O).then(q=>{for(const re of q)re.status==="rejected"&&(0,E.onUnexpectedError)(re.reason)})}}}}e.AsyncEmitter=P;class C extends s{get isPaused(){return this._isPaused!==0}constructor(g){super(g),this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=C;class t extends C{constructor(g){super(g),this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=t;class l extends s{constructor(g){super(g),this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this.hasListeners()&&(this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(D=>super.fire(D)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=l;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const D={event:g,listener:null};this.events.push(D),this.hasListeners&&this.hook(D);const M=()=>{this.hasListeners&&this.unhook(D);const b=this.events.indexOf(D);this.events.splice(b,1)};return(0,r.toDisposable)((0,L.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(D=>this.emitter.fire(D))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(g){return(D,M,b)=>g(A=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>D.call(M,A)):D.call(M,A)},void 0,b)}bufferEvents(g){const D=[];this.buffers.push(D);const M=g();return this.buffers.pop(),D.forEach(b=>b()),M}}e.EventBufferer=i;class o{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=r.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(te[21],ie([0,1,4]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,h){const c=setTimeout(I.bind(h),0);return{dispose(){clearTimeout(c)}}});var r;(function(I){function h(c){return c===I.None||c===I.Cancelled||c instanceof _?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}I.isCancellationToken=h,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=r.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=R}),define(te[151],ie([0,1,21]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new E.CancellationTokenSource,h=this.task(I.token);return this.result={promise:h,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=L;class r{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const h=JSON.stringify(I);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=r;class _{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const h=this.fn(I);return this._map.set(I,h),h}}e.CachedFunction=_}),define(te[25],ie([0,1,151,100]),function(j,e,E,L){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=_;const R=/{(\d+)}/g;function I(X,...he){return he.length===0?X:X.replace(R,function(ge,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=he.length?ge:he[be]})}e.format=I;const h=/{([^}]+)}/g;function c(X,he){return X.replace(h,(ge,me)=>he[me]??ge)}e.format2=c;function v(X){return X.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=v;function m(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function S(X,he){let ge=0;const me=he.charCodeAt(0);for(let be=X.length-1;be>=0;be--)X.charCodeAt(be)===me&&ge++;return ge}e.count=S;function u(X,he,ge="\u2026"){return X.length<=he?X:`${X.substr(0,he)}${ge}`}e.truncate=u;function y(X,he=" "){const ge=p(X,he);return s(ge,he)}e.trim=y;function p(X,he){if(!X||!he)return X;const ge=he.length;if(ge===0||X.length===0)return X;let me=0;for(;X.indexOf(he,me)===me;)me=me+ge;return X.substring(me)}e.ltrim=p;function s(X,he){if(!X||!he)return X;const ge=he.length,me=X.length;if(ge===0||me===0)return X;let be=me,Ae=-1;for(;Ae=X.lastIndexOf(he,be-1),!(Ae===-1||Ae+ge!==be);){if(Ae===0)return"";be=Ae}return X.substring(0,be)}e.rtrim=s;function w(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function a(X){return X.replace(/\*/g,"")}e.stripWildcards=a;function f(X,he,ge={}){if(!X)throw new Error("Cannot create regex from empty string");he||(X=m(X)),ge.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let me="";return ge.global&&(me+="g"),ge.matchCase||(me+="i"),ge.multiline&&(me+="m"),ge.unicode&&(me+="u"),new RegExp(X,me)}e.createRegExp=f;function P(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function C(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function l(X){return X.split(/\r\n|\r|\n/)}e.splitLines=l;function n(X){for(let he=0,ge=X.length;he<ge;he++){const me=X.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=n;function i(X,he=0,ge=X.length){for(let me=he;me<ge;me++){const be=X.charCodeAt(me);if(be!==32&&be!==9)return X.substring(he,me)}return X.substring(he,ge)}e.getLeadingWhitespace=i;function o(X,he=X.length-1){for(let ge=he;ge>=0;ge--){const me=X.charCodeAt(ge);if(me!==32&&me!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function d(X,he,ge){const me=[];let be=0;for(const Ae of X.matchAll(he)){if(me.push(X.slice(be,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");be=Ae.index+Ae[0].length,me.push(ge(Ae[0],...Ae.slice(1),Ae.index,X,Ae.groups))}return me.push(X.slice(be)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=d;function g(X,he){return X<he?-1:X>he?1:0}e.compare=g;function D(X,he,ge=0,me=X.length,be=0,Ae=he.length){for(;ge<me&&be<Ae;ge++,be++){const Je=X.charCodeAt(ge),Ve=he.charCodeAt(be);if(Je<Ve)return-1;if(Je>Ve)return 1}const Ue=me-ge,Ge=Ae-be;return Ue<Ge?-1:Ue>Ge?1:0}e.compareSubstring=D;function M(X,he){return b(X,he,0,X.length,0,he.length)}e.compareIgnoreCase=M;function b(X,he,ge=0,me=X.length,be=0,Ae=he.length){for(;ge<me&&be<Ae;ge++,be++){let Je=X.charCodeAt(ge),Ve=he.charCodeAt(be);if(Je===Ve)continue;if(Je>=128||Ve>=128)return D(X.toLowerCase(),he.toLowerCase(),ge,me,be,Ae);O(Je)&&(Je-=32),O(Ve)&&(Ve-=32);const Ye=Je-Ve;if(Ye!==0)return Ye}const Ue=me-ge,Ge=Ae-be;return Ue<Ge?-1:Ue>Ge?1:0}e.compareSubstringIgnoreCase=b;function A(X){return X>=48&&X<=57}e.isAsciiDigit=A;function O(X){return X>=97&&X<=122}e.isLowerAsciiLetter=O;function F(X){return X>=65&&X<=90}e.isUpperAsciiLetter=F;function q(X,he){return X.length===he.length&&b(X,he)===0}e.equalsIgnoreCase=q;function re(X,he){const ge=he.length;return he.length>X.length?!1:b(X,he,0,ge)===0}e.startsWithIgnoreCase=re;function Y(X,he){const ge=Math.min(X.length,he.length);let me;for(me=0;me<ge;me++)if(X.charCodeAt(me)!==he.charCodeAt(me))return me;return ge}e.commonPrefixLength=Y;function ne(X,he){const ge=Math.min(X.length,he.length);let me;const be=X.length-1,Ae=he.length-1;for(me=0;me<ge;me++)if(X.charCodeAt(be-me)!==he.charCodeAt(Ae-me))return me;return ge}e.commonSuffixLength=ne;function ce(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ce;function le(X){return 56320<=X&&X<=57343}e.isLowSurrogate=le;function K(X,he){return(X-55296<<10)+(he-56320)+65536}e.computeCodePoint=K;function V(X,he,ge){const me=X.charCodeAt(ge);if(ce(me)&&ge+1<he){const be=X.charCodeAt(ge+1);if(le(be))return K(me,be)}return me}e.getNextCodePoint=V;function U(X,he){const ge=X.charCodeAt(he-1);if(le(ge)&&he>1){const me=X.charCodeAt(he-2);if(ce(me))return K(me,ge)}return ge}class T{get offset(){return this._offset}constructor(he,ge=0){this._str=he,this._len=he.length,this._offset=ge}setOffset(he){this._offset=he}prevCodePoint(){const he=U(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=V(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=T;class x{get offset(){return this._iterator.offset}constructor(he,ge=0){this._iterator=new T(he,ge)}nextGraphemeLength(){const he=De.getInstance(),ge=this._iterator,me=ge.offset;let be=he.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ae=ge.offset,Ue=he.getGraphemeBreakType(ge.nextCodePoint());if(fe(be,Ue)){ge.setOffset(Ae);break}be=Ue}return ge.offset-me}prevGraphemeLength(){const he=De.getInstance(),ge=this._iterator,me=ge.offset;let be=he.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ae=ge.offset,Ue=he.getGraphemeBreakType(ge.prevCodePoint());if(fe(Ue,be)){ge.setOffset(Ae);break}be=Ue}return me-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function Q(X,he){return new x(X,he).nextGraphemeLength()}e.nextCharLength=Q;function Z(X,he){return new x(X,he).prevGraphemeLength()}e.prevCharLength=Z;function ae(X,he){he>0&&le(X.charCodeAt(he))&&he--;const ge=he+Q(X,he);return[ge-Z(X,ge),ge]}e.getCharContainingOffset=ae;function oe(X){const he=new x(X);let ge=0;for(;!he.eol();)ge++,he.nextGraphemeLength();return ge}e.charCount=oe;let N;function k(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(X){return N||(N=k()),N.test(X)}e.containsRTL=W;const z=/^[\t\n\r\x20-\x7E]*$/;function H(X){return z.test(X)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=B;function $(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=$;function G(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=G;function se(X,he){if(X.length<he)return X;const ge=/\b/g;let me=0;for(;ge.test(X)&&!(X.length-ge.lastIndex<he);)me=ge.lastIndex,ge.lastIndex+=1;return X.substring(me).replace(/^\s/,"")}e.lcut=se;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ye=/\x1b\].*?\x07/g;function Ce(X){return X&&(X=X.replace(ue,"").replace(ye,"")),X}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Le(X){return Re(X)?X.substr(1):X}e.stripUTF8BOM=Le;function Te(X,he){if(!X||!he||X.length<he.length)return!1;const ge=he.length,me=X.toLowerCase();let be=0,Ae=-1;for(;be<ge;){const Ue=me.indexOf(he[be],Ae+1);if(Ue<0)return!1;Ae=Ue,be++}return!0}e.fuzzyContains=Te;function we(X,he=!1){return X?(he&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=we;function ve(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=ve;function Ee(X,he=1){if(he===0)return"";let ge=-1;do ge=X.indexOf(`
`,ge+1),he--;while(he>0&&ge>=0);return ge===-1?X:(X[ge-1]==="\r"&&ge--,X.substr(0,ge))}e.getNLines=Ee;function ee(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=ee;function de(X){return De.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=de;function fe(X,he){return X===0?he!==5&&he!==7:X===2&&he===3?!1:X===4||X===2||X===3||he===4||he===2||he===3?!0:!(X===8&&(he===8||he===9||he===11||he===12)||(X===11||X===9)&&(he===9||he===10)||(X===12||X===10)&&he===10||he===5||he===13||he===7||X===1||X===13&&he===14||X===6&&he===6)}var ke;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(e.GraphemeBreakType=ke={}));class De{static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}constructor(){this._data=_e()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const ge=this._data,me=ge.length/3;let be=1;for(;be<=me;)if(he<ge[3*be])be=2*be;else if(he>ge[3*be+1])be=2*be+1;else return ge[3*be+2];return 0}}De._INSTANCE=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(X,he){if(X===0)return 0;const ge=qe(X,he);if(ge!==void 0)return ge;const me=new T(he,X);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=We;function qe(X,he){const ge=new T(he,X);let me=ge.prevCodePoint();for(;$e(me)||me===65039||me===8419;){if(ge.offset===0)return;me=ge.prevCodePoint()}if(!G(me))return;let be=ge.offset;return be>0&&ge.prevCodePoint()===8205&&(be=ge.offset),be}function $e(X){return 127995<=X&&X<=127999}var ze;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class He{static getInstance(he){return He.cache.get(Array.from(he))}static getLocales(){return He._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,r=He,He.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new E.LRUCachedFunction(X=>{function he(Ve){const Ye=new Map;for(let tt=0;tt<Ve.length;tt+=2)Ye.set(Ve[tt],Ve[tt+1]);return Ye}function ge(Ve,Ye){const tt=new Map(Ve);for(const[ot,ct]of Ye)tt.set(ot,ct);return tt}function me(Ve,Ye){if(!Ve)return Ye;const tt=new Map;for(const[ot,ct]of Ve)Ye.has(ot)&&tt.set(ot,ct);return tt}const be=r.ambiguousCharacterData.value;let Ae=X.filter(Ve=>!Ve.startsWith("_")&&Ve in be);Ae.length===0&&(Ae=["_default"]);let Ue;for(const Ve of Ae){const Ye=he(be[Ve]);Ue=me(Ue,Ye)}const Ge=he(be._common),Je=ge(Ge,Ue);return new He(Je)}),He._locales=new L.Lazy(()=>Object.keys(He.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")));class Be{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Be.getRawData())),this._data}static isInvisibleCharacter(he){return Be.getData().has(he)}static get codePoints(){return Be.getData()}}e.InvisibleCharacters=Be,Be._data=void 0}),define(te[32],ie([0,1,9,3,25,11]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(d){return d===47||d===92}e.isPathSeparator=R;function I(d){return d.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=I;function h(d){return d.indexOf("/")===-1&&(d=I(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=h;function c(d,g=E.posix.sep){if(!d)return"";const D=d.length,M=d.charCodeAt(0);if(R(M)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let A=3;const O=A;for(;A<D&&!R(d.charCodeAt(A));A++);if(O!==A&&!R(d.charCodeAt(A+1))){for(A+=1;A<D;A++)if(R(d.charCodeAt(A)))return d.slice(0,A+1).replace(/[\\/]/g,g)}}return g}else if(w(M)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+g:d.slice(0,2);let b=d.indexOf("://");if(b!==-1){for(b+=3;b<D;b++)if(R(d.charCodeAt(b)))return d.slice(0,b+1)}return""}e.getRoot=c;function v(d){if(!L.isWindows||!d||d.length<5)return!1;let g=d.charCodeAt(0);if(g!==92||(g=d.charCodeAt(1),g!==92))return!1;let D=2;const M=D;for(;D<d.length&&(g=d.charCodeAt(D),g!==92);D++);return!(M===D||(g=d.charCodeAt(D+1),isNaN(g)||g===92))}e.isUNC=v;const m=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(d,g=L.isWindows){const D=g?m:S;return!(!d||d.length===0||/^\s+$/.test(d)||(D.lastIndex=0,D.test(d))||g&&u.test(d)||d==="."||d===".."||g&&d[d.length-1]==="."||g&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=y;function p(d,g,D){const M=d===g;return!D||M?M:!d||!g?!1:(0,r.equalsIgnoreCase)(d,g)}e.isEqual=p;function s(d,g,D,M=E.sep){if(d===g)return!0;if(!d||!g||g.length>d.length)return!1;if(D){if(!(0,r.startsWithIgnoreCase)(d,g))return!1;if(g.length===d.length)return!0;let A=g.length;return g.charAt(g.length-1)===M&&A--,d.charAt(A)===M}return g.charAt(g.length-1)!==M&&(g+=M),d.indexOf(g)===0}e.isEqualOrParent=s;function w(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=w;function a(d,g){return L.isWindows&&d.endsWith(":")&&(d+=E.sep),(0,E.isAbsolute)(d)||(d=(0,E.join)(g,d)),d=(0,E.normalize)(d),L.isWindows?(d=(0,r.rtrim)(d,E.sep),d.endsWith(":")&&(d+=E.sep)):(d=(0,r.rtrim)(d,E.sep),d||(d=E.sep)),d}e.sanitizeFilePath=a;function f(d){const g=(0,E.normalize)(d);return L.isWindows?d.length>3?!1:P(g)&&(d.length===2||g.charCodeAt(2)===92):g===E.posix.sep}e.isRootOrDriveLetter=f;function P(d,g=L.isWindows){return g?w(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function C(d,g=L.isWindows){return P(d,g)?d[0]:void 0}e.getDriveLetter=C;function t(d,g,D){return g.length>d.length?-1:d===g?0:(D&&(d=d.toLowerCase(),g=g.toLowerCase()),d.indexOf(g))}e.indexOfPath=t;function l(d){const g=d.split(":");let D,M,b;for(const A of g){const O=Number(A);(0,_.isNumber)(O)?M===void 0?M=O:b===void 0&&(b=O):D=D?[D,A].join(":"):A}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:M!==void 0?M:void 0,column:b!==void 0?b:M!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(d,g,D=8){let M="";for(let A=0;A<D;A++){let O;A===0&&L.isWindows&&!g&&(D===3||D===4)?O=i:O=n,M+=O.charAt(Math.floor(Math.random()*O.length))}let b;return g?b=`${g}-${M}`:b=M,d?(0,E.join)(d,b):b}e.randomPath=o}),define(te[56],ie([0,1,25]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(w){return r(w,0)}e.hash=L;function r(w,a){switch(typeof w){case"object":return w===null?_(349,a):Array.isArray(w)?h(w,a):c(w,a);case"string":return I(w,a);case"boolean":return R(w,a);case"number":return _(w,a);case"undefined":return _(937,a);default:return _(617,a)}}e.doHash=r;function _(w,a){return(a<<5)-a+w|0}e.numberHash=_;function R(w,a){return _(w?433:863,a)}function I(w,a){a=_(149417,a);for(let f=0,P=w.length;f<P;f++)a=_(w.charCodeAt(f),a);return a}e.stringHash=I;function h(w,a){return a=_(104579,a),w.reduce((f,P)=>r(P,f),a)}function c(w,a){return a=_(181387,a),Object.keys(w).sort().reduce((f,P)=>(f=I(P,f),r(w[P],f)),a)}class v{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=r(a,this._value),this._value}}e.Hasher=v;var m;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function S(w,a,f=32){const P=f-a,C=~((1<<P)-1);return(w<<a|(C&w)>>>P)>>>0}function u(w,a=0,f=w.byteLength,P=0){for(let C=0;C<f;C++)w[a+C]=P}function y(w,a,f="0"){for(;w.length<a;)w=f+w;return w}function p(w,a=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(f=>f.toString(16).padStart(2,"0")).join(""):y((w>>>0).toString(16),a/4)}e.toHexString=p;class s{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const f=a.length;if(f===0)return;const P=this._buff;let C=this._buffLen,t=this._leftoverHighSurrogate,l,n;for(t!==0?(l=t,n=-1,t=0):(l=a.charCodeAt(0),n=0);;){let i=l;if(E.isHighSurrogate(l))if(n+1<f){const o=a.charCodeAt(n+1);E.isLowSurrogate(o)?(n++,i=E.computeCodePoint(l,o)):i=65533}else{t=l;break}else E.isLowSurrogate(l)&&(i=65533);if(C=this._push(P,C,i),n++,n<f)l=a.charCodeAt(n);else break}this._buffLen=C,this._leftoverHighSurrogate=t}_push(a,f,P){return P<128?a[f++]=P:P<2048?(a[f++]=192|(P&1984)>>>6,a[f++]=128|(P&63)>>>0):P<65536?(a[f++]=224|(P&61440)>>>12,a[f++]=128|(P&4032)>>>6,a[f++]=128|(P&63)>>>0):(a[f++]=240|(P&1835008)>>>18,a[f++]=128|(P&258048)>>>12,a[f++]=128|(P&4032)>>>6,a[f++]=128|(P&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=s._bigBlock32,f=this._buffDV;for(let g=0;g<64;g+=4)a.setUint32(g,f.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)a.setUint32(g,S(a.getUint32(g-12,!1)^a.getUint32(g-32,!1)^a.getUint32(g-56,!1)^a.getUint32(g-64,!1),1),!1);let P=this._h0,C=this._h1,t=this._h2,l=this._h3,n=this._h4,i,o,d;for(let g=0;g<80;g++)g<20?(i=C&t|~C&l,o=1518500249):g<40?(i=C^t^l,o=1859775393):g<60?(i=C&t|C&l|t&l,o=2400959708):(i=C^t^l,o=3395469782),d=S(P,5)+i+n+o+a.getUint32(g*4,!1)&4294967295,n=l,l=t,t=S(C,30),C=P,P=d;this._h0=this._h0+P&4294967295,this._h1=this._h1+C&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=s,s._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[72],ie([0,1,25]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const _="error",R="warning",I="warn",h="info",c="ignore";function v(S){return S?E.equalsIgnoreCase(_,S)?r.Error:E.equalsIgnoreCase(R,S)||E.equalsIgnoreCase(I,S)?r.Warning:E.equalsIgnoreCase(h,S)?r.Info:r.Ignore:r.Ignore}r.fromValue=v;function m(S){switch(S){case r.Error:return _;case r.Warning:return R;case r.Info:return h;default:return c}}r.toString=m}(L||(L={})),e.default=L}),define(te[62],ie([0,1,24,25]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const y=u.charCodeAt(0),p=this._value.charCodeAt(this._pos);return y-p}value(){return this._value[this._pos]}}e.StringIterator=r;class _{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class R{constructor(u=!0,y=!0){this._splitOnBackslash=u,this._caseSensitive=y}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let y=u.length-1;y>=0;y--,this._valueLen--){const p=this._value.charCodeAt(y);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var I;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(I||(I={}));class h{constructor(u,y){this._ignorePathCasing=u,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,L.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(v||(v={}));class m{static forUris(u=()=>!1,y=()=>!1){return new m(new h(u,y))}static forPaths(u=!1){return new m(new R(void 0,!u))}static forStrings(){return new m(new r)}static forConfigKeys(){return new m(new _)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,y){if(y){const p=y.slice(0);(0,E.shuffle)(p);for(const s of p)this.set(s,u)}else{const p=u.slice(0);(0,E.shuffle)(p);for(const s of p)this.set(s[0],s[1])}}set(u,y){const p=this._iter.reset(u);let s;this._root||(this._root=new c,this._root.segment=p.value());const w=[];for(s=this._root;;){const f=p.cmp(s.segment);if(f>0)s.left||(s.left=new c,s.left.segment=p.value()),w.push([-1,s]),s=s.left;else if(f<0)s.right||(s.right=new c,s.right.segment=p.value()),w.push([1,s]),s=s.right;else if(p.hasNext())p.next(),s.mid||(s.mid=new c,s.mid.segment=p.value()),w.push([0,s]),s=s.mid;else break}const a=s.value;s.value=y,s.key=u;for(let f=w.length-1;f>=0;f--){const P=w[f][1];P.updateHeight();const C=P.balanceFactor();if(C<-1||C>1){const t=w[f][0],l=w[f+1][0];if(t===1&&l===1)w[f][1]=P.rotateLeft();else if(t===-1&&l===-1)w[f][1]=P.rotateRight();else if(t===1&&l===-1)P.right=w[f+1][1]=w[f+1][1].rotateRight(),w[f][1]=P.rotateLeft();else if(t===-1&&l===1)P.left=w[f+1][1]=w[f+1][1].rotateLeft(),w[f][1]=P.rotateRight();else throw new Error;if(f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this._root=w[0][1]}}return a}get(u){return this._getNode(u)?.value}_getNode(u){const y=this._iter.reset(u);let p=this._root;for(;p;){const s=y.cmp(p.segment);if(s>0)p=p.left;else if(s<0)p=p.right;else if(y.hasNext())y.next(),p=p.mid;else break}return p}has(u){const y=this._getNode(u);return!(y?.value===void 0&&y?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,y){const p=this._iter.reset(u),s=[];let w=this._root;for(;w;){const a=p.cmp(w.segment);if(a>0)s.push([-1,w]),w=w.left;else if(a<0)s.push([1,w]),w=w.right;else if(p.hasNext())p.next(),s.push([0,w]),w=w.mid;else break}if(w){if(y?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const a=this._min(w.right);if(a.key){const{key:f,value:P,segment:C}=a;this._delete(a.key,!1),w.key=f,w.value=P,w.segment=C}}else{const a=w.left??w.right;if(s.length>0){const[f,P]=s[s.length-1];switch(f){case-1:P.left=a;break;case 0:P.mid=a;break;case 1:P.right=a;break}}else this._root=a}for(let a=s.length-1;a>=0;a--){const f=s[a][1];f.updateHeight();const P=f.balanceFactor();if(P>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),s[a][1]=f.rotateLeft()):P<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),s[a][1]=f.rotateRight()),a>0)switch(s[a-1][0]){case-1:s[a-1][1].left=s[a][1];break;case 1:s[a-1][1].right=s[a][1];break;case 0:s[a-1][1].mid=s[a][1];break}else this._root=s[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const y=this._iter.reset(u);let p=this._root,s;for(;p;){const w=y.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(y.hasNext())y.next(),s=p.value||s,p=p.mid;else break}return p&&p.value||s}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,y){const p=this._iter.reset(u);let s=this._root;for(;s;){const w=p.cmp(s.segment);if(w>0)s=s.left;else if(w<0)s=s.right;else if(p.hasNext())p.next(),s=s.mid;else return s.mid?this._entries(s.mid):y?s.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[y,p]of this)u(p,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const y=[];return this._dfsEntries(u,y),y[Symbol.iterator]()}_dfsEntries(u,y){u&&(u.left&&this._dfsEntries(u.left,y),u.value&&y.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,y),u.right&&this._dfsEntries(u.right,y))}_isBalanced(){const u=y=>{if(!y)return!0;const p=y.balanceFactor();return p<-1||p>1?!1:u(y.left)&&u(y.right)};return u(this._root)}}e.TernarySearchTree=m}),define(te[8],ie([0,1,9,3]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,_=/^\//,R=/^\/\//;function I(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!_.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,o){return!i&&!o?"file":i}function c(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==m&&(o=m+o):o=m;break}return o}const v="",m="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(o){return o instanceof u?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,d,g,D,M,b=!1){typeof o=="object"?(this.scheme=o.scheme||v,this.authority=o.authority||v,this.path=o.path||v,this.query=o.query||v,this.fragment=o.fragment||v):(this.scheme=h(o,b),this.authority=d||v,this.path=c(this.scheme,g||v),this.query=D||v,this.fragment=M||v,I(this,b))}get fsPath(){return P(this,!1)}with(o){if(!o)return this;let{scheme:d,authority:g,path:D,query:M,fragment:b}=o;return d===void 0?d=this.scheme:d===null&&(d=v),g===void 0?g=this.authority:g===null&&(g=v),D===void 0?D=this.path:D===null&&(D=v),M===void 0?M=this.query:M===null&&(M=v),b===void 0?b=this.fragment:b===null&&(b=v),d===this.scheme&&g===this.authority&&D===this.path&&M===this.query&&b===this.fragment?this:new s(d,g,D,M,b)}static parse(o,d=!1){const g=S.exec(o);return g?new s(g[2]||v,n(g[4]||v),n(g[5]||v),n(g[7]||v),n(g[9]||v),d):new s(v,v,v,v,v)}static file(o){let d=v;if(L.isWindows&&(o=o.replace(/\\/g,m)),o[0]===m&&o[1]===m){const g=o.indexOf(m,2);g===-1?(d=o.substring(2),o=m):(d=o.substring(2,g),o=o.substring(g)||m)}return new s("file",d,o,v,v)}static from(o,d){return new s(o.scheme,o.authority,o.path,o.query,o.fragment,d)}static joinPath(o,...d){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.isWindows&&o.scheme==="file"?g=u.file(E.win32.join(P(o,!0),...d)).path:g=E.posix.join(o.path,...d),o.with({path:g})}toString(o=!1){return C(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof u)return o;{const d=new s(o);return d._formatted=o.external??null,d._fsPath=o._sep===p?o.fsPath??null:null,d}}else return o}}e.URI=u;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=y;const p=L.isWindows?1:void 0;class s extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=P(this,!1)),this._fsPath}toString(o=!1){return o?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=p),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,o,d){let g,D=-1;for(let M=0;M<i.length;M++){const b=i.charCodeAt(M);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||o&&b===47||d&&b===91||d&&b===93||d&&b===58)D!==-1&&(g+=encodeURIComponent(i.substring(D,M)),D=-1),g!==void 0&&(g+=i.charAt(M));else{g===void 0&&(g=i.substr(0,M));const A=w[b];A!==void 0?(D!==-1&&(g+=encodeURIComponent(i.substring(D,M)),D=-1),g+=A):D===-1&&(D=M)}}return D!==-1&&(g+=encodeURIComponent(i.substring(D))),g!==void 0?g:i}function f(i){let o;for(let d=0;d<i.length;d++){const g=i.charCodeAt(d);g===35||g===63?(o===void 0&&(o=i.substr(0,d)),o+=w[g]):o!==void 0&&(o+=i[d])}return o!==void 0?o:i}function P(i,o){let d;return i.authority&&i.path.length>1&&i.scheme==="file"?d=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?d=i.path.substr(1):d=i.path[1].toLowerCase()+i.path.substr(2):d=i.path,L.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=P;function C(i,o){const d=o?f:a;let g="",{scheme:D,authority:M,path:b,query:A,fragment:O}=i;if(D&&(g+=D,g+=":"),(M||D==="file")&&(g+=m,g+=m),M){let F=M.indexOf("@");if(F!==-1){const q=M.substr(0,F);M=M.substr(F+1),F=q.lastIndexOf(":"),F===-1?g+=d(q,!1,!1):(g+=d(q.substr(0,F),!1,!1),g+=":",g+=d(q.substr(F+1),!1,!0)),g+="@"}M=M.toLowerCase(),F=M.lastIndexOf(":"),F===-1?g+=d(M,!1,!0):(g+=d(M.substr(0,F),!1,!0),g+=M.substr(F))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const F=b.charCodeAt(1);F>=65&&F<=90&&(b=`/${String.fromCharCode(F+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const F=b.charCodeAt(0);F>=65&&F<=90&&(b=`${String.fromCharCode(F+32)}:${b.substr(2)}`)}g+=d(b,!0,!1)}return A&&(g+="?",g+=d(A,!1,!1)),O&&(g+="#",g+=o?O:a(O,!1,!1)),g}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(l)?i.replace(l,o=>t(o)):i}}),define(te[152],ie([0,1,8]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(c){const v=c;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.isRemoteConsoleLog=L;function r(c){const v=[];let m;try{const S=JSON.parse(c.arguments),u=S[S.length-1];u&&u.__$stack&&(S.pop(),m=u.__$stack),v.push(...S)}catch{v.push("Unable to log remote console arguments",c.arguments)}return{args:v,stack:m}}e.parse=r;function _(c){if(typeof c!="string")return _(r(c).stack);const v=c;if(v){const m=R(v),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(S&&S.length===4)return{uri:E.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=_;function R(c){if(!c)return c;const v=c.indexOf(`
`);return v===-1?c:c.substring(0,v)}function I(c,v){const{args:m,stack:S}=r(c),u=typeof m[0]=="string"&&m.length===1;let y=R(S);y&&(y=`(${y.trim()})`);let p=[];if(typeof m[0]=="string"?y&&u?p=[`%c[${v}] %c${m[0]} %c${y}`,h("blue"),h(""),h("grey")]:p=[`%c[${v}] %c${m[0]}`,h("blue"),h(""),...m.slice(1)]:p=[`%c[${v}]%`,h("blue"),...m],y&&!u&&p.push(y),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,p)}e.log=I;function h(c){return`color: ${c}`}}),define(te[73],ie([0,1,17,25,8]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function _(c){return JSON.stringify(c,I)}e.stringify=_;function R(c){let v=JSON.parse(c);return v=h(v),v}e.parse=R;function I(c,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,L.regExpFlags)(v)}:v}function h(c,v=0){if(!c||v>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return r.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof E.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let m=0;m<c.length;++m)c[m]=h(c[m],v+1);else for(const m in c)Object.hasOwnProperty.call(c,m)&&(c[m]=h(c[m],v+1))}return c}e.revive=h}),define(te[14],ie([0,1,13,3,8]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractive="vscode-interactive",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(_||(e.Schemas=_={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}setServerRootPath(v){this._remoteResourcesPath=`${v}/${_.vscodeRemoteResource}`}set(v,m,S){this._hosts[v]=m,this._ports[v]=S}setConnectionToken(v,m){this._connectionTokens[v]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)try{return this._delegate(v)}catch(s){return E.onUnexpectedError(s),v}const m=v.authority;let S=this._hosts[m];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const u=this._ports[m],y=this._connectionTokens[m];let p=`path=${encodeURIComponent(v.path)}`;return typeof y=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),r.URI.from({scheme:L.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${S}:${u}`,path:this._remoteResourcesPath,query:p})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(v){const m=this.toUri(v,j);return this.uriToBrowserUri(m)}uriToBrowserUri(v){return v.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(v):v.scheme===_.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${_.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?v.with({scheme:_.vscodeFileResource,authority:v.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):v}asFileUri(v){const m=this.toUri(v,j);return this.uriToFileUri(m)}uriToFileUri(v){return v.scheme===_.vscodeFileResource?v.with({scheme:_.file,authority:v.authority!==I.FALLBACK_AUTHORITY?v.authority:null,query:null,fragment:null}):v}toUri(v,m){return r.URI.isUri(v)?v:r.URI.parse(m.toUrl(v))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I;var h;(function(c){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(v.get("3"));const m="vscode-coi";function S(y){let p;typeof y=="string"?p=new URL(y).searchParams:y instanceof URL?p=y.searchParams:r.URI.isUri(y)&&(p=new URL(y.toString(!0)).searchParams);const s=p?.get(m);if(s)return v.get(s)}c.getHeadersFromQuery=S;function u(y,p,s){if(!globalThis.crossOriginIsolated)return;const w=p&&s?"3":s?"2":"1";y instanceof URLSearchParams?y.set(m,w):y[m]=w}c.addSearchParam=u})(h||(e.COI=h={}))}),define(te[18],ie([0,1,32,14,9,3,25,8]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(u){return(0,I.uriToFsPath)(u,!0)}e.originalFSPath=h;class c{constructor(y){this._ignorePathCasing=y}compare(y,p,s=!1){return y===p?0:(0,R.compare)(this.getComparisonKey(y,s),this.getComparisonKey(p,s))}isEqual(y,p,s=!1){return y===p?!0:!y||!p?!1:this.getComparisonKey(y,s)===this.getComparisonKey(p,s)}getComparisonKey(y,p=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,p,s=!1){if(y.scheme===p.scheme){if(y.scheme===L.Schemas.file)return E.isEqualOrParent(h(y),h(p),this._ignorePathCasing(y))&&y.query===p.query&&(s||y.fragment===p.fragment);if((0,e.isEqualAuthority)(y.authority,p.authority))return E.isEqualOrParent(y.path,p.path,this._ignorePathCasing(y),"/")&&y.query===p.query&&(s||y.fragment===p.fragment)}return!1}joinPath(y,...p){return I.URI.joinPath(y,...p)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return r.posix.basename(y.path)}extname(y){return r.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let p;return y.scheme===L.Schemas.file?p=I.URI.file(r.dirname(h(y))).path:(p=r.posix.dirname(y.path),y.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),p="/")),y.with({path:p})}normalizePath(y){if(!y.path.length)return y;let p;return y.scheme===L.Schemas.file?p=I.URI.file(r.normalize(h(y))).path:p=r.posix.normalize(y.path),y.with({path:p})}relativePath(y,p){if(y.scheme!==p.scheme||!(0,e.isEqualAuthority)(y.authority,p.authority))return;if(y.scheme===L.Schemas.file){const a=r.relative(h(y),h(p));return _.isWindows?E.toSlashes(a):a}let s=y.path||"/";const w=p.path||"/";if(this._ignorePathCasing(y)){let a=0;for(const f=Math.min(s.length,w.length);a<f&&!(s.charCodeAt(a)!==w.charCodeAt(a)&&s.charAt(a).toLowerCase()!==w.charAt(a).toLowerCase());a++);s=w.substr(0,a)+s.substr(a)}return r.posix.relative(s,w)}resolvePath(y,p){if(y.scheme===L.Schemas.file){const s=I.URI.file(r.resolve(h(y),p));return y.with({authority:s.authority,path:s.path})}return p=E.toPosixPath(p),y.with({path:r.posix.resolve(y.path,p)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,p){return y===p||y!==void 0&&p!==void 0&&(0,R.equalsIgnoreCase)(y,p)}hasTrailingPathSeparator(y,p=r.sep){if(y.scheme===L.Schemas.file){const s=h(y);return s.length>E.getRoot(s).length&&s[s.length-1]===p}else{const s=y.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,p=r.sep){return(0,e.hasTrailingPathSeparator)(y,p)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,p=r.sep){let s=!1;if(y.scheme===L.Schemas.file){const w=h(y);s=w!==void 0&&w.length===E.getRoot(w).length&&w[w.length-1]===p}else{p="/";const w=y.path;s=w.length===1&&w.charCodeAt(w.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(y,p)?y.with({path:y.path+"/"}):y}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(u=>u.scheme===L.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new c(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(u,y){const p=[];for(let s=0;s<u.length;s++){const w=y(u[s]);u.some((a,f)=>f===s?!1:(0,e.isEqualOrParent)(w,y(a)))||p.push(u[s])}return p}e.distinctParents=v;var m;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function y(p){const s=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[P,C]=f.split(":");P&&C&&s.set(P,C)});const a=p.path.substring(0,p.path.indexOf(";"));return a&&s.set(u.META_DATA_MIME,a),s}u.parseMetaData=y})(m||(e.DataUri=m={}));function S(u,y,p){if(y){let s=u.path;return s&&s[0]!==r.posix.sep&&(s=r.posix.sep+s),u.with({scheme:p,authority:y,path:s})}return u.with({scheme:p})}e.toLocalResource=S}),define(te[7],ie([0,1,21,13,4,2,18,3,139]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function c(N){return!!N&&typeof N.then=="function"}e.isThenable=c;function v(N){const k=new E.CancellationTokenSource,W=N(k.token),z=new Promise((H,B)=>{const $=k.token.onCancellationRequested(()=>{$.dispose(),k.dispose(),B(new L.CancellationError)});Promise.resolve(W).then(G=>{$.dispose(),k.dispose(),H(G)},G=>{$.dispose(),k.dispose(),B(G)})});return new class{cancel(){k.cancel()}then(H,B){return z.then(H,B)}catch(H){return this.then(void 0,H)}finally(H){return z.finally(H)}}}e.createCancelablePromise=v;function m(N,k,W){return new Promise((z,H)=>{const B=k.onCancellationRequested(()=>{B.dispose(),z(W)});N.then(z,H).finally(()=>B.dispose())})}e.raceCancellation=m;function S(N,k){return new Promise((W,z)=>{const H=k.onCancellationRequested(()=>{H.dispose(),z(new L.CancellationError)});N.then(W,z).finally(()=>H.dispose())})}e.raceCancellationError=S;async function u(N){let k=-1;const W=N.map((z,H)=>z.then(B=>(k=H,B)));try{return await Promise.race(W)}finally{N.forEach((z,H)=>{H!==k&&z.cancel()})}}e.raceCancellablePromises=u;function y(N,k,W){let z;const H=setTimeout(()=>{z?.(void 0),W?.()},k);return Promise.race([N.finally(()=>clearTimeout(H)),new Promise(B=>z=B)])}e.raceTimeout=y;function p(N){return new Promise((k,W)=>{const z=N();c(z)?z.then(k,W):k(z)})}e.asPromise=p;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(k){if(this.activePromise){if(this.queuedPromiseFactory=k,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(W,W).then(z)})}return new Promise((W,z)=>{this.queuedPromise.then(W,z)})}return this.activePromise=k(),new Promise((W,z)=>{this.activePromise.then(H=>{this.activePromise=null,W(H)},H=>{this.activePromise=null,z(H)})})}}e.Throttler=s;class w{constructor(){this.current=Promise.resolve(null)}queue(k){return this.current=this.current.then(()=>k(),()=>k())}}e.Sequencer=w;class a{constructor(){this.promiseMap=new Map}queue(k,W){const H=(this.promiseMap.get(k)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(k)===H&&this.promiseMap.delete(k)});return this.promiseMap.set(k,H),H}}e.SequencerByKey=a;const f=(N,k)=>{let W=!0;const z=setTimeout(()=>{W=!1,k()},N);return{isTriggered:()=>W,dispose:()=>{clearTimeout(z),W=!1}}},P=N=>{let k=!0;return queueMicrotask(()=>{k&&(k=!1,N())}),{isTriggered:()=>k,dispose:()=>{k=!1}}};class C{constructor(k){this.defaultDelay=k,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(k,W=this.defaultDelay){this.task=k,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,B)=>{this.doResolve=H,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===h.MicrotaskDelay?P(z):f(W,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=C;class t{constructor(k){this.delayer=new C(k),this.throttler=new s}trigger(k,W){return this.delayer.trigger(()=>this.throttler.queue(k),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class l{constructor(){this._isOpen=!1,this._promise=new Promise((k,W)=>{this._completePromise=k})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class n extends l{constructor(k){super(),this._timeout=setTimeout(()=>this.open(),k)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function i(N,k){return k?new Promise((W,z)=>{const H=setTimeout(()=>{B.dispose(),W()},N),B=k.onCancellationRequested(()=>{clearTimeout(H),B.dispose(),z(new L.CancellationError)})}):v(W=>i(N,W))}e.timeout=i;function o(N,k=0){const W=setTimeout(N,k);return(0,_.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function d(N){const k=[];let W=0;const z=N.length;function H(){return W<z?N[W++]():null}function B($){$!=null&&k.push($);const G=H();return G?G.then(B):Promise.resolve(k)}return Promise.resolve(null).then(B)}e.sequence=d;function g(N,k=z=>!!z,W=null){let z=0;const H=N.length,B=()=>{if(z>=H)return Promise.resolve(W);const $=N[z++];return Promise.resolve($()).then(se=>k(se)?Promise.resolve(se):B())};return B()}e.first=g;function D(N,k=z=>!!z,W=null){if(N.length===0)return Promise.resolve(W);let z=N.length;const H=()=>{z=-1;for(const B of N)B.cancel?.()};return new Promise((B,$)=>{for(const G of N)G.then(se=>{--z>=0&&k(se)?(H(),B(se)):z===0&&B(W)}).catch(se=>{--z>=0&&(H(),$(se))})})}e.firstParallel=D;class M{constructor(k){this._size=0,this.maxDegreeOfParalellism=k,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(k){return this._size++,new Promise((W,z)=>{this.outstandingPromises.push({factory:k,c:W,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const k=this.outstandingPromises.shift();this.runningPromises++;const W=k.factory();W.then(k.c,k.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=M;class b extends M{constructor(){super(1)}}e.Queue=b;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const k=new T;return this.drainers.add(k),k.p}isDrained(){for(const[,k]of this.queues)if(k.size>0)return!1;return!0}queueFor(k,W=R.extUri){const z=W.getComparisonKey(k);let H=this.queues.get(z);return H||(H=new b,r.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete(z),this.onDidQueueDrain()}),this.queues.set(z,H)),H}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const k of this.drainers)k.complete();this.drainers.clear()}dispose(){for(const[,k]of this.queues)k.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class O{constructor(k,W){this._token=-1,typeof k=="function"&&typeof W=="number"&&this.setIfNotSet(k,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(k,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,k()},W)}setIfNotSet(k,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,k()},W))}}e.TimeoutTimer=O;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(k,W){this.cancel(),this._token=setInterval(()=>{k()},W)}}e.IntervalTimer=F;class q{constructor(k,W){this.timeoutToken=-1,this.runner=k,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(k=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,k)}get delay(){return this.timeout}set delay(k){this.timeout=k}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class re{constructor(k,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=k,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(k=this.timeout){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(k/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class Y extends q{constructor(k,W){super(k,W),this.units=[]}work(k){this.units.push(k),this.isScheduled()||this.schedule()}doRun(){const k=this.units;this.units=[],this.runner?.(k)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Y;class ne extends _.Disposable{constructor(k,W){super(),this.options=k,this.handler=W,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(k){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+k.length>this.options.maxBufferedWork)return!1}else if(this.pending+k.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const W of k)this.pendingWork.push(W);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,I.setTimeout0)(()=>{if(k)return;const W=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let k=!1;return{dispose(){k||(k=!0)}}}:e.runWhenIdle=(N,k)=>{const W=requestIdleCallback(N,typeof k=="number"?{timeout:k}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(W))}}}}();class ce{constructor(k){this._didRun=!1,this._executor=()=>{try{this._value=k()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ce;async function le(N,k,W){let z;for(let H=0;H<W;H++)try{return await N()}catch(B){z=B,await i(k)}throw z}e.retry=le;class K{hasPending(k){return this._pending?typeof k=="number"?this._pending.taskId===k:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(k,W,z){return this._pending={taskId:k,cancel:()=>z?.(),promise:W},W.then(()=>this.donePending(k),()=>this.donePending(k)),W}donePending(k){this._pending&&k===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const k=this._next;this._next=void 0,k.run().then(k.promiseResolve,k.promiseReject)}}setNext(k){if(this._next)this._next.run=k;else{let W,z;const H=new Promise((B,$)=>{W=B,z=$});this._next={run:k,promise:H,promiseResolve:W,promiseReject:z}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class V{constructor(k,W=()=>Date.now()){this.interval=k,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const k=this.nowFn();return k-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=k,this.value=0),this.value++,this.value}}e.IntervalCounter=V;var U;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(U||(U={}));class T{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((k,W)=>{this.completeCallback=k,this.errorCallback=W})}complete(k){return new Promise(W=>{this.completeCallback(k),this.outcome={outcome:0,value:k},W()})}error(k){return new Promise(W=>{this.errorCallback(k),this.outcome={outcome:1,value:k},W()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=T;var x;(function(N){async function k(z){let H;const B=await Promise.all(z.map($=>$.then(G=>G,G=>{H||(H=G)})));if(typeof H<"u")throw H;return B}N.settled=k;function W(z){return new Promise(async(H,B)=>{try{await z(H,B)}catch($){B($)}})}N.withAsyncBody=W})(x||(e.Promises=x={}));var Q;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(Q||(Q={}));class Z{static fromArray(k){return new Z(W=>{W.emitMany(k)})}static fromPromise(k){return new Z(async W=>{W.emitMany(await k)})}static fromPromises(k){return new Z(async W=>{await Promise.all(k.map(async z=>W.emitOne(await z)))})}static merge(k){return new Z(async W=>{await Promise.all(k.map(async z=>{for await(const H of z)W.emitOne(H)}))})}constructor(k){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const W={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(k(W)),this.resolve()}catch(z){this.reject(z)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let k=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(k<this._results.length)return{done:!1,value:this._results[k++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(k,W){return new Z(async z=>{for await(const H of k)z.emitOne(W(H))})}map(k){return Z.map(this,k)}static filter(k,W){return new Z(async z=>{for await(const H of k)W(H)&&z.emitOne(H)})}filter(k){return Z.filter(this,k)}static coalesce(k){return Z.filter(k,W=>!!W)}coalesce(){return Z.coalesce(this)}static async toPromise(k){const W=[];for await(const z of k)W.push(z);return W}toPromise(){return Z.toPromise(this)}emitOne(k){this._state===0&&(this._results.push(k),this._onStateChanged.fire())}emitMany(k){this._state===0&&(this._results=this._results.concat(k),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(k){this._state===0&&(this._state=2,this._error=k,this._onStateChanged.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class ae extends Z{constructor(k,W){super(W),this._source=k}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function oe(N){const k=new E.CancellationTokenSource,W=N(k.token);return new ae(k,async z=>{const H=k.token.onCancellationRequested(()=>{H.dispose(),k.dispose(),z.reject(new L.CancellationError)});try{for await(const B of W){if(k.token.isCancellationRequested)return;z.emitOne(B)}H.dispose(),k.dispose()}catch(B){H.dispose(),k.dispose(),z.reject(B)}})}e.createCancelableAsyncIterable=oe}),define(te[104],ie([0,1,24,7,32,35,9,3,25]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function c(){return Object.create(null)}e.getEmptyExpression=c,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const v="[/\\\\]",m="[^/\\\\]",S=/\//g;function u(V,U){switch(V){case 0:return"";case 1:return`${m}*?`;default:return`(?:${v}|${m}+${v}${U?`|${v}${m}+`:""})*?`}}function y(V,U){if(!V)return[];const T=[];let x=!1,Q=!1,Z="";for(const ae of V){switch(ae){case U:if(!x&&!Q){T.push(Z),Z="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}Z+=ae}return Z&&T.push(Z),T}e.splitGlobAware=y;function p(V){if(!V)return"";let U="";const T=y(V,e.GLOB_SPLIT);if(T.every(x=>x===e.GLOBSTAR))U=".*";else{let x=!1;T.forEach((Q,Z)=>{if(Q===e.GLOBSTAR){if(x)return;U+=u(2,Z===T.length-1)}else{let ae=!1,oe="",N=!1,k="";for(const W of Q){if(W!=="}"&&ae){oe+=W;continue}if(N&&(W!=="]"||!k)){let z;W==="-"?z=W:(W==="^"||W==="!")&&!k?z="^":W===e.GLOB_SPLIT?z="":z=(0,h.escapeRegExpCharacters)(W),k+=z;continue}switch(W){case"{":ae=!0;continue;case"[":N=!0;continue;case"}":{const H=`(?:${y(oe,",").map(B=>p(B)).join("|")})`;U+=H,ae=!1,oe="";break}case"]":{U+="["+k+"]",N=!1,k="";break}case"?":U+=m;continue;case"*":U+=u(1);continue;default:U+=(0,h.escapeRegExpCharacters)(W)}}Z<T.length-1&&(T[Z+1]!==e.GLOBSTAR||Z+2<T.length)&&(U+=v)}x=Q===e.GLOBSTAR})}return U}const s=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),l=function(){return!1},n=function(){return null};function i(V,U){if(!V)return n;let T;typeof V!="string"?T=V.pattern:T=V,T=T.trim();const x=`${T}_${!!U.trimForExclusions}`;let Q=t.get(x);if(Q)return o(Q,V);let Z;return s.test(T)?Q=g(T.substr(4),T):(Z=w.exec(d(T,U)))?Q=D(Z[1],T):(U.trimForExclusions?f:a).test(T)?Q=M(T,U):(Z=P.exec(d(T,U)))?Q=b(Z[1].substr(1),T,!0):(Z=C.exec(d(T,U)))?Q=b(Z[1],T,!1):Q=A(T),t.set(x,Q),o(Q,V)}function o(V,U){if(typeof U=="string")return V;const T=function(x,Q){return(0,r.isEqualOrParent)(x,U.base,!I.isLinux)?V((0,h.ltrim)(x.substr(U.base.length),R.sep),Q):null};return T.allBasenames=V.allBasenames,T.allPaths=V.allPaths,T.basenames=V.basenames,T.patterns=V.patterns,T}function d(V,U){return U.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function g(V,U){return function(T,x){return typeof T=="string"&&T.endsWith(V)?U:null}}function D(V,U){const T=`/${V}`,x=`\\${V}`,Q=function(ae,oe){return typeof ae!="string"?null:oe?oe===V?U:null:ae===V||ae.endsWith(T)||ae.endsWith(x)?U:null},Z=[V];return Q.basenames=Z,Q.patterns=[U],Q.allBasenames=Z,Q}function M(V,U){const T=le(V.slice(1,-1).split(",").map(oe=>i(oe,U)).filter(oe=>oe!==n),V),x=T.length;if(!x)return n;if(x===1)return T[0];const Q=function(oe,N){for(let k=0,W=T.length;k<W;k++)if(T[k](oe,N))return V;return null},Z=T.find(oe=>!!oe.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const ae=T.reduce((oe,N)=>N.allPaths?oe.concat(N.allPaths):oe,[]);return ae.length&&(Q.allPaths=ae),Q}function b(V,U,T){const x=R.sep===R.posix.sep,Q=x?V:V.replace(S,R.sep),Z=R.sep+Q,ae=R.posix.sep+V;let oe;return T?oe=function(N,k){return typeof N=="string"&&(N===Q||N.endsWith(Z)||!x&&(N===V||N.endsWith(ae)))?U:null}:oe=function(N,k){return typeof N=="string"&&(N===Q||!x&&N===V)?U:null},oe.allPaths=[(T?"*/":"./")+V],oe}function A(V){try{const U=new RegExp(`^${p(V)}$`);return function(T){return U.lastIndex=0,typeof T=="string"&&U.test(T)?V:null}}catch{return n}}function O(V,U,T){return!V||typeof U!="string"?!1:F(V)(U,void 0,T)}e.match=O;function F(V,U={}){if(!V)return l;if(typeof V=="string"||q(V)){const T=i(V,U);if(T===n)return l;const x=function(Q,Z){return!!T(Q,Z)};return T.allBasenames&&(x.allBasenames=T.allBasenames),T.allPaths&&(x.allPaths=T.allPaths),x}return ne(V,U)}e.parse=F;function q(V){const U=V;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.isRelativePattern=q;function re(V){return V.allBasenames||[]}e.getBasenameTerms=re;function Y(V){return V.allPaths||[]}e.getPathTerms=Y;function ne(V,U){const T=le(Object.getOwnPropertyNames(V).map(oe=>ce(oe,V[oe],U)).filter(oe=>oe!==n)),x=T.length;if(!x)return n;if(!T.some(oe=>!!oe.requiresSiblings)){if(x===1)return T[0];const oe=function(W,z){let H;for(let B=0,$=T.length;B<$;B++){const G=T[B](W,z);if(typeof G=="string")return G;(0,L.isThenable)(G)&&(H||(H=[]),H.push(G))}return H?(async()=>{for(const B of H){const $=await B;if(typeof $=="string")return $}return null})():null},N=T.find(W=>!!W.allBasenames);N&&(oe.allBasenames=N.allBasenames);const k=T.reduce((W,z)=>z.allPaths?W.concat(z.allPaths):W,[]);return k.length&&(oe.allPaths=k),oe}const Q=function(oe,N,k){let W,z;for(let H=0,B=T.length;H<B;H++){const $=T[H];$.requiresSiblings&&k&&(N||(N=(0,R.basename)(oe)),W||(W=N.substr(0,N.length-(0,R.extname)(oe).length)));const G=$(oe,N,W,k);if(typeof G=="string")return G;(0,L.isThenable)(G)&&(z||(z=[]),z.push(G))}return z?(async()=>{for(const H of z){const B=await H;if(typeof B=="string")return B}return null})():null},Z=T.find(oe=>!!oe.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const ae=T.reduce((oe,N)=>N.allPaths?oe.concat(N.allPaths):oe,[]);return ae.length&&(Q.allPaths=ae),Q}function ce(V,U,T){if(U===!1)return n;const x=i(V,T);if(x===n)return n;if(typeof U=="boolean")return x;if(U){const Q=U.when;if(typeof Q=="string"){const Z=(ae,oe,N,k)=>{if(!k||!x(ae,oe))return null;const W=Q.replace("$(basename)",()=>N),z=k(W);return(0,L.isThenable)(z)?z.then(H=>H?V:null):z?V:null};return Z.requiresSiblings=!0,Z}}return x}function le(V,U){const T=V.filter(oe=>!!oe.basenames);if(T.length<2)return V;const x=T.reduce((oe,N)=>{const k=N.basenames;return k?oe.concat(k):oe},[]);let Q;if(U){Q=[];for(let oe=0,N=x.length;oe<N;oe++)Q.push(U)}else Q=T.reduce((oe,N)=>{const k=N.patterns;return k?oe.concat(k):oe},[]);const Z=function(oe,N){if(typeof oe!="string")return null;if(!N){let W;for(W=oe.length;W>0;W--){const z=oe.charCodeAt(W-1);if(z===47||z===92)break}N=oe.substr(W)}const k=x.indexOf(N);return k!==-1?Q[k]:null};Z.basenames=x,Z.patterns=Q,Z.allBasenames=x;const ae=V.filter(oe=>!oe.basenames);return ae.push(Z),ae}function K(V,U){return(0,E.equals)(V,U,(T,x)=>typeof T=="string"&&typeof x=="string"?T===x:typeof T!="string"&&typeof x!="string"?T.base===x.base&&T.pattern===x.pattern:!1)}e.patternsEquals=K}),define(te[45],ie([0,1,24,32,9,3,18,25]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,o){const{os:d,tildify:g,relative:D}=o;if(D){const A=c(i,D,d);if(typeof A=="string")return A}let M=i.fsPath;if(d===1&&!_.isWindows?M=M.replace(/\//g,"\\"):d!==1&&_.isWindows&&(M=M.replace(/\\/g,"/")),d!==1&&g?.userHome){const A=g.userHome.fsPath;let O;i.scheme!==g.userHome.scheme&&i.path.startsWith(r.posix.sep)?O=g.userHome.with({path:i.path}).fsPath:O=i.fsPath,M=S(O,A,d)}return(d===1?r.win32:r.posix).normalize(v(M,d===1))}e.getPathLabel=h;function c(i,o,d){const g=d===1?r.win32:r.posix,D=d===3?R.extUri:R.extUriIgnorePathCase,M=o.getWorkspace(),b=(0,E.firstOrDefault)(M.folders);if(!b)return;i.scheme!==b.uri.scheme&&i.path.startsWith(r.posix.sep)&&(i=b.uri.with({path:i.path}));const A=o.getWorkspaceFolder(i);if(!A)return;let O;if(D.isEqual(A.uri,i)?O="":O=D.relativePath(A.uri,i)??"",O&&(O=g.normalize(O)),M.folders.length>1&&!o.noPrefix){const F=A.name?A.name:D.basenameOrAuthority(A.uri);O=O?`${F} \u2022 ${O}`:F}return O}function v(i,o=_.isWindows){return(0,L.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=v;let m=Object.create(null);function S(i,o,d=_.OS){if(d===1||!i||!o)return i;let g=m.original===o?m.normalized:void 0;g||(g=o,_.isWindows&&(g=(0,L.toSlashes)(g)),g=`${(0,I.rtrim)(g,r.posix.sep)}${r.posix.sep}`,m={original:o,normalized:g});let D=i;return _.isWindows&&(D=(0,L.toSlashes)(D)),(d===3?D.startsWith(g):(0,I.startsWithIgnoreCase)(D,g))?`~/${D.substr(g.length)}`:i}e.tildify=S;function u(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=u;const y="\u2026",p="\\\\",s="~";function w(i,o=r.sep){const d=new Array(i.length);let g=!1;for(let D=0;D<i.length;D++){const M=i[D];if(M===""){d[D]=`.${o}`;continue}if(!M){d[D]=M;continue}g=!0;let b="",A=M;A.indexOf(p)===0?(b=A.substr(0,A.indexOf(p)+p.length),A=A.substr(A.indexOf(p)+p.length)):A.indexOf(o)===0?(b=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length)):A.indexOf(s)===0&&(b=A.substr(0,A.indexOf(s)+s.length),A=A.substr(A.indexOf(s)+s.length));const O=A.split(o);for(let F=1;g&&F<=O.length;F++)for(let q=O.length-F;g&&q>=0;q--){g=!1;let re=O.slice(q,q+F).join(o);for(let Y=0;!g&&Y<i.length;Y++)if(Y!==D&&i[Y]&&i[Y].indexOf(re)>-1){const ne=q+F===O.length,ce=q>0&&i[Y].indexOf(o)>-1?o+re:re,le=i[Y].endsWith(ce);g=!ne||le}if(!g){let Y="";(O[0].endsWith(":")||b!=="")&&(q===1&&(q=0,F++,re=O[0]+o+re),q>0&&(Y=O[0]+o),Y=b+Y),q>0&&(Y=Y+y+o),Y=Y+re,q+F<O.length&&(Y=Y+o+y),d[D]=Y}}g&&(d[D]=M)}return d}e.shorten=w;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function f(i,o=Object.create(null)){const d=[];let g=!1,D="";for(const M of i)if(M==="$"||g&&M==="{")D&&d.push({value:D,type:a.TEXT}),D="",g=!0;else if(M==="}"&&g){const b=o[D];if(typeof b=="string")b.length&&d.push({value:b,type:a.VARIABLE});else if(b){const A=d[d.length-1];(!A||A.type!==a.SEPARATOR)&&d.push({value:b.label,type:a.SEPARATOR})}D="",g=!1}else D+=M;return D&&!g&&d.push({value:D,type:a.TEXT}),d.filter((M,b)=>{if(M.type===a.SEPARATOR){const A=d[b-1],O=d[b+1];return[A,O].every(F=>F&&(F.type===a.VARIABLE||F.type===a.TEXT)&&F.value.length>0)}return!0}).map(M=>M.value).join("")}e.template=f;function P(i,o){return _.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function C(i,o){return _.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):_.isWindows?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=C;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function l(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const d=n(i.substring(0,o));return{name:d.name,parentPath:d.parentPath+i.substring(o)}}}return n(i)}e.splitRecentLabel=l;function n(i){const o=i.indexOf("/")!==-1?r.posix:r.win32,d=o.basename(i),g=o.dirname(i);return d.length?{name:d,parentPath:g}:{name:g,parentPath:""}}}),define(te[153],ie([0,1,17,8]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(m){return m.toJSON()}class _{constructor(S){this._uriTransformer=S}transformIncoming(S){const u=this._uriTransformer.transformIncoming(S);return u===S?S:r(L.URI.from(u))}transformOutgoing(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:r(L.URI.from(u))}transformOutgoingURI(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:L.URI.from(u)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function R(m,S,u){if(!m||u>200)return null;if(typeof m=="object"){if(m instanceof L.URI)return S.transformOutgoing(m);for(const y in m)if(Object.hasOwnProperty.call(m,y)){const p=R(m[y],S,u+1);p!==null&&(m[y]=p)}}return null}function I(m,S){const u=R(m,S,0);return u===null?m:u}e.transformOutgoingURIs=I;function h(m,S,u,y){if(!m||y>200)return null;if(typeof m=="object"){if(m.$mid===1)return u?L.URI.revive(S.transformIncoming(m)):S.transformIncoming(m);if(m instanceof E.VSBuffer)return null;for(const p in m)if(Object.hasOwnProperty.call(m,p)){const s=h(m[p],S,u,y+1);s!==null&&(m[p]=s)}}return null}function c(m,S){const u=h(m,S,!1,0);return u===null?m:u}e.transformIncomingURIs=c;function v(m,S){const u=h(m,S,!0,0);return u===null?m:u}e.transformAndReviveIncomingURIs=v}),define(te[86],ie([0,1,27,62,31,141]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(c){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(c)}value(){if(this._value===void 0){let c=0,v=0;const m=(0,E.networkInterfaces)();for(const S in m){const u=m[S];if(u)for(const{mac:y,internal:p}of u)p||(v+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(c+=1))}this._value=v>0?c/v:0}return this._value}};let R;async function I(c){return R||(R=(async()=>await h(c)||r.generateUuid())()),R}e.getMachineId=I;async function h(c){try{const v=await new Promise((S,u)=>{j(["crypto"],S,u)}),m=(0,_.getMac)();return v.createHash("sha256").update(m,"utf8").digest("hex")}catch(v){c(v);return}}}),define(te[22],ie([0,1,42,27,154,7,32,83,9,3,18,8]),function(j,e,E,L,r,_,R,I,h,c,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function u(ne,ce=S.UNLINK,le){if((0,R.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");return ce===S.UNLINK?p(ne):y(ne,le)}async function y(ne,ce=(0,R.randomPath)((0,L.tmpdir)())){try{try{await E.promises.rename(ne,ce)}catch(le){return le.code==="ENOENT"?void 0:p(ne)}p(ce).catch(le=>{})}catch(le){if(le.code!=="ENOENT")throw le}}async function p(ne){return(0,r.promisify)(E.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function s(ne){if((0,R.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function w(ne,ce){return P(await(ce?a(ne):(0,r.promisify)(E.readdir)(ne)))}async function a(ne){try{return await(0,r.promisify)(E.readdir)(ne,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ce=[],le=await w(ne);for(const K of le){let V=!1,U=!1,T=!1;try{const x=await e.Promises.lstat((0,h.join)(ne,K));V=x.isFile(),U=x.isDirectory(),T=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}ce.push({name:K,isFile:()=>V,isDirectory:()=>U,isSymbolicLink:()=>T})}return ce}function f(ne){return P(E.readdirSync(ne))}e.readdirSync=f;function P(ne){return ne.map(ce=>typeof ce=="string"?c.isMacintosh?(0,I.normalizeNFC)(ce):ce:(ce.name=c.isMacintosh?(0,I.normalizeNFC)(ce.name):ce.name,ce))}async function C(ne){const ce=await w(ne),le=[];for(const K of ce)await l.existsDirectory((0,h.join)(ne,K))&&le.push(K);return le}function t(ne,ce=1e3){return new Promise(le=>{let K=!1;const V=setInterval(()=>{K||(K=!0,E.access(ne,U=>{K=!1,U&&(clearInterval(V),le(void 0))}))},ce)})}e.whenDeleted=t;var l;(function(ne){async function ce(V){let U;try{if(U=await e.Promises.lstat(V),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(c.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw x}throw T}}ne.stat=ce;async function le(V){try{const{stat:U,symbolicLink:T}=await ne.stat(V);return U.isFile()&&T?.dangling!==!0}catch{}return!1}ne.existsFile=le;async function K(V){try{const{stat:U,symbolicLink:T}=await ne.stat(V);return U.isDirectory()&&T?.dangling!==!0}catch{}return!1}ne.existsDirectory=K})(l||(e.SymlinkSupport=l={}));const n=new _.ResourceQueue;function i(ne,ce,le){return n.queueFor(m.URI.file(ne),v.extUriBiasedIgnorePathCase).queue(()=>{const K=M(le);return new Promise((V,U)=>g(ne,ce,K,T=>T?U(T):V()))})}let o=!0;function d(ne){o=ne}e.configureFlushOnWrite=d;function g(ne,ce,le,K){if(!o)return E.writeFile(ne,ce,{mode:le.mode,flag:le.flag},K);E.open(ne,le.flag,le.mode,(V,U)=>{if(V)return K(V);E.writeFile(U,ce,T=>{if(T)return E.close(U,()=>K(T));E.fdatasync(U,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),d(!1)),E.close(U,Q=>K(Q))))})})}function D(ne,ce,le){const K=M(le);if(!o)return E.writeFileSync(ne,ce,{mode:K.mode,flag:K.flag});const V=E.openSync(ne,K.flag,K.mode);try{E.writeFileSync(V,ce);try{E.fdatasyncSync(V)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),d(!1)}}finally{E.closeSync(V)}}e.writeFileSync=D;function M(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function b(ne,ce){if(ne!==ce)try{await e.Promises.rename(ne,ce)}catch(le){if(ne.toLowerCase()!==ce.toLowerCase()&&le.code==="EXDEV"||ne.endsWith("."))await A(ne,ce,{preserveSymlinks:!1}),await u(ne,S.MOVE);else throw le}}async function A(ne,ce,le){return F(ne,ce,{root:{source:ne,target:ce},options:le,handledSourcePaths:new Set})}const O=511;async function F(ne,ce,le){if(le.handledSourcePaths.has(ne))return;le.handledSourcePaths.add(ne);const{stat:K,symbolicLink:V}=await l.stat(ne);if(V){if(le.options.preserveSymlinks)try{return await Y(ne,ce,le)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(V.dangling)return}return K.isDirectory()?q(ne,ce,K.mode&O,le):re(ne,ce,K.mode&O)}async function q(ne,ce,le,K){await e.Promises.mkdir(ce,{recursive:!0,mode:le});const V=await w(ne);for(const U of V)await F((0,h.join)(ne,U),(0,h.join)(ce,U),K)}async function re(ne,ce,le){await e.Promises.copyFile(ne,ce),await e.Promises.chmod(ce,le)}async function Y(ne,ce,le){let K=await e.Promises.readlink(ne);(0,R.isEqualOrParent)(K,le.root.source,!c.isLinux)&&(K=(0,h.join)(le.root.target,K.substr(le.root.source.length+1))),await e.Promises.symlink(K,ce)}e.Promises=new class{get access(){return(0,r.promisify)(E.access)}get stat(){return(0,r.promisify)(E.stat)}get lstat(){return(0,r.promisify)(E.lstat)}get utimes(){return(0,r.promisify)(E.utimes)}get read(){return(ne,ce,le,K,V)=>new Promise((U,T)=>{E.read(ne,ce,le,K,V,(x,Q,Z)=>x?T(x):U({bytesRead:Q,buffer:Z}))})}get readFile(){return(0,r.promisify)(E.readFile)}get write(){return(ne,ce,le,K,V)=>new Promise((U,T)=>{E.write(ne,ce,le,K,V,(x,Q,Z)=>x?T(x):U({bytesWritten:Q,buffer:Z}))})}get appendFile(){return(0,r.promisify)(E.appendFile)}get fdatasync(){return(0,r.promisify)(E.fdatasync)}get truncate(){return(0,r.promisify)(E.truncate)}get rename(){return(0,r.promisify)(E.rename)}get copyFile(){return(0,r.promisify)(E.copyFile)}get open(){return(0,r.promisify)(E.open)}get close(){return(0,r.promisify)(E.close)}get symlink(){return(0,r.promisify)(E.symlink)}get readlink(){return(0,r.promisify)(E.readlink)}get chmod(){return(0,r.promisify)(E.chmod)}get mkdir(){return(0,r.promisify)(E.mkdir)}get unlink(){return(0,r.promisify)(E.unlink)}get rmdir(){return(0,r.promisify)(E.rmdir)}get realpath(){return(0,r.promisify)(E.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return C}get writeFile(){return i}get rm(){return u}get move(){return b}get copy(){return A}}}),define(te[105],ie([0,1,42,9,3,25,22]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(r.isLinux)return S;const u=(0,L.dirname)(S);if(S===u)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const s=(0,R.readdirSync)(u).filter(w=>w.toLowerCase()===y);if(s.length===1){const w=I(u);if(w)return(0,L.join)(w,s[0])}else if(s.length>1){const w=s.indexOf(y);if(w>=0){const a=I(u);if(a)return(0,L.join)(a,s[w])}}}catch{}return null}e.realcaseSync=I;async function h(S){if(r.isLinux)return S;const u=(0,L.dirname)(S);if(S===u)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const s=(await R.Promises.readdir(u)).filter(w=>w.toLowerCase()===y);if(s.length===1){const w=await h(u);if(w)return(0,L.join)(w,s[0])}else if(s.length>1){const w=s.indexOf(y);if(w>=0){const a=await h(u);if(a)return(0,L.join)(a,s[w])}}}catch{}return null}e.realcase=h;async function c(S){try{return await R.Promises.realpath(S)}catch{const y=m(S);return await R.Promises.access(y,E.constants.R_OK),y}}e.realpath=c;function v(S){try{return E.realpathSync(S)}catch{const y=m(S);return E.accessSync(y,E.constants.R_OK),y}}e.realpathSync=v;function m(S){return(0,_.rtrim)((0,L.normalize)(S),L.sep)}}),define(te[106],ie([0,1,27,9,22]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,R=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(P){P[P.x64=0]="x64",P[P.x86=1]="x86",P[P.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class m{constructor(C,t,l){this.exePath=C,this.displayName=t,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:P=!1}={}){return P?c===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:P=!1,findPreview:C=!1}={}){const t=S({useAlternateBitness:P});if(!t)return null;const l=L.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(l))return null;let n=-1,i=null;for(const g of await r.Promises.readdir(l)){let D=-1;if(C){const b=g.indexOf("-");if(b<0)continue;const A=g.substring(0,b);if(!_.test(A)||g.substring(b+1)!=="preview")continue;D=parseInt(A,10)}else{if(!_.test(g))continue;D=parseInt(g,10)}if(D<=n)continue;const M=L.join(l,g,"pwsh.exe");await r.SymlinkSupport.existsFile(M)&&(i=M,n=D)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",d=C?" Preview":"";return new m(i,`PowerShell${d}${o}`,!0)}async function y({findPreview:P}={}){if(!process.env.LOCALAPPDATA)return null;const C=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=P?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const n of await r.Promises.readdir(C))if(t.test(n)){const i=L.join(C,n,"pwsh.exe");return new m(i,l)}return null}function p(){const P=L.join(E.homedir(),".dotnet","tools","pwsh.exe");return new m(P,".NET Core PowerShell Global Tool")}function s(){const P=L.join(process.env.windir,c===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(P,"Windows PowerShell",!0)}async function*w(){let P=await u();P&&(yield P),P=await u({useAlternateBitness:!0}),P&&(yield P),P=await y(),P&&(yield P),P=p(),P&&(yield P),P=await u({findPreview:!0}),P&&(yield P),P=await y({findPreview:!0}),P&&(yield P),P=await u({useAlternateBitness:!0,findPreview:!0}),P&&(yield P),P=s(),P&&(yield P)}async function*a(){for await(const P of w())await P.exists()&&(yield P)}e.enumeratePowerShellInstallations=a;async function f(){for await(const P of a())return P;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[87],ie([0,1,9,3,36,71,11,22]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return _.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return _.TerminateResponseCode}});function h(m=r.env){return m.comspec||"cmd.exe"}e.getWindowsShell=h;function c(m){let S=[],u=!1;const y=function(p){if(u){S.push(p);return}(!m.send(p,w=>{if(w&&console.error(w),u=!1,S.length>0){const a=S.slice(0);S=[],a.forEach(f=>y(f))}})||L.isWindows)&&(u=!0)};return{send:y}}e.createQueuedSender=c;var v;(function(m){async function S(u,y,p){if(E.isAbsolute(u))return u;if(y===void 0&&(y=r.cwd()),E.dirname(u)!=="."||(p===void 0&&R.isString(r.env.PATH)&&(p=r.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(y,u);async function w(a){if(await I.Promises.exists(a)){let f;try{f=await I.Promises.stat(a)}catch(P){P.message.startsWith("EACCES")&&(f=await I.Promises.lstat(a))}return f?!f.isDirectory():!1}return!1}for(const a of p){let f;if(E.isAbsolute(a)?f=E.join(a,u):f=E.join(y,a,u),await w(f))return f;let P=f+".com";if(await w(P)||(P=f+".exe",await w(P)))return P}return E.join(y,u)}m.findExecutable=S})(v||(e.win32=v={}))}),define(te[107],ie([0,1,46,14]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(R){return new Promise((I,h)=>{let c;const v=new Map;function m(u,y,p,s,w){const a=v.get(y);if(u===R||a){const f={name:S(p),cmd:p,pid:u,ppid:y,load:s,mem:w};v.set(u,f),u===R&&(c=f),a&&(a.children||(a.children=[]),a.children.push(f),a.children.length>1&&(a.children=a.children.sort((P,C)=>P.pid-C.pid)))}}function S(u){const y=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,s=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,a=/conhost\.exe/i,f=/--type=([a-zA-Z-]+)/;if(s.exec(u))return"electron-crash-reporter";if(w.exec(u))return"winpty-process";if(a.exec(u))return"console-window-host (Windows internal process)";let P=f.exec(u);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?y.exec(u)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const C=/[a-zA-Z-]+\.js/g;let t="";do P=C.exec(u),P&&(t+=P+" ");while(P);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:p.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substr(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substr(5):y;new Promise((y,p)=>{j(["@vscode/windows-process-tree"],y,p)}).then(y=>{y.getProcessList(R,p=>{if(!p){h(new Error(`Root process ${R} not found`));return}y.getProcessCpuUsage(p,s=>{const w=new Map;s.forEach(a=>{const f=u(a.commandLine||"");w.set(a.pid,{name:S(f),cmd:f,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),c=w.get(R),c?(w.forEach(a=>{const f=w.get(a.ppid);f&&(f.children||(f.children=[]),f.children.push(a))}),w.forEach(a=>{a.children&&(a.children=a.children.sort((f,P)=>f.pid-P.pid))}),I(c)):h(new Error(`Root process ${R} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let u=function(){let y=[c];const p=[];for(;y.length;){const w=y.shift();w&&(p.push(w.pid),w.children&&(y=y.concat(w.children)))}let s=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+p.join(" "),(0,E.exec)(s,{},(w,a,f)=>{if(w||f)h(w||new Error(f.toString()));else{const P=a.toString().split(`
`);for(let C=0;C<p.length;C++){const t=v.get(p[C]);t.load=parseFloat(P[C])}if(!c){h(new Error(`Root process ${R} not found`));return}I(c)}})};(0,E.exec)("which ps",{},(y,p,s)=>{if(y||s)if(process.platform!=="linux")h(y||new Error(s.toString()));else{const w=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(w,{},(a,f,P)=>{a||P?h(a||new Error(P.toString())):(_(f,m),u())})}else{const w=p.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${w} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,P,C)=>{f||C&&!C.includes("screen size is bogus")?h(f||new Error(C.toString())):(_(P,m),process.platform==="linux"?u():c?I(c):h(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=r;function _(R,I){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=R.toString().split(`
`);for(const v of c){const m=h.exec(v.trim());m&&m.length===6&&I(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(te[155],ie([0,1,27,3,106,87]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(m,S){return m===1?L.isWindows?v():_.getWindowsShell(S):h(m,S)}e.getSystemShell=R;let I=null;function h(m,S){if(L.isLinux&&m===2||L.isMacintosh&&m===3)return"/bin/bash";if(!I){let u;if(L.isWindows)u="/bin/bash";else{if(u=S.SHELL,!u)try{u=(0,E.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}I=u}return I}let c=null;async function v(){return c||(c=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),c}});var Se=this&&this.__decorate||function(j,e,E,L){var r=arguments.length,_=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(j,e,E,L);else for(var I=j.length-1;I>=0;I--)(R=j[I])&&(_=(r<3?R(_):r>3?R(e,E,_):R(e,E))||_);return r>3&&_&&Object.defineProperty(e,E,_),_};define(te[43],ie([0,1,24,7,17,21,55,13,4,2,73,25,11]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(u||(u={}));function y(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(p||(p={}));function s(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(w||(w={}));function a(U){let T=0;for(let x=0;;x+=7){const Q=U.read(1);if(T|=(Q.buffer[0]&127)<<x,!(Q.buffer[0]&128))return T}}const f=n(0);function P(U,T){if(T===0){U.write(f);return}let x=0;for(let Z=T;Z!==0;Z=Z>>>7)x++;const Q=r.VSBuffer.alloc(x);for(let Z=0;T!==0;Z++)Q.buffer[Z]=T&127,T=T>>>7,T>0&&(Q.buffer[Z]|=128);U.write(Q)}class C{constructor(T){this.buffer=T,this.pos=0}read(T){const x=this.buffer.slice(this.pos,this.pos+T);return this.pos+=x.byteLength,x}}e.BufferReader=C;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}e.BufferWriter=t;var l;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(l||(l={}));function n(U){const T=r.VSBuffer.alloc(1);return T.writeUInt8(U,0),T}const i={Undefined:n(l.Undefined),String:n(l.String),Buffer:n(l.Buffer),VSBuffer:n(l.VSBuffer),Array:n(l.Array),Object:n(l.Object),Uint:n(l.Int)},o=typeof Buffer<"u";function d(U,T){if(typeof T>"u")U.write(i.Undefined);else if(typeof T=="string"){const x=r.VSBuffer.fromString(T);U.write(i.String),P(U,x.byteLength),U.write(x)}else if(o&&Buffer.isBuffer(T)){const x=r.VSBuffer.wrap(T);U.write(i.Buffer),P(U,x.byteLength),U.write(x)}else if(T instanceof r.VSBuffer)U.write(i.VSBuffer),P(U,T.byteLength),U.write(T);else if(Array.isArray(T)){U.write(i.Array),P(U,T.length);for(const x of T)d(U,x)}else if(typeof T=="number"&&(T|0)===T)U.write(i.Uint),P(U,T);else{const x=r.VSBuffer.fromString(JSON.stringify(T));U.write(i.Object),P(U,x.byteLength),U.write(x)}}e.serialize=d;function g(U){switch(U.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return U.read(a(U)).toString();case l.Buffer:return U.read(a(U)).buffer;case l.VSBuffer:return U.read(a(U));case l.Array:{const x=a(U),Q=[];for(let Z=0;Z<x;Z++)Q.push(g(U));return Q}case l.Object:return JSON.parse(U.read(a(U)).toString());case l.Int:return a(U)}}e.deserialize=g;class D{constructor(T,x,Q=null,Z=1e3){this.protocol=T,this.ctx=x,this.logger=Q,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(T,x){this.channels.set(T,x),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const x=this.send([T.type]);this.logger?.logOutgoing(x,0,1,s(T.type));return}case 201:case 202:case 204:case 203:{const x=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(x,T.id,1,s(T.type),T.data);return}}}send(T,x=void 0){const Q=new t;return d(Q,T),d(Q,x),this.sendBuffer(Q.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const x=new C(T),Q=g(x),Z=g(x),ae=Q[0];switch(ae){case 100:return this.logger?.logIncoming(T.byteLength,Q[1],1,`${y(ae)}: ${Q[2]}.${Q[3]}`,Z),this.onPromise({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:Z});case 102:return this.logger?.logIncoming(T.byteLength,Q[1],1,`${y(ae)}: ${Q[2]}.${Q[3]}`,Z),this.onEventListen({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:Z});case 101:return this.logger?.logIncoming(T.byteLength,Q[1],1,`${y(ae)}`),this.disposeActiveRequest({type:ae,id:Q[1]});case 103:return this.logger?.logIncoming(T.byteLength,Q[1],1,`${y(ae)}`),this.disposeActiveRequest({type:ae,id:Q[1]})}}onPromise(T){const x=this.channels.get(T.channelName);if(!x){this.collectPendingRequest(T);return}const Q=new _.CancellationTokenSource;let Z;try{Z=x.call(this.ctx,T.name,T.arg,Q.token)}catch(N){Z=Promise.reject(N)}const ae=T.id;Z.then(N=>{this.sendResponse({id:ae,data:N,type:201}),this.activeRequests.delete(T.id)},N=>{N instanceof Error?this.sendResponse({id:ae,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:ae,data:N,type:203}),this.activeRequests.delete(T.id)});const oe=(0,c.toDisposable)(()=>Q.cancel());this.activeRequests.set(T.id,oe)}onEventListen(T){const x=this.channels.get(T.channelName);if(!x){this.collectPendingRequest(T);return}const Q=T.id,ae=x.listen(this.ctx,T.name,T.arg)(oe=>this.sendResponse({id:Q,data:oe,type:204}));this.activeRequests.set(T.id,ae)}disposeActiveRequest(T){const x=this.activeRequests.get(T.id);x&&(x.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let x=this.pendingRequests.get(T.channelName);x||(x=[],this.pendingRequests.set(T.channelName,x));const Q=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:T,timeoutTimer:Q})}flushPendingRequests(T){const x=this.pendingRequests.get(T);if(x){for(const Q of x)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var M;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class b{constructor(T,x=null){this.protocol=T,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=x}getChannel(T){const x=this;return{call(Q,Z,ae){return x.isDisposed?Promise.reject(new I.CancellationError):x.requestPromise(T,Q,Z,ae)},listen(Q,Z){return x.isDisposed?h.Event.None:x.requestEvent(T,Q,Z)}}}requestPromise(T,x,Q,Z=_.CancellationToken.None){const ae=this.lastRequestId++,N={id:ae,type:100,channelName:T,name:x,arg:Q};if(Z.isCancellationRequested)return Promise.reject(new I.CancellationError);let k;return new Promise((z,H)=>{if(Z.isCancellationRequested)return H(new I.CancellationError);const B=()=>{const ue=ye=>{switch(ye.type){case 201:this.handlers.delete(ae),z(ye.data);break;case 202:{this.handlers.delete(ae);const Ce=new Error(ye.data.message);Ce.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,Ce.name=ye.data.name,H(Ce);break}case 203:this.handlers.delete(ae),H(ye.data);break}};this.handlers.set(ae,ue),this.sendRequest(N)};let $=null;this.state===w.Idle?B():($=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),$.then(()=>{$=null,B()}));const G=()=>{$?($.cancel(),$=null):this.sendRequest({id:ae,type:101}),H(new I.CancellationError)},se=Z.onCancellationRequested(G);k=(0,c.combinedDisposable)((0,c.toDisposable)(G),se),this.activeRequests.add(k)}).finally(()=>{this.activeRequests.delete(k)})}requestEvent(T,x,Q){const Z=this.lastRequestId++,oe={id:Z,type:102,channelName:T,name:x,arg:Q};let N=null;const k=new h.Emitter({onWillAddFirstListener:()=>{N=(0,L.createCancelablePromise)(z=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(k),this.sendRequest(oe)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(k),this.sendRequest({id:Z,type:103}))}}),W=z=>k.fire(z.data);return this.handlers.set(Z,W),k.event}sendRequest(T){switch(T.type){case 100:case 102:{const x=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger?.logOutgoing(x,T.id,0,`${y(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const x=this.send([T.type,T.id]);this.logger?.logOutgoing(x,T.id,0,y(T.type));return}}}send(T,x=void 0){const Q=new t;return d(Q,T),d(Q,x),this.sendBuffer(Q.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const x=new C(T),Q=g(x),Z=g(x),ae=Q[0];switch(ae){case 200:return this.logger?.logIncoming(T.byteLength,0,0,s(ae)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(T.byteLength,Q[1],0,s(ae),Z),this.onResponse({type:Q[0],id:Q[1],data:Z})}}onResponse(T){if(T.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}this.handlers.get(T.id)?.(T)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=b,Se([R.memoize],b.prototype,"onDidInitializePromise",null);class A{get connections(){const T=[];return this._connections.forEach(x=>T.push(x)),T}constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:x,onDidClientDisconnect:Q})=>{h.Event.once(x.onMessage)(ae=>{const oe=new C(ae),N=g(oe),k=new D(x,N),W=new b(x);this.channels.forEach((H,B)=>k.registerChannel(B,H));const z={channelServer:k,channelClient:W,ctx:N};this._connections.add(z),this._onDidAddConnection.fire(z),Q(()=>{k.dispose(),W.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}getChannel(T,x){const Q=this;return{call(Z,ae,oe){let N;if((0,S.isFunction)(x)){const W=(0,E.getRandomElement)(Q.connections.filter(x));N=W?Promise.resolve(W):h.Event.toPromise(h.Event.filter(Q.onDidAddConnection,x))}else N=x.routeCall(Q,Z,ae);const k=N.then(W=>W.channelClient.getChannel(T));return F(k).call(Z,ae,oe)},listen(Z,ae){if((0,S.isFunction)(x))return Q.getMulticastEvent(T,x,Z,ae);const oe=x.routeEvent(Q,Z,ae).then(N=>N.channelClient.getChannel(T));return F(oe).listen(Z,ae)}}}getMulticastEvent(T,x,Q,Z){const ae=this;let oe=new c.DisposableStore;const N=new h.Emitter({onWillAddFirstListener:()=>{oe=new c.DisposableStore;const k=new h.EventMultiplexer,W=new Map,z=B=>{const G=B.channelClient.getChannel(T).listen(Q,Z),se=k.add(G);W.set(B,se)},H=B=>{const $=W.get(B);$&&($.dispose(),W.delete(B))};ae.connections.filter(x).forEach(z),h.Event.filter(ae.onDidAddConnection,x)(z,void 0,oe),ae.onDidRemoveConnection(H,void 0,oe),k.event(N.fire,N,oe),oe.add(k)},onDidRemoveLastListener:()=>{oe.dispose()}});return N.event}registerChannel(T,x){this.channels.set(T,x),this._connections.forEach(Q=>{Q.channelServer.registerChannel(T,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(T,x,Q=null){const Z=new t;d(Z,x),T.send(Z.buffer),this.channelClient=new b(T,Q),this.channelServer=new D(T,x,Q)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,x){this.channelServer.registerChannel(T,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(U){return{call(T,x,Q){return U.then(Z=>Z.call(T,x,Q))},listen(T,x){const Q=new h.Relay;return U.then(Z=>Q.input=Z.listen(T,x)),Q.event}}}e.getDelayedChannel=F;function q(U){let T=!1;return{call(x,Q,Z){return T?U.call(x,Q,Z):(0,L.timeout)(0).then(()=>T=!0).then(()=>U.call(x,Q,Z))},listen(x,Q){if(T)return U.listen(x,Q);const Z=new h.Relay;return(0,L.timeout)(0).then(()=>T=!0).then(()=>Z.input=U.listen(x,Q)),Z.event}}}e.getNextTickChannel=q;class re{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const x of T.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await h.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=re;var Y;(function(U){function T(ae,oe){const N=ae,k=oe&&oe.disableMarshalling,W=new Map;for(const z in N)Q(z)&&W.set(z,h.Event.buffer(N[z],!0));return new class{listen(z,H,B){const $=W.get(H);if($)return $;if(Z(H)){const G=N[H];if(typeof G=="function")return G.call(N,B)}throw new Error(`Event not found: ${H}`)}call(z,H,B){const $=N[H];if(typeof $=="function"){if(!k&&Array.isArray(B))for(let G=0;G<B.length;G++)B[G]=(0,v.revive)(B[G]);return $.apply(N,B)}throw new Error(`Method not found: ${H}`)}}}U.fromService=T;function x(ae,oe){const N=oe&&oe.disableMarshalling;return new Proxy({},{get(k,W){if(typeof W=="string")return oe?.properties?.has(W)?oe.properties.get(W):Z(W)?function(z){return ae.listen(W,z)}:Q(W)?ae.listen(W):async function(...z){let H;oe&&!(0,S.isUndefinedOrNull)(oe.context)?H=[oe.context,...z]:H=z;const B=await ae.call(W,H);return N?B:(0,v.revive)(B)};throw new Error(`Property not found: ${String(W)}`)}})}U.toService=x;function Q(ae){return ae[0]==="o"&&ae[1]==="n"&&m.isUpperAsciiLetter(ae.charCodeAt(2))}function Z(ae){return/^onDynamic/.test(ae)&&m.isUpperAsciiLetter(ae.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const T=U.toString();if(T!=="[object Object]")return T}return U}function le(U){return Array.isArray(U)?U.map(ce):ce(U)}function K(U,T,x,Q,Z,ae,oe){oe=le(oe);const N=ne[Z],k=N[Q%N.length];let W=[`%c[${U}]%c[${String(T).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(ae)?(W=W.concat(oe),W.push(")")):W.push(oe),console.log.apply(console,W)}class V{constructor(T,x){this._outgoingPrefix=T,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,x,Q,Z,ae){this._totalOutgoing+=T,K(this._outgoingPrefix,this._totalOutgoing,T,x,Q,Z,ae)}logIncoming(T,x,Q,Z,ae){this._totalIncoming+=T,K(this._incomingPrefix,this._totalIncoming,T,x,Q,Z,ae)}}e.IPCLogger=V}),define(te[156],ie([0,1,17,4,43]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",c=>E.VSBuffer.wrap(c.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class R extends r.IPCClient{constructor(h,c){const v=new _(h);super(v,c),this.protocol=v}dispose(){this.protocol.disconnect()}}e.Client=R}),define(te[108],ie([0,1,7,17,4,2,43]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(b){b.Created="created",b.Read="read",b.Write="write",b.Open="open",b.Error="error",b.Close="close",b.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",b.NodeEndReceived="nodeEndReceived",b.NodeEndSent="nodeEndSent",b.NodeDrainBegin="nodeDrainBegin",b.NodeDrainEnd="nodeDrainEnd",b.zlibInflateError="zlibInflateError",b.zlibInflateData="zlibInflateData",b.zlibInflateInitialWrite="zlibInflateInitialWrite",b.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",b.zlibInflateWrite="zlibInflateWrite",b.zlibInflateFlushFired="zlibInflateFlushFired",b.zlibDeflateError="zlibDeflateError",b.zlibDeflateData="zlibDeflateData",b.zlibDeflateWrite="zlibDeflateWrite",b.zlibDeflateFlushFired="zlibDeflateFlushFired",b.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",b.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",b.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",b.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",b.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",b.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",b.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",b.ProtocolHeaderRead="protocolHeaderRead",b.ProtocolMessageRead="protocolMessageRead",b.ProtocolHeaderWrite="protocolHeaderWrite",b.ProtocolMessageWrite="protocolMessageWrite",b.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var h;(function(b){b.enableDiagnostics=!1,b.records=[];const A=new WeakMap;let O=0;function F(re,Y){if(!A.has(re)){const ne=String(++O);A.set(re,ne)}return A.get(re)}function q(re,Y,ne,ce){if(!b.enableDiagnostics)return;const le=F(re,Y);if(ce instanceof L.VSBuffer||ce instanceof Uint8Array||ce instanceof ArrayBuffer||ArrayBuffer.isView(ce)){const K=L.VSBuffer.alloc(ce.byteLength);K.set(ce),b.records.push({timestamp:Date.now(),id:le,label:Y,type:ne,buff:K})}else b.records.push({timestamp:Date.now(),id:le,label:Y,type:ne,data:ce})}b.traceSocketEvent=q})(h||(e.SocketDiagnostics=h={}));var c;(function(b){b[b.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",b[b.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(c||(e.SocketCloseEventType=c={}));let v=null;function m(){return v||(v=L.VSBuffer.alloc(0)),v}class S{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(A){this._chunks.push(A),this._totalLength+=A.byteLength}read(A){return this._read(A,!0)}peek(A){return this._read(A,!1)}_read(A,O){if(A===0)return m();if(A>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===A){const Y=this._chunks[0];return O&&(this._chunks.shift(),this._totalLength-=A),Y}if(this._chunks[0].byteLength>A){const Y=this._chunks[0].slice(0,A);return O&&(this._chunks[0]=this._chunks[0].slice(A),this._totalLength-=A),Y}const F=L.VSBuffer.alloc(A);let q=0,re=0;for(;A>0;){const Y=this._chunks[re];if(Y.byteLength>A){const ne=Y.slice(0,A);F.set(ne,q),q+=A,O&&(this._chunks[re]=Y.slice(A),this._totalLength-=A),A-=A}else F.set(Y,q),q+=Y.byteLength,O?(this._chunks.shift(),this._totalLength-=Y.byteLength):re++,A-=Y.byteLength}return F}}e.ChunkStream=S;var u;(function(b){b[b.None=0]="None",b[b.Regular=1]="Regular",b[b.Control=2]="Control",b[b.Ack=3]="Ack",b[b.Disconnect=5]="Disconnect",b[b.ReplayRequest=6]="ReplayRequest",b[b.Pause=7]="Pause",b[b.Resume=8]="Resume",b[b.KeepAlive=9]="KeepAlive",b[b.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",b[b.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(u||(u={}));function y(b){switch(b){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(b){b[b.HeaderLength=13]="HeaderLength",b[b.AcknowledgeTime=2e3]="AcknowledgeTime",b[b.TimeoutTime=2e4]="TimeoutTime",b[b.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",b[b.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",b[b.KeepAliveSendTime=5e3]="KeepAliveSendTime",b[b.LatencySampleTime=6e4]="LatencySampleTime",b[b.LatencySampleCount=5]="LatencySampleCount",b[b.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",b[b.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p||(e.ProtocolConstants=p={}));class s{constructor(A,O,F,q){this.type=A,this.id=O,this.ack=F,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends _.Disposable{constructor(A){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=A,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(A){if(!(!A||A.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(A);this._incomingData.byteLength>=this._state.readLen;){const O=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=O.readUInt32BE(9),this._state.messageType=O.readUInt8(0),this._state.id=O.readUInt32BE(1),this._state.ack=O.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const F=this._state.messageType,q=this._state.id,re=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",O),this._onMessage.fire(new s(F,q,re,O)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class a{constructor(A){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=A,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(A){if(this._isDisposed)return;A.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=L.VSBuffer.alloc(13);O.writeUInt8(A.type,0),O.writeUInt32BE(A.id,1),O.writeUInt32BE(A.ack,5),O.writeUInt32BE(A.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(A.type),id:A.id,ack:A.ack,messageSize:A.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",A.data),this._writeSoon(O,A.data)}_bufferAdd(A,O){const F=this._totalLength===0;return this._data.push(A,O),this._totalLength+=A.byteLength+O.byteLength,F}_bufferTake(){const A=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,A}_writeSoon(A,O){this._bufferAdd(A,O)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const A=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:A.byteLength}),this._socket.write(A)}}class f extends _.Disposable{constructor(A){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=A,this._socketWriter=this._register(new a(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(O=>{O.type===1&&this._onMessage.fire(O.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(A){this._socketWriter.write(new s(1,0,0,A))}}e.Protocol=f;class P extends R.IPCClient{static fromSocket(A,O){return new P(new f(A),O)}get onDidDispose(){return this.protocol.onDidDispose}constructor(A,O,F=null){super(A,O,F),this.protocol=A}dispose(){super.dispose();const A=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),A.end()}}e.Client=P;class C{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(A){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(A):this._emitter.fire(A):this._bufferedMessages.push(A)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=C;class t{constructor(A){this.data=A,this.next=null}}class l{constructor(){this._first=null,this._last=null}length(){let A=0,O=this._first;for(;O;)O=O.next,A++;return A}peek(){return this._first?this._first.data:null}toArray(){const A=[];let O=0,F=this._first;for(;F;)A[O++]=F.data,F=F.next;return A}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(A){const O=new t(A);if(!this._first){this._first=O,this._last=O;return}this._last.next=O,this._last=O}}class n{static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}constructor(){this.lastRuns=[];const A=Date.now();for(let O=0;O<n._HISTORY_LENGTH;O++)this.lastRuns[O]=A-1e3*O;setInterval(()=>{for(let O=n._HISTORY_LENGTH;O>=1;O--)this.lastRuns[O]=this.lastRuns[O-1];this.lastRuns[0]=Date.now()},1e3)}load(){const A=Date.now(),O=(1+n._HISTORY_LENGTH)*1e3;let F=0;for(let q=0;q<n._HISTORY_LENGTH;q++)A-this.lastRuns[q]<=O&&F++;return 1-F/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;var i;(function(b){b[b.Good=0]="Good",b[b.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function o(b){switch(b){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class d{constructor(A){this.connectionHealth=A}}e.ConnectionHealthChangedEvent=d;class g{constructor(A,O){this.roundTripTime=A,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=g;class D{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(A){this._onControlMessage=new C,this.onControlMessage=this._onControlMessage.event,this._onMessage=new C,this.onMessage=this._onMessage.event,this._onDidDispose=new C,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new C,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new C,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new C,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new C,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=A.loadEstimator??n.getInstance(),this._measureRoundTripTime=A.measureRoundTripTime??!1,this._shouldSendKeepAlive=A.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new _.DisposableStore,this._socket=A.socket,this._socketWriter=this._socketDisposables.add(new a(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(O=>this._receiveMessage(O))),this._socketDisposables.add(this._socket.onClose(O=>this._onSocketClose.fire(O))),this._socketLatencyMonitor=this._socketDisposables.add(new M),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(O=>this._sendLatencyMeasurementRequest(O))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(O=>this._onHighRoundTripTime.fire(O))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(O=>this._onDidChangeConnectionHealth.fire(O))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),A.initialChunk&&this._socketReader.acceptChunk(A.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const A=new s(5,0,0,m());this._socketWriter.write(A),this._socketWriter.flush()}sendPause(){const A=new s(7,0,0,m());this._socketWriter.write(A)}sendResume(){const A=new s(8,0,0,m());this._socketWriter.write(A)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(A,O){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new _.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=A,this._socketWriter=this._socketDisposables.add(new a(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(F=>this._receiveMessage(F))),this._socketDisposables.add(this._socket.onClose(F=>this._onSocketClose.fire(F))),this._socketLatencyMonitor=this._socketDisposables.add(new M),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(F=>this._sendLatencyMeasurementRequest(F))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(F=>this._onHighRoundTripTime.fire(F))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(F=>this._onDidChangeConnectionHealth.fire(F))),this._socketReader.acceptChunk(O)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const A=new s(3,0,this._incomingAckId,m());this._socketWriter.write(A);const O=this._outgoingUnackMsg.toArray();for(let F=0,q=O.length;F<q;F++)this._socketWriter.write(O[F]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(A){if(A.ack>this._outgoingAckId){this._outgoingAckId=A.ack;do{const O=this._outgoingUnackMsg.peek();if(O&&O.id<=A.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(A.type){case 0:break;case 1:{if(A.id>this._incomingMsgId)if(A.id!==this._incomingMsgId+1){const O=Date.now();O-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=O,this._socketWriter.write(new s(6,0,0,m())))}else this._incomingMsgId=A.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(A.data);break}case 2:{this._onControlMessage.fire(A.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const O=this._outgoingUnackMsg.toArray();for(let F=0,q=O.length;F<q;F++)this._socketWriter.write(O[F]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(A.data);break}case 11:{this._socketLatencyMonitor.handleResponse(A.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(A){const O=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const F=new s(1,O,this._incomingAckId,A);this._outgoingUnackMsg.push(F),this._isReconnecting||(this._socketWriter.write(F),this._recvAckCheck())}sendControl(A){const O=new s(2,0,0,A);this._socketWriter.write(O)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const A=Date.now()-this._incomingMsgLastTime;if(A>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-A+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const A=this._outgoingUnackMsg.peek(),O=Date.now()-A.writtenTime,F=Date.now()-this._socketReader.lastReadTime,q=Date.now()-this._lastSocketTimeoutTime;if(O>=2e4&&F>=2e4&&q>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:F});return}const re=Math.max(2e4-O,2e4-F,2e4-q,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},re)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const A=new s(3,0,this._incomingAckId,m());this._socketWriter.write(A)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const A=new s(9,0,this._incomingAckId,m());this._socketWriter.write(A)}_sendLatencyMeasurementRequest(A){this._incomingAckId=this._incomingMsgId;const O=new s(10,0,this._incomingAckId,A);this._socketWriter.write(O)}_sendLatencyMeasurementResponse(A){this._incomingAckId=this._incomingMsgId;const O=new s(11,0,this._incomingAckId,A);this._socketWriter.write(O)}}e.PersistentProtocol=D;class M extends _.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new r.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new r.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new r.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new E.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},A=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const A=++this._lastLatencyMeasurementId,O=L.VSBuffer.alloc(4);O.writeUInt32BE(A,0),this._onSendLatencyRequest.fire(O)},6e4)}handleResponse(A){if(A.byteLength!==4)return;const O=A.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||O!==this._lastLatencyMeasurementId)return;const F=Date.now()-this._lastLatencyMeasurementSent,q=this._latencySampleIndex++;this._latencySamples[q%this._latencySamples.length]=F;const re=this._connectionHealth,Y=this._latencySamples.filter(ne=>ne>=1e3).length;this._connectionHealth=Y>=3?1:0,F>1e3&&this._onHighRoundTripTime.fire(new g(F,Y)),re!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(te[157],ie([0,1,38,17,4,2,43,143]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(v,m){const S=r.Event.fromNodeEventEmitter(E.validatedIpcMain,m,(y,p)=>({event:y,message:p})),u=r.Event.filter(S,({event:y})=>y.sender.id===v);return r.Event.map(u,({message:y})=>y&&L.VSBuffer.wrap(y))}class c extends R.IPCServer{static getOnDidClientConnect(){const m=r.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:S})=>S);return r.Event.map(m,S=>{const u=S.id;c.Clients.get(u)?.dispose();const p=new r.Emitter;c.Clients.set(u,(0,_.toDisposable)(()=>p.fire()));const s=h(u,"vscode:message"),w=r.Event.any(r.Event.signal(h(u,"vscode:disconnect")),p.event);return{protocol:new I.Protocol(S,s),onDidClientDisconnect:w}})}constructor(){super(c.getOnDidClientConnect())}}e.Server=c,c.Clients=new Map}),define(te[109],ie([0,1,38,4,31,156]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends _.Client{constructor(c,v){super({addEventListener:(m,S)=>c.addListener(m,S),removeEventListener:(m,S)=>c.removeListener(m,S),postMessage:m=>c.postMessage(m),start:()=>c.start(),close:()=>c.close()},v)}}e.Client=R;async function I(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,r.generateUuid)();h.webContents.send("vscode:createMessageChannel",c);const v=L.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(S,u)=>({nonce:u,port:S.ports[0]})),{port:m}=await L.Event.toPromise(L.Event.once(L.Event.filter(v,S=>S.nonce===c)));return m}e.connect=I}),define(te[158],ie([0,1,46,7,17,21,152,13,4,2,37,87,71,43]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends u.ChannelServer{constructor(w){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",a=>r.VSBuffer.wrap(Buffer.from(a,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.Server=y;class p{constructor(w,a){this.modulePath=w,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new L.Delayer(f),this.child=null,this._client=null}getChannel(w){const a=this;return{call(f,P,C){return a.requestPromise(w,f,P,C)},listen(f,P){return a.requestEvent(w,f,P)}}}requestPromise(w,a,f,P=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(P.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const C=this.getCachedChannel(w),t=(0,L.createCancelablePromise)(i=>C.call(a,f,i)),l=P.onCancellationRequested(()=>t.cancel()),n=(0,c.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{l.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,a,f){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let P;const C=new h.Emitter({onWillAddFirstListener:()=>{P=this.getCachedChannel(w).listen(a,f)(C.fire,C),this.activeRequests.add(P)},onDidRemoveLastListener:()=>{this.activeRequests.delete(P),P.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return C.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(a.env={...a.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(a.env),this.child=(0,E.fork)(this.modulePath,w,a);const f=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,R.isRemoteConsoleLog)(o)){(0,R.log)(o,`IPC Library: ${this.options.serverName}`);return}f.fire(r.VSBuffer.wrap(Buffer.from(o,"base64")))});const C=this.options.useQueue?(0,m.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&C.send(o.buffer.toString("base64")),l=f.event,n={send:t,onMessage:l};this._client=new u.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,d)=>{process.removeListener("exit",i),this.activeRequests.forEach(g=>(0,c.dispose)(g)),this.activeRequests.clear(),o!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+d),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:d})})}return this._client}getCachedChannel(w){let a=this.channels.get(w);return a||(a=this.client.getChannel(w),this.channels.set(w,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(te[110],ie([0,1,7,4,2,73,11]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function h(S){const u=S;return u?.changed instanceof Map||u?.deleted instanceof Set}e.isStorageItemsChangeEvent=h;var c;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(c||(e.StorageState=c={}));class v extends r.Disposable{constructor(u,y=Object.create(null)){super(),this.database=u,this.options=y,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){u.changed?.forEach((y,p)=>this.accept(p,y)),u.deleted?.forEach(y=>this.accept(y,void 0))}accept(u,y){if(this.state===c.Closed)return;let p=!1;(0,R.isUndefinedOrNull)(y)?p=this.cache.delete(u):this.cache.get(u)!==y&&(this.cache.set(u,y),p=!0),p&&this._onDidChangeStorage.fire(u)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,y){const p=this.cache.get(u);return(0,R.isUndefinedOrNull)(p)?y:p}getBoolean(u,y){const p=this.get(u);return(0,R.isUndefinedOrNull)(p)?y:p==="true"}getNumber(u,y){const p=this.get(u);return(0,R.isUndefinedOrNull)(p)?y:parseInt(p,10)}getObject(u,y){const p=this.get(u);return(0,R.isUndefinedOrNull)(p)?y:(0,_.parse)(p)}async set(u,y){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(y))return this.delete(u);const p=(0,R.isObject)(y)||Array.isArray(y)?(0,_.stringify)(y):String(y);if(this.cache.get(u)!==p)return this.cache.set(u,p),this.pendingInserts.set(u,p),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire(u),this.doFlush()}async delete(u){if(!(this.state===c.Closed||!this.cache.delete(u)))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire(u),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(u){if(this.hasPending)return this.doFlush(u)}async doFlush(u){return this.flushDelayer.trigger(()=>this.flushPending(),u)}async whenFlushed(){if(this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}isInMemory(){return this.options.hint===I.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert?.forEach((y,p)=>this.items.set(p,y)),u.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=m}),define(te[159],ie([0,1,7,4,35,9,22]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{get onDidChangeItemsExternal(){return L.Event.None}constructor(v,m=Object.create(null)){this.path=v,this.options=m,this.name=(0,_.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const v=await this.whenConnected,m=new Map;return(await this.all(v,"SELECT * FROM ItemTable")).forEach(u=>m.set(u.key,u.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${m.size} rows`),m}async updateItems(v){const m=await this.whenConnected;return this.doUpdateItems(m,v)}doUpdateItems(v,m){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${m.insert?(0,r.mapToString)(m.insert):"0"}), delete(${m.delete?(0,r.setToString)(m.delete):"0"})`),this.transaction(v,()=>{const S=m.insert,u=m.delete;if(S&&S.size>0){const y=[];y.push([]);let p=0;S.forEach((s,w)=>{let a=y[p];a.length>I.MAX_HOST_PARAMETERS&&(p++,a=[],y.push(a)),a.push(w,s)}),y.forEach(s=>{this.prepare(v,`INSERT INTO ItemTable VALUES ${new Array(s.length/2).fill("(?,?)").join(",")}`,w=>w.run(s),()=>{const w=[];let a=0;return S.forEach((f,P)=>{w.push(P),a+=f.length}),`Keys: ${w.join(", ")} Length: ${a}`})})}if(u&&u.size){const y=[];y.push([]);let p=0;u.forEach(s=>{let w=y[p];w.length>I.MAX_HOST_PARAMETERS&&(p++,w=[],y.push(w)),w.push(s)}),y.forEach(s=>{this.prepare(v,`DELETE FROM ItemTable WHERE key IN (${new Array(s.length).fill("?").join(",")})`,w=>w.run(s),()=>{const w=[];return u.forEach(a=>{w.push(a)}),`Keys: ${w.join(", ")}`})})}})}async close(v){this.logger.trace(`[storage ${this.name}] close()`);const m=await this.whenConnected;return this.doClose(m,v)}doClose(v,m){return new Promise((S,u)=>{v.db.close(y=>(y&&this.handleSQLiteError(v,`[storage ${this.name}] close(): ${y}`),this.path===I.IN_MEMORY_PATH?S():!v.isErroneous&&!v.isInMemory?this.backup().then(S,p=>(this.logger.error(`[storage ${this.name}] backup(): ${p}`),S())):typeof m=="function"?R.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(p=>{const s=()=>this.doClose(p,void 0);return this.doUpdateItems(p,{insert:m()}).then(()=>s(),w=>(s(),Promise.reject(w)))})).then(S,u):u(y||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const v=this.toBackupPath(this.path);return R.Promises.copy(this.path,v,{preserveSymlinks:!1})}toBackupPath(v){return`${v}.backup`}async checkIntegrity(v){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${v})`);const m=await this.whenConnected,S=await this.get(m,v?"PRAGMA integrity_check":"PRAGMA quick_check"),u=v?S.integrity_check:S.quick_check;return m.isErroneous?`${u} (last error: ${m.lastError})`:m.isInMemory?`${u} (in-memory!)`:u}async connect(v,m=!0){this.logger.trace(`[storage ${this.name}] open(${v}, retryOnBusy: ${m})`);try{return await this.doConnect(v)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&m)return await(0,E.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(v,!1);try{await R.Promises.unlink(v);try{await R.Promises.rename(this.toBackupPath(v),v)}catch{}return await this.doConnect(v)}catch(u){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${u}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(v,m){v.isErroneous=!0,v.lastError=m,this.logger.error(m)}doConnect(v){return new Promise((m,S)=>{new Promise((u,y)=>{j(["@vscode/sqlite3"],u,y)}).then(u=>{const y={db:new(this.logger.isTracing?u.verbose().Database:u.Database)(v,p=>p?y.db&&p.code!=="SQLITE_CANTOPEN"?y.db.close(()=>S(p)):S(p):this.exec(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(y),s=>y.db.close(()=>S(s)))),isInMemory:v===I.IN_MEMORY_PATH};y.db.on("error",p=>this.handleSQLiteError(y,`[storage ${this.name}] Error (event): ${p}`)),this.logger.isTracing&&y.db.on("trace",p=>this.logger.trace(`[storage ${this.name}] Trace (event): ${p}`))},S)})}exec(v,m){return new Promise((S,u)=>{v.db.exec(m,y=>y?(this.handleSQLiteError(v,`[storage ${this.name}] exec(): ${y}`),u(y)):S())})}get(v,m){return new Promise((S,u)=>{v.db.get(m,(y,p)=>y?(this.handleSQLiteError(v,`[storage ${this.name}] get(): ${y}`),u(y)):S(p))})}all(v,m){return new Promise((S,u)=>{v.db.all(m,(y,p)=>y?(this.handleSQLiteError(v,`[storage ${this.name}] all(): ${y}`),u(y)):S(p))})}transaction(v,m){return new Promise((S,u)=>{v.db.serialize(()=>{v.db.run("BEGIN TRANSACTION"),m(),v.db.run("END TRANSACTION",y=>y?(this.handleSQLiteError(v,`[storage ${this.name}] transaction(): ${y}`),u(y)):S())})})}prepare(v,m,S,u){const y=v.db.prepare(m),p=s=>{this.handleSQLiteError(v,`[storage ${this.name}] prepare(): ${s} (${m}). Details: ${u()}`)};y.on("error",p),S(y),y.finalize(s=>{s&&p(s),y.removeListener("error",p)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class h{constructor(v){v&&typeof v.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=v.logTrace),v&&typeof v.logError=="function"&&(this.logError=v.logError)}get isTracing(){return!!this.logTrace}trace(v){this.logTrace?.(v)}error(v){this.logError?.(v)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[160],ie([12,10]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(te[161],ie([12,10]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([12,10]),function(j,e){return j.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([12,10]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([12,10]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([12,10]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([12,10]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([12,10]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([12,10]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([12,10]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(te[175],ie([12,10]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(te[176],ie([12,10]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([12,10]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([12,10]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([12,10]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([12,10]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([12,10]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(te[182],ie([12,10]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([12,10]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([12,10]),function(j,e){return j.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([12,10]),function(j,e){return j.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([12,10]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([12,10]),function(j,e){return j.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([12,10]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(te[194],ie([0,1,8]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(R){let I=[];try{Array.isArray(R.workspaces)&&(I=R.workspaces.map(h=>({workspace:{id:h.id,configPath:E.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=r;function _(R){let I=[];try{Array.isArray(R.folders)&&(I=R.folders.map(h=>({folderUri:E.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=_}),define(te[195],ie([0,1,13,163]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(r||(e.TokenType=r={}));function _(...c){switch(c.length){case 1:return(0,L.localize)(0,null,c[0]);case 2:return(0,L.localize)(1,null,c[0],c[1]);case 3:return(0,L.localize)(2,null,c[0],c[1],c[2]);default:return}}const R=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,E.illegalState)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(v){return this._input=v,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const m=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:m})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const m=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:m})}else this._match(126)?this._addToken(9):this._error(_("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(_("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(_("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(v){return this._isAtEnd()||this._input.charCodeAt(this._current)!==v?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(v){this._tokens.push({type:v,offset:this._start})}_error(v){const m=this._start,S=this._input.substring(this._start,this._current),u={type:19,offset:this._start,lexeme:S};this._errors.push({offset:m,lexeme:S,additionalInfo:v}),this._tokens.push(u)}_string(){this.stringRe.lastIndex=this._start;const v=this.stringRe.exec(this._input);if(v){this._current=this._start+v[0].length;const m=this._input.substring(this._start,this._current),S=h._keywords.get(m);S?this._addToken(S):this._tokens.push({type:17,lexeme:m,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let v=this._current,m=!1,S=!1;for(;;){if(v>=this._input.length){this._current=v,this._error(I);return}const y=this._input.charCodeAt(v);if(m)m=!1;else if(y===47&&!S){v++;break}else y===91?S=!0:y===92?m=!0:y===93&&(S=!1);v++}for(;v<this._input.length&&h._regexFlags.has(this._input.charCodeAt(v));)v++;this._current=v;const u=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:u,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h,h._regexFlags=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0))),h._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(te[196],ie([0,1,4,2]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(I,h,c){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,h,c){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r,r.ChannelName="extensionhostdebugservice";class _ extends L.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,h,c){this.channel.call("attach",[I,h,c])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,h){this.channel.call("terminate",[I,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,h){return this.channel.call("openExtensionDevelopmentHostWindow",[I,h])}}e.ExtensionHostDebugChannelClient=_}),define(te[197],ie([0,1,146,55,14,9,36,18,8]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,_.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",u)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=R.env.VSCODE_PORTABLE;return u?h.URI.file((0,_.join)(u,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,_.resolve)(u):(0,_.normalize)((0,_.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?h.URI.file((0,_.resolve)(u)):h.URI.file((0,_.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,_.resolve)(u);const y=R.env.VSCODE_EXTENSIONS;if(y)return y;const p=R.env.VSCODE_PORTABLE;return p?(0,_.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,_.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?h.URI.parse(u):h.URI.file((0,_.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const y of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);p&&p[1]&&p[2]&&u.push([p[1],p[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=R.env.VSCODE_PORTABLE;return u?h.URI.file((0,_.join)(u,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this._args}constructor(u,y,p){this._args=u,this.paths=y,this.productService=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,Se([L.memoize],c.prototype,"appRoot",null),Se([L.memoize],c.prototype,"userHome",null),Se([L.memoize],c.prototype,"userDataPath",null),Se([L.memoize],c.prototype,"appSettingsHome",null),Se([L.memoize],c.prototype,"tmpDir",null),Se([L.memoize],c.prototype,"cacheHome",null),Se([L.memoize],c.prototype,"stateResource",null),Se([L.memoize],c.prototype,"userRoamingDataHome",null),Se([L.memoize],c.prototype,"userDataSyncHome",null),Se([L.memoize],c.prototype,"sync",null),Se([L.memoize],c.prototype,"machineSettingsResource",null),Se([L.memoize],c.prototype,"workspaceStorageHome",null),Se([L.memoize],c.prototype,"localHistoryHome",null),Se([L.memoize],c.prototype,"keyboardLayoutResource",null),Se([L.memoize],c.prototype,"argvResource",null),Se([L.memoize],c.prototype,"isExtensionDevelopment",null),Se([L.memoize],c.prototype,"untitledWorkspacesHome",null),Se([L.memoize],c.prototype,"builtinExtensionsPath",null),Se([L.memoize],c.prototype,"extensionsPath",null),Se([L.memoize],c.prototype,"extensionDevelopmentLocationURI",null),Se([L.memoize],c.prototype,"extensionDevelopmentKind",null),Se([L.memoize],c.prototype,"extensionTestsLocationURI",null),Se([L.memoize],c.prototype,"debugExtensionHost",null),Se([L.memoize],c.prototype,"logLevel",null),Se([L.memoize],c.prototype,"extensionLogLevel",null),Se([L.memoize],c.prototype,"serviceMachineIdResource",null),Se([L.memoize],c.prototype,"disableTelemetry",null),Se([L.memoize],c.prototype,"disableWorkspaceTrust",null),Se([L.memoize],c.prototype,"policyFile",null);function v(S,u){return m(S["inspect-extensions"],S["inspect-brk-extensions"],5870,u,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=v;function m(S,u,y,p,s,w){const f=Number(u||S)||(p?null:y),P=f?!!u:!1;let C;if(w)try{C=JSON.parse(w)}catch{}return{port:f,break:P,debugId:s,env:C}}e.parseDebugParams=m}),define(te[111],ie([0,1,305,3,166]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(p,s,w=R){const a=p.find(d=>d.length>0&&d[0]!=="-"),f={},P=["_"],C=[],t={};let l;for(const d in s){const g=s[d];g.type==="subcommand"?d===a&&(l=g):(g.alias&&(f[d]=g.alias),g.type==="string"||g.type==="string[]"?(P.push(d),g.deprecates&&P.push(...g.deprecates)):g.type==="boolean"&&(C.push(d),g.deprecates&&C.push(...g.deprecates)),g.global&&(t[d]=g))}if(l&&a){const d=t;for(const b in l.options)d[b]=l.options[b];const g=p.filter(b=>b!==a),D=w.getSubcommandReporter?w.getSubcommandReporter(a):void 0,M=I(g,d,D);return{[a]:M,_:[]}}const n=E(p,{string:P,boolean:C,alias:f}),i={},o=n;i._=n._.map(d=>String(d)).filter(d=>d.length>0),delete o._;for(const d in s){const g=s[d];if(g.type==="subcommand")continue;g.alias&&delete o[g.alias];let D=o[d];if(g.deprecates)for(const M of g.deprecates)o.hasOwnProperty(M)&&(D||(D=o[M],D&&w.onDeprecatedOption(M,g.deprecationMessage||(0,r.localize)(35,null,d))),delete o[M]);if(typeof D<"u"){if(g.type==="string[]"){if(Array.isArray(D)||(D=[D]),!g.allowEmptyValue){const M=D.filter(b=>b.length>0);M.length!==D.length&&(w.onEmptyValue(d),D=M.length>0?M:void 0)}}else g.type==="string"&&(Array.isArray(D)?(D=D.pop(),w.onMultipleValues(d,D)):!D&&!g.allowEmptyValue&&(w.onEmptyValue(d),D=void 0));i[d]=D,g.deprecationMessage&&w.onDeprecatedOption(d,g.deprecationMessage)}delete o[d]}for(const d in o)w.onUnknownOption(d);return i}e.parseArgs=I;function h(p,s){let w="";return s.args&&(Array.isArray(s.args)?w=` <${s.args.join("> <")}>`:w=` <${s.args}>`),s.alias?`-${s.alias} --${p}${w}`:`--${p}${w}`}function c(p,s){const w=[];for(const a in p){const f=p[a],P=h(a,f);w.push([P,f.description])}return v(w,s)}e.formatOptions=c;function v(p,s){const a=p.reduce((C,t)=>Math.max(C,t[0].length),12)+2+1;if(s-a<25)return p.reduce((C,t)=>C.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=s-a-1,P=[];for(const C of p){const t=C[0],l=S(C[1],f),n=m(a-t.length-2);P.push("  "+t+n+l[0]);for(let i=1;i<l.length;i++)P.push(m(a)+l[i])}return P}function m(p){return" ".repeat(p)}function S(p,s){const w=[];for(;p.length;){const a=p.length<s?p.length:p.lastIndexOf(" ",s),f=p.slice(0,a).trim();p=p.slice(a),w.push(f)}return w}function u(p,s,w,a,f){const P=process.stdout.isTTY&&process.stdout.columns||80,C=f?.noInputFiles!==!0?`[${(0,r.localize)(36,null)}...]`:"",t=[`${p} ${w}`];t.push(""),t.push(`${(0,r.localize)(37,null)}: ${s} [${(0,r.localize)(38,null)}]${C}`),t.push(""),f?.noPipe!==!0&&(L.isWindows?t.push((0,r.localize)(39,null,s)):t.push((0,r.localize)(40,null,s)),t.push(""));const l={},n=[];for(const i in a){const o=a[i];if(o.type==="subcommand")o.description&&n.push({command:i,description:o.description});else if(o.description&&o.cat){let d=l[o.cat];d||(l[o.cat]=d={}),d[i]=o}}for(const i in l){const o=i,d=l[o];d&&(t.push(_[o]),t.push(...c(d,P)),t.push(""))}return n.length&&(t.push((0,r.localize)(41,null)),t.push(...v(n.map(i=>[i.command,i.description]),P)),t.push("")),t.join(`
`)}e.buildHelpMessage=u;function y(p,s){return`${p||(0,r.localize)(42,null)}
${s||(0,r.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=y}),define(te[198],ie([0,1,84,196,111]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class _ extends L.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.windowsMainService=I}call(I,h,c){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(c[0],c[1]):super.call(I,h,c)}async openExtensionDevelopmentHostWindow(I,h){const c=(0,r.parseArgs)(I,r.OPTIONS);c.debugRenderer=h;const v=c.extensionDevelopmentPath;if(!v)return{success:!1};const[m]=await this.windowsMainService.openExtensionDevelopmentHostWindow(v,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const S=m.win;if(!S)return{success:!0};const u=S.webContents.debugger;let y=u.isAttached()?1/0:0;const p=(0,E.createServer)(s=>{y++===0&&u.attach();let w=!1;const a=C=>{w||s.write(JSON.stringify(C)+"\0")},f=(C,t,l,n)=>a({method:t,params:l,sessionId:n});S.on("close",()=>{u.removeListener("message",f),s.end(),w=!0}),u.addListener("message",f);let P=Buffer.alloc(0);s.on("data",C=>{P=Buffer.concat([P,C]);for(let t=P.indexOf(0);t!==-1;t=P.indexOf(0)){let l;try{const n=P.slice(0,t).toString("utf8");P=P.slice(t+1),l=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}u.sendCommand(l.method,l.params,l.sessionId).then(n=>a({id:l.id,sessionId:l.sessionId,result:n})).catch(n=>a({id:l.id,sessionId:l.sessionId,error:{code:0,message:n.message}}))}}),s.on("error",C=>{console.error("error on cdp pipe:",C)}),s.on("close",()=>{w=!0,--y===0&&u.detach()})});return await new Promise(s=>p.listen(0,s)),S.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=_}),define(te[63],ie([0,1,306,167,111]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function _(m,S){const u=(f,P)=>{console.warn((0,L.localize)(0,null,f,P))},y=f=>{console.warn((0,L.localize)(1,null,f))},p=(f,P)=>{console.warn((0,L.localize)(2,null,f,P))},s=f=>({onUnknownOption:P=>{f!=="tunnel"&&console.warn((0,L.localize)(3,null,P,f))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:p,getSubcommandReporter:f!=="tunnel"?s:void 0}),w={onUnknownOption:f=>{console.warn((0,L.localize)(4,null,f))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:p,getSubcommandReporter:s},a=(0,r.parseArgs)(m,r.OPTIONS,S?w:void 0);return a.goto&&a._.forEach(f=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,L.localize)(5,null))),a}function R(m){const S=m.findIndex(u=>!/^-/.test(u));if(S>-1)return[...m.slice(0,S),...m.slice(S+1)]}function I(m){let[,...S]=m;process.env.VSCODE_DEV&&(S=R(S)||[]);const u=!v(process.env);return _(S,u)}e.parseMainProcessArgv=I;function h(m){let[,,...S]=m;return process.env.VSCODE_DEV&&(S=R(S)||[]),_(S,!0)}e.parseCLIProcessArgv=h;function c(m,...S){const u=m.indexOf("--");return u===-1?m.push(...S):m.splice(u,0,...S),m}e.addArg=c;function v(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function j(e,E,L){function r(R,I){const h=_(R,I),c=[h];return e.isAbsolute(h)||c.unshift(L),e.resolve(...c)}function _(R,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const v=R["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(m,"AppData","Roaming")}break;case"darwin":c=e.join(E.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:r}}if(typeof define=="function")define(te[199],ie([112,27,36]),function(e,E,L){return j(e,E,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=j(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[88],ie([0,1,27,197,199]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class _ extends L.AbstractNativeEnvironmentService{constructor(c,v){super(c,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,r.getUserDataPath)(c,v.nameShort)},v)}}e.NativeEnvironmentService=_;function R(h,c){return(0,L.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.parsePtyHostDebugPort=R;function I(h,c){return(0,L.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(te[200],ie([0,1,42,27,32]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function _(R){const I=(0,r.randomPath)((0,L.tmpdir)());try{return(0,E.writeFileSync)(I,""),R&&console.log(`Marker file for --wait created: ${I}`),I}catch(h){R&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFileSync=_}),define(te[201],ie([0,1,11,169]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(R,I,h){try{_(R,I,h)}catch(c){console.error(c?.message??c)}return R}e.localizeManifest=r;function _(R,I,h){const c=(v,m,S)=>{const u=v[m];if((0,E.isString)(u)){const y=u,p=y.length;if(p>1&&y[0]==="%"&&y[p-1]==="%"){const s=y.substr(1,p-2);let w=I[s];w===void 0&&h&&(w=h[s]);const a=typeof w=="string"?w:w?.message,f=h?.[s],P=typeof f=="string"?f:f?.message;if(!a){P||console.warn(`[${R.name}]: ${(0,L.localize)(0,null,s)}`);return}if(S&&(m==="title"||m==="category")&&P&&P!==a){const C={value:a,original:P};v[m]=C}else v[m]=a}}else if((0,E.isObject)(u))for(const y in u)u.hasOwnProperty(y)&&(y==="commands"?c(u,y,!0):c(u,y,S));else if(Array.isArray(u))for(let y=0;y<u.length;y++)c(u,y,S)};for(const v in R)R.hasOwnProperty(v)&&c(R,v)}}),define(te[202],ie([0,1,18,72,171,203]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function h(w){return w=w.trim(),w==="*"||R.test(w)}e.isValidVersionStr=h;function c(w){if(!h(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=w.match(R);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.parseVersion=c;function v(w){if(!w)return null;const a=w.majorBase,f=w.majorMustEqual,P=w.minorBase;let C=w.minorMustEqual;const t=w.patchBase;let l=w.patchMustEqual;w.hasCaret&&(a===0||(C=!1),l=!1);let n=0;if(w.preRelease){const i=I.exec(w.preRelease);if(i){const[,o,d,g]=i;n=Date.UTC(Number(o),Number(d)-1,Number(g))}}return{majorBase:a,majorMustEqual:f,minorBase:P,minorMustEqual:C,patchBase:t,patchMustEqual:l,isMinimum:w.hasGreaterEquals,notBefore:n}}e.normalizeVersion=v;function m(w,a,f){let P;typeof w=="string"?P=v(c(w)):P=w;let C;a instanceof Date?C=a.getTime():typeof a=="string"&&(C=new Date(a).getTime());let t;if(typeof f=="string"?t=v(c(f)):t=f,!P||!t)return!1;const l=P.majorBase,n=P.minorBase,i=P.patchBase;let o=t.majorBase,d=t.minorBase,g=t.patchBase;const D=t.notBefore;let M=t.majorMustEqual,b=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?l>o?!0:l<o?!1:n>d?!0:n<d||C&&C<D?!1:i>=g:(l===1&&o===0&&(!M||!b||!A)&&(o=1,d=0,g=0,M=!0,b=!1,A=!1),l<o?!1:l>o?!M:n<d?!1:n>d?!b:i<g?!1:i>g?!A:!(C&&C<D))}e.isValidVersion=m;function S(w,a,f,P,C){const t=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return t.push([L.default.Error,r.localize(0,null)]),t;if(typeof P.name!="string")return t.push([L.default.Error,r.localize(1,null,"name")]),t;if(typeof P.version!="string")return t.push([L.default.Error,r.localize(2,null,"version")]),t;if(!P.engines)return t.push([L.default.Error,r.localize(3,null,"engines")]),t;if(typeof P.engines.vscode!="string")return t.push([L.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof P.extensionDependencies<"u"&&!s(P.extensionDependencies))return t.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof P.activationEvents<"u"){if(!s(P.activationEvents))return t.push([L.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof P.main>"u"&&typeof P.browser>"u")return t.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&t.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return t.push([L.default.Error,r.localize(9,null,"main")]),t;{const i=(0,E.joinPath)(f,P.main);(0,E.isEqualOrParent)(i,f)||t.push([L.default.Warning,r.localize(10,null,i.path,f.path)])}}if(typeof P.browser<"u"){if(typeof P.browser!="string")return t.push([L.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,E.joinPath)(f,P.browser);(0,E.isEqualOrParent)(i,f)||t.push([L.default.Warning,r.localize(12,null,i.path,f.path)])}}if(!_.valid(P.version))return t.push([L.default.Error,r.localize(13,null)]),t;const l=[];if(!u(w,a,P,C,l))for(const i of l)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=S;function u(w,a,f,P,C){return P||typeof f.main>"u"&&typeof f.browser>"u"?!0:p(w,a,f.engines.vscode,C)}e.isValidExtensionVersion=u;function y(w,a,f){return w==="*"||p(a,f,w)}e.isEngineValid=y;function p(w,a,f,P=[]){const C=v(c(f));if(!C)return P.push(r.localize(14,null,f)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return P.push(r.localize(15,null,f)),!1}else if(!C.majorMustEqual)return P.push(r.localize(16,null,f)),!1;return m(w,a,C)?!0:(P.push(r.localize(17,null,w,f)),!1)}function s(w){if(!Array.isArray(w))return!1;for(let a=0,f=w.length;a<f;a++)if(typeof w[a]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(_,R,I){let h=I&&I.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const v=(await R.readFile(_.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(v)?v:null}catch{h=null}if(!h){h=(0,L.generateUuid)();try{await R.writeFile(_.serviceMachineIdResource,E.VSBuffer.fromString(h))}catch{}}return I?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=r}),define(te[74],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(r,_=[],R=!1){this.ctor=r,this.staticArguments=_,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=E}),define(te[205],ie([0,1,74]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function _(I,h,c){h instanceof E.SyncDescriptor||(h=new E.SyncDescriptor(h,[],!!c)),L.push([I,h])}e.registerSingleton=_;function R(){return L}e.getSingletonServiceDescriptors=R}),define(te[206],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(_,R){this.key=_,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class L{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(const R of this._nodes.values())R.outgoing.size===0&&_.push(R);return _}insertEdge(_,R){const I=this.lookupOrInsertNode(_),h=this.lookupOrInsertNode(R);I.outgoing.set(h.key,h),h.incoming.set(I.key,I)}removeNode(_){const R=this._hashFn(_);this._nodes.delete(R);for(const I of this._nodes.values())I.outgoing.delete(R),I.incoming.delete(R)}lookupOrInsertNode(_){const R=this._hashFn(_);let I=this._nodes.get(R);return I||(I=new E(R,_),this._nodes.set(R,I)),I}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){const _=[];for(const[R,I]of this._nodes)_.push(`${R}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return _.join(`
`)}findCycleSlow(){for(const[_,R]of this._nodes){const I=new Set([_]),h=this._findCycle(R,I);if(h)return h}}_findCycle(_,R){for(const[I,h]of _.outgoing){if(R.has(I))return[...R,I].join(" -> ");R.add(I);const c=this._findCycle(h,R);if(c)return c;R.delete(I)}}}e.Graph=L}),define(te[6],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function I(h){return h[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=I})(E||(e._util=E={})),e.IInstantiationService=r("instantiationService");function L(R,I,h){I[E.DI_TARGET]===I?I[E.DI_DEPENDENCIES].push({id:R,index:h}):(I[E.DI_DEPENDENCIES]=[{id:R,index:h}],I[E.DI_TARGET]=I)}function r(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const I=function(h,c,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(I,h,v)};return I.toString=()=>R,E.serviceIds.set(R,I),I}e.createDecorator=r;function _(R){return R}e.refineServiceDecorator=_}),define(te[64],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(te[19],ie([0,1,11,8,6]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function _(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationOverrides=_;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=R;var I;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function h(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function c(s,w){const a=Object.create(null);for(const f in s)v(a,f,s[f],w);return a}e.toValuesTree=c;function v(s,w,a,f){const P=w.split("."),C=P.pop();let t=s;for(let l=0;l<P.length;l++){const n=P[l];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${w} as ${P.slice(0,l+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[C]=a}catch{f(`Ignoring ${w} as ${P.join(".")} is ${JSON.stringify(t)}`)}else f(`Ignoring ${w} as ${P.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=v;function m(s,w){const a=w.split(".");S(s,a)}e.removeFromValueTree=m;function S(s,w){const a=w.shift();if(w.length===0){delete s[a];return}if(Object.keys(s).indexOf(a)!==-1){const f=s[a];typeof f=="object"&&!Array.isArray(f)&&(S(f,w),Object.keys(f).length===0&&delete s[a])}}function u(s,w,a){function f(t,l){let n=t;for(const i of l){if(typeof n!="object"||n===null)return;n=n[i]}return n}const P=w.split("."),C=f(s,P);return typeof C>"u"?a:C}e.getConfigurationValue=u;function y(s,w,a){Object.keys(w).forEach(f=>{f!=="__proto__"&&(f in s?E.isObject(s[f])&&E.isObject(w[f])?y(s[f],w[f],a):a&&(s[f]=w[f]):s[f]=w[f])})}e.merge=y;function p(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(te[113],ie([0,1,3,25,195,6,162,13]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",E.isMacintosh),h.set("isLinux",E.isLinux),h.set("isWindows",E.isWindows),h.set("isWeb",E.isWeb),h.set("isMacNative",E.isMacintosh&&!E.isWeb),h.set("isEdge",E.isEdge),h.set("isFirefox",E.isFirefox),h.set("isChrome",E.isChrome),h.set("isSafari",E.isSafari);function c(N,k){if(h.get(N)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(N,k)}e.setConstant=c;const v=Object.prototype.hasOwnProperty;var m;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const S={regexParsingWithErrorRecovery:!0},u=(0,R.localize)(0,null),y=(0,R.localize)(1,null),p=(0,R.localize)(2,null),s=(0,R.localize)(3,null),w=(0,R.localize)(4,null),a=(0,R.localize)(5,null),f=(0,R.localize)(6,null),P=(0,R.localize)(7,null);class C{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(k=S){this._config=k,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(k){if(k===""){this._parsingErrors.push({message:u,offset:0,lexeme:"",additionalInfo:y});return}this._tokens=this._scanner.reset(k).scan(),this._current=0,this._parsingErrors=[];try{const W=this._expr();if(!this._isAtEnd()){const z=this._peek(),H=z.type===17?a:void 0;throw this._parsingErrors.push({message:w,offset:z.offset,lexeme:r.Scanner.getLexeme(z),additionalInfo:H}),C._parseError}return W}catch(W){if(W!==C._parseError)throw W;return}}_expr(){return this._or()}_or(){const k=[this._and()];for(;this._matchOne(16);){const W=this._and();k.push(W)}return k.length===1?k[0]:t.or(...k)}_and(){const k=[this._term()];for(;this._matchOne(15);){const W=this._term();k.push(W)}return k.length===1?k[0]:t.and(...k)}_term(){if(this._matchOne(2)){const k=this._peek();switch(k.type){case 11:return this._advance(),o.INSTANCE;case 12:return this._advance(),d.INSTANCE;case 0:{this._advance();const W=this._expr();return this._consume(1,s),W?.negate()}case 17:return this._advance(),O.create(k.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",k)}}return this._primary()}_primary(){const k=this._peek();switch(k.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const W=this._expr();return this._consume(1,s),W}case 17:{const W=k.lexeme;if(this._advance(),this._matchOne(9)){const H=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),H.type!==10)throw this._errExpectedButGot("REGEX",H);const B=H.lexeme,$=B.lastIndexOf("/"),G=$===B.length-1?void 0:this._removeFlagsGY(B.substring($+1));let se;try{se=new RegExp(B.substring(1,$),G)}catch{throw this._errExpectedButGot("REGEX",H)}return ce.create(W,se)}switch(H.type){case 10:case 19:{const B=[H.lexeme];this._advance();let $=this._peek(),G=0;for(let Re=0;Re<H.lexeme.length;Re++)H.lexeme.charCodeAt(Re)===40?G++:H.lexeme.charCodeAt(Re)===41&&G--;for(;!this._isAtEnd()&&$.type!==15&&$.type!==16;){switch($.type){case 0:G++;break;case 1:G--;break;case 10:case 18:for(let Re=0;Re<$.lexeme.length;Re++)$.lexeme.charCodeAt(Re)===40?G++:H.lexeme.charCodeAt(Re)===41&&G--}if(G<0)break;B.push(r.Scanner.getLexeme($)),this._advance(),$=this._peek()}const se=B.join(""),ue=se.lastIndexOf("/"),ye=ue===se.length-1?void 0:this._removeFlagsGY(se.substring(ue+1));let Ce;try{Ce=new RegExp(se.substring(1,ue),ye)}catch{throw this._errExpectedButGot("REGEX",H)}return t.regex(W,Ce)}case 18:{const B=H.lexeme;this._advance();let $=null;if(!(0,L.isFalsyOrWhitespace)(B)){const G=B.indexOf("/"),se=B.lastIndexOf("/");if(G!==se&&G>=0){const ue=B.slice(G+1,se),ye=B[se+1]==="i"?"i":"";try{$=new RegExp(ue,ye)}catch{throw this._errExpectedButGot("REGEX",H)}}}if($===null)throw this._errExpectedButGot("REGEX",H);return ce.create(W,$)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,p);const H=this._value();return t.notIn(W,H)}switch(this._peek().type){case 3:{this._advance();const H=this._value();if(this._previous().type===18)return t.equals(W,H);switch(H){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,H)}}case 4:{this._advance();const H=this._value();if(this._previous().type===18)return t.notEquals(W,H);switch(H){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,H)}}case 5:return this._advance(),Y.create(W,this._value());case 6:return this._advance(),ne.create(W,this._value());case 7:return this._advance(),q.create(W,this._value());case 8:return this._advance(),re.create(W,this._value());case 13:return this._advance(),t.in(W,this._value());default:return t.has(W)}}case 20:throw this._parsingErrors.push({message:f,offset:k.offset,lexeme:"",additionalInfo:P}),C._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const k=this._peek();switch(k.type){case 17:case 18:return this._advance(),k.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(k){return k.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(k){return this._check(k)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(k,W){if(this._check(k))return this._advance();throw this._errExpectedButGot(W,this._peek())}_errExpectedButGot(k,W,z){const H=(0,R.localize)(8,null,k,r.Scanner.getLexeme(W)),B=W.offset,$=r.Scanner.getLexeme(W);return this._parsingErrors.push({message:H,offset:B,lexeme:$,additionalInfo:z}),C._parseError}_check(k){return this._peek().type===k}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=C,C._parseError=new Error;class t{static false(){return o.INSTANCE}static true(){return d.INSTANCE}static has(k){return g.create(k)}static equals(k,W){return D.create(k,W)}static notEquals(k,W){return A.create(k,W)}static regex(k,W){return ce.create(k,W)}static in(k,W){return M.create(k,W)}static notIn(k,W){return b.create(k,W)}static not(k){return O.create(k)}static and(...k){return V.create(k,null,!0)}static or(...k){return U.create(k,null,!0)}static greater(k,W){return q.create(k,W)}static greaterEquals(k,W){return re.create(k,W)}static smaller(k,W){return Y.create(k,W)}static smallerEquals(k,W){return ne.create(k,W)}static deserialize(k){return k==null?void 0:this._parser.parse(k)}}e.ContextKeyExpr=t,t._parser=new C({regexParsingWithErrorRecovery:!1});function l(N){const k=new C({regexParsingWithErrorRecovery:!1});return N.map(W=>(k.parse(W),k.lexingErrors.length>0?k.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,R.localize)(9,null,z.additionalInfo):(0,R.localize)(10,null),offset:z.offset,length:z.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.validateWhenClauses=l;function n(N,k){const W=N?N.substituteConstants():void 0,z=k?k.substituteConstants():void 0;return!W&&!z?!0:!W||!z?!1:W.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function i(N,k){return N.cmp(k)}class o{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=o,o.INSTANCE=new o;class d{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class g{static create(k,W=null){const z=h.get(k);return typeof z=="boolean"?z?d.INSTANCE:o.INSTANCE:new g(k,W)}constructor(k,W){this.key=k,this.negated=W,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:x(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=h.get(this.key);return typeof k=="boolean"?k?d.INSTANCE:o.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class D{static create(k,W,z=null){if(typeof W=="boolean")return W?g.create(k,z):O.create(k,z);const H=h.get(k);return typeof H=="boolean"?W===(H?"true":"false")?d.INSTANCE:o.INSTANCE:new D(k,W,z)}constructor(k,W,z){this.key=k,this.value=W,this.negated=z,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:Q(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=h.get(this.key);if(typeof k=="boolean"){const W=k?"true":"false";return this.value===W?d.INSTANCE:o.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class M{static create(k,W){return new M(k,W)}constructor(k,W){this.key=k,this.valueKey=W,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:Q(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const W=k.getValue(this.valueKey),z=k.getValue(this.key);return Array.isArray(W)?W.includes(z):typeof z=="string"&&typeof W=="object"&&W!==null?v.call(W,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=M;class b{static create(k,W){return new b(k,W)}constructor(k,W){this.key=k,this.valueKey=W,this.type=11,this._negated=M.create(k,W)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class A{static create(k,W,z=null){if(typeof W=="boolean")return W?O.create(k,z):g.create(k,z);const H=h.get(k);return typeof H=="boolean"?W===(H?"true":"false")?o.INSTANCE:d.INSTANCE:new A(k,W,z)}constructor(k,W,z){this.key=k,this.value=W,this.negated=z,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:Q(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=h.get(this.key);if(typeof k=="boolean"){const W=k?"true":"false";return this.value===W?o.INSTANCE:d.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=A;class O{static create(k,W=null){const z=h.get(k);return typeof z=="boolean"?z?o.INSTANCE:d.INSTANCE:new O(k,W)}constructor(k,W){this.key=k,this.negated=W,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:x(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=h.get(this.key);return typeof k=="boolean"?k?o.INSTANCE:d.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function F(N,k){if(typeof N=="string"){const W=parseFloat(N);isNaN(W)||(N=W)}return typeof N=="string"||typeof N=="number"?k(N):o.INSTANCE}class q{static create(k,W,z=null){return F(W,H=>new q(k,H,z))}constructor(k,W,z){this.key=k,this.value=W,this.negated=z,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:Q(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class re{static create(k,W,z=null){return F(W,H=>new re(k,H,z))}constructor(k,W,z){this.key=k,this.value=W,this.negated=z,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:Q(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=re;class Y{static create(k,W,z=null){return F(W,H=>new Y(k,H,z))}constructor(k,W,z){this.key=k,this.value=W,this.negated=z,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:Q(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=Y;class ne{static create(k,W,z=null){return F(W,H=>new ne(k,H,z))}constructor(k,W,z){this.key=k,this.value=W,this.negated=z,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:Q(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ne;class ce{static create(k,W){return new ce(k,W)}constructor(k,W){this.key=k,this.regexp=W,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const W=this.regexp?this.regexp.source:"",z=k.regexp?k.regexp.source:"";return W<z?-1:W>z?1:0}equals(k){if(k.type===this.type){const W=this.regexp?this.regexp.source:"",z=k.regexp?k.regexp.source:"";return this.key===k.key&&W===z}return!1}substituteConstants(){return this}evaluate(k){const W=k.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=le.create(this)),this.negated}}e.ContextKeyRegexExpr=ce;class le{static create(k){return new le(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(k){return new le(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=le;function K(N){let k=null;for(let W=0,z=N.length;W<z;W++){const H=N[W].substituteConstants();if(N[W]!==H&&k===null){k=[];for(let B=0;B<W;B++)k[B]=N[B]}k!==null&&(k[W]=H)}return k===null?N:k}class V{static create(k,W,z){return V._normalizeArr(k,W,z)}constructor(k,W){this.expr=k,this.negated=W,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let W=0,z=this.expr.length;W<z;W++){const H=i(this.expr[W],k.expr[W]);if(H!==0)return H}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].equals(k.expr[W]))return!1;return!0}return!1}substituteConstants(){const k=K(this.expr);return k===this.expr?this:V.create(k,this.negated,!1)}evaluate(k){for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].evaluate(k))return!1;return!0}static _normalizeArr(k,W,z){const H=[];let B=!1;for(const $ of k)if($){if($.type===1){B=!0;continue}if($.type===0)return o.INSTANCE;if($.type===6){H.push(...$.expr);continue}H.push($)}if(H.length===0&&B)return d.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(i);for(let $=1;$<H.length;$++)H[$-1].equals(H[$])&&(H.splice($,1),$--);if(H.length===1)return H[0];for(;H.length>1;){const $=H[H.length-1];if($.type!==9)break;H.pop();const G=H.pop(),se=H.length===0,ue=U.create($.expr.map(ye=>V.create([ye,G],null,z)),null,se);ue&&(H.push(ue),H.sort(i))}if(H.length===1)return H[0];if(z){for(let $=0;$<H.length;$++)for(let G=$+1;G<H.length;G++)if(H[$].negate().equals(H[G]))return o.INSTANCE;if(H.length===1)return H[0]}return new V(H,W)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const W of this.expr)k.push(...W.keys());return k}map(k){return new V(this.expr.map(W=>W.map(k)),null)}negate(){if(!this.negated){const k=[];for(const W of this.expr)k.push(W.negate());this.negated=U.create(k,this,!0)}return this.negated}}e.ContextKeyAndExpr=V;class U{static create(k,W,z){return U._normalizeArr(k,W,z)}constructor(k,W){this.expr=k,this.negated=W,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let W=0,z=this.expr.length;W<z;W++){const H=i(this.expr[W],k.expr[W]);if(H!==0)return H}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].equals(k.expr[W]))return!1;return!0}return!1}substituteConstants(){const k=K(this.expr);return k===this.expr?this:U.create(k,this.negated,!1)}evaluate(k){for(let W=0,z=this.expr.length;W<z;W++)if(this.expr[W].evaluate(k))return!0;return!1}static _normalizeArr(k,W,z){let H=[],B=!1;if(k){for(let $=0,G=k.length;$<G;$++){const se=k[$];if(se){if(se.type===0){B=!0;continue}if(se.type===1)return d.INSTANCE;if(se.type===9){H=H.concat(se.expr);continue}H.push(se)}}if(H.length===0&&B)return o.INSTANCE;H.sort(i)}if(H.length!==0){if(H.length===1)return H[0];for(let $=1;$<H.length;$++)H[$-1].equals(H[$])&&(H.splice($,1),$--);if(H.length===1)return H[0];if(z){for(let $=0;$<H.length;$++)for(let G=$+1;G<H.length;G++)if(H[$].negate().equals(H[G]))return d.INSTANCE;if(H.length===1)return H[0]}return new U(H,W)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const W of this.expr)k.push(...W.keys());return k}map(k){return new U(this.expr.map(W=>W.map(k)),null)}negate(){if(!this.negated){const k=[];for(const W of this.expr)k.push(W.negate());for(;k.length>1;){const W=k.shift(),z=k.shift(),H=[];for(const B of oe(W))for(const $ of oe(z))H.push(V.create([B,$],null,!1));k.unshift(U.create(H,null,!1))}this.negated=U.create(k,this,!0)}return this.negated}}e.ContextKeyOrExpr=U;class T extends g{static all(){return T._info.values()}constructor(k,W,z){super(k,null),this._defaultValue=W,typeof z=="object"?T._info.push({...z,key:k}):z!==!0&&T._info.push({key:k,description:z,type:W!=null?typeof W:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return D.create(this.key,k)}notEqualsTo(k){return A.create(this.key,k)}}e.RawContextKey=T,T._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService");function x(N,k){return N<k?-1:N>k?1:0}function Q(N,k,W,z){return N<W?-1:N>W?1:k<z?-1:k>z?1:0}function Z(N,k){if(N.type===0||k.type===1)return!0;if(N.type===9)return k.type===9?ae(N.expr,k.expr):!1;if(k.type===9){for(const W of k.expr)if(Z(N,W))return!0;return!1}if(N.type===6){if(k.type===6)return ae(k.expr,N.expr);for(const W of N.expr)if(Z(W,k))return!0;return!1}return N.equals(k)}e.implies=Z;function ae(N,k){let W=0,z=0;for(;W<N.length&&z<k.length;){const H=N[W].cmp(k[z]);if(H<0)return!1;H===0&&W++,z++}return W===N.length}function oe(N){return N.type===9?N.expr:[N]}}),define(te[75],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class L{constructor(){this.secretVault={}}async getPassword(_,R){return this.secretVault[_]?.[R]??null}async setPassword(_,R,I){this.secretVault[_]=this.secretVault[_]??{},this.secretVault[_][R]=I}async deletePassword(_,R){return this.secretVault[_]?.[R]?(delete this.secretVault[_][R],Object.keys(this.secretVault[_]).length===0&&delete this.secretVault[_],!0):!1}async findPassword(_){return JSON.stringify(this.secretVault[_])??null}async findCredentials(_){const R=[];for(const I of Object.keys(this.secretVault[_]||{}))R.push({account:I,password:this.secretVault[_][I]});return R}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=L}),define(te[89],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function L(_){return!!_.hostName&&!!_.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(R,I){return{}}async getSystemInfo(R,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,I){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=r}),define(te[90],ie([0,1,18,72,164,6,45,3,37]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,_.createDecorator)("dialogService");var c;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(c||(c={}));class v{getConfirmationButtons(s){return this.getButtons(s,c.Confirmation)}getPromptButtons(s){return this.getButtons(s,c.Prompt)}getInputButtons(s){return this.getButtons(s,c.Input)}getButtons(s,w){const a=[];switch(w){case c.Confirmation:{const f=s;f.primaryButton?a.push(f.primaryButton):a.push((0,r.localize)(0,null)),f.cancelButton?a.push(f.cancelButton):a.push((0,r.localize)(1,null));break}case c.Prompt:{const f=s;Array.isArray(f.buttons)&&f.buttons.length>0&&a.push(...f.buttons.map(P=>P.label)),f.cancelButton&&(f.cancelButton===!0?a.push((0,r.localize)(2,null)):typeof f.cancelButton=="string"?a.push(f.cancelButton):f.cancelButton.label?a.push(f.cancelButton.label):a.push((0,r.localize)(3,null))),a.length===0&&a.push((0,r.localize)(4,null));break}case c.Input:{const f=s;f.primaryButton?a.push(f.primaryButton):a.push((0,r.localize)(5,null)),f.cancelButton?a.push(f.cancelButton):a.push((0,r.localize)(6,null));break}}return a}getDialogType(s){if(typeof s=="string")return s;if(typeof s=="number")return s===L.default.Info?"info":s===L.default.Error?"error":s===L.default.Warning?"warning":"none"}async getPromptResult(s,w,a){const f=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&f.push(s.cancelButton),{result:await f[w]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.AbstractDialogHandler=v,e.IFileDialogService=(0,_.createDecorator)("fileDialogService");var m;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(m||(e.ConfirmResult=m={}));const S=10;function u(p){const s=[];return s.push(...p.slice(0,S).map(w=>typeof w=="string"?w:(0,E.basename)(w))),p.length>S&&(p.length-S===1?s.push((0,r.localize)(7,null)):s.push((0,r.localize)(8,null,p.length-S))),s.push(""),s.join(`
`)}e.getFileNamesMessage=u;function y(p,s){const w=(0,h.deepClone)(p);let a=(w.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),f=(p.buttons||[]).map((t,l)=>l),P=0,C=w.cancelId??a.length-1;if(a.length>1){const t=typeof C=="number"?a[C]:void 0;if(I.isLinux||I.isMacintosh){if(typeof t=="string"&&a.length>1&&C!==1){a.splice(C,1),a.splice(1,0,t);const l=f[C];f.splice(C,1),f.splice(1,0,l),C=1}I.isLinux&&a.length>1&&(a=a.reverse(),f=f.reverse(),P=a.length-1,typeof t=="string"&&(C=P-1))}else if(I.isWindows&&typeof t=="string"&&a.length>1&&C!==a.length-1){a.splice(C,1),a.push(t);const l=f[C];f.splice(C,1),f.push(l),C=a.length-1}}return w.buttons=a,w.defaultId=P,w.cancelId=C,w.noLink=!0,w.title=w.title||s.nameLong,{options:w,buttonIndeces:f}}e.massageMessageBoxOptions=y}),define(te[114],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(te[33],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(te[115],ie([0,1,168,6]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function r(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function _(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function R(a,f){switch(a){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":f==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function I(a,f){return f==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function h(a,f,P){return I(f,P)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===P?!0:c(P).includes(a)}e.isTargetPlatformCompatible=h;function c(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function v(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=v;var m;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var S;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var u;(function(a){a.Install="install",a.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var y;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var p;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var s;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class w extends Error{constructor(f,P){super(f),this.code=P,this.name=P}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[116],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(te[209],ie([0,1,46,14,9,3,71,22,87,172,116]),function(j,e,E,L,r,_,R,I,h,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=c.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends S{openTerminal(P,C){return this.spawnTerminal(E,P,h.getWindowsShell(),C)}spawnTerminal(P,C,t,l){const n=C.windowsExec||u.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=r.basename(n,".exe").toLowerCase();if(i==="cmder")return P.spawn(n,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),i==="wt"&&o.push("-d ."),new Promise((d,g)=>{const D=s(process),M=P.spawn(t,o,{cwd:l,env:D});M.on("error",g),M.on("exit",()=>d())})}runInTerminal(P,C,t,l,n){const i="windowsExec"in n&&n.windowsExec?n.windowsExec:u.getDefaultTerminalWindows();return new Promise((o,d)=>{const g=`"${C} - ${m}"`,D=`""${t.join('" "')}" & pause"`,M=Object.assign({},s(process),l);Object.keys(M).filter(q=>M[q]===null).forEach(q=>delete M[q]);const b={cwd:C,env:M,windowsVerbatimArguments:!0};let A,O;r.basename(i,".exe")==="wt"?(A=i,O=["-d",".",u.CMD,"/c",D]):(A=u.CMD,O=["/c","start",g,"/wait",i,"/c",D]),E.spawn(A,O,b).on("error",q=>{d(w(q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!u._DEFAULT_TERMINAL_WINDOWS){const P=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${P?"Sysnative":"System32"}\\cmd.exe`}return u._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=u,u.CMD="cmd.exe";class y extends S{openTerminal(P,C){return this.spawnTerminal(E,P,C)}runInTerminal(P,C,t,l,n){const i=n.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((o,d)=>{if(i===v.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const g=i===v.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${g}.scpt`).fsPath,"-t",P||m,"-w",C];for(const O of t)M.push("-a"),M.push(O);if(l){const O=Object.assign({},s(process),l);for(const F in O){const q=O[F];q===null?(M.push("-u"),M.push(F)):(M.push("-e"),M.push(`${F}=${q}`))}}let b="";const A=E.spawn(y.OSASCRIPT,M);A.on("error",O=>{d(w(O))}),A.stderr.on("data",O=>{b+=O.toString()}),A.on("exit",O=>{if(O===0)o(void 0);else if(b){const F=b.split(`
`,1);d(new Error(F[0]))}else d(new Error(c.localize(1,null,g,O)))})}else d(new Error(c.localize(2,null,i)))})}spawnTerminal(P,C,t){const l=C.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((n,i)=>{const o=["-a",l];t&&o.push(t);const d=s(process),g=P.spawn("/usr/bin/open",o,{cwd:t,env:d});g.on("error",i),g.on("exit",()=>n())})}}e.MacExternalTerminalService=y,y.OSASCRIPT="/usr/bin/osascript";class p extends S{openTerminal(P,C){return this.spawnTerminal(E,P,C)}runInTerminal(P,C,t,l,n){const i=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,d)=>{const g=[];i.then(D=>{D.indexOf("gnome-terminal")>=0?g.push("-x"):g.push("-e"),g.push("bash"),g.push("-c");const M=`${a(t)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;g.push(`''${M}''`);const b=Object.assign({},s(process),l);Object.keys(b).filter(q=>b[q]===null).forEach(q=>delete b[q]);const A={cwd:C,env:b};let O="";const F=E.spawn(D,g,A);F.on("error",q=>{d(w(q))}),F.stderr.on("data",q=>{O+=q.toString()}),F.on("exit",q=>{if(q===0)o(void 0);else if(O){const re=O.split(`
`,1);d(new Error(re[0]))}else d(new Error(c.localize(4,null,D,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const P=await I.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(C=>{P?C("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?C("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?C("konsole"):process.env.COLORTERM?C(process.env.COLORTERM):process.env.TERM?C(process.env.TERM):C("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(P,C,t){const l=C.linuxExec?Promise.resolve(C.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,i)=>{l.then(o=>{const d=s(process),g=P.spawn(o,[],{cwd:t,env:d});g.on("error",i),g.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=c.localize(3,null);function s(f){const P={...f.env};return(0,R.sanitizeProcessEnvironment)(P),P}function w(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(c.localize(5,null,f.path)):f}function a(f){let P="";for(const C of f)C.indexOf(" ")>=0?P+='"'+C+'"':P+=C,P+=" ";return P}}),define(te[16],ie([0,1,62,9,25,11,8,174,6,3,14]),function(j,e,E,L,r,_,R,I,h,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function m(T){return T.create===!0}e.isFileOpenForWriteOptions=m;var S;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var u;(function(T){T[T.Readonly=1]="Readonly",T[T.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var y;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileAtomicWrite=32768]="FileAtomicWrite",T[T.FileAtomicDelete=65536]="FileAtomicDelete",T[T.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function p(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=p;function s(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=s;function w(T){return!!(T.capabilities&131072)}e.hasFileCloneCapability=w;function a(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function f(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=f;function P(T){return p(T)?!!(T.capabilities&16384):!1}e.hasFileAtomicReadCapability=P;function C(T){return p(T)?!!(T.capabilities&32768):!1}e.hasFileAtomicWriteCapability=C;function t(T){return!!(T.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;var l;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsStorageQuota="EntryExceedsStorageQuota",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class n extends Error{static create(x,Q){const Z=new n(x.toString(),Q);return d(Z,Q),Z}constructor(x,Q){super(x),this.code=Q}}e.FileSystemProviderError=n;function i(T,x){return n.create(T,x)}e.createFileSystemProviderError=i;function o(T){return T||i((0,I.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=o;function d(T,x){return T.name=x?`${x} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=d;function g(T){if(!T)return l.Unknown;if(T instanceof n)return T.code;const x=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!x)return l.Unknown;switch(x[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=g;function D(T){if(T instanceof q)return T.fileOperationResult;switch(g(T)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=D;var M;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class b{constructor(x,Q,Z){this.resource=x,this.operation=Q,this.target=Z}isOperation(x){return this.operation===x}}e.FileOperationEvent=b;var A;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class O{constructor(x,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Z=new Map;for(const ae of x){const oe=Z.get(ae.type);switch(oe?oe.push([ae.resource,ae]):Z.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,oe]of Z)switch(ae){case 1:this.added=E.TernarySearchTree.forUris(()=>Q),this.added.fill(oe);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>Q),this.updated.fill(oe);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>Q),this.deleted.fill(oe);break}}contains(x,...Q){return this.doContains(x,{includeChildren:!1},...Q)}affects(x,...Q){return this.doContains(x,{includeChildren:!0},...Q)}doContains(x,Q,...Z){if(!x)return!1;const ae=Z.length>0;return!!((!ae||Z.includes(1))&&(this.added?.get(x)||Q.includeChildren&&this.added?.findSuperstr(x))||(!ae||Z.includes(0))&&(this.updated?.get(x)||Q.includeChildren&&this.updated?.findSuperstr(x))||(!ae||Z.includes(2))&&(this.deleted?.findSubstr(x)||Q.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=O;function F(T,x,Q){return!T||!x||T===x||x.length>T.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),Q?(0,r.startsWithIgnoreCase)(T,x):T.indexOf(x)===0)}e.isParent=F;class q extends Error{constructor(x,Q,Z){super(x),this.fileOperationResult=Q,this.options=Z}}e.FileOperationError=q;class re extends q{constructor(x,Q,Z,ae){super(x,Q,ae),this.fileOperationResult=Q,this.size=Z}}e.TooLargeFileOperationError=re;class Y extends q{constructor(x,Q,Z){super(x,2,Z),this.stat=Q}}e.NotModifiedSinceFileOperationError=Y;var ne;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ce;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.ETAG_DISABLED="";function le(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=le;async function K(T,x){if(!x.hasProvider(R.URI.from({scheme:T.scheme})))return new Promise(Q=>{const Z=x.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===T.scheme&&ae.added&&(Z.dispose(),Q())})})}e.whenProviderRegistered=K;class V{static formatSize(x){return(0,_.isNumber)(x)||(x=0),x<V.KB?(0,I.localize)(1,null,x.toFixed(0)):x<V.MB?(0,I.localize)(2,null,(x/V.KB).toFixed(2)):x<V.GB?(0,I.localize)(3,null,(x/V.MB).toFixed(2)):x<V.TB?(0,I.localize)(4,null,(x/V.GB).toFixed(2)):(0,I.localize)(5,null,(x/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;function U(T){const x=typeof T=="string"||T?.scheme===v.Schemas.vscodeRemote;return typeof T!="string"&&T?.scheme===v.Schemas.file?1024*V.MB:x?10*V.MB:c.isWeb?50*V.MB:1024*V.MB}e.getLargeFileConfirmationLimit=U}),define(te[210],ie([0,1,17,50,13,4,2,61,8,31,16]),function(j,e,E,L,r,_,R,I,h,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class m extends R.Disposable{constructor(u,y){super(),this.channel=u,this.extraCapabilities=y,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,c.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u,y){const{buffer:p}=await this.channel.call("readFile",[u,y]);return p}readFileStream(u,y,p){const s=(0,I.newWriteableStream)(a=>E.VSBuffer.concat(a.map(f=>E.VSBuffer.wrap(f))).buffer),w=this.channel.listen("readFileStream",[u,y])(a=>{if(a instanceof E.VSBuffer)s.write(a.buffer);else{if(a==="end")s.end();else{let f;if(a instanceof Error)f=a;else{const P=a;f=(0,v.createFileSystemProviderError)(P.message??(0,L.toErrorMessage)(P),P.code??v.FileSystemProviderErrorCode.Unknown)}s.error(f),s.end()}w.dispose()}});return p.onCancellationRequested(()=>{s.error((0,r.canceled)()),s.end(),w.dispose()}),s}writeFile(u,y,p){return this.channel.call("writeFile",[u,E.VSBuffer.wrap(y),p])}open(u,y){return this.channel.call("open",[u,y])}close(u){return this.channel.call("close",[u])}async read(u,y,p,s,w){const[a,f]=await this.channel.call("read",[u,y,w]);return p.set(a.buffer.slice(0,f),s),f}write(u,y,p,s,w){return this.channel.call("write",[u,y,E.VSBuffer.wrap(p),s,w])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,y){return this.channel.call("delete",[u,y])}rename(u,y,p){return this.channel.call("rename",[u,y,p])}copy(u,y,p){return this.channel.call("copy",[u,y,p])}cloneFile(u,y){return this.channel.call("cloneFile",[u,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const y=u;this._onDidChange.fire(y.map(p=>({resource:h.URI.revive(p.resource),type:p.type})))}else{const y=u;this._onDidWatchError.fire(y)}}))}watch(u,y){const p=(0,c.generateUuid)();return this.channel.call("watch",[this.sessionId,p,u,y]),(0,R.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=m}),define(te[117],ie([0,1,17,13,175,16]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(v,m,S,u,y,p){let s;try{await I(v,m,S,u,y,p)}catch(w){s=w}finally{s&&y.errorTransformer&&(s=y.errorTransformer(s)),typeof s<"u"&&S.error(s),S.end()}}e.readFileIntoStream=R;async function I(v,m,S,u,y,p){h(p);const s=await v.open(m,{create:!1});try{h(p);let w=0,a=0,f=y&&typeof y.length=="number"?y.length:void 0,P=E.VSBuffer.alloc(Math.min(y.bufferSize,typeof f=="number"?f:y.bufferSize)),C=y&&typeof y.position=="number"?y.position:0,t=0;do a=await v.read(s,C,P.buffer,t,P.byteLength-t),C+=a,t+=a,w+=a,typeof f=="number"&&(f-=a),t===P.byteLength&&(await S.write(u(P)),P=E.VSBuffer.alloc(Math.min(y.bufferSize,typeof f=="number"?f:y.bufferSize)),t=0);while(a>0&&(typeof f!="number"||f>0)&&h(p)&&c(w,y));if(t>0){let l=t;typeof f=="number"&&(l=Math.min(t,f)),S.write(u(P.slice(0,l)))}}catch(w){throw(0,_.ensureFileSystemProviderError)(w)}finally{await v.close(s)}}function h(v){if(v.isCancellationRequested)throw(0,L.canceled)();return!0}function c(v,m){if(typeof m?.limits?.size=="number"&&v>m.limits.size)throw(0,_.createFileSystemProviderError)((0,r.localize)(0,null),_.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[76],ie([0,1,104,2,9,3,8,16]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(w){return w.recursive===!0}e.isRecursiveWatchRequest=h;class c extends L.Disposable{constructor(a,f,P,C){super(),this.onFileChanges=a,this.onLogMessage=f,this.verboseLogging=P,this.options=C,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const a=new L.DisposableStore;this.watcherDisposables.value=a,this.watcher=this.createWatcher(a),this.watcher.setVerboseLogging(this.verboseLogging),a.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),a.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),a.add(this.watcher.onDidError(f=>this.onError(f)))}onError(a){this.options.restartOnError?this.restartCounter<c.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${a}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${a}`):this.error(a)}restart(a){this.restartCounter++,this.init(),this.watch(a)}async watch(a){this.requests=a,await this.watcher?.watch(a)}async setVerboseLogging(a){this.verboseLogging=a,await this.watcher?.setVerboseLogging(a)}error(a){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${a}`})}trace(a){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${a}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=c,c.MAX_RESTARTS=5;class v extends c{constructor(a,f,P){super(a,f,P,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class m extends c{constructor(a,f,P){super(a,f,P,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=m;function S(w){return w.map(a=>({type:a.type,resource:R.URI.file(a.path)}))}e.toFileChanges=S;function u(w){const a=new s;for(const f of w)a.processEvent(f);return a.coalesce()}e.coalesceEvents=u;function y(w,a){return typeof a=="string"&&!a.startsWith(E.GLOBSTAR)&&!(0,r.isAbsolute)(a)?{base:w,pattern:a}:a}e.normalizeWatcherPattern=y;function p(w,a){const f=[];for(const P of a)f.push((0,E.parse)(y(w,P)));return f}e.parseWatcherPatterns=p;class s{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(a){return _.isLinux?a.path:a.path.toLowerCase()}processEvent(a){const f=this.mapPathToChange.get(this.toKey(a));let P=!1;if(f){const C=f.type,t=a.type;f.path!==a.path&&(a.type===2||a.type===1)?P=!0:C===1&&t===2?(this.mapPathToChange.delete(this.toKey(a)),this.coalesced.delete(f)):C===2&&t===1?f.type=0:C===1&&t===0||(f.type=t)}else P=!0;P&&(this.coalesced.add(a),this.mapPathToChange.set(this.toKey(a),a))}coalesce(){const a=[],f=[];return Array.from(this.coalesced).filter(P=>P.type!==2?(a.push(P),!1):!0).sort((P,C)=>P.path.length-C.path.length).filter(P=>f.some(C=>(0,I.isParent)(P.path,C,!_.isLinux))?!1:(f.push(P.path),!0)).concat(a)}}}),define(te[211],ie([0,1,42,7,21,32,2,83,9,3,105,22,76]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends R.Disposable{constructor(s,w,a,f){super(),this.request=s,this.onDidFilesChange=w,this.onLogMessage=a,this.verboseLogging=f,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},P=>this.onDidFilesChange(P))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(P=>this.handleFileChanges(P),u.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const s=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await m.Promises.stat(s);this._register(await this.doWatch(s,w.isDirectory()))}catch(s){s.code!=="ENOENT"?this.error(s):this.trace(s)}}async normalizePath(s){let w=s.path;try{w=await m.Promises.realpath(s.path),s.path===w&&(w=await(0,v.realcase)(s.path)??s.path),s.path!==w&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${w})`)}catch{}return w}async doWatch(s,w){if(c.isMacintosh&&(0,_.isEqualOrParent)(s,"/Volumes/",!0))return this.error(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const a=new r.CancellationTokenSource(this.cts.token),f=new R.DisposableStore;try{const P=(0,h.basename)(s),C=(0,E.watch)(s);f.add((0,R.toDisposable)(()=>{C.removeAllListeners(),C.close()})),this.trace(`Started watching: '${s}'`);const t=new Set;if(w)try{for(const n of await m.Promises.readdir(s))t.add(n)}catch(n){this.error(n)}const l=new Map;f.add((0,R.toDisposable)(()=>{for(const[,n]of l)n.dispose();l.clear()})),C.on("error",(n,i)=>{this.error(`Failed to watch ${s} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),C.on("change",(n,i)=>{if(a.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let o="";if(i&&(o=i.toString(),c.isMacintosh&&(o=(0,I.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(w)if(n==="rename"){l.get(o)?.dispose();const d=setTimeout(async()=>{if(l.delete(o),o===P&&!await m.Promises.exists(s)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.existsChildStrictCase((0,h.join)(s,o));if(a.token.isCancellationRequested)return;let D;g?t.has(o)?D=0:(D=1,t.add(o)):(t.delete(o),D=2),this.onFileChange({path:(0,h.join)(this.request.path,o),type:D})},u.FILE_DELETE_HANDLER_DELAY);l.set(o,(0,R.toDisposable)(()=>clearTimeout(d)))}else{let d;t.has(o)?d=0:(d=1,t.add(o)),this.onFileChange({path:(0,h.join)(this.request.path,o),type:d})}else if(n==="rename"||o!==P){const d=setTimeout(async()=>{const g=await m.Promises.exists(s);a.token.isCancellationRequested||(g?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(s,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,R.toDisposable)(()=>clearTimeout(d)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(P){await m.Promises.exists(s)&&!a.token.isCancellationRequested&&this.error(`Failed to watch ${s} for changes using fs.watch() (${P.toString()})`)}return(0,R.toDisposable)(()=>{a.dispose(!0),f.dispose()})}onFileChange(s,w=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!w&&this.excludes.some(a=>a(s.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${s.path}`):!w&&this.includes&&this.includes.length>0&&!this.includes.some(a=>a(s.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${s.path}`):this.fileChangesAggregator.work(s))}handleFileChanges(s){const w=(0,S.coalesceEvents)(s);if(w.length>0){if(this.verboseLogging)for(const f of w)this.trace(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.throttledFileChangesEmitter.work(w)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(s){if(c.isLinux)return m.Promises.exists(s);try{const w=(0,h.basename)(s);return(await m.Promises.readdir((0,h.dirname)(s))).some(f=>f===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(s){this.verboseLogging=s}error(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}warn(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}trace(s){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=75;async function y(p,s,w,a,f=512){const P=await m.Promises.open(p,"r"),C=Buffer.allocUnsafe(f),t=new r.CancellationTokenSource(a);let l,n=!1;const i={path:p,excludes:[],recursive:!1},o=new u(i,d=>{(async()=>{for(const{type:g}of d)if(g===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:D}=await m.Promises.read(P,C,0,f,null);if(!D||t.token.isCancellationRequested)break;s(C.slice(0,D))}}catch(D){l=new Error(D),t.dispose(!0)}finally{n=!1}}})()});return await o.ready,w(),new Promise((d,g)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await m.Promises.close(P)}catch(D){l=new Error(D)}l?g(l):d()})})}e.watchFileContents=y}),define(te[212],ie([0,1,4,104,2,3,211]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new E.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=E.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(c){const v=this.normalizeRequests(c),m=v.filter(u=>{const y=this.watchers.get(u.path);return y?!(0,L.patternsEquals)(y.request.excludes,u.excludes)||!(0,L.patternsEquals)(y.request.includes,u.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:u})=>!v.find(y=>y.path===u.path&&(0,L.patternsEquals)(y.excludes,u.excludes)&&(0,L.patternsEquals)(y.includes,u.includes))).map(({request:u})=>u.path);m.length&&this.trace(`Request to start watching: ${m.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const u of S)this.stopWatching(u);for(const u of m)this.startWatching(u)}startWatching(c){const v=new R.NodeJSFileWatcherLibrary(c,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),m={request:c,instance:v};this.watchers.set(c.path,m)}async stop(){for(const[c]of this.watchers)this.stopWatching(c);this.watchers.clear()}stopWatching(c){const v=this.watchers.get(c);v&&(this.watchers.delete(c),v.instance.dispose())}normalizeRequests(c){const v=new Map;for(const m of c){const S=_.isLinux?m.path:m.path.toLowerCase();v.set(S,m)}return Array.from(v.values())}async setVerboseLogging(c){this.verboseLogging=c;for(const[,v]of this.watchers)v.instance.setVerboseLogging(c)}trace(c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(c)})}toMessage(c,v){return v?`[File Watcher (node.js)] ${c} (path: ${v.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=I}),define(te[213],ie([0,1,76,212]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends E.AbstractNonRecursiveWatcherClient{constructor(R,I,h){super(R,I,h),this.init()}createWatcher(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=r}),define(te[214],ie([0,1,14,43,158,76]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends _.AbstractUniversalWatcherClient{constructor(h,c,v){super(h,c,v),this.init()}createWatcher(h){const c=h.add(new r.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:v,signal:m})=>this.onError(`terminated by itself with code ${v}, signal: ${m}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(te[91],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...r){this._entries=new Map;for(const[_,R]of r)this.set(_,R)}set(r,_){const R=this._entries.get(r);return this._entries.set(r,_),R}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=E}),define(te[215],ie([0,1,7,13,2,74,206,6,91,101]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class m extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class S{constructor(s=new h.ServiceCollection,w=!1,a,f=v){this._services=s,this._strict=w,this._parent=a,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=f?a?._globalGraph??new R.Graph(P=>P):void 0}createChild(s){return new S(s,this._strict,this,this._enableTracing)}invokeFunction(s,...w){const a=y.traceInvocation(this._enableTracing,s);let f=!1;try{return s({get:C=>{if(f)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(C,a);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...w)}finally{f=!0,a.stop()}}createInstance(s,...w){let a,f;return s instanceof _.SyncDescriptor?(a=y.traceCreation(this._enableTracing,s.ctor),f=this._createInstance(s.ctor,s.staticArguments.concat(w),a)):(a=y.traceCreation(this._enableTracing,s),f=this._createInstance(s,w,a)),a.stop(),f}_createInstance(s,w=[],a){const f=I._util.getServiceDependencies(s).sort((t,l)=>t.index-l.index),P=[];for(const t of f){const l=this._getOrCreateServiceInstance(t.id,a);l||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),P.push(l)}const C=f.length>0?f[0].index:w.length;if(w.length!==C){console.trace(`[createInstance] First service dependency of ${s.name} at position ${C+1} conflicts with ${w.length} static arguments`);const t=C-w.length;t>0?w=w.concat(new Array(t)):w=w.slice(0,C)}return Reflect.construct(s,w.concat(P))}_setServiceInstance(s,w){if(this._services.get(s)instanceof _.SyncDescriptor)this._services.set(s,w);else if(this._parent)this._parent._setServiceInstance(s,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){const w=this._services.get(s);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):w}_getOrCreateServiceInstance(s,w){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(s));const a=this._getServiceInstanceOrDescriptor(s);return a instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,a,w.branch(s,!0)):(w.branch(s,!1),a)}_safeCreateAndCacheServiceInstance(s,w,a){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,w,a)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,w,a){const f=new R.Graph(t=>t.id.toString());let P=0;const C=[{id:s,desc:w,_trace:a}];for(;C.length;){const t=C.pop();if(f.lookupOrInsertNode(t),P++>1e3)throw new m(f);for(const l of I._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(l.id);if(n||this._throwIfStrict(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),n instanceof _.SyncDescriptor){const i={id:l.id,desc:n,_trace:t._trace.branch(l.id,!0)};f.insertEdge(t,i),C.push(i)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new m(f);break}for(const{data:l}of t){if(this._getServiceInstanceOrDescriptor(l.id)instanceof _.SyncDescriptor){const i=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,i)}f.removeNode(l)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,w,a=[],f,P){if(this._services.get(s)instanceof _.SyncDescriptor)return this._createServiceInstance(s,w,a,f,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,w,a,f,P);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(s,w,a=[],f,P){if(f){const C=new S(void 0,this._strict,this,this._enableTracing);C._globalGraphImplicitDependency=String(s);const t=new Map,l=new E.IdleValue(()=>{const n=C._createInstance(w,a,P);for(const[i,o]of t){const d=n[i];if(typeof d=="function")for(const g of o)d.apply(n,g)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let g=t.get(i);return g||(g=new c.LinkedList,t.set(i,g)),(M,b,A)=>{const O=g.push([M,b,A]);return(0,r.toDisposable)(O)}}if(i in n)return n[i];const o=l.value;let d=o[i];return typeof d!="function"||(d=d.bind(o),n[i]=d),d},set(n,i,o){return l.value[i]=o,!0},getPrototypeOf(n){return w.prototype}})}else return this._createInstance(w,a,P)}_throwIfStrict(s,w){if(w&&console.warn(s),this._strict)throw new Error(s)}}e.InstantiationService=S;var u;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(u||(u={}));class y{static traceInvocation(s,w){return s?new y(2,w.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(s,w){return s?new y(1,w.name):y._None}constructor(s,w){this.type=s,this.name=w,this._start=Date.now(),this._dep=[]}branch(s,w){const a=new y(3,s.toString());return this._dep.push([s,w,a]),a}stop(){const s=Date.now()-this._start;y._totals+=s;let w=!1;function a(P,C){const t=[],l=new Array(P+1).join("	");for(const[n,i,o]of C._dep)if(i&&o){w=!0,t.push(`${l}CREATES -> ${n}`);const d=a(P+1,o);d&&t.push(d)}else t.push(`${l}uses -> ${n}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(s>2||w)&&y.all.add(f.join(`
`))}}e.Trace=y,y.all=new Set,y._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y._totals=0}),define(te[216],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,E.createDecorator)("issueService")}),define(te[5],ie([0,1,50,4,56,2,35,3,18,11,8,113,6]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function u(){return new Date().toISOString()}function y(M){return(0,c.isNumber)(M)}e.isLogLevel=y;var p;(function(M){M[M.Off=0]="Off",M[M.Trace=1]="Trace",M[M.Debug=2]="Debug",M[M.Info=3]="Info",M[M.Warning=4]="Warning",M[M.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function s(M,b,A){switch(b){case p.Trace:M.trace(A);break;case p.Debug:M.debug(A);break;case p.Info:M.info(A);break;case p.Warning:M.warn(A);break;case p.Error:M.error(A);break;case p.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=s;function w(M,b=!1){let A="";for(let O=0;O<M.length;O++){let F=M[O];if(F instanceof Error&&(F=(0,E.toErrorMessage)(F,b)),typeof F=="object")try{F=JSON.stringify(F)}catch{}A+=(O>0?" ":"")+F}return A}class a extends _.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(b){this.level!==b&&(this.level=b,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(b){return this.level!==p.Off&&this.level<=b}}e.AbstractLogger=a;class f extends a{constructor(b){super(),this.logAlways=b}checkLogLevel(b){return this.logAlways||super.checkLogLevel(b)}trace(b,...A){this.checkLogLevel(p.Trace)&&this.log(p.Trace,w([b,...A],!0))}debug(b,...A){this.checkLogLevel(p.Debug)&&this.log(p.Debug,w([b,...A]))}info(b,...A){this.checkLogLevel(p.Info)&&this.log(p.Info,w([b,...A]))}warn(b,...A){this.checkLogLevel(p.Warning)&&this.log(p.Warning,w([b,...A]))}error(b,...A){if(this.checkLogLevel(p.Error))if(b instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=b.stack,this.log(p.Error,w(O))}else this.log(p.Error,w([b,...A]))}flush(){}}e.AbstractMessageLogger=f;class P extends a{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.useColors=!I.isWindows}trace(b,...A){this.checkLogLevel(p.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,b,...A):console.log(`[main ${u()}]`,b,...A))}debug(b,...A){this.checkLogLevel(p.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,b,...A):console.log(`[main ${u()}]`,b,...A))}info(b,...A){this.checkLogLevel(p.Info)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,b,...A):console.log(`[main ${u()}]`,b,...A))}warn(b,...A){this.checkLogLevel(p.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,b,...A):console.warn(`[main ${u()}]`,b,...A))}error(b,...A){this.checkLogLevel(p.Error)&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,b,...A):console.error(`[main ${u()}]`,b,...A))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class C extends a{constructor(b=e.DEFAULT_LOG_LEVEL,A=!0){super(),this.useColors=A,this.setLevel(b)}trace(b,...A){this.checkLogLevel(p.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",b,...A):console.log(b,...A))}debug(b,...A){this.checkLogLevel(p.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",b,...A):console.log(b,...A))}info(b,...A){this.checkLogLevel(p.Info)&&(this.useColors?console.log("%c INFO","color: #33f",b,...A):console.log(b,...A))}warn(b,...A){this.checkLogLevel(p.Warning)&&(this.useColors?console.log("%c WARN","color: #993",b,...A):console.log(b,...A))}error(b,...A){this.checkLogLevel(p.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",b,...A):console.error(b,...A))}dispose(){}flush(){}}e.ConsoleLogger=C;class t extends a{constructor(b,A=e.DEFAULT_LOG_LEVEL){super(),this.adapter=b,this.setLevel(A)}trace(b,...A){this.checkLogLevel(p.Trace)&&this.adapter.log(p.Trace,[this.extractMessage(b),...A])}debug(b,...A){this.checkLogLevel(p.Debug)&&this.adapter.log(p.Debug,[this.extractMessage(b),...A])}info(b,...A){this.checkLogLevel(p.Info)&&this.adapter.log(p.Info,[this.extractMessage(b),...A])}warn(b,...A){this.checkLogLevel(p.Warning)&&this.adapter.log(p.Warning,[this.extractMessage(b),...A])}error(b,...A){this.checkLogLevel(p.Error)&&this.adapter.log(p.Error,[this.extractMessage(b),...A])}extractMessage(b){return typeof b=="string"?b:(0,E.toErrorMessage)(b,this.checkLogLevel(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class l extends a{constructor(b){super(),this.loggers=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const A of this.loggers)A.setLevel(b);super.setLevel(b)}trace(b,...A){for(const O of this.loggers)O.trace(b,...A)}debug(b,...A){for(const O of this.loggers)O.debug(b,...A)}info(b,...A){for(const O of this.loggers)O.info(b,...A)}warn(b,...A){for(const O of this.loggers)O.warn(b,...A)}error(b,...A){for(const O of this.loggers)O.error(b,...A)}flush(){for(const b of this.loggers)b.flush()}dispose(){for(const b of this.loggers)b.dispose()}}e.MultiplexLogger=l;class n extends _.Disposable{constructor(b,A,O){if(super(),this.logLevel=b,this.logsHome=A,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const F of O)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(b){return(0,c.isString)(b)?[...this._loggers.values()].find(A=>A.info.id===b):this._loggers.get(b)}getLogger(b){return this.getLoggerEntry(b)?.logger}createLogger(b,A){const O=this.toResource(b),F=(0,c.isString)(b)?b:A?.id??(0,r.hash)(O.toString()).toString(16);let q=this._loggers.get(O)?.logger;const re=A?.logLevel==="always"?p.Trace:A?.logLevel;q||(q=this.doCreateLogger(O,re??this.getLogLevel(O)??this.logLevel,{...A,id:F}));const Y={logger:q,info:{resource:O,id:F,logLevel:re,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(Y.info),this._loggers.set(O,Y),q}toResource(b){return(0,c.isString)(b)?(0,h.joinPath)(this.logsHome,`${b}.log`):b}setLogLevel(b,A){if(v.URI.isUri(b)){const O=b,F=A,q=this._loggers.get(O);q&&F!==q.info.logLevel&&(q.info.logLevel=F===this.logLevel?void 0:F,q.logger?.setLevel(F),this._loggers.set(q.info.resource,q),this._onDidChangeLogLevel.fire([O,F]))}else{this.logLevel=b;for(const[O,F]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(b,A){const O=this.getLoggerEntry(b);O&&A!==!O.info.hidden&&(O.info.hidden=!A,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,A]))}getLogLevel(b){let A;return b&&(A=this._loggers.get(b)?.info.logLevel),A??this.logLevel}registerLogger(b){const A=this._loggers.get(b.resource);A?A.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this._loggers.set(b.resource,{info:b,logger:void 0}),this._onDidChangeLoggers.fire({added:[b],removed:[]}))}deregisterLogger(b){const A=this._loggers.get(b);A&&(A.logger&&A.logger.dispose(),this._loggers.delete(b),this._onDidChangeLoggers.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const b of this._loggers.values())yield b.info}getRegisteredLogger(b){return this._loggers.get(b)?.info}dispose(){this._loggers.forEach(b=>b.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(b){}getLevel(){return p.Info}trace(b,...A){}debug(b,...A){}info(b,...A){}warn(b,...A){}error(b,...A){}critical(b,...A){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;function d(M){if(M.verbose)return p.Trace;if(typeof M.logLevel=="string"){const b=D(M.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function g(M){switch(M){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=g;function D(M){switch(M){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",g(p.Info))});var J=this&&this.__param||function(j,e){return function(E,L){e(E,L,j)}};define(te[217],ie([0,1,75,4,2,5,3,7]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let h=e.BaseCredentialsMainService=class dt extends r.Disposable{constructor(v){super(),this.logService=v,this._onDidChangePassword=this._register(new L.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this._sequencer=new I.SequencerByKey}async getPassword(v,m){this.logService.trace("Going to get password from keytar:",v,m);let S;try{S=await this.withKeytar()}catch{return null}return await this._sequencer.queue(v+m,()=>this.doGetPassword(S,v,m))}async doGetPassword(v,m,S){this.logService.trace("Doing get password from keytar:",m,S);const u=await(0,I.retry)(()=>v.getPassword(m,S),50,3);if(!u)return this.logService.trace("Did not get a password from keytar for account:",S),u;let y,p;try{const s=JSON.parse(u);y=s.content,p=s.hasNextChunk}catch{}if(!y||!p)return this.logService.trace("Got password from keytar for account:",S),u;try{let s=1;for(;p;){const w=await(0,I.retry)(()=>v.getPassword(m,`${S}-${s}`),50,3),a=JSON.parse(w);y+=a.content,p=a.hasNextChunk,s++}return this.logService.trace(`Got ${s}-chunked password from keytar for account:`,S),y}catch(s){return this.logService.error(s),u}}async setPassword(v,m,S){this.logService.trace("Going to set password using keytar:",v,m);let u;try{u=await this.withKeytar()}catch(y){throw this.surfaceKeytarLoadError?.(y),y}await this._sequencer.queue(v+m,()=>this.doSetPassword(u,v,m,S)),this._onDidChangePassword.fire({service:v,account:m})}async doSetPassword(v,m,S,u){if(this.logService.trace("Doing set password from keytar:",m,S),!R.isWindows){await(0,I.retry)(()=>v.setPassword(m,S,u),50,3),this.logService.trace("Set password from keytar for account:",S);return}if(await this.doDeletePassword(v,m,S),u.length<=dt.PASSWORD_CHUNK_SIZE){await(0,I.retry)(()=>v.setPassword(m,S,u),50,3),this.logService.trace("Set password from keytar for account:",S);return}let y=0,p=0,s=!0;for(;s;){const w=u.substring(y,y+dt.PASSWORD_CHUNK_SIZE);y+=dt.PASSWORD_CHUNK_SIZE,s=u.length-y>0;const a={content:w,hasNextChunk:s};await(0,I.retry)(()=>v.setPassword(m,p?`${S}-${p}`:S,JSON.stringify(a)),50,3),p++}this.logService.trace(`Set${p?` ${p}-chunked`:""} password from keytar for account:`,S)}async deletePassword(v,m){this.logService.trace("Going to delete password using keytar:",v,m);let S;try{S=await this.withKeytar()}catch(y){throw this.surfaceKeytarLoadError?.(y),y}const u=await this._sequencer.queue(v+m,()=>this.doDeletePassword(S,v,m));return u&&this._onDidChangePassword.fire({service:v,account:m}),u}async doDeletePassword(v,m,S){this.logService.trace("Doing delete password from keytar:",m,S);const u=await v.getPassword(m,S);if(!u)return this.logService.trace("Did not get a password to delete from keytar for account:",S),!1;let y,p;try{const w=JSON.parse(u);y=w.content,p=w.hasNextChunk}catch{}let s=0;if(y&&p)try{for(s++;p;){const w=`${S}-${s}`,a=await v.getPassword(m,w);await v.deletePassword(m,w),p=JSON.parse(a).hasNextChunk,s++}}catch(w){this.logService.error(w)}return await v.deletePassword(m,S)?(this.logService.trace(`Deleted${s?` ${s}-chunked`:""} password from keytar for account:`,S),!0):(this.logService.trace(`Keytar failed to delete${s?` ${s}-chunked`:""} password for account:`,S),!1)}async findPassword(v){let m;try{m=await this.withKeytar()}catch{return null}return await m.findPassword(v)}async findCredentials(v){let m;try{m=await this.withKeytar()}catch{return[]}return await m.findCredentials(v)}clear(){return this._keytarCache instanceof E.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};h.MAX_PASSWORD_LENGTH=2500,h.PASSWORD_CHUNK_SIZE=h.MAX_PASSWORD_LENGTH-100,e.BaseCredentialsMainService=h=Se([J(0,_.ILogService)],h)}),define(te[218],ie([0,1,5]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=e.EncryptionMainService=class{constructor(_,R){this.machineId=_,this.logService=R}encryption(){return new Promise((_,R)=>j(["vscode-encrypt"],_,R))}async encrypt(_){let R;try{R=await this.encryption()}catch{return _}try{return R.encrypt(this.machineId,_)}catch(I){return this.logService.error(I),_}}async decrypt(_){let R;try{R=await this.encryption()}catch{return _}try{return R.decrypt(this.machineId,_)}catch(I){return this.logService.error(I),_}}};e.EncryptionMainService=L=Se([J(1,E.ILogService)],L)}),define(te[219],ie([0,1,24,7,13,4,2,9,76,5]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends R.Disposable{constructor(S,u){super(),this.logService=S,this.options=u,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(S,u){return u.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,u):this.watchNonRecursive(S,u)}watchUniversal(S,u){const y={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:u.recursive},p=(0,E.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(u=>this._onDidChangeFile.fire((0,h.toFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const u of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const u of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(u)&&S.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,u){const y={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:!1},p=(0,E.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,I.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(te[220],ie([0,1,24,7,17,21,4,56,68,2,62,14,65,18,61,173,16,117,5,13]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=e.FileService=class extends c.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(t,l){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const n=new c.DisposableStore;return this.provider.set(t,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:l}),n.add(l.onDidChangeFile(i=>this._onDidFilesChange.fire(new s.FileChangesEvent(i,!this.isPathCaseSensitive(l))))),typeof l.onDidWatchError=="function"&&n.add(l.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:t}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:l}),this.provider.delete(t),(0,c.dispose)(n)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(n){l.push(n)}}),!this.provider.has(t)&&await L.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,l){const n=this.provider.get(t.scheme);return!!(n&&n.capabilities&l)}listCapabilities(){return h.Iterable.map(this.provider,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async withProvider(t){if(!(0,u.isAbsolutePath)(t))throw new s.FileOperationError((0,p.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const l=this.provider.get(t.scheme);if(!l){const n=new f.ErrorNoTelemetry;throw n.message=(0,p.localize)(1,null,t.toString()),n}return l}async withReadProvider(t){const l=await this.withProvider(t);if((0,s.hasOpenReadWriteCloseCapability)(l)||(0,s.hasReadWriteCapability)(l)||(0,s.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const l=await this.withProvider(t);if((0,s.hasOpenReadWriteCloseCapability)(l)||(0,s.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.doResolveFile(t,l)}catch(n){throw(0,s.toFileSystemProviderErrorCode)(n)===s.FileSystemProviderErrorCode.FileNotFound?new s.FileOperationError((0,p.localize)(2,null,this.resourceForError(t)),1):(0,s.ensureFileSystemProviderError)(n)}}async doResolveFile(t,l){const n=await this.withProvider(t),i=this.isPathCaseSensitive(n),o=l?.resolveTo,d=l?.resolveSingleChildDescendants,g=l?.resolveMetadata,D=await n.stat(t);let M;return this.toFileStat(n,t,D,void 0,!!g,(b,A)=>(M||(M=v.TernarySearchTree.forUris(()=>!i),M.set(t,!0),o&&M.fill(!0,o)),M.get(b.resource)||M.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&d?A===1:!1))}async toFileStat(t,l,n,i,o,d){const{providerExtUri:g}=this.getExtUri(t),D={resource:l,name:g.basename(l),isFile:(n.type&s.FileType.File)!==0,isDirectory:(n.type&s.FileType.Directory)!==0,isSymbolicLink:(n.type&s.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&s.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&s.FilePermission.Locked),etag:(0,s.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(D.isDirectory&&d(D,i)){try{const M=await t.readdir(l),b=await L.Promises.settled(M.map(async([A,O])=>{try{const F=g.joinPath(l,A),q=o?await t.stat(F):{type:O};return await this.toFileStat(t,F,q,M.length,o,d)}catch(F){return this.logService.trace(F),null}}));D.children=(0,E.coalesce)(b)}catch(M){this.logService.trace(M),D.children=[]}return D}return D}async resolveAll(t){return L.Promises.settled(t.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.withProvider(t),n=await l.stat(t);return this.toFileStat(l,t,n,void 0,!0,()=>!1)}async exists(t){const l=await this.withProvider(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.doValidateCreateFile(t,l)}catch(n){return n}return!0}async doValidateCreateFile(t,l){if(!l?.overwrite&&await this.exists(t))throw new s.FileOperationError((0,p.localize)(3,null,this.resourceForError(t)),3,l)}async createFile(t,l=r.VSBuffer.fromString(""),n){await this.doValidateCreateFile(t,n);const i=await this.writeFile(t,l);return this._onDidRunOperation.fire(new s.FileOperationEvent(t,0,i)),i}async writeFile(t,l,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,t,n)||await this.mkdirp(i,o.dirname(t));let g;if((0,s.hasReadWriteCapability)(i)&&!(l instanceof r.VSBuffer))if((0,y.isReadableStream)(l)){const D=await(0,y.peekStream)(l,3);D.ended?g=r.VSBuffer.concat(D.buffer):g=D}else g=(0,y.peekReadable)(l,D=>r.VSBuffer.concat(D),3);else g=l;if(!(0,s.hasOpenReadWriteCloseCapability)(i)||(0,s.hasReadWriteCapability)(i)&&g instanceof r.VSBuffer)await this.doWriteUnbuffered(i,t,n,g);else{const D=g instanceof r.VSBuffer?(0,r.bufferToReadable)(g):g;n?.atomic!==!1&&n?.atomic?.postfix?await this.doWriteBufferedAtomic(i,t,(0,u.joinPath)((0,u.dirname)(t),`${(0,u.basename)(t)}${n.atomic.postfix}`),n,D):await this.doWriteBuffered(i,t,n,D)}this._onDidRunOperation.fire(new s.FileOperationEvent(t,4))}catch(d){throw new s.FileOperationError((0,p.localize)(4,null,this.resourceForError(t),(0,s.ensureFileSystemProviderError)(d).toString()),(0,s.toFileOperationResult)(d),n)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,l,n){const i=!!n?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(l)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,p.localize)(6,null,this.resourceForError(l)));if(i)throw new Error((0,p.localize)(7,null,this.resourceForError(l)))}let d;try{d=await t.stat(l)}catch{return}if(d.type&s.FileType.Directory)throw new s.FileOperationError((0,p.localize)(8,null,this.resourceForError(l)),0,n);if(this.throwIfFileIsReadonly(l,d),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==s.ETAG_DISABLED&&typeof d.mtime=="number"&&typeof d.size=="number"&&n.mtime<d.mtime&&n.etag!==(0,s.etag)({mtime:n.mtime,size:d.size}))throw new s.FileOperationError((0,p.localize)(9,null),3,n);return d}async readFile(t,l,n){const i=await this.withReadProvider(t);return l?.atomic?this.doReadFileAtomic(i,t,l,n):this.doReadFile(i,t,l,n)}async doReadFileAtomic(t,l,n,i){return new Promise((o,d)=>{this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{try{const g=await this.doReadFile(t,l,n,i);o(g)}catch(g){d(g)}})})}async doReadFile(t,l,n,i){const o=await this.doReadFileStream(t,l,{...n,preferUnbuffered:!0},i);return{...o,value:await(0,r.streamToBuffer)(o.value)}}async readFileStream(t,l,n){const i=await this.withReadProvider(t);return this.doReadFileStream(i,t,l,n)}async doReadFileStream(t,l,n,i){const o=new _.CancellationTokenSource(i),d=this.validateReadFile(l,n).then(D=>D,D=>{throw o.cancel(),D});let g;try{return typeof n?.etag=="string"&&n.etag!==s.ETAG_DISABLED&&await d,n?.atomic&&(0,s.hasFileAtomicReadCapability)(t)||!((0,s.hasOpenReadWriteCloseCapability)(t)||(0,s.hasFileReadStreamCapability)(t))||(0,s.hasReadWriteCapability)(t)&&n?.preferUnbuffered?g=this.readFileUnbuffered(t,l,n):(0,s.hasFileReadStreamCapability)(t)?g=this.readFileStreamed(t,l,o.token,n):g=this.readFileBuffered(t,l,o.token,n),{...await d,value:g}}catch(D){throw g&&await(0,y.consumeStream)(g),this.restoreReadError(D,l,n)}}restoreReadError(t,l,n){const i=(0,p.localize)(10,null,this.resourceForError(l),(0,s.ensureFileSystemProviderError)(t).toString());return t instanceof s.NotModifiedSinceFileOperationError?new s.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof s.TooLargeFileOperationError?new s.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new s.FileOperationError(i,(0,s.toFileOperationResult)(t),n)}readFileStreamed(t,l,n,i=Object.create(null)){const o=t.readFileStream(l,i,n);return(0,y.transform)(o,{data:d=>d instanceof r.VSBuffer?d:r.VSBuffer.wrap(d),error:d=>this.restoreReadError(d,l,i)},d=>r.VSBuffer.concat(d))}readFileBuffered(t,l,n,i=Object.create(null)){const o=(0,r.newWriteableBufferStream)();return(0,w.readFileIntoStream)(t,l,o,d=>d,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:d=>this.restoreReadError(d,l,i)},n),o}readFileUnbuffered(t,l,n){const i=(0,y.newWriteableStream)(o=>r.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,s.hasFileAtomicReadCapability)(t)?o=await t.readFile(l,{atomic:!0}):o=await t.readFile(l),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.validateReadFileLimits(l,o.byteLength,n),i.end(r.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(t,l){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new s.FileOperationError((0,p.localize)(11,null,this.resourceForError(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==s.ETAG_DISABLED&&l.etag===n.etag)throw new s.NotModifiedSinceFileOperationError((0,p.localize)(12,null),n,l);return this.validateReadFileLimits(t,n.size,l),n}validateReadFileLimits(t,l,n){if(typeof n?.limits?.size=="number"&&l>n.limits.size)throw new s.TooLargeFileOperationError((0,p.localize)(13,null,this.resourceForError(t)),7,l,n)}async canMove(t,l,n){return this.doCanMoveCopy(t,l,"move",n)}async canCopy(t,l,n){return this.doCanMoveCopy(t,l,"copy",n)}async doCanMoveCopy(t,l,n,i){if(t.toString()!==l.toString())try{const o=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),d=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(o,t,d,l,n,i)}catch(o){return o}return!0}async move(t,l,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),d=await this.doMoveCopy(i,t,o,l,"move",!!n),g=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,d==="move"?2:3,g)),g}async copy(t,l,n){const i=await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),d=await this.doMoveCopy(i,t,o,l,"copy",!!n),g=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,d==="copy"?3:2,g)),g}async doMoveCopy(t,l,n,i,o,d){if(l.toString()===i.toString())return o;const{exists:g,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(t,l,n,i,o,d);if(g&&!D&&d&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),o==="copy"){if(t===n&&(0,s.hasFileFolderCopyCapability)(t))await t.copy(l,i,{overwrite:d});else{const M=await this.resolve(l);M.isDirectory?await this.doCopyFolder(t,M,n,i):await this.doCopyFile(t,l,n,i)}return o}else return t===n?(await t.rename(l,i,{overwrite:d}),o):(await this.doMoveCopy(t,l,n,i,"copy",d),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(t,l,n,i){if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(t,l,n,i);if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(t,l,n,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(t,l,n,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasReadWriteCapability)(n))return this.doPipeUnbuffered(t,l,n,i)}async doCopyFolder(t,l,n,i){await n.mkdir(i),Array.isArray(l.children)&&await L.Promises.settled(l.children.map(async o=>{const d=this.getExtUri(n).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(t,await this.resolve(o.resource),n,d):this.doCopyFile(t,o.resource,n,d)}))}async doValidateMoveCopy(t,l,n,i,o,d){let g=!1;if(t===n){const{providerExtUri:M,isPathCaseSensitive:b}=this.getExtUri(t);if(b||(g=M.isEqual(l,i)),g&&o==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(l),this.resourceForError(i)));if(!g&&M.isEqualOrParent(i,l))throw new Error((0,p.localize)(15,null,this.resourceForError(l),this.resourceForError(i)))}const D=await this.exists(i);if(D&&!g){if(!d)throw new s.FileOperationError((0,p.localize)(16,null,this.resourceForError(l),this.resourceForError(i)),4);if(t===n){const{providerExtUri:M}=this.getExtUri(t);if(M.isEqualOrParent(l,i))throw new Error((0,p.localize)(17,null,this.resourceForError(l),this.resourceForError(i)))}}return{exists:D,isSameResourceWithDifferentPathCase:g}}getExtUri(t){const l=this.isPathCaseSensitive(t);return{providerExtUri:l?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(l,t);const n=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,0,n)),n}async mkdirp(t,l){const n=[],{providerExtUri:i}=this.getExtUri(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&s.FileType.Directory))throw new Error((0,p.localize)(18,null,this.resourceForError(l)));break}catch(o){if((0,s.toFileSystemProviderErrorCode)(o)!==s.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(i.basename(l)),l=i.dirname(l)}for(let o=n.length-1;o>=0;o--){l=i.joinPath(l,n[o]);try{await t.mkdir(l)}catch(d){if((0,s.toFileSystemProviderErrorCode)(d)!==s.FileSystemProviderErrorCode.FileExists)throw d}}}async canDelete(t,l){try{await this.doValidateDelete(t,l)}catch(n){return n}return!0}async doValidateDelete(t,l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),i=!!l?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(t)));const o=l?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,p.localize)(20,null,this.resourceForError(t)));if(i&&o)throw new Error((0,p.localize)(21,null,this.resourceForError(t)));let d;try{d=await n.stat(t)}catch{}if(d)this.throwIfFileIsReadonly(t,d);else throw new s.FileOperationError((0,p.localize)(22,null,this.resourceForError(t)),1);if(!!!l?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,p.localize)(23,null,this.resourceForError(t)))}return n}async del(t,l){const n=await this.doValidateDelete(t,l),i=!!l?.useTrash,o=!!l?.recursive,d=l?.atomic??!1;await n.delete(t,{recursive:o,useTrash:i,atomic:d}),this._onDidRunOperation.fire(new s.FileOperationEvent(t,1))}async cloneFile(t,l){const n=await this.withProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(t,l))return;if(n===i&&(0,s.hasFileCloneCapability)(n))return n.cloneFile(t,l);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(l));const o=this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri);return n===i&&(0,s.hasFileFolderCopyCapability)(n)?o.queue(()=>n.copy(t,l,{overwrite:!0})):o.queue(()=>this.doCopyFile(n,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let i=!1,o=()=>{i=!0};return n.add((0,c.toDisposable)(()=>o())),(async()=>{try{const d=await this.doWatch(t,l);i?(0,c.dispose)(d):o=()=>(0,c.dispose)(d)}catch(d){this.logService.error(d)}})(),n}async doWatch(t,l){const n=await this.withProvider(t),i=(0,I.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(t),l]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:n.watch(t,l)},this.activeWatchers.set(i,o)),o.count+=1,(0,c.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,c.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,c.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,l,n,i,o){await this.doWriteBuffered(t,n,i,o);try{await t.rename(n,l,{overwrite:!0})}catch(d){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw d}}async doWriteBuffered(t,l,n,i){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{const o=await t.open(l,{create:!0,unlock:n?.unlock??!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(t,o,i):await this.doWriteReadableBufferedQueued(t,o,i)}catch(d){throw(0,s.ensureFileSystemProviderError)(d)}finally{await t.close(o)}})}async doWriteStreamBufferedQueued(t,l,n){let i=0,o;if((0,y.isReadableBufferedStream)(n)){if(n.buffer.length>0){const d=r.VSBuffer.concat(n.buffer);await this.doWriteBuffer(t,l,d,d.byteLength,i,0),i+=d.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((d,g)=>{(0,y.listenStream)(o,{onData:async D=>{o.pause();try{await this.doWriteBuffer(t,l,D,D.byteLength,i,0)}catch(M){return g(M)}i+=D.byteLength,setTimeout(()=>o.resume())},onError:D=>g(D),onEnd:()=>d()})})}async doWriteReadableBufferedQueued(t,l,n){let i=0,o;for(;(o=n.read())!==null;)await this.doWriteBuffer(t,l,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(t,l,n,i,o,d){let g=0;for(;g<i;){const D=await t.write(l,o+g,n.buffer,d+g,i-g);g+=D}}async doWriteUnbuffered(t,l,n,i){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,l,n,i))}async doWriteUnbufferedQueued(t,l,n,i){let o;i instanceof r.VSBuffer?o=i:(0,y.isReadableStream)(i)?o=await(0,r.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?o=await(0,r.bufferedStreamToBuffer)(i):o=(0,r.readableToBuffer)(i),await t.writeFile(l,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(t,l,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,l,n,i))}async doPipeBufferedQueued(t,l,n,i){let o,d;try{o=await t.open(l,{create:!1}),d=await n.open(i,{create:!0,unlock:!1});const g=r.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,M=0,b=0;do b=await t.read(o,D,g.buffer,M,g.byteLength-M),await this.doWriteBuffer(n,d,g,b,D,M),D+=b,M+=b,M===g.byteLength&&(M=0);while(b>0)}catch(g){throw(0,s.ensureFileSystemProviderError)(g)}finally{await L.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof d=="number"?n.close(d):Promise.resolve()])}}async doPipeUnbuffered(t,l,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,l,n,i))}async doPipeUnbufferedQueued(t,l,n,i){return n.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,l,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,l,n,i))}async doPipeUnbufferedToBufferedQueued(t,l,n,i){const o=await n.open(i,{create:!0,unlock:!1});try{const d=await t.readFile(l);await this.doWriteBuffer(n,o,r.VSBuffer.wrap(d),d.byteLength,0,0)}catch(d){throw(0,s.ensureFileSystemProviderError)(d)}finally{await n.close(o)}}async doPipeBufferedToUnbuffered(t,l,n,i){const o=await(0,r.streamToBuffer)(this.readFileBuffered(t,l,_.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,o)}throwIfFileSystemIsReadonly(t,l){if(t.capabilities&2048)throw new s.FileOperationError((0,p.localize)(24,null,this.resourceForError(l)),6);return t}throwIfFileIsReadonly(t,l){if((l.permissions??0)&s.FilePermission.Readonly)throw new s.FileOperationError((0,p.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=P=Se([J(0,a.ILogService)],P)}),define(te[92],ie([0,1,42,307,7,35,17,4,32,2,9,3,18,61,22,177,16,117,219,50,214,213]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(E)}catch(l){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(l)}`)}})();class t extends a.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new _.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,m.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:o}=await y.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:s.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await y.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async d=>{try{let g;d.isSymbolicLink()?g=(await this.stat((0,S.joinPath)(n,d.name))).type:g=this.toType(d),o.push([d.name,g])}catch(g){this.logService.trace(g)}})),o}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let o;return i?.dangling?o=s.FileType.Unknown:n.isFile()?o=s.FileType.File:n.isDirectory()?o=s.FileType.Directory:o=s.FileType.Unknown,i&&(o|=s.FileType.SymbolicLink),o}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const d=new r.Barrier;return this.resourceLocks.set(n,d),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===d&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),d.open()})}async readFile(n,i){let o;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),o=await this.createResourceLock(n));const d=this.toFilePath(n);return await y.Promises.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}finally{o?.dispose()}}traceLock(n){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,o){const d=(0,u.newWriteableStream)(g=>R.VSBuffer.concat(g.map(D=>R.VSBuffer.wrap(D))).buffer);return(0,w.readFileIntoStream)(this,n,d,g=>g.buffer,{...i,bufferSize:256*1024},o),d}async writeFile(n,i,o){return o?.atomic!==!1&&o?.atomic?.postfix?this.doWriteFileAtomic(n,(0,S.joinPath)((0,S.dirname)(n),`${(0,S.basename)(n)}${o.atomic.postfix}`),i,o):this.doWriteFile(n,i,o)}async doWriteFileAtomic(n,i,o,d){await this.doWriteFile(i,o,d);try{await this.rename(i,n,{overwrite:!0})}catch(g){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw g}}async doWriteFile(n,i,o){let d;try{const g=this.toFilePath(n);if(!o.create||!o.overwrite){if(await y.Promises.exists(g)){if(!o.overwrite)throw(0,s.createFileSystemProviderError)((0,p.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,s.createFileSystemProviderError)((0,p.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(d,0,i,0,i.byteLength)}catch(g){throw await this.toFileSystemProviderWriteError(n,g)}finally{typeof d=="number"&&await this.close(d)}}static configureFlushOnWrite(n){t.canFlush=n}async open(n,i){const o=this.toFilePath(n);let d;(0,s.isFileOpenForWriteOptions)(i)&&(d=await this.createResourceLock(n));let g;try{if((0,s.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:M}=await y.SymlinkSupport.stat(o);M.mode&128||await y.Promises.chmod(o,M.mode|128)}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}let D;if((0,s.isFileOpenForWriteOptions)(i)){if(m.isWindows)try{await y.Promises.truncate(o,0),D="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}D||(D="w")}else D="r";g=await y.Promises.open(o,D)}catch(D){throw d?.dispose(),(0,s.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(g,0),(0,s.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(g,n),d){const D=this.mapHandleToLock.get(g);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${g} (${o})`),this.mapHandleToLock.set(g,d),D&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${g} (${o})`),D.dispose())}return g}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&t.canFlush)try{await y.Promises.fdatasync(n)}catch(o){t.configureFlushOnWrite(!1),this.logService.error(o)}return await y.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,o,d,g){const D=this.normalizePos(n,i);let M=null;try{M=(await y.Promises.read(n,o,d,g,D)).bytesRead}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(n,D,M)}return M}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,o){const d=this.mapHandleToPos.get(n);typeof d=="number"&&(typeof i=="number"||(typeof o=="number"?this.mapHandleToPos.set(n,d+o):this.mapHandleToPos.delete(n)))}async write(n,i,o,d,g){return(0,r.retry)(()=>this.doWrite(n,i,o,d,g),100,3)}async doWrite(n,i,o,d,g){const D=this.normalizePos(n,i);let M=null;try{M=(await y.Promises.write(n,o,d,g,D)).bytesWritten}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),b)}finally{this.updatePos(n,D,M)}return M}async mkdir(n){try{await y.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const o=this.toFilePath(n);if(i.recursive){let d;i?.atomic!==!1&&i.atomic.postfix&&(d=(0,v.join)((0,v.dirname)(o),`${(0,v.basename)(o)}${i.atomic.postfix}`)),await y.Promises.rm(o,y.RimRafMode.MOVE,d)}else try{await y.Promises.unlink(o)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:M}=await y.SymlinkSupport.stat(o);g=D.isDirectory()&&!M}catch{}if(g)await y.Promises.rmdir(o);else throw d}else throw d}}catch(o){throw this.toFileSystemProviderError(o)}}async rename(n,i,o){const d=this.toFilePath(n),g=this.toFilePath(i);if(d!==g)try{await this.validateMoveCopy(n,i,"move",o.overwrite),await y.Promises.move(d,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(2,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(g)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(n,i,o){const d=this.toFilePath(n),g=this.toFilePath(i);if(d!==g)try{await this.validateMoveCopy(n,i,"copy",o.overwrite),await y.Promises.copy(d,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(3,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(g)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(n,i,o,d){const g=this.toFilePath(n),D=this.toFilePath(i);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(g,D,!0)),M){if(o==="copy")throw(0,s.createFileSystemProviderError)((0,p.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const A=await this.statIgnoreError(n);if(!A)throw(0,s.createFileSystemProviderError)((0,p.localize)(5,null),s.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(i);if(O){if(!d)throw(0,s.createFileSystemProviderError)((0,p.localize)(6,null),s.FileSystemProviderErrorCode.FileExists);A.type&s.FileType.File&&O.type&s.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,o){const d=this.toFilePath(n),g=this.toFilePath(i),D=!!(this.capabilities&1024);if((0,h.isEqual)(d,g,!D))return;const M=new c.DisposableStore;try{const[b,A]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);M.add(b),M.add(A),o&&await y.Promises.mkdir((0,v.dirname)(g),{recursive:!0}),await y.Promises.copyFile(d,g)}catch(b){if(b.code==="ENOENT"&&!o)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(b)}finally{M.dispose()}}createUniversalWatcher(n,i,o){return new P.UniversalWatcherClient(d=>n(d),d=>i(d),o)}createNonRecursiveWatcher(n,i,o){return new C.NodeJSWatcherClient(d=>n(d),d=>i(d),o)}toFileSystemProviderError(n){if(n instanceof s.FileSystemProviderError)return n;let i=n,o;switch(n.code){case"ENOENT":o=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=s.FileSystemProviderErrorCode.Unknown;break;default:o=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(n,i){let o=this.toFileSystemProviderError(i);if(n&&o.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await y.SymlinkSupport.stat(this.toFilePath(n));d.mode&128||(o=(0,s.createFileSystemProviderError)(i,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return o}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(te[221],ie([0,1,4,92,2,17,61,21]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends r.Disposable{constructor(m,S){super(),this.provider=m,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(m,S,u){const y=this.getUriTransformer(m);switch(S){case"stat":return this.stat(y,u[0]);case"readdir":return this.readdir(y,u[0]);case"open":return this.open(y,u[0],u[1]);case"close":return this.close(u[0]);case"read":return this.read(u[0],u[1],u[2]);case"readFile":return this.readFile(y,u[0],u[1]);case"write":return this.write(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.writeFile(y,u[0],u[1],u[2]);case"rename":return this.rename(y,u[0],u[1],u[2]);case"copy":return this.copy(y,u[0],u[1],u[2]);case"cloneFile":return this.cloneFile(y,u[0],u[1]);case"mkdir":return this.mkdir(y,u[0]);case"delete":return this.delete(y,u[0],u[1]);case"watch":return this.watch(y,u[0],u[1],u[2],u[3]);case"unwatch":return this.unwatch(u[0],u[1])}throw new Error(`IPC Command ${S} not found`)}listen(m,S,u){const y=this.getUriTransformer(m);switch(S){case"fileChange":return this.onFileChange(y,u[0]);case"readFileStream":return this.onReadFileStream(y,u[0],u[1])}throw new Error(`Unknown event ${S}`)}stat(m,S){const u=this.transformIncoming(m,S,!0);return this.provider.stat(u)}readdir(m,S){const u=this.transformIncoming(m,S);return this.provider.readdir(u)}async readFile(m,S,u){const y=this.transformIncoming(m,S,!0),p=await this.provider.readFile(y,u);return _.VSBuffer.wrap(p)}onReadFileStream(m,S,u){const y=this.transformIncoming(m,S,!0),p=new I.CancellationTokenSource,s=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),w=this.provider.readFileStream(y,u,p.token);return(0,R.listenStream)(w,{onData:a=>s.fire(_.VSBuffer.wrap(a)),onError:a=>s.fire(a),onEnd:()=>{s.fire("end"),s.dispose(),p.dispose()}}),s.event}writeFile(m,S,u,y){const p=this.transformIncoming(m,S);return this.provider.writeFile(p,u.buffer,y)}open(m,S,u){const y=this.transformIncoming(m,S,!0);return this.provider.open(y,u)}close(m){return this.provider.close(m)}async read(m,S,u){const y=_.VSBuffer.alloc(u),p=0,s=await this.provider.read(m,S,y.buffer,p,u);return[y,s]}write(m,S,u,y,p){return this.provider.write(m,S,u.buffer,y,p)}mkdir(m,S){const u=this.transformIncoming(m,S);return this.provider.mkdir(u)}delete(m,S,u){const y=this.transformIncoming(m,S);return this.provider.delete(y,u)}rename(m,S,u,y){const p=this.transformIncoming(m,S),s=this.transformIncoming(m,u);return this.provider.rename(p,s,y)}copy(m,S,u,y){const p=this.transformIncoming(m,S),s=this.transformIncoming(m,u);return this.provider.copy(p,s,y)}cloneFile(m,S,u){const y=this.transformIncoming(m,S),p=this.transformIncoming(m,u);return this.provider.cloneFile(y,p)}onFileChange(m,S){const u=new E.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(m,u))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return u.event}async watch(m,S,u,y,p){const s=this.sessionToWatcher.get(S);if(s){const w=this.transformIncoming(m,y),a=s.watch(u,w,p);this.watchRequests.set(S+u,a)}}async unwatch(m,S){const u=m+S,y=this.watchRequests.get(u);y&&((0,r.dispose)(y),this.watchRequests.delete(u))}dispose(){super.dispose();for(const[,m]of this.watchRequests)m.dispose();this.watchRequests.clear();for(const[,m]of this.sessionToWatcher)m.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class c extends r.Disposable{constructor(m,S,u,y){super(),this.uriTransformer=m,this.logService=u,this.environmentService=y,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(m){const S=this._register(new E.Emitter);this._register(S.event(u=>{m.fire(u.map(y=>({resource:this.uriTransformer.transformOutgoingURI(y.resource),type:y.type})))})),this._register(this.fileWatcher.onDidChangeFile(u=>S.fire(u))),this._register(this.fileWatcher.onDidWatchError(u=>m.fire(u)))}getRecursiveWatcherOptions(m){}getExtraExcludes(m){}watch(m,S,u){const y=this.getExtraExcludes(this.environmentService);return Array.isArray(y)&&(u.excludes=[...u.excludes,...y]),this.watcherRequests.set(m,this.fileWatcher.watch(S,u)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(m)),this.watcherRequests.delete(m)})}dispose(){super.dispose();for(const[,m]of this.watcherRequests)m.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=c}),define(te[222],ie([0,1,15,176,3,8,16,9,221,153]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class v extends h.AbstractDiskFileSystemProviderChannel{constructor(u,y,p){super(u,y),this.environmentService=p}getUriTransformer(u){return c.DefaultURITransformer}transformIncoming(u,y){return _.URI.revive(y)}async delete(u,y,p){if(!p.useTrash)return super.delete(u,y,p);const s=this.transformIncoming(u,y),w=(0,I.normalize)(s.fsPath);try{await E.shell.trashItem(w)}catch{throw(0,R.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,I.basename)(w)):(0,L.localize)(1,null,(0,I.basename)(w)),R.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(u,y){return new m(u,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=v;class m extends h.AbstractSessionFileWatcher{watch(u,y,p){if(p.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(u,y,p)}}}),define(te[223],ie([0,1,5]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends E.AbstractMessageLogger{constructor(_=E.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(_),this._register(this.onDidChangeLogLevel(R=>{this._logger?.setLevel(R)}))}set logger(_){this._logger=_;for(const{level:R,message:I}of this.buffer)(0,E.log)(_,R,I);this.buffer=[]}log(_,R){this._logger?(0,E.log)(this._logger,_,R):this.getLevel()<=_&&this.buffer.push({level:_,message:R})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(te[224],ie([0,1,8,4,5,2]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class R extends r.AbstractLoggerService{constructor(m,S,u,y,p){super(S,u,y),this.windowId=m,this.channel=p,this._register(p.listen("onDidChangeLogLevel",m)(s=>{(0,r.isLogLevel)(s)?super.setLogLevel(s):super.setLogLevel(E.URI.revive(s[0]),s[1])})),this._register(p.listen("onDidChangeVisibility",m)(([s,w])=>super.setVisibility(E.URI.revive(s),w))),this._register(p.listen("onDidChangeLoggers",m)(({added:s,removed:w})=>{for(const a of s)super.registerLogger({...a,resource:E.URI.revive(a.resource)});for(const a of w)super.deregisterLogger(a.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(m,S)=>{this.channel.call("consoleLog",[m,S])}})}registerLogger(m){super.registerLogger(m),this.channel.call("registerLogger",[m,this.windowId])}deregisterLogger(m){super.deregisterLogger(m),this.channel.call("deregisterLogger",[m,this.windowId])}setLogLevel(m,S){super.setLogLevel(m,S),this.channel.call("setLogLevel",[m,S])}setVisibility(m,S){super.setVisibility(m,S),this.channel.call("setVisibility",[this.toResource(m),S])}doCreateLogger(m,S,u){return new I(this.channel,m,S,u,this.windowId)}static setLogLevel(m,S,u){return m.call("setLogLevel",[S,u])}}e.LoggerChannelClient=R;class I extends r.AbstractMessageLogger{constructor(m,S,u,y,p){super(y?.logLevel==="always"),this.channel=m,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[S,y,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,S){const u=[[m,S]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(m){this.channel.call("log",[this.file,m])}}class h{constructor(m,S){this.loggerService=m,this.getUriTransformer=S}listen(m,S){const u=this.getUriTransformer(m);switch(S){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,y=>({added:[...y.added].map(p=>this.transformLogger(p,u)),removed:[...y.removed].map(p=>this.transformLogger(p,u))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,y=>[u.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,y=>(0,r.isLogLevel)(y)?y:[u.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${S}`)}async call(m,S,u){const y=this.getUriTransformer(m);switch(S){case"setLogLevel":return(0,r.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(E.URI.revive(y.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(p=>this.transformLogger(p,y)))}throw new Error(`Call not found: ${S}`)}transformLogger(m,S){return{...m,resource:S.transformOutgoingURI(m.resource)}}}e.LoggerChannel=h;class c extends _.Disposable{constructor(m,S){super(),S.call("setLogLevel",[m.getLogLevel()]),this._register(m.onDidChangeLogLevel(u=>S.call("setLogLevel",[u]))),S.call("getRegisteredLoggers").then(u=>{for(const y of u)m.registerLogger({...y,resource:E.URI.revive(y.resource)})}),this._register(S.listen("onDidChangeVisibility")(([u,y])=>m.setVisibility(E.URI.revive(u),y))),this._register(S.listen("onDidChangeLoggers")(({added:u,removed:y})=>{for(const p of u)m.registerLogger({...p,resource:E.URI.revive(p.resource)});for(const p of y)m.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=c}),define(te[225],ie([0,1,2,5]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends E.Disposable{constructor(R,I=[]){super(),this.logger=new L.MultiplexLogger([R,...I]),this._register(R.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...I){this.logger.trace(R,...I)}debug(R,...I){this.logger.debug(R,...I)}info(R,...I){this.logger.info(R,...I)}warn(R,...I){this.logger.warn(R,...I)}error(R,...I){this.logger.error(R,...I)}flush(){this.logger.flush()}}e.LogService=r}),define(te[226],ie([0,1,35,8,5]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class _{constructor(I){this.loggerService=I,this.loggers=new E.ResourceMap}listen(I,h,c){switch(h){case"onDidChangeLoggers":return c?this.loggerService.getOnDidChangeLoggersEvent(c):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.loggerService.getOnDidChangeLogLevelEvent(c):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.loggerService.getOnDidChangeVisibilityEvent(c):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(I,h,c){switch(h){case"createLogger":this.createLogger(L.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.log(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1]);case"setLogLevel":return(0,r.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(L.URI.revive(c[0]),c[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(c[0]),c[1]);case"registerLogger":return this.loggerService.registerLogger({...c[0],resource:L.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}createLogger(I,h,c){this.loggers.set(I,this.loggerService.createLogger(I,h,c))}consoleLog(I,h){let c=console.log;switch(I){case r.LogLevel.Error:c=console.error;break;case r.LogLevel.Warning:c=console.warn;break;case r.LogLevel.Info:c=console.info;break}c.call(console,...h)}log(I,h){const c=this.loggers.get(I);if(!c)throw new Error("Create the logger before logging");for(const[v,m]of h)(0,r.log)(c,v,m)}}e.LoggerChannel=_}),define(te[227],ie([0,1,16,5]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(r||(r={}));async function _(c,v,m,S,u){try{const y=await new Promise((s,w)=>{j(["@vscode/spdlog"],s,w)});y.setFlushOn(r.Trace);const p=await y.createAsyncRotatingLogger(c,v,m,S);return u?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(y){console.error(y)}return null}function R(c,v,m){switch(v){case L.LogLevel.Trace:c.trace(m);break;case L.LogLevel.Debug:c.debug(m);break;case L.LogLevel.Info:c.info(m);break;case L.LogLevel.Warning:c.warn(m);break;case L.LogLevel.Error:c.error(m);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function I(c,v){switch(v){case L.LogLevel.Trace:c.setLevel(r.Trace);break;case L.LogLevel.Debug:c.setLevel(r.Debug);break;case L.LogLevel.Info:c.setLevel(r.Info);break;case L.LogLevel.Warning:c.setLevel(r.Warning);break;case L.LogLevel.Error:c.setLevel(r.Error);break;case L.LogLevel.Off:c.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class h extends L.AbstractMessageLogger{constructor(v,m,S,u,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(v,m,S,u),this._register(this.onDidChangeLogLevel(p=>{this._logger&&I(this._logger,p)}))}async _createSpdLogLogger(v,m,S,u){const y=S?6:1,p=30/y*E.ByteSize.MB,s=await _(v,m,p,y,u);if(s){this._logger=s,I(this._logger,this.getLevel());for(const{level:w,message:a}of this.buffer)R(this._logger,w,a);this.buffer=[]}}log(v,m){this._logger?R(this._logger,v,m):this.getLevel()<=v&&this.buffer.push({level:v,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(te[228],ie([0,1,31,5,227]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class _ extends L.AbstractLoggerService{doCreateLogger(I,h,c){return new r.SpdLogLogger((0,E.generateUuid)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.LoggerService=_}),define(te[66],ie([0,1,35,4,6,5,228]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(_.ILoggerService);class I extends R.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new E.ResourceMap}createLogger(c,v,m){m!==void 0&&this.loggerResourcesByWindow.set(this.toResource(c),m);try{return super.createLogger(c,v)}catch(S){throw this.loggerResourcesByWindow.delete(this.toResource(c)),S}}registerLogger(c,v){v!==void 0&&this.loggerResourcesByWindow.set(c.resource,v),super.registerLogger(c)}deregisterLogger(c){this.loggerResourcesByWindow.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const v=[];for(const m of super.getRegisteredLoggers())c===this.loggerResourcesByWindow.get(m.resource)&&v.push(m);return v}getOnDidChangeLogLevelEvent(c){return L.Event.filter(this.onDidChangeLogLevel,v=>(0,_.isLogLevel)(v)||this.isInterestedLoggerResource(v[0],c))}getOnDidChangeVisibilityEvent(c){return L.Event.filter(this.onDidChangeVisibility,([v])=>this.isInterestedLoggerResource(v,c))}getOnDidChangeLoggersEvent(c){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,v=>({added:[...v.added].filter(S=>this.isInterestedLoggerResource(S.resource,c)),removed:[...v.removed].filter(S=>this.isInterestedLoggerResource(S.resource,c))})),v=>v.added.length>0||v.removed.length>0)}deregisterLoggers(c){for(const[v,m]of this.loggerResourcesByWindow)m===c&&this.deregisterLogger(v)}isInterestedLoggerResource(c,v){const m=this.loggerResourcesByWindow.get(c);return m===void 0||m===v}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=I}),define(te[229],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function L(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function _(R){return!E(R)&&!L(R)&&!r(R)}e.isMenubarMenuItemAction=_}),define(te[39],ie([0,1,4,68,2,6]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,_.createDecorator)("policy");class R extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const v=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},v!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),L.Iterable.reduce(this.policies.entries(),(m,[S,u])=>({...m,[S]:u}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[v,m])=>({...c,[v]:{definition:m,value:this.policies.get(v)}}),{})}}e.AbstractPolicyService=R;class I{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(te[230],ie([0,1,7,4,68,11,16,5,39]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(m,S){const u=[];for(const y of new Set(r.Iterable.concat(m.keys(),S.keys())))m.get(y)!==S.get(y)&&u.push(y);return u}let v=e.FilePolicyService=class extends h.AbstractPolicyService{constructor(S,u,y){super(),this.file=S,this.fileService=u,this.logService=y,this.throttledDelayer=this._register(new E.ThrottledDelayer(500));const p=L.Event.filter(u.onDidFilesChange,s=>s.affects(S));this._register(u.watch(S)),this._register(p(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const S=new Map;try{const u=await this.fileService.readFile(this.file),y=JSON.parse(u.value.toString());if(!(0,_.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(y))this.policyDefinitions[p]&&S.set(p,y[p])}catch(u){u.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",u)}return S}async refresh(){const S=await this.read(),u=c(this.policies,S);this.policies=S,u.length>0&&this._onDidChange.fire(u)}};e.FilePolicyService=v=Se([J(1,R.IFileService),J(2,I.ILogService)],v)}),define(te[231],ie([0,1,4,2,39]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class _{constructor(h){this.service=h,this.disposables=new L.DisposableStore}listen(h,c){switch(c){case"onDidChange":return E.Event.map(this.service.onDidChange,v=>v.reduce((m,S)=>({...m,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${c}`)}call(h,c,v){switch(c){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(v)}throw new Error(`Call not found: ${c}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=_;class R extends r.AbstractPolicyService{constructor(h,c){super(),this.channel=c;for(const v in h){const{definition:m,value:S}=h[v];this.policyDefinitions[v]=m,S!==void 0&&this.policies.set(v,S)}this.channel.listen("onDidChange")(v=>{for(const m in v){const S=v[m];S===null?this.policies.delete(m):this.policies.set(m,S)}this._onDidChange.fire(Object.keys(v))})}async _updatePolicyDefinitions(h){const c=await this.channel.call("updatePolicyDefinitions",h);for(const v in c)this.policies.set(v,c[v])}}e.PolicyChannelClient=R}),define(te[232],ie([0,1,39,7,308,2,5]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=e.NativePolicyService=class extends E.AbstractPolicyService{constructor(c,v){super(),this.logService=c,this.productName=v,this.throttler=new L.Throttler,this.watcher=this._register(new _.MutableDisposable)}async _updatePolicyDefinitions(c){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.throttler.queue(()=>new Promise((v,m)=>{try{this.watcher.value=(0,r.createWatcher)(this.productName,c,S=>{this._onDidPolicyChange(S),v()})}catch(S){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),m(S)}}))}_onDidPolicyChange(c){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const v in c){const m=c[v];m===void 0?this.policies.delete(v):this.policies.set(v,m)}this._onDidChange.fire(Object.keys(c))}};e.NativePolicyService=I=Se([J(0,R.ILogService)],I)}),define(te[77],ie([0,1,3,36]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const _=E.globals.vscode.context.configuration();if(_)r=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){r=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:_,searchUrl:R,itemUrl:I,controlUrl:h}=r.extensionsGallery||{};Object.assign(r,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||_,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||I,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const c=(...m)=>m.reduce((S,u)=>(Object.keys(u).forEach(y=>{Array.isArray(S[y])&&Array.isArray(u[y])?S[y]=u[y]:typeof S[y]=="object"&&typeof u[y]=="object"?S[y]=c(S[y],u[y]):S[y]=u[y]}),S),{}),v=globalThis._VSCODE_USER_PRODUCT_JSON||{};r=c(r,v)}catch{}if(L.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const c=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:c.version,release:c.release})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(te[23],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,70,5,23]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let _=e.ExtensionUrlTrustService=class{constructor(I,h){this.productService=I,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const c=/^(.*)#([^#]+)$/.exec(h);if(!c)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,v,m]=c;let S=this.trustedExtensionUrlPublicKeys.get(I);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[I],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...S])}const u=Buffer.from(decodeURIComponent(m),"base64");if(u.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const y=u.slice(0,6),p=u.readUIntBE(0,6),s=Date.now()-p;if(s<0||s>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const w=u.slice(6),a=E.createVerify("SHA256");a.write(y),a.write(Buffer.from(v)),a.end();for(let f=0;f<S.length;f++){let P=S[f];if(P!==null){if(typeof P=="string")try{P=E.createPublicKey({key:Buffer.from(P,"base64"),format:"der",type:"spki"}),S[f]=P}catch(C){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${I}:`,C),S[f]=null;continue}if(a.verify(P,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.ExtensionUrlTrustService=_=Se([J(0,r.IProductService),J(1,L.ILogService)],_)}),define(te[234],ie([0,1,7,5]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=e.WindowProfiler=class{constructor(R,I,h){this._window=R,this._sessionId=I,this._logService=h}async inspect(R){await this._connect();const I=this._window.webContents.debugger;await I.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,E.timeout)(R);const h=await I.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),h.profile}async _connect(){const R=this._window.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async _disconnect(){const R=this._window.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.WindowProfiler=r=Se([J(2,L.ILogService)],r)}),define(te[78],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(te[47],ie([0,1,134,11]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(R,I){E.ok(L.isString(R)),E.ok(L.isObject(I)),E.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,I)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new r}),define(te[235],ie([0,1,4,47]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class _{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,c){this.schemasById[r(h)]=c,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new _;L.Registry.add(e.Extensions.JSONContribution,R)}),define(te[57],ie([0,1,24,4,11,161,19,235,47]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v||(e.ConfigurationScope=v={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const m=h.Registry.as(I.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const n=new Set;this.doRegisterConfigurations(t,l,n),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const l=new Set;this.doDeregisterConfigurations(t,l),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:t,remove:l}){const n=new Set;this.doDeregisterConfigurations(l,n),this.doRegisterConfigurations(t,!1,n),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(t){const l=new Set;this.doRegisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,l){const n=[];for(const{overrides:i,source:o}of t)for(const d in i)if(l.add(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const g=this.configurationDefaultsOverrides.get(d),D=g?.valuesSources??new Map;if(o)for(const O of Object.keys(i[d]))D.set(O,o);const M={...g?.value||{},...i[d]};this.configurationDefaultsOverrides.set(d,{source:o,value:M,valuesSources:D});const b=(0,R.getLanguageTagSettingPlainKey)(d),A={type:"object",default:M,description:_.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:r.isString(o)?void 0:o,defaultValueSource:o};n.push(...p(d)),this.configurationProperties[d]=A,this.defaultLanguageConfigurationOverridesNode.properties[d]=A}else{this.configurationDefaultsOverrides.set(d,{value:i[d],source:o});const g=this.configurationProperties[d];g&&(this.updatePropertyDefaultValue(d,g),this.updateSchema(d,g))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(t){const l=new Set;this.doDeregisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,l){for(const{overrides:n,source:i}of t)for(const o in n){const d=this.configurationDefaultsOverrides.get(o),g=r.isString(i)?i:i?.id,D=r.isString(d?.source)?d?.source:d?.source?.id;if(g===D)if(l.add(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const M=this.configurationProperties[o];M&&(this.updatePropertyDefaultValue(o,M),this.updateSchema(o,M))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let l=!1;const n=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,n),l=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,n),l=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,n),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const l of t)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,l,n){t.forEach(i=>{this.validateAndRegisterProperties(i,l,i.extensionInfo,i.restrictedProperties,void 0,n),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,l){const n=i=>{if(i.properties)for(const o in i.properties){l.add(o);const d=this.configurationProperties[o];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>n(o))};for(const i of t){n(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}}validateAndRegisterProperties(t,l=!0,n,i,o=3,d){o=r.isUndefinedOrNull(t.scope)?o:t.scope;const g=t.properties;if(g)for(const M in g){const b=g[M];if(l&&f(M,b)){delete g[M];continue}if(b.source=n,b.defaultDefaultValue=g[M].default,this.updatePropertyDefaultValue(M,b),e.OVERRIDE_PROPERTY_REGEX.test(M)?b.scope=void 0:(b.scope=r.isUndefinedOrNull(b.scope)?o:b.scope,b.restricted=r.isUndefinedOrNull(b.restricted)?!!i?.includes(M):b.restricted),g[M].hasOwnProperty("included")&&!g[M].included){this.excludedConfigurationProperties[M]=g[M],delete g[M];continue}else this.configurationProperties[M]=g[M],g[M].policy?.name&&this.policyConfigurations.set(g[M].policy.name,M);!g[M].deprecationMessage&&g[M].markdownDeprecationMessage&&(g[M].deprecationMessage=g[M].markdownDeprecationMessage),d.add(M)}const D=t.allOf;if(D)for(const M of D)this.validateAndRegisterProperties(M,l,n,i,o,d)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const l=n=>{const i=n.properties;if(i)for(const d in i)this.updateSchema(d,i[d]);n.allOf?.forEach(l)};l(t)}updateSchema(t,l){switch(e.allSettings.properties[t]=l,l.scope){case 1:e.applicationSettings.properties[t]=l;break;case 2:e.machineSettings.properties[t]=l;break;case 6:e.machineOverridableSettings.properties[t]=l;break;case 3:e.windowSettings.properties[t]=l;break;case 4:e.resourceSettings.properties[t]=l;break;case 5:e.resourceSettings.properties[t]=l,this.resourceLanguageSettingsSchema.properties[t]=l;break}}removeFromSchema(t,l){switch(delete e.allSettings.properties[t],l.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const l=`[${t}]`,n={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,n),e.allSettings.properties[l]=n,e.applicationSettings.properties[l]=n,e.machineSettings.properties[l]=n,e.machineOverridableSettings.properties[l]=n,e.windowSettings.properties[l]=n,e.resourceSettings.properties[l]=n}}registerOverridePropertyPatternKey(){const t={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,l){const n=this.configurationDefaultsOverrides.get(t);let i=n?.value,o=n?.source;r.isUndefined(i)&&(i=l.defaultDefaultValue,o=void 0),r.isUndefined(i)&&(i=w(l.type)),l.default=i,l.defaultValueSource=o}}const u="\\[([^\\]]+)\\]",y=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(C){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let l=y.exec(C);for(;l?.length;){const n=l[1].trim();n&&t.push(n),l=y.exec(C)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=p;function s(C){return C.reduce((t,l)=>`${t}[${l}]`,"")}e.keyFromOverrideIdentifiers=s;function w(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const a=new S;h.Registry.add(e.Extensions.Configuration,a);function f(C,t){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?_.localize(7,null,C):a.getConfigurationProperties()[C]!==void 0?_.localize(8,null,C):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?_.localize(9,null,C,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:_.localize(6,null)}e.validateProperty=f;function P(){const C=[],t=a.getConfigurationProperties();for(const l of Object.keys(t))C.push([l,t[l].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=P}),define(te[118],ie([0,1,24,4,44,2,35,37,11,8,19,57,47]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(l){return Object.isFrozen(l)?l:I.deepFreeze(l)}class y{constructor(n={},i=[],o=[],d){this._contents=n,this._keys=i,this._overrides=o,this.raw=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof y)return i;const o=new p("");return o.parseRaw(i),o.configurationModel});this._rawConfiguration=n.reduce((i,o)=>o===i?o:i.merge(o),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,v.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const o=this.rawConfiguration.getValue(n),d=i?this.rawConfiguration.getOverrideValue(n,i):void 0,g=i?this.rawConfiguration.override(i).getValue(n):o;return{value:o,override:d,merged:g}}getOverrideValue(n,i){const o=this.getContentsForOverrideIdentifer(i);return o?n?(0,v.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const o of this.overrides)o.identifiers.includes(n)&&i.push(...o.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return E.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),o=I.deepClone(this.overrides),d=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of n)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(i,D.contents);for(const M of D.overrides){const[b]=o.filter(A=>E.equals(A.identifiers,M.identifiers));b?(this.mergeContents(b.contents,M.contents),b.keys.push(...M.keys),b.keys=E.distinct(b.keys)):o.push(I.deepClone(M))}for(const M of D.keys)d.indexOf(M)===-1&&d.push(M)}return new y(i,d,o,g.every(D=>D instanceof y)?void 0:g)}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const d of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let g=this.contents[d];const D=i[d];D&&(typeof g=="object"&&typeof D=="object"?(g=I.deepClone(g),this.mergeContents(g,D)):g=D),o[d]=g}return new y(o,this.keys,this.overrides)}mergeContents(n,i){for(const o of Object.keys(i)){if(o in n&&h.isObject(n[o])&&h.isObject(i[o])){this.mergeContents(n[o],i[o]);continue}n[o]=I.deepClone(i[o])}}getContentsForOverrideIdentifer(n){let i=null,o=null;const d=g=>{g&&(o?this.mergeContents(o,g):o=I.deepClone(g))};for(const g of this.overrides)E.equals(g.identifiers,[n])?i=g.contents:g.identifiers.includes(n)&&d(g.contents);return d(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.updateValue(n,i,!0)}setValue(n,i){this.updateValue(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,v.removeFromValueTree)(this.contents,n),m.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,m.overrideIdentifiersFromKey)(n))),1))}updateValue(n,i,o){(0,v.addToValueTree)(this.contents,n,i,d=>console.error(d)),o=o||this.keys.indexOf(n)===-1,o&&this.keys.push(n),m.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,m.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,v.toValuesTree)(this.contents[n],d=>console.error(d))})}}e.ConfigurationModel=y;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!h.isUndefinedOrNull(n)){const o=this.doParseContent(n);this.parseRaw(o,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:o,keys:d,overrides:g,restricted:D,hasExcludedProperties:M}=this.doParseRaw(n,i);this._configurationModel=new y(o,d,g,M?[n]:void 0),this._restrictedConfigurations=D||[]}doParseContent(n){let i={},o=null,d=[];const g=[],D=[];function M(A){Array.isArray(d)?d.push(A):o!==null&&(d[o]=A)}const b={onObjectBegin:()=>{const A={};M(A),g.push(d),d=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{d=g.pop()},onArrayBegin:()=>{const A=[];M(A),g.push(d),d=A,o=null},onArrayEnd:()=>{d=g.pop()},onLiteralValue:M,onError:(A,O,F)=>{D.push({error:A,offset:O,length:F})}};if(n)try{r.visit(n,b),i=d[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(n,i){const o=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),d=this.filter(n,o,!0,i);n=d.raw;const g=(0,v.toValuesTree)(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),D=Object.keys(n),M=this.toOverrides(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:g,keys:D,overrides:M,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}filter(n,i,o,d){let g=!1;if(!d?.scopes&&!d?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:g};const D={},M=[];for(const b in n)if(m.OVERRIDE_PROPERTY_REGEX.test(b)&&o){const A=this.filter(n[b],i,!1,d);D[b]=A.raw,g=g||A.hasExcludedProperties,M.push(...A.restricted)}else{const A=i[b],O=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&M.push(b),(O===void 0||d.scopes===void 0||d.scopes.includes(O))&&!(d.skipRestricted&&A?.restricted)?D[b]=n[b]:g=!0}return{raw:D,restricted:M,hasExcludedProperties:g}}toOverrides(n,i){const o=[];for(const d of Object.keys(n))if(m.OVERRIDE_PROPERTY_REGEX.test(d)){const g={};for(const D in n[d])g[D]=n[d][D];o.push({identifiers:(0,m.overrideIdentifiersFromKey)(d),keys:Object.keys(g),contents:(0,v.toValuesTree)(g,i)})}return o}}e.ConfigurationModelParser=p;class s extends _.Disposable{constructor(n,i,o,d){super(),this.userSettingsResource=n,this.scopes=i,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&o.isEqual(g.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=s;class w{constructor(n,i,o,d,g,D,M,b,A,O,F,q,re){this.key=n,this.overrides=i,this._value=o,this.overrideIdentifiers=d,this.defaultConfiguration=g,this.policyConfiguration=D,this.applicationConfiguration=M,this.userConfiguration=b,this.localUserConfiguration=A,this.remoteUserConfiguration=O,this.workspaceConfiguration=F,this.folderConfigurationModel=q,this.memoryConfigurationModel=re}get value(){return u(this._value)}inspect(n,i,o){const d=n.inspect(i,o);return{get value(){return u(d.value)},get override(){return u(d.override)},get merged(){return u(d.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(n,i,o,d,g=new y,D=new y,M=new R.ResourceMap,b=new y,A=new R.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=d,this._remoteUserConfiguration=g,this._workspaceConfiguration=D,this._folderConfigurations=M,this._memoryConfiguration=b,this._memoryConfigurationByResource=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(n,i,o){return this.getConsolidatedConfigurationModel(n,i,o).getValue(n)}updateValue(n,i,o={}){let d;o.resource?(d=this._memoryConfigurationByResource.get(o.resource),d||(d=new y,this._memoryConfigurationByResource.set(o.resource,d))):d=this._memoryConfiguration,i===void 0?d.removeValue(n):d.setValue(n,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,o){const d=this.getConsolidatedConfigurationModel(n,i,o),g=this.getFolderConfigurationModelForResource(i.resource,o),D=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,M=new Set;for(const b of d.overrides)for(const A of b.identifiers)d.getOverrideValue(n,A)!==void 0&&M.add(A);return new w(n,i,d.getValue(n),M.size?[...M]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,g||void 0,D)}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const o=[];if(!i){const{added:d,updated:g,removed:D}=C(this._defaultConfiguration,n);i=[...d,...g,...D]}for(const d of i)for(const g of(0,m.overrideIdentifiersFromKey)(d)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(g),M=n.getKeysForOverrideIdentifier(g),b=[...M.filter(A=>D.indexOf(A)===-1),...D.filter(A=>M.indexOf(A)===-1),...D.filter(A=>!I.equals(this._defaultConfiguration.override(g).getValue(A),n.override(g).getValue(A)))];o.push([g,b])}return this.updateDefaultConfiguration(n),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:o,removed:d}=C(this._policyConfiguration,n),g=[...i,...o,...d];return g.length&&this.updatePolicyConfiguration(n),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:o,removed:d,overrides:g}=C(this.applicationConfiguration,n),D=[...i,...o,...d];return D.length&&this.updateApplicationConfiguration(n),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:o,removed:d,overrides:g}=C(this.localUserConfiguration,n),D=[...i,...o,...d];return D.length&&this.updateLocalUserConfiguration(n),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:o,removed:d,overrides:g}=C(this.remoteUserConfiguration,n),D=[...i,...o,...d];return D.length&&this.updateRemoteUserConfiguration(n),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:o,removed:d,overrides:g}=C(this.workspaceConfiguration,n),D=[...i,...o,...d];return D.length&&this.updateWorkspaceConfiguration(n),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(n,i){const o=this.folderConfigurations.get(n),{added:d,updated:g,removed:D,overrides:M}=C(o,i),b=[...d,...g,...D];return(b.length||!o)&&this.updateFolderConfiguration(n,i),{keys:b,overrides:M}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:d,removed:g,overrides:D}=C(i,void 0);return{keys:[...o,...d,...g],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,o){let d=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(d=d.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(d=d.merge(this._policyConfiguration)),d}getConsolidatedConfigurationModelForResource({resource:n},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const d=i.getFolder(n);d&&(o=this.getFolderConsolidatedConfiguration(d.uri)||o);const g=this._memoryConfigurationByResource.get(n);g&&(o=o.merge(g))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(n);d?(i=o.merge(d),this._foldersConsolidatedConfigurations.set(n,i)):i=o}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const o=i.getFolder(n);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:o,overrides:d,keys:g}=this._folderConfigurations.get(i);return n.push([i,{contents:o,overrides:d,keys:g}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this._workspaceConfiguration.keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(o=>n.add(o))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(d=>i.add(d))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),o=this.parseConfigurationModel(n.policy),d=this.parseConfigurationModel(n.application),g=this.parseConfigurationModel(n.user),D=this.parseConfigurationModel(n.workspace),M=n.folders.reduce((b,A)=>(b.set(c.URI.revive(A[0]),this.parseConfigurationModel(A[1])),b),new R.ResourceMap);return new a(i,o,d,g,new y,D,M,new y,new R.ResourceMap)}static parseConfigurationModel(n){return new y(n.contents,n.keys,n.overrides)}}e.Configuration=a;function f(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,i=new Map;for(const d of l)d.keys.forEach(g=>n.add(g)),d.overrides.forEach(([g,D])=>{const M=(0,R.getOrSet)(i,g,new Set);D.forEach(b=>M.add(b))});const o=[];return i.forEach((d,g)=>o.push([g,[...d.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=f;class P{constructor(n,i,o,d){this.change=n,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const g of n.keys)this.affectedKeys.add(g);for(const[,g]of n.overrides)for(const D of g)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const g of this.affectedKeys)this._affectsConfigStr+=g+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){const o=this._marker+n,d=this._affectsConfigStr.indexOf(o);if(d<0)return!1;const g=d+o.length;if(g>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(g);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(i){const M=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!I.equals(M,b)}return!0}}e.ConfigurationChangeEvent=P;function C(l,n){const{added:i,removed:o,updated:d}=t(n?.rawConfiguration,l?.rawConfiguration),g=[],D=l?.getAllOverrideIdentifiers()||[],M=n?.getAllOverrideIdentifiers()||[];if(n){const b=M.filter(A=>!D.includes(A));for(const A of b)g.push([A,n.getKeysForOverrideIdentifier(A)])}if(l){const b=D.filter(A=>!M.includes(A));for(const A of b)g.push([A,l.getKeysForOverrideIdentifier(A)])}if(n&&l){for(const b of D)if(M.includes(b)){const A=t({contents:l.getOverrideValue(void 0,b)||{},keys:l.getKeysForOverrideIdentifier(b)},{contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)});g.push([b,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:o,updated:d,overrides:g}}function t(l,n){const i=l?n?l.keys.filter(g=>n.keys.indexOf(g)===-1):[...l.keys]:[],o=n?l?n.keys.filter(g=>l.keys.indexOf(g)===-1):[...n.keys]:[],d=[];if(l&&n){for(const g of n.keys)if(l.keys.indexOf(g)!==-1){const D=(0,v.getConfigurationValue)(n.contents,g),M=(0,v.getConfigurationValue)(l.contents,g);I.equals(D,M)||d.push(g)}}return{added:i,removed:o,updated:d}}}),define(te[236],ie([0,1,24,4,2,37,11,118,57,5,39,47]),function(j,e,E,L,r,_,R,I,h,c,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(m.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:s,defaultsOverrides:w})=>this.onDidUpdateConfiguration(Array.from(s),w))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(s,w){this.updateConfigurationModel(s,m.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:s})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const s=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(s),s)}updateConfigurationModel(s,w){const a=this.getConfigurationDefaultOverrides();for(const f of s){const P=a[f],C=w[f];P!==void 0?this._configurationModel.addValue(f,P):C?this._configurationModel.addValue(f,C.default):this._configurationModel.removeValue(f)}}}e.DefaultConfiguration=S;class u{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let y=e.PolicyConfiguration=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(s,w,a){super(),this.defaultConfiguration=s,this.policyService=w,this.logService=a,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(s=>this.onDidChangePolicies(s))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:s})=>this.update(await this.updatePolicyDefinitions(s),!0))),this._configurationModel}async updatePolicyDefinitions(s){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",s);const w={},a=[],f=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const P of s){const C=f[P];if(!C){a.push(P);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.logService.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}a.push(P),w[C.policy.name]={type:C.type}}}return(0,R.isEmptyObject)(w)||await this.policyService.updatePolicyDefinitions(w),a}onDidChangePolicies(s){this.logService.trace("PolicyConfiguration#onDidChangePolicies",s);const w=m.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),a=(0,E.coalesce)(s.map(f=>w.get(f)));this.update(a,!0)}update(s,w){this.logService.trace("PolicyConfiguration#update",s);const a=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),f=[],P=this._configurationModel.isEmpty();for(const C of s){const t=a[C]?.policy?.name;if(t){const l=this.policyService.getPolicyValue(t);(P?l!==void 0:!(0,_.equals)(this._configurationModel.getValue(C),l))&&f.push([C,l])}else this._configurationModel.getValue(C)!==void 0&&f.push([C,void 0])}if(f.length){this.logService.trace("PolicyConfiguration#changed",f);const C=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const t of C.keys)this._configurationModel.setValue(t,C.getValue(t));for(const[t,l]of f)l===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,l);w&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=y=Se([J(1,v.IPolicyService),J(2,c.ILogService)],y)}),define(te[237],ie([0,1,7,4,2,18,19,118,236,39]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class v extends r.Disposable{constructor(S,u,y,p){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=y instanceof c.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,y,p)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,_.extUriBiasedIgnorePathCase,u)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:w})=>this.onDidDefaultConfigurationChange(s,w))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,u,y]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(S,u,new I.ConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(S,u){const y=typeof S=="string"?S:void 0,p=(0,R.isConfigurationOverrides)(S)?S:(0,R.isConfigurationOverrides)(u)?u:{};return this.configuration.getValue(y,p,void 0)}updateValue(S,u,y,p){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const u=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(y,u,2)}onDidDefaultConfigurationChange(S,u){const y=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(S,u);this.trigger(p,y,7)}onDidPolicyConfigurationChange(S){const u=this.configuration.toData(),y=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(y,u,7)}trigger(S,u,y){const p=new I.ConfigurationChangeEvent(S,{data:u},this.configuration);p.source=y,p.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=v}),define(te[238],ie([0,1,13,6]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(v){v[v.WebSocket=0]="WebSocket",v[v.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class _{constructor(m){this.id=m,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=_;class R{constructor(m,S){this.host=m,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var I;(function(v){v.Unknown="Unknown",v.NotAvailable="NotAvailable",v.TemporarilyNotAvailable="TemporarilyNotAvailable",v.NoResolverFound="NoResolverFound"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class h extends E.ErrorNoTelemetry{static isNotAvailable(m){return m instanceof h&&m._code===I.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof h&&m._code===I.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof h&&m._code===I.NoResolverFound}static isHandled(m){return m instanceof h&&m.isHandled}constructor(m,S=I.Unknown,u){super(m),this._message=m,this._code=S,this._detail=u,this.isHandled=S===I.NotAvailable&&u===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function c(v){const m=v.indexOf("+");return m===-1?v:v.substring(0,m)}e.getRemoteAuthorityPrefix=c}),define(te[58],ie([0,1,14]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(c){return c.scheme===E.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=L;function r(c){if(!c)return;const v=c.indexOf("+");return v<0?c:c.substr(0,v)}e.getRemoteName=r;function _(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=_;function R(c){const{host:v,port:m}=h(c);if(typeof m>"u")throw new Error("Remote authority doesn't contain a port!");return{host:v,port:m}}e.parseAuthorityWithPort=R;function I(c,v){let{host:m,port:S}=h(c);return typeof S>"u"&&(S=v),{host:m,port:S}}e.parseAuthorityWithOptionalPort=I;function h(c){const v=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const m=c.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const S=c.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:c,port:void 0}}}),define(te[119],ie([0,1,25,6,58]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R||(e.ExtensionType=R={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class h{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,w){if(typeof s>"u"||s===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof s=="string"||typeof w=="string"){const a=typeof s=="string"?s:s.value,f=typeof w=="string"?w:w.value;return E.equalsIgnoreCase(a,f)}return s._lower===w._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.ExtensionIdentifier=h;class c{get size(){return this._set.size}constructor(s){if(this._set=new Set,s)for(const w of s)this.add(w)}add(s){this._set.add(h.toKey(s))}delete(s){return this._set.delete(h.toKey(s))}has(s){return this._set.has(h.toKey(s))}}e.ExtensionIdentifierSet=c;class v{constructor(){this._map=new Map}clear(){this._map.clear()}delete(s){this._map.delete(h.toKey(s))}get(s){return this._map.get(h.toKey(s))}has(s){return this._map.has(h.toKey(s))}set(s,w){this._map.set(h.toKey(s),w)}values(){return this._map.values()}forEach(s){this._map.forEach(s)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=v;function m(p){return S(p)}e.isApplicationScopedExtension=m;function S(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function u(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=u;function y(p,s){if(s){const w=`onResolveRemoteAuthority:${(0,r.getRemoteName)(s)}`;return!!p.activationEvents?.includes(w)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[239],ie([0,1,7,17,21,13,4,2,65,85,31,108,238,58]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var p;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function s(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function w(k){const W=new r.CancellationTokenSource;return setTimeout(()=>W.cancel(),k),W.token}function a(k,W){if(k.isCancellationRequested||W.isCancellationRequested)return r.CancellationToken.Cancelled;const z=new r.CancellationTokenSource;return k.onCancellationRequested(()=>z.cancel()),W.onCancellationRequested(()=>z.cancel()),z.token}class f{get didTimeout(){return this._state==="timedout"}constructor(W){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((z,H)=>{this._resolvePromise=z,this._rejectPromise=H}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function P(k,W){const z=new f(W);return z.registerDisposable(k.onControlMessage(H=>{const B=JSON.parse(H.toString()),$=x(B);$?z.reject($):z.resolve(B)})),z.promise}function C(k,W,z,H,B,$,G,se){const ue=new f(se),ye=c.StopWatch.create(!1);return k.info(`Creating a socket (${G})...`),h.mark(`code/willCreateSocket/${$}`),W.connect(z,H,B,G).then(Ce=>{ue.didTimeout?(h.mark(`code/didCreateSocketError/${$}`),k.info(`Creating a socket (${G}) finished after ${ye.elapsed()} ms, but this is too late and has timed out already.`),Ce?.dispose()):(h.mark(`code/didCreateSocketOK/${$}`),k.info(`Creating a socket (${G}) was successful after ${ye.elapsed()} ms.`),ue.resolve(Ce))},Ce=>{h.mark(`code/didCreateSocketError/${$}`),k.info(`Creating a socket (${G}) returned an error after ${ye.elapsed()} ms.`),k.error(Ce),ue.reject(Ce)}),ue.promise}function t(k,W){const z=new f(W);return k.then(H=>{z.didTimeout||z.resolve(H)},H=>{z.didTimeout||z.reject(H)}),z.promise}async function l(k,W,z,H){const B=oe(k,W);k.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let $;try{$=await C(k.logService,k.remoteSocketFactoryService,k.connectTo,(0,u.getRemoteServerRootPath)(k),`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,s(W),`renderer-${s(W)}-${k.reconnectionToken}`,H)}catch(Ce){throw k.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),k.logService.error(Ce),Ce}k.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let G,se;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection($,null),G=k.reconnectionProtocol,se=!1):(G=new m.PersistentProtocol({socket:$,measureRoundTripTime:!0}),se=!0),k.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const ue=await t(k.signService.createNewMessage((0,v.generateUuid)()),H),ye={type:"auth",auth:k.connectionToken||"00000000000000000000",data:ue.data};G.sendControl(L.VSBuffer.fromString(JSON.stringify(ye)));try{const Ce=await P(G,a(H,w(1e4)));if(Ce.type!=="sign"||typeof Ce.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(k.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(k.signService.validate(ue,Ce.signedData),H)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const Le=await t(k.signService.sign(Ce.data),H),Te={type:"connectionType",commit:k.commit,signedData:Le,desiredConnectionType:W};return z&&(Te.args=z),k.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(L.VSBuffer.fromString(JSON.stringify(Te))),{protocol:G,ownsProtocol:se}}catch(Ce){throw Ce&&Ce.code==="ETIMEDOUT"&&(k.logService.error(`${B} the handshake timed out. Error:`),k.logService.error(Ce)),Ce&&Ce.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${B} received error control message when negotiating connection. Error:`),k.logService.error(Ce)),se&&T(G),Ce}}async function n(k,W,z,H){const B=Date.now(),$=oe(k,W),{protocol:G,ownsProtocol:se}=await l(k,W,z,H),ue=new f(H);return ue.registerDisposable(G.onControlMessage(ye=>{const Ce=JSON.parse(ye.toString()),Re=x(Ce);Re?(k.logService.error(`${$} received error control message when negotiating connection. Error:`),k.logService.error(Re),se&&T(G),ue.reject(Re)):(k.reconnectionProtocol?.endAcceptReconnection(),k.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${N(B)}!`),ue.resolve({protocol:G,firstMessage:Ce}))})),ue.promise}async function i(k,W){const{protocol:z}=await n(k,1,void 0,W);return{protocol:z}}async function o(k,W,z){const{protocol:H,firstMessage:B}=await n(k,2,W,z),$=B&&B.debugPort;return{protocol:H,debugPort:$}}async function d(k,W,z){const H=Date.now(),B=oe(k,3),{protocol:$}=await l(k,3,W,z);return k.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${N(H)}!`),$}async function g(k,W,z){const{connectTo:H,connectionToken:B}=await k.addressProvider.getAddress();return{commit:k.commit,quality:k.quality,connectTo:H,connectionToken:B,reconnectionToken:W,reconnectionProtocol:z,remoteSocketFactoryService:k.remoteSocketFactoryService,signService:k.signService,logService:k.logService}}async function D(k,W,z){return b(k,async H=>{const{protocol:B}=await i(H,r.CancellationToken.None);return new V(k,W,z,H.reconnectionToken,B)})}e.connectRemoteAgentManagement=D;async function M(k,W){return b(k,async z=>{const{protocol:H,debugPort:B}=await o(z,W,r.CancellationToken.None);return new U(k,W,z.reconnectionToken,H,B)})}e.connectRemoteAgentExtensionHost=M;async function b(k,W){for(let H=1;;H++)try{const B=(0,v.generateUuid)(),$=await g(k,B,null);return await W($)}catch(B){if(H<5)k.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),k.logService.error(B);else throw k.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),k.logService.error(B),K.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(B)),B}}async function A(k,W,z){const H=await g(k,(0,v.generateUuid)(),null);return await d(H,{host:W,port:z},r.CancellationToken.None)}e.connectRemoteAgentTunnel=A;function O(k){return(0,E.createCancelablePromise)(W=>new Promise((z,H)=>{const B=setTimeout(z,k*1e3);W.onCancellationRequested(()=>{clearTimeout(B),z()})}))}var F;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain",k[k.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F||(e.PersistentConnectionEventType=F={}));class q{constructor(W,z){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=q;class re{constructor(W,z,H,B){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.durationSeconds=H,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=re;class Y{constructor(W,z,H){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=Y;class ne{constructor(W,z,H){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=H,this.type=4}}e.ConnectionGainEvent=ne;class ce{constructor(W,z){this.reconnectionToken=W,this.connectionHealth=z,this.type=5}}e.ConnectionHealthChangedEvent=ce;class le{constructor(W,z,H,B){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=H,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=le;class K extends I.Disposable{static triggerPermanentFailure(W,z,H){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=z,this._permanentFailureHandled=H,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||K._permanentFailure}constructor(W,z,H,B,$){super(),this._connectionType=W,this._options=z,this.reconnectionToken=H,this.protocol=B,this._reconnectionFailureIsFatal=$,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(B.onSocketClose(G=>{const se=ae(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${se} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(G=>{const se=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(B.onHighRoundTripTime(G=>{const se=Z(this._connectionType,this.reconnectionToken);this._options.logService.info(`${se} high roundtrip time: ${G.roundTripTime}ms (${G.recentHighRoundTripCount} of 5 recent samples)`)})),this._register(B.onDidChangeConnectionHealth(G=>{this._onDidStateChange.fire(new ce(this.reconnectionToken,G))})),K._instances.push(this),this._register((0,I.toDisposable)(()=>{const G=K._instances.indexOf(this);G>=0&&K._instances.splice(G,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const W=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const B=H<z.length?z[H]:z[z.length-1];try{if(B>0){const G=O(B);this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,G)),this._options.logService.info(`${W} waiting for ${B} seconds before reconnecting...`);try{await G}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this._options.logService.info(`${W} resolving connection...`);const $=await g(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${$.connectTo}...`),await this._reconnect($,w(y)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,_.isCancellationError)($)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,S.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(W,z,H){this._reconnectionFailureIsFatal?K.triggerPermanentFailure(W,z,H):this._gotoPermanentFailure(W,z,H)}_gotoPermanentFailure(W,z,H){this._onDidStateChange.fire(new le(this.reconnectionToken,W,z,H)),T(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=K,K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class V extends K{constructor(W,z,H,B,$){super(1,W,B,$,!0),this.client=this._register(new m.Client($,{remoteAuthority:z,clientId:H},W.ipcLogger))}async _reconnect(W,z){await i(W,z)}}e.ManagementPersistentConnection=V;class U extends K{constructor(W,z,H,B,$){super(2,W,H,B,!1),this._startArguments=z,this.debugPort=$}async _reconnect(W,z){await o(W,this._startArguments,z)}}e.ExtensionHostPersistentConnection=U;function T(k){try{k.acceptDisconnect();const W=k.getSocket();k.dispose(),W.dispose()}catch(W){(0,_.onUnexpectedError)(W)}}function x(k){if(k&&k.type==="error"){const W=new Error(`Connection error: ${k.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Q(k,W){for(;k.length<W;)k+=" ";return k}function Z(k,W){return`[remote-connection][${Q(s(k),13)}][${W.substr(0,5)}\u2026]`}function ae(k,W,z){return`${Z(k,W)}[${z?"reconnect":"initial"}]`}function oe(k,W){return`${ae(W,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.connectTo}]`}function N(k){return`${Date.now()-k} ms`}}),define(te[240],ie([0,1,2,6]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.factories={}}register(R,I){return this.factories[R]??=[],this.factories[R].push(I),(0,E.toDisposable)(()=>{const h=this.factories[R]?.indexOf(I);typeof h=="number"&&h>=0&&this.factories[R]?.splice(h,1)})}getSocketFactory(R){return(this.factories[R.type]||[]).find(h=>h.supports(R))}connect(R,I,h,c){const v=this.getSocketFactory(R);if(!v)throw new Error(`No socket factory found for ${R}`);return v.connect(R,I,h,c)}}e.RemoteSocketFactoryService=r}),define(te[241],ie([0,1,27,46,42,112]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function I(u=!1){return(R===void 0||u)&&(R=h()),R}e.hasWSLFeatureInstalled=I;async function h(){const u=c();if(u===void 0)return!1;if(u>=22e3){const y=m();if(y)return new Promise(p=>{L.execFile(y,["--status"],s=>p(!s))})}else{const y=S();if(y)try{if((await r.promises.stat(y)).isFile())return!0}catch{}}return!1}function c(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(u)return parseInt(u[3])}function v(u){const y=process.env.SystemRoot;if(y){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return _.join(y,p?"Sysnative":"System32",u)}}function m(){return v("wsl.exe")}function S(){return v("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,13,2,181,57,6,5,47]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class v{constructor(C){this.original=C}toJSON(){if(!this.headers){const C=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?C[t]="*****":C[t]=this.original[t];this.headers=C}return this.headers}}class m extends r.Disposable{constructor(C){super(),this.counter=0,this.logger=C.createLogger("network",{name:(0,_.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(C,t,l){const n=`${C} #${++this.counter}: ${t.url}`;this.logger.trace(`${n} - begin`,t.type,new v(t.headers??{}));try{const i=await l();return this.logger.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${n} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=m;function S(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=S;function u(P){return P.res.statusCode===204}async function y(P){return u(P)?null:(await(0,E.streamToBuffer)(P.stream)).toString()}e.asText=y;async function p(P){if(!S(P))throw new Error("Server returned "+P.res.statusCode);return y(P)}e.asTextOrError=p;async function s(P){if(!S(P))throw new Error("Server returned "+P.res.statusCode);if(u(P))return null;const t=(await(0,E.streamToBuffer)(P.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.asJson=s;function w(P){f(P)}e.updateProxyConfigurationsScope=w;let a;function f(P){const C=c.Registry.as(R.Extensions.Configuration),t=a;a={id:"http",order:15,title:(0,_.localize)(1,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(5,null),(0,_.localize)(6,null),(0,_.localize)(7,null),(0,_.localize)(8,null)],default:"override",description:(0,_.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(10,null),restricted:!0}}},C.updateConfigurations({add:[a],remove:t?[t]:[]})}f(1)}),define(te[242],ie([0,1,17,21]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(I){this.service=I}listen(I,h){throw new Error("Invalid listen")}call(I,h,c,v=L.CancellationToken.None){switch(h){case"request":return this.service.request(c[0],v).then(async({res:m,stream:S})=>{const u=await(0,E.streamToBuffer)(S);return[{statusCode:m.statusCode,headers:m.headers},u]});case"resolveProxy":return this.service.resolveProxy(c[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class _{constructor(I){this.channel=I}async request(I,h){const[c,v]=await this.channel.call("request",[I],h);return{res:c,stream:(0,E.bufferToStream)(v)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=_}),define(te[243],ie([0,1,244,11]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(R,I){return R.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:R.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function _(R,I,h={}){const c=(0,E.parse)(R),v=h.proxyUrl||r(c,I);if(!v)return null;const m=(0,E.parse)(v);if(!/^https?:$/.test(m.protocol||""))return null;const S={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((u,y)=>{j(["http-proxy-agent"],u,y)}))(S):new(await new Promise((u,y)=>{j(["https-proxy-agent"],u,y)}))(S)}e.getProxyAgent=_}),define(te[93],ie([0,1,46,9,182,21,50,13,3,31,155,63,7,137]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function p(w,a,f,P){return f["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(P)&&!f["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(P)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=S.Promises.withAsyncBody(async(C,t)=>{const l=new _.CancellationTokenSource;let n=1e4;const i=w.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,u.clamp)(i,1,120)*1e3);const o=setTimeout(()=>{l.dispose(!0),t(new Error((0,r.localize)(0,null)))},n);try{C(await s(a,l.token))}catch(d){!(0,I.isCancellationError)(d)&&!l.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,R.toErrorMessage)(d)))):C({})}finally{clearTimeout(o),l.dispose()}})),y)}e.getResolvedShellEnv=p;async function s(w,a){const f=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",f);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",P);const C=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(C+"({.*})"+C),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};w.trace("getUnixShellEnvironment#env",l);const n=await(0,v.getSystemShell)(h.OS,l);return w.trace("getUnixShellEnvironment#shell",n),new Promise((i,o)=>{if(a.isCancellationRequested)return o(new I.CancellationError);const d=(0,L.basename)(n);let g,D;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(d)?(g=`& '${process.execPath}' ${M} -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,D=["-Login","-Command"]):d==="nu"?(g=`^'${process.execPath}' ${M} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,D=["-i","-l","-c"]):(g=`'${process.execPath}' ${M} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,d==="tcsh"||d==="csh"?D=["-ic"]:D=["-i","-l","-c"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),g);const b=(0,E.spawn)(n,[...D,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});a.onCancellationRequested(()=>(b.kill(),o(new I.CancellationError))),b.on("error",F=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(F)),o(F)});const A=[];b.stdout.on("data",F=>A.push(F));const O=[];b.stderr.on("data",F=>O.push(F)),b.on("close",(F,q)=>{const re=Buffer.concat(A).toString("utf8");w.trace("getUnixShellEnvironment#raw",re);const Y=Buffer.concat(O).toString("utf8");if(Y.trim()&&w.trace("getUnixShellEnvironment#stderr",Y),F||q)return o(new Error((0,r.localize)(2,null,F,q)));const ne=t.exec(re),ce=ne?ne[1]:"{}";try{const le=JSON.parse(ce);f?le.ELECTRON_RUN_AS_NODE=f:delete le.ELECTRON_RUN_AS_NODE,P?le.ELECTRON_NO_ATTACH_CONSOLE=P:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){w.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(le)),o(le)}})})}}),define(te[245],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class E{constructor(){this.validators=new Map}async createNewMessage(r){try{const _=await this.getValidator();if(_){const R=String(E._nextId++);return this.validators.set(R,_),{id:R,data:_.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,_){if(!r.id)return!0;const R=this.validators.get(r.id);if(!R)return!1;this.validators.delete(r.id);try{return R.validate(_)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(r){try{return await this.signValue(r)}catch{}return r}}e.AbstractSignService=E,E._nextId=1}),define(te[94],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[246],ie([0,1,245]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends E.AbstractSignService{getValidator(){return this.vsda().then(_=>new _.validator)}signValue(_){return this.vsda().then(R=>new R.signer().sign(_))}vsda(){return new Promise((_,R)=>j(["vsda"],_,R))}}e.SignService=L}),define(te[34],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(te[120],ie([0,1,7,17,11,33,16,5]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(S){S[S.IMMEDIATE=0]="IMMEDIATE",S[S.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class c{constructor(u,y,p,s){this.storagePath=u,this.logService=p,this.fileService=s,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=y===0?void 0:new E.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(u){u.fileOperationResult!==1&&this.logService.error(u)}}getItem(u,y){const p=this.storage[u];return(0,r.isUndefinedOrNull)(p)?y:p}setItem(u,y){this.setItems([{key:u,data:y}])}setItems(u){let y=!1;for(const{key:p,data:s}of u)this.storage[p]!==s&&((0,r.isUndefinedOrNull)(s)?(0,r.isUndefined)(this.storage[p])||(this.storage[p]=void 0,y=!0):(this.storage[p]=s,y=!0));y&&this.save()}removeItem(u){(0,r.isUndefined)(this.storage[u])||(this.storage[u]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const u=JSON.stringify(this.storage,null,4);if(u!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(u),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=u}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=c;let v=e.StateReadonlyService=class{constructor(u,y,p,s){this.fileStorage=new c(y.stateResource,u,p,s)}async init(){await this.fileStorage.init()}getItem(u,y){return this.fileStorage.getItem(u,y)}};e.StateReadonlyService=v=Se([J(1,_.IEnvironmentService),J(2,I.ILogService),J(3,R.IFileService)],v);class m extends v{setItem(u,y){this.fileStorage.setItem(u,y)}setItems(u){this.fileStorage.setItems(u)}removeItem(u){this.fileStorage.removeItem(u)}close(){return this.fileStorage.close()}}e.StateService=m}),define(te[121],ie([0,1,3,36,31]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(h){if(E.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function R(h,c,v,m,S,u,y,p){const s=Object.create(null);s["common.machineId"]=u,s.sessionID=(0,r.generateUuid)()+Date.now(),s.commitHash=m,s.version=S,s["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,E.PlatformToString)(E.platform),s["common.nodePlatform"]=L.platform,s["common.nodeArch"]=v,s["common.product"]=p||"desktop",y&&(s["common.msftInternal"]=y);let w=0;const a=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),E.isLinuxSnap&&(s["common.snap"]="true");const f=_(c);return f&&(s["common.platformDetail"]=f),s}e.resolveCommonProperties=R;function I(h){const c=L.env.USERDNSDOMAIN;if(!c)return!1;const v=c.toLowerCase();return h.some(m=>v===m)}e.verifyMicrosoftInternalDomain=I}),define(te[26],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(te[247],ie([0,1,27,7,44,14,9,3,8,86,22,107,89,16,23,26]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const s=new Map;async function w(t,l){const n=`${t}::${l.join(":")}`,i=s.get(n);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],d=new Map,g=new Map,D=2e4;function M(A,O,F,q){const re=O.substring(A.length+1);return L.Promises.withAsyncBody(async Y=>{let ne;try{ne=await v.Promises.readdir(O,{withFileTypes:!0})}catch{Y();return}if(q.count>=D){q.count+=ne.length,q.maxReached=!0,Y();return}let ce=ne.length;if(ce===0){Y();return}let le=ne;q.count+ne.length>D&&(q.maxReached=!0,ce=D-q.count,le=ne.slice(0,ce)),q.count+=ne.length;for(const K of le)if(K.isDirectory()){if(F.includes(K.name)||await M(A,(0,R.join)(O,K.name),F,q),--ce===0){Y();return}}else{const V=K.name.lastIndexOf(".");if(V>=0){const U=K.name.substring(V+1);U&&d.set(U,(d.get(U)??0)+1)}for(const U of o)U.relativePathPattern?.test(re)!==!1&&U.filePattern.test(K.name)&&g.set(U.tag,(g.get(U.tag)??0)+1);if(--ce===0){Y();return}}})}const b=L.Promises.withAsyncBody(async A=>{const O={count:0,maxReached:!1};await M(t,t,l,O);const F=await P(t);A({configFiles:a(g),fileTypes:a(d),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return s.set(n,b),b}e.collectWorkspaceStats=w;function a(t){return Array.from(t.entries(),([l,n])=>({name:l,count:n})).sort((l,n)=>n.count-l.count)}function f(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.virtualMachineHint.value()*100)}%`},l=E.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.getMachineInfo=f;async function P(t){try{const l=new Map,n=(0,R.join)(t,".vscode","launch.json"),i=await v.Promises.readFile(n),o=[],d=(0,r.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,r.getNodeType)(d)==="object"&&d.configurations)for(const g of d.configurations){const D=g.type;D&&(l.has(D)?l.set(D,l.get(D)+1):l.set(D,1))}return a(l)}catch{return[]}}e.collectLaunchConfigs=P;let C=e.DiagnosticsService=class{constructor(l,n){this.telemetryService=l,this.productService=n}formatMachineInfo(l){const n=[];return n.push(`OS Version:       ${l.os}`),n.push(`CPUs:             ${l.cpus}`),n.push(`Memory (System):  ${l.memory}`),n.push(`VM:               ${l.vmHint}`),n.join(`
`)}formatEnvironment(l){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||n.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(c.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${l.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(l,n){return Promise.all([(0,m.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[o,d]=i,g=this.formatProcessList(l,o);return n.forEach(D=>{if((0,S.isRemoteDiagnosticError)(D))g+=`
${D.errorMessage}`,d+=`
${D.errorMessage}`;else if(g+=`

Remote: ${D.hostName}`,D.processes&&(g+=`
${this.formatProcessList(l,D.processes)}`),D.workspaceMetadata){d+=`
|  Remote: ${D.hostName}`;for(const M of Object.keys(D.workspaceMetadata)){const b=D.workspaceMetadata[M];let A=`${b.fileCount} files`;b.maxFilesReached&&(A=`more than ${A}`),d+=`|    Folder (${M}): ${A}`,d+=this.formatWorkspaceStats(b)}}}),{processInfo:g,workspaceInfo:d}})}async getSystemInfo(l,n){const{memory:i,vmHint:o,os:d,cpus:g}=f(),D={os:d,memory:i,cpus:g,vmHint:o,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:n};return I.isWindows||(D.load=`${E.loadavg().map(M=>Math.round(M)).join(", ")}`),I.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(l,n){const i=[];return(0,m.listProcesses)(l.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,o)),l.windows.some(d=>d.folderURIs&&d.folderURIs.length>0&&!d.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),n.forEach(d=>{if((0,S.isRemoteDiagnosticError)(d))i.push(`
${d.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${d.hostName}`),i.push(this.formatMachineInfo(d.machineInfo)),d.processes&&i.push(this.formatProcessList(l,d.processes)),d.workspaceMetadata)for(const g of Object.keys(d.workspaceMetadata)){const D=d.workspaceMetadata[g];let M=`${D.fileCount} files`;D.maxFilesReached&&(M=`more than ${M}`),i.push(`Folder (${g}): ${M}`),i.push(this.formatWorkspaceStats(D))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const n=[];let o=0;const d=(b,A)=>{const O=` ${b}(${A})`;o+O.length>60?(n.push(g),g="|                 ",o=g.length):o+=O.length,g+=O};let g="|      File types:";const D=10,M=l.fileTypes.length>D?D:l.fileTypes.length;for(let b=0;b<M;b++){const A=l.fileTypes[b];d(A.name,A.count)}if(n.push(g),l.configFiles.length>=0&&(g="|      Conf files:",o=0,l.configFiles.forEach(b=>{d(b.name,b.count)}),n.push(g)),l.launchConfigFiles.length>0){let b="|      Launch Configs:";l.launchConfigFiles.forEach(A=>{const O=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;b+=O}),n.push(b)}return n.join(`
`)}expandGPUFeatures(l){const n=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const n=[],i=[];return l.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(d=>{const g=h.URI.revive(d);if(g.scheme===_.Schemas.file){const D=g.fsPath;i.push(w(D,["node_modules",".git"]).then(M=>{let b=`${M.fileCount} files`;M.maxFilesReached&&(b=`more than ${b}`),n.push(`|    Folder (${(0,R.basename)(D)}): ${b}`),n.push(this.formatWorkspaceStats(M))}).catch(M=>{n.push(`|      Error: Unable to collect workspace stats for folder ${D} (${M.toString()})`)}))}else n.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(l,n){const i=new Map;l.windows.forEach(d=>i.set(d.pid,`window [${d.id}] (${d.title})`)),l.pidToNames.forEach(({pid:d,name:g})=>i.set(d,g));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(l.mainPID,i,o,n,0),o.join(`
`)}formatProcessItem(l,n,i,o,d){const g=d===0;let D;g?D=o.pid===l?`${this.productService.applicationName} main`:"remote agent":n.has(o.pid)?D=n.get(o.pid):D=`${"  ".repeat(d)} ${o.name}`;const M=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(M/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(o.children)&&o.children.forEach(b=>this.formatProcessItem(l,n,i,b,d+1))}async getWorkspaceFileExtensions(l){const n=new Set;for(const{uri:i}of l.folders){const o=h.URI.revive(i);if(o.scheme!==_.Schemas.file)continue;const d=o.fsPath;try{(await w(d,["node_modules",".git"])).fileTypes.forEach(D=>n.add(D.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(l){for(const{uri:n}of l.folders){const i=h.URI.revive(n);if(i.scheme!==_.Schemas.file)continue;const o=i.fsPath;try{const d=await w(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),d.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:g.name,count:g.count})}),d.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:g.name,count:g.count})}),d.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};e.DiagnosticsService=C=Se([J(0,p.ITelemetryService),J(1,y.IProductService)],C)}),define(te[248],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(_){this.appenders=_}listen(_,R){throw new Error(`Event not found: ${R}`)}call(_,R,{eventName:I,data:h}){return this.appenders.forEach(c=>c.log(I,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class L{constructor(_){this.channel=_}log(_,R){return this.channel.call("log",{eventName:_,data:R}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[52],ie([0,1,37,11,4,19,58,121,26]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=c;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class m{async publicLog(o,d,g){}async publicLogError(o,d,g){}}e.NullEndpointTelemetryService=m,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(i,o){return r.Event.debounce(o.onDidChangeConfiguration,(g,D)=>{const M=g?new Set([...g.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:M}},1e3,!0)(g=>{g.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,_.ConfigurationTargetToString)(g.source),configurationKeys:Array.from(g.affectedKeys)})})}e.configurationTelemetry=S;function u(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=u;function y(i,o){return!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=y;function p(i){const o=i.getValue(h.TELEMETRY_SETTING_ID),d=i.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function s(i){const o={},d={},g={};f(i,g);for(let D in g){D=D.length>150?D.substr(D.length-149):D;const M=g[D];typeof M=="number"?d[D]=M:typeof M=="boolean"?d[D]=M?1:0:typeof M=="string"?(M.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${M.length}`),o[D]=M.substring(0,8191)):typeof M<"u"&&M!==null&&(o[D]=M)}return{properties:o,measurements:d}}e.validateTelemetryData=s;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const o=(0,R.getRemoteName)(i);return w.has(o)?o:"other"}e.cleanRemoteAuthority=a;function f(i,o,d=0,g){if(i)for(const D of Object.getOwnPropertyNames(i)){const M=i[D],b=g?g+D:D;Array.isArray(M)?o[b]=(0,E.safeStringify)(M):M instanceof Date?o[b]=M.toISOString():(0,L.isObject)(M)?d<2?f(M,o,d+1,b+"."):o[b]=(0,E.safeStringify)(M):o[b]=M}}function P(i,o){const d=i.msftInternalDomains||[],g=o.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(d)||g}e.isInternalTelemetry=P;function C(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=C;function t(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let d=i;const g=[];for(const A of o)for(;;){const O=A.exec(i);if(!O)break;g.push([O.index,A.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,M=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(d="";;){const A=M.exec(i);if(!A)break;const O=g.some(([F,q])=>A.index<q&&F<M.lastIndex);!D.test(A[0])&&!O&&(d+=i.substring(b,A.index)+"<REDACTED: user-file-path>",b=M.lastIndex)}return b<i.length&&(d+=i.substr(b)),d}function l(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of o)if(d.regex.test(i))return`<REDACTED: ${d.label}>`;return i}function n(i,o){return(0,E.cloneAndChange)(i,d=>{if(d instanceof c||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let g=d.replaceAll("%20"," ");g=t(g,o);for(const D of o)g=g.replace(D,"");return g=l(g),g}})}e.cleanData=n}),define(te[122],ie([0,1,25,115,119,3,8,13,36,52]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function v(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,E.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=v;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(i){const o=i.manifest?i.manifest.version:i.version,d=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new S(i.identifier,o,d)}static parse(i){const o=m.exec(i);return o&&o[1]&&o[2]?new S({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,d="undefined"){this.version=o,this.targetPlatform=d,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof S?v(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=S;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(n){const i=u.exec(n);return i&&i[1]?[s(i[1]),i[2]]:[s(n),void 0]}e.getIdAndVersion=y;function p(n,i){return`${n}.${i}`}e.getExtensionId=p;function s(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=s;function w(n,i){return s(p(n??r.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=w;function a(n,i){const o=[],d=g=>{for(const D of o)if(D.some(M=>v(i(M),i(g))))return D;return null};for(const g of n){const D=d(g);D?D.push(g):o.push([g])}return o}e.groupByExtension=a;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function P(n){return{id:new c.TelemetryTrustedValue(n.identifier.id),name:new c.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function C(n,i){const o=[],d=i.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const g=d.shift();if(g&&o.every(D=>!v(D.identifier,{id:g}))){const D=n.filter(M=>v(M.identifier,{id:g}));D.length===1&&(o.push(D[0]),d.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=C;async function t(n,i){if(!_.isLinux)return!1;let o;try{o=(await n.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){i.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(g))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(n,i){const o=await t(n,i),d=(0,L.getTargetPlatform)(o?"alpine":_.platform,h.arch);return i.debug("ComputeTargetPlatform:",d),d}e.computeTargetPlatform=l}),define(te[249],ie([0,1,204,52]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(_,R,I,h,c,v,m){const S={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_} (${R.nameShort})`};if((0,L.supportsTelemetry)(R,I)&&(0,L.getTelemetryLevel)(h)===3){const u=await(0,E.getServiceMachineId)(I,c,v);S["X-Market-User-Id"]=u,S["VSCode-SessionId"]=m.machineId||u}return S}e.resolveMarketplaceHeaders=r}),define(te[250],ie([0,1,2,37,3,25,183,19,57,77,23,47,26,52]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=e.TelemetryService=class{constructor(w,a,f){this._configurationService=a,this._productService=f,this._experimentProperties={},this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appenders=w.appenders,this._commonProperties=w.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=w.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!w.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(P),"gi")),P.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(P.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(P=>{(P.affectsConfiguration(S.TELEMETRY_SETTING_ID)||P.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||P.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(w,a){this._experimentProperties[w]=a}_updateTelemetryLevel(){let w=(0,u.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const f=a.usage?3:a.error?2:0;w=Math.min(w,f)}this._telemetryLevel=w}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(w,a,f){this._telemetryLevel<a||(f=(0,L.mixin)(f,this._experimentProperties),f=(0,u.cleanData)(f,this._cleanupPatterns),f=(0,L.mixin)(f,this._commonProperties),this._appenders.forEach(P=>P.log(w,f)))}publicLog(w,a){this._log(w,3,a)}publicLog2(w,a){this.publicLog(w,a)}publicLogError(w,a){this._sendErrorTelemetry&&this._log(w,2,a)}publicLogError2(w,a){this.publicLogError(w,a)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=y=Se([J(1,I.IConfigurationService),J(2,v.IProductService)],y);function p(){const s=(0,R.localize)(0,null,c.default.nameLong),w=c.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=r.isWeb?"":(0,R.localize)(3,null),f=(0,R.localize)(4,null),P=(0,R.localize)(5,null),C=(0,R.localize)(6,null),t=(0,R.localize)(7,null),l=`
|       | ${f} | ${P} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,R.localize)(8,null);return`
${s} ${w} ${a}

&nbsp;

${t}
${l}

&nbsp;

${n}
`}m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:p(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,R.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,R.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[251],ie([0,1,3,86,26]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function _(R,I){let h=R.getItem(r.machineIdKey);return(typeof h!="string"||E.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,L.getMachineId)(I.error.bind(I))),h}e.resolveMachineId=_}),define(te[252],ie([0,1,26,251]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function r(_,R){const I=await(0,L.resolveMachineId)(_,R);return _.setItem(E.machineIdKey,I),I}e.resolveMachineId=r}),define(te[123],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(te[253],ie([0,1,3,123]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class _{constructor(v){this.collections=v,this.map=new Map,this.descriptionMap=new Map,v.forEach((m,S)=>{this.populateDescriptionMap(m,S);const u=m.map.entries();let y=u.next();for(;!y.done;){const p=y.value[1],s=y.value[0];let w=this.map.get(s);if(w||(w=[],this.map.set(s,w)),w.length>0&&w[0].type===L.EnvironmentVariableMutatorType.Replace){y=u.next();continue}const a={extensionIdentifier:S,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};a.scope||delete a.scope,w.unshift(a),y=u.next()}})}async applyToProcessEnvironment(v,m,S){let u;E.isWindows&&(u={},Object.keys(v).forEach(y=>u[y.toLowerCase()]=y));for(const[y,p]of this.getVariableMap(m)){const s=E.isWindows&&u[y.toLowerCase()]||y;for(const w of p){const a=S?await S(w.value):w.value;if(w.options?.applyAtProcessCreation??!0)switch(w.type){case L.EnvironmentVariableMutatorType.Append:v[s]=(v[s]||"")+a;break;case L.EnvironmentVariableMutatorType.Prepend:v[s]=a+(v[s]||"");break;case L.EnvironmentVariableMutatorType.Replace:v[s]=a;break}if(w.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${r.get(w.type)}`;v[f]=(v[f]?v[f]+":":"")+y+"="+this._encodeColons(a)}}}}_encodeColons(v){return v.replaceAll(":","\\x3a")}diff(v,m){const S=new Map,u=new Map,y=new Map;if(v.getVariableMap(m).forEach((p,s)=>{const w=this.getVariableMap(m).get(s),a=I(p,w);a&&S.set(s,a)}),this.getVariableMap(m).forEach((p,s)=>{const w=v.getVariableMap(m).get(s),a=I(p,w);a&&y.set(s,a)}),this.getVariableMap(m).forEach((p,s)=>{const w=v.getVariableMap(m).get(s),a=h(p,w);a&&u.set(s,a)}),!(S.size===0&&u.size===0&&y.size===0))return{added:S,changed:u,removed:y}}getVariableMap(v){const m=new Map;return this.map.forEach((S,u)=>{const y=S.filter(p=>R(p,v));y.length>0&&m.set(y[0].variable,y)}),m}getDescriptionMap(v){const m=new Map;return this.descriptionMap.forEach((S,u)=>{const y=S.filter(p=>R(p,v,!0));y.length>0&&m.set(y[0].extensionIdentifier,y[0].description)}),m}populateDescriptionMap(v,m){if(!v.descriptionMap)return;const S=v.descriptionMap.entries();let u=S.next();for(;!u.done;){const y=u.value[1],p=u.value[0];let s=this.descriptionMap.get(p);s||(s=[],this.descriptionMap.set(p,s));const w={extensionIdentifier:m,scope:y.scope,description:y.description};w.scope||delete w.scope,s.push(w),u=S.next()}}}e.MergedEnvironmentVariableCollection=_;function R(c,v,m=!1){return c.scope?!!(c.scope.workspaceFolder&&v?.workspaceFolder&&c.scope.workspaceFolder.index===v.workspaceFolder.index):m?v===c.scope:!0}function I(c,v){if(!v)return c;const m=new Set;v.forEach(u=>m.add(u.extensionIdentifier));const S=[];return c.forEach(u=>{m.has(u.extensionIdentifier)||S.push(u)}),S.length===0?void 0:S}function h(c,v){if(!v)return;const m=new Map;v.forEach(u=>m.set(u.extensionIdentifier,u));const S=[];return c.forEach(u=>{const y=m.get(u.extensionIdentifier);y&&(u.type!==y.type||u.value!==y.value||u.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&S.push(y)}),S.length===0?void 0:S}}),define(te[254],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function E(h){return[...h.entries()]}e.serializeEnvironmentVariableCollection=E;function L(h){return h?[...h.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function r(h){return new Map(h)}e.deserializeEnvironmentVariableCollection=r;function _(h){return new Map(h??[])}e.deserializeEnvironmentDescriptionMap=_;function R(h){return Array.from(h.entries()).map(c=>[c[0],E(c[1].map),L(c[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=R;function I(h){return new Map(h.map(c=>[c[0],{map:r(c[1]),descriptionMap:_(c[2])}]))}e.deserializeEnvironmentVariableCollections=I}),define(te[255],ie([0,1,7,21,4,2,5]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=e.RequestStore=class extends _.Disposable{constructor(c,v){super(),this._logService=v,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new r.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=c===void 0?15e3:c}createRequest(c){return new Promise((v,m)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,v),this._onCreateRequest.fire({requestId:S,...c});const u=new L.CancellationTokenSource;(0,E.timeout)(this._timeout,u.token).then(()=>m(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,_.toDisposable)(()=>u.cancel())])})}acceptReply(c,v){const m=this._pendingRequests.get(c);m?(this._pendingRequests.delete(c),(0,_.dispose)(this._pendingRequestDisposables.get(c)||[]),this._pendingRequestDisposables.delete(c),m(v)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.RequestStore=I=Se([J(1,R.ILogService)],I)}),define(te[124],ie([0,1,6,113]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var r;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(r||(e.TerminalSettingPrefix=r={}));var _;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.ExperimentalImageSupport="terminal.integrated.experimentalImageSupport",f.SmoothScrolling="terminal.integrated.smoothScrolling"})(_||(e.TerminalSettingId=_={}));var R;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(R||(e.PosixShellType=R={}));var I;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(I||(e.WindowsShellType=I={}));var h;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(h||(e.TitleEventSource=h={}));var c;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.PtyHostWindow="ptyHostWindow",f.Logger="logger",f.Heartbeat="heartbeat"})(c||(e.TerminalIpcChannels=c={})),e.IPtyService=(0,E.createDecorator)("ptyService");var v;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={}));var m;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m||(e.HeartbeatConstants=m={}));var S;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var u;(function(f){f.TerminalView="view",f.Editor="editor"})(u||(e.TerminalLocationString=u={}));var y;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var p;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var s;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var w;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(w||(e.ShellIntegrationStatus=w={}));var a;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.ILocalPtyService=(0,E.createDecorator)("localPtyService")}),define(te[256],ie([0,1,69,8,185,102]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function R(S,u){const y=[{name:null,description:(0,r.localize)(0,null)}];return y.push(...S.map(p=>({name:p.profileName,description:I(p)}))),u&&y.push(...u.map(p=>({name:p.title,description:h(p)}))),{values:y.map(p=>p.name),markdownDescriptions:y.map(p=>p.description)}}e.createProfileSchemaEnums=R;function I(S){let u=`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:E.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?u+=`
- args: "${S.args}"`:u+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(u+=`
- overrideName: ${S.overrideName}`),S.color&&(u+=`
- color: ${S.color}`),S.env&&(u+=`
- env: ${JSON.stringify(S.env)}`),u}function h(S){return`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:E.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function c(S,u){if(!S&&!u)return!0;if(typeof S=="string"&&typeof u=="string")return S===u;if(Array.isArray(S)&&Array.isArray(u)){if(S.length!==u.length)return!1;for(let y=0;y<S.length;y++)if(S[y]!==u[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=c;function v(S,u){if(!S&&!u)return!0;if(!S||!u)return!1;if(_.ThemeIcon.isThemeIcon(S)&&_.ThemeIcon.isThemeIcon(u))return S.id===u.id&&S.color===u.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof u=="object"&&"light"in u&&"dark"in u){const y=S,p=u;if((L.URI.isUri(y.light)||m(y.light))&&(L.URI.isUri(y.dark)||m(y.dark))&&(L.URI.isUri(p.light)||m(p.light))&&(L.URI.isUri(p.dark)||m(p.dark)))return y.light.path===p.light.path&&y.dark.path===p.dark.path}if(L.URI.isUri(S)&&L.URI.isUri(u)||m(S)||m(u)){const y=S,p=u;return y.path===p.path&&y.scheme===p.scheme}return!1}e.terminalIconsEqual=v;function m(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=m}),define(te[257],ie([0,1,69,3,184,57,47,256]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,E.getAllCodicons)(),t=>t.id),markdownEnumDescriptions:Array.from((0,E.getAllCodicons)(),t=>`$(${t.id})`)};const h={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},v={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function m(t){const l=t===2?"linux":t===1?"osx":"windows";return(0,r.localize)(7,null,(0,L.PlatformToString)(t),'```json\n"terminal.integrated.profile.'+l+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const S=(0,r.localize)(8,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),u=(0,r.localize)(9,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,r.localize)(10,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.linux#`"),s=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.osx#`"),w=(0,r.localize)(13,null,"`#terminal.integrated.automationProfile.windows#`"),a={id:"terminal",order:100,title:(0,r.localize)(14,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:s},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:u},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(26,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(27,null)}},{type:"string",markdownDescription:(0,r.localize)(28,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:m(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:m(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(33,null),type:"string"},id:{description:(0,r.localize)(34,null),type:"string"},title:{description:(0,r.localize)(35,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:m(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(36,null),type:"string"},id:{description:(0,r.localize)(37,null),type:"string"},title:{description:(0,r.localize)(38,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(39,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(41,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(43,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){R.Registry.as(_.Extensions.Configuration).registerConfiguration(a),C()}e.registerTerminalPlatformConfiguration=f;let P;function C(t,l){const n=R.Registry.as(_.Extensions.Configuration);let i;t&&(i=(0,I.createProfileSchemaEnums)(t?.profiles,l));const o=P;P={id:"terminal",order:100,title:(0,r.localize)(44,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(45,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:t?.os===3?i?.values:void 0,markdownEnumDescriptions:t?.os===3?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(46,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:t?.os===2?i?.values:void 0,markdownEnumDescriptions:t?.os===2?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:t?.os===1?i?.values:void 0,markdownEnumDescriptions:t?.os===1?i?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[P],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=C}),define(te[258],ie([0,1,27,14,37,9,3,36,25,11,22,123,254,253]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let o=0;return i&&i.length===4&&(o=parseInt(i[3])),o}e.getWindowsBuildNumber=y;async function p(i,o,d,g=I.env,D=v.Promises.exists){if(_.isAbsolute(i))return await D(i)?i:void 0;if(o===void 0&&(o=I.cwd()),_.dirname(i)!=="."){const O=_.join(o,i);return await D(O)?O:void 0}const b=(0,r.getCaseInsensitive)(g,"PATH");if(d===void 0&&(0,c.isString)(b)&&(d=b.split(_.delimiter)),d===void 0||d.length===0){const O=_.join(o,i);return await D(O)?O:void 0}for(const O of d){let F;if(_.isAbsolute(O)?F=_.join(O,i):F=_.join(o,O,i),await D(F))return F;if(R.isWindows){let q=F+".com";if(await D(q)||(q=F+".exe",await D(q)))return q}}const A=_.join(o,i);return await D(A)?A:void 0}e.findExecutable=p;function s(i,o,d,g,D){const M=R.isWindows&&(!o.windowsEnableConpty||y()<18309);if(!o.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||M)return;const b=i.args,A=I.platform==="win32"?_.basename(i.executable).toLowerCase():_.basename(i.executable),O=_.dirname(L.FileAccess.asFileUri("").fsPath);let F;const q={VSCODE_INJECTION:"1"};if(o.shellIntegration.nonce&&(q.VSCODE_NONCE=o.shellIntegration.nonce),R.isWindows){if(A==="pwsh.exe"||A==="powershell.exe")return!b||l(b)?F=f.get(a.WindowsPwsh):t(b)&&(F=f.get(a.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O,""),{newArgs:F,envMixin:q}):void 0;g.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(A){case"bash":return!b||b.length===0?F=f.get(a.Bash):n(b)&&(q.VSCODE_SHELL_LOGIN="1",w(o,q),F=f.get(a.Bash)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O),{newArgs:F,envMixin:q}):void 0;case"fish":return;case"pwsh":return!b||l(b)?F=f.get(a.Pwsh):t(b)&&(F=f.get(a.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O,""),{newArgs:F,envMixin:q}):void 0;case"zsh":{if(!b||b.length===0?F=f.get(a.Zsh):n(b)?(F=f.get(a.ZshLogin),w(o,q)):(b===f.get(a.Zsh)||b===f.get(a.ZshLogin))&&(F=b),!F)return;F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],O);let re;try{re=E.userInfo().username}catch{re="unknown"}const Y=_.join(E.tmpdir(),`${re}-${D.applicationName}-zsh`);q.ZDOTDIR=Y;const ne=d?.ZDOTDIR??E.homedir()??"~";q.USER_ZDOTDIR=ne;const ce=[];return ce.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:_.join(Y,".zshrc")}),ce.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:_.join(Y,".zprofile")}),ce.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:_.join(Y,".zshenv")}),ce.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:_.join(Y,".zlogin")}),{newArgs:F,envMixin:q,filesToCopy:ce}}}g.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=s;function w(i,o){if(R.isMacintosh&&i.environmentVariableCollections){const d=(0,S.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),D=new u.MergedEnvironmentVariableCollection(d).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),M=[];if(D)for(const b of D)b.type===m.EnvironmentVariableMutatorType.Prepend&&M.push(b.value);M.length>0&&(o.VSCODE_PATH_PREFIX=M.join(""))}}var a;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(a||(a={}));const f=new Map;f.set(a.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(a.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(a.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(a.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(a.Zsh,["-i"]),f.set(a.ZshLogin,["-il"]),f.set(a.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const P=["-login","-l"],C=["-nol","-nologo"];function t(i){return typeof i=="string"?P.includes(i.toLowerCase()):i.length===1&&P.includes(i[0].toLowerCase())||i.length===2&&(P.includes(i[0].toLowerCase())||P.includes(i[1].toLowerCase()))&&(C.includes(i[0].toLowerCase())||C.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?C.includes(i.toLowerCase()):i.length===0||i?.length===1&&C.includes(i[0].toLowerCase())}function n(i){return i==="string"&&P.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&P.includes(i[0].toLowerCase())}}),define(te[259],ie([0,1,46,69,9,3,11,22,106,258,112]),function(j,e,E,L,r,_,R,I,h,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let m,S=!0;function u(i,o,d,g,D=process.env,M,b,A,O){return M=M||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},_.isWindows?y(d,M,D,b,g.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:g.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:g.getValue("terminal.integrated.defaultProfile.windows"),O,A):t(M,b,d,i&&typeof i=="object"?{...i}:g.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:g.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),O,A,D)}e.detectAvailableProfiles=u;async function y(i,o,d,g,D,M,b,A,O){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),q=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let re=!1;(0,c.getWindowsBuildNumber)()>=16299&&(re=!0),await w(A);const Y=new Map;if(i){Y.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),Y.set("Windows PowerShell",{path:`${q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),Y.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),Y.set("Command Prompt",{path:`${q}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),Y.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),Y.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const ce=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;Y.set("Cmder",{path:`${q}\\cmd.exe`,args:["/K",ce],requiresPath:process.env.CMDER_ROOT?ce:{path:ce,isUnsafe:!0},isAutoDetected:!0})}l(M,Y);const ne=await p(Y.entries(),b,o,d,g,O);if(i||D)try{const ce=await P(`${q}\\${re?"wsl":"bash"}.exe`,b);for(const le of ce)(!M||!(le.profileName in M))&&ne.push(le)}catch{S&&(g?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return ne}async function p(i,o,d,g=process.env,D,M){const b=[];for(const[A,O]of i){if(O===null)continue;let F,q,re;if("source"in O&&!("path"in O)){const le=m?.get(O.source);if(!le)continue;F=le.paths,q=O.args||le.args,O.icon?re=s(O.icon):le.icon&&(re=le.icon)}else F=Array.isArray(O.path)?O.path:[O.path],q=_.isWindows||Array.isArray(O.args)?O.args:void 0,re=s(O.icon);let Y;if(M){const le=F.map(V=>typeof V=="string"?V:V.path),K=await M(le);Y=new Array(F.length);for(let V=0;V<F.length;V++)typeof F[V]=="string"?Y[V]=K[V]:Y[V]={path:K[V],isUnsafe:!0}}else Y=F.slice();let ne;if(O.requiresPath){let le;if((0,R.isString)(O.requiresPath)?le=O.requiresPath:(le=O.requiresPath.path,O.requiresPath.isUnsafe&&(ne=le)),!await d.existsFile(le))continue}const ce=await n(A,o,Y,d,g,q,O.env,O.overrideName,O.isAutoDetected,ne);ce?(ce.isAutoDetected=O.isAutoDetected,ce.icon=re,ce.color=O.color,b.push(ce)):D?.debug("Terminal profile not validated",A,F)}return D?.debug("Validated terminal profiles",b),b}function s(i){return typeof i=="string"?{id:i}:i}async function w(i){if(m&&!i)return;const[o,d]=await Promise.all([a(),i||f()]);m=new Map,m.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),m.set("PowerShell",{profileName:"PowerShell",paths:d,icon:L.Codicon.terminalPowershell})}async function a(){const i=new Set,o=await(0,c.findExecutable)("git.exe");if(o){const D=(0,v.dirname)(o);i.add((0,v.resolve)(D,"../.."))}function d(D,M){M&&D.add(M)}d(i,process.env.ProgramW6432),d(i,process.env.ProgramFiles),d(i,process.env["ProgramFiles(X86)"]),d(i,`${process.env.LocalAppData}\\Program`);const g=[];for(const D of i)g.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return g.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),g}async function f(){const i=[];for await(const o of(0,h.enumeratePowerShellInstallations)())i.push(o.exePath);return i}async function P(i,o){const d=[],g=await new Promise((b,A)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(O,F)=>{if(O)return A("Problem occurred when getting wsl distros");b(F)})});if(!g)return[];const D=new RegExp(/[\r?\n]/),M=g.split(D).filter(b=>b.trim().length>0&&b!=="");for(const b of M){if(b===""||b.startsWith("docker-desktop"))continue;const A=`${b} (WSL)`,O={profileName:A,path:i,args:["-d",`${b}`],isDefault:A===o,icon:C(b),isAutoDetected:!1};d.push(O)}return d}function C(i){return i.includes("Ubuntu")?L.Codicon.terminalUbuntu:i.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function t(i,o,d,g,D,M,b,A){const O=new Map;if(d){const F=(await i.readFile("/etc/shells")).toString(),q=M||F.split(`
`).filter(Y=>Y.trim().includes("#")&&Y.trim().length>0),re=new Map;for(const Y of q){let ne=(0,r.basename)(Y),ce=re.get(ne)||0;ce++,ce>1&&(ne=`${ne} (${ce})`),re.set(ne,ce),O.set(ne,{path:Y,isAutoDetected:!0})}}return l(g,O),await p(O.entries(),D,i,A,o,b)}function l(i,o){if(i)for(const[d,g]of Object.entries(i))g===null||typeof g!="object"||!("path"in g)&&!("source"in g)?o.delete(d):(g.icon=g.icon||o.get(d)?.icon,o.set(d,g))}async function n(i,o,d,g,D,M,b,A,O,F){if(d.length===0)return Promise.resolve(void 0);const q=d.shift();if(q==="")return n(i,o,d,g,D,M,b,A,O);const re=typeof q!="string"&&q.isUnsafe,Y=typeof q=="string"?q:q.path,ne={profileName:i,path:Y,args:M,env:b,overrideName:A,isAutoDetected:O,isDefault:i===o,isUnsafePath:re,requiresUnsafePath:F};if((0,r.basename)(Y)===Y){const le=D.PATH?D.PATH.split(r.delimiter):void 0,K=await(0,c.findExecutable)(Y,void 0,le,void 0,g.existsFile);return K?(ne.path=K,ne.isFromPath=!0,ne):n(i,o,d,g,D,M)}return await g.existsFile((0,r.normalize)(Y))?ne:n(i,o,d,g,D,M,b,A,O)}}),define(te[260],ie([0,1,4,2,3,43,19,5,224,93,255,124,257,259]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(w){w[w.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let p=0,s=e.PtyHostService=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}_ensurePtyHost(){this.__connection||([this.__connection,this.__proxy]=this._startPtyHost())}constructor(a,f,P,C){super(),this._ptyHostStarter=a,this._configurationService=f,this._logService=P,this._loggerService=C,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new E.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new E.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new E.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new E.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new E.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new E.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new E.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new E.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new E.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new E.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new E.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new E.Emitter),this.onProcessExit=this._onProcessExit.event,(0,S.registerTerminalPlatformConfiguration)(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onBeforeWindowConnection?E.Event.once(this._ptyHostStarter.onBeforeWindowConnection)(()=>this._ensurePtyHost()):this._ensurePtyHost(),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(r.isWindows)return process.env;try{return await(0,c.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a=this._ptyHostStarter.start(p),f=a.client;this._onPtyHostStart.fire(),_.ProxyChannel.toService(f.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(t=>{this._onPtyHostExit.fire(t.code),!this._wasQuitRequested&&!this._isDisposed&&(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const C=_.ProxyChannel.toService(f.getChannel(m.TerminalIpcChannels.PtyHost));return this._register(C.onProcessData(t=>this._onProcessData.fire(t))),this._register(C.onProcessReady(t=>this._onProcessReady.fire(t))),this._register(C.onProcessExit(t=>this._onProcessExit.fire(t))),this._register(C.onDidChangeProperty(t=>this._onDidChangeProperty.fire(t))),this._register(C.onProcessReplay(t=>this._onProcessReplay.fire(t))),this._register(C.onProcessOrphanQuestion(t=>this._onProcessOrphanQuestion.fire(t))),this._register(C.onDidRequestDetach(t=>this._onDidRequestDetach.fire(t))),E.Event.once(E.Event.any(C.onProcessReady,C.onProcessReplay))(()=>{this._register(new h.RemoteLoggerChannelClient(this._loggerService,f.getChannel(m.TerminalIpcChannels.Logger)))}),this.__connection=a,this.__proxy=C,this._register(this._configurationService.onDidChangeConfiguration(async t=>{t.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[a,C]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,f,P,C,t,l,n,i,o,d,g){const D=setTimeout(()=>this._handleUnresponsiveCreateProcess(),m.HeartbeatConstants.CreateProcessTimeout),M=await this._proxy.createProcess(a,f,P,C,t,l,n,i,o,d,g);return clearTimeout(D),p=Math.max(p,M),M}updateTitle(a,f,P){return this._proxy.updateTitle(a,f,P)}updateIcon(a,f,P,C){return this._proxy.updateIcon(a,f,P,C)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a,f){return this._proxy.detachFromProcess(a,f)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,f){return this._proxy.shutdown(a,f)}input(a,f){return this._proxy.input(a,f)}processBinary(a,f){return this._proxy.processBinary(a,f)}resize(a,f,P){return this._proxy.resize(a,f,P)}acknowledgeDataEvent(a,f){return this._proxy.acknowledgeDataEvent(a,f)}setUnicodeVersion(a,f){return this._proxy.setUnicodeVersion(a,f)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,f){return this._proxy.installAutoReply(a,f)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,f,P,C=!1){const t=await this._resolveShellEnv();return(0,u.detectAvailableProfiles)(f,P,C,this._configurationService,t,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a,f){return this._proxy.getWslPath(a,f)}getRevivedPtyNewId(a){return this._proxy.getRevivedPtyNewId(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,f){return this._proxy.requestDetachInstance(a,f)}async acceptDetachInstanceReply(a,f){return this._proxy.acceptDetachInstanceReply(a,f)}async freePortKillProcess(a){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(a)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,f){return this._proxy.reviveTerminalProcesses(a,f)}async refreshProperty(a,f){return this._proxy.refreshProperty(a,f)}async updateProperty(a,f,P){return this._proxy.updateProperty(a,f,P)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._connection.store.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,f){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:f})}async acceptPtyHostResolvedVariables(a,f){this._resolveVariablesRequestStore.acceptReply(a,f)}};e.PtyHostService=s=Se([J(1,R.IConfigurationService),J(2,I.ILogService),J(3,I.ILoggerService)],s)}),define(te[79],ie([0,1,15,4,2,3,19,6,34]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const c="#FFFFFF",v="#1E1E1E",m="#000000",S="#FFFFFF",u="theme",y="themeBackground",p="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let s=e.ThemeMainService=class extends r.Disposable{constructor(a,f){super(),this.stateService=a,this.configurationService=f,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,E.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(_.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(_.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(_.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const a=this.getColorScheme();if(a.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return a.dark?m:S;let f=this.stateService.getItem(y,null);if(!f)switch(this.stateService.getItem(u,"vs-dark").split(" ")[0]){case"vs":f=c;break;case"hc-black":f=m;break;case"hc-light":f=S;break;default:f=v}return _.isMacintosh&&f.toUpperCase()===v&&(f="#171717"),f}saveWindowSplash(a,f){this.stateService.setItems([{key:u,data:f.baseTheme},{key:y,data:f.colorInfo.background},{key:p,data:f}]),typeof a=="number"&&this.updateBackgroundColor(a,f)}updateBackgroundColor(a,f){for(const P of E.BrowserWindow.getAllWindows())if(P.id===a){P.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(p)}};e.ThemeMainService=s=Se([J(0,h.IStateService),J(1,R.IConfigurationService)],s)}),define(te[125],ie([0,1,4,19,6,5]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var R;(function(p){p.Http="http",p.Https="https"})(R||(e.TunnelProtocol=R={}));var I;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(I||(e.TunnelPrivacyId=I={}));var h;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function c(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=c,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=v,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=m;function S(p,s,w,a){if(w===1)return!1;if(w===2&&m(s)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(f?.length===4&&parseInt(f[1])>=18)return!1}return p<1024}e.isPortPrivileged=S;class u{constructor(s,w,a){this.remoteAddress=s,this.localAddress=w,this._dispose=a,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=u;let y=e.AbstractTunnelService=class{constructor(s,w){this.logService=s,this.configurationService=w,this._onTunnelOpened=new E.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new E.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new E.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],w=Array.from(this._tunnels.values());for(const a of w){const f=Array.from(a.values());for(const P of f){const C=await P.value;C&&s.push(C)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:w}of s.values())await w.then(a=>a?.dispose());s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,w,a,f,P){this.addTunnelToMap(s,w,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:w,localAddress:a,privacy:f,protocol:P,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,w){(m(s)||v(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const a=this.getTunnelFromMap(s,w);if(a)return++a.refcount,a.value}openTunnel(s,w,a,f,P,C=!1,t,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${a} on local port ${P}.`),!s)return;if(w||(w="localhost"),f||(f=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(a)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(s,w,a,f,P,C,t,l);return n?n.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,a);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(i);return(i.tunnelRemoteHost!==w||i.tunnelRemotePort!==a)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),t&&i.privacy!==t&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const w=this._tunnels.get(s.tunnelRemoteHost);if(w){const a=w.get(s.tunnelRemotePort);a&&(a.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,a))}}}}async tryDisposeTunnel(s,w,a){if(a.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${w}.`);const f=a.value.then(async P=>{P&&(await P.dispose(!0),this._onTunnelClosed.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(w),f}}async closeTunnel(s,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${w} `);const a=this._tunnels.get(s);if(a&&a.has(w)){const f=a.get(w);f.refcount=0,await this.tryDisposeTunnel(s,w,f)}}addTunnelToMap(s,w,a){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(w,{refcount:1,value:a})}async removeEmptyTunnelFromMap(s,w){const a=this._tunnels.get(s);a&&(await a.get(w)||a.delete(w),a.size===0&&this._tunnels.delete(s))}getTunnelFromMap(s,w){const a=[s];v(s)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):m(s)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const f=a.map(P=>this._tunnels.get(P));for(const P of f){const C=P?.get(w);if(C)return C}}canTunnel(s){return!!c(s)}createWithProvider(s,w,a,f,P,C,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${a} on local port ${f}.`);const l=a;this._factoryInProgress.add(l);const n=f===void 0?a:f,i={elevationRequired:P?this.isPortPrivileged(n):!1},o={remoteAddress:{host:w,port:a},localAddressPort:f,privacy:C,public:C?C!==I.Private:void 0,protocol:t},d=s.forwardPort(o,i);return d?(this.addTunnelToMap(w,a,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),d}};e.AbstractTunnelService=y=Se([J(0,_.ILogService),J(1,L.IConfigurationService)],y)}),define(te[261],ie([0,1,84,27,103,7,2,19,5,23,239,125,94,3,240]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(P,C,t,l,n){let i;for(let o=3;o&&(i?.dispose(),i=await new s(P,C,t,l,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));o--);return i}class s extends R.Disposable{constructor(C,t,l,n,i){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=i,this.privacy=m.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=C,this._server=E.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=o=>this._onConnection(o),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const C=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,m.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let l=await(0,r.findFreePortFaster)(C,2,1e3,t),n=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(C){C.pause();const t=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,v.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),n=l.getSocket().socket,i=l.readEntireBuffer();l.dispose(),i.byteLength>0&&C.write(i.buffer),C.on("end",()=>{C.localAddress&&this._socketsDispose.delete(C.localAddress),n.end()}),C.on("close",()=>n.end()),C.on("error",()=>{C.localAddress&&this._socketsDispose.delete(C.localAddress),n.destroy()}),n.on("end",()=>C.end()),n.on("close",()=>C.end()),n.on("error",()=>{C.destroy()}),C.pipe(n),n.pipe(C),C.localAddress&&this._socketsDispose.set(C.localAddress,()=>{C.end(),n.end()})}}let w=e.BaseTunnelService=class extends m.AbstractTunnelService{constructor(C,t,l,n,i){super(t,i),this.remoteSocketFactoryService=C,this.signService=l,this.productService=n}isPortPrivileged(C){return(0,m.isPortPrivileged)(C,this.defaultTunnelHost,u.OS,L.release())}retainOrCreateTunnel(C,t,l,n,i,o,d,g){const D=this.getTunnelFromMap(t,l);if(D)return++D.refcount,D.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,t,l,i,o,d,g);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${l} on local port ${i}.`);const M={commit:this.productService.commit,quality:this.productService.quality,addressProvider:C,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},b=p(M,n,t,l,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,l,b),b}}};e.BaseTunnelService=w=Se([J(0,y.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,S.ISignService),J(3,c.IProductService),J(4,I.IConfigurationService)],w);let a=e.TunnelService=class extends w{constructor(C,t,l,n,i){super(C,t,l,n,i)}};e.TunnelService=a=Se([J(0,y.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,S.ISignService),J(3,c.IProductService),J(4,I.IConfigurationService)],a);let f=e.SharedTunnelsService=class extends R.Disposable{constructor(C,t,l,n,i){super(),this.remoteSocketFactoryService=C,this.logService=t,this.productService=l,this.signService=n,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(C,t,l,n,i,o,d,g,D){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${n} on local port ${o}.`),!this._tunnelServices.has(C)){const M=new a(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(M),this._tunnelServices.set(C,M),M.onTunnelClosed(async()=>{(await M.tunnels).length===0&&(M.dispose(),this._tunnelServices.delete(C))})}return this._tunnelServices.get(C).openTunnel(t,l,n,i,o,d,g,D)}};e.SharedTunnelsService=f=Se([J(0,y.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,c.IProductService),J(3,S.ISignService),J(4,I.IConfigurationService)],f)}),define(te[48],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(_){_.Uninitialized="uninitialized",_.Idle="idle",_.CheckingForUpdates="checking for updates",_.AvailableForDownload="available for download",_.Downloading="downloading",_.Downloaded="downloaded",_.Updating="updating",_.Ready="ready"})(L||(e.StateType=L={}));var r;(function(_){_[_.Setup=0]="Setup",_[_.Archive=1]="Archive",_[_.Snap=2]="Snap",_[_.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(_,R)=>({type:"idle",updateType:_,error:R}),CheckingForUpdates:_=>({type:"checking for updates",explicit:_}),AvailableForDownload:_=>({type:"available for download",update:_}),Downloading:_=>({type:"downloading",update:_}),Downloaded:_=>({type:"downloaded",update:_}),Updating:_=>({type:"updating",update:_}),Ready:_=>({type:"ready",update:_})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(te[262],ie([0,1,3,186,57,47]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[263],ie([0,1,4,48]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(I){this.service=I}listen(I,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(I,h,c){switch(h){case"checkForUpdates":return this.service.checkForUpdates(c);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=r;class _{get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}constructor(I){this.channel=I,this._onStateChange=new E.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(I){return this.channel.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=_}),define(te[40],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(te[264],ie([0,1,40,205,16,18,138,4,2]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(S){this.uri=S,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let v=e.UriIdentityService=class{constructor(S){this._fileService=S,this._dispooables=new h.DisposableStore,this._limit=2**16;const u=new Map,y=p=>{let s=u.get(p.scheme);return s===void 0&&(s=S.hasProvider(p)&&!this._fileService.hasCapability(p,1024),u.set(p.scheme,s)),s};this._dispooables.add(I.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(p=>{u.delete(p.scheme)})),this.extUri=new _.ExtUri(y),this._canonicalUris=new R.SkipList((p,s)=>this.extUri.compare(p,s,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,_.normalizePath)(S));const u=this._canonicalUris.get(S);return u?u.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new c(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((y,p)=>y[1].time<p[1].time?1:y[1].time>p[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let y=0;y<u;y++)this._canonicalUris.set(S[y][0],S[y][1].touch())}};e.UriIdentityService=v=Se([J(0,r.IFileService)],v),(0,L.registerSingleton)(E.IUriIdentityService,v,1)}),define(te[126],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(te[265],ie([0,1,8]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(I){this.handler=I}listen(I,h){throw new Error(`Event not found: ${h}`)}call(I,h,c){switch(h){case"handleURL":return this.handler.handleURL(E.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class r{constructor(I){this.channel=I}handleURL(I,h){return this.channel.call("handleURL",[I.toJSON(),h])}}e.URLHandlerChannelClient=r;class _{constructor(I,h){this.next=I,this.logService=h}async routeCall(I,h,c,v){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const m=E.URI.revive(c[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",m.toString(!0)),m.query){const S=/\bwindowId=(\d+)/.exec(m.query);if(S){const u=S[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,m.toString(!0));const y=new RegExp(`window:${u}`),p=I.connections.find(s=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",s.ctx),y.test(s.ctx)));if(p)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",m.toString(!0)),p;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",m.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",m.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(I,h,c,v)}routeEvent(I,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=_}),define(te[266],ie([0,1,7,2,8,23]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(c,v){const m=[...this.handlers.values()];return(0,E.first)(m.map(S=>()=>S.handleURL(c,v)),void 0,!1).then(S=>S||!1)}registerHandler(c){return this.handlers.add(c),(0,L.toDisposable)(()=>this.handlers.delete(c))}}e.AbstractURLService=R;let I=e.NativeURLService=class extends R{constructor(c){super(),this.productService=c}create(c){let{authority:v,path:m,query:S,fragment:u}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return v&&m&&m.indexOf("/")!==0&&(m=`/${m}`),r.URI.from({scheme:this.productService.urlProtocol,authority:v,path:m,query:S,fragment:u})}};e.NativeURLService=I=Se([J(0,_.IProductService)],I)}),define(te[267],ie([0,1,15,7,4,2,3,8]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h{constructor(v,m,S,u,y,p){if(this.urlService=m,this.logService=p,this.uris=[],this.retryCount=0,this.flushDisposable=_.Disposable.None,this.disposables=new _.DisposableStore,v&&(p.trace("ElectronURLListener initialUrisToHandle:",v.map(a=>a.originalUrl)),this.uris=v),R.isWindows){const a=u.isBuilt?[]:[`"${u.appRoot}"`];a.push("--open-url","--"),E.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,a)}const s=r.Event.map(r.Event.fromNodeEventEmitter(E.app,"open-url",(a,f)=>({event:a,url:f})),({event:a,url:f})=>(a.preventDefault(),f));this.disposables.add(s(a=>{const f=this.uriFromRawUrl(a);f&&this.urlService.open(f,{originalUrl:a})})),S.getWindows().filter(a=>a.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(v){try{return I.URI.parse(v)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const v=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",m.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",m.originalUrl),v.push(m));v.length!==0&&(this.uris=v,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=h}),define(te[268],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(te[269],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(te[270],ie([0,1,15,2,14,8]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends L.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);E.protocol.registerFileProtocol(r.Schemas.vscodeWebview,h)}handleWebviewRequest(h,c){try{const v=_.URI.parse(h.url),m=R.validWebviewFilePaths.get(v.path);if(typeof m=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${m}`,u=r.FileAccess.asFileUri(S);return c({path:u.fsPath,headers:{...r.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.WebviewProtocolProvider=R,R.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[80],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(v){return!!v.workspaceUri}e.isWorkspaceToOpen=L;function r(v){return!!v.folderUri}e.isFolderToOpen=r;function _(v){return!!v.fileUri}e.isFileToOpen=_;function R(v){const m=I(v),S=v.getValue("window.menuBarVisibility");return S==="default"||m==="native"&&S==="compact"||E.isMacintosh&&E.isNative?"classic":S}e.getMenuBarVisibility=R;function I(v){if(E.isWeb)return"custom";const m=v.getValue("window");if(m){if(E.isMacintosh&&m.nativeTabs===!0||E.isMacintosh&&m.nativeFullScreen===!1)return"native";const y=m.titleBarStyle;if(y==="native"||y==="custom")return y}return E.isLinux?"native":"custom"}e.getTitleBarStyle=I;function h(v){if(!E.isWindows||E.isWeb||I(v)==="native")return!1;const m=v.getValue("window.experimental.windowControlsOverlay.enabled");return typeof m=="boolean"?m:!0}e.useWindowControlsOverlay=h;function c(v=0){return Math.pow(1.2,v)}e.zoomLevelToZoomFactor=c}),define(te[127],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var L;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const r=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=r;var _;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(_||(e.WindowMode=_={}));var R;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(R||(e.WindowError=R={}))}),define(te[28],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var L;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(L||(e.OpenContext=L={}))}),define(te[271],ie([0,1,15,21,4,56,2,31,75,114,5,23,28]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let y=e.ProxyAuthHandler=class extends R.Disposable{constructor(s,w,a,f,P){super(),this.logService=s,this.windowsMainService=w,this.credentialsService=a,this.encryptionMainService=f,this.productService=P,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=u.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const s=r.Event.fromNodeEventEmitter(E.app,"login",(w,a,f,P,C)=>({event:w,webContents:a,req:f,authInfo:P,callback:C}));this._register(s(this.onLogin,this))}async onLogin({event:s,authInfo:w,req:a,callback:f}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===u.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}s.preventDefault();let P;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),P=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{P=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(P?.username,P?.password)}async resolveProxyCredentials(s){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(s);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(s){this.logService.trace("auth#doResolveProxyCredentials - enter",s);const w=String((0,_.hash)({scheme:s.scheme,host:s.host,port:s.port}));let a,f;try{const l=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w);if(l){const n=JSON.parse(await this.encryptionMainService.decrypt(l));a=n.username,f=n.password}}catch(l){this.logService.error(l)}if(this.state!==u.StoredCredentialsUsed&&typeof a=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=u.StoredCredentialsUsed,{username:a,password:f};const P=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!P){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${P.id} to handle proxy login`);const C={authInfo:s,username:this.sessionCredentials?.username??a,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};P.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,C),this.state=u.LoginDialogShown;const t=await new Promise(l=>{const n=async(i,o,d)=>{if(o===C.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${P.id}`),P.win?.webContents.off("ipc-message",n),d){const g={username:d.username,password:d.password};try{if(d.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(g));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w,D)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w)}catch(D){this.logService.error(D)}l({username:g.username,password:g.password})}else l(void 0)};P.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=t,t}};e.ProxyAuthHandler=y=Se([J(0,v.ILogService),J(1,S.IWindowsMainService),J(2,h.ICredentialsMainService),J(3,c.IEncryptionMainService),J(4,m.IProductService)],y)}),define(te[272],ie([0,1,75,5,33,23,28,217]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=e.CredentialsNativeMainService=class extends I.BaseCredentialsMainService{constructor(v,m,S,u){super(v),this.environmentMainService=m,this.productService=S,this.windowsMainService=u,this.surfaceKeytarLoadError=y=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new E.InMemoryCredentialsProvider,this._keytarCache;const v=await new Promise((m,S)=>{j(["keytar"],m,S)});return await v.findCredentials("test-keytar-loads"),this._keytarCache=v,this._keytarCache}};e.CredentialsNativeMainService=h=Se([J(0,L.ILogService),J(1,r.INativeEnvironmentService),J(2,_.IProductService),J(3,R.IWindowsMainService)],h)}),define(te[273],ie([0,1,15,24,3,8,22,19,63,6,5,126,28]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,c.createDecorator)(e.ID);let u=e.LaunchMainService=class{constructor(p,s,w,a){this.logService=p,this.windowsMainService=s,this.urlService=w,this.configurationService=a}async start(p,s){this.logService.trace("Received data from other instance: ",p,s),r.isMacintosh&&E.app.focus({steal:!0});const w=this.parseOpenUrl(p);if(w.length){let a=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const f=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));f&&(a=f.ready())}a.then(()=>{for(const{uri:f,originalUrl:P}of w)this.urlService.open(f,{originalUrl:P})})}else return this.startOpenWindow(p,s)}parseOpenUrl(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,L.coalesce)(p._urls.map(s=>{try{return{uri:_.URI.parse(s),originalUrl:s}}catch{return null}})):[]}async startOpenWindow(p,s){const w=(0,h.isLaunchedFromCli)(s)?0:4;let a=[];const f=p.wait&&p.waitMarkerFilePath?_.URI.file(p.waitMarkerFilePath):void 0,P=p.remote||void 0,C={context:w,cli:p,userEnv:s,waitMarkerFileURI:f,remoteAuthority:P,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,C);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let t=!1;if(p["new-window"]||p["unity-launch"]||C.forceProfile||C.forceTempProfile)t=!0;else if(p["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)a=await this.windowsMainService.open({...C,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,C),a=[l]):a=await this.windowsMainService.open({...C,forceEmpty:!0})}}else a=await this.windowsMainService.open({...C,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(f&&a.length===1&&a[0])return Promise.race([a[0].whenClosedOrLoaded,(0,R.whenDeleted)(f.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=u=Se([J(0,v.ILogService),J(1,S.IWindowsMainService),J(2,m.IURLService),J(3,I.IConfigurationService)],u)}),define(te[274],ie([0,1,15,4,2,270,28]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=e.WebviewMainService=class extends r.Disposable{constructor(c){super(),this.windowsMainService=c,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new _.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(c,v){let m;if(typeof c.windowId=="number"){const{windowId:S}=c,u=this.windowsMainService.getWindowById(S);if(!u?.win)throw new Error(`Invalid windowId: ${S}`);m=u.win.webContents}else{const{webContentsId:S}=c;if(m=E.webContents.fromId(S),!m)throw new Error(`Invalid webContentsId: ${S}`)}m.isDestroyed()||m.setIgnoreMenuShortcuts(v)}async findInFrame(c,v,m,S){const y=this.getFrameByName(c,v);if(typeof y.findInFrame=="function"){y.findInFrame(m,{findNext:S.findNext,forward:S.forward});const p=(s,w)=>{w.finalUpdate&&(this._onFoundInFrame.fire(w),y.removeListener("found-in-frame",p))};y.on("found-in-frame",p)}}async stopFindInFrame(c,v,m){const u=this.getFrameByName(c,v);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(m.keepSelection?"keepSelection":"clearSelection")}getFrameByName(c,v){const m=this.windowsMainService.getWindowById(c.windowId);if(!m?.win)throw new Error(`Invalid windowId: ${c}`);const S=m.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===v);if(!S)throw new Error(`Unknown frame: ${v}`);return S}};e.WebviewMainService=I=Se([J(0,R.IWindowsMainService)],I)}),define(te[275],ie([0,1,7,4,2]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends r.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:h,getActiveWindowId:c}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(I,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,E.createCancelablePromise)(()=>c()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(te[29],ie([0,1,190,9,62,18,8,6,14]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function c(i){const o=i;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=c;function v(i){return typeof i?.id=="string"&&!c(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=v,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function m(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const d=i;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.toWorkspaceIdentifier=m;function S(i){const o=i;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=S;function u(i){const o=i;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const d=i;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=u;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function p(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=p;function s(i){const o=i;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=s;class w{constructor(o,d,g,D,M){this._id=o,this._transient=g,this._configuration=D,this._ignorePathCasing=M,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class a{constructor(o,d){this.raw=d,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,_.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function f(i){return new a({uri:i,index:0,name:(0,_.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(i,o){return _.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function C(i){let o;return R.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=C,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function l(i,o){return!P(i,o)&&!C(i)}e.isSavedWorkspace=l;function n(i){return(typeof i=="string"?(0,L.extname)(i):(0,_.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(te[59],ie([0,1,15,7,56,45,2,83,3,11,22,165,90,6,5,23,29]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,u.createDecorator)("dialogMainService");let w=e.DialogMainService=class{constructor(f,P){this.logService=f,this.productService=P,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(f,P){return this.doPick({...f,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},P)}pickFolder(f,P){return this.doPick({...f,pickFolders:!0,title:(0,m.localize)(1,null)},P)}pickFile(f,P){return this.doPick({...f,pickFiles:!0,title:(0,m.localize)(2,null)},P)}pickWorkspace(f,P){const C=(0,m.localize)(3,null),t=(0,_.mnemonicButtonLabel)((0,m.localize)(4,null)),l=s.WORKSPACE_FILTER;return this.doPick({...f,pickFiles:!0,title:C,filters:l,buttonLabel:t},P)}async doPick(f,P){const C={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(C.properties=void 0,f.pickFiles&&f.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&C.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(C,(0,c.withNullAsUndefined)(P||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}getWindowDialogQueue(f){if(f){let P=this.windowDialogQueues.get(f.id);return P||(P=new L.Queue,this.windowDialogQueues.set(f.id,P)),P}else return this.noWindowDialogueQueue}showMessageBox(f,P){return this.getWindowDialogQueue(P).queue(async()=>{const{options:C,buttonIndeces:t}=(0,S.massageMessageBoxOptions)(f,this.productService);let l;return P?l=await E.dialog.showMessageBox(P,C):l=await E.dialog.showMessageBox(C),{response:t[l.response],checkboxChecked:l.checkboxChecked}})}async showSaveDialog(f,P){const C=this.acquireFileDialogLock(f,P);if(!C)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(P).queue(async()=>{let t;return P?t=await E.dialog.showSaveDialog(P,f):t=await E.dialog.showSaveDialog(f),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,R.dispose)(C)}}normalizePath(f){return f&&h.isMacintosh&&(f=(0,I.normalizeNFC)(f)),f}normalizePaths(f){return f.map(P=>this.normalizePath(P))}async showOpenDialog(f,P){f.defaultPath&&(await v.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const C=this.acquireFileDialogLock(f,P);if(!C)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(P).queue(async()=>{let t;return P?t=await E.dialog.showOpenDialog(P,f):t=await E.dialog.showOpenDialog(f),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,R.dispose)(C)}}acquireFileDialogLock(f,P){if(!P)return R.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",f);let C=this.windowFileDialogLocks.get(P.id);C||(C=new Set,this.windowFileDialogLocks.set(P.id,C));const t=(0,r.hash)(f);if(!C.has(t))return this.logService.trace("[DialogMainService]: new file dialog lock created",f),C.add(t),(0,R.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",f),C?.delete(t),C?.size===0&&this.windowFileDialogLocks.delete(P.id)})}};e.DialogMainService=w=Se([J(0,y.ILogService),J(1,p.IProductService)],w)}),define(te[276],ie([0,1,4,2,73,29]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends L.Disposable{constructor(h,c){super(),this.logService=h,this.storageMainService=c,this.onDidChangeApplicationStorageEmitter=this._register(new E.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(c.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,c){this._register(E.Event.debounce(h.onDidChangeStorage,(v,m)=>(v?v.push(m):v=[m],v),R.STORAGE_CHANGE_DEBOUNCE_TIME)(v=>{v.length&&c.fire(this.serializeStorageChangeEvents(v,h))}))}serializeStorageChangeEvents(h,c){const v=new Map,m=new Set;return h.forEach(S=>{const u=c.get(S.key);typeof u=="string"?v.set(S.key,u):m.add(S.key)}),{changed:Array.from(v.entries()),deleted:Array.from(m.values())}}listen(h,c,v){switch(c){case"onDidChangeStorage":{const m=v.profile?(0,r.revive)(v.profile):void 0;if(!m)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(m.id);return S||(S=this._register(new E.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(m),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(m.id,S)),S.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,v){const m=v.profile?(0,r.revive)(v.profile):void 0,S=(0,_.reviveIdentifier)(v.workspace),u=await this.withStorageInitialized(m,S);switch(c){case"getItems":return Array.from(u.items.entries());case"updateItems":{const y=v;if(y.insert)for(const[p,s]of y.insert)u.set(p,s);y.delete?.forEach(p=>u.delete(p));break}case"isUsed":{const y=v.payload;if(typeof y=="string")return this.storageMainService.isUsed(y)}default:throw new Error(`Call not found: ${c}`)}}async withStorageInitialized(h,c){let v;c?v=this.storageMainService.workspaceStorage(c):h?v=this.storageMainService.profileStorage(h):v=this.storageMainService.applicationStorage;try{await v.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${m}`)}return v}}e.StorageDatabaseChannel=R,R.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(te[41],ie([0,1,56,4,2,18,8,187,33,16,6,5,29,35,40,7,31,25,11]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function f(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&R.URI.isUri(i.location)&&R.URI.isUri(i.globalStorageHome)&&R.URI.isUri(i.settingsResource)&&R.URI.isUri(i.keybindingsResource)&&R.URI.isUri(i.tasksResource)&&R.URI.isUri(i.snippetsHome)&&R.URI.isUri(i.extensionsResource))}e.isUserDataProfile=f,e.IUserDataProfilesService=(0,v.createDecorator)("IUserDataProfilesService");function P(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:R.URI.revive(n.location).with({scheme:i}),globalStorageHome:R.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:R.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:R.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:R.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:R.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:R.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:R.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=P;function C(n,i,o,d,g){return{id:n,name:i,location:o,isDefault:!1,shortName:g?.shortName,globalStorageHome:(0,_.joinPath)(o,"globalStorage"),settingsResource:(0,_.joinPath)(o,"settings.json"),keybindingsResource:(0,_.joinPath)(o,"keybindings.json"),tasksResource:(0,_.joinPath)(o,"tasks.json"),snippetsHome:(0,_.joinPath)(o,"snippets"),extensionsResource:(0,_.joinPath)(o,"extensions.json"),cacheHome:(0,_.joinPath)(d,n),useDefaultFlags:g?.useDefaultFlags,isTransient:g?.transient}}e.toUserDataProfile=C;let t=e.UserDataProfilesService=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,o,d,g){super(),this.environmentService=i,this.fileService=o,this.uriIdentityService=d,this.logService=g,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,_.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,_.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=[];if(this.enabled)try{for(const D of this.getStoredProfiles()){if(!D.name||!(0,a.isString)(D.name)||!D.location){this.logService.warn("Skipping the invalid stored profile",D.location||D.name);continue}i.push(C((0,_.basename)(D.location),D.name,D.location,this.profilesCacheHome,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}))}}catch(D){this.logService.error(D)}const o=new u.ResourceMap,d=new Map,g=this.createDefaultProfile();if(i.unshift({...g,extensionsResource:this.getDefaultProfileExtensionsLocation()??g.extensionsResource,isDefault:!0}),i.length)try{const D=this.getStoredProfileAssociations();if(D.workspaces)for(const[M,b]of Object.entries(D.workspaces)){const A=R.URI.parse(M),O=i.find(F=>F.id===b);O&&o.set(A,O)}if(D.emptyWindows)for(const[M,b]of Object.entries(D.emptyWindows)){const A=i.find(O=>O.id===b);A&&d.set(M,A)}}catch(D){this.logService.error(D)}this._profilesObject={profiles:i,workspaces:o,emptyWindows:d}}return this._profilesObject}createDefaultProfile(){return C("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(i){const o="Temp",d=new RegExp(`${(0,w.escapeRegExpCharacters)(o)}\\s(\\d+)`);let g=0;for(const M of this.profiles){const b=d.exec(M.name),A=b?parseInt(b[1]):0;g=A>g?A:g}const D=`${o} ${g+1}`;return this.createProfile((0,E.hash)((0,s.generateUuid)()).toString(16),D,{transient:!0},i)}async createNamedProfile(i,o,d){return this.createProfile((0,E.hash)((0,s.generateUuid)()).toString(16),i,o,d)}async createProfile(i,o,d,g){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=await this.doCreateProfile(i,o,d);return g&&await this.setProfileForWorkspace(g,D),D}async doCreateProfile(i,o,d){if(!(0,a.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let g=this.profileCreationPromises.get(o);return g||(g=(async()=>{try{const D=this.profiles.find(A=>A.name===o||A.id===i);if(D)return D;const M=C(i,o,(0,_.joinPath)(this.profilesHome,i),this.profilesCacheHome,d);await this.fileService.createFolder(M.location);const b=[];return this._onWillCreateProfile.fire({profile:M,join(A){b.push(A)}}),await p.Promises.settled(b),this.updateProfiles([M],[],[]),M}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,g)),g}async updateProfile(i,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(g=>g.id===i.id);if(!d)throw new Error(`Profile '${i.name}' does not exist`);return d=C(d.id,o.name??d.name,d.location,this.profilesCacheHome,{shortName:o.shortName??d.shortName,transient:o.transient??d.isTransient,useDefaultFlags:o.useDefaultFlags??d.useDefaultFlags}),this.updateProfiles([],[],[d]),d}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(g=>g.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const d=[];this._onWillRemoveProfile.fire({profile:o,join(g){d.push(g)}});try{await Promise.allSettled(d)}catch(g){this.logService.error(g)}for(const g of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(g)?.id&&this.profilesObject.emptyWindows.delete(g);for(const g of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(g)?.id&&this.profilesObject.workspaces.delete(g);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(g){(0,c.toFileOperationResult)(g)!==1&&this.logService.error(g)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(g){this.logService.error(g)}}async setProfileForWorkspace(i,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(g=>g.id===o.id);if(!d)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(i,d)}unsetWorkspace(i,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(d=>!this.uriIdentityService.extUri.isEqual(d.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.getWorkspace(i);return R.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(i){return(0,S.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,S.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location)))}updateProfiles(i,o,d){const g=[...this.profiles,...i],D=[];this.transientProfilesObject.profiles=[];for(let M of g)M.isDefault||o.some(b=>M.id===b.id)||(M=d.find(b=>M.id===b.id)??M,M.isTransient?this.transientProfilesObject.profiles.push(M):D.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.saveStoredProfiles(D),this._profilesObject=void 0,this.triggerProfilesChanges(i,o,d)}triggerProfilesChanges(i,o,d){this._onDidChangeProfiles.fire({added:i,removed:o,updated:d,all:this.profiles})}updateWorkspaceAssociation(i,o,d){d=o?.isTransient?!0:d,d||this.updateWorkspaceAssociation(i,void 0,!0);const g=this.getWorkspace(i),D=d?this.transientProfilesObject:this.profilesObject;R.URI.isUri(g)?(D.workspaces.delete(g),o&&D.workspaces.set(g,o)):(D.emptyWindows.delete(g),o&&D.emptyWindows.set(g,o)),d||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[d,g]of this.profilesObject.workspaces.entries())i[d.toString()]=g.id;const o={};for(const[d,g]of this.profilesObject.emptyWindows.entries())o[d.toString()]=g.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const o={},d=this.createDefaultProfile();if(i.workspaces)for(const[D,M]of Object.entries(i.workspaces)){const b=R.URI.parse(M);o[D]=this.uriIdentityService.extUri.isEqual(b,d.location)?d.id:this.uriIdentityService.extUri.basename(b)}const g={};if(i.emptyWindows)for(const[D,M]of Object.entries(i.emptyWindows)){const b=R.URI.parse(M);g[D]=this.uriIdentityService.extUri.isEqual(b,d.location)?d.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:o,emptyWindows:g}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=t=Se([J(0,h.IEnvironmentService),J(1,c.IFileService),J(2,y.IUriIdentityService),J(3,m.ILogService)],t);class l extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=l}),define(te[81],ie([0,1,7,17,2,4,35,8,115,122,16,6,5,41,40,11,13,26]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var a;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(a||(e.ExtensionsProfileScanningErrorCode=a={}));class f extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let P=e.AbstractExtensionsProfileScannerService=class extends r.Disposable{constructor(n,i,o,d,g,D){super(),this.extensionsLocation=n,this.fileService=i,this.userDataProfilesService=o,this.uriIdentityService=d,this.telemetryService=g,this.logService=D,this._onAddExtensions=this._register(new _.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new _.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new _.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new _.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(n,i){return this.withProfileExtensions(n,void 0,i)}async addExtensionsToProfile(n,i){const o=[],d=[];try{return await this.withProfileExtensions(i,g=>{const D=[];for(const M of g)n.some(([b])=>(0,c.areSameExtensions)(b.identifier,M.identifier)&&b.manifest.version!==M.version)?o.push(M):D.push(M);for(const[M,b]of n)if(!D.some(A=>(0,c.areSameExtensions)(A.identifier,M.identifier)&&A.version===M.manifest.version)){const A={identifier:M.identifier,version:M.manifest.version,location:M.location,metadata:b};d.push(A),D.push(A)}return d.length&&this._onAddExtensions.fire({extensions:d,profileLocation:i}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:i}),D}),d.length&&this._onDidAddExtensions.fire({extensions:d,profileLocation:i}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:i}),d}catch(g){throw d.length&&this._onDidAddExtensions.fire({extensions:d,error:g,profileLocation:i}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:g,profileLocation:i}),g}}async updateMetadata(n,i){const o=[];return await this.withProfileExtensions(i,d=>{const g=[];for(const D of d){const M=n.find(([b])=>(0,c.areSameExtensions)(b.identifier,D.identifier)&&b.manifest.version===D.version);M&&(D.metadata={...D.metadata,...M[1]},o.push(D)),g.push(D)}return g}),o}async removeExtensionFromProfile(n,i){const o=[];this._onRemoveExtensions.fire({extensions:o,profileLocation:i});try{await this.withProfileExtensions(i,d=>{const g=[];for(const D of d)(0,c.areSameExtensions)(D.identifier,n.identifier)?o.push(D):g.push(D);return o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:i}),g}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:i})}catch(d){throw o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:d,profileLocation:i}),d}}async withProfileExtensions(n,i,o){return this.getResourceAccessQueue(n).queue(async()=>{let d=[],g;try{const D=await this.fileService.readFile(n);g=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,v.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(g=await this.migrateFromOldDefaultProfileExtensionsLocation()),!g&&o?.bailOutWhenFileNotFound)throw new f((0,s.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(g){Array.isArray(g)||this.reportAndThrowInvalidConentError(n);let D=!1;for(const M of g){C(M)||this.reportAndThrowInvalidConentError(n);let b;if((0,p.isString)(M.relativeLocation)&&M.relativeLocation)b=this.resolveExtensionLocation(M.relativeLocation);else if((0,p.isString)(M.location))b=this.resolveExtensionLocation(M.location),D=!0,M.relativeLocation=M.location,M.location=b.toJSON();else{b=I.URI.revive(M.location);const A=this.toRelativePath(b);A&&(D=!0,M.relativeLocation=A)}d.push({identifier:M.identifier,location:b,version:M.version,metadata:M.metadata})}D&&await this.fileService.writeFile(n,L.VSBuffer.fromString(JSON.stringify(g)))}if(i){d=i(d);const D=d.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.toRelativePath(M.location),metadata:M.metadata}));await this.fileService.writeFile(n,L.VSBuffer.fromString(JSON.stringify(D)))}return d})}reportAndThrowInvalidConentError(n){const i=new f(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let o;try{o=(await this.fileService.readFile(n)).value.toString()}catch(g){if((0,v.toFileOperationResult)(g)===1)return;throw g}this.logService.info("Migrating extensions from old default profile location",n.toString());let d;try{const g=JSON.parse(o);Array.isArray(g)&&g.every(D=>C(D))?d=g:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",g)}catch(g){this.logService.error(g)}if(d)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(d)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(g){if((0,v.toFileOperationResult)(g)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw g}try{await this.fileService.del(n)}catch(g){(0,v.toFileOperationResult)(g)!==1&&this.logService.error(g)}try{await this.fileService.del(i)}catch(g){(0,v.toFileOperationResult)(g)!==1&&this.logService.error(g)}return d})()),this._migrationPromise}getResourceAccessQueue(n){let i=this.resourcesAccessQueueMap.get(n);return i||(i=new E.Queue,this.resourcesAccessQueueMap.set(n,i)),i}};e.AbstractExtensionsProfileScannerService=P=Se([J(1,v.IFileService),J(2,u.IUserDataProfilesService),J(3,y.IUriIdentityService),J(4,w.ITelemetryService),J(5,S.ILogService)],P);function C(l){return(0,p.isObject)(l)&&(0,h.isIExtensionIdentifier)(l.identifier)&&(t(l.location)||(0,p.isString)(l.location)&&l.location)&&((0,p.isUndefined)(l.relativeLocation)||(0,p.isString)(l.relativeLocation))&&l.version&&(0,p.isString)(l.version)}function t(l){return l?(0,p.isString)(l.path)&&(0,p.isString)(l.scheme):!1}}),define(te[128],ie([0,1,24,7,37,17,13,44,149,2,14,9,3,18,203,72,11,8,170,33,122,119,202,16,6,5,23,4,73,81,41,40,201]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t,l,n,i,o,d,g,D,M,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(le){function K(V,U){if(V===U)return!0;const T=Object.keys(V),x=new Set;for(const Q of Object.keys(U))x.add(Q);if(T.length!==x.size)return!1;for(const Q of T){if(V[Q]!==U[Q])return!1;x.delete(Q)}return x.size===0}le.equals=K})(O||(e.Translations=O={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let F=e.AbstractExtensionsScannerService=class extends c.Disposable{constructor(K,V,U,T,x,Q,Z,ae,oe,N,k,W){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=V,this.extensionsControlLocation=U,this.currentProfile=T,this.userDataProfilesService=x,this.extensionsProfileScannerService=Q,this.fileService=Z,this.logService=ae,this.environmentService=oe,this.productService=N,this.uriIdentityService=k,this.instantiationService=W,this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,P.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,V,U){const[T,x]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(V)]),Q=U?await this.scanExtensionsUnderDevelopment(K,[...T,...x]):[];return this.dedupExtensions(T,x,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const V=[];V.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),V.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[U,T]=await Promise.all(V);return this.applyScanOptions([...U,...T],0,K,!1)}async scanUserExtensions(K){const V=K.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",V);const U=this.uriIdentityService.extUri.isEqual(K.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.createExtensionScannerInput(V,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,U),x=K.useCache&&!T.devMode&&T.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let Q;try{Q=await x.scanExtensions(T)}catch(Z){if(Z instanceof D.ExtensionsProfileScanningError&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),Q=await x.scanExtensions(T);else throw Z}return Q=await this.applyScanOptions(Q,1,K,!0),this.logService.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(K,V){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const U=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(T=>T.scheme===v.Schemas.file).map(async T=>{const x=await this.createExtensionScannerInput(T,!1,1,!0,K.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(x)).map(Z=>(Z.type=V.find(ae=>(0,P.areSameExtensions)(ae.identifier,Z.identifier))?.type??Z.type,this.extensionsScanner.validate(Z,x)))}))).flat();return this.applyScanOptions(U,"development",K,!0)}return[]}async scanExistingExtension(K,V,U){const T=await this.createExtensionScannerInput(K,!1,V,!0,U.language,!0,void 0),x=await this.extensionsScanner.scanExtension(T);return!x||!U.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(K,V,U){const T=await this.createExtensionScannerInput(K,!1,V,!0,U.language,!0,void 0),x=await this.extensionsScanner.scanOneOrMultipleExtensions(T);return this.applyScanOptions(x,V,U,!0)}async scanMetadata(K){const V=(0,u.joinPath)(K,"package.json"),U=(await this.fileService.readFile(V)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(K,V){const U=(0,u.joinPath)(K,"package.json"),T=(await this.fileService.readFile(U)).value.toString(),x=JSON.parse(T);V.isMachineScoped=V.isMachineScoped||void 0,V.isBuiltin=V.isBuiltin||void 0,x.__metadata={...x.__metadata,...V},await this.fileService.writeFile((0,u.joinPath)(K,"package.json"),_.VSBuffer.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof D.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw K}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.extensionsProfileScannerService.addExtensionsToProfile(K.map(V=>[V,V.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,_.VSBuffer.fromString(JSON.stringify([])))}catch(V){(0,l.toFileOperationResult)(V)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(V))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.logService.error(K)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(K,V,U,T){return U.includeAllVersions||(K=this.dedupExtensions(V===0?K:void 0,V===1?K:void 0,V==="development"?K:void 0,await this.getTargetPlatform(),T)),U.includeInvalid||(K=K.filter(x=>x.isValid)),K.sort((x,Q)=>{const Z=m.basename(x.location.fsPath),ae=m.basename(Q.location.fsPath);return Z<ae?-1:Z>ae?1:0})}dedupExtensions(K,V,U,T,x){const Q=(ae,oe,N)=>{if(ae.isValid&&!oe.isValid)return!1;if(ae.isValid===oe.isValid){if(x&&y.gt(ae.manifest.version,oe.manifest.version))return this.logService.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(y.eq(ae.manifest.version,oe.manifest.version)){if(ae.type===0)return this.logService.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===T)return this.logService.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`):this.logService.debug(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`),!0},Z=new C.ExtensionIdentifierMap;return K?.forEach(ae=>{const oe=Z.get(ae.identifier.id);(!oe||Q(oe,ae,!1))&&Z.set(ae.identifier.id,ae)}),V?.forEach(ae=>{const oe=Z.get(ae.identifier.id);if(!oe&&K&&ae.type===0){this.logService.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!oe||Q(oe,ae,!1))&&Z.set(ae.identifier.id,ae)}),U?.forEach(ae=>{const oe=Z.get(ae.identifier.id);(!oe||Q(oe,ae,!0))&&Z.set(ae.identifier.id,ae),Z.set(ae.identifier.id,ae)}),[...Z.values()]}async scanDefaultSystemExtensions(K,V){this.logService.trace("Started scanning system extensions");const U=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,V,!0,void 0),x=await(K&&!U.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(U);return this.logService.trace("Scanned system extensions:",x.length),x}async scanDevSystemExtensions(K,V){const U=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!U?.length)return[];this.logService.trace("Started scanning dev system extensions");const T=V?await this.getBuiltInExtensionControl():{},x=[],Q=w.URI.file(m.normalize(m.join(v.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of U){const oe=T[ae.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":x.push((0,u.joinPath)(Q,ae.name));break;default:x.push(w.URI.file(oe));break}}const Z=await Promise.all(x.map(async ae=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ae,!1,0,!0,K,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Z.length),(0,E.coalesce)(Z)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,V,U,T,x,Q,Z){const ae=await this.getTranslations(x??S.language),oe=await this.getMtime(K),N=V&&!this.uriIdentityService.extUri.isEqual(K,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,k=N?await this.getMtime(N):void 0;return new q(K,oe,N,k,V,Z,U,T,Q,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,x,ae)}async getMtime(K){try{const V=await this.fileService.stat(K);if(typeof V.mtime=="number")return V.mtime}catch{}}};e.AbstractExtensionsScannerService=F=Se([J(4,M.IUserDataProfilesService),J(5,D.IExtensionsProfileScannerService),J(6,l.IFileService),J(7,i.ILogService),J(8,f.IEnvironmentService),J(9,o.IProductService),J(10,b.IUriIdentityService),J(11,n.IInstantiationService)],F);class q{constructor(K,V,U,T,x,Q,Z,ae,oe,N,k,W,z,H,B){this.location=K,this.mtime=V,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=T,this.profile=x,this.profileScanOptions=Q,this.type=Z,this.excludeObsolete=ae,this.validate=oe,this.productVersion=N,this.productDate=k,this.productCommit=W,this.devMode=z,this.language=H,this.translations=B}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,V){return(0,u.isEqual)(K.location,V.location)&&K.mtime===V.mtime&&(0,u.isEqual)(K.applicationExtensionslocation,V.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===V.applicationExtensionslocationMtime&&K.profile===V.profile&&r.equals(K.profileScanOptions,V.profileScanOptions)&&K.type===V.type&&K.excludeObsolete===V.excludeObsolete&&K.validate===V.validate&&K.productVersion===V.productVersion&&K.productDate===V.productDate&&K.productCommit===V.productCommit&&K.devMode===V.devMode&&K.language===V.language&&O.equals(K.translations,V.translations)}}e.ExtensionScannerInput=q;let re=class extends c.Disposable{constructor(K,V,U,T,x){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=V,this.uriIdentityService=U,this.fileService=T,this.logService=x}async scanExtensions(K){const V=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let U={};if(K.excludeObsolete&&K.type===1)try{const T=(await this.fileService.readFile(this.obsoleteFile)).value.toString();U=JSON.parse(T)}catch{}return(0,s.isEmptyObject)(U)?V:V.filter(T=>!U[P.ExtensionKey.create(T).toString()])}async scanExtensionsFromLocation(K){const V=await this.fileService.resolve(K.location);if(!V.children?.length)return[];const U=await Promise.all(V.children.map(async T=>{if(!T.isDirectory||K.type===1&&(0,u.basename)(T.resource).indexOf(".")===0)return null;const x=new q(T.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(x)}));return(0,E.coalesce)(U).sort((T,x)=>T.location.path<x.location.path?-1:1)}async scanExtensionsFromProfile(K){let V=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){V=V.filter(T=>!T.metadata?.isApplicationScoped);const U=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,K);V.push(...U)}return V}async scanExtensionsFromProfileResource(K,V,U){const T=await this.extensionsProfileScannerService.scanProfileExtensions(K,U.profileScanOptions);if(!T.length)return[];const x=await Promise.all(T.map(async Q=>{if(V(Q)){const Z=new q(Q.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(Z,Q.metadata)}return null}));return(0,E.coalesce)(x)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,u.joinPath)(K.location,"package.json"))){const V=await this.scanExtension(K);return V?[V]:[]}else return await this.scanExtensions(K)}catch(V){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,R.getErrorMessage)(V)),[]}}async scanExtension(K,V){try{let U=await this.scanExtensionManifest(K.location);if(U){U.publisher||(U.publisher=C.UNDEFINED_PUBLISHER),V=V??U.__metadata,delete U.__metadata;const T=(0,P.getGalleryExtensionId)(U.publisher,U.name),x=V?.id?{id:T,uuid:V.id}:{id:T},Q=V?.isSystem?0:K.type,Z=Q===0||!!V?.isBuiltin;U=await this.translateManifest(K.location,U,q.createNlsConfiguration(K));const ae={type:Q,identifier:x,manifest:U,location:K.location,isBuiltin:Z,targetPlatform:V?.targetPlatform??"undefined",metadata:V,isValid:!0,validations:[]};return K.validate?this.validate(ae,K):ae}}catch(U){K.type!==0&&this.logService.error(U)}return null}validate(K,V){let U=!0;const T=(0,t.validateExtensionManifest)(V.productVersion,V.productDate,V.location,K.manifest,K.isBuiltin);for(const[x,Q]of T)x===p.default.Error&&(U=!1,this.logService.error(this.formatMessage(V.location,Q)));return K.isValid=U,K.validations=T,K}async scanExtensionManifest(K){const V=(0,u.joinPath)(K,"package.json");let U;try{U=(await this.fileService.readFile(V)).value.toString()}catch(x){return(0,l.toFileOperationResult)(x)!==1&&this.logService.error(this.formatMessage(K,(0,a.localize)(0,null,V.path,x.message))),null}let T;try{T=JSON.parse(U)}catch{const Q=[];(0,I.parse)(U,Q);for(const Z of Q)this.logService.error(this.formatMessage(K,(0,a.localize)(1,null,V.path,Z.offset,Z.length,(0,h.getParseErrorMessage)(Z.error))));return null}return(0,I.getNodeType)(T)!=="object"?(this.logService.error(this.formatMessage(K,(0,a.localize)(2,null,V.path))),null):T}async translateManifest(K,V,U){const T=await this.getLocalizedMessages(K,V,U);if(T)try{const x=[],Q=await this.resolveOriginalMessageBundle(T.default,x);if(x.length>0)return x.forEach(ae=>{this.logService.error(this.formatMessage(K,(0,a.localize)(3,null,T.default?.path,(0,h.getParseErrorMessage)(ae.error))))}),V;if((0,I.getNodeType)(T)!=="object")return this.logService.error(this.formatMessage(K,(0,a.localize)(4,null,T.default?.path))),V;const Z=T.values||Object.create(null);return(0,A.localizeManifest)(V,Z,Q)}catch{}return V}async getLocalizedMessages(K,V,U){const T=(0,u.joinPath)(K,"package.nls.json"),x=(oe,N)=>{N.forEach(k=>{this.logService.error(this.formatMessage(K,(0,a.localize)(5,null,oe?.path,(0,h.getParseErrorMessage)(k.error))))})},Q=oe=>{this.logService.error(this.formatMessage(K,(0,a.localize)(6,null,oe?.path)))},Z=`${V.publisher}.${V.name}`,ae=U.translations[Z];if(ae)try{const oe=w.URI.file(ae),N=(await this.fileService.readFile(oe)).value.toString(),k=[],W=(0,I.parse)(N,k);return k.length>0?(x(oe,k),{values:void 0,default:T}):(0,I.getNodeType)(W)!=="object"?(Q(oe),{values:void 0,default:T}):{values:W.contents?W.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.fileService.exists(T))return;let N;try{N=await this.findMessageBundles(K,U)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const k=(await this.fileService.readFile(N.localized)).value.toString(),W=[],z=(0,I.parse)(k,W);return W.length>0?(x(N.localized,W),{values:void 0,default:N.original}):(0,I.getNodeType)(z)!=="object"?(Q(N.localized),{values:void 0,default:N.original}):{values:z,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(K,V){if(K)try{const U=(await this.fileService.readFile(K)).value.toString();return(0,I.parse)(U,V)}catch{}}findMessageBundles(K,V){return new Promise((U,T)=>{const x=Q=>{const Z=(0,u.joinPath)(K,`package.nls.${Q}.json`);this.fileService.exists(Z).then(ae=>{ae&&U({localized:Z,original:(0,u.joinPath)(K,"package.nls.json")});const oe=Q.lastIndexOf("-");oe===-1?U({localized:(0,u.joinPath)(K,"package.nls.json"),original:null}):(Q=Q.substring(0,oe),x(Q))})};if(V.devMode||V.pseudo||!V.language)return U({localized:(0,u.joinPath)(K,"package.nls.json"),original:null});x(V.language)})}formatMessage(K,V){return`[${K.path}]: ${V}`}};re=Se([J(1,D.IExtensionsProfileScannerService),J(2,b.IUriIdentityService),J(3,l.IFileService),J(4,i.ILogService)],re);let Y=class extends re{constructor(K,V,U,T,x,Q,Z){super(V,T,x,Q,Z),this.currentProfile=K,this.userDataProfilesService=U,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const V=this.getCacheFile(K),U=await this.readExtensionCache(V);if(this.input=K,U&&U.input&&q.equals(U.input,this.input))return this.logService.debug("Using cached extensions scan result",K.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),U.result.map(x=>(x.location=w.URI.revive(x.location),x));const T=await super.scanExtensions(K);return await this.writeExtensionCache(V,{input:K,result:T}),T}async readExtensionCache(K){try{const V=await this.fileService.readFile(K),U=JSON.parse(V.value.toString());return{result:U.result,input:(0,g.revive)(U.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",K.path,(0,R.getErrorMessage)(V))}return null}async writeExtensionCache(K,V){try{await this.fileService.writeFile(K,_.VSBuffer.fromString(JSON.stringify(V)))}catch(U){this.logService.debug("Error while writing the extension cache file:",K.path,(0,R.getErrorMessage)(U))}}async validateCache(){if(!this.input)return;const K=this.getCacheFile(this.input),V=await this.readExtensionCache(K);if(!V)return;const U=V.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(T,U))try{this.logService.info("Invalidating Cache",U,T),await this.fileService.del(K),this._onDidChangeCache.fire()}catch(x){this.logService.error(x)}}getCacheFile(K){const V=this.getProfile(K);return this.uriIdentityService.extUri.joinPath(V.cacheHome,K.type===0?C.BUILTIN_MANIFEST_CACHE_FILE:C.USER_MANIFEST_CACHE_FILE)}getProfile(K){return K.type===0?this.userDataProfilesService.defaultProfile:K.profile?this.uriIdentityService.extUri.isEqual(K.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(V=>this.uriIdentityService.extUri.isEqual(K.location,V.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};Y=Se([J(2,M.IUserDataProfilesService),J(3,D.IExtensionsProfileScannerService),J(4,b.IUriIdentityService),J(5,l.IFileService),J(6,i.ILogService)],Y);function ne(le,K){const V=(0,P.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:V,identifier:new C.ExtensionIdentifier(V),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=ne;class ce extends F{constructor(K,V,U,T,x,Q,Z,ae,oe,N,k,W){super(K,V,(0,u.joinPath)(U,".vscode-oss-dev","extensions","control.json"),T,x,Q,Z,ae,oe,N,k,W),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const z=await this.fileService.readFile(w.URI.file(S.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(te[277],ie([0,1,5,41,40,26,81,16,33,8]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let v=e.ExtensionsProfileScannerService=class extends R.AbstractExtensionsProfileScannerService{constructor(S,u,y,p,s,w){super(c.URI.file(S.extensionsPath),u,y,p,s,w)}};e.ExtensionsProfileScannerService=v=Se([J(0,h.INativeEnvironmentService),J(1,I.IFileService),J(2,L.IUserDataProfilesService),J(3,r.IUriIdentityService),J(4,_.ITelemetryService),J(5,E.ILogService)],v)}),define(te[278],ie([0,1,8,33,81,128,16,6,5,23,40,41]),function(j,e,E,L,r,_,R,I,h,c,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=e.ExtensionsScannerService=class extends _.NativeExtensionsScannerService{constructor(y,p,s,w,a,f,P,C){super(E.URI.file(a.builtinExtensionsPath),E.URI.file(a.extensionsPath),a.userHome,y.defaultProfile,y,p,s,w,a,f,P,C)}};e.ExtensionsScannerService=S=Se([J(0,m.IUserDataProfilesService),J(1,r.IExtensionsProfileScannerService),J(2,R.IFileService),J(3,h.ILogService),J(4,L.INativeEnvironmentService),J(5,c.IProductService),J(6,v.IUriIdentityService),J(7,I.IInstantiationService)],S)}),define(te[279],ie([0,1,15,2,14,9,3,62,8,31,38,33,5,41]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=e.ProtocolMainService=class extends L.Disposable{constructor(s,w,a){super(),this.environmentService=s,this.logService=a,this.validRoots=I.TernarySearchTree.forPaths(!R.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(s.appRoot),this.addValidFileRoot(s.extensionsPath),this.addValidFileRoot(w.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(s.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:s}=E.session;s.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(w,a)=>this.handleResourceRequest(w,a)),s.protocol.interceptFileProtocol(r.Schemas.file,(w,a)=>this.handleFileRequest(w,a)),this._register((0,L.toDisposable)(()=>{s.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),s.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(s){const w=(0,_.normalize)(s);return this.validRoots.get(w)?L.Disposable.None:(this.validRoots.set(w,!0),(0,L.toDisposable)(()=>this.validRoots.delete(w)))}handleFileRequest(s,w){const a=h.URI.parse(s.url);return this.logService.error(`Refused to load resource ${a.fsPath} from ${r.Schemas.file}: protocol (original URL: ${s.url})`),w({error:-3})}handleResourceRequest(s,w){const a=this.requestToNormalizedFilePath(s);let f;return this.environmentService.crossOriginIsolated&&((0,_.basename)(a)==="workbench.html"||(0,_.basename)(a)==="workbench-dev.html"?f=r.COI.CoopAndCoep:f=r.COI.getHeadersFromQuery(s.url)),this.validRoots.findSubstr(a)?w({path:a,headers:f}):this.validExtensions.has((0,_.extname)(a).toLowerCase())?w({path:a}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${a} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${s.url})`),w({error:-3}))}requestToNormalizedFilePath(s){const w=h.URI.parse(s.url),a=r.FileAccess.uriToFileUri(w);return(0,_.normalize)(a.fsPath)}createIPCObjectUrl(){let s;const w=h.URI.from({scheme:"vscode",path:(0,c.generateUuid)()}),a=w.toString(),f=async()=>s;return v.validatedIpcMain.handle(a,f),this.logService.trace(`IPC Object URL: Registered new channel ${a}.`),{resource:w,update:P=>s=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${a}.`),v.validatedIpcMain.removeHandler(a)}}}};e.ProtocolMainService=y=Se([J(0,m.INativeEnvironmentService),J(1,u.IUserDataProfilesService),J(2,S.ILogService)],y)}),define(te[95],ie([0,1,7,4,2,65,11,110,6,41]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var v;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(v||(e.WillSaveStateReason=v={}));var m;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var S;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function u(a){const f=a.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=u;class y extends r.Disposable{constructor(f={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new E.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,E.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,P){if(P===e.TARGET_KEY){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:P,target:this.getKeyTargets(f)[P]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,P,C){return this.getStorage(P)?.get(f,C)}getBoolean(f,P,C){return this.getStorage(P)?.getBoolean(f,C)}getNumber(f,P,C){return this.getStorage(P)?.getNumber(f,C)}getObject(f,P,C){return this.getStorage(P)?.getObject(f,C)}store(f,P,C,t){if((0,R.isUndefinedOrNull)(P)){this.remove(f,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,C,t),this.getStorage(C)?.set(f,P)})}remove(f,P){this.withPausedEmitters(()=>{this.updateKeyTarget(f,P,void 0),this.getStorage(P)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,P){const C=[],t=this.getKeyTargets(f);for(const l of Object.keys(t))t[l]===P&&C.push(l);return C}updateKeyTarget(f,P,C){const t=this.getKeyTargets(P);typeof C=="number"?t[f]!==C&&(t[f]=C,this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[f]=="number"&&(delete t[f],this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const P=this.getStorage(f);return P?u(P):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=v.NONE){this._onWillSaveState.fire({reason:f});const P=this.getStorage(-1),C=this.getStorage(0),t=this.getStorage(1);switch(f){case v.NONE:await E.Promises.settled([P?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await E.Promises.settled([P?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,P=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return w(f,P,C,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,P){return this.emitWillSaveState(v.NONE),(0,c.isUserDataProfile)(f)?this.switchToProfile(f,P):this.switchToWorkspace(f,P)}canSwitchProfile(f,P){return!(f.id===P.id||p(P)&&p(f))}switchData(f,P,C,t){this.withPausedEmitters(()=>{if(t)for(const[l,n]of f)P.set(l,n);else{const l=new Set;for(const[n,i]of f)l.add(n),P.get(n)!==i&&this.emitDidChangeValue(C,n);for(const[n]of P.items)l.has(n)||this.emitDidChangeValue(C,n)}})}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;function p(a){return a.isDefault||!!a.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class s extends y{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(f){return!1}}e.InMemoryStorageService=s;async function w(a,f,P,C,t,l){const n=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,o=new Map;a.forEach((O,F)=>{i.set(F,O),o.set(F,n(O))});const d=new Map,g=new Map;f.forEach((O,F)=>{d.set(F,O),g.set(F,n(O))});const D=new Map,M=new Map;P.forEach((O,F)=>{D.set(F,O),M.set(F,n(O))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const b=[];if(i.forEach((O,F)=>{b.push({key:F,value:O})}),console.table(b),console.groupEnd(),console.log(o),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const O=[];d.forEach((F,q)=>{O.push({key:q,value:F})}),console.table(O),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${l})`);const A=[];D.forEach((O,F)=>{A.push({key:F,value:O})}),console.table(A),console.groupEnd(),console.log(M)}e.logStorage=w}),define(te[280],ie([0,1,24,7,4,2,9,85,8,22,110,159,5,95,26,29]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class s extends _.Disposable{get storage(){return this._storage}constructor(l,n){super(),this.logService=l,this.fileService=n,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=v.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===v.StorageState.None)try{const l=await this.doCreate();this._storage.dispose(),this._storage=l,this._register(l.onDidChangeStorage(i=>this._onDidChangeStorage.fire({key:i}))),await this.doInit(l);const n=l.getBoolean(u.IS_NEW_KEY);n===void 0?l.set(u.IS_NEW_KEY,!0):n&&l.set(u.IS_NEW_KEY,!1)}catch(l){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${l}`)}finally{this.state=v.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?l=>this.logService.trace(l):void 0,logError:l=>this.logService.error(l)}}doInit(l){return l.init()}get items(){return this._storage.items}get(l,n){return this._storage.get(l,n)}set(l,n){return this._storage.set(l,n)}delete(l){return this._storage.delete(l)}async close(){const l=new I.StopWatch(!1);await this.doClose(),l.stop(),l.elapsed()>s.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(l),this._onDidCloseStorage.fire()}async logSlowClose(l){if(this.path)try{const n=(0,E.top)(Array.from(this._storage.items.entries()).map(([o,d])=>({key:o,length:d.length})),(o,d)=>d.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),i=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${l.elapsed()}ms, DB size: ${i}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=v.StorageState.Closed,await this._storage.close()}}s.LOG_SLOW_CLOSE_THRESHOLD=2e3;class w extends s{get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.profile.globalStorageHome.fsPath,w.STORAGE_NAME)}constructor(l,n,i,o){super(i,o),this.profile=l,this.options=n}async doCreate(){return new v.Storage(new m.SQLiteStorageDatabase(this.path??m.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:v.StorageHint.STORAGE_IN_MEMORY})}}w.STORAGE_NAME="state.vscdb";class a extends w{constructor(l,n,i,o){super(l,n,i,o)}}e.ProfileStorageMain=a;class f extends w{constructor(l,n,i,o){super(n.defaultProfile,l,i,o)}async doInit(l){await super.doInit(l),this.updateTelemetryState(l)}updateTelemetryState(l){l.get(y.firstSessionDateStorageKey,void 0)===void 0&&l.set(y.firstSessionDateStorageKey,new Date().toUTCString());const i=l.get(y.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();l.set(y.lastSessionDateStorageKey,typeof i>"u"?null:i),l.set(y.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=f;class P extends s{get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,P.WORKSPACE_STORAGE_NAME)}constructor(l,n,i,o,d){super(i,d),this.workspace=l,this.options=n,this.environmentService=o}async doCreate(){const{storageFilePath:l,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new v.Storage(new m.SQLiteStorageDatabase(l,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?v.StorageHint.STORAGE_IN_MEMORY:n?v.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:m.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const l=(0,R.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,R.join)(l,P.WORKSPACE_STORAGE_NAME);return await c.Promises.exists(l)?{storageFilePath:n,wasCreated:!1}:(await c.Promises.mkdir(l,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(l),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(l){let n;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const i=(0,R.join)(l,P.WORKSPACE_META_NAME);await c.Promises.exists(i)||await c.Promises.writeFile(i,JSON.stringify(n,void 0,2))}catch(i){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.WorkspaceStorageMain=P,P.WORKSPACE_STORAGE_NAME="state.vscdb",P.WORKSPACE_META_NAME="workspace.json";class C extends s{get path(){}async doCreate(){return new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=C}),define(te[281],ie([0,1,4,2,95]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class _ extends L.Disposable{constructor(I,h,c){super(),this.storageMainService=I,this.userDataProfilesService=h,this.logService=c;const v=this._register(new L.MutableDisposable);this._onDidChange=this._register(new E.Emitter({onWillAddFirstListener:()=>v.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>v.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new L.DisposableStore;return I.add(E.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.onDidChangeApplicationStorage(h))),I.add(E.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let v=h.get(c.profile.id);return v||h.set(c.profile.id,v={profile:c.profile,keys:[],storage:c.storage}),v.keys.push(c.key),h},100)(h=>this.onDidChangeProfileStorage(h))),I}onDidChangeApplicationStorage(I){const h=I.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],c=[];if(I=I.filter(v=>v!==r.TARGET_KEY),I.length){const v=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);c.push({profile:this.userDataProfilesService.defaultProfile,changes:I.map(m=>({key:m,scope:0,target:v[m]}))})}this.triggerEvents(h,c)}onDidChangeProfileStorage(I){const h=[],c=new Map;for(const[v,m]of I.entries()){m.keys.includes(r.TARGET_KEY)&&h.push(m.profile);const S=m.keys.filter(u=>u!==r.TARGET_KEY);if(S.length){const u=(0,r.loadKeyTargets)(m.storage.storage);c.set(v,{profile:m.profile,changes:S.map(y=>({key:y,scope:0,target:u[y]}))})}}this.triggerEvents(h,[...c.values()])}triggerEvents(I,h){(I.length||h.length)&&this._onDidChange.fire({valueChanges:h,targetChanges:I})}listen(I,h,c){switch(h){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${h}`)}async call(I,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=_}),define(te[282],ie([0,1,8,33,16,5,34,40,41,11,120]),function(j,e,E,L,r,_,R,I,h,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let m=e.UserDataProfilesReadonlyService=class ht extends h.UserDataProfilesService{constructor(p,s,w,a,f){super(w,a,s,f),this.stateReadonlyService=p,this.nativeEnvironmentService=w}getStoredProfiles(){return this.stateReadonlyService.getItem(ht.PROFILES_KEY,[]).map(s=>({...s,location:(0,c.isString)(s.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,s.location):E.URI.revive(s.location)}))}getStoredProfileAssociations(){const p=this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?p:this.migrateStoredProfileAssociations(p)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(E.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",e.UserDataProfilesReadonlyService=m=Se([J(0,R.IStateReadService),J(1,I.IUriIdentityService),J(2,L.INativeEnvironmentService),J(3,r.IFileService),J(4,_.ILogService)],m);let S=e.UserDataProfilesService=class st extends m{constructor(p,s,w,a,f){super(p,s,w,a,f),this.stateService=p}saveStoredProfiles(p){p.length?this.stateService.setItem(st.PROFILES_KEY,p.map(s=>({...s,location:this.uriIdentityService.extUri.basename(s.location)}))):this.stateService.removeItem(st.PROFILES_KEY)}getStoredProfiles(){const p=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(p),this.stateService.setItem("userDataProfilesMigration",!0)),p}saveStoredProfileAssociations(p){p.emptyWindows||p.workspaces?this.stateService.setItem(st.PROFILE_ASSOCIATIONS_KEY,p):this.stateService.removeItem(st.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const p="workspaceAndProfileInfo",s=this.stateService.getItem(p,void 0);if(s){this.stateService.removeItem(p);const a=s.reduce((f,{workspace:P,profile:C})=>(f[E.URI.revive(P).toString()]=E.URI.revive(C).toString(),f),{});this.stateService.setItem(st.PROFILE_ASSOCIATIONS_KEY,{workspaces:a})}const w=super.getStoredProfileAssociations();return this.stateService.getItem(st.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(w),this.stateService.setItem(st.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),w}};e.UserDataProfilesService=S=Se([J(0,R.IStateService),J(1,I.IUriIdentityService),J(2,L.INativeEnvironmentService),J(3,r.IFileService),J(4,_.ILogService)],S);let u=e.ServerUserDataProfilesService=class extends S{constructor(p,s,w,a){super(new v.StateService(0,s,a,w),p,s,w,a)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=u=Se([J(0,I.IUriIdentityService),J(1,L.INativeEnvironmentService),J(2,r.IFileService),J(3,_.ILogService)],u)}),define(te[53],ie([0,1,33,16,6,5,40,41,282,34]),function(j,e,E,L,r,_,R,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(I.IUserDataProfilesService);let v=e.UserDataProfilesMainService=class extends h.UserDataProfilesService{constructor(S,u,y,p,s){super(S,u,y,p,s)}getAssociatedEmptyWindows(){const S=[];for(const u of this.profilesObject.emptyWindows.keys())S.push({id:u});return S}};e.UserDataProfilesMainService=v=Se([J(0,c.IStateService),J(1,R.IUriIdentityService),J(2,E.INativeEnvironmentService),J(3,L.IFileService),J(4,_.ILogService)],v)}),define(te[129],ie([0,1,18,8,29]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function _(h,c,v){for(const S of h){const u=S.openedWorkspace;if((0,r.isWorkspaceIdentifier)(u)){const y=await v(u);if(y){if(y.folders.some(p=>E.extUriBiasedIgnorePathCase.isEqualOrParent(c,p.uri)))return S}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(c,u.configPath))return S}}const m=h.filter(S=>(0,r.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(c,S.openedWorkspace.uri));if(m.length)return m.sort((S,u)=>-(S.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=_;function R(h,c){for(const v of h)if((0,r.isWorkspaceIdentifier)(v.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.configPath,c)||(0,r.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.uri,c))return v}e.findWindowOnWorkspaceOrFolder=R;function I(h,c){const v=m=>c.some(S=>E.extUriBiasedIgnorePathCase.isEqual(L.URI.file(S),L.URI.file(m)));for(const m of h)if(m.config?.extensionDevelopmentPath?.some(S=>v(S)))return m}e.findWindowOnExtensionDevelopmentPath=I}),define(te[96],ie([0,1,32,44,136,45,14,9,3,18,8,6,58,29]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function y(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function p(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=p;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function w(M){return a(M)||f(M)}e.isStoredWorkspaceFolder=w;function a(M){const b=M;return typeof b?.path=="string"&&(!b.name||typeof b.name=="string")}function f(M){const b=M;return typeof b?.uri=="string"&&(!b.name||typeof b.name=="string")}function P(M,b,A,O,F){if(M.scheme!==O.scheme)return{name:A,uri:M.toString(!0)};let q=b?void 0:F.relativePath(O,M);if(q!==void 0)q.length===0?q=".":h.isWindows&&(q=C(q));else if(M.scheme===R.Schemas.file)q=M.fsPath,h.isWindows&&(q=C(q));else if(F.isEqualAuthority(M.authority,O.authority))q=M.path;else return{name:A,uri:M.toString(!0)};return{name:A,path:q}}e.getStoredWorkspaceFolder=P;function C(M){return M=(0,_.normalizeDriveLetter)(M),(0,E.isUNC)(M)||(M=(0,E.toSlashes)(M)),M}function t(M,b,A){const O=[],F=new Set,q=A.dirname(b);for(const re of M){let Y;if(a(re))re.path&&(Y=A.resolvePath(q,re.path));else if(f(re))try{Y=v.URI.parse(re.uri),Y.path[0]!==I.posix.sep&&(Y=Y.with({path:I.posix.sep+Y.path}))}catch(ne){console.warn(ne)}if(Y){const ne=A.getComparisonKey(Y);if(!F.has(ne)){F.add(ne);const ce=re.name||A.basenameOrAuthority(Y);O.push(new u.WorkspaceFolder({uri:Y,name:ce,index:O.length},re))}}}return O}e.toWorkspaceFolders=t;function l(M,b,A,O,F){const q=n(b,M),re=F.dirname(b),Y=F.dirname(O),ne=[];for(const V of q.folders){const U=a(V)?F.resolvePath(re,V.path):v.URI.parse(V.uri);let T;A?T=!1:T=!a(V)||(0,I.isAbsolute)(V.path),ne.push(P(U,T,V.name,Y,F))}const ce={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},le=r.setProperty(M,["folders"],ne,ce);let K=r.applyEdits(M,le);return(0,c.isEqualAuthority)(q.remoteAuthority,(0,S.getRemoteAuthority)(O))&&(K=r.applyEdits(K,r.removeProperty(K,["remoteAuthority"],ce))),K}e.rewriteWorkspaceFileForNewLocation=l;function n(M,b){const A=L.parse(b);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(O=>w(O));else throw new Error(`${M} looks like an invalid workspace file.`);return A}function i(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function d(M){return typeof M.fileUri=="string"}function g(M,b){const A={workspaces:[],files:[]};if(M){const O=function(q,re){for(let Y=0;Y<q.length;Y++)try{re(q[Y],Y)}catch(ne){b.warn(`Error restoring recent entry ${JSON.stringify(q[Y])}: ${ne.toString()}. Skip entry.`)}},F=M;Array.isArray(F.entries)&&O(F.entries,q=>{const re=q.label,Y=q.remoteAuthority;i(q)?A.workspaces.push({label:re,remoteAuthority:Y,workspace:{id:q.workspace.id,configPath:v.URI.parse(q.workspace.configPath)}}):o(q)?A.workspaces.push({label:re,remoteAuthority:Y,folderUri:v.URI.parse(q.folderUri)}):d(q)&&A.files.push({label:re,remoteAuthority:Y,fileUri:v.URI.parse(q.fileUri)})})}return A}e.restoreRecentlyOpened=g;function D(M){const b={entries:[]};for(const A of M.workspaces)p(A)?b.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):b.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of M.files)b.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return b}e.toStoreData=D}),define(te[97],ie([0,1,70,14,3,18]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(c){function v(){let m=c.scheme===L.Schemas.file?(0,_.originalFSPath)(c):c.toString();return r.isLinux||(m=m.toLowerCase()),(0,E.createHash)("md5").update(m).digest("hex")}return{id:v(),configPath:c}}e.getWorkspaceIdentifier=R;function I(c,v){function m(){if(c.scheme!==L.Schemas.file)return(0,E.createHash)("md5").update(c.toString()).digest("hex");if(!v)return;let u;return r.isLinux?u=v.ino:r.isMacintosh?u=v.birthtime.getTime():r.isWindows&&(typeof v.birthtimeMs=="number"?u=Math.floor(v.birthtimeMs):u=v.birthtime.getTime()),(0,E.createHash)("md5").update(c.fsPath).update(u?String(u):"").digest("hex")}const S=m();if(typeof S=="string")return{id:S,uri:c}}e.getSingleFolderWorkspaceIdentifier=I;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=h}),define(te[130],ie([0,1,70,84,27,283,17,13,4,2,9,3,31,43,108]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(b,A){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,A)}constructor(b,A=""){this._canWrite=!0,this.debugLabel=A,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,I.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener),this._closeListener=O=>{this.traceSocketEvent("close",{hadError:O}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(b){const A=O=>{this.traceSocketEvent("read",O),b(R.VSBuffer.wrap(O))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(b){const A=O=>{b({type:0,hadError:O,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(b){const A=()=>{b()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(b){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,I.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,I.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=p;var s;(function(M){M[M.MinHeaderByteSize=2]="MinHeaderByteSize",M[M.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var w;(function(M){M[M.PeekHeader=1]="PeekHeader",M[M.ReadHeader=2]="ReadHeader",M[M.ReadBody=3]="ReadBody",M[M.Fin=4]="Fin"})(w||(w={}));class a extends c.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,A){this.socket.traceSocketEvent(b,A)}constructor(b,A,O,F){super(),this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new f(this,A,O,F,this._onData,(q,re)=>this._write(q,re))),this._register(this._flowManager.onError(q=>{console.error(q),(0,I.onUnexpectedError)(q),this._onClose.fire({type:0,hadError:!0,error:q})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(async q=>{this._flowManager.isProcessingReadQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(q)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let A=0;for(;A<b.byteLength;)this._flowManager.writeMessage(b.slice(A,Math.min(A+262144,b.byteLength))),A+=262144}_write(b,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let O=2;b.byteLength<126?O+=0:b.byteLength<2**16?O+=2:O+=8;const F=R.VSBuffer.alloc(O);if(A?F.writeUInt8(194,0):F.writeUInt8(130,0),b.byteLength<126)F.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){F.writeUInt8(126,1);let q=1;F.writeUInt8(b.byteLength>>>8&255,++q),F.writeUInt8(b.byteLength>>>0&255,++q)}else{F.writeUInt8(127,1);let q=1;F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(b.byteLength>>>24&255,++q),F.writeUInt8(b.byteLength>>>16&255,++q),F.writeUInt8(b.byteLength>>>8&255,++q),F.writeUInt8(b.byteLength>>>0&255,++q)}this.socket.write(R.VSBuffer.concat([F,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),O=A.readUInt8(0),F=(O&128)>>>7,q=(O&64)>>>6,re=A.readUInt8(1),Y=(re&128)>>>7,ne=re&127;this._state.state=2,this._state.readLen=2+(Y?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!q),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),O=A.readUInt8(1),F=(O&128)>>>7;let q=O&127,re=1;q===126?q=A.readUInt8(++re)*2**8+A.readUInt8(++re):q===127&&(q=A.readUInt8(++re)*0+A.readUInt8(++re)*0+A.readUInt8(++re)*0+A.readUInt8(++re)*0+A.readUInt8(++re)*2**24+A.readUInt8(++re)*2**16+A.readUInt8(++re)*2**8+A.readUInt8(++re));let Y=0;F&&(Y=A.readUInt8(++re)*2**24+A.readUInt8(++re)*2**16+A.readUInt8(++re)*2**8+A.readUInt8(++re)),this._state.state=3,this._state.readLen=q,this._state.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=a;class f extends c.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(b,A,O,F,q,re){super(),this._tracer=b,this._onData=q,this._writeFn=re,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new h.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new P(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new C(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Y=>this._onError.fire(Y))),this._register(this._zlibDeflateStream.onError(Y=>this._onError.fire(Y)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(b){this._writeQueue.push(b),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const b=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(A,!0)}else this._writeFn(b,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,A){return new Promise((O,F)=>{b.write(A),b.flush(q=>O(q))})}acceptFrame(b,A,O){this._readQueue.push({data:b,isCompressed:A,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(b,A,O){return new Promise((F,q)=>{b.write(A),O&&b.write(R.VSBuffer.fromByteArray([0,0,255,255])),b.flush(re=>F(re))})}}class P extends c.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(b,A,O,F){super(),this._tracer=b,this._recordInflateBytes=A,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,_.createInflateRaw)(F),this._zlibInflate.on("error",q=>{this._tracer.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this._onError.fire(q)}),this._zlibInflate.on("data",q=>{this._tracer.traceSocketEvent("zlibInflateData",q),this._pendingInflateData.push(R.VSBuffer.wrap(q))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(A)})}}class C extends c.Disposable{constructor(b,A){super(),this._tracer=b,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,_.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(R.VSBuffer.wrap(O))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),b(A)})}}function t(M,b){if(b===0)return;const A=M.byteLength>>>2;for(let ne=0;ne<A;ne++){const ce=M.readUInt32BE(ne*4);M.writeUInt32BE(ce^b,ne*4)}const O=A*4,F=M.byteLength-O,q=b>>>24&255,re=b>>>16&255,Y=b>>>8&255;F>=1&&M.writeUInt8(M.readUInt8(O)^q,O),F>=2&&M.writeUInt8(M.readUInt8(O+1)^re,O+1),F>=3&&M.writeUInt8(M.readUInt8(O+2)^Y,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function n(){const M=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${M}-sock`;const b=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),A=(0,v.join)(b,`vscode-ipc-${M}.sock`);return o(A),A}e.createRandomIPCHandle=n;function i(M,b,A){const O=(0,E.createHash)("md5").update(M).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${A}-${b}-sock`;const F=A.substr(0,4),q=b.substr(0,6),re=O.substr(0,8);let Y;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Y=(0,v.join)(e.XDG_RUNTIME_DIR,`vscode-${re}-${F}-${q}.sock`):Y=(0,v.join)(M,`${F}-${q}.sock`),o(Y),Y}e.createStaticIPCHandle=i;function o(M){const b=l[m.platform];typeof b=="number"&&M.length>=b&&console.warn(`WARNING: IPC handle "${M}" is longer than ${b} chars, try a shorter --user-data-dir`)}class d extends u.IPCServer{static toClientConnectionEvent(b){const A=h.Event.fromNodeEventEmitter(b,"connection");return h.Event.map(A,O=>({protocol:new y.Protocol(new p(O,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(O,"close"))}))}constructor(b){super(d.toClientConnectionEvent(b)),this.server=b}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function g(M){return new Promise((b,A)=>{const O=(0,L.createServer)();O.on("error",A),O.listen(M,()=>{O.removeListener("error",A),b(new d(O))})})}e.serve=g;function D(M,b){return new Promise((A,O)=>{const F=(0,L.createConnection)(M,()=>{F.removeListener("error",O),A(y.Client.fromSocket(new p(F,`ipc-client${b}`),b))});F.once("error",O)})}e.connect=D}),define(te[30],ie([0,1,55,9,130,33,88,6]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(_.IEnvironmentService);class h extends R.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}e.EnvironmentMainService=h,Se([E.memoize],h.prototype,"cachedLanguagesPath",null),Se([E.memoize],h.prototype,"backupHome",null),Se([E.memoize],h.prototype,"mainIPCHandle",null),Se([E.memoize],h.prototype,"mainLockfile",null),Se([E.memoize],h.prototype,"disableUpdates",null),Se([E.memoize],h.prototype,"disableKeytar",null),Se([E.memoize],h.prototype,"crossOriginIsolated",null),Se([E.memoize],h.prototype,"codeCachePath",null),Se([E.memoize],h.prototype,"useCodeCache",null)}),define(te[284],ie([0,1,70,32,14,9,3,18,22,194,19,30,34,16,5,193,29,97]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let a=e.BackupMainService=class wt{constructor(P,C,t,l){this.environmentMainService=P,this.configurationService=C,this.logService=t,this.stateService=l,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,i)=>(0,L.isEqual)(n,i,!R.isLinux)}}async initialize(){const P=this.stateService.getItem(wt.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(P.emptyWindows),this.workspaces=await this.validateWorkspaces((0,c.deserializeWorkspaceInfos)(P)),this.folders=await this.validateFolders((0,c.deserializeFolderInfos)(P)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(P,C){this.workspaces.some(l=>P.workspace.id===l.workspace.id)||(this.workspaces.push(P),this.storeWorkspacesMetadata());const t=(0,_.join)(this.backupHome,P.workspace.id);return C?this.moveBackupFolder(t,C).then(()=>t):t}async moveBackupFolder(P,C){if(await h.Promises.exists(P)&&await this.convertToEmptyWindowBackup(P),await h.Promises.exists(C))try{await h.Promises.rename(C,P)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(P){return this.folders.some(C=>this.backupUriComparer.isEqual(P.folderUri,C.folderUri))||(this.folders.push(P),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,this.getFolderHash(P))}registerEmptyWindowBackup(P){return this.emptyWindows.some(C=>!!C.backupFolder&&this.backupPathComparer.isEqual(C.backupFolder,P.backupFolder))||(this.emptyWindows.push(P),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,P.backupFolder)}async validateWorkspaces(P){if(!Array.isArray(P))return[];const C=new Set,t=[];for(const l of P){const n=l.workspace;if(!(0,s.isWorkspaceIdentifier)(n))return[];if(!C.has(n.id)){C.add(n.id);const i=(0,_.join)(this.backupHome,n.id);await this.doHasBackups(i)?n.configPath.scheme!==r.Schemas.file||await h.Promises.exists(n.configPath.fsPath)?t.push(l):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return t}async validateFolders(P){if(!Array.isArray(P))return[];const C=[],t=new Set;for(const l of P){const n=l.folderUri,i=this.backupUriComparer.getComparisonKey(n);if(!t.has(i)){t.add(i);const o=(0,_.join)(this.backupHome,this.getFolderHash(l));await this.doHasBackups(o)?n.scheme!==r.Schemas.file||await h.Promises.exists(n.fsPath)?C.push(l):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return C}async validateEmptyWorkspaces(P){if(!Array.isArray(P))return[];const C=[],t=new Set;for(const l of P){const n=l.backupFolder;if(typeof n!="string")return[];if(!t.has(n)){t.add(n);const i=(0,_.join)(this.backupHome,n);await this.doHasBackups(i)?C.push(l):await this.deleteStaleBackup(i)}}return C}async deleteStaleBackup(P){try{await h.Promises.rm(P,h.RimRafMode.MOVE)}catch(C){this.logService.error(`Backup: Could not delete stale backup: ${C.toString()}`)}}prepareNewEmptyWindowBackup(){let P=(0,w.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(C=>!!C.backupFolder&&this.backupPathComparer.isEqual(C.backupFolder,P.id));)P=(0,w.createEmptyWorkspaceIdentifier)();return{backupFolder:P.id}}async convertToEmptyWindowBackup(P){const C=this.prepareNewEmptyWindowBackup(),t=(0,_.join)(this.backupHome,C.backupFolder);try{await h.Promises.rename(P,t)}catch(l){return this.logService.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.emptyWindows.push(C),!0}async getDirtyWorkspaces(){const P=[];for(const C of this.workspaces)await this.hasBackups(C)&&P.push(C);for(const C of this.folders)await this.hasBackups(C)&&P.push(C);return P}hasBackups(P){let C;return(0,c.isEmptyWindowBackupInfo)(P)?C=(0,_.join)(this.backupHome,P.backupFolder):(0,p.isFolderBackupInfo)(P)?C=(0,_.join)(this.backupHome,this.getFolderHash(P)):C=(0,_.join)(this.backupHome,P.workspace.id),this.doHasBackups(C)}async doHasBackups(P){try{const C=await h.Promises.readdir(P);for(const t of C)try{if((await h.Promises.readdir((0,_.join)(P,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const P={workspaces:this.workspaces.map(({workspace:C,remoteAuthority:t})=>{const l={id:C.id,configURIPath:C.configPath.toString()};return t&&(l.remoteAuthority=t),l}),folders:this.folders.map(({folderUri:C,remoteAuthority:t})=>{const l={folderUri:C.toString()};return t&&(l.remoteAuthority=t),l}),emptyWindows:this.emptyWindows.map(({backupFolder:C,remoteAuthority:t})=>{const l={backupFolder:C};return t&&(l.remoteAuthority=t),l})};this.stateService.setItem(wt.backupWorkspacesMetadataStorageKey,P)}getFolderHash(P){const C=P.folderUri;let t;return C.scheme===r.Schemas.file?t=R.isLinux?C.fsPath:C.fsPath.toLowerCase():t=C.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};a.backupWorkspacesMetadataStorageKey="backupWorkspaces",e.BackupMainService=a=Se([J(0,m.IEnvironmentMainService),J(1,v.IConfigurationService),J(2,y.ILogService),J(3,S.IStateService)],a)}),define(te[20],ie([0,1,15,38,7,4,2,3,36,11,6,5,34,30]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,v.createDecorator)("lifecycleMainService");var y;(function(w){w[w.QUIT=1]="QUIT",w[w.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var p;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen",w[w.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let s=e.LifecycleMainService=class ft extends R.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(a,f,P){super(),this.logService=a,this.stateService=f,this.environmentMainService=P,this._onBeforeShutdown=this._register(new _.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new _.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new _.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new _.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(ft.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(ft.QUIT_AND_RESTART_KEY)}registerListeners(){const a=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};E.app.addListener("before-quit",a);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",f),E.app.once("will-quit",P=>{this.trace("Lifecycle#app.on(will-quit) - begin"),P.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),E.app.removeListener("before-quit",a),E.app.removeListener("window-all-closed",f),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}fireOnWillShutdown(a){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const f=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({reason:a,join(C,t){f.trace(`Lifecycle#onWillShutdown - begin '${C}'`),P.push(t.finally(()=>{f.trace(`Lifecycle#onWillShutdown - end '${C}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(P)}catch(C){this.logService.error(C)}try{await this.stateService.close()}catch(C){this.logService.error(C)}})(),this.pendingWillShutdownPromise}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===a)return;this.trace(`lifecycle (main): phase changed (value: ${a})`),this._phase=a;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(a){if(a<=this._phase)return;let f=this.phaseWhen.get(a);f||(f=new r.Barrier,this.phaseWhen.set(a,f)),await f.wait()}registerWindow(a){const f=new R.DisposableStore;this.windowCounter++,f.add(a.onWillLoad(C=>this._onWillLoadWindow.fire({window:a,workspace:C.workspace,reason:C.reason})));const P=(0,c.assertIsDefined)(a.win);P.on("close",C=>{const t=a.id;if(this.windowToCloseRequest.has(t)){this.windowToCloseRequest.delete(t);return}this.trace(`Lifecycle#window.on('close') - window ID ${a.id}`),C.preventDefault(),this.unload(a,1).then(l=>{if(l){this.windowToCloseRequest.delete(t);return}this.windowToCloseRequest.add(t),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this._onBeforeCloseWindow.fire(a),a.close()})}),P.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(a,f){await this.unload(a,3)||a.reload(f)}unload(a,f){const P=this.mapWindowIdToPendingUnload.get(a.id);if(P)return P;const C=this.doUnload(a,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(a.id)});return this.mapWindowIdToPendingUnload.set(a.id,C),C}async doUnload(a,f){if(!a.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${a.id}`);const P=this._quitRequested?2:f,C=await this.onBeforeUnloadWindowInRenderer(a,P);return C?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.handleWindowUnloadVeto(C)):(await this.onWillUnloadWindowInRenderer(a,P),!1)}handleWindowUnloadVeto(a){return a?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(a){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(a),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(a,f){return new Promise(P=>{const C=this.oneTimeListenerTokenGenerator++,t=`vscode:ok${C}`,l=`vscode:cancel${C}`;L.validatedIpcMain.once(t,()=>{P(!1)}),L.validatedIpcMain.once(l,()=>{P(!0)}),a.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:l,reason:f})})}onWillUnloadWindowInRenderer(a,f){return new Promise(P=>{const t=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(t,()=>P()),a.send("vscode:onWillUnload",{replyChannel:t,reason:f})})}quit(a){return this.trace(`Lifecycle#quit() - begin (willRestart: ${a})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(a&&this.stateService.setItem(ft.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.pendingQuitPromise)}trace(a){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(a):this.logService.trace(a)}async relaunch(a){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(a?.addArgs&&f.push(...a.addArgs),a?.removeArgs)for(const t of a.removeArgs){const l=f.indexOf(t);l>=0&&f.splice(l,1)}const P=()=>{try{if(I.isWindows){const t=(0,h.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:f})};E.app.once("quit",P),await this.quit(!0)&&E.app.removeListener("quit",P)}async kill(a){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const f of E.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let P;f.webContents&&!f.webContents.isDestroyed()?P=new Promise(C=>f.once("closed",C)):P=Promise.resolve(),f.destroy(),await P}})()]),E.app.exit(a)}};s.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",e.LifecycleMainService=s=Se([J(0,m.ILogService),J(1,S.IStateService),J(2,u.IEnvironmentMainService)],s)}),define(te[285],ie([0,1,3,4,2,6,20]),function(j,e,E,L,r,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,_.createDecorator)("keyboardLayoutMainService");let I=e.KeyboardLayoutMainService=class extends r.Disposable{constructor(v){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,v.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const v=await new Promise((m,S)=>{j(["native-keymap"],m,S)});this._keyboardLayoutData=h(v),E.isCI||v.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(v),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=I=Se([J(0,R.ILifecycleMainService)],I);function h(c){const v=c.getKeyMap(),m=c.getCurrentKeyboardLayout();return{keyboardMapping:v,keyboardLayoutInfo:m}}}),define(te[286],ie([0,1,244,7,17,13,11,19,33,93,5,51,243,283]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let y=e.RequestService=class extends m.AbstractRequestService{constructor(a,f,P,C){super(C),this.configurationService=a,this.environmentService=f,this.logService=P,this.configure(),this._register(a.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const a=this.configurationService.getValue("http");this.proxyUrl=a?.proxy,this.strictSSL=!!a?.proxyStrictSSL,this.authorization=a?.proxyAuthorization}async request(a,f){const{proxyUrl:P,strictSSL:C}=this;let t;try{t=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,_.getErrorMessage)(i)))}const l={...process.env,...t},n=a.agent?a.agent:await(0,S.getProxyAgent)(a.url||"",l,{proxyUrl:P,strictSSL:C});return a.agent=n,a.strictSSL=C,this.authorization&&(a.headers={...a.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(a.isChromiumNetwork?"electron":"node",a,()=>s(a,f))}async resolveProxy(a){}};e.RequestService=y=Se([J(0,I.IConfigurationService),J(1,h.INativeEnvironmentService),J(2,v.ILogService),J(3,v.ILoggerService)],y);async function p(w){return((0,E.parse)(w.url).protocol==="https:"?await new Promise((P,C)=>{j(["https"],P,C)}):await new Promise((P,C)=>{j(["http"],P,C)})).request}async function s(w,a){return L.Promises.withAsyncBody(async(f,P)=>{const C=(0,E.parse)(w.url),t=w.getRawRequest?w.getRawRequest(w):await p(w),l={hostname:C.hostname,port:C.port?parseInt(C.port):C.protocol==="https:"?443:80,protocol:C.protocol,path:C.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,R.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(l.auth=w.user+":"+w.password);const n=t(l,i=>{const o=(0,R.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)s({...w,url:i.headers.location,followRedirects:o-1},a).then(f,P);else{let d=i;!w.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(d=i.pipe((0,u.createGunzip)())),f({res:i,stream:(0,r.streamToBufferReadableStream)(d)})}});n.on("error",P),w.timeout&&n.setTimeout(w.timeout),w.isChromiumNetwork&&n.removeHeader("Content-Length"),w.data&&typeof w.data=="string"&&n.write(w.data),n.end(),a.onCancellationRequested(()=>{n.abort(),P(new _.CancellationError)})})}e.nodeRequest=s}),define(te[287],ie([0,1,15,286]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(R){return E.net.request}class _ extends L.RequestService{request(I,h){return super.request({...I||{},getRawRequest:r,isChromiumNetwork:!0},h)}}e.RequestMainService=_}),define(te[98],ie([0,1,8,49,4,2,33,16,6,20,5,95,280,41,53,40]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,h.createDecorator)("storageMainService");let s=e.StorageMainService=class extends _.Disposable{constructor(f,P,C,t,l,n){super(),this.logService=f,this.environmentService=P,this.userDataProfilesService=C,this.lifecycleMainService=t,this.fileService=l,this.uriIdentityService=n,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new r.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(f=>{f.window.profile&&this.profileStorage(f.window.profile).init(),f.workspace&&this.workspaceStorage(f.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(f=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=f.reason,f.join("applicationStorage",this.applicationStorage.close());for(const[,P]of this.mapProfileToStorage)f.join("profileStorage",P.close());for(const[,P]of this.mapWorkspaceToStorage)f.join("workspaceStorage",P.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(f=>{f.join((async()=>{await this.fileService.exists(f.profile.globalStorageHome)||await this.fileService.createFolder(f.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(f=>{const P=this.mapProfileToStorage.get(f.profile.id);P&&f.join(P.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const f=new S.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,L.once)(f.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),f}profileStorage(f){if((0,m.isProfileUsingDefaultStorage)(f))return this.applicationStorage;let P=this.mapProfileToStorage.get(f.id);if(!P){this.logService.trace(`StorageMainService: creating profile storage (${f.name})`),P=this.createProfileStorage(f),this.mapProfileToStorage.set(f.id,P);const C=this._register(P.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:P,profile:f})));(0,L.once)(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${f.name})`),this.mapProfileToStorage.delete(f.id),C.dispose()})}return P}createProfileStorage(f){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.ProfileStorageMain(f,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(f){let P=this.mapWorkspaceToStorage.get(f.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${f.id})`),P=this.createWorkspaceStorage(f),this.mapWorkspaceToStorage.set(f.id,P),(0,L.once)(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${f.id})`),this.mapWorkspaceToStorage.delete(f.id)})),P}createWorkspaceStorage(f){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.WorkspaceStorageMain(f,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(f){const P=E.URI.file(f);for(const C of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(C.path&&this.uriIdentityService.extUri.isEqualOrParent(E.URI.file(C.path),P))return!0;return!1}};e.StorageMainService=s=Se([J(0,v.ILogService),J(1,R.IEnvironmentService),J(2,y.IUserDataProfilesMainService),J(3,c.ILifecycleMainService),J(4,I.IFileService),J(5,p.IUriIdentityService)],s),e.IApplicationStorageMainService=(0,h.createDecorator)("applicationStorageMainService");let w=e.ApplicationStorageMainService=class extends m.AbstractStorageService{constructor(f,P){super(),this.userDataProfilesService=f,this.storageMainService=P,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(f){if(f===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(f){if(f===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=w=Se([J(0,u.IUserDataProfilesService),J(1,e.IStorageMainService)],w)}),define(te[99],ie([0,1,7,21,4,19,30,20,5,23,51,48]),function(j,e,E,L,r,_,R,I,h,c,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(y,p,s){return`${s.updateUrl}/api/update/${y}/${p}/${s.commit}`}e.createUpdateURL=S;let u=e.AbstractUpdateService=class{get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}constructor(p,s,w,a,f,P){this.lifecycleMainService=p,this.configurationService=s,this.environmentMainService=w,this.requestService=a,this.logService=f,this.productService=P,this._state=m.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,p.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.configurationService.getValue("update.mode"),s=this.getProductQuality(p);if(!s){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(s),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(m.State.Idle(this.getUpdateType())),p==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}getProductQuality(p){return p==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(p=60*60*1e3){return(0,E.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(p){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(s){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(s);return}}async _applySpecificUpdate(p){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=u=Se([J(0,I.ILifecycleMainService),J(1,_.IConfigurationService),J(2,R.IEnvironmentMainService),J(3,v.IRequestService),J(4,h.ILogService),J(5,c.IProductService)],u)}),define(te[288],ie([0,1,15,55,4,2,19,30,20,5,23,51,26,48,99]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=e.DarwinUpdateService=class extends y.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"error",(w,a)=>a)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(w,a,f)=>({url:a,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(w,a,f,P)=>({releaseNotes:a,version:f,productVersion:f,date:P}))}constructor(w,a,f,P,C,t,l){super(w,a,P,C,t,l),this.telemetryService=f,this.disposables=new _.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const a=this.state.type==="checking for updates"&&this.state.explicit?w:void 0;this.setState(u.State.Idle(1,a))}buildUpdateFeedUrl(w){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,y.createUpdateURL)(a,w,this.productService);try{E.autoUpdater.setFeedURL({url:f})}catch(P){this.logService.error("Failed to set update feed URL",P);return}return f}doCheckForUpdates(w){this.setState(u.State.CheckingForUpdates(w)),E.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(u.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(u.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(u.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};Se([L.memoize],p.prototype,"onRawError",null),Se([L.memoize],p.prototype,"onRawUpdateNotAvailable",null),Se([L.memoize],p.prototype,"onRawUpdateAvailable",null),Se([L.memoize],p.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=p=Se([J(0,h.ILifecycleMainService),J(1,R.IConfigurationService),J(2,S.ITelemetryService),J(3,I.IEnvironmentMainService),J(4,m.IRequestService),J(5,c.ILogService),J(6,v.IProductService)],p)}),define(te[289],ie([0,1,46,42,7,4,9,30,20,5,26,48]),function(j,e,E,L,r,_,R,I,h,c,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}constructor(p,s,w){if(this.lifecycleMainService=p,this.logService=w,this._state=m.State.Uninitialized,this._onStateChange=new _.Emitter,this.onStateChange=this._onStateChange.event,s.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(m.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}scheduleCheckForUpdates(p=60*60*1e3){return(0,r.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(p){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(p){}};S=Se([J(0,h.ILifecycleMainService),J(1,I.IEnvironmentMainService),J(2,c.ILogService)],S);let u=e.SnapUpdateService=class extends S{constructor(p,s,w,a,f,P){super(w,a,f),this.snap=p,this.snapRevision=s,this.telemetryService=P;const C=(0,L.watch)(R.dirname(this.snap)),t=_.Event.fromNodeEventEmitter(C,"change",(o,d)=>d),l=_.Event.filter(t,o=>o==="current"),i=_.Event.debounce(l,(o,d)=>d,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{i.dispose(),C.close()})}doCheckForUpdates(){this.setState(m.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(p=>{p?this.setState(m.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(m.State.Idle(2)))},p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(m.State.Idle(2,p.message||p))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const p=await new Promise((w,a)=>(0,L.realpath)(`${R.dirname(this.snap)}/current`,(f,P)=>f?a(f):w(P))),s=R.basename(p);return this.snapRevision!==s}isLatestVersion(){return this.isUpdateAvailable().then(void 0,p=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=u=Se([J(2,h.ILifecycleMainService),J(3,I.IEnvironmentMainService),J(4,c.ILogService),J(5,v.ITelemetryService)],u)}),define(te[290],ie([0,1,2,20,53,29,7,28]),function(j,e,E,L,r,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=e.UserDataProfilesHandler=class extends E.Disposable{constructor(v,m,S){super(),this.userDataProfilesService=m,this.windowsMainService=S,this._register(v.onWillLoadWindow(u=>{u.reason===2&&this.unsetProfileForWorkspace(u.window)})),this._register(v.onBeforeCloseWindow(u=>this.unsetProfileForWorkspace(u))),this._register(new R.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(v){const m=this.getWorkspace(v),S=this.userDataProfilesService.getProfileForWorkspace(m);S?.isTransient&&(this.userDataProfilesService.unsetWorkspace(m,S.isTransient),S.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(v){return v.openedWorkspace??(0,_.toWorkspaceIdentifier)(v.backupPath,v.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const v=this.userDataProfilesService.getAssociatedEmptyWindows();if(v.length===0)return;const m=this.windowsMainService.getWindows().map(S=>this.getWorkspace(S));for(const S of v)m.some(u=>u.id===S.id)||this.userDataProfilesService.unsetWorkspace(S,!1)}};e.UserDataProfilesHandler=h=Se([J(0,L.ILifecycleMainService),J(1,r.IUserDataProfilesMainService),J(2,I.IWindowsMainService)],h)}),define(te[60],ie([0,1,15,2,4,5,309,7,14,28,72,26,20,71,37,3,131]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function w(P){return typeof P.responseWindowId=="number"}let a=e.UtilityProcess=class ut extends L.Disposable{static getAll(){return Array.from(ut.all.values())}constructor(C,t,l){super(),this.logService=C,this.telemetryService=t,this.lifecycleMainService=l,this.id=String(++ut.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(C,t){let l;switch(this.configuration?.correlationId?l=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${C}`:l=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${C}`,t){case v.default.Error:this.logService.error(l);break;case v.default.Warning:this.logService.warn(l);break;case v.default.Info:this.logService.trace(l);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",v.default.Error),!1):!0}start(C){const t=this.doStart(C);return t&&C.payload&&this.postMessage(C.payload),t}doStart(C){if(!this.validateCanStart())return!1;this.configuration=C;const t=`${this.configuration.type}-${this.id}`,l=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,n=this.configuration.args??[],i=this.configuration.execArgv??[],o=this.configuration.allowLoadingUnsignedLibraries,d=this.configuration.forceAllocationsToV8Sandbox,g="pipe",D=this.createEnv(C);return this.log("creating new...",v.default.Info),this.process=E.utilityProcess.fork(l,n,{serviceName:t,env:D,execArgv:i,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:d,stdio:g}),this.registerListeners(this.process,this.configuration,t),!0}createEnv(C){const t=C.env?{...C.env}:{...(0,y.deepClone)(process.env)};t.VSCODE_AMD_ENTRYPOINT=C.entryPoint,typeof C.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(C.parentLifecycleBound)),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=C.type,p.isWindows&&((0,s.isUNCAccessRestrictionsDisabled)()?t.NODE_DISABLE_UNC_ACCESS_CHECKS="1":t.NODE_UNC_HOST_ALLOWLIST=(0,s.getUNCHostAllowlist)().join("\\")),(0,u.removeDangerousEnvVariables)(t);for(const l of Object.keys(t))t[l]=String(t[l]);return t}registerListeners(C,t,l){if(C.stdout){const n=new R.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(C.stdout,"data")(i=>this._onStdout.fire(typeof i=="string"?i:n.write(i))))}if(C.stderr){const n=new R.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(C.stderr,"data")(i=>this._onStderr.fire(typeof i=="string"?i:n.write(i))))}this._register(r.Event.fromNodeEventEmitter(C,"message")(n=>this._onMessage.fire(n))),this._register(r.Event.fromNodeEventEmitter(C,"spawn")(()=>{this.processPid=C.pid,typeof C.pid=="number"&&ut.all.set(C.pid,{pid:C.pid,name:w(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.log("successfully created",v.default.Info)})),this._register(r.Event.fromNodeEventEmitter(C,"exit")(n=>{this.log(`received exit event with code ${n}`,v.default.Info),this._onExit.fire({pid:this.processPid,code:n,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(E.app,"child-process-gone",(n,i)=>({event:n,details:i}))(({details:n})=>{n.type==="Utility"&&n.name===l&&(this.log(`crashed with code ${n.exitCode} and reason '${n.reason}'`,v.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:t.type,reason:n.reason,code:n.exitCode}),this._onCrash.fire({pid:this.processPid,code:n.exitCode,reason:n.reason}),this.onDidExitOrCrashOrKill())}))}once(C,t){const l=this._register(this._onMessage.event(n=>{n===C&&(l.dispose(),t())}))}postMessage(C,t){this.process&&this.process.postMessage(C,t)}connect(C){const{port1:t,port2:l}=new E.MessageChannelMain;return this.postMessage(C,[l]),t}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",v.default.Info);const C=process;return typeof C._debugProcess=="function"?(C._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",v.default.Info),this.process.kill()?(this.log("successfully killed the process",v.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",v.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&ut.all.delete(this.processPid),this.process=void 0}async waitForExit(C){this.process&&(this.log("waiting to exit...",v.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,I.timeout)(C)]),this.process&&(this.log(`did not exit within ${C}ms, will kill it now...`,v.default.Info),this.kill()))}};a.ID_COUNTER=0,a.all=new Map,e.UtilityProcess=a=Se([J(0,_.ILogService),J(1,m.ITelemetryService),J(2,S.ILifecycleMainService)],a);let f=e.WindowUtilityProcess=class extends a{constructor(C,t,l,n){super(C,l,n),this.windowsMainService=t}start(C){const t=this.windowsMainService.getWindowById(C.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",v.default.Error),!0;if(!super.doStart(C))return!1;this.registerWindowListeners(t.win,C);const n=this.connect(C.payload);return t.win.webContents.postMessage(C.responseChannel,C.responseNonce,[n]),!0}registerWindowListeners(C,t){t.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,l=>l.window.win===C)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(C,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=f=Se([J(0,_.ILogService),J(1,c.IWindowsMainService),J(2,m.ITelemetryService),J(3,S.ILifecycleMainService)],f)}),define(te[291],ie([0,1,13,5,20,7,60,28,26]),function(j,e,E,L,r,_,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let c=e.ExtensionHostStarter=class Dt{constructor(m,S,u,y){this._logService=m,this._lifecycleMainService=S,this._windowsMainService=u,this._telemetryService=y,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(p=>{this._shutdown=!0,p.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(m){const S=this._extHosts.get(m);if(!S)throw new Error("Unknown extension host!");return S}onDynamicStdout(m){return this._getExtHost(m).onStdout}onDynamicStderr(m){return this._getExtHost(m).onStderr}onDynamicMessage(m){return this._getExtHost(m).onMessage}onDynamicExit(m){return this._getExtHost(m).onExit}async createExtensionHost(){if(this._shutdown)throw(0,E.canceled)();const m=String(++Dt._lastId),S=new R.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(m,S),S.onExit(({pid:u,code:y,signal:p})=>{this._logService.info(`Extension host with pid ${u} exited with code: ${y}, signal: ${p}.`),setTimeout(()=>{S.dispose(),this._extHosts.delete(m)})}),{id:m}}async start(m,S){if(this._shutdown)throw(0,E.canceled)();this._getExtHost(m).start({...S,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:S.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m})}async enableInspectPort(m){if(this._shutdown)throw(0,E.canceled)();const S=this._extHosts.get(m);return S?S.enableInspectPort():!1}async kill(m){if(this._shutdown)throw(0,E.canceled)();const S=this._extHosts.get(m);S&&S.kill()}async _killAllNow(){for(const[,m]of this._extHosts)m.kill()}async _waitForAllExit(m){const S=[];for(const[,u]of this._extHosts)S.push(u.waitForExit(m));return _.Promises.settled(S).then(()=>{})}};c._lastId=0,e.ExtensionHostStarter=c=Se([J(0,L.ILogService),J(1,r.ILifecycleMainService),J(2,I.IWindowsMainService),J(3,h.ITelemetryService)],c)}),define(te[292],ie([0,1,38,7,2,30,20,5,41,39,66,60,52,88,11]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let p=e.SharedProcess=class extends r.Disposable{constructor(w,a,f,P,C,t,l){super(),this.machineId=w,this.environmentMainService=a,this.userDataProfilesService=f,this.lifecycleMainService=P,this.logService=C,this.loggerMainService=t,this.policyService=l,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){E.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(w,a)=>this.onWindowConnection(w,a)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(w,a){this.logService.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const f=await this.connect();if(w.sender.isDestroyed())return f.close();w.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[f])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage("vscode:electron-main->shared-process=exit"),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const w=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=init-done",()=>w.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>w.complete()),await w.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const w=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=ipc-ready",()=>w.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>w.complete()),await w.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new m.UtilityProcess(this.logService,S.NullTelemetryService,this.lifecycleMainService));const w=(0,u.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let a;w.port&&(a=["--nolazy"],w.break?a.push(`--inspect-brk=${w.port}`):a.push(`--inspect=${w.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:a})}createSharedProcessConfiguration(){return{machineId:this.machineId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(){return await this.whenIpcReady,(0,y.assertIsDefined)(this.utilityProcess).connect()}};e.SharedProcess=p=Se([J(1,_.IEnvironmentMainService),J(2,h.IUserDataProfilesService),J(3,R.ILifecycleMainService),J(4,I.ILogService),J(5,v.ILoggerMainService),J(6,c.IPolicyService)],p)}),define(te[293],ie([0,1,33,88,20,5,52,60,109,38,2,4,37]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let u=e.ElectronPtyHostStarter=class{constructor(p,s,w,a){this._reconnectConstants=p,this._environmentService=s,this._lifecycleMainService=w,this._logService=a,this.utilityProcess=void 0,this._onBeforeWindowConnection=new m.Emitter,this.onBeforeWindowConnection=this._onBeforeWindowConnection.event,this._onWillShutdown=new m.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),c.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(f,P)=>this._onWindowConnection(f,P))}start(p){this.utilityProcess=new I.UtilityProcess(this._logService,R.NullTelemetryService,this._lifecycleMainService);const s=(0,L.parsePtyHostDebugPort)(this._environmentService.args,this._environmentService.isBuilt);let w;s&&(w=["--nolazy"],s.break?w.push(`--inspect-brk=${s.port}`):s.break||w.push(`--inspect=${s.port}`)),this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:w,env:this._createPtyHostConfiguration(p)});const a=this.utilityProcess.connect(),f=new h.Client(a,"ptyHost"),P=new v.DisposableStore;return P.add(f),P.add(this.utilityProcess),P.add((0,v.toDisposable)(()=>{c.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel"),this.utilityProcess=void 0})),{client:f,store:P,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(p){return{...(0,S.deepClone)(process.env),VSCODE_LAST_PTY_ID:String(p),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)}}_onWindowConnection(p,s){this._onBeforeWindowConnection.fire();const w=this.utilityProcess.connect();if(p.sender.isDestroyed()){w.close();return}p.sender.postMessage("vscode:createPtyHostMessageChannelResult",s,[w])}};e.ElectronPtyHostStarter=u=Se([J(1,E.IEnvironmentService),J(2,r.ILifecycleMainService),J(3,_.ILogService)],u)}),define(te[294],ie([0,1,2,6,5,28,60,26,56,4,7,20]),function(j,e,E,L,r,_,R,I,h,c,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let S=e.UtilityProcessWorkerMainService=class extends E.Disposable{constructor(p,s,w,a){super(),this.logService=p,this.windowsMainService=s,this.telemetryService=w,this.lifecycleMainService=a,this.workers=new Map}async createWorker(p){const s=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${s})`);const w=this.hash(p);this.workers.has(w)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${s})`),this.disposeWorker(p));const a=new u(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,p);if(!a.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(w,a);const f=new v.DeferredPromise;return c.Event.once(a.onDidTerminate)(P=>{P.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${P.code}, signal: ${P.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${P.code}, signal: ${P.signal}`),this.workers.delete(w),f.complete({reason:P})}),f.p}hash(p){return(0,h.hash)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const s=this.hash(p),w=this.workers.get(s);w&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),w.kill(),this.workers.delete(s))}};e.UtilityProcessWorkerMainService=S=Se([J(0,r.ILogService),J(1,_.IWindowsMainService),J(2,I.ITelemetryService),J(3,m.ILifecycleMainService)],S);let u=class extends E.Disposable{constructor(p,s,w,a,f){super(),this.logService=p,this.windowsMainService=s,this.telemetryService=w,this.lifecycleMainService=a,this.configuration=f,this._onDidTerminate=this._register(new c.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new R.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(p=>this._onDidTerminate.fire({code:p.code,signal:p.signal}))),this._register(this.utilityProcess.onCrash(p=>this._onDidTerminate.fire({code:p.code,signal:"ECRASH"})))}spawn(){const s=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:s,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};u=Se([J(0,r.ILogService),J(1,_.IWindowsMainService),J(2,I.ITelemetryService),J(3,m.ILifecycleMainService)],u)}),define(te[295],ie([0,1,15,2,3,18,8,19,20,5,34,28,127,29]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=e.WindowsStateHandler=class St extends L.Disposable{get state(){return this._state}constructor(P,C,t,l,n){super(),this.windowsMainService=P,this.stateService=C,this.lifecycleMainService=t,this.logService=l,this.configurationService=n,this._state=p(this.stateService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){E.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(P=>this.onBeforeCloseWindow(P)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(P=>{P.newCount-P.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(P=>this.onBeforeCloseWindow(P))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const P=new Set,C={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!C.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),n&&(C.lastActiveWindow=this.toWindowState(n),C.lastActiveWindow.uiState.mode===3&&P.add(C.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);t&&(C.lastPluginDevelopmentHostWindow=this.toWindowState(t),C.lastPluginDevelopmentHostWindow.uiState.mode===3&&(P.has(C.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!t.win?.isSimpleFullScreen()&&(C.lastPluginDevelopmentHostWindow.uiState.mode=1):P.add(C.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(C.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const i=this.toWindowState(n);return i.uiState.mode===3&&(P.has(i.uiState.display)?r.isMacintosh&&i.windowId!==C.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(i.uiState.mode=1):P.add(i.uiState.display)),i}));const l=w(C);this.stateService.setItem(St.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(P){if(this.lifecycleMainService.quitRequested)return;const C=this.toWindowState(P);P.isExtensionDevelopmentHost&&!P.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=C:!P.isExtensionDevelopmentHost&&P.openedWorkspace&&this._state.openedWindows.forEach(t=>{const l=(0,u.isWorkspaceIdentifier)(P.openedWorkspace)&&t.workspace?.id===P.openedWorkspace.id,n=(0,u.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)&&t.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(t.folderUri,P.openedWorkspace.uri);(l||n)&&(t.uiState=C.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=C)}toWindowState(P){return{windowId:P.id,workspace:(0,u.isWorkspaceIdentifier)(P.openedWorkspace)?P.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)?P.openedWorkspace.uri:void 0,backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.serializeWindowState()}}getNewWindowState(P){const C=this.doGetNewWindowState(P),t=this.configurationService.getValue("window");if(C.mode===3){let l;C.hasDefaultState?l=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):l=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),l||(C.mode=1)}return C}doGetNewWindowState(P){const C=this.windowsMainService.getLastActiveWindow();if(!P.extensionTestsPath){if(P.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const d=P.workspace;if((0,u.isWorkspaceIdentifier)(d)){const D=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===d.id).map(M=>M.uiState);if(D.length)return D[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(d)){const D=this.state.openedWindows.filter(M=>M.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(M.folderUri,d.uri)).map(M=>M.uiState);if(D.length)return D[0]}else if(P.backupPath){const D=this.state.openedWindows.filter(M=>M.backupPath===P.backupPath).map(M=>M.uiState);if(D.length)return D[0]}const g=this.lastClosedState||this.state.lastActiveWindow;if(!C&&g)return g.uiState}let t;const l=E.screen.getAllDisplays();if(l.length===1)t=l[0];else{if(r.isMacintosh){const d=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(d)}!t&&C&&(t=E.screen.getDisplayMatching(C.getBounds())),t||(t=E.screen.getPrimaryDisplay()||l[0])}let n=(0,S.defaultWindowState)();n.x=Math.round(t.bounds.x+t.bounds.width/2-n.width/2),n.y=Math.round(t.bounds.y+t.bounds.height/2-n.height/2);const i=this.configurationService.getValue("window");let o=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")n.mode=0,o=!1;else if(i.newWindowDimensions==="fullscreen")n.mode=3,o=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&C){const d=C.serializeWindowState();d.mode===3?n.mode=3:n=d,o=n.mode!==3&&i.newWindowDimensions==="offset"}}return o&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(P){if(this.windowsMainService.getWindows().length===0)return P;P.x=typeof P.x=="number"?P.x:0,P.y=typeof P.y=="number"?P.y:0;const C=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;C.some(t=>t.x===P.x||t.y===P.y);)P.x+=30,P.y+=30;return P}};y.windowsStateStorageKey="windowsState",e.WindowsStateHandler=y=Se([J(0,m.IWindowsMainService),J(1,v.IStateService),J(2,h.ILifecycleMainService),J(3,c.ILogService),J(4,I.IConfigurationService)],y);function p(f){const P={openedWindows:[]},C=f||{openedWindows:[]};return C.lastActiveWindow&&(P.lastActiveWindow=s(C.lastActiveWindow)),C.lastPluginDevelopmentHostWindow&&(P.lastPluginDevelopmentHostWindow=s(C.lastPluginDevelopmentHostWindow)),Array.isArray(C.openedWindows)&&(P.openedWindows=C.openedWindows.map(t=>s(t))),P}e.restoreWindowsState=p;function s(f){const P={uiState:f.uiState};return f.backupPath&&(P.backupPath=f.backupPath),f.remoteAuthority&&(P.remoteAuthority=f.remoteAuthority),f.folder&&(P.folderUri=R.URI.parse(f.folder)),f.workspaceIdentifier&&(P.workspace={id:f.workspaceIdentifier.id,configPath:R.URI.parse(f.workspaceIdentifier.configURIPath)}),P}function w(f){return{lastActiveWindow:f.lastActiveWindow&&a(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&a(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(P=>a(P))}}e.getWindowsStateStoreData=w;function a(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(te[54],ie([0,1,15,4,44,2,14,9,18,11,22,192,64,59,30,6,5,53,129,29,96,97]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let t=e.WorkspacesManagementMainService=class extends _.Disposable{constructor(n,i,o,d,g){super(),this.environmentMainService=n,this.logService=i,this.userDataProfilesMainService=o,this.backupMainService=d,this.dialogMainService=g,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const n=(await v.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(i=>(0,h.joinPath)(this.untitledWorkspacesHome,i,f.UNTITLED_WORKSPACE_NAME));for(const i of n){const o=(0,C.getWorkspaceIdentifier)(i),d=await this.resolveLocalWorkspace(i);d?this.untitledWorkspaces.push({workspace:o,remoteAuthority:d.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(n){n.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${n}).`)}}resolveLocalWorkspace(n){return this.doResolveLocalWorkspace(n,i=>v.Promises.readFile(i,"utf8"))}doResolveLocalWorkspace(n,i){if(this.isWorkspacePath(n)&&n.scheme===R.Schemas.file)try{const o=i(n.fsPath);return o instanceof Promise?o.then(d=>this.doResolveWorkspace(n,d),d=>{}):this.doResolveWorkspace(n,o)}catch{return}}isWorkspacePath(n){return(0,f.isUntitledWorkspace)(n,this.environmentMainService)||(0,f.hasWorkspaceFileExtension)(n)}doResolveWorkspace(n,i){try{const o=this.doParseStoredWorkspace(n,i),d=(0,C.getWorkspaceIdentifier)(n);return{id:d.id,configPath:d.configPath,folders:(0,P.toWorkspaceFolders)(o.folders,d.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.logService.warn(o.toString())}}doParseStoredWorkspace(n,i){const o=(0,r.parse)(i);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(d=>(0,P.isStoredWorkspaceFolder)(d));else throw new Error(`${n.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(n,i){const{workspace:o,storedWorkspace:d}=this.newUntitledWorkspace(n,i),g=o.configPath.fsPath;return await v.Promises.mkdir((0,I.dirname)(g),{recursive:!0}),await v.Promises.writeFile(g,JSON.stringify(d,null,"	")),this.untitledWorkspaces.push({workspace:o,remoteAuthority:i}),o}newUntitledWorkspace(n=[],i){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),d=(0,h.joinPath)(this.untitledWorkspacesHome,o),g=(0,h.joinPath)(d,f.UNTITLED_WORKSPACE_NAME),D=[];for(const M of n)D.push((0,P.getStoredWorkspaceFolder)(M.uri,!0,M.name,d,h.extUriBiasedIgnorePathCase));return{workspace:(0,C.getWorkspaceIdentifier)(g),storedWorkspace:{folders:D,remoteAuthority:i}}}async getWorkspaceIdentifier(n){return(0,C.getWorkspaceIdentifier)(n)}isUntitledWorkspace(n){return(0,f.isUntitledWorkspace)(n.configPath,this.environmentMainService)}async deleteUntitledWorkspace(n){this.isUntitledWorkspace(n)&&(await this.doDeleteUntitledWorkspace(n),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(n),this._onDidDeleteUntitledWorkspace.fire(n))}async doDeleteUntitledWorkspace(n){const i=(0,h.originalFSPath)(n.configPath);try{await v.Promises.rm((0,I.dirname)(i));const o=(0,I.join)(this.environmentMainService.workspaceStorageHome.fsPath,n.id);await v.Promises.exists(o)&&await v.Promises.writeFile((0,I.join)(o,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(d=>d.workspace.id!==n.id)}catch(o){this.logService.warn(`Unable to delete untitled workspace ${i} (${o}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(n,i,o){if(!n||!n.win||!n.isReady||!await this.isValidTargetWorkspacePath(n,i,o))return;const g=await this.doEnterWorkspace(n,(0,C.getWorkspaceIdentifier)(o));if(g)return this._onDidEnterWorkspace.fire({window:n,workspace:g.workspace}),g}async isValidTargetWorkspacePath(n,i,o){return o?(0,f.isWorkspaceIdentifier)(n.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.configPath,o)?!1:(0,a.findWindowOnWorkspaceOrFolder)(i,o)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,h.basename)(o)),detail:(0,m.localize)(2,null)},(0,c.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async doEnterWorkspace(n,i){if(!n.config)return;n.focus();let o;return n.config.extensionDevelopmentPath||(n.config.backupPath?o=await this.backupMainService.registerWorkspaceBackup({workspace:i,remoteAuthority:n.remoteAuthority},n.config.backupPath):o=this.backupMainService.registerWorkspaceBackup({workspace:i,remoteAuthority:n.remoteAuthority})),(0,f.isWorkspaceIdentifier)(n.openedWorkspace)&&this.isUntitledWorkspace(n.openedWorkspace)&&await this.deleteUntitledWorkspace(n.openedWorkspace),n.config.workspace=i,n.config.backupPath=o,{workspace:i,backupPath:o}}};e.WorkspacesManagementMainService=t=Se([J(0,y.IEnvironmentMainService),J(1,s.ILogService),J(2,w.IUserDataProfilesMainService),J(3,S.IBackupMainService),J(4,u.IDialogMainService)],t)}),define(te[132],ie([0,1,15,38,21,6,28,29,54,11,5,60]),function(j,e,E,L,r,_,R,I,h,c,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,_.createDecorator)(e.ID);let S=e.DiagnosticsMainService=class{constructor(y,p,s){this.windowsMainService=y,this.workspacesManagementMainService=p,this.logService=s}async getRemoteDiagnostics(y){const p=this.windowsMainService.getWindows();return(await Promise.all(p.map(async w=>{const a=w.remoteAuthority;if(!a)return;const f=`vscode:getDiagnosticInfoResponse${w.id}`,P={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.getFolderURIs(w):void 0};return new Promise(C=>{w.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:f,args:P}),L.validatedIpcMain.once(f,(t,l)=>{l||C({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),C(l)}),setTimeout(()=>{C({hostName:a,errorMessage:`Connection to '${a}' could not be established`})},5e3)})}))).filter(w=>!!w)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const y=[];for(const s of E.BrowserWindow.getAllWindows()){const w=this.windowsMainService.getWindowById(s.id);w?y.push(await this.codeWindowToInfo(w)):y.push(this.browserWindowToInfo(s))}const p=[];for(const{pid:s,name:w}of m.UtilityProcess.getAll())p.push({pid:s,name:w});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:p,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async codeWindowToInfo(y){const p=await this.getFolderURIs(y),s=(0,c.assertIsDefined)(y.win);return this.browserWindowToInfo(s,p,y.remoteAuthority)}browserWindowToInfo(y,p=[],s){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:p,remoteAuthority:s}}async getFolderURIs(y){const p=[],s=y.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(s))p.push(s.uri);else if((0,I.isWorkspaceIdentifier)(s)){const w=await this.workspacesManagementMainService.resolveLocalWorkspace(s.configPath);w&&w.folders.forEach(f=>{p.push(f.uri)})}return p}};e.DiagnosticsMainService=S=Se([J(0,R.IWindowsMainService),J(1,h.IWorkspacesManagementMainService),J(2,v.ILogService)],S)}),define(te[67],ie([0,1,46,15,27,154,55,4,2,14,9,3,8,105,86,22,103,180,59,30,6,20,5,23,79,28,29,54,17,241,234]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t,l,n,i,o,d,g,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,P.createDecorator)("nativeHostMainService");let b=e.NativeHostMainService=class extends h.Disposable{constructor(O,F,q,re,Y,ne,ce,le){super(),this.windowsMainService=O,this.dialogMainService=F,this.lifecycleMainService=q,this.environmentMainService=re,this.logService=Y,this.productService=ne,this.themeMainService=ce,this.workspacesManagementMainService=le,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,K=>K.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:K,x:V,y:U})=>({windowId:K.id,x:V,y:U})),({windowId:K})=>!!this.windowsMainService.getWindowById(K)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(K,V)=>V.id),K=>!!this.windowsMainService.getWindowById(K)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(K,V)=>V.id),K=>!!this.windowsMainService.getWindowById(K)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(K,V)=>V.id),K=>!!this.windowsMainService.getWindowById(K)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),K=>!!K),K=>K.id),I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(K,V)=>V.id),K=>!!this.windowsMainService.getWindowById(K))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(K,V,U)=>U),K=>!(Array.isArray(K)&&K.length===1&&K[0]==="workArea")),I.Event.fromNodeEventEmitter(L.screen,"display-added"),I.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace??(0,o.toWorkspaceIdentifier)(F.backupPath,F.isExtensionDevelopmentHost),title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(O){return this.windowsMainService.getWindowCount()}async getActiveWindowId(O){const F=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(O,F,q){return Array.isArray(F)?this.doOpenWindow(O,F,q):this.doOpenEmptyWindow(O,F)}async doOpenWindow(O,F,q=Object.create(null)){F.length>0&&await this.windowsMainService.open({context:5,contextWindowId:O,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async doOpenEmptyWindow(O,F){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:O},F)}async toggleFullScreen(O){this.windowById(O)?.toggleFullScreen()}async handleTitleDoubleClick(O){this.windowById(O)?.handleTitleDoubleClick()}async isMaximized(O){const F=this.windowById(O);return F?.win?F.win.isMaximized():!1}async maximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.maximize()}async unmaximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.unmaximize()}async minimizeWindow(O){const F=this.windowById(O);F?.win&&F.win.minimize()}async updateWindowControls(O,F){const q=this.windowById(O);q&&q.updateWindowControls(F)}async focusWindow(O,F){F&&typeof F.windowId=="number"&&(O=F.windowId),this.windowById(O)?.focus({force:F?.force??!1})}async setMinimumSize(O,F,q){const re=this.windowById(O);if(re?.win){const[Y,ne]=re.win.getSize(),[ce,le]=re.win.getMinimumSize(),[K,V]=[F??ce,q??le],[U,T]=[Math.max(Y,K),Math.max(ne,V)];(ce!==K||le!==V)&&re.win.setMinimumSize(K,V),(Y!==U||ne!==T)&&re.win.setSize(U,T)}}async saveWindowSplash(O,F){this.themeMainService.saveWindowSplash(O,F)}async installShellCommand(O){const{source:F,target:q}=await this.getShellCommandLink();try{const{symbolicLink:re}=await p.SymlinkSupport.stat(F);if(re&&!re.dangling){const Y=await(0,u.realpath)(F);if(q===Y)return}await p.Promises.unlink(F)}catch(re){if(re.code!=="ENOENT")throw re}try{await p.Promises.symlink(q,F)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:Y}=await this.showMessageBox(O,{type:"info",message:(0,w.localize)(0,null,this.productService.nameShort),buttons:[(0,w.localize)(1,null),(0,w.localize)(2,null)]});if(Y===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${F}'\\" with administrator privileges"`;await(0,_.promisify)(E.exec)(ne)}catch{throw new Error((0,w.localize)(3,null,F))}}}async uninstallShellCommand(O){const{source:F}=await this.getShellCommandLink();try{await p.Promises.unlink(F)}catch(q){switch(q.code){case"EACCES":{const{response:re}=await this.showMessageBox(O,{type:"info",message:(0,w.localize)(4,null,this.productService.nameShort),buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null)]});if(re===0)try{const Y=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,_.promisify)(E.exec)(Y)}catch{throw new Error((0,w.localize)(7,null,F))}break}case"ENOENT":break;default:throw q}}}async getShellCommandLink(){const O=(0,v.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(O))throw new Error((0,w.localize)(8,null,O));return{source:F,target:O}}async showMessageBox(O,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(O))}async showSaveDialog(O,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(O))}async showOpenDialog(O,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(O))}toBrowserWindow(O){const F=this.windowById(O);if(F?.win)return F.win}async pickFileFolderAndOpen(O,F){const q=await this.dialogMainService.pickFileFolder(F);q&&await this.doOpenPicked(await Promise.all(q.map(async re=>await p.SymlinkSupport.existsDirectory(re)?{folderUri:S.URI.file(re)}:{fileUri:S.URI.file(re)})),F,O)}async pickFolderAndOpen(O,F){const q=await this.dialogMainService.pickFolder(F);q&&await this.doOpenPicked(q.map(re=>({folderUri:S.URI.file(re)})),F,O)}async pickFileAndOpen(O,F){const q=await this.dialogMainService.pickFile(F);q&&await this.doOpenPicked(q.map(re=>({fileUri:S.URI.file(re)})),F,O)}async pickWorkspaceAndOpen(O,F){const q=await this.dialogMainService.pickWorkspace(F);q&&await this.doOpenPicked(q.map(re=>({workspaceUri:S.URI.file(re)})),F,O)}async doOpenPicked(O,F,q){await this.windowsMainService.open({context:3,contextWindowId:q,cli:this.environmentMainService.args,urisToOpen:O,forceNewWindow:F.forceNewWindow})}async showItemInFolder(O,F){L.shell.showItemInFolder(F)}async setRepresentedFilename(O,F){this.windowById(O)?.setRepresentedFilename(F)}async setDocumentEdited(O,F){this.windowById(O)?.setDocumentEdited(F)}async openExternal(O,F){return m.isLinuxSnap?this.safeSnapOpenExternal(F):L.shell.openExternal(F),!0}safeSnapOpenExternal(O){const F=process.env.GDK_PIXBUF_MODULE_FILE,q=process.env.GDK_PIXBUF_MODULEDIR,re=process.env.GTK_IM_MODULE_FILE,Y=process.env.GDK_BACKEND,ne=process.env.GIO_MODULE_DIR,ce=process.env.GTK_EXE_PREFIX,le=process.env.GSETTINGS_SCHEMA_DIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,delete process.env.GTK_IM_MODULE_FILE,delete process.env.GDK_BACKEND,delete process.env.GIO_MODULE_DIR,delete process.env.GTK_EXE_PREFIX,delete process.env.GSETTINGS_SCHEMA_DIR,L.shell.openExternal(O),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=q,process.env.GTK_IM_MODULE_FILE=re,process.env.GDK_BACKEND=Y,process.env.GIO_MODULE_DIR=ne,process.env.GTK_EXE_PREFIX=ce,process.env.GSETTINGS_SCHEMA_DIR=le}moveItemToTrash(O,F){return L.shell.trashItem(F)}async isAdmin(){let O;return m.isWindows?O=(await new Promise((F,q)=>{j(["native-is-elevated"],F,q)}))():O=process.getuid()===0,O}async writeElevated(O,F,q,re){const Y=await new Promise((ne,ce)=>{j(["@vscode/sudo-prompt"],ne,ce)});return new Promise((ne,ce)=>{const le=[`"${this.cliPath}"`];re?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${F.fsPath}"`,`"${q.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};Y.exec(le.join(" "),K,(V,U,T)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),T&&this.logService.trace(`[sudo-prompt] received stderr: ${T}`),V?ce(V):ne(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,v.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return m.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(O,F,q){process.kill(F,q)}async readClipboardText(O,F){return L.clipboard.readText(F)}async writeClipboardText(O,F,q){return L.clipboard.writeText(F,q)}async readClipboardFindText(O){return L.clipboard.readFindText()}async writeClipboardFindText(O,F){return L.clipboard.writeFindText(F)}async writeClipboardBuffer(O,F,q,re){return L.clipboard.writeBuffer(F,Buffer.from(q.buffer),re)}async readClipboardBuffer(O,F){return g.VSBuffer.wrap(L.clipboard.readBuffer(F))}async hasClipboard(O,F,q){return L.clipboard.has(F,q)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(O,F){this.windowById(O)?.updateTouchBar(F)}async notifyReady(O){this.windowById(O)?.setReady()}async relaunch(O,F){return this.lifecycleMainService.relaunch(F)}async reload(O,F){const q=this.windowById(O);if(q){if((0,o.isWorkspaceIdentifier)(q.openedWorkspace)){const re=q.openedWorkspace.configPath;if(re.scheme===c.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(q,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(O){this.closeWindowById(O,O)}async closeWindowById(O,F){const q=this.windowById(F);if(q?.win)return q.win.close()}async quit(O){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(O,F){await this.lifecycleMainService.kill(F)}async resolveProxy(O,F){return this.windowById(O)?.win?.webContents?.session?.resolveProxy(F)}findFreePort(O,F,q,re,Y=1){return(0,s.findFreePort)(F,q,re,Y)}async openDevTools(O,F){const q=this.windowById(O);q?.win&&q.win.webContents.openDevTools(F)}async toggleDevTools(O){const F=this.windowById(O);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(O,F){const q=this.windowById(O);q?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&q.win.webContents.sendInputEvent(F)}async profileRenderer(O,F,q){const re=this.windowById(O);if(!re||!re.win)throw new Error;return await new M.WindowProfiler(re.win,F,this.logService).inspect(q)}async windowsGetStringRegKey(O,F,q,re){if(!m.isWindows)return;const Y=await new Promise((ne,ce)=>{j(["@vscode/windows-registry"],ne,ce)});try{return Y.GetStringRegKey(F,q,re)}catch{return}}windowById(O){if(typeof O=="number")return this.windowsMainService.getWindowById(O)}};Se([R.memoize],b.prototype,"cliPath",null),e.NativeHostMainService=b=Se([J(0,i.IWindowsMainService),J(1,a.IDialogMainService),J(2,C.ILifecycleMainService),J(3,f.IEnvironmentMainService),J(4,t.ILogService),J(5,l.IProductService),J(6,n.IThemeMainService),J(7,d.IWorkspacesManagementMainService)],b)}),define(te[296],ie([0,1,15,38,27,2,14,3,107,178,89,132,59,30,5,67,77,23,78,80,32,11,34,60,21,8,28,7]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t,l,n,i,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const g="issue.processExplorerWindowState";let D=e.IssueMainService=class Mt{constructor(A,O,F,q,re,Y,ne,ce,le,K,V){this.userEnv=A,this.environmentMainService=O,this.logService=F,this.diagnosticsService=q,this.diagnosticsMainService=re,this.dialogMainService=Y,this.nativeHostMainService=ne,this.protocolMainService=ce,this.productService=le,this.stateService=K,this.windowsMainService=V,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){L.validatedIpcMain.on("vscode:listProcesses",async A=>{const O=[];try{O.push({name:(0,c.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,v.isRemoteDiagnosticError)(q)?O.push({name:q.hostName,rootProcess:q}):q.processes&&O.push({name:q.hostName,rootProcess:q.processes})})}catch(F){this.logService.error(`Listing processes failed: ${F}`)}this.safeSend(A,"vscode:listProcessesResponse",O)}),L.validatedIpcMain.on("vscode:workbenchCommand",(A,O)=>{const{id:F,from:q,args:re}=O;let Y;switch(q){case"processExplorer":Y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${q}`)}Y?.webContents.send("vscode:runAction",{id:F,from:q,args:re})}),L.validatedIpcMain.on("vscode:closeProcessExplorer",A=>{this.processExplorerWindow?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async A=>{const O=await this.diagnosticsMainService.getMainDiagnostics(),F=[];for(const q of O.windows)F.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:re}of l.UtilityProcess.getAll())F.push([q,re]);this.safeSend(A,"vscode:pidToNameResponse",F)})}async openReporter(A){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=E.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const O=new _.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),q=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(q,F,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:A.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:A,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:s.default}),this.issueReporterWindow.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,O.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,O.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(A){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=E.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const O=new _.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),q=this.stateService.getItem(g,void 0),re=M(q)?q:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(re,F,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:A.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:A,product:s.default}),this.processExplorerWindow.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,O.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,O.dispose())});const Y=()=>{if(!this.processExplorerWindow)return;const ne=this.processExplorerWindow.getSize(),ce=this.processExplorerWindow.getPosition();if(!ne||!ce)return;const le={width:ne[0],height:ne[1],x:ce[0],y:ce[1]};this.stateService.setItem(g,le)};this.processExplorerWindow.on("moved",Y),this.processExplorerWindow.on("resized",Y)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const A=await E.contentTracing.stopRecording(`${(0,P.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,A),buttons:[(0,c.localize)(5,null)]},(0,C.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,A)}async getSystemStatus(){const[A,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(A,O)}async $getSystemInfo(){const[A,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(A,O)}async $getPerformanceInfo(){try{const[A,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(A,O)}catch(A){throw this.logService.warn("issueService#getPerformanceInfo ",A.message),A}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(A){this.logService.error(A)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:A}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.issueReporterWindow);A===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:A}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.issueReporterWindow);return A===0}return!1}async $getIssueReporterUri(A){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const O=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!O)throw new Error("Window not found");const F=`vscode:triggerIssueUriRequestHandlerResponse${O.id}`;return d.Promises.withAsyncBody(async(q,re)=>{const Y=new n.CancellationTokenSource;O.sendWhenReady("vscode:triggerIssueUriRequestHandler",Y.token,{replyChannel:F,extensionId:A}),L.validatedIpcMain.once(F,(ne,ce)=>{q(i.URI.parse(ce))});try{await(0,d.timeout)(5e3),Y.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{L.validatedIpcMain.removeHandler(F)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(A){A.isMinimized()&&A.restore(),A.focus()}safeSend(A,O,...F){A.sender.isDestroyed()||A.sender.send(O,...F)}createBrowserWindow(A,O,F,q){const re=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:A.width,height:A.height,minWidth:300,minHeight:200,x:A.x,y:A.y,title:F.title,backgroundColor:F.backgroundColor||Mt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,f.zoomLevelToZoomFactor)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}getWindowPosition(A,O,F){let q;const re=E.screen.getAllDisplays();if(re.length===1)q=re[0];else{if(I.isMacintosh){const ce=E.screen.getCursorScreenPoint();q=E.screen.getDisplayNearestPoint(ce)}!q&&A&&(q=E.screen.getDisplayMatching(A.getBounds())),q||(q=E.screen.getPrimaryDisplay()||re[0])}const Y=q.bounds,ne={width:O,height:F,x:Y.x+Y.width/2-O/2,y:Y.y+Y.height/2-F/2};return Y.width>0&&Y.height>0&&(ne.x<Y.x&&(ne.x=Y.x),ne.y<Y.y&&(ne.y=Y.y),ne.x>Y.x+Y.width&&(ne.x=Y.x),ne.y>Y.y+Y.height&&(ne.y=Y.y),ne.width>Y.width&&(ne.width=Y.width),ne.height>Y.height&&(ne.height=Y.height)),ne}};D.DEFAULT_BACKGROUND_COLOR="#1E1E1E",e.IssueMainService=D=Se([J(1,u.IEnvironmentMainService),J(2,y.ILogService),J(3,v.IDiagnosticsService),J(4,m.IDiagnosticsMainService),J(5,S.IDialogMainService),J(6,p.INativeHostMainService),J(7,a.IProtocolMainService),J(8,w.IProductService),J(9,t.IStateService),J(10,o.IWindowsMainService)],D);function M(b){return typeof b!="object"||b===null?!1:"x"in b&&"y"in b&&"width"in b&&"height"in b}}),define(te[297],ie([0,1,21,19,30,20,5,67,23,51,26,48,99]),function(j,e,E,L,r,_,R,I,h,c,v,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=e.LinuxUpdateService=class extends S.AbstractUpdateService{constructor(p,s,w,a,f,P,C,t){super(p,s,a,f,P,t),this.telemetryService=w,this.nativeHostMainService=C}buildUpdateFeedUrl(p){return(0,S.createUpdateURL)(`linux-${process.arch}`,p,this.productService)}doCheckForUpdates(p){this.url&&(this.setState(m.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},E.CancellationToken.None).then(c.asJson).then(s=>{!s||!s.url||!s.version||!s.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(m.State.Idle(1))):this.setState(m.State.AvailableForDownload(s))}).then(void 0,s=>{this.logService.error(s),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const w=p?s.message||s:void 0;this.setState(m.State.Idle(1,w))}))}async doDownloadUpdate(p){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(m.State.Idle(1))}};e.LinuxUpdateService=u=Se([J(0,_.ILifecycleMainService),J(1,L.IConfigurationService),J(2,v.ITelemetryService),J(3,r.IEnvironmentMainService),J(4,c.IRequestService),J(5,R.ILogService),J(6,I.INativeHostMainService),J(7,h.IProductService)],u)}),define(te[298],ie([0,1,46,42,27,7,21,55,9,8,140,22,19,30,16,20,5,67,23,51,26,48,99]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(d,g=1e3){for(;!d();)await(0,_.timeout)(g)}let n;function i(){return typeof n>"u"&&(L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?n=0:h.basename(h.normalize(h.join(process.execPath,"..","..")))==="Program Files"?n=3:n=1),n}let o=e.Win32UpdateService=class extends t.AbstractUpdateService{get cachePath(){const g=h.join((0,r.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return m.Promises.mkdir(g,{recursive:!0}).then(()=>g)}constructor(g,D,M,b,A,O,F,q,re){super(g,D,b,A,O,re),this.telemetryService=M,this.fileService=F,this.nativeHostMainService=q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(g){let D="win32";switch(process.arch!=="ia32"&&(D+=`-${process.arch}`),i()){case 1:D+="-archive";break;case 3:D+="-msi";break;default:this.productService.target==="user"&&(D+="-user")}return(0,t.createUpdateURL)(D,g,this.productService)}doCheckForUpdates(g){this.url&&(this.setState(C.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},R.CancellationToken.None).then(f.asJson).then(D=>{const M=i();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(C.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(C.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(C.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(b=>m.Promises.exists(b).then(A=>{if(A)return Promise.resolve(b);const O=D.url,F=D.hash,q=`${b}.tmp`;return this.requestService.request({url:O},R.CancellationToken.None).then(re=>this.fileService.writeFile(c.URI.file(q),re.stream)).then(F?()=>(0,v.checksum)(q,D.hash):()=>{}).then(()=>m.Promises.rename(q,b)).then(()=>b)})).then(b=>{const A=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:b},A&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(C.State.Downloaded(D)):this.setState(C.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const M=g?D.message||D:void 0;this.setState(C.State.Idle(i(),M))}))}async doDownloadUpdate(g){g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(C.State.Idle(i()))}async getUpdatePackagePath(g){const D=await this.cachePath;return h.join(D,`CodeSetup-${this.productService.quality}-${g}.exe`)}async cleanup(g=null){const D=g?O=>!new RegExp(`${this.productService.quality}-${g}\\.exe$`).test(O):()=>!0,M=await this.cachePath,A=(await m.Promises.readdir(M)).filter(D).map(async O=>{try{await m.Promises.unlink(h.join(M,O))}catch{}});await Promise.all(A)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const g=this.state.update;this.setState(C.State.Updating(g));const D=await this.cachePath;this.availableUpdate.updateFilePath=h.join(D,`CodeSetup-${this.productService.quality}-${g.version}.flag`),await m.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(C.State.Idle(i()))});const b=`${this.productService.win32MutexName}-ready`,A=await new Promise((O,F)=>{j(["@vscode/windows-mutex"],O,F)});l(()=>A.isActive(b)).then(()=>this.setState(C.State.Ready(g)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):i()==3?(0,E.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}async _applySpecificUpdate(g){if(this.state.type!=="idle")return;const D=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!D};this.setState(C.State.Downloading(M)),this.availableUpdate={packagePath:g},D?this.productService.target==="user"?this.doApplyUpdate():this.setState(C.State.Downloaded(M)):this.setState(C.State.Ready(M))}};Se([I.memoize],o.prototype,"cachePath",null),e.Win32UpdateService=o=Se([J(0,p.ILifecycleMainService),J(1,S.IConfigurationService),J(2,P.ITelemetryService),J(3,u.IEnvironmentMainService),J(4,f.IRequestService),J(5,s.ILogService),J(6,y.IFileService),J(7,w.INativeHostMainService),J(8,a.IProductService)],o)}),define(te[299],ie([0,1,15,7,21,50,4,2,14,9,65,3,8,188,64,19,59,30,63,16,20,5,23,78,249,98,26,102,79,80,28,29,54,127,133,39,34,53,66,24]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t,l,n,i,o,d,g,D,M,b,A,O,F,q,re,Y,ne,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var le;(function(V){V[V.NONE=0]="NONE",V[V.NAVIGATING=1]="NAVIGATING",V[V.READY=2]="READY"})(le||(le={}));let K=e.CodeWindow=class yt extends I.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const U=this.userDataProfilesService.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,b.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(U,T,x,Q,Z,ae,oe,N,k,W,z,H,B,$,G,se,ue,ye,Ce,Re){super(),this.logService=T,this.loggerMainService=x,this.environmentMainService=Q,this.policyService=Z,this.userDataProfilesService=ae,this.fileService=oe,this.applicationStorageMainService=N,this.storageMainService=k,this.configurationService=W,this.themeMainService=z,this.workspacesManagementMainService=H,this.backupMainService=B,this.telemetryService=$,this.dialogMainService=G,this.lifecycleMainService=se,this.productService=ue,this.protocolMainService=ye,this.windowsMainService=Ce,this.stateService=Re,this._onWillLoad=this._register(new R.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new R.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new R.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new R.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new R.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Le,Te]=this.restoreWindowState(U.state);this.windowState=Le,this.logService.trace("window#ctor: using window state",Le);const we=this.windowState.mode===0||this.windowState.mode===3,ve=this.configurationService.getValue("window"),Ee={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!we,title:this.productService.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(ve?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};m.isLinux?Ee.icon=(0,c.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(Ee.icon=(0,c.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(Ee.fullscreenable=!1),m.isMacintosh&&(Ee.acceptFirstMouse=!0,ve?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const ee=m.isMacintosh&&ve?.nativeTabs===!0;ee&&(Ee.tabbingIdentifier=this.productService.nameShort);const de=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(de&&(Ee.titleBarStyle="hidden",m.isMacintosh||(Ee.frame=!1),(0,D.useWindowControlsOverlay)(this.configurationService))){const fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ke=F.Color.fromHex(fe).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:fe,symbolColor:ke},this.hasWindowControlOverlay=!0}if((0,v.mark)("code/willCreateCodeBrowserWindow"),this._win=new E.BrowserWindow(Ee),(0,v.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,m.isMacintosh&&de&&this._win.setSheetOffset(22),de&&(m.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService)||m.isMacintosh)){const fe=this.stateService.getItem(yt.windowControlHeightStateStorageKey);fe&&this.updateWindowControls({height:fe})}m.isWindows&&de&&this._win.hookWindowMessage(278,()=>{const[ke,De]=this._win.getPosition(),_e=E.screen.getCursorScreenPoint(),We=_e.x-ke,qe=_e.y-De;return(()=>!(We>30&&qe>=0&&qe<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:We,y:qe})),0}),(m.isMacintosh||m.isWindows)&&Te&&(!ee||E.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(fe=>typeof fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),we&&((0,v.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,v.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(U){m.isMacintosh?this._win.setRepresentedFilename(U):this.representedFilename=U}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(U){m.isMacintosh&&this._win.setDocumentEdited(U),this.documentEdited=U}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(U){m.isMacintosh&&U?.force&&E.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.whenReadyCallbacks.push(U)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(U=>{function T(){x.dispose(),Q.dispose(),U()}const x=this.onDidClose(()=>T()),Q=this.onWillLoad(()=>T())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(T,x)=>this.onWindowError(2,{...x})),this._win.webContents.on("did-fail-load",(T,x,Q)=>this.onWindowError(3,{reason:Q,exitCode:x})),this._win.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",T=>{this._config&&(this._config.maximized=!0),E.app.emit("browser-window-maximize",T,this._win)}),this._win.on("unmaximize",T=>{this._config&&(this._config.maximized=!1),E.app.emit("browser-window-unmaximize",T,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(T=>this.onConfigurationUpdated(T))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(T=>this.onDidDeleteUntitledWorkspace(T)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(T,x)=>{const Q=await this.getMarketplaceHeaders();x({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,Q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(U,T){switch(U){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:U,reason:T?.reason,code:T?.exitCode}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:x,checkboxChecked:Q}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null),(0,u.localize)(2,null)],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),checkboxLabel:this._config?.workspace?(0,u.localize)(5,null):void 0},this._win);if(x!==2){const Z=x===0;await this.destroyWindow(Z,Q)}}else if(U===2){let x;T?x=(0,u.localize)(7,null,T.reason,T.exitCode??"<unknown>"):x=(0,u.localize)(6,null);const{response:Q,checkboxChecked:Z}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,u.localize)(8,null):(0,u.localize)(9,null),(0,u.localize)(10,null)],message:x,detail:this._config?.workspace?(0,u.localize)(11,null):(0,u.localize)(12,null),checkboxLabel:this._config?.workspace?(0,u.localize)(13,null):void 0},this._win),ae=Q===0;await this.destroyWindow(ae,Z)}break}}async destroyWindow(U,T){const x=this._config?.workspace;if(T&&x)try{const Q=this.storageMainService.workspaceStorage(x);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.logService.error(Q)}if(this._onDidDestroy.fire(),this._win?.destroy(),U&&this._config){let Q,Z;(0,b.isSingleFolderWorkspaceIdentifier)(x)?Q={folderUri:x.uri}:(0,b.isWorkspaceIdentifier)(x)?Q={workspaceUri:x.configPath}:Z=!0,(0,ce.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:Z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(U){this._config?.workspace?.id===U.id&&(this._config.workspace=void 0)}onConfigurationUpdated(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const T=this.getMenuBarVisibility();T!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=T,this.setMenuBarVisibility(T))}if(!U||U.affectsConfiguration("http.proxy")){let T=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const x=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.currentHttpProxy||x!==this.currentNoProxy)){this.currentHttpProxy=T,this.currentNoProxy=x;const Q=T||"",Z=x?`${x},<local>`:"<local>";this.logService.trace(`Setting proxy to '${Q}', bypassing '${Z}'`),this._win.webContents.session.setProxy({proxyRules:Q,proxyBypassRules:Z,pacScript:""})}}}addTabbedWindow(U){m.isMacintosh&&U.win&&this._win.addTabbedWindow(U.win)}load(U,T=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!T.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(U,T),this.readyState===0?this._config=U:this.pendingLoadConfig=U,this.readyState=1,this._win.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const x=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:U.workspace,reason:T.isReload?3:x?2:1})}updateConfiguration(U,T){const x=(this._config??this.pendingLoadConfig)?.userEnv;if(x){const Q=(0,a.isLaunchedFromCli)(x)&&!(0,a.isLaunchedFromCli)(U.userEnv),Z=this.isExtensionDevelopmentHost;(Q||Z)&&(U.userEnv={...x,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(U["disable-extensions"]=T.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this._win.isMaximized(),U.partsSplash=this.themeMainService.getWindowSplash(),(0,v.mark)("code/willOpenNewWindow"),U.perfMarks=(0,v.getMarks)(),this.configObjectUrl.update(U)}async reload(U){const T=Object.assign({},this._config);T.workspace=await this.validateWorkspaceBeforeReload(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&U&&(T.verbose=U.verbose,T.debugId=U.debugId,T.extensionEnvironment=U.extensionEnvironment,T["inspect-extensions"]=U["inspect-extensions"],T["inspect-brk-extensions"]=U["inspect-brk-extensions"],T["extensions-dir"]=U["extensions-dir"]),T.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.policyService.serialize(),T.continueOn=this.environmentMainService.continueOn,T.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},T.logLevel=this.loggerMainService.getLogLevel(),T.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async validateWorkspaceBeforeReload(U){if((0,b.isWorkspaceIdentifier)(U.workspace)){const T=U.workspace.configPath;if(T.scheme===h.Schemas.file&&!await this.fileService.exists(T))return}else if((0,b.isSingleFolderWorkspaceIdentifier)(U.workspace)){const T=U.workspace.uri;if(T.scheme===h.Schemas.file&&!await this.fileService.exists(T))return}return U.workspace}serializeWindowState(){if(!this._win)return(0,O.defaultWindowState)();if(this.isFullScreen){let x;try{x=E.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,O.defaultWindowState)();return{mode:3,display:x?x.id:void 0,width:this.windowState.width||Q.width,height:this.windowState.height||Q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const U=Object.create(null);let T;if(!m.isMacintosh&&this._win.isMaximized()?T=0:T=1,T===0?U.mode=0:U.mode=1,T===1||T===0){let x;T===1?x=this.getBounds():x=this._win.getNormalBounds(),U.x=x.x,U.y=x.y,U.width=x.width,U.height=x.height}return U}updateWindowControls(U){if(U.height&&this.stateService.setItem(yt.windowControlHeightStateStorageKey,U.height),m.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(m.isMacintosh&&U.height!==void 0){const T=(U.height-15)/2;this._win.setTrafficLightPosition({x:T,y:T})}}restoreWindowState(U){(0,v.mark)("code/willRestoreCodeWindowState");let T=!1;if(U)try{const x=E.screen.getAllDisplays();T=x.length>1,U=this.validateWindowState(U,x)}catch(x){this.logService.warn(`Unexpected error validating window state: ${x}
${x.stack}`)}return(0,v.mark)("code/didRestoreCodeWindowState"),[U||(0,O.defaultWindowState)(),T]}validateWindowState(U,T){if(this.logService.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const Z=this.getWorkingArea(T[0]);if(Z){let ae=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!Z||(U.x<Z.x&&(U.x=Z.x),U.y<Z.y&&(U.y=Z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Z),ae(),U.width>Z.width&&(U.width=Z.width),U.height>Z.height&&(U.height=Z.height),U.x>Z.x+Z.width-128&&(U.x=Z.x+Z.width-U.width),U.y>Z.y+Z.height-128&&(U.y=Z.y+Z.height-U.height),ae()}return U}if(U.display&&U.mode===3){const Z=T.find(ae=>ae.id===U.display);if(Z&&typeof Z.bounds?.x=="number"&&typeof Z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const ae=(0,O.defaultWindowState)(3);return ae.x=Z.bounds.x,ae.y=Z.bounds.y,ae}}let x,Q;try{x=E.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),Q=this.getWorkingArea(x)}catch{}if(x&&Q&&U.x+U.width>Q.x&&U.y+U.height>Q.y&&U.x<Q.x+Q.width&&U.y<Q.y+Q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",Q),U}getWorkingArea(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,T]=this._win.getPosition(),[x,Q]=this._win.getSize();return{x:U,y:T,width:x,height:Q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(U){this.useNativeFullScreen()?this.setNativeFullScreen(U):this.setSimpleFullScreen(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return m.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(U){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(U)}doSetNativeFullScreen(U){m.isMacintosh&&(this.transientIsNativeFullScreen=U,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(U)}setSimpleFullScreen(U){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(U),this._win.webContents.focus()}useNativeFullScreen(){const U=this.configurationService.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let U=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}setMenuBarVisibility(U,T=!0){m.isMacintosh||(U==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,u.localize)(14,null)),U==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(U)}):this.doSetMenuBarVisibility(U))}doSetMenuBarVisibility(U){const T=this.isFullScreen;switch(U){case"classic":this._win.setMenuBarVisibility(!T),this._win.autoHideMenuBar=T;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(U,T,...x){this.isReady?this.send(U,...x):this.ready().then(()=>{T.isCancellationRequested||this.send(U,...x)})}send(U,...T){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this._win.webContents.send(U,...T)}catch(x){this.logService.warn(`Error sending IPC message to channel '${U}' of window ${this._id}: ${(0,_.toErrorMessage)(x)}`)}}}updateTouchBar(U){m.isMacintosh&&this.touchBarGroups.forEach((T,x)=>{const Q=U[x];T.segments=this.createTouchBarGroupSegments(Q)})}createTouchBar(){if(m.isMacintosh){for(let U=0;U<10;U++){const T=this.createTouchBarGroup();this.touchBarGroups.push(T)}this._win.setTouchBar(new E.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(U=[]){const T=this.createTouchBarGroupSegments(U),x=new E.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:x.segments[Q].id,from:"touchbar"})}});return x}createTouchBarGroupSegments(U=[]){return U.map(x=>{let Q;x.icon&&!d.ThemeIcon.isThemeIcon(x.icon)&&x.icon?.dark?.scheme===h.Schemas.file&&(Q=E.nativeImage.createFromPath(S.URI.revive(x.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let Z;return typeof x.title=="string"?Z=x.title:Z=x.title.value,{id:x.id,label:Q?void 0:Z,icon:Q}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};K.windowControlHeightStateStorageKey="windowControlHeight",e.CodeWindow=K=Se([J(1,C.ILogService),J(2,ne.ILoggerMainService),J(3,w.IEnvironmentMainService),J(4,q.IPolicyService),J(5,Y.IUserDataProfilesMainService),J(6,f.IFileService),J(7,i.IApplicationStorageMainService),J(8,i.IStorageMainService),J(9,p.IConfigurationService),J(10,g.IThemeMainService),J(11,A.IWorkspacesManagementMainService),J(12,y.IBackupMainService),J(13,o.ITelemetryService),J(14,s.IDialogMainService),J(15,P.ILifecycleMainService),J(16,t.IProductService),J(17,l.IProtocolMainService),J(18,M.IWindowsMainService),J(19,re.IStateService)],K)}),define(te[82],ie([0,1,15,24,7,4,45,2,14,3,18,8,22,191,6,20,5,98,96,29,54,35]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let t=e.WorkspacesHistoryMainService=class nt extends I.Disposable{constructor(n,i,o,d){super(),this.logService=n,this.workspacesManagementMainService=i,this.lifecycleMainService=o,this.applicationStorageMainService=d,this._onDidChangeRecentlyOpened=this._register(new _.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let i=[],o=[];for(const g of n)if((0,a.isRecentWorkspace)(g))!this.workspacesManagementMainService.isUntitledWorkspace(g.workspace)&&!this.containsWorkspace(i,g.workspace)&&i.push(g);else if((0,a.isRecentFolder)(g))this.containsFolder(i,g.folderUri)||i.push(g);else{const D=this.containsFile(o,g.fileUri),M=g.fileUri.scheme===h.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,v.basename)(g.fileUri))>=0;!D&&!M&&(o.push(g),c.isWindows&&g.fileUri.scheme===h.Schemas.file&&E.app.addRecentDocument(g.fileUri.fsPath))}const d=await this.mergeEntriesFromStorage({workspaces:i,files:o});i=d.workspaces,o=d.files,i.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=nt.MAX_TOTAL_RECENT_ENTRIES),o.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(o.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:o}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const i=D=>{const M=this.location(D);for(const b of n)if(v.extUriBiasedIgnorePathCase.isEqual(b,M))return!1;return!0},o=await this.getRecentlyOpened(),d=o.workspaces.filter(i),g=o.files.filter(i);(d.length!==o.workspaces.length||g.length!==o.files.length)&&(await this.saveRecentlyOpened({files:g,workspaces:d}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(n){const i=new C.ResourceMap(g=>v.extUriBiasedIgnorePathCase.getComparisonKey(g));if(n?.workspaces)for(const g of n.workspaces)i.set(this.location(g),g);const o=new C.ResourceMap(g=>v.extUriBiasedIgnorePathCase.getComparisonKey(g));if(n?.files)for(const g of n.files)o.set(this.location(g),g);const d=await this.getRecentlyOpenedFromStorage();for(const g of d.workspaces){const D=i.get(this.location(g));D?D.label=D.label??g.label:i.set(this.location(g),g)}for(const g of d.files){const D=o.get(this.location(g));D?D.label=D.label??g.label:o.set(this.location(g),g)}return{workspaces:[...i.values()],files:[...o.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const i=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{n=JSON.parse(i)}catch(o){this.logService.error("Unexpected error parsing opened paths list",o)}return(0,a.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,a.toStoreData)(n)),-1,1)}location(n){return(0,a.isRecentFolder)(n)?n.folderUri:(0,a.isRecentFile)(n)?n.fileUri:n.workspace.configPath}containsWorkspace(n,i){return!!n.find(o=>(0,a.isRecentWorkspace)(o)&&o.workspace.id===i.id)}containsFolder(n,i){return!!n.find(o=>(0,a.isRecentFolder)(o)&&v.extUriBiasedIgnorePathCase.isEqual(o.folderUri,i))}containsFile(n,i){return!!n.find(o=>v.extUriBiasedIgnorePathCase.isEqual(o.fileUri,i))}async handleWindowsJumpList(){c.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!c.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const g of E.app.getJumpListSettings().removedItems){const D=g.args;if(D){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);M&&i.push(m.URI.parse(M[2]))}}await this.removeRecentlyOpened(i);let o=!1;const d=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(g=>{const D=(0,a.isRecentWorkspace)(g)?g.workspace:g.folderUri,{title:M,description:b}=this.getWindowsJumpListLabel(D,g.label);let A;return m.URI.isUri(D)?A=`--folder-uri "${D.toString()}"`:(o=!0,A=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:b.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));d.length>0&&n.push({type:"custom",name:o?(0,u.localize)(2,null):(0,u.localize)(3,null),items:d})}n.push({type:"recent"});try{const i=E.app.setJumpList(n);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(n,i){if(i)return{title:(0,R.splitRecentLabel)(i).name,description:i};if(m.URI.isUri(n))return{title:(0,v.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,u.localize)(4,null),description:""};let o=(0,v.basename)(n.configPath);return o.endsWith(f.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,o),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,R.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!c.isMacintosh)return;E.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),i=[];let o=0;for(let g=0;g<n.workspaces.length&&o<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;g++){const D=this.location(n.workspaces[g]);if(D.scheme===h.Schemas.file){const M=(0,v.originalFSPath)(D);await S.Promises.exists(M)&&(i.push(M),o++)}}const d=[];for(let g=0;g<n.files.length&&o<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;g++){const D=this.location(n.files[g]);if(D.scheme===h.Schemas.file){const M=(0,v.originalFSPath)(D);if(nt.COMMON_FILES_FILTER.includes((0,v.basename)(D))||i.includes(M))continue;await S.Promises.exists(M)&&(d.push(M),o++)}}d.reverse().forEach(g=>E.app.addRecentDocument(g)),i.reverse().forEach(g=>E.app.addRecentDocument(g))}};t.MAX_TOTAL_RECENT_ENTRIES=500,t.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",t.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,t.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,t.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],e.WorkspacesHistoryMainService=t=Se([J(0,s.ILogService),J(1,P.IWorkspacesManagementMainService),J(2,p.ILifecycleMainService),J(3,w.IApplicationStorageMainService)],t)}),define(te[300],ie([0,1,15,7,21,45,3,8,179,19,30,20,5,229,67,23,34,26,48,80,28,82]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let l=e.Menubar=class bt{constructor(o,d,g,D,M,b,A,O,F,q,re){this.updateService=o,this.configurationService=d,this.windowsMainService=g,this.environmentMainService=D,this.telemetryService=M,this.workspacesHistoryMainService=b,this.stateService=A,this.lifecycleMainService=O,this.logService=F,this.nativeHostMainService=q,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateService.getItem(bt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(b,A,O)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:A?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(b,A,O)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:A?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(b,A,O)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(b,A,O)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(b,A,O)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const d=this.productService.requestFeatureUrl;d&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(d,"openUserVoiceUrl"));const g=this.productService.reportIssueUrl;g&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(g,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const b=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${b}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,d){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateService.setItem(bt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){R.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){R.isMacintosh&&(this.noActiveWindow=!E.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=E.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){E.Menu.setApplicationMenu(R.isMacintosh?new E.Menu:null);return}const d=new E.Menu;let g;if(R.isMacintosh){const M=new E.Menu;g=new E.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),d.append(g)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new E.Menu;M.append(new E.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),E.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:M});this.setMenuById(M,"File"),d.append(b)}if(this.shouldDrawMenu("Edit")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),d.append(b)}if(this.shouldDrawMenu("Selection")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),d.append(b)}if(this.shouldDrawMenu("View")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:M});this.setMenuById(M,"View"),d.append(b)}if(this.shouldDrawMenu("Go")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),d.append(b)}if(this.shouldDrawMenu("Run")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),d.append(b)}if(this.shouldDrawMenu("Terminal")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),d.append(b)}let D;if(this.shouldDrawMenu("Window")){const M=new E.Menu;D=new E.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(D&&d.append(D),this.shouldDrawMenu("Help")){const M=new E.Menu,b=new E.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),d.append(b)}d.items&&d.items.length>0?E.Menu.setApplicationMenu(d):E.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const d=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),g=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const Y=new E.Menu;this.setMenuById(Y,"Preferences"),D=new E.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:Y})}const M=new E.Menu,b=new E.MenuItem({label:h.localize(12,null),role:"services",submenu:M}),A=new E.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),O=new E.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),F=new E.MenuItem({label:h.localize(15,null),role:"unhide"}),q=new E.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(Y,ne,ce)=>{const le=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.confirmBeforeQuit(ce)&&this.nativeHostMainService.quit(void 0)}})),re=[d];re.push(...g),D&&re.push(n(),D),re.push(n(),b,n(),A,O,F,n(),q),re.forEach(Y=>o.append(Y))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const d=this.configurationService.getValue("window.confirmBeforeClose");if(d==="always"||d==="keyboardOnly"&&this.isKeyboardEvent(o)){const{response:g}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return g===0}return!0}shouldDrawMenu(o){if(!R.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,d){d.forEach(g=>{if((0,u.isMenubarMenuItemSeparator)(g))o.append(n());else if((0,u.isMenubarMenuItemSubmenu)(g)){const D=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(g.label),submenu:D});this.setMenu(D,g.submenu.items),o.append(M)}else(0,u.isMenubarMenuItemRecentAction)(g)?o.append(this.createOpenRecentMenuItem(g)):(0,u.isMenubarMenuItemAction)(g)&&(g.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[g.id]?o.append(new E.MenuItem(this.likeAction(g.id,{label:this.mnemonicLabel(g.label),click:this.fallbackMenuHandlers[g.id]}))):o.append(this.createMenuItem(g.label,g.id,!1,g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)))})}setMenuById(o,d){this.menubarMenus&&this.menubarMenus[d]&&this.setMenu(o,this.menubarMenus[d].items)}insertCheckForUpdatesItems(o){const d=this.getUpdateMenuItems();d.length&&(d.forEach(g=>o.append(g)),o.append(n()))}createOpenRecentMenuItem(o){const d=I.URI.revive(o.uri),g=o.id,D=g==="openRecentFile"?{fileUri:d}:g==="openRecentWorkspace"?{workspaceUri:d}:{folderUri:d};return new E.MenuItem(this.likeAction(g,{label:o.label,click:async(M,b,A)=>{const O=this.isOptionClick(A);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:O,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([d])}},!1))}isOptionClick(o){return!!(o&&(!R.isMacintosh&&(o.ctrlKey||o.shiftKey)||R.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,d,g){const D={label:this.mnemonicLabel(o),role:g,enabled:!0};return new E.MenuItem(this.withKeybinding(d,D))}setMacWindowMenu(o){const d=new E.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),g=new E.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new E.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),b=[];this.currentEnableNativeTabs&&(b.push(n()),b.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),b.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),b.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),b.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),b.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[d,g,n(),M,...b,n(),D].forEach(A=>o.append(A))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new E.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,d,g,D){const M=this.mnemonicLabel(o),b=typeof d=="function"?d:(re,Y,ne)=>{const ce=re?re.userSettingsLabel:null;let le=d;Array.isArray(d)&&(le=this.isOptionClick(ne)?d[1]:d[0]),ce&&ne.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ce}):this.runActionInRenderer({type:"commandId",commandId:le})},A=typeof g=="boolean"?g:this.windowsMainService.getWindowCount()>0,O=typeof D=="boolean"?D:!1,F={label:M,click:b,enabled:A};O&&(F.type="checkbox",F.checked=O);let q;return typeof d=="string"?q=d:Array.isArray(d)&&(q=d[0]),R.isMacintosh&&(q==="editor.action.clipboardCutAction"?F.role="cut":q==="editor.action.clipboardCopyAction"?F.role="copy":q==="editor.action.clipboardPasteAction"&&(F.role="paste"),q==="undo"?F.click=this.makeContextAwareClickHandler(b,{inDevTools:re=>re.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?F.click=this.makeContextAwareClickHandler(b,{inDevTools:re=>re.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(F.click=this.makeContextAwareClickHandler(b,{inDevTools:re=>re.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.withKeybinding(q,F))}makeContextAwareClickHandler(o,d){return(g,D,M)=>{const b=E.BrowserWindow.getFocusedWindow();if(!b)return d.inNoWindow();if(b.webContents.isDevToolsFocused()&&b.webContents.devToolsWebContents)return d.inDevTools(b.webContents.devToolsWebContents);o(g,D||b,M)}}runActionInRenderer(o){let d=E.BrowserWindow.getFocusedWindow();if(!d){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(d=D.win)}const g=d?this.windowsMainService.getWindowById(d.id):void 0;if(g){if(this.logService.trace("menubar#runActionInRenderer",o),R.isMacintosh&&!this.environmentMainService.isBuilt&&!g.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};g.sendWhenReady("vscode:runAction",r.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};g.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,d){const g=typeof o=="string"?this.keybindings[o]:void 0;if(g?.label){if(g.isNative!==!1)d.accelerator=g.label,d.userSettingsLabel=g.userSettingsLabel;else if(typeof d.label=="string"){const D=d.label.indexOf("[");D>=0?d.label=`${d.label.substr(0,D)} [${g.label}]`:d.label=`${d.label} [${g.label}]`}}else d.accelerator=void 0;return d}likeAction(o,d,g=!d.accelerator){g&&(d=this.withKeybinding(o,d));const D=d.click;return d.click=(M,b,A)=>{this.reportMenuActionTelemetry(o),D?.(M,b,A)},d}openUrl(o,d){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(d)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:t})}mnemonicLabel(o){return(0,_.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",e.Menubar=l=Se([J(0,a.IUpdateService),J(1,c.IConfigurationService),J(2,P.IWindowsMainService),J(3,v.IEnvironmentMainService),J(4,w.ITelemetryService),J(5,C.IWorkspacesHistoryMainService),J(6,s.IStateService),J(7,m.ILifecycleMainService),J(8,S.ILogService),J(9,y.INativeHostMainService),J(10,p.IProductService)],l);function n(){return new E.MenuItem({type:"separator"})}}),define(te[301],ie([0,1,6,20,5,300]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let R=e.MenubarMainService=class{constructor(h,c,v){this.instantiationService=h,this.lifecycleMainService=c,this.logService=v,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(_.Menubar)}async updateMenubar(h,c){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(c,h)}};e.MenubarMainService=R=Se([J(0,E.IInstantiationService),J(1,L.ILifecycleMainService),J(2,r.ILogService)],R)}),define(te[302],ie([0,1,15,22,131,27,24,21,4,32,49,45,2,14,9,65,3,36,18,11,8,189,64,19,59,30,16,6,20,5,77,78,58,34,80,299,129,295,29,97,82,54,79,39,53,66]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t,l,n,i,o,d,g,D,M,b,A,O,F,q,re,Y,ne,ce,le,K,V,U,T,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Q(oe){return(0,ne.isWorkspaceIdentifier)(oe?.workspace)}function Z(oe){return(0,ne.isSingleFolderWorkspaceIdentifier)(oe?.workspace)}let ae=e.WindowsMainService=class at extends S.Disposable{constructor(N,k,W,z,H,B,$,G,se,ue,ye,Ce,Re,Le,Te,we,ve,Ee){super(),this.machineId=N,this.initialUserEnv=k,this.logService=W,this.loggerService=z,this.stateService=H,this.policyService=B,this.environmentMainService=$,this.userDataProfilesMainService=G,this.lifecycleMainService=se,this.backupMainService=ue,this.configurationService=ye,this.workspacesHistoryMainService=Ce,this.workspacesManagementMainService=Re,this.instantiationService=Le,this.dialogMainService=Te,this.fileService=we,this.protocolMainService=ve,this.themeMainService=Ee,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new h.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new Y.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(N=>this._onDidSignalReadyWindow.fire(N.window))),this._register(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const k=new S.DisposableStore;if(k.add(h.Event.any(N.onDidClose,N.onDidDestroy)(()=>k.dispose())),N.config.extensionDevelopmentPath)for(const W of N.config.extensionDevelopmentPath)k.add(this.protocolMainService.addValidFileRoot(W));N.config.extensionTestsPath&&k.add(this.protocolMainService.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,k){const W=this.environmentMainService.args,z=k?.remoteAuthority||void 0,H=!0,B=k?.forceReuseWindow,$=!B;return this.open({...N,cli:W,forceEmpty:H,forceNewWindow:$,forceReuseWindow:B,remoteAuthority:z})}openExistingWindow(N,k){N.focus(),this.handleWaitMarkerFile(k,[N])}async open(N){this.logService.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const k=[],W=[],z=[],H=[],B=[];let $,G=0;const se=await this.getPathsToOpen(N);this.logService.trace("windowsManager#open pathsToOpen",se);for(const Le of se)Z(Le)?N.addMode?k.push(Le):W.push(Le):Q(Le)?z.push(Le):Le.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Le.remoteAuthority}),$.filesToOpenOrCreate.push(Le)):Le.backupPath?B.push({backupFolder:(0,y.basename)(Le.backupPath),remoteAuthority:Le.remoteAuthority}):G++;N.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),N.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&N.waitMarkerFileURI&&($.filesToWait={paths:(0,R.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(H.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),z.push(...H),B.push(...this.backupMainService.getEmptyWindowBackups())):B.length=0;const{windows:ue,filesOpenedInWindow:ye}=await this.doOpen(N,z,W,B,G,$,k);if(this.logService.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${W.length}, emptyToRestore: ${B.length}, emptyToOpen: ${G})`),ue.length>1)if(ye)ye.focus();else{const Le=this.windowsStateHandler.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let Te=!0,we=!0;if(Le){const ve=ue.filter(Ee=>this.windowsStateHandler.state.lastActiveWindow&&Ee.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Te=!1,we=!1)}if(Te)for(let ve=ue.length-1;ve>=0;ve--){const Ee=ue[ve];if(!(Ee.openedWorkspace&&H.some(ee=>Ee.openedWorkspace&&ee.workspace.id===Ee.openedWorkspace.id)||Ee.backupPath&&B.some(ee=>Ee.backupPath&&ee.backupFolder===(0,y.basename)(Ee.backupPath)))){Ee.focus(),we=!1;break}}we&&ue[ue.length-1].focus()}const Ce=$&&$.filesToDiff.length>0,Re=$&&$.filesToMerge.length>0;if(!ue.some(Le=>Le.isExtensionDevelopmentHost)&&!Ce&&!Re&&!N.noRecentEntry){const Le=[];for(const Te of se)Q(Te)&&!Te.transient?Le.push({label:Te.label,workspace:Te.workspace,remoteAuthority:Te.remoteAuthority}):Z(Te)?Le.push({label:Te.label,folderUri:Te.workspace.uri,remoteAuthority:Te.remoteAuthority}):Te.fileUri&&Le.push({label:Te.label,fileUri:Te.fileUri,remoteAuthority:Te.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Le)}return this.handleWaitMarkerFile(N,ue),ue}handleWaitMarkerFile(N,k){const W=N.waitMarkerFileURI;N.context===0&&W&&k.length===1&&k[0]&&(async()=>{await k[0].whenClosedOrLoaded;try{await this.fileService.del(W)}catch{}})()}async doOpen(N,k,W,z,H,B,$){const G=[];let se;function ue(ve,Ee){G.push(ve),Ee&&(se=ve,B=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:Ce}=this.shouldOpenNewWindow(N);if(!N.initialStartup&&$.length>0){const ve=$[0].remoteAuthority,Ee=this.getLastActiveWindowForAuthority(ve);Ee&&ue(this.doAddFoldersToExistingWindow(Ee,$.map(ee=>ee.workspace.uri)))}const Re=W.length+k.length+z.length;if(B&&Re===0){const ve=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],Ee=this.getWindows().filter(de=>B&&(0,a.isEqualAuthority)(de.remoteAuthority,B.remoteAuthority));let ee;ve?.fileUri&&!Ce&&((N.context===4||N.context===0||N.context===1)&&(ee=await(0,re.findWindowOnFile)(Ee,ve.fileUri,async de=>de.configPath.scheme===u.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(de.configPath):void 0)),ee||(ee=this.doGetLastActiveWindow(Ee))),ee?(0,ne.isWorkspaceIdentifier)(ee.openedWorkspace)?k.push({workspace:ee.openedWorkspace,remoteAuthority:ee.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(ee.openedWorkspace)?W.push({workspace:ee.openedWorkspace,remoteAuthority:ee.remoteAuthority}):ue(this.doOpenFilesInExistingWindow(N,ee,B),!0):ue(await this.openInBrowserWindow({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const Le=(0,R.distinct)(k,ve=>ve.workspace.id);if(Le.length>0){const ve=(0,R.coalesce)(Le.map(Ee=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ee.workspace.configPath)));if(ve.length>0){const Ee=ve[0],ee=(0,a.isEqualAuthority)(B?.remoteAuthority,Ee.remoteAuthority)?B:void 0;ue(this.doOpenFilesInExistingWindow(N,Ee,ee),!!ee),ye=!0}for(const Ee of Le){if(ve.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===Ee.workspace.id))continue;const ee=Ee.remoteAuthority,de=(0,a.isEqualAuthority)(B?.remoteAuthority,ee)?B:void 0;ue(await this.doOpenFolderOrWorkspace(N,Ee,ye,de),!!de),ye=!0}}const Te=(0,R.distinct)(W,ve=>a.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Te.length>0){const ve=(0,R.coalesce)(Te.map(Ee=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ee.workspace.uri)));if(ve.length>0){const Ee=ve[0],ee=(0,a.isEqualAuthority)(B?.remoteAuthority,Ee.remoteAuthority)?B:void 0;ue(this.doOpenFilesInExistingWindow(N,Ee,ee),!!ee),ye=!0}for(const Ee of Te){if(ve.some(fe=>(0,ne.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&a.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,Ee.workspace.uri)))continue;const ee=Ee.remoteAuthority,de=(0,a.isEqualAuthority)(B?.remoteAuthority,ee)?B:void 0;ue(await this.doOpenFolderOrWorkspace(N,Ee,ye,de),!!de),ye=!0}}const we=(0,R.distinct)(z,ve=>ve.backupFolder);if(we.length>0)for(const ve of we){const Ee=ve.remoteAuthority,ee=(0,a.isEqualAuthority)(B?.remoteAuthority,Ee)?B:void 0;ue(await this.doOpenEmpty(N,!0,Ee,ee,ve),!!ee),ye=!0}if(G.length===0||B){B&&!H&&H++;const ve=B?B.remoteAuthority:N.remoteAuthority;for(let Ee=0;Ee<H;Ee++)ue(await this.doOpenEmpty(N,ye,ve,B),!!B),ye=!0}return{windows:(0,R.distinct)(G),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(N,k,W){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),k.focus();const z={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return k.sendWhenReady("vscode:openFiles",I.CancellationToken.None,z),k}doAddFoldersToExistingWindow(N,k){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:k}),N.focus();const W={foldersToAdd:k};return N.sendWhenReady("vscode:addFolders",I.CancellationToken.None,W),N}doOpenEmpty(N,k,W,z,H){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:W,filesToOpen:z,forceNewWindow:k});let B;return!k&&typeof N.contextWindowId=="number"&&(B=this.getWindowById(N.contextWindowId)),this.openInBrowserWindow({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:W,forceNewWindow:k,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:z,windowToUse:B,emptyWindowBackupInfo:H,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}doOpenFolderOrWorkspace(N,k,W,z,H){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:k,filesToOpen:z}),!W&&!H&&typeof N.contextWindowId=="number"&&(H=this.getWindowById(N.contextWindowId)),this.openInBrowserWindow({workspace:k.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:k.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:z,windowToUse:H,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async getPathsToOpen(N){let k,W=!1,z=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(k=await this.doExtractPathsFromAPI(N),W=!0):N.forceEmpty?k=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(k=await this.doExtractPathsFromCLI(N.cli),k.length===0&&k.push(Object.create(null)),W=!0):(k=await this.doGetPathsFromLastSession(),k.length===0&&k.push(Object.create(null)),z=!0),!N.addMode&&W){const H=k.filter(B=>Z(B));if(H.length>1){const B=H[0].remoteAuthority;if(H.every($=>(0,a.isEqualAuthority)($.remoteAuthority,B))){const $=await this.workspacesManagementMainService.createUntitledWorkspace(H.map(G=>({uri:G.workspace.uri})));k.push({workspace:$,remoteAuthority:B}),k=k.filter(G=>!Z(G))}}}if(N.initialStartup&&!z&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const H=await this.doGetPathsFromLastSession();k.unshift(...H.filter(B=>Q(B)||Z(B)||B.backupPath))}return k}async doExtractPathsFromAPI(N){const k={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},W=await Promise.all((0,R.coalesce)(N.urisToOpen||[]).map(async z=>{const H=await this.resolveOpenable(z,k);if(H)return H.label=z.label,H;const B=this.resourceFromOpenable(z);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,C.localize)(0,null)],message:B.scheme===u.Schemas.file?(0,C.localize)(1,null):(0,C.localize)(2,null),detail:B.scheme===u.Schemas.file?(0,C.localize)(3,null,(0,m.getPathLabel)(B,{os:s.OS,tildify:this.environmentMainService})):(0,C.localize)(4,null,B.toString(!0))},(0,f.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async doExtractPathsFromCLI(N){const k=[],W={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},z=N["folder-uri"];if(z){const $=await Promise.all(z.map(G=>{const se=this.cliArgToUri(G);if(se)return this.resolveOpenable({folderUri:se},W)}));k.push(...(0,R.coalesce)($))}const H=N["file-uri"];if(H){const $=await Promise.all(H.map(G=>{const se=this.cliArgToUri(G);if(se)return this.resolveOpenable((0,ne.hasWorkspaceFileExtension)(G)?{workspaceUri:se}:{fileUri:se},W)}));k.push(...(0,R.coalesce)($))}const B=await Promise.all(N._.map($=>W.remoteAuthority?this.doResolveRemotePath($,W):this.doResolveFilePath($,W)));return k.push(...(0,R.coalesce)(B)),k}cliArgToUri(N){try{const k=P.URI.parse(N);if(!k.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${N}`);return}return k}catch(k){this.logService.error(`Invalid URI input string: ${N}, ${k.message}`)}}async doGetPathsFromLastSession(){const N=this.getRestoreWindowsSetting();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const k=[];N!=="one"&&k.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&k.push(this.windowsStateHandler.state.lastActiveWindow);const W=await Promise.all(k.map(async z=>{if(z.workspace){const H=await this.resolveOpenable({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(Q(H))return H}else if(z.folderUri){const H=await this.resolveOpenable({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(Z(H))return H}else if(N!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,R.coalesce)(W)}}}getRestoreWindowsSetting(){let N;return this.lifecycleMainService.wasRestarted?N="all":(N=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async resolveOpenable(N,k=Object.create(null)){const W=this.resourceFromOpenable(N);return W.scheme===u.Schemas.file?((0,F.isFileToOpen)(N)&&(k={...k,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(W.fsPath,k)):this.doResolveRemoteOpenable(N,k)}doResolveRemoteOpenable(N,k){let W=this.resourceFromOpenable(N);const z=(0,A.getRemoteAuthority)(W)||k.remoteAuthority;if(W=(0,a.removeTrailingPathSeparator)((0,a.normalizePath)(W)),(0,F.isFileToOpen)(N)){if(k.gotoLineMode){const{path:H,line:B,column:$}=(0,c.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:H}),options:{selection:B?{startLineNumber:B,startColumn:$||1}:void 0},remoteAuthority:z}}return{fileUri:W,remoteAuthority:z}}else if((0,F.isWorkspaceToOpen)(N))return{workspace:(0,ce.getWorkspaceIdentifier)(W),remoteAuthority:z};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:z}}resourceFromOpenable(N){return(0,F.isWorkspaceToOpen)(N)?N.workspaceUri:(0,F.isFolderToOpen)(N)?N.folderUri:N.fileUri}async doResolveFilePath(N,k,W){let z,H;k.gotoLineMode&&({path:N,line:z,column:H}=(0,c.parseLineAndColumnAware)(N)),N=(0,c.sanitizeFilePath)((0,y.normalize)(N),(0,w.cwd)());try{const B=await L.Promises.stat(N);if(B.isFile()){if(!k.forceOpenWorkspaceAsFile){const $=await this.workspacesManagementMainService.resolveLocalWorkspace(P.URI.file(N));if($)return $.transient&&k.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:o.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:P.URI.file(N),type:o.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:H||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(P.URI.file(N),B),type:o.FileType.Directory,exists:!0};if(!s.isWindows&&N==="/dev/null")return{fileUri:P.URI.file(N),type:o.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!W)return this.onUNCHostNotAllowed(N,k);const $=P.URI.file(N);if(this.workspacesHistoryMainService.removeRecentlyOpened([$]),k.ignoreFileNotFound)return{fileUri:$,type:o.FileType.File,exists:!1}}}async onUNCHostNotAllowed(N,k){const W=P.URI.file(N),{response:z,checkboxChecked:H}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,C.localize)(5,null),(0,C.localize)(6,null),(0,C.localize)(7,null)],message:(0,C.localize)(8,null,W.authority),detail:(0,C.localize)(9,null,(0,m.getPathLabel)(W,{os:s.OS,tildify:this.environmentMainService})),checkboxLabel:(0,C.localize)(10,null,W.authority),cancelId:1});if(z===0)return(0,r.addUNCHostToAllowlist)(W.authority),H&&this._register(h.Event.once(this.onDidOpenWindow)(B=>{B.sendWhenReady("vscode:configureAllowedUNCHost",I.CancellationToken.None,W.authority)})),this.doResolveFilePath(N,k,!0);if(z===2)return E.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(N,k)}doResolveRemotePath(N,k){const W=N.charCodeAt(0),z=k.remoteAuthority;let H,B;k.gotoLineMode&&({path:N,line:H,column:B}=(0,c.parseLineAndColumnAware)(N)),W!==47&&((0,c.isWindowsDriveLetter)(W)&&N.charCodeAt(N.charCodeAt(1))===58&&(N=(0,c.toSlashes)(N)),N=`/${N}`);const $=P.URI.from({scheme:u.Schemas.vscodeRemote,authority:z,path:N});if(N.charCodeAt(N.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(N))return k.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:H?{startLineNumber:H,startColumn:B||1}:void 0},remoteAuthority:k.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)($),remoteAuthority:z};if(k.gotoLineMode||y.posix.basename(N).indexOf(".")!==-1)return{fileUri:$,options:{selection:H?{startLineNumber:H,startColumn:B||1}:void 0},remoteAuthority:z}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:z}}shouldOpenNewWindow(N){const k=this.configurationService.getValue("window"),W=k?.openFoldersInNewWindow||"default",z=k?.openFilesInNewWindow||"off";let H=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(W==="on"||W==="off")&&(H=W==="on");let B=!1;return N.forceNewWindow||N.forceReuseWindow?B=!!N.forceNewWindow&&!N.forceReuseWindow:(s.isMacintosh?N.context===1&&(B=!0):N.context!==3&&N.context!==2&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!N.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(B=z==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(N,k){const W=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),N);if(W)return this.lifecycleMainService.reload(W,k.cli),W.focus(),[W];let z=k.cli["folder-uri"]||[],H=k.cli["file-uri"]||[],B=k.cli._;if(!B.length&&!z.length&&!H.length&&!k.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ue=se?.workspace??se?.folderUri;ue&&(P.URI.isUri(ue)?ue.scheme===u.Schemas.file?B=[ue.fsPath]:z=[ue.toString()]:ue.configPath.scheme===u.Schemas.file?B=[(0,a.originalFSPath)(ue.configPath)]:H=[ue.configPath.toString()])}let $=k.remoteAuthority;for(const se of N)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=P.URI.parse(se),ye=(0,A.getRemoteAuthority)(ue);ye&&($?(0,a.isEqualAuthority)(ye,$)||this.logService.error("more than one extension development path authority"):$=ye)}B=B.filter(se=>{const ue=P.URI.file(se);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:(0,a.isEqualAuthority)((0,A.getRemoteAuthority)(ue),$)}),z=z.filter(se=>{const ue=this.cliArgToUri(se);return ue&&(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,a.isEqualAuthority)((0,A.getRemoteAuthority)(ue),$):!1}),H=H.filter(se=>{const ue=this.cliArgToUri(se);return ue&&(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,a.isEqualAuthority)((0,A.getRemoteAuthority)(ue),$):!1}),k.cli._=B,k.cli["folder-uri"]=z,k.cli["file-uri"]=H;const G={context:k.context,cli:k.cli,forceNewWindow:!0,forceEmpty:!B.length&&!z.length&&!H.length,userEnv:k.userEnv,noRecentEntry:!0,waitMarkerFileURI:k.waitMarkerFileURI,remoteAuthority:$,forceProfile:k.forceProfile,forceTempProfile:k.forceTempProfile};return this.open(G)}async openInBrowserWindow(N){const k=this.configurationService.getValue("window"),W=this.getLastActiveWindow(),z=W?.profile??this.userDataProfilesMainService.defaultProfile;let H;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(H=N.windowToUse||W,H&&H.focus());const B={...this.environmentMainService.args,...N.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:z},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.initialUserEnv,...N.userEnv},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.fsPath,product:M.default,isInitialStartup:N.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,_.release)(),hostname:(0,_.hostname)()},zoomLevel:typeof k?.zoomLevel=="number"?k.zoomLevel:void 0,autoDetectHighContrast:k?.autoDetectHighContrast??!0,autoDetectColorScheme:k?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(H){const $=H.config;!B.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=$.extensionDevelopmentPath,B.extensionDevelopmentKind=$.extensionDevelopmentKind,B["enable-proposed-api"]=$["enable-proposed-api"],B.verbose=$.verbose,B["inspect-extensions"]=$["inspect-extensions"],B["inspect-brk-extensions"]=$["inspect-brk-extensions"],B.debugId=$.debugId,B.extensionEnvironment=$.extensionEnvironment,B["extensions-dir"]=$["extensions-dir"],B["disable-extensions"]=$["disable-extensions"]),B.loggers={global:B.loggers.global,window:$?.loggers.window??B.loggers.window}}else{const $=this.windowsStateHandler.getNewWindowState(B);(0,p.mark)("code/willCreateCodeWindow");const G=H=this.instantiationService.createInstance(q.CodeWindow,{state:$,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(G),at.WINDOWS.push(G),this._onDidOpenWindow.fire(G),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,v.once)(G.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(G)),(0,v.once)(G.onDidClose)(()=>this.onWindowClosed(G)),(0,v.once)(G.onDidDestroy)(()=>this._onDidDestroyWindow.fire(G)),G.onDidTriggerSystemContextMenu(({x:ue,y:ye})=>this._onDidTriggerSystemContextMenu.fire({window:G,x:ue,y:ye}));const se=(0,f.assertIsDefined)(G.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.lifecycleMainService.reload(G)),this.lifecycleMainService.registerWindow(G)}return B.windowId=H.id,H.isReady?this.lifecycleMainService.unload(H,4).then(async $=>{$||await this.doOpenInBrowserWindow(H,B,N,z)}):await this.doOpenInBrowserWindow(H,B,N,z),H}async doOpenInBrowserWindow(N,k,W,z){if(k.extensionDevelopmentPath||((0,ne.isWorkspaceIdentifier)(k.workspace)?k.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:k.workspace,remoteAuthority:k.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(k.workspace)?k.backupPath=this.backupMainService.registerFolderBackup({folderUri:k.workspace.uri,remoteAuthority:k.remoteAuthority}):k.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:k.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const H=k.workspace??(0,ne.toWorkspaceIdentifier)(k.backupPath,!1),B=this.resolveProfileForBrowserWindow(W,H,z),$=B instanceof Promise?await B:B;k.profiles.profile=$,k.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(H,$)}N.load(k)}resolveProfileForBrowserWindow(N,k,W){return N.forceProfile?this.userDataProfilesMainService.profiles.find(z=>z.name===N.forceProfile)??this.userDataProfilesMainService.createNamedProfile(N.forceProfile):N.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(k)??W}onWindowClosed(N){const k=at.WINDOWS.indexOf(N);at.WINDOWS.splice(k,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const N=E.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(N){return this.doGetLastActiveWindow(this.getWindows().filter(k=>(0,a.isEqualAuthority)(k.remoteAuthority,N)))}doGetLastActiveWindow(N){const k=Math.max.apply(Math,N.map(W=>W.lastFocusTime));return N.find(W=>W.lastFocusTime===k)}sendToFocused(N,...k){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,I.CancellationToken.None,...k)}sendToAll(N,k,W){for(const z of this.getWindows())W&&W.indexOf(z.id)>=0||z.sendWhenReady(N,I.CancellationToken.None,k)}getWindows(){return at.WINDOWS}getWindowCount(){return at.WINDOWS.length}getWindowById(N){const k=this.getWindows().filter(W=>W.id===N);return(0,R.firstOrDefault)(k)}getWindowByWebContents(N){const k=E.BrowserWindow.fromWebContents(N);if(k)return this.getWindowById(k.id)}};ae.WINDOWS=[],e.WindowsMainService=ae=Se([J(2,D.ILogService),J(3,x.ILoggerMainService),J(4,O.IStateService),J(5,U.IPolicyService),J(6,i.IEnvironmentMainService),J(7,T.IUserDataProfilesMainService),J(8,g.ILifecycleMainService),J(9,t.IBackupMainService),J(10,l.IConfigurationService),J(11,le.IWorkspacesHistoryMainService),J(12,K.IWorkspacesManagementMainService),J(13,d.IInstantiationService),J(14,n.IDialogMainService),J(15,o.IFileService),J(16,b.IProtocolMainService),J(17,V.IThemeMainService)],ae)}),define(te[303],ie([0,1,64,28,82,54]),function(j,e,E,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=e.WorkspacesMainService=class{constructor(h,c,v,m){this.workspacesManagementMainService=h,this.windowsMainService=c,this.workspacesHistoryMainService=v,this.backupMainService=m,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const v=this.windowsMainService.getWindowById(h);if(v)return this.workspacesManagementMainService.enterWorkspace(v,this.windowsMainService.getWindows(),c)}createUntitledWorkspace(h,c,v){return this.workspacesManagementMainService.createUntitledWorkspace(c,v)}deleteUntitledWorkspace(h,c){return this.workspacesManagementMainService.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.workspacesManagementMainService.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,c){return this.workspacesHistoryMainService.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.workspacesHistoryMainService.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=R=Se([J(0,_.IWorkspacesManagementMainService),J(1,L.IWindowsMainService),J(2,r.IWorkspacesHistoryMainService),J(3,E.IBackupMainService)],R)}),define(te[304],ie([0,1,15,131,38,27,17,50,13,32,49,44,45,2,14,9,3,11,8,31,144,43,157,109,271,160,64,284,19,75,198,89,132,59,114,218,30,63,93,207,233,208,291,116,209,210,16,222,92,74,6,91,216,296,285,273,20,5,301,67,23,58,292,94,34,276,98,121,26,248,250,52,48,263,288,297,289,298,126,265,266,267,269,274,28,302,275,29,96,82,303,54,272,39,231,53,242,51,81,128,278,290,281,7,252,277,226,66,90,294,268,24,124,293,260]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t,l,n,i,o,d,g,D,M,b,A,O,F,q,re,Y,ne,ce,le,K,V,U,T,x,Q,Z,ae,oe,N,k,W,z,H,B,$,G,se,ue,ye,Ce,Re,Le,Te,we,ve,Ee,ee,de,fe,ke,De,_e,We,qe,$e,ze,He,Be,X,he,ge,me,be,Ae,Ue,Ge,Je,Ve,Ye,tt,ot,ct,Rt,gt,Lt,At,_t,Ot,Tt,Wt,Ft,mt,Ut,Nt,Bt,zt,$t,pt,Ht,Et,vt,qt,xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=e.CodeApplication=class extends u.Disposable{constructor(Ie,Pe,pe,Oe,Me,Ne,Qe,Xe,Fe,xe,je,Ke){super(),this.mainProcessNodeIpcServer=Ie,this.userEnv=Pe,this.mainInstantiationService=pe,this.logService=Oe,this.loggerService=Me,this.environmentMainService=Ne,this.lifecycleMainService=Qe,this.configurationService=Xe,this.stateService=Fe,this.fileService=xe,this.productService=je,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const Ie=Fe=>Fe?.startsWith(`${y.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Fe,xe,je,Ke)=>Ie(Ke.requestingUrl)?je(Pe.has(xe)):je(!1)),E.session.defaultSession.setPermissionCheckHandler((Fe,xe,je,Ke)=>Ie(Ke.requestingUrl)?Pe.has(xe):!1);const pe=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,"devtools"]),Oe=Fe=>{for(let xe=Fe;xe;xe=xe.parent)if(xe.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Me=Fe=>Fe.resourceType==="xhr"||Oe(Fe.frame),Ne=Fe=>{const xe=Fe.frame;if(!xe||!this.windowsMainService)return!1;const je=E.BrowserWindow.getAllWindows();for(const Ke of je)if(xe.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Qe=(Fe,xe)=>{if(Fe.path!=="/index.html")return!0;const je=xe.frame;if(!je||!this.windowsMainService)return!1;for(const Ke of this.windowsMainService.getWindows())if(Ke.win&&je.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Fe,xe)=>{const je=a.URI.parse(Fe.url);return je.scheme===y.Schemas.vscodeWebview&&!Qe(je,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),xe({cancel:!0})):je.scheme===y.Schemas.vscodeFileResource&&!Ne(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),xe({cancel:!0})):je.path.endsWith(".svg")&&!pe.has(je.scheme)?xe({cancel:!Me(Fe)}):xe({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{const je=Fe.responseHeaders,Ke=je["content-type"]||je["Content-Type"];if(Ke&&Array.isArray(Ke)){const Ze=a.URI.parse(Fe.url);if(Ze.path.endsWith(".svg")&&pe.has(Ze.scheme))return je["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:je});if(!Ze.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ke.some(rt=>rt.toLowerCase().includes("image/svg")))return xe({cancel:!Me(Fe)})}return xe({cancel:!1})});const Xe=E.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Xe.setCodeCachePath((0,p.join)(this.environmentMainService.codeCachePath,"chrome")),s.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,h.setUnexpectedErrorHandler)(pe=>this.onUnexpectedError(pe)),process.on("uncaughtException",pe=>(0,h.onUnexpectedError)(pe)),process.on("unhandledRejection",pe=>(0,h.onUnexpectedError)(pe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,P.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(pe,Oe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Oe)}),E.app.on("activate",async(pe,Oe)=>{this.logService.trace("app#activate"),Oe||await this.windowsMainService?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(pe,Oe)=>{Oe.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),Oe.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let Ie=[],Pe;E.app.on("open-file",(pe,Oe)=>{this.logService.trace("app#open-file: ",Oe),pe.preventDefault(),Ie.push((0,Ge.hasWorkspaceFileExtension)(Oe)?{workspaceUri:a.URI.file(Oe)}:{fileUri:a.URI.file(Oe)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",pe=>{const Oe=this.windowsMainService?.getWindowByWebContents(pe.sender);let Me,Ne;return Oe?.config?(Me=Oe.config,Ne={...process.env,...Oe.config.userEnv}):(Me=this.environmentMainService.args,Ne=process.env),this.resolveShellEnvironment(Me,Ne,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(pe,Oe,Me)=>{const Ne=this.validateNlsPath([Oe]);if(!Ne||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ne,R.VSBuffer.fromString(Me))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(pe,...Oe)=>{const Me=this.validateNlsPath(Oe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",pe=>pe.sender.reload())}validateNlsPath(Ie){let Pe;for(const pe of Ie)typeof pe=="string"&&(typeof Pe!="string"?Pe=pe:Pe=(0,p.join)(Pe,pe));if(!(typeof Pe!="string"||!(0,p.isAbsolute)(Pe)||!(0,c.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!s.isLinux)))return a.URI.file(Pe)}onUnexpectedError(Ie){if(Ie){const Pe={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.logService.error(Ie.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ie=this.productService.win32AppUserModelId;s.isWindows&&Ie&&E.app.setAppUserModelId(Ie);try{s.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const Pe=new t.Server;this.lifecycleMainService.onWillShutdown(Fe=>{Fe.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const pe=await(0,Ut.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Oe,sharedProcessClient:Me}=this.setupSharedProcess(pe),Ne=await this.initServices(pe,Oe);this._register(Ne.createInstance(n.ProxyAuthHandler)),this._register(Ne.createInstance(Wt.UserDataProfilesHandler)),Ne.invokeFunction(Fe=>this.initChannels(Fe,Pe,Me));const Qe=Ne.invokeFunction(Fe=>this.setupProtocolUrlHandlers(Fe,Pe));this.lifecycleMainService.phase=2,await Ne.invokeFunction(Fe=>this.openFirstWindow(Fe,Qe)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Ie,Pe){const pe=this.windowsMainService=Ie.get(be.IWindowsMainService),Oe=Ie.get(He.IURLService),Me=this.nativeHostMainService=Ie.get(ue.INativeHostMainService),Ne=this;Oe.registerHandler({async handleURL(Ke,Ze){return Ne.handleProtocolUrl(pe,Oe,Ke,Ze)}});const Qe=this._register(new Ue.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new C.StaticRouter(Ke=>Qe.getActiveClientId().then(Ze=>Ke===Ze)),Fe=new Be.URLHandlerRouter(Xe,this.logService),xe=Pe.getChannel("urlHandler",Fe);Oe.registerHandler(new Be.URLHandlerChannelClient(xe));const je=this.resolveInitialProtocolUrls();return this._register(new he.ElectronURLListener(je?.urls,Oe,pe,this.environmentMainService,this.productService,this.logService)),je}resolveInitialProtocolUrls(){const Ie=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ie);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ie.length+Pe.length===0)return;const pe=[];return{urls:[...Ie,...Pe].map(Me=>{try{return{uri:a.URI.parse(Me),originalUrl:Me}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Me);return}}).filter(Me=>{if(!Me)return!1;if(this.shouldBlockURI(Me.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Me.uri.toString(!0)),!1;const Ne=this.getWindowOpenableFromProtocolUrl(Me.uri);return Ne?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Me.uri.toString(!0),Ne),pe.push(Ne),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Me.uri.toString(!0)),!0)}),openables:pe}}shouldBlockURI(Ie){if(Ie.authority===y.Schemas.file&&s.isWindows){const{options:Pe,buttonIndeces:pe}=(0,$t.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,S.getPathLabel)(Ie,{os:s.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null)},this.productService);if(pe[E.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Ie){if(Ie.path){if(Ie.authority===y.Schemas.file){const Pe=a.URI.file(Ie.fsPath);return(0,Ge.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ie.authority===y.Schemas.vscodeRemote){const Pe=Ie.path.indexOf(p.posix.sep,1);if(Pe!==-1){const pe=Ie.path.substring(1,Pe),Oe=Ie.path.substring(Pe),Me=a.URI.from({scheme:y.Schemas.vscodeRemote,authority:pe,path:Oe,query:Ie.query,fragment:Ie.fragment});return(0,Ge.hasWorkspaceFileExtension)(Oe)?{workspaceUri:Me}:/:[\d]+$/.test(Oe)?{fileUri:Me}:{folderUri:Me}}}}}async handleProtocolUrl(Ie,Pe,pe,Oe){if(this.logService.trace("app#handleProtocolUrl():",pe.toString(!0),Oe),pe.scheme===this.productService.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:a.URI.parse(pe.query).path,query:""})),this.shouldBlockURI(pe))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Me=!1;const Ne=new URLSearchParams(pe.query);Ne.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ne.delete("windowId"),pe=pe.with({query:Ne.toString()}),Me=!0):s.isMacintosh&&Ie.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Me=!0);const Qe=Ne.get("continueOn");Qe!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Ne.delete("continueOn"),pe=pe.with({query:Ne.toString()}),this.environmentMainService.continueOn=Qe??void 0);const Xe=this.getWindowOpenableFromProtocolUrl(pe);return Xe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,pe.toString(!0)),(0,Et.firstOrDefault)(await Ie.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Xe],forceNewWindow:Me,gotoLineMode:!0}))?.focus(),!0):Me?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,Et.firstOrDefault)(await Ie.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ce.getRemoteAuthority)(pe)}))?.ready(),Pe.open(pe,Oe)):(this.logService.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Oe),!1)}setupSharedProcess(Ie){const Pe=this._register(this.mainInstantiationService.createInstance(Re.SharedProcess,Ie)),pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new l.Client(Me,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),pe))(),sharedProcessClient:pe}}async initServices(Ie,Pe){const pe=new k.ServiceCollection;switch(process.platform){case"win32":pe.set(De.IUpdateService,new oe.SyncDescriptor(ze.Win32UpdateService));break;case"linux":s.isLinuxSnap?pe.set(De.IUpdateService,new oe.SyncDescriptor($e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(De.IUpdateService,new oe.SyncDescriptor(qe.LinuxUpdateService));break;case"darwin":pe.set(De.IUpdateService,new oe.SyncDescriptor(We.DarwinUpdateService));break}pe.set(be.IWindowsMainService,new oe.SyncDescriptor(Ae.WindowsMainService,[Ie,this.userEnv],!1));const Oe=new O.DialogMainService(this.logService,this.productService);pe.set(O.IDialogMainService,Oe),pe.set(B.ILaunchMainService,new oe.SyncDescriptor(B.LaunchMainService,void 0,!1)),pe.set(A.IDiagnosticsMainService,new oe.SyncDescriptor(A.DiagnosticsMainService,void 0,!1)),pe.set(b.IDiagnosticsService,C.ProxyChannel.toService((0,C.getDelayedChannel)(Pe.then(Fe=>Fe.getChannel("diagnostics"))))),pe.set(W.IIssueMainService,new oe.SyncDescriptor(z.IssueMainService,[this.userEnv])),pe.set(F.IEncryptionMainService,new oe.SyncDescriptor(q.EncryptionMainService,[Ie])),pe.set(H.IKeyboardLayoutMainService,new oe.SyncDescriptor(H.KeyboardLayoutMainService)),pe.set(ue.INativeHostMainService,new oe.SyncDescriptor(ue.NativeHostMainService,void 0,!1)),pe.set(D.ICredentialsMainService,new oe.SyncDescriptor(ot.CredentialsNativeMainService)),pe.set(ge.IWebviewManagerService,new oe.SyncDescriptor(me.WebviewMainService)),pe.set(se.IMenubarMainService,new oe.SyncDescriptor(se.MenubarMainService)),pe.set(ce.IExtensionUrlTrustService,new oe.SyncDescriptor(le.ExtensionUrlTrustService)),pe.set(K.IExtensionHostStarter,new oe.SyncDescriptor(V.ExtensionHostStarter)),pe.set(ve.IStorageMainService,new oe.SyncDescriptor(ve.StorageMainService)),pe.set(ve.IApplicationStorageMainService,new oe.SyncDescriptor(ve.ApplicationStorageMainService));const Me=new qt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.environmentMainService,this.lifecycleMainService,this.logService),Ne=new xt.PtyHostService(Me,this.configurationService,this.logService,this.loggerService);pe.set(vt.ILocalPtyService,Ne),s.isWindows?pe.set(U.IExternalTerminalMainService,new oe.SyncDescriptor(T.WindowsExternalTerminalService)):s.isMacintosh?pe.set(U.IExternalTerminalMainService,new oe.SyncDescriptor(T.MacExternalTerminalService)):s.isLinux&&pe.set(U.IExternalTerminalMainService,new oe.SyncDescriptor(T.LinuxExternalTerminalService));const Qe=new d.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);pe.set(o.IBackupMainService,Qe);const Xe=new tt.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Qe,Oe);if(pe.set(tt.IWorkspacesManagementMainService,Xe),pe.set(Je.IWorkspacesService,new oe.SyncDescriptor(Ye.WorkspacesMainService,void 0,!1)),pe.set(Ve.IWorkspacesHistoryMainService,new oe.SyncDescriptor(Ve.WorkspacesHistoryMainService,void 0,!1)),pe.set(He.IURLService,new oe.SyncDescriptor(X.NativeURLService,void 0,!1)),(0,ke.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,ke.isInternalTelemetry)(this.productService,this.configurationService),xe=(0,C.getDelayedChannel)(Pe.then(it=>it.getChannel("telemetryAppender"))),je=new de.TelemetryAppenderClient(xe),Ke=(0,Ee.resolveCommonProperties)((0,_.release)(),(0,_.hostname)(),process.arch,this.productService.commit,this.productService.version,Ie,Fe),Ze=(0,ke.getPiiPathsFromEnvironment)(this.environmentMainService),rt={appenders:[je],commonProperties:Ke,piiPaths:Ze,sendErrorTelemetry:!0};pe.set(ee.ITelemetryService,new oe.SyncDescriptor(fe.TelemetryService,[rt],!1))}else pe.set(ee.ITelemetryService,ke.NullTelemetryService);return pe.set(_t.IExtensionsProfileScannerService,new oe.SyncDescriptor(Nt.ExtensionsProfileScannerService,void 0,!0)),pe.set(Ot.IExtensionsScannerService,new oe.SyncDescriptor(Tt.ExtensionsScannerService,void 0,!0)),pe.set(pt.IUtilityProcessWorkerMainService,new oe.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([Qe.initialize(),Xe.initialize()]),this.mainInstantiationService.createChild(pe)}initChannels(Ie,Pe,pe){const Oe=C.ProxyChannel.fromService(Ie.get(B.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Oe);const Me=C.ProxyChannel.fromService(Ie.get(A.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const Ne=new Rt.PolicyChannel(Ie.get(ct.IPolicyService));Pe.registerChannel("policy",Ne),pe.then(et=>et.registerChannel("policy",Ne));const Qe=this.fileService.getProvider(y.Schemas.file);(0,w.assertType)(Qe instanceof ae.DiskFileSystemProvider);const Xe=new Z.DiskFileSystemProviderChannel(Qe,this.logService,this.environmentMainService);Pe.registerChannel(x.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe),pe.then(et=>et.registerChannel(x.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe));const Fe=C.ProxyChannel.fromService(Ie.get(gt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",Fe),pe.then(et=>et.registerChannel("userDataProfiles",Fe));const xe=new Lt.RequestChannel(Ie.get(At.IRequestService));pe.then(et=>et.registerChannel("request",xe));const je=new _e.UpdateChannel(Ie.get(De.IUpdateService));Pe.registerChannel("update",je);const Ke=C.ProxyChannel.fromService(Ie.get(W.IIssueMainService));Pe.registerChannel("issue",Ke);const Ze=C.ProxyChannel.fromService(Ie.get(F.IEncryptionMainService));Pe.registerChannel("encryption",Ze);const rt=C.ProxyChannel.fromService(Ie.get(D.ICredentialsMainService));Pe.registerChannel("credentials",rt);const it=C.ProxyChannel.fromService(Ie.get(Le.ISignService));Pe.registerChannel("sign",it);const lt=C.ProxyChannel.fromService(Ie.get(H.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",lt),this.nativeHostMainService=Ie.get(ue.INativeHostMainService);const It=C.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",It),pe.then(et=>et.registerChannel("nativeHost",It));const jt=C.ProxyChannel.fromService(Ie.get(Je.IWorkspacesService));Pe.registerChannel("workspaces",jt);const Vt=C.ProxyChannel.fromService(Ie.get(se.IMenubarMainService));Pe.registerChannel("menubar",Vt);const Gt=C.ProxyChannel.fromService(Ie.get(He.IURLService));Pe.registerChannel("url",Gt);const Kt=C.ProxyChannel.fromService(Ie.get(ce.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Kt);const Qt=C.ProxyChannel.fromService(Ie.get(ge.IWebviewManagerService));Pe.registerChannel("webview",Qt);const Ct=this._register(new we.StorageDatabaseChannel(this.logService,Ie.get(ve.IStorageMainService)));Pe.registerChannel("storage",Ct),pe.then(et=>et.registerChannel("storage",Ct));const Yt=this._register(new Ft.ProfileStorageChangesListenerChannel(Ie.get(ve.IStorageMainService),Ie.get(gt.IUserDataProfilesMainService),this.logService));pe.then(et=>et.registerChannel("profileStorageListener",Yt));const Xt=C.ProxyChannel.fromService(Ie.get(vt.ILocalPtyService));Pe.registerChannel(vt.TerminalIpcChannels.LocalPty,Xt);const Jt=C.ProxyChannel.fromService(Ie.get(U.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",Jt);const kt=new Bt.LoggerChannel(Ie.get(zt.ILoggerMainService));Pe.registerChannel("logger",kt),pe.then(et=>et.registerChannel("logger",kt));const Zt=new M.ElectronExtensionHostDebugBroadcastChannel(Ie.get(be.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",Zt);const ei=C.ProxyChannel.fromService(Ie.get(K.IExtensionHostStarter));Pe.registerChannel(K.ipcExtensionHostStarterChannelName,ei);const ti=C.ProxyChannel.fromService(Ie.get(pt.IUtilityProcessWorkerMainService));Pe.registerChannel(Ht.ipcUtilityProcessWorkerChannelName,ti)}async openFirstWindow(Ie,Pe){const pe=this.windowsMainService=Ie.get(be.IWindowsMainService),Oe=(0,Y.isLaunchedFromCli)(process.env)?0:4,Me=this.environmentMainService.args;if(Pe){if(Pe.openables.length>0)return pe.open({context:Oe,cli:Me,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const it of Pe.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),pe.open({context:Oe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Qe=Me._.length,Xe=!!Me["folder-uri"],Fe=!!Me["file-uri"],xe=Me["skip-add-to-recently-opened"]===!0,je=Me.wait&&Me.waitMarkerFilePath?a.URI.file(Me.waitMarkerFilePath):void 0,Ke=Me.remote||void 0,Ze=Me.profile,rt=Me["profile-temp"];if(!Qe&&!Xe&&!Fe){if(Me["new-window"]||Ze||rt)return pe.open({context:Oe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ze,forceTempProfile:rt});if(Ne.length)return pe.open({context:1,cli:Me,urisToOpen:Ne.map(it=>(0,Ge.hasWorkspaceFileExtension)(it)?{workspaceUri:a.URI.file(it)}:{fileUri:a.URI.file(it)}),noRecentEntry:xe,waitMarkerFileURI:je,initialStartup:!0})}return pe.open({context:Oe,cli:Me,forceNewWindow:Me["new-window"]||!Qe&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:xe,waitMarkerFileURI:je,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ze,forceTempProfile:rt})}afterWindowOpen(){this.installMutex(),E.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ie,Pe)=>{Pe({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const Ie=this.productService.win32MutexName;if(s.isWindows&&Ie)try{const Pe=await new Promise((Oe,Me)=>{j(["@vscode/windows-mutex"],Oe,Me)}),pe=new Pe.Mutex(Ie);(0,v.once)(this.lifecycleMainService.onWillShutdown)(()=>pe.release())}catch(Pe){this.logService.error(Pe)}}async resolveShellEnvironment(Ie,Pe,pe){try{return await(0,ne.getResolvedShellEnv)(this.configurationService,this.logService,Ie,Pe)}catch(Oe){const Me=(0,I.toErrorMessage)(Oe);pe?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),pe=JSON.parse((0,m.stripComments)(Pe)),Me=(0,ke.getTelemetryLevel)(this.configurationService)>=1;if(pe["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],Qe=Pe.substring(0,Pe.length-2).concat(`,
`,Ne.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Qe))}else{const Ne=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Ne!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ne))}}catch(Ie){this.logService.error(Ie)}}};e.CodeApplication=Pt=Se([J(2,N.IInstantiationService),J(3,G.ILogService),J(4,G.ILoggerService),J(5,re.IEnvironmentMainService),J(6,$.ILifecycleMainService),J(7,g.IConfigurationService),J(8,Te.IStateService),J(9,Q.IFileService),J(10,ye.IProductService),J(11,gt.IUserDataProfilesMainService)],Pt)}),define(te[310],ie([0,1,15,42,8,24,7,50,13,32,49,45,14,9,65,3,36,25,22,43,130,304,10,19,237,247,30,63,200,16,220,92,74,215,91,20,223,5,77,23,78,279,125,261,51,287,94,246,34,52,79,53,39,232,230,2,40,264,66,225,90,120,262]),function(j,e,E,L,r,_,R,I,h,c,v,m,S,u,y,p,s,w,a,f,P,C,t,l,n,i,o,d,g,D,M,b,A,O,F,q,re,Y,ne,ce,le,K,V,U,T,x,Q,Z,ae,oe,N,k,W,z,H,B,$,G,se,ue,ye,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Re{main(){try{this.startup()}catch(we){console.error(we.message),E.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(_e=>console.error(_e));const[we,ve,Ee,ee,de,fe,ke,De]=this.createServices();try{try{await this.initServices(Ee,De,ee,de,ke)}catch(_e){throw this.handleStartupDataDirError(Ee,ke,_e),_e}await we.invokeFunction(async _e=>{const We=_e.get(Y.ILogService),qe=_e.get(q.ILifecycleMainService),$e=_e.get(D.IFileService),ze=_e.get(Y.ILoggerService),He=await this.claimInstance(We,Ee,qe,we,ke,!0);return a.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Be=>{We.warn(`app#startup(): Error writing main lockfile: ${Be.stack}`)}),fe.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),(0,v.once)(qe.onWillShutdown)(Be=>{$e.dispose(),ee.dispose(),Be.join("instanceLockfile",a.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),we.createInstance(C.CodeApplication,He,ve).startup()})}catch(_e){we.invokeFunction(this.quit,_e)}}createServices(){const we=new F.ServiceCollection,ve=new B.DisposableStore;process.once("exit",()=>ve.dispose());const Ee={_serviceBrand:void 0,...ne.default};we.set(ce.IProductService,Ee);const ee=new o.EnvironmentMainService(this.resolveArgs(),Ee),de=this.patchEnvironment(ee);we.set(o.IEnvironmentMainService,ee);const fe=new se.LoggerMainService((0,Y.getLogLevel)(ee),ee.logsHome);we.set(se.ILoggerMainService,fe);const ke=new re.BufferLogger(fe.getLogLevel()),De=ve.add(new ue.LogService(ke,[new Y.ConsoleMainLogger(fe.getLogLevel())]));we.set(Y.ILogService,De);const _e=new M.FileService(De);we.set(D.IFileService,_e);const We=new b.DiskFileSystemProvider(De);_e.registerProvider(S.Schemas.file,We);const qe=new G.UriIdentityService(_e);we.set($.IUriIdentityService,qe);const $e=new Ce.StateService(1,ee,De,_e);we.set(ae.IStateReadService,$e),we.set(ae.IStateService,$e);const ze=new k.UserDataProfilesMainService($e,qe,ee,_e,De);we.set(k.IUserDataProfilesMainService,ze);const He=p.isWindows&&Ee.win32RegValueName?ve.add(new z.NativePolicyService(De,Ee.win32RegValueName)):ee.policyFile?ve.add(new H.FilePolicyService(ee.policyFile,_e,De)):new W.NullPolicyService;we.set(W.IPolicyService,He);const Be=new n.ConfigurationService(ze.defaultProfile.settingsResource,_e,He,De);return we.set(l.IConfigurationService,Be),we.set(q.ILifecycleMainService,new A.SyncDescriptor(q.LifecycleMainService,void 0,!1)),we.set(T.IRequestService,new A.SyncDescriptor(x.RequestMainService,void 0,!0)),we.set(N.IThemeMainService,new A.SyncDescriptor(N.ThemeMainService)),we.set(Q.ISignService,new A.SyncDescriptor(Z.SignService,void 0,!1)),we.set(V.ITunnelService,new A.SyncDescriptor(U.TunnelService)),we.set(le.IProtocolMainService,new K.ProtocolMainService(ee,ze,De)),[new O.InstantiationService(we,!0),de,ee,Be,$e,ke,Ee,ze]}patchEnvironment(we){const ve={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const ee=process.env[Ee];typeof ee=="string"&&(ve[Ee]=ee)}),Object.assign(process.env,ve),ve}async initServices(we,ve,Ee,ee,de){await R.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsHome.fsPath,ve.defaultProfile.globalStorageHome.fsPath,we.workspaceStorageHome.fsPath,we.localHistoryHome.fsPath,we.backupHome].map(fe=>fe?a.Promises.mkdir(fe,{recursive:!0}):void 0)),ee.init(),Ee.initialize()]),ve.init()}async claimInstance(we,ve,Ee,ee,de,fe){let ke;try{(0,y.mark)("code/willStartMainServer"),ke=await(0,P.serve)(ve.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,v.once)(Ee.onWillShutdown)(()=>ke.dispose())}catch(De){if(De.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ve,de,De),De;let _e;try{_e=await(0,P.connect)(ve.mainIPCHandle,"main")}catch(ze){if(!fe||p.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,de.nameShort),(0,t.localize)(2,null),de),ze;try{(0,L.unlinkSync)(ve.mainIPCHandle)}catch(He){throw we.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(we,ve,Ee,ee,de,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${de.nameShort} is running.`;throw we.error(ze),_e.dispose(),new Error(ze)}let We;!ve.args.wait&&!ve.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,de.nameShort),(0,t.localize)(4,null),de)},1e4));const qe=f.ProxyChannel.toService(_e.getChannel("launch"),{disableMarshalling:!0}),$e=f.ProxyChannel.toService(_e.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return ee.invokeFunction(async()=>{const ze=new i.DiagnosticsService(oe.NullTelemetryService,de),He=await $e.getMainDiagnostics(),Be=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),X=await ze.getDiagnostics(He,Be);throw console.log(X),new h.ExpectedError});throw p.isWindows&&await this.windowsAllowSetForegroundWindow(qe,we),we.trace("Sending env to running instance..."),await qe.start(ve.args,process.env),_e.dispose(),We&&clearTimeout(We),new h.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw we.warn((0,t.localize)(5,null,de.nameShort)),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ke}handleStartupDataDirError(we,ve,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const ee=(0,_.coalesce)([we.userDataPath,we.extensionsPath,P.XDG_RUNTIME_DIR]).map(de=>(0,m.getPathLabel)(r.URI.file(de),{os:p.OS,tildify:we}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,I.toErrorMessage)(Ee),ee.join(`
`)),ve)}}showStartupWarningDialog(we,ve,Ee){E.dialog.showMessageBoxSync((0,ye.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:we,detail:ve},Ee).options)}async windowsAllowSetForegroundWindow(we,ve){if(p.isWindows){const Ee=await we.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((ee,de)=>{j(["windows-foreground-love"],ee,de)})).allowSetForegroundWindow(Ee)}catch(ee){ve.error(ee)}}}quit(we,ve){const Ee=we.get(Y.ILogService),ee=we.get(q.ILifecycleMainService);let de=0;ve&&(ve.isExpected?ve.message&&Ee.trace(ve.message):(de=1,ve.stack?Ee.error(ve.stack):Ee.error(`Startup error: ${ve.toString()}`))),ee.kill(de)}resolveArgs(){const we=this.validatePaths((0,d.parseMainProcessArgv)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const ve=(0,g.createWaitMarkerFileSync)(we.verbose);ve&&((0,d.addArg)(process.argv,"--waitMarkerFilePath",ve),we.waitMarkerFilePath=ve)}return we}validatePaths(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const ve=this.doValidatePaths(we._,we.goto);we._=ve}return we}doValidatePaths(we,ve){const Ee=(0,s.cwd)(),ee=we.map(ke=>{let De=String(ke),_e;ve&&(_e=(0,c.parseLineAndColumnAware)(De),De=_e.path),De&&(De=this.preparePath(Ee,De));const We=(0,c.sanitizeFilePath)(De,Ee),qe=(0,u.basename)(We);return qe&&!(0,c.isValidBasename)(qe)?null:ve&&_e?(_e.path=We,this.toPath(_e)):We}),de=p.isWindows||p.isMacintosh,fe=(0,_.distinct)(ee,ke=>ke&&de?ke.toLowerCase():ke||"");return(0,_.coalesce)(fe)}preparePath(we,ve){return p.isWindows&&(ve=(0,w.rtrim)(ve,'"')),ve=(0,w.trim)((0,w.trim)(ve," "),"	"),p.isWindows&&(ve=(0,u.resolve)(we,ve),ve=(0,w.rtrim)(ve,".")),ve}toPath(we){const ve=[we.path];return typeof we.line=="number"&&ve.push(String(we.line)),typeof we.column=="number"&&ve.push(String(we.column)),ve.join(":")}}new Re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/code/electron-main/main.js.map
