/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(te){for(var t=[],E=0,L=te.length;E<L;E++)t[E]=ge[te[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(te){if(Array.isArray(te)){for(var t=0,E=Array(te.length);t<te.length;t++)E[t]=te[t];return E}else return Array.from(te)}var Vt=Object.hasOwnProperty,It=Object.setPrototypeOf,Kt=Object.isFrozen,qt=Object.getPrototypeOf,jt=Object.getOwnPropertyDescriptor,tt=Object.freeze,lt=Object.seal,Gt=Object.create,Nt=typeof Reflect<"u"&&Reflect,Dt=Nt.apply,_t=Nt.construct;Dt||(Dt=function(t,E,L){return t.apply(E,L)}),tt||(tt=function(t){return t}),lt||(lt=function(t){return t}),_t||(_t=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat($t(E))))});var Yt=st(Array.prototype.forEach),kt=st(Array.prototype.pop),gt=st(Array.prototype.push),ct=st(String.prototype.toLowerCase),Pt=st(String.prototype.match),ut=st(String.prototype.replace),Xt=st(String.prototype.indexOf),Zt=st(String.prototype.trim),at=st(RegExp.prototype.test),Rt=Qt(TypeError);function st(te){return function(t){for(var E=arguments.length,L=Array(E>1?E-1:0),i=1;i<E;i++)L[i-1]=arguments[i];return Dt(te,t,L)}}function Qt(te){return function(){for(var t=arguments.length,E=Array(t),L=0;L<t;L++)E[L]=arguments[L];return _t(te,E)}}function Be(te,t){It&&It(te,null);for(var E=t.length;E--;){var L=t[E];if(typeof L=="string"){var i=ct(L);i!==L&&(Kt(t)||(t[E]=i),L=i)}te[L]=!0}return te}function ht(te){var t=Gt(null),E=void 0;for(E in te)Dt(Vt,te,[E])&&(t[E]=te[E]);return t}function wt(te,t){for(;te!==null;){var E=jt(te,t);if(E){if(E.get)return st(E.get);if(typeof E.value=="function")return st(E.value)}te=qt(te)}function L(i){return console.warn("fallback value for",i),null}return L}var Mt=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=tt(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),At=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=tt(["#text"]),Bt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Tt=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),xt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=lt(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=lt(/<%[\s\S]*|[\s\S]*%>/gm),ni=lt(/^data-[\-\w.\u00B7-\uFFFF]/),si=lt(/^aria-[\-\w]+$/),ri=lt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=lt(/^(?:\w+script|data):/i),li=lt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(te){return typeof te}:function(te){return te&&typeof Symbol=="function"&&te.constructor===Symbol&&te!==Symbol.prototype?"symbol":typeof te};function ot(te){if(Array.isArray(te)){for(var t=0,E=Array(te.length);t<te.length;t++)E[t]=te[t];return E}else return Array.from(te)}var ai=function(){return typeof window>"u"?null:window},ui=function(t,E){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var L=null,i="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(i)&&(L=E.currentScript.getAttribute(i));var W="dompurify"+(L?"#"+L:"");try{return t.createPolicy(W,{createHTML:function(y){return y}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Ht(){var te=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(ce){return Ht(ce)};if(t.version="2.3.1",t.removed=[],!te||!te.document||te.document.nodeType!==9)return t.isSupported=!1,t;var E=te.document,L=te.document,i=te.DocumentFragment,W=te.HTMLTemplateElement,w=te.Node,y=te.Element,c=te.NodeFilter,a=te.NamedNodeMap,d=a===void 0?te.NamedNodeMap||te.MozNamedAttrMap:a,I=te.Text,r=te.Comment,u=te.DOMParser,e=te.trustedTypes,l=y.prototype,n=wt(l,"cloneNode"),h=wt(l,"nextSibling"),s=wt(l,"childNodes"),D=wt(l,"parentNode");if(typeof W=="function"){var v=L.createElement("template");v.content&&v.content.ownerDocument&&(L=v.content.ownerDocument)}var A=ui(e,E),f=A&&Y?A.createHTML(""):"",p=L,O=p.implementation,k=p.createNodeIterator,m=p.createDocumentFragment,g=p.getElementsByTagName,b=E.importNode,N={};try{N=ht(L).documentMode?L.documentMode:{}}catch{}var M={};t.isSupported=typeof D=="function"&&O&&typeof O.createHTMLDocument<"u"&&N!==9;var H=ti,Z=ii,ne=ni,se=si,he=oi,ue=li,le=ri,oe=null,ye=Be({},[].concat(ot(Mt),ot(St),ot(Ct),ot(At),ot(Ot))),Te=null,Oe=Be({},[].concat(ot(Bt),ot(Tt),ot(xt),ot(yt))),ke=null,fe=null,U=!0,ie=!0,q=!1,K=!1,_=!1,j=!1,z=!1,o=!1,T=!1,$=!0,Y=!1,C=!0,F=!0,R=!1,S={},x=null,B=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),P=null,V=Be({},["audio","video","img","source","image","track"]),G=null,ee=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),re="http://www.w3.org/1998/Math/MathML",be="http://www.w3.org/2000/svg",De="http://www.w3.org/1999/xhtml",Ie=De,Se=!1,ve=null,Pe=L.createElement("form"),Le=function(ce){ve&&ve===ce||((!ce||(typeof ce>"u"?"undefined":mt(ce))!=="object")&&(ce={}),ce=ht(ce),oe="ALLOWED_TAGS"in ce?Be({},ce.ALLOWED_TAGS):ye,Te="ALLOWED_ATTR"in ce?Be({},ce.ALLOWED_ATTR):Oe,G="ADD_URI_SAFE_ATTR"in ce?Be(ht(ee),ce.ADD_URI_SAFE_ATTR):ee,P="ADD_DATA_URI_TAGS"in ce?Be(ht(V),ce.ADD_DATA_URI_TAGS):V,x="FORBID_CONTENTS"in ce?Be({},ce.FORBID_CONTENTS):B,ke="FORBID_TAGS"in ce?Be({},ce.FORBID_TAGS):{},fe="FORBID_ATTR"in ce?Be({},ce.FORBID_ATTR):{},S="USE_PROFILES"in ce?ce.USE_PROFILES:!1,U=ce.ALLOW_ARIA_ATTR!==!1,ie=ce.ALLOW_DATA_ATTR!==!1,q=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,K=ce.SAFE_FOR_TEMPLATES||!1,_=ce.WHOLE_DOCUMENT||!1,o=ce.RETURN_DOM||!1,T=ce.RETURN_DOM_FRAGMENT||!1,$=ce.RETURN_DOM_IMPORT!==!1,Y=ce.RETURN_TRUSTED_TYPE||!1,z=ce.FORCE_BODY||!1,C=ce.SANITIZE_DOM!==!1,F=ce.KEEP_CONTENT!==!1,R=ce.IN_PLACE||!1,le=ce.ALLOWED_URI_REGEXP||le,Ie=ce.NAMESPACE||De,K&&(ie=!1),T&&(o=!0),S&&(oe=Be({},[].concat(ot(Ot))),Te=[],S.html===!0&&(Be(oe,Mt),Be(Te,Bt)),S.svg===!0&&(Be(oe,St),Be(Te,Tt),Be(Te,yt)),S.svgFilters===!0&&(Be(oe,Ct),Be(Te,Tt),Be(Te,yt)),S.mathMl===!0&&(Be(oe,At),Be(Te,xt),Be(Te,yt))),ce.ADD_TAGS&&(oe===ye&&(oe=ht(oe)),Be(oe,ce.ADD_TAGS)),ce.ADD_ATTR&&(Te===Oe&&(Te=ht(Te)),Be(Te,ce.ADD_ATTR)),ce.ADD_URI_SAFE_ATTR&&Be(G,ce.ADD_URI_SAFE_ATTR),ce.FORBID_CONTENTS&&(x===B&&(x=ht(x)),Be(x,ce.FORBID_CONTENTS)),F&&(oe["#text"]=!0),_&&Be(oe,["html","head","body"]),oe.table&&(Be(oe,["tbody"]),delete ke.tbody),tt&&tt(ce),ve=ce)},Ke=Be({},["mi","mo","mn","ms","mtext"]),xe=Be({},["foreignobject","desc","title","annotation-xml"]),We=Be({},St);Be(We,Ct),Be(We,Jt);var Je=Be({},At);Be(Je,ei);var it=function(ce){var Ee=D(ce);(!Ee||!Ee.tagName)&&(Ee={namespaceURI:De,tagName:"template"});var Ne=ct(ce.tagName),He=ct(Ee.tagName);if(ce.namespaceURI===be)return Ee.namespaceURI===De?Ne==="svg":Ee.namespaceURI===re?Ne==="svg"&&(He==="annotation-xml"||Ke[He]):!!We[Ne];if(ce.namespaceURI===re)return Ee.namespaceURI===De?Ne==="math":Ee.namespaceURI===be?Ne==="math"&&xe[He]:!!Je[Ne];if(ce.namespaceURI===De){if(Ee.namespaceURI===be&&!xe[He]||Ee.namespaceURI===re&&!Ke[He])return!1;var Xe=Be({},["title","style","font","a","script"]);return!Je[Ne]&&(Xe[Ne]||!We[Ne])}return!1},Me=function(ce){gt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{try{ce.outerHTML=f}catch{ce.remove()}}},Ve=function(ce,Ee){try{gt(t.removed,{attribute:Ee.getAttributeNode(ce),from:Ee})}catch{gt(t.removed,{attribute:null,from:Ee})}if(Ee.removeAttribute(ce),ce==="is"&&!Te[ce])if(o||T)try{Me(Ee)}catch{}else try{Ee.setAttribute(ce,"")}catch{}},X=function(ce){var Ee=void 0,Ne=void 0;if(z)ce="<remove></remove>"+ce;else{var He=Pt(ce,/^[\r\n\t ]+/);Ne=He&&He[0]}var Xe=A?A.createHTML(ce):ce;if(Ie===De)try{Ee=new u().parseFromString(Xe,"text/html")}catch{}if(!Ee||!Ee.documentElement){Ee=O.createDocument(Ie,"template",null);try{Ee.documentElement.innerHTML=Se?"":Xe}catch{}}var Ze=Ee.body||Ee.documentElement;return ce&&Ne&&Ze.insertBefore(L.createTextNode(Ne),Ze.childNodes[0]||null),Ie===De?g.call(Ee,_?"html":"body")[0]:_?Ee.documentElement:Ze},ae=function(ce){return k.call(ce.ownerDocument||ce,ce,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},pe=function(ce){return ce instanceof I||ce instanceof r?!1:typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof d)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"},we=function(ce){return(typeof w>"u"?"undefined":mt(w))==="object"?ce instanceof w:ce&&(typeof ce>"u"?"undefined":mt(ce))==="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},_e=function(ce,Ee,Ne){M[ce]&&Yt(M[ce],function(He){He.call(t,Ee,Ne,ve)})},Re=function(ce){var Ee=void 0;if(_e("beforeSanitizeElements",ce,null),pe(ce)||Pt(ce.nodeName,/[\u0080-\uFFFF]/))return Me(ce),!0;var Ne=ct(ce.nodeName);if(_e("uponSanitizeElement",ce,{tagName:Ne,allowedTags:oe}),!we(ce.firstElementChild)&&(!we(ce.content)||!we(ce.content.firstElementChild))&&at(/<[/\w]/g,ce.innerHTML)&&at(/<[/\w]/g,ce.textContent)||Ne==="select"&&at(/<template/i,ce.innerHTML))return Me(ce),!0;if(!oe[Ne]||ke[Ne]){if(F&&!x[Ne]){var He=D(ce)||ce.parentNode,Xe=s(ce)||ce.childNodes;if(Xe&&He)for(var Ze=Xe.length,Qe=Ze-1;Qe>=0;--Qe)He.insertBefore(n(Xe[Qe],!0),h(ce))}return Me(ce),!0}return ce instanceof y&&!it(ce)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,ce.innerHTML)?(Me(ce),!0):(K&&ce.nodeType===3&&(Ee=ce.textContent,Ee=ut(Ee,H," "),Ee=ut(Ee,Z," "),ce.textContent!==Ee&&(gt(t.removed,{element:ce.cloneNode()}),ce.textContent=Ee)),_e("afterSanitizeElements",ce,null),!1)},Ue=function(ce,Ee,Ne){if(C&&(Ee==="id"||Ee==="name")&&(Ne in L||Ne in Pe))return!1;if(!(ie&&!fe[Ee]&&at(ne,Ee))){if(!(U&&at(se,Ee))){if(!Te[Ee]||fe[Ee])return!1;if(!G[Ee]){if(!at(le,ut(Ne,ue,""))){if(!((Ee==="src"||Ee==="xlink:href"||Ee==="href")&&ce!=="script"&&Xt(Ne,"data:")===0&&P[ce])){if(!(q&&!at(he,ut(Ne,ue,"")))){if(Ne)return!1}}}}}}return!0},Ge=function(ce){var Ee=void 0,Ne=void 0,He=void 0,Xe=void 0;_e("beforeSanitizeAttributes",ce,null);var Ze=ce.attributes;if(Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Te};for(Xe=Ze.length;Xe--;){Ee=Ze[Xe];var rt=Ee,dt=rt.name,pt=rt.namespaceURI;if(Ne=Zt(Ee.value),He=ct(dt),Qe.attrName=He,Qe.attrValue=Ne,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,_e("uponSanitizeAttribute",ce,Qe),Ne=Qe.attrValue,!Qe.forceKeepAttr&&(Ve(dt,ce),!!Qe.keepAttr)){if(at(/\/>/i,Ne)){Ve(dt,ce);continue}K&&(Ne=ut(Ne,H," "),Ne=ut(Ne,Z," "));var Ft=ce.nodeName.toLowerCase();if(Ue(Ft,He,Ne))try{pt?ce.setAttributeNS(pt,dt,Ne):ce.setAttribute(dt,Ne),kt(t.removed)}catch{}}}_e("afterSanitizeAttributes",ce,null)}},et=function Ae(ce){var Ee=void 0,Ne=ae(ce);for(_e("beforeSanitizeShadowDOM",ce,null);Ee=Ne.nextNode();)_e("uponSanitizeShadowNode",Ee,null),!Re(Ee)&&(Ee.content instanceof i&&Ae(Ee.content),Ge(Ee));_e("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Ae,ce){var Ee=void 0,Ne=void 0,He=void 0,Xe=void 0,Ze=void 0;if(Se=!Ae,Se&&(Ae="<!-->"),typeof Ae!="string"&&!we(Ae)){if(typeof Ae.toString!="function")throw Rt("toString is not a function");if(Ae=Ae.toString(),typeof Ae!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(te.toStaticHTML)==="object"||typeof te.toStaticHTML=="function"){if(typeof Ae=="string")return te.toStaticHTML(Ae);if(we(Ae))return te.toStaticHTML(Ae.outerHTML)}return Ae}if(j||Le(ce),t.removed=[],typeof Ae=="string"&&(R=!1),!R)if(Ae instanceof w)Ee=X("<!---->"),Ne=Ee.ownerDocument.importNode(Ae,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Ee=Ne:Ee.appendChild(Ne);else{if(!o&&!K&&!_&&Ae.indexOf("<")===-1)return A&&Y?A.createHTML(Ae):Ae;if(Ee=X(Ae),!Ee)return o?null:f}Ee&&z&&Me(Ee.firstChild);for(var Qe=ae(R?Ae:Ee);He=Qe.nextNode();)He.nodeType===3&&He===Xe||Re(He)||(He.content instanceof i&&et(He.content),Ge(He),Xe=He);if(Xe=null,R)return Ae;if(o){if(T)for(Ze=m.call(Ee.ownerDocument);Ee.firstChild;)Ze.appendChild(Ee.firstChild);else Ze=Ee;return $&&(Ze=b.call(E,Ze,!0)),Ze}var rt=_?Ee.outerHTML:Ee.innerHTML;return K&&(rt=ut(rt,H," "),rt=ut(rt,Z," ")),A&&Y?A.createHTML(rt):rt},t.setConfig=function(Ae){Le(Ae),j=!0},t.clearConfig=function(){ve=null,j=!1},t.isValidAttribute=function(Ae,ce,Ee){ve||Le({});var Ne=ct(Ae),He=ct(ce);return Ue(Ne,He,Ee)},t.addHook=function(Ae,ce){typeof ce=="function"&&(M[Ae]=M[Ae]||[],gt(M[Ae],ce))},t.removeHook=function(Ae){M[Ae]&&kt(M[Ae])},t.removeHooks=function(Ae){M[Ae]&&(M[Ae]=[])},t.removeAllHooks=function(){M={}},t}var ci=Ht();define("vs/base/browser/dompurify/dompurify",function(){return ci}),define(ge[39],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(w){this.domNode=w,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(w){const y=L(w);this._maxWidth!==y&&(this._maxWidth=y,this.domNode.style.maxWidth=this._maxWidth)}setWidth(w){const y=L(w);this._width!==y&&(this._width=y,this.domNode.style.width=this._width)}setHeight(w){const y=L(w);this._height!==y&&(this._height=y,this.domNode.style.height=this._height)}setTop(w){const y=L(w);this._top!==y&&(this._top=y,this.domNode.style.top=this._top)}setLeft(w){const y=L(w);this._left!==y&&(this._left=y,this.domNode.style.left=this._left)}setBottom(w){const y=L(w);this._bottom!==y&&(this._bottom=y,this.domNode.style.bottom=this._bottom)}setRight(w){const y=L(w);this._right!==y&&(this._right=y,this.domNode.style.right=this._right)}setPaddingTop(w){const y=L(w);this._paddingTop!==y&&(this._paddingTop=y,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(w){const y=L(w);this._paddingLeft!==y&&(this._paddingLeft=y,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(w){const y=L(w);this._paddingBottom!==y&&(this._paddingBottom=y,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(w){const y=L(w);this._paddingRight!==y&&(this._paddingRight=y,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(w){this._fontFamily!==w&&(this._fontFamily=w,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(w){this._fontWeight!==w&&(this._fontWeight=w,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(w){const y=L(w);this._fontSize!==y&&(this._fontSize=y,this.domNode.style.fontSize=this._fontSize)}setFontStyle(w){this._fontStyle!==w&&(this._fontStyle=w,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(w){this._fontFeatureSettings!==w&&(this._fontFeatureSettings=w,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(w){this._fontVariationSettings!==w&&(this._fontVariationSettings=w,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(w){this._textDecoration!==w&&(this._textDecoration=w,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(w){const y=L(w);this._lineHeight!==y&&(this._lineHeight=y,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(w){const y=L(w);this._letterSpacing!==y&&(this._letterSpacing=y,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(w){this._className!==w&&(this._className=w,this.domNode.className=this._className)}toggleClassName(w,y){this.domNode.classList.toggle(w,y),this._className=this.domNode.className}setDisplay(w){this._display!==w&&(this._display=w,this.domNode.style.display=this._display)}setPosition(w){this._position!==w&&(this._position=w,this.domNode.style.position=this._position)}setVisibility(w){this._visibility!==w&&(this._visibility=w,this.domNode.style.visibility=this._visibility)}setColor(w){this._color!==w&&(this._color=w,this.domNode.style.color=this._color)}setBackgroundColor(w){this._backgroundColor!==w&&(this._backgroundColor=w,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(w){this._layerHint!==w&&(this._layerHint=w,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this._boxShadow!==w&&(this._boxShadow=w,this.domNode.style.boxShadow=w)}setContain(w){this._contain!==w&&(this._contain=w,this.domNode.style.contain=this._contain)}setAttribute(w,y){this.domNode.setAttribute(w,y)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.FastDomNode=E;function L(W){return typeof W=="number"?`${W}px`:W}function i(W){return new E(W)}t.createFastDomNode=i}),define(ge[66],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,L=null;function i(w){if(!w.parent||w.parent===w)return null;try{const y=w.location,c=w.parent.location;if(y.origin!=="null"&&c.origin!=="null"&&y.origin!==c.origin)return E=!0,null}catch{return E=!0,null}return w.parent}class W{static getSameOriginWindowChain(){if(!L){L=[];let y=window,c;do c=i(y),c?L.push({window:y,iframeElement:y.frameElement||null}):L.push({window:y,iframeElement:null}),y=c;while(y)}return L.slice(0)}static hasDifferentOriginAncestor(){return L||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(y,c){if(!c||y===c)return{top:0,left:0};let a=0,d=0;const I=this.getSameOriginWindowChain();for(const r of I){if(a+=r.window.scrollY,d+=r.window.scrollX,r.window===c||!r.iframeElement)break;const u=r.iframeElement.getBoundingClientRect();a+=u.top,d+=u.left}return{top:a,left:d}}}t.IframeUtils=W}),define(ge[67],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(W){W[W.Copy=0]="Copy",W[W.Move=1]="Move"})(E||(t.ListDragOverEffect=E={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class L extends Error{constructor(w,y){super(`ListError [${w}] ${y}`)}}t.ListError=L;class i{constructor(){this.cache=new WeakMap}getHeight(w){return this.cache.get(w)??this.estimateHeight(w)}setDynamicHeight(w,y){y>0&&this.cache.set(w,y)}}t.CachedListVirtualDelegate=i}),define(ge[68],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(i){this.spliceables=i}splice(i,W,w){this.spliceables.forEach(y=>y.splice(i,W,w))}}t.CombinedSpliceable=E}),define(ge[40],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class L{constructor(W,w,y,c,a,d){this._scrollbarSize=Math.round(w),this._oppositeScrollbarSize=Math.round(y),this._arrowSize=Math.round(W),this._visibleSize=c,this._scrollSize=a,this._scrollPosition=d,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new L(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(W){const w=Math.round(W);return this._visibleSize!==w?(this._visibleSize=w,this._refreshComputedValues(),!0):!1}setScrollSize(W){const w=Math.round(W);return this._scrollSize!==w?(this._scrollSize=w,this._refreshComputedValues(),!0):!1}setScrollPosition(W){const w=Math.round(W);return this._scrollPosition!==w?(this._scrollPosition=w,this._refreshComputedValues(),!0):!1}setScrollbarSize(W){this._scrollbarSize=Math.round(W)}setOppositeScrollbarSize(W){this._oppositeScrollbarSize=Math.round(W)}static _computeValues(W,w,y,c,a){const d=Math.max(0,y-W),I=Math.max(0,d-2*w),r=c>0&&c>y;if(!r)return{computedAvailableSize:Math.round(d),computedIsNeeded:r,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const u=Math.round(Math.max(E,Math.floor(y*I/c))),e=(I-u)/(c-y),l=a*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:r,computedSliderSize:Math.round(u),computedSliderRatio:e,computedSliderPosition:Math.round(l)}}_refreshComputedValues(){const W=L._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=W.computedAvailableSize,this._computedIsNeeded=W.computedIsNeeded,this._computedSliderSize=W.computedSliderSize,this._computedSliderRatio=W.computedSliderRatio,this._computedSliderPosition=W.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(W){if(!this._computedIsNeeded)return 0;const w=W-this._arrowSize-this._computedSliderSize/2;return Math.round(w/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(W){if(!this._computedIsNeeded)return 0;const w=W-this._arrowSize;let y=this._scrollPosition;return w<this._computedSliderPosition?y-=this._visibleSize:y+=this._visibleSize,y}getDesiredScrollPositionFromDelta(W){if(!this._computedIsNeeded)return 0;const w=this._computedSliderPosition+W;return Math.round(w/this._computedSliderRatio)}}t.ScrollbarState=L}),define(ge[24],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var E;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(E||(t.TreeVisibility=E={}));var L;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(L||(t.ObjectTreeElementCollapseState=L={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var W;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class w extends Error{constructor(a,d){super(`TreeError [${a}] ${d}`)}}t.TreeError=w;class y{constructor(a){this.fn=a,this._map=new WeakMap}map(a){let d=this._map.get(a);return d||(d=this.fn(a),this._map.set(a,d)),d}}t.WeakMapper=y}),define(ge[69],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(w,y){const c=Object.create(null);for(const a of w){const d=y(a);let I=c[d];I||(I=c[d]=[]),I.push(a)}return c}t.groupBy=E;function L(w,y){const c=[],a=[];for(const d of w)y.has(d)||c.push(d);for(const d of y)w.has(d)||a.push(d);return{removed:c,added:a}}t.diffSets=L;function i(w,y){const c=[],a=[];for(const[d,I]of w)y.has(d)||c.push(I);for(const[d,I]of y)w.has(d)||a.push(I);return{removed:c,added:a}}t.diffMaps=i;class W{constructor(){this.map=new Map}add(y,c){let a=this.map.get(y);a||(a=new Set,this.map.set(y,a)),a.add(c)}delete(y,c){const a=this.map.get(y);a&&(a.delete(c),a.size===0&&this.map.delete(y))}forEach(y,c){const a=this.map.get(y);a&&a.forEach(c)}}t.SetMap=W}),define(ge[70],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(y,c){const a=Math.pow(10,c);return Math.round(y*a)/a}class L{constructor(c,a,d,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=E(Math.max(Math.min(1,I),0),3)}static equals(c,a){return c.r===a.r&&c.g===a.g&&c.b===a.b&&c.a===a.a}}t.RGBA=L;class i{constructor(c,a,d,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=E(Math.max(Math.min(1,a),0),3),this.l=E(Math.max(Math.min(1,d),0),3),this.a=E(Math.max(Math.min(1,I),0),3)}static equals(c,a){return c.h===a.h&&c.s===a.s&&c.l===a.l&&c.a===a.a}static fromRGBA(c){const a=c.r/255,d=c.g/255,I=c.b/255,r=c.a,u=Math.max(a,d,I),e=Math.min(a,d,I);let l=0,n=0;const h=(e+u)/2,s=u-e;if(s>0){switch(n=Math.min(h<=.5?s/(2*h):s/(2-2*h),1),u){case a:l=(d-I)/s+(d<I?6:0);break;case d:l=(I-a)/s+2;break;case I:l=(a-d)/s+4;break}l*=60,l=Math.round(l)}return new i(l,n,h,r)}static _hue2rgb(c,a,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?c+(a-c)*6*d:d<1/2?a:d<2/3?c+(a-c)*(2/3-d)*6:c}static toRGBA(c){const a=c.h/360,{s:d,l:I,a:r}=c;let u,e,l;if(d===0)u=e=l=I;else{const n=I<.5?I*(1+d):I+d-I*d,h=2*I-n;u=i._hue2rgb(h,n,a+1/3),e=i._hue2rgb(h,n,a),l=i._hue2rgb(h,n,a-1/3)}return new L(Math.round(u*255),Math.round(e*255),Math.round(l*255),r)}}t.HSLA=i;class W{constructor(c,a,d,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=E(Math.max(Math.min(1,a),0),3),this.v=E(Math.max(Math.min(1,d),0),3),this.a=E(Math.max(Math.min(1,I),0),3)}static equals(c,a){return c.h===a.h&&c.s===a.s&&c.v===a.v&&c.a===a.a}static fromRGBA(c){const a=c.r/255,d=c.g/255,I=c.b/255,r=Math.max(a,d,I),u=Math.min(a,d,I),e=r-u,l=r===0?0:e/r;let n;return e===0?n=0:r===a?n=((d-I)/e%6+6)%6:r===d?n=(I-a)/e+2:n=(a-d)/e+4,new W(Math.round(n*60),l,r,c.a)}static toRGBA(c){const{h:a,s:d,v:I,a:r}=c,u=I*d,e=u*(1-Math.abs(a/60%2-1)),l=I-u;let[n,h,s]=[0,0,0];return a<60?(n=u,h=e):a<120?(n=e,h=u):a<180?(h=u,s=e):a<240?(h=e,s=u):a<300?(n=e,s=u):a<=360&&(n=u,s=e),n=Math.round((n+l)*255),h=Math.round((h+l)*255),s=Math.round((s+l)*255),new L(n,h,s,r)}}t.HSVA=W;class w{static fromHex(c){return w.Format.CSS.parseHex(c)||w.red}static equals(c,a){return!c&&!a?!0:!c||!a?!1:c.equals(a)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:W.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof L)this.rgba=c;else if(c instanceof i)this._hsla=c,this.rgba=i.toRGBA(c);else if(c instanceof W)this._hsva=c,this.rgba=W.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&L.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&W.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=w._relativeLuminanceForComponent(this.rgba.r),a=w._relativeLuminanceForComponent(this.rgba.g),d=w._relativeLuminanceForComponent(this.rgba.b),I=.2126*c+.7152*a+.0722*d;return E(I,4)}static _relativeLuminanceForComponent(c){const a=c/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(c){const a=this.getRelativeLuminance(),d=c.getRelativeLuminance();return a>d?(a+.05)/(d+.05):(d+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const a=this.getRelativeLuminance(),d=c.getRelativeLuminance();return a>d}isDarkerThan(c){const a=this.getRelativeLuminance(),d=c.getRelativeLuminance();return a<d}lighten(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:a,g:d,b:I,a:r}=this.rgba;return new w(new L(a,d,I,r*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const a=c.rgba,d=this.rgba.a,I=a.a,r=d+I*(1-d);if(r<1e-6)return w.transparent;const u=this.rgba.r*d/r+a.r*I*(1-d)/r,e=this.rgba.g*d/r+a.g*I*(1-d)/r,l=this.rgba.b*d/r+a.b*I*(1-d)/r;return new w(new L(u,e,l,r))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:a,g:d,b:I,a:r}=this.rgba;return new w(new L(c.rgba.r-r*(c.rgba.r-a),c.rgba.g-r*(c.rgba.g-d),c.rgba.b-r*(c.rgba.b-I),1))}flatten(...c){const a=c.reduceRight((d,I)=>w._flatten(I,d));return w._flatten(this,a)}static _flatten(c,a){const d=1-c.rgba.a;return new w(new L(d*a.rgba.r+c.rgba.a*c.rgba.r,d*a.rgba.g+c.rgba.a*c.rgba.g,d*a.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this._toString||(this._toString=w.Format.CSS.format(this)),this._toString}static getLighterColor(c,a,d){if(c.isLighterThan(a))return c;d=d||.5;const I=c.getRelativeLuminance(),r=a.getRelativeLuminance();return d=d*(r-I)/r,c.lighten(d)}static getDarkerColor(c,a,d){if(c.isDarkerThan(a))return c;d=d||.5;const I=c.getRelativeLuminance(),r=a.getRelativeLuminance();return d=d*(I-r)/I,c.darken(d)}}t.Color=w,w.white=new w(new L(255,255,255,1)),w.black=new w(new L(0,0,0,1)),w.red=new w(new L(255,0,0,1)),w.blue=new w(new L(0,0,255,1)),w.green=new w(new L(0,255,0,1)),w.cyan=new w(new L(0,255,255,1)),w.lightgrey=new w(new L(211,211,211,1)),w.transparent=new w(new L(0,0,0,0)),function(y){let c;(function(a){let d;(function(I){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:y.Format.CSS.formatRGBA(f)}I.formatRGB=r;function u(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}I.formatRGBA=u;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(f)}I.formatHSL=e;function l(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}I.formatHSLA=l;function n(f){const p=f.toString(16);return p.length!==2?"0"+p:p}function h(f){return`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}`}I.formatHex=h;function s(f,p=!1){return p&&f.rgba.a===1?y.Format.CSS.formatHex(f):`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}${n(Math.round(f.rgba.a*255))}`}I.formatHexA=s;function D(f){return f.isOpaque()?y.Format.CSS.formatHex(f):y.Format.CSS.formatRGBA(f)}I.format=D;function v(f){const p=f.length;if(p===0||f.charCodeAt(0)!==35)return null;if(p===7){const O=16*A(f.charCodeAt(1))+A(f.charCodeAt(2)),k=16*A(f.charCodeAt(3))+A(f.charCodeAt(4)),m=16*A(f.charCodeAt(5))+A(f.charCodeAt(6));return new y(new L(O,k,m,1))}if(p===9){const O=16*A(f.charCodeAt(1))+A(f.charCodeAt(2)),k=16*A(f.charCodeAt(3))+A(f.charCodeAt(4)),m=16*A(f.charCodeAt(5))+A(f.charCodeAt(6)),g=16*A(f.charCodeAt(7))+A(f.charCodeAt(8));return new y(new L(O,k,m,g/255))}if(p===4){const O=A(f.charCodeAt(1)),k=A(f.charCodeAt(2)),m=A(f.charCodeAt(3));return new y(new L(16*O+O,16*k+k,16*m+m))}if(p===5){const O=A(f.charCodeAt(1)),k=A(f.charCodeAt(2)),m=A(f.charCodeAt(3)),g=A(f.charCodeAt(4));return new y(new L(16*O+O,16*k+k,16*m+m,(16*g+g)/255))}return null}I.parseHex=v;function A(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=a.CSS||(a.CSS={}))})(c=y.Format||(y.Format={}))}(w||(t.Color=w={}))}),define(ge[25],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function E(w){return(y,c,a)=>{let d=null,I=null;if(typeof a.value=="function"?(d="value",I=a.value):typeof a.get=="function"&&(d="get",I=a.get),!I)throw new Error("not supported");a[d]=w(I,c)}}function L(w,y,c){let a=null,d=null;if(typeof c.value=="function"?(a="value",d=c.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(a="get",d=c.get),!d)throw new Error("not supported");const I=`$memoize$${y}`;c[a]=function(...r){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,r)}),this[I]}}t.memoize=L;function i(w,y,c){return E((a,d)=>{const I=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...u){this[r]||(this[r]=c?c():void 0),clearTimeout(this[I]),y&&(this[r]=y(this[r],...u),u=[this[r]]),this[I]=setTimeout(()=>{a.apply(this,u),this[r]=c?c():void 0},w)}})}t.debounce=i;function W(w,y,c){return E((a,d)=>{const I=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,u=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...l){if(this[r]||(this[r]=c?c():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),y&&(this[r]=y(this[r],...l)),this[e])return;const n=this[u]+w;n<=Date.now()?(this[u]=Date.now(),a.apply(this,[this[r]]),this[r]=c?c():void 0):(this[e]=!0,this[I]=setTimeout(()=>{this[e]=!1,this[u]=Date.now(),a.apply(this,[this[r]]),this[r]=c?c():void 0},n-Date.now()))}})}t.throttle=W}),define(ge[71],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(i,W,w,y){this.originalStart=i,this.originalLength=W,this.modifiedStart=w,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(ge[7],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(p){setTimeout(()=>{throw p.stack?v.isErrorNoTelemetry(p)?new v(p.message+`

`+p.stack):new Error(p.message+`

`+p.stack):p},0)}}addListener(p){return this.listeners.push(p),()=>{this._removeListener(p)}}emit(p){this.listeners.forEach(O=>{O(p)})}_removeListener(p){this.listeners.splice(this.listeners.indexOf(p),1)}setUnexpectedErrorHandler(p){this.unexpectedErrorHandler=p}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(p){this.unexpectedErrorHandler(p),this.emit(p)}onUnexpectedExternalError(p){this.unexpectedErrorHandler(p)}}t.ErrorHandler=E,t.errorHandler=new E;function L(f){t.errorHandler.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=L;function i(f){if(!f||typeof f!="object")return!1;const p=f;return p.code==="EPIPE"&&p.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function W(f){a(f)||t.errorHandler.onUnexpectedError(f)}t.onUnexpectedError=W;function w(f){a(f)||t.errorHandler.onUnexpectedExternalError(f)}t.onUnexpectedExternalError=w;function y(f){if(f instanceof Error){const{name:p,message:O}=f,k=f.stacktrace||f.stack;return{$isError:!0,name:p,message:O,stack:k,noTelemetry:v.isErrorNoTelemetry(f)}}return f}t.transformErrorForSerialization=y;const c="Canceled";function a(f){return f instanceof d?!0:f instanceof Error&&f.name===c&&f.message===c}t.isCancellationError=a;class d extends Error{constructor(){super(c),this.name=this.message}}t.CancellationError=d;function I(){const f=new Error(c);return f.name=f.message,f}t.canceled=I;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.illegalArgument=r;function u(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.illegalState=u;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function l(f){const p=new Error(`${f} has been disposed`);return p.name="DISPOSED",p}t.disposed=l;function n(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.getErrorMessage=n;class h extends Error{constructor(p){super("NotImplemented"),p&&(this.message=p)}}t.NotImplementedError=h;class s extends Error{constructor(p){super("NotSupported"),p&&(this.message=p)}}t.NotSupportedError=s;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=D;class v extends Error{constructor(p){super(p),this.name="CodeExpectedError"}static fromError(p){if(p instanceof v)return p;const O=new v;return O.message=p.message,O.stack=p.stack,O}static isErrorNoTelemetry(p){return p.name==="CodeExpectedError"}}t.ErrorNoTelemetry=v;class A extends Error{constructor(p){super(p||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype)}}t.BugIndicatingError=A}),define(ge[13],me([1,0,7]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function L(C,F=0){return C[C.length-(1+F)]}t.tail=L;function i(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}t.tail2=i;function W(C,F,R=(S,x)=>S===x){if(C===F)return!0;if(!C||!F||C.length!==F.length)return!1;for(let S=0,x=C.length;S<x;S++)if(!R(C[S],F[S]))return!1;return!0}t.equals=W;function w(C,F){const R=C.length-1;F<R&&(C[F]=C[R]),C.pop()}t.removeFastWithoutKeepingOrder=w;function y(C,F,R){return c(C.length,S=>R(C[S],F))}t.binarySearch=y;function c(C,F){let R=0,S=C-1;for(;R<=S;){const x=(R+S)/2|0,B=F(x);if(B<0)R=x+1;else if(B>0)S=x-1;else return x}return-(R+1)}t.binarySearch2=c;function a(C,F){let R=0,S=C.length;if(S===0)return 0;for(;R<S;){const x=Math.floor((R+S)/2);F(C[x])?S=x:R=x+1}return R}t.findFirstInSorted=a;function d(C,F,R){if(C=C|0,C>=F.length)throw new TypeError("invalid index");const S=F[Math.floor(F.length*Math.random())],x=[],B=[],P=[];for(const V of F){const G=R(V,S);G<0?x.push(V):G>0?B.push(V):P.push(V)}return C<x.length?d(C,x,R):C<x.length+P.length?P[0]:d(C-(x.length+P.length),B,R)}t.quickSelect=d;function I(C,F){const R=[];let S;for(const x of C.slice(0).sort(F))!S||F(S[0],x)!==0?(S=[x],R.push(S)):S.push(x);return R}t.groupBy=I;function r(C,F,R){const S=[];function x(V,G,ee){if(G===0&&ee.length===0)return;const re=S[S.length-1];re&&re.start+re.deleteCount===V?(re.deleteCount+=G,re.toInsert.push(...ee)):S.push({start:V,deleteCount:G,toInsert:ee})}let B=0,P=0;for(;;){if(B===C.length){x(B,0,F.slice(P));break}if(P===F.length){x(B,C.length-B,[]);break}const V=C[B],G=F[P],ee=R(V,G);ee===0?(B+=1,P+=1):ee<0?(x(B,1,[]),B+=1):ee>0&&(x(B,0,[G]),P+=1)}return S}t.sortedDiff=r;function u(C,F,R){const S=r(C,F,R),x=[],B=[];for(const P of S)x.push(...C.slice(P.start,P.start+P.deleteCount)),B.push(...P.toInsert);return{removed:x,added:B}}t.delta=u;function e(C,F,R){if(R===0)return[];const S=C.slice(0,R).sort(F);return n(C,F,S,R,C.length),S}t.top=e;function l(C,F,R,S,x){return R===0?Promise.resolve([]):new Promise((B,P)=>{(async()=>{const V=C.length,G=C.slice(0,R).sort(F);for(let ee=R,re=Math.min(R+S,V);ee<V;ee=re,re=Math.min(re+S,V)){if(ee>R&&await new Promise(be=>setTimeout(be)),x&&x.isCancellationRequested)throw new E.CancellationError;n(C,F,G,ee,re)}return G})().then(B,P)})}t.topAsync=l;function n(C,F,R,S,x){for(const B=R.length;S<x;S++){const P=C[S];if(F(P,R[B-1])<0){R.pop();const V=a(R,G=>F(P,G)<0);R.splice(V,0,P)}}}function h(C){return C.filter(F=>!!F)}t.coalesce=h;function s(C){let F=0;for(let R=0;R<C.length;R++)C[R]&&(C[F]=C[R],F+=1);C.length=F}t.coalesceInPlace=s;function D(C,F,R){C.splice(R,0,C.splice(F,1)[0])}t.move=D;function v(C){return!Array.isArray(C)||C.length===0}t.isFalsyOrEmpty=v;function A(C){return Array.isArray(C)&&C.length>0}t.isNonEmptyArray=A;function f(C,F=R=>R){const R=new Set;return C.filter(S=>{const x=F(S);return R.has(x)?!1:(R.add(x),!0)})}t.distinct=f;function p(C){const F=new Set;return R=>{const S=C(R);return F.has(S)?!1:(F.add(S),!0)}}t.uniqueFilter=p;function O(C,F){const R=k(C,F);if(R!==-1)return C[R]}t.findLast=O;function k(C,F){for(let R=C.length-1;R>=0;R--){const S=C[R];if(F(S))return R}return-1}t.lastIndex=k;function m(C,F){return C.length>0?C[0]:F}t.firstOrDefault=m;function g(C,F){return C.length>0?C[C.length-1]:F}t.lastOrDefault=g;function b(C,F,R=(S,x)=>S===x){let S=0;for(let x=0,B=Math.min(C.length,F.length);x<B&&R(C[x],F[x]);x++)S++;return S}t.commonPrefixLength=b;function N(C){return[].concat(...C)}t.flatten=N;function M(C,F){let R=typeof F=="number"?C:0;typeof F=="number"?R=C:(R=0,F=C);const S=[];if(R<=F)for(let x=R;x<F;x++)S.push(x);else for(let x=R;x>F;x--)S.push(x);return S}t.range=M;function H(C,F,R){return C.reduce((S,x)=>(S[F(x)]=R?R(x):x,S),Object.create(null))}t.index=H;function Z(C,F){return C.push(F),()=>ne(C,F)}t.insert=Z;function ne(C,F){const R=C.indexOf(F);if(R>-1)return C.splice(R,1),F}t.remove=ne;function se(C,F,R){const S=C.slice(0,F),x=C.slice(F);return S.concat(R,x)}t.arrayInsert=se;function he(C,F){let R;if(typeof F=="number"){let S=F;R=()=>{const x=Math.sin(S++)*179426549;return x-Math.floor(x)}}else R=Math.random;for(let S=C.length-1;S>0;S-=1){const x=Math.floor(R()*(S+1)),B=C[S];C[S]=C[x],C[x]=B}}t.shuffle=he;function ue(C,F){const R=C.indexOf(F);R>-1&&(C.splice(R,1),C.unshift(F))}t.pushToStart=ue;function le(C,F){const R=C.indexOf(F);R>-1&&(C.splice(R,1),C.push(F))}t.pushToEnd=le;function oe(C,F){for(const R of F)C.push(R)}t.pushMany=oe;function ye(C,F){return Array.isArray(C)?C.map(F):F(C)}t.mapArrayOrNot=ye;function Te(C){return Array.isArray(C)?C:[C]}t.asArray=Te;function Oe(C){return C[Math.floor(Math.random()*C.length)]}t.getRandomElement=Oe;function ke(C,F){for(const R of C){const S=F(R);if(S!==void 0)return S}}t.mapFind=ke;function fe(C,F,R){const S=ie(C,F),x=C.length,B=R.length;C.length=x+B;for(let P=x-1;P>=S;P--)C[P+B]=C[P];for(let P=0;P<B;P++)C[P+S]=R[P]}t.insertInto=fe;function U(C,F,R,S){const x=ie(C,F),B=C.splice(x,R);return fe(C,x,S),B}t.splice=U;function ie(C,F){return F<0?Math.max(F+C.length,0):Math.min(F,C.length)}var q;(function(C){function F(x){return x<0}C.isLessThan=F;function R(x){return x>0}C.isGreaterThan=R;function S(x){return x===0}C.isNeitherLessOrGreaterThan=S,C.greaterThan=1,C.lessThan=-1,C.neitherLessOrGreaterThan=0})(q||(t.CompareResult=q={}));function K(C,F){return(R,S)=>F(C(R),C(S))}t.compareBy=K;function _(...C){return(F,R)=>{for(const S of C){const x=S(F,R);if(!q.isNeitherLessOrGreaterThan(x))return x}return q.neitherLessOrGreaterThan}}t.tieBreakComparators=_;const j=(C,F)=>C-F;t.numberComparator=j;function z(C,F){if(C.length===0)return;let R=C[0];for(let S=1;S<C.length;S++){const x=C[S];F(x,R)>0&&(R=x)}return R}t.findMaxBy=z;function o(C,F){if(C.length===0)return;let R=C[0];for(let S=1;S<C.length;S++){const x=C[S];F(x,R)>=0&&(R=x)}return R}t.findLastMaxBy=o;function T(C,F){return z(C,(R,S)=>-F(R,S))}t.findMinBy=T;class ${constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let R=this.firstIdx;for(;R<this.items.length&&F(this.items[R]);)R++;const S=R===this.firstIdx?null:this.items.slice(this.firstIdx,R);return this.firstIdx=R,S}takeFromEndWhile(F){let R=this.lastIdx;for(;R>=0&&F(this.items[R]);)R--;const S=R===this.lastIdx?null:this.items.slice(R+1,this.lastIdx+1);return this.lastIdx=R,S}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}removeLast(){const F=this.items[this.lastIdx];return this.lastIdx--,F}takeCount(F){const R=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,R}}t.ArrayQueue=$;class Y{constructor(F){this.iterate=F}forEach(F){this.iterate(R=>(F(R),!0))}toArray(){const F=[];return this.iterate(R=>(F.push(R),!0)),F}filter(F){return new Y(R=>this.iterate(S=>F(S)?R(S):!0))}map(F){return new Y(R=>this.iterate(S=>R(F(S))))}some(F){let R=!1;return this.iterate(S=>(R=F(S),!R)),R}findFirst(F){let R;return this.iterate(S=>F(S)?(R=S,!1):!0),R}findLast(F){let R;return this.iterate(S=>(F(S)&&(R=S),!0)),R}findLastMaxBy(F){let R,S=!0;return this.iterate(x=>((S||q.isGreaterThan(F(x,R)))&&(S=!1,R=x),!0)),R}}t.CallbackIterable=Y,Y.empty=new Y(C=>{})}),define(ge[72],me([1,0,7]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function L(c,a){if(!c)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}t.ok=L;function i(c,a="Unreachable"){throw new Error(a)}t.assertNever=i;function W(c){if(!c)throw new E.BugIndicatingError("Assertion Failed")}t.assert=W;function w(c){if(!c()){debugger;c(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=w;function y(c,a){let d=0;for(;d<c.length-1;){const I=c[d],r=c[d+1];if(!a(I,r))return!1;d++}return!0}t.checkAdjacentItems=y}),define(ge[41],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(L){const i=this;let W=!1,w;return function(){return W||(W=!0,w=L.apply(i,arguments)),w}}t.once=E}),define(ge[73],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(i){this._prefix=i,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(ge[26],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(L){function i(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=i;const W=Object.freeze([]);function w(){return W}L.empty=w;function*y(v){yield v}L.single=y;function c(v){return i(v)?v:y(v)}L.wrap=c;function a(v){return v||W}L.from=a;function d(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=d;function I(v){return v[Symbol.iterator]().next().value}L.first=I;function r(v,A){for(const f of v)if(A(f))return!0;return!1}L.some=r;function u(v,A){for(const f of v)if(A(f))return f}L.find=u;function*e(v,A){for(const f of v)A(f)&&(yield f)}L.filter=e;function*l(v,A){let f=0;for(const p of v)yield A(p,f++)}L.map=l;function*n(...v){for(const A of v)for(const f of A)yield f}L.concat=n;function h(v,A,f){let p=f;for(const O of v)p=A(p,O);return p}L.reduce=h;function*s(v,A,f=v.length){for(A<0&&(A+=v.length),f<0?f+=v.length:f>v.length&&(f=v.length);A<f;A++)yield v[A]}L.slice=s;function D(v,A=Number.POSITIVE_INFINITY){const f=[];if(A===0)return[f,v];const p=v[Symbol.iterator]();for(let O=0;O<A;O++){const k=p.next();if(k.done)return[f,L.empty()];f.push(k.value)}return[f,{[Symbol.iterator](){return p}}]}L.consume=D})(E||(t.Iterable=E={}))}),define(ge[42],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(E||(t.KeyCode=E={}));var L;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(L||(t.ScanCode=L={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(l,n){this._keyCodeToStr[l]=n,this._strToKeyCode[n.toLowerCase()]=l}keyCodeToStr(l){return this._keyCodeToStr[l]}strToKeyCode(l){return this._strToKeyCode[l.toLowerCase()]||0}}const W=new i,w=new i,y=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const c=[],a=Object.create(null),d=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>a[e]||0,toString:e=>c[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",l=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],h=[];for(const s of l){const[D,v,A,f,p,O,k,m,g]=s;if(h[v]||(h[v]=!0,c[v]=A,a[A]=v,d[A.toLowerCase()]=v,D&&(t.IMMUTABLE_CODE_TO_KEY_CODE[v]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[f]=v))),!n[f]){if(n[f]=!0,!p)throw new Error(`String representation missing for key code ${f} around scan code ${A}`);W.define(f,p),w.define(f,m||p),y.define(f,g||m||p)}O&&(t.EVENT_KEY_CODE_MAP[O]=f),k&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[k]=f)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(e){function l(A){return W.keyCodeToStr(A)}e.toString=l;function n(A){return W.strToKeyCode(A)}e.fromString=n;function h(A){return w.keyCodeToStr(A)}e.toUserSettingsUS=h;function s(A){return y.keyCodeToStr(A)}e.toUserSettingsGeneral=s;function D(A){return w.strToKeyCode(A)||y.strToKeyCode(A)}e.fromUserSettings=D;function v(A){if(A>=98&&A<=113)return null;switch(A){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(A)}e.toElectronAccelerator=v})(I||(t.KeyCodeUtils=I={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function u(e,l){const n=(l&65535)<<16>>>0;return(e|n)>>>0}t.KeyChord=u}),define(ge[74],me([1,0,7]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var L;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(L||(L={}));function i(I,r){if(typeof I=="number"){if(I===0)return null;const u=(I&65535)>>>0,e=(I&4294901760)>>>16;return e!==0?new c([W(u,r),W(e,r)]):new c([W(u,r)])}else{const u=[];for(let e=0;e<I.length;e++)u.push(W(I[e],r));return new c(u)}}t.decodeKeybinding=i;function W(I,r){const u=!!(I&2048),e=!!(I&256),l=r===2?e:u,n=!!(I&1024),h=!!(I&512),s=r===2?u:e,D=I&255;return new w(l,n,h,s,D)}t.createSimpleKeybinding=W;class w{constructor(r,u,e,l,n){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=l,this.keyCode=n}equals(r){return r instanceof w&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",l=this.metaKey?"1":"0";return`K${r}${u}${e}${l}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=w;class y{constructor(r,u,e,l,n){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=l,this.scanCode=n}equals(r){return r instanceof y&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",l=this.metaKey?"1":"0";return`S${r}${u}${e}${l}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=y;class c{constructor(r){if(r.length===0)throw(0,E.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let u=0,e=this.chords.length;u<e;u++)u!==0&&(r+=";"),r+=this.chords[u].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let u=0;u<this.chords.length;u++)if(!this.chords[u].equals(r.chords[u]))return!1;return!0}}t.Keybinding=c;class a{constructor(r,u,e,l,n,h){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=l,this.keyLabel=n,this.keyAriaLabel=h}}t.ResolvedChord=a;class d{}t.ResolvedKeybinding=d}),define(ge[30],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=E}),define(ge[2],me([1,0,41,26]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let W=null;function w(g){W=g}if(t.setDisposableTracker=w,i){const g="__is_disposable_tracked__";w(new class{trackDisposable(b){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[g]||console.log(N)},3e3)}setParent(b,N){if(b&&b!==s.None)try{b[g]=!0}catch{}}markAsDisposed(b){if(b&&b!==s.None)try{b[g]=!0}catch{}}markAsSingleton(b){}})}function y(g){return W?.trackDisposable(g),g}function c(g){W?.markAsDisposed(g)}function a(g,b){W?.setParent(g,b)}function d(g,b){if(W)for(const N of g)W.setParent(N,b)}function I(g){return W?.markAsSingleton(g),g}t.markAsSingleton=I;function r(g){return typeof g.dispose=="function"&&g.dispose.length===0}t.isDisposable=r;function u(g){if(L.Iterable.is(g)){const b=[];for(const N of g)if(N)try{N.dispose()}catch(M){b.push(M)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}t.dispose=u;function e(g){for(const b of g)r(b)&&b.dispose();return[]}t.disposeIfDisposable=e;function l(...g){const b=n(()=>u(g));return d(g,b),b}t.combinedDisposable=l;function n(g){const b=y({dispose:(0,E.once)(()=>{c(b),g()})});return b}t.toDisposable=n;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return a(b,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(b),b}}t.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new h,y(this),a(this._store,this)}dispose(){c(this),this._store.dispose()}_register(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(b)}}t.Disposable=s,s.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(b){this._isDisposed||b===this._value||(this._value?.dispose(),b&&a(b,this),this._value=b)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,c(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const b=this._value;return this._value=void 0,b&&a(b,null),b}}t.MutableDisposable=D;class v{constructor(b){this._disposable=b,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=v;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(b){let N=b;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,c(this))},this}}t.SafeDisposable=A;class f{constructor(){this.references=new Map}acquire(b,...N){let M=this.references.get(b);M||(M={counter:0,object:this.createReferencedObject(b,...N)},this.references.set(b,M));const{object:H}=M,Z=(0,E.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(b,M.object),this.references.delete(b))});return M.counter++,{object:H,dispose:Z}}}t.ReferenceCollection=f;class p{constructor(b){this.referenceCollection=b}async acquire(b,...N){const M=this.referenceCollection.acquire(b,...N);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(H){throw M.dispose(),H}}}t.AsyncReferenceCollection=p;class O{constructor(b){this.object=b}dispose(){}}t.ImmortalReference=O;function k(g){const b=new h;try{g(b)}finally{b.dispose()}}t.disposeOnReturn=k;class m{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){c(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(b){return this._store.has(b)}get(b){return this._store.get(b)}set(b,N,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(b)?.dispose(),this._store.set(b,N)}deleteAndDispose(b){this._store.get(b)?.dispose(),this._store.delete(b)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=m}),define(ge[43],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(W){this.element=W,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class L{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let W=this._first;for(;W!==E.Undefined;){const w=W.next;W.prev=E.Undefined,W.next=E.Undefined,W=w}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(W){return this._insert(W,!1)}push(W){return this._insert(W,!0)}_insert(W,w){const y=new E(W);if(this._first===E.Undefined)this._first=y,this._last=y;else if(w){const a=this._last;this._last=y,y.prev=a,a.next=y}else{const a=this._first;this._first=y,y.next=a,a.prev=y}this._size+=1;let c=!1;return()=>{c||(c=!0,this._remove(y))}}shift(){if(this._first!==E.Undefined){const W=this._first.element;return this._remove(this._first),W}}pop(){if(this._last!==E.Undefined){const W=this._last.element;return this._remove(this._last),W}}_remove(W){if(W.prev!==E.Undefined&&W.next!==E.Undefined){const w=W.prev;w.next=W.next,W.next.prev=w}else W.prev===E.Undefined&&W.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):W.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):W.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let W=this._first;for(;W!==E.Undefined;)yield W.element,W=W.next}}t.LinkedList=L}),define(ge[75],me([1,0]),function(te,t){"use strict";var E,L,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function W(l,n,h){let s=l.get(n);return s===void 0&&(s=h,l.set(n,s)),s}t.getOrSet=W;function w(l){const n=[];return l.forEach((h,s)=>{n.push(`${s} => ${h}`)}),`Map(${l.size}) {${n.join(", ")}}`}t.mapToString=w;function y(l){const n=[];return l.forEach(h=>{n.push(h)}),`Set(${l.size}) {${n.join(", ")}}`}t.setToString=y;class c{constructor(n,h){this.uri=n,this.value=h}}class a{constructor(n,h){this[E]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=h??a.defaultToKey):(this.map=new Map,this.toKey=n??a.defaultToKey)}set(n,h){return this.map.set(this.toKey(n),new c(n,h)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,h){typeof h<"u"&&(n=n.bind(h));for(const[s,D]of this.map)n(D.value,D.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}t.ResourceMap=a,a.defaultToKey=l=>l.toString();class d{constructor(n,h){this[L]="ResourceSet",!n||typeof n=="function"?this._map=new a(n):(this._map=new a(h),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,h){this._map.forEach((s,D)=>n.call(h,D,D,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=d;var I;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(I||(t.Touch=I={}));class r{constructor(){this[i]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,h=0){const s=this._map.get(n);if(s)return h!==0&&this.touch(s,h),s.value}set(n,h,s=0){let D=this._map.get(n);if(D)D.value=h,s!==0&&this.touch(D,s);else{switch(D={key:n,value:h,next:void 0,previous:void 0},s){case 0:this.addItemLast(D);break;case 1:this.addItemFirst(D);break;case 2:this.addItemLast(D);break;default:this.addItemLast(D);break}this._map.set(n,D),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const h=this._map.get(n);if(h)return this._map.delete(n),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,h){const s=this._state;let D=this._head;for(;D;){if(h?n.bind(h)(D.value,D.key,this):n(D.value,D.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");D=D.next}}keys(){const n=this,h=this._state;let s=this._head;const D={[Symbol.iterator](){return D},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.key,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return D}values(){const n=this,h=this._state;let s=this._head;const D={[Symbol.iterator](){return D},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.value,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return D}entries(){const n=this,h=this._state;let s=this._head;const D={[Symbol.iterator](){return D},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:[s.key,s.value],done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return D}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let h=this._head,s=this.size;for(;h&&s>n;)this._map.delete(h.key),h=h.next,s--;this._head=h,this._size=s,h&&(h.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const h=n.next,s=n.previous;if(!h||!s)throw new Error("Invalid list");h.previous=s,s.next=h}n.next=void 0,n.previous=void 0,this._state++}touch(n,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(n===this._head)return;const s=n.next,D=n.previous;n===this._tail?(D.next=void 0,this._tail=D):(s.previous=D,D.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(h===2){if(n===this._tail)return;const s=n.next,D=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=D,D.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((h,s)=>{n.push([s,h])}),n}fromJSON(n){this.clear();for(const[h,s]of n)this.set(h,s)}}t.LinkedMap=r;class u extends r{constructor(n,h=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,h=2){return super.get(n,h)}peek(n){return super.get(n,0)}set(n,h){return super.set(n,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=u;class e{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let h=this.map.get(n)||0;return h===0?!1:(h--,h===0?this.map.delete(n):this.map.set(n,h),!0)}has(n){return this.map.has(n)}}t.CounterSet=e}),function(te,t){typeof define=="function"&&define.amd?define(ge[76],me([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(te=typeof globalThis<"u"?globalThis:te||self,t(te.marked={}))}(this,function(te){"use strict";function t(C,F){for(var R=0;R<F.length;R++){var S=F[R];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(C,S.key,S)}}function E(C,F,R){return F&&t(C.prototype,F),R&&t(C,R),Object.defineProperty(C,"prototype",{writable:!1}),C}function L(C,F){if(C){if(typeof C=="string")return i(C,F);var R=Object.prototype.toString.call(C).slice(8,-1);if(R==="Object"&&C.constructor&&(R=C.constructor.name),R==="Map"||R==="Set")return Array.from(C);if(R==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(R))return i(C,F)}}function i(C,F){(F==null||F>C.length)&&(F=C.length);for(var R=0,S=new Array(F);R<F;R++)S[R]=C[R];return S}function W(C,F){var R=typeof Symbol<"u"&&C[Symbol.iterator]||C["@@iterator"];if(R)return(R=R.call(C)).next.bind(R);if(Array.isArray(C)||(R=L(C))||F&&C&&typeof C.length=="number"){R&&(C=R);var S=0;return function(){return S>=C.length?{done:!0}:{done:!1,value:C[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=w();function y(C){te.defaults=C}var c=/[&<>"']/,a=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(F){return r[F]};function e(C,F){if(F){if(c.test(C))return C.replace(a,u)}else if(d.test(C))return C.replace(I,u);return C}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(C){return C.replace(l,function(F,R){return R=R.toLowerCase(),R==="colon"?":":R.charAt(0)==="#"?R.charAt(1)==="x"?String.fromCharCode(parseInt(R.substring(2),16)):String.fromCharCode(+R.substring(1)):""})}var h=/(^|[^\[])\^/g;function s(C,F){C=typeof C=="string"?C:C.source,F=F||"";var R={replace:function(x,B){return B=B.source||B,B=B.replace(h,"$1"),C=C.replace(x,B),R},getRegex:function(){return new RegExp(C,F)}};return R}var D=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function A(C,F,R){if(C){var S;try{S=decodeURIComponent(n(R)).replace(D,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}F&&!v.test(R)&&(R=m(F,R));try{R=encodeURI(R).replace(/%25/g,"%")}catch{return null}return R}var f={},p=/^[^:]+:\/*[^/]*$/,O=/^([^:]+:)[\s\S]*$/,k=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(C,F){f[" "+C]||(p.test(C)?f[" "+C]=C+"/":f[" "+C]=M(C,"/",!0)),C=f[" "+C];var R=C.indexOf(":")===-1;return F.substring(0,2)==="//"?R?F:C.replace(O,"$1")+F:F.charAt(0)==="/"?R?F:C.replace(k,"$1")+F:C+F}var g={exec:function(){}};function b(C){for(var F=1,R,S;F<arguments.length;F++){R=arguments[F];for(S in R)Object.prototype.hasOwnProperty.call(R,S)&&(C[S]=R[S])}return C}function N(C,F){var R=C.replace(/\|/g,function(B,P,V){for(var G=!1,ee=P;--ee>=0&&V[ee]==="\\";)G=!G;return G?"|":" |"}),S=R.split(/ \|/),x=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>F)S.splice(F);else for(;S.length<F;)S.push("");for(;x<S.length;x++)S[x]=S[x].trim().replace(/\\\|/g,"|");return S}function M(C,F,R){var S=C.length;if(S===0)return"";for(var x=0;x<S;){var B=C.charAt(S-x-1);if(B===F&&!R)x++;else if(B!==F&&R)x++;else break}return C.slice(0,S-x)}function H(C,F){if(C.indexOf(F[1])===-1)return-1;for(var R=C.length,S=0,x=0;x<R;x++)if(C[x]==="\\")x++;else if(C[x]===F[0])S++;else if(C[x]===F[1]&&(S--,S<0))return x;return-1}function Z(C){C&&C.sanitize&&!C.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ne(C,F){if(F<1)return"";for(var R="";F>1;)F&1&&(R+=C),F>>=1,C+=C;return R+C}function se(C,F,R,S){var x=F.href,B=F.title?e(F.title):null,P=C[1].replace(/\\([\[\]])/g,"$1");if(C[0].charAt(0)!=="!"){S.state.inLink=!0;var V={type:"link",raw:R,href:x,title:B,text:P,tokens:S.inlineTokens(P)};return S.state.inLink=!1,V}return{type:"image",raw:R,href:x,title:B,text:e(P)}}function he(C,F){var R=C.match(/^(\s+)(?:```)/);if(R===null)return F;var S=R[1];return F.split(`
`).map(function(x){var B=x.match(/^\s+/);if(B===null)return x;var P=B[0];return P.length>=S.length?x.slice(S.length):x}).join(`
`)}var ue=function(){function C(R){this.options=R||te.defaults}var F=C.prototype;return F.space=function(S){var x=this.rules.block.newline.exec(S);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},F.code=function(S){var x=this.rules.block.code.exec(S);if(x){var B=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?B:M(B,`
`)}}},F.fences=function(S){var x=this.rules.block.fences.exec(S);if(x){var B=x[0],P=he(B,x[3]||"");return{type:"code",raw:B,lang:x[2]?x[2].trim():x[2],text:P}}},F.heading=function(S){var x=this.rules.block.heading.exec(S);if(x){var B=x[2].trim();if(/#$/.test(B)){var P=M(B,"#");(this.options.pedantic||!P||/ $/.test(P))&&(B=P.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:B,tokens:this.lexer.inline(B)}}},F.hr=function(S){var x=this.rules.block.hr.exec(S);if(x)return{type:"hr",raw:x[0]}},F.blockquote=function(S){var x=this.rules.block.blockquote.exec(S);if(x){var B=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(B,[]),text:B}}},F.list=function(S){var x=this.rules.block.list.exec(S);if(x){var B,P,V,G,ee,re,be,De,Ie,Se,ve,Pe,Le=x[1].trim(),Ke=Le.length>1,xe={type:"list",raw:"",ordered:Ke,start:Ke?+Le.slice(0,-1):"",loose:!1,items:[]};Le=Ke?"\\d{1,9}\\"+Le.slice(-1):"\\"+Le,this.options.pedantic&&(Le=Ke?Le:"[*+-]");for(var We=new RegExp("^( {0,3}"+Le+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Pe=!1,!(!(x=We.exec(S))||this.rules.block.hr.test(S)));){if(B=x[0],S=S.substring(B.length),De=x[2].split(`
`,1)[0],Ie=S.split(`
`,1)[0],this.options.pedantic?(G=2,ve=De.trimLeft()):(G=x[2].search(/[^ ]/),G=G>4?1:G,ve=De.slice(G),G+=x[1].length),re=!1,!De&&/^ *$/.test(Ie)&&(B+=Ie+`
`,S=S.substring(Ie.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");S&&(Se=S.split(`
`,1)[0],De=Se,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(De)||Ve.test(De)||Je.test(De)||it.test(S)));){if(De.search(/[^ ]/)>=G||!De.trim())ve+=`
`+De.slice(G);else if(!re)ve+=`
`+De;else break;!re&&!De.trim()&&(re=!0),B+=Se+`
`,S=S.substring(Se.length+1)}xe.loose||(be?xe.loose=!0:/\n *\n *$/.test(B)&&(be=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(ve),P&&(V=P[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:B,task:!!P,checked:V,loose:!1,text:ve}),xe.raw+=B}xe.items[xe.items.length-1].raw=B.trimRight(),xe.items[xe.items.length-1].text=ve.trimRight(),xe.raw=xe.raw.trimRight();var X=xe.items.length;for(ee=0;ee<X;ee++){this.lexer.state.top=!1,xe.items[ee].tokens=this.lexer.blockTokens(xe.items[ee].text,[]);var ae=xe.items[ee].tokens.filter(function(we){return we.type==="space"}),pe=ae.every(function(we){for(var _e=we.raw.split(""),Re=0,Ue=W(_e),Ge;!(Ge=Ue()).done;){var et=Ge.value;if(et===`
`&&(Re+=1),Re>1)return!0}return!1});!xe.loose&&ae.length&&pe&&(xe.loose=!0,xe.items[ee].loose=!0)}return xe}},F.html=function(S){var x=this.rules.block.html.exec(S);if(x){var B={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var P=this.options.sanitizer?this.options.sanitizer(x[0]):e(x[0]);B.type="paragraph",B.text=P,B.tokens=this.lexer.inline(P)}return B}},F.def=function(S){var x=this.rules.block.def.exec(S);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var B=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:B,raw:x[0],href:x[2],title:x[3]}}},F.table=function(S){var x=this.rules.block.table.exec(S);if(x){var B={type:"table",header:N(x[1]).map(function(be){return{text:be}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(B.header.length===B.align.length){B.raw=x[0];var P=B.align.length,V,G,ee,re;for(V=0;V<P;V++)/^ *-+: *$/.test(B.align[V])?B.align[V]="right":/^ *:-+: *$/.test(B.align[V])?B.align[V]="center":/^ *:-+ *$/.test(B.align[V])?B.align[V]="left":B.align[V]=null;for(P=B.rows.length,V=0;V<P;V++)B.rows[V]=N(B.rows[V],B.header.length).map(function(be){return{text:be}});for(P=B.header.length,G=0;G<P;G++)B.header[G].tokens=this.lexer.inline(B.header[G].text);for(P=B.rows.length,G=0;G<P;G++)for(re=B.rows[G],ee=0;ee<re.length;ee++)re[ee].tokens=this.lexer.inline(re[ee].text);return B}}},F.lheading=function(S){var x=this.rules.block.lheading.exec(S);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},F.paragraph=function(S){var x=this.rules.block.paragraph.exec(S);if(x){var B=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:B,tokens:this.lexer.inline(B)}}},F.text=function(S){var x=this.rules.block.text.exec(S);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},F.escape=function(S){var x=this.rules.inline.escape.exec(S);if(x)return{type:"escape",raw:x[0],text:e(x[1])}},F.tag=function(S){var x=this.rules.inline.tag.exec(S);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):e(x[0]):x[0]}},F.link=function(S){var x=this.rules.inline.link.exec(S);if(x){var B=x[2].trim();if(!this.options.pedantic&&/^</.test(B)){if(!/>$/.test(B))return;var P=M(B.slice(0,-1),"\\");if((B.length-P.length)%2===0)return}else{var V=H(x[2],"()");if(V>-1){var G=x[0].indexOf("!")===0?5:4,ee=G+x[1].length+V;x[2]=x[2].substring(0,V),x[0]=x[0].substring(0,ee).trim(),x[3]=""}}var re=x[2],be="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(re);De&&(re=De[1],be=De[3])}else be=x[3]?x[3].slice(1,-1):"";return re=re.trim(),/^</.test(re)&&(this.options.pedantic&&!/>$/.test(B)?re=re.slice(1):re=re.slice(1,-1)),se(x,{href:re&&re.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},F.reflink=function(S,x){var B;if((B=this.rules.inline.reflink.exec(S))||(B=this.rules.inline.nolink.exec(S))){var P=(B[2]||B[1]).replace(/\s+/g," ");if(P=x[P.toLowerCase()],!P||!P.href){var V=B[0].charAt(0);return{type:"text",raw:V,text:V}}return se(B,P,B[0],this.lexer)}},F.emStrong=function(S,x,B){B===void 0&&(B="");var P=this.rules.inline.emStrong.lDelim.exec(S);if(P&&!(P[3]&&B.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var V=P[1]||P[2]||"";if(!V||V&&(B===""||this.rules.inline.punctuation.exec(B))){var G=P[0].length-1,ee,re,be=G,De=0,Ie=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ie.lastIndex=0,x=x.slice(-1*S.length+G);(P=Ie.exec(x))!=null;)if(ee=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!ee){if(re=ee.length,P[3]||P[4]){be+=re;continue}else if((P[5]||P[6])&&G%3&&!((G+re)%3)){De+=re;continue}if(be-=re,!(be>0)){if(re=Math.min(re,re+be+De),Math.min(G,re)%2){var Se=S.slice(1,G+P.index+re);return{type:"em",raw:S.slice(0,G+P.index+re+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var ve=S.slice(2,G+P.index+re-1);return{type:"strong",raw:S.slice(0,G+P.index+re+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},F.codespan=function(S){var x=this.rules.inline.code.exec(S);if(x){var B=x[2].replace(/\n/g," "),P=/[^ ]/.test(B),V=/^ /.test(B)&&/ $/.test(B);return P&&V&&(B=B.substring(1,B.length-1)),B=e(B,!0),{type:"codespan",raw:x[0],text:B}}},F.br=function(S){var x=this.rules.inline.br.exec(S);if(x)return{type:"br",raw:x[0]}},F.del=function(S){var x=this.rules.inline.del.exec(S);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},F.autolink=function(S,x){var B=this.rules.inline.autolink.exec(S);if(B){var P,V;return B[2]==="@"?(P=e(this.options.mangle?x(B[1]):B[1]),V="mailto:"+P):(P=e(B[1]),V=P),{type:"link",raw:B[0],text:P,href:V,tokens:[{type:"text",raw:P,text:P}]}}},F.url=function(S,x){var B;if(B=this.rules.inline.url.exec(S)){var P,V;if(B[2]==="@")P=e(this.options.mangle?x(B[0]):B[0]),V="mailto:"+P;else{var G;do G=B[0],B[0]=this.rules.inline._backpedal.exec(B[0])[0];while(G!==B[0]);P=e(B[0]),B[1]==="www."?V="http://"+P:V=P}return{type:"link",raw:B[0],text:P,href:V,tokens:[{type:"text",raw:P,text:P}]}}},F.inlineText=function(S,x){var B=this.rules.inline.text.exec(S);if(B){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]):B[0]:P=e(this.options.smartypants?x(B[0]):B[0]),{type:"text",raw:B[0],text:P}}},C}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=s(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=s(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=s(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=s(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=s(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=s(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=b({},le),le.gfm=b({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=s(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=s(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=b({},le.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:s(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=s(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=s(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=s(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=s(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=s(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=s(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=s(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=s(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=s(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=s(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=s(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=b({},oe),oe.pedantic=b({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=b({},oe.normal,{escape:s(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=s(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=b({},oe.gfm,{br:s(oe.br).replace("{2,}","*").getRegex(),text:s(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ye(C){return C.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Te(C){var F="",R,S,x=C.length;for(R=0;R<x;R++)S=C.charCodeAt(R),Math.random()>.5&&(S="x"+S.toString(16)),F+="&#"+S+";";return F}var Oe=function(){function C(R){this.tokens=[],this.tokens.links=Object.create(null),this.options=R||te.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:le.normal,inline:oe.normal};this.options.pedantic?(S.block=le.pedantic,S.inline=oe.pedantic):this.options.gfm&&(S.block=le.gfm,this.options.breaks?S.inline=oe.breaks:S.inline=oe.gfm),this.tokenizer.rules=S}C.lex=function(S,x){var B=new C(x);return B.lex(S)},C.lexInline=function(S,x){var B=new C(x);return B.inlineTokens(S)};var F=C.prototype;return F.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},F.blockTokens=function(S,x){var B=this;x===void 0&&(x=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(be,De,Ie){return De+"    ".repeat(Ie.length)});for(var P,V,G,ee;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(P=be.call({lexer:B},S,x))?(S=S.substring(P.raw.length),x.push(P),!0):!1}))){if(P=this.tokenizer.space(S)){S=S.substring(P.raw.length),P.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(P);continue}if(P=this.tokenizer.code(S)){S=S.substring(P.raw.length),V=x[x.length-1],V&&(V.type==="paragraph"||V.type==="text")?(V.raw+=`
`+P.raw,V.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=V.text):x.push(P);continue}if(P=this.tokenizer.fences(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.heading(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.hr(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.blockquote(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.list(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.html(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.def(S)){S=S.substring(P.raw.length),V=x[x.length-1],V&&(V.type==="paragraph"||V.type==="text")?(V.raw+=`
`+P.raw,V.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=V.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.lheading(S)){S=S.substring(P.raw.length),x.push(P);continue}if(G=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,De=S.slice(1),Ie=void 0;B.options.extensions.startBlock.forEach(function(Se){Ie=Se.call({lexer:this},De),typeof Ie=="number"&&Ie>=0&&(be=Math.min(be,Ie))}),be<1/0&&be>=0&&(G=S.substring(0,be+1))}(),this.state.top&&(P=this.tokenizer.paragraph(G))){V=x[x.length-1],ee&&V.type==="paragraph"?(V.raw+=`
`+P.raw,V.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=V.text):x.push(P),ee=G.length!==S.length,S=S.substring(P.raw.length);continue}if(P=this.tokenizer.text(S)){S=S.substring(P.raw.length),V=x[x.length-1],V&&V.type==="text"?(V.raw+=`
`+P.raw,V.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=V.text):x.push(P);continue}if(S){var re="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return this.state.top=!0,x},F.inline=function(S,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:S,tokens:x}),x},F.inlineTokens=function(S,x){var B=this;x===void 0&&(x=[]);var P,V,G,ee=S,re,be,De;if(this.tokens.links){var Ie=Object.keys(this.tokens.links);if(Ie.length>0)for(;(re=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Ie.includes(re[0].slice(re[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,re.index)+"["+ne("a",re[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(re=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,re.index)+"["+ne("a",re[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(re=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,re.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(be||(De=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(P=ve.call({lexer:B},S,x))?(S=S.substring(P.raw.length),x.push(P),!0):!1}))){if(P=this.tokenizer.escape(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.tag(S)){S=S.substring(P.raw.length),V=x[x.length-1],V&&P.type==="text"&&V.type==="text"?(V.raw+=P.raw,V.text+=P.text):x.push(P);continue}if(P=this.tokenizer.link(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(P.raw.length),V=x[x.length-1],V&&P.type==="text"&&V.type==="text"?(V.raw+=P.raw,V.text+=P.text):x.push(P);continue}if(P=this.tokenizer.emStrong(S,ee,De)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.codespan(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.br(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.del(S)){S=S.substring(P.raw.length),x.push(P);continue}if(P=this.tokenizer.autolink(S,Te)){S=S.substring(P.raw.length),x.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(S,Te))){S=S.substring(P.raw.length),x.push(P);continue}if(G=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=S.slice(1),Le=void 0;B.options.extensions.startInline.forEach(function(Ke){Le=Ke.call({lexer:this},Pe),typeof Le=="number"&&Le>=0&&(ve=Math.min(ve,Le))}),ve<1/0&&ve>=0&&(G=S.substring(0,ve+1))}(),P=this.tokenizer.inlineText(G,ye)){S=S.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(De=P.raw.slice(-1)),be=!0,V=x[x.length-1],V&&V.type==="text"?(V.raw+=P.raw,V.text+=P.text):x.push(P);continue}if(S){var Se="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return x},E(C,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),C}(),ke=function(){function C(R){this.options=R||te.defaults}var F=C.prototype;return F.code=function(S,x,B){var P=(x||"").match(/\S*/)[0];if(this.options.highlight){var V=this.options.highlight(S,P);V!=null&&V!==S&&(B=!0,S=V)}return S=S.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(B?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(B?S:e(S,!0))+`</code></pre>
`},F.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},F.html=function(S){return S},F.heading=function(S,x,B,P){if(this.options.headerIds){var V=this.options.headerPrefix+P.slug(B);return"<h"+x+' id="'+V+'">'+S+"</h"+x+`>
`}return"<h"+x+">"+S+"</h"+x+`>
`},F.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},F.list=function(S,x,B){var P=x?"ol":"ul",V=x&&B!==1?' start="'+B+'"':"";return"<"+P+V+`>
`+S+"</"+P+`>
`},F.listitem=function(S){return"<li>"+S+`</li>
`},F.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},F.paragraph=function(S){return"<p>"+S+`</p>
`},F.table=function(S,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+x+`</table>
`},F.tablerow=function(S){return`<tr>
`+S+`</tr>
`},F.tablecell=function(S,x){var B=x.header?"th":"td",P=x.align?"<"+B+' align="'+x.align+'">':"<"+B+">";return P+S+("</"+B+`>
`)},F.strong=function(S){return"<strong>"+S+"</strong>"},F.em=function(S){return"<em>"+S+"</em>"},F.codespan=function(S){return"<code>"+S+"</code>"},F.br=function(){return this.options.xhtml?"<br/>":"<br>"},F.del=function(S){return"<del>"+S+"</del>"},F.link=function(S,x,B){if(S=A(this.options.sanitize,this.options.baseUrl,S),S===null)return B;var P='<a href="'+e(S)+'"';return x&&(P+=' title="'+x+'"'),P+=">"+B+"</a>",P},F.image=function(S,x,B){if(S=A(this.options.sanitize,this.options.baseUrl,S),S===null)return B;var P='<img src="'+S+'" alt="'+B+'"';return x&&(P+=' title="'+x+'"'),P+=this.options.xhtml?"/>":">",P},F.text=function(S){return S},C}(),fe=function(){function C(){}var F=C.prototype;return F.strong=function(S){return S},F.em=function(S){return S},F.codespan=function(S){return S},F.del=function(S){return S},F.html=function(S){return S},F.text=function(S){return S},F.link=function(S,x,B){return""+B},F.image=function(S,x,B){return""+B},F.br=function(){return""},C}(),U=function(){function C(){this.seen={}}var F=C.prototype;return F.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},F.getNextSafeSlug=function(S,x){var B=S,P=0;if(this.seen.hasOwnProperty(B)){P=this.seen[S];do P++,B=S+"-"+P;while(this.seen.hasOwnProperty(B))}return x||(this.seen[S]=P,this.seen[B]=0),B},F.slug=function(S,x){x===void 0&&(x={});var B=this.serialize(S);return this.getNextSafeSlug(B,x.dryrun)},C}(),ie=function(){function C(R){this.options=R||te.defaults,this.options.renderer=this.options.renderer||new ke,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new U}C.parse=function(S,x){var B=new C(x);return B.parse(S)},C.parseInline=function(S,x){var B=new C(x);return B.parseInline(S)};var F=C.prototype;return F.parse=function(S,x){x===void 0&&(x=!0);var B="",P,V,G,ee,re,be,De,Ie,Se,ve,Pe,Le,Ke,xe,We,Je,it,Me,Ve,X=S.length;for(P=0;P<X;P++){if(ve=S[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Ve=this.options.extensions.renderers[ve.type].call({parser:this},ve),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){B+=Ve||"";continue}switch(ve.type){case"space":continue;case"hr":{B+=this.renderer.hr();continue}case"heading":{B+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,n(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{B+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ie="",De="",ee=ve.header.length,V=0;V<ee;V++)De+=this.renderer.tablecell(this.parseInline(ve.header[V].tokens),{header:!0,align:ve.align[V]});for(Ie+=this.renderer.tablerow(De),Se="",ee=ve.rows.length,V=0;V<ee;V++){for(be=ve.rows[V],De="",re=be.length,G=0;G<re;G++)De+=this.renderer.tablecell(this.parseInline(be[G].tokens),{header:!1,align:ve.align[G]});Se+=this.renderer.tablerow(De)}B+=this.renderer.table(Ie,Se);continue}case"blockquote":{Se=this.parse(ve.tokens),B+=this.renderer.blockquote(Se);continue}case"list":{for(Pe=ve.ordered,Le=ve.start,Ke=ve.loose,ee=ve.items.length,Se="",V=0;V<ee;V++)We=ve.items[V],Je=We.checked,it=We.task,xe="",We.task&&(Me=this.renderer.checkbox(Je),Ke?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Me+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Me+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Me}):xe+=Me),xe+=this.parse(We.tokens,Ke),Se+=this.renderer.listitem(xe,it,Je);B+=this.renderer.list(Se,Pe,Le);continue}case"html":{B+=this.renderer.html(ve.text);continue}case"paragraph":{B+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Se=ve.tokens?this.parseInline(ve.tokens):ve.text;P+1<X&&S[P+1].type==="text";)ve=S[++P],Se+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);B+=x?this.renderer.paragraph(Se):Se;continue}default:{var ae='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(ae);return}else throw new Error(ae)}}}return B},F.parseInline=function(S,x){x=x||this.renderer;var B="",P,V,G,ee=S.length;for(P=0;P<ee;P++){if(V=S[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(G=this.options.extensions.renderers[V.type].call({parser:this},V),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(V.type))){B+=G||"";continue}switch(V.type){case"escape":{B+=x.text(V.text);break}case"html":{B+=x.html(V.text);break}case"link":{B+=x.link(V.href,V.title,this.parseInline(V.tokens,x));break}case"image":{B+=x.image(V.href,V.title,V.text);break}case"strong":{B+=x.strong(this.parseInline(V.tokens,x));break}case"em":{B+=x.em(this.parseInline(V.tokens,x));break}case"codespan":{B+=x.codespan(V.text);break}case"br":{B+=x.br();break}case"del":{B+=x.del(this.parseInline(V.tokens,x));break}case"text":{B+=x.text(V.text);break}default:{var re='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(re);return}else throw new Error(re)}}}return B},C}();function q(C,F,R){if(typeof C>"u"||C===null)throw new Error("marked(): input parameter is undefined or null");if(typeof C!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(C)+", string expected");if(typeof F=="function"&&(R=F,F=null),F=b({},q.defaults,F||{}),Z(F),R){var S=F.highlight,x;try{x=Oe.lex(C,F)}catch(ee){return R(ee)}var B=function(re){var be;if(!re)try{F.walkTokens&&q.walkTokens(x,F.walkTokens),be=ie.parse(x,F)}catch(De){re=De}return F.highlight=S,re?R(re):R(null,be)};if(!S||S.length<3||(delete F.highlight,!x.length))return B();var P=0;q.walkTokens(x,function(ee){ee.type==="code"&&(P++,setTimeout(function(){S(ee.text,ee.lang,function(re,be){if(re)return B(re);be!=null&&be!==ee.text&&(ee.text=be,ee.escaped=!0),P--,P===0&&B()})},0))}),P===0&&B();return}function V(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,F.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var G=Oe.lex(C,F);if(F.walkTokens){if(F.async)return Promise.all(q.walkTokens(G,F.walkTokens)).then(function(){return ie.parse(G,F)}).catch(V);q.walkTokens(G,F.walkTokens)}return ie.parse(G,F)}catch(ee){V(ee)}}q.options=q.setOptions=function(C){return b(q.defaults,C),y(q.defaults),q},q.getDefaults=w,q.defaults=te.defaults,q.use=function(){for(var C=arguments.length,F=new Array(C),R=0;R<C;R++)F[R]=arguments[R];var S=b.apply(void 0,[{}].concat(F)),x=q.defaults.extensions||{renderers:{},childTokens:{}},B;F.forEach(function(P){if(P.extensions&&(B=!0,P.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var ee=x.renderers?x.renderers[G.name]:null;ee?x.renderers[G.name]=function(){for(var re=arguments.length,be=new Array(re),De=0;De<re;De++)be[De]=arguments[De];var Ie=G.renderer.apply(this,be);return Ie===!1&&(Ie=ee.apply(this,be)),Ie}:x.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[G.level]?x[G.level].unshift(G.tokenizer):x[G.level]=[G.tokenizer],G.start&&(G.level==="block"?x.startBlock?x.startBlock.push(G.start):x.startBlock=[G.start]:G.level==="inline"&&(x.startInline?x.startInline.push(G.start):x.startInline=[G.start]))}G.childTokens&&(x.childTokens[G.name]=G.childTokens)})),P.renderer&&function(){var G=q.defaults.renderer||new ke,ee=function(De){var Ie=G[De];G[De]=function(){for(var Se=arguments.length,ve=new Array(Se),Pe=0;Pe<Se;Pe++)ve[Pe]=arguments[Pe];var Le=P.renderer[De].apply(G,ve);return Le===!1&&(Le=Ie.apply(G,ve)),Le}};for(var re in P.renderer)ee(re);S.renderer=G}(),P.tokenizer&&function(){var G=q.defaults.tokenizer||new ue,ee=function(De){var Ie=G[De];G[De]=function(){for(var Se=arguments.length,ve=new Array(Se),Pe=0;Pe<Se;Pe++)ve[Pe]=arguments[Pe];var Le=P.tokenizer[De].apply(G,ve);return Le===!1&&(Le=Ie.apply(G,ve)),Le}};for(var re in P.tokenizer)ee(re);S.tokenizer=G}(),P.walkTokens){var V=q.defaults.walkTokens;S.walkTokens=function(G){var ee=[];return ee.push(P.walkTokens.call(this,G)),V&&(ee=ee.concat(V.call(this,G))),ee}}B&&(S.extensions=x),q.setOptions(S)})},q.walkTokens=function(C,F){for(var R=[],S=function(){var V=B.value;switch(R=R.concat(F.call(q,V)),V.type){case"table":{for(var G=W(V.header),ee;!(ee=G()).done;){var re=ee.value;R=R.concat(q.walkTokens(re.tokens,F))}for(var be=W(V.rows),De;!(De=be()).done;)for(var Ie=De.value,Se=W(Ie),ve;!(ve=Se()).done;){var Pe=ve.value;R=R.concat(q.walkTokens(Pe.tokens,F))}break}case"list":{R=R.concat(q.walkTokens(V.items,F));break}default:q.defaults.extensions&&q.defaults.extensions.childTokens&&q.defaults.extensions.childTokens[V.type]?q.defaults.extensions.childTokens[V.type].forEach(function(Le){R=R.concat(q.walkTokens(V[Le],F))}):V.tokens&&(R=R.concat(q.walkTokens(V.tokens,F)))}},x=W(C),B;!(B=x()).done;)S();return R},q.parseInline=function(C,F){if(typeof C>"u"||C===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof C!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(C)+", string expected");F=b({},q.defaults,F||{}),Z(F);try{var R=Oe.lexInline(C,F);return F.walkTokens&&q.walkTokens(R,F.walkTokens),ie.parseInline(R,F)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,F.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},q.Parser=ie,q.parser=ie.parse,q.Renderer=ke,q.TextRenderer=fe,q.Lexer=Oe,q.lexer=Oe.lex,q.Tokenizer=ue,q.Slugger=U,q.parse=q;var K=q.options,_=q.setOptions,j=q.use,z=q.walkTokens,o=q.parseInline,T=q,$=ie.parse,Y=Oe.lex;te.Lexer=Oe,te.Parser=ie,te.Renderer=ke,te.Slugger=U,te.TextRenderer=fe,te.Tokenizer=ue,te.getDefaults=w,te.lexer=Y,te.marked=q,te.options=K,te.parse=T,te.parseInline=o,te.parser=$,te.setOptions=_,te.use=j,te.walkTokens=z,Object.defineProperty(te,"__esModule",{value:!0})}),define(ge[77],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(i,W=0,w=i.length,y=W-1){this.items=i,this.start=W,this.end=w,this.index=y}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=E}),define(ge[78],me([1,0,77]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class L{constructor(w=[],y=10){this._initialize(w),this._limit=y,this._onChange()}getHistory(){return this._elements}add(w){this._history.delete(w),this._history.add(w),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(w){return this._history.has(w)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const w=this._elements;this._navigator=new E.ArrayNavigator(w,0,w.length,w.length)}_reduceToLimit(){const w=this._elements;w.length>this._limit&&this._initialize(w.slice(w.length-this._limit))}_currentPosition(){const w=this._navigator.current();return w?this._elements.indexOf(w):-1}_initialize(w){this._history=new Set;for(const y of w)this._history.add(y)}get _elements(){const w=[];return this._history.forEach(y=>w.push(y)),w}}t.HistoryNavigator=L;class i{constructor(w,y=10){if(this.capacity=y,w.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:w[0],previous:void 0,next:void 0},this.valueSet=new Set([w[0]]);for(let c=1;c<w.length;c++)this.add(w[c])}add(w){const y={value:w,previous:this.tail,next:void 0};for(this.tail.next=y,this.tail=y,this.cursor=this.tail,this.size++,this.valueSet.has(w)?this._deleteFromList(w):this.valueSet.add(w);this.size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(w){if(this.tail.value===w)return w;const y=this.tail.value;return this.valueSet.delete(y),this.tail.value=w,this.valueSet.has(w)?this._deleteFromList(w):this.valueSet.add(w),y}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(w){return this.valueSet.has(w)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let w=this.head;for(;w;)yield w.value,w=w.next}_deleteFromList(w){let y=this.head;for(;y!==this.tail;)y.value===w&&(y===this.head?(this.head=this.head.next,this.head.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.size--),y=y.next}}t.HistoryNavigator2=i}),define(ge[44],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(y,c,a){return Math.min(Math.max(y,c),a)}t.clamp=E;function L(y,c){return(c+y%c)%c}t.rot=L;class i{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=i;class W{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=W;class w{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const a=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=w}),define(ge[45],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(L){function i(c,a){if(c.start>=a.end||a.start>=c.end)return{start:0,end:0};const d=Math.max(c.start,a.start),I=Math.min(c.end,a.end);return I-d<=0?{start:0,end:0}:{start:d,end:I}}L.intersect=i;function W(c){return c.end-c.start<=0}L.isEmpty=W;function w(c,a){return!W(i(c,a))}L.intersects=w;function y(c,a){const d=[],I={start:c.start,end:Math.min(a.start,c.end)},r={start:Math.max(a.end,c.start),end:c.end};return W(I)||d.push(I),W(r)||d.push(r),d}L.relativeComplement=y})(E||(t.Range=E={}))}),define(ge[79],me([1,0,45]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function L(c,a){const d=[];for(const I of a){if(c.start>=I.range.end)continue;if(c.end<I.range.start)break;const r=E.Range.intersect(c,I.range);E.Range.isEmpty(r)||d.push({range:r,size:I.size})}return d}t.groupIntersect=L;function i({start:c,end:a},d){return{start:c+d,end:a+d}}t.shift=i;function W(c){const a=[];let d=null;for(const I of c){const r=I.range.start,u=I.range.end,e=I.size;if(d&&e===d.size){d.range.end=u;continue}d={range:{start:r,end:u},size:e},a.push(d)}return a}t.consolidate=W;function w(...c){return W(c.reduce((a,d)=>a.concat(d),[]))}class y{constructor(){this.groups=[],this._size=0}splice(a,d,I=[]){const r=I.length-d,u=L({start:0,end:a},this.groups),e=L({start:a+d,end:Number.POSITIVE_INFINITY},this.groups).map(n=>({range:i(n.range,r),size:n.size})),l=I.map((n,h)=>({range:{start:a+h,end:a+h+1},size:n.size}));this.groups=w(u,l,e),this._size=this.groups.reduce((n,h)=>n+h.size*(h.range.end-h.range.start),0)}get count(){const a=this.groups.length;return a?this.groups[a-1].range.end:0}get size(){return this._size}indexAt(a){if(a<0)return-1;let d=0,I=0;for(const r of this.groups){const u=r.range.end-r.range.start,e=I+u*r.size;if(a<e)return d+Math.floor((a-I)/r.size);d+=u,I=e}return d}indexAfter(a){return Math.min(this.indexAt(a)+1,this.count)}positionAt(a){if(a<0)return-1;let d=0,I=0;for(const r of this.groups){const u=r.range.end-r.range.start,e=I+u;if(a<e)return d+(a-I)*r.size;d+=u*r.size,I=e}return-1}}t.RangeMap=y}),define(ge[80],me([1,0,7,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(v){const A=v;return A?typeof A.read=="function":!1}t.isReadable=i;function W(v){const A=v;return A?[A.on,A.pause,A.resume,A.destroy].every(f=>typeof f=="function"):!1}t.isReadableStream=W;function w(v){const A=v;return A?W(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}t.isReadableBufferedStream=w;function y(v,A){return new c(v,A)}t.newWriteableStream=y;class c{constructor(A,f){this.reducer=A,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(A){if(!this.state.destroyed){if(this.state.flowing)this.emitData(A);else if(this.buffer.data.push(A),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(A){this.state.destroyed||(this.state.flowing?this.emitError(A):this.buffer.error.push(A))}end(A){this.state.destroyed||(typeof A<"u"&&this.write(A),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(A){this.listeners.data.slice(0).forEach(f=>f(A))}emitError(A){this.listeners.error.length===0?(0,E.onUnexpectedError)(A):this.listeners.error.slice(0).forEach(f=>f(A))}emitEnd(){this.listeners.end.slice(0).forEach(A=>A())}on(A,f){if(!this.state.destroyed)switch(A){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(A,f){if(this.state.destroyed)return;let p;switch(A){case"data":p=this.listeners.data;break;case"end":p=this.listeners.end;break;case"error":p=this.listeners.error;break}if(p){const O=p.indexOf(f);O>=0&&p.splice(O,1)}}flowData(){if(this.buffer.data.length>0){const A=this.reducer(this.buffer.data);this.emitData(A),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(p=>p())}}flowErrors(){if(this.listeners.error.length>0){for(const A of this.buffer.error)this.emitError(A);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(v,A){const f=[];let p;for(;(p=v.read())!==null;)f.push(p);return A(f)}t.consumeReadable=a;function d(v,A,f){const p=[];let O;for(;(O=v.read())!==null&&p.length<f;)p.push(O);return O===null&&p.length>0?A(p):{read:()=>{if(p.length>0)return p.shift();if(typeof O<"u"){const k=O;return O=void 0,k}return v.read()}}}t.peekReadable=d;function I(v,A){return new Promise((f,p)=>{const O=[];r(v,{onData:k=>{A&&O.push(k)},onError:k=>{A?p(k):f(void 0)},onEnd:()=>{f(A?A(O):void 0)}})})}t.consumeStream=I;function r(v,A){let f=!1;return v.on("error",p=>{f||A.onError(p)}),v.on("end",()=>{f||A.onEnd()}),v.on("data",p=>{f||A.onData(p)}),(0,L.toDisposable)(()=>f=!0)}t.listenStream=r;function u(v,A){return new Promise((f,p)=>{const O=new L.DisposableStore,k=[],m=N=>{if(k.push(N),k.length>A)return O.dispose(),v.pause(),f({stream:v,buffer:k,ended:!1})},g=N=>p(N),b=()=>f({stream:v,buffer:k,ended:!0});O.add((0,L.toDisposable)(()=>v.removeListener("error",g))),v.on("error",g),O.add((0,L.toDisposable)(()=>v.removeListener("end",b))),v.on("end",b),O.add((0,L.toDisposable)(()=>v.removeListener("data",m))),v.on("data",m)})}t.peekStream=u;function e(v,A){const f=y(A);return f.end(v),f}t.toStream=e;function l(){const v=y(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=l;function n(v){let A=!1;return{read:()=>A?null:(A=!0,v)}}t.toReadable=n;function h(v,A,f){const p=y(f);return r(v,{onData:O=>p.write(A.data(O)),onError:O=>p.error(A.error?A.error(O):O),onEnd:()=>p.end()}),p}t.transform=h;function s(v,A,f){let p=!1;return{read:()=>{const O=A.read();return p?O:(p=!0,O!==null?f([v,O]):v)}}}t.prefixedReadable=s;function D(v,A,f){let p=!1;const O=y(f);return r(A,{onData:k=>p?O.write(k):(p=!0,O.write(f([v,k]))),onError:k=>O.error(k),onEnd:()=>{p||(p=!0,O.write(v)),O.end()}}),O}t.prefixedStream=D}),define(ge[31],me([1,0,30,80]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u",W=new E.Lazy(()=>new Uint8Array(256));let w,y;class c{static alloc(H){return i?new c(Buffer.allocUnsafe(H)):new c(new Uint8Array(H))}static wrap(H){return i&&!Buffer.isBuffer(H)&&(H=Buffer.from(H.buffer,H.byteOffset,H.byteLength)),new c(H)}static fromString(H,Z){return!(Z?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(H)):(w||(w=new TextEncoder),new c(w.encode(H)))}static fromByteArray(H){const Z=c.alloc(H.length);for(let ne=0,se=H.length;ne<se;ne++)Z.buffer[ne]=H[ne];return Z}static concat(H,Z){if(typeof Z>"u"){Z=0;for(let he=0,ue=H.length;he<ue;he++)Z+=H[he].byteLength}const ne=c.alloc(Z);let se=0;for(let he=0,ue=H.length;he<ue;he++){const le=H[he];ne.set(le,se),se+=le.byteLength}return ne}constructor(H){this.buffer=H,this.byteLength=this.buffer.byteLength}clone(){const H=c.alloc(this.byteLength);return H.set(this),H}toString(){return i?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(H,Z){return new c(this.buffer.subarray(H,Z))}set(H,Z){if(H instanceof c)this.buffer.set(H.buffer,Z);else if(H instanceof Uint8Array)this.buffer.set(H,Z);else if(H instanceof ArrayBuffer)this.buffer.set(new Uint8Array(H),Z);else if(ArrayBuffer.isView(H))this.buffer.set(new Uint8Array(H.buffer,H.byteOffset,H.byteLength),Z);else throw new Error("Unknown argument 'array'")}readUInt32BE(H){return I(this.buffer,H)}writeUInt32BE(H,Z){r(this.buffer,H,Z)}readUInt32LE(H){return u(this.buffer,H)}writeUInt32LE(H,Z){e(this.buffer,H,Z)}readUInt8(H){return l(this.buffer,H)}writeUInt8(H,Z){n(this.buffer,H,Z)}indexOf(H){const Z=H instanceof c?H.buffer:H,ne=Z.byteLength,se=this.buffer,he=se.byteLength;if(ne===0)return 0;if(ne===1)return se.indexOf(Z[0]);if(ne>he)return-1;const ue=W.value;ue.fill(Z.length);for(let Te=0;Te<Z.length;Te++)ue[Z[Te]]=Z.length-Te-1;let le=Z.length-1,oe=le,ye=-1;for(;le<he;)if(se[le]===Z[oe]){if(oe===0){ye=le;break}le--,oe--}else le+=Math.max(Z.length-oe,ue[se[le]]),oe=Z.length-1;return ye}}t.VSBuffer=c;function a(M,H){return M[H+0]<<0>>>0|M[H+1]<<8>>>0}t.readUInt16LE=a;function d(M,H,Z){M[Z+0]=H&255,H=H>>>8,M[Z+1]=H&255}t.writeUInt16LE=d;function I(M,H){return M[H]*2**24+M[H+1]*2**16+M[H+2]*2**8+M[H+3]}t.readUInt32BE=I;function r(M,H,Z){M[Z+3]=H,H=H>>>8,M[Z+2]=H,H=H>>>8,M[Z+1]=H,H=H>>>8,M[Z]=H}t.writeUInt32BE=r;function u(M,H){return M[H+0]<<0>>>0|M[H+1]<<8>>>0|M[H+2]<<16>>>0|M[H+3]<<24>>>0}t.readUInt32LE=u;function e(M,H,Z){M[Z+0]=H&255,H=H>>>8,M[Z+1]=H&255,H=H>>>8,M[Z+2]=H&255,H=H>>>8,M[Z+3]=H&255}t.writeUInt32LE=e;function l(M,H){return M[H]}t.readUInt8=l;function n(M,H,Z){M[Z]=H}t.writeUInt8=n;function h(M){return L.consumeReadable(M,H=>c.concat(H))}t.readableToBuffer=h;function s(M){return L.toReadable(M)}t.bufferToReadable=s;function D(M){return L.consumeStream(M,H=>c.concat(H))}t.streamToBuffer=D;async function v(M){return M.ended?c.concat(M.buffer):c.concat([...M.buffer,await D(M.stream)])}t.bufferedStreamToBuffer=v;function A(M){return L.toStream(M,H=>c.concat(H))}t.bufferToStream=A;function f(M){return L.transform(M,{data:H=>typeof H=="string"?c.fromString(H):c.wrap(H)},H=>c.concat(H))}t.streamToBufferReadableStream=f;function p(M){return L.newWriteableStream(H=>c.concat(H),M)}t.newWriteableBufferStream=p;function O(M,H){return L.prefixedReadable(M,H,Z=>c.concat(Z))}t.prefixedBufferReadable=O;function k(M,H){return L.prefixedStream(M,H,Z=>c.concat(Z))}t.prefixedBufferStream=k;function m(M){let H=0,Z=0,ne=0;const se=new Uint8Array(Math.floor(M.length/4*3)),he=le=>{switch(Z){case 3:se[ne++]=H|le,Z=0;break;case 2:se[ne++]=H|le>>>2,H=le<<6,Z=3;break;case 1:se[ne++]=H|le>>>4,H=le<<4,Z=2;break;default:H=le<<2,Z=1}};for(let le=0;le<M.length;le++){const oe=M.charCodeAt(le);if(oe>=65&&oe<=90)he(oe-65);else if(oe>=97&&oe<=122)he(oe-97+26);else if(oe>=48&&oe<=57)he(oe-48+52);else if(oe===43||oe===45)he(62);else if(oe===47||oe===95)he(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${M[le]}`)}}const ue=ne;for(;Z>0;)he(0);return c.wrap(se).slice(0,ue)}t.decodeBase64=m;const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:M},H=!0,Z=!1){const ne=Z?b:g;let se="";const he=M.byteLength%3;let ue=0;for(;ue<M.byteLength-he;ue+=3){const le=M[ue+0],oe=M[ue+1],ye=M[ue+2];se+=ne[le>>>2],se+=ne[(le<<4|oe>>>4)&63],se+=ne[(oe<<2|ye>>>6)&63],se+=ne[ye&63]}if(he===1){const le=M[ue+0];se+=ne[le>>>2],se+=ne[le<<4&63],H&&(se+="==")}else if(he===2){const le=M[ue+0],oe=M[ue+1];se+=ne[le>>>2],se+=ne[(le<<4|oe>>>4)&63],se+=ne[oe<<2&63],H&&(se+="=")}return se}t.encodeBase64=N}),define(ge[46],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[6],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(p){return typeof p=="string"}t.isString=E;function L(p){return Array.isArray(p)&&p.every(O=>E(O))}t.isStringArray=L;function i(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}t.isObject=i;function W(p){const O=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof O}t.isTypedArray=W;function w(p){return typeof p=="number"&&!isNaN(p)}t.isNumber=w;function y(p){return!!p&&typeof p[Symbol.iterator]=="function"}t.isIterable=y;function c(p){return p===!0||p===!1}t.isBoolean=c;function a(p){return typeof p>"u"}t.isUndefined=a;function d(p){return!I(p)}t.isDefined=d;function I(p){return a(p)||p===null}t.isUndefinedOrNull=I;function r(p,O){if(!p)throw new Error(O?`Unexpected type, expected '${O}'`:"Unexpected type")}t.assertType=r;function u(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}t.assertIsDefined=u;function e(...p){const O=[];for(let k=0;k<p.length;k++){const m=p[k];if(I(m))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);O.push(m)}return O}t.assertAllDefined=e;const l=Object.prototype.hasOwnProperty;function n(p){if(!i(p))return!1;for(const O in p)if(l.call(p,O))return!1;return!0}t.isEmptyObject=n;function h(p){return typeof p=="function"}t.isFunction=h;function s(...p){return p.length>0&&p.every(h)}t.areFunctions=s;function D(p,O){const k=Math.min(p.length,O.length);for(let m=0;m<k;m++)v(p[m],O[m])}t.validateConstraints=D;function v(p,O){if(E(O)){if(typeof p!==O)throw new Error(`argument does not match constraint: typeof ${O}`)}else if(h(O)){try{if(p instanceof O)return}catch{}if(!I(p)&&p.constructor===O||O.length===1&&O.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=v;function A(p){return p===null?void 0:p}t.withNullAsUndefined=A;function f(p){return typeof p>"u"?null:p}t.withUndefinedAsNull=f}),define(ge[16],me([1,0,6]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const L=Object.create(null);function i(y,c){if((0,E.isString)(c)){const a=L[c];if(a===void 0)throw new Error(`${y} references an unknown codicon: ${c}`);c=a}return L[y]=c,{id:y}}function W(){return L}t.getCodiconFontCharacters=W;function w(){return Object.values(t.Codicon)}t.getAllCodicons=w,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(ge[47],me([1,0,6]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const s=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([D,v])=>{s[D]=v&&typeof v=="object"?L(v):v}),s}t.deepClone=L;function i(h){if(!h||typeof h!="object")return h;const s=[h];for(;s.length>0;){const D=s.shift();Object.freeze(D);for(const v in D)if(W.call(D,v)){const A=D[v];typeof A=="object"&&!Object.isFrozen(A)&&!(0,E.isTypedArray)(A)&&s.push(A)}}return h}t.deepFreeze=i;const W=Object.prototype.hasOwnProperty;function w(h,s){return y(h,s,new Set)}t.cloneAndChange=w;function y(h,s,D){if((0,E.isUndefinedOrNull)(h))return h;const v=s(h);if(typeof v<"u")return v;if(Array.isArray(h)){const A=[];for(const f of h)A.push(y(f,s,D));return A}if((0,E.isObject)(h)){if(D.has(h))throw new Error("Cannot clone recursive data-structure");D.add(h);const A={};for(const f in h)W.call(h,f)&&(A[f]=y(h[f],s,D));return D.delete(h),A}return h}function c(h,s,D=!0){return(0,E.isObject)(h)?((0,E.isObject)(s)&&Object.keys(s).forEach(v=>{v in h?D&&((0,E.isObject)(h[v])&&(0,E.isObject)(s[v])?c(h[v],s[v],D):h[v]=s[v]):h[v]=s[v]}),h):s}t.mixin=c;function a(h,s){if(h===s)return!0;if(h==null||s===null||s===void 0||typeof h!=typeof s||typeof h!="object"||Array.isArray(h)!==Array.isArray(s))return!1;let D,v;if(Array.isArray(h)){if(h.length!==s.length)return!1;for(D=0;D<h.length;D++)if(!a(h[D],s[D]))return!1}else{const A=[];for(v in h)A.push(v);A.sort();const f=[];for(v in s)f.push(v);if(f.sort(),!a(A,f))return!1;for(D=0;D<A.length;D++)if(!a(h[A[D]],s[A[D]]))return!1}return!0}t.equals=a;function d(h){const s=new Set;return JSON.stringify(h,(D,v)=>{if((0,E.isObject)(v)||Array.isArray(v)){if(s.has(v))return"[Circular]";s.add(v)}return v})}t.safeStringify=d;function I(h,s){const D=Object.create(null);return!h||!s||Object.keys(s).forEach(A=>{const f=h[A],p=s[A];a(f,p)||(D[A]=p)}),D}t.distinct=I;function r(h,s){const D=s.toLowerCase(),v=Object.keys(h).find(A=>A.toLowerCase()===D);return v?h[v]:h[s]}t.getCaseInsensitive=r;function u(h,s){const D=Object.create(null);for(const[v,A]of Object.entries(h))s(v,A)&&(D[v]=A);return D}t.filter=u;function e(h){let s=[],D=Object.getPrototypeOf(h);for(;Object.prototype!==D;)s=s.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return s}t.getAllPropertyNames=e;function l(h){const s=[];for(const D of e(h))typeof h[D]=="function"&&s.push(D);return s}t.getAllMethodNames=l;function n(h,s){const D=A=>function(){const f=Array.prototype.slice.call(arguments,0);return s(A,f)},v={};for(const A of h)v[A]=D(A);return v}t.createProxyObject=n}),define(ge[17],me([1,0,16]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var L;(function(w){function y(c){return c&&typeof c=="object"&&typeof c.id=="string"}w.isThemeColor=y})(L||(t.ThemeColor=L={}));function i(w){return{id:w}}t.themeColorFromId=i;var W;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function c(s){const D=y.exec(s.id);if(!D)return c(E.Codicon.error);const[,v,A]=D,f=["codicon","codicon-"+v];return A&&f.push("codicon-modifier-"+A.substring(1)),f}w.asClassNameArray=c;function a(s){return c(s).join(" ")}w.asClassName=a;function d(s){return"."+c(s).join(".")}w.asCSSSelector=d;function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||L.isThemeColor(s.color))}w.isThemeIcon=I;const r=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function u(s){const D=r.exec(s);if(!D)return;const[,v]=D;return{id:v}}w.fromString=u;function e(s){return{id:s}}w.fromId=e;function l(s,D){let v=s.id;const A=v.lastIndexOf("~");return A!==-1&&(v=v.substring(0,A)),D&&(v=`${v}~${D}`),{id:v}}w.modify=l;function n(s){const D=s.id.lastIndexOf("~");if(D!==-1)return s.id.substring(D+1)}w.getModifier=n;function h(s,D){return s.id===D.id&&s.color?.id===D.color?.id}w.isEqual=h})(W||(t.ThemeIcon=W={}))}),define(ge[81],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[82],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(i,W){this.sender=i,this.onMessage=W}send(i){try{this.sender.send("vscode:message",i.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=E}),define(ge[48],me([8]),{}),define(ge[83],me([8]),{}),define(ge[84],me([8]),{}),define(ge[85],me([8]),{}),define(ge[86],me([1,0,84,85]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[87],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[97],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[98],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[99],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[100],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[101],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[102],me([12,10]),function(te,t){return te.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[103],me([12,10]),function(te,t){return te.create("vs/base/common/actions",t)}),define(ge[104],me([12,10]),function(te,t){return te.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,104]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let L=!1,i=!1,W=!1,w=!1,y=!1,c=!1,a=!1,d=!1,I=!1,r=!1,u,e=t.LANGUAGE_DEFAULT,l=t.LANGUAGE_DEFAULT,n,h;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?s=t.globals.vscode.process:typeof process<"u"&&(s=process);const D=typeof s?.versions?.electron=="string",v=D&&s?.type==="renderer";if(typeof navigator=="object"&&!v)h=navigator.userAgent,L=h.indexOf("Windows")>=0,i=h.indexOf("Macintosh")>=0,d=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=h.indexOf("Linux")>=0,r=h?.indexOf("Mobi")>=0,c=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||t.LANGUAGE_DEFAULT,e=u,l=navigator.language;else if(typeof s=="object"){L=s.platform==="win32",i=s.platform==="darwin",W=s.platform==="linux",w=W&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,a=D,I=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const N=s.env.VSCODE_NLS_CONFIG;if(N)try{const M=JSON.parse(N),H=M.availableLanguages["*"];u=M.locale,l=M.osLocale,e=H||t.LANGUAGE_DEFAULT,n=M._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var A;(function(N){N[N.Web=0]="Web",N[N.Mac=1]="Mac",N[N.Linux=2]="Linux",N[N.Windows=3]="Windows"})(A||(t.Platform=A={}));function f(N){switch(N){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=f;let p=0;i?p=1:L?p=3:W&&(p=2),t.isWindows=L,t.isMacintosh=i,t.isLinux=W,t.isLinuxSnap=w,t.isNative=y,t.isElectron=a,t.isWeb=c,t.isWebWorker=c&&typeof t.globals.importScripts=="function",t.isIOS=d,t.isMobile=r,t.isCI=I,t.platform=p,t.userAgent=h,t.language=e;var O;(function(N){function M(){return t.language}N.value=M;function H(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}N.isDefaultVariant=H;function Z(){return t.language==="en"}N.isDefault=Z})(O||(t.Language=O={})),t.locale=u,t.platformLocale=l,t.translationsConfigFile=n,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const N=[];t.globals.addEventListener("message",H=>{if(H.data&&H.data.vscodeScheduleAsyncWork)for(let Z=0,ne=N.length;Z<ne;Z++){const se=N[Z];if(se.id===H.data.vscodeScheduleAsyncWork){N.splice(Z,1),se.callback();return}}});let M=0;return H=>{const Z=++M;N.push({id:Z,callback:H}),t.globals.postMessage({vscodeScheduleAsyncWork:Z},"*")}}return N=>setTimeout(N)})();var k;(function(N){N[N.Windows=1]="Windows",N[N.Macintosh=2]="Macintosh",N[N.Linux=3]="Linux"})(k||(t.OperatingSystem=k={})),t.OS=i||d?2:L?1:3;let m=!0,g=!1;function b(){if(!g){g=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,m=new Uint16Array(N.buffer)[0]===(2<<8)+1}return m}t.isLittleEndian=b,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[105],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let L;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;L={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=L.cwd,t.env=L.env,t.platform=L.platform,t.arch=L.arch}),define(ge[22],me([1,0,105]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const L=65,i=97,W=90,w=122,y=46,c=47,a=92,d=58,I=63;class r extends Error{constructor(p,O,k){let m;typeof O=="string"&&O.indexOf("not ")===0?(m="must not be",O=O.replace(/^not /,"")):m="must be";const g=p.indexOf(".")!==-1?"property":"argument";let b=`The "${p}" ${g} ${m} of type ${O}`;b+=`. Received type ${typeof k}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function u(f,p){if(f===null||typeof f!="object")throw new r(p,"Object",f)}function e(f,p){if(typeof f!="string")throw new r(p,"string",f)}const l=E.platform==="win32";function n(f){return f===c||f===a}function h(f){return f===c}function s(f){return f>=L&&f<=W||f>=i&&f<=w}function D(f,p,O,k){let m="",g=0,b=-1,N=0,M=0;for(let H=0;H<=f.length;++H){if(H<f.length)M=f.charCodeAt(H);else{if(k(M))break;M=c}if(k(M)){if(!(b===H-1||N===1))if(N===2){if(m.length<2||g!==2||m.charCodeAt(m.length-1)!==y||m.charCodeAt(m.length-2)!==y){if(m.length>2){const Z=m.lastIndexOf(O);Z===-1?(m="",g=0):(m=m.slice(0,Z),g=m.length-1-m.lastIndexOf(O)),b=H,N=0;continue}else if(m.length!==0){m="",g=0,b=H,N=0;continue}}p&&(m+=m.length>0?`${O}..`:"..",g=2)}else m.length>0?m+=`${O}${f.slice(b+1,H)}`:m=f.slice(b+1,H),g=H-b-1;b=H,N=0}else M===y&&N!==-1?++N:N=-1}return m}function v(f,p){u(p,"pathObject");const O=p.dir||p.root,k=p.base||`${p.name||""}${p.ext||""}`;return O?O===p.root?`${O}${k}`:`${O}${f}${k}`:k}t.win32={resolve(...f){let p="",O="",k=!1;for(let m=f.length-1;m>=-1;m--){let g;if(m>=0){if(g=f[m],e(g,"path"),g.length===0)continue}else p.length===0?g=E.cwd():(g=E.env[`=${p}`]||E.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==p.toLowerCase()&&g.charCodeAt(2)===a)&&(g=`${p}\\`));const b=g.length;let N=0,M="",H=!1;const Z=g.charCodeAt(0);if(b===1)n(Z)&&(N=1,H=!0);else if(n(Z))if(H=!0,n(g.charCodeAt(1))){let ne=2,se=ne;for(;ne<b&&!n(g.charCodeAt(ne));)ne++;if(ne<b&&ne!==se){const he=g.slice(se,ne);for(se=ne;ne<b&&n(g.charCodeAt(ne));)ne++;if(ne<b&&ne!==se){for(se=ne;ne<b&&!n(g.charCodeAt(ne));)ne++;(ne===b||ne!==se)&&(M=`\\\\${he}\\${g.slice(se,ne)}`,N=ne)}}}else N=1;else s(Z)&&g.charCodeAt(1)===d&&(M=g.slice(0,2),N=2,b>2&&n(g.charCodeAt(2))&&(H=!0,N=3));if(M.length>0)if(p.length>0){if(M.toLowerCase()!==p.toLowerCase())continue}else p=M;if(k){if(p.length>0)break}else if(O=`${g.slice(N)}\\${O}`,k=H,H&&p.length>0)break}return O=D(O,!k,"\\",n),k?`${p}\\${O}`:`${p}${O}`||"."},normalize(f){e(f,"path");const p=f.length;if(p===0)return".";let O=0,k,m=!1;const g=f.charCodeAt(0);if(p===1)return h(g)?"\\":f;if(n(g))if(m=!0,n(f.charCodeAt(1))){let N=2,M=N;for(;N<p&&!n(f.charCodeAt(N));)N++;if(N<p&&N!==M){const H=f.slice(M,N);for(M=N;N<p&&n(f.charCodeAt(N));)N++;if(N<p&&N!==M){for(M=N;N<p&&!n(f.charCodeAt(N));)N++;if(N===p)return`\\\\${H}\\${f.slice(M)}\\`;N!==M&&(k=`\\\\${H}\\${f.slice(M,N)}`,O=N)}}}else O=1;else s(g)&&f.charCodeAt(1)===d&&(k=f.slice(0,2),O=2,p>2&&n(f.charCodeAt(2))&&(m=!0,O=3));let b=O<p?D(f.slice(O),!m,"\\",n):"";return b.length===0&&!m&&(b="."),b.length>0&&n(f.charCodeAt(p-1))&&(b+="\\"),k===void 0?m?`\\${b}`:b:m?`${k}\\${b}`:`${k}${b}`},isAbsolute(f){e(f,"path");const p=f.length;if(p===0)return!1;const O=f.charCodeAt(0);return n(O)||p>2&&s(O)&&f.charCodeAt(1)===d&&n(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let p,O;for(let g=0;g<f.length;++g){const b=f[g];e(b,"path"),b.length>0&&(p===void 0?p=O=b:p+=`\\${b}`)}if(p===void 0)return".";let k=!0,m=0;if(typeof O=="string"&&n(O.charCodeAt(0))){++m;const g=O.length;g>1&&n(O.charCodeAt(1))&&(++m,g>2&&(n(O.charCodeAt(2))?++m:k=!1))}if(k){for(;m<p.length&&n(p.charCodeAt(m));)m++;m>=2&&(p=`\\${p.slice(m)}`)}return t.win32.normalize(p)},relative(f,p){if(e(f,"from"),e(p,"to"),f===p)return"";const O=t.win32.resolve(f),k=t.win32.resolve(p);if(O===k||(f=O.toLowerCase(),p=k.toLowerCase(),f===p))return"";let m=0;for(;m<f.length&&f.charCodeAt(m)===a;)m++;let g=f.length;for(;g-1>m&&f.charCodeAt(g-1)===a;)g--;const b=g-m;let N=0;for(;N<p.length&&p.charCodeAt(N)===a;)N++;let M=p.length;for(;M-1>N&&p.charCodeAt(M-1)===a;)M--;const H=M-N,Z=b<H?b:H;let ne=-1,se=0;for(;se<Z;se++){const ue=f.charCodeAt(m+se);if(ue!==p.charCodeAt(N+se))break;ue===a&&(ne=se)}if(se!==Z){if(ne===-1)return k}else{if(H>Z){if(p.charCodeAt(N+se)===a)return k.slice(N+se+1);if(se===2)return k.slice(N+se)}b>Z&&(f.charCodeAt(m+se)===a?ne=se:se===2&&(ne=3)),ne===-1&&(ne=0)}let he="";for(se=m+ne+1;se<=g;++se)(se===g||f.charCodeAt(se)===a)&&(he+=he.length===0?"..":"\\..");return N+=ne,he.length>0?`${he}${k.slice(N,M)}`:(k.charCodeAt(N)===a&&++N,k.slice(N,M))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const p=t.win32.resolve(f);if(p.length<=2)return f;if(p.charCodeAt(0)===a){if(p.charCodeAt(1)===a){const O=p.charCodeAt(2);if(O!==I&&O!==y)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(s(p.charCodeAt(0))&&p.charCodeAt(1)===d&&p.charCodeAt(2)===a)return`\\\\?\\${p}`;return f},dirname(f){e(f,"path");const p=f.length;if(p===0)return".";let O=-1,k=0;const m=f.charCodeAt(0);if(p===1)return n(m)?f:".";if(n(m)){if(O=k=1,n(f.charCodeAt(1))){let N=2,M=N;for(;N<p&&!n(f.charCodeAt(N));)N++;if(N<p&&N!==M){for(M=N;N<p&&n(f.charCodeAt(N));)N++;if(N<p&&N!==M){for(M=N;N<p&&!n(f.charCodeAt(N));)N++;if(N===p)return f;N!==M&&(O=k=N+1)}}}}else s(m)&&f.charCodeAt(1)===d&&(O=p>2&&n(f.charCodeAt(2))?3:2,k=O);let g=-1,b=!0;for(let N=p-1;N>=k;--N)if(n(f.charCodeAt(N))){if(!b){g=N;break}}else b=!1;if(g===-1){if(O===-1)return".";g=O}return f.slice(0,g)},basename(f,p){p!==void 0&&e(p,"ext"),e(f,"path");let O=0,k=-1,m=!0,g;if(f.length>=2&&s(f.charCodeAt(0))&&f.charCodeAt(1)===d&&(O=2),p!==void 0&&p.length>0&&p.length<=f.length){if(p===f)return"";let b=p.length-1,N=-1;for(g=f.length-1;g>=O;--g){const M=f.charCodeAt(g);if(n(M)){if(!m){O=g+1;break}}else N===-1&&(m=!1,N=g+1),b>=0&&(M===p.charCodeAt(b)?--b===-1&&(k=g):(b=-1,k=N))}return O===k?k=N:k===-1&&(k=f.length),f.slice(O,k)}for(g=f.length-1;g>=O;--g)if(n(f.charCodeAt(g))){if(!m){O=g+1;break}}else k===-1&&(m=!1,k=g+1);return k===-1?"":f.slice(O,k)},extname(f){e(f,"path");let p=0,O=-1,k=0,m=-1,g=!0,b=0;f.length>=2&&f.charCodeAt(1)===d&&s(f.charCodeAt(0))&&(p=k=2);for(let N=f.length-1;N>=p;--N){const M=f.charCodeAt(N);if(n(M)){if(!g){k=N+1;break}continue}m===-1&&(g=!1,m=N+1),M===y?O===-1?O=N:b!==1&&(b=1):O!==-1&&(b=-1)}return O===-1||m===-1||b===0||b===1&&O===m-1&&O===k+1?"":f.slice(O,m)},format:v.bind(null,"\\"),parse(f){e(f,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return p;const O=f.length;let k=0,m=f.charCodeAt(0);if(O===1)return n(m)?(p.root=p.dir=f,p):(p.base=p.name=f,p);if(n(m)){if(k=1,n(f.charCodeAt(1))){let ne=2,se=ne;for(;ne<O&&!n(f.charCodeAt(ne));)ne++;if(ne<O&&ne!==se){for(se=ne;ne<O&&n(f.charCodeAt(ne));)ne++;if(ne<O&&ne!==se){for(se=ne;ne<O&&!n(f.charCodeAt(ne));)ne++;ne===O?k=ne:ne!==se&&(k=ne+1)}}}}else if(s(m)&&f.charCodeAt(1)===d){if(O<=2)return p.root=p.dir=f,p;if(k=2,n(f.charCodeAt(2))){if(O===3)return p.root=p.dir=f,p;k=3}}k>0&&(p.root=f.slice(0,k));let g=-1,b=k,N=-1,M=!0,H=f.length-1,Z=0;for(;H>=k;--H){if(m=f.charCodeAt(H),n(m)){if(!M){b=H+1;break}continue}N===-1&&(M=!1,N=H+1),m===y?g===-1?g=H:Z!==1&&(Z=1):g!==-1&&(Z=-1)}return N!==-1&&(g===-1||Z===0||Z===1&&g===N-1&&g===b+1?p.base=p.name=f.slice(b,N):(p.name=f.slice(b,g),p.base=f.slice(b,N),p.ext=f.slice(g,N))),b>0&&b!==k?p.dir=f.slice(0,b-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null};const A=(()=>{if(l){const f=/\\/g;return()=>{const p=E.cwd().replace(f,"/");return p.slice(p.indexOf("/"))}}return()=>E.cwd()})();t.posix={resolve(...f){let p="",O=!1;for(let k=f.length-1;k>=-1&&!O;k--){const m=k>=0?f[k]:A();e(m,"path"),m.length!==0&&(p=`${m}/${p}`,O=m.charCodeAt(0)===c)}return p=D(p,!O,"/",h),O?`/${p}`:p.length>0?p:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const p=f.charCodeAt(0)===c,O=f.charCodeAt(f.length-1)===c;return f=D(f,!p,"/",h),f.length===0?p?"/":O?"./":".":(O&&(f+="/"),p?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===c},join(...f){if(f.length===0)return".";let p;for(let O=0;O<f.length;++O){const k=f[O];e(k,"path"),k.length>0&&(p===void 0?p=k:p+=`/${k}`)}return p===void 0?".":t.posix.normalize(p)},relative(f,p){if(e(f,"from"),e(p,"to"),f===p||(f=t.posix.resolve(f),p=t.posix.resolve(p),f===p))return"";const O=1,k=f.length,m=k-O,g=1,b=p.length-g,N=m<b?m:b;let M=-1,H=0;for(;H<N;H++){const ne=f.charCodeAt(O+H);if(ne!==p.charCodeAt(g+H))break;ne===c&&(M=H)}if(H===N)if(b>N){if(p.charCodeAt(g+H)===c)return p.slice(g+H+1);if(H===0)return p.slice(g+H)}else m>N&&(f.charCodeAt(O+H)===c?M=H:H===0&&(M=0));let Z="";for(H=O+M+1;H<=k;++H)(H===k||f.charCodeAt(H)===c)&&(Z+=Z.length===0?"..":"/..");return`${Z}${p.slice(g+M)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const p=f.charCodeAt(0)===c;let O=-1,k=!0;for(let m=f.length-1;m>=1;--m)if(f.charCodeAt(m)===c){if(!k){O=m;break}}else k=!1;return O===-1?p?"/":".":p&&O===1?"//":f.slice(0,O)},basename(f,p){p!==void 0&&e(p,"ext"),e(f,"path");let O=0,k=-1,m=!0,g;if(p!==void 0&&p.length>0&&p.length<=f.length){if(p===f)return"";let b=p.length-1,N=-1;for(g=f.length-1;g>=0;--g){const M=f.charCodeAt(g);if(M===c){if(!m){O=g+1;break}}else N===-1&&(m=!1,N=g+1),b>=0&&(M===p.charCodeAt(b)?--b===-1&&(k=g):(b=-1,k=N))}return O===k?k=N:k===-1&&(k=f.length),f.slice(O,k)}for(g=f.length-1;g>=0;--g)if(f.charCodeAt(g)===c){if(!m){O=g+1;break}}else k===-1&&(m=!1,k=g+1);return k===-1?"":f.slice(O,k)},extname(f){e(f,"path");let p=-1,O=0,k=-1,m=!0,g=0;for(let b=f.length-1;b>=0;--b){const N=f.charCodeAt(b);if(N===c){if(!m){O=b+1;break}continue}k===-1&&(m=!1,k=b+1),N===y?p===-1?p=b:g!==1&&(g=1):p!==-1&&(g=-1)}return p===-1||k===-1||g===0||g===1&&p===k-1&&p===O+1?"":f.slice(p,k)},format:v.bind(null,"/"),parse(f){e(f,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return p;const O=f.charCodeAt(0)===c;let k;O?(p.root="/",k=1):k=0;let m=-1,g=0,b=-1,N=!0,M=f.length-1,H=0;for(;M>=k;--M){const Z=f.charCodeAt(M);if(Z===c){if(!N){g=M+1;break}continue}b===-1&&(N=!1,b=M+1),Z===y?m===-1?m=M:H!==1&&(H=1):m!==-1&&(H=-1)}if(b!==-1){const Z=g===0&&O?1:g;m===-1||H===0||H===1&&m===b-1&&m===g+1?p.base=p.name=f.slice(Z,b):(p.name=f.slice(Z,m),p.base=f.slice(Z,b),p.ext=f.slice(m,b))}return g>0?p.dir=f.slice(0,g-1):O&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=l?t.win32.normalize:t.posix.normalize,t.isAbsolute=l?t.win32.isAbsolute:t.posix.isAbsolute,t.join=l?t.win32.join:t.posix.join,t.resolve=l?t.win32.resolve:t.posix.resolve,t.relative=l?t.win32.relative:t.posix.relative,t.dirname=l?t.win32.dirname:t.posix.dirname,t.basename=l?t.win32.basename:t.posix.basename,t.extname=l?t.win32.extname:t.posix.extname,t.format=l?t.win32.format:t.posix.format,t.parse=l?t.win32.parse:t.posix.parse,t.toNamespacedPath=l?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=l?t.win32.sep:t.posix.sep,t.delimiter=l?t.win32.delimiter:t.posix.delimiter}),define(ge[106],me([1,0,22]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(d){const I=(0,E.extname)(d),r=L[I.toLowerCase()];return r!==void 0?r:w(d)}t.getMediaOrTextMime=W;function w(d){const I=(0,E.extname)(d);return i[I.toLowerCase()]}t.getMediaMime=w;function y(d){for(const I in i)if(i[I]===d)return I}t.getExtensionForMimeType=y;const c=/^(.+)\/(.+?)(;.+)?$/;function a(d,I){const r=c.exec(d);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:I?void 0:d}t.normalizeMimeType=a}),define(ge[107],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const L=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(w=!0){return new i(w)}constructor(w){this._highResolution=L&&w,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}t.StopWatch=i}),define(ge[3],me([1,0,7,41,2,43,107]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const y=!1,c=!1;var a;(function(g){g.None=()=>i.Disposable.None;function b($){if(c){const{onDidAddListener:Y}=$,C=e.create();let F=0;$.onDidAddListener=()=>{++F===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),C.print()),Y?.()}}}function N($,Y){return oe($,()=>{},0,void 0,!0,void 0,Y)}g.defer=N;function M($){return(Y,C=null,F)=>{let R=!1,S;return S=$(x=>{if(!R)return S?S.dispose():R=!0,Y.call(C,x)},null,F),R&&S.dispose(),S}}g.once=M;function H($,Y,C){return le((F,R=null,S)=>$(x=>F.call(R,Y(x)),null,S),C)}g.map=H;function Z($,Y,C){return le((F,R=null,S)=>$(x=>{Y(x),F.call(R,x)},null,S),C)}g.forEach=Z;function ne($,Y,C){return le((F,R=null,S)=>$(x=>Y(x)&&F.call(R,x),null,S),C)}g.filter=ne;function se($){return $}g.signal=se;function he(...$){return(Y,C=null,F)=>(0,i.combinedDisposable)(...$.map(R=>R(S=>Y.call(C,S),null,F)))}g.any=he;function ue($,Y,C,F){let R=C;return H($,S=>(R=Y(R,S),R),F)}g.reduce=ue;function le($,Y){let C;const F={onWillAddFirstListener(){C=$(R.fire,R)},onDidRemoveLastListener(){C?.dispose()}};Y||b(F);const R=new n(F);return Y?.add(R),R.event}function oe($,Y,C=100,F=!1,R=!1,S,x){let B,P,V,G=0,ee;const re={leakWarningThreshold:S,onWillAddFirstListener(){B=$(De=>{G++,P=Y(P,De),F&&!V&&(be.fire(P),P=void 0),ee=()=>{const Ie=P;P=void 0,V=void 0,(!F||G>1)&&be.fire(Ie),G=0},typeof C=="number"?(clearTimeout(V),V=setTimeout(ee,C)):V===void 0&&(V=0,queueMicrotask(ee))})},onWillRemoveListener(){R&&G>0&&ee?.()},onDidRemoveLastListener(){ee=void 0,B.dispose()}};x||b(re);const be=new n(re);return x?.add(be),be.event}g.debounce=oe;function ye($,Y=0,C){return g.debounce($,(F,R)=>F?(F.push(R),F):[R],Y,void 0,!0,void 0,C)}g.accumulate=ye;function Te($,Y=(F,R)=>F===R,C){let F=!0,R;return ne($,S=>{const x=F||!Y(S,R);return F=!1,R=S,x},C)}g.latch=Te;function Oe($,Y,C){return[g.filter($,Y,C),g.filter($,F=>!Y(F),C)]}g.split=Oe;function ke($,Y=!1,C=[]){let F=C.slice(),R=$(B=>{F?F.push(B):x.fire(B)});const S=()=>{F?.forEach(B=>x.fire(B)),F=null},x=new n({onWillAddFirstListener(){R||(R=$(B=>x.fire(B)))},onDidAddFirstListener(){F&&(Y?setTimeout(S):S())},onDidRemoveLastListener(){R&&R.dispose(),R=null}});return x.event}g.buffer=ke;class fe{constructor(Y){this.event=Y,this.disposables=new i.DisposableStore}map(Y){return new fe(H(this.event,Y,this.disposables))}forEach(Y){return new fe(Z(this.event,Y,this.disposables))}filter(Y){return new fe(ne(this.event,Y,this.disposables))}reduce(Y,C){return new fe(ue(this.event,Y,C,this.disposables))}latch(){return new fe(Te(this.event,void 0,this.disposables))}debounce(Y,C=100,F=!1,R=!1,S){return new fe(oe(this.event,Y,C,F,R,S,this.disposables))}on(Y,C,F){return this.event(Y,C,F)}once(Y,C,F){return M(this.event)(Y,C,F)}dispose(){this.disposables.dispose()}}function U($){return new fe($)}g.chain=U;function ie($,Y,C=F=>F){const F=(...B)=>x.fire(C(...B)),R=()=>$.on(Y,F),S=()=>$.removeListener(Y,F),x=new n({onWillAddFirstListener:R,onDidRemoveLastListener:S});return x.event}g.fromNodeEventEmitter=ie;function q($,Y,C=F=>F){const F=(...B)=>x.fire(C(...B)),R=()=>$.addEventListener(Y,F),S=()=>$.removeEventListener(Y,F),x=new n({onWillAddFirstListener:R,onDidRemoveLastListener:S});return x.event}g.fromDOMEventEmitter=q;function K($){return new Promise(Y=>M($)(Y))}g.toPromise=K;function _($,Y){return Y(void 0),$(C=>Y(C))}g.runAndSubscribe=_;function j($,Y){let C=null;function F(S){C?.dispose(),C=new i.DisposableStore,Y(S,C)}F(void 0);const R=$(S=>F(S));return(0,i.toDisposable)(()=>{R.dispose(),C?.dispose()})}g.runAndSubscribeWithStore=j;class z{constructor(Y,C){this._observable=Y,this._counter=0,this._hasChanged=!1;const F={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};C||b(F),this.emitter=new n(F),C&&C.add(this.emitter)}beginUpdate(Y){this._counter++}handlePossibleChange(Y){}handleChange(Y,C){this._hasChanged=!0}endUpdate(Y){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function o($,Y){return new z($,Y).emitter.event}g.fromObservable=o;function T($){return Y=>{let C=0,F=!1;const R={beginUpdate(){C++},endUpdate(){C--,C===0&&($.reportChanges(),F&&(F=!1,Y()))},handlePossibleChange(){},handleChange(){F=!0}};return $.addObserver(R),{dispose(){$.removeObserver(R)}}}}g.fromObservableLight=T})(a||(t.Event=a={}));class d{constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${d._idPool++}`,d.all.add(this)}start(b){this._stopWatch=new w.StopWatch(!0),this.listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=d,d.all=new Set,d._idPool=0;let I=-1;function r(g){const b=I;return I=g,{dispose(){I=b}}}t.setGlobalLeakWarningThreshold=r;class u{constructor(b,N=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=N,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(b,N){const M=this.threshold;if(M<=0||N<M)return;this._stacks||(this._stacks=new Map);const H=this._stacks.get(b.value)||0;if(this._stacks.set(b.value,H+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let Z,ne=0;for(const[se,he]of this._stacks)(!Z||ne<he)&&(Z=se,ne=he);console.warn(`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${ne}):`),console.warn(Z)}return()=>{const Z=this._stacks.get(b.value)||0;this._stacks.set(b.value,Z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class l{constructor(b,N,M){this.callback=b,this.callbackThis=N,this.stack=M,this.subscription=new i.SafeDisposable}invoke(b){this.callback.call(this.callbackThis,b)}}class n{constructor(b){this._disposed=!1,this._options=b,this._leakageMon=I>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const b=Array.from(this._listeners);queueMicrotask(()=>{for(const N of b)N.subscription.isset()&&(N.subscription.unset(),N.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(b,N,M)=>{if(this._listeners||(this._listeners=new W.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const H=this._listeners.isEmpty();H&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let Z,ne;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(ne=e.create(),Z=this._leakageMon.check(ne,this._listeners.size+1)),y&&(ne=ne??e.create());const se=new l(b,N,ne),he=this._listeners.push(se);H&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,b,N);const ue=se.subscription.set(()=>{Z?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),he(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return M instanceof i.DisposableStore?M.add(ue):Array.isArray(M)&&M.push(ue),ue}),this._event}fire(b){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s(this._options?.onListenerError));for(const N of this._listeners)this._deliveryQueue.push(this,N,b);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=n;class h{constructor(b=E.onUnexpectedError){this._onListenerError=b,this._queue=new W.LinkedList}get size(){return this._queue.size}push(b,N,M){this._queue.push(new D(b,N,M))}clear(b){const N=new W.LinkedList;for(const M of this._queue)M.emitter!==b&&N.push(M);this._queue=N}deliver(){for(;this._queue.size>0;){const b=this._queue.shift();try{b.listener.invoke(b.event)}catch(N){this._onListenerError(N)}}}}t.EventDeliveryQueue=h;class s extends h{clear(b){this._queue.clear()}}class D{constructor(b,N,M){this.emitter=b,this.listener=N,this.event=M}}class v extends n{async fireAsync(b,N,M){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new W.LinkedList);for(const H of this._listeners)this._asyncDeliveryQueue.push([H,b]);for(;this._asyncDeliveryQueue.size>0&&!N.isCancellationRequested;){const[H,Z]=this._asyncDeliveryQueue.shift(),ne=[],se={...Z,token:N,waitUntil:he=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");M&&(he=M(he,H.callback)),ne.push(he)}};try{H.invoke(se)}catch(he){(0,E.onUnexpectedError)(he);continue}Object.freeze(ne),await Promise.allSettled(ne).then(he=>{for(const ue of he)ue.status==="rejected"&&(0,E.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=v;class A extends n{get isPaused(){return this._isPaused!==0}constructor(b){super(b),this._isPaused=0,this._eventQueue=new W.LinkedList,this._mergeFn=b?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}t.PauseableEmitter=A;class f extends A{constructor(b){super(b),this._delay=b.delay??100}fire(b){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(b)}}t.DebounceEmitter=f;class p extends n{constructor(b){super(b),this._queuedEvents=[],this._mergeFn=b?.merge}fire(b){this.hasListeners()&&(this._queuedEvents.push(b),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(N=>super.fire(N)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=p;class O{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const N={event:b,listener:null};this.events.push(N),this.hasListeners&&this.hook(N);const M=()=>{this.hasListeners&&this.unhook(N);const H=this.events.indexOf(N);this.events.splice(H,1)};return(0,i.toDisposable)((0,L.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(N=>this.emitter.fire(N))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=O;class k{constructor(){this.buffers=[]}wrapEvent(b){return(N,M,H)=>b(Z=>{const ne=this.buffers[this.buffers.length-1];ne?ne.push(()=>N.call(M,Z)):N.call(M,Z)},void 0,H)}bufferEvents(b){const N=[];this.buffers.push(N);const M=b();return this.buffers.pop(),N.forEach(H=>H()),M}}t.EventBufferer=k;class m{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=i.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=m}),define(ge[18],me([1,0,3,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new E.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(v,A){this._zoomLevel!==v&&(this._zoomLevel=v)}getZoomFactor(){return this._zoomFactor}setZoomFactor(v){this._zoomFactor=v}setFullscreen(v){this._fullscreen!==v&&(this._fullscreen=v,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}i.INSTANCE=new i;class W extends L.Disposable{constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(v){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),v&&this._onDidChange.fire()}}class w extends L.Disposable{get value(){return this._value}constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const v=this._register(new W);this._register(v.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}_getPixelRatio(){const v=document.createElement("canvas").getContext("2d"),A=window.devicePixelRatio||1,f=v.webkitBackingStorePixelRatio||v.mozBackingStorePixelRatio||v.msBackingStorePixelRatio||v.oBackingStorePixelRatio||v.backingStorePixelRatio||1;return A/f}}class y{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,L.markAsSingleton)(new w)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function c(D,v){typeof D=="string"&&(D=window.matchMedia(D)),D.addEventListener("change",v)}t.addMatchMediaChangeListener=c,t.PixelRatio=new y;function a(D,v){i.INSTANCE.setZoomLevel(D,v)}t.setZoomLevel=a;function d(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=d;function I(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=I;function r(D){i.INSTANCE.setZoomFactor(D)}t.setZoomFactor=r;function u(D){i.INSTANCE.setFullscreen(D)}t.setFullscreen=u;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.isFirefox=l.indexOf("Firefox")>=0,t.isWebKit=l.indexOf("AppleWebKit")>=0,t.isChrome=l.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&l.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=l.indexOf("Electron/")>=0,t.isAndroid=l.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const D=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),v=window.matchMedia("(display-mode: fullscreen)");n=D.matches,c(D,({matches:A})=>{n&&v.matches||(n=A)})}function h(){return n}t.isStandalone=h;function s(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=s}),define(ge[108],me([1,0,18,5]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(W){W[W.Always=0]="Always",W[W.FullScreen=1]="FullScreen",W[W.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.BrowserFeatures={clipboard:{writeText:L.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:L.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>L.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[20],me([1,0,3]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class L{get event(){return this.emitter.event}constructor(W,w,y){const c=a=>this.emitter.fire(a);this.emitter=new E.Emitter({onWillAddFirstListener:()=>W.addEventListener(w,c,y),onDidRemoveLastListener:()=>W.removeEventListener(w,c,y)})}dispose(){this.emitter.dispose()}}t.DomEmitter=L}),define(ge[14],me([1,0,18,42,74,5]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function w(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return L.KeyCodeUtils.fromString(n)}const l=e.keyCode;if(l===3)return 7;if(E.isFirefox)switch(l){case 59:return 85;case 60:if(W.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.isMacintosh)return 57;break}else if(E.isWebKit){if(W.isMacintosh&&l===93)return 57;if(!W.isMacintosh&&l===92)return 57}return L.EVENT_KEY_CODE_MAP[l]||0}const y=W.isMacintosh?256:2048,c=512,a=1024,d=W.isMacintosh?2048:256;function I(e){const l=[];return e.ctrlKey&&l.push("ctrl"),e.shiftKey&&l.push("shift"),e.altKey&&l.push("alt"),e.metaKey&&l.push("meta"),`modifiers: [${l.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=I;function r(e){const l=[];return e.ctrlKey&&l.push("ctrl"),e.shiftKey&&l.push("shift"),e.altKey&&l.push("alt"),e.metaKey&&l.push("meta"),`modifiers: [${l.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${L.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class u{constructor(l){this._standardKeyboardEventBrand=!0;const n=l;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=w(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(l){return this._asKeybinding===l}_computeKeybinding(){let l=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(l=this.keyCode);let n=0;return this.ctrlKey&&(n|=y),this.altKey&&(n|=c),this.shiftKey&&(n|=a),this.metaKey&&(n|=d),n|=l,n}_computeKeyCodeChord(){let l=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(l=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,l)}}t.StandardKeyboardEvent=u}),define(ge[21],me([1,0,18,66,5]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class W{constructor(a){this.timestamp=Date.now(),this.browserEvent=a,this.leftButton=a.button===0,this.middleButton=a.button===1,this.rightButton=a.button===2,this.buttons=a.buttons,this.target=a.target,this.detail=a.detail||1,a.type==="dblclick"&&(this.detail=2),this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,typeof a.pageX=="number"?(this.posx=a.pageX,this.posy=a.pageY):(this.posx=a.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=a.clientY+document.body.scrollTop+document.documentElement.scrollTop);const d=L.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,a.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=W;class w extends W{constructor(a){super(a),this.dataTransfer=a.dataTransfer}}t.DragMouseEvent=w;class y{constructor(a,d=0,I=0){if(this.browserEvent=a||null,this.target=a?a.target||a.targetNode||a.srcElement:null,this.deltaY=I,this.deltaX=d,a){const r=a,u=a;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof u.VERTICAL_AXIS<"u"&&u.axis===u.VERTICAL_AXIS)this.deltaY=-u.detail/3;else if(a.type==="wheel"){const e=a;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaY=-a.deltaY/3:this.deltaY=-a.deltaY:this.deltaY=-a.deltaY/40}if(typeof r.wheelDeltaX<"u")E.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof u.HORIZONTAL_AXIS<"u"&&u.axis===u.HORIZONTAL_AXIS)this.deltaX=-a.detail/3;else if(a.type==="wheel"){const e=a;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaX=-a.deltaX/3:this.deltaX=-a.deltaX:this.deltaX=-a.deltaX/40}this.deltaY===0&&this.deltaX===0&&a.wheelDelta&&(this.deltaY=a.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=y}),define(ge[32],me([1,0,3,2,103]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class W extends L.Disposable{constructor(r,u="",e="",l=!0,n){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=r,this._label=u,this._cssClass=e,this._enabled=l,this._actionCallback=n}get id(){return this._id}get label(){return this._label}set label(r){this._setLabel(r)}_setLabel(r){this._label!==r&&(this._label=r,this._onDidChange.fire({label:r}))}get tooltip(){return this._tooltip||""}set tooltip(r){this._setTooltip(r)}_setTooltip(r){this._tooltip!==r&&(this._tooltip=r,this._onDidChange.fire({tooltip:r}))}get class(){return this._cssClass}set class(r){this._setClass(r)}_setClass(r){this._cssClass!==r&&(this._cssClass=r,this._onDidChange.fire({class:r}))}get enabled(){return this._enabled}set enabled(r){this._setEnabled(r)}_setEnabled(r){this._enabled!==r&&(this._enabled=r,this._onDidChange.fire({enabled:r}))}get checked(){return this._checked}set checked(r){this._setChecked(r)}_setChecked(r){this._checked!==r&&(this._checked=r,this._onDidChange.fire({checked:r}))}async run(r,u){this._actionCallback&&await this._actionCallback(r)}}t.Action=W;class w extends L.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new E.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new E.Emitter),this.onDidRun=this._onDidRun.event}async run(r,u){if(!r.enabled)return;this._onWillRun.fire({action:r});let e;try{await this.runAction(r,u)}catch(l){e=l}this._onDidRun.fire({action:r,error:e})}async runAction(r,u){await r.run(u)}}t.ActionRunner=w;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let u=[];for(const e of r)e.length&&(u.length?u=[...u,new y,...e]:u=e);return u}async run(){}}t.Separator=y,y.ID="vs.actions.separator";class c{get actions(){return this._actions}constructor(r,u,e,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=u,this.class=l,this._actions=e}async run(){}}t.SubmenuAction=c;class a extends W{constructor(){super(a.ID,i.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=a,a.ID="vs.actions.empty";function d(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}t.toAction=d}),define(ge[27],me([1,0,3]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const L=Object.freeze(function(y,c){const a=setTimeout(y.bind(c),0);return{dispose(){clearTimeout(a)}}});var i;(function(y){function c(a){return a===y.None||a===y.Cancelled||a instanceof W?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}y.isCancellationToken=c,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(i||(t.CancellationToken=i={}));class W{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class w{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new W),this._token}cancel(){this._token?this._token instanceof W&&this._token.cancel():this._token=i.Cancelled}dispose(c=!1){c&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof W&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=w}),define(ge[109],me([1,0,27]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class L{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new E.CancellationTokenSource,c=this.task(y.token);return this.result={promise:c,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}t.Cache=L;class i{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const c=JSON.stringify(y);return this.lastArgKey!==c&&(this.lastArgKey=c,this.lastCache=this.fn(y)),this.lastCache}}t.LRUCachedFunction=i;class W{get cachedValues(){return this._map}constructor(y){this.fn=y,this._map=new Map}get(y){if(this._map.has(y))return this._map.get(y);const c=this.fn(y);return this._map.set(y,c),c}}t.CachedFunction=W}),define(ge[49],me([1,0,3,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(u){u[u.Auto=1]="Auto",u[u.Hidden=2]="Hidden",u[u.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class W{constructor(e,l,n,h,s,D,v){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(l=l|0,n=n|0,h=h|0,s=s|0,D=D|0,v=v|0),this.rawScrollLeft=h,this.rawScrollTop=v,l<0&&(l=0),h+l>n&&(h=n-l),h<0&&(h=0),s<0&&(s=0),v+s>D&&(v=D-s),v<0&&(v=0),this.width=l,this.scrollWidth=n,this.scrollLeft=h,this.height=s,this.scrollHeight=D,this.scrollTop=v}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,l){return new W(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,l?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,l?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,l){const n=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,D=this.height!==e.height,v=this.scrollHeight!==e.scrollHeight,A=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:l,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:h,scrollLeftChanged:s,heightChanged:D,scrollHeightChanged:v,scrollTopChanged:A}}}t.ScrollState=W;class w extends L.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new E.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new W(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,l){const n=this._state.withScrollDimensions(e,l);this._setState(n,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const l=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(l,!1)}setScrollPositionSmooth(e,l){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const n=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===n.scrollLeft&&this._smoothScrolling.to.scrollTop===n.scrollTop)return;let h;l?h=new d(this._smoothScrolling.from,n,this._smoothScrolling.startTime,this._smoothScrolling.duration):h=this._smoothScrolling.combine(this._state,n,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=h}else{const n=this._state.withScrollPosition(e);this._smoothScrolling=d.start(this._state,n,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),l=this._state.withScrollPosition(e);if(this._setState(l,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,l){const n=this._state;n.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(n,l)))}}t.Scrollable=w;class y{constructor(e,l,n){this.scrollLeft=e,this.scrollTop=l,this.isDone=n}}t.SmoothScrollingUpdate=y;function c(u,e){const l=e-u;return function(n){return u+l*r(n)}}function a(u,e,l){return function(n){return n<l?u(n/l):e((n-l)/(1-l))}}class d{constructor(e,l,n,h){this.from=e,this.to=l,this.duration=h,this.startTime=n,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,l,n){if(Math.abs(e-l)>2.5*n){let s,D;return e<l?(s=e+.75*n,D=l-.75*n):(s=e-.75*n,D=l+.75*n),a(c(e,s),c(D,l),.33)}return c(e,l)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const l=(e-this.startTime)/this.duration;if(l<1){const n=this.scrollLeft(l),h=this.scrollTop(l);return new y(n,h,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,l,n){return d.start(e,l,n)}static start(e,l,n){n=n+10;const h=Date.now()-10;return new d(e,l,h,n)}}t.SmoothScrollingOperation=d;function I(u){return Math.pow(u,3)}function r(u){return 1-I(1-u)}}),define(ge[11],me([1,0,109,30]),function(te,t,E,L){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function W(X){return!X||typeof X!="string"?!0:X.trim().length===0}t.isFalsyOrWhitespace=W;const w=/{(\d+)}/g;function y(X,...ae){return ae.length===0?X:X.replace(w,function(pe,we){const _e=parseInt(we,10);return isNaN(_e)||_e<0||_e>=ae.length?pe:ae[_e]})}t.format=y;const c=/{([^}]+)}/g;function a(X,ae){return X.replace(c,(pe,we)=>ae[we]??pe)}t.format2=a;function d(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.escape=d;function I(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=I;function r(X,ae){let pe=0;const we=ae.charCodeAt(0);for(let _e=X.length-1;_e>=0;_e--)X.charCodeAt(_e)===we&&pe++;return pe}t.count=r;function u(X,ae,pe="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${pe}`}t.truncate=u;function e(X,ae=" "){const pe=l(X,ae);return n(pe,ae)}t.trim=e;function l(X,ae){if(!X||!ae)return X;const pe=ae.length;if(pe===0||X.length===0)return X;let we=0;for(;X.indexOf(ae,we)===we;)we=we+pe;return X.substring(we)}t.ltrim=l;function n(X,ae){if(!X||!ae)return X;const pe=ae.length,we=X.length;if(pe===0||we===0)return X;let _e=we,Re=-1;for(;Re=X.lastIndexOf(ae,_e-1),!(Re===-1||Re+pe!==_e);){if(Re===0)return"";_e=Re}return X.substring(0,_e)}t.rtrim=n;function h(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=h;function s(X){return X.replace(/\*/g,"")}t.stripWildcards=s;function D(X,ae,pe={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=I(X)),pe.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let we="";return pe.global&&(we+="g"),pe.matchCase||(we+="i"),pe.multiline&&(we+="m"),pe.unicode&&(we+="u"),new RegExp(X,we)}t.createRegExp=D;function v(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}t.regExpLeadsToEndlessLoop=v;function A(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=A;function f(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}t.regExpFlags=f;function p(X){return X.split(/\r\n|\r|\n/)}t.splitLines=p;function O(X){for(let ae=0,pe=X.length;ae<pe;ae++){const we=X.charCodeAt(ae);if(we!==32&&we!==9)return ae}return-1}t.firstNonWhitespaceIndex=O;function k(X,ae=0,pe=X.length){for(let we=ae;we<pe;we++){const _e=X.charCodeAt(we);if(_e!==32&&_e!==9)return X.substring(ae,we)}return X.substring(ae,pe)}t.getLeadingWhitespace=k;function m(X,ae=X.length-1){for(let pe=ae;pe>=0;pe--){const we=X.charCodeAt(pe);if(we!==32&&we!==9)return pe}return-1}t.lastNonWhitespaceIndex=m;function g(X,ae,pe){const we=[];let _e=0;for(const Re of X.matchAll(ae)){if(we.push(X.slice(_e,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");_e=Re.index+Re[0].length,we.push(pe(Re[0],...Re.slice(1),Re.index,X,Re.groups))}return we.push(X.slice(_e)),Promise.all(we).then(Re=>Re.join(""))}t.replaceAsync=g;function b(X,ae){return X<ae?-1:X>ae?1:0}t.compare=b;function N(X,ae,pe=0,we=X.length,_e=0,Re=ae.length){for(;pe<we&&_e<Re;pe++,_e++){const et=X.charCodeAt(pe),Ae=ae.charCodeAt(_e);if(et<Ae)return-1;if(et>Ae)return 1}const Ue=we-pe,Ge=Re-_e;return Ue<Ge?-1:Ue>Ge?1:0}t.compareSubstring=N;function M(X,ae){return H(X,ae,0,X.length,0,ae.length)}t.compareIgnoreCase=M;function H(X,ae,pe=0,we=X.length,_e=0,Re=ae.length){for(;pe<we&&_e<Re;pe++,_e++){let et=X.charCodeAt(pe),Ae=ae.charCodeAt(_e);if(et===Ae)continue;if(et>=128||Ae>=128)return N(X.toLowerCase(),ae.toLowerCase(),pe,we,_e,Re);ne(et)&&(et-=32),ne(Ae)&&(Ae-=32);const ce=et-Ae;if(ce!==0)return ce}const Ue=we-pe,Ge=Re-_e;return Ue<Ge?-1:Ue>Ge?1:0}t.compareSubstringIgnoreCase=H;function Z(X){return X>=48&&X<=57}t.isAsciiDigit=Z;function ne(X){return X>=97&&X<=122}t.isLowerAsciiLetter=ne;function se(X){return X>=65&&X<=90}t.isUpperAsciiLetter=se;function he(X,ae){return X.length===ae.length&&H(X,ae)===0}t.equalsIgnoreCase=he;function ue(X,ae){const pe=ae.length;return ae.length>X.length?!1:H(X,ae,0,pe)===0}t.startsWithIgnoreCase=ue;function le(X,ae){const pe=Math.min(X.length,ae.length);let we;for(we=0;we<pe;we++)if(X.charCodeAt(we)!==ae.charCodeAt(we))return we;return pe}t.commonPrefixLength=le;function oe(X,ae){const pe=Math.min(X.length,ae.length);let we;const _e=X.length-1,Re=ae.length-1;for(we=0;we<pe;we++)if(X.charCodeAt(_e-we)!==ae.charCodeAt(Re-we))return we;return pe}t.commonSuffixLength=oe;function ye(X){return 55296<=X&&X<=56319}t.isHighSurrogate=ye;function Te(X){return 56320<=X&&X<=57343}t.isLowSurrogate=Te;function Oe(X,ae){return(X-55296<<10)+(ae-56320)+65536}t.computeCodePoint=Oe;function ke(X,ae,pe){const we=X.charCodeAt(pe);if(ye(we)&&pe+1<ae){const _e=X.charCodeAt(pe+1);if(Te(_e))return Oe(we,_e)}return we}t.getNextCodePoint=ke;function fe(X,ae){const pe=X.charCodeAt(ae-1);if(Te(pe)&&ae>1){const we=X.charCodeAt(ae-2);if(ye(we))return Oe(we,pe)}return pe}class U{get offset(){return this._offset}constructor(ae,pe=0){this._str=ae,this._len=ae.length,this._offset=pe}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=fe(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=ke(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}t.CodePointIterator=U;class ie{get offset(){return this._iterator.offset}constructor(ae,pe=0){this._iterator=new U(ae,pe)}nextGraphemeLength(){const ae=Le.getInstance(),pe=this._iterator,we=pe.offset;let _e=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,Ue=ae.getGraphemeBreakType(pe.nextCodePoint());if(ve(_e,Ue)){pe.setOffset(Re);break}_e=Ue}return pe.offset-we}prevGraphemeLength(){const ae=Le.getInstance(),pe=this._iterator,we=pe.offset;let _e=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,Ue=ae.getGraphemeBreakType(pe.prevCodePoint());if(ve(Ue,_e)){pe.setOffset(Re);break}_e=Ue}return we-pe.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ie;function q(X,ae){return new ie(X,ae).nextGraphemeLength()}t.nextCharLength=q;function K(X,ae){return new ie(X,ae).prevGraphemeLength()}t.prevCharLength=K;function _(X,ae){ae>0&&Te(X.charCodeAt(ae))&&ae--;const pe=ae+q(X,ae);return[pe-K(X,pe),pe]}t.getCharContainingOffset=_;function j(X){const ae=new ie(X);let pe=0;for(;!ae.eol();)pe++,ae.nextGraphemeLength();return pe}t.charCount=j;let z;function o(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(X){return z||(z=o()),z.test(X)}t.containsRTL=T;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(X){return $.test(X)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function C(X){return t.UNUSUAL_LINE_TERMINATORS.test(X)}t.containsUnusualLineTerminators=C;function F(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}t.isFullWidthCharacter=F;function R(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}t.isEmojiImprecise=R;function S(X,ae){if(X.length<ae)return X;const pe=/\b/g;let we=0;for(;pe.test(X)&&!(X.length-pe.lastIndex<ae);)we=pe.lastIndex,pe.lastIndex+=1;return X.substring(we).replace(/^\s/,"")}t.lcut=S;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,B=/\x1b\].*?\x07/g;function P(X){return X&&(X=X.replace(x,"").replace(B,"")),X}t.removeAnsiEscapeCodes=P,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function V(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}t.startsWithUTF8BOM=V;function G(X){return V(X)?X.substr(1):X}t.stripUTF8BOM=G;function ee(X,ae){if(!X||!ae||X.length<ae.length)return!1;const pe=ae.length,we=X.toLowerCase();let _e=0,Re=-1;for(;_e<pe;){const Ue=we.indexOf(ae[_e],Re+1);if(Ue<0)return!1;Re=Ue,_e++}return!0}t.fuzzyContains=ee;function re(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}t.containsUppercaseCharacter=re;function be(X){return X.charAt(0).toUpperCase()+X.slice(1)}t.uppercaseFirstLetter=be;function De(X,ae=1){if(ae===0)return"";let pe=-1;do pe=X.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?X:(X[pe-1]==="\r"&&pe--,X.substr(0,pe))}t.getNLines=De;function Ie(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}t.singleLetterHash=Ie;function Se(X){return Le.getInstance().getGraphemeBreakType(X)}t.getGraphemeBreakType=Se;function ve(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var Pe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Ke()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const pe=this._data,we=pe.length/3;let _e=1;for(;_e<=we;)if(ae<pe[3*_e])_e=2*_e;else if(ae>pe[3*_e+1])_e=2*_e+1;else return pe[3*_e+2];return 0}}Le._INSTANCE=null;function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(X,ae){if(X===0)return 0;const pe=We(X,ae);if(pe!==void 0)return pe;const we=new U(ae,X);return we.prevCodePoint(),we.offset}t.getLeftDeleteOffset=xe;function We(X,ae){const pe=new U(ae,X);let we=pe.prevCodePoint();for(;Je(we)||we===65039||we===8419;){if(pe.offset===0)return;we=pe.prevCodePoint()}if(!R(we))return;let _e=pe.offset;return _e>0&&pe.prevCodePoint()===8205&&(_e=pe.offset),_e}function Je(X){return 127995<=X&&X<=127999}var it;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class Me{static getInstance(ae){return Me.cache.get(Array.from(ae))}static getLocales(){return Me._locales.value}constructor(ae){this.confusableDictionary=ae}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Me,i=Me,Me.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Me.cache=new E.LRUCachedFunction(X=>{function ae(Ae){const ce=new Map;for(let Ee=0;Ee<Ae.length;Ee+=2)ce.set(Ae[Ee],Ae[Ee+1]);return ce}function pe(Ae,ce){const Ee=new Map(Ae);for(const[Ne,He]of ce)Ee.set(Ne,He);return Ee}function we(Ae,ce){if(!Ae)return ce;const Ee=new Map;for(const[Ne,He]of Ae)ce.has(Ne)&&Ee.set(Ne,He);return Ee}const _e=i.ambiguousCharacterData.value;let Re=X.filter(Ae=>!Ae.startsWith("_")&&Ae in _e);Re.length===0&&(Re=["_default"]);let Ue;for(const Ae of Re){const ce=ae(_e[Ae]);Ue=we(Ue,ce)}const Ge=ae(_e._common),et=pe(Ge,Ue);return new Me(et)}),Me._locales=new L.Lazy(()=>Object.keys(Me.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(ae){return Ve.getData().has(ae)}static get codePoints(){return Ve.getData()}}t.InvisibleCharacters=Ve,Ve._data=void 0}),define(ge[110],me([1,0,22,5,11,6]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function w(g){return g===47||g===92}t.isPathSeparator=w;function y(g){return g.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=y;function c(g){return g.indexOf("/")===-1&&(g=y(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}t.toPosixPath=c;function a(g,b=E.posix.sep){if(!g)return"";const N=g.length,M=g.charCodeAt(0);if(w(M)){if(w(g.charCodeAt(1))&&!w(g.charCodeAt(2))){let Z=3;const ne=Z;for(;Z<N&&!w(g.charCodeAt(Z));Z++);if(ne!==Z&&!w(g.charCodeAt(Z+1))){for(Z+=1;Z<N;Z++)if(w(g.charCodeAt(Z)))return g.slice(0,Z+1).replace(/[\\/]/g,b)}}return b}else if(h(M)&&g.charCodeAt(1)===58)return w(g.charCodeAt(2))?g.slice(0,2)+b:g.slice(0,2);let H=g.indexOf("://");if(H!==-1){for(H+=3;H<N;H++)if(w(g.charCodeAt(H)))return g.slice(0,H+1)}return""}t.getRoot=a;function d(g){if(!L.isWindows||!g||g.length<5)return!1;let b=g.charCodeAt(0);if(b!==92||(b=g.charCodeAt(1),b!==92))return!1;let N=2;const M=N;for(;N<g.length&&(b=g.charCodeAt(N),b!==92);N++);return!(M===N||(b=g.charCodeAt(N+1),isNaN(b)||b===92))}t.isUNC=d;const I=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(g,b=L.isWindows){const N=b?I:r;return!(!g||g.length===0||/^\s+$/.test(g)||(N.lastIndex=0,N.test(g))||b&&u.test(g)||g==="."||g===".."||b&&g[g.length-1]==="."||b&&g.length!==g.trim().length||g.length>255)}t.isValidBasename=e;function l(g,b,N){const M=g===b;return!N||M?M:!g||!b?!1:(0,i.equalsIgnoreCase)(g,b)}t.isEqual=l;function n(g,b,N,M=E.sep){if(g===b)return!0;if(!g||!b||b.length>g.length)return!1;if(N){if(!(0,i.startsWithIgnoreCase)(g,b))return!1;if(b.length===g.length)return!0;let Z=b.length;return b.charAt(b.length-1)===M&&Z--,g.charAt(Z)===M}return b.charAt(b.length-1)!==M&&(b+=M),g.indexOf(b)===0}t.isEqualOrParent=n;function h(g){return g>=65&&g<=90||g>=97&&g<=122}t.isWindowsDriveLetter=h;function s(g,b){return L.isWindows&&g.endsWith(":")&&(g+=E.sep),(0,E.isAbsolute)(g)||(g=(0,E.join)(b,g)),g=(0,E.normalize)(g),L.isWindows?(g=(0,i.rtrim)(g,E.sep),g.endsWith(":")&&(g+=E.sep)):(g=(0,i.rtrim)(g,E.sep),g||(g=E.sep)),g}t.sanitizeFilePath=s;function D(g){const b=(0,E.normalize)(g);return L.isWindows?g.length>3?!1:v(b)&&(g.length===2||b.charCodeAt(2)===92):b===E.posix.sep}t.isRootOrDriveLetter=D;function v(g,b=L.isWindows){return b?h(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}t.hasDriveLetter=v;function A(g,b=L.isWindows){return v(g,b)?g[0]:void 0}t.getDriveLetter=A;function f(g,b,N){return b.length>g.length?-1:g===b?0:(N&&(g=g.toLowerCase(),b=b.toLowerCase()),g.indexOf(b))}t.indexOfPath=f;function p(g){const b=g.split(":");let N,M,H;for(const Z of b){const ne=Number(Z);(0,W.isNumber)(ne)?M===void 0?M=ne:H===void 0&&(H=ne):N=N?[N,Z].join(":"):Z}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:M!==void 0?M:void 0,column:H!==void 0?H:M!==void 0?1:void 0}}t.parseLineAndColumnAware=p;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",k="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(g,b,N=8){let M="";for(let Z=0;Z<N;Z++){let ne;Z===0&&L.isWindows&&!b&&(N===3||N===4)?ne=k:ne=O,M+=ne.charAt(Math.floor(Math.random()*ne.length))}let H;return b?H=`${b}-${M}`:H=M,g?(0,E.join)(g,H):H}t.randomPath=m}),define(ge[33],me([1,0,75,11]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...B){return function(P,V){for(let G=0,ee=B.length;G<ee;G++){const re=B[G](P,V);if(re)return re}return null}}t.or=i,t.matchesStrictPrefix=W.bind(void 0,!1),t.matchesPrefix=W.bind(void 0,!0);function W(B,P,V){if(!V||V.length<P.length)return null;let G;return B?G=L.startsWithIgnoreCase(V,P):G=V.indexOf(P)===0,G?P.length>0?[{start:0,end:P.length}]:[]:null}function w(B,P){const V=P.toLowerCase().indexOf(B.toLowerCase());return V===-1?null:[{start:V,end:V+B.length}]}t.matchesContiguousSubString=w;function y(B,P){return c(B.toLowerCase(),P.toLowerCase(),0,0)}t.matchesSubString=y;function c(B,P,V,G){if(V===B.length)return[];if(G===P.length)return null;if(B[V]===P[G]){let ee=null;return(ee=c(B,P,V+1,G+1))?h({start:G,end:G+1},ee):null}return c(B,P,V,G+1)}function a(B){return 97<=B&&B<=122}function d(B){return 65<=B&&B<=90}t.isUpper=d;function I(B){return 48<=B&&B<=57}function r(B){return B===32||B===9||B===10||B===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>u.add(B.charCodeAt(0)));function e(B){return r(B)||u.has(B)}function l(B,P){return B===P||e(B)&&e(P)}function n(B){return a(B)||d(B)||I(B)}function h(B,P){return P.length===0?P=[B]:B.end===P[0].start?P[0].start=B.start:P.unshift(B),P}function s(B,P){for(let V=P;V<B.length;V++){const G=B.charCodeAt(V);if(d(G)||I(G)||V>0&&!n(B.charCodeAt(V-1)))return V}return B.length}function D(B,P,V,G){if(V===B.length)return[];if(G===P.length)return null;if(B[V]!==P[G].toLowerCase())return null;{let ee=null,re=G+1;for(ee=D(B,P,V+1,G+1);!ee&&(re=s(P,re))<P.length;)ee=D(B,P,V+1,re),re++;return ee===null?null:h({start:G,end:G+1},ee)}}function v(B){let P=0,V=0,G=0,ee=0,re=0;for(let ve=0;ve<B.length;ve++)re=B.charCodeAt(ve),d(re)&&P++,a(re)&&V++,n(re)&&G++,I(re)&&ee++;const be=P/B.length,De=V/B.length,Ie=G/B.length,Se=ee/B.length;return{upperPercent:be,lowerPercent:De,alphaPercent:Ie,numericPercent:Se}}function A(B){const{upperPercent:P,lowerPercent:V}=B;return V===0&&P>.6}function f(B){const{upperPercent:P,lowerPercent:V,alphaPercent:G,numericPercent:ee}=B;return V>.2&&P<.8&&G>.6&&ee<.2}function p(B){let P=0,V=0,G=0,ee=0;for(let re=0;re<B.length;re++)G=B.charCodeAt(re),d(G)&&P++,a(G)&&V++,r(G)&&ee++;return(P===0||V===0)&&ee===0?B.length<=30:P<=5}function O(B,P){if(!P||(P=P.trim(),P.length===0)||!p(B)||P.length>60)return null;const V=v(P);if(!f(V)){if(!A(V))return null;P=P.toLowerCase()}let G=null,ee=0;for(B=B.toLowerCase();ee<P.length&&(G=D(B,P,0,ee))===null;)ee=s(P,ee+1);return G}t.matchesCamelCase=O;function k(B,P,V=!1){if(!P||P.length===0)return null;let G=null,ee=0;for(B=B.toLowerCase(),P=P.toLowerCase();ee<P.length&&(G=m(B,P,0,ee,V))===null;)ee=g(P,ee+1);return G}t.matchesWords=k;function m(B,P,V,G,ee){if(V===B.length)return[];if(G===P.length)return null;if(l(B.charCodeAt(V),P.charCodeAt(G))){let re=null,be=G+1;if(re=m(B,P,V+1,G+1,ee),!ee)for(;!re&&(be=g(P,be))<P.length;)re=m(B,P,V+1,be,ee),be++;return re?B.charCodeAt(V)!==P.charCodeAt(G)?re:h({start:G,end:G+1},re):null}else return null}function g(B,P){for(let V=P;V<B.length;V++)if(e(B.charCodeAt(V))||V>0&&e(B.charCodeAt(V-1)))return V;return B.length}const b=i(t.matchesPrefix,O,w),N=i(t.matchesPrefix,O,y),M=new E.LRUCache(1e4);function H(B,P,V=!1){if(typeof B!="string"||typeof P!="string")return null;let G=M.get(B);G||(G=new RegExp(L.convertSimple2RegExpPattern(B),"i"),M.set(B,G));const ee=G.exec(P);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:V?N(B,P):b(B,P)}t.matchesFuzzy=H;function Z(B,P){const V=$(B,B.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?se(V):null}t.matchesFuzzy2=Z;function ne(B,P,V,G,ee,re){const be=Math.min(13,B.length);for(;V<be;V++){const De=$(B,P,V,G,ee,re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,re]}t.anyScore=ne;function se(B){if(typeof B>"u")return[];const P=[],V=B[1];for(let G=B.length-1;G>1;G--){const ee=B[G]+V,re=P[P.length-1];re&&re.end===ee?re.end=ee+1:P.push({start:ee,end:ee+1})}return P}t.createMatches=se;const he=128;function ue(){const B=[],P=[];for(let V=0;V<=he;V++)P[V]=0;for(let V=0;V<=he;V++)B.push(P.slice(0));return B}function le(B){const P=[];for(let V=0;V<=B;V++)P[V]=0;return P}const oe=le(2*he),ye=le(2*he),Te=ue(),Oe=ue(),ke=ue(),fe=!1;function U(B,P,V,G,ee){function re(De,Ie,Se=" "){for(;De.length<Ie;)De=Se+De;return De}let be=` |   |${G.split("").map(De=>re(De,3)).join("|")}
`;for(let De=0;De<=V;De++)De===0?be+=" |":be+=`${P[De-1]}|`,be+=B[De].slice(0,ee+1).map(Ie=>re(Ie.toString(),3)).join("|")+`
`;return be}function ie(B,P,V,G){B=B.substr(P),V=V.substr(G),console.log(U(Oe,B,B.length,V,V.length)),console.log(U(ke,B,B.length,V,V.length)),console.log(U(Te,B,B.length,V,V.length))}function q(B,P){if(P<0||P>=B.length)return!1;const V=B.codePointAt(P);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(V)}}function K(B,P){if(P<0||P>=B.length)return!1;switch(B.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function _(B,P,V){return P[B]!==V[B]}function j(B,P,V,G,ee,re,be=!1){for(;P<V&&ee<re;)B[P]===G[ee]&&(be&&(oe[P]=ee),P+=1),ee+=1;return P===V}t.isPatternInWord=j;var z;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(z||(z={}));var o;(function(B){B.Default=[-100,0];function P(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}B.isDefault=P})(o||(t.FuzzyScore=o={}));class T{constructor(P,V){this.firstMatchCanBeWeak=P,this.boostFullMatch=V}}t.FuzzyScoreOptions=T,T.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(B,P,V,G,ee,re,be=T.default){const De=B.length>he?he:B.length,Ie=G.length>he?he:G.length;if(V>=De||re>=Ie||De-V>Ie-re||!j(P,V,De,ee,re,Ie,!0))return;Y(De,Ie,V,re,P,ee);let Se=1,ve=1,Pe=V,Le=re;const Ke=[!1];for(Se=1,Pe=V;Pe<De;Se++,Pe++){const Me=oe[Pe],Ve=ye[Pe],X=Pe+1<De?ye[Pe+1]:Ie;for(ve=Me-re+1,Le=Me;Le<X;ve++,Le++){let ae=Number.MIN_SAFE_INTEGER,pe=!1;Le<=Ve&&(ae=C(B,P,Pe,V,G,ee,Le,Ie,re,Te[Se-1][ve-1]===0,Ke));let we=0;ae!==Number.MAX_SAFE_INTEGER&&(pe=!0,we=ae+Oe[Se-1][ve-1]);const _e=Le>Me,Re=_e?Oe[Se][ve-1]+(Te[Se][ve-1]>0?-5:0):0,Ue=Le>Me+1&&Te[Se][ve-1]>0,Ge=Ue?Oe[Se][ve-2]+(Te[Se][ve-2]>0?-5:0):0;if(Ue&&(!_e||Ge>=Re)&&(!pe||Ge>=we))Oe[Se][ve]=Ge,ke[Se][ve]=3,Te[Se][ve]=0;else if(_e&&(!pe||Re>=we))Oe[Se][ve]=Re,ke[Se][ve]=2,Te[Se][ve]=0;else if(pe)Oe[Se][ve]=we,ke[Se][ve]=1,Te[Se][ve]=Te[Se-1][ve-1]+1;else throw new Error("not possible")}}if(fe&&ie(B,V,G,re),!Ke[0]&&!be.firstMatchCanBeWeak)return;Se--,ve--;const xe=[Oe[Se][ve],re];let We=0,Je=0;for(;Se>=1;){let Me=ve;do{const Ve=ke[Se][Me];if(Ve===3)Me=Me-2;else if(Ve===2)Me=Me-1;else break}while(Me>=1);We>1&&P[V+Se-1]===ee[re+ve-1]&&!_(Me+re-1,G,ee)&&We+1>Te[Se][Me]&&(Me=ve),Me===ve?We++:We=1,Je||(Je=Me),Se--,ve=Me-1,xe.push(ve)}Ie===De&&be.boostFullMatch&&(xe[0]+=2);const it=Je-De;return xe[0]-=it,xe}t.fuzzyScore=$;function Y(B,P,V,G,ee,re){let be=B-1,De=P-1;for(;be>=V&&De>=G;)ee[be]===re[De]&&(ye[be]=De,be--),De--}function C(B,P,V,G,ee,re,be,De,Ie,Se,ve){if(P[V]!==re[be])return Number.MIN_SAFE_INTEGER;let Pe=1,Le=!1;return be===V-G?Pe=B[V]===ee[be]?7:5:_(be,ee,re)&&(be===0||!_(be-1,ee,re))?(Pe=B[V]===ee[be]?7:5,Le=!0):q(re,be)&&(be===0||!q(re,be-1))?Pe=5:(q(re,be-1)||K(re,be-1))&&(Pe=5,Le=!0),Pe>1&&V===G&&(ve[0]=!0),Le||(Le=_(be,ee,re)||q(re,be-1)||K(re,be-1)),V===G?be>Ie&&(Pe-=Le?3:5):Se?Pe+=Le?2:0:Pe+=Le?0:1,be+1===De&&(Pe-=Le?3:5),Pe}function F(B,P,V,G,ee,re,be){return S(B,P,V,G,ee,re,!0,be)}t.fuzzyScoreGracefulAggressive=F;function R(B,P,V,G,ee,re,be){return S(B,P,V,G,ee,re,!1,be)}t.fuzzyScoreGraceful=R;function S(B,P,V,G,ee,re,be,De){let Ie=$(B,P,V,G,ee,re,De);if(Ie&&!be)return Ie;if(B.length>=3){const Se=Math.min(7,B.length-1);for(let ve=V+1;ve<Se;ve++){const Pe=x(B,ve);if(Pe){const Le=$(Pe,Pe.toLowerCase(),V,G,ee,re,De);Le&&(Le[0]-=3,(!Ie||Le[0]>Ie[0])&&(Ie=Le))}}}return Ie}function x(B,P){if(P+1>=B.length)return;const V=B[P],G=B[P+1];if(V!==G)return B.slice(0,P)+G+V+B.slice(P+2)}}),define(ge[111],me([1,0,11]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function L(h){return i(h,0)}t.hash=L;function i(h,s){switch(typeof h){case"object":return h===null?W(349,s):Array.isArray(h)?c(h,s):a(h,s);case"string":return y(h,s);case"boolean":return w(h,s);case"number":return W(h,s);case"undefined":return W(937,s);default:return W(617,s)}}t.doHash=i;function W(h,s){return(s<<5)-s+h|0}t.numberHash=W;function w(h,s){return W(h?433:863,s)}function y(h,s){s=W(149417,s);for(let D=0,v=h.length;D<v;D++)s=W(h.charCodeAt(D),s);return s}t.stringHash=y;function c(h,s){return s=W(104579,s),h.reduce((D,v)=>i(v,D),s)}function a(h,s){return s=W(181387,s),Object.keys(h).sort().reduce((D,v)=>(D=y(v,D),i(h[v],D)),s)}class d{constructor(){this._value=0}get value(){return this._value}hash(s){return this._value=i(s,this._value),this._value}}t.Hasher=d;var I;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function r(h,s,D=32){const v=D-s,A=~((1<<v)-1);return(h<<s|(A&h)>>>v)>>>0}function u(h,s=0,D=h.byteLength,v=0){for(let A=0;A<D;A++)h[s+A]=v}function e(h,s,D="0"){for(;h.length<s;)h=D+h;return h}function l(h,s=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),s/4)}t.toHexString=l;class n{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(s){const D=s.length;if(D===0)return;const v=this._buff;let A=this._buffLen,f=this._leftoverHighSurrogate,p,O;for(f!==0?(p=f,O=-1,f=0):(p=s.charCodeAt(0),O=0);;){let k=p;if(E.isHighSurrogate(p))if(O+1<D){const m=s.charCodeAt(O+1);E.isLowSurrogate(m)?(O++,k=E.computeCodePoint(p,m)):k=65533}else{f=p;break}else E.isLowSurrogate(p)&&(k=65533);if(A=this._push(v,A,k),O++,O<D)p=s.charCodeAt(O);else break}this._buffLen=A,this._leftoverHighSurrogate=f}_push(s,D,v){return v<128?s[D++]=v:v<2048?(s[D++]=192|(v&1984)>>>6,s[D++]=128|(v&63)>>>0):v<65536?(s[D++]=224|(v&61440)>>>12,s[D++]=128|(v&4032)>>>6,s[D++]=128|(v&63)>>>0):(s[D++]=240|(v&1835008)>>>18,s[D++]=128|(v&258048)>>>12,s[D++]=128|(v&4032)>>>6,s[D++]=128|(v&63)>>>0),D>=64&&(this._step(),D-=64,this._totalLen+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),D}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const s=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(s/4294967296),!1),this._buffDV.setUint32(60,s%4294967296,!1),this._step()}_step(){const s=n._bigBlock32,D=this._buffDV;for(let b=0;b<64;b+=4)s.setUint32(b,D.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)s.setUint32(b,r(s.getUint32(b-12,!1)^s.getUint32(b-32,!1)^s.getUint32(b-56,!1)^s.getUint32(b-64,!1),1),!1);let v=this._h0,A=this._h1,f=this._h2,p=this._h3,O=this._h4,k,m,g;for(let b=0;b<80;b++)b<20?(k=A&f|~A&p,m=1518500249):b<40?(k=A^f^p,m=1859775393):b<60?(k=A&f|A&p|f&p,m=2400959708):(k=A^f^p,m=3395469782),g=r(v,5)+k+O+m+s.getUint32(b*4,!1)&4294967295,O=p,p=f,f=r(A,30),A=v,v=g;this._h0=this._h0+v&4294967295,this._h1=this._h1+A&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+p&4294967295,this._h4=this._h4+O&4294967295}}t.StringSHA1=n,n._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[112],me([1,0,71,111]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.source=r}getElements(){const r=this.source,u=new Int32Array(r.length);for(let e=0,l=r.length;e<l;e++)u[e]=r.charCodeAt(e);return u}}t.StringDiffSequence=i;function W(I,r,u){return new d(new i(I),new i(r)).ComputeDiff(u).changes}t.stringDiff=W;class w{static Assert(r,u){if(!r)throw new Error(u)}}class y{static Copy(r,u,e,l,n){for(let h=0;h<n;h++)e[l+h]=r[u+h]}static Copy2(r,u,e,l,n){for(let h=0;h<n;h++)e[l+h]=r[u+h]}}var c;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(r,u){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,u),this.m_originalCount++}AddModifiedElement(r,u){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,u),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class d{constructor(r,u,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=r,this._modifiedSequence=u;const[l,n,h]=d._getElements(r),[s,D,v]=d._getElements(u);this._hasStrings=h&&v,this._originalStringElements=l,this._originalElementsOrHash=n,this._modifiedStringElements=s,this._modifiedElementsOrHash=D,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(r){return r.length>0&&typeof r[0]=="string"}static _getElements(r){const u=r.getElements();if(d._isStringArray(u)){const e=new Int32Array(u.length);for(let l=0,n=u.length;l<n;l++)e[l]=(0,L.stringHash)(u[l],0);return[u,e,!0]}return u instanceof Int32Array?[[],u,!1]:[[],new Int32Array(u),!1]}ElementsAreEqual(r,u){return this._originalElementsOrHash[r]!==this._modifiedElementsOrHash[u]?!1:this._hasStrings?this._originalStringElements[r]===this._modifiedStringElements[u]:!0}ElementsAreStrictEqual(r,u){if(!this.ElementsAreEqual(r,u))return!1;const e=d._getStrictElement(this._originalSequence,r),l=d._getStrictElement(this._modifiedSequence,u);return e===l}static _getStrictElement(r,u){return typeof r.getStrictElement=="function"?r.getStrictElement(u):null}OriginalElementsAreEqual(r,u){return this._originalElementsOrHash[r]!==this._originalElementsOrHash[u]?!1:this._hasStrings?this._originalStringElements[r]===this._originalStringElements[u]:!0}ModifiedElementsAreEqual(r,u){return this._modifiedElementsOrHash[r]!==this._modifiedElementsOrHash[u]?!1:this._hasStrings?this._modifiedStringElements[r]===this._modifiedStringElements[u]:!0}ComputeDiff(r){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,r)}_ComputeDiff(r,u,e,l,n){const h=[!1];let s=this.ComputeDiffRecursive(r,u,e,l,h);return n&&(s=this.PrettifyChanges(s)),{quitEarly:h[0],changes:s}}ComputeDiffRecursive(r,u,e,l,n){for(n[0]=!1;r<=u&&e<=l&&this.ElementsAreEqual(r,e);)r++,e++;for(;u>=r&&l>=e&&this.ElementsAreEqual(u,l);)u--,l--;if(r>u||e>l){let f;return e<=l?(w.Assert(r===u+1,"originalStart should only be one more than originalEnd"),f=[new E.DiffChange(r,0,e,l-e+1)]):r<=u?(w.Assert(e===l+1,"modifiedStart should only be one more than modifiedEnd"),f=[new E.DiffChange(r,u-r+1,e,0)]):(w.Assert(r===u+1,"originalStart should only be one more than originalEnd"),w.Assert(e===l+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const h=[0],s=[0],D=this.ComputeRecursionPoint(r,u,e,l,h,s,n),v=h[0],A=s[0];if(D!==null)return D;if(!n[0]){const f=this.ComputeDiffRecursive(r,v,e,A,n);let p=[];return n[0]?p=[new E.DiffChange(v+1,u-(v+1)+1,A+1,l-(A+1)+1)]:p=this.ComputeDiffRecursive(v+1,u,A+1,l,n),this.ConcatenateChanges(f,p)}return[new E.DiffChange(r,u-r+1,e,l-e+1)]}WALKTRACE(r,u,e,l,n,h,s,D,v,A,f,p,O,k,m,g,b,N){let M=null,H=null,Z=new a,ne=u,se=e,he=O[0]-g[0]-l,ue=-1073741824,le=this.m_forwardHistory.length-1;do{const oe=he+r;oe===ne||oe<se&&v[oe-1]<v[oe+1]?(f=v[oe+1],k=f-he-l,f<ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,k),he=oe+1-r):(f=v[oe-1]+1,k=f-he-l,f<ue&&Z.MarkNextChange(),ue=f-1,Z.AddOriginalElement(f,k+1),he=oe-1-r),le>=0&&(v=this.m_forwardHistory[le],r=v[0],ne=1,se=v.length-1)}while(--le>=-1);if(M=Z.getReverseChanges(),N[0]){let oe=O[0]+1,ye=g[0]+1;if(M!==null&&M.length>0){const Te=M[M.length-1];oe=Math.max(oe,Te.getOriginalEnd()),ye=Math.max(ye,Te.getModifiedEnd())}H=[new E.DiffChange(oe,p-oe+1,ye,m-ye+1)]}else{Z=new a,ne=h,se=s,he=O[0]-g[0]-D,ue=1073741824,le=b?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const oe=he+n;oe===ne||oe<se&&A[oe-1]>=A[oe+1]?(f=A[oe+1]-1,k=f-he-D,f>ue&&Z.MarkNextChange(),ue=f+1,Z.AddOriginalElement(f+1,k+1),he=oe+1-n):(f=A[oe-1],k=f-he-D,f>ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,k+1),he=oe-1-n),le>=0&&(A=this.m_reverseHistory[le],n=A[0],ne=1,se=A.length-1)}while(--le>=-1);H=Z.getChanges()}return this.ConcatenateChanges(M,H)}ComputeRecursionPoint(r,u,e,l,n,h,s){let D=0,v=0,A=0,f=0,p=0,O=0;r--,e--,n[0]=0,h[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const k=u-r+(l-e),m=k+1,g=new Int32Array(m),b=new Int32Array(m),N=l-e,M=u-r,H=r-e,Z=u-l,se=(M-N)%2===0;g[N]=r,b[M]=u,s[0]=!1;for(let he=1;he<=k/2+1;he++){let ue=0,le=0;A=this.ClipDiagonalBound(N-he,he,N,m),f=this.ClipDiagonalBound(N+he,he,N,m);for(let ye=A;ye<=f;ye+=2){ye===A||ye<f&&g[ye-1]<g[ye+1]?D=g[ye+1]:D=g[ye-1]+1,v=D-(ye-N)-H;const Te=D;for(;D<u&&v<l&&this.ElementsAreEqual(D+1,v+1);)D++,v++;if(g[ye]=D,D+v>ue+le&&(ue=D,le=v),!se&&Math.abs(ye-M)<=he-1&&D>=b[ye])return n[0]=D,h[0]=v,Te<=b[ye]&&1447>0&&he<=1447+1?this.WALKTRACE(N,A,f,H,M,p,O,Z,g,b,D,u,n,v,l,h,se,s):null}const oe=(ue-r+(le-e)-he)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ue,oe))return s[0]=!0,n[0]=ue,h[0]=le,oe>0&&1447>0&&he<=1447+1?this.WALKTRACE(N,A,f,H,M,p,O,Z,g,b,D,u,n,v,l,h,se,s):(r++,e++,[new E.DiffChange(r,u-r+1,e,l-e+1)]);p=this.ClipDiagonalBound(M-he,he,M,m),O=this.ClipDiagonalBound(M+he,he,M,m);for(let ye=p;ye<=O;ye+=2){ye===p||ye<O&&b[ye-1]>=b[ye+1]?D=b[ye+1]-1:D=b[ye-1],v=D-(ye-M)-Z;const Te=D;for(;D>r&&v>e&&this.ElementsAreEqual(D,v);)D--,v--;if(b[ye]=D,se&&Math.abs(ye-N)<=he&&D<=g[ye])return n[0]=D,h[0]=v,Te>=g[ye]&&1447>0&&he<=1447+1?this.WALKTRACE(N,A,f,H,M,p,O,Z,g,b,D,u,n,v,l,h,se,s):null}if(he<=1447){let ye=new Int32Array(f-A+2);ye[0]=N-A+1,y.Copy2(g,A,ye,1,f-A+1),this.m_forwardHistory.push(ye),ye=new Int32Array(O-p+2),ye[0]=M-p+1,y.Copy2(b,p,ye,1,O-p+1),this.m_reverseHistory.push(ye)}}return this.WALKTRACE(N,A,f,H,M,p,O,Z,g,b,D,u,n,v,l,h,se,s)}PrettifyChanges(r){for(let u=0;u<r.length;u++){const e=r[u],l=u<r.length-1?r[u+1].originalStart:this._originalElementsOrHash.length,n=u<r.length-1?r[u+1].modifiedStart:this._modifiedElementsOrHash.length,h=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<l&&e.modifiedStart+e.modifiedLength<n&&(!h||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const v=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!v)break;e.originalStart++,e.modifiedStart++}const D=[null];if(u<r.length-1&&this.ChangesOverlap(r[u],r[u+1],D)){r[u]=D[0],r.splice(u+1,1),u--;continue}}for(let u=r.length-1;u>=0;u--){const e=r[u];let l=0,n=0;if(u>0){const f=r[u-1];l=f.originalStart+f.originalLength,n=f.modifiedStart+f.modifiedLength}const h=e.originalLength>0,s=e.modifiedLength>0;let D=0,v=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const p=e.originalStart-f,O=e.modifiedStart-f;if(p<l||O<n||h&&!this.OriginalElementsAreEqual(p,p+e.originalLength)||s&&!this.ModifiedElementsAreEqual(O,O+e.modifiedLength))break;const m=(p===l&&O===n?5:0)+this._boundaryScore(p,e.originalLength,O,e.modifiedLength);m>v&&(v=m,D=f)}e.originalStart-=D,e.modifiedStart-=D;const A=[null];if(u>0&&this.ChangesOverlap(r[u-1],r[u],A)){r[u-1]=A[0],r.splice(u,1),u++;continue}}if(this._hasStrings)for(let u=1,e=r.length;u<e;u++){const l=r[u-1],n=r[u],h=n.originalStart-l.originalStart-l.originalLength,s=l.originalStart,D=n.originalStart+n.originalLength,v=D-s,A=l.modifiedStart,f=n.modifiedStart+n.modifiedLength,p=f-A;if(h<5&&v<20&&p<20){const O=this._findBetterContiguousSequence(s,v,A,p,h);if(O){const[k,m]=O;(k!==l.originalStart+l.originalLength||m!==l.modifiedStart+l.modifiedLength)&&(l.originalLength=k-l.originalStart,l.modifiedLength=m-l.modifiedStart,n.originalStart=k+h,n.modifiedStart=m+h,n.originalLength=D-n.originalStart,n.modifiedLength=f-n.modifiedStart)}}}return r}_findBetterContiguousSequence(r,u,e,l,n){if(u<n||l<n)return null;const h=r+u-n+1,s=e+l-n+1;let D=0,v=0,A=0;for(let f=r;f<h;f++)for(let p=e;p<s;p++){const O=this._contiguousSequenceScore(f,p,n);O>0&&O>D&&(D=O,v=f,A=p)}return D>0?[v,A]:null}_contiguousSequenceScore(r,u,e){let l=0;for(let n=0;n<e;n++){if(!this.ElementsAreEqual(r+n,u+n))return 0;l+=this._originalStringElements[r+n].length}return l}_OriginalIsBoundary(r){return r<=0||r>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[r])}_OriginalRegionIsBoundary(r,u){if(this._OriginalIsBoundary(r)||this._OriginalIsBoundary(r-1))return!0;if(u>0){const e=r+u;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(r){return r<=0||r>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[r])}_ModifiedRegionIsBoundary(r,u){if(this._ModifiedIsBoundary(r)||this._ModifiedIsBoundary(r-1))return!0;if(u>0){const e=r+u;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(r,u,e,l){const n=this._OriginalRegionIsBoundary(r,u)?1:0,h=this._ModifiedRegionIsBoundary(e,l)?1:0;return n+h}ConcatenateChanges(r,u){const e=[];if(r.length===0||u.length===0)return u.length>0?u:r;if(this.ChangesOverlap(r[r.length-1],u[0],e)){const l=new Array(r.length+u.length-1);return y.Copy(r,0,l,0,r.length-1),l[r.length-1]=e[0],y.Copy(u,1,l,r.length,u.length-1),l}else{const l=new Array(r.length+u.length);return y.Copy(r,0,l,0,r.length),y.Copy(u,0,l,r.length,u.length),l}}ChangesOverlap(r,u,e){if(w.Assert(r.originalStart<=u.originalStart,"Left change is not less than or equal to right change"),w.Assert(r.modifiedStart<=u.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=u.originalStart||r.modifiedStart+r.modifiedLength>=u.modifiedStart){const l=r.originalStart;let n=r.originalLength;const h=r.modifiedStart;let s=r.modifiedLength;return r.originalStart+r.originalLength>=u.originalStart&&(n=u.originalStart+u.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=u.modifiedStart&&(s=u.modifiedStart+u.modifiedLength-r.modifiedStart),e[0]=new E.DiffChange(l,n,h,s),!0}else return e[0]=null,!1}ClipDiagonalBound(r,u,e,l){if(r>=0&&r<l)return r;const n=e,h=l-e-1,s=u%2===0;if(r<0){const D=n%2===0;return s===D?0:1}else{const D=h%2===0;return s===D?l-1:l-2}}}t.LcsDiff=d}),define(ge[34],me([1,0,33,11,17]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const W="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${w.source}`,"g");function c(h){return h.replace(y,(s,D)=>D?s:`\\${s}`)}t.escapeIcons=c;const a=new RegExp(`\\\\${w.source}`,"g");function d(h){return h.replace(a,s=>`\\${s}`)}t.markdownEscapeEscapedIcons=d;const I=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function r(h){return h.indexOf(W)===-1?h:h.replace(I,(s,D,v,A)=>v?s:D||A||"")}t.stripIcons=r;function u(h){return h?h.replace(/\$\((.*?)\)/g,(s,D)=>` ${D} `).trim():""}t.getCodiconAriaLabel=u;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(h){e.lastIndex=0;let s="";const D=[];let v=0;for(;;){const A=e.lastIndex,f=e.exec(h),p=h.substring(A,f?.index);if(p.length>0){s+=p;for(let O=0;O<p.length;O++)D.push(v)}if(!f)break;v+=f[0].length}return{text:s,iconOffsets:D}}t.parseLabelWithIcons=l;function n(h,s,D=!1){const{text:v,iconOffsets:A}=s;if(!A||A.length===0)return(0,E.matchesFuzzy)(h,v,D);const f=(0,L.ltrim)(v," "),p=v.length-f.length,O=(0,E.matchesFuzzy)(h,f,D);if(O)for(const k of O){const m=A[k.start+p]+p;k.start+=m,k.end+=m}return O}t.matchesFuzzyIconAware=n}),define(ge[113],me([1,0,13,11]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const e=u.charCodeAt(0),l=this._value.charCodeAt(this._pos);return e-l}value(){return this._value[this._pos]}}t.StringIterator=i;class W{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=W;class w{constructor(u=!0,e=!0){this._splitOnBackslash=u,this._caseSensitive=e}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let e=u.length-1;e>=0;e--,this._valueLen--){const l=this._value.charCodeAt(e);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const e=this._value.charCodeAt(this._to);if(e===47||this._splitOnBackslash&&e===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=w;var y;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(y||(y={}));class c{constructor(u,e){this._ignorePathCasing=u,this._ignoreQueryAndFragment=e,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,L.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=c;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class I{static forUris(u=()=>!1,e=()=>!1){return new I(new c(u,e))}static forPaths(u=!1){return new I(new w(void 0,!u))}static forStrings(){return new I(new i)}static forConfigKeys(){return new I(new W)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,e){if(e){const l=e.slice(0);(0,E.shuffle)(l);for(const n of l)this.set(n,u)}else{const l=u.slice(0);(0,E.shuffle)(l);for(const n of l)this.set(n[0],n[1])}}set(u,e){const l=this._iter.reset(u);let n;this._root||(this._root=new a,this._root.segment=l.value());const h=[];for(n=this._root;;){const D=l.cmp(n.segment);if(D>0)n.left||(n.left=new a,n.left.segment=l.value()),h.push([-1,n]),n=n.left;else if(D<0)n.right||(n.right=new a,n.right.segment=l.value()),h.push([1,n]),n=n.right;else if(l.hasNext())l.next(),n.mid||(n.mid=new a,n.mid.segment=l.value()),h.push([0,n]),n=n.mid;else break}const s=n.value;n.value=e,n.key=u;for(let D=h.length-1;D>=0;D--){const v=h[D][1];v.updateHeight();const A=v.balanceFactor();if(A<-1||A>1){const f=h[D][0],p=h[D+1][0];if(f===1&&p===1)h[D][1]=v.rotateLeft();else if(f===-1&&p===-1)h[D][1]=v.rotateRight();else if(f===1&&p===-1)v.right=h[D+1][1]=h[D+1][1].rotateRight(),h[D][1]=v.rotateLeft();else if(f===-1&&p===1)v.left=h[D+1][1]=h[D+1][1].rotateLeft(),h[D][1]=v.rotateRight();else throw new Error;if(D>0)switch(h[D-1][0]){case-1:h[D-1][1].left=h[D][1];break;case 1:h[D-1][1].right=h[D][1];break;case 0:h[D-1][1].mid=h[D][1];break}else this._root=h[0][1]}}return s}get(u){return this._getNode(u)?.value}_getNode(u){const e=this._iter.reset(u);let l=this._root;for(;l;){const n=e.cmp(l.segment);if(n>0)l=l.left;else if(n<0)l=l.right;else if(e.hasNext())e.next(),l=l.mid;else break}return l}has(u){const e=this._getNode(u);return!(e?.value===void 0&&e?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,e){const l=this._iter.reset(u),n=[];let h=this._root;for(;h;){const s=l.cmp(h.segment);if(s>0)n.push([-1,h]),h=h.left;else if(s<0)n.push([1,h]),h=h.right;else if(l.hasNext())l.next(),n.push([0,h]),h=h.mid;else break}if(h){if(e?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const s=this._min(h.right);if(s.key){const{key:D,value:v,segment:A}=s;this._delete(s.key,!1),h.key=D,h.value=v,h.segment=A}}else{const s=h.left??h.right;if(n.length>0){const[D,v]=n[n.length-1];switch(D){case-1:v.left=s;break;case 0:v.mid=s;break;case 1:v.right=s;break}}else this._root=s}for(let s=n.length-1;s>=0;s--){const D=n[s][1];D.updateHeight();const v=D.balanceFactor();if(v>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),n[s][1]=D.rotateLeft()):v<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),n[s][1]=D.rotateRight()),s>0)switch(n[s-1][0]){case-1:n[s-1][1].left=n[s][1];break;case 1:n[s-1][1].right=n[s][1];break;case 0:n[s-1][1].mid=n[s][1];break}else this._root=n[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const e=this._iter.reset(u);let l=this._root,n;for(;l;){const h=e.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(e.hasNext())e.next(),n=l.value||n,l=l.mid;else break}return l&&l.value||n}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,e){const l=this._iter.reset(u);let n=this._root;for(;n;){const h=l.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(l.hasNext())l.next(),n=n.mid;else return n.mid?this._entries(n.mid):e?n.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[e,l]of this)u(l,e)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const e=[];return this._dfsEntries(u,e),e[Symbol.iterator]()}_dfsEntries(u,e){u&&(u.left&&this._dfsEntries(u.left,e),u.value&&e.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,e),u.right&&this._dfsEntries(u.right,e))}_isBalanced(){const u=e=>{if(!e)return!0;const l=e.balanceFactor();return l<-1||l>1?!1:u(e.left)&&u(e.right)};return u(this._root)}}t.TernarySearchTree=I}),define(ge[15],me([1,0,22,5]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,W=/^\//,w=/^\/\//;function y(k,m){if(!k.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${k.authority}", path: "${k.path}", query: "${k.query}", fragment: "${k.fragment}"}`);if(k.scheme&&!i.test(k.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(k.path){if(k.authority){if(!W.test(k.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(k.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(k,m){return!k&&!m?"file":k}function a(k,m){switch(k){case"https":case"http":case"file":m?m[0]!==I&&(m=I+m):m=I;break}return m}const d="",I="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(m){return m instanceof u?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,g,b,N,M,H=!1){typeof m=="object"?(this.scheme=m.scheme||d,this.authority=m.authority||d,this.path=m.path||d,this.query=m.query||d,this.fragment=m.fragment||d):(this.scheme=c(m,H),this.authority=g||d,this.path=a(this.scheme,b||d),this.query=N||d,this.fragment=M||d,y(this,H))}get fsPath(){return v(this,!1)}with(m){if(!m)return this;let{scheme:g,authority:b,path:N,query:M,fragment:H}=m;return g===void 0?g=this.scheme:g===null&&(g=d),b===void 0?b=this.authority:b===null&&(b=d),N===void 0?N=this.path:N===null&&(N=d),M===void 0?M=this.query:M===null&&(M=d),H===void 0?H=this.fragment:H===null&&(H=d),g===this.scheme&&b===this.authority&&N===this.path&&M===this.query&&H===this.fragment?this:new n(g,b,N,M,H)}static parse(m,g=!1){const b=r.exec(m);return b?new n(b[2]||d,O(b[4]||d),O(b[5]||d),O(b[7]||d),O(b[9]||d),g):new n(d,d,d,d,d)}static file(m){let g=d;if(L.isWindows&&(m=m.replace(/\\/g,I)),m[0]===I&&m[1]===I){const b=m.indexOf(I,2);b===-1?(g=m.substring(2),m=I):(g=m.substring(2,b),m=m.substring(b)||I)}return new n("file",g,m,d,d)}static from(m,g){return new n(m.scheme,m.authority,m.path,m.query,m.fragment,g)}static joinPath(m,...g){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return L.isWindows&&m.scheme==="file"?b=u.file(E.win32.join(v(m,!0),...g)).path:b=E.posix.join(m.path,...g),m.with({path:b})}toString(m=!1){return A(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof u)return m;{const g=new n(m);return g._formatted=m.external??null,g._fsPath=m._sep===l?m.fsPath??null:null,g}}else return m}}t.URI=u;function e(k){return!k||typeof k!="object"?!1:typeof k.scheme=="string"&&(typeof k.authority=="string"||typeof k.authority>"u")&&(typeof k.path=="string"||typeof k.path>"u")&&(typeof k.query=="string"||typeof k.query>"u")&&(typeof k.fragment=="string"||typeof k.fragment>"u")}t.isUriComponents=e;const l=L.isWindows?1:void 0;class n extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(m=!1){return m?A(this,!0):(this._formatted||(this._formatted=A(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=l),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(k,m,g){let b,N=-1;for(let M=0;M<k.length;M++){const H=k.charCodeAt(M);if(H>=97&&H<=122||H>=65&&H<=90||H>=48&&H<=57||H===45||H===46||H===95||H===126||m&&H===47||g&&H===91||g&&H===93||g&&H===58)N!==-1&&(b+=encodeURIComponent(k.substring(N,M)),N=-1),b!==void 0&&(b+=k.charAt(M));else{b===void 0&&(b=k.substr(0,M));const Z=h[H];Z!==void 0?(N!==-1&&(b+=encodeURIComponent(k.substring(N,M)),N=-1),b+=Z):N===-1&&(N=M)}}return N!==-1&&(b+=encodeURIComponent(k.substring(N))),b!==void 0?b:k}function D(k){let m;for(let g=0;g<k.length;g++){const b=k.charCodeAt(g);b===35||b===63?(m===void 0&&(m=k.substr(0,g)),m+=h[b]):m!==void 0&&(m+=k[g])}return m!==void 0?m:k}function v(k,m){let g;return k.authority&&k.path.length>1&&k.scheme==="file"?g=`//${k.authority}${k.path}`:k.path.charCodeAt(0)===47&&(k.path.charCodeAt(1)>=65&&k.path.charCodeAt(1)<=90||k.path.charCodeAt(1)>=97&&k.path.charCodeAt(1)<=122)&&k.path.charCodeAt(2)===58?m?g=k.path.substr(1):g=k.path[1].toLowerCase()+k.path.substr(2):g=k.path,L.isWindows&&(g=g.replace(/\//g,"\\")),g}t.uriToFsPath=v;function A(k,m){const g=m?D:s;let b="",{scheme:N,authority:M,path:H,query:Z,fragment:ne}=k;if(N&&(b+=N,b+=":"),(M||N==="file")&&(b+=I,b+=I),M){let se=M.indexOf("@");if(se!==-1){const he=M.substr(0,se);M=M.substr(se+1),se=he.lastIndexOf(":"),se===-1?b+=g(he,!1,!1):(b+=g(he.substr(0,se),!1,!1),b+=":",b+=g(he.substr(se+1),!1,!0)),b+="@"}M=M.toLowerCase(),se=M.lastIndexOf(":"),se===-1?b+=g(M,!1,!0):(b+=g(M.substr(0,se),!1,!0),b+=M.substr(se))}if(H){if(H.length>=3&&H.charCodeAt(0)===47&&H.charCodeAt(2)===58){const se=H.charCodeAt(1);se>=65&&se<=90&&(H=`/${String.fromCharCode(se+32)}:${H.substr(3)}`)}else if(H.length>=2&&H.charCodeAt(1)===58){const se=H.charCodeAt(0);se>=65&&se<=90&&(H=`${String.fromCharCode(se+32)}:${H.substr(2)}`)}b+=g(H,!0,!1)}return Z&&(b+="?",b+=g(Z,!1,!1)),ne&&(b+="#",b+=m?ne:s(ne,!1,!1)),b}function f(k){try{return decodeURIComponent(k)}catch{return k.length>3?k.substr(0,3)+f(k.substr(3)):k}}const p=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(k){return k.match(p)?k.replace(p,m=>f(m)):k}}),define(ge[50],me([1,0,31,11,15]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function W(a){return JSON.stringify(a,y)}t.stringify=W;function w(a){let d=JSON.parse(a);return d=c(d),d}t.parse=w;function y(a,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:(0,L.regExpFlags)(d)}:d}function c(a,d=0){if(!a||d>200)return a;if(typeof a=="object"){switch(a.$mid){case 1:return i.URI.revive(a);case 2:return new RegExp(a.source,a.flags);case 16:return new Date(a.source)}if(a instanceof E.VSBuffer||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let I=0;I<a.length;++I)a[I]=c(a[I],d+1);else for(const I in a)Object.hasOwnProperty.call(a,I)&&(a[I]=c(a[I],d+1))}return a}t.revive=c}),define(ge[28],me([1,0,7,5,15]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractive="vscode-interactive",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(W||(t.Schemas=W={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}setServerRootPath(d){this._remoteResourcesPath=`${d}/${W.vscodeRemoteResource}`}set(d,I,r){this._hosts[d]=I,this._ports[d]=r}setConnectionToken(d,I){this._connectionTokens[d]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(d){if(this._delegate)try{return this._delegate(d)}catch(n){return E.onUnexpectedError(n),d}const I=d.authority;let r=this._hosts[I];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const u=this._ports[I],e=this._connectionTokens[I];let l=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(l+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:L.isWeb?this._preferredWebSchema:W.vscodeRemoteResource,authority:`${r}:${u}`,path:this._remoteResourcesPath,query:l})}}t.RemoteAuthorities=new w,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(d){const I=this.toUri(d,te);return this.uriToBrowserUri(I)}uriToBrowserUri(d){return d.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(d):d.scheme===W.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${W.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?d.with({scheme:W.vscodeFileResource,authority:d.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(d){const I=this.toUri(d,te);return this.uriToFileUri(I)}uriToFileUri(d){return d.scheme===W.vscodeFileResource?d.with({scheme:W.file,authority:d.authority!==y.FALLBACK_AUTHORITY?d.authority:null,query:null,fragment:null}):d}toUri(d,I){return i.URI.isUri(d)?d:i.URI.parse(I.toUrl(d))}}y.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new y;var c;(function(a){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(d.get("3"));const I="vscode-coi";function r(e){let l;typeof e=="string"?l=new URL(e).searchParams:e instanceof URL?l=e.searchParams:i.URI.isUri(e)&&(l=new URL(e.toString(!0)).searchParams);const n=l?.get(I);if(n)return d.get(n)}a.getHeadersFromQuery=r;function u(e,l,n){if(!globalThis.crossOriginIsolated)return;const h=l&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(I,h):e[I]=h}a.addSearchParam=u})(c||(t.COI=c={}))}),define(ge[35],me([1,0,110,28,22,5,11,15]),function(te,t,E,L,i,W,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function c(u){return(0,y.uriToFsPath)(u,!0)}t.originalFSPath=c;class a{constructor(e){this._ignorePathCasing=e}compare(e,l,n=!1){return e===l?0:(0,w.compare)(this.getComparisonKey(e,n),this.getComparisonKey(l,n))}isEqual(e,l,n=!1){return e===l?!0:!e||!l?!1:this.getComparisonKey(e,n)===this.getComparisonKey(l,n)}getComparisonKey(e,l=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,l,n=!1){if(e.scheme===l.scheme){if(e.scheme===L.Schemas.file)return E.isEqualOrParent(c(e),c(l),this._ignorePathCasing(e))&&e.query===l.query&&(n||e.fragment===l.fragment);if((0,t.isEqualAuthority)(e.authority,l.authority))return E.isEqualOrParent(e.path,l.path,this._ignorePathCasing(e),"/")&&e.query===l.query&&(n||e.fragment===l.fragment)}return!1}joinPath(e,...l){return y.URI.joinPath(e,...l)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let l;return e.scheme===L.Schemas.file?l=y.URI.file(i.dirname(c(e))).path:(l=i.posix.dirname(e.path),e.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),l="/")),e.with({path:l})}normalizePath(e){if(!e.path.length)return e;let l;return e.scheme===L.Schemas.file?l=y.URI.file(i.normalize(c(e))).path:l=i.posix.normalize(e.path),e.with({path:l})}relativePath(e,l){if(e.scheme!==l.scheme||!(0,t.isEqualAuthority)(e.authority,l.authority))return;if(e.scheme===L.Schemas.file){const s=i.relative(c(e),c(l));return W.isWindows?E.toSlashes(s):s}let n=e.path||"/";const h=l.path||"/";if(this._ignorePathCasing(e)){let s=0;for(const D=Math.min(n.length,h.length);s<D&&!(n.charCodeAt(s)!==h.charCodeAt(s)&&n.charAt(s).toLowerCase()!==h.charAt(s).toLowerCase());s++);n=h.substr(0,s)+n.substr(s)}return i.posix.relative(n,h)}resolvePath(e,l){if(e.scheme===L.Schemas.file){const n=y.URI.file(i.resolve(c(e),l));return e.with({authority:n.authority,path:n.path})}return l=E.toPosixPath(l),e.with({path:i.posix.resolve(e.path,l)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,l){return e===l||e!==void 0&&l!==void 0&&(0,w.equalsIgnoreCase)(e,l)}hasTrailingPathSeparator(e,l=i.sep){if(e.scheme===L.Schemas.file){const n=c(e);return n.length>E.getRoot(n).length&&n[n.length-1]===l}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,l=i.sep){return(0,t.hasTrailingPathSeparator)(e,l)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,l=i.sep){let n=!1;if(e.scheme===L.Schemas.file){const h=c(e);n=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===l}else{l="/";const h=e.path;n=h.length===1&&h.charCodeAt(h.length-1)===47}return!n&&!(0,t.hasTrailingPathSeparator)(e,l)?e.with({path:e.path+"/"}):e}}t.ExtUri=a,t.extUri=new a(()=>!1),t.extUriBiasedIgnorePathCase=new a(u=>u.scheme===L.Schemas.file?!W.isLinux:!0),t.extUriIgnorePathCase=new a(u=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function d(u,e){const l=[];for(let n=0;n<u.length;n++){const h=e(u[n]);u.some((s,D)=>D===n?!1:(0,t.isEqualOrParent)(h,e(s)))||l.push(u[n])}return l}t.distinctParents=d;var I;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function e(l){const n=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(D=>{const[v,A]=D.split(":");v&&A&&n.set(v,A)});const s=l.path.substring(0,l.path.indexOf(";"));return s&&n.set(u.META_DATA_MIME,s),n}u.parseMetaData=e})(I||(t.DataUri=I={}));function r(u,e,l){if(e){let n=u.path;return n&&n[0]!==i.posix.sep&&(n=i.posix.sep+n),u.with({scheme:l,authority:e,path:n})}return u.with({scheme:l})}t.toLocalResource=r}),define(ge[9],me([1,0,27,7,3,2,35,5,46]),function(te,t,E,L,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function a(z){return!!z&&typeof z.then=="function"}t.isThenable=a;function d(z){const o=new E.CancellationTokenSource,T=z(o.token),$=new Promise((Y,C)=>{const F=o.token.onCancellationRequested(()=>{F.dispose(),o.dispose(),C(new L.CancellationError)});Promise.resolve(T).then(R=>{F.dispose(),o.dispose(),Y(R)},R=>{F.dispose(),o.dispose(),C(R)})});return new class{cancel(){o.cancel()}then(Y,C){return $.then(Y,C)}catch(Y){return this.then(void 0,Y)}finally(Y){return $.finally(Y)}}}t.createCancelablePromise=d;function I(z,o,T){return new Promise(($,Y)=>{const C=o.onCancellationRequested(()=>{C.dispose(),$(T)});z.then($,Y).finally(()=>C.dispose())})}t.raceCancellation=I;function r(z,o){return new Promise((T,$)=>{const Y=o.onCancellationRequested(()=>{Y.dispose(),$(new L.CancellationError)});z.then(T,$).finally(()=>Y.dispose())})}t.raceCancellationError=r;async function u(z){let o=-1;const T=z.map(($,Y)=>$.then(C=>(o=Y,C)));try{return await Promise.race(T)}finally{z.forEach(($,Y)=>{Y!==o&&$.cancel()})}}t.raceCancellablePromises=u;function e(z,o,T){let $;const Y=setTimeout(()=>{$?.(void 0),T?.()},o);return Promise.race([z.finally(()=>clearTimeout(Y)),new Promise(C=>$=C)])}t.raceTimeout=e;function l(z){return new Promise((o,T)=>{const $=z();a($)?$.then(o,T):o($)})}t.asPromise=l;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(o){if(this.activePromise){if(this.queuedPromiseFactory=o,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(T,T).then($)})}return new Promise((T,$)=>{this.queuedPromise.then(T,$)})}return this.activePromise=o(),new Promise((T,$)=>{this.activePromise.then(Y=>{this.activePromise=null,T(Y)},Y=>{this.activePromise=null,$(Y)})})}}t.Throttler=n;class h{constructor(){this.current=Promise.resolve(null)}queue(o){return this.current=this.current.then(()=>o(),()=>o())}}t.Sequencer=h;class s{constructor(){this.promiseMap=new Map}queue(o,T){const Y=(this.promiseMap.get(o)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(o)===Y&&this.promiseMap.delete(o)});return this.promiseMap.set(o,Y),Y}}t.SequencerByKey=s;const D=(z,o)=>{let T=!0;const $=setTimeout(()=>{T=!1,o()},z);return{isTriggered:()=>T,dispose:()=>{clearTimeout($),T=!1}}},v=z=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,z())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class A{constructor(o){this.defaultDelay=o,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(o,T=this.defaultDelay){this.task=o,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,C)=>{this.doResolve=Y,this.doReject=C}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}}));const $=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===c.MicrotaskDelay?v($):D(T,$),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=A;class f{constructor(o){this.delayer=new A(o),this.throttler=new n}trigger(o,T){return this.delayer.trigger(()=>this.throttler.queue(o),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=f;class p{constructor(){this._isOpen=!1,this._promise=new Promise((o,T)=>{this._completePromise=o})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=p;class O extends p{constructor(o){super(),this._timeout=setTimeout(()=>this.open(),o)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=O;function k(z,o){return o?new Promise((T,$)=>{const Y=setTimeout(()=>{C.dispose(),T()},z),C=o.onCancellationRequested(()=>{clearTimeout(Y),C.dispose(),$(new L.CancellationError)})}):d(T=>k(z,T))}t.timeout=k;function m(z,o=0){const T=setTimeout(z,o);return(0,W.toDisposable)(()=>clearTimeout(T))}t.disposableTimeout=m;function g(z){const o=[];let T=0;const $=z.length;function Y(){return T<$?z[T++]():null}function C(F){F!=null&&o.push(F);const R=Y();return R?R.then(C):Promise.resolve(o)}return Promise.resolve(null).then(C)}t.sequence=g;function b(z,o=$=>!!$,T=null){let $=0;const Y=z.length,C=()=>{if($>=Y)return Promise.resolve(T);const F=z[$++];return Promise.resolve(F()).then(S=>o(S)?Promise.resolve(S):C())};return C()}t.first=b;function N(z,o=$=>!!$,T=null){if(z.length===0)return Promise.resolve(T);let $=z.length;const Y=()=>{$=-1;for(const C of z)C.cancel?.()};return new Promise((C,F)=>{for(const R of z)R.then(S=>{--$>=0&&o(S)?(Y(),C(S)):$===0&&C(T)}).catch(S=>{--$>=0&&(Y(),F(S))})})}t.firstParallel=N;class M{constructor(o){this._size=0,this.maxDegreeOfParalellism=o,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new i.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(o){return this._size++,new Promise((T,$)=>{this.outstandingPromises.push({factory:o,c:T,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const o=this.outstandingPromises.shift();this.runningPromises++;const T=o.factory();T.then(o.c,o.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=M;class H extends M{constructor(){super(1)}}t.Queue=H;class Z{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const o=new U;return this.drainers.add(o),o.p}isDrained(){for(const[,o]of this.queues)if(o.size>0)return!1;return!0}queueFor(o,T=w.extUri){const $=T.getComparisonKey(o);let Y=this.queues.get($);return Y||(Y=new H,i.Event.once(Y.onDrained)(()=>{Y?.dispose(),this.queues.delete($),this.onDidQueueDrain()}),this.queues.set($,Y)),Y}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const o of this.drainers)o.complete();this.drainers.clear()}dispose(){for(const[,o]of this.queues)o.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=Z;class ne{constructor(o,T){this._token=-1,typeof o=="function"&&typeof T=="number"&&this.setIfNotSet(o,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(o,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,o()},T)}setIfNotSet(o,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,o()},T))}}t.TimeoutTimer=ne;class se{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(o,T){this.cancel(),this._token=setInterval(()=>{o()},T)}}t.IntervalTimer=se;class he{constructor(o,T){this.timeoutToken=-1,this.runner=o,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(o=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,o)}get delay(){return this.timeout}set delay(o){this.timeout=o}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=he;class ue{constructor(o,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=o,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(o=this.timeout){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(o/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ue;class le extends he{constructor(o,T){super(o,T),this.units=[]}work(o){this.units.push(o),this.isScheduled()||this.schedule()}doRun(){const o=this.units;this.units=[],this.runner?.(o)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=le;class oe extends W.Disposable{constructor(o,T){super(),this.options=o,this.handler=T,this.pendingWork=[],this.throttler=this._register(new W.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(o){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+o.length>this.options.maxBufferedWork)return!1}else if(this.pending+o.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of o)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new he(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=z=>{(0,y.setTimeout0)(()=>{if(o)return;const T=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:t.runWhenIdle=(z,o)=>{const T=requestIdleCallback(z,typeof o=="number"?{timeout:o}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(T))}}}}();class ye{constructor(o){this._didRun=!1,this._executor=()=>{try{this._value=o()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=ye;async function Te(z,o,T){let $;for(let Y=0;Y<T;Y++)try{return await z()}catch(C){$=C,await k(o)}throw $}t.retry=Te;class Oe{hasPending(o){return this._pending?typeof o=="number"?this._pending.taskId===o:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(o,T,$){return this._pending={taskId:o,cancel:()=>$?.(),promise:T},T.then(()=>this.donePending(o),()=>this.donePending(o)),T}donePending(o){this._pending&&o===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const o=this._next;this._next=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}setNext(o){if(this._next)this._next.run=o;else{let T,$;const Y=new Promise((C,F)=>{T=C,$=F});this._next={run:o,promise:Y,promiseResolve:T,promiseReject:$}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}t.TaskSequentializer=Oe;class ke{constructor(o,T=()=>Date.now()){this.interval=o,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const o=this.nowFn();return o-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=o,this.value=0),this.value++,this.value}}t.IntervalCounter=ke;var fe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(fe||(fe={}));class U{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((o,T)=>{this.completeCallback=o,this.errorCallback=T})}complete(o){return new Promise(T=>{this.completeCallback(o),this.outcome={outcome:0,value:o},T()})}error(o){return new Promise(T=>{this.errorCallback(o),this.outcome={outcome:1,value:o},T()})}cancel(){return this.error(new L.CancellationError)}}t.DeferredPromise=U;var ie;(function(z){async function o($){let Y;const C=await Promise.all($.map(F=>F.then(R=>R,R=>{Y||(Y=R)})));if(typeof Y<"u")throw Y;return C}z.settled=o;function T($){return new Promise(async(Y,C)=>{try{await $(Y,C)}catch(F){C(F)}})}z.withAsyncBody=T})(ie||(t.Promises=ie={}));var q;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(q||(q={}));class K{static fromArray(o){return new K(T=>{T.emitMany(o)})}static fromPromise(o){return new K(async T=>{T.emitMany(await o)})}static fromPromises(o){return new K(async T=>{await Promise.all(o.map(async $=>T.emitOne(await $)))})}static merge(o){return new K(async T=>{await Promise.all(o.map(async $=>{for await(const Y of $)T.emitOne(Y)}))})}constructor(o){this._state=0,this._results=[],this._error=null,this._onStateChanged=new i.Emitter,queueMicrotask(async()=>{const T={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(o(T)),this.resolve()}catch($){this.reject($)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(o<this._results.length)return{done:!1,value:this._results[o++]};if(this._state===1)return{done:!0,value:void 0};await i.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(o,T){return new K(async $=>{for await(const Y of o)$.emitOne(T(Y))})}map(o){return K.map(this,o)}static filter(o,T){return new K(async $=>{for await(const Y of o)T(Y)&&$.emitOne(Y)})}filter(o){return K.filter(this,o)}static coalesce(o){return K.filter(o,T=>!!T)}coalesce(){return K.coalesce(this)}static async toPromise(o){const T=[];for await(const $ of o)T.push($);return T}toPromise(){return K.toPromise(this)}emitOne(o){this._state===0&&(this._results.push(o),this._onStateChanged.fire())}emitMany(o){this._state===0&&(this._results=this._results.concat(o),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(o){this._state===0&&(this._state=2,this._error=o,this._onStateChanged.fire())}}t.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class _ extends K{constructor(o,T){super(T),this._source=o}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=_;function j(z){const o=new E.CancellationTokenSource,T=z(o.token);return new _(o,async $=>{const Y=o.token.onCancellationRequested(()=>{Y.dispose(),o.dispose(),$.reject(new L.CancellationError)});try{for await(const C of T){if(o.token.isCancellationRequested)return;$.emitOne(C)}Y.dispose(),o.dispose()}catch(C){Y.dispose(),o.dispose(),$.reject(C)}})}t.createCancelableAsyncIterable=j}),define(ge[4],me([1,0,18,108,14,21,9,7,3,114,2,28,5,6,15]),function(te,t,E,L,i,W,w,y,c,a,d,I,r,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.setVisibility=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function l(J){for(;J.firstChild;)J.firstChild.remove()}t.clearNode=l;function n(J){return J?.isConnected??!1}t.isInDOM=n;class h{constructor(Q,de,Ce,Fe){this._node=Q,this._type=de,this._handler=Ce,this._options=Fe||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function s(J,Q,de,Ce){return new h(J,Q,de,Ce)}t.addDisposableListener=s;function D(J){return function(Q){return J(new W.StandardMouseEvent(Q))}}function v(J){return function(Q){return J(new i.StandardKeyboardEvent(Q))}}const A=function(Q,de,Ce,Fe){let $e=Ce;return de==="click"||de==="mousedown"?$e=D(Ce):(de==="keydown"||de==="keypress"||de==="keyup")&&($e=v(Ce)),s(Q,de,$e,Fe)};t.addStandardDisposableListener=A;const f=function(Q,de,Ce){const Fe=D(de);return O(Q,Fe,Ce)};t.addStandardDisposableGenericMouseDownListener=f;const p=function(Q,de,Ce){const Fe=D(de);return m(Q,Fe,Ce)};t.addStandardDisposableGenericMouseUpListener=p;function O(J,Q,de){return s(J,r.isIOS&&L.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Q,de)}t.addDisposableGenericMouseDownListener=O;function k(J,Q,de){return s(J,r.isIOS&&L.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Q,de)}t.addDisposableGenericMouseMoveListener=k;function m(J,Q,de){return s(J,r.isIOS&&L.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Q,de)}t.addDisposableGenericMouseUpListener=m;class g{constructor(Q,de=0){this._runner=Q,this.priority=de,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(Q){(0,y.onUnexpectedError)(Q)}}static sort(Q,de){return de.priority-Q.priority}}(function(){let J=[],Q=null,de=!1,Ce=!1;const Fe=()=>{for(de=!1,Q=J,J=[],Ce=!0;Q.length>0;)Q.sort(g.sort),Q.shift().execute();Ce=!1};t.scheduleAtNextAnimationFrame=($e,ze=0)=>{const Ye=new g($e,ze);return J.push(Ye),de||(de=!0,requestAnimationFrame(Fe)),Ye},t.runAtThisOrScheduleAtNextAnimationFrame=($e,ze)=>{if(Ce){const Ye=new g($e,ze);return Q.push(Ye),Ye}else return(0,t.scheduleAtNextAnimationFrame)($e,ze)}})();function b(J){return(0,t.scheduleAtNextAnimationFrame)(J,1e4)}t.measure=b;function N(J){return(0,t.scheduleAtNextAnimationFrame)(J,-1e4)}t.modify=N;const M=8,H=function(J,Q){return Q};class Z extends d.Disposable{constructor(Q,de,Ce,Fe=H,$e=M){super();let ze=null,Ye=0;const nt=this._register(new w.TimeoutTimer),je=()=>{Ye=new Date().getTime(),Ce(ze),ze=null};this._register(s(Q,de,vt=>{ze=Fe(ze,vt);const Et=new Date().getTime()-Ye;Et>=$e?(nt.cancel(),je()):nt.setIfNotSet(je,$e-Et)}))}}function ne(J,Q,de,Ce,Fe){return new Z(J,Q,de,Ce,Fe)}t.addDisposableThrottledListener=ne;function se(J){return document.defaultView.getComputedStyle(J,null)}t.getComputedStyle=se;function he(J){if(J!==document.body)return new le(J.clientWidth,J.clientHeight);if(r.isIOS&&window.visualViewport)return new le(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new le(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new le(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new le(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=he;class ue{static convertToPixels(Q,de){return parseFloat(de)||0}static getDimension(Q,de,Ce){const Fe=se(Q),$e=Fe?Fe.getPropertyValue(de):"0";return ue.convertToPixels(Q,$e)}static getBorderLeftWidth(Q){return ue.getDimension(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return ue.getDimension(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return ue.getDimension(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return ue.getDimension(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return ue.getDimension(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return ue.getDimension(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return ue.getDimension(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return ue.getDimension(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return ue.getDimension(Q,"margin-left","marginLeft")}static getMarginTop(Q){return ue.getDimension(Q,"margin-top","marginTop")}static getMarginRight(Q){return ue.getDimension(Q,"margin-right","marginRight")}static getMarginBottom(Q){return ue.getDimension(Q,"margin-bottom","marginBottom")}}class le{constructor(Q,de){this.width=Q,this.height=de}with(Q=this.width,de=this.height){return Q!==this.width||de!==this.height?new le(Q,de):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof le?Q:new le(Q.width,Q.height)}static equals(Q,de){return Q===de?!0:!Q||!de?!1:Q.width===de.width&&Q.height===de.height}}t.Dimension=le,le.None=new le(0,0);function oe(J){let Q=J.offsetParent,de=J.offsetTop,Ce=J.offsetLeft;for(;(J=J.parentNode)!==null&&J!==document.body&&J!==document.documentElement;){de-=J.scrollTop;const Fe=R(J)?null:se(J);Fe&&(Ce-=Fe.direction!=="rtl"?J.scrollLeft:-J.scrollLeft),J===Q&&(Ce+=ue.getBorderLeftWidth(J),de+=ue.getBorderTopWidth(J),de+=J.offsetTop,Ce+=J.offsetLeft,Q=J.offsetParent)}return{left:Ce,top:de}}t.getTopLeftOffset=oe;function ye(J,Q,de){typeof Q=="number"&&(J.style.width=`${Q}px`),typeof de=="number"&&(J.style.height=`${de}px`)}t.size=ye;function Te(J,Q,de,Ce,Fe,$e="absolute"){typeof Q=="number"&&(J.style.top=`${Q}px`),typeof de=="number"&&(J.style.right=`${de}px`),typeof Ce=="number"&&(J.style.bottom=`${Ce}px`),typeof Fe=="number"&&(J.style.left=`${Fe}px`),J.style.position=$e}t.position=Te;function Oe(J){const Q=J.getBoundingClientRect();return{left:Q.left+window.scrollX,top:Q.top+window.scrollY,width:Q.width,height:Q.height}}t.getDomNodePagePosition=Oe;function ke(J){let Q=J,de=1;do{const Ce=se(Q).zoom;Ce!=null&&Ce!=="1"&&(de*=Ce),Q=Q.parentElement}while(Q!==null&&Q!==document.documentElement);return de}t.getDomNodeZoomLevel=ke;function fe(J){const Q=ue.getMarginLeft(J)+ue.getMarginRight(J);return J.offsetWidth+Q}t.getTotalWidth=fe;function U(J){const Q=ue.getBorderLeftWidth(J)+ue.getBorderRightWidth(J),de=ue.getPaddingLeft(J)+ue.getPaddingRight(J);return J.offsetWidth-Q-de}t.getContentWidth=U;function ie(J){const Q=ue.getMarginLeft(J)+ue.getMarginRight(J);return J.scrollWidth+Q}t.getTotalScrollWidth=ie;function q(J){const Q=ue.getBorderTopWidth(J)+ue.getBorderBottomWidth(J),de=ue.getPaddingTop(J)+ue.getPaddingBottom(J);return J.offsetHeight-Q-de}t.getContentHeight=q;function K(J){const Q=ue.getMarginTop(J)+ue.getMarginBottom(J);return J.offsetHeight+Q}t.getTotalHeight=K;function _(J,Q){if(J===null)return 0;const de=oe(J),Ce=oe(Q);return de.left-Ce.left}function j(J,Q){const de=Q.map(Fe=>Math.max(ie(Fe),fe(Fe))+_(Fe,J)||0);return Math.max(...de)}t.getLargestChildWidth=j;function z(J,Q){for(;J;){if(J===Q)return!0;J=J.parentNode}return!1}t.isAncestor=z;const o="parentFlowToElementId";function T(J,Q){J.dataset[o]=Q.id}t.setParentFlowTo=T;function $(J){const Q=J.dataset[o];return typeof Q=="string"?document.getElementById(Q):null}function Y(J,Q){let de=J;for(;de;){if(de===Q)return!0;if(de instanceof HTMLElement){const Ce=$(de);if(Ce){de=Ce;continue}}de=de.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function C(J,Q,de){for(;J&&J.nodeType===J.ELEMENT_NODE;){if(J.classList.contains(Q))return J;if(de){if(typeof de=="string"){if(J.classList.contains(de))return null}else if(J===de)return null}J=J.parentNode}return null}t.findParentWithClass=C;function F(J,Q,de){return!!C(J,Q,de)}t.hasParentWithClass=F;function R(J){return J&&!!J.host&&!!J.mode}t.isShadowRoot=R;function S(J){return!!x(J)}t.isInShadowDOM=S;function x(J){for(;J.parentNode;){if(J===document.body)return null;J=J.parentNode}return R(J)?J:null}t.getShadowRoot=x;function B(){let J=document.activeElement;for(;J?.shadowRoot;)J=J.shadowRoot.activeElement;return J}t.getActiveElement=B;function P(J=document.getElementsByTagName("head")[0],Q){const de=document.createElement("style");return de.type="text/css",de.media="screen",Q?.(de),J.appendChild(de),de}t.createStyleSheet=P;function V(J=document.getElementsByTagName("head")[0]){const Q=document.createElement("meta");return J.appendChild(Q),Q}t.createMetaElement=V;let G=null;function ee(){return G||(G=P()),G}function re(J){return J?.sheet?.rules?J.sheet.rules:J?.sheet?.cssRules?J.sheet.cssRules:[]}function be(J,Q,de=ee()){!de||!Q||de.sheet.insertRule(J+"{"+Q+"}",0)}t.createCSSRule=be;function De(J,Q=ee()){if(!Q)return;const de=re(Q),Ce=[];for(let Fe=0;Fe<de.length;Fe++)de[Fe].selectorText.indexOf(J)!==-1&&Ce.push(Fe);for(let Fe=Ce.length-1;Fe>=0;Fe--)Q.sheet.deleteRule(Ce[Fe])}t.removeCSSRulesContainingSelector=De;function Ie(J){return typeof HTMLElement=="object"?J instanceof HTMLElement:J&&typeof J=="object"&&J.nodeType===1&&typeof J.nodeName=="string"}t.isHTMLElement=Ie,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"};function Se(J){const Q=J;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.isEventLike=Se,t.EventHelper={stop:(J,Q)=>(J.preventDefault(),Q&&J.stopPropagation(),J)};function ve(J){const Q=[];for(let de=0;J&&J.nodeType===J.ELEMENT_NODE;de++)Q[de]=J.scrollTop,J=J.parentNode;return Q}t.saveParentsScrollTop=ve;function Pe(J,Q){for(let de=0;J&&J.nodeType===J.ELEMENT_NODE;de++)J.scrollTop!==Q[de]&&(J.scrollTop=Q[de]),J=J.parentNode}t.restoreParentsScrollTop=Pe;class Le extends d.Disposable{static hasFocusWithin(Q){const de=x(Q),Ce=de?de.activeElement:document.activeElement;return z(Ce,Q)}constructor(Q){super(),this._onDidFocus=this._register(new c.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new c.Emitter),this.onDidBlur=this._onDidBlur.event;let de=Le.hasFocusWithin(Q),Ce=!1;const Fe=()=>{Ce=!1,de||(de=!0,this._onDidFocus.fire())},$e=()=>{de&&(Ce=!0,window.setTimeout(()=>{Ce&&(Ce=!1,de=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Le.hasFocusWithin(Q)!==de&&(de?$e():Fe())},this._register(s(Q,t.EventType.FOCUS,Fe,!0)),this._register(s(Q,t.EventType.BLUR,$e,!0)),this._register(s(Q,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(s(Q,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}refreshState(){this._refreshStateHandler()}}function Ke(J){return new Le(J)}t.trackFocus=Ke;function xe(J,Q){return J.after(Q),Q}t.after=xe;function We(J,...Q){if(J.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.append=We;function Je(J,Q){return J.insertBefore(Q,J.firstChild),Q}t.prepend=Je;function it(J,...Q){J.innerText="",We(J,...Q)}t.reset=it;const Me=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ve;(function(J){J.HTML="http://www.w3.org/1999/xhtml",J.SVG="http://www.w3.org/2000/svg"})(Ve||(t.Namespace=Ve={}));function X(J,Q,de,...Ce){const Fe=Me.exec(Q);if(!Fe)throw new Error("Bad use of emmet");const $e=Fe[1]||"div";let ze;return J!==Ve.HTML?ze=document.createElementNS(J,$e):ze=document.createElement($e),Fe[3]&&(ze.id=Fe[3]),Fe[4]&&(ze.className=Fe[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Ye,nt])=>{typeof nt>"u"||(/^on\w+$/.test(Ye)?ze[Ye]=nt:Ye==="selected"?nt&&ze.setAttribute(Ye,"true"):ze.setAttribute(Ye,nt))}),ze.append(...Ce),ze}function ae(J,Q,...de){return X(Ve.HTML,J,Q,...de)}t.$=ae,ae.SVG=function(J,Q,...de){return X(Ve.SVG,J,Q,...de)};function pe(J,Q){const de=[];return J.forEach((Ce,Fe)=>{Fe>0&&(Q instanceof Node?de.push(Q.cloneNode()):de.push(document.createTextNode(Q))),de.push(Ce)}),de}t.join=pe;function we(J,...Q){J?_e(...Q):Re(...Q)}t.setVisibility=we;function _e(...J){for(const Q of J)Q.style.display="",Q.removeAttribute("aria-hidden")}t.show=_e;function Re(...J){for(const Q of J)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.hide=Re;function Ue(J,Q){for(;J&&J.nodeType===J.ELEMENT_NODE;){if(J instanceof HTMLElement&&J.hasAttribute(Q))return J;J=J.parentNode}return null}function Ge(J){!J||!J.hasAttribute("tabIndex")||(document.activeElement===J&&Ue(J.parentElement,"tabIndex")?.focus(),J.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ge;function et(J){return Q=>{Q.preventDefault(),Q.stopPropagation(),J(Q)}}t.finalHandler=et;function Ae(){return new Promise(J=>{document.readyState==="complete"||document&&document.body!==null?J(void 0):window.addEventListener("DOMContentLoaded",J,!1)})}t.domContentLoaded=Ae;function ce(J){const Q=window.devicePixelRatio*J;return Math.max(1,Math.floor(Q))/window.devicePixelRatio}t.computeScreenAwareSize=ce;function Ee(J){window.open(J,"_blank","noopener")}t.windowOpenNoOpener=Ee;const Ne=780,He=640;function Xe(J){const Q=Math.floor(window.screenLeft+window.innerWidth/2-Ne/2),de=Math.floor(window.screenTop+window.innerHeight/2-He/2);window.open(J,"_blank",`width=${Ne},height=${He},top=${de},left=${Q}`)}t.windowOpenPopup=Xe;function Ze(J,Q=!0){const de=window.open();return de?(Q&&(de.opener=null),de.location.href=J,!0):!1}t.windowOpenWithSuccess=Ze;function Qe(J){const Q=()=>{J(),de=(0,t.scheduleAtNextAnimationFrame)(Q)};let de=(0,t.scheduleAtNextAnimationFrame)(Q);return(0,d.toDisposable)(()=>de.dispose())}t.animate=Qe,I.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function rt(J){return J?`url('${I.FileAccess.uriToBrowserUri(J).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=rt;function dt(J){return`'${J.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=dt;function pt(J,Q){if(J!==void 0){const de=J.match(/^\s*var\((.+)\)$/);if(de){const Ce=de[1].split(",",2);return Ce.length===2&&(Q=pt(Ce[1].trim(),Q)),`var(${Ce[0]}, ${Q})`}return J}return Q}t.asCssValueWithDefault=pt;function Ft(J,Q){let de;if(e.URI.isUri(J))de=J.toString(!0);else{const Fe=new Blob([J]);de=URL.createObjectURL(Fe),setTimeout(()=>URL.revokeObjectURL(de))}const Ce=document.createElement("a");document.body.appendChild(Ce),Ce.download=Q,Ce.href=de,Ce.click(),setTimeout(()=>document.body.removeChild(Ce))}t.triggerDownload=Ft;function Wt(){return new Promise(J=>{const Q=document.createElement("input");document.body.appendChild(Q),Q.type="file",Q.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(Q,"input"))(()=>{J((0,u.withNullAsUndefined)(Q.files))}),Q.click(),setTimeout(()=>document.body.removeChild(Q))})}t.triggerUpload=Wt;var bt;(function(J){J[J.DOCUMENT=1]="DOCUMENT",J[J.BROWSER=2]="BROWSER"})(bt||(t.DetectedFullscreenMode=bt={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:bt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:bt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:bt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function zt(J,Q=!1){const de=document.createElement("a");return a.addHook("afterSanitizeAttributes",Ce=>{for(const Fe of["href","src"])if(Ce.hasAttribute(Fe)){const $e=Ce.getAttribute(Fe);if(Fe==="href"&&$e.startsWith("#"))continue;if(de.href=$e,!J.includes(de.protocol.replace(/:$/,""))){if(Q&&Fe==="src"&&de.href.startsWith("data:"))continue;Ce.removeAttribute(Fe)}}}),(0,d.toDisposable)(()=>{a.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=zt;const fi=[I.Schemas.http,I.Schemas.https,I.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function mi(J,Q){const de=zt(fi);try{const Ce=a.sanitize(Q,gi);J.innerHTML=Ce}finally{de.dispose()}}t.safeInnerHtml=mi;function pi(J){const Q=new Uint16Array(J.length);for(let Fe=0;Fe<Q.length;Fe++)Q[Fe]=J.charCodeAt(Fe);let de="";const Ce=new Uint8Array(Q.buffer);for(let Fe=0;Fe<Ce.length;Fe++)de+=String.fromCharCode(Ce[Fe]);return de}function bi(J){return btoa(pi(J))}t.multibyteAwareBtoa=bi;class ft extends c.Emitter{constructor(){super(),this._subscriptions=new d.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(s(window,"keydown",Q=>{if(Q.defaultPrevented)return;const de=new i.StandardKeyboardEvent(Q);if(!(de.keyCode===6&&Q.repeat)){if(Q.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(Q.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(Q.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(Q.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(de.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=Q.altKey,this._keyStatus.ctrlKey=Q.ctrlKey,this._keyStatus.metaKey=Q.metaKey,this._keyStatus.shiftKey=Q.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=Q,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(s(window,"keyup",Q=>{Q.defaultPrevented||(!Q.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!Q.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!Q.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!Q.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=Q.altKey,this._keyStatus.ctrlKey=Q.ctrlKey,this._keyStatus.metaKey=Q.metaKey,this._keyStatus.shiftKey=Q.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=Q,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(s(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(s(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(s(document.body,"mousemove",Q=>{Q.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function vi(J){const Q=document.cookie.match("(^|[^;]+)\\s*"+J+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.getCookieValue=vi;class Di extends d.Disposable{constructor(Q,de){super(),this.element=Q,this.callbacks=de,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(s(this.element,t.EventType.DRAG_ENTER,Q=>{this.counter++,this.dragStartTime=Q.timeStamp,this.callbacks.onDragEnter(Q)})),this._register(s(this.element,t.EventType.DRAG_OVER,Q=>{Q.preventDefault(),this.callbacks.onDragOver?.(Q,Q.timeStamp-this.dragStartTime)})),this._register(s(this.element,t.EventType.DRAG_LEAVE,Q=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(Q))})),this._register(s(this.element,t.EventType.DRAG_END,Q=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(Q)})),this._register(s(this.element,t.EventType.DROP,Q=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(Q)}))}}t.DragAndDropObserver=Di;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(J,...Q){let de,Ce;Array.isArray(Q[0])?(de={},Ce=Q[0]):(de=Q[0]||{},Ce=Q[1]);const Fe=wi.exec(J);if(!Fe||!Fe.groups)throw new Error("Bad use of h");const $e=Fe.groups.tag||"div",ze=document.createElement($e);Fe.groups.id&&(ze.id=Fe.groups.id);const Ye=[];if(Fe.groups.class)for(const je of Fe.groups.class.split("."))je!==""&&Ye.push(je);if(de.className!==void 0)for(const je of de.className.split("."))je!==""&&Ye.push(je);Ye.length>0&&(ze.className=Ye.join(" "));const nt={};if(Fe.groups.name&&(nt[Fe.groups.name]=ze),Ce)for(const je of Ce)je instanceof HTMLElement?ze.appendChild(je):typeof je=="string"?ze.append(je):"root"in je&&(Object.assign(nt,je),ze.appendChild(je.root));for(const[je,vt]of Object.entries(de))if(je!=="className")if(je==="style")for(const[Et,Lt]of Object.entries(vt))ze.style.setProperty(Ut(Et),typeof Lt=="number"?Lt+"px":""+Lt);else je==="tabIndex"?ze.tabIndex=vt:ze.setAttribute(Ut(je),vt.toString());return nt.root=ze,nt}t.h=yi;function Ut(J){return J.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[51],me([1,0,4,2,106]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class W extends L.Disposable{constructor(c,a){super(),this._register((0,E.addDisposableListener)(c,"dragover",d=>{d.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{a(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this._register((0,E.addDisposableListener)(c,d,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=W,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(y,c,a,d,I){const r=document.createElement("div");r.className=a,r.textContent=c,I&&(r.style.color=I),d&&(r.style.background=d),y.dataTransfer&&(document.body.appendChild(r),y.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=w}),define(ge[52],me([1,0,4]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function L(r,u={}){const e=W(u);return e.textContent=r,e}t.renderText=L;function i(r,u={}){const e=W(u);return c(e,a(r,!!u.renderCodeSegments),u.actionHandler,u.renderCodeSegments),e}t.renderFormattedText=i;function W(r){const u=r.inline?"span":"div",e=document.createElement(u);return r.className&&(e.className=r.className),e}t.createElement=W;class w{constructor(u){this.source=u,this.index=0}eos(){return this.index>=this.source.length}next(){const u=this.peek();return this.advance(),u}peek(){return this.source[this.index]}advance(){this.index++}}var y;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(y||(y={}));function c(r,u,e,l){let n;if(u.type===2)n=document.createTextNode(u.content||"");else if(u.type===3)n=document.createElement("b");else if(u.type===4)n=document.createElement("i");else if(u.type===7&&l)n=document.createElement("code");else if(u.type===5&&e){const h=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(h,"click",s=>{e.callback(String(u.index),s)})),n=h}else u.type===8?n=document.createElement("br"):u.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(u.children)&&u.children.forEach(h=>{c(n,h,e,l)})}function a(r,u){const e={type:1,children:[]};let l=0,n=e;const h=[],s=new w(r);for(;!s.eos();){let D=s.next();const v=D==="\\"&&I(s.peek(),u)!==0;if(v&&(D=s.next()),!v&&d(D,u)&&D===s.peek()){s.advance(),n.type===2&&(n=h.pop());const A=I(D,u);if(n.type===A||n.type===5&&A===6)n=h.pop();else{const f={type:A,children:[]};A===5&&(f.index=l,l++),n.children.push(f),h.push(n),n=f}}else if(D===`
`)n.type===2&&(n=h.pop()),n.children.push({type:8});else if(n.type!==2){const A={type:2,content:D};n.children.push(A),h.push(n),n=A}else n.content+=D}return n.type===2&&(n=h.pop()),h.length,e}function d(r,u){return I(r,u)!==0}function I(r,u){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return u?7:0;default:return 0}}}),define(ge[53],me([1,0,4,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this._hooks=new L.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(w,y){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const c=this._onStopCallback;this._onStopCallback=null,w&&c&&c(y)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(w,y,c,a,d){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=a,this._onStopCallback=d;let I=w;try{w.setPointerCapture(y),this._hooks.add((0,L.toDisposable)(()=>{try{w.releasePointerCapture(y)}catch{}}))}catch{I=window}this._hooks.add(E.addDisposableListener(I,E.EventType.POINTER_MOVE,r=>{if(r.buttons!==c){this.stopMonitoring(!0);return}r.preventDefault(),this._pointerMoveCallback(r)})),this._hooks.add(E.addDisposableListener(I,E.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var qe=this&&this.__decorate||function(te,t,E,L){var i=arguments.length,W=i<3?t:L===null?L=Object.getOwnPropertyDescriptor(t,E):L,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(te,t,E,L);else for(var y=te.length-1;y>=0;y--)(w=te[y])&&(W=(i<3?w(W):i>3?w(t,E,W):w(t,E))||W);return i>3&&W&&Object.defineProperty(t,E,W),W};define(ge[23],me([1,0,4,13,25,2,43]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var y;(function(a){a.Tap="-monaco-gesturetap",a.Change="-monaco-gesturechange",a.Start="-monaco-gesturestart",a.End="-monaco-gesturesend",a.Contextmenu="-monaco-gesturecontextmenu"})(y||(t.EventType=y={}));class c extends W.Disposable{constructor(){super(),this.dispatched=!1,this.targets=new w.LinkedList,this.ignoreTargets=new w.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(E.addDisposableListener(document,"touchstart",d=>this.onTouchStart(d),{passive:!1})),this._register(E.addDisposableListener(document,"touchend",d=>this.onTouchEnd(d))),this._register(E.addDisposableListener(document,"touchmove",d=>this.onTouchMove(d),{passive:!1}))}static addTarget(d){if(!c.isTouchDevice())return W.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const I=c.INSTANCE.targets.push(d);return(0,W.toDisposable)(I)}static ignoreTarget(d){if(!c.isTouchDevice())return W.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const I=c.INSTANCE.ignoreTargets.push(d);return(0,W.toDisposable)(I)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(d){const I=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let r=0,u=d.targetTouches.length;r<u;r++){const e=d.targetTouches.item(r);this.activeTouches[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:I,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[I],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const l=this.newGestureEvent(y.Start,e.target);l.pageX=e.pageX,l.pageY=e.pageY,this.dispatchEvent(l)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}onTouchEnd(d){const I=Date.now(),r=Object.keys(this.activeTouches).length;for(let u=0,e=d.changedTouches.length;u<e;u++){const l=d.changedTouches.item(u);if(!this.activeTouches.hasOwnProperty(String(l.identifier))){console.warn("move of an UNKNOWN touch",l);continue}const n=this.activeTouches[l.identifier],h=Date.now()-n.initialTimeStamp;if(h<c.HOLD_DELAY&&Math.abs(n.initialPageX-L.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-L.tail(n.rollingPageY))<30){const s=this.newGestureEvent(y.Tap,n.initialTarget);s.pageX=L.tail(n.rollingPageX),s.pageY=L.tail(n.rollingPageY),this.dispatchEvent(s)}else if(h>=c.HOLD_DELAY&&Math.abs(n.initialPageX-L.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-L.tail(n.rollingPageY))<30){const s=this.newGestureEvent(y.Contextmenu,n.initialTarget);s.pageX=L.tail(n.rollingPageX),s.pageY=L.tail(n.rollingPageY),this.dispatchEvent(s)}else if(r===1){const s=L.tail(n.rollingPageX),D=L.tail(n.rollingPageY),v=L.tail(n.rollingTimestamps)-n.rollingTimestamps[0],A=s-n.rollingPageX[0],f=D-n.rollingPageY[0],p=[...this.targets].filter(O=>n.initialTarget instanceof Node&&O.contains(n.initialTarget));this.inertia(p,I,Math.abs(A)/v,A>0?1:-1,s,Math.abs(f)/v,f>0?1:-1,D)}this.dispatchEvent(this.newGestureEvent(y.End,n.initialTarget)),delete this.activeTouches[l.identifier]}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}newGestureEvent(d,I){const r=document.createEvent("CustomEvent");return r.initEvent(d,!1,!0),r.initialTarget=I,r.tapCount=0,r}dispatchEvent(d){if(d.type===y.Tap){const I=new Date().getTime();let r=0;I-this._lastSetTapCountTime>c.CLEAR_TAP_COUNT_TIME?r=1:r=2,this._lastSetTapCountTime=I,d.tapCount=r}else(d.type===y.Change||d.type===y.Contextmenu)&&(this._lastSetTapCountTime=0);if(d.initialTarget instanceof Node){for(const I of this.ignoreTargets)if(I.contains(d.initialTarget))return;for(const I of this.targets)I.contains(d.initialTarget)&&(I.dispatchEvent(d),this.dispatched=!0)}}inertia(d,I,r,u,e,l,n,h){this.handle=E.scheduleAtNextAnimationFrame(()=>{const s=Date.now(),D=s-I;let v=0,A=0,f=!0;r+=c.SCROLL_FRICTION*D,l+=c.SCROLL_FRICTION*D,r>0&&(f=!1,v=u*r*D),l>0&&(f=!1,A=n*l*D);const p=this.newGestureEvent(y.Change);p.translationX=v,p.translationY=A,d.forEach(O=>O.dispatchEvent(p)),f||this.inertia(d,s,r,u,e+v,l,n,h+A)})}onTouchMove(d){const I=Date.now();for(let r=0,u=d.changedTouches.length;r<u;r++){const e=d.changedTouches.item(r);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const l=this.activeTouches[e.identifier],n=this.newGestureEvent(y.Change,l.initialTarget);n.translationX=e.pageX-L.tail(l.rollingPageX),n.translationY=e.pageY-L.tail(l.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.dispatchEvent(n),l.rollingPageX.length>3&&(l.rollingPageX.shift(),l.rollingPageY.shift(),l.rollingTimestamps.shift()),l.rollingPageX.push(e.pageX),l.rollingPageY.push(e.pageY),l.rollingTimestamps.push(I)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}}t.Gesture=c,c.SCROLL_FRICTION=-.005,c.HOLD_DELAY=700,c.CLEAR_TAP_COUNT_TIME=400,qe([i.memoize],c,"isTouchDevice",null)}),define(ge[54],me([1,0,4,5,83]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const i=2e4;let W,w,y,c,a;function d(e){W=document.createElement("div"),W.className="monaco-aria-container";const l=()=>{const h=document.createElement("div");return h.className="monaco-alert",h.setAttribute("role","alert"),h.setAttribute("aria-atomic","true"),W.appendChild(h),h};w=l(),y=l();const n=()=>{const h=document.createElement("div");return h.className="monaco-status",h.setAttribute("role","complementary"),h.setAttribute("aria-live","polite"),h.setAttribute("aria-atomic","true"),W.appendChild(h),h};c=n(),a=n(),e.appendChild(W)}t.setARIAContainer=d;function I(e){W&&(w.textContent!==e?(E.clearNode(y),u(w,e)):(E.clearNode(w),u(y,e)))}t.alert=I;function r(e){W&&(L.isMacintosh?I(e):c.textContent!==e?(E.clearNode(a),u(c,e)):(E.clearNode(c),u(a,e)))}t.status=r;function u(e,l){E.clearNode(e),l.length>i&&(l=l.substr(0,i)),e.textContent=l,e.style.visibility="hidden",e.style.visibility="visible"}}),define(ge[115],me([1,0,4,17]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(y){const c=new Array;let a,d=0,I=0;for(;(a=i.exec(y))!==null;){I=a.index||0,d<I&&c.push(y.substring(d,I)),d=(a.index||0)+a[0].length;const[,r,u]=a;c.push(r?`$(${u})`:w({id:u}))}return d<y.length&&c.push(y.substring(d)),c}t.renderLabelWithIcons=W;function w(y){const c=E.$("span");return c.classList.add(...L.ThemeIcon.asClassNameArray(y)),c}t.renderIcon=w}),define(ge[116],me([1,0,4]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function L(W){try{W.parentElement?.removeChild(W)}catch{}}class i{constructor(w){this.renderers=w,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(w){let y=this.getTemplateCache(w).pop(),c=!1;if(y)c=this.transactionNodesPendingRemoval.has(y.domNode),c&&this.transactionNodesPendingRemoval.delete(y.domNode);else{const a=(0,E.$)(".monaco-list-row"),I=this.getRenderer(w).renderTemplate(a);y={domNode:a,templateId:w,templateData:I}}return{row:y,isReusingConnectedDomNode:c}}release(w){w&&this.releaseRow(w)}transact(w){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{w()}finally{for(const y of this.transactionNodesPendingRemoval)this.doRemoveNode(y);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(w){const{domNode:y,templateId:c}=w;y&&(this.inTransaction?this.transactionNodesPendingRemoval.add(y):this.doRemoveNode(y)),this.getTemplateCache(c).push(w)}doRemoveNode(w){w.classList.remove("scrolling"),L(w)}getTemplateCache(w){let y=this.cache.get(w);return y||(y=[],this.cache.set(w,y)),y}dispose(){this.cache.forEach((w,y)=>{for(const c of w)this.getRenderer(y).disposeTemplate(c.templateData),c.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(w){const y=this.renderers.get(w);if(!y)throw new Error(`No renderer found for ${w}`);return y}}t.RowCache=i}),define(ge[117],me([1,0,9,2]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends L.Disposable{constructor(w,y,c){super(),this._visibility=w,this._visibleClassName=y,this._invisibleClassName=c,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new E.TimeoutTimer)}setVisibility(w){this._visibility!==w&&(this._visibility=w,this._updateShouldBeVisible())}setShouldBeVisible(w){this._rawShouldBeVisible=w,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const w=this._applyVisibilitySetting();this._shouldBeVisible!==w&&(this._shouldBeVisible=w,this.ensureVisibility())}setIsNeeded(w){this._isNeeded!==w&&(this._isNeeded=w,this.ensureVisibility())}setDomNode(w){this._domNode=w,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(w){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(w?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(ge[118],me([1,0,4,23,13,3,2,5]),function(te,t,E,L,i,W,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class c extends w.Disposable{constructor(d,I,r,u){super(),this.selected=0,this.selectBoxOptions=u||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new W.Emitter),this.styles=r,this.registerListeners(),this.setOptions(d,I)}registerListeners(){this._register(L.Gesture.addTarget(this.selectElement)),[L.EventType.Tap].forEach(d=>{this._register(E.addDisposableListener(this.selectElement,d,I=>{this.selectElement.focus()}))}),this._register(E.addStandardDisposableListener(this.selectElement,"click",d=>{E.EventHelper.stop(d,!0)})),this._register(E.addStandardDisposableListener(this.selectElement,"change",d=>{this.selectElement.title=d.target.value,this._onDidSelect.fire({index:d.target.selectedIndex,selected:d.target.value})})),this._register(E.addStandardDisposableListener(this.selectElement,"keydown",d=>{let I=!1;y.isMacintosh?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(I=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(I=!0),I&&d.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(d,I){(!this.options||!i.equals(this.options,d))&&(this.options=d,this.selectElement.options.length=0,this.options.forEach((r,u)=>{this.selectElement.add(this.createOption(r.text,u,r.isDisabled))})),I!==void 0&&this.select(I)}select(d){this.options.length===0?this.selected=0:d>=0&&d<this.options.length?this.selected=d:d>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(d){this.selectBoxOptions.ariaLabel=d,this.selectElement.setAttribute("aria-label",d)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(d){this.selectElement.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(d){this.styles=d,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(d,I,r){const u=document.createElement("option");return u.value=d,u.text=d,u.disabled=!!r,u}}t.SelectBoxNative=c}),define(ge[55],me([1,0,24,13,9,46,112,3,26]),function(te,t,E,L,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function a(u){return typeof u=="object"&&"visibility"in u&&"data"in u}t.isFilterResult=a;function d(u){switch(u){case!0:return 1;case!1:return 0;default:return u}}t.getVisibleState=d;function I(u){return typeof u.collapsible=="boolean"}class r{constructor(e,l,n,h={}){this.user=e,this.list=l,this.rootRef=[],this.eventBufferer=new y.EventBufferer,this._onDidChangeCollapseState=new y.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new y.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new y.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new i.Delayer(W.MicrotaskDelay),this.collapseByDefault=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.filter=h.filter,this.autoExpandSingleChildren=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.root={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,l,n=c.Iterable.empty(),h={}){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");h.diffIdentityProvider?this.spliceSmart(h.diffIdentityProvider,e,l,n,h):this.spliceSimple(e,l,n,h)}spliceSmart(e,l,n,h=c.Iterable.empty(),s,D=s.diffDepth??0){const{parentNode:v}=this.getParentNodeWithListIndex(l);if(!v.lastDiffIds)return this.spliceSimple(l,n,h,s);const A=[...h],f=l[l.length-1],p=new w.LcsDiff({getElements:()=>v.lastDiffIds},{getElements:()=>[...v.children.slice(0,f),...A,...v.children.slice(f+n)].map(b=>e.getId(b.element).toString())}).ComputeDiff(!1);if(p.quitEarly)return v.lastDiffIds=void 0,this.spliceSimple(l,n,A,s);const O=l.slice(0,-1),k=(b,N,M)=>{if(D>0)for(let H=0;H<M;H++)b--,N--,this.spliceSmart(e,[...O,b,0],Number.MAX_SAFE_INTEGER,A[N].children,s,D-1)};let m=Math.min(v.children.length,f+n),g=A.length;for(const b of p.changes.sort((N,M)=>M.originalStart-N.originalStart))k(m,g,m-(b.originalStart+b.originalLength)),m=b.originalStart,g=b.modifiedStart-f,this.spliceSimple([...O,m],b.originalLength,c.Iterable.slice(A,g,g+b.modifiedLength),s);k(m,g,m)}spliceSimple(e,l,n=c.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:s,diffIdentityProvider:D}){const{parentNode:v,listIndex:A,revealed:f,visible:p}=this.getParentNodeWithListIndex(e),O=[],k=c.Iterable.map(n,ue=>this.createTreeNode(ue,v,v.visible?1:0,f,O,h)),m=e[e.length-1],g=v.children.length>0;let b=0;for(let ue=m;ue>=0&&ue<v.children.length;ue--){const le=v.children[ue];if(le.visible){b=le.visibleChildIndex;break}}const N=[];let M=0,H=0;for(const ue of k)N.push(ue),H+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=b+M++);const Z=(0,L.splice)(v.children,m,l,N);D?v.lastDiffIds?(0,L.splice)(v.lastDiffIds,m,l,N.map(ue=>D.getId(ue.element).toString())):v.lastDiffIds=v.children.map(ue=>D.getId(ue.element).toString()):v.lastDiffIds=void 0;let ne=0;for(const ue of Z)ue.visible&&ne++;if(ne!==0)for(let ue=m+N.length;ue<v.children.length;ue++){const le=v.children[ue];le.visible&&(le.visibleChildIndex-=ne)}if(v.visibleChildrenCount+=M-ne,f&&p){const ue=Z.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(v,H-ue),this.list.splice(A,ue,O)}if(Z.length>0&&s){const ue=le=>{s(le),le.children.forEach(ue)};Z.forEach(ue)}this._onDidSplice.fire({insertedNodes:N,deletedNodes:Z});const se=v.children.length>0;g!==se&&this.setCollapsible(e.slice(0,-1),se);let he=v;for(;he;){if(he.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}he=he.parent}}rerender(e){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{node:l,listIndex:n,revealed:h}=this.getTreeNodeWithListIndex(e);l.visible&&h&&this.list.splice(n,1,[l])}updateElementHeight(e,l){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{listIndex:n}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(n,l)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:l,visible:n,revealed:h}=this.getTreeNodeWithListIndex(e);return n&&h?l:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,l){const n=this.getTreeNode(e);typeof l>"u"&&(l=!n.collapsible);const h={collapsible:l};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,h))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,l,n){const h=this.getTreeNode(e);typeof l>"u"&&(l=!h.collapsed);const s={collapsed:l,recursive:n||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,s))}_setCollapseState(e,l){const{node:n,listIndex:h,revealed:s}=this.getTreeNodeWithListIndex(e),D=this._setListNodeCollapseState(n,h,s,l);if(n!==this.root&&this.autoExpandSingleChildren&&D&&!I(l)&&n.collapsible&&!n.collapsed&&!l.recursive){let v=-1;for(let A=0;A<n.children.length;A++)if(n.children[A].visible)if(v>-1){v=-1;break}else v=A;v>-1&&this._setCollapseState([...e,v],l)}return D}_setListNodeCollapseState(e,l,n,h){const s=this._setNodeCollapseState(e,h,!1);if(!n||!e.visible||!s)return s;const D=e.renderNodeCount,v=this.updateNodeAfterCollapseChange(e),A=D-(l===-1?0:1);return this.list.splice(l+1,A,v.slice(1)),s}_setNodeCollapseState(e,l,n){let h;if(e===this.root?h=!1:(I(l)?(h=e.collapsible!==l.collapsible,e.collapsible=l.collapsible):e.collapsible?(h=e.collapsed!==l.collapsed,e.collapsed=l.collapsed):h=!1,h&&this._onDidChangeCollapseState.fire({node:e,deep:n})),!I(l)&&l.recursive)for(const s of e.children)h=this._setNodeCollapseState(s,l,!0)||h;return h}expandTo(e){this.eventBufferer.bufferEvents(()=>{let l=this.getTreeNode(e);for(;l.parent;)l=l.parent,e=e.slice(0,e.length-1),l.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,l=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,l),this.refilterDelayer.cancel()}createTreeNode(e,l,n,h,s,D){const v={parent:l,element:e.element,children:[],depth:l.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},A=this._filterNode(v,n);v.visibility=A,h&&s.push(v);const f=e.children||c.Iterable.empty(),p=h&&A!==0&&!v.collapsed;let O=0,k=1;for(const m of f){const g=this.createTreeNode(m,v,A,p,s,D);v.children.push(g),k+=g.renderNodeCount,g.visible&&(g.visibleChildIndex=O++)}return v.collapsible=v.collapsible||v.children.length>0,v.visibleChildrenCount=O,v.visible=A===2?O>0:A===1,v.visible?v.collapsed||(v.renderNodeCount=k):(v.renderNodeCount=0,h&&s.pop()),D?.(v),v}updateNodeAfterCollapseChange(e){const l=e.renderNodeCount,n=[];return this._updateNodeAfterCollapseChange(e,n),this._updateAncestorsRenderNodeCount(e.parent,n.length-l),n}_updateNodeAfterCollapseChange(e,l){if(e.visible===!1)return 0;if(l.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(n,l);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const l=e.renderNodeCount,n=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,n),this._updateAncestorsRenderNodeCount(e.parent,n.length-l),n}_updateNodeAfterFilterChange(e,l,n,h=!0){let s;if(e!==this.root){if(s=this._filterNode(e,l),s===0)return e.visible=!1,e.renderNodeCount=0,!1;h&&n.push(e)}const D=n.length;e.renderNodeCount=e===this.root?0:1;let v=!1;if(!e.collapsed||s!==0){let A=0;for(const f of e.children)v=this._updateNodeAfterFilterChange(f,s,n,h&&!e.collapsed)||v,f.visible&&(f.visibleChildIndex=A++);e.visibleChildrenCount=A}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=s===2?v:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=n.length-D):(e.renderNodeCount=0,h&&n.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,l){if(l!==0)for(;e;)e.renderNodeCount+=l,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,l){const n=this.filter?this.filter.filter(e.element,l):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):a(n)?(e.filterData=n.data,d(n.visibility)):(e.filterData=void 0,d(n))}hasTreeNode(e,l=this.root){if(!e||e.length===0)return!0;const[n,...h]=e;return n<0||n>l.children.length?!1:this.hasTreeNode(h,l.children[n])}getTreeNode(e,l=this.root){if(!e||e.length===0)return l;const[n,...h]=e;if(n<0||n>l.children.length)throw new E.TreeError(this.user,"Invalid tree location");return this.getTreeNode(h,l.children[n])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:l,listIndex:n,revealed:h,visible:s}=this.getParentNodeWithListIndex(e),D=e[e.length-1];if(D<0||D>l.children.length)throw new E.TreeError(this.user,"Invalid tree location");const v=l.children[D];return{node:v,listIndex:n,revealed:h,visible:s&&v.visible}}getParentNodeWithListIndex(e,l=this.root,n=0,h=!0,s=!0){const[D,...v]=e;if(D<0||D>l.children.length)throw new E.TreeError(this.user,"Invalid tree location");for(let A=0;A<D;A++)n+=l.children[A].renderNodeCount;return h=h&&!l.collapsed,s=s&&l.visible,v.length===0?{parentNode:l,listIndex:n,revealed:h,visible:s}:this.getParentNodeWithListIndex(v,l.children[D],n+1,h,s)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const l=[];let n=e;for(;n.parent;)l.push(n.parent.children.indexOf(n)),n=n.parent;return l.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,L.tail2)(e)[0]}getFirstElementChild(e){const l=this.getTreeNode(e);if(l.children.length!==0)return l.children[0].element}getLastElementAncestor(e=[]){const l=this.getTreeNode(e);if(l.children.length!==0)return this._getLastElementAncestor(l)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(ge[119],me([1,0,55,24,26]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class W{get size(){return this.nodes.size}constructor(y,c,a={}){this.user=y,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new E.IndexTreeModel(y,c,null,a),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,a.sorter&&(this.sorter={compare(d,I){return a.sorter.compare(d.element,I.element)}}),this.identityProvider=a.identityProvider}setChildren(y,c=i.Iterable.empty(),a={}){const d=this.getElementLocation(y);this._setChildren(d,this.preserveCollapseState(c),a)}_setChildren(y,c=i.Iterable.empty(),a){const d=new Set,I=new Set,r=e=>{if(e.element===null)return;const l=e;if(d.add(l.element),this.nodes.set(l.element,l),this.identityProvider){const n=this.identityProvider.getId(l.element).toString();I.add(n),this.nodesByIdentity.set(n,l)}a.onDidCreateNode?.(l)},u=e=>{if(e.element===null)return;const l=e;if(d.has(l.element)||this.nodes.delete(l.element),this.identityProvider){const n=this.identityProvider.getId(l.element).toString();I.has(n)||this.nodesByIdentity.delete(n)}a.onDidDeleteNode?.(l)};this.model.splice([...y,0],Number.MAX_VALUE,c,{...a,onDidCreateNode:r,onDidDeleteNode:u})}preserveCollapseState(y=i.Iterable.empty()){return this.sorter&&(y=[...y].sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(y,c=>{let a=this.nodes.get(c.element);if(!a&&this.identityProvider){const r=this.identityProvider.getId(c.element).toString();a=this.nodesByIdentity.get(r)}if(!a){let r;return typeof c.collapsed>"u"?r=void 0:c.collapsed===L.ObjectTreeElementCollapseState.Collapsed||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:c.collapsed===L.ObjectTreeElementCollapseState.Expanded||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!c.collapsed,{...c,children:this.preserveCollapseState(c.children),collapsed:r}}const d=typeof c.collapsible=="boolean"?c.collapsible:a.collapsible;let I;return typeof c.collapsed>"u"||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrExpanded?I=a.collapsed:c.collapsed===L.ObjectTreeElementCollapseState.Collapsed?I=!0:c.collapsed===L.ObjectTreeElementCollapseState.Expanded?I=!1:I=!!c.collapsed,{...c,collapsible:d,collapsed:I,children:this.preserveCollapseState(c.children)}})}rerender(y){const c=this.getElementLocation(y);this.model.rerender(c)}updateElementHeight(y,c){const a=this.getElementLocation(y);this.model.updateElementHeight(a,c)}resort(y=null,c=!0){if(!this.sorter)return;const a=this.getElementLocation(y),d=this.model.getNode(a);this._setChildren(a,this.resortChildren(d,c),{})}resortChildren(y,c,a=!0){let d=[...y.children];return(c||a)&&(d=d.sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(d,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.resortChildren(I,c,!1)}))}getFirstElementChild(y=null){const c=this.getElementLocation(y);return this.model.getFirstElementChild(c)}getLastElementAncestor(y=null){const c=this.getElementLocation(y);return this.model.getLastElementAncestor(c)}has(y){return this.nodes.has(y)}getListIndex(y){const c=this.getElementLocation(y);return this.model.getListIndex(c)}getListRenderCount(y){const c=this.getElementLocation(y);return this.model.getListRenderCount(c)}isCollapsible(y){const c=this.getElementLocation(y);return this.model.isCollapsible(c)}setCollapsible(y,c){const a=this.getElementLocation(y);return this.model.setCollapsible(a,c)}isCollapsed(y){const c=this.getElementLocation(y);return this.model.isCollapsed(c)}setCollapsed(y,c,a){const d=this.getElementLocation(y);return this.model.setCollapsed(d,c,a)}expandTo(y){const c=this.getElementLocation(y);this.model.expandTo(c)}refilter(){this.model.refilter()}getNode(y=null){if(y===null)return this.model.getNode(this.model.rootRef);const c=this.nodes.get(y);if(!c)throw new L.TreeError(this.user,`Tree element not found: ${y}`);return c}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new L.TreeError(this.user,"Invalid getParentNodeLocation call");const c=this.nodes.get(y);if(!c)throw new L.TreeError(this.user,`Tree element not found: ${y}`);const a=this.model.getNodeLocation(c),d=this.model.getParentNodeLocation(a);return this.model.getNode(d).element}getElementLocation(y){if(y===null)return[];const c=this.nodes.get(y);if(!c)throw new L.TreeError(this.user,`Tree element not found: ${y}`);return this.model.getNodeLocation(c)}}t.ObjectTreeModel=W}),define(ge[19],me([1,0,4,14,21,23,2]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class y extends w.Disposable{onclick(a,d){this._register(E.addDisposableListener(a,E.EventType.CLICK,I=>d(new i.StandardMouseEvent(I))))}onmousedown(a,d){this._register(E.addDisposableListener(a,E.EventType.MOUSE_DOWN,I=>d(new i.StandardMouseEvent(I))))}onmouseover(a,d){this._register(E.addDisposableListener(a,E.EventType.MOUSE_OVER,I=>d(new i.StandardMouseEvent(I))))}onmouseleave(a,d){this._register(E.addDisposableListener(a,E.EventType.MOUSE_LEAVE,I=>d(new i.StandardMouseEvent(I))))}onkeydown(a,d){this._register(E.addDisposableListener(a,E.EventType.KEY_DOWN,I=>d(new L.StandardKeyboardEvent(I))))}onkeyup(a,d){this._register(E.addDisposableListener(a,E.EventType.KEY_UP,I=>d(new L.StandardKeyboardEvent(I))))}oninput(a,d){this._register(E.addDisposableListener(a,E.EventType.INPUT,d))}onblur(a,d){this._register(E.addDisposableListener(a,E.EventType.BLUR,d))}onfocus(a,d){this._register(E.addDisposableListener(a,E.EventType.FOCUS,d))}onchange(a,d){this._register(E.addDisposableListener(a,E.EventType.CHANGE,d))}ignoreGesture(a){return W.Gesture.ignoreTarget(a)}}t.Widget=y}),define(ge[36],me([1,0,53,19,9,17,4]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends L.Widget{constructor(a){super(),this._onActivate=a.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=a.bgWidth+"px",this.bgDomNode.style.height=a.bgHeight+"px",typeof a.top<"u"&&(this.bgDomNode.style.top="0px"),typeof a.left<"u"&&(this.bgDomNode.style.left="0px"),typeof a.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof a.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=a.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(a.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof a.top<"u"&&(this.domNode.style.top=a.top+"px"),typeof a.left<"u"&&(this.domNode.style.left=a.left+"px"),typeof a.bottom<"u"&&(this.domNode.style.bottom=a.bottom+"px"),typeof a.right<"u"&&(this.domNode.style.right=a.right+"px"),this._pointerMoveMonitor=this._register(new E.GlobalPointerMoveMonitor),this._register(w.addStandardDisposableListener(this.bgDomNode,w.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._register(w.addStandardDisposableListener(this.domNode,w.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._pointerdownRepeatTimer=this._register(new i.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new i.TimeoutTimer)}_arrowPointerDown(a){if(!a.target||!(a.target instanceof Element))return;const d=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(d,200),this._pointerMoveMonitor.startMonitoring(a.target,a.pointerId,a.buttons,I=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),a.preventDefault()}}t.ScrollbarArrow=y}),define(ge[56],me([1,0,4,39,53,36,117,19,5]),function(te,t,E,L,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const a=140;class d extends y.Widget{constructor(r){super(),this._lazyRender=r.lazyRender,this._host=r.host,this._scrollable=r.scrollable,this._scrollByPage=r.scrollByPage,this._scrollbarState=r.scrollbarState,this._visibilityController=this._register(new w.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,L.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,u=>this._domNodePointerDown(u)))}_createArrow(r){const u=this._register(new W.ScrollbarArrow(r));this.domNode.domNode.appendChild(u.bgDomNode),this.domNode.domNode.appendChild(u.domNode)}_createSlider(r,u,e,l){this.slider=(0,L.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(u),typeof e=="number"&&this.slider.setWidth(e),typeof l=="number"&&this.slider.setHeight(l),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this._sliderPointerDown(n))})),this.onclick(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}_onElementSize(r){return this._scrollbarState.setVisibleSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(r){return this._scrollbarState.setScrollSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(r){return this._scrollbarState.setScrollPosition(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(r){r.target===this.domNode.domNode&&this._onPointerDown(r)}delegatePointerDown(r){const u=this.domNode.domNode.getClientRects()[0].top,e=u+this._scrollbarState.getSliderPosition(),l=u+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),n=this._sliderPointerPosition(r);e<=n&&n<=l?r.button===0&&(r.preventDefault(),this._sliderPointerDown(r)):this._onPointerDown(r)}_onPointerDown(r){let u,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")u=r.offsetX,e=r.offsetY;else{const n=E.getDomNodePagePosition(this.domNode.domNode);u=r.pageX-n.left,e=r.pageY-n.top}const l=this._pointerDownRelativePosition(u,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(l):this._scrollbarState.getDesiredScrollPositionFromOffset(l)),r.button===0&&(r.preventDefault(),this._sliderPointerDown(r))}_sliderPointerDown(r){if(!r.target||!(r.target instanceof Element))return;const u=this._sliderPointerPosition(r),e=this._sliderOrthogonalPointerPosition(r),l=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const h=this._sliderOrthogonalPointerPosition(n),s=Math.abs(h-e);if(c.isWindows&&s>a){this._setDesiredScrollPositionNow(l.getScrollPosition());return}const v=this._sliderPointerPosition(n)-u;this._setDesiredScrollPositionNow(l.getDesiredScrollPositionFromDelta(v))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(r){const u={};this.writeScrollPosition(u,r),this._scrollable.setScrollPositionNow(u)}updateScrollbarSize(r){this._updateScrollbarSize(r),this._scrollbarState.setScrollbarSize(r),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=d}),define(ge[120],me([1,0,21,56,36,40,16]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class y extends L.AbstractScrollbar{constructor(a,d,I){const r=a.getScrollDimensions(),u=a.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:I,scrollbarState:new W.ScrollbarState(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,r.width,r.scrollWidth,u.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:a,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.ARROW_IMG_SIZE)/2,l=(d.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonLeft,top:l,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonRight,top:l,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}_updateSlider(a,d){this.slider.setWidth(a),this.slider.setLeft(d)}_renderDomNode(a,d){this.domNode.setWidth(a),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(a){return this._shouldRender=this._onElementScrollSize(a.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(a.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(a.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(a,d){return a}_sliderPointerPosition(a){return a.pageX}_sliderOrthogonalPointerPosition(a){return a.pageY}_updateScrollbarSize(a){this.slider.setHeight(a)}writeScrollPosition(a,d){a.scrollLeft=d}updateOptions(a){this.updateScrollbarSize(a.horizontal===2?0:a.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(a.vertical===2?0:a.verticalScrollbarSize),this._visibilityController.setVisibility(a.horizontal),this._scrollByPage=a.scrollByPage}}t.HorizontalScrollbar=y}),define(ge[121],me([1,0,21,56,36,40,16]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class y extends L.AbstractScrollbar{constructor(a,d,I){const r=a.getScrollDimensions(),u=a.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:I,scrollbarState:new W.ScrollbarState(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,r.height,r.scrollHeight,u.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:a,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.ARROW_IMG_SIZE)/2,l=(d.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonUp,top:e,left:l,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonDown,top:void 0,left:l,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}_updateSlider(a,d){this.slider.setHeight(a),this.slider.setTop(d)}_renderDomNode(a,d){this.domNode.setWidth(d),this.domNode.setHeight(a),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(a){return this._shouldRender=this._onElementScrollSize(a.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(a.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(a.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(a,d){return d}_sliderPointerPosition(a){return a.pageY}_sliderOrthogonalPointerPosition(a){return a.pageX}_updateScrollbarSize(a){this.slider.setWidth(a)}writeScrollPosition(a,d){a.scrollTop=d}updateOptions(a){this.updateScrollbarSize(a.vertical===2?0:a.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(a.vertical),this._scrollByPage=a.scrollByPage}}t.VerticalScrollbar=y}),define(ge[57],me([1,0,18,4,39,21,120,121,19,9,3,2,5,49,90]),function(te,t,E,L,i,W,w,y,c,a,d,I,r,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,l=50,n=!0;class h{constructor(k,m,g){this.timestamp=k,this.deltaX=m,this.deltaY=g,this.score=0}}class s{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let k=1,m=0,g=1,b=this._rear;do{const N=b===this._front?k:Math.pow(2,-g);if(k-=N,m+=this._memory[b].score*N,b===this._front)break;b=(this._capacity+b-1)%this._capacity,g++}while(!0);return m<=.5}acceptStandardWheelEvent(k){const m=window.devicePixelRatio/(0,E.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),k.deltaX/m,k.deltaY/m):this.accept(Date.now(),k.deltaX,k.deltaY)}accept(k,m,g){const b=new h(k,m,g);b.score=this._computeScore(b),this._front===-1&&this._rear===-1?(this._memory[0]=b,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=b)}_computeScore(k){if(Math.abs(k.deltaX)>0&&Math.abs(k.deltaY)>0)return 1;let m=.5;const g=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(k.deltaX)||!this._isAlmostInt(k.deltaY))&&(m+=.25),Math.min(Math.max(m,0),1)}_isAlmostInt(k){return Math.abs(Math.round(k)-k)<.01}}t.MouseWheelClassifier=s,s.INSTANCE=new s;class D extends c.Widget{get options(){return this._options}constructor(k,m,g){super(),this._onScroll=this._register(new d.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new d.Emitter),this.onWillScroll=this._onWillScroll.event,k.style.overflow="hidden",this._options=p(m),this._scrollable=g,this._register(this._scrollable.onScroll(N=>{this._onWillScroll.fire(N),this._onDidScroll(N),this._onScroll.fire(N)}));const b={onMouseWheel:N=>this._onMouseWheel(N),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new y.VerticalScrollbar(this._scrollable,this._options,b)),this._horizontalScrollbar=this._register(new w.HorizontalScrollbar(this._scrollable,this._options,b)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(k),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,N=>this._onMouseOver(N)),this.onmouseleave(this._listenOnDomNode,N=>this._onMouseLeave(N)),this._hideTimeout=this._register(new a.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,I.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(k){this._verticalScrollbar.delegatePointerDown(k)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(k){this._scrollable.setScrollDimensions(k,!1)}updateClassName(k){this._options.className=k,r.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(k){typeof k.handleMouseWheel<"u"&&(this._options.handleMouseWheel=k.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof k.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=k.mouseWheelScrollSensitivity),typeof k.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=k.fastScrollSensitivity),typeof k.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=k.scrollPredominantAxis),typeof k.horizontal<"u"&&(this._options.horizontal=k.horizontal),typeof k.vertical<"u"&&(this._options.vertical=k.vertical),typeof k.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=k.horizontalScrollbarSize),typeof k.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=k.verticalScrollbarSize),typeof k.scrollByPage<"u"&&(this._options.scrollByPage=k.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(k){this._revealOnScroll=k}delegateScrollFromMouseWheelEvent(k){this._onMouseWheel(new W.StandardWheelEvent(k))}_setListeningToMouseWheel(k){if(this._mouseWheelToDispose.length>0!==k&&(this._mouseWheelToDispose=(0,I.dispose)(this._mouseWheelToDispose),k)){const g=b=>{this._onMouseWheel(new W.StandardWheelEvent(b))};this._mouseWheelToDispose.push(L.addDisposableListener(this._listenOnDomNode,L.EventType.MOUSE_WHEEL,g,{passive:!1}))}}_onMouseWheel(k){const m=s.INSTANCE;n&&m.acceptStandardWheelEvent(k);let g=!1;if(k.deltaY||k.deltaX){let N=k.deltaY*this._options.mouseWheelScrollSensitivity,M=k.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(N)>=Math.abs(M)?M=0:N=0),this._options.flipAxes&&([N,M]=[M,N]);const H=!r.isMacintosh&&k.browserEvent&&k.browserEvent.shiftKey;(this._options.scrollYToX||H)&&!M&&(M=N,N=0),k.browserEvent&&k.browserEvent.altKey&&(M=M*this._options.fastScrollSensitivity,N=N*this._options.fastScrollSensitivity);const Z=this._scrollable.getFutureScrollPosition();let ne={};if(N){const se=l*N,he=Z.scrollTop-(se<0?Math.floor(se):Math.ceil(se));this._verticalScrollbar.writeScrollPosition(ne,he)}if(M){const se=l*M,he=Z.scrollLeft-(se<0?Math.floor(se):Math.ceil(se));this._horizontalScrollbar.writeScrollPosition(ne,he)}ne=this._scrollable.validateScrollPosition(ne),(Z.scrollLeft!==ne.scrollLeft||Z.scrollTop!==ne.scrollTop)&&(n&&this._options.mouseWheelSmoothScroll&&m.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(ne):this._scrollable.setScrollPositionNow(ne),g=!0)}let b=g;!b&&this._options.alwaysConsumeMouseWheel&&(b=!0),!b&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(b=!0),b&&(k.preventDefault(),k.stopPropagation())}_onDidScroll(k){this._shouldRender=this._horizontalScrollbar.onDidScroll(k)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(k)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const k=this._scrollable.getCurrentScrollPosition(),m=k.scrollTop>0,g=k.scrollLeft>0,b=g?" left":"",N=m?" top":"",M=g||m?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${b}`),this._topShadowDomNode.setClassName(`shadow${N}`),this._topLeftShadowDomNode.setClassName(`shadow${M}${N}${b}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(k){this._mouseIsOver=!1,this._hide()}_onMouseOver(k){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=D;class v extends D{constructor(k,m){m=m||{},m.mouseWheelSmoothScroll=!1;const g=new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>L.scheduleAtNextAnimationFrame(b)});super(k,m,g),this._register(g)}setScrollPosition(k){this._scrollable.setScrollPositionNow(k)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=v;class A extends D{constructor(k,m,g){super(k,m,g)}setScrollPosition(k){k.reuseAnimation?this._scrollable.setScrollPositionSmooth(k,k.reuseAnimation):this._scrollable.setScrollPositionNow(k)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=A;class f extends D{constructor(k,m){m=m||{},m.mouseWheelSmoothScroll=!1;const g=new u.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>L.scheduleAtNextAnimationFrame(b)});super(k,m,g),this._register(g),this._element=k,this.onScroll(b=>{b.scrollTopChanged&&(this._element.scrollTop=b.scrollTop),b.scrollLeftChanged&&(this._element.scrollLeft=b.scrollLeft)}),this.scanDomNode()}setScrollPosition(k){this._scrollable.setScrollPositionNow(k)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=f;function p(O){const k={lazyRender:typeof O.lazyRender<"u"?O.lazyRender:!1,className:typeof O.className<"u"?O.className:"",useShadows:typeof O.useShadows<"u"?O.useShadows:!0,handleMouseWheel:typeof O.handleMouseWheel<"u"?O.handleMouseWheel:!0,flipAxes:typeof O.flipAxes<"u"?O.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof O.consumeMouseWheelIfScrollbarIsNeeded<"u"?O.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof O.alwaysConsumeMouseWheel<"u"?O.alwaysConsumeMouseWheel:!1,scrollYToX:typeof O.scrollYToX<"u"?O.scrollYToX:!1,mouseWheelScrollSensitivity:typeof O.mouseWheelScrollSensitivity<"u"?O.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof O.fastScrollSensitivity<"u"?O.fastScrollSensitivity:5,scrollPredominantAxis:typeof O.scrollPredominantAxis<"u"?O.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof O.mouseWheelSmoothScroll<"u"?O.mouseWheelSmoothScroll:!0,arrowSize:typeof O.arrowSize<"u"?O.arrowSize:11,listenOnDomNode:typeof O.listenOnDomNode<"u"?O.listenOnDomNode:null,horizontal:typeof O.horizontal<"u"?O.horizontal:1,horizontalScrollbarSize:typeof O.horizontalScrollbarSize<"u"?O.horizontalScrollbarSize:10,horizontalSliderSize:typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:0,horizontalHasArrows:typeof O.horizontalHasArrows<"u"?O.horizontalHasArrows:!1,vertical:typeof O.vertical<"u"?O.vertical:1,verticalScrollbarSize:typeof O.verticalScrollbarSize<"u"?O.verticalScrollbarSize:10,verticalHasArrows:typeof O.verticalHasArrows<"u"?O.verticalHasArrows:!1,verticalSliderSize:typeof O.verticalSliderSize<"u"?O.verticalSliderSize:0,scrollByPage:typeof O.scrollByPage<"u"?O.scrollByPage:!1};return k.horizontalSliderSize=typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:k.horizontalScrollbarSize,k.verticalSliderSize=typeof O.verticalSliderSize<"u"?O.verticalSliderSize:k.verticalScrollbarSize,r.isMacintosh&&(k.className+=" mac"),k}}),define(ge[58],me([1,0,51,4,20,23,57,13,9,25,3,2,45,49,79,116,7]),function(te,t,E,L,i,W,w,y,c,a,d,I,r,u,e,l,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const h={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(k){return[k]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class D{get context(){return this._context}set context(m){this._context=m}constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=D;class v{constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=v;class A{constructor(){this.types=[],this.files=[]}update(m){if(m.types&&this.types.splice(0,this.types.length,...m.types),m.files){this.files.splice(0,this.files.length);for(let g=0;g<m.files.length;g++){const b=m.files.item(g);b&&(b.size||b.type)&&this.files.push(b)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=A;function f(k,m){return Array.isArray(k)&&Array.isArray(m)?(0,y.equals)(k,m):k===m}class p{constructor(m){m?.getSetSize?this.getSetSize=m.getSetSize.bind(m):this.getSetSize=(g,b,N)=>N,m?.getPosInSet?this.getPosInSet=m.getPosInSet.bind(m):this.getPosInSet=(g,b)=>b+1,m?.getRole?this.getRole=m.getRole.bind(m):this.getRole=g=>"listitem",m?.isChecked?this.isChecked=m.isChecked.bind(m):this.isChecked=g=>{}}}class O{get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(m){if(m!==this._horizontalScrolling){if(m&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=m,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const g of this.items)this.measureItemWidth(g);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,L.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(m,g,b,N=s){if(this.virtualDelegate=g,this.domId=`list_id_${++O.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new c.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=I.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=I.Disposable.None,this.onDragLeaveTimeout=I.Disposable.None,this.disposables=new I.DisposableStore,this._onDidChangeContentHeight=new d.Emitter,this._onDidChangeContentWidth=new d.Emitter,this.onDidChangeContentHeight=d.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=d.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,N.horizontalScrolling&&N.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new e.RangeMap;for(const H of b)this.renderers.set(H.templateId,H);this.cache=this.disposables.add(new l.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof N.mouseSupport=="boolean"?N.mouseSupport:!0),this._horizontalScrolling=N.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof N.additionalScrollHeight>"u"?0:N.additionalScrollHeight,this.accessibilityProvider=new p(N.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(N.transformOptimization??s.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(W.Gesture.addTarget(this.rowsContainer)),this.scrollable=new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:N.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:H=>(0,L.scheduleAtNextAnimationFrame)(H)}),this.scrollableElement=this.disposables.add(new w.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:N.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:N.verticalScrollMode??s.verticalScrollMode,useShadows:N.useShadows??s.useShadows,mouseWheelScrollSensitivity:N.mouseWheelScrollSensitivity,fastScrollSensitivity:N.fastScrollSensitivity,scrollByPage:N.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),m.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,L.addDisposableListener)(this.rowsContainer,W.EventType.Change,H=>this.onTouchChange(H))),this.disposables.add((0,L.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",H=>H.target.scrollTop=0)),this.disposables.add((0,L.addDisposableListener)(this.domNode,"dragover",H=>this.onDragOver(this.toDragEvent(H)))),this.disposables.add((0,L.addDisposableListener)(this.domNode,"drop",H=>this.onDrop(this.toDragEvent(H)))),this.disposables.add((0,L.addDisposableListener)(this.domNode,"dragleave",H=>this.onDragLeave(this.toDragEvent(H)))),this.disposables.add((0,L.addDisposableListener)(this.domNode,"dragend",H=>this.onDragEnd(H))),this.setRowLineHeight=N.setRowLineHeight??s.setRowLineHeight,this.setRowHeight=N.setRowHeight??s.setRowHeight,this.supportDynamicHeights=N.supportDynamicHeights??s.supportDynamicHeights,this.dnd=N.dnd??s.dnd,this.layout(N.initialSize?.height,N.initialSize?.width)}updateOptions(m){m.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=m.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),m.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(m.smoothScrolling?125:0),m.horizontalScrolling!==void 0&&(this.horizontalScrolling=m.horizontalScrolling);let g;m.scrollByPage!==void 0&&(g={...g??{},scrollByPage:m.scrollByPage}),m.mouseWheelScrollSensitivity!==void 0&&(g={...g??{},mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity}),m.fastScrollSensitivity!==void 0&&(g={...g??{},fastScrollSensitivity:m.fastScrollSensitivity}),g&&this.scrollableElement.updateOptions(g)}delegateScrollFromMouseWheelEvent(m){this.scrollableElement.delegateScrollFromMouseWheelEvent(m)}delegateVerticalScrollbarPointerDown(m){this.scrollableElement.delegateVerticalScrollbarPointerDown(m)}updateElementHeight(m,g,b){if(m<0||m>=this.items.length)return;const N=this.items[m].size;if(typeof g>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[m].lastDynamicHeightWidth=void 0,g=N+this.probeDynamicHeight(m)}if(N===g)return;const M=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let H=0;m<M.start||b!==null&&b>m&&b<=M.end?H=g-N:H=0,this.rangeMap.splice(m,1,[{size:g}]),this.items[m].size=g,this.render(M,Math.max(0,this.lastRenderTop+H),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(m,g,b=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(m,g,b)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(m,g,b=[]){const N=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),M={start:m,end:m+g},H=r.Range.intersect(N,M),Z=new Map;for(let K=H.end-1;K>=H.start;K--){const _=this.items[K];if(_.dragStartDisposable.dispose(),_.checkedDisposable.dispose(),_.row){let j=Z.get(_.templateId);j||(j=[],Z.set(_.templateId,j));const z=this.renderers.get(_.templateId);z&&z.disposeElement&&z.disposeElement(_.element,K,_.row.templateData,_.size),j.push(_.row)}_.row=null}const ne={start:m+g,end:this.items.length},se=r.Range.intersect(ne,N),he=r.Range.relativeComplement(ne,N),ue=b.map(K=>({id:String(this.itemId++),element:K,templateId:this.virtualDelegate.getTemplateId(K),size:this.virtualDelegate.getHeight(K),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(K),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.Disposable.None,checkedDisposable:I.Disposable.None}));let le;m===0&&g>=this.items.length?(this.rangeMap=new e.RangeMap,this.rangeMap.splice(0,0,ue),le=this.items,this.items=ue):(this.rangeMap.splice(m,g,ue),le=this.items.splice(m,g,...ue));const oe=b.length-g,ye=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),Te=(0,e.shift)(se,oe),Oe=r.Range.intersect(ye,Te);for(let K=Oe.start;K<Oe.end;K++)this.updateItemInDOM(this.items[K],K);const ke=r.Range.relativeComplement(Te,ye);for(const K of ke)for(let _=K.start;_<K.end;_++)this.removeItemFromDOM(_);const fe=he.map(K=>(0,e.shift)(K,oe)),ie=[{start:m,end:m+b.length},...fe].map(K=>r.Range.intersect(ye,K)),q=this.getNextToLastElement(ie);for(const K of ie)for(let _=K.start;_<K.end;_++){const j=this.items[_],o=Z.get(j.templateId)?.pop();this.insertItemInDOM(_,q,o)}for(const K of Z.values())for(const _ of K)this.cache.release(_);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),le.map(K=>K.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,L.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let m=0;for(const g of this.items)typeof g.width<"u"&&(m=Math.max(m,g.width));this.scrollWidth=m,this.scrollableElement.setScrollDimensions({scrollWidth:m===0?0:m+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(m){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const g=this.items[m];this.measureItemWidth(g),typeof g.width<"u"&&g.width>this.scrollWidth&&(this.scrollWidth=g.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const m of this.items)m.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const m=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),g=this.rangeMap.positionAt(m.start),b=this.rangeMap.positionAt(m.start+1);return b!==-1&&(b-g)/2+g<this.scrollTop?m.start+1:m.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(m){return this.items[m].element}indexOf(m){return this.items.findIndex(g=>g.element===m)}domElement(m){const g=this.items[m].row;return g&&g.domNode}elementHeight(m){return this.items[m].size}elementTop(m){return this.rangeMap.positionAt(m)}indexAt(m){return this.rangeMap.indexAt(m)}indexAfter(m){return this.rangeMap.indexAfter(m)}layout(m,g){const b={height:typeof m=="number"?m:(0,L.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,b.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(b),typeof g<"u"&&(this.renderWidth=g,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof g=="number"?g:(0,L.getContentWidth)(this.domNode)})}render(m,g,b,N,M,H=!1){const Z=this.getRenderRange(g,b),ne=r.Range.relativeComplement(Z,m),se=r.Range.relativeComplement(m,Z),he=this.getNextToLastElement(ne);if(H){const ue=r.Range.intersect(m,Z);for(let le=ue.start;le<ue.end;le++)this.updateItemInDOM(this.items[le],le)}this.cache.transact(()=>{for(const ue of se)for(let le=ue.start;le<ue.end;le++)this.removeItemFromDOM(le);for(const ue of ne)for(let le=ue.start;le<ue.end;le++)this.insertItemInDOM(le,he)}),N!==void 0&&(this.rowsContainer.style.left=`-${N}px`),this.rowsContainer.style.top=`-${g}px`,this.horizontalScrolling&&M!==void 0&&(this.rowsContainer.style.width=`${Math.max(M,this.renderWidth)}px`),this.lastRenderTop=g,this.lastRenderHeight=b}insertItemInDOM(m,g,b){const N=this.items[m];let M=!1;if(!N.row)if(b)N.row=b;else{const he=this.cache.alloc(N.templateId);N.row=he.row,M=he.isReusingConnectedDomNode}const H=this.accessibilityProvider.getRole(N.element)||"listitem";N.row.domNode.setAttribute("role",H);const Z=this.accessibilityProvider.isChecked(N.element);if(typeof Z=="boolean")N.row.domNode.setAttribute("aria-checked",String(!!Z));else if(Z){const he=ue=>N.row.domNode.setAttribute("aria-checked",String(!!ue));he(Z.value),N.checkedDisposable=Z.onDidChange(he)}(M||!N.row.domNode.parentElement)&&(g?this.rowsContainer.insertBefore(N.row.domNode,g):this.rowsContainer.appendChild(N.row.domNode)),this.updateItemInDOM(N,m);const ne=this.renderers.get(N.templateId);if(!ne)throw new Error(`No renderer found for template id ${N.templateId}`);ne?.renderElement(N.element,m,N.row.templateData,N.size);const se=this.dnd.getDragURI(N.element);N.dragStartDisposable.dispose(),N.row.domNode.draggable=!!se,se&&(N.dragStartDisposable=(0,L.addDisposableListener)(N.row.domNode,"dragstart",he=>this.onDragStart(N.element,se,he))),this.horizontalScrolling&&(this.measureItemWidth(N),this.eventuallyUpdateScrollWidth())}measureItemWidth(m){if(!m.row||!m.row.domNode)return;m.row.domNode.style.width="fit-content",m.width=(0,L.getContentWidth)(m.row.domNode);const g=window.getComputedStyle(m.row.domNode);g.paddingLeft&&(m.width+=parseFloat(g.paddingLeft)),g.paddingRight&&(m.width+=parseFloat(g.paddingRight)),m.row.domNode.style.width=""}updateItemInDOM(m,g){m.row.domNode.style.top=`${this.elementTop(g)}px`,this.setRowHeight&&(m.row.domNode.style.height=`${m.size}px`),this.setRowLineHeight&&(m.row.domNode.style.lineHeight=`${m.size}px`),m.row.domNode.setAttribute("data-index",`${g}`),m.row.domNode.setAttribute("data-last-element",g===this.length-1?"true":"false"),m.row.domNode.setAttribute("data-parity",g%2===0?"even":"odd"),m.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(m.element,g,this.length))),m.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(m.element,g))),m.row.domNode.setAttribute("id",this.getElementDomId(g)),m.row.domNode.classList.toggle("drop-target",m.dropTarget)}removeItemFromDOM(m){const g=this.items[m];if(g.dragStartDisposable.dispose(),g.checkedDisposable.dispose(),g.row){const b=this.renderers.get(g.templateId);b&&b.disposeElement&&b.disposeElement(g.element,m,g.row.templateData,g.size),this.cache.release(g.row),g.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(m,g){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:m,reuseAnimation:g})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(m){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:m})}get scrollTop(){return this.getScrollTop()}set scrollTop(m){this.setScrollTop(m)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"click")).event,m=>this.toMouseEvent(m),this.disposables)}get onMouseDblClick(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"dblclick")).event,m=>this.toMouseEvent(m),this.disposables)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"auxclick")).event,m=>this.toMouseEvent(m),this.disposables),m=>m.browserEvent.button===1,this.disposables)}get onMouseUp(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseup")).event,m=>this.toMouseEvent(m),this.disposables)}get onMouseDown(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousedown")).event,m=>this.toMouseEvent(m),this.disposables)}get onMouseOver(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseover")).event,m=>this.toMouseEvent(m),this.disposables)}get onMouseMove(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousemove")).event,m=>this.toMouseEvent(m),this.disposables)}get onMouseOut(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseout")).event,m=>this.toMouseEvent(m),this.disposables)}get onContextMenu(){return d.Event.any(d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"contextmenu")).event,m=>this.toMouseEvent(m),this.disposables),d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,W.EventType.Contextmenu)).event,m=>this.toGestureEvent(m),this.disposables))}get onTouchStart(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"touchstart")).event,m=>this.toTouchEvent(m),this.disposables)}get onTap(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.rowsContainer,W.EventType.Tap)).event,m=>this.toGestureEvent(m),this.disposables)}toMouseEvent(m){const g=this.getItemIndexFromEventTarget(m.target||null),b=typeof g>"u"?void 0:this.items[g],N=b&&b.element;return{browserEvent:m,index:g,element:N}}toTouchEvent(m){const g=this.getItemIndexFromEventTarget(m.target||null),b=typeof g>"u"?void 0:this.items[g],N=b&&b.element;return{browserEvent:m,index:g,element:N}}toGestureEvent(m){const g=this.getItemIndexFromEventTarget(m.initialTarget||null),b=typeof g>"u"?void 0:this.items[g],N=b&&b.element;return{browserEvent:m,index:g,element:N}}toDragEvent(m){const g=this.getItemIndexFromEventTarget(m.target||null),b=typeof g>"u"?void 0:this.items[g],N=b&&b.element;return{browserEvent:m,index:g,element:N}}onScroll(m){try{const g=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(g,m.scrollTop,m.height,m.scrollLeft,m.scrollWidth),this.supportDynamicHeights&&this._rerender(m.scrollTop,m.height,m.inSmoothScrolling)}catch(g){throw console.error("Got bad scroll event:",m),g}}onTouchChange(m){m.preventDefault(),m.stopPropagation(),this.scrollTop-=m.translationY}onDragStart(m,g,b){if(!b.dataTransfer)return;const N=this.dnd.getDragElements(m);if(b.dataTransfer.effectAllowed="copyMove",b.dataTransfer.setData(E.DataTransfers.TEXT,g),b.dataTransfer.setDragImage){let M;this.dnd.getDragLabel&&(M=this.dnd.getDragLabel(N,b)),typeof M>"u"&&(M=String(N.length));const H=(0,L.$)(".monaco-drag-image");H.textContent=M;const ne=(se=>{for(;se&&!se.classList.contains("monaco-workbench");)se=se.parentElement;return se||document.body})(this.domNode);ne.appendChild(H),b.dataTransfer.setDragImage(H,-10,-10),setTimeout(()=>ne.removeChild(H),0)}this.domNode.classList.add("dragging"),this.currentDragData=new D(N),h.CurrentDragAndDropData=new v(N),this.dnd.onDragStart?.(this.currentDragData,b)}onDragOver(m){if(m.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),h.CurrentDragAndDropData&&h.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(m.browserEvent),!m.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(h.CurrentDragAndDropData)this.currentDragData=h.CurrentDragAndDropData;else{if(!m.browserEvent.dataTransfer.types)return!1;this.currentDragData=new A}const g=this.dnd.onDragOver(this.currentDragData,m.element,m.index,m.browserEvent);if(this.canDrop=typeof g=="boolean"?g:g.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;m.browserEvent.dataTransfer.dropEffect=typeof g!="boolean"&&g.effect===0?"copy":"move";let b;if(typeof g!="boolean"&&g.feedback?b=g.feedback:typeof m.index>"u"?b=[-1]:b=[m.index],b=(0,y.distinct)(b).filter(N=>N>=-1&&N<this.length).sort((N,M)=>N-M),b=b[0]===-1?[-1]:b,f(this.currentDragFeedback,b))return!0;if(this.currentDragFeedback=b,this.currentDragFeedbackDisposable.dispose(),b[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,I.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const N of b){const M=this.items[N];M.dropTarget=!0,M.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,I.toDisposable)(()=>{for(const N of b){const M=this.items[N];M.dropTarget=!1,M.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(m){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,c.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,m.element,m.index,m.browserEvent)}onDrop(m){if(!this.canDrop)return;const g=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,h.CurrentDragAndDropData=void 0,!(!g||!m.browserEvent.dataTransfer)&&(m.browserEvent.preventDefault(),g.update(m.browserEvent.dataTransfer),this.dnd.drop(g,m.element,m.index,m.browserEvent))}onDragEnd(m){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,h.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(m)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=I.Disposable.None}setupDragAndDropScrollTopAnimation(m){if(!this.dragOverAnimationDisposable){const g=(0,L.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,L.animate)(this.animateDragAndDropScrollTop.bind(this,g))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,c.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=m.pageY}animateDragAndDropScrollTop(m){if(this.dragOverMouseY===void 0)return;const g=this.dragOverMouseY-m,b=this.renderHeight-35;g<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(g-35))):g>b&&(this.scrollTop+=Math.min(14,Math.floor(.3*(g-b))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(m){const g=this.scrollableElement.getDomNode();let b=m;for(;b instanceof HTMLElement&&b!==this.rowsContainer&&g.contains(b);){const N=b.getAttribute("data-index");if(N){const M=Number(N);if(!isNaN(M))return M}b=b.parentElement}}getRenderRange(m,g){return{start:this.rangeMap.indexAt(m),end:this.rangeMap.indexAfter(m+g-1)}}_rerender(m,g,b){const N=this.getRenderRange(m,g);let M,H;m===this.elementTop(N.start)?(M=N.start,H=0):N.end-N.start>1&&(M=N.start+1,H=this.elementTop(M)-m);let Z=0;for(;;){const ne=this.getRenderRange(m,g);let se=!1;for(let he=ne.start;he<ne.end;he++){const ue=this.probeDynamicHeight(he);ue!==0&&this.rangeMap.splice(he,1,[this.items[he]]),Z+=ue,se=se||ue!==0}if(!se){Z!==0&&this.eventuallyUpdateScrollDimensions();const he=r.Range.relativeComplement(N,ne);for(const le of he)for(let oe=le.start;oe<le.end;oe++)this.items[oe].row&&this.removeItemFromDOM(oe);const ue=r.Range.relativeComplement(ne,N);for(const le of ue)for(let oe=le.start;oe<le.end;oe++){const ye=oe+1,Te=ye<this.items.length?this.items[ye].row:null,Oe=Te?Te.domNode:null;this.insertItemInDOM(oe,Oe)}for(let le=ne.start;le<ne.end;le++)this.items[le].row&&this.updateItemInDOM(this.items[le],le);if(typeof M=="number"){const le=this.scrollable.getFutureScrollPosition().scrollTop-m,oe=this.elementTop(M)-H+le;this.setScrollTop(oe,b)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(m){const g=this.items[m];if(this.virtualDelegate.getDynamicHeight){const H=this.virtualDelegate.getDynamicHeight(g.element);if(H!==null){const Z=g.size;return g.size=H,g.lastDynamicHeightWidth=this.renderWidth,H-Z}}if(!g.hasDynamicHeight||g.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(g.element))return 0;const b=g.size;if(g.row)return g.row.domNode.style.height="",g.size=g.row.domNode.offsetHeight,g.lastDynamicHeightWidth=this.renderWidth,g.size-b;const{row:N}=this.cache.alloc(g.templateId);N.domNode.style.height="",this.rowsContainer.appendChild(N.domNode);const M=this.renderers.get(g.templateId);if(!M)throw new n.BugIndicatingError("Missing renderer for templateId: "+g.templateId);return M.renderElement(g.element,m,N.templateData,void 0),g.size=N.domNode.offsetHeight,M.disposeElement?.(g.element,m,N.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(g.element,g.size),g.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(N.domNode),this.cache.release(N),g.size-b}getNextToLastElement(m){const g=m[m.length-1];if(!g)return null;const b=this.items[g.end];return!b||!b.row?null:b.row.domNode}getElementDomId(m){return`${this.domId}_${m}`}dispose(){if(this.items){for(const m of this.items)if(m.row){const g=this.renderers.get(m.row.templateId);g&&(g.disposeElement?.(m.element,-1,m.row.templateData,void 0),g.disposeTemplate(m.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,I.dispose)(this.disposables)}}t.ListView=O,O.InstanceCount=0,qe([a.memoize],O.prototype,"onMouseClick",null),qe([a.memoize],O.prototype,"onMouseDblClick",null),qe([a.memoize],O.prototype,"onMouseMiddleClick",null),qe([a.memoize],O.prototype,"onMouseUp",null),qe([a.memoize],O.prototype,"onMouseDown",null),qe([a.memoize],O.prototype,"onMouseOver",null),qe([a.memoize],O.prototype,"onMouseMove",null),qe([a.memoize],O.prototype,"onMouseOut",null),qe([a.memoize],O.prototype,"onContextMenu",null),qe([a.memoize],O.prototype,"onTouchStart",null),qe([a.memoize],O.prototype,"onTap",null)}),define(ge[37],me([1,0,4,20,14,23,54,68,13,9,70,25,3,33,2,44,5,6,67,58,89]),function(te,t,E,L,i,W,w,y,c,a,d,I,r,u,e,l,n,h,s,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class v{constructor(_){this.trait=_,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(_){return _}renderElement(_,j,z){const o=this.renderedElements.findIndex(T=>T.templateData===z);if(o>=0){const T=this.renderedElements[o];this.trait.unrender(z),T.index=j}else{const T={index:j,templateData:z};this.renderedElements.push(T)}this.trait.renderIndex(j,z)}splice(_,j,z){const o=[];for(const T of this.renderedElements)T.index<_?o.push(T):T.index>=_+j&&o.push({index:T.index+z-j,templateData:T.templateData});this.renderedElements=o}renderIndexes(_){for(const{index:j,templateData:z}of this.renderedElements)_.indexOf(j)>-1&&this.trait.renderIndex(j,z)}disposeTemplate(_){const j=this.renderedElements.findIndex(z=>z.templateData===_);j<0||this.renderedElements.splice(j,1)}}class A{get name(){return this._trait}get renderer(){return new v(this)}constructor(_){this._trait=_,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new r.Emitter,this.onChange=this._onChange.event}splice(_,j,z){j=Math.max(0,Math.min(j,this.length-_));const o=z.length-j,T=_+j,$=[...this.sortedIndexes.filter(C=>C<_),...z.map((C,F)=>C?F+_:-1).filter(C=>C!==-1),...this.sortedIndexes.filter(C=>C>=T).map(C=>C+o)],Y=this.length+o;if(this.sortedIndexes.length>0&&$.length===0&&Y>0){const C=this.sortedIndexes.find(F=>F>=_)??Y-1;$.push(Math.min(C,Y-1))}this.renderer.splice(_,j,z.length),this._set($,$),this.length=Y}renderIndex(_,j){j.classList.toggle(this._trait,this.contains(_))}unrender(_){_.classList.remove(this._trait)}set(_,j){return this._set(_,[..._].sort(ke),j)}_set(_,j,z){const o=this.indexes,T=this.sortedIndexes;this.indexes=_,this.sortedIndexes=j;const $=Te(T,_);return this.renderer.renderIndexes($),this._onChange.fire({indexes:_,browserEvent:z}),o}get(){return this.indexes}contains(_){return(0,c.binarySearch)(this.sortedIndexes,_,ke)>=0}dispose(){(0,e.dispose)(this._onChange)}}qe([I.memoize],A.prototype,"renderer",null);class f extends A{constructor(_){super("selected"),this.setAriaSelected=_}renderIndex(_,j){super.renderIndex(_,j),this.setAriaSelected&&(this.contains(_)?j.setAttribute("aria-selected","true"):j.setAttribute("aria-selected","false"))}}class p{constructor(_,j,z){this.trait=_,this.view=j,this.identityProvider=z}splice(_,j,z){if(!this.identityProvider)return this.trait.splice(_,j,z.map(()=>!1));const o=this.trait.get().map($=>this.identityProvider.getId(this.view.element($)).toString()),T=z.map($=>o.indexOf(this.identityProvider.getId($).toString())>-1);this.trait.splice(_,j,T)}}function O(K){return K.tagName==="INPUT"||K.tagName==="TEXTAREA"}t.isInputElement=O;function k(K){return K.classList.contains("monaco-editor")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:k(K.parentElement)}t.isMonacoEditor=k;function m(K){return K.tagName==="A"&&K.classList.contains("monaco-button")||K.tagName==="DIV"&&K.classList.contains("monaco-button-dropdown")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:m(K.parentElement)}t.isButton=m;class g{get onKeyDown(){return this.disposables.add(r.Event.chain(this.disposables.add(new L.DomEmitter(this.view.domNode,"keydown")).event).filter(_=>!O(_.target)).map(_=>new i.StandardKeyboardEvent(_)))}constructor(_,j,z){this.list=_,this.view=j,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(o=>o.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===9).on(this.onEscape,this,this.disposables),z.multipleSelectionSupport!==!1&&this.onKeyDown.filter(o=>(n.isMacintosh?o.metaKey:o.ctrlKey)&&o.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}updateOptions(_){_.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),_.multipleSelectionSupport&&this.onKeyDown.filter(j=>(n.isMacintosh?j.metaKey:j.ctrlKey)&&j.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(_){_.preventDefault(),_.stopPropagation(),this.list.setSelection(this.list.getFocus(),_.browserEvent)}onUpArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusPrevious(1,!1,_.browserEvent);const j=this.list.getFocus()[0];this.list.setAnchor(j),this.list.reveal(j),this.view.domNode.focus()}onDownArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusNext(1,!1,_.browserEvent);const j=this.list.getFocus()[0];this.list.setAnchor(j),this.list.reveal(j),this.view.domNode.focus()}onPageUpArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusPreviousPage(_.browserEvent);const j=this.list.getFocus()[0];this.list.setAnchor(j),this.list.reveal(j),this.view.domNode.focus()}onPageDownArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusNextPage(_.browserEvent);const j=this.list.getFocus()[0];this.list.setAnchor(j),this.list.reveal(j),this.view.domNode.focus()}onCtrlA(_){_.preventDefault(),_.stopPropagation(),this.list.setSelection((0,c.range)(this.list.length),_.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(_){this.list.getSelection().length&&(_.preventDefault(),_.stopPropagation(),this.list.setSelection([],_.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}qe([I.memoize],g.prototype,"onKeyDown",null);var b;(function(K){K[K.Automatic=0]="Automatic",K[K.Trigger=1]="Trigger"})(b||(t.TypeNavigationMode=b={}));var N;(function(K){K[K.Idle=0]="Idle",K[K.Typing=1]="Typing"})(N||(N={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(K){return K.ctrlKey||K.metaKey||K.altKey?!1:K.keyCode>=31&&K.keyCode<=56||K.keyCode>=21&&K.keyCode<=30||K.keyCode>=98&&K.keyCode<=107||K.keyCode>=85&&K.keyCode<=95}};class M{constructor(_,j,z,o,T){this.list=_,this.view=j,this.keyboardNavigationLabelProvider=z,this.keyboardNavigationEventFilter=o,this.delegate=T,this.enabled=!1,this.state=N.Idle,this.mode=b.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(_.options)}updateOptions(_){_.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=_.typeNavigationMode??b.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let _=!1;const j=this.enabledDisposables.add(r.Event.chain(this.enabledDisposables.add(new L.DomEmitter(this.view.domNode,"keydown")).event)).filter(T=>!O(T.target)).filter(()=>this.mode===b.Automatic||this.triggered).map(T=>new i.StandardKeyboardEvent(T)).filter(T=>_||this.keyboardNavigationEventFilter(T)).filter(T=>this.delegate.mightProducePrintableCharacter(T)).forEach(T=>E.EventHelper.stop(T,!0)).map(T=>T.browserEvent.key).event,z=r.Event.debounce(j,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);r.Event.reduce(r.Event.any(j,z),(T,$)=>$===null?null:(T||"")+$,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),z(this.onClear,this,this.enabledDisposables),j(()=>_=!0,void 0,this.enabledDisposables),z(()=>_=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const _=this.list.getFocus();if(_.length>0&&_[0]===this.previouslyFocused){const j=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(_[0]));j&&(0,w.alert)(j)}this.previouslyFocused=-1}onInput(_){if(!_){this.state=N.Idle,this.triggered=!1;return}const j=this.list.getFocus(),z=j.length>0?j[0]:0,o=this.state===N.Idle?1:0;this.state=N.Typing;for(let T=0;T<this.list.length;T++){const $=(z+T+o)%this.list.length,Y=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element($)),C=Y&&Y.toString();if(typeof C>"u"||(0,u.matchesPrefix)(_,C)){this.previouslyFocused=z,this.list.setFocus([$]),this.list.reveal($);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class H{constructor(_,j){this.list=_,this.view=j,this.disposables=new e.DisposableStore,this.disposables.add(r.Event.chain(this.disposables.add(new L.DomEmitter(j.domNode,"keydown")).event)).filter(o=>!O(o.target)).map(o=>new i.StandardKeyboardEvent(o)).filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey).on(this.onTab,this,this.disposables)}onTab(_){if(_.target!==this.view.domNode)return;const j=this.list.getFocus();if(j.length===0)return;const z=this.view.domElement(j[0]);if(!z)return;const o=z.querySelector("[tabIndex]");if(!o||!(o instanceof HTMLElement)||o.tabIndex===-1)return;const T=window.getComputedStyle(o);T.visibility==="hidden"||T.display==="none"||(_.preventDefault(),_.stopPropagation(),o.focus())}dispose(){this.disposables.dispose()}}function Z(K){return n.isMacintosh?K.browserEvent.metaKey:K.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function ne(K){return K.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ne;function se(K){return K instanceof MouseEvent&&K.button===2}const he={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:ne};class ue{constructor(_){this.list=_,this.disposables=new e.DisposableStore,this._onPointer=new r.Emitter,this.onPointer=this._onPointer.event,_.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||he),this.mouseSupport=typeof _.options.mouseSupport>"u"||!!_.options.mouseSupport,this.mouseSupport&&(_.onMouseDown(this.onMouseDown,this,this.disposables),_.onContextMenu(this.onContextMenu,this,this.disposables),_.onMouseDblClick(this.onDoubleClick,this,this.disposables),_.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(W.Gesture.addTarget(_.getHTMLElement()))),r.Event.any(_.onMouseClick,_.onMouseMiddleClick,_.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(_){_.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,_.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||he))}isSelectionSingleChangeEvent(_){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(_):!1}isSelectionRangeChangeEvent(_){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(_):!1}isSelectionChangeEvent(_){return this.isSelectionSingleChangeEvent(_)||this.isSelectionRangeChangeEvent(_)}onMouseDown(_){k(_.browserEvent.target)||document.activeElement!==_.browserEvent.target&&this.list.domFocus()}onContextMenu(_){if(O(_.browserEvent.target)||k(_.browserEvent.target))return;const j=typeof _.index>"u"?[]:[_.index];this.list.setFocus(j,_.browserEvent)}onViewPointer(_){if(!this.mouseSupport||O(_.browserEvent.target)||k(_.browserEvent.target)||_.browserEvent.isHandledByList)return;_.browserEvent.isHandledByList=!0;const j=_.index;if(typeof j>"u"){this.list.setFocus([],_.browserEvent),this.list.setSelection([],_.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(_))return this.changeSelection(_);if(this.isSelectionChangeEvent(_))return this.changeSelection(_);this.list.setFocus([j],_.browserEvent),this.list.setAnchor(j),se(_.browserEvent)||this.list.setSelection([j],_.browserEvent),this._onPointer.fire(_)}onDoubleClick(_){if(O(_.browserEvent.target)||k(_.browserEvent.target)||this.isSelectionChangeEvent(_)||_.browserEvent.isHandledByList)return;_.browserEvent.isHandledByList=!0;const j=this.list.getFocus();this.list.setSelection(j,_.browserEvent)}changeSelection(_){const j=_.index;let z=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(_)){typeof z>"u"&&(z=this.list.getFocus()[0]??j,this.list.setAnchor(z));const o=Math.min(z,j),T=Math.max(z,j),$=(0,c.range)(o,T+1),Y=this.list.getSelection(),C=ye(Te(Y,[z]),z);if(C.length===0)return;const F=Te($,Oe(Y,C));this.list.setSelection(F,_.browserEvent),this.list.setFocus([j],_.browserEvent)}else if(this.isSelectionSingleChangeEvent(_)){const o=this.list.getSelection(),T=o.filter($=>$!==j);this.list.setFocus([j]),this.list.setAnchor(j),o.length===T.length?this.list.setSelection([...T,j],_.browserEvent):this.list.setSelection(T,_.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=ue;class le{constructor(_,j){this.styleElement=_,this.selectorSuffix=j}style(_){const j=this.selectorSuffix&&`.${this.selectorSuffix}`,z=[];_.listBackground&&z.push(`.monaco-list${j} .monaco-list-rows { background: ${_.listBackground}; }`),_.listFocusBackground&&(z.push(`.monaco-list${j}:focus .monaco-list-row.focused { background-color: ${_.listFocusBackground}; }`),z.push(`.monaco-list${j}:focus .monaco-list-row.focused:hover { background-color: ${_.listFocusBackground}; }`)),_.listFocusForeground&&z.push(`.monaco-list${j}:focus .monaco-list-row.focused { color: ${_.listFocusForeground}; }`),_.listActiveSelectionBackground&&(z.push(`.monaco-list${j}:focus .monaco-list-row.selected { background-color: ${_.listActiveSelectionBackground}; }`),z.push(`.monaco-list${j}:focus .monaco-list-row.selected:hover { background-color: ${_.listActiveSelectionBackground}; }`)),_.listActiveSelectionForeground&&z.push(`.monaco-list${j}:focus .monaco-list-row.selected { color: ${_.listActiveSelectionForeground}; }`),_.listActiveSelectionIconForeground&&z.push(`.monaco-list${j}:focus .monaco-list-row.selected .codicon { color: ${_.listActiveSelectionIconForeground}; }`),_.listFocusAndSelectionBackground&&z.push(`
				.monaco-drag-image,
				.monaco-list${j}:focus .monaco-list-row.selected.focused { background-color: ${_.listFocusAndSelectionBackground}; }
			`),_.listFocusAndSelectionForeground&&z.push(`
				.monaco-drag-image,
				.monaco-list${j}:focus .monaco-list-row.selected.focused { color: ${_.listFocusAndSelectionForeground}; }
			`),_.listInactiveFocusForeground&&(z.push(`.monaco-list${j} .monaco-list-row.focused { color:  ${_.listInactiveFocusForeground}; }`),z.push(`.monaco-list${j} .monaco-list-row.focused:hover { color:  ${_.listInactiveFocusForeground}; }`)),_.listInactiveSelectionIconForeground&&z.push(`.monaco-list${j} .monaco-list-row.focused .codicon { color:  ${_.listInactiveSelectionIconForeground}; }`),_.listInactiveFocusBackground&&(z.push(`.monaco-list${j} .monaco-list-row.focused { background-color:  ${_.listInactiveFocusBackground}; }`),z.push(`.monaco-list${j} .monaco-list-row.focused:hover { background-color:  ${_.listInactiveFocusBackground}; }`)),_.listInactiveSelectionBackground&&(z.push(`.monaco-list${j} .monaco-list-row.selected { background-color:  ${_.listInactiveSelectionBackground}; }`),z.push(`.monaco-list${j} .monaco-list-row.selected:hover { background-color:  ${_.listInactiveSelectionBackground}; }`)),_.listInactiveSelectionForeground&&z.push(`.monaco-list${j} .monaco-list-row.selected { color: ${_.listInactiveSelectionForeground}; }`),_.listHoverBackground&&z.push(`.monaco-list${j}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${_.listHoverBackground}; }`),_.listHoverForeground&&z.push(`.monaco-list${j}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${_.listHoverForeground}; }`);const o=(0,E.asCssValueWithDefault)(_.listFocusAndSelectionOutline,(0,E.asCssValueWithDefault)(_.listSelectionOutline,_.listFocusOutline??""));o&&z.push(`.monaco-list${j}:focus .monaco-list-row.focused.selected { outline: 1px solid ${o}; outline-offset: -1px;}`),_.listFocusOutline&&z.push(`
				.monaco-drag-image,
				.monaco-list${j}:focus .monaco-list-row.focused { outline: 1px solid ${_.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${j}.last-focused .monaco-list-row.focused { outline: 1px solid ${_.listFocusOutline}; outline-offset: -1px; }
			`);const T=(0,E.asCssValueWithDefault)(_.listSelectionOutline,_.listInactiveFocusOutline??"");T&&z.push(`.monaco-list${j} .monaco-list-row.focused.selected { outline: 1px dotted ${T}; outline-offset: -1px; }`),_.listSelectionOutline&&z.push(`.monaco-list${j} .monaco-list-row.selected { outline: 1px dotted ${_.listSelectionOutline}; outline-offset: -1px; }`),_.listInactiveFocusOutline&&z.push(`.monaco-list${j} .monaco-list-row.focused { outline: 1px dotted ${_.listInactiveFocusOutline}; outline-offset: -1px; }`),_.listHoverOutline&&z.push(`.monaco-list${j} .monaco-list-row:hover { outline: 1px dashed ${_.listHoverOutline}; outline-offset: -1px; }`),_.listDropBackground&&z.push(`
				.monaco-list${j}.drop-target,
				.monaco-list${j} .monaco-list-rows.drop-target,
				.monaco-list${j} .monaco-list-row.drop-target { background-color: ${_.listDropBackground} !important; color: inherit !important; }
			`),_.tableColumnsBorder&&z.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${_.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),_.tableOddRowsBackgroundColor&&z.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${_.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=z.join(`
`)}}t.DefaultStyleController=le,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const oe={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ye(K,_){const j=K.indexOf(_);if(j===-1)return[];const z=[];let o=j-1;for(;o>=0&&K[o]===_-(j-o);)z.push(K[o--]);for(z.reverse(),o=j;o<K.length&&K[o]===_+(o-j);)z.push(K[o++]);return z}function Te(K,_){const j=[];let z=0,o=0;for(;z<K.length||o<_.length;)if(z>=K.length)j.push(_[o++]);else if(o>=_.length)j.push(K[z++]);else if(K[z]===_[o]){j.push(K[z]),z++,o++;continue}else K[z]<_[o]?j.push(K[z++]):j.push(_[o++]);return j}function Oe(K,_){const j=[];let z=0,o=0;for(;z<K.length||o<_.length;)if(z>=K.length)j.push(_[o++]);else if(o>=_.length)j.push(K[z++]);else if(K[z]===_[o]){z++,o++;continue}else K[z]<_[o]?j.push(K[z++]):o++;return j}const ke=(K,_)=>K-_;class fe{constructor(_,j){this._templateId=_,this.renderers=j}get templateId(){return this._templateId}renderTemplate(_){return this.renderers.map(j=>j.renderTemplate(_))}renderElement(_,j,z,o){let T=0;for(const $ of this.renderers)$.renderElement(_,j,z[T++],o)}disposeElement(_,j,z,o){let T=0;for(const $ of this.renderers)$.disposeElement?.(_,j,z[T],o),T+=1}disposeTemplate(_){let j=0;for(const z of this.renderers)z.disposeTemplate(_[j++])}}class U{constructor(_){this.accessibilityProvider=_,this.templateId="a18n"}renderTemplate(_){return _}renderElement(_,j,z){const o=this.accessibilityProvider.getAriaLabel(_);o?z.setAttribute("aria-label",o):z.removeAttribute("aria-label");const T=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(_);typeof T=="number"?z.setAttribute("aria-level",`${T}`):z.removeAttribute("aria-level")}disposeTemplate(_){}}class ie{constructor(_,j){this.list=_,this.dnd=j}getDragElements(_){const j=this.list.getSelectedElements();return j.indexOf(_)>-1?j:[_]}getDragURI(_){return this.dnd.getDragURI(_)}getDragLabel(_,j){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(_,j)}onDragStart(_,j){this.dnd.onDragStart?.(_,j)}onDragOver(_,j,z,o){return this.dnd.onDragOver(_,j,z,o)}onDragLeave(_,j,z,o){this.dnd.onDragLeave?.(_,j,z,o)}onDragEnd(_){this.dnd.onDragEnd?.(_)}drop(_,j,z,o){this.dnd.drop(_,j,z,o)}}class q{get onDidChangeFocus(){return r.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),_=>this.toListEvent(_),this.disposables)}get onDidChangeSelection(){return r.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),_=>this.toListEvent(_),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let _=!1;const j=this.disposables.add(r.Event.chain(this.disposables.add(new L.DomEmitter(this.view.domNode,"keydown")).event)).map(T=>new i.StandardKeyboardEvent(T)).filter(T=>_=T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>E.EventHelper.stop(T,!0)).filter(()=>!1).event,z=this.disposables.add(r.Event.chain(this.disposables.add(new L.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>_=!1).map(T=>new i.StandardKeyboardEvent(T)).filter(T=>T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>E.EventHelper.stop(T,!0)).map(({browserEvent:T})=>{const $=this.getFocus(),Y=$.length?$[0]:void 0,C=typeof Y<"u"?this.view.element(Y):void 0,F=typeof Y<"u"?this.view.domElement(Y):this.view.domNode;return{index:Y,element:C,anchor:F,browserEvent:T}}).event,o=this.disposables.add(r.Event.chain(this.view.onContextMenu)).filter(T=>!_).map(({element:T,index:$,browserEvent:Y})=>({element:T,index:$,anchor:{x:Y.pageX+1,y:Y.pageY},browserEvent:Y})).event;return r.Event.any(j,z,o)}get onKeyDown(){return this.disposables.add(new L.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new L.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new L.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.disposables.add(new L.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.disposables.add(new L.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(_,j,z,o,T=oe){this.user=_,this._options=T,this.focus=new A("focused"),this.anchor=new A("anchor"),this.eventBufferer=new r.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event;const $=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new f($!=="listbox");const Y=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=T.accessibilityProvider,this.accessibilityProvider&&(Y.push(new U(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),o=o.map(F=>new fe(F.templateId,[...Y,F]));const C={...T,dnd:T.dnd&&new ie(this,T.dnd)};if(this.view=this.createListView(j,z,o,C),this.view.domNode.setAttribute("role",$),T.styleController)this.styleController=T.styleController(this.view.domId);else{const F=(0,E.createStyleSheet)(this.view.domNode);this.styleController=new le(F,this.view.domId)}if(this.spliceable=new y.CombinedSpliceable([new p(this.focus,this.view,T.identityProvider),new p(this.selection,this.view,T.identityProvider),new p(this.anchor,this.view,T.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new H(this,this.view)),(typeof T.keyboardSupport!="boolean"||T.keyboardSupport)&&(this.keyboardController=new g(this,this.view,T),this.disposables.add(this.keyboardController)),T.keyboardNavigationLabelProvider){const F=T.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new M(this,this.view,T.keyboardNavigationLabelProvider,T.keyboardNavigationEventFilter??(()=>!0),F),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(T),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(_,j,z,o){return new D.ListView(_,j,z,o)}createMouseController(_){return new ue(this)}updateOptions(_={}){this._options={...this._options,..._},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(_),this.keyboardController?.updateOptions(_),this.view.updateOptions(_)}get options(){return this._options}splice(_,j,z=[]){if(_<0||_>this.view.length)throw new s.ListError(this.user,`Invalid start index: ${_}`);if(j<0)throw new s.ListError(this.user,`Invalid delete count: ${j}`);j===0&&z.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(_,j,z))}updateWidth(_){this.view.updateWidth(_)}updateElementHeight(_,j){this.view.updateElementHeight(_,j,null)}rerender(){this.view.rerender()}element(_){return this.view.element(_)}indexOf(_){return this.view.indexOf(_)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(_){this.view.setScrollTop(_)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(_){this.view.setScrollLeft(_)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(_){this._ariaLabel=_,this.view.domNode.setAttribute("aria-label",_)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(_,j){this.view.layout(_,j)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(_,j){for(const z of _)if(z<0||z>=this.length)throw new s.ListError(this.user,`Invalid index ${z}`);this.selection.set(_,j)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(_=>this.view.element(_))}setAnchor(_){if(typeof _>"u"){this.anchor.set([]);return}if(_<0||_>=this.length)throw new s.ListError(this.user,`Invalid index ${_}`);this.anchor.set([_])}getAnchor(){return(0,c.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const _=this.getAnchor();return typeof _>"u"?void 0:this.element(_)}setFocus(_,j){for(const z of _)if(z<0||z>=this.length)throw new s.ListError(this.user,`Invalid index ${z}`);this.focus.set(_,j)}focusNext(_=1,j=!1,z,o){if(this.length===0)return;const T=this.focus.get(),$=this.findNextIndex(T.length>0?T[0]+_:0,j,o);$>-1&&this.setFocus([$],z)}focusPrevious(_=1,j=!1,z,o){if(this.length===0)return;const T=this.focus.get(),$=this.findPreviousIndex(T.length>0?T[0]-_:0,j,o);$>-1&&this.setFocus([$],z)}async focusNextPage(_,j){let z=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);z=z===0?0:z-1;const o=this.getFocus()[0];if(o!==z&&(o===void 0||z>o)){const T=this.findPreviousIndex(z,!1,j);T>-1&&o!==T?this.setFocus([T],_):this.setFocus([z],_)}else{const T=this.view.getScrollTop();let $=T+this.view.renderHeight;z>o&&($-=this.view.elementHeight(z)),this.view.setScrollTop($),this.view.getScrollTop()!==T&&(this.setFocus([]),await(0,a.timeout)(0),await this.focusNextPage(_,j))}}async focusPreviousPage(_,j){let z;const o=this.view.getScrollTop();o===0?z=this.view.indexAt(o):z=this.view.indexAfter(o-1);const T=this.getFocus()[0];if(T!==z&&(T===void 0||T>=z)){const $=this.findNextIndex(z,!1,j);$>-1&&T!==$?this.setFocus([$],_):this.setFocus([z],_)}else{const $=o;this.view.setScrollTop(o-this.view.renderHeight),this.view.getScrollTop()!==$&&(this.setFocus([]),await(0,a.timeout)(0),await this.focusPreviousPage(_,j))}}focusLast(_,j){if(this.length===0)return;const z=this.findPreviousIndex(this.length-1,!1,j);z>-1&&this.setFocus([z],_)}focusFirst(_,j){this.focusNth(0,_,j)}focusNth(_,j,z){if(this.length===0)return;const o=this.findNextIndex(_,!1,z);o>-1&&this.setFocus([o],j)}findNextIndex(_,j=!1,z){for(let o=0;o<this.length;o++){if(_>=this.length&&!j)return-1;if(_=_%this.length,!z||z(this.element(_)))return _;_++}return-1}findPreviousIndex(_,j=!1,z){for(let o=0;o<this.length;o++){if(_<0&&!j)return-1;if(_=(this.length+_%this.length)%this.length,!z||z(this.element(_)))return _;_--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(_=>this.view.element(_))}reveal(_,j){if(_<0||_>=this.length)throw new s.ListError(this.user,`Invalid index ${_}`);const z=this.view.getScrollTop(),o=this.view.elementTop(_),T=this.view.elementHeight(_);if((0,h.isNumber)(j)){const $=T-this.view.renderHeight;this.view.setScrollTop($*(0,l.clamp)(j,0,1)+o)}else{const $=o+T,Y=z+this.view.renderHeight;o<z&&$>=Y||(o<z||$>=Y&&T>=this.view.renderHeight?this.view.setScrollTop(o):$>=Y&&this.view.setScrollTop($-this.view.renderHeight))}}getRelativeTop(_){if(_<0||_>=this.length)throw new s.ListError(this.user,`Invalid index ${_}`);const j=this.view.getScrollTop(),z=this.view.elementTop(_),o=this.view.elementHeight(_);if(z<j||z+o>j+this.view.renderHeight)return null;const T=o-this.view.renderHeight;return Math.abs((j-z)/T)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(_){return this.view.getElementDomId(_)}style(_){this.styleController.style(_)}toListEvent({indexes:_,browserEvent:j}){return{indexes:_,elements:_.map(z=>this.view.element(z)),browserEvent:j}}_onFocusChange(){const _=this.focus.get();this.view.domNode.classList.toggle("element-focused",_.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const _=this.focus.get();if(_.length>0){let j;this.accessibilityProvider?.getActiveDescendantId&&(j=this.accessibilityProvider.getActiveDescendantId(this.view.element(_[0]))),this.view.domNode.setAttribute("aria-activedescendant",j||this.view.getElementDomId(_[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const _=this.selection.get();this.view.domNode.classList.toggle("selection-none",_.length===0),this.view.domNode.classList.toggle("selection-single",_.length===1),this.view.domNode.classList.toggle("selection-multiple",_.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=q,qe([I.memoize],q.prototype,"onDidChangeFocus",null),qe([I.memoize],q.prototype,"onDidChangeSelection",null),qe([I.memoize],q.prototype,"onContextMenu",null),qe([I.memoize],q.prototype,"onKeyDown",null),qe([I.memoize],q.prototype,"onKeyUp",null),qe([I.memoize],q.prototype,"onKeyPress",null),qe([I.memoize],q.prototype,"onDidFocus",null),qe([I.memoize],q.prototype,"onDidBlur",null)}),define(ge[59],me([1,0,7,34,35,11,15]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var y;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(y||(t.MarkdownStringTextNewlineStyle=y={}));class c{constructor(h="",s=!1){if(this.value=h,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(h,s=0){return this.value+=r(this.supportThemeIcons?(0,L.escapeIcons)(h):h).replace(/([ \t]+)/g,(D,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,s){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(h,s,D){return this.value+="[",this.value+=this._escape(s,"]"),this.value+="](",this.value+=this._escape(String(h),")"),D&&(this.value+=` "${this._escape(this._escape(D,'"'),")")}"`),this.value+=")",this}_escape(h,s){const D=new RegExp((0,W.escapeRegExpCharacters)(s),"g");return h.replace(D,(v,A)=>h.charAt(A-1)!=="\\"?`\\${v}`:v)}}t.MarkdownString=c;function a(n){return d(n)?!n.value:Array.isArray(n)?n.every(a):!0}t.isEmptyMarkdownString=a;function d(n){return n instanceof c?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.isMarkdownString=d;function I(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons&&n.supportHtml===h.supportHtml&&(n.baseUri===h.baseUri||!!n.baseUri&&!!h.baseUri&&(0,i.isEqual)(w.URI.from(n.baseUri),w.URI.from(h.baseUri)))}t.markdownStringEqual=I;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function u(n){return n.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=u;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function l(n){const h=[],s=n.split("|").map(v=>v.trim());n=s[0];const D=s[1];if(D){const v=/height=(\d+)/.exec(D),A=/width=(\d+)/.exec(D),f=v?v[1]:"",p=A?A[1]:"",O=isFinite(parseInt(p)),k=isFinite(parseInt(f));O&&h.push(`width="${p}"`),k&&h.push(`height="${f}"`)}return{href:n,dimensions:h}}t.parseHrefAndDimensions=l}),define(ge[122],me([1,0,4,114,20,52,14,21,115,7,3,59,34,73,30,2,76,50,28,47,35,11,15]),function(te,t,E,L,i,W,w,y,c,a,d,I,r,u,e,l,n,h,s,D,v,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const p=Object.freeze({image:(q,K,_)=>{let j=[],z=[];return q&&({href:q,dimensions:j}=(0,I.parseHrefAndDimensions)(q),z.push(`src="${(0,I.escapeDoubleQuotes)(q)}"`)),_&&z.push(`alt="${(0,I.escapeDoubleQuotes)(_)}"`),K&&z.push(`title="${(0,I.escapeDoubleQuotes)(K)}"`),j.length&&(z=z.concat(j)),"<img "+z.join(" ")+">"},paragraph:q=>`<p>${q}</p>`,link:(q,K,_)=>typeof q!="string"?"":(q===_&&(_=(0,I.removeMarkdownEscapes)(_)),K=typeof K=="string"?(0,I.escapeDoubleQuotes)((0,I.removeMarkdownEscapes)(K)):"",q=(0,I.removeMarkdownEscapes)(q),q=q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${q}" title="${K||q}">${_}</a>`)});function O(q,K={},_={}){const j=new l.DisposableStore;let z=!1;const o=(0,W.createElement)(K),T=function(P){let V;try{V=(0,h.parse)(decodeURIComponent(P))}catch{}return V?(V=(0,D.cloneAndChange)(V,G=>{if(q.uris&&q.uris[G])return f.URI.revive(q.uris[G])}),encodeURIComponent(JSON.stringify(V))):P},$=function(P,V){const G=q.uris&&q.uris[P];let ee=f.URI.revive(G);return V?P.startsWith(s.Schemas.data+":")?P:(ee||(ee=f.URI.parse(P)),s.FileAccess.uriToBrowserUri(ee).toString(!0)):!ee||f.URI.parse(P).toString()===ee.toString()?P:(ee.query&&(ee=ee.with({query:T(ee.query)})),ee.toString())},Y=new n.marked.Renderer;Y.image=p.image,Y.link=p.link,Y.paragraph=p.paragraph;const C=[],F=[];if(K.codeBlockRendererSync?Y.code=(P,V)=>{const G=u.defaultGenerator.nextId(),ee=K.codeBlockRendererSync(k(V),P);return F.push([G,ee]),`<div class="code" data-code="${G}">${(0,A.escape)(P)}</div>`}:K.codeBlockRenderer&&(Y.code=(P,V)=>{const G=u.defaultGenerator.nextId(),ee=K.codeBlockRenderer(k(V),P);return C.push(ee.then(re=>[G,re])),`<div class="code" data-code="${G}">${(0,A.escape)(P)}</div>`}),K.actionHandler){const P=function(ee){let re=ee.target;if(!(re.tagName!=="A"&&(re=re.parentElement,!re||re.tagName!=="A")))try{let be=re.dataset.href;be&&(q.baseUri&&(be=m(f.URI.from(q.baseUri),be)),K.actionHandler.callback(be,ee))}catch(be){(0,a.onUnexpectedError)(be)}finally{ee.preventDefault()}},V=K.actionHandler.disposables.add(new i.DomEmitter(o,"click")),G=K.actionHandler.disposables.add(new i.DomEmitter(o,"auxclick"));K.actionHandler.disposables.add(d.Event.any(V.event,G.event)(ee=>{const re=new y.StandardMouseEvent(ee);!re.leftButton&&!re.middleButton||P(re)})),K.actionHandler.disposables.add(E.addDisposableListener(o,"keydown",ee=>{const re=new w.StandardKeyboardEvent(ee);!re.equals(10)&&!re.equals(3)||P(re)}))}q.supportHtml||(_.sanitizer=P=>(q.isTrusted?P.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?P:"",_.sanitize=!0,_.silent=!0),_.renderer=Y;let R=q.value??"";R.length>1e5&&(R=`${R.substr(0,1e5)}\u2026`),q.supportThemeIcons&&(R=(0,r.markdownEscapeEscapedIcons)(R));let S;if(K.fillInIncompleteTokens){const P={...n.marked.defaults,..._},V=n.marked.lexer(R,P),G=he(V);S=n.marked.parser(G,P)}else S=n.marked.parse(R,_);q.supportThemeIcons&&(S=(0,c.renderLabelWithIcons)(S).map(V=>typeof V=="string"?V:V.outerHTML).join(""));const B=new DOMParser().parseFromString(g(q,S),"text/html");if(B.body.querySelectorAll("img").forEach(P=>{const V=P.getAttribute("src");if(V){let G=V;try{q.baseUri&&(G=m(f.URI.from(q.baseUri),G))}catch{}P.src=$(G,!0)}}),B.body.querySelectorAll("a").forEach(P=>{const V=P.getAttribute("href");if(P.setAttribute("href",""),!V||/^data:|javascript:/i.test(V)||/^command:/i.test(V)&&!q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(V))P.replaceWith(...P.childNodes);else{let G=$(V,!1);q.baseUri&&(G=m(f.URI.from(q.baseUri),V)),P.dataset.href=G}}),o.innerHTML=g(q,B.body.innerHTML),C.length>0)Promise.all(C).then(P=>{if(z)return;const V=new Map(P),G=o.querySelectorAll("div[data-code]");for(const ee of G){const re=V.get(ee.dataset.code??"");re&&E.reset(ee,re)}K.asyncRenderCallback?.()});else if(F.length>0){const P=new Map(F),V=o.querySelectorAll("div[data-code]");for(const G of V){const ee=P.get(G.dataset.code??"");ee&&E.reset(G,ee)}}if(K.asyncRenderCallback)for(const P of o.getElementsByTagName("img")){const V=j.add(E.addDisposableListener(P,"load",()=>{V.dispose(),K.asyncRenderCallback()}))}return{element:o,dispose:()=>{z=!0,j.dispose()}}}t.renderMarkdown=O;function k(q){if(!q)return"";const K=q.split(/[\s+|:|,|\{|\?]/,1);return K.length?K[0]:q}function m(q,K){return/^\w[\w\d+.-]*:/.test(K)?K:q.path.endsWith("/")?(0,v.resolvePath)(q,K).toString():(0,v.resolvePath)((0,v.dirname)(q),K).toString()}function g(q,K){const{config:_,allowedSchemes:j}=b(q);L.addHook("uponSanitizeAttribute",(o,T)=>{if(T.attrName==="style"||T.attrName==="class"){if(o.tagName==="SPAN"){if(T.attrName==="style"){T.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(T.attrValue);return}else if(T.attrName==="class"){T.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(T.attrValue);return}}T.keepAttr=!1;return}});const z=E.hookDomPurifyHrefAndSrcSanitizer(j);try{return L.sanitize(K,{..._,RETURN_TRUSTED_TYPE:!0})}finally{L.removeHook("uponSanitizeAttribute"),z.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function b(q){const K=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return q.isTrusted&&K.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...E.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:K}}function N(q){return typeof q=="string"?q:M(q)}t.renderStringAsPlaintext=N;function M(q){let K=q.value??"";K.length>1e5&&(K=`${K.substr(0,1e5)}\u2026`);const _=n.marked.parse(K,{renderer:Z.value}).replace(/&(#\d+|[a-zA-Z]+);/g,j=>H.get(j)??j);return g({isTrusted:!1},_).toString()}t.renderMarkdownAsPlaintext=M;const H=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),Z=new e.Lazy(()=>{const q=new n.marked.Renderer;return q.code=K=>K,q.blockquote=K=>K,q.html=K=>"",q.heading=(K,_,j)=>K+`
`,q.hr=()=>"",q.list=(K,_)=>K,q.listitem=K=>K+`
`,q.paragraph=K=>K+`
`,q.table=(K,_)=>K+_+`
`,q.tablerow=K=>K,q.tablecell=(K,_)=>K+" ",q.strong=K=>K,q.em=K=>K,q.codespan=K=>K,q.br=()=>`
`,q.del=K=>K,q.image=(K,_,j)=>"",q.text=K=>K,q.link=(K,_,j)=>j,q});function ne(q){let K="";return q.forEach(_=>{K+=_.raw}),K}function se(q){for(const K of q.tokens)if(K.type==="text"){const _=K.raw.split(`
`),j=_[_.length-1];if(j.includes("`"))return le(q);if(j.includes("**"))return ke(q);if(j.match(/\*\w/))return oe(q);if(j.match(/(^|\s)__\w/))return fe(q);if(j.match(/(^|\s)_\w/))return ye(q);if(j.match(/(^|\s)\[.*\]\(\w*/))return Te(q);if(j.match(/(^|\s)\[\w/))return Oe(q)}}function he(q){let K,_;for(K=0;K<q.length;K++){const j=q[K];if(j.type==="paragraph"&&j.raw.match(/(\n|^)```/)){_=ue(q.slice(K));break}if(j.type==="paragraph"&&j.raw.match(/(\n|^)\|/)){_=ie(q.slice(K));break}if(K===q.length-1&&j.type==="paragraph"){const z=se(j);if(z){_=[z];break}}}if(_){const j=[...q.slice(0,K),..._];return j.links=q.links,j}return q}t.fillInIncompleteTokens=he;function ue(q){const K=ne(q);return n.marked.lexer(K+"\n```")}function le(q){return U(q,"`")}function oe(q){return U(q,"*")}function ye(q){return U(q,"_")}function Te(q){return U(q,")")}function Oe(q){return U(q,"](about:blank)")}function ke(q){return U(q,"**")}function fe(q){return U(q,"__")}function U(q,K){const _=ne(Array.isArray(q)?q:[q]);return n.marked.lexer(_+K)[0]}function ie(q){const K=ne(q),_=K.split(`
`);let j,z=!1;for(let o=0;o<_.length;o++){const T=_[o].trim();if(typeof j>"u"&&T.match(/^\s*\|/)){const $=T.match(/(\|[^\|]+)(?=\||$)/g);$&&(j=$.length)}else if(typeof j=="number")if(T.match(/^\s*\|/)){if(o!==_.length-1)return;z=!0}else return}if(typeof j=="number"&&j>0){const o=z?_.slice(0,-1).join(`
`):K,T=!!o.match(/\|\s*$/),$=o+(T?"":"|")+`
|${" --- |".repeat(j)}`;return n.marked.lexer($)}}}),define(ge[123],me([1,0,4,9,27,59,34,2,6,99]),function(te,t,E,L,i,W,w,y,c,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function d(u,e){(0,c.isString)(e)?u.title=(0,w.stripIcons)(e):e?.markdownNotSupportedFallback?u.title=e.markdownNotSupportedFallback:u.removeAttribute("title")}t.setupNativeHover=d;class I{constructor(e,l,n){this.hoverDelegate=e,this.target=l,this.fadeInAnimation=n}async update(e,l,n){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let h;if(e===void 0||(0,c.isString)(e)||e instanceof HTMLElement)h=e;else if(!(0,c.isFunction)(e.markdown))h=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,a.localize)(0,null),l),this._cancellationTokenSource=new i.CancellationTokenSource;const s=this._cancellationTokenSource.token;if(h=await e.markdown(s),h===void 0&&(h=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.show(h,l,n)}show(e,l,n){const h=this._hoverWidget;if(this.hasContent(e)){const s={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!h,...n};this._hoverWidget=this.hoverDelegate.showHover(s,l)}h?.dispose()}hasContent(e){return e?(0,W.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function r(u,e,l,n){let h,s;const D=(O,k)=>{const m=s!==void 0;O&&(s?.dispose(),s=void 0),k&&(h?.dispose(),h=void 0),m&&u.onDidHideHover?.()},v=(O,k,m)=>new L.TimeoutTimer(async()=>{(!s||s.isDisposed)&&(s=new I(u,m||e,O>0),await s.update(l,k,n))},O),A=()=>{if(h)return;const O=new y.DisposableStore,k=b=>D(!1,b.fromElement===e);O.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,k,!0));const m=()=>D(!0,!0);O.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,m,!0));const g={targetElements:[e],dispose:()=>{}};if(u.placement===void 0||u.placement==="mouse"){const b=N=>{g.x=N.x+10,N.target instanceof HTMLElement&&N.target.classList.contains("action-label")&&D(!0,!0)};O.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,b,!0))}O.add(v(u.delay,!1,g)),h=O},f=E.addDisposableListener(e,E.EventType.MOUSE_OVER,A,!0);return{show:O=>{D(!1,!0),v(0,O)},hide:()=>{D(!0,!0)},update:async(O,k)=>{l=O,await s?.update(l,void 0,k)},dispose:()=>{f.dispose(),D(!0,!0)}}}t.setupCustomHover=r}),define(ge[124],me([1,0,4,20,14,122,37,13,3,42,2,5,101,92]),function(te,t,E,L,i,W,w,y,c,a,d,I,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const u=E.$,e="selectOption.entry.template";class l{get templateId(){return e}renderTemplate(s){const D=Object.create(null);return D.root=s,D.text=E.append(s,u(".option-text")),D.detail=E.append(s,u(".option-detail")),D.decoratorRight=E.append(s,u(".option-decorator-right")),D}renderElement(s,D,v){const A=v,f=s.text,p=s.detail,O=s.decoratorRight,k=s.isDisabled;A.text.textContent=f,A.detail.textContent=p||"",A.decoratorRight.innerText=O||"",k?A.root.classList.add("option-disabled"):A.root.classList.remove("option-disabled")}disposeTemplate(s){}}class n extends d.Disposable{constructor(s,D,v,A,f){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=A,this.selectBoxOptions=f||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=n.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new c.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(v),this.selected=D||0,s&&this.setOptions(s,D),this.initStyleSheet()}getHeight(){return 22}getTemplateId(){return e}constructSelectDropDown(s){this.contextViewProvider=s,this.selectDropDownContainer=E.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=E.append(this.selectDropDownContainer,u(".select-box-details-pane"));const D=E.append(this.selectDropDownContainer,u(".select-box-dropdown-container-width-control")),v=E.append(D,u(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",E.append(v,this.widthControlElement),this._dropDownPosition=0,this.styleElement=E.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.DRAG_START,A=>{E.EventHelper.stop(A,!0)}))}registerListeners(){this._register(E.addStandardDisposableListener(this.selectElement,"change",D=>{this.selected=D.target.selectedIndex,this._onDidSelect.fire({index:D.target.selectedIndex,selected:D.target.value}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(E.addDisposableListener(this.selectElement,E.EventType.CLICK,D=>{E.EventHelper.stop(D),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.MOUSE_DOWN,D=>{E.EventHelper.stop(D)}));let s;this._register(E.addDisposableListener(this.selectElement,"touchstart",D=>{s=this._isVisible})),this._register(E.addDisposableListener(this.selectElement,"touchend",D=>{E.EventHelper.stop(D),s?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.KEY_DOWN,D=>{const v=new i.StandardKeyboardEvent(D);let A=!1;I.isMacintosh?(v.keyCode===18||v.keyCode===16||v.keyCode===10||v.keyCode===3)&&(A=!0):(v.keyCode===18&&v.altKey||v.keyCode===16&&v.altKey||v.keyCode===10||v.keyCode===3)&&(A=!0),A&&(this.showSelectDropDown(),E.EventHelper.stop(D,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(s,D){y.equals(this.options,s)||(this.options=s,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((v,A)=>{this.selectElement.add(this.createOption(v.text,A,v.isDisabled)),typeof v.description=="string"&&(this._hasDetails=!0)})),D!==void 0&&(this.select(D),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(s){s>=0&&s<this.options.length?this.selected=s:s>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(s){this.selectBoxOptions.ariaLabel=s,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(s){this.selectElement.tabIndex=s?0:-1}render(s){this.container=s,s.classList.add("select-container"),s.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const s=[];this.styles.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=s.join(`
`)}styleSelectElement(){const s=this.styles.selectBackground??"",D=this.styles.selectForeground??"",v=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=s,this.selectElement.style.color=D,this.selectElement.style.borderColor=v}styleList(){const s=this.styles.selectBackground??"",D=E.asCssValueWithDefault(this.styles.selectListBackground,s);this.selectDropDownListContainer.style.backgroundColor=D,this.selectionDetailsPane.style.backgroundColor=D;const v=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=v,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(s,D,v){const A=document.createElement("option");return A.value=s,A.text=s,A.disabled=!!v,A}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:s=>this.renderSelectDropDown(s,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:s=>this.renderSelectDropDown(s),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(s){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),s&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(s,D){return s.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(D),{dispose:()=>{try{s.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let s=0;return this.options.forEach((D,v)=>{this.updateDetail(v),this.selectionDetailsPane.offsetHeight>s&&(s=this.selectionDetailsPane.offsetHeight)}),s}layoutSelectDropDown(s){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const D=E.getDomNodePagePosition(this.selectElement),v=getComputedStyle(this.selectElement),A=parseFloat(v.getPropertyValue("--dropdown-padding-top"))+parseFloat(v.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-D.top-D.height-(this.selectBoxOptions.minBottomMargin||0),p=D.top-n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,O=this.selectElement.offsetWidth,k=this.setWidthControlElement(this.widthControlElement),m=Math.max(k,Math.round(O)).toString()+"px";this.selectDropDownContainer.style.width=m,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let g=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const b=this._hasDetails?this._cachedMaxDetailsHeight:0,N=g+A+b,M=Math.floor((f-A-b)/this.getHeight()),H=Math.floor((p-A-b)/this.getHeight());if(s)return D.top+D.height>window.innerHeight-22||D.top<n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||M<1&&H<1?!1:(M<n.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&H>M&&this.options.length>M?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(D.top+D.height>window.innerHeight-22||D.top<n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&M<1||this._dropDownPosition===1&&H<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&M+H<1)return this.hideSelectDropDown(!0),!1;N>f&&(g=M*this.getHeight())}else N>p&&(g=H*this.getHeight());return this.selectList.layout(g),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=g+A+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=g+A+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=m,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(s){let D=0;if(s){let v=0,A=0;this.options.forEach((f,p)=>{const O=f.detail?f.detail.length:0,k=f.decoratorRight?f.decoratorRight.length:0,m=f.text.length+O+k;m>A&&(v=p,A=m)}),s.textContent=this.options[v].text+(this.options[v].decoratorRight?this.options[v].decoratorRight+" ":""),D=E.getTotalWidth(s)}return D}createSelectList(s){if(this.selectList)return;this.selectDropDownListContainer=E.append(s,u(".select-box-dropdown-list-container")),this.listRenderer=new l,this.selectList=new w.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:A=>{let f=A.text;return A.detail&&(f+=`. ${A.detail}`),A.decoratorRight&&(f+=`. ${A.decoratorRight}`),A.description&&(f+=`. ${A.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>I.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const D=this._register(new L.DomEmitter(this.selectDropDownListContainer,"keydown")),v=c.Event.chain(D.event).filter(()=>this.selectList.length>0).map(A=>new i.StandardKeyboardEvent(A));this._register(v.filter(A=>A.keyCode===3).on(A=>this.onEnter(A),this)),this._register(v.filter(A=>A.keyCode===2).on(A=>this.onEnter(A),this)),this._register(v.filter(A=>A.keyCode===9).on(A=>this.onEscape(A),this)),this._register(v.filter(A=>A.keyCode===16).on(A=>this.onUpArrow(A),this)),this._register(v.filter(A=>A.keyCode===18).on(A=>this.onDownArrow(A),this)),this._register(v.filter(A=>A.keyCode===12).on(this.onPageDown,this)),this._register(v.filter(A=>A.keyCode===11).on(this.onPageUp,this)),this._register(v.filter(A=>A.keyCode===14).on(this.onHome,this)),this._register(v.filter(A=>A.keyCode===13).on(this.onEnd,this)),this._register(v.filter(A=>A.keyCode>=21&&A.keyCode<=56||A.keyCode>=85&&A.keyCode<=113).on(this.onCharacter,this)),this._register(E.addDisposableListener(this.selectList.getHTMLElement(),E.EventType.POINTER_UP,A=>this.onPointerUp(A))),this._register(this.selectList.onMouseOver(A=>typeof A.index<"u"&&this.selectList.setFocus([A.index]))),this._register(this.selectList.onDidChangeFocus(A=>this.onListFocus(A))),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.FOCUS_OUT,A=>{!this._isVisible||E.isAncestor(A.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(s){if(!this.selectList.length)return;E.EventHelper.stop(s);const D=s.target;if(!D||D.classList.contains("slider"))return;const v=D.closest(".monaco-list-row");if(!v)return;const A=Number(v.getAttribute("data-index")),f=v.classList.contains("option-disabled");A>=0&&A<this.options.length&&!f&&(this.selected=A,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(s,D){const v=f=>{for(let p=0;p<f.childNodes.length;p++){const O=f.childNodes.item(p);(O.tagName&&O.tagName.toLowerCase())==="img"?f.removeChild(O):v(O)}},A=(0,W.renderMarkdown)({value:s,supportThemeIcons:!0},{actionHandler:D});return A.element.classList.add("select-box-description-markdown"),v(A.element),A.element}onListFocus(s){!this._isVisible||!this._hasDetails||this.updateDetail(s.indexes[0])}updateDetail(s){this.selectionDetailsPane.innerText="";const D=this.options[s],v=D?.description??"",A=D?.descriptionIsMarkdown??!1;if(v){if(A){const f=D.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(v,f))}else this.selectionDetailsPane.innerText=v;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(s){E.EventHelper.stop(s),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(s){E.EventHelper.stop(s),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(s){if(this.selected<this.options.length-1){E.EventHelper.stop(s,!0);const D=this.options[this.selected+1].isDisabled;if(D&&this.options.length>this.selected+2)this.selected+=2;else{if(D)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(s){this.selected>0&&(E.EventHelper.stop(s,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(s){E.EventHelper.stop(s),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(s){E.EventHelper.stop(s),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(s){E.EventHelper.stop(s),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(s){E.EventHelper.stop(s),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(s){const D=a.KeyCodeUtils.toString(s.keyCode);let v=-1;for(let A=0;A<this.options.length-1;A++)if(v=(A+this.selected+1)%this.options.length,this.options[v].text.charAt(0).toUpperCase()===D&&!this.options[v].isDisabled){this.select(v),this.selectList.setFocus([v]),this.selectList.reveal(this.selectList.getFocus()[0]),E.EventHelper.stop(s);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=n,n.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,n.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(ge[125],me([1,0,37,124,118,19,5,91]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...E.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends W.Widget{constructor(a,d,I,r,u){super(),w.isMacintosh&&!u?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(a,d,r,u):this.selectBoxDelegate=new L.SelectBoxList(a,d,I,r,u),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(a,d){this.selectBoxDelegate.setOptions(a,d)}select(a){this.selectBoxDelegate.select(a)}setAriaLabel(a){this.selectBoxDelegate.setAriaLabel(a)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(a){this.selectBoxDelegate.setFocusable(a)}render(a){this.selectBoxDelegate.render(a)}}t.SelectBox=y}),define(ge[60],me([1,0,18,51,4,23,123,125,32,2,5,6,96,48]),function(te,t,E,L,i,W,w,y,c,a,d,I,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class u extends a.Disposable{get action(){return this._action}constructor(h,s,D={}){super(),this.options=D,this._context=h||this,this._action=s,s instanceof c.Action&&this._register(s.onDidChange(v=>{this.element&&this.handleActionChangeEvent(v)}))}handleActionChangeEvent(h){h.enabled!==void 0&&this.updateEnabled(),h.checked!==void 0&&this.updateChecked(),h.class!==void 0&&this.updateClass(),h.label!==void 0&&(this.updateLabel(),this.updateTooltip()),h.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new c.ActionRunner)),this._actionRunner}set actionRunner(h){this._actionRunner=h}isEnabled(){return this._action.enabled}setActionContext(h){this._context=h}render(h){const s=this.element=h;this._register(W.Gesture.addTarget(h));const D=this.options&&this.options.draggable;D&&(h.draggable=!0,E.isFirefox&&this._register((0,i.addDisposableListener)(h,i.EventType.DRAG_START,v=>v.dataTransfer?.setData(L.DataTransfers.TEXT,this._action.label)))),this._register((0,i.addDisposableListener)(s,W.EventType.Tap,v=>this.onClick(v,!0))),this._register((0,i.addDisposableListener)(s,i.EventType.MOUSE_DOWN,v=>{D||i.EventHelper.stop(v,!0),this._action.enabled&&v.button===0&&s.classList.add("active")})),d.isMacintosh&&this._register((0,i.addDisposableListener)(s,i.EventType.CONTEXT_MENU,v=>{v.button===0&&v.ctrlKey===!0&&this.onClick(v)})),this._register((0,i.addDisposableListener)(s,i.EventType.CLICK,v=>{i.EventHelper.stop(v,!0),this.options&&this.options.isMenu||this.onClick(v)})),this._register((0,i.addDisposableListener)(s,i.EventType.DBLCLICK,v=>{i.EventHelper.stop(v,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(v=>{this._register((0,i.addDisposableListener)(s,v,A=>{i.EventHelper.stop(A),s.classList.remove("active")}))})}onClick(h,s=!1){i.EventHelper.stop(h,!0);const D=I.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?h:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,D)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(h){this.element&&(this.element.tabIndex=h?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const h=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(h):(this.customHover=(0,w.setupCustomHover)(this.options.hoverDelegate,this.element,h),this._store.add(this.customHover))):this.element.title=h}updateAriaLabel(){if(this.element){const h=this.getTooltip()??"";this.element.setAttribute("aria-label",h)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=u;class e extends u{constructor(h,s,D){super(h,s,D),this.options=D,this.options.icon=D.icon!==void 0?D.icon:!1,this.options.label=D.label!==void 0?D.label:!0,this.cssClass=""}render(h){super.render(h),this.element&&(this.label=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.label&&this.label.setAttribute("role",this.getDefaultAriaRole()),this.options.label&&this.options.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===c.Separator.ID?"presentation":this.options.isMenu?"menuitem":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(h){this.label&&(this.label.tabIndex=h?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let h=null;return this.action.tooltip?h=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(h=this.action.label,this.options.keybinding&&(h=r.localize(0,null,h,this.options.keybinding))),h??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const h=this.getTooltip()??"";this.label.setAttribute("aria-label",h)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox")):(this.label.classList.remove("checked"),this.label.setAttribute("aria-checked",""),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=e;class l extends u{constructor(h,s,D,v,A,f,p){super(h,s),this.selectBox=new y.SelectBox(D,v,A,f,p),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(h,s){this.selectBox.setOptions(h,s)}select(h){this.selectBox.select(h)}registerListeners(){this._register(this.selectBox.onDidSelect(h=>this.runAction(h.selected,h.index)))}runAction(h,s){this.actionRunner.run(this._action,this.getActionContext(h,s))}getActionContext(h,s){return h}setFocusable(h){this.selectBox.setFocusable(h)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(h){this.selectBox.render(h)}}t.SelectActionViewItem=l}),define(ge[61],me([1,0,4,14,60,32,3,2,6,48]),function(te,t,E,L,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var a;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(a||(t.ActionsOrientation=a={}));class d extends y.Disposable{constructor(u,e={}){super(),this._actionRunnerDisposables=this._register(new y.DisposableStore),this.viewItemDisposables=this._register(new y.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new w.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new w.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new W.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(h=>this._onDidRun.fire(h))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(h=>this._onWillRun.fire(h))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let l,n;switch(this._orientation){case 0:l=[15],n=[17];break;case 1:l=[16],n=[18],this.domNode.className+=" vertical";break}this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,h=>{const s=new L.StandardKeyboardEvent(h);let D=!0;const v=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;l&&(s.equals(l[0])||s.equals(l[1]))?D=this.focusPrevious():n&&(s.equals(n[0])||s.equals(n[1]))?D=this.focusNext():s.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():s.equals(14)?D=this.focusFirst():s.equals(13)?D=this.focusLast():s.equals(2)&&v instanceof i.BaseActionViewItem&&v.trapsArrowNavigation?D=this.focusNext():this.isTriggerKeyEvent(s)?this._triggerKeys.keyDown?this.doTrigger(s):this.triggerKeyDown=!0:D=!1,D&&(s.preventDefault(),s.stopPropagation())})),this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,h=>{const s=new L.StandardKeyboardEvent(h);this.isTriggerKeyEvent(s)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(E.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),u.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(u){u?this.actionsList.setAttribute("aria-label",u):this.actionsList.removeAttribute("aria-label")}setFocusable(u){if(this.focusable=u,this.focusable){const e=this.viewItems.find(l=>l instanceof i.BaseActionViewItem&&l.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(u){let e=!1;return this._triggerKeys.keys.forEach(l=>{e=e||u.equals(l)}),e}updateFocusedItem(){for(let u=0;u<this.actionsList.children.length;u++){const e=this.actionsList.children[u];if(E.isAncestor(E.getActiveElement(),e)){this.focusedItem=u;break}}}get context(){return this._context}set context(u){this._context=u,this.viewItems.forEach(e=>e.setActionContext(u))}get actionRunner(){return this._actionRunner}set actionRunner(u){this._actionRunner=u,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(e=>this._onDidRun.fire(e))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(e=>this._onWillRun.fire(e))),this.viewItems.forEach(e=>e.actionRunner=u)}getContainer(){return this.domNode}hasAction(u){return this.viewItems.findIndex(e=>e.action.id===u.id)!==-1}getAction(u){if(typeof u=="number")return this.viewItems[u]?.action;if(u instanceof HTMLElement){for(;u.parentElement!==this.actionsList;){if(!u.parentElement)return;u=u.parentElement}for(let e=0;e<this.actionsList.childNodes.length;e++)if(this.actionsList.childNodes[e]===u)return this.viewItems[e].action}}push(u,e={}){const l=Array.isArray(u)?u:[u];let n=c.isNumber(e.index)?e.index:null;l.forEach(h=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let D;const v={hoverDelegate:this.options.hoverDelegate,...e};this.options.actionViewItemProvider&&(D=this.options.actionViewItemProvider(h,v)),D||(D=new i.ActionViewItem(this.context,h,v)),this.options.allowContextMenu||this.viewItemDisposables.set(D,E.addDisposableListener(s,E.EventType.CONTEXT_MENU,A=>{E.EventHelper.stop(A,!0)})),D.actionRunner=this._actionRunner,D.setActionContext(this.context),D.render(s),this.focusable&&D instanceof i.BaseActionViewItem&&this.viewItems.length===0&&D.setFocusable(!0),n===null||n<0||n>=this.actionsList.children.length?(this.actionsList.appendChild(s),this.viewItems.push(D)):(this.actionsList.insertBefore(s,this.actionsList.children[n]),this.viewItems.splice(n,0,D),n++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(u){if(u>=0&&u<this.actionsList.children.length){const e=this.actionsList.children.item(u);if(e)return e.clientWidth}return 0}getHeight(u){if(u>=0&&u<this.actionsList.children.length){const e=this.actionsList.children.item(u);if(e)return e.clientHeight}return 0}pull(u){u>=0&&u<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[u]),this.viewItemDisposables.deleteAndDispose(this.viewItems[u]),(0,y.dispose)(this.viewItems.splice(u,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,y.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),E.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(u){let e=!1,l;if(u===void 0?e=!0:typeof u=="number"?l=u:typeof u=="boolean"&&(e=u),e&&typeof this.focusedItem>"u"){const n=this.viewItems.findIndex(h=>h.isEnabled());this.focusedItem=n===-1?void 0:n,this.updateFocus(void 0,void 0,!0)}else l!==void 0&&(this.focusedItem=l),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(u){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let l;do{if(!u&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,l=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!l.isEnabled()||l.action.id===W.Separator.ID));return this.updateFocus(),!0}focusPrevious(u){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let l;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!u&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}l=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!l.isEnabled()||l.action.id===W.Separator.ID));return this.updateFocus(!0),!0}updateFocus(u,e,l=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const n=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(n){let h=!0;c.isFunction(n.focus)||(h=!1),this.options.focusOnlyEnabledItems&&c.isFunction(n.isEnabled)&&!n.isEnabled()&&(h=!1),n.action.id===W.Separator.ID&&(h=!1),h?(l||this.previouslyFocusedItem!==this.focusedItem)&&(n.focus(u),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(u){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof i.BaseActionViewItem){const l=e._context===null||e._context===void 0?u:e._context;this.run(e._action,l)}}async run(u,e){await this._actionRunner.run(u,e)}dispose(){this._context=void 0,this.viewItems=(0,y.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=d;function I(r){if(!r.length)return r;let u=-1;for(let l=0;l<r.length;l++)if(r[l].id!==W.Separator.ID){u=l;break}if(u===-1)return[];r=r.slice(u);for(let l=r.length-1;l>=0&&r[l].id===W.Separator.ID;l--)r.splice(l,1);let e=!1;for(let l=r.length-1;l>=0;l--){const n=r[l].id===W.Separator.ID;n&&!e?r.splice(l,1):n?n&&(e=!1):e=!0}return r}t.prepareActions=I}),define(ge[62],me([1,0,4,20,52,61,54,57,19,3,78,47,100,88]),function(te,t,E,L,i,W,w,y,c,a,d,I,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const u=E.$;var e;(function(h){h[h.INFO=1]="INFO",h[h.WARNING=2]="WARNING",h[h.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class l extends c.Widget{constructor(s,D,v){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new a.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new a.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=D,this.options=v,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=E.append(s,u(".monaco-inputbox.idle"));const A=this.options.flexibleHeight?"textarea":"input",f=E.append(this.element,u(".ibwrapper"));if(this.input=E.append(f,u(A+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=E.append(f,u("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new y.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),E.append(s,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(k=>this.input.scrollTop=k.scrollTop));const p=this._register(new L.DomEmitter(document,"selectionchange")),O=a.Event.filter(p.event,()=>document.getSelection()?.anchorNode===f);this._register(O(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new W.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(s){this.placeholder=s,this.input.setAttribute("placeholder",s)}setTooltip(s){this.tooltip=s,this.input.title=s}setAriaLabel(s){this.ariaLabel=s,s?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(s){this.input.value!==s&&(this.input.value=s,this.onValueChange())}get step(){return this.input.step}set step(s){this.input.step=s}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:E.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(s=null){this.input.select(),s&&(this.input.setSelectionRange(s.start,s.end),s.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(s){s?this.enable():this.disable()}get width(){return E.getTotalWidth(this.input)}set width(s){if(this.options.flexibleHeight&&this.options.flexibleWidth){let D=0;if(this.mirror){const v=parseFloat(this.mirror.style.paddingLeft||"")||0,A=parseFloat(this.mirror.style.paddingRight||"")||0;D=v+A}this.input.style.width=s-D+"px"}else this.input.style.width=s+"px";this.mirror&&(this.mirror.style.width=s+"px")}set paddingRight(s){this.input.style.width=`calc(100% - ${s}px)`,this.mirror&&(this.mirror.style.paddingRight=s+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const s=this.cachedContentHeight,D=this.cachedHeight,v=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:s,height:D}),this.scrollableElement.setScrollPosition({scrollTop:v})}showMessage(s,D){if(this.state==="open"&&(0,I.equals)(this.message,s))return;this.message=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(s.type));const v=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${E.asCssValueWithDefault(v.border,"transparent")}`,this.message.content&&(this.hasFocus()||D)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let s=null;return this.validation&&(s=this.validation(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const D=this.options.inputBoxStyles;switch(s){case 1:return{border:D.inputValidationInfoBorder,background:D.inputValidationInfoBackground,foreground:D.inputValidationInfoForeground};case 2:return{border:D.inputValidationWarningBorder,background:D.inputValidationWarningBackground,foreground:D.inputValidationWarningForeground};default:return{border:D.inputValidationErrorBorder,background:D.inputValidationErrorBackground,foreground:D.inputValidationErrorForeground}}}classForType(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let s;const D=()=>s.style.width=E.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:A=>{if(!this.message)return null;s=E.append(A,u(".monaco-inputbox-container")),D();const f={inline:!0,className:"monaco-inputbox-message"},p=this.message.formatContent?(0,i.renderFormattedText)(this.message.content,f):(0,i.renderText)(this.message.content,f);p.classList.add(this.classForType(this.message.type));const O=this.stylesForType(this.message.type);return p.style.backgroundColor=O.background??"",p.style.color=O.foreground??"",p.style.border=O.border?`1px solid ${O.border}`:"",E.append(s,p),null},onHide:()=>{this.state="closed"},layout:D});let v;this.message.type===3?v=r.localize(0,null,this.message.content):this.message.type===2?v=r.localize(1,null,this.message.content):v=r.localize(2,null,this.message.content),w.alert(v),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const s=this.value,v=s.charCodeAt(s.length-1)===10?" ":"";(s+v).replace(/\u000c/g,"")?this.mirror.textContent=s+v:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const s=this.options.inputBoxStyles,D=s.inputBackground??"",v=s.inputForeground??"",A=s.inputBorder??"";this.element.style.backgroundColor=D,this.element.style.color=v,this.input.style.backgroundColor="inherit",this.input.style.color=v,this.element.style.border=`1px solid ${E.asCssValueWithDefault(A,"transparent")}`}layout(){if(!this.mirror)return;const s=this.cachedContentHeight;this.cachedContentHeight=E.getTotalHeight(this.mirror),s!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(s){const D=this.inputElement,v=D.selectionStart,A=D.selectionEnd,f=D.value;v!==null&&A!==null&&(this.value=f.substr(0,v)+s+f.substr(A),D.setSelectionRange(v+1,v+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=l;class n extends l{constructor(s,D,v){const A=r.localize(3,null),f=` or \u21C5 ${A}`,p=` (\u21C5 ${A})`;super(s,D,v),this._onDidFocus=this._register(new a.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new a.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new d.HistoryNavigator(v.history,100);const O=()=>{if(v.showHistoryHint&&v.showHistoryHint()&&!this.placeholder.endsWith(f)&&!this.placeholder.endsWith(p)&&this.history.getHistory().length){const k=this.placeholder.endsWith(")")?f:p,m=this.placeholder+k;v.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=m:this.setPlaceHolder(m)}};this.observer=new MutationObserver((k,m)=>{k.forEach(g=>{g.target.textContent||O()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>O()),this.onblur(this.input,()=>{const k=m=>{if(this.placeholder.endsWith(m)){const g=this.placeholder.slice(0,this.placeholder.length-m.length);return v.showPlaceholderOnFocus?this.placeholder=g:this.setPlaceHolder(g),!0}else return!1};k(p)||k(f)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(s){this.value&&(s||this.value!==this.getCurrentValue())&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let s=this.getNextValue();s&&(s=s===this.value?this.getNextValue():s),this.value=s??"",w.status(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let s=this.getPreviousValue();s&&(s=s===this.value?this.getPreviousValue():s),s&&(this.value=s,w.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let s=this.history.current();return s||(s=this.history.last(),this.history.next()),s}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=n}),define(ge[63],me([1,0,60,19,16,17,3,93]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends E.BaseActionViewItem{constructor(I,r,u){super(I,r,u),this.toggle=this._register(new c({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:u.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:u.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:u.toggleStyles?.inputActiveOptionForeground})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(I){this.element=I,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(I){this.toggle.domNode.tabIndex=I?0:-1}}t.ToggleActionViewItem=y;class c extends L.Widget{constructor(I){super(),this._onChange=this._register(new w.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new w.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=I,this._checked=this._opts.isChecked;const r=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,r.push(...W.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&r.push(...this._opts.actionClassName.split(" ")),this._checked&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...r),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,u=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),u.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,u=>{if(u.keyCode===10||u.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),u.preventDefault(),u.stopPropagation();return}this._onKeyDown.fire(u)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(I){this._checked=I,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(I){this._icon&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this._icon)),this._icon=I,this._icon&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(I){this.domNode.title=I,this.domNode.setAttribute("aria-label",I)}}t.Toggle=c;class a extends L.Widget{constructor(I,r,u){super(),this.title=I,this.isChecked=r,this.checkbox=new c({title:this.title,isChecked:this.isChecked,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.checkbox.domNode,this.styles=u,this.applyStyles(),this._register(this.checkbox.onChange(()=>this.applyStyles()))}get checked(){return this.checkbox.checked}set checked(I){this.checkbox.checked=I,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=a}),define(ge[126],me([1,0,63,16,98]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const W=i.localize(0,null),w=i.localize(1,null),y=i.localize(2,null);class c extends E.Toggle{constructor(r){super({icon:L.Codicon.caseSensitive,title:W+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=c;class a extends E.Toggle{constructor(r){super({icon:L.Codicon.wholeWord,title:w+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=a;class d extends E.Toggle{constructor(r){super({icon:L.Codicon.regex,title:y+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=d}),define(ge[127],me([1,0,4,126,62,19,3,97,2,87]),function(te,t,E,L,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const a=y.localize(0,null);class d extends W.Widget{constructor(r,u,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new c.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new w.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new w.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new w.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new w.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new w.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new w.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new w.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||a,this.showCommonFindToggles=!!e.showCommonFindToggles;const l=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",h=e.appendRegexLabel||"",s=e.history||[],D=!!e.flexibleHeight,v=!!e.flexibleWidth,A=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new i.HistoryInputBox(this.domNode,u,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:D,flexibleWidth:v,flexibleMaxHeight:A,inputBoxStyles:e.inputBoxStyles})),this.showCommonFindToggles){this.regex=this._register(new L.RegexToggle({appendTitle:h,isChecked:!1,...e.toggleStyles})),this._register(this.regex.onChange(p=>{this._onDidOptionChange.fire(p),!p&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(p=>{this._onRegexKeyDown.fire(p)})),this.wholeWords=this._register(new L.WholeWordsToggle({appendTitle:n,isChecked:!1,...e.toggleStyles})),this._register(this.wholeWords.onChange(p=>{this._onDidOptionChange.fire(p),!p&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new L.CaseSensitiveToggle({appendTitle:l,isChecked:!1,...e.toggleStyles})),this._register(this.caseSensitive.onChange(p=>{this._onDidOptionChange.fire(p),!p&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(p=>{this._onCaseSensitiveKeyDown.fire(p)}));const f=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,p=>{if(p.equals(15)||p.equals(17)||p.equals(9)){const O=f.indexOf(document.activeElement);if(O>=0){let k=-1;p.equals(17)?k=(O+1)%f.length:p.equals(15)&&(O===0?k=f.length-1:k=O-1),p.equals(9)?(f[O].blur(),this.inputBox.focus()):k>=0&&f[k].focus(),E.EventHelper.stop(p,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(e?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),r?.appendChild(this.domNode),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",f=>{this.imeSessionInProgress=!0})),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionend",f=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,f=>this._onKeyDown.fire(f)),this.onkeyup(this.inputBox.inputElement,f=>this._onKeyUp.fire(f)),this.oninput(this.inputBox.inputElement,f=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,f=>this._onMouseDown.fire(f))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.updateInputBoxPadding(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const r of this.additionalToggles)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const r of this.additionalToggles)r.disable()}setFocusInputOnOptionClick(r){this.fixFocusOnOptionClickEnabled=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const u of this.additionalToggles)u.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new c.DisposableStore;for(const u of r??[])this.additionalTogglesDisposables.add(u),this.controls.appendChild(u.domNode),this.additionalTogglesDisposables.add(u.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(u);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((u,e)=>u+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(r){this.caseSensitive&&(this.caseSensitive.checked=r)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(r){this.wholeWords&&(this.wholeWords.checked=r)}getRegex(){return this.regex?.checked??!1}setRegex(r){this.regex&&(this.regex.checked=r,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=d,d.OPTION_CHANGE="optionChange"}),define(ge[128],me([1,0,4,20,14,61,127,62,58,37,63,55,24,32,13,9,16,17,69,3,33,2,44,6,102,94]),function(te,t,E,L,i,W,w,y,c,a,d,I,r,u,e,l,n,h,s,D,v,A,f,p,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class k extends c.ElementsDragAndDropData{set context(o){this.data.context=o}get context(){return this.data.context}constructor(o){super(o.elements.map(T=>T.element)),this.data=o}}function m(z){return z instanceof c.ElementsDragAndDropData?new k(z):z}class g{constructor(o,T){this.modelProvider=o,this.dnd=T,this.autoExpandDisposable=A.Disposable.None}getDragURI(o){return this.dnd.getDragURI(o.element)}getDragLabel(o,T){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(o.map($=>$.element),T)}onDragStart(o,T){this.dnd.onDragStart?.(m(o),T)}onDragOver(o,T,$,Y,C=!0){const F=this.dnd.onDragOver(m(o),T&&T.element,$,Y),R=this.autoExpandNode!==T;if(R&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=T),typeof T>"u")return F;if(R&&typeof F!="boolean"&&F.autoExpand&&(this.autoExpandDisposable=(0,l.disposableTimeout)(()=>{const V=this.modelProvider(),G=V.getNodeLocation(T);V.isCollapsed(G)&&V.setCollapsed(G,!1),this.autoExpandNode=void 0},500)),typeof F=="boolean"||!F.accept||typeof F.bubble>"u"||F.feedback){if(!C){const V=typeof F=="boolean"?F:F.accept,G=typeof F=="boolean"?void 0:F.effect;return{accept:V,effect:G,feedback:[$]}}return F}if(F.bubble===1){const V=this.modelProvider(),G=V.getNodeLocation(T),ee=V.getParentNodeLocation(G),re=V.getNode(ee),be=ee&&V.getListIndex(ee);return this.onDragOver(o,re,be,Y,!1)}const S=this.modelProvider(),x=S.getNodeLocation(T),B=S.getListIndex(x),P=S.getListRenderCount(x);return{...F,feedback:(0,e.range)(B,B+P)}}drop(o,T,$,Y){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(m(o),T&&T.element,$,Y)}onDragEnd(o){this.dnd.onDragEnd?.(o)}}function b(z,o){return o&&{...o,identityProvider:o.identityProvider&&{getId(T){return o.identityProvider.getId(T.element)}},dnd:o.dnd&&new g(z,o.dnd),multipleSelectionController:o.multipleSelectionController&&{isSelectionSingleChangeEvent(T){return o.multipleSelectionController.isSelectionSingleChangeEvent({...T,element:T.element})},isSelectionRangeChangeEvent(T){return o.multipleSelectionController.isSelectionRangeChangeEvent({...T,element:T.element})}},accessibilityProvider:o.accessibilityProvider&&{...o.accessibilityProvider,getSetSize(T){const $=z(),Y=$.getNodeLocation(T),C=$.getParentNodeLocation(Y);return $.getNode(C).visibleChildrenCount},getPosInSet(T){return T.visibleChildIndex+1},isChecked:o.accessibilityProvider&&o.accessibilityProvider.isChecked?T=>o.accessibilityProvider.isChecked(T.element):void 0,getRole:o.accessibilityProvider&&o.accessibilityProvider.getRole?T=>o.accessibilityProvider.getRole(T.element):()=>"treeitem",getAriaLabel(T){return o.accessibilityProvider.getAriaLabel(T.element)},getWidgetAriaLabel(){return o.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:o.accessibilityProvider&&o.accessibilityProvider.getWidgetRole?()=>o.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:o.accessibilityProvider&&o.accessibilityProvider.getAriaLevel?T=>o.accessibilityProvider.getAriaLevel(T.element):T=>T.depth,getActiveDescendantId:o.accessibilityProvider.getActiveDescendantId&&(T=>o.accessibilityProvider.getActiveDescendantId(T.element))},keyboardNavigationLabelProvider:o.keyboardNavigationLabelProvider&&{...o.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(T){return o.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(T.element)}}}}class N{constructor(o){this.delegate=o}getHeight(o){return this.delegate.getHeight(o.element)}getTemplateId(o){return this.delegate.getTemplateId(o.element)}hasDynamicHeight(o){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(o.element)}setDynamicHeight(o,T){this.delegate.setDynamicHeight?.(o.element,T)}}t.ComposedTreeDelegate=N;class M{static lift(o){return o instanceof M?o:new M(o)}static empty(o=0){return new M({focus:[],selection:[],expanded:Object.create(null),scrollTop:o})}constructor(o){if(this.focus=new Set(o.focus),this.selection=new Set(o.selection),o.expanded instanceof Array){this.expanded=Object.create(null);for(const T of o.expanded)this.expanded[T]=1}else this.expanded=o.expanded;this.expanded=o.expanded,this.scrollTop=o.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=M;var H;(function(z){z.None="none",z.OnHover="onHover",z.Always="always"})(H||(t.RenderIndentGuides=H={}));class Z{get elements(){return this._elements}constructor(o,T=[]){this._elements=T,this.disposables=new A.DisposableStore,this.onDidChange=D.Event.forEach(o,$=>this._elements=$,this.disposables)}dispose(){this.disposables.dispose()}}class ne{constructor(o,T,$,Y,C,F={}){this.renderer=o,this.modelProvider=T,this.activeNodes=Y,this.renderedIndentGuides=C,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=ne.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=A.Disposable.None,this.disposables=new A.DisposableStore,this.templateId=o.templateId,this.updateOptions(F),D.Event.map($,R=>R.node)(this.onDidChangeNodeTwistieState,this,this.disposables),o.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(o={}){if(typeof o.indent<"u"){const T=(0,f.clamp)(o.indent,0,40);if(T!==this.indent){this.indent=T;for(const[$,Y]of this.renderedNodes)this.renderTreeElement($,Y)}}if(typeof o.renderIndentGuides<"u"){const T=o.renderIndentGuides!==H.None;if(T!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=T;for(const[$,Y]of this.renderedNodes)this._renderIndentGuides($,Y);if(this.indentGuidesDisposable.dispose(),T){const $=new A.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,$),this.indentGuidesDisposable=$,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof o.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=o.hideTwistiesOfChildlessElements)}renderTemplate(o){const T=(0,E.append)(o,(0,E.$)(".monaco-tl-row")),$=(0,E.append)(T,(0,E.$)(".monaco-tl-indent")),Y=(0,E.append)(T,(0,E.$)(".monaco-tl-twistie")),C=(0,E.append)(T,(0,E.$)(".monaco-tl-contents")),F=this.renderer.renderTemplate(C);return{container:o,indent:$,twistie:Y,indentGuidesDisposable:A.Disposable.None,templateData:F}}renderElement(o,T,$,Y){this.renderedNodes.set(o,$),this.renderedElements.set(o.element,o),this.renderTreeElement(o,$),this.renderer.renderElement(o,T,$.templateData,Y)}disposeElement(o,T,$,Y){$.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(o,T,$.templateData,Y),typeof Y=="number"&&(this.renderedNodes.delete(o),this.renderedElements.delete(o.element))}disposeTemplate(o){this.renderer.disposeTemplate(o.templateData)}onDidChangeTwistieState(o){const T=this.renderedElements.get(o);T&&this.onDidChangeNodeTwistieState(T)}onDidChangeNodeTwistieState(o){const T=this.renderedNodes.get(o);T&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(o,T))}renderTreeElement(o,T){const $=ne.DefaultIndent+(o.depth-1)*this.indent;T.twistie.style.paddingLeft=`${$}px`,T.indent.style.width=`${$+this.indent-16}px`,o.collapsible?T.container.setAttribute("aria-expanded",String(!o.collapsed)):T.container.removeAttribute("aria-expanded"),T.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded));let Y=!1;this.renderer.renderTwistie&&(Y=this.renderer.renderTwistie(o.element,T.twistie)),o.collapsible&&(!this.hideTwistiesOfChildlessElements||o.visibleChildrenCount>0)?(Y||T.twistie.classList.add(...h.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded)),T.twistie.classList.add("collapsible"),T.twistie.classList.toggle("collapsed",o.collapsed)):T.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(o,T)}_renderIndentGuides(o,T){if((0,E.clearNode)(T.indent),T.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const $=new A.DisposableStore,Y=this.modelProvider();for(;;){const C=Y.getNodeLocation(o),F=Y.getParentNodeLocation(C);if(!F)break;const R=Y.getNode(F),S=(0,E.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(R)&&S.classList.add("active"),T.indent.childElementCount===0?T.indent.appendChild(S):T.indent.insertBefore(S,T.indent.firstElementChild),this.renderedIndentGuides.add(R,S),$.add((0,A.toDisposable)(()=>this.renderedIndentGuides.delete(R,S))),o=R}T.indentGuidesDisposable=$}_onDidChangeActiveNodes(o){if(!this.shouldRenderIndentGuides)return;const T=new Set,$=this.modelProvider();o.forEach(Y=>{const C=$.getNodeLocation(Y);try{const F=$.getParentNodeLocation(C);Y.collapsible&&Y.children.length>0&&!Y.collapsed?T.add(Y):F&&T.add($.getNode(F))}catch{}}),this.activeIndentNodes.forEach(Y=>{T.has(Y)||this.renderedIndentGuides.forEach(Y,C=>C.classList.remove("active"))}),T.forEach(Y=>{this.activeIndentNodes.has(Y)||this.renderedIndentGuides.forEach(Y,C=>C.classList.add("active"))}),this.activeIndentNodes=T}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,A.dispose)(this.disposables)}}ne.DefaultIndent=8;class se{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(o){this._pattern=o,this._lowercasePattern=o.toLowerCase()}constructor(o,T,$){this.tree=o,this.keyboardNavigationLabelProvider=T,this._filter=$,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new A.DisposableStore,o.onWillRefilter(this.reset,this,this.disposables)}filter(o,T){let $=1;if(this._filter){const F=this._filter.filter(o,T);if(typeof F=="boolean"?$=F?1:0:(0,I.isFilterResult)(F)?$=(0,I.getVisibleState)(F.visibility):$=F,$===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:v.FuzzyScore.Default,visibility:$};const Y=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o),C=Array.isArray(Y)?Y:[Y];for(const F of C){const R=F&&F.toString();if(typeof R>"u")return{data:v.FuzzyScore.Default,visibility:$};let S;if(this.tree.findMatchType===ye.Contiguous){const x=R.toLowerCase().indexOf(this._lowercasePattern);if(x>-1){S=[Number.MAX_SAFE_INTEGER,0];for(let B=this._lowercasePattern.length;B>0;B--)S.push(x+B-1)}}else S=(0,v.fuzzyScore)(this._pattern,this._lowercasePattern,0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(S)return this._matchCount++,C.length===1?{data:S,visibility:$}:{data:{label:R,score:S},visibility:$}}return this.tree.findMode===oe.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(o):2:{data:v.FuzzyScore.Default,visibility:$}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,A.dispose)(this.disposables)}}class he extends d.Toggle{constructor(o){super({icon:n.Codicon.listFilter,title:(0,O.localize)(0,null),isChecked:o.isChecked??!1,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.ModeToggle=he;class ue extends d.Toggle{constructor(o){super({icon:n.Codicon.searchFuzzy,title:(0,O.localize)(1,null),isChecked:o.isChecked??!1,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const le={inputBoxStyles:y.unthemedInboxStyles,toggleStyles:d.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(z){z[z.Highlight=0]="Highlight",z[z.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var ye;(function(z){z[z.Fuzzy=0]="Fuzzy",z[z.Contiguous=1]="Contiguous"})(ye||(t.TreeFindMatchType=ye={}));class Te extends A.Disposable{set mode(o){this.modeToggle.checked=o===oe.Filter,this.findInput.inputBox.setPlaceHolder(o===oe.Filter?(0,O.localize)(2,null):(0,O.localize)(3,null))}set matchType(o){this.matchTypeToggle.checked=o===ye.Fuzzy}get value(){return this.findInput.inputBox.value}set value(o){this.findInput.inputBox.value=o}constructor(o,T,$,Y,C,F){super(),this.tree=T,this.elements=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new D.Emitter,this.onDidDisable=this._onDidDisable.event,o.appendChild(this.elements.root),this._register((0,A.toDisposable)(()=>o.removeChild(this.elements.root)));const R=F?.styles??le;R.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=R.listFilterWidgetBackground),R.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${R.listFilterWidgetShadow}`),this.modeToggle=this._register(new he({...R.toggleStyles,isChecked:Y===oe.Filter})),this.matchTypeToggle=this._register(new ue({...R.toggleStyles,isChecked:C===ye.Fuzzy})),this.onDidChangeMode=D.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?oe.Filter:oe.Highlight,this._store),this.onDidChangeMatchType=D.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?ye.Fuzzy:ye.Contiguous,this._store),this.findInput=this._register(new w.FindInput(this.elements.findInput,$,{label:(0,O.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:R.inputBoxStyles,toggleStyles:R.toggleStyles,history:F?.history})),this.actionbar=this._register(new W.ActionBar(this.elements.actionbar)),this.mode=Y;const S=this._register(new L.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),x=this._register(D.Event.chain(S.event)).map(G=>new i.StandardKeyboardEvent(G)).event;this._register(x(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const B=this._register(new u.Action("close",(0,O.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(B,{icon:!0,label:!1});const P=this._register(new L.DomEmitter(this.elements.grab,"mousedown"));this._register(P.event(G=>{const ee=new A.DisposableStore,re=ee.add(new L.DomEmitter(window,"mousemove")),be=ee.add(new L.DomEmitter(window,"mouseup")),De=this.right,Ie=G.pageX,Se=this.top,ve=G.pageY;this.elements.grab.classList.add("grabbing");const Pe=this.elements.root.style.transition;this.elements.root.style.transition="unset";const Le=Ke=>{const xe=Ke.pageX-Ie;this.right=De-xe;const We=Ke.pageY-ve;this.top=Se+We,this.layout()};ee.add(re.event(Le)),ee.add(be.event(Ke=>{Le(Ke),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=Pe,ee.dispose()}))}));const V=this._register(D.Event.chain(this._register(new L.DomEmitter(this.elements.grab,"keydown")).event)).map(G=>new i.StandardKeyboardEvent(G)).event;this._register(V(G=>{let ee,re;if(G.keyCode===15?ee=Number.POSITIVE_INFINITY:G.keyCode===17?ee=0:G.keyCode===10&&(ee=this.right===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?re=0:G.keyCode===18&&(re=Number.POSITIVE_INFINITY),ee!==void 0&&(G.preventDefault(),G.stopPropagation(),this.right=ee,this.layout()),re!==void 0){G.preventDefault(),G.stopPropagation(),this.top=re;const be=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=be},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(o=this.width){this.width=o,this.right=(0,f.clamp)(this.right,0,Math.max(0,o-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,f.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(o){this.findInput.showMessage(o)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,l.timeout)(300),super.dispose()}}class Oe{get pattern(){return this._pattern}get mode(){return this._mode}set mode(o){o!==this._mode&&(this._mode=o,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(o))}get matchType(){return this._matchType}set matchType(o){o!==this._matchType&&(this._matchType=o,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(o))}constructor(o,T,$,Y,C,F={}){this.tree=o,this.view=$,this.filter=Y,this.contextViewProvider=C,this.options=F,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new D.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new D.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new D.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new D.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new A.DisposableStore,this.disposables=new A.DisposableStore,this._mode=o.options.defaultFindMode??oe.Highlight,this._matchType=o.options.defaultFindMatchType??ye.Fuzzy,T.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(o={}){o.defaultFindMode!==void 0&&(this.mode=o.defaultFindMode),o.defaultFindMatchType!==void 0&&(this.matchType=o.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new Te(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(o=>this.mode=o,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(o=>this.matchType=o,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new A.DisposableStore,this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(o){this._pattern=o,this._onDidChangePattern.fire(o),this.filter.pattern=o,this.tree.refilter(),o&&this.tree.focusNext(0,!0,void 0,$=>!v.FuzzyScore.isDefault($.filterData));const T=this.tree.getFocus();if(T.length>0){const $=T[0];this.tree.getRelativeTop($)===null&&this.tree.reveal($,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const o=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&o?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,O.localize)(6,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(o){return!this.widget||!this.pattern||this._mode===oe.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!v.FuzzyScore.isDefault(o.filterData)}layout(o){this.width=o,this.widget?.layout(o)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function ke(z){let o=r.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(z.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?o=r.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(z.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?o=r.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(z.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(o=r.TreeMouseEventTarget.Filter),{browserEvent:z.browserEvent,element:z.element?z.element.element:null,target:o}}function fe(z){return{element:z.element?z.element.element:null,browserEvent:z.browserEvent,anchor:z.anchor}}function U(z,o){o(z),z.children.forEach(T=>U(T,o))}class ie{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(o,T){this.getFirstViewElementWithTrait=o,this.identityProvider=T,this.nodes=[],this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event}set(o,T){!T?.__forceEvent&&(0,e.equals)(this.nodes,o)||this._set(o,!1,T)}_set(o,T,$){if(this.nodes=[...o],this.elements=void 0,this._nodeSet=void 0,!T){const Y=this;this._onDidChange.fire({get elements(){return Y.get()},browserEvent:$})}}get(){return this.elements||(this.elements=this.nodes.map(o=>o.element)),[...this.elements]}getNodes(){return this.nodes}has(o){return this.nodeSet.has(o)}onDidModelSplice({insertedNodes:o,deletedNodes:T}){if(!this.identityProvider){const S=this.createNodeSet(),x=B=>S.delete(B);T.forEach(B=>U(B,x)),this.set([...S.values()]);return}const $=new Set,Y=S=>$.add(this.identityProvider.getId(S.element).toString());T.forEach(S=>U(S,Y));const C=new Map,F=S=>C.set(this.identityProvider.getId(S.element).toString(),S);o.forEach(S=>U(S,F));const R=[];for(const S of this.nodes){const x=this.identityProvider.getId(S.element).toString();if(!$.has(x))R.push(S);else{const P=C.get(x);P&&P.visible&&R.push(P)}}if(this.nodes.length>0&&R.length===0){const S=this.getFirstViewElementWithTrait();S&&R.push(S)}this._set(R,!0)}createNodeSet(){const o=new Set;for(const T of this.nodes)o.add(T);return o}}class q extends a.MouseController{constructor(o,T){super(o),this.tree=T}onViewPointer(o){if((0,a.isButton)(o.browserEvent.target)||(0,a.isInputElement)(o.browserEvent.target)||(0,a.isMonacoEditor)(o.browserEvent.target)||o.browserEvent.isHandledByList)return;const T=o.element;if(!T)return super.onViewPointer(o);if(this.isSelectionRangeChangeEvent(o)||this.isSelectionSingleChangeEvent(o))return super.onViewPointer(o);const $=o.browserEvent.target,Y=$.classList.contains("monaco-tl-twistie")||$.classList.contains("monaco-icon-label")&&$.classList.contains("folder-icon")&&o.browserEvent.offsetX<16;let C=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?C=this.tree.expandOnlyOnTwistieClick(T.element):C=!!this.tree.expandOnlyOnTwistieClick,C&&!Y&&o.browserEvent.detail!==2)return super.onViewPointer(o);if(!this.tree.expandOnDoubleClick&&o.browserEvent.detail===2)return super.onViewPointer(o);if(T.collapsible){const F=this.tree.getNodeLocation(T),R=o.browserEvent.altKey;if(this.tree.setFocus([F]),this.tree.toggleCollapsed(F,R),C&&Y){o.browserEvent.isHandledByList=!0;return}}super.onViewPointer(o)}onDoubleClick(o){o.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||o.browserEvent.isHandledByList||super.onDoubleClick(o)}}class K extends a.List{constructor(o,T,$,Y,C,F,R,S){super(o,T,$,Y,S),this.focusTrait=C,this.selectionTrait=F,this.anchorTrait=R}createMouseController(o){return new q(this,o.tree)}splice(o,T,$=[]){if(super.splice(o,T,$),$.length===0)return;const Y=[],C=[];let F;$.forEach((R,S)=>{this.focusTrait.has(R)&&Y.push(o+S),this.selectionTrait.has(R)&&C.push(o+S),this.anchorTrait.has(R)&&(F=o+S)}),Y.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...Y])),C.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...C])),typeof F=="number"&&super.setAnchor(F)}setFocus(o,T,$=!1){super.setFocus(o,T),$||this.focusTrait.set(o.map(Y=>this.element(Y)),T)}setSelection(o,T,$=!1){super.setSelection(o,T),$||this.selectionTrait.set(o.map(Y=>this.element(Y)),T)}setAnchor(o,T=!1){super.setAnchor(o),T||(typeof o>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(o)]))}}class _{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return D.Event.map(this.view.onMouseClick,ke)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.view.onMouseDblClick,ke),o=>o.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return D.Event.map(this.view.onContextMenu,fe)}get onTap(){return D.Event.map(this.view.onTap,ke)}get onPointer(){return D.Event.map(this.view.onPointer,ke)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??oe.Highlight}set findMode(o){this.findController&&(this.findController.mode=o)}get findMatchType(){return this.findController?.matchType??ye.Fuzzy}set findMatchType(o){this.findController&&(this.findController.matchType=o)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(o,T,$,Y,C={}){this._user=o,this._options=C,this.eventBufferer=new D.EventBufferer,this.onDidChangeFindOpenState=D.Event.None,this.disposables=new A.DisposableStore,this._onWillRefilter=new D.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new D.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const F=new N($),R=new D.Relay,S=new D.Relay,x=this.disposables.add(new Z(S.event)),B=new s.SetMap;this.renderers=Y.map(G=>new ne(G,()=>this.model,R.event,x,B,C));for(const G of this.renderers)this.disposables.add(G);let P;C.keyboardNavigationLabelProvider&&(P=new se(this,C.keyboardNavigationLabelProvider,C.filter),C={...C,filter:P},this.disposables.add(P)),this.focus=new ie(()=>this.view.getFocusedElements()[0],C.identityProvider),this.selection=new ie(()=>this.view.getSelectedElements()[0],C.identityProvider),this.anchor=new ie(()=>this.view.getAnchorElement(),C.identityProvider),this.view=new K(o,T,F,this.renderers,this.focus,this.selection,this.anchor,{...b(()=>this.model,C),tree:this}),this.model=this.createModel(o,this.view,C),R.input=this.model.onDidChangeCollapseState;const V=D.Event.forEach(this.model.onDidSplice,G=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(G),this.selection.onDidModelSplice(G)})},this.disposables);if(V(()=>null,null,this.disposables),S.input=D.Event.chain(D.Event.any(V,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const G=new Set;for(const ee of this.focus.getNodes())G.add(ee);for(const ee of this.selection.getNodes())G.add(ee);return[...G.values()]}).event,C.keyboardSupport!==!1){const G=D.Event.chain(this.view.onKeyDown).filter(ee=>!(0,a.isInputElement)(ee.target)).map(ee=>new i.StandardKeyboardEvent(ee));G.filter(ee=>ee.keyCode===15).on(this.onLeftArrow,this,this.disposables),G.filter(ee=>ee.keyCode===17).on(this.onRightArrow,this,this.disposables),G.filter(ee=>ee.keyCode===10).on(this.onSpace,this,this.disposables)}if((C.findWidgetEnabled??!0)&&C.keyboardNavigationLabelProvider&&C.contextViewProvider){const G=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new Oe(this,this.model,this.view,P,C.contextViewProvider,G),this.focusNavigationFilter=ee=>this.findController.shouldAllowFocus(ee),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=D.Event.None,this.onDidChangeFindMatchType=D.Event.None;this.styleElement=(0,E.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===H.Always)}updateOptions(o={}){this._options={...this._options,...o};for(const T of this.renderers)T.updateOptions(o);this.view.updateOptions(this._options),this.findController?.updateOptions(o),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===H.Always)}get options(){return this._options}updateWidth(o){const T=this.model.getListIndex(o);T!==-1&&this.view.updateWidth(T)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(o){this.view.scrollTop=o}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(o){this.view.scrollLeft=o}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const o=this.view.firstVisibleIndex;return o<0||o>=this.view.length?void 0:this.view.element(o).element}get lastVisibleElement(){const o=this.view.lastVisibleIndex;return this.view.element(o).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(o){this.view.ariaLabel=o}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(o,T){this.view.layout(o,T),(0,p.isNumber)(T)&&this.findController?.layout(T)}style(o){const T=`.${this.view.domId}`,$=[];o.treeIndentGuidesStroke&&($.push(`.monaco-list${T}:hover .monaco-tl-indent > .indent-guide, .monaco-list${T}.always .monaco-tl-indent > .indent-guide  { border-color: ${o.treeInactiveIndentGuidesStroke}; }`),$.push(`.monaco-list${T} .monaco-tl-indent > .indent-guide.active { border-color: ${o.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=$.join(`
`),this.view.style(o)}getParentElement(o){const T=this.model.getParentNodeLocation(o);return this.model.getNode(T).element}getFirstElementChild(o){return this.model.getFirstElementChild(o)}getNode(o){return this.model.getNode(o)}getNodeLocation(o){return this.model.getNodeLocation(o)}collapse(o,T=!1){return this.model.setCollapsed(o,!0,T)}expand(o,T=!1){return this.model.setCollapsed(o,!1,T)}toggleCollapsed(o,T=!1){return this.model.setCollapsed(o,void 0,T)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(o){return this.model.isCollapsible(o)}setCollapsible(o,T){return this.model.setCollapsible(o,T)}isCollapsed(o){return this.model.isCollapsed(o)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(o){if(typeof o>"u")return this.view.setAnchor(void 0);const T=this.model.getNode(o);this.anchor.set([T]);const $=this.model.getListIndex(o);$>-1&&this.view.setAnchor($,!0)}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(o,T){const $=o.map(C=>this.model.getNode(C));this.selection.set($,T);const Y=o.map(C=>this.model.getListIndex(C)).filter(C=>C>-1);this.view.setSelection(Y,T,!0)}getSelection(){return this.selection.get()}setFocus(o,T){const $=o.map(C=>this.model.getNode(C));this.focus.set($,T);const Y=o.map(C=>this.model.getListIndex(C)).filter(C=>C>-1);this.view.setFocus(Y,T,!0)}focusNext(o=1,T=!1,$,Y=this.focusNavigationFilter){this.view.focusNext(o,T,$,Y)}focusPrevious(o=1,T=!1,$,Y=this.focusNavigationFilter){this.view.focusPrevious(o,T,$,Y)}focusNextPage(o,T=this.focusNavigationFilter){return this.view.focusNextPage(o,T)}focusPreviousPage(o,T=this.focusNavigationFilter){return this.view.focusPreviousPage(o,T)}focusLast(o,T=this.focusNavigationFilter){this.view.focusLast(o,T)}focusFirst(o,T=this.focusNavigationFilter){this.view.focusFirst(o,T)}getFocus(){return this.focus.get()}reveal(o,T){this.model.expandTo(o);const $=this.model.getListIndex(o);$!==-1&&this.view.reveal($,T)}getRelativeTop(o){const T=this.model.getListIndex(o);return T===-1?null:this.view.getRelativeTop(T)}getViewState(o=this.options.identityProvider){if(!o)throw new r.TreeError(this._user,"Can't get tree view state without an identity provider");const T=F=>o.getId(F).toString(),$=M.empty(this.scrollTop);for(const F of this.getFocus())$.focus.add(T(F));for(const F of this.getSelection())$.selection.add(T(F));const Y=this.model.getNode(),C=[Y];for(;C.length>0;){const F=C.shift();F!==Y&&F.collapsible&&($.expanded[T(F.element)]=F.collapsed?0:1),C.push(...F.children)}return $}onLeftArrow(o){o.preventDefault(),o.stopPropagation();const T=this.view.getFocusedElements();if(T.length===0)return;const $=T[0],Y=this.model.getNodeLocation($);if(!this.model.setCollapsed(Y,!0)){const F=this.model.getParentNodeLocation(Y);if(!F)return;const R=this.model.getListIndex(F);this.view.reveal(R),this.view.setFocus([R])}}onRightArrow(o){o.preventDefault(),o.stopPropagation();const T=this.view.getFocusedElements();if(T.length===0)return;const $=T[0],Y=this.model.getNodeLocation($);if(!this.model.setCollapsed(Y,!1)){if(!$.children.some(S=>S.visible))return;const[F]=this.view.getFocus(),R=F+1;this.view.reveal(R),this.view.setFocus([R])}}onSpace(o){o.preventDefault(),o.stopPropagation();const T=this.view.getFocusedElements();if(T.length===0)return;const $=T[0],Y=this.model.getNodeLocation($),C=o.browserEvent.altKey;this.model.setCollapsed(Y,void 0,C)}navigate(o){return new j(this.view,this.model,o)}dispose(){(0,A.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=_;class j{constructor(o,T,$){this.view=o,this.model=T,$?this.index=this.model.getListIndex($):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,24,26]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class w extends E.AbstractTree{constructor(c,a,d,I,r,u={}){super(c,a,d,I,u),this.user=c,this.dataSource=r,this.nodesByIdentity=new Map,this.identityProvider=u.identityProvider}getInput(){return this.input}setInput(c,a){if(a&&!this.identityProvider)throw new i.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=c,!c){this.nodesByIdentity.clear(),this.model.setChildren(null,W.Iterable.empty());return}if(!a){this._refresh(c);return}const d=[],I=[],r=e=>{const l=this.identityProvider.getId(e).toString();return!a.expanded[l]},u=e=>{const l=this.identityProvider.getId(e.element).toString();a.focus.has(l)&&d.push(e.element),a.selection.has(l)&&I.push(e.element)};this._refresh(c,r,u),this.setFocus(d),this.setSelection(I),a&&typeof a.scrollTop=="number"&&(this.scrollTop=a.scrollTop)}updateChildren(c=this.input){if(typeof this.input>"u")throw new i.TreeError(this.user,"Tree input not set");let a;this.identityProvider&&(a=d=>{const I=this.identityProvider.getId(d).toString(),r=this.nodesByIdentity.get(I);if(r)return r.collapsed}),this._refresh(c,a)}resort(c=this.input,a=!0){this.model.resort(c===this.input?null:c,a)}refresh(c){if(c===void 0){this.view.rerender();return}this.model.rerender(c)}_refresh(c,a,d){let I;if(this.identityProvider){const r=new Set,u=d;d=e=>{const l=this.identityProvider.getId(e.element).toString();r.add(l),this.nodesByIdentity.set(l,e),u?.(e)},I=e=>{const l=this.identityProvider.getId(e.element).toString();r.has(l)||this.nodesByIdentity.delete(l)}}this.model.setChildren(c===this.input?null:c,this.iterate(c,a).elements,{onDidCreateNode:d,onDidDeleteNode:I})}iterate(c,a){const d=[...this.dataSource.getChildren(c)];return{elements:W.Iterable.map(d,r=>{const{elements:u,size:e}=this.iterate(r,a),l=this.dataSource.hasChildren?this.dataSource.hasChildren(r):void 0,n=e===0?void 0:a&&a(r);return{element:r,children:u,collapsible:l,collapsed:n}}),size:d.length}}createModel(c,a,d){return new L.ObjectTreeModel(c,a,d)}}t.DataTree=w}),define(ge[64],me([1,0,13,9,31,27,25,7,3,2,50,11,6]),function(te,t,E,L,i,W,w,y,c,a,d,I,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var u;(function(fe){fe[fe.Promise=100]="Promise",fe[fe.PromiseCancel=101]="PromiseCancel",fe[fe.EventListen=102]="EventListen",fe[fe.EventDispose=103]="EventDispose"})(u||(u={}));function e(fe){switch(fe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(fe){fe[fe.Initialize=200]="Initialize",fe[fe.PromiseSuccess=201]="PromiseSuccess",fe[fe.PromiseError=202]="PromiseError",fe[fe.PromiseErrorObj=203]="PromiseErrorObj",fe[fe.EventFire=204]="EventFire"})(l||(l={}));function n(fe){switch(fe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(fe){fe[fe.Uninitialized=0]="Uninitialized",fe[fe.Idle=1]="Idle"})(h||(h={}));function s(fe){let U=0;for(let ie=0;;ie+=7){const q=fe.read(1);if(U|=(q.buffer[0]&127)<<ie,!(q.buffer[0]&128))return U}}const D=O(0);function v(fe,U){if(U===0){fe.write(D);return}let ie=0;for(let K=U;K!==0;K=K>>>7)ie++;const q=i.VSBuffer.alloc(ie);for(let K=0;U!==0;K++)q.buffer[K]=U&127,U=U>>>7,U>0&&(q.buffer[K]|=128);fe.write(q)}class A{constructor(U){this.buffer=U,this.pos=0}read(U){const ie=this.buffer.slice(this.pos,this.pos+U);return this.pos+=ie.byteLength,ie}}t.BufferReader=A;class f{constructor(){this.buffers=[]}get buffer(){return i.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}t.BufferWriter=f;var p;(function(fe){fe[fe.Undefined=0]="Undefined",fe[fe.String=1]="String",fe[fe.Buffer=2]="Buffer",fe[fe.VSBuffer=3]="VSBuffer",fe[fe.Array=4]="Array",fe[fe.Object=5]="Object",fe[fe.Int=6]="Int"})(p||(p={}));function O(fe){const U=i.VSBuffer.alloc(1);return U.writeUInt8(fe,0),U}const k={Undefined:O(p.Undefined),String:O(p.String),Buffer:O(p.Buffer),VSBuffer:O(p.VSBuffer),Array:O(p.Array),Object:O(p.Object),Uint:O(p.Int)},m=typeof Buffer<"u";function g(fe,U){if(typeof U>"u")fe.write(k.Undefined);else if(typeof U=="string"){const ie=i.VSBuffer.fromString(U);fe.write(k.String),v(fe,ie.byteLength),fe.write(ie)}else if(m&&Buffer.isBuffer(U)){const ie=i.VSBuffer.wrap(U);fe.write(k.Buffer),v(fe,ie.byteLength),fe.write(ie)}else if(U instanceof i.VSBuffer)fe.write(k.VSBuffer),v(fe,U.byteLength),fe.write(U);else if(Array.isArray(U)){fe.write(k.Array),v(fe,U.length);for(const ie of U)g(fe,ie)}else if(typeof U=="number"&&(U|0)===U)fe.write(k.Uint),v(fe,U);else{const ie=i.VSBuffer.fromString(JSON.stringify(U));fe.write(k.Object),v(fe,ie.byteLength),fe.write(ie)}}t.serialize=g;function b(fe){switch(fe.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return fe.read(s(fe)).toString();case p.Buffer:return fe.read(s(fe)).buffer;case p.VSBuffer:return fe.read(s(fe));case p.Array:{const ie=s(fe),q=[];for(let K=0;K<ie;K++)q.push(b(fe));return q}case p.Object:return JSON.parse(fe.read(s(fe)).toString());case p.Int:return s(fe)}}t.deserialize=b;class N{constructor(U,ie,q=null,K=1e3){this.protocol=U,this.ctx=ie,this.logger=q,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(U,ie){this.channels.set(U,ie),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const ie=this.send([U.type]);this.logger?.logOutgoing(ie,0,1,n(U.type));return}case 201:case 202:case 204:case 203:{const ie=this.send([U.type,U.id],U.data);this.logger?.logOutgoing(ie,U.id,1,n(U.type),U.data);return}}}send(U,ie=void 0){const q=new f;return g(q,U),g(q,ie),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const ie=new A(U),q=b(ie),K=b(ie),_=q[0];switch(_){case 100:return this.logger?.logIncoming(U.byteLength,q[1],1,`${e(_)}: ${q[2]}.${q[3]}`,K),this.onPromise({type:_,id:q[1],channelName:q[2],name:q[3],arg:K});case 102:return this.logger?.logIncoming(U.byteLength,q[1],1,`${e(_)}: ${q[2]}.${q[3]}`,K),this.onEventListen({type:_,id:q[1],channelName:q[2],name:q[3],arg:K});case 101:return this.logger?.logIncoming(U.byteLength,q[1],1,`${e(_)}`),this.disposeActiveRequest({type:_,id:q[1]});case 103:return this.logger?.logIncoming(U.byteLength,q[1],1,`${e(_)}`),this.disposeActiveRequest({type:_,id:q[1]})}}onPromise(U){const ie=this.channels.get(U.channelName);if(!ie){this.collectPendingRequest(U);return}const q=new W.CancellationTokenSource;let K;try{K=ie.call(this.ctx,U.name,U.arg,q.token)}catch(z){K=Promise.reject(z)}const _=U.id;K.then(z=>{this.sendResponse({id:_,data:z,type:201}),this.activeRequests.delete(U.id)},z=>{z instanceof Error?this.sendResponse({id:_,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:_,data:z,type:203}),this.activeRequests.delete(U.id)});const j=(0,a.toDisposable)(()=>q.cancel());this.activeRequests.set(U.id,j)}onEventListen(U){const ie=this.channels.get(U.channelName);if(!ie){this.collectPendingRequest(U);return}const q=U.id,_=ie.listen(this.ctx,U.name,U.arg)(j=>this.sendResponse({id:q,data:j,type:204}));this.activeRequests.set(U.id,_)}disposeActiveRequest(U){const ie=this.activeRequests.get(U.id);ie&&(ie.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let ie=this.pendingRequests.get(U.channelName);ie||(ie=[],this.pendingRequests.set(U.channelName,ie));const q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ie.push({request:U,timeoutTimer:q})}flushPendingRequests(U){const ie=this.pendingRequests.get(U);if(ie){for(const q of ie)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=N;var M;(function(fe){fe[fe.LocalSide=0]="LocalSide",fe[fe.OtherSide=1]="OtherSide"})(M||(t.RequestInitiator=M={}));class H{constructor(U,ie=null){this.protocol=U,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=ie}getChannel(U){const ie=this;return{call(q,K,_){return ie.isDisposed?Promise.reject(new y.CancellationError):ie.requestPromise(U,q,K,_)},listen(q,K){return ie.isDisposed?c.Event.None:ie.requestEvent(U,q,K)}}}requestPromise(U,ie,q,K=W.CancellationToken.None){const _=this.lastRequestId++,z={id:_,type:100,channelName:U,name:ie,arg:q};if(K.isCancellationRequested)return Promise.reject(new y.CancellationError);let o;return new Promise(($,Y)=>{if(K.isCancellationRequested)return Y(new y.CancellationError);const C=()=>{const x=B=>{switch(B.type){case 201:this.handlers.delete(_),$(B.data);break;case 202:{this.handlers.delete(_);const P=new Error(B.data.message);P.stack=Array.isArray(B.data.stack)?B.data.stack.join(`
`):B.data.stack,P.name=B.data.name,Y(P);break}case 203:this.handlers.delete(_),Y(B.data);break}};this.handlers.set(_,x),this.sendRequest(z)};let F=null;this.state===h.Idle?C():(F=(0,L.createCancelablePromise)(x=>this.whenInitialized()),F.then(()=>{F=null,C()}));const R=()=>{F?(F.cancel(),F=null):this.sendRequest({id:_,type:101}),Y(new y.CancellationError)},S=K.onCancellationRequested(R);o=(0,a.combinedDisposable)((0,a.toDisposable)(R),S),this.activeRequests.add(o)}).finally(()=>{this.activeRequests.delete(o)})}requestEvent(U,ie,q){const K=this.lastRequestId++,j={id:K,type:102,channelName:U,name:ie,arg:q};let z=null;const o=new c.Emitter({onWillAddFirstListener:()=>{z=(0,L.createCancelablePromise)($=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(o),this.sendRequest(j)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(o),this.sendRequest({id:K,type:103}))}}),T=$=>o.fire($.data);return this.handlers.set(K,T),o.event}sendRequest(U){switch(U.type){case 100:case 102:{const ie=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger?.logOutgoing(ie,U.id,0,`${e(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const ie=this.send([U.type,U.id]);this.logger?.logOutgoing(ie,U.id,0,e(U.type));return}}}send(U,ie=void 0){const q=new f;return g(q,U),g(q,ie),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const ie=new A(U),q=b(ie),K=b(ie),_=q[0];switch(_){case 200:return this.logger?.logIncoming(U.byteLength,0,0,n(_)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(U.byteLength,q[1],0,n(_),K),this.onResponse({type:q[0],id:q[1],data:K})}}onResponse(U){if(U.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(U.id)?.(U)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=H,qe([w.memoize],H.prototype,"onDidInitializePromise",null);class Z{get connections(){const U=[];return this._connections.forEach(ie=>U.push(ie)),U}constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:ie,onDidClientDisconnect:q})=>{c.Event.once(ie.onMessage)(_=>{const j=new A(_),z=b(j),o=new N(ie,z),T=new H(ie);this.channels.forEach((Y,C)=>o.registerChannel(C,Y));const $={channelServer:o,channelClient:T,ctx:z};this._connections.add($),this._onDidAddConnection.fire($),q(()=>{o.dispose(),T.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)})})})}getChannel(U,ie){const q=this;return{call(K,_,j){let z;if((0,r.isFunction)(ie)){const T=(0,E.getRandomElement)(q.connections.filter(ie));z=T?Promise.resolve(T):c.Event.toPromise(c.Event.filter(q.onDidAddConnection,ie))}else z=ie.routeCall(q,K,_);const o=z.then(T=>T.channelClient.getChannel(U));return se(o).call(K,_,j)},listen(K,_){if((0,r.isFunction)(ie))return q.getMulticastEvent(U,ie,K,_);const j=ie.routeEvent(q,K,_).then(z=>z.channelClient.getChannel(U));return se(j).listen(K,_)}}}getMulticastEvent(U,ie,q,K){const _=this;let j=new a.DisposableStore;const z=new c.Emitter({onWillAddFirstListener:()=>{j=new a.DisposableStore;const o=new c.EventMultiplexer,T=new Map,$=C=>{const R=C.channelClient.getChannel(U).listen(q,K),S=o.add(R);T.set(C,S)},Y=C=>{const F=T.get(C);F&&(F.dispose(),T.delete(C))};_.connections.filter(ie).forEach($),c.Event.filter(_.onDidAddConnection,ie)($,void 0,j),_.onDidRemoveConnection(Y,void 0,j),o.event(z.fire,z,j),j.add(o)},onDidRemoveLastListener:()=>{j.dispose()}});return z.event}registerChannel(U,ie){this.channels.set(U,ie),this._connections.forEach(q=>{q.channelServer.registerChannel(U,ie)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=Z;class ne{constructor(U,ie,q=null){const K=new f;g(K,ie),U.send(K.buffer),this.channelClient=new H(U,q),this.channelServer=new N(U,ie,q)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,ie){this.channelServer.registerChannel(U,ie)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ne;function se(fe){return{call(U,ie,q){return fe.then(K=>K.call(U,ie,q))},listen(U,ie){const q=new c.Relay;return fe.then(K=>q.input=K.listen(U,ie)),q.event}}}t.getDelayedChannel=se;function he(fe){let U=!1;return{call(ie,q,K){return U?fe.call(ie,q,K):(0,L.timeout)(0).then(()=>U=!0).then(()=>fe.call(ie,q,K))},listen(ie,q){if(U)return fe.listen(ie,q);const K=new c.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>K.input=fe.listen(ie,q)),K.event}}}t.getNextTickChannel=he;class ue{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const ie of U.connections)if(await Promise.resolve(this.fn(ie.ctx)))return Promise.resolve(ie);return await c.Event.toPromise(U.onDidAddConnection),await this.route(U)}}t.StaticRouter=ue;var le;(function(fe){function U(_,j){const z=_,o=j&&j.disableMarshalling,T=new Map;for(const $ in z)q($)&&T.set($,c.Event.buffer(z[$],!0));return new class{listen($,Y,C){const F=T.get(Y);if(F)return F;if(K(Y)){const R=z[Y];if(typeof R=="function")return R.call(z,C)}throw new Error(`Event not found: ${Y}`)}call($,Y,C){const F=z[Y];if(typeof F=="function"){if(!o&&Array.isArray(C))for(let R=0;R<C.length;R++)C[R]=(0,d.revive)(C[R]);return F.apply(z,C)}throw new Error(`Method not found: ${Y}`)}}}fe.fromService=U;function ie(_,j){const z=j&&j.disableMarshalling;return new Proxy({},{get(o,T){if(typeof T=="string")return j?.properties?.has(T)?j.properties.get(T):K(T)?function($){return _.listen(T,$)}:q(T)?_.listen(T):async function(...$){let Y;j&&!(0,r.isUndefinedOrNull)(j.context)?Y=[j.context,...$]:Y=$;const C=await _.call(T,Y);return z?C:(0,d.revive)(C)};throw new Error(`Property not found: ${String(T)}`)}})}fe.toService=ie;function q(_){return _[0]==="o"&&_[1]==="n"&&I.isUpperAsciiLetter(_.charCodeAt(2))}function K(_){return/^onDynamic/.test(_)&&I.isUpperAsciiLetter(_.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ye(fe){if(Array.isArray(fe))return fe;if(fe&&typeof fe=="object"&&typeof fe.toString=="function"){const U=fe.toString();if(U!=="[object Object]")return U}return fe}function Te(fe){return Array.isArray(fe)?fe.map(ye):ye(fe)}function Oe(fe,U,ie,q,K,_,j){j=Te(j);const z=oe[K],o=z[q%z.length];let T=[`%c[${fe}]%c[${String(U).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(_)?(T=T.concat(j),T.push(")")):T.push(j),console.log.apply(console,T)}class ke{constructor(U,ie){this._outgoingPrefix=U,this._incomingPrefix=ie,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,ie,q,K,_){this._totalOutgoing+=U,Oe(this._outgoingPrefix,this._totalOutgoing,U,ie,q,K,_)}logIncoming(U,ie,q,K,_){this._totalIncoming+=U,Oe(this._incomingPrefix,this._totalIncoming,U,ie,q,K,_)}}t.IPCLogger=ke}),define(ge[29],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(ge[130],me([1,0,81,29]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function W(y,c,a){const d=[],I=i++,r=`vscode:onContextMenu${I}`,u=(e,l,n)=>{d[l].click?.(n)};L.ipcRenderer.once(r,u),L.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,l)=>{l===I&&(L.ipcRenderer.removeListener(r,u),a?.())}),L.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,I,y.map(e=>w(e,d)),r,c)}t.popup=W;function w(y,c){const a={id:c.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return c.push(y),Array.isArray(y.submenu)&&(a.submenu=y.submenu.map(d=>w(d,c))),a}}),define(ge[131],me([1,0,31,3,64,82,29]),function(te,t,E,L,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class y extends i.IPCClient{static createProtocol(){const a=L.Event.fromNodeEventEmitter(w.ipcRenderer,"vscode:message",(d,I)=>E.VSBuffer.wrap(I));return w.ipcRenderer.send("vscode:hello"),new W.Protocol(w.ipcRenderer,a)}constructor(a){const d=y.createProtocol();super(d,a),this.protocol=d}dispose(){this.protocol.disconnect()}}t.Client=y}),define(ge[132],me([12,10]),function(te,t){return te.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,10]),function(te,t){return te.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[38],me([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function y(c){return c[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=y})(E||(t._util=E={})),t.IInstantiationService=i("instantiationService");function L(w,y,c){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:w,index:c}):(y[E.DI_DEPENDENCIES]=[{id:w,index:c}],y[E.DI_TARGET]=y)}function i(w){if(E.serviceIds.has(w))return E.serviceIds.get(w);const y=function(c,a,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,c,d)};return y.toString=()=>w,E.serviceIds.set(w,y),y}t.createDecorator=i;function W(w){return w}t.refineServiceDecorator=W}),define(ge[134],me([1,0,38]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function L(W){return!!W.hostName&&!!W.errorMessage}t.isRemoteDiagnosticError=L;class i{async getPerformanceInfo(w,y){return{}}async getSystemInfo(w,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,y){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.NullDiagnosticsService=i}),define(ge[135],me([1,0,113,22,11,6,15,132,38,5,28]),function(te,t,E,L,i,W,w,y,c,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.ByteSize=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicDeleteCapability=t.hasFileAtomicWriteCapability=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,c.createDecorator)("fileService");function I(U){return U.create===!0}t.isFileOpenForWriteOptions=I;var r;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var u;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(u||(t.FilePermission=u={}));var e;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function l(U){return!!(U.capabilities&2)}t.hasReadWriteCapability=l;function n(U){return!!(U.capabilities&8)}t.hasFileFolderCopyCapability=n;function h(U){return!!(U.capabilities&131072)}t.hasFileCloneCapability=h;function s(U){return!!(U.capabilities&4)}t.hasOpenReadWriteCloseCapability=s;function D(U){return!!(U.capabilities&16)}t.hasFileReadStreamCapability=D;function v(U){return l(U)?!!(U.capabilities&16384):!1}t.hasFileAtomicReadCapability=v;function A(U){return l(U)?!!(U.capabilities&32768):!1}t.hasFileAtomicWriteCapability=A;function f(U){return!!(U.capabilities&65536)}t.hasFileAtomicDeleteCapability=f;var p;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(p||(t.FileSystemProviderErrorCode=p={}));class O extends Error{static create(ie,q){const K=new O(ie.toString(),q);return g(K,q),K}constructor(ie,q){super(ie),this.code=q}}t.FileSystemProviderError=O;function k(U,ie){return O.create(U,ie)}t.createFileSystemProviderError=k;function m(U){return U||k((0,y.localize)(0,null),p.Unknown)}t.ensureFileSystemProviderError=m;function g(U,ie){return U.name=ie?`${ie} (FileSystemError)`:"FileSystemError",U}t.markAsFileSystemProviderError=g;function b(U){if(!U)return p.Unknown;if(U instanceof O)return U.code;const ie=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!ie)return p.Unknown;switch(ie[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}t.toFileSystemProviderErrorCode=b;function N(U){if(U instanceof he)return U.fileOperationResult;switch(b(U)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}t.toFileOperationResult=N;var M;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(M||(t.FileOperation=M={}));class H{constructor(ie,q,K){this.resource=ie,this.operation=q,this.target=K}isOperation(ie){return this.operation===ie}}t.FileOperationEvent=H;var Z;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class ne{constructor(ie,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const K=new Map;for(const _ of ie){const j=K.get(_.type);switch(j?j.push([_.resource,_]):K.set(_.type,[[_.resource,_]]),_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}}for(const[_,j]of K)switch(_){case 1:this.added=E.TernarySearchTree.forUris(()=>q),this.added.fill(j);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>q),this.updated.fill(j);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>q),this.deleted.fill(j);break}}contains(ie,...q){return this.doContains(ie,{includeChildren:!1},...q)}affects(ie,...q){return this.doContains(ie,{includeChildren:!0},...q)}doContains(ie,q,...K){if(!ie)return!1;const _=K.length>0;return!!((!_||K.includes(1))&&(this.added?.get(ie)||q.includeChildren&&this.added?.findSuperstr(ie))||(!_||K.includes(0))&&(this.updated?.get(ie)||q.includeChildren&&this.updated?.findSuperstr(ie))||(!_||K.includes(2))&&(this.deleted?.findSubstr(ie)||q.includeChildren&&this.deleted?.findSuperstr(ie)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=ne;function se(U,ie,q){return!U||!ie||U===ie||ie.length>U.length?!1:(ie.charAt(ie.length-1)!==L.sep&&(ie+=L.sep),q?(0,i.startsWithIgnoreCase)(U,ie):U.indexOf(ie)===0)}t.isParent=se;class he extends Error{constructor(ie,q,K){super(ie),this.fileOperationResult=q,this.options=K}}t.FileOperationError=he;class ue extends he{constructor(ie,q,K,_){super(ie,q,_),this.fileOperationResult=q,this.size=K}}t.TooLargeFileOperationError=ue;class le extends he{constructor(ie,q,K){super(ie,2,K),this.stat=q}}t.NotModifiedSinceFileOperationError=le;var oe;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(oe||(t.FileOperationResult=oe={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ye;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(t.FileKind=ye={})),t.ETAG_DISABLED="";function Te(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}t.etag=Te;async function Oe(U,ie){if(!ie.hasProvider(w.URI.from({scheme:U.scheme})))return new Promise(q=>{const K=ie.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===U.scheme&&_.added&&(K.dispose(),q())})})}t.whenProviderRegistered=Oe;class ke{static formatSize(ie){return(0,W.isNumber)(ie)||(ie=0),ie<ke.KB?(0,y.localize)(1,null,ie.toFixed(0)):ie<ke.MB?(0,y.localize)(2,null,(ie/ke.KB).toFixed(2)):ie<ke.GB?(0,y.localize)(3,null,(ie/ke.MB).toFixed(2)):ie<ke.TB?(0,y.localize)(4,null,(ie/ke.GB).toFixed(2)):(0,y.localize)(5,null,(ie/ke.TB).toFixed(2))}}t.ByteSize=ke,ke.KB=1024,ke.MB=ke.KB*ke.KB,ke.GB=ke.MB*ke.KB,ke.TB=ke.GB*ke.KB;function fe(U){const ie=typeof U=="string"||U?.scheme===d.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===d.Schemas.file?1024*ke.MB:ie?10*ke.MB:a.isWeb?50*ke.MB:1024*ke.MB}t.getLargeFileConfirmationLimit=fe}),define(ge[136],me([1,0,38]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,E.createDecorator)("mainProcessService");class L{constructor(W,w){this.server=W,this.router=w}getChannel(W){return this.server.getChannel(W,this.router)}registerChannel(W,w){this.server.registerChannel(W,w)}}t.MainProcessService=L}),define(ge[137],me([1,0,2,131]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends E.Disposable{constructor(w){super(),this.mainProcessConnection=this._register(new L.Client(`window:${w}`))}getChannel(w){return this.mainProcessConnection.getChannel(w)}registerChannel(w,y){this.mainProcessConnection.registerChannel(w,y)}}t.ElectronIPCMainProcessService=i});var hi=this&&this.__param||function(te,t){return function(E,L){t(E,L,te)}};define(ge[138],me([1,0,64,136]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=t.NativeHostService=class{constructor(w,y){return this.windowId=w,E.ProxyChannel.toService(y.getChannel("nativeHost"),{context:w,properties:(()=>{const c=new Map;return c.set("windowId",w),c})()})}};t.NativeHostService=i=qe([hi(1,L.IMainProcessService)],i)}),define(ge[65],me([1,0,72,6]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.data=new Map}add(w,y){E.ok(L.isString(w)),E.ok(L.isObject(y)),E.ok(!this.data.has(w),"There is already an extension with this id"),this.data.set(w,y)}knows(w){return this.data.has(w)}as(w){return this.data.get(w)||null}}t.Registry=new i}),define(ge[139],me([1,0,3,65]),function(te,t,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class W{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,a){this.schemasById[i(c)]=a,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const w=new W;L.Registry.add(t.Extensions.JSONContribution,w)}),define(ge[140],me([1,0,9,16,17,3,6,15,133,139,65]),function(te,t,E,L,i,W,w,y,c,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var I;(function(v){function A(f,p){let O=f.defaults;for(;i.ThemeIcon.isThemeIcon(O);){const k=e.getIcon(O.id);if(!k)return;O=k.defaults}return O}v.getDefinition=A})(I||(t.IconContribution=I={}));var r;(function(v){function A(p){return{weight:p.weight,style:p.style,src:p.src.map(O=>({format:O.format,location:O.location.toString()}))}}v.toJSONObject=A;function f(p){const O=k=>(0,w.isString)(k)?k:void 0;if(p&&Array.isArray(p.src)&&p.src.every(k=>(0,w.isString)(k.format)&&(0,w.isString)(k.location)))return{weight:O(p.weight),style:O(p.style),src:p.src.map(k=>({format:k.format,location:y.URI.parse(k.location)}))}}v.fromJSONObject=f})(r||(t.IconFontDefinition=r={}));class u{constructor(){this._onDidChange=new W.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(A,f,p,O){const k=this.iconsById[A];if(k){if(p&&!k.description){k.description=p,this.iconSchema.properties[A].markdownDescription=`${p} $(${A})`;const b=this.iconReferenceSchema.enum.indexOf(A);b!==-1&&(this.iconReferenceSchema.enumDescriptions[b]=p),this._onDidChange.fire()}return k}const m={id:A,description:p,defaults:f,deprecationMessage:O};this.iconsById[A]=m;const g={$ref:"#/definitions/icons"};return O&&(g.deprecationMessage=O),p&&(g.markdownDescription=`${p}: $(${A})`),this.iconSchema.properties[A]=g,this.iconReferenceSchema.enum.push(A),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:A}}deregisterIcon(A){delete this.iconsById[A],delete this.iconSchema.properties[A];const f=this.iconReferenceSchema.enum.indexOf(A);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(A=>this.iconsById[A])}getIcon(A){return this.iconsById[A]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(A,f){const p=this.iconFontsById[A];return p||(this.iconFontsById[A]=f,this._onDidChange.fire(),f)}deregisterIconFont(A){delete this.iconFontsById[A]}getIconFont(A){return this.iconFontsById[A]}toString(){const A=(k,m)=>k.id.localeCompare(m.id),f=k=>{for(;i.ThemeIcon.isThemeIcon(k.defaults);)k=this.iconsById[k.defaults.id];return`codicon codicon-${k?k.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const O=Object.keys(this.iconsById).map(k=>this.iconsById[k]);for(const k of O.filter(m=>!!m.description).sort(A))p.push(`|<i class="${f(k)}"></i>|${k.id}|${i.ThemeIcon.isThemeIcon(k.defaults)?k.defaults.id:k.id}|${k.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const k of O.filter(m=>!i.ThemeIcon.isThemeIcon(m.defaults)).sort(A))p.push(`|<i class="${f(k)}"></i>|${k.id}|`);return p.join(`
`)}}const e=new u;d.Registry.add(t.Extensions.IconContribution,e);function l(v,A,f,p){return e.registerIcon(v,A,f,p)}t.registerIcon=l;function n(){return e}t.getIconRegistry=n;function h(){const v=(0,L.getCodiconFontCharacters)();for(const A in v){const f="\\"+v[A].toString(16);e.registerIcon(A,{fontCharacter:f})}}h(),t.iconsSchemaId="vscode://schemas/icons";const s=d.Registry.as(a.Extensions.JSONContribution);s.registerSchema(t.iconsSchemaId,e.getIconSchema());const D=new E.RunOnceScheduler(()=>s.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{D.isScheduled()||D.schedule()}),t.widgetClose=l("widget-close",L.Codicon.close,(0,c.localize)(2,null)),t.gotoPreviousLocation=l("goto-previous-location",L.Codicon.arrowUp,(0,c.localize)(3,null)),t.gotoNextLocation=l("goto-next-location",L.Codicon.arrowDown,(0,c.localize)(4,null)),t.syncing=i.ThemeIcon.modify(L.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(ge[141],me([1,0,4,3,17,140]),function(te,t,E,L,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function w(c){const a=new L.Emitter,d=(0,W.getIconRegistry)();return d.onDidChange(()=>a.fire()),c?.onDidProductIconThemeChange(()=>a.fire()),{onDidChange:a.event,getCSS(){const I=c?c.getProductIconTheme():new y,r={},u=l=>{const n=I.getIcon(l);if(!n)return;const h=n.font;return h?(r[h.id]=h.definition,`.codicon-${l.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(h.id)}; }`):`.codicon-${l.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const l of d.getIcons()){const n=u(l);n&&e.push(n)}for(const l in r){const n=r[l],h=n.weight?`font-weight: ${n.weight};`:"",s=n.style?`font-style: ${n.style};`:"",D=n.src.map(v=>`${(0,E.asCSSUrl)(v.location)} format('${v.format}')`).join(", ");e.push(`@font-face { src: ${D}; font-family: ${(0,E.asCSSPropertyValue)(l)};${h}${s} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=w;class y{getIcon(a){const d=(0,W.getIconRegistry)();let I=a.defaults;for(;i.ThemeIcon.isThemeIcon(I);){const r=d.getIcon(I.id);if(!r)return;I=r.defaults}return I}}t.UnthemedProductIconTheme=y}),define(ge[142],me([1,0,5]),function(te,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(d){return!!d.workspaceUri}t.isWorkspaceToOpen=L;function i(d){return!!d.folderUri}t.isFolderToOpen=i;function W(d){return!!d.fileUri}t.isFileToOpen=W;function w(d){const I=y(d),r=d.getValue("window.menuBarVisibility");return r==="default"||I==="native"&&r==="compact"||E.isMacintosh&&E.isNative?"classic":r}t.getMenuBarVisibility=w;function y(d){if(E.isWeb)return"custom";const I=d.getValue("window");if(I){if(E.isMacintosh&&I.nativeTabs===!0||E.isMacintosh&&I.nativeFullScreen===!1)return"native";const e=I.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=y;function c(d){if(!E.isWindows||E.isWeb||y(d)==="native")return!1;const I=d.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:!0}t.useWindowControlsOverlay=c;function a(d=0){return Math.pow(1.2,d)}t.zoomLevelToZoomFactor=a}),define(ge[143],me([1,0,18,29,142]),function(te,t,E,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function W(c){L.webFrame.setZoomLevel(c),(0,E.setZoomFactor)((0,i.zoomLevelToZoomFactor)(c)),(0,E.setZoomLevel)(c,!1)}t.applyZoom=W;function w(){W((0,E.getZoomLevel)()+1)}t.zoomIn=w;function y(){W((0,E.getZoomLevel)()-1)}t.zoomOut=y}),define(ge[144],me([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,95,86]),function(te,t,E,L,i,W,w,y,c,a,d,I,r,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const l=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class h{getHeight(M){return 22}getTemplateId(M){return k(M)?"process":p(M)?"machine":(0,c.isRemoteDiagnosticError)(M)?"error":O(M)?"header":""}}class s{hasChildren(M){return(0,c.isRemoteDiagnosticError)(M)?!1:k(M)?!!M.children?.length:!0}getChildren(M){return k(M)?M.children?M.children:[]:(0,c.isRemoteDiagnosticError)(M)?[]:O(M)?M.processRoots.length>1?M.processRoots:[M.processRoots[0].rootProcess]:p(M)?[M.rootProcess]:[M.processes]}}class D{constructor(){this.templateId="header"}renderTemplate(M){const H=(0,L.append)(M,(0,L.$)(".row")),Z=(0,L.append)(H,(0,L.$)(".nameLabel")),ne=(0,L.append)(H,(0,L.$)(".cpu")),se=(0,L.append)(H,(0,L.$)(".memory")),he=(0,L.append)(H,(0,L.$)(".pid"));return{name:Z,CPU:ne,memory:se,PID:he}}renderElement(M,H,Z,ne){Z.name.textContent=(0,E.localize)(0,null),Z.CPU.textContent=(0,E.localize)(1,null),Z.PID.textContent=(0,E.localize)(2,null),Z.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(M){}}class v{constructor(){this.templateId="machine"}renderTemplate(M){const H=Object.create(null),Z=(0,L.append)(M,(0,L.$)(".row"));return H.name=(0,L.append)(Z,(0,L.$)(".nameLabel")),H}renderElement(M,H,Z,ne){Z.name.textContent=M.element.name}disposeTemplate(M){}}class A{constructor(){this.templateId="error"}renderTemplate(M){const H=Object.create(null),Z=(0,L.append)(M,(0,L.$)(".row"));return H.name=(0,L.append)(Z,(0,L.$)(".nameLabel")),H}renderElement(M,H,Z,ne){Z.name.textContent=M.element.errorMessage}disposeTemplate(M){}}class f{constructor(M,H,Z){this.platform=M,this.totalMem=H,this.mapPidToName=Z,this.templateId="process"}renderTemplate(M){const H=(0,L.append)(M,(0,L.$)(".row")),Z=(0,L.append)(H,(0,L.$)(".nameLabel")),ne=(0,L.append)(H,(0,L.$)(".cpu")),se=(0,L.append)(H,(0,L.$)(".memory")),he=(0,L.append)(H,(0,L.$)(".pid"));return{name:Z,CPU:ne,PID:he,memory:se}}renderElement(M,H,Z,ne){const{element:se}=M,he=se.pid.toFixed(0);let ue=se.name;this.mapPidToName.has(se.pid)&&(ue=this.mapPidToName.get(se.pid)),Z.name.textContent=ue,Z.name.title=se.cmd,Z.CPU.textContent=se.load.toFixed(0),Z.PID.textContent=he,Z.PID.parentElement.id=`pid-${he}`;const le=this.platform==="win32"?se.mem:this.totalMem*(se.mem/100);Z.memory.textContent=(le/a.ByteSize.MB).toFixed(0)}disposeTemplate(M){}}function p(N){return!!N.name&&!!N.rootProcess}function O(N){return!!N.processRoots}function k(N){return!!N.pid}class m{constructor(M,H){this.data=H,this.mapPidToName=new Map;const Z=new d.ElectronIPCMainProcessService(M);this.nativeHostService=new I.NativeHostService(M,Z),this.applyStyles(H.styles),this.setEventHandlers(H),y.ipcRenderer.on("vscode:pidToNameResponse",(ne,se)=>{this.mapPidToName=new Map;for(const[he,ue]of se)this.mapPidToName.set(he,ue)}),y.ipcRenderer.on("vscode:listProcessesResponse",async(ne,se)=>{se.forEach((he,ue)=>{k(he.rootProcess)&&(he.rootProcess.name=ue===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:se}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(se),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),y.ipcRenderer.send("vscode:pidToNameRequest"),y.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(M){document.onkeydown=H=>{const Z=M.platform==="darwin"?H.metaKey:H.ctrlKey;Z&&H.keyCode===87&&(H.stopPropagation(),H.preventDefault(),y.ipcRenderer.send("vscode:closeProcessExplorer")),Z&&H.keyCode===187&&(0,u.zoomIn)(),Z&&H.keyCode===189&&(0,u.zoomOut)()}}async createProcessTree(M){const H=document.getElementById("process-list");if(!H)return;const{totalmem:Z}=await this.nativeHostService.getOSStatistics(),ne=[new f(this.data.platform,Z,this.mapPidToName),new D,new v,new A];this.tree=new i.DataTree("processExplorer",H,new h,ne,new s,{identityProvider:{getId:se=>k(se)?se.pid.toString():(0,c.isRemoteDiagnosticError)(se)?se.hostName:O(se)?"processes":p(se)?se.name:"header"}}),this.tree.setInput({processes:{processRoots:M}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onKeyDown(se=>{const he=new e.StandardKeyboardEvent(se);if(he.keyCode===35&&he.altKey){const ue=this.getSelectedPids();Promise.all(ue.map(le=>this.nativeHostService.killProcess(le,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(se=>{k(se.element)&&this.showContextMenu(se.element,!0)}),H.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{H.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(M){const H=l.exec(M);return H&&H.groups.port!=="0"||M.indexOf("node ")>=0||M.indexOf("node.exe")>=0}attachTo(M){const H={type:"node",request:"attach",name:`process ${M.pid}`};let Z=l.exec(M.cmd);Z?H.port=Number(Z.groups.port):H.processId=String(M.pid),Z=n.exec(M.cmd),Z&&(H.port=Number(Z.groups.port)),y.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[H]})}applyStyles(M){const H=(0,L.createStyleSheet)(),Z=[];M.listFocusBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${M.listFocusBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${M.listFocusBackground}; }`)),M.listFocusForeground&&Z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${M.listFocusForeground}; }`),M.listActiveSelectionBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${M.listActiveSelectionBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${M.listActiveSelectionBackground}; }`)),M.listActiveSelectionForeground&&Z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${M.listActiveSelectionForeground}; }`),M.listHoverBackground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${M.listHoverBackground}; }`),M.listHoverForeground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${M.listHoverForeground}; }`),M.listFocusOutline&&Z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${M.listFocusOutline}; outline-offset: -1px; }`),M.listHoverOutline&&Z.push(`.monaco-list-row:hover { outline: 1px dashed ${M.listHoverOutline}; outline-offset: -1px; }`),M.scrollbarShadowColor&&Z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${M.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),M.scrollbarSliderBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${M.scrollbarSliderBackgroundColor};
				}
			`),M.scrollbarSliderHoverBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${M.scrollbarSliderHoverBackgroundColor};
				}
			`),M.scrollbarSliderActiveBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${M.scrollbarSliderActiveBackgroundColor};
				}
			`),H.textContent=Z.join(`
`),M.color&&(document.body.style.color=M.color)}showContextMenu(M,H){const Z=[],ne=Number(M.pid);H&&(Z.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGTERM")}}),Z.push({label:(0,E.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGKILL")}}),Z.push({type:"separator"})),Z.push({label:(0,E.localize)(6,null),click:()=>{const se=this.getSelectedPids();se?.includes(ne)||(se.length=0,se.push(ne));const he=se?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(he){const ue=he.map(le=>le.innerText).filter(le=>!!le);this.nativeHostService.writeClipboardText(ue.join(`
`))}}}),Z.push({label:(0,E.localize)(7,null),click:()=>{const se=document.getElementById("process-list");se&&this.nativeHostService.writeClipboardText(se.innerText)}}),M&&H&&this.isDebuggable(M.cmd)&&(Z.push({type:"separator"}),Z.push({label:(0,E.localize)(8,null),click:()=>{this.attachTo(M)}})),(0,w.popup)(Z)}requestProcessList(M){setTimeout(()=>{const H=Date.now(),Z=M+H-this.lastRequestTime;this.lastRequestTime=H,Z>1e3?(y.ipcRenderer.send("vscode:pidToNameRequest"),y.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(Z)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(M=>{if(!(!M||!("pid"in M)))return M.pid}).filter(M=>!!M)}}function g(){const N=(0,L.createStyleSheet)();N.id="codiconStyles";const M=(0,r.getIconsStyleSheet)(void 0);function H(){N.textContent=M.getCSS()}const Z=new W.RunOnceScheduler(H,0);M.onDidChange(()=>Z.schedule()),Z.schedule()}function b(N){const M=N.data.platform==="win32"?"windows":N.data.platform==="linux"?"linux":"mac";document.body.classList.add(M),g(),(0,u.applyZoom)(N.data.zoomLevel),new m(N.windowId,N.data)}t.startup=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
