/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/hash","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(q){for(var e=[],T=0,O=q.length;T<O;T++)e[T]=ne[q[T]];return e};define(ne[51],re([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(w,f,l)=>{let D=null,I=null;if(typeof l.value=="function"?(D="value",I=l.value):typeof l.get=="function"&&(D="get",I=l.get),!I)throw new Error("not supported");l[D]=N(I,f)}}function O(N,w,f){let l=null,D=null;if(typeof f.value=="function"?(l="value",D=f.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",D=f.get),!D)throw new Error("not supported");const I=`$memoize$${w}`;f[l]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,v)}),this[I]}}e.memoize=O;function R(N,w,f){return T((l,D)=>{const I=`$debounce$${D}`,v=`$debounce$result$${D}`;return function(...g){this[v]||(this[v]=f?f():void 0),clearTimeout(this[I]),w&&(this[v]=w(this[v],...g),g=[this[v]]),this[I]=setTimeout(()=>{l.apply(this,g),this[v]=f?f():void 0},N)}})}e.debounce=R;function A(N,w,f){return T((l,D)=>{const I=`$throttle$timer$${D}`,v=`$throttle$result$${D}`,g=`$throttle$lastRun$${D}`,L=`$throttle$pending$${D}`;return function(...E){if(this[v]||(this[v]=f?f():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),w&&(this[v]=w(this[v],...E)),this[L])return;const u=this[g]+N;u<=Date.now()?(this[g]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0):(this[L]=!0,this[I]=setTimeout(()=>{this[L]=!1,this[g]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0},u-Date.now()))}})}e.throttle=A}),define(ne[70],re([0,1,9]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function R(f,l="Unreachable"){throw new Error(l)}e.assertNever=R;function A(f){if(!f)throw new T.BugIndicatingError("Assertion Failed")}e.assert=A;function N(f){if(!f()){debugger;f(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function w(f,l){let D=0;for(;D<f.length-1;){const I=f[D],v=f[D+1];if(!l(I,v))return!1;D++}return!0}e.checkAdjacentItems=w}),define(ne[52],re([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T||(e.ScanError=T={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(t,o=!1){let n=0;const i=t.length;let r="",a=0,c=16,C=0;function S(Q){let ce=0,ae=0;for(;ce<Q;){const se=t.charCodeAt(n);if(se>=48&&se<=57)ae=ae*16+se-48;else if(se>=65&&se<=70)ae=ae*16+se-65+10;else if(se>=97&&se<=102)ae=ae*16+se-97+10;else break;n++,ce++}return ce<Q&&(ae=-1),ae}function m(Q){n=Q,r="",a=0,c=16,C=0}function x(){const Q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&l(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&l(t.charCodeAt(n)))for(n++;n<t.length&&l(t.charCodeAt(n));)n++;else return C=3,t.substring(Q,n);let ce=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&l(t.charCodeAt(n))){for(n++;n<t.length&&l(t.charCodeAt(n));)n++;ce=n}else C=3;return t.substring(Q,ce)}function X(){let Q="",ce=n;for(;;){if(n>=i){Q+=t.substring(ce,n),C=2;break}const ae=t.charCodeAt(n);if(ae===34){Q+=t.substring(ce,n),n++;break}if(ae===92){if(Q+=t.substring(ce,n),n++,n>=i){C=2;break}switch(t.charCodeAt(n++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const j=S(4);j>=0?Q+=String.fromCharCode(j):C=4;break}default:C=5}ce=n;continue}if(ae>=0&&ae<=31)if(f(ae)){Q+=t.substring(ce,n),C=2;break}else C=6;n++}return Q}function K(){if(r="",C=0,a=n,n>=i)return a=i,c=17;let Q=t.charCodeAt(n);if(w(Q)){do n++,r+=String.fromCharCode(Q),Q=t.charCodeAt(n);while(w(Q));return c=15}if(f(Q))return n++,r+=String.fromCharCode(Q),Q===13&&t.charCodeAt(n)===10&&(n++,r+=`
`),c=14;switch(Q){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,r=X(),c=10;case 47:{const ce=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!f(t.charCodeAt(n));)n++;return r=t.substring(ce,n),c=12}if(t.charCodeAt(n+1)===42){n+=2;const ae=i-1;let se=!1;for(;n<ae;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,se=!0;break}n++}return se||(n++,C=1),r=t.substring(ce,n),c=13}return r+=String.fromCharCode(Q),n++,c=16}case 45:if(r+=String.fromCharCode(Q),n++,n===i||!l(t.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=x(),c=11;default:for(;n<i&&ie(Q);)n++,Q=t.charCodeAt(n);if(a!==n){switch(r=t.substring(a,n),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(Q),n++,c=16}}function ie(Q){if(w(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let Q;do Q=K();while(Q>=12&&Q<=15);return Q}return{setPosition:m,getPosition:()=>n,scan:o?ue:K,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>C}}e.createScanner=N;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function I(t,o){const n=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function C(S,m,x,X){a.value=S,a.offset=m,a.length=x,a.type=X,a.colonOffset=void 0,r=a}try{y(t,{onObjectBegin:(S,m)=>{if(o<=S)throw i;r=void 0,c=o>S,n.push("")},onObjectProperty:(S,m,x)=>{if(o<m||(C(S,m,x,"property"),n[n.length-1]=S,o<=m+x))throw i},onObjectEnd:(S,m)=>{if(o<=S)throw i;r=void 0,n.pop()},onArrayBegin:(S,m)=>{if(o<=S)throw i;r=void 0,n.push(0)},onArrayEnd:(S,m)=>{if(o<=S)throw i;r=void 0,n.pop()},onLiteralValue:(S,m,x)=>{if(o<m||(C(S,m,x,P(S)),o<=m+x))throw i},onSeparator:(S,m,x)=>{if(o<=m)throw i;if(S===":"&&r&&r.type==="property")r.colonOffset=m,c=!1,r=void 0;else if(S===","){const X=n[n.length-1];typeof X=="number"?n[n.length-1]=X+1:(c=!0,n[n.length-1]=""),r=void 0}}})}catch(S){if(S!==i)throw S}return{path:n,previousNode:r,isAtPropertyKey:c,matches:S=>{let m=0;for(let x=0;m<S.length&&x<n.length;x++)if(S[m]===n[x]||S[m]==="*")m++;else if(S[m]!=="**")return!1;return m===S.length}}}e.getLocation=I;function v(t,o=[],n=A.DEFAULT){let i=null,r=[];const a=[];function c(S){Array.isArray(r)?r.push(S):i!==null&&(r[i]=S)}return y(t,{onObjectBegin:()=>{const S={};c(S),a.push(r),r=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];c(S),a.push(r),r=S,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:c,onError:(S,m,x)=>{o.push({error:S,offset:m,length:x})}},n),r[0]}e.parse=v;function g(t,o=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function a(S){return i.children.push(S),S}y(t,{onObjectBegin:S=>{i=a({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,m,x)=>{i=a({type:"property",offset:m,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:m,length:x,parent:i})},onObjectEnd:(S,m)=>{i.length=S+m-i.offset,i=i.parent,r(S+m)},onArrayBegin:(S,m)=>{i=a({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,m)=>{i.length=S+m-i.offset,i=i.parent,r(S+m)},onLiteralValue:(S,m,x)=>{a({type:P(S),offset:m,length:x,parent:i,value:S}),r(m+x)},onSeparator:(S,m,x)=>{i.type==="property"&&(S===":"?i.colonOffset=m:S===","&&r(m))},onError:(S,m,x)=>{o.push({error:S,offset:m,length:x})}},n);const C=i.children[0];return C&&delete C.parent,C}e.parseTree=g;function L(t,o){if(!t)return;let n=t;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=L;function E(t){if(!t.parent||!t.parent.children)return[];const o=E(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.getNodePath=E;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const o=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(o[n.children[0].value]=u(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function d(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.contains=d;function h(t,o,n=!1){if(d(t,o,n)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=o;r++){const a=h(i[r],o,n);if(a)return a}return t}}e.findNodeAtOffset=h;function y(t,o,n=A.DEFAULT){const i=N(t,!1);function r(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(Y){return Y?F=>Y(F,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=r(o.onObjectBegin),C=a(o.onObjectProperty),S=r(o.onObjectEnd),m=r(o.onArrayBegin),x=r(o.onArrayEnd),X=a(o.onLiteralValue),K=a(o.onSeparator),ie=r(o.onComment),ue=a(o.onError),Q=n&&n.disallowComments,ce=n&&n.allowTrailingComma;function ae(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:Q||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(Y){case 12:case 13:Q?se(10):ie();break;case 16:se(1);break;case 15:case 14:break;default:return Y}}}function se(Y,F=[],U=[]){if(ue(Y),F.length+U.length>0){let k=i.getToken();for(;k!==17;){if(F.indexOf(k)!==-1){ae();break}else if(U.indexOf(k)!==-1)break;k=ae()}}}function j(Y){const F=i.getTokenValue();return Y?X(F):C(F),ae(),!0}function B(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(se(2),Y=0)}catch{se(2)}X(Y);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return ae(),!0}function V(){return i.getToken()!==10?(se(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(K(":"),ae(),G()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function M(){c(),ae();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||se(4,[],[]),K(","),ae(),i.getToken()===2&&ce)break}else Y&&se(6,[],[]);V()||se(4,[],[2,5]),Y=!0}return S(),i.getToken()!==2?se(7,[2],[]):ae(),!0}function $(){m(),ae();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||se(4,[],[]),K(","),ae(),i.getToken()===4&&ce)break}else Y&&se(6,[],[]);G()||se(4,[],[4,5]),Y=!0}return x(),i.getToken()!==4?se(8,[4],[]):ae(),!0}function G(){switch(i.getToken()){case 3:return $();case 1:return M();case 10:return j(!0);default:return B()}}return ae(),i.getToken()===17?n.allowEmptyContent?!0:(se(4,[],[]),!1):G()?(i.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=y;function p(t,o){const n=N(t),i=[];let r,a=0,c;do switch(c=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:a!==c&&i.push(t.substring(a,c)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=p;function P(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=P}),define(ne[71],re([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(w,f,l){return Math.min(Math.max(w,f),l)}e.clamp=T;function O(w,f){return(f+w%f)%f}e.rot=O;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class A{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class N{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const l=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=N}),function(){function q(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function N(f){A.push(f,Date.now())}function w(){const f=[];for(let l=0;l<A.length;l+=2)f.push({name:A[l],startTime:A[l+1]});return f}return{mark:N,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(R+N.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function T(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=T(O))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var O in T)(typeof exports=="object"?exports:q)[O]=T[O]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function T(O){if(e[O])return e[O].exports;var R=e[O]={i:O,l:!1,exports:{}};return q[O].call(R.exports,R,R.exports,T),R.l=!0,R.exports}return T.m=q,T.c=e,T.d=function(O,R,A){T.o(O,R)||Object.defineProperty(O,R,{enumerable:!0,get:A})},T.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},T.t=function(O,R){if(1&R&&(O=T(O)),8&R||4&R&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(T.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&R&&typeof O!="string")for(var N in O)T.d(A,N,function(w){return O[w]}.bind(null,N));return A},T.n=function(O){var R=O&&O.__esModule?function(){return O.default}:function(){return O};return T.d(R,"a",R),R},T.o=function(O,R){return Object.prototype.hasOwnProperty.call(O,R)},T.p="",T(T.s=0)}([function(q,e,T){(function(O){var R;e=q.exports=U,R=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],f=e.src=[],l=0,D=l++;f[D]="0|[1-9]\\d*";var I=l++;f[I]="[0-9]+";var v=l++;f[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=l++;f[g]="("+f[D]+")\\.("+f[D]+")\\.("+f[D]+")";var L=l++;f[L]="("+f[I]+")\\.("+f[I]+")\\.("+f[I]+")";var E=l++;f[E]="(?:"+f[D]+"|"+f[v]+")";var u=l++;f[u]="(?:"+f[I]+"|"+f[v]+")";var d=l++;f[d]="(?:-("+f[E]+"(?:\\."+f[E]+")*))";var h=l++;f[h]="(?:-?("+f[u]+"(?:\\."+f[u]+")*))";var y=l++;f[y]="[0-9A-Za-z-]+";var p=l++;f[p]="(?:\\+("+f[y]+"(?:\\."+f[y]+")*))";var P=l++,t="v?"+f[g]+f[d]+"?"+f[p]+"?";f[P]="^"+t+"$";var o="[v=\\s]*"+f[L]+f[h]+"?"+f[p]+"?",n=l++;f[n]="^"+o+"$";var i=l++;f[i]="((?:<|>)?=?)";var r=l++;f[r]=f[I]+"|x|X|\\*";var a=l++;f[a]=f[D]+"|x|X|\\*";var c=l++;f[c]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[d]+")?"+f[p]+"?)?)?";var C=l++;f[C]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[h]+")?"+f[p]+"?)?)?";var S=l++;f[S]="^"+f[i]+"\\s*"+f[c]+"$";var m=l++;f[m]="^"+f[i]+"\\s*"+f[C]+"$";var x=l++;f[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=l++;f[X]="(?:~>?)";var K=l++;f[K]="(\\s*)"+f[X]+"\\s+",w[K]=new RegExp(f[K],"g");var ie=l++;f[ie]="^"+f[X]+f[c]+"$";var ue=l++;f[ue]="^"+f[X]+f[C]+"$";var Q=l++;f[Q]="(?:\\^)";var ce=l++;f[ce]="(\\s*)"+f[Q]+"\\s+",w[ce]=new RegExp(f[ce],"g");var ae=l++;f[ae]="^"+f[Q]+f[c]+"$";var se=l++;f[se]="^"+f[Q]+f[C]+"$";var j=l++;f[j]="^"+f[i]+"\\s*("+o+")$|^$";var B=l++;f[B]="^"+f[i]+"\\s*("+t+")$|^$";var V=l++;f[V]="(\\s*)"+f[i]+"\\s*("+o+"|"+f[c]+")",w[V]=new RegExp(f[V],"g");var M=l++;f[M]="^\\s*("+f[c]+")\\s+-\\s+("+f[c]+")\\s*$";var $=l++;f[$]="^\\s*("+f[C]+")\\s+-\\s+("+f[C]+")\\s*$";var G=l++;f[G]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)R(Y,f[Y]),w[Y]||(w[Y]=new RegExp(f[Y]));function F(z,J){if(z instanceof U)return z;if(typeof z!="string"||z.length>A||!(J?w[n]:w[P]).test(z))return null;try{return new U(z,J)}catch{return null}}function U(z,J){if(z instanceof U){if(z.loose===J)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(z,J);R("SemVer",z,J),this.loose=J;var ee=z.trim().match(J?w[n]:w[P]);if(!ee)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var Se=+me;if(Se>=0&&Se<N)return Se}return me}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=F,e.valid=function(z,J){var ee=F(z,J);return ee?ee.version:null},e.clean=function(z,J){var ee=F(z.trim().replace(/^[=v]+/,""),J);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof U||(z=new U(z,this.loose)),this.compareMain(z)||this.comparePre(z)},U.prototype.compareMain=function(z){return z instanceof U||(z=new U(z,this.loose)),s(this.major,z.major)||s(this.minor,z.minor)||s(this.patch,z.patch)},U.prototype.comparePre=function(z){if(z instanceof U||(z=new U(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var J=0;do{var ee=this.prerelease[J],me=z.prerelease[J];if(R("prerelease compare",J,ee,me),ee===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ee===void 0)return-1;if(ee!==me)return s(ee,me)}while(++J)},U.prototype.inc=function(z,J){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,J,ee,me){typeof ee=="string"&&(me=ee,ee=void 0);try{return new U(z,ee).inc(J,me).version}catch{return null}},e.diff=function(z,J){if(H(z,J))return null;var ee=F(z),me=F(J);if(ee.prerelease.length||me.prerelease.length){for(var Se in ee)if((Se==="major"||Se==="minor"||Se==="patch")&&ee[Se]!==me[Se])return"pre"+Se;return"prerelease"}for(var Se in ee)if((Se==="major"||Se==="minor"||Se==="patch")&&ee[Se]!==me[Se])return Se},e.compareIdentifiers=s;var k=/^[0-9]+$/;function s(z,J){var ee=k.test(z),me=k.test(J);return ee&&me&&(z=+z,J=+J),ee&&!me?-1:me&&!ee?1:z<J?-1:z>J?1:0}function b(z,J,ee){return new U(z,ee).compare(new U(J,ee))}function _(z,J,ee){return b(z,J,ee)>0}function W(z,J,ee){return b(z,J,ee)<0}function H(z,J,ee){return b(z,J,ee)===0}function Z(z,J,ee){return b(z,J,ee)!==0}function le(z,J,ee){return b(z,J,ee)>=0}function de(z,J,ee){return b(z,J,ee)<=0}function pe(z,J,ee,me){var Se;switch(J){case"===":typeof z=="object"&&(z=z.version),typeof ee=="object"&&(ee=ee.version),Se=z===ee;break;case"!==":typeof z=="object"&&(z=z.version),typeof ee=="object"&&(ee=ee.version),Se=z!==ee;break;case"":case"=":case"==":Se=H(z,ee,me);break;case"!=":Se=Z(z,ee,me);break;case">":Se=_(z,ee,me);break;case">=":Se=le(z,ee,me);break;case"<":Se=W(z,ee,me);break;case"<=":Se=de(z,ee,me);break;default:throw new TypeError("Invalid operator: "+J)}return Se}function fe(z,J){if(z instanceof fe){if(z.loose===J)return z;z=z.value}if(!(this instanceof fe))return new fe(z,J);R("comparator",z,J),this.loose=J,this.parse(z),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,J){return s(J,z)},e.major=function(z,J){return new U(z,J).major},e.minor=function(z,J){return new U(z,J).minor},e.patch=function(z,J){return new U(z,J).patch},e.compare=b,e.compareLoose=function(z,J){return b(z,J,!0)},e.rcompare=function(z,J,ee){return b(J,z,ee)},e.sort=function(z,J){return z.sort(function(ee,me){return e.compare(ee,me,J)})},e.rsort=function(z,J){return z.sort(function(ee,me){return e.rcompare(ee,me,J)})},e.gt=_,e.lt=W,e.eq=H,e.neq=Z,e.gte=le,e.lte=de,e.cmp=pe,e.Comparator=fe;var ge={};function oe(z,J){if(z instanceof oe)return z.loose===J?z:new oe(z.raw,J);if(z instanceof fe)return new oe(z.value,J);if(!(this instanceof oe))return new oe(z,J);if(this.loose=J,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function he(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ee(z,J,ee,me,Se,ke,Pe,Oe,Ce,Le,Fe,Ie,Te){return((J=he(ee)?"":he(me)?">="+ee+".0.0":he(Se)?">="+ee+"."+me+".0":">="+J)+" "+(Oe=he(Ce)?"":he(Le)?"<"+(+Ce+1)+".0.0":he(Fe)?"<"+Ce+"."+(+Le+1)+".0":Ie?"<="+Ce+"."+Le+"."+Fe+"-"+Ie:"<="+Oe)).trim()}function De(z,J){for(var ee=0;ee<z.length;ee++)if(!z[ee].test(J))return!1;if(J.prerelease.length){for(ee=0;ee<z.length;ee++)if(R(z[ee].semver),z[ee].semver!==ge&&z[ee].semver.prerelease.length>0){var me=z[ee].semver;if(me.major===J.major&&me.minor===J.minor&&me.patch===J.patch)return!0}return!1}return!0}function Ne(z,J,ee){try{J=new oe(J,ee)}catch{return!1}return J.test(z)}function Me(z,J,ee,me){var Se,ke,Pe,Oe,Ce;switch(z=new U(z,me),J=new oe(J,me),ee){case">":Se=_,ke=de,Pe=W,Oe=">",Ce=">=";break;case"<":Se=W,ke=le,Pe=_,Oe="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(z,J,me))return!1;for(var Le=0;Le<J.set.length;++Le){var Fe=J.set[Le],Ie=null,Te=null;if(Fe.forEach(function(xe){xe.semver===ge&&(xe=new fe(">=0.0.0")),Ie=Ie||xe,Te=Te||xe,Se(xe.semver,Ie.semver,me)?Ie=xe:Pe(xe.semver,Te.semver,me)&&(Te=xe)}),Ie.operator===Oe||Ie.operator===Ce||(!Te.operator||Te.operator===Oe)&&ke(z,Te.semver)||Te.operator===Ce&&Pe(z,Te.semver))return!1}return!0}fe.prototype.parse=function(z){var J=this.loose?w[j]:w[B],ee=z.match(J);if(!ee)throw new TypeError("Invalid comparator: "+z);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ge},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===ge||(typeof z=="string"&&(z=new U(z,this.loose)),pe(z,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(z,J){if(!(z instanceof fe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new oe(z.value,J),Ne(this.value,ee,J);if(z.operator==="")return ee=new oe(this.value,J),Ne(z.semver,ee,J);var me=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ke=this.semver.version===z.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Oe=pe(this.semver,"<",z.semver,J)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ce=pe(this.semver,">",z.semver,J)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return me||Se||ke&&Pe||Oe||Ce},e.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(z){var J=this.loose;z=z.trim(),R("range",z,J);var ee=J?w[$]:w[M];z=z.replace(ee,Ee),R("hyphen replace",z),z=z.replace(w[V],"$1$2$3"),R("comparator trim",z,w[V]),z=(z=(z=z.replace(w[K],"$1~")).replace(w[ce],"$1^")).split(/\s+/).join(" ");var me=J?w[j]:w[B],Se=z.split(" ").map(function(ke){return function(Pe,Oe){return R("comp",Pe),Pe=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Fe){return function(Ie,Te){R("caret",Ie,Te);var xe=Te?w[se]:w[ae];return Ie.replace(xe,function(_e,ye,we,be,Re){var Ae;return R("caret",Ie,_e,ye,we,be,Re),he(ye)?Ae="":he(we)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(be)?Ae=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+Re+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+Re+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+Re+" <"+(+ye+1)+".0.0"):(R("no pr"),Ae=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+" <"+(+ye+1)+".0.0"),R("caret return",Ae),Ae})}(Fe,Le)}).join(" ")}(Pe,Oe),R("caret",Pe),Pe=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Fe){return function(Ie,Te){var xe=Te?w[ue]:w[ie];return Ie.replace(xe,function(_e,ye,we,be,Re){var Ae;return R("tilde",Ie,_e,ye,we,be,Re),he(ye)?Ae="":he(we)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(be)?Ae=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=">="+ye+"."+we+"."+be+Re+" <"+ye+"."+(+we+1)+".0"):Ae=">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0",R("tilde return",Ae),Ae})}(Fe,Le)}).join(" ")}(Pe,Oe),R("tildes",Pe),Pe=function(Ce,Le){return R("replaceXRanges",Ce,Le),Ce.split(/\s+/).map(function(Fe){return function(Ie,Te){Ie=Ie.trim();var xe=Te?w[m]:w[S];return Ie.replace(xe,function(_e,ye,we,be,Re,Ae){R("xRange",Ie,_e,ye,we,be,Re,Ae);var $e=he(we),Ve=$e||he(be),We=Ve||he(Re);return ye==="="&&We&&(ye=""),$e?_e=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(Ve&&(be=0),We&&(Re=0),ye===">"?(ye=">=",Ve?(we=+we+1,be=0,Re=0):We&&(be=+be+1,Re=0)):ye==="<="&&(ye="<",Ve?we=+we+1:be=+be+1),_e=ye+we+"."+be+"."+Re):Ve?_e=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(_e=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),R("xRange return",_e),_e})}(Fe,Le)}).join(" ")}(Pe,Oe),R("xrange",Pe),Pe=function(Ce,Le){return R("replaceStars",Ce,Le),Ce.trim().replace(w[G],"")}(Pe,Oe),R("stars",Pe),Pe}(ke,J)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(ke){return!!ke.match(me)})),Se=Se.map(function(ke){return new fe(ke,J)})},oe.prototype.intersects=function(z,J){if(!(z instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(me){return z.set.some(function(Se){return Se.every(function(ke){return me.intersects(ke,J)})})})})},e.toComparators=function(z,J){return new oe(z,J).set.map(function(ee){return ee.map(function(me){return me.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new U(z,this.loose));for(var J=0;J<this.set.length;J++)if(De(this.set[J],z))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(z,J,ee){var me=null,Se=null;try{var ke=new oe(J,ee)}catch{return null}return z.forEach(function(Pe){ke.test(Pe)&&(me&&Se.compare(Pe)!==-1||(Se=new U(me=Pe,ee)))}),me},e.minSatisfying=function(z,J,ee){var me=null,Se=null;try{var ke=new oe(J,ee)}catch{return null}return z.forEach(function(Pe){ke.test(Pe)&&(me&&Se.compare(Pe)!==1||(Se=new U(me=Pe,ee)))}),me},e.validRange=function(z,J){try{return new oe(z,J).range||"*"}catch{return null}},e.ltr=function(z,J,ee){return Me(z,J,"<",ee)},e.gtr=function(z,J,ee){return Me(z,J,">",ee)},e.outside=Me,e.prerelease=function(z,J){var ee=F(z,J);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(z,J,ee){return z=new oe(z,ee),J=new oe(J,ee),z.intersects(J)},e.coerce=function(z){if(z instanceof U)return z;if(typeof z!="string")return null;var J=z.match(w[x]);return J==null?null:F((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,T(1))},function(q,e){var T,O,R=q.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function w(u){if(T===setTimeout)return setTimeout(u,0);if((T===A||!T)&&setTimeout)return T=setTimeout,setTimeout(u,0);try{return T(u,0)}catch{try{return T.call(null,u,0)}catch{return T.call(this,u,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:A}catch{T=A}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var f,l=[],D=!1,I=-1;function v(){D&&f&&(D=!1,f.length?l=f.concat(l):I=-1,l.length&&g())}function g(){if(!D){var u=w(v);D=!0;for(var d=l.length;d;){for(f=l,l=[];++I<d;)f&&f[I].run();I=-1,d=l.length}f=null,D=!1,function(h){if(O===clearTimeout)return clearTimeout(h);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(h);try{O(h)}catch{try{return O.call(null,h)}catch{return O.call(this,h)}}}(u)}}function L(u,d){this.fun=u,this.array=d}function E(){}R.nextTick=function(u){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];l.push(new L(u,d)),l.length!==1||D||w(g)},L.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=E,R.addListener=E,R.once=E,R.off=E,R.removeListener=E,R.removeAllListeners=E,R.emit=E,R.prependListener=E,R.prependOnceListener=E,R.listeners=function(u){return[]},R.binding=function(u){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(u){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[72],re([0,1]),function(q,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(w,f,l){this.level=w,this.key=f,this.value=l,this.forward=[]}}const R=void 0;class A{constructor(w,f=2**16){this.comparator=w,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new O(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,R,R)}has(w){return!!A._search(this,w,this.comparator)}get(w){return A._search(this,w,this.comparator)?.value}set(w,f){return A._insert(this,w,f,this.comparator)&&(this._size+=1),this}delete(w){const f=A._delete(this,w,this.comparator);return f&&(this._size-=1),f}forEach(w,f){let l=this._header.forward[0];for(;l;)w.call(f,l.value,l.key,this),l=l.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",f=this._header.forward[0];for(;f;)w+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return w}static _search(w,f,l){let D=w._header;for(let I=w._level-1;I>=0;I--)for(;D.forward[I]&&l(D.forward[I].key,f)<0;)D=D.forward[I];if(D=D.forward[0],D&&l(D.key,f)===0)return D}static _insert(w,f,l,D){const I=[];let v=w._header;for(let g=w._level-1;g>=0;g--){for(;v.forward[g]&&D(v.forward[g].key,f)<0;)v=v.forward[g];I[g]=v}if(v=v.forward[0],v&&D(v.key,f)===0)return v.value=l,!1;{const g=A._randomLevel(w);if(g>w._level){for(let L=w._level;L<g;L++)I[L]=w._header;w._level=g}v=new O(g,f,l);for(let L=0;L<g;L++)v.forward[L]=I[L].forward[L],I[L].forward[L]=v;return!0}}static _randomLevel(w,f=.5){let l=1;for(;Math.random()<f&&l<w._maxLevel;)l+=1;return l}static _delete(w,f,l){const D=[];let I=w._header;for(let v=w._level-1;v>=0;v--){for(;I.forward[v]&&l(I.forward[v].key,f)<0;)I=I.forward[v];D[v]=I}if(I=I.forward[0],!I||l(I.key,f)!==0)return!1;for(let v=0;v<w._level&&D[v].forward[v]===I;v++)D[v].forward[v]=I.forward[v];for(;w._level>0&&w._header.forward[w._level-1]===R;)w._level-=1;return!0}}e.SkipList=A}),define(ne[44],re([0,1,9,2]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(p){const P=p;return P?typeof P.read=="function":!1}e.isReadable=R;function A(p){const P=p;return P?[P.on,P.pause,P.resume,P.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function N(p){const P=p;return P?A(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.isReadableBufferedStream=N;function w(p,P){return new f(p,P)}e.newWriteableStream=w;class f{constructor(P,t){this.reducer=P,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(P){if(!this.state.destroyed){if(this.state.flowing)this.emitData(P);else if(this.buffer.data.push(P),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(P){this.state.destroyed||(this.state.flowing?this.emitError(P):this.buffer.error.push(P))}end(P){this.state.destroyed||(typeof P<"u"&&this.write(P),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(P){this.listeners.data.slice(0).forEach(t=>t(P))}emitError(P){this.listeners.error.length===0?(0,T.onUnexpectedError)(P):this.listeners.error.slice(0).forEach(t=>t(P))}emitEnd(){this.listeners.end.slice(0).forEach(P=>P())}on(P,t){if(!this.state.destroyed)switch(P){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(P,t){if(this.state.destroyed)return;let o;switch(P){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const P=this.reducer(this.buffer.data);this.emitData(P),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const P of this.buffer.error)this.emitError(P);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(p,P){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return P(t)}e.consumeReadable=l;function D(p,P,t){const o=[];let n;for(;(n=p.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?P(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return p.read()}}}e.peekReadable=D;function I(p,P){return new Promise((t,o)=>{const n=[];v(p,{onData:i=>{P&&n.push(i)},onError:i=>{P?o(i):t(void 0)},onEnd:()=>{t(P?P(n):void 0)}})})}e.consumeStream=I;function v(p,P){let t=!1;return p.on("error",o=>{t||P.onError(o)}),p.on("end",()=>{t||P.onEnd()}),p.on("data",o=>{t||P.onData(o)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=v;function g(p,P){return new Promise((t,o)=>{const n=new O.DisposableStore,i=[],r=C=>{if(i.push(C),i.length>P)return n.dispose(),p.pause(),t({stream:p,buffer:i,ended:!1})},a=C=>o(C),c=()=>t({stream:p,buffer:i,ended:!0});n.add((0,O.toDisposable)(()=>p.removeListener("error",a))),p.on("error",a),n.add((0,O.toDisposable)(()=>p.removeListener("end",c))),p.on("end",c),n.add((0,O.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}e.peekStream=g;function L(p,P){const t=w(P);return t.end(p),t}e.toStream=L;function E(){const p=w(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=E;function u(p){let P=!1;return{read:()=>P?null:(P=!0,p)}}e.toReadable=u;function d(p,P,t){const o=w(t);return v(p,{onData:n=>o.write(P.data(n)),onError:n=>o.error(P.error?P.error(n):n),onEnd:()=>o.end()}),o}e.transform=d;function h(p,P,t){let o=!1;return{read:()=>{const n=P.read();return o?n:(o=!0,n!==null?t([p,n]):p)}}}e.prefixedReadable=h;function y(p,P,t){let o=!1;const n=w(t);return v(P,{onData:i=>o?n.write(i):(o=!0,n.write(t([p,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(p)),n.end()}}),n}e.prefixedStream=y}),define(ne[14],re([0,1,161,44]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u",A=new T.Lazy(()=>new Uint8Array(256));let N,w;class f{static alloc(m){return R?new f(Buffer.allocUnsafe(m)):new f(new Uint8Array(m))}static wrap(m){return R&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new f(m)}static fromString(m,x){return!(x?.dontUseNodeBuffer||!1)&&R?new f(Buffer.from(m)):(N||(N=new TextEncoder),new f(N.encode(m)))}static fromByteArray(m){const x=f.alloc(m.length);for(let X=0,K=m.length;X<K;X++)x.buffer[X]=m[X];return x}static concat(m,x){if(typeof x>"u"){x=0;for(let ie=0,ue=m.length;ie<ue;ie++)x+=m[ie].byteLength}const X=f.alloc(x);let K=0;for(let ie=0,ue=m.length;ie<ue;ie++){const Q=m[ie];X.set(Q,K),K+=Q.byteLength}return X}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=f.alloc(this.byteLength);return m.set(this),m}toString(){return R?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(m,x){return new f(this.buffer.subarray(m,x))}set(m,x){if(m instanceof f)this.buffer.set(m.buffer,x);else if(m instanceof Uint8Array)this.buffer.set(m,x);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),x);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),x);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return I(this.buffer,m)}writeUInt32BE(m,x){v(this.buffer,m,x)}readUInt32LE(m){return g(this.buffer,m)}writeUInt32LE(m,x){L(this.buffer,m,x)}readUInt8(m){return E(this.buffer,m)}writeUInt8(m,x){u(this.buffer,m,x)}indexOf(m){const x=m instanceof f?m.buffer:m,X=x.byteLength,K=this.buffer,ie=K.byteLength;if(X===0)return 0;if(X===1)return K.indexOf(x[0]);if(X>ie)return-1;const ue=A.value;ue.fill(x.length);for(let se=0;se<x.length;se++)ue[x[se]]=x.length-se-1;let Q=x.length-1,ce=Q,ae=-1;for(;Q<ie;)if(K[Q]===x[ce]){if(ce===0){ae=Q;break}Q--,ce--}else Q+=Math.max(x.length-ce,ue[K[Q]]),ce=x.length-1;return ae}}e.VSBuffer=f;function l(S,m){return S[m+0]<<0>>>0|S[m+1]<<8>>>0}e.readUInt16LE=l;function D(S,m,x){S[x+0]=m&255,m=m>>>8,S[x+1]=m&255}e.writeUInt16LE=D;function I(S,m){return S[m]*2**24+S[m+1]*2**16+S[m+2]*2**8+S[m+3]}e.readUInt32BE=I;function v(S,m,x){S[x+3]=m,m=m>>>8,S[x+2]=m,m=m>>>8,S[x+1]=m,m=m>>>8,S[x]=m}e.writeUInt32BE=v;function g(S,m){return S[m+0]<<0>>>0|S[m+1]<<8>>>0|S[m+2]<<16>>>0|S[m+3]<<24>>>0}e.readUInt32LE=g;function L(S,m,x){S[x+0]=m&255,m=m>>>8,S[x+1]=m&255,m=m>>>8,S[x+2]=m&255,m=m>>>8,S[x+3]=m&255}e.writeUInt32LE=L;function E(S,m){return S[m]}e.readUInt8=E;function u(S,m,x){S[x]=m}e.writeUInt8=u;function d(S){return O.consumeReadable(S,m=>f.concat(m))}e.readableToBuffer=d;function h(S){return O.toReadable(S)}e.bufferToReadable=h;function y(S){return O.consumeStream(S,m=>f.concat(m))}e.streamToBuffer=y;async function p(S){return S.ended?f.concat(S.buffer):f.concat([...S.buffer,await y(S.stream)])}e.bufferedStreamToBuffer=p;function P(S){return O.toStream(S,m=>f.concat(m))}e.bufferToStream=P;function t(S){return O.transform(S,{data:m=>typeof m=="string"?f.fromString(m):f.wrap(m)},m=>f.concat(m))}e.streamToBufferReadableStream=t;function o(S){return O.newWriteableStream(m=>f.concat(m),S)}e.newWriteableBufferStream=o;function n(S,m){return O.prefixedReadable(S,m,x=>f.concat(x))}e.prefixedBufferReadable=n;function i(S,m){return O.prefixedStream(S,m,x=>f.concat(x))}e.prefixedBufferStream=i;function r(S){let m=0,x=0,X=0;const K=new Uint8Array(Math.floor(S.length/4*3)),ie=Q=>{switch(x){case 3:K[X++]=m|Q,x=0;break;case 2:K[X++]=m|Q>>>2,m=Q<<6,x=3;break;case 1:K[X++]=m|Q>>>4,m=Q<<4,x=2;break;default:m=Q<<2,x=1}};for(let Q=0;Q<S.length;Q++){const ce=S.charCodeAt(Q);if(ce>=65&&ce<=90)ie(ce-65);else if(ce>=97&&ce<=122)ie(ce-97+26);else if(ce>=48&&ce<=57)ie(ce-48+52);else if(ce===43||ce===45)ie(62);else if(ce===47||ce===95)ie(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${S[Q]}`)}}const ue=X;for(;x>0;)ie(0);return f.wrap(K).slice(0,ue)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:S},m=!0,x=!1){const X=x?c:a;let K="";const ie=S.byteLength%3;let ue=0;for(;ue<S.byteLength-ie;ue+=3){const Q=S[ue+0],ce=S[ue+1],ae=S[ue+2];K+=X[Q>>>2],K+=X[(Q<<4|ce>>>4)&63],K+=X[(ce<<2|ae>>>6)&63],K+=X[ae&63]}if(ie===1){const Q=S[ue+0];K+=X[Q>>>2],K+=X[Q<<4&63],m&&(K+="==")}else if(ie===2){const Q=S[ue+0],ce=S[ue+1];K+=X[Q>>>2],K+=X[(Q<<4|ce>>>4)&63],K+=X[ce<<2&63],m&&(K+="=")}return K}e.encodeBase64=C}),define(ne[30],re([0,1,3]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([y,p])=>{h[y]=p&&typeof p=="object"?O(p):p}),h}e.deepClone=O;function R(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const y=h.shift();Object.freeze(y);for(const p in y)if(A.call(y,p)){const P=y[p];typeof P=="object"&&!Object.isFrozen(P)&&!(0,T.isTypedArray)(P)&&h.push(P)}}return d}e.deepFreeze=R;const A=Object.prototype.hasOwnProperty;function N(d,h){return w(d,h,new Set)}e.cloneAndChange=N;function w(d,h,y){if((0,T.isUndefinedOrNull)(d))return d;const p=h(d);if(typeof p<"u")return p;if(Array.isArray(d)){const P=[];for(const t of d)P.push(w(t,h,y));return P}if((0,T.isObject)(d)){if(y.has(d))throw new Error("Cannot clone recursive data-structure");y.add(d);const P={};for(const t in d)A.call(d,t)&&(P[t]=w(d[t],h,y));return y.delete(d),P}return d}function f(d,h,y=!0){return(0,T.isObject)(d)?((0,T.isObject)(h)&&Object.keys(h).forEach(p=>{p in d?y&&((0,T.isObject)(d[p])&&(0,T.isObject)(h[p])?f(d[p],h[p],y):d[p]=h[p]):d[p]=h[p]}),d):h}e.mixin=f;function l(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let y,p;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(y=0;y<d.length;y++)if(!l(d[y],h[y]))return!1}else{const P=[];for(p in d)P.push(p);P.sort();const t=[];for(p in h)t.push(p);if(t.sort(),!l(P,t))return!1;for(y=0;y<P.length;y++)if(!l(d[P[y]],h[P[y]]))return!1}return!0}e.equals=l;function D(d){const h=new Set;return JSON.stringify(d,(y,p)=>{if((0,T.isObject)(p)||Array.isArray(p)){if(h.has(p))return"[Circular]";h.add(p)}return p})}e.safeStringify=D;function I(d,h){const y=Object.create(null);return!d||!h||Object.keys(h).forEach(P=>{const t=d[P],o=h[P];l(t,o)||(y[P]=o)}),y}e.distinct=I;function v(d,h){const y=h.toLowerCase(),p=Object.keys(d).find(P=>P.toLowerCase()===y);return p?d[p]:d[h]}e.getCaseInsensitive=v;function g(d,h){const y=Object.create(null);for(const[p,P]of Object.entries(d))h(p,P)&&(y[p]=P);return y}e.filter=g;function L(d){let h=[],y=Object.getPrototypeOf(d);for(;Object.prototype!==y;)h=h.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return h}e.getAllPropertyNames=L;function E(d){const h=[];for(const y of L(d))typeof d[y]=="function"&&h.push(y);return h}e.getAllMethodNames=E;function u(d,h){const y=P=>function(){const t=Array.prototype.slice.call(arguments,0);return h(P,t)},p={};for(const P of d)p[P]=y(P);return p}e.createProxyObject=u}),define(ne[28],re([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(R){return T.test(R)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(w){for(let f=0;f<w.length;f++)w[f]=Math.floor(Math.random()*256);return w};const A=new Uint8Array(16),N=[];for(let w=0;w<256;w++)N.push(w.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,l="";return l+=N[A[f++]],l+=N[A[f++]],l+=N[A[f++]],l+=N[A[f++]],l+="-",l+=N[A[f++]],l+=N[A[f++]],l+="-",l+=N[A[f++]],l+=N[A[f++]],l+="-",l+=N[A[f++]],l+=N[A[f++]],l+="-",l+=N[A[f++]],l+=N[A[f++]],l+=N[A[f++]],l+=N[A[f++]],l+=N[A[f++]],l+=N[A[f++]],l}}()}),define(ne[73],re([0,1,32]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(N){const w=N.replace(/\-/g,":").toLowerCase();return!O.has(w)}function A(){const N=(0,T.networkInterfaces)();for(const w in N){const f=N[w];if(f){for(const{mac:l}of f)if(R(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ne[74],re([7,4]),function(q,e){return q.create("vs/base/common/date",e)}),define(ne[75],re([0,1,74]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,R=O*60,A=R*24,N=A*7,w=A*30,f=A*365;function l(I,v,g,L){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,T.localize)(0,null,l(new Date().getTime()+E*1e3,!1));if(!L&&E<30)return(0,T.localize)(1,null);let u;return E<O?(u=E,v?u===1?g?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):g?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u):u===1?g?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):g?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):E<R?(u=Math.floor(E/O),v?u===1?g?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):g?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u):u===1?g?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):g?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):E<A?(u=Math.floor(E/R),v?u===1?g?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):g?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u):u===1?g?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):g?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):E<N?(u=Math.floor(E/A),v?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u)):E<w?(u=Math.floor(E/N),v?u===1?g?(0,T.localize)(30,null,u):(0,T.localize)(31,null,u):g?(0,T.localize)(32,null,u):(0,T.localize)(33,null,u):u===1?g?(0,T.localize)(34,null,u):(0,T.localize)(35,null,u):g?(0,T.localize)(36,null,u):(0,T.localize)(37,null,u)):E<f?(u=Math.floor(E/w),v?u===1?g?(0,T.localize)(38,null,u):(0,T.localize)(39,null,u):g?(0,T.localize)(40,null,u):(0,T.localize)(41,null,u):u===1?g?(0,T.localize)(42,null,u):(0,T.localize)(43,null,u):g?(0,T.localize)(44,null,u):(0,T.localize)(45,null,u)):(u=Math.floor(E/f),v?u===1?g?(0,T.localize)(46,null,u):(0,T.localize)(47,null,u):g?(0,T.localize)(48,null,u):(0,T.localize)(49,null,u):u===1?g?(0,T.localize)(50,null,u):(0,T.localize)(51,null,u):g?(0,T.localize)(52,null,u):(0,T.localize)(53,null,u))}e.fromNow=l;function D(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(ne[76],re([7,4]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(ne[33],re([0,1,19,3,76]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(I,v){return v&&(I.stack||I.stacktrace)?R.localize(0,null,w(I),N(I.stack)||N(I.stacktrace)):w(I)}function N(I){return Array.isArray(I)?I.join(`
`):I}function w(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?R.localize(1,null,I.message):I.message||R.localize(2,null)}function f(I=null,v=!1){if(!I)return R.localize(3,null);if(Array.isArray(I)){const g=T.coalesce(I),L=f(g[0],v);return g.length>1?R.localize(4,null,L,g.length):L}if(O.isString(I))return I;if(I.detail){const g=I.detail;if(g.error)return A(g.error,v);if(g.exception)return A(g.exception,v)}return I.stack?A(I,v):I.message?I.message:R.localize(5,null)}e.toErrorMessage=f;function l(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=l;function D(I,v){let g;return typeof I=="string"?g=new Error(I):g=I,g.actions=v,g}e.createErrorWithActions=D}),define(ne[77],re([7,4]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[78],re([0,1,77]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(R){switch(R){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(ne[53],re([0,1,12]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(O||(e.Source=O={}));var R;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(w,...f){const l=f.reduce((v,g)=>(v[g]=!0,v),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(v=>!l[v]).forEach(v=>{for(let g=0;g<D.length;g++)if(v.search(D[g])!==-1){delete w[v];break}})}e.sanitizeProcessEnvironment=A;function N(w){w&&(delete w.DEBUG,T.isMacintosh&&delete w.DYLD_LIBRARY_PATH,T.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(ne[45],re([0,1,29]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(d){return R(d,0)}e.hash=O;function R(d,h){switch(typeof d){case"object":return d===null?A(349,h):Array.isArray(d)?f(d,h):l(d,h);case"string":return w(d,h);case"boolean":return N(d,h);case"number":return A(d,h);case"undefined":return A(937,h);default:return A(617,h)}}e.doHash=R;function A(d,h){return(h<<5)-h+d|0}e.numberHash=A;function N(d,h){return A(d?433:863,h)}function w(d,h){h=A(149417,h);for(let y=0,p=d.length;y<p;y++)h=A(d.charCodeAt(y),h);return h}e.stringHash=w;function f(d,h){return h=A(104579,h),d.reduce((y,p)=>R(p,y),h)}function l(d,h){return h=A(181387,h),Object.keys(d).sort().reduce((y,p)=>(y=w(p,y),R(d[p],y)),h)}class D{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=R(h,this._value),this._value}}e.Hasher=D;var I;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(d,h,y=32){const p=y-h,P=~((1<<p)-1);return(d<<h|(P&d)>>>p)>>>0}function g(d,h=0,y=d.byteLength,p=0){for(let P=0;P<y;P++)d[h+P]=p}function L(d,h,y="0"){for(;d.length<h;)d=y+d;return d}function E(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(y=>y.toString(16).padStart(2,"0")).join(""):L((d>>>0).toString(16),h/4)}e.toHexString=E;class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const y=h.length;if(y===0)return;const p=this._buff;let P=this._buffLen,t=this._leftoverHighSurrogate,o,n;for(t!==0?(o=t,n=-1,t=0):(o=h.charCodeAt(0),n=0);;){let i=o;if(T.isHighSurrogate(o))if(n+1<y){const r=h.charCodeAt(n+1);T.isLowSurrogate(r)?(n++,i=T.computeCodePoint(o,r)):i=65533}else{t=o;break}else T.isLowSurrogate(o)&&(i=65533);if(P=this._push(p,P,i),n++,n<y)o=h.charCodeAt(n);else break}this._buffLen=P,this._leftoverHighSurrogate=t}_push(h,y,p){return p<128?h[y++]=p:p<2048?(h[y++]=192|(p&1984)>>>6,h[y++]=128|(p&63)>>>0):p<65536?(h[y++]=224|(p&61440)>>>12,h[y++]=128|(p&4032)>>>6,h[y++]=128|(p&63)>>>0):(h[y++]=240|(p&1835008)>>>18,h[y++]=128|(p&258048)>>>12,h[y++]=128|(p&4032)>>>6,h[y++]=128|(p&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=u._bigBlock32,y=this._buffDV;for(let c=0;c<64;c+=4)h.setUint32(c,y.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,v(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let p=this._h0,P=this._h1,t=this._h2,o=this._h3,n=this._h4,i,r,a;for(let c=0;c<80;c++)c<20?(i=P&t|~P&o,r=1518500249):c<40?(i=P^t^o,r=1859775393):c<60?(i=P&t|P&o|t&o,r=2400959708):(i=P^t^o,r=3395469782),a=v(p,5)+i+n+r+h.getUint32(c*4,!1)&4294967295,n=o,o=t,t=v(P,30),P=p,p=a;this._h0=this._h0+p&4294967295,this._h1=this._h1+P&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[54],re([0,1,29]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(O||(O={})),function(R){const A="error",N="warning",w="warn",f="info",l="ignore";function D(v){return v?T.equalsIgnoreCase(A,v)?R.Error:T.equalsIgnoreCase(N,v)||T.equalsIgnoreCase(w,v)?R.Warning:T.equalsIgnoreCase(f,v)?R.Info:R.Ignore:R.Ignore}R.fromValue=D;function I(v){switch(v){case R.Error:return A;case R.Warning:return N;case R.Info:return f;default:return l}}R.toString=I}(O||(O={})),e.default=O}),define(ne[79],re([0,1,11]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(l){const D=l;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=O;function R(l){const D=[];let I;try{const v=JSON.parse(l.arguments),g=v[v.length-1];g&&g.__$stack&&(v.pop(),I=g.__$stack),D.push(...v)}catch{D.push("Unable to log remote console arguments",l.arguments)}return{args:D,stack:I}}e.parse=R;function A(l){if(typeof l!="string")return A(R(l).stack);const D=l;if(D){const I=N(D),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:T.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=A;function N(l){if(!l)return l;const D=l.indexOf(`
`);return D===-1?l:l.substring(0,D)}function w(l,D){const{args:I,stack:v}=R(l),g=typeof I[0]=="string"&&I.length===1;let L=N(v);L&&(L=`(${L.trim()})`);let E=[];if(typeof I[0]=="string"?L&&g?E=[`%c[${D}] %c${I[0]} %c${L}`,f("blue"),f(""),f("grey")]:E=[`%c[${D}] %c${I[0]}`,f("blue"),f(""),...I.slice(1)]:E=[`%c[${D}]%`,f("blue"),...I],L&&!g&&E.push(L),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,E)}e.log=w;function f(l){return`color: ${l}`}}),define(ne[46],re([0,1,14,29,11]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(l){return JSON.stringify(l,w)}e.stringify=A;function N(l){let D=JSON.parse(l);return D=f(D),D}e.parse=N;function w(l,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,O.regExpFlags)(D)}:D}function f(l,D=0){if(!l||D>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return R.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof T.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let I=0;I<l.length;++I)l[I]=f(l[I],D+1);else for(const I in l)Object.hasOwnProperty.call(l,I)&&(l[I]=f(l[I],D+1))}return l}e.revive=f}),define(ne[80],re([0,1,32,55,28,73]),function(q,e,T,O,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(l){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(l)}value(){if(this._value===void 0){let l=0,D=0;const I=(0,T.networkInterfaces)();for(const v in I){const g=I[v];if(g)for(const{mac:L,internal:E}of g)E||(D+=1,this._isVirtualMachineMacAddress(L.toUpperCase())&&(l+=1))}this._value=D>0?l/D:0}return this._value}};let N;async function w(l){return N||(N=(async()=>await f(l)||R.generateUuid())()),N}e.getMachineId=w;async function f(l){try{const D=await new Promise((v,g)=>{q(["crypto"],v,g)}),I=(0,A.getMac)();return D.createHash("sha256").update(I,"utf8").digest("hex")}catch(D){l(D);return}}}),define(ne[81],re([0,1,32,15,22]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var f;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class I{constructor(P,t,o){this.exePath=P,this.displayName=t,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:p=!1,findPreview:P=!1}={}){const t=v({useAlternateBitness:p});if(!t)return null;const o=O.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let n=-1,i=null;for(const c of await R.Promises.readdir(o)){let C=-1;if(P){const m=c.indexOf("-");if(m<0)continue;const x=c.substring(0,m);if(!A.test(x)||c.substring(m+1)!=="preview")continue;C=parseInt(x,10)}else{if(!A.test(c))continue;C=parseInt(c,10)}if(C<=n)continue;const S=O.join(o,c,"pwsh.exe");await R.SymlinkSupport.existsFile(S)&&(i=S,n=C)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",a=P?" Preview":"";return new I(i,`PowerShell${a}${r}`,!0)}async function L({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const P=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=p?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(P))if(t.test(n)){const i=O.join(P,n,"pwsh.exe");return new I(i,o)}return null}function E(){const p=O.join(T.homedir(),".dotnet","tools","pwsh.exe");return new I(p,".NET Core PowerShell Global Tool")}function u(){const p=O.join(process.env.windir,l===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(p,"Windows PowerShell",!0)}async function*d(){let p=await g();p&&(yield p),p=await g({useAlternateBitness:!0}),p&&(yield p),p=await L(),p&&(yield p),p=E(),p&&(yield p),p=await g({findPreview:!0}),p&&(yield p),p=await L({findPreview:!0}),p&&(yield p),p=await g({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=u(),p&&(yield p)}async function*h(){for await(const p of d())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=h;async function y(){for await(const p of h())return p;return null}e.getFirstAvailablePowerShellInstallation=y}),define(ne[56],re([0,1,15,12,34,53,3,22]),function(q,e,T,O,R,A,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function f(I=R.env){return I.comspec||"cmd.exe"}e.getWindowsShell=f;function l(I){let v=[],g=!1;const L=function(E){if(g){v.push(E);return}(!I.send(E,d=>{if(d&&console.error(d),g=!1,v.length>0){const h=v.slice(0);v=[],h.forEach(y=>L(y))}})||O.isWindows)&&(g=!0)};return{send:L}}e.createQueuedSender=l;var D;(function(I){async function v(g,L,E){if(T.isAbsolute(g))return g;if(L===void 0&&(L=R.cwd()),T.dirname(g)!=="."||(E===void 0&&N.isString(R.env.PATH)&&(E=R.env.PATH.split(T.delimiter)),E===void 0||E.length===0))return T.join(L,g);async function d(h){if(await w.Promises.exists(h)){let y;try{y=await w.Promises.stat(h)}catch(p){p.message.startsWith("EACCES")&&(y=await w.Promises.lstat(h))}return y?!y.isDirectory():!1}return!1}for(const h of E){let y;if(T.isAbsolute(h)?y=T.join(h,g):y=T.join(L,h,g),await d(y))return y;let p=y+".com";if(await d(p)||(p=y+".exe",await d(p)))return p}return T.join(L,g)}I.findExecutable=v})(D||(e.win32=D={}))}),define(ne[82],re([0,1,32,12,81,56]),function(q,e,T,O,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(I,v){return I===1?O.isWindows?D():A.getWindowsShell(v):f(I,v)}e.getSystemShell=N;let w=null;function f(I,v){if(O.isLinux&&I===2||O.isMacintosh&&I===3)return"/bin/bash";if(!w){let g;if(O.isWindows)g="/bin/bash";else{if(g=v.SHELL,!g)try{g=(0,T.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}w=g}return w}let l=null;async function D(){return l||(l=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ve=this&&this.__decorate||function(q,e,T,O){var R=arguments.length,A=R<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,T):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(q,e,T,O);else for(var w=q.length-1;w>=0;w--)(N=q[w])&&(A=(R<3?N(A):R>3?N(e,T,A):N(e,T))||A);return R>3&&A&&Object.defineProperty(e,T,A),A};define(ne[57],re([0,1,19,8,14,23,51,9,5,2,46,29,3]),function(q,e,T,O,R,A,N,w,f,l,D,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(g||(g={}));function L(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(E||(E={}));function u(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(d||(d={}));function h(V){let M=0;for(let $=0;;$+=7){const G=V.read(1);if(M|=(G.buffer[0]&127)<<$,!(G.buffer[0]&128))return M}}const y=n(0);function p(V,M){if(M===0){V.write(y);return}let $=0;for(let Y=M;Y!==0;Y=Y>>>7)$++;const G=R.VSBuffer.alloc($);for(let Y=0;M!==0;Y++)G.buffer[Y]=M&127,M=M>>>7,M>0&&(G.buffer[Y]|=128);V.write(G)}class P{constructor(M){this.buffer=M,this.pos=0}read(M){const $=this.buffer.slice(this.pos,this.pos+M);return this.pos+=$.byteLength,$}}e.BufferReader=P;class t{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}e.BufferWriter=t;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const M=R.VSBuffer.alloc(1);return M.writeUInt8(V,0),M}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},r=typeof Buffer<"u";function a(V,M){if(typeof M>"u")V.write(i.Undefined);else if(typeof M=="string"){const $=R.VSBuffer.fromString(M);V.write(i.String),p(V,$.byteLength),V.write($)}else if(r&&Buffer.isBuffer(M)){const $=R.VSBuffer.wrap(M);V.write(i.Buffer),p(V,$.byteLength),V.write($)}else if(M instanceof R.VSBuffer)V.write(i.VSBuffer),p(V,M.byteLength),V.write(M);else if(Array.isArray(M)){V.write(i.Array),p(V,M.length);for(const $ of M)a(V,$)}else if(typeof M=="number"&&(M|0)===M)V.write(i.Uint),p(V,M);else{const $=R.VSBuffer.fromString(JSON.stringify(M));V.write(i.Object),p(V,$.byteLength),V.write($)}}e.serialize=a;function c(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(h(V)).toString();case o.Buffer:return V.read(h(V)).buffer;case o.VSBuffer:return V.read(h(V));case o.Array:{const $=h(V),G=[];for(let Y=0;Y<$;Y++)G.push(c(V));return G}case o.Object:return JSON.parse(V.read(h(V)).toString());case o.Int:return h(V)}}e.deserialize=c;class C{constructor(M,$,G=null,Y=1e3){this.protocol=M,this.ctx=$,this.logger=G,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(M,$){this.channels.set(M,$),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const $=this.send([M.type]);this.logger?.logOutgoing($,0,1,u(M.type));return}case 201:case 202:case 204:case 203:{const $=this.send([M.type,M.id],M.data);this.logger?.logOutgoing($,M.id,1,u(M.type),M.data);return}}}send(M,$=void 0){const G=new t;return a(G,M),a(G,$),this.sendBuffer(G.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const $=new P(M),G=c($),Y=c($),F=G[0];switch(F){case 100:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(F)}: ${G[2]}.${G[3]}`,Y),this.onPromise({type:F,id:G[1],channelName:G[2],name:G[3],arg:Y});case 102:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(F)}: ${G[2]}.${G[3]}`,Y),this.onEventListen({type:F,id:G[1],channelName:G[2],name:G[3],arg:Y});case 101:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(F)}`),this.disposeActiveRequest({type:F,id:G[1]});case 103:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(F)}`),this.disposeActiveRequest({type:F,id:G[1]})}}onPromise(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const G=new A.CancellationTokenSource;let Y;try{Y=$.call(this.ctx,M.name,M.arg,G.token)}catch(k){Y=Promise.reject(k)}const F=M.id;Y.then(k=>{this.sendResponse({id:F,data:k,type:201}),this.activeRequests.delete(M.id)},k=>{k instanceof Error?this.sendResponse({id:F,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:F,data:k,type:203}),this.activeRequests.delete(M.id)});const U=(0,l.toDisposable)(()=>G.cancel());this.activeRequests.set(M.id,U)}onEventListen(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const G=M.id,F=$.listen(this.ctx,M.name,M.arg)(U=>this.sendResponse({id:G,data:U,type:204}));this.activeRequests.set(M.id,F)}disposeActiveRequest(M){const $=this.activeRequests.get(M.id);$&&($.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let $=this.pendingRequests.get(M.channelName);$||($=[],this.pendingRequests.set(M.channelName,$));const G=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:M,timeoutTimer:G})}flushPendingRequests(M){const $=this.pendingRequests.get(M);if($){for(const G of $)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var S;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class m{constructor(M,$=null){this.protocol=M,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=$}getChannel(M){const $=this;return{call(G,Y,F){return $.isDisposed?Promise.reject(new w.CancellationError):$.requestPromise(M,G,Y,F)},listen(G,Y){return $.isDisposed?f.Event.None:$.requestEvent(M,G,Y)}}}requestPromise(M,$,G,Y=A.CancellationToken.None){const F=this.lastRequestId++,k={id:F,type:100,channelName:M,name:$,arg:G};if(Y.isCancellationRequested)return Promise.reject(new w.CancellationError);let s;return new Promise((_,W)=>{if(Y.isCancellationRequested)return W(new w.CancellationError);const H=()=>{const pe=fe=>{switch(fe.type){case 201:this.handlers.delete(F),_(fe.data);break;case 202:{this.handlers.delete(F);const ge=new Error(fe.data.message);ge.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ge.name=fe.data.name,W(ge);break}case 203:this.handlers.delete(F),W(fe.data);break}};this.handlers.set(F,pe),this.sendRequest(k)};let Z=null;this.state===d.Idle?H():(Z=(0,O.createCancelablePromise)(pe=>this.whenInitialized()),Z.then(()=>{Z=null,H()}));const le=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:F,type:101}),W(new w.CancellationError)},de=Y.onCancellationRequested(le);s=(0,l.combinedDisposable)((0,l.toDisposable)(le),de),this.activeRequests.add(s)}).finally(()=>{this.activeRequests.delete(s)})}requestEvent(M,$,G){const Y=this.lastRequestId++,U={id:Y,type:102,channelName:M,name:$,arg:G};let k=null;const s=new f.Emitter({onWillAddFirstListener:()=>{k=(0,O.createCancelablePromise)(_=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(s),this.sendRequest(U)})},onDidRemoveLastListener:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(s),this.sendRequest({id:Y,type:103}))}}),b=_=>s.fire(_.data);return this.handlers.set(Y,b),s.event}sendRequest(M){switch(M.type){case 100:case 102:{const $=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing($,M.id,0,`${L(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.send([M.type,M.id]);this.logger?.logOutgoing($,M.id,0,L(M.type));return}}}send(M,$=void 0){const G=new t;return a(G,M),a(G,$),this.sendBuffer(G.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const $=new P(M),G=c($),Y=c($),F=G[0];switch(F){case 200:return this.logger?.logIncoming(M.byteLength,0,0,u(F)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(M.byteLength,G[1],0,u(F),Y),this.onResponse({type:G[0],id:G[1],data:Y})}}onResponse(M){if(M.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=m,ve([N.memoize],m.prototype,"onDidInitializePromise",null);class x{get connections(){const M=[];return this._connections.forEach($=>M.push($)),M}constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:$,onDidClientDisconnect:G})=>{f.Event.once($.onMessage)(F=>{const U=new P(F),k=c(U),s=new C($,k),b=new m($);this.channels.forEach((W,H)=>s.registerChannel(H,W));const _={channelServer:s,channelClient:b,ctx:k};this._connections.add(_),this._onDidAddConnection.fire(_),G(()=>{s.dispose(),b.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}getChannel(M,$){const G=this;return{call(Y,F,U){let k;if((0,v.isFunction)($)){const b=(0,T.getRandomElement)(G.connections.filter($));k=b?Promise.resolve(b):f.Event.toPromise(f.Event.filter(G.onDidAddConnection,$))}else k=$.routeCall(G,Y,F);const s=k.then(b=>b.channelClient.getChannel(M));return K(s).call(Y,F,U)},listen(Y,F){if((0,v.isFunction)($))return G.getMulticastEvent(M,$,Y,F);const U=$.routeEvent(G,Y,F).then(k=>k.channelClient.getChannel(M));return K(U).listen(Y,F)}}}getMulticastEvent(M,$,G,Y){const F=this;let U=new l.DisposableStore;const k=new f.Emitter({onWillAddFirstListener:()=>{U=new l.DisposableStore;const s=new f.EventMultiplexer,b=new Map,_=H=>{const le=H.channelClient.getChannel(M).listen(G,Y),de=s.add(le);b.set(H,de)},W=H=>{const Z=b.get(H);Z&&(Z.dispose(),b.delete(H))};F.connections.filter($).forEach(_),f.Event.filter(F.onDidAddConnection,$)(_,void 0,U),F.onDidRemoveConnection(W,void 0,U),s.event(k.fire,k,U),U.add(s)},onDidRemoveLastListener:()=>{U.dispose()}});return k.event}registerChannel(M,$){this.channels.set(M,$),this._connections.forEach(G=>{G.channelServer.registerChannel(M,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=x;class X{constructor(M,$,G=null){const Y=new t;a(Y,$),M.send(Y.buffer),this.channelClient=new m(M,G),this.channelServer=new C(M,$,G)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,$){this.channelServer.registerChannel(M,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=X;function K(V){return{call(M,$,G){return V.then(Y=>Y.call(M,$,G))},listen(M,$){const G=new f.Relay;return V.then(Y=>G.input=Y.listen(M,$)),G.event}}}e.getDelayedChannel=K;function ie(V){let M=!1;return{call($,G,Y){return M?V.call($,G,Y):(0,O.timeout)(0).then(()=>M=!0).then(()=>V.call($,G,Y))},listen($,G){if(M)return V.listen($,G);const Y=new f.Relay;return(0,O.timeout)(0).then(()=>M=!0).then(()=>Y.input=V.listen($,G)),Y.event}}}e.getNextTickChannel=ie;class ue{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const $ of M.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await f.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ue;var Q;(function(V){function M(F,U){const k=F,s=U&&U.disableMarshalling,b=new Map;for(const _ in k)G(_)&&b.set(_,f.Event.buffer(k[_],!0));return new class{listen(_,W,H){const Z=b.get(W);if(Z)return Z;if(Y(W)){const le=k[W];if(typeof le=="function")return le.call(k,H)}throw new Error(`Event not found: ${W}`)}call(_,W,H){const Z=k[W];if(typeof Z=="function"){if(!s&&Array.isArray(H))for(let le=0;le<H.length;le++)H[le]=(0,D.revive)(H[le]);return Z.apply(k,H)}throw new Error(`Method not found: ${W}`)}}}V.fromService=M;function $(F,U){const k=U&&U.disableMarshalling;return new Proxy({},{get(s,b){if(typeof b=="string")return U?.properties?.has(b)?U.properties.get(b):Y(b)?function(_){return F.listen(b,_)}:G(b)?F.listen(b):async function(..._){let W;U&&!(0,v.isUndefinedOrNull)(U.context)?W=[U.context,..._]:W=_;const H=await F.call(b,W);return k?H:(0,D.revive)(H)};throw new Error(`Property not found: ${String(b)}`)}})}V.toService=$;function G(F){return F[0]==="o"&&F[1]==="n"&&I.isUpperAsciiLetter(F.charCodeAt(2))}function Y(F){return/^onDynamic/.test(F)&&I.isUpperAsciiLetter(F.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const M=V.toString();if(M!=="[object Object]")return M}return V}function se(V){return Array.isArray(V)?V.map(ae):ae(V)}function j(V,M,$,G,Y,F,U){U=se(U);const k=ce[Y],s=k[G%k.length];let b=[`%c[${V}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${s}`];/\($/.test(F)?(b=b.concat(U),b.push(")")):b.push(U),console.log.apply(console,b)}class B{constructor(M,$){this._outgoingPrefix=M,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,$,G,Y,F){this._totalOutgoing+=M,j(this._outgoingPrefix,this._totalOutgoing,M,$,G,Y,F)}logIncoming(M,$,G,Y,F){this._totalIncoming+=M,j(this._incomingPrefix,this._totalIncoming,M,$,G,Y,F)}}e.IPCLogger=B}),define(ne[83],re([0,1,58,8,14,23,79,9,5,2,30,56,53,57]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class L extends g.ChannelServer{constructor(d){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>R.VSBuffer.wrap(Buffer.from(h,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=L;class E{constructor(d,h){this.modulePath=d,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new O.Delayer(y),this.child=null,this._client=null}getChannel(d){const h=this;return{call(y,p,P){return h.requestPromise(d,y,p,P)},listen(y,p){return h.requestEvent(d,y,p)}}}requestPromise(d,h,y,p=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const P=this.getCachedChannel(d),t=(0,O.createCancelablePromise)(i=>P.call(h,y,i)),o=p.onCancellationRequested(()=>t.cancel()),n=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(d,h,y){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let p;const P=new f.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(d).listen(h,y)(P.fire,P),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return P.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(h.env),this.child=(0,T.fork)(this.modulePath,d,h);const y=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,N.isRemoteConsoleLog)(r)){(0,N.log)(r,`IPC Library: ${this.options.serverName}`);return}y.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const P=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&P.send(r.buffer.toString("base64")),o=y.event,n={send:t,onMessage:o};this._client=new g.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(c=>(0,l.dispose)(c)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(d){let h=this.channels.get(d);return h||(h=this.client.getChannel(d),this.channels.set(d,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(ne[84],re([0,1,8,5,2,46,3]),function(q,e,T,O,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var w;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function f(v){const g=v;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=f;var l;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(l||(e.StorageState=l={}));class D extends R.Disposable{constructor(g,L=Object.create(null)){super(),this.database=g,this.options=L,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((L,E)=>this.accept(E,L)),g.deleted?.forEach(L=>this.accept(L,void 0))}accept(g,L){if(this.state===l.Closed)return;let E=!1;(0,N.isUndefinedOrNull)(L)?E=this.cache.delete(g):this.cache.get(g)!==L&&(this.cache.set(g,L),E=!0),E&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,L){const E=this.cache.get(g);return(0,N.isUndefinedOrNull)(E)?L:E}getBoolean(g,L){const E=this.get(g);return(0,N.isUndefinedOrNull)(E)?L:E==="true"}getNumber(g,L){const E=this.get(g);return(0,N.isUndefinedOrNull)(E)?L:parseInt(E,10)}getObject(g,L){const E=this.get(g);return(0,N.isUndefinedOrNull)(E)?L:(0,A.parse)(E)}async set(g,L){if(this.state===l.Closed)return;if((0,N.isUndefinedOrNull)(L))return this.delete(g);const E=(0,N.isObject)(L)||Array.isArray(L)?(0,A.stringify)(L):String(L);if(this.cache.get(g)!==E)return this.cache.set(g,E),this.pendingInserts.set(g,E),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}isInMemory(){return this.options.hint===w.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=D,D.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert?.forEach((L,E)=>this.items.set(E,L)),g.delete?.forEach(L=>this.items.delete(L))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[85],re([7,4]),function(q,e){return q.create("vs/base/node/zip",e)}),define(ne[86],re([7,4]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[87],re([7,4]),function(q,e){return q.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[88],re([7,4]),function(q,e){return q.create("vs/platform/contextkey/common/scanner",e)}),define(ne[89],re([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[90],re([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[91],re([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[92],re([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[93],re([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[94],re([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[95],re([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[96],re([7,4]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[97],re([7,4]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(ne[98],re([7,4]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(ne[99],re([7,4]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[100],re([7,4]),function(q,e){return q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[101],re([7,4]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(ne[102],re([7,4]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[103],re([7,4]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[104],re([7,4]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[105],re([7,4]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(ne[106],re([0,1,9,88]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var R;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...l){switch(l.length){case 1:return(0,O.localize)(0,null,l[0]);case 2:return(0,O.localize)(1,null,l[0],l[1]);case 3:return(0,O.localize)(2,null,l[0],l[1],l[2]);default:return}}const N=(0,O.localize)(3,null),w=(0,O.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,T.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(D){return this._input=D,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(D){return this._isAtEnd()||this._input.charCodeAt(this._current)!==D?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(D){this._tokens.push({type:D,offset:this._start})}_error(D){const I=this._start,v=this._input.substring(this._start,this._current),g={type:19,offset:this._start,lexeme:v};this._errors.push({offset:I,lexeme:v,additionalInfo:D}),this._tokens.push(g)}_string(){this.stringRe.lastIndex=this._start;const D=this.stringRe.exec(this._input);if(D){this._current=this._start+D[0].length;const I=this._input.substring(this._start,this._current),v=f._keywords.get(I);v?this._addToken(v):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(N);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let D=this._current,I=!1,v=!1;for(;;){if(D>=this._input.length){this._current=D,this._error(w);return}const L=this._input.charCodeAt(D);if(I)I=!1;else if(L===47&&!v){D++;break}else L===91?v=!0:L===92?I=!0:L===93&&(v=!1);D++}for(;D<this._input.length&&f._regexFlags.has(this._input.charCodeAt(D));)D++;this._current=D;const g=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:g,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f,f._regexFlags=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),f._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ne[107],re([0,1,75,51,16,15,34,17,11]),function(q,e,T,O,R,A,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.dirname)(R.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",g)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(f.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=N.env.VSCODE_PORTABLE;return g?f.URI.file((0,A.join)(g,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.resolve)(g):(0,A.normalize)((0,A.join)(R.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?f.URI.file((0,A.resolve)(g)):f.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.resolve)(g);const L=N.env.VSCODE_EXTENSIONS;if(L)return L;const E=N.env.VSCODE_PORTABLE;return E?(0,A.join)(E,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(L=>/^[^:/?#]+?:\/\//.test(L)?f.URI.parse(L):f.URI.file((0,A.normalize)(L)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,A.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const L of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(L);E&&E[1]&&E[2]&&g.push([E[1],E[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=N.env.VSCODE_PORTABLE;return g?f.URI.file((0,A.join)(g,"policy.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this._args}constructor(g,L,E){this._args=g,this.paths=L,this.productService=E,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ve([O.memoize],l.prototype,"appRoot",null),ve([O.memoize],l.prototype,"userHome",null),ve([O.memoize],l.prototype,"userDataPath",null),ve([O.memoize],l.prototype,"appSettingsHome",null),ve([O.memoize],l.prototype,"tmpDir",null),ve([O.memoize],l.prototype,"cacheHome",null),ve([O.memoize],l.prototype,"stateResource",null),ve([O.memoize],l.prototype,"userRoamingDataHome",null),ve([O.memoize],l.prototype,"userDataSyncHome",null),ve([O.memoize],l.prototype,"sync",null),ve([O.memoize],l.prototype,"machineSettingsResource",null),ve([O.memoize],l.prototype,"workspaceStorageHome",null),ve([O.memoize],l.prototype,"localHistoryHome",null),ve([O.memoize],l.prototype,"keyboardLayoutResource",null),ve([O.memoize],l.prototype,"argvResource",null),ve([O.memoize],l.prototype,"isExtensionDevelopment",null),ve([O.memoize],l.prototype,"untitledWorkspacesHome",null),ve([O.memoize],l.prototype,"builtinExtensionsPath",null),ve([O.memoize],l.prototype,"extensionsPath",null),ve([O.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ve([O.memoize],l.prototype,"extensionDevelopmentKind",null),ve([O.memoize],l.prototype,"extensionTestsLocationURI",null),ve([O.memoize],l.prototype,"debugExtensionHost",null),ve([O.memoize],l.prototype,"logLevel",null),ve([O.memoize],l.prototype,"extensionLogLevel",null),ve([O.memoize],l.prototype,"serviceMachineIdResource",null),ve([O.memoize],l.prototype,"disableTelemetry",null),ve([O.memoize],l.prototype,"disableWorkspaceTrust",null),ve([O.memoize],l.prototype,"policyFile",null);function D(v,g){return I(v["inspect-extensions"],v["inspect-brk-extensions"],5870,g,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=D;function I(v,g,L,E,u,d){const y=Number(g||v)||(E?null:L),p=y?!!g:!1;let P;if(d)try{P=JSON.parse(d)}catch{}return{port:y,break:p,debugId:u,env:P}}e.parseDebugParams=I}),function(){"use strict";function q(e,T,O){function R(N,w){const f=A(N,w),l=[f];return e.isAbsolute(f)||l.unshift(O),e.resolve(...l)}function A(N,w){process.env.VSCODE_DEV&&(w="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,w);const D=N["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(I,"AppData","Roaming")}break;case"darwin":l=e.join(T.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,w)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[108],re([162,32,34]),function(e,T,O){return q(e,T,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=q(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[109],re([0,1,32,107,108]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(l,D){super(l,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,R.getUserDataPath)(l,D.nameShort)},D)}}e.NativeEnvironmentService=A;function N(f,l){return(0,O.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.parsePtyHostDebugPort=N;function w(f,l){return(0,O.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.parseSharedProcessDebugPort=w}),define(ne[110],re([0,1,3,92]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(N,w,f){try{A(N,w,f)}catch(l){console.error(l?.message??l)}return N}e.localizeManifest=R;function A(N,w,f){const l=(D,I,v)=>{const g=D[I];if((0,T.isString)(g)){const L=g,E=L.length;if(E>1&&L[0]==="%"&&L[E-1]==="%"){const u=L.substr(1,E-2);let d=w[u];d===void 0&&f&&(d=f[u]);const h=typeof d=="string"?d:d?.message,y=f?.[u],p=typeof y=="string"?y:y?.message;if(!h){p||console.warn(`[${N.name}]: ${(0,O.localize)(0,null,u)}`);return}if(v&&(I==="title"||I==="category")&&p&&p!==h){const P={value:h,original:p};D[I]=P}else D[I]=h}}else if((0,T.isObject)(g))for(const L in g)g.hasOwnProperty(L)&&(L==="commands"?l(g,L,!0):l(g,L,v));else if(Array.isArray(g))for(let L=0;L<g.length;L++)l(g,L,v)};for(const D in N)N.hasOwnProperty(D)&&l(N,D)}}),define(ne[47],re([0,1,17,54,96,41]),function(q,e,T,O,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function f(d){return d=d.trim(),d==="*"||N.test(d)}e.isValidVersionStr=f;function l(d){if(!f(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(N);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=l;function D(d){if(!d)return null;const h=d.majorBase,y=d.majorMustEqual,p=d.minorBase;let P=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(h===0||(P=!1),o=!1);let n=0;if(d.preRelease){const i=w.exec(d.preRelease);if(i){const[,r,a,c]=i;n=Date.UTC(Number(r),Number(a)-1,Number(c))}}return{majorBase:h,majorMustEqual:y,minorBase:p,minorMustEqual:P,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:n}}e.normalizeVersion=D;function I(d,h,y){let p;typeof d=="string"?p=D(l(d)):p=d;let P;h instanceof Date?P=h.getTime():typeof h=="string"&&(P=new Date(h).getTime());let t;if(typeof y=="string"?t=D(l(y)):t=y,!p||!t)return!1;const o=p.majorBase,n=p.minorBase,i=p.patchBase;let r=t.majorBase,a=t.minorBase,c=t.patchBase;const C=t.notBefore;let S=t.majorMustEqual,m=t.minorMustEqual,x=t.patchMustEqual;return t.isMinimum?o>r?!0:o<r?!1:n>a?!0:n<a||P&&P<C?!1:i>=c:(o===1&&r===0&&(!S||!m||!x)&&(r=1,a=0,c=0,S=!0,m=!1,x=!1),o<r?!1:o>r?!S:n<a?!1:n>a?!m:i<c?!1:i>c?!x:!(P&&P<C))}e.isValidVersion=I;function v(d,h,y,p,P){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([O.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([O.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([O.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([O.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([O.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!u(p.extensionDependencies))return t.push([O.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!u(p.activationEvents))return t.push([O.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([O.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([O.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([O.default.Error,R.localize(9,null,"main")]),t;{const i=(0,T.joinPath)(y,p.main);(0,T.isEqualOrParent)(i,y)||t.push([O.default.Warning,R.localize(10,null,i.path,y.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([O.default.Error,R.localize(11,null,"browser")]),t;{const i=(0,T.joinPath)(y,p.browser);(0,T.isEqualOrParent)(i,y)||t.push([O.default.Warning,R.localize(12,null,i.path,y.path)])}}if(!A.valid(p.version))return t.push([O.default.Error,R.localize(13,null)]),t;const o=[];if(!g(d,h,p,P,o))for(const i of o)t.push([O.default.Error,i]);return t}e.validateExtensionManifest=v;function g(d,h,y,p,P){return p||typeof y.main>"u"&&typeof y.browser>"u"?!0:E(d,h,y.engines.vscode,P)}e.isValidExtensionVersion=g;function L(d,h,y){return d==="*"||E(h,y,d)}e.isEngineValid=L;function E(d,h,y,p=[]){const P=D(l(y));if(!P)return p.push(R.localize(14,null,y)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return p.push(R.localize(15,null,y)),!1}else if(!P.majorMustEqual)return p.push(R.localize(16,null,y)),!1;return I(d,h,P)?!0:(p.push(R.localize(17,null,d,y)),!1)}function u(d){if(!Array.isArray(d))return!1;for(let h=0,y=d.length;h<y;h++)if(typeof d[h]!="string")return!1;return!0}}),define(ne[111],re([0,1,14,28]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(A,N,w){let f=w&&w.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const D=(await N.readFile(A.serviceMachineIdResource)).value.toString();f=(0,O.isUUID)(D)?D:null}catch{f=null}if(!f){f=(0,O.generateUuid)();try{await N.writeFile(A.serviceMachineIdResource,T.VSBuffer.fromString(f))}catch{}}return w?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=R}),define(ne[48],re([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(R,A=[],N=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(ne[112],re([0,1,48]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var R;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(w,f,l){f instanceof T.SyncDescriptor||(f=new T.SyncDescriptor(f,[],!!l)),O.push([w,f])}e.registerSingleton=A;function N(){return O}e.getSingletonServiceDescriptors=N}),define(ne[113],re([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const N of this._nodes.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const w=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(N);w.outgoing.set(f.key,f),f.incoming.set(w.key,w)}removeNode(A){const N=this._hashFn(A);this._nodes.delete(N);for(const w of this._nodes.values())w.outgoing.delete(N),w.incoming.delete(N)}lookupOrInsertNode(A){const N=this._hashFn(A);let w=this._nodes.get(N);return w||(w=new T(N,A),this._nodes.set(N,w)),w}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[N,w]of this._nodes)A.push(`${N}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this._nodes){const w=new Set([A]),f=this._findCycle(N,w);if(f)return f}}_findCycle(A,N){for(const[w,f]of A.outgoing){if(N.has(w))return[...N,w].join(" -> ");N.add(w);const l=this._findCycle(f,N);if(l)return l;N.delete(w)}}}e.Graph=O}),define(ne[24],re([0,1,3,11,10]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof O.URI)}e.isConfigurationOverrides=A;function N(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=N;var w;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function f(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function l(u,d){const h=Object.create(null);for(const y in u)D(h,y,u[y],d);return h}e.toValuesTree=l;function D(u,d,h,y){const p=d.split("."),P=p.pop();let t=u;for(let o=0;o<p.length;o++){const n=p[o];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:y(`Ignoring ${d} as ${p.slice(0,o+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[P]=h}catch{y(`Ignoring ${d} as ${p.join(".")} is ${JSON.stringify(t)}`)}else y(`Ignoring ${d} as ${p.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=D;function I(u,d){const h=d.split(".");v(u,h)}e.removeFromValueTree=I;function v(u,d){const h=d.shift();if(d.length===0){delete u[h];return}if(Object.keys(u).indexOf(h)!==-1){const y=u[h];typeof y=="object"&&!Array.isArray(y)&&(v(y,d),Object.keys(y).length===0&&delete u[h])}}function g(u,d,h){function y(t,o){let n=t;for(const i of o){if(typeof n!="object"||n===null)return;n=n[i]}return n}const p=d.split("."),P=y(u,p);return typeof P>"u"?h:P}e.getConfigurationValue=g;function L(u,d,h){Object.keys(d).forEach(y=>{y!=="__proto__"&&(y in u?T.isObject(u[y])&&T.isObject(d[y])?L(u[y],d[y],h):h&&(u[y]=d[y]):u[y]=d[y])})}e.merge=L;function E(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(ne[114],re([0,1,12,29,106,10,87,9]),function(q,e,T,O,R,A,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",T.isMacintosh),f.set("isLinux",T.isLinux),f.set("isWindows",T.isWindows),f.set("isWeb",T.isWeb),f.set("isMacNative",T.isMacintosh&&!T.isWeb),f.set("isEdge",T.isEdge),f.set("isFirefox",T.isFirefox),f.set("isChrome",T.isChrome),f.set("isSafari",T.isSafari);function l(k,s){if(f.get(k)!==void 0)throw(0,w.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(k,s)}e.setConstant=l;const D=Object.prototype.hasOwnProperty;var I;(function(k){k[k.False=0]="False",k[k.True=1]="True",k[k.Defined=2]="Defined",k[k.Not=3]="Not",k[k.Equals=4]="Equals",k[k.NotEquals=5]="NotEquals",k[k.And=6]="And",k[k.Regex=7]="Regex",k[k.NotRegex=8]="NotRegex",k[k.Or=9]="Or",k[k.In=10]="In",k[k.NotIn=11]="NotIn",k[k.Greater=12]="Greater",k[k.GreaterEquals=13]="GreaterEquals",k[k.Smaller=14]="Smaller",k[k.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const v={regexParsingWithErrorRecovery:!0},g=(0,N.localize)(0,null),L=(0,N.localize)(1,null),E=(0,N.localize)(2,null),u=(0,N.localize)(3,null),d=(0,N.localize)(4,null),h=(0,N.localize)(5,null),y=(0,N.localize)(6,null),p=(0,N.localize)(7,null);class P{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(s=v){this._config=s,this._scanner=new R.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(s){if(s===""){this._parsingErrors.push({message:g,offset:0,lexeme:"",additionalInfo:L});return}this._tokens=this._scanner.reset(s).scan(),this._current=0,this._parsingErrors=[];try{const b=this._expr();if(!this._isAtEnd()){const _=this._peek(),W=_.type===17?h:void 0;throw this._parsingErrors.push({message:d,offset:_.offset,lexeme:R.Scanner.getLexeme(_),additionalInfo:W}),P._parseError}return b}catch(b){if(b!==P._parseError)throw b;return}}_expr(){return this._or()}_or(){const s=[this._and()];for(;this._matchOne(16);){const b=this._and();s.push(b)}return s.length===1?s[0]:t.or(...s)}_and(){const s=[this._term()];for(;this._matchOne(15);){const b=this._term();s.push(b)}return s.length===1?s[0]:t.and(...s)}_term(){if(this._matchOne(2)){const s=this._peek();switch(s.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),a.INSTANCE;case 0:{this._advance();const b=this._expr();return this._consume(1,u),b?.negate()}case 17:return this._advance(),X.create(s.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",s)}}return this._primary()}_primary(){const s=this._peek();switch(s.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const b=this._expr();return this._consume(1,u),b}case 17:{const b=s.lexeme;if(this._advance(),this._matchOne(9)){const W=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),W.type!==10)throw this._errExpectedButGot("REGEX",W);const H=W.lexeme,Z=H.lastIndexOf("/"),le=Z===H.length-1?void 0:this._removeFlagsGY(H.substring(Z+1));let de;try{de=new RegExp(H.substring(1,Z),le)}catch{throw this._errExpectedButGot("REGEX",W)}return ae.create(b,de)}switch(W.type){case 10:case 19:{const H=[W.lexeme];this._advance();let Z=this._peek(),le=0;for(let oe=0;oe<W.lexeme.length;oe++)W.lexeme.charCodeAt(oe)===40?le++:W.lexeme.charCodeAt(oe)===41&&le--;for(;!this._isAtEnd()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let oe=0;oe<Z.lexeme.length;oe++)Z.lexeme.charCodeAt(oe)===40?le++:W.lexeme.charCodeAt(oe)===41&&le--}if(le<0)break;H.push(R.Scanner.getLexeme(Z)),this._advance(),Z=this._peek()}const de=H.join(""),pe=de.lastIndexOf("/"),fe=pe===de.length-1?void 0:this._removeFlagsGY(de.substring(pe+1));let ge;try{ge=new RegExp(de.substring(1,pe),fe)}catch{throw this._errExpectedButGot("REGEX",W)}return t.regex(b,ge)}case 18:{const H=W.lexeme;this._advance();let Z=null;if(!(0,O.isFalsyOrWhitespace)(H)){const le=H.indexOf("/"),de=H.lastIndexOf("/");if(le!==de&&le>=0){const pe=H.slice(le+1,de),fe=H[de+1]==="i"?"i":"";try{Z=new RegExp(pe,fe)}catch{throw this._errExpectedButGot("REGEX",W)}}}if(Z===null)throw this._errExpectedButGot("REGEX",W);return ae.create(b,Z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,E);const W=this._value();return t.notIn(b,W)}switch(this._peek().type){case 3:{this._advance();const W=this._value();if(this._previous().type===18)return t.equals(b,W);switch(W){case"true":return t.has(b);case"false":return t.not(b);default:return t.equals(b,W)}}case 4:{this._advance();const W=this._value();if(this._previous().type===18)return t.notEquals(b,W);switch(W){case"true":return t.not(b);case"false":return t.has(b);default:return t.notEquals(b,W)}}case 5:return this._advance(),Q.create(b,this._value());case 6:return this._advance(),ce.create(b,this._value());case 7:return this._advance(),ie.create(b,this._value());case 8:return this._advance(),ue.create(b,this._value());case 13:return this._advance(),t.in(b,this._value());default:return t.has(b)}}case 20:throw this._parsingErrors.push({message:y,offset:s.offset,lexeme:"",additionalInfo:p}),P._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const s=this._peek();switch(s.type){case 17:case 18:return this._advance(),s.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(s){return s.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(s){return this._check(s)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(s,b){if(this._check(s))return this._advance();throw this._errExpectedButGot(b,this._peek())}_errExpectedButGot(s,b,_){const W=(0,N.localize)(8,null,s,R.Scanner.getLexeme(b)),H=b.offset,Z=R.Scanner.getLexeme(b);return this._parsingErrors.push({message:W,offset:H,lexeme:Z,additionalInfo:_}),P._parseError}_check(s){return this._peek().type===s}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=P,P._parseError=new Error;class t{static false(){return r.INSTANCE}static true(){return a.INSTANCE}static has(s){return c.create(s)}static equals(s,b){return C.create(s,b)}static notEquals(s,b){return x.create(s,b)}static regex(s,b){return ae.create(s,b)}static in(s,b){return S.create(s,b)}static notIn(s,b){return m.create(s,b)}static not(s){return X.create(s)}static and(...s){return B.create(s,null,!0)}static or(...s){return V.create(s,null,!0)}static greater(s,b){return ie.create(s,b)}static greaterEquals(s,b){return ue.create(s,b)}static smaller(s,b){return Q.create(s,b)}static smallerEquals(s,b){return ce.create(s,b)}static deserialize(s){return s==null?void 0:this._parser.parse(s)}}e.ContextKeyExpr=t,t._parser=new P({regexParsingWithErrorRecovery:!1});function o(k){const s=new P({regexParsingWithErrorRecovery:!1});return k.map(b=>(s.parse(b),s.lexingErrors.length>0?s.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,N.localize)(9,null,_.additionalInfo):(0,N.localize)(10,null),offset:_.offset,length:_.lexeme.length})):s.parsingErrors.length>0?s.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}e.validateWhenClauses=o;function n(k,s){const b=k?k.substituteConstants():void 0,_=s?s.substituteConstants():void 0;return!b&&!_?!0:!b||!_?!1:b.equals(_)}e.expressionsAreEqualWithConstantSubstitution=n;function i(k,s){return k.cmp(s)}class r{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return a.INSTANCE}}e.ContextKeyFalseExpr=r,r.INSTANCE=new r;class a{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=a,a.INSTANCE=new a;class c{static create(s,b=null){const _=f.get(s);return typeof _=="boolean"?_?a.INSTANCE:r.INSTANCE:new c(s,b)}constructor(s,b){this.key=s,this.negated=b,this.type=2}cmp(s){return s.type!==this.type?this.type-s.type:$(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=f.get(this.key);return typeof s=="boolean"?s?a.INSTANCE:r.INSTANCE:this}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return this.negated||(this.negated=X.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class C{static create(s,b,_=null){if(typeof b=="boolean")return b?c.create(s,_):X.create(s,_);const W=f.get(s);return typeof W=="boolean"?b===(W?"true":"false")?a.INSTANCE:r.INSTANCE:new C(s,b,_)}constructor(s,b,_){this.key=s,this.value=b,this.negated=_,this.type=4}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){const s=f.get(this.key);if(typeof s=="boolean"){const b=s?"true":"false";return this.value===b?a.INSTANCE:r.INSTANCE}return this}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class S{static create(s,b){return new S(s,b)}constructor(s,b){this.key=s,this.valueKey=b,this.type=10,this.negated=null}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}substituteConstants(){return this}evaluate(s){const b=s.getValue(this.valueKey),_=s.getValue(this.key);return Array.isArray(b)?b.includes(_):typeof _=="string"&&typeof b=="object"&&b!==null?D.call(b,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class m{static create(s,b){return new m(s,b)}constructor(s,b){this.key=s,this.valueKey=b,this.type=11,this._negated=S.create(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:this._negated.cmp(s._negated)}equals(s){return s.type===this.type?this._negated.equals(s._negated):!1}substituteConstants(){return this}evaluate(s){return!this._negated.evaluate(s)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(s){return s.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=m;class x{static create(s,b,_=null){if(typeof b=="boolean")return b?X.create(s,_):c.create(s,_);const W=f.get(s);return typeof W=="boolean"?b===(W?"true":"false")?r.INSTANCE:a.INSTANCE:new x(s,b,_)}constructor(s,b,_){this.key=s,this.value=b,this.negated=_,this.type=5}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){const s=f.get(this.key);if(typeof s=="boolean"){const b=s?"true":"false";return this.value===b?r.INSTANCE:a.INSTANCE}return this}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=x;class X{static create(s,b=null){const _=f.get(s);return typeof _=="boolean"?_?r.INSTANCE:a.INSTANCE:new X(s,b)}constructor(s,b){this.key=s,this.negated=b,this.type=3}cmp(s){return s.type!==this.type?this.type-s.type:$(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=f.get(this.key);return typeof s=="boolean"?s?r.INSTANCE:a.INSTANCE:this}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=X;function K(k,s){if(typeof k=="string"){const b=parseFloat(k);isNaN(b)||(k=b)}return typeof k=="string"||typeof k=="number"?s(k):r.INSTANCE}class ie{static create(s,b,_=null){return K(b,W=>new ie(s,W,_))}constructor(s,b,_){this.key=s,this.value=b,this.negated=_,this.type=12}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=ie;class ue{static create(s,b,_=null){return K(b,W=>new ue(s,W,_))}constructor(s,b,_){this.key=s,this.value=b,this.negated=_,this.type=13}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=ue;class Q{static create(s,b,_=null){return K(b,W=>new Q(s,W,_))}constructor(s,b,_){this.key=s,this.value=b,this.negated=_,this.type=14}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=Q;class ce{static create(s,b,_=null){return K(b,W=>new ce(s,W,_))}constructor(s,b,_){this.key=s,this.value=b,this.negated=_,this.type=15}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ce;class ae{static create(s,b){return new ae(s,b)}constructor(s,b){this.key=s,this.regexp=b,this.type=7,this.negated=null}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const b=this.regexp?this.regexp.source:"",_=s.regexp?s.regexp.source:"";return b<_?-1:b>_?1:0}equals(s){if(s.type===this.type){const b=this.regexp?this.regexp.source:"",_=s.regexp?s.regexp.source:"";return this.key===s.key&&b===_}return!1}substituteConstants(){return this}evaluate(s){const b=s.getValue(this.key);return this.regexp?this.regexp.test(b):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=ae;class se{static create(s){return new se(s)}constructor(s){this._actual=s,this.type=8}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}substituteConstants(){return this}evaluate(s){return!this._actual.evaluate(s)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(s){return new se(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function j(k){let s=null;for(let b=0,_=k.length;b<_;b++){const W=k[b].substituteConstants();if(k[b]!==W&&s===null){s=[];for(let H=0;H<b;H++)s[H]=k[H]}s!==null&&(s[b]=W)}return s===null?k:s}class B{static create(s,b,_){return B._normalizeArr(s,b,_)}constructor(s,b){this.expr=s,this.negated=b,this.type=6}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let b=0,_=this.expr.length;b<_;b++){const W=i(this.expr[b],s.expr[b]);if(W!==0)return W}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let b=0,_=this.expr.length;b<_;b++)if(!this.expr[b].equals(s.expr[b]))return!1;return!0}return!1}substituteConstants(){const s=j(this.expr);return s===this.expr?this:B.create(s,this.negated,!1)}evaluate(s){for(let b=0,_=this.expr.length;b<_;b++)if(!this.expr[b].evaluate(s))return!1;return!0}static _normalizeArr(s,b,_){const W=[];let H=!1;for(const Z of s)if(Z){if(Z.type===1){H=!0;continue}if(Z.type===0)return r.INSTANCE;if(Z.type===6){W.push(...Z.expr);continue}W.push(Z)}if(W.length===0&&H)return a.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let Z=1;Z<W.length;Z++)W[Z-1].equals(W[Z])&&(W.splice(Z,1),Z--);if(W.length===1)return W[0];for(;W.length>1;){const Z=W[W.length-1];if(Z.type!==9)break;W.pop();const le=W.pop(),de=W.length===0,pe=V.create(Z.expr.map(fe=>B.create([fe,le],null,_)),null,de);pe&&(W.push(pe),W.sort(i))}if(W.length===1)return W[0];if(_){for(let Z=0;Z<W.length;Z++)for(let le=Z+1;le<W.length;le++)if(W[Z].negate().equals(W[le]))return r.INSTANCE;if(W.length===1)return W[0]}return new B(W,b)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(const b of this.expr)s.push(...b.keys());return s}map(s){return new B(this.expr.map(b=>b.map(s)),null)}negate(){if(!this.negated){const s=[];for(const b of this.expr)s.push(b.negate());this.negated=V.create(s,this,!0)}return this.negated}}e.ContextKeyAndExpr=B;class V{static create(s,b,_){return V._normalizeArr(s,b,_)}constructor(s,b){this.expr=s,this.negated=b,this.type=9}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let b=0,_=this.expr.length;b<_;b++){const W=i(this.expr[b],s.expr[b]);if(W!==0)return W}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let b=0,_=this.expr.length;b<_;b++)if(!this.expr[b].equals(s.expr[b]))return!1;return!0}return!1}substituteConstants(){const s=j(this.expr);return s===this.expr?this:V.create(s,this.negated,!1)}evaluate(s){for(let b=0,_=this.expr.length;b<_;b++)if(this.expr[b].evaluate(s))return!0;return!1}static _normalizeArr(s,b,_){let W=[],H=!1;if(s){for(let Z=0,le=s.length;Z<le;Z++){const de=s[Z];if(de){if(de.type===0){H=!0;continue}if(de.type===1)return a.INSTANCE;if(de.type===9){W=W.concat(de.expr);continue}W.push(de)}}if(W.length===0&&H)return r.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let Z=1;Z<W.length;Z++)W[Z-1].equals(W[Z])&&(W.splice(Z,1),Z--);if(W.length===1)return W[0];if(_){for(let Z=0;Z<W.length;Z++)for(let le=Z+1;le<W.length;le++)if(W[Z].negate().equals(W[le]))return a.INSTANCE;if(W.length===1)return W[0]}return new V(W,b)}}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(const b of this.expr)s.push(...b.keys());return s}map(s){return new V(this.expr.map(b=>b.map(s)),null)}negate(){if(!this.negated){const s=[];for(const b of this.expr)s.push(b.negate());for(;s.length>1;){const b=s.shift(),_=s.shift(),W=[];for(const H of U(b))for(const Z of U(_))W.push(B.create([H,Z],null,!1));s.unshift(V.create(W,null,!1))}this.negated=V.create(s,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class M extends c{static all(){return M._info.values()}constructor(s,b,_){super(s,null),this._defaultValue=b,typeof _=="object"?M._info.push({..._,key:s}):_!==!0&&M._info.push({key:s,description:_,type:b!=null?typeof b:void 0})}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(s){return C.create(this.key,s)}notEqualsTo(s){return x.create(this.key,s)}}e.RawContextKey=M,M._info=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function $(k,s){return k<s?-1:k>s?1:0}function G(k,s,b,_){return k<b?-1:k>b?1:s<_?-1:s>_?1:0}function Y(k,s){if(k.type===0||s.type===1)return!0;if(k.type===9)return s.type===9?F(k.expr,s.expr):!1;if(s.type===9){for(const b of s.expr)if(Y(k,b))return!0;return!1}if(k.type===6){if(s.type===6)return F(s.expr,k.expr);for(const b of k.expr)if(Y(b,s))return!0;return!1}return k.equals(s)}e.implies=Y;function F(k,s){let b=0,_=0;for(;b<k.length&&_<s.length;){const W=k[b].cmp(s[_]);if(W<0)return!1;W===0&&b++,_++}return b===k.length}function U(k){return k.type===9?k.expr:[k]}}),define(ne[59],re([0,1,10]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(ne[18],re([0,1,10]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[20],re([0,1,90,10]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function N(h,y){switch(h){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":y==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function w(h,y){return y==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function f(h,y,p){return w(y,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:l(p).includes(h)}e.isTargetPlatformCompatible=f;function l(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var g;(function(h){h.Install="install",h.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var L;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(L||(e.InstallOperation=L={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var E;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var u;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class d extends Error{constructor(y,p){super(y),this.code=p,this.name=p}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,T.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,N)=>q(["node-vsce-sign"],async w=>A(w),N))),this.moduleLoadingPromise}async verify(A,N,w){let f;try{f=await this.vsceSign()}catch{return!1}return f.verify(A,N,w)}}e.ExtensionSignatureVerificationService=O}),define(ne[61],re([0,1,14,9,98,13]),function(q,e,T,O,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(D,I,v,g,L,E){let u;try{await w(D,I,v,g,L,E)}catch(d){u=d}finally{u&&L.errorTransformer&&(u=L.errorTransformer(u)),typeof u<"u"&&v.error(u),v.end()}}e.readFileIntoStream=N;async function w(D,I,v,g,L,E){f(E);const u=await D.open(I,{create:!1});try{f(E);let d=0,h=0,y=L&&typeof L.length=="number"?L.length:void 0,p=T.VSBuffer.alloc(Math.min(L.bufferSize,typeof y=="number"?y:L.bufferSize)),P=L&&typeof L.position=="number"?L.position:0,t=0;do h=await D.read(u,P,p.buffer,t,p.byteLength-t),P+=h,t+=h,d+=h,typeof y=="number"&&(y-=h),t===p.byteLength&&(await v.write(g(p)),p=T.VSBuffer.alloc(Math.min(L.bufferSize,typeof y=="number"?y:L.bufferSize)),t=0);while(h>0&&(typeof y!="number"||y>0)&&f(E)&&l(d,L));if(t>0){let o=t;typeof y=="number"&&(o=Math.min(t,y)),v.write(g(p.slice(0,o)))}}catch(d){throw(0,A.ensureFileSystemProviderError)(d)}finally{await D.close(u)}}function f(D){if(D.isCancellationRequested)throw(0,O.canceled)();return!0}function l(D,I){if(typeof I?.limits?.size=="number"&&D>I.limits.size)throw(0,A.createFileSystemProviderError)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[115],re([0,1,5,163,2,12,164]),function(q,e,T,O,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new T.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=T.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const D=this.normalizeRequests(l),I=D.filter(g=>{const L=this.watchers.get(g.path);return L?!(0,O.patternsEquals)(L.request.excludes,g.excludes)||!(0,O.patternsEquals)(L.request.includes,g.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:g})=>!D.find(L=>L.path===g.path&&(0,O.patternsEquals)(L.excludes,g.excludes)&&(0,O.patternsEquals)(L.includes,g.includes))).map(({request:g})=>g.path);I.length&&this.trace(`Request to start watching: ${I.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const g of v)this.stopWatching(g);for(const g of I)this.startWatching(g)}startWatching(l){const D=new N.NodeJSFileWatcherLibrary(l,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),I={request:l,instance:D};this.watchers.set(l.path,I)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const D=this.watchers.get(l);D&&(this.watchers.delete(l),D.instance.dispose())}normalizeRequests(l){const D=new Map;for(const I of l){const v=A.isLinux?I.path:I.path.toLowerCase();D.set(v,I)}return Array.from(D.values())}async setVerboseLogging(l){this.verboseLogging=l;for(const[,D]of this.watchers)D.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,D){return D?`[File Watcher (node.js)] ${l} (path: ${D.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=w}),define(ne[116],re([0,1,62,115]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends T.AbstractNonRecursiveWatcherClient{constructor(N,w,f){super(N,w,f),this.init()}createWatcher(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(ne[117],re([0,1,16,57,83,62]),function(q,e,T,O,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends A.AbstractUniversalWatcherClient{constructor(f,l,D){super(f,l,D),this.init()}createWatcher(f){const l=f.add(new R.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:D,signal:I})=>this.onError(`terminated by itself with code ${D}, signal: ${I}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(ne[63],re([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...R){this._entries=new Map;for(const[A,N]of R)this.set(A,N)}set(R,A){const N=this._entries.get(R);return this._entries.set(R,A),N}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=T}),define(ne[118],re([0,1,8,9,2,48,113,10,63,165]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class I extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class v{constructor(u=new f.ServiceCollection,d=!1,h,y=D){this._services=u,this._strict=d,this._parent=h,this._enableTracing=y,this._activeInstantiations=new Set,this._services.set(w.IInstantiationService,this),this._globalGraph=y?h?._globalGraph??new N.Graph(p=>p):void 0}createChild(u){return new v(u,this._strict,this,this._enableTracing)}invokeFunction(u,...d){const h=L.traceInvocation(this._enableTracing,u);let y=!1;try{return u({get:P=>{if(y)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(P,h);if(!t)throw new Error(`[invokeFunction] unknown service '${P}'`);return t}},...d)}finally{y=!0,h.stop()}}createInstance(u,...d){let h,y;return u instanceof A.SyncDescriptor?(h=L.traceCreation(this._enableTracing,u.ctor),y=this._createInstance(u.ctor,u.staticArguments.concat(d),h)):(h=L.traceCreation(this._enableTracing,u),y=this._createInstance(u,d,h)),h.stop(),y}_createInstance(u,d=[],h){const y=w._util.getServiceDependencies(u).sort((t,o)=>t.index-o.index),p=[];for(const t of y){const o=this._getOrCreateServiceInstance(t.id,h);o||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const P=y.length>0?y[0].index:d.length;if(d.length!==P){console.trace(`[createInstance] First service dependency of ${u.name} at position ${P+1} conflicts with ${d.length} static arguments`);const t=P-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,P)}return Reflect.construct(u,d.concat(p))}_setServiceInstance(u,d){if(this._services.get(u)instanceof A.SyncDescriptor)this._services.set(u,d);else if(this._parent)this._parent._setServiceInstance(u,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const d=this._services.get(u);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):d}_getOrCreateServiceInstance(u,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(u));const h=this._getServiceInstanceOrDescriptor(u);return h instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,h,d.branch(u,!0)):(d.branch(u,!1),h)}_safeCreateAndCacheServiceInstance(u,d,h){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,d,h)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,d,h){const y=new N.Graph(t=>t.id.toString());let p=0;const P=[{id:u,desc:d,_trace:h}];for(;P.length;){const t=P.pop();if(y.lookupOrInsertNode(t),p++>1e3)throw new I(y);for(const o of w._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${u} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof A.SyncDescriptor){const i={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};y.insertEdge(t,i),P.push(i)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new I(y);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}y.removeNode(o)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,d,h=[],y,p){if(this._services.get(u)instanceof A.SyncDescriptor)return this._createServiceInstance(u,d,h,y,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,d,h,y,p);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(u,d,h=[],y,p){if(y){const P=new v(void 0,this._strict,this,this._enableTracing);P._globalGraphImplicitDependency=String(u);const t=new Map,o=new T.IdleValue(()=>{const n=P._createInstance(d,h,p);for(const[i,r]of t){const a=n[i];if(typeof a=="function")for(const c of r)a.apply(n,c)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=t.get(i);return c||(c=new l.LinkedList,t.set(i,c)),(S,m,x)=>{const X=c.push([S,m,x]);return(0,R.toDisposable)(X)}}if(i in n)return n[i];const r=o.value;let a=r[i];return typeof a!="function"||(a=a.bind(r),n[i]=a),a},set(n,i,r){return o.value[i]=r,!0},getPrototypeOf(n){return d.prototype}})}else return this._createInstance(d,h,p)}_throwIfStrict(u,d){if(d&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=v;var g;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(g||(g={}));class L{static traceInvocation(u,d){return u?new L(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):L._None}static traceCreation(u,d){return u?new L(1,d.name):L._None}constructor(u,d){this.type=u,this.name=d,this._start=Date.now(),this._dep=[]}branch(u,d){const h=new L(3,u.toString());return this._dep.push([u,d,h]),h}stop(){const u=Date.now()-this._start;L._totals+=u;let d=!1;function h(p,P){const t=[],o=new Array(p+1).join("	");for(const[n,i,r]of P._dep)if(i&&r){d=!0,t.push(`${o}CREATES -> ${n}`);const a=h(p+1,r);a&&t.push(a)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${L._totals.toFixed(2)}ms)`];(u>2||d)&&L.all.add(y.join(`
`))}}e.Trace=L,L.all=new Set,L._None=new class extends L{constructor(){super(0,null)}stop(){}branch(){return this}},L._totals=0});var te=this&&this.__param||function(q,e){return function(T,O){e(T,O,q)}};define(ne[64],re([0,1,23,2,12,100,20,10]),function(q,e,T,O,R,A,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function f(D){return D.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=f,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let l=e.LanguagePackBaseService=class extends O.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new T.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let v;try{v=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const L=v.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(u=>u.startsWith("lp-"))).map(E=>{const u=E.properties.localizedLanguages?.[0],d=f(E);return{...this.createQuickPickItem(d,u,E),extensionId:E.identifier.id,galleryExtension:E}});return L.push(this.createQuickPickItem("en","English")),L}createQuickPickItem(I,v,g){const L=v??I;let E;if(L!==I&&(E=`(${I})`),I.toLowerCase()===R.language.toLowerCase()&&(E??="",E+=(0,A.localize)(0,null)),g?.installCount){E??="";const u=g.installCount;let d;u>1e6?d=`${Math.floor(u/1e5)/10}M`:u>1e3?d=`${Math.floor(u/1e3)}K`:d=String(u),E+=` $(cloud-download) ${d}`}return{id:I,label:L,description:E}}};e.LanguagePackBaseService=l=ve([te(0,N.IExtensionGalleryService)],l)}),define(ne[6],re([0,1,33,5,45,2,35,12,17,3,11,114,10]),function(q,e,T,O,R,A,N,w,f,l,D,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function g(){return new Date().toISOString()}function L(S){return(0,l.isNumber)(S)}e.isLogLevel=L;var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function u(S,m,x){switch(m){case E.Trace:S.trace(x);break;case E.Debug:S.debug(x);break;case E.Info:S.info(x);break;case E.Warning:S.warn(x);break;case E.Error:S.error(x);break;case E.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=u;function d(S,m=!1){let x="";for(let X=0;X<S.length;X++){let K=S[X];if(K instanceof Error&&(K=(0,T.toErrorMessage)(K,m)),typeof K=="object")try{K=JSON.stringify(K)}catch{}x+=(X>0?" ":"")+K}return x}class h extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(m){this.level!==m&&(this.level=m,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(m){return this.level!==E.Off&&this.level<=m}}e.AbstractLogger=h;class y extends h{constructor(m){super(),this.logAlways=m}checkLogLevel(m){return this.logAlways||super.checkLogLevel(m)}trace(m,...x){this.checkLogLevel(E.Trace)&&this.log(E.Trace,d([m,...x],!0))}debug(m,...x){this.checkLogLevel(E.Debug)&&this.log(E.Debug,d([m,...x]))}info(m,...x){this.checkLogLevel(E.Info)&&this.log(E.Info,d([m,...x]))}warn(m,...x){this.checkLogLevel(E.Warning)&&this.log(E.Warning,d([m,...x]))}error(m,...x){if(this.checkLogLevel(E.Error))if(m instanceof Error){const X=Array.prototype.slice.call(arguments);X[0]=m.stack,this.log(E.Error,d(X))}else this.log(E.Error,d([m,...x]))}flush(){}}e.AbstractMessageLogger=y;class p extends h{constructor(m=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(m),this.useColors=!w.isWindows}trace(m,...x){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,m,...x):console.log(`[main ${g()}]`,m,...x))}debug(m,...x){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,m,...x):console.log(`[main ${g()}]`,m,...x))}info(m,...x){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,m,...x):console.log(`[main ${g()}]`,m,...x))}warn(m,...x){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,m,...x):console.warn(`[main ${g()}]`,m,...x))}error(m,...x){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,m,...x):console.error(`[main ${g()}]`,m,...x))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class P extends h{constructor(m=e.DEFAULT_LOG_LEVEL,x=!0){super(),this.useColors=x,this.setLevel(m)}trace(m,...x){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",m,...x):console.log(m,...x))}debug(m,...x){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",m,...x):console.log(m,...x))}info(m,...x){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",m,...x):console.log(m,...x))}warn(m,...x){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",m,...x):console.log(m,...x))}error(m,...x){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",m,...x):console.error(m,...x))}dispose(){}flush(){}}e.ConsoleLogger=P;class t extends h{constructor(m,x=e.DEFAULT_LOG_LEVEL){super(),this.adapter=m,this.setLevel(x)}trace(m,...x){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(m),...x])}debug(m,...x){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(m),...x])}info(m,...x){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(m),...x])}warn(m,...x){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(m),...x])}error(m,...x){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(m),...x])}extractMessage(m){return typeof m=="string"?m:(0,T.toErrorMessage)(m,this.checkLogLevel(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends h{constructor(m){super(),this.loggers=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const x of this.loggers)x.setLevel(m);super.setLevel(m)}trace(m,...x){for(const X of this.loggers)X.trace(m,...x)}debug(m,...x){for(const X of this.loggers)X.debug(m,...x)}info(m,...x){for(const X of this.loggers)X.info(m,...x)}warn(m,...x){for(const X of this.loggers)X.warn(m,...x)}error(m,...x){for(const X of this.loggers)X.error(m,...x)}flush(){for(const m of this.loggers)m.flush()}dispose(){for(const m of this.loggers)m.dispose()}}e.MultiplexLogger=o;class n extends A.Disposable{constructor(m,x,X){if(super(),this.logLevel=m,this.logsHome=x,this._loggers=new N.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,X)for(const K of X)this._loggers.set(K.resource,{logger:void 0,info:K})}getLoggerEntry(m){return(0,l.isString)(m)?[...this._loggers.values()].find(x=>x.info.id===m):this._loggers.get(m)}getLogger(m){return this.getLoggerEntry(m)?.logger}createLogger(m,x){const X=this.toResource(m),K=(0,l.isString)(m)?m:x?.id??(0,R.hash)(X.toString()).toString(16);let ie=this._loggers.get(X)?.logger;const ue=x?.logLevel==="always"?E.Trace:x?.logLevel;ie||(ie=this.doCreateLogger(X,ue??this.getLogLevel(X)??this.logLevel,{...x,id:K}));const Q={logger:ie,info:{resource:X,id:K,logLevel:ue,name:x?.name,hidden:x?.hidden,extensionId:x?.extensionId,when:x?.when}};return this.registerLogger(Q.info),this._loggers.set(X,Q),ie}toResource(m){return(0,l.isString)(m)?(0,f.joinPath)(this.logsHome,`${m}.log`):m}setLogLevel(m,x){if(D.URI.isUri(m)){const X=m,K=x,ie=this._loggers.get(X);ie&&K!==ie.info.logLevel&&(ie.info.logLevel=K===this.logLevel?void 0:K,ie.logger?.setLevel(K),this._loggers.set(ie.info.resource,ie),this._onDidChangeLogLevel.fire([X,K]))}else{this.logLevel=m;for(const[X,K]of this._loggers.entries())this._loggers.get(X)?.info.logLevel===void 0&&K.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(m,x){const X=this.getLoggerEntry(m);X&&x!==!X.info.hidden&&(X.info.hidden=!x,this._loggers.set(X.info.resource,X),this._onDidChangeVisibility.fire([X.info.resource,x]))}getLogLevel(m){let x;return m&&(x=this._loggers.get(m)?.info.logLevel),x??this.logLevel}registerLogger(m){const x=this._loggers.get(m.resource);x?x.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this._loggers.set(m.resource,{info:m,logger:void 0}),this._onDidChangeLoggers.fire({added:[m],removed:[]}))}deregisterLogger(m){const x=this._loggers.get(m);x&&(x.logger&&x.logger.dispose(),this._loggers.delete(m),this._onDidChangeLoggers.fire({added:[],removed:[x.info]}))}*getRegisteredLoggers(){for(const m of this._loggers.values())yield m.info}getRegisteredLogger(m){return this._loggers.get(m)?.info}dispose(){this._loggers.forEach(m=>m.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(m){}getLevel(){return E.Info}trace(m,...x){}debug(m,...x){}info(m,...x){}warn(m,...x){}error(m,...x){}critical(m,...x){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function a(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const m=C(S.logLevel.toLowerCase());if(m!==void 0)return m}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function c(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=c;function C(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",c(E.Info))}),define(ne[119],re([0,1,19,8,9,5,2,15,62,6]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends N.Disposable{constructor(v,g){super(),this.logService=v,this.options=g,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(v,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,g):this.watchNonRecursive(v,g)}watchUniversal(v,g){const L={path:this.toFilePath(v),excludes:g.excludes,includes:g.includes,recursive:g.recursive},E=(0,T.insert)(this.universalPathsToWatch,L);return this.refreshUniversalWatchers(),(0,N.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,R.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,f.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const g of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const g of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(g)&&v.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,g){const L={path:this.toFilePath(v),excludes:g.excludes,includes:g.includes,recursive:!1},E=(0,T.insert)(this.nonRecursivePathsToWatch,L);return this.refreshNonRecursiveWatchers(),(0,N.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,R.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,f.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,w.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(ne[120],re([0,1,19,8,14,23,5,45,65,2,55,16,121,17,44,97,13,61,6,9]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=e.FileService=class extends l.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new N.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new N.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new N.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new N.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const n=new l.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(i=>this._onDidFilesChange.fire(new u.FileChangesEvent(i,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,l.dispose)(n)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(n){o.push(n)}}),!this.provider.has(t)&&await O.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const n=this.provider.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return f.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,g.isAbsolutePath)(t))throw new u.FileOperationError((0,E.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const n=new y.ErrorNoTelemetry;throw n.message=(0,E.localize)(1,null,t.toString()),n}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasReadWriteCapability)(o)||(0,u.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,E.localize)(2,null,this.resourceForError(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async doResolveFile(t,o){const n=await this.withProvider(t),i=this.isPathCaseSensitive(n),r=o?.resolveTo,a=o?.resolveSingleChildDescendants,c=o?.resolveMetadata,C=await n.stat(t);let S;return this.toFileStat(n,t,C,void 0,!!c,(m,x)=>(S||(S=D.TernarySearchTree.forUris(()=>!i),S.set(t,!0),r&&S.fill(!0,r)),S.get(m.resource)||S.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&a?x===1:!1))}async toFileStat(t,o,n,i,r,a){const{providerExtUri:c}=this.getExtUri(t),C={resource:o,name:c.basename(o),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&u.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&u.FilePermission.Locked),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(C.isDirectory&&a(C,i)){try{const S=await t.readdir(o),m=await O.Promises.settled(S.map(async([x,X])=>{try{const K=c.joinPath(o,x),ie=r?await t.stat(K):{type:X};return await this.toFileStat(t,K,ie,S.length,r,a)}catch(K){return this.logService.trace(K),null}}));C.children=(0,T.coalesce)(m)}catch(S){this.logService.trace(S),C.children=[]}return C}return C}async resolveAll(t){return O.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),n=await o.stat(t);return this.toFileStat(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(n){return n}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,E.localize)(3,null,this.resourceForError(t)),3,o)}async createFile(t,o=R.VSBuffer.fromString(""),n){await this.doValidateCreateFile(t,n);const i=await this.writeFile(t,o);return this._onDidRunOperation.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,o,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,t,n)||await this.mkdirp(i,r.dirname(t));let c;if((0,u.hasReadWriteCapability)(i)&&!(o instanceof R.VSBuffer))if((0,L.isReadableStream)(o)){const C=await(0,L.peekStream)(o,3);C.ended?c=R.VSBuffer.concat(C.buffer):c=C}else c=(0,L.peekReadable)(o,C=>R.VSBuffer.concat(C),3);else c=o;if(!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&c instanceof R.VSBuffer)await this.doWriteUnbuffered(i,t,n,c);else{const C=c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c;n?.atomic!==!1&&n?.atomic?.postfix?await this.doWriteBufferedAtomic(i,t,(0,g.joinPath)((0,g.dirname)(t),`${(0,g.basename)(t)}${n.atomic.postfix}`),n,C):await this.doWriteBuffered(i,t,n,C)}this._onDidRunOperation.fire(new u.FileOperationEvent(t,4))}catch(a){throw new u.FileOperationError((0,E.localize)(4,null,this.resourceForError(t),(0,u.ensureFileSystemProviderError)(a).toString()),(0,u.toFileOperationResult)(a),n)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,n){const i=!!n?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(o)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,E.localize)(6,null,this.resourceForError(o)));if(i)throw new Error((0,E.localize)(7,null,this.resourceForError(o)))}let a;try{a=await t.stat(o)}catch{return}if(a.type&u.FileType.Directory)throw new u.FileOperationError((0,E.localize)(8,null,this.resourceForError(o)),0,n);if(this.throwIfFileIsReadonly(o,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:a.size}))throw new u.FileOperationError((0,E.localize)(9,null),3,n);return a}async readFile(t,o,n){const i=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(i,t,o,n):this.doReadFile(i,t,o,n)}async doReadFileAtomic(t,o,n,i){return new Promise((r,a)=>{this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(t,o,n,i);r(c)}catch(c){a(c)}})})}async doReadFile(t,o,n,i){const r=await this.doReadFileStream(t,o,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(t,o,n){const i=await this.withReadProvider(t);return this.doReadFileStream(i,t,o,n)}async doReadFileStream(t,o,n,i){const r=new A.CancellationTokenSource(i),a=this.validateReadFile(o,n).then(C=>C,C=>{throw r.cancel(),C});let c;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await a,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?c=this.readFileUnbuffered(t,o,n):(0,u.hasFileReadStreamCapability)(t)?c=this.readFileStreamed(t,o,r.token,n):c=this.readFileBuffered(t,o,r.token,n),{...await a,value:c}}catch(C){throw c&&await(0,L.consumeStream)(c),this.restoreReadError(C,o,n)}}restoreReadError(t,o,n){const i=(0,E.localize)(10,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}readFileStreamed(t,o,n,i=Object.create(null)){const r=t.readFileStream(o,i,n);return(0,L.transform)(r,{data:a=>a instanceof R.VSBuffer?a:R.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,o,i)},a=>R.VSBuffer.concat(a))}readFileBuffered(t,o,n,i=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,d.readFileIntoStream)(t,o,r,a=>a,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,o,i)},n),r}readFileUnbuffered(t,o,n){const i=(0,L.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(o,{atomic:!0}):r=await t.readFile(o),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(o,r.byteLength,n),i.end(R.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,E.localize)(11,null,this.resourceForError(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==u.ETAG_DISABLED&&o.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,E.localize)(12,null),n,o);return this.validateReadFileLimits(t,n.size,o),n}validateReadFileLimits(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new u.TooLargeFileOperationError((0,E.localize)(13,null,this.resourceForError(t)),7,o,n)}async canMove(t,o,n){return this.doCanMoveCopy(t,o,"move",n)}async canCopy(t,o,n){return this.doCanMoveCopy(t,o,"copy",n)}async doCanMoveCopy(t,o,n,i){if(t.toString()!==o.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(r,t,a,o,n,i)}catch(r){return r}return!0}async move(t,o,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(i,t,r,o,"move",!!n),c=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,a==="move"?2:3,c)),c}async copy(t,o,n){const i=await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(i,t,r,o,"copy",!!n),c=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,a==="copy"?3:2,c)),c}async doMoveCopy(t,o,n,i,r,a){if(o.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:C}=await this.doValidateMoveCopy(t,o,n,i,r,a);if(c&&!C&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),r==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(o,i,{overwrite:a});else{const S=await this.resolve(o);S.isDirectory?await this.doCopyFolder(t,S,n,i):await this.doCopyFile(t,o,n,i)}return r}else return t===n?(await t.rename(o,i,{overwrite:a}),r):(await this.doMoveCopy(t,o,n,i,"copy",a),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(t,o,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(t,o,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(t,o,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.doPipeUnbuffered(t,o,n,i)}async doCopyFolder(t,o,n,i){await n.mkdir(i),Array.isArray(o.children)&&await O.Promises.settled(o.children.map(async r=>{const a=this.getExtUri(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(t,await this.resolve(r.resource),n,a):this.doCopyFile(t,r.resource,n,a)}))}async doValidateMoveCopy(t,o,n,i,r,a){let c=!1;if(t===n){const{providerExtUri:S,isPathCaseSensitive:m}=this.getExtUri(t);if(m||(c=S.isEqual(o,i)),c&&r==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!c&&S.isEqualOrParent(i,o))throw new Error((0,E.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const C=await this.exists(i);if(C&&!c){if(!a)throw new u.FileOperationError((0,E.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(t===n){const{providerExtUri:S}=this.getExtUri(t);if(S.isEqualOrParent(o,i))throw new Error((0,E.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:C,isSameResourceWithDifferentPathCase:c}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,0,n)),n}async mkdirp(t,o){const n=[],{providerExtUri:i}=this.getExtUri(t);for(;!i.isEqual(o,i.dirname(o));)try{if(!((await t.stat(o)).type&u.FileType.Directory))throw new Error((0,E.localize)(18,null,this.resourceForError(o)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(o)),o=i.dirname(o)}for(let r=n.length-1;r>=0;r--){o=i.joinPath(o,n[r]);try{await t.mkdir(o)}catch(a){if((0,u.toFileSystemProviderErrorCode)(a)!==u.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(n){return n}return!0}async doValidateDelete(t,o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),i=!!o?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(t)));const r=o?.atomic;if(r&&!(n.capabilities&65536))throw new Error((0,E.localize)(20,null,this.resourceForError(t)));if(i&&r)throw new Error((0,E.localize)(21,null,this.resourceForError(t)));let a;try{a=await n.stat(t)}catch{}if(a)this.throwIfFileIsReadonly(t,a);else throw new u.FileOperationError((0,E.localize)(22,null,this.resourceForError(t)),1);if(!!!o?.recursive){const C=await this.resolve(t);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,E.localize)(23,null,this.resourceForError(t)))}return n}async del(t,o){const n=await this.doValidateDelete(t,o),i=!!o?.useTrash,r=!!o?.recursive,a=o?.atomic??!1;await n.delete(t,{recursive:r,useTrash:i,atomic:a}),this._onDidRunOperation.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,o){const n=await this.withProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(t,o))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,o);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(o));const r=this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(t,o,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,t,i,o))}watch(t,o={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,l.toDisposable)(()=>r())),(async()=>{try{const a=await this.doWatch(t,o);i?(0,l.dispose)(a):r=()=>(0,l.dispose)(a)}catch(a){this.logService.error(a)}})(),n}async doWatch(t,o){const n=await this.withProvider(t),i=(0,w.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(t),o]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:n.watch(t,o)},this.activeWatchers.set(i,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,l.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,o,n,i,r){await this.doWriteBuffered(t,n,i,r);try{await t.rename(n,o,{overwrite:!0})}catch(a){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async doWriteBuffered(t,o,n,i){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{const r=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,L.isReadableStream)(i)||(0,L.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(t,r,i):await this.doWriteReadableBufferedQueued(t,r,i)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await t.close(r)}})}async doWriteStreamBufferedQueued(t,o,n){let i=0,r;if((0,L.isReadableBufferedStream)(n)){if(n.buffer.length>0){const a=R.VSBuffer.concat(n.buffer);await this.doWriteBuffer(t,o,a,a.byteLength,i,0),i+=a.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((a,c)=>{(0,L.listenStream)(r,{onData:async C=>{r.pause();try{await this.doWriteBuffer(t,o,C,C.byteLength,i,0)}catch(S){return c(S)}i+=C.byteLength,setTimeout(()=>r.resume())},onError:C=>c(C),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(t,o,n){let i=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(t,o,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(t,o,n,i,r,a){let c=0;for(;c<i;){const C=await t.write(o,r+c,n.buffer,a+c,i-c);c+=C}}async doWriteUnbuffered(t,o,n,i){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,o,n,i))}async doWriteUnbufferedQueued(t,o,n,i){let r;i instanceof R.VSBuffer?r=i:(0,L.isReadableStream)(i)?r=await(0,R.streamToBuffer)(i):(0,L.isReadableBufferedStream)(i)?r=await(0,R.bufferedStreamToBuffer)(i):r=(0,R.readableToBuffer)(i),await t.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(t,o,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,o,n,i))}async doPipeBufferedQueued(t,o,n,i){let r,a;try{r=await t.open(o,{create:!1}),a=await n.open(i,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.BUFFER_SIZE);let C=0,S=0,m=0;do m=await t.read(r,C,c.buffer,S,c.byteLength-S),await this.doWriteBuffer(n,a,c,m,C,S),C+=m,S+=m,S===c.byteLength&&(S=0);while(m>0)}catch(c){throw(0,u.ensureFileSystemProviderError)(c)}finally{await O.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async doPipeUnbuffered(t,o,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,o,n,i))}async doPipeUnbufferedQueued(t,o,n,i){return n.writeFile(i,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,o,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,o,n,i))}async doPipeUnbufferedToBufferedQueued(t,o,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(o);await this.doWriteBuffer(n,r,R.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(t,o,n,i){const r=await(0,R.streamToBuffer)(this.readFileBuffered(t,o,A.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,r)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&2048)throw new u.FileOperationError((0,E.localize)(24,null,this.resourceForError(o)),6);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,E.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===I.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=p=ve([te(0,h.ILogService)],p)}),define(ne[122],re([0,1,123,166,8,35,14,5,167,2,15,12,17,44,22,99,13,61,119,33,117,116]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h,y,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(T)}catch(o){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(o)}`)}})();class t extends h.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=w.Event.None,this.resourceLocks=new A.ResourceMap(r=>v.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:r}=await L.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:u.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await L.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,v.joinPath)(n,a.name))).type:c=this.toType(a),r.push([a.name,c])}catch(c){this.logService.trace(c)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let r;return i?.dangling?r=u.FileType.Unknown:n.isFile()?r=u.FileType.File:n.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,i&&(r|=u.FileType.SymbolicLink),r}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const a=new R.Barrier;return this.resourceLocks.set(n,a),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===a&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),r=await this.createResourceLock(n));const a=this.toFilePath(n);return await L.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}traceLock(n){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,r){const a=(0,g.newWriteableStream)(c=>N.VSBuffer.concat(c.map(C=>N.VSBuffer.wrap(C))).buffer);return(0,d.readFileIntoStream)(this,n,a,c=>c.buffer,{...i,bufferSize:256*1024},r),a}async writeFile(n,i,r){return r?.atomic!==!1&&r?.atomic?.postfix?this.doWriteFileAtomic(n,(0,v.joinPath)((0,v.dirname)(n),`${(0,v.basename)(n)}${r.atomic.postfix}`),i,r):this.doWriteFile(n,i,r)}async doWriteFileAtomic(n,i,r,a){await this.doWriteFile(i,r,a);try{await this.rename(i,n,{overwrite:!0})}catch(c){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async doWriteFile(n,i,r){let a;try{const c=this.toFilePath(n);if(!r.create||!r.overwrite){if(await L.Promises.exists(c)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,E.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,E.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(n,c)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){t.canFlush=n}async open(n,i){const r=this.toFilePath(n);let a;(0,u.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(n));let c;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await L.SymlinkSupport.stat(r);S.mode&128||await L.Promises.chmod(r,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}let C;if((0,u.isFileOpenForWriteOptions)(i)){if(I.isWindows)try{await L.Promises.truncate(r,0),C="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}C||(C="w")}else C="r";c=await L.Promises.open(r,C)}catch(C){throw a?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,C):this.toFileSystemProviderError(C)}if(this.mapHandleToPos.set(c,0),(0,u.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,n),a){const C=this.mapHandleToLock.get(c);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${r})`),this.mapHandleToLock.set(c,a),C&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${r})`),C.dispose())}return c}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&t.canFlush)try{await L.Promises.fdatasync(n)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await L.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,a,c){const C=this.normalizePos(n,i);let S=null;try{S=(await L.Promises.read(n,r,a,c,C)).bytesRead}catch(m){throw this.toFileSystemProviderError(m)}finally{this.updatePos(n,C,S)}return S}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,r){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(n,a+r):this.mapHandleToPos.delete(n)))}async write(n,i,r,a,c){return(0,R.retry)(()=>this.doWrite(n,i,r,a,c),100,3)}async doWrite(n,i,r,a,c){const C=this.normalizePos(n,i);let S=null;try{S=(await L.Promises.write(n,r,a,c,C)).bytesWritten}catch(m){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),m)}finally{this.updatePos(n,C,S)}return S}async mkdir(n){try{await L.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const r=this.toFilePath(n);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,D.join)((0,D.dirname)(r),`${(0,D.basename)(r)}${i.atomic.postfix}`)),await L.Promises.rm(r,L.RimRafMode.MOVE,a)}else try{await L.Promises.unlink(r)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let c=!1;try{const{stat:C,symbolicLink:S}=await L.SymlinkSupport.stat(r);c=C.isDirectory()&&!S}catch{}if(c)await L.Promises.rmdir(r);else throw a}else throw a}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(n,i,r){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateMoveCopy(n,i,"move",r.overwrite),await L.Promises.move(a,c)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,E.localize)(2,null,(0,D.basename)(a),(0,D.basename)((0,D.dirname)(c)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(n,i,r){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateMoveCopy(n,i,"copy",r.overwrite),await L.Promises.copy(a,c,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,E.localize)(3,null,(0,D.basename)(a),(0,D.basename)((0,D.dirname)(c)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(n,i,r,a){const c=this.toFilePath(n),C=this.toFilePath(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,f.isEqual)(c,C,!0)),S){if(r==="copy")throw(0,u.createFileSystemProviderError)((0,E.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const x=await this.statIgnoreError(n);if(!x)throw(0,u.createFileSystemProviderError)((0,E.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const X=await this.statIgnoreError(i);if(X){if(!a)throw(0,u.createFileSystemProviderError)((0,E.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);x.type&u.FileType.File&&X.type&u.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,r){const a=this.toFilePath(n),c=this.toFilePath(i),C=!!(this.capabilities&1024);if((0,f.isEqual)(a,c,!C))return;const S=new l.DisposableStore;try{const[m,x]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);S.add(m),S.add(x),r&&await L.Promises.mkdir((0,D.dirname)(c),{recursive:!0}),await L.Promises.copyFile(a,c)}catch(m){if(m.code==="ENOENT"&&!r)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(m)}finally{S.dispose()}}createUniversalWatcher(n,i,r){return new p.UniversalWatcherClient(a=>n(a),a=>i(a),r)}createNonRecursiveWatcher(n,i,r){return new P.NodeJSWatcherClient(a=>n(a),a=>i(a),r)}toFileSystemProviderError(n){if(n instanceof u.FileSystemProviderError)return n;let i=n,r;switch(n.code){case"ENOENT":r=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=u.FileSystemProviderErrorCode.Unknown;break;default:r=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(n,i){let r=this.toFileSystemProviderError(i);if(n&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await L.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(r=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(ne[124],re([0,1,2,6]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class R extends T.Disposable{constructor(N,w=[]){super(),this.logger=new O.MultiplexLogger([N,...w]),this._register(N.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(N){this.logger.setLevel(N)}getLevel(){return this.logger.getLevel()}trace(N,...w){this.logger.trace(N,...w)}debug(N,...w){this.logger.debug(N,...w)}info(N,...w){this.logger.info(N,...w)}warn(N,...w){this.logger.warn(N,...w)}error(N,...w){this.logger.error(N,...w)}flush(){this.logger.flush()}}e.LogService=R}),define(ne[125],re([0,1,13,6]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var R;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(R||(R={}));async function A(l,D,I,v,g){try{const L=await new Promise((u,d)=>{q(["@vscode/spdlog"],u,d)});L.setFlushOn(R.Trace);const E=await L.createAsyncRotatingLogger(l,D,I,v);return g?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(L){console.error(L)}return null}function N(l,D,I){switch(D){case O.LogLevel.Trace:l.trace(I);break;case O.LogLevel.Debug:l.debug(I);break;case O.LogLevel.Info:l.info(I);break;case O.LogLevel.Warning:l.warn(I);break;case O.LogLevel.Error:l.error(I);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function w(l,D){switch(D){case O.LogLevel.Trace:l.setLevel(R.Trace);break;case O.LogLevel.Debug:l.setLevel(R.Debug);break;case O.LogLevel.Info:l.setLevel(R.Info);break;case O.LogLevel.Warning:l.setLevel(R.Warning);break;case O.LogLevel.Error:l.setLevel(R.Error);break;case O.LogLevel.Off:l.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class f extends O.AbstractMessageLogger{constructor(D,I,v,g,L){super(),this.buffer=[],this.setLevel(L),this._loggerCreationPromise=this._createSpdLogLogger(D,I,v,g),this._register(this.onDidChangeLogLevel(E=>{this._logger&&w(this._logger,E)}))}async _createSpdLogLogger(D,I,v,g){const L=v?6:1,E=30/L*T.ByteSize.MB,u=await A(D,I,E,L,g);if(u){this._logger=u,w(this._logger,this.getLevel());for(const{level:d,message:h}of this.buffer)N(this._logger,d,h);this.buffer=[]}}log(D,I){this._logger?N(this._logger,D,I):this.getLevel()<=D&&this.buffer.push({level:D,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(ne[126],re([0,1,28,6,125]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends O.AbstractLoggerService{doCreateLogger(w,f,l){return new R.SpdLogLogger((0,T.generateUuid)(),w.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.LoggerService=A}),define(ne[38],re([0,1,5,65,2,10]),function(q,e,T,O,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class N extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),O.Iterable.reduce(this.policies.entries(),(I,[v,g])=>({...I,[v]:g}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[D,I])=>({...l,[D]:{definition:I,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=N;class w{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(ne[127],re([0,1,8,5,65,3,13,6,38]),function(q,e,T,O,R,A,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(I,v){const g=[];for(const L of new Set(R.Iterable.concat(I.keys(),v.keys())))I.get(L)!==v.get(L)&&g.push(L);return g}let D=e.FilePolicyService=class extends f.AbstractPolicyService{constructor(v,g,L){super(),this.file=v,this.fileService=g,this.logService=L,this.throttledDelayer=this._register(new T.ThrottledDelayer(500));const E=O.Event.filter(g.onDidFilesChange,u=>u.affects(v));this._register(g.watch(v)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const v=new Map;try{const g=await this.fileService.readFile(this.file),L=JSON.parse(g.value.toString());if(!(0,A.isObject)(L))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(L))this.policyDefinitions[E]&&v.set(E,L[E])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return v}async refresh(){const v=await this.read(),g=l(this.policies,v);this.policies=v,g.length>0&&this._onDidChange.fire(g)}};e.FilePolicyService=D=ve([te(1,N.IFileService),te(2,w.ILogService)],D)}),define(ne[128],re([0,1,38,8,168,2,6]),function(q,e,T,O,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let w=e.NativePolicyService=class extends T.AbstractPolicyService{constructor(l,D){super(),this.logService=l,this.productName=D,this.throttler=new O.Throttler,this.watcher=this._register(new A.MutableDisposable)}async _updatePolicyDefinitions(l){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.throttler.queue(()=>new Promise((D,I)=>{try{this.watcher.value=(0,R.createWatcher)(this.productName,l,v=>{this._onDidPolicyChange(v),D()})}catch(v){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),I(v)}}))}_onDidPolicyChange(l){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const D in l){const I=l[D];I===void 0?this.policies.delete(D):this.policies.set(D,I)}this._onDidChange.fire(Object.keys(l))}};e.NativePolicyService=w=ve([te(0,N.ILogService)],w)}),define(ne[31],re([0,1,10]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,70,3]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(N,w){T.ok(O.isString(N)),T.ok(O.isObject(w)),T.ok(!this.data.has(N),"There is already an extension with this id"),this.data.set(N,w)}knows(N){return this.data.has(N)}as(N){return this.data.get(N)||null}}e.Registry=new R}),define(ne[129],re([0,1,5,36]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class A{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,l){this.schemasById[R(f)]=l,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const N=new A;O.Registry.add(e.Extensions.JSONContribution,N)}),define(ne[42],re([0,1,19,5,3,86,24,129,36]),function(q,e,T,O,R,A,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=f.Registry.as(w.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.doRegisterConfigurations(t,o,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(t,!1,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const n=[];for(const{overrides:i,source:r}of t)for(const a in i)if(o.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),C=c?.valuesSources??new Map;if(r)for(const X of Object.keys(i[a]))C.set(X,r);const S={...c?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:r,value:S,valuesSources:C});const m=(0,N.getLanguageTagSettingPlainKey)(a),x={type:"object",default:S,description:A.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:R.isString(r)?void 0:r,defaultValueSource:r};n.push(...E(a)),this.configurationProperties[a]=x,this.defaultLanguageConfigurationOverridesNode.properties[a]=x}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:r});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:n,source:i}of t)for(const r in n){const a=this.configurationDefaultsOverrides.get(r),c=R.isString(i)?i:i?.id,C=R.isString(a?.source)?a?.source:a?.source?.id;if(c===C)if(o.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const S=this.configurationProperties[r];S&&(this.updatePropertyDefaultValue(r,S),this.updateSchema(r,S))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,n),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,n){t.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,o){const n=i=>{if(i.properties)for(const r in i.properties){o.add(r);const a=this.configurationProperties[r];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of t){n(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,o=!0,n,i,r=3,a){r=R.isUndefinedOrNull(t.scope)?r:t.scope;const c=t.properties;if(c)for(const S in c){const m=c[S];if(o&&y(S,m)){delete c[S];continue}if(m.source=n,m.defaultDefaultValue=c[S].default,this.updatePropertyDefaultValue(S,m),e.OVERRIDE_PROPERTY_REGEX.test(S)?m.scope=void 0:(m.scope=R.isUndefinedOrNull(m.scope)?r:m.scope,m.restricted=R.isUndefinedOrNull(m.restricted)?!!i?.includes(S):m.restricted),c[S].hasOwnProperty("included")&&!c[S].included){this.excludedConfigurationProperties[S]=c[S],delete c[S];continue}else this.configurationProperties[S]=c[S],c[S].policy?.name&&this.policyConfigurations.set(c[S].policy.name,S);!c[S].deprecationMessage&&c[S].markdownDeprecationMessage&&(c[S].deprecationMessage=c[S].markdownDeprecationMessage),a.add(S)}const C=t.allOf;if(C)for(const S of C)this.validateAndRegisterProperties(S,o,n,i,r,a)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const n=this.configurationDefaultsOverrides.get(t);let i=n?.value,r=n?.source;R.isUndefined(i)&&(i=o.defaultDefaultValue,r=void 0),R.isUndefined(i)&&(i=d(o.type)),o.default=i,o.defaultValueSource=r}}const g="\\[([^\\]]+)\\]",L=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(P){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(P)){let o=L.exec(P);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=L.exec(P)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=E;function u(P){return P.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=u;function d(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new v;f.Registry.add(e.Extensions.Configuration,h);function y(P,t){return P.trim()?e.OVERRIDE_PROPERTY_REGEX.test(P)?A.localize(7,null,P):h.getConfigurationProperties()[P]!==void 0?A.localize(8,null,P):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,P,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=y;function p(){const P=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))P.push([o,t[o].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=p}),define(ne[66],re([0,1,19,5,52,2,35,30,3,11,24,42,36]),function(q,e,T,O,R,A,N,w,f,l,D,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(o){return Object.isFrozen(o)?o:w.deepFreeze(o)}class L{constructor(n={},i=[],r=[],a){this._contents=n,this._keys=i,this._overrides=r,this.raw=a,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof L)return i;const r=new E("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),a=i?this.rawConfiguration.getOverrideValue(n,i):void 0,c=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:a,merged:c}}getOverrideValue(n,i){const r=this.getContentsForOverrideIdentifer(i);return r?n?(0,D.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return T.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=w.deepClone(this.contents),r=w.deepClone(this.overrides),a=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const C of n)if(c.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(i,C.contents);for(const S of C.overrides){const[m]=r.filter(x=>T.equals(x.identifiers,S.identifiers));m?(this.mergeContents(m.contents,S.contents),m.keys.push(...S.keys),m.keys=T.distinct(m.keys)):r.push(w.deepClone(S))}for(const S of C.keys)a.indexOf(S)===-1&&a.push(S)}return new L(i,a,r,c.every(C=>C instanceof L)?void 0:c)}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const a of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[a];const C=i[a];C&&(typeof c=="object"&&typeof C=="object"?(c=w.deepClone(c),this.mergeContents(c,C)):c=C),r[a]=c}return new L(r,this.keys,this.overrides)}mergeContents(n,i){for(const r of Object.keys(i)){if(r in n&&f.isObject(n[r])&&f.isObject(i[r])){this.mergeContents(n[r],i[r]);continue}n[r]=w.deepClone(i[r])}}getContentsForOverrideIdentifer(n){let i=null,r=null;const a=c=>{c&&(r?this.mergeContents(r,c):r=w.deepClone(c))};for(const c of this.overrides)T.equals(c.identifiers,[n])?i=c.contents:c.identifiers.includes(n)&&a(c.contents);return a(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.updateValue(n,i,!0)}setValue(n,i){this.updateValue(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,D.removeFromValueTree)(this.contents,n),I.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,I.overrideIdentifiersFromKey)(n))),1))}updateValue(n,i,r){(0,D.addToValueTree)(this.contents,n,i,a=>console.error(a)),r=r||this.keys.indexOf(n)===-1,r&&this.keys.push(n),I.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,D.toValuesTree)(this.contents[n],a=>console.error(a))})}}e.ConfigurationModel=L;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new L}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!f.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:r,keys:a,overrides:c,restricted:C,hasExcludedProperties:S}=this.doParseRaw(n,i);this._configurationModel=new L(r,a,c,S?[n]:void 0),this._restrictedConfigurations=C||[]}doParseContent(n){let i={},r=null,a=[];const c=[],C=[];function S(x){Array.isArray(a)?a.push(x):r!==null&&(a[r]=x)}const m={onObjectBegin:()=>{const x={};S(x),c.push(a),a=x,r=null},onObjectProperty:x=>{r=x},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const x=[];S(x),c.push(a),a=x,r=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:S,onError:(x,X,K)=>{C.push({error:x,offset:X,length:K})}};if(n)try{R.visit(n,m),i=a[0]||{}}catch(x){console.error(`Error while parsing settings file ${this._name}: ${x}`),this._parseErrors=[x]}return i}doParseRaw(n,i){const r=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),a=this.filter(n,r,!0,i);n=a.raw;const c=(0,D.toValuesTree)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),C=Object.keys(n),S=this.toOverrides(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:c,keys:C,overrides:S,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(n,i,r,a){let c=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const C={},S=[];for(const m in n)if(I.OVERRIDE_PROPERTY_REGEX.test(m)&&r){const x=this.filter(n[m],i,!1,a);C[m]=x.raw,c=c||x.hasExcludedProperties,S.push(...x.restricted)}else{const x=i[m],X=x?typeof x.scope<"u"?x.scope:3:void 0;x?.restricted&&S.push(m),(X===void 0||a.scopes===void 0||a.scopes.includes(X))&&!(a.skipRestricted&&x?.restricted)?C[m]=n[m]:c=!0}return{raw:C,restricted:S,hasExcludedProperties:c}}toOverrides(n,i){const r=[];for(const a of Object.keys(n))if(I.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const C in n[a])c[C]=n[a][C];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,D.toValuesTree)(c,i)})}return r}}e.ConfigurationModelParser=E;class u extends A.Disposable{constructor(n,i,r,a){super(),this.userSettingsResource=n,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new L}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class d{constructor(n,i,r,a,c,C,S,m,x,X,K,ie,ue){this.key=n,this.overrides=i,this._value=r,this.overrideIdentifiers=a,this.defaultConfiguration=c,this.policyConfiguration=C,this.applicationConfiguration=S,this.userConfiguration=m,this.localUserConfiguration=x,this.remoteUserConfiguration=X,this.workspaceConfiguration=K,this.folderConfigurationModel=ie,this.memoryConfigurationModel=ue}get value(){return g(this._value)}inspect(n,i,r){const a=n.inspect(i,r);return{get value(){return g(a.value)},get override(){return g(a.override)},get merged(){return g(a.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(n,i,r,a,c=new L,C=new L,S=new N.ResourceMap,m=new L,x=new N.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=a,this._remoteUserConfiguration=c,this._workspaceConfiguration=C,this._folderConfigurations=S,this._memoryConfiguration=m,this._memoryConfigurationByResource=x,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new N.ResourceMap,this._userConfiguration=null}getValue(n,i,r){return this.getConsolidatedConfigurationModel(n,i,r).getValue(n)}updateValue(n,i,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new L,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(n):a.setValue(n,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,r){const a=this.getConsolidatedConfigurationModel(n,i,r),c=this.getFolderConfigurationModelForResource(i.resource,r),C=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,S=new Set;for(const m of a.overrides)for(const x of m.identifiers)a.getOverrideValue(n,x)!==void 0&&S.add(x);return new d(n,i,a.getValue(n),S.size?[...S]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,c||void 0,C)}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:a,updated:c,removed:C}=P(this._defaultConfiguration,n);i=[...a,...c,...C]}for(const a of i)for(const c of(0,I.overrideIdentifiersFromKey)(a)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(c),S=n.getKeysForOverrideIdentifier(c),m=[...S.filter(x=>C.indexOf(x)===-1),...C.filter(x=>S.indexOf(x)===-1),...C.filter(x=>!w.equals(this._defaultConfiguration.override(c).getValue(x),n.override(c).getValue(x)))];r.push([c,m])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:a}=P(this._policyConfiguration,n),c=[...i,...r,...a];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:a,overrides:c}=P(this.applicationConfiguration,n),C=[...i,...r,...a];return C.length&&this.updateApplicationConfiguration(n),{keys:C,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:a,overrides:c}=P(this.localUserConfiguration,n),C=[...i,...r,...a];return C.length&&this.updateLocalUserConfiguration(n),{keys:C,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:a,overrides:c}=P(this.remoteUserConfiguration,n),C=[...i,...r,...a];return C.length&&this.updateRemoteUserConfiguration(n),{keys:C,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:a,overrides:c}=P(this.workspaceConfiguration,n),C=[...i,...r,...a];return C.length&&this.updateWorkspaceConfiguration(n),{keys:C,overrides:c}}compareAndUpdateFolderConfiguration(n,i){const r=this.folderConfigurations.get(n),{added:a,updated:c,removed:C,overrides:S}=P(r,i),m=[...a,...c,...C];return(m.length||!r)&&this.updateFolderConfiguration(n,i),{keys:m,overrides:S}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:a,removed:c,overrides:C}=P(i,void 0);return{keys:[...r,...a,...c],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,r){let a=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:n},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const a=i.getFolder(n);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const c=this._memoryConfigurationByResource.get(n);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(n);a?(i=r.merge(a),this._foldersConsolidatedConfigurations.set(n,i)):i=r}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:r,overrides:a,keys:c}=this._folderConfigurations.get(i);return n.push([i,{contents:r,overrides:a,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this._workspaceConfiguration.keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),a=this.parseConfigurationModel(n.application),c=this.parseConfigurationModel(n.user),C=this.parseConfigurationModel(n.workspace),S=n.folders.reduce((m,x)=>(m.set(l.URI.revive(x[0]),this.parseConfigurationModel(x[1])),m),new N.ResourceMap);return new h(i,r,a,c,new L,C,S,new L,new N.ResourceMap)}static parseConfigurationModel(n){return new L(n.contents,n.keys,n.overrides)}}e.Configuration=h;function y(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const a of o)a.keys.forEach(c=>n.add(c)),a.overrides.forEach(([c,C])=>{const S=(0,N.getOrSet)(i,c,new Set);C.forEach(m=>S.add(m))});const r=[];return i.forEach((a,c)=>r.push([c,[...a.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=y;class p{constructor(n,i,r,a){this.change=n,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=a,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of n.keys)this.affectedKeys.add(c);for(const[,c]of n.overrides)for(const C of c)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){const r=this._marker+n,a=this._affectsConfigStr.indexOf(r);if(a<0)return!1;const c=a+r.length;if(c>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(c);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(i){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,m=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!w.equals(S,m)}return!0}}e.ConfigurationChangeEvent=p;function P(o,n){const{added:i,removed:r,updated:a}=t(n?.rawConfiguration,o?.rawConfiguration),c=[],C=o?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const m=S.filter(x=>!C.includes(x));for(const x of m)c.push([x,n.getKeysForOverrideIdentifier(x)])}if(o){const m=C.filter(x=>!S.includes(x));for(const x of m)c.push([x,o.getKeysForOverrideIdentifier(x)])}if(n&&o){for(const m of C)if(S.includes(m)){const x=t({contents:o.getOverrideValue(void 0,m)||{},keys:o.getKeysForOverrideIdentifier(m)},{contents:n.getOverrideValue(void 0,m)||{},keys:n.getKeysForOverrideIdentifier(m)});c.push([m,[...x.added,...x.removed,...x.updated]])}}return{added:i,removed:r,updated:a,overrides:c}}function t(o,n){const i=o?n?o.keys.filter(c=>n.keys.indexOf(c)===-1):[...o.keys]:[],r=n?o?n.keys.filter(c=>o.keys.indexOf(c)===-1):[...n.keys]:[],a=[];if(o&&n){for(const c of n.keys)if(o.keys.indexOf(c)!==-1){const C=(0,D.getConfigurationValue)(n.contents,c),S=(0,D.getConfigurationValue)(o.contents,c);w.equals(C,S)||a.push(c)}}return{added:i,removed:r,updated:a}}}),define(ne[130],re([0,1,19,5,2,30,3,66,42,6,38,36]),function(q,e,T,O,R,A,N,w,f,l,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(I.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:d})=>this.onDidUpdateConfiguration(Array.from(u),d))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(u,d){this.updateConfigurationModel(u,I.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new w.ConfigurationModel;const u=I.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(u),u)}updateConfigurationModel(u,d){const h=this.getConfigurationDefaultOverrides();for(const y of u){const p=h[y],P=d[y];p!==void 0?this._configurationModel.addValue(y,p):P?this._configurationModel.addValue(y,P.default):this._configurationModel.removeValue(y)}}}e.DefaultConfiguration=v;class g{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let L=e.PolicyConfiguration=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(u,d,h){super(),this.defaultConfiguration=u,this.policyService=d,this.logService=h,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.updatePolicyDefinitions(u),!0))),this._configurationModel}async updatePolicyDefinitions(u){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",u);const d={},h=[],y=I.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const p of u){const P=y[p];if(!P){h.push(p);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.logService.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}h.push(p),d[P.policy.name]={type:P.type}}}return(0,N.isEmptyObject)(d)||await this.policyService.updatePolicyDefinitions(d),h}onDidChangePolicies(u){this.logService.trace("PolicyConfiguration#onDidChangePolicies",u);const d=I.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),h=(0,T.coalesce)(u.map(y=>d.get(y)));this.update(h,!0)}update(u,d){this.logService.trace("PolicyConfiguration#update",u);const h=I.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),y=[],p=this._configurationModel.isEmpty();for(const P of u){const t=h[P]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(p?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(P),o))&&y.push([P,o])}else this._configurationModel.getValue(P)!==void 0&&y.push([P,void 0])}if(y.length){this.logService.trace("PolicyConfiguration#changed",y);const P=this._configurationModel;this._configurationModel=new w.ConfigurationModel;for(const t of P.keys)this._configurationModel.setValue(t,P.getValue(t));for(const[t,o]of y)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=L=ve([te(1,D.IPolicyService),te(2,l.ILogService)],L)}),define(ne[131],re([0,1,8,5,2,17,24,66,130,38]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends R.Disposable{constructor(v,g,L,E){super(),this.settingsResource=v,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration),this.policyConfiguration=L instanceof l.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,L,E)),this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,g)),this.configuration=new w.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:u,properties:d})=>this.onDidDefaultConfigurationChange(u,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(u=>this.onDidPolicyConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,g,L]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new w.Configuration(v,g,new w.ConfigurationModel,L)}getConfigurationData(){return this.configuration.toData()}getValue(v,g){const L=typeof v=="string"?v:void 0,E=(0,N.isConfigurationOverrides)(v)?v:(0,N.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(L,E,void 0)}updateValue(v,g,L,E){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const g=this.configuration.toData(),L=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(L,g,2)}onDidDefaultConfigurationChange(v,g){const L=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(v,g);this.trigger(E,L,7)}onDidPolicyConfigurationChange(v){const g=this.configuration.toData(),L=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(L,g,7)}trigger(v,g,L){const E=new w.ConfigurationChangeEvent(v,{data:g},this.configuration);E.source=L,E.sourceConfig=this.getTargetConfiguration(L),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(ne[67],re([0,1,16]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(l){return l.scheme===T.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=O;function R(l){if(!l)return;const D=l.indexOf("+");return D<0?l:l.substr(0,D)}e.getRemoteName=R;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=A;function N(l){const{host:D,port:I}=f(l);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:I}}e.parseAuthorityWithPort=N;function w(l,D){let{host:I,port:v}=f(l);return typeof v>"u"&&(v=D),{host:I,port:v}}e.parseAuthorityWithOptionalPort=w;function f(l){const D=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const I=l.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(N||(e.ExtensionType=N={}));var w;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.LINUX_PPC64LE="linux-ppc64le",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class f{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,d){if(typeof u>"u"||u===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof u=="string"||typeof d=="string"){const h=typeof u=="string"?u:u.value,y=typeof d=="string"?d:d.value;return T.equalsIgnoreCase(h,y)}return u._lower===d._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=f;class l{get size(){return this._set.size}constructor(u){if(this._set=new Set,u)for(const d of u)this.add(d)}add(u){this._set.add(f.toKey(u))}delete(u){return this._set.delete(f.toKey(u))}has(u){return this._set.has(f.toKey(u))}}e.ExtensionIdentifierSet=l;class D{constructor(){this._map=new Map}clear(){this._map.clear()}delete(u){this._map.delete(f.toKey(u))}get(u){return this._map.get(f.toKey(u))}has(u){return this._map.has(f.toKey(u))}set(u,d){this._map.set(f.toKey(u),d)}values(){return this._map.values()}forEach(u){this._map.forEach(u)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=D;function I(E){return v(E)}e.isApplicationScopedExtension=I;function v(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function g(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function L(E,u){if(u){const d=`onResolveRemoteAuthority:${(0,R.getRemoteName)(u)}`;return!!E.activationEvents?.includes(d)}return!1}e.isResolverExtension=L,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[132],re([0,1,2,37,13]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends T.Disposable{constructor(w,f,l,D,I){super(),this.userDataProfilesService=w,this.fileService=f,this.uriIdentityService=l,this.logService=I,this._register(D.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(D.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(w){for(const f of w)f.local&&this.invalidate(f.profileLocation)}onDidUnInstallExtension(w){w.error||this.invalidate(w.profileLocation)}async invalidate(w){if(w)for(const f of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(f.extensionsResource,w)&&await this.deleteUserCacheFile(f);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(w){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(w.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(f){(0,R.toFileOperationResult)(f)!==1&&this.logService.error(f)}}}e.ExtensionsManifestCache=A}),define(ne[43],re([0,1,14,9,2,101,42,10,6,36]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,w.createDecorator)("requestService");class D{constructor(P){this.original=P}toJSON(){if(!this.headers){const P=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?P[t]="*****":P[t]=this.original[t];this.headers=P}return this.headers}}class I extends R.Disposable{constructor(P){super(),this.counter=0,this.logger=P.createLogger("network",{name:(0,A.localize)(0,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async logAndRequest(P,t,o){const n=`${P} #${++this.counter}: ${t.url}`;this.logger.trace(`${n} - begin`,t.type,new D(t.headers??{}));try{const i=await o();return this.logger.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${n} - error`,t.type,(0,O.getErrorMessage)(i)),i}}}e.AbstractRequestService=I;function v(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=v;function g(p){return p.res.statusCode===204}async function L(p){return g(p)?null:(await(0,T.streamToBuffer)(p.stream)).toString()}e.asText=L;async function E(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);return L(p)}e.asTextOrError=E;async function u(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const t=(await(0,T.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.asJson=u;function d(p){y(p)}e.updateProxyConfigurationsScope=d;let h;function y(p){const P=l.Registry.as(N.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null)],default:"override",description:(0,A.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(10,null),restricted:!0}}},P.updateConfigurations({add:[h],remove:t?[t]:[]})}y(1)}),define(ne[133],re([0,1,23,16,13,43]),function(q,e,T,O,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=e.DownloadService=class{constructor(f,l){this.requestService=f,this.fileService=l}async download(f,l,D=T.CancellationToken.None){if(f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(f,l);return}const I={type:"GET",url:f.toString(!0)},v=await this.requestService.request(I,D);if(v.res.statusCode===200)await this.fileService.writeFile(l,v.stream);else{const g=await(0,A.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${g}`)}}};e.DownloadService=N=ve([te(0,A.IRequestService),te(1,R.IFileService)],N)}),define(ne[134],re([0,1,135,3]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(N,w){return N.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:N.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function A(N,w,f={}){const l=(0,T.parse)(N),D=f.proxyUrl||R(l,w);if(!D)return null;const I=(0,T.parse)(D);if(!/^https?:$/.test(I.protocol||""))return null;const v={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,O.isBoolean)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((g,L)=>{q(["http-proxy-agent"],g,L)}))(v):new(await new Promise((g,L)=>{q(["https-proxy-agent"],g,L)}))(v)}e.getProxyAgent=A}),define(ne[136],re([0,1,58,15,102,23,33,9,12,28,82,169,8,71]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let L;async function E(d,h,y,p){return y["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(p)&&!y["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(p)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),L||(L=v.Promises.withAsyncBody(async(P,t)=>{const o=new A.CancellationTokenSource;let n=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,g.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),t(new Error((0,R.localize)(0,null)))},n);try{P(await u(h,o.token))}catch(a){!(0,w.isCancellationError)(a)&&!o.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,N.toErrorMessage)(a)))):P({})}finally{clearTimeout(r),o.dispose()}})),L)}e.getResolvedShellEnv=E;async function u(d,h){const y=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",y);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",p);const P=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(P+"({.*})"+P),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const n=await(0,D.getSystemShell)(f.OS,o);return d.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(h.isCancellationRequested)return r(new w.CancellationError);const a=(0,O.basename)(n);let c,C;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${S} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,C=["-Login","-Command"]):a==="nu"?(c=`^'${process.execPath}' ${S} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,C=["-i","-l","-c"]):(c=`'${process.execPath}' ${S} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,a==="tcsh"||a==="csh"?C=["-ic"]:C=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),c);const m=(0,T.spawn)(n,[...C,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(m.kill(),r(new w.CancellationError))),m.on("error",K=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(K)),r(K)});const x=[];m.stdout.on("data",K=>x.push(K));const X=[];m.stderr.on("data",K=>X.push(K)),m.on("close",(K,ie)=>{const ue=Buffer.concat(x).toString("utf8");d.trace("getUnixShellEnvironment#raw",ue);const Q=Buffer.concat(X).toString("utf8");if(Q.trim()&&d.trace("getUnixShellEnvironment#stderr",Q),K||ie)return r(new Error((0,R.localize)(2,null,K,ie)));const ce=t.exec(ue),ae=ce?ce[1]:"{}";try{const se=JSON.parse(ae);y?se.ELECTRON_RUN_AS_NODE=y:delete se.ELECTRON_RUN_AS_NODE,p?se.ELECTRON_NO_ATTACH_CONSOLE=p:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",se),i(se)}catch(se){d.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(se)),r(se)}})})}}),define(ne[137],re([0,1,10]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,T.createDecorator)("stateReadService"),e.IStateService=(0,T.createDecorator)("stateService")}),define(ne[68],re([0,1,8,14,3,18,13,6]),function(q,e,T,O,R,A,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var f;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(f||(e.SaveStrategy=f={}));class l{constructor(g,L,E,u){this.storagePath=g,this.logService=E,this.fileService=u,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=L===0?void 0:new T.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(g){g.fileOperationResult!==1&&this.logService.error(g)}}getItem(g,L){const E=this.storage[g];return(0,R.isUndefinedOrNull)(E)?L:E}setItem(g,L){this.setItems([{key:g,data:L}])}setItems(g){let L=!1;for(const{key:E,data:u}of g)this.storage[E]!==u&&((0,R.isUndefinedOrNull)(u)?(0,R.isUndefined)(this.storage[E])||(this.storage[E]=void 0,L=!0):(this.storage[E]=u,L=!0));L&&this.save()}removeItem(g){(0,R.isUndefined)(this.storage[g])||(this.storage[g]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const g=JSON.stringify(this.storage,null,4);if(g!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,O.VSBuffer.fromString(g),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=g}catch(L){this.logService.error(L)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=l;let D=e.StateReadonlyService=class{constructor(g,L,E,u){this.fileStorage=new l(L.stateResource,g,E,u)}async init(){await this.fileStorage.init()}getItem(g,L){return this.fileStorage.getItem(g,L)}};e.StateReadonlyService=D=ve([te(1,A.IEnvironmentService),te(2,w.ILogService),te(3,N.IFileService)],D);class I extends D{setItem(g,L){this.fileStorage.setItem(g,L)}setItems(g){this.fileStorage.setItems(g)}removeItem(g){this.fileStorage.removeItem(g)}close(){return this.fileStorage.close()}}e.StateService=I}),define(ne[69],re([0,1,12,34,28]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(f){if(T.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function N(f,l,D,I,v,g,L,E){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=(0,R.generateUuid)()+Date.now(),u.commitHash=I,u.version=v,u["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,T.PlatformToString)(T.platform),u["common.nodePlatform"]=O.platform,u["common.nodeArch"]=D,u["common.product"]=E||"desktop",L&&(u["common.msftInternal"]=L);let d=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),T.isLinuxSnap&&(u["common.snap"]="true");const y=A(l);return y&&(u["common.platformDetail"]=y),u}e.resolveCommonProperties=N;function w(f){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const D=l.toLowerCase();return f.some(I=>D===I)}e.verifyMicrosoftInternalDomain=w}),define(ne[25],re([0,1,10]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,5,24,67,69,25]),function(q,e,T,O,R,A,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class D{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class I{async publicLog(r,a,c){}async publicLogError(r,a,c){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,r){return R.Event.debounce(r.onDidChangeConfiguration,(c,C)=>{const S=c?new Set([...c.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:S}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=v;function g(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=g;function L(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=L;function E(i){const r=i.getValue(f.TELEMETRY_SETTING_ID),a=i.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function u(i){const r={},a={},c={};y(i,c);for(let C in c){C=C.length>150?C.substr(C.length-149):C;const S=c[C];typeof S=="number"?a[C]=S:typeof S=="boolean"?a[C]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${S.length}`),r[C]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(r[C]=S)}return{properties:r,measurements:a}}e.validateTelemetryData=u;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const r=(0,N.getRemoteName)(i);return d.has(r)?r:"other"}e.cleanRemoteAuthority=h;function y(i,r,a=0,c){if(i)for(const C of Object.getOwnPropertyNames(i)){const S=i[C],m=c?c+C:C;Array.isArray(S)?r[m]=(0,T.safeStringify)(S):S instanceof Date?r[m]=S.toISOString():(0,O.isObject)(S)?a<2?y(S,r,a+1,m+"."):r[m]=(0,T.safeStringify)(S):r[m]=S}}function p(i,r){const a=i.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,w.verifyMicrosoftInternalDomain)(a)||c}e.isInternalTelemetry=p;function P(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=P;function t(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const c=[];for(const x of r)for(;;){const X=x.exec(i);if(!X)break;c.push([X.index,x.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(a="";;){const x=S.exec(i);if(!x)break;const X=c.some(([K,ie])=>x.index<ie&&K<S.lastIndex);!C.test(x[0])&&!X&&(a+=i.substring(m,x.index)+"<REDACTED: user-file-path>",m=S.lastIndex)}return m<i.length&&(a+=i.substr(m)),a}function o(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of r)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function n(i,r){return(0,T.cloneAndChange)(i,a=>{if(a instanceof l||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let c=a.replaceAll("%20"," ");c=t(c,r);for(const C of r)c=c.replace(C,"");return c=o(c),c}})}e.cleanData=n}),define(ne[26],re([0,1,29,20,37,12,11,9,34,39]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,T.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=D;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const r=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,r,a)}static parse(i){const r=I.exec(i);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?D(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function L(n){const i=g.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=L;function E(n,i){return`${n}.${i}`}e.getExtensionId=E;function u(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=u;function d(n,i){return u(E(n??R.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=d;function h(n,i){const r=[],a=c=>{for(const C of r)if(C.some(S=>D(i(S),i(c))))return C;return null};for(const c of n){const C=a(c);C?C.push(c):r.push([c])}return r}e.groupByExtension=h;function y(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function p(n){return{id:new l.TelemetryTrustedValue(n.identifier.id),name:new l.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function P(n,i){const r=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const c=a.shift();if(c&&r.every(C=>!D(C.identifier,{id:c}))){const C=n.filter(S=>D(S.identifier,{id:c}));C.length===1&&(r.push(C[0]),a.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=P;async function t(n,i){if(!A.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const r=await t(n,i),a=(0,O.getTargetPlatform)(r?"alpine":A.platform,f.arch);return i.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(ne[138],re([0,1,23,9,16,17,41,11,91,20,26,37]),function(q,e,T,O,R,A,N,w,f,l,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const v=u=>(0,f.localize)(0,null,u),g=(0,f.localize)(1,null,"ms-dotnettools.csharp");function L(u,d){return d?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let E=e.ExtensionManagementCLI=class{constructor(d,h,y){this.logger=d,this.extensionManagementService=h,this.extensionGalleryService=y}get location(){}async listExtensions(d,h,y){let p=await this.extensionManagementService.getInstalled(1,y);const P=I.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(h&&h!==""){if(P.indexOf(h.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.logger.info("Possible Categories: "),P.forEach(o=>{this.logger.info(o)});return}this.location&&this.logger.info((0,f.localize)(2,null,this.location)),p=p.sort((o,n)=>o.identifier.id.localeCompare(n.identifier.id));let t;for(const o of p)t!==o.identifier.id&&(t=o.identifier.id,this.logger.info(L(o.manifest,d)))}async installExtensions(d,h,y,p){const P=[];try{const t=[];d.length&&this.logger.info(this.location?(0,f.localize)(3,null,this.location):(0,f.localize)(4,null));const o=[];let n=[];const i=(a,c,C)=>{n.push({id:a,version:c!=="prerelease"?c:void 0,installOptions:{...y,isBuiltin:C,installPreReleaseVersion:c==="prerelease"||y.installPreReleaseVersion}})};for(const a of d)if(a instanceof w.URI)o.push({vsix:a,installOptions:y});else{const[c,C]=(0,D.getIdAndVersion)(a);i(c,C,!1)}for(const a of h)if(a instanceof w.URI)o.push({vsix:a,installOptions:{...y,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,C]=(0,D.getIdAndVersion)(a);i(c,C,!0)}const r=await this.extensionManagementService.getInstalled(1,y.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:a,installOptions:c})=>{try{const C=await this.installVSIX(a,c,p,r);C&&t.push(C)}catch(C){this.logger.error(C),P.push(a.toString())}})),n.length&&(n=n.filter(({id:a,version:c})=>{const C=r.find(S=>(0,D.areSameExtensions)(S.identifier,{id:a}));if(C){if(!p&&(!c||c==="prerelease"&&C.preRelease))return this.logger.info((0,f.localize)(5,null,a,C.manifest.version,a)),!1;if(c&&C.manifest.version===c)return this.logger.info((0,f.localize)(6,null,`${a}@${c}`)),!1}return!0}),n.length)){const a=await this.getGalleryExtensions(n);await Promise.all(n.map(async c=>{const C=a.get(c.id.toLowerCase());if(C)try{const S=await this.installFromGallery(c,C,r);S&&t.push(S)}catch(S){this.logger.error(S.message||S.stack||S),P.push(c.id)}else this.logger.error(`${v(c.version?`${c.id}@${c.version}`:c.id)}
${g}`),P.push(c.id)}))}}catch(t){throw this.logger.error((0,f.localize)(7,null,(0,O.getErrorMessage)(t))),t}if(P.length)throw new Error((0,f.localize)(8,null,P.join(", ")))}async installVSIX(d,h,y,p){const P=await this.extensionManagementService.getManifest(d);if(!P)throw new Error("Invalid vsix");if(await this.validateVSIX(P,y,h.profileLocation,p))try{return await this.extensionManagementService.install(d,h),this.logger.info((0,f.localize)(9,null,(0,A.basename)(d))),P}catch(o){if((0,O.isCancellationError)(o))return this.logger.info((0,f.localize)(10,null,(0,A.basename)(d))),null;throw o}return null}async getGalleryExtensions(d){const h=new Map,y=d.some(t=>t.installOptions.installPreReleaseVersion),p=await this.extensionManagementService.getTargetPlatform(),P=[];for(const t of d)l.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&P.push({...t,preRelease:y});if(P.length){const t=await this.extensionGalleryService.getExtensions(P,{targetPlatform:p},T.CancellationToken.None);for(const o of t)h.set(o.identifier.id.toLowerCase(),o)}return h}async installFromGallery({id:d,version:h,installOptions:y},p,P){const t=await this.extensionGalleryService.getManifest(p,T.CancellationToken.None);if(t&&!this.validateExtensionKind(t))return null;const o=P.find(n=>(0,D.areSameExtensions)(n.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.logger.info((0,f.localize)(11,null,h?`${d}@${h}`:d)),null;this.logger.info((0,f.localize)(12,null,d,p.version))}try{y.isBuiltin?this.logger.info(h?(0,f.localize)(13,null,d,h):(0,f.localize)(14,null,d)):this.logger.info(h?(0,f.localize)(15,null,d,h):(0,f.localize)(16,null,d));const n=await this.extensionManagementService.installFromGallery(p,{...y,installGivenVersion:!!h});return this.logger.info((0,f.localize)(17,null,d,n.manifest.version)),t}catch(n){if((0,O.isCancellationError)(n))return this.logger.info((0,f.localize)(18,null,d)),null;throw n}}validateExtensionKind(d){return!0}async validateVSIX(d,h,y,p){if(!h){const P={id:(0,D.getGalleryExtensionId)(d.publisher,d.name)},t=p.find(o=>(0,D.areSameExtensions)(P,o.identifier)&&(0,N.gt)(o.manifest.version,d.version));if(t)return this.logger.info((0,f.localize)(19,null,t.identifier.id,t.manifest.version,d.version)),!1}return this.validateExtensionKind(d)}async uninstallExtensions(d,h,y){const p=async t=>{if(t instanceof w.URI){const o=await this.extensionManagementService.getManifest(t);return L(o)}return t},P=[];for(const t of d){const o=await p(t),i=(await this.extensionManagementService.getInstalled(void 0,y)).filter(r=>(0,D.areSameExtensions)(r.identifier,{id:o}));if(!i.length)throw new Error(`${this.notInstalled(o)}
${g}`);if(i.some(r=>r.type===0)){this.logger.info((0,f.localize)(20,null,o));return}if(!h&&i.some(r=>r.isBuiltin)){this.logger.info((0,f.localize)(21,null,o));return}this.logger.info((0,f.localize)(22,null,o));for(const r of i)await this.extensionManagementService.uninstall(r,{profileLocation:y}),P.push(r);this.location?this.logger.info((0,f.localize)(23,null,o,this.location)):this.logger.info((0,f.localize)(24,null,o))}}async locateExtension(d){const h=await this.extensionManagementService.getInstalled();d.forEach(y=>{h.forEach(p=>{if(p.identifier.id===y&&p.location.scheme===R.Schemas.file){this.logger.info(p.location.fsPath);return}})})}notInstalled(d){return this.location?(0,f.localize)(25,null,d,this.location):(0,f.localize)(26,null,d)}};e.ExtensionManagementCLI=E=ve([te(1,l.IExtensionManagementService),te(2,l.IExtensionGalleryService)],E)}),define(ne[139],re([0,1,5,2,35,26,37]),function(q,e,T,O,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class w extends O.Disposable{constructor(l,D,I,v,g,L,E){super(),this.extensionManagementService=l,this.extensionsScannerService=D,this.userDataProfilesService=I,this.extensionsProfileScannerService=v,this.uriIdentityService=g,this.fileService=L,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,u=>E.error(u))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.onDidChangeProfiles(l.added,l.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(l=>this.onAddExtensions(l))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(l=>this.onDidAddExtensions(l))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(l=>this.onRemoveExtensions(l))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(l=>this.onDidRemoveExtensions(l))),this._register(this.fileService.onDidFilesChange(l=>this.onDidFilesChange(l)))}async onDidChangeProfiles(l,D){try{await Promise.all(D.map(I=>(this.extensionsProfileWatchDisposables.deleteAndDispose(I.id),this.removeExtensionsFromProfile(I.extensionsResource)))),l.length&&await Promise.all(l.map(I=>(this.extensionsProfileWatchDisposables.set(I.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(I.extensionsResource)),this.fileService.watch(I.extensionsResource))),this.populateExtensionsFromProfile(I.extensionsResource))))}catch(I){throw this.logService.error(I),I}}async onAddExtensions(l){for(const D of l.extensions)this.addExtensionWithKey(this.getKey(D.identifier,D.version),l.profileLocation)}async onDidAddExtensions(l){for(const D of l.extensions){const I=this.getKey(D.identifier,D.version);l.error?this.removeExtensionWithKey(I,l.profileLocation):this.addExtensionWithKey(I,l.profileLocation)}}async onRemoveExtensions(l){for(const D of l.extensions)this.removeExtensionWithKey(this.getKey(D.identifier,D.version),l.profileLocation)}async onDidRemoveExtensions(l){const D=[],I=[];for(const v of l.extensions){const g=this.getKey(v.identifier,v.version);l.error?this.addExtensionWithKey(g,l.profileLocation):(this.removeExtensionWithKey(g,l.profileLocation),this.allExtensions.has(g)||(this.logService.debug("Extension is removed from all profiles",v.identifier.id,v.version),I.push(this.extensionManagementService.scanInstalledExtensionAtLocation(v.location).then(L=>{L?D.push(L):this.logService.info("Extension not found at the location",v.location.toString())},L=>this.logService.error(L)))))}try{await Promise.all(I),D.length&&await this.uninstallExtensionsNotInProfiles(D)}catch(v){this.logService.error(v)}}onDidFilesChange(l){for(const D of this.userDataProfilesService.profiles)l.contains(D.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(D.extensionsResource)}async onDidExtensionsProfileChange(l){const D=[],I=[],v=await this.extensionsProfileScannerService.scanProfileExtensions(l),g=new Set,L=new Set;for(const[E,u]of this.allExtensions)u.has(l)&&L.add(E);for(const E of v){const u=this.getKey(E.identifier,E.version);g.add(u),L.has(u)||(D.push(E.identifier),this.addExtensionWithKey(u,l))}for(const E of L)if(!g.has(E)){const u=this.fromKey(E);u&&(I.push(u.identifier),this.removeExtensionWithKey(E,l))}(D.length||I.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D.length?{extensions:D,profileLocation:l}:void 0,removed:I.length?{extensions:I,profileLocation:l}:void 0})}async populateExtensionsFromProfile(l){const D=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const I of D)this.addExtensionWithKey(this.getKey(I.identifier,I.version),l)}async removeExtensionsFromProfile(l){for(const D of[...this.allExtensions.keys()])this.removeExtensionWithKey(D,l);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(l){l||(l=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(I=>!this.allExtensions.has(this.getKey(I.identifier,I.manifest.version)))),l.length&&await this.extensionManagementService.markAsUninstalled(...l)}addExtensionWithKey(l,D){let I=this.allExtensions.get(l);I||this.allExtensions.set(l,I=new R.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(v))),I.add(D)}removeExtensionWithKey(l,D){const I=this.allExtensions.get(l);I&&I.delete(D),I?.size||this.allExtensions.delete(l)}getKey(l,D){return`${N.ExtensionIdentifier.toKey(l.id)}@${D}`}fromKey(l){const[D,I]=(0,A.getIdAndVersion)(l);return I?{identifier:{id:D},version:I}:void 0}}e.ExtensionsWatcher=w}),define(ne[140],re([0,1,111,39]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(A,N,w,f,l,D,I){const v={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,O.supportsTelemetry)(N,w)&&(0,O.getTelemetryLevel)(f)===3){const g=await(0,T.getServiceMachineId)(w,l,D);v["X-Market-User-Id"]=g,v["VSCode-SessionId"]=I.machineId||g}return v}e.resolveMarketplaceHeaders=R}),define(ne[141],re([0,1,170,19,8,2,16,15,22,18,20,26,6,64,11]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=e.NativeLanguagePackService=class extends g.LanguagePackBaseService{constructor(y,p,P,t){super(P),this.extensionManagementService=y,this.logService=t,this.cache=this._register(new u(p,t)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(y,p){const t=(await this.cache.getLanguagePacks())[p];if(!t){this.logService.warn(`No language pack found for ${p}`);return}const o=t.translations[y];return o?L.URI.file(o):void 0}async getInstalledLanguages(){const y=await this.cache.getLanguagePacks(),p=Object.keys(y).map(P=>{const t=y[P];return{...this.createQuickPickItem(P,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((P,t)=>P.label.localeCompare(t.label)),p}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const p=await this.cache.getLanguagePacks();Object.keys(p).some(P=>p[P]&&p[P].extensions.some(t=>(0,I.areSameExtensions)(t.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),P=await this.cache.update(p);return!(0,O.equals)(Object.keys(y),Object.keys(P))}};e.NativeLanguagePackService=E=ve([te(0,D.IExtensionManagementService),te(1,l.INativeEnvironmentService),te(2,D.IExtensionGalleryService),te(3,v.ILogService)],E);let u=class extends A.Disposable{constructor(y,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(p=>{Object.keys(p).forEach(P=>delete p[P]),this.createLanguagePacksFromExtensions(p,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...p){for(const P of p)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,P);Object.keys(y).forEach(P=>this.updateHash(y[P]))}createLanguagePacksFromExtension(y,p){const P=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of t)if(p.location.scheme===N.Schemas.file&&d(o)){let n=y[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},y[o.languageId]=n);const i=n.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,P))[0];i?i.version=p.manifest.version:n.extensions.push({extensionIdentifier:P,version:p.manifest.version});for(const r of o.translations)n.translations[r.id]=(0,w.join)(p.location.fsPath,r.path)}}updateHash(y){if(y){const p=(0,T.createHash)("md5");for(const P of y.extensions)p.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);y.hash=p.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return f.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(p=y(P),P)).then(P=>{for(const o of Object.keys(P))P[o]||delete P[o];this.languagePacks=P,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),f.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>p,P=>this.logService.error(P))})}};u=ve([te(0,l.INativeEnvironmentService),te(1,v.ILogService)],u);function d(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const y of h.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ne[142],re([0,1,9,30,39]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://0.0.0.0/OneCollector/1.0",N="https://0.0.0.0/ping";async function w(l,D,I){const v=await new Promise((d,h)=>{q(["@microsoft/1ds-core-js"],d,h)}),g=await new Promise((d,h)=>{q(["@microsoft/1ds-post-js"],d,h)}),L=new v.AppInsightsCore,E=new g.PostChannel,u={instrumentationKey:l,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(I){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:I};u.extensionConfig[E.identifier]=d}return L.initialize(u,[]),L.addTelemetryInitializer(d=>{D&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),L}class f{constructor(D,I,v,g,L){this._isInternalTelemetry=D,this._eventPrefix=I,this._defaultData=v,this._xhrOverride=L,this.endPointUrl=A,this.endPointHealthUrl=N,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(D){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){D(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=w(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{D(I)},I=>{(0,T.onUnexpectedError)(I),console.error(I)})}}log(D,I){if(!this._aiCoreOrKey)return;I=(0,O.mixin)(I,this._defaultData),I=(0,R.validateTelemetryData)(I);const v=this._eventPrefix+"/"+D;try{this._withAIClient(g=>{g.pluginVersionString=I?.properties.version??"Unknown",g.track({name:v,baseData:{name:v,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(D=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,D(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ne[143],re([0,1,2,30,12,29,103,24,42,144,31,36,25,39]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let L=e.TelemetryService=class{constructor(d,h,y){this._configurationService=h,this._productService=y,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(v.TELEMETRY_SETTING_ID)||p.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(d,h){this._experimentProperties[d]=h}_updateTelemetryLevel(){let d=(0,g.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const y=h.usage?3:h.error?2:0;d=Math.min(d,y)}this._telemetryLevel=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(d,h,y){this._telemetryLevel<h||(y=(0,O.mixin)(y,this._experimentProperties),y=(0,g.cleanData)(y,this._cleanupPatterns),y=(0,O.mixin)(y,this._commonProperties),this._appenders.forEach(p=>p.log(d,y)))}publicLog(d,h){this._log(d,3,h)}publicLog2(d,h){this.publicLog(d,h)}publicLogError(d,h){this._sendErrorTelemetry&&this._log(d,2,h)}publicLogError2(d,h){this.publicLogError(d,h)}};L.IDLE_START_EVENT_NAME="UserIdleStart",L.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=L=ve([te(1,w.IConfigurationService),te(2,D.IProductService)],L);function E(){const u=(0,N.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=R.isWeb?"":(0,N.localize)(3,null),y=(0,N.localize)(4,null),p=(0,N.localize)(5,null),P=(0,N.localize)(6,null),t=(0,N.localize)(7,null),o=`
|       | ${y} | ${p} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,N.localize)(8,null);return`
${u} ${d} ${h}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}I.Registry.as(f.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:E(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(f.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,N.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,N.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[145],re([0,1,171,142]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends O.AbstractOneDataSystemAppender{constructor(N,w,f,l){const D={sendPOST:(I,v)=>{const g={method:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data)}};try{const L=T.request(I.urlString,g,E=>{E.on("data",function(u){v(E.statusCode??200,E.headers,u.toString())}),E.on("error",function(u){v(0,{})})});L.write(I.data),L.end()}catch{v(0,{})}}};super(N,w,f,l,D)}}e.OneDataSystemAppender=R}),define(ne[146],re([0,1,15,22]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function R(A,N){const w=Object.create(null),f=(D,I)=>{const v=JSON.parse(D);w[I]=v};if(N){const D=[],I=await O.Promises.readdir(N);for(const g of I)try{(await O.Promises.stat((0,T.join)(N,g))).isDirectory()&&D.push(g)}catch{}const v=[];for(const g of D)(await O.Promises.readdir((0,T.join)(N,g))).filter(E=>E==="telemetry.json").length===1&&v.push(g);for(const g of v){const L=(await O.Promises.readFile((0,T.join)(N,g,"telemetry.json"))).toString();f(L,g)}}let l=(await O.Promises.readFile((0,T.join)(A,"telemetry-core.json"))).toString();return f(l,"vscode-core"),l=(await O.Promises.readFile((0,T.join)(A,"telemetry-extensions.json"))).toString(),f(l,"vscode-extensions"),JSON.stringify(w,null,4)}e.buildTelemetryMessage=R}),define(ne[147],re([0,1,12,80,25]),function(q,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(N,w){let f=N.getItem(R.machineIdKey);return(typeof f!="string"||T.isMacintosh&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,O.getMachineId)(w.error.bind(w))),f}e.resolveMachineId=A}),define(ne[27],re([0,1,10]),function(q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(ne[148],re([0,1,27,112,13,17,72,5,2]),function(q,e,T,O,R,A,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let D=e.UriIdentityService=class{constructor(v){this._fileService=v,this._dispooables=new f.DisposableStore,this._limit=2**16;const g=new Map,L=E=>{let u=g.get(E.scheme);return u===void 0&&(u=v.hasProvider(E)&&!this._fileService.hasCapability(E,1024),g.set(E.scheme,u)),u};this._dispooables.add(w.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(E=>{g.delete(E.scheme)})),this.extUri=new A.ExtUri(L),this._canonicalUris=new N.SkipList((E,u)=>this.extUri.compare(E,u,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,A.normalizePath)(v));const g=this._canonicalUris.get(v);return g?g.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new l(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((L,E)=>L[1].time<E[1].time?1:L[1].time>E[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let L=0;L<g;L++)this._canonicalUris.set(v[L][0],v[L][1].touch())}};e.UriIdentityService=D=ve([te(0,R.IFileService)],D),(0,O.registerSingleton)(T.IUriIdentityService,D,1)}),define(ne[149],re([0,1,105,15,55,17,11,10,16]),function(q,e,T,O,R,A,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function l(i){const r=i;return typeof r?.id=="string"&&N.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=l;function D(i){return typeof i?.id=="string"&&!l(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=I;function v(i){const r=i;return typeof r?.id=="string"&&N.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=v;function g(i){const r=i;if(r?.uri)return{id:r.id,uri:N.URI.revive(r.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:N.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var L;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(L||(e.WorkbenchState=L={}));function E(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=E;function u(i){const r=i;return!!(r&&typeof r=="object"&&N.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=u;class d{constructor(r,a,c,C,S){this._id=r,this._transient=c,this._configuration=C,this._ignorePathCasing=S,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=a}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(r,a){this.raw=a,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function y(i){return new h({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function P(i){let r;return N.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=P,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(i,r){return!p(i,r)&&!P(i)}e.isSavedWorkspace=o;function n(i){return(typeof i=="string"?(0,O.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ne[21],re([0,1,45,5,2,17,11,104,18,13,10,6,149,35,27,8,28,29,3]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function y(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&N.URI.isUri(i.location)&&N.URI.isUri(i.globalStorageHome)&&N.URI.isUri(i.settingsResource)&&N.URI.isUri(i.keybindingsResource)&&N.URI.isUri(i.tasksResource)&&N.URI.isUri(i.snippetsHome)&&N.URI.isUri(i.extensionsResource))}e.isUserDataProfile=y,e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function p(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:N.URI.revive(n.location).with({scheme:i}),globalStorageHome:N.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:N.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:N.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:N.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:N.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:N.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:N.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=p;function P(n,i,r,a,c){return{id:n,name:i,location:r,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(a,n),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=P;let t=e.UserDataProfilesService=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,a,c){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=a,this.logService=c,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=[];if(this.enabled)try{for(const C of this.getStoredProfiles()){if(!C.name||!(0,h.isString)(C.name)||!C.location){this.logService.warn("Skipping the invalid stored profile",C.location||C.name);continue}i.push(P((0,A.basename)(C.location),C.name,C.location,this.profilesCacheHome,{shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}))}}catch(C){this.logService.error(C)}const r=new g.ResourceMap,a=new Map,c=this.createDefaultProfile();if(i.unshift({...c,extensionsResource:this.getDefaultProfileExtensionsLocation()??c.extensionsResource,isDefault:!0}),i.length)try{const C=this.getStoredProfileAssociations();if(C.workspaces)for(const[S,m]of Object.entries(C.workspaces)){const x=N.URI.parse(S),X=i.find(K=>K.id===m);X&&r.set(x,X)}if(C.emptyWindows)for(const[S,m]of Object.entries(C.emptyWindows)){const x=i.find(X=>X.id===m);x&&a.set(S,x)}}catch(C){this.logService.error(C)}this._profilesObject={profiles:i,workspaces:r,emptyWindows:a}}return this._profilesObject}createDefaultProfile(){return P("__default__profile__",(0,w.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,d.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const S of this.profiles){const m=a.exec(S.name),x=m?parseInt(m[1]):0;c=x>c?x:c}const C=`${r} ${c+1}`;return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),C,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),i,r,a)}async createProfile(i,r,a,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const C=await this.doCreateProfile(i,r,a);return c&&await this.setProfileForWorkspace(c,C),C}async doCreateProfile(i,r,a){if(!(0,h.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.profileCreationPromises.get(r);return c||(c=(async()=>{try{const C=this.profiles.find(x=>x.name===r||x.id===i);if(C)return C;const S=P(i,r,(0,A.joinPath)(this.profilesHome,i),this.profilesCacheHome,a);await this.fileService.createFolder(S.location);const m=[];return this._onWillCreateProfile.fire({profile:S,join(x){m.push(x)}}),await E.Promises.settled(m),this.updateProfiles([S],[],[]),S}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,c)),c}async updateProfile(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(c=>c.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=P(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(c){a.push(c)}});try{await Promise.allSettled(a)}catch(c){this.logService.error(c)}for(const c of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(c)?.id&&this.profilesObject.emptyWindows.delete(c);for(const c of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(c){(0,l.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(c){this.logService.error(c)}}async setProfileForWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(c=>c.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return N.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,a){const c=[...this.profiles,...i],C=[];this.transientProfilesObject.profiles=[];for(let S of c)S.isDefault||r.some(m=>S.id===m.id)||(S=a.find(m=>S.id===m.id)??S,S.isTransient?this.transientProfilesObject.profiles.push(S):C.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.saveStoredProfiles(C),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,a)}triggerProfilesChanges(i,r,a){this._onDidChangeProfiles.fire({added:i,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const c=this.getWorkspace(i),C=a?this.transientProfilesObject:this.profilesObject;N.URI.isUri(c)?(C.workspaces.delete(c),r&&C.workspaces.set(c,r)):(C.emptyWindows.delete(c),r&&C.emptyWindows.set(c,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,c]of this.profilesObject.workspaces.entries())i[a.toString()]=c.id;const r={};for(const[a,c]of this.profilesObject.emptyWindows.entries())r[a.toString()]=c.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const r={},a=this.createDefaultProfile();if(i.workspaces)for(const[C,S]of Object.entries(i.workspaces)){const m=N.URI.parse(S);r[C]=this.uriIdentityService.extUri.isEqual(m,a.location)?a.id:this.uriIdentityService.extUri.basename(m)}const c={};if(i.emptyWindows)for(const[C,S]of Object.entries(i.emptyWindows)){const m=N.URI.parse(S);c[C]=this.uriIdentityService.extUri.isEqual(m,a.location)?a.id:this.uriIdentityService.extUri.basename(m)}return{workspaces:r,emptyWindows:c}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=t=ve([te(0,f.IEnvironmentService),te(1,l.IFileService),te(2,L.IUriIdentityService),te(3,I.ILogService)],t);class o extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=o}),define(ne[150],re([0,1,19,8,23,9,5,2,12,3,11,89,20,26,37,6,31,25,21]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=e.AbstractExtensionManagementService=class extends w.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,r,a,c,C){super(),this.galleryService=i,this.telemetryService=r,this.logService=a,this.productService=c,this.userDataProfilesService=C,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new N.Emitter),this._onDidInstallExtensions=this._register(new N.Emitter),this._onUninstallExtension=this._register(new N.Emitter),this._onDidUninstallExtension=this._register(new N.Emitter),this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(({task:S})=>S.cancel()),this.uninstallingExtensions.forEach(S=>S.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,v.isTargetPlatformCompatible)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.galleryService.isEnabled())throw new v.ExtensionManagementError(I.localize(0,null),v.ExtensionManagementErrorCode.Internal);const a=await this.checkAndGetCompatibleVersion(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(a.manifest,a.extension,r)}catch(a){throw t(this.telemetryService,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(i),error:a}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(a),P(a)}}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,r,a){const c=a.isApplicationScoped||a.isBuiltin||(0,L.isApplicationScopedExtension)(i),C={...a,installOnlyNewlyAddedFromExtensionPack:D.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},S=ue=>`${g.ExtensionKey.create(ue).toString()}${C.profileLocation?`-${C.profileLocation.toString()}`:""}`;if(!D.URI.isUri(r)){const ue=this.installingExtensions.get(S(r));if(ue)return this.logService.info("Extensions is already requested to install",r.identifier.id),ue.task.waitUntilTaskIsFinished()}const m=[],x=[],X=[],K=this.createInstallExtensionTask(i,r,C);D.URI.isUri(r)||this.installingExtensions.set(S(r),{task:K,waitingTasks:[]}),this._onInstallExtension.fire({identifier:K.identifier,source:r,profileLocation:C.profileLocation}),this.logService.info("Installing extension:",K.identifier.id),m.push({task:K,manifest:i});let ie=!1;try{if(C.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const Q=await this.getAllDepsAndPackExtensions(K.identifier,i,!!C.installOnlyNewlyAddedFromExtensionPack,!!C.installPreReleaseVersion,C.profileLocation),ce=await this.getInstalled(void 0,C.profileLocation);for(const{gallery:ae,manifest:se}of(0,T.distinct)(Q,({gallery:j})=>j.identifier.id)){ie=ie||!!se.extensionDependencies?.some(V=>(0,g.areSameExtensions)({id:V},K.identifier));const j=S(ae),B=this.installingExtensions.get(j);if(B){if(this.canWaitForTask(K,B.task)){const V=B.task.identifier;this.logService.info("Waiting for already requested installing extension",V.id,K.identifier.id),B.waitingTasks.push(K),x.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,M=>M.some($=>(0,g.areSameExtensions)($.identifier,V)))).then(M=>{if(this.logService.info("Finished waiting for already requested installing extension",V.id,K.identifier.id),!M.find(G=>(0,g.areSameExtensions)(G.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!ce.some(({identifier:V})=>(0,g.areSameExtensions)(V,ae.identifier))){const V=this.createInstallExtensionTask(se,ae,{...C,donotIncludePackAndDependencies:!0});this.installingExtensions.set(j,{task:V,waitingTasks:[K]}),this._onInstallExtension.fire({identifier:V.identifier,source:ae,profileLocation:C.profileLocation}),this.logService.info("Installing extension:",V.identifier.id,K.identifier.id),m.push({task:V,manifest:se})}}}catch(Q){if(D.URI.isUri(K.source))(0,T.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",K.identifier.id,Q.message),(0,T.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",K.identifier.id,Q.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),Q}const ue=m.reduce((Q,{task:ce,manifest:ae})=>(Q.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:ae}),Q),new Map);for(;ue.size;){let Q;const ce=[...ue.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(se=>ue.has(se.toLowerCase())));ce.length?Q=ue.size===1?ce:ce.filter(({task:ae})=>!(ae===K&&!ie)):(this.logService.info("Found extensions with circular dependencies",ce.map(({task:ae})=>ae.identifier.id)),Q=[...ue.values()]),await this.joinAllSettled(Q.map(async({task:ae})=>{const se=new Date().getTime();try{const j=await ae.run();if(await this.joinAllSettled(this.participants.map(B=>B.postInstall(j,ae.source,C,R.CancellationToken.None))),!D.URI.isUri(ae.source)){const B=ae.operation===3,V=B?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.telemetryService,B?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-se,durationSinceUpdate:V}),f.isWeb&&ae.operation!==3)try{await this.galleryService.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"install")}catch{}}X.push({local:j,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:C.context,profileLocation:ae.profileLocation,applicationScoped:j.isApplicationScoped})}catch(j){throw D.URI.isUri(ae.source)||t(this.telemetryService,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-se,error:j}),this.logService.error("Error while installing the extension:",ae.identifier.id),j}finally{ue.delete(ae.identifier.id.toLowerCase())}}))}return x.length&&await this.joinAllSettled(x),X.forEach(({identifier:Q})=>this.logService.info("Extension installed successfully:",Q.id)),this._onDidInstallExtensions.fire(X),X.filter(({identifier:Q})=>(0,g.areSameExtensions)(Q,K.identifier))[0].local}catch(ue){if(m.forEach(({task:Q})=>Q.cancel()),X.length)try{const Q=await Promise.allSettled(X.map(({local:ce})=>this.createUninstallExtensionTask(ce,{versionOnly:!0,profileLocation:C.profileLocation}).run()));for(let ce=0;ce<Q.length;ce++){const ae=Q[ce],{identifier:se}=X[ce];ae.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",se.id):this.logService.warn("Rollback: Error while uninstalling extension",se.id,(0,A.getErrorMessage)(ae.reason))}}catch(Q){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(Q),X.map(({identifier:ce})=>ce.id))}throw this._onDidInstallExtensions.fire(m.map(({task:Q})=>({identifier:Q.identifier,operation:2,source:Q.source,context:C.context,profileLocation:C.profileLocation}))),ue}finally{for(const{task:ue}of m)ue.source&&!D.URI.isUri(ue.source)&&this.installingExtensions.delete(S(ue.source))}}canWaitForTask(i,r){for(const[,{task:a,waitingTasks:c}]of this.installingExtensions.entries())if(a===i&&(c.includes(r)||c.some(C=>this.canWaitForTask(C,r)))||a===r&&c[0]&&!this.canWaitForTask(i,c[0]))return!1;return!0}async joinAllSettled(i){const r=[],a=[],c=await Promise.allSettled(i);for(const C of c)C.status==="fulfilled"?r.push(C.value):a.push(C.reason);if(a.length)throw p(a);return r}async getAllDepsAndPackExtensions(i,r,a,c,C){if(!this.galleryService.isEnabled())return[];const S=await this.getInstalled(void 0,C),m=[],x=[],X=async(K,ie)=>{m.push(K);const ue=ie.extensionDependencies||[],Q=[...ue];if(ie.extensionPack){const ce=a?S.find(ae=>(0,g.areSameExtensions)(ae.identifier,K)):void 0;for(const ae of ie.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(se=>(0,g.areSameExtensions)({id:se},{id:ae}))||Q.every(se=>!(0,g.areSameExtensions)({id:se},{id:ae}))&&Q.push(ae)}if(Q.length){const ce=Q.filter(ae=>m.every(se=>!(0,g.areSameExtensions)(se,{id:ae})));if(ce.length){const ae=await this.galleryService.getExtensions(ce.map(se=>({id:se,preRelease:c})),R.CancellationToken.None);for(const se of ae){if(m.find(V=>(0,g.areSameExtensions)(V,se.identifier)))continue;const j=ue.some(V=>(0,g.areSameExtensions)({id:V},se.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(se,!1,c)}catch(V){if(V instanceof v.ExtensionManagementError&&V.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!j){this.logService.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw V}x.push({gallery:B.extension,manifest:B.manifest}),await X(B.extension.identifier,B.manifest)}}}};return await X(i,r),x}async checkAndGetCompatibleVersion(i,r,a){if((await this.getExtensionsControlManifest()).malicious.some(m=>(0,g.areSameExtensions)(i.identifier,m)))throw new v.ExtensionManagementError(I.localize(1,null,i.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const m=await this.getTargetPlatform();throw new v.ExtensionManagementError(I.localize(2,null,i.identifier.id,this.productService.nameLong,(0,v.TargetPlatformToString)(m)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const C=await this.getCompatibleVersion(i,r,a);if(C){if(a&&!r&&i.hasPreReleaseVersion&&!C.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(I.localize(3,null,i.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],R.CancellationToken.None))[0]?new v.ExtensionManagementError(I.localize(4,null,i.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(I.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",C.identifier.id);const S=await this.galleryService.getManifest(C,R.CancellationToken.None);if(S===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(S.version!==C.version)throw new v.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:S}}async getCompatibleVersion(i,r,a){const c=await this.getTargetPlatform();let C=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(C=(await this.galleryService.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null),!C&&await this.galleryService.isExtensionCompatible(i,a,c)&&(C=i),C||(r?C=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null:C=await this.galleryService.getCompatibleExtension(i,a,c)),C}async uninstallExtension(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},c=K=>`${K.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,C=this.uninstallingExtensions.get(c(i.identifier));if(C)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),C.waitUntilTaskIsFinished();const S=K=>{const ie=this.createUninstallExtensionTask(K,a);return this.uninstallingExtensions.set(c(ie.extension.identifier),ie),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this._onUninstallExtension.fire({identifier:K.identifier,profileLocation:a.profileLocation,applicationScoped:K.isApplicationScoped}),ie},m=(K,ie)=>{ie?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,a.profileLocation.toString(),ie.message):this.logService.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,ie.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(K),error:ie}),this._onDidUninstallExtension.fire({identifier:K.identifier,error:ie?.code,profileLocation:a.profileLocation,applicationScoped:K.isApplicationScoped})},x=[],X=[];try{x.push(S(i));const K=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ie=this.getAllPackExtensionsToUninstall(i,K);for(const ue of ie)this.uninstallingExtensions.has(c(ue.identifier))?this.logService.info("Extensions is already requested to uninstall",ue.identifier.id):x.push(S(ue))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(x.map(ie=>ie.extension),K,i),await this.joinAllSettled(x.map(async ie=>{try{if(await ie.run(),await this.joinAllSettled(this.participants.map(ue=>ue.postUninstall(ie.extension,a,R.CancellationToken.None))),ie.extension.identifier.uuid)try{await this.galleryService.reportStatistic(ie.extension.manifest.publisher,ie.extension.manifest.name,ie.extension.manifest.version,"uninstall")}catch{}m(ie.extension)}catch(ue){const Q=ue instanceof v.ExtensionManagementError?ue:new v.ExtensionManagementError((0,A.getErrorMessage)(ue),v.ExtensionManagementErrorCode.Internal);throw m(ie.extension,Q),Q}finally{X.push(ie)}}))}catch(K){const ie=K instanceof v.ExtensionManagementError?K:new v.ExtensionManagementError((0,A.getErrorMessage)(K),v.ExtensionManagementErrorCode.Internal);for(const ue of x){try{ue.cancel()}catch{}X.includes(ue)||m(ue.extension,ie)}throw ie}finally{for(const K of x)this.uninstallingExtensions.delete(c(K.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}checkForDependents(i,r,a){for(const c of i){const C=this.getDependents(c,r);if(C.length){const S=C.filter(m=>!i.some(x=>(0,g.areSameExtensions)(x.identifier,m.identifier)));if(S.length)throw new Error(this.getDependentsErrorMessage(c,S,a))}}}getDependentsErrorMessage(i,r,a){return a===i?r.length===1?I.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const C=r.filter(m=>!m.isBuiltin&&c.some(x=>(0,g.areSameExtensions)({id:x},m.identifier))),S=[];for(const m of C)S.push(...this.getAllPackExtensionsToUninstall(m,r,a));return[...C,...S]}return[]}getDependents(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(c=>(0,g.areSameExtensions)({id:c},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=y=ve([te(0,v.IExtensionGalleryService),te(1,d.ITelemetryService),te(2,E.ILogService),te(3,u.IProductService),te(4,h.IUserDataProfilesService)],y);function p(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=p;function P(n){if(n instanceof v.ExtensionManagementError)return n;const i=new v.ExtensionManagementError(n.message,v.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:r,verificationStatus:a,duration:c,error:C,durationSinceUpdate:S}){let m,x;(0,l.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(m=v.ExtensionManagementErrorCode.Signature,x=a),a="Unverified")),C&&(C instanceof v.ExtensionManagementError?(m=C.code,C.code===v.ExtensionManagementErrorCode.Signature&&(x=C.message)):m=v.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:a,success:!C,duration:c,errorcode:m,errorcodeDetail:x,durationSinceUpdate:S})}class o{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>new Promise((r,a)=>{const c=i.onCancellationRequested(()=>{c.dispose(),a(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=o}),define(ne[40],re([0,1,8,14,2,5,35,11,20,26,13,10,6,21,27,3,9,25]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class y extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=y,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let p=e.AbstractExtensionsProfileScannerService=class extends R.Disposable{constructor(n,i,r,a,c,C){super(),this.extensionsLocation=n,this.fileService=i,this.userDataProfilesService=r,this.uriIdentityService=a,this.telemetryService=c,this.logService=C,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new N.ResourceMap}scanProfileExtensions(n,i){return this.withProfileExtensions(n,void 0,i)}async addExtensionsToProfile(n,i){const r=[],a=[];try{return await this.withProfileExtensions(i,c=>{const C=[];for(const S of c)n.some(([m])=>(0,l.areSameExtensions)(m.identifier,S.identifier)&&m.manifest.version!==S.version)?r.push(S):C.push(S);for(const[S,m]of n)if(!C.some(x=>(0,l.areSameExtensions)(x.identifier,S.identifier)&&x.version===S.manifest.version)){const x={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:m};a.push(x),C.push(x)}return a.length&&this._onAddExtensions.fire({extensions:a,profileLocation:i}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),C}),a.length&&this._onDidAddExtensions.fire({extensions:a,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i}),a}catch(c){throw a.length&&this._onDidAddExtensions.fire({extensions:a,error:c,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:c,profileLocation:i}),c}}async updateMetadata(n,i){const r=[];return await this.withProfileExtensions(i,a=>{const c=[];for(const C of a){const S=n.find(([m])=>(0,l.areSameExtensions)(m.identifier,C.identifier)&&m.manifest.version===C.version);S&&(C.metadata={...C.metadata,...S[1]},r.push(C)),c.push(C)}return c}),r}async removeExtensionFromProfile(n,i){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:i});try{await this.withProfileExtensions(i,a=>{const c=[];for(const C of a)(0,l.areSameExtensions)(C.identifier,n.identifier)?r.push(C):c.push(C);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),c}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i})}catch(a){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:a,profileLocation:i}),a}}async withProfileExtensions(n,i,r){return this.getResourceAccessQueue(n).queue(async()=>{let a=[],c;try{const C=await this.fileService.readFile(n);c=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,D.toFileOperationResult)(C)!==1)throw C;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&r?.bailOutWhenFileNotFound)throw new y((0,u.getErrorMessage)(C),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(n);let C=!1;for(const S of c){P(S)||this.reportAndThrowInvalidConentError(n);let m;if((0,E.isString)(S.relativeLocation)&&S.relativeLocation)m=this.resolveExtensionLocation(S.relativeLocation);else if((0,E.isString)(S.location))m=this.resolveExtensionLocation(S.location),C=!0,S.relativeLocation=S.location,S.location=m.toJSON();else{m=w.URI.revive(S.location);const x=this.toRelativePath(m);x&&(C=!0,S.relativeLocation=x)}a.push({identifier:S.identifier,location:m,version:S.version,metadata:S.metadata})}C&&await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(c)))}if(i){a=i(a);const C=a.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.toRelativePath(S.location),metadata:S.metadata}));await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(C)))}return a})}reportAndThrowInvalidConentError(n){const i=new y(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(n)).value.toString()}catch(c){if((0,D.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",n.toString());let a;try{const c=JSON.parse(r);Array.isArray(c)&&c.every(C=>P(C))?a=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(a)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,D.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(n)}catch(c){(0,D.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(i)}catch(c){(0,D.toFileOperationResult)(c)!==1&&this.logService.error(c)}return a})()),this._migrationPromise}getResourceAccessQueue(n){let i=this.resourcesAccessQueueMap.get(n);return i||(i=new T.Queue,this.resourcesAccessQueueMap.set(n,i)),i}};e.AbstractExtensionsProfileScannerService=p=ve([te(1,D.IFileService),te(2,g.IUserDataProfilesService),te(3,L.IUriIdentityService),te(4,d.ITelemetryService),te(5,v.ILogService)],p);function P(o){return(0,E.isObject)(o)&&(0,f.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,E.isString)(o.location)&&o.location)&&((0,E.isUndefined)(o.relativeLocation)||(0,E.isString)(o.relativeLocation))&&o.version&&(0,E.isString)(o.version)}function t(o){return o?(0,E.isString)(o.path)&&(0,E.isString)(o.scheme):!1}}),define(ne[49],re([0,1,19,8,30,14,9,52,78,2,16,15,12,17,41,54,3,11,93,18,26,37,47,13,10,6,31,5,46,40,21,27,110]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h,y,p,P,t,o,n,i,r,a,c,C,S,m,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(se){function j(B,V){if(B===V)return!0;const M=Object.keys(B),$=new Set;for(const G of Object.keys(V))$.add(G);if(M.length!==$.size)return!1;for(const G of M){if(B[G]!==V[G])return!1;$.delete(G)}return $.size===0}se.equals=j})(X||(e.Translations=X={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let K=e.AbstractExtensionsScannerService=class extends l.Disposable{constructor(j,B,V,M,$,G,Y,F,U,k,s,b){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=B,this.extensionsControlLocation=V,this.currentProfile=M,this.userDataProfilesService=$,this.extensionsProfileScannerService=G,this.fileService=Y,this.logService=F,this.environmentService=U,this.productService=k,this.uriIdentityService=s,this.instantiationService=b,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Q,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Q,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ue,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,B,V){const[M,$]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(B)]),G=V?await this.scanExtensionsUnderDevelopment(j,[...M,...$]):[];return this.dedupExtensions(M,$,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const B=[];B.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),B.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[V,M]=await Promise.all(B);return this.applyScanOptions([...V,...M],0,j,!1)}async scanUserExtensions(j){const B=j.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",B);const V=this.uriIdentityService.extUri.isEqual(j.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.createExtensionScannerInput(B,!!j.profileLocation,1,!j.includeUninstalled,j.language,!0,V),$=j.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let G;try{G=await $.scanExtensions(M)}catch(Y){if(Y instanceof C.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),G=await $.scanExtensions(M);else throw Y}return G=await this.applyScanOptions(G,1,j,!0),this.logService.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(j,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(M=>M.scheme===D.Schemas.file).map(async M=>{const $=await this.createExtensionScannerInput(M,!1,1,!0,j.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(Y=>(Y.type=B.find(F=>(0,p.areSameExtensions)(F.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,$)))}))).flat();return this.applyScanOptions(V,"development",j,!0)}return[]}async scanExistingExtension(j,B,V){const M=await this.createExtensionScannerInput(j,!1,B,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanExtension(M);return!$||!V.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(j,B,V){const M=await this.createExtensionScannerInput(j,!1,B,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanOneOrMultipleExtensions(M);return this.applyScanOptions($,B,V,!0)}async scanMetadata(j){const B=(0,g.joinPath)(j,"package.json"),V=(await this.fileService.readFile(B)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(j,B){const V=(0,g.joinPath)(j,"package.json"),M=(await this.fileService.readFile(V)).value.toString(),$=JSON.parse(M);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,$.__metadata={...$.__metadata,...B},await this.fileService.writeFile((0,g.joinPath)(j,"package.json"),A.VSBuffer.fromString(JSON.stringify($,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(j){if(j instanceof C.ExtensionsProfileScanningError&&j.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw j}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});if(j.length)await this.extensionsProfileScannerService.addExtensionsToProfile(j.map(B=>[B,B.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,o.toFileOperationResult)(B)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(B))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(j){this.logService.error(j)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(j,B,V,M){return V.includeAllVersions||(j=this.dedupExtensions(B===0?j:void 0,B===1?j:void 0,B==="development"?j:void 0,await this.getTargetPlatform(),M)),V.includeInvalid||(j=j.filter($=>$.isValid)),j.sort(($,G)=>{const Y=I.basename($.location.fsPath),F=I.basename(G.location.fsPath);return Y<F?-1:Y>F?1:0})}dedupExtensions(j,B,V,M,$){const G=(F,U,k)=>{if(F.isValid&&!U.isValid)return!1;if(F.isValid===U.isValid){if($&&L.gt(F.manifest.version,U.manifest.version))return this.logService.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(L.eq(F.manifest.version,U.manifest.version)){if(F.type===0)return this.logService.debug(`Skipping extension ${U.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===M)return this.logService.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return k?this.logService.warn(`Overwriting user extension ${F.location.path} with ${U.location.path}.`):this.logService.debug(`Overwriting user extension ${F.location.path} with ${U.location.path}.`),!0},Y=new P.ExtensionIdentifierMap;return j?.forEach(F=>{const U=Y.get(F.identifier.id);(!U||G(U,F,!1))&&Y.set(F.identifier.id,F)}),B?.forEach(F=>{const U=Y.get(F.identifier.id);if(!U&&j&&F.type===0){this.logService.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!U||G(U,F,!1))&&Y.set(F.identifier.id,F)}),V?.forEach(F=>{const U=Y.get(F.identifier.id);(!U||G(U,F,!0))&&Y.set(F.identifier.id,F),Y.set(F.identifier.id,F)}),[...Y.values()]}async scanDefaultSystemExtensions(j,B){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),$=await(j&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(j,B){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const M=B?await this.getBuiltInExtensionControl():{},$=[],G=d.URI.file(I.normalize(I.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of V){const U=M[F.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":$.push((0,g.joinPath)(G,F.name));break;default:$.push(d.URI.file(U));break}}const Y=await Promise.all($.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,!1,0,!0,j,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,T.coalesce)(Y)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,B,V,M,$,G,Y){const F=await this.getTranslations($??v.language),U=await this.getMtime(j),k=B&&!this.uriIdentityService.extUri.isEqual(j,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,s=k?await this.getMtime(k):void 0;return new ie(j,U,k,s,B,Y,V,M,G,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,F)}async getMtime(j){try{const B=await this.fileService.stat(j);if(typeof B.mtime=="number")return B.mtime}catch{}}};e.AbstractExtensionsScannerService=K=ve([te(4,S.IUserDataProfilesService),te(5,C.IExtensionsProfileScannerService),te(6,o.IFileService),te(7,i.ILogService),te(8,y.IEnvironmentService),te(9,r.IProductService),te(10,m.IUriIdentityService),te(11,n.IInstantiationService)],K);class ie{constructor(j,B,V,M,$,G,Y,F,U,k,s,b,_,W,H){this.location=j,this.mtime=B,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=M,this.profile=$,this.profileScanOptions=G,this.type=Y,this.excludeObsolete=F,this.validate=U,this.productVersion=k,this.productDate=s,this.productCommit=b,this.devMode=_,this.language=W,this.translations=H}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,B){return(0,g.isEqual)(j.location,B.location)&&j.mtime===B.mtime&&(0,g.isEqual)(j.applicationExtensionslocation,B.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&j.profile===B.profile&&R.equals(j.profileScanOptions,B.profileScanOptions)&&j.type===B.type&&j.excludeObsolete===B.excludeObsolete&&j.validate===B.validate&&j.productVersion===B.productVersion&&j.productDate===B.productDate&&j.productCommit===B.productCommit&&j.devMode===B.devMode&&j.language===B.language&&X.equals(j.translations,B.translations)}}e.ExtensionScannerInput=ie;let ue=class extends l.Disposable{constructor(j,B,V,M,$){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=B,this.uriIdentityService=V,this.fileService=M,this.logService=$}async scanExtensions(j){const B=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let V={};if(j.excludeObsolete&&j.type===1)try{const M=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(M)}catch{}return(0,u.isEmptyObject)(V)?B:B.filter(M=>!V[p.ExtensionKey.create(M).toString()])}async scanExtensionsFromLocation(j){const B=await this.fileService.resolve(j.location);if(!B.children?.length)return[];const V=await Promise.all(B.children.map(async M=>{if(!M.isDirectory||j.type===1&&(0,g.basename)(M.resource).indexOf(".")===0)return null;const $=new ie(M.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension($)}));return(0,T.coalesce)(V).sort((M,$)=>M.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(j){let B=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){B=B.filter(M=>!M.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,j);B.push(...V)}return B}async scanExtensionsFromProfileResource(j,B,V){const M=await this.extensionsProfileScannerService.scanProfileExtensions(j,V.profileScanOptions);if(!M.length)return[];const $=await Promise.all(M.map(async G=>{if(B(G)){const Y=new ie(G.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(Y,G.metadata)}return null}));return(0,T.coalesce)($)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,g.joinPath)(j.location,"package.json"))){const B=await this.scanExtension(j);return B?[B]:[]}else return await this.scanExtensions(j)}catch(B){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,N.getErrorMessage)(B)),[]}}async scanExtension(j,B){try{let V=await this.scanExtensionManifest(j.location);if(V){V.publisher||(V.publisher=P.UNDEFINED_PUBLISHER),B=B??V.__metadata,delete V.__metadata;const M=(0,p.getGalleryExtensionId)(V.publisher,V.name),$=B?.id?{id:M,uuid:B.id}:{id:M},G=B?.isSystem?0:j.type,Y=G===0||!!B?.isBuiltin;V=await this.translateManifest(j.location,V,ie.createNlsConfiguration(j));const F={type:G,identifier:$,manifest:V,location:j.location,isBuiltin:Y,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return j.validate?this.validate(F,j):F}}catch(V){j.type!==0&&this.logService.error(V)}return null}validate(j,B){let V=!0;const M=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,j.manifest,j.isBuiltin);for(const[$,G]of M)$===E.default.Error&&(V=!1,this.logService.error(this.formatMessage(B.location,G)));return j.isValid=V,j.validations=M,j}async scanExtensionManifest(j){const B=(0,g.joinPath)(j,"package.json");let V;try{V=(await this.fileService.readFile(B)).value.toString()}catch($){return(0,o.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(j,(0,h.localize)(0,null,B.path,$.message))),null}let M;try{M=JSON.parse(V)}catch{const G=[];(0,w.parse)(V,G);for(const Y of G)this.logService.error(this.formatMessage(j,(0,h.localize)(1,null,B.path,Y.offset,Y.length,(0,f.getParseErrorMessage)(Y.error))));return null}return(0,w.getNodeType)(M)!=="object"?(this.logService.error(this.formatMessage(j,(0,h.localize)(2,null,B.path))),null):M}async translateManifest(j,B,V){const M=await this.getLocalizedMessages(j,B,V);if(M)try{const $=[],G=await this.resolveOriginalMessageBundle(M.default,$);if($.length>0)return $.forEach(F=>{this.logService.error(this.formatMessage(j,(0,h.localize)(3,null,M.default?.path,(0,f.getParseErrorMessage)(F.error))))}),B;if((0,w.getNodeType)(M)!=="object")return this.logService.error(this.formatMessage(j,(0,h.localize)(4,null,M.default?.path))),B;const Y=M.values||Object.create(null);return(0,x.localizeManifest)(B,Y,G)}catch{}return B}async getLocalizedMessages(j,B,V){const M=(0,g.joinPath)(j,"package.nls.json"),$=(U,k)=>{k.forEach(s=>{this.logService.error(this.formatMessage(j,(0,h.localize)(5,null,U?.path,(0,f.getParseErrorMessage)(s.error))))})},G=U=>{this.logService.error(this.formatMessage(j,(0,h.localize)(6,null,U?.path)))},Y=`${B.publisher}.${B.name}`,F=V.translations[Y];if(F)try{const U=d.URI.file(F),k=(await this.fileService.readFile(U)).value.toString(),s=[],b=(0,w.parse)(k,s);return s.length>0?($(U,s),{values:void 0,default:M}):(0,w.getNodeType)(b)!=="object"?(G(U),{values:void 0,default:M}):{values:b.contents?b.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.fileService.exists(M))return;let k;try{k=await this.findMessageBundles(j,V)}catch{return}if(!k.localized)return{values:void 0,default:k.original};try{const s=(await this.fileService.readFile(k.localized)).value.toString(),b=[],_=(0,w.parse)(s,b);return b.length>0?($(k.localized,b),{values:void 0,default:k.original}):(0,w.getNodeType)(_)!=="object"?(G(k.localized),{values:void 0,default:k.original}):{values:_,default:k.original}}catch{return{values:void 0,default:k.original}}}}async resolveOriginalMessageBundle(j,B){if(j)try{const V=(await this.fileService.readFile(j)).value.toString();return(0,w.parse)(V,B)}catch{}}findMessageBundles(j,B){return new Promise((V,M)=>{const $=G=>{const Y=(0,g.joinPath)(j,`package.nls.${G}.json`);this.fileService.exists(Y).then(F=>{F&&V({localized:Y,original:(0,g.joinPath)(j,"package.nls.json")});const U=G.lastIndexOf("-");U===-1?V({localized:(0,g.joinPath)(j,"package.nls.json"),original:null}):(G=G.substring(0,U),$(G))})};if(B.devMode||B.pseudo||!B.language)return V({localized:(0,g.joinPath)(j,"package.nls.json"),original:null});$(B.language)})}formatMessage(j,B){return`[${j.path}]: ${B}`}};ue=ve([te(1,C.IExtensionsProfileScannerService),te(2,m.IUriIdentityService),te(3,o.IFileService),te(4,i.ILogService)],ue);let Q=class extends ue{constructor(j,B,V,M,$,G,Y){super(B,M,$,G,Y),this.currentProfile=j,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const B=this.getCacheFile(j),V=await this.readExtensionCache(B);if(this.input=j,V&&V.input&&ie.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",j.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map($=>($.location=d.URI.revive($.location),$));const M=await super.scanExtensions(j);return await this.writeExtensionCache(B,{input:j,result:M}),M}async readExtensionCache(j){try{const B=await this.fileService.readFile(j),V=JSON.parse(B.value.toString());return{result:V.result,input:(0,c.revive)(V.input)}}catch(B){this.logService.debug("Error while reading the extension cache file:",j.path,(0,N.getErrorMessage)(B))}return null}async writeExtensionCache(j,B){try{await this.fileService.writeFile(j,A.VSBuffer.fromString(JSON.stringify(B)))}catch(V){this.logService.debug("Error while writing the extension cache file:",j.path,(0,N.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const j=this.getCacheFile(this.input),B=await this.readExtensionCache(j);if(!B)return;const V=B.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(M,V))try{this.logService.info("Invalidating Cache",V,M),await this.fileService.del(j),this._onDidChangeCache.fire()}catch($){this.logService.error($)}}getCacheFile(j){const B=this.getProfile(j);return this.uriIdentityService.extUri.joinPath(B.cacheHome,j.type===0?P.BUILTIN_MANIFEST_CACHE_FILE:P.USER_MANIFEST_CACHE_FILE)}getProfile(j){return j.type===0?this.userDataProfilesService.defaultProfile:j.profile?this.uriIdentityService.extUri.isEqual(j.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(B=>this.uriIdentityService.extUri.isEqual(j.location,B.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};Q=ve([te(2,S.IUserDataProfilesService),te(3,C.IExtensionsProfileScannerService),te(4,m.IUriIdentityService),te(5,o.IFileService),te(6,i.ILogService)],Q);function ce(se,j){const B=(0,p.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:B,identifier:new P.ExtensionIdentifier(B),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:j,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=ce;class ae extends K{constructor(j,B,V,M,$,G,Y,F,U,k,s,b){super(j,B,(0,g.joinPath)(V,".vscode-oss-dev","extensions","control.json"),M,$,G,Y,F,U,k,s,b),this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const _=await this.fileService.readFile(d.URI.file(v.translationsConfigFile));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=ae}),define(ne[151],re([0,1,58,8,33,5,2,16,15,22,6,21]),function(q,e,T,O,R,A,N,w,f,l,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=e.ExtensionsLifecycle=class extends N.Disposable{constructor(L,E){super(),this.userDataProfilesService=L,this.logService=E,this.processesLimiter=new O.Limiter(5)}async postUninstall(L){const E=this.parseScript(L,"uninstall");E&&(this.logService.info(L.identifier.id,L.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(E.script,"uninstall",E.args,!0,L),this.logService.info("Finished running post uninstall script",L.identifier.id,L.manifest.version)}catch(u){this.logService.error("Failed to run post uninstall script",L.identifier.id,L.manifest.version),this.logService.error(u)}}));try{await l.Promises.rm(this.getExtensionStoragePath(L))}catch(u){this.logService.error("Error while removing extension storage path",L.identifier.id),this.logService.error(u)}}parseScript(L,E){const u=`vscode:${E}`;if(L.location.scheme===w.Schemas.file&&L.manifest&&L.manifest.scripts&&typeof L.manifest.scripts[u]=="string"){const d=L.manifest.scripts[u].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(L.identifier.id,L.manifest.version,`${u} should be a node script`),null):{script:(0,f.join)(L.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(L,E,u,d,h){return new Promise((y,p)=>{const P=this.start(L,E,u,h);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?p(n):y(void 0)};P.on("error",n=>{o((0,R.toErrorMessage)(n)||"Unknown")}),P.on("exit",(n,i)=>{o(n?`post-${E} process exited with code ${n}`:void 0)}),d&&(t=setTimeout(()=>{t=null,P.kill(),p("timed out")},5e3))})}start(L,E,u,d){const h={silent:!0,execArgv:void 0},y=(0,T.fork)(L,[`--type=extension-post-${E}`,...u],h);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(y.stdout,"data"),P=A.Event.fromNodeEventEmitter(y.stderr,"data");p(n=>this.logService.info(d.identifier.id,d.manifest.version,`post-${E}`,n)),P(n=>this.logService.error(d.identifier.id,d.manifest.version,`post-${E}`,n));const t=A.Event.any(A.Event.map(p,n=>({data:`%c${n}`,format:[""]})),A.Event.map(P,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),y}getExtensionStoragePath(L){return(0,f.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,L.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=v=ve([te(0,I.IUserDataProfilesService),te(1,D.ILogService)],v)}),define(ne[152],re([0,1,6,21,27,25,40,13,18,11]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let D=e.ExtensionsProfileScannerService=class extends N.AbstractExtensionsProfileScannerService{constructor(v,g,L,E,u,d){super(l.URI.file(v.extensionsPath),g,L,E,u,d)}};e.ExtensionsProfileScannerService=D=ve([te(0,f.INativeEnvironmentService),te(1,w.IFileService),te(2,O.IUserDataProfilesService),te(3,R.IUriIdentityService),te(4,A.ITelemetryService),te(5,T.ILogService)],D)}),define(ne[153],re([0,1,11,18,40,49,13,10,6,31,27,21]),function(q,e,T,O,R,A,N,w,f,l,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=e.ExtensionsScannerService=class extends A.NativeExtensionsScannerService{constructor(L,E,u,d,h,y,p,P){super(T.URI.file(h.builtinExtensionsPath),T.URI.file(h.extensionsPath),h.userHome,L.defaultProfile,L,E,u,d,h,y,p,P)}};e.ExtensionsScannerService=v=ve([te(0,I.IUserDataProfilesService),te(1,R.IExtensionsProfileScannerService),te(2,N.IFileService),te(3,f.ILogService),te(4,O.INativeEnvironmentService),te(5,l.IProductService),te(6,D.IUriIdentityService),te(7,w.IInstantiationService)],v)}),define(ne[154],re([0,1,8,5,2,121,3,84,10,21]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var D;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var I;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var v;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function g(h){const y=h.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=g;class L extends R.Disposable{constructor(y={flushInterval:L.DEFAULT_FLUSH_INTERVAL}){super(),this.options=y,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,p){if(p===e.TARGET_KEY){switch(y){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:y})}else this._onDidChangeValue.fire({scope:y,key:p,target:this.getKeyTargets(y)[p]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,p,P){return this.getStorage(p)?.get(y,P)}getBoolean(y,p,P){return this.getStorage(p)?.getBoolean(y,P)}getNumber(y,p,P){return this.getStorage(p)?.getNumber(y,P)}getObject(y,p,P){return this.getStorage(p)?.getObject(y,P)}store(y,p,P,t){if((0,N.isUndefinedOrNull)(p)){this.remove(y,P);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,P,t),this.getStorage(P)?.set(y,p)})}remove(y,p){this.withPausedEmitters(()=>{this.updateKeyTarget(y,p,void 0),this.getStorage(p)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,p){const P=[],t=this.getKeyTargets(y);for(const o of Object.keys(t))t[o]===p&&P.push(o);return P}updateKeyTarget(y,p,P){const t=this.getKeyTargets(p);typeof P=="number"?t[y]!==P&&(t[y]=P,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[y]=="number"&&(delete t[y],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(y){switch(y){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(y){const p=this.getStorage(y);return p?g(p):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=D.NONE){this._onWillSaveState.fire({reason:y});const p=this.getStorage(-1),P=this.getStorage(0),t=this.getStorage(1);switch(y){case D.NONE:await T.Promises.settled([p?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await T.Promises.settled([p?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return d(y,p,P,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(y,p){return this.emitWillSaveState(D.NONE),(0,l.isUserDataProfile)(y)?this.switchToProfile(y,p):this.switchToWorkspace(y,p)}canSwitchProfile(y,p){return!(y.id===p.id||E(p)&&E(y))}switchData(y,p,P,t){this.withPausedEmitters(()=>{if(t)for(const[o,n]of y)p.set(o,n);else{const o=new Set;for(const[n,i]of y)o.add(n),p.get(n)!==i&&this.emitDidChangeValue(P,n);for(const[n]of p.items)o.has(n)||this.emitDidChangeValue(P,n)}})}}e.AbstractStorageService=L,L.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class u extends L{constructor(){super(),this.applicationStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.profileStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y))),this._register(this.applicationStorage.onDidChangeStorage(y=>this.emitDidChangeValue(-1,y)))}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(y){return!1}}e.InMemoryStorageService=u;async function d(h,y,p,P,t,o){const n=X=>{try{return JSON.parse(X)}catch{return X}},i=new Map,r=new Map;h.forEach((X,K)=>{i.set(K,X),r.set(K,n(X))});const a=new Map,c=new Map;y.forEach((X,K)=>{a.set(K,X),c.set(K,n(X))});const C=new Map,S=new Map;p.forEach((X,K)=>{C.set(K,X),S.set(K,n(X))}),console.group(P!==t?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const m=[];if(i.forEach((X,K)=>{m.push({key:K,value:X})}),console.table(m),console.groupEnd(),console.log(r),P!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const X=[];a.forEach((K,ie)=>{X.push({key:ie,value:K})}),console.table(X),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${o})`);const x=[];C.forEach((X,K)=>{x.push({key:K,value:X})}),console.table(x),console.groupEnd(),console.log(S)}e.logStorage=d}),define(ne[155],re([0,1,19,23,9,12,34,3,11,24,18,20,26,47,13,6,31,43,140,154,25]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const P=A.isWeb?"web":(0,I.getTargetPlatform)(A.platform,N.arch),t="X-Market-Search-Activity-Id";var o;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...k){return String(k.reduce((s,b)=>s|b,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},C={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class S{constructor(s=C){this.state=s}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(s,b=this.state.pageSize){return new S({...this.state,pageNumber:s,pageSize:b})}withFilter(s,...b){const _=[...this.state.criteria,...b.length?b.map(W=>({filterType:s,value:W})):[{filterType:s}]];return new S({...this.state,criteria:_})}withSortBy(s){return new S({...this.state,sortBy:s})}withSortOrder(s){return new S({...this.state,sortOrder:s})}withFlags(...s){return new S({...this.state,flags:s.reduce((b,_)=>b|_,0)})}withAssetTypes(...s){return new S({...this.state,assetTypes:s})}withSource(s){return new S({...this.state,source:s})}get raw(){const{criteria:s,pageNumber:b,pageSize:_,sortBy:W,sortOrder:H,flags:Z,assetTypes:le}=this.state;return{filters:[{criteria:s,pageNumber:b,pageSize:_,sortBy:W,sortOrder:H}],assetTypes:le,flags:Z}}get searchText(){const s=this.state.criteria.filter(b=>b.filterType===i.SearchText)[0];return s&&s.value?s.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(s=>String(s.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function m(k,s){const b=(k||[]).filter(_=>_.statisticName===s)[0];return b?b.value:0}function x(k){const s="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(_=>_.assetType.indexOf(s)===0).reduce((_,W)=>{const H=ie(k,W.assetType);return H&&_.push([W.assetType.substring(s.length),H]),_},[])}function X(k){if(k.properties){const s=k.properties.filter(W=>W.key===r.Repository),b=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=s.filter(W=>b.test(W.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return ie(k,r.Repository)}function K(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function ie(k,s){return k.files.filter(_=>_.assetType===s)[0]?{uri:`${k.assetUri}/${s}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${s}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function ue(k,s){const b=k.properties?k.properties.filter(W=>W.key===s):[],_=b.length>0&&b[0].value;return _?_.split(",").map(W=>(0,v.adoptToGalleryExtensionId)(W)):[]}function Q(k){const s=k.properties?k.properties.filter(b=>b.key===a.Engine):[];return s.length>0&&s[0].value||""}function ce(k){const s=k.properties?k.properties.filter(b=>b.key===a.PreRelease):[];return s.length>0&&s[0].value==="true"}function ae(k){const s=k.properties?k.properties.filter(_=>_.key===a.LocalizedLanguages):[],b=s.length>0&&s[0].value||"";return b?b.split(","):[]}function se(k){return k.properties?.find(s=>s.key===a.SponsorLink)?.value}function j(k){return k.indexOf("preview")!==-1}function B(k){return k.targetPlatform?(0,I.toTargetPlatform)(k.targetPlatform):"undefined"}function V(k){const s=(0,T.distinct)(k.versions.map(B)),b=!!k.tags?.includes(I.WEB_EXTENSION_TAG),_=s.indexOf("web");return b?_===-1&&s.push("web"):_!==-1&&s.splice(_,1),s}function M(k,s){const b=(0,I.getFallbackTargetPlarforms)(s);for(let _=0;_<k.length;_++){const W=k[_];if(W.version===k[_-1]?.version){let H=_;const Z=B(W);if(Z===s)for(;H>0&&k[H-1].version===W.version;)H--;else if(b.includes(Z))for(;H>0&&k[H-1].version===W.version&&B(k[H-1])!==s;)H--;H!==_&&(k.splice(_,1),k.splice(H,0,W))}}return k}e.sortExtensionVersions=M;function $(k,s,b){k.telemetryData={index:s,querySource:b,queryActivityId:k.queryContext?.[t]}}function G(k,s,b,_){const W=k.versions[0],H={manifest:ie(s,r.Manifest),readme:ie(s,r.Details),changelog:ie(s,r.Changelog),license:ie(s,r.License),repository:X(s),download:K(s),icon:ie(s,r.Icon),signature:ie(s,r.Signature),coreTranslations:x(s)};return{identifier:{id:(0,v.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:s.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(W),description:k.shortDescription||"",installCount:m(k.statistics,"install"),rating:m(k.statistics,"averagerating"),ratingCount:m(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:b,assets:H,properties:{dependencies:ue(s,a.Dependency),extensionPack:ue(s,a.ExtensionPack),engine:Q(s),localizedLanguages:ae(s),targetPlatform:B(s),isPreReleaseVersion:ce(s)},hasPreReleaseVersion:ce(W),hasReleaseVersion:!0,preview:j(k.flags),isSigned:!!H.signature,queryContext:_}}let Y=class{constructor(s,b,_,W,H,Z,le,de){this.requestService=b,this.logService=_,this.environmentService=W,this.telemetryService=H,this.fileService=Z,this.productService=le,this.configurationService=de;const pe=le.extensionsGallery,fe=pe?.servicePPEUrl&&de.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=fe?pe.servicePPEUrl:pe?.serviceUrl,this.extensionsGallerySearchUrl=fe?void 0:pe?.searchUrl,this.extensionsControlUrl=pe?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,s,this.telemetryService)}api(s=""){return`${this.extensionsGalleryUrl}${s}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(s,b,_){const W=O.CancellationToken.isCancellationToken(b)?{}:b,H=O.CancellationToken.isCancellationToken(b)?b:_,Z=[],le=[],de=[],pe=[];let fe=!0;for(const he of s){he.uuid?le.push(he.uuid):Z.push(he.id);const Ee=!!(he.version||he.preRelease);de.push({id:he.id,uuid:he.uuid,includePreRelease:Ee}),he.version&&pe.push({id:he.id,uuid:he.uuid,version:he.version}),fe=fe&&!!he.hasPreRelease&&!Ee}if(!le.length&&!Z.length)return[];let ge=new S().withPage(1,s.length);le.length&&(ge=ge.withFilter(i.ExtensionId,...le)),Z.length&&(ge=ge.withFilter(i.ExtensionName,...Z)),(W.queryAllVersions||fe)&&(ge=ge.withFlags(ge.flags,o.IncludeVersions)),W.source&&(ge=ge.withSource(W.source));const{extensions:oe}=await this.queryGalleryExtensions(ge,{targetPlatform:W.targetPlatform??P,includePreRelease:de,versions:pe,compatible:!!W.compatible},H);return W.source&&oe.forEach((he,Ee)=>$(he,Ee,W.source)),oe}async getCompatibleExtension(s,b,_){if((0,I.isNotWebExtensionInWebTargetPlatform)(s.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(s,b,_))return s;const W=new S().withFlags(o.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,s.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(W,{targetPlatform:_,compatible:!0,includePreRelease:b},O.CancellationToken.None);return H[0]||null}async isExtensionCompatible(s,b,_){if(!(0,I.isTargetPlatformCompatible)(s.properties.targetPlatform,s.allTargetPlatforms,_)||!b&&s.properties.isPreReleaseVersion)return!1;let W=s.properties.engine;if(!W){const H=await this.getManifest(s,O.CancellationToken.None);if(!H)throw new Error("Manifest was not found");W=H.engines.vscode}return(0,g.isEngineValid)(W,this.productService.version,this.productService.date)}async isValidVersion(s,b,_,W,H){if(!(0,I.isTargetPlatformCompatible)(B(s),W,H)||b!=="any"&&ce(s)!==(b==="prerelease"))return!1;if(_)try{const Z=await this.getEngine(s);if(!(0,g.isEngineValid)(Z,this.productService.version,this.productService.date))return!1}catch(Z){return this.logService.error(`Error while getting the engine for the version ${s.version}.`,(0,R.getErrorMessage)(Z)),!1}return!0}async query(s,b){let _=s.text||"";const W=s.pageSize??50;let H=new S().withPage(1,W);_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ge,oe)=>(H=H.withFilter(i.Category,oe||ge),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ge,oe)=>(H=H.withFilter(i.Tag,oe||ge),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(i.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),H=H.withFilter(i.SearchText,_)),H=H.withSortBy(0)):s.ids?H=H.withFilter(i.ExtensionId,...s.ids):s.names?H=H.withFilter(i.ExtensionName,...s.names):H=H.withSortBy(4),typeof s.sortBy=="number"&&(H=H.withSortBy(s.sortBy)),typeof s.sortOrder=="number"&&(H=H.withSortOrder(s.sortOrder)),s.source&&(H=H.withSource(s.source));const Z=async(fe,ge)=>{const{extensions:oe,total:he}=await this.queryGalleryExtensions(fe,{targetPlatform:P,compatible:!1,includePreRelease:!!s.includePreRelease},ge);return oe.forEach((Ee,De)=>$(Ee,(fe.pageNumber-1)*fe.pageSize+De,s.source)),{extensions:oe,total:he}},{extensions:le,total:de}=await Z(H,b),pe=async(fe,ge)=>{if(ge.isCancellationRequested)throw new R.CancellationError;const{extensions:oe}=await Z(H.withPage(fe+1),ge);return oe};return{firstPage:le,total:de,pageSize:H.pageSize,getPage:pe}}async queryGalleryExtensions(s,b,_){const W=s.flags;s.flags&o.IncludeLatestVersionOnly&&s.flags&o.IncludeVersions&&(s=s.withFlags(s.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(s.flags&o.IncludeLatestVersionOnly)&&!(s.flags&o.IncludeVersions)&&(s=s.withFlags(s.flags,o.IncludeLatestVersionOnly)),b.versions?.length&&(s=s.withFlags(s.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),s=s.withFlags(s.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:H,total:Z,context:le}=await this.queryRawGalleryExtensions(s,_);if(!(s.flags&o.IncludeLatestVersionOnly)){const ge=[];for(const oe of H){const he=await this.toGalleryExtensionWithCriteria(oe,b,le);he&&ge.push(he)}return{extensions:ge,total:Z}}const pe=[],fe=new Map;for(let ge=0;ge<H.length;ge++){const oe=H[ge],he={id:(0,v.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),uuid:oe.extensionId},Ee=(0,w.isBoolean)(b.includePreRelease)?b.includePreRelease:!!b.includePreRelease.find(Ne=>(0,v.areSameExtensions)(Ne,he))?.includePreRelease;if(b.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(V(oe),b.targetPlatform))continue;const De=await this.toGalleryExtensionWithCriteria(oe,b,le);!De||De.properties.isPreReleaseVersion&&(!Ee||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==b.targetPlatform&&De.hasPreReleaseVersion?fe.set(oe.extensionId,ge):pe.push([ge,De])}if(fe.size){const ge=new Date().getTime(),oe=new S().withFlags(W&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,fe.size).withFilter(i.ExtensionId,...fe.keys()),{extensions:he}=await this.queryGalleryExtensions(oe,b,_);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:fe.size});for(const Ee of he){const De=fe.get(Ee.identifier.uuid);pe.push([De,Ee])}}return{extensions:pe.sort((ge,oe)=>ge[0]-oe[0]).map(([,ge])=>ge),total:Z}}async toGalleryExtensionWithCriteria(s,b,_){const W={id:(0,v.getGalleryExtensionId)(s.publisher.publisherName,s.extensionName),uuid:s.extensionId},H=b.versions?.find(pe=>(0,v.areSameExtensions)(pe,W))?.version,Z=(0,w.isBoolean)(b.includePreRelease)?b.includePreRelease:!!b.includePreRelease.find(pe=>(0,v.areSameExtensions)(pe,W))?.includePreRelease,le=V(s),de=M(s.versions,b.targetPlatform);if(b.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(le,b.targetPlatform))return null;for(let pe=0;pe<de.length;pe++){const fe=de[pe];if(!(H&&fe.version!==H)){if(await this.isValidVersion(fe,Z?"any":"release",b.compatible,le,b.targetPlatform))return G(s,fe,le,_);if(H&&fe.version===H)return null}}return H||b.compatible?null:G(s,s.versions[0],le)}async queryRawGalleryExtensions(s,b){if(!this.isEnabled())throw new Error("No extension gallery service configured.");s=s.withFlags(s.flags,o.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(o.Unpublished));const _=await this.commonHeadersPromise,W=JSON.stringify(s.raw),H={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},Z=new Date().getTime();let le,de,pe=0;try{if(le=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&s.criteria.some(ge=>ge.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:W,headers:H},b),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:pe};const fe=await(0,d.asJson)(le);if(fe){const ge=fe.results[0],oe=ge.extensions,he=ge.resultMetadata&&ge.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return pe=he&&he.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:oe,total:pe,context:{[t]:le.res.headers.activityid}}}return{galleryExtensions:[],total:pe}}catch(fe){throw de=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...s.telemetryData,requestBodySize:String(W.length),duration:new Date().getTime()-Z,success:!!le&&(0,d.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:de?(0,R.isCancellationError)(de)?"canceled":(0,R.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(s,b,_,W){if(!this.isEnabled())return;const H=A.isWeb?this.api(`/itemName/${s}.${b}/version/${_}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${s}/extensions/${b}/${_}/stats?statType=${W}`),Z=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.commonHeadersPromise,Accept:Z};try{await this.requestService.request({type:"POST",url:H,headers:de},O.CancellationToken.None)}catch{}}async download(s,b,_){this.logService.trace("ExtensionGalleryService#download",s.identifier.id);const W=(0,v.getGalleryExtensionTelemetryData)(s),H=new Date().getTime(),Z=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...W,duration:ge}),le=_===2?"install":_===3?"update":"",de=le?{uri:`${s.assets.download.uri}${f.URI.parse(s.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${s.assets.download.fallbackUri}${f.URI.parse(s.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:s.assets.download,pe=s.queryContext?.[t]?{[t]:s.queryContext[t]}:void 0,fe=await this.getAsset(de,pe?{headers:pe}:void 0);await this.fileService.writeFile(b,fe.stream),Z(new Date().getTime()-H)}async downloadSignatureArchive(s,b){if(!s.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",s.identifier.id);const _=await this.getAsset(s.assets.signature);await this.fileService.writeFile(b,_.stream)}async getReadme(s,b){if(s.assets.readme){const _=await this.getAsset(s.assets.readme,{},b);return await(0,d.asTextOrError)(_)||""}return""}async getManifest(s,b){if(s.assets.manifest){const _=await this.getAsset(s.assets.manifest,{},b),W=await(0,d.asTextOrError)(_);return W?JSON.parse(W):null}return null}async getManifestFromRawExtensionVersion(s,b){const _=ie(s,r.Manifest);if(!_)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},H=await this.getAsset(_,{headers:W});return await(0,d.asJson)(H)}async getCoreTranslation(s,b){const _=s.assets.coreTranslations.filter(W=>W[0]===b.toUpperCase())[0];if(_){const W=await this.getAsset(_[1]),H=await(0,d.asTextOrError)(W);return H?JSON.parse(H):null}return null}async getChangelog(s,b){if(s.assets.changelog){const _=await this.getAsset(s.assets.changelog,{},b);return await(0,d.asTextOrError)(_)||""}return""}async getAllCompatibleVersions(s,b,_){let W=new S().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);s.identifier.uuid?W=W.withFilter(i.ExtensionId,s.identifier.uuid):W=W.withFilter(i.ExtensionName,s.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(W,O.CancellationToken.None);if(!H.length)return[];const Z=V(H[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(Z,_))return[];const le=[];await Promise.all(H[0].versions.map(async fe=>{try{await this.isValidVersion(fe,b?"any":"release",!0,Z,_)&&le.push(fe)}catch{}}));const de=[],pe=new Set;for(const fe of M(le,_))pe.has(fe.version)||(pe.add(fe.version),de.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ce(fe)}));return de}async getAsset(s,b={},_=O.CancellationToken.None){const W=await this.commonHeadersPromise,H={type:"GET"},Z={...W,...b.headers||{}};b={...b,...H,headers:Z};const le=s.uri,de=s.fallbackUri,pe={...b,url:le};try{const fe=await this.requestService.request(pe,_);if(fe.res.statusCode===200)return fe;const ge=await(0,d.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ge}`)}catch(fe){if((0,R.isCancellationError)(fe))throw fe;const ge=(0,R.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:ge});const oe={...b,url:de};return this.requestService.request(oe,_)}}async getEngine(s){let b=Q(s);if(!b){const _=await this.getManifestFromRawExtensionVersion(s,O.CancellationToken.None);if(!_)throw new Error("Manifest was not found");b=_.engines.vscode}return b}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const s=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(s.res.statusCode!==200)throw new Error("Could not get extensions report.");const b=await(0,d.asJson)(s),_=[],W={};if(b){for(const H of b.malicious)_.push({id:H});if(b.migrateToPreRelease)for(const[H,Z]of Object.entries(b.migrateToPreRelease))(!Z.engine||(0,g.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(W[H.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(b.deprecated)for(const[H,Z]of Object.entries(b.deprecated))Z&&(W[H.toLowerCase()]=(0,w.isBoolean)(Z)?{}:Z)}return{malicious:_,deprecated:W}}};Y=ve([te(1,d.IRequestService),te(2,E.ILogService),te(3,D.IEnvironmentService),te(4,p.ITelemetryService),te(5,L.IFileService),te(6,u.IProductService),te(7,l.IConfigurationService)],Y);let F=e.ExtensionGalleryService=class extends Y{constructor(s,b,_,W,H,Z,le,de){super(s,b,_,W,H,Z,le,de)}};e.ExtensionGalleryService=F=ve([te(0,y.IStorageService),te(1,d.IRequestService),te(2,E.ILogService),te(3,D.IEnvironmentService),te(4,p.ITelemetryService),te(5,L.IFileService),te(6,u.IProductService),te(7,l.IConfigurationService)],F);let U=e.ExtensionGalleryServiceWithNoStorageService=class extends Y{constructor(s,b,_,W,H,Z,le){super(void 0,s,b,_,W,H,Z,le)}};e.ExtensionGalleryServiceWithNoStorageService=U=ve([te(0,d.IRequestService),te(1,E.ILogService),te(2,D.IEnvironmentService),te(3,p.ITelemetryService),te(4,L.IFileService),te(5,u.IProductService),te(6,l.IConfigurationService)],U)}),define(ne[156],re([0,1,11,18,13,6,137,27,21,3,68]),function(q,e,T,O,R,A,N,w,f,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let I=e.UserDataProfilesReadonlyService=class ze extends f.UserDataProfilesService{constructor(E,u,d,h,y){super(d,h,u,y),this.stateReadonlyService=E,this.nativeEnvironmentService=d}getStoredProfiles(){return this.stateReadonlyService.getItem(ze.PROFILES_KEY,[]).map(u=>({...u,location:(0,l.isString)(u.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,u.location):T.URI.revive(u.location)}))}getStoredProfileAssociations(){const E=this.stateReadonlyService.getItem(ze.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ze.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?E:this.migrateStoredProfileAssociations(E)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(T.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};I.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",e.UserDataProfilesReadonlyService=I=ve([te(0,N.IStateReadService),te(1,w.IUriIdentityService),te(2,O.INativeEnvironmentService),te(3,R.IFileService),te(4,A.ILogService)],I);let v=e.UserDataProfilesService=class Ue extends I{constructor(E,u,d,h,y){super(E,u,d,h,y),this.stateService=E}saveStoredProfiles(E){E.length?this.stateService.setItem(Ue.PROFILES_KEY,E.map(u=>({...u,location:this.uriIdentityService.extUri.basename(u.location)}))):this.stateService.removeItem(Ue.PROFILES_KEY)}getStoredProfiles(){const E=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(E),this.stateService.setItem("userDataProfilesMigration",!0)),E}saveStoredProfileAssociations(E){E.emptyWindows||E.workspaces?this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_KEY,E):this.stateService.removeItem(Ue.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const E="workspaceAndProfileInfo",u=this.stateService.getItem(E,void 0);if(u){this.stateService.removeItem(E);const h=u.reduce((y,{workspace:p,profile:P})=>(y[T.URI.revive(p).toString()]=T.URI.revive(P).toString(),y),{});this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_KEY,{workspaces:h})}const d=super.getStoredProfileAssociations();return this.stateService.getItem(Ue.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(d),this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),d}};e.UserDataProfilesService=v=ve([te(0,N.IStateService),te(1,w.IUriIdentityService),te(2,O.INativeEnvironmentService),te(3,R.IFileService),te(4,A.ILogService)],v);let g=e.ServerUserDataProfilesService=class extends v{constructor(E,u,d,h){super(new D.StateService(0,u,h,d),E,u,d,h)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=g=ve([te(0,w.IUriIdentityService),te(1,O.INativeEnvironmentService),te(2,R.IFileService),te(3,A.ILogService)],g)}),define(ne[50],re([0,1,123,8,15,3,22,85,172,173]),function(q,e,T,O,R,A,N,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const D=new RegExp(e.CorruptZipMessage);class I extends Error{constructor(o,n){let i=n.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=n}}e.ExtractError=I;function v(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,i)=>n+i,o&61440)}function g(t){if(t instanceof I)return t;let o;return D.test(t.message)&&(o="CorruptZip"),new I(o,t)}function L(t,o,n,i,r,a){const c=R.dirname(o),C=R.join(i,c);if(!C.startsWith(i))return Promise.reject(new Error(w.localize(0,null,o)));const S=R.join(i,o);let m;return a.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(N.Promises.mkdir(C,{recursive:!0})).then(()=>new Promise((x,X)=>{if(!a.isCancellationRequested)try{m=(0,T.createWriteStream)(S,{mode:n}),m.once("close",()=>x()),m.once("error",X),t.once("error",X),t.pipe(m)}catch(K){X(K)}}))}function E(t,o,n,i){let r=(0,O.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((c,C)=>{const S=new O.Sequencer,m=x=>{x.isCancellationRequested||(a++,t.readEntry())};t.once("error",C),t.once("close",()=>r.then(()=>{i.isCancellationRequested||t.entryCount===a?c():C(new I("Incomplete",new Error(w.localize(1,null,a,t.entryCount))))},C)),t.readEntry(),t.on("entry",x=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(x.fileName)){m(i);return}const X=x.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(X)){const ue=R.join(o,X);r=(0,O.createCancelablePromise)(Q=>N.Promises.mkdir(ue,{recursive:!0}).then(()=>m(Q)).then(void 0,C));return}const K=d(t,x),ie=v(x);r=(0,O.createCancelablePromise)(ue=>S.queue(()=>K.then(Q=>L(Q,X,ie,o,n,ue).then(()=>m(ue)))).then(null,C))})})}function u(t,o=!1){return new Promise((n,i)=>{(0,f.open)(t,o?{lazyEntries:!0}:void 0,(r,a)=>{r?i(g(r)):n((0,A.assertIsDefined)(a))})})}function d(t,o){return new Promise((n,i)=>{t.openReadStream(o,(r,a)=>{r?i(g(r)):n((0,A.assertIsDefined)(a))})})}function h(t,o){return new Promise((n,i)=>{const r=new l.ZipFile;o.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const a=(0,T.createWriteStream)(t);r.outputStream.pipe(a),r.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>n(t))})}e.zip=h;function y(t,o,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=u(t,!0);return n.overwrite&&(a=a.then(c=>N.Promises.rm(o).then(()=>c))),a.then(c=>E(c,o,{sourcePathRegex:r},i))}e.extract=y;function p(t,o){return u(t).then(n=>new Promise((i,r)=>{n.on("entry",a=>{a.fileName===o&&d(n,a).then(c=>i(c),c=>r(c))}),n.once("close",()=>r(new Error(w.localize(2,null,o))))}))}function P(t,o){return p(t,o).then(n=>new Promise((i,r)=>{const a=[];n.once("error",r),n.on("data",c=>a.push(c)),n.on("end",()=>i(Buffer.concat(a)))}))}e.buffer=P}),define(ne[157],re([0,1,8,9,2,16,12,17,41,3,28,22,50,24,18,20,26,60,13,6]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=e.ExtensionsDownloader=class je extends R.Disposable{constructor(t,o,n,i,r,a){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=i,this.extensionSignatureVerificationService=r,this.logService=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,o,n){await this.cleanUpPromise;const i=(0,w.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,i,a=>this.extensionGalleryService.download(t,a,o))}catch(a){throw new E.ExtensionManagementError(a.message,E.ExtensionManagementErrorCode.Download)}let r=!1;if(n&&this.shouldVerifySignature(t)){const a=await this.downloadSignatureArchive(t);try{r=await this.extensionSignatureVerificationService.verify(i.fsPath,a.fsPath,this.logService.getLevel()===y.LogLevel.Trace)}catch(c){const C=c;if(r=C.code,C.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${C.output}`),r===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.ExtensionManagementError(v.CorruptZipMessage,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(a)}catch(c){this.logService.error(c)}}}return r===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${t.identifier.id}`),{location:i,verificationStatus:r}}shouldVerifySignature(t){if(!t.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,l.isBoolean)(o)?o:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const o=(0,w.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${je.SignatureArchiveExtension}`);return await this.downloadFile(t,o,n=>this.extensionGalleryService.downloadSignatureArchive(t,n)),o}async downloadFile(t,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const i=(0,w.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);await this.fileService.exists(i)||await n(i);try{await this.rename(i,o,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async rename(t,o,n){try{await I.Promises.rename(t.fsPath,o.fsPath)}catch(i){if(N.isWindows&&i&&i.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${t} to ${o} with 'EPERM' error. Trying again...`),this.rename(t,o,n);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],n=[],i=[];for(const c of t.children)if(c.name.endsWith(je.SignatureArchiveExtension))i.push(c.resource);else{const C=u.ExtensionKey.parse(c.name);C&&n.push([C,c])}const r=(0,u.groupByExtension)(n,([c])=>c),a=[];for(const c of r)c.sort((C,S)=>f.rcompare(C[0].version,S[0].version)),o.push(...c.slice(1).map(C=>C[1].resource)),a.push(c[0][1]);a.sort((c,C)=>c.mtime-C.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(c=>c.resource)),o.push(...i),await T.Promises.settled(o.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?u.ExtensionKey.create(t).toString().toLowerCase():(0,D.generateUuid)()}};p.SignatureArchiveExtension=".sigzip",e.ExtensionsDownloader=p=ve([te(0,L.INativeEnvironmentService),te(1,h.IFileService),te(2,E.IExtensionGalleryService),te(3,g.IConfigurationService),te(4,d.IExtensionSignatureVerificationService),te(5,y.ILogService)],p)}),define(ne[158],re([0,1,50,95]),function(q,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(A){return(0,T.buffer)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=R}),define(ne[159],re([0,1,8,14,23,33,9,5,2,35,16,15,12,17,41,3,11,28,22,50,94,59,18,150,20,26,40,49,157,151,158,132,139,47,13,10,6,31,25,27,21]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h,y,p,P,t,o,n,i,r,a,c,C,S,m,x,X,K,ie,ue,Q,ce,ae,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let j=e.ExtensionManagementService=class extends o.AbstractExtensionManagementService{constructor(F,U,k,s,b,_,W,H,Z,le,de,pe){super(F,U,k,le,pe),this.extensionsScannerService=b,this.extensionsProfileScannerService=_,this.downloadService=W,this.fileService=Z,this.uriIdentityService=de,this._onDidUpdateExtensionMetadata=this._register(new w.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new l.ResourceSet;const fe=this._register(H.createInstance(C.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(B,oe=>fe.postUninstall(oe))),this.manifestCache=this._register(new m.ExtensionsManifestCache(pe,Z,de,this,this.logService)),this.extensionsDownloader=this._register(H.createInstance(c.ExtensionsDownloader));const ge=this._register(new x.ExtensionsWatcher(this,this.extensionsScannerService,pe,_,de,Z,k));this._register(ge.onDidChangeExtensionsByAnotherSource(oe=>this.onDidChangeExtensionsFromAnotherSource(oe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const U=await this.collectFiles(F),k=await(0,y.zip)((0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,U);return u.URI.file(k)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:U,cleanup:k}=await this.downloadVsix(F),s=I.resolve(U.fsPath);try{return await(0,S.getManifest)(s)}finally{await k()}}getInstalled(F,U=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(F??null,U)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.extensionsScanner.scanUserExtensionAtLocation(F)}async install(F,U={}){this.logService.trace("ExtensionManagementService#install",F.toString());const{location:k,cleanup:s}=await this.downloadVsix(F);try{const b=await(0,S.getManifest)(I.resolve(k.fsPath));if(b.engines&&b.engines.vscode&&!(0,X.isEngineValid)(b.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,(0,i.getGalleryExtensionId)(b.publisher,b.name),this.productService.version));return await this.installExtension(b,k,U)}finally{await s()}}async installFromLocation(F,U){this.logService.trace("ExtensionManagementService#installFromLocation",F.toString());const k=await this.extensionsScanner.scanUserExtensionAtLocation(F);if(!k)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.addExtensionsToProfile([[k,void 0]],U),this.logService.info("Successfully installed extension",k.identifier.id,U.toString()),k}async installExtensionsFromProfile(F,U,k){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",F,U.toString(),k.toString());const s=(await this.extensionsScanner.scanExtensions(1,U)).filter(b=>F.some(_=>(0,i.areSameExtensions)(_,b.identifier)));if(s.length){const b=await Promise.all(s.map(_=>this.extensionsScanner.scanMetadata(_,U)));await this.addExtensionsToProfile(s.map((_,W)=>[_,b[W]]),k),this.logService.info("Successfully installed extensions",s.map(_=>_.identifier.id),k.toString())}return s}async updateMetadata(F,U,k=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.pinned=U.pinned||void 0,F=await this.extensionsScanner.updateMetadata(F,U,k),this.manifestCache.invalidate(k),this._onDidUpdateExtensionMetadata.fire(F),F}async reinstallFromGallery(F){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const U=await this.getTargetPlatform(),[k]=await this.galleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:U,compatible:!0},R.CancellationToken.None);if(!k)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(F);try{await this.extensionsScanner.removeUninstalledExtension(F)}catch(s){throw new Error(p.localize(3,null,(0,A.toErrorMessage)(s)))}return this.installFromGallery(k)}copyExtensions(F,U){return this.extensionsScanner.copyExtensions(F,U)}markAsUninstalled(...F){return this.extensionsScanner.setUninstalled(...F)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(F){this.logService.error(F)}}async download(F,U,k){const{location:s}=await this.extensionsDownloader.download(F,U,!k);return s}async downloadVsix(F){if(F.scheme===D.Schemas.file)return{location:F,async cleanup(){}};this.logService.trace("Downloading extension from",F.toString());const U=(0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)());return await this.downloadService.download(F,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(s){this.logService.error(s)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(F,U,k){if(u.URI.isUri(U))return new $(F,U,k,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const s=i.ExtensionKey.create(U).toString();let b=this.installGalleryExtensionsTasks.get(s);return b||(this.installGalleryExtensionsTasks.set(s,b=new M(F,U,k,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),b.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(s))),b}createUninstallExtensionTask(F,U){return new G(F,U.profileLocation,this.extensionsProfileScannerService)}async collectFiles(F){const U=async s=>{let b=await h.Promises.readdir(s);b=b.map(H=>I.join(s,H));const _=await Promise.all(b.map(H=>h.Promises.stat(H)));let W=Promise.resolve([]);return _.forEach((H,Z)=>{const le=b[Z];H.isFile()&&(W=W.then(de=>[...de,le])),H.isDirectory()&&(W=W.then(de=>U(le).then(pe=>[...de,...pe])))}),W};return(await U(F.location.fsPath)).map(s=>({path:`extension/${I.relative(F.location.fsPath,s)}`,localPath:s}))}async onDidChangeExtensionsFromAnotherSource({added:F,removed:U}){if(U)for(const k of U.extensions)this.logService.info("Extensions removed from another source",k.id,U.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:k,profileLocation:U.profileLocation});if(F){const s=(await this.extensionsScanner.scanExtensions(1,F.profileLocation)).filter(b=>F.extensions.some(_=>(0,i.areSameExtensions)(_,b.identifier)));this._onDidInstallExtensions.fire(s.map(b=>(this.logService.info("Extensions added from another source",b.identifier.id,F.profileLocation.toString()),{identifier:b.identifier,local:b,profileLocation:F.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(U=>this.knownDirectories.add(U)));const F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const U of F.children??[])U.isDirectory&&this.knownDirectories.add(U.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(U=>this.onDidFilesChange(U)))}async onDidFilesChange(F){if(!F.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const U=[];for(const k of F.rawAdded){if(this.knownDirectories.has(k)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(k),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(k,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(k).startsWith(".")||!(await this.fileService.stat(k)).isDirectory)continue;const s=await this.extensionsScanner.scanUserExtensionAtLocation(k);s&&s.installedTimestamp===void 0&&(this.knownDirectories.add(k),U.push(s))}U.length&&(await this.addExtensionsToProfile(U.map(k=>[k,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",U.map(k=>k.identifier.id)))}async addExtensionsToProfile(F,U){const k=F.map(s=>s[0]);await this.setInstalled(k),await this.extensionsProfileScannerService.addExtensionsToProfile(F,U),this._onDidInstallExtensions.fire(k.map(s=>({local:s,identifier:s.identifier,operation:1,profileLocation:U})))}async setInstalled(F){const U=await this.extensionsScanner.getUninstalledExtensions();for(const k of F){const s=i.ExtensionKey.create(k);U[s.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",s.id),await this.extensionsScanner.setInstalled(s),this.logService.info("Removed the extension from uninstalled list:",s.id))}}};e.ExtensionManagementService=j=ve([te(0,n.IExtensionGalleryService),te(1,ce.ITelemetryService),te(2,ue.ILogService),te(3,t.INativeEnvironmentService),te(4,a.IExtensionsScannerService),te(5,r.IExtensionsProfileScannerService),te(6,P.IDownloadService),te(7,ie.IInstantiationService),te(8,K.IFileService),te(9,Q.IProductService),te(10,ae.IUriIdentityService),te(11,se.IUserDataProfilesService)],j);let B=e.ExtensionsScanner=class extends f.Disposable{constructor(F,U,k,s,b,_){super(),this.beforeRemovingExtension=F,this.fileService=U,this.extensionsScannerService=k,this.extensionsProfileScannerService=s,this.uriIdentityService=b,this.logService=_,this._onExtract=this._register(new w.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,g.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(F,U){const k={includeInvalid:!0,profileLocation:U};let s=[];return F===null||F===0?s.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},k,!1)):F===1&&s.push(...await this.extensionsScannerService.scanUserExtensions(k)),s=F!==null?s.filter(b=>b.type===F):s,Promise.all(s.map(b=>this.toLocalExtension(b)))}async scanAllUserExtensions(F){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(U.map(k=>this.toLocalExtension(k)))}async scanUserExtensionAtLocation(F){try{const U=await this.extensionsScannerService.scanExistingExtension(F,1,{includeInvalid:!0});if(U)return await this.toLocalExtension(U)}catch(U){this.logService.error(U)}return null}async extractUserExtension(F,U,k,s){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const b=F.toString(),_=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`),W=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,b);try{await h.Promises.rm(W)}catch{throw new n.ExtensionManagementError(p.localize(4,null,W,F.id),n.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(F,U,_,s),await this.extensionsScannerService.updateMetadata(u.URI.file(_),k);try{this._onExtract.fire(u.URI.file(W)),await this.rename(F,_,W,Date.now()+2*60*1e3),this.logService.info("Renamed to",W)}catch(H){try{await h.Promises.rm(_)}catch{}if(H.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${(0,N.getErrorMessage)(H)}. Deleted from extracted location`,_),H}return this.scanLocalExtension(u.URI.file(W),1)}async scanMetadata(F,U){return U?(await this.extensionsProfileScannerService.scanProfileExtensions(U)).find(s=>(0,i.areSameExtensions)(s.identifier,F.identifier))?.metadata:this.extensionsScannerService.scanMetadata(F.location)}async updateMetadata(F,U,k){return k?await this.extensionsProfileScannerService.updateMetadata([[F,U]],k):await this.extensionsScannerService.updateMetadata(F.location,U),this.scanLocalExtension(F.location,F.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const U=F.map(k=>i.ExtensionKey.create(k));await this.withUninstalledExtensions(k=>U.forEach(s=>{k[s.toString()]=!0,this.logService.info("Marked extension as uninstalled",s.toString())}))}async setInstalled(F){await this.withUninstalledExtensions(U=>delete U[F.toString()])}async removeExtension(F,U){this.logService.trace(`Deleting ${U} extension from disk`,F.identifier.id,F.location.fsPath);const k=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(F.location),`._${(0,d.generateUuid)()}`);await this.rename(F.identifier,F.location.fsPath,k.fsPath,Date.now()+2*60*1e3),await this.fileService.del(k,{recursive:!0}),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[i.ExtensionKey.create(F).toString()])}async copyExtensions(F,U){const k=await this.scanExtensions(1,F),s=await Promise.all(k.filter(b=>!b.isApplicationScoped).map(async b=>[b,await this.scanMetadata(b,F)]));await this.extensionsProfileScannerService.addExtensionsToProfile(s,U)}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(s){if((0,K.toFileOperationResult)(s)!==1)throw s}let k={};if(U)try{k=JSON.parse(U)}catch{}return F&&(F(k),Object.keys(k).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(k))):await this.fileService.del(this.uninstalledResource)),k})}async extractAtLocation(F,U,k,s){this.logService.trace(`Started extracting the extension from ${U} to ${k}`);try{await h.Promises.rm(k)}catch(b){throw new n.ExtensionManagementError(this.joinErrors(b).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(U,k,{sourcePath:"extension",overwrite:!0},s),this.logService.info(`Extracted extension to ${k}:`,F.id)}catch(b){try{await h.Promises.rm(k)}catch{}let _=n.ExtensionManagementErrorCode.Extract;throw b instanceof y.ExtractError&&(b.type==="CorruptZip"?_=n.ExtensionManagementErrorCode.CorruptZip:b.type==="Incomplete"&&(_=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(b.message,_)}}async rename(F,U,k,s){try{await h.Promises.rename(U,k)}catch(b){if(v.isWindows&&b&&b.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${U} to ${k} with 'EPERM' error. Trying again...`,F.id),this.rename(F,U,k,s);throw new n.ExtensionManagementError(b.message||p.localize(5,null,U,k),b.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,U){const k=await this.extensionsScannerService.scanExistingExtension(F,U,{includeInvalid:!0});if(k)return this.toLocalExtension(k);throw new Error(p.localize(6,null,F.path))}async toLocalExtension(F){const U=await this.fileService.resolve(F.location);let k,s;return U.children&&(k=U.children.find(({name:b})=>/^readme(\.txt|\.md|)$/i.test(b))?.resource,s=U.children.find(({name:b})=>/^changelog(\.txt|\.md|)$/i.test(b))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:k,changelogUrl:s,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(F));const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const b of U)F[i.ExtensionKey.create(b).toString()]||k.add(b.identifier.id.toLowerCase());try{const b=(0,i.groupByExtension)(U,_=>_.identifier);await T.Promises.settled(b.map(async _=>{const W=_.sort((H,Z)=>L.rcompare(H.manifest.version,Z.manifest.version))[0];k.has(W.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(W))}))}catch(b){this.logService.error(b)}const s=U.filter(b=>b.metadata&&F[i.ExtensionKey.create(b).toString()]);await Promise.allSettled(s.map(b=>this.removeUninstalledExtension(b)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const F=[];let U;try{U=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(k){(0,K.toFileOperationResult)(k)!==1&&this.logService.error(k)}for(const k of U?.children??[])k.isDirectory&&k.name.startsWith("._")&&(0,d.isUUID)(k.name.substring(2))&&F.push((async()=>{this.logService.trace("Deleting the generated extension folder",k.resource.toString());try{await this.fileService.del(k.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",k.resource.toString())}catch(s){this.logService.error(s)}})());await Promise.allSettled(F)}joinErrors(F){const U=Array.isArray(F)?F:[F];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((k,s)=>new Error(`${k.message}${k.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}};e.ExtensionsScanner=B=ve([te(1,K.IFileService),te(2,a.IExtensionsScannerService),te(3,r.IExtensionsProfileScannerService),te(4,ae.IUriIdentityService),te(5,ue.ILogService)],B);class V extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(F,U,k,s,b,_,W,H,Z){super(),this.identifier=F,this.source=U,this.options=k,this.extensionsScanner=s,this.uriIdentityService=b,this.userDataProfilesService=_,this.extensionsScannerService=W,this.extensionsProfileScannerService=H,this.logService=Z,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(F){const[U,k]=await this.install(F);return this._profileLocation=U.isBuiltin||U.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[U,k]],this._profileLocation),U}async extractExtension({zipPath:F,key:U,metadata:k},s){let b=await this.unsetIfUninstalled(U);return b||(this.logService.trace("Extracting extension...",U.id),b=await this.extensionsScanner.extractUserExtension(U,F,k,s),this.logService.info("Extracting extension completed.",U.id)),b}async unsetIfUninstalled(F){return await this.isUninstalled(F)?(this.logService.trace("Removing the extension from uninstalled list:",F.id),await this.extensionsScanner.setInstalled(F),this.logService.info("Removed the extension from uninstalled list:",F.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(s=>i.ExtensionKey.create(s).equals(F))):void 0}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]}}class M extends V{constructor(F,U,k,s,b,_,W,H,Z,le){super(U.identifier,U,k,b,_,W,H,Z,le),this.gallery=U,this.extensionsDownloader=s}async install(F){const k=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(W=>(0,i.areSameExtensions)(W.identifier,this.gallery.identifier));k&&(this._operation=3);const s={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(k,s),s];const{location:b,verificationStatus:_}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=_,this.validateManifest(b.fsPath),[await this.extractExtension({zipPath:b.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:s},F),s]}catch(W){try{await this.extensionsDownloader.delete(b)}catch(H){this.logService.warn("Error while deleting the downloaded file",b.toString(),(0,N.getErrorMessage)(H))}throw W}}async validateManifest(F){try{await(0,S.getManifest)(F)}catch(U){throw new n.ExtensionManagementError((0,o.joinErrors)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class $ extends V{constructor(F,U,k,s,b,_,W,H,Z,le){super({id:(0,i.getGalleryExtensionId)(F.publisher,F.name)},U,k,b,_,W,H,Z,le),this.manifest=F,this.location=U,this.galleryService=s}async doRun(F){const U=await super.doRun(F);return this.updateMetadata(U,F),U}async install(F){const U=new i.ExtensionKey(this.identifier,this.manifest.version),s=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(W=>(0,i.areSameExtensions)(this.identifier,W.identifier)),b={isApplicationScoped:this.options.isApplicationScoped||s?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||s?.isMachineScoped,isBuiltin:this.options.isBuiltin||s?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(s)if(this._operation=3,U.equals(new i.ExtensionKey(s.identifier,s.manifest.version)))try{await this.extensionsScanner.removeExtension(s,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&L.gt(s.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(s);else{const W=await this.unsetIfUninstalled(U);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:I.resolve(this.location.fsPath),key:U,metadata:b},F),b]}async updateMetadata(F,U){try{let[k]=await this.galleryService.getExtensions([{id:F.identifier.id,version:F.manifest.version}],U);if(k||([k]=await this.galleryService.getExtensions([{id:F.identifier.id}],U)),k){const s={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(F,s,this.options.profileLocation)}}catch{}}}class G extends o.AbstractExtensionTask{constructor(F,U,k){super(),this.extension=F,this.profileLocation=U,this.extensionsProfileScannerService=k}async doRun(F){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ne[160],re([0,1,135,8,14,9,3,24,18,136,6,43,134,174]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let L=e.RequestService=class extends I.AbstractRequestService{constructor(h,y,p,P){super(P),this.configurationService=h,this.environmentService=y,this.logService=p,this.configure(),this._register(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const h=this.configurationService.getValue("http");this.proxyUrl=h?.proxy,this.strictSSL=!!h?.proxyStrictSSL,this.authorization=h?.proxyAuthorization}async request(h,y){const{proxyUrl:p,strictSSL:P}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const o={...process.env,...t},n=h.agent?h.agent:await(0,v.getProxyAgent)(h.url||"",o,{proxyUrl:p,strictSSL:P});return h.agent=n,h.strictSSL=P,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(h.isChromiumNetwork?"electron":"node",h,()=>u(h,y))}async resolveProxy(h){}};e.RequestService=L=ve([te(0,w.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,D.ILogService),te(3,D.ILoggerService)],L);async function E(d){return((0,T.parse)(d.url).protocol==="https:"?await new Promise((p,P)=>{q(["https"],p,P)}):await new Promise((p,P)=>{q(["http"],p,P)})).request}async function u(d,h){return O.Promises.withAsyncBody(async(y,p)=>{const P=(0,T.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await E(d),o={hostname:P.hostname,port:P.port?parseInt(P.port):P.protocol==="https:"?443:80,protocol:P.protocol,path:P.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,N.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password);const n=t(o,i=>{const r=(0,N.isNumber)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)u({...d,url:i.headers.location,followRedirects:r-1},h).then(y,p);else{let a=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,g.createGunzip)())),y({res:i,stream:(0,R.streamToBufferReadableStream)(a)})}});n.on("error",p),d.timeout&&n.setTimeout(d.timeout),d.isChromiumNetwork&&n.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&n.write(d.data),n.end(),h.onCancellationRequested(()=>{n.abort(),p(new A.CancellationError)})})}e.nodeRequest=u}),define(ne[175],re([0,1,32,8,33,9,2,16,15,12,34,11,22,24,131,59,133,18,109,155,20,60,138,40,49,159,153,13,120,122,48,118,63,64,141,6,127,38,128,144,31,43,160,68,69,25,143,39,145,146,27,148,21,156,147,152,124,126,4]),function(q,e,T,O,R,A,N,w,f,l,D,I,v,g,L,E,u,d,h,y,p,P,t,o,n,i,r,a,c,C,S,m,x,X,K,ie,ue,Q,ce,ae,se,j,B,V,M,$,G,Y,F,U,k,s,b,_,W,H,Z,le,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends N.Disposable{constructor(oe){super(),this.argv=oe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[oe,he]=await this.initServices();return oe.invokeFunction(async Ee=>{const De=Ee.get(ie.ILogService),Ne=Ee.get(a.IFileService),Me=Ee.get(d.INativeEnvironmentService),z=Ee.get(b.IUserDataProfilesService);De.info("CLI main",this.argv),this.registerErrorHandler(De),await this.doRun(Me,Ne,z,oe),await Promise.all(he.map(J=>{(0,O.raceTimeout)(J.flush(),1e3)}))})}async initServices(){const oe=new x.ServiceCollection,he={_serviceBrand:void 0,...ae.default};oe.set(se.IProductService,he);const Ee=new h.NativeEnvironmentService(this.argv,he);oe.set(d.INativeEnvironmentService,Ee),await Promise.all([Ee.appSettingsHome.fsPath,Ee.extensionsPath].map(Ie=>Ie?v.Promises.mkdir(Ie,{recursive:!0}):void 0));const De=new le.LoggerService((0,ie.getLogLevel)(Ee),Ee.logsHome);oe.set(ie.ILoggerService,De);const Ne=this._register(De.createLogger("cli",{name:(0,de.localize)(0,null)})),Me=[];De.getLogLevel()===ie.LogLevel.Trace&&Me.push(new ie.ConsoleLogger(De.getLogLevel()));const z=this._register(new Z.LogService(Ne,Me));oe.set(ie.ILogService,z);const J=this._register(new c.FileService(z));oe.set(a.IFileService,J);const ee=this._register(new C.DiskFileSystemProvider(z));J.registerProvider(w.Schemas.file,ee);const me=new s.UriIdentityService(J);oe.set(k.IUriIdentityService,me);const Se=new V.StateReadonlyService(1,Ee,z,J),ke=new _.UserDataProfilesReadonlyService(Se,me,Ee,J,z);oe.set(b.IUserDataProfilesService,ke);const Pe=l.isWindows&&he.win32RegValueName?this._register(new ce.NativePolicyService(z,he.win32RegValueName)):Ee.policyFile?this._register(new ue.FilePolicyService(Ee.policyFile,J,z)):new Q.NullPolicyService;oe.set(Q.IPolicyService,Pe);const Oe=this._register(new L.ConfigurationService(ke.defaultProfile.settingsResource,J,Pe,z));oe.set(g.IConfigurationService,Oe),await Promise.all([Se.init(),Oe.initialize()]);let Ce;try{Ce=await(0,W.resolveMachineId)(Se,z)}catch(Ie){Ie.code!=="ENOENT"&&z.error(Ie)}ke.init(),oe.set(k.IUriIdentityService,new s.UriIdentityService(J)),oe.set(j.IRequestService,new S.SyncDescriptor(B.RequestService,void 0,!0)),oe.set(E.IDownloadService,new S.SyncDescriptor(u.DownloadService,void 0,!0)),oe.set(o.IExtensionsProfileScannerService,new S.SyncDescriptor(H.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new S.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),oe.set(P.IExtensionSignatureVerificationService,new S.SyncDescriptor(P.ExtensionSignatureVerificationService,void 0,!0)),oe.set(i.INativeServerExtensionManagementService,new S.SyncDescriptor(i.ExtensionManagementService,void 0,!0)),oe.set(p.IExtensionGalleryService,new S.SyncDescriptor(y.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(X.ILanguagePackService,new S.SyncDescriptor(K.NativeLanguagePackService,void 0,!1));const Le=[],Fe=(0,Y.isInternalTelemetry)(he,Oe);if((0,Y.supportsTelemetry)(he,Ee)){he.aiConfig&&he.aiConfig.ariaKey&&Le.push(new F.OneDataSystemAppender(Fe,"monacoworkbench",null,he.aiConfig.ariaKey));const Ie={appenders:Le,sendErrorTelemetry:!1,commonProperties:(0,M.resolveCommonProperties)((0,T.release)(),(0,T.hostname)(),process.arch,he.commit,he.version,Ce,Fe),piiPaths:(0,Y.getPiiPathsFromEnvironment)(Ee)};oe.set($.ITelemetryService,new S.SyncDescriptor(G.TelemetryService,[Ie],!1))}else oe.set($.ITelemetryService,Y.NullTelemetryService);return[new m.InstantiationService(oe),Le]}registerErrorHandler(oe){(0,A.setUnexpectedErrorHandler)(he=>{const Ee=(0,R.toErrorMessage)(he,!0);Ee&&oe.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",he=>{(0,A.isSigPipeError)(he)||(0,A.onUnexpectedError)(he)}),process.on("unhandledRejection",he=>(0,A.onUnexpectedError)(he))}async doRun(oe,he,Ee,De){let Ne;if(oe.args.profile&&(Ne=Ee.profiles.find(z=>z.name===oe.args.profile),!Ne))throw new Error(`Profile '${oe.args.profile}' not found.`);const Me=(Ne??Ee.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return De.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,Me);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const z={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Me};return De.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),z,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return De.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Me);if(this.argv["locate-extension"])return De.createInstance(t.ExtensionManagementCLI,new ie.ConsoleLogger(ie.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}asExtensionIdOrVSIX(oe){return oe.map(he=>/\.vsix$/i.test(he)?I.URI.file((0,f.isAbsolute)(he)?he:(0,f.join)((0,D.cwd)(),he)):he)}}async function fe(ge){const oe=new pe(ge);try{await oe.run()}finally{oe.dispose()}}e.main=fe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/code/node/cliProcessMain.js.map
