/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/types","vs/nls","vs/base/common/uri","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/network","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","child_process","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/skipList","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(ne){for(var e=[],L=0,O=ne.length;L<O;L++)e[L]=oe[ne[L]];return e};define(oe[59],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(T){return(R,I,m)=>{let P=null,p=null;if(typeof m.value=="function"?(P="value",p=m.value):typeof m.get=="function"&&(P="get",p=m.get),!p)throw new Error("not supported");m[P]=T(p,I)}}function O(T,R,I){let m=null,P=null;if(typeof I.value=="function"?(m="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(m="get",P=I.get),!P)throw new Error("not supported");const p=`$memoize$${R}`;I[m]=function(...v){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,v)}),this[p]}}e.memoize=O;function _(T,R,I){return L((m,P)=>{const p=`$debounce$${P}`,v=`$debounce$result$${P}`;return function(...d){this[v]||(this[v]=I?I():void 0),clearTimeout(this[p]),R&&(this[v]=R(this[v],...d),d=[this[v]]),this[p]=setTimeout(()=>{m.apply(this,d),this[v]=I?I():void 0},T)}})}e.debounce=_;function U(T,R,I){return L((m,P)=>{const p=`$throttle$timer$${P}`,v=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,f=`$throttle$pending$${P}`;return function(...E){if(this[v]||(this[v]=I?I():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),R&&(this[v]=R(this[v],...E)),this[f])return;const a=this[d]+T;a<=Date.now()?(this[d]=Date.now(),m.apply(this,[this[v]]),this[v]=I?I():void 0):(this[f]=!0,this[p]=setTimeout(()=>{this[f]=!1,this[d]=Date.now(),m.apply(this,[this[v]]),this[v]=I?I():void 0},a-Date.now()))}})}e.throttle=U}),define(oe[7],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?y.isErrorNoTelemetry(r)?new y(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(t=>{t(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=L,e.errorHandler=new L;function O(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=O;function _(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=_;function U(n){m(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=U;function T(n){m(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=T;function R(n){if(n instanceof Error){const{name:r,message:t}=n,i=n.stacktrace||n.stack;return{$isError:!0,name:r,message:t,stack:i,noTelemetry:y.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=R;const I="Canceled";function m(n){return n instanceof P?!0:n instanceof Error&&n.name===I&&n.message===I}e.isCancellationError=m;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function p(){const n=new Error(I);return n.name=n.message,n}e.canceled=p;function v(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=v;function d(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=d;function f(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function E(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}e.disposed=E;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=a;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=h;class u extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=u;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class y extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof y)return r;const t=new y;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class k extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.BugIndicatingError=k}),define(oe[21],ae([0,1,7]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function O(j,K=0){return j[j.length-(1+K)]}e.tail=O;function _(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=_;function U(j,K,ee=(ce,ue)=>ce===ue){if(j===K)return!0;if(!j||!K||j.length!==K.length)return!1;for(let ce=0,ue=j.length;ce<ue;ce++)if(!ee(j[ce],K[ce]))return!1;return!0}e.equals=U;function T(j,K){const ee=j.length-1;K<ee&&(j[K]=j[ee]),j.pop()}e.removeFastWithoutKeepingOrder=T;function R(j,K,ee){return I(j.length,ce=>ee(j[ce],K))}e.binarySearch=R;function I(j,K){let ee=0,ce=j-1;for(;ee<=ce;){const ue=(ee+ce)/2|0,fe=K(ue);if(fe<0)ee=ue+1;else if(fe>0)ce=ue-1;else return ue}return-(ee+1)}e.binarySearch2=I;function m(j,K){let ee=0,ce=j.length;if(ce===0)return 0;for(;ee<ce;){const ue=Math.floor((ee+ce)/2);K(j[ue])?ce=ue:ee=ue+1}return ee}e.findFirstInSorted=m;function P(j,K,ee){if(j=j|0,j>=K.length)throw new TypeError("invalid index");const ce=K[Math.floor(K.length*Math.random())],ue=[],fe=[],ve=[];for(const Ee of K){const Ce=ee(Ee,ce);Ce<0?ue.push(Ee):Ce>0?fe.push(Ee):ve.push(Ee)}return j<ue.length?P(j,ue,ee):j<ue.length+ve.length?ve[0]:P(j-(ue.length+ve.length),fe,ee)}e.quickSelect=P;function p(j,K){const ee=[];let ce;for(const ue of j.slice(0).sort(K))!ce||K(ce[0],ue)!==0?(ce=[ue],ee.push(ce)):ce.push(ue);return ee}e.groupBy=p;function v(j,K,ee){const ce=[];function ue(Ee,Ce,Re){if(Ce===0&&Re.length===0)return;const Le=ce[ce.length-1];Le&&Le.start+Le.deleteCount===Ee?(Le.deleteCount+=Ce,Le.toInsert.push(...Re)):ce.push({start:Ee,deleteCount:Ce,toInsert:Re})}let fe=0,ve=0;for(;;){if(fe===j.length){ue(fe,0,K.slice(ve));break}if(ve===K.length){ue(fe,j.length-fe,[]);break}const Ee=j[fe],Ce=K[ve],Re=ee(Ee,Ce);Re===0?(fe+=1,ve+=1):Re<0?(ue(fe,1,[]),fe+=1):Re>0&&(ue(fe,0,[Ce]),ve+=1)}return ce}e.sortedDiff=v;function d(j,K,ee){const ce=v(j,K,ee),ue=[],fe=[];for(const ve of ce)ue.push(...j.slice(ve.start,ve.start+ve.deleteCount)),fe.push(...ve.toInsert);return{removed:ue,added:fe}}e.delta=d;function f(j,K,ee){if(ee===0)return[];const ce=j.slice(0,ee).sort(K);return a(j,K,ce,ee,j.length),ce}e.top=f;function E(j,K,ee,ce,ue){return ee===0?Promise.resolve([]):new Promise((fe,ve)=>{(async()=>{const Ee=j.length,Ce=j.slice(0,ee).sort(K);for(let Re=ee,Le=Math.min(ee+ce,Ee);Re<Ee;Re=Le,Le=Math.min(Le+ce,Ee)){if(Re>ee&&await new Promise(je=>setTimeout(je)),ue&&ue.isCancellationRequested)throw new L.CancellationError;a(j,K,Ce,Re,Le)}return Ce})().then(fe,ve)})}e.topAsync=E;function a(j,K,ee,ce,ue){for(const fe=ee.length;ce<ue;ce++){const ve=j[ce];if(K(ve,ee[fe-1])<0){ee.pop();const Ee=m(ee,Ce=>K(ve,Ce)<0);ee.splice(Ee,0,ve)}}}function h(j){return j.filter(K=>!!K)}e.coalesce=h;function u(j){let K=0;for(let ee=0;ee<j.length;ee++)j[ee]&&(j[K]=j[ee],K+=1);j.length=K}e.coalesceInPlace=u;function b(j,K,ee){j.splice(ee,0,j.splice(K,1)[0])}e.move=b;function y(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=y;function k(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=k;function n(j,K=ee=>ee){const ee=new Set;return j.filter(ce=>{const ue=K(ce);return ee.has(ue)?!1:(ee.add(ue),!0)})}e.distinct=n;function r(j){const K=new Set;return ee=>{const ce=j(ee);return K.has(ce)?!1:(K.add(ce),!0)}}e.uniqueFilter=r;function t(j,K){const ee=i(j,K);if(ee!==-1)return j[ee]}e.findLast=t;function i(j,K){for(let ee=j.length-1;ee>=0;ee--){const ce=j[ee];if(K(ce))return ee}return-1}e.lastIndex=i;function s(j,K){return j.length>0?j[0]:K}e.firstOrDefault=s;function o(j,K){return j.length>0?j[j.length-1]:K}e.lastOrDefault=o;function l(j,K,ee=(ce,ue)=>ce===ue){let ce=0;for(let ue=0,fe=Math.min(j.length,K.length);ue<fe&&ee(j[ue],K[ue]);ue++)ce++;return ce}e.commonPrefixLength=l;function w(j){return[].concat(...j)}e.flatten=w;function S(j,K){let ee=typeof K=="number"?j:0;typeof K=="number"?ee=j:(ee=0,K=j);const ce=[];if(ee<=K)for(let ue=ee;ue<K;ue++)ce.push(ue);else for(let ue=ee;ue>K;ue--)ce.push(ue);return ce}e.range=S;function c(j,K,ee){return j.reduce((ce,ue)=>(ce[K(ue)]=ee?ee(ue):ue,ce),Object.create(null))}e.index=c;function C(j,K){return j.push(K),()=>D(j,K)}e.insert=C;function D(j,K){const ee=j.indexOf(K);if(ee>-1)return j.splice(ee,1),K}e.remove=D;function N(j,K,ee){const ce=j.slice(0,K),ue=j.slice(K);return ce.concat(ee,ue)}e.arrayInsert=N;function F(j,K){let ee;if(typeof K=="number"){let ce=K;ee=()=>{const ue=Math.sin(ce++)*179426549;return ue-Math.floor(ue)}}else ee=Math.random;for(let ce=j.length-1;ce>0;ce-=1){const ue=Math.floor(ee()*(ce+1)),fe=j[ce];j[ce]=j[ue],j[ue]=fe}}e.shuffle=F;function V(j,K){const ee=j.indexOf(K);ee>-1&&(j.splice(ee,1),j.unshift(K))}e.pushToStart=V;function z(j,K){const ee=j.indexOf(K);ee>-1&&(j.splice(ee,1),j.push(K))}e.pushToEnd=z;function x(j,K){for(const ee of K)j.push(ee)}e.pushMany=x;function Q(j,K){return Array.isArray(j)?j.map(K):K(j)}e.mapArrayOrNot=Q;function te(j){return Array.isArray(j)?j:[j]}e.asArray=te;function G(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=G;function J(j,K){for(const ee of j){const ce=K(ee);if(ce!==void 0)return ce}}e.mapFind=J;function B(j,K,ee){const ce=X(j,K),ue=j.length,fe=ee.length;j.length=ue+fe;for(let ve=ue-1;ve>=ce;ve--)j[ve+fe]=j[ve];for(let ve=0;ve<fe;ve++)j[ve+ce]=ee[ve]}e.insertInto=B;function M(j,K,ee,ce){const ue=X(j,K),fe=j.splice(ue,ee);return B(j,ue,ce),fe}e.splice=M;function X(j,K){return K<0?Math.max(K+j.length,0):Math.min(K,j.length)}var ie;(function(j){function K(ue){return ue<0}j.isLessThan=K;function ee(ue){return ue>0}j.isGreaterThan=ee;function ce(ue){return ue===0}j.isNeitherLessOrGreaterThan=ce,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function se(j,K){return(ee,ce)=>K(j(ee),j(ce))}e.compareBy=se;function H(...j){return(K,ee)=>{for(const ce of j){const ue=ce(K,ee);if(!ie.isNeitherLessOrGreaterThan(ue))return ue}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const Z=(j,K)=>j-K;e.numberComparator=Z;function $(j,K){if(j.length===0)return;let ee=j[0];for(let ce=1;ce<j.length;ce++){const ue=j[ce];K(ue,ee)>0&&(ee=ue)}return ee}e.findMaxBy=$;function g(j,K){if(j.length===0)return;let ee=j[0];for(let ce=1;ce<j.length;ce++){const ue=j[ce];K(ue,ee)>=0&&(ee=ue)}return ee}e.findLastMaxBy=g;function A(j,K){return $(j,(ee,ce)=>-K(ee,ce))}e.findMinBy=A;class W{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let ee=this.firstIdx;for(;ee<this.items.length&&K(this.items[ee]);)ee++;const ce=ee===this.firstIdx?null:this.items.slice(this.firstIdx,ee);return this.firstIdx=ee,ce}takeFromEndWhile(K){let ee=this.lastIdx;for(;ee>=0&&K(this.items[ee]);)ee--;const ce=ee===this.lastIdx?null:this.items.slice(ee+1,this.lastIdx+1);return this.lastIdx=ee,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const ee=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,ee}}e.ArrayQueue=W;class q{constructor(K){this.iterate=K}forEach(K){this.iterate(ee=>(K(ee),!0))}toArray(){const K=[];return this.iterate(ee=>(K.push(ee),!0)),K}filter(K){return new q(ee=>this.iterate(ce=>K(ce)?ee(ce):!0))}map(K){return new q(ee=>this.iterate(ce=>ee(K(ce))))}some(K){let ee=!1;return this.iterate(ce=>(ee=K(ce),!ee)),ee}findFirst(K){let ee;return this.iterate(ce=>K(ce)?(ee=ce,!1):!0),ee}findLast(K){let ee;return this.iterate(ce=>(K(ce)&&(ee=ce),!0)),ee}findLastMaxBy(K){let ee,ce=!0;return this.iterate(ue=>((ce||ie.isGreaterThan(K(ue,ee)))&&(ce=!1,ee=ue),!0)),ee}}e.CallbackIterable=q,q.empty=new q(j=>{})}),define(oe[122],ae([0,1,7]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(I,m){if(!I)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=O;function _(I,m="Unreachable"){throw new Error(m)}e.assertNever=_;function U(I){if(!I)throw new L.BugIndicatingError("Assertion Failed")}e.assert=U;function T(I){if(!I()){debugger;I(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function R(I,m){let P=0;for(;P<I.length-1;){const p=I[P],v=I[P+1];if(!m(p,v))return!1;P++}return!0}e.checkAdjacentItems=R}),define(oe[82],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(O){const _=this;let U=!1,T;return function(){return U||(U=!0,T=O.apply(_,arguments)),T}}e.once=L}),define(oe[60],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(O){function _(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}O.is=_;const U=Object.freeze([]);function T(){return U}O.empty=T;function*R(y){yield y}O.single=R;function I(y){return _(y)?y:R(y)}O.wrap=I;function m(y){return y||U}O.from=m;function P(y){return!y||y[Symbol.iterator]().next().done===!0}O.isEmpty=P;function p(y){return y[Symbol.iterator]().next().value}O.first=p;function v(y,k){for(const n of y)if(k(n))return!0;return!1}O.some=v;function d(y,k){for(const n of y)if(k(n))return n}O.find=d;function*f(y,k){for(const n of y)k(n)&&(yield n)}O.filter=f;function*E(y,k){let n=0;for(const r of y)yield k(r,n++)}O.map=E;function*a(...y){for(const k of y)for(const n of k)yield n}O.concat=a;function h(y,k,n){let r=n;for(const t of y)r=k(r,t);return r}O.reduce=h;function*u(y,k,n=y.length){for(k<0&&(k+=y.length),n<0?n+=y.length:n>y.length&&(n=y.length);k<n;k++)yield y[k]}O.slice=u;function b(y,k=Number.POSITIVE_INFINITY){const n=[];if(k===0)return[n,y];const r=y[Symbol.iterator]();for(let t=0;t<k;t++){const i=r.next();if(i.done)return[n,O.empty()];n.push(i.value)}return[n,{[Symbol.iterator](){return r}}]}O.consume=b})(L||(e.Iterable=L={}))}),define(oe[34],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var O;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var _;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(_||(e.ParseErrorCode=_={}));var U;(function(n){n.DEFAULT={allowTrailingComma:!0}})(U||(e.ParseOptions=U={}));function T(n,r=!1){let t=0;const i=n.length;let s="",o=0,l=16,w=0;function S(z){let x=0,Q=0;for(;x<z;){const te=n.charCodeAt(t);if(te>=48&&te<=57)Q=Q*16+te-48;else if(te>=65&&te<=70)Q=Q*16+te-65+10;else if(te>=97&&te<=102)Q=Q*16+te-97+10;else break;t++,x++}return x<z&&(Q=-1),Q}function c(z){t=z,s="",o=0,l=16,w=0}function C(){const z=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&m(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&m(n.charCodeAt(t)))for(t++;t<n.length&&m(n.charCodeAt(t));)t++;else return w=3,n.substring(z,t);let x=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&m(n.charCodeAt(t))){for(t++;t<n.length&&m(n.charCodeAt(t));)t++;x=t}else w=3;return n.substring(z,x)}function D(){let z="",x=t;for(;;){if(t>=i){z+=n.substring(x,t),w=2;break}const Q=n.charCodeAt(t);if(Q===34){z+=n.substring(x,t),t++;break}if(Q===92){if(z+=n.substring(x,t),t++,t>=i){w=2;break}switch(n.charCodeAt(t++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const G=S(4);G>=0?z+=String.fromCharCode(G):w=4;break}default:w=5}x=t;continue}if(Q>=0&&Q<=31)if(I(Q)){z+=n.substring(x,t),w=2;break}else w=6;t++}return z}function N(){if(s="",w=0,o=t,t>=i)return o=i,l=17;let z=n.charCodeAt(t);if(R(z)){do t++,s+=String.fromCharCode(z),z=n.charCodeAt(t);while(R(z));return l=15}if(I(z))return t++,s+=String.fromCharCode(z),z===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(z){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=D(),l=10;case 47:{const x=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!I(n.charCodeAt(t));)t++;return s=n.substring(x,t),l=12}if(n.charCodeAt(t+1)===42){t+=2;const Q=i-1;let te=!1;for(;t<Q;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,te=!0;break}t++}return te||(t++,w=1),s=n.substring(x,t),l=13}return s+=String.fromCharCode(z),t++,l=16}case 45:if(s+=String.fromCharCode(z),t++,t===i||!m(n.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=C(),l=11;default:for(;t<i&&F(z);)t++,z=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(z),t++,l=16}}function F(z){if(R(z)||I(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:c,getPosition:()=>t,scan:r?V:N,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>w}}e.createScanner=T;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function p(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function w(S,c,C,D){o.value=S,o.offset=c,o.length=C,o.type=D,o.colonOffset=void 0,s=o}try{b(n,{onObjectBegin:(S,c)=>{if(r<=S)throw i;s=void 0,l=r>S,t.push("")},onObjectProperty:(S,c,C)=>{if(r<c||(w(S,c,C,"property"),t[t.length-1]=S,r<=c+C))throw i},onObjectEnd:(S,c)=>{if(r<=S)throw i;s=void 0,t.pop()},onArrayBegin:(S,c)=>{if(r<=S)throw i;s=void 0,t.push(0)},onArrayEnd:(S,c)=>{if(r<=S)throw i;s=void 0,t.pop()},onLiteralValue:(S,c,C)=>{if(r<c||(w(S,c,C,k(S)),r<=c+C))throw i},onSeparator:(S,c,C)=>{if(r<=c)throw i;if(S===":"&&s&&s.type==="property")s.colonOffset=c,l=!1,s=void 0;else if(S===","){const D=t[t.length-1];typeof D=="number"?t[t.length-1]=D+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(S){if(S!==i)throw S}return{path:t,previousNode:s,isAtPropertyKey:l,matches:S=>{let c=0;for(let C=0;c<S.length&&C<t.length;C++)if(S[c]===t[C]||S[c]==="*")c++;else if(S[c]!=="**")return!1;return c===S.length}}}e.getLocation=p;function v(n,r=[],t=U.DEFAULT){let i=null,s=[];const o=[];function l(S){Array.isArray(s)?s.push(S):i!==null&&(s[i]=S)}return b(n,{onObjectBegin:()=>{const S={};l(S),o.push(s),s=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const S=[];l(S),o.push(s),s=S,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(S,c,C)=>{r.push({error:S,offset:c,length:C})}},t),s[0]}e.parse=v;function d(n,r=[],t=U.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function o(S){return i.children.push(S),S}b(n,{onObjectBegin:S=>{i=o({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,c,C)=>{i=o({type:"property",offset:c,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:c,length:C,parent:i})},onObjectEnd:(S,c)=>{i.length=S+c-i.offset,i=i.parent,s(S+c)},onArrayBegin:(S,c)=>{i=o({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,c)=>{i.length=S+c-i.offset,i=i.parent,s(S+c)},onLiteralValue:(S,c,C)=>{o({type:k(S),offset:c,length:C,parent:i,value:S}),s(c+C)},onSeparator:(S,c,C)=>{i.type==="property"&&(S===":"?i.colonOffset=c:S===","&&s(c))},onError:(S,c,C)=>{r.push({error:S,offset:c,length:C})}},t);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=d;function f(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=f;function E(n){if(!n.parent||!n.parent.children)return[];const r=E(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=E;function a(n){switch(n.type){case"array":return n.children.map(a);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=a(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=a;function h(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=h;function u(n,r,t=!1){if(h(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=u(i[s],r,t);if(o)return o}return n}}e.findNodeAtOffset=u;function b(n,r,t=U.DEFAULT){const i=T(n,!1);function s(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(se){return se?H=>se(H,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),w=o(r.onObjectProperty),S=s(r.onObjectEnd),c=s(r.onArrayBegin),C=s(r.onArrayEnd),D=o(r.onLiteralValue),N=o(r.onSeparator),F=s(r.onComment),V=o(r.onError),z=t&&t.disallowComments,x=t&&t.allowTrailingComma;function Q(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:z||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(se){case 12:case 13:z?te(10):F();break;case 16:te(1);break;case 15:case 14:break;default:return se}}}function te(se,H=[],Z=[]){if(V(se),H.length+Z.length>0){let $=i.getToken();for(;$!==17;){if(H.indexOf($)!==-1){Q();break}else if(Z.indexOf($)!==-1)break;$=Q()}}}function G(se){const H=i.getTokenValue();return se?D(H):w(H),Q(),!0}function J(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(te(2),se=0)}catch{te(2)}D(se);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return Q(),!0}function B(){return i.getToken()!==10?(te(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(N(":"),Q(),ie()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function M(){l(),Q();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||te(4,[],[]),N(","),Q(),i.getToken()===2&&x)break}else se&&te(6,[],[]);B()||te(4,[],[2,5]),se=!0}return S(),i.getToken()!==2?te(7,[2],[]):Q(),!0}function X(){c(),Q();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||te(4,[],[]),N(","),Q(),i.getToken()===4&&x)break}else se&&te(6,[],[]);ie()||te(4,[],[4,5]),se=!0}return C(),i.getToken()!==4?te(8,[4],[]):Q(),!0}function ie(){switch(i.getToken()){case 3:return X();case 1:return M();case 10:return G(!0);default:return J()}}return Q(),i.getToken()===17?t.allowEmptyContent?!0:(te(4,[],[]),!1):ie()?(i.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.visit=b;function y(n,r){const t=T(n),i=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&i.push(n.substring(o,l)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}e.stripComments=y;function k(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(oe[41],ae([0,1,34]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(m,P,p){let v,d,f,E,a;if(P){for(E=P.offset,a=E+P.length,f=E;f>0&&!I(m,f-1);)f--;let l=a;for(;l<m.length&&!I(m,l);)l++;d=m.substring(f,l),v=T(d,p)}else d=m,v=0,f=0,E=0,a=m.length;const h=R(p,m);let u=!1,b=0,y;p.insertSpaces?y=U(" ",p.tabSize||4):y="	";const k=(0,L.createScanner)(d,!1);let n=!1;function r(){return h+U(y,v+b)}function t(){let l=k.scan();for(u=!1;l===15||l===14;)u=u||l===14,l=k.scan();return n=l===16||k.getTokenError()!==0,l}const i=[];function s(l,w,S){!n&&w<a&&S>E&&m.substring(w,S)!==l&&i.push({offset:w,length:S-w,content:l})}let o=t();if(o!==17){const l=k.getTokenOffset()+f,w=U(y,v);s(w,f,l)}for(;o!==17;){let l=k.getTokenOffset()+k.getTokenLength()+f,w=t(),S="";for(;!u&&(w===12||w===13);){const C=k.getTokenOffset()+f;s(" ",l,C),l=k.getTokenOffset()+k.getTokenLength()+f,S=w===12?r():"",w=t()}if(w===2)o!==1&&(b--,S=r());else if(w===4)o!==3&&(b--,S=r());else{switch(o){case 3:case 1:b++,S=r();break;case 5:case 12:S=r();break;case 13:u?S=r():S=" ";break;case 6:S=" ";break;case 10:if(w===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?S=" ":w!==5&&w!==17&&(n=!0);break;case 16:n=!0;break}u&&(w===12||w===13)&&(S=r())}const c=k.getTokenOffset()+f;s(S,l,c),o=w}return i}e.format=O;function _(m,P){const p=JSON.stringify(m,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?p.replace(/\r\n|\r|\n/g,P.eol):p}e.toFormattedString=_;function U(m,P){let p="";for(let v=0;v<P;v++)p+=m;return p}function T(m,P){let p=0,v=0;const d=P.tabSize||4;for(;p<m.length;){const f=m.charAt(p);if(f===" ")v++;else if(f==="	")v+=d;else break;p++}return Math.floor(v/d)}function R(m,P){for(let p=0;p<P.length;p++){const v=P.charAt(p);if(v==="\r")return p+1<P.length&&P.charAt(p+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=R;function I(m,P){return`\r
`.indexOf(m.charAt(P))!==-1}e.isEOL=I}),define(oe[83],ae([0,1,34,41]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function _(m,P,p){return U(m,P,void 0,p)}e.removeProperty=_;function U(m,P,p,v,d){const f=P.slice(),E=[],a=(0,L.parseTree)(m,E);let h,u;for(;f.length>0&&(u=f.pop(),h=(0,L.findNodeAtLocation)(a,f),h===void 0&&p!==void 0);)typeof u=="string"?p={[u]:p}:p=[p];if(h)if(h.type==="object"&&typeof u=="string"&&Array.isArray(h.children)){const b=(0,L.findNodeAtLocation)(h,[u]);if(b!==void 0)if(p===void 0){if(!b.parent)throw new Error("Malformed AST");const y=h.children.indexOf(b.parent);let k,n=b.parent.offset+b.parent.length;if(y>0){const r=h.children[y-1];k=r.offset+r.length}else k=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return T(m,{offset:k,length:n-k,content:""},v)}else return T(m,{offset:b.offset,length:b.length,content:JSON.stringify(p)},v);else{if(p===void 0)return[];const y=`${JSON.stringify(u)}: ${JSON.stringify(p)}`,k=d?d(h.children.map(r=>r.children[0].value)):h.children.length;let n;if(k>0){const r=h.children[k-1];n={offset:r.offset+r.length,length:0,content:","+y}}else h.children.length===0?n={offset:h.offset+1,length:0,content:y}:n={offset:h.offset+1,length:0,content:y+","};return T(m,n,v)}}else if(h.type==="array"&&typeof u=="number"&&Array.isArray(h.children))if(p!==void 0){const b=`${JSON.stringify(p)}`;let y;if(h.children.length===0||u===0)y={offset:h.offset+1,length:0,content:h.children.length===0?b:b+","};else{const k=u===-1||u>h.children.length?h.children.length:u,n=h.children[k-1];y={offset:n.offset+n.length,length:0,content:","+b}}return T(m,y,v)}else{const b=u,y=h.children[b];let k;if(h.children.length===1)k={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===b){const n=h.children[b-1],r=n.offset+n.length,t=h.offset+h.length;k={offset:r,length:t-2-r,content:""}}else k={offset:y.offset,length:h.children[b+1].offset-y.offset,content:""};return T(m,k,v)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${h.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return T(m,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(p)},v)}}e.setProperty=U;function T(m,P,p){let v=R(m,P),d=P.offset,f=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;d>0&&!(0,O.isEOL)(v,d-1);)d--;for(;f<v.length&&!(0,O.isEOL)(v,f);)f++}const E=(0,O.format)(v,{offset:d,length:f-d},p);for(let h=E.length-1;h>=0;h--){const u=E[h];v=R(v,u),d=Math.min(d,u.offset),f=Math.max(f,u.offset+u.length),f+=u.content.length-u.length}const a=m.length-(v.length-f)-d;return[{offset:d,length:a,content:v.substring(d,f)}]}e.withFormatting=T;function R(m,P){return m.substring(0,P.offset)+P.content+m.substring(P.offset+P.length)}e.applyEdit=R;function I(m,P){const p=P.slice(0).sort((d,f)=>{const E=d.offset-f.offset;return E===0?d.length-f.length:E});let v=m.length;for(let d=p.length-1;d>=0;d--){const f=p[d];if(f.offset+f.length<=v)m=R(m,f);else throw new Error("Overlapping edit");v=f.offset}return m}e.applyEdits=I}),define(oe[84],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(_){this.executor=_,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=L}),define(oe[2],ae([0,1,82,60]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const _=!1;let U=null;function T(o){U=o}if(e.setDisposableTracker=T,_){const o="__is_disposable_tracked__";T(new class{trackDisposable(l){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[o]||console.log(w)},3e3)}setParent(l,w){if(l&&l!==u.None)try{l[o]=!0}catch{}}markAsDisposed(l){if(l&&l!==u.None)try{l[o]=!0}catch{}}markAsSingleton(l){}})}function R(o){return U?.trackDisposable(o),o}function I(o){U?.markAsDisposed(o)}function m(o,l){U?.setParent(o,l)}function P(o,l){if(U)for(const w of o)U.setParent(w,l)}function p(o){return U?.markAsSingleton(o),o}e.markAsSingleton=p;function v(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=v;function d(o){if(O.Iterable.is(o)){const l=[];for(const w of o)if(w)try{w.dispose()}catch(S){l.push(S)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=d;function f(o){for(const l of o)v(l)&&l.dispose();return[]}e.disposeIfDisposable=f;function E(...o){const l=a(()=>d(o));return P(o,l),l}e.combinedDisposable=E;function a(o){const l=R({dispose:(0,L.once)(()=>{I(l),o()})});return l}e.toDisposable=a;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return m(l,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new h,R(this),m(this._store,this)}dispose(){I(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&m(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,I(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&m(l,null),l}}e.MutableDisposable=b;class y{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=y;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(l){let w=l;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,I(this))},this}}e.SafeDisposable=k;class n{constructor(){this.references=new Map}acquire(l,...w){let S=this.references.get(l);S||(S={counter:0,object:this.createReferencedObject(l,...w)},this.references.set(l,S));const{object:c}=S,C=(0,L.once)(()=>{--S.counter===0&&(this.destroyReferencedObject(l,S.object),this.references.delete(l))});return S.counter++,{object:c,dispose:C}}}e.ReferenceCollection=n;class r{constructor(l){this.referenceCollection=l}async acquire(l,...w){const S=this.referenceCollection.acquire(l,...w);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(c){throw S.dispose(),c}}}e.AsyncReferenceCollection=r;class t{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=t;function i(o){const l=new h;try{o(l)}finally{l.dispose()}}e.disposeOnReturn=i;class s{constructor(){this._store=new Map,this._isDisposed=!1,R(this)}dispose(){I(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(l){return this._store.has(l)}get(l){return this._store.get(l)}set(l,w,S=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this._store.get(l)?.dispose(),this._store.set(l,w)}deleteAndDispose(l){this._store.get(l)?.dispose(),this._store.delete(l)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(oe[85],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(U){this.element=U,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class O{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let U=this._first;for(;U!==L.Undefined;){const T=U.next;U.prev=L.Undefined,U.next=L.Undefined,U=T}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(U){return this._insert(U,!1)}push(U){return this._insert(U,!0)}_insert(U,T){const R=new L(U);if(this._first===L.Undefined)this._first=R,this._last=R;else if(T){const m=this._last;this._last=R,R.prev=m,m.next=R}else{const m=this._first;this._first=R,R.next=m,m.prev=R}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const U=this._first.element;return this._remove(this._first),U}}pop(){if(this._last!==L.Undefined){const U=this._last.element;return this._remove(this._last),U}}_remove(U){if(U.prev!==L.Undefined&&U.next!==L.Undefined){const T=U.prev;T.next=U.next,U.next.prev=T}else U.prev===L.Undefined&&U.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):U.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):U.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let U=this._first;for(;U!==L.Undefined;)yield U.element,U=U.next}}e.LinkedList=O}),define(oe[35],ae([0,1]),function(ne,e){"use strict";var L,O,_;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function U(E,a,h){let u=E.get(a);return u===void 0&&(u=h,E.set(a,u)),u}e.getOrSet=U;function T(E){const a=[];return E.forEach((h,u)=>{a.push(`${u} => ${h}`)}),`Map(${E.size}) {${a.join(", ")}}`}e.mapToString=T;function R(E){const a=[];return E.forEach(h=>{a.push(h)}),`Set(${E.size}) {${a.join(", ")}}`}e.setToString=R;class I{constructor(a,h){this.uri=a,this.value=h}}class m{constructor(a,h){this[L]="ResourceMap",a instanceof m?(this.map=new Map(a.map),this.toKey=h??m.defaultToKey):(this.map=new Map,this.toKey=a??m.defaultToKey)}set(a,h){return this.map.set(this.toKey(a),new I(a,h)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,h){typeof h<"u"&&(a=a.bind(h));for(const[u,b]of this.map)a(b.value,b.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=m,m.defaultToKey=E=>E.toString();class P{constructor(a,h){this[O]="ResourceSet",!a||typeof a=="function"?this._map=new m(a):(this._map=new m(h),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,h){this._map.forEach((u,b)=>a.call(h,b,b,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var p;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class v{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,h=0){const u=this._map.get(a);if(u)return h!==0&&this.touch(u,h),u.value}set(a,h,u=0){let b=this._map.get(a);if(b)b.value=h,u!==0&&this.touch(b,u);else{switch(b={key:a,value:h,next:void 0,previous:void 0},u){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(a,b),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const h=this._map.get(a);if(h)return this._map.delete(a),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,h){const u=this._state;let b=this._head;for(;b;){if(h?a.bind(h)(b.value,b.key,this):a(b.value,b.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const a=this,h=this._state;let u=this._head;const b={[Symbol.iterator](){return b},next(){if(a._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.key,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return b}values(){const a=this,h=this._state;let u=this._head;const b={[Symbol.iterator](){return b},next(){if(a._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.value,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return b}entries(){const a=this,h=this._state;let u=this._head;const b={[Symbol.iterator](){return b},next(){if(a._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:[u.key,u.value],done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return b}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let h=this._head,u=this.size;for(;h&&u>a;)this._map.delete(h.key),h=h.next,u--;this._head=h,this._size=u,h&&(h.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const h=a.next,u=a.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}a.next=void 0,a.previous=void 0,this._state++}touch(a,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(a===this._head)return;const u=a.next,b=a.previous;a===this._tail?(b.next=void 0,this._tail=b):(u.previous=b,b.next=u),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(h===2){if(a===this._tail)return;const u=a.next,b=a.previous;a===this._head?(u.previous=void 0,this._head=u):(u.previous=b,b.next=u),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((h,u)=>{a.push([u,h])}),a}fromJSON(a){this.clear();for(const[h,u]of a)this.set(h,u)}}e.LinkedMap=v;class d extends v{constructor(a,h=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,h=2){return super.get(a,h)}peek(a){return super.get(a,0)}set(a,h){return super.set(a,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class f{constructor(){this.map=new Map}add(a){return this.map.set(a,(this.map.get(a)||0)+1),this}delete(a){let h=this.map.get(a)||0;return h===0?!1:(h--,h===0?this.map.delete(a):this.map.set(a,h),!0)}has(a){return this.map.has(a)}}e.CounterSet=f}),define(oe[86],ae([0,1,35]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new L.LRUCache(1e4);function _(m){return I(m,"NFC",O)}e.normalizeNFC=_;const U=new L.LRUCache(1e4);function T(m){return I(m,"NFD",U)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function I(m,P,p){if(!m)return m;const v=p.get(m);if(v)return v;let d;return R.test(m)?d=m.normalize(P):d=m,p.set(m,d),d}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(P){return T(P).replace(m,"")}}()}),function(){function ne(_){const U=[];typeof _=="number"&&U.push("code/timeOrigin",_);function T(I){U.push(I,Date.now())}function R(){const I=[];for(let m=0;m<U.length;m+=2)I.push({name:U[m],startTime:U[m+1]});return I}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const U=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const T of performance.getEntriesByType("mark"))U.push({name:T.name,startTime:Math.round(_+T.startTime)});return U}};if(typeof process=="object"){const _=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function L(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=L(O))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var O in L)(typeof exports=="object"?exports:ne)[O]=L[O]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function L(O){if(e[O])return e[O].exports;var _=e[O]={i:O,l:!1,exports:{}};return ne[O].call(_.exports,_,_.exports,L),_.l=!0,_.exports}return L.m=ne,L.c=e,L.d=function(O,_,U){L.o(O,_)||Object.defineProperty(O,_,{enumerable:!0,get:U})},L.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},L.t=function(O,_){if(1&_&&(O=L(O)),8&_||4&_&&typeof O=="object"&&O&&O.__esModule)return O;var U=Object.create(null);if(L.r(U),Object.defineProperty(U,"default",{enumerable:!0,value:O}),2&_&&typeof O!="string")for(var T in O)L.d(U,T,function(R){return O[R]}.bind(null,T));return U},L.n=function(O){var _=O&&O.__esModule?function(){return O.default}:function(){return O};return L.d(_,"a",_),_},L.o=function(O,_){return Object.prototype.hasOwnProperty.call(O,_)},L.p="",L(L.s=0)}([function(ne,e,L){(function(O){var _;e=ne.exports=Z,_=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var U=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],I=e.src=[],m=0,P=m++;I[P]="0|[1-9]\\d*";var p=m++;I[p]="[0-9]+";var v=m++;I[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=m++;I[d]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var f=m++;I[f]="("+I[p]+")\\.("+I[p]+")\\.("+I[p]+")";var E=m++;I[E]="(?:"+I[P]+"|"+I[v]+")";var a=m++;I[a]="(?:"+I[p]+"|"+I[v]+")";var h=m++;I[h]="(?:-("+I[E]+"(?:\\."+I[E]+")*))";var u=m++;I[u]="(?:-?("+I[a]+"(?:\\."+I[a]+")*))";var b=m++;I[b]="[0-9A-Za-z-]+";var y=m++;I[y]="(?:\\+("+I[b]+"(?:\\."+I[b]+")*))";var k=m++,n="v?"+I[d]+I[h]+"?"+I[y]+"?";I[k]="^"+n+"$";var r="[v=\\s]*"+I[f]+I[u]+"?"+I[y]+"?",t=m++;I[t]="^"+r+"$";var i=m++;I[i]="((?:<|>)?=?)";var s=m++;I[s]=I[p]+"|x|X|\\*";var o=m++;I[o]=I[P]+"|x|X|\\*";var l=m++;I[l]="[v=\\s]*("+I[o]+")(?:\\.("+I[o]+")(?:\\.("+I[o]+")(?:"+I[h]+")?"+I[y]+"?)?)?";var w=m++;I[w]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[u]+")?"+I[y]+"?)?)?";var S=m++;I[S]="^"+I[i]+"\\s*"+I[l]+"$";var c=m++;I[c]="^"+I[i]+"\\s*"+I[w]+"$";var C=m++;I[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=m++;I[D]="(?:~>?)";var N=m++;I[N]="(\\s*)"+I[D]+"\\s+",R[N]=new RegExp(I[N],"g");var F=m++;I[F]="^"+I[D]+I[l]+"$";var V=m++;I[V]="^"+I[D]+I[w]+"$";var z=m++;I[z]="(?:\\^)";var x=m++;I[x]="(\\s*)"+I[z]+"\\s+",R[x]=new RegExp(I[x],"g");var Q=m++;I[Q]="^"+I[z]+I[l]+"$";var te=m++;I[te]="^"+I[z]+I[w]+"$";var G=m++;I[G]="^"+I[i]+"\\s*("+r+")$|^$";var J=m++;I[J]="^"+I[i]+"\\s*("+n+")$|^$";var B=m++;I[B]="(\\s*)"+I[i]+"\\s*("+r+"|"+I[l]+")",R[B]=new RegExp(I[B],"g");var M=m++;I[M]="^\\s*("+I[l]+")\\s+-\\s+("+I[l]+")\\s*$";var X=m++;I[X]="^\\s*("+I[w]+")\\s+-\\s+("+I[w]+")\\s*$";var ie=m++;I[ie]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)_(se,I[se]),R[se]||(R[se]=new RegExp(I[se]));function H(le,de){if(le instanceof Z)return le;if(typeof le!="string"||le.length>U||!(de?R[t]:R[k]).test(le))return null;try{return new Z(le,de)}catch{return null}}function Z(le,de){if(le instanceof Z){if(le.loose===de)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>U)throw new TypeError("version is longer than "+U+" characters");if(!(this instanceof Z))return new Z(le,de);_("SemVer",le,de),this.loose=de;var ge=le.trim().match(de?R[t]:R[k]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<T)return Pe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=H,e.valid=function(le,de){var ge=H(le,de);return ge?ge.version:null},e.clean=function(le,de){var ge=H(le.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(le){return _("SemVer.compare",this.version,this.loose,le),le instanceof Z||(le=new Z(le,this.loose)),this.compareMain(le)||this.comparePre(le)},Z.prototype.compareMain=function(le){return le instanceof Z||(le=new Z(le,this.loose)),g(this.major,le.major)||g(this.minor,le.minor)||g(this.patch,le.patch)},Z.prototype.comparePre=function(le){if(le instanceof Z||(le=new Z(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ie=le.prerelease[de];if(_("prerelease compare",de,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return g(ge,Ie)}while(++de)},Z.prototype.inc=function(le,de){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,de,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new Z(le,ge).inc(de,Ie).version}catch{return null}},e.diff=function(le,de){if(j(le,de))return null;var ge=H(le),Ie=H(de);if(ge.prerelease.length||Ie.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=g;var $=/^[0-9]+$/;function g(le,de){var ge=$.test(le),Ie=$.test(de);return ge&&Ie&&(le=+le,de=+de),ge&&!Ie?-1:Ie&&!ge?1:le<de?-1:le>de?1:0}function A(le,de,ge){return new Z(le,ge).compare(new Z(de,ge))}function W(le,de,ge){return A(le,de,ge)>0}function q(le,de,ge){return A(le,de,ge)<0}function j(le,de,ge){return A(le,de,ge)===0}function K(le,de,ge){return A(le,de,ge)!==0}function ee(le,de,ge){return A(le,de,ge)>=0}function ce(le,de,ge){return A(le,de,ge)<=0}function ue(le,de,ge,Ie){var Pe;switch(de){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le!==ge;break;case"":case"=":case"==":Pe=j(le,ge,Ie);break;case"!=":Pe=K(le,ge,Ie);break;case">":Pe=W(le,ge,Ie);break;case">=":Pe=ee(le,ge,Ie);break;case"<":Pe=q(le,ge,Ie);break;case"<=":Pe=ce(le,ge,Ie);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function fe(le,de){if(le instanceof fe){if(le.loose===de)return le;le=le.value}if(!(this instanceof fe))return new fe(le,de);_("comparator",le,de),this.loose=de,this.parse(le),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,_("comp",this)}e.rcompareIdentifiers=function(le,de){return g(de,le)},e.major=function(le,de){return new Z(le,de).major},e.minor=function(le,de){return new Z(le,de).minor},e.patch=function(le,de){return new Z(le,de).patch},e.compare=A,e.compareLoose=function(le,de){return A(le,de,!0)},e.rcompare=function(le,de,ge){return A(de,le,ge)},e.sort=function(le,de){return le.sort(function(ge,Ie){return e.compare(ge,Ie,de)})},e.rsort=function(le,de){return le.sort(function(ge,Ie){return e.rcompare(ge,Ie,de)})},e.gt=W,e.lt=q,e.eq=j,e.neq=K,e.gte=ee,e.lte=ce,e.cmp=ue,e.Comparator=fe;var ve={};function Ee(le,de){if(le instanceof Ee)return le.loose===de?le:new Ee(le.raw,de);if(le instanceof fe)return new Ee(le.value,de);if(!(this instanceof Ee))return new Ee(le,de);if(this.loose=de,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function Ce(le){return!le||le.toLowerCase()==="x"||le==="*"}function Re(le,de,ge,Ie,Pe,Ne,ke,We,Ue,Me,Fe,_e,re){return((de=Ce(ge)?"":Ce(Ie)?">="+ge+".0.0":Ce(Pe)?">="+ge+"."+Ie+".0":">="+de)+" "+(We=Ce(Ue)?"":Ce(Me)?"<"+(+Ue+1)+".0.0":Ce(Fe)?"<"+Ue+"."+(+Me+1)+".0":_e?"<="+Ue+"."+Me+"."+Fe+"-"+_e:"<="+We)).trim()}function Le(le,de){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<le.length;ge++)if(_(le[ge].semver),le[ge].semver!==ve&&le[ge].semver.prerelease.length>0){var Ie=le[ge].semver;if(Ie.major===de.major&&Ie.minor===de.minor&&Ie.patch===de.patch)return!0}return!1}return!0}function je(le,de,ge){try{de=new Ee(de,ge)}catch{return!1}return de.test(le)}function Ke(le,de,ge,Ie){var Pe,Ne,ke,We,Ue;switch(le=new Z(le,Ie),de=new Ee(de,Ie),ge){case">":Pe=W,Ne=ce,ke=q,We=">",Ue=">=";break;case"<":Pe=q,Ne=ee,ke=W,We="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(le,de,Ie))return!1;for(var Me=0;Me<de.set.length;++Me){var Fe=de.set[Me],_e=null,re=null;if(Fe.forEach(function(he){he.semver===ve&&(he=new fe(">=0.0.0")),_e=_e||he,re=re||he,Pe(he.semver,_e.semver,Ie)?_e=he:ke(he.semver,re.semver,Ie)&&(re=he)}),_e.operator===We||_e.operator===Ue||(!re.operator||re.operator===We)&&Ne(le,re.semver)||re.operator===Ue&&ke(le,re.semver))return!1}return!0}fe.prototype.parse=function(le){var de=this.loose?R[G]:R[J],ge=le.match(de);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new Z(ge[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(le){return _("Comparator.test",le,this.loose),this.semver===ve||(typeof le=="string"&&(le=new Z(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(le,de){if(!(le instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(le.value,de),je(this.value,ge,de);if(le.operator==="")return ge=new Ee(this.value,de),je(le.semver,ge,de);var Ie=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ne=this.semver.version===le.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),We=ue(this.semver,"<",le.semver,de)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ue=ue(this.semver,">",le.semver,de)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ie||Pe||Ne&&ke||We||Ue},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(le){var de=this.loose;le=le.trim(),_("range",le,de);var ge=de?R[X]:R[M];le=le.replace(ge,Re),_("hyphen replace",le),le=le.replace(R[B],"$1$2$3"),_("comparator trim",le,R[B]),le=(le=(le=le.replace(R[N],"$1~")).replace(R[x],"$1^")).split(/\s+/).join(" ");var Ie=de?R[G]:R[J],Pe=le.split(" ").map(function(Ne){return function(ke,We){return _("comp",ke),ke=function(Ue,Me){return Ue.trim().split(/\s+/).map(function(Fe){return function(_e,re){_("caret",_e,re);var he=re?R[te]:R[Q];return _e.replace(he,function(me,Se,ye,be,De){var Ae;return _("caret",_e,me,Se,ye,be,De),Ce(Se)?Ae="":Ce(ye)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(be)?Ae=Se==="0"?">="+Se+"."+ye+".0 <"+Se+"."+(+ye+1)+".0":">="+Se+"."+ye+".0 <"+(+Se+1)+".0.0":De?(_("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ae=Se==="0"?ye==="0"?">="+Se+"."+ye+"."+be+De+" <"+Se+"."+ye+"."+(+be+1):">="+Se+"."+ye+"."+be+De+" <"+Se+"."+(+ye+1)+".0":">="+Se+"."+ye+"."+be+De+" <"+(+Se+1)+".0.0"):(_("no pr"),Ae=Se==="0"?ye==="0"?">="+Se+"."+ye+"."+be+" <"+Se+"."+ye+"."+(+be+1):">="+Se+"."+ye+"."+be+" <"+Se+"."+(+ye+1)+".0":">="+Se+"."+ye+"."+be+" <"+(+Se+1)+".0.0"),_("caret return",Ae),Ae})}(Fe,Me)}).join(" ")}(ke,We),_("caret",ke),ke=function(Ue,Me){return Ue.trim().split(/\s+/).map(function(Fe){return function(_e,re){var he=re?R[V]:R[F];return _e.replace(he,function(me,Se,ye,be,De){var Ae;return _("tilde",_e,me,Se,ye,be,De),Ce(Se)?Ae="":Ce(ye)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(be)?Ae=">="+Se+"."+ye+".0 <"+Se+"."+(+ye+1)+".0":De?(_("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ae=">="+Se+"."+ye+"."+be+De+" <"+Se+"."+(+ye+1)+".0"):Ae=">="+Se+"."+ye+"."+be+" <"+Se+"."+(+ye+1)+".0",_("tilde return",Ae),Ae})}(Fe,Me)}).join(" ")}(ke,We),_("tildes",ke),ke=function(Ue,Me){return _("replaceXRanges",Ue,Me),Ue.split(/\s+/).map(function(Fe){return function(_e,re){_e=_e.trim();var he=re?R[c]:R[S];return _e.replace(he,function(me,Se,ye,be,De,Ae){_("xRange",_e,me,Se,ye,be,De,Ae);var ze=Ce(ye),Te=ze||Ce(be),$e=Te||Ce(De);return Se==="="&&$e&&(Se=""),ze?me=Se===">"||Se==="<"?"<0.0.0":"*":Se&&$e?(Te&&(be=0),$e&&(De=0),Se===">"?(Se=">=",Te?(ye=+ye+1,be=0,De=0):$e&&(be=+be+1,De=0)):Se==="<="&&(Se="<",Te?ye=+ye+1:be=+be+1),me=Se+ye+"."+be+"."+De):Te?me=">="+ye+".0.0 <"+(+ye+1)+".0.0":$e&&(me=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0"),_("xRange return",me),me})}(Fe,Me)}).join(" ")}(ke,We),_("xrange",ke),ke=function(Ue,Me){return _("replaceStars",Ue,Me),Ue.trim().replace(R[ie],"")}(ke,We),_("stars",ke),ke}(Ne,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ne){return!!Ne.match(Ie)})),Pe=Pe.map(function(Ne){return new fe(Ne,de)})},Ee.prototype.intersects=function(le,de){if(!(le instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return le.set.some(function(Pe){return Pe.every(function(Ne){return Ie.intersects(Ne,de)})})})})},e.toComparators=function(le,de){return new Ee(le,de).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new Z(le,this.loose));for(var de=0;de<this.set.length;de++)if(Le(this.set[de],le))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(le,de,ge){var Ie=null,Pe=null;try{var Ne=new Ee(de,ge)}catch{return null}return le.forEach(function(ke){Ne.test(ke)&&(Ie&&Pe.compare(ke)!==-1||(Pe=new Z(Ie=ke,ge)))}),Ie},e.minSatisfying=function(le,de,ge){var Ie=null,Pe=null;try{var Ne=new Ee(de,ge)}catch{return null}return le.forEach(function(ke){Ne.test(ke)&&(Ie&&Pe.compare(ke)!==1||(Pe=new Z(Ie=ke,ge)))}),Ie},e.validRange=function(le,de){try{return new Ee(le,de).range||"*"}catch{return null}},e.ltr=function(le,de,ge){return Ke(le,de,"<",ge)},e.gtr=function(le,de,ge){return Ke(le,de,">",ge)},e.outside=Ke,e.prerelease=function(le,de){var ge=H(le,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,de,ge){return le=new Ee(le,ge),de=new Ee(de,ge),le.intersects(de)},e.coerce=function(le){if(le instanceof Z)return le;if(typeof le!="string")return null;var de=le.match(R[C]);return de==null?null:H((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,L(1))},function(ne,e){var L,O,_=ne.exports={};function U(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(a){if(L===setTimeout)return setTimeout(a,0);if((L===U||!L)&&setTimeout)return L=setTimeout,setTimeout(a,0);try{return L(a,0)}catch{try{return L.call(null,a,0)}catch{return L.call(this,a,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:U}catch{L=U}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var I,m=[],P=!1,p=-1;function v(){P&&I&&(P=!1,I.length?m=I.concat(m):p=-1,m.length&&d())}function d(){if(!P){var a=R(v);P=!0;for(var h=m.length;h;){for(I=m,m=[];++p<h;)I&&I[p].run();p=-1,h=m.length}I=null,P=!1,function(u){if(O===clearTimeout)return clearTimeout(u);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(u);try{O(u)}catch{try{return O.call(null,u)}catch{return O.call(this,u)}}}(a)}}function f(a,h){this.fun=a,this.array=h}function E(){}_.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)h[u-1]=arguments[u];m.push(new f(a,h)),m.length!==1||P||R(d)},f.prototype.run=function(){this.fun.apply(null,this.array)},_.title="browser",_.browser=!0,_.env={},_.argv=[],_.version="",_.versions={},_.on=E,_.addListener=E,_.once=E,_.off=E,_.removeListener=E,_.removeAllListeners=E,_.emit=E,_.prependListener=E,_.prependOnceListener=E,_.listeners=function(a){return[]},_.binding=function(a){throw new Error("process.binding is not supported")},_.cwd=function(){return"/"},_.chdir=function(a){throw new Error("process.chdir is not supported")},_.umask=function(){return 0}}])}),define(oe[123],ae([0,1]),function(ne,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(R,I,m){this.level=R,this.key=I,this.value=m,this.forward=[]}}const _=void 0;class U{constructor(R,I=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new O(this._maxLevel,_,_)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,_,_)}has(R){return!!U._search(this,R,this.comparator)}get(R){return U._search(this,R,this.comparator)?.value}set(R,I){return U._insert(this,R,I,this.comparator)&&(this._size+=1),this}delete(R){const I=U._delete(this,R,this.comparator);return I&&(this._size-=1),I}forEach(R,I){let m=this._header.forward[0];for(;m;)R.call(I,m.value,m.key,this),m=m.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",I=this._header.forward[0];for(;I;)R+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return R}static _search(R,I,m){let P=R._header;for(let p=R._level-1;p>=0;p--)for(;P.forward[p]&&m(P.forward[p].key,I)<0;)P=P.forward[p];if(P=P.forward[0],P&&m(P.key,I)===0)return P}static _insert(R,I,m,P){const p=[];let v=R._header;for(let d=R._level-1;d>=0;d--){for(;v.forward[d]&&P(v.forward[d].key,I)<0;)v=v.forward[d];p[d]=v}if(v=v.forward[0],v&&P(v.key,I)===0)return v.value=m,!1;{const d=U._randomLevel(R);if(d>R._level){for(let f=R._level;f<d;f++)p[f]=R._header;R._level=d}v=new O(d,I,m);for(let f=0;f<d;f++)v.forward[f]=p[f].forward[f],p[f].forward[f]=v;return!0}}static _randomLevel(R,I=.5){let m=1;for(;Math.random()<I&&m<R._maxLevel;)m+=1;return m}static _delete(R,I,m){const P=[];let p=R._header;for(let v=R._level-1;v>=0;v--){for(;p.forward[v]&&m(p.forward[v].key,I)<0;)p=p.forward[v];P[v]=p}if(p=p.forward[0],!p||m(p.key,I)!==0)return!1;for(let v=0;v<R._level&&P[v].forward[v]===p;v++)P[v].forward[v]=p.forward[v];for(;R._level>0&&R._header.forward[R._level-1]===_;)R._level-=1;return!0}}e.SkipList=U}),define(oe[42],ae([0,1,7,2]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function _(y){const k=y;return k?typeof k.read=="function":!1}e.isReadable=_;function U(y){const k=y;return k?[k.on,k.pause,k.resume,k.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=U;function T(y){const k=y;return k?U(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=T;function R(y,k){return new I(y,k)}e.newWriteableStream=R;class I{constructor(k,n){this.reducer=k,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(k){if(!this.state.destroyed){if(this.state.flowing)this.emitData(k);else if(this.buffer.data.push(k),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(k){this.state.destroyed||(this.state.flowing?this.emitError(k):this.buffer.error.push(k))}end(k){this.state.destroyed||(typeof k<"u"&&this.write(k),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(k){this.listeners.data.slice(0).forEach(n=>n(k))}emitError(k){this.listeners.error.length===0?(0,L.onUnexpectedError)(k):this.listeners.error.slice(0).forEach(n=>n(k))}emitEnd(){this.listeners.end.slice(0).forEach(k=>k())}on(k,n){if(!this.state.destroyed)switch(k){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(k,n){if(this.state.destroyed)return;let r;switch(k){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const k=this.reducer(this.buffer.data);this.emitData(k),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const k of this.buffer.error)this.emitError(k);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(y,k){const n=[];let r;for(;(r=y.read())!==null;)n.push(r);return k(n)}e.consumeReadable=m;function P(y,k,n){const r=[];let t;for(;(t=y.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?k(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return y.read()}}}e.peekReadable=P;function p(y,k){return new Promise((n,r)=>{const t=[];v(y,{onData:i=>{k&&t.push(i)},onError:i=>{k?r(i):n(void 0)},onEnd:()=>{n(k?k(t):void 0)}})})}e.consumeStream=p;function v(y,k){let n=!1;return y.on("error",r=>{n||k.onError(r)}),y.on("end",()=>{n||k.onEnd()}),y.on("data",r=>{n||k.onData(r)}),(0,O.toDisposable)(()=>n=!0)}e.listenStream=v;function d(y,k){return new Promise((n,r)=>{const t=new O.DisposableStore,i=[],s=w=>{if(i.push(w),i.length>k)return t.dispose(),y.pause(),n({stream:y,buffer:i,ended:!1})},o=w=>r(w),l=()=>n({stream:y,buffer:i,ended:!0});t.add((0,O.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),t.add((0,O.toDisposable)(()=>y.removeListener("end",l))),y.on("end",l),t.add((0,O.toDisposable)(()=>y.removeListener("data",s))),y.on("data",s)})}e.peekStream=d;function f(y,k){const n=R(k);return n.end(y),n}e.toStream=f;function E(){const y=R(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=E;function a(y){let k=!1;return{read:()=>k?null:(k=!0,y)}}e.toReadable=a;function h(y,k,n){const r=R(n);return v(y,{onData:t=>r.write(k.data(t)),onError:t=>r.error(k.error?k.error(t):t),onEnd:()=>r.end()}),r}e.transform=h;function u(y,k,n){let r=!1;return{read:()=>{const t=k.read();return r?t:(r=!0,t!==null?n([y,t]):y)}}}e.prefixedReadable=u;function b(y,k,n){let r=!1;const t=R(n);return v(k,{onData:i=>r?t.write(i):(r=!0,t.write(n([y,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(y)),t.end()}}),t}e.prefixedStream=b}),define(oe[16],ae([0,1,84,42]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer<"u",U=new L.Lazy(()=>new Uint8Array(256));let T,R;class I{static alloc(c){return _?new I(Buffer.allocUnsafe(c)):new I(new Uint8Array(c))}static wrap(c){return _&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new I(c)}static fromString(c,C){return!(C?.dontUseNodeBuffer||!1)&&_?new I(Buffer.from(c)):(T||(T=new TextEncoder),new I(T.encode(c)))}static fromByteArray(c){const C=I.alloc(c.length);for(let D=0,N=c.length;D<N;D++)C.buffer[D]=c[D];return C}static concat(c,C){if(typeof C>"u"){C=0;for(let F=0,V=c.length;F<V;F++)C+=c[F].byteLength}const D=I.alloc(C);let N=0;for(let F=0,V=c.length;F<V;F++){const z=c[F];D.set(z,N),N+=z.byteLength}return D}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=I.alloc(this.byteLength);return c.set(this),c}toString(){return _?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(c,C){return new I(this.buffer.subarray(c,C))}set(c,C){if(c instanceof I)this.buffer.set(c.buffer,C);else if(c instanceof Uint8Array)this.buffer.set(c,C);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),C);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return p(this.buffer,c)}writeUInt32BE(c,C){v(this.buffer,c,C)}readUInt32LE(c){return d(this.buffer,c)}writeUInt32LE(c,C){f(this.buffer,c,C)}readUInt8(c){return E(this.buffer,c)}writeUInt8(c,C){a(this.buffer,c,C)}indexOf(c){const C=c instanceof I?c.buffer:c,D=C.byteLength,N=this.buffer,F=N.byteLength;if(D===0)return 0;if(D===1)return N.indexOf(C[0]);if(D>F)return-1;const V=U.value;V.fill(C.length);for(let te=0;te<C.length;te++)V[C[te]]=C.length-te-1;let z=C.length-1,x=z,Q=-1;for(;z<F;)if(N[z]===C[x]){if(x===0){Q=z;break}z--,x--}else z+=Math.max(C.length-x,V[N[z]]),x=C.length-1;return Q}}e.VSBuffer=I;function m(S,c){return S[c+0]<<0>>>0|S[c+1]<<8>>>0}e.readUInt16LE=m;function P(S,c,C){S[C+0]=c&255,c=c>>>8,S[C+1]=c&255}e.writeUInt16LE=P;function p(S,c){return S[c]*2**24+S[c+1]*2**16+S[c+2]*2**8+S[c+3]}e.readUInt32BE=p;function v(S,c,C){S[C+3]=c,c=c>>>8,S[C+2]=c,c=c>>>8,S[C+1]=c,c=c>>>8,S[C]=c}e.writeUInt32BE=v;function d(S,c){return S[c+0]<<0>>>0|S[c+1]<<8>>>0|S[c+2]<<16>>>0|S[c+3]<<24>>>0}e.readUInt32LE=d;function f(S,c,C){S[C+0]=c&255,c=c>>>8,S[C+1]=c&255,c=c>>>8,S[C+2]=c&255,c=c>>>8,S[C+3]=c&255}e.writeUInt32LE=f;function E(S,c){return S[c]}e.readUInt8=E;function a(S,c,C){S[C]=c}e.writeUInt8=a;function h(S){return O.consumeReadable(S,c=>I.concat(c))}e.readableToBuffer=h;function u(S){return O.toReadable(S)}e.bufferToReadable=u;function b(S){return O.consumeStream(S,c=>I.concat(c))}e.streamToBuffer=b;async function y(S){return S.ended?I.concat(S.buffer):I.concat([...S.buffer,await b(S.stream)])}e.bufferedStreamToBuffer=y;function k(S){return O.toStream(S,c=>I.concat(c))}e.bufferToStream=k;function n(S){return O.transform(S,{data:c=>typeof c=="string"?I.fromString(c):I.wrap(c)},c=>I.concat(c))}e.streamToBufferReadableStream=n;function r(S){return O.newWriteableStream(c=>I.concat(c),S)}e.newWriteableBufferStream=r;function t(S,c){return O.prefixedReadable(S,c,C=>I.concat(C))}e.prefixedBufferReadable=t;function i(S,c){return O.prefixedStream(S,c,C=>I.concat(C))}e.prefixedBufferStream=i;function s(S){let c=0,C=0,D=0;const N=new Uint8Array(Math.floor(S.length/4*3)),F=z=>{switch(C){case 3:N[D++]=c|z,C=0;break;case 2:N[D++]=c|z>>>2,c=z<<6,C=3;break;case 1:N[D++]=c|z>>>4,c=z<<4,C=2;break;default:c=z<<2,C=1}};for(let z=0;z<S.length;z++){const x=S.charCodeAt(z);if(x>=65&&x<=90)F(x-65);else if(x>=97&&x<=122)F(x-97+26);else if(x>=48&&x<=57)F(x-48+52);else if(x===43||x===45)F(62);else if(x===47||x===95)F(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${S[z]}`)}}const V=D;for(;C>0;)F(0);return I.wrap(N).slice(0,V)}e.decodeBase64=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:S},c=!0,C=!1){const D=C?l:o;let N="";const F=S.byteLength%3;let V=0;for(;V<S.byteLength-F;V+=3){const z=S[V+0],x=S[V+1],Q=S[V+2];N+=D[z>>>2],N+=D[(z<<4|x>>>4)&63],N+=D[(x<<2|Q>>>6)&63],N+=D[Q&63]}if(F===1){const z=S[V+0];N+=D[z>>>2],N+=D[z<<4&63],c&&(N+="==")}else if(F===2){const z=S[V+0],x=S[V+1];N+=D[z>>>2],N+=D[(z<<4|x>>>4)&63],N+=D[x<<2&63],c&&(N+="=")}return N}e.encodeBase64=w}),define(oe[124],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[10],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(r){return typeof r=="string"}e.isString=L;function O(r){return Array.isArray(r)&&r.every(t=>L(t))}e.isStringArray=O;function _(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=_;function U(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=U;function T(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=T;function R(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=R;function I(r){return r===!0||r===!1}e.isBoolean=I;function m(r){return typeof r>"u"}e.isUndefined=m;function P(r){return!p(r)}e.isDefined=P;function p(r){return m(r)||r===null}e.isUndefinedOrNull=p;function v(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=v;function d(r){if(p(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=d;function f(...r){const t=[];for(let i=0;i<r.length;i++){const s=r[i];if(p(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.assertAllDefined=f;const E=Object.prototype.hasOwnProperty;function a(r){if(!_(r))return!1;for(const t in r)if(E.call(r,t))return!1;return!0}e.isEmptyObject=a;function h(r){return typeof r=="function"}e.isFunction=h;function u(...r){return r.length>0&&r.every(h)}e.areFunctions=u;function b(r,t){const i=Math.min(r.length,t.length);for(let s=0;s<i;s++)y(r[s],t[s])}e.validateConstraints=b;function y(r,t){if(L(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(r instanceof t)return}catch{}if(!p(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function k(r){return r===null?void 0:r}e.withNullAsUndefined=k;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(oe[31],ae([0,1,10]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const u=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([b,y])=>{u[b]=y&&typeof y=="object"?O(y):y}),u}e.deepClone=O;function _(h){if(!h||typeof h!="object")return h;const u=[h];for(;u.length>0;){const b=u.shift();Object.freeze(b);for(const y in b)if(U.call(b,y)){const k=b[y];typeof k=="object"&&!Object.isFrozen(k)&&!(0,L.isTypedArray)(k)&&u.push(k)}}return h}e.deepFreeze=_;const U=Object.prototype.hasOwnProperty;function T(h,u){return R(h,u,new Set)}e.cloneAndChange=T;function R(h,u,b){if((0,L.isUndefinedOrNull)(h))return h;const y=u(h);if(typeof y<"u")return y;if(Array.isArray(h)){const k=[];for(const n of h)k.push(R(n,u,b));return k}if((0,L.isObject)(h)){if(b.has(h))throw new Error("Cannot clone recursive data-structure");b.add(h);const k={};for(const n in h)U.call(h,n)&&(k[n]=R(h[n],u,b));return b.delete(h),k}return h}function I(h,u,b=!0){return(0,L.isObject)(h)?((0,L.isObject)(u)&&Object.keys(u).forEach(y=>{y in h?b&&((0,L.isObject)(h[y])&&(0,L.isObject)(u[y])?I(h[y],u[y],b):h[y]=u[y]):h[y]=u[y]}),h):u}e.mixin=I;function m(h,u){if(h===u)return!0;if(h==null||u===null||u===void 0||typeof h!=typeof u||typeof h!="object"||Array.isArray(h)!==Array.isArray(u))return!1;let b,y;if(Array.isArray(h)){if(h.length!==u.length)return!1;for(b=0;b<h.length;b++)if(!m(h[b],u[b]))return!1}else{const k=[];for(y in h)k.push(y);k.sort();const n=[];for(y in u)n.push(y);if(n.sort(),!m(k,n))return!1;for(b=0;b<k.length;b++)if(!m(h[k[b]],u[k[b]]))return!1}return!0}e.equals=m;function P(h){const u=new Set;return JSON.stringify(h,(b,y)=>{if((0,L.isObject)(y)||Array.isArray(y)){if(u.has(y))return"[Circular]";u.add(y)}return y})}e.safeStringify=P;function p(h,u){const b=Object.create(null);return!h||!u||Object.keys(u).forEach(k=>{const n=h[k],r=u[k];m(n,r)||(b[k]=r)}),b}e.distinct=p;function v(h,u){const b=u.toLowerCase(),y=Object.keys(h).find(k=>k.toLowerCase()===b);return y?h[y]:h[u]}e.getCaseInsensitive=v;function d(h,u){const b=Object.create(null);for(const[y,k]of Object.entries(h))u(y,k)&&(b[y]=k);return b}e.filter=d;function f(h){let u=[],b=Object.getPrototypeOf(h);for(;Object.prototype!==b;)u=u.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return u}e.getAllPropertyNames=f;function E(h){const u=[];for(const b of f(h))typeof h[b]=="function"&&u.push(b);return u}e.getAllMethodNames=E;function a(h,u){const b=k=>function(){const n=Array.prototype.slice.call(arguments,0);return u(k,n)},y={};for(const k of h)y[k]=b(k);return y}e.createProxyObject=a}),define(oe[32],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(_){return L.test(_)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(R){for(let I=0;I<R.length;I++)R[I]=Math.floor(Math.random()*256);return R};const U=new Uint8Array(16),T=[];for(let R=0;R<256;R++)T.push(R.toString(16).padStart(2,"0"));return function(){_(U),U[6]=U[6]&15|64,U[8]=U[8]&63|128;let I=0,m="";return m+=T[U[I++]],m+=T[U[I++]],m+=T[U[I++]],m+=T[U[I++]],m+="-",m+=T[U[I++]],m+=T[U[I++]],m+="-",m+=T[U[I++]],m+=T[U[I++]],m+="-",m+=T[U[I++]],m+=T[U[I++]],m+="-",m+=T[U[I++]],m+=T[U[I++]],m+=T[U[I++]],m+=T[U[I++]],m+=T[U[I++]],m+=T[U[I++]],m}}()}),define(oe[125],ae([0,1,36]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function _(T){const R=T.replace(/\-/g,":").toLowerCase();return!O.has(R)}function U(){const T=(0,L.networkInterfaces)();for(const R in T){const I=T[R];if(I){for(const{mac:m}of I)if(_(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=U}),define(oe[126],ae([0,1,61]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(R,I,m,P=1){let p=!1;return new Promise(v=>{const d=setTimeout(()=>{if(!p)return p=!0,v(0)},m);_(R,I,P,f=>{if(!p)return p=!0,clearTimeout(d),v(f)})})}e.findFreePort=O;function _(R,I,m,P){if(I===0)return P(0);const p=new L.Socket;p.once("connect",()=>(T(p),_(R+m,I-1,m,P))),p.once("data",()=>{}),p.once("error",v=>(T(p),v.code!=="ECONNREFUSED"?_(R+m,I-1,m,P):P(R))),p.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function U(R,I,m,P="127.0.0.1"){let p=!1,v,d=1;const f=L.createServer({pauseOnConnect:!0});function E(a,h){p||(p=!0,f.removeAllListeners(),f.close(),v&&clearTimeout(v),h(a))}return new Promise(a=>{v=setTimeout(()=>{E(0,a)},m),f.on("listening",()=>{E(R,a)}),f.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&d<I?(R++,d++,f.listen(R,P)):E(0,a)}),f.on("close",()=>{E(0,a)}),f.listen(R,P)})}e.findFreePortFaster=U;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(I){console.error(I)}}}),define(oe[127],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(O){return!!O.parentPort}e.isUtilityProcess=L}),define(oe[128],ae([11,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(oe[62],ae([0,1,128]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,_=O*60,U=_*24,T=U*7,R=U*30,I=U*365;function m(p,v,d,f){typeof p!="number"&&(p=p.getTime());const E=Math.round((new Date().getTime()-p)/1e3);if(E<-30)return(0,L.localize)(0,null,m(new Date().getTime()+E*1e3,!1));if(!f&&E<30)return(0,L.localize)(1,null);let a;return E<O?(a=E,v?a===1?d?(0,L.localize)(2,null,a):(0,L.localize)(3,null,a):d?(0,L.localize)(4,null,a):(0,L.localize)(5,null,a):a===1?d?(0,L.localize)(6,null,a):(0,L.localize)(7,null,a):d?(0,L.localize)(8,null,a):(0,L.localize)(9,null,a)):E<_?(a=Math.floor(E/O),v?a===1?d?(0,L.localize)(10,null,a):(0,L.localize)(11,null,a):d?(0,L.localize)(12,null,a):(0,L.localize)(13,null,a):a===1?d?(0,L.localize)(14,null,a):(0,L.localize)(15,null,a):d?(0,L.localize)(16,null,a):(0,L.localize)(17,null,a)):E<U?(a=Math.floor(E/_),v?a===1?d?(0,L.localize)(18,null,a):(0,L.localize)(19,null,a):d?(0,L.localize)(20,null,a):(0,L.localize)(21,null,a):a===1?d?(0,L.localize)(22,null,a):(0,L.localize)(23,null,a):d?(0,L.localize)(24,null,a):(0,L.localize)(25,null,a)):E<T?(a=Math.floor(E/U),v?a===1?(0,L.localize)(26,null,a):(0,L.localize)(27,null,a):a===1?(0,L.localize)(28,null,a):(0,L.localize)(29,null,a)):E<R?(a=Math.floor(E/T),v?a===1?d?(0,L.localize)(30,null,a):(0,L.localize)(31,null,a):d?(0,L.localize)(32,null,a):(0,L.localize)(33,null,a):a===1?d?(0,L.localize)(34,null,a):(0,L.localize)(35,null,a):d?(0,L.localize)(36,null,a):(0,L.localize)(37,null,a)):E<I?(a=Math.floor(E/R),v?a===1?d?(0,L.localize)(38,null,a):(0,L.localize)(39,null,a):d?(0,L.localize)(40,null,a):(0,L.localize)(41,null,a):a===1?d?(0,L.localize)(42,null,a):(0,L.localize)(43,null,a):d?(0,L.localize)(44,null,a):(0,L.localize)(45,null,a)):(a=Math.floor(E/I),v?a===1?d?(0,L.localize)(46,null,a):(0,L.localize)(47,null,a):d?(0,L.localize)(48,null,a):(0,L.localize)(49,null,a):a===1?d?(0,L.localize)(50,null,a):(0,L.localize)(51,null,a):d?(0,L.localize)(52,null,a):(0,L.localize)(53,null,a))}e.fromNow=m;function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(oe[129],ae([11,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,10,129]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function U(p,v){return v&&(p.stack||p.stacktrace)?_.localize(0,null,R(p),T(p.stack)||T(p.stacktrace)):R(p)}function T(p){return Array.isArray(p)?p.join(`
`):p}function R(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?_.localize(1,null,p.message):p.message||_.localize(2,null)}function I(p=null,v=!1){if(!p)return _.localize(3,null);if(Array.isArray(p)){const d=L.coalesce(p),f=I(d[0],v);return d.length>1?_.localize(4,null,f,d.length):f}if(O.isString(p))return p;if(p.detail){const d=p.detail;if(d.error)return U(d.error,v);if(d.exception)return U(d.exception,v)}return p.stack?U(p,v):p.message?p.message:_.localize(5,null)}e.toErrorMessage=I;function m(p){const v=p;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=m;function P(p,v){let d;return typeof p=="string"?d=new Error(p):d=p,d.actions=v,d}e.createErrorWithActions=P}),define(oe[130],ae([11,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(oe[131],ae([0,1,130]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(_){switch(_){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(oe[132],ae([11,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,132]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,_=!1,U=!1,T=!1,R=!1,I=!1,m=!1,P=!1,p=!1,v=!1,d,f=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,a,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const b=typeof u?.versions?.electron=="string",y=b&&u?.type==="renderer";if(typeof navigator=="object"&&!y)h=navigator.userAgent,O=h.indexOf("Windows")>=0,_=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=h.indexOf("Linux")>=0,v=h?.indexOf("Mobi")>=0,I=!0,d=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,f=d,E=navigator.language;else if(typeof u=="object"){O=u.platform==="win32",_=u.platform==="darwin",U=u.platform==="linux",T=U&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=b,p=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const w=u.env.VSCODE_NLS_CONFIG;if(w)try{const S=JSON.parse(w),c=S.availableLanguages["*"];d=S.locale,E=S.osLocale,f=c||e.LANGUAGE_DEFAULT,a=S._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var k;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(k||(e.Platform=k={}));function n(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let r=0;_?r=1:O?r=3:U&&(r=2),e.isWindows=O,e.isMacintosh=_,e.isLinux=U,e.isLinuxSnap=T,e.isNative=R,e.isElectron=m,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=v,e.isCI=p,e.platform=r,e.userAgent=h,e.language=f;var t;(function(w){function S(){return e.language}w.value=S;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}w.isDefaultVariant=c;function C(){return e.language==="en"}w.isDefault=C})(t||(e.Language=t={})),e.locale=d,e.platformLocale=E,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const w=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let C=0,D=w.length;C<D;C++){const N=w[C];if(N.id===c.data.vscodeScheduleAsyncWork){w.splice(C,1),N.callback();return}}});let S=0;return c=>{const C=++S;w.push({id:C,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return w=>setTimeout(w)})();var i;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=_||P?2:O?1:3;let s=!0,o=!1;function l(){if(!o){o=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,s=new Uint16Array(w.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const _=L.globals.vscode.process;O={get platform(){return _.platform},get arch(){return _.arch},get env(){return _.env},cwd(){return _.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(oe[15],ae([0,1,37]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,_=97,U=90,T=122,R=46,I=47,m=92,P=58,p=63;class v extends Error{constructor(r,t,i){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const o=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${o} ${s} of type ${t}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function d(n,r){if(n===null||typeof n!="object")throw new v(r,"Object",n)}function f(n,r){if(typeof n!="string")throw new v(r,"string",n)}const E=L.platform==="win32";function a(n){return n===I||n===m}function h(n){return n===I}function u(n){return n>=O&&n<=U||n>=_&&n<=T}function b(n,r,t,i){let s="",o=0,l=-1,w=0,S=0;for(let c=0;c<=n.length;++c){if(c<n.length)S=n.charCodeAt(c);else{if(i(S))break;S=I}if(i(S)){if(!(l===c-1||w===1))if(w===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==R||s.charCodeAt(s.length-2)!==R){if(s.length>2){const C=s.lastIndexOf(t);C===-1?(s="",o=0):(s=s.slice(0,C),o=s.length-1-s.lastIndexOf(t)),l=c,w=0;continue}else if(s.length!==0){s="",o=0,l=c,w=0;continue}}r&&(s+=s.length>0?`${t}..`:"..",o=2)}else s.length>0?s+=`${t}${n.slice(l+1,c)}`:s=n.slice(l+1,c),o=c-l-1;l=c,w=0}else S===R&&w!==-1?++w:w=-1}return s}function y(n,r){d(r,"pathObject");const t=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${i}`:`${t}${n}${i}`:i}e.win32={resolve(...n){let r="",t="",i=!1;for(let s=n.length-1;s>=-1;s--){let o;if(s>=0){if(o=n[s],f(o,"path"),o.length===0)continue}else r.length===0?o=L.cwd():(o=L.env[`=${r}`]||L.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===m)&&(o=`${r}\\`));const l=o.length;let w=0,S="",c=!1;const C=o.charCodeAt(0);if(l===1)a(C)&&(w=1,c=!0);else if(a(C))if(c=!0,a(o.charCodeAt(1))){let D=2,N=D;for(;D<l&&!a(o.charCodeAt(D));)D++;if(D<l&&D!==N){const F=o.slice(N,D);for(N=D;D<l&&a(o.charCodeAt(D));)D++;if(D<l&&D!==N){for(N=D;D<l&&!a(o.charCodeAt(D));)D++;(D===l||D!==N)&&(S=`\\\\${F}\\${o.slice(N,D)}`,w=D)}}}else w=1;else u(C)&&o.charCodeAt(1)===P&&(S=o.slice(0,2),w=2,l>2&&a(o.charCodeAt(2))&&(c=!0,w=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(i){if(r.length>0)break}else if(t=`${o.slice(w)}\\${t}`,i=c,c&&r.length>0)break}return t=b(t,!i,"\\",a),i?`${r}\\${t}`:`${r}${t}`||"."},normalize(n){f(n,"path");const r=n.length;if(r===0)return".";let t=0,i,s=!1;const o=n.charCodeAt(0);if(r===1)return h(o)?"\\":n;if(a(o))if(s=!0,a(n.charCodeAt(1))){let w=2,S=w;for(;w<r&&!a(n.charCodeAt(w));)w++;if(w<r&&w!==S){const c=n.slice(S,w);for(S=w;w<r&&a(n.charCodeAt(w));)w++;if(w<r&&w!==S){for(S=w;w<r&&!a(n.charCodeAt(w));)w++;if(w===r)return`\\\\${c}\\${n.slice(S)}\\`;w!==S&&(i=`\\\\${c}\\${n.slice(S,w)}`,t=w)}}}else t=1;else u(o)&&n.charCodeAt(1)===P&&(i=n.slice(0,2),t=2,r>2&&a(n.charCodeAt(2))&&(s=!0,t=3));let l=t<r?b(n.slice(t),!s,"\\",a):"";return l.length===0&&!s&&(l="."),l.length>0&&a(n.charCodeAt(r-1))&&(l+="\\"),i===void 0?s?`\\${l}`:l:s?`${i}\\${l}`:`${i}${l}`},isAbsolute(n){f(n,"path");const r=n.length;if(r===0)return!1;const t=n.charCodeAt(0);return a(t)||r>2&&u(t)&&n.charCodeAt(1)===P&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,t;for(let o=0;o<n.length;++o){const l=n[o];f(l,"path"),l.length>0&&(r===void 0?r=t=l:r+=`\\${l}`)}if(r===void 0)return".";let i=!0,s=0;if(typeof t=="string"&&a(t.charCodeAt(0))){++s;const o=t.length;o>1&&a(t.charCodeAt(1))&&(++s,o>2&&(a(t.charCodeAt(2))?++s:i=!1))}if(i){for(;s<r.length&&a(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(n,r){if(f(n,"from"),f(r,"to"),n===r)return"";const t=e.win32.resolve(n),i=e.win32.resolve(r);if(t===i||(n=t.toLowerCase(),r=i.toLowerCase(),n===r))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===m;)s++;let o=n.length;for(;o-1>s&&n.charCodeAt(o-1)===m;)o--;const l=o-s;let w=0;for(;w<r.length&&r.charCodeAt(w)===m;)w++;let S=r.length;for(;S-1>w&&r.charCodeAt(S-1)===m;)S--;const c=S-w,C=l<c?l:c;let D=-1,N=0;for(;N<C;N++){const V=n.charCodeAt(s+N);if(V!==r.charCodeAt(w+N))break;V===m&&(D=N)}if(N!==C){if(D===-1)return i}else{if(c>C){if(r.charCodeAt(w+N)===m)return i.slice(w+N+1);if(N===2)return i.slice(w+N)}l>C&&(n.charCodeAt(s+N)===m?D=N:N===2&&(D=3)),D===-1&&(D=0)}let F="";for(N=s+D+1;N<=o;++N)(N===o||n.charCodeAt(N)===m)&&(F+=F.length===0?"..":"\\..");return w+=D,F.length>0?`${F}${i.slice(w,S)}`:(i.charCodeAt(w)===m&&++w,i.slice(w,S))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===m){if(r.charCodeAt(1)===m){const t=r.charCodeAt(2);if(t!==p&&t!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===m)return`\\\\?\\${r}`;return n},dirname(n){f(n,"path");const r=n.length;if(r===0)return".";let t=-1,i=0;const s=n.charCodeAt(0);if(r===1)return a(s)?n:".";if(a(s)){if(t=i=1,a(n.charCodeAt(1))){let w=2,S=w;for(;w<r&&!a(n.charCodeAt(w));)w++;if(w<r&&w!==S){for(S=w;w<r&&a(n.charCodeAt(w));)w++;if(w<r&&w!==S){for(S=w;w<r&&!a(n.charCodeAt(w));)w++;if(w===r)return n;w!==S&&(t=i=w+1)}}}}else u(s)&&n.charCodeAt(1)===P&&(t=r>2&&a(n.charCodeAt(2))?3:2,i=t);let o=-1,l=!0;for(let w=r-1;w>=i;--w)if(a(n.charCodeAt(w))){if(!l){o=w;break}}else l=!1;if(o===-1){if(t===-1)return".";o=t}return n.slice(0,o)},basename(n,r){r!==void 0&&f(r,"ext"),f(n,"path");let t=0,i=-1,s=!0,o;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(t=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let l=r.length-1,w=-1;for(o=n.length-1;o>=t;--o){const S=n.charCodeAt(o);if(a(S)){if(!s){t=o+1;break}}else w===-1&&(s=!1,w=o+1),l>=0&&(S===r.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=w))}return t===i?i=w:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=t;--o)if(a(n.charCodeAt(o))){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){f(n,"path");let r=0,t=-1,i=0,s=-1,o=!0,l=0;n.length>=2&&n.charCodeAt(1)===P&&u(n.charCodeAt(0))&&(r=i=2);for(let w=n.length-1;w>=r;--w){const S=n.charCodeAt(w);if(a(S)){if(!o){i=w+1;break}continue}s===-1&&(o=!1,s=w+1),S===R?t===-1?t=w:l!==1&&(l=1):t!==-1&&(l=-1)}return t===-1||s===-1||l===0||l===1&&t===s-1&&t===i+1?"":n.slice(t,s)},format:y.bind(null,"\\"),parse(n){f(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.length;let i=0,s=n.charCodeAt(0);if(t===1)return a(s)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(a(s)){if(i=1,a(n.charCodeAt(1))){let D=2,N=D;for(;D<t&&!a(n.charCodeAt(D));)D++;if(D<t&&D!==N){for(N=D;D<t&&a(n.charCodeAt(D));)D++;if(D<t&&D!==N){for(N=D;D<t&&!a(n.charCodeAt(D));)D++;D===t?i=D:D!==N&&(i=D+1)}}}}else if(u(s)&&n.charCodeAt(1)===P){if(t<=2)return r.root=r.dir=n,r;if(i=2,a(n.charCodeAt(2))){if(t===3)return r.root=r.dir=n,r;i=3}}i>0&&(r.root=n.slice(0,i));let o=-1,l=i,w=-1,S=!0,c=n.length-1,C=0;for(;c>=i;--c){if(s=n.charCodeAt(c),a(s)){if(!S){l=c+1;break}continue}w===-1&&(S=!1,w=c+1),s===R?o===-1?o=c:C!==1&&(C=1):o!==-1&&(C=-1)}return w!==-1&&(o===-1||C===0||C===1&&o===w-1&&o===l+1?r.base=r.name=n.slice(l,w):(r.name=n.slice(l,o),r.base=n.slice(l,w),r.ext=n.slice(o,w))),l>0&&l!==i?r.dir=n.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(E){const n=/\\/g;return()=>{const r=L.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...n){let r="",t=!1;for(let i=n.length-1;i>=-1&&!t;i--){const s=i>=0?n[i]:k();f(s,"path"),s.length!==0&&(r=`${s}/${r}`,t=s.charCodeAt(0)===I)}return r=b(r,!t,"/",h),t?`/${r}`:r.length>0?r:"."},normalize(n){if(f(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I,t=n.charCodeAt(n.length-1)===I;return n=b(n,!r,"/",h),n.length===0?r?"/":t?"./":".":(t&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return f(n,"path"),n.length>0&&n.charCodeAt(0)===I},join(...n){if(n.length===0)return".";let r;for(let t=0;t<n.length;++t){const i=n[t];f(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(n,r){if(f(n,"from"),f(r,"to"),n===r||(n=e.posix.resolve(n),r=e.posix.resolve(r),n===r))return"";const t=1,i=n.length,s=i-t,o=1,l=r.length-o,w=s<l?s:l;let S=-1,c=0;for(;c<w;c++){const D=n.charCodeAt(t+c);if(D!==r.charCodeAt(o+c))break;D===I&&(S=c)}if(c===w)if(l>w){if(r.charCodeAt(o+c)===I)return r.slice(o+c+1);if(c===0)return r.slice(o+c)}else s>w&&(n.charCodeAt(t+c)===I?S=c:c===0&&(S=0));let C="";for(c=t+S+1;c<=i;++c)(c===i||n.charCodeAt(c)===I)&&(C+=C.length===0?"..":"/..");return`${C}${r.slice(o+S)}`},toNamespacedPath(n){return n},dirname(n){if(f(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I;let t=-1,i=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===I){if(!i){t=s;break}}else i=!1;return t===-1?r?"/":".":r&&t===1?"//":n.slice(0,t)},basename(n,r){r!==void 0&&f(r,"ext"),f(n,"path");let t=0,i=-1,s=!0,o;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let l=r.length-1,w=-1;for(o=n.length-1;o>=0;--o){const S=n.charCodeAt(o);if(S===I){if(!s){t=o+1;break}}else w===-1&&(s=!1,w=o+1),l>=0&&(S===r.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=w))}return t===i?i=w:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===I){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){f(n,"path");let r=-1,t=0,i=-1,s=!0,o=0;for(let l=n.length-1;l>=0;--l){const w=n.charCodeAt(l);if(w===I){if(!s){t=l+1;break}continue}i===-1&&(s=!1,i=l+1),w===R?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===t+1?"":n.slice(r,i)},format:y.bind(null,"/"),parse(n){f(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.charCodeAt(0)===I;let i;t?(r.root="/",i=1):i=0;let s=-1,o=0,l=-1,w=!0,S=n.length-1,c=0;for(;S>=i;--S){const C=n.charCodeAt(S);if(C===I){if(!w){o=S+1;break}continue}l===-1&&(w=!1,l=S+1),C===R?s===-1?s=S:c!==1&&(c=1):s!==-1&&(c=-1)}if(l!==-1){const C=o===0&&t?1:o;s===-1||c===0||c===1&&s===l-1&&s===o+1?r.base=r.name=n.slice(C,l):(r.name=n.slice(C,s),r.base=n.slice(C,l),r.ext=n.slice(s,l))}return o>0?r.dir=n.slice(0,o-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(oe[133],ae([0,1,15]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(P){const p=(0,L.extname)(P),v=O[p.toLowerCase()];return v!==void 0?v:T(P)}e.getMediaOrTextMime=U;function T(P){const p=(0,L.extname)(P);return _[p.toLowerCase()]}e.getMediaMime=T;function R(P){for(const p in _)if(_[p]===P)return p}e.getExtensionForMimeType=R;const I=/^(.+)\/(.+?)(;.+)?$/;function m(P,p){const v=I.exec(P);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:p?void 0:P}e.normalizeMimeType=m}),define(oe[87],ae([0,1,5]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(O||(e.Source=O={}));var _;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(_||(e.TerminateResponseCode=_={}));function U(R,...I){const m=I.reduce((v,d)=>(v[d]=!0,v),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(v=>!m[v]).forEach(v=>{for(let d=0;d<P.length;d++)if(v.search(P[d])!==-1){delete R[v];break}})}e.sanitizeProcessEnvironment=U;function T(R){R&&(delete R.DEBUG,L.isMacintosh&&delete R.DYLD_LIBRARY_PATH,L.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(oe[88],ae([0,1,5]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const O=L.globals.performance&&typeof L.globals.performance.now=="function";class _{static create(T=!0){return new _(T)}constructor(T){this._highResolution=O&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=_}),define(oe[3],ae([0,1,7,82,2,85,88]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,I=!1;var m;(function(o){o.None=()=>_.Disposable.None;function l(W){if(I){const{onDidAddListener:q}=W,j=f.create();let K=0;W.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),q?.()}}}function w(W,q){return x(W,()=>{},0,void 0,!0,void 0,q)}o.defer=w;function S(W){return(q,j=null,K)=>{let ee=!1,ce;return ce=W(ue=>{if(!ee)return ce?ce.dispose():ee=!0,q.call(j,ue)},null,K),ee&&ce.dispose(),ce}}o.once=S;function c(W,q,j){return z((K,ee=null,ce)=>W(ue=>K.call(ee,q(ue)),null,ce),j)}o.map=c;function C(W,q,j){return z((K,ee=null,ce)=>W(ue=>{q(ue),K.call(ee,ue)},null,ce),j)}o.forEach=C;function D(W,q,j){return z((K,ee=null,ce)=>W(ue=>q(ue)&&K.call(ee,ue),null,ce),j)}o.filter=D;function N(W){return W}o.signal=N;function F(...W){return(q,j=null,K)=>(0,_.combinedDisposable)(...W.map(ee=>ee(ce=>q.call(j,ce),null,K)))}o.any=F;function V(W,q,j,K){let ee=j;return c(W,ce=>(ee=q(ee,ce),ee),K)}o.reduce=V;function z(W,q){let j;const K={onWillAddFirstListener(){j=W(ee.fire,ee)},onDidRemoveLastListener(){j?.dispose()}};q||l(K);const ee=new a(K);return q?.add(ee),ee.event}function x(W,q,j=100,K=!1,ee=!1,ce,ue){let fe,ve,Ee,Ce=0,Re;const Le={leakWarningThreshold:ce,onWillAddFirstListener(){fe=W(Ke=>{Ce++,ve=q(ve,Ke),K&&!Ee&&(je.fire(ve),ve=void 0),Re=()=>{const le=ve;ve=void 0,Ee=void 0,(!K||Ce>1)&&je.fire(le),Ce=0},typeof j=="number"?(clearTimeout(Ee),Ee=setTimeout(Re,j)):Ee===void 0&&(Ee=0,queueMicrotask(Re))})},onWillRemoveListener(){ee&&Ce>0&&Re?.()},onDidRemoveLastListener(){Re=void 0,fe.dispose()}};ue||l(Le);const je=new a(Le);return ue?.add(je),je.event}o.debounce=x;function Q(W,q=0,j){return o.debounce(W,(K,ee)=>K?(K.push(ee),K):[ee],q,void 0,!0,void 0,j)}o.accumulate=Q;function te(W,q=(K,ee)=>K===ee,j){let K=!0,ee;return D(W,ce=>{const ue=K||!q(ce,ee);return K=!1,ee=ce,ue},j)}o.latch=te;function G(W,q,j){return[o.filter(W,q,j),o.filter(W,K=>!q(K),j)]}o.split=G;function J(W,q=!1,j=[]){let K=j.slice(),ee=W(fe=>{K?K.push(fe):ue.fire(fe)});const ce=()=>{K?.forEach(fe=>ue.fire(fe)),K=null},ue=new a({onWillAddFirstListener(){ee||(ee=W(fe=>ue.fire(fe)))},onDidAddFirstListener(){K&&(q?setTimeout(ce):ce())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return ue.event}o.buffer=J;class B{constructor(q){this.event=q,this.disposables=new _.DisposableStore}map(q){return new B(c(this.event,q,this.disposables))}forEach(q){return new B(C(this.event,q,this.disposables))}filter(q){return new B(D(this.event,q,this.disposables))}reduce(q,j){return new B(V(this.event,q,j,this.disposables))}latch(){return new B(te(this.event,void 0,this.disposables))}debounce(q,j=100,K=!1,ee=!1,ce){return new B(x(this.event,q,j,K,ee,ce,this.disposables))}on(q,j,K){return this.event(q,j,K)}once(q,j,K){return S(this.event)(q,j,K)}dispose(){this.disposables.dispose()}}function M(W){return new B(W)}o.chain=M;function X(W,q,j=K=>K){const K=(...fe)=>ue.fire(j(...fe)),ee=()=>W.on(q,K),ce=()=>W.removeListener(q,K),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromNodeEventEmitter=X;function ie(W,q,j=K=>K){const K=(...fe)=>ue.fire(j(...fe)),ee=()=>W.addEventListener(q,K),ce=()=>W.removeEventListener(q,K),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromDOMEventEmitter=ie;function se(W){return new Promise(q=>S(W)(q))}o.toPromise=se;function H(W,q){return q(void 0),W(j=>q(j))}o.runAndSubscribe=H;function Z(W,q){let j=null;function K(ce){j?.dispose(),j=new _.DisposableStore,q(ce,j)}K(void 0);const ee=W(ce=>K(ce));return(0,_.toDisposable)(()=>{ee.dispose(),j?.dispose()})}o.runAndSubscribeWithStore=Z;class ${constructor(q,j){this._observable=q,this._counter=0,this._hasChanged=!1;const K={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};j||l(K),this.emitter=new a(K),j&&j.add(this.emitter)}beginUpdate(q){this._counter++}handlePossibleChange(q){}handleChange(q,j){this._hasChanged=!0}endUpdate(q){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function g(W,q){return new $(W,q).emitter.event}o.fromObservable=g;function A(W){return q=>{let j=0,K=!1;const ee={beginUpdate(){j++},endUpdate(){j--,j===0&&(W.reportChanges(),K&&(K=!1,q()))},handlePossibleChange(){},handleChange(){K=!0}};return W.addObserver(ee),{dispose(){W.removeObserver(ee)}}}}o.fromObservableLight=A})(m||(e.Event=m={}));class P{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${P._idPool++}`,P.all.add(this)}start(l){this._stopWatch=new T.StopWatch(!0),this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P,P.all=new Set,P._idPool=0;let p=-1;function v(o){const l=p;return p=o,{dispose(){p=l}}}e.setGlobalLeakWarningThreshold=v;class d{constructor(l,w=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=w,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(l,w){const S=this.threshold;if(S<=0||w<S)return;this._stacks||(this._stacks=new Map);const c=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=S*.5;let C,D=0;for(const[N,F]of this._stacks)(!C||D<F)&&(C=N,D=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${D}):`),console.warn(C)}return()=>{const C=this._stacks.get(l.value)||0;this._stacks.set(l.value,C-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(l,w,S){this.callback=l,this.callbackThis=w,this.stack=S,this.subscription=new _.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class a{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=p>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??p):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(R){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const w of l)w.subscription.isset()&&(w.subscription.unset(),w.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,w,S)=>{if(this._listeners||(this._listeners=new U.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),_.Disposable.None;const c=this._listeners.isEmpty();c&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let C,D;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(D=f.create(),C=this._leakageMon.check(D,this._listeners.size+1)),R&&(D=D??f.create());const N=new E(l,w,D),F=this._listeners.push(N);c&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,l,w);const V=N.subscription.set(()=>{C?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),F(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return S instanceof _.DisposableStore?S.add(V):Array.isArray(S)&&S.push(V),V}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new u(this._options?.onListenerError));for(const w of this._listeners)this._deliveryQueue.push(this,w,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=a;class h{constructor(l=L.onUnexpectedError){this._onListenerError=l,this._queue=new U.LinkedList}get size(){return this._queue.size}push(l,w,S){this._queue.push(new b(l,w,S))}clear(l){const w=new U.LinkedList;for(const S of this._queue)S.emitter!==l&&w.push(S);this._queue=w}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(w){this._onListenerError(w)}}}}e.EventDeliveryQueue=h;class u extends h{clear(l){this._queue.clear()}}class b{constructor(l,w,S){this.emitter=l,this.listener=w,this.event=S}}class y extends a{async fireAsync(l,w,S){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const c of this._listeners)this._asyncDeliveryQueue.push([c,l]);for(;this._asyncDeliveryQueue.size>0&&!w.isCancellationRequested;){const[c,C]=this._asyncDeliveryQueue.shift(),D=[],N={...C,token:w,waitUntil:F=>{if(Object.isFrozen(D))throw new Error("waitUntil can NOT be called asynchronous");S&&(F=S(F,c.callback)),D.push(F)}};try{c.invoke(N)}catch(F){(0,L.onUnexpectedError)(F);continue}Object.freeze(D),await Promise.allSettled(D).then(F=>{for(const V of F)V.status==="rejected"&&(0,L.onUnexpectedError)(V.reason)})}}}}e.AsyncEmitter=y;class k extends a{get isPaused(){return this._isPaused!==0}constructor(l){super(l),this._isPaused=0,this._eventQueue=new U.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=k;class n extends k{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=n;class r extends a{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this.hasListeners()&&(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(w=>super.fire(w)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const w={event:l,listener:null};this.events.push(w),this.hasListeners&&this.hook(w);const S=()=>{this.hasListeners&&this.unhook(w);const c=this.events.indexOf(w);this.events.splice(c,1)};return(0,_.toDisposable)((0,O.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(w=>this.emitter.fire(w))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(l){return(w,S,c)=>l(C=>{const D=this.buffers[this.buffers.length-1];D?D.push(()=>w.call(S,C)):w.call(S,C)},void 0,c)}bufferEvents(l){const w=[];this.buffers.push(w);const S=l();return this.buffers.pop(),w.forEach(c=>c()),S}}e.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=_.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(oe[26],ae([0,1,3]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(R,I){const m=setTimeout(R.bind(I),0);return{dispose(){clearTimeout(m)}}});var _;(function(R){function I(m){return m===R.None||m===R.Cancelled||m instanceof U?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=I,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(_||(e.CancellationToken=_={}));class U{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new U),this._token}cancel(){this._token?this._token instanceof U&&this._token.cancel():this._token=_.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof U&&this._token.dispose():this._token=_.None}}e.CancellationTokenSource=T}),define(oe[134],ae([0,1,26]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new L.CancellationTokenSource,I=this.task(R.token);return this.result={promise:I,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=O;class _{constructor(R){this.fn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const I=JSON.stringify(R);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(R)),this.lastCache}}e.LRUCachedFunction=_;class U{get cachedValues(){return this._map}constructor(R){this.fn=R,this._map=new Map}get(R){if(this._map.has(R))return this._map.get(R);const I=this.fn(R);return this._map.set(R,I),I}}e.CachedFunction=U}),define(oe[27],ae([0,1,134,84]),function(ne,e,L,O){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function U(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=U;const T=/{(\d+)}/g;function R(re,...he){return he.length===0?re:re.replace(T,function(me,Se){const ye=parseInt(Se,10);return isNaN(ye)||ye<0||ye>=he.length?me:he[ye]})}e.format=R;const I=/{([^}]+)}/g;function m(re,he){return re.replace(I,(me,Se)=>he[Se]??me)}e.format2=m;function P(re){return re.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=P;function p(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function v(re,he){let me=0;const Se=he.charCodeAt(0);for(let ye=re.length-1;ye>=0;ye--)re.charCodeAt(ye)===Se&&me++;return me}e.count=v;function d(re,he,me="\u2026"){return re.length<=he?re:`${re.substr(0,he)}${me}`}e.truncate=d;function f(re,he=" "){const me=E(re,he);return a(me,he)}e.trim=f;function E(re,he){if(!re||!he)return re;const me=he.length;if(me===0||re.length===0)return re;let Se=0;for(;re.indexOf(he,Se)===Se;)Se=Se+me;return re.substring(Se)}e.ltrim=E;function a(re,he){if(!re||!he)return re;const me=he.length,Se=re.length;if(me===0||Se===0)return re;let ye=Se,be=-1;for(;be=re.lastIndexOf(he,ye-1),!(be===-1||be+me!==ye);){if(be===0)return"";ye=be}return re.substring(0,ye)}e.rtrim=a;function h(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function u(re){return re.replace(/\*/g,"")}e.stripWildcards=u;function b(re,he,me={}){if(!re)throw new Error("Cannot create regex from empty string");he||(re=p(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let Se="";return me.global&&(Se+="g"),me.matchCase||(Se+="i"),me.multiline&&(Se+="m"),me.unicode&&(Se+="u"),new RegExp(re,Se)}e.createRegExp=b;function y(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function k(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function n(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=n;function r(re){return re.split(/\r\n|\r|\n/)}e.splitLines=r;function t(re){for(let he=0,me=re.length;he<me;he++){const Se=re.charCodeAt(he);if(Se!==32&&Se!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function i(re,he=0,me=re.length){for(let Se=he;Se<me;Se++){const ye=re.charCodeAt(Se);if(ye!==32&&ye!==9)return re.substring(he,Se)}return re.substring(he,me)}e.getLeadingWhitespace=i;function s(re,he=re.length-1){for(let me=he;me>=0;me--){const Se=re.charCodeAt(me);if(Se!==32&&Se!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function o(re,he,me){const Se=[];let ye=0;for(const be of re.matchAll(he)){if(Se.push(re.slice(ye,be.index)),be.index===void 0)throw new Error("match.index should be defined");ye=be.index+be[0].length,Se.push(me(be[0],...be.slice(1),be.index,re,be.groups))}return Se.push(re.slice(ye)),Promise.all(Se).then(be=>be.join(""))}e.replaceAsync=o;function l(re,he){return re<he?-1:re>he?1:0}e.compare=l;function w(re,he,me=0,Se=re.length,ye=0,be=he.length){for(;me<Se&&ye<be;me++,ye++){const ze=re.charCodeAt(me),Te=he.charCodeAt(ye);if(ze<Te)return-1;if(ze>Te)return 1}const De=Se-me,Ae=be-ye;return De<Ae?-1:De>Ae?1:0}e.compareSubstring=w;function S(re,he){return c(re,he,0,re.length,0,he.length)}e.compareIgnoreCase=S;function c(re,he,me=0,Se=re.length,ye=0,be=he.length){for(;me<Se&&ye<be;me++,ye++){let ze=re.charCodeAt(me),Te=he.charCodeAt(ye);if(ze===Te)continue;if(ze>=128||Te>=128)return w(re.toLowerCase(),he.toLowerCase(),me,Se,ye,be);D(ze)&&(ze-=32),D(Te)&&(Te-=32);const $e=ze-Te;if($e!==0)return $e}const De=Se-me,Ae=be-ye;return De<Ae?-1:De>Ae?1:0}e.compareSubstringIgnoreCase=c;function C(re){return re>=48&&re<=57}e.isAsciiDigit=C;function D(re){return re>=97&&re<=122}e.isLowerAsciiLetter=D;function N(re){return re>=65&&re<=90}e.isUpperAsciiLetter=N;function F(re,he){return re.length===he.length&&c(re,he)===0}e.equalsIgnoreCase=F;function V(re,he){const me=he.length;return he.length>re.length?!1:c(re,he,0,me)===0}e.startsWithIgnoreCase=V;function z(re,he){const me=Math.min(re.length,he.length);let Se;for(Se=0;Se<me;Se++)if(re.charCodeAt(Se)!==he.charCodeAt(Se))return Se;return me}e.commonPrefixLength=z;function x(re,he){const me=Math.min(re.length,he.length);let Se;const ye=re.length-1,be=he.length-1;for(Se=0;Se<me;Se++)if(re.charCodeAt(ye-Se)!==he.charCodeAt(be-Se))return Se;return me}e.commonSuffixLength=x;function Q(re){return 55296<=re&&re<=56319}e.isHighSurrogate=Q;function te(re){return 56320<=re&&re<=57343}e.isLowSurrogate=te;function G(re,he){return(re-55296<<10)+(he-56320)+65536}e.computeCodePoint=G;function J(re,he,me){const Se=re.charCodeAt(me);if(Q(Se)&&me+1<he){const ye=re.charCodeAt(me+1);if(te(ye))return G(Se,ye)}return Se}e.getNextCodePoint=J;function B(re,he){const me=re.charCodeAt(he-1);if(te(me)&&he>1){const Se=re.charCodeAt(he-2);if(Q(Se))return G(Se,me)}return me}class M{get offset(){return this._offset}constructor(he,me=0){this._str=he,this._len=he.length,this._offset=me}setOffset(he){this._offset=he}prevCodePoint(){const he=B(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=J(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=M;class X{get offset(){return this._iterator.offset}constructor(he,me=0){this._iterator=new M(he,me)}nextGraphemeLength(){const he=Pe.getInstance(),me=this._iterator,Se=me.offset;let ye=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,De=he.getGraphemeBreakType(me.nextCodePoint());if(ge(ye,De)){me.setOffset(be);break}ye=De}return me.offset-Se}prevGraphemeLength(){const he=Pe.getInstance(),me=this._iterator,Se=me.offset;let ye=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,De=he.getGraphemeBreakType(me.prevCodePoint());if(ge(De,ye)){me.setOffset(be);break}ye=De}return Se-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function ie(re,he){return new X(re,he).nextGraphemeLength()}e.nextCharLength=ie;function se(re,he){return new X(re,he).prevGraphemeLength()}e.prevCharLength=se;function H(re,he){he>0&&te(re.charCodeAt(he))&&he--;const me=he+ie(re,he);return[me-se(re,me),me]}e.getCharContainingOffset=H;function Z(re){const he=new X(re);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=Z;let $;function g(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function A(re){return $||($=g()),$.test(re)}e.containsRTL=A;const W=/^[\t\n\r\x20-\x7E]*$/;function q(re){return W.test(re)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=j;function K(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=K;function ee(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=ee;function ce(re,he){if(re.length<he)return re;const me=/\b/g;let Se=0;for(;me.test(re)&&!(re.length-me.lastIndex<he);)Se=me.lastIndex,me.lastIndex+=1;return re.substring(Se).replace(/^\s/,"")}e.lcut=ce;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,fe=/\x1b\].*?\x07/g;function ve(re){return re&&(re=re.replace(ue,"").replace(fe,"")),re}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ce(re){return Ee(re)?re.substr(1):re}e.stripUTF8BOM=Ce;function Re(re,he){if(!re||!he||re.length<he.length)return!1;const me=he.length,Se=re.toLowerCase();let ye=0,be=-1;for(;ye<me;){const De=Se.indexOf(he[ye],be+1);if(De<0)return!1;be=De,ye++}return!0}e.fuzzyContains=Re;function Le(re,he=!1){return re?(he&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=Le;function je(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=je;function Ke(re,he=1){if(he===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.getNLines=Ke;function le(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.singleLetterHash=le;function de(re){return Pe.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=de;function ge(re,he){return re===0?he!==5&&he!==7:re===2&&he===3?!1:re===4||re===2||re===3||he===4||he===2||he===3?!0:!(re===8&&(he===8||he===9||he===11||he===12)||(re===11||re===9)&&(he===9||he===10)||(re===12||re===10)&&he===10||he===5||he===13||he===7||re===1||re===13&&he===14||re===6&&he===6)}var Ie;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(e.GraphemeBreakType=Ie={}));class Pe{static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Ne()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this._data,Se=me.length/3;let ye=1;for(;ye<=Se;)if(he<me[3*ye])ye=2*ye;else if(he>me[3*ye+1])ye=2*ye+1;else return me[3*ye+2];return 0}}Pe._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(re,he){if(re===0)return 0;const me=We(re,he);if(me!==void 0)return me;const Se=new M(he,re);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=ke;function We(re,he){const me=new M(he,re);let Se=me.prevCodePoint();for(;Ue(Se)||Se===65039||Se===8419;){if(me.offset===0)return;Se=me.prevCodePoint()}if(!ee(Se))return;let ye=me.offset;return ye>0&&me.prevCodePoint()===8205&&(ye=me.offset),ye}function Ue(re){return 127995<=re&&re<=127999}var Me;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(he){return Fe.cache.get(Array.from(he))}static getLocales(){return Fe._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Fe,_=Fe,Fe.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.cache=new L.LRUCachedFunction(re=>{function he(Te){const $e=new Map;for(let qe=0;qe<Te.length;qe+=2)$e.set(Te[qe],Te[qe+1]);return $e}function me(Te,$e){const qe=new Map(Te);for(const[Ze,nt]of $e)qe.set(Ze,nt);return qe}function Se(Te,$e){if(!Te)return $e;const qe=new Map;for(const[Ze,nt]of Te)$e.has(Ze)&&qe.set(Ze,nt);return qe}const ye=_.ambiguousCharacterData.value;let be=re.filter(Te=>!Te.startsWith("_")&&Te in ye);be.length===0&&(be=["_default"]);let De;for(const Te of be){const $e=he(ye[Te]);De=Se(De,$e)}const Ae=he(ye._common),ze=me(Ae,De);return new Fe(ze)}),Fe._locales=new O.Lazy(()=>Object.keys(Fe.ambiguousCharacterData.value).filter(re=>!re.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(he){return _e.getData().has(he)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(oe[46],ae([0,1,15,5,27,10]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function R(o){return o.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function I(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=I;function m(o,l=L.posix.sep){if(!o)return"";const w=o.length,S=o.charCodeAt(0);if(T(S)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let C=3;const D=C;for(;C<w&&!T(o.charCodeAt(C));C++);if(D!==C&&!T(o.charCodeAt(C+1))){for(C+=1;C<w;C++)if(T(o.charCodeAt(C)))return o.slice(0,C+1).replace(/[\\/]/g,l)}}return l}else if(h(S)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let c=o.indexOf("://");if(c!==-1){for(c+=3;c<w;c++)if(T(o.charCodeAt(c)))return o.slice(0,c+1)}return""}e.getRoot=m;function P(o){if(!O.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let w=2;const S=w;for(;w<o.length&&(l=o.charCodeAt(w),l!==92);w++);return!(S===w||(l=o.charCodeAt(w+1),isNaN(l)||l===92))}e.isUNC=P;const p=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(o,l=O.isWindows){const w=l?p:v;return!(!o||o.length===0||/^\s+$/.test(o)||(w.lastIndex=0,w.test(o))||l&&d.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=f;function E(o,l,w){const S=o===l;return!w||S?S:!o||!l?!1:(0,_.equalsIgnoreCase)(o,l)}e.isEqual=E;function a(o,l,w,S=L.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(w){if(!(0,_.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let C=l.length;return l.charAt(l.length-1)===S&&C--,o.charAt(C)===S}return l.charAt(l.length-1)!==S&&(l+=S),o.indexOf(l)===0}e.isEqualOrParent=a;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function u(o,l){return O.isWindows&&o.endsWith(":")&&(o+=L.sep),(0,L.isAbsolute)(o)||(o=(0,L.join)(l,o)),o=(0,L.normalize)(o),O.isWindows?(o=(0,_.rtrim)(o,L.sep),o.endsWith(":")&&(o+=L.sep)):(o=(0,_.rtrim)(o,L.sep),o||(o=L.sep)),o}e.sanitizeFilePath=u;function b(o){const l=(0,L.normalize)(o);return O.isWindows?o.length>3?!1:y(l)&&(o.length===2||l.charCodeAt(2)===92):l===L.posix.sep}e.isRootOrDriveLetter=b;function y(o,l=O.isWindows){return l?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function k(o,l=O.isWindows){return y(o,l)?o[0]:void 0}e.getDriveLetter=k;function n(o,l,w){return l.length>o.length?-1:o===l?0:(w&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=n;function r(o){const l=o.split(":");let w,S,c;for(const C of l){const D=Number(C);(0,U.isNumber)(D)?S===void 0?S=D:c===void 0&&(c=D):w=w?[w,C].join(":"):C}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:S!==void 0?S:void 0,column:c!==void 0?c:S!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(o,l,w=8){let S="";for(let C=0;C<w;C++){let D;C===0&&O.isWindows&&!l&&(w===3||w===4)?D=i:D=t,S+=D.charAt(Math.floor(Math.random()*D.length))}let c;return l?c=`${l}-${S}`:c=S,o?(0,L.join)(o,c):c}e.randomPath=s}),define(oe[63],ae([0,1,27]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(h){return _(h,0)}e.hash=O;function _(h,u){switch(typeof h){case"object":return h===null?U(349,u):Array.isArray(h)?I(h,u):m(h,u);case"string":return R(h,u);case"boolean":return T(h,u);case"number":return U(h,u);case"undefined":return U(937,u);default:return U(617,u)}}e.doHash=_;function U(h,u){return(u<<5)-u+h|0}e.numberHash=U;function T(h,u){return U(h?433:863,u)}function R(h,u){u=U(149417,u);for(let b=0,y=h.length;b<y;b++)u=U(h.charCodeAt(b),u);return u}e.stringHash=R;function I(h,u){return u=U(104579,u),h.reduce((b,y)=>_(y,b),u)}function m(h,u){return u=U(181387,u),Object.keys(h).sort().reduce((b,y)=>(b=R(y,b),_(h[y],b)),u)}class P{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=_(u,this._value),this._value}}e.Hasher=P;var p;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function v(h,u,b=32){const y=b-u,k=~((1<<y)-1);return(h<<u|(k&h)>>>y)>>>0}function d(h,u=0,b=h.byteLength,y=0){for(let k=0;k<b;k++)h[u+k]=y}function f(h,u,b="0"){for(;h.length<u;)h=b+h;return h}function E(h,u=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(b=>b.toString(16).padStart(2,"0")).join(""):f((h>>>0).toString(16),u/4)}e.toHexString=E;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const b=u.length;if(b===0)return;const y=this._buff;let k=this._buffLen,n=this._leftoverHighSurrogate,r,t;for(n!==0?(r=n,t=-1,n=0):(r=u.charCodeAt(0),t=0);;){let i=r;if(L.isHighSurrogate(r))if(t+1<b){const s=u.charCodeAt(t+1);L.isLowSurrogate(s)?(t++,i=L.computeCodePoint(r,s)):i=65533}else{n=r;break}else L.isLowSurrogate(r)&&(i=65533);if(k=this._push(y,k,i),t++,t<b)r=u.charCodeAt(t);else break}this._buffLen=k,this._leftoverHighSurrogate=n}_push(u,b,y){return y<128?u[b++]=y:y<2048?(u[b++]=192|(y&1984)>>>6,u[b++]=128|(y&63)>>>0):y<65536?(u[b++]=224|(y&61440)>>>12,u[b++]=128|(y&4032)>>>6,u[b++]=128|(y&63)>>>0):(u[b++]=240|(y&1835008)>>>18,u[b++]=128|(y&258048)>>>12,u[b++]=128|(y&4032)>>>6,u[b++]=128|(y&63)>>>0),b>=64&&(this._step(),b-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),b}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=a._bigBlock32,b=this._buffDV;for(let l=0;l<64;l+=4)u.setUint32(l,b.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)u.setUint32(l,v(u.getUint32(l-12,!1)^u.getUint32(l-32,!1)^u.getUint32(l-56,!1)^u.getUint32(l-64,!1),1),!1);let y=this._h0,k=this._h1,n=this._h2,r=this._h3,t=this._h4,i,s,o;for(let l=0;l<80;l++)l<20?(i=k&n|~k&r,s=1518500249):l<40?(i=k^n^r,s=1859775393):l<60?(i=k&n|k&r|n&r,s=2400959708):(i=k^n^r,s=3395469782),o=v(y,5)+i+t+s+u.getUint32(l*4,!1)&4294967295,t=r,r=n,n=v(k,30),k=y,y=o;this._h0=this._h0+y&4294967295,this._h1=this._h1+k&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=a,a._bigBlock32=new DataView(new ArrayBuffer(320))}),define(oe[89],ae([0,1,27]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(O||(O={})),function(_){const U="error",T="warning",R="warn",I="info",m="ignore";function P(v){return v?L.equalsIgnoreCase(U,v)?_.Error:L.equalsIgnoreCase(T,v)||L.equalsIgnoreCase(R,v)?_.Warning:L.equalsIgnoreCase(I,v)?_.Info:_.Ignore:_.Ignore}_.fromValue=P;function p(v){switch(v){case _.Error:return U;case _.Warning:return T;case _.Info:return I;default:return m}}_.toString=p}(O||(O={})),e.default=O}),define(oe[47],ae([0,1,21,27]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class _{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const f=d.charCodeAt(0),E=this._value.charCodeAt(this._pos);return f-E}value(){return this._value[this._pos]}}e.StringIterator=_;class U{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,O.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=U;class T{constructor(d=!0,f=!0){this._splitOnBackslash=d,this._caseSensitive=f}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let f=d.length-1;f>=0;f--,this._valueLen--){const E=this._value.charCodeAt(f);if(!(E===47||this._splitOnBackslash&&E===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,O.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var R;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(R||(R={}));class I{constructor(d,f){this._ignorePathCasing=d,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,O.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(P||(P={}));class p{static forUris(d=()=>!1,f=()=>!1){return new p(new I(d,f))}static forPaths(d=!1){return new p(new T(void 0,!d))}static forStrings(){return new p(new _)}static forConfigKeys(){return new p(new U)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,f){if(f){const E=f.slice(0);(0,L.shuffle)(E);for(const a of E)this.set(a,d)}else{const E=d.slice(0);(0,L.shuffle)(E);for(const a of E)this.set(a[0],a[1])}}set(d,f){const E=this._iter.reset(d);let a;this._root||(this._root=new m,this._root.segment=E.value());const h=[];for(a=this._root;;){const b=E.cmp(a.segment);if(b>0)a.left||(a.left=new m,a.left.segment=E.value()),h.push([-1,a]),a=a.left;else if(b<0)a.right||(a.right=new m,a.right.segment=E.value()),h.push([1,a]),a=a.right;else if(E.hasNext())E.next(),a.mid||(a.mid=new m,a.mid.segment=E.value()),h.push([0,a]),a=a.mid;else break}const u=a.value;a.value=f,a.key=d;for(let b=h.length-1;b>=0;b--){const y=h[b][1];y.updateHeight();const k=y.balanceFactor();if(k<-1||k>1){const n=h[b][0],r=h[b+1][0];if(n===1&&r===1)h[b][1]=y.rotateLeft();else if(n===-1&&r===-1)h[b][1]=y.rotateRight();else if(n===1&&r===-1)y.right=h[b+1][1]=h[b+1][1].rotateRight(),h[b][1]=y.rotateLeft();else if(n===-1&&r===1)y.left=h[b+1][1]=h[b+1][1].rotateLeft(),h[b][1]=y.rotateRight();else throw new Error;if(b>0)switch(h[b-1][0]){case-1:h[b-1][1].left=h[b][1];break;case 1:h[b-1][1].right=h[b][1];break;case 0:h[b-1][1].mid=h[b][1];break}else this._root=h[0][1]}}return u}get(d){return this._getNode(d)?.value}_getNode(d){const f=this._iter.reset(d);let E=this._root;for(;E;){const a=f.cmp(E.segment);if(a>0)E=E.left;else if(a<0)E=E.right;else if(f.hasNext())f.next(),E=E.mid;else break}return E}has(d){const f=this._getNode(d);return!(f?.value===void 0&&f?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,f){const E=this._iter.reset(d),a=[];let h=this._root;for(;h;){const u=E.cmp(h.segment);if(u>0)a.push([-1,h]),h=h.left;else if(u<0)a.push([1,h]),h=h.right;else if(E.hasNext())E.next(),a.push([0,h]),h=h.mid;else break}if(h){if(f?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this._min(h.right);if(u.key){const{key:b,value:y,segment:k}=u;this._delete(u.key,!1),h.key=b,h.value=y,h.segment=k}}else{const u=h.left??h.right;if(a.length>0){const[b,y]=a[a.length-1];switch(b){case-1:y.left=u;break;case 0:y.mid=u;break;case 1:y.right=u;break}}else this._root=u}for(let u=a.length-1;u>=0;u--){const b=a[u][1];b.updateHeight();const y=b.balanceFactor();if(y>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),a[u][1]=b.rotateLeft()):y<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),a[u][1]=b.rotateRight()),u>0)switch(a[u-1][0]){case-1:a[u-1][1].left=a[u][1];break;case 1:a[u-1][1].right=a[u][1];break;case 0:a[u-1][1].mid=a[u][1];break}else this._root=a[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const f=this._iter.reset(d);let E=this._root,a;for(;E;){const h=f.cmp(E.segment);if(h>0)E=E.left;else if(h<0)E=E.right;else if(f.hasNext())f.next(),a=E.value||a,E=E.mid;else break}return E&&E.value||a}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,f){const E=this._iter.reset(d);let a=this._root;for(;a;){const h=E.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(E.hasNext())E.next(),a=a.mid;else return a.mid?this._entries(a.mid):f?a.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[f,E]of this)d(E,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const f=[];return this._dfsEntries(d,f),f[Symbol.iterator]()}_dfsEntries(d,f){d&&(d.left&&this._dfsEntries(d.left,f),d.value&&f.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,f),d.right&&this._dfsEntries(d.right,f))}_isBalanced(){const d=f=>{if(!f)return!0;const E=f.balanceFactor();return E<-1||E>1?!1:d(f.left)&&d(f.right)};return d(this._root)}}e.TernarySearchTree=p}),define(oe[12],ae([0,1,15,5]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const _=/^\w[\w\d+.-]*$/,U=/^\//,T=/^\/\//;function R(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!_.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!U.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,s){return!i&&!s?"file":i}function m(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==p&&(s=p+s):s=p;break}return s}const P="",p="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(s){return s instanceof d?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,l,w,S,c=!1){typeof s=="object"?(this.scheme=s.scheme||P,this.authority=s.authority||P,this.path=s.path||P,this.query=s.query||P,this.fragment=s.fragment||P):(this.scheme=I(s,c),this.authority=o||P,this.path=m(this.scheme,l||P),this.query=w||P,this.fragment=S||P,R(this,c))}get fsPath(){return y(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:l,path:w,query:S,fragment:c}=s;return o===void 0?o=this.scheme:o===null&&(o=P),l===void 0?l=this.authority:l===null&&(l=P),w===void 0?w=this.path:w===null&&(w=P),S===void 0?S=this.query:S===null&&(S=P),c===void 0?c=this.fragment:c===null&&(c=P),o===this.scheme&&l===this.authority&&w===this.path&&S===this.query&&c===this.fragment?this:new a(o,l,w,S,c)}static parse(s,o=!1){const l=v.exec(s);return l?new a(l[2]||P,t(l[4]||P),t(l[5]||P),t(l[7]||P),t(l[9]||P),o):new a(P,P,P,P,P)}static file(s){let o=P;if(O.isWindows&&(s=s.replace(/\\/g,p)),s[0]===p&&s[1]===p){const l=s.indexOf(p,2);l===-1?(o=s.substring(2),s=p):(o=s.substring(2,l),s=s.substring(l)||p)}return new a("file",o,s,P,P)}static from(s,o){return new a(s.scheme,s.authority,s.path,s.query,s.fragment,o)}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return O.isWindows&&s.scheme==="file"?l=d.file(L.win32.join(y(s,!0),...o)).path:l=L.posix.join(s.path,...o),s.with({path:l})}toString(s=!1){return k(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof d)return s;{const o=new a(s);return o._formatted=s.external??null,o._fsPath=s._sep===E?s.fsPath??null:null,o}}else return s}}e.URI=d;function f(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=f;const E=O.isWindows?1:void 0;class a extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(s=!1){return s?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=E),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,s,o){let l,w=-1;for(let S=0;S<i.length;S++){const c=i.charCodeAt(S);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||s&&c===47||o&&c===91||o&&c===93||o&&c===58)w!==-1&&(l+=encodeURIComponent(i.substring(w,S)),w=-1),l!==void 0&&(l+=i.charAt(S));else{l===void 0&&(l=i.substr(0,S));const C=h[c];C!==void 0?(w!==-1&&(l+=encodeURIComponent(i.substring(w,S)),w=-1),l+=C):w===-1&&(w=S)}}return w!==-1&&(l+=encodeURIComponent(i.substring(w))),l!==void 0?l:i}function b(i){let s;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);l===35||l===63?(s===void 0&&(s=i.substr(0,o)),s+=h[l]):s!==void 0&&(s+=i[o])}return s!==void 0?s:i}function y(i,s){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,O.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function k(i,s){const o=s?b:u;let l="",{scheme:w,authority:S,path:c,query:C,fragment:D}=i;if(w&&(l+=w,l+=":"),(S||w==="file")&&(l+=p,l+=p),S){let N=S.indexOf("@");if(N!==-1){const F=S.substr(0,N);S=S.substr(N+1),N=F.lastIndexOf(":"),N===-1?l+=o(F,!1,!1):(l+=o(F.substr(0,N),!1,!1),l+=":",l+=o(F.substr(N+1),!1,!0)),l+="@"}S=S.toLowerCase(),N=S.lastIndexOf(":"),N===-1?l+=o(S,!1,!0):(l+=o(S.substr(0,N),!1,!0),l+=S.substr(N))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const N=c.charCodeAt(1);N>=65&&N<=90&&(c=`/${String.fromCharCode(N+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const N=c.charCodeAt(0);N>=65&&N<=90&&(c=`${String.fromCharCode(N+32)}:${c.substr(2)}`)}l+=o(c,!0,!1)}return C&&(l+="?",l+=o(C,!1,!1)),D&&(l+="#",l+=s?D:u(D,!1,!1)),l}function n(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+n(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function t(i){return i.match(r)?i.replace(r,s=>n(s)):i}}),define(oe[135],ae([0,1,12]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=O;function _(m){const P=[];let p;try{const v=JSON.parse(m.arguments),d=v[v.length-1];d&&d.__$stack&&(v.pop(),p=d.__$stack),P.push(...v)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:p}}e.parse=_;function U(m){if(typeof m!="string")return U(_(m).stack);const P=m;if(P){const p=T(P),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(v&&v.length===4)return{uri:L.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=U;function T(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function R(m,P){const{args:p,stack:v}=_(m),d=typeof p[0]=="string"&&p.length===1;let f=T(v);f&&(f=`(${f.trim()})`);let E=[];if(typeof p[0]=="string"?f&&d?E=[`%c[${P}] %c${p[0]} %c${f}`,I("blue"),I(""),I("grey")]:E=[`%c[${P}] %c${p[0]}`,I("blue"),I(""),...p.slice(1)]:E=[`%c[${P}]%`,I("blue"),...p],f&&!d&&E.push(f),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,E)}e.log=R;function I(m){return`color: ${m}`}}),define(oe[64],ae([0,1,16,27,12]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function U(m){return JSON.stringify(m,R)}e.stringify=U;function T(m){let P=JSON.parse(m);return P=I(P),P}e.parse=T;function R(m,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,O.regExpFlags)(P)}:P}function I(m,P=0){if(!m||P>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return _.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof L.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let p=0;p<m.length;++p)m[p]=I(m[p],P+1);else for(const p in m)Object.hasOwnProperty.call(m,p)&&(m[p]=I(m[p],P+1))}return m}e.revive=I}),define(oe[25],ae([0,1,7,5,12]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var U;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(U||(e.Schemas=U={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${U.vscodeRemoteResource}`}set(P,p,v){this._hosts[P]=p,this._ports[P]=v}setConnectionToken(P,p){this._connectionTokens[P]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(a){return L.onUnexpectedError(a),P}const p=P.authority;let v=this._hosts[p];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const d=this._ports[p],f=this._connectionTokens[p];let E=`path=${encodeURIComponent(P.path)}`;return typeof f=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),_.URI.from({scheme:O.isWeb?this._preferredWebSchema:U.vscodeRemoteResource,authority:`${v}:${d}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(P){const p=this.toUri(P,ne);return this.uriToBrowserUri(p)}uriToBrowserUri(P){return P.scheme===U.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===U.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${U.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?P.with({scheme:U.vscodeFileResource,authority:P.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const p=this.toUri(P,ne);return this.uriToFileUri(p)}uriToFileUri(P){return P.scheme===U.vscodeFileResource?P.with({scheme:U.file,authority:P.authority!==R.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,p){return _.URI.isUri(P)?P:_.URI.parse(p.toUrl(P))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R;var I;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const p="vscode-coi";function v(f){let E;typeof f=="string"?E=new URL(f).searchParams:f instanceof URL?E=f.searchParams:_.URI.isUri(f)&&(E=new URL(f.toString(!0)).searchParams);const a=E?.get(p);if(a)return P.get(a)}m.getHeadersFromQuery=v;function d(f,E,a){if(!globalThis.crossOriginIsolated)return;const h=E&&a?"3":a?"2":"1";f instanceof URLSearchParams?f.set(p,h):f[p]=h}m.addSearchParam=d})(I||(e.COI=I={}))}),define(oe[22],ae([0,1,46,25,15,5,27,12]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(d){return(0,R.uriToFsPath)(d,!0)}e.originalFSPath=I;class m{constructor(f){this._ignorePathCasing=f}compare(f,E,a=!1){return f===E?0:(0,T.compare)(this.getComparisonKey(f,a),this.getComparisonKey(E,a))}isEqual(f,E,a=!1){return f===E?!0:!f||!E?!1:this.getComparisonKey(f,a)===this.getComparisonKey(E,a)}getComparisonKey(f,E=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,E,a=!1){if(f.scheme===E.scheme){if(f.scheme===O.Schemas.file)return L.isEqualOrParent(I(f),I(E),this._ignorePathCasing(f))&&f.query===E.query&&(a||f.fragment===E.fragment);if((0,e.isEqualAuthority)(f.authority,E.authority))return L.isEqualOrParent(f.path,E.path,this._ignorePathCasing(f),"/")&&f.query===E.query&&(a||f.fragment===E.fragment)}return!1}joinPath(f,...E){return R.URI.joinPath(f,...E)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return _.posix.basename(f.path)}extname(f){return _.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let E;return f.scheme===O.Schemas.file?E=R.URI.file(_.dirname(I(f))).path:(E=_.posix.dirname(f.path),f.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),E="/")),f.with({path:E})}normalizePath(f){if(!f.path.length)return f;let E;return f.scheme===O.Schemas.file?E=R.URI.file(_.normalize(I(f))).path:E=_.posix.normalize(f.path),f.with({path:E})}relativePath(f,E){if(f.scheme!==E.scheme||!(0,e.isEqualAuthority)(f.authority,E.authority))return;if(f.scheme===O.Schemas.file){const u=_.relative(I(f),I(E));return U.isWindows?L.toSlashes(u):u}let a=f.path||"/";const h=E.path||"/";if(this._ignorePathCasing(f)){let u=0;for(const b=Math.min(a.length,h.length);u<b&&!(a.charCodeAt(u)!==h.charCodeAt(u)&&a.charAt(u).toLowerCase()!==h.charAt(u).toLowerCase());u++);a=h.substr(0,u)+a.substr(u)}return _.posix.relative(a,h)}resolvePath(f,E){if(f.scheme===O.Schemas.file){const a=R.URI.file(_.resolve(I(f),E));return f.with({authority:a.authority,path:a.path})}return E=L.toPosixPath(E),f.with({path:_.posix.resolve(f.path,E)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,E){return f===E||f!==void 0&&E!==void 0&&(0,T.equalsIgnoreCase)(f,E)}hasTrailingPathSeparator(f,E=_.sep){if(f.scheme===O.Schemas.file){const a=I(f);return a.length>L.getRoot(a).length&&a[a.length-1]===E}else{const a=f.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,E=_.sep){return(0,e.hasTrailingPathSeparator)(f,E)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,E=_.sep){let a=!1;if(f.scheme===O.Schemas.file){const h=I(f);a=h!==void 0&&h.length===L.getRoot(h).length&&h[h.length-1]===E}else{E="/";const h=f.path;a=h.length===1&&h.charCodeAt(h.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(f,E)?f.with({path:f.path+"/"}):f}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(d=>d.scheme===O.Schemas.file?!U.isLinux:!0),e.extUriIgnorePathCase=new m(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(d,f){const E=[];for(let a=0;a<d.length;a++){const h=f(d[a]);d.some((u,b)=>b===a?!1:(0,e.isEqualOrParent)(h,f(u)))||E.push(d[a])}return E}e.distinctParents=P;var p;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function f(E){const a=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(b=>{const[y,k]=b.split(":");y&&k&&a.set(y,k)});const u=E.path.substring(0,E.path.indexOf(";"));return u&&a.set(d.META_DATA_MIME,u),a}d.parseMetaData=f})(p||(e.DataUri=p={}));function v(d,f,E){if(f){let a=d.path;return a&&a[0]!==_.posix.sep&&(a=_.posix.sep+a),d.with({scheme:E,authority:f,path:a})}return d.with({scheme:E})}e.toLocalResource=v}),define(oe[6],ae([0,1,26,7,3,2,22,5,124]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m($){return!!$&&typeof $.then=="function"}e.isThenable=m;function P($){const g=new L.CancellationTokenSource,A=$(g.token),W=new Promise((q,j)=>{const K=g.token.onCancellationRequested(()=>{K.dispose(),g.dispose(),j(new O.CancellationError)});Promise.resolve(A).then(ee=>{K.dispose(),g.dispose(),q(ee)},ee=>{K.dispose(),g.dispose(),j(ee)})});return new class{cancel(){g.cancel()}then(q,j){return W.then(q,j)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=P;function p($,g,A){return new Promise((W,q)=>{const j=g.onCancellationRequested(()=>{j.dispose(),W(A)});$.then(W,q).finally(()=>j.dispose())})}e.raceCancellation=p;function v($,g){return new Promise((A,W)=>{const q=g.onCancellationRequested(()=>{q.dispose(),W(new O.CancellationError)});$.then(A,W).finally(()=>q.dispose())})}e.raceCancellationError=v;async function d($){let g=-1;const A=$.map((W,q)=>W.then(j=>(g=q,j)));try{return await Promise.race(A)}finally{$.forEach((W,q)=>{q!==g&&W.cancel()})}}e.raceCancellablePromises=d;function f($,g,A){let W;const q=setTimeout(()=>{W?.(void 0),A?.()},g);return Promise.race([$.finally(()=>clearTimeout(q)),new Promise(j=>W=j)])}e.raceTimeout=f;function E($){return new Promise((g,A)=>{const W=$();m(W)?W.then(g,A):g(W)})}e.asPromise=E;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(g){if(this.activePromise){if(this.queuedPromiseFactory=g,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(A,A).then(W)})}return new Promise((A,W)=>{this.queuedPromise.then(A,W)})}return this.activePromise=g(),new Promise((A,W)=>{this.activePromise.then(q=>{this.activePromise=null,A(q)},q=>{this.activePromise=null,W(q)})})}}e.Throttler=a;class h{constructor(){this.current=Promise.resolve(null)}queue(g){return this.current=this.current.then(()=>g(),()=>g())}}e.Sequencer=h;class u{constructor(){this.promiseMap=new Map}queue(g,A){const q=(this.promiseMap.get(g)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(g)===q&&this.promiseMap.delete(g)});return this.promiseMap.set(g,q),q}}e.SequencerByKey=u;const b=($,g)=>{let A=!0;const W=setTimeout(()=>{A=!1,g()},$);return{isTriggered:()=>A,dispose:()=>{clearTimeout(W),A=!1}}},y=$=>{let g=!0;return queueMicrotask(()=>{g&&(g=!1,$())}),{isTriggered:()=>g,dispose:()=>{g=!1}}};class k{constructor(g){this.defaultDelay=g,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(g,A=this.defaultDelay){this.task=g,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,j)=>{this.doResolve=q,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}}));const W=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=A===I.MicrotaskDelay?y(W):b(A,W),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=k;class n{constructor(g){this.delayer=new k(g),this.throttler=new a}trigger(g,A){return this.delayer.trigger(()=>this.throttler.queue(g),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class r{constructor(){this._isOpen=!1,this._promise=new Promise((g,A)=>{this._completePromise=g})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class t extends r{constructor(g){super(),this._timeout=setTimeout(()=>this.open(),g)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=t;function i($,g){return g?new Promise((A,W)=>{const q=setTimeout(()=>{j.dispose(),A()},$),j=g.onCancellationRequested(()=>{clearTimeout(q),j.dispose(),W(new O.CancellationError)})}):P(A=>i($,A))}e.timeout=i;function s($,g=0){const A=setTimeout($,g);return(0,U.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=s;function o($){const g=[];let A=0;const W=$.length;function q(){return A<W?$[A++]():null}function j(K){K!=null&&g.push(K);const ee=q();return ee?ee.then(j):Promise.resolve(g)}return Promise.resolve(null).then(j)}e.sequence=o;function l($,g=W=>!!W,A=null){let W=0;const q=$.length,j=()=>{if(W>=q)return Promise.resolve(A);const K=$[W++];return Promise.resolve(K()).then(ce=>g(ce)?Promise.resolve(ce):j())};return j()}e.first=l;function w($,g=W=>!!W,A=null){if($.length===0)return Promise.resolve(A);let W=$.length;const q=()=>{W=-1;for(const j of $)j.cancel?.()};return new Promise((j,K)=>{for(const ee of $)ee.then(ce=>{--W>=0&&g(ce)?(q(),j(ce)):W===0&&j(A)}).catch(ce=>{--W>=0&&(q(),K(ce))})})}e.firstParallel=w;class S{constructor(g){this._size=0,this.maxDegreeOfParalellism=g,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new _.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(g){return this._size++,new Promise((A,W)=>{this.outstandingPromises.push({factory:g,c:A,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const g=this.outstandingPromises.shift();this.runningPromises++;const A=g.factory();A.then(g.c,g.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=S;class c extends S{constructor(){super(1)}}e.Queue=c;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const g=new M;return this.drainers.add(g),g.p}isDrained(){for(const[,g]of this.queues)if(g.size>0)return!1;return!0}queueFor(g,A=T.extUri){const W=A.getComparisonKey(g);let q=this.queues.get(W);return q||(q=new c,_.Event.once(q.onDrained)(()=>{q?.dispose(),this.queues.delete(W),this.onDidQueueDrain()}),this.queues.set(W,q)),q}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const g of this.drainers)g.complete();this.drainers.clear()}dispose(){for(const[,g]of this.queues)g.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class D{constructor(g,A){this._token=-1,typeof g=="function"&&typeof A=="number"&&this.setIfNotSet(g,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(g,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,g()},A)}setIfNotSet(g,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,g()},A))}}e.TimeoutTimer=D;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(g,A){this.cancel(),this._token=setInterval(()=>{g()},A)}}e.IntervalTimer=N;class F{constructor(g,A){this.timeoutToken=-1,this.runner=g,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(g=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,g)}get delay(){return this.timeout}set delay(g){this.timeout=g}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class V{constructor(g,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.runner=g,this.timeout=A,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(g=this.timeout){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(g/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class z extends F{constructor(g,A){super(g,A),this.units=[]}work(g){this.units.push(g),this.isScheduled()||this.schedule()}doRun(){const g=this.units;this.units=[],this.runner?.(g)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class x extends U.Disposable{constructor(g,A){super(),this.options=g,this.handler=A,this.pendingWork=[],this.throttler=this._register(new U.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(g){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+g.length>this.options.maxBufferedWork)return!1}else if(this.pending+g.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const A of g)this.pendingWork.push(A);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,R.setTimeout0)(()=>{if(g)return;const A=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:e.runWhenIdle=($,g)=>{const A=requestIdleCallback($,typeof g=="number"?{timeout:g}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(A))}}}}();class Q{constructor(g){this._didRun=!1,this._executor=()=>{try{this._value=g()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Q;async function te($,g,A){let W;for(let q=0;q<A;q++)try{return await $()}catch(j){W=j,await i(g)}throw W}e.retry=te;class G{hasPending(g){return this._pending?typeof g=="number"?this._pending.taskId===g:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(g,A,W){return this._pending={taskId:g,cancel:()=>W?.(),promise:A},A.then(()=>this.donePending(g),()=>this.donePending(g)),A}donePending(g){this._pending&&g===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const g=this._next;this._next=void 0,g.run().then(g.promiseResolve,g.promiseReject)}}setNext(g){if(this._next)this._next.run=g;else{let A,W;const q=new Promise((j,K)=>{A=j,W=K});this._next={run:g,promise:q,promiseResolve:A,promiseReject:W}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=G;class J{constructor(g,A=()=>Date.now()){this.interval=g,this.nowFn=A,this.lastIncrementTime=0,this.value=0}increment(){const g=this.nowFn();return g-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=g,this.value=0),this.value++,this.value}}e.IntervalCounter=J;var B;(function($){$[$.Resolved=0]="Resolved",$[$.Rejected=1]="Rejected"})(B||(B={}));class M{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((g,A)=>{this.completeCallback=g,this.errorCallback=A})}complete(g){return new Promise(A=>{this.completeCallback(g),this.outcome={outcome:0,value:g},A()})}error(g){return new Promise(A=>{this.errorCallback(g),this.outcome={outcome:1,value:g},A()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=M;var X;(function($){async function g(W){let q;const j=await Promise.all(W.map(K=>K.then(ee=>ee,ee=>{q||(q=ee)})));if(typeof q<"u")throw q;return j}$.settled=g;function A(W){return new Promise(async(q,j)=>{try{await W(q,j)}catch(K){j(K)}})}$.withAsyncBody=A})(X||(e.Promises=X={}));var ie;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(ie||(ie={}));class se{static fromArray(g){return new se(A=>{A.emitMany(g)})}static fromPromise(g){return new se(async A=>{A.emitMany(await g)})}static fromPromises(g){return new se(async A=>{await Promise.all(g.map(async W=>A.emitOne(await W)))})}static merge(g){return new se(async A=>{await Promise.all(g.map(async W=>{for await(const q of W)A.emitOne(q)}))})}constructor(g){this._state=0,this._results=[],this._error=null,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const A={emitOne:W=>this.emitOne(W),emitMany:W=>this.emitMany(W),reject:W=>this.reject(W)};try{await Promise.resolve(g(A)),this.resolve()}catch(W){this.reject(W)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let g=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(g<this._results.length)return{done:!1,value:this._results[g++]};if(this._state===1)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(g,A){return new se(async W=>{for await(const q of g)W.emitOne(A(q))})}map(g){return se.map(this,g)}static filter(g,A){return new se(async W=>{for await(const q of g)A(q)&&W.emitOne(q)})}filter(g){return se.filter(this,g)}static coalesce(g){return se.filter(g,A=>!!A)}coalesce(){return se.coalesce(this)}static async toPromise(g){const A=[];for await(const W of g)A.push(W);return A}toPromise(){return se.toPromise(this)}emitOne(g){this._state===0&&(this._results.push(g),this._onStateChanged.fire())}emitMany(g){this._state===0&&(this._results=this._results.concat(g),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(g){this._state===0&&(this._state=2,this._error=g,this._onStateChanged.fire())}}e.AsyncIterableObject=se,se.EMPTY=se.fromArray([]);class H extends se{constructor(g,A){super(A),this._source=g}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function Z($){const g=new L.CancellationTokenSource,A=$(g.token);return new H(g,async W=>{const q=g.token.onCancellationRequested(()=>{q.dispose(),g.dispose(),W.reject(new O.CancellationError)});try{for await(const j of A){if(g.token.isCancellationRequested)return;W.emitOne(j)}q.dispose(),g.dispose()}catch(j){q.dispose(),g.dispose(),W.reject(j)}})}e.createCancelableAsyncIterable=Z}),define(oe[90],ae([0,1,21,6,46,35,15,5,27]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",p="[^/\\\\]",v=/\//g;function d(J,B){switch(J){case 0:return"";case 1:return`${p}*?`;default:return`(?:${P}|${p}+${P}${B?`|${P}${p}+`:""})*?`}}function f(J,B){if(!J)return[];const M=[];let X=!1,ie=!1,se="";for(const H of J){switch(H){case B:if(!X&&!ie){M.push(se),se="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}se+=H}return se&&M.push(se),M}e.splitGlobAware=f;function E(J){if(!J)return"";let B="";const M=f(J,e.GLOB_SPLIT);if(M.every(X=>X===e.GLOBSTAR))B=".*";else{let X=!1;M.forEach((ie,se)=>{if(ie===e.GLOBSTAR){if(X)return;B+=d(2,se===M.length-1)}else{let H=!1,Z="",$=!1,g="";for(const A of ie){if(A!=="}"&&H){Z+=A;continue}if($&&(A!=="]"||!g)){let W;A==="-"?W=A:(A==="^"||A==="!")&&!g?W="^":A===e.GLOB_SPLIT?W="":W=(0,I.escapeRegExpCharacters)(A),g+=W;continue}switch(A){case"{":H=!0;continue;case"[":$=!0;continue;case"}":{const q=`(?:${f(Z,",").map(j=>E(j)).join("|")})`;B+=q,H=!1,Z="";break}case"]":{B+="["+g+"]",$=!1,g="";break}case"?":B+=p;continue;case"*":B+=d(1);continue;default:B+=(0,I.escapeRegExpCharacters)(A)}}se<M.length-1&&(M[se+1]!==e.GLOBSTAR||se+2<M.length)&&(B+=P)}X=ie===e.GLOBSTAR})}return B}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new U.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i(J,B){if(!J)return t;let M;typeof J!="string"?M=J.pattern:M=J,M=M.trim();const X=`${M}_${!!B.trimForExclusions}`;let ie=n.get(X);if(ie)return s(ie,J);let se;return a.test(M)?ie=l(M.substr(4),M):(se=h.exec(o(M,B)))?ie=w(se[1],M):(B.trimForExclusions?b:u).test(M)?ie=S(M,B):(se=y.exec(o(M,B)))?ie=c(se[1].substr(1),M,!0):(se=k.exec(o(M,B)))?ie=c(se[1],M,!1):ie=C(M),n.set(X,ie),s(ie,J)}function s(J,B){if(typeof B=="string")return J;const M=function(X,ie){return(0,_.isEqualOrParent)(X,B.base,!R.isLinux)?J((0,I.ltrim)(X.substr(B.base.length),T.sep),ie):null};return M.allBasenames=J.allBasenames,M.allPaths=J.allPaths,M.basenames=J.basenames,M.patterns=J.patterns,M}function o(J,B){return B.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function l(J,B){return function(M,X){return typeof M=="string"&&M.endsWith(J)?B:null}}function w(J,B){const M=`/${J}`,X=`\\${J}`,ie=function(H,Z){return typeof H!="string"?null:Z?Z===J?B:null:H===J||H.endsWith(M)||H.endsWith(X)?B:null},se=[J];return ie.basenames=se,ie.patterns=[B],ie.allBasenames=se,ie}function S(J,B){const M=te(J.slice(1,-1).split(",").map(Z=>i(Z,B)).filter(Z=>Z!==t),J),X=M.length;if(!X)return t;if(X===1)return M[0];const ie=function(Z,$){for(let g=0,A=M.length;g<A;g++)if(M[g](Z,$))return J;return null},se=M.find(Z=>!!Z.allBasenames);se&&(ie.allBasenames=se.allBasenames);const H=M.reduce((Z,$)=>$.allPaths?Z.concat($.allPaths):Z,[]);return H.length&&(ie.allPaths=H),ie}function c(J,B,M){const X=T.sep===T.posix.sep,ie=X?J:J.replace(v,T.sep),se=T.sep+ie,H=T.posix.sep+J;let Z;return M?Z=function($,g){return typeof $=="string"&&($===ie||$.endsWith(se)||!X&&($===J||$.endsWith(H)))?B:null}:Z=function($,g){return typeof $=="string"&&($===ie||!X&&$===J)?B:null},Z.allPaths=[(M?"*/":"./")+J],Z}function C(J){try{const B=new RegExp(`^${E(J)}$`);return function(M){return B.lastIndex=0,typeof M=="string"&&B.test(M)?J:null}}catch{return t}}function D(J,B,M){return!J||typeof B!="string"?!1:N(J)(B,void 0,M)}e.match=D;function N(J,B={}){if(!J)return r;if(typeof J=="string"||F(J)){const M=i(J,B);if(M===t)return r;const X=function(ie,se){return!!M(ie,se)};return M.allBasenames&&(X.allBasenames=M.allBasenames),M.allPaths&&(X.allPaths=M.allPaths),X}return x(J,B)}e.parse=N;function F(J){const B=J;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=F;function V(J){return J.allBasenames||[]}e.getBasenameTerms=V;function z(J){return J.allPaths||[]}e.getPathTerms=z;function x(J,B){const M=te(Object.getOwnPropertyNames(J).map(Z=>Q(Z,J[Z],B)).filter(Z=>Z!==t)),X=M.length;if(!X)return t;if(!M.some(Z=>!!Z.requiresSiblings)){if(X===1)return M[0];const Z=function(A,W){let q;for(let j=0,K=M.length;j<K;j++){const ee=M[j](A,W);if(typeof ee=="string")return ee;(0,O.isThenable)(ee)&&(q||(q=[]),q.push(ee))}return q?(async()=>{for(const j of q){const K=await j;if(typeof K=="string")return K}return null})():null},$=M.find(A=>!!A.allBasenames);$&&(Z.allBasenames=$.allBasenames);const g=M.reduce((A,W)=>W.allPaths?A.concat(W.allPaths):A,[]);return g.length&&(Z.allPaths=g),Z}const ie=function(Z,$,g){let A,W;for(let q=0,j=M.length;q<j;q++){const K=M[q];K.requiresSiblings&&g&&($||($=(0,T.basename)(Z)),A||(A=$.substr(0,$.length-(0,T.extname)(Z).length)));const ee=K(Z,$,A,g);if(typeof ee=="string")return ee;(0,O.isThenable)(ee)&&(W||(W=[]),W.push(ee))}return W?(async()=>{for(const q of W){const j=await q;if(typeof j=="string")return j}return null})():null},se=M.find(Z=>!!Z.allBasenames);se&&(ie.allBasenames=se.allBasenames);const H=M.reduce((Z,$)=>$.allPaths?Z.concat($.allPaths):Z,[]);return H.length&&(ie.allPaths=H),ie}function Q(J,B,M){if(B===!1)return t;const X=i(J,M);if(X===t)return t;if(typeof B=="boolean")return X;if(B){const ie=B.when;if(typeof ie=="string"){const se=(H,Z,$,g)=>{if(!g||!X(H,Z))return null;const A=ie.replace("$(basename)",()=>$),W=g(A);return(0,O.isThenable)(W)?W.then(q=>q?J:null):W?J:null};return se.requiresSiblings=!0,se}}return X}function te(J,B){const M=J.filter(Z=>!!Z.basenames);if(M.length<2)return J;const X=M.reduce((Z,$)=>{const g=$.basenames;return g?Z.concat(g):Z},[]);let ie;if(B){ie=[];for(let Z=0,$=X.length;Z<$;Z++)ie.push(B)}else ie=M.reduce((Z,$)=>{const g=$.patterns;return g?Z.concat(g):Z},[]);const se=function(Z,$){if(typeof Z!="string")return null;if(!$){let A;for(A=Z.length;A>0;A--){const W=Z.charCodeAt(A-1);if(W===47||W===92)break}$=Z.substr(A)}const g=X.indexOf($);return g!==-1?ie[g]:null};se.basenames=X,se.patterns=ie,se.allBasenames=X;const H=J.filter(Z=>!Z.basenames);return H.push(se),H}function G(J,B){return(0,L.equals)(J,B,(M,X)=>typeof M=="string"&&typeof X=="string"?M===X:typeof M!="string"&&typeof X!="string"?M.base===X.base&&M.pattern===X.pattern:!1)}e.patternsEquals=G}),define(oe[91],ae([0,1,16,12]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function _(p){return p.toJSON()}class U{constructor(v){this._uriTransformer=v}transformIncoming(v){const d=this._uriTransformer.transformIncoming(v);return d===v?v:_(O.URI.from(d))}transformOutgoing(v){const d=this._uriTransformer.transformOutgoing(v);return d===v?v:_(O.URI.from(d))}transformOutgoingURI(v){const d=this._uriTransformer.transformOutgoing(v);return d===v?v:O.URI.from(d)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=U,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function T(p,v,d){if(!p||d>200)return null;if(typeof p=="object"){if(p instanceof O.URI)return v.transformOutgoing(p);for(const f in p)if(Object.hasOwnProperty.call(p,f)){const E=T(p[f],v,d+1);E!==null&&(p[f]=E)}}return null}function R(p,v){const d=T(p,v,0);return d===null?p:d}e.transformOutgoingURIs=R;function I(p,v,d,f){if(!p||f>200)return null;if(typeof p=="object"){if(p.$mid===1)return d?O.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof L.VSBuffer)return null;for(const E in p)if(Object.hasOwnProperty.call(p,E)){const a=I(p[E],v,d,f+1);a!==null&&(p[E]=a)}}return null}function m(p,v){const d=I(p,v,!1,0);return d===null?p:d}e.transformIncomingURIs=m;function P(p,v){const d=I(p,v,!0,0);return d===null?p:d}e.transformAndReviveIncomingURIs=P}),define(oe[136],ae([0,1,36,47,32,125]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(m){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(m)}value(){if(this._value===void 0){let m=0,P=0;const p=(0,L.networkInterfaces)();for(const v in p){const d=p[v];if(d)for(const{mac:f,internal:E}of d)E||(P+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(m+=1))}this._value=P>0?m/P:0}return this._value}};let T;async function R(m){return T||(T=(async()=>await I(m)||_.generateUuid())()),T}e.getMachineId=R;async function I(m){try{const P=await new Promise((v,d)=>{ne(["crypto"],v,d)}),p=(0,U.getMac)();return P.createHash("sha256").update(p,"utf8").digest("hex")}catch(P){m(P);return}}}),define(oe[30],ae([0,1,51,36,261,6,46,86,15,5,22,12]),function(ne,e,L,O,_,U,T,R,I,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function d(x,Q=v.UNLINK,te){if((0,T.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");return Q===v.UNLINK?E(x):f(x,te)}async function f(x,Q=(0,T.randomPath)((0,O.tmpdir)())){try{try{await L.promises.rename(x,Q)}catch(te){return te.code==="ENOENT"?void 0:E(x)}E(Q).catch(te=>{})}catch(te){if(te.code!=="ENOENT")throw te}}async function E(x){return(0,_.promisify)(L.rm)(x,{recursive:!0,force:!0,maxRetries:3})}function a(x){if((0,T.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(x,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function h(x,Q){return y(await(Q?u(x):(0,_.promisify)(L.readdir)(x)))}async function u(x){try{return await(0,_.promisify)(L.readdir)(x,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const Q=[],te=await h(x);for(const G of te){let J=!1,B=!1,M=!1;try{const X=await e.Promises.lstat((0,I.join)(x,G));J=X.isFile(),B=X.isDirectory(),M=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}Q.push({name:G,isFile:()=>J,isDirectory:()=>B,isSymbolicLink:()=>M})}return Q}function b(x){return y(L.readdirSync(x))}e.readdirSync=b;function y(x){return x.map(Q=>typeof Q=="string"?m.isMacintosh?(0,R.normalizeNFC)(Q):Q:(Q.name=m.isMacintosh?(0,R.normalizeNFC)(Q.name):Q.name,Q))}async function k(x){const Q=await h(x),te=[];for(const G of Q)await r.existsDirectory((0,I.join)(x,G))&&te.push(G);return te}function n(x,Q=1e3){return new Promise(te=>{let G=!1;const J=setInterval(()=>{G||(G=!0,L.access(x,B=>{G=!1,B&&(clearInterval(J),te(void 0))}))},Q)})}e.whenDeleted=n;var r;(function(x){async function Q(J){let B;try{if(B=await e.Promises.lstat(J),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(m.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw X}throw M}}x.stat=Q;async function te(J){try{const{stat:B,symbolicLink:M}=await x.stat(J);return B.isFile()&&M?.dangling!==!0}catch{}return!1}x.existsFile=te;async function G(J){try{const{stat:B,symbolicLink:M}=await x.stat(J);return B.isDirectory()&&M?.dangling!==!0}catch{}return!1}x.existsDirectory=G})(r||(e.SymlinkSupport=r={}));const t=new U.ResourceQueue;function i(x,Q,te){return t.queueFor(p.URI.file(x),P.extUriBiasedIgnorePathCase).queue(()=>{const G=S(te);return new Promise((J,B)=>l(x,Q,G,M=>M?B(M):J()))})}let s=!0;function o(x){s=x}e.configureFlushOnWrite=o;function l(x,Q,te,G){if(!s)return L.writeFile(x,Q,{mode:te.mode,flag:te.flag},G);L.open(x,te.flag,te.mode,(J,B)=>{if(J)return G(J);L.writeFile(B,Q,M=>{if(M)return L.close(B,()=>G(M));L.fdatasync(B,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),o(!1)),L.close(B,ie=>G(ie))))})})}function w(x,Q,te){const G=S(te);if(!s)return L.writeFileSync(x,Q,{mode:G.mode,flag:G.flag});const J=L.openSync(x,G.flag,G.mode);try{L.writeFileSync(J,Q);try{L.fdatasyncSync(J)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o(!1)}}finally{L.closeSync(J)}}e.writeFileSync=w;function S(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function c(x,Q){if(x!==Q)try{await e.Promises.rename(x,Q)}catch(te){if(x.toLowerCase()!==Q.toLowerCase()&&te.code==="EXDEV"||x.endsWith("."))await C(x,Q,{preserveSymlinks:!1}),await d(x,v.MOVE);else throw te}}async function C(x,Q,te){return N(x,Q,{root:{source:x,target:Q},options:te,handledSourcePaths:new Set})}const D=511;async function N(x,Q,te){if(te.handledSourcePaths.has(x))return;te.handledSourcePaths.add(x);const{stat:G,symbolicLink:J}=await r.stat(x);if(J){if(te.options.preserveSymlinks)try{return await z(x,Q,te)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(J.dangling)return}return G.isDirectory()?F(x,Q,G.mode&D,te):V(x,Q,G.mode&D)}async function F(x,Q,te,G){await e.Promises.mkdir(Q,{recursive:!0,mode:te});const J=await h(x);for(const B of J)await N((0,I.join)(x,B),(0,I.join)(Q,B),G)}async function V(x,Q,te){await e.Promises.copyFile(x,Q),await e.Promises.chmod(Q,te)}async function z(x,Q,te){let G=await e.Promises.readlink(x);(0,T.isEqualOrParent)(G,te.root.source,!m.isLinux)&&(G=(0,I.join)(te.root.target,G.substr(te.root.source.length+1))),await e.Promises.symlink(G,Q)}e.Promises=new class{get access(){return(0,_.promisify)(L.access)}get stat(){return(0,_.promisify)(L.stat)}get lstat(){return(0,_.promisify)(L.lstat)}get utimes(){return(0,_.promisify)(L.utimes)}get read(){return(x,Q,te,G,J)=>new Promise((B,M)=>{L.read(x,Q,te,G,J,(X,ie,se)=>X?M(X):B({bytesRead:ie,buffer:se}))})}get readFile(){return(0,_.promisify)(L.readFile)}get write(){return(x,Q,te,G,J)=>new Promise((B,M)=>{L.write(x,Q,te,G,J,(X,ie,se)=>X?M(X):B({bytesWritten:ie,buffer:se}))})}get appendFile(){return(0,_.promisify)(L.appendFile)}get fdatasync(){return(0,_.promisify)(L.fdatasync)}get truncate(){return(0,_.promisify)(L.truncate)}get rename(){return(0,_.promisify)(L.rename)}get copyFile(){return(0,_.promisify)(L.copyFile)}get open(){return(0,_.promisify)(L.open)}get close(){return(0,_.promisify)(L.close)}get symlink(){return(0,_.promisify)(L.symlink)}get readlink(){return(0,_.promisify)(L.readlink)}get chmod(){return(0,_.promisify)(L.chmod)}get mkdir(){return(0,_.promisify)(L.mkdir)}get unlink(){return(0,_.promisify)(L.unlink)}get rmdir(){return(0,_.promisify)(L.rmdir)}get realpath(){return(0,_.promisify)(L.realpath)}async exists(x){try{return await e.Promises.access(x),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return d}get move(){return c}get copy(){return C}}}),define(oe[137],ae([0,1,51,15,5,27,30]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(v){if(_.isLinux)return v;const d=(0,O.dirname)(v);if(v===d)return v;const f=((0,O.basename)(v)||v).toLowerCase();try{const a=(0,T.readdirSync)(d).filter(h=>h.toLowerCase()===f);if(a.length===1){const h=R(d);if(h)return(0,O.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(f);if(h>=0){const u=R(d);if(u)return(0,O.join)(u,a[h])}}}catch{}return null}e.realcaseSync=R;async function I(v){if(_.isLinux)return v;const d=(0,O.dirname)(v);if(v===d)return v;const f=((0,O.basename)(v)||v).toLowerCase();try{const a=(await T.Promises.readdir(d)).filter(h=>h.toLowerCase()===f);if(a.length===1){const h=await I(d);if(h)return(0,O.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(f);if(h>=0){const u=await I(d);if(u)return(0,O.join)(u,a[h])}}}catch{}return null}e.realcase=I;async function m(v){try{return await T.Promises.realpath(v)}catch{const f=p(v);return await T.Promises.access(f,L.constants.R_OK),f}}e.realpath=m;function P(v){try{return L.realpathSync(v)}catch{const f=p(v);return L.accessSync(f,L.constants.R_OK),f}}e.realpathSync=P;function p(v){return(0,U.rtrim)((0,O.normalize)(v),O.sep)}}),define(oe[138],ae([0,1,15,5,37,87,10,30]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return U.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return U.TerminateResponseCode}});function I(p=_.env){return p.comspec||"cmd.exe"}e.getWindowsShell=I;function m(p){let v=[],d=!1;const f=function(E){if(d){v.push(E);return}(!p.send(E,h=>{if(h&&console.error(h),d=!1,v.length>0){const u=v.slice(0);v=[],u.forEach(b=>f(b))}})||O.isWindows)&&(d=!0)};return{send:f}}e.createQueuedSender=m;var P;(function(p){async function v(d,f,E){if(L.isAbsolute(d))return d;if(f===void 0&&(f=_.cwd()),L.dirname(d)!=="."||(E===void 0&&T.isString(_.env.PATH)&&(E=_.env.PATH.split(L.delimiter)),E===void 0||E.length===0))return L.join(f,d);async function h(u){if(await R.Promises.exists(u)){let b;try{b=await R.Promises.stat(u)}catch(y){y.message.startsWith("EACCES")&&(b=await R.Promises.lstat(u))}return b?!b.isDirectory():!1}return!1}for(const u of E){let b;if(L.isAbsolute(u)?b=L.join(u,d):b=L.join(f,u,d),await h(b))return b;let y=b+".com";if(await h(y)||(y=b+".exe",await h(y)))return y}return L.join(f,d)}p.findExecutable=v})(P||(e.win32=P={}))}),define(oe[139],ae([0,1,65,25]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function _(T){return new Promise((R,I)=>{let m;const P=new Map;function p(d,f,E,a,h){const u=P.get(f);if(d===T||u){const b={name:v(E),cmd:E,pid:d,ppid:f,load:a,mem:h};P.set(d,b),d===T&&(m=b),u&&(u.children||(u.children=[]),u.children.push(b),u.children.length>1&&(u.children=u.children.sort((y,k)=>y.pid-k.pid)))}}function v(d){const f=/--utility-sub-type=network/i,E=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,b=/--type=([a-zA-Z-]+)/;if(a.exec(d))return"electron-crash-reporter";if(h.exec(d))return"winpty-process";if(u.exec(d))return"console-window-host (Windows internal process)";let y=b.exec(d);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?f.exec(d)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const k=/[a-zA-Z-]+\.js/g;let n="";do y=k.exec(d),y&&(n+=y+" ");while(y);return n&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${n})`:E.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,E)=>{ne(["@vscode/windows-process-tree"],f,E)}).then(f=>{f.getProcessList(T,E=>{if(!E){I(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(E,a=>{const h=new Map;a.forEach(u=>{const b=d(u.commandLine||"");h.set(u.pid,{name:v(b),cmd:b,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),m=h.get(T),m?(h.forEach(u=>{const b=h.get(u.ppid);b&&(b.children||(b.children=[]),b.children.push(u))}),h.forEach(u=>{u.children&&(u.children=u.children.sort((b,y)=>b.pid-y.pid))}),R(m)):I(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let d=function(){let f=[m];const E=[];for(;f.length;){const h=f.shift();h&&(E.push(h.pid),h.children&&(f=f.concat(h.children)))}let a=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+E.join(" "),(0,L.exec)(a,{},(h,u,b)=>{if(h||b)I(h||new Error(b.toString()));else{const y=u.toString().split(`
`);for(let k=0;k<E.length;k++){const n=P.get(E[k]);n.load=parseFloat(y[k])}if(!m){I(new Error(`Root process ${T} not found`));return}R(m)}})};(0,L.exec)("which ps",{},(f,E,a)=>{if(f||a)if(process.platform!=="linux")I(f||new Error(a.toString()));else{const h=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(h,{},(u,b,y)=>{u||y?I(u||new Error(y.toString())):(U(b,p),d())})}else{const h=E.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${h} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,y,k)=>{b||k&&!k.includes("screen size is bogus")?I(b||new Error(k.toString())):(U(y,p),process.platform==="linux"?d():m?R(m):I(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=_;function U(T,R){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=T.toString().split(`
`);for(const P of m){const p=I.exec(P.trim());p&&p.length===6&&R(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}});var pe=this&&this.__decorate||function(ne,e,L,O){var _=arguments.length,U=_<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,L):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(ne,e,L,O);else for(var R=ne.length-1;R>=0;R--)(T=ne[R])&&(U=(_<3?T(U):_>3?T(e,L,U):T(e,L))||U);return _>3&&U&&Object.defineProperty(e,L,U),U};define(oe[43],ae([0,1,21,6,16,26,59,7,3,2,64,27,10]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(d||(d={}));function f(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(E||(E={}));function a(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(h||(h={}));function u(B){let M=0;for(let X=0;;X+=7){const ie=B.read(1);if(M|=(ie.buffer[0]&127)<<X,!(ie.buffer[0]&128))return M}}const b=t(0);function y(B,M){if(M===0){B.write(b);return}let X=0;for(let se=M;se!==0;se=se>>>7)X++;const ie=_.VSBuffer.alloc(X);for(let se=0;M!==0;se++)ie.buffer[se]=M&127,M=M>>>7,M>0&&(ie.buffer[se]|=128);B.write(ie)}class k{constructor(M){this.buffer=M,this.pos=0}read(M){const X=this.buffer.slice(this.pos,this.pos+M);return this.pos+=X.byteLength,X}}e.BufferReader=k;class n{constructor(){this.buffers=[]}get buffer(){return _.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}e.BufferWriter=n;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function t(B){const M=_.VSBuffer.alloc(1);return M.writeUInt8(B,0),M}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(B,M){if(typeof M>"u")B.write(i.Undefined);else if(typeof M=="string"){const X=_.VSBuffer.fromString(M);B.write(i.String),y(B,X.byteLength),B.write(X)}else if(s&&Buffer.isBuffer(M)){const X=_.VSBuffer.wrap(M);B.write(i.Buffer),y(B,X.byteLength),B.write(X)}else if(M instanceof _.VSBuffer)B.write(i.VSBuffer),y(B,M.byteLength),B.write(M);else if(Array.isArray(M)){B.write(i.Array),y(B,M.length);for(const X of M)o(B,X)}else if(typeof M=="number"&&(M|0)===M)B.write(i.Uint),y(B,M);else{const X=_.VSBuffer.fromString(JSON.stringify(M));B.write(i.Object),y(B,X.byteLength),B.write(X)}}e.serialize=o;function l(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(u(B)).toString();case r.Buffer:return B.read(u(B)).buffer;case r.VSBuffer:return B.read(u(B));case r.Array:{const X=u(B),ie=[];for(let se=0;se<X;se++)ie.push(l(B));return ie}case r.Object:return JSON.parse(B.read(u(B)).toString());case r.Int:return u(B)}}e.deserialize=l;class w{constructor(M,X,ie=null,se=1e3){this.protocol=M,this.ctx=X,this.logger=ie,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(M,X){this.channels.set(M,X),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const X=this.send([M.type]);this.logger?.logOutgoing(X,0,1,a(M.type));return}case 201:case 202:case 204:case 203:{const X=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(X,M.id,1,a(M.type),M.data);return}}}send(M,X=void 0){const ie=new n;return o(ie,M),o(ie,X),this.sendBuffer(ie.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const X=new k(M),ie=l(X),se=l(X),H=ie[0];switch(H){case 100:return this.logger?.logIncoming(M.byteLength,ie[1],1,`${f(H)}: ${ie[2]}.${ie[3]}`,se),this.onPromise({type:H,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 102:return this.logger?.logIncoming(M.byteLength,ie[1],1,`${f(H)}: ${ie[2]}.${ie[3]}`,se),this.onEventListen({type:H,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 101:return this.logger?.logIncoming(M.byteLength,ie[1],1,`${f(H)}`),this.disposeActiveRequest({type:H,id:ie[1]});case 103:return this.logger?.logIncoming(M.byteLength,ie[1],1,`${f(H)}`),this.disposeActiveRequest({type:H,id:ie[1]})}}onPromise(M){const X=this.channels.get(M.channelName);if(!X){this.collectPendingRequest(M);return}const ie=new U.CancellationTokenSource;let se;try{se=X.call(this.ctx,M.name,M.arg,ie.token)}catch($){se=Promise.reject($)}const H=M.id;se.then($=>{this.sendResponse({id:H,data:$,type:201}),this.activeRequests.delete(M.id)},$=>{$ instanceof Error?this.sendResponse({id:H,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:H,data:$,type:203}),this.activeRequests.delete(M.id)});const Z=(0,m.toDisposable)(()=>ie.cancel());this.activeRequests.set(M.id,Z)}onEventListen(M){const X=this.channels.get(M.channelName);if(!X){this.collectPendingRequest(M);return}const ie=M.id,H=X.listen(this.ctx,M.name,M.arg)(Z=>this.sendResponse({id:ie,data:Z,type:204}));this.activeRequests.set(M.id,H)}disposeActiveRequest(M){const X=this.activeRequests.get(M.id);X&&(X.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let X=this.pendingRequests.get(M.channelName);X||(X=[],this.pendingRequests.set(M.channelName,X));const ie=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:M,timeoutTimer:ie})}flushPendingRequests(M){const X=this.pendingRequests.get(M);if(X){for(const ie of X)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=w;var S;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class c{constructor(M,X=null){this.protocol=M,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=X}getChannel(M){const X=this;return{call(ie,se,H){return X.isDisposed?Promise.reject(new R.CancellationError):X.requestPromise(M,ie,se,H)},listen(ie,se){return X.isDisposed?I.Event.None:X.requestEvent(M,ie,se)}}}requestPromise(M,X,ie,se=U.CancellationToken.None){const H=this.lastRequestId++,$={id:H,type:100,channelName:M,name:X,arg:ie};if(se.isCancellationRequested)return Promise.reject(new R.CancellationError);let g;return new Promise((W,q)=>{if(se.isCancellationRequested)return q(new R.CancellationError);const j=()=>{const ue=fe=>{switch(fe.type){case 201:this.handlers.delete(H),W(fe.data);break;case 202:{this.handlers.delete(H);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,q(ve);break}case 203:this.handlers.delete(H),q(fe.data);break}};this.handlers.set(H,ue),this.sendRequest($)};let K=null;this.state===h.Idle?j():(K=(0,O.createCancelablePromise)(ue=>this.whenInitialized()),K.then(()=>{K=null,j()}));const ee=()=>{K?(K.cancel(),K=null):this.sendRequest({id:H,type:101}),q(new R.CancellationError)},ce=se.onCancellationRequested(ee);g=(0,m.combinedDisposable)((0,m.toDisposable)(ee),ce),this.activeRequests.add(g)}).finally(()=>{this.activeRequests.delete(g)})}requestEvent(M,X,ie){const se=this.lastRequestId++,Z={id:se,type:102,channelName:M,name:X,arg:ie};let $=null;const g=new I.Emitter({onWillAddFirstListener:()=>{$=(0,O.createCancelablePromise)(W=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(g),this.sendRequest(Z)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(g),this.sendRequest({id:se,type:103}))}}),A=W=>g.fire(W.data);return this.handlers.set(se,A),g.event}sendRequest(M){switch(M.type){case 100:case 102:{const X=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing(X,M.id,0,`${f(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const X=this.send([M.type,M.id]);this.logger?.logOutgoing(X,M.id,0,f(M.type));return}}}send(M,X=void 0){const ie=new n;return o(ie,M),o(ie,X),this.sendBuffer(ie.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const X=new k(M),ie=l(X),se=l(X),H=ie[0];switch(H){case 200:return this.logger?.logIncoming(M.byteLength,0,0,a(H)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(M.byteLength,ie[1],0,a(H),se),this.onResponse({type:ie[0],id:ie[1],data:se})}}onResponse(M){if(M.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=c,pe([T.memoize],c.prototype,"onDidInitializePromise",null);class C{get connections(){const M=[];return this._connections.forEach(X=>M.push(X)),M}constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:X,onDidClientDisconnect:ie})=>{I.Event.once(X.onMessage)(H=>{const Z=new k(H),$=l(Z),g=new w(X,$),A=new c(X);this.channels.forEach((q,j)=>g.registerChannel(j,q));const W={channelServer:g,channelClient:A,ctx:$};this._connections.add(W),this._onDidAddConnection.fire(W),ie(()=>{g.dispose(),A.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(M,X){const ie=this;return{call(se,H,Z){let $;if((0,v.isFunction)(X)){const A=(0,L.getRandomElement)(ie.connections.filter(X));$=A?Promise.resolve(A):I.Event.toPromise(I.Event.filter(ie.onDidAddConnection,X))}else $=X.routeCall(ie,se,H);const g=$.then(A=>A.channelClient.getChannel(M));return N(g).call(se,H,Z)},listen(se,H){if((0,v.isFunction)(X))return ie.getMulticastEvent(M,X,se,H);const Z=X.routeEvent(ie,se,H).then($=>$.channelClient.getChannel(M));return N(Z).listen(se,H)}}}getMulticastEvent(M,X,ie,se){const H=this;let Z=new m.DisposableStore;const $=new I.Emitter({onWillAddFirstListener:()=>{Z=new m.DisposableStore;const g=new I.EventMultiplexer,A=new Map,W=j=>{const ee=j.channelClient.getChannel(M).listen(ie,se),ce=g.add(ee);A.set(j,ce)},q=j=>{const K=A.get(j);K&&(K.dispose(),A.delete(j))};H.connections.filter(X).forEach(W),I.Event.filter(H.onDidAddConnection,X)(W,void 0,Z),H.onDidRemoveConnection(q,void 0,Z),g.event($.fire,$,Z),Z.add(g)},onDidRemoveLastListener:()=>{Z.dispose()}});return $.event}registerChannel(M,X){this.channels.set(M,X),this._connections.forEach(ie=>{ie.channelServer.registerChannel(M,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class D{constructor(M,X,ie=null){const se=new n;o(se,X),M.send(se.buffer),this.channelClient=new c(M,ie),this.channelServer=new w(M,X,ie)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,X){this.channelServer.registerChannel(M,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function N(B){return{call(M,X,ie){return B.then(se=>se.call(M,X,ie))},listen(M,X){const ie=new I.Relay;return B.then(se=>ie.input=se.listen(M,X)),ie.event}}}e.getDelayedChannel=N;function F(B){let M=!1;return{call(X,ie,se){return M?B.call(X,ie,se):(0,O.timeout)(0).then(()=>M=!0).then(()=>B.call(X,ie,se))},listen(X,ie){if(M)return B.listen(X,ie);const se=new I.Relay;return(0,O.timeout)(0).then(()=>M=!0).then(()=>se.input=B.listen(X,ie)),se.event}}}e.getNextTickChannel=F;class V{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const X of M.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await I.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=V;var z;(function(B){function M(H,Z){const $=H,g=Z&&Z.disableMarshalling,A=new Map;for(const W in $)ie(W)&&A.set(W,I.Event.buffer($[W],!0));return new class{listen(W,q,j){const K=A.get(q);if(K)return K;if(se(q)){const ee=$[q];if(typeof ee=="function")return ee.call($,j)}throw new Error(`Event not found: ${q}`)}call(W,q,j){const K=$[q];if(typeof K=="function"){if(!g&&Array.isArray(j))for(let ee=0;ee<j.length;ee++)j[ee]=(0,P.revive)(j[ee]);return K.apply($,j)}throw new Error(`Method not found: ${q}`)}}}B.fromService=M;function X(H,Z){const $=Z&&Z.disableMarshalling;return new Proxy({},{get(g,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):se(A)?function(W){return H.listen(A,W)}:ie(A)?H.listen(A):async function(...W){let q;Z&&!(0,v.isUndefinedOrNull)(Z.context)?q=[Z.context,...W]:q=W;const j=await H.call(A,q);return $?j:(0,P.revive)(j)};throw new Error(`Property not found: ${String(A)}`)}})}B.toService=X;function ie(H){return H[0]==="o"&&H[1]==="n"&&p.isUpperAsciiLetter(H.charCodeAt(2))}function se(H){return/^onDynamic/.test(H)&&p.isUpperAsciiLetter(H.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const M=B.toString();if(M!=="[object Object]")return M}return B}function te(B){return Array.isArray(B)?B.map(Q):Q(B)}function G(B,M,X,ie,se,H,Z){Z=te(Z);const $=x[se],g=$[ie%$.length];let A=[`%c[${B}]%c[${String(M).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(H)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}class J{constructor(M,X){this._outgoingPrefix=M,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,X,ie,se,H){this._totalOutgoing+=M,G(this._outgoingPrefix,this._totalOutgoing,M,X,ie,se,H)}logIncoming(M,X,ie,se,H){this._totalIncoming+=M,G(this._incomingPrefix,this._totalIncoming,M,X,ie,se,H)}}e.IPCLogger=J}),define(oe[92],ae([0,1,6,16,3,2,43]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var I;(function(c){c.enableDiagnostics=!1,c.records=[];const C=new WeakMap;let D=0;function N(V,z){if(!C.has(V)){const x=String(++D);C.set(V,x)}return C.get(V)}function F(V,z,x,Q){if(!c.enableDiagnostics)return;const te=N(V,z);if(Q instanceof O.VSBuffer||Q instanceof Uint8Array||Q instanceof ArrayBuffer||ArrayBuffer.isView(Q)){const G=O.VSBuffer.alloc(Q.byteLength);G.set(Q),c.records.push({timestamp:Date.now(),id:te,label:z,type:x,buff:G})}else c.records.push({timestamp:Date.now(),id:te,label:z,type:x,data:Q})}c.traceSocketEvent=F})(I||(e.SocketDiagnostics=I={}));var m;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let P=null;function p(){return P||(P=O.VSBuffer.alloc(0)),P}class v{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(C){this._chunks.push(C),this._totalLength+=C.byteLength}read(C){return this._read(C,!0)}peek(C){return this._read(C,!1)}_read(C,D){if(C===0)return p();if(C>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===C){const z=this._chunks[0];return D&&(this._chunks.shift(),this._totalLength-=C),z}if(this._chunks[0].byteLength>C){const z=this._chunks[0].slice(0,C);return D&&(this._chunks[0]=this._chunks[0].slice(C),this._totalLength-=C),z}const N=O.VSBuffer.alloc(C);let F=0,V=0;for(;C>0;){const z=this._chunks[V];if(z.byteLength>C){const x=z.slice(0,C);N.set(x,F),F+=C,D&&(this._chunks[V]=z.slice(C),this._totalLength-=C),C-=C}else N.set(z,F),F+=z.byteLength,D?(this._chunks.shift(),this._totalLength-=z.byteLength):V++,C-=z.byteLength}return N}}e.ChunkStream=v;var d;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive",c[c.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",c[c.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function f(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime",c[c.LatencySampleTime=6e4]="LatencySampleTime",c[c.LatencySampleCount=5]="LatencySampleCount",c[c.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",c[c.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E||(e.ProtocolConstants=E={}));class a{constructor(C,D,N,F){this.type=C,this.id=D,this.ack=N,this.data=F,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends U.Disposable{constructor(C){super(),this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=C,this._isDisposed=!1,this._incomingData=new v,this._register(this._socket.onData(D=>this.acceptChunk(D))),this.lastReadTime=Date.now()}acceptChunk(C){if(!(!C||C.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;){const D=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=D.readUInt32BE(9),this._state.messageType=D.readUInt8(0),this._state.id=D.readUInt32BE(1),this._state.ack=D.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const N=this._state.messageType,F=this._state.id,V=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",D),this._onMessage.fire(new a(N,F,V,D)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(C){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=C,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(C){if(this._isDisposed)return;C.writtenTime=Date.now(),this.lastWriteTime=Date.now();const D=O.VSBuffer.alloc(13);D.writeUInt8(C.type,0),D.writeUInt32BE(C.id,1),D.writeUInt32BE(C.ack,5),D.writeUInt32BE(C.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(C.type),id:C.id,ack:C.ack,messageSize:C.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",C.data),this._writeSoon(D,C.data)}_bufferAdd(C,D){const N=this._totalLength===0;return this._data.push(C,D),this._totalLength+=C.byteLength+D.byteLength,N}_bufferTake(){const C=O.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,C}_writeSoon(C,D){this._bufferAdd(C,D)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const C=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:C.byteLength}),this._socket.write(C)}}class b extends U.Disposable{constructor(C){super(),this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=C,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(D=>{D.type===1&&this._onMessage.fire(D.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(C){this._socketWriter.write(new a(1,0,0,C))}}e.Protocol=b;class y extends T.IPCClient{static fromSocket(C,D){return new y(new b(C),D)}get onDidDispose(){return this.protocol.onDidDispose}constructor(C,D,N=null){super(C,D,N),this.protocol=C}dispose(){super.dispose();const C=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),C.end()}}e.Client=y;class k{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(C){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(C):this._emitter.fire(C):this._bufferedMessages.push(C)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=k;class n{constructor(C){this.data=C,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let C=0,D=this._first;for(;D;)D=D.next,C++;return C}peek(){return this._first?this._first.data:null}toArray(){const C=[];let D=0,N=this._first;for(;N;)C[D++]=N.data,N=N.next;return C}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(C){const D=new n(C);if(!this._first){this._first=D,this._last=D;return}this._last.next=D,this._last=D}}class t{static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}constructor(){this.lastRuns=[];const C=Date.now();for(let D=0;D<t._HISTORY_LENGTH;D++)this.lastRuns[D]=C-1e3*D;setInterval(()=>{for(let D=t._HISTORY_LENGTH;D>=1;D--)this.lastRuns[D]=this.lastRuns[D-1];this.lastRuns[0]=Date.now()},1e3)}load(){const C=Date.now(),D=(1+t._HISTORY_LENGTH)*1e3;let N=0;for(let F=0;F<t._HISTORY_LENGTH;F++)C-this.lastRuns[F]<=D&&N++;return 1-N/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;var i;(function(c){c[c.Good=0]="Good",c[c.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function s(c){switch(c){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class o{constructor(C){this.connectionHealth=C}}e.ConnectionHealthChangedEvent=o;class l{constructor(C,D){this.roundTripTime=C,this.recentHighRoundTripCount=D}}e.HighRoundTripTimeEvent=l;class w{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(C){this._onControlMessage=new k,this.onControlMessage=this._onControlMessage.event,this._onMessage=new k,this.onMessage=this._onMessage.event,this._onDidDispose=new k,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new k,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new k,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new k,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new k,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=C.loadEstimator??t.getInstance(),this._measureRoundTripTime=C.measureRoundTripTime??!1,this._shouldSendKeepAlive=C.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new U.DisposableStore,this._socket=C.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(D=>this._receiveMessage(D))),this._socketDisposables.add(this._socket.onClose(D=>this._onSocketClose.fire(D))),this._socketLatencyMonitor=this._socketDisposables.add(new S),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(D=>this._sendLatencyMeasurementRequest(D))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(D=>this._onHighRoundTripTime.fire(D))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(D=>this._onDidChangeConnectionHealth.fire(D))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),C.initialChunk&&this._socketReader.acceptChunk(C.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const C=new a(5,0,0,p());this._socketWriter.write(C),this._socketWriter.flush()}sendPause(){const C=new a(7,0,0,p());this._socketWriter.write(C)}sendResume(){const C=new a(8,0,0,p());this._socketWriter.write(C)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(C,D){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new U.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=C,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(N=>this._receiveMessage(N))),this._socketDisposables.add(this._socket.onClose(N=>this._onSocketClose.fire(N))),this._socketLatencyMonitor=this._socketDisposables.add(new S),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(N=>this._sendLatencyMeasurementRequest(N))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(N=>this._onHighRoundTripTime.fire(N))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(N=>this._onDidChangeConnectionHealth.fire(N))),this._socketReader.acceptChunk(D)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const C=new a(3,0,this._incomingAckId,p());this._socketWriter.write(C);const D=this._outgoingUnackMsg.toArray();for(let N=0,F=D.length;N<F;N++)this._socketWriter.write(D[N]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(C){if(C.ack>this._outgoingAckId){this._outgoingAckId=C.ack;do{const D=this._outgoingUnackMsg.peek();if(D&&D.id<=C.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(C.type){case 0:break;case 1:{if(C.id>this._incomingMsgId)if(C.id!==this._incomingMsgId+1){const D=Date.now();D-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=D,this._socketWriter.write(new a(6,0,0,p())))}else this._incomingMsgId=C.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(C.data);break}case 2:{this._onControlMessage.fire(C.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const D=this._outgoingUnackMsg.toArray();for(let N=0,F=D.length;N<F;N++)this._socketWriter.write(D[N]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(C.data);break}case 11:{this._socketLatencyMonitor.handleResponse(C.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(C){const D=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const N=new a(1,D,this._incomingAckId,C);this._outgoingUnackMsg.push(N),this._isReconnecting||(this._socketWriter.write(N),this._recvAckCheck())}sendControl(C){const D=new a(2,0,0,C);this._socketWriter.write(D)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const C=Date.now()-this._incomingMsgLastTime;if(C>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-C+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const C=this._outgoingUnackMsg.peek(),D=Date.now()-C.writtenTime,N=Date.now()-this._socketReader.lastReadTime,F=Date.now()-this._lastSocketTimeoutTime;if(D>=2e4&&N>=2e4&&F>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:D,timeSinceLastReceivedSomeData:N});return}const V=Math.max(2e4-D,2e4-N,2e4-F,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},V)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const C=new a(3,0,this._incomingAckId,p());this._socketWriter.write(C)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const C=new a(9,0,this._incomingAckId,p());this._socketWriter.write(C)}_sendLatencyMeasurementRequest(C){this._incomingAckId=this._incomingMsgId;const D=new a(10,0,this._incomingAckId,C);this._socketWriter.write(D)}_sendLatencyMeasurementResponse(C){this._incomingAckId=this._incomingMsgId;const D=new a(11,0,this._incomingAckId,C);this._socketWriter.write(D)}}e.PersistentProtocol=w;class S extends U.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new _.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new _.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new _.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new L.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},C=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const C=++this._lastLatencyMeasurementId,D=O.VSBuffer.alloc(4);D.writeUInt32BE(C,0),this._onSendLatencyRequest.fire(D)},6e4)}handleResponse(C){if(C.byteLength!==4)return;const D=C.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||D!==this._lastLatencyMeasurementId)return;const N=Date.now()-this._lastLatencyMeasurementSent,F=this._latencySampleIndex++;this._latencySamples[F%this._latencySamples.length]=N;const V=this._connectionHealth,z=this._latencySamples.filter(x=>x>=1e3).length;this._connectionHealth=z>=3?1:0,N>1e3&&this._onHighRoundTripTime.fire(new l(N,z)),V!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(oe[93],ae([0,1,65,6,16,26,135,7,3,2,31,138,87,43]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends d.ChannelServer{constructor(h){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",u=>_.VSBuffer.wrap(Buffer.from(u,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=f;class E{constructor(h,u){this.modulePath=h,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new O.Delayer(b),this.child=null,this._client=null}getChannel(h){const u=this;return{call(b,y,k){return u.requestPromise(h,b,y,k)},listen(b,y){return u.requestEvent(h,b,y)}}}requestPromise(h,u,b,y=U.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const k=this.getCachedChannel(h),n=(0,O.createCancelablePromise)(i=>k.call(u,b,i)),r=y.onCancellationRequested(()=>n.cancel()),t=(0,m.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(h,u,b){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let y;const k=new I.Emitter({onWillAddFirstListener:()=>{y=this.getCachedChannel(h).listen(u,b)(k.fire,k),this.activeRequests.add(y)},onDidRemoveLastListener:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return k.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(u.env),this.child=(0,L.fork)(this.modulePath,h,u);const b=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}b.fire(_.VSBuffer.wrap(Buffer.from(s,"base64")))});const k=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&k.send(s.buffer.toString("base64")),r=b.event,t={send:n,onMessage:r};this._client=new d.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(l=>(0,m.dispose)(l)),this.activeRequests.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:o})})}return this._client}getCachedChannel(h){let u=this.channels.get(h);return u||(u=this.client.getChannel(h),this.channels.set(h,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(oe[140],ae([0,1,127,16,43,3,10,21]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(v){this.port=v,this.onMessage=U.Event.fromNodeEventEmitter(this.port,"message",d=>O.VSBuffer.wrap(d.data)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}class m extends _.IPCServer{static getOnDidClientConnect(){(0,T.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const v=new U.Emitter;return process.parentPort.on("message",d=>{const f=(0,R.firstOrDefault)(d.ports);f&&v.fire(f)}),U.Event.map(v.event,d=>({protocol:new I(d),onDidClientDisconnect:U.Event.fromNodeEventEmitter(d,"close")}))}constructor(){super(m.getOnDidClientConnect())}}e.Server=m;function P(p,v,d){const f=E=>{E.data===v&&(p.removeListener("message",f),d())};p.on("message",f)}e.once=P}),define(oe[66],ae([0,1,6,3,2,64,10]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function I(v){const d=v;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var m;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(m||(e.StorageState=m={}));class P extends _.Disposable{constructor(d,f=Object.create(null)){super(),this.database=d,this.options=f,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((f,E)=>this.accept(E,f)),d.deleted?.forEach(f=>this.accept(f,void 0))}accept(d,f){if(this.state===m.Closed)return;let E=!1;(0,T.isUndefinedOrNull)(f)?E=this.cache.delete(d):this.cache.get(d)!==f&&(this.cache.set(d,f),E=!0),E&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,f){const E=this.cache.get(d);return(0,T.isUndefinedOrNull)(E)?f:E}getBoolean(d,f){const E=this.get(d);return(0,T.isUndefinedOrNull)(E)?f:E==="true"}getNumber(d,f){const E=this.get(d);return(0,T.isUndefinedOrNull)(E)?f:parseInt(E,10)}getObject(d,f){const E=this.get(d);return(0,T.isUndefinedOrNull)(E)?f:(0,U.parse)(E)}async set(d,f){if(this.state===m.Closed)return;if((0,T.isUndefinedOrNull)(f))return this.delete(d);const E=(0,T.isObject)(f)||Array.isArray(f)?(0,U.stringify)(f):String(f);if(this.cache.get(d)!==E)return this.cache.set(d,E),this.pendingInserts.set(d,E),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===m.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((f,E)=>this.items.set(E,f)),d.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=p}),define(oe[141],ae([11,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(oe[142],ae([11,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[143],ae([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[144],ae([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(oe[145],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[146],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[147],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[148],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[149],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[150],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[151],ae([11,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[152],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(oe[153],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(oe[154],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(oe[155],ae([11,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[156],ae([11,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[157],ae([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[158],ae([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[159],ae([11,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(oe[160],ae([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[161],ae([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[162],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[163],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[164],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[165],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[166],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[167],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[168],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[169],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[170],ae([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[171],ae([11,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(oe[172],ae([0,1,7,144]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var _;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(_||(e.TokenType=_={}));function U(...m){switch(m.length){case 1:return(0,O.localize)(0,null,m[0]);case 2:return(0,O.localize)(1,null,m[0],m[1]);case 3:return(0,O.localize)(2,null,m[0],m[1],m[2]);default:return}}const T=(0,O.localize)(3,null),R=(0,O.localize)(4,null);class I{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const p=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:p})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const p=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:p})}else this._match(126)?this._addToken(9):this._error(U("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(U("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(U("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const p=this._start,v=this._input.substring(this._start,this._current),d={type:19,offset:this._start,lexeme:v};this._errors.push({offset:p,lexeme:v,additionalInfo:P}),this._tokens.push(d)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const p=this._input.substring(this._start,this._current),v=I._keywords.get(p);v?this._addToken(v):this._tokens.push({type:17,lexeme:p,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,p=!1,v=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(R);return}const f=this._input.charCodeAt(P);if(p)p=!1;else if(f===47&&!v){P++;break}else f===91?v=!0:f===92?p=!0:f===93&&(v=!1);P++}for(;P<this._input.length&&I._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const d=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:d,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=I,I._regexFlags=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),I._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(oe[173],ae([0,1,62,59,25,15,37,22,12]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,U.dirname)(_.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,U.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,U.join)(this.userDataPath,"logs",d)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(I.URI.file((0,U.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=T.env.VSCODE_PORTABLE;return d?I.URI.file((0,U.join)(d,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,U.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,U.resolve)(d):(0,U.normalize)((0,U.join)(_.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?I.URI.file((0,U.resolve)(d)):I.URI.file((0,U.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,U.resolve)(d);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const E=T.env.VSCODE_PORTABLE;return E?(0,U.join)(E,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(f=>/^[^:/?#]+?:\/\//.test(f)?I.URI.parse(f):I.URI.file((0,U.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?I.URI.parse(d):I.URI.file((0,U.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const f of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(f);E&&E[1]&&E[2]&&d.push([E[1],E[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=T.env.VSCODE_PORTABLE;return d?I.URI.file((0,U.join)(d,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,f,E){this._args=d,this.paths=f,this.productService=E,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,pe([O.memoize],m.prototype,"appRoot",null),pe([O.memoize],m.prototype,"userHome",null),pe([O.memoize],m.prototype,"userDataPath",null),pe([O.memoize],m.prototype,"appSettingsHome",null),pe([O.memoize],m.prototype,"tmpDir",null),pe([O.memoize],m.prototype,"cacheHome",null),pe([O.memoize],m.prototype,"stateResource",null),pe([O.memoize],m.prototype,"userRoamingDataHome",null),pe([O.memoize],m.prototype,"userDataSyncHome",null),pe([O.memoize],m.prototype,"sync",null),pe([O.memoize],m.prototype,"machineSettingsResource",null),pe([O.memoize],m.prototype,"workspaceStorageHome",null),pe([O.memoize],m.prototype,"localHistoryHome",null),pe([O.memoize],m.prototype,"keyboardLayoutResource",null),pe([O.memoize],m.prototype,"argvResource",null),pe([O.memoize],m.prototype,"isExtensionDevelopment",null),pe([O.memoize],m.prototype,"untitledWorkspacesHome",null),pe([O.memoize],m.prototype,"builtinExtensionsPath",null),pe([O.memoize],m.prototype,"extensionsPath",null),pe([O.memoize],m.prototype,"extensionDevelopmentLocationURI",null),pe([O.memoize],m.prototype,"extensionDevelopmentKind",null),pe([O.memoize],m.prototype,"extensionTestsLocationURI",null),pe([O.memoize],m.prototype,"debugExtensionHost",null),pe([O.memoize],m.prototype,"logLevel",null),pe([O.memoize],m.prototype,"extensionLogLevel",null),pe([O.memoize],m.prototype,"serviceMachineIdResource",null),pe([O.memoize],m.prototype,"disableTelemetry",null),pe([O.memoize],m.prototype,"disableWorkspaceTrust",null),pe([O.memoize],m.prototype,"policyFile",null);function P(v,d){return p(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function p(v,d,f,E,a,h){const b=Number(d||v)||(E?null:f),y=b?!!d:!1;let k;if(h)try{k=JSON.parse(h)}catch{}return{port:b,break:y,debugId:a,env:k}}e.parseDebugParams=p}),function(){"use strict";function ne(e,L,O){function _(T,R){const I=U(T,R),m=[I];return e.isAbsolute(I)||m.unshift(O),e.resolve(...m)}function U(T,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,R);const P=T["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(p,"AppData","Roaming")}break;case"darwin":m=e.join(L.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,R)}return{getUserDataPath:_}}if(typeof define=="function")define(oe[174],ae([262,36,37]),function(e,L,O){return ne(e,L,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=ne(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[175],ae([0,1,36,173,174]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class U extends O.AbstractNativeEnvironmentService{constructor(m,P){super(m,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,_.getUserDataPath)(m,P.nameShort)},P)}}e.NativeEnvironmentService=U;function T(I,m){return(0,O.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,m,I.extensionEnvironment)}e.parsePtyHostDebugPort=T;function R(I,m){return(0,O.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,m,I.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(oe[176],ae([0,1,10,147]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function _(T,R,I){try{U(T,R,I)}catch(m){console.error(m?.message??m)}return T}e.localizeManifest=_;function U(T,R,I){const m=(P,p,v)=>{const d=P[p];if((0,L.isString)(d)){const f=d,E=f.length;if(E>1&&f[0]==="%"&&f[E-1]==="%"){const a=f.substr(1,E-2);let h=R[a];h===void 0&&I&&(h=I[a]);const u=typeof h=="string"?h:h?.message,b=I?.[a],y=typeof b=="string"?b:b?.message;if(!u){y||console.warn(`[${T.name}]: ${(0,O.localize)(0,null,a)}`);return}if(v&&(p==="title"||p==="category")&&y&&y!==u){const k={value:u,original:y};P[p]=k}else P[p]=u}}else if((0,L.isObject)(d))for(const f in d)d.hasOwnProperty(f)&&(f==="commands"?m(d,f,!0):m(d,f,v));else if(Array.isArray(d))for(let f=0;f<d.length;f++)m(d,f,v)};for(const P in T)T.hasOwnProperty(P)&&m(T,P)}}),define(oe[177],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(U){this.channel=U}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(U){return this.channel.call("promptImportantExtensionsInstallNotification",[U])}promptWorkspaceRecommendations(U){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class O{constructor(U){this.service=U}listen(U,T){throw new Error(`Event not found: ${T}`)}call(U,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(oe[67],ae([0,1,22,89,151,52]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function I(h){return h=h.trim(),h==="*"||T.test(h)}e.isValidVersionStr=I;function m(h){if(!I(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=h.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=m;function P(h){if(!h)return null;const u=h.majorBase,b=h.majorMustEqual,y=h.minorBase;let k=h.minorMustEqual;const n=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(u===0||(k=!1),r=!1);let t=0;if(h.preRelease){const i=R.exec(h.preRelease);if(i){const[,s,o,l]=i;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:u,majorMustEqual:b,minorBase:y,minorMustEqual:k,patchBase:n,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:t}}e.normalizeVersion=P;function p(h,u,b){let y;typeof h=="string"?y=P(m(h)):y=h;let k;u instanceof Date?k=u.getTime():typeof u=="string"&&(k=new Date(u).getTime());let n;if(typeof b=="string"?n=P(m(b)):n=b,!y||!n)return!1;const r=y.majorBase,t=y.minorBase,i=y.patchBase;let s=n.majorBase,o=n.minorBase,l=n.patchBase;const w=n.notBefore;let S=n.majorMustEqual,c=n.minorMustEqual,C=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||k&&k<w?!1:i>=l:(r===1&&s===0&&(!S||!c||!C)&&(s=1,o=0,l=0,S=!0,c=!1,C=!1),r<s?!1:r>s?!S:t<o?!1:t>o?!c:i<l?!1:i>l?!C:!(k&&k<w))}e.isValidVersion=p;function v(h,u,b,y,k){const n=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return n.push([O.default.Error,_.localize(0,null)]),n;if(typeof y.name!="string")return n.push([O.default.Error,_.localize(1,null,"name")]),n;if(typeof y.version!="string")return n.push([O.default.Error,_.localize(2,null,"version")]),n;if(!y.engines)return n.push([O.default.Error,_.localize(3,null,"engines")]),n;if(typeof y.engines.vscode!="string")return n.push([O.default.Error,_.localize(4,null,"engines.vscode")]),n;if(typeof y.extensionDependencies<"u"&&!a(y.extensionDependencies))return n.push([O.default.Error,_.localize(5,null,"extensionDependencies")]),n;if(typeof y.activationEvents<"u"){if(!a(y.activationEvents))return n.push([O.default.Error,_.localize(6,null,"activationEvents")]),n;if(typeof y.main>"u"&&typeof y.browser>"u")return n.push([O.default.Error,_.localize(7,null,"activationEvents","main","browser")]),n}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&n.push([O.default.Warning,_.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return n.push([O.default.Error,_.localize(9,null,"main")]),n;{const i=(0,L.joinPath)(b,y.main);(0,L.isEqualOrParent)(i,b)||n.push([O.default.Warning,_.localize(10,null,i.path,b.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return n.push([O.default.Error,_.localize(11,null,"browser")]),n;{const i=(0,L.joinPath)(b,y.browser);(0,L.isEqualOrParent)(i,b)||n.push([O.default.Warning,_.localize(12,null,i.path,b.path)])}}if(!U.valid(y.version))return n.push([O.default.Error,_.localize(13,null)]),n;const r=[];if(!d(h,u,y,k,r))for(const i of r)n.push([O.default.Error,i]);return n}e.validateExtensionManifest=v;function d(h,u,b,y,k){return y||typeof b.main>"u"&&typeof b.browser>"u"?!0:E(h,u,b.engines.vscode,k)}e.isValidExtensionVersion=d;function f(h,u,b){return h==="*"||E(u,b,h)}e.isEngineValid=f;function E(h,u,b,y=[]){const k=P(m(b));if(!k)return y.push(_.localize(14,null,b)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return y.push(_.localize(15,null,b)),!1}else if(!k.majorMustEqual)return y.push(_.localize(16,null,b)),!1;return p(h,u,k)?!0:(y.push(_.localize(17,null,h,b)),!1)}function a(h){if(!Array.isArray(h))return!1;for(let u=0,b=h.length;u<b;u++)if(typeof h[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,16,32]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function _(U,T,R){let I=R&&R.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await T.readFile(U.serviceMachineIdResource)).value.toString();I=(0,O.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,O.generateUuid)();try{await T.writeFile(U.serviceMachineIdResource,L.VSBuffer.fromString(I))}catch{}}return R?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=_}),define(oe[68],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(_,U=[],T=!1){this.ctor=_,this.staticArguments=U,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=L}),define(oe[178],ae([0,1,68]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var _;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(_||(e.InstantiationType=_={}));function U(R,I,m){I instanceof L.SyncDescriptor||(I=new L.SyncDescriptor(I,[],!!m)),O.push([R,I])}e.registerSingleton=U;function T(){return O}e.getSingletonServiceDescriptors=T}),define(oe[179],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(U,T){this.key=U,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class O{constructor(U){this._hashFn=U,this._nodes=new Map}roots(){const U=[];for(const T of this._nodes.values())T.outgoing.size===0&&U.push(T);return U}insertEdge(U,T){const R=this.lookupOrInsertNode(U),I=this.lookupOrInsertNode(T);R.outgoing.set(I.key,I),I.incoming.set(R.key,R)}removeNode(U){const T=this._hashFn(U);this._nodes.delete(T);for(const R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(U){const T=this._hashFn(U);let R=this._nodes.get(T);return R||(R=new L(T,U),this._nodes.set(T,R)),R}lookup(U){return this._nodes.get(this._hashFn(U))}isEmpty(){return this._nodes.size===0}toString(){const U=[];for(const[T,R]of this._nodes)U.push(`${T}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return U.join(`
`)}findCycleSlow(){for(const[U,T]of this._nodes){const R=new Set([U]),I=this._findCycle(T,R);if(I)return I}}_findCycle(U,T){for(const[R,I]of U.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const m=this._findCycle(I,T);if(m)return m;T.delete(R)}}}e.Graph=O}),define(oe[4],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(I){return I[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(L||(e._util=L={})),e.IInstantiationService=_("instantiationService");function O(T,R,I){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:T,index:I}):(R[L.DI_DEPENDENCIES]=[{id:T,index:I}],R[L.DI_TARGET]=R)}function _(T){if(L.serviceIds.has(T))return L.serviceIds.get(T);const R=function(I,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(R,I,P)};return R.toString=()=>T,L.serviceIds.set(T,R),R}e.createDecorator=_;function U(T){return T}e.refineServiceDecorator=U}),define(oe[180],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(oe[18],ae([0,1,10,12,4]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function U(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof O.URI)}e.isConfigurationOverrides=U;function T(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function I(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function m(a,h){const u=Object.create(null);for(const b in a)P(u,b,a[b],h);return u}e.toValuesTree=m;function P(a,h,u,b){const y=h.split("."),k=y.pop();let n=a;for(let r=0;r<y.length;r++){const t=y[r];let i=n[t];switch(typeof i){case"undefined":i=n[t]=Object.create(null);break;case"object":break;default:b(`Ignoring ${h} as ${y.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[k]=u}catch{b(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(n)}`)}else b(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=P;function p(a,h){const u=h.split(".");v(a,u)}e.removeFromValueTree=p;function v(a,h){const u=h.shift();if(h.length===0){delete a[u];return}if(Object.keys(a).indexOf(u)!==-1){const b=a[u];typeof b=="object"&&!Array.isArray(b)&&(v(b,h),Object.keys(b).length===0&&delete a[u])}}function d(a,h,u){function b(n,r){let t=n;for(const i of r){if(typeof t!="object"||t===null)return;t=t[i]}return t}const y=h.split("."),k=b(a,y);return typeof k>"u"?u:k}e.getConfigurationValue=d;function f(a,h,u){Object.keys(h).forEach(b=>{b!=="__proto__"&&(b in a?L.isObject(a[b])&&L.isObject(h[b])?f(a[b],h[b],u):u&&(a[b]=h[b]):a[b]=h[b])})}e.merge=f;function E(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(oe[94],ae([0,1,5,27,172,4,143,7]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",L.isMacintosh),I.set("isLinux",L.isLinux),I.set("isWindows",L.isWindows),I.set("isWeb",L.isWeb),I.set("isMacNative",L.isMacintosh&&!L.isWeb),I.set("isEdge",L.isEdge),I.set("isFirefox",L.isFirefox),I.set("isChrome",L.isChrome),I.set("isSafari",L.isSafari);function m($,g){if(I.get($)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set($,g)}e.setConstant=m;const P=Object.prototype.hasOwnProperty;var p;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),f=(0,T.localize)(1,null),E=(0,T.localize)(2,null),a=(0,T.localize)(3,null),h=(0,T.localize)(4,null),u=(0,T.localize)(5,null),b=(0,T.localize)(6,null),y=(0,T.localize)(7,null);class k{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(g=v){this._config=g,this._scanner=new _.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(g){if(g===""){this._parsingErrors.push({message:d,offset:0,lexeme:"",additionalInfo:f});return}this._tokens=this._scanner.reset(g).scan(),this._current=0,this._parsingErrors=[];try{const A=this._expr();if(!this._isAtEnd()){const W=this._peek(),q=W.type===17?u:void 0;throw this._parsingErrors.push({message:h,offset:W.offset,lexeme:_.Scanner.getLexeme(W),additionalInfo:q}),k._parseError}return A}catch(A){if(A!==k._parseError)throw A;return}}_expr(){return this._or()}_or(){const g=[this._and()];for(;this._matchOne(16);){const A=this._and();g.push(A)}return g.length===1?g[0]:n.or(...g)}_and(){const g=[this._term()];for(;this._matchOne(15);){const A=this._term();g.push(A)}return g.length===1?g[0]:n.and(...g)}_term(){if(this._matchOne(2)){const g=this._peek();switch(g.type){case 11:return this._advance(),s.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const A=this._expr();return this._consume(1,a),A?.negate()}case 17:return this._advance(),D.create(g.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",g)}}return this._primary()}_primary(){const g=this._peek();switch(g.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const A=this._expr();return this._consume(1,a),A}case 17:{const A=g.lexeme;if(this._advance(),this._matchOne(9)){const q=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),q.type!==10)throw this._errExpectedButGot("REGEX",q);const j=q.lexeme,K=j.lastIndexOf("/"),ee=K===j.length-1?void 0:this._removeFlagsGY(j.substring(K+1));let ce;try{ce=new RegExp(j.substring(1,K),ee)}catch{throw this._errExpectedButGot("REGEX",q)}return Q.create(A,ce)}switch(q.type){case 10:case 19:{const j=[q.lexeme];this._advance();let K=this._peek(),ee=0;for(let Ee=0;Ee<q.lexeme.length;Ee++)q.lexeme.charCodeAt(Ee)===40?ee++:q.lexeme.charCodeAt(Ee)===41&&ee--;for(;!this._isAtEnd()&&K.type!==15&&K.type!==16;){switch(K.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let Ee=0;Ee<K.lexeme.length;Ee++)K.lexeme.charCodeAt(Ee)===40?ee++:q.lexeme.charCodeAt(Ee)===41&&ee--}if(ee<0)break;j.push(_.Scanner.getLexeme(K)),this._advance(),K=this._peek()}const ce=j.join(""),ue=ce.lastIndexOf("/"),fe=ue===ce.length-1?void 0:this._removeFlagsGY(ce.substring(ue+1));let ve;try{ve=new RegExp(ce.substring(1,ue),fe)}catch{throw this._errExpectedButGot("REGEX",q)}return n.regex(A,ve)}case 18:{const j=q.lexeme;this._advance();let K=null;if(!(0,O.isFalsyOrWhitespace)(j)){const ee=j.indexOf("/"),ce=j.lastIndexOf("/");if(ee!==ce&&ee>=0){const ue=j.slice(ee+1,ce),fe=j[ce+1]==="i"?"i":"";try{K=new RegExp(ue,fe)}catch{throw this._errExpectedButGot("REGEX",q)}}}if(K===null)throw this._errExpectedButGot("REGEX",q);return Q.create(A,K)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,E);const q=this._value();return n.notIn(A,q)}switch(this._peek().type){case 3:{this._advance();const q=this._value();if(this._previous().type===18)return n.equals(A,q);switch(q){case"true":return n.has(A);case"false":return n.not(A);default:return n.equals(A,q)}}case 4:{this._advance();const q=this._value();if(this._previous().type===18)return n.notEquals(A,q);switch(q){case"true":return n.not(A);case"false":return n.has(A);default:return n.notEquals(A,q)}}case 5:return this._advance(),z.create(A,this._value());case 6:return this._advance(),x.create(A,this._value());case 7:return this._advance(),F.create(A,this._value());case 8:return this._advance(),V.create(A,this._value());case 13:return this._advance(),n.in(A,this._value());default:return n.has(A)}}case 20:throw this._parsingErrors.push({message:b,offset:g.offset,lexeme:"",additionalInfo:y}),k._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const g=this._peek();switch(g.type){case 17:case 18:return this._advance(),g.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(g){return g.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(g){return this._check(g)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(g,A){if(this._check(g))return this._advance();throw this._errExpectedButGot(A,this._peek())}_errExpectedButGot(g,A,W){const q=(0,T.localize)(8,null,g,_.Scanner.getLexeme(A)),j=A.offset,K=_.Scanner.getLexeme(A);return this._parsingErrors.push({message:q,offset:j,lexeme:K,additionalInfo:W}),k._parseError}_check(g){return this._peek().type===g}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=k,k._parseError=new Error;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(g){return l.create(g)}static equals(g,A){return w.create(g,A)}static notEquals(g,A){return C.create(g,A)}static regex(g,A){return Q.create(g,A)}static in(g,A){return S.create(g,A)}static notIn(g,A){return c.create(g,A)}static not(g){return D.create(g)}static and(...g){return J.create(g,null,!0)}static or(...g){return B.create(g,null,!0)}static greater(g,A){return F.create(g,A)}static greaterEquals(g,A){return V.create(g,A)}static smaller(g,A){return z.create(g,A)}static smallerEquals(g,A){return x.create(g,A)}static deserialize(g){return g==null?void 0:this._parser.parse(g)}}e.ContextKeyExpr=n,n._parser=new k({regexParsingWithErrorRecovery:!1});function r($){const g=new k({regexParsingWithErrorRecovery:!1});return $.map(A=>(g.parse(A),g.lexingErrors.length>0?g.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,T.localize)(9,null,W.additionalInfo):(0,T.localize)(10,null),offset:W.offset,length:W.lexeme.length})):g.parsingErrors.length>0?g.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.validateWhenClauses=r;function t($,g){const A=$?$.substituteConstants():void 0,W=g?g.substituteConstants():void 0;return!A&&!W?!0:!A||!W?!1:A.equals(W)}e.expressionsAreEqualWithConstantSubstitution=t;function i($,g){return $.cmp(g)}class s{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=s,s.INSTANCE=new s;class o{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return s.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class l{static create(g,A=null){const W=I.get(g);return typeof W=="boolean"?W?o.INSTANCE:s.INSTANCE:new l(g,A)}constructor(g,A){this.key=g,this.negated=A,this.type=2}cmp(g){return g.type!==this.type?this.type-g.type:X(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=I.get(this.key);return typeof g=="boolean"?g?o.INSTANCE:s.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class w{static create(g,A,W=null){if(typeof A=="boolean")return A?l.create(g,W):D.create(g,W);const q=I.get(g);return typeof q=="boolean"?A===(q?"true":"false")?o.INSTANCE:s.INSTANCE:new w(g,A,W)}constructor(g,A,W){this.key=g,this.value=A,this.negated=W,this.type=4}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=I.get(this.key);if(typeof g=="boolean"){const A=g?"true":"false";return this.value===A?o.INSTANCE:s.INSTANCE}return this}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class S{static create(g,A){return new S(g,A)}constructor(g,A){this.key=g,this.valueKey=A,this.type=10,this.negated=null}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}substituteConstants(){return this}evaluate(g){const A=g.getValue(this.valueKey),W=g.getValue(this.key);return Array.isArray(A)?A.includes(W):typeof W=="string"&&typeof A=="object"&&A!==null?P.call(A,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=c.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class c{static create(g,A){return new c(g,A)}constructor(g,A){this.key=g,this.valueKey=A,this.type=11,this._negated=S.create(g,A)}cmp(g){return g.type!==this.type?this.type-g.type:this._negated.cmp(g._negated)}equals(g){return g.type===this.type?this._negated.equals(g._negated):!1}substituteConstants(){return this}evaluate(g){return!this._negated.evaluate(g)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(g){return g.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=c;class C{static create(g,A,W=null){if(typeof A=="boolean")return A?D.create(g,W):l.create(g,W);const q=I.get(g);return typeof q=="boolean"?A===(q?"true":"false")?s.INSTANCE:o.INSTANCE:new C(g,A,W)}constructor(g,A,W){this.key=g,this.value=A,this.negated=W,this.type=5}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=I.get(this.key);if(typeof g=="boolean"){const A=g?"true":"false";return this.value===A?s.INSTANCE:o.INSTANCE}return this}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class D{static create(g,A=null){const W=I.get(g);return typeof W=="boolean"?W?s.INSTANCE:o.INSTANCE:new D(g,A)}constructor(g,A){this.key=g,this.negated=A,this.type=3}cmp(g){return g.type!==this.type?this.type-g.type:X(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=I.get(this.key);return typeof g=="boolean"?g?s.INSTANCE:o.INSTANCE:this}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function N($,g){if(typeof $=="string"){const A=parseFloat($);isNaN(A)||($=A)}return typeof $=="string"||typeof $=="number"?g($):s.INSTANCE}class F{static create(g,A,W=null){return N(A,q=>new F(g,q,W))}constructor(g,A,W){this.key=g,this.value=A,this.negated=W,this.type=12}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class V{static create(g,A,W=null){return N(A,q=>new V(g,q,W))}constructor(g,A,W){this.key=g,this.value=A,this.negated=W,this.type=13}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=V;class z{static create(g,A,W=null){return N(A,q=>new z(g,q,W))}constructor(g,A,W){this.key=g,this.value=A,this.negated=W,this.type=14}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class x{static create(g,A,W=null){return N(A,q=>new x(g,q,W))}constructor(g,A,W){this.key=g,this.value=A,this.negated=W,this.type=15}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=x;class Q{static create(g,A){return new Q(g,A)}constructor(g,A){this.key=g,this.regexp=A,this.type=7,this.negated=null}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const A=this.regexp?this.regexp.source:"",W=g.regexp?g.regexp.source:"";return A<W?-1:A>W?1:0}equals(g){if(g.type===this.type){const A=this.regexp?this.regexp.source:"",W=g.regexp?g.regexp.source:"";return this.key===g.key&&A===W}return!1}substituteConstants(){return this}evaluate(g){const A=g.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=te.create(this)),this.negated}}e.ContextKeyRegexExpr=Q;class te{static create(g){return new te(g)}constructor(g){this._actual=g,this.type=8}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}substituteConstants(){return this}evaluate(g){return!this._actual.evaluate(g)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(g){return new te(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=te;function G($){let g=null;for(let A=0,W=$.length;A<W;A++){const q=$[A].substituteConstants();if($[A]!==q&&g===null){g=[];for(let j=0;j<A;j++)g[j]=$[j]}g!==null&&(g[A]=q)}return g===null?$:g}class J{static create(g,A,W){return J._normalizeArr(g,A,W)}constructor(g,A){this.expr=g,this.negated=A,this.type=6}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let A=0,W=this.expr.length;A<W;A++){const q=i(this.expr[A],g.expr[A]);if(q!==0)return q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let A=0,W=this.expr.length;A<W;A++)if(!this.expr[A].equals(g.expr[A]))return!1;return!0}return!1}substituteConstants(){const g=G(this.expr);return g===this.expr?this:J.create(g,this.negated,!1)}evaluate(g){for(let A=0,W=this.expr.length;A<W;A++)if(!this.expr[A].evaluate(g))return!1;return!0}static _normalizeArr(g,A,W){const q=[];let j=!1;for(const K of g)if(K){if(K.type===1){j=!0;continue}if(K.type===0)return s.INSTANCE;if(K.type===6){q.push(...K.expr);continue}q.push(K)}if(q.length===0&&j)return o.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(i);for(let K=1;K<q.length;K++)q[K-1].equals(q[K])&&(q.splice(K,1),K--);if(q.length===1)return q[0];for(;q.length>1;){const K=q[q.length-1];if(K.type!==9)break;q.pop();const ee=q.pop(),ce=q.length===0,ue=B.create(K.expr.map(fe=>J.create([fe,ee],null,W)),null,ce);ue&&(q.push(ue),q.sort(i))}if(q.length===1)return q[0];if(W){for(let K=0;K<q.length;K++)for(let ee=K+1;ee<q.length;ee++)if(q[K].negate().equals(q[ee]))return s.INSTANCE;if(q.length===1)return q[0]}return new J(q,A)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(const A of this.expr)g.push(...A.keys());return g}map(g){return new J(this.expr.map(A=>A.map(g)),null)}negate(){if(!this.negated){const g=[];for(const A of this.expr)g.push(A.negate());this.negated=B.create(g,this,!0)}return this.negated}}e.ContextKeyAndExpr=J;class B{static create(g,A,W){return B._normalizeArr(g,A,W)}constructor(g,A){this.expr=g,this.negated=A,this.type=9}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let A=0,W=this.expr.length;A<W;A++){const q=i(this.expr[A],g.expr[A]);if(q!==0)return q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let A=0,W=this.expr.length;A<W;A++)if(!this.expr[A].equals(g.expr[A]))return!1;return!0}return!1}substituteConstants(){const g=G(this.expr);return g===this.expr?this:B.create(g,this.negated,!1)}evaluate(g){for(let A=0,W=this.expr.length;A<W;A++)if(this.expr[A].evaluate(g))return!0;return!1}static _normalizeArr(g,A,W){let q=[],j=!1;if(g){for(let K=0,ee=g.length;K<ee;K++){const ce=g[K];if(ce){if(ce.type===0){j=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){q=q.concat(ce.expr);continue}q.push(ce)}}if(q.length===0&&j)return s.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let K=1;K<q.length;K++)q[K-1].equals(q[K])&&(q.splice(K,1),K--);if(q.length===1)return q[0];if(W){for(let K=0;K<q.length;K++)for(let ee=K+1;ee<q.length;ee++)if(q[K].negate().equals(q[ee]))return o.INSTANCE;if(q.length===1)return q[0]}return new B(q,A)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(const A of this.expr)g.push(...A.keys());return g}map(g){return new B(this.expr.map(A=>A.map(g)),null)}negate(){if(!this.negated){const g=[];for(const A of this.expr)g.push(A.negate());for(;g.length>1;){const A=g.shift(),W=g.shift(),q=[];for(const j of Z(A))for(const K of Z(W))q.push(J.create([j,K],null,!1));g.unshift(B.create(q,null,!1))}this.negated=B.create(g,this,!0)}return this.negated}}e.ContextKeyOrExpr=B;class M extends l{static all(){return M._info.values()}constructor(g,A,W){super(g,null),this._defaultValue=A,typeof W=="object"?M._info.push({...W,key:g}):W!==!0&&M._info.push({key:g,description:W,type:A!=null?typeof A:void 0})}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return w.create(this.key,g)}notEqualsTo(g){return C.create(this.key,g)}}e.RawContextKey=M,M._info=[],e.IContextKeyService=(0,U.createDecorator)("contextKeyService");function X($,g){return $<g?-1:$>g?1:0}function ie($,g,A,W){return $<A?-1:$>A?1:g<W?-1:g>W?1:0}function se($,g){if($.type===0||g.type===1)return!0;if($.type===9)return g.type===9?H($.expr,g.expr):!1;if(g.type===9){for(const A of g.expr)if(se($,A))return!0;return!1}if($.type===6){if(g.type===6)return H(g.expr,$.expr);for(const A of $.expr)if(se(A,g))return!0;return!1}return $.equals(g)}e.implies=se;function H($,g){let A=0,W=0;for(;A<$.length&&W<g.length;){const q=$[A].cmp(g[W]);if(q<0)return!1;q===0&&A++,W++}return A===$.length}function Z($){return $.type===9?$.expr:[$]}}),define(oe[95],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function O(U){return!!U.hostName&&!!U.errorMessage}e.isRemoteDiagnosticError=O;class _{async getPerformanceInfo(T,R){return{}}async getSystemInfo(T,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,R){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=_}),define(oe[96],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(oe[14],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[28],ae([0,1,146,4]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function _(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=_;function U(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=U;function T(u,b){switch(u){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":b==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function R(u,b){return b==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function I(u,b,y){return R(b,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:m(y).includes(u)}e.isTargetPlatformCompatible=I;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var p;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var a;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class h extends Error{constructor(b,y){super(b),this.code=y,this.name=y}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(oe[181],ae([0,1,3,2,31,12,91,28]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(a,h){return a?U.URI.revive(h?h.transformIncoming(a):a):void 0}function m(a,h){return h?h.transformOutgoingURI(a):a}function P(a,h){h=h||T.DefaultURITransformer;const u=a.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...a,manifest:void 0},h),manifest:u}}function p(a,h){return a?.profileLocation?(0,T.transformAndReviveIncomingURIs)(a,h??T.DefaultURITransformer):a}function v(a,h){return h?(0,_.cloneAndChange)(a,u=>u instanceof U.URI?h.transformOutgoingURI(u):void 0):a}class d{constructor(h,u){this.service=h,this.getUriTransformer=u,this.onInstallExtension=L.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,u){const b=this.getUriTransformer(h);switch(u){case"onInstallExtension":return L.Event.map(this.onInstallExtension,y=>({...y,profileLocation:y.profileLocation?m(y.profileLocation,b):y.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,y=>y.map(k=>({...k,local:k.local?v(k.local,b):k.local,profileLocation:k.profileLocation?m(k.profileLocation,b):k.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,y=>({...y,profileLocation:y.profileLocation?m(y.profileLocation,b):y.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,y=>({...y,profileLocation:y.profileLocation?m(y.profileLocation,b):y.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,y=>v(y,b))}throw new Error("Invalid listen")}async call(h,u,b){const y=this.getUriTransformer(h);switch(u){case"zip":{const k=P(b[0],y),n=await this.service.zip(k);return m(n,y)}case"unzip":return this.service.unzip(I(b[0],y));case"install":return this.service.install(I(b[0],y),p(b[1],y));case"installFromLocation":return this.service.installFromLocation(I(b[0],y),I(b[1],y));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(b[0],I(b[1],y),I(b[2],y));case"getManifest":return this.service.getManifest(I(b[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],p(b[1],y));case"uninstall":return this.service.uninstall(P(b[0],y),p(b[1],y));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(b[0],y));case"getInstalled":return(await this.service.getInstalled(b[0],I(b[1],y))).map(n=>v(n,y));case"copyExtensions":return this.service.copyExtensions(I(b[0],y),I(b[1],y));case"updateMetadata":{const k=await this.service.updateMetadata(P(b[0],y),b[1],I(b[2],y));return v(k,y)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(b[0],b[1],b[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class f extends O.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(h){super(),this.channel=h,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this._register(this.channel.listen("onInstallExtension")(u=>this.fireEvent(this._onInstallExtension,{...u,source:this.isUriComponents(u.source)?U.URI.revive(u.source):u.source,profileLocation:U.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(u=>this.fireEvent(this._onDidInstallExtensions,u.map(b=>({...b,local:b.local?P(b.local,null):b.local,source:this.isUriComponents(b.source)?U.URI.revive(b.source):b.source,profileLocation:U.URI.revive(b.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(u=>this.fireEvent(this._onUninstallExtension,{...u,profileLocation:U.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(u=>this.fireEvent(this._onDidUninstallExtension,{...u,profileLocation:U.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(u=>this._onDidUpdateExtensionMetadata.fire(P(u,null))))}fireEvent(h,u){h.fire(u)}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const u=await this.getTargetPlatform();return h.allTargetPlatforms.some(b=>(0,R.isTargetPlatformCompatible)(b,h.allTargetPlatforms,u))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(u=>U.URI.revive(u)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,u){return Promise.resolve(this.channel.call("install",[h,u])).then(b=>P(b,null))}installFromLocation(h,u){return Promise.resolve(this.channel.call("installFromLocation",[h,u])).then(b=>P(b,null))}async installExtensionsFromProfile(h,u,b){return(await this.channel.call("installExtensionsFromProfile",[h,u,b])).map(k=>P(k,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,u){return Promise.resolve(this.channel.call("installFromGallery",[h,u])).then(b=>P(b,null))}uninstall(h,u){return Promise.resolve(this.channel.call("uninstall",[h,u]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h])).then(u=>P(u,null))}getInstalled(h=null,u){return Promise.resolve(this.channel.call("getInstalled",[h,u])).then(b=>b.map(y=>P(y,null)))}updateMetadata(h,u,b){return Promise.resolve(this.channel.call("updateMetadata",[h,u,b])).then(y=>P(y,null))}copyExtensions(h,u){return this.channel.call("copyExtensions",[h,u])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(h,u,b){const y=await this.channel.call("download",[h,u,b]);return U.URI.revive(y)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class E{constructor(h){this.service=h}listen(h,u){throw new Error("Invalid listen")}call(h,u,b){switch(u){case"getConfigBasedTips":return this.service.getConfigBasedTips(U.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(oe[97],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((U,T)=>ne(["node-vsce-sign"],async R=>U(R),T))),this.moduleLoadingPromise}async verify(U,T,R){let I;try{I=await this.vsceSign()}catch{return!1}return I.verify(U,T,R)}}e.ExtensionSignatureVerificationService=O}),define(oe[98],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(O||(e.RecommendationSource=O={}));function _(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=_;var U;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(U||(e.RecommendationsNotificationResult=U={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,47,15,27,10,12,153,4,5,25]),function(ne,e,L,O,_,U,T,R,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function p(M){return M.create===!0}e.isFileOpenForWriteOptions=p;var v;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var d;(function(M){M[M.Readonly=1]="Readonly",M[M.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var f;(function(M){M[M.None=0]="None",M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileAtomicWrite=32768]="FileAtomicWrite",M[M.FileAtomicDelete=65536]="FileAtomicDelete",M[M.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function E(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=E;function a(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(M){return!!(M.capabilities&131072)}e.hasFileCloneCapability=h;function u(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function b(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=b;function y(M){return E(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;function k(M){return E(M)?!!(M.capabilities&32768):!1}e.hasFileAtomicWriteCapability=k;function n(M){return!!(M.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;var r;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsStorageQuota="EntryExceedsStorageQuota",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class t extends Error{static create(X,ie){const se=new t(X.toString(),ie);return o(se,ie),se}constructor(X,ie){super(X),this.code=ie}}e.FileSystemProviderError=t;function i(M,X){return t.create(M,X)}e.createFileSystemProviderError=i;function s(M){return M||i((0,R.localize)(0,null),r.Unknown)}e.ensureFileSystemProviderError=s;function o(M,X){return M.name=X?`${X} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=o;function l(M){if(!M)return r.Unknown;if(M instanceof t)return M.code;const X=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!X)return r.Unknown;switch(X[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.toFileSystemProviderErrorCode=l;function w(M){if(M instanceof F)return M.fileOperationResult;switch(l(M)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=w;var S;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(S||(e.FileOperation=S={}));class c{constructor(X,ie,se){this.resource=X,this.operation=ie,this.target=se}isOperation(X){return this.operation===X}}e.FileOperationEvent=c;var C;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class D{constructor(X,ie){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const H of X){const Z=se.get(H.type);switch(Z?Z.push([H.resource,H]):se.set(H.type,[[H.resource,H]]),H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}}for(const[H,Z]of se)switch(H){case 1:this.added=L.TernarySearchTree.forUris(()=>ie),this.added.fill(Z);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>ie),this.updated.fill(Z);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>ie),this.deleted.fill(Z);break}}contains(X,...ie){return this.doContains(X,{includeChildren:!1},...ie)}affects(X,...ie){return this.doContains(X,{includeChildren:!0},...ie)}doContains(X,ie,...se){if(!X)return!1;const H=se.length>0;return!!((!H||se.includes(1))&&(this.added?.get(X)||ie.includeChildren&&this.added?.findSuperstr(X))||(!H||se.includes(0))&&(this.updated?.get(X)||ie.includeChildren&&this.updated?.findSuperstr(X))||(!H||se.includes(2))&&(this.deleted?.findSubstr(X)||ie.includeChildren&&this.deleted?.findSuperstr(X)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=D;function N(M,X,ie){return!M||!X||M===X||X.length>M.length?!1:(X.charAt(X.length-1)!==O.sep&&(X+=O.sep),ie?(0,_.startsWithIgnoreCase)(M,X):M.indexOf(X)===0)}e.isParent=N;class F extends Error{constructor(X,ie,se){super(X),this.fileOperationResult=ie,this.options=se}}e.FileOperationError=F;class V extends F{constructor(X,ie,se,H){super(X,ie,H),this.fileOperationResult=ie,this.size=se}}e.TooLargeFileOperationError=V;class z extends F{constructor(X,ie,se){super(X,2,se),this.stat=ie}}e.NotModifiedSinceFileOperationError=z;var x;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Q;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.ETAG_DISABLED="";function te(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=te;async function G(M,X){if(!X.hasProvider(T.URI.from({scheme:M.scheme})))return new Promise(ie=>{const se=X.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(se.dispose(),ie())})})}e.whenProviderRegistered=G;class J{static formatSize(X){return(0,U.isNumber)(X)||(X=0),X<J.KB?(0,R.localize)(1,null,X.toFixed(0)):X<J.MB?(0,R.localize)(2,null,(X/J.KB).toFixed(2)):X<J.GB?(0,R.localize)(3,null,(X/J.MB).toFixed(2)):X<J.TB?(0,R.localize)(4,null,(X/J.GB).toFixed(2)):(0,R.localize)(5,null,(X/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;function B(M){const X=typeof M=="string"||M?.scheme===P.Schemas.vscodeRemote;return typeof M!="string"&&M?.scheme===P.Schemas.file?1024*J.MB:X?10*J.MB:m.isWeb?50*J.MB:1024*J.MB}e.getLargeFileConfirmationLimit=B});var Y=this&&this.__param||function(ne,e){return function(L,O){e(L,O,ne)}};define(oe[182],ae([0,1,69,42,13]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let U=e.ChecksumService=class{constructor(R){this.fileService=R}async checksum(R){const I=(await this.fileService.readFileStream(R)).value;return new Promise((m,P)=>{const p=(0,L.createHash)("md5");(0,O.listenStream)(I,{onData:v=>p.update(v.buffer),onError:v=>P(v),onEnd:()=>m(p.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=U=pe([Y(0,_.IFileService)],U)}),define(oe[183],ae([0,1,16,38,7,3,2,42,12,32,13]),function(ne,e,L,O,_,U,T,R,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class p extends T.Disposable{constructor(d,f){super(),this.channel=d,this.extraCapabilities=f,this.onDidChangeCapabilities=U.Event.None,this._onDidChange=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new U.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,f){const{buffer:E}=await this.channel.call("readFile",[d,f]);return E}readFileStream(d,f,E){const a=(0,R.newWriteableStream)(u=>L.VSBuffer.concat(u.map(b=>L.VSBuffer.wrap(b))).buffer),h=this.channel.listen("readFileStream",[d,f])(u=>{if(u instanceof L.VSBuffer)a.write(u.buffer);else{if(u==="end")a.end();else{let b;if(u instanceof Error)b=u;else{const y=u;b=(0,P.createFileSystemProviderError)(y.message??(0,O.toErrorMessage)(y),y.code??P.FileSystemProviderErrorCode.Unknown)}a.error(b),a.end()}h.dispose()}});return E.onCancellationRequested(()=>{a.error((0,_.canceled)()),a.end(),h.dispose()}),a}writeFile(d,f,E){return this.channel.call("writeFile",[d,L.VSBuffer.wrap(f),E])}open(d,f){return this.channel.call("open",[d,f])}close(d){return this.channel.call("close",[d])}async read(d,f,E,a,h){const[u,b]=await this.channel.call("read",[d,f,h]);return E.set(u.buffer.slice(0,b),a),b}write(d,f,E,a,h){return this.channel.call("write",[d,f,L.VSBuffer.wrap(E),a,h])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,f){return this.channel.call("delete",[d,f])}rename(d,f,E){return this.channel.call("rename",[d,f,E])}copy(d,f,E){return this.channel.call("copy",[d,f,E])}cloneFile(d,f){return this.channel.call("cloneFile",[d,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const f=d;this._onDidChange.fire(f.map(E=>({resource:I.URI.revive(E.resource),type:E.type})))}else{const f=d;this._onDidWatchError.fire(f)}}))}watch(d,f){const E=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,E,d,f]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=p}),define(oe[99],ae([0,1,16,7,154,13]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,p,v,d,f,E){let a;try{await R(P,p,v,d,f,E)}catch(h){a=h}finally{a&&f.errorTransformer&&(a=f.errorTransformer(a)),typeof a<"u"&&v.error(a),v.end()}}e.readFileIntoStream=T;async function R(P,p,v,d,f,E){I(E);const a=await P.open(p,{create:!1});try{I(E);let h=0,u=0,b=f&&typeof f.length=="number"?f.length:void 0,y=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof b=="number"?b:f.bufferSize)),k=f&&typeof f.position=="number"?f.position:0,n=0;do u=await P.read(a,k,y.buffer,n,y.byteLength-n),k+=u,n+=u,h+=u,typeof b=="number"&&(b-=u),n===y.byteLength&&(await v.write(d(y)),y=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof b=="number"?b:f.bufferSize)),n=0);while(u>0&&(typeof b!="number"||b>0)&&I(E)&&m(h,f));if(n>0){let r=n;typeof b=="number"&&(r=Math.min(n,b)),v.write(d(y.slice(0,r)))}}catch(h){throw(0,U.ensureFileSystemProviderError)(h)}finally{await P.close(a)}}function I(P){if(P.isCancellationRequested)throw(0,O.canceled)();return!0}function m(P,p){if(typeof p?.limits?.size=="number"&&P>p.limits.size)throw(0,U.createFileSystemProviderError)((0,_.localize)(0,null),U.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[53],ae([0,1,90,2,15,5,12,13]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(h){return h.recursive===!0}e.isRecursiveWatchRequest=I;class m extends O.Disposable{constructor(u,b,y,k){super(),this.onFileChanges=u,this.onLogMessage=b,this.verboseLogging=y,this.options=k,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new O.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(b=>this.onFileChanges(b))),u.add(this.watcher.onDidLogMessage(b=>this.onLogMessage(b))),u.add(this.watcher.onDidError(b=>this.onError(b)))}onError(u){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}trace(u){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class P extends m{constructor(u,b,y){super(u,b,y,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class p extends m{constructor(u,b,y){super(u,b,y,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=p;function v(h){return h.map(u=>({type:u.type,resource:T.URI.file(u.path)}))}e.toFileChanges=v;function d(h){const u=new a;for(const b of h)u.processEvent(b);return u.coalesce()}e.coalesceEvents=d;function f(h,u){return typeof u=="string"&&!u.startsWith(L.GLOBSTAR)&&!(0,_.isAbsolute)(u)?{base:h,pattern:u}:u}e.normalizeWatcherPattern=f;function E(h,u){const b=[];for(const y of u)b.push((0,L.parse)(f(h,y)));return b}e.parseWatcherPatterns=E;class a{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return U.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const b=this.mapPathToChange.get(this.toKey(u));let y=!1;if(b){const k=b.type,n=u.type;b.path!==u.path&&(u.type===2||u.type===1)?y=!0:k===1&&n===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(b)):k===2&&n===1?b.type=0:k===1&&n===0||(b.type=n)}else y=!0;y&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],b=[];return Array.from(this.coalesced).filter(y=>y.type!==2?(u.push(y),!1):!0).sort((y,k)=>y.path.length-k.path.length).filter(y=>b.some(k=>(0,R.isParent)(y.path,k,!U.isLinux))?!1:(b.push(y.path),!0)).concat(u)}}}),define(oe[184],ae([0,1,51,6,26,46,2,86,15,5,137,30,53]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends T.Disposable{constructor(a,h,u,b){super(),this.request=a,this.onDidFilesChange=h,this.onLogMessage=u,this.verboseLogging=b,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.onDidFilesChange(y))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(y=>this.handleFileChanges(y),d.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new _.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const a=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await p.Promises.stat(a);this._register(await this.doWatch(a,h.isDirectory()))}catch(a){a.code!=="ENOENT"?this.error(a):this.trace(a)}}async normalizePath(a){let h=a.path;try{h=await p.Promises.realpath(a.path),a.path===h&&(h=await(0,P.realcase)(a.path)??a.path),a.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${h})`)}catch{}return h}async doWatch(a,h){if(m.isMacintosh&&(0,U.isEqualOrParent)(a,"/Volumes/",!0))return this.error(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const u=new _.CancellationTokenSource(this.cts.token),b=new T.DisposableStore;try{const y=(0,I.basename)(a),k=(0,L.watch)(a);b.add((0,T.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.trace(`Started watching: '${a}'`);const n=new Set;if(h)try{for(const t of await p.Promises.readdir(a))n.add(t)}catch(t){this.error(t)}const r=new Map;b.add((0,T.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),k.on("error",(t,i)=>{this.error(`Failed to watch ${a} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),k.on("change",(t,i)=>{if(u.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let s="";if(i&&(s=i.toString(),m.isMacintosh&&(s=(0,R.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(h)if(t==="rename"){r.get(s)?.dispose();const o=setTimeout(async()=>{if(r.delete(s),s===y&&!await p.Promises.exists(a)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,I.join)(a,s));if(u.token.isCancellationRequested)return;let w;l?n.has(s)?w=0:(w=1,n.add(s)):(n.delete(s),w=2),this.onFileChange({path:(0,I.join)(this.request.path,s),type:w})},d.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,T.toDisposable)(()=>clearTimeout(o)))}else{let o;n.has(s)?o=0:(o=1,n.add(s)),this.onFileChange({path:(0,I.join)(this.request.path,s),type:o})}else if(t==="rename"||s!==y){const o=setTimeout(async()=>{const l=await p.Promises.exists(a);u.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),b.add(await this.doWatch(a,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);b.clear(),b.add((0,T.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(y){await p.Promises.exists(a)&&!u.token.isCancellationRequested&&this.error(`Failed to watch ${a} for changes using fs.watch() (${y.toString()})`)}return(0,T.toDisposable)(()=>{u.dispose(!0),b.dispose()})}onFileChange(a,h=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!h&&this.excludes.some(u=>u(a.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${a.path}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(u=>u(a.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${a.path}`):this.fileChangesAggregator.work(a))}handleFileChanges(a){const h=(0,v.coalesceEvents)(a);if(h.length>0){if(this.verboseLogging)for(const b of h)this.trace(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.throttledFileChangesEmitter.work(h)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(a){if(m.isLinux)return p.Promises.exists(a);try{const h=(0,I.basename)(a);return(await p.Promises.readdir((0,I.dirname)(a))).some(b=>b===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(a){this.verboseLogging=a}error(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}warn(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}trace(a){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=75;async function f(E,a,h,u,b=512){const y=await p.Promises.open(E,"r"),k=Buffer.allocUnsafe(b),n=new _.CancellationTokenSource(u);let r,t=!1;const i={path:E,excludes:[],recursive:!1},s=new d(i,o=>{(async()=>{for(const{type:l}of o)if(l===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:w}=await p.Promises.read(y,k,0,b,null);if(!w||n.token.isCancellationRequested)break;a(k.slice(0,w))}}catch(w){r=new Error(w),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,h(),new Promise((o,l)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await p.Promises.close(y)}catch(w){r=new Error(w)}r?l(r):o()})})}e.watchFileContents=f}),define(oe[185],ae([0,1,3,90,2,5,184]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends _.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=L.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const P=this.normalizeRequests(m),p=P.filter(d=>{const f=this.watchers.get(d.path);return f?!(0,O.patternsEquals)(f.request.excludes,d.excludes)||!(0,O.patternsEquals)(f.request.includes,d.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:d})=>!P.find(f=>f.path===d.path&&(0,O.patternsEquals)(f.excludes,d.excludes)&&(0,O.patternsEquals)(f.includes,d.includes))).map(({request:d})=>d.path);p.length&&this.trace(`Request to start watching: ${p.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const d of v)this.stopWatching(d);for(const d of p)this.startWatching(d)}startWatching(m){const P=new T.NodeJSFileWatcherLibrary(m,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),p={request:m,instance:P};this.watchers.set(m.path,p)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const P=this.watchers.get(m);P&&(this.watchers.delete(m),P.instance.dispose())}normalizeRequests(m){const P=new Map;for(const p of m){const v=U.isLinux?p.path:p.path.toLowerCase();P.set(v,p)}return Array.from(P.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,P]of this.watchers)P.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,P){return P?`[File Watcher (node.js)] ${m} (path: ${P.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=R}),define(oe[186],ae([0,1,53,185]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class _ extends L.AbstractNonRecursiveWatcherClient{constructor(T,R,I){super(T,R,I),this.init()}createWatcher(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=_}),define(oe[187],ae([0,1,25,43,93,53]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends U.AbstractUniversalWatcherClient{constructor(I,m,P){super(I,m,P),this.init()}createWatcher(I){const m=I.add(new _.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(m.onDidProcessExit(({code:P,signal:p})=>this.onError(`terminated by itself with code ${P}, signal: ${p}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(oe[70],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(..._){this._entries=new Map;for(const[U,T]of _)this.set(U,T)}set(_,U){const T=this._entries.get(_);return this._entries.set(_,U),T}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=L}),define(oe[188],ae([0,1,6,7,2,68,179,4,70,85]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class p extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class v{constructor(a=new I.ServiceCollection,h=!1,u,b=P){this._services=a,this._strict=h,this._parent=u,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=b?u?._globalGraph??new T.Graph(y=>y):void 0}createChild(a){return new v(a,this._strict,this,this._enableTracing)}invokeFunction(a,...h){const u=f.traceInvocation(this._enableTracing,a);let b=!1;try{return a({get:k=>{if(b)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(k,u);if(!n)throw new Error(`[invokeFunction] unknown service '${k}'`);return n}},...h)}finally{b=!0,u.stop()}}createInstance(a,...h){let u,b;return a instanceof U.SyncDescriptor?(u=f.traceCreation(this._enableTracing,a.ctor),b=this._createInstance(a.ctor,a.staticArguments.concat(h),u)):(u=f.traceCreation(this._enableTracing,a),b=this._createInstance(a,h,u)),u.stop(),b}_createInstance(a,h=[],u){const b=R._util.getServiceDependencies(a).sort((n,r)=>n.index-r.index),y=[];for(const n of b){const r=this._getOrCreateServiceInstance(n.id,u);r||this._throwIfStrict(`[createInstance] ${a.name} depends on UNKNOWN service ${n.id}.`,!1),y.push(r)}const k=b.length>0?b[0].index:h.length;if(h.length!==k){console.trace(`[createInstance] First service dependency of ${a.name} at position ${k+1} conflicts with ${h.length} static arguments`);const n=k-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,k)}return Reflect.construct(a,h.concat(y))}_setServiceInstance(a,h){if(this._services.get(a)instanceof U.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){const h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(a));const u=this._getServiceInstanceOrDescriptor(a);return u instanceof U.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,u,h.branch(a,!0)):(h.branch(a,!1),u)}_safeCreateAndCacheServiceInstance(a,h,u){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,u)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,u){const b=new T.Graph(n=>n.id.toString());let y=0;const k=[{id:a,desc:h,_trace:u}];for(;k.length;){const n=k.pop();if(b.lookupOrInsertNode(n),y++>1e3)throw new p(b);for(const r of R._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(r.id);if(t||this._throwIfStrict(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof U.SyncDescriptor){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};b.insertEdge(n,i),k.push(i)}}}for(;;){const n=b.roots();if(n.length===0){if(!b.isEmpty())throw new p(b);break}for(const{data:r}of n){if(this._getServiceInstanceOrDescriptor(r.id)instanceof U.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}b.removeNode(r)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,u=[],b,y){if(this._services.get(a)instanceof U.SyncDescriptor)return this._createServiceInstance(a,h,u,b,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,u,b,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h,u=[],b,y){if(b){const k=new v(void 0,this._strict,this,this._enableTracing);k._globalGraphImplicitDependency=String(a);const n=new Map,r=new L.IdleValue(()=>{const t=k._createInstance(h,u,y);for(const[i,s]of n){const o=t[i];if(typeof o=="function")for(const l of s)o.apply(t,l)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=n.get(i);return l||(l=new m.LinkedList,n.set(i,l)),(S,c,C)=>{const D=l.push([S,c,C]);return(0,_.toDisposable)(D)}}if(i in t)return t[i];const s=r.value;let o=s[i];return typeof o!="function"||(o=o.bind(s),t[i]=o),o},set(t,i,s){return r.value[i]=s,!0},getPrototypeOf(t){return h.prototype}})}else return this._createInstance(h,u,y)}_throwIfStrict(a,h){if(h&&console.warn(a),this._strict)throw new Error(a)}}e.InstantiationService=v;var d;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(d||(d={}));class f{static traceInvocation(a,h){return a?new f(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(a,h){return a?new f(1,h.name):f._None}constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}branch(a,h){const u=new f(3,a.toString());return this._dep.push([a,h,u]),u}stop(){const a=Date.now()-this._start;f._totals+=a;let h=!1;function u(y,k){const n=[],r=new Array(y+1).join("	");for(const[t,i,s]of k._dep)if(i&&s){h=!0,n.push(`${r}CREATES -> ${t}`);const o=u(y+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(a>2||h)&&f.all.add(b.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f._totals=0}),define(oe[71],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class O{constructor(U,T){this.server=U,this.router=T}getChannel(U){return this.server.getChannel(U,this.router)}registerChannel(U,T){this.server.registerChannel(U,T)}}e.MainProcessService=O}),define(oe[72],ae([0,1,26,2,5,156,28,4]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let m=e.LanguagePackBaseService=class extends O.Disposable{constructor(p){super(),this.extensionGalleryService=p}async getAvailableLanguages(){const p=new L.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let v;try{v=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const f=v.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(a=>a.startsWith("lp-"))).map(E=>{const a=E.properties.localizedLanguages?.[0],h=I(E);return{...this.createQuickPickItem(h,a,E),extensionId:E.identifier.id,galleryExtension:E}});return f.push(this.createQuickPickItem("en","English")),f}createQuickPickItem(p,v,d){const f=v??p;let E;if(f!==p&&(E=`(${p})`),p.toLowerCase()===_.language.toLowerCase()&&(E??="",E+=(0,U.localize)(0,null)),d?.installCount){E??="";const a=d.installCount;let h;a>1e6?h=`${Math.floor(a/1e5)/10}M`:a>1e3?h=`${Math.floor(a/1e3)}K`:h=String(a),E+=` $(cloud-download) ${h}`}return{id:p,label:f,description:E}}};e.LanguagePackBaseService=m=pe([Y(0,T.IExtensionGalleryService)],m)}),define(oe[189],ae([0,1,2,72]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let _=e.LocalizationsUpdater=class extends L.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=_=pe([Y(0,O.ILanguagePackService)],_)}),define(oe[8],ae([0,1,38,3,63,2,35,5,22,10,12,94,4]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function d(){return new Date().toISOString()}function f(S){return(0,m.isNumber)(S)}e.isLogLevel=f;var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function a(S,c,C){switch(c){case E.Trace:S.trace(C);break;case E.Debug:S.debug(C);break;case E.Info:S.info(C);break;case E.Warning:S.warn(C);break;case E.Error:S.error(C);break;case E.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=a;function h(S,c=!1){let C="";for(let D=0;D<S.length;D++){let N=S[D];if(N instanceof Error&&(N=(0,L.toErrorMessage)(N,c)),typeof N=="object")try{N=JSON.stringify(N)}catch{}C+=(D>0?" ":"")+N}return C}class u extends U.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(c){return this.level!==E.Off&&this.level<=c}}e.AbstractLogger=u;class b extends u{constructor(c){super(),this.logAlways=c}checkLogLevel(c){return this.logAlways||super.checkLogLevel(c)}trace(c,...C){this.checkLogLevel(E.Trace)&&this.log(E.Trace,h([c,...C],!0))}debug(c,...C){this.checkLogLevel(E.Debug)&&this.log(E.Debug,h([c,...C]))}info(c,...C){this.checkLogLevel(E.Info)&&this.log(E.Info,h([c,...C]))}warn(c,...C){this.checkLogLevel(E.Warning)&&this.log(E.Warning,h([c,...C]))}error(c,...C){if(this.checkLogLevel(E.Error))if(c instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=c.stack,this.log(E.Error,h(D))}else this.log(E.Error,h([c,...C]))}flush(){}}e.AbstractMessageLogger=b;class y extends u{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.useColors=!R.isWindows}trace(c,...C){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,c,...C):console.log(`[main ${d()}]`,c,...C))}debug(c,...C){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,c,...C):console.log(`[main ${d()}]`,c,...C))}info(c,...C){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,c,...C):console.log(`[main ${d()}]`,c,...C))}warn(c,...C){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,c,...C):console.warn(`[main ${d()}]`,c,...C))}error(c,...C){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,c,...C):console.error(`[main ${d()}]`,c,...C))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class k extends u{constructor(c=e.DEFAULT_LOG_LEVEL,C=!0){super(),this.useColors=C,this.setLevel(c)}trace(c,...C){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",c,...C):console.log(c,...C))}debug(c,...C){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",c,...C):console.log(c,...C))}info(c,...C){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",c,...C):console.log(c,...C))}warn(c,...C){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",c,...C):console.log(c,...C))}error(c,...C){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",c,...C):console.error(c,...C))}dispose(){}flush(){}}e.ConsoleLogger=k;class n extends u{constructor(c,C=e.DEFAULT_LOG_LEVEL){super(),this.adapter=c,this.setLevel(C)}trace(c,...C){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(c),...C])}debug(c,...C){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(c),...C])}info(c,...C){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(c),...C])}warn(c,...C){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(c),...C])}error(c,...C){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(c),...C])}extractMessage(c){return typeof c=="string"?c:(0,L.toErrorMessage)(c,this.checkLogLevel(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class r extends u{constructor(c){super(),this.loggers=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const C of this.loggers)C.setLevel(c);super.setLevel(c)}trace(c,...C){for(const D of this.loggers)D.trace(c,...C)}debug(c,...C){for(const D of this.loggers)D.debug(c,...C)}info(c,...C){for(const D of this.loggers)D.info(c,...C)}warn(c,...C){for(const D of this.loggers)D.warn(c,...C)}error(c,...C){for(const D of this.loggers)D.error(c,...C)}flush(){for(const c of this.loggers)c.flush()}dispose(){for(const c of this.loggers)c.dispose()}}e.MultiplexLogger=r;class t extends U.Disposable{constructor(c,C,D){if(super(),this.logLevel=c,this.logsHome=C,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,D)for(const N of D)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(c){return(0,m.isString)(c)?[...this._loggers.values()].find(C=>C.info.id===c):this._loggers.get(c)}getLogger(c){return this.getLoggerEntry(c)?.logger}createLogger(c,C){const D=this.toResource(c),N=(0,m.isString)(c)?c:C?.id??(0,_.hash)(D.toString()).toString(16);let F=this._loggers.get(D)?.logger;const V=C?.logLevel==="always"?E.Trace:C?.logLevel;F||(F=this.doCreateLogger(D,V??this.getLogLevel(D)??this.logLevel,{...C,id:N}));const z={logger:F,info:{resource:D,id:N,logLevel:V,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(z.info),this._loggers.set(D,z),F}toResource(c){return(0,m.isString)(c)?(0,I.joinPath)(this.logsHome,`${c}.log`):c}setLogLevel(c,C){if(P.URI.isUri(c)){const D=c,N=C,F=this._loggers.get(D);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.logLevel?void 0:N,F.logger?.setLevel(N),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([D,N]))}else{this.logLevel=c;for(const[D,N]of this._loggers.entries())this._loggers.get(D)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(c,C){const D=this.getLoggerEntry(c);D&&C!==!D.info.hidden&&(D.info.hidden=!C,this._loggers.set(D.info.resource,D),this._onDidChangeVisibility.fire([D.info.resource,C]))}getLogLevel(c){let C;return c&&(C=this._loggers.get(c)?.info.logLevel),C??this.logLevel}registerLogger(c){const C=this._loggers.get(c.resource);C?C.info.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this._loggers.set(c.resource,{info:c,logger:void 0}),this._onDidChangeLoggers.fire({added:[c],removed:[]}))}deregisterLogger(c){const C=this._loggers.get(c);C&&(C.logger&&C.logger.dispose(),this._loggers.delete(c),this._onDidChangeLoggers.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const c of this._loggers.values())yield c.info}getRegisteredLogger(c){return this._loggers.get(c)?.info}dispose(){this._loggers.forEach(c=>c.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(c){}getLevel(){return E.Info}trace(c,...C){}debug(c,...C){}info(c,...C){}warn(c,...C){}error(c,...C){}critical(c,...C){}dispose(){}flush(){}}e.NullLogger=i;class s extends i{}e.NullLogService=s;function o(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const c=w(S.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=l;function w(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=w,e.CONTEXT_LOG_LEVEL=new p.RawContextKey("logLevel",l(E.Info))}),define(oe[190],ae([0,1,6,7,2,22,30,14,8]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let m=e.LogsDataCleaner=class extends _.Disposable{constructor(p,v){super(),this.environmentService=p,this.logService=v,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const p=(0,U.basename)(this.environmentService.logsHome),v=(0,U.dirname)(this.environmentService.logsHome),E=(await T.Promises.readdir(v.fsPath)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==p),a=E.slice(0,Math.max(0,E.length-9));a.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${a.join(", ")}'`),await Promise.all(a.map(h=>T.Promises.rm((0,U.joinPath)(v,h).fsPath))))}catch(p){(0,O.onUnexpectedError)(p)}}};e.LogsDataCleaner=m=pe([Y(0,R.IEnvironmentService),Y(1,I.ILogService)],m)}),define(oe[191],ae([0,1,21,6,7,3,2,15,53,8]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(v,d){super(),this.logService=v,this.options=d,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new U.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(v,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,d):this.watchNonRecursive(v,d)}watchUniversal(v,d){const f={path:this.toFilePath(v),excludes:d.excludes,includes:d.includes,recursive:d.recursive},E=(0,L.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,_.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,I.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const d of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const d of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(d)&&v.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,d){const f={path:this.toFilePath(v),excludes:d.excludes,includes:d.includes,recursive:!1},E=(0,L.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,_.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,I.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,R.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(oe[192],ae([0,1,21,6,16,26,3,63,60,2,47,25,100,22,42,152,13,99,8,7]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=e.FileService=class extends m.Disposable{constructor(n){super(),this.logService=n,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(n,r){if(this.provider.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${n}`);const t=new m.DisposableStore;return this.provider.set(n,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new a.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),t.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:n}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:n,provider:r}),this.provider.delete(n),(0,m.dispose)(t)})}getProvider(n){return this.provider.get(n)}async activateProvider(n){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:n,join(t){r.push(t)}}),!this.provider.has(n)&&await O.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.provider.has(n.scheme)}hasCapability(n,r){const t=this.provider.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return I.Iterable.map(this.provider,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async withProvider(n){if(!(0,d.isAbsolutePath)(n))throw new a.FileOperationError((0,E.localize)(0,null,this.resourceForError(n)),8);await this.activateProvider(n.scheme);const r=this.provider.get(n.scheme);if(!r){const t=new b.ErrorNoTelemetry;throw t.message=(0,E.localize)(1,null,n.toString()),t}return r}async withReadProvider(n){const r=await this.withProvider(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)||(0,a.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(n){const r=await this.withProvider(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.doResolveFile(n,r)}catch(t){throw(0,a.toFileSystemProviderErrorCode)(t)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,E.localize)(2,null,this.resourceForError(n)),1):(0,a.ensureFileSystemProviderError)(t)}}async doResolveFile(n,r){const t=await this.withProvider(n),i=this.isPathCaseSensitive(t),s=r?.resolveTo,o=r?.resolveSingleChildDescendants,l=r?.resolveMetadata,w=await t.stat(n);let S;return this.toFileStat(t,n,w,void 0,!!l,(c,C)=>(S||(S=P.TernarySearchTree.forUris(()=>!i),S.set(n,!0),s&&S.fill(!0,s)),S.get(c.resource)||S.findSuperstr(c.resource.with({query:null,fragment:null}))?!0:c.isDirectory&&o?C===1:!1))}async toFileStat(n,r,t,i,s,o){const{providerExtUri:l}=this.getExtUri(n),w={resource:r,name:l.basename(r),isFile:(t.type&a.FileType.File)!==0,isDirectory:(t.type&a.FileType.Directory)!==0,isSymbolicLink:(t.type&a.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&a.FilePermission.Readonly)||!!(n.capabilities&2048),locked:!!((t.permissions??0)&a.FilePermission.Locked),etag:(0,a.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(w.isDirectory&&o(w,i)){try{const S=await n.readdir(r),c=await O.Promises.settled(S.map(async([C,D])=>{try{const N=l.joinPath(r,C),F=s?await n.stat(N):{type:D};return await this.toFileStat(n,N,F,S.length,s,o)}catch(N){return this.logService.trace(N),null}}));w.children=(0,L.coalesce)(c)}catch(S){this.logService.trace(S),w.children=[]}return w}return w}async resolveAll(n){return O.Promises.settled(n.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.withProvider(n),t=await r.stat(n);return this.toFileStat(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.withProvider(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.doValidateCreateFile(n,r)}catch(t){return t}return!0}async doValidateCreateFile(n,r){if(!r?.overwrite&&await this.exists(n))throw new a.FileOperationError((0,E.localize)(3,null,this.resourceForError(n)),3,r)}async createFile(n,r=_.VSBuffer.fromString(""),t){await this.doValidateCreateFile(n,t);const i=await this.writeFile(n,r);return this._onDidRunOperation.fire(new a.FileOperationEvent(n,0,i)),i}async writeFile(n,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,n,t)||await this.mkdirp(i,s.dirname(n));let l;if((0,a.hasReadWriteCapability)(i)&&!(r instanceof _.VSBuffer))if((0,f.isReadableStream)(r)){const w=await(0,f.peekStream)(r,3);w.ended?l=_.VSBuffer.concat(w.buffer):l=w}else l=(0,f.peekReadable)(r,w=>_.VSBuffer.concat(w),3);else l=r;if(!(0,a.hasOpenReadWriteCloseCapability)(i)||(0,a.hasReadWriteCapability)(i)&&l instanceof _.VSBuffer)await this.doWriteUnbuffered(i,n,t,l);else{const w=l instanceof _.VSBuffer?(0,_.bufferToReadable)(l):l;t?.atomic!==!1&&t?.atomic?.postfix?await this.doWriteBufferedAtomic(i,n,(0,d.joinPath)((0,d.dirname)(n),`${(0,d.basename)(n)}${t.atomic.postfix}`),t,w):await this.doWriteBuffered(i,n,t,w)}this._onDidRunOperation.fire(new a.FileOperationEvent(n,4))}catch(o){throw new a.FileOperationError((0,E.localize)(4,null,this.resourceForError(n),(0,a.ensureFileSystemProviderError)(o).toString()),(0,a.toFileOperationResult)(o),t)}return this.resolve(n,{resolveMetadata:!0})}async validateWriteFile(n,r,t){const i=!!t?.unlock;if(i&&!(n.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(r)));if(!!t?.atomic){if(!(n.capabilities&32768))throw new Error((0,E.localize)(6,null,this.resourceForError(r)));if(i)throw new Error((0,E.localize)(7,null,this.resourceForError(r)))}let o;try{o=await n.stat(r)}catch{return}if(o.type&a.FileType.Directory)throw new a.FileOperationError((0,E.localize)(8,null,this.resourceForError(r)),0,t);if(this.throwIfFileIsReadonly(r,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,a.etag)({mtime:t.mtime,size:o.size}))throw new a.FileOperationError((0,E.localize)(9,null),3,t);return o}async readFile(n,r,t){const i=await this.withReadProvider(n);return r?.atomic?this.doReadFileAtomic(i,n,r,t):this.doReadFile(i,n,r,t)}async doReadFileAtomic(n,r,t,i){return new Promise((s,o)=>{this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(n,r,t,i);s(l)}catch(l){o(l)}})})}async doReadFile(n,r,t,i){const s=await this.doReadFileStream(n,r,{...t,preferUnbuffered:!0},i);return{...s,value:await(0,_.streamToBuffer)(s.value)}}async readFileStream(n,r,t){const i=await this.withReadProvider(n);return this.doReadFileStream(i,n,r,t)}async doReadFileStream(n,r,t,i){const s=new U.CancellationTokenSource(i),o=this.validateReadFile(r,t).then(w=>w,w=>{throw s.cancel(),w});let l;try{return typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&await o,t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)||!((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasFileReadStreamCapability)(n))||(0,a.hasReadWriteCapability)(n)&&t?.preferUnbuffered?l=this.readFileUnbuffered(n,r,t):(0,a.hasFileReadStreamCapability)(n)?l=this.readFileStreamed(n,r,s.token,t):l=this.readFileBuffered(n,r,s.token,t),{...await o,value:l}}catch(w){throw l&&await(0,f.consumeStream)(l),this.restoreReadError(w,r,t)}}restoreReadError(n,r,t){const i=(0,E.localize)(10,null,this.resourceForError(r),(0,a.ensureFileSystemProviderError)(n).toString());return n instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(i,n.stat,t):n instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(i,n.fileOperationResult,n.size,n.options):new a.FileOperationError(i,(0,a.toFileOperationResult)(n),t)}readFileStreamed(n,r,t,i=Object.create(null)){const s=n.readFileStream(r,i,t);return(0,f.transform)(s,{data:o=>o instanceof _.VSBuffer?o:_.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,r,i)},o=>_.VSBuffer.concat(o))}readFileBuffered(n,r,t,i=Object.create(null)){const s=(0,_.newWriteableBufferStream)();return(0,h.readFileIntoStream)(n,r,s,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,r,i)},t),s}readFileUnbuffered(n,r,t){const i=(0,f.newWriteableStream)(s=>_.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)?s=await n.readFile(r,{atomic:!0}):s=await n.readFile(r),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(r,s.byteLength,t),i.end(_.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new a.FileOperationError((0,E.localize)(11,null,this.resourceForError(n)),0,r);if(typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&r.etag===t.etag)throw new a.NotModifiedSinceFileOperationError((0,E.localize)(12,null),t,r);return this.validateReadFileLimits(n,t.size,r),t}validateReadFileLimits(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new a.TooLargeFileOperationError((0,E.localize)(13,null,this.resourceForError(n)),7,r,t)}async canMove(n,r,t){return this.doCanMoveCopy(n,r,"move",t)}async canCopy(n,r,t){return this.doCanMoveCopy(n,r,"copy",t)}async doCanMoveCopy(n,r,t,i){if(n.toString()!==r.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n):await this.withReadProvider(n),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(s,n,o,r,t,i)}catch(s){return s}return!0}async move(n,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,n,s,r,"move",!!t),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,o==="move"?2:3,l)),l}async copy(n,r,t){const i=await this.withReadProvider(n),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,n,s,r,"copy",!!t),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,o==="copy"?3:2,l)),l}async doMoveCopy(n,r,t,i,s,o){if(r.toString()===i.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(n,r,t,i,s,o);if(l&&!w&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),s==="copy"){if(n===t&&(0,a.hasFileFolderCopyCapability)(n))await n.copy(r,i,{overwrite:o});else{const S=await this.resolve(r);S.isDirectory?await this.doCopyFolder(n,S,t,i):await this.doCopyFile(n,r,t,i)}return s}else return n===t?(await n.rename(r,i,{overwrite:o}),s):(await this.doMoveCopy(n,r,t,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(n,r,t,i){if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(n,r,t,i);if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.doPipeUnbuffered(n,r,t,i)}async doCopyFolder(n,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async s=>{const o=this.getExtUri(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(n,await this.resolve(s.resource),t,o):this.doCopyFile(n,s.resource,t,o)}))}async doValidateMoveCopy(n,r,t,i,s,o){let l=!1;if(n===t){const{providerExtUri:S,isPathCaseSensitive:c}=this.getExtUri(n);if(c||(l=S.isEqual(r,i)),l&&s==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!l&&S.isEqualOrParent(i,r))throw new Error((0,E.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const w=await this.exists(i);if(w&&!l){if(!o)throw new a.FileOperationError((0,E.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(n===t){const{providerExtUri:S}=this.getExtUri(n);if(S.isEqualOrParent(r,i))throw new Error((0,E.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:w,isSameResourceWithDifferentPathCase:l}}getExtUri(n){const r=this.isPathCaseSensitive(n);return{providerExtUri:r?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(n){return!!(n.capabilities&1024)}async createFolder(n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n);await this.mkdirp(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,0,t)),t}async mkdirp(n,r){const t=[],{providerExtUri:i}=this.getExtUri(n);for(;!i.isEqual(r,i.dirname(r));)try{if(!((await n.stat(r)).type&a.FileType.Directory))throw new Error((0,E.localize)(18,null,this.resourceForError(r)));break}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(r)),r=i.dirname(r)}for(let s=t.length-1;s>=0;s--){r=i.joinPath(r,t[s]);try{await n.mkdir(r)}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(n,r){try{await this.doValidateDelete(n,r)}catch(t){return t}return!0}async doValidateDelete(n,r){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n),i=!!r?.useTrash;if(i&&!(t.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(n)));const s=r?.atomic;if(s&&!(t.capabilities&65536))throw new Error((0,E.localize)(20,null,this.resourceForError(n)));if(i&&s)throw new Error((0,E.localize)(21,null,this.resourceForError(n)));let o;try{o=await t.stat(n)}catch{}if(o)this.throwIfFileIsReadonly(n,o);else throw new a.FileOperationError((0,E.localize)(22,null,this.resourceForError(n)),1);if(!!!r?.recursive){const w=await this.resolve(n);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,E.localize)(23,null,this.resourceForError(n)))}return t}async del(n,r){const t=await this.doValidateDelete(n,r),i=!!r?.useTrash,s=!!r?.recursive,o=r?.atomic??!1;await t.delete(n,{recursive:s,useTrash:i,atomic:o}),this._onDidRunOperation.fire(new a.FileOperationEvent(n,1))}async cloneFile(n,r){const t=await this.withProvider(n),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(t===i&&this.getExtUri(t).providerExtUri.isEqual(n,r))return;if(t===i&&(0,a.hasFileCloneCapability)(t))return t.cloneFile(n,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const s=this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri);return t===i&&(0,a.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(n,r,{overwrite:!0})):s.queue(()=>this.doCopyFile(t,n,i,r))}watch(n,r={recursive:!1,excludes:[]}){const t=new m.DisposableStore;let i=!1,s=()=>{i=!0};return t.add((0,m.toDisposable)(()=>s())),(async()=>{try{const o=await this.doWatch(n,r);i?(0,m.dispose)(o):s=()=>(0,m.dispose)(o)}catch(o){this.logService.error(o)}})(),t}async doWatch(n,r){const t=await this.withProvider(n),i=(0,R.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(n),r]);let s=this.activeWatchers.get(i);return s||(s={count:0,disposable:t.watch(n,r)},this.activeWatchers.set(i,s)),s.count+=1,(0,m.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,m.dispose)(s.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,n]of this.activeWatchers)(0,m.dispose)(n.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(n,r,t,i,s){await this.doWriteBuffered(n,t,i,s);try{await n.rename(t,r,{overwrite:!0})}catch(o){try{await n.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async doWriteBuffered(n,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(async()=>{const s=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,f.isReadableStream)(i)||(0,f.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(n,s,i):await this.doWriteReadableBufferedQueued(n,s,i)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await n.close(s)}})}async doWriteStreamBufferedQueued(n,r,t){let i=0,s;if((0,f.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=_.VSBuffer.concat(t.buffer);await this.doWriteBuffer(n,r,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((o,l)=>{(0,f.listenStream)(s,{onData:async w=>{s.pause();try{await this.doWriteBuffer(n,r,w,w.byteLength,i,0)}catch(S){return l(S)}i+=w.byteLength,setTimeout(()=>s.resume())},onError:w=>l(w),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(n,r,t){let i=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(n,r,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(n,r,t,i,s,o){let l=0;for(;l<i;){const w=await n.write(r,s+l,t.buffer,o+l,i-l);l+=w}}async doWriteUnbuffered(n,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(n,r,t,i))}async doWriteUnbufferedQueued(n,r,t,i){let s;i instanceof _.VSBuffer?s=i:(0,f.isReadableStream)(i)?s=await(0,_.streamToBuffer)(i):(0,f.isReadableBufferedStream)(i)?s=await(0,_.bufferedStreamToBuffer)(i):s=(0,_.readableToBuffer)(i),await n.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async doPipeBuffered(n,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(n,r,t,i))}async doPipeBufferedQueued(n,r,t,i){let s,o;try{s=await n.open(r,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const l=_.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,S=0,c=0;do c=await n.read(s,w,l.buffer,S,l.byteLength-S),await this.doWriteBuffer(t,o,l,c,w,S),w+=c,S+=c,S===l.byteLength&&(S=0);while(c>0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await O.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(n,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(n,r,t,i))}async doPipeUnbufferedQueued(n,r,t,i){return t.writeFile(i,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(n,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(n,r,t,i))}async doPipeUnbufferedToBufferedQueued(n,r,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const o=await n.readFile(r);await this.doWriteBuffer(t,s,_.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(n,r,t,i){const s=await(0,_.streamToBuffer)(this.readFileBuffered(n,r,U.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,s)}throwIfFileSystemIsReadonly(n,r){if(n.capabilities&2048)throw new a.FileOperationError((0,E.localize)(24,null,this.resourceForError(r)),6);return n}throwIfFileIsReadonly(n,r){if((r.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,E.localize)(25,null,this.resourceForError(n)),6)}resourceForError(n){return n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}};e.FileService=y=pe([Y(0,u.ILogService)],y)}),define(oe[193],ae([0,1,51,263,6,35,16,3,46,2,15,5,22,42,30,155,13,99,191,38,187,186]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(r)}`)}})();class n extends u.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new U.ResourceMap(s=>v.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,p.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:a.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,v.joinPath)(t,o.name))).type:l=this.toType(o),s.push([o.name,l])}catch(l){this.logService.trace(l)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let s;return i?.dangling?s=a.FileType.Unknown:t.isFile()?s=a.FileType.File:t.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,i&&(s|=a.FileType.SymbolicLink),s}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new _.Barrier;return this.resourceLocks.set(t,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,m.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),s=await this.createResourceLock(t));const o=this.toFilePath(t);return await f.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,s){const o=(0,d.newWriteableStream)(l=>T.VSBuffer.concat(l.map(w=>T.VSBuffer.wrap(w))).buffer);return(0,h.readFileIntoStream)(this,t,o,l=>l.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.doWriteFileAtomic(t,(0,v.joinPath)((0,v.dirname)(t),`${(0,v.basename)(t)}${s.atomic.postfix}`),i,s):this.doWriteFile(t,i,s)}async doWriteFileAtomic(t,i,s,o){await this.doWriteFile(i,s,o);try{await this.rename(i,t,{overwrite:!0})}catch(l){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async doWriteFile(t,i,s){let o;try{const l=this.toFilePath(t);if(!s.create||!s.overwrite){if(await f.Promises.exists(l)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,E.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,E.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(t,l)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,i){const s=this.toFilePath(t);let o;(0,a.isFileOpenForWriteOptions)(i)&&(o=await this.createResourceLock(t));let l;try{if((0,a.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await f.SymlinkSupport.stat(s);S.mode&128||await f.Promises.chmod(s,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}let w;if((0,a.isFileOpenForWriteOptions)(i)){if(p.isWindows)try{await f.Promises.truncate(s,0),w="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}w||(w="w")}else w="r";l=await f.Promises.open(s,w)}catch(w){throw o?.dispose(),(0,a.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,w):this.toFileSystemProviderError(w)}if(this.mapHandleToPos.set(l,0),(0,a.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(l,t),o){const w=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,o),w&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),w.dispose())}return l}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await f.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await f.Promises.close(t)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,l){const w=this.normalizePos(t,i);let S=null;try{S=(await f.Promises.read(t,s,o,l,w)).bytesRead}catch(c){throw this.toFileSystemProviderError(c)}finally{this.updatePos(t,w,S)}return S}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,s){const o=this.mapHandleToPos.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(t,o+s):this.mapHandleToPos.delete(t)))}async write(t,i,s,o,l){return(0,_.retry)(()=>this.doWrite(t,i,s,o,l),100,3)}async doWrite(t,i,s,o,l){const w=this.normalizePos(t,i);let S=null;try{S=(await f.Promises.write(t,s,o,l,w)).bytesWritten}catch(c){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),c)}finally{this.updatePos(t,w,S)}return S}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const s=this.toFilePath(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,P.join)((0,P.dirname)(s),`${(0,P.basename)(s)}${i.atomic.postfix}`)),await f.Promises.rm(s,f.RimRafMode.MOVE,o)}else try{await f.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:w,symbolicLink:S}=await f.SymlinkSupport.stat(s);l=w.isDirectory()&&!S}catch{}if(l)await f.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.toFileSystemProviderError(s)}}async rename(t,i,s){const o=this.toFilePath(t),l=this.toFilePath(i);if(o!==l)try{await this.validateMoveCopy(t,i,"move",s.overwrite),await f.Promises.move(o,l)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(t,i,s){const o=this.toFilePath(t),l=this.toFilePath(i);if(o!==l)try{await this.validateMoveCopy(t,i,"copy",s.overwrite),await f.Promises.copy(o,l,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),w.toString()))),this.toFileSystemProviderError(w)}}async validateMoveCopy(t,i,s,o){const l=this.toFilePath(t),w=this.toFilePath(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,I.isEqual)(l,w,!0)),S){if(s==="copy")throw(0,a.createFileSystemProviderError)((0,E.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const C=await this.statIgnoreError(t);if(!C)throw(0,a.createFileSystemProviderError)((0,E.localize)(5,null),a.FileSystemProviderErrorCode.FileNotFound);const D=await this.statIgnoreError(i);if(D){if(!o)throw(0,a.createFileSystemProviderError)((0,E.localize)(6,null),a.FileSystemProviderErrorCode.FileExists);C.type&a.FileType.File&&D.type&a.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,s){const o=this.toFilePath(t),l=this.toFilePath(i),w=!!(this.capabilities&1024);if((0,I.isEqual)(o,l,!w))return;const S=new m.DisposableStore;try{const[c,C]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);S.add(c),S.add(C),s&&await f.Promises.mkdir((0,P.dirname)(l),{recursive:!0}),await f.Promises.copyFile(o,l)}catch(c){if(c.code==="ENOENT"&&!s)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(c)}finally{S.dispose()}}createUniversalWatcher(t,i,s){return new y.UniversalWatcherClient(o=>t(o),o=>i(o),s)}createNonRecursiveWatcher(t,i,s){return new k.NodeJSWatcherClient(o=>t(o),o=>i(o),s)}toFileSystemProviderError(t){if(t instanceof a.FileSystemProviderError)return t;let i=t,s;switch(t.code){case"ENOENT":s=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=a.FileSystemProviderErrorCode.Unknown;break;default:s=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(t,i){let s=this.toFileSystemProviderError(i);if(t&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await f.SymlinkSupport.stat(this.toFilePath(t));o.mode&128||(s=(0,a.createFileSystemProviderError)(i,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(oe[101],ae([0,1,3,2,4,8]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,_.createDecorator)("sharedProcessLifecycleService");let T=e.SharedProcessLifecycleService=class extends O.Disposable{constructor(I){super(),this.logService=I,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=T=pe([Y(0,U.ILogService)],T)}),define(oe[194],ae([0,1,12,3,8,2]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class T extends _.AbstractLoggerService{constructor(p,v,d,f,E){super(v,d,f),this.windowId=p,this.channel=E,this._register(E.listen("onDidChangeLogLevel",p)(a=>{(0,_.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(L.URI.revive(a[0]),a[1])})),this._register(E.listen("onDidChangeVisibility",p)(([a,h])=>super.setVisibility(L.URI.revive(a),h))),this._register(E.listen("onDidChangeLoggers",p)(({added:a,removed:h})=>{for(const u of a)super.registerLogger({...u,resource:L.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new _.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}registerLogger(p){super.registerLogger(p),this.channel.call("registerLogger",[p,this.windowId])}deregisterLogger(p){super.deregisterLogger(p),this.channel.call("deregisterLogger",[p,this.windowId])}setLogLevel(p,v){super.setLogLevel(p,v),this.channel.call("setLogLevel",[p,v])}setVisibility(p,v){super.setVisibility(p,v),this.channel.call("setVisibility",[this.toResource(p),v])}doCreateLogger(p,v,d){return new R(this.channel,p,v,d,this.windowId)}static setLogLevel(p,v,d){return p.call("setLogLevel",[v,d])}}e.LoggerChannelClient=T;class R extends _.AbstractMessageLogger{constructor(p,v,d,f,E){super(f?.logLevel==="always"),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,f,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const d=[[p,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(p){this.channel.call("log",[this.file,p])}}class I{constructor(p,v){this.loggerService=p,this.getUriTransformer=v}listen(p,v){const d=this.getUriTransformer(p);switch(v){case"onDidChangeLoggers":return O.Event.map(this.loggerService.onDidChangeLoggers,f=>({added:[...f.added].map(E=>this.transformLogger(E,d)),removed:[...f.removed].map(E=>this.transformLogger(E,d))}));case"onDidChangeVisibility":return O.Event.map(this.loggerService.onDidChangeVisibility,f=>[d.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return O.Event.map(this.loggerService.onDidChangeLogLevel,f=>(0,_.isLogLevel)(f)?f:[d.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${v}`)}async call(p,v,d){const f=this.getUriTransformer(p);switch(v){case"setLogLevel":return(0,_.isLogLevel)(d[0])?this.loggerService.setLogLevel(d[0]):this.loggerService.setLogLevel(L.URI.revive(f.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(E=>this.transformLogger(E,f)))}throw new Error(`Call not found: ${v}`)}transformLogger(p,v){return{...p,resource:v.transformOutgoingURI(p.resource)}}}e.LoggerChannel=I;class m extends U.Disposable{constructor(p,v){super(),v.call("setLogLevel",[p.getLogLevel()]),this._register(p.onDidChangeLogLevel(d=>v.call("setLogLevel",[d]))),v.call("getRegisteredLoggers").then(d=>{for(const f of d)p.registerLogger({...f,resource:L.URI.revive(f.resource)})}),this._register(v.listen("onDidChangeVisibility")(([d,f])=>p.setVisibility(L.URI.revive(d),f))),this._register(v.listen("onDidChangeLoggers")(({added:d,removed:f})=>{for(const E of d)p.registerLogger({...E,resource:L.URI.revive(E.resource)});for(const E of f)p.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=m}),define(oe[195],ae([0,1,2,8]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class _ extends L.Disposable{constructor(T,R=[]){super(),this.logger=new O.MultiplexLogger([T,...R]),this._register(T.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...R){this.logger.trace(T,...R)}debug(T,...R){this.logger.debug(T,...R)}info(T,...R){this.logger.info(T,...R)}warn(T,...R){this.logger.warn(T,...R)}error(T,...R){this.logger.error(T,...R)}flush(){this.logger.flush()}}e.LogService=_}),define(oe[54],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(oe[55],ae([0,1,3,60,2,4]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,U.createDecorator)("policy");class T extends _.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(m){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(m),O.Iterable.reduce(this.policies.entries(),(p,[v,d])=>({...p,[v]:d}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[P,p])=>({...m,[P]:{definition:p,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=T;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[196],ae([0,1,3,2,55]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class U{constructor(I){this.service=I,this.disposables=new O.DisposableStore}listen(I,m){switch(m){case"onDidChange":return L.Event.map(this.service.onDidChange,P=>P.reduce((p,v)=>({...p,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(I,m,P){switch(m){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=U;class T extends _.AbstractPolicyService{constructor(I,m){super(),this.channel=m;for(const P in I){const{definition:p,value:v}=I[P];this.policyDefinitions[P]=p,v!==void 0&&this.policies.set(P,v)}this.channel.listen("onDidChange")(P=>{for(const p in P){const v=P[p];v===null?this.policies.delete(p):this.policies.set(p,v)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(I){const m=await this.channel.call("updatePolicyDefinitions",I);for(const P in m)this.policies.set(P,m[P])}}e.PolicyChannelClient=T}),define(oe[102],ae([0,1,5,37]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const U=L.globals.vscode.context.configuration();if(U)_=U.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){_=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:U,searchUrl:T,itemUrl:R,controlUrl:I}=_.extensionsGallery||{};Object.assign(_,{extensionsGallery:{serviceUrl:O.env.VSCODE_GALLERY_SERVICE_URL||U,searchUrl:O.env.VSCODE_GALLERY_SEARCH_URL||T,itemUrl:O.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:O.env.VSCODE_GALLERY_CONTROL_URL||I}});try{const m=(...p)=>p.reduce((v,d)=>(Object.keys(d).forEach(f=>{Array.isArray(v[f])&&Array.isArray(d[f])?v[f]=d[f]:typeof v[f]=="object"&&typeof d[f]=="object"?v[f]=m(v[f],d[f]):v[f]=d[f]}),v),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};_=m(_,P)}catch{}if(O.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),!_.version){const m=globalThis._VSCODE_PACKAGE_JSON;Object.assign(_,{version:m.version,release:m.release})}}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(oe[24],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[197],ae([0,1,6,7,2,15,30,8,24]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let m=e.CodeCacheCleaner=class extends _.Disposable{constructor(p,v,d){super(),this.productService=v,this.logService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,p&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(p)},3e4)).schedule()}async cleanUpCodeCaches(p){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),d=(0,U.dirname)(p),f=(0,U.basename)(p),E=await T.Promises.readdir(d);await Promise.all(E.map(async a=>{if(a===f)return;const h=(0,U.join)(d,a),u=await T.Promises.stat(h);if(u.isDirectory()&&v-u.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${a}.`),T.Promises.rm(h)}))}catch(v){(0,O.onUnexpectedError)(v)}}};e.CodeCacheCleaner=m=pe([Y(1,I.IProductService),Y(2,R.ILogService)],m)}),define(oe[198],ae([0,1,6,7,2,15,30,14,8,24]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=e.LanguagePackCachedDataCleaner=class extends _.Disposable{constructor(v,d,f){super(),this.environmentService=v,this.logService=d,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),d=JSON.parse(await T.Promises.readFile((0,U.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(d)){const b=d[u];v[`${b.hash}.${u}`]=!0}const f=(0,U.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(f))return;const a=await T.Promises.readdir(f);for(const u of a){if(v[u]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await T.Promises.rm((0,U.join)(f,u))}const h=Date.now();for(const u of Object.keys(v)){const b=(0,U.join)(f,u),y=await T.Promises.readdir(b);for(const k of y){if(k==="tcf.json")continue;const n=(0,U.join)(b,k),r=await T.Promises.stat(n);r.isDirectory()&&h-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,U.join)(u,k)}`),await T.Promises.rm(n))}}}catch(v){(0,O.onUnexpectedError)(v)}}};e.LanguagePackCachedDataCleaner=P=pe([Y(0,R.INativeEnvironmentService),Y(1,I.ILogService),Y(2,m.IProductService)],P)}),define(oe[199],ae([0,1,15,4]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var _;(function(U){function T(I){return!!(I.samples&&I.timeDeltas)}U.isValidProfile=T;function R(I,m="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,L.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,L.join)(m,(0,L.basename)(P.callFrame.url)));return I}U.rewriteAbsolutePaths=R})(_||(e.Utils=_={}))}),define(oe[200],ae([0,1,32]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this._sessions=new Map}async startProfiling(U){const R=await(await new Promise((m,P)=>{ne(["v8-inspect-profiler"],m,P)})).startProfiling({port:U.port,checkForPaused:!0}),I=(0,L.generateUuid)();return this._sessions.set(I,R),I}async stopProfiling(U){const T=this._sessions.get(U);if(!T)throw new Error(`UNKNOWN session '${U}'`);const R=await T.stop();return this._sessions.delete(U),R.profile}}e.InspectProfilingService=O}),define(oe[40],ae([0,1,122,10]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(T,R){L.ok(O.isString(T)),L.ok(O.isObject(R)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new _}),define(oe[103],ae([0,1,3,40]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class U{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,m){this.schemasById[_(I)]=m,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new U;O.Registry.add(e.Extensions.JSONContribution,T)}),define(oe[48],ae([0,1,21,3,10,142,18,103,40]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=I.Registry.as(R.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:U.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.doRegisterConfigurations(n,r,t),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.doDeregisterConfigurations(n,r),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.doDeregisterConfigurations(r,t),this.doRegisterConfigurations(n,!1,t),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.doRegisterDefaultConfigurations(n,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const l=this.configurationDefaultsOverrides.get(o),w=l?.valuesSources??new Map;if(s)for(const D of Object.keys(i[o]))w.set(D,s);const S={...l?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:s,value:S,valuesSources:w});const c=(0,T.getLanguageTagSettingPlainKey)(o),C={type:"object",default:S,description:U.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:_.isString(s)?void 0:s,defaultValueSource:s};t.push(...E(o)),this.configurationProperties[o]=C,this.defaultLanguageConfigurationOverridesNode.properties[o]=C}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:s});const l=this.configurationProperties[o];l&&(this.updatePropertyDefaultValue(o,l),this.updateSchema(o,l))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(n){const r=new Set;this.doDeregisterDefaultConfigurations(n,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.configurationDefaultsOverrides.get(s),l=_.isString(i)?i:i?.id,w=_.isString(o?.source)?o?.source:o?.source?.id;if(l===w)if(r.add(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const S=this.configurationProperties[s];S&&(this.updatePropertyDefaultValue(s,S),this.updateSchema(s,S))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,t),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r,t){n.forEach(i=>{this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.configurationProperties[s];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}}validateAndRegisterProperties(n,r=!0,t,i,s=3,o){s=_.isUndefinedOrNull(n.scope)?s:n.scope;const l=n.properties;if(l)for(const S in l){const c=l[S];if(r&&b(S,c)){delete l[S];continue}if(c.source=t,c.defaultDefaultValue=l[S].default,this.updatePropertyDefaultValue(S,c),e.OVERRIDE_PROPERTY_REGEX.test(S)?c.scope=void 0:(c.scope=_.isUndefinedOrNull(c.scope)?s:c.scope,c.restricted=_.isUndefinedOrNull(c.restricted)?!!i?.includes(S):c.restricted),l[S].hasOwnProperty("included")&&!l[S].included){this.excludedConfigurationProperties[S]=l[S],delete l[S];continue}else this.configurationProperties[S]=l[S],l[S].policy?.name&&this.policyConfigurations.set(l[S].policy.name,S);!l[S].deprecationMessage&&l[S].markdownDeprecationMessage&&(l[S].deprecationMessage=l[S].markdownDeprecationMessage),o.add(S)}const w=n.allOf;if(w)for(const S of w)this.validateAndRegisterProperties(S,r,t,i,s,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);t.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,t={type:"object",description:U.localize(2,null),errorMessage:U.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}registerOverridePropertyPatternKey(){const n={type:"object",description:U.localize(4,null),errorMessage:U.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const t=this.configurationDefaultsOverrides.get(n);let i=t?.value,s=t?.source;_.isUndefined(i)&&(i=r.defaultDefaultValue,s=void 0),_.isUndefined(i)&&(i=h(r.type)),r.default=i,r.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",f=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(k){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let r=f.exec(k);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=f.exec(k)}}return(0,L.distinct)(n)}e.overrideIdentifiersFromKey=E;function a(k){return k.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=a;function h(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new v;I.Registry.add(e.Extensions.Configuration,u);function b(k,n){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?U.localize(7,null,k):u.getConfigurationProperties()[k]!==void 0?U.localize(8,null,k):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?U.localize(9,null,k,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:U.localize(6,null)}e.validateProperty=b;function y(){const k=[],n=u.getConfigurationProperties();for(const r of Object.keys(n))k.push([r,n[r].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=y}),define(oe[73],ae([0,1,21,3,34,2,35,31,10,12,18,48,40]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(r){return Object.isFrozen(r)?r:R.deepFreeze(r)}class f{constructor(t={},i=[],s=[],o){this._contents=t,this._keys=i,this._overrides=s,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof f)return i;const s=new E("");return s.parseRaw(i),s.configurationModel});this._rawConfiguration=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const s=this.rawConfiguration.getValue(t),o=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):s;return{value:s,override:o,merged:l}}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,P.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return L.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.distinct(t)}override(t){let i=this.overrideConfigurations.get(t);return i||(i=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,i)),i}merge(...t){const i=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const w of t)if(l.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.mergeContents(i,w.contents);for(const S of w.overrides){const[c]=s.filter(C=>L.equals(C.identifiers,S.identifiers));c?(this.mergeContents(c.contents,S.contents),c.keys.push(...S.keys),c.keys=L.distinct(c.keys)):s.push(R.deepClone(S))}for(const S of w.keys)o.indexOf(S)===-1&&o.push(S)}return new f(i,o,s,l.every(w=>w instanceof f)?void 0:l)}createOverrideConfigurationModel(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o];const w=i[o];w&&(typeof l=="object"&&typeof w=="object"?(l=R.deepClone(l),this.mergeContents(l,w)):l=w),s[o]=l}return new f(s,this.keys,this.overrides)}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&I.isObject(t[s])&&I.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=R.deepClone(i[s])}}getContentsForOverrideIdentifer(t){let i=null,s=null;const o=l=>{l&&(s?this.mergeContents(s,l):s=R.deepClone(l))};for(const l of this.overrides)L.equals(l.identifiers,[t])?i=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.updateValue(t,i,!0)}setValue(t,i){this.updateValue(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,t),p.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>L.equals(s.identifiers,(0,p.overrideIdentifiersFromKey)(t))),1))}updateValue(t,i,s){(0,P.addToValueTree)(this.contents,t,i,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),p.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,P.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=f;class E{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!I.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:o,overrides:l,restricted:w,hasExcludedProperties:S}=this.doParseRaw(t,i);this._configurationModel=new f(s,o,l,S?[t]:void 0),this._restrictedConfigurations=w||[]}doParseContent(t){let i={},s=null,o=[];const l=[],w=[];function S(C){Array.isArray(o)?o.push(C):s!==null&&(o[s]=C)}const c={onObjectBegin:()=>{const C={};S(C),l.push(o),o=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const C=[];S(C),l.push(o),o=C,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:S,onError:(C,D,N)=>{w.push({error:C,offset:D,length:N})}};if(t)try{_.visit(t,c),i=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return i}doParseRaw(t,i){const s=v.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,s,!0,i);t=o.raw;const l=(0,P.toValuesTree)(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`)),w=Object.keys(t),S=this.toOverrides(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`));return{contents:l,keys:w,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,i,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:l};const w={},S=[];for(const c in t)if(p.OVERRIDE_PROPERTY_REGEX.test(c)&&s){const C=this.filter(t[c],i,!1,o);w[c]=C.raw,l=l||C.hasExcludedProperties,S.push(...C.restricted)}else{const C=i[c],D=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&S.push(c),(D===void 0||o.scopes===void 0||o.scopes.includes(D))&&!(o.skipRestricted&&C?.restricted)?w[c]=t[c]:l=!0}return{raw:w,restricted:S,hasExcludedProperties:l}}toOverrides(t,i){const s=[];for(const o of Object.keys(t))if(p.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const w in t[o])l[w]=t[o][w];s.push({identifiers:(0,p.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,P.toValuesTree)(l,i)})}return s}}e.ConfigurationModelParser=E;class a extends U.Disposable{constructor(t,i,s,o){super(),this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class h{constructor(t,i,s,o,l,w,S,c,C,D,N,F,V){this.key=t,this.overrides=i,this._value=s,this.overrideIdentifiers=o,this.defaultConfiguration=l,this.policyConfiguration=w,this.applicationConfiguration=S,this.userConfiguration=c,this.localUserConfiguration=C,this.remoteUserConfiguration=D,this.workspaceConfiguration=N,this.folderConfigurationModel=F,this.memoryConfigurationModel=V}get value(){return d(this._value)}inspect(t,i,s){const o=t.inspect(i,s);return{get value(){return d(o.value)},get override(){return d(o.override)},get merged(){return d(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(t,i,s,o,l=new f,w=new f,S=new T.ResourceMap,c=new f,C=new T.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=i,this._applicationConfiguration=s,this._localUserConfiguration=o,this._remoteUserConfiguration=l,this._workspaceConfiguration=w,this._folderConfigurations=S,this._memoryConfiguration=c,this._memoryConfigurationByResource=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidatedConfigurationModel(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new f,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const o=this.getConsolidatedConfigurationModel(t,i,s),l=this.getFolderConfigurationModelForResource(i.resource,s),w=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,S=new Set;for(const c of o.overrides)for(const C of c.identifiers)o.getOverrideValue(t,C)!==void 0&&S.add(C);return new h(t,i,o.getValue(t),S.size?[...S]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this._workspaceConfiguration:void 0,l||void 0,w)}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:l,removed:w}=k(this._defaultConfiguration,t);i=[...o,...l,...w]}for(const o of i)for(const l of(0,p.overrideIdentifiersFromKey)(o)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=t.getKeysForOverrideIdentifier(l),c=[...S.filter(C=>w.indexOf(C)===-1),...w.filter(C=>S.indexOf(C)===-1),...w.filter(C=>!R.equals(this._defaultConfiguration.override(l).getValue(C),t.override(l).getValue(C)))];s.push([l,c])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=k(this._policyConfiguration,t),l=[...i,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=k(this.applicationConfiguration,t),w=[...i,...s,...o];return w.length&&this.updateApplicationConfiguration(t),{keys:w,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=k(this.localUserConfiguration,t),w=[...i,...s,...o];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=k(this.remoteUserConfiguration,t),w=[...i,...s,...o];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:l}=k(this.workspaceConfiguration,t),w=[...i,...s,...o];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:w,overrides:S}=k(s,i),c=[...o,...l,...w];return(c.length||!s)&&this.updateFolderConfiguration(t,i),{keys:c,overrides:S}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:w}=k(i,void 0);return{keys:[...s,...o,...l],overrides:w}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,i,s){let o=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const l=this._memoryConfigurationByResource.get(t);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=s.merge(o),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this._workspaceConfiguration.keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.policy),o=this.parseConfigurationModel(t.application),l=this.parseConfigurationModel(t.user),w=this.parseConfigurationModel(t.workspace),S=t.folders.reduce((c,C)=>(c.set(m.URI.revive(C[0]),this.parseConfigurationModel(C[1])),c),new T.ResourceMap);return new u(i,s,o,l,new f,w,S,new f,new T.ResourceMap)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides)}}e.Configuration=u;function b(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,w])=>{const S=(0,T.getOrSet)(i,l,new Set);w.forEach(c=>S.add(c))});const s=[];return i.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=b;class y{constructor(t,i,s,o){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const w of l)this.affectedKeys.add(w);this._affectsConfigStr=this._marker;for(const l of this.affectedKeys)this._affectsConfigStr+=l+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){const s=this._marker+t,o=this._affectsConfigStr.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this._affectsConfigStr.length)return!1;const w=this._affectsConfigStr.charCodeAt(l);if(w!==this._markerCode1&&w!==this._markerCode2)return!1;if(i){const S=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!R.equals(S,c)}return!0}}e.ConfigurationChangeEvent=y;function k(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),l=[],w=r?.getAllOverrideIdentifiers()||[],S=t?.getAllOverrideIdentifiers()||[];if(t){const c=S.filter(C=>!w.includes(C));for(const C of c)l.push([C,t.getKeysForOverrideIdentifier(C)])}if(r){const c=w.filter(C=>!S.includes(C));for(const C of c)l.push([C,r.getKeysForOverrideIdentifier(C)])}if(t&&r){for(const c of w)if(S.includes(c)){const C=n({contents:r.getOverrideValue(void 0,c)||{},keys:r.getKeysForOverrideIdentifier(c)},{contents:t.getOverrideValue(void 0,c)||{},keys:t.getKeysForOverrideIdentifier(c)});l.push([c,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:s,updated:o,overrides:l}}function n(r,t){const i=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const w=(0,P.getConfigurationValue)(t.contents,l),S=(0,P.getConfigurationValue)(r.contents,l);R.equals(w,S)||o.push(l)}}return{added:i,removed:s,updated:o}}}),define(oe[201],ae([0,1,21,3,2,31,10,73,48,8,55,40]),function(ne,e,L,O,_,U,T,R,I,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends _.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(p.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:h})=>this.onDidUpdateConfiguration(Array.from(a),h))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(a,h){this.updateConfigurationModel(a,p.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:a})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new R.ConfigurationModel;const a=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(a),a)}updateConfigurationModel(a,h){const u=this.getConfigurationDefaultOverrides();for(const b of a){const y=u[b],k=h[b];y!==void 0?this._configurationModel.addValue(b,y):k?this._configurationModel.addValue(b,k.default):this._configurationModel.removeValue(b)}}}e.DefaultConfiguration=v;class d{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let f=e.PolicyConfiguration=class extends _.Disposable{get configurationModel(){return this._configurationModel}constructor(a,h,u){super(),this.defaultConfiguration=a,this.policyService=h,this.logService=u,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(a=>this.onDidChangePolicies(a))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:a})=>this.update(await this.updatePolicyDefinitions(a),!0))),this._configurationModel}async updatePolicyDefinitions(a){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",a);const h={},u=[],b=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const y of a){const k=b[y];if(!k){u.push(y);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.logService.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}u.push(y),h[k.policy.name]={type:k.type}}}return(0,T.isEmptyObject)(h)||await this.policyService.updatePolicyDefinitions(h),u}onDidChangePolicies(a){this.logService.trace("PolicyConfiguration#onDidChangePolicies",a);const h=p.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),u=(0,L.coalesce)(a.map(b=>h.get(b)));this.update(u,!0)}update(a,h){this.logService.trace("PolicyConfiguration#update",a);const u=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),b=[],y=this._configurationModel.isEmpty();for(const k of a){const n=u[k]?.policy?.name;if(n){const r=this.policyService.getPolicyValue(n);(y?r!==void 0:!(0,U.equals)(this._configurationModel.getValue(k),r))&&b.push([k,r])}else this._configurationModel.getValue(k)!==void 0&&b.push([k,void 0])}if(b.length){this.logService.trace("PolicyConfiguration#changed",b);const k=this._configurationModel;this._configurationModel=new R.ConfigurationModel;for(const n of k.keys)this._configurationModel.setValue(n,k.getValue(n));for(const[n,r]of b)r===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,r);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=f=pe([Y(1,P.IPolicyService),Y(2,m.ILogService)],f)}),define(oe[202],ae([0,1,6,3,2,22,18,73,201,55]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends _.Disposable{constructor(v,d,f,E){super(),this.settingsResource=v,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=f instanceof m.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,f,E)),this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,U.extUriBiasedIgnorePathCase,d)),this.configuration=new R.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:a,properties:h})=>this.onDidDefaultConfigurationChange(a,h))),this._register(this.policyConfiguration.onDidChangeConfiguration(a=>this.onDidPolicyConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,d,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new R.Configuration(v,d,new R.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(v,d){const f=typeof v=="string"?v:void 0,E=(0,T.isConfigurationOverrides)(v)?v:(0,T.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(f,E,void 0)}updateValue(v,d,f,E){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const d=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(f,d,2)}onDidDefaultConfigurationChange(v,d){const f=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(v,d);this.trigger(E,f,7)}onDidPolicyConfigurationChange(v){const d=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(f,d,7)}trigger(v,d,f){const E=new R.ConfigurationChangeEvent(v,{data:d},this.configuration);E.source=f,E.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(oe[203],ae([0,1,16]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const O=(_,U,T)=>{const R=new Uint8Array(16);for(let P=0;P<16;P++)R[P]=Math.round(Math.random()*256);const I=(0,L.encodeBase64)(L.VSBuffer.wrap(R));return[`GET ws://localhost${_}?${U}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=O,e.socketRawEndHeaderSequence=L.VSBuffer.fromString(`\r
\r
`)}),define(oe[204],ae([0,1,7,4]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var _;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(_||(e.RemoteConnectionType=_={}));class U{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=U;class T{constructor(p,v){this.host=p,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class I extends L.ErrorNoTelemetry{static isNotAvailable(p){return p instanceof I&&p._code===R.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof I&&p._code===R.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof I&&p._code===R.NoResolverFound}static isHandled(p){return p instanceof I&&p.isHandled}constructor(p,v=R.Unknown,d){super(p),this._message=p,this._code=v,this._detail=d,this.isHandled=v===R.NotAvailable&&d===!0,Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I;function m(P){const p=P.indexOf("+");return p===-1?P:P.substring(0,p)}e.getRemoteAuthorityPrefix=m}),define(oe[74],ae([0,1,25]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(m){return m.scheme===L.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=O;function _(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=_;function U(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=U;function T(m){const{host:P,port:p}=I(m);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:p}}e.parseAuthorityWithPort=T;function R(m,P){let{host:p,port:v}=I(m);return typeof v>"u"&&(v=P),{host:p,port:v}}e.parseAuthorityWithOptionalPort=R;function I(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const p=m.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const v=m.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:m,port:void 0}}}),define(oe[49],ae([0,1,27,4,74]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function U(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=U,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(T||(e.ExtensionType=T={}));var R;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.LINUX_PPC64LE="linux-ppc64le",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class I{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,h){if(typeof a>"u"||a===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof a=="string"||typeof h=="string"){const u=typeof a=="string"?a:a.value,b=typeof h=="string"?h:h.value;return L.equalsIgnoreCase(u,b)}return a._lower===h._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=I;class m{get size(){return this._set.size}constructor(a){if(this._set=new Set,a)for(const h of a)this.add(h)}add(a){this._set.add(I.toKey(a))}delete(a){return this._set.delete(I.toKey(a))}has(a){return this._set.has(I.toKey(a))}}e.ExtensionIdentifierSet=m;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(a){this._map.delete(I.toKey(a))}get(a){return this._map.get(I.toKey(a))}has(a){return this._map.has(I.toKey(a))}set(a,h){this._map.set(I.toKey(a),h)}values(){return this._map.values()}forEach(a){this._map.forEach(a)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function p(E){return v(E)}e.isApplicationScopedExtension=p;function v(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function d(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function f(E,a){if(a){const h=`onResolveRemoteAuthority:${(0,_.getRemoteName)(a)}`;return!!E.activationEvents?.includes(h)}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[205],ae([0,1,2,49,13]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends L.Disposable{constructor(R,I,m,P,p){super(),this.userDataProfilesService=R,this.fileService=I,this.uriIdentityService=m,this.logService=p,this._register(P.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(P.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(R){for(const I of R)I.local&&this.invalidate(I.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const I of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(I.extensionsResource,R)&&await this.deleteUserCacheFile(I);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(I){(0,_.toFileOperationResult)(I)!==1&&this.logService.error(I)}}}e.ExtensionsManifestCache=U}),define(oe[206],ae([0,1,6,16,26,7,3,2,100,88,32,92,204,74]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var E;(function(g){g[g.Management=1]="Management",g[g.ExtensionHost=2]="ExtensionHost",g[g.Tunnel=3]="Tunnel"})(E||(e.ConnectionType=E={}));function a(g){switch(g){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(g){const A=new _.CancellationTokenSource;return setTimeout(()=>A.cancel(),g),A.token}function u(g,A){if(g.isCancellationRequested||A.isCancellationRequested)return _.CancellationToken.Cancelled;const W=new _.CancellationTokenSource;return g.onCancellationRequested(()=>W.cancel()),A.onCancellationRequested(()=>W.cancel()),W.token}class b{get didTimeout(){return this._state==="timedout"}constructor(A){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((W,q)=>{this._resolvePromise=W,this._rejectPromise=q}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function y(g,A){const W=new b(A);return W.registerDisposable(g.onControlMessage(q=>{const j=JSON.parse(q.toString()),K=X(j);K?W.reject(K):W.resolve(j)})),W.promise}function k(g,A,W,q,j,K,ee,ce){const ue=new b(ce),fe=m.StopWatch.create(!1);return g.info(`Creating a socket (${ee})...`),I.mark(`code/willCreateSocket/${K}`),A.connect(W,q,j,ee).then(ve=>{ue.didTimeout?(I.mark(`code/didCreateSocketError/${K}`),g.info(`Creating a socket (${ee}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),ve?.dispose()):(I.mark(`code/didCreateSocketOK/${K}`),g.info(`Creating a socket (${ee}) was successful after ${fe.elapsed()} ms.`),ue.resolve(ve))},ve=>{I.mark(`code/didCreateSocketError/${K}`),g.info(`Creating a socket (${ee}) returned an error after ${fe.elapsed()} ms.`),g.error(ve),ue.reject(ve)}),ue.promise}function n(g,A){const W=new b(A);return g.then(q=>{W.didTimeout||W.resolve(q)},q=>{W.didTimeout||W.reject(q)}),W.promise}async function r(g,A,W,q){const j=Z(g,A);g.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let K;try{K=await k(g.logService,g.remoteSocketFactoryService,g.connectTo,(0,d.getRemoteServerRootPath)(g),`reconnectionToken=${g.reconnectionToken}&reconnection=${g.reconnectionProtocol?"true":"false"}`,a(A),`renderer-${a(A)}-${g.reconnectionToken}`,q)}catch(ve){throw g.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),g.logService.error(ve),ve}g.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let ee,ce;g.reconnectionProtocol?(g.reconnectionProtocol.beginAcceptReconnection(K,null),ee=g.reconnectionProtocol,ce=!1):(ee=new p.PersistentProtocol({socket:K,measureRoundTripTime:!0}),ce=!0),g.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const ue=await n(g.signService.createNewMessage((0,P.generateUuid)()),q),fe={type:"auth",auth:g.connectionToken||"00000000000000000000",data:ue.data};ee.sendControl(O.VSBuffer.fromString(JSON.stringify(fe)));try{const ve=await y(ee,u(q,h(1e4)));if(ve.type!=="sign"||typeof ve.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(g.logService.trace(`${j} 4/6. received SignRequest control message.`),!await n(g.signService.validate(ue,ve.signedData),q)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const Ce=await n(g.signService.sign(ve.data),q),Re={type:"connectionType",commit:g.commit,signedData:Ce,desiredConnectionType:A};return W&&(Re.args=W),g.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(O.VSBuffer.fromString(JSON.stringify(Re))),{protocol:ee,ownsProtocol:ce}}catch(ve){throw ve&&ve.code==="ETIMEDOUT"&&(g.logService.error(`${j} the handshake timed out. Error:`),g.logService.error(ve)),ve&&ve.code==="VSCODE_CONNECTION_ERROR"&&(g.logService.error(`${j} received error control message when negotiating connection. Error:`),g.logService.error(ve)),ce&&M(ee),ve}}async function t(g,A,W,q){const j=Date.now(),K=Z(g,A),{protocol:ee,ownsProtocol:ce}=await r(g,A,W,q),ue=new b(q);return ue.registerDisposable(ee.onControlMessage(fe=>{const ve=JSON.parse(fe.toString()),Ee=X(ve);Ee?(g.logService.error(`${K} received error control message when negotiating connection. Error:`),g.logService.error(Ee),ce&&M(ee),ue.reject(Ee)):(g.reconnectionProtocol?.endAcceptReconnection(),g.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${$(j)}!`),ue.resolve({protocol:ee,firstMessage:ve}))})),ue.promise}async function i(g,A){const{protocol:W}=await t(g,1,void 0,A);return{protocol:W}}async function s(g,A,W){const{protocol:q,firstMessage:j}=await t(g,2,A,W),K=j&&j.debugPort;return{protocol:q,debugPort:K}}async function o(g,A,W){const q=Date.now(),j=Z(g,3),{protocol:K}=await r(g,3,A,W);return g.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${$(q)}!`),K}async function l(g,A,W){const{connectTo:q,connectionToken:j}=await g.addressProvider.getAddress();return{commit:g.commit,quality:g.quality,connectTo:q,connectionToken:j,reconnectionToken:A,reconnectionProtocol:W,remoteSocketFactoryService:g.remoteSocketFactoryService,signService:g.signService,logService:g.logService}}async function w(g,A,W){return c(g,async q=>{const{protocol:j}=await i(q,_.CancellationToken.None);return new J(g,A,W,q.reconnectionToken,j)})}e.connectRemoteAgentManagement=w;async function S(g,A){return c(g,async W=>{const{protocol:q,debugPort:j}=await s(W,A,_.CancellationToken.None);return new B(g,A,W.reconnectionToken,q,j)})}e.connectRemoteAgentExtensionHost=S;async function c(g,A){for(let q=1;;q++)try{const j=(0,P.generateUuid)(),K=await l(g,j,null);return await A(K)}catch(j){if(q<5)g.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),g.logService.error(j);else throw g.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),g.logService.error(j),G.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(j)),j}}async function C(g,A,W){const q=await l(g,(0,P.generateUuid)(),null);return await o(q,{host:A,port:W},_.CancellationToken.None)}e.connectRemoteAgentTunnel=C;function D(g){return(0,L.createCancelablePromise)(A=>new Promise((W,q)=>{const j=setTimeout(W,g*1e3);A.onCancellationRequested(()=>{clearTimeout(j),W()})}))}var N;(function(g){g[g.ConnectionLost=0]="ConnectionLost",g[g.ReconnectionWait=1]="ReconnectionWait",g[g.ReconnectionRunning=2]="ReconnectionRunning",g[g.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",g[g.ConnectionGain=4]="ConnectionGain",g[g.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(A,W){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=F;class V{constructor(A,W,q,j){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.durationSeconds=q,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=V;class z{constructor(A,W,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=z;class x{constructor(A,W,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=q,this.type=4}}e.ConnectionGainEvent=x;class Q{constructor(A,W){this.reconnectionToken=A,this.connectionHealth=W,this.type=5}}e.ConnectionHealthChangedEvent=Q;class te{constructor(A,W,q,j){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=q,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=te;class G extends R.Disposable{static triggerPermanentFailure(A,W,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=W,this._permanentFailureHandled=q,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(A=>A._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(A=>A._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||G._permanentFailure}constructor(A,W,q,j,K){super(),this._connectionType=A,this._options=W,this.reconnectionToken=q,this.protocol=j,this._reconnectionFailureIsFatal=K,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(j.onSocketClose(ee=>{const ce=H(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${ce} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${ce} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${ce} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(ee=>{const ce=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(j.onHighRoundTripTime(ee=>{const ce=se(this._connectionType,this.reconnectionToken);this._options.logService.info(`${ce} high roundtrip time: ${ee.roundTripTime}ms (${ee.recentHighRoundTripCount} of 5 recent samples)`)})),this._register(j.onDidChangeConnectionHealth(ee=>{this._onDidStateChange.fire(new Q(this.reconnectionToken,ee))})),G._instances.push(this),this._register((0,R.toDisposable)(()=>{const ee=G._instances.indexOf(this);ee>=0&&G._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const A=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const j=q<W.length?W[q]:W[W.length-1];try{if(j>0){const ee=D(j);this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,ee)),this._options.logService.info(`${A} waiting for ${j} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${A} resolving connection...`);const K=await l(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${K.connectTo}...`),await this._reconnect(K,h(f)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((0,U.isCancellationError)(K)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if(K instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,v.RemoteAuthorityResolverError.isHandled(K));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(A,W,q){this._reconnectionFailureIsFatal?G.triggerPermanentFailure(A,W,q):this._gotoPermanentFailure(A,W,q)}_gotoPermanentFailure(A,W,q){this._onDidStateChange.fire(new te(this.reconnectionToken,A,W,q)),M(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=G,G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class J extends G{constructor(A,W,q,j,K){super(1,A,j,K,!0),this.client=this._register(new p.Client(K,{remoteAuthority:W,clientId:q},A.ipcLogger))}async _reconnect(A,W){await i(A,W)}}e.ManagementPersistentConnection=J;class B extends G{constructor(A,W,q,j,K){super(2,A,q,j,!1),this._startArguments=W,this.debugPort=K}async _reconnect(A,W){await s(A,this._startArguments,W)}}e.ExtensionHostPersistentConnection=B;function M(g){try{g.acceptDisconnect();const A=g.getSocket();g.dispose(),A.dispose()}catch(A){(0,U.onUnexpectedError)(A)}}function X(g){if(g&&g.type==="error"){const A=new Error(`Connection error: ${g.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function ie(g,A){for(;g.length<A;)g+=" ";return g}function se(g,A){return`[remote-connection][${ie(a(g),13)}][${A.substr(0,5)}\u2026]`}function H(g,A,W){return`${se(g,A)}[${W?"reconnect":"initial"}]`}function Z(g,A){return`${H(A,g.reconnectionToken,!!g.reconnectionProtocol)}[${g.connectTo}]`}function $(g){return`${Date.now()-g} ms`}}),define(oe[104],ae([0,1,2,4]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class _{constructor(){this.factories={}}register(T,R){return this.factories[T]??=[],this.factories[T].push(R),(0,L.toDisposable)(()=>{const I=this.factories[T]?.indexOf(R);typeof I=="number"&&I>=0&&this.factories[T]?.splice(I,1)})}getSocketFactory(T){return(this.factories[T.type]||[]).find(I=>I.supports(T))}connect(T,R,I,m){const P=this.getSocketFactory(T);if(!P)throw new Error(`No socket factory found for ${T}`);return P.connect(T,R,I,m)}}e.RemoteSocketFactoryService=_}),define(oe[207],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,157]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var _;(function(U){U.disconnected=T=>({type:"disconnected",onTokenFailed:T}),U.connected=T=>({type:"connected",info:T}),U.connecting=T=>({type:"connecting",progress:T}),U.uninitialized={type:"uninitialized"}})(_||(e.TunnelStates=_={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(oe[56],ae([0,1,16,7,2,159,48,4,8,40]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class P{constructor(k){this.original=k}toJSON(){if(!this.headers){const k=Object.create(null);for(const n in this.original)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?k[n]="*****":k[n]=this.original[n];this.headers=k}return this.headers}}class p extends _.Disposable{constructor(k){super(),this.counter=0,this.logger=k.createLogger("network",{name:(0,U.localize)(0,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async logAndRequest(k,n,r){const t=`${k} #${++this.counter}: ${n.url}`;this.logger.trace(`${t} - begin`,n.type,new P(n.headers??{}));try{const i=await r();return this.logger.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${t} - error`,n.type,(0,O.getErrorMessage)(i)),i}}}e.AbstractRequestService=p;function v(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=v;function d(y){return y.res.statusCode===204}async function f(y){return d(y)?null:(await(0,L.streamToBuffer)(y.stream)).toString()}e.asText=f;async function E(y){if(!v(y))throw new Error("Server returned "+y.res.statusCode);return f(y)}e.asTextOrError=E;async function a(y){if(!v(y))throw new Error("Server returned "+y.res.statusCode);if(d(y))return null;const n=(await(0,L.streamToBuffer)(y.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}e.asJson=a;function h(y){b(y)}e.updateProxyConfigurationsScope=h;let u;function b(y){const k=m.Registry.as(T.Extensions.Configuration),n=u;u={id:"http",order:15,title:(0,U.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,U.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,U.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,U.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,U.localize)(5,null),(0,U.localize)(6,null),(0,U.localize)(7,null),(0,U.localize)(8,null)],default:"override",description:(0,U.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,U.localize)(10,null),restricted:!0}}},k.updateConfigurations({add:[u],remove:n?[n]:[]})}b(1)}),define(oe[208],ae([0,1,26,25,13,56]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=e.DownloadService=class{constructor(I,m){this.requestService=I,this.fileService=m}async download(I,m,P=L.CancellationToken.None){if(I.scheme===O.Schemas.file||I.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(I,m);return}const p={type:"GET",url:I.toString(!0)},v=await this.requestService.request(p,P);if(v.res.statusCode===200)await this.fileService.writeFile(m,v.stream);else{const d=await(0,U.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${d}`)}}};e.DownloadService=T=pe([Y(0,U.IRequestService),Y(1,_.IFileService)],T)}),define(oe[209],ae([0,1,16,26]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class _{constructor(R){this.service=R}listen(R,I){throw new Error("Invalid listen")}call(R,I,m,P=O.CancellationToken.None){switch(I){case"request":return this.service.request(m[0],P).then(async({res:p,stream:v})=>{const d=await(0,L.streamToBuffer)(v);return[{statusCode:p.statusCode,headers:p.headers},d]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=_;class U{constructor(R){this.channel=R}async request(R,I){const[m,P]=await this.channel.call("request",[R],I);return{res:m,stream:(0,L.bufferToStream)(P)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}}e.RequestChannelClient=U}),define(oe[210],ae([0,1,59,25,175]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class U extends _.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}}e.SharedProcessEnvironmentService=U,pe([L.memoize],U.prototype,"userRoamingDataHome",null)}),define(oe[211],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class L{constructor(){this.validators=new Map}async createNewMessage(_){try{const U=await this.getValidator();if(U){const T=String(L._nextId++);return this.validators.set(T,U),{id:T,data:U.createNewMessage(_)}}}catch{}return{id:"",data:_}}async validate(_,U){if(!_.id)return!0;const T=this.validators.get(_.id);if(!T)return!1;this.validators.delete(_.id);try{return T.validate(U)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(_){try{return await this.signValue(_)}catch{}return _}}e.AbstractSignService=L,L._nextId=1}),define(oe[106],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[212],ae([0,1,211]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends L.AbstractSignService{getValidator(){return this.vsda().then(U=>new U.validator)}signValue(U){return this.vsda().then(T=>new T.signer().sign(U))}vsda(){return new Promise((U,T)=>ne(["vsda"],U,T))}}e.SignService=O}),define(oe[75],ae([0,1,3,2]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class _ extends O.Disposable{constructor(p,v,d){super(),this.channel=p,this.profile=v,this.workspace=d}async getItems(){const p={profile:this.profile,workspace:this.workspace},v=await this.channel.call("getItems",p);return new Map(v)}updateItems(p){const v={profile:this.profile,workspace:this.workspace};return p.insert&&(v.insert=Array.from(p.insert.entries())),p.delete&&(v.delete=Array.from(p.delete.values())),this.channel.call("updateItems",v)}}class U extends _{constructor(p,v){super(p,v,void 0),this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(p=>this.onDidChangeStorage(p)))}onDidChangeStorage(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this._onDidChangeItemsExternal.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class T extends U{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class R extends U{constructor(p,v){super(p,v)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class I extends _{constructor(p,v){super(p,void 0,v),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class m{constructor(p){this.channel=p}isUsed(p){const v={payload:p,profile:void 0,workspace:void 0};return this.channel.call("isUsed",v)}}e.StorageClient=m}),define(oe[107],ae([0,1,5,37,32]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function U(I){if(L.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function T(I,m,P,p,v,d,f,E){const a=Object.create(null);a["common.machineId"]=d,a.sessionID=(0,_.generateUuid)()+Date.now(),a.commitHash=p,a.version=v,a["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,L.PlatformToString)(L.platform),a["common.nodePlatform"]=O.platform,a["common.nodeArch"]=P,a["common.product"]=E||"desktop",f&&(a["common.msftInternal"]=f);let h=0;const u=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.isLinuxSnap&&(a["common.snap"]="true");const b=U(m);return b&&(a["common.platformDetail"]=b),a}e.resolveCommonProperties=T;function R(I){const m=O.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return I.some(p=>P===p)}e.verifyMicrosoftInternalDomain=R}),define(oe[20],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(U){U[U.NONE=0]="NONE",U[U.CRASH=1]="CRASH",U[U.ERROR=2]="ERROR",U[U.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var _;(function(U){U.OFF="off",U.CRASH="crash",U.ERROR="error",U.ON="all"})(_||(e.TelemetryConfiguration=_={}))}),define(oe[213],ae([0,1,36,6,34,25,15,5,12,136,30,139,95,13,24,20]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function h(n,r){const t=`${n}::${r.join(":")}`,i=a.get(t);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,l=new Map,w=2e4;function S(C,D,N,F){const V=D.substring(C.length+1);return O.Promises.withAsyncBody(async z=>{let x;try{x=await P.Promises.readdir(D,{withFileTypes:!0})}catch{z();return}if(F.count>=w){F.count+=x.length,F.maxReached=!0,z();return}let Q=x.length;if(Q===0){z();return}let te=x;F.count+x.length>w&&(F.maxReached=!0,Q=w-F.count,te=x.slice(0,Q)),F.count+=x.length;for(const G of te)if(G.isDirectory()){if(N.includes(G.name)||await S(C,(0,T.join)(D,G.name),N,F),--Q===0){z();return}}else{const J=G.name.lastIndexOf(".");if(J>=0){const B=G.name.substring(J+1);B&&o.set(B,(o.get(B)??0)+1)}for(const B of s)B.relativePathPattern?.test(V)!==!1&&B.filePattern.test(G.name)&&l.set(B.tag,(l.get(B.tag)??0)+1);if(--Q===0){z();return}}})}const c=O.Promises.withAsyncBody(async C=>{const D={count:0,maxReached:!1};await S(n,n,r,D);const N=await y(n);C({configFiles:u(l),fileTypes:u(o),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:N})});return a.set(t,c),c}e.collectWorkspaceStats=h;function u(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function b(){const n={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},r=L.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=b;async function y(n){try{const r=new Map,t=(0,T.join)(n,".vscode","launch.json"),i=await P.Promises.readFile(t),s=[],o=(0,_.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,_.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const w=l.type;w&&(r.has(w)?r.set(w,r.get(w)+1):r.set(w,1))}return u(r)}catch{return[]}}e.collectLaunchConfigs=y;let k=e.DiagnosticsService=class{constructor(r,t){this.telemetryService=r,this.productService=t}formatMachineInfo(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}formatEnvironment(r){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const i=L.cpus();return i&&i.length>0&&t.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),t.push(`Memory (System):  ${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,p.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async i=>{let[s,o]=i,l=this.formatProcessList(r,s);return t.forEach(w=>{if((0,v.isRemoteDiagnosticError)(w))l+=`
${w.errorMessage}`,o+=`
${w.errorMessage}`;else if(l+=`

Remote: ${w.hostName}`,w.processes&&(l+=`
${this.formatProcessList(r,w.processes)}`),w.workspaceMetadata){o+=`
|  Remote: ${w.hostName}`;for(const S of Object.keys(w.workspaceMetadata)){const c=w.workspaceMetadata[S];let C=`${c.fileCount} files`;c.maxFilesReached&&(C=`more than ${C}`),o+=`|    Folder (${S}): ${C}`,o+=this.formatWorkspaceStats(c)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(r,t){const{memory:i,vmHint:s,os:o,cpus:l}=b(),w={os:o,memory:i,cpus:l,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(w.load=`${L.loadavg().map(S=>Math.round(S)).join(", ")}`),R.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(r,t){const i=[];return(0,p.listProcesses)(r.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(r)),i.push(""),i.push(this.formatProcessList(r,s)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(r))),t.forEach(o=>{if((0,v.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(r,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const w=o.workspaceMetadata[l];let S=`${w.fileCount} files`;w.maxFilesReached&&(S=`more than ${S}`),i.push(`Folder (${l}): ${S}`),i.push(this.formatWorkspaceStats(w))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(r){const t=[];let s=0;const o=(c,C)=>{const D=` ${c}(${C})`;s+D.length>60?(t.push(l),l="|                 ",s=l.length):s+=D.length,l+=D};let l="|      File types:";const w=10,S=r.fileTypes.length>w?w:r.fileTypes.length;for(let c=0;c<S;c++){const C=r.fileTypes[c];o(C.name,C.count)}if(t.push(l),r.configFiles.length>=0&&(l="|      Conf files:",s=0,r.configFiles.forEach(c=>{o(c.name,c.count)}),t.push(l)),r.launchConfigFiles.length>0){let c="|      Launch Configs:";r.launchConfigFiles.forEach(C=>{const D=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;c+=D}),t.push(c)}return t.join(`
`)}expandGPUFeatures(r){const t=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${r[i]}`).join(`
                  `)}formatWorkspaceMetadata(r){const t=[],i=[];return r.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const l=I.URI.revive(o);if(l.scheme===U.Schemas.file){const w=l.fsPath;i.push(h(w,["node_modules",".git"]).then(S=>{let c=`${S.fileCount} files`;S.maxFilesReached&&(c=`more than ${c}`),t.push(`|    Folder (${(0,T.basename)(w)}): ${c}`),t.push(this.formatWorkspaceStats(S))}).catch(S=>{t.push(`|      Error: Unable to collect workspace stats for folder ${w} (${S.toString()})`)}))}else t.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,t){const i=new Map;r.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:l})=>i.set(o,l));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(r.mainPID,i,s,t,0),s.join(`
`)}formatProcessItem(r,t,i,s,o){const l=o===0;let w;l?w=s.pid===r?`${this.productService.applicationName} main`:"remote agent":t.has(s.pid)?w=t.get(s.pid):w=`${"  ".repeat(o)} ${s.name}`;const S=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(S/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(s.children)&&s.children.forEach(c=>this.formatProcessItem(r,t,i,c,o+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:i}of r.folders){const s=I.URI.revive(i);if(s.scheme!==U.Schemas.file)continue;const o=s.fsPath;try{(await h(o,["node_modules",".git"])).fileTypes.forEach(w=>t.add(w.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const i=I.URI.revive(t);if(i.scheme!==U.Schemas.file)continue;const s=i.fsPath;try{const o=await h(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};e.DiagnosticsService=k=pe([Y(0,E.ITelemetryService),Y(1,f.IProductService)],k)}),define(oe[108],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(U){this.appenders=U}listen(U,T){throw new Error(`Event not found: ${T}`)}call(U,T,{eventName:R,data:I}){return this.appenders.forEach(m=>m.log(R,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class O{constructor(U){this.channel=U}log(U,T){return this.channel.call("log",{eventName:U,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(oe[45],ae([0,1,31,10,3,18,74,107,20]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class p{async publicLog(s,o,l){}async publicLogError(s,o,l){}}e.NullEndpointTelemetryService=p,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,s){return _.Event.debounce(s.onDidChangeConfiguration,(l,w)=>{const S=l?new Set([...l.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:S}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,U.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=v;function d(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=d;function f(i,s){return!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=f;function E(i){const s=i.getValue(I.TELEMETRY_SETTING_ID),o=i.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function a(i){const s={},o={},l={};b(i,l);for(let w in l){w=w.length>150?w.substr(w.length-149):w;const S=l[w];typeof S=="number"?o[w]=S:typeof S=="boolean"?o[w]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${S.length}`),s[w]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(s[w]=S)}return{properties:s,measurements:o}}e.validateTelemetryData=a;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const s=(0,T.getRemoteName)(i);return h.has(s)?s:"other"}e.cleanRemoteAuthority=u;function b(i,s,o=0,l){if(i)for(const w of Object.getOwnPropertyNames(i)){const S=i[w],c=l?l+w:w;Array.isArray(S)?s[c]=(0,L.safeStringify)(S):S instanceof Date?s[c]=S.toISOString():(0,O.isObject)(S)?o<2?b(S,s,o+1,c+"."):s[c]=(0,L.safeStringify)(S):s[c]=S}}function y(i,s){const o=i.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(o)||l}e.isInternalTelemetry=y;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=k;function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const l=[];for(const C of s)for(;;){const D=C.exec(i);if(!D)break;l.push([D.index,C.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(o="";;){const C=S.exec(i);if(!C)break;const D=l.some(([N,F])=>C.index<F&&N<S.lastIndex);!w.test(C[0])&&!D&&(o+=i.substring(c,C.index)+"<REDACTED: user-file-path>",c=S.lastIndex)}return c<i.length&&(o+=i.substr(c)),o}function r(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of s)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function t(i,s){return(0,L.cloneAndChange)(i,o=>{if(o instanceof m||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=n(l,s);for(const w of s)l=l.replace(w,"");return l=r(l),l}})}e.cleanData=t}),define(oe[33],ae([0,1,27,28,49,5,12,7,37,45]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=P;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,s,o)}static parse(i){const s=p.exec(i);return s&&s[1]&&s[2]?new v({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(t){const i=d.exec(t);return i&&i[1]?[a(i[1]),i[2]]:[a(t),void 0]}e.getIdAndVersion=f;function E(t,i){return`${t}.${i}`}e.getExtensionId=E;function a(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=a;function h(t,i){return a(E(t??_.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=h;function u(t,i){const s=[],o=l=>{for(const w of s)if(w.some(S=>P(i(S),i(l))))return w;return null};for(const l of t){const w=o(l);w?w.push(l):s.push([l])}return s}e.groupByExtension=u;function b(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function y(t){return{id:new m.TelemetryTrustedValue(t.identifier.id),name:new m.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function k(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(w=>!P(w.identifier,{id:l}))){const w=t.filter(S=>P(S.identifier,{id:l}));w.length===1&&(s.push(w[0]),o.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=k;async function n(t,i){if(!U.isLinux)return!1;let s;try{s=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,O.getTargetPlatform)(s?"alpine":U.platform,I.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=r}),define(oe[214],ae([0,1,21,2,22,12,13,24,6,3,15,5,37,33]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let f=e.ExtensionTipsService=class extends O.Disposable{constructor(b,y){super(),this.fileService=b,this.productService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,k])=>this.allConfigBasedTips.set(k.configPath,k))}getConfigBasedTips(b){return this.getValidConfigBasedTips(b)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(b){const y=[];for(const[k,n]of this.allConfigBasedTips)if(!(n.configScheme&&n.configScheme!==b.scheme))try{const r=(await this.fileService.readFile((0,_.joinPath)(b,k))).value.toString();for(const[t,i]of Object.entries(n.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(r))&&y.push({extensionId:t,extensionName:i.name,configName:n.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return y}};e.ExtensionTipsService=f=pe([Y(0,T.IFileService),Y(1,R.IProductService)],f);const E="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";class h extends f{constructor(b,y,k,n,r,t,i,s){super(i,s),this.userHome=b,this.windowEvents=y,this.telemetryService=k,this.extensionManagementService=n,this.storageService=r,this.extensionRecommendationNotificationService=t,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,s.exeBasedExtensionTips&&Object.entries(s.exeBasedExtensionTips).forEach(([o,l])=>{const w=[],S=[],c=[];Object.entries(l.recommendations).forEach(([C,D])=>{D.important?l.important?w.push({extensionId:C,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):S.push({extensionId:C,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):c.push({extensionId:C,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),w.length&&this.highImportanceExecutableTips.set(o,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:w}),S.length&&this.mediumImportanceExecutableTips.set(o,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:S}),c.length&&this.allOtherExecutableTips.set(o,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:c})}),(0,I.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const b=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),y=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...b,...y]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const b=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),y=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),k=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(b,k),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(y,k)}groupImportantTipsByExe(b,y){const k=new Map;b.forEach(s=>k.set(s.extensionId.toLowerCase(),s));const{installed:n,uninstalled:r}=this.groupByInstalled([...k.keys()],y);for(const s of n){const o=k.get(s);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:s,exeName:o.exeName})}for(const s of r){const o=k.get(s);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:s,exeName:o.exeName})}const t=this.getPromptedExecutableTips(),i=new Map;for(const s of r){const o=k.get(s);if(o&&(!t[o.exeName]||!t[o.exeName].includes(o.extensionId))){let l=i.get(o.exeName);l||(l=[],i.set(o.exeName,l)),l.push(o)}}return i}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[b,y]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(k=>{switch(k){case"reacted":this.addToRecommendedExecutables(y[0].exeName,y);break;case"ignored":this.highImportanceTipsByExe.delete(b);break;case"incompatibleWindow":{const n=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(n(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const n=this._register((0,I.disposableTimeout)(()=>{n.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const b=this.getLastPromptedMediumExeTime(),y=Date.now()-b,k=7*24*60*60*1e3;if(y<k){const t=this._register((0,I.disposableTimeout)(()=>{t.dispose(),this.promptMediumImportanceExeBasedTip()},k-y));return}const[n,r]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(r).then(t=>{switch(t){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(n),this.addToRecommendedExecutables(r[0].exeName,r);const i=this._register((0,I.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},k));break}case"ignored":this.mediumImportanceTipsByExe.delete(n),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const i=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(i(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const i=this._register((0,I.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(b){const y=await this.extensionManagementService.getInstalled(1),k=b.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(r=>y.every(t=>!(0,d.areSameExtensions)(t.identifier,{id:r})))).map(({extensionId:n})=>n.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:k,source:3,name:b[0].exeFriendlyName,searchValue:`@exe:"${b[0].exeName}"`})}getLastPromptedMediumExeTime(){let b=this.storageService.getNumber(a,-1);return b||(b=Date.now(),this.updateLastPromptedMediumExeTime(b)),b}updateLastPromptedMediumExeTime(b){this.storageService.store(a,b,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(E,-1,"{}"))}addToRecommendedExecutables(b,y){const k=this.getPromptedExecutableTips();k[b]=y.map(({extensionId:n})=>n.toLowerCase()),this.storageService.store(E,JSON.stringify(k),-1,0)}groupByInstalled(b,y){const k=[],n=[],r=y.reduce((t,i)=>(t.add(i.identifier.id.toLowerCase()),t),new Set);return b.forEach(t=>{r.has(t.toLowerCase())?k.push(t):n.push(t)}),{installed:k,uninstalled:n}}async getValidExecutableBasedExtensionTips(b){const y=[],k=new Map;for(const n of b.keys()){const r=b.get(n);if(!r||!(0,L.isNonEmptyArray)(r.recommendations))continue;const t=[];p.isWindows?r.windowsPath&&t.push(r.windowsPath.replace("%USERPROFILE%",()=>v.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>v.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>v.env.ProgramFiles).replace("%APPDATA%",()=>v.env.APPDATA).replace("%WINDIR%",()=>v.env.WINDIR)):(t.push((0,P.join)("/usr/local/bin",n)),t.push((0,P.join)("/usr/bin",n)),t.push((0,P.join)(this.userHome.fsPath,n)));for(const i of t){let s=k.get(i);if(s===void 0&&(s=await this.fileService.exists(U.URI.file(i)),k.set(i,s)),s)for(const{extensionId:o,extensionName:l,isExtensionPack:w,whenNotInstalled:S}of r.recommendations)y.push({extensionId:o,extensionName:l,isExtensionPack:w,exeName:n,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:S})}}return y}}e.AbstractNativeExtensionTipsService=h}),define(oe[215],ae([0,1,26,33]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function _(U,T,R,I,m){try{const P=await U.getExtensionsControlManifest();if(!P.deprecated)return;const p=await U.getInstalled(1);for(const[v,d]of Object.entries(P.deprecated)){if(!d?.extension)continue;const{id:f,autoMigrate:E,preRelease:a}=d.extension;if(!E)continue;const h=p.find(b=>(0,O.areSameExtensions)(b.identifier,{id:v}));if(!h)continue;const u=(await T.getExtensions([{id:f,preRelease:a}],{targetPlatform:await U.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!u){m.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{m.info(`Migrating '${h.identifier.id}' extension to '${f}' extension...`);const b=!I.getDisabledExtensions().some(k=>(0,O.areSameExtensions)(k,h.identifier));await U.uninstall(h),m.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let y=p.find(k=>(0,O.areSameExtensions)(k.identifier,{id:f}));(!y||!y.isPreReleaseVersion&&b)&&(y=await U.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${y.identifier.id}'`),b||(await I.disableExtension(y.identifier),m.info(`Disabled the pre-release extension '${y.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),E.storage&&(R.addToMigrationList((0,O.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,O.getExtensionId)(y.manifest.publisher,y.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${h.identifier.id}' extension to '${f}' extension.`)}catch(b){m.error(b)}}}catch(P){m.error(P)}}e.migrateUnsupportedExtensions=_}),define(oe[216],ae([0,1,3,2,35,33,49]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends O.Disposable{constructor(m,P,p,v,d,f,E){super(),this.extensionManagementService=m,this.extensionsScannerService=P,this.userDataProfilesService=p,this.extensionsProfileScannerService=v,this.uriIdentityService=d,this.fileService=f,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,a=>E.error(a))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(m=>this.onDidChangeProfiles(m.added,m.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(m=>this.onAddExtensions(m))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(m=>this.onDidAddExtensions(m))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(m=>this.onRemoveExtensions(m))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(m=>this.onDidRemoveExtensions(m))),this._register(this.fileService.onDidFilesChange(m=>this.onDidFilesChange(m)))}async onDidChangeProfiles(m,P){try{await Promise.all(P.map(p=>(this.extensionsProfileWatchDisposables.deleteAndDispose(p.id),this.removeExtensionsFromProfile(p.extensionsResource)))),m.length&&await Promise.all(m.map(p=>(this.extensionsProfileWatchDisposables.set(p.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(p.extensionsResource)),this.fileService.watch(p.extensionsResource))),this.populateExtensionsFromProfile(p.extensionsResource))))}catch(p){throw this.logService.error(p),p}}async onAddExtensions(m){for(const P of m.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),m.profileLocation)}async onDidAddExtensions(m){for(const P of m.extensions){const p=this.getKey(P.identifier,P.version);m.error?this.removeExtensionWithKey(p,m.profileLocation):this.addExtensionWithKey(p,m.profileLocation)}}async onRemoveExtensions(m){for(const P of m.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),m.profileLocation)}async onDidRemoveExtensions(m){const P=[],p=[];for(const v of m.extensions){const d=this.getKey(v.identifier,v.version);m.error?this.addExtensionWithKey(d,m.profileLocation):(this.removeExtensionWithKey(d,m.profileLocation),this.allExtensions.has(d)||(this.logService.debug("Extension is removed from all profiles",v.identifier.id,v.version),p.push(this.extensionManagementService.scanInstalledExtensionAtLocation(v.location).then(f=>{f?P.push(f):this.logService.info("Extension not found at the location",v.location.toString())},f=>this.logService.error(f)))))}try{await Promise.all(p),P.length&&await this.uninstallExtensionsNotInProfiles(P)}catch(v){this.logService.error(v)}}onDidFilesChange(m){for(const P of this.userDataProfilesService.profiles)m.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(m){const P=[],p=[],v=await this.extensionsProfileScannerService.scanProfileExtensions(m),d=new Set,f=new Set;for(const[E,a]of this.allExtensions)a.has(m)&&f.add(E);for(const E of v){const a=this.getKey(E.identifier,E.version);d.add(a),f.has(a)||(P.push(E.identifier),this.addExtensionWithKey(a,m))}for(const E of f)if(!d.has(E)){const a=this.fromKey(E);a&&(p.push(a.identifier),this.removeExtensionWithKey(E,m))}(P.length||p.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:m}:void 0,removed:p.length?{extensions:p,profileLocation:m}:void 0})}async populateExtensionsFromProfile(m){const P=await this.extensionsProfileScannerService.scanProfileExtensions(m);for(const p of P)this.addExtensionWithKey(this.getKey(p.identifier,p.version),m)}async removeExtensionsFromProfile(m){for(const P of[...this.allExtensions.keys()])this.removeExtensionWithKey(P,m);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(m){m||(m=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(p=>!this.allExtensions.has(this.getKey(p.identifier,p.manifest.version)))),m.length&&await this.extensionManagementService.markAsUninstalled(...m)}addExtensionWithKey(m,P){let p=this.allExtensions.get(m);p||this.allExtensions.set(m,p=new _.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(v))),p.add(P)}removeExtensionWithKey(m,P){const p=this.allExtensions.get(m);p&&p.delete(P),p?.size||this.allExtensions.delete(m)}getKey(m,P){return`${T.ExtensionIdentifier.toKey(m.id)}@${P}`}fromKey(m){const[P,p]=(0,U.getIdAndVersion)(m);return p?{identifier:{id:P},version:p}:void 0}}e.ExtensionsWatcher=R}),define(oe[217],ae([0,1,44,45]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function _(U,T,R,I,m,P,p){const v={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${T.nameShort})`};if((0,O.supportsTelemetry)(T,R)&&(0,O.getTelemetryLevel)(I)===3){const d=await(0,L.getServiceMachineId)(R,m,P);v["X-Market-User-Id"]=d,v["VSCode-SessionId"]=p.machineId||d}return v}e.resolveMarketplaceHeaders=_}),define(oe[218],ae([0,1,69,21,6,2,25,15,30,14,28,33,8,72,12]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=e.NativeLanguagePackService=class extends d.LanguagePackBaseService{constructor(b,y,k,n){super(k),this.extensionManagementService=b,this.logService=n,this.cache=this._register(new a(y,n)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getBuiltInExtensionTranslationsUri(b,y){const n=(await this.cache.getLanguagePacks())[y];if(!n){this.logService.warn(`No language pack found for ${y}`);return}const r=n.translations[b];return r?f.URI.file(r):void 0}async getInstalledLanguages(){const b=await this.cache.getLanguagePacks(),y=Object.keys(b).map(k=>{const n=b[k];return{...this.createQuickPickItem(k,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return y.push(this.createQuickPickItem("en","English")),y.sort((k,n)=>k.label.localeCompare(n.label)),y}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const y=await this.cache.getLanguagePacks();Object.keys(y).some(k=>y[k]&&y[k].extensions.some(n=>(0,p.areSameExtensions)(n.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),k=await this.cache.update(y);return!(0,O.equals)(Object.keys(b),Object.keys(k))}};e.NativeLanguagePackService=E=pe([Y(0,P.IExtensionManagementService),Y(1,m.INativeEnvironmentService),Y(2,P.IExtensionGalleryService),Y(3,v.ILogService)],E);let a=class extends U.Disposable{constructor(b,y){super(),this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new _.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(y=>{Object.keys(y).forEach(k=>delete y[k]),this.createLanguagePacksFromExtensions(y,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...y){for(const k of y)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,k);Object.keys(b).forEach(k=>this.updateHash(b[k]))}createLanguagePacksFromExtension(b,y){const k=y.identifier,n=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const r of n)if(y.location.scheme===T.Schemas.file&&h(r)){let t=b[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},b[r.languageId]=t);const i=t.extensions.filter(s=>(0,p.areSameExtensions)(s.extensionIdentifier,k))[0];i?i.version=y.manifest.version:t.extensions.push({extensionIdentifier:k,version:y.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,R.join)(y.location.fsPath,s.path)}}updateHash(b){if(b){const y=(0,L.createHash)("md5");for(const k of b.extensions)y.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);b.hash=y.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(y=b(k),k)).then(k=>{for(const r of Object.keys(k))k[r]||delete k[r];this.languagePacks=k,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),I.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>y,k=>this.logService.error(k))})}};a=pe([Y(0,m.INativeEnvironmentService),Y(1,v.ILogService)],a);function h(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const b of u.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[219],ae([0,1,7,31,45]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const U="https://0.0.0.0/OneCollector/1.0",T="https://0.0.0.0/ping";async function R(m,P,p){const v=await new Promise((h,u)=>{ne(["@microsoft/1ds-core-js"],h,u)}),d=await new Promise((h,u)=>{ne(["@microsoft/1ds-post-js"],h,u)}),f=new v.AppInsightsCore,E=new d.PostChannel,a={instrumentationKey:m,endpointUrl:U,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(p){a.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:p};a.extensionConfig[E.identifier]=h}return f.initialize(a,[]),f.addTelemetryInitializer(h=>{P&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),f}class I{constructor(P,p,v,d,f){this._isInternalTelemetry=P,this._eventPrefix=p,this._defaultData=v,this._xhrOverride=f,this.endPointUrl=U,this.endPointHealthUrl=T,this._defaultData||(this._defaultData={}),typeof d=="function"?this._aiCoreOrKey=d():this._aiCoreOrKey=d,this._asyncAiCore=null}_withAIClient(P){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=R(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(p=>{P(p)},p=>{(0,L.onUnexpectedError)(p),console.error(p)})}}log(P,p){if(!this._aiCoreOrKey)return;p=(0,O.mixin)(p,this._defaultData),p=(0,_.validateTelemetryData)(p);const v=this._eventPrefix+"/"+P;try{this._withAIClient(d=>{d.pluginVersionString=p?.properties.version??"Unknown",d.track({name:v,baseData:{name:v,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(p=>{p.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(oe[109],ae([0,1,2,160,14,8,24,45]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=e.TelemetryLogAppender=class extends L.Disposable{constructor(P,p,v,d,f=""){super(),this.prefix=f;const E=p.getLogger(R.telemetryLogId);if(E)this.logger=this._register(E);else{const h=(0,R.isLoggingOnly)(d,v)?" (Not Sent)":"",u=()=>(0,R.supportsTelemetry)(d,v)&&P.getLevel()===U.LogLevel.Trace;this.logger=this._register(p.createLogger(R.telemetryLogId,{name:(0,O.localize)(0,null,h),hidden:!u()})),this._register(P.onDidChangeLogLevel(()=>p.setVisibility(R.telemetryLogId,u()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,p){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,R.validateTelemetryData)(p))}};e.TelemetryLogAppender=I=pe([Y(0,U.ILogService),Y(1,U.ILoggerService),Y(2,_.IEnvironmentService),Y(3,T.IProductService)],I)}),define(oe[110],ae([0,1,2,31,5,27,161,18,48,102,24,40,20,45]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=e.TelemetryService=class{constructor(h,u,b){this._configurationService=u,this._productService=b,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,U.escapeRegExpCharacters)(y),"gi")),y.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,U.escapeRegExpCharacters)(y.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(y=>{(y.affectsConfiguration(v.TELEMETRY_SETTING_ID)||y.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||y.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(h,u){this._experimentProperties[h]=u}_updateTelemetryLevel(){let h=(0,d.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const b=u.usage?3:u.error?2:0;h=Math.min(h,b)}this._telemetryLevel=h}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(h,u,b){this._telemetryLevel<u||(b=(0,O.mixin)(b,this._experimentProperties),b=(0,d.cleanData)(b,this._cleanupPatterns),b=(0,O.mixin)(b,this._commonProperties),this._appenders.forEach(y=>y.log(h,b)))}publicLog(h,u){this._log(h,3,u)}publicLog2(h,u){this.publicLog(h,u)}publicLogError(h,u){this._sendErrorTelemetry&&this._log(h,2,u)}publicLogError2(h,u){this.publicLogError(h,u)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=f=pe([Y(1,R.IConfigurationService),Y(2,P.IProductService)],f);function E(){const a=(0,T.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=_.isWeb?"":(0,T.localize)(3,null),b=(0,T.localize)(4,null),y=(0,T.localize)(5,null),k=(0,T.localize)(6,null),n=(0,T.localize)(7,null),r=`
|       | ${b} | ${y} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${a} ${h} ${u}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}p.Registry.as(I.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:E(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(I.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,T.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,T.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[220],ae([0,1,264,219]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class _ extends O.AbstractOneDataSystemAppender{constructor(T,R,I,m){const P={sendPOST:(p,v)=>{const d={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const f=L.request(p.urlString,d,E=>{E.on("data",function(a){v(E.statusCode??200,E.headers,a.toString())}),E.on("error",function(a){v(0,{})})});f.write(p.data),f.end()}catch{v(0,{})}}};super(T,R,I,m,P)}}e.OneDataSystemAppender=_}),define(oe[221],ae([0,1,25,93,18,14,8,24,20,108,109,110]),function(ne,e,L,O,_,U,T,R,I,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=e.CustomEndpointTelemetryService=class{constructor(f,E,a,h,u,b){this.configurationService=f,this.telemetryService=E,this.logService=a,this.loggerService=h,this.environmentService=u,this.productService=b,this.customTelemetryServices=new Map}getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const E=Object.create(null);E["common.vscodemachineid"]=this.telemetryService.machineId,E["common.vscodesessionid"]=this.telemetryService.sessionId;const a=[f.id,JSON.stringify(E),f.aiKey],u=new O.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=[new m.TelemetryAppenderClient(u),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new p.TelemetryService({appenders:b,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}publicLog(f,E,a){this.getCustomTelemetryService(f).publicLog(E,a)}publicLogError(f,E,a){this.getCustomTelemetryService(f).publicLogError(E,a)}};e.CustomEndpointTelemetryService=v=pe([Y(0,_.IConfigurationService),Y(1,I.ITelemetryService),Y(2,T.ILogService),Y(3,T.ILoggerService),Y(4,U.IEnvironmentService),Y(5,R.IProductService)],v)}),define(oe[76],ae([0,1,3,18,4,8]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var T;(function(E){E.Http="http",E.Https="https"})(T||(e.TunnelProtocol=T={}));var R;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(R||(e.TunnelPrivacyId=R={}));var I;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(I||(e.ProvidedOnAutoForward=I={}));function m(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=p;function v(E,a,h,u){if(h===1)return!1;if(h===2&&p(a)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(b?.length===4&&parseInt(b[1])>=18)return!1}return E<1024}e.isPortPrivileged=v;class d{constructor(a,h,u){this.remoteAddress=a,this.localAddress=h,this._dispose=u,this._onDispose=new L.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let f=e.AbstractTunnelService=class{constructor(a,h){this.logService=a,this.configurationService=h,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this._tunnelProvider=a,a?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this._canElevate=a.elevation,this._privacyOptions=a.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const a=[],h=Array.from(this._tunnels.values());for(const u of h){const b=Array.from(u.values());for(const y of b){const k=await y.value;k&&a.push(k)}}return a}async dispose(){for(const a of this._tunnels.values()){for(const{value:h}of a.values())await h.then(u=>u?.dispose());a.clear()}this._tunnels.clear()}setEnvironmentTunnel(a,h,u,b,y){this.addTunnelToMap(a,h,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:h,localAddress:u,privacy:b,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,h){(p(a)||P(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(a,h);if(u)return++u.refcount,u.value}openTunnel(a,h,u,b,y,k=!1,n,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${y}.`),!a)return;if(h||(h="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(a,h,u,b,y,k,n,r);return t?t.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&i.privacy!==n&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const h=this._tunnels.get(a.tunnelRemoteHost);if(h){const u=h.get(a.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,u))}}}}async tryDisposeTunnel(a,h,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${h}.`);const b=u.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(h),b}}async closeTunnel(a,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${h} `);const u=this._tunnels.get(a);if(u&&u.has(h)){const b=u.get(h);b.refcount=0,await this.tryDisposeTunnel(a,h,b)}}addTunnelToMap(a,h,u){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(h,{refcount:1,value:u})}async removeEmptyTunnelFromMap(a,h){const u=this._tunnels.get(a);u&&(await u.get(h)||u.delete(h),u.size===0&&this._tunnels.delete(a))}getTunnelFromMap(a,h){const u=[a];P(a)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):p(a)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const b=u.map(y=>this._tunnels.get(y));for(const y of b){const k=y?.get(h);if(k)return k}}canTunnel(a){return!!m(a)}createWithProvider(a,h,u,b,y,k,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${b}.`);const r=u;this._factoryInProgress.add(r);const t=b===void 0?u:b,i={elevationRequired:y?this.isPortPrivileged(t):!1},s={remoteAddress:{host:h,port:u},localAddressPort:b,privacy:k,public:k?k!==R.Private:void 0,protocol:n},o=a.forwardPort(s,i);return o?(this.addTunnelToMap(h,u,o),o.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),o}};e.AbstractTunnelService=f=pe([Y(0,U.ILogService),Y(1,O.IConfigurationService)],f)}),define(oe[222],ae([0,1,8,76,2,7,6]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends _.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let I=e.SharedProcessTunnelService=class Ct extends _.Disposable{constructor(P,p){super(),this._tunnelService=P,this._logService=p,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,p,v,d,f,E,a){const h=new R,u=await Promise.resolve(this._tunnelService.openTunnel(P,h,v,d,f,E,a));if(!u)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${d} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(p))throw this._disposedTunnels.delete(p),h.dispose(),await u.dispose(),(0,U.canceled)();return h.setTunnel(u),this._tunnels.set(p,h),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${p}: ${u.localAddress} (local) to ${v}:${d} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(P,p){const v=this._tunnels.get(P);v&&v.setAddress(p)}async destroyTunnel(P){const p=this._tunnels.get(P);if(p){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await p.dispose();return}this._disposedTunnels.add(P)}};I._lastId=0,e.SharedProcessTunnelService=I=pe([Y(0,O.ISharedTunnelsService),Y(1,L.ILogService)],I)}),define(oe[223],ae([0,1,61,36,126,6,2,18,8,24,206,76,106,5,104]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(y,k,n,r,t){let i;for(let s=3;s&&(i?.dispose(),i=await new a(y,k,n,r,t).waitForReady(),!(t&&_.BROWSER_RESTRICTED_PORTS[t]||!_.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));s--);return i}class a extends T.Disposable{constructor(k,n,r,t,i){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=i,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=k,this._server=L.createServer(),this._barrier=new U.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const k=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let r=await(0,_.findFreePortFaster)(k,2,1e3,n),t=null;return this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(r=0,this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(k){k.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,P.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=r.getSocket().socket,i=r.readEntireBuffer();r.dispose(),i.byteLength>0&&k.write(i.buffer),k.on("end",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),t.end()}),k.on("close",()=>t.end()),k.on("error",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),t.destroy()}),t.on("end",()=>k.end()),t.on("close",()=>k.end()),t.on("error",()=>{k.destroy()}),k.pipe(t),t.pipe(k),k.localAddress&&this._socketsDispose.set(k.localAddress,()=>{k.end(),t.end()})}}let h=e.BaseTunnelService=class extends p.AbstractTunnelService{constructor(k,n,r,t,i){super(n,i),this.remoteSocketFactoryService=k,this.signService=r,this.productService=t}isPortPrivileged(k){return(0,p.isPortPrivileged)(k,this.defaultTunnelHost,d.OS,O.release())}retainOrCreateTunnel(k,n,r,t,i,s,o,l){const w=this.getTunnelFromMap(n,r);if(w)return++w.refcount,w.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,r,i,s,o,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const S={commit:this.productService.commit,quality:this.productService.quality,addressProvider:k,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},c=E(S,t,n,r,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,r,c),c}}};e.BaseTunnelService=h=pe([Y(0,f.IRemoteSocketFactoryService),Y(1,I.ILogService),Y(2,v.ISignService),Y(3,m.IProductService),Y(4,R.IConfigurationService)],h);let u=e.TunnelService=class extends h{constructor(k,n,r,t,i){super(k,n,r,t,i)}};e.TunnelService=u=pe([Y(0,f.IRemoteSocketFactoryService),Y(1,I.ILogService),Y(2,v.ISignService),Y(3,m.IProductService),Y(4,R.IConfigurationService)],u);let b=e.SharedTunnelsService=class extends T.Disposable{constructor(k,n,r,t,i){super(),this.remoteSocketFactoryService=k,this.logService=n,this.productService=r,this.signService=t,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(k,n,r,t,i,s,o,l,w){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this._tunnelServices.has(k)){const S=new u(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(S),this._tunnelServices.set(k,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this._tunnelServices.delete(k))})}return this._tunnelServices.get(k).openTunnel(n,r,t,i,s,o,l,w)}};e.SharedTunnelsService=b=pe([Y(0,f.IRemoteSocketFactoryService),Y(1,I.ILogService),Y(2,m.IProductService),Y(3,v.ISignService),Y(4,R.IConfigurationService)],b)}),define(oe[29],ae([0,1,4]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(oe[224],ae([0,1,29,178,13,22,123,3,2]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(v){this.uri=v,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let P=e.UriIdentityService=class{constructor(v){this._fileService=v,this._dispooables=new I.DisposableStore,this._limit=2**16;const d=new Map,f=E=>{let a=d.get(E.scheme);return a===void 0&&(a=v.hasProvider(E)&&!this._fileService.hasCapability(E,1024),d.set(E.scheme,a)),a};this._dispooables.add(R.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(E=>{d.delete(E.scheme)})),this.extUri=new U.ExtUri(f),this._canonicalUris=new T.SkipList((E,a)=>this.extUri.compare(E,a,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,U.normalizePath)(v));const d=this._canonicalUris.get(v);return d?d.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new m(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((f,E)=>f[1].time<E[1].time?1:f[1].time>E[1].time?-1:0);m._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let f=0;f<d;f++)this._canonicalUris.set(v[f][0],v[f][1].touch())}};e.UriIdentityService=P=pe([Y(0,_.IFileService)],P),(0,O.registerSingleton)(L.IUriIdentityService,P,1)}),define(oe[225],ae([0,1,3,2,13,42,47,16]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends O.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(P,p,v,d){super(),this.fileSystemScheme=P,this.fileSystemProvider=p,this.userDataScheme=v,this.logService=d,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(P,p){this.watchResources.set(P,P);const v=this.fileSystemProvider.watch(this.toFileSystemResource(P),p);return(0,O.toDisposable)(()=>{this.watchResources.delete(P),v.dispose()})}stat(P){return this.fileSystemProvider.stat(this.toFileSystemResource(P))}mkdir(P){return this.fileSystemProvider.mkdir(this.toFileSystemResource(P))}rename(P,p,v){return this.fileSystemProvider.rename(this.toFileSystemResource(P),this.toFileSystemResource(p),v)}readFile(P){return this.fileSystemProvider.readFile(this.toFileSystemResource(P),{atomic:!0})}readFileStream(P,p,v){const d=(0,U.newWriteableStream)(f=>R.VSBuffer.concat(f.map(E=>R.VSBuffer.wrap(E))).buffer);return(async()=>{try{const f=await this.readFile(P);d.end(f)}catch(f){d.error(f),d.end()}})(),d}readdir(P){return this.fileSystemProvider.readdir(this.toFileSystemResource(P))}writeFile(P,p,v){return this.fileSystemProvider.writeFile(this.toFileSystemResource(P),p,v)}delete(P,p){return this.fileSystemProvider.delete(this.toFileSystemResource(P),p)}copy(P,p,v){if((0,_.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(P),this.toFileSystemResource(p),v);throw new Error("copy not supported")}handleFileChanges(P){const p=[];for(const v of P){if(v.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(v.resource);this.watchResources.findSubstr(d)&&p.push({resource:d,type:v.type})}p.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(p))}toFileSystemResource(P){return P.with({scheme:this.fileSystemScheme})}toUserDataResource(P){return P.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(oe[57],ae([0,1,83]),function(ne,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(T,R,I,m){const P=(0,L.setProperty)(T,R,I,m)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=O;function _(T,R,I){let m=I;for(;m>=0;){if(T.charAt(m)===R.charAt(R.length-1)&&R.length===1)return m+1;if(m--,R.length===2&&m>=0&&T.charAt(m)===R.charAt(0))return m+2}return 0}e.getLineStartOffset=_;function U(T,R,I){let m=I;for(;m>=0;)if(T.charAt(m)===R.charAt(R.length-1)&&R.length===1||(m++,R.length===2&&m>=0&&T.charAt(m)===R.charAt(1)))return m;return T.length-1}e.getLineEndOffset=U}),define(oe[226],ae([0,1,31,52,10]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function U(d,f,E,a,h,u){const b=[],y=[],k=[];if(!f){const z=d.filter(({identifier:x})=>h.every(Q=>Q.toLowerCase()!==x.id.toLowerCase()));return{local:{added:b,removed:y,updated:k},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}d=d.map(p),f=f.map(p),E=E?E.map(p):null;const n=new Map,r=z=>{z.uuid&&n.set(z.id.toLowerCase(),z.uuid)};d.forEach(({identifier:z})=>r(z)),f.forEach(({identifier:z})=>r(z)),E?.forEach(({identifier:z})=>r(z));const t=z=>{const x=z.identifier.uuid||n.get(z.identifier.id.toLowerCase());return x?`uuid:${x}`:`id:${z.identifier.id.toLowerCase()}`},i=(z,x)=>(z.set(t(x),x),z),s=d.reduce(i,new Map),o=f.reduce(i,new Map),l=f.reduce((z,x)=>i(z,(0,L.deepClone)(x)),new Map),w=E?E.reduce(i,new Map):null,S=a.reduce(i,new Map),c=h.reduce((z,x)=>{const Q=n.get(x.toLowerCase());return z.add(Q?`uuid:${Q}`:`id:${x.toLowerCase()}`)},new Set),C=u?u.reduce((z,{id:x,uuid:Q})=>(Q=Q??n.get(x.toLowerCase()),z.add(Q?`uuid:${Q}`:`id:${x.toLowerCase()}`)),new Set):null,D=T(s,o,c,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const z=T(w,s,c,!1),x=T(w,o,c,!0),Q=(te,G,J,B)=>{let M,X,ie;return G.installed?(M=B.pinned,ie=B.preRelease,M&&(X=B.version)):(M=J.pinned,ie=J.preRelease,M&&(X=J.version)),M===void 0&&(M=G.pinned,M&&(X=G.version)),ie===void 0&&(ie=G.preRelease),{...B,installed:G.installed||J.installed,pinned:M,preRelease:ie,version:X??(J.version&&(!G.installed||O.gt(J.version,G.version))?J.version:G.version),state:I(G,J,w?.get(te))}};for(const te of x.removed.values()){const G=s.get(te);if(!G)continue;const J=(0,_.assertIsDefined)(w?.get(te)),B=C&&!C.has(te)&&J.installed;G.installed&&B?y.push(G.identifier):l.set(te,G)}for(const te of x.added.values()){const G=(0,_.assertIsDefined)(o.get(te)),J=s.get(te);if(J){if(D.updated.has(te)){const B=Q(te,J,G,G);R(J,G,!1,!1)||k.push(v(B,te)),l.set(te,B)}}else G.installed&&b.push(v(G,te))}for(const te of x.updated.values()){const G=(0,_.assertIsDefined)(o.get(te)),J=(0,_.assertIsDefined)(w?.get(te)),B=s.get(te);if(B)if(C&&!C.has(te)&&J.installed&&B.installed&&!G.installed)y.push(B.identifier);else{const X=Q(te,B,G,G);k.push(v(X,te)),l.set(te,X)}else G.installed&&b.push(v(G,te))}for(const te of z.added.values())x.added.has(te)||l.set(te,(0,_.assertIsDefined)(s.get(te)));for(const te of z.updated.values()){if(x.removed.has(te)||x.updated.has(te))continue;const G=(0,_.assertIsDefined)(s.get(te)),J=(0,_.assertIsDefined)(o.get(te));l.set(te,Q(te,G,J,G))}for(const te of z.removed.values())x.updated.has(te)||x.removed.has(te)||S.has(te)||(0,_.assertIsDefined)(o.get(te)).installed&&C&&(C.has(te)||!(0,_.assertIsDefined)(w?.get(te)).installed||l.delete(te))}const N=[],F=T(o,l,new Set,!0),V=F.added.size>0||F.updated.size>0||F.removed.size>0;return V&&l.forEach((z,x)=>N.push(v(z,x))),{local:{added:b,removed:y,updated:k},remote:V?{added:[...F.added].map(z=>l.get(z)),updated:[...F.updated].map(z=>l.get(z)),removed:[...F.removed].map(z=>o.get(z)),all:N}:null}}e.merge=U;function T(d,f,E,a){const h=d?[...d.keys()].filter(n=>!E.has(n)):[],u=[...f.keys()].filter(n=>!E.has(n)),b=u.filter(n=>!h.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),y=h.filter(n=>!u.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),k=new Set;for(const n of h){if(y.has(n))continue;const r=d.get(n),t=f.get(n);(!t||!R(r,t,a,!0))&&k.add(n)}return{added:b,removed:y,updated:k}}function R(d,f,E,a){return!(d.disabled!==f.disabled||a&&d.installed!==f.installed||d.installed&&f.installed&&(d.preRelease!==f.preRelease||d.pinned!==f.pinned||f.pinned&&d.version!==f.version)||!P(d.state,f.state)||E&&d.version!==f.version)}function I(d,f,E){const a=d.state,h=f.state,u=E?.state;if(!f.version||a&&O.gt(d.version,f.version))return a;if(h&&O.gt(f.version,d.version)||!a)return h;if(!h)return a;const b=(0,L.deepClone)(a),y=u?m(u,h):{added:Object.keys(h).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},k=u?m(u,a):{added:Object.keys(a).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...y.added.values(),...y.updated.values()])b[n]=h[n];for(const n of y.removed.values())k.updated.has(n)||delete b[n];return b}function m(d,f){const E=Object.keys(d),a=Object.keys(f),h=a.filter(y=>!E.includes(y)).reduce((y,k)=>(y.add(k),y),new Set),u=E.filter(y=>!a.includes(y)).reduce((y,k)=>(y.add(k),y),new Set),b=new Set;for(const y of E){if(u.has(y))continue;const k=d[y],n=f[y];(0,L.equals)(k,n)||b.add(y)}return{added:h,removed:u,updated:b}}function P(d={},f={}){const{added:E,removed:a,updated:h}=m(d,f);return E.size===0&&a.size===0&&h.size===0}function p(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function v(d,f){const E={identifier:{id:d.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},version:d.version,preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled&&(E.disabled=!0),d.installed&&(E.installed=!0),d.state&&(E.state=d.state),E}}),define(oe[111],ae([0,1,21,18,4]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,_.createDecorator)("IIgnoredExtensionsManagementService");let U=e.IgnoredExtensionsManagementService=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,I){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==R&&P!==`-${R}`),I&&m.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(R,I){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==R&&P!==`-${R}`),I&&m.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(R){const I=R.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),m=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),P=[],p=[];if(Array.isArray(m))for(const v of m)v.startsWith("-")?p.push(v.substring(1)):P.push(v);return(0,L.distinct)([...I,...P].filter(v=>!p.includes(v)))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};e.IgnoredExtensionsManagementService=U=pe([Y(0,O.IConfigurationService)],U)}),define(oe[227],ae([0,1,21,34,31,94,57]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(y){return(0,O.parse)(y)||[]}async function I(y,k,n,r,t){const i=R(y),s=R(k),o=n?R(n):null,l=[...i,...s,...o||[]].map(Q=>Q.key),w=await t.resolveUserBindings(l),S=P(i,s,o,w);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:y,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};const c=v(i),C=v(s),D=o?v(o):null,N=f(c,C,w),F=D?f(D,c,w):{added:[...c.keys()].reduce((Q,te)=>(Q.add(te),Q),new Set),removed:new Set,updated:new Set},V=D?f(D,C,w):{added:[...C.keys()].reduce((Q,te)=>(Q.add(te),Q),new Set),removed:new Set,updated:new Set},z=m(N,F,V);let x=y;for(const Q of z.removed.values())z.conflicts.has(Q)||(x=u(x,Q,r));for(const Q of z.added.values()){if(z.conflicts.has(Q))continue;const te=C.get(Q);if(te.some(G=>G.command!==`-${Q}`&&S.conflicts.has(w[G.key]))){z.conflicts.add(Q);continue}x=h(x,te,r)}for(const Q of z.updated.values()){if(z.conflicts.has(Q))continue;const te=C.get(Q);if(te.some(G=>G.command!==`-${Q}`&&S.conflicts.has(w[G.key]))){z.conflicts.add(Q);continue}x=b(x,Q,te,r)}return{mergeContent:x,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=I;function m(y,k,n){const r=new Set,t=new Set,i=new Set,s=new Set;for(const o of k.removed.values())n.updated.has(o)&&s.add(o);for(const o of n.removed.values())s.has(o)||(k.updated.has(o)?s.add(o):t.add(o));for(const o of k.added.values())s.has(o)||n.added.has(o)&&y.updated.has(o)&&s.add(o);for(const o of n.added.values())s.has(o)||(k.added.has(o)?y.updated.has(o)&&s.add(o):r.add(o));for(const o of k.updated.values())s.has(o)||n.updated.has(o)&&y.updated.has(o)&&s.add(o);for(const o of n.updated.values())s.has(o)||(k.updated.has(o)?y.updated.has(o)&&s.add(o):i.add(o));return{added:r,removed:t,updated:i,conflicts:s}}function P(y,k,n,r){const t=new Set,i=p(y,r),s=p(k,r),o=n?p(n,r):null,l=d(i,s);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const w=o?d(o,i):{added:[...i.keys()].reduce((F,V)=>(F.add(V),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const S=o?d(o,s):{added:[...s.keys()].reduce((F,V)=>(F.add(V),F),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:c,removed:C,updated:D,conflicts:N}=m(l,w,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:c,removed:C,updated:D,conflicts:N}}function p(y,k){const n=new Map;for(const r of y){const t=k[r.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(r)}return n}function v(y){const k=new Map;for(const n of y){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=k.get(r);t||(t=[],k.set(r,t)),t.push(n)}return k}function d(y,k){const n=[...y.keys()],r=[...k.keys()],t=r.filter(o=>!n.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),i=n.filter(o=>!r.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),s=new Set;for(const o of n){if(i.has(o))continue;const l=y.get(o).map(S=>({...S,key:o})),w=k.get(o).map(S=>({...S,key:o}));(0,L.equals)(l,w,(S,c)=>a(S,c))||s.add(o)}return{added:t,removed:i,updated:s}}function f(y,k,n){const r=[...y.keys()],t=[...k.keys()],i=t.filter(l=>!r.includes(l)).reduce((l,w)=>(l.add(w),l),new Set),s=r.filter(l=>!t.includes(l)).reduce((l,w)=>(l.add(w),l),new Set),o=new Set;for(const l of r){if(s.has(l))continue;const w=y.get(l).map(c=>({...c,key:n[c.key]})),S=k.get(l).map(c=>({...c,key:n[c.key]}));E(w,S)||o.add(l)}return{added:i,removed:s,updated:o}}function E(y,k){return!(!(0,L.equals)(y.filter(({command:n})=>n[0]!=="-"),k.filter(({command:n})=>n[0]!=="-"),(n,r)=>a(n,r))||!(0,L.equals)(y.filter(({command:n})=>n[0]==="-"),k.filter(({command:n})=>n[0]==="-"),(n,r)=>a(n,r)))}function a(y,k){if(y.command!==k.command||y.key!==k.key)return!1;const n=U.ContextKeyExpr.deserialize(y.when),r=U.ContextKeyExpr.deserialize(k.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!_.equals(y.args,k.args))}function h(y,k,n){for(const r of k)y=T.edit(y,[-1],r,n);return y}function u(y,k,n){const r=R(y);for(let t=r.length-1;t>=0;t--)(r[t].command===k||r[t].command===`-${k}`)&&(y=T.edit(y,[t],void 0,n));return y}function b(y,k,n,r){const t=R(y),i=t.findIndex(s=>s.command===k||s.command===`-${k}`);for(let s=t.length-1;s>=0;s--)(t[s].command===k||t[s].command===`-${k}`)&&(y=T.edit(y,[s],void 0,r));for(let s=n.length-1;s>=0;s--)y=T.edit(y,[i],n[s],r);return y}}),define(oe[228],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(U,T,R){const I={},m={},P=new Set;if(!T)return{local:{added:I,updated:m,removed:[...P.values()]},remote:{added:U,updated:{},removed:[]},conflicts:[]};const p=O(U,T);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:I,updated:m,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=O(R,U),d=O(R,T),f={},E={},a=new Set,h=new Set;for(const u of v.removed.values())d.updated.has(u)?I[u]=T[u]:a.add(u);for(const u of d.removed.values())h.has(u)||(v.updated.has(u)?h.add(u):P.add(u));for(const u of v.updated.values())h.has(u)||(d.updated.has(u)?p.updated.has(u)&&h.add(u):E[u]=U[u]);for(const u of d.updated.values())h.has(u)||(v.updated.has(u)?p.updated.has(u)&&h.add(u):U[u]!==void 0&&(m[u]=T[u]));for(const u of v.added.values())h.has(u)||(d.added.has(u)?p.updated.has(u)&&h.add(u):f[u]=U[u]);for(const u of d.added.values())h.has(u)||(v.added.has(u)?p.updated.has(u)&&h.add(u):I[u]=T[u]);return{local:{added:I,removed:[...P.values()],updated:m},remote:{added:f,removed:[...a.values()],updated:E},conflicts:[...h.values()]}}e.merge=L;function O(U,T){const R=U?Object.keys(U):[],I=T?Object.keys(T):[],m=I.filter(v=>!R.includes(v)).reduce((v,d)=>(v.add(d),v),new Set),P=R.filter(v=>!I.includes(v)).reduce((v,d)=>(v.add(d),v),new Set),p=new Set;for(const v of R){if(P.has(v))continue;const d=U[v],f=T[v];d!==f&&p.add(v)}return{added:m,removed:P,updated:p}}function _(U,T){const{added:R,removed:I,updated:m}=O(U,T);return R.size===0&&I.size===0&&m.size===0}e.areSame=_}),define(oe[229],ae([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(_,U,T,R){const I={added:[],removed:[],updated:[]};let m={added:[],removed:[],updated:[]};if(!U){const p=_.filter(({id:v})=>!R.includes(v));return p.length?m.added=p:m=null,{local:I,remote:m}}const P=O(_,U,R);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const p=O(T,_,R),v=O(T,U,R);for(const d of v.removed){const f=_.find(E=>E.id===d);f&&I.removed.push(f)}for(const d of v.added){const f=U.find(E=>E.id===d);p.added.includes(d)?P.updated.includes(d)&&I.updated.push(f):I.added.push(f)}for(const d of v.updated)I.updated.push(U.find(f=>f.id===d));for(const d of p.added)v.added.includes(d)||m.added.push(_.find(f=>f.id===d));for(const d of p.updated)v.removed.includes(d)||v.updated.includes(d)||m.updated.push(_.find(f=>f.id===d));for(const d of p.removed){const f=U.find(E=>E.id===d);f&&m.removed.push(f)}}return m.added.length===0&&m.removed.length===0&&m.updated.length===0&&(m=null),{local:I,remote:m}}e.merge=L;function O(_,U,T){_=_?_.filter(({id:v})=>!T.includes(v)):[],U=U.filter(({id:v})=>!T.includes(v));const R=_.map(({id:v})=>v),I=U.map(({id:v})=>v),m=I.filter(v=>!R.includes(v)),P=R.filter(v=>!I.includes(v)),p=[];for(const{id:v,name:d,shortName:f}of _){if(P.includes(v))continue;const E=U.find(a=>a.id===v);(!E||E.name!==d||E.shortName!==f)&&p.push(v)}return{added:m,removed:P,updated:p}}}),define(oe[23],ae([0,1,21,10,167,48,28,4,103,40]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const s=m.Registry.as(U.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function p(){const s=m.Registry.as(U.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(S=>!!s[S].ignoreSync),l=Object.keys(s).filter(S=>s[S].scope===2||s[S].scope===6),w=P();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...l,...w])}e.getDefaultIgnoredSettings=p,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function v(){const s="vscode://schemas/ignoredSettings",o=m.Registry.as(U.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,_.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=m.Registry.as(I.Extensions.JSONContribution),w=()=>{const S=P(),c=p().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),C=Object.keys(U.allSettings.properties).filter(F=>!c.includes(F)),D=c.filter(F=>!S.includes(F)),N={items:{type:"string",enum:[...C,...D.map(F=>`-${F}`)]}};l.registerSchema(s,N)};return o.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=v;function d(s){return s&&(0,O.isObject)(s)&&(0,O.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=d;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles",s.WorkspaceState="workspaceState"})(f||(e.SyncResource=f={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(s,...o){return s?[s,...o]:o}e.getPathSegments=E;function a(s,o,l,w){return w.joinPath(l.userDataSyncHome,...E(s,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=a,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=h;var u;(function(s){s.Unauthorized="Unauthorized",s.Forbidden="Forbidden",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class b extends Error{constructor(o,l,w,S){super(o),this.code=l,this.resource=w,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=b;class y extends b{constructor(o,l,w,S,c){super(o,w,void 0,c),this.url=l,this.serverCode=S}}e.UserDataSyncStoreError=y;class k extends b{constructor(o,l){super(o,l)}}e.UserDataAutoSyncError=k,function(s){function o(l){if(l instanceof s)return l;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(w&&w[1]){const S=w[2]==="unknown"?void 0:w[2],c=w[3]==="unknown"?void 0:w[3];return new s(l.message,w[1],S,c)}return new s(l.message,"Unknown")}s.toUserDataSyncError=o}(b||(e.UserDataSyncError=b={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r||(e.Change=r={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t||(e.MergeState=t={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(s){return`sync.enable.${s}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[230],ae([0,1,31,23]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function _(T,R,I,m,P){if(!R)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const p=U(T,R);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const v=I?U(I,R):{added:Object.keys(R).reduce((u,b)=>(u.add(b),u),new Set),removed:new Set,updated:new Set},d=I?U(I,T):{added:Object.keys(T).reduce((u,b)=>(u.add(b),u),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},E=L.deepClone(R),a=!I;for(const u of d.added.values())u!==O.SYNC_SERVICE_URL_TYPE&&a&&v.added.has(u)||(E[u]=T[u]);for(const u of d.updated.values())E[u]=T[u];for(const u of d.removed.values())m.unregistered.includes(u)||delete E[u];for(const u of v.added.values()){const b=R[u];if(m.machine.includes(u)){P.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(u))continue;const y=T[u];y&&y.value===b.value||u===O.SYNC_SERVICE_URL_TYPE&&a&&d.added.has(u)||(y?f.updated[u]=b:f.added[u]=b)}for(const u of v.updated.values()){const b=R[u];if(m.machine.includes(u)){P.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(u)||d.removed.has(u))continue;const y=T[u];y&&y.value===b.value||(f.updated[u]=b)}for(const u of v.removed.values()){if(m.machine.includes(u)){P.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}d.updated.has(u)||d.removed.has(u)||f.removed.push(u)}const h=U(R,E);return{local:f,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:E}}}e.merge=_;function U(T,R){const I=Object.keys(T),m=Object.keys(R),P=m.filter(d=>!I.includes(d)).reduce((d,f)=>(d.add(f),d),new Set),p=I.filter(d=>!m.includes(d)).reduce((d,f)=>(d.add(f),d),new Set),v=new Set;for(const d of I){if(p.has(d))continue;const f=T[d],E=R[d];L.equals(f,E)||v.add(d)}return{added:P,removed:p,updated:v}}}),define(oe[231],ae([0,1,21,34,83,41,31,57,23]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function m(l,w,S){let c=[];S?c=p(S):c=P(w);const C=[],D=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(c))for(const N of c)N.startsWith("-")?D.push(N.substring(1)):C.push(N);return(0,L.distinct)([...l,...C].filter(N=>!D.includes(N)))}e.getIgnoredSettings=m;function P(l){let w=l.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=l.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:l.getValue("settingsSync.ignoredSettings")||[]}function p(l){const w=(0,O.parse)(l);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function v(l,w){const S=(0,O.parse)(l)||{};let c="{}";for(const C of Object.keys(S)){const D=(0,_.setProperty)(c,[C],S[C],w);c=(0,_.applyEdits)(c,D)}return c}e.removeComments=v;function d(l,w,S,c){if(S.length){const C=o(w),D=(0,O.parse)(w)||{},N=(0,O.parse)(l);if(!N)return l;const F=[];for(const V of S){const z=D[V],x=N[V];z===void 0?l=R.edit(l,[V],void 0,c):x!==void 0?l=R.edit(l,[V],z,c):F.push(n(V,C))}F.sort((V,z)=>V.startOffset-z.startOffset),F.forEach(V=>l=u(V.setting.key,w,l,c))}return l}e.updateIgnoredSettings=d;function f(l,w,S,c,C,D){const N=d(l,w,c,D),F=S!==N,V=S!==w;if(!F&&!V)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!V)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(V&&!F)return{conflictsSettings:[],localContent:d(w,l,c,D),remoteContent:null,hasConflicts:!1};if(S===null&&a(l)){const A=E(l,w,c)?null:d(w,l,c,D);return{conflictsSettings:[],localContent:A,remoteContent:null,hasConflicts:!1}}let z=l,x=w;const Q=(0,O.parse)(l),te=(0,O.parse)(w),G=S?(0,O.parse)(S):null,J=c.reduce((A,W)=>(A.add(W),A),new Set),B=h(Q,te,J),M=h(G,Q,J),X=h(G,te,J),ie=new Map,se=new Set,H=A=>{se.add(A);const W=C.filter(({key:q})=>q===A)[0];W?(z=R.edit(z,[A],W.value,D),x=R.edit(x,[A],W.value,D)):ie.set(A,{key:A,localValue:Q[A],remoteValue:te[A]})};for(const A of M.removed.values())X.updated.has(A)?H(A):x=R.edit(x,[A],void 0,D);for(const A of X.removed.values())se.has(A)||(M.updated.has(A)?H(A):z=R.edit(z,[A],void 0,D));for(const A of M.updated.values())se.has(A)||(X.updated.has(A)?B.updated.has(A)&&H(A):x=R.edit(x,[A],Q[A],D));for(const A of X.updated.values())se.has(A)||(M.updated.has(A)?B.updated.has(A)&&H(A):z=R.edit(z,[A],te[A],D));for(const A of M.added.values())se.has(A)||(X.added.has(A)?B.updated.has(A)&&H(A):x=u(A,z,x,D));for(const A of X.added.values())se.has(A)||(M.added.has(A)?B.updated.has(A)&&H(A):z=u(A,x,z,D));const Z=ie.size>0||!E(z,x,c),$=Z||!E(z,l,[]),g=Z||!E(x,w,[]);return{localContent:$?z:null,remoteContent:g?x:null,conflictsSettings:[...ie.values()],hasConflicts:Z}}e.merge=f;function E(l,w,S){if(l===w)return!0;const c=(0,O.parse)(l),C=(0,O.parse)(w),D=S.reduce((V,z)=>(V.add(z),V),new Set),N=o(l).filter(V=>!(V.setting&&D.has(V.setting.key))),F=o(w).filter(V=>!(V.setting&&D.has(V.setting.key)));if(N.length!==F.length)return!1;for(let V=0;V<N.length;V++){const z=N[V],x=F[V];if(z.setting&&x.setting){if(z.setting.key!==x.setting.key||!T.equals(c[z.setting.key],C[z.setting.key]))return!1}else if(!z.setting&&!x.setting){if(z.value!==x.value)return!1}else return!1}return!0}function a(l){return l?o(l).length===0:!0}e.isEmpty=a;function h(l,w,S){const c=l?Object.keys(l).filter(V=>!S.has(V)):[],C=Object.keys(w).filter(V=>!S.has(V)),D=C.filter(V=>!c.includes(V)).reduce((V,z)=>(V.add(z),V),new Set),N=c.filter(V=>!C.includes(V)).reduce((V,z)=>(V.add(z),V),new Set),F=new Set;if(l)for(const V of c){if(N.has(V))continue;const z=l[V],x=w[V];T.equals(z,x)||F.add(V)}return{added:D,removed:N,updated:F}}function u(l,w,S,c){const C=(0,O.parse)(w),D=o(w),N=o(S),F=b(l,D,N);return y(S,l,C[l],F,N,c)}e.addSetting=u;function b(l,w,S){const c=w.findIndex(D=>D.setting?.key===l),C=w[c-1];if(C){if(C.setting){const N=n(C.setting.key,S);if(N)return{index:S.indexOf(N),insertAfter:!0}}else{const N=r(c,w);if(N){const F=n(N.setting.key,S);if(F){const V=t(S.indexOf(F),S),z=i(w,N,w[c]);if(V){const x=i(S,F,V),Q=s(z,x);return Q?{index:S.indexOf(Q),insertAfter:!0}:{index:S.indexOf(V),insertAfter:!1}}else{const x=i(S,F,S[S.length-1]),Q=s(z,x);return Q?{index:S.indexOf(Q),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const D=w[c+1];if(D)if(D.setting){const N=n(D.setting.key,S);if(N)return{index:S.indexOf(N),insertAfter:!1}}else{const N=t(c,w);if(N){const F=n(N.setting.key,S);if(F){const V=r(S.indexOf(F),S),z=i(w,w[c],N);if(V){const x=i(S,V,F),Q=s(z.reverse(),x.reverse());return Q?{index:S.indexOf(Q),insertAfter:!1}:{index:S.indexOf(V),insertAfter:!0}}else{const x=i(S,S[0],F),Q=s(z.reverse(),x.reverse());return Q?{index:S.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function y(l,w,S,c,C,D){let N;return c.index===-1?N=(0,_.setProperty)(l,[w],S,D):N=k(l,w,S,c,C,D).map(F=>(0,_.withFormatting)(l,F,D)[0]),(0,_.applyEdits)(l,N)}function k(l,w,S,c,C,D){const N=`${JSON.stringify(w)}: ${JSON.stringify(S)}`,F=(0,U.getEOL)(D,l),V=C[c.index];if(c.insertAfter){const z=[];if(V.setting)z.push({offset:V.endOffset,length:0,content:","+N});else{const x=t(c.index,C),Q=r(c.index,C),te=Q?.setting?.commaOffset;Q&&te===void 0&&z.push({offset:Q.endOffset,length:0,content:","});const G=te!==void 0&&te>V.endOffset;z.push({offset:G?te+1:V.endOffset,length:0,content:x?F+N+",":F+N})}return z}else{if(V.setting)return[{offset:V.startOffset,length:0,content:N+","}];const z=(C[c.index-1]&&!C[c.index-1].setting?F:"")+N+(t(c.index,C)?",":"")+F;return[{offset:V.startOffset,length:0,content:z}]}}function n(l,w){return w.filter(S=>S.setting?.key===l)[0]}function r(l,w){for(let S=l-1;S>=0;S--)if(w[S].setting)return w[S]}function t(l,w){for(let S=l+1;S<w.length;S++)if(w[S].setting)return w[S]}function i(l,w,S){const c=l.indexOf(w),C=l.indexOf(S);return l.filter((D,N)=>c<N&&N<C)}function s(l,w){if(l.length&&w.length){let S=0;for(;S<w.length&&S<l.length;S++)if(l[S].value!==w[S].value)return w[S-1];return w[S-1]}}function o(l){const w=[];let S=-1,c,C;const D={onObjectBegin:N=>{S++},onObjectProperty:(N,F,V)=>{S===0&&(c=F,C=N)},onObjectEnd:(N,F)=>{S--,S===0&&w.push({startOffset:c,endOffset:N+F,value:l.substring(c,N+F),setting:{key:C,commaOffset:void 0}})},onArrayBegin:(N,F)=>{S++},onArrayEnd:(N,F)=>{S--,S===0&&w.push({startOffset:c,endOffset:N+F,value:l.substring(c,N+F),setting:{key:C,commaOffset:void 0}})},onLiteralValue:(N,F,V)=>{S===0&&w.push({startOffset:c,endOffset:F+V,value:l.substring(c,F+V),setting:{key:C,commaOffset:void 0}})},onSeparator:(N,F,V)=>{if(S===0&&N===","){let z=w.length-1;for(;z>=0&&!w[z].setting;z--);const x=w[z];x&&w.splice(z,1,{startOffset:x.startOffset,endOffset:x.endOffset,value:x.value,setting:{key:x.setting.key,commaOffset:F}})}},onComment:(N,F)=>{S===0&&w.push({startOffset:N,endOffset:N+F,value:l.substring(N,N+F)})}};return(0,O.visit)(l,D),w}}),define(oe[77],ae([0,1,3,2,4,23]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,_.createDecorator)("IUserDataSyncAccountService");let T=e.UserDataSyncAccountService=class extends O.Disposable{get account(){return this._account}constructor(I,m){super(),this.userDataSyncStoreService=I,this.logService=m,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};e.UserDataSyncAccountService=T=pe([Y(0,U.IUserDataSyncStoreService),Y(1,U.IUserDataSyncLogService)],T)}),define(oe[232],ae([0,1,2,12]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class _{constructor(v){this.service=v}listen(v,d){switch(d){case"onError":return this.service.onError}throw new Error(`Event not found: ${d}`)}call(v,d,f){switch(d){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=_;class U{constructor(v){this.service=v}listen(v,d){throw new Error(`Event not found: ${d}`)}call(v,d,f){switch(d){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(O.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=U;class T{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(v){this.service=v}listen(v,d){switch(d){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${d}`)}async call(v,d,f){switch(d){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class I{constructor(v){this.service=v}listen(v,d){switch(d){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(v,d,f){switch(d){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class m{constructor(v){this.service=v}listen(v,d){switch(d){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(v,d,f){switch(d){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=m;class P extends L.Disposable{constructor(v){super(),this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:O.URI.revive(v.url),type:v.type,defaultUrl:O.URI.revive(v.defaultUrl),insidersUrl:O.URI.revive(v.insidersUrl),stableUrl:O.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(oe[233],ae([0,1,168,8,23]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let U=e.UserDataSyncLogService=class extends O.AbstractLogger{constructor(R){super(),this.logger=this._register(R.createLogger(_.USER_DATA_SYNC_LOG_ID,{name:(0,L.localize)(0,null)}))}trace(R,...I){this.logger.trace(R,...I)}debug(R,...I){this.logger.debug(R,...I)}info(R,...I){this.logger.info(R,...I)}warn(R,...I){this.logger.warn(R,...I)}error(R,...I){this.logger.error(R,...I)}flush(){this.logger.flush()}};e.UserDataSyncLogService=U=pe([Y(0,O.ILoggerService)],U)}),define(oe[234],ae([0,1,6,3,2]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class U extends _.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:I,getActiveWindowId:m}){super(),this.disposables=this._register(new _.DisposableStore),O.Event.latch(O.Event.any(R,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>m()),(async()=>{try{const p=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:p}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=U}),define(oe[112],ae([0,1,171,15,47,22,12,4,25]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function m(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=m;function P(i){return typeof i?.id=="string"&&!m(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=p;function v(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=v;function d(i){const s=i;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=d;var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function E(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function a(i){const s=i;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=a;class h{constructor(s,o,l,w,S){this._id=s,this._transient=l,this._configuration=w,this._ignorePathCasing=S,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,U.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function b(i){return new u({uri:i,index:0,name:(0,U.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(i,s){return U.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function k(i){let s;return T.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=k,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function r(i,s){return!y(i,s)&&!k(i)}e.isSavedWorkspace=r;function t(i){return(typeof i=="string"?(0,O.extname)(i):(0,U.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(oe[17],ae([0,1,63,3,2,22,12,162,14,13,4,8,112,35,29,6,32,27,10]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function b(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&T.URI.isUri(i.location)&&T.URI.isUri(i.globalStorageHome)&&T.URI.isUri(i.settingsResource)&&T.URI.isUri(i.keybindingsResource)&&T.URI.isUri(i.tasksResource)&&T.URI.isUri(i.snippetsHome)&&T.URI.isUri(i.extensionsResource))}e.isUserDataProfile=b,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function y(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:T.URI.revive(t.location).with({scheme:i}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:i}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=y;function k(t,i,s,o,l){return{id:t,name:i,location:s,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,U.joinPath)(s,"globalStorage"),settingsResource:(0,U.joinPath)(s,"settings.json"),keybindingsResource:(0,U.joinPath)(s,"keybindings.json"),tasksResource:(0,U.joinPath)(s,"tasks.json"),snippetsHome:(0,U.joinPath)(s,"snippets"),extensionsResource:(0,U.joinPath)(s,"extensions.json"),cacheHome:(0,U.joinPath)(o,t),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=k;let n=e.UserDataProfilesService=class extends _.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,s,o,l){super(),this.environmentService=i,this.fileService=s,this.uriIdentityService=o,this.logService=l,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,U.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,U.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=[];if(this.enabled)try{for(const w of this.getStoredProfiles()){if(!w.name||!(0,u.isString)(w.name)||!w.location){this.logService.warn("Skipping the invalid stored profile",w.location||w.name);continue}i.push(k((0,U.basename)(w.location),w.name,w.location,this.profilesCacheHome,{shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}))}}catch(w){this.logService.error(w)}const s=new d.ResourceMap,o=new Map,l=this.createDefaultProfile();if(i.unshift({...l,extensionsResource:this.getDefaultProfileExtensionsLocation()??l.extensionsResource,isDefault:!0}),i.length)try{const w=this.getStoredProfileAssociations();if(w.workspaces)for(const[S,c]of Object.entries(w.workspaces)){const C=T.URI.parse(S),D=i.find(N=>N.id===c);D&&s.set(C,D)}if(w.emptyWindows)for(const[S,c]of Object.entries(w.emptyWindows)){const C=i.find(D=>D.id===c);C&&o.set(S,C)}}catch(w){this.logService.error(w)}this._profilesObject={profiles:i,workspaces:s,emptyWindows:o}}return this._profilesObject}createDefaultProfile(){return k("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(i){const s="Temp",o=new RegExp(`${(0,h.escapeRegExpCharacters)(s)}\\s(\\d+)`);let l=0;for(const S of this.profiles){const c=o.exec(S.name),C=c?parseInt(c[1]):0;l=C>l?C:l}const w=`${s} ${l+1}`;return this.createProfile((0,L.hash)((0,a.generateUuid)()).toString(16),w,{transient:!0},i)}async createNamedProfile(i,s,o){return this.createProfile((0,L.hash)((0,a.generateUuid)()).toString(16),i,s,o)}async createProfile(i,s,o,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const w=await this.doCreateProfile(i,s,o);return l&&await this.setProfileForWorkspace(l,w),w}async doCreateProfile(i,s,o){if(!(0,u.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.profileCreationPromises.get(s);return l||(l=(async()=>{try{const w=this.profiles.find(C=>C.name===s||C.id===i);if(w)return w;const S=k(i,s,(0,U.joinPath)(this.profilesHome,i),this.profilesCacheHome,o);await this.fileService.createFolder(S.location);const c=[];return this._onWillCreateProfile.fire({profile:S,join(C){c.push(C)}}),await E.Promises.settled(c),this.updateProfiles([S],[],[]),S}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,l)),l}async updateProfile(i,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=k(o.id,s.name??o.name,o.location,this.profilesCacheHome,{shortName:s.shortName??o.shortName,transient:s.transient??o.isTransient,useDefaultFlags:s.useDefaultFlags??o.useDefaultFlags}),this.updateProfiles([],[],[o]),o}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(l=>l.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:s,join(l){o.push(l)}});try{await Promise.allSettled(o)}catch(l){this.logService.error(l)}for(const l of[...this.profilesObject.emptyWindows.keys()])s.id===this.profilesObject.emptyWindows.get(l)?.id&&this.profilesObject.emptyWindows.delete(l);for(const l of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{await this.fileService.del(s.cacheHome,{recursive:!0})}catch(l){(0,m.toFileOperationResult)(l)!==1&&this.logService.error(l)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(l){this.logService.error(l)}}async setProfileForWorkspace(i,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(l=>l.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(i,o)}unsetWorkspace(i,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.getWorkspace(i);return T.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindows.get(s)??this.profilesObject.emptyWindows.get(s)}getWorkspace(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location))||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location)))}updateProfiles(i,s,o){const l=[...this.profiles,...i],w=[];this.transientProfilesObject.profiles=[];for(let S of l)S.isDefault||s.some(c=>S.id===c.id)||(S=o.find(c=>S.id===c.id)??S,S.isTransient?this.transientProfilesObject.profiles.push(S):w.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.saveStoredProfiles(w),this._profilesObject=void 0,this.triggerProfilesChanges(i,s,o)}triggerProfilesChanges(i,s,o){this._onDidChangeProfiles.fire({added:i,removed:s,updated:o,all:this.profiles})}updateWorkspaceAssociation(i,s,o){o=s?.isTransient?!0:o,o||this.updateWorkspaceAssociation(i,void 0,!0);const l=this.getWorkspace(i),w=o?this.transientProfilesObject:this.profilesObject;T.URI.isUri(l)?(w.workspaces.delete(l),s&&w.workspaces.set(l,s)):(w.emptyWindows.delete(l),s&&w.emptyWindows.set(l,s)),o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[o,l]of this.profilesObject.workspaces.entries())i[o.toString()]=l.id;const s={};for(const[o,l]of this.profilesObject.emptyWindows.entries())s[o.toString()]=l.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:s}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const s={},o=this.createDefaultProfile();if(i.workspaces)for(const[w,S]of Object.entries(i.workspaces)){const c=T.URI.parse(S);s[w]=this.uriIdentityService.extUri.isEqual(c,o.location)?o.id:this.uriIdentityService.extUri.basename(c)}const l={};if(i.emptyWindows)for(const[w,S]of Object.entries(i.emptyWindows)){const c=T.URI.parse(S);l[w]=this.uriIdentityService.extUri.isEqual(c,o.location)?o.id:this.uriIdentityService.extUri.basename(c)}return{workspaces:s,emptyWindows:l}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=n=pe([Y(0,I.IEnvironmentService),Y(1,m.IFileService),Y(2,f.IUriIdentityService),Y(3,p.ILogService)],n);class r extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=r}),define(oe[235],ae([0,1,6,2,17]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let U=e.UserDataProfilesCleaner=class extends O.Disposable{constructor(R){super(),this._register(new L.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=U=pe([Y(0,_.IUserDataProfilesService)],U)}),define(oe[236],ae([0,1,21,6,26,7,3,2,5,10,12,145,28,33,49,8,24,20,17]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let b=e.AbstractExtensionManagementService=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,s,o,l,w){super(),this.galleryService=i,this.telemetryService=s,this.logService=o,this.productService=l,this.userDataProfilesService=w,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:S})=>S.cancel()),this.uninstallingExtensions.forEach(S=>S.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,v.isTargetPlatformCompatible)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{if(!this.galleryService.isEnabled())throw new v.ExtensionManagementError(p.localize(0,null),v.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(i,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,s)}catch(o){throw n(this.telemetryService,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(i),error:o}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(o),k(o)}}async uninstall(i,s={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,s)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,s,o){const l=o.isApplicationScoped||o.isBuiltin||(0,f.isApplicationScopedExtension)(i),w={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(s)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:l,profileLocation:l?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},S=V=>`${d.ExtensionKey.create(V).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!P.URI.isUri(s)){const V=this.installingExtensions.get(S(s));if(V)return this.logService.info("Extensions is already requested to install",s.identifier.id),V.task.waitUntilTaskIsFinished()}const c=[],C=[],D=[],N=this.createInstallExtensionTask(i,s,w);P.URI.isUri(s)||this.installingExtensions.set(S(s),{task:N,waitingTasks:[]}),this._onInstallExtension.fire({identifier:N.identifier,source:s,profileLocation:w.profileLocation}),this.logService.info("Installing extension:",N.identifier.id),c.push({task:N,manifest:i});let F=!1;try{if(w.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const z=await this.getAllDepsAndPackExtensions(N.identifier,i,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),x=await this.getInstalled(void 0,w.profileLocation);for(const{gallery:Q,manifest:te}of(0,L.distinct)(z,({gallery:G})=>G.identifier.id)){F=F||!!te.extensionDependencies?.some(B=>(0,d.areSameExtensions)({id:B},N.identifier));const G=S(Q),J=this.installingExtensions.get(G);if(J){if(this.canWaitForTask(N,J.task)){const B=J.task.identifier;this.logService.info("Waiting for already requested installing extension",B.id,N.identifier.id),J.waitingTasks.push(N),C.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,M=>M.some(X=>(0,d.areSameExtensions)(X.identifier,B)))).then(M=>{if(this.logService.info("Finished waiting for already requested installing extension",B.id,N.identifier.id),!M.find(ie=>(0,d.areSameExtensions)(ie.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!x.some(({identifier:B})=>(0,d.areSameExtensions)(B,Q.identifier))){const B=this.createInstallExtensionTask(te,Q,{...w,donotIncludePackAndDependencies:!0});this.installingExtensions.set(G,{task:B,waitingTasks:[N]}),this._onInstallExtension.fire({identifier:B.identifier,source:Q,profileLocation:w.profileLocation}),this.logService.info("Installing extension:",B.identifier.id,N.identifier.id),c.push({task:B,manifest:te})}}}catch(z){if(P.URI.isUri(N.source))(0,L.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",N.identifier.id,z.message),(0,L.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",N.identifier.id,z.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),z}const V=c.reduce((z,{task:x,manifest:Q})=>(z.set(x.identifier.id.toLowerCase(),{task:x,manifest:Q}),z),new Map);for(;V.size;){let z;const x=[...V.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(te=>V.has(te.toLowerCase())));x.length?z=V.size===1?x:x.filter(({task:Q})=>!(Q===N&&!F)):(this.logService.info("Found extensions with circular dependencies",x.map(({task:Q})=>Q.identifier.id)),z=[...V.values()]),await this.joinAllSettled(z.map(async({task:Q})=>{const te=new Date().getTime();try{const G=await Q.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(G,Q.source,w,_.CancellationToken.None))),!P.URI.isUri(Q.source)){const J=Q.operation===3,B=J?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(n(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-te,durationSinceUpdate:B}),I.isWeb&&Q.operation!==3)try{await this.galleryService.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}D.push({local:G,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:w.context,profileLocation:Q.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw P.URI.isUri(Q.source)||n(this.telemetryService,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-te,error:G}),this.logService.error("Error while installing the extension:",Q.identifier.id),G}finally{V.delete(Q.identifier.id.toLowerCase())}}))}return C.length&&await this.joinAllSettled(C),D.forEach(({identifier:z})=>this.logService.info("Extension installed successfully:",z.id)),this._onDidInstallExtensions.fire(D),D.filter(({identifier:z})=>(0,d.areSameExtensions)(z,N.identifier))[0].local}catch(V){if(c.forEach(({task:z})=>z.cancel()),D.length)try{const z=await Promise.allSettled(D.map(({local:x})=>this.createUninstallExtensionTask(x,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let x=0;x<z.length;x++){const Q=z[x],{identifier:te}=D[x];Q.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",te.id):this.logService.warn("Rollback: Error while uninstalling extension",te.id,(0,U.getErrorMessage)(Q.reason))}}catch(z){this.logService.warn("Error while rolling back extensions",(0,U.getErrorMessage)(z),D.map(({identifier:x})=>x.id))}throw this._onDidInstallExtensions.fire(c.map(({task:z})=>({identifier:z.identifier,operation:2,source:z.source,context:w.context,profileLocation:w.profileLocation}))),V}finally{for(const{task:V}of c)V.source&&!P.URI.isUri(V.source)&&this.installingExtensions.delete(S(V.source))}}canWaitForTask(i,s){for(const[,{task:o,waitingTasks:l}]of this.installingExtensions.entries())if(o===i&&(l.includes(s)||l.some(w=>this.canWaitForTask(w,s)))||o===s&&l[0]&&!this.canWaitForTask(i,l[0]))return!1;return!0}async joinAllSettled(i){const s=[],o=[],l=await Promise.allSettled(i);for(const w of l)w.status==="fulfilled"?s.push(w.value):o.push(w.reason);if(o.length)throw y(o);return s}async getAllDepsAndPackExtensions(i,s,o,l,w){if(!this.galleryService.isEnabled())return[];const S=await this.getInstalled(void 0,w),c=[],C=[],D=async(N,F)=>{c.push(N);const V=F.extensionDependencies||[],z=[...V];if(F.extensionPack){const x=o?S.find(Q=>(0,d.areSameExtensions)(Q.identifier,N)):void 0;for(const Q of F.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(te=>(0,d.areSameExtensions)({id:te},{id:Q}))||z.every(te=>!(0,d.areSameExtensions)({id:te},{id:Q}))&&z.push(Q)}if(z.length){const x=z.filter(Q=>c.every(te=>!(0,d.areSameExtensions)(te,{id:Q})));if(x.length){const Q=await this.galleryService.getExtensions(x.map(te=>({id:te,preRelease:l})),_.CancellationToken.None);for(const te of Q){if(c.find(B=>(0,d.areSameExtensions)(B,te.identifier)))continue;const G=V.some(B=>(0,d.areSameExtensions)({id:B},te.identifier));let J;try{J=await this.checkAndGetCompatibleVersion(te,!1,l)}catch(B){if(B instanceof v.ExtensionManagementError&&B.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!G){this.logService.info("Skipping the packed extension as it cannot be installed",te.identifier.id);continue}else throw B}C.push({gallery:J.extension,manifest:J.manifest}),await D(J.extension.identifier,J.manifest)}}}};return await D(i,s),C}async checkAndGetCompatibleVersion(i,s,o){if((await this.getExtensionsControlManifest()).malicious.some(c=>(0,d.areSameExtensions)(i.identifier,c)))throw new v.ExtensionManagementError(p.localize(1,null,i.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const c=await this.getTargetPlatform();throw new v.ExtensionManagementError(p.localize(2,null,i.identifier.id,this.productService.nameLong,(0,v.TargetPlatformToString)(c)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const w=await this.getCompatibleVersion(i,s,o);if(w){if(o&&!s&&i.hasPreReleaseVersion&&!w.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(p.localize(3,null,i.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],_.CancellationToken.None))[0]?new v.ExtensionManagementError(p.localize(4,null,i.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(p.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",w.identifier.id);const S=await this.galleryService.getManifest(w,_.CancellationToken.None);if(S===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(S.version!==w.version)throw new v.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:S}}async getCompatibleVersion(i,s,o){const l=await this.getTargetPlatform();let w=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(w=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},_.CancellationToken.None))[0]||null),!w&&await this.galleryService.isExtensionCompatible(i,o,l)&&(w=i),w||(s?w=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},_.CancellationToken.None))[0]||null:w=await this.galleryService.getCompatibleExtension(i,o,l)),w}async uninstallExtension(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation??this.getCurrentExtensionsManifestLocation()},l=N=>`${N.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,w=this.uninstallingExtensions.get(l(i.identifier));if(w)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),w.waitUntilTaskIsFinished();const S=N=>{const F=this.createUninstallExtensionTask(N,o);return this.uninstallingExtensions.set(l(F.extension.identifier),F),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this._onUninstallExtension.fire({identifier:N.identifier,profileLocation:o.profileLocation,applicationScoped:N.isApplicationScoped}),F},c=(N,F)=>{F?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,F.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(N),error:F}),this._onDidUninstallExtension.fire({identifier:N.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:N.isApplicationScoped})},C=[],D=[];try{C.push(S(i));const N=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(i,N);for(const V of F)this.uninstallingExtensions.has(l(V.identifier))?this.logService.info("Extensions is already requested to uninstall",V.identifier.id):C.push(S(V))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(C.map(F=>F.extension),N,i),await this.joinAllSettled(C.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(V=>V.postUninstall(F.extension,o,_.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}c(F.extension)}catch(V){const z=V instanceof v.ExtensionManagementError?V:new v.ExtensionManagementError((0,U.getErrorMessage)(V),v.ExtensionManagementErrorCode.Internal);throw c(F.extension,z),z}finally{D.push(F)}}))}catch(N){const F=N instanceof v.ExtensionManagementError?N:new v.ExtensionManagementError((0,U.getErrorMessage)(N),v.ExtensionManagementErrorCode.Internal);for(const V of C){try{V.cancel()}catch{}D.includes(V)||c(V.extension,F)}throw F}finally{for(const N of C)this.uninstallingExtensions.delete(l(N.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}checkForDependents(i,s,o){for(const l of i){const w=this.getDependents(l,s);if(w.length){const S=w.filter(c=>!i.some(C=>(0,d.areSameExtensions)(C.identifier,c.identifier)));if(S.length)throw new Error(this.getDependentsErrorMessage(l,S,o))}}}getDependentsErrorMessage(i,s,o){return o===i?s.length===1?p.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?p.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const w=s.filter(c=>!c.isBuiltin&&l.some(C=>(0,d.areSameExtensions)({id:C},c.identifier))),S=[];for(const c of w)S.push(...this.getAllPackExtensionsToUninstall(c,s,o));return[...w,...S]}return[]}getDependents(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,d.areSameExtensions)({id:l},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=b=pe([Y(0,v.IExtensionGalleryService),Y(1,h.ITelemetryService),Y(2,E.ILogService),Y(3,a.IProductService),Y(4,u.IUserDataProfilesService)],b);function y(t){const i=Array.isArray(t)?t:[t];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((s,o)=>new Error(`${s.message}${s.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=y;function k(t){if(t instanceof v.ExtensionManagementError)return t;const i=new v.ExtensionManagementError(t.message,v.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:o,duration:l,error:w,durationSinceUpdate:S}){let c,C;(0,m.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(c=v.ExtensionManagementErrorCode.Signature,C=o),o="Unverified")),w&&(w instanceof v.ExtensionManagementError?(c=w.code,w.code===v.ExtensionManagementErrorCode.Signature&&(C=w.message)):c=v.ExtensionManagementErrorCode.Internal),t.publicLog(i,{...s,verificationStatus:o,success:!w,duration:l,errorcode:c,errorcodeDetail:C,durationSinceUpdate:S})}class r{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>new Promise((s,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new U.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(oe[50],ae([0,1,6,16,2,3,35,12,28,33,13,4,8,17,29,10,7,20]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class b extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let y=e.AbstractExtensionsProfileScannerService=class extends _.Disposable{constructor(t,i,s,o,l,w){super(),this.extensionsLocation=t,this.fileService=i,this.userDataProfilesService=s,this.uriIdentityService=o,this.telemetryService=l,this.logService=w,this._onAddExtensions=this._register(new U.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new U.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new U.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new U.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(t,i){return this.withProfileExtensions(t,void 0,i)}async addExtensionsToProfile(t,i){const s=[],o=[];try{return await this.withProfileExtensions(i,l=>{const w=[];for(const S of l)t.some(([c])=>(0,m.areSameExtensions)(c.identifier,S.identifier)&&c.manifest.version!==S.version)?s.push(S):w.push(S);for(const[S,c]of t)if(!w.some(C=>(0,m.areSameExtensions)(C.identifier,S.identifier)&&C.version===S.manifest.version)){const C={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:c};o.push(C),w.push(C)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:i}),s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:i}),w}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:i}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:i}),o}catch(l){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:l,profileLocation:i}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const s=[];return await this.withProfileExtensions(i,o=>{const l=[];for(const w of o){const S=t.find(([c])=>(0,m.areSameExtensions)(c.identifier,w.identifier)&&c.manifest.version===w.version);S&&(w.metadata={...w.metadata,...S[1]},s.push(w)),l.push(w)}return l}),s}async removeExtensionFromProfile(t,i){const s=[];this._onRemoveExtensions.fire({extensions:s,profileLocation:i});try{await this.withProfileExtensions(i,o=>{const l=[];for(const w of o)(0,m.areSameExtensions)(w.identifier,t.identifier)?s.push(w):l.push(w);return s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:i}),l}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:o,profileLocation:i}),o}}async withProfileExtensions(t,i,s){return this.getResourceAccessQueue(t).queue(async()=>{let o=[],l;try{const w=await this.fileService.readFile(t);l=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,P.toFileOperationResult)(w)!==1)throw w;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(l=await this.migrateFromOldDefaultProfileExtensionsLocation()),!l&&s?.bailOutWhenFileNotFound)throw new b((0,a.getErrorMessage)(w),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.reportAndThrowInvalidConentError(t);let w=!1;for(const S of l){k(S)||this.reportAndThrowInvalidConentError(t);let c;if((0,E.isString)(S.relativeLocation)&&S.relativeLocation)c=this.resolveExtensionLocation(S.relativeLocation);else if((0,E.isString)(S.location))c=this.resolveExtensionLocation(S.location),w=!0,S.relativeLocation=S.location,S.location=c.toJSON();else{c=R.URI.revive(S.location);const C=this.toRelativePath(c);C&&(w=!0,S.relativeLocation=C)}o.push({identifier:S.identifier,location:c,version:S.version,metadata:S.metadata})}w&&await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(l)))}if(i){o=i(o);const w=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.toRelativePath(S.location),metadata:S.metadata}));await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(w)))}return o})}reportAndThrowInvalidConentError(t){const i=new b(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let s;try{s=(await this.fileService.readFile(t)).value.toString()}catch(l){if((0,P.toFileOperationResult)(l)===1)return;throw l}this.logService.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(w=>k(w))?o=l:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.logService.error(l)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.toFileOperationResult)(l)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw l}try{await this.fileService.del(t)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.logService.error(l)}try{await this.fileService.del(i)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.logService.error(l)}return o})()),this._migrationPromise}getResourceAccessQueue(t){let i=this.resourcesAccessQueueMap.get(t);return i||(i=new L.Queue,this.resourcesAccessQueueMap.set(t,i)),i}};e.AbstractExtensionsProfileScannerService=y=pe([Y(1,P.IFileService),Y(2,d.IUserDataProfilesService),Y(3,f.IUriIdentityService),Y(4,h.ITelemetryService),Y(5,v.ILogService)],y);function k(r){return(0,E.isObject)(r)&&(0,I.isIExtensionIdentifier)(r.identifier)&&(n(r.location)||(0,E.isString)(r.location)&&r.location)&&((0,E.isUndefined)(r.relativeLocation)||(0,E.isString)(r.relativeLocation))&&r.version&&(0,E.isString)(r.version)}function n(r){return r?(0,E.isString)(r.path)&&(0,E.isString)(r.scheme):!1}}),define(oe[78],ae([0,1,21,6,31,16,7,34,131,2,25,15,5,22,52,89,10,12,148,14,33,49,67,13,4,8,24,3,64,50,17,29,176]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k,n,r,t,i,s,o,l,w,S,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var D;(function(te){function G(J,B){if(J===B)return!0;const M=Object.keys(J),X=new Set;for(const ie of Object.keys(B))X.add(ie);if(M.length!==X.size)return!1;for(const ie of M){if(J[ie]!==B[ie])return!1;X.delete(ie)}return X.size===0}te.equals=G})(D||(e.Translations=D={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let N=e.AbstractExtensionsScannerService=class extends m.Disposable{constructor(G,J,B,M,X,ie,se,H,Z,$,g,A){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=J,this.extensionsControlLocation=B,this.currentProfile=M,this.userDataProfilesService=X,this.extensionsProfileScannerService=ie,this.fileService=se,this.logService=H,this.environmentService=Z,this.productService=$,this.uriIdentityService=g,this.instantiationService=A,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(V,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,y.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,J,B){const[M,X]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(J)]),ie=B?await this.scanExtensionsUnderDevelopment(G,[...M,...X]):[];return this.dedupExtensions(M,X,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const J=[];J.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),J.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[B,M]=await Promise.all(J);return this.applyScanOptions([...B,...M],0,G,!1)}async scanUserExtensions(G){const J=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",J);const B=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.createExtensionScannerInput(J,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,B),X=G.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ie;try{ie=await X.scanExtensions(M)}catch(se){if(se instanceof w.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ie=await X.scanExtensions(M);else throw se}return ie=await this.applyScanOptions(ie,1,G,!0),this.logService.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(G,J){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(M=>M.scheme===P.Schemas.file).map(async M=>{const X=await this.createExtensionScannerInput(M,!1,1,!0,G.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(X)).map(se=>(se.type=J.find(H=>(0,y.areSameExtensions)(H.identifier,se.identifier))?.type??se.type,this.extensionsScanner.validate(se,X)))}))).flat();return this.applyScanOptions(B,"development",G,!0)}return[]}async scanExistingExtension(G,J,B){const M=await this.createExtensionScannerInput(G,!1,J,!0,B.language,!0,void 0),X=await this.extensionsScanner.scanExtension(M);return!X||!B.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(G,J,B){const M=await this.createExtensionScannerInput(G,!1,J,!0,B.language,!0,void 0),X=await this.extensionsScanner.scanOneOrMultipleExtensions(M);return this.applyScanOptions(X,J,B,!0)}async scanMetadata(G){const J=(0,d.joinPath)(G,"package.json"),B=(await this.fileService.readFile(J)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(G,J){const B=(0,d.joinPath)(G,"package.json"),M=(await this.fileService.readFile(B)).value.toString(),X=JSON.parse(M);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,X.__metadata={...X.__metadata,...J},await this.fileService.writeFile((0,d.joinPath)(G,"package.json"),U.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof w.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(J=>[J,J.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify([])))}catch(J){(0,r.toFileOperationResult)(J)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(J))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,J,B,M){return B.includeAllVersions||(G=this.dedupExtensions(J===0?G:void 0,J===1?G:void 0,J==="development"?G:void 0,await this.getTargetPlatform(),M)),B.includeInvalid||(G=G.filter(X=>X.isValid)),G.sort((X,ie)=>{const se=p.basename(X.location.fsPath),H=p.basename(ie.location.fsPath);return se<H?-1:se>H?1:0})}dedupExtensions(G,J,B,M,X){const ie=(H,Z,$)=>{if(H.isValid&&!Z.isValid)return!1;if(H.isValid===Z.isValid){if(X&&f.gt(H.manifest.version,Z.manifest.version))return this.logService.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(f.eq(H.manifest.version,Z.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${Z.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===M)return this.logService.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return $?this.logService.warn(`Overwriting user extension ${H.location.path} with ${Z.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${Z.location.path}.`),!0},se=new k.ExtensionIdentifierMap;return G?.forEach(H=>{const Z=se.get(H.identifier.id);(!Z||ie(Z,H,!1))&&se.set(H.identifier.id,H)}),J?.forEach(H=>{const Z=se.get(H.identifier.id);if(!Z&&G&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!Z||ie(Z,H,!1))&&se.set(H.identifier.id,H)}),B?.forEach(H=>{const Z=se.get(H.identifier.id);(!Z||ie(Z,H,!0))&&se.set(H.identifier.id,H),se.set(H.identifier.id,H)}),[...se.values()]}async scanDefaultSystemExtensions(G,J){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),X=await(G&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",X.length),X}async scanDevSystemExtensions(G,J){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const M=J?await this.getBuiltInExtensionControl():{},X=[],ie=h.URI.file(p.normalize(p.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const H of B){const Z=M[H.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":X.push((0,d.joinPath)(ie,H.name));break;default:X.push(h.URI.file(Z));break}}const se=await Promise.all(X.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,G,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",se.length),(0,L.coalesce)(se)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,J,B,M,X,ie,se){const H=await this.getTranslations(X??v.language),Z=await this.getMtime(G),$=J&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,g=$?await this.getMtime($):void 0;return new F(G,Z,$,g,J,se,B,M,ie,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,X,H)}async getMtime(G){try{const J=await this.fileService.stat(G);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.AbstractExtensionsScannerService=N=pe([Y(4,S.IUserDataProfilesService),Y(5,w.IExtensionsProfileScannerService),Y(6,r.IFileService),Y(7,i.ILogService),Y(8,b.IEnvironmentService),Y(9,s.IProductService),Y(10,c.IUriIdentityService),Y(11,t.IInstantiationService)],N);class F{constructor(G,J,B,M,X,ie,se,H,Z,$,g,A,W,q,j){this.location=G,this.mtime=J,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=M,this.profile=X,this.profileScanOptions=ie,this.type=se,this.excludeObsolete=H,this.validate=Z,this.productVersion=$,this.productDate=g,this.productCommit=A,this.devMode=W,this.language=q,this.translations=j}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,J){return(0,d.isEqual)(G.location,J.location)&&G.mtime===J.mtime&&(0,d.isEqual)(G.applicationExtensionslocation,J.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&G.profile===J.profile&&_.equals(G.profileScanOptions,J.profileScanOptions)&&G.type===J.type&&G.excludeObsolete===J.excludeObsolete&&G.validate===J.validate&&G.productVersion===J.productVersion&&G.productDate===J.productDate&&G.productCommit===J.productCommit&&G.devMode===J.devMode&&G.language===J.language&&D.equals(G.translations,J.translations)}}e.ExtensionScannerInput=F;let V=class extends m.Disposable{constructor(G,J,B,M,X){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=J,this.uriIdentityService=B,this.fileService=M,this.logService=X}async scanExtensions(G){const J=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let B={};if(G.excludeObsolete&&G.type===1)try{const M=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(M)}catch{}return(0,a.isEmptyObject)(B)?J:J.filter(M=>!B[y.ExtensionKey.create(M).toString()])}async scanExtensionsFromLocation(G){const J=await this.fileService.resolve(G.location);if(!J.children?.length)return[];const B=await Promise.all(J.children.map(async M=>{if(!M.isDirectory||G.type===1&&(0,d.basename)(M.resource).indexOf(".")===0)return null;const X=new F(M.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(X)}));return(0,L.coalesce)(B).sort((M,X)=>M.location.path<X.location.path?-1:1)}async scanExtensionsFromProfile(G){let J=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){J=J.filter(M=>!M.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,G);J.push(...B)}return J}async scanExtensionsFromProfileResource(G,J,B){const M=await this.extensionsProfileScannerService.scanProfileExtensions(G,B.profileScanOptions);if(!M.length)return[];const X=await Promise.all(M.map(async ie=>{if(J(ie)){const se=new F(ie.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(se,ie.metadata)}return null}));return(0,L.coalesce)(X)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,d.joinPath)(G.location,"package.json"))){const J=await this.scanExtension(G);return J?[J]:[]}else return await this.scanExtensions(G)}catch(J){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,T.getErrorMessage)(J)),[]}}async scanExtension(G,J){try{let B=await this.scanExtensionManifest(G.location);if(B){B.publisher||(B.publisher=k.UNDEFINED_PUBLISHER),J=J??B.__metadata,delete B.__metadata;const M=(0,y.getGalleryExtensionId)(B.publisher,B.name),X=J?.id?{id:M,uuid:J.id}:{id:M},ie=J?.isSystem?0:G.type,se=ie===0||!!J?.isBuiltin;B=await this.translateManifest(G.location,B,F.createNlsConfiguration(G));const H={type:ie,identifier:X,manifest:B,location:G.location,isBuiltin:se,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return G.validate?this.validate(H,G):H}}catch(B){G.type!==0&&this.logService.error(B)}return null}validate(G,J){let B=!0;const M=(0,n.validateExtensionManifest)(J.productVersion,J.productDate,J.location,G.manifest,G.isBuiltin);for(const[X,ie]of M)X===E.default.Error&&(B=!1,this.logService.error(this.formatMessage(J.location,ie)));return G.isValid=B,G.validations=M,G}async scanExtensionManifest(G){const J=(0,d.joinPath)(G,"package.json");let B;try{B=(await this.fileService.readFile(J)).value.toString()}catch(X){return(0,r.toFileOperationResult)(X)!==1&&this.logService.error(this.formatMessage(G,(0,u.localize)(0,null,J.path,X.message))),null}let M;try{M=JSON.parse(B)}catch{const ie=[];(0,R.parse)(B,ie);for(const se of ie)this.logService.error(this.formatMessage(G,(0,u.localize)(1,null,J.path,se.offset,se.length,(0,I.getParseErrorMessage)(se.error))));return null}return(0,R.getNodeType)(M)!=="object"?(this.logService.error(this.formatMessage(G,(0,u.localize)(2,null,J.path))),null):M}async translateManifest(G,J,B){const M=await this.getLocalizedMessages(G,J,B);if(M)try{const X=[],ie=await this.resolveOriginalMessageBundle(M.default,X);if(X.length>0)return X.forEach(H=>{this.logService.error(this.formatMessage(G,(0,u.localize)(3,null,M.default?.path,(0,I.getParseErrorMessage)(H.error))))}),J;if((0,R.getNodeType)(M)!=="object")return this.logService.error(this.formatMessage(G,(0,u.localize)(4,null,M.default?.path))),J;const se=M.values||Object.create(null);return(0,C.localizeManifest)(J,se,ie)}catch{}return J}async getLocalizedMessages(G,J,B){const M=(0,d.joinPath)(G,"package.nls.json"),X=(Z,$)=>{$.forEach(g=>{this.logService.error(this.formatMessage(G,(0,u.localize)(5,null,Z?.path,(0,I.getParseErrorMessage)(g.error))))})},ie=Z=>{this.logService.error(this.formatMessage(G,(0,u.localize)(6,null,Z?.path)))},se=`${J.publisher}.${J.name}`,H=B.translations[se];if(H)try{const Z=h.URI.file(H),$=(await this.fileService.readFile(Z)).value.toString(),g=[],A=(0,R.parse)($,g);return g.length>0?(X(Z,g),{values:void 0,default:M}):(0,R.getNodeType)(A)!=="object"?(ie(Z),{values:void 0,default:M}):{values:A.contents?A.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.fileService.exists(M))return;let $;try{$=await this.findMessageBundles(G,B)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const g=(await this.fileService.readFile($.localized)).value.toString(),A=[],W=(0,R.parse)(g,A);return A.length>0?(X($.localized,A),{values:void 0,default:$.original}):(0,R.getNodeType)(W)!=="object"?(ie($.localized),{values:void 0,default:$.original}):{values:W,default:$.original}}catch{return{values:void 0,default:$.original}}}}async resolveOriginalMessageBundle(G,J){if(G)try{const B=(await this.fileService.readFile(G)).value.toString();return(0,R.parse)(B,J)}catch{}}findMessageBundles(G,J){return new Promise((B,M)=>{const X=ie=>{const se=(0,d.joinPath)(G,`package.nls.${ie}.json`);this.fileService.exists(se).then(H=>{H&&B({localized:se,original:(0,d.joinPath)(G,"package.nls.json")});const Z=ie.lastIndexOf("-");Z===-1?B({localized:(0,d.joinPath)(G,"package.nls.json"),original:null}):(ie=ie.substring(0,Z),X(ie))})};if(J.devMode||J.pseudo||!J.language)return B({localized:(0,d.joinPath)(G,"package.nls.json"),original:null});X(J.language)})}formatMessage(G,J){return`[${G.path}]: ${J}`}};V=pe([Y(1,w.IExtensionsProfileScannerService),Y(2,c.IUriIdentityService),Y(3,r.IFileService),Y(4,i.ILogService)],V);let z=class extends V{constructor(G,J,B,M,X,ie,se){super(J,M,X,ie,se),this.currentProfile=G,this.userDataProfilesService=B,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const J=this.getCacheFile(G),B=await this.readExtensionCache(J);if(this.input=G,B&&B.input&&F.equals(B.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(X=>(X.location=h.URI.revive(X.location),X));const M=await super.scanExtensions(G);return await this.writeExtensionCache(J,{input:G,result:M}),M}async readExtensionCache(G){try{const J=await this.fileService.readFile(G),B=JSON.parse(J.value.toString());return{result:B.result,input:(0,l.revive)(B.input)}}catch(J){this.logService.debug("Error while reading the extension cache file:",G.path,(0,T.getErrorMessage)(J))}return null}async writeExtensionCache(G,J){try{await this.fileService.writeFile(G,U.VSBuffer.fromString(JSON.stringify(J)))}catch(B){this.logService.debug("Error while writing the extension cache file:",G.path,(0,T.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const G=this.getCacheFile(this.input),J=await this.readExtensionCache(G);if(!J)return;const B=J.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!_.equals(M,B))try{this.logService.info("Invalidating Cache",B,M),await this.fileService.del(G),this._onDidChangeCache.fire()}catch(X){this.logService.error(X)}}getCacheFile(G){const J=this.getProfile(G);return this.uriIdentityService.extUri.joinPath(J.cacheHome,G.type===0?k.BUILTIN_MANIFEST_CACHE_FILE:k.USER_MANIFEST_CACHE_FILE)}getProfile(G){return G.type===0?this.userDataProfilesService.defaultProfile:G.profile?this.uriIdentityService.extUri.isEqual(G.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(J=>this.uriIdentityService.extUri.isEqual(G.location,J.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};z=pe([Y(2,S.IUserDataProfilesService),Y(3,w.IExtensionsProfileScannerService),Y(4,c.IUriIdentityService),Y(5,r.IFileService),Y(6,i.ILogService)],z);function x(te,G){const J=(0,y.getExtensionId)(te.manifest.publisher,te.manifest.name);return{id:J,identifier:new k.ExtensionIdentifier(J),isBuiltin:te.type===0,isUserBuiltin:te.type===1&&te.isBuiltin,isUnderDevelopment:G,extensionLocation:te.location,uuid:te.identifier.uuid,targetPlatform:te.targetPlatform,...te.manifest}}e.toExtensionDescription=x;class Q extends N{constructor(G,J,B,M,X,ie,se,H,Z,$,g,A){super(G,J,(0,d.joinPath)(B,".vscode-oss-dev","extensions","control.json"),M,X,ie,se,H,Z,$,g,A),this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const W=await this.fileService.readFile(h.URI.file(v.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=Q}),define(oe[237],ae([0,1,65,6,38,3,2,25,15,30,8,17]),function(ne,e,L,O,_,U,T,R,I,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=e.ExtensionsLifecycle=class extends T.Disposable{constructor(f,E){super(),this.userDataProfilesService=f,this.logService=E,this.processesLimiter=new O.Limiter(5)}async postUninstall(f){const E=this.parseScript(f,"uninstall");E&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(E.script,"uninstall",E.args,!0,f),this.logService.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(a){this.logService.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.logService.error(a)}}));try{await m.Promises.rm(this.getExtensionStoragePath(f))}catch(a){this.logService.error("Error while removing extension storage path",f.identifier.id),this.logService.error(a)}}parseScript(f,E){const a=`vscode:${E}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[a]=="string"){const h=f.manifest.scripts[a].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${a} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(f,E,a,h,u){return new Promise((b,y)=>{const k=this.start(f,E,a,u);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?y(t):b(void 0)};k.on("error",t=>{r((0,_.toErrorMessage)(t)||"Unknown")}),k.on("exit",(t,i)=>{r(t?`post-${E} process exited with code ${t}`:void 0)}),h&&(n=setTimeout(()=>{n=null,k.kill(),y("timed out")},5e3))})}start(f,E,a,h){const u={silent:!0,execArgv:void 0},b=(0,L.fork)(f,[`--type=extension-post-${E}`,...a],u);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const y=U.Event.fromNodeEventEmitter(b.stdout,"data"),k=U.Event.fromNodeEventEmitter(b.stderr,"data");y(t=>this.logService.info(h.identifier.id,h.manifest.version,`post-${E}`,t)),k(t=>this.logService.error(h.identifier.id,h.manifest.version,`post-${E}`,t));const n=U.Event.any(U.Event.map(y,t=>({data:`%c${t}`,format:[""]})),U.Event.map(k,t=>({data:`%c${t}`,format:["color: red"]})));return U.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),b}getExtensionStoragePath(f){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=v=pe([Y(0,p.IUserDataProfilesService),Y(1,P.ILogService)],v)}),define(oe[238],ae([0,1,8,17,29,20,50,13,14,12]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=e.ExtensionsProfileScannerService=class extends T.AbstractExtensionsProfileScannerService{constructor(v,d,f,E,a,h){super(m.URI.file(v.extensionsPath),d,f,E,a,h)}};e.ExtensionsProfileScannerService=P=pe([Y(0,I.INativeEnvironmentService),Y(1,R.IFileService),Y(2,O.IUserDataProfilesService),Y(3,_.IUriIdentityService),Y(4,U.ITelemetryService),Y(5,L.ILogService)],P)}),define(oe[239],ae([0,1,12,14,50,78,13,4,8,24,29,17]),function(ne,e,L,O,_,U,T,R,I,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=e.ExtensionsScannerService=class extends U.NativeExtensionsScannerService{constructor(f,E,a,h,u,b,y,k){super(L.URI.file(u.builtinExtensionsPath),L.URI.file(u.extensionsPath),u.userHome,f.defaultProfile,f,E,a,h,u,b,y,k)}};e.ExtensionsScannerService=v=pe([Y(0,p.IUserDataProfilesService),Y(1,_.IExtensionsProfileScannerService),Y(2,T.IFileService),Y(3,I.ILogService),Y(4,O.INativeEnvironmentService),Y(5,m.IProductService),Y(6,P.IUriIdentityService),Y(7,R.IInstantiationService)],v)}),define(oe[19],ae([0,1,6,3,2,100,10,66,4,17]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var p;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function d(u){const b=u.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=d;class f extends _.Disposable{constructor(b={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=b,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new _.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,_.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,U.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,U.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,y){if(y===e.TARGET_KEY){switch(b){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:b})}else this._onDidChangeValue.fire({scope:b,key:y,target:this.getKeyTargets(b)[y]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,y,k){return this.getStorage(y)?.get(b,k)}getBoolean(b,y,k){return this.getStorage(y)?.getBoolean(b,k)}getNumber(b,y,k){return this.getStorage(y)?.getNumber(b,k)}getObject(b,y,k){return this.getStorage(y)?.getObject(b,k)}store(b,y,k,n){if((0,T.isUndefinedOrNull)(y)){this.remove(b,k);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,k,n),this.getStorage(k)?.set(b,y)})}remove(b,y){this.withPausedEmitters(()=>{this.updateKeyTarget(b,y,void 0),this.getStorage(y)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,y){const k=[],n=this.getKeyTargets(b);for(const r of Object.keys(n))n[r]===y&&k.push(r);return k}updateKeyTarget(b,y,k){const n=this.getKeyTargets(y);typeof k=="number"?n[b]!==k&&(n[b]=k,this.getStorage(y)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[b]=="number"&&(delete n[b],this.getStorage(y)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(b){switch(b){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(b){const y=this.getStorage(b);return y?d(y):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=P.NONE){this._onWillSaveState.fire({reason:b});const y=this.getStorage(-1),k=this.getStorage(0),n=this.getStorage(1);switch(b){case P.NONE:await L.Promises.settled([y?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([y?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.getStorage(-1)?.items??new Map,y=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return h(b,y,k,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(b,y){return this.emitWillSaveState(P.NONE),(0,m.isUserDataProfile)(b)?this.switchToProfile(b,y):this.switchToWorkspace(b,y)}canSwitchProfile(b,y){return!(b.id===y.id||E(y)&&E(b))}switchData(b,y,k,n){this.withPausedEmitters(()=>{if(n)for(const[r,t]of b)y.set(r,t);else{const r=new Set;for(const[t,i]of b)r.add(t),y.get(t)!==i&&this.emitDidChangeValue(k,t);for(const[t]of y.items)r.has(t)||this.emitDidChangeValue(k,t)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class a extends f{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.profileStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),this._register(this.applicationStorage.onDidChangeStorage(b=>this.emitDidChangeValue(-1,b)))}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(b){return!1}}e.InMemoryStorageService=a;async function h(u,b,y,k,n,r){const t=D=>{try{return JSON.parse(D)}catch{return D}},i=new Map,s=new Map;u.forEach((D,N)=>{i.set(N,D),s.set(N,t(D))});const o=new Map,l=new Map;b.forEach((D,N)=>{o.set(N,D),l.set(N,t(D))});const w=new Map,S=new Map;y.forEach((D,N)=>{w.set(N,D),S.set(N,t(D))}),console.group(k!==n?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const c=[];if(i.forEach((D,N)=>{c.push({key:N,value:D})}),console.table(c),console.groupEnd(),console.log(s),k!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const D=[];o.forEach((N,F)=>{D.push({key:F,value:N})}),console.table(D),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const C=[];w.forEach((D,N)=>{C.push({key:N,value:D})}),console.table(C),console.groupEnd(),console.log(S)}e.logStorage=h}),define(oe[113],ae([0,1,3,2,10,28,33,19]),function(ne,e,L,O,_,U,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=e.GlobalExtensionEnablementService=class extends O.Disposable{constructor(p,v){super(),this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new m(p)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"}))),this._register(v.onDidInstallExtensions(d=>d.forEach(({local:f,operation:E})=>{f&&E===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(p,v){return this._removeFromDisabledExtensions(p)?(this._onDidChangeEnablement.fire({extensions:[p],source:v}),!0):!1}async disableExtension(p,v){return this._addToDisabledExtensions(p)?(this._onDidChangeEnablement.fire({extensions:[p],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(U.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(p){const v=this.getDisabledExtensions();return v.every(d=>!(0,T.areSameExtensions)(d,p))?(v.push(p),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(p){const v=this.getDisabledExtensions();for(let d=0;d<v.length;d++){const f=v[d];if((0,T.areSameExtensions)(f,p))return v.splice(d,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(p){this._setExtensions(U.DISABLED_EXTENSIONS_STORAGE_PATH,p)}_getExtensions(p){return this.storageManger.get(p,0)}_setExtensions(p,v){this.storageManger.set(p,v,0)}};e.GlobalExtensionEnablementService=I=pe([Y(0,R.IStorageService),Y(1,U.IExtensionManagementService)],I);class m extends O.Disposable{constructor(p){super(),this.storageService=p,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(p.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(p,v){let d;return v===0?((0,_.isUndefinedOrNull)(this.storage[p])&&(this.storage[p]=this._get(p,v)),d=this.storage[p]):d=this._get(p,v),JSON.parse(d)}set(p,v,d){const f=JSON.stringify(v.map(({id:a,uuid:h})=>({id:a,uuid:h})));this._get(p,d)!==f&&(d===0&&(v.length?this.storage[p]=f:delete this.storage[p]),this._set(p,v.length?f:void 0,d))}onDidStorageChange(p){if(p.scope===0&&!(0,_.isUndefinedOrNull)(this.storage[p.key])&&this._get(p.key,p.scope)!==this.storage[p.key]){const d=this.get(p.key,p.scope);delete this.storage[p.key];const f=this.get(p.key,p.scope),E=d.filter(h=>!f.some(u=>(0,T.areSameExtensions)(h,u))),a=f.filter(h=>!d.some(u=>(0,T.areSameExtensions)(u,h)));(E.length||a.length)&&this._onDidChange.fire([...E,...a])}}_get(p,v){return this.storageService.get(p,v,"[]")}_set(p,v,d){v?this.storageService.store(p,v,d,1):this.storageService.remove(p,d)}}e.StorageManager=m}),define(oe[240],ae([0,1,21,26,7,5,37,10,12,18,14,28,33,67,13,8,24,56,217,19,20]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const k=U.isWeb?"web":(0,p.getTargetPlatform)(U.platform,T.arch),n="X-Market-Search-Activity-Id";var r;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...$){return String($.reduce((g,A)=>g|A,0))}var i;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class S{constructor(g=w){this.state=g}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(g,A=this.state.pageSize){return new S({...this.state,pageNumber:g,pageSize:A})}withFilter(g,...A){const W=[...this.state.criteria,...A.length?A.map(q=>({filterType:g,value:q})):[{filterType:g}]];return new S({...this.state,criteria:W})}withSortBy(g){return new S({...this.state,sortBy:g})}withSortOrder(g){return new S({...this.state,sortOrder:g})}withFlags(...g){return new S({...this.state,flags:g.reduce((A,W)=>A|W,0)})}withAssetTypes(...g){return new S({...this.state,assetTypes:g})}withSource(g){return new S({...this.state,source:g})}get raw(){const{criteria:g,pageNumber:A,pageSize:W,sortBy:q,sortOrder:j,flags:K,assetTypes:ee}=this.state;return{filters:[{criteria:g,pageNumber:A,pageSize:W,sortBy:q,sortOrder:j}],assetTypes:ee,flags:K}}get searchText(){const g=this.state.criteria.filter(A=>A.filterType===i.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(g=>String(g.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function c($,g){const A=($||[]).filter(W=>W.statisticName===g)[0];return A?A.value:0}function C($){const g="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(W=>W.assetType.indexOf(g)===0).reduce((W,q)=>{const j=F($,q.assetType);return j&&W.push([q.assetType.substring(g.length),j]),W},[])}function D($){if($.properties){const g=$.properties.filter(q=>q.key===s.Repository),A=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=g.filter(q=>A.test(q.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return F($,s.Repository)}function N($){return{uri:`${$.fallbackAssetUri}/${s.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${s.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function F($,g){return $.files.filter(W=>W.assetType===g)[0]?{uri:`${$.assetUri}/${g}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${g}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function V($,g){const A=$.properties?$.properties.filter(q=>q.key===g):[],W=A.length>0&&A[0].value;return W?W.split(",").map(q=>(0,v.adoptToGalleryExtensionId)(q)):[]}function z($){const g=$.properties?$.properties.filter(A=>A.key===o.Engine):[];return g.length>0&&g[0].value||""}function x($){const g=$.properties?$.properties.filter(A=>A.key===o.PreRelease):[];return g.length>0&&g[0].value==="true"}function Q($){const g=$.properties?$.properties.filter(W=>W.key===o.LocalizedLanguages):[],A=g.length>0&&g[0].value||"";return A?A.split(","):[]}function te($){return $.properties?.find(g=>g.key===o.SponsorLink)?.value}function G($){return $.indexOf("preview")!==-1}function J($){return $.targetPlatform?(0,p.toTargetPlatform)($.targetPlatform):"undefined"}function B($){const g=(0,L.distinct)($.versions.map(J)),A=!!$.tags?.includes(p.WEB_EXTENSION_TAG),W=g.indexOf("web");return A?W===-1&&g.push("web"):W!==-1&&g.splice(W,1),g}function M($,g){const A=(0,p.getFallbackTargetPlarforms)(g);for(let W=0;W<$.length;W++){const q=$[W];if(q.version===$[W-1]?.version){let j=W;const K=J(q);if(K===g)for(;j>0&&$[j-1].version===q.version;)j--;else if(A.includes(K))for(;j>0&&$[j-1].version===q.version&&J($[j-1])!==g;)j--;j!==W&&($.splice(W,1),$.splice(j,0,q))}}return $}e.sortExtensionVersions=M;function X($,g,A){$.telemetryData={index:g,querySource:A,queryActivityId:$.queryContext?.[n]}}function ie($,g,A,W){const q=$.versions[0],j={manifest:F(g,s.Manifest),readme:F(g,s.Details),changelog:F(g,s.Changelog),license:F(g,s.License),repository:D(g),download:N(g),icon:F(g,s.Icon),signature:F(g,s.Signature),coreTranslations:C(g)};return{identifier:{id:(0,v.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:g.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,publisherSponsorLink:te(q),description:$.shortDescription||"",installCount:c($.statistics,"install"),rating:c($.statistics,"averagerating"),ratingCount:c($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:A,assets:j,properties:{dependencies:V(g,o.Dependency),extensionPack:V(g,o.ExtensionPack),engine:z(g),localizedLanguages:Q(g),targetPlatform:J(g),isPreReleaseVersion:x(g)},hasPreReleaseVersion:x(q),hasReleaseVersion:!0,preview:G($.flags),isSigned:!!j.signature,queryContext:W}}let se=class{constructor(g,A,W,q,j,K,ee,ce){this.requestService=A,this.logService=W,this.environmentService=q,this.telemetryService=j,this.fileService=K,this.productService=ee,this.configurationService=ce;const ue=ee.extensionsGallery,fe=ue?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=fe?ue.servicePPEUrl:ue?.serviceUrl,this.extensionsGallerySearchUrl=fe?void 0:ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(ee.version,ee,this.environmentService,this.configurationService,this.fileService,g,this.telemetryService)}api(g=""){return`${this.extensionsGalleryUrl}${g}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(g,A,W){const q=O.CancellationToken.isCancellationToken(A)?{}:A,j=O.CancellationToken.isCancellationToken(A)?A:W,K=[],ee=[],ce=[],ue=[];let fe=!0;for(const Ce of g){Ce.uuid?ee.push(Ce.uuid):K.push(Ce.id);const Re=!!(Ce.version||Ce.preRelease);ce.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Re}),Ce.version&&ue.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),fe=fe&&!!Ce.hasPreRelease&&!Re}if(!ee.length&&!K.length)return[];let ve=new S().withPage(1,g.length);ee.length&&(ve=ve.withFilter(i.ExtensionId,...ee)),K.length&&(ve=ve.withFilter(i.ExtensionName,...K)),(q.queryAllVersions||fe)&&(ve=ve.withFlags(ve.flags,r.IncludeVersions)),q.source&&(ve=ve.withSource(q.source));const{extensions:Ee}=await this.queryGalleryExtensions(ve,{targetPlatform:q.targetPlatform??k,includePreRelease:ce,versions:ue,compatible:!!q.compatible},j);return q.source&&Ee.forEach((Ce,Re)=>X(Ce,Re,q.source)),Ee}async getCompatibleExtension(g,A,W){if((0,p.isNotWebExtensionInWebTargetPlatform)(g.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(g,A,W))return g;const q=new S().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,g.identifier.uuid),{extensions:j}=await this.queryGalleryExtensions(q,{targetPlatform:W,compatible:!0,includePreRelease:A},O.CancellationToken.None);return j[0]||null}async isExtensionCompatible(g,A,W){if(!(0,p.isTargetPlatformCompatible)(g.properties.targetPlatform,g.allTargetPlatforms,W)||!A&&g.properties.isPreReleaseVersion)return!1;let q=g.properties.engine;if(!q){const j=await this.getManifest(g,O.CancellationToken.None);if(!j)throw new Error("Manifest was not found");q=j.engines.vscode}return(0,d.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(g,A,W,q,j){if(!(0,p.isTargetPlatformCompatible)(J(g),q,j)||A!=="any"&&x(g)!==(A==="prerelease"))return!1;if(W)try{const K=await this.getEngine(g);if(!(0,d.isEngineValid)(K,this.productService.version,this.productService.date))return!1}catch(K){return this.logService.error(`Error while getting the engine for the version ${g.version}.`,(0,_.getErrorMessage)(K)),!1}return!0}async query(g,A){let W=g.text||"";const q=g.pageSize??50;let j=new S().withPage(1,q);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ve,Ee)=>(j=j.withFilter(i.Category,Ee||ve),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ve,Ee)=>(j=j.withFilter(i.Tag,Ee||ve),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(i.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),j=j.withFilter(i.SearchText,W)),j=j.withSortBy(0)):g.ids?j=j.withFilter(i.ExtensionId,...g.ids):g.names?j=j.withFilter(i.ExtensionName,...g.names):j=j.withSortBy(4),typeof g.sortBy=="number"&&(j=j.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(j=j.withSortOrder(g.sortOrder)),g.source&&(j=j.withSource(g.source));const K=async(fe,ve)=>{const{extensions:Ee,total:Ce}=await this.queryGalleryExtensions(fe,{targetPlatform:k,compatible:!1,includePreRelease:!!g.includePreRelease},ve);return Ee.forEach((Re,Le)=>X(Re,(fe.pageNumber-1)*fe.pageSize+Le,g.source)),{extensions:Ee,total:Ce}},{extensions:ee,total:ce}=await K(j,A),ue=async(fe,ve)=>{if(ve.isCancellationRequested)throw new _.CancellationError;const{extensions:Ee}=await K(j.withPage(fe+1),ve);return Ee};return{firstPage:ee,total:ce,pageSize:j.pageSize,getPage:ue}}async queryGalleryExtensions(g,A,W){const q=g.flags;g.flags&r.IncludeLatestVersionOnly&&g.flags&r.IncludeVersions&&(g=g.withFlags(g.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(g.flags&r.IncludeLatestVersionOnly)&&!(g.flags&r.IncludeVersions)&&(g=g.withFlags(g.flags,r.IncludeLatestVersionOnly)),A.versions?.length&&(g=g.withFlags(g.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),g=g.withFlags(g.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:j,total:K,context:ee}=await this.queryRawGalleryExtensions(g,W);if(!(g.flags&r.IncludeLatestVersionOnly)){const ve=[];for(const Ee of j){const Ce=await this.toGalleryExtensionWithCriteria(Ee,A,ee);Ce&&ve.push(Ce)}return{extensions:ve,total:K}}const ue=[],fe=new Map;for(let ve=0;ve<j.length;ve++){const Ee=j[ve],Ce={id:(0,v.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Re=(0,R.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(je=>(0,v.areSameExtensions)(je,Ce))?.includePreRelease;if(A.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(B(Ee),A.targetPlatform))continue;const Le=await this.toGalleryExtensionWithCriteria(Ee,A,ee);!Le||Le.properties.isPreReleaseVersion&&(!Re||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==A.targetPlatform&&Le.hasPreReleaseVersion?fe.set(Ee.extensionId,ve):ue.push([ve,Le])}if(fe.size){const ve=new Date().getTime(),Ee=new S().withFlags(q&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,fe.size).withFilter(i.ExtensionId,...fe.keys()),{extensions:Ce}=await this.queryGalleryExtensions(Ee,A,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ve,count:fe.size});for(const Re of Ce){const Le=fe.get(Re.identifier.uuid);ue.push([Le,Re])}}return{extensions:ue.sort((ve,Ee)=>ve[0]-Ee[0]).map(([,ve])=>ve),total:K}}async toGalleryExtensionWithCriteria(g,A,W){const q={id:(0,v.getGalleryExtensionId)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},j=A.versions?.find(ue=>(0,v.areSameExtensions)(ue,q))?.version,K=(0,R.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(ue=>(0,v.areSameExtensions)(ue,q))?.includePreRelease,ee=B(g),ce=M(g.versions,A.targetPlatform);if(A.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(ee,A.targetPlatform))return null;for(let ue=0;ue<ce.length;ue++){const fe=ce[ue];if(!(j&&fe.version!==j)){if(await this.isValidVersion(fe,K?"any":"release",A.compatible,ee,A.targetPlatform))return ie(g,fe,ee,W);if(j&&fe.version===j)return null}}return j||A.compatible?null:ie(g,g.versions[0],ee)}async queryRawGalleryExtensions(g,A){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,t(r.Unpublished));const W=await this.commonHeadersPromise,q=JSON.stringify(g.raw),j={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},K=new Date().getTime();let ee,ce,ue=0;try{if(ee=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&g.criteria.some(ve=>ve.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:j},A),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:ue};const fe=await(0,h.asJson)(ee);if(fe){const ve=fe.results[0],Ee=ve.extensions,Ce=ve.resultMetadata&&ve.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return ue=Ce&&Ce.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue,context:{[n]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(fe){throw ce=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-K,success:!!ee&&(0,h.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:ce?(0,_.isCancellationError)(ce)?"canceled":(0,_.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(g,A,W,q){if(!this.isEnabled())return;const j=U.isWeb?this.api(`/itemName/${g}.${A}/version/${W}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${g}/extensions/${A}/${W}/stats?statType=${q}`),K=U.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:K};try{await this.requestService.request({type:"POST",url:j,headers:ce},O.CancellationToken.None)}catch{}}async download(g,A,W){this.logService.trace("ExtensionGalleryService#download",g.identifier.id);const q=(0,v.getGalleryExtensionTelemetryData)(g),j=new Date().getTime(),K=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:ve}),ee=W===2?"install":W===3?"update":"",ce=ee?{uri:`${g.assets.download.uri}${I.URI.parse(g.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${g.assets.download.fallbackUri}${I.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:g.assets.download,ue=g.queryContext?.[n]?{[n]:g.queryContext[n]}:void 0,fe=await this.getAsset(ce,ue?{headers:ue}:void 0);await this.fileService.writeFile(A,fe.stream),K(new Date().getTime()-j)}async downloadSignatureArchive(g,A){if(!g.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const W=await this.getAsset(g.assets.signature);await this.fileService.writeFile(A,W.stream)}async getReadme(g,A){if(g.assets.readme){const W=await this.getAsset(g.assets.readme,{},A);return await(0,h.asTextOrError)(W)||""}return""}async getManifest(g,A){if(g.assets.manifest){const W=await this.getAsset(g.assets.manifest,{},A),q=await(0,h.asTextOrError)(W);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(g,A){const W=F(g,s.Manifest);if(!W)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},j=await this.getAsset(W,{headers:q});return await(0,h.asJson)(j)}async getCoreTranslation(g,A){const W=g.assets.coreTranslations.filter(q=>q[0]===A.toUpperCase())[0];if(W){const q=await this.getAsset(W[1]),j=await(0,h.asTextOrError)(q);return j?JSON.parse(j):null}return null}async getChangelog(g,A){if(g.assets.changelog){const W=await this.getAsset(g.assets.changelog,{},A);return await(0,h.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(g,A,W){let q=new S().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?q=q.withFilter(i.ExtensionId,g.identifier.uuid):q=q.withFilter(i.ExtensionName,g.identifier.id);const{galleryExtensions:j}=await this.queryRawGalleryExtensions(q,O.CancellationToken.None);if(!j.length)return[];const K=B(j[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(K,W))return[];const ee=[];await Promise.all(j[0].versions.map(async fe=>{try{await this.isValidVersion(fe,A?"any":"release",!0,K,W)&&ee.push(fe)}catch{}}));const ce=[],ue=new Set;for(const fe of M(ee,W))ue.has(fe.version)||(ue.add(fe.version),ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:x(fe)}));return ce}async getAsset(g,A={},W=O.CancellationToken.None){const q=await this.commonHeadersPromise,j={type:"GET"},K={...q,...A.headers||{}};A={...A,...j,headers:K};const ee=g.uri,ce=g.fallbackUri,ue={...A,url:ee};try{const fe=await this.requestService.request(ue,W);if(fe.res.statusCode===200)return fe;const ve=await(0,h.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ve}`)}catch(fe){if((0,_.isCancellationError)(fe))throw fe;const ve=(0,_.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ee,message:ve});const Ee={...A,url:ce};return this.requestService.request(Ee,W)}}async getEngine(g){let A=z(g);if(!A){const W=await this.getManifestFromRawExtensionVersion(g,O.CancellationToken.None);if(!W)throw new Error("Manifest was not found");A=W.engines.vscode}return A}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const g=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const A=await(0,h.asJson)(g),W=[],q={};if(A){for(const j of A.malicious)W.push({id:j});if(A.migrateToPreRelease)for(const[j,K]of Object.entries(A.migrateToPreRelease))(!K.engine||(0,d.isEngineValid)(K.engine,this.productService.version,this.productService.date))&&(q[j.toLowerCase()]={disallowInstall:!0,extension:{id:K.id,displayName:K.displayName,autoMigrate:{storage:!!K.migrateStorage},preRelease:!0}});if(A.deprecated)for(const[j,K]of Object.entries(A.deprecated))K&&(q[j.toLowerCase()]=(0,R.isBoolean)(K)?{}:K)}return{malicious:W,deprecated:q}}};se=pe([Y(1,h.IRequestService),Y(2,E.ILogService),Y(3,P.IEnvironmentService),Y(4,y.ITelemetryService),Y(5,f.IFileService),Y(6,a.IProductService),Y(7,m.IConfigurationService)],se);let H=e.ExtensionGalleryService=class extends se{constructor(g,A,W,q,j,K,ee,ce){super(g,A,W,q,j,K,ee,ce)}};e.ExtensionGalleryService=H=pe([Y(0,b.IStorageService),Y(1,h.IRequestService),Y(2,E.ILogService),Y(3,P.IEnvironmentService),Y(4,y.ITelemetryService),Y(5,f.IFileService),Y(6,a.IProductService),Y(7,m.IConfigurationService)],H);let Z=e.ExtensionGalleryServiceWithNoStorageService=class extends se{constructor(g,A,W,q,j,K,ee){super(void 0,g,A,W,q,j,K,ee)}};e.ExtensionGalleryServiceWithNoStorageService=Z=pe([Y(0,h.IRequestService),Y(1,E.ILogService),Y(2,P.IEnvironmentService),Y(3,y.ITelemetryService),Y(4,f.IFileService),Y(5,a.IProductService),Y(6,m.IConfigurationService)],Z)}),define(oe[79],ae([0,1,4,3,2,19,33,24,21,8,10]),function(ne,e,L,O,_,U,T,R,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const p=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=e.ExtensionStorageService=class Je extends _.Disposable{static toKey(f){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const E=p.exec(f);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(f,E){const a=await f.getInstalled(),h=[];for(const[u,b]of Je.readAllExtensionsWithKeysForSync(E)){const y=a.find(k=>(0,T.areSameExtensions)(k.identifier,{id:u}))?.manifest.version;for(const k of b)y!==k&&h.push(Je.toKey({id:u,version:k}))}for(const u of h)E.remove(u,0)}static readAllExtensionsWithKeysForSync(f){const E=new Map,a=f.keys(0,1);for(const h of a){const u=Je.fromKey(h);if(u){let b=E.get(u.id.toLowerCase());b||E.set(u.id.toLowerCase(),b=[]),b.push(u.version)}}return E}constructor(f,E,a){super(),this.storageService=f,this.productService=E,this.logService=a,this._onDidChangeExtensionStorageToSync=this._register(new O.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const E=Je.fromKey(f.key);if(E){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(E.id.toLowerCase());else{let a=this.extensionsWithKeysForSync.get(E.id.toLowerCase());a||this.extensionsWithKeysForSync.set(E.id.toLowerCase(),a=[]),a.push(E.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,P.isString)(f))return f;const E=f.manifest?f.manifest.publisher:f.publisher,a=f.manifest?f.manifest.name:f.name;return(0,T.getExtensionId)(E,a)}getExtensionState(f,E){const a=this.getExtensionId(f),h=this.getExtensionStateRaw(f,E);if(h)try{return JSON.parse(h)}catch(u){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${a}, global: ${E}): ${u}`)}}getExtensionStateRaw(f,E){const a=this.getExtensionId(f),h=this.storageService.get(a,E?0:1);return h&&h?.length>Je.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${a}, global: ${E}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(f,E,a){const h=this.getExtensionId(f);E===void 0?this.storageService.remove(h,a?0:1):this.storageService.store(h,JSON.stringify(E),a?0:1,1)}setKeysForSync(f,E){this.storageService.store(Je.toKey(f),JSON.stringify(E),0,1)}getKeysForSync(f){const E=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],a=this.storageService.get(Je.toKey(f),0),h=a?JSON.parse(a):void 0;return h&&E?(0,I.distinct)([...h,...E]):h||E}addToMigrationList(f,E){if(f!==E){const a=this.migrationList.filter(h=>!h.includes(f)&&!h.includes(E));a.push([f,E]),this.migrationList=a}}getSourceExtensionToMigrate(f){const E=this.migrationList.find(([,a])=>f===a);return E?E[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(f);if(Array.isArray(E))return E}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};v.LARGE_STATE_WARNING_THRESHOLD=512*1024,e.ExtensionStorageService=v=pe([Y(0,U.IStorageService),Y(1,R.IProductService),Y(2,m.ILogService)],v)}),define(oe[241],ae([0,1,28,13,24,14,98,54,19,20,214]),function(ne,e,L,O,_,U,T,R,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let p=e.ExtensionTipsService=class extends P.AbstractNativeExtensionTipsService{constructor(d,f,E,a,h,u,b,y){super(d.userHome,h,f,E,a,u,b,y)}};e.ExtensionTipsService=p=pe([Y(0,U.INativeEnvironmentService),Y(1,m.ITelemetryService),Y(2,L.IExtensionManagementService),Y(3,I.IStorageService),Y(4,R.INativeHostService),Y(5,T.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,_.IProductService)],p)}),define(oe[242],ae([0,1,105,3,20,14,2,8,15,65,24,5,6,101,18,158,36,19,10]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const b=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP],y="remoteTunnelSession";let k=e.RemoteTunnelService=class extends T.Disposable{constructor(t,i,s,o,l,w,S){super(),this.telemetryService=t,this.productService=i,this.environmentService=s,this.configurationService=w,this.storageService=S,this._onDidTokenFailedEmitter=new O.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new O.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeSessionEmitter=new O.Emitter,this.onDidChangeSession=this._onDidChangeSessionEmitter.event,this._initialized=!1,this._logger=this._register(o.createLogger(L.LOG_ID,{name:L.LOGGER_NAME})),this._startTunnelProcessDelayer=new v.Delayer(100),this._register(this._logger.onDidChangeLogLevel(c=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)(c)))),this._register(l.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(w.onDidChangeConfiguration(c=>{b.some(C=>c.affectsConfiguration(C))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._session=this._restoreSession(),this._tunnelStatus=L.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(t){this._tunnelStatus=t,this._onDidChangeTunnelStatusEmitter.fire(t)}setSession(t){n(t,this._session)||(this._session=t,this._onDidChangeSessionEmitter.fire(t),this._storeSession(t),t?(this._logger.info(`Session updated: ${t.accountLabel} (${t.providerId})`),t.token&&this._logger.info(`Session token updated: ${t.accountLabel} (${t.providerId})`)):this._logger.info("Session reset"))}async getSession(){return this._session}async initialize(t){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setSession(t);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(i){this._logger.error(i)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let t;p.isMacintosh?t=this.environmentService.appRoot:t=(0,I.dirname)((0,I.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,I.join)(t,"bin",`${this.productService.tunnelApplicationName}${p.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(t){if(n(t,this._session))return this._tunnelStatus;this.setSession(t);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(i){this._logger.error(i)}return this._tunnelStatus}async stopTunnel(){this.setSession(void 0),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);const t=(i,s)=>{s?this._logger.error(i):this._logger.info(i)};try{await this.runCodeTunneCommand("stop",["kill"],t)}catch(i){this._logger.error(i)}this.setTunnelStatus(L.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!this._session}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let t=!1;const i=(c,C)=>{C?this._logger.error(c):this._logger.info(c),!this.environmentService.isBuilt&&c.startsWith("   Compiling")&&this.setTunnelStatus(L.TunnelStates.connecting((0,E.localize)(0,null)))},s=this.runCodeTunneCommand("status",["status"],i);this._tunnelProcess=s;try{const c=await s;if(this._tunnelProcess!==s)return;if(t=c===0,this._logger.info(t?"Other tunnel running, attaching...":"No other tunnel running"),!t&&!this._session){this._tunnelProcess=void 0,this.setTunnelStatus(L.TunnelStates.disconnected());return}}catch(c){this._logger.error(c),this._tunnelProcess=void 0,this.setTunnelStatus(L.TunnelStates.disconnected());return}const o=this._session;if(o&&o.token){const c=o.token;this.setTunnelStatus(L.TunnelStates.connecting((0,E.localize)(1,null,o.accountLabel,o.providerId)));const C=(N,F)=>{N=N.replaceAll(c,"*".repeat(4)),i(N,F)},D=this.runCodeTunneCommand("login",["user","login","--provider",o.providerId,"--access-token",c,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],C);this._tunnelProcess=D;try{if(await D,this._tunnelProcess!==D)return}catch(N){this._logger.error(N),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(o),this.setTunnelStatus(L.TunnelStates.disconnected(o));return}}const l=this._getTunnelName();l?this.setTunnelStatus(L.TunnelStates.connecting((0,E.localize)(2,null,l))):this.setTunnelStatus(L.TunnelStates.connecting((0,E.localize)(3,null)));const w=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];l?w.push("--name",l):w.push("--random-name"),this._preventSleep()&&w.push("--no-sleep");const S=this.runCodeTunneCommand("tunnel",w,(c,C)=>{C?this._logger.error(c):this._logger.info(c);const D=c.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(D){const N={link:D[1],domain:D[2],tunnelName:D[4],isAttached:t};this.setTunnelStatus(L.TunnelStates.connected(N))}else c.match(/error refreshing token/)&&(S.cancel(),this._onDidTokenFailedEmitter.fire(o),this.setTunnelStatus(L.TunnelStates.disconnected(o)))});this._tunnelProcess=S,S.finally(()=>{S===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._session=void 0,this.setTunnelStatus(L.TunnelStates.disconnected()))})}runCodeTunneCommand(t,i,s=()=>{}){return(0,v.createCancelablePromise)(o=>new Promise((l,w)=>{o.isCancellationRequested&&l(-1);let S;const c=["ignore","pipe","pipe"];if(o.onCancellationRequested(()=>{S&&(this._logger.info(`${t} terminating(${S.pid})`),S.kill())}),!this.environmentService.isBuilt)s("Building tunnel CLI from sources and run",!1),s(`${t} Spawning: cargo run -- tunnel ${i.join(" ")}`,!1),S=(0,m.spawn)("cargo",["run","--","tunnel",...i],{cwd:(0,I.join)(this.environmentService.appRoot,"cli"),stdio:c});else{s("Running tunnel CLI",!1);const C=this.getTunnelCommandLocation();s(`${t} Spawning: ${C} tunnel ${i.join(" ")}`,!1),S=(0,m.spawn)(C,["tunnel",...i],{cwd:(0,a.homedir)(),stdio:c})}S.stdout.on("data",C=>{if(S){const D=C.toString();s(D,!1)}}),S.stderr.on("data",C=>{if(S){const D=C.toString();s(D,!0)}}),S.on("exit",C=>{S&&(s(`${t} exit(${S.pid}): + ${C} `,!1),S=void 0,l(C||0))}),S.on("error",C=>{S&&(s(`${t} error(${S.pid}): + ${C} `,!0),S=void 0,w())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let t=this.configurationService.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,a.hostname)();return t=t.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),t||void 0}_restoreSession(){try{const t=this.storageService.get(y,-1);if(t){const i=JSON.parse(t);if(i&&(0,u.isString)(i.accountLabel)&&(0,u.isString)(i.sessionId)&&(0,u.isString)(i.providerId))return i;this._logger.error("Problems restoring session from storage, invalid format",i)}}catch(t){this._logger.error("Problems restoring session from storage",t)}}_storeSession(t){if(t){const i={providerId:t.providerId,sessionId:t.sessionId,accountLabel:t.accountLabel};this.storageService.store(y,JSON.stringify(i),-1,1)}else this.storageService.remove(y,-1)}};e.RemoteTunnelService=k=pe([Y(0,_.ITelemetryService),Y(1,P.IProductService),Y(2,U.INativeEnvironmentService),Y(3,R.ILoggerService),Y(4,d.ISharedProcessLifecycleService),Y(5,f.IConfigurationService),Y(6,h.IStorageService)],k);function n(r,t){return r&&t?r.sessionId===t.sessionId&&r.providerId===t.providerId&&r.token===t.token:r===t}}),define(oe[243],ae([0,1,6,2,22,66,19,75,17]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class m extends T.AbstractStorageService{constructor(p,v,d,f){super(),this.initialWorkspace=p,this.initialProfiles=v,this.remoteService=d,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new O.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new O.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const p=this._register(new R.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),v=this._register(new U.Storage(p));return this._register(v.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d))),v}createProfileStorage(p){this.profileStorageDisposables.clear(),this.profileStorageProfile=p;let v;if((0,T.isProfileUsingDefaultStorage)(p))v=this.applicationStorage;else{const d=this.profileStorageDisposables.add(new R.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),p));v=this.profileStorageDisposables.add(new U.Storage(d))}return this.profileStorageDisposables.add(v.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),v}createWorkspaceStorage(p){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=p?.id;let v;if(p){const d=this.workspaceStorageDisposables.add(new R.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),p));v=this.workspaceStorageDisposables.add(new U.Storage(d)),this.workspaceStorageDisposables.add(v.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return v}async doInitialize(){await L.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(p){switch(p){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(p){switch(p){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,_.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(p,v){if(!this.canSwitchProfile(this.profileStorageProfile,p))return;const d=this.profileStorage,f=d.items;d!==this.applicationStorage&&await d.close(),this.profileStorage=this.createProfileStorage(p),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0,v)}async switchToWorkspace(p,v){const d=this.workspaceStorage,f=d?.items??new Map;await d?.close(),this.workspaceStorage=this.createWorkspaceStorage(p),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1,v)}hasScope(p){return(0,I.isUserDataProfile)(p)?this.profileStorageProfile.id===p.id:this.workspaceStorageId===p.id}}e.RemoteStorageService=m}),define(oe[244],ae([0,1,3,2,17,91]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class T{constructor(m,P){this.service=m,this.getUriTransformer=P}listen(m,P){const p=this.getUriTransformer(m);switch(P){case"onDidChangeProfiles":return L.Event.map(this.service.onDidChangeProfiles,v=>({all:v.all.map(d=>(0,U.transformOutgoingURIs)({...d},p)),added:v.added.map(d=>(0,U.transformOutgoingURIs)({...d},p)),removed:v.removed.map(d=>(0,U.transformOutgoingURIs)({...d},p)),updated:v.updated.map(d=>(0,U.transformOutgoingURIs)({...d},p))}))}throw new Error(`Invalid listen ${P}`)}async call(m,P,p){const v=this.getUriTransformer(m);switch(P){case"createProfile":{const d=await this.service.createProfile(p[0],p[1],p[2]);return(0,U.transformOutgoingURIs)({...d},v)}case"updateProfile":{let d=(0,_.reviveProfile)((0,U.transformIncomingURIs)(p[0],v),this.service.profilesHome.scheme);return d=await this.service.updateProfile(d,p[1]),(0,U.transformOutgoingURIs)({...d},v)}case"removeProfile":{const d=(0,_.reviveProfile)((0,U.transformIncomingURIs)(p[0],v),this.service.profilesHome.scheme);return this.service.removeProfile(d)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=T;class R extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(m,P,p){super(),this.profilesHome=P,this.channel=p,this._profiles=[],this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=m.map(v=>(0,_.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const d=v.added.map(a=>(0,_.reviveProfile)(a,this.profilesHome.scheme)),f=v.removed.map(a=>(0,_.reviveProfile)(a,this.profilesHome.scheme)),E=v.updated.map(a=>(0,_.reviveProfile)(a,this.profilesHome.scheme));this._profiles=v.all.map(a=>(0,_.reviveProfile)(a,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:f,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(m){this.enabled=m}isEnabled(){return this.enabled}async createNamedProfile(m,P,p){const v=await this.channel.call("createNamedProfile",[m,P,p]);return(0,_.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(m,P,p,v){const d=await this.channel.call("createProfile",[m,P,p,v]);return(0,_.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(m){const P=await this.channel.call("createTransientProfile",[m]);return(0,_.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(m,P){await this.channel.call("setProfileForWorkspace",[m,P])}removeProfile(m){return this.channel.call("removeProfile",[m])}async updateProfile(m,P){const p=await this.channel.call("updateProfile",[m,P]);return(0,_.reviveProfile)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(oe[58],ae([0,1,2,66,4,19,3,75,17]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,_.createDecorator)("IUserDataProfileStorageService");let m=e.AbstractUserDataProfileStorageService=class extends L.Disposable{constructor(d){super(),this.storageService=d}async readStorageData(d){return this.withProfileScopedStorageService(d,async f=>this.getItems(f))}async updateStorageData(d,f,E){return this.withProfileScopedStorageService(d,async a=>this.writeItems(a,f,E))}async withProfileScopedStorageService(d,f){if(this.storageService.hasScope(d))return f(this.storageService);const E=await this.createStorageDatabase(d),a=new p(E);try{await a.initialize();const h=await f(a);return await a.flush(),h}finally{a.dispose(),await this.closeAndDispose(E)}}getItems(d){const f=new Map,E=a=>{for(const h of d.keys(0,a))f.set(h,{value:d.get(h,0),target:a})};return E(0),E(1),f}writeItems(d,f,E){for(const[a,h]of f)d.store(a,h,0,E)}async closeAndDispose(d){try{await d.close()}finally{(0,L.isDisposable)(d)&&d.dispose()}}};e.AbstractUserDataProfileStorageService=m=pe([Y(0,U.IStorageService)],m);class P extends m{constructor(d,f,E,a){super(E),this.remoteService=d;const h=d.getChannel("profileStorageListener"),u=this._register(new L.MutableDisposable);this._onDidChange=this._register(new T.Emitter({onWillAddFirstListener:()=>{u.value=h.listen("onDidChange")(b=>{a.trace("profile storage changes",b),this._onDidChange.fire({targetChanges:b.targetChanges.map(y=>(0,I.reviveProfile)(y,f.profilesHome.scheme)),valueChanges:b.valueChanges.map(y=>({...y,profile:(0,I.reviveProfile)(y.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(d){const f=this.remoteService.getChannel("storage");return(0,U.isProfileUsingDefaultStorage)(d)?new R.ApplicationStorageDatabaseClient(f):new R.ProfileStorageDatabaseClient(f,d)}}e.RemoteUserDataProfileStorageService=P;class p extends U.AbstractStorageService{constructor(d){super({flushInterval:100}),this.profileStorage=this._register(new O.Storage(d))}doInitialize(){return this.profileStorage.init()}getStorage(d){return d===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(oe[245],ae([0,1,19,8,17,71,58]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=e.NativeUserDataProfileStorageService=class extends T.RemoteUserDataProfileStorageService{constructor(m,P,p,v){super(m,P,p,v)}};e.NativeUserDataProfileStorageService=R=pe([Y(0,U.IMainProcessService),Y(1,_.IUserDataProfilesService),Y(2,L.IStorageService),Y(3,O.ILogService)],R)}),define(oe[39],ae([0,1,21,6,16,26,3,34,2,27,10,163,18,14,13,8,44,19,20,29,23,17]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||r(w.syncData)))}e.isRemoteUserData=n;function r(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}e.isSyncData=r;function t(w,S){return`${(0,m.uppercaseFirstLetter)(w)}${S.isDefault?"":` (${S.name})`}`}e.getSyncResourceLogLabel=t;let i=e.AbstractSynchroniser=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(S,c,C,D,N,F,V,z,x,Q,te,G){super(),this.syncResource=S,this.collection=c,this.fileService=C,this.environmentService=D,this.storageService=N,this.userDataSyncStoreService=F,this.userDataSyncBackupStoreService=V,this.userDataSyncEnablementService=z,this.telemetryService=x,this.logService=Q,this.configurationService=te,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new O.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=t(S.syncResource,S.profile),this.extUri=G.extUri,this.syncFolder=this.extUri.joinPath(D.userDataSyncHome,...(0,y.getPathSegments)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,y.PREVIEW_DIR_NAME),this.lastSyncResource=(0,y.getLastSyncResourceUri)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,D,this.extUri),this.currentMachineIdPromise=(0,a.getServiceMachineId)(D,C,N)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const S=await this.syncPreviewPromise;this.syncPreviewPromise=null;const c=await this.performSync(S.remoteUserData,S.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(c)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.hasRemoteChanged(S):!0)&&this._onDidChangeLocal.fire()}}setStatus(S){this._status!==S&&(this._status=S,this._onDidChangStatus.fire(S))}async sync(S,c={}){await this._sync(S,!0,this.getUserDataSyncConfiguration(),c)}async preview(S,c,C={}){return this._sync(S,!1,c,C)}async apply(S,c={}){try{this.syncHeaders={...c};const C=await this.doApply(S);return this.setStatus(C),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(S,c,C,D){try{if(this.syncHeaders={...D},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),V=await this.getLatestRemoteUserData(S,F);return N=await this.performSync(V,F,c,C),N==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(N)}}finally{this.syncHeaders={}}}async replace(S){const c=this.parseSyncData(S);if(!c)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const C=await this.getLastSyncUserData(),D=await this.getLatestRemoteUserData(null,C),N=await this.isRemoteDataFromCurrentMachine(D),F=await this.generateSyncPreview({ref:D.ref,syncData:c},C,N,this.getUserDataSyncConfiguration(),U.CancellationToken.None),V=[];for(const z of F){const x=await this.getAcceptResult(z,z.remoteResource,void 0,U.CancellationToken.None),{remoteChange:Q}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,U.CancellationToken.None);V.push([z,{...x,remoteChange:Q!==0?Q:2}])}await this.applyResult(D,C,V,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(S){const c=await this.currentMachineIdPromise;return!!S.syncData?.machineId&&S.syncData.machineId===c}async getLatestRemoteUserData(S,c){if(c){const C=S?S[this.resource]:void 0;if(c.ref===C||C===void 0&&c.syncData===null)return c}return this.getRemoteUserData(c)}async performSync(S,c,C,D){if(S.syncData&&S.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new y.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(S,c,C,D)}catch(N){if(N instanceof y.UserDataSyncError)switch(N.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(S,c,C,D);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),c=await this.getLastSyncUserData(),this.performSync(S,c,C,D)}throw N}}async doSync(S,c,C,D){try{const N=await this.isRemoteDataFromCurrentMachine(S),F=!N&&c===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,V=C&&!F;this.syncPreviewPromise||(this.syncPreviewPromise=(0,O.createCancelablePromise)(x=>this.doGenerateSyncResourcePreview(S,c,N,V,D,x)));let z=await this.syncPreviewPromise;if(C&&F){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const x of z.resourcePreviews)z=await this.accept(x.remoteResource)||z}return this.updateConflicts(z.resourcePreviews),z.resourcePreviews.some(({mergeState:x})=>x==="conflict")?"hasConflicts":C?await this.doApply(!1):"syncing"}catch(N){throw this.syncPreviewPromise=null,N}}async merge(S){return await this.updateSyncResourcePreview(S,async c=>{const C=await this.getMergeResult(c,U.CancellationToken.None);await this.fileService.writeFile(c.previewResource,_.VSBuffer.fromString(C?.content||""));const D=C&&!C.hasConflicts?await this.getAcceptResult(c,c.previewResource,void 0,U.CancellationToken.None):void 0;return c.acceptResult=D,c.mergeState=C.hasConflicts?"conflict":D?"accepted":"preview",c.localChange=D?D.localChange:C.localChange,c.remoteChange=D?D.remoteChange:C.remoteChange,c}),this.syncPreviewPromise}async accept(S,c){return await this.updateSyncResourcePreview(S,async C=>{const D=await this.getAcceptResult(C,S,c,U.CancellationToken.None);return C.acceptResult=D,C.mergeState="accepted",C.localChange=D.localChange,C.remoteChange=D.remoteChange,C}),this.syncPreviewPromise}async discard(S){return await this.updateSyncResourcePreview(S,async c=>{const C=await this.getMergeResult(c,U.CancellationToken.None);return await this.fileService.writeFile(c.previewResource,_.VSBuffer.fromString(C.content||"")),c.acceptResult=void 0,c.mergeState="preview",c.localChange=C.localChange,c.remoteChange=C.remoteChange,c}),this.syncPreviewPromise}async updateSyncResourcePreview(S,c){if(!this.syncPreviewPromise)return;let C=await this.syncPreviewPromise;const D=C.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:V})=>this.extUri.isEqual(N,S)||this.extUri.isEqual(F,S)||this.extUri.isEqual(V,S));D!==-1&&(this.syncPreviewPromise=(0,O.createCancelablePromise)(async N=>{const F=[...C.resourcePreviews];return F[D]=await c(F[D]),{...C,resourcePreviews:F}}),C=await this.syncPreviewPromise,this.updateConflicts(C.resourcePreviews),C.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(S){if(!this.syncPreviewPromise)return"idle";const c=await this.syncPreviewPromise;return c.resourcePreviews.some(({mergeState:C})=>C==="conflict")?"hasConflicts":c.resourcePreviews.some(({mergeState:C})=>C!=="accepted")?"syncing":(await this.applyResult(c.remoteUserData,c.lastSyncUserData,c.resourcePreviews.map(C=>[C,C.acceptResult]),S),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(S){const c=S.filter(({mergeState:C})=>C==="conflict");(0,L.equals)(this._conflicts,c,(C,D)=>this.extUri.isEqual(C.previewResource,D.previewResource))||(this._conflicts=c,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async resolvePreviewContent(S){const c=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(c)for(const C of c.resourcePreviews){if(this.extUri.isEqual(C.acceptedResource,S))return C.acceptResult?C.acceptResult.content:null;if(this.extUri.isEqual(C.remoteResource,S))return C.remoteContent;if(this.extUri.isEqual(C.localResource,S))return C.localContent;if(this.extUri.isEqual(C.baseResource,S))return C.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(S){(0,f.toFileOperationResult)(S)!==1&&this.logService.error(S)}}async doGenerateSyncResourcePreview(S,c,C,D,N,F){const V=await this.generateSyncPreview(S,c,C,N,F),z=[];for(const x of V){const Q=x.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)z.push({...x,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const te=D?await this.getMergeResult(x,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile(x.previewResource,_.VSBuffer.fromString(te?.content||""));const G=te&&!te.hasConflicts?await this.getAcceptResult(x,x.previewResource,void 0,F):void 0;z.push({...x,acceptResult:G,mergeState:te?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:te?te.localChange:x.localChange,remoteChange:G?G.remoteChange:te?te.remoteChange:x.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:c,resourcePreviews:z,isLastSyncFromCurrentMachine:C}}async getLastSyncUserData(){let S=this.getStoredLastSyncUserDataStateContent();if(S||(S=await this.migrateLastSyncUserData()),!S)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const c=JSON.parse(S),C=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!c.version&&!!C&&c.version!==C,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${c.version} is not compatible with current sync state version ${C}.`),await this.resetLocal(),null;let D,N=1;for(;D===void 0&&N++<6;)try{const F=await this.readLastSyncStoredRemoteUserData();F&&(F.ref===c.ref?D=F.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof f.FileOperationError&&F.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(F instanceof y.UserDataSyncError)throw F;this.logService.error(F,N)}}if(D===void 0)try{const F=await this.userDataSyncStoreService.resolveResourceContent(this.resource,c.ref,this.collection,this.syncHeaders);D=F===null?null:this.parseSyncData(F),await this.writeLastSyncStoredRemoteUserData({ref:c.ref,syncData:D})}catch(F){if(F instanceof y.UserDataSyncError&&F.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw F}return D===void 0?null:{...c,syncData:D}}async updateLastSyncUserData(S,c={}){if(c.ref||c.version)throw new Error("Cannot have core properties as additional");const C=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),D={ref:S.ref,version:C,...c};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(D),-1,1),await this.writeLastSyncStoredRemoteUserData(S)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const S=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const c=S?JSON.parse(S):void 0;if(n(c))return c}catch(c){this.logService.error(c)}}async writeLastSyncStoredRemoteUserData(S){await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(S)))}async migrateLastSyncUserData(){try{const S=await this.fileService.readFile(this.lastSyncResource),c=JSON.parse(S.value.toString());await this.fileService.del(this.lastSyncResource),c.ref&&c.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...c,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:c.ref,syncData:c.content===null?null:JSON.parse(c.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,c)}catch(S){S instanceof f.FileOperationError&&S.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(S)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(S){const{ref:c,content:C}=await this.getUserData(S);let D=null;return C!==null&&(D=this.parseSyncData(C)),{ref:c,syncData:D}}parseSyncData(S){try{const c=JSON.parse(S);if(r(c))return c}catch(c){this.logService.error(c)}throw new y.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(S){const c=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,c,this.collection,this.syncHeaders)}async updateRemoteUserData(S,c){const C=await this.currentMachineIdPromise,D={version:this.version,machineId:C,content:S};try{return c=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(D),c,this.collection,this.syncHeaders),{ref:c,syncData:D}}catch(N){throw N instanceof y.UserDataSyncError&&N.code==="TooLarge"&&(N=new y.UserDataSyncError(N.message,N.code,this.resource)),N}}async backupLocal(S){const c={version:this.version,content:S};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(c))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i=pe([Y(2,f.IFileService),Y(3,d.IEnvironmentService),Y(4,h.IStorageService),Y(5,y.IUserDataSyncStoreService),Y(6,y.IUserDataSyncBackupStoreService),Y(7,y.IUserDataSyncEnablementService),Y(8,u.ITelemetryService),Y(9,y.IUserDataSyncLogService),Y(10,v.IConfigurationService),Y(11,b.IUriIdentityService)],i);let s=e.AbstractFileSynchroniser=class extends i{constructor(S,c,C,D,N,F,V,z,x,Q,te,G,J){super(c,C,D,N,F,V,z,x,Q,te,G,J),this.file=S,this._register(this.fileService.watch(this.extUri.dirname(S))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(S,c,C){try{c?await this.fileService.writeFile(this.file,_.VSBuffer.fromString(S),C?void 0:c):await this.fileService.createFile(this.file,_.VSBuffer.fromString(S),{overwrite:C})}catch(D){throw D instanceof f.FileOperationError&&D.fileOperationResult===1||D instanceof f.FileOperationError&&D.fileOperationResult===3?new y.UserDataSyncError(D.message,"LocalPreconditionFailed"):D}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(S){if(!(S instanceof f.FileOperationError&&S.fileOperationResult===1))throw S}}onFileChanges(S){S.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=s=pe([Y(3,f.IFileService),Y(4,d.IEnvironmentService),Y(5,h.IStorageService),Y(6,y.IUserDataSyncStoreService),Y(7,y.IUserDataSyncBackupStoreService),Y(8,y.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,y.IUserDataSyncLogService),Y(11,v.IConfigurationService),Y(12,b.IUriIdentityService)],s);let o=e.AbstractJsonFileSynchroniser=class extends s{constructor(S,c,C,D,N,F,V,z,x,Q,te,G,J,B){super(S,c,C,D,N,F,V,z,x,Q,te,J,B),this.userDataSyncUtilService=G,this._formattingOptions=void 0}hasErrors(S,c){const C=[],D=(0,R.parse)(S,C,{allowEmptyContent:!0,allowTrailingComma:!0});return C.length>0||!(0,P.isUndefined)(D)&&c!==Array.isArray(D)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=o=pe([Y(3,f.IFileService),Y(4,d.IEnvironmentService),Y(5,h.IStorageService),Y(6,y.IUserDataSyncStoreService),Y(7,y.IUserDataSyncBackupStoreService),Y(8,y.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,y.IUserDataSyncLogService),Y(11,y.IUserDataSyncUtilService),Y(12,v.IConfigurationService),Y(13,b.IUriIdentityService)],o);let l=e.AbstractInitializer=class{constructor(S,c,C,D,N,F,V){this.resource=S,this.userDataProfilesService=c,this.environmentService=C,this.logService=D,this.fileService=N,this.storageService=F,this.extUri=V.extUri,this.lastSyncResource=(0,y.getLastSyncResourceUri)(void 0,this.resource,C,this.extUri)}async initialize({ref:S,content:c}){if(!c){this.logService.info("Remote content does not exist.",this.resource);return}const C=this.parseSyncData(c);if(C)try{await this.doInitialize({ref:S,syncData:C})}catch(D){this.logService.error(D)}}parseSyncData(S){try{const c=JSON.parse(S);if(r(c))return c}catch(c){this.logService.error(c)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(S,c={}){if(c.ref||c.version)throw new Error("Cannot have core properties as additional");const C={ref:S.ref,version:void 0,...c};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(C),-1,1),await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(S)))}};e.AbstractInitializer=l=pe([Y(1,k.IUserDataProfilesService),Y(2,d.IEnvironmentService),Y(3,E.ILogService),Y(4,f.IFileService),Y(5,h.IStorageService),Y(6,b.IUriIdentityService)],l)}),define(oe[114],ae([0,1,6,26,7,3,41,2,27,18,14,113,28,33,79,13,4,70,8,19,20,29,17,39,226,111,23,58]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k,n,r,t,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function l(N,F){const V=JSON.parse(N.content);if(N.version===1||N.version===2){const z=(await F.getInstalled(0)).filter(x=>x.isBuiltin);for(const x of V)N.version===1&&(x.enabled===!1&&(x.disabled=!0),delete x.enabled),N.version===2&&z.every(Q=>!(0,d.areSameExtensions)(Q.identifier,x.identifier))&&(x.installed=!0)}return V}function w(N){return JSON.parse(N.content)}e.parseExtensions=w;function S(N,F){return N.sort((V,z)=>!V.identifier.uuid&&z.identifier.uuid?-1:V.identifier.uuid&&!z.identifier.uuid?1:(0,I.compare)(V.identifier.id,z.identifier.id)),F?(0,T.toFormattedString)(N,{}):JSON.stringify(N)}e.stringify=S;let c=e.ExtensionsSynchroniser=class extends r.AbstractSynchroniser{constructor(F,V,z,x,Q,te,G,J,B,M,X,ie,se,H,Z,$,g){super({syncResource:"extensions",profile:F},V,x,z,Q,te,G,ie,se,M,X,Z),this.extensionManagementService=J,this.ignoredExtensionsManagementService=B,this.instantiationService=g,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(C),this._register(U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtensions,A=>A.some(({local:W})=>!!W)),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,A=>!A.error),U.Event.filter($.onDidChange,A=>A.valueChanges.some(({profile:W,changes:q})=>this.syncResource.profile.id===W.id&&q.some(j=>j.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),H.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(F,V){const z=F.syncData?await l(F.syncData,this.extensionManagementService):null,x=V?.skippedExtensions??[],Q=V?.builtinExtensions??null,te=V?.syncData?await l(V.syncData,this.extensionManagementService):null,{localExtensions:G,ignoredExtensions:J}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);z?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:M}=(0,t.merge)(G,z,te,x,J,Q),X={local:B,remote:M,content:this.getPreviewContent(G,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:M!==null?2:0},ie=this.stringify(G,!1);return[{skippedExtensions:x,builtinExtensions:Q,baseResource:this.baseResource,baseContent:te?this.stringify(te,!1):ie,localResource:this.localResource,localContent:ie,localExtensions:G,remoteResource:this.remoteResource,remoteExtensions:z,remoteContent:z?this.stringify(z,!1):null,previewResource:this.previewResource,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(F){const V=F.syncData?await l(F.syncData,this.extensionManagementService):null,{localExtensions:z,ignoredExtensions:x}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,t.merge)(z,V,V,F.skippedExtensions||[],x,F.builtinExtensions||[]);return Q!==null}getPreviewContent(F,V,z,x){const Q=[...V,...z],te=new Set,G=J=>{te.add(J.id.toLowerCase()),J.uuid&&te.add(J.uuid)};Q.forEach(({identifier:J})=>G(J)),x.forEach(G);for(const J of F)te.has(J.identifier.id.toLowerCase())||J.identifier.uuid&&te.has(J.identifier.uuid)||Q.push(J);return this.stringify(Q,!1)}async getMergeResult(F,V){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,V,z,x){if(this.extUri.isEqual(V,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(V,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(V,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${V.toString()}`)}async acceptLocal(F){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),x=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,z,F.builtinExtensions),{local:Q,remote:te}=x;return{content:F.localContent,local:Q,remote:te,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:te!==null?2:0}}async acceptRemote(F){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),x=F.remoteContent?JSON.parse(F.remoteContent):null;if(x!==null){const Q=(0,t.merge)(F.localExtensions,x,F.localExtensions,[],z,F.builtinExtensions),{local:te,remote:G}=Q;return{content:F.remoteContent,local:te,remote:G,localChange:te.added.length>0||te.removed.length>0||te.updated.length>0?2:0,remoteChange:G!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(F,V,z,x){let{skippedExtensions:Q,builtinExtensions:te,localExtensions:G}=z[0][0];const{local:J,remote:B,localChange:M,remoteChange:X}=z[0][1];if(M===0&&X===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(G)),Q=await this.localExtensionsProvider.updateLocalExtensions(J.added,J.removed,J.updated,Q,this.syncResource.profile)),B){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ie=JSON.stringify(B.all);F=await this.updateRemoteUserData(ie,x?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(se=>se.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(se=>se.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(se=>se.identifier.id))}.`:""}`)}V?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),te=this.computeBuiltinExtensions(G,te),await this.updateLastSyncUserData(F,{skippedExtensions:Q,builtinExtensions:te}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ie=>ie.identifier.id))}.`:""}`))}computeBuiltinExtensions(F,V){const z=new Set,x=[];for(const Q of F)z.add(Q.identifier.id.toLowerCase()),Q.installed||x.push(Q.identifier);if(V)for(const Q of V)z.has(Q.id.toLowerCase())||x.push(Q);return x}async resolveContent(F){if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const V=await this.resolvePreviewContent(F);return V&&this.stringify(JSON.parse(V),!0)}return null}stringify(F,V){return S(F,V)}async hasLocalData(){try{const{localExtensions:F}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(F.some(V=>V.installed||V.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=c=pe([Y(2,P.IEnvironmentService),Y(3,E.IFileService),Y(4,b.IStorageService),Y(5,s.IUserDataSyncStoreService),Y(6,s.IUserDataSyncBackupStoreService),Y(7,v.IExtensionManagementService),Y(8,i.IIgnoredExtensionsManagementService),Y(9,s.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,s.IUserDataSyncEnablementService),Y(12,y.ITelemetryService),Y(13,f.IExtensionStorageService),Y(14,k.IUriIdentityService),Y(15,o.IUserDataProfileStorageService),Y(16,a.IInstantiationService)],c);let C=e.LocalExtensionsProvider=class{constructor(F,V,z,x,Q,te){this.extensionManagementService=F,this.userDataProfileStorageService=V,this.extensionGalleryService=z,this.ignoredExtensionsManagementService=x,this.instantiationService=Q,this.logService=te}async getLocalExtensions(F){const V=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(V);return{localExtensions:await this.withProfileScopedServices(F,async(Q,te)=>{const G=Q.getDisabledExtensions();return V.map(J=>{const{identifier:B,isBuiltin:M,manifest:X,preRelease:ie,pinned:se}=J,H={identifier:B,preRelease:ie,version:X.version,pinned:!!se};G.some(Z=>(0,d.areSameExtensions)(Z,B))&&(H.disabled=!0),M||(H.installed=!0);try{const Z=te.getKeysForSync({id:B.id,version:X.version});if(Z){const $=te.getExtensionState(J,!0)||{};H.state=Object.keys($).reduce((g,A)=>(Z.includes(A)&&(g[A]=$[A]),g),{})}}catch(Z){this.logService.info(`${(0,r.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,_.getErrorMessage)(Z))}return H})}),ignoredExtensions:z}}async updateLocalExtensions(F,V,z,x,Q){const te=(0,r.getSyncResourceLogLabel)("extensions",Q),G=[],J=[],B=[],M=await this.extensionManagementService.getInstalled(void 0,Q.extensionsResource);if((F.length||z.length)&&await this.withProfileScopedServices(Q,async(ie,se)=>{await L.Promises.settled([...F,...z].map(async H=>{const Z=M.find(A=>(0,d.areSameExtensions)(A.identifier,H.identifier));if(Z&&Z.isBuiltin){H.state&&Z.manifest.version===H.version&&this.updateExtensionState(H.state,Z,Z.manifest.version,se),ie.getDisabledExtensions().some(W=>(0,d.areSameExtensions)(W,H.identifier))!==!!H.disabled&&(H.disabled?(this.logService.trace(`${te}: Disabling extension...`,H.identifier.id),await ie.disableExtension(H.identifier),this.logService.info(`${te}: Disabled extension`,H.identifier.id)):(this.logService.trace(`${te}: Enabling extension...`,H.identifier.id),await ie.enableExtension(H.identifier),this.logService.info(`${te}: Enabled extension`,H.identifier.id))),J.push(H.identifier);return}const $=H.pinned?H.version:void 0,g=(await this.extensionGalleryService.getExtensions([{...H.identifier,version:$,preRelease:$?void 0:H.preRelease}],O.CancellationToken.None))[0];if(H.state&&(Z?Z.manifest.version===H.version:g)&&this.updateExtensionState(H.state,Z||g,Z?.manifest.version,se),g)try{ie.getDisabledExtensions().some(W=>(0,d.areSameExtensions)(W,H.identifier))!==!!H.disabled&&(H.disabled?(this.logService.trace(`${te}: Disabling extension...`,H.identifier.id,g.version),await ie.disableExtension(g.identifier),this.logService.info(`${te}: Disabled extension`,H.identifier.id,g.version)):(this.logService.trace(`${te}: Enabling extension...`,H.identifier.id,g.version),await ie.enableExtension(g.identifier),this.logService.info(`${te}: Enabled extension`,H.identifier.id,g.version))),(!Z||Z.preRelease!==H.preRelease||Z.pinned!==H.pinned||$&&Z.manifest.version!==$)&&(await this.extensionManagementService.canInstall(g)?G.push([H,g]):(this.logService.info(`${te}: Skipped synchronizing extension because it cannot be installed.`,g.displayName||g.identifier.id),B.push(H)))}catch(A){B.push(H),this.logService.error(A),this.logService.info(`${te}: Skipped synchronizing extension`,g.displayName||g.identifier.id)}else B.push(H),this.logService.info(`${te}: Skipped synchronizing extension because the extension is not found.`,H.identifier.id)}))}),V.length){const ie=M.filter(({identifier:se,isBuiltin:H})=>!H&&V.some(Z=>(0,d.areSameExtensions)(se,Z)));await L.Promises.settled(ie.map(async se=>{this.logService.trace(`${te}: Uninstalling local extension...`,se.identifier.id),await this.extensionManagementService.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.logService.info(`${te}: Uninstalled local extension.`,se.identifier.id),J.push(se.identifier)}))}for(const[ie,se]of G)try{this.logService.trace(`${te}: Installing extension...`,se.identifier.id,se.version),await this.extensionManagementService.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ie.pinned&&!!ie.version,installPreReleaseVersion:ie.preRelease,profileLocation:Q.extensionsResource,context:{[v.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[v.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.logService.info(`${te}: Installed extension.`,se.identifier.id,se.version),J.push(se.identifier)}catch(H){B.push(ie),H instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatiblePreRelease,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(H.code)?this.logService.info(`${te}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.logService.error(H),this.logService.info(`${te}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const X=[];for(const ie of x)J.some(se=>(0,d.areSameExtensions)(se,ie.identifier))||X.push(ie);for(const ie of B)X.some(se=>(0,d.areSameExtensions)(se.identifier,ie.identifier))||X.push(ie);return X}updateExtensionState(F,V,z,x){const Q=x.getExtensionState(V,!0)||{},te=z?x.getKeysForSync({id:V.identifier.id,version:z}):void 0;te?te.forEach(G=>{Q[G]=F[G]}):Object.keys(F).forEach(G=>Q[G]=F[G]),x.setExtensionState(V,Q,!0)}async withProfileScopedServices(F,V){return this.userDataProfileStorageService.withProfileScopedStorageService(F,async z=>{const x=new R.DisposableStore,Q=this.instantiationService.createChild(new h.ServiceCollection([b.IStorageService,z])),te=x.add(Q.createInstance(p.GlobalExtensionEnablementService)),G=x.add(Q.createInstance(f.ExtensionStorageService));try{return await V(te,G)}finally{x.dispose()}})}};e.LocalExtensionsProvider=C=pe([Y(0,v.IExtensionManagementService),Y(1,o.IUserDataProfileStorageService),Y(2,v.IExtensionGalleryService),Y(3,i.IIgnoredExtensionsManagementService),Y(4,a.IInstantiationService),Y(5,s.IUserDataSyncLogService)],C);let D=e.AbstractExtensionsInitializer=class extends r.AbstractInitializer{constructor(F,V,z,x,Q,te,G,J){super("extensions",x,Q,te,z,G,J),this.extensionManagementService=F,this.ignoredExtensionsManagementService=V}async parseExtensions(F){return F.syncData?await l(F.syncData,this.extensionManagementService):null}generatePreview(F,V){const z=[],x=[],Q=[];for(const te of F){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(te.identifier.id))continue;const G=V.find(J=>(0,d.areSameExtensions)(J.identifier,te.identifier));G?(z.push(G),te.disabled&&Q.push(te.identifier)):te.installed&&(x.push({...te.identifier,preRelease:!!te.preRelease}),te.disabled&&Q.push(te.identifier))}return{installedExtensions:z,newExtensions:x,disabledExtensions:Q,remoteExtensions:F}}};e.AbstractExtensionsInitializer=D=pe([Y(0,v.IExtensionManagementService),Y(1,i.IIgnoredExtensionsManagementService),Y(2,E.IFileService),Y(3,n.IUserDataProfilesService),Y(4,P.IEnvironmentService),Y(5,u.ILogService),Y(6,b.IStorageService),Y(7,k.IUriIdentityService)],D)}),define(oe[115],ae([0,1,16,7,3,34,41,5,32,18,14,13,8,44,19,20,29,39,57,230,23,17,58,4]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",i=["locale"];function s(C,D){const N=C.storage?Object.keys(C.storage).sort():[],F={};return N.forEach(V=>F[V]=C.storage[V]),C.storage=F,D?(0,T.toFormattedString)(C,{}):JSON.stringify(C)}e.stringify=s;const o=1;let l=e.GlobalStateSynchroniser=class extends h.AbstractSynchroniser{constructor(D,N,F,V,z,x,Q,te,G,J,B,M,X,ie){super({syncResource:"globalState",profile:D},N,V,te,M,z,x,G,J,Q,B,X),this.userDataProfileStorageService=F,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ie.createInstance(w),this._register(V.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(_.Event.any(_.Event.filter(V.onDidFilesChange,se=>se.contains(this.environmentService.argvResource)),_.Event.filter(F.onDidChange,se=>!!(se.targetChanges.some(H=>this.syncResource.profile.id===H.id)||se.valueChanges.some(({profile:H,changes:Z})=>this.syncResource.profile.id===H.id&&Z.some($=>$.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,N,F){const V=D.syncData?JSON.parse(D.syncData.content):null;N=N===null&&F?D:N;const z=N&&N.syncData?JSON.parse(N.syncData.content):null,x=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);V?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.getStorageKeys(z),{local:te,remote:G}=(0,b.merge)(x.storage,V?V.storage:null,z?z.storage:null,Q,this.logService),J={content:null,local:te,remote:G,localChange:Object.keys(te.added).length>0||Object.keys(te.updated).length>0||te.removed.length>0?2:0,remoteChange:G.all!==null?2:0},B=s(x,!1);return[{baseResource:this.baseResource,baseContent:z?s(z,!1):B,localResource:this.localResource,localContent:B,localUserData:x,remoteResource:this.remoteResource,remoteContent:V?s(V,!1):null,previewResource:this.previewResource,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.acceptedResource,storageKeys:Q}]}async hasRemoteChanged(D){const N=D.syncData?JSON.parse(D.syncData.content):null;if(N===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),V=await this.getStorageKeys(N),{remote:z}=(0,b.merge)(F.storage,N.storage,N.storage,V,this.logService);return z.all!==null}async getMergeResult(D,N){return{...D.previewResult,hasConflicts:!1}}async getAcceptResult(D,N,F,V){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(D);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(D);if(this.extUri.isEqual(N,this.previewResource))return D.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(D){if(D.remoteContent!==null){const N=JSON.parse(D.remoteContent),{local:F,remote:V}=(0,b.merge)(D.localUserData.storage,N.storage,null,D.storageKeys,this.logService);return{content:D.remoteContent,local:F,remote:V,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:V!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(D,N,F,V){const{localUserData:z}=F[0][0],{local:x,remote:Q,localChange:te,remoteChange:G}=F[0][1];if(te===0&&G===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),te!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(z)),await this.localGlobalStateProvider.writeLocalGlobalState(x,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),G!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const J=JSON.stringify({storage:Q.all});D=await this.updateRemoteUserData(J,V?null:D.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}N?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(D){if(this.extUri.isEqual(this.remoteResource,D)||this.extUri.isEqual(this.baseResource,D)||this.extUri.isEqual(this.localResource,D)||this.extUri.isEqual(this.acceptedResource,D)){const N=await this.resolvePreviewContent(D);return N&&s(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(D){const N=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),F=[],V=[];for(const[Q,te]of N)te.target===0?F.push(Q):te.target===1&&V.push(Q);const z=[...F,...V],x=D?.storage?Object.keys(D.storage).filter(Q=>!Q.startsWith(t)&&!z.includes(Q)&&N.get(Q)!==void 0):[];if(!R.isWeb){const Q=[...y.ALL_SYNC_RESOURCES.map(te=>(0,y.getEnablementKey)(te)),y.SYNC_SERVICE_URL_TYPE];x.push(...Q),V.push(...Q)}return{user:F,machine:V,unregistered:x}}};e.GlobalStateSynchroniser=l=pe([Y(2,n.IUserDataProfileStorageService),Y(3,p.IFileService),Y(4,y.IUserDataSyncStoreService),Y(5,y.IUserDataSyncBackupStoreService),Y(6,y.IUserDataSyncLogService),Y(7,P.IEnvironmentService),Y(8,y.IUserDataSyncEnablementService),Y(9,E.ITelemetryService),Y(10,m.IConfigurationService),Y(11,f.IStorageService),Y(12,a.IUriIdentityService),Y(13,r.IInstantiationService)],l);let w=e.LocalGlobalStateProvider=class{constructor(D,N,F,V){this.fileService=D,this.environmentService=N,this.userDataProfileStorageService=F,this.logService=V}async getLocalGlobalState(D){const N={};if(D.isDefault){const V=await this.getLocalArgvContent(),z=(0,U.parse)(V);for(const x of i)z[x]!==void 0&&(N[`${t}${x}`]={version:1,value:z[x]})}const F=await this.userDataProfileStorageService.readStorageData(D);for(const[V,z]of F)z.value&&z.target===0&&(N[V]={version:1,value:z.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const D=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),D.value.toString()}catch(D){this.logService.debug((0,O.getErrorMessage)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:N,updated:F},V){const z=(0,h.getSyncResourceLogLabel)("globalState",V),x={},Q=new Map,te=await this.userDataProfileStorageService.readStorageData(V),G=(J,B)=>{for(const M of J){if(M.startsWith(t)){x[M.substring(t.length)]=B?B[M].value:void 0;continue}if(B){const X=B[M];X.value!==te.get(M)?.value&&Q.set(M,X.value)}else te.get(M)!==void 0&&Q.set(M,void 0)}};if(G(Object.keys(D),D),G(Object.keys(F),F),G(N),Object.keys(x).length){this.logService.trace(`${z}: Updating locale...`);const J=await this.getLocalArgvContent();let B=J;for(const M of Object.keys(x))B=(0,u.edit)(B,[M],x[M],{});J!==B&&(this.logService.trace(`${z}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(B)),this.logService.info(`${z}: Updated locale.`)),this.logService.info(`${z}: Updated locale`)}Q.size&&(this.logService.trace(`${z}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(V,Q,0),this.logService.info(`${z}: Updated global state`,[...Q.keys()]))}};e.LocalGlobalStateProvider=w=pe([Y(0,p.IFileService),Y(1,P.IEnvironmentService),Y(2,n.IUserDataProfileStorageService),Y(3,y.IUserDataSyncLogService)],w);let S=e.GlobalStateInitializer=class extends h.AbstractInitializer{constructor(D,N,F,V,z,x){super("globalState",F,V,z,N,D,x)}async doInitialize(D){const N=D.syncData?JSON.parse(D.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},V={};for(const z of Object.keys(N.storage))z.startsWith(t)?F[z.substring(t.length)]=N.storage[z].value:this.storageService.get(z,0)===void 0&&(V[z]=N.storage[z].value);if(Object.keys(F).length){let z="{}";try{z=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const x of Object.keys(F))z=(0,u.edit)(z,[x],F[x],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(z))}if(Object.keys(V).length)for(const z of Object.keys(V))this.storageService.store(z,V[z],0,0)}};e.GlobalStateInitializer=S=pe([Y(0,f.IStorageService),Y(1,p.IFileService),Y(2,k.IUserDataProfilesService),Y(3,P.IEnvironmentService),Y(4,y.IUserDataSyncLogService),Y(5,a.IUriIdentityService)],S);let c=e.UserDataSyncStoreTypeSynchronizer=class{constructor(D,N,F,V,z){this.userDataSyncStoreClient=D,this.storageService=N,this.environmentService=F,this.fileService=V,this.logService=z}getSyncStoreType(D){return this.parseGlobalState(D)?.storage[y.SYNC_SERVICE_URL_TYPE]?.value}async sync(D){const N=(0,y.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(D,N)}catch(F){if(F instanceof y.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(D,N)}throw F}}async doSync(D,N){const F=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),V=this.parseGlobalState(F)||{storage:{}};V.storage[y.SYNC_SERVICE_URL_TYPE]={value:D,version:o};const z=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),x={version:o,machineId:z,content:s(V,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(x),F.ref,void 0,N)}parseGlobalState({content:D}){if(!D)return null;const N=JSON.parse(D);if((0,h.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=c=pe([Y(1,f.IStorageService),Y(2,P.IEnvironmentService),Y(3,p.IFileService),Y(4,v.ILogService)],c)}),define(oe[116],ae([0,1,21,16,3,34,5,10,164,18,14,13,19,20,29,17,39,227,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(n,r,t){try{const i=JSON.parse(n);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=b;let y=e.KeybindingsSynchroniser=class extends a.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,l,w,S,c,C,D,N,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,S,c,C,i,s,w,N,o,D,l,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.filter(l.onDidChangeConfiguration,V=>V.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i,s){const o=r.syncData?b(r.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?r:t;const l=t?this.getKeybindingsContentFromLastSyncUserData(t):null,w=await this.getLocalFileContent(),S=await this.getFormattingOptions();let c=null,C=!1,D=!1,N=!1;if(o){let z=w?w.value.toString():"[]";if(z=z||"[]",this.hasErrors(z,!0))throw new u.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!l||l!==z||l!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const x=await(0,h.merge)(z,o,l,S,this.userDataSyncUtilService);x.hasChanges&&(c=x.mergeContent,N=x.hasConflicts,C=N||x.mergeContent!==z,D=N||x.mergeContent!==o)}}else w&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),c=w.value.toString(),D=!0);const F={content:N?l:c,localChange:C?w?2:1:0,remoteChange:D?2:0,hasConflicts:N},V=w?w.value.toString():null;return[{fileContent:w,baseResource:this.baseResource,baseContent:l,localResource:this.localResource,localContent:V,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getKeybindingsContentFromLastSyncUserData(r);if(t===null)return!0;const i=await this.getLocalFileContent(),s=i?i.value.toString():"",o=await this.getFormattingOptions(),l=await(0,h.merge)(s||"[]",t,t,o,this.userDataSyncUtilService);return l.hasConflicts||l.mergeContent!==t}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,s){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,s){const{fileContent:o}=i[0][0];let{content:l,localChange:w,remoteChange:S}=i[0][1];if(w===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l,!0)))throw new u.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(l||"[]",o,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),S!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const c=this.toSyncContent(l||"[]",r.syncData?.content);r=await this.updateRemoteUserData(c,s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,U.parse)(r.value.toString());if((0,L.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)?this.resolvePreviewContent(r):null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:b(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(u.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=y=pe([Y(2,u.IUserDataSyncStoreService),Y(3,u.IUserDataSyncBackupStoreService),Y(4,u.IUserDataSyncLogService),Y(5,m.IConfigurationService),Y(6,u.IUserDataSyncEnablementService),Y(7,p.IFileService),Y(8,P.IEnvironmentService),Y(9,v.IStorageService),Y(10,u.IUserDataSyncUtilService),Y(11,d.ITelemetryService),Y(12,f.IUriIdentityService)],y);let k=e.KeybindingsInitializer=class extends a.AbstractInitializer{constructor(r,t,i,s,o,l){super("keybindings",t,i,s,r,o,l)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,O.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,U.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return b(r,!0,this.logService)}catch(t){return this.logService.error(t),null}}};e.KeybindingsInitializer=k=pe([Y(0,p.IFileService),Y(1,E.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,u.IUserDataSyncLogService),Y(4,v.IStorageService),Y(5,f.IUriIdentityService)],k)}),define(oe[117],ae([0,1,16,3,165,18,73,14,28,13,19,20,29,17,39,57,231,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function b(n){const r=JSON.parse(n);return u(r)?r:{settings:n}}e.parseSettingsSyncContent=b;let y=e.SettingsSynchroniser=class extends f.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,l,w,S,c,C,D,N,F,V){super(r.settingsResource,{syncResource:"settings",profile:r},t,i,s,o,l,w,D,N,S,c,C,V),this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,t),s=this.getSettingsSyncContent(i),o=new T.ConfigurationModelParser(h.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,t,i){const s=await this.getLocalFileContent(),o=await this.getFormattingOptions(),l=this.getSettingsSyncContent(r);t=t===null&&i?r:t;const w=t?this.getSettingsSyncContent(t):null,S=await this.getIgnoredSettings();let c=null,C=!1,D=!1,N=!1;if(l){let x=s?s.value.toString().trim():"{}";x=x||"{}",this.validateContent(x),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Q=(0,a.merge)(x,l.settings,w?w.settings:null,S,[],o);c=Q.localContent||Q.remoteContent,C=Q.localContent!==null,D=Q.remoteContent!==null,N=Q.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),c=s.value.toString().trim()||"{}",this.validateContent(c),D=!0);const F=s?s.value.toString():null,V=w?.settings??null,z={content:N?V:c,localChange:C?2:0,remoteChange:D?2:0,hasConflicts:N};return[{fileContent:s,baseResource:this.baseResource,baseContent:V,localResource:this.localResource,localContent:F,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getSettingsSyncContent(r);if(t===null)return!0;const i=await this.getLocalFileContent(),s=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),l=await this.getFormattingOptions();return(0,a.merge)(s||"{}",t.settings,t.settings,o,[],l).remoteContent!==null}async getMergeResult(r,t){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,a.updateIgnoredSettings)(r.previewResult.content,"{}",s,i):null}}async getAcceptResult(r,t,i,s){const o=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?(0,a.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",l,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,a.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",l,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,a.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",l,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,s){const{fileContent:o}=i[0][0];let{content:l,localChange:w,remoteChange:S}=i[0][1];if(w===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),w!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(l,o,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),S!==0){const c=await this.getFormattingOptions(),C=this.getSettingsSyncContent(r),D=await this.getIgnoredSettings(l);l=(0,a.updateIgnoredSettings)(l,C?C.settings:"{}",D,c),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=await this.getFormattingOptions(),i=(0,E.edit)(r.value.toString(),[h.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,a.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r)?this.resolvePreviewContent(r):null}async resolvePreviewContent(r){let t=await super.resolvePreviewContent(r);if(t){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();t=(0,a.updateIgnoredSettings)(t,"{}",s,i)}return t}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return b(r)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,a.getIgnoredSettings)(t,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new h.UserDataSyncError((0,_.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=y=pe([Y(2,m.IFileService),Y(3,R.IEnvironmentService),Y(4,P.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,h.IUserDataSyncUtilService),Y(9,U.IConfigurationService),Y(10,h.IUserDataSyncEnablementService),Y(11,p.ITelemetryService),Y(12,I.IExtensionManagementService),Y(13,v.IUriIdentityService)],y);let k=e.SettingsInitializer=class extends f.AbstractInitializer{constructor(r,t,i,s,o,l){super("settings",t,i,s,r,o,l)}async doInitialize(r){const t=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,L.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,a.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return b(r)}catch(t){this.logService.error(t)}return null}};e.SettingsInitializer=k=pe([Y(0,m.IFileService),Y(1,d.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,v.IUriIdentityService)],k)}),define(oe[118],ae([0,1,16,3,31,18,14,13,19,20,29,17,39,228,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(u){return JSON.parse(u.content)}e.parseSnippets=E;let a=e.SnippetsSynchroniser=class extends v.AbstractSynchroniser{constructor(b,y,k,n,r,t,i,s,o,l,w,S){super({syncResource:"snippets",profile:b},y,n,k,r,t,i,l,w,s,o,S),this.version=1,this.snippetsFolder=b.snippetsHome,this._register(this.fileService.watch(k.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(O.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(b,y,k){const n=await this.getSnippetsFileContents(),r=this.toSnippetsContents(n),t=b.syncData?this.parseSnippets(b.syncData):null;y=y===null&&k?b:y;const i=y&&y.syncData?this.parseSnippets(y.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,d.merge)(r,t,i);return this.getResourcePreviews(s,n,t||{},i||{})}async hasRemoteChanged(b){const y=b.syncData?this.parseSnippets(b.syncData):null;if(y===null)return!0;const k=await this.getSnippetsFileContents(),n=this.toSnippetsContents(k),r=(0,d.merge)(n,y,y);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async getMergeResult(b,y){return b.previewResult}async getAcceptResult(b,y,k,n){if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:b.fileContent?b.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:b.remoteContent,localChange:b.remoteContent!==null?b.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder))return k===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:k,localChange:k===null?b.fileContent!==null?3:0:2,remoteChange:k===null?b.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async applyResult(b,y,k,n){const r=k.map(([t,i])=>({...t,acceptResult:i}));r.every(({localChange:t,remoteChange:i})=>t===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,n)),r.some(({remoteChange:t})=>t!==0)&&(b=await this.updateRemoteSnippets(r,b,n)),y?.ref!==b.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(b),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.fileService.del(t)}catch{}}getResourcePreviews(b,y,k,n){const r=new Map;for(const t of Object.keys(b.local.added)){const i={content:b.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(b.local.updated)){const i={content:b.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=y[t]?y[t].value.toString():null;r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of b.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=y[t]?y[t].value.toString():null;r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(b.remote.added)){const i={content:b.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=y[t]?y[t].value.toString():null;r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(b.remote.updated)){const i={content:b.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=y[t]?y[t].value.toString():null;r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of b.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of b.conflicts){const i={content:n[t]??null,hasConflicts:!0,localChange:y[t]?2:1,remoteChange:k[t]?2:1},s=y[t]?y[t].value.toString():null;r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(y))if(!r.has(t)){const i={content:y[t]?y[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=y[t]?y[t].value.toString():null;r.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(b){return this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(b):null}async hasLocalData(){try{const b=await this.getSnippetsFileContents();if(Object.keys(b).length)return!0}catch{}return!1}async updateLocalBackup(b){const y={};for(const k of b)k.fileContent&&(y[this.extUri.basename(k.localResource)]=k.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(y)))}async updateLocalSnippets(b,y){for(const{fileContent:k,acceptResult:n,localResource:r,remoteResource:t,localChange:i}of b)if(i!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r),o=this.extUri.joinPath(this.snippetsFolder,s);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,L.VSBuffer.fromString(n.content),{overwrite:y}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,L.VSBuffer.fromString(n.content),y?void 0:k),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(b,y,k){const n=y.syncData?this.parseSnippets(y.syncData):{},r=(0,_.deepClone)(n);for(const{acceptResult:t,localResource:i,remoteResource:s,remoteChange:o}of b)if(o!==0){const l=i?this.extUri.basename(i):this.extUri.basename(s);o===3?delete r[l]:r[l]=t.content}return(0,d.areSame)(n,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),y=await this.updateRemoteUserData(JSON.stringify(r),k?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),y}parseSnippets(b){return E(b)}toSnippetsContents(b){const y={};for(const k of Object.keys(b))y[k]=b[k].value.toString();return y}async getSnippetsFileContents(){const b={};let y;try{y=await this.fileService.resolve(this.snippetsFolder)}catch(k){if(k instanceof R.FileOperationError&&k.fileOperationResult===1)return b;throw k}for(const k of y.children||[]){const n=k.resource,r=this.extUri.extname(n);if(r===".json"||r===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,n),i=await this.fileService.readFile(n);b[t]=i}}return b}};e.SnippetsSynchroniser=a=pe([Y(2,T.IEnvironmentService),Y(3,R.IFileService),Y(4,I.IStorageService),Y(5,f.IUserDataSyncStoreService),Y(6,f.IUserDataSyncBackupStoreService),Y(7,f.IUserDataSyncLogService),Y(8,U.IConfigurationService),Y(9,f.IUserDataSyncEnablementService),Y(10,m.ITelemetryService),Y(11,P.IUriIdentityService)],a);let h=e.SnippetsInitializer=class extends v.AbstractInitializer{constructor(b,y,k,n,r,t){super("snippets",y,k,n,b,r,t)}async doInitialize(b){const y=b.syncData?JSON.parse(b.syncData.content):null;if(!y){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(y)){const r=y[n];if(r){const t=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,n);await this.fileService.createFile(t,L.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(b)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(b){return b.fileOperationResult===1}}};e.SnippetsInitializer=h=pe([Y(0,R.IFileService),Y(1,p.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,I.IStorageService),Y(5,P.IUriIdentityService)],h)}),define(oe[119],ae([0,1,16,18,14,13,19,20,29,17,39,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(a,h){try{return JSON.parse(a).tasks??null}catch(u){return h.error(u),null}}e.getTasksContentFromSyncContent=v;let d=e.TasksSynchroniser=class extends P.AbstractFileSynchroniser{constructor(h,u,b,y,k,n,r,t,i,s,o,l){super(h.tasksResource,{syncResource:"tasks",profile:h},u,t,i,s,b,y,r,o,k,n,l),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(h,u,b,y){const k=h.syncData?v(h.syncData.content,this.logService):null;u=u===null&&b?h:u;const n=u?.syncData?v(u.syncData.content,this.logService):null,r=await this.getLocalFileContent();let t=null,i=!1,s=!1,o=!1;if(h.syncData){const S=r?r.value.toString():null;if(!n||n!==S||n!==k){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const c=E(S,k,n);t=c.content,o=c.hasConflicts,i=c.hasLocalChanged,s=c.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const l={content:o?n:t,localChange:i?r?2:1:0,remoteChange:s?2:0,hasConflicts:o},w=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:w,localChange:l.localChange,remoteResource:this.remoteResource,remoteContent:k,remoteChange:l.remoteChange,previewResource:this.previewResource,previewResult:l,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const u=h?.syncData?v(h.syncData.content,this.logService):null;if(u===null)return!0;const b=await this.getLocalFileContent(),y=b?b.value.toString():null,k=E(y,u,u);return k.hasLocalChanged||k.hasRemoteChanged}async getMergeResult(h,u){return h.previewResult}async getAcceptResult(h,u,b,y){if(this.extUri.isEqual(u,this.localResource))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(u,this.remoteResource))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(u,this.previewResource))return b===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:b,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async applyResult(h,u,b,y){const{fileContent:k}=b[0][0],{content:n,localChange:r,remoteChange:t}=b[0][1];if(r===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),k&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(k.value.toString()))),n?await this.updateLocalFileContent(n,k,y):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(n));h=await this.updateRemoteUserData(i,y?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}u?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(h){return this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)?this.resolvePreviewContent(h):null}toTasksSyncContent(h){return h?{tasks:h}:{}}};e.TasksSynchroniser=d=pe([Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncBackupStoreService),Y(4,p.IUserDataSyncLogService),Y(5,O.IConfigurationService),Y(6,p.IUserDataSyncEnablementService),Y(7,U.IFileService),Y(8,_.IEnvironmentService),Y(9,T.IStorageService),Y(10,R.ITelemetryService),Y(11,I.IUriIdentityService)],d);let f=e.TasksInitializer=class extends P.AbstractInitializer{constructor(h,u,b,y,k,n){super("tasks",u,b,y,h,k,n),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(h){const u=h.syncData?v(h.syncData.content,this.logService):null;if(!u){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,L.VSBuffer.fromString(u)),await this.updateLastSyncUserData(h)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=f=pe([Y(0,U.IFileService),Y(1,m.IUserDataProfilesService),Y(2,_.IEnvironmentService),Y(3,p.IUserDataSyncLogService),Y(4,T.IStorageService),Y(5,I.IUriIdentityService)],f);function E(a,h,u){if(a===null&&h===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(a===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const b=u!==a,y=u!==h;return!b&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:b&&!y?{content:a,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!b?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:a,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,18,14,13,19,20,29,17,39,229,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let d=e.UserDataProfilesManifestSynchroniser=class extends P.AbstractSynchroniser{constructor(h,u,b,y,k,n,r,t,i,s,o,l,w){super({syncResource:"profiles",profile:h},u,y,k,n,r,t,o,l,i,s,w),this.userDataProfilesService=b,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?E(h.syncData):null}async getRemoteSyncedProfiles(h){const u=await this.getLastSyncUserData(),b=await this.getLatestRemoteUserData(h,u);return b?.syncData?E(b.syncData):null}async generateSyncPreview(h,u,b){if(!this.userDataProfilesService.isEnabled())throw new v.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const y=h.syncData?E(h.syncData):null,k=u?.syncData?E(u.syncData):null,n=this.getLocalUserDataProfiles(),{local:r,remote:t}=(0,p.merge)(n,y,k,[]),i={local:r,remote:t,content:k?this.stringifyRemoteProfiles(k):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=f(n,!1);return[{baseResource:this.baseResource,baseContent:k?this.stringifyRemoteProfiles(k):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:y?this.stringifyRemoteProfiles(y):null,remoteProfiles:y,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const u=h?.syncData?E(h.syncData):null,b=this.getLocalUserDataProfiles(),{remote:y}=(0,p.merge)(b,u,u,[]);return!!y?.added.length||!!y?.removed.length||!!y?.updated.length}async getMergeResult(h,u){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,u,b,y){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(u,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(h){const u=this.getLocalUserDataProfiles(),b=(0,p.merge)(u,null,null,[]),{local:y,remote:k}=b;return{content:h.localContent,local:y,remote:k,localChange:y.added.length>0||y.removed.length>0||y.updated.length>0?2:0,remoteChange:k!==null?2:0}}async acceptRemote(h){const u=h.remoteContent?JSON.parse(h.remoteContent):null,b=[],y=[];for(const k of this.getLocalUserDataProfiles()){const n=u?.find(r=>r.id===k.id);n&&(b.push({id:k.id,name:k.name,collection:n.collection}),y.push(k))}if(u!==null){const k=(0,p.merge)(y,u,b,[]),{local:n,remote:r}=k;return{content:h.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,u,b,y){const{local:k,remote:n,localChange:r,remoteChange:t}=b[0][1];r===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const i=b[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new v.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const s=[];for(const o of k.added)s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${o.name}' profile...`),await this.userDataProfilesService.createProfile(o.id,o.name,{shortName:o.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${o.name}'.`)})());for(const o of k.removed)s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${o.name}' profile...`),await this.userDataProfilesService.removeProfile(o),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${o.name}'.`)})());for(const o of k.updated){const l=this.userDataProfilesService.profiles.find(w=>w.id===o.id);l?s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${o.name}' profile...`),await this.userDataProfilesService.updateProfile(l,{name:o.name,shortName:o.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${o.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(s)}if(t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const s=[],o=i.length+(n?.added.length??0)<=20;if(o)for(const l of n?.added||[]){const w=await this.userDataSyncStoreService.createCollection(this.syncHeaders);s.push(w),i.push({id:l.id,name:l.name,collection:w,shortName:l.shortName})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const l of n?.removed||[])i.splice(i.findIndex(({id:w})=>l.id===w),1);for(const l of n?.updated||[]){const w=i.find(({id:S})=>l.id===S);w&&i.splice(i.indexOf(w),1,{id:l.id,name:l.name,collection:w.collection,shortName:l.shortName})}try{h=await this.updateRemoteProfiles(i,y?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${o&&n?.added.length?` Added: ${JSON.stringify(n.added.map(l=>l.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(l=>l.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(l=>l.name))}.`:""}`)}catch(l){if(s.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of s)await this.userDataSyncStoreService.deleteCollection(w,this.syncHeaders)}throw l}for(const l of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(l.collection,this.syncHeaders)}u?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,u){return this.updateRemoteUserData(this.stringifyRemoteProfiles(h),u)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(h){if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const u=await this.resolvePreviewContent(h);return u&&(0,L.toFormattedString)(JSON.parse(u),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(h=>!h.isDefault&&!h.isTransient)}stringifyRemoteProfiles(h){return JSON.stringify([...h].sort((u,b)=>u.name.localeCompare(b.name)))}};e.UserDataProfilesManifestSynchroniser=d=pe([Y(2,m.IUserDataProfilesService),Y(3,U.IFileService),Y(4,_.IEnvironmentService),Y(5,T.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncLogService),Y(9,O.IConfigurationService),Y(10,v.IUserDataSyncEnablementService),Y(11,R.ITelemetryService),Y(12,I.IUriIdentityService)],d);function f(a,h){const u=[...a].sort((b,y)=>b.name.localeCompare(y.name)).map(b=>({id:b.id,name:b.name}));return h?(0,L.toFormattedString)(u,{}):JSON.stringify(u)}e.stringifyLocalProfiles=f;function E(a){return JSON.parse(a.content)}e.parseUserDataProfilesManifest=E}),define(oe[246],ae([0,1,6,16,62,2,22,18,14,13,17,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let v=e.UserDataSyncBackupStoreService=class extends U.Disposable{constructor(f,E,a,h,u){super(),this.environmentService=f,this.fileService=E,this.configurationService=a,this.logService=h,this.userDataProfilesService=u,this.cleanUp()}async cleanUp(){for(const E of this.userDataProfilesService.profiles)for(const a of p.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(E,a))}catch(h){this.logService.error(h)}let f;try{f=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(E){(0,m.toFileOperationResult)(E)!==1&&this.logService.error(E);return}if(f.children){for(const E of f.children)if(E.isDirectory&&!this.userDataProfilesService.profiles.some(a=>a.id===E.name))try{this.logService.info("Deleting non existing profile from backup",E.resource.path),await this.fileService.del(E.resource,{recursive:!0})}catch(a){this.logService.error(a)}}}async getAllRefs(f,E){const a=this.getResourceBackupHome(f,E);try{const h=await this.fileService.resolve(a);if(h.children)return h.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)}))}catch(h){if((0,m.toFileOperationResult)(h)!==1)throw h}return[]}async resolveContent(f,E,a){const h=this.getResourceBackupHome(f,E),u=(0,T.joinPath)(h,a);try{return(await this.fileService.readFile(u)).value.toString()}catch(b){return this.logService.error(b),null}}async backup(f,E,a){const h=this.getResourceBackupHome(f,E),u=(0,T.joinPath)(h,`${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(u,O.VSBuffer.fromString(a))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(h)}catch{}}getResourceBackupHome(f,E){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[E]:[f.id,E])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const E=await this.fileService.resolve(f);if(E.children){const a=E.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let u=a.filter(y=>Date.now()-this.getCreationTime(y)>h);const b=a.length-u.length;b<10&&(u=u.slice(10-b)),await L.Promises.settled(u.map(async y=>{this.logService.info("Deleting from backup",y.resource.path),await this.fileService.del(y.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=v=pe([Y(0,I.IEnvironmentService),Y(1,m.IFileService),Y(2,R.IConfigurationService),Y(3,p.IUserDataSyncLogService),Y(4,P.IUserDataProfilesService)],v)}),define(oe[247],ae([0,1,3,2,5,14,19,20,23]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const m="sync.enable";let P=e.UserDataSyncEnablementService=class extends O.Disposable{constructor(v,d,f,E){super(),this.storageService=v,this.telemetryService=d,this.environmentService=f,this.userDataSyncStoreManagementService=E,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(a=>this.onDidStorageChange(a)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(m,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(m,{enabled:v}),this.storageService.store(m,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,I.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,d){if(this.isResourceEnabled(v)!==d){const f=(0,I.getEnablementKey)(v);this.storeResourceEnablement(f,d)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,d){this.storageService.store(v,d,-1,_.isWeb?0:1)}onDidStorageChange(v){if(v.scope!==-1)return;if(m===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const d=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===v.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}};e.UserDataSyncEnablementService=P=pe([Y(0,T.IStorageService),Y(1,R.ITelemetryService),Y(2,U.IEnvironmentService),Y(3,I.IUserDataSyncStoreManagementService)],P)}),define(oe[80],ae([0,1,3,2,5,27,169,14,13,4,24,44,19,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,m.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",E="Safari",a="Chrome",h="Edge",u="Firefox",b="Android";function y(r){switch(r){case E:case a:case h:case u:case b:case(0,_.PlatformToString)(0):return!0}return!1}e.isWebPlatform=y;function k(){return _.isSafari?E:_.isChrome?a:_.isEdge?h:_.isFirefox?u:_.isAndroid?b:(0,_.PlatformToString)(_.isWeb?0:_.platform)}let n=e.UserDataSyncMachinesService=class it extends O.Disposable{constructor(t,i,s,o,l,w){super(),this.storageService=s,this.userDataSyncStoreService=o,this.logService=l,this.productService=w,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,p.getServiceMachineId)(t,i,s)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,s=await this.readMachinesData(t);s.machines.some(({id:o})=>o===i)||(s.machines.push({id:i,name:this.computeCurrentMachineName(s.machines),platform:k()}),await this.writeMachinesData(s))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,s=await this.readMachinesData(t),o=s.machines.filter(({id:l})=>l!==i);o.length!==s.machines.length&&(s.machines=o,await this.writeMachinesData(s))}async renameMachine(t,i,s){const o=await this.readMachinesData(s),l=o.machines.find(({id:w})=>w===t);if(l){l.name=i,await this.writeMachinesData(o);const w=await this.currentMachineIdPromise;t===w&&this.storageService.store(f,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[s,o]of t){const l=i.machines.find(w=>w.id===s);l&&(l.disabled=o?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(f,-1);if(i)return i;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${k()} (${this.productService.nameShort})`,o=new RegExp(`${(0,U.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let l=0;for(const w of t){const S=o.exec(w.name),c=S?parseInt(S[1]):0;l=c>l?c:l}return`${s} #${l+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==it.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),s=await this.userDataSyncStoreService.writeResource(it.RESOURCE,i,this.userData?.ref||null);this.userData={ref:s,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[it.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(it.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:it.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",e.UserDataSyncMachinesService=n=pe([Y(0,R.IEnvironmentService),Y(1,I.IFileService),Y(2,v.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncLogService),Y(5,P.IProductService)],n)}),define(oe[248],ae([0,1,6,62,38,7,3,2,5,22,12,166,24,19,20,23,77,80]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const u="sync.disableMachineEventually",b="sync.sessionId",y="sync.storeUrl",k="sync.productQuality";let n=e.UserDataAutoSyncService=class extends R.Disposable{get syncUrl(){const i=this.storageService.get(y,-1);return i?P.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(y,i.toString(),-1,1):this.storageService.remove(y,-1)}get productQuality(){return this.storageService.get(k,-1)}set productQuality(i){i?this.storageService.store(k,i,-1,1):this.storageService.remove(k,-1)}constructor(i,s,o,l,w,S,c,C,D,N){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=l,this.userDataSyncService=w,this.logService=S,this.userDataSyncAccountService=c,this.telemetryService=C,this.userDataSyncMachinesService=D,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,m.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(c.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(w.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:s}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(b,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(l){if(this.logService.error(l),s)this.updateEnablement(!1);else throw l}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const s=E.UserDataSyncError.toUserDataSyncError(i);s instanceof E.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(u,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(u,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(u,-1)}async triggerSync(i,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const l=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:l}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=n=pe([Y(0,v.IProductService),Y(1,E.IUserDataSyncStoreManagementService),Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncEnablementService),Y(4,E.IUserDataSyncService),Y(5,E.IUserDataSyncLogService),Y(6,a.IUserDataSyncAccountService),Y(7,f.ITelemetryService),Y(8,h.IUserDataSyncMachinesService),Y(9,d.IStorageService)],n);class r extends R.Disposable{constructor(i,s,o,l,w,S,c,C,D){super(),this.lastSyncUrl=i,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=l,this.userDataSyncService=w,this.userDataSyncMachinesService=S,this.logService=c,this.telemetryService=C,this.storageService=D,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(i,s){const o=(0,L.createCancelablePromise)(async l=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(w){if((0,U.isCancellationError)(w))return}return this.doSync(i,s,l)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,m.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!i&&(!(0,m.isEqual)(s.defaultUrl,i.defaultUrl)||!(0,m.isEqual)(s.insidersUrl,i.insidersUrl)||!(0,m.isEqual)(s.stableUrl,i.stableUrl))}async doSync(i,s,o){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let l;try{await this.createAndRunSyncTask(s,o)}catch(w){if(this.logService.error(w),l=w,E.UserDataSyncError.toUserDataSyncError(w).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(s,o),l=void 0}catch(S){this.logService.error(S),l=S}}this._onDidFinishSync.fire(l)}async createAndRunSyncTask(i,s){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,i),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new E.UserDataAutoSyncError((0,p.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,p.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,p.localize)(2,null),"TurnedOff");const o=this.storageService.get(b,-1);if(o&&this.manifest&&o!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new E.UserDataAutoSyncError((0,p.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,p.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,p.localize)(5,null),"SessionExpired");const l=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const w=l.find(c=>c.isCurrent);if(w?.disabled)throw new E.UserDataAutoSyncError((0,p.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(c){throw new E.UserDataAutoSyncError((0,_.toErrorMessage)(c),c instanceof E.UserDataSyncError?c.code:"Unknown")}this.manifest&&this.manifest.session!==o&&this.storageService.store(b,this.manifest.session,-1,1),!s.isCancellationRequested&&(w||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(i){return super._register(i)}}r.INTERVAL_SYNCING="Interval"}),define(oe[249],ae([0,1,12,170,14,13,44,19,29,23,17,39,118,117,116,18,119,114,115,4,120,41]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=e.UserDataSyncResourceProviderService=class xe{constructor(t,i,s,o,l,w,S,c,C,D){this.userDataSyncStoreService=t,this.userDataSyncBackupStoreService=i,this.logService=s,this.environmentService=l,this.storageService=w,this.fileService=S,this.userDataProfilesService=c,this.configurationService=C,this.instantiationService=D,this.extUri=o.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const i=this.parseSyncData(t.content,"profiles");return(0,y.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(t,i){return(await this.userDataSyncStoreService.getAllResourceRefs(t,i?.collection)).map(({created:o,ref:l})=>({created:o,uri:this.toUri({remote:!0,syncResource:t,profile:i?.id??this.userDataProfilesService.defaultProfile.id,collection:i?.collection,ref:l,node:void 0})}))}async getLocalSyncResourceHandles(t,i){return(await this.userDataSyncBackupStoreService.getAllRefs(i,t)).map(({created:o,ref:l})=>({created:o,uri:this.toUri({remote:!1,syncResource:t,profile:i.id,collection:void 0,ref:l,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const i=this.resolveUri(t),s=i?this.userDataProfilesService.profiles.find(o=>o.id===i.profile):void 0;return i&&s?{profile:s,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:t}){const i=this.resolveUri(t);if(!i)return[];const s=this.userDataProfilesService.profiles.find(o=>o.id===i.profile);switch(i.syncResource){case"settings":return this.getSettingsAssociatedResources(t,s);case"keybindings":return this.getKeybindingsAssociatedResources(t,s);case"tasks":return this.getTasksAssociatedResources(t,s);case"snippets":return this.getSnippetsAssociatedResources(t,s);case"globalState":return this.getGlobalStateAssociatedResources(t,s);case"extensions":return this.getExtensionsAssociatedResources(t,s);case"profiles":return this.getProfilesAssociatedResources(t,s);case"workspaceState":return[]}}async getMachineId({uri:t}){const i=this.resolveUri(t);if(i){if(i.remote){if(i.ref){const{content:s}=await this.getUserData(i.syncResource,i.ref,i.collection);if(s)return this.parseSyncData(s,i.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const i=this.resolveUri(t);if(!i||i.node===xe.NOT_EXISTING_RESOURCE)return null;if(i.ref){const s=await this.getContentFromStore(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&s?this.resolveNodeContent(i.syncResource,s,i.node):s}return!i.remote&&!i.node?this.resolveLatestContent(i.syncResource,i.profile):null}async getContentFromStore(t,i,s,o,l){if(t){const{content:S}=await this.getUserData(i,l,o);return S}const w=this.userDataProfilesService.profiles.find(S=>S.id===s);return w?this.userDataSyncBackupStoreService.resolveContent(w,i,l):null}resolveNodeContent(t,i,s){const o=this.parseSyncData(i,t);switch(t){case"settings":return this.resolveSettingsNodeContent(o,s);case"keybindings":return this.resolveKeybindingsNodeContent(o,s);case"tasks":return this.resolveTasksNodeContent(o,s);case"snippets":return this.resolveSnippetsNodeContent(o,s);case"globalState":return this.resolveGlobalStateNodeContent(o,s);case"extensions":return this.resolveExtensionsNodeContent(o,s);case"profiles":return this.resolveProfileNodeContent(o,s);case"workspaceState":return null}}async resolveLatestContent(t,i){const s=this.userDataProfilesService.profiles.find(o=>o.id===i);if(!s)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(s);case"extensions":return this.resolveLatestExtensionsContent(s);case"profiles":return this.resolveLatestProfilesContent(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(t,i){const s=this.extUri.joinPath(t,"settings.json"),o=i?i.settingsResource:this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveSettingsNodeContent(t,i){switch(i){case"settings.json":return(0,d.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,i){const s=this.extUri.joinPath(t,"keybindings.json"),o=i?i.keybindingsResource:this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveKeybindingsNodeContent(t,i){switch(i){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,i){const s=this.extUri.joinPath(t,"tasks.json"),o=i?i.tasksResource:this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveTasksNodeContent(t,i){switch(i){case"tasks.json":return(0,a.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,i){const s=await this.resolveContent(t);if(s){const o=this.parseSyncData(s,"snippets");if(o){const l=(0,v.parseSnippets)(o),w=[];for(const S of Object.keys(l)){const c=this.extUri.joinPath(t,S),C=i?this.extUri.joinPath(i.snippetsHome,S):this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);w.push({resource:c,comparableResource:C})}return w}}return[]}resolveSnippetsNodeContent(t,i){return(0,v.parseSnippets)(t)[i]||null}getExtensionsAssociatedResources(t,i){const s=this.extUri.joinPath(t,"extensions.json"),o=i?this.toUri({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveExtensionsNodeContent(t,i){switch(i){case"extensions.json":return(0,h.stringify)((0,h.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:i}=await this.instantiationService.createInstance(h.LocalExtensionsProvider).getLocalExtensions(t);return(0,h.stringify)(i,!0)}getGlobalStateAssociatedResources(t,i){const s=this.extUri.joinPath(t,"globalState.json"),o=i?this.toUri({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveGlobalStateNodeContent(t,i){switch(i){case"globalState.json":return(0,u.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const i=await this.instantiationService.createInstance(u.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,u.stringify)(i,!0)}getProfilesAssociatedResources(t,i){const s=this.extUri.joinPath(t,"profiles.json"),o=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:o}]}resolveProfileNodeContent(t,i){switch(i){case"profiles.json":return(0,k.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,y.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}toUri(t){const i=t.remote?xe.REMOTE_BACKUP_AUTHORITY:xe.LOCAL_BACKUP_AUTHORITY,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.extUri.joinPath(L.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...s)}resolveUri(t){if(t.scheme!==m.USER_DATA_SYNC_SCHEME||t.authority!==xe.LOCAL_BACKUP_AUTHORITY&&t.authority!==xe.REMOTE_BACKUP_AUTHORITY)return;const i=[];for(;t.path!=="/";)i.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(i.length<2)return;const s=t.authority===xe.REMOTE_BACKUP_AUTHORITY,o=i.shift(),l=i.shift();let w,S,c;for(;i.length;){const C=i.shift();C.startsWith("collection:")?w=C.substring(11):C.startsWith("ref:")?S=C.substring(4):c=C}return{remote:s,syncResource:o,profile:l,collection:w,ref:S,node:c}}parseSyncData(t,i){try{const s=JSON.parse(t);if((0,p.isSyncData)(s))return s}catch(s){this.logService.error(s)}throw new m.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",i)}async getUserData(t,i,s){const o=await this.userDataSyncStoreService.resolveResourceContent(t,i,s);return{ref:i,content:o}}};n.NOT_EXISTING_RESOURCE="not-existing-resource",n.REMOTE_BACKUP_AUTHORITY="remote-backup",n.LOCAL_BACKUP_AUTHORITY="local-backup",e.UserDataSyncResourceProviderService=n=pe([Y(0,m.IUserDataSyncStoreService),Y(1,m.IUserDataSyncBackupStoreService),Y(2,m.IUserDataSyncLogService),Y(3,I.IUriIdentityService),Y(4,_.IEnvironmentService),Y(5,R.IStorageService),Y(6,U.IFileService),Y(7,P.IUserDataProfilesService),Y(8,E.IConfigurationService),Y(9,b.IInstantiationService)],n)}),define(oe[250],ae([0,1,21,6,26,38,3,2,22,10,32,18,28,4,19,20,17,114,115,116,117,118,119,120,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let s=e.UserDataSyncService=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(c,C,D,N,F,V,z,x,Q){super(),this.userDataSyncStoreService=c,this.userDataSyncStoreManagementService=C,this.instantiationService=D,this.logService=N,this.telemetryService=F,this.storageService=V,this.userDataSyncEnablementService=z,this.userDataProfilesService=x,this.userDataSyncResourceProviderService=Q,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=C.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(i,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(c,C){this.checkEnablement(),this.logService.info("Sync started.");const D=new Date().getTime(),N=(0,P.generateUuid)();try{const x=(0,t.createSyncHeaders)(N);C&&(x["Cache-Control"]="no-cache"),c=await this.userDataSyncStoreService.manifest(c,x)}catch(x){const Q=t.UserDataSyncError.toUserDataSyncError(x);throw w(Q,N,this.userDataSyncStoreManagementService,this.telemetryService),Q}const F=!1,V=this;let z;return{manifest:c,async run(){if(F)throw new Error("Can run a task only once");z=(0,O.createCancelablePromise)(x=>V.sync(c,!1,N,x)),await z.finally(()=>z=void 0),V.logService.info(`Sync done. Took ${new Date().getTime()-D}ms`),V.updateLastSyncTime()},stop(){return z?.cancel(),V.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const c=new Date().getTime(),C=(0,P.generateUuid)(),D=(0,t.createSyncHeaders)(C);let N;try{N=await this.userDataSyncStoreService.manifest(null,D)}catch(z){const x=t.UserDataSyncError.toUserDataSyncError(z);throw w(x,C,this.userDataSyncStoreManagementService,this.telemetryService),x}await this.resetLocal();const F=this,V=new _.CancellationTokenSource;return{id:C,async merge(){return F.sync(N,!0,C,V.token)},async apply(){try{try{await F.applyManualSync(N,C,V.token)}catch(z){if(t.UserDataSyncError.toUserDataSyncError(z).code==="MethodNotFound")F.logService.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.logService.info("Applying manual sync again..."),await F.applyManualSync(N,C,V.token);else throw z}}catch(z){throw F.logService.error(z),z}F.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),F.updateLastSyncTime()},async stop(){V.cancel(),await F.stop(),await F.resetLocal()}}}async sync(c,C,D,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,c,C,D,N));const V=F.enabled.find(z=>z.resource==="profiles");if(V){const z=await V.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(z,c,C,D,N)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(c,C,D,N,F){for(const V of c){if(F.isCancellationRequested)return;const z=this.userDataProfilesService.profiles.find(Q=>Q.id===V.id);if(!z){this.logService.error(`Profile with id:${V.id} and name: ${V.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",V.name);const x=this.getOrCreateActiveProfileSynchronizer(z,V);this._syncErrors.push(...await this.syncProfile(x,C,D,N,F))}for(const[V,z]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(x=>x.id===z[0].profile.id)||(z[1].dispose(),this.activeProfileSynchronizers.delete(V))}async applyManualSync(c,C,D){const N=this.getActiveProfileSynchronizers();for(const Q of N){if(D.isCancellationRequested)return;await Q.apply(C,D)}const F=N.find(Q=>Q.profile.isDefault);if(!F)return;const V=F.enabled.find(Q=>Q.resource==="profiles");if(!V)return;const x=(await V.getRemoteSyncedProfiles(c?.latest??null)||[]).filter(Q=>N.every(te=>te.profile.id!==Q.id));x.length&&await this.syncRemoteProfiles(x,c,!1,C,D)}async syncProfile(c,C,D,N,F){return(await c.sync(C,D,N,F)).map(([z,x])=>({profile:c.profile,syncResource:z,error:x}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(c=>c.stop()))}async resolveContent(c){const C=await this.userDataSyncResourceProviderService.resolveContent(c);if(C)return C;for(const D of this.getActiveProfileSynchronizers())for(const N of D.enabled){const F=await N.resolveContent(c);if(F)return F}return null}async replace(c){this.checkEnablement();const C=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(c);if(!C)return;const D=await this.resolveContent(c.uri);D&&await this.performAction(C.profile,async N=>{if(C.syncResource===N.resource)return await N.replace(D),!0})}async accept(c,C,D,N){this.checkEnablement(),await this.performAction(c.profile,async F=>{if(c.syncResource===F.resource)return await F.accept(C,D),N&&await F.apply((0,m.isBoolean)(N)?!1:N.force,(0,t.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(c,C){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(c,C)}async getLocalSyncResourceHandles(c,C){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(c,C??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(c){return this.userDataSyncResourceProviderService.getAssociatedResources(c)}async getMachineId(c){return this.userDataSyncResourceProviderService.getMachineId(c)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async C=>{if(C.resource!=="globalState"&&await C.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async C=>{if(await C.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(c){this.logService.error(c)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(i,-1);for(const[c]of this.activeProfileSynchronizers.values())try{await c.resetLocal()}catch(C){this.logService.error(C)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const c=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),C=c.map(V=>V.collection),D=await this.userDataSyncStoreService.getAllCollections(),N=D.filter(V=>!C.includes(V));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map(V=>this.userDataSyncStoreService.deleteCollection(V))),this.logService.info("Deleted redundant collections on server"));const F=c.filter(V=>D.includes(V.collection));if(F.length!==c.length){this.logService.info("Updating remote profiles with invalid collections on server");const V=this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{await V.updateRemoteProfiles(F,null),this.logService.info("Updated remote profiles on server")}finally{V.dispose()}}}async performAction(c,C){const D=new R.DisposableStore;try{const N=this.activeProfileSynchronizers.get(c.id);if(N){const Q=await this.performActionWithProfileSynchronizer(N[0],C,D);return(0,m.isUndefined)(Q)?null:Q}if(c.isDefault){const Q=D.add(this.instantiationService.createInstance(o,c,void 0)),te=await this.performActionWithProfileSynchronizer(Q,C,D);return(0,m.isUndefined)(te)?null:te}if(this.userDataProfilesService.isEnabled())return null;const F=D.add(this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,c,void 0)),V=await this.userDataSyncStoreService.manifest(null),x=(await F.getRemoteSyncedProfiles(V?.latest??null)||[]).find(Q=>Q.id===c.id);if(x){const Q=D.add(this.instantiationService.createInstance(o,c,x.collection)),te=await this.performActionWithProfileSynchronizer(Q,C,D);return(0,m.isUndefined)(te)?null:te}return null}finally{D.dispose()}}async performActionWithProfileSynchronizer(c,C,D){const N=[...c.enabled,...c.disabled.reduce((F,V)=>(V!=="workspaceState"&&F.push(D.add(c.createSynchronizer(V))),F),[])];for(const F of N){const V=await C(F);if(!(0,m.isUndefined)(V))return V}}setStatus(c){const C=this._status;this._status!==c&&(this._status=c,this._onDidChangeStatus.fire(c),C==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const c=this.getActiveProfileSynchronizers().map(C=>C.conflicts).flat();(0,L.equals)(this._conflicts,c,(C,D)=>C.profile.id===D.profile.id&&C.syncResource===D.syncResource&&(0,L.equals)(C.conflicts,D.conflicts,(N,F)=>(0,I.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=c,this._onDidChangeConflicts.fire(c))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(c,C){let D=this.activeProfileSynchronizers.get(c.id);if(D&&D[0].collection!==C?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.activeProfileSynchronizers.delete(c.id)),!D){const N=new R.DisposableStore,F=N.add(this.instantiationService.createInstance(o,c,C?.collection));N.add(F.onDidChangeStatus(V=>this.setStatus(V))),N.add(F.onDidChangeConflicts(V=>this.updateConflicts())),N.add(F.onDidChangeLocal(V=>this._onDidChangeLocal.fire(V))),this.activeProfileSynchronizers.set(c.id,D=[F,N])}return D[0]}getActiveProfileSynchronizers(){const c=[];for(const[C]of this.activeProfileSynchronizers.values())c.push(C);return c}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,c])=>c.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=s=pe([Y(0,t.IUserDataSyncStoreService),Y(1,t.IUserDataSyncStoreManagementService),Y(2,d.IInstantiationService),Y(3,t.IUserDataSyncLogService),Y(4,E.ITelemetryService),Y(5,f.IStorageService),Y(6,t.IUserDataSyncEnablementService),Y(7,a.IUserDataProfilesService),Y(8,t.IUserDataSyncResourceProviderService)],s);let o=class extends R.Disposable{get enabled(){return this._enabled.sort((c,C)=>c[1]-C[1]).map(([c])=>c)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(c=>!this.userDataSyncEnablementService.isResourceEnabled(c))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(c,C,D,N,F,V,z,x,Q,te){super(),this.profile=c,this.collection=C,this.userDataSyncEnablementService=D,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=V,this.telemetryService=z,this.logService=x,this.userDataProfilesService=Q,this.configurationService=te,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(D.onDidChangeResourceEnablement(([G,J])=>this.onDidChangeResourceEnablement(G,J))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,G])=>G.dispose())));for(const G of t.ALL_SYNC_RESOURCES)D.isResourceEnabled(G)&&this.registerSynchronizer(G)}onDidChangeResourceEnablement(c,C){C?this.registerSynchronizer(c):this.deRegisterSynchronizer(c)}registerSynchronizer(c){if(this._enabled.some(([F])=>F.resource===c))return;if(c==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(c==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||c==="workspaceState")return;const C=new R.DisposableStore,D=C.add(this.createSynchronizer(c));C.add(D.onDidChangeStatus(()=>this.updateStatus())),C.add(D.onDidChangeConflicts(()=>this.updateConflicts())),C.add(D.onDidChangeLocal(()=>this._onDidChangeLocal.fire(c)));const N=this.getOrder(c);this._enabled.push([D,N,C])}deRegisterSynchronizer(c){const C=this._enabled.findIndex(([D])=>D.resource===c);if(C!==-1){const[[D,,N]]=this._enabled.splice(C,1);N.dispose(),this.updateStatus(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,F=>this.logService.error(F))}}createSynchronizer(c){switch(c){case"settings":return this.instantiationService.createInstance(y.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(b.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(k.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(h.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(c,C,D,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const V=[],z=(0,t.createSyncHeaders)(D),x=(this.collection?c?.collections?.[this.collection]?.latest:c?.latest)??null,Q=C?await this.getUserDataSyncConfiguration(x):{};for(const te of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(te.resource))return[];try{if(C){const G=await te.preview(x,Q,z);if(G)for(const J of G.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await te.merge(J.previewResource)}else await te.sync(x,z)}catch(G){const J=t.UserDataSyncError.toUserDataSyncError(G);if(w(J,D,this.userDataSyncStoreManagementService,this.telemetryService),l(G))throw J;this.logService.error(G),this.logService.error(`${te.resource}: ${(0,U.toErrorMessage)(G)}`),V.push([te.resource,J])}}return V}finally{this.updateStatus()}}async apply(c,C){const D=(0,t.createSyncHeaders)(c);for(const N of this.enabled){if(C.isCancellationRequested)return;try{await N.apply(!1,D)}catch(F){const V=t.UserDataSyncError.toUserDataSyncError(F);if(w(V,c,this.userDataSyncStoreManagementService,this.telemetryService),l(F))throw V;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,U.toErrorMessage)(F)}`)}}}async stop(){for(const c of this.enabled)try{c.status!=="idle"&&await c.stop()}catch(C){this.logService.error(C)}}async resetLocal(){for(const c of this.enabled)try{await c.resetLocal()}catch(C){this.logService.error(`${c.resource}: ${(0,U.toErrorMessage)(C)}`),this.logService.error(C)}}async getUserDataSyncConfiguration(c){if(!this.profile.isDefault)return{};const C=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),D=this.enabled.find(N=>N instanceof y.SettingsSynchroniser);if(D){const N=await D.getRemoteUserDataSyncConfiguration(c);return{...C,...N}}return C}setStatus(c){this._status!==c&&(this._status=c,this._onDidChangeStatus.fire(c))}updateStatus(){return this.updateConflicts(),this.enabled.some(c=>c.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(c=>c.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const c=this.enabled.filter(C=>C.status==="hasConflicts").filter(C=>C.conflicts.conflicts.length>0).map(C=>C.conflicts);(0,L.equals)(this._conflicts,c,(C,D)=>C.syncResource===D.syncResource&&(0,L.equals)(C.conflicts,D.conflicts,(N,F)=>(0,I.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=c,this._onDidChangeConflicts.fire(c))}getOrder(c){switch(c){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=pe([Y(2,t.IUserDataSyncEnablementService),Y(3,d.IInstantiationService),Y(4,v.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,E.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,a.IUserDataProfilesService),Y(9,p.IConfigurationService)],o);function l(S){if(S instanceof t.UserDataSyncError)switch(S.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(S,c,C,D){D.publicLog2("sync/error",{code:S.code,serverCode:S instanceof t.UserDataSyncStoreError?String(S.serverCode):void 0,url:S instanceof t.UserDataSyncStoreError?S.url:void 0,resource:S.resource,executionId:c,service:C.userDataSyncStore.url.toString()})}}),define(oe[251],ae([0,1,3,2,12,17,23]),function(ne,e,L,O,_,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(v,d){return{...v,profile:(0,U.reviveProfile)(v.profile,d.profilesHome.scheme)}}function I(v){return{created:v.created,uri:_.URI.revive(v.uri)}}class m{constructor(d,f,E){this.service=d,this.userDataProfilesService=f,this.logService=E,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(d,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(d,f,E){try{return await this._call(d,f,E)}catch(a){throw this.logService.error(a),a}}async _call(d,f,E){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(_.URI.revive(E[0]));case"accept":return this.service.accept(R(E[0],this.userDataProfilesService),_.URI.revive(E[1]),E[2],E[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0],E[1]?(0,U.reviveProfile)(E[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0],E[1]);case"replace":return this.service.replace(I(E[0]));case"getAssociatedResources":return this.service.getAssociatedResources(I(E[0]));case"getMachineId":return this.service.getMachineId(I(E[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const a=f.substring(11),h=E[0],u=this.getManualSyncTask(h);switch(E=E.slice(1),a){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.manualSyncTasks.delete(this.createKey(u.id)));case"stop":return u.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(u.id)))}}throw new Error("Invalid call")}getManualSyncTask(d){const f=this.manualSyncTasks.get(this.createKey(d));if(!f)throw new Error(`Manual sync taks not found: ${d}`);return f}async createManualSyncTask(){const d=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(d.id),d),d.id}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=m;let P=e.UserDataSyncChannelClient=class extends O.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(d,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(E,a,h){return d.call(E,a,h).then(null,u=>{throw T.UserDataSyncError.toUserDataSyncError(u)})},listen(E,a){return d.listen(E,a)}},this.channel.call("_getInitialData").then(([E,a,h])=>{this.updateStatus(E),this.updateConflicts(a),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(u=>this.updateStatus(u))),this._register(this.channel.listen("onDidChangeLastSyncTime")(u=>this.updateLastSyncTime(u)))}),this._register(this.channel.listen("onDidChangeConflicts")(E=>this.updateConflicts(E))),this._register(this.channel.listen("onSyncErrors")(E=>this._onSyncErrors.fire(E.map(a=>({...a,error:T.UserDataSyncError.toUserDataSyncError(a.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.channel.call("createManualSyncTask"),f=this;return new p(d,{async call(a,h,u){return f.channel.call(`manualSync/${a}`,[d,...Array.isArray(h)?h:[h]],u)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,f,E,a){return this.channel.call("accept",[d,f,E,a])}resolveContent(d){return this.channel.call("resolveContent",[d])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(d,f){return(await this.channel.call("getLocalSyncResourceHandles",[d,f])).map(({created:a,uri:h})=>({created:a,uri:_.URI.revive(h)}))}async getRemoteSyncResourceHandles(d,f){return(await this.channel.call("getRemoteSyncResourceHandles",[d,f])).map(({created:a,uri:h})=>({created:a,uri:_.URI.revive(h)}))}async getAssociatedResources(d){return(await this.channel.call("getAssociatedResources",[d])).map(({resource:E,comparableResource:a})=>({resource:_.URI.revive(E),comparableResource:_.URI.revive(a)}))}getMachineId(d){return this.channel.call("getMachineId",[d])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(d){return this.channel.call("replace",[d])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(f=>({syncResource:f.syncResource,profile:(0,U.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(E=>({...E,baseResource:_.URI.revive(E.baseResource),localResource:_.URI.revive(E.localResource),remoteResource:_.URI.revive(E.remoteResource),previewResource:_.URI.revive(E.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}};e.UserDataSyncChannelClient=P=pe([Y(1,U.IUserDataProfilesService)],P);class p extends O.Disposable{constructor(d,f){super(),this.id=d,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(oe[252],ae([0,1,6,26,7,3,2,133,5,22,10,12,32,18,14,13,24,56,44,19,23]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const k="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",i=100,s=1e3*60*5;let o=e.AbstractUserDataSyncStoreManagementService=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(y.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(D){this.storageService.store(y.SYNC_SERVICE_URL_TYPE,D,-1,I.isWeb?0:1)}constructor(D,N,F){super(),this.productService=D,this.configurationService=N,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new U.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(U.Event.filter(F.onDidChangeValue,V=>V.key===y.SYNC_SERVICE_URL_TYPE&&V.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[y.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(y.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(D,N){D=I.isWeb&&D?.web?{...D,...D.web}:D;const F={...D||{},...N||{}};if(F&&(0,P.isString)(F.url)&&(0,P.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(V=>Array.isArray(F.authenticationProviders[V].scopes))){const V=F,z=!!V.canSwitch&&!N?.url,x=V.url===V.insidersUrl?"insiders":"stable",Q=(z?this.userDataSyncStoreType:void 0)||x,te=N?.url||(Q==="insiders"?V.insidersUrl:Q==="stable"?V.stableUrl:V.url);return{url:p.URI.parse(te),type:Q,defaultType:x,defaultUrl:p.URI.parse(V.url),stableUrl:p.URI.parse(V.stableUrl),insidersUrl:p.URI.parse(V.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(V.authenticationProviders).reduce((G,J)=>(G.push({id:J,scopes:V.authenticationProviders[J].scopes}),G),[])}}}};e.AbstractUserDataSyncStoreManagementService=o=pe([Y(0,a.IProductService),Y(1,d.IConfigurationService),Y(2,b.IStorageService)],o);let l=e.UserDataSyncStoreManagementService=class extends o{constructor(D,N,F){super(D,N,F);const V=this.storageService.get(k,-1);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const z=this.productService[y.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(k,JSON.stringify(z),-1,1):this.storageService.remove(k,-1)}async switch(D){D!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=D,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=l=pe([Y(0,a.IProductService),Y(1,d.IConfigurationService),Y(2,b.IStorageService)],l);let w=e.UserDataSyncStoreClient=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(D,N,F,V,z,x,Q){super(),this.requestService=F,this.logService=V,this.storageService=Q,this._onTokenFailed=this._register(new U.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new U.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new U.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(D),this.commonHeadersPromise=(0,u.getServiceMachineId)(z,x,Q).then(te=>{const G={"X-Client-Name":`${N.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(G["X-Client-Commit"]=N.commit),G}),this.session=new c(i,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(D,N){this.authToken={token:D,type:N}}updateUserDataSyncStoreUrl(D){this.userDataSyncStoreUrl=D?(0,m.joinPath)(D,"v1"):void 0}initDonotMakeRequestsUntil(){const D=this.storageService.getNumber(n,-1);D&&Date.now()<D&&this.setDonotMakeRequestsUntil(new Date(D))}setDonotMakeRequestsUntil(D){this._donotMakeRequestsUntil?.getTime()!==D?.getTime()&&(this._donotMakeRequestsUntil=D,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();D={...D},D["Content-Type"]="application/json";const F=await this.request(N,{type:"GET",headers:D},[],O.CancellationToken.None);return(await(0,h.asJson)(F))?.map(({id:V})=>V)||[]}async createCollection(D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();D={...D},D["Content-Type"]=R.Mimes.text;const F=await this.request(N,{type:"POST",headers:D},[],O.CancellationToken.None),V=await(0,h.asTextOrError)(F);if(!V)throw new y.UserDataSyncStoreError("Server did not return the collection id",N,"NoCollection",F.res.statusCode,F.res.headers[y.HEADER_OPERATION_ID]);return V}async deleteCollection(D,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=D?(0,m.joinPath)(this.userDataSyncStoreUrl,"collection",D).toString():(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(F,{type:"DELETE",headers:N},[],O.CancellationToken.None)}async getAllResourceRefs(D,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,N,D),V={},z=await this.request(F.toString(),{type:"GET",headers:V},[],O.CancellationToken.None);return(await(0,h.asJson)(z)||[]).map(({url:Q,created:te})=>({ref:(0,m.relativePath)(F,F.with({path:Q})),created:te*1e3}))}async resolveResourceContent(D,N,F,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,D),N).toString();V={...V},V["Cache-Control"]="no-cache";const x=await this.request(z,{type:"GET",headers:V},[],O.CancellationToken.None);return await(0,h.asTextOrError)(x)}async deleteResource(D,N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=N!==null?(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,D),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,F,D).toString(),z={};await this.request(V,{type:"DELETE",headers:z},[],O.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,m.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(D,{type:"DELETE",headers:N},[],O.CancellationToken.None)}async readResource(D,N,F,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,D),"latest").toString();V={...V},V["Cache-Control"]="no-cache",N&&(V["If-None-Match"]=N.ref);const x=await this.request(z,{type:"GET",headers:V},[304],O.CancellationToken.None);let Q=null;if(x.res.statusCode===304&&(Q=N),Q===null){const te=x.res.headers.etag;if(!te)throw new y.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",x.res.statusCode,x.res.headers[y.HEADER_OPERATION_ID]);const G=await(0,h.asTextOrError)(x);if(!G&&x.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",z,"EmptyResponse",x.res.statusCode,x.res.headers[y.HEADER_OPERATION_ID]);Q={ref:te,content:G}}return Q}async writeResource(D,N,F,V,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=this.getResourceUrl(this.userDataSyncStoreUrl,V,D).toString();z={...z},z["Content-Type"]=R.Mimes.text,F&&(z["If-Match"]=F);const Q=await this.request(x,{type:"POST",data:N,headers:z},[],O.CancellationToken.None),te=Q.res.headers.etag;if(!te)throw new y.UserDataSyncStoreError("Server did not return the ref",x,"NoRef",Q.res.statusCode,Q.res.headers[y.HEADER_OPERATION_ID]);return te}async manifest(D,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,m.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",D&&(N["If-None-Match"]=D.ref);const V=await this.request(F,{type:"GET",headers:N},[304],O.CancellationToken.None);let z=null;if(V.res.statusCode===304&&(z=D),!z){const Q=V.res.headers.etag;if(!Q)throw new y.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",V.res.statusCode,V.res.headers[y.HEADER_OPERATION_ID]);const te=await(0,h.asTextOrError)(V);if(!te&&V.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",F,"EmptyResponse",V.res.statusCode,V.res.headers[y.HEADER_OPERATION_ID]);te&&(z={...JSON.parse(te),ref:Q})}const x=this.storageService.get(r,-1);return x&&z&&x!==z.session&&this.clearSession(),z===null&&x&&this.clearSession(),z&&this.storageService.store(r,z.session,-1,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(D,N,F){return N?(0,m.joinPath)(D,"collection",N,"resource",F):(0,m.joinPath)(D,"resource",F)}clearSession(){this.storageService.remove(r,-1),this.storageService.remove(t,-1)}async request(D,N,F,V){if(!this.authToken)throw new y.UserDataSyncStoreError("No Auth Token Available",D,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;N.headers={...N.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:D,type:N.type,headers:{...N.headers,authorization:void 0}});let x;try{x=await this.session.request(D,N,V)}catch(B){if(!(B instanceof y.UserDataSyncStoreError)){let M="RequestFailed";const X=(0,_.getErrorMessage)(B).toLowerCase();X.includes("xhr timeout")?M="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?M="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?M="RequestPathNotEscaped":X.includes("headers must be an object")?M="RequestHeadersNotObject":(0,_.isCancellationError)(B)&&(M="RequestCanceled"),B=new y.UserDataSyncStoreError(`Connection refused for the request '${D}'.`,D,M,void 0,void 0)}throw this.logService.info("Request failed",D),B}const Q=x.res.headers[y.HEADER_OPERATION_ID],te={url:D,status:x.res.statusCode,"execution-id":N.headers[y.HEADER_EXECUTION_ID],"operation-id":Q},G=(0,h.isSuccess)(x)||x.res.statusCode&&F.includes(x.res.statusCode);let J="";if(G?this.logService.trace("Request succeeded",te):(this.logService.info("Request failed",te),J=await(0,h.asText)(x)||""),x.res.statusCode===401||x.res.statusCode===403){if(this.authToken=void 0,x.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because of Unauthorized (401).`,D,"Unauthorized",x.res.statusCode,Q);if(x.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because the access is forbidden (403).`,D,"Forbidden",x.res.statusCode,Q)}if(this._onTokenSucceed.fire(),x.res.statusCode===404)throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because the requested resource is not found (404).`,D,"NotFound",x.res.statusCode,Q);if(x.res.statusCode===405)throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because the requested endpoint is not found (405). ${J}`,D,"MethodNotFound",x.res.statusCode,Q);if(x.res.statusCode===409)throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,D,"Conflict",x.res.statusCode,Q);if(x.res.statusCode===410)throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because the requested resource is not longer available (410).`,D,"Gone",x.res.statusCode,Q);if(x.res.statusCode===412)throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,D,"PreconditionFailed",x.res.statusCode,Q);if(x.res.statusCode===413)throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because of too large payload (413).`,D,"TooLarge",x.res.statusCode,Q);if(x.res.statusCode===426)throw new y.UserDataSyncStoreError(`${N.type} request '${D}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,D,"UpgradeRequired",x.res.statusCode,Q);if(x.res.statusCode===429){const B=x.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",x.res.statusCode,Q)):new y.UserDataSyncStoreError(`${N.type} request '${D}' failed because of too many requests (429).`,D,"RemoteTooManyRequests",x.res.statusCode,Q)}if(!G)throw new y.UserDataSyncStoreError("Server returned "+x.res.statusCode,D,"Unknown",x.res.statusCode,Q);return x}addSessionHeaders(D){let N=this.storageService.get(t,-1);N===void 0&&(N=(0,v.generateUuid)(),this.storageService.store(t,N,-1,1)),D["X-Machine-Session-Id"]=N;const F=this.storageService.get(r,-1);F!==void 0&&(D["X-User-Session-Id"]=F)}};e.UserDataSyncStoreClient=w=pe([Y(1,a.IProductService),Y(2,h.IRequestService),Y(3,y.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,E.IFileService),Y(6,b.IStorageService)],w);let S=e.UserDataSyncStoreService=class extends w{constructor(D,N,F,V,z,x,Q){super(D.userDataSyncStore?.url,N,F,V,z,x,Q),this._register(D.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(D.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=S=pe([Y(0,y.IUserDataSyncStoreManagementService),Y(1,a.IProductService),Y(2,h.IRequestService),Y(3,y.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,E.IFileService),Y(6,b.IStorageService)],S);class c{constructor(D,N,F,V){this.limit=D,this.interval=N,this.requestService=F,this.logService=V,this.requests=[],this.startTime=void 0}request(D,N,F){if(this.isExpired()&&this.reset(),N.url=D,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new y.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,D,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(D),this.requestService.request(N,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=c}),define(oe[253],ae([0,1,3,54,24,19,20,248,23,77,80]),function(ne,e,L,O,_,U,T,R,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let p=e.UserDataAutoSyncService=class extends R.UserDataAutoSyncService{constructor(d,f,E,a,h,u,b,y,k,n,r){super(d,f,E,a,h,b,y,k,n,r),this._register(L.Event.debounce(L.Event.any(L.Event.map(u.onDidFocusWindow,()=>"windowFocus"),L.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};e.UserDataAutoSyncService=p=pe([Y(0,_.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncEnablementService),Y(4,I.IUserDataSyncService),Y(5,O.INativeHostService),Y(6,I.IUserDataSyncLogService),Y(7,m.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,U.IStorageService)],p)}),define(oe[254],ae([0,1,69,25,5,22]),function(ne,e,L,O,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(m){function P(){let p=m.scheme===O.Schemas.file?(0,U.originalFSPath)(m):m.toString();return _.isLinux||(p=p.toLowerCase()),(0,L.createHash)("md5").update(p).digest("hex")}return{id:P(),configPath:m}}e.getWorkspaceIdentifier=T;function R(m,P){function p(){if(m.scheme!==O.Schemas.file)return(0,L.createHash)("md5").update(m.toString()).digest("hex");if(!P)return;let d;return _.isLinux?d=P.ino:_.isMacintosh?d=P.birthtime.getTime():_.isWindows&&(typeof P.birthtimeMs=="number"?d=Math.floor(P.birthtimeMs):d=P.birthtime.getTime()),(0,L.createHash)("md5").update(m.fsPath).update(d?String(d):"").digest("hex")}const v=p();if(typeof v=="string")return{id:v,uri:m}}e.getSingleFolderWorkspaceIdentifier=R;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[255],ae([0,1,6,7,2,15,30,14,8,75,112,254,54,71]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=e.UnusedWorkspaceStorageDataCleaner=class extends _.Disposable{constructor(a,h,u,b){super(),this.environmentService=a,this.logService=h,this.nativeHostService=u,this.mainProcessService=b,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const a=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),h=new m.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(a.map(async u=>{const b=(0,U.join)(this.environmentService.workspaceStorageHome.fsPath,u);u.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||u===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===u)||await h.isUsed(b)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await T.Promises.rm(b))}))}catch(a){(0,O.onUnexpectedError)(a)}}};e.UnusedWorkspaceStorageDataCleaner=f=pe([Y(0,R.INativeEnvironmentService),Y(1,I.ILogService),Y(2,v.INativeHostService),Y(3,d.IMainProcessService)],f)}),define(oe[81],ae([0,1,51,6,15,10,30,141,265,266]),function(ne,e,L,O,_,U,T,R,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class p extends Error{constructor(r,t){let i=t.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=r,this.cause=t}}e.ExtractError=p;function v(n){const r=n.externalFileAttributes>>16||33188;return[448,56,7].map(t=>r&t).reduce((t,i)=>t+i,r&61440)}function d(n){if(n instanceof p)return n;let r;return P.test(n.message)&&(r="CorruptZip"),new p(r,n)}function f(n,r,t,i,s,o){const l=_.dirname(r),w=_.join(i,l);if(!w.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const S=_.join(i,r);let c;return o.onCancellationRequested(()=>{c?.destroy()}),Promise.resolve(T.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((C,D)=>{if(!o.isCancellationRequested)try{c=(0,L.createWriteStream)(S,{mode:t}),c.once("close",()=>C()),c.once("error",D),n.once("error",D),n.pipe(c)}catch(N){D(N)}}))}function E(n,r,t,i){let s=(0,O.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((l,w)=>{const S=new O.Sequencer,c=C=>{C.isCancellationRequested||(o++,n.readEntry())};n.once("error",w),n.once("close",()=>s.then(()=>{i.isCancellationRequested||n.entryCount===o?l():w(new p("Incomplete",new Error(R.localize(1,null,o,n.entryCount))))},w)),n.readEntry(),n.on("entry",C=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(C.fileName)){c(i);return}const D=C.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(D)){const V=_.join(r,D);s=(0,O.createCancelablePromise)(z=>T.Promises.mkdir(V,{recursive:!0}).then(()=>c(z)).then(void 0,w));return}const N=h(n,C),F=v(C);s=(0,O.createCancelablePromise)(V=>S.queue(()=>N.then(z=>f(z,D,F,r,t,V).then(()=>c(V)))).then(null,w))})})}function a(n,r=!1){return new Promise((t,i)=>{(0,I.open)(n,r?{lazyEntries:!0}:void 0,(s,o)=>{s?i(d(s)):t((0,U.assertIsDefined)(o))})})}function h(n,r){return new Promise((t,i)=>{n.openReadStream(r,(s,o)=>{s?i(d(s)):t((0,U.assertIsDefined)(o))})})}function u(n,r){return new Promise((t,i)=>{const s=new m.ZipFile;r.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const o=(0,L.createWriteStream)(n);s.outputStream.pipe(o),s.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>t(n))})}e.zip=u;function b(n,r,t={},i){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let o=a(n,!0);return t.overwrite&&(o=o.then(l=>T.Promises.rm(r).then(()=>l))),o.then(l=>E(l,r,{sourcePathRegex:s},i))}e.extract=b;function y(n,r){return a(n).then(t=>new Promise((i,s)=>{t.on("entry",o=>{o.fileName===r&&h(t,o).then(l=>i(l),l=>s(l))}),t.once("close",()=>s(new Error(R.localize(2,null,r))))}))}function k(n,r){return y(n,r).then(t=>new Promise((i,s)=>{const o=[];t.once("error",s),t.on("data",l=>o.push(l)),t.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=k}),define(oe[256],ae([0,1,6,7,2,25,5,22,52,10,32,30,81,18,14,28,33,97,13,8]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=e.ExtensionsDownloader=class gt extends _.Disposable{constructor(n,r,t,i,s,o){super(),this.fileService=r,this.extensionGalleryService=t,this.configurationService=i,this.extensionSignatureVerificationService=s,this.logService=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,r,t){await this.cleanUpPromise;const i=(0,R.joinPath)(this.extensionsDownloadDir,this.getName(n));try{await this.downloadFile(n,i,o=>this.extensionGalleryService.download(n,o,r))}catch(o){throw new E.ExtensionManagementError(o.message,E.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.shouldVerifySignature(n)){const o=await this.downloadSignatureArchive(n);try{s=await this.extensionSignatureVerificationService.verify(i.fsPath,o.fsPath,this.logService.getLevel()===b.LogLevel.Trace)}catch(l){const w=l;if(s=w.code,w.output&&this.logService.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${w.output}`),s===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.ExtensionManagementError(v.CorruptZipMessage,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(l){this.logService.error(l)}}}return s===!0?this.logService.info(`Extension signature is verified: ${n.identifier.id}`):s===!1?this.logService.info(`Extension signature verification is not done: ${n.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${s}': ${n.identifier.id}`),{location:i,verificationStatus:s}}shouldVerifySignature(n){if(!n.isSigned)return!1;const r=this.configurationService.getValue("extensions.verifySignature");return(0,m.isBoolean)(r)?r:!0}async downloadSignatureArchive(n){await this.cleanUpPromise;const r=(0,R.joinPath)(this.extensionsDownloadDir,`${this.getName(n)}${gt.SignatureArchiveExtension}`);return await this.downloadFile(n,r,t=>this.extensionGalleryService.downloadSignatureArchive(n,t)),r}async downloadFile(n,r,t){if(await this.fileService.exists(r))return;if(r.scheme!==U.Schemas.file){await t(r);return}const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(i)||await t(i);try{await this.rename(i,r,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(i)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async rename(n,r,t){try{await p.Promises.rename(n.fsPath,r.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<t)return this.logService.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.rename(n,r,t);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const l of n.children)if(l.name.endsWith(gt.SignatureArchiveExtension))i.push(l.resource);else{const w=a.ExtensionKey.parse(l.name);w&&t.push([w,l])}const s=(0,a.groupByExtension)(t,([l])=>l),o=[];for(const l of s)l.sort((w,S)=>I.rcompare(w[0].version,S[0].version)),r.push(...l.slice(1).map(w=>w[1].resource)),o.push(l[0][1]);o.sort((l,w)=>l.mtime-w.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(l=>l.resource)),r.push(...i),await L.Promises.settled(r.map(l=>(this.logService.trace("Deleting from cache",l.path),this.fileService.del(l))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?a.ExtensionKey.create(n).toString().toLowerCase():(0,P.generateUuid)()}};y.SignatureArchiveExtension=".sigzip",e.ExtensionsDownloader=y=pe([Y(0,f.INativeEnvironmentService),Y(1,u.IFileService),Y(2,E.IExtensionGalleryService),Y(3,d.IConfigurationService),Y(4,h.IExtensionSignatureVerificationService),Y(5,b.ILogService)],y)}),define(oe[257],ae([0,1,81,150]),function(ne,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function _(U){return(0,L.buffer)(U,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=_}),define(oe[121],ae([0,1,6,16,26,38,7,3,2,35,25,15,5,22,52,10,12,32,30,81,149,96,14,236,28,33,50,78,256,237,257,205,216,67,13,4,8,24,20,29,17]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k,n,r,t,i,s,o,l,w,S,c,C,D,N,F,V,z,x,Q,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(t.IExtensionManagementService);let G=e.ExtensionManagementService=class extends r.AbstractExtensionManagementService{constructor(H,Z,$,g,A,W,q,j,K,ee,ce,ue){super(H,Z,$,ee,ue),this.extensionsScannerService=A,this.extensionsProfileScannerService=W,this.downloadService=q,this.fileService=K,this.uriIdentityService=ce,this._onDidUpdateExtensionMetadata=this._register(new R.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new m.ResourceSet;const fe=this._register(j.createInstance(w.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(J,Ee=>fe.postUninstall(Ee))),this.manifestCache=this._register(new c.ExtensionsManifestCache(ue,K,ce,this,this.logService)),this.extensionsDownloader=this._register(j.createInstance(l.ExtensionsDownloader));const ve=this._register(new C.ExtensionsWatcher(this,this.extensionsScannerService,ue,W,ce,K,$));this._register(ve.onDidChangeExtensionsByAnotherSource(Ee=>this.onDidChangeExtensionsFromAnotherSource(Ee))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(H){this.logService.trace("ExtensionManagementService#zip",H.identifier.id);const Z=await this.collectFiles(H),$=await(0,b.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,Z);return a.URI.file($)}async unzip(H){return this.logService.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const{location:Z,cleanup:$}=await this.downloadVsix(H),g=p.resolve(Z.fsPath);try{return await(0,S.getManifest)(g)}finally{await $()}}getInstalled(H,Z=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(H??null,Z)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(H){return this.extensionsScanner.scanUserExtensionAtLocation(H)}async install(H,Z={}){this.logService.trace("ExtensionManagementService#install",H.toString());const{location:$,cleanup:g}=await this.downloadVsix(H);try{const A=await(0,S.getManifest)(p.resolve($.fsPath));if(A.engines&&A.engines.vscode&&!(0,D.isEngineValid)(A.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,i.getGalleryExtensionId)(A.publisher,A.name),this.productService.version));return await this.installExtension(A,$,Z)}finally{await g()}}async installFromLocation(H,Z){this.logService.trace("ExtensionManagementService#installFromLocation",H.toString());const $=await this.extensionsScanner.scanUserExtensionAtLocation(H);if(!$)throw new Error(`Cannot find a valid extension from the location ${H.toString()}`);return await this.addExtensionsToProfile([[$,void 0]],Z),this.logService.info("Successfully installed extension",$.identifier.id,Z.toString()),$}async installExtensionsFromProfile(H,Z,$){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",H,Z.toString(),$.toString());const g=(await this.extensionsScanner.scanExtensions(1,Z)).filter(A=>H.some(W=>(0,i.areSameExtensions)(W,A.identifier)));if(g.length){const A=await Promise.all(g.map(W=>this.extensionsScanner.scanMetadata(W,Z)));await this.addExtensionsToProfile(g.map((W,q)=>[W,A[q]]),$),this.logService.info("Successfully installed extensions",g.map(W=>W.identifier.id),$.toString())}return g}async updateMetadata(H,Z,$=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",H.identifier.id),Z.isPreReleaseVersion&&(Z.preRelease=!0),Z.isMachineScoped=Z.isMachineScoped||void 0,Z.isBuiltin=Z.isBuiltin||void 0,Z.pinned=Z.pinned||void 0,H=await this.extensionsScanner.updateMetadata(H,Z,$),this.manifestCache.invalidate($),this._onDidUpdateExtensionMetadata.fire(H),H}async reinstallFromGallery(H){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",H.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(1,null));const Z=await this.getTargetPlatform(),[$]=await this.galleryService.getExtensions([{...H.identifier,preRelease:H.preRelease}],{targetPlatform:Z,compatible:!0},_.CancellationToken.None);if(!$)throw new Error(y.localize(2,null));await this.extensionsScanner.setUninstalled(H);try{await this.extensionsScanner.removeUninstalledExtension(H)}catch(g){throw new Error(y.localize(3,null,(0,U.toErrorMessage)(g)))}return this.installFromGallery($)}copyExtensions(H,Z){return this.extensionsScanner.copyExtensions(H,Z)}markAsUninstalled(...H){return this.extensionsScanner.setUninstalled(...H)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(H){this.logService.error(H)}}async download(H,Z,$){const{location:g}=await this.extensionsDownloader.download(H,Z,!$);return g}async downloadVsix(H){if(H.scheme===P.Schemas.file)return{location:H,async cleanup(){}};this.logService.trace("Downloading extension from",H.toString());const Z=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(H,Z),this.logService.info("Downloaded extension to",Z.toString()),{location:Z,cleanup:async()=>{try{await this.fileService.del(Z)}catch(g){this.logService.error(g)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(H,Z,$){if(a.URI.isUri(Z))return new X(H,Z,$,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const g=i.ExtensionKey.create(Z).toString();let A=this.installGalleryExtensionsTasks.get(g);return A||(this.installGalleryExtensionsTasks.set(g,A=new M(H,Z,$,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),A.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(g))),A}createUninstallExtensionTask(H,Z){return new ie(H,Z.profileLocation,this.extensionsProfileScannerService)}async collectFiles(H){const Z=async g=>{let A=await u.Promises.readdir(g);A=A.map(j=>p.join(g,j));const W=await Promise.all(A.map(j=>u.Promises.stat(j)));let q=Promise.resolve([]);return W.forEach((j,K)=>{const ee=A[K];j.isFile()&&(q=q.then(ce=>[...ce,ee])),j.isDirectory()&&(q=q.then(ce=>Z(ee).then(ue=>[...ce,...ue])))}),q};return(await Z(H.location.fsPath)).map(g=>({path:`extension/${p.relative(H.location.fsPath,g)}`,localPath:g}))}async onDidChangeExtensionsFromAnotherSource({added:H,removed:Z}){if(Z)for(const $ of Z.extensions)this.logService.info("Extensions removed from another source",$.id,Z.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:$,profileLocation:Z.profileLocation});if(H){const g=(await this.extensionsScanner.scanExtensions(1,H.profileLocation)).filter(A=>H.extensions.some(W=>(0,i.areSameExtensions)(W,A.identifier)));this._onDidInstallExtensions.fire(g.map(A=>(this.logService.info("Extensions added from another source",A.identifier.id,H.profileLocation.toString()),{identifier:A.identifier,local:A,profileLocation:H.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(Z=>this.knownDirectories.add(Z)));const H=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const Z of H.children??[])Z.isDirectory&&this.knownDirectories.add(Z.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(Z=>this.onDidFilesChange(Z)))}async onDidFilesChange(H){if(!H.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const Z=[];for(const $ of H.rawAdded){if(this.knownDirectories.has($)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname($),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual($,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename($).startsWith(".")||!(await this.fileService.stat($)).isDirectory)continue;const g=await this.extensionsScanner.scanUserExtensionAtLocation($);g&&g.installedTimestamp===void 0&&(this.knownDirectories.add($),Z.push(g))}Z.length&&(await this.addExtensionsToProfile(Z.map($=>[$,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",Z.map($=>$.identifier.id)))}async addExtensionsToProfile(H,Z){const $=H.map(g=>g[0]);await this.setInstalled($),await this.extensionsProfileScannerService.addExtensionsToProfile(H,Z),this._onDidInstallExtensions.fire($.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:Z})))}async setInstalled(H){const Z=await this.extensionsScanner.getUninstalledExtensions();for(const $ of H){const g=i.ExtensionKey.create($);Z[g.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",g.id),await this.extensionsScanner.setInstalled(g),this.logService.info("Removed the extension from uninstalled list:",g.id))}}};e.ExtensionManagementService=G=pe([Y(0,t.IExtensionGalleryService),Y(1,x.ITelemetryService),Y(2,V.ILogService),Y(3,n.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,s.IExtensionsProfileScannerService),Y(6,k.IDownloadService),Y(7,F.IInstantiationService),Y(8,N.IFileService),Y(9,z.IProductService),Y(10,Q.IUriIdentityService),Y(11,te.IUserDataProfilesService)],G);let J=e.ExtensionsScanner=class extends I.Disposable{constructor(H,Z,$,g,A,W){super(),this.beforeRemovingExtension=H,this.fileService=Z,this.extensionsScannerService=$,this.extensionsProfileScannerService=g,this.uriIdentityService=A,this.logService=W,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(H,Z){const $={includeInvalid:!0,profileLocation:Z};let g=[];return H===null||H===0?g.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},$,!1)):H===1&&g.push(...await this.extensionsScannerService.scanUserExtensions($)),g=H!==null?g.filter(A=>A.type===H):g,Promise.all(g.map(A=>this.toLocalExtension(A)))}async scanAllUserExtensions(H){const Z=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!H,includeInvalid:!0});return Promise.all(Z.map($=>this.toLocalExtension($)))}async scanUserExtensionAtLocation(H){try{const Z=await this.extensionsScannerService.scanExistingExtension(H,1,{includeInvalid:!0});if(Z)return await this.toLocalExtension(Z)}catch(Z){this.logService.error(Z)}return null}async extractUserExtension(H,Z,$,g){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const A=H.toString(),W=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),q=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,A);try{await u.Promises.rm(q)}catch{throw new t.ExtensionManagementError(y.localize(4,null,q,H.id),t.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(H,Z,W,g),await this.extensionsScannerService.updateMetadata(a.URI.file(W),$);try{this._onExtract.fire(a.URI.file(q)),await this.rename(H,W,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(j){try{await u.Promises.rm(W)}catch{}if(j.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",H.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(j)}. Deleted from extracted location`,W),j}return this.scanLocalExtension(a.URI.file(q),1)}async scanMetadata(H,Z){return Z?(await this.extensionsProfileScannerService.scanProfileExtensions(Z)).find(g=>(0,i.areSameExtensions)(g.identifier,H.identifier))?.metadata:this.extensionsScannerService.scanMetadata(H.location)}async updateMetadata(H,Z,$){return $?await this.extensionsProfileScannerService.updateMetadata([[H,Z]],$):await this.extensionsScannerService.updateMetadata(H.location,Z),this.scanLocalExtension(H.location,H.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...H){const Z=H.map($=>i.ExtensionKey.create($));await this.withUninstalledExtensions($=>Z.forEach(g=>{$[g.toString()]=!0,this.logService.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(H){await this.withUninstalledExtensions(Z=>delete Z[H.toString()])}async removeExtension(H,Z){this.logService.trace(`Deleting ${Z} extension from disk`,H.identifier.id,H.location.fsPath);const $=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(H.location),`._${(0,h.generateUuid)()}`);await this.rename(H.identifier,H.location.fsPath,$.fsPath,Date.now()+2*60*1e3),await this.fileService.del($,{recursive:!0}),this.logService.info("Deleted from disk",H.identifier.id,H.location.fsPath)}async removeUninstalledExtension(H){await this.removeExtension(H,"uninstalled"),await this.withUninstalledExtensions(Z=>delete Z[i.ExtensionKey.create(H).toString()])}async copyExtensions(H,Z){const $=await this.scanExtensions(1,H),g=await Promise.all($.filter(A=>!A.isApplicationScoped).map(async A=>[A,await this.scanMetadata(A,H)]));await this.extensionsProfileScannerService.addExtensionsToProfile(g,Z)}async withUninstalledExtensions(H){return this.uninstalledFileLimiter.queue(async()=>{let Z;try{Z=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(g){if((0,N.toFileOperationResult)(g)!==1)throw g}let $={};if(Z)try{$=JSON.parse(Z)}catch{}return H&&(H($),Object.keys($).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify($))):await this.fileService.del(this.uninstalledResource)),$})}async extractAtLocation(H,Z,$,g){this.logService.trace(`Started extracting the extension from ${Z} to ${$}`);try{await u.Promises.rm($)}catch(A){throw new t.ExtensionManagementError(this.joinErrors(A).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,b.extract)(Z,$,{sourcePath:"extension",overwrite:!0},g),this.logService.info(`Extracted extension to ${$}:`,H.id)}catch(A){try{await u.Promises.rm($)}catch{}let W=t.ExtensionManagementErrorCode.Extract;throw A instanceof b.ExtractError&&(A.type==="CorruptZip"?W=t.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(W=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(A.message,W)}}async rename(H,Z,$,g){try{await u.Promises.rename(Z,$)}catch(A){if(v.isWindows&&A&&A.code==="EPERM"&&Date.now()<g)return this.logService.info(`Failed renaming ${Z} to ${$} with 'EPERM' error. Trying again...`,H.id),this.rename(H,Z,$,g);throw new t.ExtensionManagementError(A.message||y.localize(5,null,Z,$),A.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(H,Z){const $=await this.extensionsScannerService.scanExistingExtension(H,Z,{includeInvalid:!0});if($)return this.toLocalExtension($);throw new Error(y.localize(6,null,H.path))}async toLocalExtension(H){const Z=await this.fileService.resolve(H.location);let $,g;return Z.children&&($=Z.children.find(({name:A})=>/^readme(\.txt|\.md|)$/i.test(A))?.resource,g=Z.children.find(({name:A})=>/^changelog(\.txt|\.md|)$/i.test(A))?.resource),{identifier:H.identifier,type:H.type,isBuiltin:H.isBuiltin||!!H.metadata?.isBuiltin,location:H.location,manifest:H.manifest,targetPlatform:H.targetPlatform,validations:H.validations,isValid:H.isValid,readmeUrl:$,changelogUrl:g,publisherDisplayName:H.metadata?.publisherDisplayName||null,publisherId:H.metadata?.publisherId||null,isApplicationScoped:!!H.metadata?.isApplicationScoped,isMachineScoped:!!H.metadata?.isMachineScoped,isPreReleaseVersion:!!H.metadata?.isPreReleaseVersion,preRelease:!!H.metadata?.preRelease,installedTimestamp:H.metadata?.installedTimestamp,updated:!!H.metadata?.updated,pinned:!!H.metadata?.pinned}}async removeUninstalledExtensions(){const H=await this.getUninstalledExtensions();if(Object.keys(H).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(H));const Z=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),$=new Set;for(const A of Z)H[i.ExtensionKey.create(A).toString()]||$.add(A.identifier.id.toLowerCase());try{const A=(0,i.groupByExtension)(Z,W=>W.identifier);await L.Promises.settled(A.map(async W=>{const q=W.sort((j,K)=>f.rcompare(j.manifest.version,K.manifest.version))[0];$.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}))}catch(A){this.logService.error(A)}const g=Z.filter(A=>A.metadata&&H[i.ExtensionKey.create(A).toString()]);await Promise.allSettled(g.map(A=>this.removeUninstalledExtension(A)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const H=[];let Z;try{Z=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch($){(0,N.toFileOperationResult)($)!==1&&this.logService.error($)}for(const $ of Z?.children??[])$.isDirectory&&$.name.startsWith("._")&&(0,h.isUUID)($.name.substring(2))&&H.push((async()=>{this.logService.trace("Deleting the generated extension folder",$.resource.toString());try{await this.fileService.del($.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",$.resource.toString())}catch(g){this.logService.error(g)}})());await Promise.allSettled(H)}joinErrors(H){const Z=Array.isArray(H)?H:[H];return Z.length===1?Z[0]instanceof Error?Z[0]:new Error(Z[0]):Z.reduce(($,g)=>new Error(`${$.message}${$.message?",":""}${g instanceof Error?g.message:g}`),new Error(""))}};e.ExtensionsScanner=J=pe([Y(1,N.IFileService),Y(2,o.IExtensionsScannerService),Y(3,s.IExtensionsProfileScannerService),Y(4,Q.IUriIdentityService),Y(5,V.ILogService)],J);class B extends r.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(H,Z,$,g,A,W,q,j,K){super(),this.identifier=H,this.source=Z,this.options=$,this.extensionsScanner=g,this.uriIdentityService=A,this.userDataProfilesService=W,this.extensionsScannerService=q,this.extensionsProfileScannerService=j,this.logService=K,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(H){const[Z,$]=await this.install(H);return this._profileLocation=Z.isBuiltin||Z.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[Z,$]],this._profileLocation),Z}async extractExtension({zipPath:H,key:Z,metadata:$},g){let A=await this.unsetIfUninstalled(Z);return A||(this.logService.trace("Extracting extension...",Z.id),A=await this.extensionsScanner.extractUserExtension(Z,H,$,g),this.logService.info("Extracting extension completed.",Z.id)),A}async unsetIfUninstalled(H){return await this.isUninstalled(H)?(this.logService.trace("Removing the extension from uninstalled list:",H.id),await this.extensionsScanner.setInstalled(H),this.logService.info("Removed the extension from uninstalled list:",H.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(g=>i.ExtensionKey.create(g).equals(H))):void 0}async isUninstalled(H){return!!(await this.extensionsScanner.getUninstalledExtensions())[H.toString()]}}class M extends B{constructor(H,Z,$,g,A,W,q,j,K,ee){super(Z.identifier,Z,$,A,W,q,j,K,ee),this.gallery=Z,this.extensionsDownloader=g}async install(H){const $=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(q=>(0,i.areSameExtensions)(q.identifier,this.gallery.identifier));$&&(this._operation=3);const g={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||$?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||$?.isMachineScoped,isBuiltin:this.options.isBuiltin||$?.isBuiltin,isSystem:$?.type===0?!0:void 0,updated:!!$,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:$?.preRelease)};if($?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata($,g),g];const{location:A,verificationStatus:W}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=W,this.validateManifest(A.fsPath),[await this.extractExtension({zipPath:A.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:g},H),g]}catch(q){try{await this.extensionsDownloader.delete(A)}catch(j){this.logService.warn("Error while deleting the downloaded file",A.toString(),(0,T.getErrorMessage)(j))}throw q}}async validateManifest(H){try{await(0,S.getManifest)(H)}catch(Z){throw new t.ExtensionManagementError((0,r.joinErrors)(Z).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class X extends B{constructor(H,Z,$,g,A,W,q,j,K,ee){super({id:(0,i.getGalleryExtensionId)(H.publisher,H.name)},Z,$,A,W,q,j,K,ee),this.manifest=H,this.location=Z,this.galleryService=g}async doRun(H){const Z=await super.doRun(H);return this.updateMetadata(Z,H),Z}async install(H){const Z=new i.ExtensionKey(this.identifier,this.manifest.version),g=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(q=>(0,i.areSameExtensions)(this.identifier,q.identifier)),A={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this._operation=3,Z.equals(new i.ExtensionKey(g.identifier,g.manifest.version)))try{await this.extensionsScanner.removeExtension(g,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&f.gt(g.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(g);else{const q=await this.unsetIfUninstalled(Z);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(y.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:p.resolve(this.location.fsPath),key:Z,metadata:A},H),A]}async updateMetadata(H,Z){try{let[$]=await this.galleryService.getExtensions([{id:H.identifier.id,version:H.manifest.version}],Z);if($||([$]=await this.galleryService.getExtensions([{id:H.identifier.id}],Z)),$){const g={id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId,isPreReleaseVersion:$.properties.isPreReleaseVersion,preRelease:$.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(H,g,this.options.profileLocation)}}catch{}}}class ie extends r.AbstractExtensionTask{constructor(H,Z,$){super(),this.extension=H,this.profileLocation=Z,this.extensionsProfileScannerService=$}async doRun(H){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(oe[258],ae([0,1,2,28,79,215,121,8,19]),function(ne,e,L,O,_,U,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let m=e.ExtensionsContributions=class extends L.Disposable{constructor(p,v,d,f,E,a){super(),p.cleanUp(),(0,U.migrateUnsupportedExtensions)(p,v,d,f,a),_.ExtensionStorageService.removeOutdatedExtensionVersions(p,E)}};e.ExtensionsContributions=m=pe([Y(0,T.INativeServerExtensionManagementService),Y(1,O.IExtensionGalleryService),Y(2,_.IExtensionStorageService),Y(3,O.IGlobalExtensionEnablementService),Y(4,I.IStorageService),Y(5,R.ILogService)],m)}),define(oe[259],ae([0,1,69,61,36,267,16,7,3,2,15,5,32,43,92]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{traceSocketEvent(c,C){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,C)}constructor(c,C=""){this._canWrite=!0,this.debugLabel=C,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener),this._closeListener=D=>{this.traceSocketEvent("close",{hadError:D}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(c){const C=D=>{this.traceSocketEvent("read",D),c(T.VSBuffer.wrap(D))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(c){const C=D=>{c({type:0,hadError:D,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(c){const C=()=>{c()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(c){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,R.onUnexpectedError)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,R.onUnexpectedError)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=E;var a;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(a||(a={}));var h;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(h||(h={}));class u extends m.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,C){this.socket.traceSocketEvent(c,C)}constructor(c,C,D,N){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:D?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new b(this,C,D,N,this._onData,(F,V)=>this._write(F,V))),this._register(this._flowManager.onError(F=>{console.error(F),(0,R.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new f.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){let C=0;for(;C<c.byteLength;)this._flowManager.writeMessage(c.slice(C,Math.min(C+262144,c.byteLength))),C+=262144}_write(c,C){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let D=2;c.byteLength<126?D+=0:c.byteLength<2**16?D+=2:D+=8;const N=T.VSBuffer.alloc(D);if(C?N.writeUInt8(194,0):N.writeUInt8(130,0),c.byteLength<126)N.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){N.writeUInt8(126,1);let F=1;N.writeUInt8(c.byteLength>>>8&255,++F),N.writeUInt8(c.byteLength>>>0&255,++F)}else{N.writeUInt8(127,1);let F=1;N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(c.byteLength>>>24&255,++F),N.writeUInt8(c.byteLength>>>16&255,++F),N.writeUInt8(c.byteLength>>>8&255,++F),N.writeUInt8(c.byteLength>>>0&255,++F)}this.socket.write(T.VSBuffer.concat([N,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const C=this._incomingData.peek(this._state.readLen),D=C.readUInt8(0),N=(D&128)>>>7,F=(D&64)>>>6,V=C.readUInt8(1),z=(V&128)>>>7,x=V&127;this._state.state=2,this._state.readLen=2+(z?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const C=this._incomingData.read(this._state.readLen),D=C.readUInt8(1),N=(D&128)>>>7;let F=D&127,V=1;F===126?F=C.readUInt8(++V)*2**8+C.readUInt8(++V):F===127&&(F=C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*2**24+C.readUInt8(++V)*2**16+C.readUInt8(++V)*2**8+C.readUInt8(++V));let z=0;N&&(z=C.readUInt8(++V)*2**24+C.readUInt8(++V)*2**16+C.readUInt8(++V)*2**8+C.readUInt8(++V)),this._state.state=3,this._state.readLen=F,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const C=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),n(C,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(C,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=u;class b extends m.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}constructor(c,C,D,N,F,V){super(),this._tracer=c,this._onData=F,this._writeFn=V,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new I.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,C?(this._zlibInflateStream=this._register(new y(this._tracer,N,D,{windowBits:15})),this._zlibDeflateStream=this._register(new k(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const C=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(C,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,C){return new Promise((D,N)=>{c.write(C),c.flush(F=>D(F))})}acceptFrame(c,C,D){this._readQueue.push({data:c,isCompressed:C,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const C=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(C)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(c,C,D){return new Promise((N,F)=>{c.write(C),D&&c.write(T.VSBuffer.fromByteArray([0,0,255,255])),c.flush(V=>N(V))})}}class y extends m.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}constructor(c,C,D,N){super(),this._tracer=c,this._recordInflateBytes=C,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,U.createInflateRaw)(N),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(T.VSBuffer.wrap(F))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const C=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(C)})}}class k extends m.Disposable{constructor(c,C){super(),this._tracer=c,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,U.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(T.VSBuffer.wrap(D))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let C=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,C=C.slice(0,C.byteLength-4),c(C)})}}function n(S,c){if(c===0)return;const C=S.byteLength>>>2;for(let x=0;x<C;x++){const Q=S.readUInt32BE(x*4);S.writeUInt32BE(Q^c,x*4)}const D=C*4,N=S.byteLength-D,F=c>>>24&255,V=c>>>16&255,z=c>>>8&255;N>=1&&S.writeUInt8(S.readUInt8(D)^F,D),N>=2&&S.writeUInt8(S.readUInt8(D+1)^V,D+1),N>=3&&S.writeUInt8(S.readUInt8(D+2)^z,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function t(){const S=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const c=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,_.tmpdir)(),C=(0,P.join)(c,`vscode-ipc-${S}.sock`);return s(C),C}e.createRandomIPCHandle=t;function i(S,c,C){const D=(0,L.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${C}-${c}-sock`;const N=C.substr(0,4),F=c.substr(0,6),V=D.substr(0,8);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${V}-${N}-${F}.sock`):z=(0,P.join)(S,`${N}-${F}.sock`),s(z),z}e.createStaticIPCHandle=i;function s(S){const c=r[p.platform];typeof c=="number"&&S.length>=c&&console.warn(`WARNING: IPC handle "${S}" is longer than ${c} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{static toClientConnectionEvent(c){const C=I.Event.fromNodeEventEmitter(c,"connection");return I.Event.map(C,D=>({protocol:new f.Protocol(new E(D,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(D,"close"))}))}constructor(c){super(o.toClientConnectionEvent(c)),this.server=c}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(S){return new Promise((c,C)=>{const D=(0,O.createServer)();D.on("error",C),D.listen(S,()=>{D.removeListener("error",C),c(new o(D))})})}e.serve=l;function w(S,c){return new Promise((C,D)=>{const N=(0,O.createConnection)(S,()=>{N.removeListener("error",D),C(f.Client.fromSocket(new E(N,`ipc-client${c}`),c))});N.once("error",D)})}e.connect=w}),define(oe[260],ae([0,1,61,259,203]),function(ne,e,L,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(U){return!0}connect({host:U,port:T},R,I,m){return new Promise((P,p)=>{const v=L.createConnection({host:U,port:T},()=>{v.removeListener("error",p),v.write((0,_.makeRawSocketHeaders)(R,I,m));const d=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",d),P(new O.NodeSocket(v,m)))};v.on("data",d)});v.setNoDelay(!0),v.once("error",p)})}}}),define(oe[268],ae([0,1,36,38,7,2,25,12,43,140,197,198,189,190,255,180,182,18,202,95,213,96,208,14,210,113,240,28,97,181,121,98,13,192,193,68,4,188,70,72,218,8,194,102,24,56,19,107,20,108,109,110,45,221,79,111,23,77,246,232,233,80,247,250,251,252,58,245,234,106,212,76,223,207,222,29,224,5,225,183,200,199,78,239,17,50,196,55,244,220,235,105,249,258,9,195,101,242,238,209,177,54,253,241,71,243,104,260]),function(ne,e,L,O,_,U,T,R,I,m,P,p,v,d,f,E,a,h,u,b,y,k,n,r,t,i,s,o,l,w,S,c,C,D,N,F,V,z,x,Q,te,G,J,B,M,X,ie,se,H,Z,$,g,A,W,q,j,K,ee,ce,ue,fe,ve,Ee,Ce,Re,Le,je,Ke,le,de,ge,Ie,Pe,Ne,ke,We,Ue,Me,Fe,_e,re,he,me,Se,ye,be,De,Ae,ze,Te,$e,qe,Ze,nt,bt,It,mt,Pt,Dt,Rt,Lt,kt,_t,Tt,St,At,vt,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ot extends U.Disposable{constructor(we){super(),this.configuration=we,this.server=this._register(new m.Server),this.lifecycleService=void 0,this.registerListeners()}registerListeners(){let we=!1;const Oe=()=>{we||(we=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Oe),(0,m.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe)}async init(){const we=await this.initServices();(0,K.registerConfiguration)(),we.invokeFunction(Oe=>{const Ye=Oe.get(G.ILogService);Ye.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(Ye)}),this._register((0,U.combinedDisposable)(we.createInstance(P.CodeCacheCleaner,this.configuration.codeCachePath),we.createInstance(p.LanguagePackCachedDataCleaner),we.createInstance(f.UnusedWorkspaceStorageDataCleaner),we.createInstance(d.LogsDataCleaner),we.createInstance(v.LocalizationsUpdater),we.createInstance(nt.ExtensionsContributions),we.createInstance($e.UserDataProfilesCleaner)))}async initServices(){const we=new x.ServiceCollection,Oe={_serviceBrand:void 0,...B.default};we.set(M.IProductService,Oe);const Ye=new I.StaticRouter(Ve=>Ve==="main"),Be=new St.MainProcessService(this.server,Ye);we.set(St.IMainProcessService,Be);const at=this.configuration.policiesData?new De.PolicyChannelClient(this.configuration.policiesData,Be.getChannel("policy")):new Ae.NullPolicyService;we.set(Ae.IPolicyService,at);const He=new t.SharedProcessEnvironmentService(this.configuration.args,Oe);we.set(r.INativeEnvironmentService,He);const et=new J.LoggerChannelClient(void 0,this.configuration.logLevel,He.logsHome,this.configuration.loggers.map(Ve=>({...Ve,resource:R.URI.revive(Ve.resource)})),Be.getChannel("logger"));we.set(G.ILoggerService,et);const ct=this._register(et.createLogger("sharedprocess",{name:(0,bt.localize)(0,null)})),ht=this._register(new G.ConsoleLogger(ct.getLevel())),Ge=this._register(new It.LogService(ct,[ht]));we.set(G.ILogService,Ge),this.lifecycleService=this._register(new mt.SharedProcessLifecycleService(Ge)),we.set(mt.ISharedProcessLifecycleService,this.lifecycleService);const Qe=this._register(new D.FileService(Ge));we.set(C.IFileService,Qe);const dt=this._register(new N.DiskFileSystemProvider(Ge));Qe.registerProvider(T.Schemas.file,dt);const ft=this._register(new Fe.FileUserDataProvider(T.Schemas.file,this._register(new _e.DiskFileSystemProviderClient(Be.getChannel(_e.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Me.isLinux})),T.Schemas.vscodeUserData,Ge));Qe.registerProvider(T.Schemas.vscodeUserData,ft);const tt=this._register(new ze.UserDataProfilesService(this.configuration.profiles.all,R.URI.revive(this.configuration.profiles.home).with({scheme:He.userRoamingDataHome.scheme}),Be.getChannel("userDataProfiles")));we.set(ye.IUserDataProfilesService,tt);const Xe=this._register(new u.ConfigurationService(tt.defaultProfile.settingsResource,Qe,at,Ge));we.set(h.IConfigurationService,Xe);const st=new At.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Be,He);we.set(ie.IStorageService,st),this._register((0,U.toDisposable)(()=>st.flush())),await Promise.all([Xe.initialize(),st.initialize()]);const Nt=new Ue.UriIdentityService(Qe);we.set(We.IUriIdentityService,Nt),we.set(X.IRequestService,new Rt.RequestChannelClient(Be.getChannel("request"))),we.set(E.IChecksumService,new F.SyncDescriptor(a.ChecksumService,void 0,!1)),we.set(he.IV8InspectProfilingService,new F.SyncDescriptor(re.InspectProfilingService,void 0,!1));const yt=I.ProxyChannel.toService(Be.getChannel("nativeHost"));we.set(kt.INativeHostService,yt),we.set(k.IDownloadService,new F.SyncDescriptor(n.DownloadService,void 0,!0));const Ft=this._register(new le.ActiveWindowManager(yt)),Mt=new I.StaticRouter(Ve=>Ft.getActiveClientId().then(ut=>Ve===ut));we.set(c.IExtensionRecommendationNotificationService,new Lt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let lt;const rt=[],Et=(0,A.isInternalTelemetry)(Oe,Xe);if((0,A.supportsTelemetry)(Oe,He)){const Ve=new $.TelemetryLogAppender(Ge,et,He,Oe);if(rt.push(Ve),Oe.aiConfig?.ariaKey){const ut=new Te.OneDataSystemAppender(Et,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,U.toDisposable)(()=>ut.flush())),rt.push(ut)}lt=new g.TelemetryService({appenders:rt,commonProperties:(0,se.resolveCommonProperties)((0,L.release)(),(0,L.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Et),sendErrorTelemetry:!0,piiPaths:(0,A.getPiiPathsFromEnvironment)(He)},Xe,Oe)}else{lt=A.NullTelemetryService;const Ve=A.NullAppender;rt.push(Ve)}this.server.registerChannel("telemetryAppender",new Z.TelemetryAppenderChannel(rt)),we.set(H.ITelemetryService,lt);const $t=new W.CustomEndpointTelemetryService(Xe,lt,Ge,et,He,Oe);we.set(H.ICustomEndpointTelemetryService,$t),we.set(be.IExtensionsProfileScannerService,new F.SyncDescriptor(Dt.ExtensionsProfileScannerService,void 0,!0)),we.set(me.IExtensionsScannerService,new F.SyncDescriptor(Se.ExtensionsScannerService,void 0,!0)),we.set(l.IExtensionSignatureVerificationService,new F.SyncDescriptor(l.ExtensionSignatureVerificationService,void 0,!0)),we.set(S.INativeServerExtensionManagementService,new F.SyncDescriptor(S.ExtensionManagementService,void 0,!0)),we.set(o.IExtensionGalleryService,new F.SyncDescriptor(s.ExtensionGalleryService,void 0,!0)),we.set(o.IExtensionTipsService,new F.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),we.set(Q.ILanguagePackService,new F.SyncDescriptor(te.NativeLanguagePackService,void 0,!1)),we.set(b.IDiagnosticsService,new F.SyncDescriptor(y.DiagnosticsService,void 0,!1)),we.set(ee.IUserDataSyncAccountService,new F.SyncDescriptor(ee.UserDataSyncAccountService,void 0,!0)),we.set(K.IUserDataSyncLogService,new F.SyncDescriptor(fe.UserDataSyncLogService,void 0,!0)),we.set(K.IUserDataSyncUtilService,new ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),we.set(o.IGlobalExtensionEnablementService,new F.SyncDescriptor(i.GlobalExtensionEnablementService,void 0,!1)),we.set(j.IIgnoredExtensionsManagementService,new F.SyncDescriptor(j.IgnoredExtensionsManagementService,void 0,!0)),we.set(q.IExtensionStorageService,new F.SyncDescriptor(q.ExtensionStorageService)),we.set(K.IUserDataSyncStoreManagementService,new F.SyncDescriptor(Le.UserDataSyncStoreManagementService,void 0,!0)),we.set(K.IUserDataSyncStoreService,new F.SyncDescriptor(Le.UserDataSyncStoreService,void 0,!0)),we.set(ve.IUserDataSyncMachinesService,new F.SyncDescriptor(ve.UserDataSyncMachinesService,void 0,!0)),we.set(K.IUserDataSyncBackupStoreService,new F.SyncDescriptor(ce.UserDataSyncBackupStoreService,void 0,!1)),we.set(K.IUserDataSyncEnablementService,new F.SyncDescriptor(Ee.UserDataSyncEnablementService,void 0,!0)),we.set(K.IUserDataSyncService,new F.SyncDescriptor(Ce.UserDataSyncService,void 0,!1)),we.set(je.IUserDataProfileStorageService,new F.SyncDescriptor(Ke.NativeUserDataProfileStorageService,void 0,!0)),we.set(K.IUserDataSyncResourceProviderService,new F.SyncDescriptor(Ze.UserDataSyncResourceProviderService,void 0,!0)),we.set(de.ISignService,new F.SyncDescriptor(ge.SignService,void 0,!1));const wt=new vt.RemoteSocketFactoryService;return we.set(vt.IRemoteSocketFactoryService,wt),wt.register(0,Ut.nodeSocketFactory),we.set(Ie.ISharedTunnelsService,new F.SyncDescriptor(Pe.SharedTunnelsService)),we.set(Ne.ISharedProcessTunnelService,new F.SyncDescriptor(ke.SharedProcessTunnelService)),we.set(qe.IRemoteTunnelService,new F.SyncDescriptor(Pt.RemoteTunnelService)),new z.InstantiationService(we)}initChannels(we){const Oe=new w.ExtensionManagementChannel(we.get(o.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const Ye=I.ProxyChannel.fromService(we.get(Q.ILanguagePackService));this.server.registerChannel("languagePacks",Ye);const Be=I.ProxyChannel.fromService(we.get(b.IDiagnosticsService));this.server.registerChannel("diagnostics",Be);const at=new w.ExtensionTipsChannel(we.get(o.IExtensionTipsService));this.server.registerChannel("extensionTipsService",at);const He=I.ProxyChannel.fromService(we.get(E.IChecksumService));this.server.registerChannel("checksum",He);const et=I.ProxyChannel.fromService(we.get(he.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",et);const ct=new ue.UserDataSyncMachinesServiceChannel(we.get(ve.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const ht=I.ProxyChannel.fromService(we.get(H.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ht);const Ge=new ue.UserDataSyncAccountServiceChannel(we.get(ee.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Qe=new ue.UserDataSyncStoreManagementServiceChannel(we.get(K.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const dt=new Re.UserDataSyncChannel(we.get(K.IUserDataSyncService),we.get(ye.IUserDataProfilesService),we.get(G.ILogService));this.server.registerChannel("userDataSync",dt);const ft=this._register(we.get(V.IInstantiationService).createInstance(_t.UserDataAutoSyncService)),tt=new ue.UserDataAutoSyncChannel(ft);this.server.registerChannel("userDataAutoSync",tt);const Xe=I.ProxyChannel.fromService(we.get(Ne.ISharedProcessTunnelService));this.server.registerChannel(Ne.ipcSharedProcessTunnelChannelName,Xe);const st=I.ProxyChannel.fromService(we.get(qe.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",st)}registerErrorHandler(we){process.on("uncaughtException",Oe=>(0,_.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,_.onUnexpectedError)(Oe)),(0,_.setUnexpectedErrorHandler)(Oe=>{const Ye=(0,O.toErrorMessage)(Oe,!0);Ye&&we.error(`[uncaught exception in sharedProcess]: ${Ye}`)})}}async function pt(ot){const we=new Ot(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await we.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=pt,process.parentPort.once("message",ot=>{pt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
