/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/base/common/lifecycle","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/strings","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/base/common/extpath","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/glob","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","child_process","vs/platform/contextkey/common/contextkey","fs","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","os","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/base/common/console","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(re){for(var e=[],c=0,A=re.length;c<A;c++)e[c]=ye[re[c]];return e};define(ye[65],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(R,P){const _=Object.create(null);for(const g of R){const T=P(g);let k=_[T];k||(k=_[T]=[]),k.push(g)}return _}e.groupBy=c;function A(R,P){const _=[],g=[];for(const T of R)P.has(T)||_.push(T);for(const T of P)R.has(T)||g.push(T);return{removed:_,added:g}}e.diffSets=A;function l(R,P){const _=[],g=[];for(const[T,k]of R)P.has(T)||_.push(k);for(const[T,k]of P)R.has(T)||g.push(k);return{removed:_,added:g}}e.diffMaps=l;class L{constructor(){this.map=new Map}add(P,_){let g=this.map.get(P);g||(g=new Set,this.map.set(P,g)),g.add(_)}delete(P,_){const g=this.map.get(P);g&&(g.delete(_),g.size===0&&this.map.delete(P))}forEach(P,_){const g=this.map.get(P);g&&g.forEach(_)}}e.SetMap=L}),define(ye[66],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(R){return(P,_,g)=>{let T=null,k=null;if(typeof g.value=="function"?(T="value",k=g.value):typeof g.get=="function"&&(T="get",k=g.get),!k)throw new Error("not supported");g[T]=R(k,_)}}function A(R,P,_){let g=null,T=null;if(typeof _.value=="function"?(g="value",T=_.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(g="get",T=_.get),!T)throw new Error("not supported");const k=`$memoize$${P}`;_[g]=function(...m){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,m)}),this[k]}}e.memoize=A;function l(R,P,_){return c((g,T)=>{const k=`$debounce$${T}`,m=`$debounce$result$${T}`;return function(...D){this[m]||(this[m]=_?_():void 0),clearTimeout(this[k]),P&&(this[m]=P(this[m],...D),D=[this[m]]),this[k]=setTimeout(()=>{g.apply(this,D),this[m]=_?_():void 0},R)}})}e.debounce=l;function L(R,P,_){return c((g,T)=>{const k=`$throttle$timer$${T}`,m=`$throttle$result$${T}`,D=`$throttle$lastRun$${T}`,S=`$throttle$pending$${T}`;return function(...v){if(this[m]||(this[m]=_?_():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...v)),this[S])return;const n=this[D]+R;n<=Date.now()?(this[D]=Date.now(),g.apply(this,[this[m]]),this[m]=_?_():void 0):(this[S]=!0,this[k]=setTimeout(()=>{this[S]=!1,this[D]=Date.now(),g.apply(this,[this[m]]),this[m]=_?_():void 0},n-Date.now()))}})}e.throttle=L}),define(ye[8],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?E.isErrorNoTelemetry(a)?new E(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(r=>{r(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=c,e.errorHandler=new c;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function l(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function L(t){g(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=L;function R(t){g(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=R;function P(t){if(t instanceof Error){const{name:a,message:r}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:a,message:r,stack:s,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const _="Canceled";function g(t){return t instanceof T?!0:t instanceof Error&&t.name===_&&t.message===_}e.isCancellationError=g;class T extends Error{constructor(){super(_),this.name=this.message}}e.CancellationError=T;function k(){const t=new Error(_);return t.name=t.message,t}e.canceled=k;function m(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=m;function D(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=D;function S(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function v(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=v;function n(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=n;class h extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=h;class d extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=d;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class E extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof E)return a;const r=new E;return r.message=a.message,r.stack=a.stack,r}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class p extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.BugIndicatingError=p}),define(ye[19],Ce([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(Z,ne=0){return Z[Z.length-(1+ne)]}e.tail=A;function l(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=l;function L(Z,ne,le=(te,de)=>te===de){if(Z===ne)return!0;if(!Z||!ne||Z.length!==ne.length)return!1;for(let te=0,de=Z.length;te<de;te++)if(!le(Z[te],ne[te]))return!1;return!0}e.equals=L;function R(Z,ne){const le=Z.length-1;ne<le&&(Z[ne]=Z[le]),Z.pop()}e.removeFastWithoutKeepingOrder=R;function P(Z,ne,le){return _(Z.length,te=>le(Z[te],ne))}e.binarySearch=P;function _(Z,ne){let le=0,te=Z-1;for(;le<=te;){const de=(le+te)/2|0,oe=ne(de);if(oe<0)le=de+1;else if(oe>0)te=de-1;else return de}return-(le+1)}e.binarySearch2=_;function g(Z,ne){let le=0,te=Z.length;if(te===0)return 0;for(;le<te;){const de=Math.floor((le+te)/2);ne(Z[de])?te=de:le=de+1}return le}e.findFirstInSorted=g;function T(Z,ne,le){if(Z=Z|0,Z>=ne.length)throw new TypeError("invalid index");const te=ne[Math.floor(ne.length*Math.random())],de=[],oe=[],ue=[];for(const O of ne){const q=le(O,te);q<0?de.push(O):q>0?oe.push(O):ue.push(O)}return Z<de.length?T(Z,de,le):Z<de.length+ue.length?ue[0]:T(Z-(de.length+ue.length),oe,le)}e.quickSelect=T;function k(Z,ne){const le=[];let te;for(const de of Z.slice(0).sort(ne))!te||ne(te[0],de)!==0?(te=[de],le.push(te)):te.push(de);return le}e.groupBy=k;function m(Z,ne,le){const te=[];function de(O,q,Q){if(q===0&&Q.length===0)return;const ie=te[te.length-1];ie&&ie.start+ie.deleteCount===O?(ie.deleteCount+=q,ie.toInsert.push(...Q)):te.push({start:O,deleteCount:q,toInsert:Q})}let oe=0,ue=0;for(;;){if(oe===Z.length){de(oe,0,ne.slice(ue));break}if(ue===ne.length){de(oe,Z.length-oe,[]);break}const O=Z[oe],q=ne[ue],Q=le(O,q);Q===0?(oe+=1,ue+=1):Q<0?(de(oe,1,[]),oe+=1):Q>0&&(de(oe,0,[q]),ue+=1)}return te}e.sortedDiff=m;function D(Z,ne,le){const te=m(Z,ne,le),de=[],oe=[];for(const ue of te)de.push(...Z.slice(ue.start,ue.start+ue.deleteCount)),oe.push(...ue.toInsert);return{removed:de,added:oe}}e.delta=D;function S(Z,ne,le){if(le===0)return[];const te=Z.slice(0,le).sort(ne);return n(Z,ne,te,le,Z.length),te}e.top=S;function v(Z,ne,le,te,de){return le===0?Promise.resolve([]):new Promise((oe,ue)=>{(async()=>{const O=Z.length,q=Z.slice(0,le).sort(ne);for(let Q=le,ie=Math.min(le+te,O);Q<O;Q=ie,ie=Math.min(ie+te,O)){if(Q>le&&await new Promise(pe=>setTimeout(pe)),de&&de.isCancellationRequested)throw new c.CancellationError;n(Z,ne,q,Q,ie)}return q})().then(oe,ue)})}e.topAsync=v;function n(Z,ne,le,te,de){for(const oe=le.length;te<de;te++){const ue=Z[te];if(ne(ue,le[oe-1])<0){le.pop();const O=g(le,q=>ne(ue,q)<0);le.splice(O,0,ue)}}}function h(Z){return Z.filter(ne=>!!ne)}e.coalesce=h;function d(Z){let ne=0;for(let le=0;le<Z.length;le++)Z[le]&&(Z[ne]=Z[le],ne+=1);Z.length=ne}e.coalesceInPlace=d;function w(Z,ne,le){Z.splice(le,0,Z.splice(ne,1)[0])}e.move=w;function E(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=E;function p(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=p;function t(Z,ne=le=>le){const le=new Set;return Z.filter(te=>{const de=ne(te);return le.has(de)?!1:(le.add(de),!0)})}e.distinct=t;function a(Z){const ne=new Set;return le=>{const te=Z(le);return ne.has(te)?!1:(ne.add(te),!0)}}e.uniqueFilter=a;function r(Z,ne){const le=s(Z,ne);if(le!==-1)return Z[le]}e.findLast=r;function s(Z,ne){for(let le=Z.length-1;le>=0;le--){const te=Z[le];if(ne(te))return le}return-1}e.lastIndex=s;function f(Z,ne){return Z.length>0?Z[0]:ne}e.firstOrDefault=f;function b(Z,ne){return Z.length>0?Z[Z.length-1]:ne}e.lastOrDefault=b;function u(Z,ne,le=(te,de)=>te===de){let te=0;for(let de=0,oe=Math.min(Z.length,ne.length);de<oe&&le(Z[de],ne[de]);de++)te++;return te}e.commonPrefixLength=u;function C(Z){return[].concat(...Z)}e.flatten=C;function y(Z,ne){let le=typeof ne=="number"?Z:0;typeof ne=="number"?le=Z:(le=0,ne=Z);const te=[];if(le<=ne)for(let de=le;de<ne;de++)te.push(de);else for(let de=le;de>ne;de--)te.push(de);return te}e.range=y;function o(Z,ne,le){return Z.reduce((te,de)=>(te[ne(de)]=le?le(de):de,te),Object.create(null))}e.index=o;function i(Z,ne){return Z.push(ne),()=>I(Z,ne)}e.insert=i;function I(Z,ne){const le=Z.indexOf(ne);if(le>-1)return Z.splice(le,1),ne}e.remove=I;function F(Z,ne,le){const te=Z.slice(0,ne),de=Z.slice(ne);return te.concat(le,de)}e.arrayInsert=F;function U(Z,ne){let le;if(typeof ne=="number"){let te=ne;le=()=>{const de=Math.sin(te++)*179426549;return de-Math.floor(de)}}else le=Math.random;for(let te=Z.length-1;te>0;te-=1){const de=Math.floor(le()*(te+1)),oe=Z[te];Z[te]=Z[de],Z[de]=oe}}e.shuffle=U;function $(Z,ne){const le=Z.indexOf(ne);le>-1&&(Z.splice(le,1),Z.unshift(ne))}e.pushToStart=$;function B(Z,ne){const le=Z.indexOf(ne);le>-1&&(Z.splice(le,1),Z.push(ne))}e.pushToEnd=B;function N(Z,ne){for(const le of ne)Z.push(le)}e.pushMany=N;function V(Z,ne){return Array.isArray(Z)?Z.map(ne):ne(Z)}e.mapArrayOrNot=V;function x(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=x;function W(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=W;function ee(Z,ne){for(const le of Z){const te=ne(le);if(te!==void 0)return te}}e.mapFind=ee;function se(Z,ne,le){const te=J(Z,ne),de=Z.length,oe=le.length;Z.length=de+oe;for(let ue=de-1;ue>=te;ue--)Z[ue+oe]=Z[ue];for(let ue=0;ue<oe;ue++)Z[ue+te]=le[ue]}e.insertInto=se;function H(Z,ne,le,te){const de=J(Z,ne),oe=Z.splice(de,le);return se(Z,de,te),oe}e.splice=H;function J(Z,ne){return ne<0?Math.max(ne+Z.length,0):Math.min(ne,Z.length)}var j;(function(Z){function ne(de){return de<0}Z.isLessThan=ne;function le(de){return de>0}Z.isGreaterThan=le;function te(de){return de===0}Z.isNeitherLessOrGreaterThan=te,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(j||(e.CompareResult=j={}));function ae(Z,ne){return(le,te)=>ne(Z(le),Z(te))}e.compareBy=ae;function we(...Z){return(ne,le)=>{for(const te of Z){const de=te(ne,le);if(!j.isNeitherLessOrGreaterThan(de))return de}return j.neitherLessOrGreaterThan}}e.tieBreakComparators=we;const _e=(Z,ne)=>Z-ne;e.numberComparator=_e;function ve(Z,ne){if(Z.length===0)return;let le=Z[0];for(let te=1;te<Z.length;te++){const de=Z[te];ne(de,le)>0&&(le=de)}return le}e.findMaxBy=ve;function M(Z,ne){if(Z.length===0)return;let le=Z[0];for(let te=1;te<Z.length;te++){const de=Z[te];ne(de,le)>=0&&(le=de)}return le}e.findLastMaxBy=M;function X(Z,ne){return ve(Z,(le,te)=>-ne(le,te))}e.findMinBy=X;class fe{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let le=this.firstIdx;for(;le<this.items.length&&ne(this.items[le]);)le++;const te=le===this.firstIdx?null:this.items.slice(this.firstIdx,le);return this.firstIdx=le,te}takeFromEndWhile(ne){let le=this.lastIdx;for(;le>=0&&ne(this.items[le]);)le--;const te=le===this.lastIdx?null:this.items.slice(le+1,this.lastIdx+1);return this.lastIdx=le,te}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ne=this.items[this.firstIdx];return this.firstIdx++,ne}removeLast(){const ne=this.items[this.lastIdx];return this.lastIdx--,ne}takeCount(ne){const le=this.items.slice(this.firstIdx,this.firstIdx+ne);return this.firstIdx+=ne,le}}e.ArrayQueue=fe;class Ee{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(le=>(ne(le),!0))}toArray(){const ne=[];return this.iterate(le=>(ne.push(le),!0)),ne}filter(ne){return new Ee(le=>this.iterate(te=>ne(te)?le(te):!0))}map(ne){return new Ee(le=>this.iterate(te=>le(ne(te))))}some(ne){let le=!1;return this.iterate(te=>(le=ne(te),!le)),le}findFirst(ne){let le;return this.iterate(te=>ne(te)?(le=te,!1):!0),le}findLast(ne){let le;return this.iterate(te=>(ne(te)&&(le=te),!0)),le}findLastMaxBy(ne){let le,te=!0;return this.iterate(de=>((te||j.isGreaterThan(ne(de,le)))&&(te=!1,le=de),!0)),le}}e.CallbackIterable=Ee,Ee.empty=new Ee(Z=>{})}),define(ye[52],Ce([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(_,g){if(!_)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=A;function l(_,g="Unreachable"){throw new Error(g)}e.assertNever=l;function L(_){if(!_)throw new c.BugIndicatingError("Assertion Failed")}e.assert=L;function R(_){if(!_()){debugger;_(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function P(_,g){let T=0;for(;T<_.length-1;){const k=_[T],m=_[T+1];if(!g(k,m))return!1;T++}return!0}e.checkAdjacentItems=P}),define(ye[67],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(A){const l=this;let L=!1,R;return function(){return L||(L=!0,R=A.apply(l,arguments)),R}}e.once=c}),define(ye[109],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(l){this._prefix=l,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ye[53],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(A){function l(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}A.is=l;const L=Object.freeze([]);function R(){return L}A.empty=R;function*P(E){yield E}A.single=P;function _(E){return l(E)?E:P(E)}A.wrap=_;function g(E){return E||L}A.from=g;function T(E){return!E||E[Symbol.iterator]().next().done===!0}A.isEmpty=T;function k(E){return E[Symbol.iterator]().next().value}A.first=k;function m(E,p){for(const t of E)if(p(t))return!0;return!1}A.some=m;function D(E,p){for(const t of E)if(p(t))return t}A.find=D;function*S(E,p){for(const t of E)p(t)&&(yield t)}A.filter=S;function*v(E,p){let t=0;for(const a of E)yield p(a,t++)}A.map=v;function*n(...E){for(const p of E)for(const t of p)yield t}A.concat=n;function h(E,p,t){let a=t;for(const r of E)a=p(a,r);return a}A.reduce=h;function*d(E,p,t=E.length){for(p<0&&(p+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);p<t;p++)yield E[p]}A.slice=d;function w(E,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,E];const a=E[Symbol.iterator]();for(let r=0;r<p;r++){const s=a.next();if(s.done)return[t,A.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return a}}]}A.consume=w})(c||(e.Iterable=c={}))}),define(ye[150],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(c||(e.ScanError=c={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l||(e.ParseErrorCode=l={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,a=!1){let r=0;const s=t.length;let f="",b=0,u=16,C=0;function y(B){let N=0,V=0;for(;N<B;){const x=t.charCodeAt(r);if(x>=48&&x<=57)V=V*16+x-48;else if(x>=65&&x<=70)V=V*16+x-65+10;else if(x>=97&&x<=102)V=V*16+x-97+10;else break;r++,N++}return N<B&&(V=-1),V}function o(B){r=B,f="",b=0,u=16,C=0}function i(){const B=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return C=3,t.substring(B,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;N=r}else C=3;return t.substring(B,N)}function I(){let B="",N=r;for(;;){if(r>=s){B+=t.substring(N,r),C=2;break}const V=t.charCodeAt(r);if(V===34){B+=t.substring(N,r),r++;break}if(V===92){if(B+=t.substring(N,r),r++,r>=s){C=2;break}switch(t.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const W=y(4);W>=0?B+=String.fromCharCode(W):C=4;break}default:C=5}N=r;continue}if(V>=0&&V<=31)if(_(V)){B+=t.substring(N,r),C=2;break}else C=6;r++}return B}function F(){if(f="",C=0,b=r,r>=s)return b=s,u=17;let B=t.charCodeAt(r);if(P(B)){do r++,f+=String.fromCharCode(B),B=t.charCodeAt(r);while(P(B));return u=15}if(_(B))return r++,f+=String.fromCharCode(B),B===13&&t.charCodeAt(r)===10&&(r++,f+=`
`),u=14;switch(B){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,f=I(),u=10;case 47:{const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<s&&!_(t.charCodeAt(r));)r++;return f=t.substring(N,r),u=12}if(t.charCodeAt(r+1)===42){r+=2;const V=s-1;let x=!1;for(;r<V;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,x=!0;break}r++}return x||(r++,C=1),f=t.substring(N,r),u=13}return f+=String.fromCharCode(B),r++,u=16}case 45:if(f+=String.fromCharCode(B),r++,r===s||!g(t.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=i(),u=11;default:for(;r<s&&U(B);)r++,B=t.charCodeAt(r);if(b!==r){switch(f=t.substring(b,r),f){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return f+=String.fromCharCode(B),r++,u=16}}function U(B){if(P(B)||_(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let B;do B=F();while(B>=12&&B<=15);return B}return{setPosition:o,getPosition:()=>r,scan:a?$:F,getToken:()=>u,getTokenValue:()=>f,getTokenOffset:()=>b,getTokenLength:()=>r-b,getTokenError:()=>C}}e.createScanner=R;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,a){const r=[],s=new Object;let f;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function C(y,o,i,I){b.value=y,b.offset=o,b.length=i,b.type=I,b.colonOffset=void 0,f=b}try{w(t,{onObjectBegin:(y,o)=>{if(a<=y)throw s;f=void 0,u=a>y,r.push("")},onObjectProperty:(y,o,i)=>{if(a<o||(C(y,o,i,"property"),r[r.length-1]=y,a<=o+i))throw s},onObjectEnd:(y,o)=>{if(a<=y)throw s;f=void 0,r.pop()},onArrayBegin:(y,o)=>{if(a<=y)throw s;f=void 0,r.push(0)},onArrayEnd:(y,o)=>{if(a<=y)throw s;f=void 0,r.pop()},onLiteralValue:(y,o,i)=>{if(a<o||(C(y,o,i,p(y)),a<=o+i))throw s},onSeparator:(y,o,i)=>{if(a<=o)throw s;if(y===":"&&f&&f.type==="property")f.colonOffset=o,u=!1,f=void 0;else if(y===","){const I=r[r.length-1];typeof I=="number"?r[r.length-1]=I+1:(u=!0,r[r.length-1]=""),f=void 0}}})}catch(y){if(y!==s)throw y}return{path:r,previousNode:f,isAtPropertyKey:u,matches:y=>{let o=0;for(let i=0;o<y.length&&i<r.length;i++)if(y[o]===r[i]||y[o]==="*")o++;else if(y[o]!=="**")return!1;return o===y.length}}}e.getLocation=k;function m(t,a=[],r=L.DEFAULT){let s=null,f=[];const b=[];function u(y){Array.isArray(f)?f.push(y):s!==null&&(f[s]=y)}return w(t,{onObjectBegin:()=>{const y={};u(y),b.push(f),f=y,s=null},onObjectProperty:y=>{s=y},onObjectEnd:()=>{f=b.pop()},onArrayBegin:()=>{const y=[];u(y),b.push(f),f=y,s=null},onArrayEnd:()=>{f=b.pop()},onLiteralValue:u,onError:(y,o,i)=>{a.push({error:y,offset:o,length:i})}},r),f[0]}e.parse=m;function D(t,a=[],r=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(y){s.type==="property"&&(s.length=y-s.offset,s=s.parent)}function b(y){return s.children.push(y),y}w(t,{onObjectBegin:y=>{s=b({type:"object",offset:y,length:-1,parent:s,children:[]})},onObjectProperty:(y,o,i)=>{s=b({type:"property",offset:o,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:y,offset:o,length:i,parent:s})},onObjectEnd:(y,o)=>{s.length=y+o-s.offset,s=s.parent,f(y+o)},onArrayBegin:(y,o)=>{s=b({type:"array",offset:y,length:-1,parent:s,children:[]})},onArrayEnd:(y,o)=>{s.length=y+o-s.offset,s=s.parent,f(y+o)},onLiteralValue:(y,o,i)=>{b({type:p(y),offset:o,length:i,parent:s,value:y}),f(o+i)},onSeparator:(y,o,i)=>{s.type==="property"&&(y===":"?s.colonOffset=o:y===","&&f(o))},onError:(y,o,i)=>{a.push({error:y,offset:o,length:i})}},r);const C=s.children[0];return C&&delete C.parent,C}e.parseTree=D;function S(t,a){if(!t)return;let r=t;for(const s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let f=!1;for(const b of r.children)if(Array.isArray(b.children)&&b.children[0].value===s){r=b.children[1],f=!0;break}if(!f)return}else{const f=s;if(r.type!=="array"||f<0||!Array.isArray(r.children)||f>=r.children.length)return;r=r.children[f]}return r}e.findNodeAtLocation=S;function v(t){if(!t.parent||!t.parent.children)return[];const a=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;a.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&a.push(r)}return a}e.getNodePath=v;function n(t){switch(t.type){case"array":return t.children.map(n);case"object":{const a=Object.create(null);for(const r of t.children){const s=r.children[1];s&&(a[r.children[0].value]=n(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=n;function h(t,a,r=!1){return a>=t.offset&&a<t.offset+t.length||r&&a===t.offset+t.length}e.contains=h;function d(t,a,r=!1){if(h(t,a,r)){const s=t.children;if(Array.isArray(s))for(let f=0;f<s.length&&s[f].offset<=a;f++){const b=d(s[f],a,r);if(b)return b}return t}}e.findNodeAtOffset=d;function w(t,a,r=L.DEFAULT){const s=R(t,!1);function f(ae){return ae?()=>ae(s.getTokenOffset(),s.getTokenLength()):()=>!0}function b(ae){return ae?we=>ae(we,s.getTokenOffset(),s.getTokenLength()):()=>!0}const u=f(a.onObjectBegin),C=b(a.onObjectProperty),y=f(a.onObjectEnd),o=f(a.onArrayBegin),i=f(a.onArrayEnd),I=b(a.onLiteralValue),F=b(a.onSeparator),U=f(a.onComment),$=b(a.onError),B=r&&r.disallowComments,N=r&&r.allowTrailingComma;function V(){for(;;){const ae=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:B||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ae){case 12:case 13:B?x(10):U();break;case 16:x(1);break;case 15:case 14:break;default:return ae}}}function x(ae,we=[],_e=[]){if($(ae),we.length+_e.length>0){let ve=s.getToken();for(;ve!==17;){if(we.indexOf(ve)!==-1){V();break}else if(_e.indexOf(ve)!==-1)break;ve=V()}}}function W(ae){const we=s.getTokenValue();return ae?I(we):C(we),V(),!0}function ee(){switch(s.getToken()){case 11:{let ae=0;try{ae=JSON.parse(s.getTokenValue()),typeof ae!="number"&&(x(2),ae=0)}catch{x(2)}I(ae);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return V(),!0}function se(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(F(":"),V(),j()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function H(){u(),V();let ae=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ae||x(4,[],[]),F(","),V(),s.getToken()===2&&N)break}else ae&&x(6,[],[]);se()||x(4,[],[2,5]),ae=!0}return y(),s.getToken()!==2?x(7,[2],[]):V(),!0}function J(){o(),V();let ae=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ae||x(4,[],[]),F(","),V(),s.getToken()===4&&N)break}else ae&&x(6,[],[]);j()||x(4,[],[4,5]),ae=!0}return i(),s.getToken()!==4?x(8,[4],[]):V(),!0}function j(){switch(s.getToken()){case 3:return J();case 1:return H();case 10:return W(!0);default:return ee()}}return V(),s.getToken()===17?r.allowEmptyContent?!0:(x(4,[],[]),!1):j()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=w;function E(t,a){const r=R(t),s=[];let f,b=0,u;do switch(u=r.getPosition(),f=r.scan(),f){case 12:case 13:case 17:b!==u&&s.push(t.substring(b,u)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),b=r.getPosition();break}while(f!==17);return s.join("")}e.stripComments=E;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ye[54],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(l){this.executor=l,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(l){this._error=l}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=c}),define(ye[4],Ce([1,0,67,53]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let L=null;function R(b){L=b}if(e.setDisposableTracker=R,l){const b="__is_disposable_tracked__";R(new class{trackDisposable(u){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[b]||console.log(C)},3e3)}setParent(u,C){if(u&&u!==d.None)try{u[b]=!0}catch{}}markAsDisposed(u){if(u&&u!==d.None)try{u[b]=!0}catch{}}markAsSingleton(u){}})}function P(b){return L?.trackDisposable(b),b}function _(b){L?.markAsDisposed(b)}function g(b,u){L?.setParent(b,u)}function T(b,u){if(L)for(const C of b)L.setParent(C,u)}function k(b){return L?.markAsSingleton(b),b}e.markAsSingleton=k;function m(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.isDisposable=m;function D(b){if(A.Iterable.is(b)){const u=[];for(const C of b)if(C)try{C.dispose()}catch(y){u.push(y)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.dispose=D;function S(b){for(const u of b)m(u)&&u.dispose();return[]}e.disposeIfDisposable=S;function v(...b){const u=n(()=>D(b));return T(b,u),u}e.combinedDisposable=v;function n(b){const u=P({dispose:(0,c.once)(()=>{_(u),b()})});return u}e.toDisposable=n;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{D(this._toDispose)}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return g(u,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new h,P(this),g(this._store,this)}dispose(){_(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&g(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&g(u,null),u}}e.MutableDisposable=w;class E{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=E;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(u){let C=u;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,_(this))},this}}e.SafeDisposable=p;class t{constructor(){this.references=new Map}acquire(u,...C){let y=this.references.get(u);y||(y={counter:0,object:this.createReferencedObject(u,...C)},this.references.set(u,y));const{object:o}=y,i=(0,c.once)(()=>{--y.counter===0&&(this.destroyReferencedObject(u,y.object),this.references.delete(u))});return y.counter++,{object:o,dispose:i}}}e.ReferenceCollection=t;class a{constructor(u){this.referenceCollection=u}async acquire(u,...C){const y=this.referenceCollection.acquire(u,...C);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(o){throw y.dispose(),o}}}e.AsyncReferenceCollection=a;class r{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=r;function s(b){const u=new h;try{b(u)}finally{u.dispose()}}e.disposeOnReturn=s;class f{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){_(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{D(this._store.values())}finally{this._store.clear()}}has(u){return this._store.has(u)}get(u){return this._store.get(u)}set(u,C,y=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this._store.get(u)?.dispose(),this._store.set(u,C)}deleteAndDispose(u){this._store.get(u)?.dispose(),this._store.delete(u)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=f}),define(ye[68],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(L){this.element=L,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class A{constructor(){this._first=c.Undefined,this._last=c.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===c.Undefined}clear(){let L=this._first;for(;L!==c.Undefined;){const R=L.next;L.prev=c.Undefined,L.next=c.Undefined,L=R}this._first=c.Undefined,this._last=c.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,R){const P=new c(L);if(this._first===c.Undefined)this._first=P,this._last=P;else if(R){const g=this._last;this._last=P,P.prev=g,g.next=P}else{const g=this._first;this._first=P,P.next=g,g.prev=P}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(P))}}shift(){if(this._first!==c.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==c.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==c.Undefined&&L.next!==c.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===c.Undefined&&L.next===c.Undefined?(this._first=c.Undefined,this._last=c.Undefined):L.next===c.Undefined?(this._last=this._last.prev,this._last.next=c.Undefined):L.prev===c.Undefined&&(this._first=this._first.next,this._first.prev=c.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==c.Undefined;)yield L.element,L=L.next}}e.LinkedList=A}),define(ye[28],Ce([1,0]),function(re,e){"use strict";var c,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(v,n,h){let d=v.get(n);return d===void 0&&(d=h,v.set(n,d)),d}e.getOrSet=L;function R(v){const n=[];return v.forEach((h,d)=>{n.push(`${d} => ${h}`)}),`Map(${v.size}) {${n.join(", ")}}`}e.mapToString=R;function P(v){const n=[];return v.forEach(h=>{n.push(h)}),`Set(${v.size}) {${n.join(", ")}}`}e.setToString=P;class _{constructor(n,h){this.uri=n,this.value=h}}class g{constructor(n,h){this[c]="ResourceMap",n instanceof g?(this.map=new Map(n.map),this.toKey=h??g.defaultToKey):(this.map=new Map,this.toKey=n??g.defaultToKey)}set(n,h){return this.map.set(this.toKey(n),new _(n,h)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,h){typeof h<"u"&&(n=n.bind(h));for(const[d,w]of this.map)n(w.value,w.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=g,g.defaultToKey=v=>v.toString();class T{constructor(n,h){this[A]="ResourceSet",!n||typeof n=="function"?this._map=new g(n):(this._map=new g(h),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,h){this._map.forEach((d,w)=>n.call(h,w,w,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var k;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class m{constructor(){this[l]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,h=0){const d=this._map.get(n);if(d)return h!==0&&this.touch(d,h),d.value}set(n,h,d=0){let w=this._map.get(n);if(w)w.value=h,d!==0&&this.touch(w,d);else{switch(w={key:n,value:h,next:void 0,previous:void 0},d){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(n,w),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const h=this._map.get(n);if(h)return this._map.delete(n),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,h){const d=this._state;let w=this._head;for(;w;){if(h?n.bind(h)(w.value,w.key,this):n(w.value,w.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const n=this,h=this._state;let d=this._head;const w={[Symbol.iterator](){return w},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const E={value:d.key,done:!1};return d=d.next,E}else return{value:void 0,done:!0}}};return w}values(){const n=this,h=this._state;let d=this._head;const w={[Symbol.iterator](){return w},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const E={value:d.value,done:!1};return d=d.next,E}else return{value:void 0,done:!0}}};return w}entries(){const n=this,h=this._state;let d=this._head;const w={[Symbol.iterator](){return w},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const E={value:[d.key,d.value],done:!1};return d=d.next,E}else return{value:void 0,done:!0}}};return w}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let h=this._head,d=this.size;for(;h&&d>n;)this._map.delete(h.key),h=h.next,d--;this._head=h,this._size=d,h&&(h.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const h=n.next,d=n.previous;if(!h||!d)throw new Error("Invalid list");h.previous=d,d.next=h}n.next=void 0,n.previous=void 0,this._state++}touch(n,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(n===this._head)return;const d=n.next,w=n.previous;n===this._tail?(w.next=void 0,this._tail=w):(d.previous=w,w.next=d),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(h===2){if(n===this._tail)return;const d=n.next,w=n.previous;n===this._head?(d.previous=void 0,this._head=d):(d.previous=w,w.next=d),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((h,d)=>{n.push([d,h])}),n}fromJSON(n){this.clear();for(const[h,d]of n)this.set(h,d)}}e.LinkedMap=m;class D extends m{constructor(n,h=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,h=2){return super.get(n,h)}peek(n){return super.get(n,0)}set(n,h){return super.set(n,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=D;class S{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let h=this.map.get(n)||0;return h===0?!1:(h--,h===0?this.map.delete(n):this.map.set(n,h),!0)}has(n){return this.map.has(n)}}e.CounterSet=S}),function(re,e){typeof define=="function"&&define.amd?define(ye[151],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(Z,ne){for(var le=0;le<ne.length;le++){var te=ne[le];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Z,te.key,te)}}function c(Z,ne,le){return ne&&e(Z.prototype,ne),le&&e(Z,le),Object.defineProperty(Z,"prototype",{writable:!1}),Z}function A(Z,ne){if(Z){if(typeof Z=="string")return l(Z,ne);var le=Object.prototype.toString.call(Z).slice(8,-1);if(le==="Object"&&Z.constructor&&(le=Z.constructor.name),le==="Map"||le==="Set")return Array.from(Z);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return l(Z,ne)}}function l(Z,ne){(ne==null||ne>Z.length)&&(ne=Z.length);for(var le=0,te=new Array(ne);le<ne;le++)te[le]=Z[le];return te}function L(Z,ne){var le=typeof Symbol<"u"&&Z[Symbol.iterator]||Z["@@iterator"];if(le)return(le=le.call(Z)).next.bind(le);if(Array.isArray(Z)||(le=A(Z))||ne&&Z&&typeof Z.length=="number"){le&&(Z=le);var te=0;return function(){return te>=Z.length?{done:!0}:{done:!1,value:Z[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=R();function P(Z){re.defaults=Z}var _=/[&<>"']/,g=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(ne){return m[ne]};function S(Z,ne){if(ne){if(_.test(Z))return Z.replace(g,D)}else if(T.test(Z))return Z.replace(k,D);return Z}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(Z){return Z.replace(v,function(ne,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var h=/(^|[^\[])\^/g;function d(Z,ne){Z=typeof Z=="string"?Z:Z.source,ne=ne||"";var le={replace:function(de,oe){return oe=oe.source||oe,oe=oe.replace(h,"$1"),Z=Z.replace(de,oe),le},getRegex:function(){return new RegExp(Z,ne)}};return le}var w=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Z,ne,le){if(Z){var te;try{te=decodeURIComponent(n(le)).replace(w,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}ne&&!E.test(le)&&(le=f(ne,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Z,ne){t[" "+Z]||(a.test(Z)?t[" "+Z]=Z+"/":t[" "+Z]=y(Z,"/",!0)),Z=t[" "+Z];var le=Z.indexOf(":")===-1;return ne.substring(0,2)==="//"?le?ne:Z.replace(r,"$1")+ne:ne.charAt(0)==="/"?le?ne:Z.replace(s,"$1")+ne:Z+ne}var b={exec:function(){}};function u(Z){for(var ne=1,le,te;ne<arguments.length;ne++){le=arguments[ne];for(te in le)Object.prototype.hasOwnProperty.call(le,te)&&(Z[te]=le[te])}return Z}function C(Z,ne){var le=Z.replace(/\|/g,function(oe,ue,O){for(var q=!1,Q=ue;--Q>=0&&O[Q]==="\\";)q=!q;return q?"|":" |"}),te=le.split(/ \|/),de=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>ne)te.splice(ne);else for(;te.length<ne;)te.push("");for(;de<te.length;de++)te[de]=te[de].trim().replace(/\\\|/g,"|");return te}function y(Z,ne,le){var te=Z.length;if(te===0)return"";for(var de=0;de<te;){var oe=Z.charAt(te-de-1);if(oe===ne&&!le)de++;else if(oe!==ne&&le)de++;else break}return Z.slice(0,te-de)}function o(Z,ne){if(Z.indexOf(ne[1])===-1)return-1;for(var le=Z.length,te=0,de=0;de<le;de++)if(Z[de]==="\\")de++;else if(Z[de]===ne[0])te++;else if(Z[de]===ne[1]&&(te--,te<0))return de;return-1}function i(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Z,ne){if(ne<1)return"";for(var le="";ne>1;)ne&1&&(le+=Z),ne>>=1,Z+=Z;return le+Z}function F(Z,ne,le,te){var de=ne.href,oe=ne.title?S(ne.title):null,ue=Z[1].replace(/\\([\[\]])/g,"$1");if(Z[0].charAt(0)!=="!"){te.state.inLink=!0;var O={type:"link",raw:le,href:de,title:oe,text:ue,tokens:te.inlineTokens(ue)};return te.state.inLink=!1,O}return{type:"image",raw:le,href:de,title:oe,text:S(ue)}}function U(Z,ne){var le=Z.match(/^(\s+)(?:```)/);if(le===null)return ne;var te=le[1];return ne.split(`
`).map(function(de){var oe=de.match(/^\s+/);if(oe===null)return de;var ue=oe[0];return ue.length>=te.length?de.slice(te.length):de}).join(`
`)}var $=function(){function Z(le){this.options=le||re.defaults}var ne=Z.prototype;return ne.space=function(te){var de=this.rules.block.newline.exec(te);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ne.code=function(te){var de=this.rules.block.code.exec(te);if(de){var oe=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:y(oe,`
`)}}},ne.fences=function(te){var de=this.rules.block.fences.exec(te);if(de){var oe=de[0],ue=U(oe,de[3]||"");return{type:"code",raw:oe,lang:de[2]?de[2].trim():de[2],text:ue}}},ne.heading=function(te){var de=this.rules.block.heading.exec(te);if(de){var oe=de[2].trim();if(/#$/.test(oe)){var ue=y(oe,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(oe=ue.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:oe,tokens:this.lexer.inline(oe)}}},ne.hr=function(te){var de=this.rules.block.hr.exec(te);if(de)return{type:"hr",raw:de[0]}},ne.blockquote=function(te){var de=this.rules.block.blockquote.exec(te);if(de){var oe=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},ne.list=function(te){var de=this.rules.block.list.exec(te);if(de){var oe,ue,O,q,Q,ie,pe,De,he,Ae,Te,He,Ve=de[1].trim(),tt=Ve.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=tt?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=tt?Ve:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&(He=!1,!(!(de=Ke.exec(te))||this.rules.block.hr.test(te)));){if(oe=de[0],te=te.substring(oe.length),De=de[2].split(`
`,1)[0],he=te.split(`
`,1)[0],this.options.pedantic?(q=2,Te=De.trimLeft()):(q=de[2].search(/[^ ]/),q=q>4?1:q,Te=De.slice(q),q+=de[1].length),ie=!1,!De&&/^ *$/.test(he)&&(oe+=he+`
`,te=te.substring(he.length+1),He=!0),!He)for(var nt=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),xe=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");te&&(Ae=te.split(`
`,1)[0],De=Ae,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(De)||xe.test(De)||nt.test(De)||ot.test(te)));){if(De.search(/[^ ]/)>=q||!De.trim())Te+=`
`+De.slice(q);else if(!ie)Te+=`
`+De;else break;!ie&&!De.trim()&&(ie=!0),oe+=Ae+`
`,te=te.substring(Ae.length+1)}Xe.loose||(pe?Xe.loose=!0:/\n *\n *$/.test(oe)&&(pe=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(Te),ue&&(O=ue[0]!=="[ ] ",Te=Te.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:oe,task:!!ue,checked:O,loose:!1,text:Te}),Xe.raw+=oe}Xe.items[Xe.items.length-1].raw=oe.trimRight(),Xe.items[Xe.items.length-1].text=Te.trimRight(),Xe.raw=Xe.raw.trimRight();var Ie=Xe.items.length;for(Q=0;Q<Ie;Q++){this.lexer.state.top=!1,Xe.items[Q].tokens=this.lexer.blockTokens(Xe.items[Q].text,[]);var K=Xe.items[Q].tokens.filter(function(me){return me.type==="space"}),Y=K.every(function(me){for(var Fe=me.raw.split(""),We=0,ze=L(Fe),Ye;!(Ye=ze()).done;){var ct=Ye.value;if(ct===`
`&&(We+=1),We>1)return!0}return!1});!Xe.loose&&K.length&&Y&&(Xe.loose=!0,Xe.items[Q].loose=!0)}return Xe}},ne.html=function(te){var de=this.rules.block.html.exec(te);if(de){var oe={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(de[0]):S(de[0]);oe.type="paragraph",oe.text=ue,oe.tokens=this.lexer.inline(ue)}return oe}},ne.def=function(te){var de=this.rules.block.def.exec(te);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var oe=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:de[0],href:de[2],title:de[3]}}},ne.table=function(te){var de=this.rules.block.table.exec(te);if(de){var oe={type:"table",header:C(de[1]).map(function(pe){return{text:pe}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=de[0];var ue=oe.align.length,O,q,Q,ie;for(O=0;O<ue;O++)/^ *-+: *$/.test(oe.align[O])?oe.align[O]="right":/^ *:-+: *$/.test(oe.align[O])?oe.align[O]="center":/^ *:-+ *$/.test(oe.align[O])?oe.align[O]="left":oe.align[O]=null;for(ue=oe.rows.length,O=0;O<ue;O++)oe.rows[O]=C(oe.rows[O],oe.header.length).map(function(pe){return{text:pe}});for(ue=oe.header.length,q=0;q<ue;q++)oe.header[q].tokens=this.lexer.inline(oe.header[q].text);for(ue=oe.rows.length,q=0;q<ue;q++)for(ie=oe.rows[q],Q=0;Q<ie.length;Q++)ie[Q].tokens=this.lexer.inline(ie[Q].text);return oe}}},ne.lheading=function(te){var de=this.rules.block.lheading.exec(te);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ne.paragraph=function(te){var de=this.rules.block.paragraph.exec(te);if(de){var oe=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:oe,tokens:this.lexer.inline(oe)}}},ne.text=function(te){var de=this.rules.block.text.exec(te);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ne.escape=function(te){var de=this.rules.inline.escape.exec(te);if(de)return{type:"escape",raw:de[0],text:S(de[1])}},ne.tag=function(te){var de=this.rules.inline.tag.exec(te);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):S(de[0]):de[0]}},ne.link=function(te){var de=this.rules.inline.link.exec(te);if(de){var oe=de[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var ue=y(oe.slice(0,-1),"\\");if((oe.length-ue.length)%2===0)return}else{var O=o(de[2],"()");if(O>-1){var q=de[0].indexOf("!")===0?5:4,Q=q+de[1].length+O;de[2]=de[2].substring(0,O),de[0]=de[0].substring(0,Q).trim(),de[3]=""}}var ie=de[2],pe="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ie);De&&(ie=De[1],pe=De[3])}else pe=de[3]?de[3].slice(1,-1):"";return ie=ie.trim(),/^</.test(ie)&&(this.options.pedantic&&!/>$/.test(oe)?ie=ie.slice(1):ie=ie.slice(1,-1)),F(de,{href:ie&&ie.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ne.reflink=function(te,de){var oe;if((oe=this.rules.inline.reflink.exec(te))||(oe=this.rules.inline.nolink.exec(te))){var ue=(oe[2]||oe[1]).replace(/\s+/g," ");if(ue=de[ue.toLowerCase()],!ue||!ue.href){var O=oe[0].charAt(0);return{type:"text",raw:O,text:O}}return F(oe,ue,oe[0],this.lexer)}},ne.emStrong=function(te,de,oe){oe===void 0&&(oe="");var ue=this.rules.inline.emStrong.lDelim.exec(te);if(ue&&!(ue[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ue[1]||ue[2]||"";if(!O||O&&(oe===""||this.rules.inline.punctuation.exec(oe))){var q=ue[0].length-1,Q,ie,pe=q,De=0,he=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(he.lastIndex=0,de=de.slice(-1*te.length+q);(ue=he.exec(de))!=null;)if(Q=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Q){if(ie=Q.length,ue[3]||ue[4]){pe+=ie;continue}else if((ue[5]||ue[6])&&q%3&&!((q+ie)%3)){De+=ie;continue}if(pe-=ie,!(pe>0)){if(ie=Math.min(ie,ie+pe+De),Math.min(q,ie)%2){var Ae=te.slice(1,q+ue.index+ie);return{type:"em",raw:te.slice(0,q+ue.index+ie+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var Te=te.slice(2,q+ue.index+ie-1);return{type:"strong",raw:te.slice(0,q+ue.index+ie+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}}}}},ne.codespan=function(te){var de=this.rules.inline.code.exec(te);if(de){var oe=de[2].replace(/\n/g," "),ue=/[^ ]/.test(oe),O=/^ /.test(oe)&&/ $/.test(oe);return ue&&O&&(oe=oe.substring(1,oe.length-1)),oe=S(oe,!0),{type:"codespan",raw:de[0],text:oe}}},ne.br=function(te){var de=this.rules.inline.br.exec(te);if(de)return{type:"br",raw:de[0]}},ne.del=function(te){var de=this.rules.inline.del.exec(te);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ne.autolink=function(te,de){var oe=this.rules.inline.autolink.exec(te);if(oe){var ue,O;return oe[2]==="@"?(ue=S(this.options.mangle?de(oe[1]):oe[1]),O="mailto:"+ue):(ue=S(oe[1]),O=ue),{type:"link",raw:oe[0],text:ue,href:O,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.url=function(te,de){var oe;if(oe=this.rules.inline.url.exec(te)){var ue,O;if(oe[2]==="@")ue=S(this.options.mangle?de(oe[0]):oe[0]),O="mailto:"+ue;else{var q;do q=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(q!==oe[0]);ue=S(oe[0]),oe[1]==="www."?O="http://"+ue:O=ue}return{type:"link",raw:oe[0],text:ue,href:O,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.inlineText=function(te,de){var oe=this.rules.inline.text.exec(te);if(oe){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):S(oe[0]):oe[0]:ue=S(this.options.smartypants?de(oe[0]):oe[0]),{type:"text",raw:oe[0],text:ue}}},Z}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=d(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=d(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=d(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=d(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=d(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=d(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=u({},B),B.gfm=u({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=d(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=d(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=u({},B.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:d(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=d(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=d(B._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=d(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=d(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=d(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=d(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=d(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=d(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=d(N.reflink).replace("label",N._label).replace("ref",B._label).getRegex(),N.nolink=d(N.nolink).replace("ref",B._label).getRegex(),N.reflinkSearch=d(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=u({},N),N.pedantic=u({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=u({},N.normal,{escape:d(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=d(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=u({},N.gfm,{br:d(N.br).replace("{2,}","*").getRegex(),text:d(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Z){var ne="",le,te,de=Z.length;for(le=0;le<de;le++)te=Z.charCodeAt(le),Math.random()>.5&&(te="x"+te.toString(16)),ne+="&#"+te+";";return ne}var W=function(){function Z(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||re.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:B.normal,inline:N.normal};this.options.pedantic?(te.block=B.pedantic,te.inline=N.pedantic):this.options.gfm&&(te.block=B.gfm,this.options.breaks?te.inline=N.breaks:te.inline=N.gfm),this.tokenizer.rules=te}Z.lex=function(te,de){var oe=new Z(de);return oe.lex(te)},Z.lexInline=function(te,de){var oe=new Z(de);return oe.inlineTokens(te)};var ne=Z.prototype;return ne.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ne.blockTokens=function(te,de){var oe=this;de===void 0&&(de=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(pe,De,he){return De+"    ".repeat(he.length)});for(var ue,O,q,Q;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(ue=pe.call({lexer:oe},te,de))?(te=te.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.space(te)){te=te.substring(ue.raw.length),ue.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ue);continue}if(ue=this.tokenizer.code(te)){te=te.substring(ue.raw.length),O=de[de.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):de.push(ue);continue}if(ue=this.tokenizer.fences(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.heading(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.hr(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.blockquote(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.list(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.html(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.def(te)){te=te.substring(ue.raw.length),O=de[de.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.lheading(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(q=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,De=te.slice(1),he=void 0;oe.options.extensions.startBlock.forEach(function(Ae){he=Ae.call({lexer:this},De),typeof he=="number"&&he>=0&&(pe=Math.min(pe,he))}),pe<1/0&&pe>=0&&(q=te.substring(0,pe+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(q))){O=de[de.length-1],Q&&O.type==="paragraph"?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):de.push(ue),Q=q.length!==te.length,te=te.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(te)){te=te.substring(ue.raw.length),O=de[de.length-1],O&&O.type==="text"?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):de.push(ue);continue}if(te){var ie="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ie);break}else throw new Error(ie)}}return this.state.top=!0,de},ne.inline=function(te,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:te,tokens:de}),de},ne.inlineTokens=function(te,de){var oe=this;de===void 0&&(de=[]);var ue,O,q,Q=te,ie,pe,De;if(this.tokens.links){var he=Object.keys(this.tokens.links);if(he.length>0)for(;(ie=this.tokenizer.rules.inline.reflinkSearch.exec(Q))!=null;)he.includes(ie[0].slice(ie[0].lastIndexOf("[")+1,-1))&&(Q=Q.slice(0,ie.index)+"["+I("a",ie[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ie=this.tokenizer.rules.inline.blockSkip.exec(Q))!=null;)Q=Q.slice(0,ie.index)+"["+I("a",ie[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ie=this.tokenizer.rules.inline.escapedEmSt.exec(Q))!=null;)Q=Q.slice(0,ie.index)+"++"+Q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(pe||(De=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Te){return(ue=Te.call({lexer:oe},te,de))?(te=te.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.tag(te)){te=te.substring(ue.raw.length),O=de[de.length-1],O&&ue.type==="text"&&O.type==="text"?(O.raw+=ue.raw,O.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.link(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(ue.raw.length),O=de[de.length-1],O&&ue.type==="text"&&O.type==="text"?(O.raw+=ue.raw,O.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.emStrong(te,Q,De)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.codespan(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.br(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.del(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.autolink(te,x)){te=te.substring(ue.raw.length),de.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(te,x))){te=te.substring(ue.raw.length),de.push(ue);continue}if(q=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Te=1/0,He=te.slice(1),Ve=void 0;oe.options.extensions.startInline.forEach(function(tt){Ve=tt.call({lexer:this},He),typeof Ve=="number"&&Ve>=0&&(Te=Math.min(Te,Ve))}),Te<1/0&&Te>=0&&(q=te.substring(0,Te+1))}(),ue=this.tokenizer.inlineText(q,V)){te=te.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(De=ue.raw.slice(-1)),pe=!0,O=de[de.length-1],O&&O.type==="text"?(O.raw+=ue.raw,O.text+=ue.text):de.push(ue);continue}if(te){var Ae="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return de},c(Z,null,[{key:"rules",get:function(){return{block:B,inline:N}}}]),Z}(),ee=function(){function Z(le){this.options=le||re.defaults}var ne=Z.prototype;return ne.code=function(te,de,oe){var ue=(de||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(te,ue);O!=null&&O!==te&&(oe=!0,te=O)}return te=te.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+S(ue,!0)+'">'+(oe?te:S(te,!0))+`</code></pre>
`:"<pre><code>"+(oe?te:S(te,!0))+`</code></pre>
`},ne.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},ne.html=function(te){return te},ne.heading=function(te,de,oe,ue){if(this.options.headerIds){var O=this.options.headerPrefix+ue.slug(oe);return"<h"+de+' id="'+O+'">'+te+"</h"+de+`>
`}return"<h"+de+">"+te+"</h"+de+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(te,de,oe){var ue=de?"ol":"ul",O=de&&oe!==1?' start="'+oe+'"':"";return"<"+ue+O+`>
`+te+"</"+ue+`>
`},ne.listitem=function(te){return"<li>"+te+`</li>
`},ne.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(te){return"<p>"+te+`</p>
`},ne.table=function(te,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+de+`</table>
`},ne.tablerow=function(te){return`<tr>
`+te+`</tr>
`},ne.tablecell=function(te,de){var oe=de.header?"th":"td",ue=de.align?"<"+oe+' align="'+de.align+'">':"<"+oe+">";return ue+te+("</"+oe+`>
`)},ne.strong=function(te){return"<strong>"+te+"</strong>"},ne.em=function(te){return"<em>"+te+"</em>"},ne.codespan=function(te){return"<code>"+te+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(te){return"<del>"+te+"</del>"},ne.link=function(te,de,oe){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var ue='<a href="'+S(te)+'"';return de&&(ue+=' title="'+de+'"'),ue+=">"+oe+"</a>",ue},ne.image=function(te,de,oe){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var ue='<img src="'+te+'" alt="'+oe+'"';return de&&(ue+=' title="'+de+'"'),ue+=this.options.xhtml?"/>":">",ue},ne.text=function(te){return te},Z}(),se=function(){function Z(){}var ne=Z.prototype;return ne.strong=function(te){return te},ne.em=function(te){return te},ne.codespan=function(te){return te},ne.del=function(te){return te},ne.html=function(te){return te},ne.text=function(te){return te},ne.link=function(te,de,oe){return""+oe},ne.image=function(te,de,oe){return""+oe},ne.br=function(){return""},Z}(),H=function(){function Z(){this.seen={}}var ne=Z.prototype;return ne.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(te,de){var oe=te,ue=0;if(this.seen.hasOwnProperty(oe)){ue=this.seen[te];do ue++,oe=te+"-"+ue;while(this.seen.hasOwnProperty(oe))}return de||(this.seen[te]=ue,this.seen[oe]=0),oe},ne.slug=function(te,de){de===void 0&&(de={});var oe=this.serialize(te);return this.getNextSafeSlug(oe,de.dryrun)},Z}(),J=function(){function Z(le){this.options=le||re.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new H}Z.parse=function(te,de){var oe=new Z(de);return oe.parse(te)},Z.parseInline=function(te,de){var oe=new Z(de);return oe.parseInline(te)};var ne=Z.prototype;return ne.parse=function(te,de){de===void 0&&(de=!0);var oe="",ue,O,q,Q,ie,pe,De,he,Ae,Te,He,Ve,tt,Xe,Ke,nt,ot,et,xe,Ie=te.length;for(ue=0;ue<Ie;ue++){if(Te=te[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(xe=this.options.extensions.renderers[Te.type].call({parser:this},Te),xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Te.type))){oe+=xe||"";continue}switch(Te.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Te.tokens),Te.depth,n(this.parseInline(Te.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Te.text,Te.lang,Te.escaped);continue}case"table":{for(he="",De="",Q=Te.header.length,O=0;O<Q;O++)De+=this.renderer.tablecell(this.parseInline(Te.header[O].tokens),{header:!0,align:Te.align[O]});for(he+=this.renderer.tablerow(De),Ae="",Q=Te.rows.length,O=0;O<Q;O++){for(pe=Te.rows[O],De="",ie=pe.length,q=0;q<ie;q++)De+=this.renderer.tablecell(this.parseInline(pe[q].tokens),{header:!1,align:Te.align[q]});Ae+=this.renderer.tablerow(De)}oe+=this.renderer.table(he,Ae);continue}case"blockquote":{Ae=this.parse(Te.tokens),oe+=this.renderer.blockquote(Ae);continue}case"list":{for(He=Te.ordered,Ve=Te.start,tt=Te.loose,Q=Te.items.length,Ae="",O=0;O<Q;O++)Ke=Te.items[O],nt=Ke.checked,ot=Ke.task,Xe="",Ke.task&&(et=this.renderer.checkbox(nt),tt?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=et+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=et+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:et}):Xe+=et),Xe+=this.parse(Ke.tokens,tt),Ae+=this.renderer.listitem(Xe,ot,nt);oe+=this.renderer.list(Ae,He,Ve);continue}case"html":{oe+=this.renderer.html(Te.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Te.tokens));continue}case"text":{for(Ae=Te.tokens?this.parseInline(Te.tokens):Te.text;ue+1<Ie&&te[ue+1].type==="text";)Te=te[++ue],Ae+=`
`+(Te.tokens?this.parseInline(Te.tokens):Te.text);oe+=de?this.renderer.paragraph(Ae):Ae;continue}default:{var K='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return oe},ne.parseInline=function(te,de){de=de||this.renderer;var oe="",ue,O,q,Q=te.length;for(ue=0;ue<Q;ue++){if(O=te[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(q=this.options.extensions.renderers[O.type].call({parser:this},O),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){oe+=q||"";continue}switch(O.type){case"escape":{oe+=de.text(O.text);break}case"html":{oe+=de.html(O.text);break}case"link":{oe+=de.link(O.href,O.title,this.parseInline(O.tokens,de));break}case"image":{oe+=de.image(O.href,O.title,O.text);break}case"strong":{oe+=de.strong(this.parseInline(O.tokens,de));break}case"em":{oe+=de.em(this.parseInline(O.tokens,de));break}case"codespan":{oe+=de.codespan(O.text);break}case"br":{oe+=de.br();break}case"del":{oe+=de.del(this.parseInline(O.tokens,de));break}case"text":{oe+=de.text(O.text);break}default:{var ie='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(ie);return}else throw new Error(ie)}}}return oe},Z}();function j(Z,ne,le){if(typeof Z>"u"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof ne=="function"&&(le=ne,ne=null),ne=u({},j.defaults,ne||{}),i(ne),le){var te=ne.highlight,de;try{de=W.lex(Z,ne)}catch(Q){return le(Q)}var oe=function(ie){var pe;if(!ie)try{ne.walkTokens&&j.walkTokens(de,ne.walkTokens),pe=J.parse(de,ne)}catch(De){ie=De}return ne.highlight=te,ie?le(ie):le(null,pe)};if(!te||te.length<3||(delete ne.highlight,!de.length))return oe();var ue=0;j.walkTokens(de,function(Q){Q.type==="code"&&(ue++,setTimeout(function(){te(Q.text,Q.lang,function(ie,pe){if(ie)return oe(ie);pe!=null&&pe!==Q.text&&(Q.text=pe,Q.escaped=!0),ue--,ue===0&&oe()})},0))}),ue===0&&oe();return}function O(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+S(Q.message+"",!0)+"</pre>";throw Q}try{var q=W.lex(Z,ne);if(ne.walkTokens){if(ne.async)return Promise.all(j.walkTokens(q,ne.walkTokens)).then(function(){return J.parse(q,ne)}).catch(O);j.walkTokens(q,ne.walkTokens)}return J.parse(q,ne)}catch(Q){O(Q)}}j.options=j.setOptions=function(Z){return u(j.defaults,Z),P(j.defaults),j},j.getDefaults=R,j.defaults=re.defaults,j.use=function(){for(var Z=arguments.length,ne=new Array(Z),le=0;le<Z;le++)ne[le]=arguments[le];var te=u.apply(void 0,[{}].concat(ne)),de=j.defaults.extensions||{renderers:{},childTokens:{}},oe;ne.forEach(function(ue){if(ue.extensions&&(oe=!0,ue.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var Q=de.renderers?de.renderers[q.name]:null;Q?de.renderers[q.name]=function(){for(var ie=arguments.length,pe=new Array(ie),De=0;De<ie;De++)pe[De]=arguments[De];var he=q.renderer.apply(this,pe);return he===!1&&(he=Q.apply(this,pe)),he}:de.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[q.level]?de[q.level].unshift(q.tokenizer):de[q.level]=[q.tokenizer],q.start&&(q.level==="block"?de.startBlock?de.startBlock.push(q.start):de.startBlock=[q.start]:q.level==="inline"&&(de.startInline?de.startInline.push(q.start):de.startInline=[q.start]))}q.childTokens&&(de.childTokens[q.name]=q.childTokens)})),ue.renderer&&function(){var q=j.defaults.renderer||new ee,Q=function(De){var he=q[De];q[De]=function(){for(var Ae=arguments.length,Te=new Array(Ae),He=0;He<Ae;He++)Te[He]=arguments[He];var Ve=ue.renderer[De].apply(q,Te);return Ve===!1&&(Ve=he.apply(q,Te)),Ve}};for(var ie in ue.renderer)Q(ie);te.renderer=q}(),ue.tokenizer&&function(){var q=j.defaults.tokenizer||new $,Q=function(De){var he=q[De];q[De]=function(){for(var Ae=arguments.length,Te=new Array(Ae),He=0;He<Ae;He++)Te[He]=arguments[He];var Ve=ue.tokenizer[De].apply(q,Te);return Ve===!1&&(Ve=he.apply(q,Te)),Ve}};for(var ie in ue.tokenizer)Q(ie);te.tokenizer=q}(),ue.walkTokens){var O=j.defaults.walkTokens;te.walkTokens=function(q){var Q=[];return Q.push(ue.walkTokens.call(this,q)),O&&(Q=Q.concat(O.call(this,q))),Q}}oe&&(te.extensions=de),j.setOptions(te)})},j.walkTokens=function(Z,ne){for(var le=[],te=function(){var O=oe.value;switch(le=le.concat(ne.call(j,O)),O.type){case"table":{for(var q=L(O.header),Q;!(Q=q()).done;){var ie=Q.value;le=le.concat(j.walkTokens(ie.tokens,ne))}for(var pe=L(O.rows),De;!(De=pe()).done;)for(var he=De.value,Ae=L(he),Te;!(Te=Ae()).done;){var He=Te.value;le=le.concat(j.walkTokens(He.tokens,ne))}break}case"list":{le=le.concat(j.walkTokens(O.items,ne));break}default:j.defaults.extensions&&j.defaults.extensions.childTokens&&j.defaults.extensions.childTokens[O.type]?j.defaults.extensions.childTokens[O.type].forEach(function(Ve){le=le.concat(j.walkTokens(O[Ve],ne))}):O.tokens&&(le=le.concat(j.walkTokens(O.tokens,ne)))}},de=L(Z),oe;!(oe=de()).done;)te();return le},j.parseInline=function(Z,ne){if(typeof Z>"u"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");ne=u({},j.defaults,ne||{}),i(ne);try{var le=W.lexInline(Z,ne);return ne.walkTokens&&j.walkTokens(le,ne.walkTokens),J.parseInline(le,ne)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+S(te.message+"",!0)+"</pre>";throw te}},j.Parser=J,j.parser=J.parse,j.Renderer=ee,j.TextRenderer=se,j.Lexer=W,j.lexer=W.lex,j.Tokenizer=$,j.Slugger=H,j.parse=j;var ae=j.options,we=j.setOptions,_e=j.use,ve=j.walkTokens,M=j.parseInline,X=j,fe=J.parse,Ee=W.lex;re.Lexer=W,re.Parser=J,re.Renderer=ee,re.Slugger=H,re.TextRenderer=se,re.Tokenizer=$,re.getDefaults=R,re.lexer=Ee,re.marked=j,re.options=ae,re.parse=X,re.parseInline=M,re.parser=fe,re.setOptions=we,re.use=_e,re.walkTokens=ve,Object.defineProperty(re,"__esModule",{value:!0})}),define(ye[69],Ce([1,0,28]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new c.LRUCache(1e4);function l(g){return _(g,"NFC",A)}e.normalizeNFC=l;const L=new c.LRUCache(1e4);function R(g){return _(g,"NFD",L)}e.normalizeNFD=R;const P=/[^\u0000-\u0080]/;function _(g,T,k){if(!g)return g;const m=k.get(g);if(m)return m;let D;return P.test(g)?D=g.normalize(T):D=g,k.set(g,D),D}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(T){return R(T).replace(g,"")}}()}),define(ye[110],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(P,_,g){return Math.min(Math.max(P,_),g)}e.clamp=c;function A(P,_){return(_+P%_)%_}e.rot=A;class l{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=l;class L{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class R{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const g=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=g,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function re(l){const L=[];typeof l=="number"&&L.push("code/timeOrigin",l);function R(_){L.push(_,Date.now())}function P(){const _=[];for(let g=0;g<L.length;g+=2)_.push({name:L[g],startTime:L[g+1]});return _}return{mark:R,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(l+R.startTime)});return L}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=c(A))}(),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var A in c)(typeof exports=="object"?exports:re)[A]=c[A]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function c(A){if(e[A])return e[A].exports;var l=e[A]={i:A,l:!1,exports:{}};return re[A].call(l.exports,l,l.exports,c),l.l=!0,l.exports}return c.m=re,c.c=e,c.d=function(A,l,L){c.o(A,l)||Object.defineProperty(A,l,{enumerable:!0,get:L})},c.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},c.t=function(A,l){if(1&l&&(A=c(A)),8&l||4&l&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(c.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&l&&typeof A!="string")for(var R in A)c.d(L,R,function(P){return A[P]}.bind(null,R));return L},c.n=function(A){var l=A&&A.__esModule?function(){return A.default}:function(){return A};return c.d(l,"a",l),l},c.o=function(A,l){return Object.prototype.hasOwnProperty.call(A,l)},c.p="",c(c.s=0)}([function(re,e,c){(function(A){var l;e=re.exports=_e,l=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],_=e.src=[],g=0,T=g++;_[T]="0|[1-9]\\d*";var k=g++;_[k]="[0-9]+";var m=g++;_[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=g++;_[D]="("+_[T]+")\\.("+_[T]+")\\.("+_[T]+")";var S=g++;_[S]="("+_[k]+")\\.("+_[k]+")\\.("+_[k]+")";var v=g++;_[v]="(?:"+_[T]+"|"+_[m]+")";var n=g++;_[n]="(?:"+_[k]+"|"+_[m]+")";var h=g++;_[h]="(?:-("+_[v]+"(?:\\."+_[v]+")*))";var d=g++;_[d]="(?:-?("+_[n]+"(?:\\."+_[n]+")*))";var w=g++;_[w]="[0-9A-Za-z-]+";var E=g++;_[E]="(?:\\+("+_[w]+"(?:\\."+_[w]+")*))";var p=g++,t="v?"+_[D]+_[h]+"?"+_[E]+"?";_[p]="^"+t+"$";var a="[v=\\s]*"+_[S]+_[d]+"?"+_[E]+"?",r=g++;_[r]="^"+a+"$";var s=g++;_[s]="((?:<|>)?=?)";var f=g++;_[f]=_[k]+"|x|X|\\*";var b=g++;_[b]=_[T]+"|x|X|\\*";var u=g++;_[u]="[v=\\s]*("+_[b]+")(?:\\.("+_[b]+")(?:\\.("+_[b]+")(?:"+_[h]+")?"+_[E]+"?)?)?";var C=g++;_[C]="[v=\\s]*("+_[f]+")(?:\\.("+_[f]+")(?:\\.("+_[f]+")(?:"+_[d]+")?"+_[E]+"?)?)?";var y=g++;_[y]="^"+_[s]+"\\s*"+_[u]+"$";var o=g++;_[o]="^"+_[s]+"\\s*"+_[C]+"$";var i=g++;_[i]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=g++;_[I]="(?:~>?)";var F=g++;_[F]="(\\s*)"+_[I]+"\\s+",P[F]=new RegExp(_[F],"g");var U=g++;_[U]="^"+_[I]+_[u]+"$";var $=g++;_[$]="^"+_[I]+_[C]+"$";var B=g++;_[B]="(?:\\^)";var N=g++;_[N]="(\\s*)"+_[B]+"\\s+",P[N]=new RegExp(_[N],"g");var V=g++;_[V]="^"+_[B]+_[u]+"$";var x=g++;_[x]="^"+_[B]+_[C]+"$";var W=g++;_[W]="^"+_[s]+"\\s*("+a+")$|^$";var ee=g++;_[ee]="^"+_[s]+"\\s*("+t+")$|^$";var se=g++;_[se]="(\\s*)"+_[s]+"\\s*("+a+"|"+_[u]+")",P[se]=new RegExp(_[se],"g");var H=g++;_[H]="^\\s*("+_[u]+")\\s+-\\s+("+_[u]+")\\s*$";var J=g++;_[J]="^\\s*("+_[C]+")\\s+-\\s+("+_[C]+")\\s*$";var j=g++;_[j]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)l(ae,_[ae]),P[ae]||(P[ae]=new RegExp(_[ae]));function we(he,Ae){if(he instanceof _e)return he;if(typeof he!="string"||he.length>L||!(Ae?P[r]:P[p]).test(he))return null;try{return new _e(he,Ae)}catch{return null}}function _e(he,Ae){if(he instanceof _e){if(he.loose===Ae)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof _e))return new _e(he,Ae);l("SemVer",he,Ae),this.loose=Ae;var Te=he.trim().match(Ae?P[r]:P[p]);if(!Te)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+Te[1],this.minor=+Te[2],this.patch=+Te[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Te[4]?this.prerelease=Te[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var Ve=+He;if(Ve>=0&&Ve<R)return Ve}return He}):this.prerelease=[],this.build=Te[5]?Te[5].split("."):[],this.format()}e.parse=we,e.valid=function(he,Ae){var Te=we(he,Ae);return Te?Te.version:null},e.clean=function(he,Ae){var Te=we(he.trim().replace(/^[=v]+/,""),Ae);return Te?Te.version:null},e.SemVer=_e,_e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_e.prototype.toString=function(){return this.version},_e.prototype.compare=function(he){return l("SemVer.compare",this.version,this.loose,he),he instanceof _e||(he=new _e(he,this.loose)),this.compareMain(he)||this.comparePre(he)},_e.prototype.compareMain=function(he){return he instanceof _e||(he=new _e(he,this.loose)),M(this.major,he.major)||M(this.minor,he.minor)||M(this.patch,he.patch)},_e.prototype.comparePre=function(he){if(he instanceof _e||(he=new _e(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var Ae=0;do{var Te=this.prerelease[Ae],He=he.prerelease[Ae];if(l("prerelease compare",Ae,Te,He),Te===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(Te===void 0)return-1;if(Te!==He)return M(Te,He)}while(++Ae)},_e.prototype.inc=function(he,Ae){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ae),this.inc("pre",Ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ae),this.inc("pre",Ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Te=this.prerelease.length;--Te>=0;)typeof this.prerelease[Te]=="number"&&(this.prerelease[Te]++,Te=-2);Te===-1&&this.prerelease.push(0)}Ae&&(this.prerelease[0]===Ae?isNaN(this.prerelease[1])&&(this.prerelease=[Ae,0]):this.prerelease=[Ae,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,Ae,Te,He){typeof Te=="string"&&(He=Te,Te=void 0);try{return new _e(he,Te).inc(Ae,He).version}catch{return null}},e.diff=function(he,Ae){if(Z(he,Ae))return null;var Te=we(he),He=we(Ae);if(Te.prerelease.length||He.prerelease.length){for(var Ve in Te)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Te[Ve]!==He[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Te)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Te[Ve]!==He[Ve])return Ve},e.compareIdentifiers=M;var ve=/^[0-9]+$/;function M(he,Ae){var Te=ve.test(he),He=ve.test(Ae);return Te&&He&&(he=+he,Ae=+Ae),Te&&!He?-1:He&&!Te?1:he<Ae?-1:he>Ae?1:0}function X(he,Ae,Te){return new _e(he,Te).compare(new _e(Ae,Te))}function fe(he,Ae,Te){return X(he,Ae,Te)>0}function Ee(he,Ae,Te){return X(he,Ae,Te)<0}function Z(he,Ae,Te){return X(he,Ae,Te)===0}function ne(he,Ae,Te){return X(he,Ae,Te)!==0}function le(he,Ae,Te){return X(he,Ae,Te)>=0}function te(he,Ae,Te){return X(he,Ae,Te)<=0}function de(he,Ae,Te,He){var Ve;switch(Ae){case"===":typeof he=="object"&&(he=he.version),typeof Te=="object"&&(Te=Te.version),Ve=he===Te;break;case"!==":typeof he=="object"&&(he=he.version),typeof Te=="object"&&(Te=Te.version),Ve=he!==Te;break;case"":case"=":case"==":Ve=Z(he,Te,He);break;case"!=":Ve=ne(he,Te,He);break;case">":Ve=fe(he,Te,He);break;case">=":Ve=le(he,Te,He);break;case"<":Ve=Ee(he,Te,He);break;case"<=":Ve=te(he,Te,He);break;default:throw new TypeError("Invalid operator: "+Ae)}return Ve}function oe(he,Ae){if(he instanceof oe){if(he.loose===Ae)return he;he=he.value}if(!(this instanceof oe))return new oe(he,Ae);l("comparator",he,Ae),this.loose=Ae,this.parse(he),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(he,Ae){return M(Ae,he)},e.major=function(he,Ae){return new _e(he,Ae).major},e.minor=function(he,Ae){return new _e(he,Ae).minor},e.patch=function(he,Ae){return new _e(he,Ae).patch},e.compare=X,e.compareLoose=function(he,Ae){return X(he,Ae,!0)},e.rcompare=function(he,Ae,Te){return X(Ae,he,Te)},e.sort=function(he,Ae){return he.sort(function(Te,He){return e.compare(Te,He,Ae)})},e.rsort=function(he,Ae){return he.sort(function(Te,He){return e.rcompare(Te,He,Ae)})},e.gt=fe,e.lt=Ee,e.eq=Z,e.neq=ne,e.gte=le,e.lte=te,e.cmp=de,e.Comparator=oe;var ue={};function O(he,Ae){if(he instanceof O)return he.loose===Ae?he:new O(he.raw,Ae);if(he instanceof oe)return new O(he.value,Ae);if(!(this instanceof O))return new O(he,Ae);if(this.loose=Ae,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(Te){return this.parseRange(Te.trim())},this).filter(function(Te){return Te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function q(he){return!he||he.toLowerCase()==="x"||he==="*"}function Q(he,Ae,Te,He,Ve,tt,Xe,Ke,nt,ot,et,xe,Ie){return((Ae=q(Te)?"":q(He)?">="+Te+".0.0":q(Ve)?">="+Te+"."+He+".0":">="+Ae)+" "+(Ke=q(nt)?"":q(ot)?"<"+(+nt+1)+".0.0":q(et)?"<"+nt+"."+(+ot+1)+".0":xe?"<="+nt+"."+ot+"."+et+"-"+xe:"<="+Ke)).trim()}function ie(he,Ae){for(var Te=0;Te<he.length;Te++)if(!he[Te].test(Ae))return!1;if(Ae.prerelease.length){for(Te=0;Te<he.length;Te++)if(l(he[Te].semver),he[Te].semver!==ue&&he[Te].semver.prerelease.length>0){var He=he[Te].semver;if(He.major===Ae.major&&He.minor===Ae.minor&&He.patch===Ae.patch)return!0}return!1}return!0}function pe(he,Ae,Te){try{Ae=new O(Ae,Te)}catch{return!1}return Ae.test(he)}function De(he,Ae,Te,He){var Ve,tt,Xe,Ke,nt;switch(he=new _e(he,He),Ae=new O(Ae,He),Te){case">":Ve=fe,tt=te,Xe=Ee,Ke=">",nt=">=";break;case"<":Ve=Ee,tt=le,Xe=fe,Ke="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(he,Ae,He))return!1;for(var ot=0;ot<Ae.set.length;++ot){var et=Ae.set[ot],xe=null,Ie=null;if(et.forEach(function(K){K.semver===ue&&(K=new oe(">=0.0.0")),xe=xe||K,Ie=Ie||K,Ve(K.semver,xe.semver,He)?xe=K:Xe(K.semver,Ie.semver,He)&&(Ie=K)}),xe.operator===Ke||xe.operator===nt||(!Ie.operator||Ie.operator===Ke)&&tt(he,Ie.semver)||Ie.operator===nt&&Xe(he,Ie.semver))return!1}return!0}oe.prototype.parse=function(he){var Ae=this.loose?P[W]:P[ee],Te=he.match(Ae);if(!Te)throw new TypeError("Invalid comparator: "+he);this.operator=Te[1],this.operator==="="&&(this.operator=""),Te[2]?this.semver=new _e(Te[2],this.loose):this.semver=ue},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(he){return l("Comparator.test",he,this.loose),this.semver===ue||(typeof he=="string"&&(he=new _e(he,this.loose)),de(he,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(he,Ae){if(!(he instanceof oe))throw new TypeError("a Comparator is required");var Te;if(this.operator==="")return Te=new O(he.value,Ae),pe(this.value,Te,Ae);if(he.operator==="")return Te=new O(this.value,Ae),pe(he.semver,Te,Ae);var He=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),tt=this.semver.version===he.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),Ke=de(this.semver,"<",he.semver,Ae)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),nt=de(this.semver,">",he.semver,Ae)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return He||Ve||tt&&Xe||Ke||nt},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(he){var Ae=this.loose;he=he.trim(),l("range",he,Ae);var Te=Ae?P[J]:P[H];he=he.replace(Te,Q),l("hyphen replace",he),he=he.replace(P[se],"$1$2$3"),l("comparator trim",he,P[se]),he=(he=(he=he.replace(P[F],"$1~")).replace(P[N],"$1^")).split(/\s+/).join(" ");var He=Ae?P[W]:P[ee],Ve=he.split(" ").map(function(tt){return function(Xe,Ke){return l("comp",Xe),Xe=function(nt,ot){return nt.trim().split(/\s+/).map(function(et){return function(xe,Ie){l("caret",xe,Ie);var K=Ie?P[x]:P[V];return xe.replace(K,function(Y,me,Fe,We,ze){var Ye;return l("caret",xe,Y,me,Fe,We,ze),q(me)?Ye="":q(Fe)?Ye=">="+me+".0.0 <"+(+me+1)+".0.0":q(We)?Ye=me==="0"?">="+me+"."+Fe+".0 <"+me+"."+(+Fe+1)+".0":">="+me+"."+Fe+".0 <"+(+me+1)+".0.0":ze?(l("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=me==="0"?Fe==="0"?">="+me+"."+Fe+"."+We+ze+" <"+me+"."+Fe+"."+(+We+1):">="+me+"."+Fe+"."+We+ze+" <"+me+"."+(+Fe+1)+".0":">="+me+"."+Fe+"."+We+ze+" <"+(+me+1)+".0.0"):(l("no pr"),Ye=me==="0"?Fe==="0"?">="+me+"."+Fe+"."+We+" <"+me+"."+Fe+"."+(+We+1):">="+me+"."+Fe+"."+We+" <"+me+"."+(+Fe+1)+".0":">="+me+"."+Fe+"."+We+" <"+(+me+1)+".0.0"),l("caret return",Ye),Ye})}(et,ot)}).join(" ")}(Xe,Ke),l("caret",Xe),Xe=function(nt,ot){return nt.trim().split(/\s+/).map(function(et){return function(xe,Ie){var K=Ie?P[$]:P[U];return xe.replace(K,function(Y,me,Fe,We,ze){var Ye;return l("tilde",xe,Y,me,Fe,We,ze),q(me)?Ye="":q(Fe)?Ye=">="+me+".0.0 <"+(+me+1)+".0.0":q(We)?Ye=">="+me+"."+Fe+".0 <"+me+"."+(+Fe+1)+".0":ze?(l("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=">="+me+"."+Fe+"."+We+ze+" <"+me+"."+(+Fe+1)+".0"):Ye=">="+me+"."+Fe+"."+We+" <"+me+"."+(+Fe+1)+".0",l("tilde return",Ye),Ye})}(et,ot)}).join(" ")}(Xe,Ke),l("tildes",Xe),Xe=function(nt,ot){return l("replaceXRanges",nt,ot),nt.split(/\s+/).map(function(et){return function(xe,Ie){xe=xe.trim();var K=Ie?P[o]:P[y];return xe.replace(K,function(Y,me,Fe,We,ze,Ye){l("xRange",xe,Y,me,Fe,We,ze,Ye);var ct=q(Fe),st=ct||q(We),ft=st||q(ze);return me==="="&&ft&&(me=""),ct?Y=me===">"||me==="<"?"<0.0.0":"*":me&&ft?(st&&(We=0),ft&&(ze=0),me===">"?(me=">=",st?(Fe=+Fe+1,We=0,ze=0):ft&&(We=+We+1,ze=0)):me==="<="&&(me="<",st?Fe=+Fe+1:We=+We+1),Y=me+Fe+"."+We+"."+ze):st?Y=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ft&&(Y=">="+Fe+"."+We+".0 <"+Fe+"."+(+We+1)+".0"),l("xRange return",Y),Y})}(et,ot)}).join(" ")}(Xe,Ke),l("xrange",Xe),Xe=function(nt,ot){return l("replaceStars",nt,ot),nt.trim().replace(P[j],"")}(Xe,Ke),l("stars",Xe),Xe}(tt,Ae)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(tt){return!!tt.match(He)})),Ve=Ve.map(function(tt){return new oe(tt,Ae)})},O.prototype.intersects=function(he,Ae){if(!(he instanceof O))throw new TypeError("a Range is required");return this.set.some(function(Te){return Te.every(function(He){return he.set.some(function(Ve){return Ve.every(function(tt){return He.intersects(tt,Ae)})})})})},e.toComparators=function(he,Ae){return new O(he,Ae).set.map(function(Te){return Te.map(function(He){return He.value}).join(" ").trim().split(" ")})},O.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new _e(he,this.loose));for(var Ae=0;Ae<this.set.length;Ae++)if(ie(this.set[Ae],he))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(he,Ae,Te){var He=null,Ve=null;try{var tt=new O(Ae,Te)}catch{return null}return he.forEach(function(Xe){tt.test(Xe)&&(He&&Ve.compare(Xe)!==-1||(Ve=new _e(He=Xe,Te)))}),He},e.minSatisfying=function(he,Ae,Te){var He=null,Ve=null;try{var tt=new O(Ae,Te)}catch{return null}return he.forEach(function(Xe){tt.test(Xe)&&(He&&Ve.compare(Xe)!==1||(Ve=new _e(He=Xe,Te)))}),He},e.validRange=function(he,Ae){try{return new O(he,Ae).range||"*"}catch{return null}},e.ltr=function(he,Ae,Te){return De(he,Ae,"<",Te)},e.gtr=function(he,Ae,Te){return De(he,Ae,">",Te)},e.outside=De,e.prerelease=function(he,Ae){var Te=we(he,Ae);return Te&&Te.prerelease.length?Te.prerelease:null},e.intersects=function(he,Ae,Te){return he=new O(he,Te),Ae=new O(Ae,Te),he.intersects(Ae)},e.coerce=function(he){if(he instanceof _e)return he;if(typeof he!="string")return null;var Ae=he.match(P[i]);return Ae==null?null:we((Ae[1]||"0")+"."+(Ae[2]||"0")+"."+(Ae[3]||"0"))}}).call(this,c(1))},function(re,e){var c,A,l=re.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function P(n){if(c===setTimeout)return setTimeout(n,0);if((c===L||!c)&&setTimeout)return c=setTimeout,setTimeout(n,0);try{return c(n,0)}catch{try{return c.call(null,n,0)}catch{return c.call(this,n,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:L}catch{c=L}try{A=typeof clearTimeout=="function"?clearTimeout:R}catch{A=R}})();var _,g=[],T=!1,k=-1;function m(){T&&_&&(T=!1,_.length?g=_.concat(g):k=-1,g.length&&D())}function D(){if(!T){var n=P(m);T=!0;for(var h=g.length;h;){for(_=g,g=[];++k<h;)_&&_[k].run();k=-1,h=g.length}_=null,T=!1,function(d){if(A===clearTimeout)return clearTimeout(d);if((A===R||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(d);try{A(d)}catch{try{return A.call(null,d)}catch{return A.call(this,d)}}}(n)}}function S(n,h){this.fun=n,this.array=h}function v(){}l.nextTick=function(n){var h=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)h[d-1]=arguments[d];g.push(new S(n,h)),g.length!==1||T||P(D)},S.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=v,l.addListener=v,l.once=v,l.off=v,l.removeListener=v,l.removeAllListeners=v,l.emit=v,l.prependListener=v,l.prependOnceListener=v,l.listeners=function(n){return[]},l.binding=function(n){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(n){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(ye[91],Ce([1,0,8,4]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(E){const p=E;return p?typeof p.read=="function":!1}e.isReadable=l;function L(E){const p=E;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function R(E){const p=E;return p?L(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=R;function P(E,p){return new _(E,p)}e.newWriteableStream=P;class _{constructor(p,t){this.reducer=p,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(t=>t(p))}emitError(p){this.listeners.error.length===0?(0,c.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(t=>t(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,t){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(p,t){if(this.state.destroyed)return;let a;switch(p){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const r=a.indexOf(t);r>=0&&a.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(E,p){const t=[];let a;for(;(a=E.read())!==null;)t.push(a);return p(t)}e.consumeReadable=g;function T(E,p,t){const a=[];let r;for(;(r=E.read())!==null&&a.length<t;)a.push(r);return r===null&&a.length>0?p(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const s=r;return r=void 0,s}return E.read()}}}e.peekReadable=T;function k(E,p){return new Promise((t,a)=>{const r=[];m(E,{onData:s=>{p&&r.push(s)},onError:s=>{p?a(s):t(void 0)},onEnd:()=>{t(p?p(r):void 0)}})})}e.consumeStream=k;function m(E,p){let t=!1;return E.on("error",a=>{t||p.onError(a)}),E.on("end",()=>{t||p.onEnd()}),E.on("data",a=>{t||p.onData(a)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=m;function D(E,p){return new Promise((t,a)=>{const r=new A.DisposableStore,s=[],f=C=>{if(s.push(C),s.length>p)return r.dispose(),E.pause(),t({stream:E,buffer:s,ended:!1})},b=C=>a(C),u=()=>t({stream:E,buffer:s,ended:!0});r.add((0,A.toDisposable)(()=>E.removeListener("error",b))),E.on("error",b),r.add((0,A.toDisposable)(()=>E.removeListener("end",u))),E.on("end",u),r.add((0,A.toDisposable)(()=>E.removeListener("data",f))),E.on("data",f)})}e.peekStream=D;function S(E,p){const t=P(p);return t.end(E),t}e.toStream=S;function v(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=v;function n(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}e.toReadable=n;function h(E,p,t){const a=P(t);return m(E,{onData:r=>a.write(p.data(r)),onError:r=>a.error(p.error?p.error(r):r),onEnd:()=>a.end()}),a}e.transform=h;function d(E,p,t){let a=!1;return{read:()=>{const r=p.read();return a?r:(a=!0,r!==null?t([E,r]):E)}}}e.prefixedReadable=d;function w(E,p,t){let a=!1;const r=P(t);return m(p,{onData:s=>a?r.write(s):(a=!0,r.write(t([E,s]))),onError:s=>r.error(s),onEnd:()=>{a||(a=!0,r.write(E)),r.end()}}),r}e.prefixedStream=w}),define(ye[21],Ce([1,0,54,91]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const l=typeof Buffer<"u",L=new c.Lazy(()=>new Uint8Array(256));let R,P;class _{static alloc(o){return l?new _(Buffer.allocUnsafe(o)):new _(new Uint8Array(o))}static wrap(o){return l&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new _(o)}static fromString(o,i){return!(i?.dontUseNodeBuffer||!1)&&l?new _(Buffer.from(o)):(R||(R=new TextEncoder),new _(R.encode(o)))}static fromByteArray(o){const i=_.alloc(o.length);for(let I=0,F=o.length;I<F;I++)i.buffer[I]=o[I];return i}static concat(o,i){if(typeof i>"u"){i=0;for(let U=0,$=o.length;U<$;U++)i+=o[U].byteLength}const I=_.alloc(i);let F=0;for(let U=0,$=o.length;U<$;U++){const B=o[U];I.set(B,F),F+=B.byteLength}return I}constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}clone(){const o=_.alloc(this.byteLength);return o.set(this),o}toString(){return l?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(o,i){return new _(this.buffer.subarray(o,i))}set(o,i){if(o instanceof _)this.buffer.set(o.buffer,i);else if(o instanceof Uint8Array)this.buffer.set(o,i);else if(o instanceof ArrayBuffer)this.buffer.set(new Uint8Array(o),i);else if(ArrayBuffer.isView(o))this.buffer.set(new Uint8Array(o.buffer,o.byteOffset,o.byteLength),i);else throw new Error("Unknown argument 'array'")}readUInt32BE(o){return k(this.buffer,o)}writeUInt32BE(o,i){m(this.buffer,o,i)}readUInt32LE(o){return D(this.buffer,o)}writeUInt32LE(o,i){S(this.buffer,o,i)}readUInt8(o){return v(this.buffer,o)}writeUInt8(o,i){n(this.buffer,o,i)}indexOf(o){const i=o instanceof _?o.buffer:o,I=i.byteLength,F=this.buffer,U=F.byteLength;if(I===0)return 0;if(I===1)return F.indexOf(i[0]);if(I>U)return-1;const $=L.value;$.fill(i.length);for(let x=0;x<i.length;x++)$[i[x]]=i.length-x-1;let B=i.length-1,N=B,V=-1;for(;B<U;)if(F[B]===i[N]){if(N===0){V=B;break}B--,N--}else B+=Math.max(i.length-N,$[F[B]]),N=i.length-1;return V}}e.VSBuffer=_;function g(y,o){return y[o+0]<<0>>>0|y[o+1]<<8>>>0}e.readUInt16LE=g;function T(y,o,i){y[i+0]=o&255,o=o>>>8,y[i+1]=o&255}e.writeUInt16LE=T;function k(y,o){return y[o]*2**24+y[o+1]*2**16+y[o+2]*2**8+y[o+3]}e.readUInt32BE=k;function m(y,o,i){y[i+3]=o,o=o>>>8,y[i+2]=o,o=o>>>8,y[i+1]=o,o=o>>>8,y[i]=o}e.writeUInt32BE=m;function D(y,o){return y[o+0]<<0>>>0|y[o+1]<<8>>>0|y[o+2]<<16>>>0|y[o+3]<<24>>>0}e.readUInt32LE=D;function S(y,o,i){y[i+0]=o&255,o=o>>>8,y[i+1]=o&255,o=o>>>8,y[i+2]=o&255,o=o>>>8,y[i+3]=o&255}e.writeUInt32LE=S;function v(y,o){return y[o]}e.readUInt8=v;function n(y,o,i){y[i]=o}e.writeUInt8=n;function h(y){return A.consumeReadable(y,o=>_.concat(o))}e.readableToBuffer=h;function d(y){return A.toReadable(y)}e.bufferToReadable=d;function w(y){return A.consumeStream(y,o=>_.concat(o))}e.streamToBuffer=w;async function E(y){return y.ended?_.concat(y.buffer):_.concat([...y.buffer,await w(y.stream)])}e.bufferedStreamToBuffer=E;function p(y){return A.toStream(y,o=>_.concat(o))}e.bufferToStream=p;function t(y){return A.transform(y,{data:o=>typeof o=="string"?_.fromString(o):_.wrap(o)},o=>_.concat(o))}e.streamToBufferReadableStream=t;function a(y){return A.newWriteableStream(o=>_.concat(o),y)}e.newWriteableBufferStream=a;function r(y,o){return A.prefixedReadable(y,o,i=>_.concat(i))}e.prefixedBufferReadable=r;function s(y,o){return A.prefixedStream(y,o,i=>_.concat(i))}e.prefixedBufferStream=s;function f(y){let o=0,i=0,I=0;const F=new Uint8Array(Math.floor(y.length/4*3)),U=B=>{switch(i){case 3:F[I++]=o|B,i=0;break;case 2:F[I++]=o|B>>>2,o=B<<6,i=3;break;case 1:F[I++]=o|B>>>4,o=B<<4,i=2;break;default:o=B<<2,i=1}};for(let B=0;B<y.length;B++){const N=y.charCodeAt(B);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${y[B]}`)}}const $=I;for(;i>0;)U(0);return _.wrap(F).slice(0,$)}e.decodeBase64=f;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:y},o=!0,i=!1){const I=i?u:b;let F="";const U=y.byteLength%3;let $=0;for(;$<y.byteLength-U;$+=3){const B=y[$+0],N=y[$+1],V=y[$+2];F+=I[B>>>2],F+=I[(B<<4|N>>>4)&63],F+=I[(N<<2|V>>>6)&63],F+=I[V&63]}if(U===1){const B=y[$+0];F+=I[B>>>2],F+=I[B<<4&63],o&&(F+="==")}else if(U===2){const B=y[$+0],N=y[$+1];F+=I[B>>>2],F+=I[(B<<4|N>>>4)&63],F+=I[N<<2&63],o&&(F+="=")}return F}e.encodeBase64=C}),define(ye[152],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[12],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(a){return typeof a=="string"}e.isString=c;function A(a){return Array.isArray(a)&&a.every(r=>c(r))}e.isStringArray=A;function l(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=l;function L(a){const r=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof r}e.isTypedArray=L;function R(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=R;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=P;function _(a){return a===!0||a===!1}e.isBoolean=_;function g(a){return typeof a>"u"}e.isUndefined=g;function T(a){return!k(a)}e.isDefined=T;function k(a){return g(a)||a===null}e.isUndefinedOrNull=k;function m(a,r){if(!a)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=m;function D(a){if(k(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=D;function S(...a){const r=[];for(let s=0;s<a.length;s++){const f=a[s];if(k(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);r.push(f)}return r}e.assertAllDefined=S;const v=Object.prototype.hasOwnProperty;function n(a){if(!l(a))return!1;for(const r in a)if(v.call(a,r))return!1;return!0}e.isEmptyObject=n;function h(a){return typeof a=="function"}e.isFunction=h;function d(...a){return a.length>0&&a.every(h)}e.areFunctions=d;function w(a,r){const s=Math.min(a.length,r.length);for(let f=0;f<s;f++)E(a[f],r[f])}e.validateConstraints=w;function E(a,r){if(c(r)){if(typeof a!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(a instanceof r)return}catch{}if(!k(a)&&a.constructor===r||r.length===1&&r.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function p(a){return a===null?void 0:a}e.withNullAsUndefined=p;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ye[70],Ce([1,0,12]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function l(P,_){if((0,c.isString)(_)){const g=A[_];if(g===void 0)throw new Error(`${P} references an unknown codicon: ${_}`);_=g}return A[P]=_,{id:P}}function L(){return A}e.getCodiconFontCharacters=L;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(ye[23],Ce([1,0,12]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const d=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([w,E])=>{d[w]=E&&typeof E=="object"?A(E):E}),d}e.deepClone=A;function l(h){if(!h||typeof h!="object")return h;const d=[h];for(;d.length>0;){const w=d.shift();Object.freeze(w);for(const E in w)if(L.call(w,E)){const p=w[E];typeof p=="object"&&!Object.isFrozen(p)&&!(0,c.isTypedArray)(p)&&d.push(p)}}return h}e.deepFreeze=l;const L=Object.prototype.hasOwnProperty;function R(h,d){return P(h,d,new Set)}e.cloneAndChange=R;function P(h,d,w){if((0,c.isUndefinedOrNull)(h))return h;const E=d(h);if(typeof E<"u")return E;if(Array.isArray(h)){const p=[];for(const t of h)p.push(P(t,d,w));return p}if((0,c.isObject)(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const p={};for(const t in h)L.call(h,t)&&(p[t]=P(h[t],d,w));return w.delete(h),p}return h}function _(h,d,w=!0){return(0,c.isObject)(h)?((0,c.isObject)(d)&&Object.keys(d).forEach(E=>{E in h?w&&((0,c.isObject)(h[E])&&(0,c.isObject)(d[E])?_(h[E],d[E],w):h[E]=d[E]):h[E]=d[E]}),h):d}e.mixin=_;function g(h,d){if(h===d)return!0;if(h==null||d===null||d===void 0||typeof h!=typeof d||typeof h!="object"||Array.isArray(h)!==Array.isArray(d))return!1;let w,E;if(Array.isArray(h)){if(h.length!==d.length)return!1;for(w=0;w<h.length;w++)if(!g(h[w],d[w]))return!1}else{const p=[];for(E in h)p.push(E);p.sort();const t=[];for(E in d)t.push(E);if(t.sort(),!g(p,t))return!1;for(w=0;w<p.length;w++)if(!g(h[p[w]],d[p[w]]))return!1}return!0}e.equals=g;function T(h){const d=new Set;return JSON.stringify(h,(w,E)=>{if((0,c.isObject)(E)||Array.isArray(E)){if(d.has(E))return"[Circular]";d.add(E)}return E})}e.safeStringify=T;function k(h,d){const w=Object.create(null);return!h||!d||Object.keys(d).forEach(p=>{const t=h[p],a=d[p];g(t,a)||(w[p]=a)}),w}e.distinct=k;function m(h,d){const w=d.toLowerCase(),E=Object.keys(h).find(p=>p.toLowerCase()===w);return E?h[E]:h[d]}e.getCaseInsensitive=m;function D(h,d){const w=Object.create(null);for(const[E,p]of Object.entries(h))d(E,p)&&(w[E]=p);return w}e.filter=D;function S(h){let d=[],w=Object.getPrototypeOf(h);for(;Object.prototype!==w;)d=d.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return d}e.getAllPropertyNames=S;function v(h){const d=[];for(const w of S(h))typeof h[w]=="function"&&d.push(w);return d}e.getAllMethodNames=v;function n(h,d){const w=p=>function(){const t=Array.prototype.slice.call(arguments,0);return d(p,t)},E={};for(const p of h)E[p]=w(p);return E}e.createProxyObject=n}),define(ye[55],Ce([1,0,70]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(R){function P(_){return _&&typeof _=="object"&&typeof _.id=="string"}R.isThemeColor=P})(A||(e.ThemeColor=A={}));function l(R){return{id:R}}e.themeColorFromId=l;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function _(d){const w=P.exec(d.id);if(!w)return _(c.Codicon.error);const[,E,p]=w,t=["codicon","codicon-"+E];return p&&t.push("codicon-modifier-"+p.substring(1)),t}R.asClassNameArray=_;function g(d){return _(d).join(" ")}R.asClassName=g;function T(d){return"."+_(d).join(".")}R.asCSSSelector=T;function k(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||A.isThemeColor(d.color))}R.isThemeIcon=k;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function D(d){const w=m.exec(d);if(!w)return;const[,E]=w;return{id:E}}R.fromString=D;function S(d){return{id:d}}R.fromId=S;function v(d,w){let E=d.id;const p=E.lastIndexOf("~");return p!==-1&&(E=E.substring(0,p)),w&&(E=`${E}~${w}`),{id:E}}R.modify=v;function n(d){const w=d.id.lastIndexOf("~");if(w!==-1)return d.id.substring(w+1)}R.getModifier=n;function h(d,w){return d.id===w.id&&d.color?.id===w.color?.id}R.isEqual=h})(L||(e.ThemeIcon=L={}))}),define(ye[111],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c||(e.Constants=c={}));function A(L){return L<0?0:L>255?255:L|0}e.toUint8=A;function l(L){return L<0?0:L>4294967295?4294967295:L|0}e.toUint32=l}),define(ye[32],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(l){return c.test(l)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let _=0;_<P.length;_++)P[_]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),R=[];for(let P=0;P<256;P++)R.push(P.toString(16).padStart(2,"0"));return function(){l(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let _=0,g="";return g+=R[L[_++]],g+=R[L[_++]],g+=R[L[_++]],g+=R[L[_++]],g+="-",g+=R[L[_++]],g+=R[L[_++]],g+="-",g+=R[L[_++]],g+=R[L[_++]],g+="-",g+=R[L[_++]],g+=R[L[_++]],g+="-",g+=R[L[_++]],g+=R[L[_++]],g+=R[L[_++]],g+=R[L[_++]],g+=R[L[_++]],g+=R[L[_++]],g}}()}),define(ye[153],Ce([1,0,19,53,32]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=L;function R(k,m,D){const S={id:(0,l.generateUuid)(),name:k,uri:m,data:D};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.createFileDataTransferItem=R;class P{constructor(){this._entries=new Map}get size(){let m=0;for(const D of this._entries)m++;return m}has(m){return this._entries.has(this.toKey(m))}matches(m){const D=[...this._entries.keys()];return A.Iterable.some(this,([S,v])=>v.asFile())&&D.push("files"),T(_(m),D)}get(m){return this._entries.get(this.toKey(m))?.[0]}append(m,D){const S=this._entries.get(m);S?S.push(D):this._entries.set(this.toKey(m),[D])}replace(m,D){this._entries.set(this.toKey(m),[D])}delete(m){this._entries.delete(this.toKey(m))}*[Symbol.iterator](){for(const[m,D]of this._entries)for(const S of D)yield[m,S]}toKey(m){return _(m)}}e.VSDataTransfer=P;function _(k){return k.toLowerCase()}function g(k,m){return T(_(k),m.map(_))}e.matchesMimeType=g;function T(k,m){if(k==="*/*")return m.length>0;if(m.includes(k))return!0;const D=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[S,v,n]=D;return n==="*"?m.some(h=>h.startsWith(v+"/")):!1}e.UriList=Object.freeze({create:k=>(0,c.distinct)(k.map(m=>m.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(m=>!m.startsWith("#"))})}),define(ye[112],Ce([1,0,111]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){const _=(0,c.toUint8)(P);this._defaultValue=_,this._asciiMap=A._createAsciiMap(_),this._map=new Map}static _createAsciiMap(P){const _=new Uint8Array(256);return _.fill(P),_}set(P,_){const g=(0,c.toUint8)(_);P>=0&&P<256?this._asciiMap[P]=g:this._map.set(P,g)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=A;var l;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(l||(l={}));class L{constructor(){this._actual=new A(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}clear(){return this._actual.clear()}}e.CharacterSet=L}),define(ye[56],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(l,L){this.lineNumber=l,this.column=L}with(l=this.lineNumber,L=this.column){return l===this.lineNumber&&L===this.column?this:new c(l,L)}delta(l=0,L=0){return this.with(this.lineNumber+l,this.column+L)}equals(l){return c.equals(this,l)}static equals(l,L){return!l&&!L?!0:!!l&&!!L&&l.lineNumber===L.lineNumber&&l.column===L.column}isBefore(l){return c.isBefore(this,l)}static isBefore(l,L){return l.lineNumber<L.lineNumber?!0:L.lineNumber<l.lineNumber?!1:l.column<L.column}isBeforeOrEqual(l){return c.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,L){return l.lineNumber<L.lineNumber?!0:L.lineNumber<l.lineNumber?!1:l.column<=L.column}static compare(l,L){const R=l.lineNumber|0,P=L.lineNumber|0;if(R===P){const _=l.column|0,g=L.column|0;return _-g}return R-P}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new c(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=c}),define(ye[35],Ce([1,0,56]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(L,R,P,_){L>P||L===P&&R>_?(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=P,this.endColumn=_)}isEmpty(){return A.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return A.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return A.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return A.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return A.plusRange(this,L)}static plusRange(L,R){let P,_,g,T;return R.startLineNumber<L.startLineNumber?(P=R.startLineNumber,_=R.startColumn):R.startLineNumber===L.startLineNumber?(P=R.startLineNumber,_=Math.min(R.startColumn,L.startColumn)):(P=L.startLineNumber,_=L.startColumn),R.endLineNumber>L.endLineNumber?(g=R.endLineNumber,T=R.endColumn):R.endLineNumber===L.endLineNumber?(g=R.endLineNumber,T=Math.max(R.endColumn,L.endColumn)):(g=L.endLineNumber,T=L.endColumn),new A(P,_,g,T)}intersectRanges(L){return A.intersectRanges(this,L)}static intersectRanges(L,R){let P=L.startLineNumber,_=L.startColumn,g=L.endLineNumber,T=L.endColumn;const k=R.startLineNumber,m=R.startColumn,D=R.endLineNumber,S=R.endColumn;return P<k?(P=k,_=m):P===k&&(_=Math.max(_,m)),g>D?(g=D,T=S):g===D&&(T=Math.min(T,S)),P>g||P===g&&_>T?null:new A(P,_,g,T)}equalsRange(L){return A.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(L){return new c.Position(L.endLineNumber,L.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(L){return new c.Position(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new A(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new A(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(L){return new A(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(L){return new A(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new A(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new A(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new A(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const g=L.startLineNumber|0,T=R.startLineNumber|0;if(g===T){const k=L.startColumn|0,m=R.startColumn|0;if(k===m){const D=L.endLineNumber|0,S=R.endLineNumber|0;if(D===S){const v=L.endColumn|0,n=R.endColumn|0;return v-n}return D-S}return k-m}return g-T}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.Range=A}),define(ye[154],Ce([1,0,56,35]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(l||(e.SelectionDirection=l={}));class L extends A.Range{constructor(P,_,g,T){super(P,_,g,T),this.selectionStartLineNumber=P,this.selectionStartColumn=_,this.positionLineNumber=g,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return L.selectionsEqual(this,P)}static selectionsEqual(P,_){return P.selectionStartLineNumber===_.selectionStartLineNumber&&P.selectionStartColumn===_.selectionStartColumn&&P.positionLineNumber===_.positionLineNumber&&P.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,_){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,P,_):new L(P,_,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,_){return this.getDirection()===0?new L(P,_,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,P,_)}static fromPositions(P,_=P){return new L(P.lineNumber,P.column,_.lineNumber,_.column)}static fromRange(P,_){return _===0?new L(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new L(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new L(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,_){if(P&&!_||!P&&_)return!1;if(!P&&!_)return!0;if(P.length!==_.length)return!1;for(let g=0,T=P.length;g<T;g++)if(!this.selectionsEqual(P[g],_[g]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,_,g,T,k){return k===0?new L(P,_,g,T):new L(g,T,P,_)}}e.Selection=L}),define(ye[155],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[156],Ce([1,0,112]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class l extends c.CharacterClassifier{constructor(P){super(0);for(let _=0,g=P.length;_<g;_++)this.set(P.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function L(R){const P={};return _=>(P.hasOwnProperty(_)||(P[_]=R(_)),P[_])}e.getMapForWordSeparators=L(R=>new l(R))}),define(ye[113],Ce([1,0,53,4,68]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(k=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)k.indexOf(D)>=0||(m+="\\"+D);return m+="\\s]+)",new RegExp(m,"g")}e.DEFAULT_WORD_REGEXP=L();function R(k){let m=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)m=k;else{let D="g";k.ignoreCase&&(D+="i"),k.multiline&&(D+="m"),k.unicode&&(D+="u"),m=new RegExp(k.source,D)}return m.lastIndex=0,m}e.ensureValidWordDefinition=R;const P=new l.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function _(k){const m=P.unshift(k);return(0,A.toDisposable)(m)}e.setDefaultGetWordAtTextConfig=_;function g(k,m,D,S,v){if(v||(v=c.Iterable.first(P)),D.length>v.maxLen){let E=k-v.maxLen/2;return E<0?E=0:S+=E,D=D.substring(E,k+v.maxLen/2),g(k,m,D,S,v)}const n=Date.now(),h=k-1-S;let d=-1,w=null;for(let E=1;!(Date.now()-n>=v.timeBudget);E++){const p=h-v.windowSize*E;m.lastIndex=Math.max(0,p);const t=T(m,D,h,d);if(!t&&w||(w=t,p<=0))break;d=p}if(w){const E={word:w[0],startColumn:S+1+w.index,endColumn:S+1+w.index+w[0].length};return m.lastIndex=0,E}return null}e.getWordAtText=g;function T(k,m,D,S){let v;for(;v=k.exec(m);){const n=v.index||0;if(n<=D&&k.lastIndex>=D)return v;if(S>0&&n>S)return null}return null}}),define(ye[157],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(c||(e.IndentAction=c={}));class A{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let _=0,g=P.notIn.length;_<g;_++)switch(P.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,_){if(P.getTokenCount()===0)return!0;const g=P.findTokenIndexAtOffset(_-2),T=P.getStandardTokenType(g);return this.isOK(T)}_findNeutralCharacterInRange(P,_){for(let g=P;g<=_;g++){const T=String.fromCharCode(g);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=A;class l{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of P)L(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),L(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),L(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),L(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&L(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=l;function L(R,P,_){R.has(P)?R.get(P).push(_):R.set(P,[_])}}),define(ye[158],Ce([1,0,112]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class l{constructor(S,v,n){const h=new Uint8Array(S*v);for(let d=0,w=S*v;d<w;d++)h[d]=n;this._data=h,this.rows=S,this.cols=v}get(S,v){return this._data[S*this.cols+v]}set(S,v,n){this._data[S*this.cols+v]=n}}class L{constructor(S){let v=0,n=0;for(let d=0,w=S.length;d<w;d++){const[E,p,t]=S[d];p>v&&(v=p),E>n&&(n=E),t>n&&(n=t)}v++,n++;const h=new l(n,v,0);for(let d=0,w=S.length;d<w;d++){const[E,p,t]=S[d];h.set(E,p,t)}this._states=h,this._maxCharCode=v}nextState(S,v){return v<0||v>=this._maxCharCode?0:this._states.get(S,v)}}e.StateMachine=L;let R=null;function P(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var _;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let g=null;function T(){if(g===null){g=new c.CharacterClassifier(0);const D=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<D.length;v++)g.set(D.charCodeAt(v),1);const S=".,;:";for(let v=0;v<S.length;v++)g.set(S.charCodeAt(v),2)}return g}class k{static _createLink(S,v,n,h,d){let w=d-1;do{const E=v.charCodeAt(w);if(S.get(E)!==2)break;w--}while(w>h);if(h>0){const E=v.charCodeAt(h-1),p=v.charCodeAt(w);(E===40&&p===41||E===91&&p===93||E===123&&p===125)&&w--}return{range:{startLineNumber:n,startColumn:h+1,endLineNumber:n,endColumn:w+2},url:v.substring(h,w+1)}}static computeLinks(S,v=P()){const n=T(),h=[];for(let d=1,w=S.getLineCount();d<=w;d++){const E=S.getLineContent(d),p=E.length;let t=0,a=0,r=0,s=1,f=!1,b=!1,u=!1,C=!1;for(;t<p;){let y=!1;const o=E.charCodeAt(t);if(s===13){let i;switch(o){case 40:f=!0,i=0;break;case 41:i=f?0:1;break;case 91:u=!0,b=!0,i=0;break;case 93:u=!1,i=b?0:1;break;case 123:C=!0,i=0;break;case 125:i=C?0:1;break;case 39:case 34:case 96:r===o?i=1:r===39||r===34||r===96?i=0:i=1;break;case 42:i=r===42?1:0;break;case 124:i=r===124?1:0;break;case 32:i=u?0:1;break;default:i=n.get(o)}i===1&&(h.push(k._createLink(n,E,d,a,t)),y=!0)}else if(s===12){let i;o===91?(b=!0,i=0):i=n.get(o),i===1?y=!0:s=13}else s=v.nextState(s,o),s===0&&(y=!0);y&&(s=1,f=!1,b=!1,C=!1,a=t+1,r=o),t++}s===13&&h.push(k._createLink(n,E,d,a,p))}return h}}e.LinkComputer=k;function m(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:k.computeLinks(D)}e.computeLinks=m}),define(ye[114],Ce([1,0,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var A;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(A||(e.OverviewRulerLane=A={}));var l;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(l||(e.GlyphMarginLane=l={}));var L;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var P;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(P||(e.EndOfLinePreference=P={}));var _;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(_||(e.DefaultEndOfLine=_={}));var g;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class T{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,p.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!p.insertSpaces,this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=!!p.trimAutoWhitespace,this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this._indentSizeIsTabSize===p._indentSizeIsTabSize&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=T;class k{constructor(p,t){this._findMatchBrand=void 0,this.range=p,this.matches=t}}e.FindMatch=k;var m;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function D(E){return E&&typeof E.read=="function"}e.isITextSnapshot=D;var S;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None",E[E.LeftOfInjectedText=3]="LeftOfInjectedText",E[E.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var v;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class n{constructor(p,t,a,r,s,f){this.identifier=p,this.range=t,this.text=a,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=s,this._isTracked=f}}e.ValidAnnotatedEditOperation=n;class h{constructor(p,t,a){this.regex=p,this.wordSeparators=t,this.simpleSearch=a}}e.SearchData=h;class d{constructor(p,t,a){this.reverseEdits=p,this.changes=t,this.trimAutoWhitespaceLineNumbers=a}}e.ApplyEditsResult=d;function w(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=w}),define(ye[159],Ce([1,0,19,111]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,g){_=(0,A.toUint32)(_);const T=this.values,k=this.prefixSum,m=g.length;return m===0?!1:(this.values=new Uint32Array(T.length+m),this.values.set(T.subarray(0,_),0),this.values.set(T.subarray(_),_+m),this.values.set(g,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,g){return _=(0,A.toUint32)(_),g=(0,A.toUint32)(g),this.values[_]===g?!1:(this.values[_]=g,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,g){_=(0,A.toUint32)(_),g=(0,A.toUint32)(g);const T=this.values,k=this.prefixSum;if(_>=T.length)return!1;const m=T.length-_;return g>=m&&(g=m),g===0?!1:(this.values=new Uint32Array(T.length-g),this.values.set(T.subarray(0,_),0),this.values.set(T.subarray(_+g),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,A.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let g=this.prefixSumValidIndex[0]+1;g===0&&(this.prefixSum[0]=this.values[0],g++),_>=this.values.length&&(_=this.values.length-1);for(let T=g;T<=_;T++)this.prefixSum[T]=this.prefixSum[T-1]+this.values[T];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let g=0,T=this.values.length-1,k=0,m=0,D=0;for(;g<=T;)if(k=g+(T-g)/2|0,m=this.prefixSum[k],D=m-this.values[k],_<D)T=k-1;else if(_>=m)g=k+1;else break;return new R(k,_-D)}}e.PrefixSumComputer=l;class L{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const g=this._indexBySum[_],T=g>0?this._prefixSum[g-1]:0;return new R(g,_-T)}removeValues(_,g){this._values.splice(_,g),this._invalidate(_)}insertValues(_,g){this._values=(0,c.arrayInsert)(this._values,_,g),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,g=this._values.length;_<g;_++){const T=this._values[_],k=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=k+T;for(let m=0;m<T;m++)this._indexBySum[k+m]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,g){this._values[_]!==g&&(this._values[_]=g,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=L;class R{constructor(_,g){this.index=_,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=g}}e.PrefixSumIndexOfResult=R}),define(ye[160],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class c{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(L){if(L&&this._dragOperations.has(L)){const R=this._dragOperations.get(L);return this._dragOperations.delete(L),R}}addDragOperationTransfer(L,R){this._dragOperations.set(L,R)}}e.TreeViewsDnDService=c;class A{constructor(L){this.identifier=L}}e.DraggedTreeItemsIdentifier=A}),define(ye[161],Ce([13,14]),function(re,e){return re.create("vs/base/common/actions",e)}),define(ye[162],Ce([13,14]),function(re,e){return re.create("vs/base/common/date",e)}),define(ye[163],Ce([1,0,162]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,l=A*60,L=l*24,R=L*7,P=L*30,_=L*365;function g(k,m,D,S){typeof k!="number"&&(k=k.getTime());const v=Math.round((new Date().getTime()-k)/1e3);if(v<-30)return(0,c.localize)(0,null,g(new Date().getTime()+v*1e3,!1));if(!S&&v<30)return(0,c.localize)(1,null);let n;return v<A?(n=v,m?n===1?D?(0,c.localize)(2,null,n):(0,c.localize)(3,null,n):D?(0,c.localize)(4,null,n):(0,c.localize)(5,null,n):n===1?D?(0,c.localize)(6,null,n):(0,c.localize)(7,null,n):D?(0,c.localize)(8,null,n):(0,c.localize)(9,null,n)):v<l?(n=Math.floor(v/A),m?n===1?D?(0,c.localize)(10,null,n):(0,c.localize)(11,null,n):D?(0,c.localize)(12,null,n):(0,c.localize)(13,null,n):n===1?D?(0,c.localize)(14,null,n):(0,c.localize)(15,null,n):D?(0,c.localize)(16,null,n):(0,c.localize)(17,null,n)):v<L?(n=Math.floor(v/l),m?n===1?D?(0,c.localize)(18,null,n):(0,c.localize)(19,null,n):D?(0,c.localize)(20,null,n):(0,c.localize)(21,null,n):n===1?D?(0,c.localize)(22,null,n):(0,c.localize)(23,null,n):D?(0,c.localize)(24,null,n):(0,c.localize)(25,null,n)):v<R?(n=Math.floor(v/L),m?n===1?(0,c.localize)(26,null,n):(0,c.localize)(27,null,n):n===1?(0,c.localize)(28,null,n):(0,c.localize)(29,null,n)):v<P?(n=Math.floor(v/R),m?n===1?D?(0,c.localize)(30,null,n):(0,c.localize)(31,null,n):D?(0,c.localize)(32,null,n):(0,c.localize)(33,null,n):n===1?D?(0,c.localize)(34,null,n):(0,c.localize)(35,null,n):D?(0,c.localize)(36,null,n):(0,c.localize)(37,null,n)):v<_?(n=Math.floor(v/P),m?n===1?D?(0,c.localize)(38,null,n):(0,c.localize)(39,null,n):D?(0,c.localize)(40,null,n):(0,c.localize)(41,null,n):n===1?D?(0,c.localize)(42,null,n):(0,c.localize)(43,null,n):D?(0,c.localize)(44,null,n):(0,c.localize)(45,null,n)):(n=Math.floor(v/_),m?n===1?D?(0,c.localize)(46,null,n):(0,c.localize)(47,null,n):D?(0,c.localize)(48,null,n):(0,c.localize)(49,null,n):n===1?D?(0,c.localize)(50,null,n):(0,c.localize)(51,null,n):D?(0,c.localize)(52,null,n):(0,c.localize)(53,null,n))}e.fromNow=g;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ye[164],Ce([13,14]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(ye[45],Ce([1,0,19,12,164]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(k,m){return m&&(k.stack||k.stacktrace)?l.localize(0,null,P(k),R(k.stack)||R(k.stacktrace)):P(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?l.localize(1,null,k.message):k.message||l.localize(2,null)}function _(k=null,m=!1){if(!k)return l.localize(3,null);if(Array.isArray(k)){const D=c.coalesce(k),S=_(D[0],m);return D.length>1?l.localize(4,null,S,D.length):S}if(A.isString(k))return k;if(k.detail){const D=k.detail;if(D.error)return L(D.error,m);if(D.exception)return L(D.exception,m)}return k.stack?L(k,m):k.message?k.message:l.localize(5,null)}e.toErrorMessage=_;function g(k){const m=k;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=g;function T(k,m){let D;return typeof k=="string"?D=new Error(k):D=k,D.actions=m,D}e.createErrorWithActions=T}),define(ye[165],Ce([13,14]),function(re,e){return re.create("vs/base/common/platform",e)}),define(ye[9],Ce([1,0,165]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,l=!1,L=!1,R=!1,P=!1,_=!1,g=!1,T=!1,k=!1,m=!1,D,S=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,n,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const w=typeof d?.versions?.electron=="string",E=w&&d?.type==="renderer";if(typeof navigator=="object"&&!E)h=navigator.userAgent,A=h.indexOf("Windows")>=0,l=h.indexOf("Macintosh")>=0,T=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,_=!0,D=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,S=D,v=navigator.language;else if(typeof d=="object"){A=d.platform==="win32",l=d.platform==="darwin",L=d.platform==="linux",R=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,g=w,k=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const C=d.env.VSCODE_NLS_CONFIG;if(C)try{const y=JSON.parse(C),o=y.availableLanguages["*"];D=y.locale,v=y.osLocale,S=o||e.LANGUAGE_DEFAULT,n=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var p;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(p||(e.Platform=p={}));function t(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let a=0;l?a=1:A?a=3:L&&(a=2),e.isWindows=A,e.isMacintosh=l,e.isLinux=L,e.isLinuxSnap=R,e.isNative=P,e.isElectron=g,e.isWeb=_,e.isWebWorker=_&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=m,e.isCI=k,e.platform=a,e.userAgent=h,e.language=S;var r;(function(C){function y(){return e.language}C.value=y;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}C.isDefaultVariant=o;function i(){return e.language==="en"}C.isDefault=i})(r||(e.Language=r={})),e.locale=D,e.platformLocale=v,e.translationsConfigFile=n,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const C=[];e.globals.addEventListener("message",o=>{if(o.data&&o.data.vscodeScheduleAsyncWork)for(let i=0,I=C.length;i<I;i++){const F=C[i];if(F.id===o.data.vscodeScheduleAsyncWork){C.splice(i,1),F.callback();return}}});let y=0;return o=>{const i=++y;C.push({id:i,callback:o}),e.globals.postMessage({vscodeScheduleAsyncWork:i},"*")}}return C=>setTimeout(C)})();var s;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=l||T?2:A?1:3;let f=!0,b=!1;function u(){if(!b){b=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,f=new Uint16Array(C.buffer)[0]===(2<<8)+1}return f}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[39],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const l=c.globals.vscode.process;A={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ye[10],Ce([1,0,39]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,l=97,L=90,R=122,P=46,_=47,g=92,T=58,k=63;class m extends Error{constructor(a,r,s){let f;typeof r=="string"&&r.indexOf("not ")===0?(f="must not be",r=r.replace(/^not /,"")):f="must be";const b=a.indexOf(".")!==-1?"property":"argument";let u=`The "${a}" ${b} ${f} of type ${r}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function D(t,a){if(t===null||typeof t!="object")throw new m(a,"Object",t)}function S(t,a){if(typeof t!="string")throw new m(a,"string",t)}const v=c.platform==="win32";function n(t){return t===_||t===g}function h(t){return t===_}function d(t){return t>=A&&t<=L||t>=l&&t<=R}function w(t,a,r,s){let f="",b=0,u=-1,C=0,y=0;for(let o=0;o<=t.length;++o){if(o<t.length)y=t.charCodeAt(o);else{if(s(y))break;y=_}if(s(y)){if(!(u===o-1||C===1))if(C===2){if(f.length<2||b!==2||f.charCodeAt(f.length-1)!==P||f.charCodeAt(f.length-2)!==P){if(f.length>2){const i=f.lastIndexOf(r);i===-1?(f="",b=0):(f=f.slice(0,i),b=f.length-1-f.lastIndexOf(r)),u=o,C=0;continue}else if(f.length!==0){f="",b=0,u=o,C=0;continue}}a&&(f+=f.length>0?`${r}..`:"..",b=2)}else f.length>0?f+=`${r}${t.slice(u+1,o)}`:f=t.slice(u+1,o),b=o-u-1;u=o,C=0}else y===P&&C!==-1?++C:C=-1}return f}function E(t,a){D(a,"pathObject");const r=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${s}`:`${r}${t}${s}`:s}e.win32={resolve(...t){let a="",r="",s=!1;for(let f=t.length-1;f>=-1;f--){let b;if(f>=0){if(b=t[f],S(b,"path"),b.length===0)continue}else a.length===0?b=c.cwd():(b=c.env[`=${a}`]||c.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==a.toLowerCase()&&b.charCodeAt(2)===g)&&(b=`${a}\\`));const u=b.length;let C=0,y="",o=!1;const i=b.charCodeAt(0);if(u===1)n(i)&&(C=1,o=!0);else if(n(i))if(o=!0,n(b.charCodeAt(1))){let I=2,F=I;for(;I<u&&!n(b.charCodeAt(I));)I++;if(I<u&&I!==F){const U=b.slice(F,I);for(F=I;I<u&&n(b.charCodeAt(I));)I++;if(I<u&&I!==F){for(F=I;I<u&&!n(b.charCodeAt(I));)I++;(I===u||I!==F)&&(y=`\\\\${U}\\${b.slice(F,I)}`,C=I)}}}else C=1;else d(i)&&b.charCodeAt(1)===T&&(y=b.slice(0,2),C=2,u>2&&n(b.charCodeAt(2))&&(o=!0,C=3));if(y.length>0)if(a.length>0){if(y.toLowerCase()!==a.toLowerCase())continue}else a=y;if(s){if(a.length>0)break}else if(r=`${b.slice(C)}\\${r}`,s=o,o&&a.length>0)break}return r=w(r,!s,"\\",n),s?`${a}\\${r}`:`${a}${r}`||"."},normalize(t){S(t,"path");const a=t.length;if(a===0)return".";let r=0,s,f=!1;const b=t.charCodeAt(0);if(a===1)return h(b)?"\\":t;if(n(b))if(f=!0,n(t.charCodeAt(1))){let C=2,y=C;for(;C<a&&!n(t.charCodeAt(C));)C++;if(C<a&&C!==y){const o=t.slice(y,C);for(y=C;C<a&&n(t.charCodeAt(C));)C++;if(C<a&&C!==y){for(y=C;C<a&&!n(t.charCodeAt(C));)C++;if(C===a)return`\\\\${o}\\${t.slice(y)}\\`;C!==y&&(s=`\\\\${o}\\${t.slice(y,C)}`,r=C)}}}else r=1;else d(b)&&t.charCodeAt(1)===T&&(s=t.slice(0,2),r=2,a>2&&n(t.charCodeAt(2))&&(f=!0,r=3));let u=r<a?w(t.slice(r),!f,"\\",n):"";return u.length===0&&!f&&(u="."),u.length>0&&n(t.charCodeAt(a-1))&&(u+="\\"),s===void 0?f?`\\${u}`:u:f?`${s}\\${u}`:`${s}${u}`},isAbsolute(t){S(t,"path");const a=t.length;if(a===0)return!1;const r=t.charCodeAt(0);return n(r)||a>2&&d(r)&&t.charCodeAt(1)===T&&n(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,r;for(let b=0;b<t.length;++b){const u=t[b];S(u,"path"),u.length>0&&(a===void 0?a=r=u:a+=`\\${u}`)}if(a===void 0)return".";let s=!0,f=0;if(typeof r=="string"&&n(r.charCodeAt(0))){++f;const b=r.length;b>1&&n(r.charCodeAt(1))&&(++f,b>2&&(n(r.charCodeAt(2))?++f:s=!1))}if(s){for(;f<a.length&&n(a.charCodeAt(f));)f++;f>=2&&(a=`\\${a.slice(f)}`)}return e.win32.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a)return"";const r=e.win32.resolve(t),s=e.win32.resolve(a);if(r===s||(t=r.toLowerCase(),a=s.toLowerCase(),t===a))return"";let f=0;for(;f<t.length&&t.charCodeAt(f)===g;)f++;let b=t.length;for(;b-1>f&&t.charCodeAt(b-1)===g;)b--;const u=b-f;let C=0;for(;C<a.length&&a.charCodeAt(C)===g;)C++;let y=a.length;for(;y-1>C&&a.charCodeAt(y-1)===g;)y--;const o=y-C,i=u<o?u:o;let I=-1,F=0;for(;F<i;F++){const $=t.charCodeAt(f+F);if($!==a.charCodeAt(C+F))break;$===g&&(I=F)}if(F!==i){if(I===-1)return s}else{if(o>i){if(a.charCodeAt(C+F)===g)return s.slice(C+F+1);if(F===2)return s.slice(C+F)}u>i&&(t.charCodeAt(f+F)===g?I=F:F===2&&(I=3)),I===-1&&(I=0)}let U="";for(F=f+I+1;F<=b;++F)(F===b||t.charCodeAt(F)===g)&&(U+=U.length===0?"..":"\\..");return C+=I,U.length>0?`${U}${s.slice(C,y)}`:(s.charCodeAt(C)===g&&++C,s.slice(C,y))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===g){if(a.charCodeAt(1)===g){const r=a.charCodeAt(2);if(r!==k&&r!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(d(a.charCodeAt(0))&&a.charCodeAt(1)===T&&a.charCodeAt(2)===g)return`\\\\?\\${a}`;return t},dirname(t){S(t,"path");const a=t.length;if(a===0)return".";let r=-1,s=0;const f=t.charCodeAt(0);if(a===1)return n(f)?t:".";if(n(f)){if(r=s=1,n(t.charCodeAt(1))){let C=2,y=C;for(;C<a&&!n(t.charCodeAt(C));)C++;if(C<a&&C!==y){for(y=C;C<a&&n(t.charCodeAt(C));)C++;if(C<a&&C!==y){for(y=C;C<a&&!n(t.charCodeAt(C));)C++;if(C===a)return t;C!==y&&(r=s=C+1)}}}}else d(f)&&t.charCodeAt(1)===T&&(r=a>2&&n(t.charCodeAt(2))?3:2,s=r);let b=-1,u=!0;for(let C=a-1;C>=s;--C)if(n(t.charCodeAt(C))){if(!u){b=C;break}}else u=!1;if(b===-1){if(r===-1)return".";b=r}return t.slice(0,b)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let r=0,s=-1,f=!0,b;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(r=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let u=a.length-1,C=-1;for(b=t.length-1;b>=r;--b){const y=t.charCodeAt(b);if(n(y)){if(!f){r=b+1;break}}else C===-1&&(f=!1,C=b+1),u>=0&&(y===a.charCodeAt(u)?--u===-1&&(s=b):(u=-1,s=C))}return r===s?s=C:s===-1&&(s=t.length),t.slice(r,s)}for(b=t.length-1;b>=r;--b)if(n(t.charCodeAt(b))){if(!f){r=b+1;break}}else s===-1&&(f=!1,s=b+1);return s===-1?"":t.slice(r,s)},extname(t){S(t,"path");let a=0,r=-1,s=0,f=-1,b=!0,u=0;t.length>=2&&t.charCodeAt(1)===T&&d(t.charCodeAt(0))&&(a=s=2);for(let C=t.length-1;C>=a;--C){const y=t.charCodeAt(C);if(n(y)){if(!b){s=C+1;break}continue}f===-1&&(b=!1,f=C+1),y===P?r===-1?r=C:u!==1&&(u=1):r!==-1&&(u=-1)}return r===-1||f===-1||u===0||u===1&&r===f-1&&r===s+1?"":t.slice(r,f)},format:E.bind(null,"\\"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.length;let s=0,f=t.charCodeAt(0);if(r===1)return n(f)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(n(f)){if(s=1,n(t.charCodeAt(1))){let I=2,F=I;for(;I<r&&!n(t.charCodeAt(I));)I++;if(I<r&&I!==F){for(F=I;I<r&&n(t.charCodeAt(I));)I++;if(I<r&&I!==F){for(F=I;I<r&&!n(t.charCodeAt(I));)I++;I===r?s=I:I!==F&&(s=I+1)}}}}else if(d(f)&&t.charCodeAt(1)===T){if(r<=2)return a.root=a.dir=t,a;if(s=2,n(t.charCodeAt(2))){if(r===3)return a.root=a.dir=t,a;s=3}}s>0&&(a.root=t.slice(0,s));let b=-1,u=s,C=-1,y=!0,o=t.length-1,i=0;for(;o>=s;--o){if(f=t.charCodeAt(o),n(f)){if(!y){u=o+1;break}continue}C===-1&&(y=!1,C=o+1),f===P?b===-1?b=o:i!==1&&(i=1):b!==-1&&(i=-1)}return C!==-1&&(b===-1||i===0||i===1&&b===C-1&&b===u+1?a.base=a.name=t.slice(u,C):(a.name=t.slice(u,b),a.base=t.slice(u,C),a.ext=t.slice(b,C))),u>0&&u!==s?a.dir=t.slice(0,u-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(v){const t=/\\/g;return()=>{const a=c.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...t){let a="",r=!1;for(let s=t.length-1;s>=-1&&!r;s--){const f=s>=0?t[s]:p();S(f,"path"),f.length!==0&&(a=`${f}/${a}`,r=f.charCodeAt(0)===_)}return a=w(a,!r,"/",h),r?`/${a}`:a.length>0?a:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===_,r=t.charCodeAt(t.length-1)===_;return t=w(t,!a,"/",h),t.length===0?a?"/":r?"./":".":(r&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===_},join(...t){if(t.length===0)return".";let a;for(let r=0;r<t.length;++r){const s=t[r];S(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const r=1,s=t.length,f=s-r,b=1,u=a.length-b,C=f<u?f:u;let y=-1,o=0;for(;o<C;o++){const I=t.charCodeAt(r+o);if(I!==a.charCodeAt(b+o))break;I===_&&(y=o)}if(o===C)if(u>C){if(a.charCodeAt(b+o)===_)return a.slice(b+o+1);if(o===0)return a.slice(b+o)}else f>C&&(t.charCodeAt(r+o)===_?y=o:o===0&&(y=0));let i="";for(o=r+y+1;o<=s;++o)(o===s||t.charCodeAt(o)===_)&&(i+=i.length===0?"..":"/..");return`${i}${a.slice(b+y)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===_;let r=-1,s=!0;for(let f=t.length-1;f>=1;--f)if(t.charCodeAt(f)===_){if(!s){r=f;break}}else s=!1;return r===-1?a?"/":".":a&&r===1?"//":t.slice(0,r)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let r=0,s=-1,f=!0,b;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let u=a.length-1,C=-1;for(b=t.length-1;b>=0;--b){const y=t.charCodeAt(b);if(y===_){if(!f){r=b+1;break}}else C===-1&&(f=!1,C=b+1),u>=0&&(y===a.charCodeAt(u)?--u===-1&&(s=b):(u=-1,s=C))}return r===s?s=C:s===-1&&(s=t.length),t.slice(r,s)}for(b=t.length-1;b>=0;--b)if(t.charCodeAt(b)===_){if(!f){r=b+1;break}}else s===-1&&(f=!1,s=b+1);return s===-1?"":t.slice(r,s)},extname(t){S(t,"path");let a=-1,r=0,s=-1,f=!0,b=0;for(let u=t.length-1;u>=0;--u){const C=t.charCodeAt(u);if(C===_){if(!f){r=u+1;break}continue}s===-1&&(f=!1,s=u+1),C===P?a===-1?a=u:b!==1&&(b=1):a!==-1&&(b=-1)}return a===-1||s===-1||b===0||b===1&&a===s-1&&a===r+1?"":t.slice(a,s)},format:E.bind(null,"/"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.charCodeAt(0)===_;let s;r?(a.root="/",s=1):s=0;let f=-1,b=0,u=-1,C=!0,y=t.length-1,o=0;for(;y>=s;--y){const i=t.charCodeAt(y);if(i===_){if(!C){b=y+1;break}continue}u===-1&&(C=!1,u=y+1),i===P?f===-1?f=y:o!==1&&(o=1):f!==-1&&(o=-1)}if(u!==-1){const i=b===0&&r?1:b;f===-1||o===0||o===1&&f===u-1&&f===b+1?a.base=a.name=t.slice(i,u):(a.name=t.slice(i,f),a.base=t.slice(i,u),a.ext=t.slice(f,u))}return b>0?a.dir=t.slice(0,b-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ye[115],Ce([1,0,54,10]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new c.Lazy(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),L=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(C,y,o=!1){const i=C||"",I=y||"",F=l.value.collator.compare(i,I);return l.value.collatorIsNumeric&&F===0&&i!==I?i<I?-1:1:F}e.compareFileNames=P;function _(C,y){const o=L.value.collator;return C=C||"",y=y||"",E(o,C,y)}e.compareFileNamesDefault=_;function g(C,y){const o=L.value.collator;return C=C||"",y=y||"",r(C,y)||E(o,C,y)}e.compareFileNamesUpper=g;function T(C,y){const o=L.value.collator;return C=C||"",y=y||"",a(C,y)||E(o,C,y)}e.compareFileNamesLower=T;function k(C,y){return C=C||"",y=y||"",C===y?0:C<y?-1:1}e.compareFileNamesUnicode=k;function m(C,y){const[o,i]=d(C),[I,F]=d(y);let U=l.value.collator.compare(i,F);if(U===0){if(l.value.collatorIsNumeric&&i!==F)return i<F?-1:1;if(U=l.value.collator.compare(o,I),l.value.collatorIsNumeric&&U===0&&o!==I)return o<I?-1:1}return U}e.compareFileExtensions=m;function D(C,y){C=C||"",y=y||"";const o=w(C),i=w(y),I=L.value.collator,F=R.value.collator;return E(F,o,i)||E(I,C,y)}e.compareFileExtensionsDefault=D;function S(C,y){C=C||"",y=y||"";const o=w(C),i=w(y),I=L.value.collator,F=R.value.collator;return E(F,o,i)||r(C,y)||E(I,C,y)}e.compareFileExtensionsUpper=S;function v(C,y){C=C||"",y=y||"";const o=w(C),i=w(y),I=L.value.collator,F=R.value.collator;return E(F,o,i)||a(C,y)||E(I,C,y)}e.compareFileExtensionsLower=v;function n(C,y){C=C||"",y=y||"";const o=w(C).toLowerCase(),i=w(y).toLowerCase();return o!==i?o<i?-1:1:C!==y?C<y?-1:1:0}e.compareFileExtensionsUnicode=n;const h=/^(.*?)(\.([^.]*))?$/;function d(C,y=!1){const o=C?h.exec(C):[];let i=[o&&o[1]||"",o&&o[3]||""];return y&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function w(C){const y=C?h.exec(C):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function E(C,y,o){const i=C.compare(y,o);return i!==0?i:y.length!==o.length?y.length<o.length?-1:1:0}function p(C){const y=C.charAt(0);return y.toLocaleUpperCase()!==y}function t(C){const y=C.charAt(0);return y.toLocaleLowerCase()!==y}function a(C,y){return p(C)&&t(y)?-1:t(C)&&p(y)?1:0}function r(C,y){return t(C)&&p(y)?-1:p(C)&&t(y)?1:0}function s(C,y,o=!1){return o||(C=C&&C.toLowerCase(),y=y&&y.toLowerCase()),C===y?0:C<y?-1:1}function f(C,y,o=!1){const i=C.split(A.sep),I=y.split(A.sep),F=i.length-1,U=I.length-1;let $,B;for(let N=0;;N++){if($=F===N,B=U===N,$&&B)return P(i[N],I[N],o);if($)return-1;if(B)return 1;const V=s(i[N],I[N],o);if(V!==0)return V}}e.comparePaths=f;function b(C,y,o){const i=C.toLowerCase(),I=y.toLowerCase(),F=u(C,y,o);if(F)return F;const U=i.endsWith(o),$=I.endsWith(o);if(U!==$)return U?-1:1;const B=P(i,I);return B!==0?B:i.localeCompare(I)}e.compareAnything=b;function u(C,y,o){const i=C.toLowerCase(),I=y.toLowerCase(),F=i.startsWith(o),U=I.startsWith(o);if(F!==U)return F?-1:1;if(F&&U){if(i.length<I.length)return-1;if(i.length>I.length)return 1}return 0}e.compareByPrefix=u}),define(ye[92],Ce([1,0,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(T){const k=(0,c.extname)(T),m=A[k.toLowerCase()];return m!==void 0?m:R(T)}e.getMediaOrTextMime=L;function R(T){const k=(0,c.extname)(T);return l[k.toLowerCase()]}e.getMediaMime=R;function P(T){for(const k in l)if(l[k]===T)return k}e.getExtensionForMimeType=P;const _=/^(.+)\/(.+?)(;.+)?$/;function g(T,k){const m=_.exec(T);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:k?void 0:T}e.normalizeMimeType=g}),define(ye[93],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l||(e.TerminateResponseCode=l={}));function L(P,..._){const g=_.reduce((m,D)=>(m[D]=!0,m),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(m=>!g[m]).forEach(m=>{for(let D=0;D<T.length;D++)if(m.search(T[D])!==-1){delete P[m];break}})}e.sanitizeProcessEnvironment=L;function R(P){P&&(delete P.DEBUG,c.isMacintosh&&delete P.DYLD_LIBRARY_PATH,c.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ye[40],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=c.globals.performance&&typeof c.globals.performance.now=="function";class l{static create(R=!0){return new l(R)}constructor(R){this._highResolution=A&&R,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?c.globals.performance.now():Date.now()}}e.StopWatch=l}),define(ye[3],Ce([1,0,8,67,4,68,40]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,_=!1;var g;(function(b){b.None=()=>l.Disposable.None;function u(fe){if(_){const{onDidAddListener:Ee}=fe,Z=S.create();let ne=0;fe.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),Ee?.()}}}function C(fe,Ee){return N(fe,()=>{},0,void 0,!0,void 0,Ee)}b.defer=C;function y(fe){return(Ee,Z=null,ne)=>{let le=!1,te;return te=fe(de=>{if(!le)return te?te.dispose():le=!0,Ee.call(Z,de)},null,ne),le&&te.dispose(),te}}b.once=y;function o(fe,Ee,Z){return B((ne,le=null,te)=>fe(de=>ne.call(le,Ee(de)),null,te),Z)}b.map=o;function i(fe,Ee,Z){return B((ne,le=null,te)=>fe(de=>{Ee(de),ne.call(le,de)},null,te),Z)}b.forEach=i;function I(fe,Ee,Z){return B((ne,le=null,te)=>fe(de=>Ee(de)&&ne.call(le,de),null,te),Z)}b.filter=I;function F(fe){return fe}b.signal=F;function U(...fe){return(Ee,Z=null,ne)=>(0,l.combinedDisposable)(...fe.map(le=>le(te=>Ee.call(Z,te),null,ne)))}b.any=U;function $(fe,Ee,Z,ne){let le=Z;return o(fe,te=>(le=Ee(le,te),le),ne)}b.reduce=$;function B(fe,Ee){let Z;const ne={onWillAddFirstListener(){Z=fe(le.fire,le)},onDidRemoveLastListener(){Z?.dispose()}};Ee||u(ne);const le=new n(ne);return Ee?.add(le),le.event}function N(fe,Ee,Z=100,ne=!1,le=!1,te,de){let oe,ue,O,q=0,Q;const ie={leakWarningThreshold:te,onWillAddFirstListener(){oe=fe(De=>{q++,ue=Ee(ue,De),ne&&!O&&(pe.fire(ue),ue=void 0),Q=()=>{const he=ue;ue=void 0,O=void 0,(!ne||q>1)&&pe.fire(he),q=0},typeof Z=="number"?(clearTimeout(O),O=setTimeout(Q,Z)):O===void 0&&(O=0,queueMicrotask(Q))})},onWillRemoveListener(){le&&q>0&&Q?.()},onDidRemoveLastListener(){Q=void 0,oe.dispose()}};de||u(ie);const pe=new n(ie);return de?.add(pe),pe.event}b.debounce=N;function V(fe,Ee=0,Z){return b.debounce(fe,(ne,le)=>ne?(ne.push(le),ne):[le],Ee,void 0,!0,void 0,Z)}b.accumulate=V;function x(fe,Ee=(ne,le)=>ne===le,Z){let ne=!0,le;return I(fe,te=>{const de=ne||!Ee(te,le);return ne=!1,le=te,de},Z)}b.latch=x;function W(fe,Ee,Z){return[b.filter(fe,Ee,Z),b.filter(fe,ne=>!Ee(ne),Z)]}b.split=W;function ee(fe,Ee=!1,Z=[]){let ne=Z.slice(),le=fe(oe=>{ne?ne.push(oe):de.fire(oe)});const te=()=>{ne?.forEach(oe=>de.fire(oe)),ne=null},de=new n({onWillAddFirstListener(){le||(le=fe(oe=>de.fire(oe)))},onDidAddFirstListener(){ne&&(Ee?setTimeout(te):te())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return de.event}b.buffer=ee;class se{constructor(Ee){this.event=Ee,this.disposables=new l.DisposableStore}map(Ee){return new se(o(this.event,Ee,this.disposables))}forEach(Ee){return new se(i(this.event,Ee,this.disposables))}filter(Ee){return new se(I(this.event,Ee,this.disposables))}reduce(Ee,Z){return new se($(this.event,Ee,Z,this.disposables))}latch(){return new se(x(this.event,void 0,this.disposables))}debounce(Ee,Z=100,ne=!1,le=!1,te){return new se(N(this.event,Ee,Z,ne,le,te,this.disposables))}on(Ee,Z,ne){return this.event(Ee,Z,ne)}once(Ee,Z,ne){return y(this.event)(Ee,Z,ne)}dispose(){this.disposables.dispose()}}function H(fe){return new se(fe)}b.chain=H;function J(fe,Ee,Z=ne=>ne){const ne=(...oe)=>de.fire(Z(...oe)),le=()=>fe.on(Ee,ne),te=()=>fe.removeListener(Ee,ne),de=new n({onWillAddFirstListener:le,onDidRemoveLastListener:te});return de.event}b.fromNodeEventEmitter=J;function j(fe,Ee,Z=ne=>ne){const ne=(...oe)=>de.fire(Z(...oe)),le=()=>fe.addEventListener(Ee,ne),te=()=>fe.removeEventListener(Ee,ne),de=new n({onWillAddFirstListener:le,onDidRemoveLastListener:te});return de.event}b.fromDOMEventEmitter=j;function ae(fe){return new Promise(Ee=>y(fe)(Ee))}b.toPromise=ae;function we(fe,Ee){return Ee(void 0),fe(Z=>Ee(Z))}b.runAndSubscribe=we;function _e(fe,Ee){let Z=null;function ne(te){Z?.dispose(),Z=new l.DisposableStore,Ee(te,Z)}ne(void 0);const le=fe(te=>ne(te));return(0,l.toDisposable)(()=>{le.dispose(),Z?.dispose()})}b.runAndSubscribeWithStore=_e;class ve{constructor(Ee,Z){this._observable=Ee,this._counter=0,this._hasChanged=!1;const ne={onWillAddFirstListener:()=>{Ee.addObserver(this)},onDidRemoveLastListener:()=>{Ee.removeObserver(this)}};Z||u(ne),this.emitter=new n(ne),Z&&Z.add(this.emitter)}beginUpdate(Ee){this._counter++}handlePossibleChange(Ee){}handleChange(Ee,Z){this._hasChanged=!0}endUpdate(Ee){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function M(fe,Ee){return new ve(fe,Ee).emitter.event}b.fromObservable=M;function X(fe){return Ee=>{let Z=0,ne=!1;const le={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(fe.reportChanges(),ne&&(ne=!1,Ee()))},handlePossibleChange(){},handleChange(){ne=!0}};return fe.addObserver(le),{dispose(){fe.removeObserver(le)}}}}b.fromObservableLight=X})(g||(e.Event=g={}));class T{constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${T._idPool++}`,T.all.add(this)}start(u){this._stopWatch=new R.StopWatch(!0),this.listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=T,T.all=new Set,T._idPool=0;let k=-1;function m(b){const u=k;return k=b,{dispose(){k=u}}}e.setGlobalLeakWarningThreshold=m;class D{constructor(u,C=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=C,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(u,C){const y=this.threshold;if(y<=0||C<y)return;this._stacks||(this._stacks=new Map);const o=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=y*.5;let i,I=0;for(const[F,U]of this._stacks)(!i||I<U)&&(i=F,I=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${I}):`),console.warn(i)}return()=>{const i=this._stacks.get(u.value)||0;this._stacks.set(u.value,i-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(u,C,y){this.callback=u,this.callbackThis=C,this.stack=y,this.subscription=new l.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class n{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=k>0||this._options?.leakWarningThreshold?new D(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const C of u)C.subscription.isset()&&(C.subscription.unset(),C.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,C,y)=>{if(this._listeners||(this._listeners=new L.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const o=this._listeners.isEmpty();o&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let i,I;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(I=S.create(),i=this._leakageMon.check(I,this._listeners.size+1)),P&&(I=I??S.create());const F=new v(u,C,I),U=this._listeners.push(F);o&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,u,C);const $=F.subscription.set(()=>{i?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),U(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return y instanceof l.DisposableStore?y.add($):Array.isArray(y)&&y.push($),$}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new d(this._options?.onListenerError));for(const C of this._listeners)this._deliveryQueue.push(this,C,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=n;class h{constructor(u=c.onUnexpectedError){this._onListenerError=u,this._queue=new L.LinkedList}get size(){return this._queue.size}push(u,C,y){this._queue.push(new w(u,C,y))}clear(u){const C=new L.LinkedList;for(const y of this._queue)y.emitter!==u&&C.push(y);this._queue=C}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(C){this._onListenerError(C)}}}}e.EventDeliveryQueue=h;class d extends h{clear(u){this._queue.clear()}}class w{constructor(u,C,y){this.emitter=u,this.listener=C,this.event=y}}class E extends n{async fireAsync(u,C,y){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,u]);for(;this._asyncDeliveryQueue.size>0&&!C.isCancellationRequested;){const[o,i]=this._asyncDeliveryQueue.shift(),I=[],F={...i,token:C,waitUntil:U=>{if(Object.isFrozen(I))throw new Error("waitUntil can NOT be called asynchronous");y&&(U=y(U,o.callback)),I.push(U)}};try{o.invoke(F)}catch(U){(0,c.onUnexpectedError)(U);continue}Object.freeze(I),await Promise.allSettled(I).then(U=>{for(const $ of U)$.status==="rejected"&&(0,c.onUnexpectedError)($.reason)})}}}}e.AsyncEmitter=E;class p extends n{get isPaused(){return this._isPaused!==0}constructor(u){super(u),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=p;class t extends p{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=t;class a extends n{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this.hasListeners()&&(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(C=>super.fire(C)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=a;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const C={event:u,listener:null};this.events.push(C),this.hasListeners&&this.hook(C);const y=()=>{this.hasListeners&&this.unhook(C);const o=this.events.indexOf(C);this.events.splice(o,1)};return(0,l.toDisposable)((0,A.once)(y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(C=>this.emitter.fire(C))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(u){return(C,y,o)=>u(i=>{const I=this.buffers[this.buffers.length-1];I?I.push(()=>C.call(y,i)):C.call(y,i)},void 0,o)}bufferEvents(u){const C=[];this.buffers.push(C);const y=u();return this.buffers.pop(),C.forEach(o=>o()),y}}e.EventBufferer=s;class f{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=l.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(ye[166],Ce([1,0,3,4,161]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends A.Disposable{constructor(m,D="",S="",v=!0,n){super(),this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=m,this._label=D,this._cssClass=S,this._enabled=v,this._actionCallback=n}get id(){return this._id}get label(){return this._label}set label(m){this._setLabel(m)}_setLabel(m){this._label!==m&&(this._label=m,this._onDidChange.fire({label:m}))}get tooltip(){return this._tooltip||""}set tooltip(m){this._setTooltip(m)}_setTooltip(m){this._tooltip!==m&&(this._tooltip=m,this._onDidChange.fire({tooltip:m}))}get class(){return this._cssClass}set class(m){this._setClass(m)}_setClass(m){this._cssClass!==m&&(this._cssClass=m,this._onDidChange.fire({class:m}))}get enabled(){return this._enabled}set enabled(m){this._setEnabled(m)}_setEnabled(m){this._enabled!==m&&(this._enabled=m,this._onDidChange.fire({enabled:m}))}get checked(){return this._checked}set checked(m){this._setChecked(m)}_setChecked(m){this._checked!==m&&(this._checked=m,this._onDidChange.fire({checked:m}))}async run(m,D){this._actionCallback&&await this._actionCallback(m)}}e.Action=L;class R extends A.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new c.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new c.Emitter),this.onDidRun=this._onDidRun.event}async run(m,D){if(!m.enabled)return;this._onWillRun.fire({action:m});let S;try{await this.runAction(m,D)}catch(v){S=v}this._onDidRun.fire({action:m,error:S})}async runAction(m,D){await m.run(D)}}e.ActionRunner=R;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let D=[];for(const S of m)S.length&&(D.length?D=[...D,new P,...S]:D=S);return D}async run(){}}e.Separator=P,P.ID="vs.actions.separator";class _{get actions(){return this._actions}constructor(m,D,S,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=D,this.class=v,this._actions=S}async run(){}}e.SubmenuAction=_;class g extends L{constructor(){super(g.ID,l.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g,g.ID="vs.actions.empty";function T(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=T}),define(ye[22],Ce([1,0,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,_){const g=setTimeout(P.bind(_),0);return{dispose(){clearTimeout(g)}}});var l;(function(P){function _(g){return g===P.None||g===P.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}P.isCancellationToken=_,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(l||(e.CancellationToken=l={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new c.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=l.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=l.None}}e.CancellationTokenSource=R}),define(ye[167],Ce([1,0,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new c.CancellationTokenSource,_=this.task(P.token);return this.result={promise:_,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=A;class l{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const _=JSON.stringify(P);return this.lastArgKey!==_&&(this.lastArgKey=_,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=l;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const _=this.fn(P);return this._map.set(P,_),_}}e.CachedFunction=L}),define(ye[11],Ce([1,0,167,54]),function(re,e,c,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}e.isFalsyOrWhitespace=L;const R=/{(\d+)}/g;function P(Ie,...K){return K.length===0?Ie:Ie.replace(R,function(Y,me){const Fe=parseInt(me,10);return isNaN(Fe)||Fe<0||Fe>=K.length?Y:K[Fe]})}e.format=P;const _=/{([^}]+)}/g;function g(Ie,K){return Ie.replace(_,(Y,me)=>K[me]??Y)}e.format2=g;function T(Ie){return Ie.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}e.escape=T;function k(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function m(Ie,K){let Y=0;const me=K.charCodeAt(0);for(let Fe=Ie.length-1;Fe>=0;Fe--)Ie.charCodeAt(Fe)===me&&Y++;return Y}e.count=m;function D(Ie,K,Y="\u2026"){return Ie.length<=K?Ie:`${Ie.substr(0,K)}${Y}`}e.truncate=D;function S(Ie,K=" "){const Y=v(Ie,K);return n(Y,K)}e.trim=S;function v(Ie,K){if(!Ie||!K)return Ie;const Y=K.length;if(Y===0||Ie.length===0)return Ie;let me=0;for(;Ie.indexOf(K,me)===me;)me=me+Y;return Ie.substring(me)}e.ltrim=v;function n(Ie,K){if(!Ie||!K)return Ie;const Y=K.length,me=Ie.length;if(Y===0||me===0)return Ie;let Fe=me,We=-1;for(;We=Ie.lastIndexOf(K,Fe-1),!(We===-1||We+Y!==Fe);){if(We===0)return"";Fe=We}return Ie.substring(0,Fe)}e.rtrim=n;function h(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function d(Ie){return Ie.replace(/\*/g,"")}e.stripWildcards=d;function w(Ie,K,Y={}){if(!Ie)throw new Error("Cannot create regex from empty string");K||(Ie=k(Ie)),Y.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let me="";return Y.global&&(me+="g"),Y.matchCase||(me+="i"),Y.multiline&&(me+="m"),Y.unicode&&(me+="u"),new RegExp(Ie,me)}e.createRegExp=w;function E(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function p(Ie){return!!Ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function t(Ie){return(Ie.global?"g":"")+(Ie.ignoreCase?"i":"")+(Ie.multiline?"m":"")+(Ie.unicode?"u":"")}e.regExpFlags=t;function a(Ie){return Ie.split(/\r\n|\r|\n/)}e.splitLines=a;function r(Ie){for(let K=0,Y=Ie.length;K<Y;K++){const me=Ie.charCodeAt(K);if(me!==32&&me!==9)return K}return-1}e.firstNonWhitespaceIndex=r;function s(Ie,K=0,Y=Ie.length){for(let me=K;me<Y;me++){const Fe=Ie.charCodeAt(me);if(Fe!==32&&Fe!==9)return Ie.substring(K,me)}return Ie.substring(K,Y)}e.getLeadingWhitespace=s;function f(Ie,K=Ie.length-1){for(let Y=K;Y>=0;Y--){const me=Ie.charCodeAt(Y);if(me!==32&&me!==9)return Y}return-1}e.lastNonWhitespaceIndex=f;function b(Ie,K,Y){const me=[];let Fe=0;for(const We of Ie.matchAll(K)){if(me.push(Ie.slice(Fe,We.index)),We.index===void 0)throw new Error("match.index should be defined");Fe=We.index+We[0].length,me.push(Y(We[0],...We.slice(1),We.index,Ie,We.groups))}return me.push(Ie.slice(Fe)),Promise.all(me).then(We=>We.join(""))}e.replaceAsync=b;function u(Ie,K){return Ie<K?-1:Ie>K?1:0}e.compare=u;function C(Ie,K,Y=0,me=Ie.length,Fe=0,We=K.length){for(;Y<me&&Fe<We;Y++,Fe++){const ct=Ie.charCodeAt(Y),st=K.charCodeAt(Fe);if(ct<st)return-1;if(ct>st)return 1}const ze=me-Y,Ye=We-Fe;return ze<Ye?-1:ze>Ye?1:0}e.compareSubstring=C;function y(Ie,K){return o(Ie,K,0,Ie.length,0,K.length)}e.compareIgnoreCase=y;function o(Ie,K,Y=0,me=Ie.length,Fe=0,We=K.length){for(;Y<me&&Fe<We;Y++,Fe++){let ct=Ie.charCodeAt(Y),st=K.charCodeAt(Fe);if(ct===st)continue;if(ct>=128||st>=128)return C(Ie.toLowerCase(),K.toLowerCase(),Y,me,Fe,We);I(ct)&&(ct-=32),I(st)&&(st-=32);const ft=ct-st;if(ft!==0)return ft}const ze=me-Y,Ye=We-Fe;return ze<Ye?-1:ze>Ye?1:0}e.compareSubstringIgnoreCase=o;function i(Ie){return Ie>=48&&Ie<=57}e.isAsciiDigit=i;function I(Ie){return Ie>=97&&Ie<=122}e.isLowerAsciiLetter=I;function F(Ie){return Ie>=65&&Ie<=90}e.isUpperAsciiLetter=F;function U(Ie,K){return Ie.length===K.length&&o(Ie,K)===0}e.equalsIgnoreCase=U;function $(Ie,K){const Y=K.length;return K.length>Ie.length?!1:o(Ie,K,0,Y)===0}e.startsWithIgnoreCase=$;function B(Ie,K){const Y=Math.min(Ie.length,K.length);let me;for(me=0;me<Y;me++)if(Ie.charCodeAt(me)!==K.charCodeAt(me))return me;return Y}e.commonPrefixLength=B;function N(Ie,K){const Y=Math.min(Ie.length,K.length);let me;const Fe=Ie.length-1,We=K.length-1;for(me=0;me<Y;me++)if(Ie.charCodeAt(Fe-me)!==K.charCodeAt(We-me))return me;return Y}e.commonSuffixLength=N;function V(Ie){return 55296<=Ie&&Ie<=56319}e.isHighSurrogate=V;function x(Ie){return 56320<=Ie&&Ie<=57343}e.isLowSurrogate=x;function W(Ie,K){return(Ie-55296<<10)+(K-56320)+65536}e.computeCodePoint=W;function ee(Ie,K,Y){const me=Ie.charCodeAt(Y);if(V(me)&&Y+1<K){const Fe=Ie.charCodeAt(Y+1);if(x(Fe))return W(me,Fe)}return me}e.getNextCodePoint=ee;function se(Ie,K){const Y=Ie.charCodeAt(K-1);if(x(Y)&&K>1){const me=Ie.charCodeAt(K-2);if(V(me))return W(me,Y)}return Y}class H{get offset(){return this._offset}constructor(K,Y=0){this._str=K,this._len=K.length,this._offset=Y}setOffset(K){this._offset=K}prevCodePoint(){const K=se(this._str,this._offset);return this._offset-=K>=65536?2:1,K}nextCodePoint(){const K=ee(this._str,this._len,this._offset);return this._offset+=K>=65536?2:1,K}eol(){return this._offset>=this._len}}e.CodePointIterator=H;class J{get offset(){return this._iterator.offset}constructor(K,Y=0){this._iterator=new H(K,Y)}nextGraphemeLength(){const K=Ve.getInstance(),Y=this._iterator,me=Y.offset;let Fe=K.getGraphemeBreakType(Y.nextCodePoint());for(;!Y.eol();){const We=Y.offset,ze=K.getGraphemeBreakType(Y.nextCodePoint());if(Te(Fe,ze)){Y.setOffset(We);break}Fe=ze}return Y.offset-me}prevGraphemeLength(){const K=Ve.getInstance(),Y=this._iterator,me=Y.offset;let Fe=K.getGraphemeBreakType(Y.prevCodePoint());for(;Y.offset>0;){const We=Y.offset,ze=K.getGraphemeBreakType(Y.prevCodePoint());if(Te(ze,Fe)){Y.setOffset(We);break}Fe=ze}return me-Y.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=J;function j(Ie,K){return new J(Ie,K).nextGraphemeLength()}e.nextCharLength=j;function ae(Ie,K){return new J(Ie,K).prevGraphemeLength()}e.prevCharLength=ae;function we(Ie,K){K>0&&x(Ie.charCodeAt(K))&&K--;const Y=K+j(Ie,K);return[Y-ae(Ie,Y),Y]}e.getCharContainingOffset=we;function _e(Ie){const K=new J(Ie);let Y=0;for(;!K.eol();)Y++,K.nextGraphemeLength();return Y}e.charCount=_e;let ve;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function X(Ie){return ve||(ve=M()),ve.test(Ie)}e.containsRTL=X;const fe=/^[\t\n\r\x20-\x7E]*$/;function Ee(Ie){return fe.test(Ie)}e.isBasicASCII=Ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Ie){return e.UNUSUAL_LINE_TERMINATORS.test(Ie)}e.containsUnusualLineTerminators=Z;function ne(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}e.isFullWidthCharacter=ne;function le(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}e.isEmojiImprecise=le;function te(Ie,K){if(Ie.length<K)return Ie;const Y=/\b/g;let me=0;for(;Y.test(Ie)&&!(Ie.length-Y.lastIndex<K);)me=Y.lastIndex,Y.lastIndex+=1;return Ie.substring(me).replace(/^\s/,"")}e.lcut=te;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,oe=/\x1b\].*?\x07/g;function ue(Ie){return Ie&&(Ie=Ie.replace(de,"").replace(oe,"")),Ie}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function O(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=O;function q(Ie){return O(Ie)?Ie.substr(1):Ie}e.stripUTF8BOM=q;function Q(Ie,K){if(!Ie||!K||Ie.length<K.length)return!1;const Y=K.length,me=Ie.toLowerCase();let Fe=0,We=-1;for(;Fe<Y;){const ze=me.indexOf(K[Fe],We+1);if(ze<0)return!1;We=ze,Fe++}return!0}e.fuzzyContains=Q;function ie(Ie,K=!1){return Ie?(K&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}e.containsUppercaseCharacter=ie;function pe(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}e.uppercaseFirstLetter=pe;function De(Ie,K=1){if(K===0)return"";let Y=-1;do Y=Ie.indexOf(`
`,Y+1),K--;while(K>0&&Y>=0);return Y===-1?Ie:(Ie[Y-1]==="\r"&&Y--,Ie.substr(0,Y))}e.getNLines=De;function he(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}e.singleLetterHash=he;function Ae(Ie){return Ve.getInstance().getGraphemeBreakType(Ie)}e.getGraphemeBreakType=Ae;function Te(Ie,K){return Ie===0?K!==5&&K!==7:Ie===2&&K===3?!1:Ie===4||Ie===2||Ie===3||K===4||K===2||K===3?!0:!(Ie===8&&(K===8||K===9||K===11||K===12)||(Ie===11||Ie===9)&&(K===9||K===10)||(Ie===12||Ie===10)&&K===10||K===5||K===13||K===7||Ie===1||Ie===13&&K===14||Ie===6&&K===6)}var He;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(He||(e.GraphemeBreakType=He={}));class Ve{static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}constructor(){this._data=tt()}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const Y=this._data,me=Y.length/3;let Fe=1;for(;Fe<=me;)if(K<Y[3*Fe])Fe=2*Fe;else if(K>Y[3*Fe+1])Fe=2*Fe+1;else return Y[3*Fe+2];return 0}}Ve._INSTANCE=null;function tt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(Ie,K){if(Ie===0)return 0;const Y=Ke(Ie,K);if(Y!==void 0)return Y;const me=new H(K,Ie);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Xe;function Ke(Ie,K){const Y=new H(K,Ie);let me=Y.prevCodePoint();for(;nt(me)||me===65039||me===8419;){if(Y.offset===0)return;me=Y.prevCodePoint()}if(!le(me))return;let Fe=Y.offset;return Fe>0&&Y.prevCodePoint()===8205&&(Fe=Y.offset),Fe}function nt(Ie){return 127995<=Ie&&Ie<=127999}var ot;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.noBreakWhitespace="\xA0";class et{static getInstance(K){return et.cache.get(Array.from(K))}static getLocales(){return et._locales.value}constructor(K){this.confusableDictionary=K}isAmbiguous(K){return this.confusableDictionary.has(K)}getPrimaryConfusable(K){return this.confusableDictionary.get(K)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=et,l=et,et.ambiguousCharacterData=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),et.cache=new c.LRUCachedFunction(Ie=>{function K(st){const ft=new Map;for(let kt=0;kt<st.length;kt+=2)ft.set(st[kt],st[kt+1]);return ft}function Y(st,ft){const kt=new Map(st);for(const[Tt,bt]of ft)kt.set(Tt,bt);return kt}function me(st,ft){if(!st)return ft;const kt=new Map;for(const[Tt,bt]of st)ft.has(Tt)&&kt.set(Tt,bt);return kt}const Fe=l.ambiguousCharacterData.value;let We=Ie.filter(st=>!st.startsWith("_")&&st in Fe);We.length===0&&(We=["_default"]);let ze;for(const st of We){const ft=K(Fe[st]);ze=me(ze,ft)}const Ye=K(Fe._common),ct=Y(Ye,ze);return new et(ct)}),et._locales=new A.Lazy(()=>Object.keys(et.ambiguousCharacterData.value).filter(Ie=>!Ie.startsWith("_")));class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(K){return xe.getData().has(K)}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe,xe._data=void 0}),define(ye[30],Ce([1,0,10,9,11,12]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(b){return b===47||b===92}e.isPathSeparator=R;function P(b){return b.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=P;function _(b){return b.indexOf("/")===-1&&(b=P(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.toPosixPath=_;function g(b,u=c.posix.sep){if(!b)return"";const C=b.length,y=b.charCodeAt(0);if(R(y)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let i=3;const I=i;for(;i<C&&!R(b.charCodeAt(i));i++);if(I!==i&&!R(b.charCodeAt(i+1))){for(i+=1;i<C;i++)if(R(b.charCodeAt(i)))return b.slice(0,i+1).replace(/[\\/]/g,u)}}return u}else if(h(y)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+u:b.slice(0,2);let o=b.indexOf("://");if(o!==-1){for(o+=3;o<C;o++)if(R(b.charCodeAt(o)))return b.slice(0,o+1)}return""}e.getRoot=g;function T(b){if(!A.isWindows||!b||b.length<5)return!1;let u=b.charCodeAt(0);if(u!==92||(u=b.charCodeAt(1),u!==92))return!1;let C=2;const y=C;for(;C<b.length&&(u=b.charCodeAt(C),u!==92);C++);return!(y===C||(u=b.charCodeAt(C+1),isNaN(u)||u===92))}e.isUNC=T;const k=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(b,u=A.isWindows){const C=u?k:m;return!(!b||b.length===0||/^\s+$/.test(b)||(C.lastIndex=0,C.test(b))||u&&D.test(b)||b==="."||b===".."||u&&b[b.length-1]==="."||u&&b.length!==b.trim().length||b.length>255)}e.isValidBasename=S;function v(b,u,C){const y=b===u;return!C||y?y:!b||!u?!1:(0,l.equalsIgnoreCase)(b,u)}e.isEqual=v;function n(b,u,C,y=c.sep){if(b===u)return!0;if(!b||!u||u.length>b.length)return!1;if(C){if(!(0,l.startsWithIgnoreCase)(b,u))return!1;if(u.length===b.length)return!0;let i=u.length;return u.charAt(u.length-1)===y&&i--,b.charAt(i)===y}return u.charAt(u.length-1)!==y&&(u+=y),b.indexOf(u)===0}e.isEqualOrParent=n;function h(b){return b>=65&&b<=90||b>=97&&b<=122}e.isWindowsDriveLetter=h;function d(b,u){return A.isWindows&&b.endsWith(":")&&(b+=c.sep),(0,c.isAbsolute)(b)||(b=(0,c.join)(u,b)),b=(0,c.normalize)(b),A.isWindows?(b=(0,l.rtrim)(b,c.sep),b.endsWith(":")&&(b+=c.sep)):(b=(0,l.rtrim)(b,c.sep),b||(b=c.sep)),b}e.sanitizeFilePath=d;function w(b){const u=(0,c.normalize)(b);return A.isWindows?b.length>3?!1:E(u)&&(b.length===2||u.charCodeAt(2)===92):u===c.posix.sep}e.isRootOrDriveLetter=w;function E(b,u=A.isWindows){return u?h(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function p(b,u=A.isWindows){return E(b,u)?b[0]:void 0}e.getDriveLetter=p;function t(b,u,C){return u.length>b.length?-1:b===u?0:(C&&(b=b.toLowerCase(),u=u.toLowerCase()),b.indexOf(u))}e.indexOfPath=t;function a(b){const u=b.split(":");let C,y,o;for(const i of u){const I=Number(i);(0,L.isNumber)(I)?y===void 0?y=I:o===void 0&&(o=I):C=C?[C,i].join(":"):i}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:y!==void 0?y:void 0,column:o!==void 0?o:y!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function f(b,u,C=8){let y="";for(let i=0;i<C;i++){let I;i===0&&A.isWindows&&!u&&(C===3||C===4)?I=s:I=r,y+=I.charAt(Math.floor(Math.random()*I.length))}let o;return u?o=`${u}-${y}`:o=y,b?(0,c.join)(b,o):o}e.randomPath=f}),define(ye[116],Ce([1,0,28,11]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...oe){return function(ue,O){for(let q=0,Q=oe.length;q<Q;q++){const ie=oe[q](ue,O);if(ie)return ie}return null}}e.or=l,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(oe,ue,O){if(!O||O.length<ue.length)return null;let q;return oe?q=A.startsWithIgnoreCase(O,ue):q=O.indexOf(ue)===0,q?ue.length>0?[{start:0,end:ue.length}]:[]:null}function R(oe,ue){const O=ue.toLowerCase().indexOf(oe.toLowerCase());return O===-1?null:[{start:O,end:O+oe.length}]}e.matchesContiguousSubString=R;function P(oe,ue){return _(oe.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=P;function _(oe,ue,O,q){if(O===oe.length)return[];if(q===ue.length)return null;if(oe[O]===ue[q]){let Q=null;return(Q=_(oe,ue,O+1,q+1))?h({start:q,end:q+1},Q):null}return _(oe,ue,O,q+1)}function g(oe){return 97<=oe&&oe<=122}function T(oe){return 65<=oe&&oe<=90}e.isUpper=T;function k(oe){return 48<=oe&&oe<=57}function m(oe){return oe===32||oe===9||oe===10||oe===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>D.add(oe.charCodeAt(0)));function S(oe){return m(oe)||D.has(oe)}function v(oe,ue){return oe===ue||S(oe)&&S(ue)}function n(oe){return g(oe)||T(oe)||k(oe)}function h(oe,ue){return ue.length===0?ue=[oe]:oe.end===ue[0].start?ue[0].start=oe.start:ue.unshift(oe),ue}function d(oe,ue){for(let O=ue;O<oe.length;O++){const q=oe.charCodeAt(O);if(T(q)||k(q)||O>0&&!n(oe.charCodeAt(O-1)))return O}return oe.length}function w(oe,ue,O,q){if(O===oe.length)return[];if(q===ue.length)return null;if(oe[O]!==ue[q].toLowerCase())return null;{let Q=null,ie=q+1;for(Q=w(oe,ue,O+1,q+1);!Q&&(ie=d(ue,ie))<ue.length;)Q=w(oe,ue,O+1,ie),ie++;return Q===null?null:h({start:q,end:q+1},Q)}}function E(oe){let ue=0,O=0,q=0,Q=0,ie=0;for(let Te=0;Te<oe.length;Te++)ie=oe.charCodeAt(Te),T(ie)&&ue++,g(ie)&&O++,n(ie)&&q++,k(ie)&&Q++;const pe=ue/oe.length,De=O/oe.length,he=q/oe.length,Ae=Q/oe.length;return{upperPercent:pe,lowerPercent:De,alphaPercent:he,numericPercent:Ae}}function p(oe){const{upperPercent:ue,lowerPercent:O}=oe;return O===0&&ue>.6}function t(oe){const{upperPercent:ue,lowerPercent:O,alphaPercent:q,numericPercent:Q}=oe;return O>.2&&ue<.8&&q>.6&&Q<.2}function a(oe){let ue=0,O=0,q=0,Q=0;for(let ie=0;ie<oe.length;ie++)q=oe.charCodeAt(ie),T(q)&&ue++,g(q)&&O++,m(q)&&Q++;return(ue===0||O===0)&&Q===0?oe.length<=30:ue<=5}function r(oe,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!a(oe)||ue.length>60)return null;const O=E(ue);if(!t(O)){if(!p(O))return null;ue=ue.toLowerCase()}let q=null,Q=0;for(oe=oe.toLowerCase();Q<ue.length&&(q=w(oe,ue,0,Q))===null;)Q=d(ue,Q+1);return q}e.matchesCamelCase=r;function s(oe,ue,O=!1){if(!ue||ue.length===0)return null;let q=null,Q=0;for(oe=oe.toLowerCase(),ue=ue.toLowerCase();Q<ue.length&&(q=f(oe,ue,0,Q,O))===null;)Q=b(ue,Q+1);return q}e.matchesWords=s;function f(oe,ue,O,q,Q){if(O===oe.length)return[];if(q===ue.length)return null;if(v(oe.charCodeAt(O),ue.charCodeAt(q))){let ie=null,pe=q+1;if(ie=f(oe,ue,O+1,q+1,Q),!Q)for(;!ie&&(pe=b(ue,pe))<ue.length;)ie=f(oe,ue,O+1,pe,Q),pe++;return ie?oe.charCodeAt(O)!==ue.charCodeAt(q)?ie:h({start:q,end:q+1},ie):null}else return null}function b(oe,ue){for(let O=ue;O<oe.length;O++)if(S(oe.charCodeAt(O))||O>0&&S(oe.charCodeAt(O-1)))return O;return oe.length}const u=l(e.matchesPrefix,r,R),C=l(e.matchesPrefix,r,P),y=new c.LRUCache(1e4);function o(oe,ue,O=!1){if(typeof oe!="string"||typeof ue!="string")return null;let q=y.get(oe);q||(q=new RegExp(A.convertSimple2RegExpPattern(oe),"i"),y.set(oe,q));const Q=q.exec(ue);return Q?[{start:Q.index,end:Q.index+Q[0].length}]:O?C(oe,ue):u(oe,ue)}e.matchesFuzzy=o;function i(oe,ue){const O=fe(oe,oe.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?F(O):null}e.matchesFuzzy2=i;function I(oe,ue,O,q,Q,ie){const pe=Math.min(13,oe.length);for(;O<pe;O++){const De=fe(oe,ue,O,q,Q,ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ie]}e.anyScore=I;function F(oe){if(typeof oe>"u")return[];const ue=[],O=oe[1];for(let q=oe.length-1;q>1;q--){const Q=oe[q]+O,ie=ue[ue.length-1];ie&&ie.end===Q?ie.end=Q+1:ue.push({start:Q,end:Q+1})}return ue}e.createMatches=F;const U=128;function $(){const oe=[],ue=[];for(let O=0;O<=U;O++)ue[O]=0;for(let O=0;O<=U;O++)oe.push(ue.slice(0));return oe}function B(oe){const ue=[];for(let O=0;O<=oe;O++)ue[O]=0;return ue}const N=B(2*U),V=B(2*U),x=$(),W=$(),ee=$(),se=!1;function H(oe,ue,O,q,Q){function ie(De,he,Ae=" "){for(;De.length<he;)De=Ae+De;return De}let pe=` |   |${q.split("").map(De=>ie(De,3)).join("|")}
`;for(let De=0;De<=O;De++)De===0?pe+=" |":pe+=`${ue[De-1]}|`,pe+=oe[De].slice(0,Q+1).map(he=>ie(he.toString(),3)).join("|")+`
`;return pe}function J(oe,ue,O,q){oe=oe.substr(ue),O=O.substr(q),console.log(H(W,oe,oe.length,O,O.length)),console.log(H(ee,oe,oe.length,O,O.length)),console.log(H(x,oe,oe.length,O,O.length))}function j(oe,ue){if(ue<0||ue>=oe.length)return!1;const O=oe.codePointAt(ue);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(O)}}function ae(oe,ue){if(ue<0||ue>=oe.length)return!1;switch(oe.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function we(oe,ue,O){return ue[oe]!==O[oe]}function _e(oe,ue,O,q,Q,ie,pe=!1){for(;ue<O&&Q<ie;)oe[ue]===q[Q]&&(pe&&(N[ue]=Q),ue+=1),Q+=1;return ue===O}e.isPatternInWord=_e;var ve;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var M;(function(oe){oe.Default=[-100,0];function ue(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}oe.isDefault=ue})(M||(e.FuzzyScore=M={}));class X{constructor(ue,O){this.firstMatchCanBeWeak=ue,this.boostFullMatch=O}}e.FuzzyScoreOptions=X,X.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function fe(oe,ue,O,q,Q,ie,pe=X.default){const De=oe.length>U?U:oe.length,he=q.length>U?U:q.length;if(O>=De||ie>=he||De-O>he-ie||!_e(ue,O,De,Q,ie,he,!0))return;Ee(De,he,O,ie,ue,Q);let Ae=1,Te=1,He=O,Ve=ie;const tt=[!1];for(Ae=1,He=O;He<De;Ae++,He++){const et=N[He],xe=V[He],Ie=He+1<De?V[He+1]:he;for(Te=et-ie+1,Ve=et;Ve<Ie;Te++,Ve++){let K=Number.MIN_SAFE_INTEGER,Y=!1;Ve<=xe&&(K=Z(oe,ue,He,O,q,Q,Ve,he,ie,x[Ae-1][Te-1]===0,tt));let me=0;K!==Number.MAX_SAFE_INTEGER&&(Y=!0,me=K+W[Ae-1][Te-1]);const Fe=Ve>et,We=Fe?W[Ae][Te-1]+(x[Ae][Te-1]>0?-5:0):0,ze=Ve>et+1&&x[Ae][Te-1]>0,Ye=ze?W[Ae][Te-2]+(x[Ae][Te-2]>0?-5:0):0;if(ze&&(!Fe||Ye>=We)&&(!Y||Ye>=me))W[Ae][Te]=Ye,ee[Ae][Te]=3,x[Ae][Te]=0;else if(Fe&&(!Y||We>=me))W[Ae][Te]=We,ee[Ae][Te]=2,x[Ae][Te]=0;else if(Y)W[Ae][Te]=me,ee[Ae][Te]=1,x[Ae][Te]=x[Ae-1][Te-1]+1;else throw new Error("not possible")}}if(se&&J(oe,O,q,ie),!tt[0]&&!pe.firstMatchCanBeWeak)return;Ae--,Te--;const Xe=[W[Ae][Te],ie];let Ke=0,nt=0;for(;Ae>=1;){let et=Te;do{const xe=ee[Ae][et];if(xe===3)et=et-2;else if(xe===2)et=et-1;else break}while(et>=1);Ke>1&&ue[O+Ae-1]===Q[ie+Te-1]&&!we(et+ie-1,q,Q)&&Ke+1>x[Ae][et]&&(et=Te),et===Te?Ke++:Ke=1,nt||(nt=et),Ae--,Te=et-1,Xe.push(Te)}he===De&&pe.boostFullMatch&&(Xe[0]+=2);const ot=nt-De;return Xe[0]-=ot,Xe}e.fuzzyScore=fe;function Ee(oe,ue,O,q,Q,ie){let pe=oe-1,De=ue-1;for(;pe>=O&&De>=q;)Q[pe]===ie[De]&&(V[pe]=De,pe--),De--}function Z(oe,ue,O,q,Q,ie,pe,De,he,Ae,Te){if(ue[O]!==ie[pe])return Number.MIN_SAFE_INTEGER;let He=1,Ve=!1;return pe===O-q?He=oe[O]===Q[pe]?7:5:we(pe,Q,ie)&&(pe===0||!we(pe-1,Q,ie))?(He=oe[O]===Q[pe]?7:5,Ve=!0):j(ie,pe)&&(pe===0||!j(ie,pe-1))?He=5:(j(ie,pe-1)||ae(ie,pe-1))&&(He=5,Ve=!0),He>1&&O===q&&(Te[0]=!0),Ve||(Ve=we(pe,Q,ie)||j(ie,pe-1)||ae(ie,pe-1)),O===q?pe>he&&(He-=Ve?3:5):Ae?He+=Ve?2:0:He+=Ve?0:1,pe+1===De&&(He-=Ve?3:5),He}function ne(oe,ue,O,q,Q,ie,pe){return te(oe,ue,O,q,Q,ie,!0,pe)}e.fuzzyScoreGracefulAggressive=ne;function le(oe,ue,O,q,Q,ie,pe){return te(oe,ue,O,q,Q,ie,!1,pe)}e.fuzzyScoreGraceful=le;function te(oe,ue,O,q,Q,ie,pe,De){let he=fe(oe,ue,O,q,Q,ie,De);if(he&&!pe)return he;if(oe.length>=3){const Ae=Math.min(7,oe.length-1);for(let Te=O+1;Te<Ae;Te++){const He=de(oe,Te);if(He){const Ve=fe(He,He.toLowerCase(),O,q,Q,ie,De);Ve&&(Ve[0]-=3,(!he||Ve[0]>he[0])&&(he=Ve))}}}return he}function de(oe,ue){if(ue+1>=oe.length)return;const O=oe[ue],q=oe[ue+1];if(O!==q)return oe.slice(0,ue)+q+O+oe.slice(ue+2)}}),define(ye[71],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(h){return l(h,0)}e.hash=A;function l(h,d){switch(typeof h){case"object":return h===null?L(349,d):Array.isArray(h)?_(h,d):g(h,d);case"string":return P(h,d);case"boolean":return R(h,d);case"number":return L(h,d);case"undefined":return L(937,d);default:return L(617,d)}}e.doHash=l;function L(h,d){return(d<<5)-d+h|0}e.numberHash=L;function R(h,d){return L(h?433:863,d)}function P(h,d){d=L(149417,d);for(let w=0,E=h.length;w<E;w++)d=L(h.charCodeAt(w),d);return d}e.stringHash=P;function _(h,d){return d=L(104579,d),h.reduce((w,E)=>l(E,w),d)}function g(h,d){return d=L(181387,d),Object.keys(h).sort().reduce((w,E)=>(w=P(E,w),l(h[E],w)),d)}class T{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=l(d,this._value),this._value}}e.Hasher=T;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function m(h,d,w=32){const E=w-d,p=~((1<<E)-1);return(h<<d|(p&h)>>>E)>>>0}function D(h,d=0,w=h.byteLength,E=0){for(let p=0;p<w;p++)h[d+p]=E}function S(h,d,w="0"){for(;h.length<d;)h=w+h;return h}function v(h,d=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(w=>w.toString(16).padStart(2,"0")).join(""):S((h>>>0).toString(16),d/4)}e.toHexString=v;class n{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const w=d.length;if(w===0)return;const E=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,a,r;for(t!==0?(a=t,r=-1,t=0):(a=d.charCodeAt(0),r=0);;){let s=a;if(c.isHighSurrogate(a))if(r+1<w){const f=d.charCodeAt(r+1);c.isLowSurrogate(f)?(r++,s=c.computeCodePoint(a,f)):s=65533}else{t=a;break}else c.isLowSurrogate(a)&&(s=65533);if(p=this._push(E,p,s),r++,r<w)a=d.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(d,w,E){return E<128?d[w++]=E:E<2048?(d[w++]=192|(E&1984)>>>6,d[w++]=128|(E&63)>>>0):E<65536?(d[w++]=224|(E&61440)>>>12,d[w++]=128|(E&4032)>>>6,d[w++]=128|(E&63)>>>0):(d[w++]=240|(E&1835008)>>>18,d[w++]=128|(E&258048)>>>12,d[w++]=128|(E&4032)>>>6,d[w++]=128|(E&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,D(this._buff,this._buffLen),this._buffLen>56&&(this._step(),D(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=n._bigBlock32,w=this._buffDV;for(let u=0;u<64;u+=4)d.setUint32(u,w.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)d.setUint32(u,m(d.getUint32(u-12,!1)^d.getUint32(u-32,!1)^d.getUint32(u-56,!1)^d.getUint32(u-64,!1),1),!1);let E=this._h0,p=this._h1,t=this._h2,a=this._h3,r=this._h4,s,f,b;for(let u=0;u<80;u++)u<20?(s=p&t|~p&a,f=1518500249):u<40?(s=p^t^a,f=1859775393):u<60?(s=p&t|p&a|t&a,f=2400959708):(s=p^t^a,f=3395469782),b=m(E,5)+s+r+f+d.getUint32(u*4,!1)&4294967295,r=a,a=t,t=m(p,30),p=E,E=b;this._h0=this._h0+E&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=n,n._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ye[117],Ce([1,0,115,116,71,10,9,11]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,g=[_,[]];function T(x,W,ee,se){if(!x||!W)return g;const H=x.length,J=W.length;if(H<J)return g;const j=x.toLowerCase();return k(W,ee,J,x,j,H,se)}e.scoreFuzzy=T;function k(x,W,ee,se,H,J,j){const ae=[],we=[];for(let X=0;X<ee;X++){const fe=X*J,Ee=fe-J,Z=X>0,ne=x[X],le=W[X];for(let te=0;te<J;te++){const de=te>0,oe=fe+te,ue=oe-1,O=Ee+te-1,q=de?ae[ue]:0,Q=Z&&de?ae[O]:0,ie=Z&&de?we[O]:0;let pe;!Q&&Z?pe=0:pe=m(ne,le,se,H,te,ie),pe&&Q+pe>=q&&(j||Z||H.startsWith(W,te))?(we[oe]=ie+1,ae[oe]=Q+pe):(we[oe]=_,ae[oe]=q)}}const _e=[];let ve=ee-1,M=J-1;for(;ve>=0&&M>=0;){const X=ve*J+M;we[X]===_||(_e.push(M),ve--),M--}return[ae[ee*J-1],_e.reverse()]}function m(x,W,ee,se,H,J){let j=0;if(!D(W,se[H]))return j;if(j+=1,J>0&&(j+=J*5),x===ee[H]&&(j+=1),H===0)j+=8;else{const ae=S(ee.charCodeAt(H-1));ae?j+=ae:(0,A.isUpper)(ee.charCodeAt(H))&&J===0&&(j+=2)}return j}function D(x,W){return x===W?!0:x==="/"||x==="\\"?W==="/"||W==="\\":!1}function S(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function n(x,W,ee=0,se=0){const H=W;return H.values&&H.values.length>1?h(x,H.values,ee,se):d(x,W,ee,se)}e.scoreFuzzy2=n;function h(x,W,ee,se){let H=0;const J=[];for(const j of W){const[ae,we]=d(x,j,ee,se);if(typeof ae!="number")return v;H+=ae,J.push(...we)}return[H,C(J)]}function d(x,W,ee,se){const H=(0,A.fuzzyScore)(W.original,W.originalLowercase,ee,x,x.toLowerCase(),se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?[H[0],(0,A.createMatches)(H)]:v}const w=Object.freeze({score:0}),E=1<<18,p=1<<17,t=1<<16;function a(x,W,ee,se){const H=se.values?se.values:[se];return(0,l.hash)({[se.normalized]:{values:H.map(j=>({value:j.normalized,expectContiguousMatch:j.expectContiguousMatch})),label:x,description:W,allowNonContiguousMatches:ee}})}function r(x,W,ee,se,H){if(!x||!W.normalized)return w;const J=se.getItemLabel(x);if(!J)return w;const j=se.getItemDescription(x),ae=a(J,j,ee,W),we=H[ae];if(we)return we;const _e=s(J,j,se.getItemPath(x),W,ee);return H[ae]=_e,_e}e.scoreItemFuzzy=r;function s(x,W,ee,se,H){const J=!ee||!se.containsPathSeparator;return ee&&(R.isLinux?se.pathNormalized===ee:(0,P.equalsIgnoreCase)(se.pathNormalized,ee))?{score:E,labelMatch:[{start:0,end:x.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:se.values&&se.values.length>1?f(x,W,ee,se.values,J,H):b(x,W,ee,se,J,H)}function f(x,W,ee,se,H,J){let j=0;const ae=[],we=[];for(const _e of se){const{score:ve,labelMatch:M,descriptionMatch:X}=b(x,W,ee,_e,H,J);if(ve===_)return w;j+=ve,M&&ae.push(...M),X&&we.push(...X)}return{score:j,labelMatch:C(ae),descriptionMatch:C(we)}}function b(x,W,ee,se,H,J){if(H||!W){const[j,ae]=T(x,se.normalized,se.normalizedLowercase,J&&!se.expectContiguousMatch);if(j){const we=(0,A.matchesPrefix)(se.normalized,x);let _e;if(we){_e=p;const ve=Math.round(se.normalized.length/x.length*100);_e+=ve}else _e=t;return{score:_e+j,labelMatch:we||u(ae)}}}if(W){let j=W;ee&&(j=`${W}${L.sep}`);const ae=j.length,we=`${j}${x}`,[_e,ve]=T(we,se.normalized,se.normalizedLowercase,J&&!se.expectContiguousMatch);if(_e){const M=u(ve),X=[],fe=[];return M.forEach(Ee=>{Ee.start<ae&&Ee.end>ae?(X.push({start:0,end:Ee.end-ae}),fe.push({start:Ee.start,end:ae})):Ee.start>=ae?X.push({start:Ee.start-ae,end:Ee.end-ae}):fe.push(Ee)}),{score:_e,labelMatch:X,descriptionMatch:fe}}}return w}function u(x){const W=[];if(!x)return W;let ee;for(const se of x)ee&&ee.end===se?ee.end+=1:(ee={start:se,end:se+1},W.push(ee));return W}function C(x){const W=x.sort((H,J)=>H.start-J.start),ee=[];let se;for(const H of W)!se||!y(se,H)?(se=H,ee.push(H)):(se.start=Math.min(se.start,H.start),se.end=Math.max(se.end,H.end));return ee}function y(x,W){return!(x.end<W.start||W.end<x.start)}function o(x,W,ee,se,H,J){const j=r(x,ee,se,H,J),ae=r(W,ee,se,H,J),we=j.score,_e=ae.score;if((we===E||_e===E)&&we!==_e)return we===E?-1:1;if(we>t||_e>t){if(we!==_e)return we>_e?-1:1;if(we<p&&_e<p){const ne=I(j.labelMatch,ae.labelMatch);if(ne!==0)return ne}const Ee=H.getItemLabel(x)||"",Z=H.getItemLabel(W)||"";if(Ee.length!==Z.length)return Ee.length-Z.length}if(we!==_e)return we>_e?-1:1;const ve=Array.isArray(j.labelMatch)&&j.labelMatch.length>0,M=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0;if(ve&&!M)return-1;if(M&&!ve)return 1;const X=i(x,j,H),fe=i(W,ae,H);return X&&fe&&X!==fe?fe>X?-1:1:F(x,W,ee,H)}e.compareItemsByFuzzyScore=o;function i(x,W,ee){let se=-1,H=-1;if(W.descriptionMatch&&W.descriptionMatch.length?se=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(se=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(H=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const J=ee.getItemDescription(x);J&&(H+=J.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(H=W.descriptionMatch[W.descriptionMatch.length-1].end);return H-se}function I(x,W){if(!x&&!W||(!x||!x.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!x||!x.length)return 1;const ee=x[0].start,H=x[x.length-1].end-ee,J=W[0].start,ae=W[W.length-1].end-J;return H===ae?0:ae<H?1:-1}function F(x,W,ee,se){const H=se.getItemLabel(x)||"",J=se.getItemLabel(W)||"",j=se.getItemDescription(x),ae=se.getItemDescription(W),we=H.length+(j?j.length:0),_e=J.length+(ae?ae.length:0);if(we!==_e)return we-_e;const ve=se.getItemPath(x),M=se.getItemPath(W);return ve&&M&&ve.length!==M.length?ve.length-M.length:H!==J?(0,c.compareAnything)(H,J,ee.normalized):j&&ae&&j!==ae?(0,c.compareAnything)(j,ae,ee.normalized):ve&&M&&ve!==M?(0,c.compareAnything)(ve,M,ee.normalized):0}function U(x){return x.startsWith('"')&&x.endsWith('"')}const $=" ";function B(x){typeof x!="string"&&(x="");const W=x.toLowerCase(),{pathNormalized:ee,normalized:se,normalizedLowercase:H}=N(x),J=ee.indexOf(L.sep)>=0,j=U(x);let ae;const we=x.split($);if(we.length>1)for(const _e of we){const ve=U(_e),{pathNormalized:M,normalized:X,normalizedLowercase:fe}=N(_e);X&&(ae||(ae=[]),ae.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:M,normalized:X,normalizedLowercase:fe,expectContiguousMatch:ve}))}return{original:x,originalLowercase:W,pathNormalized:ee,normalized:se,normalizedLowercase:H,values:ae,containsPathSeparator:J,expectContiguousMatch:j}}e.prepareQuery=B;function N(x){let W;R.isWindows?W=x.replace(/\//g,L.sep):W=x.replace(/\\/g,L.sep);const ee=(0,P.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:ee,normalizedLowercase:ee.toLowerCase()}}function V(x){return Array.isArray(x)?B(x.map(W=>W.original).join($)):B(x.original)}e.pieceToQuery=V}),define(ye[168],Ce([1,0,116,11,55]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",R=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${R.source}`,"g");function _(h){return h.replace(P,(d,w)=>w?d:`\\${d}`)}e.escapeIcons=_;const g=new RegExp(`\\\\${R.source}`,"g");function T(h){return h.replace(g,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=T;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(h){return h.indexOf(L)===-1?h:h.replace(k,(d,w,E,p)=>E?d:w||p||"")}e.stripIcons=m;function D(h){return h?h.replace(/\$\((.*?)\)/g,(d,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=D;const S=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(h){S.lastIndex=0;let d="";const w=[];let E=0;for(;;){const p=S.lastIndex,t=S.exec(h),a=h.substring(p,t?.index);if(a.length>0){d+=a;for(let r=0;r<a.length;r++)w.push(E)}if(!t)break;E+=t[0].length}return{text:d,iconOffsets:w}}e.parseLabelWithIcons=v;function n(h,d,w=!1){const{text:E,iconOffsets:p}=d;if(!p||p.length===0)return(0,c.matchesFuzzy)(h,E,w);const t=(0,A.ltrim)(E," "),a=E.length-t.length,r=(0,c.matchesFuzzy)(h,t,w);if(r)for(const s of r){const f=p[s.start+a]+a;s.start+=f,s.end+=f}return r}e.matchesFuzzyIconAware=n}),define(ye[41],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(A||(A={})),function(l){const L="error",R="warning",P="warn",_="info",g="ignore";function T(m){return m?c.equalsIgnoreCase(L,m)?l.Error:c.equalsIgnoreCase(R,m)||c.equalsIgnoreCase(P,m)?l.Warning:c.equalsIgnoreCase(_,m)?l.Info:l.Ignore:l.Ignore}l.fromValue=T;function k(m){switch(m){case l.Error:return L;case l.Warning:return R;case l.Info:return _;default:return g}}l.toString=k}(A||(A={})),e.default=A}),define(ye[72],Ce([1,0,19,11]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this._value="",this._pos=0}reset(D){return this._value=D,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(D){const S=D.charCodeAt(0),v=this._value.charCodeAt(this._pos);return S-v}value(){return this._value[this._pos]}}e.StringIterator=l;class L{constructor(D=!0){this._caseSensitive=D}reset(D){return this._value=D,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let D=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(D)this._from++;else break;else D=!1;return this}cmp(D){return this._caseSensitive?(0,A.compareSubstring)(D,this._value,0,D.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(D,this._value,0,D.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class R{constructor(D=!0,S=!0){this._splitOnBackslash=D,this._caseSensitive=S}reset(D){this._from=0,this._to=0,this._value=D,this._valueLen=D.length;for(let S=D.length-1;S>=0;S--,this._valueLen--){const v=this._value.charCodeAt(S);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let D=!0;for(;this._to<this._valueLen;this._to++){const S=this._value.charCodeAt(this._to);if(S===47||this._splitOnBackslash&&S===92)if(D)this._from++;else break;else D=!1}return this}cmp(D){return this._caseSensitive?(0,A.compareSubstring)(D,this._value,0,D.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(D,this._value,0,D.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var P;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(P||(P={}));class _{constructor(D,S){this._ignorePathCasing=D,this._ignoreQueryAndFragment=S,this._states=[],this._stateIdx=0}reset(D){return this._value=D,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(D)),this._pathIterator.reset(D.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(D)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(D){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(D,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(D,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(D);if(this._states[this._stateIdx]===4)return(0,A.compare)(D,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(D,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=_;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(T||(T={}));class k{static forUris(D=()=>!1,S=()=>!1){return new k(new _(D,S))}static forPaths(D=!1){return new k(new R(void 0,!D))}static forStrings(){return new k(new l)}static forConfigKeys(){return new k(new L)}constructor(D){this._iter=D}clear(){this._root=void 0}fill(D,S){if(S){const v=S.slice(0);(0,c.shuffle)(v);for(const n of v)this.set(n,D)}else{const v=D.slice(0);(0,c.shuffle)(v);for(const n of v)this.set(n[0],n[1])}}set(D,S){const v=this._iter.reset(D);let n;this._root||(this._root=new g,this._root.segment=v.value());const h=[];for(n=this._root;;){const w=v.cmp(n.segment);if(w>0)n.left||(n.left=new g,n.left.segment=v.value()),h.push([-1,n]),n=n.left;else if(w<0)n.right||(n.right=new g,n.right.segment=v.value()),h.push([1,n]),n=n.right;else if(v.hasNext())v.next(),n.mid||(n.mid=new g,n.mid.segment=v.value()),h.push([0,n]),n=n.mid;else break}const d=n.value;n.value=S,n.key=D;for(let w=h.length-1;w>=0;w--){const E=h[w][1];E.updateHeight();const p=E.balanceFactor();if(p<-1||p>1){const t=h[w][0],a=h[w+1][0];if(t===1&&a===1)h[w][1]=E.rotateLeft();else if(t===-1&&a===-1)h[w][1]=E.rotateRight();else if(t===1&&a===-1)E.right=h[w+1][1]=h[w+1][1].rotateRight(),h[w][1]=E.rotateLeft();else if(t===-1&&a===1)E.left=h[w+1][1]=h[w+1][1].rotateLeft(),h[w][1]=E.rotateRight();else throw new Error;if(w>0)switch(h[w-1][0]){case-1:h[w-1][1].left=h[w][1];break;case 1:h[w-1][1].right=h[w][1];break;case 0:h[w-1][1].mid=h[w][1];break}else this._root=h[0][1]}}return d}get(D){return this._getNode(D)?.value}_getNode(D){const S=this._iter.reset(D);let v=this._root;for(;v;){const n=S.cmp(v.segment);if(n>0)v=v.left;else if(n<0)v=v.right;else if(S.hasNext())S.next(),v=v.mid;else break}return v}has(D){const S=this._getNode(D);return!(S?.value===void 0&&S?.mid===void 0)}delete(D){return this._delete(D,!1)}deleteSuperstr(D){return this._delete(D,!0)}_delete(D,S){const v=this._iter.reset(D),n=[];let h=this._root;for(;h;){const d=v.cmp(h.segment);if(d>0)n.push([-1,h]),h=h.left;else if(d<0)n.push([1,h]),h=h.right;else if(v.hasNext())v.next(),n.push([0,h]),h=h.mid;else break}if(h){if(S?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const d=this._min(h.right);if(d.key){const{key:w,value:E,segment:p}=d;this._delete(d.key,!1),h.key=w,h.value=E,h.segment=p}}else{const d=h.left??h.right;if(n.length>0){const[w,E]=n[n.length-1];switch(w){case-1:E.left=d;break;case 0:E.mid=d;break;case 1:E.right=d;break}}else this._root=d}for(let d=n.length-1;d>=0;d--){const w=n[d][1];w.updateHeight();const E=w.balanceFactor();if(E>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),n[d][1]=w.rotateLeft()):E<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),n[d][1]=w.rotateRight()),d>0)switch(n[d-1][0]){case-1:n[d-1][1].left=n[d][1];break;case 1:n[d-1][1].right=n[d][1];break;case 0:n[d-1][1].mid=n[d][1];break}else this._root=n[0][1]}}}_min(D){for(;D.left;)D=D.left;return D}findSubstr(D){const S=this._iter.reset(D);let v=this._root,n;for(;v;){const h=S.cmp(v.segment);if(h>0)v=v.left;else if(h<0)v=v.right;else if(S.hasNext())S.next(),n=v.value||n,v=v.mid;else break}return v&&v.value||n}findSuperstr(D){return this._findSuperstrOrElement(D,!1)}_findSuperstrOrElement(D,S){const v=this._iter.reset(D);let n=this._root;for(;n;){const h=v.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(v.hasNext())v.next(),n=n.mid;else return n.mid?this._entries(n.mid):S?n.value:void 0}}hasElementOrSubtree(D){return this._findSuperstrOrElement(D,!0)!==void 0}forEach(D){for(const[S,v]of this)D(v,S)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(D){const S=[];return this._dfsEntries(D,S),S[Symbol.iterator]()}_dfsEntries(D,S){D&&(D.left&&this._dfsEntries(D.left,S),D.value&&S.push([D.key,D.value]),D.mid&&this._dfsEntries(D.mid,S),D.right&&this._dfsEntries(D.right,S))}_isBalanced(){const D=S=>{if(!S)return!0;const v=S.balanceFactor();return v<-1||v>1?!1:D(S.left)&&D(S.right)};return D(this._root)}}e.TernarySearchTree=k}),define(ye[2],Ce([1,0,10,9]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function P(s,f){if(!s.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!l.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,f){return!s&&!f?"file":s}function g(s,f){switch(s){case"https":case"http":case"file":f?f[0]!==k&&(f=k+f):f=k;break}return f}const T="",k="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(f){return f instanceof D?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,b,u,C,y,o=!1){typeof f=="object"?(this.scheme=f.scheme||T,this.authority=f.authority||T,this.path=f.path||T,this.query=f.query||T,this.fragment=f.fragment||T):(this.scheme=_(f,o),this.authority=b||T,this.path=g(this.scheme,u||T),this.query=C||T,this.fragment=y||T,P(this,o))}get fsPath(){return E(this,!1)}with(f){if(!f)return this;let{scheme:b,authority:u,path:C,query:y,fragment:o}=f;return b===void 0?b=this.scheme:b===null&&(b=T),u===void 0?u=this.authority:u===null&&(u=T),C===void 0?C=this.path:C===null&&(C=T),y===void 0?y=this.query:y===null&&(y=T),o===void 0?o=this.fragment:o===null&&(o=T),b===this.scheme&&u===this.authority&&C===this.path&&y===this.query&&o===this.fragment?this:new n(b,u,C,y,o)}static parse(f,b=!1){const u=m.exec(f);return u?new n(u[2]||T,r(u[4]||T),r(u[5]||T),r(u[7]||T),r(u[9]||T),b):new n(T,T,T,T,T)}static file(f){let b=T;if(A.isWindows&&(f=f.replace(/\\/g,k)),f[0]===k&&f[1]===k){const u=f.indexOf(k,2);u===-1?(b=f.substring(2),f=k):(b=f.substring(2,u),f=f.substring(u)||k)}return new n("file",b,f,T,T)}static from(f,b){return new n(f.scheme,f.authority,f.path,f.query,f.fragment,b)}static joinPath(f,...b){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return A.isWindows&&f.scheme==="file"?u=D.file(c.win32.join(E(f,!0),...b)).path:u=c.posix.join(f.path,...b),f.with({path:u})}toString(f=!1){return p(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof D)return f;{const b=new n(f);return b._formatted=f.external??null,b._fsPath=f._sep===v?f.fsPath??null:null,b}}else return f}}e.URI=D;function S(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.isUriComponents=S;const v=A.isWindows?1:void 0;class n extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(f=!1){return f?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=v),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(s,f,b){let u,C=-1;for(let y=0;y<s.length;y++){const o=s.charCodeAt(y);if(o>=97&&o<=122||o>=65&&o<=90||o>=48&&o<=57||o===45||o===46||o===95||o===126||f&&o===47||b&&o===91||b&&o===93||b&&o===58)C!==-1&&(u+=encodeURIComponent(s.substring(C,y)),C=-1),u!==void 0&&(u+=s.charAt(y));else{u===void 0&&(u=s.substr(0,y));const i=h[o];i!==void 0?(C!==-1&&(u+=encodeURIComponent(s.substring(C,y)),C=-1),u+=i):C===-1&&(C=y)}}return C!==-1&&(u+=encodeURIComponent(s.substring(C))),u!==void 0?u:s}function w(s){let f;for(let b=0;b<s.length;b++){const u=s.charCodeAt(b);u===35||u===63?(f===void 0&&(f=s.substr(0,b)),f+=h[u]):f!==void 0&&(f+=s[b])}return f!==void 0?f:s}function E(s,f){let b;return s.authority&&s.path.length>1&&s.scheme==="file"?b=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?f?b=s.path.substr(1):b=s.path[1].toLowerCase()+s.path.substr(2):b=s.path,A.isWindows&&(b=b.replace(/\//g,"\\")),b}e.uriToFsPath=E;function p(s,f){const b=f?w:d;let u="",{scheme:C,authority:y,path:o,query:i,fragment:I}=s;if(C&&(u+=C,u+=":"),(y||C==="file")&&(u+=k,u+=k),y){let F=y.indexOf("@");if(F!==-1){const U=y.substr(0,F);y=y.substr(F+1),F=U.lastIndexOf(":"),F===-1?u+=b(U,!1,!1):(u+=b(U.substr(0,F),!1,!1),u+=":",u+=b(U.substr(F+1),!1,!0)),u+="@"}y=y.toLowerCase(),F=y.lastIndexOf(":"),F===-1?u+=b(y,!1,!0):(u+=b(y.substr(0,F),!1,!0),u+=y.substr(F))}if(o){if(o.length>=3&&o.charCodeAt(0)===47&&o.charCodeAt(2)===58){const F=o.charCodeAt(1);F>=65&&F<=90&&(o=`/${String.fromCharCode(F+32)}:${o.substr(3)}`)}else if(o.length>=2&&o.charCodeAt(1)===58){const F=o.charCodeAt(0);F>=65&&F<=90&&(o=`${String.fromCharCode(F+32)}:${o.substr(2)}`)}u+=b(o,!0,!1)}return i&&(u+="?",u+=b(i,!1,!1)),I&&(u+="#",u+=f?I:d(I,!1,!1)),u}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(a)?s.replace(a,f=>t(f)):s}}),define(ye[169],Ce([1,0,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(g){const T=g;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=A;function l(g){const T=[];let k;try{const m=JSON.parse(g.arguments),D=m[m.length-1];D&&D.__$stack&&(m.pop(),k=D.__$stack),T.push(...m)}catch{T.push("Unable to log remote console arguments",g.arguments)}return{args:T,stack:k}}e.parse=l;function L(g){if(typeof g!="string")return L(l(g).stack);const T=g;if(T){const k=R(T),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(m&&m.length===4)return{uri:c.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=L;function R(g){if(!g)return g;const T=g.indexOf(`
`);return T===-1?g:g.substring(0,T)}function P(g,T){const{args:k,stack:m}=l(g),D=typeof k[0]=="string"&&k.length===1;let S=R(m);S&&(S=`(${S.trim()})`);let v=[];if(typeof k[0]=="string"?S&&D?v=[`%c[${T}] %c${k[0]} %c${S}`,_("blue"),_(""),_("grey")]:v=[`%c[${T}] %c${k[0]}`,_("blue"),_(""),...k.slice(1)]:v=[`%c[${T}]%`,_("blue"),...k],S&&!D&&v.push(S),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,v)}e.log=P;function _(g){return`color: ${g}`}}),define(ye[73],Ce([1,0,21,11,2]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(g){return JSON.stringify(g,P)}e.stringify=L;function R(g){let T=JSON.parse(g);return T=_(T),T}e.parse=R;function P(g,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,A.regExpFlags)(T)}:T}function _(g,T=0){if(!g||T>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return l.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof c.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let k=0;k<g.length;++k)g[k]=_(g[k],T+1);else for(const k in g)Object.hasOwnProperty.call(g,k)&&(g[k]=_(g[k],T+1))}return g}e.revive=_}),define(ye[18],Ce([1,0,8,9,2]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(T){this._preferredWebSchema=T}setDelegate(T){this._delegate=T}setServerRootPath(T){this._remoteResourcesPath=`${T}/${L.vscodeRemoteResource}`}set(T,k,m){this._hosts[T]=k,this._ports[T]=m}setConnectionToken(T,k){this._connectionTokens[T]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(T){if(this._delegate)try{return this._delegate(T)}catch(n){return c.onUnexpectedError(n),T}const k=T.authority;let m=this._hosts[k];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const D=this._ports[k],S=this._connectionTokens[k];let v=`path=${encodeURIComponent(T.path)}`;return typeof S=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),l.URI.from({scheme:A.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${m}:${D}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(T){const k=this.toUri(T,re);return this.uriToBrowserUri(k)}uriToBrowserUri(T){return T.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===L.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${L.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?T.with({scheme:L.vscodeFileResource,authority:T.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(T){const k=this.toUri(T,re);return this.uriToFileUri(k)}uriToFileUri(T){return T.scheme===L.vscodeFileResource?T.with({scheme:L.file,authority:T.authority!==P.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(T,k){return l.URI.isUri(T)?T:l.URI.parse(k.toUrl(T))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var _;(function(g){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(T.get("3"));const k="vscode-coi";function m(S){let v;typeof S=="string"?v=new URL(S).searchParams:S instanceof URL?v=S.searchParams:l.URI.isUri(S)&&(v=new URL(S.toString(!0)).searchParams);const n=v?.get(k);if(n)return T.get(n)}g.getHeadersFromQuery=m;function D(S,v,n){if(!globalThis.crossOriginIsolated)return;const h=v&&n?"3":n?"2":"1";S instanceof URLSearchParams?S.set(k,h):S[k]=h}g.addSearchParam=D})(_||(e.COI=_={}))}),define(ye[24],Ce([1,0,30,18,10,9,11,2]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(D){return(0,P.uriToFsPath)(D,!0)}e.originalFSPath=_;class g{constructor(S){this._ignorePathCasing=S}compare(S,v,n=!1){return S===v?0:(0,R.compare)(this.getComparisonKey(S,n),this.getComparisonKey(v,n))}isEqual(S,v,n=!1){return S===v?!0:!S||!v?!1:this.getComparisonKey(S,n)===this.getComparisonKey(v,n)}getComparisonKey(S,v=!1){return S.with({path:this._ignorePathCasing(S)?S.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(S){return this._ignorePathCasing(S)}isEqualOrParent(S,v,n=!1){if(S.scheme===v.scheme){if(S.scheme===A.Schemas.file)return c.isEqualOrParent(_(S),_(v),this._ignorePathCasing(S))&&S.query===v.query&&(n||S.fragment===v.fragment);if((0,e.isEqualAuthority)(S.authority,v.authority))return c.isEqualOrParent(S.path,v.path,this._ignorePathCasing(S),"/")&&S.query===v.query&&(n||S.fragment===v.fragment)}return!1}joinPath(S,...v){return P.URI.joinPath(S,...v)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return l.posix.basename(S.path)}extname(S){return l.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let v;return S.scheme===A.Schemas.file?v=P.URI.file(l.dirname(_(S))).path:(v=l.posix.dirname(S.path),S.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),v="/")),S.with({path:v})}normalizePath(S){if(!S.path.length)return S;let v;return S.scheme===A.Schemas.file?v=P.URI.file(l.normalize(_(S))).path:v=l.posix.normalize(S.path),S.with({path:v})}relativePath(S,v){if(S.scheme!==v.scheme||!(0,e.isEqualAuthority)(S.authority,v.authority))return;if(S.scheme===A.Schemas.file){const d=l.relative(_(S),_(v));return L.isWindows?c.toSlashes(d):d}let n=S.path||"/";const h=v.path||"/";if(this._ignorePathCasing(S)){let d=0;for(const w=Math.min(n.length,h.length);d<w&&!(n.charCodeAt(d)!==h.charCodeAt(d)&&n.charAt(d).toLowerCase()!==h.charAt(d).toLowerCase());d++);n=h.substr(0,d)+n.substr(d)}return l.posix.relative(n,h)}resolvePath(S,v){if(S.scheme===A.Schemas.file){const n=P.URI.file(l.resolve(_(S),v));return S.with({authority:n.authority,path:n.path})}return v=c.toPosixPath(v),S.with({path:l.posix.resolve(S.path,v)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,v){return S===v||S!==void 0&&v!==void 0&&(0,R.equalsIgnoreCase)(S,v)}hasTrailingPathSeparator(S,v=l.sep){if(S.scheme===A.Schemas.file){const n=_(S);return n.length>c.getRoot(n).length&&n[n.length-1]===v}else{const n=S.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,v=l.sep){return(0,e.hasTrailingPathSeparator)(S,v)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,v=l.sep){let n=!1;if(S.scheme===A.Schemas.file){const h=_(S);n=h!==void 0&&h.length===c.getRoot(h).length&&h[h.length-1]===v}else{v="/";const h=S.path;n=h.length===1&&h.charCodeAt(h.length-1)===47}return!n&&!(0,e.hasTrailingPathSeparator)(S,v)?S.with({path:S.path+"/"}):S}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(D=>D.scheme===A.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new g(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(D,S){const v=[];for(let n=0;n<D.length;n++){const h=S(D[n]);D.some((d,w)=>w===n?!1:(0,e.isEqualOrParent)(h,S(d)))||v.push(D[n])}return v}e.distinctParents=T;var k;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function S(v){const n=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(w=>{const[E,p]=w.split(":");E&&p&&n.set(E,p)});const d=v.path.substring(0,v.path.indexOf(";"));return d&&n.set(D.META_DATA_MIME,d),n}D.parseMetaData=S})(k||(e.DataUri=k={}));function m(D,S,v){if(S){let n=D.path;return n&&n[0]!==l.posix.sep&&(n=l.posix.sep+n),D.with({scheme:v,authority:S,path:n})}return D.with({scheme:v})}e.toLocalResource=m}),define(ye[16],Ce([1,0,22,8,3,4,24,9,152]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(ve){return!!ve&&typeof ve.then=="function"}e.isThenable=g;function T(ve){const M=new c.CancellationTokenSource,X=ve(M.token),fe=new Promise((Ee,Z)=>{const ne=M.token.onCancellationRequested(()=>{ne.dispose(),M.dispose(),Z(new A.CancellationError)});Promise.resolve(X).then(le=>{ne.dispose(),M.dispose(),Ee(le)},le=>{ne.dispose(),M.dispose(),Z(le)})});return new class{cancel(){M.cancel()}then(Ee,Z){return fe.then(Ee,Z)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return fe.finally(Ee)}}}e.createCancelablePromise=T;function k(ve,M,X){return new Promise((fe,Ee)=>{const Z=M.onCancellationRequested(()=>{Z.dispose(),fe(X)});ve.then(fe,Ee).finally(()=>Z.dispose())})}e.raceCancellation=k;function m(ve,M){return new Promise((X,fe)=>{const Ee=M.onCancellationRequested(()=>{Ee.dispose(),fe(new A.CancellationError)});ve.then(X,fe).finally(()=>Ee.dispose())})}e.raceCancellationError=m;async function D(ve){let M=-1;const X=ve.map((fe,Ee)=>fe.then(Z=>(M=Ee,Z)));try{return await Promise.race(X)}finally{ve.forEach((fe,Ee)=>{Ee!==M&&fe.cancel()})}}e.raceCancellablePromises=D;function S(ve,M,X){let fe;const Ee=setTimeout(()=>{fe?.(void 0),X?.()},M);return Promise.race([ve.finally(()=>clearTimeout(Ee)),new Promise(Z=>fe=Z)])}e.raceTimeout=S;function v(ve){return new Promise((M,X)=>{const fe=ve();g(fe)?fe.then(M,X):M(fe)})}e.asPromise=v;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const X=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(X,X).then(fe)})}return new Promise((X,fe)=>{this.queuedPromise.then(X,fe)})}return this.activePromise=M(),new Promise((X,fe)=>{this.activePromise.then(Ee=>{this.activePromise=null,X(Ee)},Ee=>{this.activePromise=null,fe(Ee)})})}}e.Throttler=n;class h{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=h;class d{constructor(){this.promiseMap=new Map}queue(M,X){const Ee=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.promiseMap.get(M)===Ee&&this.promiseMap.delete(M)});return this.promiseMap.set(M,Ee),Ee}}e.SequencerByKey=d;const w=(ve,M)=>{let X=!0;const fe=setTimeout(()=>{X=!1,M()},ve);return{isTriggered:()=>X,dispose:()=>{clearTimeout(fe),X=!1}}},E=ve=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,ve())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class p{constructor(M){this.defaultDelay=M,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,X=this.defaultDelay){this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ee,Z)=>{this.doResolve=Ee,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ee=this.task;return this.task=null,Ee()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=X===_.MicrotaskDelay?E(fe):w(X,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new A.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(M){this.delayer=new p(M),this.throttler=new n}trigger(M,X){return this.delayer.trigger(()=>this.throttler.queue(M),X)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this._isOpen=!1,this._promise=new Promise((M,X)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class r extends a{constructor(M){super(),this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function s(ve,M){return M?new Promise((X,fe)=>{const Ee=setTimeout(()=>{Z.dispose(),X()},ve),Z=M.onCancellationRequested(()=>{clearTimeout(Ee),Z.dispose(),fe(new A.CancellationError)})}):T(X=>s(ve,X))}e.timeout=s;function f(ve,M=0){const X=setTimeout(ve,M);return(0,L.toDisposable)(()=>clearTimeout(X))}e.disposableTimeout=f;function b(ve){const M=[];let X=0;const fe=ve.length;function Ee(){return X<fe?ve[X++]():null}function Z(ne){ne!=null&&M.push(ne);const le=Ee();return le?le.then(Z):Promise.resolve(M)}return Promise.resolve(null).then(Z)}e.sequence=b;function u(ve,M=fe=>!!fe,X=null){let fe=0;const Ee=ve.length,Z=()=>{if(fe>=Ee)return Promise.resolve(X);const ne=ve[fe++];return Promise.resolve(ne()).then(te=>M(te)?Promise.resolve(te):Z())};return Z()}e.first=u;function C(ve,M=fe=>!!fe,X=null){if(ve.length===0)return Promise.resolve(X);let fe=ve.length;const Ee=()=>{fe=-1;for(const Z of ve)Z.cancel?.()};return new Promise((Z,ne)=>{for(const le of ve)le.then(te=>{--fe>=0&&M(te)?(Ee(),Z(te)):fe===0&&Z(X)}).catch(te=>{--fe>=0&&(Ee(),ne(te))})})}e.firstParallel=C;class y{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new l.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(M){return this._size++,new Promise((X,fe)=>{this.outstandingPromises.push({factory:M,c:X,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const X=M.factory();X.then(M.c,M.e),X.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class o extends y{constructor(){super(1)}}e.Queue=o;class i{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const M=new H;return this.drainers.add(M),M.p}isDrained(){for(const[,M]of this.queues)if(M.size>0)return!1;return!0}queueFor(M,X=R.extUri){const fe=X.getComparisonKey(M);let Ee=this.queues.get(fe);return Ee||(Ee=new o,l.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.queues.delete(fe),this.onDidQueueDrain()}),this.queues.set(fe,Ee)),Ee}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const M of this.drainers)M.complete();this.drainers.clear()}dispose(){for(const[,M]of this.queues)M.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=i;class I{constructor(M,X){this._token=-1,typeof M=="function"&&typeof X=="number"&&this.setIfNotSet(M,X)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,X){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},X)}setIfNotSet(M,X){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},X))}}e.TimeoutTimer=I;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,X){this.cancel(),this._token=setInterval(()=>{M()},X)}}e.IntervalTimer=F;class U{constructor(M,X){this.timeoutToken=-1,this.runner=M,this.timeout=X,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class ${constructor(M,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.runner=M,this.timeout=X,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(M=this.timeout){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(M/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class B extends U{constructor(M,X){super(M,X),this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner?.(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class N extends L.Disposable{constructor(M,X){super(),this.options=M,this.handler=X,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.options.maxBufferedWork)return!1}else if(this.pending+M.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const X of M)this.pendingWork.push(X);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ve=>{(0,P.setTimeout0)(()=>{if(M)return;const X=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(ve,M)=>{const X=requestIdleCallback(ve,typeof M=="number"?{timeout:M}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(X))}}}}();class V{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(X){this._error=X}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function x(ve,M,X){let fe;for(let Ee=0;Ee<X;Ee++)try{return await ve()}catch(Z){fe=Z,await s(M)}throw fe}e.retry=x;class W{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(M,X,fe){return this._pending={taskId:M,cancel:()=>fe?.(),promise:X},X.then(()=>this.donePending(M),()=>this.donePending(M)),X}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let X,fe;const Ee=new Promise((Z,ne)=>{X=Z,fe=ne});this._next={run:M,promise:Ee,promiseResolve:X,promiseReject:fe}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class ee{constructor(M,X=()=>Date.now()){this.interval=M,this.nowFn=X,this.lastIncrementTime=0,this.value=0}increment(){const M=this.nowFn();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;var se;(function(ve){ve[ve.Resolved=0]="Resolved",ve[ve.Rejected=1]="Rejected"})(se||(se={}));class H{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((M,X)=>{this.completeCallback=M,this.errorCallback=X})}complete(M){return new Promise(X=>{this.completeCallback(M),this.outcome={outcome:0,value:M},X()})}error(M){return new Promise(X=>{this.errorCallback(M),this.outcome={outcome:1,value:M},X()})}cancel(){return this.error(new A.CancellationError)}}e.DeferredPromise=H;var J;(function(ve){async function M(fe){let Ee;const Z=await Promise.all(fe.map(ne=>ne.then(le=>le,le=>{Ee||(Ee=le)})));if(typeof Ee<"u")throw Ee;return Z}ve.settled=M;function X(fe){return new Promise(async(Ee,Z)=>{try{await fe(Ee,Z)}catch(ne){Z(ne)}})}ve.withAsyncBody=X})(J||(e.Promises=J={}));var j;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(j||(j={}));class ae{static fromArray(M){return new ae(X=>{X.emitMany(M)})}static fromPromise(M){return new ae(async X=>{X.emitMany(await M)})}static fromPromises(M){return new ae(async X=>{await Promise.all(M.map(async fe=>X.emitOne(await fe)))})}static merge(M){return new ae(async X=>{await Promise.all(M.map(async fe=>{for await(const Ee of fe)X.emitOne(Ee)}))})}constructor(M){this._state=0,this._results=[],this._error=null,this._onStateChanged=new l.Emitter,queueMicrotask(async()=>{const X={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(M(X)),this.resolve()}catch(fe){this.reject(fe)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(M<this._results.length)return{done:!1,value:this._results[M++]};if(this._state===1)return{done:!0,value:void 0};await l.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(M,X){return new ae(async fe=>{for await(const Ee of M)fe.emitOne(X(Ee))})}map(M){return ae.map(this,M)}static filter(M,X){return new ae(async fe=>{for await(const Ee of M)X(Ee)&&fe.emitOne(Ee)})}filter(M){return ae.filter(this,M)}static coalesce(M){return ae.filter(M,X=>!!X)}coalesce(){return ae.coalesce(this)}static async toPromise(M){const X=[];for await(const fe of M)X.push(fe);return X}toPromise(){return ae.toPromise(this)}emitOne(M){this._state===0&&(this._results.push(M),this._onStateChanged.fire())}emitMany(M){this._state===0&&(this._results=this._results.concat(M),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(M){this._state===0&&(this._state=2,this._error=M,this._onStateChanged.fire())}}e.AsyncIterableObject=ae,ae.EMPTY=ae.fromArray([]);class we extends ae{constructor(M,X){super(X),this._source=M}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function _e(ve){const M=new c.CancellationTokenSource,X=ve(M.token);return new we(M,async fe=>{const Ee=M.token.onCancellationRequested(()=>{Ee.dispose(),M.dispose(),fe.reject(new A.CancellationError)});try{for await(const Z of X){if(M.token.isCancellationRequested)return;fe.emitOne(Z)}Ee.dispose(),M.dispose()}catch(Z){Ee.dispose(),M.dispose(),fe.reject(Z)}})}e.createCancelableAsyncIterable=_e}),define(ye[33],Ce([1,0,19,16,30,28,10,9,11]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",k="[^/\\\\]",m=/\//g;function D(ee,se){switch(ee){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}${se?`|${T}${k}+`:""})*?`}}function S(ee,se){if(!ee)return[];const H=[];let J=!1,j=!1,ae="";for(const we of ee){switch(we){case se:if(!J&&!j){H.push(ae),ae="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":j=!0;break;case"]":j=!1;break}ae+=we}return ae&&H.push(ae),H}e.splitGlobAware=S;function v(ee){if(!ee)return"";let se="";const H=S(ee,e.GLOB_SPLIT);if(H.every(J=>J===e.GLOBSTAR))se=".*";else{let J=!1;H.forEach((j,ae)=>{if(j===e.GLOBSTAR){if(J)return;se+=D(2,ae===H.length-1)}else{let we=!1,_e="",ve=!1,M="";for(const X of j){if(X!=="}"&&we){_e+=X;continue}if(ve&&(X!=="]"||!M)){let fe;X==="-"?fe=X:(X==="^"||X==="!")&&!M?fe="^":X===e.GLOB_SPLIT?fe="":fe=(0,_.escapeRegExpCharacters)(X),M+=fe;continue}switch(X){case"{":we=!0;continue;case"[":ve=!0;continue;case"}":{const Ee=`(?:${S(_e,",").map(Z=>v(Z)).join("|")})`;se+=Ee,we=!1,_e="";break}case"]":{se+="["+M+"]",ve=!1,M="";break}case"?":se+=k;continue;case"*":se+=D(1);continue;default:se+=(0,_.escapeRegExpCharacters)(X)}}ae<H.length-1&&(H[ae+1]!==e.GLOBSTAR||ae+2<H.length)&&(se+=T)}J=j===e.GLOBSTAR})}return se}const n=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(ee,se){if(!ee)return r;let H;typeof ee!="string"?H=ee.pattern:H=ee,H=H.trim();const J=`${H}_${!!se.trimForExclusions}`;let j=t.get(J);if(j)return f(j,ee);let ae;return n.test(H)?j=u(H.substr(4),H):(ae=h.exec(b(H,se)))?j=C(ae[1],H):(se.trimForExclusions?w:d).test(H)?j=y(H,se):(ae=E.exec(b(H,se)))?j=o(ae[1].substr(1),H,!0):(ae=p.exec(b(H,se)))?j=o(ae[1],H,!1):j=i(H),t.set(J,j),f(j,ee)}function f(ee,se){if(typeof se=="string")return ee;const H=function(J,j){return(0,l.isEqualOrParent)(J,se.base,!P.isLinux)?ee((0,_.ltrim)(J.substr(se.base.length),R.sep),j):null};return H.allBasenames=ee.allBasenames,H.allPaths=ee.allPaths,H.basenames=ee.basenames,H.patterns=ee.patterns,H}function b(ee,se){return se.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function u(ee,se){return function(H,J){return typeof H=="string"&&H.endsWith(ee)?se:null}}function C(ee,se){const H=`/${ee}`,J=`\\${ee}`,j=function(we,_e){return typeof we!="string"?null:_e?_e===ee?se:null:we===ee||we.endsWith(H)||we.endsWith(J)?se:null},ae=[ee];return j.basenames=ae,j.patterns=[se],j.allBasenames=ae,j}function y(ee,se){const H=x(ee.slice(1,-1).split(",").map(_e=>s(_e,se)).filter(_e=>_e!==r),ee),J=H.length;if(!J)return r;if(J===1)return H[0];const j=function(_e,ve){for(let M=0,X=H.length;M<X;M++)if(H[M](_e,ve))return ee;return null},ae=H.find(_e=>!!_e.allBasenames);ae&&(j.allBasenames=ae.allBasenames);const we=H.reduce((_e,ve)=>ve.allPaths?_e.concat(ve.allPaths):_e,[]);return we.length&&(j.allPaths=we),j}function o(ee,se,H){const J=R.sep===R.posix.sep,j=J?ee:ee.replace(m,R.sep),ae=R.sep+j,we=R.posix.sep+ee;let _e;return H?_e=function(ve,M){return typeof ve=="string"&&(ve===j||ve.endsWith(ae)||!J&&(ve===ee||ve.endsWith(we)))?se:null}:_e=function(ve,M){return typeof ve=="string"&&(ve===j||!J&&ve===ee)?se:null},_e.allPaths=[(H?"*/":"./")+ee],_e}function i(ee){try{const se=new RegExp(`^${v(ee)}$`);return function(H){return se.lastIndex=0,typeof H=="string"&&se.test(H)?ee:null}}catch{return r}}function I(ee,se,H){return!ee||typeof se!="string"?!1:F(ee)(se,void 0,H)}e.match=I;function F(ee,se={}){if(!ee)return a;if(typeof ee=="string"||U(ee)){const H=s(ee,se);if(H===r)return a;const J=function(j,ae){return!!H(j,ae)};return H.allBasenames&&(J.allBasenames=H.allBasenames),H.allPaths&&(J.allPaths=H.allPaths),J}return N(ee,se)}e.parse=F;function U(ee){const se=ee;return se?typeof se.base=="string"&&typeof se.pattern=="string":!1}e.isRelativePattern=U;function $(ee){return ee.allBasenames||[]}e.getBasenameTerms=$;function B(ee){return ee.allPaths||[]}e.getPathTerms=B;function N(ee,se){const H=x(Object.getOwnPropertyNames(ee).map(_e=>V(_e,ee[_e],se)).filter(_e=>_e!==r)),J=H.length;if(!J)return r;if(!H.some(_e=>!!_e.requiresSiblings)){if(J===1)return H[0];const _e=function(X,fe){let Ee;for(let Z=0,ne=H.length;Z<ne;Z++){const le=H[Z](X,fe);if(typeof le=="string")return le;(0,A.isThenable)(le)&&(Ee||(Ee=[]),Ee.push(le))}return Ee?(async()=>{for(const Z of Ee){const ne=await Z;if(typeof ne=="string")return ne}return null})():null},ve=H.find(X=>!!X.allBasenames);ve&&(_e.allBasenames=ve.allBasenames);const M=H.reduce((X,fe)=>fe.allPaths?X.concat(fe.allPaths):X,[]);return M.length&&(_e.allPaths=M),_e}const j=function(_e,ve,M){let X,fe;for(let Ee=0,Z=H.length;Ee<Z;Ee++){const ne=H[Ee];ne.requiresSiblings&&M&&(ve||(ve=(0,R.basename)(_e)),X||(X=ve.substr(0,ve.length-(0,R.extname)(_e).length)));const le=ne(_e,ve,X,M);if(typeof le=="string")return le;(0,A.isThenable)(le)&&(fe||(fe=[]),fe.push(le))}return fe?(async()=>{for(const Ee of fe){const Z=await Ee;if(typeof Z=="string")return Z}return null})():null},ae=H.find(_e=>!!_e.allBasenames);ae&&(j.allBasenames=ae.allBasenames);const we=H.reduce((_e,ve)=>ve.allPaths?_e.concat(ve.allPaths):_e,[]);return we.length&&(j.allPaths=we),j}function V(ee,se,H){if(se===!1)return r;const J=s(ee,H);if(J===r)return r;if(typeof se=="boolean")return J;if(se){const j=se.when;if(typeof j=="string"){const ae=(we,_e,ve,M)=>{if(!M||!J(we,_e))return null;const X=j.replace("$(basename)",()=>ve),fe=M(X);return(0,A.isThenable)(fe)?fe.then(Ee=>Ee?ee:null):fe?ee:null};return ae.requiresSiblings=!0,ae}}return J}function x(ee,se){const H=ee.filter(_e=>!!_e.basenames);if(H.length<2)return ee;const J=H.reduce((_e,ve)=>{const M=ve.basenames;return M?_e.concat(M):_e},[]);let j;if(se){j=[];for(let _e=0,ve=J.length;_e<ve;_e++)j.push(se)}else j=H.reduce((_e,ve)=>{const M=ve.patterns;return M?_e.concat(M):_e},[]);const ae=function(_e,ve){if(typeof _e!="string")return null;if(!ve){let X;for(X=_e.length;X>0;X--){const fe=_e.charCodeAt(X-1);if(fe===47||fe===92)break}ve=_e.substr(X)}const M=J.indexOf(ve);return M!==-1?j[M]:null};ae.basenames=J,ae.patterns=j,ae.allBasenames=J;const we=ee.filter(_e=>!_e.basenames);return we.push(ae),we}function W(ee,se){return(0,c.equals)(ee,se,(H,J)=>typeof H=="string"&&typeof J=="string"?H===J:typeof H!="string"&&typeof J!="string"?H.base===J.base&&H.pattern===J.pattern:!1)}e.patternsEquals=W}),define(ye[118],Ce([1,0,8,168,24,11,2]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class _{constructor(h="",d=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(h,d=0){return this.value+=m(this.supportThemeIcons?(0,A.escapeIcons)(h):h).replace(/([ \t]+)/g,(w,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(h,d,w){return this.value+="[",this.value+=this._escape(d,"]"),this.value+="](",this.value+=this._escape(String(h),")"),w&&(this.value+=` "${this._escape(this._escape(w,'"'),")")}"`),this.value+=")",this}_escape(h,d){const w=new RegExp((0,L.escapeRegExpCharacters)(d),"g");return h.replace(w,(E,p)=>h.charAt(p-1)!=="\\"?`\\${E}`:E)}}e.MarkdownString=_;function g(n){return T(n)?!n.value:Array.isArray(n)?n.every(g):!0}e.isEmptyMarkdownString=g;function T(n){return n instanceof _?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function k(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons&&n.supportHtml===h.supportHtml&&(n.baseUri===h.baseUri||!!n.baseUri&&!!h.baseUri&&(0,l.isEqual)(R.URI.from(n.baseUri),R.URI.from(h.baseUri)))}e.markdownStringEqual=k;function m(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function D(n){return n.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function S(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=S;function v(n){const h=[],d=n.split("|").map(E=>E.trim());n=d[0];const w=d[1];if(w){const E=/height=(\d+)/.exec(w),p=/width=(\d+)/.exec(w),t=E?E[1]:"",a=p?p[1]:"",r=isFinite(parseInt(a)),s=isFinite(parseInt(t));r&&h.push(`width="${a}"`),s&&h.push(`height="${t}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=v}),define(ye[119],Ce([1,0,19,30,10,9,24,11]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function _(s,f){const{os:b,tildify:u,relative:C}=f;if(C){const i=g(s,C,b);if(typeof i=="string")return i}let y=s.fsPath;if(b===1&&!L.isWindows?y=y.replace(/\//g,"\\"):b!==1&&L.isWindows&&(y=y.replace(/\\/g,"/")),b!==1&&u?.userHome){const i=u.userHome.fsPath;let I;s.scheme!==u.userHome.scheme&&s.path.startsWith(l.posix.sep)?I=u.userHome.with({path:s.path}).fsPath:I=s.fsPath,y=m(I,i,b)}return(b===1?l.win32:l.posix).normalize(T(y,b===1))}e.getPathLabel=_;function g(s,f,b){const u=b===1?l.win32:l.posix,C=b===3?R.extUri:R.extUriIgnorePathCase,y=f.getWorkspace(),o=(0,c.firstOrDefault)(y.folders);if(!o)return;s.scheme!==o.uri.scheme&&s.path.startsWith(l.posix.sep)&&(s=o.uri.with({path:s.path}));const i=f.getWorkspaceFolder(s);if(!i)return;let I;if(C.isEqual(i.uri,s)?I="":I=C.relativePath(i.uri,s)??"",I&&(I=u.normalize(I)),y.folders.length>1&&!f.noPrefix){const F=i.name?i.name:C.basenameOrAuthority(i.uri);I=I?`${F} \u2022 ${I}`:F}return I}function T(s,f=L.isWindows){return(0,A.hasDriveLetter)(s,f)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=T;let k=Object.create(null);function m(s,f,b=L.OS){if(b===1||!s||!f)return s;let u=k.original===f?k.normalized:void 0;u||(u=f,L.isWindows&&(u=(0,A.toSlashes)(u)),u=`${(0,P.rtrim)(u,l.posix.sep)}${l.posix.sep}`,k={original:f,normalized:u});let C=s;return L.isWindows&&(C=(0,A.toSlashes)(C)),(b===3?C.startsWith(u):(0,P.startsWithIgnoreCase)(C,u))?`~/${C.substr(u.length)}`:s}e.tildify=m;function D(s,f){return s.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=D;const S="\u2026",v="\\\\",n="~";function h(s,f=l.sep){const b=new Array(s.length);let u=!1;for(let C=0;C<s.length;C++){const y=s[C];if(y===""){b[C]=`.${f}`;continue}if(!y){b[C]=y;continue}u=!0;let o="",i=y;i.indexOf(v)===0?(o=i.substr(0,i.indexOf(v)+v.length),i=i.substr(i.indexOf(v)+v.length)):i.indexOf(f)===0?(o=i.substr(0,i.indexOf(f)+f.length),i=i.substr(i.indexOf(f)+f.length)):i.indexOf(n)===0&&(o=i.substr(0,i.indexOf(n)+n.length),i=i.substr(i.indexOf(n)+n.length));const I=i.split(f);for(let F=1;u&&F<=I.length;F++)for(let U=I.length-F;u&&U>=0;U--){u=!1;let $=I.slice(U,U+F).join(f);for(let B=0;!u&&B<s.length;B++)if(B!==C&&s[B]&&s[B].indexOf($)>-1){const N=U+F===I.length,V=U>0&&s[B].indexOf(f)>-1?f+$:$,x=s[B].endsWith(V);u=!N||x}if(!u){let B="";(I[0].endsWith(":")||o!=="")&&(U===1&&(U=0,F++,$=I[0]+f+$),U>0&&(B=I[0]+f),B=o+B),U>0&&(B=B+S+f),B=B+$,U+F<I.length&&(B=B+f+S),b[C]=B}}u&&(b[C]=y)}return b}e.shorten=h;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function w(s,f=Object.create(null)){const b=[];let u=!1,C="";for(const y of s)if(y==="$"||u&&y==="{")C&&b.push({value:C,type:d.TEXT}),C="",u=!0;else if(y==="}"&&u){const o=f[C];if(typeof o=="string")o.length&&b.push({value:o,type:d.VARIABLE});else if(o){const i=b[b.length-1];(!i||i.type!==d.SEPARATOR)&&b.push({value:o.label,type:d.SEPARATOR})}C="",u=!1}else C+=y;return C&&!u&&b.push({value:C,type:d.TEXT}),b.filter((y,o)=>{if(y.type===d.SEPARATOR){const i=b[o-1],I=b[o+1];return[i,I].every(F=>F&&(F.type===d.VARIABLE||F.type===d.TEXT)&&F.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=w;function E(s,f){return L.isMacintosh||f?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):s.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function p(s,f){return L.isMacintosh||f?s.replace(/\(&&\w\)|&&/g,""):L.isWindows?s.replace(/&&|&/g,b=>b==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(s){if(s.endsWith("]")){const f=s.lastIndexOf(" [",s.length-2);if(f!==-1){const b=r(s.substring(0,f));return{name:b.name,parentPath:b.parentPath+s.substring(f)}}}return r(s)}e.splitRecentLabel=a;function r(s){const f=s.indexOf("/")!==-1?l.posix:l.win32,b=f.basename(s),u=f.dirname(s);return b.length?{name:b,parentPath:u}:{name:u,parentPath:""}}}),define(ye[120],Ce([1,0,21,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(k){return k.toJSON()}class L{constructor(m){this._uriTransformer=m}transformIncoming(m){const D=this._uriTransformer.transformIncoming(m);return D===m?m:l(A.URI.from(D))}transformOutgoing(m){const D=this._uriTransformer.transformOutgoing(m);return D===m?m:l(A.URI.from(D))}transformOutgoingURI(m){const D=this._uriTransformer.transformOutgoing(m);return D===m?m:A.URI.from(D)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,m,D){if(!k||D>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return m.transformOutgoing(k);for(const S in k)if(Object.hasOwnProperty.call(k,S)){const v=R(k[S],m,D+1);v!==null&&(k[S]=v)}}return null}function P(k,m){const D=R(k,m,0);return D===null?k:D}e.transformOutgoingURIs=P;function _(k,m,D,S){if(!k||S>200)return null;if(typeof k=="object"){if(k.$mid===1)return D?A.URI.revive(m.transformIncoming(k)):m.transformIncoming(k);if(k instanceof c.VSBuffer)return null;for(const v in k)if(Object.hasOwnProperty.call(k,v)){const n=_(k[v],m,D,S+1);n!==null&&(k[v]=n)}}return null}function g(k,m){const D=_(k,m,!1,0);return D===null?k:D}e.transformIncomingURIs=g;function T(k,m){const D=_(k,m,!0,0);return D===null?k:D}e.transformAndReviveIncomingURIs=T}),define(ye[29],Ce([1,0,48,74,345,16,30,69,10,9,24,2]),function(re,e,c,A,l,L,R,P,_,g,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function D(N,V=m.UNLINK,x){if((0,R.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return V===m.UNLINK?v(N):S(N,x)}async function S(N,V=(0,R.randomPath)((0,A.tmpdir)())){try{try{await c.promises.rename(N,V)}catch(x){return x.code==="ENOENT"?void 0:v(N)}v(V).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function v(N){return(0,l.promisify)(c.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function n(N){if((0,R.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=n;async function h(N,V){return E(await(V?d(N):(0,l.promisify)(c.readdir)(N)))}async function d(N){try{return await(0,l.promisify)(c.readdir)(N,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const V=[],x=await h(N);for(const W of x){let ee=!1,se=!1,H=!1;try{const J=await e.Promises.lstat((0,_.join)(N,W));ee=J.isFile(),se=J.isDirectory(),H=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}V.push({name:W,isFile:()=>ee,isDirectory:()=>se,isSymbolicLink:()=>H})}return V}function w(N){return E(c.readdirSync(N))}e.readdirSync=w;function E(N){return N.map(V=>typeof V=="string"?g.isMacintosh?(0,P.normalizeNFC)(V):V:(V.name=g.isMacintosh?(0,P.normalizeNFC)(V.name):V.name,V))}async function p(N){const V=await h(N),x=[];for(const W of V)await a.existsDirectory((0,_.join)(N,W))&&x.push(W);return x}function t(N,V=1e3){return new Promise(x=>{let W=!1;const ee=setInterval(()=>{W||(W=!0,c.access(N,se=>{W=!1,se&&(clearInterval(ee),x(void 0))}))},V)})}e.whenDeleted=t;var a;(function(N){async function V(ee){let se;try{if(se=await e.Promises.lstat(ee),!se.isSymbolicLink())return{stat:se}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:se?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&se)return{stat:se,symbolicLink:{dangling:!0}};if(g.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&se)return{stat:se,symbolicLink:{dangling:!0}};throw J}throw H}}N.stat=V;async function x(ee){try{const{stat:se,symbolicLink:H}=await N.stat(ee);return se.isFile()&&H?.dangling!==!0}catch{}return!1}N.existsFile=x;async function W(ee){try{const{stat:se,symbolicLink:H}=await N.stat(ee);return se.isDirectory()&&H?.dangling!==!0}catch{}return!1}N.existsDirectory=W})(a||(e.SymlinkSupport=a={}));const r=new L.ResourceQueue;function s(N,V,x){return r.queueFor(k.URI.file(N),T.extUriBiasedIgnorePathCase).queue(()=>{const W=y(x);return new Promise((ee,se)=>u(N,V,W,H=>H?se(H):ee()))})}let f=!0;function b(N){f=N}e.configureFlushOnWrite=b;function u(N,V,x,W){if(!f)return c.writeFile(N,V,{mode:x.mode,flag:x.flag},W);c.open(N,x.flag,x.mode,(ee,se)=>{if(ee)return W(ee);c.writeFile(se,V,H=>{if(H)return c.close(se,()=>W(H));c.fdatasync(se,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),b(!1)),c.close(se,j=>W(j))))})})}function C(N,V,x){const W=y(x);if(!f)return c.writeFileSync(N,V,{mode:W.mode,flag:W.flag});const ee=c.openSync(N,W.flag,W.mode);try{c.writeFileSync(ee,V);try{c.fdatasyncSync(ee)}catch(se){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",se),b(!1)}}finally{c.closeSync(ee)}}e.writeFileSync=C;function y(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function o(N,V){if(N!==V)try{await e.Promises.rename(N,V)}catch(x){if(N.toLowerCase()!==V.toLowerCase()&&x.code==="EXDEV"||N.endsWith("."))await i(N,V,{preserveSymlinks:!1}),await D(N,m.MOVE);else throw x}}async function i(N,V,x){return F(N,V,{root:{source:N,target:V},options:x,handledSourcePaths:new Set})}const I=511;async function F(N,V,x){if(x.handledSourcePaths.has(N))return;x.handledSourcePaths.add(N);const{stat:W,symbolicLink:ee}=await a.stat(N);if(ee){if(x.options.preserveSymlinks)try{return await B(N,V,x)}catch(se){console.warn("[node.js fs] copy of symlink failed: ",se)}if(ee.dangling)return}return W.isDirectory()?U(N,V,W.mode&I,x):$(N,V,W.mode&I)}async function U(N,V,x,W){await e.Promises.mkdir(V,{recursive:!0,mode:x});const ee=await h(N);for(const se of ee)await F((0,_.join)(N,se),(0,_.join)(V,se),W)}async function $(N,V,x){await e.Promises.copyFile(N,V),await e.Promises.chmod(V,x)}async function B(N,V,x){let W=await e.Promises.readlink(N);(0,R.isEqualOrParent)(W,x.root.source,!g.isLinux)&&(W=(0,_.join)(x.root.target,W.substr(x.root.source.length+1))),await e.Promises.symlink(W,V)}e.Promises=new class{get access(){return(0,l.promisify)(c.access)}get stat(){return(0,l.promisify)(c.stat)}get lstat(){return(0,l.promisify)(c.lstat)}get utimes(){return(0,l.promisify)(c.utimes)}get read(){return(N,V,x,W,ee)=>new Promise((se,H)=>{c.read(N,V,x,W,ee,(J,j,ae)=>J?H(J):se({bytesRead:j,buffer:ae}))})}get readFile(){return(0,l.promisify)(c.readFile)}get write(){return(N,V,x,W,ee)=>new Promise((se,H)=>{c.write(N,V,x,W,ee,(J,j,ae)=>J?H(J):se({bytesWritten:j,buffer:ae}))})}get appendFile(){return(0,l.promisify)(c.appendFile)}get fdatasync(){return(0,l.promisify)(c.fdatasync)}get truncate(){return(0,l.promisify)(c.truncate)}get rename(){return(0,l.promisify)(c.rename)}get copyFile(){return(0,l.promisify)(c.copyFile)}get open(){return(0,l.promisify)(c.open)}get close(){return(0,l.promisify)(c.close)}get symlink(){return(0,l.promisify)(c.symlink)}get readlink(){return(0,l.promisify)(c.readlink)}get chmod(){return(0,l.promisify)(c.chmod)}get mkdir(){return(0,l.promisify)(c.mkdir)}get unlink(){return(0,l.promisify)(c.unlink)}get rmdir(){return(0,l.promisify)(c.rmdir)}get realpath(){return(0,l.promisify)(c.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return p}get writeFile(){return s}get rm(){return D}get move(){return o}get copy(){return i}}}),define(ye[94],Ce([1,0,48,10,9,11,29]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(m){if(l.isLinux)return m;const D=(0,A.dirname)(m);if(m===D)return m;const S=((0,A.basename)(m)||m).toLowerCase();try{const n=(0,R.readdirSync)(D).filter(h=>h.toLowerCase()===S);if(n.length===1){const h=P(D);if(h)return(0,A.join)(h,n[0])}else if(n.length>1){const h=n.indexOf(S);if(h>=0){const d=P(D);if(d)return(0,A.join)(d,n[h])}}}catch{}return null}e.realcaseSync=P;async function _(m){if(l.isLinux)return m;const D=(0,A.dirname)(m);if(m===D)return m;const S=((0,A.basename)(m)||m).toLowerCase();try{const n=(await R.Promises.readdir(D)).filter(h=>h.toLowerCase()===S);if(n.length===1){const h=await _(D);if(h)return(0,A.join)(h,n[0])}else if(n.length>1){const h=n.indexOf(S);if(h>=0){const d=await _(D);if(d)return(0,A.join)(d,n[h])}}}catch{}return null}e.realcase=_;async function g(m){try{return await R.Promises.realpath(m)}catch{const S=k(m);return await R.Promises.access(S,c.constants.R_OK),S}}e.realpath=g;function T(m){try{return c.realpathSync(m)}catch{const S=k(m);return c.accessSync(S,c.constants.R_OK),S}}e.realpathSync=T;function k(m){return(0,L.rtrim)((0,A.normalize)(m),A.sep)}}),define(ye[95],Ce([1,0,10,9,39,93,12,29]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function _(k=l.env){return k.comspec||"cmd.exe"}e.getWindowsShell=_;function g(k){let m=[],D=!1;const S=function(v){if(D){m.push(v);return}(!k.send(v,h=>{if(h&&console.error(h),D=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(w=>S(w))}})||A.isWindows)&&(D=!0)};return{send:S}}e.createQueuedSender=g;var T;(function(k){async function m(D,S,v){if(c.isAbsolute(D))return D;if(S===void 0&&(S=l.cwd()),c.dirname(D)!=="."||(v===void 0&&R.isString(l.env.PATH)&&(v=l.env.PATH.split(c.delimiter)),v===void 0||v.length===0))return c.join(S,D);async function h(d){if(await P.Promises.exists(d)){let w;try{w=await P.Promises.stat(d)}catch(E){E.message.startsWith("EACCES")&&(w=await P.Promises.lstat(d))}return w?!w.isDirectory():!1}return!1}for(const d of v){let w;if(c.isAbsolute(d)?w=c.join(d,D):w=c.join(S,d,D),await h(w))return w;let E=w+".com";if(await h(E)||(E=w+".exe",await h(E)))return E}return c.join(S,D)}k.findExecutable=m})(T||(e.win32=T={}))});var je=this&&this.__decorate||function(re,e,c,A){var l=arguments.length,L=l<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,c):A,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(re,e,c,A);else for(var P=re.length-1;P>=0;P--)(R=re[P])&&(L=(l<3?R(L):l>3?R(e,c,L):R(e,c))||L);return l>3&&L&&Object.defineProperty(e,c,L),L};define(ye[75],Ce([1,0,19,16,21,22,66,8,3,4,73,11,12]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(D||(D={}));function S(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(v||(v={}));function n(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(h||(h={}));function d(se){let H=0;for(let J=0;;J+=7){const j=se.read(1);if(H|=(j.buffer[0]&127)<<J,!(j.buffer[0]&128))return H}}const w=r(0);function E(se,H){if(H===0){se.write(w);return}let J=0;for(let ae=H;ae!==0;ae=ae>>>7)J++;const j=l.VSBuffer.alloc(J);for(let ae=0;H!==0;ae++)j.buffer[ae]=H&127,H=H>>>7,H>0&&(j.buffer[ae]|=128);se.write(j)}class p{constructor(H){this.buffer=H,this.pos=0}read(H){const J=this.buffer.slice(this.pos,this.pos+H);return this.pos+=J.byteLength,J}}e.BufferReader=p;class t{constructor(){this.buffers=[]}get buffer(){return l.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}e.BufferWriter=t;var a;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(a||(a={}));function r(se){const H=l.VSBuffer.alloc(1);return H.writeUInt8(se,0),H}const s={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object),Uint:r(a.Int)},f=typeof Buffer<"u";function b(se,H){if(typeof H>"u")se.write(s.Undefined);else if(typeof H=="string"){const J=l.VSBuffer.fromString(H);se.write(s.String),E(se,J.byteLength),se.write(J)}else if(f&&Buffer.isBuffer(H)){const J=l.VSBuffer.wrap(H);se.write(s.Buffer),E(se,J.byteLength),se.write(J)}else if(H instanceof l.VSBuffer)se.write(s.VSBuffer),E(se,H.byteLength),se.write(H);else if(Array.isArray(H)){se.write(s.Array),E(se,H.length);for(const J of H)b(se,J)}else if(typeof H=="number"&&(H|0)===H)se.write(s.Uint),E(se,H);else{const J=l.VSBuffer.fromString(JSON.stringify(H));se.write(s.Object),E(se,J.byteLength),se.write(J)}}e.serialize=b;function u(se){switch(se.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return se.read(d(se)).toString();case a.Buffer:return se.read(d(se)).buffer;case a.VSBuffer:return se.read(d(se));case a.Array:{const J=d(se),j=[];for(let ae=0;ae<J;ae++)j.push(u(se));return j}case a.Object:return JSON.parse(se.read(d(se)).toString());case a.Int:return d(se)}}e.deserialize=u;class C{constructor(H,J,j=null,ae=1e3){this.protocol=H,this.ctx=J,this.logger=j,this.timeoutDelay=ae,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(we=>this.onRawMessage(we)),this.sendResponse({type:200})}registerChannel(H,J){this.channels.set(H,J),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const J=this.send([H.type]);this.logger?.logOutgoing(J,0,1,n(H.type));return}case 201:case 202:case 204:case 203:{const J=this.send([H.type,H.id],H.data);this.logger?.logOutgoing(J,H.id,1,n(H.type),H.data);return}}}send(H,J=void 0){const j=new t;return b(j,H),b(j,J),this.sendBuffer(j.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const J=new p(H),j=u(J),ae=u(J),we=j[0];switch(we){case 100:return this.logger?.logIncoming(H.byteLength,j[1],1,`${S(we)}: ${j[2]}.${j[3]}`,ae),this.onPromise({type:we,id:j[1],channelName:j[2],name:j[3],arg:ae});case 102:return this.logger?.logIncoming(H.byteLength,j[1],1,`${S(we)}: ${j[2]}.${j[3]}`,ae),this.onEventListen({type:we,id:j[1],channelName:j[2],name:j[3],arg:ae});case 101:return this.logger?.logIncoming(H.byteLength,j[1],1,`${S(we)}`),this.disposeActiveRequest({type:we,id:j[1]});case 103:return this.logger?.logIncoming(H.byteLength,j[1],1,`${S(we)}`),this.disposeActiveRequest({type:we,id:j[1]})}}onPromise(H){const J=this.channels.get(H.channelName);if(!J){this.collectPendingRequest(H);return}const j=new L.CancellationTokenSource;let ae;try{ae=J.call(this.ctx,H.name,H.arg,j.token)}catch(ve){ae=Promise.reject(ve)}const we=H.id;ae.then(ve=>{this.sendResponse({id:we,data:ve,type:201}),this.activeRequests.delete(H.id)},ve=>{ve instanceof Error?this.sendResponse({id:we,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.sendResponse({id:we,data:ve,type:203}),this.activeRequests.delete(H.id)});const _e=(0,g.toDisposable)(()=>j.cancel());this.activeRequests.set(H.id,_e)}onEventListen(H){const J=this.channels.get(H.channelName);if(!J){this.collectPendingRequest(H);return}const j=H.id,we=J.listen(this.ctx,H.name,H.arg)(_e=>this.sendResponse({id:j,data:_e,type:204}));this.activeRequests.set(H.id,we)}disposeActiveRequest(H){const J=this.activeRequests.get(H.id);J&&(J.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let J=this.pendingRequests.get(H.channelName);J||(J=[],this.pendingRequests.set(H.channelName,J));const j=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:H,timeoutTimer:j})}flushPendingRequests(H){const J=this.pendingRequests.get(H);if(J){for(const j of J)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var y;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class o{constructor(H,J=null){this.protocol=H,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=J}getChannel(H){const J=this;return{call(j,ae,we){return J.isDisposed?Promise.reject(new P.CancellationError):J.requestPromise(H,j,ae,we)},listen(j,ae){return J.isDisposed?_.Event.None:J.requestEvent(H,j,ae)}}}requestPromise(H,J,j,ae=L.CancellationToken.None){const we=this.lastRequestId++,ve={id:we,type:100,channelName:H,name:J,arg:j};if(ae.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((fe,Ee)=>{if(ae.isCancellationRequested)return Ee(new P.CancellationError);const Z=()=>{const de=oe=>{switch(oe.type){case 201:this.handlers.delete(we),fe(oe.data);break;case 202:{this.handlers.delete(we);const ue=new Error(oe.data.message);ue.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,ue.name=oe.data.name,Ee(ue);break}case 203:this.handlers.delete(we),Ee(oe.data);break}};this.handlers.set(we,de),this.sendRequest(ve)};let ne=null;this.state===h.Idle?Z():(ne=(0,A.createCancelablePromise)(de=>this.whenInitialized()),ne.then(()=>{ne=null,Z()}));const le=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:we,type:101}),Ee(new P.CancellationError)},te=ae.onCancellationRequested(le);M=(0,g.combinedDisposable)((0,g.toDisposable)(le),te),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(H,J,j){const ae=this.lastRequestId++,_e={id:ae,type:102,channelName:H,name:J,arg:j};let ve=null;const M=new _.Emitter({onWillAddFirstListener:()=>{ve=(0,A.createCancelablePromise)(fe=>this.whenInitialized()),ve.then(()=>{ve=null,this.activeRequests.add(M),this.sendRequest(_e)})},onDidRemoveLastListener:()=>{ve?(ve.cancel(),ve=null):(this.activeRequests.delete(M),this.sendRequest({id:ae,type:103}))}}),X=fe=>M.fire(fe.data);return this.handlers.set(ae,X),M.event}sendRequest(H){switch(H.type){case 100:case 102:{const J=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger?.logOutgoing(J,H.id,0,`${S(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const J=this.send([H.type,H.id]);this.logger?.logOutgoing(J,H.id,0,S(H.type));return}}}send(H,J=void 0){const j=new t;return b(j,H),b(j,J),this.sendBuffer(j.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const J=new p(H),j=u(J),ae=u(J),we=j[0];switch(we){case 200:return this.logger?.logIncoming(H.byteLength,0,0,n(we)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(H.byteLength,j[1],0,n(we),ae),this.onResponse({type:j[0],id:j[1],data:ae})}}onResponse(H){if(H.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(H.id)?.(H)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=o,je([R.memoize],o.prototype,"onDidInitializePromise",null);class i{get connections(){const H=[];return this._connections.forEach(J=>H.push(J)),H}constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:J,onDidClientDisconnect:j})=>{_.Event.once(J.onMessage)(we=>{const _e=new p(we),ve=u(_e),M=new C(J,ve),X=new o(J);this.channels.forEach((Ee,Z)=>M.registerChannel(Z,Ee));const fe={channelServer:M,channelClient:X,ctx:ve};this._connections.add(fe),this._onDidAddConnection.fire(fe),j(()=>{M.dispose(),X.dispose(),this._connections.delete(fe),this._onDidRemoveConnection.fire(fe)})})})}getChannel(H,J){const j=this;return{call(ae,we,_e){let ve;if((0,m.isFunction)(J)){const X=(0,c.getRandomElement)(j.connections.filter(J));ve=X?Promise.resolve(X):_.Event.toPromise(_.Event.filter(j.onDidAddConnection,J))}else ve=J.routeCall(j,ae,we);const M=ve.then(X=>X.channelClient.getChannel(H));return F(M).call(ae,we,_e)},listen(ae,we){if((0,m.isFunction)(J))return j.getMulticastEvent(H,J,ae,we);const _e=J.routeEvent(j,ae,we).then(ve=>ve.channelClient.getChannel(H));return F(_e).listen(ae,we)}}}getMulticastEvent(H,J,j,ae){const we=this;let _e=new g.DisposableStore;const ve=new _.Emitter({onWillAddFirstListener:()=>{_e=new g.DisposableStore;const M=new _.EventMultiplexer,X=new Map,fe=Z=>{const le=Z.channelClient.getChannel(H).listen(j,ae),te=M.add(le);X.set(Z,te)},Ee=Z=>{const ne=X.get(Z);ne&&(ne.dispose(),X.delete(Z))};we.connections.filter(J).forEach(fe),_.Event.filter(we.onDidAddConnection,J)(fe,void 0,_e),we.onDidRemoveConnection(Ee,void 0,_e),M.event(ve.fire,ve,_e),_e.add(M)},onDidRemoveLastListener:()=>{_e.dispose()}});return ve.event}registerChannel(H,J){this.channels.set(H,J),this._connections.forEach(j=>{j.channelServer.registerChannel(H,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=i;class I{constructor(H,J,j=null){const ae=new t;b(ae,J),H.send(ae.buffer),this.channelClient=new o(H,j),this.channelServer=new C(H,J,j)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,J){this.channelServer.registerChannel(H,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=I;function F(se){return{call(H,J,j){return se.then(ae=>ae.call(H,J,j))},listen(H,J){const j=new _.Relay;return se.then(ae=>j.input=ae.listen(H,J)),j.event}}}e.getDelayedChannel=F;function U(se){let H=!1;return{call(J,j,ae){return H?se.call(J,j,ae):(0,A.timeout)(0).then(()=>H=!0).then(()=>se.call(J,j,ae))},listen(J,j){if(H)return se.listen(J,j);const ae=new _.Relay;return(0,A.timeout)(0).then(()=>H=!0).then(()=>ae.input=se.listen(J,j)),ae.event}}}e.getNextTickChannel=U;class ${constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const J of H.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await _.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=$;var B;(function(se){function H(we,_e){const ve=we,M=_e&&_e.disableMarshalling,X=new Map;for(const fe in ve)j(fe)&&X.set(fe,_.Event.buffer(ve[fe],!0));return new class{listen(fe,Ee,Z){const ne=X.get(Ee);if(ne)return ne;if(ae(Ee)){const le=ve[Ee];if(typeof le=="function")return le.call(ve,Z)}throw new Error(`Event not found: ${Ee}`)}call(fe,Ee,Z){const ne=ve[Ee];if(typeof ne=="function"){if(!M&&Array.isArray(Z))for(let le=0;le<Z.length;le++)Z[le]=(0,T.revive)(Z[le]);return ne.apply(ve,Z)}throw new Error(`Method not found: ${Ee}`)}}}se.fromService=H;function J(we,_e){const ve=_e&&_e.disableMarshalling;return new Proxy({},{get(M,X){if(typeof X=="string")return _e?.properties?.has(X)?_e.properties.get(X):ae(X)?function(fe){return we.listen(X,fe)}:j(X)?we.listen(X):async function(...fe){let Ee;_e&&!(0,m.isUndefinedOrNull)(_e.context)?Ee=[_e.context,...fe]:Ee=fe;const Z=await we.call(X,Ee);return ve?Z:(0,T.revive)(Z)};throw new Error(`Property not found: ${String(X)}`)}})}se.toService=J;function j(we){return we[0]==="o"&&we[1]==="n"&&k.isUpperAsciiLetter(we.charCodeAt(2))}function ae(we){return/^onDynamic/.test(we)&&k.isUpperAsciiLetter(we.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const H=se.toString();if(H!=="[object Object]")return H}return se}function x(se){return Array.isArray(se)?se.map(V):V(se)}function W(se,H,J,j,ae,we,_e){_e=x(_e);const ve=N[ae],M=ve[j%ve.length];let X=[`%c[${se}]%c[${String(H).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(we)?(X=X.concat(_e),X.push(")")):X.push(_e),console.log.apply(console,X)}class ee{constructor(H,J){this._outgoingPrefix=H,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,J,j,ae,we){this._totalOutgoing+=H,W(this._outgoingPrefix,this._totalOutgoing,H,J,j,ae,we)}logIncoming(H,J,j,ae,we){this._totalIncoming+=H,W(this._incomingPrefix,this._totalIncoming,H,J,j,ae,we)}}e.IPCLogger=ee}),define(ye[121],Ce([1,0,16,21,3,4,75]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var _;(function(o){o.enableDiagnostics=!1,o.records=[];const i=new WeakMap;let I=0;function F($,B){if(!i.has($)){const N=String(++I);i.set($,N)}return i.get($)}function U($,B,N,V){if(!o.enableDiagnostics)return;const x=F($,B);if(V instanceof A.VSBuffer||V instanceof Uint8Array||V instanceof ArrayBuffer||ArrayBuffer.isView(V)){const W=A.VSBuffer.alloc(V.byteLength);W.set(V),o.records.push({timestamp:Date.now(),id:x,label:B,type:N,buff:W})}else o.records.push({timestamp:Date.now(),id:x,label:B,type:N,data:V})}o.traceSocketEvent=U})(_||(e.SocketDiagnostics=_={}));var g;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g||(e.SocketCloseEventType=g={}));let T=null;function k(){return T||(T=A.VSBuffer.alloc(0)),T}class m{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,I){if(i===0)return k();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const B=this._chunks[0];return I&&(this._chunks.shift(),this._totalLength-=i),B}if(this._chunks[0].byteLength>i){const B=this._chunks[0].slice(0,i);return I&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),B}const F=A.VSBuffer.alloc(i);let U=0,$=0;for(;i>0;){const B=this._chunks[$];if(B.byteLength>i){const N=B.slice(0,i);F.set(N,U),U+=i,I&&(this._chunks[$]=B.slice(i),this._totalLength-=i),i-=i}else F.set(B,U),U+=B.byteLength,I?(this._chunks.shift(),this._totalLength-=B.byteLength):$++,i-=B.byteLength}return F}}e.ChunkStream=m;var D;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive",o[o.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",o[o.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(D||(D={}));function S(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",o[o.KeepAliveSendTime=5e3]="KeepAliveSendTime",o[o.LatencySampleTime=6e4]="LatencySampleTime",o[o.LatencySampleCount=5]="LatencySampleCount",o[o.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",o[o.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v||(e.ProtocolConstants=v={}));class n{constructor(i,I,F,U){this.type=i,this.id=I,this.ack=F,this.data=U,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends L.Disposable{constructor(i){super(),this._onMessage=this._register(new l.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new m,this._register(this._socket.onData(I=>this.acceptChunk(I))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const I=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=I.readUInt32BE(9),this._state.messageType=I.readUInt8(0),this._state.id=I.readUInt32BE(1),this._state.ack=I.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const F=this._state.messageType,U=this._state.id,$=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",I),this._onMessage.fire(new n(F,U,$,I)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const I=A.VSBuffer.alloc(13);I.writeUInt8(i.type,0),I.writeUInt32BE(i.id,1),I.writeUInt32BE(i.ack,5),I.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(I,i.data)}_bufferAdd(i,I){const F=this._totalLength===0;return this._data.push(i,I),this._totalLength+=i.byteLength+I.byteLength,F}_bufferTake(){const i=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,I){this._bufferAdd(i,I)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class w extends L.Disposable{constructor(i){super(),this._onMessage=new l.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(I=>{I.type===1&&this._onMessage.fire(I.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new n(1,0,0,i))}}e.Protocol=w;class E extends R.IPCClient{static fromSocket(i,I){return new E(new w(i),I)}get onDidDispose(){return this.protocol.onDidDispose}constructor(i,I,F=null){super(i,I,F),this.protocol=i}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new l.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class t{constructor(i){this.data=i,this.next=null}}class a{constructor(){this._first=null,this._last=null}length(){let i=0,I=this._first;for(;I;)I=I.next,i++;return i}peek(){return this._first?this._first.data:null}toArray(){const i=[];let I=0,F=this._first;for(;F;)i[I++]=F.data,F=F.next;return i}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const I=new t(i);if(!this._first){this._first=I,this._last=I;return}this._last.next=I,this._last=I}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const i=Date.now();for(let I=0;I<r._HISTORY_LENGTH;I++)this.lastRuns[I]=i-1e3*I;setInterval(()=>{for(let I=r._HISTORY_LENGTH;I>=1;I--)this.lastRuns[I]=this.lastRuns[I-1];this.lastRuns[0]=Date.now()},1e3)}load(){const i=Date.now(),I=(1+r._HISTORY_LENGTH)*1e3;let F=0;for(let U=0;U<r._HISTORY_LENGTH;U++)i-this.lastRuns[U]<=I&&F++;return 1-F/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;var s;(function(o){o[o.Good=0]="Good",o[o.Poor=1]="Poor"})(s||(e.ConnectionHealth=s={}));function f(o){switch(o){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=f;class b{constructor(i){this.connectionHealth=i}}e.ConnectionHealthChangedEvent=b;class u{constructor(i,I){this.roundTripTime=i,this.recentHighRoundTripCount=I}}e.HighRoundTripTimeEvent=u;class C{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(i){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new p,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new p,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=i.loadEstimator??r.getInstance(),this._measureRoundTripTime=i.measureRoundTripTime??!1,this._shouldSendKeepAlive=i.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new L.DisposableStore,this._socket=i.socket,this._socketWriter=this._socketDisposables.add(new d(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.add(this._socket.onClose(I=>this._onSocketClose.fire(I))),this._socketLatencyMonitor=this._socketDisposables.add(new y),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(I=>this._sendLatencyMeasurementRequest(I))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(I=>this._onHighRoundTripTime.fire(I))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(I=>this._onDidChangeConnectionHealth.fire(I))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),i.initialChunk&&this._socketReader.acceptChunk(i.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new n(5,0,0,k());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new n(7,0,0,k());this._socketWriter.write(i)}sendResume(){const i=new n(8,0,0,k());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,I){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new L.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=this._socketDisposables.add(new d(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(F=>this._receiveMessage(F))),this._socketDisposables.add(this._socket.onClose(F=>this._onSocketClose.fire(F))),this._socketLatencyMonitor=this._socketDisposables.add(new y),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(F=>this._sendLatencyMeasurementRequest(F))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(F=>this._onHighRoundTripTime.fire(F))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(F=>this._onDidChangeConnectionHealth.fire(F))),this._socketReader.acceptChunk(I)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const i=new n(3,0,this._incomingAckId,k());this._socketWriter.write(i);const I=this._outgoingUnackMsg.toArray();for(let F=0,U=I.length;F<U;F++)this._socketWriter.write(I[F]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const I=this._outgoingUnackMsg.peek();if(I&&I.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const I=Date.now();I-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=I,this._socketWriter.write(new n(6,0,0,k())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const I=this._outgoingUnackMsg.toArray();for(let F=0,U=I.length;F<U;F++)this._socketWriter.write(I[F]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(i.data);break}case 11:{this._socketLatencyMonitor.handleResponse(i.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const I=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const F=new n(1,I,this._incomingAckId,i);this._outgoingUnackMsg.push(F),this._isReconnecting||(this._socketWriter.write(F),this._recvAckCheck())}sendControl(i){const I=new n(2,0,0,i);this._socketWriter.write(I)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),I=Date.now()-i.writtenTime,F=Date.now()-this._socketReader.lastReadTime,U=Date.now()-this._lastSocketTimeoutTime;if(I>=2e4&&F>=2e4&&U>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:I,timeSinceLastReceivedSomeData:F});return}const $=Math.max(2e4-I,2e4-F,2e4-U,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},$)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new n(3,0,this._incomingAckId,k());this._socketWriter.write(i)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const i=new n(9,0,this._incomingAckId,k());this._socketWriter.write(i)}_sendLatencyMeasurementRequest(i){this._incomingAckId=this._incomingMsgId;const I=new n(10,0,this._incomingAckId,i);this._socketWriter.write(I)}_sendLatencyMeasurementResponse(i){this._incomingAckId=this._incomingMsgId;const I=new n(11,0,this._incomingAckId,i);this._socketWriter.write(I)}}e.PersistentProtocol=C;class y extends L.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new l.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new l.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new l.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new c.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},i=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const i=++this._lastLatencyMeasurementId,I=A.VSBuffer.alloc(4);I.writeUInt32BE(i,0),this._onSendLatencyRequest.fire(I)},6e4)}handleResponse(i){if(i.byteLength!==4)return;const I=i.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||I!==this._lastLatencyMeasurementId)return;const F=Date.now()-this._lastLatencyMeasurementSent,U=this._latencySampleIndex++;this._latencySamples[U%this._latencySamples.length]=F;const $=this._connectionHealth,B=this._latencySamples.filter(N=>N>=1e3).length;this._connectionHealth=B>=3?1:0,F>1e3&&this._onHighRoundTripTime.fire(new u(F,B)),$!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(ye[170],Ce([1,0,46,16,21,22,169,8,3,4,23,95,93,75]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends D.ChannelServer{constructor(h){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:_.Event.fromNodeEventEmitter(process,"message",d=>l.VSBuffer.wrap(Buffer.from(d,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=S;class v{constructor(h,d){this.modulePath=h,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new _.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new A.Delayer(w),this.child=null,this._client=null}getChannel(h){const d=this;return{call(w,E,p){return d.requestPromise(h,w,E,p)},listen(w,E){return d.requestEvent(h,w,E)}}}requestPromise(h,d,w,E=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(h),t=(0,A.createCancelablePromise)(s=>p.call(d,w,s)),a=E.onCancellationRequested(()=>t.cancel()),r=(0,g.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{a.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(h,d,w){if(!this.disposeDelayer)return _.Event.None;this.disposeDelayer.cancel();let E;const p=new _.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(h).listen(d,w)(p.fire,p),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(f=>!/^--inspect(-brk)?=/.test(f)).filter(f=>!f.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(d.env),this.child=(0,c.fork)(this.modulePath,h,d);const w=new _.Emitter;_.Event.fromNodeEventEmitter(this.child,"message",f=>f)(f=>{if((0,R.isRemoteConsoleLog)(f)){(0,R.log)(f,`IPC Library: ${this.options.serverName}`);return}w.fire(l.VSBuffer.wrap(Buffer.from(f,"base64")))});const p=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,t=f=>this.child&&this.child.connected&&p.send(f.buffer.toString("base64")),a=w.event,r={send:t,onMessage:a};this._client=new D.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",f=>console.warn('IPC "'+this.options.serverName+'" errored with '+f)),this.child.on("exit",(f,b)=>{process.removeListener("exit",s),this.activeRequests.forEach(u=>(0,g.dispose)(u)),this.activeRequests.clear(),f!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+f+" and signal "+b),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:f,signal:b})})}return this._client}getCachedChannel(h){let d=this.channels.get(h);return d||(d=this.client.getChannel(h),this.channels.set(h,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(ye[171],Ce([1,0,33,10]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(L,R,P,_,g,T){if(Array.isArray(L)){let k=0;for(const m of L){const D=l(m,R,P,_,g,T);if(D===10)return D;D>k&&(k=D)}return k}else{if(typeof L=="string")return _?L==="*"?5:L===P?10:0:0;if(L){const{language:k,pattern:m,scheme:D,hasAccessToAllModels:S,notebookType:v}=L;if(!_&&!S)return 0;v&&g&&(R=g);let n=0;if(D)if(D===R.scheme)n=10;else if(D==="*")n=5;else return 0;if(k)if(k===P)n=10;else if(k==="*")n=Math.max(n,5);else return 0;if(v)if(v===T)n=10;else if(v==="*"&&T!==void 0)n=Math.max(n,5);else return 0;if(m){let h;if(typeof m=="string"?h=m:h={...m,base:(0,A.normalize)(m.base)},h===R.fsPath||(0,c.match)(h,R.fsPath))n=10;else return 0}return n}else return 0}}e.score=l}),define(ye[172],Ce([1,0,11,56,159]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class L{constructor(P,_,g,T){this._uri=P,this._lines=_,this._eol=g,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const _=P.changes;for(const g of _)this._acceptDeleteRange(g.range),this._acceptInsertText(new A.Position(g.range.startLineNumber,g.range.startColumn),g.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,_=this._lines.length,g=new Uint32Array(_);for(let T=0;T<_;T++)g[T]=this._lines[T].length+P;this._lineStarts=new l.PrefixSumComputer(g)}}_setLineText(P,_){this._lines[P]=_,this._lineStarts&&this._lineStarts.setValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,_){if(_.length===0)return;const g=(0,c.splitLines)(_);if(g.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+g[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}g[g.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+g[0]);const T=new Uint32Array(g.length-1);for(let k=1;k<g.length;k++)this._lines.splice(P.lineNumber+k-1,0,g[k]),T[k-1]=g[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,T)}}e.MirrorTextModel=L}),define(ye[173],Ce([1,0,11,156,56,35,114]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class _{constructor(d,w,E,p){this.searchString=d,this.isRegex=w,this.matchCase=E,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=g(this.searchString):d=this.searchString.indexOf(`
`)>=0;let w=null;try{w=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch{return null}if(!w)return null;let E=!this.isRegex&&!d;return E&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(E=this.matchCase),new R.SearchData(w,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,E?this.searchString:null)}}e.SearchParams=_;function g(h){if(!h||h.length===0)return!1;for(let d=0,w=h.length;d<w;d++){const E=h.charCodeAt(d);if(E===10)return!0;if(E===92){if(d++,d>=w)break;const p=h.charCodeAt(d);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=g;function T(h,d,w){if(!w)return new R.FindMatch(h,null);const E=[];for(let p=0,t=d.length;p<t;p++)E[p]=d[p];return new R.FindMatch(h,E)}e.createFindMatch=T;class k{constructor(d){const w=[];let E=0;for(let p=0,t=d.length;p<t;p++)d.charCodeAt(p)===10&&(w[E++]=p);this._lineFeedsOffsets=w}findLineFeedCountBeforeOffset(d){const w=this._lineFeedsOffsets;let E=0,p=w.length-1;if(p===-1||d<=w[0])return 0;for(;E<p;){const t=E+((p-E)/2>>0);w[t]>=d?p=t-1:w[t+1]>=d?(E=t,p=t):E=t+1}return E+1}}class m{static findMatches(d,w,E,p,t){const a=w.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(d,E,new n(a.wordSeparators,a.regex),p,t):this._doFindMatchesLineByLine(d,E,a,p,t):[]}static _getMultilineMatchRange(d,w,E,p,t,a){let r,s=0;p?(s=p.findLineFeedCountBeforeOffset(t),r=w+t+s):r=w+t;let f;if(p){const y=p.findLineFeedCountBeforeOffset(t+a.length)-s;f=r+a.length+y}else f=r+a.length;const b=d.getPositionAt(r),u=d.getPositionAt(f);return new L.Range(b.lineNumber,b.column,u.lineNumber,u.column)}static _doFindMatchesMultiline(d,w,E,p,t){const a=d.getOffsetAt(w.getStartPosition()),r=d.getValueInRange(w,1),s=d.getEOL()===`\r
`?new k(r):null,f=[];let b=0,u;for(E.reset(0);u=E.next(r);)if(f[b++]=T(this._getMultilineMatchRange(d,a,r,s,u.index,u[0]),u,p),b>=t)return f;return f}static _doFindMatchesLineByLine(d,w,E,p,t){const a=[];let r=0;if(w.startLineNumber===w.endLineNumber){const f=d.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return r=this._findMatchesInLine(E,f,w.startLineNumber,w.startColumn-1,r,a,p,t),a}const s=d.getLineContent(w.startLineNumber).substring(w.startColumn-1);r=this._findMatchesInLine(E,s,w.startLineNumber,w.startColumn-1,r,a,p,t);for(let f=w.startLineNumber+1;f<w.endLineNumber&&r<t;f++)r=this._findMatchesInLine(E,d.getLineContent(f),f,0,r,a,p,t);if(r<t){const f=d.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);r=this._findMatchesInLine(E,f,w.endLineNumber,0,r,a,p,t)}return a}static _findMatchesInLine(d,w,E,p,t,a,r,s){const f=d.wordSeparators;if(!r&&d.simpleSearch){const C=d.simpleSearch,y=C.length,o=w.length;let i=-y;for(;(i=w.indexOf(C,i+y))!==-1;)if((!f||v(f,w,o,i,y))&&(a[t++]=new R.FindMatch(new L.Range(E,i+1+p,E,i+1+y+p),null),t>=s))return t;return t}const b=new n(d.wordSeparators,d.regex);let u;b.reset(0);do if(u=b.next(w),u&&(a[t++]=T(new L.Range(E,u.index+1+p,E,u.index+1+u[0].length+p),u,r),t>=s))return t;while(u);return t}static findNextMatch(d,w,E,p){const t=w.parseSearchRequest();if(!t)return null;const a=new n(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(d,E,a,p):this._doFindNextMatchLineByLine(d,E,a,p)}static _doFindNextMatchMultiline(d,w,E,p){const t=new l.Position(w.lineNumber,1),a=d.getOffsetAt(t),r=d.getLineCount(),s=d.getValueInRange(new L.Range(t.lineNumber,t.column,r,d.getLineMaxColumn(r)),1),f=d.getEOL()===`\r
`?new k(s):null;E.reset(w.column-1);const b=E.next(s);return b?T(this._getMultilineMatchRange(d,a,s,f,b.index,b[0]),b,p):w.lineNumber!==1||w.column!==1?this._doFindNextMatchMultiline(d,new l.Position(1,1),E,p):null}static _doFindNextMatchLineByLine(d,w,E,p){const t=d.getLineCount(),a=w.lineNumber,r=d.getLineContent(a),s=this._findFirstMatchInLine(E,r,a,w.column,p);if(s)return s;for(let f=1;f<=t;f++){const b=(a+f-1)%t,u=d.getLineContent(b+1),C=this._findFirstMatchInLine(E,u,b+1,1,p);if(C)return C}return null}static _findFirstMatchInLine(d,w,E,p,t){d.reset(p-1);const a=d.next(w);return a?T(new L.Range(E,a.index+1,E,a.index+1+a[0].length),a,t):null}static findPreviousMatch(d,w,E,p){const t=w.parseSearchRequest();if(!t)return null;const a=new n(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(d,E,a,p):this._doFindPreviousMatchLineByLine(d,E,a,p)}static _doFindPreviousMatchMultiline(d,w,E,p){const t=this._doFindMatchesMultiline(d,new L.Range(1,1,w.lineNumber,w.column),E,p,10*P);if(t.length>0)return t[t.length-1];const a=d.getLineCount();return w.lineNumber!==a||w.column!==d.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(d,new l.Position(a,d.getLineMaxColumn(a)),E,p):null}static _doFindPreviousMatchLineByLine(d,w,E,p){const t=d.getLineCount(),a=w.lineNumber,r=d.getLineContent(a).substring(0,w.column-1),s=this._findLastMatchInLine(E,r,a,p);if(s)return s;for(let f=1;f<=t;f++){const b=(t+a-f-1)%t,u=d.getLineContent(b+1),C=this._findLastMatchInLine(E,u,b+1,p);if(C)return C}return null}static _findLastMatchInLine(d,w,E,p){let t=null,a;for(d.reset(0);a=d.next(w);)t=T(new L.Range(E,a.index+1,E,a.index+1+a[0].length),a,p);return t}}e.TextModelSearch=m;function D(h,d,w,E,p){if(E===0)return!0;const t=d.charCodeAt(E-1);if(h.get(t)!==0||t===13||t===10)return!0;if(p>0){const a=d.charCodeAt(E);if(h.get(a)!==0)return!0}return!1}function S(h,d,w,E,p){if(E+p===w)return!0;const t=d.charCodeAt(E+p);if(h.get(t)!==0||t===13||t===10)return!0;if(p>0){const a=d.charCodeAt(E+p-1);if(h.get(a)!==0)return!0}return!1}function v(h,d,w,E,p){return D(h,d,w,E,p)&&S(h,d,w,E,p)}e.isValidMatch=v;class n{constructor(d,w){this._wordSeparators=d,this._searchRegex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const w=d.length;let E;do{if(this._prevMatchStartIndex+this._prevMatchLength===w||(E=this._searchRegex.exec(d),!E))return null;const p=E.index,t=E[0].length;if(p===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){c.getNextCodePoint(d,w,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=t,!this._wordSeparators||v(this._wordSeparators,d,w,p,t))return E}while(E);return null}}e.Searcher=n}),define(ye[122],Ce([1,0,21,9]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(l||(l={}));function L(k){for(let m=0,D=k.length;m<D;m+=4){const S=k[m+0],v=k[m+1],n=k[m+2],h=k[m+3];k[m+0]=h,k[m+1]=n,k[m+2]=v,k[m+3]=S}}function R(k){const m=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return A.isLittleEndian()||L(m),c.VSBuffer.wrap(m)}function P(k){const m=k.buffer;if(A.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const D=new Uint8Array(m.byteLength);return D.set(m),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function _(k){const m=new Uint32Array(g(k));let D=0;if(m[D++]=k.id,k.type==="full")m[D++]=1,m[D++]=k.data.length,m.set(k.data,D),D+=k.data.length;else{m[D++]=2,m[D++]=k.deltas.length;for(const S of k.deltas)m[D++]=S.start,m[D++]=S.deleteCount,S.data?(m[D++]=S.data.length,m.set(S.data,D),D+=S.data.length):m[D++]=0}return R(m)}e.encodeSemanticTokensDto=_;function g(k){let m=0;if(m+=1+1,k.type==="full")m+=1+k.data.length;else{m+=1,m+=(1+1+1)*k.deltas.length;for(const D of k.deltas)D.data&&(m+=D.data.length)}return m}function T(k){const m=P(k);let D=0;const S=m[D++];if(m[D++]===1){const d=m[D++],w=m.subarray(D,D+d);return D+=d,{id:S,type:"full",data:w}}const n=m[D++],h=[];for(let d=0;d<n;d++){const w=m[D++],E=m[D++],p=m[D++];let t;p>0&&(t=m.subarray(D,D+p),D+=p),h[d]={start:w,deleteCount:E,data:t}}return{id:S,type:"delta",deltas:h}}e.decodeSemanticTokensDto=T}),define(ye[174],Ce([1,0,3,4]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,_){return this._tokenizationSupports.set(P,_),this.handleChange([P]),(0,A.toDisposable)(()=>{this._tokenizationSupports.get(P)===_&&(this._tokenizationSupports.delete(P),this.handleChange([P]))})}get(P){return this._tokenizationSupports.get(P)||null}registerFactory(P,_){this._factories.get(P)?.dispose();const g=new L(this,P,_);return this._factories.set(P,g),(0,A.toDisposable)(()=>{const T=this._factories.get(P);!T||T!==g||(this._factories.delete(P),T.dispose())})}async getOrCreate(P){const _=this.get(P);if(_)return _;const g=this._factories.get(P);return!g||g.isResolved?null:(await g.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const g=this._factories.get(P);return!!(!g||g.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=l;class L extends A.Disposable{get isResolved(){return this._isResolved}constructor(P,_,g){super(),this._registry=P,this._languageId=_,this._factory=g,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await this._factory.tokenizationSupport;this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(ye[76],Ce([1,0,70,2,35,174]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class R{constructor(I,F,U){this.offset=I,this.type=F,this.language=U,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=R;class P{constructor(I,F){this.tokens=I,this.endState=F,this._tokenizationResultBrand=void 0}}e.TokenizationResult=P;class _{constructor(I,F){this.tokens=I,this.endState=F,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=_;var g;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(g||(e.CompletionItemKind=g={}));var T;(function(i){const I=new Map;I.set(0,c.Codicon.symbolMethod),I.set(1,c.Codicon.symbolFunction),I.set(2,c.Codicon.symbolConstructor),I.set(3,c.Codicon.symbolField),I.set(4,c.Codicon.symbolVariable),I.set(5,c.Codicon.symbolClass),I.set(6,c.Codicon.symbolStruct),I.set(7,c.Codicon.symbolInterface),I.set(8,c.Codicon.symbolModule),I.set(9,c.Codicon.symbolProperty),I.set(10,c.Codicon.symbolEvent),I.set(11,c.Codicon.symbolOperator),I.set(12,c.Codicon.symbolUnit),I.set(13,c.Codicon.symbolValue),I.set(15,c.Codicon.symbolEnum),I.set(14,c.Codicon.symbolConstant),I.set(15,c.Codicon.symbolEnum),I.set(16,c.Codicon.symbolEnumMember),I.set(17,c.Codicon.symbolKeyword),I.set(27,c.Codicon.symbolSnippet),I.set(18,c.Codicon.symbolText),I.set(19,c.Codicon.symbolColor),I.set(20,c.Codicon.symbolFile),I.set(21,c.Codicon.symbolReference),I.set(22,c.Codicon.symbolCustomColor),I.set(23,c.Codicon.symbolFolder),I.set(24,c.Codicon.symbolTypeParameter),I.set(25,c.Codicon.account),I.set(26,c.Codicon.issues);function F(B){let N=I.get(B);return N||(console.info("No codicon found for CompletionItemKind "+B),N=c.Codicon.symbolProperty),N}i.toIcon=F;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function $(B,N){let V=U.get(B);return typeof V>"u"&&!N&&(V=9),V}i.fromString=$})(T||(e.CompletionItemKinds=T={}));var k;(function(i){i[i.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var m;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(m||(e.CompletionItemInsertTextRule=m={}));var D;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D||(e.CompletionTriggerKind=D={}));var S;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(S||(e.InlineCompletionTriggerKind=S={}));class v{constructor(I,F,U,$){this.range=I,this.text=F,this.completionKind=U,this.isSnippetText=$}equals(I){return l.Range.lift(this.range).equalsRange(I.range)&&this.text===I.text&&this.completionKind===I.completionKind&&this.isSnippetText===I.isSnippetText}}e.SelectedSuggestionInfo=v;var n;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var h;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(h||(e.SignatureHelpTriggerKind=h={}));var d;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(d||(e.DocumentHighlightKind=d={}));function w(i){return i&&A.URI.isUri(i.uri)&&l.Range.isIRange(i.range)&&(l.Range.isIRange(i.originSelectionRange)||l.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=w;var E;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(E||(e.SymbolKind=E={}));var p;(function(i){i[i.Deprecated=1]="Deprecated"})(p||(e.SymbolTag=p={}));var t;(function(i){const I=new Map;I.set(0,c.Codicon.symbolFile),I.set(1,c.Codicon.symbolModule),I.set(2,c.Codicon.symbolNamespace),I.set(3,c.Codicon.symbolPackage),I.set(4,c.Codicon.symbolClass),I.set(5,c.Codicon.symbolMethod),I.set(6,c.Codicon.symbolProperty),I.set(7,c.Codicon.symbolField),I.set(8,c.Codicon.symbolConstructor),I.set(9,c.Codicon.symbolEnum),I.set(10,c.Codicon.symbolInterface),I.set(11,c.Codicon.symbolFunction),I.set(12,c.Codicon.symbolVariable),I.set(13,c.Codicon.symbolConstant),I.set(14,c.Codicon.symbolString),I.set(15,c.Codicon.symbolNumber),I.set(16,c.Codicon.symbolBoolean),I.set(17,c.Codicon.symbolArray),I.set(18,c.Codicon.symbolObject),I.set(19,c.Codicon.symbolKey),I.set(20,c.Codicon.symbolNull),I.set(21,c.Codicon.symbolEnumMember),I.set(22,c.Codicon.symbolStruct),I.set(23,c.Codicon.symbolEvent),I.set(24,c.Codicon.symbolOperator),I.set(25,c.Codicon.symbolTypeParameter);function F(U){let $=I.get(U);return $||(console.info("No codicon found for SymbolKind "+U),$=c.Codicon.symbolProperty),$}i.toIcon=F})(t||(e.SymbolKinds=t={}));class a{static fromValue(I){switch(I){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(I)}constructor(I){this.value=I}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var r;(function(i){function I(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}i.is=I})(r||(e.Command=r={}));var s;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(s||(e.CommentThreadCollapsibleState=s={}));var f;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(f||(e.CommentThreadState=f={}));var b;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(b||(e.CommentMode=b={}));var u;(function(i){i[i.Published=0]="Published",i[i.Draft=1]="Draft"})(u||(e.CommentState=u={}));var C;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class y{constructor(I){this.createSupport=I,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(I=>{I&&I.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=y,e.TokenizationRegistry=new L.TokenizationRegistry;var o;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(o||(e.ExternalUriOpenerPriority=o={}))}),define(ye[175],Ce([13,14]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(ye[123],Ce([1,0,175,9,113,19,23,155]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(_||(e.EditorAutoIndentStrategy=_={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=g;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class k{constructor(Y,me,Fe,We){this.id=Y,this.name=me,this.defaultValue=Fe,this.schema=We}applyUpdate(Y,me){return D(Y,me)}compute(Y,me,Fe){return Fe}}class m{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=m;function D(K,Y){if(typeof K!="object"||typeof Y!="object"||!K||!Y)return new m(Y,K!==Y);if(Array.isArray(K)||Array.isArray(Y)){const Fe=Array.isArray(K)&&Array.isArray(Y)&&L.equals(K,Y);return new m(Y,!Fe)}let me=!1;for(const Fe in Y)if(Y.hasOwnProperty(Fe)){const We=D(K[Fe],Y[Fe]);We.didChange&&(K[Fe]=We.newValue,me=!0)}return new m(K,me)}class S{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return D(Y,me)}validate(Y){return this.defaultValue}}class v{constructor(Y,me,Fe,We){this.id=Y,this.name=me,this.defaultValue=Fe,this.schema=We}applyUpdate(Y,me){return D(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,Fe){return Fe}}function n(K,Y){return typeof K>"u"?Y:K==="false"?!1:!!K}e.boolean=n;class h extends v{constructor(Y,me,Fe,We=void 0){typeof We<"u"&&(We.type="boolean",We.default=Fe),super(Y,me,Fe,We)}validate(Y){return n(Y,this.defaultValue)}}function d(K,Y,me,Fe){if(typeof K>"u")return Y;let We=parseInt(K,10);return isNaN(We)?Y:(We=Math.max(me,We),We=Math.min(Fe,We),We|0)}e.clampedInt=d;class w extends v{static clampedInt(Y,me,Fe,We){return d(Y,me,Fe,We)}constructor(Y,me,Fe,We,ze,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Fe,Ye.minimum=We,Ye.maximum=ze),super(Y,me,Fe,Ye),this.minimum=We,this.maximum=ze}validate(Y){return w.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function E(K,Y,me,Fe){if(typeof K>"u")return Y;const We=p.float(K,Y);return p.clamp(We,me,Fe)}e.clampedFloat=E;class p extends v{static clamp(Y,me,Fe){return Y<me?me:Y>Fe?Fe:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const Fe=parseFloat(Y);return isNaN(Fe)?me:Fe}constructor(Y,me,Fe,We,ze){typeof ze<"u"&&(ze.type="number",ze.default=Fe),super(Y,me,Fe,ze),this.validationFn=We}validate(Y){return this.validationFn(p.float(Y,this.defaultValue))}}class t extends v{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Fe,We=void 0){typeof We<"u"&&(We.type="string",We.default=Fe),super(Y,me,Fe,We)}validate(Y){return t.string(Y,this.defaultValue)}}function a(K,Y,me,Fe){return typeof K!="string"?Y:Fe&&K in Fe?Fe[K]:me.indexOf(K)===-1?Y:K}e.stringSet=a;class r extends v{constructor(Y,me,Fe,We,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.enum=We,ze.default=Fe),super(Y,me,Fe,ze),this._allowedValues=We}validate(Y){return a(Y,this.defaultValue,this._allowedValues)}}class s extends k{constructor(Y,me,Fe,We,ze,Ye,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=ze,ct.default=We),super(Y,me,Fe,ct),this._allowedValues=ze,this._convert=Ye}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function f(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Fe){return Fe===0?Y.accessibilitySupport:Fe}}class u extends k{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:c.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function y(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(o||(e.TextEditorCursorStyle=o={}));function i(K){switch(K){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=i;function I(K){switch(K){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class F extends S{constructor(){super(137)}compute(Y,me,Fe){const We=["monaco-editor"];return me.get(37)&&We.push(me.get(37)),Y.extraEditorClassName&&We.push(Y.extraEditorClassName),me.get(71)==="default"?We.push("mouse-default"):me.get(71)==="copy"&&We.push("mouse-copy"),me.get(107)&&We.push("showUnused"),me.get(135)&&We.push("showDeprecated"),We.join(" ")}}class U extends h{constructor(){super(35,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(Y,me,Fe){return Fe&&Y.emptySelectionClipboard}}class $ extends k{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:c.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:c.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":a(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":a(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class B extends k{constructor(){super(49,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?B.OFF:Y==="true"?B.ON:Y:Y?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class N extends k{constructor(){super(52,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?N.OFF:Y==="true"?N.TRANSLATE:Y:Y?N.TRANSLATE:N.OFF}compute(Y,me,Fe){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class V extends S{constructor(){super(48)}compute(Y,me,Fe){return Y.fontInfo}}class x extends v{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(Y){const me=p.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(me,6,100)}compute(Y,me,Fe){return Y.fontInfo.fontSize}}class W extends k{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(w.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class ee extends k{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Fe,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Fe,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Fe,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Fe,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Fe,description:c.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:a(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??a(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??a(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??a(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??a(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??a(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends k{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:c.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:w.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky),above:n(me.above,this.defaultValue.above)}}}var H;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(H||(e.RenderMinimap=H={}));class J extends S{constructor(){super(140)}compute(Y,me,Fe){return J.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Fe=Math.floor(Y.paddingTop/Y.lineHeight);let We=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(We=Math.max(We,me-1));const ze=(Fe+Y.viewLineCount+We)/(Y.pixelRatio*Y.height),Ye=Math.floor(Y.viewLineCount/ze);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:We,desiredRatio:ze,minimapLineCount:Ye}}static _computeMinimapLayout(Y,me){const Fe=Y.outerWidth,We=Y.outerHeight,ze=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ze*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Ye=me.stableMinimapLayoutInput,ct=Ye&&Y.outerHeight===Ye.outerHeight&&Y.lineHeight===Ye.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ye.pixelRatio&&Y.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Y.paddingTop===Ye.paddingTop&&Y.paddingBottom===Ye.paddingBottom&&Y.minimap.enabled===Ye.minimap.enabled&&Y.minimap.side===Ye.minimap.side&&Y.minimap.size===Ye.minimap.size&&Y.minimap.showSlider===Ye.minimap.showSlider&&Y.minimap.renderCharacters===Ye.minimap.renderCharacters&&Y.minimap.maxColumn===Ye.minimap.maxColumn&&Y.minimap.scale===Ye.minimap.scale&&Y.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Y.isViewportWrapping===Ye.isViewportWrapping,st=Y.lineHeight,ft=Y.typicalHalfwidthCharacterWidth,kt=Y.scrollBeyondLastLine,Tt=Y.minimap.renderCharacters;let bt=ze>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const zt=Y.minimap.maxColumn,Mt=Y.minimap.size,jt=Y.minimap.side,Ft=Y.verticalScrollbarWidth,Nt=Y.viewLineCount,$t=Y.remainingWidth,ut=Y.isViewportWrapping,gt=Tt?2:3;let xt=Math.floor(ze*We);const Ut=xt/ze;let _t=!1,mt=!1,It=gt*bt,Wt=bt/ze,Le=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:qe,extraLinesBeforeFirstLine:it,extraLinesBeyondLastLine:yt,desiredRatio:Rt,minimapLineCount:Pt}=J.computeContainedMinimapLineCount({viewLineCount:Nt,scrollBeyondLastLine:kt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:We,lineHeight:st,pixelRatio:ze});if(Nt/Pt>1)_t=!0,mt=!0,bt=1,It=1,Wt=bt/ze;else{let lt=!1,vt=bt+1;if(Mt==="fit"){const Et=Math.ceil((it+Nt+yt)*It);ut&&ct&&$t<=me.stableFitRemainingWidth?(lt=!0,vt=me.stableFitMaxMinimapScale):lt=Et>xt}if(Mt==="fill"||lt){_t=!0;const Et=bt;It=Math.min(st*ze,Math.max(1,Math.floor(1/Rt))),ut&&ct&&$t<=me.stableFitRemainingWidth&&(vt=me.stableFitMaxMinimapScale),bt=Math.min(vt,Math.max(1,Math.floor(It/gt))),bt>Et&&(Le=Math.min(2,bt/Et)),Wt=bt/ze/Le,xt=Math.ceil(Math.max(qe,it+Nt+yt)*It),ut?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=$t,me.stableFitMaxMinimapScale=bt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Pe=Math.floor(zt*Wt),ke=Math.min(Pe,Math.max(0,Math.floor(($t-Ft-2)*Wt/(ft+Wt)))+e.MINIMAP_GUTTER_WIDTH);let ce=Math.floor(ze*ke);const Me=ce/ze;ce=Math.floor(ce*Le);const Be=Tt?1:2,Qe=jt==="left"?0:Fe-ke-Ft;return{renderMinimap:Be,minimapLeft:Qe,minimapWidth:ke,minimapHeightIsEditorHeight:_t,minimapIsSampling:mt,minimapScale:bt,minimapLineHeight:It,minimapCanvasInnerWidth:ce,minimapCanvasInnerHeight:xt,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ut}}static computeLayout(Y,me){const Fe=me.outerWidth|0,We=me.outerHeight|0,ze=me.lineHeight|0,Ye=me.lineNumbersDigitCount|0,ct=me.typicalHalfwidthCharacterWidth,st=me.maxDigitWidth,ft=me.pixelRatio,kt=me.viewLineCount,Tt=Y.get(132),bt=Tt==="inherit"?Y.get(131):Tt,zt=bt==="inherit"?Y.get(127):bt,Mt=Y.get(130),jt=me.isDominatedByLongLines,Ft=Y.get(55),Nt=Y.get(65).renderType!==0,$t=Y.get(66),ut=Y.get(101),gt=Y.get(81),xt=Y.get(70),Ut=Y.get(99),_t=Ut.verticalScrollbarSize,mt=Ut.verticalHasArrows,It=Ut.arrowSize,Wt=Ut.horizontalScrollbarSize,Le=Y.get(41),Pe=Y.get(106)!=="never";let ke=Y.get(63);Le&&Pe&&(ke+=16);let ce=0;if(Nt){const oi=Math.max(Ye,$t);ce=Math.round(oi*st)}let Me=0;Ft&&(Me=ze*me.glyphMarginDecorationLaneCount);let Be=0,Qe=Be+Me,qe=Qe+ce,it=qe+ke;const yt=Fe-Me-ce-ke;let Rt=!1,Pt=!1,wt=-1;bt==="inherit"&&jt?(Rt=!0,Pt=!0):zt==="on"||zt==="bounded"?Pt=!0:zt==="wordWrapColumn"&&(wt=Mt);const lt=J._computeMinimapLayout({outerWidth:Fe,outerHeight:We,lineHeight:ze,typicalHalfwidthCharacterWidth:ct,pixelRatio:ft,scrollBeyondLastLine:ut,paddingTop:gt.top,paddingBottom:gt.bottom,minimap:xt,verticalScrollbarWidth:_t,viewLineCount:kt,remainingWidth:yt,isViewportWrapping:Pt},me.memory||new T);lt.renderMinimap!==0&&lt.minimapLeft===0&&(Be+=lt.minimapWidth,Qe+=lt.minimapWidth,qe+=lt.minimapWidth,it+=lt.minimapWidth);const vt=yt-lt.minimapWidth,Et=Math.max(1,Math.floor((vt-_t-2)/ct)),St=mt?It:0;return Pt&&(wt=Math.max(1,Et),zt==="bounded"&&(wt=Math.min(wt,Mt))),{width:Fe,height:We,glyphMarginLeft:Be,glyphMarginWidth:Me,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Qe,lineNumbersWidth:ce,decorationsLeft:qe,decorationsWidth:ke,contentLeft:it,contentWidth:vt,minimap:lt,viewportColumn:Et,isWordWrapMinified:Rt,isViewportWrapping:Pt,wrappingColumn:wt,verticalScrollbarWidth:_t,horizontalScrollbarHeight:Wt,overviewRuler:{top:St,width:_t,height:We-2*St,right:0}}}}e.EditorLayoutInfoComputer=J;class j extends k{constructor(){super(134,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate(Y){return a(Y,"simple",["simple","advanced"])}compute(Y,me,Fe){return me.get(2)===2?"advanced":Fe}}class ae extends k{constructor(){const Y={enabled:!0};super(62,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:c.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:n(Y.enabled,this.defaultValue.enabled)}}}class we extends k{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(111,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:c.localize(52,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class _e extends k{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(136,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:c.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(54,null),c.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:c.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:c.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:c.localize(60,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:a(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:n(me.padding,this.defaultValue.padding)}}}class ve extends k{constructor(){super(63,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):w.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,me,Fe){return Fe<0?w.clampedInt(-Fe*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Fe}}class M extends p{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>p.clamp(Y,0,150),{markdownDescription:c.localize(61,null)})}compute(Y,me,Fe){return Y.fontInfo.lineHeight}}class X extends k{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:c.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:c.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(64,null),c.localize(65,null),c.localize(66,null)],default:Y.size,description:c.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:c.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:c.localize(69,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:c.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:c.localize(72,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),autohide:n(me.autohide,this.defaultValue.autohide),size:a(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(me.side,this.defaultValue.side,["right","left"]),showSlider:a(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(me.scale,1,1,3),maxColumn:w.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(K){return K==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ee extends k{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:w.clampedInt(me.top,0,0,1e3),bottom:w.clampedInt(me.bottom,0,0,1e3)}}}class Z extends k{constructor(){const Y={enabled:!0,cycle:!0};super(83,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:c.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:c.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class ne extends S{constructor(){super(138)}compute(Y,me,Fe){return Y.pixelRatio}}class le extends k{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)]}];super(86,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:c.localize(80,null)},comments:{anyOf:me,default:Y.comments,description:c.localize(81,null)},other:{anyOf:me,default:Y.other,description:c.localize(82,null)}},default:Y,markdownDescription:c.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const ft=Y?"on":"off";return{comments:ft,strings:ft,other:ft}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Fe,strings:We}=Y,ze=["on","inline","off"];let Ye,ct,st;return typeof me=="boolean"?Ye=me?"on":"off":Ye=a(me,this.defaultValue.other,ze),typeof Fe=="boolean"?ct=Fe?"on":"off":ct=a(Fe,this.defaultValue.comments,ze),typeof We=="boolean"?st=We?"on":"off":st=a(We,this.defaultValue.strings,ze),{other:Ye,comments:ct,strings:st}}}var te;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class de extends k{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(84,null),c.localize(85,null),c.localize(86,null),c.localize(87,null)],default:"on",description:c.localize(88,null)})}validate(Y){let me=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,Fe=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Fe}}}function oe(K){const Y=K.get(94);return Y==="editable"?K.get(88):Y!=="on"}e.filterValidationDecorations=oe;class ue extends k{constructor(){const Y=[],me={type:"number",description:c.localize(89,null)};super(98,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:c.localize(90,null),format:"color-hex"}}}]},default:Y,description:c.localize(91,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const Fe of Y)if(typeof Fe=="number")me.push({column:w.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const We=Fe;me.push({column:w.clampedInt(We.column,0,0,1e4),color:We.color})}return me.sort((Fe,We)=>Fe.column-We.column),me}return this.defaultValue}}function O(K,Y){if(typeof K!="string")return Y;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(99,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:"auto",description:c.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(96,null),c.localize(97,null),c.localize(98,null)],default:"auto",description:c.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:c.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:c.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Fe=w.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=w.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(me.vertical,this.defaultValue.vertical),horizontal:O(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:w.clampedInt(me.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:We,verticalSliderSize:w.clampedInt(me.verticalSliderSize,We,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends k{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(121,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:c.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:c.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:c.localize(109,null)}})}applyUpdate(Y,me){let Fe=!1;me.allowedCharacters&&Y&&(R.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Fe=!0)),me.allowedLocales&&Y&&(R.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Fe=!0));const We=super.applyUpdate(Y,me);return Fe?new m(We.newValue,!0):We}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:he(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Fe={};for(const[We,ze]of Object.entries(Y))ze===!0&&(Fe[We]=!0);return Fe}}class ie extends k{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:c.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[c.localize(111,null),c.localize(112,null)],description:c.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:c.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:a(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(me.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:n(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(me.keepOnBlur,this.defaultValue.keepOnBlur)}}}class pe extends k{constructor(){const Y={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:c.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:c.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class De extends k{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(117,null),c.localize(118,null),c.localize(119,null)],default:Y.bracketPairs,description:c.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],default:Y.bracketPairsHorizontal,description:c.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:c.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:c.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(127,null),c.localize(128,null),c.localize(129,null)],default:Y.highlightActiveIndentation,description:c.localize(130,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:he(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(K,Y,me){const Fe=me.indexOf(K);return Fe===-1?Y:me[Fe]}class Ae extends k{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(114,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(131,null),c.localize(132,null)],default:Y.insertMode,description:c.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:c.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:c.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:c.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(137,null),c.localize(138,null),c.localize(139,null),c.localize(140,null)],default:Y.selectionMode,markdownDescription:c.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:c.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:c.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:c.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:c.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:c.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:a(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:a(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(109,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(179,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var He;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Ve extends k{constructor(){super(133,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(180,null),c.localize(181,null),c.localize(182,null),c.localize(183,null)],description:c.localize(184,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,me,Fe){return me.get(2)===2?0:Fe}}class tt extends S{constructor(){super(141)}compute(Y,me,Fe){const We=me.get(140);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}class Xe extends k{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:c.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(187,null),c.localize(188,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),showDropSelector:a(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ke extends k{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:c.localize(189,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(190,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(191,null),c.localize(192,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),showPasteSelector:a(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?ot:A.isLinux?et:nt,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function xe(K){return e.editorOptionsRegistry[K.id]=K,K}var Ie;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",K[K.autoClosingDelete=7]="autoClosingDelete",K[K.autoClosingOvertype=8]="autoClosingOvertype",K[K.autoClosingQuotes=9]="autoClosingQuotes",K[K.autoIndent=10]="autoIndent",K[K.automaticLayout=11]="automaticLayout",K[K.autoSurround=12]="autoSurround",K[K.bracketPairColorization=13]="bracketPairColorization",K[K.guides=14]="guides",K[K.codeLens=15]="codeLens",K[K.codeLensFontFamily=16]="codeLensFontFamily",K[K.codeLensFontSize=17]="codeLensFontSize",K[K.colorDecorators=18]="colorDecorators",K[K.colorDecoratorsLimit=19]="colorDecoratorsLimit",K[K.columnSelection=20]="columnSelection",K[K.comments=21]="comments",K[K.contextmenu=22]="contextmenu",K[K.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",K[K.cursorBlinking=24]="cursorBlinking",K[K.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",K[K.cursorStyle=26]="cursorStyle",K[K.cursorSurroundingLines=27]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",K[K.cursorWidth=29]="cursorWidth",K[K.disableLayerHinting=30]="disableLayerHinting",K[K.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",K[K.domReadOnly=32]="domReadOnly",K[K.dragAndDrop=33]="dragAndDrop",K[K.dropIntoEditor=34]="dropIntoEditor",K[K.emptySelectionClipboard=35]="emptySelectionClipboard",K[K.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",K[K.extraEditorClassName=37]="extraEditorClassName",K[K.fastScrollSensitivity=38]="fastScrollSensitivity",K[K.find=39]="find",K[K.fixedOverflowWidgets=40]="fixedOverflowWidgets",K[K.folding=41]="folding",K[K.foldingStrategy=42]="foldingStrategy",K[K.foldingHighlight=43]="foldingHighlight",K[K.foldingImportsByDefault=44]="foldingImportsByDefault",K[K.foldingMaximumRegions=45]="foldingMaximumRegions",K[K.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=47]="fontFamily",K[K.fontInfo=48]="fontInfo",K[K.fontLigatures=49]="fontLigatures",K[K.fontSize=50]="fontSize",K[K.fontWeight=51]="fontWeight",K[K.fontVariations=52]="fontVariations",K[K.formatOnPaste=53]="formatOnPaste",K[K.formatOnType=54]="formatOnType",K[K.glyphMargin=55]="glyphMargin",K[K.gotoLocation=56]="gotoLocation",K[K.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",K[K.hover=58]="hover",K[K.inDiffEditor=59]="inDiffEditor",K[K.inlineSuggest=60]="inlineSuggest",K[K.letterSpacing=61]="letterSpacing",K[K.lightbulb=62]="lightbulb",K[K.lineDecorationsWidth=63]="lineDecorationsWidth",K[K.lineHeight=64]="lineHeight",K[K.lineNumbers=65]="lineNumbers",K[K.lineNumbersMinChars=66]="lineNumbersMinChars",K[K.linkedEditing=67]="linkedEditing",K[K.links=68]="links",K[K.matchBrackets=69]="matchBrackets",K[K.minimap=70]="minimap",K[K.mouseStyle=71]="mouseStyle",K[K.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=73]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",K[K.multiCursorModifier=75]="multiCursorModifier",K[K.multiCursorPaste=76]="multiCursorPaste",K[K.multiCursorLimit=77]="multiCursorLimit",K[K.occurrencesHighlight=78]="occurrencesHighlight",K[K.overviewRulerBorder=79]="overviewRulerBorder",K[K.overviewRulerLanes=80]="overviewRulerLanes",K[K.padding=81]="padding",K[K.pasteAs=82]="pasteAs",K[K.parameterHints=83]="parameterHints",K[K.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",K[K.quickSuggestions=86]="quickSuggestions",K[K.quickSuggestionsDelay=87]="quickSuggestionsDelay",K[K.readOnly=88]="readOnly",K[K.renameOnType=89]="renameOnType",K[K.renderControlCharacters=90]="renderControlCharacters",K[K.renderFinalNewline=91]="renderFinalNewline",K[K.renderLineHighlight=92]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=93]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=94]="renderValidationDecorations",K[K.renderWhitespace=95]="renderWhitespace",K[K.revealHorizontalRightPadding=96]="revealHorizontalRightPadding",K[K.roundedSelection=97]="roundedSelection",K[K.rulers=98]="rulers",K[K.scrollbar=99]="scrollbar",K[K.scrollBeyondLastColumn=100]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=101]="scrollBeyondLastLine",K[K.scrollPredominantAxis=102]="scrollPredominantAxis",K[K.selectionClipboard=103]="selectionClipboard",K[K.selectionHighlight=104]="selectionHighlight",K[K.selectOnLineNumbers=105]="selectOnLineNumbers",K[K.showFoldingControls=106]="showFoldingControls",K[K.showUnused=107]="showUnused",K[K.snippetSuggestions=108]="snippetSuggestions",K[K.smartSelect=109]="smartSelect",K[K.smoothScrolling=110]="smoothScrolling",K[K.stickyScroll=111]="stickyScroll",K[K.stickyTabStops=112]="stickyTabStops",K[K.stopRenderingLineAfter=113]="stopRenderingLineAfter",K[K.suggest=114]="suggest",K[K.suggestFontSize=115]="suggestFontSize",K[K.suggestLineHeight=116]="suggestLineHeight",K[K.suggestOnTriggerCharacters=117]="suggestOnTriggerCharacters",K[K.suggestSelection=118]="suggestSelection",K[K.tabCompletion=119]="tabCompletion",K[K.tabIndex=120]="tabIndex",K[K.unicodeHighlighting=121]="unicodeHighlighting",K[K.unusualLineTerminators=122]="unusualLineTerminators",K[K.useShadowDOM=123]="useShadowDOM",K[K.useTabStops=124]="useTabStops",K[K.wordBreak=125]="wordBreak",K[K.wordSeparators=126]="wordSeparators",K[K.wordWrap=127]="wordWrap",K[K.wordWrapBreakAfterCharacters=128]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=129]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=130]="wordWrapColumn",K[K.wordWrapOverride1=131]="wordWrapOverride1",K[K.wordWrapOverride2=132]="wordWrapOverride2",K[K.wrappingIndent=133]="wrappingIndent",K[K.wrappingStrategy=134]="wrappingStrategy",K[K.showDeprecated=135]="showDeprecated",K[K.inlayHints=136]="inlayHints",K[K.editorClassName=137]="editorClassName",K[K.pixelRatio=138]="pixelRatio",K[K.tabFocusMode=139]="tabFocusMode",K[K.layoutInfo=140]="layoutInfo",K[K.wrappingInfo=141]="wrappingInfo",K[K.defaultColorDecorators=142]="defaultColorDecorators"})(Ie||(e.EditorOption=Ie={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:xe(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(193,null)})),acceptSuggestionOnEnter:xe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(194,null),""],markdownDescription:c.localize(195,null)})),accessibilitySupport:xe(new b),accessibilityPageSize:xe(new w(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(196,null),tags:["accessibility"]})),ariaLabel:xe(new t(4,"ariaLabel",c.localize(197,null))),screenReaderAnnounceInlineSuggestion:xe(new h(6,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(198,null),tags:["accessibility"]})),autoClosingBrackets:xe(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(199,null),c.localize(200,null),""],description:c.localize(201,null)})),autoClosingDelete:xe(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(202,null),""],description:c.localize(203,null)})),autoClosingOvertype:xe(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(204,null),""],description:c.localize(205,null)})),autoClosingQuotes:xe(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(206,null),c.localize(207,null),""],description:c.localize(208,null)})),autoIndent:xe(new s(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[c.localize(209,null),c.localize(210,null),c.localize(211,null),c.localize(212,null),c.localize(213,null)],description:c.localize(214,null)})),automaticLayout:xe(new h(11,"automaticLayout",!1)),autoSurround:xe(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(215,null),c.localize(216,null),c.localize(217,null),""],description:c.localize(218,null)})),bracketPairColorization:xe(new pe),bracketPairGuides:xe(new De),stickyTabStops:xe(new h(112,"stickyTabStops",!1,{description:c.localize(219,null)})),codeLens:xe(new h(15,"codeLens",!0,{description:c.localize(220,null)})),codeLensFontFamily:xe(new t(16,"codeLensFontFamily","",{description:c.localize(221,null)})),codeLensFontSize:xe(new w(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(222,null)})),colorDecorators:xe(new h(18,"colorDecorators",!0,{description:c.localize(223,null)})),colorDecoratorsLimit:xe(new w(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(224,null)})),columnSelection:xe(new h(20,"columnSelection",!1,{description:c.localize(225,null)})),comments:xe(new u),contextmenu:xe(new h(22,"contextmenu",!0)),copyWithSyntaxHighlighting:xe(new h(23,"copyWithSyntaxHighlighting",!0,{description:c.localize(226,null)})),cursorBlinking:xe(new s(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],y,{description:c.localize(227,null)})),cursorSmoothCaretAnimation:xe(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(228,null),c.localize(229,null),c.localize(230,null)],description:c.localize(231,null)})),cursorStyle:xe(new s(26,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:c.localize(232,null)})),cursorSurroundingLines:xe(new w(27,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(233,null)})),cursorSurroundingLinesStyle:xe(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(234,null),c.localize(235,null)],description:c.localize(236,null)})),cursorWidth:xe(new w(29,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(237,null)})),disableLayerHinting:xe(new h(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:xe(new h(31,"disableMonospaceOptimizations",!1)),domReadOnly:xe(new h(32,"domReadOnly",!1)),dragAndDrop:xe(new h(33,"dragAndDrop",!0,{description:c.localize(238,null)})),emptySelectionClipboard:xe(new U),dropIntoEditor:xe(new Xe),stickyScroll:xe(new we),experimentalWhitespaceRendering:xe(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(239,null),c.localize(240,null),c.localize(241,null)],description:c.localize(242,null)})),extraEditorClassName:xe(new t(37,"extraEditorClassName","")),fastScrollSensitivity:xe(new p(38,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:c.localize(243,null)})),find:xe(new $),fixedOverflowWidgets:xe(new h(40,"fixedOverflowWidgets",!1)),folding:xe(new h(41,"folding",!0,{description:c.localize(244,null)})),foldingStrategy:xe(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(245,null),c.localize(246,null)],description:c.localize(247,null)})),foldingHighlight:xe(new h(43,"foldingHighlight",!0,{description:c.localize(248,null)})),foldingImportsByDefault:xe(new h(44,"foldingImportsByDefault",!1,{description:c.localize(249,null)})),foldingMaximumRegions:xe(new w(45,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(250,null)})),unfoldOnClickAfterEndOfLine:xe(new h(46,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(251,null)})),fontFamily:xe(new t(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(252,null)})),fontInfo:xe(new V),fontLigatures2:xe(new B),fontSize:xe(new x),fontWeight:xe(new W),fontVariations:xe(new N),formatOnPaste:xe(new h(53,"formatOnPaste",!1,{description:c.localize(253,null)})),formatOnType:xe(new h(54,"formatOnType",!1,{description:c.localize(254,null)})),glyphMargin:xe(new h(55,"glyphMargin",!0,{description:c.localize(255,null)})),gotoLocation:xe(new ee),hideCursorInOverviewRuler:xe(new h(57,"hideCursorInOverviewRuler",!1,{description:c.localize(256,null)})),hover:xe(new se),inDiffEditor:xe(new h(59,"inDiffEditor",!1)),letterSpacing:xe(new p(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>p.clamp(K,-5,20),{description:c.localize(257,null)})),lightbulb:xe(new ae),lineDecorationsWidth:xe(new ve),lineHeight:xe(new M),lineNumbers:xe(new de),lineNumbersMinChars:xe(new w(66,"lineNumbersMinChars",5,1,300)),linkedEditing:xe(new h(67,"linkedEditing",!1,{description:c.localize(258,null)})),links:xe(new h(68,"links",!0,{description:c.localize(259,null)})),matchBrackets:xe(new r(69,"matchBrackets","always",["always","near","never"],{description:c.localize(260,null)})),minimap:xe(new X),mouseStyle:xe(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:xe(new p(72,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:c.localize(261,null)})),mouseWheelZoom:xe(new h(73,"mouseWheelZoom",!1,{markdownDescription:c.localize(262,null)})),multiCursorMergeOverlapping:xe(new h(74,"multiCursorMergeOverlapping",!0,{description:c.localize(263,null)})),multiCursorModifier:xe(new s(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[c.localize(264,null),c.localize(265,null)],markdownDescription:c.localize(266,null)})),multiCursorPaste:xe(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(267,null),c.localize(268,null)],markdownDescription:c.localize(269,null)})),multiCursorLimit:xe(new w(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(270,null)})),occurrencesHighlight:xe(new h(78,"occurrencesHighlight",!0,{description:c.localize(271,null)})),overviewRulerBorder:xe(new h(79,"overviewRulerBorder",!0,{description:c.localize(272,null)})),overviewRulerLanes:xe(new w(80,"overviewRulerLanes",3,0,3)),padding:xe(new Ee),pasteAs:xe(new Ke),parameterHints:xe(new Z),peekWidgetDefaultFocus:xe(new r(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),definitionLinkOpensInPeek:xe(new h(85,"definitionLinkOpensInPeek",!1,{description:c.localize(276,null)})),quickSuggestions:xe(new le),quickSuggestionsDelay:xe(new w(87,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(277,null)})),readOnly:xe(new h(88,"readOnly",!1)),renameOnType:xe(new h(89,"renameOnType",!1,{description:c.localize(278,null),markdownDeprecationMessage:c.localize(279,null)})),renderControlCharacters:xe(new h(90,"renderControlCharacters",!0,{description:c.localize(280,null),restricted:!0})),renderFinalNewline:xe(new r(91,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(281,null)})),renderLineHighlight:xe(new r(92,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(282,null)],description:c.localize(283,null)})),renderLineHighlightOnlyWhenFocus:xe(new h(93,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(284,null)})),renderValidationDecorations:xe(new r(94,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:xe(new r(95,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(285,null),c.localize(286,null),c.localize(287,null),""],description:c.localize(288,null)})),revealHorizontalRightPadding:xe(new w(96,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:xe(new h(97,"roundedSelection",!0,{description:c.localize(289,null)})),rulers:xe(new ue),scrollbar:xe(new q),scrollBeyondLastColumn:xe(new w(100,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(290,null)})),scrollBeyondLastLine:xe(new h(101,"scrollBeyondLastLine",!0,{description:c.localize(291,null)})),scrollPredominantAxis:xe(new h(102,"scrollPredominantAxis",!0,{description:c.localize(292,null)})),selectionClipboard:xe(new h(103,"selectionClipboard",!0,{description:c.localize(293,null),included:A.isLinux})),selectionHighlight:xe(new h(104,"selectionHighlight",!0,{description:c.localize(294,null)})),selectOnLineNumbers:xe(new h(105,"selectOnLineNumbers",!0)),showFoldingControls:xe(new r(106,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(295,null),c.localize(296,null),c.localize(297,null)],description:c.localize(298,null)})),showUnused:xe(new h(107,"showUnused",!0,{description:c.localize(299,null)})),showDeprecated:xe(new h(135,"showDeprecated",!0,{description:c.localize(300,null)})),inlayHints:xe(new _e),snippetSuggestions:xe(new r(108,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null),c.localize(304,null)],description:c.localize(305,null)})),smartSelect:xe(new Te),smoothScrolling:xe(new h(110,"smoothScrolling",!1,{description:c.localize(306,null)})),stopRenderingLineAfter:xe(new w(113,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:xe(new Ae),inlineSuggest:xe(new ie),suggestFontSize:xe(new w(115,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(307,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:xe(new w(116,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(308,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:xe(new h(117,"suggestOnTriggerCharacters",!0,{description:c.localize(309,null)})),suggestSelection:xe(new r(118,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(310,null),c.localize(311,null),c.localize(312,null)],description:c.localize(313,null)})),tabCompletion:xe(new r(119,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(314,null),c.localize(315,null),c.localize(316,null)],description:c.localize(317,null)})),tabIndex:xe(new w(120,"tabIndex",0,-1,1073741824)),unicodeHighlight:xe(new Q),unusualLineTerminators:xe(new r(122,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(318,null),c.localize(319,null),c.localize(320,null)],description:c.localize(321,null)})),useShadowDOM:xe(new h(123,"useShadowDOM",!0)),useTabStops:xe(new h(124,"useTabStops",!0,{description:c.localize(322,null)})),wordBreak:xe(new r(125,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(323,null),c.localize(324,null)],description:c.localize(325,null)})),wordSeparators:xe(new t(126,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:c.localize(326,null)})),wordWrap:xe(new r(127,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(327,null),c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),wordWrapBreakAfterCharacters:xe(new t(128,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:xe(new t(129,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:xe(new w(130,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(332,null)})),wordWrapOverride1:xe(new r(131,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:xe(new r(132,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:xe(new F),defaultColorDecorators:xe(new h(142,"defaultColorDecorators",!1,{markdownDescription:c.localize(333,null)})),pixelRatio:xe(new ne),tabFocusMode:xe(new h(139,"tabFocusMode",!1,{markdownDescription:c.localize(334,null)})),layoutInfo:xe(new J),wrappingInfo:xe(new tt),wrappingIndent:xe(new Ve),wrappingStrategy:xe(new j)}}),define(ye[176],Ce([13,14]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[177],Ce([13,14]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[178],Ce([13,14]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(ye[179],Ce([13,14]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[180],Ce([13,14]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[181],Ce([13,14]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[182],Ce([13,14]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(ye[183],Ce([13,14]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(ye[184],Ce([13,14]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[185],Ce([13,14]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(ye[186],Ce([13,14]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[187],Ce([13,14]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(ye[188],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostChat",e)}),define(ye[189],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[190],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[191],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ye[192],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(ye[193],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[194],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[195],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[196],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[197],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[198],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[199],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[200],Ce([13,14]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[201],Ce([13,14]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(ye[202],Ce([13,14]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(ye[203],Ce([13,14]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[204],Ce([13,14]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[205],Ce([13,14]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[206],Ce([13,14]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[207],Ce([13,14]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[208],Ce([13,14]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[209],Ce([13,14]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[210],Ce([13,14]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[211],Ce([1,0,8,178]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(l||(e.TokenType=l={}));function L(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class _{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,c.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(T){return this._input=T,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const k=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:k})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const k=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:k})}else this._match(126)?this._addToken(9):this._error(L("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(L("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(T){return this._isAtEnd()||this._input.charCodeAt(this._current)!==T?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(T){this._tokens.push({type:T,offset:this._start})}_error(T){const k=this._start,m=this._input.substring(this._start,this._current),D={type:19,offset:this._start,lexeme:m};this._errors.push({offset:k,lexeme:m,additionalInfo:T}),this._tokens.push(D)}_string(){this.stringRe.lastIndex=this._start;const T=this.stringRe.exec(this._input);if(T){this._current=this._start+T[0].length;const k=this._input.substring(this._start,this._current),m=_._keywords.get(k);m?this._addToken(m):this._tokens.push({type:17,lexeme:k,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let T=this._current,k=!1,m=!1;for(;;){if(T>=this._input.length){this._current=T,this._error(P);return}const S=this._input.charCodeAt(T);if(k)k=!1;else if(S===47&&!m){T++;break}else S===91?m=!0:S===92?k=!0:S===93&&(m=!1);T++}for(;T<this._input.length&&_._regexFlags.has(this._input.charCodeAt(T));)T++;this._current=T;const D=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:D,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=_,_._regexFlags=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),_._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ye[212],Ce([1,0,24,41,180,346]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function _(h){return h=h.trim(),h==="*"||R.test(h)}e.isValidVersionStr=_;function g(h){if(!_(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=h.match(R);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=g;function T(h){if(!h)return null;const d=h.majorBase,w=h.majorMustEqual,E=h.minorBase;let p=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(d===0||(p=!1),a=!1);let r=0;if(h.preRelease){const s=P.exec(h.preRelease);if(s){const[,f,b,u]=s;r=Date.UTC(Number(f),Number(b)-1,Number(u))}}return{majorBase:d,majorMustEqual:w,minorBase:E,minorMustEqual:p,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:r}}e.normalizeVersion=T;function k(h,d,w){let E;typeof h=="string"?E=T(g(h)):E=h;let p;d instanceof Date?p=d.getTime():typeof d=="string"&&(p=new Date(d).getTime());let t;if(typeof w=="string"?t=T(g(w)):t=w,!E||!t)return!1;const a=E.majorBase,r=E.minorBase,s=E.patchBase;let f=t.majorBase,b=t.minorBase,u=t.patchBase;const C=t.notBefore;let y=t.majorMustEqual,o=t.minorMustEqual,i=t.patchMustEqual;return t.isMinimum?a>f?!0:a<f?!1:r>b?!0:r<b||p&&p<C?!1:s>=u:(a===1&&f===0&&(!y||!o||!i)&&(f=1,b=0,u=0,y=!0,o=!1,i=!1),a<f?!1:a>f?!y:r<b?!1:r>b?!o:s<u?!1:s>u?!i:!(p&&p<C))}e.isValidVersion=k;function m(h,d,w,E,p){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([A.default.Error,l.localize(0,null)]),t;if(typeof E.name!="string")return t.push([A.default.Error,l.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([A.default.Error,l.localize(2,null,"version")]),t;if(!E.engines)return t.push([A.default.Error,l.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([A.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!n(E.extensionDependencies))return t.push([A.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!n(E.activationEvents))return t.push([A.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([A.default.Error,l.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([A.default.Warning,l.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([A.default.Error,l.localize(9,null,"main")]),t;{const s=(0,c.joinPath)(w,E.main);(0,c.isEqualOrParent)(s,w)||t.push([A.default.Warning,l.localize(10,null,s.path,w.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([A.default.Error,l.localize(11,null,"browser")]),t;{const s=(0,c.joinPath)(w,E.browser);(0,c.isEqualOrParent)(s,w)||t.push([A.default.Warning,l.localize(12,null,s.path,w.path)])}}if(!L.valid(E.version))return t.push([A.default.Error,l.localize(13,null)]),t;const a=[];if(!D(h,d,E,p,a))for(const s of a)t.push([A.default.Error,s]);return t}e.validateExtensionManifest=m;function D(h,d,w,E,p){return E||typeof w.main>"u"&&typeof w.browser>"u"?!0:v(h,d,w.engines.vscode,p)}e.isValidExtensionVersion=D;function S(h,d,w){return h==="*"||v(d,w,h)}e.isEngineValid=S;function v(h,d,w,E=[]){const p=T(g(w));if(!p)return E.push(l.localize(14,null,w)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return E.push(l.localize(15,null,w)),!1}else if(!p.majorMustEqual)return E.push(l.localize(16,null,w)),!1;return k(h,d,p)?!0:(E.push(l.localize(17,null,h,w)),!1)}function n(h){if(!Array.isArray(h))return!1;for(let d=0,w=h.length;d<w;d++)if(typeof h[d]!="string")return!1;return!0}}),define(ye[96],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(l,L=[],R=!1){this.ctor=l,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=c}),define(ye[97],Ce([1,0,96]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l||(e.InstantiationType=l={}));function L(P,_,g){_ instanceof c.SyncDescriptor||(_=new c.SyncDescriptor(_,[],!!g)),A.push([P,_])}e.registerSingleton=L;function R(){return A}e.getSingletonServiceDescriptors=R}),define(ye[213],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class A{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const R of this._nodes.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const P=this.lookupOrInsertNode(L),_=this.lookupOrInsertNode(R);P.outgoing.set(_.key,_),_.incoming.set(P.key,P)}removeNode(L){const R=this._hashFn(L);this._nodes.delete(R);for(const P of this._nodes.values())P.outgoing.delete(R),P.incoming.delete(R)}lookupOrInsertNode(L){const R=this._hashFn(L);let P=this._nodes.get(R);return P||(P=new c(R,L),this._nodes.set(R,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[R,P]of this._nodes)L.push(`${R}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this._nodes){const P=new Set([L]),_=this._findCycle(R,P);if(_)return _}}_findCycle(L,R){for(const[P,_]of L.outgoing){if(R.has(P))return[...R,P].join(" -> ");R.add(P);const g=this._findCycle(_,R);if(g)return g;R.delete(P)}}}e.Graph=A}),define(ye[5],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function P(_){return _[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=P})(c||(e._util=c={})),e.IInstantiationService=l("instantiationService");function A(R,P,_){P[c.DI_TARGET]===P?P[c.DI_DEPENDENCIES].push({id:R,index:_}):(P[c.DI_DEPENDENCIES]=[{id:R,index:_}],P[c.DI_TARGET]=P)}function l(R){if(c.serviceIds.has(R))return c.serviceIds.get(R);const P=function(_,g,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,_,T)};return P.toString=()=>R,c.serviceIds.set(R,P),P}e.createDecorator=l;function L(R){return R}e.refineServiceDecorator=L}),define(ye[57],Ce([1,0,12,2,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function L(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=L;function R(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=R;var P;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function _(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=_;function g(n,h){const d=Object.create(null);for(const w in n)T(d,w,n[w],h);return d}e.toValuesTree=g;function T(n,h,d,w){const E=h.split("."),p=E.pop();let t=n;for(let a=0;a<E.length;a++){const r=E[a];let s=t[r];switch(typeof s){case"undefined":s=t[r]=Object.create(null);break;case"object":break;default:w(`Ignoring ${h} as ${E.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}t=s}if(typeof t=="object"&&t!==null)try{t[p]=d}catch{w(`Ignoring ${h} as ${E.join(".")} is ${JSON.stringify(t)}`)}else w(`Ignoring ${h} as ${E.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function k(n,h){const d=h.split(".");m(n,d)}e.removeFromValueTree=k;function m(n,h){const d=h.shift();if(h.length===0){delete n[d];return}if(Object.keys(n).indexOf(d)!==-1){const w=n[d];typeof w=="object"&&!Array.isArray(w)&&(m(w,h),Object.keys(w).length===0&&delete n[d])}}function D(n,h,d){function w(t,a){let r=t;for(const s of a){if(typeof r!="object"||r===null)return;r=r[s]}return r}const E=h.split("."),p=w(n,E);return typeof p>"u"?d:p}e.getConfigurationValue=D;function S(n,h,d){Object.keys(h).forEach(w=>{w!=="__proto__"&&(w in n?c.isObject(n[w])&&c.isObject(h[w])?S(n[w],h[w],d):d&&(n[w]=h[w]):n[w]=h[w])})}e.merge=S;function v(n){return n.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(ye[47],Ce([1,0,9,11,211,5,177,8]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",c.isMacintosh),_.set("isLinux",c.isLinux),_.set("isWindows",c.isWindows),_.set("isWeb",c.isWeb),_.set("isMacNative",c.isMacintosh&&!c.isWeb),_.set("isEdge",c.isEdge),_.set("isFirefox",c.isFirefox),_.set("isChrome",c.isChrome),_.set("isSafari",c.isSafari);function g(ve,M){if(_.get(ve)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");_.set(ve,M)}e.setConstant=g;const T=Object.prototype.hasOwnProperty;var k;(function(ve){ve[ve.False=0]="False",ve[ve.True=1]="True",ve[ve.Defined=2]="Defined",ve[ve.Not=3]="Not",ve[ve.Equals=4]="Equals",ve[ve.NotEquals=5]="NotEquals",ve[ve.And=6]="And",ve[ve.Regex=7]="Regex",ve[ve.NotRegex=8]="NotRegex",ve[ve.Or=9]="Or",ve[ve.In=10]="In",ve[ve.NotIn=11]="NotIn",ve[ve.Greater=12]="Greater",ve[ve.GreaterEquals=13]="GreaterEquals",ve[ve.Smaller=14]="Smaller",ve[ve.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const m={regexParsingWithErrorRecovery:!0},D=(0,R.localize)(0,null),S=(0,R.localize)(1,null),v=(0,R.localize)(2,null),n=(0,R.localize)(3,null),h=(0,R.localize)(4,null),d=(0,R.localize)(5,null),w=(0,R.localize)(6,null),E=(0,R.localize)(7,null);class p{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(M=m){this._config=M,this._scanner=new l.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(M){if(M===""){this._parsingErrors.push({message:D,offset:0,lexeme:"",additionalInfo:S});return}this._tokens=this._scanner.reset(M).scan(),this._current=0,this._parsingErrors=[];try{const X=this._expr();if(!this._isAtEnd()){const fe=this._peek(),Ee=fe.type===17?d:void 0;throw this._parsingErrors.push({message:h,offset:fe.offset,lexeme:l.Scanner.getLexeme(fe),additionalInfo:Ee}),p._parseError}return X}catch(X){if(X!==p._parseError)throw X;return}}_expr(){return this._or()}_or(){const M=[this._and()];for(;this._matchOne(16);){const X=this._and();M.push(X)}return M.length===1?M[0]:t.or(...M)}_and(){const M=[this._term()];for(;this._matchOne(15);){const X=this._term();M.push(X)}return M.length===1?M[0]:t.and(...M)}_term(){if(this._matchOne(2)){const M=this._peek();switch(M.type){case 11:return this._advance(),f.INSTANCE;case 12:return this._advance(),b.INSTANCE;case 0:{this._advance();const X=this._expr();return this._consume(1,n),X?.negate()}case 17:return this._advance(),I.create(M.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",M)}}return this._primary()}_primary(){const M=this._peek();switch(M.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const X=this._expr();return this._consume(1,n),X}case 17:{const X=M.lexeme;if(this._advance(),this._matchOne(9)){const Ee=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Ee.type!==10)throw this._errExpectedButGot("REGEX",Ee);const Z=Ee.lexeme,ne=Z.lastIndexOf("/"),le=ne===Z.length-1?void 0:this._removeFlagsGY(Z.substring(ne+1));let te;try{te=new RegExp(Z.substring(1,ne),le)}catch{throw this._errExpectedButGot("REGEX",Ee)}return V.create(X,te)}switch(Ee.type){case 10:case 19:{const Z=[Ee.lexeme];this._advance();let ne=this._peek(),le=0;for(let O=0;O<Ee.lexeme.length;O++)Ee.lexeme.charCodeAt(O)===40?le++:Ee.lexeme.charCodeAt(O)===41&&le--;for(;!this._isAtEnd()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let O=0;O<ne.lexeme.length;O++)ne.lexeme.charCodeAt(O)===40?le++:Ee.lexeme.charCodeAt(O)===41&&le--}if(le<0)break;Z.push(l.Scanner.getLexeme(ne)),this._advance(),ne=this._peek()}const te=Z.join(""),de=te.lastIndexOf("/"),oe=de===te.length-1?void 0:this._removeFlagsGY(te.substring(de+1));let ue;try{ue=new RegExp(te.substring(1,de),oe)}catch{throw this._errExpectedButGot("REGEX",Ee)}return t.regex(X,ue)}case 18:{const Z=Ee.lexeme;this._advance();let ne=null;if(!(0,A.isFalsyOrWhitespace)(Z)){const le=Z.indexOf("/"),te=Z.lastIndexOf("/");if(le!==te&&le>=0){const de=Z.slice(le+1,te),oe=Z[te+1]==="i"?"i":"";try{ne=new RegExp(de,oe)}catch{throw this._errExpectedButGot("REGEX",Ee)}}}if(ne===null)throw this._errExpectedButGot("REGEX",Ee);return V.create(X,ne)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,v);const Ee=this._value();return t.notIn(X,Ee)}switch(this._peek().type){case 3:{this._advance();const Ee=this._value();if(this._previous().type===18)return t.equals(X,Ee);switch(Ee){case"true":return t.has(X);case"false":return t.not(X);default:return t.equals(X,Ee)}}case 4:{this._advance();const Ee=this._value();if(this._previous().type===18)return t.notEquals(X,Ee);switch(Ee){case"true":return t.not(X);case"false":return t.has(X);default:return t.notEquals(X,Ee)}}case 5:return this._advance(),B.create(X,this._value());case 6:return this._advance(),N.create(X,this._value());case 7:return this._advance(),U.create(X,this._value());case 8:return this._advance(),$.create(X,this._value());case 13:return this._advance(),t.in(X,this._value());default:return t.has(X)}}case 20:throw this._parsingErrors.push({message:w,offset:M.offset,lexeme:"",additionalInfo:E}),p._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const M=this._peek();switch(M.type){case 17:case 18:return this._advance(),M.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(M){return M.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(M){return this._check(M)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(M,X){if(this._check(M))return this._advance();throw this._errExpectedButGot(X,this._peek())}_errExpectedButGot(M,X,fe){const Ee=(0,R.localize)(8,null,M,l.Scanner.getLexeme(X)),Z=X.offset,ne=l.Scanner.getLexeme(X);return this._parsingErrors.push({message:Ee,offset:Z,lexeme:ne,additionalInfo:fe}),p._parseError}_check(M){return this._peek().type===M}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=p,p._parseError=new Error;class t{static false(){return f.INSTANCE}static true(){return b.INSTANCE}static has(M){return u.create(M)}static equals(M,X){return C.create(M,X)}static notEquals(M,X){return i.create(M,X)}static regex(M,X){return V.create(M,X)}static in(M,X){return y.create(M,X)}static notIn(M,X){return o.create(M,X)}static not(M){return I.create(M)}static and(...M){return ee.create(M,null,!0)}static or(...M){return se.create(M,null,!0)}static greater(M,X){return U.create(M,X)}static greaterEquals(M,X){return $.create(M,X)}static smaller(M,X){return B.create(M,X)}static smallerEquals(M,X){return N.create(M,X)}static deserialize(M){return M==null?void 0:this._parser.parse(M)}}e.ContextKeyExpr=t,t._parser=new p({regexParsingWithErrorRecovery:!1});function a(ve){const M=new p({regexParsingWithErrorRecovery:!1});return ve.map(X=>(M.parse(X),M.lexingErrors.length>0?M.lexingErrors.map(fe=>({errorMessage:fe.additionalInfo?(0,R.localize)(9,null,fe.additionalInfo):(0,R.localize)(10,null),offset:fe.offset,length:fe.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(fe=>({errorMessage:fe.additionalInfo?`${fe.message}. ${fe.additionalInfo}`:fe.message,offset:fe.offset,length:fe.lexeme.length})):[]))}e.validateWhenClauses=a;function r(ve,M){const X=ve?ve.substituteConstants():void 0,fe=M?M.substituteConstants():void 0;return!X&&!fe?!0:!X||!fe?!1:X.equals(fe)}e.expressionsAreEqualWithConstantSubstitution=r;function s(ve,M){return ve.cmp(M)}class f{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class b{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class u{static create(M,X=null){const fe=_.get(M);return typeof fe=="boolean"?fe?b.INSTANCE:f.INSTANCE:new u(M,X)}constructor(M,X){this.key=M,this.negated=X,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:J(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=_.get(this.key);return typeof M=="boolean"?M?b.INSTANCE:f.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class C{static create(M,X,fe=null){if(typeof X=="boolean")return X?u.create(M,fe):I.create(M,fe);const Ee=_.get(M);return typeof Ee=="boolean"?X===(Ee?"true":"false")?b.INSTANCE:f.INSTANCE:new C(M,X,fe)}constructor(M,X,fe){this.key=M,this.value=X,this.negated=fe,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:j(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){const M=_.get(this.key);if(typeof M=="boolean"){const X=M?"true":"false";return this.value===X?b.INSTANCE:f.INSTANCE}return this}evaluate(M){return M.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(M){return M.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class y{static create(M,X){return new y(M,X)}constructor(M,X){this.key=M,this.valueKey=X,this.type=10,this.negated=null}cmp(M){return M.type!==this.type?this.type-M.type:j(this.key,this.valueKey,M.key,M.valueKey)}equals(M){return M.type===this.type?this.key===M.key&&this.valueKey===M.valueKey:!1}substituteConstants(){return this}evaluate(M){const X=M.getValue(this.valueKey),fe=M.getValue(this.key);return Array.isArray(X)?X.includes(fe):typeof fe=="string"&&typeof X=="object"&&X!==null?T.call(X,fe):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(M){return M.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=o.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=y;class o{static create(M,X){return new o(M,X)}constructor(M,X){this.key=M,this.valueKey=X,this.type=11,this._negated=y.create(M,X)}cmp(M){return M.type!==this.type?this.type-M.type:this._negated.cmp(M._negated)}equals(M){return M.type===this.type?this._negated.equals(M._negated):!1}substituteConstants(){return this}evaluate(M){return!this._negated.evaluate(M)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(M){return M.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=o;class i{static create(M,X,fe=null){if(typeof X=="boolean")return X?I.create(M,fe):u.create(M,fe);const Ee=_.get(M);return typeof Ee=="boolean"?X===(Ee?"true":"false")?f.INSTANCE:b.INSTANCE:new i(M,X,fe)}constructor(M,X,fe){this.key=M,this.value=X,this.negated=fe,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:j(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){const M=_.get(this.key);if(typeof M=="boolean"){const X=M?"true":"false";return this.value===X?f.INSTANCE:b.INSTANCE}return this}evaluate(M){return M.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(M){return M.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=i;class I{static create(M,X=null){const fe=_.get(M);return typeof fe=="boolean"?fe?f.INSTANCE:b.INSTANCE:new I(M,X)}constructor(M,X){this.key=M,this.negated=X,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:J(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=_.get(this.key);return typeof M=="boolean"?M?f.INSTANCE:b.INSTANCE:this}evaluate(M){return!M.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(M){return M.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=I;function F(ve,M){if(typeof ve=="string"){const X=parseFloat(ve);isNaN(X)||(ve=X)}return typeof ve=="string"||typeof ve=="number"?M(ve):f.INSTANCE}class U{static create(M,X,fe=null){return F(X,Ee=>new U(M,Ee,fe))}constructor(M,X,fe){this.key=M,this.value=X,this.negated=fe,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:j(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(M){return M.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=U;class ${static create(M,X,fe=null){return F(X,Ee=>new $(M,Ee,fe))}constructor(M,X,fe){this.key=M,this.value=X,this.negated=fe,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:j(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(M){return M.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=$;class B{static create(M,X,fe=null){return F(X,Ee=>new B(M,Ee,fe))}constructor(M,X,fe){this.key=M,this.value=X,this.negated=fe,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:j(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(M){return M.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=B;class N{static create(M,X,fe=null){return F(X,Ee=>new N(M,Ee,fe))}constructor(M,X,fe){this.key=M,this.value=X,this.negated=fe,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:j(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(M){return M.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class V{static create(M,X){return new V(M,X)}constructor(M,X){this.key=M,this.regexp=X,this.type=7,this.negated=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.key<M.key)return-1;if(this.key>M.key)return 1;const X=this.regexp?this.regexp.source:"",fe=M.regexp?M.regexp.source:"";return X<fe?-1:X>fe?1:0}equals(M){if(M.type===this.type){const X=this.regexp?this.regexp.source:"",fe=M.regexp?M.regexp.source:"";return this.key===M.key&&X===fe}return!1}substituteConstants(){return this}evaluate(M){const X=M.getValue(this.key);return this.regexp?this.regexp.test(X):!1}serialize(){const M=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${M}`}keys(){return[this.key]}map(M){return M.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=x.create(this)),this.negated}}e.ContextKeyRegexExpr=V;class x{static create(M){return new x(M)}constructor(M){this._actual=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this._actual.cmp(M._actual)}equals(M){return M.type===this.type?this._actual.equals(M._actual):!1}substituteConstants(){return this}evaluate(M){return!this._actual.evaluate(M)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(M){return new x(this._actual.map(M))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=x;function W(ve){let M=null;for(let X=0,fe=ve.length;X<fe;X++){const Ee=ve[X].substituteConstants();if(ve[X]!==Ee&&M===null){M=[];for(let Z=0;Z<X;Z++)M[Z]=ve[Z]}M!==null&&(M[X]=Ee)}return M===null?ve:M}class ee{static create(M,X,fe){return ee._normalizeArr(M,X,fe)}constructor(M,X){this.expr=M,this.negated=X,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let X=0,fe=this.expr.length;X<fe;X++){const Ee=s(this.expr[X],M.expr[X]);if(Ee!==0)return Ee}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let X=0,fe=this.expr.length;X<fe;X++)if(!this.expr[X].equals(M.expr[X]))return!1;return!0}return!1}substituteConstants(){const M=W(this.expr);return M===this.expr?this:ee.create(M,this.negated,!1)}evaluate(M){for(let X=0,fe=this.expr.length;X<fe;X++)if(!this.expr[X].evaluate(M))return!1;return!0}static _normalizeArr(M,X,fe){const Ee=[];let Z=!1;for(const ne of M)if(ne){if(ne.type===1){Z=!0;continue}if(ne.type===0)return f.INSTANCE;if(ne.type===6){Ee.push(...ne.expr);continue}Ee.push(ne)}if(Ee.length===0&&Z)return b.INSTANCE;if(Ee.length!==0){if(Ee.length===1)return Ee[0];Ee.sort(s);for(let ne=1;ne<Ee.length;ne++)Ee[ne-1].equals(Ee[ne])&&(Ee.splice(ne,1),ne--);if(Ee.length===1)return Ee[0];for(;Ee.length>1;){const ne=Ee[Ee.length-1];if(ne.type!==9)break;Ee.pop();const le=Ee.pop(),te=Ee.length===0,de=se.create(ne.expr.map(oe=>ee.create([oe,le],null,fe)),null,te);de&&(Ee.push(de),Ee.sort(s))}if(Ee.length===1)return Ee[0];if(fe){for(let ne=0;ne<Ee.length;ne++)for(let le=ne+1;le<Ee.length;le++)if(Ee[ne].negate().equals(Ee[le]))return f.INSTANCE;if(Ee.length===1)return Ee[0]}return new ee(Ee,X)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const X of this.expr)M.push(...X.keys());return M}map(M){return new ee(this.expr.map(X=>X.map(M)),null)}negate(){if(!this.negated){const M=[];for(const X of this.expr)M.push(X.negate());this.negated=se.create(M,this,!0)}return this.negated}}e.ContextKeyAndExpr=ee;class se{static create(M,X,fe){return se._normalizeArr(M,X,fe)}constructor(M,X){this.expr=M,this.negated=X,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let X=0,fe=this.expr.length;X<fe;X++){const Ee=s(this.expr[X],M.expr[X]);if(Ee!==0)return Ee}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let X=0,fe=this.expr.length;X<fe;X++)if(!this.expr[X].equals(M.expr[X]))return!1;return!0}return!1}substituteConstants(){const M=W(this.expr);return M===this.expr?this:se.create(M,this.negated,!1)}evaluate(M){for(let X=0,fe=this.expr.length;X<fe;X++)if(this.expr[X].evaluate(M))return!0;return!1}static _normalizeArr(M,X,fe){let Ee=[],Z=!1;if(M){for(let ne=0,le=M.length;ne<le;ne++){const te=M[ne];if(te){if(te.type===0){Z=!0;continue}if(te.type===1)return b.INSTANCE;if(te.type===9){Ee=Ee.concat(te.expr);continue}Ee.push(te)}}if(Ee.length===0&&Z)return f.INSTANCE;Ee.sort(s)}if(Ee.length!==0){if(Ee.length===1)return Ee[0];for(let ne=1;ne<Ee.length;ne++)Ee[ne-1].equals(Ee[ne])&&(Ee.splice(ne,1),ne--);if(Ee.length===1)return Ee[0];if(fe){for(let ne=0;ne<Ee.length;ne++)for(let le=ne+1;le<Ee.length;le++)if(Ee[ne].negate().equals(Ee[le]))return b.INSTANCE;if(Ee.length===1)return Ee[0]}return new se(Ee,X)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const X of this.expr)M.push(...X.keys());return M}map(M){return new se(this.expr.map(X=>X.map(M)),null)}negate(){if(!this.negated){const M=[];for(const X of this.expr)M.push(X.negate());for(;M.length>1;){const X=M.shift(),fe=M.shift(),Ee=[];for(const Z of _e(X))for(const ne of _e(fe))Ee.push(ee.create([Z,ne],null,!1));M.unshift(se.create(Ee,null,!1))}this.negated=se.create(M,this,!0)}return this.negated}}e.ContextKeyOrExpr=se;class H extends u{static all(){return H._info.values()}constructor(M,X,fe){super(M,null),this._defaultValue=X,typeof fe=="object"?H._info.push({...fe,key:M}):fe!==!0&&H._info.push({key:M,description:fe,type:X!=null?typeof X:void 0})}bindTo(M){return M.createKey(this.key,this._defaultValue)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return C.create(this.key,M)}notEqualsTo(M){return i.create(this.key,M)}}e.RawContextKey=H,H._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function J(ve,M){return ve<M?-1:ve>M?1:0}function j(ve,M,X,fe){return ve<X?-1:ve>X?1:M<fe?-1:M>fe?1:0}function ae(ve,M){if(ve.type===0||M.type===1)return!0;if(ve.type===9)return M.type===9?we(ve.expr,M.expr):!1;if(M.type===9){for(const X of M.expr)if(ae(ve,X))return!0;return!1}if(ve.type===6){if(M.type===6)return we(M.expr,ve.expr);for(const X of ve.expr)if(ae(X,M))return!0;return!1}return ve.equals(M)}e.implies=ae;function we(ve,M){let X=0,fe=0;for(;X<ve.length&&fe<M.length;){const Ee=ve[X].cmp(M[fe]);if(Ee<0)return!1;Ee===0&&X++,fe++}return X===ve.length}function _e(ve){return ve.type===9?ve.expr:[ve]}}),define(ye[214],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[124],Ce([1,0,179,5]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function R(d,w){switch(d){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":w==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function P(d,w){return w==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function _(d,w,E){return P(w,E)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===E?!0:g(E).includes(d)}e.isTargetPlatformCompatible=_;function g(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function T(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=T;var k;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var m;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var D;(function(d){d.Install="install",d.Uninstall="uninstall"})(D||(e.StatisticType=D={}));var S;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var v;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var n;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class h extends Error{constructor(w,E){super(w),this.code=E,this.name=E}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,c.localize)(1,null),original:"Preferences"}}),define(ye[215],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(ye[216],Ce([1,0,46,18,10,9,93,29,95,181,215]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=g.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends m{openTerminal(E,p){return this.spawnTerminal(c,E,_.getWindowsShell(),p)}spawnTerminal(E,p,t,a){const r=p.windowsExec||D.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=l.basename(r,".exe").toLowerCase();if(s==="cmder")return E.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const f=["/c","start","/wait"];return r.indexOf(" ")>=0&&f.push('""'),f.push(r),s==="wt"&&f.push("-d ."),new Promise((b,u)=>{const C=n(process),y=E.spawn(t,f,{cwd:a,env:C});y.on("error",u),y.on("exit",()=>b())})}runInTerminal(E,p,t,a,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:D.getDefaultTerminalWindows();return new Promise((f,b)=>{const u=`"${p} - ${k}"`,C=`""${t.join('" "')}" & pause"`,y=Object.assign({},n(process),a);Object.keys(y).filter(U=>y[U]===null).forEach(U=>delete y[U]);const o={cwd:p,env:y,windowsVerbatimArguments:!0};let i,I;l.basename(s,".exe")==="wt"?(i=s,I=["-d",".",D.CMD,"/c",C]):(i=D.CMD,I=["/c","start",u,"/wait",s,"/c",C]),c.spawn(i,I,o).on("error",U=>{b(h(U))}),f(void 0)})}static getDefaultTerminalWindows(){if(!D._DEFAULT_TERMINAL_WINDOWS){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return D._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=D,D.CMD="cmd.exe";class S extends m{openTerminal(E,p){return this.spawnTerminal(c,E,p)}runInTerminal(E,p,t,a,r){const s=r.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((f,b)=>{if(s===T.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const u=s===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`).fsPath,"-t",E||k,"-w",p];for(const I of t)y.push("-a"),y.push(I);if(a){const I=Object.assign({},n(process),a);for(const F in I){const U=I[F];U===null?(y.push("-u"),y.push(F)):(y.push("-e"),y.push(`${F}=${U}`))}}let o="";const i=c.spawn(S.OSASCRIPT,y);i.on("error",I=>{b(h(I))}),i.stderr.on("data",I=>{o+=I.toString()}),i.on("exit",I=>{if(I===0)f(void 0);else if(o){const F=o.split(`
`,1);b(new Error(F[0]))}else b(new Error(g.localize(1,null,u,I)))})}else b(new Error(g.localize(2,null,s)))})}spawnTerminal(E,p,t){const a=p.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const f=["-a",a];t&&f.push(t);const b=n(process),u=E.spawn("/usr/bin/open",f,{cwd:t,env:b});u.on("error",s),u.on("exit",()=>r())})}}e.MacExternalTerminalService=S,S.OSASCRIPT="/usr/bin/osascript";class v extends m{openTerminal(E,p){return this.spawnTerminal(c,E,p)}runInTerminal(E,p,t,a,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((f,b)=>{const u=[];s.then(C=>{C.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const y=`${d(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;u.push(`''${y}''`);const o=Object.assign({},n(process),a);Object.keys(o).filter(U=>o[U]===null).forEach(U=>delete o[U]);const i={cwd:p,env:o};let I="";const F=c.spawn(C,u,i);F.on("error",U=>{b(h(U))}),F.stderr.on("data",U=>{I+=U.toString()}),F.on("exit",U=>{if(U===0)f(void 0);else if(I){const $=I.split(`
`,1);b(new Error($[0]))}else b(new Error(g.localize(4,null,C,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{E?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(E,p,t){const a=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{a.then(f=>{const b=n(process),u=E.spawn(f,[],{cwd:t,env:b});u.on("error",s),u.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=g.localize(3,null);function n(w){const E={...w.env};return(0,R.sanitizeProcessEnvironment)(E),E}function h(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(g.localize(5,null,w.path)):w}function d(w){let E="";for(const p of w)p.indexOf(" ")>=0?E+='"'+p+'"':E+=p,E+=" ";return E}}),define(ye[31],Ce([1,0,72,10,11,12,2,182,5,9,18]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function k(H){return H.create===!0}e.isFileOpenForWriteOptions=k;var m;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var D;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(D||(e.FilePermission=D={}));var S;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(S||(e.FileSystemProviderCapabilities=S={}));function v(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=v;function n(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=n;function h(H){return!!(H.capabilities&131072)}e.hasFileCloneCapability=h;function d(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function w(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=w;function E(H){return v(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;function p(H){return v(H)?!!(H.capabilities&32768):!1}e.hasFileAtomicWriteCapability=p;function t(H){return!!(H.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class r extends Error{static create(J,j){const ae=new r(J.toString(),j);return b(ae,j),ae}constructor(J,j){super(J),this.code=j}}e.FileSystemProviderError=r;function s(H,J){return r.create(H,J)}e.createFileSystemProviderError=s;function f(H){return H||s((0,P.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=f;function b(H,J){return H.name=J?`${J} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=b;function u(H){if(!H)return a.Unknown;if(H instanceof r)return H.code;const J=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!J)return a.Unknown;switch(J[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=u;function C(H){if(H instanceof U)return H.fileOperationResult;switch(u(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=C;var y;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(y||(e.FileOperation=y={}));class o{constructor(J,j,ae){this.resource=J,this.operation=j,this.target=ae}isOperation(J){return this.operation===J}}e.FileOperationEvent=o;var i;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(i||(e.FileChangeType=i={}));class I{constructor(J,j){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const we of J){const _e=ae.get(we.type);switch(_e?_e.push([we.resource,we]):ae.set(we.type,[[we.resource,we]]),we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}}for(const[we,_e]of ae)switch(we){case 1:this.added=c.TernarySearchTree.forUris(()=>j),this.added.fill(_e);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>j),this.updated.fill(_e);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>j),this.deleted.fill(_e);break}}contains(J,...j){return this.doContains(J,{includeChildren:!1},...j)}affects(J,...j){return this.doContains(J,{includeChildren:!0},...j)}doContains(J,j,...ae){if(!J)return!1;const we=ae.length>0;return!!((!we||ae.includes(1))&&(this.added?.get(J)||j.includeChildren&&this.added?.findSuperstr(J))||(!we||ae.includes(0))&&(this.updated?.get(J)||j.includeChildren&&this.updated?.findSuperstr(J))||(!we||ae.includes(2))&&(this.deleted?.findSubstr(J)||j.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=I;function F(H,J,j){return!H||!J||H===J||J.length>H.length?!1:(J.charAt(J.length-1)!==A.sep&&(J+=A.sep),j?(0,l.startsWithIgnoreCase)(H,J):H.indexOf(J)===0)}e.isParent=F;class U extends Error{constructor(J,j,ae){super(J),this.fileOperationResult=j,this.options=ae}}e.FileOperationError=U;class $ extends U{constructor(J,j,ae,we){super(J,j,we),this.fileOperationResult=j,this.size=ae}}e.TooLargeFileOperationError=$;class B extends U{constructor(J,j,ae){super(J,2,ae),this.stat=j}}e.NotModifiedSinceFileOperationError=B;var N;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function x(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=x;async function W(H,J){if(!J.hasProvider(R.URI.from({scheme:H.scheme})))return new Promise(j=>{const ae=J.onDidChangeFileSystemProviderRegistrations(we=>{we.scheme===H.scheme&&we.added&&(ae.dispose(),j())})})}e.whenProviderRegistered=W;class ee{static formatSize(J){return(0,L.isNumber)(J)||(J=0),J<ee.KB?(0,P.localize)(1,null,J.toFixed(0)):J<ee.MB?(0,P.localize)(2,null,(J/ee.KB).toFixed(2)):J<ee.GB?(0,P.localize)(3,null,(J/ee.MB).toFixed(2)):J<ee.TB?(0,P.localize)(4,null,(J/ee.GB).toFixed(2)):(0,P.localize)(5,null,(J/ee.TB).toFixed(2))}}e.ByteSize=ee,ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB;function se(H){const J=typeof H=="string"||H?.scheme===T.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===T.Schemas.file?1024*ee.MB:J?10*ee.MB:g.isWeb?50*ee.MB:1024*ee.MB}e.getLargeFileConfirmationLimit=se}),define(ye[217],Ce([1,0,21,8,183,31]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(T,k,m,D,S,v){let n;try{await P(T,k,m,D,S,v)}catch(h){n=h}finally{n&&S.errorTransformer&&(n=S.errorTransformer(n)),typeof n<"u"&&m.error(n),m.end()}}e.readFileIntoStream=R;async function P(T,k,m,D,S,v){_(v);const n=await T.open(k,{create:!1});try{_(v);let h=0,d=0,w=S&&typeof S.length=="number"?S.length:void 0,E=c.VSBuffer.alloc(Math.min(S.bufferSize,typeof w=="number"?w:S.bufferSize)),p=S&&typeof S.position=="number"?S.position:0,t=0;do d=await T.read(n,p,E.buffer,t,E.byteLength-t),p+=d,t+=d,h+=d,typeof w=="number"&&(w-=d),t===E.byteLength&&(await m.write(D(E)),E=c.VSBuffer.alloc(Math.min(S.bufferSize,typeof w=="number"?w:S.bufferSize)),t=0);while(d>0&&(typeof w!="number"||w>0)&&_(v)&&g(h,S));if(t>0){let a=t;typeof w=="number"&&(a=Math.min(t,w)),m.write(D(E.slice(0,a)))}}catch(h){throw(0,L.ensureFileSystemProviderError)(h)}finally{await T.close(n)}}function _(T){if(T.isCancellationRequested)throw(0,A.canceled)();return!0}function g(T,k){if(typeof k?.limits?.size=="number"&&T>k.limits.size)throw(0,L.createFileSystemProviderError)((0,l.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[77],Ce([1,0,33,4,10,9,2,31]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function _(h){return h.recursive===!0}e.isRecursiveWatchRequest=_;class g extends A.Disposable{constructor(d,w,E,p){super(),this.onFileChanges=d,this.onLogMessage=w,this.verboseLogging=E,this.options=p,this.watcherDisposables=this._register(new A.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new A.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(w=>this.onFileChanges(w))),d.add(this.watcher.onDidLogMessage(w=>this.onLogMessage(w))),d.add(this.watcher.onDidError(w=>this.onError(w)))}onError(d){this.options.restartOnError?this.restartCounter<g.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=g,g.MAX_RESTARTS=5;class T extends g{constructor(d,w,E){super(d,w,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class k extends g{constructor(d,w,E){super(d,w,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function m(h){return h.map(d=>({type:d.type,resource:R.URI.file(d.path)}))}e.toFileChanges=m;function D(h){const d=new n;for(const w of h)d.processEvent(w);return d.coalesce()}e.coalesceEvents=D;function S(h,d){return typeof d=="string"&&!d.startsWith(c.GLOBSTAR)&&!(0,l.isAbsolute)(d)?{base:h,pattern:d}:d}e.normalizeWatcherPattern=S;function v(h,d){const w=[];for(const E of d)w.push((0,c.parse)(S(h,E)));return w}e.parseWatcherPatterns=v;class n{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return L.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const w=this.mapPathToChange.get(this.toKey(d));let E=!1;if(w){const p=w.type,t=d.type;w.path!==d.path&&(d.type===2||d.type===1)?E=!0:p===1&&t===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(w)):p===2&&t===1?w.type=0:p===1&&t===0||(w.type=t)}else E=!0;E&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],w=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(d.push(E),!1):!0).sort((E,p)=>E.path.length-p.path.length).filter(E=>w.some(p=>(0,P.isParent)(E.path,p,!L.isLinux))?!1:(w.push(E.path),!0)).concat(d)}}}),define(ye[218],Ce([1,0,48,16,22,30,4,69,10,9,94,29,77]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class D extends R.Disposable{constructor(n,h,d,w){super(),this.request=n,this.onDidFilesChange=h,this.onLogMessage=d,this.verboseLogging=w,this.throttledFileChangesEmitter=this._register(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.onDidFilesChange(E))),this.fileChangesAggregator=this._register(new A.RunOnceWorker(E=>this.handleFileChanges(E),D.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new l.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const n=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await k.Promises.stat(n);this._register(await this.doWatch(n,h.isDirectory()))}catch(n){n.code!=="ENOENT"?this.error(n):this.trace(n)}}async normalizePath(n){let h=n.path;try{h=await k.Promises.realpath(n.path),n.path===h&&(h=await(0,T.realcase)(n.path)??n.path),n.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${h})`)}catch{}return h}async doWatch(n,h){if(g.isMacintosh&&(0,L.isEqualOrParent)(n,"/Volumes/",!0))return this.error(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const d=new l.CancellationTokenSource(this.cts.token),w=new R.DisposableStore;try{const E=(0,_.basename)(n),p=(0,c.watch)(n);w.add((0,R.toDisposable)(()=>{p.removeAllListeners(),p.close()})),this.trace(`Started watching: '${n}'`);const t=new Set;if(h)try{for(const r of await k.Promises.readdir(n))t.add(r)}catch(r){this.error(r)}const a=new Map;w.add((0,R.toDisposable)(()=>{for(const[,r]of a)r.dispose();a.clear()})),p.on("error",(r,s)=>{this.error(`Failed to watch ${n} for changes using fs.watch() (${r}, ${s})`),this.dispose()}),p.on("change",(r,s)=>{if(d.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${s}`);let f="";if(s&&(f=s.toString(),g.isMacintosh&&(f=(0,P.normalizeNFC)(f))),!(!f||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){a.get(f)?.dispose();const b=setTimeout(async()=>{if(a.delete(f),f===E&&!await k.Promises.exists(n)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,_.join)(n,f));if(d.token.isCancellationRequested)return;let C;u?t.has(f)?C=0:(C=1,t.add(f)):(t.delete(f),C=2),this.onFileChange({path:(0,_.join)(this.request.path,f),type:C})},D.FILE_DELETE_HANDLER_DELAY);a.set(f,(0,R.toDisposable)(()=>clearTimeout(b)))}else{let b;t.has(f)?b=0:(b=1,t.add(f)),this.onFileChange({path:(0,_.join)(this.request.path,f),type:b})}else if(r==="rename"||f!==E){const b=setTimeout(async()=>{const u=await k.Promises.exists(n);d.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),w.add(await this.doWatch(n,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},D.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,R.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(E){await k.Promises.exists(n)&&!d.token.isCancellationRequested&&this.error(`Failed to watch ${n} for changes using fs.watch() (${E.toString()})`)}return(0,R.toDisposable)(()=>{d.dispose(!0),w.dispose()})}onFileChange(n,h=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.path}`),!h&&this.excludes.some(d=>d(n.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${n.path}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(d=>d(n.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${n.path}`):this.fileChangesAggregator.work(n))}handleFileChanges(n){const h=(0,m.coalesceEvents)(n);if(h.length>0){if(this.verboseLogging)for(const w of h)this.trace(`>> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`);this.throttledFileChangesEmitter.work(h)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(n){if(g.isLinux)return k.Promises.exists(n);try{const h=(0,_.basename)(n);return(await k.Promises.readdir((0,_.dirname)(n))).some(w=>w===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(n){this.verboseLogging=n}error(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}warn(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}trace(n){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=D,D.FILE_DELETE_HANDLER_DELAY=100,D.FILE_CHANGES_HANDLER_DELAY=75;async function S(v,n,h,d,w=512){const E=await k.Promises.open(v,"r"),p=Buffer.allocUnsafe(w),t=new l.CancellationTokenSource(d);let a,r=!1;const s={path:v,excludes:[],recursive:!1},f=new D(s,b=>{(async()=>{for(const{type:u}of b)if(u===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:C}=await k.Promises.read(E,p,0,w,null);if(!C||t.token.isCancellationRequested)break;n(p.slice(0,C))}}catch(C){a=new Error(C),t.dispose(!0)}finally{r=!1}}})()});return await f.ready,h(),new Promise((b,u)=>{t.token.onCancellationRequested(async()=>{f.dispose();try{await k.Promises.close(E)}catch(C){a=new Error(C)}a?u(a):b()})})}e.watchFileContents=S}),define(ye[219],Ce([1,0,3,33,4,9,218]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends l.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new c.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new c.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=c.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(g){const T=this.normalizeRequests(g),k=T.filter(D=>{const S=this.watchers.get(D.path);return S?!(0,A.patternsEquals)(S.request.excludes,D.excludes)||!(0,A.patternsEquals)(S.request.includes,D.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:D})=>!T.find(S=>S.path===D.path&&(0,A.patternsEquals)(S.excludes,D.excludes)&&(0,A.patternsEquals)(S.includes,D.includes))).map(({request:D})=>D.path);k.length&&this.trace(`Request to start watching: ${k.map(D=>`${D.path} (excludes: ${D.excludes.length>0?D.excludes:"<none>"}, includes: ${D.includes&&D.includes.length>0?JSON.stringify(D.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const D of m)this.stopWatching(D);for(const D of k)this.startWatching(D)}startWatching(g){const T=new R.NodeJSFileWatcherLibrary(g,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),k={request:g,instance:T};this.watchers.set(g.path,k)}async stop(){for(const[g]of this.watchers)this.stopWatching(g);this.watchers.clear()}stopWatching(g){const T=this.watchers.get(g);T&&(this.watchers.delete(g),T.instance.dispose())}normalizeRequests(g){const T=new Map;for(const k of g){const m=L.isLinux?k.path:k.path.toLowerCase();T.set(m,k)}return Array.from(T.values())}async setVerboseLogging(g){this.verboseLogging=g;for(const[,T]of this.watchers)T.instance.setVerboseLogging(g)}trace(g){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(g)})}toMessage(g,T){return T?`[File Watcher (node.js)] ${g} (path: ${T.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=P}),define(ye[220],Ce([1,0,77,219]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends c.AbstractNonRecursiveWatcherClient{constructor(R,P,_){super(R,P,_),this.init()}createWatcher(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(ye[221],Ce([1,0,18,75,170,77]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends L.AbstractUniversalWatcherClient{constructor(_,g,T){super(_,g,T),this.init()}createWatcher(_){const g=_.add(new l.Client(c.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return _.add(g.onDidProcessExit(({code:T,signal:k})=>this.onError(`terminated by itself with code ${T}, signal: ${k}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ye[98],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...l){this._entries=new Map;for(const[L,R]of l)this.set(L,R)}set(l,L){const R=this._entries.get(l);return this._entries.set(l,L),R}has(l){return this._entries.has(l)}get(l){return this._entries.get(l)}}e.ServiceCollection=c}),define(ye[222],Ce([1,0,16,8,4,96,213,5,98,68]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class k extends Error{constructor(n){super("cyclic dependency between services"),this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class m{constructor(n=new _.ServiceCollection,h=!1,d,w=T){this._services=n,this._strict=h,this._parent=d,this._enableTracing=w,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=w?d?._globalGraph??new R.Graph(E=>E):void 0}createChild(n){return new m(n,this._strict,this,this._enableTracing)}invokeFunction(n,...h){const d=S.traceInvocation(this._enableTracing,n);let w=!1;try{return n({get:p=>{if(w)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(p,d);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...h)}finally{w=!0,d.stop()}}createInstance(n,...h){let d,w;return n instanceof L.SyncDescriptor?(d=S.traceCreation(this._enableTracing,n.ctor),w=this._createInstance(n.ctor,n.staticArguments.concat(h),d)):(d=S.traceCreation(this._enableTracing,n),w=this._createInstance(n,h,d)),d.stop(),w}_createInstance(n,h=[],d){const w=P._util.getServiceDependencies(n).sort((t,a)=>t.index-a.index),E=[];for(const t of w){const a=this._getOrCreateServiceInstance(t.id,d);a||this._throwIfStrict(`[createInstance] ${n.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(a)}const p=w.length>0?w[0].index:h.length;if(h.length!==p){console.trace(`[createInstance] First service dependency of ${n.name} at position ${p+1} conflicts with ${h.length} static arguments`);const t=p-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,p)}return Reflect.construct(n,h.concat(E))}_setServiceInstance(n,h){if(this._services.get(n)instanceof L.SyncDescriptor)this._services.set(n,h);else if(this._parent)this._parent._setServiceInstance(n,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(n){const h=this._services.get(n);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(n):h}_getOrCreateServiceInstance(n,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(n));const d=this._getServiceInstanceOrDescriptor(n);return d instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(n,d,h.branch(n,!0)):(h.branch(n,!1),d)}_safeCreateAndCacheServiceInstance(n,h,d){if(this._activeInstantiations.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this._activeInstantiations.add(n);try{return this._createAndCacheServiceInstance(n,h,d)}finally{this._activeInstantiations.delete(n)}}_createAndCacheServiceInstance(n,h,d){const w=new R.Graph(t=>t.id.toString());let E=0;const p=[{id:n,desc:h,_trace:d}];for(;p.length;){const t=p.pop();if(w.lookupOrInsertNode(t),E++>1e3)throw new k(w);for(const a of P._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(a.id);if(r||this._throwIfStrict(`[createInstance] ${n} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),r instanceof L.SyncDescriptor){const s={id:a.id,desc:r,_trace:t._trace.branch(a.id,!0)};w.insertEdge(t,s),p.push(s)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:a}of t){if(this._getServiceInstanceOrDescriptor(a.id)instanceof L.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}w.removeNode(a)}}return this._getServiceInstanceOrDescriptor(n)}_createServiceInstanceWithOwner(n,h,d=[],w,E){if(this._services.get(n)instanceof L.SyncDescriptor)return this._createServiceInstance(n,h,d,w,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(n,h,d,w,E);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(n,h,d=[],w,E){if(w){const p=new m(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(n);const t=new Map,a=new c.IdleValue(()=>{const r=p._createInstance(h,d,E);for(const[s,f]of t){const b=r[s];if(typeof b=="function")for(const u of f)b.apply(r,u)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let u=t.get(s);return u||(u=new g.LinkedList,t.set(s,u)),(y,o,i)=>{const I=u.push([y,o,i]);return(0,l.toDisposable)(I)}}if(s in r)return r[s];const f=a.value;let b=f[s];return typeof b!="function"||(b=b.bind(f),r[s]=b),b},set(r,s,f){return a.value[s]=f,!0},getPrototypeOf(r){return h.prototype}})}else return this._createInstance(h,d,E)}_throwIfStrict(n,h){if(h&&console.warn(n),this._strict)throw new Error(n)}}e.InstantiationService=m;var D;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(D||(D={}));class S{static traceInvocation(n,h){return n?new S(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(n,h){return n?new S(1,h.name):S._None}constructor(n,h){this.type=n,this.name=h,this._start=Date.now(),this._dep=[]}branch(n,h){const d=new S(3,n.toString());return this._dep.push([n,h,d]),d}stop(){const n=Date.now()-this._start;S._totals+=n;let h=!1;function d(E,p){const t=[],a=new Array(E+1).join("	");for(const[r,s,f]of p._dep)if(s&&f){h=!0,t.push(`${a}CREATES -> ${r}`);const b=d(E+1,f);b&&t.push(b)}else t.push(`${a}uses -> ${r}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(n>2||h)&&S.all.add(w.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}},S._totals=0}),define(ye[17],Ce([1,0,45,3,71,4,28,9,24,12,2,47,5]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function D(){return new Date().toISOString()}function S(y){return(0,g.isNumber)(y)}e.isLogLevel=S;var v;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function n(y,o,i){switch(o){case v.Trace:y.trace(i);break;case v.Debug:y.debug(i);break;case v.Info:y.info(i);break;case v.Warning:y.warn(i);break;case v.Error:y.error(i);break;case v.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=n;function h(y,o=!1){let i="";for(let I=0;I<y.length;I++){let F=y[I];if(F instanceof Error&&(F=(0,c.toErrorMessage)(F,o)),typeof F=="object")try{F=JSON.stringify(F)}catch{}i+=(I>0?" ":"")+F}return i}class d extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(o){return this.level!==v.Off&&this.level<=o}}e.AbstractLogger=d;class w extends d{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||super.checkLogLevel(o)}trace(o,...i){this.checkLogLevel(v.Trace)&&this.log(v.Trace,h([o,...i],!0))}debug(o,...i){this.checkLogLevel(v.Debug)&&this.log(v.Debug,h([o,...i]))}info(o,...i){this.checkLogLevel(v.Info)&&this.log(v.Info,h([o,...i]))}warn(o,...i){this.checkLogLevel(v.Warning)&&this.log(v.Warning,h([o,...i]))}error(o,...i){if(this.checkLogLevel(v.Error))if(o instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=o.stack,this.log(v.Error,h(I))}else this.log(v.Error,h([o,...i]))}flush(){}}e.AbstractMessageLogger=w;class E extends d{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!P.isWindows}trace(o,...i){this.checkLogLevel(v.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,o,...i):console.log(`[main ${D()}]`,o,...i))}debug(o,...i){this.checkLogLevel(v.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,o,...i):console.log(`[main ${D()}]`,o,...i))}info(o,...i){this.checkLogLevel(v.Info)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,o,...i):console.log(`[main ${D()}]`,o,...i))}warn(o,...i){this.checkLogLevel(v.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,o,...i):console.warn(`[main ${D()}]`,o,...i))}error(o,...i){this.checkLogLevel(v.Error)&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,o,...i):console.error(`[main ${D()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class p extends d{constructor(o=e.DEFAULT_LOG_LEVEL,i=!0){super(),this.useColors=i,this.setLevel(o)}trace(o,...i){this.checkLogLevel(v.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",o,...i):console.log(o,...i))}debug(o,...i){this.checkLogLevel(v.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",o,...i):console.log(o,...i))}info(o,...i){this.checkLogLevel(v.Info)&&(this.useColors?console.log("%c INFO","color: #33f",o,...i):console.log(o,...i))}warn(o,...i){this.checkLogLevel(v.Warning)&&(this.useColors?console.log("%c WARN","color: #993",o,...i):console.log(o,...i))}error(o,...i){this.checkLogLevel(v.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",o,...i):console.error(o,...i))}dispose(){}flush(){}}e.ConsoleLogger=p;class t extends d{constructor(o,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(i)}trace(o,...i){this.checkLogLevel(v.Trace)&&this.adapter.log(v.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.checkLogLevel(v.Debug)&&this.adapter.log(v.Debug,[this.extractMessage(o),...i])}info(o,...i){this.checkLogLevel(v.Info)&&this.adapter.log(v.Info,[this.extractMessage(o),...i])}warn(o,...i){this.checkLogLevel(v.Warning)&&this.adapter.log(v.Warning,[this.extractMessage(o),...i])}error(o,...i){this.checkLogLevel(v.Error)&&this.adapter.log(v.Error,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,c.toErrorMessage)(o,this.checkLogLevel(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends d{constructor(o){super(),this.loggers=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.loggers)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const I of this.loggers)I.trace(o,...i)}debug(o,...i){for(const I of this.loggers)I.debug(o,...i)}info(o,...i){for(const I of this.loggers)I.info(o,...i)}warn(o,...i){for(const I of this.loggers)I.warn(o,...i)}error(o,...i){for(const I of this.loggers)I.error(o,...i)}flush(){for(const o of this.loggers)o.flush()}dispose(){for(const o of this.loggers)o.dispose()}}e.MultiplexLogger=a;class r extends L.Disposable{constructor(o,i,I){if(super(),this.logLevel=o,this.logsHome=i,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new A.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,I)for(const F of I)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(o){return(0,g.isString)(o)?[...this._loggers.values()].find(i=>i.info.id===o):this._loggers.get(o)}getLogger(o){return this.getLoggerEntry(o)?.logger}createLogger(o,i){const I=this.toResource(o),F=(0,g.isString)(o)?o:i?.id??(0,l.hash)(I.toString()).toString(16);let U=this._loggers.get(I)?.logger;const $=i?.logLevel==="always"?v.Trace:i?.logLevel;U||(U=this.doCreateLogger(I,$??this.getLogLevel(I)??this.logLevel,{...i,id:F}));const B={logger:U,info:{resource:I,id:F,logLevel:$,name:i?.name,hidden:i?.hidden,extensionId:i?.extensionId,when:i?.when}};return this.registerLogger(B.info),this._loggers.set(I,B),U}toResource(o){return(0,g.isString)(o)?(0,_.joinPath)(this.logsHome,`${o}.log`):o}setLogLevel(o,i){if(T.URI.isUri(o)){const I=o,F=i,U=this._loggers.get(I);U&&F!==U.info.logLevel&&(U.info.logLevel=F===this.logLevel?void 0:F,U.logger?.setLevel(F),this._loggers.set(U.info.resource,U),this._onDidChangeLogLevel.fire([I,F]))}else{this.logLevel=o;for(const[I,F]of this._loggers.entries())this._loggers.get(I)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(o,i){const I=this.getLoggerEntry(o);I&&i!==!I.info.hidden&&(I.info.hidden=!i,this._loggers.set(I.info.resource,I),this._onDidChangeVisibility.fire([I.info.resource,i]))}getLogLevel(o){let i;return o&&(i=this._loggers.get(o)?.info.logLevel),i??this.logLevel}registerLogger(o){const i=this._loggers.get(o.resource);i?i.info.hidden!==o.hidden&&this.setVisibility(o.resource,!o.hidden):(this._loggers.set(o.resource,{info:o,logger:void 0}),this._onDidChangeLoggers.fire({added:[o],removed:[]}))}deregisterLogger(o){const i=this._loggers.get(o);i&&(i.logger&&i.logger.dispose(),this._loggers.delete(o),this._onDidChangeLoggers.fire({added:[],removed:[i.info]}))}*getRegisteredLoggers(){for(const o of this._loggers.values())yield o.info}getRegisteredLogger(o){return this._loggers.get(o)?.info}dispose(){this._loggers.forEach(o=>o.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class s{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(o){}getLevel(){return v.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogger=s;class f extends s{}e.NullLogService=f;function b(y){if(y.verbose)return v.Trace;if(typeof y.logLevel=="string"){const o=C(y.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function u(y){switch(y){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=u;function C(y){switch(y){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",u(v.Info))}),define(ye[223],Ce([1,0,19,16,8,3,4,10,77,17]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends R.Disposable{constructor(m,D){super(),this.logService=m,this.options=D,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new A.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new A.ThrottledDelayer(0))}watch(m,D){return D.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,D):this.watchNonRecursive(m,D)}watchUniversal(m,D){const S={path:this.toFilePath(m),excludes:D.excludes,includes:D.includes,recursive:D.recursive},v=(0,c.insert)(this.universalPathsToWatch,S);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,l.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(D=>this._onDidChangeFile.fire((0,_.toFileChanges)(D)),D=>this.onWatcherLogMessage(D),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const D of this.universalPathsToWatch)(0,_.isRecursiveWatchRequest)(D)&&(D.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const D of this.universalPathsToWatch)(0,_.isRecursiveWatchRequest)(D)&&m.includes(D.path)&&(D.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,D){const S={path:this.toFilePath(m),excludes:D.excludes,includes:D.includes,recursive:!1},v=(0,c.insert)(this.nonRecursivePathsToWatch,S);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,l.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,_.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,P.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ye[224],Ce([1,0,48,347,16,28,21,3,30,4,10,9,24,91,29,184,31,217,223,45,221,220]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(c)}catch(a){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(a)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(r,s){super(r,s),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(f=>m.extUriBiasedIgnorePathCase.getComparisonKey(f)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:s,symbolicLink:f}=await S.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(s,f),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:n.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const s=await S.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),f=[];return await Promise.all(s.map(async b=>{try{let u;b.isSymbolicLink()?u=(await this.stat((0,m.joinPath)(r,b.name))).type:u=this.toType(b),f.push([b.name,u])}catch(u){this.logService.trace(u)}})),f}catch(s){throw this.toFileSystemProviderError(s)}}toType(r,s){let f;return s?.dangling?f=n.FileType.Unknown:r.isFile()?f=n.FileType.File:r.isDirectory()?f=n.FileType.Directory:f=n.FileType.Unknown,s&&(f|=n.FileType.SymbolicLink),f}async createResourceLock(r){const s=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let f;for(;f=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await f.wait();const b=new l.Barrier;return this.resourceLocks.set(r,b),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(r)===b&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),b.open()})}async readFile(r,s){let f;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),f=await this.createResourceLock(r));const b=this.toFilePath(r);return await S.Promises.readFile(b)}catch(b){throw this.toFileSystemProviderError(b)}finally{f?.dispose()}}traceLock(r){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,s,f){const b=(0,D.newWriteableStream)(u=>R.VSBuffer.concat(u.map(C=>R.VSBuffer.wrap(C))).buffer);return(0,h.readFileIntoStream)(this,r,b,u=>u.buffer,{...s,bufferSize:256*1024},f),b}async writeFile(r,s,f){return f?.atomic!==!1&&f?.atomic?.postfix?this.doWriteFileAtomic(r,(0,m.joinPath)((0,m.dirname)(r),`${(0,m.basename)(r)}${f.atomic.postfix}`),s,f):this.doWriteFile(r,s,f)}async doWriteFileAtomic(r,s,f,b){await this.doWriteFile(s,f,b);try{await this.rename(s,r,{overwrite:!0})}catch(u){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw u}}async doWriteFile(r,s,f){let b;try{const u=this.toFilePath(r);if(!f.create||!f.overwrite){if(await S.Promises.exists(u)){if(!f.overwrite)throw(0,n.createFileSystemProviderError)((0,v.localize)(0,null),n.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,n.createFileSystemProviderError)((0,v.localize)(1,null),n.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:f.unlock}),await this.write(b,0,s,0,s.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(r,u)}finally{typeof b=="number"&&await this.close(b)}}static configureFlushOnWrite(r){t.canFlush=r}async open(r,s){const f=this.toFilePath(r);let b;(0,n.isFileOpenForWriteOptions)(s)&&(b=await this.createResourceLock(r));let u;try{if((0,n.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:y}=await S.SymlinkSupport.stat(f);y.mode&128||await S.Promises.chmod(f,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}let C;if((0,n.isFileOpenForWriteOptions)(s)){if(k.isWindows)try{await S.Promises.truncate(f,0),C="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}C||(C="w")}else C="r";u=await S.Promises.open(f,C)}catch(C){throw b?.dispose(),(0,n.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(r,C):this.toFileSystemProviderError(C)}if(this.mapHandleToPos.set(u,0),(0,n.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(u,r),b){const C=this.mapHandleToLock.get(u);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${f})`),this.mapHandleToLock.set(u,b),C&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${f})`),C.dispose())}return u}async close(r){const s=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&t.canFlush)try{await S.Promises.fdatasync(r)}catch(f){t.configureFlushOnWrite(!1),this.logService.error(f)}return await S.Promises.close(r)}catch(f){throw this.toFileSystemProviderError(f)}finally{s&&(this.mapHandleToLock.get(r)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),s.dispose())}}async read(r,s,f,b,u){const C=this.normalizePos(r,s);let y=null;try{y=(await S.Promises.read(r,f,b,u,C)).bytesRead}catch(o){throw this.toFileSystemProviderError(o)}finally{this.updatePos(r,C,y)}return y}normalizePos(r,s){return s===this.mapHandleToPos.get(r)?null:s}updatePos(r,s,f){const b=this.mapHandleToPos.get(r);typeof b=="number"&&(typeof s=="number"||(typeof f=="number"?this.mapHandleToPos.set(r,b+f):this.mapHandleToPos.delete(r)))}async write(r,s,f,b,u){return(0,l.retry)(()=>this.doWrite(r,s,f,b,u),100,3)}async doWrite(r,s,f,b,u){const C=this.normalizePos(r,s);let y=null;try{y=(await S.Promises.write(r,f,b,u,C)).bytesWritten}catch(o){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),o)}finally{this.updatePos(r,C,y)}return y}async mkdir(r){try{await S.Promises.mkdir(this.toFilePath(r))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(r,s){try{const f=this.toFilePath(r);if(s.recursive){let b;s?.atomic!==!1&&s.atomic.postfix&&(b=(0,T.join)((0,T.dirname)(f),`${(0,T.basename)(f)}${s.atomic.postfix}`)),await S.Promises.rm(f,S.RimRafMode.MOVE,b)}else try{await S.Promises.unlink(f)}catch(b){if(b.code==="EPERM"||b.code==="EISDIR"){let u=!1;try{const{stat:C,symbolicLink:y}=await S.SymlinkSupport.stat(f);u=C.isDirectory()&&!y}catch{}if(u)await S.Promises.rmdir(f);else throw b}else throw b}}catch(f){throw this.toFileSystemProviderError(f)}}async rename(r,s,f){const b=this.toFilePath(r),u=this.toFilePath(s);if(b!==u)try{await this.validateMoveCopy(r,s,"move",f.overwrite),await S.Promises.move(b,u)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(2,null,(0,T.basename)(b),(0,T.basename)((0,T.dirname)(u)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(r,s,f){const b=this.toFilePath(r),u=this.toFilePath(s);if(b!==u)try{await this.validateMoveCopy(r,s,"copy",f.overwrite),await S.Promises.copy(b,u,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(3,null,(0,T.basename)(b),(0,T.basename)((0,T.dirname)(u)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(r,s,f,b){const u=this.toFilePath(r),C=this.toFilePath(s);let y=!1;if(!!(this.capabilities&1024)||(y=(0,_.isEqual)(u,C,!0)),y){if(f==="copy")throw(0,n.createFileSystemProviderError)((0,v.localize)(4,null),n.FileSystemProviderErrorCode.FileExists);if(f==="move")return}const i=await this.statIgnoreError(r);if(!i)throw(0,n.createFileSystemProviderError)((0,v.localize)(5,null),n.FileSystemProviderErrorCode.FileNotFound);const I=await this.statIgnoreError(s);if(I){if(!b)throw(0,n.createFileSystemProviderError)((0,v.localize)(6,null),n.FileSystemProviderErrorCode.FileExists);i.type&n.FileType.File&&I.type&n.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,s){return this.doCloneFile(r,s,!1)}async doCloneFile(r,s,f){const b=this.toFilePath(r),u=this.toFilePath(s),C=!!(this.capabilities&1024);if((0,_.isEqual)(b,u,!C))return;const y=new g.DisposableStore;try{const[o,i]=await Promise.all([this.createResourceLock(r),this.createResourceLock(s)]);y.add(o),y.add(i),f&&await S.Promises.mkdir((0,T.dirname)(u),{recursive:!0}),await S.Promises.copyFile(b,u)}catch(o){if(o.code==="ENOENT"&&!f)return this.doCloneFile(r,s,!0);throw this.toFileSystemProviderError(o)}finally{y.dispose()}}createUniversalWatcher(r,s,f){return new E.UniversalWatcherClient(b=>r(b),b=>s(b),f)}createNonRecursiveWatcher(r,s,f){return new p.NodeJSWatcherClient(b=>r(b),b=>s(b),f)}toFileSystemProviderError(r){if(r instanceof n.FileSystemProviderError)return r;let s=r,f;switch(r.code){case"ENOENT":f=n.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=n.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=n.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=n.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=n.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,f=n.FileSystemProviderErrorCode.Unknown;break;default:f=n.FileSystemProviderErrorCode.Unknown}return(0,n.createFileSystemProviderError)(s,f)}async toFileSystemProviderWriteError(r,s){let f=this.toFileSystemProviderError(s);if(r&&f.code===n.FileSystemProviderErrorCode.NoPermissions)try{const{stat:b}=await S.SymlinkSupport.stat(this.toFilePath(r));b.mode&128||(f=(0,n.createFileSystemProviderError)(s,n.FileSystemProviderErrorCode.FileWriteLocked))}catch(b){this.logService.trace(b)}return f}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(ye[225],Ce([1,0,4,17]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends c.Disposable{constructor(R,P=[]){super(),this.logger=new A.MultiplexLogger([R,...P]),this._register(R.onDidChangeLogLevel(_=>this.setLevel(_)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...P){this.logger.trace(R,...P)}debug(R,...P){this.logger.debug(R,...P)}info(R,...P){this.logger.info(R,...P)}warn(R,...P){this.logger.warn(R,...P)}error(R,...P){this.logger.error(R,...P)}flush(){this.logger.flush()}}e.LogService=l}),define(ye[226],Ce([1,0,31,17]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(l||(l={}));async function L(g,T,k,m,D){try{const S=await new Promise((n,h)=>{re(["@vscode/spdlog"],n,h)});S.setFlushOn(l.Trace);const v=await S.createAsyncRotatingLogger(g,T,k,m);return D?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(S){console.error(S)}return null}function R(g,T,k){switch(T){case A.LogLevel.Trace:g.trace(k);break;case A.LogLevel.Debug:g.debug(k);break;case A.LogLevel.Info:g.info(k);break;case A.LogLevel.Warning:g.warn(k);break;case A.LogLevel.Error:g.error(k);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function P(g,T){switch(T){case A.LogLevel.Trace:g.setLevel(l.Trace);break;case A.LogLevel.Debug:g.setLevel(l.Debug);break;case A.LogLevel.Info:g.setLevel(l.Info);break;case A.LogLevel.Warning:g.setLevel(l.Warning);break;case A.LogLevel.Error:g.setLevel(l.Error);break;case A.LogLevel.Off:g.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class _ extends A.AbstractMessageLogger{constructor(T,k,m,D,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(T,k,m,D),this._register(this.onDidChangeLogLevel(v=>{this._logger&&P(this._logger,v)}))}async _createSpdLogLogger(T,k,m,D){const S=m?6:1,v=30/S*c.ByteSize.MB,n=await L(T,k,v,S,D);if(n){this._logger=n,P(this._logger,this.getLevel());for(const{level:h,message:d}of this.buffer)R(this._logger,h,d);this.buffer=[]}}log(T,k){this._logger?R(this._logger,T,k):this.getLevel()<=T&&this.buffer.push({level:T,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(ye[125],Ce([1,0,41,185,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(_){function g(S,v){return v-S}_.compare=g;const T=Object.create(null);T[_.Error]=(0,A.localize)(0,null),T[_.Warning]=(0,A.localize)(1,null),T[_.Info]=(0,A.localize)(2,null);function k(S){return T[S]||""}_.toString=k;function m(S){switch(S){case c.default.Error:return _.Error;case c.default.Warning:return _.Warning;case c.default.Info:return _.Info;case c.default.Ignore:return _.Hint}}_.fromSeverity=m;function D(S){switch(S){case _.Error:return c.default.Error;case _.Warning:return c.default.Warning;case _.Info:return c.default.Info;case _.Hint:return c.default.Ignore}}_.toSeverity=D}(R||(e.MarkerSeverity=R={}));var P;(function(_){const g="";function T(m){return k(m,!0)}_.makeKey=T;function k(m,D){const S=[g];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(g),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(g),m.severity!==void 0&&m.severity!==null?S.push(R.toString(m.severity)):S.push(g),m.message&&D?S.push(m.message.replace("\xA6","\\\xA6")):S.push(g),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(g),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(g),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(g),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(g),S.push(g),S.join("\xA6")}_.makeKeyOptionalMessage=k})(P||(e.IMarkerData=P={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(ye[227],Ce([1,0,3,41,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,l.createDecorator)("notificationService");var L;(function(T){T[T.DEFAULT=0]="DEFAULT",T[T.SILENT=1]="SILENT",T[T.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var P;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(P||(e.NotificationsFilter=P={}));class _{constructor(){this.progress=new g,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=_;class g{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=g}),define(ye[126],Ce([1,0,11,2,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function L(g,T){return A.URI.isUri(g)?(0,c.equalsIgnoreCase)(g.scheme,T):(0,c.startsWithIgnoreCase)(g,T+":")}e.matchesScheme=L;function R(g,...T){return T.some(k=>L(g,k))}e.matchesSomeScheme=R;function P(g,T){return g.with({fragment:`${T.startLineNumber},${T.startColumn}${T.endLineNumber?`-${T.endLineNumber}${T.endColumn?`,${T.endColumn}`:""}`:""}`})}e.withSelection=P;function _(g){let T;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(T={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:T,uri:g}}e.extractSelection=_}),define(ye[228],Ce([1,0,9,39]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const L=c.globals.vscode.context.configuration();if(L)l=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){l=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:L,searchUrl:R,itemUrl:P,controlUrl:_}=l.extensionsGallery||{};Object.assign(l,{extensionsGallery:{serviceUrl:A.env.VSCODE_GALLERY_SERVICE_URL||L,searchUrl:A.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:A.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:A.env.VSCODE_GALLERY_CONTROL_URL||_}});try{const g=(...k)=>k.reduce((m,D)=>(Object.keys(D).forEach(S=>{Array.isArray(m[S])&&Array.isArray(D[S])?m[S]=D[S]:typeof m[S]=="object"&&typeof D[S]=="object"?m[S]=g(m[S],D[S]):m[S]=D[S]}),m),{}),T=globalThis._VSCODE_USER_PRODUCT_JSON||{};l=g(l,T)}catch{}if(A.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const g=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:g.version,release:g.release})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(ye[229],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(re,e){return function(c,A){e(c,A,re)}};define(ye[127],Ce([1,0,16,22,4,5]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var R;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this._value}constructor(k){this.callback=k}report(k){this._value=k,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let _=e.UnmanagedProgress=class extends l.Disposable{constructor(k,m){super(),this.deferred=new c.DeferredPromise,m.withProgress(k,D=>(this.reporter=D,this.lastStep&&D.report(this.lastStep),this.deferred.p)),this._register((0,l.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};e.UnmanagedProgress=_=je([$e(1,e.IProgressService)],_);class g extends l.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new l.DisposableStore)}start(k){this.stop();const m=++this.currentOperationId,D=new A.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,l.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,l.toDisposable)(()=>D.cancel())),this.currentOperationDisposables.add((0,l.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:D.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=g,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(ye[42],Ce([1,0,52,12]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.data=new Map}add(R,P){c.ok(A.isString(R)),c.ok(A.isObject(P)),c.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,P)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new l}),define(ye[99],Ce([1,0,3,42]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,g){this.schemasById[l(_)]=g,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new L;A.Registry.add(e.Extensions.JSONContribution,R)}),define(ye[128],Ce([1,0,19,3,12,176,57,99,42]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=_.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const r=new Set;this.doRegisterConfigurations(t,a,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const a=new Set;this.doDeregisterConfigurations(t,a),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:t,remove:a}){const r=new Set;this.doDeregisterConfigurations(a,r),this.doRegisterConfigurations(t,!1,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const a=new Set;this.doRegisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,a){const r=[];for(const{overrides:s,source:f}of t)for(const b in s)if(a.add(b),e.OVERRIDE_PROPERTY_REGEX.test(b)){const u=this.configurationDefaultsOverrides.get(b),C=u?.valuesSources??new Map;if(f)for(const I of Object.keys(s[b]))C.set(I,f);const y={...u?.value||{},...s[b]};this.configurationDefaultsOverrides.set(b,{source:f,value:y,valuesSources:C});const o=(0,R.getLanguageTagSettingPlainKey)(b),i={type:"object",default:y,description:L.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:l.isString(f)?void 0:f,defaultValueSource:f};r.push(...v(b)),this.configurationProperties[b]=i,this.defaultLanguageConfigurationOverridesNode.properties[b]=i}else{this.configurationDefaultsOverrides.set(b,{value:s[b],source:f});const u=this.configurationProperties[b];u&&(this.updatePropertyDefaultValue(b,u),this.updateSchema(b,u))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const a=new Set;this.doDeregisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,a){for(const{overrides:r,source:s}of t)for(const f in r){const b=this.configurationDefaultsOverrides.get(f),u=l.isString(s)?s:s?.id,C=l.isString(b?.source)?b?.source:b?.source?.id;if(u===C)if(a.add(f),this.configurationDefaultsOverrides.delete(f),e.OVERRIDE_PROPERTY_REGEX.test(f))delete this.configurationProperties[f],delete this.defaultLanguageConfigurationOverridesNode.properties[f];else{const y=this.configurationProperties[f];y&&(this.updatePropertyDefaultValue(f,y),this.updateSchema(f,y))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let a=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),a=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),a=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const a of t)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,a,r){t.forEach(s=>{this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties,void 0,r),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(t,a){const r=s=>{if(s.properties)for(const f in s.properties){a.add(f);const b=this.configurationProperties[f];b?.policy?.name&&this.policyConfigurations.delete(b.policy.name),delete this.configurationProperties[f],this.removeFromSchema(f,s.properties[f])}s.allOf?.forEach(f=>r(f))};for(const s of t){r(s);const f=this.configurationContributors.indexOf(s);f!==-1&&this.configurationContributors.splice(f,1)}}validateAndRegisterProperties(t,a=!0,r,s,f=3,b){f=l.isUndefinedOrNull(t.scope)?f:t.scope;const u=t.properties;if(u)for(const y in u){const o=u[y];if(a&&w(y,o)){delete u[y];continue}if(o.source=r,o.defaultDefaultValue=u[y].default,this.updatePropertyDefaultValue(y,o),e.OVERRIDE_PROPERTY_REGEX.test(y)?o.scope=void 0:(o.scope=l.isUndefinedOrNull(o.scope)?f:o.scope,o.restricted=l.isUndefinedOrNull(o.restricted)?!!s?.includes(y):o.restricted),u[y].hasOwnProperty("included")&&!u[y].included){this.excludedConfigurationProperties[y]=u[y],delete u[y];continue}else this.configurationProperties[y]=u[y],u[y].policy?.name&&this.policyConfigurations.set(u[y].policy.name,y);!u[y].deprecationMessage&&u[y].markdownDeprecationMessage&&(u[y].deprecationMessage=u[y].markdownDeprecationMessage),b.add(y)}const C=t.allOf;if(C)for(const y of C)this.validateAndRegisterProperties(y,a,r,s,f,b)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const a=r=>{const s=r.properties;if(s)for(const b in s)this.updateSchema(b,s[b]);r.allOf?.forEach(a)};a(t)}updateSchema(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.resourceLanguageSettingsSchema.properties[t]=a;break}}removeFromSchema(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const a=`[${t}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,r),e.allSettings.properties[a]=r,e.applicationSettings.properties[a]=r,e.machineSettings.properties[a]=r,e.machineOverridableSettings.properties[a]=r,e.windowSettings.properties[a]=r,e.resourceSettings.properties[a]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,a){const r=this.configurationDefaultsOverrides.get(t);let s=r?.value,f=r?.source;l.isUndefined(s)&&(s=a.defaultDefaultValue,f=void 0),l.isUndefined(s)&&(s=h(a.type)),a.default=s,a.defaultValueSource=f}}const D="\\[([^\\]]+)\\]",S=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let a=S.exec(p);for(;a?.length;){const r=a[1].trim();r&&t.push(r),a=S.exec(p)}}return(0,c.distinct)(t)}e.overrideIdentifiersFromKey=v;function n(p){return p.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=n;function h(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const d=new m;_.Registry.add(e.Extensions.Configuration,d);function w(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?L.localize(7,null,p):d.getConfigurationProperties()[p]!==void 0?L.localize(8,null,p):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,p,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=w;function E(){const p=[],t=d.getConfigurationProperties();for(const a of Object.keys(t))p.push([a,t[a].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=E}),define(ye[230],Ce([1,0,19,3,150,4,28,23,12,2,57,128,42]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function D(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class S{constructor(r={},s=[],f=[],b){this._contents=r,this._keys=s,this._overrides=f,this.raw=b,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(s=>{if(s instanceof S)return s;const f=new v("");return f.parseRaw(s),f.configurationModel});this._rawConfiguration=r.reduce((s,f)=>f===s?f:s.merge(f),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,s){const f=this.rawConfiguration.getValue(r),b=s?this.rawConfiguration.getOverrideValue(r,s):void 0,u=s?this.rawConfiguration.override(s).getValue(r):f;return{value:f,override:b,merged:u}}getOverrideValue(r,s){const f=this.getContentsForOverrideIdentifer(s);return f?r?(0,T.getConfigurationValue)(f,r):f:void 0}getKeysForOverrideIdentifier(r){const s=[];for(const f of this.overrides)f.identifiers.includes(r)&&s.push(...f.keys);return c.distinct(s)}getAllOverrideIdentifiers(){const r=[];for(const s of this.overrides)r.push(...s.identifiers);return c.distinct(r)}override(r){let s=this.overrideConfigurations.get(r);return s||(s=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,s)),s}merge(...r){const s=P.deepClone(this.contents),f=P.deepClone(this.overrides),b=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const C of r)if(u.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(s,C.contents);for(const y of C.overrides){const[o]=f.filter(i=>c.equals(i.identifiers,y.identifiers));o?(this.mergeContents(o.contents,y.contents),o.keys.push(...y.keys),o.keys=c.distinct(o.keys)):f.push(P.deepClone(y))}for(const y of C.keys)b.indexOf(y)===-1&&b.push(y)}return new S(s,b,f,u.every(C=>C instanceof S)?void 0:u)}createOverrideConfigurationModel(r){const s=this.getContentsForOverrideIdentifer(r);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const f={};for(const b of c.distinct([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[b];const C=s[b];C&&(typeof u=="object"&&typeof C=="object"?(u=P.deepClone(u),this.mergeContents(u,C)):u=C),f[b]=u}return new S(f,this.keys,this.overrides)}mergeContents(r,s){for(const f of Object.keys(s)){if(f in r&&_.isObject(r[f])&&_.isObject(s[f])){this.mergeContents(r[f],s[f]);continue}r[f]=P.deepClone(s[f])}}getContentsForOverrideIdentifer(r){let s=null,f=null;const b=u=>{u&&(f?this.mergeContents(f,u):f=P.deepClone(u))};for(const u of this.overrides)c.equals(u.identifiers,[r])?s=u.contents:u.identifiers.includes(r)&&b(u.contents);return b(s),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,s){this.updateValue(r,s,!0)}setValue(r,s){this.updateValue(r,s,!1)}removeValue(r){const s=this.keys.indexOf(r);s!==-1&&(this.keys.splice(s,1),(0,T.removeFromValueTree)(this.contents,r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(f=>c.equals(f.identifiers,(0,k.overrideIdentifiersFromKey)(r))),1))}updateValue(r,s,f){(0,T.addToValueTree)(this.contents,r,s,b=>console.error(b)),f=f||this.keys.indexOf(r)===-1,f&&this.keys.push(r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,T.toValuesTree)(this.contents[r],b=>console.error(b))})}}e.ConfigurationModel=S;class v{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,s){if(!_.isUndefinedOrNull(r)){const f=this.doParseContent(r);this.parseRaw(f,s)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,s){this._raw=r;const{contents:f,keys:b,overrides:u,restricted:C,hasExcludedProperties:y}=this.doParseRaw(r,s);this._configurationModel=new S(f,b,u,y?[r]:void 0),this._restrictedConfigurations=C||[]}doParseContent(r){let s={},f=null,b=[];const u=[],C=[];function y(i){Array.isArray(b)?b.push(i):f!==null&&(b[f]=i)}const o={onObjectBegin:()=>{const i={};y(i),u.push(b),b=i,f=null},onObjectProperty:i=>{f=i},onObjectEnd:()=>{b=u.pop()},onArrayBegin:()=>{const i=[];y(i),u.push(b),b=i,f=null},onArrayEnd:()=>{b=u.pop()},onLiteralValue:y,onError:(i,I,F)=>{C.push({error:i,offset:I,length:F})}};if(r)try{l.visit(r,o),s=b[0]||{}}catch(i){console.error(`Error while parsing settings file ${this._name}: ${i}`),this._parseErrors=[i]}return s}doParseRaw(r,s){const f=m.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),b=this.filter(r,f,!0,s);r=b.raw;const u=(0,T.toValuesTree)(r,o=>console.error(`Conflict in settings file ${this._name}: ${o}`)),C=Object.keys(r),y=this.toOverrides(r,o=>console.error(`Conflict in settings file ${this._name}: ${o}`));return{contents:u,keys:C,overrides:y,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}filter(r,s,f,b){let u=!1;if(!b?.scopes&&!b?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:u};const C={},y=[];for(const o in r)if(k.OVERRIDE_PROPERTY_REGEX.test(o)&&f){const i=this.filter(r[o],s,!1,b);C[o]=i.raw,u=u||i.hasExcludedProperties,y.push(...i.restricted)}else{const i=s[o],I=i?typeof i.scope<"u"?i.scope:3:void 0;i?.restricted&&y.push(o),(I===void 0||b.scopes===void 0||b.scopes.includes(I))&&!(b.skipRestricted&&i?.restricted)?C[o]=r[o]:u=!0}return{raw:C,restricted:y,hasExcludedProperties:u}}toOverrides(r,s){const f=[];for(const b of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(b)){const u={};for(const C in r[b])u[C]=r[b][C];f.push({identifiers:(0,k.overrideIdentifiersFromKey)(b),keys:Object.keys(u),contents:(0,T.toValuesTree)(u,s)})}return f}}e.ConfigurationModelParser=v;class n extends L.Disposable{constructor(r,s,f,b){super(),this.userSettingsResource=r,this.scopes=s,this.fileService=b,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.any(A.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),A.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&f.isEqual(u.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=n;class h{constructor(r,s,f,b,u,C,y,o,i,I,F,U,$){this.key=r,this.overrides=s,this._value=f,this.overrideIdentifiers=b,this.defaultConfiguration=u,this.policyConfiguration=C,this.applicationConfiguration=y,this.userConfiguration=o,this.localUserConfiguration=i,this.remoteUserConfiguration=I,this.workspaceConfiguration=F,this.folderConfigurationModel=U,this.memoryConfigurationModel=$}get value(){return D(this._value)}inspect(r,s,f){const b=r.inspect(s,f);return{get value(){return D(b.value)},get override(){return D(b.override)},get merged(){return D(b.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(r,s,f,b,u=new S,C=new S,y=new R.ResourceMap,o=new S,i=new R.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=s,this._applicationConfiguration=f,this._localUserConfiguration=b,this._remoteUserConfiguration=u,this._workspaceConfiguration=C,this._folderConfigurations=y,this._memoryConfiguration=o,this._memoryConfigurationByResource=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(r,s,f){return this.getConsolidatedConfigurationModel(r,s,f).getValue(r)}updateValue(r,s,f={}){let b;f.resource?(b=this._memoryConfigurationByResource.get(f.resource),b||(b=new S,this._memoryConfigurationByResource.set(f.resource,b))):b=this._memoryConfiguration,s===void 0?b.removeValue(r):b.setValue(r,s),f.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,s,f){const b=this.getConsolidatedConfigurationModel(r,s,f),u=this.getFolderConfigurationModelForResource(s.resource,f),C=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,y=new Set;for(const o of b.overrides)for(const i of o.identifiers)b.getOverrideValue(r,i)!==void 0&&y.add(i);return new h(r,s,b.getValue(r),y.size?[...y]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this._workspaceConfiguration:void 0,u||void 0,C)}keys(r){const s=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,s){this._folderConfigurations.set(r,s),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,s){const f=[];if(!s){const{added:b,updated:u,removed:C}=p(this._defaultConfiguration,r);s=[...b,...u,...C]}for(const b of s)for(const u of(0,k.overrideIdentifiersFromKey)(b)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(u),y=r.getKeysForOverrideIdentifier(u),o=[...y.filter(i=>C.indexOf(i)===-1),...C.filter(i=>y.indexOf(i)===-1),...C.filter(i=>!P.equals(this._defaultConfiguration.override(u).getValue(i),r.override(u).getValue(i)))];f.push([u,o])}return this.updateDefaultConfiguration(r),{keys:s,overrides:f}}compareAndUpdatePolicyConfiguration(r){const{added:s,updated:f,removed:b}=p(this._policyConfiguration,r),u=[...s,...f,...b];return u.length&&this.updatePolicyConfiguration(r),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:s,updated:f,removed:b,overrides:u}=p(this.applicationConfiguration,r),C=[...s,...f,...b];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:u}}compareAndUpdateLocalUserConfiguration(r){const{added:s,updated:f,removed:b,overrides:u}=p(this.localUserConfiguration,r),C=[...s,...f,...b];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:u}}compareAndUpdateRemoteUserConfiguration(r){const{added:s,updated:f,removed:b,overrides:u}=p(this.remoteUserConfiguration,r),C=[...s,...f,...b];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:u}}compareAndUpdateWorkspaceConfiguration(r){const{added:s,updated:f,removed:b,overrides:u}=p(this.workspaceConfiguration,r),C=[...s,...f,...b];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:u}}compareAndUpdateFolderConfiguration(r,s){const f=this.folderConfigurations.get(r),{added:b,updated:u,removed:C,overrides:y}=p(f,s),o=[...b,...u,...C];return(o.length||!f)&&this.updateFolderConfiguration(r,s),{keys:o,overrides:y}}compareAndDeleteFolderConfiguration(r){const s=this.folderConfigurations.get(r);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:f,updated:b,removed:u,overrides:C}=p(s,void 0);return{keys:[...f,...b,...u],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,s,f){let b=this.getConsolidatedConfigurationModelForResource(s,f);return s.overrideIdentifier&&(b=b.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(b=b.merge(this._policyConfiguration)),b}getConsolidatedConfigurationModelForResource({resource:r},s){let f=this.getWorkspaceConsolidatedConfiguration();if(s&&r){const b=s.getFolder(r);b&&(f=this.getFolderConsolidatedConfiguration(b.uri)||f);const u=this._memoryConfigurationByResource.get(r);u&&(f=f.merge(u))}return f}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let s=this._foldersConsolidatedConfigurations.get(r);if(!s){const f=this.getWorkspaceConsolidatedConfiguration(),b=this._folderConfigurations.get(r);b?(s=f.merge(b),this._foldersConsolidatedConfigurations.set(r,s)):s=f}return s}getFolderConfigurationModelForResource(r,s){if(s&&r){const f=s.getFolder(r);if(f)return this._folderConfigurations.get(f.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,s)=>{const{contents:f,overrides:b,keys:u}=this._folderConfigurations.get(s);return r.push([s,{contents:f,overrides:b,keys:u}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(s=>r.add(s)),this.userConfiguration.keys.forEach(s=>r.add(s)),this._workspaceConfiguration.keys.forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(f=>r.add(f))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(f=>r.add(f))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(f=>s.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(f=>s.add(f)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(f=>s.add(f)),this._folderConfigurations.forEach(f=>f.getKeysForOverrideIdentifier(r).forEach(b=>s.add(b))),[...s.values()]}static parse(r){const s=this.parseConfigurationModel(r.defaults),f=this.parseConfigurationModel(r.policy),b=this.parseConfigurationModel(r.application),u=this.parseConfigurationModel(r.user),C=this.parseConfigurationModel(r.workspace),y=r.folders.reduce((o,i)=>(o.set(g.URI.revive(i[0]),this.parseConfigurationModel(i[1])),o),new R.ResourceMap);return new d(s,f,b,u,new S,C,y,new S,new R.ResourceMap)}static parseConfigurationModel(r){return new S(r.contents,r.keys,r.overrides)}}e.Configuration=d;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,s=new Map;for(const b of a)b.keys.forEach(u=>r.add(u)),b.overrides.forEach(([u,C])=>{const y=(0,R.getOrSet)(s,u,new Set);C.forEach(o=>y.add(o))});const f=[];return s.forEach((b,u)=>f.push([u,[...b.values()]])),{keys:[...r.values()],overrides:f}}e.mergeChanges=w;class E{constructor(r,s,f,b){this.change=r,this.previous=s,this.currentConfiguraiton=f,this.currentWorkspace=b,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const u of r.keys)this.affectedKeys.add(u);for(const[,u]of r.overrides)for(const C of u)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const u of this.affectedKeys)this._affectsConfigStr+=u+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,s){const f=this._marker+r,b=this._affectsConfigStr.indexOf(f);if(b<0)return!1;const u=b+f.length;if(u>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(u);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(s){const y=this.previousConfiguration?this.previousConfiguration.getValue(r,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,s,this.currentWorkspace);return!P.equals(y,o)}return!0}}e.ConfigurationChangeEvent=E;function p(a,r){const{added:s,removed:f,updated:b}=t(r?.rawConfiguration,a?.rawConfiguration),u=[],C=a?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const o=y.filter(i=>!C.includes(i));for(const i of o)u.push([i,r.getKeysForOverrideIdentifier(i)])}if(a){const o=C.filter(i=>!y.includes(i));for(const i of o)u.push([i,a.getKeysForOverrideIdentifier(i)])}if(r&&a){for(const o of C)if(y.includes(o)){const i=t({contents:a.getOverrideValue(void 0,o)||{},keys:a.getKeysForOverrideIdentifier(o)},{contents:r.getOverrideValue(void 0,o)||{},keys:r.getKeysForOverrideIdentifier(o)});u.push([o,[...i.added,...i.removed,...i.updated]])}}return{added:s,removed:f,updated:b,overrides:u}}function t(a,r){const s=a?r?a.keys.filter(u=>r.keys.indexOf(u)===-1):[...a.keys]:[],f=r?a?r.keys.filter(u=>a.keys.indexOf(u)===-1):[...r.keys]:[],b=[];if(a&&r){for(const u of r.keys)if(a.keys.indexOf(u)!==-1){const C=(0,T.getConfigurationValue)(r.contents,u),y=(0,T.getConfigurationValue)(a.contents,u);P.equals(C,y)||b.push(u)}}return{added:s,removed:f,updated:b}}}),define(ye[129],Ce([1,0,8,5]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var l;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(l||(e.RemoteConnectionType=l={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=L;class R{constructor(k,m){this.host=k,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var P;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class _ extends c.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof _&&k._code===P.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof _&&k._code===P.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof _&&k._code===P.NoResolverFound}static isHandled(k){return k instanceof _&&k.isHandled}constructor(k,m=P.Unknown,D){super(k),this._message=k,this._code=m,this._detail=D,this.isHandled=m===P.NotAvailable&&D===!0,Object.setPrototypeOf(this,_.prototype)}}e.RemoteAuthorityResolverError=_;function g(T){const k=T.indexOf("+");return k===-1?T:T.substring(0,k)}e.getRemoteAuthorityPrefix=g}),define(ye[78],Ce([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(g){return g.scheme===c.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=A;function l(g){if(!g)return;const T=g.indexOf("+");return T<0?g:g.substr(0,T)}e.getRemoteName=l;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=L;function R(g){const{host:T,port:k}=_(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:k}}e.parseAuthorityWithPort=R;function P(g,T){let{host:k,port:m}=_(g);return typeof m>"u"&&(m=T),{host:k,port:m}}e.parseAuthorityWithOptionalPort=P;function _(g){const T=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const m=g.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:g,port:void 0}}}),define(ye[26],Ce([1,0,11,5,78]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(R||(e.ExtensionType=R={}));var P;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.LINUX_PPC64LE="linux-ppc64le",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class _{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,h){if(typeof n>"u"||n===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof n=="string"||typeof h=="string"){const d=typeof n=="string"?n:n.value,w=typeof h=="string"?h:h.value;return c.equalsIgnoreCase(d,w)}return n._lower===h._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=_;class g{get size(){return this._set.size}constructor(n){if(this._set=new Set,n)for(const h of n)this.add(h)}add(n){this._set.add(_.toKey(n))}delete(n){return this._set.delete(_.toKey(n))}has(n){return this._set.has(_.toKey(n))}}e.ExtensionIdentifierSet=g;class T{constructor(){this._map=new Map}clear(){this._map.clear()}delete(n){this._map.delete(_.toKey(n))}get(n){return this._map.get(_.toKey(n))}has(n){return this._map.has(_.toKey(n))}set(n,h){this._map.set(_.toKey(n),h)}values(){return this._map.values()}forEach(n){this._map.forEach(n)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function k(v){return m(v)}e.isApplicationScopedExtension=k;function m(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function D(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=D;function S(v,n){if(n){const h=`onResolveRemoteAuthority:${(0,l.getRemoteName)(n)}`;return!!v.activationEvents?.includes(h)}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[130],Ce([1,0,8,26]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class l{constructor(){this._generators=new Map,this._cache=new WeakMap}register(R,P){this._generators.set(R,P)}readActivationEvents(R){return this._cache.has(R)||this._cache.set(R,this._readActivationEvents(R)),this._cache.get(R)}createActivationEventsMap(R){const P=Object.create(null);for(const _ of R){const g=this.readActivationEvents(_);g.length>0&&(P[A.ExtensionIdentifier.toKey(_.identifier)]=g)}return P}_readActivationEvents(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const P=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return P;for(const _ in R.contributes){const g=this._generators.get(_);if(!g)continue;const T=R.contributes[_],k=Array.isArray(T)?T:[T];try{g(k,P)}catch(m){(0,c.onUnexpectedError)(m)}}return P}}e.ImplicitActivationEventsImpl=l,e.ImplicitActivationEvents=new l}),define(ye[231],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class c{constructor(){this.validators=new Map}async createNewMessage(l){try{const L=await this.getValidator();if(L){const R=String(c._nextId++);return this.validators.set(R,L),{id:R,data:L.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,L){if(!l.id)return!0;const R=this.validators.get(l.id);if(!R)return!1;this.validators.delete(l.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(l){try{return await this.signValue(l)}catch{}return l}}e.AbstractSignService=c,c._nextId=1}),define(ye[232],Ce([1,0,231]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class A extends c.AbstractSignService{getValidator(){return this.vsda().then(L=>new L.validator)}signValue(L){return this.vsda().then(R=>new R.signer().sign(L))}vsda(){return new Promise((L,R)=>re(["vsda"],L,R))}}e.SignService=A}),define(ye[233],Ce([1,0,9,39,32]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(_){if(c.platform===2&&/^penguin(\.|$)/i.test(_))return"chromebook"}function R(_,g,T,k,m,D,S,v){const n=Object.create(null);n["common.machineId"]=D,n.sessionID=(0,l.generateUuid)()+Date.now(),n.commitHash=k,n.version=m,n["common.platformVersion"]=(_||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,c.PlatformToString)(c.platform),n["common.nodePlatform"]=A.platform,n["common.nodeArch"]=T,n["common.product"]=v||"desktop",S&&(n["common.msftInternal"]=S);let h=0;const d=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),c.isLinuxSnap&&(n["common.snap"]="true");const w=L(g);return w&&(n["common.platformDetail"]=w),n}e.resolveCommonProperties=R;function P(_){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const T=g.toLowerCase();return _.some(k=>T===k)}e.verifyMicrosoftInternalDomain=P}),define(ye[234],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var l;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(l||(e.TelemetryConfiguration=l={}))}),define(ye[79],Ce([1,0,23,12,3,57,78,233,234]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=g;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class k{async publicLog(f,b,u){}async publicLogError(f,b,u){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(s,f){return l.Event.debounce(f.onDidChangeConfiguration,(u,C)=>{const y=u?new Set([...u.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:y}},1e3,!0)(u=>{u.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(u.source),configurationKeys:Array.from(u.affectedKeys)})})}e.configurationTelemetry=m;function D(s,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!s.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=D;function S(s,f){return!(f.isBuilt||f.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=S;function v(s){const f=s.getValue(_.TELEMETRY_SETTING_ID),b=s.getValue(_.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||b===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function n(s){const f={},b={},u={};w(s,u);for(let C in u){C=C.length>150?C.substr(C.length-149):C;const y=u[C];typeof y=="number"?b[C]=y:typeof y=="boolean"?b[C]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${y.length}`),f[C]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(f[C]=y)}return{properties:f,measurements:b}}e.validateTelemetryData=n;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(s){if(!s)return"none";const f=(0,R.getRemoteName)(s);return h.has(f)?f:"other"}e.cleanRemoteAuthority=d;function w(s,f,b=0,u){if(s)for(const C of Object.getOwnPropertyNames(s)){const y=s[C],o=u?u+C:C;Array.isArray(y)?f[o]=(0,c.safeStringify)(y):y instanceof Date?f[o]=y.toISOString():(0,A.isObject)(y)?b<2?w(y,f,b+1,o+"."):f[o]=(0,c.safeStringify)(y):f[o]=y}}function E(s,f){const b=s.msftInternalDomains||[],u=f.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(b)||u}e.isInternalTelemetry=E;function p(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=p;function t(s,f){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let b=s;const u=[];for(const i of f)for(;;){const I=i.exec(s);if(!I)break;u.push([I.index,i.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const i=y.exec(s);if(!i)break;const I=u.some(([F,U])=>i.index<U&&F<y.lastIndex);!C.test(i[0])&&!I&&(b+=s.substring(o,i.index)+"<REDACTED: user-file-path>",o=y.lastIndex)}return o<s.length&&(b+=s.substr(o)),b}function a(s){if(!s)return s;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const b of f)if(b.regex.test(s))return`<REDACTED: ${b.label}>`;return s}function r(s,f){return(0,c.cloneAndChange)(s,b=>{if(b instanceof g||Object.hasOwnProperty.call(b,"isTrustedTelemetryValue"))return b.value;if(typeof b=="string"){let u=b.replaceAll("%20"," ");u=t(u,f);for(const C of f)u=u.replace(C,"");return u=a(u),u}})}e.cleanData=r}),define(ye[235],Ce([1,0,11,124,26,9,2,8,39,79]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,c.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=T;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const f=s.manifest?s.manifest.version:s.version,b=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,f,b)}static parse(s){const f=k.exec(s);return f&&f[1]&&f[2]?new m({id:f[1]},f[2],f[4]||void 0):null}constructor(s,f,b="undefined"){this.version=f,this.targetPlatform=b,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?T(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=m;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(r){const s=D.exec(r);return s&&s[1]?[n(s[1]),s[2]]:[n(r),void 0]}e.getIdAndVersion=S;function v(r,s){return`${r}.${s}`}e.getExtensionId=v;function n(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=n;function h(r,s){return n(v(r??l.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=h;function d(r,s){const f=[],b=u=>{for(const C of f)if(C.some(y=>T(s(y),s(u))))return C;return null};for(const u of r){const C=b(u);C?C.push(u):f.push([u])}return f}e.groupByExtension=d;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function E(r){return{id:new g.TelemetryTrustedValue(r.identifier.id),name:new g.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(r,s){const f=[],b=s.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const u=b.shift();if(u&&f.every(C=>!T(C.identifier,{id:u}))){const C=r.filter(y=>T(y.identifier,{id:u}));C.length===1&&(f.push(C[0]),b.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=p;async function t(r,s){if(!L.isLinux)return!1;let f;try{f=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){s.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(u))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,s){const f=await t(r,s),b=(0,A.getTargetPlatform)(f?"alpine":L.platform,_.arch);return s.debug("ComputeTargetPlatform:",b),b}e.computeTargetPlatform=a}),define(ye[236],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function c(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=c;function A(_){return _?[..._.entries()]:[]}e.serializeEnvironmentDescriptionMap=A;function l(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=l;function L(_){return new Map(_??[])}e.deserializeEnvironmentDescriptionMap=L;function R(_){return Array.from(_.entries()).map(g=>[g[0],c(g[1].map),A(g[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=R;function P(_){return new Map(_.map(g=>[g[0],{map:l(g[1]),descriptionMap:L(g[2])}]))}e.deserializeEnvironmentVariableCollections=P}),define(ye[237],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(l){this._callback=l,this._terminalBufferMap=new Map}dispose(){for(const l of this._terminalBufferMap.values())l.dispose()}startBuffering(l,L,R=5){const P=L(_=>{const g=typeof _=="string"?_:_.data;let T=this._terminalBufferMap.get(l);if(T){T.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(l),R);T={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(l),P.dispose()}},this._terminalBufferMap.set(l,T)});return P}stopBuffering(l){this._terminalBufferMap.get(l)?.dispose()}flushBuffer(l){const L=this._terminalBufferMap.get(l);L&&(this._terminalBufferMap.delete(l),this._callback(l,L.data.join("")))}}e.TerminalDataBufferer=c}),define(ye[238],Ce([1,0,16,70,55,3,12,2,186,99,42]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(E){function p(t,a){let r=t.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const s=S.getIcon(r.id);if(!s)return;r=s.defaults}return r}E.getDefinition=p})(k||(e.IconContribution=k={}));var m;(function(E){function p(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}E.toJSONObject=p;function t(a){const r=s=>(0,R.isString)(s)?s:void 0;if(a&&Array.isArray(a.src)&&a.src.every(s=>(0,R.isString)(s.format)&&(0,R.isString)(s.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(s=>({format:s.format,location:P.URI.parse(s.location)}))}}E.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class D{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,t,a,r){const s=this.iconsById[p];if(s){if(a&&!s.description){s.description=a,this.iconSchema.properties[p].markdownDescription=`${a} $(${p})`;const u=this.iconReferenceSchema.enum.indexOf(p);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=a),this._onDidChange.fire()}return s}const f={id:p,description:a,defaults:t,deprecationMessage:r};this.iconsById[p]=f;const b={$ref:"#/definitions/icons"};return r&&(b.deprecationMessage=r),a&&(b.markdownDescription=`${a}: $(${p})`),this.iconSchema.properties[p]=b,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const t=this.iconReferenceSchema.enum.indexOf(p);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,t){const a=this.iconFontsById[p];return a||(this.iconFontsById[p]=t,this._onDidChange.fire(),t)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(s,f)=>s.id.localeCompare(f.id),t=s=>{for(;l.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of r.filter(f=>!!f.description).sort(p))a.push(`|<i class="${t(s)}"></i>|${s.id}|${l.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const s of r.filter(f=>!l.ThemeIcon.isThemeIcon(f.defaults)).sort(p))a.push(`|<i class="${t(s)}"></i>|${s.id}|`);return a.join(`
`)}}const S=new D;T.Registry.add(e.Extensions.IconContribution,S);function v(E,p,t,a){return S.registerIcon(E,p,t,a)}e.registerIcon=v;function n(){return S}e.getIconRegistry=n;function h(){const E=(0,A.getCodiconFontCharacters)();for(const p in E){const t="\\"+E[p].toString(16);S.registerIcon(p,{fontCharacter:t})}}h(),e.iconsSchemaId="vscode://schemas/icons";const d=T.Registry.as(g.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,S.getIconSchema());const w=new c.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);S.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=v("widget-close",A.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=v("goto-previous-location",A.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=v("goto-next-location",A.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=l.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(ye[131],Ce([1,0,3,57,5,17]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var R;(function(v){v.Http="http",v.Https="https"})(R||(e.TunnelProtocol=R={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P||(e.TunnelPrivacyId=P={}));var _;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(_||(e.ProvidedOnAutoForward=_={}));function g(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=k;function m(v,n,h,d){if(h===1)return!1;if(h===2&&k(n)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(w?.length===4&&parseInt(w[1])>=18)return!1}return v<1024}e.isPortPrivileged=m;class D{constructor(n,h,d){this.remoteAddress=n,this.localAddress=h,this._dispose=d,this._onDispose=new c.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=D;let S=e.AbstractTunnelService=class{constructor(n,h){this.logService=n,this.configurationService=h,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const n=this.configurationService.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],h=Array.from(this._tunnels.values());for(const d of h){const w=Array.from(d.values());for(const E of w){const p=await E.value;p&&n.push(p)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:h}of n.values())await h.then(d=>d?.dispose());n.clear()}this._tunnels.clear()}setEnvironmentTunnel(n,h,d,w,E){this.addTunnelToMap(n,h,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:h,localAddress:d,privacy:w,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,h){(k(n)||T(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const d=this.getTunnelFromMap(n,h);if(d)return++d.refcount,d.value}openTunnel(n,h,d,w,E,p=!1,t,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${d} on local port ${E}.`),!n)return;if(h||(h="localhost"),w||(w=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(n,h,d,w,E,p,t,a);return r?r.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.makeTunnel(s);return(s.tunnelRemoteHost!==h||s.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),t&&s.privacy!==t&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(f),f}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const h=this._tunnels.get(n.tunnelRemoteHost);if(h){const d=h.get(n.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,d))}}}}async tryDisposeTunnel(n,h,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${h}.`);const w=d.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(h),w}}async closeTunnel(n,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${h} `);const d=this._tunnels.get(n);if(d&&d.has(h)){const w=d.get(h);w.refcount=0,await this.tryDisposeTunnel(n,h,w)}}addTunnelToMap(n,h,d){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(h,{refcount:1,value:d})}async removeEmptyTunnelFromMap(n,h){const d=this._tunnels.get(n);d&&(await d.get(h)||d.delete(h),d.size===0&&this._tunnels.delete(n))}getTunnelFromMap(n,h){const d=[n];T(n)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):k(n)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const w=d.map(E=>this._tunnels.get(E));for(const E of w){const p=E?.get(h);if(p)return p}}canTunnel(n){return!!g(n)}createWithProvider(n,h,d,w,E,p,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${d} on local port ${w}.`);const a=d;this._factoryInProgress.add(a);const r=w===void 0?d:w,s={elevationRequired:E?this.isPortPrivileged(r):!1},f={remoteAddress:{host:h,port:d},localAddressPort:w,privacy:p,public:p?p!==P.Private:void 0,protocol:t},b=n.forwardPort(f,s);return b?(this.addTunnelToMap(h,d,b),b.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(a)})):this._factoryInProgress.delete(a),b}};e.AbstractTunnelService=S=je([$e(0,L.ILogService),$e(1,A.IConfigurationService)],S)}),define(ye[239],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var A;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(A||(e.EditSessionIdentityMatch=A={}))}),define(ye[240],Ce([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(_){return _.scheme!==c.Schemas.file&&_.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function l(_){if(_.folders.length)return _.folders.every(g=>A(g.uri))?_.folders[0].uri:void 0;if(_.configuration&&A(_.configuration))return _.configuration}e.getVirtualWorkspaceLocation=l;function L(_){return l(_)?.scheme}e.getVirtualWorkspaceScheme=L;function R(_){return l(_)?.authority}e.getVirtualWorkspaceAuthority=R;function P(_){return l(_)!==void 0}e.isVirtualWorkspace=P}),define(ye[49],Ce([1,0,187,10,72,24,2,5,18]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function g(s){const f=s;return typeof f?.id=="string"&&R.URI.isUri(f.uri)}e.isSingleFolderWorkspaceIdentifier=g;function T(s){return typeof s?.id=="string"&&!g(s)&&!m(s)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(s,f){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.basename)(s)}:f?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const b=s;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.toWorkspaceIdentifier=k;function m(s){const f=s;return typeof f?.id=="string"&&R.URI.isUri(f.configPath)}e.isWorkspaceIdentifier=m;function D(s){const f=s;if(f?.uri)return{id:f.id,uri:R.URI.revive(f.uri)};const b=s;if(b?.configPath)return{id:b.id,configPath:R.URI.revive(b.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=D;var S;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function v(s){const f=s;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=v;function n(s){const f=s;return!!(f&&typeof f=="object"&&R.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=n;class h{constructor(f,b,u,C,y){this._id=f,this._transient=u,this._configuration=C,this._ignorePathCasing=y,this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=b}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f)||null}updateFoldersMap(){this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class d{constructor(f,b){this.raw=b,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,L.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function w(s){return new d({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(s,f){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,f.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function p(s){let f;return R.URI.isUri(s)?f=s:f=s.configuration,f?.scheme===_.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(s,f){return!E(s,f)&&!p(s)}e.isSavedWorkspace=a;function r(s){return(typeof s=="string"?(0,A.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ye[80],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(l){this.id=l,this._data=new Map,this._idPool=1}add(l){const L=this._idPool++;return this._data.set(L,l),this.logDebugInfo(),L}get(l,L){return this._data.has(l)?this._data.get(l)[L]:void 0}delete(l){this._data.delete(l),this.logDebugInfo()}logDebugInfo(){c.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(ye[50],Ce([1,0,18,24,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new A.ExtUri(P=>{const _=this._providerInfo.get(P.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(P,_){_===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,_)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(ye[27],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ye[241],Ce([1,0,192,17,225,27]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=e.ExtHostLogService=class extends l.LogService{constructor(_,g,T){const k=T.remote.isRemote?"remoteexthost":_?"workerexthost":"exthost",m=T.remote.isRemote?(0,c.localize)(0,null):_?(0,c.localize)(1,null):(0,c.localize)(2,null);super(g.createLogger(k,{name:m}))}};e.ExtHostLogService=R=je([$e(1,A.ILoggerService),$e(2,L.IExtHostInitDataService)],R)}),define(ye[242],Ce([1,0,16]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(R,P,_){this._deferredPromises=new Map,this._id=R,this._shared=P,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(g=>(this._value=g,this)),this._storageListener=this._storage.onDidChangeStorage(g=>{g.shared===this._shared&&g.key===this._id&&(this._value=g.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const g=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of g.values())T.complete()}catch(T){for(const k of g.values())k.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,P){let _=this._value[R];return typeof _>"u"&&(_=P),_}update(R,P){this._value[R]=P;const _=this._deferredPromises.get(R);if(_!==void 0)return _.p;const g=new c.DeferredPromise;return this._deferredPromises.set(R,g),this._scheduler.isScheduled()||this._scheduler.schedule(),g.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=A;class l extends A{setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}constructor(R,P){super(R.identifier.value,!0,P),this._extension=R}}e.ExtensionGlobalMemento=l}),define(ye[243],Ce([1,0,3,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(R){this._notebooksAndEditors=R,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new c.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(R,P,_,g){const k=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(R)).acceptModelChanged(P.value,_,g);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(R,P){this._notebooksAndEditors.getNotebookDocument(A.URI.revive(R)).acceptDirty(P)}$acceptModelSaved(R){const P=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(R));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(ye[20],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class A{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=A});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[244],Ce([1,0,26,3]),function(re,e,c,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(P,_){l.set(this,void 0),this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(P.identifier),Je(this,l,_,"f"),Oe(this,l,"f").onDidChangePassword(g=>{g.extensionId===this._id&&this._onDidChange.fire({key:g.key})})}get(P){return Oe(this,l,"f").get(this._id,P)}store(P,_){return Oe(this,l,"f").store(this._id,P,_)}delete(P){return Oe(this,l,"f").delete(this._id,P)}}e.ExtensionSecrets=L,l=new WeakMap}),define(ye[58],Ce([1,0,5,131,3,20]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var R;(function(_){function g(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:k.protocol}}_.fromApiTunnel=g;function T(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==A.TunnelPrivacyId.ConstantPrivate&&k.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}_.fromServiceTunnel=T})(R||(e.TunnelDtoConverter=R={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let P=e.ExtHostTunnelService=class{constructor(g){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(g){return g}async openTunnel(g,T){}async getTunnels(){return[]}async setTunnelFactory(g){return{dispose:()=>{}}}registerPortsAttributesProvider(g,T){return{dispose:()=>{}}}async $providePortAttributes(g,T,k,m,D){return[]}async $forwardPort(g,T){}async $closeTunnel(g){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=P=je([$e(0,L.IExtHostRpcService)],P)}),define(ye[59],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class A{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=A}),define(ye[245],Ce([1,0,21]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(_){let g=this.buffers.indexOf(_);return g<0&&(g=this.buffers.length,this.buffers.push(_)),g}}function l(P,_){if(_.serializeBuffersForPostMessage){const g=new A,k=JSON.stringify(P,(D,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S)};if(ArrayBuffer.isView(S)){const v=L(S);if(v)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S.buffer),view:{type:v,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=g.buffers.map(D=>{const S=new Uint8Array(D);return c.VSBuffer.wrap(S)});return{message:k,buffers:m}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=l;function L(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(P,_){const g=_.map(m=>{const D=new ArrayBuffer(m.byteLength);return new Uint8Array(D).set(m.buffer),D}),T=_.length?(m,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const S=D,{index:v}=S,n=g[v];if(S.view)switch(S.view.type){case 1:return new Int8Array(n,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(n,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(n,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(n,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(n,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(n,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(n,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(n,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(n,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(n,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(n,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return n}return D}:void 0;return{message:JSON.parse(P,T),arrayBuffers:g}}e.deserializeWebviewMessage=R}),define(ye[246],Ce([1,0,247,348,349,2,350]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,m,D,S,v,n){const h=n.environment.useHostProxy,d=typeof h=="boolean"?h:!n.remote.isRemote,w=(0,R.createProxyResolver)({resolveProxy:p=>k.resolveProxy(p),getHttpProxySetting:()=>m.getConfiguration("http").get("proxy"),log:(p,t,...a)=>{switch(p){case R.LogLevel.Trace:S.trace(t,...a);break;case R.LogLevel.Debug:S.debug(t,...a);break;case R.LogLevel.Info:S.info(t,...a);break;case R.LogLevel.Warning:S.warn(t,...a);break;case R.LogLevel.Error:S.error(t,...a);break;case R.LogLevel.Critical:S.error(t,...a);break;case R.LogLevel.Off:break;default:r(p,t,a);break}function r(s,f,...b){S.error("Unknown log level",s),S.error(f,...b)}},getLogLevel:()=>S.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:d,env:process.env}),E=_(m,w);return T(D,E)}e.connectProxyResolver=P;function _(k,m){const D={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(v=>{D.config=k.getConfiguration("http").get("proxySupport")||"off"});const S={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(v=>{S.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,R.createHttpPatch)(c,m,{config:"off"},S,!0)),on:Object.assign({},c,(0,R.createHttpPatch)(c,m,{config:"on"},S,!0)),override:Object.assign({},c,(0,R.createHttpPatch)(c,m,{config:"override"},S,!0)),onRequest:Object.assign({},c,(0,R.createHttpPatch)(c,m,D,S,!0)),default:Object.assign(c,(0,R.createHttpPatch)(c,m,D,S,!1))},https:{off:Object.assign({},A,(0,R.createHttpPatch)(A,m,{config:"off"},S,!0)),on:Object.assign({},A,(0,R.createHttpPatch)(A,m,{config:"on"},S,!0)),override:Object.assign({},A,(0,R.createHttpPatch)(A,m,{config:"override"},S,!0)),onRequest:Object.assign({},A,(0,R.createHttpPatch)(A,m,D,S,!0)),default:Object.assign(A,(0,R.createHttpPatch)(A,m,D,S,!1))},tls:Object.assign(l,(0,R.createTlsPatch)(l))}}const g=new Map;function T(k,m){return k.getExtensionPathIndex().then(D=>{const S=globalThis._VSCODE_NODE_MODULES.module,v=S._load;S._load=function(h,d,w){if(h==="tls")return m.tls;if(h!=="http"&&h!=="https")return v.apply(this,arguments);const E=m[h],p=D.findSubstr(L.URI.file(d.filename));let t=g.get(p);if(t||g.set(p,t={}),!t[h]){const a=E.default;t[h]={...a}}return t[h]}})}}),define(ye[248],Ce([1,0,120]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function l(L){return new c.URITransformer(A(L))}e.createURITransformer=l}),define(ye[132],Ce([1,0,201,12,2,4,5,42,31,18,45,166,41]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(j){j[j.PROGRAMMATIC=1]="PROGRAMMATIC",j[j.USER=2]="USER",j[j.EDIT=3]="EDIT",j[j.NAVIGATION=4]="NAVIGATION",j[j.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var S;(function(j){j[j.IDENTICAL=1]="IDENTICAL",j[j.SIMILAR=2]="SIMILAR",j[j.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function v(j){const ae=j;return!!ae&&typeof ae.getSelection=="function"&&!!ae.onDidChangeSelection}e.isEditorPaneWithSelection=v;function n(j,ae,we){for(const _e of we.visibleEditorPanes)if(_e.group.id===ae&&j.matches(_e.input))return _e.getViewState()}e.findViewStateForEditor=n;function h(j){if(b(j))return!1;const ae=j;return l.URI.isUri(ae?.resource)}e.isResourceEditorInput=h;function d(j){if(b(j))return!1;const ae=j;return ae?.original!==void 0&&ae.modified!==void 0}e.isResourceDiffEditorInput=d;function w(j){if(b(j)||d(j))return!1;const ae=j;return ae?.primary!==void 0&&ae.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function E(j){if(b(j))return!1;const ae=j;return ae?ae.resource===void 0||ae.resource.scheme===g.Schemas.untitled||ae.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;function p(j){if(b(j))return!1;const ae=j;return l.URI.isUri(ae?.base?.resource)&&l.URI.isUri(ae?.input1?.resource)&&l.URI.isUri(ae?.input2?.resource)&&l.URI.isUri(ae?.result?.resource)}e.isResourceMergeEditorInput=p;var t;(function(j){j[j.SHORT=0]="SHORT",j[j.MEDIUM=1]="MEDIUM",j[j.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var a;(function(j){j[j.EXPLICIT=1]="EXPLICIT",j[j.AUTO=2]="AUTO",j[j.FOCUS_CHANGE=3]="FOCUS_CHANGE",j[j.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(ae,we){let _e=this.mapIdToSaveSource.get(ae);return _e||(_e={source:ae,label:we},this.mapIdToSaveSource.set(ae,_e)),_e.source}getSourceLabel(ae){return this.mapIdToSaveSource.get(ae)?.label??ae}}e.SaveSourceRegistry=new r;var s;(function(j){j[j.None=0]="None",j[j.Readonly=2]="Readonly",j[j.Untitled=4]="Untitled",j[j.Singleton=8]="Singleton",j[j.RequiresTrust=16]="RequiresTrust",j[j.CanSplitInGroup=32]="CanSplitInGroup",j[j.ForceDescription=64]="ForceDescription",j[j.CanDropIntoEditor=128]="CanDropIntoEditor",j[j.MultipleEditors=256]="MultipleEditors",j[j.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class f extends L.Disposable{}e.AbstractEditorInput=f;function b(j){return j instanceof f}e.isEditorInput=b;function u(j){const ae=j;return l.URI.isUri(ae?.preferredResource)}function C(j){const ae=j;return b(ae?.primary)&&b(ae?.secondary)}e.isSideBySideEditorInput=C;function y(j){const ae=j;return b(ae?.modified)&&b(ae?.original)}e.isDiffEditorInput=y;function o(j,ae,we,_e,ve){return J(_e,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const M={...we,limits:{size:Number.MAX_VALUE}};j.openEditor(ae,M)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.createTooLargeFileError=o;function i(j){return b(j?.editor)}e.isEditorInputWithOptions=i;function I(j){const ae=j;return i(j)&&ae?.group!==void 0}e.isEditorInputWithOptionsAndGroup=I;function F(j){const ae=j;return typeof ae?.groupId=="number"&&b(ae.editor)}e.isEditorIdentifier=F;var U;(function(j){j[j.UNKNOWN=0]="UNKNOWN",j[j.REPLACE=1]="REPLACE",j[j.MOVE=2]="MOVE",j[j.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var $;(function(j){j[j.GROUP_ACTIVE=0]="GROUP_ACTIVE",j[j.GROUP_INDEX=1]="GROUP_INDEX",j[j.GROUP_LOCKED=2]="GROUP_LOCKED",j[j.EDITOR_OPEN=3]="EDITOR_OPEN",j[j.EDITOR_CLOSE=4]="EDITOR_CLOSE",j[j.EDITOR_MOVE=5]="EDITOR_MOVE",j[j.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",j[j.EDITOR_LABEL=7]="EDITOR_LABEL",j[j.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",j[j.EDITOR_PIN=9]="EDITOR_PIN",j[j.EDITOR_STICKY=10]="EDITOR_STICKY",j[j.EDITOR_DIRTY=11]="EDITOR_DIRTY",j[j.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})($||(e.GroupModelChangeKind=$={}));var B;(function(j){j[j.PRIMARY=1]="PRIMARY",j[j.SECONDARY=2]="SECONDARY",j[j.BOTH=3]="BOTH",j[j.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class N{getOriginalUri(ae,we){if(!ae)return;if(p(ae))return e.EditorResourceAccessor.getOriginalUri(ae.result,we);if(we?.supportSideBySide){const{primary:ve,secondary:M}=this.getSideEditors(ae);if(ve&&M){if(we?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:we.filterByScheme}),secondary:this.getOriginalUri(M,{filterByScheme:we.filterByScheme})};if(we?.supportSideBySide===B.ANY)return this.getOriginalUri(ve,{filterByScheme:we.filterByScheme})??this.getOriginalUri(M,{filterByScheme:we.filterByScheme});ae=we.supportSideBySide===B.PRIMARY?ve:M}}if(d(ae)||w(ae)||p(ae))return;const _e=u(ae)?ae.preferredResource:ae.resource;return!_e||!we||!we.filterByScheme?_e:this.filterUri(_e,we.filterByScheme)}getSideEditors(ae){return C(ae)||w(ae)?{primary:ae.primary,secondary:ae.secondary}:y(ae)||d(ae)?{primary:ae.modified,secondary:ae.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ae,we){if(!ae)return;if(p(ae))return e.EditorResourceAccessor.getCanonicalUri(ae.result,we);if(we?.supportSideBySide){const{primary:ve,secondary:M}=this.getSideEditors(ae);if(ve&&M){if(we?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:we.filterByScheme}),secondary:this.getCanonicalUri(M,{filterByScheme:we.filterByScheme})};if(we?.supportSideBySide===B.ANY)return this.getCanonicalUri(ve,{filterByScheme:we.filterByScheme})??this.getCanonicalUri(M,{filterByScheme:we.filterByScheme});ae=we.supportSideBySide===B.PRIMARY?ve:M}}if(d(ae)||w(ae)||p(ae))return;const _e=ae.resource;return!_e||!we||!we.filterByScheme?_e:this.filterUri(_e,we.filterByScheme)}filterUri(ae,we){if(Array.isArray(we)){if(we.some(_e=>ae.scheme===_e))return ae}else if(we===ae.scheme)return ae}}e.EditorResourceAccessor=new N;var V;(function(j){j[j.LEFT=0]="LEFT",j[j.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class x{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ae){const we=this.instantiationService=ae.get(R.IInstantiationService);for(const[_e,ve]of this.editorSerializerConstructors)this.createEditorSerializer(_e,ve,we);this.editorSerializerConstructors.clear()}createEditorSerializer(ae,we,_e){const ve=_e.createInstance(we);this.editorSerializerInstances.set(ae,ve)}registerFileEditorFactory(ae){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ae}getFileEditorFactory(){return(0,A.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ae,we){if(this.editorSerializerConstructors.has(ae)||this.editorSerializerInstances.has(ae))throw new Error(`A editor serializer with type ID '${ae}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ae,we,this.instantiationService):this.editorSerializerConstructors.set(ae,we),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(ae),this.editorSerializerInstances.delete(ae)})}getEditorSerializer(ae){return this.editorSerializerInstances.get(typeof ae=="string"?ae:ae.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new x);async function W(j,ae,we){return!j||!j.length?[]:await Promise.all(j.map(async _e=>{const ve=l.URI.revive(_e.fileUri);if(!ve){we.info("Cannot resolve the path because it is not valid.",_e);return}if(!await ae.canHandleResource(ve)){we.info("Cannot resolve the path because it cannot be handled",_e);return}let X=_e.exists,fe=_e.type;if(typeof X!="boolean"||typeof fe!="number")try{fe=(await ae.stat(ve)).isDirectory?_.FileType.Directory:_.FileType.Unknown,X=!0}catch(Z){we.error(Z),X=!1}if(!X&&_e.openOnlyIfExists){we.info("Cannot resolve the path because it does not exist",_e);return}if(fe===_.FileType.Directory){we.info("Cannot resolve the path because it is a directory",_e);return}const Ee={..._e.options,pinned:!0};return X?{resource:ve,options:Ee}:{resource:ve,options:Ee,forceUntitled:!0}}))}e.pathsToEditors=W;var ee;(function(j){j[j.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",j[j.SEQUENTIAL=1]="SEQUENTIAL"})(ee||(e.EditorsOrder=ee={}));function se(j){const ae=j;if(!ae)return!1;const we=ae;if(we.modified)return se(we.modified);const _e=ae;return!!(_e.contributionsState&&_e.viewState&&Array.isArray(_e.cursorState))}e.isTextEditorViewState=se;function H(j){return(0,T.isErrorWithActions)(j)}e.isEditorOpenError=H;function J(j,ae,we){const _e=(0,T.createErrorWithActions)(j,ae);return _e.forceMessage=we?.forceMessage,_e.forceSeverity=we?.forceSeverity,_e.allowDialog=we?.allowDialog,_e}e.createEditorOpenError=J}),define(ye[249],Ce([1,0,3,202,5,4,28,42,19,65,23,70,238]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",k.Codicon.window,(0,A.localize)(0,null));var D;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var S;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.ViewContainerLocations=[0,1,2];function v(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=v;class n extends L.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,_.flatten)([...this.viewContainers.values()])}registerViewContainer(s,f,b){const u=this.get(s.id);if(u)return u;const C=s;return C.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,R.getOrSet)(this.viewContainers,f,[]).push(C),b?.isDefault&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:f}),C}deregisterViewContainer(s){for(const f of this.viewContainers.keys()){const b=this.viewContainers.get(f),u=b?.indexOf(s);if(u!==-1){b?.splice(u,1),b.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:f});return}}}get(s){return this.all.filter(f=>f.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(b=>b?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===s)}}P.Registry.add(D.ViewContainersRegistry,new n);var h;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(h||(e.ViewContentGroups=h={}));function d(r,s){const f=r.group??h.More,b=s.group??h.More;return f!==b?f.localeCompare(b):(r.order??5)-(s.order??5)}class w extends L.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new g.SetMap}registerViews(s,f){this.registerViews2([{views:s,viewContainer:f}])}registerViews2(s){s.forEach(({views:f,viewContainer:b})=>this.addViews(f,b)),this._onViewsRegistered.fire(s)}deregisterViews(s,f){const b=this.removeViews(s,f);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:f})}moveViews(s,f){for(const b of this._views.keys())if(b!==f){const u=this.removeViews(s,b);u.length&&(this.addViews(u,f),this._onDidChangeContainer.fire({views:u,from:b,to:f}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const f of this._viewContainers){const b=(this._views.get(f)||[]).filter(u=>u.id===s)[0];if(b)return b}return null}getViewContainer(s){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(u=>u.id===s)[0])return f;return null}registerViewWelcomeContent(s,f){return this._viewWelcomeContents.add(s,f),this._onDidChangeViewWelcomeContent.fire(s),(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(s,f),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,f){const b=new Map;for(const[u,C]of f)this._viewWelcomeContents.add(s,C),b.set(u,(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(s,C),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),b}getViewWelcomeContent(s){const f=[];return this._viewWelcomeContents.forEach(s,b=>f.push(b)),f.sort(d)}addViews(s,f){let b=this._views.get(f);b||(b=[],this._views.set(f,b),this._viewContainers.push(f));for(const u of s){if(this.getView(u.id)!==null)throw new Error((0,A.localize)(1,null,u.id));b.push(u)}}removeViews(s,f){const b=this._views.get(f);if(!b)return[];const u=[],C=[];for(const y of b)s.includes(y)?u.push(y):C.push(y);return u.length&&(C.length?this._views.set(f,C):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),u}}P.Registry.add(D.ViewsRegistry,new w),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var E;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(E||(e.ViewVisibilityState=E={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p||(e.TreeItemCollapsibleState=p={}));class t{constructor(s,f){this.resolved=!1,this._hasResolve=!1,(0,T.mixin)(this,s),this._hasResolve=!!f,this.resolve=async b=>{if(f&&!this.resolved){const u=await f(b);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class a extends Error{constructor(s){super((0,A.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=a}),define(ye[133],Ce([1,0,3,16,203]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,_,g,T){const k={command:P};if(_&&Object.keys(_).length>0&&(k.arguments=_),this.internalSend("request",k),typeof T=="number"){const m=setTimeout(()=>{clearTimeout(m);const D=this.pendingRequests.get(k.seq);if(D){this.pendingRequests.delete(k.seq);const S={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,l.localize)(0,null,T,P)};D(S)}},T)}return g&&this.pendingRequests.set(k.seq,g),k.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,_){return P.type!=="event"||_.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,A.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const _=P,g=this.pendingRequests.get(_.request_seq);g&&(this.pendingRequests.delete(_.request_seq),g(_));break}}}}internalSend(P,_){_.type=P,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((_,g)=>P.set(g,_)),await(0,A.timeout)(500),P.forEach((_,g)=>{_({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(g)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(ye[250],Ce([1,0,204,47,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const L=m=>c.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var R;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(R||(e.State=R={}));function P(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var _;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(_||(e.MemoryRangeType=_={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var g;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var T;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(T||(e.DebuggerString=T={})),e.IDebugService=(0,l.createDecorator)("debugService");var k;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(ye[251],Ce([1,0,11,2,10,23,18,35,22,19]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function k(u,C,y){return u.replace(T,function(o,i){return C&&i.length>0&&i[0]!=="_"?o:y&&y.hasOwnProperty(i)?y[i]:o})}e.formatPII=k;function m(u){const C={};for(const y of Object.keys(u))y.startsWith("!")||(C[y]=u[y]);return C}e.filterExceptionsFromTelemetry=m;function D(u){return u.configuration.request==="attach"&&!S(u)&&(!u.parentSession||D(u.parentSession))}e.isSessionAttach=D;function S(u){let C=u.configuration.type;if(C)return C==="vslsShare"&&(C=u.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(C,"extensionhost")||(0,c.equalsIgnoreCase)(C,"pwa-extensionhost")?u:u.parentSession?S(u.parentSession):void 0}e.getExtensionHostDebugSession=S;function v(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=v;function n(u,C,y){let o,i=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=I.exec(u);){const U=F.index+1,$=U+F[0].length;if(U<=C&&$>=y){o=F[0],i=U;break}}if(o){const U=/\w+/g;let $=null;for(;($=U.exec(o))&&!($.index+1+i+$[0].length>=y););$&&(o=o.substring(0,U.lastIndex))}return o?{start:i,end:i+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=n;async function h(u,C,y,o){if(u.evaluatableExpressionProvider.has(C)){const i=u.evaluatableExpressionProvider.ordered(C),I=(0,g.coalesce)(await Promise.all(i.map(async F=>{try{return await F.provideEvaluatableExpression(C,y,o??_.CancellationToken.None)}catch{return}})));if(I.length>0){let F=I[0].expression;const U=I[0].range;return F||(F=C.getLineContent(y.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:F}}}else{const i=C.getLineContent(y.lineNumber),{start:I,end:F}=n(i,y.column,y.column),U=i.substring(I-1,F);return{matchingExpression:U,range:new P.Range(y.lineNumber,I,y.lineNumber,I+U.length)}}return null}e.getEvaluatableExpressionAtPosition=h;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(u){return!!(u&&u.match(d))}e.isUri=w;function E(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(w(u.path))return A.URI.parse(u.path);if((0,l.isAbsolute)(u.path))return A.URI.file(u.path)}return u.path}function p(u){if(typeof u.path=="object"){const C=A.URI.revive(u.path);if(C)return C.scheme===R.Schemas.file?C.fsPath:C.toString()}return u.path}function t(u,C){const y=C?E:p,o=(0,L.deepClone)(u);return r(o,(i,I)=>{i&&I&&(I.path=y(I))}),o}e.convertToDAPaths=t;function a(u,C){const y=C?E:p,o=(0,L.deepClone)(u);return r(o,(i,I)=>{!i&&I&&(I.path=y(I))}),o}e.convertToVSCPaths=a;function r(u,C){switch(u.type){case"event":{const y=u;switch(y.event){case"output":C(!1,y.body.source);break;case"loadedSource":C(!1,y.body.source);break;case"breakpoint":C(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=u;switch(y.command){case"setBreakpoints":C(!0,y.arguments.source);break;case"breakpointLocations":C(!0,y.arguments.source);break;case"source":C(!0,y.arguments.source);break;case"gotoTargets":C(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(o=>C(!1,o));break;default:break}break}case"response":{const y=u;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(o=>C(!1,o.source));break;case"loadedSources":y.body.sources.forEach(o=>C(!1,o));break;case"scopes":y.body.scopes.forEach(o=>C(!1,o.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(o=>C(!1,o.source));break;case"setBreakpoints":y.body.breakpoints.forEach(o=>C(!1,o.source));break;case"disassemble":y.body?.instructions.forEach(i=>C(!1,i.location));break;default:break}break}}}function s(u){return u.filter(C=>!C.presentation?.hidden).sort((C,y)=>C.presentation?y.presentation?C.presentation.group?y.presentation.group?C.presentation.group!==y.presentation.group?C.presentation.group.localeCompare(y.presentation.group):f(C.presentation.order,y.presentation.order):-1:y.presentation.group?1:f(C.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.getVisibleAndSorted=s;function f(u,C){return typeof u!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:u-C}async function b(u,C){const y=u.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(y!=="none"&&(await C.saveAll(),y==="allEditorsInActiveGroup")){const o=C.activeEditorPane;o&&o.input.resource?.scheme===R.Schemas.untitled&&await C.save({editor:o.input,groupId:o.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(ye[252],Ce([1,0,46,134,23,10,9,11,29,205,133]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends T.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(h,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,h.on("data",w=>this.handleData(w))}sendMessage(h){if(this.outputStream){const d=JSON.stringify(h);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${k.TWO_CRLF}${d}`,"utf8")}}handleData(h){for(this.rawData=Buffer.concat([this.rawData,h]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(w){this._onError.fire(new Error((w.message||w)+`
`+d))}continue}}else{const d=this.rawData.indexOf(k.TWO_CRLF);if(d!==-1){const E=this.rawData.toString("utf8",0,d).split(k.HEADER_LINESEPARATOR);for(const p of E){const t=p.split(k.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(d+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k,k.TWO_CRLF=`\r
\r
`,k.HEADER_LINESEPARATOR=/\r?\n/,k.HEADER_FIELDSEPARATOR=/: */;class m extends k{startSession(){return new Promise((h,d)=>{let w=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),h(),w=!0}),this.socket.on("close",()=>{w?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",E=>{w?this._onError.fire(E):d(E)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class D extends m{constructor(h){super(),this.adapterServer=h}createConnection(h){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",h)}}e.SocketDebugAdapter=D;class S extends m{constructor(h){super(),this.adapterServer=h}createConnection(h){return A.createConnection(this.adapterServer.path,h)}}e.NamedPipeDebugAdapter=S;class v extends k{constructor(h,d){super(),this.adapterExecutable=h,this.debugType=d}async startSession(){const h=this.adapterExecutable.command,d=this.adapterExecutable.args,w=this.adapterExecutable.options||{};try{if(h)if(L.isAbsolute(h)){if(!await _.Promises.exists(h))throw new Error(g.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.debugType));let E=process.env;if(w.env&&Object.keys(w.env).length>0&&(E=l.mixin(l.deepClone(process.env),w.env)),h==="node")if(Array.isArray(d)&&d.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:E,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};w.cwd&&(t.cwd=w.cwd);const a=c.fork(d[0],d.slice(1),t);if(!a.pid)throw new Error(g.localize(2,null,d[0]));this.serverProcess=a}else throw new Error(g.localize(3,null));else{const p={env:E};w.cwd&&(p.cwd=w.cwd),this.serverProcess=c.spawn(h,d,p)}this.serverProcess.on("error",p=>{this._onError.fire(p)}),this.serverProcess.on("exit",(p,t)=>{this._onExit.fire(p)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stdin.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(E){this._onError.fire(E)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((h,d)=>{const w=c.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(E,p,t){if(E)return d(E)});w.on("exit",h),w.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(h,d){if(!h)return;const w=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?w.runtime=L.join(d,h.runtime):w.runtime=h.runtime),h.runtimeArgs&&(w.runtimeArgs=h.runtimeArgs),h.program&&(L.isAbsolute(h.program)?w.program=h.program:w.program=L.join(d,h.program)),h.args&&(w.args=h.args);const E=h;return E.win&&(w.win=v.extract(E.win,d)),E.winx86&&(w.winx86=v.extract(E.winx86,d)),E.windows&&(w.windows=v.extract(E.windows,d)),E.osx&&(w.osx=v.extract(E.osx,d)),E.linux&&(w.linux=v.extract(E.linux,d)),w}static platformAdapterExecutable(h,d){let w=Object.create(null);d=d.toLowerCase();for(const s of h)if(s.contributes){const f=s.contributes.debuggers;f&&f.length>0&&f.filter(b=>typeof b.type=="string"&&P.equalsIgnoreCase(b.type,d)).forEach(b=>{const u=v.extract(b,s.extensionLocation.fsPath);w=l.mixin(w,u,s.isBuiltin)})}let E;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?E=w.winx86||w.win||w.windows:R.isWindows?E=w.win||w.windows:R.isMacintosh?E=w.osx:R.isLinux&&(E=w.linux),E=E||w;const p=E.program||w.program,t=E.args||w.args,a=E.runtime||w.runtime,r=E.runtimeArgs||w.runtimeArgs;if(a)return{type:"executable",command:a,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(t||[])};if(p)return{type:"executable",command:p,args:t||[]}}}e.ExecutableDebugAdapter=v}),define(ye[253],Ce([1,0,46,30,9]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function L(g,T){return new Promise((k,m)=>{let D="";const S=c.spawn(g,T);S.pid&&S.stdout.on("data",v=>{D+=v.toString()}),S.on("error",v=>{m(v)}),S.on("close",v=>{k(D)})})}async function R(g){if(g)if(l.isWindows){const T=await new Promise((k,m)=>{re(["@vscode/windows-process-tree"],k,m)});return new Promise(k=>{T.getProcessTree(g,m=>{k(!!m&&m.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(g)]).then(T=>{const k=T.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},T=>!0);return Promise.resolve(!0)}e.hasChildProcesses=R;var P;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(P||(P={}));function _(g,T,k,m,D){g=g.trim().toLowerCase();let S;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?S=1:g.indexOf("cmd.exe")>=0?S=0:g.indexOf("bash")>=0?S=2:l.isWindows?S=0:S=2;let v,n=" ";switch(S){case 1:if(v=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),m){const h=(0,A.getDriveLetter)(m);h&&(n+=`${h}:; `),n+=`cd ${v(m)}; `}if(D)for(const h in D){const d=D[h];d===null?n+=`Remove-Item env:${h}; `:n+=`\${env:${h}}='${d}'; `}if(T.length>0){const h=T.shift(),d=k?h:v(h);n+=d[0]==="'"?`& ${d} `:`${d} `;for(const w of T)n+=w==="<"||w===">"||k?w:v(w),n+=" "}break;case 0:if(v=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(d=>h.includes(d))||h.length===0?`"${h}"`:h),m){const h=(0,A.getDriveLetter)(m);h&&(n+=`${h}: && `),n+=`cd ${v(m)} && `}if(D){n+='cmd /C "';for(const h in D){let d=D[h];d===null?n+=`set "${h}=" && `:(d=d.replace(/[&^|<>]/g,w=>`^${w}`),n+=`set "${h}=${d}" && `)}}for(const h of T)n+=h==="<"||h===">"||k?h:v(h),n+=" ";D&&(n+='"');break;case 2:{v=d=>(d=d.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),d.length===0?'""':d);const h=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(m&&(n+=`cd ${v(m)} ; `),D){n+="/usr/bin/env";for(const d in D){const w=D[d];w===null?n+=` -u ${h(d)}`:n+=` ${h(`${d}=${w}`)}`}n+=" "}for(const d of T)n+=d==="<"||d===">"||k?d:v(d),n+=" ";break}}return n}e.prepareCommand=_}),define(ye[100],Ce([1,0,21,33,53,92,18,10,9,47]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(T||(e.CellKind=T={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var m;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var D;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(D||(e.NotebookExecutionState=D={}));var S;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var v;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var n;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(n||(e.NotebookCellsChangeType=n={}));var h;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var d;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var w;(function(x){x.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],ee=new RegExp(`^[${W.join("")}]+`),se=7;function H(ve,M){const X=M.toString(se),Ee=`${X.length<W.length?W[X.length-1]:"z"}${X}s${(0,c.encodeBase64)(c.VSBuffer.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:x.scheme,fragment:Ee})}x.generate=H;function J(ve){if(ve.scheme!==x.scheme)return;const M=ve.fragment.indexOf("s");if(M<0)return;const X=parseInt(ve.fragment.substring(0,M).replace(ee,""),se),fe=(0,c.decodeBase64)(ve.fragment.substring(M+1)).toString();if(!isNaN(X))return{handle:X,notebook:ve.with({scheme:fe,fragment:null})}}x.parse=J;function j(ve,M){return ve.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${M??""},${ve.scheme!==R.Schemas.file?ve.scheme:""}`})}x.generateCellOutputUri=j;function ae(ve){if(ve.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const M=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!M)return;const X=M[1]&&M[1]!==""?M[1]:void 0,fe=M[2];return{outputId:X,notebook:ve.with({scheme:fe||R.Schemas.file,fragment:null})}}x.parseCellOutputUri=ae;function we(ve,M,X){return x.generate(ve,M).with({scheme:X})}x.generateCellPropertyUri=we;function _e(ve,M){if(ve.scheme===M)return x.parse(ve.with({scheme:x.scheme}))}x.parseCellPropertyUri=_e})(w||(e.CellUri=w={}));const E=x=>_.isWindows?x.replace(/\//g,"\\"):x;class p{constructor(W=[],ee=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=ee,this.order=[...new Set(W)].map(se=>({pattern:se,matches:A.parse(E(se))}))}sort(W){const ee=new Map(l.Iterable.map(W,H=>[H,E(H)]));let se=[];for(const{matches:H}of this.order)for(const[J,j]of ee)if(H(j)){se.push(J),ee.delete(J);break}return ee.size&&(se=se.concat([...ee.keys()].sort((H,J)=>this.defaultOrder.indexOf(H)-this.defaultOrder.indexOf(J)))),se}prioritize(W,ee){const se=this.findIndex(W);if(se===-1){this.order.unshift({pattern:W,matches:A.parse(E(W))});return}const H=new Set(ee.map(j=>this.findIndex(j,se)));H.delete(-1);const J=Array.from(H).sort();this.order.splice(se+1,0,...J.map(j=>this.order[j]));for(let j=J.length-1;j>=0;j--)this.order.splice(J[j],1)}toArray(){return this.order.map(W=>W.pattern)}findIndex(W,ee=this.order.length){const se=E(W);for(let H=0;H<ee;H++)if(this.order[H].matches(se))return H;return-1}}e.MimeTypeDisplayOrder=p;function t(x,W,ee,se=(H,J)=>H===J){const H=[];function J(we,_e,ve){if(_e===0&&ve.length===0)return;const M=H[H.length-1];M&&M.start+M.deleteCount===we?(M.deleteCount+=_e,M.toInsert.push(...ve)):H.push({start:we,deleteCount:_e,toInsert:ve})}let j=0,ae=0;for(;;){if(j===x.length){J(j,0,W.slice(ae));break}if(ae===W.length){J(j,x.length-j,[]);break}const we=x[j],_e=W[ae];if(se(we,_e)){j+=1,ae+=1;continue}ee(_e)?(J(j,1,[]),j+=1):(J(j,0,[_e]),ae+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(x){x.default="default",x.option="option"})(a||(e.NotebookEditorPriority=a={}));function r(x){const W=x;return!!((typeof W.include=="string"||A.isRelativePattern(W.include))&&(typeof W.exclude=="string"||A.isRelativePattern(W.exclude)))}e.isDocumentExcludePattern=r;function s(x,W,ee){if(Array.isArray(x.viewType)&&x.viewType.indexOf(W)>=0||x.viewType===W)return!0;if(x.filenamePattern){const se=r(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,H=r(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(A.match(se,(0,P.basename)(ee.fsPath).toLowerCase()))return!(H&&A.match(H,(0,P.basename)(ee.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var f;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(f||(e.CellStatusbarAlignment=f={}));class b{static create(W){return`${b._prefix}${W}`}static parse(W){if(W.startsWith(b._prefix))return W.substring(b._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=b,b._prefix="notebook/";function u(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=u;const C=new TextDecoder;function y(x){const W=[];let ee=!1;for(const se of x)(W.length===0||ee)&&(W.push(se),ee=!0);return F(W),V(c.VSBuffer.concat(W.map(se=>c.VSBuffer.wrap(se))))}e.compressOutputItemStreams=y;const o=`${String.fromCharCode(27)}[A`,i=o.split("").map(x=>x.charCodeAt(0)),I=10;function F(x){x.forEach((W,ee)=>{if(ee===0||W.length<o.length)return;const se=x[ee-1],H=W.subarray(0,o.length);if(H[0]===i[0]&&H[1]===i[1]&&H[2]===i[2]){const J=se.lastIndexOf(I);if(J===-1)return;x[ee-1]=se.subarray(0,J),x[ee]=W.subarray(o.length)}})}function U(x){let W=x;do x=W,W=x.replace(/[^\n]\x08/gm,"");while(W.length<x.length);return x}function $(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const W=x.match(/^(.*)\r+/m)[1];let ee=x.match(/\r+(.*)$/m)[1];ee=ee+W.slice(ee.length,W.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return x}const B="\b".charCodeAt(0),N="\r".charCodeAt(0);function V(x){return!x.buffer.includes(B)&&!x.buffer.includes(N)?x:c.VSBuffer.fromString($(U(C.decode(x.buffer))))}}),define(ye[254],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(A||(e.CellExecutionUpdateType=A={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ye[60],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(L){L.Delimiter="\0"})(c||(e.TestIdPathParts=c={}));var A;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class l{static fromExtHostTestItem(R,P,_=R.parent){if(R._isRoot)return new l([P]);const g=[R.id];for(let T=_;T&&T.id!==P;T=T.parent)g.push(T.id);return g.push(P),new l(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const P=R.indexOf("\0");return P===-1?R:R.slice(0,P)}static fromString(R){return new l(R.split("\0"))}static join(R,P){return new l([...R.path,P])}static joinToString(R,P){return R.toString()+"\0"+P}static parentId(R){const P=R.lastIndexOf("\0");return P===-1?void 0:R.slice(0,P)}static localId(R){const P=R.lastIndexOf("\0");return P===-1?R:R.slice(P+1)}static isChild(R,P){return P.startsWith(R)&&P[R.length]==="\0"}static compare(R,P){return R===P?0:l.isChild(R,P)?2:l.isChild(P,R)?3:1}constructor(R,P=R.length){if(this.path=R,this.viewEnd=P,R.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new l(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new l(this.path,R)}*idsToRoot(){for(let R=this.viewEnd;R>0;R--)yield new l(this.path,R)}compare(R){if(typeof R=="string")return l.compare(this.toString(),R);for(let P=0;P<R.viewEnd&&P<this.viewEnd;P++)if(R.path[P]!==this.path[P])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=l}),define(ye[81],Ce([1,0,2,35,60]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var P;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(P||(e.TestRunProfileBitset=P={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const _=C=>"runId"in C;e.isStartControllerTests=_;var g;(function(C){C.serialize=y=>({range:y.range.toJSON(),uri:y.uri.toJSON()}),C.deserialize=y=>({range:A.Range.lift(y.range),uri:c.URI.revive(y.uri)})})(g||(e.IRichLocation=g={}));var T;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(T||(e.TestMessageType=T={}));var k;(function(C){C.serialize=y=>({message:y.message,type:0,expected:y.expected,actual:y.actual,location:y.location&&g.serialize(y.location)}),C.deserialize=y=>({message:y.message,type:0,expected:y.expected,actual:y.actual,location:y.location&&g.deserialize(y.location)})})(k||(e.ITestErrorMessage=k={}));const m=(C,y)=>`${y?"s":"e"}${C}`;e.getMarkId=m;var D;(function(C){C.serialize=y=>({message:y.message,type:1,offset:y.offset,length:y.length,location:y.location&&g.serialize(y.location)}),C.deserialize=y=>({message:y.message,type:1,offset:y.offset,length:y.length,location:y.location&&g.deserialize(y.location)})})(D||(e.ITestOutputMessage=D={}));var S;(function(C){C.serialize=y=>y.type===0?k.serialize(y):D.serialize(y),C.deserialize=y=>y.type===0?k.deserialize(y):D.deserialize(y)})(S||(e.ITestMessage=S={}));var v;(function(C){C.serializeWithoutMessages=y=>({state:y.state,duration:y.duration,messages:[]}),C.serialize=y=>({state:y.state,duration:y.duration,messages:y.messages.map(S.serialize)}),C.deserialize=y=>({state:y.state,duration:y.duration,messages:y.messages.map(S.deserialize)})})(v||(e.ITestTaskState=v={}));const n="\0",h=(C,y)=>C+n+y;e.namespaceTestTag=h;const d=C=>{const y=C.indexOf(n);return{ctrlId:C.slice(0,y),tagId:C.slice(y+1)}};e.denamespaceTestTag=d;var w;(function(C){C.serialize=y=>({extId:y.extId,label:y.label,tags:y.tags,busy:y.busy,children:void 0,uri:y.uri?.toJSON(),range:y.range?.toJSON()||null,description:y.description,error:y.error,sortText:y.sortText}),C.deserialize=y=>({extId:y.extId,label:y.label,tags:y.tags,busy:y.busy,children:void 0,uri:y.uri?c.URI.revive(y.uri):void 0,range:y.range?A.Range.lift(y.range):null,description:y.description,error:y.error,sortText:y.sortText})})(w||(e.ITestItem=w={}));var E;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var p;(function(C){C.serialize=y=>({expand:y.expand,item:w.serialize(y.item)}),C.deserialize=y=>({controllerId:l.TestId.root(y.item.extId),expand:y.expand,item:w.deserialize(y.item)})})(p||(e.InternalTestItem=p={}));var t;(function(C){C.serialize=y=>{let o;return y.item&&(o={},y.item.label!==void 0&&(o.label=y.item.label),y.item.tags!==void 0&&(o.tags=y.item.tags),y.item.busy!==void 0&&(o.busy=y.item.busy),y.item.uri!==void 0&&(o.uri=y.item.uri?.toJSON()),y.item.range!==void 0&&(o.range=y.item.range?.toJSON()),y.item.description!==void 0&&(o.description=y.item.description),y.item.error!==void 0&&(o.error=y.item.error),y.item.sortText!==void 0&&(o.sortText=y.item.sortText)),{extId:y.extId,expand:y.expand,item:o}},C.deserialize=y=>{let o;return y.item&&(o={},y.item.label!==void 0&&(o.label=y.item.label),y.item.tags!==void 0&&(o.tags=y.item.tags),y.item.busy!==void 0&&(o.busy=y.item.busy),y.item.range!==void 0&&(o.range=y.item.range?A.Range.lift(y.item.range):null),y.item.description!==void 0&&(o.description=y.item.description),y.item.error!==void 0&&(o.error=y.item.error),y.item.sortText!==void 0&&(o.sortText=y.item.sortText)),{extId:y.extId,expand:y.expand,item:o}}})(t||(e.ITestItemUpdate=t={}));const a=(C,y)=>{y.expand!==void 0&&(C.expand=y.expand),y.item!==void 0&&(C.item=C.item?Object.assign(C.item,y.item):y.item)};e.applyTestItemUpdate=a;var r;(function(C){C.serializeWithoutMessages=y=>({...p.serialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(v.serializeWithoutMessages)}),C.serialize=y=>({...p.serialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(v.serialize)}),C.deserialize=y=>({...p.deserialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(v.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var s;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(s||(e.DetailType=s={}));var f;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(f||(e.TestDiffOpType=f={}));var b;(function(C){C.deserialize=y=>y.op===0?{op:y.op,item:p.deserialize(y.item)}:y.op===1?{op:y.op,item:t.deserialize(y.item)}:y.op===2?{op:y.op,uri:c.URI.revive(y.uri),docv:y.docv}:y,C.serialize=y=>y.op===0?{op:y.op,item:p.serialize(y.item)}:y.op===1?{op:y.op,item:t.serialize(y.item)}:y})(b||(e.TestsDiffOp=b={}));class u{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(y){const o=this.createChangeCollector();for(const i of y)switch(i.op){case 0:this.add(p.deserialize(i.item),o);break;case 1:this.update(t.deserialize(i.item),o);break;case 3:this.remove(i.itemId,o);break;case 5:this.retireTest(i.itemId);break;case 4:this.updatePendingRoots(i.amount);break;case 6:this._tags.set(i.tag.id,i.tag);break;case 7:this._tags.delete(i.id);break}o.complete?.()}add(y,o){const i=l.TestId.parentId(y.item.extId)?.toString();let I;if(!i)I=this.createItem(y),this.roots.add(I),this.items.set(y.item.extId,I);else if(this.items.has(i)){const F=this.items.get(i);F.children.add(y.item.extId),I=this.createItem(y,F),this.items.set(y.item.extId,I)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(y)}`);return}return o.add?.(I),y.expand===2&&this.busyControllerCount++,I}update(y,o){const i=this.items.get(y.extId);if(i)return y.expand!==void 0&&(i.expand===2&&this.busyControllerCount--,y.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(i,y),o.update?.(i),i}remove(y,o){const i=this.items.get(y);if(!i)return;const I=l.TestId.parentId(i.item.extId)?.toString();I?this.items.get(I).children.delete(i.item.extId):this.roots.delete(i);const F=[[y]];for(;F.length;)for(const U of F.pop()){const $=this.items.get(U);$&&(F.push($.children),this.items.delete(U),o.remove?.($,$!==i),$.expand===2&&this.busyControllerCount--)}}retireTest(y){}updatePendingRoots(y){this.pendingRootCount+=y}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=u}),define(ye[101],Ce([1,0,16,3,4,52,81,60]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var _;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(_||(e.TestItemEventOp=_={}));const g=(d,w)=>d===w,k=Object.entries({range:(d,w)=>d===w?!0:!d||!w?!1:d.equalsRange(w),busy:g,label:g,description:g,error:g,sortText:g,tags:(d,w)=>!(d.length!==w.length||d.some(E=>!w.includes(E)))}),m=(d,w)=>{let E;for(const[p,t]of k)t(d[p],w[p])||(E?E[p]=w[p]:E={[p]:w[p]});return E};class D extends l.Disposable{get root(){return this.options.root}constructor(w){super(),this.options=w,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new A.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(w){this._resolveHandler=w;for(const E of this.tree.values())this.updateExpandability(E)}get resolveHandler(){return this._resolveHandler}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){switch(w.op){case 2:{for(const E of this.diff)if(E.op===2&&E.uri===w.uri){E.docv=w.docv;return}break}case 1:{const E=this.diff[this.diff.length-1];if(E){if(E.op===1&&E.item.extId===w.item.extId){(0,R.applyTestItemUpdate)(E.item,w.item);return}if(E.op===0&&E.item.item.extId===w.item.extId){(0,R.applyTestItemUpdate)(E.item,w.item);return}}break}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,E){const p=this.tree.get(w);if(p){if((p.expandLevels===void 0||E>p.expandLevels)&&(p.expandLevels=E),p.expand===1){const t=this.resolveChildren(p);return t.isOpen()?this.expandChildren(p,E-1):t.wait().then(()=>this.expandChildren(p,E-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,E-1)):this.expandChildren(p,E-1)}}dispose(){for(const w of this.tree.values())this.options.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(w,E){switch(E.op){case 3:this.removeItem(P.TestId.joinToString(w.fullId,E.id));break;case 0:this.upsertItem(E.item,w);break;case 5:for(const p of E.ops)this.onTestItemEvent(w,p);break;case 1:this.diffTagRefs(E.new,E.old,w.fullId.toString());break;case 2:this.updateExpandability(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:E.update}});break;case 6:this.documentSynced(w.actual.uri);break;default:(0,L.assertNever)(E)}}documentSynced(w){w&&this.pushDiff({op:2,uri:w,docv:this.options.getDocumentVersion(w)})}upsertItem(w,E){const p=P.TestId.fromExtHostTestItem(w,this.root.id,E?.actual),t=this.options.getApiFor(w);t.parent&&t.parent!==E?.actual&&this.options.getChildren(t.parent).delete(w.id);let a=this.tree.get(p.toString());if(!a){a={fullId:p,actual:w,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},w.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(w,E),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(w)}}),this.connectItemAndChildren(w,a,E);return}if(a.actual===w){this.connectItem(w,a,E);return}if(a.actual.uri?.toString()!==w.uri?.toString())return this.removeItem(p.toString()),this.upsertItem(w,E);const r=this.options.getChildren(a.actual),s=a.actual,f=m(this.options.toITestItem(s),this.options.toITestItem(w));this.options.getApiFor(s).listener=void 0,a.actual=w,a.expand=0,f&&(f.hasOwnProperty("tags")&&(this.diffTagRefs(w.tags,s.tags,p.toString()),delete f.tags),this.onTestItemEvent(a,{op:4,update:f})),this.connectItemAndChildren(w,a,E);for(const[b,u]of r)this.options.getChildren(w).get(u.id)||this.removeItem(P.TestId.joinToString(p,u.id));this.documentSynced(a.actual.uri)}diffTagRefs(w,E,p){const t=new Set(E.map(a=>a.id));for(const a of w)t.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:p,item:{tags:w.map(a=>(0,R.namespaceTestTag)(this.options.controllerId,a.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(w){const E=this.tags.get(w.id);E?E.refCount++:(this.tags.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.options.controllerId,w.id)}}))}decrementTagRefs(w){const E=this.tags.get(w);E&&!--E.refCount&&(this.tags.delete(w),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.options.controllerId,w)}))}setItemParent(w,E){this.options.getApiFor(w).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(w,E,p){this.setItemParent(w,p);const t=this.options.getApiFor(w);t.parent=p?.actual,t.listener=a=>this.onTestItemEvent(E,a),this.updateExpandability(E)}connectItemAndChildren(w,E,p){this.connectItem(w,E,p);for(const[t,a]of this.options.getChildren(w))this.upsertItem(a,E)}updateExpandability(w){let E;this._resolveHandler?w.resolveBarrier?E=w.resolveBarrier.isOpen()?3:2:E=w.actual.canResolveChildren?1:0:E=0,E!==w.expand&&(w.expand=E,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:E}}),E===1&&w.expandLevels!==void 0&&this.resolveChildren(w))}expandChildren(w,E){if(E<0)return;const p=[];for(const[t,a]of this.options.getChildren(w.actual)){const r=this.expand(P.TestId.joinToString(w.fullId,a.id),E);(0,c.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this._resolveHandler){const a=new c.Barrier;return a.open(),a}w.expand=2,this.pushExpandStateUpdate(w);const E=w.resolveBarrier=new c.Barrier,p=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let t;try{t=this._resolveHandler(w.actual===this.root?void 0:w.actual)}catch(a){p(a)}return(0,c.isThenable)(t)?t.catch(p).then(()=>{E.open(),this.updateExpandability(w)}):(E.open(),this.updateExpandability(w)),w.resolveBarrier}pushExpandStateUpdate(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}removeItem(w){const E=this.tree.get(w);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const p=[E];for(;p.length;){const t=p.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const a of t.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(t.fullId.toString());for(const[a,r]of this.options.getChildren(t.actual))p.push(this.tree.get(P.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.diffOpEmitter.fire(w)}}e.TestItemCollection=D;class S extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=S;class v extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class n extends Error{constructor(w,E,p){super(`TestItem with ID "${w}" is from controller "${E}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=n;const h=(d,w,E)=>{let p=new Map;return{get size(){return p.size},forEach(t,a){for(const r of p.values())t.call(a,r,this)},[Symbol.iterator](){return p.entries()},replace(t){const a=new Map,r=new Set(p.keys()),s={op:5,ops:[]};for(const f of t){if(!(f instanceof E))throw new v(f.id);const b=w(f).controllerId;if(b!==d.controllerId)throw new n(f.id,b,d.controllerId);if(a.has(f.id))throw new S(f.id);a.set(f.id,f),r.delete(f.id),s.ops.push({op:0,item:f})}for(const f of r.keys())s.ops.push({op:3,id:f});d.listener?.(s),p=a},add(t){if(!(t instanceof E))throw new v(t.id);p.set(t.id,t),d.listener?.({op:0,item:t})},delete(t){p.delete(t)&&d.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=h}),define(ye[135],Ce([1,0,101]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,l=(R,P)=>{const _={controllerId:P};return A.set(R,_),_};e.createPrivateApiFor=l;const L=R=>{const P=A.get(R);if(!P)throw new c.InvalidTestItemError(R?.id||"<unknown>");return P};e.getPrivateApiFor=L}),define(ye[102],Ce([1,0,18,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(P,_){return P.scheme===c.Schemas.http||P.scheme===c.Schemas.https?P:(_&&_.authority&&_.isRemote&&P.scheme===c.Schemas.file&&(P=A.URI.from({scheme:c.Schemas.vscodeRemote,authority:_.authority,path:P.path})),A.URI.from({scheme:c.Schemas.https,authority:`${P.scheme}+${L(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=l;function L(P){return P.replace(/./g,_=>{const g=_.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?_:"-"+g.toString(16).padStart(4,"0")})}function R(P){return P.replace(/-([0-9a-f]{4})/g,(_,g)=>String.fromCharCode(parseInt(g,16)))}e.decodeAuthority=R}),define(ye[255],Ce([1,0,3,4,102]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(P,_,g){this._proxy=P,this._editors=_,this._remoteInfo=g,this._handlePool=0,this._disposables=new A.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const T=_.getVisibleTextEditors();for(const k of this._insets.values())T.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,_,g,T,k){let m;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===P){m=w;break}if(!m)throw new Error("not a visible editor");const D=this,S=this._handlePool++,v=new c.Emitter,n=new c.Emitter,h=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,l.asWebviewUri)(w,D._remoteInfo)}get cspSource(){return l.webviewGenericCspSource}set options(w){this._options=w,D._proxy.$setOptions(S,w)}get options(){return this._options}set html(w){this._html=w,D._proxy.$setHtml(S,w)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(w){return D._proxy.$postMessage(S,w)}},d=new class{constructor(){this.editor=P,this.line=_,this.height=g,this.webview=h,this.onDidDispose=n.event}dispose(){D._insets.has(S)&&(D._insets.delete(S),D._proxy.$disposeEditorInset(S),n.fire(),n.dispose(),v.dispose())}};return this._proxy.$createEditorInset(S,m.id,m.value.document.uri,_+1,g,T||{},k.identifier,k.extensionLocation),this._insets.set(S,{editor:P,inset:d,onDidReceiveMessage:v}),d}$onDidDispose(P){const _=this._insets.get(P);_&&_.inset.dispose()}$onDidReceiveMessage(P,_){this._insets.get(P)?.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=L}),define(ye[256],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var A;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(A||(e.VariableKind=A={}));class l extends Error{constructor(R,P){super(P),this.variable=R}}e.VariableError=l}),define(ye[257],Ce([1,0,10,39,12,23,9,119,208,256,11]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(D,S,v,n){this._contributedVariables=new Map,this._context=D,this._labelService=S,this._userHomePromise=v,n&&(this._envVariablesPromise=n.then(h=>this.prepareEnv(h)))}prepareEnv(D){if(R.isWindows){const S=Object.create(null);return Object.keys(D).forEach(v=>{S[v.toLowerCase()]=D[v]}),S}return D}resolveWithEnvironment(D,S,v){return this.recursiveResolve({env:this.prepareEnv(D),userHome:void 0},S?S.uri:void 0,v)}async resolveAsync(D,S){const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,D?D.uri:void 0,S)}async resolveAnyBase(D,S,v,n){const h=L.deepClone(S);R.isWindows&&h.windows?Object.keys(h.windows).forEach(w=>h[w]=h.windows[w]):R.isMacintosh&&h.osx?Object.keys(h.osx).forEach(w=>h[w]=h.osx[w]):R.isLinux&&h.linux&&Object.keys(h.linux).forEach(w=>h[w]=h.linux[w]),delete h.windows,delete h.osx,delete h.linux;const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,D?D.uri:void 0,h,v,n)}async resolveAnyAsync(D,S,v){return this.resolveAnyBase(D,S,v)}async resolveAnyMap(D,S,v){const n=new Map;return{newConfig:await this.resolveAnyBase(D,S,v,n),resolvedVariables:n}}resolveWithInteractionReplace(D,S,v,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,S,v,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,S){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,S)}async recursiveResolve(D,S,v,n,h){if(l.isString(v))return this.resolveString(D,S,v,n,h);if(Array.isArray(v))return Promise.all(v.map(d=>this.recursiveResolve(D,S,d,n,h)));if(l.isObject(v)){const d=Object.create(null),w=await Promise.all(Object.keys(v).map(async E=>[await this.resolveString(D,S,E,n,h),await this.recursiveResolve(D,S,v[E],n,h)]));for(const[E,p]of w)d[E]=p;return d}return v}resolveString(D,S,v,n,h){return(0,T.replaceAsync)(v,k.VARIABLE_REGEXP,async(d,w)=>{if(w.includes(k.VARIABLE_LHS))return d;let E=await this.evaluateSingleVariable(D,d,w,S,n);return h?.set(w,E),E!==d&&l.isString(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.resolveString(D,S,E,n,h)),E})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}async evaluateSingleVariable(D,S,v,n,h){let d;const w=v.split(":");w.length>1&&(v=w[0],d=w[1]);const E=a=>{const r=this._context.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new g.VariableError(a,(0,_.localize)(0,null,S))},p=a=>{const r=E(a);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return(0,P.normalizeDriveLetter)(s)}throw new g.VariableError(a,(0,_.localize)(1,null,S,c.basename(r)))},t=a=>{if(d){const r=this._context.getFolderUri(d);if(r)return r;throw new g.VariableError(a,(0,_.localize)(2,null,S,d))}if(n)return n;throw this._context.getWorkspaceFolderCount()>1?new g.VariableError(a,(0,_.localize)(3,null,S)):new g.VariableError(a,(0,_.localize)(4,null,S))};switch(v){case"env":if(d){if(D.env){const a=D.env[R.isWindows?d.toLowerCase():d];if(l.isString(a))return a}return""}throw new g.VariableError(g.VariableKind.Env,(0,_.localize)(5,null,S));case"config":if(d){const a=this._context.getConfigurationValue(n,d);if(l.isUndefinedOrNull(a))throw new g.VariableError(g.VariableKind.Config,(0,_.localize)(6,null,S,d));if(l.isObject(a))throw new g.VariableError(g.VariableKind.Config,(0,_.localize)(7,null,S,d));return a}throw new g.VariableError(g.VariableKind.Config,(0,_.localize)(8,null,S));case"command":return this.resolveFromMap(g.VariableKind.Command,S,d,h,"command");case"input":return this.resolveFromMap(g.VariableKind.Input,S,d,h,"input");case"extensionInstallFolder":if(d){const a=await this._context.getExtension(d);if(!a)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,_.localize)(9,null,S,d));return this.fsPath(a.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,_.localize)(10,null,S));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(t(g.VariableKind.WorkspaceFolder)));case"cwd":return n||d?(0,P.normalizeDriveLetter)(this.fsPath(t(g.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(c.basename(this.fsPath(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,_.localize)(11,null,S))}case"lineNumber":{const a=this._context.getLineNumber();if(a)return a;throw new g.VariableError(g.VariableKind.LineNumber,(0,_.localize)(12,null,S))}case"selectedText":{const a=this._context.getSelectedText();if(a)return a;throw new g.VariableError(g.VariableKind.SelectedText,(0,_.localize)(13,null,S))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return p(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return n||d?c.relative(this.fsPath(t(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const a=c.dirname(E(g.VariableKind.RelativeFileDirname));if(n||d){const r=c.relative(this.fsPath(t(g.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return c.dirname(E(g.VariableKind.FileDirname));case"fileExtname":return c.extname(E(g.VariableKind.FileExtname));case"fileBasename":return c.basename(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=c.basename(E(g.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-c.extname(a).length)}case"fileDirnameBasename":return c.basename(c.dirname(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const a=this._context.getExecPath();return a||S}case"execInstallFolder":{const a=this._context.getAppRoot();return a||S}case"pathSeparator":return c.sep;default:try{const a=d?`${v}:${d}`:v;return this.resolveFromMap(g.VariableKind.Unknown,S,a,h,void 0)}catch{return S}}}}resolveFromMap(D,S,v,n,h){if(v&&n){const d=h===void 0?n[v]:n[h+":"+v];if(typeof d=="string")return d;throw new g.VariableError(D,(0,_.localize)(14,null,S))}return S}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[136],Ce([1,0,5,132]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var l;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(l||(e.GroupDirection=l={}));var L;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var P;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EVEN=1]="EVEN",S[S.TOGGLE=2]="TOGGLE"})(P||(e.GroupsArrangement=P={}));var _;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(_||(e.MergeGroupMode=_={}));function g(S){const v=S;return(0,A.isEditorInput)(v?.editor)&&(0,A.isEditorInput)(v?.replacement)}e.isEditorReplacement=g;var T;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var k;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function m(S){const v=S;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=m;function D(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(ye[258],Ce([1,0,5,136]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(L){const R=L;return typeof L=="number"||(0,A.isEditorGroup)(R)}e.isPreferredGroup=l}),define(ye[259],Ce([1,0,5,214]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(A.IEnvironmentService)}),define(ye[137],Ce([1,0,26,3,10,4]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=R;class P{static isHostExtension(n,h,d){if(h.getExtensionDescription(n))return!1;const w=d.getExtensionDescription(n);return w?!!((w.main||w.browser)&&w.api==="none"):!1}constructor(n,h){this._activationEventsReader=n,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=h,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new c.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this._extensionsMap.set(n.identifier,n),this._extensionsArr.push(n);const h=this._activationEventsReader.readActivationEvents(n);if(Array.isArray(h))for(let d of h)d==="onUri"&&(d=`onUri:${c.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(d)||this._activationMap.set(d,[]),this._activationMap.get(d).push(n)}}set(n){this._extensionDescriptions=n,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,h){this._extensionDescriptions=S(this._extensionDescriptions,h),this._extensionDescriptions=this._extensionDescriptions.concat(n);const d=P._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=S(this._extensionDescriptions,d.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new R(d)}static _findLoopingExtensions(n){const h=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(t){this._nodesSet.has(t)||(this._nodesSet.add(t),this._nodesArr.push(t))}addArc(t,a){this.addNode(t),this.addNode(a),this._arcs.has(t)?this._arcs.get(t).push(a):this._arcs.set(t,[a])}getArcs(t){return this._arcs.has(t)?this._arcs.get(t):[]}hasOnlyGoodArcs(t,a){const r=h.getArcs(t);for(let s=0;s<r.length;s++)if(!a.has(r[s]))return!1;return!0}getNodes(){return this._nodesArr}},d=new c.ExtensionIdentifierMap;for(const t of n)if(d.set(t.identifier,t),t.extensionDependencies)for(const a of t.extensionDependencies)h.addArc(c.ExtensionIdentifier.toKey(t.identifier),c.ExtensionIdentifier.toKey(a));const w=new Set;h.getNodes().filter(t=>h.getArcs(t).length===0).forEach(t=>w.add(t));const E=h.getNodes().filter(t=>!w.has(t));let p;do{p=!1;for(let t=0;t<E.length;t++){const a=E[t];h.hasOnlyGoodArcs(a,w)&&(E.splice(t,1),t--,w.add(a),p=!0)}}while(p);return E.map(t=>d.get(t))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(n)}getExtensionDescriptionsForActivationEvent(n){const h=this._activationMap.get(n);return h?h.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const h=this._extensionsMap.get(n);return h||void 0}getExtensionDescriptionByUUID(n){for(const h of this._extensionsArr)if(h.uuid===n)return h}getExtensionDescriptionByIdOrUUID(n,h){return this.getExtensionDescription(n)??(h?this.getExtensionDescriptionByUUID(h):void 0)}}e.ExtensionDescriptionRegistry=P,e.basicActivationEventsReader={readActivationEvents:v=>v.activationEvents};class _{constructor(n){this._lock=new k,this._actual=new P(n,[])}async acquireLock(n){const h=await this._lock.acquire(n);return new g(this,h)}deltaExtensions(n,h,d){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(h,d)}containsActivationEvent(n){return this._actual.containsActivationEvent(n)}containsExtension(n){return this._actual.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this._actual.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(n){return this._actual.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this._actual.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,h){return this._actual.getExtensionDescriptionByIdOrUUID(n,h)}}e.LockableExtensionDescriptionRegistry=_;class g extends L.Disposable{constructor(n,h){super(),this._registry=n,this._isDisposed=!1,this._register(h)}isAcquiredFor(n){return!this._isDisposed&&this._registry===n}}e.ExtensionDescriptionRegistryLock=g;class T{constructor(n){this.name=n,this.promise=new Promise((h,d)=>{this._resolve=h})}resolve(n){this._resolve(n)}}class k{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(n){const h=new T(n);return this._pendingCustomers.push(h),this._advance(),h.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const n=this._pendingCustomers.shift();this._isLocked=!0;let h=!0;const d=setTimeout(()=>{h&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),w=()=>{h&&(clearTimeout(d),h=!1,this._isLocked=!1,this._advance())};n.resolve((0,L.toDisposable)(w))}}var m;(function(v){v[v.Builtin=0]="Builtin",v[v.User=1]="User",v[v.Dev=2]="Dev"})(m||(m={}));function D(v,n){const h=v.isBuiltin?0:v.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(h!==d)return h-d;const w=l.posix.basename(v.extensionLocation.path),E=l.posix.basename(n.extensionLocation.path);return w<E?-1:w>E?1:0}function S(v,n){const h=new c.ExtensionIdentifierSet(n);return v.filter(d=>!h.has(d.identifier))}}),define(ye[260],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(c||(e.ExtHostConnectionType=c={}));class A{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[A.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=A,A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class l{constructor(){this.type=2}serialize(k){k[l.ENV_KEY]="1"}}e.SocketExtHostConnection=l,l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class L{constructor(){this.type=3}serialize(k){k[L.ENV_KEY]="1"}}e.MessagePortExtHostConnection=L,L.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function R(T){delete T[A.ENV_KEY],delete T[l.ENV_KEY],delete T[L.ENV_KEY]}function P(T,k){R(k),T.serialize(k)}e.writeExtHostConnection=P;function _(T){if(T[A.ENV_KEY])return g(T,new A(T[A.ENV_KEY]));if(T[l.ENV_KEY])return g(T,new l);if(T[L.ENV_KEY])return g(T,new L);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=_;function g(T,k){return R(T),k}}),define(ye[103],Ce([1,0,21]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(A||(e.UIKind=A={}));var l;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(l||(e.ExtensionHostExitCode=l={}));var L;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(g){const T=c.VSBuffer.alloc(1);switch(g){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=R;function P(g,T){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=P;var _;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(_||(e.NativeLogMarkers=_={}))}),define(ye[82],Ce([1,0,5,3,17,27,103,78,79,23,2,4,195]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=e.ExtHostTelemetry=class extends k.Disposable{constructor(h,d){super(),this.initData=h,this.loggerService=d,this._onDidChangeTelemetryEnabled=this._register(new A.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new A.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=T.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=d.createLogger(this.extHostTelemetryLogFile,{id:_.extensionTelemetryLogChannelId,name:(0,m.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(d.onDidChangeLogLevel(w=>{(0,l.isLogLevel)(w)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(h,d,w){const E=this.getTelemetryDetails(),p=new S(d,w,h,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(h),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),t=this._telemetryLoggers.get(h.identifier.value)??[];return this._telemetryLoggers.set(h.identifier.value,[...t,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(h,d,w){this._level=h,this._telemetryIsSupported=d,this._productConfig=w??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(h){const d=Object.create(null);switch(d["common.extname"]=`${h.publisher}.${h.name}`,d["common.extversion"]=h.version,d["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,d["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,d["common.vscodeversion"]=this.initData.version,d["common.isnewappinstall"]=v(this.initData.telemetryInfo.firstSessionDate),d["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:d["common.uikind"]="web";break;case R.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,P.getRemoteName)((0,_.cleanRemoteAuthority)(this.initData.remote.authority)),d}$onDidChangeTelemetryLevel(h){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=h;const d=this.getTelemetryDetails();this._telemetryLoggers.forEach((w,E)=>{const p=w.filter(t=>!t.isDisposed);p.length===0?this._telemetryLoggers.delete(E):this._telemetryLoggers.set(E,p)}),this._telemetryLoggers.forEach(w=>{for(const E of w)E.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(h,d){const E=this._telemetryLoggers.get(h.value)?.filter(t=>!t.isDisposed);if(!E)return this._telemetryLoggers.delete(h.value),!1;let p=!1;for(const t of E)t.ignoreUnhandledExtHostErrors||(t.logError(d),p=!0);return p}};e.ExtHostTelemetry=D=je([$e(0,L.IExtHostInitDataService),$e(1,l.ILoggerService)],D);class S{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,d,w,E,p,t,a){this._extension=w,this._logger=E,this._inLoggingOnlyMode=p,this._commonProperties=t,this._onDidChangeEnableStates=new A.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=d?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=d?.additionalCommonProperties,this._sender=h,this._telemetryEnablements={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(h,d){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:h,isErrorsEnabled:d},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(h){let d="properties"in h?h.properties??{}:h;return d=(0,_.cleanData)(d,[]),this._additionalCommonProperties&&(d=(0,g.mixin)(d,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(d=(0,g.mixin)(d,this._commonProperties)),"properties"in h?h.properties=d:h=d,h}logEvent(h,d){this._sender&&(this._extension.publisher==="vscode"?h=this._extension.name+"/"+h:h=this._extension.identifier.value+"/"+h,d=this.mixInCommonPropsAndCleanData(d||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(h,d),this._logger.trace(h,d))}logUsage(h,d){this._telemetryEnablements.isUsageEnabled&&this.logEvent(h,d)}logError(h,d){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof h=="string"?this.logEvent(h,d):this._sender.sendErrorData(h,d))}get apiTelemetryLogger(){if(!this._apiObject){const h=this,d={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return h._telemetryEnablements.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h._onDidChangeEnableStates.event.bind(h)};this._apiObject=Object.freeze(d)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let h=this._sender;this._sender=void 0,Promise.resolve(h.flush()).then(h=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=S;function v(n){const h=Date.now()-new Date(n).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=v,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ye[25],Ce([1,0,3,2,235,130,26,5]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class _{constructor(p){this.dependency=p}}e.MissingExtensionDependency=_;var g;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class T{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:L.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(p,t){const a=[],r=[],s=[],f=[],b=k(this._allExtensions),u=k(p),C=(F,U)=>F.extensionLocation.toString()===U.extensionLocation.toString()||F.isBuiltin===U.isBuiltin||F.isUserBuiltin===U.isUserBuiltin||F.isUnderDevelopment===U.isUnderDevelopment;for(const F of this._allExtensions){const U=u.get(F.identifier);if(!U){a.push(F.identifier),b.delete(F.identifier);continue}if(!C(F,U)){a.push(F.identifier),b.delete(F.identifier);continue}}for(const F of p){const U=b.get(F.identifier);if(!U){r.push(F);continue}if(!C(U,F)){a.push(U.identifier),b.delete(U.identifier);continue}}const y=new R.ExtensionIdentifierSet(this._myExtensions),o=new R.ExtensionIdentifierSet(t);for(const F of this._myExtensions)o.has(F)||s.push(F);for(const F of t)y.has(F)||f.push(F);const i=L.ImplicitActivationEvents.createActivationEventsMap(r),I={toRemove:a,toAdd:r,addActivationEvents:i,myToRemove:s,myToAdd:f};return this.delta(I),I}delta(p){const{toRemove:t,toAdd:a,myToRemove:r,myToAdd:s}=p,f=new R.ExtensionIdentifierSet(t),b=new R.ExtensionIdentifierSet(r);for(let u=0;u<this._allExtensions.length;u++)f.has(this._allExtensions[u].identifier)&&(this._allExtensions.splice(u,1),u--);for(let u=0;u<this._myExtensions.length;u++)b.has(this._myExtensions[u])&&(this._myExtensions.splice(u,1),u--);for(const u of a)this._allExtensions.push(u);for(const u of s)this._myExtensions.push(u)}containsExtension(p){for(const t of this._myExtensions)if(R.ExtensionIdentifier.equals(t,p))return!0;return!1}}e.ExtensionHostExtensions=T;function k(E){const p=new R.ExtensionIdentifierMap;for(const t of E)p.set(t.identifier,t);return p}function m(E,p){return E.enabledApiProposals?E.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=m;function D(E,p){if(!m(E,p))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.checkProposedApiEnabled=D;class S{constructor(p,t,a,r){this.codeLoadingTime=p,this.activateCallTime=t,this.activateResolvedTime=a,this.activationReason=r}}e.ActivationTimes=S;class v{constructor(p,t){this.description=p,this.value=t}}e.ExtensionPointContribution=v;var n;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(n||(e.ActivationKind=n={}));function h(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,l.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function d(E,p){return{identifier:new R.ExtensionIdentifier((0,l.getExtensionId)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!p,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.toExtensionDescription=d;class w{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.onWillStop=c.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=w}),define(ye[261],Ce([1,0,8,137,26,25,17,16]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class _{constructor(h,d,w,E){this.startup=h,this.codeLoadingTime=d,this.activateCallTime=w,this.activateResolvedTime=E}}e.ExtensionActivationTimes=_,_.NONE=new _(!1,-1,-1,-1);class g{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,d){return h===-1||d===-1?-1:d-h}build(){return new _(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=g;class T{constructor(h,d,w,E,p,t){this.activationFailed=h,this.activationFailedError=d,this.activationTimes=w,this.module=E,this.exports=p,this.subscriptions=t}}e.ActivatedExtension=T;class k extends T{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class m extends T{constructor(){super(!1,null,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class D extends T{constructor(h){super(!0,h,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=e.ExtensionsActivator=class{constructor(h,d,w,E){this._logService=E,this._registry=h,this._globalRegistry=d,this._host=w,this._operations=new l.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,d]of this._operations)d.dispose()}async waitForActivatingExtensions(){const h=[];for(const[d,w]of this._operations)h.push(w.wait());await Promise.all(h)}isActivated(h){const d=this._operations.get(h);return!!(d&&d.value)}getActivatedExtension(h){const d=this._operations.get(h);if(!d||!d.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return d.value}async activateByEvent(h,d){if(this._alreadyActivatedEvents[h])return;const w=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(w.map(E=>({id:E.identifier,reason:{startup:d,extensionId:E.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,d){const w=this._registry.getExtensionDescription(h);if(!w)throw new Error(`Extension '${h}' is not known`);return this._activateExtensions([{id:w.identifier,reason:d}])}async _activateExtensions(h){const d=h.filter(w=>!this.isActivated(w.id)).map(w=>this._handleActivationRequest(w));await Promise.all(d.map(w=>w.wait()))}_handleActivationRequest(h){if(this._operations.has(h.id))return this._operations.get(h.id);if(this._isHostExtension(h.id))return this._createAndSaveOperation(h,null,[],null);const d=this._registry.getExtensionDescription(h.id);if(!d){const p=new Error(`Cannot activate unknown extension '${h.id.value}'`),t=this._createAndSaveOperation(h,null,[],new D(p));return this._host.onExtensionActivationError(h.id,p,new L.MissingExtensionDependency(h.id.value)),t}const w=[],E=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const p of E){if(this._isResolvedExtension(p))continue;const t=this._operations.get(p);if(t){w.push(t);continue}if(this._isHostExtension(p)){w.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(p).identifier,reason:h.reason}));continue}const a=this._registry.getExtensionDescription(p);if(a){if(!a.main&&!a.browser)continue;w.push(this._handleActivationRequest({id:a.identifier,reason:h.reason}));continue}const r=d.displayName||d.identifier.value,s=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),f=this._createAndSaveOperation(h,d.displayName,[],new D(s));return this._host.onExtensionActivationError(d.identifier,s,new L.MissingExtensionDependency(p)),f}return this._createAndSaveOperation(h,d.displayName,w,null)}_createAndSaveOperation(h,d,w,E){const p=new v(h.id,d,h.reason,w,E,this._host,this._logService);return this._operations.set(h.id,p),p}_isHostExtension(h){return A.ExtensionDescriptionRegistry.isHostExtension(h,this._registry,this._globalRegistry)}_isResolvedExtension(h){const d=this._globalRegistry.getExtensionDescription(h);return d?!d.main&&!d.browser:!1}};e.ExtensionsActivator=S=je([$e(3,R.ILogService)],S);let v=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(h,d,w,E,p,t,a){this._id=h,this._displayName=d,this._reason=w,this._deps=E,this._value=p,this._host=t,this._logService=a,this._barrier=new P.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const d=this._deps[h];if(d.value&&!d.value.activationFailed){this._deps.splice(h,1),h--;continue}if(d.value&&d.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);w.detail=d.value.activationFailedError,this._value=new D(w),this._host.onExtensionActivationError(this._id,w,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const d=new Error;if(h&&h.name&&(d.name=h.name),h&&h.message?d.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(d.stack=h.stack),this._value=new D(d),this._isDisposed&&c.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};v=je([$e(6,R.ILogService)],v)});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[7],Ce([1,0,19,8,118,28,92,11,12,2,32,26,31,129,100,25]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v){"use strict";var n,h,d,w,E,p,t,a,r,s,f,b,u,C,y,o,i,I,F,U,$,B,N,V,x,W;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function ee(G){return Object.assign(G,{apply:function(){const be=arguments.length===1?[]:arguments[1];return Reflect.construct(G,be,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[be,...Re]=arguments;return Reflect.construct(G,Re,be.constructor)}}})}var se;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(se||(e.TerminalOutputAnchor=se={}));var H;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(H||(e.TerminalQuickFixType=H={}));let J=e.Disposable=r=class{static from(...z){let be=z;return new r(function(){if(be){for(const Re of be)Re&&typeof Re.dispose=="function"&&Re.dispose();be=void 0}})}constructor(z){n.set(this,void 0),Je(this,n,z,"f")}dispose(){typeof Oe(this,n,"f")=="function"&&(Oe(this,n,"f").call(this),Je(this,n,void 0,"f"))}};n=new WeakMap,e.Disposable=J=r=je([ee],J);let j=e.Position=s=class{static Min(...z){if(z.length===0)throw new TypeError;let be=z[0];for(let Re=1;Re<z.length;Re++){const Ge=z[Re];Ge.isBefore(be)&&(be=Ge)}return be}static Max(...z){if(z.length===0)throw new TypeError;let be=z[0];for(let Re=1;Re<z.length;Re++){const Ge=z[Re];Ge.isAfter(be)&&(be=Ge)}return be}static isPosition(z){if(!z)return!1;if(z instanceof s)return!0;const{line:be,character:Re}=z;return typeof be=="number"&&typeof Re=="number"}static of(z){if(z instanceof s)return z;if(this.isPosition(z))return new s(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(z,be){if(z<0)throw(0,A.illegalArgument)("line must be non-negative");if(be<0)throw(0,A.illegalArgument)("character must be non-negative");this._line=z,this._character=be}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,be=0){if(z===null||be===null)throw(0,A.illegalArgument)();let Re;return typeof z>"u"?Re=0:typeof z=="number"?Re=z:(Re=typeof z.lineDelta=="number"?z.lineDelta:0,be=typeof z.characterDelta=="number"?z.characterDelta:0),Re===0&&be===0?this:new s(this.line+Re,this.character+be)}with(z,be=this.character){if(z===null||be===null)throw(0,A.illegalArgument)();let Re;return typeof z>"u"?Re=this.line:typeof z=="number"?Re=z:(Re=typeof z.line=="number"?z.line:this.line,be=typeof z.character=="number"?z.character:this.character),Re===this.line&&be===this.character?this:new s(Re,be)}toJSON(){return{line:this.line,character:this.character}}};e.Position=j=s=je([ee],j);let ae=e.Range=f=class{static isRange(z){return z instanceof f?!0:z?j.isPosition(z.start)&&j.isPosition(z.end):!1}static of(z){if(z instanceof f)return z;if(this.isRange(z))return new f(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(z,be,Re,Ge){let Ze,at;if(typeof z=="number"&&typeof be=="number"&&typeof Re=="number"&&typeof Ge=="number"?(Ze=new j(z,be),at=new j(Re,Ge)):j.isPosition(z)&&j.isPosition(be)&&(Ze=j.of(z),at=j.of(be)),!Ze||!at)throw new Error("Invalid arguments");Ze.isBefore(at)?(this._start=Ze,this._end=at):(this._start=at,this._end=Ze)}contains(z){return f.isRange(z)?this.contains(z.start)&&this.contains(z.end):j.isPosition(z)?!(j.of(z).isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const be=j.Max(z.start,this._start),Re=j.Min(z.end,this._end);if(!be.isAfter(Re))return new f(be,Re)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const be=j.Min(z.start,this._start),Re=j.Max(z.end,this.end);return new f(be,Re)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,be=this.end){if(z===null||be===null)throw(0,A.illegalArgument)();let Re;return z?j.isPosition(z)?Re=z:(Re=z.start||this.start,be=z.end||this.end):Re=this.start,Re.isEqual(this._start)&&be.isEqual(this.end)?this:new f(Re,be)}toJSON(){return[this.start,this.end]}};e.Range=ae=f=je([ee],ae);let we=e.Selection=b=class extends ae{static isSelection(z){return z instanceof b?!0:z?ae.isRange(z)&&j.isPosition(z.anchor)&&j.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(z,be,Re,Ge){let Ze,at;if(typeof z=="number"&&typeof be=="number"&&typeof Re=="number"&&typeof Ge=="number"?(Ze=new j(z,be),at=new j(Re,Ge)):j.isPosition(z)&&j.isPosition(be)&&(Ze=j.of(z),at=j.of(be)),!Ze||!at)throw new Error("Invalid arguments");super(Ze,at),this._anchor=Ze,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=we=b=je([ee],we);const _e=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,A.illegalArgument)("connectionToken")};class ve{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,be,Re){if(typeof z!="string"||z.length===0)throw(0,A.illegalArgument)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,A.illegalArgument)("port");typeof Re<"u"&&_e(Re),this.host=z,this.port=Math.round(be),this.connectionToken=Re}}e.ResolvedAuthority=ve;class M{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,be){this.makeConnection=z,this.connectionToken=be,typeof be<"u"&&_e(be)}}e.ManagedResolvedAuthority=M;class X extends Error{static NotAvailable(z,be){return new X(z,D.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(z){return new X(z,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,be=D.RemoteAuthorityResolverErrorCode.Unknown,Re){super(z),this._message=z,this._code=be,this._detail=Re,Object.setPrototypeOf(this,X.prototype)}}e.RemoteAuthorityResolverError=X;var fe;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var Ee;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Ee||(e.EnvironmentVariableMutatorType=Ee={}));let Z=e.TextEdit=u=class{static isTextEdit(z){return z instanceof u?!0:z?ae.isRange(z)&&typeof z.newText=="string":!1}static replace(z,be){return new u(z,be)}static insert(z,be){return u.replace(new ae(z,z),be)}static delete(z){return u.replace(z,"")}static setEndOfLine(z){const be=new u(new ae(new j(0,0),new j(0,0)),"");return be.newEol=z,be}get range(){return this._range}set range(z){if(z&&!ae.isRange(z))throw(0,A.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,A.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,A.illegalArgument)("newEol");this._newEol=z}constructor(z,be){this._range=z,this._newText=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Z=u=je([ee],Z);let ne=e.NotebookEdit=C=class{static isNotebookCellEdit(z){return z instanceof C?!0:z?Jt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,be){return new C(z,be)}static insertCells(z,be){return new C(new Jt(z,z),be)}static deleteCells(z){return new C(z,[])}static updateCellMetadata(z,be){const Re=new C(new Jt(z,z),[]);return Re.newCellMetadata=be,Re}static updateNotebookMetadata(z){const be=new C(new Jt(0,0),[]);return be.newNotebookMetadata=z,be}constructor(z,be){this.range=z,this.newCells=be}};e.NotebookEdit=ne=C=je([ee],ne);class le{static isSnippetTextEdit(z){return z instanceof le?!0:z?ae.isRange(z.range)&&oe.isSnippetString(z.snippet):!1}static replace(z,be){return new le(z,be)}static insert(z,be){return le.replace(new ae(z,z),be)}constructor(z,be){this.range=z,this.snippet=be}}e.SnippetTextEdit=le;var te;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(te||(e.FileEditType=te={}));let de=e.WorkspaceEdit=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,be,Re,Ge){this._edits.push({_type:1,from:z,to:be,options:Re,metadata:Ge})}createFile(z,be,Re){this._edits.push({_type:1,from:void 0,to:z,options:be,metadata:Re})}deleteFile(z,be,Re){this._edits.push({_type:1,from:z,to:void 0,options:be,metadata:Re})}replaceNotebookMetadata(z,be,Re){this._edits.push({_type:3,metadata:Re,uri:z,edit:{editType:5,metadata:be},notebookMetadata:be})}replaceNotebookCells(z,be,Re,Ge){const Ze=be.start,at=be.end;(Ze!==at||Re.length>0)&&this._edits.push({_type:5,uri:z,index:Ze,count:at-Ze,cells:Re,metadata:Ge})}replaceNotebookCellMetadata(z,be,Re,Ge){this._edits.push({_type:3,metadata:Ge,uri:z,edit:{editType:8,index:be,metadata:Re}})}replace(z,be,Re,Ge){this._edits.push({_type:2,uri:z,edit:new Z(be,Re),metadata:Ge})}insert(z,be,Re,Ge){this.replace(z,new ae(be,be),Re,Ge)}delete(z,be,Re){this.replace(z,be,"",Re)}has(z){return this._edits.some(be=>be._type===2&&be.uri.toString()===z.toString())}set(z,be){if(be)for(const Re of be){if(!Re)continue;let Ge,Ze;Array.isArray(Re)?(Ge=Re[0],Ze=Re[1]):Ge=Re,ne.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.replaceNotebookCellMetadata(z,Ge.range.start,Ge.newCellMetadata,Ze):Ge.newNotebookMetadata?this.replaceNotebookMetadata(z,Ge.newNotebookMetadata,Ze):this.replaceNotebookCells(z,Ge.range,Ge.newCells,Ze):le.isSnippetTextEdit(Ge)?this._edits.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:Ze}):this._edits.push({_type:2,uri:z,edit:Ge,metadata:Ze})}else{for(let Re=0;Re<this._edits.length;Re++){const Ge=this._edits[Re];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this._edits[Re]=void 0);break}}(0,c.coalesceInPlace)(this._edits)}}get(z){const be=[];for(const Re of this._edits)Re._type===2&&Re.uri.toString()===z.toString()&&be.push(Re.edit);return be}entries(){const z=new L.ResourceMap;for(const be of this._edits)if(be._type===2){let Re=z.get(be.uri);Re||(Re=[be.uri,[]],z.set(be.uri,Re)),Re[1].push(be.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=de=je([ee],de);let oe=e.SnippetString=y=class{static isSnippetString(z){return z instanceof y?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this._tabstop=1,this.value=z||""}appendText(z){return this.value+=y._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,be=this._tabstop++){if(typeof z=="function"){const Re=new y;Re._tabstop=this._tabstop,z(Re),this._tabstop=Re._tabstop,z=Re.value}else z=y._escape(z);return this.value+="${",this.value+=be,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,be=this._tabstop++){const Re=z.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(z,be){if(typeof be=="function"){const Re=new y;Re._tabstop=this._tabstop,be(Re),this._tabstop=Re._tabstop,be=Re.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.SnippetString=oe=y=je([ee],oe);var ue;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(ue||(e.DiagnosticTag=ue={}));var O;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(O||(e.DiagnosticSeverity=O={}));let q=e.Location=o=class{static isLocation(z){return z instanceof o?!0:z?ae.isRange(z.range)&&g.URI.isUri(z.uri):!1}constructor(z,be){if(this.uri=z,be)if(ae.isRange(be))this.range=ae.of(be);else if(j.isPosition(be))this.range=new ae(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=q=o=je([ee],q);let Q=e.DiagnosticRelatedInformation=class{static is(z){return z?typeof z.message=="string"&&z.location&&ae.isRange(z.location.range)&&g.URI.isUri(z.location.uri):!1}constructor(z,be){this.location=z,this.message=be}static isEqual(z,be){return z===be?!0:!z||!be?!1:z.message===be.message&&z.location.range.isEqual(be.location.range)&&z.location.uri.toString()===be.location.uri.toString()}};e.DiagnosticRelatedInformation=Q=je([ee],Q);let ie=e.Diagnostic=class{constructor(z,be,Re=O.Error){if(!ae.isRange(z))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=z,this.message=be,this.severity=Re}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,be){return z===be?!0:!z||!be?!1:z.message===be.message&&z.severity===be.severity&&z.code===be.code&&z.severity===be.severity&&z.source===be.source&&z.range.isEqual(be.range)&&(0,c.equals)(z.tags,be.tags)&&(0,c.equals)(z.relatedInformation,be.relatedInformation,Q.isEqual)}};e.Diagnostic=ie=je([ee],ie);let pe=e.Hover=class{constructor(z,be){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=be}};e.Hover=pe=je([ee],pe);var De;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(De||(e.DocumentHighlightKind=De={}));let he=e.DocumentHighlight=class{constructor(z,be=De.Text){this.range=z,this.kind=be}toJSON(){return{range:this.range,kind:De[this.kind]}}};e.DocumentHighlight=he=je([ee],he);var Ae;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var Te;(function(G){G[G.Deprecated=1]="Deprecated"})(Te||(e.SymbolTag=Te={}));let He=e.SymbolInformation=i=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,be,Re,Ge,Ze){this.name=z,this.kind=be,this.containerName=Ze,typeof Re=="string"&&(this.containerName=Re),Ge instanceof q?this.location=Ge:Re instanceof ae&&(this.location=new q(Ge,Re)),i.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=He=i=je([ee],He);let Ve=e.DocumentSymbol=I=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(I.validate)}constructor(z,be,Re,Ge,Ze){this.name=z,this.detail=be,this.kind=Re,this.range=Ge,this.selectionRange=Ze,this.children=[],I.validate(this)}};e.DocumentSymbol=Ve=I=je([ee],Ve);var tt;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(tt||(e.CodeActionTriggerKind=tt={}));let Xe=e.CodeAction=class{constructor(z,be){this.title=z,this.kind=be}};e.CodeAction=Xe=je([ee],Xe);let Ke=e.CodeActionKind=F=class{constructor(z){this.value=z}append(z){return new F(this.value?this.value+F.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+F.sep)}};Ke.sep=".",e.CodeActionKind=Ke=F=je([ee],Ke);class nt extends Ke{constructor(z){super(z),this.value=z}}e.NotebookCodeActionKind=nt,Ke.Empty=new Ke(""),Ke.QuickFix=Ke.Empty.append("quickfix"),Ke.Refactor=Ke.Empty.append("refactor"),Ke.RefactorExtract=Ke.Refactor.append("extract"),Ke.RefactorInline=Ke.Refactor.append("inline"),Ke.RefactorMove=Ke.Refactor.append("move"),Ke.RefactorRewrite=Ke.Refactor.append("rewrite"),Ke.Source=Ke.Empty.append("source"),Ke.SourceOrganizeImports=Ke.Source.append("organizeImports"),Ke.SourceFixAll=Ke.Source.append("fixAll"),Ke.Notebook=Ke.Empty.append("notebook");let ot=e.SelectionRange=class{constructor(z,be){if(this.range=z,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=ot=je([ee],ot);class et{constructor(z,be,Re,Ge,Ze,at){this.kind=z,this.name=be,this.detail=Re,this.uri=Ge,this.range=Ze,this.selectionRange=at}}e.CallHierarchyItem=et;class xe{constructor(z,be){this.fromRanges=be,this.from=z}}e.CallHierarchyIncomingCall=xe;class Ie{constructor(z,be){this.fromRanges=be,this.to=z}}e.CallHierarchyOutgoingCall=Ie;var K;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(K||(e.LanguageStatusSeverity=K={}));let Y=e.CodeLens=class{constructor(z,be){this.range=z,this.command=be}get isResolved(){return!!this.command}};e.CodeLens=Y=je([ee],Y);let me=e.MarkdownString=U=class{static isMarkdownString(z){return z instanceof U?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,be=!1){h.set(this,void 0),Je(this,h,new l.MarkdownString(z,{supportThemeIcons:be}),"f")}get value(){return Oe(this,h,"f").value}set value(z){Oe(this,h,"f").value=z}get isTrusted(){return Oe(this,h,"f").isTrusted}set isTrusted(z){Oe(this,h,"f").isTrusted=z}get supportThemeIcons(){return Oe(this,h,"f").supportThemeIcons}set supportThemeIcons(z){Oe(this,h,"f").supportThemeIcons=z}get supportHtml(){return Oe(this,h,"f").supportHtml}set supportHtml(z){Oe(this,h,"f").supportHtml=z}get baseUri(){return Oe(this,h,"f").baseUri}set baseUri(z){Oe(this,h,"f").baseUri=z}appendText(z){return Oe(this,h,"f").appendText(z),this}appendMarkdown(z){return Oe(this,h,"f").appendMarkdown(z),this}appendCodeblock(z,be){return Oe(this,h,"f").appendCodeblock(be??"",z),this}};h=new WeakMap,e.MarkdownString=me=U=je([ee],me);let Fe=e.ParameterInformation=class{constructor(z,be){this.label=z,this.documentation=be}};e.ParameterInformation=Fe=je([ee],Fe);let We=e.SignatureInformation=class{constructor(z,be){this.label=z,this.documentation=be,this.parameters=[]}};e.SignatureInformation=We=je([ee],We);let ze=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=ze=je([ee],ze);var Ye;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(Ye||(e.SignatureHelpTriggerKind=Ye={}));var ct;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let st=e.InlayHintLabelPart=class{constructor(z){this.value=z}};e.InlayHintLabelPart=st=je([ee],st);let ft=e.InlayHint=class{constructor(z,be,Re){this.position=z,this.label=be,this.kind=Re}};e.InlayHint=ft=je([ee],ft);var kt;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(kt||(e.CompletionTriggerKind=kt={}));var Tt;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Tt||(e.CompletionItemKind=Tt={}));var bt;(function(G){G[G.Deprecated=1]="Deprecated"})(bt||(e.CompletionItemTag=bt={}));let zt=e.CompletionItem=class{constructor(z,be){this.label=z,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&Tt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=zt=je([ee],zt);let Mt=e.CompletionList=class{constructor(z=[],be=!1){this.items=z,this.isIncomplete=be}};e.CompletionList=Mt=je([ee],Mt);let jt=e.InlineSuggestion=class{constructor(z,be,Re){this.insertText=z,this.range=be,this.command=Re}};e.InlineSuggestion=jt=je([ee],jt);let Ft=e.InlineSuggestionList=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.InlineSuggestionList=Ft=je([ee],Ft);var Nt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Nt||(e.ViewColumn=Nt={}));var $t;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function ut(G,z){return`${k.ExtensionIdentifier.toKey(G)}.${z}`}e.asStatusBarItemIdentifier=ut;var gt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var xt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(xt||(e.TextDocumentSaveReason=xt={}));var Ut;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var _t;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(_t||(e.TextEditorSelectionChangeKind=_t={}));var mt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(mt||(e.TextDocumentChangeReason=mt={}));var It;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(It||(e.DecorationRangeBehavior=It={})),function(G){function z(be){switch(be){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=z}(_t||(e.TextEditorSelectionChangeKind=_t={}));let Wt=e.DocumentLink=class{constructor(z,be){if(be&&!g.URI.isUri(be))throw(0,A.illegalArgument)("target");if(!ae.isRange(z)||z.isEmpty)throw(0,A.illegalArgument)("range");this.range=z,this.target=be}};e.DocumentLink=Wt=je([ee],Wt);let Le=e.Color=class{constructor(z,be,Re,Ge){this.red=z,this.green=be,this.blue=Re,this.alpha=Ge}};e.Color=Le=je([ee],Le);let Pe=e.ColorInformation=class{constructor(z,be){if(be&&!(be instanceof Le))throw(0,A.illegalArgument)("color");if(!ae.isRange(z)||z.isEmpty)throw(0,A.illegalArgument)("range");this.range=z,this.color=be}};e.ColorInformation=Pe=je([ee],Pe);let ke=e.ColorPresentation=class{constructor(z){if(!z||typeof z!="string")throw(0,A.illegalArgument)("label");this.label=z}};e.ColorPresentation=ke=je([ee],ke);var ce;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ce||(e.ColorFormat=ce={}));var Me;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Me||(e.SourceControlInputBoxValidationType=Me={}));var Be;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Be||(e.TerminalExitReason=Be={}));class Qe{constructor(z,be,Re){if(this.startIndex=z,this.length=be,this.tooltip=Re,typeof z!="number"||z<0)throw(0,A.illegalArgument)("startIndex");if(typeof be!="number"||be<1)throw(0,A.illegalArgument)("length");if(Re!==void 0&&typeof Re!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Qe;class qe{constructor(z){this.uri=z}}e.TerminalQuickFixOpener=qe;class it{constructor(z){this.terminalCommand=z}}e.TerminalQuickFixCommand=it;var yt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(yt||(e.TerminalLocation=yt={}));class Rt{constructor(z){if(this.options=z,typeof z!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Rt;var Pt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var wt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(wt||(e.TaskPanelKind=wt={}));let lt=e.TaskGroup=$=class{static from(z){switch(z){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(z,be){if(this.label=be,typeof z!="string"||typeof be!="string")throw(0,A.illegalArgument)("name");this._id=z}get id(){return this._id}};lt.Clean=new $("clean","Clean"),lt.Build=new $("build","Build"),lt.Rebuild=new $("rebuild","Rebuild"),lt.Test=new $("test","Test"),e.TaskGroup=lt=$=je([ee],lt);function vt(G){let z="";for(let be=0;be<G.length;be++)z+=G[be].replace(/,/g,",,")+",";return z}let Et=e.ProcessExecution=class{constructor(z,be,Re){if(typeof z!="string")throw(0,A.illegalArgument)("process");this._args=[],this._process=z,be!==void 0&&(Array.isArray(be)?(this._args=be,this._options=Re):this._options=be)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,A.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(const be of this._args)z.push(be);return vt(z)}};e.ProcessExecution=Et=je([ee],Et);let St=e.ShellExecution=class{constructor(z,be,Re){if(this._args=[],Array.isArray(be)){if(!z)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,A.illegalArgument)("command");this._command=z,this._args=be,this._options=Re}else{if(typeof z!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=z,this._options=be}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,A.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const be of this._args)z.push(typeof be=="string"?be:be.value);return vt(z)}};e.ShellExecution=St=je([ee],St);var oi;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(oi||(e.ShellQuoting=oi={}));var Ht;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Ht||(e.TaskScope=Ht={}));class Li{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=Li;let Gt=e.Task=B=class{constructor(z,be,Re,Ge,Ze,at){this.__deprecated=!1,this._definition=this.definition=z;let ht;typeof be=="string"?(this._name=this.name=be,this._source=this.source=Re,this.execution=Ge,ht=Ze,this.__deprecated=!0):be===Ht.Global||be===Ht.Workspace?(this.target=be,this._name=this.name=Re,this._source=this.source=Ge,this.execution=Ze,ht=at):(this.target=be,this._name=this.name=Re,this._source=this.source=Ge,this.execution=Ze,ht=at),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Et?this._definition={type:B.ProcessType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:B.ShellType,id:this._execution.computeId()}:this._execution instanceof Li?this._definition={type:B.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:B.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,A.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const be=this._definition.type;(B.EmptyType===be||B.ProcessType===be||B.ShellType===be||B.ExtensionCallbackType===be)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};Gt.ExtensionCallbackType="customExecution",Gt.ProcessType="process",Gt.ShellType="shell",Gt.EmptyType="$empty",e.Task=Gt=B=je([ee],Gt);var Ei;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Ei||(e.ProgressLocation=Ei={}));var At;(function(G){function z(be){const Re=be;return(0,_.isNumber)(Re.value)?Re.tooltip&&!(0,_.isString)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}G.isViewBadge=z})(At||(e.ViewBadge=At={}));let Fi=e.TreeItem=N=class{static isTreeItem(z,be){const Re=z;if(Re.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(be,"treeItemCheckbox");const Ge=(0,_.isNumber)(Re.checkboxState)?Re.checkboxState:(0,_.isObject)(Re.checkboxState)&&(0,_.isNumber)(Re.checkboxState.state)?Re.checkboxState.state:void 0,Ze=!(0,_.isNumber)(Re.checkboxState)&&(0,_.isObject)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ct.Checked&&Ge!==Ct.Unchecked||Ze!==void 0&&!(0,_.isString)(Ze))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(z instanceof N)return!0;if(Re.label!==void 0&&!(0,_.isString)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,_.isString)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,_.isString)(Re.iconPath)&&!g.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,_.isString)(Re.iconPath.id))){const Ge=Re.iconPath;if(!Ge||!(0,_.isString)(Ge.light)&&!g.URI.isUri(Ge.light)&&!(0,_.isString)(Ge.dark)&&!g.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,_.isString)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!g.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,_.isString)(Re.tooltip)&&!(Re.tooltip instanceof me)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<ai.None&&Re.collapsibleState>ai.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,_.isString)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(z,be=ai.None){this.collapsibleState=be,g.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.TreeItem=Fi=N=je([ee],Fi);var ai;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(ai||(e.TreeItemCollapsibleState=ai={}));var Ct;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let di=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.DataTransferItem=di=je([ee],di);class wi extends di{}e.InternalDataTransferItem=wi;class hi extends wi{constructor(z){super(""),d.set(this,void 0),Je(this,d,z,"f")}asFile(){return Oe(this,d,"f")}}e.InternalFileDataTransferItem=hi,d=new WeakMap;class cn{constructor(z,be,Re,Ge){this.name=z,this.uri=be,this._itemId=Re,this._getData=Ge}data(){return this._getData()}}e.DataTransferFile=cn;let Oi=e.DataTransfer=class{constructor(z){w.add(this),E.set(this,new Map);for(const[be,Re]of z??[]){const Ge=Oe(this,E,"f").get(Oe(this,w,"m",p).call(this,be));Ge?Ge.push(Re):Oe(this,E,"f").set(Oe(this,w,"m",p).call(this,be),[Re])}}get(z){return Oe(this,E,"f").get(Oe(this,w,"m",p).call(this,z))?.[0]}set(z,be){Oe(this,E,"f").set(Oe(this,w,"m",p).call(this,z),[be])}forEach(z,be){for(const[Re,Ge]of Oe(this,E,"f"))for(const Ze of Ge)z.call(be,Ze,Re,this)}*[(E=new WeakMap,w=new WeakSet,Symbol.iterator)](){for(const[z,be]of Oe(this,E,"f"))for(const Re of be)yield[z,Re]}};p=function(z){return z.toLowerCase()},e.DataTransfer=Oi=je([ee],Oi);let Ot=e.DocumentDropEdit=class{constructor(z){this.insertText=z}};e.DocumentDropEdit=Ot=je([ee],Ot);let Si=e.DocumentPasteEdit=class{constructor(z,be,Re){this.id=be,this.label=Re,this.insertText=z}};e.DocumentPasteEdit=Si=je([ee],Si);let Qt=e.ThemeIcon=class{constructor(z,be){this.id=z,this.color=be}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.ThemeIcon=Qt=je([ee],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let ci=e.ThemeColor=class{constructor(z){this.id=z}};e.ThemeColor=ci=je([ee],ci);var li;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let dt=e.RelativePattern=class{get base(){return this._base}set base(z){this._base=z,this._baseUri=g.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}constructor(z,be){if(typeof z!="string"&&(!z||!g.URI.isUri(z)&&!g.URI.isUri(z.uri)))throw(0,A.illegalArgument)("base");if(typeof be!="string")throw(0,A.illegalArgument)("pattern");typeof z=="string"?this.baseUri=g.URI.file(z):g.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=dt=je([ee],dt);const Mi=new WeakMap;function ei(G,z){Mi.set(G,z)}e.setBreakpointId=ei;let Kt=e.Breakpoint=class{constructor(z,be,Re,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof be=="string"&&(this.condition=be),typeof Re=="string"&&(this.hitCondition=Re),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=Mi.get(this)??(0,T.generateUuid)()),this._id}};e.Breakpoint=Kt=je([ee],Kt);let _i=e.SourceBreakpoint=class extends Kt{constructor(z,be,Re,Ge,Ze){if(super(be,Re,Ge,Ze),z===null)throw(0,A.illegalArgument)("location");this.location=z}};e.SourceBreakpoint=_i=je([ee],_i);let Ni=e.FunctionBreakpoint=class extends Kt{constructor(z,be,Re,Ge,Ze){super(be,Re,Ge,Ze),this.functionName=z}};e.FunctionBreakpoint=Ni=je([ee],Ni);let xi=e.DataBreakpoint=class extends Kt{constructor(z,be,Re,Ge,Ze,at,ht){if(super(Ge,Ze,at,ht),!be)throw(0,A.illegalArgument)("dataId");this.label=z,this.dataId=be,this.canPersist=Re}};e.DataBreakpoint=xi=je([ee],xi);let Ui=e.DebugAdapterExecutable=class{constructor(z,be,Re){this.command=z,this.args=be||[],this.options=Re}};e.DebugAdapterExecutable=Ui=je([ee],Ui);let yi=e.DebugAdapterServer=class{constructor(z,be){this.port=z,this.host=be}};e.DebugAdapterServer=yi=je([ee],yi);let Wi=e.DebugAdapterNamedPipeServer=class{constructor(z){this.path=z}};e.DebugAdapterNamedPipeServer=Wi=je([ee],Wi);let Ci=e.DebugAdapterInlineImplementation=class{constructor(z){this.implementation=z}};e.DebugAdapterInlineImplementation=Ci=je([ee],Ci);let ni=e.StackFrameFocus=class{constructor(z,be,Re){this.session=z,this.threadId=be,this.frameId=Re}};e.StackFrameFocus=ni=je([ee],ni);let Bi=e.ThreadFocus=class{constructor(z,be){this.session=z,this.threadId=be}};e.ThreadFocus=Bi=je([ee],Bi);let fi=e.EvaluatableExpression=class{constructor(z,be){this.range=z,this.expression=be}};e.EvaluatableExpression=fi=je([ee],fi);var mi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let zi=e.InlineValueText=class{constructor(z,be){this.range=z,this.text=be}};e.InlineValueText=zi=je([ee],zi);let $i=e.InlineValueVariableLookup=class{constructor(z,be,Re=!0){this.range=z,this.variableName=be,this.caseSensitiveLookup=Re}};e.InlineValueVariableLookup=$i=je([ee],$i);let ri=e.InlineValueEvaluatableExpression=class{constructor(z,be){this.range=z,this.expression=be}};e.InlineValueEvaluatableExpression=ri=je([ee],ri);let Hi=e.InlineValueContext=class{constructor(z,be){this.frameId=z,this.stoppedLocation=be}};e.InlineValueContext=Hi=je([ee],Hi);var Vi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let ji=e.FileSystemError=V=class extends Error{static FileExists(z){return new V(z,m.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(z){return new V(z,m.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(z){return new V(z,m.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(z){return new V(z,m.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(z){return new V(z,m.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(z){return new V(z,m.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(z,be=m.FileSystemProviderErrorCode.Unknown,Re){super(g.URI.isUri(z)?z.toString(!0):z),this.code=Re?.name??"Unknown",(0,m.markAsFileSystemProviderError)(this,be),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.FileSystemError=ji=V=je([ee],ji);let si=e.FoldingRange=class{constructor(z,be,Re){this.start=z,this.end=be,this.kind=Re}};e.FoldingRange=si=je([ee],si);var qi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(qi||(e.FoldingRangeKind=qi={}));var Gi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Di;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Di||(e.CommentMode=Di={}));var Ki;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Ki||(e.CommentState=Ki={}));var Xi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Xi||(e.CommentThreadState=Xi={}));class ln{constructor(z,be=[]){this.tokenTypes=z,this.tokenModifiers=be}}e.SemanticTokensLegend=ln;function Ii(G){return typeof G>"u"||(0,_.isStringArray)(G)}class gi{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let be=0,Re=z.tokenTypes.length;be<Re;be++)this._tokenTypeStrToInt.set(z.tokenTypes[be],be);for(let be=0,Re=z.tokenModifiers.length;be<Re;be++)this._tokenModifierStrToInt.set(z.tokenModifiers[be],be)}}push(z,be,Re,Ge,Ze){if(typeof z=="number"&&typeof be=="number"&&typeof Re=="number"&&typeof Ge=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this._pushEncoded(z,be,Re,Ge,Ze);if(ae.isRange(z)&&typeof be=="string"&&Ii(Re))return this._push(z,be,Re);throw(0,A.illegalArgument)()}_push(z,be,Re){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(be))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,Ze=z.start.character,at=z.end.character-z.start.character,ht=this._tokenTypeStrToInt.get(be);let Bt=0;if(Re)for(const qt of Re){if(!this._tokenModifierStrToInt.has(qt))throw new Error("`tokenModifier` is not in the provided legend");const Xt=this._tokenModifierStrToInt.get(qt);Bt|=1<<Xt>>>0}this._pushEncoded(Ge,Ze,at,ht,Bt)}_pushEncoded(z,be,Re,Ge,Ze){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&be<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Bt=this._data.length/5|0;let qt=0,Xt=0;for(let Zt=0;Zt<Bt;Zt++){let ti=this._data[5*Zt],Ai=this._data[5*Zt+1];ti===0?(ti=qt,Ai+=Xt):ti+=qt,this._data[5*Zt]=ti,this._data[5*Zt+1]=Ai,qt=ti,Xt=Ai}}let at=z,ht=be;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Re,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Ze,this._prevLine=z,this._prevChar=be}static _sortAndDeltaEncode(z){const be=[],Re=z.length/5|0;for(let ht=0;ht<Re;ht++)be[ht]=ht;be.sort((ht,Bt)=>{const qt=z[5*ht],Xt=z[5*Bt];if(qt===Xt){const Zt=z[5*ht+1],ti=z[5*Bt+1];return Zt-ti}return qt-Xt});const Ge=new Uint32Array(z.length);let Ze=0,at=0;for(let ht=0;ht<Re;ht++){const Bt=5*be[ht],qt=z[Bt+0],Xt=z[Bt+1],Zt=z[Bt+2],ti=z[Bt+3],Ai=z[Bt+4],An=qt-Ze,Gn=An===0?Xt-at:Xt,Ri=5*ht;Ge[Ri+0]=An,Ge[Ri+1]=Gn,Ge[Ri+2]=Zt,Ge[Ri+3]=ti,Ge[Ri+4]=Ai,Ze=qt,at=Xt}return Ge}build(z){return this._dataIsSortedAndDeltaEncoded?new Ue(new Uint32Array(this._data),z):new Ue(gi._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=gi;class Ue{constructor(z,be){this.resultId=be,this.data=z}}e.SemanticTokens=Ue;class Yt{constructor(z,be,Re){this.start=z,this.deleteCount=be,this.data=Re}}e.SemanticTokensEdit=Yt;class Qi{constructor(z,be){this.resultId=be,this.edits=z}}e.SemanticTokensEdits=Qi;var pt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(pt||(e.DebugConsoleMode=pt={}));let ki=e.QuickInputButtons=class{constructor(){}};ki.Back={iconPath:new Qt("arrow-left")},e.QuickInputButtons=ki=je([ee],ki);var Yi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Pi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Pi||(e.InputBoxValidationSeverity=Pi={}));var Ji;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Ji||(e.ExtensionKind=Ji={}));class pi{static validate(z){if(typeof z.badge=="string"){let be=(0,P.nextCharLength)(z.badge,0);if(be<z.badge.length&&(be+=(0,P.nextCharLength)(z.badge,be)),z.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Qt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,be,Re){this.badge=z,this.tooltip=be,this.color=Re}}e.FileDecoration=pi;let Zi=e.ColorTheme=class{constructor(z){this.kind=z}};e.ColorTheme=Zi=je([ee],Zi);var en;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class Jt{static isNotebookRange(z){return z instanceof Jt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(z,be){if(z<0)throw(0,A.illegalArgument)("start must be positive");if(be<0)throw(0,A.illegalArgument)("end must be positive");z<=be?(this._start=z,this._end=be):(this._start=be,this._end=z)}with(z){let be=this._start,Re=this._end;return z.start!==void 0&&(be=z.start),z.end!==void 0&&(Re=z.end),be===this._start&&Re===this._end?this:new Jt(be,Re)}}e.NotebookRange=Jt;class ui{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(be=>ui.isNotebookCellData(be))}static isNotebookCellData(z){return!0}constructor(z,be,Re,Ge,Ze,at,ht){this.kind=z,this.value=be,this.languageId=Re,this.mime=Ge,this.outputs=Ze??[],this.metadata=at,this.executionSummary=ht,ui.validate(this)}}e.NotebookCellData=ui;class un{constructor(z){this.cells=z}}e.NotebookData=un;class Vt{static isNotebookCellOutputItem(z){return z instanceof Vt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const be={name:z.name,message:z.message,stack:z.stack};return Vt.json(be,"application/vnd.code.notebook.error")}static stdout(z){return Vt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Vt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,be="application/octet-stream"){return new Vt(z,be)}static text(z,be=R.Mimes.text){const Re=Oe(Vt,t,"f",a).encode(String(z));return new Vt(Re,be)}static json(z,be="text/x-json"){const Re=JSON.stringify(z,void 0,"	");return Vt.text(Re,be)}constructor(z,be){this.data=z,this.mime=be;const Re=(0,R.normalizeMimeType)(be,!0);if(!Re)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.NotebookCellOutputItem=Vt,t=Vt,a={value:new TextEncoder};class vi{static isNotebookCellOutput(z){return z instanceof vi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,be=!1){const Re=new Set,Ge=new Set;for(let Ze=0;Ze<z.length;Ze++){const at=z[Ze],ht=(0,R.normalizeMimeType)(at.mime);if(!Re.has(ht)||(0,S.isTextStreamMime)(ht)){Re.add(ht);continue}Ge.add(Ze),be&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?z:z.filter((Ze,at)=>!Ge.has(at))}constructor(z,be,Re){this.items=vi.ensureUniqueMimeTypes(z,!0),typeof be=="string"?(this.id=be,this.metadata=Re):(this.id=(0,T.generateUuid)(),this.metadata=be??Re)}}e.NotebookCellOutput=vi;var tn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class dn{constructor(z,be){this.text=z,this.alignment=be}}e.NotebookCellStatusBarItem=dn;var on;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var ge;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(ge||(e.NotebookControllerAffinity2=ge={}));class Se{constructor(z,be=[]){this.uri=z,this.provides=(0,c.asArray)(be)}}e.NotebookRendererScript=Se;class Ne{constructor(z){this.label=z}}e.NotebookKernelSourceAction=Ne;let rt=e.TimelineItem=class{constructor(z,be){this.label=z,this.timestamp=be}};e.TimelineItem=rt=je([ee],rt);var Dt;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Dt||(e.ExtensionMode=Dt={}));var Lt;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Lt||(e.ExtensionRuntime=Lt={}));var mn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(mn||(e.StandardTokenType=mn={}));class Mn{constructor(z,be){this.ranges=z,this.wordPattern=be}}e.LinkedEditingRanges=Mn;class Nn{constructor(z){this._autoForwardAction=z}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Nn;var gn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(gn||(e.TestResultState=gn={}));var pn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pn||(e.TestRunProfileKind=pn={}));let hn=e.TestRunRequest=class{constructor(z=void 0,be=void 0,Re=void 0,Ge=!1){this.include=z,this.exclude=be,this.profile=Re,this.continuous=Ge}};e.TestRunRequest=hn=je([ee],hn);let vn=e.TestRunRequest2=class extends hn{};e.TestRunRequest2=vn=je([ee],vn);let bn=e.TestMessage=x=class{static diff(z,be,Re){const Ge=new x(z);return Ge.expectedOutput=be,Ge.actualOutput=Re,Ge}constructor(z){this.message=z}};e.TestMessage=bn=x=je([ee],bn);let En=e.TestTag=class{constructor(z){this.id=z}};e.TestTag=En=je([ee],En);let Ti=e.CoveredCount=class{constructor(z,be){this.covered=z,this.total=be}};e.CoveredCount=Ti=je([ee],Ti);let wn=e.FileCoverage=W=class{static fromDetails(z,be){const Re=new Ti(0,0),Ge=new Ti(0,0),Ze=new Ti(0,0);for(const ht of be)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const Bt of ht.branches)Ge.total+=1,Ge.covered+=Bt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=ht.executionCount>0?1:0;const at=new W(z,Re,Ge.total>0?Ge:void 0,Ze.total>0?Ze:void 0);return at.detailedCoverage=be,at}constructor(z,be,Re,Ge){this.uri=z,this.statementCoverage=be,this.branchCoverage=Re,this.functionCoverage=Ge}};e.FileCoverage=wn=W=je([ee],wn);let Sn=e.StatementCoverage=class{constructor(z,be,Re=[]){this.executionCount=z,this.location=be,this.branches=Re}};e.StatementCoverage=Sn=je([ee],Sn);let _n=e.BranchCoverage=class{constructor(z,be){this.executionCount=z,this.location=be}};e.BranchCoverage=_n=je([ee],_n);let yn=e.FunctionCoverage=class{constructor(z,be){this.executionCount=z,this.location=be}};e.FunctionCoverage=yn=je([ee],yn);var Cn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Cn||(e.ExternalUriOpenerPriority=Cn={}));var Dn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Dn||(e.WorkspaceTrustState=Dn={}));var In;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class xn{constructor(z,be,Re,Ge,Ze,at){this.kind=z,this.name=be,this.detail=Re,this.uri=Ge,this.range=Ze,this.selectionRange=at}}e.TypeHierarchyItem=xn;class Un{constructor(z){this.uri=z}}e.TextTabInput=Un;class Wn{constructor(z,be){this.original=z,this.modified=be}}e.TextDiffTabInput=Wn;class Bn{constructor(z,be,Re,Ge){this.base=z,this.input1=be,this.input2=Re,this.result=Ge}}e.TextMergeTabInput=Bn;class zn{constructor(z,be){this.uri=z,this.viewType=be}}e.CustomEditorTabInput=zn;class $n{constructor(z){this.viewType=z}}e.WebviewEditorTabInput=$n;class Hn{constructor(z,be){this.uri=z,this.notebookType=be}}e.NotebookEditorTabInput=Hn;class Vn{constructor(z,be,Re){this.original=z,this.modified=be,this.notebookType=Re}}e.NotebookDiffEditorTabInput=Vn;class jn{constructor(){}}e.TerminalEditorTabInput=jn;class qn{constructor(z,be){this.uri=z,this.inputBoxUri=be}}e.InteractiveWindowInput=qn;var kn;(function(G){G[G.Up=1]="Up",G[G.Down=2]="Down"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Pn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Pn||(e.InteractiveSessionCopyKind=Pn={}));var Tn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}))}),define(ye[138],Ce([1,0,52,18,11,172,113,7,19]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const g=new Map;function T(S,v){v?g.set(S,v):g.delete(S)}e.setWordDefinitionFor=T;function k(S){return g.get(S)}class m extends L.MirrorTextModel{constructor(v,n,h,d,w,E,p,t){super(n,h,d,w),this._proxy=v,this._languageId=E,this._isDirty=p,this.notebook=t,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,_.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===A.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},save(){return v._save()},getText(n){return n?v._getTextInRange(n):v.getText()},get eol(){return v._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(n){return v._lineAt(n)},offsetAt(n){return v._offsetAt(n)},positionAt(n){return v._positionAt(n)},validateRange(n){return v._validateRange(n)},validatePosition(n){return v._validatePosition(n)},getWordRangeAtPosition(n,h){return v._getWordRangeAtPosition(n,h)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,c.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,c.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const n=this._validateRange(v);if(n.isEmpty)return"";if(n.isSingleLine)return this._lines[n.start.line].substring(n.start.character,n.end.character);const h=this._eol,d=n.start.line,w=n.end.line,E=[];E.push(this._lines[d].substring(n.start.character));for(let p=d+1;p<w;p++)E.push(this._lines[p]);return E.push(this._lines[w].substring(0,n.end.character)),E.join(h)}_lineAt(v){let n;if(v instanceof P.Position?n=v.line:typeof v=="number"&&(n=v),typeof n!="number"||n<0||n>=this._lines.length||Math.floor(n)!==n)throw new Error("Illegal value for `line`");return new D(n,this._lines[n],n===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const n=this._lineStarts.getIndexOf(v),h=this._lines[n.index].length;return new P.Position(n.index,Math.min(n.remainder,h))}_validateRange(v){if(!(v instanceof P.Range))throw new Error("Invalid argument");const n=this._validatePosition(v.start),h=this._validatePosition(v.end);return n===v.start&&h===v.end?v:new P.Range(n.line,n.character,h.line,h.character)}_validatePosition(v){if(!(v instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:n,character:h}=v,d=!1;if(n<0)n=0,h=0,d=!0;else if(n>=this._lines.length)n=this._lines.length-1,h=this._lines[n].length,d=!0;else{const w=this._lines[n].length;h<0?(h=0,d=!0):h>w&&(h=w,d=!0)}return d?new P.Position(n,h):v}_getWordRangeAtPosition(v,n){const h=this._validatePosition(v);if(!n)n=k(this._languageId);else if((0,l.regExpLeadsToEndlessLoop)(n))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${n.source}' because it matches the empty string.`);const d=(0,R.getWordAtText)(h.character+1,(0,R.ensureValidWordDefinition)(n),this._lines[h.line],0);if(d)return new P.Range(h.line,d.startColumn-1,h.line,d.endColumn-1)}}e.ExtHostDocumentData=m;class D{constructor(v,n,h){this._line=v,this._text=n,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=D}),define(ye[262],Ce([1,0,7,20,3]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=e.ExtHostTheming=class{constructor(P){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new l.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let _;switch(P){case"light":_=c.ColorThemeKind.Light;break;case"hcDark":_=c.ColorThemeKind.HighContrast;break;case"hcLight":_=c.ColorThemeKind.HighContrastLight;break;default:_=c.ColorThemeKind.Dark}this._actual=new c.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=L=je([$e(0,A.IExtHostRpcService)],L)}),define(ye[15],Ce([1,0,19,21,153,67,118,28,151,73,92,23,12,2,35,76,125,135,132,100,60,81,258,7]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Le){function Pe(ce){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Qe,positionColumn:qe}=ce,it=new a.Position(Me-1,Be-1),yt=new a.Position(Qe-1,qe-1);return new a.Selection(it,yt)}Le.to=Pe;function ke(ce){const{anchor:Me,active:Be}=ce;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Le.from=ke})(r||(e.Selection=r={}));var s;(function(Le){function Pe(ce){if(!ce)return;const{start:Me,end:Be}=ce;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Le.from=Pe;function ke(ce){if(!ce)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Qe,endColumn:qe}=ce;return new a.Range(Me-1,Be-1,Qe-1,qe-1)}Le.to=ke})(s||(e.Range=s={}));var f;(function(Le){function Pe(ke){switch(ke){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Le.to=Pe})(f||(e.TokenType=f={}));var b;(function(Le){function Pe(ce){return new a.Position(ce.lineNumber-1,ce.column-1)}Le.to=Pe;function ke(ce){return{lineNumber:ce.line+1,column:ce.character+1}}Le.from=ke})(b||(e.Position=b={}));var u;(function(Le){function Pe(Me,Be,Qe){return(0,c.coalesce)((0,c.asArray)(Me).map(qe=>ke(qe,Be,Qe)))}Le.from=Pe;function ke(Me,Be,Qe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Qe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:ce(Me.scheme,Be),pattern:K.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Qe?.isBuiltin}}function ce(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(u||(e.DocumentSelector=u={}));var C;(function(Le){function Pe(ce){switch(ce){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Le.from=Pe;function ke(ce){switch(ce){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Le.to=ke})(C||(e.DiagnosticTag=C={}));var y;(function(Le){function Pe(ce){let Me;return ce.code&&((0,m.isString)(ce.code)||(0,m.isNumber)(ce.code)?Me=String(ce.code):Me={value:String(ce.code.value),target:ce.code.target}),{...s.from(ce.range),message:ce.message,source:ce.source,code:Me,severity:i.from(ce.severity),relatedInformation:ce.relatedInformation&&ce.relatedInformation.map(o.from),tags:Array.isArray(ce.tags)?(0,c.coalesce)(ce.tags.map(C.from)):void 0}}Le.from=Pe;function ke(ce){const Me=new a.Diagnostic(s.to(ce),ce.message,i.to(ce.severity));return Me.source=ce.source,Me.code=(0,m.isString)(ce.code)?ce.code:ce.code?.value,Me.relatedInformation=ce.relatedInformation&&ce.relatedInformation.map(o.to),Me.tags=ce.tags&&(0,c.coalesce)(ce.tags.map(C.to)),Me}Le.to=ke})(y||(e.Diagnostic=y={}));var o;(function(Le){function Pe(ce){return{...s.from(ce.location.range),message:ce.message,resource:ce.location.uri}}Le.from=Pe;function ke(ce){return new a.DiagnosticRelatedInformation(new a.Location(ce.resource,s.to(ce)),ce.message)}Le.to=ke})(o||(e.DiagnosticRelatedInformation=o={}));var i;(function(Le){function Pe(ce){switch(ce){case a.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Le.from=Pe;function ke(ce){switch(ce){case n.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Le.to=ke})(i||(e.DiagnosticSeverity=i={}));var I;(function(Le){function Pe(ce){return typeof ce=="number"&&ce>=a.ViewColumn.One?ce-1:ce===a.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Pe;function ke(ce){if(typeof ce=="number"&&ce>=0)return ce+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=ke})(I||(e.ViewColumn=I={}));function F(Le){return typeof Le.range<"u"}function U(Le){return Le.length===0?!0:!!F(Le[0])}e.isDecorationOptionsArr=U;var $;(function(Le){function Pe(qe){return qe.map(Le.from)}Le.fromMany=Pe;function ke(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function ce(qe){let it;if(ke(qe)){const{language:wt,value:lt}=qe;it={value:"```"+wt+`
`+lt+"\n```\n"}}else a.MarkdownString.isMarkdownString(qe)?it={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?it={value:qe}:it={value:""};const yt=Object.create(null);it.uris=yt;const Rt=wt=>{try{let lt=D.URI.parse(wt,!0);lt=lt.with({query:Me(lt.query,yt)}),yt[wt]=lt}catch{}return""},Pt=new _.marked.Renderer;return Pt.link=Rt,Pt.image=wt=>typeof wt=="string"?Rt(R.parseHrefAndDimensions(wt).href):"",(0,_.marked)(it.value,{renderer:Pt}),it}Le.from=ce;function Me(qe,it){if(!qe)return qe;let yt;try{yt=(0,g.parse)(qe)}catch{}if(!yt)return qe;let Rt=!1;return yt=(0,k.cloneAndChange)(yt,Pt=>{if(D.URI.isUri(Pt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[wt]=Pt,Rt=!0,wt}else return}),Rt?JSON.stringify(yt):qe}function Be(qe){const it=new a.MarkdownString(qe.value,qe.supportThemeIcons);return it.isTrusted=qe.isTrusted,it.supportHtml=qe.supportHtml,it.baseUri=qe.baseUri?D.URI.from(qe.baseUri):void 0,it}Le.to=Be;function Qe(qe){if(qe)return typeof qe=="string"?qe:Le.from(qe)}Le.fromStrict=Qe})($||(e.MarkdownString=$={}));function B(Le){return U(Le)?Le.map(Pe=>({range:s.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?$.fromMany(Pe.hoverMessage):Pe.hoverMessage?$.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Le.map(Pe=>({range:s.from(Pe)}))}e.fromRangeOrRangeWithMessage=B;function N(Le){return typeof Le>"u"?Le:typeof Le=="string"?D.URI.file(Le):Le}e.pathOrURIToURI=N;var V;(function(Le){function Pe(ke){return typeof ke>"u"?ke:{contentText:ke.contentText,contentIconPath:ke.contentIconPath?N(ke.contentIconPath):void 0,border:ke.border,borderColor:ke.borderColor,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,color:ke.color,backgroundColor:ke.backgroundColor,margin:ke.margin,width:ke.width,height:ke.height}}Le.from=Pe})(V||(e.ThemableDecorationAttachmentRenderOptions=V={}));var x;(function(Le){function Pe(ke){return typeof ke>"u"?ke:{backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?N(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?V.from(ke.before):void 0,after:ke.after?V.from(ke.after):void 0}}Le.from=Pe})(x||(e.ThemableDecorationRenderOptions=x={}));var W;(function(Le){function Pe(ke){if(typeof ke>"u")return ke;switch(ke){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Pe})(W||(e.DecorationRangeBehavior=W={}));var ee;(function(Le){function Pe(ke){return{isWholeLine:ke.isWholeLine,rangeBehavior:ke.rangeBehavior?W.from(ke.rangeBehavior):void 0,overviewRulerLane:ke.overviewRulerLane,light:ke.light?x.from(ke.light):void 0,dark:ke.dark?x.from(ke.dark):void 0,backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?N(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?V.from(ke.before):void 0,after:ke.after?V.from(ke.after):void 0}}Le.from=Pe})(ee||(e.DecorationRenderOptions=ee={}));var se;(function(Le){function Pe(ce){return{text:ce.newText,eol:ce.newEol&&nt.from(ce.newEol),range:s.from(ce.range)}}Le.from=Pe;function ke(ce){const Me=new a.TextEdit(s.to(ce.range),ce.text);return Me.newEol=typeof ce.eol>"u"?void 0:nt.to(ce.eol),Me}Le.to=ke})(se||(e.TextEdit=se={}));var H;(function(Le){function Pe(ce,Me){const Be={edits:[]};if(ce instanceof a.WorkspaceEdit){const Qe=new P.ResourceSet;for(const qe of ce._allEntries())qe._type===1&&D.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of ce._allEntries())if(qe._type===1){let it;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?it={type:"base64",value:(0,A.encodeBase64)(A.VSBuffer.wrap(qe.options.contents))}:it={type:"dataTransferItem",id:qe.options.contents._itemId}),Be.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:it},metadata:qe.metadata})}else qe._type===2?Be.edits.push({resource:qe.uri,textEdit:se.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Be.edits.push({resource:qe.uri,textEdit:{range:s.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Be.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Be.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ct.from)}})}return Be}Le.from=Pe;function ke(ce){const Me=new a.WorkspaceEdit,Be=new P.ResourceMap;for(const Qe of ce.edits)if(Qe.textEdit){const qe=Qe,it=D.URI.revive(qe.resource),yt=s.to(qe.textEdit.range),Rt=qe.textEdit.text,Pt=qe.textEdit.insertAsSnippet;let wt;Pt?wt=a.SnippetTextEdit.replace(yt,new a.SnippetString(Rt)):wt=a.TextEdit.replace(yt,Rt);const lt=Be.get(it);lt?lt.push(wt):Be.set(it,[wt])}else Me.renameFile(D.URI.revive(Qe.oldResource),D.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of Be)Me.set(Qe,qe);return Me}Le.to=ke})(H||(e.WorkspaceEdit=H={}));var J;(function(Le){const Pe=Object.create(null);Pe[a.SymbolKind.File]=0,Pe[a.SymbolKind.Module]=1,Pe[a.SymbolKind.Namespace]=2,Pe[a.SymbolKind.Package]=3,Pe[a.SymbolKind.Class]=4,Pe[a.SymbolKind.Method]=5,Pe[a.SymbolKind.Property]=6,Pe[a.SymbolKind.Field]=7,Pe[a.SymbolKind.Constructor]=8,Pe[a.SymbolKind.Enum]=9,Pe[a.SymbolKind.Interface]=10,Pe[a.SymbolKind.Function]=11,Pe[a.SymbolKind.Variable]=12,Pe[a.SymbolKind.Constant]=13,Pe[a.SymbolKind.String]=14,Pe[a.SymbolKind.Number]=15,Pe[a.SymbolKind.Boolean]=16,Pe[a.SymbolKind.Array]=17,Pe[a.SymbolKind.Object]=18,Pe[a.SymbolKind.Key]=19,Pe[a.SymbolKind.Null]=20,Pe[a.SymbolKind.EnumMember]=21,Pe[a.SymbolKind.Struct]=22,Pe[a.SymbolKind.Event]=23,Pe[a.SymbolKind.Operator]=24,Pe[a.SymbolKind.TypeParameter]=25;function ke(Me){return typeof Pe[Me]=="number"?Pe[Me]:6}Le.from=ke;function ce(Me){for(const Be in Pe)if(Pe[Be]===Me)return Number(Be);return a.SymbolKind.Property}Le.to=ce})(J||(e.SymbolKind=J={}));var j;(function(Le){function Pe(ce){switch(ce){case a.SymbolTag.Deprecated:return 1}}Le.from=Pe;function ke(ce){switch(ce){case 1:return a.SymbolTag.Deprecated}}Le.to=ke})(j||(e.SymbolTag=j={}));var ae;(function(Le){function Pe(ce){return{name:ce.name,kind:J.from(ce.kind),tags:ce.tags&&ce.tags.map(j.from),containerName:ce.containerName,location:X.from(ce.location)}}Le.from=Pe;function ke(ce){const Me=new a.SymbolInformation(ce.name,J.to(ce.kind),ce.containerName,X.to(ce.location));return Me.tags=ce.tags&&ce.tags.map(j.to),Me}Le.to=ke})(ae||(e.WorkspaceSymbol=ae={}));var we;(function(Le){function Pe(ce){const Me={name:ce.name||"!!MISSING: name!!",detail:ce.detail,range:s.from(ce.range),selectionRange:s.from(ce.selectionRange),kind:J.from(ce.kind),tags:ce.tags?.map(j.from)??[]};return ce.children&&(Me.children=ce.children.map(Pe)),Me}Le.from=Pe;function ke(ce){const Me=new a.DocumentSymbol(ce.name,ce.detail,J.to(ce.kind),s.to(ce.range),s.to(ce.selectionRange));return(0,c.isNonEmptyArray)(ce.tags)&&(Me.tags=ce.tags.map(j.to)),ce.children&&(Me.children=ce.children.map(ke)),Me}Le.to=ke})(we||(e.DocumentSymbol=we={}));var _e;(function(Le){function Pe(ce){const Me=new a.CallHierarchyItem(J.to(ce.kind),ce.name,ce.detail||"",D.URI.revive(ce.uri),s.to(ce.range),s.to(ce.selectionRange));return Me._sessionId=ce._sessionId,Me._itemId=ce._itemId,Me}Le.to=Pe;function ke(ce,Me,Be){if(Me=Me??ce._sessionId,Be=Be??ce._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:ce.name,detail:ce.detail,kind:J.from(ce.kind),uri:ce.uri,range:s.from(ce.range),selectionRange:s.from(ce.selectionRange),tags:ce.tags?.map(j.from)}}Le.from=ke})(_e||(e.CallHierarchyItem=_e={}));var ve;(function(Le){function Pe(ke){return new a.CallHierarchyIncomingCall(_e.to(ke.from),ke.fromRanges.map(ce=>s.to(ce)))}Le.to=Pe})(ve||(e.CallHierarchyIncomingCall=ve={}));var M;(function(Le){function Pe(ke){return new a.CallHierarchyOutgoingCall(_e.to(ke.to),ke.fromRanges.map(ce=>s.to(ce)))}Le.to=Pe})(M||(e.CallHierarchyOutgoingCall=M={}));var X;(function(Le){function Pe(ce){return{range:ce.range&&s.from(ce.range),uri:ce.uri}}Le.from=Pe;function ke(ce){return new a.Location(D.URI.revive(ce.uri),s.to(ce.range))}Le.to=ke})(X||(e.location=X={}));var fe;(function(Le){function Pe(ce){const Me=ce,Be=ce;return{originSelectionRange:Me.originSelectionRange?s.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:s.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?s.from(Me.targetSelectionRange):void 0}}Le.from=Pe;function ke(ce){return{targetUri:D.URI.revive(ce.uri),targetRange:s.to(ce.range),targetSelectionRange:ce.targetSelectionRange?s.to(ce.targetSelectionRange):void 0,originSelectionRange:ce.originSelectionRange?s.to(ce.originSelectionRange):void 0}}Le.to=ke})(fe||(e.DefinitionLink=fe={}));var Ee;(function(Le){function Pe(ce){return{range:s.from(ce.range),contents:$.fromMany(ce.contents)}}Le.from=Pe;function ke(ce){return new a.Hover(ce.contents.map($.to),s.to(ce.range))}Le.to=ke})(Ee||(e.Hover=Ee={}));var Z;(function(Le){function Pe(ce){return{range:s.from(ce.range),expression:ce.expression}}Le.from=Pe;function ke(ce){return new a.EvaluatableExpression(s.to(ce.range),ce.expression)}Le.to=ke})(Z||(e.EvaluatableExpression=Z={}));var ne;(function(Le){function Pe(ce){if(ce instanceof a.InlineValueText)return{type:"text",range:s.from(ce.range),text:ce.text};if(ce instanceof a.InlineValueVariableLookup)return{type:"variable",range:s.from(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};if(ce instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(ce.range),expression:ce.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Pe;function ke(ce){switch(ce.type){case"text":return{range:s.to(ce.range),text:ce.text};case"variable":return{range:s.to(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};case"expression":return{range:s.to(ce.range),expression:ce.expression}}}Le.to=ke})(ne||(e.InlineValue=ne={}));var le;(function(Le){function Pe(ce){return{frameId:ce.frameId,stoppedLocation:s.from(ce.stoppedLocation)}}Le.from=Pe;function ke(ce){return new a.InlineValueContext(ce.frameId,s.to(ce.stoppedLocation))}Le.to=ke})(le||(e.InlineValueContext=le={}));var te;(function(Le){function Pe(ce){return{range:s.from(ce.range),kind:ce.kind}}Le.from=Pe;function ke(ce){return new a.DocumentHighlight(s.to(ce.range),ce.kind)}Le.to=ke})(te||(e.DocumentHighlight=te={}));var de;(function(Le){function Pe(ke){switch(ke){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Le.to=Pe})(de||(e.CompletionTriggerKind=de={}));var oe;(function(Le){function Pe(ke){return{triggerKind:de.to(ke.triggerKind),triggerCharacter:ke.triggerCharacter}}Le.to=Pe})(oe||(e.CompletionContext=oe={}));var ue;(function(Le){function Pe(ce){switch(ce){case a.CompletionItemTag.Deprecated:return 1}}Le.from=Pe;function ke(ce){switch(ce){case 1:return a.CompletionItemTag.Deprecated}}Le.to=ke})(ue||(e.CompletionItemTag=ue={}));var O;(function(Le){const Pe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ke(Be){return Pe.get(Be)??9}Le.from=ke;const ce=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Me(Be){return ce.get(Be)??a.CompletionItemKind.Property}Le.to=Me})(O||(e.CompletionItemKind=O={}));var q;(function(Le){function Pe(ke,ce){const Me=new a.CompletionItem(ke.label);return Me.insertText=ke.insertText,Me.kind=O.to(ke.kind),Me.tags=ke.tags?.map(ue.to),Me.detail=ke.detail,Me.documentation=R.isMarkdownString(ke.documentation)?$.to(ke.documentation):ke.documentation,Me.sortText=ke.sortText,Me.filterText=ke.filterText,Me.preselect=ke.preselect,Me.commitCharacters=ke.commitCharacters,S.Range.isIRange(ke.range)?Me.range=s.to(ke.range):typeof ke.range=="object"&&(Me.range={inserting:s.to(ke.range.insert),replacing:s.to(ke.range.replace)}),Me.keepWhitespace=typeof ke.insertTextRules>"u"?!1:!!(ke.insertTextRules&1),typeof ke.insertTextRules<"u"&&ke.insertTextRules&4?Me.insertText=new a.SnippetString(ke.insertText):(Me.insertText=ke.insertText,Me.textEdit=Me.range instanceof a.Range?new a.TextEdit(Me.range,Me.insertText):void 0),ke.additionalTextEdits&&ke.additionalTextEdits.length>0&&(Me.additionalTextEdits=ke.additionalTextEdits.map(Be=>se.to(Be))),Me.command=ce&&ke.command?ce.fromInternal(ke.command):void 0,Me}Le.to=Pe})(q||(e.CompletionItem=q={}));var Q;(function(Le){function Pe(ce){if(typeof ce.label!="string"&&!Array.isArray(ce.label))throw new TypeError("Invalid label");return{label:ce.label,documentation:$.fromStrict(ce.documentation)}}Le.from=Pe;function ke(ce){return{label:ce.label,documentation:R.isMarkdownString(ce.documentation)?$.to(ce.documentation):ce.documentation}}Le.to=ke})(Q||(e.ParameterInformation=Q={}));var ie;(function(Le){function Pe(ce){return{label:ce.label,documentation:$.fromStrict(ce.documentation),parameters:Array.isArray(ce.parameters)?ce.parameters.map(Q.from):[],activeParameter:ce.activeParameter}}Le.from=Pe;function ke(ce){return{label:ce.label,documentation:R.isMarkdownString(ce.documentation)?$.to(ce.documentation):ce.documentation,parameters:Array.isArray(ce.parameters)?ce.parameters.map(Q.to):[],activeParameter:ce.activeParameter}}Le.to=ke})(ie||(e.SignatureInformation=ie={}));var pe;(function(Le){function Pe(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(ie.from):[]}}Le.from=Pe;function ke(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(ie.to):[]}}Le.to=ke})(pe||(e.SignatureHelp=pe={}));var De;(function(Le){function Pe(ke,ce){const Me=new a.InlayHint(b.to(ce.position),typeof ce.label=="string"?ce.label:ce.label.map(he.to.bind(void 0,ke)),ce.kind&&Ae.to(ce.kind));return Me.textEdits=ce.textEdits&&ce.textEdits.map(se.to),Me.tooltip=R.isMarkdownString(ce.tooltip)?$.to(ce.tooltip):ce.tooltip,Me.paddingLeft=ce.paddingLeft,Me.paddingRight=ce.paddingRight,Me}Le.to=Pe})(De||(e.InlayHint=De={}));var he;(function(Le){function Pe(ke,ce){const Me=new a.InlayHintLabelPart(ce.label);return Me.tooltip=R.isMarkdownString(ce.tooltip)?$.to(ce.tooltip):ce.tooltip,v.Command.is(ce.command)&&(Me.command=ke.fromInternal(ce.command)),ce.location&&(Me.location=X.to(ce.location)),Me}Le.to=Pe})(he||(e.InlayHintLabelPart=he={}));var Ae;(function(Le){function Pe(ce){return ce}Le.from=Pe;function ke(ce){return ce}Le.to=ke})(Ae||(e.InlayHintKind=Ae={}));var Te;(function(Le){function Pe(ce){return{range:s.from(ce.range),url:ce.target,tooltip:ce.tooltip}}Le.from=Pe;function ke(ce){let Me;if(ce.url)try{Me=typeof ce.url=="string"?D.URI.parse(ce.url,!0):D.URI.revive(ce.url)}catch{}return new a.DocumentLink(s.to(ce.range),Me)}Le.to=ke})(Te||(e.DocumentLink=Te={}));var He;(function(Le){function Pe(ce){const Me=new a.ColorPresentation(ce.label);return ce.textEdit&&(Me.textEdit=se.to(ce.textEdit)),ce.additionalTextEdits&&(Me.additionalTextEdits=ce.additionalTextEdits.map(Be=>se.to(Be))),Me}Le.to=Pe;function ke(ce){return{label:ce.label,textEdit:ce.textEdit?se.from(ce.textEdit):void 0,additionalTextEdits:ce.additionalTextEdits?ce.additionalTextEdits.map(Me=>se.from(Me)):void 0}}Le.from=ke})(He||(e.ColorPresentation=He={}));var Ve;(function(Le){function Pe(ce){return new a.Color(ce[0],ce[1],ce[2],ce[3])}Le.to=Pe;function ke(ce){return[ce.red,ce.green,ce.blue,ce.alpha]}Le.from=ke})(Ve||(e.Color=Ve={}));var tt;(function(Le){function Pe(ce){return{range:s.from(ce.range)}}Le.from=Pe;function ke(ce){return new a.SelectionRange(s.to(ce.range))}Le.to=ke})(tt||(e.SelectionRange=tt={}));var Xe;(function(Le){function Pe(ke){switch(ke){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Le.to=Pe})(Xe||(e.TextDocumentSaveReason=Xe={}));var Ke;(function(Le){function Pe(ce){switch(ce){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Pe;function ke(ce){switch(ce){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Le.to=ke})(Ke||(e.TextEditorLineNumbersStyle=Ke={}));var nt;(function(Le){function Pe(ce){if(ce===a.EndOfLine.CRLF)return 1;if(ce===a.EndOfLine.LF)return 0}Le.from=Pe;function ke(ce){if(ce===1)return a.EndOfLine.CRLF;if(ce===0)return a.EndOfLine.LF}Le.to=ke})(nt||(e.EndOfLine=nt={}));var ot;(function(Le){function Pe(ke){if(typeof ke=="object")return ke.viewId;switch(ke){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Pe})(ot||(e.ProgressLocation=ot={}));var et;(function(Le){function Pe(ce){const Me={start:ce.start+1,end:ce.end+1};return ce.kind&&(Me.kind=xe.from(ce.kind)),Me}Le.from=Pe;function ke(ce){const Me={start:ce.start-1,end:ce.end-1};return ce.kind&&(Me.kind=xe.to(ce.kind)),Me}Le.to=ke})(et||(e.FoldingRange=et={}));var xe;(function(Le){function Pe(ce){if(ce)switch(ce){case a.FoldingRangeKind.Comment:return v.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return v.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return v.FoldingRangeKind.Region}}Le.from=Pe;function ke(ce){if(ce)switch(ce.value){case v.FoldingRangeKind.Comment.value:return a.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports.value:return a.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region.value:return a.FoldingRangeKind.Region}}Le.to=ke})(xe||(e.FoldingRangeKind=xe={}));var Ie;(function(Le){function Pe(ke){if(ke)return{pinned:typeof ke.preview=="boolean"?!ke.preview:void 0,inactive:ke.background,preserveFocus:ke.preserveFocus,selection:typeof ke.selection=="object"?s.from(ke.selection):void 0,override:typeof ke.override=="boolean"?d.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Pe})(Ie||(e.TextEditorOpenOptions=Ie={}));var K;(function(Le){function Pe(Be){return Be instanceof a.RelativePattern?Be.toJSON():typeof Be=="string"?Be:ke(Be)||ce(Be)?new a.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Le.from=Pe;function ke(Be){const Qe=Be;return Qe?D.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function ce(Be){const Qe=Be;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new a.RelativePattern(D.URI.revive(Be.baseUri),Be.pattern)}Le.to=Me})(K||(e.GlobPattern=K={}));var Y;(function(Le){function Pe(ke){if(ke){if(Array.isArray(ke))return ke.map(Pe);if(typeof ke=="string")return ke;{const ce=ke;return{language:ce.language,scheme:ce.scheme,pattern:K.from(ce.pattern),exclusive:ce.exclusive,notebookType:ce.notebookType}}}else return}Le.from=Pe})(Y||(e.LanguageSelector=Y={}));var me;(function(Le){function Pe(ce){return{start:ce.start,end:ce.end}}Le.from=Pe;function ke(ce){return new a.NotebookRange(ce.start,ce.end)}Le.to=ke})(me||(e.NotebookRange=me={}));var Fe;(function(Le){function Pe(ce){return{timing:typeof ce.runStartTime=="number"&&typeof ce.runEndTime=="number"?{startTime:ce.runStartTime,endTime:ce.runEndTime}:void 0,executionOrder:ce.executionOrder,success:ce.lastRunSuccess}}Le.to=Pe;function ke(ce){return{lastRunSuccess:ce.success,runStartTime:ce.timing?.startTime,runEndTime:ce.timing?.endTime,executionOrder:ce.executionOrder}}Le.from=ke})(Fe||(e.NotebookCellExecutionSummary=Fe={}));var We;(function(Le){function Pe(ke){if(ke===w.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ke===w.NotebookCellExecutionState.Pending)return;if(ke===w.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ke}`)}Le.to=Pe})(We||(e.NotebookCellExecutionState=We={}));var ze;(function(Le){function Pe(ce){switch(ce){case a.NotebookCellKind.Markup:return w.CellKind.Markup;case a.NotebookCellKind.Code:default:return w.CellKind.Code}}Le.from=Pe;function ke(ce){switch(ce){case w.CellKind.Markup:return a.NotebookCellKind.Markup;case w.CellKind.Code:default:return a.NotebookCellKind.Code}}Le.to=ke})(ze||(e.NotebookCellKind=ze={}));var Ye;(function(Le){function Pe(ce){const Me={metadata:ce.metadata??Object.create(null),cells:[]};for(const Be of ce.cells)a.NotebookCellData.validate(Be),Me.cells.push(ct.from(Be));return Me}Le.from=Pe;function ke(ce){const Me=new a.NotebookData(ce.cells.map(ct.to));return(0,m.isEmptyObject)(ce.metadata)||(Me.metadata=ce.metadata),Me}Le.to=ke})(Ye||(e.NotebookData=Ye={}));var ct;(function(Le){function Pe(ce){return{cellKind:ze.from(ce.kind),language:ce.languageId,mime:ce.mime,source:ce.value,metadata:ce.metadata,internalMetadata:Fe.from(ce.executionSummary??{}),outputs:ce.outputs?ce.outputs.map(ft.from):[]}}Le.from=Pe;function ke(ce){return new a.NotebookCellData(ze.to(ce.cellKind),ce.source,ce.language,ce.mime,ce.outputs?ce.outputs.map(ft.to):void 0,ce.metadata,ce.internalMetadata?Fe.to(ce.internalMetadata):void 0)}Le.to=ke})(ct||(e.NotebookCellData=ct={}));var st;(function(Le){function Pe(ce){return{mime:ce.mime,valueBytes:A.VSBuffer.wrap(ce.data)}}Le.from=Pe;function ke(ce){return new a.NotebookCellOutputItem(ce.valueBytes.buffer,ce.mime)}Le.to=ke})(st||(e.NotebookCellOutputItem=st={}));var ft;(function(Le){function Pe(ce){return{outputId:ce.id,items:ce.items.map(st.from),metadata:ce.metadata}}Le.from=Pe;function ke(ce){const Me=ce.items.map(st.to);return new a.NotebookCellOutput(Me,ce.outputId,ce.metadata)}Le.to=ke})(ft||(e.NotebookCellOutput=ft={}));var kt;(function(Le){function Pe(Me){return ce(Me)?{include:(0,m.withNullAsUndefined)(K.from(Me.include)),exclude:(0,m.withNullAsUndefined)(K.from(Me.exclude))}:(0,m.withNullAsUndefined)(K.from(Me))}Le.from=Pe;function ke(Me){return ce(Me)?{include:K.to(Me.include),exclude:K.to(Me.exclude)}:K.to(Me)}Le.to=ke;function ce(Me){const Be=Me;return Be?!(0,m.isUndefinedOrNull)(Be.include)&&!(0,m.isUndefinedOrNull)(Be.exclude):!1}})(kt||(e.NotebookExclusiveDocumentPattern=kt={}));var Tt;(function(Le){function Pe(ke,ce,Me){const Be=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{alignment:ke.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:ce.toInternal(Be,Me),text:ke.text,tooltip:ke.tooltip,accessibilityInformation:ke.accessibilityInformation,priority:ke.priority}}Le.from=Pe})(Tt||(e.NotebookStatusBarItem=Tt={}));var bt;(function(Le){function Pe(ke,ce,Me){const Be=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{command:ce.toInternal(Be,Me),label:ke.label,description:ke.description,detail:ke.detail,documentation:ke.documentation}}Le.from=Pe})(bt||(e.NotebookKernelSourceAction=bt={}));var zt;(function(Le){function Pe(ke){return{transientOutputs:ke?.transientOutputs??!1,transientCellMetadata:ke?.transientCellMetadata??{},transientDocumentMetadata:ke?.transientDocumentMetadata??{},cellContentMetadata:ke?.cellContentMetadata??{}}}Le.from=Pe})(zt||(e.NotebookDocumentContentOptions=zt={}));var Mt;(function(Le){function Pe(ce){return{uri:ce.uri,provides:ce.provides}}Le.from=Pe;function ke(ce){return new a.NotebookRendererScript(D.URI.revive(ce.uri),ce.provides)}Le.to=ke})(Mt||(e.NotebookRendererScript=Mt={}));var jt;(function(Le){function Pe(ce){return{message:$.fromStrict(ce.message)||"",type:0,expected:ce.expectedOutput,actual:ce.actualOutput,location:ce.location&&{range:s.from(ce.location.range),uri:ce.location.uri}}}Le.from=Pe;function ke(ce){const Me=new a.TestMessage(typeof ce.message=="string"?ce.message:$.to(ce.message));return Me.actualOutput=ce.actual,Me.expectedOutput=ce.expected,Me.location=ce.location?X.to(ce.location):void 0,Me}Le.to=ke})(jt||(e.TestMessage=jt={}));var Ft;(function(Le){Le.namespace=p.namespaceTestTag,Le.denamespace=p.denamespaceTestTag})(Ft||(e.TestTag=Ft={}));var Nt;(function(Le){function Pe(ce){const Me=(0,h.getPrivateApiFor)(ce).controllerId;return{extId:E.TestId.fromExtHostTestItem(ce,Me).toString(),label:ce.label,uri:D.URI.revive(ce.uri),busy:ce.busy,tags:ce.tags.map(Be=>Ft.namespace(Me,Be.id)),range:S.Range.lift(s.from(ce.range)),description:ce.description||null,sortText:ce.sortText||null,error:ce.error&&$.fromStrict(ce.error)||null}}Le.from=Pe;function ke(ce){return{parent:void 0,error:void 0,id:E.TestId.fromString(ce.extId).localId,label:ce.label,uri:D.URI.revive(ce.uri),tags:(ce.tags||[]).map(Me=>{const{tagId:Be}=Ft.denamespace(Me);return new a.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(ce.range||void 0),canResolveChildren:!1,busy:ce.busy,description:ce.description||void 0,sortText:ce.sortText||void 0}}Le.toPlain=ke})(Nt||(e.TestItem=Nt={})),function(Le){function Pe(ce){return{id:ce.id}}Le.from=Pe;function ke(ce){return new a.TestTag(ce.id)}Le.to=ke}(Ft||(e.TestTag=Ft={}));var $t;(function(Le){const Pe=(ce,Me)=>{const Be=[];for(const[qe,it]of Me)E.TestId.compare(it.item.extId,qe)===2&&(Me.delete(qe),Be.push(it));const Qe={...Nt.toPlain(ce.item),parent:void 0,taskStates:ce.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(it=>it.type===0).map(jt.to)})),children:Be.map(qe=>Pe(qe,Me))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function ke(ce){const Me=[],Be=new Map;for(const Qe of ce.items){Be.set(Qe.item.extId,Qe);const qe=E.TestId.root(Qe.item.extId);ce.request.targets.some(it=>it.controllerId===qe&&it.testIds.includes(Qe.item.extId))&&Me.push(Qe)}return{completedAt:ce.completedAt,results:Me.map(Qe=>Pe(Qe,Be))}}Le.to=ke})($t||(e.TestResults=$t={}));var ut;(function(Le){function Pe(Be){return{covered:Be.covered,total:Be.covered}}function ke(Be){return"line"in Be?b.from(Be):s.from(Be)}function ce(Be){return"branches"in Be?{count:Be.executionCount,location:ke(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ke(Qe.location)})):void 0}:{type:0,count:Be.executionCount,location:ke(Be.location)}}Le.fromDetailed=ce;function Me(Be){return{uri:Be.uri,statement:Pe(Be.statementCoverage),branch:Be.branchCoverage&&Pe(Be.branchCoverage),function:Be.functionCoverage&&Pe(Be.functionCoverage),details:Be.detailedCoverage?.map(ce)}}Le.fromFile=Me})(ut||(e.TestCoverage=ut={}));var gt;(function(Le){function Pe(ke){switch(ke){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Le.to=Pe})(gt||(e.CodeActionTriggerKind=gt={}));var xt;(function(Le){function Pe(ce){const Me=new a.TypeHierarchyItem(J.to(ce.kind),ce.name,ce.detail||"",D.URI.revive(ce.uri),s.to(ce.range),s.to(ce.selectionRange));return Me._sessionId=ce._sessionId,Me._itemId=ce._itemId,Me}Le.to=Pe;function ke(ce,Me,Be){if(Me=Me??ce._sessionId,Be=Be??ce._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:J.from(ce.kind),name:ce.name,detail:ce.detail??"",uri:ce.uri,range:s.from(ce.range),selectionRange:s.from(ce.selectionRange),tags:ce.tags?.map(j.from)}}Le.from=ke})(xt||(e.TypeHierarchyItem=xt={}));var Ut;(function(Le){function Pe(ke){if(ke)return{value:ke.value,tooltip:ke.tooltip}}Le.from=Pe})(Ut||(e.ViewBadge=Ut={}));var _t;(function(Le){function Pe(Be,Qe,qe){const it=Qe.fileData;return it?new a.InternalFileDataTransferItem(new a.DataTransferFile(it.name,D.URI.revive(it.uri),it.id,(0,L.once)(()=>qe(it.id)))):Be===T.Mimes.uriList&&Qe.uriListData?new a.InternalDataTransferItem(Me(Qe.uriListData)):new a.InternalDataTransferItem(Qe.asString)}Le.to=Pe;async function ke(Be,Qe){const qe=await Qe.asString();if(Be===T.Mimes.uriList)return{asString:qe,fileData:void 0,uriListData:ce(qe)};const it=Qe.asFile();return{asString:qe,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Le.from=ke;function ce(Be){return l.UriList.split(Be).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return D.URI.parse(Qe)}catch{}return Qe})}function Me(Be){return l.UriList.create(Be.map(Qe=>typeof Qe=="string"?Qe:D.URI.revive(Qe)))}})(_t||(e.DataTransferItem=_t={}));var mt;(function(Le){function Pe(ce,Me){const Be=ce.items.map(([Qe,qe])=>[Qe,_t.to(Qe,qe,Me)]);return new a.DataTransfer(Be)}Le.toDataTransfer=Pe;async function ke(ce){const Me={items:[]},Be=[];for(const[Qe,qe]of ce)Be.push((async()=>{Me.items.push([Qe,await _t.from(Qe,qe)])})());return await Promise.all(Be),Me}Le.from=ke})(mt||(e.DataTransfer=mt={}));var It;(function(Le){function Pe(ce){return{message:ce.message,metadata:ce.metadata,title:ce.title,tooltip:ce.tooltip}}Le.to=Pe;function ke(ce){return{kind:"reply",message:ce.message,metadata:ce.metadata,title:ce.title,tooltip:ce.tooltip}}Le.from=ke})(It||(e.ChatReplyFollowup=It={}));var Wt;(function(Le){function Pe(ke){return typeof ke=="string"?{title:ke,message:ke,kind:"reply"}:"commandId"in ke?{kind:"command",title:ke.title??"",commandId:ke.commandId??"",args:ke.args}:It.from(ke)}Le.from=Pe})(Wt||(e.ChatFollowup=Wt={}))}),define(ye[263],Ce([1,0,2,8,7,15,68]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(g,T,k,m={timeout:1500,errors:3}){this._logService=g,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=m,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(g){return(T,k,m)=>{const S={dispose:this._callbacks.push([T,k,g])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(g,T){const k=c.URI.revive(g);let m=!1;const D=setTimeout(()=>m=!0,this._thresholds.timeout),S=[];try{for(const v of[...this._callbacks]){if(m)break;const n=this._documents.getDocument(k),h=await this._deliverEventAsyncAndBlameBadListeners(v,{document:n,reason:L.TextDocumentSaveReason.to(T)});S.push(h)}}finally{clearTimeout(D)}return S}_deliverEventAsyncAndBlameBadListeners([g,T,k],m){const D=this._badListeners.get(g);return typeof D=="number"&&D>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,g,T,m).then(()=>!0,S=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const v=this._badListeners.get(g);this._badListeners.set(g,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(g,T,k,m){const D=[],S=Date.now(),{document:v,reason:n}=m,{version:h}=v,d=Object.freeze({document:v,reason:n,waitUntil(w){if(Object.isFrozen(D))throw(0,A.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(w))}});try{T.apply(k,[d])}catch(w){return Promise.reject(w)}return Object.freeze(D),new Promise((w,E)=>{const p=setTimeout(()=>E(new Error("timeout")),this._thresholds.timeout);return Promise.all(D).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(p),w(t)}).catch(t=>{clearTimeout(p),E(t)})}).then(w=>{const E={edits:[]};for(const p of w)if(Array.isArray(p)&&p.every(t=>t instanceof l.TextEdit))for(const{newText:t,newEol:a,range:r}of p)E.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:r&&L.Range.from(r),text:t,eol:a&&L.EndOfLine.from(a)}});if(E.edits.length!==0)return h===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[264],Ce([1,0,18,2,15,7,100]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(k,m,D,S){this.start=k,this.deletedCount=m,this.deletedItems=D,this.items=S}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class _{static asModelAddData(k,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,m,D){this.notebook=k,this._extHostDocument=m,this._cellData=D,this.handle=D.handle,this.uri=A.URI.revive(D.uri),this.cellKind=D.cellKind,this._outputs=D.outputs.map(l.NotebookCellOutput.to),this._internalMetadata=D.internalMetadata??{},this._metadata=Object.freeze(D.metadata??{}),this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:l.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return k._mime},set mime(S){k._mime=S},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(D)}return this._apiCell}setOutputs(k){this._outputs=k.map(l.NotebookCellOutput.to)}setOutputItems(k,m,D){const S=D.map(l.NotebookCellOutputItem.to),v=this._outputs.find(n=>n.id===k);if(v&&(m||(v.items.length=0),v.items.push(...S),v.items.length>1&&v.items.every(n=>R.isTextStreamMime(n.mime)))){const n=new Map,h=[];v.items.forEach(d=>{let w;n.has(d.mime)?w=n.get(d.mime):(w=[],n.set(d.mime,w),h.push(d.mime)),w.push(d.data)}),v.items.length=0,h.forEach(d=>{const w=R.compressOutputItemStreams(n.get(d));v.items.push({mime:d,data:w.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=_;class g{constructor(k,m,D,S,v){this._proxy=k,this._textDocumentsAndEditors=m,this._textDocuments=D,this.uri=S,this.handle=g._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=v.viewType,this._metadata=Object.freeze(v.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,v.cells]],!0,void 0),this._versionId=v.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,m={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===c.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(D){return D=k._validateIndex(D),k._cells[D].apiCell},getCells(D){return(D?k._getCells(D):k._cells).map(v=>v.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,m,D){this._versionId=k.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:D});const S={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},v=[];for(const h of k.rawEvents)h.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1,S.contentChanges):h.kind===R.NotebookCellsChangeType.Move?this._moveCells(h.index,h.length,h.newIdx,S.contentChanges):h.kind===R.NotebookCellsChangeType.Output?(this._setCellOutputs(h.index,h.outputs),v.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===R.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems),v.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(h.index,h.language),v.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document})):h.kind===R.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document}):h.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(h.index,h.metadata),v.push({cell:this._cells[h.index].apiCell,metadata:this._cells[h.index].apiCell.metadata})):h.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(h.index,h.internalMetadata),v.push({cell:this._cells[h.index].apiCell,executionSummary:this._cells[h.index].apiCell.executionSummary}));const n=new Map;for(let h=0;h<v.length;h++){const d=v[h],w=n.get(d.cell);if(w===void 0){const E=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});n.set(d.cell,E-1)}else S.cellChanges[w]={...S.cellChanges[w],...d}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let m=k.start|0,D=k.end|0;return m<0&&(m=0),D>this._cells.length&&(D=this._cells.length),k.with({start:m,end:D})}_getCells(k){k=this._validateRange(k);const m=[];for(let D=k.start;D<k.end;D++)m.push(this._cells[D]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,m,D){if(this._disposed)return;const S=[],v=[],n=[];if(k.reverse().forEach(h=>{const w=h[2].map(t=>{const a=new _(this,this._textDocumentsAndEditors,t);return m||v.push(_.asModelAddData(this.apiNotebook,t)),a}),E=new P(h[0],h[1],[],w),p=this._cells.splice(h[0],h[1],...w);for(const t of p)n.push(t.uri),E.deletedItems.push(t.apiCell);S.push(E)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:n}),D)for(const h of S)D.push(h.asApiEvent())}_moveCells(k,m,D,S){const v=this._cells.splice(k,m);this._cells.splice(D,0,...v);const n=[new P(k,m,v.map(h=>h.apiCell),[]),new P(D,0,[],v)];for(const h of n)S.push(h.asApiEvent())}_setCellOutputs(k,m){this._cells[k].setOutputs(m)}_setCellOutputItems(k,m,D,S){this._cells[k].setOutputItems(m,D,S)}_changeCellLanguage(k,m){const D=this._cells[k];D.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(D.uri,m)}_changeCellMime(k,m){const D=this._cells[k];D.apiCell.mime=m}_changeCellMetadata(k,m){this._cells[k].setMetadata(m)}_changeCellInternalMetadata(k,m){this._cells[k].setInternalMetadata(m)}getCellFromApiCell(k){return this._cells.find(m=>m.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(m=>m.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=g,g._handlePool=0}),define(ye[265],Ce([1,0,3,2,15,7]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(_,g,T,k={timeout:1500,errors:3}){this._logService=_,this._notebooksAndEditors=g,this._mainThreadBulkEdits=T,this._thresholds=k,this._onWillSaveNotebookDocumentEvent=new c.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(_){return(g,T,k)=>{const m=function(S){g.call(T,S)};return m.extension=_,this._onWillSaveNotebookDocumentEvent.event(m,void 0,k)}}async $participateInSave(_,g,T){const k=A.URI.revive(_),m=this._notebooksAndEditors.getNotebookDocument(k);if(!m)throw new Error("Unable to resolve notebook document");const D=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:m.apiNotebook,reason:l.TextDocumentSaveReason.to(g)},T,async(v,n)=>{const h=Date.now(),d=await await Promise.resolve(v);Date.now()-h>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!T.isCancellationRequested&&d&&(d instanceof L.WorkspaceEdit?D.push(d):this._logService.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data"))}),T.isCancellationRequested)return!1;if(D.length===0)return!0;const S={edits:[]};for(const v of D){const{edits:n}=l.WorkspaceEdit.from(v);S.edits=S.edits.concat(n)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(S)}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(ye[139],Ce([1,0,8,15,7]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(P,_,g,T,k,m){this.id=P,this._proxy=_,this.notebookData=g,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=T,this._viewColumn=m}get apiEditor(){if(!this._editor){const P=this;this._editor={get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(_){this.selections=[_]},get selections(){return P._selections},set selections(_){if(!Array.isArray(_)||!_.every(l.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");P._selections=_,P._trySetSelections(_)},get visibleRanges(){return P._visibleRanges},revealRange(_,g){P._proxy.$tryRevealRange(P.id,A.NotebookRange.from(_),g??l.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},L.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(A.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(ye[266],Ce([1,0,8,3,17,15]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=e.ExtHostNotebookEditors=class{constructor(_,g){this._logService=_,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new A.Emitter({onListenerError:c.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new A.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(_,g){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,g);const T=this._notebooksAndEditors.getEditorById(_);g.visibleRanges&&T._acceptVisibleRanges(g.visibleRanges.ranges.map(L.NotebookRange.to)),g.selections&&T._acceptSelections(g.selections.selections.map(L.NotebookRange.to)),g.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),g.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const g in _)this._notebooksAndEditors.getEditorById(g)._acceptViewColumn(L.ViewColumn.to(_[g]))}};e.ExtHostNotebookEditors=R=je([$e(0,l.ILogService)],R)}),define(ye[267],Ce([1,0,15,127,193,22,66,8]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,D,S){const v=this._handles++,{title:n,location:h,cancellable:d}=D,w={label:(0,l.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(v,{location:c.ProgressLocation.from(h),title:n,source:w,cancellable:d},m.isUnderDevelopment?void 0:m.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(v,S,!!d)}_withProgress(m,D,S){let v;S&&(v=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,v));const n=d=>{this._proxy.$progressEnd(d),this._mapHandleToCancellationSource.delete(d),v?.dispose()};let h;try{h=D(new T(this._proxy,m),S&&v?v.token:L.CancellationToken.None)}catch(d){throw n(m),d}return h.then(d=>n(m),d=>n(m)),h}$acceptProgressCanceled(m){const D=this._mapHandleToCancellationSource.get(m);D&&(D.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=_;function g(k,m){return k.message=m.message,typeof m.increment=="number"&&(typeof k.increment=="number"?k.increment+=m.increment:k.increment=m.increment),k}class T extends A.Progress{constructor(m,D){super(S=>this.throttledReport(S)),this._proxy=m,this._handle=D}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}je([(0,R.throttle)(100,(k,m)=>g(k,m),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(ye[140],Ce([1,0,35,135,60,101,81,15,2]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(w,E,p,t)=>{let a=E;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!p(a,r)){const s=a;a=r,w.listener?.(t(r,s))}}}},T=(w,E)=>w===E,k={range:(w,E)=>w===E?!0:!w||!E?!1:w.isEqual(E),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(w,E)=>!(w.length!==E.length||w.some(p=>!E.find(t=>p.id===t.id)))},m=w=>E=>({op:4,update:w(E)}),D=(w,E)=>({range:(()=>{let p;const t=m(a=>({range:c.Range.lift(P.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return p},set(a){w.listener?.({op:6}),k.range(p,a)||(p=a,w.listener?.(t(a)))}}})(),label:g(w,E,k.label,m(p=>({label:p}))),description:g(w,void 0,k.description,m(p=>({description:p}))),sortText:g(w,void 0,k.sortText,m(p=>({sortText:p}))),canResolveChildren:g(w,!1,k.canResolveChildren,p=>({op:2,state:p})),busy:g(w,!1,k.busy,m(p=>({busy:p}))),error:g(w,void 0,k.error,m(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:g(w,[],k.tags,(p,t)=>({op:1,new:p.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),S=w=>{const E=l.TestId.fromString(w.extId),p=new n(E.controllerId,E.localId,w.label,_.URI.revive(w.uri)||void 0);return p.range=P.Range.to(w.range||void 0),p.description=w.description||void 0,p.sortText=w.sortText||void 0,p.tags=w.tags.map(t=>P.TestTag.to({id:(0,R.denamespaceTestTag)(t).tagId})),p},v=w=>{let E;for(const p of w.tests){const t=S(p.item);(0,A.getPrivateApiFor)(t).parent=E,E=t}return E};e.toItemFromContext=v;class n{constructor(E,p,t,a){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,A.createPrivateApiFor)(this,E);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof h?void 0:r.parent}},children:{value:(0,L.createTestItemChildren)(r,A.getPrivateApiFor,n),enumerable:!0,writable:!1},...D(r,t)})}}e.TestItemImpl=n;class h extends n{constructor(E,p){super(E,E,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class d extends L.TestItemCollection{constructor(E,p,t){super({controllerId:E,getDocumentVersion:a=>a&&t.getDocument(a)?.version,getApiFor:A.getPrivateApiFor,getChildren:a=>a.children,root:new h(E,p),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(ye[141],Ce([1,0,52,8,109,15,7]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(m,D,S){const v=P._Keys.nextId();m.$registerTextEditorDecorationType(D.identifier,v,L.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:v,dispose(){m.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=P,P._Keys=new l.IdGenerator("TextEditorDecorationType");class _{constructor(m,D){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=D.undoStopBefore,this._undoStopAfter=D.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,D){this._throwIfFinalized();let S=null;if(m instanceof R.Position)S=new R.Range(m,m);else if(m instanceof R.Range)S=m;else throw new Error("Unrecognized location");this._pushEdit(S,D,!1)}insert(m,D){this._throwIfFinalized(),this._pushEdit(new R.Range(m,m),D,!0)}delete(m){this._throwIfFinalized();let D=null;if(m instanceof R.Range)D=m;else throw new Error("Unrecognized location");this._pushEdit(D,null,!0)}_pushEdit(m,D,S){const v=this._document.validateRange(m);this._collectedEdits.push({range:v,text:D,forceMoveMarkers:S})}setEndOfLine(m){if(this._throwIfFinalized(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this._setEndOfLine=m}}class g{constructor(m,D,S,v){this._proxy=m,this._id=D,this._accept(S),this._logService=v;const n=this;this.value={get tabSize(){return n._tabSize},set tabSize(h){n._setTabSize(h)},get indentSize(){return n._indentSize},set indentSize(h){n._setIndentSize(h)},get insertSpaces(){return n._insertSpaces},set insertSpaces(h){n._setInsertSpaces(h)},get cursorStyle(){return n._cursorStyle},set cursorStyle(h){n._setCursorStyle(h)},get lineNumbers(){return n._lineNumbers},set lineNumbers(h){n._setLineNumbers(h)}}}_accept(m){this._tabSize=m.tabSize,this._indentSize=m.indentSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const D=Math.floor(m);return D>0?D:null}if(typeof m=="string"){const D=parseInt(m,10);return isNaN(D)?null:D>0?D:null}return null}_setTabSize(m){const D=this._validateTabSize(m);if(D!==null){if(typeof D=="number"){if(this._tabSize===D)return;this._tabSize=D}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:D}))}}_validateIndentSize(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const D=Math.floor(m);return D>0?D:null}if(typeof m=="string"){const D=parseInt(m,10);return isNaN(D)?null:D>0?D:null}return null}_setIndentSize(m){const D=this._validateIndentSize(m);if(D!==null){if(typeof D=="number"){if(this._indentSize===D)return;this._indentSize=D}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:D}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:!!m}_setInsertSpaces(m){const D=this._validateInsertSpaces(m);if(typeof D=="boolean"){if(this._insertSpaces===D)return;this._insertSpaces=D}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:D}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const D={};let S=!1;if(typeof m.tabSize<"u"){const v=this._validateTabSize(m.tabSize);v==="auto"?(S=!0,D.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,S=!0,D.tabSize=v)}if(typeof m.indentSize<"u"){const v=this._validateIndentSize(m.indentSize);v==="tabSize"?(S=!0,D.indentSize=v):typeof v=="number"&&this._indentSize!==v&&(this._indentSize=v,S=!0,D.indentSize=v)}if(typeof m.insertSpaces<"u"){const v=this._validateInsertSpaces(m.insertSpaces);v==="auto"?(S=!0,D.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,S=!0,D.insertSpaces=v)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,S=!0,D.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,S=!0,D.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,D))}_warnOnError(m,D){D.catch(S=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(S)})}}e.ExtHostTextEditorOptions=g;class T{constructor(m,D,S,v,n,h,d,w){this.id=m,this._proxy=D,this._logService=S,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._options=new g(this._proxy,this.id,h,S),this._visibleRanges=d,this._viewColumn=w;const E=this;this.value=Object.freeze({get document(){return v.value},set document(p){throw(0,A.readonly)("document")},get selection(){return E._selections&&E._selections[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,A.illegalArgument)("selection");E._selections=[p],E._trySetSelection()},get selections(){return E._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof R.Selection)))throw(0,A.illegalArgument)("selections");E._selections=p,E._trySetSelection()},get visibleRanges(){return E._visibleRanges},set visibleRanges(p){throw(0,A.readonly)("visibleRanges")},get options(){return E._options.value},set options(p){E._disposed||E._options.assign(p)},get viewColumn(){return E._viewColumn},set viewColumn(p){throw(0,A.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(E._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new _(v.value,t);return p(a),E._applyEdit(a)},insertSnippet(p,t,a={undoStopBefore:!0,undoStopAfter:!0}){if(E._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=E._selections.map(s=>L.Range.from(s));else if(t instanceof R.Position){const{lineNumber:s,column:f}=L.Position.from(t);r=[{startLineNumber:s,startColumn:f,endLineNumber:s,endColumn:f}]}else if(t instanceof R.Range)r=[L.Range.from(t)];else{r=[];for(const s of t)if(s instanceof R.Range)r.push(L.Range.from(s));else{const{lineNumber:f,column:b}=L.Position.from(s);r.push({startLineNumber:f,startColumn:b,endLineNumber:f,endColumn:b})}}return D.$tryInsertSnippet(m,v.value.version,p.value,r,a)},setDecorations(p,t){const a=t.length===0;a&&!E._hasDecorationsForKey.has(p.key)||(a?E._hasDecorationsForKey.delete(p.key):E._hasDecorationsForKey.add(p.key),E._runOnProxy(()=>{if(L.isDecorationOptionsArr(t))return D.$trySetDecorations(m,p.key,L.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let s=0,f=t.length;s<f;s++){const b=t[s];r[4*s]=b.start.line+1,r[4*s+1]=b.start.character+1,r[4*s+2]=b.end.line+1,r[4*s+3]=b.end.character+1}return D.$trySetDecorationsFast(m,p.key,r)}}))},revealRange(p,t){E._runOnProxy(()=>D.$tryRevealRange(m,L.Range.from(p),t||R.TextEditorRevealType.Default))},show(p){D.$tryShowEditor(m,L.ViewColumn.from(p))},hide(){D.$tryHideEditor(m)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,c.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,c.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,c.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,c.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const D=m.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const S=D.edits.map(n=>n.range);S.sort((n,h)=>n.end.line===h.end.line?n.end.character===h.end.character?n.start.line===h.start.line?n.start.character-h.start.character:n.start.line-h.start.line:n.end.character-h.end.character:n.end.line-h.end.line);for(let n=0,h=S.length-1;n<h;n++){const d=S[n].end;if(S[n+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=D.edits.map(n=>({range:L.Range.from(n.range),text:n.text,forceMoveMarkers:n.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,v,{setEndOfLine:typeof D.setEndOfLine=="number"?L.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this._logService.warn(D),null))}}e.ExtHostTextEditor=T}),define(ye[268],Ce([1,0,197,7,24,2,3,4,249,16,7,12,19,15,22,25,160]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(E,p){if((0,k.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let t;return Array.isArray(E.highlights)&&(t=E.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),t=t.length?t:void 0),{label:E.label,highlights:t}}}class d{constructor(p,t,a){this._proxy=p,this.commands=t,this.logService=a,this.treeViews=new Map,this.treeDragAndDropService=new n.TreeViewsDnDService;function r(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:s=>r(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(f=>r(f)?this.convertArgument(f):f):s})}registerTreeDataProvider(p,t,a){const r=this.createTreeView(p,{treeDataProvider:t},a);return{dispose:()=>r.dispose()}}createTreeView(p,t,a){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],s=t.dragAndDropController?.dragMimeTypes??[],f=!!t.dragAndDropController?.handleDrag,b=!!t.dragAndDropController?.handleDrop,u=this.createExtHostTreeView(p,t,a),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:s,hasHandleDrag:f,hasHandleDrop:b,manuallyManageCheckboxes:!!t.manuallyManageCheckboxSelection},y=this._proxy.$registerTreeViewDataProvider(p,C);return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,v.checkProposedApiEnabled)(a,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(o){u.message=o},get title(){return u.title},set title(o){u.title=o},get description(){return u.description},set description(o){u.description=o},get badge(){return u.badge},set badge(o){o!==void 0&&T.ViewBadge.isViewBadge(o)?u.badge={value:Math.floor(Math.abs(o.value)),tooltip:o.tooltip}:o===void 0&&(u.badge=void 0)},reveal:(o,i)=>u.reveal(o,i),dispose:async()=>{await y,this.treeViews.delete(p),u.dispose()}}}$getChildren(p,t){const a=this.treeViews.get(p);return a?a.getChildren(t):Promise.reject(new _.NoTreeViewError(p))}async $handleDrop(p,t,a,r,s,f,b,u){const C=this.treeViews.get(p);if(!C)return Promise.reject(new _.NoTreeViewError(p));const y=D.DataTransfer.toDataTransfer(a,async o=>(await this._proxy.$resolveDropFileData(p,t,o)).buffer);return b===p&&u&&await this.addAdditionalTransferItems(y,C,u,s,f),C.onDrop(y,r,s)}async addAdditionalTransferItems(p,t,a,r,s){const f=this.treeDragAndDropService.removeDragOperationTransfer(s);if(f)(await f)?.forEach((b,u)=>{b&&p.set(u,b)});else if(s&&t.handleDrag){const b=t.handleDrag(a,p,r);this.treeDragAndDropService.addDragOperationTransfer(s,b),await b}return p}async $handleDrag(p,t,a,r){const s=this.treeViews.get(p);if(!s)return Promise.reject(new _.NoTreeViewError(p));const f=await this.addAdditionalTransferItems(new A.DataTransfer,s,t,r,a);if(!(!f||r.isCancellationRequested))return D.DataTransfer.from(f)}async $hasResolve(p){const t=this.treeViews.get(p);if(!t)throw new _.NoTreeViewError(p);return t.hasResolve}$resolve(p,t,a){const r=this.treeViews.get(p);if(!r)throw new _.NoTreeViewError(p);return r.resolveTreeItem(t,a)}$setExpanded(p,t,a){const r=this.treeViews.get(p);if(!r)throw new _.NoTreeViewError(p);r.setExpanded(t,a)}$setSelection(p,t){const a=this.treeViews.get(p);if(!a)throw new _.NoTreeViewError(p);a.setSelection(t)}$setFocus(p,t){const a=this.treeViews.get(p);if(!a)throw new _.NoTreeViewError(p);a.setFocus(t)}$setVisible(p,t){const a=this.treeViews.get(p);if(!a)throw new _.NoTreeViewError(p);a.setVisible(t)}$changeCheckboxState(p,t){const a=this.treeViews.get(p);if(!a)throw new _.NoTreeViewError(p);a.setCheckboxState(t)}createExtHostTreeView(p,t,a){const r=new w(p,t,this._proxy,this.commands.converter,this.logService,a);return this.treeViews.set(p,r),r}convertArgument(p){const t=this.treeViews.get(p.$treeViewId);return t&&"$treeItemHandle"in p?t.getExtensionElement(p.$treeItemHandle):t&&"$focusedTreeItem"in p&&p.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=d;class w extends P.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,k.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,t,a,r,s,f){if(super(),this.viewId=p,this.proxy=a,this.commands=r,this.logService=s,this.extension=f,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new R.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new S.CancellationTokenSource,f.contributes&&f.contributes.views)for(const C in f.contributes.views)for(const y of f.contributes.views[C])y.id===p&&(this._title=y.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(C=>this._onDidChangeData.fire({message:!1,element:C})));let b,u;this._register(R.Event.debounce(this._onDidChangeData.event,(C,y)=>(C||(C={message:!1,elements:[]}),y.element!==!1&&(b||(b=new Promise(o=>u=o),this.refreshPromise=this.refreshPromise.then(()=>b)),Array.isArray(y.element)?C.elements.push(...y.element):C.elements.push(y.element)),y.message&&(C.message=!0),C),200,!0)(({message:C,elements:y})=>{y.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=u;return b=null,this.refresh(y).then(()=>o())})),C&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(p){const t=p?this.getExtensionElement(p):void 0;if(p&&!t)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let a=this.getChildrenNodes(p);return a||(a=await this.fetchChildrenNodes(t)),a?a.map(r=>r.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,t){t=t||{select:!0,focus:!1};const a=(0,k.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,k.isUndefinedOrNull)(t.focus)?!1:t.focus,s=(0,k.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(f=>this.resolveTreeNode(p,f[f.length-1]).then(b=>this.proxy.$reveal(this.viewId,{item:b.item,parentChain:f.map(u=>u.item)},{select:a,focus:r,expand:s})),f=>this.logService.error(f)):this.proxy.$reveal(this.viewId,void 0,{select:a,focus:r,expand:s})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=D.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,t){const a=this.getExtensionElement(p);a&&(t?this._onDidExpandElement.fire(Object.freeze({element:a})):this._onDidCollapseElement.fire(Object.freeze({element:a})))}setSelection(p){(0,m.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this._focusedHandle=p}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const t=(await Promise.all(p.map(async a=>{const r=this.getExtensionElement(a.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:a.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);t.forEach(a=>{a.treeItem.checkboxState=a.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(a=>[a.extensionItem,a.newState])})}async handleDrag(p,t,a){const r=[];for(const s of p){const f=this.getExtensionElement(s);f&&r.push(f)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,t,a),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,t,a){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.dndController?.handleDrop))return(0,g.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,p,a):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,t){if(!this.dataProvider.resolveTreeItem)return;const a=this.elements.get(p);if(a){const r=this.nodes.get(a);if(r){const s=await this.dataProvider.resolveTreeItem(r.extensionItem,a,t)??r.extensionItem;return this.validateTreeItem(s),r.item.tooltip=this.getTooltip(s.tooltip),r.item.command=this.getCommand(r.disposableStore,s.command),r.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(t=>t?this.resolveUnknownParentChain(t).then(a=>this.resolveTreeNode(t,a[a.length-1]).then(r=>(a.push(r),a))):Promise.resolve([]))}resolveParent(p){const t=this.nodes.get(p);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,g.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,t){const a=this.nodes.get(p);return a?Promise.resolve(a):(0,g.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(r=>this.createHandle(p,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const s=this.getExtensionElement(r);if(s){const f=this.nodes.get(s);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(p){if(p){let t;if(typeof p=="string"){const a=this.getExtensionElement(p);t=a?this.nodes.get(a):void 0}else t=p;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const t=new S.CancellationTokenSource(this._refreshCancellationSource.token);try{const a=p?this.nodes.get(p):void 0,r=await this.dataProvider.getChildren(p);if(t.token.isCancellationRequested)return;const s=await Promise.all((0,m.coalesce)(r||[]).map(async f=>{const b=await this.dataProvider.getTreeItem(f);return b&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(f,b,a):null}));return t.token.isCancellationRequested?void 0:(0,m.coalesce)(s)}finally{t.dispose()}}refresh(p){if(p.some(a=>!a))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new S.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const a=this.getHandlesToRefresh(p);if(a.length)return this.refreshHandles(a)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const t=new Set,a=p.map(s=>this.nodes.get(s));for(const s of a)if(s&&!t.has(s.item.handle)){let f=s;for(;f&&f.parent&&a.findIndex(b=>f&&f.parent&&b&&b.item.handle===f.parent.item.handle)===-1;){const b=this.elements.get(f.parent.item.handle);f=b?this.nodes.get(b):void 0}f&&!f.parent&&t.add(s.item.handle)}const r=[];return t.forEach(s=>{const f=this.elements.get(s);if(f){const b=this.nodes.get(f);b&&(!b.parent||!t.has(b.parent.item.handle))&&r.push(s)}}),r}refreshHandles(p){const t={};return Promise.all(p.map(a=>this.refreshNode(a).then(r=>{r&&(t[a]=r.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(p){const t=this.getExtensionElement(p);if(t){const a=this.nodes.get(t);if(a)return this.clearChildren(t),(0,g.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(r=>{if(r){const s=this.createTreeNode(t,r,a.parent);return this.updateNodeCache(t,s,a,a.parent),a.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,t,a){const r=this.createTreeNode(p,t,a);if(t.id&&this.elements.has(r.item.handle))throw new Error((0,c.localize)(0,null,t.id));return this.addNodeToCache(p,r),this.addNodeToParentCache(r,a),r}getTooltip(p){return T.MarkdownString.isMarkdownString(p)?D.MarkdownString.from(p):p}getCommand(p,t){return t?{...this.commands.toInternal(t,p),originalId:t.command}:void 0}getCheckbox(p){if(p.checkboxState===void 0)return;let t,a,r;return typeof p.checkboxState=="number"?t=p.checkboxState:(t=p.checkboxState.state,a=p.checkboxState.tooltip,r=p.checkboxState.accessibilityInformation),{isChecked:t===T.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:r}}validateTreeItem(p){if(!T.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,t,a){this.validateTreeItem(t);const r=new P.DisposableStore,s=this.createHandle(p,t,a),f=this.getLightIconPath(t);return{item:{handle:s,parentHandle:a?a.item.handle:void 0,label:h(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(r,t.command),contextValue:t.contextValue,icon:f,iconDark:this.getDarkIconPath(t)||f,themeIcon:this.getThemeIcon(t),collapsibleState:(0,k.isUndefinedOrNull)(t.collapsibleState)?T.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:a,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(p){return p.iconPath instanceof T.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:t,label:a,resourceUri:r},s,f){if(t)return`${w.ID_HANDLE_PREFIX}/${t}`;const b=h(a,this.extension),u=s?s.item.handle:w.LABEL_HANDLE_PREFIX;let C=b?b.label:r?(0,l.basename)(r):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const y=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,o=this.getChildrenNodes(s)||[];let i,I=0;do{if(i=`${u}/${I}:${C}`,f||!this.elements.has(i)||y===i)break;I++}while(I<=o.length);return i}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof T.ThemeIcon))return typeof p.iconPath=="string"||L.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof T.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return L.URI.isUri(p)?p:L.URI.file(p)}addNodeToCache(p,t){this.elements.set(t.item.handle,p),this.nodes.set(p,t)}updateNodeCache(p,t,a,r){this.elements.delete(t.item.handle),this.nodes.delete(p),t.item.handle!==a.item.handle&&this.elements.delete(a.item.handle),this.addNodeToCache(p,t);const s=this.getChildrenNodes(r)||[],f=s.filter(b=>b.item.handle===a.item.handle)[0];f&&s.splice(s.indexOf(f),1,t)}addNodeToParentCache(p,t){t?(t.children||(t.children=[]),t.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const t=this.nodes.get(p);if(t){if(t.children)for(const a of t.children){const r=this.elements.get(a.item.handle);r&&this.clear(r)}t.children=void 0}}else this.clearAll()}clear(p){const t=this.nodes.get(p);if(t){if(t.children)for(const a of t.children){const r=this.elements.get(a.item.handle);r&&this.clear(r)}this.nodes.delete(p),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(ye[269],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[270],Ce([1,0,209,8,41,124,99,42,26,269,229,130]),function(re,e,c,A,l,L,R,P,_,g,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=P.Registry.as(R.Extensions.JSONContribution);class D{constructor(p,t,a){this._messageHandler=p,this._extension=t,this._extensionPointId=a}_msg(p,t){this._messageHandler({type:p,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(l.default.Error,p)}warn(p){this._msg(l.default.Warning,p)}info(p){this._msg(l.default.Info,p)}}e.ExtensionMessageCollector=D;class S{static _toSet(p){const t=new _.ExtensionIdentifierSet;for(let a=0,r=p.length;a<r;a++)t.add(p[a].description.identifier);return t}static compute(p,t){if(!p||!p.length)return new S(t,[]);if(!t||!t.length)return new S([],p);const a=this._toSet(p),r=this._toSet(t),s=t.filter(b=>!a.has(b.description.identifier)),f=p.filter(b=>!r.has(b.description.identifier));return new S(s,f)}constructor(p,t){this.added=p,this.removed=t}}e.ExtensionPointUserDelta=S;class v{constructor(p,t){this.name=p,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=S.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,A.onUnexpectedError)(p)}}}e.ExtensionPoint=v;const n={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:_.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:n,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const t=new v(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,t),p.activationEventsGenerator&&k.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,m.registerSchema(h,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const w={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(w.ExtensionsRegistry,new d),e.ExtensionsRegistry=P.Registry.as(w.ExtensionsRegistry),m.registerSchema(h,e.schema),m.registerSchema(T.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(ye[271],Ce([1,0,206,12,23,270,47,3]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const _={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var g;(function(m){function D(S,v,n){if(!S)return;const h=A.isString(S.type)?S.type:void 0;if(!h||h.length===0){n.error(c.localize(3,null));return}const d=[];if(Array.isArray(S.required))for(const w of S.required)A.isString(w)&&d.push(w);return{extensionId:v.value,taskType:h,required:d,properties:S.properties?l.deepClone(S.properties):{},when:S.when?R.ContextKeyExpr.deserialize(S.when):void 0}}m.from=D})(g||(g={}));const T=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,D)=>{for(const S of m)S.type&&D.push(`onTaskType:${S.type}`)},jsonSchema:{description:c.localize(4,null),type:"array",items:_}});class k{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((D,S)=>{T.setHandler((v,n)=>{this._schema=void 0;try{for(const h of n.removed){const d=h.value;for(const w of d)this.taskTypes&&w.type&&this.taskTypes[w.type]&&delete this.taskTypes[w.type]}for(const h of n.added){const d=h.value;for(const w of d){const E=g.from(w,h.description.identifier,h.collector);E&&(this.taskTypes[E.taskType]=E)}}(n.removed.length>0||n.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}D(void 0)})})}onReady(){return this.readyPromise}get(D){return this.taskTypes[D]}all(){return Object.keys(this.taskTypes).map(D=>this.taskTypes[D])}getJsonSchema(){if(this._schema===void 0){const D=[];for(const S of this.all()){const v={type:"object",additionalProperties:!1};S.required.length>0&&(v.required=S.required.slice(0)),S.properties!==void 0?v.properties=l.deepClone(S.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[S.taskType]},D.push(v)}this._schema={oneOf:D}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(ye[272],Ce([1,0,207,12,24,23,47,271]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var _;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(_||(e.ShellQuoting=_={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function V(x){if(!x)return N.Strong;switch(x.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=V}(_||(e.ShellQuoting=_={}));var g;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var T;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(T||(e.RevealKind=T={})),function(N){function V(x){switch(x.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=V}(T||(e.RevealKind=T={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(N){function V(x){switch(x.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=V}(k||(e.RevealProblemKind=k={}));var m;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(m||(e.PanelKind=m={})),function(N){function V(x){switch(x.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=V}(m||(e.PanelKind=m={}));var D;(function(N){N.defaults={echo:!0,reveal:T.Always,revealProblems:k.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(D||(e.PresentationOptions=D={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function V(W){switch(W.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=V;function x(W){switch(W){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=x}(S||(e.RuntimeType=S={}));var v;(function(N){function V(x){return A.isString(x)?x:x.value}N.value=V})(v||(e.CommandString=v={}));var n;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function V(W){return W===N.Clean._id||W===N.Build._id||W===N.Rebuild._id||W===N.Test._id}N.is=V;function x(W){if(W!==void 0)return A.isString(W)?V(W)?{_id:W,isDefault:!1}:void 0:W}N.from=x})(n||(e.TaskGroup=n={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var d;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function V(x){switch(x){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=V})(d||(e.TaskSourceKind=d={}));var w;(function(N){N.parallel="parallel",N.sequence="sequence"})(w||(e.DependsOrder=w={}));var E;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(p||(e.RunOptions=p={}));class t{constructor(V,x,W,ee,se,H){this._label="",this._id=V,x&&(this._label=x),W&&(this.type=W),this.runOptions=ee,this.configurationProperties=se,this._source=H}getDefinition(V){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const V={folder:this.getFolderId(),id:this._id};return JSON.stringify(V)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,x=!1){if(V===void 0)return!1;if(A.isString(V))return V===this._label||V===this.configurationProperties.identifier||x&&V===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),V&&(this._taskLoadMessages=this._taskLoadMessages.concat(V))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class a extends t{constructor(V,x,W,ee,se,H,J,j){super(V,W,void 0,J,j,x),this.command={},this._source=x,this.hasDefinedMatchers=H,se&&(this.command=se)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case S.Shell:x="shell";break;case S.Process:x="process";break;case S.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(V){return V instanceof a}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let x=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(x+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:x};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(V){return new a(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.CustomTask=a;class r extends t{constructor(V,x,W,ee,se,H,J){super(V,W,ee,H,J,x),this._source=x,this.configures=se}static is(V){return V instanceof r}fromObject(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let x=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(x+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:x};return JSON.stringify(W)}}e.ConfiguringTask=r;class s extends t{constructor(V,x,W,ee,se,H,J,j,ae){super(V,W,ee,j,ae,x),this.defines=se,this.hasDefinedMatchers=J,this.command=H,this.icon=ae.icon,this.hide=ae.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof s}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.getFolderId(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(V){return new s(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.ContributedTask=s;class f extends t{constructor(V,x,W,ee,se,H){super(V,W,ee,se,H,x),this._source=x}clone(){return new f(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof f}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(V){return new f(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.InMemoryTask=f;var b;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(N){N._default=N.Terminal}(b||(e.ExecutionEngine=b={}));var u;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class C{constructor(V){this._order=new Map;for(let x=0;x<V.length;x++)this._order.set(V[x].uri.toString(),x)}compare(V,x){const W=V.getWorkspaceFolder(),ee=x.getWorkspaceFolder();if(W&&ee){let se=this._order.get(W.uri.toString());se=se===void 0?0:se+1;let H=this._order.get(ee.uri.toString());return H=H===void 0?0:H+1,se===H?V._label.localeCompare(x._label):se-H}else return!W&&ee?-1:W&&!ee?1:0}}e.TaskSorter=C;var y;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(y||(e.TaskEventKind=y={}));var o;(function(N){N.SingleRun="singleRun",N.Background="background"})(o||(e.TaskRunType=o={}));var i;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(i||(e.TaskRunSource=i={}));var I;(function(N){function V(x,W,ee,se){if(W){const H={kind:x,taskId:W._id,taskName:W.configurationProperties.name,runType:W.configurationProperties.isBackground?"background":"singleRun",group:W.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ee,__task:W};return x==="start"?H.resolvedVariables=se:x==="processStarted"?H.processId=se:x==="processEnded"&&(H.exitCode=se),Object.freeze(H)}else return Object.freeze({kind:"changed"})}N.create=V})(I||(e.TaskEvent=I={}));var F;(function(N){function V(W){const ee=Object.keys(W).sort();let se="";for(const H of ee){let J=W[H];J instanceof Object?J=V(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),se+=H+","+J+","}return se}function x(W){const se={_key:V(W),type:W.taskType};return Object.assign(se,W),se}N.create=x})(F||(e.KeyedTaskIdentifier=F={}));var U;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(U||(e.TaskSettingId=U={}));var $;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})($||(e.TasksSchemaProperties=$={}));var B;(function(N){function V(x,W){const ee=P.TaskDefinitionRegistry.get(x.type);if(ee===void 0){const j=L.deepClone(x);return delete j._key,F.create(j)}const se=Object.create(null);se.type=ee.taskType;const H=new Set;ee.required.forEach(j=>H.add(j));const J=ee.properties;for(const j of Object.keys(J)){const ae=x[j];if(ae!=null)se[j]=ae;else if(H.has(j)){const we=J[j];if(we.default!==void 0)se[j]=L.deepClone(we.default);else switch(we.type){case"boolean":se[j]=!1;break;case"number":case"integer":se[j]=0;break;case"string":se[j]="";break;default:W.error(c.localize(2,null,JSON.stringify(x,void 0,0),j));return}}}return F.create(se)}N.createTaskIdentifier=V})(B||(e.TaskDefinition=B={}))}),define(ye[273],Ce([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,P)=>{this._actualOk=R,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,c.onUnexpectedError)(R))}then(R,P){return this._ensureActual().then(R,P)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=A;class l extends A{constructor(){super(),this._hasErr=!0,this._err=new c.CancellationError}}e.CanceledLazyPromise=l}),define(ye[61],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(_){this._proxyIdentifierBrand=void 0,this.sid=_,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const A=[];function l(P){const _=new c(P);return A[_.nid]=_,_}e.createProxyIdentifier=l;function L(P){return A[P].sid}e.getStringIdentifierForProxy=L;class R{constructor(_){this.value=_}}e.SerializableObjectWithBuffers=R}),define(ye[6],Ce([1,0,61]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var l;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(l||(e.TabInputKind=l={}));var L;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var P;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var _;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(_||(e.CellOutputKind=_={}));var g;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var T;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class k{static mixin(n){return n._id=k._n++,n}}e.IdObject=k,k._n=0;var m;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var D;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var S;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,c.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,c.createProxyIdentifier)("MainThreadChat"),MainThreadInteractiveEditor:(0,c.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,c.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,c.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,c.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,c.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,c.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,c.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostChat:(0,c.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,c.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,c.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,c.createProxyIdentifier)("ExtHostIssueReporter")}}),define(ye[83],Ce([1,0,5,17,6,20]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let R=e.ExtHostApiDeprecationService=class{constructor(_,g){this._extHostLogService=g,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(l.MainContext.MainThreadTelemetry)}report(_,g,T){const k=this.getUsageKey(_,g);this._reportedUsages.has(k)||(this._reportedUsages.add(k),g.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:_}))}getUsageKey(_,g){return`${_}-${g.identifier.value}`}};e.ExtHostApiDeprecationService=R=je([$e(0,L.IExtHostRpcService),$e(1,A.ILogService)],R),e.NullApiDeprecationService=Object.freeze(new class{report(P,_,g){}})}),define(ye[274],Ce([1,0,3,6,7,26]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(g){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new P,this._getSessionsTaskSingler=new P,this._proxy=g.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(g){return this._providers=g,Promise.resolve()}async getSession(g,T,k,m={}){const D=L.ExtensionIdentifier.toKey(g.identifier),S=[...k].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${D} ${T} ${S}`,async()=>{await this._proxy.$ensureProvider(T);const v=g.displayName||g.name;return this._proxy.$getSession(T,k,D,v,m)})}async getSessions(g,T,k){const m=L.ExtensionIdentifier.toKey(g.identifier),D=[...k].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${m} ${D}`,async()=>{await this._proxy.$ensureProvider(T);const S=g.displayName||g.name;return this._proxy.$getSessions(T,k,m,S)})}async removeSession(g,T){const k=this._authenticationProviders.get(g);return k?k.provider.removeSession(T):this._proxy.$removeSession(g,T)}registerAuthenticationProvider(g,T,k,m){if(this._authenticationProviders.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this._authenticationProviders.set(g,{label:T,provider:k,options:m??{supportsMultipleAccounts:!1}}),this._providers.find(S=>S.id===g)||this._providers.push({id:g,label:T});const D=k.onDidChangeSessions(S=>{this._proxy.$sendDidChangeSessions(g,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this._proxy.$registerAuthenticationProvider(g,T,m?.supportsMultipleAccounts??!1),new l.Disposable(()=>{D.dispose(),this._authenticationProviders.delete(g);const S=this._providers.findIndex(v=>v.id===g);S>-1&&this._providers.splice(S),this._proxy.$unregisterAuthenticationProvider(g)})}$createSession(g,T,k){const m=this._authenticationProviders.get(g);if(m)return Promise.resolve(m.provider.createSession(T,k));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,T){const k=this._authenticationProviders.get(g);if(k)return Promise.resolve(k.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,T){const k=this._authenticationProviders.get(g);if(k)return Promise.resolve(k.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,T){return this._onDidChangeSessions.fire({provider:{id:g,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=R;class P{constructor(){this._inFlightPromises=new Map}getOrCreate(g,T){const k=this._inFlightPromises.get(g);if(k)return k;const m=T().finally(()=>this._inFlightPromises.delete(g));return this._inFlightPromises.set(g,m),m}}}),define(ye[275],Ce([1,0,6,20,15]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=e.ExtHostBulkEdits=class{constructor(P,_){this._proxy=P.getProxy(c.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:g=>_.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,_,g){const T=l.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(T,void 0,g?.isRefactoring??!1)}};e.ExtHostBulkEdits=L=je([$e(0,A.IExtHostRpcService)],L)}),define(ye[276],Ce([1,0,3,4,40,12,188,6,15]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class g{constructor(m,D){this.extension=m,this.provider=D,this.handle=g._pool++}}g._pool=0;class T{constructor(m,D){this.logService=D,this._chatProvider=new Map,this._slashCommandProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new c.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=m.getProxy(P.MainContext.MainThreadChat)}registerChatProvider(m,D,S){const v=new g(m,S);return this._chatProvider.set(v.handle,v),this._proxy.$registerChatProvider(v.handle,D),(0,A.toDisposable)(()=>{this._proxy.$unregisterChatProvider(v.handle),this._chatProvider.delete(v.handle)})}addChatRequest(m){this._proxy.$addRequest(m)}sendInteractiveRequestToProvider(m,D){this._proxy.$sendRequestToProvider(m,D)}async $prepareChat(m,D,S){const v=this._chatProvider.get(m);if(!v)return;const n=await v.provider.prepareSession(D,S);if(!n)return;const h=T._nextId++;return this._chatSessions.set(h,n),{id:h,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveRequest(m,D,S,v){const n=this._chatProvider.get(m);if(!n)return;const h=this._chatSessions.get(D);if(!h||!n.provider.resolveRequest)return;const d=await n.provider.resolveRequest(h,S,v);if(d)return{message:typeof d.message=="string"?d.message:_.ChatReplyFollowup.from(d.message)}}async $provideWelcomeMessage(m,D){const S=this._chatProvider.get(m);if(!S||!S.provider.provideWelcomeMessage)return;const v=await S.provider.provideWelcomeMessage(D);if(v)return v.map(n=>typeof n=="string"?n:n.map(h=>_.ChatReplyFollowup.from(h)))}async $provideFollowups(m,D,S){const v=this._chatProvider.get(m);if(!v)return;const n=this._chatSessions.get(D);return!n||!v.provider.provideFollowups?void 0:(await v.provider.provideFollowups(n,S))?.map(d=>_.ChatFollowup.from(d))}$removeRequest(m,D,S){const v=this._chatProvider.get(m);if(!v)return;const n=this._chatSessions.get(D);n&&v.provider.removeRequest&&v.provider.removeRequest(n,S)}async $provideReply(m,D,S,v){const n=this._chatProvider.get(m);if(!n)return;const h=this._chatSessions.get(D);if(!h)return;const d={session:h,message:typeof S.message=="string"?S.message:_.ChatReplyFollowup.to(S.message)},w=l.StopWatch.create(!1);let E;const p={report:r=>{if(v.isCancellationRequested)return;typeof E>"u"&&(E=w.elapsed());const s="responseId"in r?{requestId:r.responseId}:r;this._proxy.$acceptResponseProgress(m,D,s)}};let t;try{t=await n.provider.provideResponseWithProgress(d,p,v),t||(t={errorDetails:{message:(0,R.localize)(0,null)}})}catch(r){t={errorDetails:{message:(0,R.localize)(1,null,r.message),responseIsIncomplete:!0}},this.logService.error(r)}try{if(h.saveState&&this._chatSessions.has(D)){const r=h.saveState();this._proxy.$acceptChatState(D,r)}}catch(r){this.logService.warn(r)}const a={firstProgress:E??0,totalElapsed:w.elapsed()};return{errorDetails:t.errorDetails,timings:a}}async $provideSlashCommands(m,D,S){const v=this._chatProvider.get(m);if(!v)return;const n=this._chatSessions.get(D);return!n||!v.provider.provideSlashCommands?void 0:(await v.provider.provideSlashCommands(n,S))?.map(d=>({...d,kind:_.CompletionItemKind.from(d.kind)}))}$releaseSession(m){this._chatSessions.delete(m)}async $onDidPerformUserAction(m){this._onDidPerformUserAction.fire(m)}registerSlashCommandProvider(m,D,S){const v=new g(m,S);return this._slashCommandProvider.set(v.handle,v),this._proxy.$registerSlashCommandProvider(v.handle,D),(0,A.toDisposable)(()=>{this._proxy.$unregisterSlashCommandProvider(v.handle),this._slashCommandProvider.delete(v.handle)})}async $provideProviderSlashCommands(m,D){const S=this._slashCommandProvider.get(m);return S?(await S.provider.provideSlashCommands(D))?.map(n=>({...n,kind:_.CompletionItemKind.from(n.kind)})):void 0}async $resolveSlashCommand(m,D,S){const v=this._slashCommandProvider.get(m);if(!v)return;const n=await v.provider.resolveSlashCommand(D,S);return(0,L.withNullAsUndefined)(n)}}e.ExtHostChat=T,T._nextId=0}),define(ye[277],Ce([1,0,6]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(L){const R=L.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(P){return R.$writeText(P)}})}}e.ExtHostClipboard=A});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[36],Ce([1,0,12,7,15,23,6,19,17,73,35,56,2,4,5,20,140,21,61,45,40,79,82]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t){"use strict";var a,r,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=e.ExtHostCommands=class{constructor(i,I,F){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,r.set(this,void 0),s.set(this,void 0),Je(this,a,i.getProxy(R.MainContext.MainThreadCommands),"f"),this._logService=I,Je(this,s,F,"f"),Je(this,r,i.getProxy(R.MainContext.MainThreadTelemetry),"f"),this.converter=new b(this,U=>{const $=this._apiCommands.get(U);return $?.result===C.Void?$:void 0},I),this._argumentProcessors=[{processArgument(U){return(0,g.revive)(U)}},{processArgument(U){return(0,L.cloneAndChange)(U,function($){if(T.Range.isIRange($))return l.Range.to($);if(k.Position.isIPosition($))return l.Position.to($);if(T.Range.isIRange($.range)&&m.URI.isUri($.uri))return l.location.to($);if($ instanceof h.VSBuffer)return $.buffer.buffer;if(!Array.isArray($))return $})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const I=this.registerCommand(!1,i.id,async(...F)=>{const U=i.args.map((B,N)=>{if(!B.validate(F[N]))throw new Error(`Invalid argument '${B.name}' when running '${i.id}', received: ${F[N]}`);return B.convert(F[N])}),$=await this.executeCommand(i.internalId,...U);return i.result.convert($,F,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new A.Disposable(()=>{I.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,I,F,U,$,B){if(this._logService.trace("ExtHostCommands#registerCommand",I),!I.trim().length)throw new Error("invalid id");if(this._commands.has(I))throw new Error(`command '${I}' already exists`);return this._commands.set(I,{callback:F,thisArg:U,description:$,extension:B}),i&&Oe(this,a,"f").$registerCommand(I),new A.Disposable(()=>{this._commands.delete(I)&&i&&Oe(this,a,"f").$unregisterCommand(I)})}executeCommand(i,...I){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,I,!0)}async _doExecuteCommand(i,I,F){if(this._commands.has(i))return Oe(this,a,"f").$fireCommandActivationEvent(i),this._executeContributedCommand(i,I,!1);{let U=!1;const $=(0,L.cloneAndChange)(I,function(B){if(B instanceof A.Position)return l.Position.from(B);if(B instanceof A.Range)return l.Range.from(B);if(B instanceof A.Location)return l.location.from(B);if(A.NotebookRange.isNotebookRange(B))return l.NotebookRange.from(B);if(B instanceof ArrayBuffer)return U=!0,h.VSBuffer.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return U=!0,h.VSBuffer.wrap(B);if(B instanceof h.VSBuffer)return U=!0,B;if(!Array.isArray(B))return B});try{const B=await Oe(this,a,"f").$executeCommand(i,U?new d.SerializableObjectWithBuffers($):$,F);return(0,g.revive)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this._doExecuteCommand(i,I,!1);throw B}}}async _executeContributedCommand(i,I,F){const U=this._commands.get(i);if(!U)throw new Error("Unknown command");const{callback:$,thisArg:B,description:N}=U;if(N)for(let x=0;x<N.args.length;x++)try{(0,c.validateConstraint)(I[x],N.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${N.args[x].name}' - ${N.args[x].description}`)}const V=E.StopWatch.create();try{return await $.apply(B,I)}catch(x){if(i===this.converter.delegatingCommandId){const W=this.converter.getActualCommand(...I);W&&(i=W.command)}if(this._logService.error(x,i,U.extension?.identifier),!F)throw x;if(U.extension?.identifier){const W=Oe(this,s,"f").onExtensionError(U.extension.identifier,x);this._logService.trace("forwarded error to extension?",W,U.extension?.identifier)}throw new class extends Error{constructor(){super((0,w.toErrorMessage)(x)),this.id=i,this.source=U.extension?.displayName??U.extension?.name}}}finally{this._reportTelemetry(U,i,V.elapsed())}}_reportTelemetry(i,I,F){i.extension&&Oe(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:i.extension.identifier.value,id:new p.TelemetryTrustedValue(I),duration:F})}$executeContributedCommand(i,...I){this._logService.trace("ExtHostCommands#$executeContributedCommand",i);const F=this._commands.get(i);return F?(I=I.map(U=>this._argumentProcessors.reduce(($,B)=>B.processArgument($,F.extension?.identifier),U)),this._executeContributedCommand(i,I,!0)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),Oe(this,a,"f").$getCommands().then(I=>(i&&(I=I.filter(F=>F[0]!=="_")),I))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(const[I,F]of this._commands){const{description:U}=F;U&&(i[I]=U)}return Promise.resolve(i)}};a=new WeakMap,r=new WeakMap,s=new WeakMap,e.ExtHostCommands=f=je([$e(0,v.IExtHostRpcService),$e(1,_.ILogService),$e(2,t.IExtHostTelemetry)],f),e.IExtHostCommands=(0,S.createDecorator)("IExtHostCommands");class b{constructor(i,I,F){this._commands=i,this._lookupApiCommand=I,this._logService=F,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,I){if(!i)return;const F={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return F;const U=this._lookupApiCommand(i.command);if(U)F.id=U.internalId,F.arguments=U.args.map(($,B)=>$.convert(i.arguments&&i.arguments[B]));else if((0,P.isNonEmptyArray)(i.arguments)){const $=`${i.command}/${++this._cachIdPool}`;this._cache.set($,i),I.add((0,D.toDisposable)(()=>{this._cache.delete($),this._logService.trace("CommandsConverter#DISPOSE",$)})),F.$ident=$,F.id=this.delegatingCommandId,F.arguments=[$],this._logService.trace("CommandsConverter#CREATE",i.command,$)}return F}fromInternal(i){return typeof i.$ident=="string"?this._cache.get(i.$ident):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const I=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],I?I.command:"MISSING"),I?this._commands.executeCommand(I.command,...I.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${i[0]}`)}}e.CommandsConverter=b;class u{constructor(i,I,F,U){this.name=i,this.description=I,this.validate=F,this.convert=U}optional(){return new u(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,I){return new u(i??this.name,I??this.description,this.validate,this.convert)}}e.ApiCommandArgument=u,u.Uri=new u("uri","Uri of a text document",o=>m.URI.isUri(o),o=>o),u.Position=new u("position","A position in a text document",o=>A.Position.isPosition(o),l.Position.from),u.Range=new u("range","A range in a text document",o=>A.Range.isRange(o),l.Range.from),u.Selection=new u("selection","A selection in a text document",o=>A.Selection.isSelection(o),l.Selection.from),u.Number=new u("number","",o=>typeof o=="number",o=>o),u.String=new u("string","",o=>typeof o=="string",o=>o),u.CallHierarchyItem=new u("item","A call hierarchy item",o=>o instanceof A.CallHierarchyItem,l.CallHierarchyItem.from),u.TypeHierarchyItem=new u("item","A type hierarchy item",o=>o instanceof A.TypeHierarchyItem,l.TypeHierarchyItem.from),u.TestItem=new u("testItem","A VSCodium TestItem",o=>o instanceof n.TestItemImpl,l.TestItem.from);class C{constructor(i,I){this.description=i,this.convert=I}}e.ApiCommandResult=C,C.Void=new C("no result",o=>o);class y{constructor(i,I,F,U,$){this.id=i,this.internalId=I,this.description=F,this.args=U,this.result=$}}e.ApiCommand=y}),define(ye[278],Ce([1,0,19,18,2,76,122,47,126,36,15,7]),function(re,e,c,A,l,L,R,P,_,g,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const m=[new g.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",S(T.DocumentHighlight.to))),new g.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,c.isFalsyOrEmpty)(n))return;class d extends k.SymbolInformation{static to(E){const p=new d(E.name,T.SymbolKind.to(E.kind),E.containerName||"",new k.Location(h[0],T.Range.to(E.range)));return p.detail=E.detail,p.range=p.location.range,p.selectionRange=T.Range.to(E.selectionRange),p.children=E.children?E.children.map(d.to):[],p}}return n.map(d.to)})),new g.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(T.TextEdit.to))),new g.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range,new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(T.TextEdit.to))),new g.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,new g.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(T.TextEdit.to))),new g.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location-instances.",S(T.location.to))),new g.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Hover-instances.",S(T.Hover.to))),new g.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>k.Position.isPosition(h)),n=>n.map(T.Position.from))],new g.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let d;for(const w of h.reverse())d=new k.SelectionRange(T.Range.to(w),d);return d}))),new g.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.ApiCommandArgument.String.with("query","Search string")],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(T.WorkspaceSymbol.to))),new g.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(T.CallHierarchyItem.to))),new g.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(T.CallHierarchyIncomingCall.to))),new g.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(T.CallHierarchyOutgoingCall.to))),new g.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:T.Range.to(n.range),placeholder:n.text}})),new g.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("newName","The new symbol name")],new g.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return T.WorkspaceEdit.to(n)}})),new g.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(T.DocumentLink.to))),new g.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,R.decodeSemanticTokensDto)(n);if(h.type==="full")return new k.SemanticTokens(h.data,void 0)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range.optional()],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,R.decodeSemanticTokensDto)(n);if(h.type==="full")return new k.SemanticTokens(h.data,void 0)})),new g.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,d)=>{if(!n)return new k.CompletionList([]);const w=n.suggestions.map(E=>T.CompletionItem.to(E,d));return new k.CompletionList(w,n.incomplete)})),new g.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return T.SignatureHelp.to(n)})),new g.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,d)=>S(w=>new k.CodeLens(T.Range.to(w.range),w.command&&d.fromInternal(w.command)))(n))),new g.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>k.Range.isRange(n),n=>k.Selection.isSelection(n)?T.Selection.from(n):T.Range.from(n)),g.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,d)=>S(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(w.command)}else{const E=new k.CodeAction(w.title,w.kind?new k.CodeActionKind(w.kind):void 0);return w.edit&&(E.edit=T.WorkspaceEdit.to(w.edit)),w.command&&(E.command=d.fromInternal(w.command)),E.isPreferred=w.isPreferred,E}})(n))),new g.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new k.ColorInformation(T.Range.to(h.range),T.Color.to(h.color))):[])),new g.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.ApiCommandArgument("color","The color to show and insert",n=>n instanceof k.Color,T.Color.from),new g.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:T.Range.from(n.range)}))],new g.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(T.ColorPresentation.to):[])),new g.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,h,d)=>n.map(T.InlayHint.to.bind(void 0,d)))),new g.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,h)=>{if(n)return n.map(T.FoldingRange.to)})),new g.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",S(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>T.NotebookExclusiveDocumentPattern.to(h))})))),new g.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(T.InlineValue.to))),new g.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>l.URI.isUri(n)||typeof n=="string"&&(0,_.matchesSomeScheme)(n,A.Schemas.http,A.Schemas.https),n=>n),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[T.ViewColumn.from(n),void 0]:[T.ViewColumn.from(n.viewColumn),T.TextEditorOpenOptions.from(n)])).optional(),g.ApiCommandArgument.String.with("label","").optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.ApiCommandArgument.Uri.with("resource","Resource to open"),g.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[T.ViewColumn.from(n),void 0]:[T.ViewColumn.from(n.viewColumn),T.TextEditorOpenOptions.from(n)])).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),g.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),g.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[T.ViewColumn.from(n.viewColumn),T.TextEditorOpenOptions.from(n)]).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(T.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(T.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(T.TypeHierarchyItem.to))),new g.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.ApiCommandArgument.TestItem],g.ApiCommandResult.Void),new g.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.ApiCommandResult.Void),new g.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.ApiCommandArgument.String.with("name","The context key name"),new g.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],g.ApiCommandResult.Void)];class D{static register(h){m.forEach(h.registerApiCommand,h),this._registerValidateWhenClausesCommand(h)}static _registerValidateWhenClausesCommand(h){h.registerCommand(!1,"_validateWhenClauses",P.validateWhenClauses)}}e.ExtHostApiCommands=D;function S(n){return h=>{if(Array.isArray(h))return h.map(n)}}function v(n){if(!Array.isArray(n))return;const h=[];for(const d of n)L.isLocationLink(d)?h.push(T.DefinitionLink.to(d)):h.push(T.location.to(d));return h}}),define(ye[279],Ce([1,0,16,66,3,4,2,76,26,15,7,6,25,12]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(v,n,h){const d=v.getProxy(k.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new _.ExtensionIdentifierMap,n.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const C=this._commentControllers.get(u.handle);return C?C.value:u}else if(u&&u.$mid===7){const C=this._commentControllers.get(u.commentControlHandle);if(!C)return u;const y=C.getCommentThread(u.commentThreadHandle);return y?y.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const C=this._commentControllers.get(u.thread.commentControlHandle);if(!C)return u;const y=C.getCommentThread(u.thread.commentThreadHandle);return y?u.$mid===8?y.value:{thread:y.value,text:u.text}:u}else if(u&&u.$mid===10){const C=this._commentControllers.get(u.thread.commentControlHandle);if(!C)return u;const y=C.getCommentThread(u.thread.commentThreadHandle);if(!y)return u;const o=u.commentUniqueId,i=y.getCommentByUniqueId(o);return i||u}else if(u&&u.$mid===11){const C=this._commentControllers.get(u.thread.commentControlHandle);if(!C)return u;const y=C.getCommentThread(u.thread.commentThreadHandle);if(!y)return u;const o=u.text,i=u.commentUniqueId,I=y.getCommentByUniqueId(i);return I?(typeof I.body=="string"?I.body=o:I.body=new T.MarkdownString(o),I):u}return u}})}createCommentController(u,C,y){const o=w.handlePool++,i=new p(u,o,C,y);this._commentControllers.set(i.handle,i);const I=this._commentControllersByExtension.get(u.identifier)||[];return I.push(i),this._commentControllersByExtension.set(u.identifier,I),i.value}$createCommentThreadTemplate(u,C,y){const o=this._commentControllers.get(u);o&&o.$createCommentThreadTemplate(C,y)}async $updateCommentThreadTemplate(u,C,y){const o=this._commentControllers.get(u);o&&o.$updateCommentThreadTemplate(C,y)}$deleteCommentThread(u,C){this._commentControllers.get(u)?.$deleteCommentThread(C)}$provideCommentingRanges(u,C,y){const o=this._commentControllers.get(u);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const i=h.getDocument(R.URI.revive(C));return(0,c.asPromise)(async()=>{const I=await o.commentingRangeProvider.provideCommentingRanges(i,y);let F;return Array.isArray(I)?F={ranges:I,fileComments:!1}:I?F={ranges:I.ranges||[],fileComments:I.fileComments||!1}:F=(0,D.withNullAsUndefined)(I),F}).then(I=>{let F;return I&&(F={ranges:I.ranges.map(U=>g.Range.from(U)),fileComments:I.fileComments}),F})}$toggleReaction(u,C,y,o,i){const I=this._commentControllers.get(u);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const F=I.getCommentThread(C);if(F){const U=F.getCommentByUniqueId(o.uniqueIdInThread);if(I!==void 0&&U&&I.reactionHandler)return I.reactionHandler(U,r(i))}return Promise.resolve(void 0)})}}w.handlePool=0;class E{set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){(u===void 0!=(this._range===void 0)||!u||!this._range||!u.isEqual(this._range))&&(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(u){this._state=u,this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,C,y,o,i,I,F,U){this._commentControllerHandle=C,this._id=y,this._uri=o,this._range=i,this._comments=I,this.extensionDescription=F,this._isTemplate=U,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new l.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),d.$createCommentThread(C,this.handle,this._id,this._uri,g.Range.from(this._range),F.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(C,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(B){$.range=B},get comments(){return $.comments},set comments(B){$.comments=B},get collapsibleState(){return $.collapsibleState},set collapsibleState(B){$.collapsibleState=B},get canReply(){return $.canReply},set canReply(B){$.canReply=B},get contextValue(){return $.contextValue},set contextValue(B){$.contextValue=B},get label(){return $.label},set label(B){$.label=B},get state(){return $.state},set state(B){$.state=B},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const u=y=>Object.prototype.hasOwnProperty.call(this.modifications,y),C={};u("range")&&(C.range=g.Range.from(this._range)),u("label")&&(C.label=this.label),u("contextValue")&&(C.contextValue=this.contextValue??null),u("comments")&&(C.comments=this._comments.map(y=>t(this,y,this._commentsMap,this.extensionDescription))),u("collapsibleState")&&(C.collapseState=s(this._collapseState)),u("canReply")&&(C.canReply=this.canReply),u("state")&&(C.state=f(this._state)),u("isTemplate")&&(C.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,C)}getCommentByUniqueId(u){for(const C of this._commentsMap){const y=C[0],o=C[1];if(u===o)return y}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}E._handlePool=0,je([(0,A.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(u,C,y,o){this._extension=u,this._handle=C,this._id=y,this._label=o,this._threads=new Map,d.$registerCommentController(this.handle,y,o);const i=this;this.value=Object.freeze({id:i.id,label:i.label,get options(){return i.options},set options(I){i.options=I},get commentingRangeProvider(){return i.commentingRangeProvider},set commentingRangeProvider(I){i.commentingRangeProvider=I},get reactionHandler(){return i.reactionHandler},set reactionHandler(I){i.reactionHandler=I},createCommentThread(I,F,U){return i.createCommentThread(I,F,U).value},dispose:()=>{i.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(u,C,y){C===void 0&&(0,m.checkProposedApiEnabled)(this._extension,"fileComments");const o=new E(this.id,this.handle,void 0,u,C,y,this._extension,!1);return this._threads.set(o.handle,o),o}$createCommentThreadTemplate(u,C){const y=new E(this.id,this.handle,void 0,R.URI.revive(u),g.Range.to(C),[],this._extension,!0);return y.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(y.handle,y),y}$updateCommentThreadTemplate(u,C){const y=this._threads.get(u);y&&(y.range=g.Range.to(C))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function t(b,u,C,y){let o=C.get(u);return o||(o=++b.commentHandle,C.set(u,o)),u.state!==void 0&&(0,m.checkProposedApiEnabled)(y,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:o,body:typeof u.body=="string"?u.body:g.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(i=>a(i)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function a(b){return{label:b.label,iconPath:b.iconPath?g.pathOrURIToURI(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function r(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?R.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function s(b){if(b!==void 0)switch(b){case T.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function f(b){if(b!==void 0)switch(b){case T.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new w}e.createExtHostComments=S}),define(ye[280],Ce([1,0,23,6,27,20]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=e.AbstractExtHostConsoleForwarder=class{constructor(T,k){this._mainThreadConsole=T.getProxy(A.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(T,k){const m=this,D=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){m._handleConsoleCall(T,k,D,arguments)}})}_handleConsoleCall(T,k,m,D){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:_(D,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(T,m,D)}};e.AbstractExtHostConsoleForwarder=R=je([$e(0,L.IExtHostRpcService),$e(1,l.IExtHostInitDataService)],R);const P=1e5;function _(g,T){const k=[];if(g.length)for(let m=0;m<g.length;m++){let D=g[m];if(typeof D>"u")D="undefined";else if(D instanceof Error){const S=D;S.stack?D=S.stack:D=S.toString()}k.push(D)}if(T){const m=new Error().stack;m&&k.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,c.safeStringify)(k);return m.length>P?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ye[142],Ce([1,0,2,6,7,5,20,17,19,11,10,25]),function(re,e,c,A,l,L,R,P,_,g,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=e.ExtHostDecorations=class an{constructor(S,v){this._logService=v,this._provider=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(S,v){const n=an._handlePool++;this._provider.set(n,{provider:S,extensionDescription:v}),this._proxy.$registerDecorationProvider(n,v.identifier.value);const h=S.onDidChangeFileDecorations&&S.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(n,null);return}const w=(0,_.asArray)(d);if(w.length<=an._maxEventSize){this._proxy.$onDidChange(n,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",v.identifier.value,w.length);const E=w.map(a=>({uri:a,rank:(0,g.count)(a.path,"/")})),p=(0,_.groupBy)(E,(a,r)=>a.rank-r.rank||(0,g.compare)(a.uri.path,r.uri.path)),t=[];e:for(const a of p){let r;for(const s of a){const f=(0,T.dirname)(s.uri.path);if(r!==f&&(r=f,t.push(s.uri)>=an._maxEventSize))break e}}this._proxy.$onDidChange(n,t)});return new l.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(S,v,n){if(!this._provider.has(S))return Object.create(null);const h=Object.create(null),{provider:d,extensionDescription:w}=this._provider.get(S);return await Promise.all(v.map(async E=>{try{const{uri:p,id:t}=E,a=await Promise.resolve(d.provideFileDecoration(c.URI.revive(p),n));if(!a)return;try{l.FileDecoration.validate(a),a.badge&&typeof a.badge!="string"&&(0,k.checkProposedApiEnabled)(w,"codiconDecoration"),h[t]=[a.propagate,a.tooltip,a.badge,a.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${w}': ${r}`)}}catch(p){this._logService.error(p)}})),h}};m._handlePool=0,m._maxEventSize=250,e.ExtHostDecorations=m=je([$e(0,R.IExtHostRpcService),$e(1,P.ILogService)],m),e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[281],Ce([1,0,189,125,2,6,7,15,3,17,28,50]),function(re,e,c,A,l,L,R,P,_,g,T,k){"use strict";var m,D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(d,w,E,p,t,a,r){this._name=d,this._owner=w,this._maxDiagnosticsPerFile=E,this._modelVersionIdProvider=p,m.set(this,void 0),D.set(this,void 0),S.set(this,void 0),this._isDisposed=!1,Je(this,S,new T.ResourceMap(s=>t.getComparisonKey(s)),"f"),Je(this,m,a,"f"),Je(this,D,r,"f")}dispose(){this._isDisposed||(Oe(this,D,"f").fire([...Oe(this,S,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,S,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,w){if(!d){this.clear();return}this._checkDisposed();let E=[];if(l.URI.isUri(d)){if(!w){this.delete(d);return}Oe(this,S,"f").set(d,w.slice()),E=[d]}else if(Array.isArray(d)){E=[];let t;d=[...d].sort(v._compareIndexedTuplesByUri);for(const a of d){const[r,s]=a;if((!t||r.toString()!==t.toString())&&(t&&Oe(this,S,"f").get(t).length===0&&Oe(this,S,"f").delete(t),t=r,E.push(r),Oe(this,S,"f").set(r,[])),s)Oe(this,S,"f").get(r)?.push(...s);else{const f=Oe(this,S,"f").get(r);f&&(f.length=0)}}}if(Oe(this,D,"f").fire(E),!Oe(this,m,"f"))return;const p=[];for(const t of E){let a=[];const r=Oe(this,S,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){a=[];const s=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const b of r)if(b.severity===s[f]&&a.push({...P.Diagnostic.from(b),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;a.push({severity:A.MarkerSeverity.Info,message:(0,c.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=r.map(s=>({...P.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(t)}));p.push([t,a])}Oe(this,m,"f").$changeMany(this._owner,p)}delete(d){this._checkDisposed(),Oe(this,D,"f").fire([d]),Oe(this,S,"f").delete(d),Oe(this,m,"f")?.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),Oe(this,D,"f").fire([...Oe(this,S,"f").keys()]),Oe(this,S,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(d,w){this._checkDisposed();for(const[E,p]of this)d.call(w,E,p,this)}*[(m=new WeakMap,D=new WeakMap,S=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const d of Oe(this,S,"f").keys())yield[d,this.get(d)]}get(d){this._checkDisposed();const w=Oe(this,S,"f").get(d);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(Oe(this,S,"f").get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,w){return d[0].toString()<w[0].toString()?-1:d[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=v;let n=e.ExtHostDiagnostics=class bi{static _mapper(d){const w=new T.ResourceMap;for(const E of d)w.set(E,E);return{uris:Object.freeze(Array.from(w.values()))}}constructor(d,w,E,p){this._logService=w,this._fileSystemInfoService=E,this._extHostDocumentsAndEditors=p,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,bi._mapper),this._proxy=d.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(d,w){const{_collections:E,_proxy:p,_onDidChangeDiagnostics:t,_logService:a,_fileSystemInfoService:r,_extHostDocumentsAndEditors:s}=this,f=new class{$changeMany(C,y){p.$changeMany(C,y),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,C,y.length===0?"CLEARING":y)}$clear(C){p.$clear(C),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,C)}dispose(){p.dispose()}};let b;if(!w)w="_generated_diagnostic_collection_name_#"+bi._idPool++,b=w;else if(!E.has(w))b=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do b=w+bi._idPool++;while(E.has(b))}return new class extends v{constructor(){super(w,b,bi._maxDiagnosticsPerFile,C=>s.getDocument(C)?.version,r.extUri,f,t),E.set(b,this)}dispose(){super.dispose(),E.delete(b)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const w=new Map,E=[];for(const p of this._collections.values())p.forEach((t,a)=>{let r=w.get(t.toString());typeof r>"u"&&(r=E.length,w.set(t.toString(),r),E.push([t,[]])),E[r][1]=E[r][1].concat(...a)});return E}}_getDiagnostics(d){let w=[];for(const E of this._collections.values())E.has(d)&&(w=w.concat(E.get(d)));return w}$acceptMarkersChange(d){if(!this._mirrorCollection){const w="_generated_mirror",E=new v(w,w,bi._maxDiagnosticsPerFile,p=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,E),this._mirrorCollection=E}for(const[w,E]of d)this._mirrorCollection.set(l.URI.revive(w),E.map(P.Diagnostic.to))}};n._idPool=0,n._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=n=je([$e(1,g.ILogService),$e(2,k.IExtHostFileSystemInfo)],n)}),define(ye[282],Ce([1,0,2,6,25]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class L{constructor(P){this._proxy=P.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(P,_){return _?.allowUIResources&&(0,l.checkProposedApiEnabled)(P,"showLocal"),this._proxy.$showOpenDialog(_).then(g=>g?g.map(T=>c.URI.revive(T)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(_=>_?c.URI.revive(_):void 0)}}e.ExtHostDialogs=L}),define(ye[283],Ce([1,0,8,2,7,6,18,22,11]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class g{constructor(k,m,D){this._documentsAndEditors=m,this._logService=D,this._documentContentProviders=new Map,this._proxy=k.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,m){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const D=g._handlePool++;this._documentContentProviders.set(D,m),this._proxy.$registerTextContentProvider(D,k);let S;return typeof m.onDidChange=="function"&&(S=m.onDidChange(v=>{if(v.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(D,v).then(n=>{if(!n&&typeof n!="string")return;const h=this._documentsAndEditors.getDocument(v);if(!h)return;const d=(0,_.splitLines)(n);if(!h.equalLines(d))return this._proxy.$onVirtualDocumentChange(v,n)},c.onUnexpectedError)})),new l.Disposable(()=>{this._documentContentProviders.delete(D)&&this._proxy.$unregisterTextContentProvider(D),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(k,m){const D=this._documentContentProviders.get(k);return D?Promise.resolve(D.provideTextDocumentContent(A.URI.revive(m),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=g,g._handlePool=0}),define(ye[284],Ce([1,0,3,4,2,6,138,15,12,23,7]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(D,S){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new A.DisposableStore,this._documentLoader=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=S,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const n of v)this._onDidRemoveDocument.fire(n.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const n of v)this._onDidAddDocument.fire(n.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(D){if(!D)return;const S=this._documentsAndEditors.getDocument(D);if(S)return S}getDocument(D){const S=this.getDocumentData(D);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return S.document}ensureDocumentData(D){const S=this._documentsAndEditors.getDocument(D);if(S)return Promise.resolve(S);let v=this._documentLoader.get(D.toString());return v||(v=this._proxy.$tryOpenDocument(D).then(n=>{this._documentLoader.delete(D.toString());const h=l.URI.revive(n);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(h))},n=>(this._documentLoader.delete(D.toString()),Promise.reject(n))),this._documentLoader.set(D.toString(),v)),v}createDocumentData(D){return this._proxy.$tryCreateDocument(D).then(S=>l.URI.revive(S))}$acceptModelLanguageChanged(D,S){const v=l.URI.revive(D),n=this._documentsAndEditors.getDocument(v);if(!n)throw new Error("unknown document");this._onDidRemoveDocument.fire(n.document),n._acceptLanguageId(S),this._onDidAddDocument.fire(n.document)}$acceptModelSaved(D){const S=l.URI.revive(D),v=this._documentsAndEditors.getDocument(S);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(D,S){const v=l.URI.revive(D),n=this._documentsAndEditors.getDocument(v);if(!n)throw new Error("unknown document");n._acceptIsDirty(S),this._onDidChangeDocument.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,S,v){const n=l.URI.revive(D),h=this._documentsAndEditors.getDocument(n);if(!h)throw new Error("unknown document");h._acceptIsDirty(v),h.onEvents(S);let d;S.isUndoing?d=T.TextDocumentChangeReason.Undo:S.isRedoing&&(d=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,g.deepFreeze)({document:h.document,contentChanges:S.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:d}))}setWordDefinitionFor(D,S){(0,R.setWordDefinitionFor)(D,S)}}e.ExtHostDocuments=k}),define(ye[62],Ce([1,0,52,3,4,2,5,6,138,20,141,15,17,28,18,53,54]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(E){this.value=E,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let d=e.ExtHostDocumentsAndEditors=class{constructor(E,p){this._extHostRpc=E,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new D.ResourceMap,this._onDidAddDocuments=new A.Emitter,this._onDidRemoveDocuments=new A.Emitter,this._onDidChangeVisibleTextEditors=new A.Emitter,this._onDidChangeActiveTextEditor=new A.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const p=[],t=[],a=[];if(E.removedDocuments)for(const r of E.removedDocuments){const s=L.URI.revive(r),f=this._documents.get(s);f?.unref()&&(this._documents.delete(s),p.push(f.value))}if(E.addedDocuments)for(const r of E.addedDocuments){const s=L.URI.revive(r.uri);let f=this._documents.get(s);if(f&&s.scheme!==S.Schemas.vscodeNotebookCell&&s.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);f||(f=new h(new _.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,f),t.push(f.value)),f.ref()}if(E.removedEditors)for(const r of E.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&a.push(s)}if(E.addedEditors)for(const r of E.addedEditors){const s=L.URI.revive(r.documentUri);c.ok(this._documents.has(s),`document '${s}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const f=this._documents.get(s).value,b=new T.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new n.Lazy(()=>f.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(u=>k.Range.to(u)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,b)}E.newActiveEditor!==void 0&&(c.ok(E.newActiveEditor===null||this._editors.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this._activeEditorId=E.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(a),E.removedDocuments&&this._onDidRemoveDocuments.fire(p),E.addedDocuments&&this._onDidAddDocuments.fire(t),(E.removedEditors||E.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),E.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(E){return this._documents.get(E)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),E=>E.value)}getEditor(E){return this._editors.get(E)}activeEditor(E){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return E?p:p?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=d=je([$e(0,g.IExtHostRpcService),$e(1,m.ILogService)],d),e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[63],Ce([1,0,15,6,2,3,5,7,20,12,65]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class k{constructor(n,h,d){this._activeTabIdGetter=d,this._parentGroup=h,this.acceptDtoUpdate(n)}get apiObject(){if(!this._apiObject){const n=this,h={get isActive(){return n._dto.id===n._activeTabIdGetter()},get label(){return n._dto.label},get input(){return n._input},get isDirty(){return n._dto.isDirty},get isPinned(){return n._dto.isPinned},get isPreview(){return n._dto.isPreview},get group(){return n._parentGroup.apiObject}};this._apiObject=Object.freeze(h)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(n){this._dto=n,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(l.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(l.URI.revive(this._dto.input.base),l.URI.revive(this._dto.input.input1),l.URI.revive(this._dto.input.input2),l.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(l.URI.revive(this._dto.input.uri),l.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(n,h){this._tabs=[],this._activeTabId="",this._dto=n,this._activeGroupIdGetter=h;for(const d of n.tabs)d.isActive&&(this._activeTabId=d.id),this._tabs.push(new k(d,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const n=this,h={get isActive(){return n._dto.groupId===n._activeGroupIdGetter()},get viewColumn(){return c.ViewColumn.to(n._dto.viewColumn)},get activeTab(){return n._tabs.find(d=>d.tabId===n._activeTabId)?.apiObject},get tabs(){return Object.freeze(n._tabs.map(d=>d.apiObject))}};this._apiObject=Object.freeze(h)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(n){this._dto=n}acceptTabOperation(n){if(n.kind===0){const d=new k(n.tabDto,this,()=>this.activeTabId());return this._tabs.splice(n.index,0,d),n.tabDto.isActive&&(this._activeTabId=d.tabId),d}else if(n.kind===1){const d=this._tabs.splice(n.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${n.index} which does not exist`);return d.tabId===this._activeTabId&&(this._activeTabId=""),d}else if(n.kind===3){if(n.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this._tabs.splice(n.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${n.oldIndex} which does not exist`);return this._tabs.splice(n.index,0,d),d}const h=this._tabs.find(d=>d.tabId===n.tabDto.id);if(!h)throw new Error("INVALID tab");return n.tabDto.isActive?this._activeTabId=n.tabDto.id:this._activeTabId===n.tabDto.id&&!n.tabDto.isActive&&(this._activeTabId=""),h.acceptDtoUpdate(n.tabDto),h}activeTabId(){return this._activeTabId}}let D=e.ExtHostEditorTabs=class{constructor(n){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=n.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const n=this,h={onDidChangeTabGroups:n._onDidChangeTabGroups.event,onDidChangeTabs:n._onDidChangeTabs.event,get all(){return Object.freeze(n._extHostTabGroups.map(d=>d.apiObject))},get activeTabGroup(){const d=n._activeGroupId;return(0,g.assertIsDefined)(n._extHostTabGroups.find(E=>E.groupId===d)?.apiObject)},close:async(d,w)=>{const E=Array.isArray(d)?d:[d];return E.length?S(E[0])?this._closeGroups(E,w):this._closeTabs(E,w):!0}};this._apiObject=Object.freeze(h)}return this._apiObject}$acceptEditorTabModel(n){const h=new Set(this._extHostTabGroups.map(r=>r.groupId)),d=new Set(n.map(r=>r.groupId)),w=(0,T.diffSets)(h,d),E=this._extHostTabGroups.filter(r=>w.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],t=[];this._extHostTabGroups=n.map(r=>{const s=new m(r,()=>this._activeGroupId);return w.added.includes(s.groupId)?p.push(s.apiObject):t.push(s.apiObject),s});const a=(0,g.assertIsDefined)(n.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this._activeGroupId!==a&&(this._activeGroupId=a),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:E,changed:t}))}$acceptTabGroupUpdate(n){const h=this._extHostTabGroups.find(d=>d.groupId===n.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(n),n.isActive&&(this._activeGroupId=n.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(n){const h=this._extHostTabGroups.find(w=>w.groupId===n.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const d=h.acceptTabOperation(n);switch(n.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}_findExtHostTabFromApi(n){for(const h of this._extHostTabGroups)for(const d of h.tabs)if(d.apiObject===n)return d}_findExtHostTabGroupFromApi(n){return this._extHostTabGroups.find(h=>h.apiObject===n)}async _closeTabs(n,h){const d=[];for(const w of n){const E=this._findExtHostTabFromApi(w);if(!E)throw new Error("Tab close: Invalid tab not found!");d.push(E.tabId)}return this._proxy.$closeTab(d,h)}async _closeGroups(n,h){const d=[];for(const w of n){const E=this._findExtHostTabGroupFromApi(w);if(!E)throw new Error("Group close: Invalid group not found!");d.push(E.groupId)}return this._proxy.$closeGroup(d,h)}};e.ExtHostEditorTabs=D=je([$e(0,_.IExtHostRpcService)],D);function S(v){return v.tabs!==void 0}}),define(ye[285],Ce([1,0,2,6,4,7,15,158,11,21,25]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(S){this._stateMachine=void 0,this._schemes.push(S)}delete(S){const v=this._schemes.indexOf(S);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const S=this._schemes.sort(),v=[];let n,h,d=14,w=14;for(const E of S){let p=n?(0,_.commonPrefixLength)(n,E):0;for(p===0?h=1:h=w;p<E.length;p++)p+1===E.length?(d=w,w=9):w+=1,v.push([h,E.toUpperCase().charCodeAt(p),w]),v.push([h,E.toLowerCase().charCodeAt(p),w]),h=w;n=E,w=d}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new P.StateMachine(v)}}provideDocumentLinks(S){this._initStateMachine();const v=[],n=P.LinkComputer.computeLinks({getLineContent(h){return S.lineAt(h-1).text},getLineCount(){return S.lineCount}},this._stateMachine);for(const h of n){const d=R.DocumentLink.to(h);d.target&&v.push(d)}return v}}class m{constructor(S,v){this._extHostLanguageFeatures=v,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=S.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(S,v,n,h={}){if(m._validateFileSystemProvider(n),this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(S,"*",this._linkProvider));const d=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(d,n);let w=2;h.isCaseSensitive&&(w+=1024),h.isReadonly&&(w+=2048),typeof n.copy=="function"&&(w+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,T.checkProposedApiEnabled)(S,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(d,v,w).catch(p=>{console.error(`FAILED to register filesystem provider of ${S.identifier.value}-extension for the scheme ${v}`),console.error(p)});const E=n.onDidChangeFile(p=>{const t=[];for(const a of p){const{uri:r,type:s}=a;if(r.scheme!==v)continue;let f;switch(s){case L.FileChangeType.Changed:f=0;break;case L.FileChangeType.Created:f=1;break;case L.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:f})}this._proxy.$onFileSystemChange(d,t)});return(0,l.toDisposable)(()=>{E.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(d),this._proxy.$unregisterProvider(d)})}static _validateFileSystemProvider(S){if(!S)throw new Error("MISSING provider");if(typeof S.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof S.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof S.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof S.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof S.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof S.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof S.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof S.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(S){const{type:v,ctime:n,mtime:h,size:d,permissions:w}=S;return{type:v,ctime:n,mtime:h,size:d,permissions:w}}$stat(S,v){return Promise.resolve(this._getFsProvider(S).stat(c.URI.revive(v))).then(n=>m._asIStat(n))}$readdir(S,v){return Promise.resolve(this._getFsProvider(S).readDirectory(c.URI.revive(v)))}$readFile(S,v){return Promise.resolve(this._getFsProvider(S).readFile(c.URI.revive(v))).then(n=>g.VSBuffer.wrap(n))}$writeFile(S,v,n,h){return Promise.resolve(this._getFsProvider(S).writeFile(c.URI.revive(v),n.buffer,h))}$delete(S,v,n){return Promise.resolve(this._getFsProvider(S).delete(c.URI.revive(v),n))}$rename(S,v,n,h){return Promise.resolve(this._getFsProvider(S).rename(c.URI.revive(v),c.URI.revive(n),h))}$copy(S,v,n,h){const d=this._getFsProvider(S);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(c.URI.revive(v),c.URI.revive(n),h))}$mkdir(S,v){return Promise.resolve(this._getFsProvider(S).createDirectory(c.URI.revive(v)))}$watch(S,v,n,h){const d=this._getFsProvider(S).watch(c.URI.revive(n),h);this._watches.set(v,d)}$unwatch(S,v){const n=this._watches.get(v);n&&(n.dispose(),this._watches.delete(v))}$open(S,v,n){const h=this._getFsProvider(S);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(c.URI.revive(v),n))}$close(S,v){const n=this._getFsProvider(S);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(v))}$read(S,v,n,h){const d=this._getFsProvider(S);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const w=g.VSBuffer.alloc(h);return Promise.resolve(d.read(v,n,w.buffer,0,h)).then(E=>w.slice(0,E))}$write(S,v,n,h){const d=this._getFsProvider(S);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(v,n,h.buffer,0,h.byteLength))}_getFsProvider(S){const v=this._fsProvider.get(S);if(!v){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return v}}e.ExtHostFileSystem=m}),define(ye[64],Ce([1,0,6,31,7,21,5,20,50,4]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=e.ExtHostConsumerFileSystem=class ii{constructor(m,D){this._fileSystemProvider=new Map,this._proxy=m.getProxy(c.MainContext.MainThreadFileSystem);const S=this;this.value=Object.freeze({async stat(v){try{let n;const h=S._fileSystemProvider.get(v.scheme);return h?(await S._proxy.$ensureActivation(v.scheme),n=await h.stat(v)):n=await S._proxy.$stat(v),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===A.FilePermission.Readonly?1:void 0}}catch(n){ii._handleError(n)}},async readDirectory(v){try{const n=S._fileSystemProvider.get(v.scheme);return n?(await S._proxy.$ensureActivation(v.scheme),(await n.readDirectory(v)).slice()):await S._proxy.$readdir(v)}catch(n){return ii._handleError(n)}},async createDirectory(v){try{return await S._proxy.$mkdir(v)}catch(n){return ii._handleError(n)}},async readFile(v){try{const n=S._fileSystemProvider.get(v.scheme);return n?(await S._proxy.$ensureActivation(v.scheme),(await n.readFile(v)).slice()):(await S._proxy.$readFile(v)).buffer}catch(n){return ii._handleError(n)}},async writeFile(v,n){try{return await S._proxy.$writeFile(v,L.VSBuffer.wrap(n))}catch(h){return ii._handleError(h)}},async delete(v,n){try{const h=S._fileSystemProvider.get(v.scheme);return h?(await S._proxy.$ensureActivation(v.scheme),await h.delete(v,{recursive:!1,...n})):await S._proxy.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(h){return ii._handleError(h)}},async rename(v,n,h){try{return await S._proxy.$rename(v,n,{overwrite:!1,...h})}catch(d){return ii._handleError(d)}},async copy(v,n,h){try{return await S._proxy.$copy(v,n,{overwrite:!1,...h})}catch(d){return ii._handleError(d)}},isWritableFileSystem(v){const n=D.getCapabilities(v);if(typeof n=="number")return!(n&2048)}})}static _handleError(m){if(m instanceof l.FileSystemError)throw m;if(m instanceof A.FileSystemProviderError)switch(m.code){case A.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(m.message);case A.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(m.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(m.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(m.message);case A.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(m.message);case A.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(m.message);default:throw new l.FileSystemError(m.message,m.name)}if(!(m instanceof Error))throw new l.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(m.message);switch(m.name){case A.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(m.message);case A.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(m.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(m.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(m.message);case A.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(m.message);case A.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(m.message);default:throw new l.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,D){return this._fileSystemProvider.set(m,D),(0,g.toDisposable)(()=>this._fileSystemProvider.delete(m))}};e.ExtHostConsumerFileSystem=T=je([$e(0,P.IExtHostRpcService),$e(1,_.IExtHostFileSystemInfo)],T),e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[286],Ce([1,0,3,33,2,6,15,7]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(k,m,D,S,v,n,h,d){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter;const w=this.ensureWatching(k,D,v);this._config=0,n&&(this._config+=1),h&&(this._config+=2),d&&(this._config+=4);const E=(0,A.parse)(v),p=typeof v=="string",t=S(a=>{if(!n)for(const r of a.created){const s=l.URI.revive(r);E(s.fsPath)&&(!p||m.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!h)for(const r of a.changed){const s=l.URI.revive(r);E(s.fsPath)&&(!p||m.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!d)for(const r of a.deleted){const s=l.URI.revive(r);E(s.fsPath)&&(!p||m.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(k,m,D){const S=P.Disposable.from();if(typeof D=="string")return S;const v=k.getProxy(L.MainContext.MainThreadFileSystem);let n=!1;(D.pattern.includes(A.GLOBSTAR)||D.pattern.includes(A.GLOB_SPLIT))&&(n=!0);const h=Math.random();return v.$watch(m.identifier.value,h,D.baseUri,{recursive:n,excludes:[]}),P.Disposable.from({dispose:()=>v.$unwatch(h)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class g{constructor(k,m,D){this._mainContext=k,this._logService=m,this._extHostDocumentsAndEditors=D,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,m,D,S,v,n){return new _(this._mainContext,k,m,this._onFileSystemEvent.event,R.GlobPattern.from(D),S,v,n)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,m){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(D=>({oldUri:l.URI.revive(D.source),newUri:l.URI.revive(D.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(D=>l.URI.revive(D.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(D=>l.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,m){return(D,S,v)=>{const n=function(d){D.call(S,d)};return n.extension=k,m.event(n,void 0,v)}}async $onWillRunFileOperation(k,m,D,S){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(v=>({oldUri:l.URI.revive(v.source),newUri:l.URI.revive(v.target)}))},D,S);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(v=>l.URI.revive(v.target))},D,S);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(v=>l.URI.revive(v.target))},D,S)}}async _fireWillEvent(k,m,D,S){const v=new Set,n=[];if(await k.fireAsync(m,S,async(d,w)=>{const E=Date.now(),p=await Promise.resolve(d);p instanceof P.WorkspaceEdit&&(n.push([w.extension,p]),v.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-E>D&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),S.isCancellationRequested||n.length===0)return;const h={edits:[]};for(const[,d]of n){const{edits:w}=R.WorkspaceEdit.from(d,{getTextDocumentVersion:E=>this._extHostDocumentsAndEditors.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(w)}return{edit:h,extensionNames:Array.from(v)}}}e.ExtHostFileSystemEventService=g}),define(ye[287],Ce([1,0,2,36]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(R,P,_,g,T){this._extHostNotebooks=P,this._textDocumentsAndEditors=_,this._commands=g;const k=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new A.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new A.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new A.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new A.ApiCommandResult("Notebook and input URI",m=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const D=this._extHostNotebooks.getEditorById(m.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:c.URI.revive(m.notebookUri),inputUri:c.URI.revive(m.inputUri),notebookEditor:D.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:c.URI.revive(m.notebookUri),inputUri:c.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(R,P,_,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:_,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=l}),define(ye[288],Ce([1,0,4,2,6,15,7,36]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class _{constructor(m,D){this.extension=m,this.provider=D,this.handle=_._pool++}}_._pool=0;class g{constructor(m){this.session=m,this.responses=[]}}class T{constructor(m,D,S,v){this._documents=S,this._logService=v,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=m.getProxy(l.MainContext.MainThreadInteractiveEditor),D.registerApiCommand(new P.ApiCommand("vscode.editorChat.start","interactiveEditor.start","Invoke a new editor chat session",[new P.ApiCommandArgument("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?L.Range.from(n.initialRange):void 0,message:n.message,autoSend:n.autoSend}})],P.ApiCommandResult.Void))}registerProvider(m,D){const S=new _(m,D);return this._inputProvider.set(S.handle,S),this._proxy.$registerInteractiveEditorProvider(S.handle,m.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,c.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(S.handle),this._inputProvider.delete(S.handle)})}async $prepareInteractiveSession(m,D,S,v){const n=this._inputProvider.get(m);if(!n){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const h=this._documents.getDocument(A.URI.revive(D)),d=L.Selection.to(S),w=await n.provider.prepareInteractiveEditorSession({document:h,selection:d},v);if(!w)return;if(w.wholeRange&&!w.wholeRange.contains(d))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const E=T._nextId++;return this._inputSessions.set(E,new g(w)),{id:E,placeholder:w.placeholder,slashCommands:w.slashCommands?.map(p=>({command:p.command,detail:p.detail,refer:p.refer})),wholeRange:L.Range.from(w.wholeRange)}}async $provideResponse(m,D,S,v){const n=this._inputProvider.get(m);if(!n)return;const h=this._inputSessions.get(D.id);if(!h)return;const d=await n.provider.provideInteractiveEditorResponse({session:h.session,prompt:S.prompt,selection:L.Selection.to(S.selection),wholeRange:L.Range.to(S.wholeRange),attempt:S.attempt},v);if(d){const w=h.responses.push(d)-1,E={wholeRange:L.Range.from(d.wholeRange),placeholder:d.placeholder};if(T._isMessageResponse(d))return{...E,id:w,type:"message",message:L.MarkdownString.from(d.contents)};const{edits:p}=d;if(p instanceof R.WorkspaceEdit)return{...E,id:w,type:"bulkEdit",edits:L.WorkspaceEdit.from(p)};if(Array.isArray(p))return{...E,id:w,type:"editorEdit",edits:p.map(L.TextEdit.from)}}}$handleFeedback(m,D,S,v){const n=this._inputProvider.get(m),h=this._inputSessions.get(D),d=h?.responses[S];if(n&&d){let w;switch(v){case 1:w=R.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:w=R.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:w=R.InteractiveEditorResponseFeedbackKind.Undone;break}n.provider.handleInteractiveEditorResponseFeedback?.(h.session,d,w)}}$releaseSession(m,D){const S=this._inputSessions.get(D),v=this._inputProvider.get(m);S&&v&&v.provider.releaseInteractiveEditorSession?.(S.session),this._inputSessions.delete(D)}static _isMessageResponse(m){return typeof m=="object"&&typeof m.contents=="object"}}e.ExtHostInteractiveEditor=T,T._nextId=0}),define(ye[289],Ce([1,0,6,7]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class l{constructor(R){this._IssueUriRequestHandlers=new Map,this._proxy=R.getProxy(c.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(R,P){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const _=this._IssueUriRequestHandlers.get(R);if(!_)throw new Error("Issue request handler not found");const g=await _.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(R,P){const _=R.identifier.value;return this._IssueUriRequestHandlers.set(_,P),this._proxy.$registerIssueUriRequestHandler(_),new A.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(_),this._IssueUriRequestHandlers.delete(_)})}}e.ExtHostIssueReporter=l}),define(ye[290],Ce([1,0,4,6]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(R){this._handlePool=0,this._proxy=R.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,R),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=l}),define(ye[291],Ce([1,0,2,23,15,7,76,6,11,35,19,12,154,22,4,122,109,80,40,8,16,25,191]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class a{constructor(O,q){this._documents=O,this._provider=q}async provideDocumentSymbols(O,q){const Q=this._documents.getDocument(O),ie=await this._provider.provideDocumentSymbols(Q,q);if(!(0,T.isFalsyOrEmpty)(ie))return ie[0]instanceof L.DocumentSymbol?ie.map(l.DocumentSymbol.from):a._asDocumentSymbolTree(ie)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((ie,pe)=>{let De=ie.location.range.start.compareTo(pe.location.range.start);return De===0&&(De=pe.location.range.end.compareTo(ie.location.range.end)),De});const q=[],Q=[];for(const ie of O){const pe={name:ie.name||"!!MISSING: name!!",kind:l.SymbolKind.from(ie.kind),tags:ie.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:ie.containerName,range:l.Range.from(ie.location.range),selectionRange:l.Range.from(ie.location.range),children:[]};for(;;){if(Q.length===0){Q.push(pe),q.push(pe);break}const De=Q[Q.length-1];if(g.Range.containsRange(De.range,pe.range)&&!g.Range.equalsRange(De.range,pe.range)){De.children?.push(pe),Q.push(pe);break}Q.pop()}}return q}}class r{constructor(O,q,Q){this._documents=O,this._commands=q,this._provider=Q,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,q){const Q=this._documents.getDocument(O),ie=await this._provider.provideCodeLenses(Q,q);if(!ie||q.isCancellationRequested)return;const pe=this._cache.add(ie),De=new S.DisposableStore;this._disposables.set(pe,De);const he={cacheId:pe,lenses:[]};for(let Ae=0;Ae<ie.length;Ae++)he.lenses.push({cacheId:[pe,Ae],range:l.Range.from(ie[Ae].range),command:this._commands.toInternal(ie[Ae].command,De)});return he}async resolveCodeLens(O,q){const Q=O.cacheId&&this._cache.get(...O.cacheId);if(!Q)return;let ie;if(typeof this._provider.resolveCodeLens!="function"||Q.isResolved?ie=Q:ie=await this._provider.resolveCodeLens(Q,q),ie||(ie=Q),q.isCancellationRequested)return;const pe=O.cacheId&&this._disposables.get(O.cacheId[0]);if(pe)return O.command=this._commands.toInternal(ie.command??r._badCmd,pe),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ue){return Array.isArray(ue)?ue.map(l.DefinitionLink.from):ue?[l.DefinitionLink.from(ue)]:[]}class f{constructor(O,q){this._documents=O,this._provider=q}async provideDefinition(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideDefinition(ie,pe,Q);return s(De)}}class b{constructor(O,q){this._documents=O,this._provider=q}async provideDeclaration(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideDeclaration(ie,pe,Q);return s(De)}}class u{constructor(O,q){this._documents=O,this._provider=q}async provideImplementation(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideImplementation(ie,pe,Q);return s(De)}}class C{constructor(O,q){this._documents=O,this._provider=q}async provideTypeDefinition(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideTypeDefinition(ie,pe,Q);return s(De)}}class y{constructor(O,q){this._documents=O,this._provider=q}async provideHover(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideHover(ie,pe,Q);if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ie.getWordRangeAtPosition(pe)),De.range||(De.range=new L.Range(pe,pe)),l.Hover.from(De)}}class o{constructor(O,q){this._documents=O,this._provider=q}async provideEvaluatableExpression(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideEvaluatableExpression(ie,pe,Q);if(De)return l.EvaluatableExpression.from(De)}}class i{constructor(O,q){this._documents=O,this._provider=q}async provideInlineValues(O,q,Q,ie){const pe=this._documents.getDocument(O),De=await this._provider.provideInlineValues(pe,l.Range.to(q),l.InlineValueContext.to(Q),ie);if(Array.isArray(De))return De.map(he=>l.InlineValue.from(he))}}class I{constructor(O,q){this._documents=O,this._provider=q}async provideDocumentHighlights(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideDocumentHighlights(ie,pe,Q);if(Array.isArray(De))return De.map(l.DocumentHighlight.from)}}class F{constructor(O,q){this._documents=O,this._provider=q}async provideLinkedEditingRanges(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.provideLinkedEditingRanges(ie,pe,Q);if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(l.Range.from)),wordPattern:De.wordPattern}}}class U{constructor(O,q){this._documents=O,this._provider=q}async provideReferences(O,q,Q,ie){const pe=this._documents.getDocument(O),De=l.Position.to(q),he=await this._provider.provideReferences(pe,De,Q,ie);if(Array.isArray(he))return he.map(l.location.from)}}class ${constructor(O,q,Q,ie,pe,De,he){this._documents=O,this._commands=q,this._diagnostics=Q,this._provider=ie,this._logService=pe,this._extension=De,this._apiDeprecation=he,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,q,Q,ie){const pe=this._documents.getDocument(O),De=m.Selection.isISelection(q)?l.Selection.to(q):l.Range.to(q),he=[];for(const Xe of this._diagnostics.getDiagnostics(O))if(De.intersection(Xe.range)&&he.push(Xe)>$._maxCodeActionsPerFile)break;const Ae={diagnostics:he,only:Q.only?new L.CodeActionKind(Q.only):void 0,triggerKind:l.CodeActionTriggerKind.to(Q.trigger)},Te=await this._provider.provideCodeActions(pe,De,Ae,ie);if(!(0,T.isNonEmptyArray)(Te)||ie.isCancellationRequested)return;const He=this._cache.add(Te),Ve=new S.DisposableStore;this._disposables.set(He,Ve);const tt=[];for(let Xe=0;Xe<Te.length;Xe++){const Ke=Te[Xe];Ke&&($._isCommand(Ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Ke.title,command:this._commands.toInternal(Ke,Ve)})):(Ae.only&&(Ke.kind?Ae.only.contains(Ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${Ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[He,Xe],title:Ke.title,command:Ke.command&&this._commands.toInternal(Ke.command,Ve),diagnostics:Ke.diagnostics&&Ke.diagnostics.map(l.Diagnostic.from),edit:Ke.edit&&l.WorkspaceEdit.from(Ke.edit,void 0),kind:Ke.kind&&Ke.kind.value,isPreferred:Ke.isPreferred,disabled:Ke.disabled?.reason})))}return{cacheId:He,actions:tt}}async resolveCodeAction(O,q){const[Q,ie]=O,pe=this._cache.get(Q,ie);if(!pe||$._isCommand(pe))return{};if(!this._provider.resolveCodeAction)return{};const De=await this._provider.resolveCodeAction(pe,q)??pe;let he;De.edit&&(he=l.WorkspaceEdit.from(De.edit,void 0));let Ae;if(De.command){const Te=this._disposables.get(Q);Te&&(Ae=this._commands.toInternal(De.command,Te))}return{edit:he,command:Ae}}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}$._maxCodeActionsPerFile=1e3;class B{constructor(O,q,Q,ie,pe){this._proxy=O,this._documents=q,this._provider=Q,this._handle=ie,this._extension=pe}async prepareDocumentPaste(O,q,Q,ie){if(!this._provider.prepareDocumentPaste)return;const pe=this._documents.getDocument(O),De=q.map(Te=>l.Range.to(Te)),he=l.DataTransfer.toDataTransfer(Q,()=>{throw new w.NotImplementedError});if(await this._provider.prepareDocumentPaste(pe,De,he,ie),ie.isCancellationRequested)return;const Ae=Array.from(he).filter(([,Te])=>!(Te instanceof L.InternalDataTransferItem));return l.DataTransfer.from(Ae)}async providePasteEdits(O,q,Q,ie,pe){if(!this._provider.provideDocumentPasteEdits)return;const De=this._documents.getDocument(q),he=Q.map(He=>l.Range.to(He)),Ae=l.DataTransfer.toDataTransfer(ie,async He=>(await this._proxy.$resolvePasteFileData(this._handle,O,He)).buffer),Te=await this._provider.provideDocumentPasteEdits(De,he,Ae,pe);if(Te)return{id:Te.id?this._extension.identifier.value+"."+Te.id:this._extension.identifier.value,label:Te.label??(0,t.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,priority:Te.priority??0,insertText:typeof Te.insertText=="string"?Te.insertText:{snippet:Te.insertText.value},additionalEdit:Te.additionalEdit?l.WorkspaceEdit.from(Te.additionalEdit,void 0):void 0}}}class N{constructor(O,q){this._documents=O,this._provider=q}async provideDocumentFormattingEdits(O,q,Q){const ie=this._documents.getDocument(O),pe=await this._provider.provideDocumentFormattingEdits(ie,q,Q);if(Array.isArray(pe))return pe.map(l.TextEdit.from)}}class V{constructor(O,q){this._documents=O,this._provider=q}async provideDocumentRangeFormattingEdits(O,q,Q,ie){const pe=this._documents.getDocument(O),De=l.Range.to(q),he=await this._provider.provideDocumentRangeFormattingEdits(pe,De,Q,ie);if(Array.isArray(he))return he.map(l.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,q,Q,ie){(0,k.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const pe=this._documents.getDocument(O),De=q.map(l.Range.to),he=await this._provider.provideDocumentRangesFormattingEdits(pe,De,Q,ie);if(Array.isArray(he))return he.map(l.TextEdit.from)}}class x{constructor(O,q){this._documents=O,this._provider=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,q,Q,ie,pe){const De=this._documents.getDocument(O),he=l.Position.to(q),Ae=await this._provider.provideOnTypeFormattingEdits(De,he,Q,ie,pe);if(Array.isArray(Ae))return Ae.map(l.TextEdit.from)}}class W{constructor(O,q){this._provider=O,this._logService=q,this._cache=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,q){const Q=await this._provider.provideWorkspaceSymbols(O,q);if(!(0,T.isNonEmptyArray)(Q))return{symbols:[]};const ie=this._cache.add(Q),pe={cacheId:ie,symbols:[]};for(let De=0;De<Q.length;De++){const he=Q[De];if(!he||!he.name){this._logService.warn("INVALID SymbolInformation",he);continue}pe.symbols.push({...l.WorkspaceSymbol.from(he),cacheId:[ie,De]})}return pe}async resolveWorkspaceSymbol(O,q){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const Q=this._cache.get(...O.cacheId);if(Q){const ie=await this._provider.resolveWorkspaceSymbol(Q,q);return ie&&(0,A.mixin)(O,l.WorkspaceSymbol.from(ie),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class ee{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,q,Q){this._documents=O,this._provider=q,this._logService=Q}async provideRenameEdits(O,q,Q,ie){const pe=this._documents.getDocument(O),De=l.Position.to(q);try{const he=await this._provider.provideRenameEdits(pe,De,Q,ie);return he?l.WorkspaceEdit.from(he):void 0}catch(he){const Ae=ee._asMessage(he);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(O,q,Q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ie=this._documents.getDocument(O),pe=l.Position.to(q);try{const De=await this._provider.prepareRename(ie,pe,Q);let he,Ae;if(L.Range.isRange(De)?(he=De,Ae=ie.getText(De)):(0,k.isObject)(De)&&(he=De.range,Ae=De.placeholder),!he||!Ae)return;if(he.start.line>pe.line||he.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(he),text:Ae}}catch(De){const he=ee._asMessage(De);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(De)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class se{constructor(O,q){this.resultId=O,this.tokens=q}}class H{constructor(O,q){this._documents=O,this._provider=q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,q,Q){const ie=this._documents.getDocument(O),pe=q!==0?this._previousResults.get(q):null;let De=typeof pe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ie,pe.resultId,Q):await this._provider.provideDocumentSemanticTokens(ie,Q);return pe&&this._previousResults.delete(q),De?(De=H._fixProvidedSemanticTokens(De),this._send(H._convertToEdits(pe,De),De)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return H._isSemanticTokens(O)?H._isCorrectSemanticTokens(O)?O:new L.SemanticTokens(new Uint32Array(O.data),O.resultId):H._isSemanticTokensEdits(O)?H._isCorrectSemanticTokensEdits(O)?O:new L.SemanticTokensEdits(O.edits.map(q=>new L.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const q of O.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,q){if(!H._isSemanticTokens(q)||!O||!O.tokens)return q;const Q=O.tokens,ie=Q.length,pe=q.data,De=pe.length;let he=0;const Ae=Math.min(ie,De);for(;he<Ae&&Q[he]===pe[he];)he++;if(he===ie&&he===De)return new L.SemanticTokensEdits([],q.resultId);let Te=0;const He=Ae-he;for(;Te<He&&Q[ie-Te-1]===pe[De-Te-1];)Te++;return new L.SemanticTokensEdits([{start:he,deleteCount:ie-he-Te,data:pe.subarray(he,De-Te)}],q.resultId)}_send(O,q){if(H._isSemanticTokens(O)){const Q=this._nextResultId++;return this._previousResults.set(Q,new se(O.resultId,O.data)),(0,v.encodeSemanticTokensDto)({id:Q,type:"full",data:O.data})}if(H._isSemanticTokensEdits(O)){const Q=this._nextResultId++;return H._isSemanticTokens(q)?this._previousResults.set(Q,new se(q.resultId,q.data)):this._previousResults.set(Q,new se(O.resultId)),(0,v.encodeSemanticTokensDto)({id:Q,type:"delta",deltas:(O.edits||[]).map(ie=>({start:ie.start,deleteCount:ie.deleteCount,data:ie.data}))})}return null}}class J{constructor(O,q){this._documents=O,this._provider=q}async provideDocumentRangeSemanticTokens(O,q,Q){const ie=this._documents.getDocument(O),pe=await this._provider.provideDocumentRangeSemanticTokens(ie,l.Range.to(q),Q);return pe?this._send(pe):null}_send(O){return(0,v.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class j{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,q,Q,ie,pe){this._documents=O,this._commands=q,this._provider=Q,this._apiDeprecation=ie,this._extension=pe,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,q,Q,ie){const pe=this._documents.getDocument(O),De=l.Position.to(q),he=pe.getWordRangeAtPosition(De)||new L.Range(De,De),Ae=he.with({end:De}),Te=new d.StopWatch(!0),He=await this._provider.provideCompletionItems(pe,De,ie,l.CompletionContext.to(Q));if(!He||ie.isCancellationRequested)return;const Ve=Array.isArray(He)?new L.CompletionList(He):He,tt=j.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),Xe=new S.DisposableStore;this._disposables.set(tt,Xe);const Ke=[],nt={x:tt,b:Ke,a:{replace:l.Range.from(he),insert:l.Range.from(Ae)},c:Ve.isIncomplete||void 0,d:Te.elapsed()};for(let ot=0;ot<Ve.items.length;ot++){const et=Ve.items[ot],xe=this._convertCompletionItem(et,[tt,ot],Ae,he);Ke.push(xe)}return nt}async resolveCompletionItem(O,q){if(typeof this._provider.resolveCompletionItem!="function")return;const Q=this._cache.get(...O);if(!Q)return;const ie=await this._provider.resolveCompletionItem(Q,q);if(!ie)return;const pe={...Q,documentation:ie.documentation,detail:ie.detail,additionalTextEdits:ie.additionalTextEdits};return Q.insertText!==ie.insertText&&(this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),pe.insertText=ie.insertText),this._convertCompletionItem(pe,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,q,Q,ie){const pe=this._disposables.get(q[0]);if(!pe)throw Error("DisposableStore is missing...");const De=this._commands.toInternal(O.command,pe),he={x:q,a:O.label,b:O.kind!==void 0?l.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(l.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:l.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(l.TextEdit.from),n:De?.$ident,o:De?.id,p:De?.$ident?void 0:De?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),he.h=O.textEdit.newText):typeof O.insertText=="string"?he.h=O.insertText:O.insertText instanceof L.SnippetString&&(he.h=O.insertText.value,he.i|=4);let Ae;return O.textEdit?Ae=O.textEdit.range:O.range&&(Ae=O.range),L.Range.isRange(Ae)?he.j=l.Range.from(Ae):Ae&&(!Q?.isEqual(Ae.inserting)||!ie?.isEqual(Ae.replacing))&&(he.j={insert:l.Range.from(Ae.inserting),replace:l.Range.from(Ae.replacing)}),he}}class ae{async provideInlineCompletions(O,q,Q,ie){}disposeCompletions(O){}handleDidShowCompletionItem(O,q,Q){}handlePartialAccept(O,q,Q){}}class we extends ae{constructor(O,q,Q,ie){super(),this._extension=O,this._documents=q,this._provider=Q,this._commands=ie,this._references=new _e,this._isAdditionsProposedApiEnabled=(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,q,Q,ie){const pe=this._documents.getDocument(O),De=l.Position.to(q),he=await this._provider.provideInlineCompletionItems(pe,De,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:l.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Q.triggerKind]},ie);if(!he||ie.isCancellationRequested)return;const Ae=Array.isArray(he)?he:he.items,Te=this._isAdditionsProposedApiEnabled?Array.isArray(he)?[]:he.commands||[]:[],He=this._isAdditionsProposedApiEnabled&&!Array.isArray(he)?he.suppressSuggestions:void 0,Ve=this._isAdditionsProposedApiEnabled&&!Array.isArray(he)?he.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:Ae}),items:Ae.map((Ke,nt)=>{let ot;Ke.command&&(tt||(tt=new S.DisposableStore),ot=this._commands.toInternal(Ke.command,tt));const et=Ke.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:Ke.filterText,range:Ke.range?l.Range.from(Ke.range):void 0,command:ot,idx:nt,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ke.completeBracketPairs:!1}}),commands:Te.map(Ke=>(tt||(tt=new S.DisposableStore),this._commands.toInternal(Ke,tt))),suppressSuggestions:He,enableForwardStability:Ve}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,q,Q){const ie=this._references.get(O)?.items[q];ie&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(ie,Q)}handlePartialAccept(O,q,Q){const ie=this._references.get(O)?.items[q];ie&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(ie,Q)}}class _e{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const q=this._idPool++;return this._references.set(q,O),q}disposeReferenceId(O){const q=this._references.get(O);return this._references.delete(O),q}get(O){return this._references.get(O)}}class ve{constructor(O,q){this._documents=O,this._provider=q,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,q,Q,ie){const pe=this._documents.getDocument(O),De=l.Position.to(q),he=this.reviveContext(Q),Ae=await this._provider.provideSignatureHelp(pe,De,ie,he);if(Ae){const Te=this._cache.add([Ae]);return{...l.SignatureHelp.from(Ae),id:Te}}}reviveContext(O){let q;if(O.activeSignatureHelp){const Q=l.SignatureHelp.to(O.activeSignatureHelp),ie=this._cache.get(O.activeSignatureHelp.id,0);ie?(q=ie,q.activeSignature=Q.activeSignature,q.activeParameter=Q.activeParameter):q=Q}return{...O,activeSignatureHelp:q}}releaseSignatureHelp(O){this._cache.delete(O)}}class M{constructor(O,q,Q,ie,pe){this._documents=O,this._commands=q,this._provider=Q,this._logService=ie,this._extension=pe,this._cache=new h.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Range.to(q),De=await this._provider.provideInlayHints(ie,pe,Q);if(!Array.isArray(De)||De.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${q}`);return}if(Q.isCancellationRequested)return;const he=this._cache.add(De);this._disposables.set(he,new S.DisposableStore);const Ae={hints:[],cacheId:he};for(let Te=0;Te<De.length;Te++)this._isValidInlayHint(De[Te],pe)&&Ae.hints.push(this._convertInlayHint(De[Te],[he,Te]));return this._logService.trace(`[InlayHints] ${Ae.hints.length} inlay hints from '${this._extension.identifier.value}' for ${q}`),Ae}async resolveInlayHint(O,q){if(typeof this._provider.resolveInlayHint!="function")return;const Q=this._cache.get(...O);if(!Q)return;const ie=await this._provider.resolveInlayHint(Q,q);if(ie&&this._isValidInlayHint(ie))return this._convertInlayHint(ie,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,q){return O.label.length===0||Array.isArray(O.label)&&O.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(q&&!q.contains(O.position))}_convertInlayHint(O,q){const Q=this._disposables.get(q[0]);if(!Q)throw Error("DisposableStore is missing...");const ie={label:"",cacheId:q,tooltip:l.MarkdownString.fromStrict(O.tooltip),position:l.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(l.TextEdit.from),kind:O.kind&&l.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?ie.label=O.label:ie.label=O.label.map(pe=>{const De={label:pe.value};return De.tooltip=l.MarkdownString.fromStrict(pe.tooltip),L.Location.isLocation(pe.location)&&(De.location=l.location.from(pe.location)),pe.command&&(De.command=this._commands.toInternal(pe.command,Q)),De}),ie}}class X{constructor(O,q){this._documents=O,this._provider=q,this._cache=new h.Cache("DocumentLink")}async provideLinks(O,q){const Q=this._documents.getDocument(O),ie=await this._provider.provideDocumentLinks(Q,q);if(!(!Array.isArray(ie)||ie.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ie.filter(X._validateLink).map(l.DocumentLink.from)};{const pe=this._cache.add(ie),De={links:[],cacheId:pe};for(let he=0;he<ie.length;he++){if(!X._validateLink(ie[he]))continue;const Ae=l.DocumentLink.from(ie[he]);Ae.cacheId=[pe,he],De.links.push(Ae)}return De}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,q){if(typeof this._provider.resolveDocumentLink!="function")return;const Q=this._cache.get(...O);if(!Q)return;const ie=await this._provider.resolveDocumentLink(Q,q);if(!(!ie||!X._validateLink(ie)))return l.DocumentLink.from(ie)}releaseLinks(O){this._cache.delete(O)}}class fe{constructor(O,q){this._documents=O,this._provider=q}async provideColors(O,q){const Q=this._documents.getDocument(O),ie=await this._provider.provideDocumentColors(Q,q);return Array.isArray(ie)?ie.map(De=>({color:l.Color.from(De.color),range:l.Range.from(De.range)})):[]}async provideColorPresentations(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Range.to(q.range),De=l.Color.to(q.color),he=await this._provider.provideColorPresentations(De,{document:ie,range:pe},Q);if(Array.isArray(he))return he.map(l.ColorPresentation.from)}}class Ee{constructor(O,q){this._documents=O,this._provider=q}async provideFoldingRanges(O,q,Q){const ie=this._documents.getDocument(O),pe=await this._provider.provideFoldingRanges(ie,q,Q);if(Array.isArray(pe))return pe.map(l.FoldingRange.from)}}class Z{constructor(O,q,Q){this._documents=O,this._provider=q,this._logService=Q}async provideSelectionRanges(O,q,Q){const ie=this._documents.getDocument(O),pe=q.map(l.Position.to),De=await this._provider.provideSelectionRanges(ie,pe,Q);if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ae=0;Ae<pe.length;Ae++){const Te=[];he.push(Te);let He=pe[Ae],Ve=De[Ae];for(;;){if(!Ve.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Te.push(l.SelectionRange.from(Ve)),!Ve.parent)break;He=Ve.range,Ve=Ve.parent}}return he}}class ne{constructor(O,q){this._documents=O,this._provider=q,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.prepareCallHierarchy(ie,pe,Q);if(!De)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(De)?De.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,De)]}async provideCallsTo(O,q,Q){const ie=this._itemFromCache(O,q);if(!ie)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(ie,Q);if(pe)return pe.map(De=>({from:this._cacheAndConvertItem(O,De.from),fromRanges:De.fromRanges.map(he=>l.Range.from(he))}))}async provideCallsFrom(O,q,Q){const ie=this._itemFromCache(O,q);if(!ie)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(ie,Q);if(pe)return pe.map(De=>({to:this._cacheAndConvertItem(O,De.to),fromRanges:De.fromRanges.map(he=>l.Range.from(he))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,q){const Q=this._cache.get(O),ie=l.CallHierarchyItem.from(q,O,Q.size.toString(36));return Q.set(ie._itemId,q),ie}_itemFromCache(O,q){return this._cache.get(O)?.get(q)}}class le{constructor(O,q){this._documents=O,this._provider=q,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(O,q,Q){const ie=this._documents.getDocument(O),pe=l.Position.to(q),De=await this._provider.prepareTypeHierarchy(ie,pe,Q);if(!De)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(De)?De.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,De)]}async provideSupertypes(O,q,Q){const ie=this._itemFromCache(O,q);if(!ie)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySupertypes(ie,Q);if(pe)return pe.map(De=>this._cacheAndConvertItem(O,De))}async provideSubtypes(O,q,Q){const ie=this._itemFromCache(O,q);if(!ie)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySubtypes(ie,Q);if(pe)return pe.map(De=>this._cacheAndConvertItem(O,De))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,q){const Q=this._cache.get(O),ie=l.TypeHierarchyItem.from(q,O,Q.size.toString(36));return Q.set(ie._itemId,q),ie}_itemFromCache(O,q){return this._cache.get(O)?.get(q)}}class te{constructor(O,q,Q,ie,pe){this._proxy=O,this._documents=q,this._provider=Q,this._handle=ie,this._extension=pe}async provideDocumentOnDropEdits(O,q,Q,ie,pe){const De=this._documents.getDocument(q),he=l.Position.to(Q),Ae=l.DataTransfer.toDataTransfer(ie,async He=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,He)).buffer),Te=await this._provider.provideDocumentDropEdits(De,he,Ae,pe);if(Te)return{id:Te.id?this._extension.identifier.value+"."+Te.id:this._extension.identifier.value,label:Te.label??(0,t.localize)(1,null,this._extension.displayName||this._extension.name),priority:Te.priority??0,insertText:typeof Te.insertText=="string"?Te.insertText:{snippet:Te.insertText.value},additionalEdit:Te.additionalEdit?l.WorkspaceEdit.from(Te.additionalEdit,void 0):void 0}}}class de{constructor(O,q){this.adapter=O,this.extension=q}}class oe{constructor(O,q,Q,ie,pe,De,he,Ae){this._uriTransformer=q,this._documents=Q,this._commands=ie,this._diagnostics=pe,this._logService=De,this._apiDeprecation=he,this._extensionTelemetry=Ae,this._adapter=new Map,this._proxy=O.getProxy(P.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O,q){return l.DocumentSelector.from(O,this._uriTransformer,q)}_createDisposable(O){return new L.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return oe._handlePool++}async _withAdapter(O,q,Q,ie,pe,De=!1){const he=this._adapter.get(O);if(!he||!(he.adapter instanceof q))return ie;const Ae=Date.now();De||this._logService.trace(`[${he.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Te=Q(he.adapter,he.extension);return Promise.resolve(Te).catch(He=>{(0,w.isCancellationError)(He)||(this._logService.error(`[${he.extension.identifier.value}] provider FAILED`),this._logService.error(He),this._extensionTelemetry.onExtensionError(he.extension.identifier,He))}).finally(()=>{De||this._logService.trace(`[${he.extension.identifier.value}] provider DONE after ${Date.now()-Ae}ms`)}),D.CancellationToken.isCancellationToken(pe)?(0,E.raceCancellationError)(Te,pe):Te}_addNewAdapter(O,q){const Q=this._nextHandle();return this._adapter.set(Q,new de(O,q)),Q}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,q,Q,ie){const pe=this._addNewAdapter(new a(this._documents,Q),O),De=ie&&ie.label||oe._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(q,O),De),this._createDisposable(pe)}$provideDocumentSymbols(O,q,Q){return this._withAdapter(O,a,ie=>ie.provideDocumentSymbols(c.URI.revive(q),Q),void 0,Q)}registerCodeLensProvider(O,q,Q){const ie=this._nextHandle(),pe=typeof Q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ie,new de(new r(this._documents,this._commands.converter,Q),O)),this._proxy.$registerCodeLensSupport(ie,this._transformDocumentSelector(q,O),pe);let De=this._createDisposable(ie);if(pe!==void 0){const he=Q.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(pe));De=L.Disposable.from(De,he)}return De}$provideCodeLenses(O,q,Q){return this._withAdapter(O,r,ie=>ie.provideCodeLenses(c.URI.revive(q),Q),void 0,Q)}$resolveCodeLens(O,q,Q){return this._withAdapter(O,r,ie=>ie.resolveCodeLens(q,Q),void 0,void 0)}$releaseCodeLenses(O,q){this._withAdapter(O,r,Q=>Promise.resolve(Q.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(O,q,Q){const ie=this._addNewAdapter(new f(this._documents,Q),O);return this._proxy.$registerDefinitionSupport(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideDefinition(O,q,Q,ie){return this._withAdapter(O,f,pe=>pe.provideDefinition(c.URI.revive(q),Q,ie),[],ie)}registerDeclarationProvider(O,q,Q){const ie=this._addNewAdapter(new b(this._documents,Q),O);return this._proxy.$registerDeclarationSupport(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideDeclaration(O,q,Q,ie){return this._withAdapter(O,b,pe=>pe.provideDeclaration(c.URI.revive(q),Q,ie),[],ie)}registerImplementationProvider(O,q,Q){const ie=this._addNewAdapter(new u(this._documents,Q),O);return this._proxy.$registerImplementationSupport(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideImplementation(O,q,Q,ie){return this._withAdapter(O,u,pe=>pe.provideImplementation(c.URI.revive(q),Q,ie),[],ie)}registerTypeDefinitionProvider(O,q,Q){const ie=this._addNewAdapter(new C(this._documents,Q),O);return this._proxy.$registerTypeDefinitionSupport(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideTypeDefinition(O,q,Q,ie){return this._withAdapter(O,C,pe=>pe.provideTypeDefinition(c.URI.revive(q),Q,ie),[],ie)}registerHoverProvider(O,q,Q,ie){const pe=this._addNewAdapter(new y(this._documents,Q),O);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(q,O)),this._createDisposable(pe)}$provideHover(O,q,Q,ie){return this._withAdapter(O,y,pe=>pe.provideHover(c.URI.revive(q),Q,ie),void 0,ie)}registerEvaluatableExpressionProvider(O,q,Q,ie){const pe=this._addNewAdapter(new o(this._documents,Q),O);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(q,O)),this._createDisposable(pe)}$provideEvaluatableExpression(O,q,Q,ie){return this._withAdapter(O,o,pe=>pe.provideEvaluatableExpression(c.URI.revive(q),Q,ie),void 0,ie)}registerInlineValuesProvider(O,q,Q,ie){const pe=typeof Q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new i(this._documents,Q),O);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(q,O),pe);let he=this._createDisposable(De);if(pe!==void 0){const Ae=Q.onDidChangeInlineValues(Te=>this._proxy.$emitInlineValuesEvent(pe));he=L.Disposable.from(he,Ae)}return he}$provideInlineValues(O,q,Q,ie,pe){return this._withAdapter(O,i,De=>De.provideInlineValues(c.URI.revive(q),Q,ie,pe),void 0,pe)}registerDocumentHighlightProvider(O,q,Q){const ie=this._addNewAdapter(new I(this._documents,Q),O);return this._proxy.$registerDocumentHighlightProvider(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideDocumentHighlights(O,q,Q,ie){return this._withAdapter(O,I,pe=>pe.provideDocumentHighlights(c.URI.revive(q),Q,ie),void 0,ie)}registerLinkedEditingRangeProvider(O,q,Q){const ie=this._addNewAdapter(new F(this._documents,Q),O);return this._proxy.$registerLinkedEditingRangeProvider(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideLinkedEditingRanges(O,q,Q,ie){return this._withAdapter(O,F,async pe=>{const De=await pe.provideLinkedEditingRanges(c.URI.revive(q),Q,ie);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?oe._serializeRegExp(De.wordPattern):void 0}},void 0,ie)}registerReferenceProvider(O,q,Q){const ie=this._addNewAdapter(new U(this._documents,Q),O);return this._proxy.$registerReferenceSupport(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideReferences(O,q,Q,ie,pe){return this._withAdapter(O,U,De=>De.provideReferences(c.URI.revive(q),Q,ie,pe),void 0,pe)}registerCodeActionProvider(O,q,Q,ie){const pe=new S.DisposableStore,De=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,Q,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(De,this._transformDocumentSelector(q,O),{providedKinds:ie?.providedCodeActionKinds?.map(he=>he.value),documentation:ie?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,pe)}))},oe._extLabel(O),!!Q.resolveCodeAction),pe.add(this._createDisposable(De)),pe}$provideCodeActions(O,q,Q,ie,pe){return this._withAdapter(O,$,De=>De.provideCodeActions(c.URI.revive(q),Q,ie,pe),void 0,pe)}$resolveCodeAction(O,q,Q){return this._withAdapter(O,$,ie=>ie.resolveCodeAction(q,Q),{},void 0)}$releaseCodeActions(O,q){this._withAdapter(O,$,Q=>Promise.resolve(Q.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(O,q,Q){const ie=this._addNewAdapter(new N(this._documents,Q),O);return this._proxy.$registerDocumentFormattingSupport(ie,this._transformDocumentSelector(q,O),O.identifier,O.displayName||O.name),this._createDisposable(ie)}$provideDocumentFormattingEdits(O,q,Q,ie){return this._withAdapter(O,N,pe=>pe.provideDocumentFormattingEdits(c.URI.revive(q),Q,ie),void 0,ie)}registerDocumentRangeFormattingEditProvider(O,q,Q){const ie=typeof Q.provideDocumentRangesFormattingEdits=="function";ie&&(0,p.checkProposedApiEnabled)(O,"formatMultipleRanges");const pe=this._addNewAdapter(new V(this._documents,Q),O);return this._proxy.$registerRangeFormattingSupport(pe,this._transformDocumentSelector(q,O),O.identifier,O.displayName||O.name,ie),this._createDisposable(pe)}$provideDocumentRangeFormattingEdits(O,q,Q,ie,pe){return this._withAdapter(O,V,De=>De.provideDocumentRangeFormattingEdits(c.URI.revive(q),Q,ie,pe),void 0,pe)}$provideDocumentRangesFormattingEdits(O,q,Q,ie,pe){return this._withAdapter(O,V,De=>De.provideDocumentRangesFormattingEdits(c.URI.revive(q),Q,ie,pe),void 0,pe)}registerOnTypeFormattingEditProvider(O,q,Q,ie){const pe=this._addNewAdapter(new x(this._documents,Q),O);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(q,O),ie,O.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(O,q,Q,ie,pe,De){return this._withAdapter(O,x,he=>he.provideOnTypeFormattingEdits(c.URI.revive(q),Q,ie,pe,De),void 0,De)}registerWorkspaceSymbolProvider(O,q){const Q=this._addNewAdapter(new W(q,this._logService),O);return this._proxy.$registerNavigateTypeSupport(Q,typeof q.resolveWorkspaceSymbol=="function"),this._createDisposable(Q)}$provideWorkspaceSymbols(O,q,Q){return this._withAdapter(O,W,ie=>ie.provideWorkspaceSymbols(q,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(O,q,Q){return this._withAdapter(O,W,ie=>ie.resolveWorkspaceSymbol(q,Q),void 0,void 0)}$releaseWorkspaceSymbols(O,q){this._withAdapter(O,W,Q=>Q.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(O,q,Q){const ie=this._addNewAdapter(new ee(this._documents,Q,this._logService),O);return this._proxy.$registerRenameSupport(ie,this._transformDocumentSelector(q,O),ee.supportsResolving(Q)),this._createDisposable(ie)}$provideRenameEdits(O,q,Q,ie,pe){return this._withAdapter(O,ee,De=>De.provideRenameEdits(c.URI.revive(q),Q,ie,pe),void 0,pe)}$resolveRenameLocation(O,q,Q,ie){return this._withAdapter(O,ee,pe=>pe.resolveRenameLocation(c.URI.revive(q),Q,ie),void 0,ie)}registerDocumentSemanticTokensProvider(O,q,Q,ie){const pe=this._addNewAdapter(new H(this._documents,Q),O),De=typeof Q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(q,O),ie,De);let he=this._createDisposable(pe);if(De){const Ae=Q.onDidChangeSemanticTokens(Te=>this._proxy.$emitDocumentSemanticTokensEvent(De));he=L.Disposable.from(he,Ae)}return he}$provideDocumentSemanticTokens(O,q,Q,ie){return this._withAdapter(O,H,pe=>pe.provideDocumentSemanticTokens(c.URI.revive(q),Q,ie),null,ie)}$releaseDocumentSemanticTokens(O,q){this._withAdapter(O,H,Q=>Q.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,q,Q,ie){const pe=this._addNewAdapter(new J(this._documents,Q),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(q,O),ie),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(O,q,Q,ie){return this._withAdapter(O,J,pe=>pe.provideDocumentRangeSemanticTokens(c.URI.revive(q),Q,ie),null,ie)}registerCompletionItemProvider(O,q,Q,ie){const pe=this._addNewAdapter(new j(this._documents,this._commands.converter,Q,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(pe,this._transformDocumentSelector(q,O),ie,j.supportsResolving(Q),`${O.identifier.value}(${ie.join("")})`),this._createDisposable(pe)}$provideCompletionItems(O,q,Q,ie,pe){return this._withAdapter(O,j,De=>De.provideCompletionItems(c.URI.revive(q),Q,ie,pe),void 0,pe)}$resolveCompletionItem(O,q,Q){return this._withAdapter(O,j,ie=>ie.resolveCompletionItem(q,Q),void 0,Q)}$releaseCompletionItems(O,q){this._withAdapter(O,j,Q=>Q.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(O,q,Q){const ie=new we(O,this._documents,Q,this._commands.converter),pe=this._addNewAdapter(ie,O);return this._proxy.$registerInlineCompletionsSupport(pe,this._transformDocumentSelector(q,O),ie.supportsHandleEvents),this._createDisposable(pe)}$provideInlineCompletions(O,q,Q,ie,pe){return this._withAdapter(O,ae,De=>De.provideInlineCompletions(c.URI.revive(q),Q,ie,pe),void 0,pe)}$handleInlineCompletionDidShow(O,q,Q,ie){this._withAdapter(O,ae,async pe=>{pe.handleDidShowCompletionItem(q,Q,ie)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,q,Q,ie){this._withAdapter(O,ae,async pe=>{pe.handlePartialAccept(q,Q,ie)},void 0,void 0)}$freeInlineCompletionsList(O,q){this._withAdapter(O,ae,async Q=>{Q.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(O,q,Q,ie){const pe=Array.isArray(ie)?{triggerCharacters:ie,retriggerCharacters:[]}:ie,De=this._addNewAdapter(new ve(this._documents,Q),O);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(q,O),pe),this._createDisposable(De)}$provideSignatureHelp(O,q,Q,ie,pe){return this._withAdapter(O,ve,De=>De.provideSignatureHelp(c.URI.revive(q),Q,ie,pe),void 0,pe)}$releaseSignatureHelp(O,q){this._withAdapter(O,ve,Q=>Q.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(O,q,Q){const ie=typeof Q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new M(this._documents,this._commands.converter,Q,this._logService,O),O);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(q,O),typeof Q.resolveInlayHint=="function",ie,oe._extLabel(O));let De=this._createDisposable(pe);if(ie!==void 0){const he=Q.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ie));De=L.Disposable.from(De,he)}return De}$provideInlayHints(O,q,Q,ie){return this._withAdapter(O,M,pe=>pe.provideInlayHints(c.URI.revive(q),Q,ie),void 0,ie)}$resolveInlayHint(O,q,Q){return this._withAdapter(O,M,ie=>ie.resolveInlayHint(q,Q),void 0,Q)}$releaseInlayHints(O,q){this._withAdapter(O,M,Q=>Q.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(O,q,Q){const ie=this._addNewAdapter(new X(this._documents,Q),O);return this._proxy.$registerDocumentLinkProvider(ie,this._transformDocumentSelector(q,O),typeof Q.resolveDocumentLink=="function"),this._createDisposable(ie)}$provideDocumentLinks(O,q,Q){return this._withAdapter(O,X,ie=>ie.provideLinks(c.URI.revive(q),Q),void 0,Q,q.scheme==="output")}$resolveDocumentLink(O,q,Q){return this._withAdapter(O,X,ie=>ie.resolveLink(q,Q),void 0,void 0,!0)}$releaseDocumentLinks(O,q){this._withAdapter(O,X,Q=>Q.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(O,q,Q){const ie=this._addNewAdapter(new fe(this._documents,Q),O);return this._proxy.$registerDocumentColorProvider(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideDocumentColors(O,q,Q){return this._withAdapter(O,fe,ie=>ie.provideColors(c.URI.revive(q),Q),[],Q)}$provideColorPresentations(O,q,Q,ie){return this._withAdapter(O,fe,pe=>pe.provideColorPresentations(c.URI.revive(q),Q,ie),void 0,ie)}registerFoldingRangeProvider(O,q,Q){const ie=this._nextHandle(),pe=typeof Q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ie,new de(new Ee(this._documents,Q),O)),this._proxy.$registerFoldingRangeProvider(ie,this._transformDocumentSelector(q,O),O.identifier,pe);let De=this._createDisposable(ie);if(pe!==void 0){const he=Q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));De=L.Disposable.from(De,he)}return De}$provideFoldingRanges(O,q,Q,ie){return this._withAdapter(O,Ee,pe=>pe.provideFoldingRanges(c.URI.revive(q),Q,ie),void 0,ie)}registerSelectionRangeProvider(O,q,Q){const ie=this._addNewAdapter(new Z(this._documents,Q,this._logService),O);return this._proxy.$registerSelectionRangeProvider(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$provideSelectionRanges(O,q,Q,ie){return this._withAdapter(O,Z,pe=>pe.provideSelectionRanges(c.URI.revive(q),Q,ie),[],ie)}registerCallHierarchyProvider(O,q,Q){const ie=this._addNewAdapter(new ne(this._documents,Q),O);return this._proxy.$registerCallHierarchyProvider(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$prepareCallHierarchy(O,q,Q,ie){return this._withAdapter(O,ne,pe=>Promise.resolve(pe.prepareSession(c.URI.revive(q),Q,ie)),void 0,ie)}$provideCallHierarchyIncomingCalls(O,q,Q,ie){return this._withAdapter(O,ne,pe=>pe.provideCallsTo(q,Q,ie),void 0,ie)}$provideCallHierarchyOutgoingCalls(O,q,Q,ie){return this._withAdapter(O,ne,pe=>pe.provideCallsFrom(q,Q,ie),void 0,ie)}$releaseCallHierarchy(O,q){this._withAdapter(O,ne,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(O,q,Q){const ie=this._addNewAdapter(new le(this._documents,Q),O);return this._proxy.$registerTypeHierarchyProvider(ie,this._transformDocumentSelector(q,O)),this._createDisposable(ie)}$prepareTypeHierarchy(O,q,Q,ie){return this._withAdapter(O,le,pe=>Promise.resolve(pe.prepareSession(c.URI.revive(q),Q,ie)),void 0,ie)}$provideTypeHierarchySupertypes(O,q,Q,ie){return this._withAdapter(O,le,pe=>pe.provideSupertypes(q,Q,ie),void 0,ie)}$provideTypeHierarchySubtypes(O,q,Q,ie){return this._withAdapter(O,le,pe=>pe.provideSubtypes(q,Q,ie),void 0,ie)}$releaseTypeHierarchy(O,q){this._withAdapter(O,le,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(O,q,Q,ie){const pe=this._nextHandle();return this._adapter.set(pe,new de(new te(this._proxy,this._documents,Q,pe,O),O)),this._proxy.$registerDocumentOnDropEditProvider(pe,this._transformDocumentSelector(q,O),(0,p.isProposedApiEnabled)(O,"dropMetadata")?ie:void 0),this._createDisposable(pe)}$provideDocumentOnDropEdits(O,q,Q,ie,pe,De){return this._withAdapter(O,te,he=>Promise.resolve(he.provideDocumentOnDropEdits(q,c.URI.revive(Q),ie,pe,De)),void 0,void 0)}registerDocumentPasteEditProvider(O,q,Q,ie){const pe=this._nextHandle();return this._adapter.set(pe,new de(new B(this._proxy,this._documents,Q,pe,O),O)),this._proxy.$registerPasteEditProvider(pe,this._transformDocumentSelector(q,O),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,copyMimeTypes:ie.copyMimeTypes,pasteMimeTypes:ie.pasteMimeTypes}),this._createDisposable(pe)}$prepareDocumentPaste(O,q,Q,ie,pe){return this._withAdapter(O,B,De=>De.prepareDocumentPaste(c.URI.revive(q),Q,ie,pe),void 0,pe)}$providePasteEdits(O,q,Q,ie,pe,De){return this._withAdapter(O,B,he=>he.providePasteEdits(q,c.URI.revive(Q),ie,pe,De),void 0,De)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,_.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:oe._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:oe._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?oe._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?oe._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:oe._serializeRegExp(O.beforeText),afterText:O.afterText?oe._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?oe._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(oe._serializeOnEnterRule)}setLanguageConfiguration(O,q,Q){const{wordPattern:ie}=Q;if(ie&&(0,_.regExpLeadsToEndlessLoop)(ie))throw new Error(`Invalid language configuration: wordPattern '${ie}' is not allowed to match the empty string.`);ie?this._documents.setWordDefinitionFor(q,ie):this._documents.setWordDefinitionFor(q,void 0),Q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),Q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const pe=this._nextHandle(),De={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?oe._serializeRegExp(Q.wordPattern):void 0,indentationRules:Q.indentationRules?oe._serializeIndentationRule(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?oe._serializeOnEnterRules(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,q,De),this._createDisposable(pe)}$setWordDefinitions(O){for(const q of O)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=oe,oe._handlePool=0}),define(ye[292],Ce([1,0,6,15,7,41,16,4]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(T,k,m,D){this._documents=k,this._commands=m,this._uriTransformer=D,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=T.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(T){this._languageIds=T}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(T,k){await this._proxy.$changeLanguage(T,k);const m=this._documents.getDocumentData(T);if(!m)throw new Error(`document '${T.toString()}' NOT found`);return m.document}async tokenAtPosition(T,k){const m=T.version,D=A.Position.from(k),S=await this._proxy.$tokensAtPosition(T.uri,D),v={type:l.StandardTokenType.Other,range:T.getWordRangeAtPosition(k)??new l.Range(k.line,k.character,k.line,k.character)};if(!S)return v;const n={range:A.Range.to(S.range),type:A.TokenType.to(S.type)};return!n.range.contains(k)||m!==T.version?v:n}createLanguageStatusItem(T,k,m){const D=this._handlePool++,S=this._proxy,v=this._ids,n=`${T.identifier.value}/${k}`;if(v.has(n))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);v.add(n);const h={selector:m,id:k,name:T.displayName??T.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let d;const w=new P.DisposableStore,E=()=>{d?.dispose(),d=(0,R.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(D,{id:n,name:h.name??T.displayName??T.name,source:T.displayName??T.name,selector:A.DocumentSelector.from(h.selector,this._uriTransformer),label:h.text,detail:h.detail??"",severity:h.severity===l.LanguageStatusSeverity.Error?L.default.Error:h.severity===l.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:h.command&&this._commands.toInternal(h.command,w),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},p={dispose(){w.dispose(),d?.dispose(),S.$removeLanguageStatus(D),v.delete(n)},get id(){return h.id},get name(){return h.name},set name(t){h.name=t,E()},get selector(){return h.selector},set selector(t){h.selector=t,E()},get text(){return h.text},set text(t){h.text=t,E()},get detail(){return h.detail},set detail(t){h.detail=t,E()},get severity(){return h.severity},set severity(t){h.severity=t,E()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(t){h.accessibilityInformation=t,E()},get command(){return h.command},set command(t){h.command=t,E()},get busy(){return h.busy},set busy(t){h.busy=t,E()}};return E(),p}}e.ExtHostLanguages=_}),define(ye[104],Ce([1,0,9,11,2,5,17,6,27,20]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let T=e.ExtHostLocalizationService=class{constructor(m,D,S){this.logService=S,this.bundleCache=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadLocalization),this.currentLanguage=m.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===c.LANGUAGE_DEFAULT}getMessage(m,D){const{message:S,args:v,comment:n}=D;if(this.isDefaultLanguage)return(0,A.format2)(S,v??{});let h=S;n&&n.length>0&&(h+=`/${Array.isArray(n)?n.join(""):n}`);const d=this.bundleCache.get(m)?.contents[h];return d||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,A.format2)(d??S,v??{})}getBundle(m){return this.bundleCache.get(m)?.contents}getBundleUri(m){return this.bundleCache.get(m)?.uri}async initializeLocalizedMessages(m){if(this.isDefaultLanguage||!m.l10n&&!m.isBuiltin||this.bundleCache.has(m.identifier.value))return;let D;const S=await this.getBundleLocation(m);if(!S){this.logService.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const v=await this._proxy.$fetchBundleContents(S),n=JSON.parse(v);D=m.isBuiltin?n.contents?.bundle:n}catch(v){this.logService.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${v.message}`);return}D&&this.bundleCache.set(m.identifier.value,{contents:D,uri:S})}async getBundleLocation(m){if(m.isBuiltin){const D=await this._proxy.$fetchBuiltInBundleUri(m.identifier.value,this.currentLanguage);return l.URI.revive(D)}return m.l10n?l.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=T=je([$e(0,_.IExtHostInitDataService),$e(1,g.IExtHostRpcService),$e(2,R.ILogService)],T),e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(ye[143],Ce([1,0,17,6,27,20,2,73]),function(re,e,c,A,l,L,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let _=e.ExtHostLoggerService=class extends c.AbstractLoggerService{constructor(k,m){super(m.logLevel,m.logsLocation,m.loggers.map(D=>(0,P.revive)(D))),this._proxy=k.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(k,m){m?this.setLogLevel(R.URI.revive(m),k):this.setLogLevel(k)}setVisibility(k,m){super.setVisibility(k,m),this._proxy.$setVisibility(k,m)}doCreateLogger(k,m,D){return new g(this._proxy,k,m,D)}};e.ExtHostLoggerService=_=je([$e(0,L.IExtHostRpcService),$e(1,l.IExtHostInitDataService)],_);class g extends c.AbstractMessageLogger{constructor(k,m,D,S){super(S?.logLevel==="always"),this.proxy=k,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(D),this.proxy.$createLogger(m,S).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,m){const D=[[k,m]];this.isLoggerCreated?this.doLog(D):this.buffer.push(...D)}doLog(k){this.proxy.$log(this.file,k)}flush(){this.proxy.$flush(this.file)}}}),define(ye[105],Ce([1,0,6,5,4,20,21]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,A.createDecorator)("IExtHostManagedSockets");let P=e.ExtHostManagedSockets=class{constructor(k){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=k.getProxy(c.MainContext.MainThreadManagedSockets)}setFactory(k,m){for(const D of this._managedRemoteSockets.values())D.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new _(k,m),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(k){if(!this._factory||this._factory.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const m=++this._remoteSocketIdCounter,D=await this._factory.makeConnection(),S=new l.DisposableStore;return this._managedRemoteSockets.set(m,new g(m,D,S)),S.add((0,l.toDisposable)(()=>this._managedRemoteSockets.delete(m))),S.add(D.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(m),S.dispose()})),S.add(D.onDidClose(v=>{this._proxy.$onDidManagedSocketClose(m,v?.stack??v?.message),S.dispose()})),S.add(D.onDidReceiveMessage(v=>this._proxy.$onDidManagedSocketHaveData(m,R.VSBuffer.wrap(v)))),m}$remoteSocketWrite(k,m){this._managedRemoteSockets.get(k)?.actual.send(m.buffer)}$remoteSocketEnd(k){const m=this._managedRemoteSockets.get(k);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(k){await this._managedRemoteSockets.get(k)?.actual.drain?.()}};e.ExtHostManagedSockets=P=je([$e(0,L.IExtHostRpcService)],P);class _{constructor(k,m){this.socketFactoryId=k,this.makeConnection=m}}class g extends l.Disposable{constructor(k,m,D){super(),this.socketId=k,this.actual=m,this._register(D)}}}),define(ye[293],Ce([1,0,6,17,25]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(P){return P&&P.title}let R=e.ExtHostMessageService=class{constructor(_,g){this._logService=g,this._proxy=_.getProxy(c.MainContext.MainThreadMessageService)}showMessage(_,g,T,k,m){const D={source:{identifier:_.identifier,label:_.displayName||_.name}};let S;typeof k=="string"||L(k)?S=[k,...m]:(D.modal=k?.modal,D.useCustom=k?.useCustom,D.detail=k?.detail,S=m),D.useCustom&&(0,l.checkProposedApiEnabled)(_,"resolvers");const v=[];for(let n=0;n<S.length;n++){const h=S[n];if(typeof h=="string")v.push({title:h,handle:n,isCloseAffordance:!1});else if(typeof h=="object"){const{title:d,isCloseAffordance:w}=h;v.push({title:d,isCloseAffordance:!!w,handle:n})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(g,T,D,v).then(n=>{if(typeof n=="number")return S[n]})}};e.ExtHostMessageService=R=je([$e(1,A.ILogService)],R)}),define(ye[294],Ce([1,0,21,3,4,28,11,12,2,80,6,36,15,7,61,264,139,8]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(E=>E.apiEditor)}constructor(E,p,t,a){this._textDocumentsAndEditors=t,this._textDocuments=a,this._notebookStatusBarItemProviders=new Map,this._documents=new L.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new A.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new A.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new A.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new A.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new g.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=E.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=E.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=E.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const s=r.notebookEditor?.notebookUri,f=r.cell.handle,u=this._documents.get(s)?.getCell(f);if(u)return u.apiCell}if(r&&r.$mid===14){const s=r.uri,f=this._documents.get(s);if(f)return f.apiNotebook}return r}}),d._registerApiCommands(p)}getEditorById(E){const p=this._editors.get(E);if(!p)throw new Error(`unknown text editor: ${E}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(E){for(const[p,t]of this._editors)if(t.apiEditor===E)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(E,p){const t=this._documents.get(E);if(!t&&!p)throw new Error(`NO notebook document for '${E}'`);return t}static _convertNotebookRegistrationData(E,p){if(!p)return;const t=p.filenamePattern.map(a=>m.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(p.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:p.displayName,filenamePattern:t,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,p,t){const a=d._notebookStatusBarItemProviderHandlePool++,r=typeof t.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,t),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,r,p);let s;return r!==void 0&&(s=t.onDidChangeCellStatusBarItems(f=>this._notebookProxy.$emitCellStatusBarEvent(r))),new D.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,r),s?.dispose()})}async createNotebookDocument(E){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return _.URI.revive(p)}async openNotebookDocument(E){const p=this._documents.get(E);if(p)return p.apiNotebook;const t=await this._notebookDocumentsProxy.$tryOpenNotebook(E),a=this._documents.get(_.URI.revive(t));return(0,P.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(E,p){_.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let t;typeof p=="object"?t={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(m.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:t={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(E.uri,E.notebookType,t),r=a&&this._editors.get(a)?.apiEditor;if(r)return r;throw a?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,p,t,a){const r=this._notebookStatusBarItemProviders.get(E),s=_.URI.revive(p),f=this._documents.get(s);if(!f||!r)return;const b=f.getCellFromIndex(t);if(!b)return;const u=await r.provideCellStatusBarItems(b.apiCell,a);if(!u)return;const C=new l.DisposableStore,y=this._statusBarCache.add([C]),i=(Array.isArray(u)?u:[u]).map(I=>m.NotebookStatusBarItem.from(I,this._commandsConverter,C));return{cacheId:y,items:i}}$releaseNotebookCellStatusBarItems(E){this._statusBarCache.delete(E)}registerNotebookSerializer(E,p,t,a,r){if((0,R.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,t),this._notebookProxy.$registerNotebookSerializer(s,{id:E.identifier,location:E.extensionLocation},p,m.NotebookDocumentContentOptions.from(a),d._convertNotebookRegistrationData(E,r)),(0,l.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(E,p,t){const a=this._notebookSerializer.get(E);if(!a)throw new Error("NO serializer found");const r=await a.deserializeNotebook(p.buffer,t);return new S.SerializableObjectWithBuffers(m.NotebookData.from(r))}async $notebookToData(E,p,t){const a=this._notebookSerializer.get(E);if(!a)throw new Error("NO serializer found");const r=await a.serializeNotebook(m.NotebookData.to(p.value),t);return c.VSBuffer.wrap(r)}_createExtHostEditor(E,p,t){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const a=new n.ExtHostNotebookEditor(p,this._notebookEditorsProxy,E,t.visibleRanges.map(m.NotebookRange.to),t.selections.map(m.NotebookRange.to),typeof t.viewColumn=="number"?m.ViewColumn.to(t.viewColumn):void 0);this._editors.set(p,a)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const t of E.value.removedDocuments){const a=_.URI.revive(t),r=this._documents.get(a);r&&(r.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===a.toString()&&this._editors.delete(s.id)}if(E.value.addedDocuments){const t=[];for(const a of E.value.addedDocuments){const r=_.URI.revive(a.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,a);t.push(...a.cells.map(f=>v.ExtHostCell.asModelAddData(s.apiNotebook,f))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(E.value.addedEditors)for(const t of E.value.addedEditors){if(this._editors.has(t.id))return;const a=_.URI.revive(t.documentUri),r=this._documents.get(a);r&&this._createExtHostEditor(r,t.id,t)}const p=[];if(E.value.removedEditors)for(const t of E.value.removedEditors){const a=this._editors.get(t);a&&(this._editors.delete(t),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),p.push(a))}if(E.value.visibleEditors){this._visibleNotebookEditors=E.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const t=new Set;this._visibleNotebookEditors.forEach(a=>t.add(a.id));for(const a of this._editors.values()){const r=t.has(a.id);a._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this._activeNotebookEditor=void 0:E.value.newActiveEditor&&(this._editors.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(E){const p=k.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new k.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>c.VSBuffer.wrap(r))],new k.ApiCommandResult("Notebook Data",r=>m.NotebookData.to(r.value))),a=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new S.SerializableObjectWithBuffers(m.NotebookData.from(r)))],new k.ApiCommandResult("Bytes",r=>r.buffer));E.registerApiCommand(t),E.registerApiCommand(a)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(ye[295],Ce([1,0,19,16,22,3,4,28,2,26,17,80,6,36,15,7,102,254,25,61]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let E=e.ExtHostNotebookKernels=class{constructor(u,C,y,o,i){this._initData=C,this._extHostNotebook=y,this._commands=o,this._logService=i,this._activeExecutions=new P.ResourceMap,this._activeNotebookExecutions=new P.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new k.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=u.getProxy(m.MainContext.MainThreadNotebookKernels);const I=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const U=this._extHostNotebook.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:U}}else if(F&&"notebookEditor"in F){const U=this._extHostNotebook.getIdByEditor(F.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return F})],D.ApiCommandResult.Void);this._commands.registerApiCommand(I)}createNotebookController(u,C,y,o,i,I){for(const we of this._kernelData.values())if(we.controller.id===C&&g.ExtensionIdentifier.equals(u.identifier,we.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const F=this._handlePool++,U=this;this._logService.trace(`NotebookController[${F}], CREATED by ${u.identifier.value}, ${C}`);const $=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${u.identifier}'`);let B=!1;const N=new R.DisposableStore,V=new L.Emitter,x=new L.Emitter,W={id:f(u.identifier,C),notebookType:y,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:o||u.identifier.value,preloads:I?I.map(S.NotebookRendererScript.from):[]};let ee=i??$,se;this._proxy.$addKernel(F,W).catch(we=>{console.log(we),B=!0});let H=0;const J=()=>{if(B)return;const we=++H;Promise.resolve().then(()=>{we===H&&this._proxy.$updateKernel(F,W)})},j=new P.ResourceMap,ae={get id(){return C},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return W.label},set label(we){W.label=we??u.displayName??u.name,J()},get detail(){return W.detail??""},set detail(we){W.detail=we,J()},get description(){return W.description??""},set description(we){W.description=we,J()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(we){W.supportedLanguages=we,J()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(we){W.supportsExecutionOrder=we,J()},get rendererScripts(){return W.preloads?W.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(we){ee=we??$},get interruptHandler(){return se},set interruptHandler(we){se=we,W.supportsInterrupt=!!we,J()},createNotebookCellExecution(we){if(B)throw new Error("notebook controller is DISPOSED");if(!j.has(we.notebook.uri))throw U._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(_e=>_e.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return U._createNotebookCellExecution(we,f(u.identifier,this.id))},createNotebookExecution(we){if((0,d.checkProposedApiEnabled)(u,"notebookExecution"),B)throw new Error("notebook controller is DISPOSED");if(!j.has(we.uri))throw U._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(_e=>_e.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return U._createNotebookExecution(we,f(u.identifier,this.id))},dispose:()=>{B||(this._logService.trace(`NotebookController[${F}], DISPOSED`),B=!0,this._kernelData.delete(F),N.dispose(),V.dispose(),x.dispose(),this._proxy.$removeKernel(F))},updateNotebookAffinity(we,_e){_e===v.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(u,"notebookControllerAffinityHidden"),U._proxy.$updateNotebookPriority(F,we.uri,_e)},onDidReceiveMessage:x.event,postMessage(we,_e){return(0,d.checkProposedApiEnabled)(u,"notebookMessaging"),U._proxy.$postMessage(F,_e&&U._extHostNotebook.getIdByEditor(_e),we)},asWebviewUri(we){return(0,d.checkProposedApiEnabled)(u,"notebookMessaging"),(0,n.asWebviewUri)(we,U._initData.remote)}};return this._kernelData.set(F,{extensionId:u.identifier,controller:ae,onDidReceiveMessage:x,onDidChangeSelection:V,associatedNotebooks:j}),ae}getIdByController(u){for(const[C,y]of this._kernelData)if(y.controller===u)return f(y.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,C){const y=this._kernelDetectionTaskHandlePool++,o=this;this._logService.trace(`NotebookControllerDetectionTask[${y}], CREATED by ${u.identifier.value}`),this._proxy.$addKernelDetectionTask(y,C);const i={dispose:()=>{this._kernelDetectionTask.delete(y),o._proxy.$removeKernelDetectionTask(y)}};return this._kernelDetectionTask.set(y,i),i}registerKernelSourceActionProvider(u,C,y){const o=this._kernelSourceActionProviderHandlePool++,i=typeof y.onDidChangeNotebookKernelSourceActions=="function"?o:void 0,I=this;this._kernelSourceActionProviders.set(o,y),this._logService.trace(`NotebookKernelSourceActionProvider[${o}], CREATED by ${u.identifier.value}`),this._proxy.$addKernelSourceActionProvider(o,o,C);let F;return i!==void 0&&(F=y.onDidChangeNotebookKernelSourceActions(U=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(i))),{dispose:()=>{this._kernelSourceActionProviders.delete(o),I._proxy.$removeKernelSourceActionProvider(o,o),F?.dispose()}}}async $provideKernelSourceActions(u,C){const y=this._kernelSourceActionProviders.get(u);if(y){const o=new R.DisposableStore;return this._kernelSourceActionProviderCache.add([o]),(await y.provideNotebookKernelSourceActions(C)??[]).map(I=>S.NotebookKernelSourceAction.from(I,this._commands.converter,o))}return[]}$acceptNotebookAssociation(u,C,y){const o=this._kernelData.get(u);if(o){const i=this._extHostNotebook.getNotebookDocument(_.URI.revive(C));y?o.associatedNotebooks.set(i.uri,!0):o.associatedNotebooks.delete(i.uri),this._logService.trace(`NotebookController[${u}] ASSOCIATE notebook`,i.uri.toString(),y),o.onDidChangeSelection.fire({selected:y,notebook:i.apiNotebook})}}async $executeCells(u,C,y){const o=this._kernelData.get(u);if(!o)return;const i=this._extHostNotebook.getNotebookDocument(_.URI.revive(C)),I=[];for(const F of y){const U=i.getCell(F);U&&I.push(U.apiCell)}try{this._logService.trace(`NotebookController[${u}] EXECUTE cells`,i.uri.toString(),I.length),await o.controller.executeHandler.call(o.controller,I,i.apiNotebook,o.controller)}catch(F){this._logService.error(`NotebookController[${u}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(u,C,y){const o=this._kernelData.get(u);if(!o)return;const i=this._extHostNotebook.getNotebookDocument(_.URI.revive(C));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,i.apiNotebook);else for(const I of y){const F=i.getCell(I);F&&this._activeExecutions.get(F.uri)?.cancel()}if(o.controller.interruptHandler){const I=this._activeNotebookExecutions.get(i.uri);y.length&&Array.isArray(I)&&I.length&&I.forEach(F=>F.dispose())}}$acceptKernelMessageFromRenderer(u,C,y){const o=this._kernelData.get(u);if(!o)return;const i=this._extHostNotebook.getEditorById(C);o.onDidReceiveMessage.fire(Object.freeze({editor:i.apiEditor,message:y}))}$cellExecutionChanged(u,C,y){const i=this._extHostNotebook.getNotebookDocument(_.URI.revive(u)).getCell(C);if(i){const I=y?S.NotebookCellExecutionState.to(y):v.NotebookCellExecutionState.Idle;I!==void 0&&this._onDidChangeCellExecutionState.fire({cell:i.apiCell,state:I})}}_createNotebookCellExecution(u,C){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const i=new t(C,o,this._proxy);this._activeExecutions.set(o.uri,i);const I=i.onDidChangeState(()=>{i.state===p.Resolved&&(i.dispose(),I.dispose(),this._activeExecutions.delete(o.uri))});return i.asApiObject()}_createNotebookExecution(u,C){const y=this._extHostNotebook.getNotebookDocument(u.uri),o=u.getCells().find(F=>{const U=y.getCellFromApiCell(F);return U&&this._activeExecutions.has(U.uri)});if(o)throw new Error(`duplicate cell execution for ${o.document.uri}`);if(this._activeNotebookExecutions.has(y.uri))throw new Error(`duplicate notebook execution for ${y.uri}`);const i=new r(C,y,this._proxy),I=i.onDidChangeState(()=>{i.state===a.Resolved&&(i.dispose(),I.dispose(),this._activeNotebookExecutions.delete(y.uri))});return this._activeNotebookExecutions.set(y.uri,[i,I]),i.asApiObject()}};e.ExtHostNotebookKernels=E=je([$e(4,T.ILogService)],E);var p;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(p||(p={}));class t extends R.Disposable{get state(){return this._state}constructor(u,C,y){super(),this._cell=C,this._proxy=y,this._handle=t.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new s(10,o=>this.update(o)),this._executionOrder=C.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,u,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(u){await this._collector.addItem(u)}async update(u){const C=Array.isArray(u)?u:[u];return this._proxy.$updateExecution(this._handle,new w.SerializableObjectWithBuffers(C))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(u){let C=this._cell;if(u&&(C=this._cell.notebook.getCellFromApiCell(u)),!C)throw new Error("INVALID cell");return C.handle}validateAndConvertOutputs(u){return u.map(C=>{const y=v.NotebookCellOutput.ensureUniqueMimeTypes(C.items,!0);return y===C.items?S.NotebookCellOutput.from(C):S.NotebookCellOutput.from({items:y,id:C.id,metadata:C.metadata})})}async updateOutputs(u,C,y){const o=this.cellIndexToHandle(C),i=this.validateAndConvertOutputs((0,c.asArray)(u));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,cellHandle:o,append:y,outputs:i})}async updateOutputItems(u,C,y){return u=v.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(u),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:u.map(S.NotebookCellOutputItem.from),outputId:C.id,append:y})}asApiObject(){const u=this;return Object.freeze({get token(){return u._tokenSource.token},get cell(){return u._cell.apiCell},get executionOrder(){return u._executionOrder},set executionOrder(y){u._executionOrder=y,u.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:u._executionOrder}])},start(y){if(u._state===p.Resolved||u._state===p.Started)throw new Error("Cannot call start again");u._state=p.Started,u._onDidChangeState.fire(),u.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:y})},end(y,o){if(u._state===p.Resolved)throw new Error("Cannot call resolve twice");u._state=p.Resolved,u._onDidChangeState.fire(),u._collector.flush(),u._proxy.$completeExecution(u._handle,new w.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:y}))},clearOutput(y){return u.verifyStateForOutput(),u.updateOutputs([],y,!1)},appendOutput(y,o){return u.verifyStateForOutput(),u.updateOutputs(y,o,!0)},replaceOutput(y,o){return u.verifyStateForOutput(),u.updateOutputs(y,o,!1)},appendOutputItems(y,o){return u.verifyStateForOutput(),u.updateOutputItems(y,o,!0)},replaceOutputItems(y,o){return u.verifyStateForOutput(),u.updateOutputItems(y,o,!1)}})}}t.HANDLE=0;var a;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(a||(a={}));class r extends R.Disposable{get state(){return this._state}constructor(u,C,y){super(),this._notebook=C,this._proxy=y,this._handle=r.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,u,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===a.Resolved||this._state===a.Started)throw new Error("Cannot call start again");this._state=a.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===a.Resolved)throw new Error("Cannot call resolve twice");this._state=a.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}r.HANDLE=0;class s{constructor(u,C){this.delay=u,this.callback=C,this.batch=[],this.startedTimer=Date.now()}addItem(u){return this.batch.push(u),this.currentDeferred||(this.currentDeferred=new A.DeferredPromise,this.startedTimer=Date.now(),(0,A.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const u=this.currentDeferred;this.currentDeferred=void 0;const C=this.batch;return this.batch=[],this.callback(C).finally(()=>u.complete())}}function f(b,u){return`${b.value}/${u}`}e.createKernelId=f}),define(ye[296],Ce([1,0,3,6,139]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(P,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,_,g){const T=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(_)?.fire({editor:T.apiEditor,message:g})}createRendererMessaging(P,_){if(!P.contributes?.notebookRenderer?.some(T=>T.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);return{onDidReceiveMessage:(T,k,m)=>this.getOrCreateEmitterFor(_).event(T,k,m),postMessage:(T,k)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,k]=[k,T]);const m=k&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(m?.id,_,T)}}}getOrCreateEmitterFor(P){let _=this._rendererMessageEmitters.get(P);return _||(_=new c.Emitter({onDidRemoveLastListener:()=>{_?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,_),_)}}e.ExtHostNotebookRenderers=L}),define(ye[297],Ce([1,0,4,12,2,25,6]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(g){this.handlers=new Map,this.proxy=g.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,T,k){if((0,L.checkProposedApiEnabled)(g,"profileContentHandlers"),this.handlers.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.handlers.set(T,k),this.proxy.$registerProfileContentHandler(T,k.name,k.description,g.identifier.value),(0,c.toDisposable)(()=>{this.handlers.delete(T),this.proxy.$unregisterProfileContentHandler(T)})}async $saveProfile(g,T,k,m){const D=this.handlers.get(g);if(!D)throw new Error(`Unknown handler with id: ${g}`);return D.saveProfile(T,k,m)}async $readProfile(g,T,k){const m=this.handlers.get(g);if(!m)throw new Error(`Unknown handler with id: ${g}`);return m.readProfile((0,A.isString)(T)?T:l.URI.revive(T),k)}}e.ExtHostProfileContentHandlers=P}),define(ye[298],Ce([1,0,2,6,16,15]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{constructor(_,g){this.uriTransformer=g,this.providers=new Map,this.proxy=_.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(_,g,T){const k=c.URI.revive(g),m=this.providers.get(_);return m?(0,l.asPromise)(()=>m.provideOriginalResource(k,T)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider(_,g,T,k){const m=R.handlePool++;return this.providers.set(m,g),this.proxy.$registerQuickDiffProvider(m,L.DocumentSelector.from(_,this.uriTransformer),T,k),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(m),this.providers.delete(m)}}}}e.ExtHostQuickDiff=R,R.handlePool=0}),define(ye[299],Ce([1,0,22,3,4,6,2,7,8,19,41,55,25,15]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(v,n,h){const d=v.getProxy(L.MainContext.MainThreadQuickOpen);class w{constructor(u,C){this._sessions=new Map,this._instances=0,this._workspace=u,this._commands=C}showQuickPick(u,C,y,o=c.CancellationToken.None){this._onDidSelectItem=void 0;const i=Promise.resolve(C),I=++this._instances,F=d.$show(I,{title:y?.title,placeHolder:y?.placeHolder,matchOnDescription:y?.matchOnDescription,matchOnDetail:y?.matchOnDetail,ignoreFocusLost:y?.ignoreFocusOut,canPickMany:y?.canPickMany},o),U={},$=F.then(()=>U);return Promise.race([$,i]).then(B=>{if(B===U)return;const N=(0,m.isProposedApiEnabled)(u,"quickPickItemTooltip");return i.then(V=>{const x=[];for(let W=0;W<V.length;W++){const ee=V[W];typeof ee=="string"?x.push({label:ee,handle:W}):ee.kind===P.QuickPickItemKind.Separator?x.push({type:"separator",label:ee.label}):(ee.tooltip&&!N&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`),x.push({label:ee.label,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:N?D.MarkdownString.fromStrict(ee.tooltip):void 0,handle:W}))}return y&&typeof y.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{y.onDidSelectItem(V[W])}),d.$setItems(I,x),F.then(W=>{if(typeof W=="number")return V[W];if(Array.isArray(W))return W.map(ee=>V[ee])})})}).then(void 0,B=>{if(!(0,_.isCancellationError)(B))return d.$setError(I,B),Promise.reject(B)})}$onItemSelected(u){this._onDidSelectItem?.(u)}showInput(u,C=c.CancellationToken.None){return this._validateInput=u?.validateInput,d.$input(u,typeof this._validateInput=="function",C).then(void 0,y=>{if(!(0,_.isCancellationError)(y))return Promise.reject(y)})}async $validateInput(u){if(!this._validateInput)return;const C=await this._validateInput(u);if(!C||typeof C=="string")return C;let y;switch(C.severity){case P.InputBoxValidationSeverity.Info:y=T.default.Info;break;case P.InputBoxValidationSeverity.Warning:y=T.default.Warning;break;case P.InputBoxValidationSeverity.Error:y=T.default.Error;break;default:y=C.message?T.default.Error:T.default.Ignore;break}return{content:C.message,severity:y}}async showWorkspaceFolderPick(u,C=c.CancellationToken.None){const y=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!y)return;const o=await this._workspace.getWorkspaceFolders2();if(o)return o.find(i=>i.uri.toString()===y.uri.toString())}createQuickPick(u){const C=new s(u,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(u){const C=new f(u,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}$onDidChangeValue(u,C){this._sessions.get(u)?._fireDidChangeValue(C)}$onDidAccept(u){this._sessions.get(u)?._fireDidAccept()}$onDidChangeActive(u,C){const y=this._sessions.get(u);y instanceof s&&y._fireDidChangeActive(C)}$onDidChangeSelection(u,C){const y=this._sessions.get(u);y instanceof s&&y._fireDidChangeSelection(C)}$onDidTriggerButton(u,C){this._sessions.get(u)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(u,C,y){const o=this._sessions.get(u);o instanceof s&&o._fireDidTriggerItemButton(C,y)}$onDidHide(u){this._sessions.get(u)?._fireDidHide()}}class E{constructor(u,C){this._extensionId=u,this._onDidDispose=C,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(u){this._title=u,this.update({title:u})}get step(){return this._steps}set step(u){this._steps=u,this.update({step:u})}get totalSteps(){return this._totalSteps}set totalSteps(u){this._totalSteps=u,this.update({totalSteps:u})}get enabled(){return this._enabled}set enabled(u){this._enabled=u,this.update({enabled:u})}get busy(){return this._busy}set busy(u){this._busy=u,this.update({busy:u})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(u){this._ignoreFocusOut=u,this.update({ignoreFocusOut:u})}get value(){return this._value}set value(u){this._value=u,this.update({value:u})}get placeholder(){return this._placeholder}set placeholder(u){this._placeholder=u,this.update({placeholder:u})}get buttons(){return this._buttons}set buttons(u){this._buttons=u.slice(),this._handlesToButtons.clear(),u.forEach((C,y)=>{const o=C===P.QuickInputButtons.Back?-1:y;this._handlesToButtons.set(o,C)}),this.update({buttons:u.map((C,y)=>({...r(C),tooltip:C.tooltip,handle:C===P.QuickInputButtons.Back?-1:y}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(u){this._value=u,this._onDidChangeValueEmitter.fire(u)}_fireDidTriggerButton(u){const C=this._handlesToButtons.get(u);C&&this._onDidTriggerButtonEmitter.fire(C)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,l.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(u){if(!this._disposed){for(const C of Object.keys(u)){const y=u[C];this._pendingUpdate[C]=y===void 0?null:y}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function p(b){if(b instanceof P.ThemeIcon)return{id:b.id};const u=a(b),C=t(b);return{dark:typeof u=="string"?R.URI.file(u):u,light:typeof C=="string"?R.URI.file(C):C}}function t(b){return typeof b=="object"&&"light"in b?b.light:b}function a(b){return typeof b=="object"&&"dark"in b?b.dark:b}function r(b){const u=p(b.iconPath);let C,y;return"id"in u?y=k.ThemeIcon.asClassName(u):C=u,{iconPath:C,iconClass:y}}class s extends E{constructor(u,C){super(u.identifier,C),this.extension=u,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this._onDidTriggerItemButtonEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(u){this._items=u.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),u.forEach((o,i)=>{this._handlesToItems.set(i,o),this._itemsToHandles.set(o,i)});const C=(0,m.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),y=[];for(let o=0;o<u.length;o++){const i=u[o];i.kind===P.QuickPickItemKind.Separator?y.push({type:"separator",label:i.label}):(i.tooltip&&!C&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),y.push({handle:o,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,tooltip:C?D.MarkdownString.fromStrict(i.tooltip):void 0,buttons:i.buttons?.map((I,F)=>({...r(I),tooltip:I.tooltip,handle:F}))}))}this.update({items:y})}get canSelectMany(){return this._canSelectMany}set canSelectMany(u){this._canSelectMany=u,this.update({canSelectMany:u})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(u){this._matchOnDescription=u,this.update({matchOnDescription:u})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(u){this._matchOnDetail=u,this.update({matchOnDetail:u})}get sortByLabel(){return this._sortByLabel}set sortByLabel(u){this._sortByLabel=u,this.update({sortByLabel:u})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(u){this._keepScrollPosition=u,this.update({keepScrollPosition:u})}get activeItems(){return this._activeItems}set activeItems(u){this._activeItems=u.filter(C=>this._itemsToHandles.has(C)),this.update({activeItems:this._activeItems.map(C=>this._itemsToHandles.get(C))})}get selectedItems(){return this._selectedItems}set selectedItems(u){this._selectedItems=u.filter(C=>this._itemsToHandles.has(C)),this.update({selectedItems:this._selectedItems.map(C=>this._itemsToHandles.get(C))})}_fireDidChangeActive(u){const C=(0,g.coalesce)(u.map(y=>this._handlesToItems.get(y)));this._activeItems=C,this._onDidChangeActiveEmitter.fire(C)}_fireDidChangeSelection(u){const C=(0,g.coalesce)(u.map(y=>this._handlesToItems.get(y)));this._selectedItems=C,this._onDidChangeSelectionEmitter.fire(C)}_fireDidTriggerItemButton(u,C){const y=this._handlesToItems.get(u);if(!y||!y.buttons||!y.buttons.length)return;const o=y.buttons[C];o&&this._onDidTriggerItemButtonEmitter.fire({button:o,item:y})}}class f extends E{constructor(u,C){super(u.identifier,C),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(u){this._password=u,this.update({password:u})}get prompt(){return this._prompt}set prompt(u){this._prompt=u,this.update({prompt:u})}get valueSelection(){return this._valueSelection}set valueSelection(u){this._valueSelection=u,this.update({valueSelection:u})}get validationMessage(){return this._validationMessage}set validationMessage(u){this._validationMessage=u,u?typeof u=="string"?this.update({validationMessage:u,severity:T.default.Error}):this.update({validationMessage:u.message,severity:u.severity??T.default.Error}):this.update({validationMessage:void 0,severity:T.default.Ignore})}}return new w(n,h)}e.createExtHostQuickOpen=S});var Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)},Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c};define(ye[300],Ce([1,0,2,3,66,4,16,6,19,115,17,26,55,15,25,18]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v){"use strict";var n,h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(o){if(o)return typeof o.iconPath=="string"?c.URI.file(o.iconPath):c.URI.isUri(o.iconPath)||m.ThemeIcon.isThemeIcon(o.iconPath)?o.iconPath:void 0}function E(o,i){if(!o.iconPath&&!i.iconPath)return 0;if(o.iconPath){if(!i.iconPath)return 1}else return-1;const I=typeof o.iconPath=="string"?o.iconPath:c.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id,F=typeof i.iconPath=="string"?i.iconPath:c.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id;return(0,g.comparePaths)(I,F)}function p(o,i){let I=0;if(o.strikeThrough!==i.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==i.faded)return o.faded?1:-1;if(o.tooltip!==i.tooltip)return(o.tooltip||"").localeCompare(i.tooltip||"");if(I=E(o,i),I!==0)return I;if(o.light&&i.light)I=E(o.light,i.light);else{if(o.light)return 1;if(i.light)return-1}if(I!==0)return I;if(o.dark&&i.dark)I=E(o.dark,i.dark);else{if(o.dark)return 1;if(i.dark)return-1}return I}function t(o,i){if(o.command!==i.command)return o.command<i.command?-1:1;if(o.title!==i.title)return o.title<i.title?-1:1;if(o.tooltip!==i.tooltip){if(o.tooltip!==void 0&&i.tooltip!==void 0)return o.tooltip<i.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(i.tooltip!==void 0)return-1}if(o.arguments===i.arguments)return 0;if(o.arguments)if(i.arguments){if(o.arguments.length!==i.arguments.length)return o.arguments.length-i.arguments.length}else return 1;else return-1;for(let I=0;I<o.arguments.length;I++){const F=o.arguments[I],U=i.arguments[I];if(F!==U)return F<U?-1:1}return 0}function a(o,i){let I=(0,g.comparePaths)(o.resourceUri.fsPath,i.resourceUri.fsPath,!0);if(I!==0)return I;if(o.command&&i.command)I=t(o.command,i.command);else{if(o.command)return 1;if(i.command)return-1}if(I!==0)return I;if(o.decorations&&i.decorations)I=p(o.decorations,i.decorations);else{if(o.decorations)return 1;if(i.decorations)return-1}return I}function r(o,i){for(let I=0;I<o.length;I++)if(o[I]!==i[I])return!1;return!0}function s(o,i){return o.command===i.command&&o.title===i.title&&o.tooltip===i.tooltip&&(o.arguments&&i.arguments?r(o.arguments,i.arguments):o.arguments===i.arguments)}function f(o,i){return(0,_.equals)(o,i,s)}class b{get value(){return this._value}set value(i){i=i??"",Oe(this,n,"f").$setInputBoxValue(this._sourceControlHandle,i),this.updateValue(i)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(i){Oe(this,n,"f").$setInputBoxPlaceholder(this._sourceControlHandle,i),this._placeholder=i}get validateInput(){return(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(i){if((0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),i&&typeof i!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=i,Oe(this,n,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!i)}get enabled(){return this._enabled}set enabled(i){i=!!i,this._enabled!==i&&(this._enabled=i,Oe(this,n,"f").$setInputBoxEnablement(this._sourceControlHandle,i))}get visible(){return this._visible}set visible(i){i=!!i,this._visible!==i&&(this._visible=i,Oe(this,n,"f").$setInputBoxVisibility(this._sourceControlHandle,i))}get document(){return(0,S.checkProposedApiEnabled)(this._extension,"scmTextDocument"),Oe(this,h,"f").getDocument(this._documentUri)}constructor(i,I,F,U,$){this._extension=i,this._sourceControlHandle=U,this._documentUri=$,n.set(this,void 0),h.set(this,void 0),this._value="",this._onDidChange=new A.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,h,I,"f"),Je(this,n,F,"f")}showValidationMessage(i,I){(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,n,"f").$showValidationMessage(this._sourceControlHandle,i,I)}$onInputBoxValueChange(i){this.updateValue(i)}updateValue(i){this._value=i,this._onDidChange.fire(i)}}e.ExtHostSCMInputBox=b,n=new WeakMap,h=new WeakMap;class u{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(i){this._label=i,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,i)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(i){this._hideWhenEmpty=i,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(i){this._resourceStates=[...i],this._onDidUpdateResourceStates.fire()}constructor(i,I,F,U,$){this._proxy=i,this._commands=I,this._sourceControlHandle=F,this._id=U,this._label=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new A.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=u._handlePool++}getResourceState(i){return this._resourceStatesMap.get(i)}$executeResourceCommand(i,I){const F=this._resourceStatesCommandsMap.get(i);return F?(0,R.asPromise)(()=>this._commands.executeCommand(F.command,...F.arguments||[],I)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const i=[...this._resourceStates].sort(a),F=(0,_.sortedDiff)(this._resourceSnapshot,i,a).map(B=>{const N=B.toInsert.map(V=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,V);const W=V.resourceUri;let ee;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const X=new L.DisposableStore;ee=this._commands.converter.toInternal(V.command,X),this._resourceStatesDisposablesMap.set(x,X)}else this._resourceStatesCommandsMap.set(x,V.command);const se=w(V.decorations),H=V.decorations&&w(V.decorations.light)||se,J=V.decorations&&w(V.decorations.dark)||se,j=[H,J],ae=V.decorations&&V.decorations.tooltip||"",we=V.decorations&&!!V.decorations.strikeThrough,_e=V.decorations&&!!V.decorations.faded,ve=V.contextValue||"";return{rawResource:[x,W,j,ae,we,_e,ve,ee],handle:x}});return{start:B.start,deleteCount:B.deleteCount,toInsert:N}}),U=F.map(({start:B,deleteCount:N,toInsert:V})=>[B,N,V.map(x=>x.rawResource)]),$=F.reverse();for(const{start:B,deleteCount:N,toInsert:V}of $){const x=V.map(ee=>ee.handle),W=this._handlesSnapshot.splice(B,N,...x);for(const ee of W)this._resourceStatesMap.delete(ee),this._resourceStatesCommandsMap.delete(ee),this._resourceStatesDisposablesMap.get(ee)?.dispose(),this._resourceStatesDisposablesMap.delete(ee)}return this._resourceSnapshot=i,U}dispose(){this._disposed=!0,this._onDidDispose.fire()}}u._handlePool=0;class C{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(i){this._count!==i&&(this._count=i,Oe(this,d,"f").$updateSourceControl(this.handle,{count:i}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(i){this._quickDiffProvider=i;let I;(0,S.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(I=i?.label),Oe(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!i,quickDiffLabel:I})}get commitTemplate(){return this._commitTemplate}set commitTemplate(i){i!==this._commitTemplate&&(this._commitTemplate=i,Oe(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:i}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(i){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=i;const I=this._commands.converter.toInternal(i,this._acceptInputDisposables.value);Oe(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:I})}get actionButton(){return(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(i){(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=i;const I=i!==void 0?{command:this._commands.converter.toInternal(i.command,this._actionButtonDisposables.value),secondaryCommands:i.secondaryCommands?.map(F=>F.map(U=>this._commands.converter.toInternal(U,this._actionButtonDisposables.value))),description:i.description,enabled:i.enabled}:void 0;Oe(this,d,"f").$updateSourceControl(this.handle,{actionButton:I??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(i){if(this._statusBarCommands&&i&&f(this._statusBarCommands,i))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=i;const I=(i||[]).map(F=>this._commands.converter.toInternal(F,this._statusBarDisposables.value));Oe(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:I})}get selected(){return this._selected}constructor(i,I,F,U,$,B,N){this._extension=i,this._commands=U,this._id=$,this._label=B,this._rootUri=N,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new A.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=C._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,d,F,"f");const V=c.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${$}/scm${this.handle}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this._inputBox=new b(i,I,Oe(this,d,"f"),this.handle,V),Oe(this,d,"f").$registerSourceControl(this.handle,$,B,N,V)}createResourceGroup(i,I){const F=new u(Oe(this,d,"f"),this._commands,this.handle,i,I),U=A.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,U),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const i=[],I=[];for(const[F,U]of this.createdResourceGroups){U.dispose();const $=F.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(F),this.eventuallyUpdateResourceStates()});A.Event.once(F.onDidDispose)(()=>{this.updatedResourceGroups.delete(F),$.dispose(),this._groups.delete(F.handle),Oe(this,d,"f").$unregisterGroup(this.handle,F.handle)}),i.push([F.handle,F.id,F.label,F.features]);const B=F._takeResourceStateSnapshot();B.length>0&&I.push([F.handle,B]),this._groups.set(F.handle,F)}Oe(this,d,"f").$registerGroups(this.handle,i,I),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const i=[];this.updatedResourceGroups.forEach(I=>{const F=I._takeResourceStateSnapshot();F.length!==0&&i.push([I.handle,F])}),i.length>0&&Oe(this,d,"f").$spliceResourceStates(this.handle,i),this.updatedResourceGroups.clear()}getResourceGroup(i){return this._groups.get(i)}setSelectionState(i){this._selected=i,this._onDidChangeSelection.fire(i)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(i=>i.dispose()),Oe(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,C._handlePool=0,je([(0,l.debounce)(100)],C.prototype,"eventuallyAddResourceGroups",null),je([(0,l.debounce)(100)],C.prototype,"eventuallyUpdateResourceStates",null);let y=e.ExtHostSCM=class Rn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(i,I,F,U){this._commands=I,this._extHostDocuments=F,this.logService=U,this._sourceControls=new Map,this._sourceControlsByExtension=new k.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new A.Emitter,this._proxy=i.getProxy(P.MainContext.MainThreadSCM),this._telemetry=i.getProxy(P.MainContext.MainThreadTelemetry),I.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===3){const B=this._sourceControls.get($.sourceControlHandle);if(!B)return $;const N=B.getResourceGroup($.groupHandle);return N?N.getResourceState($.handle):$}else if($&&$.$mid===4){const B=this._sourceControls.get($.sourceControlHandle);return B?B.getResourceGroup($.groupHandle):$}else if($&&$.$mid===5){const B=this._sourceControls.get($.handle);return B||$}return $}})}createSourceControl(i,I,F,U){this.logService.trace("ExtHostSCM#createSourceControl",i.identifier.value,I,F,U),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:i.identifier.value});const $=Rn._handlePool++,B=new C(i,this._extHostDocuments,this._proxy,this._commands,I,F,U);this._sourceControls.set($,B);const N=this._sourceControlsByExtension.get(i.identifier)||[];return N.push(B),this._sourceControlsByExtension.set(i.identifier,N),B}getLastInputBox(i){this.logService.trace("ExtHostSCM#getLastInputBox",i.identifier.value);const I=this._sourceControlsByExtension.get(i.identifier),F=I&&I[I.length-1];return F&&F.inputBox}$provideOriginalResource(i,I,F){const U=c.URI.revive(I);this.logService.trace("ExtHostSCM#$provideOriginalResource",i,U.toString());const $=this._sourceControls.get(i);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(U,F)).then(B=>B||null)}$onInputBoxValueChange(i,I){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",i);const F=this._sourceControls.get(i);return F&&F.inputBox.$onInputBoxValueChange(I),Promise.resolve(void 0)}$executeResourceCommand(i,I,F,U){this.logService.trace("ExtHostSCM#$executeResourceCommand",i,I,F);const $=this._sourceControls.get(i);if(!$)return Promise.resolve(void 0);const B=$.getResourceGroup(I);return B?B.$executeResourceCommand(F,U):Promise.resolve(void 0)}$validateInput(i,I,F){this.logService.trace("ExtHostSCM#$validateInput",i);const U=this._sourceControls.get(i);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>U.inputBox.validateInput(I,F)).then($=>{if(!$)return Promise.resolve(void 0);const B=D.MarkdownString.fromStrict($.message);return B?Promise.resolve([B,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(i){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",i),i!==void 0&&this._sourceControls.get(i)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=i,Promise.resolve(void 0)}};y._handlePool=0,e.ExtHostSCM=y=je([$e(3,T.ILogService)],y)}),define(ye[106],Ce([1,0,6,3,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(P){this._onDidChangePassword=new A.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,_){return this._proxy.$getPassword(P,_)}store(P,_,g){return this._proxy.$setPassword(P,_,g)}delete(P,_){return this._proxy.$deletePassword(P,_)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")}),define(ye[301],Ce([1,0,6,7]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class l{constructor(R){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(c.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(R,P,_,g){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const T=this._semanticSimilarityProviders.get(R);if(!T)throw new Error("Semantic similarity provider not found");return await T.provideSimilarityScore(P,_,g)}registerSemanticSimilarityProvider(R,P){const _=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(_,P),this._proxy.$registerSemanticSimilarityProvider(_),new A.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(_),this._semanticSimilarityProviders.delete(_)})}}e.ExtHostSemanticSimilarity=l}),define(ye[302],Ce([1,0,6,15,2]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class L{constructor(P,_){this.uriTransformer=_,this.providers=new Map,this.proxy=P.getProxy(c.MainContext.MainThreadShare)}async $provideShare(P,_,g){return await this.providers.get(P)?.provideShare({selection:A.Range.to(_.range),resourceUri:l.URI.revive(_.resourceUri)},g)??void 0}registerShareProvider(P,_){const g=L.handlePool++;return this.providers.set(g,_),this.proxy.$registerShareProvider(g,A.DocumentSelector.from(P,this.uriTransformer),_.id,_.label,_.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(g),this.providers.delete(g)}}}}e.ExtHostShare=L,L.handlePool=0});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[303],Ce([1,0,7,6,194,4,15,12]),function(re,e,c,A,l,L,R,P){"use strict";var _,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(S,v,n,h,d,w=c.StatusBarAlignment.Left,E){if(_.set(this,void 0),g.set(this,void 0),this._disposed=!1,this._text="",this._staleCommandRegistrations=new L.DisposableStore,Je(this,_,S,"f"),Je(this,g,v,"f"),d&&h){this._entryId=(0,c.asStatusBarItemIdentifier)(h.identifier,d);const p=n.get(this._entryId);p&&(this._visible=!0,this._alignment=p.alignLeft?c.StatusBarAlignment.Left:c.StatusBarAlignment.Right,this._priority=p.priority,this.name=p.name,this.text=p.text,this.command=p.command)}else this._entryId=String(T.ID_GEN++);this._extension=h,this._id=d,this._alignment=w,this._priority=this.validatePriority(E)}validatePriority(S){if((0,P.isNumber)(S))return S===Number.POSITIVE_INFINITY?Number.MAX_VALUE:S===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:S}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(S){this._text=S,this.update()}set name(S){this._name=S,this.update()}set tooltip(S){this._tooltip=S,this.update()}set color(S){this._color=S,this.update()}set backgroundColor(S){S&&!T.ALLOWED_BACKGROUND_COLORS.has(S.id)&&(S=void 0),this._backgroundColor=S,this.update()}set command(S){this._command?.fromApi!==S&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new L.DisposableStore,typeof S=="string"?this._command={fromApi:S,internal:Oe(this,g,"f").toInternal({title:"",command:S},this._latestCommandRegistration)}:S?this._command={fromApi:S,internal:Oe(this,g,"f").toInternal(S,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(S){this._accessibilityInformation=S,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,_,"f").$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let S;this._extension?this._id?S=`${this._extension.identifier.value}.${this._id}`:S=this._extension.identifier.value:S=this._id;let v;this._name?v=this._name:v=(0,l.localize)(0,null,this._extension.displayName||this._extension.name);let n=this._color;this._backgroundColor&&(n=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const h=R.MarkdownString.fromStrict(this._tooltip);Oe(this,_,"f").$setEntry(this._entryId,S,this._extension?.identifier.value,v,this._text,h,this._command?.internal,n,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,_=new WeakMap,g=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(S){this._messages=[],this._item=S.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,l.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(S){const v={message:S};return this._messages.unshift(v),this._update(),new c.Disposable(()=>{const n=this._messages.indexOf(v);n>=0&&(this._messages.splice(n,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(S,v){this._existingItems=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new k(this)}$acceptStaticEntries(S){for(const v of S)this._existingItems.set(v.entryId,v)}createStatusBarEntry(S,v,n,h){return new T(this._proxy,this._commands,this._existingItems,S,v,n,h)}setStatusBarMessage(S,v){const n=this._statusMessage.setMessage(S);let h;return typeof v=="number"?h=setTimeout(()=>n.dispose(),v):typeof v<"u"&&v.then(()=>n.dispose(),()=>n.dispose()),new c.Disposable(()=>{n.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=m}),define(ye[107],Ce([1,0,6,3,5]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(P,_){this._logService=_,this._onDidChangeStorage=new A.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,_){this._proxy.$registerExtensionStorageKeysToSync(P,_)}async initializeExtensionStorage(P,_,g){const T=await this._proxy.$initializeExtensionStorage(P,_);let k;return T&&(k=this.safeParseValue(P,_,T)),k||g}setValue(P,_,g){return this._proxy.$setValue(P,_,g)}$acceptValue(P,_,g){const T=this.safeParseValue(P,_,g);T&&this._onDidChangeStorage.fire({shared:P,key:_,value:T})}safeParseValue(P,_,g){try{return JSON.parse(g)}catch(T){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${_}, global: ${P}): ${T}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(ye[84],Ce([1,0,5,27,17,64,2]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let P=e.ExtensionStoragePaths=class{constructor(g,T,k){this._logService=T,this._extHostFileSystem=k,this._workspace=g.workspace??void 0,this._environment=g.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(g){return R.URI.joinPath(this._environment.workspaceStorageHome,g)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const g=this._workspace.id,T=await this._getWorkspaceStorageURI(g);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this._value)return R.URI.joinPath(this._value,g.identifier.value)}globalValue(g){return R.URI.joinPath(this._environment.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=P=je([$e(0,A.IExtHostInitDataService),$e(1,l.ILogService),$e(2,L.IExtHostConsumerFileSystem)],P)}),define(ye[43],Ce([1,0,3,6,5,2,20,4,7,196,8,236,22,32,237,55,12,16,15,25]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class E{constructor(o,i,I,F){this._proxy=o,this._id=i,this._creationOptions=I,this._name=F,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise($=>this._pidPromiseComplete=$);const U=this;this.value={get name(){return U._name||""},get processId(){return U._pidPromise},get creationOptions(){return U._creationOptions},get exitStatus(){return U._exitStatus},get state(){return U._state},sendText($,B=!0){U._checkDisposed(),U._proxy.$sendText(U._id,$,B)},show($){U._checkDisposed(),U._proxy.$show(U._id,$)},hide(){U._checkDisposed(),U._proxy.$hide(U._id)},dispose(){U._disposed||(U._disposed=!0,U._proxy.$dispose(U._id))},get dimensions(){if(!(U._cols===void 0||U._rows===void 0))return{columns:U._cols,rows:U._rows}}}}async create(o,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,n.withNullAsUndefined)(o.shellPath),shellArgs:(0,n.withNullAsUndefined)(o.shellArgs),cwd:(0,n.withNullAsUndefined)(o.cwd),env:(0,n.withNullAsUndefined)(o.env),icon:(0,n.withNullAsUndefined)(b(o.iconPath)),color:v.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,n.withNullAsUndefined)(o.message),strictEnv:(0,n.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,n.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,n.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,n.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this._serializeParentTerminal(o.location,i?.resolvedExtHostIdentifier),isTransient:(0,n.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,i,I,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:I,color:v.ThemeColor.isThemeColor(F)?F.id:void 0,location:this._serializeParentTerminal(o,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,i){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in o?{viewColumn:d.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,i){this._exitStatus=Object.freeze({code:o,reason:i})}setDimensions(o,i){return o===this._cols&&i===this._rows||o===0||i===0?!1:(this._cols=o,this._rows=i,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=E;class p{get onProcessReady(){return this._onProcessReady.event}constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${i}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,i){this._pty.setDimensions?.({columns:o,rows:i})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose?.((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions?.(i=>{i&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this._pty.onDidChangeName?.(i=>{this._onDidChangeProperty.fire({type:"title",value:i})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}let t=1,a=e.BaseExtHostTerminalService=class extends P.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(o,i){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new c.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=i.getProxy(A.MainContext.MainThreadTerminalService),this._bufferer=new S.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[I,F]of this._terminalProcesses)F.shutdown(!0)}})}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,i){const I=new E(this._proxy,(0,D.generateUuid)(),o,o.name),F=new p(o.pty);return I.createExtensionTerminal(o.location,this._serializeParentTerminal(o,i).resolvedExtHostIdentifier,b(o.iconPath),u(o.color)).then(U=>{const $=this._setupExtHostProcessListeners(U,F);this._terminalProcessDisposables[U]=$}),this._terminals.push(I),I.value}_serializeParentTerminal(o,i){if(i=i||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const I=o.location.parentTerminal;if(I){const F=this._terminals.find(U=>U.value===I);F&&(i.resolvedExtHostIdentifier=F._id)}}else o.location&&typeof o.location!="object"?i.location=o.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(o,i){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const F=new p(i),U=this._setupExtHostProcessListeners(o,F);this._terminalProcessDisposables[o]=U}async $acceptActiveTerminalChanged(o){const i=this._activeTerminal;if(o===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const I=this._getTerminalById(o);I&&(this._activeTerminal=I,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,i){const I=this._getTerminalById(o);I&&this._onDidWriteTerminalData.fire({terminal:I.value,data:i})}async $acceptTerminalDimensions(o,i,I){const F=this._getTerminalById(o);F&&F.setDimensions(i,I)&&this._onDidChangeTerminalDimensions.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptTerminalMaximumDimensions(o,i,I){this._terminalProcesses.get(o)?.resize(i,I)}async $acceptTerminalTitleChange(o,i){const I=this._getTerminalById(o);I&&(I.name=i)}async $acceptTerminalClosed(o,i,I){const F=this._getTerminalObjectIndexById(this._terminals,o);if(F!==null){const U=this._terminals.splice(F,1)[0];U.setExitStatus(i,I),this._onDidCloseTerminal.fire(U.value)}}$acceptTerminalOpened(o,i,I,F){if(i){const B=this._getTerminalObjectIndexById(this._terminals,i);if(B!==null){this._terminals[B]._id=o,this._onDidOpenTerminal.fire(this.terminals[B]),this._terminals[B].isOpen=!0;return}}const U={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:L.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},$=new E(this._proxy,o,U,I);this._terminals.push($),this._onDidOpenTerminal.fire($.value),$.isOpen=!0}async $acceptTerminalProcessId(o,i){this._getTerminalById(o)?._setProcessId(i)}async $startExtensionTerminal(o,i){const I=this._getTerminalById(o);if(!I)return{message:(0,g.localize)(0,null,o)};I.isOpen||await new Promise(U=>{const $=this.onDidOpenTerminal(async B=>{B===I.value&&($.dispose(),U())})});const F=this._terminalProcesses.get(o);F?F.startSendingEvents(i):this._extensionTerminalAwaitingStart[o]={initialDimensions:i}}_setupExtHostProcessListeners(o,i){const I=new P.DisposableStore;I.add(i.onProcessReady(U=>this._proxy.$sendProcessReady(o,U.pid,U.cwd))),I.add(i.onDidChangeProperty(U=>this._proxy.$sendProcessProperty(o,U))),this._bufferer.startBuffering(o,i.onProcessData),I.add(i.onProcessExit(U=>this._onProcessExit(o,U))),this._terminalProcesses.set(o,i);const F=this._extensionTerminalAwaitingStart[o];return F&&i instanceof p&&(i.startSendingEvents(F.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),I}$acceptProcessAckDataEvent(o,i){this._terminalProcesses.get(o)?.acknowledgeDataEvent(i)}$acceptProcessInput(o,i){this._terminalProcesses.get(o)?.input(i)}$acceptTerminalInteraction(o){const i=this._getTerminalById(o);i?.setInteractedWith()&&this._onDidChangeTerminalState.fire(i.value)}$acceptProcessResize(o,i,I){try{this._terminalProcesses.get(o)?.resize(i,I)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(o,i){this._terminalProcesses.get(o)?.shutdown(i)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(i=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(i=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:i}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,i,I){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,I),this._proxy.$registerProfileProvider(i,o.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}registerTerminalQuickFixProvider(o,i,I){if(this._quickFixProviders.has(o))throw new Error(`Terminal quick fix provider "${o}" is already registered`);return this._quickFixProviders.set(o,I),this._proxy.$registerQuickFixProvider(o,i),new _.Disposable(()=>{this._quickFixProviders.delete(o),this._proxy.$unregisterQuickFixProvider(o)})}async $provideTerminalQuickFixes(o,i){const I=new m.CancellationTokenSource().token;if(I.isCancellationRequested)return;const F=this._quickFixProviders.get(o);if(!F)return;const U=await F.provideTerminalQuickFixes(i,I);if(U!==null)return U}async $createContributedProfileTerminal(o,i){const I=new m.CancellationTokenSource().token;let F=await this._profileProviders.get(o)?.provideTerminalProfile(I);if(!I.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,i);return}this.createTerminalFromOptions(F.options,i)}}async $provideLinks(o,i){const I=this._getTerminalById(o);if(!I)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const U=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,U);const $=[],B={terminal:I.value,line:i},N=[];for(const W of this._linkProviders)N.push(h.Promises.withAsyncBody(async ee=>{U.token.onCancellationRequested(()=>ee({provider:W,links:[]}));const se=await W.provideTerminalLinks(B,U.token)||[];U.token.isCancellationRequested||ee({provider:W,links:se})}));const V=await Promise.all(N);if(U.token.isCancellationRequested)return[];const x=new Map;for(const W of V)W&&W.links.length>0&&$.push(...W.links.map(ee=>{const se={id:t++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return x.set(se.id,{provider:W.provider,link:ee}),se}));return this._terminalLinkCache.set(o,x),$}$activateLink(o,i){const I=this._terminalLinkCache.get(o)?.get(i);I&&I.provider.handleTerminalLink(I.link)}_onProcessExit(o,i){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const I=this._terminalProcessDisposables[o];I&&(I.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,i)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,i){const I=this._getTerminalObjectIndexById(o,i);return I!==null?o[I]:null}_getTerminalObjectIndexById(o,i){let I=null;return o.some((F,U)=>F._id===i?(I=U,!0):!1),I}getEnvironmentVariableCollection(o){let i=this._environmentVariableCollections.get(o.identifier.value);return i||(i=new r(o),this._setEnvironmentVariableCollection(o.identifier.value,i)),i.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(o,i){const I=(0,k.serializeEnvironmentVariableCollection)(i.map),F=(0,k.serializeEnvironmentDescriptionMap)(i.descriptionMap);this._proxy.$setEnvironmentVariableCollection(o,i.persistent,I.length===0?void 0:I,F)}$initEnvironmentVariableCollections(o){o.forEach(i=>{const I=i[0],F=new r(void 0,i[1]);this._setEnvironmentVariableCollection(I,F)})}$acceptDefaultProfile(o,i){const I=this._defaultProfile;this._defaultProfile=o,this._defaultAutomationProfile=i,I?.path!==o.path&&this._onDidChangeShell.fire(o.path)}_setEnvironmentVariableCollection(o,i){this._environmentVariableCollections.set(o,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,i)})}};e.BaseExtHostTerminalService=a=je([$e(1,R.IExtHostRpcService)],a);class r{get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o,i){this._extension=o,this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(i)}getScopedEnvironmentVariableCollection(o){this._extension&&o&&(0,w.checkProposedApiEnabled)(this._extension,"envCollectionWorkspace");const i=this.getScopeKey(o);let I=this.scopedCollections.get(i);return I||(I=new s(this,o),this.scopedCollections.set(i,I),I.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),I}replace(o,i,I,F){this._extension&&I&&(0,w.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(o,{value:i,type:_.EnvironmentVariableMutatorType.Replace,options:I??{},scope:F})}append(o,i,I,F){this._extension&&I&&(0,w.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(o,{value:i,type:_.EnvironmentVariableMutatorType.Append,options:I??{},scope:F})}prepend(o,i,I,F){this._extension&&I&&(0,w.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(o,{value:i,type:_.EnvironmentVariableMutatorType.Prepend,options:I??{},scope:F})}_setIfDiffers(o,i){if(i.options&&i.options.applyAtProcessCreation===!1&&!i.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const I=this.getKey(o,i.scope),F=this.map.get(I);if(!F||F.value!==i.value||F.type!==i.type||F.options?.applyAtProcessCreation!==(i.options.applyAtProcessCreation??!0)||F.options?.applyAtShellIntegration!==(i.options.applyAtShellIntegration??!1)||F.scope?.workspaceFolder?.index!==i.scope?.workspaceFolder?.index){const U=this.getKey(o,i.scope),$={variable:o,...i,options:{applyAtProcessCreation:i.options.applyAtProcessCreation??!0,applyAtShellIntegration:i.options.applyAtShellIntegration??!1}};this.map.set(U,$),this._onDidChangeCollection.fire()}}get(o,i){const I=this.getKey(o,i),F=this.map.get(I);return F?C(F):void 0}getKey(o,i){const I=this.getScopeKey(i);return I.length?`${o}:::${I}`:o}getScopeKey(o){return this.getWorkspaceKey(o?.workspaceFolder)??""}getWorkspaceKey(o){return o?o.uri.toString():void 0}getVariableMap(o){const i=new Map;for(const[I,F]of this.map)this.getScopeKey(F.scope)===this.getScopeKey(o)&&i.set(I,C(F));return i}delete(o,i){const I=this.getKey(o,i);this.map.delete(I),this._onDidChangeCollection.fire()}clear(o){if(o?.workspaceFolder){for(const[i,I]of this.map)I.scope?.workspaceFolder?.index===o.workspaceFolder.index&&this.map.delete(i);this.clearDescription(o)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(o,i){const I=this.getScopeKey(i),F=this.descriptionMap.get(I);if(!F||F.description!==o){let U;typeof o=="string"?U=o:U=o?.value.split(`

`)[0];const $={description:U,scope:i};this.descriptionMap.set(I,$),this._onDidChangeCollection.fire()}}getDescription(o){const i=this.getScopeKey(o);return this.descriptionMap.get(i)?.description}clearDescription(o){const i=this.getScopeKey(o);this.descriptionMap.delete(i)}}class s{get persistent(){return this.collection.persistent}set persistent(o){this.collection.persistent=o}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o,i){this.collection=o,this.scope=i,this._onDidChangeCollection=new c.Emitter}getScopedEnvironmentVariableCollection(o){return this.collection.getScopedEnvironmentVariableCollection(o)}replace(o,i,I){this.collection.replace(o,i,I,this.scope)}append(o,i,I){this.collection.append(o,i,I,this.scope)}prepend(o,i,I){this.collection.prepend(o,i,I,this.scope)}get(o){return this.collection.get(o,this.scope)}forEach(o,i){this.collection.getVariableMap(this.scope).forEach((I,F)=>o.call(i,F,I,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(o){this.collection.delete(o,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(o){this.collection.setDescription(o,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let f=e.WorkerExtHostTerminalService=class extends a{constructor(o){super(!1,o)}createTerminal(o,i,I){throw new T.NotSupportedError}createTerminalFromOptions(o,i){throw new T.NotSupportedError}};e.WorkerExtHostTerminalService=f=je([$e(0,R.IExtHostRpcService)],f);function b(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function u(y){return v.ThemeColor.isThemeColor(y)?y:void 0}function C(y){const o={...y};return delete o.scope,o.options=o.options??void 0,delete o.variable,o}});var Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)},Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c};define(ye[304],Ce([1,0,19,16,21,22,3,67,71,4,23,12,32,6,20,140,15,7,60,101,81,25]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p){"use strict";var t,a;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=e.ExtHostTesting=class{constructor(N,V,x){this.editors=x,this.resultsChangedEmitter=new R.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(D.MainContext.MainThreadTesting),this.observer=new F(this.proxy),this.runTracker=new u(this.proxy),V.registerArgumentProcessor({processArgument:W=>{if(W?.$mid!==15)return W;const ee=W,se=ee.tests[ee.tests.length-1].item.extId;return this.controllers.get(d.TestId.root(se))?.collection.tree.get(se)?.actual??(0,v.toItemFromContext)(W)}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const W=await V.executeCommand("_testing.getExplorerSelection"),ee=se=>{const H=this.controllers.get(d.TestId.root(se));if(H)return d.TestId.isRoot(se)?H.controller:H.collection.tree.get(se)?.actual};return{include:W?.include.map(ee).filter(k.isDefined)||[],exclude:W?.exclude.map(ee).filter(k.isDefined)||[]}})}createTestController(N,V,x,W){if(this.controllers.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const ee=new g.DisposableStore,se=ee.add(new v.ExtHostTestItemCollection(V,x,this.editors));se.root.label=x;const H=new Map,J=this.proxy,j={items:se.root.children,get label(){return x},set label(we){x=we,se.root.label=we,J.$updateController(V,{label:x})},get refreshHandler(){return W},set refreshHandler(we){W=we,J.$updateController(V,{canRefresh:!!we})},get id(){return V},createRunProfile:(we,_e,ve,M,X,fe)=>{let Ee=(0,_.hash)(we);for(;H.has(Ee);)Ee++;return new U(this.proxy,H,V,Ee,we,_e,ve,M,X,fe)},createTestItem(we,_e,ve){return new v.TestItemImpl(V,we,_e,ve)},createTestRun:(we,_e,ve=!0)=>this.runTracker.createTestRun(V,se,we,_e,ve),invalidateTestResults:we=>{(0,p.checkProposedApiEnabled)(N,"testInvalidateResults");for(const _e of we instanceof Array?we:[we]){const ve=_e?d.TestId.fromExtHostTestItem(_e,V).toString():V;this.proxy.$markTestRetired(ve)}},set resolveHandler(we){se.resolveHandler=we},get resolveHandler(){return se.resolveHandler},dispose:()=>{ee.dispose()}};J.$registerTestController(V,x,!!W),ee.add((0,g.toDisposable)(()=>J.$unregisterTestController(V)));const ae={controller:j,collection:se,profiles:H};return this.controllers.set(V,ae),ee.add((0,g.toDisposable)(()=>this.controllers.delete(V))),ee.add(se.onDidGenerateDiff(we=>J.$publishDiff(V,we.map(E.TestsDiffOp.serialize)))),j}createTestObserver(){return this.observer.checkout()}async runTests(N,V=L.CancellationToken.None){const x=C(N);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.controllers.get(x.controllerId);if(!W)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(ee=>d.TestId.fromExtHostTestItem(ee,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:$[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:N.exclude?.map(ee=>ee.id)},V)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,V,x){return(0,c.mapFind)(this.runTracker.trackers,ee=>ee.id===N?ee.getCoverage(V):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(N,V,x,W){return(0,c.mapFind)(this.runTracker.trackers,se=>se.id===N?se.getCoverage(V):void 0)?.resolveFileCoverage(x,W)??Promise.resolve([])}$configureRunProfile(N,V){this.controllers.get(N)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(N,V){await this.controllers.get(N)?.controller.refreshHandler?.(V)}$publishTestResults(N){this.results=Object.freeze(N.map(V=>(0,T.deepFreeze)(n.TestResults.to(V))).concat(this.results).sort((V,x)=>x.completedAt-V.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,V){const x=this.controllers.get(d.TestId.fromString(N).controllerId)?.collection;x&&(await x.expand(N,V<0?1/0:V),x.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(E.TestsDiffOp.deserialize))}async $runControllerTests(N,V){return Promise.all(N.map(x=>this.runControllerTestRequest(x,!1,V)))}async $startContinuousRun(N,V){const x=new L.CancellationTokenSource(V),W=await Promise.all(N.map(ee=>this.runControllerTestRequest(ee,!0,x.token)));return!V.isCancellationRequested&&!W.some(ee=>ee.error)&&await new Promise(ee=>V.onCancellationRequested(ee)),x.dispose(!0),W}async runControllerTestRequest(N,V,x){const W=this.controllers.get(N.controllerId);if(!W)return{};const{collection:ee,profiles:se}=W,H=se.get(N.profileId);if(!H)return{};const J=N.testIds.map(_e=>ee.tree.get(_e)).filter(k.isDefined),j=N.excludeExtIds.map(_e=>W.collection.tree.get(_e)).filter(k.isDefined).filter(_e=>J.some(ve=>ve.fullId.compare(_e.fullId)===2));if(!J.length)return{};const ae=new h.TestRunRequest(J.some(_e=>_e.actual instanceof v.TestItemRootImpl)?void 0:J.map(_e=>_e.actual),j.map(_e=>_e.actual),H,V),we=(0,E.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(ae,y.fromInternal(N,W.collection),x);try{return await H.runHandler(ae,x),{}}catch(_e){return{error:String(_e)}}finally{we&&(we.hasRunningTasks&&!x.isCancellationRequested&&await R.Event.toPromise(we.onEnd),we.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};e.ExtHostTesting=r=je([$e(0,S.IExtHostRpcService)],r);const s=1e4;var f;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(f||(f={}));class b extends g.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,V,x){super(),this.dto=N,this.proxy=V,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(x));const W=this._register(new A.RunOnceScheduler(()=>this.forciblyEndTasks(),s));this._register(this.cts.token.onCancellationRequested(()=>W.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const V=this.dto.id,x=this.dto.controllerId,W=(0,m.generateUuid)(),ee=new o(this.proxy,V,W),se=ae=>(we,..._e)=>{if(J){console.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(we)&&(this.ensureTestIsKnown(we),ae(we,..._e))},H=(ae,we)=>{const _e=we instanceof Array?we.map(n.TestMessage.from):[n.TestMessage.from(we)];if(ae.uri&&ae.range){const ve={range:n.Range.from(ae.range),uri:ae.uri};for(const M of _e)M.location=M.location||ve}this.proxy.$appendTestMessagesInRun(V,W,d.TestId.fromExtHostTestItem(ae,x).toString(),_e)};let J=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return ee.coverageProvider},set coverageProvider(ae){ee.coverageProvider=ae},enqueued:se(ae=>{this.proxy.$updateTestStateInRun(V,W,d.TestId.fromExtHostTestItem(ae,x).toString(),1)}),skipped:se(ae=>{this.proxy.$updateTestStateInRun(V,W,d.TestId.fromExtHostTestItem(ae,x).toString(),5)}),started:se(ae=>{this.proxy.$updateTestStateInRun(V,W,d.TestId.fromExtHostTestItem(ae,x).toString(),2)}),errored:se((ae,we,_e)=>{H(ae,we),this.proxy.$updateTestStateInRun(V,W,d.TestId.fromExtHostTestItem(ae,x).toString(),6,_e)}),failed:se((ae,we,_e)=>{H(ae,we),this.proxy.$updateTestStateInRun(V,W,d.TestId.fromExtHostTestItem(ae,x).toString(),4,_e)}),passed:se((ae,we)=>{this.proxy.$updateTestStateInRun(V,W,d.TestId.fromExtHostTestItem(ae,this.dto.controllerId).toString(),3,we)}),appendOutput:(ae,we,_e)=>{J||(_e&&(this.dto.isIncluded(_e)?this.ensureTestIsKnown(_e):_e=void 0),this.proxy.$appendOutputToRun(V,W,l.VSBuffer.fromString(ae),we&&n.location.from(we),_e&&d.TestId.fromExtHostTestItem(_e,x).toString()))},end:()=>{J||(J=!0,this.proxy.$finishedTestRunTask(V,W),this.tasks.delete(W),this.tasks.size||this.markEnded())}};return this.tasks.set(W,{run:j,coverage:ee}),this.proxy.$startedTestRunTask(V,{id:W,name:N,running:!0}),j}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof v.TestItemImpl))throw new w.InvalidTestItemError(N.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const V=[],x=this.dto.colllection.root;for(;;){const W=n.TestItem.from(N);if(V.unshift(W),this.sharedTestIds.has(W.extId)||(this.sharedTestIds.add(W.extId),N===x))break;N=N.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,V)}}class u{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,V,x){return this.getTracker(N,V,x)}cancelRunById(N){for(const V of this.tracked.values())if(V.id===N){V.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,V,x,W,ee){const se=this.tracked.get(x);if(se)return se.createRun(W);const H=y.fromPublic(N,V,x,ee),J=C(x);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!x.continuous,profile:J&&{group:$[J.kind],id:J.profileId},exclude:x.exclude?.map(ae=>d.TestId.fromExtHostTestItem(ae,V.root.id).toString())??[],id:H.id,include:x.include?.map(ae=>d.TestId.fromExtHostTestItem(ae,V.root.id).toString())??[V.root.id],persist:ee});const j=this.getTracker(x,H);return j.onEnd(()=>{this.proxy.$finishedExtensionTestRun(H.id),j.dispose()}),j.createRun(W)}getTracker(N,V,x){const W=new b(V,this.proxy,x);return this.tracked.set(N,W),W.onEnd(()=>this.tracked.delete(N)),W}}e.TestRunCoordinator=u;const C=B=>{if(B.profile){if(!(B.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class y{static fromPublic(N,V,x,W){return new y(N,(0,m.generateUuid)(),x.include?.map(ee=>d.TestId.fromExtHostTestItem(ee,N).toString())??[N],x.exclude?.map(ee=>d.TestId.fromExtHostTestItem(ee,N).toString())??[],W,V)}static fromInternal(N,V){return new y(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,V)}constructor(N,V,x,W,ee,se){this.controllerId=N,this.id=V,this.isPersisted=ee,this.colllection=se,this.includePrefix=x.map(H=>H+"\0"),this.excludePrefix=W.map(H=>H+"\0")}isIncluded(N){const V=d.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(V===x||V.startsWith(x))return!1;for(const x of this.includePrefix)if(V===x||V.startsWith(x))return!0;return!1}}e.TestRunDto=y;class o{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,V,x){this.proxy=N,this.runId=V,this.taskId=x}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(V){throw this.fileCoverage=void 0,V}}async resolveFileCoverage(N,V){const x=await this.fileCoverage;let W=x?.[N];return!this._coverageProvider||!x||!W?[]:(W.detailedCoverage||(W=x[N]=await this._coverageProvider.resolveFileCoverage?.(W,V)??W),W.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class i{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,n.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const V=d.TestId.parentId(N.item.extId);if(V&&this.alreadyRemoved.has(V.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:V,removed:x}=this;return{get added(){return[...N].map(W=>W.revived)},get updated(){return[...V].map(W=>W.revived)},get removed(){return[...x].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class I extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,V){return{...N,revived:n.TestItem.toPlain(N.item),depth:V?V.depth+1:0,children:new Set}}createChangeCollector(){return new i(this.changeEmitter)}}class F{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(V=>V.revived)},dispose:(0,P.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new I;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class U{get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?n.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,V,x,W,ee,se,H,J=!1,j=void 0,ae=!1){this.controllerId=x,this.profileId=W,this._label=ee,this.kind=se,this.runHandler=H,this._isDefault=J,this._tag=j,this._supportsContinuousRun=ae,t.set(this,void 0),a.set(this,void 0),Je(this,t,N,"f"),Je(this,a,V,"f"),V.set(W,this);const we=$[se];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);Oe(this,t,"f").$publishTestRunProfile({profileId:W,controllerId:x,tag:j?n.TestTag.namespace(this.controllerId,j.id):null,label:ee,group:we,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ae})}dispose(){Oe(this,a,"f")?.delete(this.profileId)&&(Je(this,a,void 0,"f"),Oe(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=U,t=new WeakMap,a=new WeakMap;const $={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ye[305],Ce([1,0,19,8,3,6,141,15,7]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class g{constructor(k,m){this._extHostDocumentsAndEditors=m,this._onDidChangeTextEditorSelection=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=k.getProxy(L.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(D=>this._onDidChangeVisibleTextEditors.fire(D)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(D=>this._onDidChangeActiveTextEditor.fire(D))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(k){const m=this._extHostDocumentsAndEditors.allEditors();return k?m:m.map(D=>D.value)}async showTextDocument(k,m,D){let S;typeof m=="number"?S={position:P.ViewColumn.from(m),preserveFocus:D}:typeof m=="object"?S={position:P.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selection:typeof m.selection=="object"?P.Range.from(m.selection):void 0,pinned:typeof m.preview=="boolean"?!m.preview:void 0}:S={preserveFocus:!1};const v=await this._proxy.$tryShowTextDocument(k.uri,S),n=v&&this._extHostDocumentsAndEditors.getEditor(v);if(n)return n.value;throw v?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,m){return new R.TextEditorDecorationType(this._proxy,k,m).value}$acceptEditorPropertiesChanged(k,m){const D=this._extHostDocumentsAndEditors.getEditor(k);if(!D)throw new Error("unknown text editor");if(m.options&&D._acceptOptions(m.options),m.selections){const S=m.selections.selections.map(P.Selection.to);D._acceptSelections(S)}if(m.visibleRanges){const S=c.coalesce(m.visibleRanges.map(P.Range.to));D._acceptVisibleRanges(S)}if(m.options&&this._onDidChangeTextEditorOptions.fire({textEditor:D.value,options:{...m.options,lineNumbers:P.TextEditorLineNumbersStyle.to(m.options.lineNumbers)}}),m.selections){const S=_.TextEditorSelectionChangeKind.fromValue(m.selections.source),v=m.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:D.value,selections:v,kind:S})}if(m.visibleRanges){const S=c.coalesce(m.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:D.value,visibleRanges:S})}}$acceptEditorPositionData(k){for(const m in k){const D=this._extHostDocumentsAndEditors.getEditor(m);if(!D)throw new Error("Unknown text editor");const S=P.ViewColumn.to(k[m]);D.value.viewColumn!==S&&(D._acceptViewColumn(S),this._onDidChangeTextEditorViewColumn.fire({textEditor:D.value,viewColumn:S}))}}getDiffInformation(k){return Promise.resolve(this._proxy.$getDiffInformation(k))}}e.ExtHostEditors=g}),define(ye[306],Ce([1,0,2,5,6,4,7,15,26,12]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class T{constructor(D,S){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=D.getProxy(l.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(v,n)=>{if(v&&v.$mid===12)if(this._providers.get(v.source)&&_.ExtensionIdentifier.equals(n,this._providers.get(v.source)?.extension)){const h=v.uri===void 0?void 0:c.URI.revive(v.uri);return this._itemsBySourceAndUriMap.get(v.source)?.get(k(h))?.get(v.handle)}else return;return v}})}async $getTimeline(D,S,v,n){return this._providers.get(D)?.provider.provideTimeline(c.URI.revive(S),v,n)}registerTimelineProvider(D,S,v,n){const h=new L.DisposableStore,d=this.convertTimelineItem(S.id,n,h).bind(this);let w;S.onDidChange&&(w=S.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:S.id}),this));const E=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...S,scheme:D,onDidChange:void 0,async provideTimeline(p,t,a){t?.resetCache&&(h.clear(),E.get(S.id)?.clear());const r=await S.provideTimeline(p,t,a);if(r==null)return;const s=d(p,t);return{...r,source:S.id,items:r.items.map(s)}},dispose(){for(const p of E.values())p.get(S.id)?.clear();w?.dispose(),h.dispose()}},v)}convertTimelineItem(D,S,v){return(n,h)=>{let d;if(h?.cacheResults){let w=this._itemsBySourceAndUriMap.get(D);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(D,w));const E=k(n);d=w.get(E),d===void 0&&(d=new Map,w.set(E,d))}return w=>{const{iconPath:E,...p}=w,t=`${D}|${w.id??w.timestamp}`;d?.set(t,w);let a,r,s;w.iconPath&&(E instanceof R.ThemeIcon?s={id:E.id,color:E.color}:c.URI.isUri(E)?(a=E,r=E):{light:a,dark:r}=E);let f;return R.MarkdownString.isMarkdownString(p.tooltip)?f=P.MarkdownString.from(p.tooltip):(0,g.isString)(p.tooltip)?f=p.tooltip:R.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=P.MarkdownString.from(p.detail)):(0,g.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=p.detail),{...p,id:p.id??void 0,handle:t,source:D,command:w.command?S.toInternal(w.command,v):void 0,icon:a,iconDark:r,themeIcon:s,tooltip:f,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(D,S){if(this._providers.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this._proxy.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this._providers.set(D.id,{provider:D,extension:S}),(0,L.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(D.id)?.clear();this._providers.delete(D.id),this._proxy.$unregisterTimelineProvider(D.id),D.dispose()})}}e.ExtHostTimeline=T;function k(m){return m?.toString()}}),define(ye[307],Ce([1,0,4,18,2,6]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(_){this._openers=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,g,T,k){if(this._openers.has(g))throw new Error(`Opener with id '${g}' already registered`);const m=k.schemes.find(D=>!R.supportedSchemes.has(D));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(g,T),this._proxy.$registerUriOpener(g,k.schemes,_,k.label),(0,c.toDisposable)(()=>{this._openers.delete(g),this._proxy.$unregisterUriOpener(g)})}async $canOpenUri(_,g,T){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener with id: ${_}`);const m=l.URI.revive(g);return k.canOpenExternalUri(m,T)}async $openUri(_,g,T){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener id: '${_}'`);return k.openExternalUri(l.URI.revive(g.resolvedUri),{sourceUri:l.URI.revive(g.sourceUri)},T)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([A.Schemas.http,A.Schemas.https])}),define(ye[308],Ce([1,0,6,2,4,8,26]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(g){this.handles=new R.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=g.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(g,T){const k=g.identifier;if(this.handles.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const m=P.HandlePool++;return this.handles.add(k),this.handlers.set(m,T),this._proxy.$registerUriHandler(m,k,g.displayName||g.name),(0,l.toDisposable)(()=>{this.handles.delete(k),this.handlers.delete(m),this._proxy.$unregisterUriHandler(m)})}$handleExternalUri(g,T){const k=this.handlers.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(A.URI.revive(T))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(g){return A.URI.revive(await this._proxy.$createAppUri(g))}}e.ExtHostUrls=P,P.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[85],Ce([1,0,3,18,23,2,212,245,102,6]),function(re,e,c,A,l,L,R,P,_,g){"use strict";var T,k,m,D,S,v,n,h,d,w,E,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(i,I,F,U,$,B,N){T.set(this,void 0),k.set(this,void 0),m.set(this,void 0),D.set(this,void 0),S.set(this,void 0),v.set(this,void 0),n.set(this,""),h.set(this,void 0),d.set(this,!1),w.set(this,!1),E.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new c.Emitter),this._onDidDispose=Oe(this,t,"f").event,Je(this,T,i,"f"),Je(this,k,I,"f"),Je(this,h,F,"f"),Je(this,D,U,"f"),Je(this,S,$,"f"),Je(this,v,B,"f"),Je(this,E,r(B),"f"),Je(this,p,s(B),"f"),Je(this,m,N,"f")}dispose(){Je(this,d,!0,"f"),Oe(this,t,"f").fire(),Oe(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(i){return Je(this,w,!0,"f"),(0,_.asWebviewUri)(i,Oe(this,D,"f"))}get cspSource(){const i=Oe(this,v,"f").extensionLocation;if(i.scheme===A.Schemas.https||i.scheme===A.Schemas.http){let I=i.toString();return I.endsWith("/")||(I+="/"),I+" "+_.webviewGenericCspSource}return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,n,"f")}set html(i){this.assertNotDisposed(),Oe(this,n,"f")!==i&&(Je(this,n,i,"f"),Oe(this,p,"f")&&!Oe(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(i)&&(Je(this,w,!0,"f"),Oe(this,m,"f").report("Webview vscode-resource: uris",Oe(this,v,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,k,"f").$setHtml(Oe(this,T,"f"),this.rewriteOldResourceUrlsIfNeeded(i)))}get options(){return this.assertNotDisposed(),Oe(this,h,"f")}set options(i){this.assertNotDisposed(),l.equals(Oe(this,h,"f"),i)||Oe(this,k,"f").$setOptions(Oe(this,T,"f"),u(Oe(this,v,"f"),Oe(this,S,"f"),i)),Je(this,h,i,"f")}async postMessage(i){if(Oe(this,d,"f"))return!1;const I=(0,P.serializeWebviewMessage)(i,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,k,"f").$postMessage(Oe(this,T,"f"),I.message,...I.buffers)}assertNotDisposed(){if(Oe(this,d,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(i){if(!Oe(this,p,"f"))return i;const I=Oe(this,v,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,F=Oe(this,v,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Oe(this,v,"f").extensionLocation.authority:void 0;return i.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,$,B,N,V,x)=>{const W=L.URI.from({scheme:N||"file",path:decodeURIComponent(V)}),ee=(0,_.asWebviewUri)(W,{isRemote:I,authority:F}).toString();return`${$}${ee}${x}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,$,B,N,V,x)=>{const W=L.URI.from({scheme:N||"file",path:decodeURIComponent(V)}),ee=(0,_.asWebviewUri)(W,{isRemote:I,authority:F}).toString();return`${$}${ee}${x}`})}}e.ExtHostWebview=a,T=new WeakMap,k=new WeakMap,m=new WeakMap,D=new WeakMap,S=new WeakMap,v=new WeakMap,n=new WeakMap,h=new WeakMap,d=new WeakMap,w=new WeakMap,E=new WeakMap,p=new WeakMap,t=new WeakMap;function r(o){try{const i=(0,R.normalizeVersion)((0,R.parseVersion)(o.engines.vscode));return!!i&&i.majorBase>=1&&i.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function s(o){try{const i=(0,R.normalizeVersion)((0,R.parseVersion)(o.engines.vscode));return i?i.majorBase<1||i.majorBase===1&&i.minorBase<60:!1}catch{return!1}}class f{constructor(i,I,F,U,$){this.remoteInfo=I,this.workspace=F,this._logService=U,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=i.getProxy(g.MainContext.MainThreadWebviews)}$onMessage(i,I,F){const U=this.getWebview(i);if(U){const{message:$}=(0,P.deserializeWebviewMessage)(I,F.value);U._onMessageEmitter.fire($)}}$onMissingCsp(i,I){this._logService.warn(`${I} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(i,I,F){const U=new a(i,this._webviewProxy,C(I),this.remoteInfo,this.workspace,F,this._deprecationService);return this._webviews.set(i,U),U._onDidDispose(()=>{this._webviews.delete(i)}),U}deleteWebview(i){this._webviews.delete(i)}getWebview(i){return this._webviews.get(i)}}e.ExtHostWebviews=f;function b(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=b;function u(o,i,I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,enableForms:I.enableForms,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots||y(o,i)}}e.serializeWebviewOptions=u;function C(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(i=>L.URI.from(i))}}function y(o,i){return[...(i?.getWorkspaceFolders()||[]).map(I=>I.uri),o.extensionLocation]}}),define(ye[309],Ce([1,0,22,71,4,18,24,2,15,85,80,6,7]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(a,r){this.document=a,this._storagePath=r,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,r){await this.getEdit(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.getEdit(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=p(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const r=this._edits.get(a,0);if(!r)throw new Error("No edit found");return r}}class S{constructor(){this._documents=new Map}get(a,r){return this._documents.get(this.key(a,r))}add(a,r,s){const f=this.key(a,r.uri);if(this._documents.has(f))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const b=new D(r,s);return this._documents.set(f,b),b}delete(a,r){const s=this.key(a,r.uri);this._documents.delete(s)}key(a,r){return`${a}@@@${r}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class n{constructor(){this._providers=new Map}addTextProvider(a,r,s){return this.add(0,a,r,s)}addCustomProvider(a,r,s){return this.add(1,a,r,s)}get(a){return this._providers.get(a)}add(a,r,s,f){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:a,extension:s,provider:f}),new m.Disposable(()=>this._providers.delete(r))}}class h{constructor(a,r,s,f,b){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=f,this._extHostWebviewPanels=b,this._editorProviders=new n,this._documents=new S,this._proxy=a.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,s,f){const b=new l.DisposableStore;return w(s)?(b.add(this._editorProviders.addTextProvider(r,a,s)),this._proxy.$registerTextEditorProvider((0,g.toExtensionData)(a),r,f.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,g.shouldSerializeBuffersForPostMessage)(a))):(b.add(this._editorProviders.addCustomProvider(r,a,s)),d(s)&&b.add(s.onDidChangeCustomDocument(u=>{const C=this.getCustomDocumentEntry(r,u.document.uri);if(E(u)){const y=C.addEdit(u);this._proxy.$onDidEdit(u.document.uri,r,y,u.label)}else this._proxy.$onContentChange(u.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,g.toExtensionData)(a),r,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,g.shouldSerializeBuffersForPostMessage)(a))),m.Disposable.from(b,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,s,f,b){const u=this._editorProviders.get(r);if(!u)throw new Error(`No provider found for '${r}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${r}'`);const C=P.URI.revive(a),y=await u.provider.openCustomDocument(C,{backupId:s,untitledDocumentData:f?.buffer},b);let o;return d(u.provider)&&this._extensionStoragePaths&&(o=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(r,y,o),{editable:d(u.provider)}}async $disposeCustomDocument(a,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const f=P.URI.revive(a),{document:b}=this.getCustomDocumentEntry(r,f);this._documents.delete(r,b),b.dispose()}async $resolveCustomEditor(a,r,s,f,b,u){const C=this._editorProviders.get(s);if(!C)throw new Error(`No provider found for '${s}'`);const y=_.ViewColumn.to(b),o=this._extHostWebview.createNewWebview(r,f.contentOptions,C.extension),i=this._extHostWebviewPanels.createNewWebviewPanel(r,s,f.title,y,f.options,o,f.active),I=P.URI.revive(a);switch(C.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,I);return C.provider.resolveCustomEditor(F,i,u)}case 0:{const F=this._extHostDocuments.getDocument(I);return C.provider.resolveCustomTextEditor(F,i,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,s){this.getCustomDocumentEntry(r,a).disposeEdits(s)}async $onMoveCustomEditor(a,r,s){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const b=this._extHostWebviewPanels.getWebviewPanel(a);if(!b)throw new Error("No webview found");const u=P.URI.revive(r),C=this._extHostDocuments.getDocument(u);await f.provider.moveCustomTextEditor(C,b,c.CancellationToken.None)}async $undo(a,r,s,f){return this.getCustomDocumentEntry(r,a).undo(s,f)}async $redo(a,r,s,f){return this.getCustomDocumentEntry(r,a).redo(s,f)}async $revert(a,r,s){const f=this.getCustomDocumentEntry(r,a);await this.getCustomEditorProvider(r).revertCustomDocument(f.document,s),f.disposeBackup()}async $onSave(a,r,s){const f=this.getCustomDocumentEntry(r,a);await this.getCustomEditorProvider(r).saveCustomDocument(f.document,s),f.disposeBackup()}async $onSaveAs(a,r,s,f){const b=this.getCustomDocumentEntry(r,a);return this.getCustomEditorProvider(r).saveCustomDocumentAs(b.document,P.URI.revive(s),f)}async $backup(a,r,s){const f=this.getCustomDocumentEntry(r,a),u=await this.getCustomEditorProvider(r).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},s);return f.updateBackup(u),u.id}getCustomDocumentEntry(a,r){const s=this._documents.get(a,P.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(a){const s=this._editorProviders.get(a)?.provider;if(!s||!d(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=h;function d(t){return!!t.onDidChangeCustomDocument}function w(t){return typeof t.resolveCustomTextEditor=="function"}function E(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function p(t){const a=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,A.hash)(a)+""}});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[310],Ce([1,0,3,4,2,32,15,85,6,7]),function(re,e,c,A,l,L,R,P,_,g){"use strict";var T,k,m,D,S,v,n,h,d,w,E,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends A.Disposable{constructor(b,u,C,y){super(),T.set(this,void 0),k.set(this,void 0),m.set(this,void 0),D.set(this,void 0),S.set(this,void 0),v.set(this,void 0),n.set(this,void 0),h.set(this,void 0),d.set(this,!0),w.set(this,void 0),E.set(this,!1),p.set(this,this._register(new c.Emitter)),this.onDidDispose=Oe(this,p,"f").event,t.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,T,b,"f"),Je(this,k,u,"f"),Je(this,D,C,"f"),Je(this,m,y.viewType,"f"),Je(this,S,y.panelOptions,"f"),Je(this,h,y.viewColumn,"f"),Je(this,v,y.title,"f"),Je(this,w,y.active,"f")}dispose(){Oe(this,E,"f")||(Je(this,E,!0,"f"),Oe(this,p,"f").fire(),Oe(this,k,"f").$disposeWebview(Oe(this,T,"f")),Oe(this,D,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,D,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,v,"f")}set title(b){this.assertNotDisposed(),Oe(this,v,"f")!==b&&(Je(this,v,b,"f"),Oe(this,k,"f").$setTitle(Oe(this,T,"f"),b))}get iconPath(){return this.assertNotDisposed(),Oe(this,n,"f")}set iconPath(b){this.assertNotDisposed(),Oe(this,n,"f")!==b&&(Je(this,n,b,"f"),Oe(this,k,"f").$setIconPath(Oe(this,T,"f"),l.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return Oe(this,S,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,h,"f")=="number"&&Oe(this,h,"f")<0))return Oe(this,h,"f")}get active(){return this.assertNotDisposed(),Oe(this,w,"f")}get visible(){return this.assertNotDisposed(),Oe(this,d,"f")}_updateViewState(b){Oe(this,E,"f")||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(Je(this,w,b.active,"f"),Je(this,d,b.visible,"f"),Je(this,h,b.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(b,u){this.assertNotDisposed(),Oe(this,k,"f").$reveal(Oe(this,T,"f"),{viewColumn:typeof b>"u"?void 0:R.ViewColumn.from(b),preserveFocus:!!u})}assertNotDisposed(){if(Oe(this,E,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,m=new WeakMap,D=new WeakMap,S=new WeakMap,v=new WeakMap,n=new WeakMap,h=new WeakMap,d=new WeakMap,w=new WeakMap,E=new WeakMap,p=new WeakMap,t=new WeakMap;class r{static newHandle(){return(0,L.generateUuid)()}constructor(b,u,C){this.webviews=u,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=b.getProxy(_.MainContext.MainThreadWebviewPanels)}createWebviewPanel(b,u,C,y,o={}){const i=typeof y=="object"?y.viewColumn:y,I={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof y=="object"&&!!y.preserveFocus},F=(0,P.shouldSerializeBuffersForPostMessage)(b),U=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(b),U,u,{title:C,panelOptions:s(o),webviewOptions:(0,P.serializeWebviewOptions)(b,this.workspace,o),serializeBuffersForPostMessage:F},I);const $=this.webviews.createNewWebview(U,o,b);return this.createNewWebviewPanel(U,u,C,i,o,$,!0)}$onDidChangeWebviewPanelViewStates(b){const u=Object.keys(b);u.sort((C,y)=>{const o=b[C],i=b[y];return o.active?1:i.active?-1:+o.visible-+i.visible});for(const C of u){const y=this.getWebviewPanel(C);if(!y)continue;const o=b[C];y._updateViewState({active:o.active,visible:o.visible,viewColumn:R.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this._webviewPanels.delete(b),this.webviews.deleteWebview(b)}registerWebviewPanelSerializer(b,u,C){if(this._serializers.has(u))throw new Error(`Serializer for '${u}' already registered`);return this._serializers.set(u,{serializer:C,extension:b}),this._proxy.$registerSerializer(u,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(b)}),new g.Disposable(()=>{this._serializers.delete(u),this._proxy.$unregisterSerializer(u)})}async $deserializeWebviewPanel(b,u,C,y){const o=this._serializers.get(u);if(!o)throw new Error(`No serializer found for '${u}'`);const{serializer:i,extension:I}=o,F=this.webviews.createNewWebview(b,C.webviewOptions,I),U=this.createNewWebviewPanel(b,u,C.title,y,C.panelOptions,F,C.active);await i.deserializeWebviewPanel(U,C.state)}createNewWebviewPanel(b,u,C,y,o,i,I){const F=new a(b,this._proxy,i,{viewType:u,title:C,viewColumn:y,panelOptions:o,active:I});return this._webviewPanels.set(b,F),F}getWebviewPanel(b){return this._webviewPanels.get(b)}}e.ExtHostWebviewPanels=r;function s(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[311],Ce([1,0,3,4,85,15,6,7]),function(re,e,c,A,l,L,R,P){"use strict";var _,g,T,k,m,D,S,v,n,h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends A.Disposable{constructor(t,a,r,s,f,b){super(),_.set(this,void 0),g.set(this,void 0),T.set(this,void 0),k.set(this,void 0),m.set(this,!1),D.set(this,void 0),S.set(this,void 0),v.set(this,void 0),n.set(this,void 0),h.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Oe(this,h,"f").event,d.set(this,this._register(new c.Emitter)),this.onDidDispose=Oe(this,d,"f").event,Je(this,T,r,"f"),Je(this,S,s,"f"),Je(this,_,t,"f"),Je(this,g,a,"f"),Je(this,k,f,"f"),Je(this,D,b,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,d,"f").fire(),Oe(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,S,"f")}set title(t){this.assertNotDisposed(),Oe(this,S,"f")!==t&&(Je(this,S,t,"f"),Oe(this,g,"f").$setWebviewViewTitle(Oe(this,_,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,v,"f")}set description(t){this.assertNotDisposed(),Oe(this,v,"f")!==t&&(Je(this,v,t,"f"),Oe(this,g,"f").$setWebviewViewDescription(Oe(this,_,"f"),t))}get visible(){return Oe(this,D,"f")}get webview(){return Oe(this,k,"f")}get viewType(){return Oe(this,T,"f")}_setVisible(t){t===Oe(this,D,"f")||Oe(this,m,"f")||(Je(this,D,t,"f"),Oe(this,h,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,n,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,n,"f")?.value&&t?.tooltip===Oe(this,n,"f")?.tooltip)&&(Je(this,n,L.ViewBadge.from(t),"f"),Oe(this,g,"f").$setWebviewViewBadge(Oe(this,_,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,g,"f").$show(Oe(this,_,"f"),!!t)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,g=new WeakMap,T=new WeakMap,k=new WeakMap,m=new WeakMap,D=new WeakMap,S=new WeakMap,v=new WeakMap,n=new WeakMap,h=new WeakMap,d=new WeakMap;class E{constructor(t,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,a,r,s){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:r,extension:t}),this._proxy.$registerWebviewViewProvider((0,l.toExtensionData)(t),a,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(t,a,r,s,f){const b=this._viewProviders.get(a);if(!b)throw new Error(`No view provider found for '${a}'`);const{provider:u,extension:C}=b,y=this._extHostWebview.createNewWebview(t,{},C),o=new w(t,this._proxy,a,r,y,!0);this._webviewViews.set(t,o),await u.resolveWebviewView(o,{state:s},f)}async $onDidChangeWebviewViewVisibility(t,a){this.getWebviewView(t)._setVisible(a)}async $disposeWebviewView(t){const a=this.getWebviewView(t);this._webviewViews.delete(t),a.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const a=this._webviewViews.get(t);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=E}),define(ye[144],Ce([1,0,3,6,2,18,11,5,20,25]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=e.ExtHostWindow=class Ln{getState(m){const D=this._state;return{get focused(){return D.focused},get active(){return(0,g.checkProposedApiEnabled)(m,"windowActivity"),D.active}}}constructor(m){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ln.InitialState,this._proxy=m.getProxy(A.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:D,isActive:S})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",S)})}$onDidChangeWindowFocus(m){this.onDidChangeWindowProperty("focused",m)}$onDidChangeWindowActive(m){this.onDidChangeWindowProperty("active",m)}onDidChangeWindowProperty(m,D){D!==this._state[m]&&(this._state={...this._state,[m]:D},this._onDidChangeWindowState.fire(this._state))}openUri(m,D){let S;if(typeof m=="string"){S=m;try{m=l.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,R.isFalsyOrWhitespace)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this._proxy.$openUri(m,S,D)}async asExternalUri(m,D){if((0,R.isFalsyOrWhitespace)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const S=await this._proxy.$asExternalUri(m,D);return l.URI.from(S)}};T.InitialState={focused:!0,active:!0},e.ExtHostWindow=T=je([$e(0,_.IExtHostRpcService)],T),e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[312],Ce([1,0,280,27,20]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let R=e.ExtHostConsoleForwarder=class extends c.AbstractExtHostConsoleForwarder{constructor(_,g){super(_,g),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(_,g,T){const k=_==="error"||_==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),g.apply(console,T),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(_,g){const T=process[_],k=T.write;let m="";Object.defineProperty(T,"write",{set:()=>{},get:()=>(D,S,v)=>{if(!this._isMakingConsoleCall){m+=D.toString(S);const n=m.length>L?m.length:m.lastIndexOf(`
`);n!==-1&&(console[g](m.slice(0,n)),m=m.slice(n+1))}k.call(T,D,S,v)}})}};e.ExtHostConsoleForwarder=R=je([$e(0,l.IExtHostRpcService),$e(1,A.IExtHostInitDataService)],R)}),define(ye[313],Ce([1,0,64,18,17,224,31]),function(re,e,c,A,l,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let P=e.ExtHostDiskFileSystemProvider=class{constructor(T,k){T.addFileSystemProvider(A.Schemas.file,new _(k))}};e.ExtHostDiskFileSystemProvider=P=je([$e(0,c.IExtHostConsumerFileSystem),$e(1,l.ILogService)],P);class _{constructor(T){this.logService=T,this.impl=new L.DiskFileSystemProvider(this.logService)}async stat(T){const k=await this.impl.stat(T);return{type:k.type,ctime:k.ctime,mtime:k.mtime,size:k.size,permissions:k.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(T){return this.impl.readdir(T)}createDirectory(T){return this.impl.mkdir(T)}readFile(T){return this.impl.readFile(T)}writeFile(T,k,m){return this.impl.writeFile(T,k,{...m,unlock:!1,atomic:!1})}delete(T,k){return this.impl.delete(T,{...k,useTrash:!1,atomic:!1})}rename(T,k,m){return this.impl.rename(T,k,m)}copy(T,k,m){return this.impl.copy(T,k,m)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(T,k){throw new Error("Method not implemented.")}}}),define(ye[314],Ce([1,0,10,74,32,36,4,6,2,20]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=e.ExtHostDownloadService=class extends R.Disposable{constructor(m,D){super();const S=m.getProxy(P.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async v=>{const n=_.URI.file((0,c.join)((0,A.tmpdir)(),(0,l.generateUuid)()));return await S.$download(v,n),n})}};e.ExtHostDownloadService=T=je([$e(0,g.IExtHostRpcService),$e(1,L.IExtHostCommands)],T)}),define(ye[315],Ce([1,0,143,18,226,32]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class R extends c.ExtHostLoggerService{doCreateLogger(_,g,T){return _.scheme===A.Schemas.file?new l.SpdLogLogger(T?.name||(0,L.generateUuid)(),_.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,g):super.doCreateLogger(_,g,T)}registerLogger(_){super.registerLogger(_),this._proxy.$registerLogger(_)}deregisterLogger(_){super.deregisterLogger(_),this._proxy.$deregisterLogger(_)}}e.ExtHostLoggerService=R}),define(ye[316],Ce([1,0,48,10,2,84,4,18,16,29]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends L.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const a=await super._getWorkspaceStorageURI(t);if(a.scheme!==P.Schemas.file)return a;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${a.fsPath}.`),a;const r=a.fsPath;let s=0;do{let f;s===0?f=r:f=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await k(f);const b=A.join(f,"vscode.lock"),u=await v(this._logService,b,!1);if(u)return this._workspaceStorageLock=u,process.on("exit",()=>{u.dispose()}),l.URI.file(f);s++}while(s<10);return a}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function k(p){try{await g.Promises.stat(p);return}catch{}try{await g.Promises.mkdir(p,{recursive:!0})}catch{}}const m=1e3,D=10*60*1e3;class S extends R.Disposable{constructor(t,a){super(),this.logService=t,this.filename=a,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await n(t,a);(!r||r.pid!==process.pid)&&(t.info(`Lock '${a}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.Promises.utimes(a,new Date,new Date)}catch(s){t.error(s),t.info(`Lock '${a}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{c.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const a={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.filename,JSON.stringify(a),{flag:"w"})}catch(a){this.logService.error(a)}}}async function v(p,t,a){try{const s={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(s),{flag:"wx"})}catch(s){p.error(s)}const r=await n(p,t);return!r||r.pid!==process.pid?a?(p.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),w(p,t)):(p.info(`Lock '${t}': Lock acquired.`),new S(p,t))}async function n(p,t){let a;try{a=await g.Promises.readFile(t)}catch(r){return p.error(r),null}try{return JSON.parse(String(a))}catch(r){return p.error(r),null}}async function h(p,t){let a;try{a=await g.Promises.stat(t)}catch(r){return p.error(r),0}return a.mtime.getTime()}function d(p){try{return process.kill(p,0),!0}catch{return!1}}async function w(p,t){const a=await n(p,t);if(!a)return p.info(`Lock '${t}': Could not read pid of lock holder.`),E(p,t);if(a.willReleaseAt){let u=a.willReleaseAt-Date.now();if(u<5e3){for(u>0?p.info(`Lock '${t}': The lockfile is scheduled to be released in ${u} ms.`):p.info(`Lock '${t}': The lockfile is scheduled to have been released.`);u>0;){if(await(0,_.timeout)(Math.min(100,u)),await h(p,t)===0)return E(p,t);u=a.willReleaseAt-Date.now()}return E(p,t)}}if(!d(a.pid))return p.info(`Lock '${t}': The pid ${a.pid} appears to be gone.`),E(p,t);const r=await h(p,t),s=Date.now()-r;if(s<=D)return p.info(`Lock '${t}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;p.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const f=await h(p,t),b=Date.now()-f;return b<=D?(p.info(`Lock '${t}': The lock does not look stale, elapsed: ${b} ms, giving up.`),null):(p.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),E(p,t))}async function E(p,t){p.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return v(p,t,!0)}}),define(ye[317],Ce([1,0,32,20,43]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=e.ExtHostTerminalService=class extends l.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,_,g){return this.createTerminalFromOptions({name:P,shellPath:_,shellArgs:g})}createTerminalFromOptions(P,_){const g=new l.ExtHostTerminal(this._proxy,(0,c.generateUuid)(),P,P.name);return this._terminals.push(g),g.create(P,this._serializeParentTerminal(P,_)),g.value}};e.ExtHostTerminalService=L=je([$e(0,A.IExtHostRpcService)],L)}),define(ye[318],Ce([1,0,6,20,200,4,27,2,46,24,29,7,9,58,3,131,110,17]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class d extends v.DisposableTunnel{}function w(u){const C=u.trim().split(`
`),y=[];return C.forEach(i=>{const I=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(i);I&&I.length>=3&&y.push({pid:parseInt(I[1],10),socket:parseInt(I[2],10)})}),y.reduce((i,I)=>(i[I.socket]=I,i),{})}e.getSockets=w;function E(...u){const C=[].concat(...u.map(t));return[...new Map(C.filter(y=>y.st==="0A").map(y=>{const o=y.local_address.split(":");return{socket:parseInt(y.inode,10),ip:p(o[0]),port:parseInt(o[1],16)}}).map(y=>[y.ip+":"+y.port,y])).values()]}e.loadListeningPorts=E;function p(u){let C="";if(u.length===8)for(let y=u.length-2;y>=0;y-=2)C+=parseInt(u.substr(y,2),16),y!==0&&(C+=".");else for(let y=0;y<u.length;y+=8){const o=u.substring(y,y+8);let i="";for(let I=8;I>=2;I-=2)i+=o.substring(I-2,I),(I===6||I===2)&&(i=parseInt(i,16).toString(16),C+=`${i}`,i="",y+I!==u.length-6&&(C+=":"))}return C}e.parseIpAddress=p;function t(u){const C=u.trim().split(`
`),y=C.shift().trim().split(/\s+/).filter(i=>i!=="rx_queue"&&i!=="tm->when");return C.map(i=>i.trim().split(/\s+/).reduce((I,F,U)=>(I[y[U]||U]=F,I),{}))}e.loadConnectionTable=t;function a(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/server-main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function r(u){const C=u.trim().split(`
`),y=[];return C.forEach(o=>{const i=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(o);i&&i.length>=4&&y.push({pid:parseInt(i[1],10),ppid:parseInt(i[2]),cmd:i[3]})}),y}e.getRootProcesses=r;async function s(u,C,y){const o=y.reduce((I,F)=>(I[F.pid]=F,I),{}),i=[];return u.forEach(({socket:I,ip:F,port:U})=>{const $=C[I]?C[I].pid:void 0,B=$?o[$]?.cmd:void 0;$&&B&&!a(B)&&i.push({host:F,port:U,detail:B,pid:$})}),i}e.findPorts=s;function f(u,C,y){const o=new Map,i=r(C);for(const I of u){const F=y.get(I.port);if(F){o.set(I.port,F);continue}const U=i.find($=>$.cmd.includes(`${I.port}`));if(U){let $=U,B;do B=i.find(N=>N.ppid===$.pid),B&&($=B);while(B);o.set(I.port,{host:I.ip,port:I.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else o.set(I.port,{host:I.ip,port:I.port,ppid:Number.MAX_VALUE})}return o}e.tryFindRootPorts=f;let b=e.ExtHostTunnelService=class extends L.Disposable{constructor(C,y,o){super(),this.logService=o,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new S.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._initialCandidates=void 0,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=C.getProxy(c.MainContext.MainThreadTunnelService),m.isLinux&&y.remote.isRemote&&y.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async openTunnel(C,y){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${C.identifier.value} called openTunnel API for ${y.remoteAddress.host}:${y.remoteAddress.port}.`);const o=await this._proxy.$openTunnel(y,C.displayName);if(o){const i=new d(o.remoteAddress,o.localAddress,()=>this._proxy.$closeTunnel(o.remoteAddress));return this._register(i),i}}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(C=>C.port).join(", ")}`)}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(C){return Math.max(C*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(C,y){const o=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(o,{selector:C,provider:y}),this._proxy.$registerPortsAttributesProvider(C,o),new k.Disposable(()=>{this._portAttributesProviders.delete(o),this._proxy.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(C,y,o,i,I){const F=[];for(const $ of C){const B=this._portAttributesProviders.get($);if(!B)return[];F.push(...await Promise.all(y.map(async N=>({providedAttributes:await B.provider.providePortAttributes(N,o,i,I),port:N}))))}const U=F.filter($=>!!$.providedAttributes);return U.length>0?U.map($=>({autoForwardAction:$.providedAttributes.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(C){if(C&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=C;let y;this._initialCandidates&&(y=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const o=new n.MovingAverage;let i=0;for(;this._candidateFindingEnabled;){const I=new Date().getTime(),F=(await this.findCandidatePorts()).filter(B=>(0,v.isLocalhost)(B.host)||(0,v.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(B=>B.port).join(", ")}`);const U=new Date().getTime()-I;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),i++>3&&o.update(U),(!y||JSON.stringify(y)!==JSON.stringify(F))&&(y=F,await this._proxy.$onFoundNewCandidates(y));const $=this.calculateDelay(o.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${$} ms.`),await new Promise(B=>setTimeout(()=>B(),$))}}async setTunnelFactory(C){if(C){if(C.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(C.candidatePortSource),C.showCandidatePort&&(this._showCandidatePort=C.showCandidatePort,this._proxy.$setCandidateFilter()),C.tunnelFactory){this._forwardPortProvider=C.tunnelFactory;let y=C.tunnelFeatures?.privacyOptions??[];C.tunnelFeatures?.public&&y.length===0&&(y=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const o=C.tunnelFeatures?{elevation:!!C.tunnelFeatures?.elevation,public:!!C.tunnelFeatures?.public,privacyOptions:y}:void 0;this._proxy.$setTunnelProvider(o)}}else this._forwardPortProvider=void 0;return(0,L.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(C,y){if(this._extensionTunnels.has(C.host)){const o=this._extensionTunnels.get(C.host);o.has(C.port)&&(y&&o.get(C.port).disposeListener.dispose(),await o.get(C.port).tunnel.dispose(),o.delete(C.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(C,y){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this._forwardPortProvider(C,y);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const i=await o;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(C.remoteAddress.host)||this._extensionTunnels.set(C.remoteAddress.host,new Map);const I=this._register(i.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(i.remoteAddress))));return this._extensionTunnels.get(C.remoteAddress.host).set(C.remoteAddress.port,{tunnel:i,disposeListener:I}),D.TunnelDtoConverter.fromApiTunnel(i)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(C){const y=await Promise.all(C.map(i=>this._showCandidatePort(i.host,i.port,i.detail??""))),o=C.filter((i,I)=>y[I]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${C.map(i=>i.port).join(", ")} to ${o.map(i=>i.port).join(", ")}`),o}async findCandidatePorts(){let C="",y="";try{C=await T.Promises.readFile("/proc/net/tcp","utf8"),y=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const o=E(C,y),i=await new Promise(x=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,ee,se)=>{x(ee)})}),I=w(i),F=await T.Promises.readdir("/proc"),U=[];for(const x of F)try{const W=Number(x),ee=g.joinPath(P.URI.file("/proc"),x);if((await T.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(W)){const H=await T.Promises.readlink(g.joinPath(ee,"cwd").fsPath),J=await T.Promises.readFile(g.joinPath(ee,"cmdline").fsPath,"utf8");U.push({pid:W,cwd:H,cmd:J})}}catch{}const $=[],B=o.filter(x=>{const W=I[x.socket];return W||$.push(x),W}),N=s(B,I,U);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const x=await new Promise(W=>{(0,_.exec)("ps -F -A -l | grep root",(ee,se,H)=>{W(se)})});this._foundRootPorts=f($,x,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.map(W=>W.port).join(", ")}`)}return N.then(x=>V?x.concat(V):x)}};e.ExtHostTunnelService=b=je([$e(0,A.IExtHostRpcService),$e(1,R.IExtHostInitDataService),$e(2,h.ILogService)],b)}),define(ye[319],Ce([1,0,16,21,22,8,3,4,120,273,61]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(o,i){try{return JSON.stringify(o,i)}catch{return"null"}}const D="$$ref$$",S={[D]:-1};class v{constructor(i,I){this.jsonString=i,this.referencedBuffers=I}}function n(o,i=null,I=!1){const F=[];return{jsonString:(I?m:JSON.stringify)(o,($,B)=>{if(typeof B>"u")return S;if(typeof B=="object"){if(B instanceof A.VSBuffer){const N=F.push(B)-1;return{[D]:N}}if(i)return i($,B)}return B}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=n;function h(o,i,I){return JSON.parse(o,(F,U)=>{if(U){const $=U[D];if(typeof $=="number")return i[$];if(I&&U.$mid===1)return I.transformIncoming(U)}return U})}e.parseJsonAndRestoreBufferRefs=h;function d(o,i){return JSON.stringify(o,i)}function w(o){return o?(i,I)=>I&&I.$mid===1?o.transformOutgoing(I):I:null}var E;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var p;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(p||(e.ResponsiveState=p={}));const t=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends P.Disposable{constructor(i,I=null,F=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=i,this._logger=I,this._uriTransformer=F,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let U=0,$=T.ProxyIdentifier.count;U<$;U++)this._locals[U]=null,this._proxies[U]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(U=>this._receiveOneMessage(U))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(i=>{this._pendingRPCReplies[i].resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(i){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(i){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(i){this._responsiveState!==i&&(this._responsiveState=i,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(i){return this._uriTransformer?(0,_.transformIncomingURIs)(i,this._uriTransformer):i}getProxy(i){const{nid:I,sid:F}=i;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,F)),this._proxies[I]}_createProxy(i,I){const F={get:(U,$)=>(typeof $=="string"&&!U[$]&&$.charCodeAt(0)===36&&(U[$]=(...B)=>this._remoteCall(i,$,B)),$===r?I:U[$])};return new Proxy(Object.create(null),F)}set(i,I){return this._locals[i.nid]=I,I}assertRegistered(i){for(let I=0,F=i.length;I<F;I++){const U=i[I];if(!this._locals[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}_receiveOneMessage(i){if(this._isDisposed)return;const I=i.byteLength,F=f.read(i,0),U=F.readUInt8(),$=F.readUInt32();switch(U){case 1:case 2:{let{rpcId:B,method:N,args:V}=u.deserializeRequestJSONArgs(F);this._uriTransformer&&(V=(0,_.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,$,B,N,V,U===2);break}case 3:case 4:{let{rpcId:B,method:N,args:V}=u.deserializeRequestMixedArgs(F);this._uriTransformer&&(V=(0,_.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,$,B,N,V,U===4);break}case 5:{this._logger?.logIncoming(I,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(I,$);break}case 7:{this._receiveReply(I,$,void 0);break}case 9:{let B=u.deserializeReplyOKJSON(F);this._uriTransformer&&(B=(0,_.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(I,$,B);break}case 10:{const B=u.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(I,$,B);break}case 8:{const B=u.deserializeReplyOKVSBuffer(F);this._receiveReply(I,$,B);break}case 11:{let B=u.deserializeReplyErrError(F);this._uriTransformer&&(B=(0,_.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(I,$,B);break}case 12:{this._receiveReplyErr(I,$,void 0);break}default:console.error("received unexpected message"),console.error(i)}}_receiveRequest(i,I,F,U,$,B){this._logger?.logIncoming(i,I,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(F)}.${U}(`,$);const N=String(I);let V,x;if(B){const ee=new l.CancellationTokenSource;$.push(ee.token),V=this._invokeHandler(F,U,$),x=()=>ee.cancel()}else V=this._invokeHandler(F,U,$),x=t;this._cancelInvokedHandlers[N]=x;const W=u.serializeAcknowledged(I);this._logger?.logOutgoing(W.byteLength,I,1,"ack"),this._protocol.send(W),V.then(ee=>{delete this._cancelInvokedHandlers[N];const se=u.serializeReplyOK(I,ee,this._uriReplacer);this._logger?.logOutgoing(se.byteLength,I,1,"reply:",ee),this._protocol.send(se)},ee=>{delete this._cancelInvokedHandlers[N];const se=u.serializeReplyErr(I,ee);this._logger?.logOutgoing(se.byteLength,I,1,"replyErr:",ee),this._protocol.send(se)})}_receiveCancel(i,I){this._logger?.logIncoming(i,I,1,"receiveCancel");const F=String(I);this._cancelInvokedHandlers[F]?.()}_receiveReply(i,I,F){this._logger?.logIncoming(i,I,0,"receiveReply:",F);const U=String(I);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const $=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U],$.resolveOk(F)}_receiveReplyErr(i,I,F){this._logger?.logIncoming(i,I,0,"receiveReplyErr:",F);const U=String(I);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const $=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U];let B;F&&(F.$isError?(B=new Error,B.name=F.name,B.message=F.message,B.stack=F.stack):B=F),$.resolveErr(B)}_invokeHandler(i,I,F){try{return Promise.resolve(this._doInvokeHandler(i,I,F))}catch(U){return Promise.reject(U)}}_doInvokeHandler(i,I,F){const U=this._locals[i];if(!U)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(i));const $=U[I];if(typeof $!="function")throw new Error("Unknown method "+I+" on actor "+(0,T.getStringIdentifierForProxy)(i));return $.apply(U,F)}_remoteCall(i,I,F){if(this._isDisposed)return new g.CanceledLazyPromise;let U=null;if(F.length>0&&l.CancellationToken.isCancellationToken(F[F.length-1])&&(U=F.pop()),U&&U.isCancellationRequested)return Promise.reject(L.canceled());const $=u.serializeRequestArguments(F,this._uriReplacer),B=++this._lastMessageId,N=String(B),V=new g.LazyPromise;U&&U.onCancellationRequested(()=>{const W=u.serializeCancel(B);this._logger?.logOutgoing(W.byteLength,B,0,"cancel"),this._protocol.send(u.serializeCancel(B))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(B);const x=u.serializeRequest(B,i,I,$,!!U);return this._logger?.logOutgoing(x.byteLength,B,0,`request: ${(0,T.getStringIdentifierForProxy)(i)}.${I}(`,F),this._protocol.send(x),V}}e.RPCProtocol=s,k=a,s.UNRESPONSIVE_TIME=3*1e3;class f{static alloc(i,I,F){const U=new f(A.VSBuffer.alloc(F+1+4),0);return U.writeUInt8(i),U.writeUInt32(I),U}static read(i,I){return new f(i,I)}get buffer(){return this._buff}constructor(i,I){this._buff=i,this._offset=I}static sizeUInt8(){return 1}writeUInt8(i){this._buff.writeUInt8(i,this._offset),this._offset+=1}readUInt8(){const i=this._buff.readUInt8(this._offset);return this._offset+=1,i}writeUInt32(i){this._buff.writeUInt32BE(i,this._offset),this._offset+=4}readUInt32(){const i=this._buff.readUInt32BE(this._offset);return this._offset+=4,i}static sizeShortString(i){return 1+i.byteLength}writeShortString(i){this._buff.writeUInt8(i.byteLength,this._offset),this._offset+=1,this._buff.set(i,this._offset),this._offset+=i.byteLength}readShortString(){const i=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,F}static sizeLongString(i){return 4+i.byteLength}writeLongString(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readLongString(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,F}writeBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}static sizeVSBuffer(i){return 4+i.byteLength}writeVSBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readVSBuffer(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+i);return this._offset+=i,I}static sizeMixedArray(i){let I=0;I+=1;for(let F=0,U=i.length;F<U;F++){const $=i[F];switch(I+=1,$.type){case 1:I+=this.sizeLongString($.value);break;case 2:I+=this.sizeVSBuffer($.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString($.value);for(let B=0;B<$.buffers.length;++B)I+=this.sizeVSBuffer($.buffers[B]);break;case 4:break}}return I}writeMixedArray(i){this._buff.writeUInt8(i.length,this._offset),this._offset+=1;for(let I=0,F=i.length;I<F;I++){const U=i[I];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let $=0;$<U.buffers.length;++$)this.writeBuffer(U.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const i=this._buff.readUInt8(this._offset);this._offset+=1;const I=new Array(i);for(let F=0;F<i;F++)switch(this.readUInt8()){case 1:I[F]=this.readLongString();break;case 2:I[F]=this.readVSBuffer();break;case 3:{const $=this.readUInt32(),B=this.readLongString(),N=[];for(let V=0;V<$;++V)N.push(this.readVSBuffer());I[F]=new T.SerializableObjectWithBuffers(h(B,N,null));break}case 4:I[F]=void 0;break}return I}}f.sizeUInt32=4;var b;(function(o){o[o.Simple=0]="Simple",o[o.Mixed=1]="Mixed"})(b||(b={}));class u{static _useMixedArgSerialization(i){for(let I=0,F=i.length;I<F;I++)if(i[I]instanceof A.VSBuffer||i[I]instanceof T.SerializableObjectWithBuffers||typeof i[I]>"u")return!0;return!1}static serializeRequestArguments(i,I){if(this._useMixedArgSerialization(i)){const F=[];for(let U=0,$=i.length;U<$;U++){const B=i[U];if(B instanceof A.VSBuffer)F[U]={type:2,value:B};else if(typeof B>"u")F[U]={type:4};else if(B instanceof T.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=n(B.value,I);F[U]={type:3,value:A.VSBuffer.fromString(N),buffers:V}}else F[U]={type:1,value:A.VSBuffer.fromString(d(B,I))}}return{type:1,args:F}}return{type:0,args:d(i,I)}}static serializeRequest(i,I,F,U,$){switch(U.type){case 0:return this._requestJSONArgs(i,I,F,U.args,$);case 1:return this._requestMixedArgs(i,I,F,U.args,$)}}static _requestJSONArgs(i,I,F,U,$){const B=A.VSBuffer.fromString(F),N=A.VSBuffer.fromString(U);let V=0;V+=f.sizeUInt8(),V+=f.sizeShortString(B),V+=f.sizeLongString(N);const x=f.alloc($?2:1,i,V);return x.writeUInt8(I),x.writeShortString(B),x.writeLongString(N),x.buffer}static deserializeRequestJSONArgs(i){const I=i.readUInt8(),F=i.readShortString(),U=i.readLongString();return{rpcId:I,method:F,args:JSON.parse(U)}}static _requestMixedArgs(i,I,F,U,$){const B=A.VSBuffer.fromString(F);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(B),N+=f.sizeMixedArray(U);const V=f.alloc($?4:3,i,N);return V.writeUInt8(I),V.writeShortString(B),V.writeMixedArray(U),V.buffer}static deserializeRequestMixedArgs(i){const I=i.readUInt8(),F=i.readShortString(),U=i.readMixedArray(),$=new Array(U.length);for(let B=0,N=U.length;B<N;B++){const V=U[B];typeof V=="string"?$[B]=JSON.parse(V):$[B]=V}return{rpcId:I,method:F,args:$}}static serializeAcknowledged(i){return f.alloc(5,i,0).buffer}static serializeCancel(i){return f.alloc(6,i,0).buffer}static serializeReplyOK(i,I,F){if(typeof I>"u")return this._serializeReplyOKEmpty(i);if(I instanceof A.VSBuffer)return this._serializeReplyOKVSBuffer(i,I);if(I instanceof T.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:$}=n(I.value,F,!0);return this._serializeReplyOKJSONWithBuffers(i,U,$)}else return this._serializeReplyOKJSON(i,m(I,F))}static _serializeReplyOKEmpty(i){return f.alloc(7,i,0).buffer}static _serializeReplyOKVSBuffer(i,I){let F=0;F+=f.sizeVSBuffer(I);const U=f.alloc(8,i,F);return U.writeVSBuffer(I),U.buffer}static deserializeReplyOKVSBuffer(i){return i.readVSBuffer()}static _serializeReplyOKJSON(i,I){const F=A.VSBuffer.fromString(I);let U=0;U+=f.sizeLongString(F);const $=f.alloc(9,i,U);return $.writeLongString(F),$.buffer}static _serializeReplyOKJSONWithBuffers(i,I,F){const U=A.VSBuffer.fromString(I);let $=0;$+=f.sizeUInt32,$+=f.sizeLongString(U);for(const N of F)$+=f.sizeVSBuffer(N);const B=f.alloc(10,i,$);B.writeUInt32(F.length),B.writeLongString(U);for(const N of F)B.writeBuffer(N);return B.buffer}static deserializeReplyOKJSON(i){const I=i.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(i,I){const F=i.readUInt32(),U=i.readLongString(),$=[];for(let B=0;B<F;++B)$.push(i.readVSBuffer());return new T.SerializableObjectWithBuffers(h(U,$,I))}static serializeReplyErr(i,I){const F=I?m(L.transformErrorForSerialization(I),null):void 0;if(typeof F!="string")return this._serializeReplyErrEmpty(i);const U=A.VSBuffer.fromString(F);let $=0;$+=f.sizeLongString(U);const B=f.alloc(11,i,$);return B.writeLongString(U),B.buffer}static deserializeReplyErrError(i){const I=i.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(i){return f.alloc(12,i,0).buffer}}var C;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",o[o.ReplyErrError=11]="ReplyErrError",o[o.ReplyErrEmpty=12]="ReplyErrEmpty"})(C||(C={}));var y;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",o[o.Undefined=4]="Undefined"})(y||(y={}))}),define(ye[320],Ce([1,0,3,42,47,5]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)("outputService");var R;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.channels=new Map,this._onDidRegisterChannel=new c.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new c.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(g){this.channels.has(g.id)||(this.channels.set(g.id,g),this._onDidRegisterChannel.fire(g.id))}getChannels(){const g=[];return this.channels.forEach(T=>g.push(T)),g}getChannel(g){return this.channels.get(g)}removeChannel(g){this.channels.delete(g),this._onDidRemoveChannel.fire(g)}}A.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(ye[145],Ce([1,0,6,5,20,26,17,320,64,27,50,163,21,12,31,3,4]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends R.AbstractMessageLogger{get disposed(){return this._disposed}constructor(p,t,a,r,s){super(),this.id=p,this.name=t,this.logger=a,this.proxy=r,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(a.getLevel()),this._register(a.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,p)}replace(p){const t=this.offset;this.info(p),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(p,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:t))}hide(){this.proxy.$close(this.id)}log(p,t){this.offset+=m.VSBuffer.fromString(t).byteLength,(0,R.log)(this.logger,p,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class d extends h{appendLine(p){this.append(p)}}let w=e.ExtHostOutputService=class{constructor(p,t,a,r,s,f){this.initData=t,this.extHostFileSystem=a,this.extHostFileSystemInfo=r,this.loggerService=s,this.logService=f,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[t,a]of this.channels)a.visible=t===this.visibleChannelId}createOutputChannel(p,t,a){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,s=(0,D.isString)(t)?t:void 0;if((0,D.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const b=this.initData.environment.extensionLogLevel?.find(([C])=>L.ExtensionIdentifier.equals(a.identifier,C))?.[1];b&&(f=(0,R.parseLogLevel)(b));const u=r?this.doCreateLogOutputChannel(p,f,a):this.doCreateOutputChannel(p,s,a);return u.then(C=>{this.channels.set(C.id,C),C.visible=C.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(p,f??this.logService.getLevel(),u):this.createExtHostOutputChannel(p,u)}async doCreateOutputChannel(p,t,a){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.proxy.$register(p,s,t,a.identifier.value);return new h(b,p,f,this.proxy,a)}async doCreateLogOutputChannel(p,t,a){const r=await this.createExtensionLogDirectory(a),s=p.replace(/[\\/:\*\?"<>\|]/g,""),f=this.extHostFileSystemInfo.extUri.joinPath(r,`${s}.log`),b=`${a.identifier.value}.${s}`,u=this.loggerService.createLogger(f,{id:b,name:p,logLevel:t,extensionId:a.identifier.value});return new d(b,p,u,this.proxy,a)}createExtensionLogDirectory(p){let t=this.extensionLogDirectoryPromise.get(p.identifier.value);if(!t){const a=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,p.identifier.value);this.extensionLogDirectoryPromise.set(p.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(a)}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return t}createExtHostOutputChannel(p,t){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return p},append(s){r(),t.then(f=>f.append(s))},appendLine(s){r(),t.then(f=>f.appendLine(s))},clear(){r(),t.then(s=>s.clear())},replace(s){r(),t.then(f=>f.replace(s))},show(s,f){r(),t.then(b=>b.show(s,f))},hide(){r(),t.then(s=>s.hide())},dispose(){a=!0,t.then(s=>s.dispose())}}}createExtHostLogOutputChannel(p,t,a){const r=new n.DisposableStore,s=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},f=r.add(new v.Emitter);function b(u){t=u,f.fire(u)}return a.then(u=>{r.add(u),u.logLevel!==t&&b(u.logLevel),r.add(u.onDidChangeLogLevel(C=>b(C)))}),{...this.createExtHostOutputChannel(p,a),get logLevel(){return t},onDidChangeLogLevel:f.event,trace(u,...C){s(),a.then(y=>y.trace(u,...C))},debug(u,...C){s(),a.then(y=>y.debug(u,...C))},info(u,...C){s(),a.then(y=>y.info(u,...C))},warn(u,...C){s(),a.then(y=>y.warn(u,...C))},error(u,...C){s(),a.then(y=>y.error(u,...C))},dispose(){r.dispose()}}}};e.ExtHostOutputService=w=je([$e(0,l.IExtHostRpcService),$e(1,g.IExtHostInitDataService),$e(2,_.IExtHostConsumerFileSystem),$e(3,T.IExtHostFileSystemInfo),$e(4,R.ILoggerService),$e(5,R.ILogService)],w),e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")});var Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)},Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c};define(ye[321],Ce([1,0,5,16]),function(re,e,c,A){"use strict";var l,L,R,P,_,g,T,k,m,D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new(S=class{constructor(){l.set(this,5),L.set(this,2e3),R.set(this,[]),P.set(this,3),_.set(this,[]),g.set(this,100),T.set(this,2),k.set(this,500),m.set(this,1500),D.set(this,void 0)}get latency(){return Oe(this,D,"f")}async measure(v){let n=1/0;for(let d=0;d<Oe(this,l,"f");d++){const w=await v.getRoundTripTime();if(w===void 0)return;n=Math.min(n,w/2),await(0,A.timeout)(Oe(this,L,"f"))}Oe(this,_,"f").push(n),Oe(this,_,"f").length>Oe(this,g,"f")&&Oe(this,_,"f").shift();let h;return Oe(this,R,"f").length<Oe(this,P,"f")?Oe(this,R,"f").push(n):h=Oe(this,R,"f").reduce((d,w)=>d+w,0)/Oe(this,R,"f").length,Je(this,D,{initial:h,current:n,average:Oe(this,_,"f").reduce((d,w)=>d+w,0)/Oe(this,_,"f").length,high:(()=>typeof h>"u"?!1:n>Oe(this,m,"f")||n>Oe(this,k,"f")&&n>h*Oe(this,T,"f"))()},"f"),Oe(this,D,"f")}},l=new WeakMap,L=new WeakMap,R=new WeakMap,P=new WeakMap,_=new WeakMap,g=new WeakMap,T=new WeakMap,k=new WeakMap,m=new WeakMap,D=new WeakMap,S)}),define(ye[322],Ce([1,0,30,18,10,9,24,2,5,240,49,259,321]),function(re,e,c,A,l,L,R,P,_,g,T,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let D=e.AbstractPathService=class Fn{constructor(v,n,h,d){this.localUserHome=v,this.remoteAgentService=n,this.environmentService=h,this.contextService=d,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome??v})()}hasValidBasename(v,n,h){return typeof n=="string"||typeof n>"u"?this.resolveOS.then(d=>this.doHasValidBasename(v,d,n)):this.doHasValidBasename(v,n,h)}doHasValidBasename(v,n,h){return v.scheme===A.Schemas.file||v.scheme===A.Schemas.vscodeRemote?(0,c.isValidBasename)(h??(0,R.basename)(v),n===1):!0}get defaultUriScheme(){return Fn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(v,n){if(v.remoteAuthority)return A.Schemas.vscodeRemote;const h=(0,g.getVirtualWorkspaceScheme)(n.getWorkspace());if(h)return h;const d=n.getWorkspace().folders[0];if(d)return d.uri.scheme;const w=n.getWorkspace().configuration;return w?w.scheme:A.Schemas.file}userHome(v){return v?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(v=>v===1?l.win32:l.posix)}async fileURI(v){let n="";if(await this.resolveOS===1&&(v=v.replace(/\\/g,"/")),v[0]==="/"&&v[1]==="/"){const d=v.indexOf("/",2);d===-1?(n=v.substring(2),v="/"):(n=v.substring(2,d),v=v.substring(d)||"/")}return P.URI.from({scheme:A.Schemas.file,authority:n,path:v,query:"",fragment:""})}};e.AbstractPathService=D=je([$e(1,m.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,T.IWorkspaceContextService)],D)}),define(ye[86],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(R,P){this.line=R,this.character=P}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,P){return new c(0,0)}with(R){return new c(0,0)}}e.Position=c;class A{constructor(R,P,_,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(R,P),this.end=new c(_,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new A(0,0,0,0)}with(R){return new A(0,0,0,0)}}e.Range=A;var l;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(l||(e.TextSearchCompleteMessageType=l={}))}),define(ye[34],Ce([1,0,19,33,23,30,11,5,10,8,86,16]),function(re,e,c,A,l,L,R,P,_,g,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",D=" characters skipped \u27EB",S=(m.length+D.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var v;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(v||(e.SearchProviderType=v={}));var n;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(n||(e.QueryType=n={}));function h(J){return!!J.preview}e.resultIsMatch=h;function d(J){return!!J.resource}e.isFileMatch=d;function w(J){return!!J.message}e.isProgressMessage=w;var E;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class p{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=p;class t{constructor(j,ae,we,_e){this.ranges=ae,this.webviewIndex=_e;const ve=Array.isArray(ae)?ae:[ae];if(we&&we.matchLines===1&&a(ve)){j=(0,R.getNLines)(j,we.matchLines);let M="",X=0,fe=0;const Ee=Math.floor(we.charsPerLine/5),Z=[];for(const ne of ve){const le=Math.max(ne.startColumn-Ee,0),te=ne.startColumn+we.charsPerLine;if(le>fe+Ee+S){const de=m+(le-fe)+D;M+=de+j.slice(le,te),X+=le-(fe+de.length)}else M+=j.slice(fe,te);Z.push(new s(0,ne.startColumn-X,ne.endColumn-X)),fe=te}this.preview={text:M,matches:Array.isArray(this.ranges)?Z:Z[0]}}else{const M=Array.isArray(ae)?ae[0].startLineNumber:ae.startLineNumber;this.preview={text:j,matches:(0,c.mapArrayOrNot)(ae,X=>new r(X.startLineNumber-M,X.startColumn,X.endLineNumber-M,X.endColumn))}}}}e.TextSearchMatch=t;function a(J){const j=J[0].startLineNumber;for(const ae of J)if(ae.startLineNumber!==j||ae.endLineNumber!==j)return!1;return!0}class r{constructor(j,ae,we,_e){this.startLineNumber=j,this.startColumn=ae,this.endLineNumber=we,this.endColumn=_e}}e.SearchRange=r;class s extends r{constructor(j,ae,we){super(j,ae,j,we)}}e.OneLineRange=s;var f;(function(J){J.List="list",J.Tree="tree"})(f||(e.ViewMode=f={}));var b;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function u(J,j=!0){const ae=J&&J.files&&J.files.exclude,we=j&&J&&J.search&&J.search.exclude;if(!ae&&!we)return;if(!ae||!we)return ae||we;let _e=Object.create(null);return _e=l.mixin(_e,l.deepClone(ae)),_e=l.mixin(_e,l.deepClone(we),!0),_e}e.getExcludes=u;function C(J,j){return J.excludePattern&&A.match(J.excludePattern,j)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&A.match(J.includePattern,j)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ae=>{const we=ae.folder.fsPath;if(L.isEqualOrParent(j,we)){const _e=_.relative(we,j);return!ae.includePattern||!!A.match(ae.includePattern,_e)}else return!1}):!1:!0}e.pathIncludedInQuery=C;var y;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(y||(e.SearchErrorCode=y={}));class o extends Error{constructor(j,ae){super(j),this.code=ae}}e.SearchError=o;function i(J){const j=J.message;if((0,g.isCancellationError)(J))return new o(j,y.canceled);try{const ae=JSON.parse(j);return new o(ae.message,ae.code)}catch{return new o(j,y.other)}}e.deserializeSearchError=i;function I(J){const j={message:J.message,code:J.code};return new Error(JSON.stringify(j))}e.serializeSearchError=I;function F(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=F;function U(J){return J.type==="success"}e.isSerializedSearchSuccess=U;function $(J){return!!J.path}e.isSerializedFileMatch=$;function B(J,j){const ae=J.searchPath?J.searchPath:J.relativePath;return(0,R.fuzzyContains)(ae,j)}e.isFilePatternMatch=B;class N{constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function V(J,j){const ae={...J||{},...j||{}};return Object.keys(ae).filter(we=>{const _e=ae[we];return typeof _e=="boolean"&&_e})}e.resolvePatternsForProvider=V;class x{constructor(j,ae){this._parsedIncludeExpression=null,this._excludeExpression={...j.excludePattern||{},...ae.excludePattern||{}},this._parsedExcludeExpression=A.parse(this._excludeExpression);let we=j.includePattern;ae.includePattern&&(we?we={...we,...ae.includePattern}:we=ae.includePattern),we&&(this._parsedIncludeExpression=A.parse(we))}matchesExcludesSync(j,ae,we){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,ae,we))}includedInQuerySync(j,ae,we){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,ae,we)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,ae,we))}includedInQuery(j,ae,we){const _e=this._parsedExcludeExpression(j,ae,we),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(j,ae,we):!0;return(0,k.isThenable)(_e)?_e.then(M=>M?!1:ve()):ve()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=x;function W(J){for(const j in J)if(typeof J[j]!="boolean")return!0;return!1}function ee(J){if(!J)return;let j;return ae=>(j||(j=(J()||Promise.resolve([])).then(we=>we?H(we):{})),j.then(we=>!!we[ae]))}e.hasSiblingPromiseFn=ee;function se(J){if(!J)return;let j;return ae=>{if(!j){const we=J();j=we?H(we):{}}return!!j[ae]}}e.hasSiblingFn=se;function H(J){const j={};for(const ae of J)j[ae]=!0;return j}}),define(ye[37],Ce([1,0,19,16,22,3,4,72,18,110,24,11,12,2,198,5,17,227,49,50,27,20,15,7,59,34,6]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t,a,r,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function b(U,$,B){return new T.ExtUri(N=>o(N,B)).isEqual(U,$)}function u(U,$,B){return b(U.uri,$.uri,B)?0:(0,k.compare)(U.uri.toString(),$.uri.toString())}function C(U,$,B){return U.index!==$.index?U.index<$.index?-1:1:b(U.uri,$.uri,B)?(0,k.compare)(U.name,$.name):(0,k.compare)(U.uri.toString(),$.uri.toString())}function y(U,$,B,N){const V=U.slice(0).sort((W,ee)=>B(W,ee,N)),x=$.slice(0).sort((W,ee)=>B(W,ee,N));return(0,c.delta)(V,x,(W,ee)=>B(W,ee,N))}function o(U,$){const B=$.getCapabilities(U.scheme);return!(B&&B&1024)}class i extends d.Workspace{static toExtHostWorkspace($,B,N,V){if(!$)return{workspace:null,added:[],removed:[]};const{id:x,name:W,folders:ee,configuration:se,transient:H,isUntitled:J}=$,j=[],ae=B;B?ee.forEach((M,X)=>{const fe=D.URI.revive(M.uri),Ee=i._findFolder(N||B,fe,V);Ee?(Ee.name=M.name,Ee.index=M.index,j.push(Ee)):j.push({uri:fe,name:M.name,index:X})}):j.push(...ee.map(({uri:M,name:X,index:fe})=>({uri:D.URI.revive(M),name:X,index:fe}))),j.sort((M,X)=>M.index<X.index?-1:1);const we=new i(x,W,j,!!H,se?D.URI.revive(se):null,!!J,M=>o(M,V)),{added:_e,removed:ve}=y(ae?ae.workspaceFolders:[],we.workspaceFolders,u,V);return{workspace:we,added:_e,removed:ve}}static _findFolder($,B,N){for(let V=0;V<$.folders.length;V++){const x=$.workspaceFolders[V];if(b(x.uri,B,N))return x}}constructor($,B,N,V,x,W,ee){super($,N.map(se=>new d.WorkspaceFolder(se)),V,x,ee),this._name=B,this._isUntitled=W,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(ee),N.forEach(se=>{this._workspaceFolders.push(se),this._structure.set(se.uri,se)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,B){return B&&this._structure.get($)&&($=(0,T.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let I=e.ExtHostWorkspace=class{constructor($,B,N,V,x){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new L.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=V,this._extHostFileSystemInfo=N,this._uriTransformerService=x,this._requestIdProvider=new g.Counter,this._barrier=new A.Barrier,this._proxy=$.getProxy(f.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(f.MainContext.MainThreadMessageService);const W=B.workspace;this._confirmedWorkspace=W?new i(W.id,W.name,[],!!W.transient,W.configuration?D.URI.revive(W.configuration):null,!!W.isUntitled,ee=>o(ee,N)):void 0}$initializeWorkspace($,B){this._trusted=B,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?D.URI.from({scheme:_.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,B,N,...V){const x=[];if(Array.isArray(V)&&V.forEach(J=>{D.URI.isUri(J.uri)&&!x.some(j=>b(j.uri,J.uri,this._extHostFileSystemInfo))&&x.push({uri:J.uri,name:J.name||(0,T.basenameOrAuthority)(J.uri)})}),this._unconfirmedWorkspace||[B,N].some(J=>typeof J!="number"||J<0)||N===0&&x.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+N>W.length)return!1;const ee=W.slice(0);ee.splice(B,N,...x.map(J=>({uri:J.uri,name:J.name||(0,T.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<ee.length;J++){const j=ee[J];if(ee.some((ae,we)=>we!==J&&b(j.uri,ae.uri,this._extHostFileSystemInfo)))return!1}ee.forEach((J,j)=>J.index=j);const{added:se,removed:H}=y(W,ee,C,this._extHostFileSystemInfo);if(se.length===0&&H.length===0)return!1;if(this._proxy){const J=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(J,B,N,x).then(void 0,j=>{this._unconfirmedWorkspace=void 0;const ae={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(h.Severity.Error,(0,S.localize)(0,null,J,j.toString()),ae,[])})}return this.trySetWorkspaceFolders(ee),!0}getWorkspaceFolder($,B){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,B)}async getWorkspaceFolder2($,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,B)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,B){let N,V="";if(typeof $=="string"?(N=D.URI.file($),V=$):typeof $<"u"&&(N=$,V=$.fsPath),!N)return V;const x=this.getWorkspaceFolder(N,!0);if(!x)return V;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let W=(0,T.relativePath)(x.uri,N);return B&&x.name&&(W=`${x.name}/${W}`),W}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=i.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:B,added:N,removed:V}=i.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:V}))}findFiles($,B,N,V,x=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let W;if(B===null?W=!1:B&&(typeof B=="string"?W=B:W=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:ee,folder:se}=F(t.GlobPattern.from($));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(ee),(0,m.withUndefinedAsNull)(se),(0,m.withUndefinedAsNull)(W),(0,m.withUndefinedAsNull)(N),x).then(H=>Array.isArray(H)?H.map(J=>D.URI.revive(J)):[])}async findTextInFiles($,B,N,V,x=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),ee=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:se,folder:H}=F(t.GlobPattern.from(B.include)),J=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,j={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ee,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:se,excludePattern:J},ae=!1;if(this._activeSearchCallbacks[W]=we=>{if(ae)return;const _e=D.URI.revive(we.resource);we.results.forEach(ve=>{(0,s.resultIsMatch)(ve)?N({uri:_e,preview:{text:ve.preview.text,matches:(0,c.mapArrayOrNot)(ve.preview.matches,M=>new a.Range(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))},ranges:(0,c.mapArrayOrNot)(ve.ranges,M=>new a.Range(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))}):N({uri:_e,text:ve.text,lineNumber:ve.lineNumber})})},x.isCancellationRequested)return{};try{const we=await this._proxy.$startTextSearch($,(0,m.withUndefinedAsNull)(H),j,W,x);return delete this._activeSearchCallbacks[W],we||{}}catch(we){throw delete this._activeSearchCallbacks[W],we}}$handleTextSearchResult($,B){this._activeSearchCallbacks[B]?.($)}async save($){const B=await this._proxy.$save($,{saveAs:!1});return D.URI.revive(B)}async saveAs($){const B=await this._proxy.$save($,{saveAs:!0});return D.URI.revive(B)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider($,B){if(this._editSessionIdentityProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._editSessionIdentityProviders.set($,B);const N=this._uriTransformerService.transformOutgoingScheme($),V=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(V,N),(0,R.toDisposable)(()=>{this._editSessionIdentityProviders.delete($),this._proxy.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier($,B){this._logService.info("Getting edit session identifier for workspaceFolder",$);const N=await this.resolveWorkspaceFolder(D.URI.revive($));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const V=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!V),!V)return;const x=await V.provideEditSessionIdentity(N,B);if(this._logService.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch($,B,N,V){this._logService.info("Getting edit session identifier for workspaceFolder",$);const x=await this.resolveWorkspaceFolder(D.URI.revive($));if(!x){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const W=this._editSessionIdentityProviders.get(x.uri.scheme);if(this._logService.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!W),!W)return;const ee=await W.provideEditSessionIdentityMatch?.(B,N,V);if(this._logService.info("Provider returned edit session identifier match result: ",ee),!!ee)return ee}getOnWillCreateEditSessionIdentityEvent($){return(B,N,V)=>{const x=function(ee){B.call(N,ee)};return x.extension=$,this._onWillCreateEditSessionIdentityEvent.event(x,void 0,V)}}async $onWillCreateEditSessionIdentity($,B,N){const V=await this.resolveWorkspaceFolder(D.URI.revive($));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:V},B,async(x,W)=>{const ee=Date.now();await Promise.resolve(x),Date.now()-ee>N&&this._logService.warn("SLOW edit session create-participant",W.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider($,B){if(this._canonicalUriProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._canonicalUriProviders.set($,B);const N=this._uriTransformerService.transformOutgoingScheme($),V=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(V,N),(0,R.toDisposable)(()=>{this._canonicalUriProviders.delete($),this._proxy.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri($,B,N){const V=this._canonicalUriProviders.get($.scheme);if(!V)return;const x=await V.provideCanonicalUri?.(D.URI.revive($),B,N);if(x)return x}async $provideCanonicalUri($,B,N){return this.provideCanonicalUri(D.URI.revive($),{targetScheme:B},N)}};e.ExtHostWorkspace=I=je([$e(0,p.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,w.IExtHostFileSystemInfo),$e(3,n.ILogService),$e(4,r.IURITransformerService)],I),e.IExtHostWorkspace=(0,v.createDecorator)("IExtHostWorkspace");function F(U){let $,B;return U&&(typeof U=="string"?$=U:($=U.pattern,B=D.URI.revive(U.baseUri))),{includePattern:$,folder:B}}}),define(ye[38],Ce([1,0,23,3,37,6,7,230,128,12,16,5,20,17,2]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(a,r){if(r){const s=r.split(".");let f=a;for(let b=0;f&&b<s.length;b++)f=f[s[b]];return f}}function n(a){return a instanceof S.URI}function h(a){return a&&a.uri instanceof S.URI&&a.languageId&&typeof a.languageId=="string"}function d(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function w(a){return a&&a.uri instanceof S.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function E(a){if(n(a))return{resource:a};if(h(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(d(a))return{overrideIdentifier:a.languageId};if(w(a))return{resource:a.uri};if(a===null)return{resource:null}}let p=e.ExtHostConfiguration=class{constructor(r,s,f){this._proxy=r.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=f,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(r,s))}};e.ExtHostConfiguration=p=je([$e(0,m.IExtHostRpcService),$e(1,l.IExtHostWorkspace),$e(2,D.ILogService)],p);class t{constructor(r,s,f,b){this._onDidChangeConfiguration=new A.Emitter,this._proxy=r,this._logService=b,this._extHostWorkspace=s,this._configuration=P.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,f))}getConfiguration(r,s,f){const b=E(s)||{},u=this._toReadonlyValue(r?v(this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,b,f?.identifier);function C(o){if(o==null)return null;if(typeof o=="boolean")return o?2:5;switch(o){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const y={has(o){return typeof v(u,o)<"u"},get:(o,i)=>{this._validateConfigurationAccess(r?`${r}.${o}`:o,b,f?.identifier);let I=v(u,o);if(typeof I>"u")I=i;else{let F;const U=($,B)=>{if((0,g.isObject)($)){let N;const V=()=>{F=F||(0,c.deepClone)(u),N=N||v(F,B)};return new Proxy($,{get:(x,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return V(),()=>N;if(F)return N=N||v(F,B),N[W];const ee=x[W];return typeof W=="string"?U(ee,`${B}.${W}`):ee},set:(x,W,ee)=>(V(),N&&(N[W]=ee),!0),deleteProperty:(x,W)=>(V(),N&&delete N[W],!0),defineProperty:(x,W,ee)=>(V(),N&&Object.defineProperty(N,W,ee),!0)})}return Array.isArray($)?(0,c.deepClone)($):$};I=U(I,o)}return I},update:(o,i,I,F)=>{o=r?`${r}.${o}`:o;const U=C(I);return i!==void 0?this._proxy.$updateConfigurationOption(U,o,i,b,F):this._proxy.$removeConfigurationOption(U,o,b,F)},inspect:o=>{o=r?`${r}.${o}`:o;const i=this._configuration.inspect(o,b,this._extHostWorkspace.workspace);if(i)return{key:o,defaultValue:(0,c.deepClone)(i.policy?.value??i.default?.value),globalValue:(0,c.deepClone)(i.user?.value??i.application?.value),workspaceValue:(0,c.deepClone)(i.workspace?.value),workspaceFolderValue:(0,c.deepClone)(i.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(i.default?.override),globalLanguageValue:(0,c.deepClone)(i.user?.override??i.application?.override),workspaceLanguageValue:(0,c.deepClone)(i.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(i.workspaceFolder?.override),languageIds:(0,c.deepClone)(i.overrideIdentifiers)}}};return typeof u=="object"&&(0,c.mixin)(y,u,!1),Object.freeze(y)}_toReadonlyValue(r){const s=f=>(0,g.isObject)(f)?new Proxy(f,{get:(b,u)=>s(b[u]),set:(b,u,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(b,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(b,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return s(r)}_validateConfigurationAccess(r,s,f){const b=_.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),u=f?`[${f.value}] `:"";if(b===4){typeof s?.resource>"u"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){s?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const f=new P.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(b,u)=>f.affectsConfiguration(b,E(u))})}_toMap(r){return r.reduce((s,f)=>(s.set(f[0],f[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[87],Ce([1,0,2,16,3,6,7,37,62,38,22,43,20,27,5,18,9,17,83,272,8]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function($){function B(V){if(V!=null)return V}$.from=B;function N(V){if(V!=null)return V}$.to=N})(t||(t={}));var a;(function($){function B(V){if(V!=null)return V}$.from=B;function N(V){if(V!=null)return V}$.to=N})(a||(a={}));var r;(function($){function B(V){if(V!=null)return V}$.from=B;function N(V){if(V!=null)return V}$.to=N})(r||(r={}));var s;(function($){function B(x){if(x){const W=x;return W&&!!W.process}else return!1}$.is=B;function N(x){if(x==null)return;const W={process:x.process,args:x.args};return x.options&&(W.options=r.from(x.options)),W}$.from=N;function V(x){if(x!=null)return new R.ProcessExecution(x.process,x.args,x.options)}$.to=V})(s||(s={}));var f;(function($){function B(V){if(V!=null)return V}$.from=B;function N(V){if(V!=null)return V}$.to=N})(f||(f={}));var b;(function($){function B(x){if(x){const W=x;return W&&(!!W.commandLine||!!W.command)}else return!1}$.is=B;function N(x){if(x==null)return;const W={};return x.commandLine!==void 0?W.commandLine=x.commandLine:(W.command=x.command,W.args=x.args),x.options&&(W.options=f.from(x.options)),W}$.from=N;function V(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new R.ShellExecution(x.commandLine,x.options):new R.ShellExecution(x.command,x.args?x.args:[],x.options)}$.to=V})(b||(b={}));var u;(function($){function B(x){if(x){const W=x;return W&&W.customExecution==="customExecution"}else return!1}$.is=B;function N(x){return{customExecution:"customExecution"}}$.from=N;function V(x,W){return W.get(x)}$.to=V})(u||(e.CustomExecutionDTO=u={}));var C;(function($){function B(N,V){let x;return N.scope!==void 0&&typeof N.scope!="number"?x=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===R.TaskScope.Workspace&&V&&V.workspaceFile?x=V.workspaceFile:x=w.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:x}}$.from=B})(C||(e.TaskHandleDTO=C={}));var y;(function($){function B(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}$.from=B})(y||(y={}));var o;(function($){function B(x,W){if(x==null)return[];const ee=[];for(const se of x){const H=N(se,W);H&&ee.push(H)}return ee}$.fromMany=B;function N(x,W){if(x==null)return;let ee;x.execution instanceof R.ProcessExecution?ee=s.from(x.execution):x.execution instanceof R.ShellExecution?ee=b.from(x.execution):x.execution&&x.execution instanceof R.CustomExecution&&(ee=u.from(x.execution));const se=t.from(x.definition);let H;return x.scope?typeof x.scope=="number"?H=x.scope:H=x.scope.uri:H=R.TaskScope.Workspace,!se||!H?void 0:{_id:x._id,definition:se,name:x.name,source:{extensionId:W.identifier.value,label:x.source,scope:H},execution:ee,isBackground:x.isBackground,group:y.from(x.group),presentationOptions:a.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}$.from=N;async function V(x,W,ee){if(x==null)return;let se;s.is(x.execution)?se=s.to(x.execution):b.is(x.execution)?se=b.to(x.execution):u.is(x.execution)&&(se=u.to(x._id,ee));const H=t.to(x.definition);let J;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?J=x.source.scope:J=await W.resolveWorkspaceFolder(c.URI.revive(x.source.scope)):J=R.TaskScope.Workspace),!H||!J)return;const j=new R.Task(H,J,x.name,x.source.label,se,x.problemMatchers);return x.isBackground!==void 0&&(j.isBackground=x.isBackground),x.group!==void 0&&(j.group=R.TaskGroup.from(x.group._id),j.group&&x.group.isDefault&&(j.group=new R.TaskGroup(j.group.id,j.group.label),x.group.isDefault===!0&&(j.group.isDefault=x.group.isDefault))),x.presentationOptions&&(j.presentationOptions=a.to(x.presentationOptions)),x._id&&(j._id=x._id),x.detail&&(j.detail=x.detail),j}$.to=V})(o||(e.TaskDTO=o={}));var i;(function($){function B(V){return V}$.from=B;function N(V){if(V)return Object.assign(Object.create(null),V)}$.to=N})(i||(i={}));class I{constructor(B,N,V){this._id=N,this._task=V,p.set(this,void 0),Je(this,p,B,"f")}get task(){return this._task}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}p=new WeakMap;let F=e.ExtHostTaskBase=class{constructor(B,N,V,x,W,ee,se,H){this._onDidExecuteTask=new l.Emitter,this._onDidTerminateTask=new l.Emitter,this._onDidTaskProcessStarted=new l.Emitter,this._onDidTaskProcessEnded=new l.Emitter,this._proxy=B.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=x,this._configurationService=W,this._terminalService=ee,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=se,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,N,V){if(!V)return new R.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:N,provider:V,extension:B}),this._proxy.$registerTaskProvider(x,N),new R.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(B,N){this._proxy.$registerTaskSystem(B,N)}fetchTasks(B){return this._proxy.$fetchTasks(i.from(B)).then(async N=>{const V=[];for(const x of N){const W=await o.to(x,this._workspaceProvider,this._providedCustomExecutions2);W&&V.push(W)}return V})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(N=>B.push(N)),B}terminateTask(B){if(!(B instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,N,V){const x=this._providedCustomExecutions2.get(B.id);x&&(this._activeCustomExecutions2.set(B.id,x),this._terminalService.attachPtyToTerminal(N,await x.callback(V))),this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const N=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const N=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:N,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const N=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:B.exitCode})}$provideTasks(B,N){const V=this._handlers.get(B);if(!V)return Promise.reject(new Error("no handler found"));const x=[],W=(0,A.asPromise)(()=>V.provider.provideTasks(T.CancellationToken.None)).then(ee=>this.provideTasksInternal(N,x,V,ee));return new Promise(ee=>{W.then(se=>{Promise.all(x).then(()=>{ee(se)})})})}async $resolveTask(B,N){const V=this._handlers.get(B);if(!V)return Promise.reject(new Error("no handler found"));if(N.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${V.type}].`);const x=await o.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const W=await V.provider.resolveTask(x,T.CancellationToken.None);if(!W)return;this.checkDeprecation(W,V);const ee=o.from(W,V.extension);if(!ee)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(ee.execution)&&await this.addCustomExecution(ee,W,!0),await this.resolveTaskInternal(ee)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,N,V){const x=await this._proxy.$createTaskId(B);!V&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,N.execution)),this._providedCustomExecutions2.set(x,N.execution)}async getTaskExecution(B,N){if(typeof B=="string"){const W=this._taskExecutionPromises.get(B);if(!W)throw new E.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return W}const V=this._taskExecutionPromises.get(B.id);if(V)return V;const x=new Promise((W,ee)=>{function se(H,J,j){j?W(new I(H,J.id,j)):ee("Unexpected: Task does not exist.")}N?se(this,B,N):o.to(B.task,this._workspaceProvider,this._providedCustomExecutions2).then(H=>se(this,B,H))});return this._taskExecutionPromises.set(B.id,x),x.then(W=>(this._taskExecutions.set(B.id,W),W),W=>Promise.reject(W))}checkDeprecation(B,N){B._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));const V=this._notProvidedCustomExecutions.values();let x=V.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=V.next()}};e.ExtHostTaskBase=F=je([$e(0,m.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,g.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,h.ILogService),$e(7,d.IExtHostApiDeprecationService)],F);let U=e.WorkerExtHostTask=class extends F{constructor(B,N,V,x,W,ee,se,H){super(B,N,V,x,W,ee,se,H),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:n.PlatformToString(0)})}async executeTask(B,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const V=o.from(N,B);if(V===void 0)throw new Error("Task is not valid");if(u.is(V.execution))await this.addCustomExecution(V,N,!1);else throw new E.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),N);return this._proxy.$executeTask(V).catch(W=>{throw new Error(W)}),x}provideTasksInternal(B,N,V,x){const W=[];if(x)for(const ee of x){this.checkDeprecation(ee,V),(!ee.definition||!B[ee.definition.type])&&this._logService.warn(`The task [${ee.source}, ${ee.name}] uses an undefined task type. The task will be ignored in the future.`);const se=o.from(ee,V.extension);se&&u.is(se.execution)?(W.push(se),N.push(this.addCustomExecution(se,ee,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:V.extension}}async resolveTaskInternal(B){if(u.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,N,V){}};e.WorkerExtHostTask=U=je([$e(0,m.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,g.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,h.ILogService),$e(7,d.IExtHostApiDeprecationService)],U),e.IExtHostTask=(0,S.createDecorator)("IExtHostTask")}),define(ye[323],Ce([1,0,10,22,45,33,24,40,34]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class g{constructor(m,D,S){this.config=m,this.provider=D,this.sessionToken=S,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&L.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const D=this.config.folderQueries||[];return new Promise((S,v)=>{const n=h=>{this.resultCount++,m(h)};if(this.isCanceled)return S({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const d=h.toString(),w=c.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,w)||this.matchFile(n,{base:h,basename:w})}),Promise.all(D.map(h=>this.searchInFolder(h,n))).then(h=>{S({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{v(new Error((0,l.toErrorMessage)(h)))})})}async searchInFolder(m,D){const S=new A.CancellationTokenSource,v=this.getSearchOptionsForFolder(m),n=this.initDirectoryTree(),h=new _.QueryGlobTester(this.config,m),d=!h.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(S),w=P.StopWatch.create();const E=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,S.token),p=w.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(E&&E.forEach(a=>{const r=c.posix.relative(m.folder.path,a.path);if(d){const s=c.basename(a.path);this.matchFile(D,{base:m.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(n,m.folder,r,D)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(n,h,D),{providerTime:p,postProcessTime:t.elapsed()})}finally{S.dispose(),this.activeCancellationTokens.delete(S)}}getSearchOptionsForFolder(m){const D=(0,_.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),S=(0,_.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:D,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},D,S,v){if(S===this.filePattern){const h=c.basename(this.filePattern);this.matchFile(v,{base:D,relativePath:this.filePattern,basename:h})}function n(h){const d=c.basename(h),w=c.dirname(h);let E=m[w];E||(E=m[w]=[],n(w)),E.push({base:D,relativePath:h,basename:d})}n(S)}matchDirectoryTree({rootEntries:m,pathToEntries:D},S,v){const n=this,h=this.filePattern;function d(w){const E=(0,_.hasSiblingFn)(()=>w.map(p=>p.basename));for(let p=0,t=w.length;p<t;p++){const a=w[p],{relativePath:r,basename:s}=a;if(S.matchesExcludesSync(r,s,h!==s?E:void 0))continue;const f=D[r];if(f)d(f);else{if(r===h)continue;n.matchFile(v,a)}if(n.isLimitHit)break}}d(m)}matchFile(m,D){(!this.includePattern||D.relativePath&&this.includePattern(D.relativePath,D.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(D))}}class T{constructor(){this.sessions=new Map}fileSearch(m,D,S,v){const n=this.getSessionTokenSource(m.cacheKey),h=new g(m,D,n&&n.token);let d=0;const w=E=>{d+=E.length,S(E.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(h,T.BATCH_SIZE,w,v).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:E.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(m)return this.sessions.has(m)||this.sessions.set(m,new A.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:R.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,D,S,v){v.onCancellationRequested(()=>{m.cancel()});const n=d=>{d&&(h.push(d),D>0&&h.length>=D&&(S(h),h=[]))};let h=[];return m.search(n).then(d=>(h.length&&S(h),d),d=>(h.length&&S(h),Promise.reject(d)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(ye[324],Ce([1,0,19,65,33,119,28,18,10,24,11,12,2,173,210,57,17,49,136,322,34]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=e.QueryBuilder=class{constructor(o,i,I,F,U){this.configurationService=o,this.workspaceContextService=i,this.editorGroupsService=I,this.logService=F,this.pathService=U}text(o,i,I={}){o=this.getContentPattern(o,I);const F=this.configurationService.getValue(),U=i&&i.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(i?.map(h.toWorkspaceFolder),I),type:2,contentPattern:o,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:F.search.usePCRE2||U||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}getContentPattern(o,i){const I=this.configurationService.getValue();o.isRegExp&&(o.pattern=o.pattern.replace(/\r?\n/g,"\\n"));const F={...o,wordSeparators:I.editor.wordSeparators};return this.isCaseSensitive(o,i)&&(F.isCaseSensitive=!0),this.isMultiline(o)&&(F.isMultiline=!0),i.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=i.notebookSearchConfig.includeMarkupInput),i.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=i.notebookSearchConfig.includeMarkupPreview),i.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=i.notebookSearchConfig.includeCodeInput),i.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=i.notebookSearchConfig.includeOutput),F}file(o,i={}){return{...this.commonQuery(o,i),type:1,filePattern:i.filePattern?i.filePattern.trim():i.filePattern,exists:i.exists,sortByScore:i.sortByScore,cacheKey:i.cacheKey}}handleIncludeExclude(o,i){return o?(o=Array.isArray(o)?o.map(f):f(o),i?this.parseSearchPaths(o):{pattern:a(...Array.isArray(o)?o:[o])}):{}}commonQuery(o=[],i={}){const I=this.handleIncludeExclude(i.includePattern,i.expandPatterns),F=this.handleIncludeExclude(i.excludePattern,i.expandPatterns),U=o.length>1,$=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,i,F)):o.map(V=>this.getFolderQueryForRoot(V,i,F,U))).filter(V=>!!V),B={_reason:i._reason,folderQueries:$,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:i.extraFileResources,excludePattern:F.pattern,includePattern:I.pattern,onlyOpenEditors:i.onlyOpenEditors,maxResults:i.maxResults};if(i.onlyOpenEditors){const V=c.coalesce(c.flatten(this.editorGroupsService.groups.map(ee=>ee.editors.map(se=>se.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(V));const x=V.filter(ee=>(0,E.pathIncludedInQuery)(B,ee.fsPath)),W=this.commonQueryFromFileList(x);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...B,...W}}const N=i.extraFileResources&&i.extraFileResources.filter(V=>(0,E.pathIncludedInQuery)(B,V.fsPath));return B.extraFileResources=N&&N.length?N:void 0,B}commonQueryFromFileList(o){const i=[],I=new R.ResourceMap,F={};let U=!1;return o.forEach($=>{if($.scheme===P.Schemas.walkThrough)return;if((0,g.isAbsolutePath)($)){const N=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:_.dirname($.fsPath)});let V=I.get(N);V||(U=!0,V={folder:N,includePattern:{}},i.push(V),I.set(N,V));const x=_.relative(N.fsPath,$.fsPath);(0,k.assertIsDefined)(V.includePattern)[x.replace(/\\/g,"/")]=!0}else $.fsPath&&(U=!0,F[$.fsPath]=!0)}),{folderQueries:i,includePattern:F,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(o,i){if(i.isSmartCase){if(o.isRegExp){if(T.containsUppercaseCharacter(o.pattern,!0))return!0}else if(T.containsUppercaseCharacter(o.pattern))return!0}return!!o.isCaseSensitive}isMultiline(o){return o.isMultiline||o.isRegExp&&(0,D.isMultilineRegexSource)(o.pattern)||o.pattern.indexOf(`
`)>=0?!0:!!o.isMultiline}parseSearchPaths(o){const i=W=>_.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),F=(Array.isArray(o)?o:r(o)).map(W=>{const ee=this.pathService.resolvedUserHome;return ee?(0,L.untildify)(W,ee.scheme===P.Schemas.file?ee.fsPath:ee.path):W}),U=A.groupBy(F,W=>i(W)?"searchPaths":"exprSegments"),$=(U.exprSegments||[]).map(W=>T.rtrim(W,"/")).map(W=>T.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),s(W))),B={},N=this.expandSearchPathPatterns(U.searchPaths||[]);N&&N.length&&(B.searchPaths=N);const V=c.flatten($),x=a(...V);return x&&(B.pattern=x),B}getExcludesForFolder(o,i){return i.disregardExcludeSettings?void 0:(0,E.getExcludes)(o,!i.disregardSearchExcludeSettings)}expandSearchPathPatterns(o){if(!o||!o.length)return[];const i=o.flatMap(F=>{let{pathPortion:U,globPortion:$}=t(F);return $&&($=b($)),this.expandOneSearchPath(U).flatMap(N=>this.resolveOneSearchPathPattern(N,$))}),I=new Map;return i.forEach(F=>{const U=F.searchPath.toString(),$=I.get(U);$?F.pattern&&($.pattern=$.pattern||{},$.pattern[F.pattern]=!0):I.set(U,{searchPath:F.searchPath,pattern:F.pattern?a(F.pattern):void 0})}),Array.from(I.values())}expandOneSearchPath(o){if(_.isAbsolute(o)){const i=this.workspaceContextService.getWorkspace().folders;return i[0]&&i[0].uri.scheme!==P.Schemas.file?[{searchPath:i[0].uri.with({path:o})}]:[{searchPath:m.URI.file(_.normalize(o))}]}if(this.workspaceContextService.getWorkbenchState()===2){const i=this.workspaceContextService.getWorkspace().folders[0].uri;if(o=f(o),o.startsWith("../")||o===".."){const F=_.posix.resolve(i.path,o);return[{searchPath:i.with({path:F})}]}const I=b(o);return[{searchPath:i,pattern:I}]}else{if(o==="./"||o===".\\")return[];{const i=o.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(U=>{const $=i.match(new RegExp(`^${T.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return $?{match:$,folder:U}:null}).filter(k.isDefined);if(F.length)return F.map(U=>{const $=U.match[1];return{searchPath:U.folder.uri,pattern:$&&b($)}});{const U=o.match(/\.[\/\\](.+)[\/\\]?/),$=U?U[1]:o,B=S.localize(0,null,$);throw new Error(B)}}}}resolveOneSearchPathPattern(o,i){const I=o.pattern&&i?`${o.pattern}/${i}`:o.pattern||i,F=[{searchPath:o.searchPath,pattern:I}];return I&&!I.endsWith("**")&&F.push({searchPath:o.searchPath,pattern:I+"/**"}),F}getFolderQueryForSearchPath(o,i,I){const F=this.getFolderQueryForRoot((0,h.toWorkspaceFolder)(o.searchPath),i,I,!1);return F?{...F,includePattern:o.pattern}:null}getFolderQueryForRoot(o,i,I,F){let U;const $=m.URI.isUri(o)?o:o.uri;if(I.searchPaths){const W=I.searchPaths.filter(ee=>(0,g.isEqual)(ee.searchPath,$))[0];if(W&&!W.pattern)return null;W&&(U=W.pattern)}const B=this.configurationService.getValue({resource:$}),V={...this.getExcludesForFolder(B,i)||{},...U||{}},x=m.URI.isUri(o)?(0,g.basename)(o):o.name;return{folder:$,folderName:F?x:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof i.disregardIgnoreFiles=="boolean"?i.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof i.disregardGlobalIgnoreFiles=="boolean"?i.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof i.disregardParentIgnoreFiles=="boolean"?i.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof i.ignoreSymlinks=="boolean"?i.ignoreSymlinks:!B.search.followSymlinks}}};e.QueryBuilder=p=je([$e(0,v.IConfigurationService),$e(1,h.IWorkspaceContextService),$e(2,d.IEditorGroupsService),$e(3,n.ILogService),$e(4,w.IPathService)],p);function t(y){const o=y.match(/[\*\{\}\(\)\[\]\?]/);if(o){const i=o.index,I=y.substr(0,i).match(/[/|\\][^/\\]*$/);if(I){let F=y.substr(0,I.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:y.substr((I.index||0)+1)}}}return{pathPortion:y}}function a(...y){return y.length?y.reduce((o,i)=>(o[i]=!0,o),Object.create(null)):void 0}function r(y){return l.splitGlobAware(y,",").map(o=>o.trim()).filter(o=>!!o.length)}function s(y){return[`**/${y}/**`,`**/${y}`].map(i=>i.replace(/\*\*\/\*\*/g,"**"))}function f(y){return y.replace(/\\/g,"/")}function b(y){return f(y).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(y){return y.replace(/([?*[\]])/g,"[$1]")}function C(y,o){y=c.distinct(y,F=>F.toString());const i=[],I=o.getWorkspace();return y&&y.forEach(F=>{let U;if(o.getWorkbenchState()===2)U=(0,g.relativePath)(I.folders[0].uri,F),U&&U!=="."&&(U="./"+U);else{const $=o.getWorkspaceFolder(F);if($){const B=$.name;if(I.folders.filter(V=>V.name===B).length===1){const V=(0,g.relativePath)($.uri,F);V===""?U=`./${$.name}`:U=`./${$.name}/${V}`}else U=F.fsPath}}U&&i.push(u(U))}),i}e.resolveResourcesForSearchIncludes=C}),define(ye[325],Ce([1,0,24,2,22,8,5,324,34,49]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(v,n){const h=n.activationEvents;if(!h)return Promise.resolve(void 0);const d=[],w=[];for(const s of h)if(/^workspaceContains:/.test(s)){const f=s.substr(18);f.indexOf("*")>=0||f.indexOf("?")>=0||v.forceUsingSearch?w.push(f):d.push(f)}if(d.length===0&&w.length===0)return Promise.resolve(void 0);let E;const p=new Promise((s,f)=>{E=s}),t=s=>E({activationEvent:s}),a=Promise.all(d.map(s=>m(v,s,t))).then(()=>{}),r=D(v,n.identifier,w,t);return Promise.all([a,r]).then(()=>{E(void 0)}),p}e.checkActivateWorkspaceContainsExtension=k;async function m(v,n,h){for(const d of v.folders)if(await v.exists(c.joinPath(A.URI.revive(d),n))){h(`workspaceContains:${n}`);return}}async function D(v,n,h,d){if(h.length===0)return Promise.resolve(void 0);const w=new l.CancellationTokenSource,E=v.checkExists(v.folders,h,w.token),p=setTimeout(async()=>{w.cancel(),v.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},T);let t=!1;try{t=await E}catch(a){L.isCancellationError(a)||L.onUnexpectedError(a)}w.dispose(),clearTimeout(p),t&&d(`workspaceContains:${h.join(",")}`)}function S(v,n,h,d){const w=v.get(R.IInstantiationService),E=v.get(_.ISearchService),t=w.createInstance(P.QueryBuilder).file(n.map(a=>(0,g.toWorkspaceFolder)(A.URI.revive(a))),{_reason:"checkExists",includePattern:h,exists:!0});return E.fileSearch(t,d).then(a=>!!a.limitHit,a=>L.isCancellationError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=S});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(re,c):l?l.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(ye[44],Ce([1,0,190,10,88,24,16,4,72,2,17,6,38,261,107,37,25,137,8,26,21,242,7,129,5,27,84,20,98,58,43,3,325,106,244,18,104,40,9,105]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t,a,r,s,f,b,u,C,y,o,i,I,F,U,$,B,N,V){"use strict";var x,W,ee;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let se=e.AbstractExtHostExtensionService=class On extends P.Disposable{constructor(M,X,fe,Ee,Z,ne,le,te,de,oe,ue,O){super(),this._extHostManagedSockets=O,this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=X,this._extHostContext=fe,this._initData=le,this._extHostWorkspace=Ee,this._extHostConfiguration=Z,this._logService=ne,this._extHostTunnelService=de,this._extHostTerminalService=oe,this._extHostLocalizationService=ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._activationEventsReader=new _e(this._initData.activationEvents),this._globalRegistry=new h.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const q=new w.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new h.ExtensionDescriptionRegistry(this._activationEventsReader,ae(this._globalRegistry,q)),this._storage=new S.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=te,this._instaService=M.createChild(new u.ServiceCollection([S.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState])),this._activator=this._register(new D.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Q,ie,pe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Q,d.transformErrorForSerialization(ie),pe)},actualActivateExtension:async(Q,ie)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(Q,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Q,ie),new D.HostExtension;const pe=this._myRegistry.getExtensionDescription(Q);return this._activateExtension(pe,ie)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),l.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){d.onUnexpectedError(M)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._myRegistry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(M)}terminate(M,X=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${M}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),d.setUnexpectedErrorHandler(Ee=>{this._logService.error(Ee)}),this._extHostContext.dispose();const fe=this._deactivateAll();Promise.race([(0,R.timeout)(5e3),fe]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${X}`):this._logService.info(`Extension host exiting with code ${X}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(X)})}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}async getExtension(M){const X=await this._mainThreadExtensionsProxy.$getExtension(M);return X&&{...X,identifier:new w.ExtensionIdentifier(X.identifier.value),extensionLocation:g.URI.revive(X.extensionLocation)}}_activateByEvent(M,X){return this._activator.activateByEvent(M,X)}_activateById(M,X){return this._activator.activateById(M,X)}activateByIdWithErrors(M,X){return this._activateById(M,X).then(()=>{const fe=this._activator.getActivatedExtension(M);if(fe.activationFailed)return Promise.reject(fe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._myRegistry)}getExtensionExports(M){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(M).exports;try{return this._activator.getActivatedExtension(M).exports}catch{return null}}async _realPathExtensionUri(M){if(M.scheme!==U.Schemas.file)return M;const X=await this._hostUtils.realpath(M.fsPath);return g.URI.file(X)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(M=>new we(M))),this._extensionPathIndex}async _createExtensionPathIndex(M){const X=_.TernarySearchTree.forUris(fe=>L.extUriBiasedIgnorePathCase.ignorePathCasing(fe));return await Promise.all(M.map(async fe=>{if(this._getEntryPoint(fe)){const Ee=await this._realPathExtensionUri(fe.extensionLocation);X.set(Ee,fe)}})),X}_deactivate(M){let X=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return X;const fe=this._activator.getActivatedExtension(M);if(!fe)return X;try{typeof fe.module.deactivate=="function"&&(X=Promise.resolve(fe.module.deactivate()).then(void 0,Ee=>(this._logService.error(Ee),Promise.resolve(void 0))))}catch(Ee){this._logService.error(`An error occurred when deactivating the extension '${M.value}':`),this._logService.error(Ee)}try{(0,P.dispose)(fe.subscriptions)}catch(Ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${M.value}':`),this._logService.error(Ee)}return X}async _activateExtension(M,X){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,X).then(fe=>{const Ee=fe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,X),this._logExtensionActivationTimes(M,X,"success",Ee),fe},fe=>{throw this._logExtensionActivationTimes(M,X,"failure"),fe})}_logExtensionActivationTimes(M,X,fe,Ee){const Z=J(M,X);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...Ee||{},outcome:fe})}_doActivateExtension(M,X){const fe=J(M,X);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",fe);const Ee=this._getEntryPoint(M);if(!Ee)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${M.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this._logService.flush();const Z=new D.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this._loadCommonJSModule(M,(0,L.joinPath)(M.extensionLocation,Ee),Z),this._loadExtensionContext(M)]).then(ne=>(l.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),On._callActivate(this._logService,M.identifier,ne[0],ne[1],Z))).then(ne=>(l.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ne))}_loadExtensionContext(M){const X=new p.ExtensionGlobalMemento(M,this._storage),fe=new p.ExtensionMemento(M.identifier.value,!1,this._storage),Ee=new F.ExtensionSecrets(M,this._secretState),Z=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ne=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([X.whenReady,fe.whenReady,this._storagePath.whenReady]).then(()=>{const le=this;let te,de;const oe=(0,n.isProposedApiEnabled)(M,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(M.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:fe,secrets:Ee,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(ue){return A.join(M.extensionLocation.fsPath,ue)},get storagePath(){return le._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return le._storagePath.globalValue(M).fsPath},get logPath(){return A.join(le._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return g.URI.joinPath(le._initData.logsLocation,M.identifier.value)},get storageUri(){return le._storagePath.workspaceValue(M)},get globalStorageUri(){return le._storagePath.globalValue(M)},get extensionMode(){return Z},get extension(){return te===void 0&&(te=new j(le,M.identifier,M,ne,!1)),te},get extensionRuntime(){return(0,n.checkProposedApiEnabled)(M,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le._extHostTerminalService.getEnvironmentVariableCollection(M)},get messagePassingProtocol(){if(!de){if(!oe)return;const ue=o.Event.buffer(o.Event.fromDOMEventEmitter(oe,"message",O=>O.data));oe.start(),de={onDidReceiveMessage:ue,postMessage:oe.postMessage.bind(oe)}}return de}})})}static _callActivate(M,X,fe,Ee,Z){return fe=fe||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,X,fe,Ee,Z).then(ne=>new D.ActivatedExtension(!1,null,Z.build(),fe,ne,Ee.subscriptions))}static _callActivateOptional(M,X,fe,Ee,Z){if(typeof fe.activate=="function")try{Z.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${X.value}`);const ne=typeof global=="object"?global:self,le=fe.activate.apply(ne,[Ee]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(le).then(te=>(Z.activateResolveStop(),te))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(fe)}_activateOneStartupFinished(M,X){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:X}).then(void 0,fe=>{this._logService.error(fe)})}_activateAllStartupFinishedDeferred(M,X=0){const Ee=Date.now();(0,N.setTimeout0)(()=>{for(let Z=X;Z<M.length;Z+=1){const ne=M[Z];for(const le of ne.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-Ee>50){this._activateAllStartupFinishedDeferred(M,Z);break}else this._activateOneStartupFinished(ne,le)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(l.getMarks()),this._extHostConfiguration.getConfigProvider().then(M=>{const X=M.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),fe=this._myRegistry.getAllExtensionDescriptions();if(X)this._activateAllStartupFinishedDeferred(fe);else for(const Ee of fe)if(Ee.activationEvents)for(const Z of Ee.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(Ee,Z)})}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const X=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],fe=this._handleWorkspaceContainsEagerExtensions(X),Ee=this._handleRemoteResolverEagerExtensions(),Z=Promise.all([Ee,M,fe]).then(()=>{});return Promise.race([Z,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(X=>this._handleWorkspaceContainsEagerExtension(M,X))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,X){if(this.isActivated(X.identifier))return;const fe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ee={logService:this._logService,folders:M.map(ne=>ne.uri),forceUsingSearch:fe,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,le,te)=>this._mainThreadWorkspaceProxy.$checkExists(ne,le,te)},Z=await(0,i.checkActivateWorkspaceContainsExtension)(Ee,X);if(Z)return this._activateById(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:Z.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:X}=this._initData.environment;if(!M||!X)throw new Error(c.localize(0,null));const fe=await this._loadCommonJSModule(null,X,new D.ExtensionActivationTimesBuilder(!1));if(!fe||typeof fe.run!="function")throw new Error(c.localize(1,null,X.toString()));return new Promise((Ee,Z)=>{const ne=(de,oe)=>{de?Z(de):Ee(typeof oe=="number"&&oe>0?1:0)},le=(0,L.originalFSPath)(X),te=fe.run(le,ne);te&&te.then&&te.then(()=>{Ee(0)}).catch(de=>{Z(de instanceof Error&&de.stack?de.stack:String(de))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(M,X){return this._resolvers[M]=X,(0,P.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const X=M.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const fe=M.substr(0,X);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${fe}`,!1),{authorityPrefix:fe,resolver:this._resolvers[fe]}}async $resolveAuthority(M,X){const fe=B.StopWatch.create(!1),Ee=()=>`[resolveAuthority(${(0,a.getRemoteAuthorityPrefix)(M)},${X})][${fe.elapsed()}ms] `,Z=oe=>this._logService.info(`${Ee()}${oe}`),ne=(oe,ue=void 0)=>this._logService.error(`${Ee()}${oe}`,ue);Z("activating resolver...");const{authorityPrefix:le,resolver:te}=await this._activateAndGetResolver(M);if(!te)return ne("no resolver"),{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${le}.`,detail:void 0}};const de=new R.IntervalTimer;try{Z("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(te)),de.cancelAndSet(()=>Z("waiting..."),1e3),Z("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${le}`);const oe=await te.resolve(M,{resolveAttempt:X});l.mark(`code/extHost/didResolveAuthorityOK/${le}`),de.dispose();const ue={environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures},O={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};Z(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)?"managed authority":`${oe.host}:${oe.port}`}`);let q;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)){const Q=X;this._extHostManagedSockets.setFactory(Q,oe.makeConnection),q={authority:M,connectTo:new a.ManagedRemoteConnection(Q),connectionToken:oe.connectionToken}}else q={authority:M,connectTo:new a.WebSocketRemoteConnection(oe.host,oe.port),connectionToken:oe.connectionToken};return{type:"ok",value:{authority:q,options:O,tunnelInformation:ue}}}catch(oe){if(l.mark(`code/extHost/didResolveAuthorityError/${le}`),de.dispose(),ne("returned an error",oe),oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(M,X){this._logService.info(`$getCanonicalURI invoked for authority (${(0,a.getRemoteAuthorityPrefix)(M)})`);const{resolver:fe}=await this._activateAndGetResolver(M);if(!fe)return null;const Ee=g.URI.revive(X);if(typeof fe.getCanonicalURI>"u")return Ee;const Z=await(0,R.asPromise)(()=>fe.getCanonicalURI(Ee));return Z||Ee}$startExtensionHost(M){M.toAdd.forEach(Ee=>Ee.extensionLocation=g.URI.revive(Ee.extensionLocation));const{globalRegistry:X,myExtensions:fe}=H(this._activationEventsReader,this._globalRegistry,this._myRegistry,M);return this._globalRegistry.set(X.getAllExtensionDescriptions()),this._myRegistry.set(fe),this._startExtensionHost()}$activateByEvent(M,X){return X===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(fe=>this._activateByEvent(M,!1))}async $activate(M,X){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(M)?(await this._activateById(M,X),!0):!1}async $deltaExtensions(M){M.toAdd.forEach(ne=>ne.extensionLocation=g.URI.revive(ne.extensionLocation));const{globalRegistry:X,myExtensions:fe}=H(this._activationEventsReader,this._globalRegistry,this._myRegistry,M),Ee=await this._createExtensionPathIndex(fe);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this._globalRegistry.set(X.getAllExtensionDescriptions()),this._myRegistry.set(fe),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){const X=E.VSBuffer.alloc(M),fe=Math.random()%256;for(let Ee=0;Ee<M;Ee++)X.writeUInt8(fe,Ee);return X}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=se=je([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,b.IExtHostRpcService),$e(3,v.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,T.ILogService),$e(6,s.IExtHostInitDataService),$e(7,f.IExtensionStoragePaths),$e(8,C.IExtHostTunnelService),$e(9,y.IExtHostTerminalService),$e(10,$.IExtHostLocalizationService),$e(11,V.IExtHostManagedSockets)],se);function H(ve,M,X,fe){ve.addActivationEvents(fe.addActivationEvents);const Ee=new h.ExtensionDescriptionRegistry(ve,M.getAllExtensionDescriptions());Ee.deltaExtensions(fe.toAdd,fe.toRemove);const Z=new w.ExtensionIdentifierSet(X.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of fe.myToRemove)Z.delete(le);for(const le of fe.myToAdd)Z.add(le);const ne=ae(Ee,Z);return{globalRegistry:Ee,myExtensions:ne}}function J(ve,M){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class j{constructor(M,X,fe,Ee,Z){x.set(this,void 0),W.set(this,void 0),ee.set(this,void 0),Je(this,x,M,"f"),Je(this,W,X,"f"),Je(this,ee,fe.identifier,"f"),this.id=fe.identifier.value,this.extensionUri=fe.extensionLocation,this.extensionPath=A.normalize((0,L.originalFSPath)(fe.extensionLocation)),this.packageJSON=fe,this.extensionKind=Ee,this.isFromDifferentExtensionHost=Z}get isActive(){return Oe(this,x,"f").isActivated(Oe(this,ee,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,x,"f").getExtensionExports(Oe(this,ee,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,x,"f").activateByIdWithErrors(Oe(this,ee,"f"),{startup:!1,extensionId:Oe(this,W,"f"),activationEvent:"api"}),this.exports}}e.Extension=j,x=new WeakMap,W=new WeakMap,ee=new WeakMap;function ae(ve,M){return ve.getAllExtensionDescriptions().filter(X=>M.has(X.identifier))}class we{constructor(M){this._searchTree=M}setSearchTree(M){this._searchTree=M}findSubstr(M){return this._searchTree.findSubstr(M)}forEach(M){return this._searchTree.forEach(M)}}e.ExtensionPaths=we;class _e{constructor(M){this._map=new w.ExtensionIdentifierMap,this.addActivationEvents(M)}readActivationEvents(M){return this._map.get(M.identifier)}addActivationEvents(M){for(const X of Object.keys(M))this._map.set(X,M[X])}}}),define(ye[326],Ce([1,0,88,2,6,38,25,26,20,27,5,44,39,17,11]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let v=e.RequireInterceptor=class{constructor(p,t,a,r,s,f,b){this._apiFactory=p,this._extensionRegistry=t,this._instaService=a,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=f,this._logService=b,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,t,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(d,t)),this.register(this._instaService.createInstance(n)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,t,this._initData.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const t of p.nodeModuleName)this._factories.set(t,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(t=>p.alternativeModuleName(t))}};e.RequireInterceptor=v=je([$e(2,T.IInstantiationService),$e(3,L.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,g.IExtHostInitDataService),$e(6,D.ILogService)],v);let n=class fn{constructor(p){if(p.environment.appRoot&&fn.aliased.size){const t=(0,S.escapeRegExpCharacters)(this.forceForwardSlashes(p.environment.appRoot.fsPath)),a="[a-z0-9_.-]",r=`@${a}+\\/${a}+|${a}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(p));if(!t)return;const[,a,r,s]=t,f=fn.aliased.get(r);if(f!==void 0)return console.warn(`${r} as been renamed to ${f}, please update your imports`),a+f+s}forceForwardSlashes(p){return p.replace(/\\/g,"/")}};n.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),n=je([$e(0,g.IExtHostInitDataService)],n);class h{constructor(p,t,a,r,s){this._apiFactory=p,this._extensionPaths=t,this._extensionRegistry=a,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new P.ExtensionIdentifierMap}load(p,t){const a=this._extensionPaths.findSubstr(t);if(a){let r=this._extApiImpl.get(a.identifier);return r||(r=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(a.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,f)=>r+=`	${f} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(p,t,a){this._extensionPaths=p,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=a,s=t.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let f=r.appRoot.fsPath;m.platform==="win32"&&(f=f.replace(/\\/g,"/")),f[f.length-1]==="/"&&(f=f.substr(0,f.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${f}/node_modules.asar/keytar`),this.alternativeNames.add(`${f}/node_modules/keytar`)}this._impl={getPassword:(f,b)=>s.$getPassword(f,b),setPassword:(f,b,u)=>s.$setPassword(f,b,u),deletePassword:(f,b)=>s.$deletePassword(f,b),findPassword:f=>s.$findPassword(f),findCredentials(f){return s.$findCredentials(f)}}}load(p,t){const a=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:a?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(p){const t=p.length;if(t<=7||!this.alternativeNames)return;const a=t-7;if((p.charAt(a)==="/"||p.charAt(a)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}};d=je([$e(1,_.IExtHostRpcService),$e(2,g.IExtHostInitDataService)],d);let w=class{constructor(p,t,a){this._extensionPaths=p,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(l.MainContext.MainThreadTelemetry);const r=a.getProxy(l.MainContext.MainThreadWindow);this._impl=(s,f)=>{const b=A.URI.parse(s);return f?this.callOriginal(s,f):b.scheme==="http"||b.scheme==="https"?r.$openUri(b,s,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this._appUriScheme?r.$openUri(b,s,{}):this.callOriginal(s,f)}}load(p,t,a){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=a(p),this._impl}callOriginal(p,t){return this.sendNoForwardTelemetry(),this._original(p,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=je([$e(2,_.IExtHostRpcService)],w)}),define(ye[51],Ce([1,0,54,4,10,39,5,62,63,44,7,37,257,38]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class S extends m.AbstractVariableResolverService{constructor(h,d,w,E,p,t,a){function r(){if(w){const s=w.activeEditor();if(s)return s.document.uri;const f=E.tabGroups.all.find(b=>b.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof T.TextDiffTabInput||f.input instanceof T.NotebookDiffEditorTabInput)return f.input.modified;if(f.input instanceof T.TextTabInput||f.input instanceof T.NotebookEditorTabInput||f.input instanceof T.CustomEditorTabInput)return f.input.uri}}}super({getFolderUri:s=>{const f=t.folders.filter(b=>b.name===s);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(s,f)=>p.getConfiguration(void 0,s).get(f),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return l.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const s=r();if(s){const f=d.getWorkspaceFolder(s);if(f)return l.normalize(f.uri.fsPath)}}},getSelectedText:()=>{if(w){const s=w.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(w){const s=w.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>h.getExtension(s)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let v=e.ExtHostVariableResolverProviderService=class extends A.Disposable{constructor(h,d,w,E,p){super(),this.extensionService=h,this.workspaceService=d,this.editorService=w,this.configurationService=E,this.editorTabs=p,this._resolver=new c.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new S(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=v=je([$e(0,g.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,P.IExtHostDocumentsAndEditors),$e(3,D.IExtHostConfiguration),$e(4,_.IExtHostEditorTabs)],v)}),define(ye[89],Ce([1,0,16,3,12,2,5,6,63,44,20,7,37,133,251,38,51]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let h=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,s,f,b,u,C){this._workspaceService=s,this._extensionService=f,this._configurationService=b,this._editorTabs=u,this._variableResolver=C,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=r.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._onDidChangeStackFrameFocus=new A.Emitter,this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(y=>{y.onDidChange(o=>{this.registerAllDebugTypes(y)}),this.registerAllDebugTypes(y)})}asDebugSourceUri(r,s){const f=r;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let b=`debug:${encodeURIComponent(f.path||"")}`,u="?";return s&&(b+=`${u}session=${encodeURIComponent(s.id)}`,u="&"),b+=`${u}ref=${f.sourceReference}`,L.URI.parse(b)}else{if(f.path)return L.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const f of r.getAllExtensionDescriptions())if(f.contributes){const b=f.contributes.debuggers;if(b&&b.length>0)for(const u of b)(0,S.isDebuggerMainContribution)(u)&&s.push(u.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(u=>{const C=u.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,u),!0)});this.fireBreakpointChanges(s,[],[]);const f=[],b=new Map;for(const u of s)if(u instanceof k.SourceBreakpoint){let C=b.get(u.location.uri.toString());C||(C={type:"sourceMulti",uri:u.location.uri,lines:[]},b.set(u.location.uri.toString(),C),f.push(C)),C.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof k.FunctionBreakpoint&&f.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],s,[]);const f=s.filter(C=>C instanceof k.SourceBreakpoint).map(C=>C.id),b=s.filter(C=>C instanceof k.FunctionBreakpoint).map(C=>C.id),u=s.filter(C=>C instanceof k.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(f,b,u)}startDebugging(r,s,f){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,f){if(!s)return new k.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:b,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,f,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,b),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(u=>u.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(r,s,f){if(!f)return new k.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:b,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,b),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(u=>u.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new k.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:f,factory:s}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let f;const b=await this.getFolder(r);return b&&(f={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(f,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new p(r.implementation)}createSignService(){}async $startDASession(r,s){const f=this,b=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const C=this.convertToDto(u),y=this.createDebugAdapter(C,b);if(!y)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const o=y;return this._debugAdapters.set(r,o),this.getDebugAdapterTrackers(b).then(i=>(i&&this._debugAdaptersTrackers.set(r,i),o.onMessage(async I=>{if(I.type==="request"&&I.command==="handshake"){const F=I,U={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(F.arguments.value);U.body={signature:$},o.sendResponse(U)}else throw new Error("no signer")}catch($){U.success=!1,U.message=$.message,o.sendResponse(U)}}else i&&i.onDidSendMessage&&i.onDidSendMessage(I),I=(0,S.convertToVSCPaths)(I,!0),f._debugServiceProxy.$acceptDAMessage(r,I)}),o.onError(I=>{i&&i.onError&&i.onError(I),this._debugServiceProxy.$acceptDAError(r,I.name,I.message,I.stack)}),o.onExit(I=>{i&&i.onExit&&i.onExit((0,l.withNullAsUndefined)(I),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,l.withNullAsUndefined)(I),void 0)}),i&&i.onWillStartSession&&i.onWillStartSession(),o.startSession()))})}$sendDAMessage(r,s){s=(0,S.convertToDAPaths)(s,!1);const f=this._debugAdaptersTrackers.get(r);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(s),this._debugAdapters.get(r)?.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const f=this._debugAdapters.get(r);return this._debugAdapters.delete(r),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],f=[],b=[];if(r.added)for(const u of r.added){const C=u.id;if(C&&!this._breakpoints.has(C)){let y;if(u.type==="function")y=new k.FunctionBreakpoint(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")y=new k.DataBreakpoint(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const o=L.URI.revive(u.uri);y=new k.SourceBreakpoint(new k.Location(o,new k.Position(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,k.setBreakpointId)(y,C),this._breakpoints.set(C,y),s.push(y)}}if(r.removed)for(const u of r.removed){const C=this._breakpoints.get(u);C&&(this._breakpoints.delete(u),f.push(C))}if(r.changed){for(const u of r.changed)if(u.id){const C=this._breakpoints.get(u.id);if(C){if(C instanceof k.FunctionBreakpoint&&u.type==="function"){const y=C;y.enabled=u.enabled,y.condition=u.condition,y.hitCondition=u.hitCondition,y.logMessage=u.logMessage,y.functionName=u.functionName}else if(C instanceof k.SourceBreakpoint&&u.type==="source"){const y=C;y.enabled=u.enabled,y.condition=u.condition,y.hitCondition=u.hitCondition,y.logMessage=u.logMessage,y.location=new k.Location(L.URI.revive(u.uri),new k.Position(u.line,u.character))}b.push(C)}}}this.fireBreakpointChanges(s,f,b)}async $acceptStackFrameFocus(r){let s;const f=r.sessionId?await this.getSession(r.sessionId):void 0;if(!f)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new k.ThreadFocus(f,r.threadId):s=new k.StackFrameFocus(f,r.threadId,r.frameId),this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(r,s,f){return(0,c.asPromise)(async()=>{const b=this.getConfigProviderByHandle(r);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.getFolder(s);return b.provideDebugConfigurations(u,f)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(r,s,f,b){return(0,c.asPromise)(async()=>{const u=this.getConfigProviderByHandle(r);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(s);return u.resolveDebugConfiguration(C,f,b)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,f,b){return(0,c.asPromise)(async()=>{const u=this.getConfigProviderByHandle(r);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(s);return u.resolveDebugConfigurationWithSubstitutedVariables(C,f,b)})}async $provideDebugAdapter(r,s){const f=this.getAdapterDescriptorFactoryByHandle(r);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(s);return this.getAdapterDescriptor(f,b).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(u)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){(await this.getSession(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const b={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(f=>f.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(f=>f.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(f=>f.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const f=r.contributes.debuggers;if(f&&f.length>0){for(const b of f)if(b.label&&b.type&&b.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const f=r.configuration.type,b=this._trackerFactories.filter(u=>u.type===f||u.type==="*").map(u=>(0,c.asPromise)(()=>u.factory.createDebugAdapterTracker(r)).then(C=>C,C=>null));return Promise.race([Promise.all(b).then(u=>{const C=u.filter(y=>!!y);if(C.length>0)return new E(C)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async getAdapterDescriptor(r,s){const f=s.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.DebugAdapterServer(f));if(r){const u=await this._extensionService.getExtensionRegistry();return(0,c.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,u))).then(C=>{if(C)return C})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,b))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,f){(r.length>0||s.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:f}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const f=await this.getFolder(r.folderUri),b=r.parent?this._debugSessions.get(r.parent):void 0;s=new d(this._debugServiceProxy,r.id,r.type,r.name,f,r.configuration,b),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=L.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=h=je([$e(0,T.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,g.IExtHostExtensionService),$e(3,v.IExtHostConfiguration),$e(4,_.IExtHostEditorTabs),$e(5,n.IExtHostVariableResolverProvider)],h);class d{constructor(r,s,f,b,u,C,y){this._debugServiceProxy=r,this._id=s,this._type=f,this._name=b,this._workspaceFolder=u,this._configuration=C,this._parentSession=y}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=d;class w{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=w;class E{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(f=>f.onExit?f.onExit(r,s):void 0)}}class p extends D.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=e.WorkerExtHostDebugService=class extends h{constructor(r,s,f,b,u,C){super(r,s,f,b,u,C)}};e.WorkerExtHostDebugService=t=je([$e(0,T.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,g.IExtHostExtensionService),$e(3,v.IExtHostConfiguration),$e(4,_.IExtHostEditorTabs),$e(5,n.IExtHostVariableResolverProvider)],t)}),define(ye[327],Ce([1,0,8,88,2,6,319,17,97,98,27,222,20,59,44,82]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class n{static async installEarlyHandler(w){const E=w.get(P.ILogService),t=w.get(m.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(a=>{E.error(a);const r=c.transformErrorForSerialization(a);t.$onUnexpectedError(r)})}static async installFullHandler(w){const E=w.get(P.ILogService),p=w.get(m.IExtHostRpcService),t=w.get(S.IExtHostExtensionService),a=w.get(v.IExtHostTelemetry),r=p.getProxy(L.MainContext.MainThreadExtensionService),s=p.getProxy(L.MainContext.MainThreadErrors),f=await t.getExtensionPathIndex(),b=new WeakMap;function u(y,o){let i="",I,F;for(const U of o)i+=`
	at ${U.toString()}`,F=U.getFileName(),!I&&F&&(I=f.findSubstr(l.URI.file(F)));return b.set(y,I?.identifier),`${y.name||"Error"}: ${y.message||""}${i}`}let C=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(y){C=function(o,i){return u(o,i),y.call(Error,o,i)}}}),c.setUnexpectedErrorHandler(y=>{E.error(y);const o=c.transformErrorForSerialization(y),i=b.get(y);if(!i){s.$onUnexpectedError(o);return}r.$onExtensionRuntimeError(i,o);const I=a.onExtensionError(i,y);E.trace("forwarded error to extension?",I,i)})}}Error.stackTraceLimit=100;class h{constructor(w,E,p,t,a){this._hostUtils=p,this._rpcProtocol=new R.RPCProtocol(w,null,t),E=h._transform(E,this._rpcProtocol);const r=new g.ServiceCollection(...(0,_.getSingletonServiceDescriptors)());r.set(T.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:a}),r.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),r.set(D.IURITransformerService,new D.URITransformerService(t)),r.set(S.IHostUtils,p);const s=new k.InstantiationService(r,!0);s.invokeFunction(n.installEarlyHandler),this._logService=s.invokeFunction(f=>f.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",E),this._extensionService=s.invokeFunction(f=>f.get(S.IExtHostExtensionService)),this._extensionService.initialize(),s.invokeFunction(n.installFullHandler)}async asBrowserUri(w){const E=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return l.URI.revive(await E.$asBrowserUri(w))}terminate(w){this._extensionService.terminate(w)}static _transform(w,E){w.allExtensions.forEach(t=>{t.extensionLocation=l.URI.revive(E.transformIncomingURIs(t.extensionLocation))}),w.environment.appRoot=l.URI.revive(E.transformIncomingURIs(w.environment.appRoot));const p=w.environment.extensionDevelopmentLocationURI;return p&&(w.environment.extensionDevelopmentLocationURI=p.map(t=>l.URI.revive(E.transformIncomingURIs(t)))),w.environment.extensionTestsLocationURI=l.URI.revive(E.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=l.URI.revive(E.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=l.URI.revive(E.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=l.URI.revive(E.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=l.URI.revive(E.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=l.URI.revive(E.transformIncomingURIs(w.logsLocation)),w.workspace=E.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=h}),define(ye[328],Ce([1,0,16,9,199,216,232,89,63,44,20,43,7,51,37,252,253,38]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let d=e.ExtHostDebugService=class extends P.ExtHostDebugServiceBase{constructor(a,r,s,f,b,u,C){super(a,r,s,f,u,C),this._terminalService=b,this._integratedTerminalInstances=new p}createDebugAdapter(a,r){switch(a.type){case"server":return new v.SocketDebugAdapter(a);case"pipeServer":return new v.NamedPipeDebugAdapter(a);case"executable":return new v.ExecutableDebugAdapter(a,r.type)}return super.createDebugAdapter(a,r)}daExecutableFromPackage(a,r){const s=v.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),a.type);if(s)return new m.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new R.SignService}async $runInTerminal(a,r){if(a.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal($=>{this._integratedTerminalInstances.onTerminalClosed($)}));const s=await this._configurationService.getConfigProvider(),f=this._terminalService.getDefaultShell(!0),b=this._terminalService.getDefaultShellArgs(!0),u=a.title||l.localize(0,null),C=JSON.stringify({shell:f,shellArgs:b});let y=await this._integratedTerminalInstances.checkout(C,u),o,i=!1;if(y)o=a.cwd;else{const $={shellPath:f,shellArgs:b,cwd:a.cwd,name:u,iconPath:new m.ThemeIcon("debug")};i=!0,y=this._terminalService.createTerminalFromOptions($,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(y,C)}y.show(!0);const I=await y.processId;i?await new Promise($=>setTimeout($,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0||f.indexOf("cmd.exe")>=0?y.sendText("cls"):f.indexOf("bash")>=0?y.sendText("clear"):A.isWindows?y.sendText("cls"):y.sendText("clear"));const F=(0,n.prepareCommand)(f,a.args,!!a.argsCanBeInterpretedByShell,o,a.env);y.sendText(F);const U=this.onDidTerminateDebugSession($=>{$.id===r&&(this._integratedTerminalInstances.free(y),U.dispose())});return I}else if(a.kind==="external")return E(a,await this._configurationService.getConfigProvider());return super.$runInTerminal(a,r)}};e.ExtHostDebugService=d=je([$e(0,T.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,g.IExtHostExtensionService),$e(3,h.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,_.IExtHostEditorTabs),$e(6,D.IExtHostVariableResolverProvider)],d);let w;function E(t,a){if(!w)if(A.isWindows)w=new L.WindowsExternalTerminalService;else if(A.isMacintosh)w=new L.MacExternalTerminalService;else if(A.isLinux)w=new L.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=a.getConfiguration("terminal");return w.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class p{constructor(){this._terminalInstances=new Map}async checkout(a,r){const f=[...this._terminalInstances.entries()].map(([b,u])=>(0,c.createCancelablePromise)(async C=>{if(b.name!==r||u.lastUsedAt!==-1&&await(0,n.hasChildProcesses)(await b.processId))return null;const y=Date.now();return u.lastUsedAt+p.minUseDelay>y||C.isCancellationRequested||u.config!==a?null:(u.lastUsedAt=y,b)}));return await(0,c.firstParallel)(f,b=>!!b)}insert(a,r){this._terminalInstances.set(a,{lastUsedAt:Date.now(),config:r})}free(a){const r=this._terminalInstances.get(a);r&&(r.lastUsedAt=-1)}onTerminalClosed(a){this._terminalInstances.delete(a)}}p.minUseDelay=1e3}),define(ye[329],Ce([1,0,10,2,95,37,62,38,49,43,20,27,87,18,17,83,24,74,51]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=e.ExtHostTask=class extends m.ExtHostTaskBase{constructor(p,t,a,r,s,f,b,u,C){super(p,t,a,r,s,f,b,u),this.workspaceService=a,this.variableResolver=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,t){const a=t;if(!t.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const r=m.TaskHandleDTO.from(a,this.workspaceService),s=await this._proxy.$getTaskExecution(r);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.getTaskExecution(s,t);return this._proxy.$executeTask(r).catch(()=>{}),f}else{const r=m.TaskDTO.from(t,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,t,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),t);return this._proxy.$executeTask(r).catch(()=>{}),s}}provideTasksInternal(p,t,a,r){const s=[];if(r)for(const f of r){this.checkDeprecation(f,a),(!f.definition||!p[f.definition.type])&&this._logService.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const b=m.TaskDTO.from(f,a.extension);b&&(s.push(b),m.CustomExecutionDTO.is(b.execution)&&t.push(this.addCustomExecution(b,f,!0)))}return{tasks:s,extension:a.extension}}async resolveTaskInternal(p){return p}async getAFolder(p){let t=p&&p.length>0?p[0]:void 0;if(!t){const a=A.URI.file((0,h.homedir)());t=new _.WorkspaceFolder({uri:a,name:n.basename(a),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,t){const a=A.URI.revive(p),r={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(a),f=await this._workspaceProvider.getWorkspaceFolders2()??[],b=await this.variableResolver.getResolver(),u=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(f);for(const C of t.variables)r.variables[C]=await b.resolveAsync(u,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(c.delimiter);for(let y=0;y<C.length;y++)C[y]=await b.resolveAsync(u,C[y])}r.process=await l.win32.findExecutable(await b.resolveAsync(u,t.process.name),t.process.cwd!==void 0?await b.resolveAsync(u,t.process.cwd):void 0,C)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,t,a){return l.win32.findExecutable(p,t,a)}};e.ExtHostTask=w=je([$e(0,T.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,L.IExtHostWorkspace),$e(3,R.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,g.IExtHostTerminalService),$e(6,S.ILogService),$e(7,v.IExtHostApiDeprecationService),$e(8,d.IExtHostVariableResolverProvider)],w)}),define(ye[330],Ce([1,0,74,51]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends A.ExtHostVariableResolverProviderService{homeDir(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(ye[146],Ce([1,0,19,16,22,45,18,10,24,2,34]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(d,w,E,p){this.query=d,this.provider=w,this.fileUtils=E,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,w){const E=this.query.folderQueries||[],p=new l.CancellationTokenSource;return w.onCancellationRequested(()=>p.cancel()),new Promise((t,a)=>{this.collector=new D(d);let r=!1;const s=(f,b)=>{if(!r&&!this.isLimitHit){const u=this.resultSize(f);v(f)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,r=!0,p.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const C=this.resultSize(f);this.resultCount+=C,(C>0||!v(f))&&this.collector.add(f,b)}};Promise.all(E.map((f,b)=>this.searchInFolder(f,u=>s(u,b),p.token))).then(f=>{p.dispose(),this.collector.flush();const b=f.some(u=>!!u&&!!u.limitHit);t({limitHit:this.isLimitHit||b,messages:(0,c.flatten)(f.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.processType}})},f=>{p.dispose();const b=(0,L.toErrorMessage)(f);a(new Error(b))})})}resultSize(d){return v(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,w){const E=Array.isArray(d.ranges)?d.ranges:[d.ranges],p=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:E.slice(0,w),preview:{matches:p.slice(0,w),text:d.preview.text},uri:d.uri}}async searchInFolder(d,w,E){const p=new T.QueryGlobTester(this.query,d),t=[],a={report:f=>{if(!this.validateProviderResult(f))return;const b=d.folder.scheme===R.Schemas.file?(0,T.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(_.dirname(f.uri))):void 0,u=_.relativePath(d.folder,f.uri);if(u){const C=p.includedInQuery(u,P.basename(u),b);(0,A.isThenable)(C)?t.push(C.then(y=>{y&&w(f)})):C&&w(f)}}},r=this.getSearchOptionsForFolder(d),s=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,a,E);return t.length&&await Promise.all(t),s}validateProviderResult(d){if(v(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const w=(0,T.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),E=(0,T.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),p={folder:g.URI.from(d.folder),excludes:E,includes:w,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=k;function m(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class D{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new n(512,w=>this.sendItems(w))}add(d,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!_.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(S(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=D;function S(h){return v(h)?{preview:{matches:(0,c.mapArrayOrNot)(h.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:h.preview.text},ranges:(0,c.mapArrayOrNot)(h.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function v(h){return!!h.preview}e.extensionResultIsMatch=v;class n{constructor(d,w){this.maxBatchSize=d,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,w){d&&this.addItemToBatch(d,w)}addItems(d,w){d&&this.addItemsToBatch(d,w)}addItemToBatch(d,w){this.batch.push(d),this.batchSize+=w,this.onUpdate()}addItemsToBatch(d,w){this.batch=this.batch.concat(d),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<n.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},n.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=n,n.TIMEOUT=4e3,n.START_BATCH_AFTER_COUNT=50}),define(ye[90],Ce([1,0,4,6,5,323,20,59,17,2,146]),function(re,e,c,A,l,L,R,P,_,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let k=e.ExtHostSearch=class{constructor(v,n,h){this.extHostRpc=v,this._uriTransformer=n,this._logService=h,this._proxy=this.extHostRpc.getProxy(A.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,n){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const h=this._handlePool++;return this._textSearchProvider.set(h,n),this._proxy.$registerTextSearchProvider(h,this._transformScheme(v)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(v,n){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const h=this._handlePool++;return this._fileSearchProvider.set(h,n),this._proxy.$registerFileSearchProvider(h,this._transformScheme(v)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(v,n,h,d){const w=m(h),E=this._fileSearchProvider.get(v);if(E)return this._fileSearchManager.fileSearch(w,E,p=>{this._proxy.$handleFileMatch(v,n,p.map(t=>t.resource))},d);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,n,h,d){const w=this._textSearchProvider.get(v);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const E=m(h);return this.createTextSearchManager(E,w).search(t=>this._proxy.$handleTextMatch(v,n,t),d)}$enableExtensionHostSearch(){}createTextSearchManager(v,n){return new T.TextSearchManager(v,n,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};e.ExtHostSearch=k=je([$e(0,R.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,_.ILogService)],k);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(D),extraFileResources:S.extraFileResources&&S.extraFileResources.map(v=>g.URI.revive(v))}}e.reviveQuery=m;function D(S){return{...S,folder:g.URI.revive(S.folder)}}}),define(ye[331],Ce([1,0,22,8,3,41,2,123,114,157,171,31,6,103,278,277,36,279,38,281,282,283,263,284,62,44,285,286,291,292,293,145,267,299,300,303,107,43,305,268,15,7,79,308,85,144,37,26,255,290,78,142,87,89,90,17,59,20,27,294,262,58,83,274,306,84,64,311,309,310,275,50,304,307,106,63,82,295,86,296,18,126,266,243,287,4,25,250,104,239,297,298,276,288,265,301,289,105,302]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t,a,r,s,f,b,u,C,y,o,i,I,F,U,$,B,N,V,x,W,ee,se,H,J,j,ae,we,_e,ve,M,X,fe,Ee,Z,ne,le,te,de,oe,ue,O,q,Q,ie,pe,De,he,Ae,Te,He,Ve,tt,Xe,Ke,nt,ot,et,xe,Ie,K,Y,me,Fe,We,ze,Ye,ct,st,ft,kt,Tt,bt,zt,Mt,jt,Ft,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function $t(ut){const gt=ut.get(te.IExtHostInitDataService),xt=ut.get(He.IExtHostFileSystemInfo),Ut=ut.get(pe.IExtHostConsumerFileSystem),_t=ut.get(s.IExtHostExtensionService),mt=ut.get(j.IExtHostWorkspace),It=ut.get(nt.IExtHostTelemetry),Wt=ut.get(d.IExtHostConfiguration),Le=ut.get(ne.IURITransformerService),Pe=ut.get(le.IExtHostRpcService),ke=ut.get($.IExtHostStorage),ce=ut.get(ie.IExtensionStoragePaths),Me=ut.get(Z.ILoggerService),Be=ut.get(Z.ILogService),Qe=ut.get(ue.IExtHostTunnelService),qe=ut.get(O.IExtHostApiDeprecationService),it=ut.get(J.IExtHostWindow),yt=ut.get(Xe.IExtHostSecretState),Rt=ut.get(Ke.IExtHostEditorTabs),Pt=ut.get(Ft.IExtHostManagedSockets);Pe.set(m.ExtHostContext.ExtHostFileSystemInfo,xt),Pe.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Me),Pe.set(m.ExtHostContext.ExtHostWorkspace,mt),Pe.set(m.ExtHostContext.ExtHostConfiguration,Wt),Pe.set(m.ExtHostContext.ExtHostExtensionService,_t),Pe.set(m.ExtHostContext.ExtHostStorage,ke),Pe.set(m.ExtHostContext.ExtHostTunnelService,Qe),Pe.set(m.ExtHostContext.ExtHostWindow,it),Pe.set(m.ExtHostContext.ExtHostSecretState,yt),Pe.set(m.ExtHostContext.ExtHostTelemetry,It),Pe.set(m.ExtHostContext.ExtHostEditorTabs,Rt),Pe.set(m.ExtHostContext.ExtHostManagedSockets,Pt);const wt=Pe.set(m.ExtHostContext.ExtHostDecorations,ut.get(M.IExtHostDecorations)),lt=Pe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(r.IExtHostDocumentsAndEditors)),vt=Pe.set(m.ExtHostContext.ExtHostCommands,ut.get(n.IExtHostCommands)),Et=Pe.set(m.ExtHostContext.ExtHostTerminalService,ut.get(B.IExtHostTerminalService)),St=Pe.set(m.ExtHostContext.ExtHostDebugService,ut.get(fe.IExtHostDebugService)),oi=Pe.set(m.ExtHostContext.ExtHostSearch,ut.get(Ee.IExtHostSearch)),Ht=Pe.set(m.ExtHostContext.ExtHostTask,ut.get(X.IExtHostTask)),Li=Pe.set(m.ExtHostContext.ExtHostOutputService,ut.get(o.IExtHostOutputService)),Gt=Pe.set(m.ExtHostContext.ExtHostLocalization,ut.get(ct.IExtHostLocalizationService)),Ei=Pe.set(m.ExtHostContext.ExtHostUrls,new se.ExtHostUrls(Pe)),At=Pe.set(m.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Pe,lt)),Fi=Pe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Pe,lt,Be)),ai=Pe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Be,At,Pe.getProxy(m.MainContext.MainThreadBulkEdits))),Ct=Pe.set(m.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(Pe,vt,lt,At)),di=Pe.set(m.ExtHostContext.ExtHostNotebookDocuments,new me.ExtHostNotebookDocuments(Ct)),wi=Pe.set(m.ExtHostContext.ExtHostNotebookEditors,new Y.ExtHostNotebookEditors(Be,Ct)),hi=Pe.set(m.ExtHostContext.ExtHostNotebookKernels,new ot.ExtHostNotebookKernels(Pe,gt,Ct,vt,Be)),cn=Pe.set(m.ExtHostContext.ExtHostNotebookRenderers,new xe.ExtHostNotebookRenderers(Pe,Ct)),Oi=Pe.set(m.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new zt.ExtHostNotebookDocumentSaveParticipant(Be,Ct,Pe.getProxy(m.MainContext.MainThreadBulkEdits))),Ot=Pe.set(m.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Pe,lt)),Si=Pe.set(m.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(Pe.getProxy(m.MainContext.MainThreadTreeViews),vt,Be)),Qt=Pe.set(m.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(Pe.getProxy(m.MainContext.MainThreadEditorInsets),Ot,gt.remote)),ci=Pe.set(m.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Pe,Be,xt,lt)),li=Pe.set(m.ExtHostContext.ExtHostLanguages,new C.ExtHostLanguages(Pe,At,vt.converter,Le)),dt=Pe.set(m.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(Pe,Le,At,vt,ci,Be,qe,It)),Mi=Pe.set(m.ExtHostContext.ExtHostFileSystem,new f.ExtHostFileSystem(Pe,dt)),ei=Pe.set(m.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(Pe,Be,lt)),Kt=Pe.set(m.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(Pe,mt,vt)),_i=Pe.set(m.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Pe,vt,At,Be)),Ni=Pe.set(m.ExtHostContext.ExtHostQuickDiff,new kt.ExtHostQuickDiff(Pe,Le)),xi=Pe.set(m.ExtHostContext.ExtHostShare,new Nt.ExtHostShare(Pe,Le)),Ui=Pe.set(m.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Pe,vt,At)),yi=Pe.set(m.ExtHostContext.ExtHostProgress,new i.ExtHostProgress(Pe.getProxy(m.MainContext.MainThreadProgress))),Wi=Pe.set(m.ExtHostContext.ExtHosLabelService,new _e.ExtHostLabelService(Pe)),Ci=Pe.set(m.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Pe)),ni=Pe.set(m.ExtHostContext.ExtHostAuthentication,new q.ExtHostAuthentication(Pe)),Bi=Pe.set(m.ExtHostContext.ExtHostTimeline,new Q.ExtHostTimeline(Pe,vt)),fi=Pe.set(m.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Pe,gt.remote,mt,Be,qe)),mi=Pe.set(m.ExtHostContext.ExtHostWebviewPanels,new Ae.ExtHostWebviewPanels(Pe,fi,mt)),zi=Pe.set(m.ExtHostContext.ExtHostCustomEditors,new he.ExtHostCustomEditors(Pe,At,ce,fi,mi)),$i=Pe.set(m.ExtHostContext.ExtHostWebviewViews,new De.ExtHostWebviewViews(Pe,fi)),ri=Pe.set(m.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(Pe,vt,lt)),Hi=Pe.set(m.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Pe)),Vi=Pe.set(m.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Pe));Pe.set(m.ExtHostContext.ExtHostInteractive,new Fe.ExtHostInteractive(Pe,Ct,lt,vt,Be));const ji=Pe.set(m.ExtHostContext.ExtHostInteractiveEditor,new bt.ExtHostInteractiveEditor(Pe,vt,At,Be)),si=Pe.set(m.ExtHostContext.ExtHostChat,new Tt.ExtHostChat(Pe,Be)),qi=Pe.set(m.ExtHostContext.ExtHostSemanticSimilarity,new Mt.ExtHostSemanticSimilarity(Pe)),Gi=Pe.set(m.ExtHostContext.ExtHostIssueReporter,new jt.ExtHostIssueReporter(Pe)),Di=Pe.set(m.ExtHostContext.ExtHostStatusBar,new U.ExtHostStatusBar(Pe,vt.converter)),Ki=Object.values(m.ExtHostContext);Pe.assertRegistered(Ki);const Xi=new Te.ExtHostBulkEdits(Pe,lt),ln=new v.ExtHostClipboard(Pe),Ii=new y.ExtHostMessageService(Pe,Be),gi=new E.ExtHostDialogs(Pe);return S.ExtHostApiCommands.register(vt),function(Ue,Yt,Qi){const pt=function(){let ge=!Ue.isUnderDevelopment;function Se(){ge||(Be.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ne(rt){if(Array.isArray(rt))rt.forEach(Ne);else if(typeof rt=="string")Se();else{const Dt=rt;typeof Dt.scheme>"u"&&Se(),typeof Dt.exclusive=="boolean"&&(0,ze.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),ki={getSession(ge,Se,Ne){return ni.getSession(Ue,ge,Se,Ne)},getSessions(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"authGetSessions"),ni.getSessions(Ue,ge,Se)},async hasSession(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"authSession"),!!await ni.getSession(Ue,ge,Se,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(ge,Se,Ne,rt){return ni.registerAuthenticationProvider(ge,Se,Ne,rt)}},Yi={registerCommand(ge,Se,Ne){return vt.registerCommand(!0,ge,Se,Ne,void 0,Ue)},registerTextEditorCommand(ge,Se,Ne){return vt.registerCommand(!0,ge,(...rt)=>{const Dt=Ot.getActiveTextEditor();if(!Dt){Be.warn("Cannot execute "+ge+" because there is no active text editor.");return}return Dt.edit(Lt=>{Se.apply(Ne,[Dt,Lt,...rt])}).then(Lt=>{Lt||Be.warn("Edits from command "+ge+" were not applied.")},Lt=>{Be.warn("An error occurred while running command "+ge,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ge,Se,Ne)=>((0,ze.checkProposedApiEnabled)(Ue,"diffCommand"),vt.registerCommand(!0,ge,async(...rt)=>{const Dt=lt.activeEditor(!0);if(!Dt){Be.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(Dt.id);Se.apply(Ne,[Lt,...rt])},void 0,void 0,Ue)),executeCommand(ge,...Se){return vt.executeCommand(ge,...Se)},getCommands(ge=!1){return vt.getCommands(ge)}},Pi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return(0,ze.checkProposedApiEnabled)(Ue,"envShellEvent"),Et.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(Ue,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(Ue,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,Se){return nt.ExtHostTelemetryLogger.validateSender(ge),It.instantiateLogger(Ue,ge,Se)},openExternal(ge,Se){return it.openUri(ge,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===gt.environment.appUriScheme)return Ei.createAppUri(ge);try{return await it.asExternalUri(ge,{allowTunneling:!!gt.remote.authority})}catch(Se){if((0,K.matchesScheme)(ge,Ie.Schemas.http)||(0,K.matchesScheme)(ge,Ie.Schemas.https))return ge;throw Se}},get remoteName(){return(0,ve.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,ze.checkProposedApiEnabled)(Ue,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Be.getLevel()},get onDidChangeLogLevel(){return Be.onDidChangeLogLevel},registerIssueUriRequestHandler(ge){return(0,ze.checkProposedApiEnabled)(Ue,"handleIssueUri"),Gi.registerIssueUriRequestHandler(Ue,ge)},get appQuality(){return(0,ze.checkProposedApiEnabled)(Ue,"resolvers"),gt.quality},get appCommit(){return(0,ze.checkProposedApiEnabled)(Ue,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Pi);const Ji={createTestController(ge,Se,Ne){return ri.createTestController(Ue,ge,Se,Ne)},createTestObserver(){return(0,ze.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,ze.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,ze.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,ze.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},pi=gt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Zi={getExtension(ge,Se){(0,ze.isProposedApiEnabled)(Ue,"extensionsAny")||(Se=!1);const Ne=Yt.mine.getExtensionDescription(ge);if(Ne)return new s.Extension(_t,Ue.identifier,Ne,pi,!1);if(Se){const rt=Yt.all.getExtensionDescription(ge);if(rt)return new s.Extension(_t,Ue.identifier,rt,pi,!0)}},get all(){const ge=[];for(const Se of Yt.mine.getAllExtensionDescriptions())ge.push(new s.Extension(_t,Ue.identifier,Se,pi,!1));return ge},get allAcrossExtensionHosts(){(0,ze.checkProposedApiEnabled)(Ue,"extensionsAny");const ge=new ae.ExtensionIdentifierSet(Yt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),Se=[];for(const Ne of Yt.all.getAllExtensionDescriptions()){const rt=!ge.has(Ne.identifier);Se.push(new s.Extension(_t,Ue.identifier,Ne,pi,rt))}return Se},get onDidChange(){return(0,ze.isProposedApiEnabled)(Ue,"extensionsAny")?l.Event.any(Yt.mine.onDidChange,Yt.all.onDidChange):Yt.mine.onDidChange}},en={createDiagnosticCollection(ge){return ci.createDiagnosticCollection(Ue.identifier,ge)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:ge=>ci.getDiagnostics(ge),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(ge,Se){return li.changeLanguage(ge.uri,Se)},match(ge,Se){const Ne=At.getDocumentData(Se.uri)?.notebook;return(0,T.score)(x.LanguageSelector.from(ge),Se.uri,Se.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ge,Se,Ne){return dt.registerCodeActionProvider(Ue,pt(ge),Se,Ne)},registerDocumentPasteEditProvider(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,pt(ge),Se,Ne)},registerCodeLensProvider(ge,Se){return dt.registerCodeLensProvider(Ue,pt(ge),Se)},registerDefinitionProvider(ge,Se){return dt.registerDefinitionProvider(Ue,pt(ge),Se)},registerDeclarationProvider(ge,Se){return dt.registerDeclarationProvider(Ue,pt(ge),Se)},registerImplementationProvider(ge,Se){return dt.registerImplementationProvider(Ue,pt(ge),Se)},registerTypeDefinitionProvider(ge,Se){return dt.registerTypeDefinitionProvider(Ue,pt(ge),Se)},registerHoverProvider(ge,Se){return dt.registerHoverProvider(Ue,pt(ge),Se,Ue.identifier)},registerEvaluatableExpressionProvider(ge,Se){return dt.registerEvaluatableExpressionProvider(Ue,pt(ge),Se,Ue.identifier)},registerInlineValuesProvider(ge,Se){return dt.registerInlineValuesProvider(Ue,pt(ge),Se,Ue.identifier)},registerDocumentHighlightProvider(ge,Se){return dt.registerDocumentHighlightProvider(Ue,pt(ge),Se)},registerLinkedEditingRangeProvider(ge,Se){return dt.registerLinkedEditingRangeProvider(Ue,pt(ge),Se)},registerReferenceProvider(ge,Se){return dt.registerReferenceProvider(Ue,pt(ge),Se)},registerRenameProvider(ge,Se){return dt.registerRenameProvider(Ue,pt(ge),Se)},registerDocumentSymbolProvider(ge,Se,Ne){return dt.registerDocumentSymbolProvider(Ue,pt(ge),Se,Ne)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider(Ue,ge)},registerDocumentFormattingEditProvider(ge,Se){return dt.registerDocumentFormattingEditProvider(Ue,pt(ge),Se)},registerDocumentRangeFormattingEditProvider(ge,Se){return dt.registerDocumentRangeFormattingEditProvider(Ue,pt(ge),Se)},registerOnTypeFormattingEditProvider(ge,Se,Ne,...rt){return dt.registerOnTypeFormattingEditProvider(Ue,pt(ge),Se,[Ne].concat(rt))},registerDocumentSemanticTokensProvider(ge,Se,Ne){return dt.registerDocumentSemanticTokensProvider(Ue,pt(ge),Se,Ne)},registerDocumentRangeSemanticTokensProvider(ge,Se,Ne){return dt.registerDocumentRangeSemanticTokensProvider(Ue,pt(ge),Se,Ne)},registerSignatureHelpProvider(ge,Se,Ne,...rt){return typeof Ne=="object"?dt.registerSignatureHelpProvider(Ue,pt(ge),Se,Ne):dt.registerSignatureHelpProvider(Ue,pt(ge),Se,typeof Ne>"u"?[]:[Ne,...rt])},registerCompletionItemProvider(ge,Se,...Ne){return dt.registerCompletionItemProvider(Ue,pt(ge),Se,Ne)},registerInlineCompletionItemProvider(ge,Se){return Se.handleDidShowCompletionItem&&(0,ze.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,ze.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,pt(ge),Se)},registerDocumentLinkProvider(ge,Se){return dt.registerDocumentLinkProvider(Ue,pt(ge),Se)},registerColorProvider(ge,Se){return dt.registerColorProvider(Ue,pt(ge),Se)},registerFoldingRangeProvider(ge,Se){return dt.registerFoldingRangeProvider(Ue,pt(ge),Se)},registerSelectionRangeProvider(ge,Se){return dt.registerSelectionRangeProvider(Ue,ge,Se)},registerCallHierarchyProvider(ge,Se){return dt.registerCallHierarchyProvider(Ue,ge,Se)},registerTypeHierarchyProvider(ge,Se){return dt.registerTypeHierarchyProvider(Ue,ge,Se)},setLanguageConfiguration:(ge,Se)=>dt.setLanguageConfiguration(Ue,ge,Se),getTokenInformationAtPosition(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"tokenInformation"),li.tokenAtPosition(ge,Se)},registerInlayHintsProvider(ge,Se){return dt.registerInlayHintsProvider(Ue,ge,Se)},createLanguageStatusItem(ge,Se){return li.createLanguageStatusItem(Ue,ge,Se)},registerDocumentDropEditProvider(ge,Se,Ne){return dt.registerDocumentOnDropEditProvider(Ue,ge,Se,(0,ze.isProposedApiEnabled)(Ue,"dropMetadata")?Ne:void 0)}},Jt={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ge,Se,Ne){const rt=await(R.URI.isUri(ge)?Promise.resolve(ui.openTextDocument(ge)):Promise.resolve(ge));return Ot.showTextDocument(rt,Se,Ne)},createTextEditorDecorationType(ge){return Ot.createTextEditorDecorationType(Ue,ge)},onDidChangeActiveTextEditor(ge,Se,Ne){return Ot.onDidChangeActiveTextEditor(ge,Se,Ne)},onDidChangeVisibleTextEditors(ge,Se,Ne){return Ot.onDidChangeVisibleTextEditors(ge,Se,Ne)},onDidChangeTextEditorSelection(ge,Se,Ne){return Ot.onDidChangeTextEditorSelection(ge,Se,Ne)},onDidChangeTextEditorOptions(ge,Se,Ne){return Ot.onDidChangeTextEditorOptions(ge,Se,Ne)},onDidChangeTextEditorVisibleRanges(ge,Se,Ne){return Ot.onDidChangeTextEditorVisibleRanges(ge,Se,Ne)},onDidChangeTextEditorViewColumn(ge,Se,Ne){return Ot.onDidChangeTextEditorViewColumn(ge,Se,Ne)},onDidCloseTerminal(ge,Se,Ne){return Et.onDidCloseTerminal(ge,Se,Ne)},onDidOpenTerminal(ge,Se,Ne){return Et.onDidOpenTerminal(ge,Se,Ne)},onDidChangeActiveTerminal(ge,Se,Ne){return Et.onDidChangeActiveTerminal(ge,Se,Ne)},onDidChangeTerminalDimensions(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(Ue,"terminalDimensions"),Et.onDidChangeTerminalDimensions(ge,Se,Ne)},onDidChangeTerminalState(ge,Se,Ne){return Et.onDidChangeTerminalState(ge,Se,Ne)},onDidWriteTerminalData(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Et.onDidWriteTerminalData(ge,Se,Ne)},get state(){return it.getState(Ue)},onDidChangeWindowState(ge,Se,Ne){return it.onDidChangeWindowState(ge,Se,Ne)},showInformationMessage(ge,...Se){return Ii.showMessage(Ue,L.default.Info,ge,Se[0],Se.slice(1))},showWarningMessage(ge,...Se){return Ii.showMessage(Ue,L.default.Warning,ge,Se[0],Se.slice(1))},showErrorMessage(ge,...Se){return Ii.showMessage(Ue,L.default.Error,ge,Se[0],Se.slice(1))},showQuickPick(ge,Se,Ne){return Kt.showQuickPick(Ue,ge,Se,Ne)},showWorkspaceFolderPick(ge){return Kt.showWorkspaceFolderPick(ge)},showInputBox(ge,Se){return Kt.showInput(ge,Se)},showOpenDialog(ge){return gi.showOpenDialog(Ue,ge)},showSaveDialog(ge){return gi.showSaveDialog(ge)},createStatusBarItem(ge,Se,Ne){let rt,Dt,Lt;return typeof ge=="string"?(rt=ge,Dt=Se,Lt=Ne):(Dt=ge,Lt=Se),Di.createStatusBarEntry(Ue,rt,Dt,Lt)},setStatusBarMessage(ge,Se){return Di.setStatusBarMessage(ge,Se)},withScmProgress(ge){return qe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),yi.withProgress(Ue,{location:W.ProgressLocation.SourceControl},(Se,Ne)=>ge({report(rt){}}))},withProgress(ge,Se){return yi.withProgress(Ue,ge,Se)},createOutputChannel(ge,Se){return Li.createOutputChannel(ge,Se,Ue)},createWebviewPanel(ge,Se,Ne,rt){return mi.createWebviewPanel(Ue,ge,Se,Ne,rt)},createWebviewTextEditorInset(ge,Se,Ne,rt){return(0,ze.checkProposedApiEnabled)(Ue,"editorInsets"),Qt.createWebviewEditorInset(ge,Se,Ne,rt,Ue)},createTerminal(ge,Se,Ne){return typeof ge=="object"?"pty"in ge?Et.createExtensionTerminal(ge):Et.createTerminalFromOptions(ge):Et.createTerminal(ge,Se,Ne)},registerTerminalLinkProvider(ge){return Et.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Se){return Et.registerProfileProvider(Ue,ge,Se)},registerTerminalQuickFixProvider(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(ge,Ue.identifier.value,Se)},registerTreeDataProvider(ge,Se){return Si.registerTreeDataProvider(ge,Se,Ue)},createTreeView(ge,Se){return Si.createTreeView(ge,Se,Ue)},registerWebviewPanelSerializer:(ge,Se)=>mi.registerWebviewPanelSerializer(Ue,ge,Se),registerCustomEditorProvider:(ge,Se,Ne={})=>zi.registerCustomEditorProvider(Ue,ge,Se,Ne),registerFileDecorationProvider(ge){return wt.registerFileDecorationProvider(ge,Ue)},registerUriHandler(ge){return Ei.registerUriHandler(Ue,ge)},createQuickPick(){return Kt.createQuickPick(Ue)},createInputBox(){return Kt.createInputBox(Ue)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(ge,Se,Ne){return Ci.onDidChangeActiveColorTheme(ge,Se,Ne)},registerWebviewViewProvider(ge,Se,Ne){return $i.registerWebviewViewProvider(Ue,ge,Se,Ne?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Se,Ne){return Ct.onDidChangeActiveNotebookEditor(ge,Se,Ne)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Se,Ne){return wi.onDidChangeNotebookEditorSelection(ge,Se,Ne)},onDidChangeNotebookEditorVisibleRanges(ge,Se,Ne){return wi.onDidChangeNotebookEditorVisibleRanges(ge,Se,Ne)},showNotebookDocument(ge,Se){return Ct.showNotebookDocument(ge,Se)},registerExternalUriOpener(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(Ue,"externalUriOpener"),Hi.registerExternalUriOpener(Ue.identifier,ge,Se,Ne)},registerProfileContentHandler(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Vi.registrProfileContentHandler(Ue,ge,Se)},registerQuickDiffProvider(ge,Se,Ne,rt){return(0,ze.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ni.registerQuickDiffProvider(pt(ge),Se,Ne,rt)},get tabGroups(){return Rt.tabGroups},registerShareProvider(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"shareProvider"),xi.registerShareProvider(pt(ge),Se)}},ui={get rootPath(){return qe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw A.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw A.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw A.readonly()},updateWorkspaceFolders:(ge,Se,...Ne)=>mt.updateWorkspaceFolders(Ue,ge,Se||0,...Ne),onDidChangeWorkspaceFolders:function(ge,Se,Ne){return mt.onDidChangeWorkspace(ge,Se,Ne)},asRelativePath:(ge,Se)=>mt.getRelativePath(ge,Se),findFiles:(ge,Se,Ne,rt)=>mt.findFiles(ge,Se,Ne,Ue.identifier,rt),findTextInFiles:(ge,Se,Ne,rt)=>{(0,ze.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Lt;return typeof Se=="object"?(Dt=Se,Lt=Ne):(Dt={},Lt=Se,rt=Ne),mt.findTextInFiles(ge,Dt||{},Lt,Ue.identifier,rt)},save:ge=>((0,ze.checkProposedApiEnabled)(Ue,"saveEditor"),mt.save(ge)),saveAs:ge=>((0,ze.checkProposedApiEnabled)(Ue,"saveEditor"),mt.saveAs(ge)),saveAll:ge=>mt.saveAll(ge),applyEdit(ge,Se){return Xi.applyWorkspaceEdit(ge,Ue,Se)},createFileSystemWatcher:(ge,Se,Ne,rt)=>ei.createFileSystemWatcher(mt,Ue,ge,Se,Ne,rt),get textDocuments(){return At.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw A.readonly()},openTextDocument(ge){let Se;const Ne=ge;if(typeof ge=="string")Se=Promise.resolve(R.URI.file(ge));else if(R.URI.isUri(ge))Se=Promise.resolve(ge);else if(!Ne||typeof Ne=="object")Se=At.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(rt=>At.ensureDocumentData(rt).then(Dt=>Dt.document))},onDidOpenTextDocument:(ge,Se,Ne)=>At.onDidAddDocument(ge,Se,Ne),onDidCloseTextDocument:(ge,Se,Ne)=>At.onDidRemoveDocument(ge,Se,Ne),onDidChangeTextDocument:(ge,Se,Ne)=>At.onDidChangeDocument(ge,Se,Ne),onDidSaveTextDocument:(ge,Se,Ne)=>At.onDidSaveDocument(ge,Se,Ne),onWillSaveTextDocument:(ge,Se,Ne)=>ai.getOnWillSaveTextDocumentEvent(Ue)(ge,Se,Ne),get notebookDocuments(){return Ct.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Se){let Ne;if(R.URI.isUri(ge))Ne=ge,await Ct.openNotebookDocument(ge);else if(typeof ge=="string")Ne=R.URI.revive(await Ct.createNotebookDocument({viewType:ge,content:Se}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ge,Se,Ne){return di.onDidSaveNotebookDocument(ge,Se,Ne)},onDidChangeNotebookDocument(ge,Se,Ne){return di.onDidChangeNotebookDocument(ge,Se,Ne)},onWillSaveNotebookDocument(ge,Se,Ne){return Oi.getOnWillSaveNotebookDocumentEvent(Ue)(ge,Se,Ne)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Se,Ne,rt){return Ct.registerNotebookSerializer(Ue,ge,Se,Ne,(0,ze.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ge,Se,Ne)=>Qi.onDidChangeConfiguration(ge,Se,Ne),getConfiguration(ge,Se){return Se=arguments.length===1?void 0:Se,Qi.getConfiguration(ge,Se,Ue)},registerTextDocumentContentProvider(ge,Se){return Fi.registerTextDocumentContentProvider(ge,Se)},registerTaskProvider:(ge,Se)=>(qe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Ue,ge,Se)),registerFileSystemProvider(ge,Se,Ne){return(0,We.combinedDisposable)(Mi.registerFileSystemProvider(Ue,ge,Se,Ne),Ut.addFileSystemProvider(ge,Se))},get fs(){return Ut.value},registerFileSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(Ue,"fileSearchProvider"),oi.registerFileSearchProvider(ge,Se)),registerTextSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(Ue,"textSearchProvider"),oi.registerTextSearchProvider(ge,Se)),registerRemoteAuthorityResolver:(ge,Se)=>((0,ze.checkProposedApiEnabled)(Ue,"resolvers"),_t.registerRemoteAuthorityResolver(ge,Se)),registerResourceLabelFormatter:ge=>((0,ze.checkProposedApiEnabled)(Ue,"resolvers"),Wi.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Se,Ne)=>ei.onDidCreateFile(ge,Se,Ne),onDidDeleteFiles:(ge,Se,Ne)=>ei.onDidDeleteFile(ge,Se,Ne),onDidRenameFiles:(ge,Se,Ne)=>ei.onDidRenameFile(ge,Se,Ne),onWillCreateFiles:(ge,Se,Ne)=>ei.getOnWillCreateFileEvent(Ue)(ge,Se,Ne),onWillDeleteFiles:(ge,Se,Ne)=>ei.getOnWillDeleteFileEvent(Ue)(ge,Se,Ne),onWillRenameFiles:(ge,Se,Ne)=>ei.getOnWillRenameFileEvent(Ue)(ge,Se,Ne),openTunnel:ge=>((0,ze.checkProposedApiEnabled)(Ue,"tunnels"),Qe.openTunnel(Ue,ge).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,ze.checkProposedApiEnabled)(Ue,"tunnels"),Qe.getTunnels()},onDidChangeTunnels:(ge,Se,Ne)=>((0,ze.checkProposedApiEnabled)(Ue,"tunnels"),Qe.onDidChangeTunnels(ge,Se,Ne)),registerPortAttributesProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(Ue,"portsAttributes"),Qe.registerPortsAttributesProvider(ge,Se)),registerTimelineProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(Ue,"timeline"),Bi.registerTimelineProvider(ge,Se,Ue.identifier,vt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,ze.checkProposedApiEnabled)(Ue,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Se,Ne)=>mt.onDidGrantWorkspaceTrust(ge,Se,Ne),registerEditSessionIdentityProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,Se)),onWillCreateEditSessionIdentity:(ge,Se,Ne)=>((0,ze.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(Ue)(ge,Se,Ne)),registerCanonicalUriProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),mt.registerCanonicalUriProvider(ge,Se)),getCanonicalUri:(ge,Se,Ne)=>((0,ze.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),mt.provideCanonicalUri(ge,Se,Ne))},un={get inputBox(){return qe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),_i.getLastInputBox(Ue)},createSourceControl(ge,Se,Ne){return _i.createSourceControl(Ue,ge,Se,Ne)}},Vt={createCommentController(ge,Se){return Ui.createCommentController(Ue,ge,Se)}},vi={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},onDidStartDebugSession(ge,Se,Ne){return St.onDidStartDebugSession(ge,Se,Ne)},onDidTerminateDebugSession(ge,Se,Ne){return St.onDidTerminateDebugSession(ge,Se,Ne)},onDidChangeActiveDebugSession(ge,Se,Ne){return St.onDidChangeActiveDebugSession(ge,Se,Ne)},onDidReceiveDebugSessionCustomEvent(ge,Se,Ne){return St.onDidReceiveDebugSessionCustomEvent(ge,Se,Ne)},onDidChangeBreakpoints(ge,Se,Ne){return St.onDidChangeBreakpoints(ge,Se,Ne)},onDidChangeStackFrameFocus(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(Ue,"debugFocus"),St.onDidChangeStackFrameFocus(ge,Se,Ne)},registerDebugConfigurationProvider(ge,Se,Ne){return St.registerDebugConfigurationProvider(ge,Se,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Se){return St.registerDebugAdapterDescriptorFactory(Ue,ge,Se)},registerDebugAdapterTrackerFactory(ge,Se){return St.registerDebugAdapterTrackerFactory(ge,Se)},startDebugging(ge,Se,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?St.startDebugging(ge,Se,{parentSession:Ne}):St.startDebugging(ge,Se,Ne||{})},stopDebugging(ge){return St.stopDebugging(ge)},addBreakpoints(ge){return St.addBreakpoints(ge)},removeBreakpoints(ge){return St.removeBreakpoints(ge)},asDebugSourceUri(ge,Se){return St.asDebugSourceUri(ge,Se)}},tn={registerTaskProvider:(ge,Se)=>Ht.registerTaskProvider(Ue,ge,Se),fetchTasks:ge=>Ht.fetchTasks(ge),executeTask:ge=>Ht.executeTask(Ue,ge),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ge,Se,Ne)=>Ht.onDidStartTask(ge,Se,Ne),onDidEndTask:(ge,Se,Ne)=>Ht.onDidEndTask(ge,Se,Ne),onDidStartTaskProcess:(ge,Se,Ne)=>Ht.onDidStartTaskProcess(ge,Se,Ne),onDidEndTaskProcess:(ge,Se,Ne)=>Ht.onDidEndTaskProcess(ge,Se,Ne)},nn={createNotebookController(ge,Se,Ne,rt,Dt){return hi.createNotebookController(Ue,ge,Se,Ne,rt,(0,ze.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Se)=>Ct.registerNotebookCellStatusBarItemProvider(Ue,ge,Se),createRendererMessaging(ge){return cn.createRendererMessaging(Ue,ge)},createNotebookControllerDetectionTask(ge){return(0,ze.checkProposedApiEnabled)(Ue,"notebookKernelSource"),hi.createNotebookControllerDetectionTask(Ue,ge)},registerKernelSourceActionProvider(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"notebookKernelSource"),hi.registerKernelSourceActionProvider(Ue,ge,Se)},onDidChangeNotebookCellExecutionState(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),hi.onDidChangeNotebookCellExecutionState(ge,Se,Ne)}},rn={t(...ge){if(typeof ge[0]=="string"){const Se=ge.shift(),Ne=!ge||typeof ge[0]!="object"?ge:ge[0];return Gt.getMessage(Ue.identifier.value,{message:Se,args:Ne})}return Gt.getMessage(Ue.identifier.value,ge[0])},get bundle(){return Gt.getBundle(Ue.identifier.value)},get uri(){return Gt.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(ge){return(0,ze.checkProposedApiEnabled)(Ue,"interactive"),ji.registerProvider(Ue,ge)},registerInteractiveSessionProvider(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"interactive"),si.registerChatProvider(Ue,ge,Se)},addInteractiveRequest(ge){return(0,ze.checkProposedApiEnabled)(Ue,"interactive"),si.addChatRequest(ge)},sendInteractiveRequestToProvider(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"interactive"),si.sendInteractiveRequestToProvider(ge,Se)},get onDidPerformUserAction(){return(0,ze.checkProposedApiEnabled)(Ue,"interactiveUserActions"),si.onDidPerformUserAction}},dn={registerSlashCommandProvider(ge,Se){return(0,ze.checkProposedApiEnabled)(Ue,"interactiveSlashCommands"),si.registerSlashCommandProvider(Ue,ge,Se)}},on={registerSemanticSimilarityProvider(ge){return(0,ze.checkProposedApiEnabled)(Ue,"semanticSimilarity"),qi.registerSemanticSimilarityProvider(Ue,ge)}};return{version:gt.version,ai:on,authentication:ki,commands:Yi,comments:Vt,debug:vi,env:Pi,extensions:Zi,interactive:sn,interactiveSlashCommands:dn,l10n:rn,languages:en,notebooks:nn,scm:un,tasks:tn,tests:Ji,window:Jt,workspace:ui,Breakpoint:W.Breakpoint,TerminalOutputAnchor:W.TerminalOutputAnchor,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentState:W.CommentState,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileDecoration2:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestionList,Hover:W.Hover,IndentAction:g.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalQuickFixCommand:W.TerminalQuickFixCommand,TerminalQuickFixOpener:W.TerminalQuickFixOpener,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TerminalExitReason:W.TerminalExitReason,TerminalQuickFixType:W.TerminalQuickFixType,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,SnippetTextEdit:W.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItem2:W.TreeItem,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:D.UIKind,Uri:R.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,DocumentDropEdit:W.DocumentDropEdit,DocumentPasteEdit:W.DocumentPasteEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,ManagedResolvedAuthority:W.ManagedResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.NotebookEdit,NotebookKernelSourceAction:W.NotebookKernelSourceAction,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestRunRequest2:W.TestRunRequest2,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:et.TextSearchCompleteMessageType,DataTransfer:W.DataTransfer,DataTransferItem:W.DataTransferItem,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.TextTabInput,TabInputTextDiff:W.TextDiffTabInput,TabInputTextMerge:W.TextMergeTabInput,TabInputCustom:W.CustomEditorTabInput,TabInputNotebook:W.NotebookEditorTabInput,TabInputNotebookDiff:W.NotebookDiffEditorTabInput,TabInputWebview:W.WebviewEditorTabInput,TabInputTerminal:W.TerminalEditorTabInput,TabInputInteractiveWindow:W.InteractiveWindowInput,TelemetryTrustedValue:ee.TelemetryTrustedValue,LogLevel:Z.LogLevel,EditSessionIdentityMatch:st.EditSessionIdentityMatch,InteractiveSessionVoteDirection:W.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:W.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:W.InteractiveEditorResponseFeedbackKind,StackFrameFocus:W.StackFrameFocus,ThreadFocus:W.ThreadFocus,NotebookCodeActionKind:W.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=$t}),define(ye[332],Ce([1,0,97,145,37,142,38,36,62,43,87,89,90,107,58,83,144,64,50,106,82,63,143,17,51,104,105]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t,a,r,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,c.registerSingleton)(a.ILoggerService,t.ExtHostLoggerService,1),(0,c.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,c.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,c.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,c.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,c.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(f.IExtHostManagedSockets,f.ExtHostManagedSockets,0),(0,c.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,c.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,c.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,c.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask,0),(0,c.registerSingleton)(g.IExtHostTerminalService,g.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(S.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(n.IExtHostWindow,n.ExtHostWindow,0),(0,c.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,c.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,c.registerSingleton)(E.IExtHostTelemetry,E.ExtHostTelemetry,0),(0,c.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,c.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(ye[108],Ce([1,0,19,17,34,86]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=R;function P(k,m,D,S){const v=(0,c.mapArrayOrNot)(D,_),n=new l.TextSearchMatch(m,v,S),h=n.preview.matches;return{ranges:(0,c.mapArrayOrNot)(v,g),uri:k,preview:{text:n.preview.text,matches:(0,c.mapArrayOrNot)(h,g)}}}e.createTextSearchResult=P;function _(k){return new l.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function g(k){return new L.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=e.OutputChannel=class{constructor(m,D){this.prefix=m,this.logService=D}appendLine(m){this.logService.debug(`${this.prefix}#search`,m)}};e.OutputChannel=T=je([$e(1,A.ILogService)],T)}),define(ye[333],Ce([1,0,46,10,69,30,9,11,108,334]),function(re,e,c,A,l,L,R,P,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const T=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(w,E,p,t){const a=m(w,E,p,t),r=E.folder.fsPath;return{cmd:c.spawn(T,a.args,{cwd:r}),rgDiskPath:T,siblingClauses:a.siblingClauses,rgArgs:a,cwd:r}}e.spawnRipgrepCmd=k;function m(w,E,p,t){const a=["--files","--hidden","--case-sensitive"];S([E],p,!1).forEach(s=>{const f=(0,_.anchorGlob)(s);if(a.push("-g",f),R.isMacintosh){const b=(0,l.normalizeNFD)(f);b!==f&&a.push("-g",b)}});const r=D([E],t,void 0,!1);return r.globArgs.forEach(s=>{const f=`!${(0,_.anchorGlob)(s)}`;if(a.push("-g",f),R.isMacintosh){const b=(0,l.normalizeNFD)(f);b!==f&&a.push("-g",b)}}),E.disregardIgnoreFiles!==!1?a.push("--no-ignore"):E.disregardParentIgnoreFiles!==!1&&a.push("--no-ignore-parent"),E.ignoreSymlinks||a.push("--follow"),w.exists&&a.push("--quiet"),a.push("--no-config"),E.disregardGlobalIgnoreFiles&&a.push("--no-ignore-global"),{args:a,siblingClauses:r.siblingClauses}}function D(w,E,p,t=!0){const a=[];let r={};return w.forEach(s=>{const f=Object.assign({},s.excludePattern||{},E||{}),b=v(f,t?s.folder.fsPath:void 0,p);a.push(...b.globArgs),b.siblingClauses&&(r=Object.assign(r,b.siblingClauses))}),{globArgs:a,siblingClauses:r}}function S(w,E,p=!0){const t=[];return w.forEach(a=>{const r=Object.assign({},E||{},a.includePattern||{}),s=v(r,p?a.folder.fsPath:void 0);t.push(...s.globArgs)}),t}function v(w,E,p){const t=[],a={};return Object.keys(w).forEach(r=>{if(p&&p.has(r)||!r)return;const s=w[r];r=h(E?n(E,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof s=="boolean"&&s?(r.startsWith("\\\\")&&(r+="**"),t.push(d(r))):s&&s.when&&(a[r]=s)}),{globArgs:t,siblingClauses:a}}function n(w,E){return A.isAbsolute(E)?E:A.join(w,E)}e.getAbsoluteGlob=n;function h(w){return w=P.rtrim(w,"\\"),P.rtrim(w,"/")}function d(w){return L.getRoot(w).toLowerCase()==="c:/"?w.replace(/^c:[/\\]/i,"/"):w}e.fixDriveC=d}),define(ye[335],Ce([1,0,46,48,10,336,19,45,33,69,30,9,40,11,12,29,34,333,117]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const w=new Set;process.on("exit",()=>{w.forEach(r=>r())});class E{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&_.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,d.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&_.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(f=>{const b=Object.assign({},f.excludePattern||{},this.config.excludePattern||{}),u=f.folder.fsPath;s.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==u).forEach(C=>{(0,T.isEqualOrParent)(C,u)&&(b[l.relative(u,C)]=!0)}),this.folderExcludePatterns.set(u,new t(b,u))})}cancel(){this.isCanceled=!0,w.forEach(s=>s())}walk(s,f,b,u,C){if(this.fileWalkSW=m.StopWatch.create(!1),this.isCanceled)return C(null,this.isLimitHit);f.forEach(y=>{const o=l.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,o)||this.matchFile(b,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=m.StopWatch.create(!1),this.parallel(s,(y,o)=>{this.call(this.cmdTraversal,this,y,b,u,i=>{if(i){const I=(0,P.toErrorMessage)(i);console.error(I),this.errors.push(I),o(i,void 0)}else o(null,void 0)})},(y,o)=>{this.fileWalkSW.stop();const i=y?R.coalesce(y)[0]:null;C(i,this.isLimitHit)})}parallel(s,f,b){const u=new Array(s.length),C=new Array(s.length);let y=!1,o=0;if(s.length===0)return b(null,[]);s.forEach((i,I)=>{f(i,(F,U)=>{if(F?(y=!0,u[I]=null,C[I]=F):(u[I]=U,C[I]=null),++o===s.length)return b(y?C:null,u)})})}call(s,f,...b){try{s.apply(f,b)}catch(u){b[b.length-1](u)}}cmdTraversal(s,f,b,u){const C=s.folder.fsPath,y=k.isMacintosh,o=()=>$&&$.kill();w.add(o);let i=x=>{w.delete(o),i=()=>{},u(x)},I="";const F=this.initDirectoryTree(),U=(0,h.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression),$=U.cmd,B=!Object.keys(U.siblingClauses).length,N=U.rgArgs.args.map(x=>x.match(/^-/)?x:`'${x}'`).join(" ");let V=`${U.rgDiskPath} ${N}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),b({message:V}),this.cmdResultCount=0,this.collectStdout($,"utf8",b,(x,W,ee)=>{if(x){i(x);return}if(this.isLimitHit){i();return}const H=(I+(y?g.normalizeNFC(W||""):W)).split(`
`);if(ee){const J=H.length;H[J-1]=H[J-1].trim(),H[J-1]||H.pop()}else I=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){i(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,B){for(const J of H)if(this.matchFile(f,{base:C,relativePath:J,searchPath:this.getSearchPath(s,J)}),this.isLimitHit){o();break}(ee||this.isLimitHit)&&i();return}this.addDirectoryEntries(s,F,C,H,f),ee&&(this.matchDirectoryTree(F,C,f),i())})}spawnFindCmd(s){const f=this.folderExcludePatterns.get(s.folder.fsPath),b=f.getBasenameTerms(),u=f.getPathTerms(),C=["-L","."];if(b.length||u.length){C.push("-not","(","(");for(const y of b)C.push("-name",y),C.push("-o");for(const y of u)C.push("-path",y),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),c.spawn("find",C,{cwd:s.folder.fsPath})}readStdout(s,f,b){let u="";this.collectStdout(s,f,()=>{},(C,y,o)=>{if(C){b(C);return}u+=y,o&&b(null,u)})}collectStdout(s,f,b,u){let C=(i,I,F)=>{(i||F)&&(C=()=>{},this.cmdSW?.stop()),u(i,I,F)},y=!1;s.stdout?(this.forwardData(s.stdout,f,C),s.stdout.once("data",()=>y=!0)):b({message:"stdout is null"});let o;s.stderr?o=this.collectData(s.stderr):b({message:"stderr is null"}),s.on("error",i=>{C(i)}),s.on("close",i=>{let I;!y&&(I=this.decodeData(o,f))&&a(I)?C(new Error(`command failed with error code ${i}: ${this.decodeData(o,f)}`)):(this.exists&&i===0&&(this.isLimitHit=!0),C(null,"",!0))})}forwardData(s,f,b){const u=new L.StringDecoder(f);return s.on("data",C=>{b(null,u.write(C))}),u}collectData(s){const f=[];return s.on("data",b=>{f.push(b)}),f}decodeData(s,f){const b=new L.StringDecoder(f);return s.map(u=>b.write(u)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:f},b,u,C){u.indexOf(this.filePattern)!==-1&&this.matchFile(C,{base:b,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const y=o=>{const i=l.basename(o),I=l.dirname(o);let F=f[I];F||(F=f[I]=[],y(I)),F.push({base:b,relativePath:o,basename:i,searchPath:this.getSearchPath(s,o)})};u.forEach(y)}matchDirectoryTree({rootEntries:s,pathToEntries:f},b,u){const C=this,y=this.folderExcludePatterns.get(b),o=this.filePattern;function i(I){C.directoriesWalked++;const F=(0,n.hasSiblingFn)(()=>I.map(U=>U.basename));for(let U=0,$=I.length;U<$;U++){const B=I[U],{relativePath:N,basename:V}=B;if(y.test(N,V,o!==V?F:void 0))continue;const x=f[N];if(x)i(x);else{if(C.filesWalked++,N===o)continue;C.matchFile(u,B)}if(C.isLimitHit)break}}i(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,f,b,u,C){const y=s.folder,o=(0,n.hasSiblingFn)(()=>b);this.parallel(b,(i,I)=>{if(this.isCanceled||this.isLimitHit)return I(null);const F=f?[f,i].join(l.sep):i;if(this.folderExcludePatterns.get(s.folder.fsPath).test(F,i,this.config.filePattern!==i?o:void 0))return I(null);const U=[y.fsPath,F].join(l.sep);A.lstat(U,($,B)=>{if($||this.isCanceled||this.isLimitHit)return I(null);this.statLinkIfNeeded(U,B,(N,V)=>N||this.isCanceled||this.isLimitHit?I(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(U,B,(x,W)=>x||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?I(null):(this.walkedPaths[W]=!0,v.Promises.readdir(U).then(ee=>{if(this.isCanceled||this.isLimitHit)return I(null);this.doWalk(s,F,ee,u,se=>I(se||null))},ee=>{I(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&S.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(u,{base:y.fsPath,relativePath:F,searchPath:this.getSearchPath(s,F)}),I(null,void 0)))})},i=>{const I=i&&R.coalesce(i);return C(I&&I.length>0?I[0]:void 0)})}matchFile(s,f){this.isFileMatch(f)&&(!this.includePattern||this.includePattern(f.relativePath,l.basename(f.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(f))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,n.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,f,b){return f.isSymbolicLink()?A.stat(s,b):b(null,f)}realPathIfNeeded(s,f,b){return f.isSymbolicLink()?A.realpath(s,(u,C)=>u?b(u):b(null,C)):b(null,s)}getSearchPath(s,f){return s.folderName?l.join(s.folderName,f):f}}e.FileWalker=E;class p{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new E(s)}search(s,f,b){this.walker.walk(this.folderQueries,this.extraFiles,s,f,(u,C)=>{b(u,{limitHit:C,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(s,f){this.expression=s,this.root=f,this.init(s)}init(s){let f,b;Object.keys(s).filter(u=>s[u]).forEach(u=>{l.isAbsolute(u)?(f=f||_.getEmptyExpression(),f[u]=s[u]):(b=b||_.getEmptyExpression(),b[u]=s[u])}),this.absoluteParsedExpr=f&&_.parse(f,{trimForExclusions:!0}),this.relativeParsedExpr=b&&_.parse(b,{trimForExclusions:!0})}test(s,f,b){return this.relativeParsedExpr&&this.relativeParsedExpr(s,f,b)||this.absoluteParsedExpr&&this.absoluteParsedExpr(l.join(this.root,s),f,b)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(..._.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(..._.getPathTerms(this.relativeParsedExpr)),s}}function a(r){const s=r.trim().split(`
`),f=s[0].trim();if(f.startsWith("Error parsing regex"))return f;if(f.startsWith("regex parse error"))return D.uppercaseFirstLetter(s[s.length-1].trim());if(f.startsWith("error parsing glob")||f.startsWith("unsupported encoding"))return f.charAt(0).toUpperCase()+f.substr(1);if(f==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(f.startsWith("Literal "))return f}}),define(ye[337],Ce([1,0,91,21]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const L=512,R=512,P=512*8,_=512*128;var g;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(g||(e.DecodeStreamErrorKind=g={}));class T extends Error{constructor(s,f){super(s),this.decodeStreamErrorKind=f}}e.DecodeStreamError=T;class k{static async create(s){let f;if(s!==e.UTF8)f=(await new Promise((u,C)=>{re(["@vscode/iconv-lite-umd"],u,C)})).getDecoder(v(s));else{const b=new TextDecoder;f={write(u){return b.decode(u,{stream:!0})},end(){return b.decode()}}}return new k(f)}constructor(s){this.iconvLiteDecoder=s}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function m(r,s){const f=s.minBytesRequiredForDetection??s.guessEncoding?P:R;return new Promise((b,u)=>{const C=(0,c.newWriteableStream)(U=>U.join("")),y=[];let o=0,i;const I=async()=>{try{const U=await a({buffer:A.VSBuffer.concat(y),bytesRead:o},s.guessEncoding);if(U.seemsBinary&&s.acceptTextOnly)throw new T("Stream is binary but only text is accepted for decoding",1);U.encoding=await s.overwriteEncoding(U.encoding),i=await k.create(U.encoding);const $=i.write(A.VSBuffer.concat(y).buffer);C.write($),y.length=0,o=0,b({stream:C,detected:U})}catch(U){F?.dispose(),C.destroy(),u(U)}},F=(0,c.listenStream)(r,{onData:async U=>{i?C.write(i.write(U.buffer)):(y.push(U),o+=U.byteLength,o>=f&&(r.pause(),await I(),setTimeout(()=>r.resume())))},onError:U=>C.error(U),onEnd:async()=>{i||await I(),C.end(i?.end())}})})}e.toDecodeStream=m;async function D(r,s,f){const u=(await new Promise((o,i)=>{re(["@vscode/iconv-lite-umd"],o,i)})).getEncoder(v(s),f);let C=!1,y=!1;return{read(){if(y)return null;const o=r.read();if(typeof o!="string"){if(y=!0,!C&&f?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const i=u.end();return i&&i.length>0?(C=!0,A.VSBuffer.wrap(i)):null}return C=!0,A.VSBuffer.wrap(u.write(o))}}}e.toEncodeReadable=D;async function S(r){return(await new Promise((f,b)=>{re(["@vscode/iconv-lite-umd"],f,b)})).encodingExists(v(r))}e.encodingExists=S;function v(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=v;function n(r,s){if(!r||s<e.UTF16be_BOM.length)return null;const f=r.readUInt8(0),b=r.readUInt8(1);if(f===e.UTF16be_BOM[0]&&b===e.UTF16be_BOM[1])return e.UTF16be;if(f===e.UTF16le_BOM[0]&&b===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const u=r.readUInt8(2);return f===e.UTF8_BOM[0]&&b===e.UTF8_BOM[1]&&u===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=n;const h=["ascii","utf-16","utf-32"];async function d(r){const s=await new Promise((y,o)=>{re(["jschardet"],y,o)}),f=r.slice(0,_),b=p(f.buffer),u=s.detect(b);if(!u||!u.encoding)return null;const C=u.encoding.toLowerCase();return 0<=h.indexOf(C)?null:E(u.encoding)}const w={ibm866:"cp866",big5:"cp950"};function E(r){const s=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[s]||s}function p(r){let s="";for(let f=0;f<r.length;f++)s+=String.fromCharCode(r[f]);return s}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=r.match(/windows(\d+)/);return s?"windows-"+s[1]:r}}}e.toCanonicalName=t;function a({buffer:r,bytesRead:s},f){let b=n(r,s),u=!1;if(b!==e.UTF16be&&b!==e.UTF16le&&r){let C=!0,y=!0,o=!1;for(let i=0;i<s&&i<L;i++){const I=i%2===1,F=r.readUInt8(i)===0;if(F&&(o=!0),C&&(I&&!F||!I&&F)&&(C=!1),y&&(I&&F||!I&&!F)&&(y=!1),F&&!C&&!y)break}o&&(C?b=e.UTF16le:y?b=e.UTF16be:u=!0)}return f&&!u&&!b&&r?d(r.slice(0,s)).then(C=>({seemsBinary:!1,encoding:C})):{seemsBinary:u,encoding:b}}e.detectEncodingFromBuffer=a,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[147],Ce([1,0,337,29,146]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class L extends l.TextSearchManager{constructor(P,_,g=A,T="searchProcess"){super(P,_,{readdir:k=>g.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,c.toCanonicalName)(k)},T)}}e.NativeTextSearchManager=L}),define(ye[148],Ce([1,0,46,351,336,19,65,33,10,11,2,34,86,352,334,108]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const n=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(i){this.outputChannel=i}provideTextSearchResults(i,I,F,U){return this.outputChannel.appendLine(`provideTextSearchResults ${i.pattern}, ${JSON.stringify({...I,folder:I.folder.toString()})}`),new Promise(($,B)=>{U.onCancellationRequested(()=>J());const N=a(i,I),V=I.folder.fsPath,x=N.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${n} ${x}
 - cwd: ${V}`);let W=c.spawn(n,N,{cwd:V});W.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),B((0,k.serializeSearchError)(new k.SearchError(ve&&ve.message,k.SearchErrorCode.rgProcessError)))});let ee=!1;const se=new E(I.maxResults,V,I.previewOptions);se.on("result",ve=>{ee=!0,ae="",F.report(ve)});let H=!1;const J=()=>{H=!0,W?.kill(),se?.cancel()};let j=!1;se.on("hitLimit",()=>{j=!0,J()});let ae="";W.stdout.on("data",ve=>{se.handleData(ve),ee||(ae+=ve)});let we=!1;W.stdout.once("data",()=>we=!0);let _e="";W.stderr.on("data",ve=>{const M=ve.toString();this.outputChannel.appendLine(M),_e.length+M.length<1e6&&(_e+=M)}),W.on("close",()=>{if(this.outputChannel.appendLine(we?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(ee?"Got result from parser":"No result from parser"),ae&&this.outputChannel.appendLine(`Got data without result: ${ae}`),this.outputChannel.appendLine(""),H)$({limitHit:j});else{se.flush(),W=null;let ve;_e&&!we&&(ve=d(_e))?B((0,k.serializeSearchError)(new k.SearchError(ve.message,ve.code))):$({limitHit:j})}})})}}e.RipgrepTextSearchEngine=h;function d(o){const i=o.split(`
`),I=i[0].trim();if(i.some(U=>U.startsWith("regex parse error")))return new k.SearchError(w(i),k.SearchErrorCode.regexParseError);const F=I.match(/grep config error: unknown encoding: (.*)/);if(F)return new k.SearchError(`Unknown encoding: ${F[1]}`,k.SearchErrorCode.unknownEncoding);if(I.startsWith("error parsing glob"))return new k.SearchError(I.charAt(0).toUpperCase()+I.substr(1),k.SearchErrorCode.globParseError);if(I.startsWith("the literal"))return new k.SearchError(I.charAt(0).toUpperCase()+I.substr(1),k.SearchErrorCode.invalidLiteral);if(I.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(I,k.SearchErrorCode.regexParseError)}function w(o){const i=["Regex parse error"],I=o.filter(F=>F.startsWith("PCRE2:"));if(I.length>=1){const F=I[0].replace("PCRE2:","");if(F.indexOf(":")!==-1&&F.split(":").length>=2){const U=F.split(":")[1];i.push(":"+U)}}return i.join("")}class E extends A.EventEmitter{constructor(i,I,F){super(),this.maxResults=i,this.rootFolder=I,this.previewOptions=F,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new l.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(i,I){return super.on(i,I),this}handleData(i){if(this.isDone)return;const I=typeof i=="string"?i:this.stringDecoder.write(i);this.handleDecodedData(I)}handleDecodedData(i){let I=i.indexOf(`
`);const F=this.remainder+i;if(I>=0)I+=this.remainder.length;else{this.remainder=F;return}let U=0;for(;I>=0;)this.handleLine(F.substring(U,I).trim()),U=I+1,I=F.indexOf(`
`,U);this.remainder=F.substring(U)}handleLine(i){if(this.isDone||!i)return;let I;try{I=JSON.parse(i)}catch{throw new Error(`malformed line from rg: ${i}`)}if(I.type==="match"){const F=p(I.data.path),U=T.URI.file(_.join(this.rootFolder,F)),$=this.createTextSearchMatch(I.data,U);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(I.type==="context"){const F=p(I.data.path),U=T.URI.file(_.join(this.rootFolder,F));this.createTextSearchContext(I.data,U).forEach(B=>this.onResult(B))}}createTextSearchMatch(i,I){const F=i.line_number-1,U=p(i.lines),$=Buffer.from(U);let B=0,N=0,V=F;i.submatches.length===0&&i.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const x=(0,L.coalesce)(i.submatches.map((W,ee)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const se=p(W.match),H=$.slice(B,W.start).toString(),J=t(H),j=J.numLines>0?J.lastLineLength:J.lastLineLength+N,ae=t(se),we=J.numLines+V,_e=ae.numLines+we,ve=ae.numLines>0?ae.lastLineLength:ae.lastLineLength+j;return B=W.end,N=ve,V=_e,new m.Range(we,j,_e,ve)}));return(0,v.createTextSearchResult)(I,U,x,this.previewOptions)}createTextSearchContext(i,I){const F=p(i.lines),U=i.line_number;return F.replace(/\r?\n$/,"").split(`
`).map(($,B)=>({text:$,uri:I,lineNumber:U+B}))}onResult(i){this.emit("result",i)}}e.RipgrepParser=E;function p(o){return o.bytes?Buffer.from(o.bytes,"base64").toString():o.text}function t(o){const i=/\n/g;let I=0,F=-1,U;for(;U=i.exec(o);)I++,F=U.index;const $=F>=0?o.length-F-1:o.length;return{numLines:I,lastLineLength:$}}function a(o,i){const I=["--hidden"];I.push(o.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:F,otherIncludes:U}=(0,R.groupBy)(i.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const B=new Set;U.forEach(N=>{B.add(N)}),I.push("-g","!*"),B.forEach(N=>{r(N).map(v.anchorGlob).forEach(V=>{I.push("-g",V)})})}F&&F.length&&F.forEach(B=>{I.push("-g",B)}),i.excludes.map(v.anchorGlob).forEach(B=>I.push("-g",`!${B}`)),i.maxFileSize&&I.push("--max-filesize",i.maxFileSize+""),i.useIgnoreFiles?i.useParentIgnoreFiles||I.push("--no-ignore-parent"):I.push("--no-ignore"),i.followSymlinks&&I.push("--follow"),i.encoding&&i.encoding!=="utf8"&&I.push("--encoding",i.encoding),o.pattern==="--"&&(o.isRegExp=!0,o.pattern="\\-\\-"),o.isMultiline&&!o.isRegExp&&(o.pattern=(0,g.escapeRegExpCharacters)(o.pattern),o.isRegExp=!0),i.usePCRE2&&I.push("--pcre2"),I.push("--crlf"),o.isRegExp&&(o.pattern=s(o.pattern),I.push("--engine","auto"));let $;if(o.isWordMatch){const N=(0,g.createRegExp)(o.pattern,!!o.isRegExp,{wholeWord:o.isWordMatch}).source.replace(/\\\//g,"/");I.push("--regexp",N)}else if(o.isRegExp){let B=b(o.pattern);B=u(B),I.push("--regexp",B)}else $=o.pattern,I.push("--fixed-strings");return I.push("--no-config"),i.useGlobalIgnoreFiles||I.push("--no-ignore-global"),I.push("--json"),o.isMultiline&&I.push("--multiline"),i.beforeContext&&I.push("--before-context",i.beforeContext+""),i.afterContext&&I.push("--after-context",i.afterContext+""),I.push("--"),$&&I.push($),I.push("."),I}e.getRgArgs=a;function r(o){return y(o).flatMap(I=>{const F=(0,P.splitGlobAware)(I,"/");return F.map((U,$)=>F.slice(0,$+1).join("/"))})}function s(o){const i=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;o.match(i);)o=o.replace(i,"$1\\x{$2}");const I=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;o.match(I);)o=o.replace(I,"$1\\x{$2}");return o}e.unicodeEscapesToPCRE2=s;const f=o=>o.type==="Assertion"&&o.kind==="lookbehind";function b(o){let i;try{i=new D.RegExpParser().parsePattern(o)}catch{return o}let I="",F=0;const U=(N,V,x)=>{I+=o.slice(F,N)+x,F=V},$=[];return new D.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const V=$[0];if(!V)U(N.start,N.end,"\\r?\\n");else if(!$.some(f))if(V.type==="CharacterClass")if(V.negate){const x=o.slice(V.start+2,N.start)+o.slice(N.end,V.end-1);V.parent?.type==="Quantifier"?U(V.start,V.end,x?`[^${x}]`:"."):U(V.start,V.end,"(?!\\r?\\n"+(x?`|[${x}]`:"")+")")}else{const x=o.slice(V.start+1,N.start)+o.slice(N.end,V.end-1);U(V.start,V.end,x===""?"\\r?\\n":`(?:[${x}]|\\r?\\n)`)}else V.type==="Quantifier"&&U(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){$.unshift(N)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(N){$.unshift(N)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(N){$.unshift(N)},onCharacterClassLeave(){$.shift()},onAssertionEnter(N){f(N)&&$.push(N)},onAssertionLeave(N){$[0]===N&&$.shift()}}).visit(i),I+=o.slice(F),I}e.fixRegexNewline=b;function u(o){return o.replace(/\n/g,"\\r?\\n")}e.fixNewline=u;function C(o){let i=!1,I=!1,F="",U="";for(let $=0;$<o.length;$++){const B=o[$];switch(B){case"\\":I?(i?U+="\\"+B:F+="\\"+B,I=!1):I=!0;break;case"{":if(I)i?U+=B:F+=B,I=!1;else{if(i)return{strInBraces:F+"{"+U+"{"+o.substring($+1)};i=!0}break;case"}":if(I)i?U+=B:F+=B,I=!1;else{if(i)return{fixedStart:F,strInBraces:U,fixedEnd:o.substring($+1)};F+=B}break;default:i?U+=(I?"\\":"")+B:F+=(I?"\\":"")+B,I=!1;break}}return{strInBraces:F+(i?"{"+U:"")}}function y(o){const{fixedStart:i,strInBraces:I,fixedEnd:F}=C(o);if(i===void 0||F===void 0)return[I];let U=(0,P.splitGlobAware)(I,",");U.length||(U=[""]);const $=y(F);return U.flatMap(B=>{const N=i+B;return $.map(V=>N+V)})}e.performBraceExpansionForRipgrep=y}),define(ye[338],Ce([1,0,22,148,127,18]),function(re,e,c,A,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(g){this.outputChannel=g,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(g,T,k,m){const D=new A.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===L.Schemas.vscodeUserData){const S={...T,folder:T.folder.with({scheme:L.Schemas.file})},v=new l.Progress(n=>k.report({...n,uri:n.uri.with({scheme:T.folder.scheme})}));return this.withToken(m,n=>D.provideTextSearchResults(g,S,v,n))}else return this.withToken(m,S=>D.provideTextSearchResults(g,T,k,S))}async withToken(g,T){const k=P(g);this.inProgress.add(k);const m=await T(k.token);return this.inProgress.delete(k),m}dispose(){this.inProgress.forEach(g=>g.cancel())}}e.RipgrepSearchProvider=R;function P(_){const g=new c.CancellationTokenSource;return _.onCancellationRequested(()=>g.cancel()),g}}),define(ye[339],Ce([1,0,29,148,147]),function(re,e,c,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class L{constructor(_){this.query=_}search(_,g,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(D){T({message:D})}},m=new l.NativeTextSearchManager(this.query,new A.RipgrepTextSearchEngine(k),c);return new Promise((D,S)=>m.search(v=>{g(v.map(R))},_).then(v=>D({limitHit:v.limitHit,type:"success",stats:v.stats}),S))}}e.TextSearchEngineAdapter=L;function R(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((_,g)=>{if(g.ranges){const T=g;return _+(Array.isArray(T.ranges)?T.ranges.length:1)}else return _+1},0)}}}),define(ye[340],Ce([1,0,19,16,8,3,117,10,40,2,31,34,335,339]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class S{constructor(E="searchProcess"){this.processType=E,this.caches=Object.create(null)}fileSearch(E){let p;const t=h(E),a=new L.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.doFileSearchWithEngine(m.Engine,t,s=>a.fire(s),r)),p.then(r=>a.fire(r),r=>a.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return a.event}textSearch(E){let p;const t=h(E),a=new L.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.ripgrepTextSearch(t,s=>a.fire(s),r)),p.then(r=>a.fire(r),r=>a.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return a.event}ripgrepTextSearch(E,p,t){return E.maxFileSize=this.getPlatformFileLimits().maxFileSize,new D.TextSearchEngineAdapter(E).search(t,p,p)}getPlatformFileLimits(){return{maxFileSize:process.arch==="ia32"?300*T.ByteSize.MB:16*T.ByteSize.GB}}doFileSearch(E,p,t){return this.doFileSearchWithEngine(m.Engine,E,p,t)}doFileSearchWithEngine(E,p,t,a,r=S.BATCH_SIZE){let s=0;const f=u=>{Array.isArray(u)?(s+=u.length,t(u.map(C=>this.rawMatchToSearchItem(C)))):u.relativePath?(s++,t(this.rawMatchToSearchItem(u))):t(u)};if(p.sortByScore){let u=this.trySortedSearchFromCache(p,f,a);if(!u){const C=p.maxResults?Object.assign({},p,{maxResults:null}):p,y=new E(C);u=this.doSortedSearch(y,p,t,f,a)}return new Promise((C,y)=>{u.then(([o,i])=>{const I=i.map(F=>this.rawMatchToSearchItem(F));this.sendProgress(I,t,r),C(o)},y)})}const b=new E(p);return this.doSearch(b,f,r,a).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(E){return{path:E.base?(0,P.join)(E.base,E.relativePath):E.relativePath}}doSortedSearch(E,p,t,a,r){const s=new L.Emitter;let f=(0,A.createCancelablePromise)(u=>{let C=[];const y=o=>{Array.isArray(o)?C=o:(a(o),s.fire(o))};return this.doSearch(E,y,-1,u).then(o=>[o,C])}),b;if(p.cacheKey){b=this.getOrCreateCache(p.cacheKey);const u={promise:f,event:s.event,resolved:!1};b.resultsToSearchCache[p.filePattern||""]=u,f.then(()=>{u.resolved=!0},C=>{delete b.resultsToSearchCache[p.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([u,C])=>{const y=b?b.scorerCache:Object.create(null),o=(typeof p.maxResults!="number"||p.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(p,C,y,r).then(i=>{const I=o?o.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:I,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:i.length},messages:u.messages,limitHit:u.limitHit||typeof p.maxResults=="number"&&C.length>p.maxResults},i]})})}getOrCreateCache(E){const p=this.caches[E];return p||(this.caches[E]=new v)}trySortedSearchFromCache(E,p,t){const a=E.cacheKey&&this.caches[E.cacheKey];if(!a)return;const r=this.getResultsFromCache(a,E.filePattern||"",p,t);if(r)return r.then(([s,f,b])=>{const u=_.StopWatch.create(!1);return this.sortResults(E,f,a.scorerCache,t).then(C=>{const y=u.elapsed(),o={fromCache:!0,detailStats:b,type:this.processType,resultCount:f.length,sortingTime:y};return[{type:"success",limitHit:s.limitHit||typeof E.maxResults=="number"&&f.length>E.maxResults,stats:o},C]})})}sortResults(E,p,t,a){const r=(0,R.prepareQuery)(E.filePattern||""),s=(b,u)=>(0,R.compareItemsByFuzzyScore)(b,u,r,!0,n,t),f=typeof E.maxResults=="number"?E.maxResults:Number.MAX_VALUE;return c.topAsync(p,s,f,1e4,a)}sendProgress(E,p,t){if(t&&t>0)for(let a=0;a<E.length;a+=t)p(E.slice(a,a+t));else p(E)}getResultsFromCache(E,p,t,a){const r=_.StopWatch.create(!1),s=p.indexOf(P.sep)>=0;let f;for(const y in E.resultsToSearchCache)if(p.startsWith(y)){if(s&&y.indexOf(P.sep)<0&&y!=="")continue;const o=E.resultsToSearchCache[y];f={promise:this.preventCancellation(o.promise),event:o.event,resolved:o.resolved};break}if(!f)return null;const b=r.elapsed(),u=_.StopWatch.create(!1),C=f.event(t);return a&&a.onCancellationRequested(()=>{C.dispose()}),f.promise.then(([y,o])=>{if(a&&a.isCancellationRequested)throw(0,l.canceled)();const i=[],I=(0,R.prepareQuery)(p).normalizedLowercase;for(const F of o)(0,k.isFilePatternMatch)(F,I)&&i.push(F);return[y,i,{cacheWasResolved:f.resolved,cacheLookupTime:b,cacheFilterTime:u.elapsed(),cacheEntryCount:o.length}]})}doSearch(E,p,t,a){return new Promise((r,s)=>{let f=[];a?.onCancellationRequested(()=>E.cancel()),E.search(b=>{b&&(t?(f.push(b),t>0&&f.length>=t&&(p(f),f=[])):p(b))},b=>{p(b)},(b,u)=>{f.length&&p(f),b?s(b):r(u)})})}clearCache(E){return delete this.caches[E],Promise.resolve(void 0)}preventCancellation(E){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,t){return E.then(p,t)}catch(p){return this.then(void 0,p)}finally(p){return E.finally(p)}}}}e.SearchService=S,S.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const n=new class{getItemLabel(w){return(0,P.basename)(w.relativePath)}getItemDescription(w){return(0,P.dirname)(w.relativePath)}getItemPath(w){return w.relativePath}};function h(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(d),extraFileResources:w.extraFileResources&&w.extraFileResources.map(E=>g.URI.revive(E))}}function d(w){return{...w,folder:g.URI.revive(w.folder)}}}),define(ye[341],Ce([1,0,4,18,2,29,17,27,20,90,59,34,340,338,108,147]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let n=e.NativeExtHostSearch=class extends g.ExtHostSearch{constructor(d,w,E,p){super(d,E,p),this._pfs=L,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new S.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new D.RipgrepSearchProvider(t)),w.remote.isRemote&&w.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const d=new S.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(A.Schemas.file,new D.RipgrepSearchProvider(d)),this.registerInternalFileSearchProvider(A.Schemas.file,new m.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(d,w){const E=this._handlePool++;return this._internalFileSearchProvider=w,this._internalFileSearchHandle=E,this._proxy.$registerFileSearchProvider(E,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(E)})}$provideFileSearchResults(d,w,E,p){const t=(0,g.reviveQuery)(E);return d===this._internalFileSearchHandle?this.doInternalFileSearch(d,w,t,p):super.$provideFileSearchResults(d,w,E,p)}doInternalFileSearch(d,w,E,p){const t=a=>{if((0,k.isSerializedFileMatch)(a)&&(a=[a]),Array.isArray(a)){this._proxy.$handleFileMatch(d,w,a.map(r=>l.URI.file(r.path)));return}a.message&&this._logService.debug("ExtHostSearch",a.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(E,t,p)}$clearCache(d){return this._internalFileSearchProvider?.clearCache(d),super.$clearCache(d)}createTextSearchManager(d,w){return new v.NativeTextSearchManager(d,w,void 0,"textSearchProvider")}};e.NativeExtHostSearch=n=je([$e(0,_.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,T.IURITransformerService),$e(3,R.ILogService)],n)}),define(ye[149],Ce([1,0,353,134,74,354,21,8,3,4,10,9,32,75,121]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(o,i){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,i)}constructor(o,i=""){this._canWrite=!0,this.debugLabel=i,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,P.onUnexpectedError)(I)}},this.socket.on("error",this._errorListener),this._closeListener=I=>{this.traceSocketEvent("close",{hadError:I}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(o){const i=I=>{this.traceSocketEvent("read",I),o(R.VSBuffer.wrap(I))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(o){const i=I=>{o({type:0,hadError:I,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(o){const i=()=>{o()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(o){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,P.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,P.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.NodeSocket=v;var n;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(n||(n={}));var h;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(h||(h={}));class d extends g.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,i){this.socket.traceSocketEvent(o,i)}constructor(o,i,I,F){super(),this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:I?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new w(this,i,I,F,this._onData,(U,$)=>this._write(U,$))),this._register(this._flowManager.onError(U=>{console.error(U),(0,P.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(async U=>{this._flowManager.isProcessingReadQueue()&&await _.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(U)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){let i=0;for(;i<o.byteLength;)this._flowManager.writeMessage(o.slice(i,Math.min(i+262144,o.byteLength))),i+=262144}_write(o,i){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let I=2;o.byteLength<126?I+=0:o.byteLength<2**16?I+=2:I+=8;const F=R.VSBuffer.alloc(I);if(i?F.writeUInt8(194,0):F.writeUInt8(130,0),o.byteLength<126)F.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){F.writeUInt8(126,1);let U=1;F.writeUInt8(o.byteLength>>>8&255,++U),F.writeUInt8(o.byteLength>>>0&255,++U)}else{F.writeUInt8(127,1);let U=1;F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(o.byteLength>>>24&255,++U),F.writeUInt8(o.byteLength>>>16&255,++U),F.writeUInt8(o.byteLength>>>8&255,++U),F.writeUInt8(o.byteLength>>>0&255,++U)}this.socket.write(R.VSBuffer.concat([F,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const i=this._incomingData.peek(this._state.readLen),I=i.readUInt8(0),F=(I&128)>>>7,U=(I&64)>>>6,$=i.readUInt8(1),B=($&128)>>>7,N=$&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!U),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const i=this._incomingData.read(this._state.readLen),I=i.readUInt8(1),F=(I&128)>>>7;let U=I&127,$=1;U===126?U=i.readUInt8(++$)*2**8+i.readUInt8(++$):U===127&&(U=i.readUInt8(++$)*0+i.readUInt8(++$)*0+i.readUInt8(++$)*0+i.readUInt8(++$)*0+i.readUInt8(++$)*2**24+i.readUInt8(++$)*2**16+i.readUInt8(++$)*2**8+i.readUInt8(++$));let B=0;F&&(B=i.readUInt8(++$)*2**24+i.readUInt8(++$)*2**16+i.readUInt8(++$)*2**8+i.readUInt8(++$)),this._state.state=3,this._state.readLen=U,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const i=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),t(i,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(i,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await _.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class w extends g.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(o,i,I,F,U,$){super(),this._tracer=o,this._onData=U,this._writeFn=$,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new _.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new _.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,i?(this._zlibInflateStream=this._register(new E(this._tracer,F,I,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const i=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(i,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,i){return new Promise((I,F)=>{o.write(i),o.flush(U=>I(U))})}acceptFrame(o,i,I){this._readQueue.push({data:o,isCompressed:i,isLastFrameOfMessage:I}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const i=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(i)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(o,i,I){return new Promise((F,U)=>{o.write(i),I&&o.write(R.VSBuffer.fromByteArray([0,0,255,255])),o.flush($=>F($))})}}class E extends g.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(o,i,I,F){super(),this._tracer=o,this._recordInflateBytes=i,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,L.createInflateRaw)(F),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(R.VSBuffer.wrap(U))}),I&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this._zlibInflate.write(I.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const i=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(i)})}}class p extends g.Disposable{constructor(o,i){super(),this._tracer=o,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,L.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",I=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this._onError.fire(I)}),this._zlibDeflate.on("data",I=>{this._tracer.traceSocketEvent("zlibDeflateData",I),this._pendingDeflateData.push(R.VSBuffer.wrap(I))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let i=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,i=i.slice(0,i.byteLength-4),o(i)})}}function t(y,o){if(o===0)return;const i=y.byteLength>>>2;for(let N=0;N<i;N++){const V=y.readUInt32BE(N*4);y.writeUInt32BE(V^o,N*4)}const I=i*4,F=y.byteLength-I,U=o>>>24&255,$=o>>>16&255,B=o>>>8&255;F>=1&&y.writeUInt8(y.readUInt8(I)^U,I),F>=2&&y.writeUInt8(y.readUInt8(I+1)^$,I+1),F>=3&&y.writeUInt8(y.readUInt8(I+2)^B,I+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function r(){const y=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const o=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,l.tmpdir)(),i=(0,T.join)(o,`vscode-ipc-${y}.sock`);return f(i),i}e.createRandomIPCHandle=r;function s(y,o,i){const I=(0,c.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${i}-${o}-sock`;const F=i.substr(0,4),U=o.substr(0,6),$=I.substr(0,8);let B;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?B=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${$}-${F}-${U}.sock`):B=(0,T.join)(y,`${F}-${U}.sock`),f(B),B}e.createStaticIPCHandle=s;function f(y){const o=a[k.platform];typeof o=="number"&&y.length>=o&&console.warn(`WARNING: IPC handle "${y}" is longer than ${o} chars, try a shorter --user-data-dir`)}class b extends D.IPCServer{static toClientConnectionEvent(o){const i=_.Event.fromNodeEventEmitter(o,"connection");return _.Event.map(i,I=>({protocol:new S.Protocol(new v(I,"ipc-server-connection")),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(I,"close"))}))}constructor(o){super(b.toClientConnectionEvent(o)),this.server=o}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=b;function u(y){return new Promise((o,i)=>{const I=(0,A.createServer)();I.on("error",i),I.listen(y,()=>{I.removeListener("error",i),o(new b(I))})})}e.serve=u;function C(y,o){return new Promise((i,I)=>{const F=(0,A.createConnection)(y,()=>{F.removeListener("error",I),i(S.Client.fromSocket(new v(F,`ipc-client${o}`),o))});F.once("error",I)})}e.connect=C}),define(ye[342],Ce([1,0,149,247,48,36,2,17,49]),function(re,e,c,A,l,L,R,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class g{constructor(m,D,S){this._commands=m,this.logService=D,this._ipcHandlePath=S,this._server=A.createServer((v,n)=>this.onRequest(v,n)),this.setup().catch(v=>(D.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",m=>this.logService.error(m))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(m,D){const S=(n,h)=>{D.writeHead(n,{"content-type":"application/json"}),D.end(JSON.stringify(h||null),d=>d&&this.logService.error(d))},v=[];m.setEncoding("utf8"),m.on("data",n=>v.push(n)),m.on("end",async()=>{try{const n=JSON.parse(v.join(""));let h;switch(n.type){case"open":h=await this.open(n);break;case"openExternal":h=await this.openExternal(n);break;case"status":h=await this.getStatus(n);break;case"extensionManagement":h=await this.manageExtensions(n);break;default:S(404,`Unknown message type: ${n.type}`);break}S(200,h)}catch(n){const h=n instanceof Error?n.message:JSON.stringify(n);S(500,h),this.logService.error("Error while processing pipe request",n)}})}async open(m){const{fileURIs:D,folderURIs:S,forceNewWindow:v,diffMode:n,mergeMode:h,addMode:d,forceReuseWindow:w,gotoLineMode:E,waitMarkerFilePath:p,remoteAuthority:t}=m,a=[];if(Array.isArray(S))for(const b of S)try{a.push({folderUri:R.URI.parse(b)})}catch{}if(Array.isArray(D))for(const b of D)try{(0,_.hasWorkspaceFileExtension)(b)?a.push({workspaceUri:R.URI.parse(b)}):a.push({fileUri:R.URI.parse(b)})}catch{}const r=p?R.URI.file(p):void 0,f={forceNewWindow:v,diffMode:n,mergeMode:h,addMode:d,gotoLineMode:E,forceReuseWindow:w,preferNewWindow:!w&&!r&&!d,waitMarkerFileURI:r,remoteAuthority:t};return this._commands.executeCommand("_remoteCLI.windowOpen",a,f),""}async openExternal(m){for(const D of m.uris){const S=R.URI.parse(D),v=S.scheme==="file"?S:D;await this._commands.executeCommand("_remoteCLI.openExternal",v)}}async manageExtensions(m){const D=v=>v?.map(n=>/\.vsix$/i.test(n)?R.URI.parse(n):n),S={list:m.list,install:D(m.install),uninstall:D(m.uninstall),force:m.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",S)}async getStatus(m){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&l.existsSync(this._ipcHandlePath)&&l.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=g;let T=e.CLIServer=class extends g{constructor(m,D){super(m,D,(0,c.createRandomIPCHandle)())}};e.CLIServer=T=je([$e(0,L.IExtHostCommands),$e(1,P.ILogService)],T)}),define(ye[343],Ce([1,0,88,331,326,246,44,314,2,18,7,342,94,312,313]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends l.RequireInterceptor{_installInterceptor(){const d=this,w=globalThis._VSCODE_NODE_MODULES.module,E=w._load;w._load=function(r,s,f){return r=t(r),d._factories.has(r)?d._factories.get(r).load(r,_.URI.file((0,m.realpathSync)(s.filename)),b=>E.apply(this,[b,s,f])):E.apply(this,arguments)};const p=w._resolveLookupPaths;w._resolveLookupPaths=(a,r)=>p.call(this,t(a),r);const t=a=>{for(const r of d._alternatives){const s=r(a);if(s){a=s;break}}return a}}}class n extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(D.ExtHostConsoleForwarder);const d=this._instaService.invokeFunction(A.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(P.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const p=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=p.ipcHandlePath}this._instaService.createInstance(S.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(v,d,{mine:this._myRegistry,all:this._globalRegistry}).install(),c.mark("code/extHost/didInitAPI");const E=await this._extHostConfiguration.getConfigProvider();await(0,L.connectProxyResolver)(this._extHostWorkspace,E,this,this._logService,this._mainThreadTelemetryProxy,this._initData),c.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(d){return d.main}async _loadCommonJSModule(d,w,E){if(w.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let p=null;E.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this._logService.flush();const t=d?.identifier.value;d&&await this._extHostLocalizationService.initializeLocalizedMessages(d);try{t&&c.mark(`code/extHost/willLoadExtensionCode/${t}`),p=re.__$__nodeRequire(w.fsPath)}finally{t&&c.mark(`code/extHost/didLoadExtensionCode/${t}`),E.codeLoadingStop()}return p}async $setRemoteEnvironment(d){if(this._initData.remote.isRemote)for(const w in d){const E=d[w];E===null?delete process.env[w]:process.env[w]=E}}}e.ExtHostExtensionService=n}),define(ye[344],Ce([1,0,97,317,329,328,341,343,318,89,44,90,87,43,58,84,316,315,17,330,51,241,96]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h,d,w,E,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(T.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,c.registerSingleton)(d.ILoggerService,h.ExtHostLoggerService,1),(0,c.registerSingleton)(d.ILogService,new t.SyncDescriptor(p.ExtHostLogService,[!1],!0)),(0,c.registerSingleton)(v.IExtensionStoragePaths,n.ExtensionStoragePaths,0),(0,c.registerSingleton)(g.IExtHostDebugService,L.ExtHostDebugService,0),(0,c.registerSingleton)(k.IExtHostSearch,R.NativeExtHostSearch,0),(0,c.registerSingleton)(m.IExtHostTask,l.ExtHostTask,0),(0,c.registerSingleton)(D.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,c.registerSingleton)(S.IExtHostTunnelService,_.ExtHostTunnelService,0),(0,c.registerSingleton)(E.IExtHostVariableResolverProvider,w.NodeExtHostVariableResolverProviderService,0)}),define(ye[355],Ce([1,0,134,356,88,8,121,149,228,103,327,21,29,94,16,123,248,260,332,344]),function(re,e,c,A,l,L,R,P,_,g,T,k,m,D,S,v,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let b=0;b<process.execArgv.length;b++)process.execArgv[b]==="--inspect-port=0"&&(process.execArgv.splice(b,1),b--)}();const d=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const f=globalThis._VSCODE_NODE_MODULES.module,b=f._load;f._load=function(u){if(u==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return b.apply(this,arguments)}})();const w=process.exit.bind(process);function E(f){process.exit=function(b){if(f)w(b);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const b=new Error("An extension called process.crash() and this was prevented.");console.warn(b.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(f){w()};function t(){const f=(0,h.readExtHostConnection)(process.env);if(f.type===3)return new Promise((b,u)=>{const C=y=>{const o=y[0],i=new R.BufferedEmitter;o.on("message",I=>i.fire(k.VSBuffer.wrap(I.data))),o.on("close",()=>{p("renderer closed the MessagePort")}),o.start(),b({onMessage:i.event,send:I=>o.postMessage(I.buffer)})};process.parentPort.on("message",y=>C(y.ports))});if(f.type===2)return new Promise((b,u)=>{let C=null;const y=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),o=108e5,i=3e5,I=new S.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),o),F=new S.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),i);process.on("message",($,B)=>{if($&&$.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from($.initialDataChunk,"base64"));let V;if($.skipWebSocketFrames)V=new P.NodeSocket(B,"extHost-socket");else{const x=k.VSBuffer.wrap(Buffer.from($.inflateBytes,"base64"));V=new P.WebSocketNodeSocket(new P.NodeSocket(B,"extHost-socket"),$.permessageDeflate,x,!1)}C?(I.cancel(),F.cancel(),C.beginAcceptReconnection(V,N),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(y),C=new R.PersistentProtocol({socket:V,initialChunk:N}),C.sendResume(),C.onDidDispose(()=>p("renderer disconnected")),b(C),C.onSocketClose(()=>{I.schedule()}))}if($&&$.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;I.isScheduled()&&F.schedule()}});const U={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(U)});{const b=f.pipeName;return new Promise((u,C)=>{const y=c.createConnection(b,()=>{y.removeListener("error",C);const o=new R.PersistentProtocol({socket:new P.NodeSocket(y,"extHost-renderer")});o.sendResume(),u(o)});y.once("error",C),y.on("close",()=>{p("renderer closed the socket")})})}}async function a(){const f=await t();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,f.onMessage(b=>{(0,g.isMessageOfType)(b,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(b)})}send(b){this._terminating||f.send(b)}async drain(){if(f.drain)return f.drain()}}}function r(f){return new Promise(b=>{const u=f.onMessage(C=>{u.dispose();const y=JSON.parse(C.toString()),o=y.commit,i=_.default.commit;if(o&&i&&o!==i&&w(55),y.parentPid){let I=0;setInterval(function(){try{process.kill(y.parentPid,0),I=0}catch(U){U&&U.code==="EPERM"?(I++,I>=3&&p(`parent process ${y.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):p(`parent process ${y.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(y.parentPid)}catch(U){(0,L.onUnexpectedError)(U)}}f.send((0,g.createMessageOfType)(0)),b({protocol:f,initData:y})});f.send((0,g.createMessageOfType)(1))})}async function s(){const f=[];process.on("unhandledRejection",(I,F)=>{f.push(F),setTimeout(()=>{const U=f.indexOf(F);U>=0&&F.catch($=>{f.splice(U,1),(0,L.isCancellationError)($)||(console.warn(`rejected promise not handled within 1 second: ${$}`),$&&$.stack&&console.warn(`stack trace: ${$.stack}`),I&&(0,L.onUnexpectedError)(I))})},1e3)}),process.on("rejectionHandled",I=>{const F=f.indexOf(I);F>=0&&f.splice(F,1)}),process.on("uncaughtException",function(I){(0,L.isSigPipeError)(I)||(0,L.onUnexpectedError)(I)}),l.mark("code/extHost/willConnectToRenderer");const b=await a();l.mark("code/extHost/didConnectToRenderer");const u=await r(b);l.mark("code/extHost/didWaitForInitData");const{initData:C}=u;E(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=d.useHostProxy!==void 0?d.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,v.boolean)(d.skipWorkspaceStorageLock,!1);const y=new class{constructor(){this.pid=process.pid}exit(F){w(F)}exists(F){return m.Promises.exists(F)}realpath(F){return(0,D.realpath)(F)}};let o=null;C.remote.authority&&d.transformURIs&&(o=(0,n.createURITransformer)(C.remote.authority));const i=new T.ExtensionHostMain(u.protocol,C,y,o);p=I=>i.terminate(I)}s().catch(f=>console.log(f))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/workbench/api/node/extensionHostProcess.js.map
