/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/workbench/services/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(te){for(var e=[],i=0,C=te.length;i<C;i++)e[i]=Ae[te[i]];return e};define(Ae[64],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(O,A){const _=Object.create(null);for(const m of O){const R=A(m);let b=_[R];b||(b=_[R]=[]),b.push(m)}return _}e.groupBy=i;function C(O,A){const _=[],m=[];for(const R of O)A.has(R)||_.push(R);for(const R of A)O.has(R)||m.push(R);return{removed:_,added:m}}e.diffSets=C;function y(O,A){const _=[],m=[];for(const[R,b]of O)A.has(R)||_.push(b);for(const[R,b]of A)O.has(R)||m.push(b);return{removed:_,added:m}}e.diffMaps=y;class M{constructor(){this.map=new Map}add(A,_){let m=this.map.get(A);m||(m=new Set,this.map.set(A,m)),m.add(_)}delete(A,_){const m=this.map.get(A);m&&(m.delete(_),m.size===0&&this.map.delete(A))}forEach(A,_){const m=this.map.get(A);m&&m.forEach(_)}}e.SetMap=M}),define(Ae[65],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(O){return(A,_,m)=>{let R=null,b=null;if(typeof m.value=="function"?(R="value",b=m.value):typeof m.get=="function"&&(R="get",b=m.get),!b)throw new Error("not supported");m[R]=O(b,_)}}function C(O,A,_){let m=null,R=null;if(typeof _.value=="function"?(m="value",R=_.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(m="get",R=_.get),!R)throw new Error("not supported");const b=`$memoize$${A}`;_[m]=function(...c){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[b]}}e.memoize=C;function y(O,A,_){return i((m,R)=>{const b=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...p){this[c]||(this[c]=_?_():void 0),clearTimeout(this[b]),A&&(this[c]=A(this[c],...p),p=[this[c]]),this[b]=setTimeout(()=>{m.apply(this,p),this[c]=_?_():void 0},O)}})}e.debounce=y;function M(O,A,_){return i((m,R)=>{const b=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...d){if(this[c]||(this[c]=_?_():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...d)),this[g])return;const t=this[p]+O;t<=Date.now()?(this[p]=Date.now(),m.apply(this,[this[c]]),this[c]=_?_():void 0):(this[g]=!0,this[b]=setTimeout(()=>{this[g]=!1,this[p]=Date.now(),m.apply(this,[this[c]]),this[c]=_?_():void 0},t-Date.now()))}})}e.throttle=M}),define(Ae[86],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ae[115],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var C;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var y;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(y||(e.ParseErrorCode=y={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function O(n,u=!1){let r=0;const a=n.length;let E="",D=0,f=16,T=0;function w($){let N=0,V=0;for(;N<$;){const x=n.charCodeAt(r);if(x>=48&&x<=57)V=V*16+x-48;else if(x>=65&&x<=70)V=V*16+x-65+10;else if(x>=97&&x<=102)V=V*16+x-97+10;else break;r++,N++}return N<$&&(V=-1),V}function o($){r=$,E="",D=0,f=16,T=0}function s(){const $=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&m(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&m(n.charCodeAt(r)))for(r++;r<n.length&&m(n.charCodeAt(r));)r++;else return T=3,n.substring($,r);let N=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&m(n.charCodeAt(r))){for(r++;r<n.length&&m(n.charCodeAt(r));)r++;N=r}else T=3;return n.substring($,N)}function F(){let $="",N=r;for(;;){if(r>=a){$+=n.substring(N,r),T=2;break}const V=n.charCodeAt(r);if(V===34){$+=n.substring(N,r),r++;break}if(V===92){if($+=n.substring(N,r),r++,r>=a){T=2;break}switch(n.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const W=w(4);W>=0?$+=String.fromCharCode(W):T=4;break}default:T=5}N=r;continue}if(V>=0&&V<=31)if(_(V)){$+=n.substring(N,r),T=2;break}else T=6;r++}return $}function B(){if(E="",T=0,D=r,r>=a)return D=a,f=17;let $=n.charCodeAt(r);if(A($)){do r++,E+=String.fromCharCode($),$=n.charCodeAt(r);while(A($));return f=15}if(_($))return r++,E+=String.fromCharCode($),$===13&&n.charCodeAt(r)===10&&(r++,E+=`
`),f=14;switch($){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,E=F(),f=10;case 47:{const N=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<a&&!_(n.charCodeAt(r));)r++;return E=n.substring(N,r),f=12}if(n.charCodeAt(r+1)===42){r+=2;const V=a-1;let x=!1;for(;r<V;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,x=!0;break}r++}return x||(r++,T=1),E=n.substring(N,r),f=13}return E+=String.fromCharCode($),r++,f=16}case 45:if(E+=String.fromCharCode($),r++,r===a||!m(n.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=s(),f=11;default:for(;r<a&&G($);)r++,$=n.charCodeAt(r);if(D!==r){switch(E=n.substring(D,r),E){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return E+=String.fromCharCode($),r++,f=16}}function G($){if(A($)||_($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:o,getPosition:()=>r,scan:u?q:B,getToken:()=>f,getTokenValue:()=>E,getTokenOffset:()=>D,getTokenLength:()=>r-D,getTokenError:()=>T}}e.createScanner=O;function A(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function _(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function b(n,u){const r=[],a=new Object;let E;const D={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function T(w,o,s,F){D.value=w,D.offset=o,D.length=s,D.type=F,D.colonOffset=void 0,E=D}try{S(n,{onObjectBegin:(w,o)=>{if(u<=w)throw a;E=void 0,f=u>w,r.push("")},onObjectProperty:(w,o,s)=>{if(u<o||(T(w,o,s,"property"),r[r.length-1]=w,u<=o+s))throw a},onObjectEnd:(w,o)=>{if(u<=w)throw a;E=void 0,r.pop()},onArrayBegin:(w,o)=>{if(u<=w)throw a;E=void 0,r.push(0)},onArrayEnd:(w,o)=>{if(u<=w)throw a;E=void 0,r.pop()},onLiteralValue:(w,o,s)=>{if(u<o||(T(w,o,s,v(w)),u<=o+s))throw a},onSeparator:(w,o,s)=>{if(u<=o)throw a;if(w===":"&&E&&E.type==="property")E.colonOffset=o,f=!1,E=void 0;else if(w===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(f=!0,r[r.length-1]=""),E=void 0}}})}catch(w){if(w!==a)throw w}return{path:r,previousNode:E,isAtPropertyKey:f,matches:w=>{let o=0;for(let s=0;o<w.length&&s<r.length;s++)if(w[o]===r[s]||w[o]==="*")o++;else if(w[o]!=="**")return!1;return o===w.length}}}e.getLocation=b;function c(n,u=[],r=M.DEFAULT){let a=null,E=[];const D=[];function f(w){Array.isArray(E)?E.push(w):a!==null&&(E[a]=w)}return S(n,{onObjectBegin:()=>{const w={};f(w),D.push(E),E=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{E=D.pop()},onArrayBegin:()=>{const w=[];f(w),D.push(E),E=w,a=null},onArrayEnd:()=>{E=D.pop()},onLiteralValue:f,onError:(w,o,s)=>{u.push({error:w,offset:o,length:s})}},r),E[0]}e.parse=c;function p(n,u=[],r=M.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(w){a.type==="property"&&(a.length=w-a.offset,a=a.parent)}function D(w){return a.children.push(w),w}S(n,{onObjectBegin:w=>{a=D({type:"object",offset:w,length:-1,parent:a,children:[]})},onObjectProperty:(w,o,s)=>{a=D({type:"property",offset:o,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:w,offset:o,length:s,parent:a})},onObjectEnd:(w,o)=>{a.length=w+o-a.offset,a=a.parent,E(w+o)},onArrayBegin:(w,o)=>{a=D({type:"array",offset:w,length:-1,parent:a,children:[]})},onArrayEnd:(w,o)=>{a.length=w+o-a.offset,a=a.parent,E(w+o)},onLiteralValue:(w,o,s)=>{D({type:v(w),offset:o,length:s,parent:a,value:w}),E(o+s)},onSeparator:(w,o,s)=>{a.type==="property"&&(w===":"?a.colonOffset=o:w===","&&E(o))},onError:(w,o,s)=>{u.push({error:w,offset:o,length:s})}},r);const T=a.children[0];return T&&delete T.parent,T}e.parseTree=p;function g(n,u){if(!n)return;let r=n;for(const a of u)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let E=!1;for(const D of r.children)if(Array.isArray(D.children)&&D.children[0].value===a){r=D.children[1],E=!0;break}if(!E)return}else{const E=a;if(r.type!=="array"||E<0||!Array.isArray(r.children)||E>=r.children.length)return;r=r.children[E]}return r}e.findNodeAtLocation=g;function d(n){if(!n.parent||!n.parent.children)return[];const u=d(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;u.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&u.push(r)}return u}e.getNodePath=d;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const u=Object.create(null);for(const r of n.children){const a=r.children[1];a&&(u[r.children[0].value]=t(a))}return u}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=t;function l(n,u,r=!1){return u>=n.offset&&u<n.offset+n.length||r&&u===n.offset+n.length}e.contains=l;function h(n,u,r=!1){if(l(n,u,r)){const a=n.children;if(Array.isArray(a))for(let E=0;E<a.length&&a[E].offset<=u;E++){const D=h(a[E],u,r);if(D)return D}return n}}e.findNodeAtOffset=h;function S(n,u,r=M.DEFAULT){const a=O(n,!1);function E(le){return le?()=>le(a.getTokenOffset(),a.getTokenLength()):()=>!0}function D(le){return le?De=>le(De,a.getTokenOffset(),a.getTokenLength()):()=>!0}const f=E(u.onObjectBegin),T=D(u.onObjectProperty),w=E(u.onObjectEnd),o=E(u.onArrayBegin),s=E(u.onArrayEnd),F=D(u.onLiteralValue),B=D(u.onSeparator),G=E(u.onComment),q=D(u.onError),$=r&&r.disallowComments,N=r&&r.allowTrailingComma;function V(){for(;;){const le=a.scan();switch(a.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:$||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(le){case 12:case 13:$?x(10):G();break;case 16:x(1);break;case 15:case 14:break;default:return le}}}function x(le,De=[],Te=[]){if(q(le),De.length+Te.length>0){let Ee=a.getToken();for(;Ee!==17;){if(De.indexOf(Ee)!==-1){V();break}else if(Te.indexOf(Ee)!==-1)break;Ee=V()}}}function W(le){const De=a.getTokenValue();return le?F(De):T(De),V(),!0}function ee(){switch(a.getToken()){case 11:{let le=0;try{le=JSON.parse(a.getTokenValue()),typeof le!="number"&&(x(2),le=0)}catch{x(2)}F(le);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return V(),!0}function Ie(){return a.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),a.getToken()===6?(B(":"),V(),X()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function oe(){f(),V();let le=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(le||x(4,[],[]),B(","),V(),a.getToken()===2&&N)break}else le&&x(6,[],[]);Ie()||x(4,[],[2,5]),le=!0}return w(),a.getToken()!==2?x(7,[2],[]):V(),!0}function ue(){o(),V();let le=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(le||x(4,[],[]),B(","),V(),a.getToken()===4&&N)break}else le&&x(6,[],[]);X()||x(4,[],[4,5]),le=!0}return s(),a.getToken()!==4?x(8,[4],[]):V(),!0}function X(){switch(a.getToken()){case 3:return ue();case 1:return oe();case 10:return W(!0);default:return ee()}}return V(),a.getToken()===17?r.allowEmptyContent?!0:(x(4,[],[]),!1):X()?(a.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=S;function I(n,u){const r=O(n),a=[];let E,D=0,f;do switch(f=r.getPosition(),E=r.scan(),E){case 12:case 13:case 17:D!==f&&a.push(n.substring(D,f)),u!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,u)),D=r.getPosition();break}while(E!==17);return a.join("")}e.stripComments=I;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ae[28],Re([1,0]),function(te,e){"use strict";var i,C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(d,t,l){let h=d.get(t);return h===void 0&&(h=l,d.set(t,h)),h}e.getOrSet=M;function O(d){const t=[];return d.forEach((l,h)=>{t.push(`${h} => ${l}`)}),`Map(${d.size}) {${t.join(", ")}}`}e.mapToString=O;function A(d){const t=[];return d.forEach(l=>{t.push(l)}),`Set(${d.size}) {${t.join(", ")}}`}e.setToString=A;class _{constructor(t,l){this.uri=t,this.value=l}}class m{constructor(t,l){this[i]="ResourceMap",t instanceof m?(this.map=new Map(t.map),this.toKey=l??m.defaultToKey):(this.map=new Map,this.toKey=t??m.defaultToKey)}set(t,l){return this.map.set(this.toKey(t),new _(t,l)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,l){typeof l<"u"&&(t=t.bind(l));for(const[h,S]of this.map)t(S.value,S.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=m,m.defaultToKey=d=>d.toString();class R{constructor(t,l){this[C]="ResourceSet",!t||typeof t=="function"?this._map=new m(t):(this._map=new m(l),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,l){this._map.forEach((h,S)=>t.call(l,S,S,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class c{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,l=0){const h=this._map.get(t);if(h)return l!==0&&this.touch(h,l),h.value}set(t,l,h=0){let S=this._map.get(t);if(S)S.value=l,h!==0&&this.touch(S,h);else{switch(S={key:t,value:l,next:void 0,previous:void 0},h){case 0:this.addItemLast(S);break;case 1:this.addItemFirst(S);break;case 2:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(t,S),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this._map.get(t);if(l)return this._map.delete(t),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,l){const h=this._state;let S=this._head;for(;S;){if(l?t.bind(l)(S.value,S.key,this):t(S.value,S.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const t=this,l=this._state;let h=this._head;const S={[Symbol.iterator](){return S},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const I={value:h.key,done:!1};return h=h.next,I}else return{value:void 0,done:!0}}};return S}values(){const t=this,l=this._state;let h=this._head;const S={[Symbol.iterator](){return S},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const I={value:h.value,done:!1};return h=h.next,I}else return{value:void 0,done:!0}}};return S}entries(){const t=this,l=this._state;let h=this._head;const S={[Symbol.iterator](){return S},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const I={value:[h.key,h.value],done:!1};return h=h.next,I}else return{value:void 0,done:!0}}};return S}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this._head,h=this.size;for(;l&&h>t;)this._map.delete(l.key),l=l.next,h--;this._head=l,this._size=h,l&&(l.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const l=t.next,h=t.previous;if(!l||!h)throw new Error("Invalid list");l.previous=h,h.next=l}t.next=void 0,t.previous=void 0,this._state++}touch(t,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this._head)return;const h=t.next,S=t.previous;t===this._tail?(S.next=void 0,this._tail=S):(h.previous=S,S.next=h),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(l===2){if(t===this._tail)return;const h=t.next,S=t.previous;t===this._head?(h.previous=void 0,this._head=h):(h.previous=S,S.next=h),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((l,h)=>{t.push([h,l])}),t}fromJSON(t){this.clear();for(const[l,h]of t)this.set(l,h)}}e.LinkedMap=c;class p extends c{constructor(t,l=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class g{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let l=this.map.get(t)||0;return l===0?!1:(l--,l===0?this.map.delete(t):this.map.set(t,l),!0)}has(t){return this.map.has(t)}}e.CounterSet=g}),function(te,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(be,ge){for(var Ce=0;Ce<ge.length;Ce++){var ae=ge[Ce];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(be,ae.key,ae)}}function i(be,ge,Ce){return ge&&e(be.prototype,ge),Ce&&e(be,Ce),Object.defineProperty(be,"prototype",{writable:!1}),be}function C(be,ge){if(be){if(typeof be=="string")return y(be,ge);var Ce=Object.prototype.toString.call(be).slice(8,-1);if(Ce==="Object"&&be.constructor&&(Ce=be.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(be);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return y(be,ge)}}function y(be,ge){(ge==null||ge>be.length)&&(ge=be.length);for(var Ce=0,ae=new Array(ge);Ce<ge;Ce++)ae[Ce]=be[Ce];return ae}function M(be,ge){var Ce=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(Ce)return(Ce=Ce.call(be)).next.bind(Ce);if(Array.isArray(be)||(Ce=C(be))||ge&&be&&typeof be.length=="number"){Ce&&(be=Ce);var ae=0;return function(){return ae>=be.length?{done:!0}:{done:!1,value:be[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function O(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=O();function A(be){te.defaults=be}var _=/[&<>"']/,m=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ge){return c[ge]};function g(be,ge){if(ge){if(_.test(be))return be.replace(m,p)}else if(R.test(be))return be.replace(b,p);return be}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(be){return be.replace(d,function(ge,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var l=/(^|[^\[])\^/g;function h(be,ge){be=typeof be=="string"?be:be.source,ge=ge||"";var Ce={replace:function(de,Z){return Z=Z.source||Z,Z=Z.replace(l,"$1"),be=be.replace(de,Z),Ce},getRegex:function(){return new RegExp(be,ge)}};return Ce}var S=/[^\w:]/g,I=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(be,ge,Ce){if(be){var ae;try{ae=decodeURIComponent(t(Ce)).replace(S,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ge&&!I.test(Ce)&&(Ce=E(ge,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var n={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(be,ge){n[" "+be]||(u.test(be)?n[" "+be]=be+"/":n[" "+be]=w(be,"/",!0)),be=n[" "+be];var Ce=be.indexOf(":")===-1;return ge.substring(0,2)==="//"?Ce?ge:be.replace(r,"$1")+ge:ge.charAt(0)==="/"?Ce?ge:be.replace(a,"$1")+ge:be+ge}var D={exec:function(){}};function f(be){for(var ge=1,Ce,ae;ge<arguments.length;ge++){Ce=arguments[ge];for(ae in Ce)Object.prototype.hasOwnProperty.call(Ce,ae)&&(be[ae]=Ce[ae])}return be}function T(be,ge){var Ce=be.replace(/\|/g,function(Z,ne,k){for(var z=!1,H=ne;--H>=0&&k[H]==="\\";)z=!z;return z?"|":" |"}),ae=Ce.split(/ \|/),de=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ge)ae.splice(ge);else for(;ae.length<ge;)ae.push("");for(;de<ae.length;de++)ae[de]=ae[de].trim().replace(/\\\|/g,"|");return ae}function w(be,ge,Ce){var ae=be.length;if(ae===0)return"";for(var de=0;de<ae;){var Z=be.charAt(ae-de-1);if(Z===ge&&!Ce)de++;else if(Z!==ge&&Ce)de++;else break}return be.slice(0,ae-de)}function o(be,ge){if(be.indexOf(ge[1])===-1)return-1;for(var Ce=be.length,ae=0,de=0;de<Ce;de++)if(be[de]==="\\")de++;else if(be[de]===ge[0])ae++;else if(be[de]===ge[1]&&(ae--,ae<0))return de;return-1}function s(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(be,ge){if(ge<1)return"";for(var Ce="";ge>1;)ge&1&&(Ce+=be),ge>>=1,be+=be;return Ce+be}function B(be,ge,Ce,ae){var de=ge.href,Z=ge.title?g(ge.title):null,ne=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){ae.state.inLink=!0;var k={type:"link",raw:Ce,href:de,title:Z,text:ne,tokens:ae.inlineTokens(ne)};return ae.state.inLink=!1,k}return{type:"image",raw:Ce,href:de,title:Z,text:g(ne)}}function G(be,ge){var Ce=be.match(/^(\s+)(?:```)/);if(Ce===null)return ge;var ae=Ce[1];return ge.split(`
`).map(function(de){var Z=de.match(/^\s+/);if(Z===null)return de;var ne=Z[0];return ne.length>=ae.length?de.slice(ae.length):de}).join(`
`)}var q=function(){function be(Ce){this.options=Ce||te.defaults}var ge=be.prototype;return ge.space=function(ae){var de=this.rules.block.newline.exec(ae);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ge.code=function(ae){var de=this.rules.block.code.exec(ae);if(de){var Z=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:w(Z,`
`)}}},ge.fences=function(ae){var de=this.rules.block.fences.exec(ae);if(de){var Z=de[0],ne=G(Z,de[3]||"");return{type:"code",raw:Z,lang:de[2]?de[2].trim():de[2],text:ne}}},ge.heading=function(ae){var de=this.rules.block.heading.exec(ae);if(de){var Z=de[2].trim();if(/#$/.test(Z)){var ne=w(Z,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(Z=ne.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ge.hr=function(ae){var de=this.rules.block.hr.exec(ae);if(de)return{type:"hr",raw:de[0]}},ge.blockquote=function(ae){var de=this.rules.block.blockquote.exec(ae);if(de){var Z=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ge.list=function(ae){var de=this.rules.block.list.exec(ae);if(de){var Z,ne,k,z,H,j,ce,pe,ie,Se,_e,Be,He=de[1].trim(),Ze=He.length>1,Xe={type:"list",raw:"",ordered:Ze,start:Ze?+He.slice(0,-1):"",loose:!1,items:[]};He=Ze?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=Ze?He:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Be=!1,!(!(de=Ke.exec(ae))||this.rules.block.hr.test(ae)));){if(Z=de[0],ae=ae.substring(Z.length),pe=de[2].split(`
`,1)[0],ie=ae.split(`
`,1)[0],this.options.pedantic?(z=2,_e=pe.trimLeft()):(z=de[2].search(/[^ ]/),z=z>4?1:z,_e=pe.slice(z),z+=de[1].length),j=!1,!pe&&/^ *$/.test(ie)&&(Z+=ie+`
`,ae=ae.substring(ie.length+1),Be=!0),!Be)for(var it=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:```|~~~)"),Me=new RegExp("^ {0,"+Math.min(3,z-1)+"}#");ae&&(Se=ae.split(`
`,1)[0],pe=Se,this.options.pedantic&&(pe=pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(pe)||Me.test(pe)||it.test(pe)||st.test(ae)));){if(pe.search(/[^ ]/)>=z||!pe.trim())_e+=`
`+pe.slice(z);else if(!j)_e+=`
`+pe;else break;!j&&!pe.trim()&&(j=!0),Z+=Se+`
`,ae=ae.substring(Se.length+1)}Xe.loose||(ce?Xe.loose=!0:/\n *\n *$/.test(Z)&&(ce=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(_e),ne&&(k=ne[0]!=="[ ] ",_e=_e.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!ne,checked:k,loose:!1,text:_e}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=_e.trimRight(),Xe.raw=Xe.raw.trimRight();var dt=Xe.items.length;for(H=0;H<dt;H++){this.lexer.state.top=!1,Xe.items[H].tokens=this.lexer.blockTokens(Xe.items[H].text,[]);var Y=Xe.items[H].tokens.filter(function(fe){return fe.type==="space"}),J=Y.every(function(fe){for(var Ue=fe.raw.split(""),Ve=0,$e=M(Ue),Je;!(Je=$e()).done;){var mt=Je.value;if(mt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&Y.length&&J&&(Xe.loose=!0,Xe.items[H].loose=!0)}return Xe}},ge.html=function(ae){var de=this.rules.block.html.exec(ae);if(de){var Z={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ne=this.options.sanitizer?this.options.sanitizer(de[0]):g(de[0]);Z.type="paragraph",Z.text=ne,Z.tokens=this.lexer.inline(ne)}return Z}},ge.def=function(ae){var de=this.rules.block.def.exec(ae);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var Z=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:de[0],href:de[2],title:de[3]}}},ge.table=function(ae){var de=this.rules.block.table.exec(ae);if(de){var Z={type:"table",header:T(de[1]).map(function(ce){return{text:ce}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=de[0];var ne=Z.align.length,k,z,H,j;for(k=0;k<ne;k++)/^ *-+: *$/.test(Z.align[k])?Z.align[k]="right":/^ *:-+: *$/.test(Z.align[k])?Z.align[k]="center":/^ *:-+ *$/.test(Z.align[k])?Z.align[k]="left":Z.align[k]=null;for(ne=Z.rows.length,k=0;k<ne;k++)Z.rows[k]=T(Z.rows[k],Z.header.length).map(function(ce){return{text:ce}});for(ne=Z.header.length,z=0;z<ne;z++)Z.header[z].tokens=this.lexer.inline(Z.header[z].text);for(ne=Z.rows.length,z=0;z<ne;z++)for(j=Z.rows[z],H=0;H<j.length;H++)j[H].tokens=this.lexer.inline(j[H].text);return Z}}},ge.lheading=function(ae){var de=this.rules.block.lheading.exec(ae);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ge.paragraph=function(ae){var de=this.rules.block.paragraph.exec(ae);if(de){var Z=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:Z,tokens:this.lexer.inline(Z)}}},ge.text=function(ae){var de=this.rules.block.text.exec(ae);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ge.escape=function(ae){var de=this.rules.inline.escape.exec(ae);if(de)return{type:"escape",raw:de[0],text:g(de[1])}},ge.tag=function(ae){var de=this.rules.inline.tag.exec(ae);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):g(de[0]):de[0]}},ge.link=function(ae){var de=this.rules.inline.link.exec(ae);if(de){var Z=de[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var ne=w(Z.slice(0,-1),"\\");if((Z.length-ne.length)%2===0)return}else{var k=o(de[2],"()");if(k>-1){var z=de[0].indexOf("!")===0?5:4,H=z+de[1].length+k;de[2]=de[2].substring(0,k),de[0]=de[0].substring(0,H).trim(),de[3]=""}}var j=de[2],ce="";if(this.options.pedantic){var pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);pe&&(j=pe[1],ce=pe[3])}else ce=de[3]?de[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(Z)?j=j.slice(1):j=j.slice(1,-1)),B(de,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ge.reflink=function(ae,de){var Z;if((Z=this.rules.inline.reflink.exec(ae))||(Z=this.rules.inline.nolink.exec(ae))){var ne=(Z[2]||Z[1]).replace(/\s+/g," ");if(ne=de[ne.toLowerCase()],!ne||!ne.href){var k=Z[0].charAt(0);return{type:"text",raw:k,text:k}}return B(Z,ne,Z[0],this.lexer)}},ge.emStrong=function(ae,de,Z){Z===void 0&&(Z="");var ne=this.rules.inline.emStrong.lDelim.exec(ae);if(ne&&!(ne[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=ne[1]||ne[2]||"";if(!k||k&&(Z===""||this.rules.inline.punctuation.exec(Z))){var z=ne[0].length-1,H,j,ce=z,pe=0,ie=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,de=de.slice(-1*ae.length+z);(ne=ie.exec(de))!=null;)if(H=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!H){if(j=H.length,ne[3]||ne[4]){ce+=j;continue}else if((ne[5]||ne[6])&&z%3&&!((z+j)%3)){pe+=j;continue}if(ce-=j,!(ce>0)){if(j=Math.min(j,j+ce+pe),Math.min(z,j)%2){var Se=ae.slice(1,z+ne.index+j);return{type:"em",raw:ae.slice(0,z+ne.index+j+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var _e=ae.slice(2,z+ne.index+j-1);return{type:"strong",raw:ae.slice(0,z+ne.index+j+1),text:_e,tokens:this.lexer.inlineTokens(_e)}}}}}},ge.codespan=function(ae){var de=this.rules.inline.code.exec(ae);if(de){var Z=de[2].replace(/\n/g," "),ne=/[^ ]/.test(Z),k=/^ /.test(Z)&&/ $/.test(Z);return ne&&k&&(Z=Z.substring(1,Z.length-1)),Z=g(Z,!0),{type:"codespan",raw:de[0],text:Z}}},ge.br=function(ae){var de=this.rules.inline.br.exec(ae);if(de)return{type:"br",raw:de[0]}},ge.del=function(ae){var de=this.rules.inline.del.exec(ae);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ge.autolink=function(ae,de){var Z=this.rules.inline.autolink.exec(ae);if(Z){var ne,k;return Z[2]==="@"?(ne=g(this.options.mangle?de(Z[1]):Z[1]),k="mailto:"+ne):(ne=g(Z[1]),k=ne),{type:"link",raw:Z[0],text:ne,href:k,tokens:[{type:"text",raw:ne,text:ne}]}}},ge.url=function(ae,de){var Z;if(Z=this.rules.inline.url.exec(ae)){var ne,k;if(Z[2]==="@")ne=g(this.options.mangle?de(Z[0]):Z[0]),k="mailto:"+ne;else{var z;do z=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(z!==Z[0]);ne=g(Z[0]),Z[1]==="www."?k="http://"+ne:k=ne}return{type:"link",raw:Z[0],text:ne,href:k,tokens:[{type:"text",raw:ne,text:ne}]}}},ge.inlineText=function(ae,de){var Z=this.rules.inline.text.exec(ae);if(Z){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]:ne=g(this.options.smartypants?de(Z[0]):Z[0]),{type:"text",raw:Z[0],text:ne}}},be}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=h($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=h(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=h($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=h($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=h($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=h($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=f({},$),$.gfm=f({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=h($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=h($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=f({},$.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:h($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=h(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=h($._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=h(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=h(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=h(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=h(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=h(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=h(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=h(N.reflink).replace("label",N._label).replace("ref",$._label).getRegex(),N.nolink=h(N.nolink).replace("ref",$._label).getRegex(),N.reflinkSearch=h(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=f({},N),N.pedantic=f({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=f({},N.normal,{escape:h(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=h(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=f({},N.gfm,{br:h(N.br).replace("{2,}","*").getRegex(),text:h(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(be){var ge="",Ce,ae,de=be.length;for(Ce=0;Ce<de;Ce++)ae=be.charCodeAt(Ce),Math.random()>.5&&(ae="x"+ae.toString(16)),ge+="&#"+ae+";";return ge}var W=function(){function be(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||te.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:$.normal,inline:N.normal};this.options.pedantic?(ae.block=$.pedantic,ae.inline=N.pedantic):this.options.gfm&&(ae.block=$.gfm,this.options.breaks?ae.inline=N.breaks:ae.inline=N.gfm),this.tokenizer.rules=ae}be.lex=function(ae,de){var Z=new be(de);return Z.lex(ae)},be.lexInline=function(ae,de){var Z=new be(de);return Z.inlineTokens(ae)};var ge=be.prototype;return ge.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ge.blockTokens=function(ae,de){var Z=this;de===void 0&&(de=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(ce,pe,ie){return pe+"    ".repeat(ie.length)});for(var ne,k,z,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(ne=ce.call({lexer:Z},ae,de))?(ae=ae.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.space(ae)){ae=ae.substring(ne.raw.length),ne.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ne);continue}if(ne=this.tokenizer.code(ae)){ae=ae.substring(ne.raw.length),k=de[de.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+ne.raw,k.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):de.push(ne);continue}if(ne=this.tokenizer.fences(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.heading(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.hr(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.blockquote(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.list(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.html(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.def(ae)){ae=ae.substring(ne.raw.length),k=de[de.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+ne.raw,k.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.lheading(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(z=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,pe=ae.slice(1),ie=void 0;Z.options.extensions.startBlock.forEach(function(Se){ie=Se.call({lexer:this},pe),typeof ie=="number"&&ie>=0&&(ce=Math.min(ce,ie))}),ce<1/0&&ce>=0&&(z=ae.substring(0,ce+1))}(),this.state.top&&(ne=this.tokenizer.paragraph(z))){k=de[de.length-1],H&&k.type==="paragraph"?(k.raw+=`
`+ne.raw,k.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):de.push(ne),H=z.length!==ae.length,ae=ae.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(ae)){ae=ae.substring(ne.raw.length),k=de[de.length-1],k&&k.type==="text"?(k.raw+=`
`+ne.raw,k.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):de.push(ne);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,de},ge.inline=function(ae,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:ae,tokens:de}),de},ge.inlineTokens=function(ae,de){var Z=this;de===void 0&&(de=[]);var ne,k,z,H=ae,j,ce,pe;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)ie.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+F("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+F("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(ce||(pe=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(ne=_e.call({lexer:Z},ae,de))?(ae=ae.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.tag(ae)){ae=ae.substring(ne.raw.length),k=de[de.length-1],k&&ne.type==="text"&&k.type==="text"?(k.raw+=ne.raw,k.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.link(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ne.raw.length),k=de[de.length-1],k&&ne.type==="text"&&k.type==="text"?(k.raw+=ne.raw,k.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.emStrong(ae,H,pe)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.codespan(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.br(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.del(ae)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.autolink(ae,x)){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(ae,x))){ae=ae.substring(ne.raw.length),de.push(ne);continue}if(z=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=1/0,Be=ae.slice(1),He=void 0;Z.options.extensions.startInline.forEach(function(Ze){He=Ze.call({lexer:this},Be),typeof He=="number"&&He>=0&&(_e=Math.min(_e,He))}),_e<1/0&&_e>=0&&(z=ae.substring(0,_e+1))}(),ne=this.tokenizer.inlineText(z,V)){ae=ae.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(pe=ne.raw.slice(-1)),ce=!0,k=de[de.length-1],k&&k.type==="text"?(k.raw+=ne.raw,k.text+=ne.text):de.push(ne);continue}if(ae){var Se="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return de},i(be,null,[{key:"rules",get:function(){return{block:$,inline:N}}}]),be}(),ee=function(){function be(Ce){this.options=Ce||te.defaults}var ge=be.prototype;return ge.code=function(ae,de,Z){var ne=(de||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(ae,ne);k!=null&&k!==ae&&(Z=!0,ae=k)}return ae=ae.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+g(ne,!0)+'">'+(Z?ae:g(ae,!0))+`</code></pre>
`:"<pre><code>"+(Z?ae:g(ae,!0))+`</code></pre>
`},ge.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ge.html=function(ae){return ae},ge.heading=function(ae,de,Z,ne){if(this.options.headerIds){var k=this.options.headerPrefix+ne.slug(Z);return"<h"+de+' id="'+k+'">'+ae+"</h"+de+`>
`}return"<h"+de+">"+ae+"</h"+de+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(ae,de,Z){var ne=de?"ol":"ul",k=de&&Z!==1?' start="'+Z+'"':"";return"<"+ne+k+`>
`+ae+"</"+ne+`>
`},ge.listitem=function(ae){return"<li>"+ae+`</li>
`},ge.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(ae){return"<p>"+ae+`</p>
`},ge.table=function(ae,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+de+`</table>
`},ge.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ge.tablecell=function(ae,de){var Z=de.header?"th":"td",ne=de.align?"<"+Z+' align="'+de.align+'">':"<"+Z+">";return ne+ae+("</"+Z+`>
`)},ge.strong=function(ae){return"<strong>"+ae+"</strong>"},ge.em=function(ae){return"<em>"+ae+"</em>"},ge.codespan=function(ae){return"<code>"+ae+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(ae){return"<del>"+ae+"</del>"},ge.link=function(ae,de,Z){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var ne='<a href="'+g(ae)+'"';return de&&(ne+=' title="'+de+'"'),ne+=">"+Z+"</a>",ne},ge.image=function(ae,de,Z){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var ne='<img src="'+ae+'" alt="'+Z+'"';return de&&(ne+=' title="'+de+'"'),ne+=this.options.xhtml?"/>":">",ne},ge.text=function(ae){return ae},be}(),Ie=function(){function be(){}var ge=be.prototype;return ge.strong=function(ae){return ae},ge.em=function(ae){return ae},ge.codespan=function(ae){return ae},ge.del=function(ae){return ae},ge.html=function(ae){return ae},ge.text=function(ae){return ae},ge.link=function(ae,de,Z){return""+Z},ge.image=function(ae,de,Z){return""+Z},ge.br=function(){return""},be}(),oe=function(){function be(){this.seen={}}var ge=be.prototype;return ge.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(ae,de){var Z=ae,ne=0;if(this.seen.hasOwnProperty(Z)){ne=this.seen[ae];do ne++,Z=ae+"-"+ne;while(this.seen.hasOwnProperty(Z))}return de||(this.seen[ae]=ne,this.seen[Z]=0),Z},ge.slug=function(ae,de){de===void 0&&(de={});var Z=this.serialize(ae);return this.getNextSafeSlug(Z,de.dryrun)},be}(),ue=function(){function be(Ce){this.options=Ce||te.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ie,this.slugger=new oe}be.parse=function(ae,de){var Z=new be(de);return Z.parse(ae)},be.parseInline=function(ae,de){var Z=new be(de);return Z.parseInline(ae)};var ge=be.prototype;return ge.parse=function(ae,de){de===void 0&&(de=!0);var Z="",ne,k,z,H,j,ce,pe,ie,Se,_e,Be,He,Ze,Xe,Ke,it,st,tt,Me,dt=ae.length;for(ne=0;ne<dt;ne++){if(_e=ae[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(Me=this.options.extensions.renderers[_e.type].call({parser:this},_e),Me!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){Z+=Me||"";continue}switch(_e.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,t(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for(ie="",pe="",H=_e.header.length,k=0;k<H;k++)pe+=this.renderer.tablecell(this.parseInline(_e.header[k].tokens),{header:!0,align:_e.align[k]});for(ie+=this.renderer.tablerow(pe),Se="",H=_e.rows.length,k=0;k<H;k++){for(ce=_e.rows[k],pe="",j=ce.length,z=0;z<j;z++)pe+=this.renderer.tablecell(this.parseInline(ce[z].tokens),{header:!1,align:_e.align[z]});Se+=this.renderer.tablerow(pe)}Z+=this.renderer.table(ie,Se);continue}case"blockquote":{Se=this.parse(_e.tokens),Z+=this.renderer.blockquote(Se);continue}case"list":{for(Be=_e.ordered,He=_e.start,Ze=_e.loose,H=_e.items.length,Se="",k=0;k<H;k++)Ke=_e.items[k],it=Ke.checked,st=Ke.task,Xe="",Ke.task&&(tt=this.renderer.checkbox(it),Ze?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=tt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=tt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:tt}):Xe+=tt),Xe+=this.parse(Ke.tokens,Ze),Se+=this.renderer.listitem(Xe,st,it);Z+=this.renderer.list(Se,Be,He);continue}case"html":{Z+=this.renderer.html(_e.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(Se=_e.tokens?this.parseInline(_e.tokens):_e.text;ne+1<dt&&ae[ne+1].type==="text";)_e=ae[++ne],Se+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);Z+=de?this.renderer.paragraph(Se):Se;continue}default:{var Y='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(Y);return}else throw new Error(Y)}}}return Z},ge.parseInline=function(ae,de){de=de||this.renderer;var Z="",ne,k,z,H=ae.length;for(ne=0;ne<H;ne++){if(k=ae[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(z=this.options.extensions.renderers[k.type].call({parser:this},k),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){Z+=z||"";continue}switch(k.type){case"escape":{Z+=de.text(k.text);break}case"html":{Z+=de.html(k.text);break}case"link":{Z+=de.link(k.href,k.title,this.parseInline(k.tokens,de));break}case"image":{Z+=de.image(k.href,k.title,k.text);break}case"strong":{Z+=de.strong(this.parseInline(k.tokens,de));break}case"em":{Z+=de.em(this.parseInline(k.tokens,de));break}case"codespan":{Z+=de.codespan(k.text);break}case"br":{Z+=de.br();break}case"del":{Z+=de.del(this.parseInline(k.tokens,de));break}case"text":{Z+=de.text(k.text);break}default:{var j='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return Z},be}();function X(be,ge,Ce){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof ge=="function"&&(Ce=ge,ge=null),ge=f({},X.defaults,ge||{}),s(ge),Ce){var ae=ge.highlight,de;try{de=W.lex(be,ge)}catch(H){return Ce(H)}var Z=function(j){var ce;if(!j)try{ge.walkTokens&&X.walkTokens(de,ge.walkTokens),ce=ue.parse(de,ge)}catch(pe){j=pe}return ge.highlight=ae,j?Ce(j):Ce(null,ce)};if(!ae||ae.length<3||(delete ge.highlight,!de.length))return Z();var ne=0;X.walkTokens(de,function(H){H.type==="code"&&(ne++,setTimeout(function(){ae(H.text,H.lang,function(j,ce){if(j)return Z(j);ce!=null&&ce!==H.text&&(H.text=ce,H.escaped=!0),ne--,ne===0&&Z()})},0))}),ne===0&&Z();return}function k(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+g(H.message+"",!0)+"</pre>";throw H}try{var z=W.lex(be,ge);if(ge.walkTokens){if(ge.async)return Promise.all(X.walkTokens(z,ge.walkTokens)).then(function(){return ue.parse(z,ge)}).catch(k);X.walkTokens(z,ge.walkTokens)}return ue.parse(z,ge)}catch(H){k(H)}}X.options=X.setOptions=function(be){return f(X.defaults,be),A(X.defaults),X},X.getDefaults=O,X.defaults=te.defaults,X.use=function(){for(var be=arguments.length,ge=new Array(be),Ce=0;Ce<be;Ce++)ge[Ce]=arguments[Ce];var ae=f.apply(void 0,[{}].concat(ge)),de=X.defaults.extensions||{renderers:{},childTokens:{}},Z;ge.forEach(function(ne){if(ne.extensions&&(Z=!0,ne.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var H=de.renderers?de.renderers[z.name]:null;H?de.renderers[z.name]=function(){for(var j=arguments.length,ce=new Array(j),pe=0;pe<j;pe++)ce[pe]=arguments[pe];var ie=z.renderer.apply(this,ce);return ie===!1&&(ie=H.apply(this,ce)),ie}:de.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[z.level]?de[z.level].unshift(z.tokenizer):de[z.level]=[z.tokenizer],z.start&&(z.level==="block"?de.startBlock?de.startBlock.push(z.start):de.startBlock=[z.start]:z.level==="inline"&&(de.startInline?de.startInline.push(z.start):de.startInline=[z.start]))}z.childTokens&&(de.childTokens[z.name]=z.childTokens)})),ne.renderer&&function(){var z=X.defaults.renderer||new ee,H=function(pe){var ie=z[pe];z[pe]=function(){for(var Se=arguments.length,_e=new Array(Se),Be=0;Be<Se;Be++)_e[Be]=arguments[Be];var He=ne.renderer[pe].apply(z,_e);return He===!1&&(He=ie.apply(z,_e)),He}};for(var j in ne.renderer)H(j);ae.renderer=z}(),ne.tokenizer&&function(){var z=X.defaults.tokenizer||new q,H=function(pe){var ie=z[pe];z[pe]=function(){for(var Se=arguments.length,_e=new Array(Se),Be=0;Be<Se;Be++)_e[Be]=arguments[Be];var He=ne.tokenizer[pe].apply(z,_e);return He===!1&&(He=ie.apply(z,_e)),He}};for(var j in ne.tokenizer)H(j);ae.tokenizer=z}(),ne.walkTokens){var k=X.defaults.walkTokens;ae.walkTokens=function(z){var H=[];return H.push(ne.walkTokens.call(this,z)),k&&(H=H.concat(k.call(this,z))),H}}Z&&(ae.extensions=de),X.setOptions(ae)})},X.walkTokens=function(be,ge){for(var Ce=[],ae=function(){var k=Z.value;switch(Ce=Ce.concat(ge.call(X,k)),k.type){case"table":{for(var z=M(k.header),H;!(H=z()).done;){var j=H.value;Ce=Ce.concat(X.walkTokens(j.tokens,ge))}for(var ce=M(k.rows),pe;!(pe=ce()).done;)for(var ie=pe.value,Se=M(ie),_e;!(_e=Se()).done;){var Be=_e.value;Ce=Ce.concat(X.walkTokens(Be.tokens,ge))}break}case"list":{Ce=Ce.concat(X.walkTokens(k.items,ge));break}default:X.defaults.extensions&&X.defaults.extensions.childTokens&&X.defaults.extensions.childTokens[k.type]?X.defaults.extensions.childTokens[k.type].forEach(function(He){Ce=Ce.concat(X.walkTokens(k[He],ge))}):k.tokens&&(Ce=Ce.concat(X.walkTokens(k.tokens,ge)))}},de=M(be),Z;!(Z=de()).done;)ae();return Ce},X.parseInline=function(be,ge){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");ge=f({},X.defaults,ge||{}),s(ge);try{var Ce=W.lexInline(be,ge);return ge.walkTokens&&X.walkTokens(Ce,ge.walkTokens),ue.parseInline(Ce,ge)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+g(ae.message+"",!0)+"</pre>";throw ae}},X.Parser=ue,X.parser=ue.parse,X.Renderer=ee,X.TextRenderer=Ie,X.Lexer=W,X.lexer=W.lex,X.Tokenizer=q,X.Slugger=oe,X.parse=X;var le=X.options,De=X.setOptions,Te=X.use,Ee=X.walkTokens,P=X.parseInline,K=X,he=ue.parse,ye=W.lex;te.Lexer=W,te.Parser=ue,te.Renderer=ee,te.Slugger=oe,te.TextRenderer=Ie,te.Tokenizer=q,te.getDefaults=O,te.lexer=ye,te.marked=X,te.options=le,te.parse=K,te.parseInline=P,te.parser=he,te.setOptions=De,te.use=Te,te.walkTokens=Ee,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(A,_,m){return Math.min(Math.max(A,_),m)}e.clamp=i;function C(A,_){return(_+A%_)%_}e.rot=C;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class M{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class O{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const m=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=O}),function(){function te(y){const M=[];typeof y=="number"&&M.push("code/timeOrigin",y);function O(_){M.push(_,Date.now())}function A(){const _=[];for(let m=0;m<M.length;m+=2)_.push({name:M[m],startTime:M[m+1]});return _}return{mark:O,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const O of performance.getEntriesByType("mark"))M.push({name:O.name,startTime:Math.round(y+O.startTime)});return M}};if(typeof process=="object"){const y=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=i(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var C in i)(typeof exports=="object"?exports:te)[C]=i[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function i(C){if(e[C])return e[C].exports;var y=e[C]={i:C,l:!1,exports:{}};return te[C].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=te,i.c=e,i.d=function(C,y,M){i.o(C,y)||Object.defineProperty(C,y,{enumerable:!0,get:M})},i.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},i.t=function(C,y){if(1&y&&(C=i(C)),8&y||4&y&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(i.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&y&&typeof C!="string")for(var O in C)i.d(M,O,function(A){return C[A]}.bind(null,O));return M},i.n=function(C){var y=C&&C.__esModule?function(){return C.default}:function(){return C};return i.d(y,"a",y),y},i.o=function(C,y){return Object.prototype.hasOwnProperty.call(C,y)},i.p="",i(i.s=0)}([function(te,e,i){(function(C){var y;e=te.exports=Te,y=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],_=e.src=[],m=0,R=m++;_[R]="0|[1-9]\\d*";var b=m++;_[b]="[0-9]+";var c=m++;_[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=m++;_[p]="("+_[R]+")\\.("+_[R]+")\\.("+_[R]+")";var g=m++;_[g]="("+_[b]+")\\.("+_[b]+")\\.("+_[b]+")";var d=m++;_[d]="(?:"+_[R]+"|"+_[c]+")";var t=m++;_[t]="(?:"+_[b]+"|"+_[c]+")";var l=m++;_[l]="(?:-("+_[d]+"(?:\\."+_[d]+")*))";var h=m++;_[h]="(?:-?("+_[t]+"(?:\\."+_[t]+")*))";var S=m++;_[S]="[0-9A-Za-z-]+";var I=m++;_[I]="(?:\\+("+_[S]+"(?:\\."+_[S]+")*))";var v=m++,n="v?"+_[p]+_[l]+"?"+_[I]+"?";_[v]="^"+n+"$";var u="[v=\\s]*"+_[g]+_[h]+"?"+_[I]+"?",r=m++;_[r]="^"+u+"$";var a=m++;_[a]="((?:<|>)?=?)";var E=m++;_[E]=_[b]+"|x|X|\\*";var D=m++;_[D]=_[R]+"|x|X|\\*";var f=m++;_[f]="[v=\\s]*("+_[D]+")(?:\\.("+_[D]+")(?:\\.("+_[D]+")(?:"+_[l]+")?"+_[I]+"?)?)?";var T=m++;_[T]="[v=\\s]*("+_[E]+")(?:\\.("+_[E]+")(?:\\.("+_[E]+")(?:"+_[h]+")?"+_[I]+"?)?)?";var w=m++;_[w]="^"+_[a]+"\\s*"+_[f]+"$";var o=m++;_[o]="^"+_[a]+"\\s*"+_[T]+"$";var s=m++;_[s]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=m++;_[F]="(?:~>?)";var B=m++;_[B]="(\\s*)"+_[F]+"\\s+",A[B]=new RegExp(_[B],"g");var G=m++;_[G]="^"+_[F]+_[f]+"$";var q=m++;_[q]="^"+_[F]+_[T]+"$";var $=m++;_[$]="(?:\\^)";var N=m++;_[N]="(\\s*)"+_[$]+"\\s+",A[N]=new RegExp(_[N],"g");var V=m++;_[V]="^"+_[$]+_[f]+"$";var x=m++;_[x]="^"+_[$]+_[T]+"$";var W=m++;_[W]="^"+_[a]+"\\s*("+u+")$|^$";var ee=m++;_[ee]="^"+_[a]+"\\s*("+n+")$|^$";var Ie=m++;_[Ie]="(\\s*)"+_[a]+"\\s*("+u+"|"+_[f]+")",A[Ie]=new RegExp(_[Ie],"g");var oe=m++;_[oe]="^\\s*("+_[f]+")\\s+-\\s+("+_[f]+")\\s*$";var ue=m++;_[ue]="^\\s*("+_[T]+")\\s+-\\s+("+_[T]+")\\s*$";var X=m++;_[X]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)y(le,_[le]),A[le]||(A[le]=new RegExp(_[le]));function De(ie,Se){if(ie instanceof Te)return ie;if(typeof ie!="string"||ie.length>M||!(Se?A[r]:A[v]).test(ie))return null;try{return new Te(ie,Se)}catch{return null}}function Te(ie,Se){if(ie instanceof Te){if(ie.loose===Se)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Te))return new Te(ie,Se);y("SemVer",ie,Se),this.loose=Se;var _e=ie.trim().match(Se?A[r]:A[v]);if(!_e)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+_e[1],this.minor=+_e[2],this.patch=+_e[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");_e[4]?this.prerelease=_e[4].split(".").map(function(Be){if(/^[0-9]+$/.test(Be)){var He=+Be;if(He>=0&&He<O)return He}return Be}):this.prerelease=[],this.build=_e[5]?_e[5].split("."):[],this.format()}e.parse=De,e.valid=function(ie,Se){var _e=De(ie,Se);return _e?_e.version:null},e.clean=function(ie,Se){var _e=De(ie.trim().replace(/^[=v]+/,""),Se);return _e?_e.version:null},e.SemVer=Te,Te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Te.prototype.toString=function(){return this.version},Te.prototype.compare=function(ie){return y("SemVer.compare",this.version,this.loose,ie),ie instanceof Te||(ie=new Te(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},Te.prototype.compareMain=function(ie){return ie instanceof Te||(ie=new Te(ie,this.loose)),P(this.major,ie.major)||P(this.minor,ie.minor)||P(this.patch,ie.patch)},Te.prototype.comparePre=function(ie){if(ie instanceof Te||(ie=new Te(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var Se=0;do{var _e=this.prerelease[Se],Be=ie.prerelease[Se];if(y("prerelease compare",Se,_e,Be),_e===void 0&&Be===void 0)return 0;if(Be===void 0)return 1;if(_e===void 0)return-1;if(_e!==Be)return P(_e,Be)}while(++Se)},Te.prototype.inc=function(ie,Se){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _e=this.prerelease.length;--_e>=0;)typeof this.prerelease[_e]=="number"&&(this.prerelease[_e]++,_e=-2);_e===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,Se,_e,Be){typeof _e=="string"&&(Be=_e,_e=void 0);try{return new Te(ie,_e).inc(Se,Be).version}catch{return null}},e.diff=function(ie,Se){if(be(ie,Se))return null;var _e=De(ie),Be=De(Se);if(_e.prerelease.length||Be.prerelease.length){for(var He in _e)if((He==="major"||He==="minor"||He==="patch")&&_e[He]!==Be[He])return"pre"+He;return"prerelease"}for(var He in _e)if((He==="major"||He==="minor"||He==="patch")&&_e[He]!==Be[He])return He},e.compareIdentifiers=P;var Ee=/^[0-9]+$/;function P(ie,Se){var _e=Ee.test(ie),Be=Ee.test(Se);return _e&&Be&&(ie=+ie,Se=+Se),_e&&!Be?-1:Be&&!_e?1:ie<Se?-1:ie>Se?1:0}function K(ie,Se,_e){return new Te(ie,_e).compare(new Te(Se,_e))}function he(ie,Se,_e){return K(ie,Se,_e)>0}function ye(ie,Se,_e){return K(ie,Se,_e)<0}function be(ie,Se,_e){return K(ie,Se,_e)===0}function ge(ie,Se,_e){return K(ie,Se,_e)!==0}function Ce(ie,Se,_e){return K(ie,Se,_e)>=0}function ae(ie,Se,_e){return K(ie,Se,_e)<=0}function de(ie,Se,_e,Be){var He;switch(Se){case"===":typeof ie=="object"&&(ie=ie.version),typeof _e=="object"&&(_e=_e.version),He=ie===_e;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof _e=="object"&&(_e=_e.version),He=ie!==_e;break;case"":case"=":case"==":He=be(ie,_e,Be);break;case"!=":He=ge(ie,_e,Be);break;case">":He=he(ie,_e,Be);break;case">=":He=Ce(ie,_e,Be);break;case"<":He=ye(ie,_e,Be);break;case"<=":He=ae(ie,_e,Be);break;default:throw new TypeError("Invalid operator: "+Se)}return He}function Z(ie,Se){if(ie instanceof Z){if(ie.loose===Se)return ie;ie=ie.value}if(!(this instanceof Z))return new Z(ie,Se);y("comparator",ie,Se),this.loose=Se,this.parse(ie),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(ie,Se){return P(Se,ie)},e.major=function(ie,Se){return new Te(ie,Se).major},e.minor=function(ie,Se){return new Te(ie,Se).minor},e.patch=function(ie,Se){return new Te(ie,Se).patch},e.compare=K,e.compareLoose=function(ie,Se){return K(ie,Se,!0)},e.rcompare=function(ie,Se,_e){return K(Se,ie,_e)},e.sort=function(ie,Se){return ie.sort(function(_e,Be){return e.compare(_e,Be,Se)})},e.rsort=function(ie,Se){return ie.sort(function(_e,Be){return e.rcompare(_e,Be,Se)})},e.gt=he,e.lt=ye,e.eq=be,e.neq=ge,e.gte=Ce,e.lte=ae,e.cmp=de,e.Comparator=Z;var ne={};function k(ie,Se){if(ie instanceof k)return ie.loose===Se?ie:new k(ie.raw,Se);if(ie instanceof Z)return new k(ie.value,Se);if(!(this instanceof k))return new k(ie,Se);if(this.loose=Se,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(_e){return this.parseRange(_e.trim())},this).filter(function(_e){return _e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function z(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function H(ie,Se,_e,Be,He,Ze,Xe,Ke,it,st,tt,Me,dt){return((Se=z(_e)?"":z(Be)?">="+_e+".0.0":z(He)?">="+_e+"."+Be+".0":">="+Se)+" "+(Ke=z(it)?"":z(st)?"<"+(+it+1)+".0.0":z(tt)?"<"+it+"."+(+st+1)+".0":Me?"<="+it+"."+st+"."+tt+"-"+Me:"<="+Ke)).trim()}function j(ie,Se){for(var _e=0;_e<ie.length;_e++)if(!ie[_e].test(Se))return!1;if(Se.prerelease.length){for(_e=0;_e<ie.length;_e++)if(y(ie[_e].semver),ie[_e].semver!==ne&&ie[_e].semver.prerelease.length>0){var Be=ie[_e].semver;if(Be.major===Se.major&&Be.minor===Se.minor&&Be.patch===Se.patch)return!0}return!1}return!0}function ce(ie,Se,_e){try{Se=new k(Se,_e)}catch{return!1}return Se.test(ie)}function pe(ie,Se,_e,Be){var He,Ze,Xe,Ke,it;switch(ie=new Te(ie,Be),Se=new k(Se,Be),_e){case">":He=he,Ze=ae,Xe=ye,Ke=">",it=">=";break;case"<":He=ye,Ze=Ce,Xe=he,Ke="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ce(ie,Se,Be))return!1;for(var st=0;st<Se.set.length;++st){var tt=Se.set[st],Me=null,dt=null;if(tt.forEach(function(Y){Y.semver===ne&&(Y=new Z(">=0.0.0")),Me=Me||Y,dt=dt||Y,He(Y.semver,Me.semver,Be)?Me=Y:Xe(Y.semver,dt.semver,Be)&&(dt=Y)}),Me.operator===Ke||Me.operator===it||(!dt.operator||dt.operator===Ke)&&Ze(ie,dt.semver)||dt.operator===it&&Xe(ie,dt.semver))return!1}return!0}Z.prototype.parse=function(ie){var Se=this.loose?A[W]:A[ee],_e=ie.match(Se);if(!_e)throw new TypeError("Invalid comparator: "+ie);this.operator=_e[1],this.operator==="="&&(this.operator=""),_e[2]?this.semver=new Te(_e[2],this.loose):this.semver=ne},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(ie){return y("Comparator.test",ie,this.loose),this.semver===ne||(typeof ie=="string"&&(ie=new Te(ie,this.loose)),de(ie,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(ie,Se){if(!(ie instanceof Z))throw new TypeError("a Comparator is required");var _e;if(this.operator==="")return _e=new k(ie.value,Se),ce(this.value,_e,Se);if(ie.operator==="")return _e=new k(this.value,Se),ce(ie.semver,_e,Se);var Be=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Ze=this.semver.version===ie.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Ke=de(this.semver,"<",ie.semver,Se)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),it=de(this.semver,">",ie.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return Be||He||Ze&&Xe||Ke||it},e.Range=k,k.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},k.prototype.toString=function(){return this.range},k.prototype.parseRange=function(ie){var Se=this.loose;ie=ie.trim(),y("range",ie,Se);var _e=Se?A[ue]:A[oe];ie=ie.replace(_e,H),y("hyphen replace",ie),ie=ie.replace(A[Ie],"$1$2$3"),y("comparator trim",ie,A[Ie]),ie=(ie=(ie=ie.replace(A[B],"$1~")).replace(A[N],"$1^")).split(/\s+/).join(" ");var Be=Se?A[W]:A[ee],He=ie.split(" ").map(function(Ze){return function(Xe,Ke){return y("comp",Xe),Xe=function(it,st){return it.trim().split(/\s+/).map(function(tt){return function(Me,dt){y("caret",Me,dt);var Y=dt?A[x]:A[V];return Me.replace(Y,function(J,fe,Ue,Ve,$e){var Je;return y("caret",Me,J,fe,Ue,Ve,$e),z(fe)?Je="":z(Ue)?Je=">="+fe+".0.0 <"+(+fe+1)+".0.0":z(Ve)?Je=fe==="0"?">="+fe+"."+Ue+".0 <"+fe+"."+(+Ue+1)+".0":">="+fe+"."+Ue+".0 <"+(+fe+1)+".0.0":$e?(y("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Je=fe==="0"?Ue==="0"?">="+fe+"."+Ue+"."+Ve+$e+" <"+fe+"."+Ue+"."+(+Ve+1):">="+fe+"."+Ue+"."+Ve+$e+" <"+fe+"."+(+Ue+1)+".0":">="+fe+"."+Ue+"."+Ve+$e+" <"+(+fe+1)+".0.0"):(y("no pr"),Je=fe==="0"?Ue==="0"?">="+fe+"."+Ue+"."+Ve+" <"+fe+"."+Ue+"."+(+Ve+1):">="+fe+"."+Ue+"."+Ve+" <"+fe+"."+(+Ue+1)+".0":">="+fe+"."+Ue+"."+Ve+" <"+(+fe+1)+".0.0"),y("caret return",Je),Je})}(tt,st)}).join(" ")}(Xe,Ke),y("caret",Xe),Xe=function(it,st){return it.trim().split(/\s+/).map(function(tt){return function(Me,dt){var Y=dt?A[q]:A[G];return Me.replace(Y,function(J,fe,Ue,Ve,$e){var Je;return y("tilde",Me,J,fe,Ue,Ve,$e),z(fe)?Je="":z(Ue)?Je=">="+fe+".0.0 <"+(+fe+1)+".0.0":z(Ve)?Je=">="+fe+"."+Ue+".0 <"+fe+"."+(+Ue+1)+".0":$e?(y("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Je=">="+fe+"."+Ue+"."+Ve+$e+" <"+fe+"."+(+Ue+1)+".0"):Je=">="+fe+"."+Ue+"."+Ve+" <"+fe+"."+(+Ue+1)+".0",y("tilde return",Je),Je})}(tt,st)}).join(" ")}(Xe,Ke),y("tildes",Xe),Xe=function(it,st){return y("replaceXRanges",it,st),it.split(/\s+/).map(function(tt){return function(Me,dt){Me=Me.trim();var Y=dt?A[o]:A[w];return Me.replace(Y,function(J,fe,Ue,Ve,$e,Je){y("xRange",Me,J,fe,Ue,Ve,$e,Je);var mt=z(Ue),_t=mt||z(Ve),Ct=_t||z($e);return fe==="="&&Ct&&(fe=""),mt?J=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Ct?(_t&&(Ve=0),Ct&&($e=0),fe===">"?(fe=">=",_t?(Ue=+Ue+1,Ve=0,$e=0):Ct&&(Ve=+Ve+1,$e=0)):fe==="<="&&(fe="<",_t?Ue=+Ue+1:Ve=+Ve+1),J=fe+Ue+"."+Ve+"."+$e):_t?J=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":Ct&&(J=">="+Ue+"."+Ve+".0 <"+Ue+"."+(+Ve+1)+".0"),y("xRange return",J),J})}(tt,st)}).join(" ")}(Xe,Ke),y("xrange",Xe),Xe=function(it,st){return y("replaceStars",it,st),it.trim().replace(A[X],"")}(Xe,Ke),y("stars",Xe),Xe}(Ze,Se)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(Ze){return!!Ze.match(Be)})),He=He.map(function(Ze){return new Z(Ze,Se)})},k.prototype.intersects=function(ie,Se){if(!(ie instanceof k))throw new TypeError("a Range is required");return this.set.some(function(_e){return _e.every(function(Be){return ie.set.some(function(He){return He.every(function(Ze){return Be.intersects(Ze,Se)})})})})},e.toComparators=function(ie,Se){return new k(ie,Se).set.map(function(_e){return _e.map(function(Be){return Be.value}).join(" ").trim().split(" ")})},k.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new Te(ie,this.loose));for(var Se=0;Se<this.set.length;Se++)if(j(this.set[Se],ie))return!0;return!1},e.satisfies=ce,e.maxSatisfying=function(ie,Se,_e){var Be=null,He=null;try{var Ze=new k(Se,_e)}catch{return null}return ie.forEach(function(Xe){Ze.test(Xe)&&(Be&&He.compare(Xe)!==-1||(He=new Te(Be=Xe,_e)))}),Be},e.minSatisfying=function(ie,Se,_e){var Be=null,He=null;try{var Ze=new k(Se,_e)}catch{return null}return ie.forEach(function(Xe){Ze.test(Xe)&&(Be&&He.compare(Xe)!==1||(He=new Te(Be=Xe,_e)))}),Be},e.validRange=function(ie,Se){try{return new k(ie,Se).range||"*"}catch{return null}},e.ltr=function(ie,Se,_e){return pe(ie,Se,"<",_e)},e.gtr=function(ie,Se,_e){return pe(ie,Se,">",_e)},e.outside=pe,e.prerelease=function(ie,Se){var _e=De(ie,Se);return _e&&_e.prerelease.length?_e.prerelease:null},e.intersects=function(ie,Se,_e){return ie=new k(ie,_e),Se=new k(Se,_e),ie.intersects(Se)},e.coerce=function(ie){if(ie instanceof Te)return ie;if(typeof ie!="string")return null;var Se=ie.match(A[s]);return Se==null?null:De((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,i(1))},function(te,e){var i,C,y=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function A(t){if(i===setTimeout)return setTimeout(t,0);if((i===M||!i)&&setTimeout)return i=setTimeout,setTimeout(t,0);try{return i(t,0)}catch{try{return i.call(null,t,0)}catch{return i.call(this,t,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:M}catch{i=M}try{C=typeof clearTimeout=="function"?clearTimeout:O}catch{C=O}})();var _,m=[],R=!1,b=-1;function c(){R&&_&&(R=!1,_.length?m=_.concat(m):b=-1,m.length&&p())}function p(){if(!R){var t=A(c);R=!0;for(var l=m.length;l;){for(_=m,m=[];++b<l;)_&&_[b].run();b=-1,l=m.length}_=null,R=!1,function(h){if(C===clearTimeout)return clearTimeout(h);if((C===O||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(h);try{C(h)}catch{try{return C.call(null,h)}catch{return C.call(this,h)}}}(t)}}function g(t,l){this.fun=t,this.array=l}function d(){}y.nextTick=function(t){var l=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)l[h-1]=arguments[h];m.push(new g(t,l)),m.length!==1||R||A(p)},g.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=d,y.addListener=d,y.once=d,y.off=d,y.removeListener=d,y.removeAllListeners=d,y.emit=d,y.prependListener=d,y.prependOnceListener=d,y.listeners=function(t){return[]},y.binding=function(t){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(t){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,10,6]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(I){const v=I;return v?typeof v.read=="function":!1}e.isReadable=y;function M(I){const v=I;return v?[v.on,v.pause,v.resume,v.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=M;function O(I){const v=I;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=O;function A(I,v){return new _(I,v)}e.newWriteableStream=A;class _{constructor(v,n){this.reducer=v,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(n=>n(v))}emitError(v){this.listeners.error.length===0?(0,i.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(n=>n(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,n){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(v,n){if(this.state.destroyed)return;let u;switch(v){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const r=u.indexOf(n);r>=0&&u.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(I,v){const n=[];let u;for(;(u=I.read())!==null;)n.push(u);return v(n)}e.consumeReadable=m;function R(I,v,n){const u=[];let r;for(;(r=I.read())!==null&&u.length<n;)u.push(r);return r===null&&u.length>0?v(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return I.read()}}}e.peekReadable=R;function b(I,v){return new Promise((n,u)=>{const r=[];c(I,{onData:a=>{v&&r.push(a)},onError:a=>{v?u(a):n(void 0)},onEnd:()=>{n(v?v(r):void 0)}})})}e.consumeStream=b;function c(I,v){let n=!1;return I.on("error",u=>{n||v.onError(u)}),I.on("end",()=>{n||v.onEnd()}),I.on("data",u=>{n||v.onData(u)}),(0,C.toDisposable)(()=>n=!0)}e.listenStream=c;function p(I,v){return new Promise((n,u)=>{const r=new C.DisposableStore,a=[],E=T=>{if(a.push(T),a.length>v)return r.dispose(),I.pause(),n({stream:I,buffer:a,ended:!1})},D=T=>u(T),f=()=>n({stream:I,buffer:a,ended:!0});r.add((0,C.toDisposable)(()=>I.removeListener("error",D))),I.on("error",D),r.add((0,C.toDisposable)(()=>I.removeListener("end",f))),I.on("end",f),r.add((0,C.toDisposable)(()=>I.removeListener("data",E))),I.on("data",E)})}e.peekStream=p;function g(I,v){const n=A(v);return n.end(I),n}e.toStream=g;function d(){const I=A(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=d;function t(I){let v=!1;return{read:()=>v?null:(v=!0,I)}}e.toReadable=t;function l(I,v,n){const u=A(n);return c(I,{onData:r=>u.write(v.data(r)),onError:r=>u.error(v.error?v.error(r):r),onEnd:()=>u.end()}),u}e.transform=l;function h(I,v,n){let u=!1;return{read:()=>{const r=v.read();return u?r:(u=!0,r!==null?n([I,r]):I)}}}e.prefixedReadable=h;function S(I,v,n){let u=!1;const r=A(n);return c(v,{onData:a=>u?r.write(a):(u=!0,r.write(n([I,a]))),onError:a=>r.error(a),onEnd:()=>{u||(u=!0,r.write(I)),r.end()}}),r}e.prefixedStream=S}),define(Ae[24],Re([1,0,66,118]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const y=typeof Buffer<"u",M=new i.Lazy(()=>new Uint8Array(256));let O,A;class _{static alloc(o){return y?new _(Buffer.allocUnsafe(o)):new _(new Uint8Array(o))}static wrap(o){return y&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new _(o)}static fromString(o,s){return!(s?.dontUseNodeBuffer||!1)&&y?new _(Buffer.from(o)):(O||(O=new TextEncoder),new _(O.encode(o)))}static fromByteArray(o){const s=_.alloc(o.length);for(let F=0,B=o.length;F<B;F++)s.buffer[F]=o[F];return s}static concat(o,s){if(typeof s>"u"){s=0;for(let G=0,q=o.length;G<q;G++)s+=o[G].byteLength}const F=_.alloc(s);let B=0;for(let G=0,q=o.length;G<q;G++){const $=o[G];F.set($,B),B+=$.byteLength}return F}constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}clone(){const o=_.alloc(this.byteLength);return o.set(this),o}toString(){return y?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(o,s){return new _(this.buffer.subarray(o,s))}set(o,s){if(o instanceof _)this.buffer.set(o.buffer,s);else if(o instanceof Uint8Array)this.buffer.set(o,s);else if(o instanceof ArrayBuffer)this.buffer.set(new Uint8Array(o),s);else if(ArrayBuffer.isView(o))this.buffer.set(new Uint8Array(o.buffer,o.byteOffset,o.byteLength),s);else throw new Error("Unknown argument 'array'")}readUInt32BE(o){return b(this.buffer,o)}writeUInt32BE(o,s){c(this.buffer,o,s)}readUInt32LE(o){return p(this.buffer,o)}writeUInt32LE(o,s){g(this.buffer,o,s)}readUInt8(o){return d(this.buffer,o)}writeUInt8(o,s){t(this.buffer,o,s)}indexOf(o){const s=o instanceof _?o.buffer:o,F=s.byteLength,B=this.buffer,G=B.byteLength;if(F===0)return 0;if(F===1)return B.indexOf(s[0]);if(F>G)return-1;const q=M.value;q.fill(s.length);for(let x=0;x<s.length;x++)q[s[x]]=s.length-x-1;let $=s.length-1,N=$,V=-1;for(;$<G;)if(B[$]===s[N]){if(N===0){V=$;break}$--,N--}else $+=Math.max(s.length-N,q[B[$]]),N=s.length-1;return V}}e.VSBuffer=_;function m(w,o){return w[o+0]<<0>>>0|w[o+1]<<8>>>0}e.readUInt16LE=m;function R(w,o,s){w[s+0]=o&255,o=o>>>8,w[s+1]=o&255}e.writeUInt16LE=R;function b(w,o){return w[o]*2**24+w[o+1]*2**16+w[o+2]*2**8+w[o+3]}e.readUInt32BE=b;function c(w,o,s){w[s+3]=o,o=o>>>8,w[s+2]=o,o=o>>>8,w[s+1]=o,o=o>>>8,w[s]=o}e.writeUInt32BE=c;function p(w,o){return w[o+0]<<0>>>0|w[o+1]<<8>>>0|w[o+2]<<16>>>0|w[o+3]<<24>>>0}e.readUInt32LE=p;function g(w,o,s){w[s+0]=o&255,o=o>>>8,w[s+1]=o&255,o=o>>>8,w[s+2]=o&255,o=o>>>8,w[s+3]=o&255}e.writeUInt32LE=g;function d(w,o){return w[o]}e.readUInt8=d;function t(w,o,s){w[s]=o}e.writeUInt8=t;function l(w){return C.consumeReadable(w,o=>_.concat(o))}e.readableToBuffer=l;function h(w){return C.toReadable(w)}e.bufferToReadable=h;function S(w){return C.consumeStream(w,o=>_.concat(o))}e.streamToBuffer=S;async function I(w){return w.ended?_.concat(w.buffer):_.concat([...w.buffer,await S(w.stream)])}e.bufferedStreamToBuffer=I;function v(w){return C.toStream(w,o=>_.concat(o))}e.bufferToStream=v;function n(w){return C.transform(w,{data:o=>typeof o=="string"?_.fromString(o):_.wrap(o)},o=>_.concat(o))}e.streamToBufferReadableStream=n;function u(w){return C.newWriteableStream(o=>_.concat(o),w)}e.newWriteableBufferStream=u;function r(w,o){return C.prefixedReadable(w,o,s=>_.concat(s))}e.prefixedBufferReadable=r;function a(w,o){return C.prefixedStream(w,o,s=>_.concat(s))}e.prefixedBufferStream=a;function E(w){let o=0,s=0,F=0;const B=new Uint8Array(Math.floor(w.length/4*3)),G=$=>{switch(s){case 3:B[F++]=o|$,s=0;break;case 2:B[F++]=o|$>>>2,o=$<<6,s=3;break;case 1:B[F++]=o|$>>>4,o=$<<4,s=2;break;default:o=$<<2,s=1}};for(let $=0;$<w.length;$++){const N=w.charCodeAt($);if(N>=65&&N<=90)G(N-65);else if(N>=97&&N<=122)G(N-97+26);else if(N>=48&&N<=57)G(N-48+52);else if(N===43||N===45)G(62);else if(N===47||N===95)G(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${w[$]}`)}}const q=F;for(;s>0;)G(0);return _.wrap(B).slice(0,q)}e.decodeBase64=E;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:w},o=!0,s=!1){const F=s?f:D;let B="";const G=w.byteLength%3;let q=0;for(;q<w.byteLength-G;q+=3){const $=w[q+0],N=w[q+1],V=w[q+2];B+=F[$>>>2],B+=F[($<<4|N>>>4)&63],B+=F[(N<<2|V>>>6)&63],B+=F[V&63]}if(G===1){const $=w[q+0];B+=F[$>>>2],B+=F[$<<4&63],o&&(B+="==")}else if(G===2){const $=w[q+0],N=w[q+1];B+=F[$>>>2],B+=F[($<<4|N>>>4)&63],B+=F[N<<2&63],o&&(B+="=")}return B}e.encodeBase64=T}),define(Ae[119],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ae[39],Re([1,0,87]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var C;(function(O){function A(_){return _&&typeof _=="object"&&typeof _.id=="string"}O.isThemeColor=A})(C||(e.ThemeColor=C={}));function y(O){return{id:O}}e.themeColorFromId=y;var M;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function _(h){const S=A.exec(h.id);if(!S)return _(i.Codicon.error);const[,I,v]=S,n=["codicon","codicon-"+I];return v&&n.push("codicon-modifier-"+v.substring(1)),n}O.asClassNameArray=_;function m(h){return _(h).join(" ")}O.asClassName=m;function R(h){return"."+_(h).join(".")}O.asCSSSelector=R;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||C.isThemeColor(h.color))}O.isThemeIcon=b;const c=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function p(h){const S=c.exec(h);if(!S)return;const[,I]=S;return{id:I}}O.fromString=p;function g(h){return{id:h}}O.fromId=g;function d(h,S){let I=h.id;const v=I.lastIndexOf("~");return v!==-1&&(I=I.substring(0,v)),S&&(I=`${I}~${S}`),{id:I}}O.modify=d;function t(h){const S=h.id.lastIndexOf("~");if(S!==-1)return h.id.substring(S+1)}O.getModifier=t;function l(h,S){return h.id===S.id&&h.color?.id===S.color?.id}O.isEqual=l})(M||(e.ThemeIcon=M={}))}),define(Ae[36],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(y){return i.test(y)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(A){for(let _=0;_<A.length;_++)A[_]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),O=[];for(let A=0;A<256;A++)O.push(A.toString(16).padStart(2,"0"));return function(){y(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let _=0,m="";return m+=O[M[_++]],m+=O[M[_++]],m+=O[M[_++]],m+=O[M[_++]],m+="-",m+=O[M[_++]],m+=O[M[_++]],m+="-",m+=O[M[_++]],m+=O[M[_++]],m+="-",m+=O[M[_++]],m+=O[M[_++]],m+="-",m+=O[M[_++]],m+=O[M[_++]],m+=O[M[_++]],m+=O[M[_++]],m+=O[M[_++]],m+=O[M[_++]],m}}()}),define(Ae[120],Re([1,0,18,88,36]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function M(b){return{asString:async()=>b,asFile:()=>{},value:typeof b=="string"?b:void 0}}e.createStringDataTransferItem=M;function O(b,c,p){const g={id:(0,y.generateUuid)(),name:b,uri:c,data:p};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.createFileDataTransferItem=O;class A{constructor(){this._entries=new Map}get size(){let c=0;for(const p of this._entries)c++;return c}has(c){return this._entries.has(this.toKey(c))}matches(c){const p=[...this._entries.keys()];return C.Iterable.some(this,([g,d])=>d.asFile())&&p.push("files"),R(_(c),p)}get(c){return this._entries.get(this.toKey(c))?.[0]}append(c,p){const g=this._entries.get(c);g?g.push(p):this._entries.set(this.toKey(c),[p])}replace(c,p){this._entries.set(this.toKey(c),[p])}delete(c){this._entries.delete(this.toKey(c))}*[Symbol.iterator](){for(const[c,p]of this._entries)for(const g of p)yield[c,g]}toKey(c){return _(c)}}e.VSDataTransfer=A;function _(b){return b.toLowerCase()}function m(b,c){return R(_(b),c.map(_))}e.matchesMimeType=m;function R(b,c){if(b==="*/*")return c.length>0;if(c.includes(b))return!0;const p=b.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[g,d,t]=p;return t==="*"?c.some(l=>l.startsWith(d+"/")):!1}e.UriList=Object.freeze({create:b=>(0,i.distinct)(b.map(c=>c.toString())).join(`\r
`),split:b=>b.split(`\r
`),parse:b=>e.UriList.split(b).filter(c=>!c.startsWith("#"))})}),define(Ae[121],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[122],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(O){O[O.None=0]="None",O[O.Indent=1]="Indent",O[O.IndentOutdent=2]="IndentOutdent",O[O.Outdent=3]="Outdent"})(i||(e.IndentAction=i={}));class C{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let _=0,m=A.notIn.length;_<m;_++)switch(A.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,_){if(A.getTokenCount()===0)return!0;const m=A.findTokenIndexAtOffset(_-2),R=A.getStandardTokenType(m);return this.isOK(R)}_findNeutralCharacterInRange(A,_){for(let m=A;m<=_;m++){const R=String.fromCharCode(m);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class y{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of A)M(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),M(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),M(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),M(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&M(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function M(O,A,_){O.has(A)?O.get(A).push(_):O.set(A,[_])}}),define(Ae[123],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class i{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(M){if(M&&this._dragOperations.has(M)){const O=this._dragOperations.get(M);return this._dragOperations.delete(M),O}}addDragOperationTransfer(M,O){this._dragOperations.set(M,O)}}e.TreeViewsDnDService=i;class C{constructor(M){this.identifier=M}}e.DraggedTreeItemsIdentifier=C}),define(Ae[124],Re([11,12]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ae[125],Re([11,12]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ae[126],Re([1,0,125]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,y=C*60,M=y*24,O=M*7,A=M*30,_=M*365;function m(b,c,p,g){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,i.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,i.localize)(1,null);let t;return d<C?(t=d,c?t===1?p?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):p?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?p?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):p?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):d<y?(t=Math.floor(d/C),c?t===1?p?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):p?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?p?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):p?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):d<M?(t=Math.floor(d/y),c?t===1?p?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):p?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?p?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):p?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):d<O?(t=Math.floor(d/M),c?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):d<A?(t=Math.floor(d/O),c?t===1?p?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):p?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?p?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):p?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):d<_?(t=Math.floor(d/A),c?t===1?p?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):p?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?p?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):p?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(d/_),c?t===1?p?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):p?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?p?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):p?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=m;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ae[127],Re([11,12]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ae[40],Re([1,0,18,9,127]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(b,c){return c&&(b.stack||b.stacktrace)?y.localize(0,null,A(b),O(b.stack)||O(b.stacktrace)):A(b)}function O(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?y.localize(1,null,b.message):b.message||y.localize(2,null)}function _(b=null,c=!1){if(!b)return y.localize(3,null);if(Array.isArray(b)){const p=i.coalesce(b),g=_(p[0],c);return p.length>1?y.localize(4,null,g,p.length):g}if(C.isString(b))return b;if(b.detail){const p=b.detail;if(p.error)return M(p.error,c);if(p.exception)return M(p.exception,c)}return b.stack?M(b,c):b.message?b.message:y.localize(5,null)}e.toErrorMessage=_;function m(b){const c=b;return c instanceof Error&&Array.isArray(c.actions)}e.isErrorWithActions=m;function R(b,c){let p;return typeof b=="string"?p=new Error(b):p=b,p.actions=c,p}e.createErrorWithActions=R}),define(Ae[128],Re([1,0,66,19]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new i.Lazy(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),M=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),O=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(T,w,o=!1){const s=T||"",F=w||"",B=y.value.collator.compare(s,F);return y.value.collatorIsNumeric&&B===0&&s!==F?s<F?-1:1:B}e.compareFileNames=A;function _(T,w){const o=M.value.collator;return T=T||"",w=w||"",I(o,T,w)}e.compareFileNamesDefault=_;function m(T,w){const o=M.value.collator;return T=T||"",w=w||"",r(T,w)||I(o,T,w)}e.compareFileNamesUpper=m;function R(T,w){const o=M.value.collator;return T=T||"",w=w||"",u(T,w)||I(o,T,w)}e.compareFileNamesLower=R;function b(T,w){return T=T||"",w=w||"",T===w?0:T<w?-1:1}e.compareFileNamesUnicode=b;function c(T,w){const[o,s]=h(T),[F,B]=h(w);let G=y.value.collator.compare(s,B);if(G===0){if(y.value.collatorIsNumeric&&s!==B)return s<B?-1:1;if(G=y.value.collator.compare(o,F),y.value.collatorIsNumeric&&G===0&&o!==F)return o<F?-1:1}return G}e.compareFileExtensions=c;function p(T,w){T=T||"",w=w||"";const o=S(T),s=S(w),F=M.value.collator,B=O.value.collator;return I(B,o,s)||I(F,T,w)}e.compareFileExtensionsDefault=p;function g(T,w){T=T||"",w=w||"";const o=S(T),s=S(w),F=M.value.collator,B=O.value.collator;return I(B,o,s)||r(T,w)||I(F,T,w)}e.compareFileExtensionsUpper=g;function d(T,w){T=T||"",w=w||"";const o=S(T),s=S(w),F=M.value.collator,B=O.value.collator;return I(B,o,s)||u(T,w)||I(F,T,w)}e.compareFileExtensionsLower=d;function t(T,w){T=T||"",w=w||"";const o=S(T).toLowerCase(),s=S(w).toLowerCase();return o!==s?o<s?-1:1:T!==w?T<w?-1:1:0}e.compareFileExtensionsUnicode=t;const l=/^(.*?)(\.([^.]*))?$/;function h(T,w=!1){const o=T?l.exec(T):[];let s=[o&&o[1]||"",o&&o[3]||""];return w&&(!s[0]&&s[1]||s[0]&&s[0].charAt(0)===".")&&(s=[s[0]+"."+s[1],""]),s}function S(T){const w=T?l.exec(T):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function I(T,w,o){const s=T.compare(w,o);return s!==0?s:w.length!==o.length?w.length<o.length?-1:1:0}function v(T){const w=T.charAt(0);return w.toLocaleUpperCase()!==w}function n(T){const w=T.charAt(0);return w.toLocaleLowerCase()!==w}function u(T,w){return v(T)&&n(w)?-1:n(T)&&v(w)?1:0}function r(T,w){return n(T)&&v(w)?-1:v(T)&&n(w)?1:0}function a(T,w,o=!1){return o||(T=T&&T.toLowerCase(),w=w&&w.toLowerCase()),T===w?0:T<w?-1:1}function E(T,w,o=!1){const s=T.split(C.sep),F=w.split(C.sep),B=s.length-1,G=F.length-1;let q,$;for(let N=0;;N++){if(q=B===N,$=G===N,q&&$)return A(s[N],F[N],o);if(q)return-1;if($)return 1;const V=a(s[N],F[N],o);if(V!==0)return V}}e.comparePaths=E;function D(T,w,o){const s=T.toLowerCase(),F=w.toLowerCase(),B=f(T,w,o);if(B)return B;const G=s.endsWith(o),q=F.endsWith(o);if(G!==q)return G?-1:1;const $=A(s,F);return $!==0?$:s.localeCompare(F)}e.compareAnything=D;function f(T,w,o){const s=T.toLowerCase(),F=w.toLowerCase(),B=s.startsWith(o),G=F.startsWith(o);if(B!==G)return B?-1:1;if(B&&G){if(s.length<F.length)return-1;if(s.length>F.length)return 1}return 0}e.compareByPrefix=f}),define(Ae[67],Re([1,0,19]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const b=(0,i.extname)(R),c=C[b.toLowerCase()];return c!==void 0?c:O(R)}e.getMediaOrTextMime=M;function O(R){const b=(0,i.extname)(R);return y[b.toLowerCase()]}e.getMediaMime=O;function A(R){for(const b in y)if(y[b]===R)return b}e.getExtensionForMimeType=A;const _=/^(.+)\/(.+?)(;.+)?$/;function m(R,b){const c=_.exec(R);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:b?void 0:R}e.normalizeMimeType=m}),define(Ae[129],Re([1,0,5,6,124]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends C.Disposable{constructor(c,p="",g="",d=!0,t){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=c,this._label=p,this._cssClass=g,this._enabled=d,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}async run(c,p){this._actionCallback&&await this._actionCallback(c)}}e.Action=M;class O extends C.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(c,p){if(!c.enabled)return;this._onWillRun.fire({action:c});let g;try{await this.runAction(c,p)}catch(d){g=d}this._onDidRun.fire({action:c,error:g})}async runAction(c,p){await c.run(p)}}e.ActionRunner=O;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let p=[];for(const g of c)g.length&&(p.length?p=[...p,new A,...g]:p=g);return p}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class _{get actions(){return this._actions}constructor(c,p,g,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=p,this.class=d,this._actions=g}async run(){}}e.SubmenuAction=_;class m extends M{constructor(){super(m.ID,y.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m,m.ID="vs.actions.empty";function R(b){return{id:b.id,label:b.label,class:void 0,enabled:b.enabled??!0,checked:b.checked??!1,run:async()=>b.run(),tooltip:b.label}}e.toAction=R}),define(Ae[41],Re([1,0,19,21,13,9]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(D){return D===47||D===92}e.isPathSeparator=O;function A(D){return D.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=A;function _(D){return D.indexOf("/")===-1&&(D=A(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}e.toPosixPath=_;function m(D,f=i.posix.sep){if(!D)return"";const T=D.length,w=D.charCodeAt(0);if(O(w)){if(O(D.charCodeAt(1))&&!O(D.charCodeAt(2))){let s=3;const F=s;for(;s<T&&!O(D.charCodeAt(s));s++);if(F!==s&&!O(D.charCodeAt(s+1))){for(s+=1;s<T;s++)if(O(D.charCodeAt(s)))return D.slice(0,s+1).replace(/[\\/]/g,f)}}return f}else if(l(w)&&D.charCodeAt(1)===58)return O(D.charCodeAt(2))?D.slice(0,2)+f:D.slice(0,2);let o=D.indexOf("://");if(o!==-1){for(o+=3;o<T;o++)if(O(D.charCodeAt(o)))return D.slice(0,o+1)}return""}e.getRoot=m;function R(D){if(!C.isWindows||!D||D.length<5)return!1;let f=D.charCodeAt(0);if(f!==92||(f=D.charCodeAt(1),f!==92))return!1;let T=2;const w=T;for(;T<D.length&&(f=D.charCodeAt(T),f!==92);T++);return!(w===T||(f=D.charCodeAt(T+1),isNaN(f)||f===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(D,f=C.isWindows){const T=f?b:c;return!(!D||D.length===0||/^\s+$/.test(D)||(T.lastIndex=0,T.test(D))||f&&p.test(D)||D==="."||D===".."||f&&D[D.length-1]==="."||f&&D.length!==D.trim().length||D.length>255)}e.isValidBasename=g;function d(D,f,T){const w=D===f;return!T||w?w:!D||!f?!1:(0,y.equalsIgnoreCase)(D,f)}e.isEqual=d;function t(D,f,T,w=i.sep){if(D===f)return!0;if(!D||!f||f.length>D.length)return!1;if(T){if(!(0,y.startsWithIgnoreCase)(D,f))return!1;if(f.length===D.length)return!0;let s=f.length;return f.charAt(f.length-1)===w&&s--,D.charAt(s)===w}return f.charAt(f.length-1)!==w&&(f+=w),D.indexOf(f)===0}e.isEqualOrParent=t;function l(D){return D>=65&&D<=90||D>=97&&D<=122}e.isWindowsDriveLetter=l;function h(D,f){return C.isWindows&&D.endsWith(":")&&(D+=i.sep),(0,i.isAbsolute)(D)||(D=(0,i.join)(f,D)),D=(0,i.normalize)(D),C.isWindows?(D=(0,y.rtrim)(D,i.sep),D.endsWith(":")&&(D+=i.sep)):(D=(0,y.rtrim)(D,i.sep),D||(D=i.sep)),D}e.sanitizeFilePath=h;function S(D){const f=(0,i.normalize)(D);return C.isWindows?D.length>3?!1:I(f)&&(D.length===2||f.charCodeAt(2)===92):f===i.posix.sep}e.isRootOrDriveLetter=S;function I(D,f=C.isWindows){return f?l(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function v(D,f=C.isWindows){return I(D,f)?D[0]:void 0}e.getDriveLetter=v;function n(D,f,T){return f.length>D.length?-1:D===f?0:(T&&(D=D.toLowerCase(),f=f.toLowerCase()),D.indexOf(f))}e.indexOfPath=n;function u(D){const f=D.split(":");let T,w,o;for(const s of f){const F=Number(s);(0,M.isNumber)(F)?w===void 0?w=F:o===void 0&&(o=F):T=T?[T,s].join(":"):s}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:w!==void 0?w:void 0,column:o!==void 0?o:w!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(D,f,T=8){let w="";for(let s=0;s<T;s++){let F;s===0&&C.isWindows&&!f&&(T===3||T===4)?F=a:F=r,w+=F.charAt(Math.floor(Math.random()*F.length))}let o;return f?o=`${f}-${w}`:o=w,D?(0,i.join)(D,o):o}e.randomPath=E}),define(Ae[130],Re([1,0,28,13]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Z){return function(ne,k){for(let z=0,H=Z.length;z<H;z++){const j=Z[z](ne,k);if(j)return j}return null}}e.or=y,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,ne,k){if(!k||k.length<ne.length)return null;let z;return Z?z=C.startsWithIgnoreCase(k,ne):z=k.indexOf(ne)===0,z?ne.length>0?[{start:0,end:ne.length}]:[]:null}function O(Z,ne){const k=ne.toLowerCase().indexOf(Z.toLowerCase());return k===-1?null:[{start:k,end:k+Z.length}]}e.matchesContiguousSubString=O;function A(Z,ne){return _(Z.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=A;function _(Z,ne,k,z){if(k===Z.length)return[];if(z===ne.length)return null;if(Z[k]===ne[z]){let H=null;return(H=_(Z,ne,k+1,z+1))?l({start:z,end:z+1},H):null}return _(Z,ne,k,z+1)}function m(Z){return 97<=Z&&Z<=122}function R(Z){return 65<=Z&&Z<=90}e.isUpper=R;function b(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function g(Z){return c(Z)||p.has(Z)}function d(Z,ne){return Z===ne||g(Z)&&g(ne)}function t(Z){return m(Z)||R(Z)||b(Z)}function l(Z,ne){return ne.length===0?ne=[Z]:Z.end===ne[0].start?ne[0].start=Z.start:ne.unshift(Z),ne}function h(Z,ne){for(let k=ne;k<Z.length;k++){const z=Z.charCodeAt(k);if(R(z)||b(z)||k>0&&!t(Z.charCodeAt(k-1)))return k}return Z.length}function S(Z,ne,k,z){if(k===Z.length)return[];if(z===ne.length)return null;if(Z[k]!==ne[z].toLowerCase())return null;{let H=null,j=z+1;for(H=S(Z,ne,k+1,z+1);!H&&(j=h(ne,j))<ne.length;)H=S(Z,ne,k+1,j),j++;return H===null?null:l({start:z,end:z+1},H)}}function I(Z){let ne=0,k=0,z=0,H=0,j=0;for(let _e=0;_e<Z.length;_e++)j=Z.charCodeAt(_e),R(j)&&ne++,m(j)&&k++,t(j)&&z++,b(j)&&H++;const ce=ne/Z.length,pe=k/Z.length,ie=z/Z.length,Se=H/Z.length;return{upperPercent:ce,lowerPercent:pe,alphaPercent:ie,numericPercent:Se}}function v(Z){const{upperPercent:ne,lowerPercent:k}=Z;return k===0&&ne>.6}function n(Z){const{upperPercent:ne,lowerPercent:k,alphaPercent:z,numericPercent:H}=Z;return k>.2&&ne<.8&&z>.6&&H<.2}function u(Z){let ne=0,k=0,z=0,H=0;for(let j=0;j<Z.length;j++)z=Z.charCodeAt(j),R(z)&&ne++,m(z)&&k++,c(z)&&H++;return(ne===0||k===0)&&H===0?Z.length<=30:ne<=5}function r(Z,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!u(Z)||ne.length>60)return null;const k=I(ne);if(!n(k)){if(!v(k))return null;ne=ne.toLowerCase()}let z=null,H=0;for(Z=Z.toLowerCase();H<ne.length&&(z=S(Z,ne,0,H))===null;)H=h(ne,H+1);return z}e.matchesCamelCase=r;function a(Z,ne,k=!1){if(!ne||ne.length===0)return null;let z=null,H=0;for(Z=Z.toLowerCase(),ne=ne.toLowerCase();H<ne.length&&(z=E(Z,ne,0,H,k))===null;)H=D(ne,H+1);return z}e.matchesWords=a;function E(Z,ne,k,z,H){if(k===Z.length)return[];if(z===ne.length)return null;if(d(Z.charCodeAt(k),ne.charCodeAt(z))){let j=null,ce=z+1;if(j=E(Z,ne,k+1,z+1,H),!H)for(;!j&&(ce=D(ne,ce))<ne.length;)j=E(Z,ne,k+1,ce,H),ce++;return j?Z.charCodeAt(k)!==ne.charCodeAt(z)?j:l({start:z,end:z+1},j):null}else return null}function D(Z,ne){for(let k=ne;k<Z.length;k++)if(g(Z.charCodeAt(k))||k>0&&g(Z.charCodeAt(k-1)))return k;return Z.length}const f=y(e.matchesPrefix,r,O),T=y(e.matchesPrefix,r,A),w=new i.LRUCache(1e4);function o(Z,ne,k=!1){if(typeof Z!="string"||typeof ne!="string")return null;let z=w.get(Z);z||(z=new RegExp(C.convertSimple2RegExpPattern(Z),"i"),w.set(Z,z));const H=z.exec(ne);return H?[{start:H.index,end:H.index+H[0].length}]:k?T(Z,ne):f(Z,ne)}e.matchesFuzzy=o;function s(Z,ne){const k=he(Z,Z.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return k?B(k):null}e.matchesFuzzy2=s;function F(Z,ne,k,z,H,j){const ce=Math.min(13,Z.length);for(;k<ce;k++){const pe=he(Z,ne,k,z,H,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,j]}e.anyScore=F;function B(Z){if(typeof Z>"u")return[];const ne=[],k=Z[1];for(let z=Z.length-1;z>1;z--){const H=Z[z]+k,j=ne[ne.length-1];j&&j.end===H?j.end=H+1:ne.push({start:H,end:H+1})}return ne}e.createMatches=B;const G=128;function q(){const Z=[],ne=[];for(let k=0;k<=G;k++)ne[k]=0;for(let k=0;k<=G;k++)Z.push(ne.slice(0));return Z}function $(Z){const ne=[];for(let k=0;k<=Z;k++)ne[k]=0;return ne}const N=$(2*G),V=$(2*G),x=q(),W=q(),ee=q(),Ie=!1;function oe(Z,ne,k,z,H){function j(pe,ie,Se=" "){for(;pe.length<ie;)pe=Se+pe;return pe}let ce=` |   |${z.split("").map(pe=>j(pe,3)).join("|")}
`;for(let pe=0;pe<=k;pe++)pe===0?ce+=" |":ce+=`${ne[pe-1]}|`,ce+=Z[pe].slice(0,H+1).map(ie=>j(ie.toString(),3)).join("|")+`
`;return ce}function ue(Z,ne,k,z){Z=Z.substr(ne),k=k.substr(z),console.log(oe(W,Z,Z.length,k,k.length)),console.log(oe(ee,Z,Z.length,k,k.length)),console.log(oe(x,Z,Z.length,k,k.length))}function X(Z,ne){if(ne<0||ne>=Z.length)return!1;const k=Z.codePointAt(ne);switch(k){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(k)}}function le(Z,ne){if(ne<0||ne>=Z.length)return!1;switch(Z.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function De(Z,ne,k){return ne[Z]!==k[Z]}function Te(Z,ne,k,z,H,j,ce=!1){for(;ne<k&&H<j;)Z[ne]===z[H]&&(ce&&(N[ne]=H),ne+=1),H+=1;return ne===k}e.isPatternInWord=Te;var Ee;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var P;(function(Z){Z.Default=[-100,0];function ne(k){return!k||k.length===2&&k[0]===-100&&k[1]===0}Z.isDefault=ne})(P||(e.FuzzyScore=P={}));class K{constructor(ne,k){this.firstMatchCanBeWeak=ne,this.boostFullMatch=k}}e.FuzzyScoreOptions=K,K.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function he(Z,ne,k,z,H,j,ce=K.default){const pe=Z.length>G?G:Z.length,ie=z.length>G?G:z.length;if(k>=pe||j>=ie||pe-k>ie-j||!Te(ne,k,pe,H,j,ie,!0))return;ye(pe,ie,k,j,ne,H);let Se=1,_e=1,Be=k,He=j;const Ze=[!1];for(Se=1,Be=k;Be<pe;Se++,Be++){const tt=N[Be],Me=V[Be],dt=Be+1<pe?V[Be+1]:ie;for(_e=tt-j+1,He=tt;He<dt;_e++,He++){let Y=Number.MIN_SAFE_INTEGER,J=!1;He<=Me&&(Y=be(Z,ne,Be,k,z,H,He,ie,j,x[Se-1][_e-1]===0,Ze));let fe=0;Y!==Number.MAX_SAFE_INTEGER&&(J=!0,fe=Y+W[Se-1][_e-1]);const Ue=He>tt,Ve=Ue?W[Se][_e-1]+(x[Se][_e-1]>0?-5:0):0,$e=He>tt+1&&x[Se][_e-1]>0,Je=$e?W[Se][_e-2]+(x[Se][_e-2]>0?-5:0):0;if($e&&(!Ue||Je>=Ve)&&(!J||Je>=fe))W[Se][_e]=Je,ee[Se][_e]=3,x[Se][_e]=0;else if(Ue&&(!J||Ve>=fe))W[Se][_e]=Ve,ee[Se][_e]=2,x[Se][_e]=0;else if(J)W[Se][_e]=fe,ee[Se][_e]=1,x[Se][_e]=x[Se-1][_e-1]+1;else throw new Error("not possible")}}if(Ie&&ue(Z,k,z,j),!Ze[0]&&!ce.firstMatchCanBeWeak)return;Se--,_e--;const Xe=[W[Se][_e],j];let Ke=0,it=0;for(;Se>=1;){let tt=_e;do{const Me=ee[Se][tt];if(Me===3)tt=tt-2;else if(Me===2)tt=tt-1;else break}while(tt>=1);Ke>1&&ne[k+Se-1]===H[j+_e-1]&&!De(tt+j-1,z,H)&&Ke+1>x[Se][tt]&&(tt=_e),tt===_e?Ke++:Ke=1,it||(it=tt),Se--,_e=tt-1,Xe.push(_e)}ie===pe&&ce.boostFullMatch&&(Xe[0]+=2);const st=it-pe;return Xe[0]-=st,Xe}e.fuzzyScore=he;function ye(Z,ne,k,z,H,j){let ce=Z-1,pe=ne-1;for(;ce>=k&&pe>=z;)H[ce]===j[pe]&&(V[ce]=pe,ce--),pe--}function be(Z,ne,k,z,H,j,ce,pe,ie,Se,_e){if(ne[k]!==j[ce])return Number.MIN_SAFE_INTEGER;let Be=1,He=!1;return ce===k-z?Be=Z[k]===H[ce]?7:5:De(ce,H,j)&&(ce===0||!De(ce-1,H,j))?(Be=Z[k]===H[ce]?7:5,He=!0):X(j,ce)&&(ce===0||!X(j,ce-1))?Be=5:(X(j,ce-1)||le(j,ce-1))&&(Be=5,He=!0),Be>1&&k===z&&(_e[0]=!0),He||(He=De(ce,H,j)||X(j,ce-1)||le(j,ce-1)),k===z?ce>ie&&(Be-=He?3:5):Se?Be+=He?2:0:Be+=He?0:1,ce+1===pe&&(Be-=He?3:5),Be}function ge(Z,ne,k,z,H,j,ce){return ae(Z,ne,k,z,H,j,!0,ce)}e.fuzzyScoreGracefulAggressive=ge;function Ce(Z,ne,k,z,H,j,ce){return ae(Z,ne,k,z,H,j,!1,ce)}e.fuzzyScoreGraceful=Ce;function ae(Z,ne,k,z,H,j,ce,pe){let ie=he(Z,ne,k,z,H,j,pe);if(ie&&!ce)return ie;if(Z.length>=3){const Se=Math.min(7,Z.length-1);for(let _e=k+1;_e<Se;_e++){const Be=de(Z,_e);if(Be){const He=he(Be,Be.toLowerCase(),k,z,H,j,pe);He&&(He[0]-=3,(!ie||He[0]>ie[0])&&(ie=He))}}}return ie}function de(Z,ne){if(ne+1>=Z.length)return;const k=Z[ne],z=Z[ne+1];if(k!==z)return Z.slice(0,ne)+z+k+Z.slice(ne+2)}}),define(Ae[131],Re([1,0,130,13,39]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",O=new RegExp(`\\$\\(${y.ThemeIcon.iconNameExpression}(?:${y.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${O.source}`,"g");function _(l){return l.replace(A,(h,S)=>S?h:`\\${h}`)}e.escapeIcons=_;const m=new RegExp(`\\\\${O.source}`,"g");function R(l){return l.replace(m,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=R;const b=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function c(l){return l.indexOf(M)===-1?l:l.replace(b,(h,S,I,v)=>I?h:S||v||"")}e.stripIcons=c;function p(l){return l?l.replace(/\$\((.*?)\)/g,(h,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=p;const g=new RegExp(`\\$\\(${y.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(l){g.lastIndex=0;let h="";const S=[];let I=0;for(;;){const v=g.lastIndex,n=g.exec(l),u=l.substring(v,n?.index);if(u.length>0){h+=u;for(let r=0;r<u.length;r++)S.push(I)}if(!n)break;I+=n[0].length}return{text:h,iconOffsets:S}}e.parseLabelWithIcons=d;function t(l,h,S=!1){const{text:I,iconOffsets:v}=h;if(!v||v.length===0)return(0,i.matchesFuzzy)(l,I,S);const n=(0,C.ltrim)(I," "),u=I.length-n.length,r=(0,i.matchesFuzzy)(l,n,S);if(r)for(const a of r){const E=v[a.start+u]+u;a.start+=E,a.end+=E}return r}e.matchesFuzzyIconAware=t}),define(Ae[29],Re([1,0,13]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(C||(C={})),function(y){const M="error",O="warning",A="warn",_="info",m="ignore";function R(c){return c?i.equalsIgnoreCase(M,c)?y.Error:i.equalsIgnoreCase(O,c)||i.equalsIgnoreCase(A,c)?y.Warning:i.equalsIgnoreCase(_,c)?y.Info:y.Ignore:y.Ignore}y.fromValue=R;function b(c){switch(c){case y.Error:return M;case y.Warning:return O;case y.Info:return _;default:return m}}y.toString=b}(C||(C={})),e.default=C}),define(Ae[48],Re([1,0,18,13]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this._value="",this._pos=0}reset(p){return this._value=p,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(p){const g=p.charCodeAt(0),d=this._value.charCodeAt(this._pos);return g-d}value(){return this._value[this._pos]}}e.StringIterator=y;class M{constructor(p=!0){this._caseSensitive=p}reset(p){return this._value=p,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let p=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(p)this._from++;else break;else p=!1;return this}cmp(p){return this._caseSensitive?(0,C.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class O{constructor(p=!0,g=!0){this._splitOnBackslash=p,this._caseSensitive=g}reset(p){this._from=0,this._to=0,this._value=p,this._valueLen=p.length;for(let g=p.length-1;g>=0;g--,this._valueLen--){const d=this._value.charCodeAt(g);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let p=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(p)this._from++;else break;else p=!1}return this}cmp(p){return this._caseSensitive?(0,C.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=O;var A;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(A||(A={}));class _{constructor(p,g){this._ignorePathCasing=p,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(p){return this._value=p,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new O(!1,!this._ignorePathCasing(p)),this._pathIterator.reset(p.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(p)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(p){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(p,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(p,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(p);if(this._states[this._stateIdx]===4)return(0,C.compare)(p,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(p,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=_;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(R||(R={}));class b{static forUris(p=()=>!1,g=()=>!1){return new b(new _(p,g))}static forPaths(p=!1){return new b(new O(void 0,!p))}static forStrings(){return new b(new y)}static forConfigKeys(){return new b(new M)}constructor(p){this._iter=p}clear(){this._root=void 0}fill(p,g){if(g){const d=g.slice(0);(0,i.shuffle)(d);for(const t of d)this.set(t,p)}else{const d=p.slice(0);(0,i.shuffle)(d);for(const t of d)this.set(t[0],t[1])}}set(p,g){const d=this._iter.reset(p);let t;this._root||(this._root=new m,this._root.segment=d.value());const l=[];for(t=this._root;;){const S=d.cmp(t.segment);if(S>0)t.left||(t.left=new m,t.left.segment=d.value()),l.push([-1,t]),t=t.left;else if(S<0)t.right||(t.right=new m,t.right.segment=d.value()),l.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new m,t.mid.segment=d.value()),l.push([0,t]),t=t.mid;else break}const h=t.value;t.value=g,t.key=p;for(let S=l.length-1;S>=0;S--){const I=l[S][1];I.updateHeight();const v=I.balanceFactor();if(v<-1||v>1){const n=l[S][0],u=l[S+1][0];if(n===1&&u===1)l[S][1]=I.rotateLeft();else if(n===-1&&u===-1)l[S][1]=I.rotateRight();else if(n===1&&u===-1)I.right=l[S+1][1]=l[S+1][1].rotateRight(),l[S][1]=I.rotateLeft();else if(n===-1&&u===1)I.left=l[S+1][1]=l[S+1][1].rotateLeft(),l[S][1]=I.rotateRight();else throw new Error;if(S>0)switch(l[S-1][0]){case-1:l[S-1][1].left=l[S][1];break;case 1:l[S-1][1].right=l[S][1];break;case 0:l[S-1][1].mid=l[S][1];break}else this._root=l[0][1]}}return h}get(p){return this._getNode(p)?.value}_getNode(p){const g=this._iter.reset(p);let d=this._root;for(;d;){const t=g.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(p){const g=this._getNode(p);return!(g?.value===void 0&&g?.mid===void 0)}delete(p){return this._delete(p,!1)}deleteSuperstr(p){return this._delete(p,!0)}_delete(p,g){const d=this._iter.reset(p),t=[];let l=this._root;for(;l;){const h=d.cmp(l.segment);if(h>0)t.push([-1,l]),l=l.left;else if(h<0)t.push([1,l]),l=l.right;else if(d.hasNext())d.next(),t.push([0,l]),l=l.mid;else break}if(l){if(g?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const h=this._min(l.right);if(h.key){const{key:S,value:I,segment:v}=h;this._delete(h.key,!1),l.key=S,l.value=I,l.segment=v}}else{const h=l.left??l.right;if(t.length>0){const[S,I]=t[t.length-1];switch(S){case-1:I.left=h;break;case 0:I.mid=h;break;case 1:I.right=h;break}}else this._root=h}for(let h=t.length-1;h>=0;h--){const S=t[h][1];S.updateHeight();const I=S.balanceFactor();if(I>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),t[h][1]=S.rotateLeft()):I<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),t[h][1]=S.rotateRight()),h>0)switch(t[h-1][0]){case-1:t[h-1][1].left=t[h][1];break;case 1:t[h-1][1].right=t[h][1];break;case 0:t[h-1][1].mid=t[h][1];break}else this._root=t[0][1]}}}_min(p){for(;p.left;)p=p.left;return p}findSubstr(p){const g=this._iter.reset(p);let d=this._root,t;for(;d;){const l=g.cmp(d.segment);if(l>0)d=d.left;else if(l<0)d=d.right;else if(g.hasNext())g.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(p){return this._findSuperstrOrElement(p,!1)}_findSuperstrOrElement(p,g){const d=this._iter.reset(p);let t=this._root;for(;t;){const l=d.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this._entries(t.mid):g?t.value:void 0}}hasElementOrSubtree(p){return this._findSuperstrOrElement(p,!0)!==void 0}forEach(p){for(const[g,d]of this)p(d,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(p){const g=[];return this._dfsEntries(p,g),g[Symbol.iterator]()}_dfsEntries(p,g){p&&(p.left&&this._dfsEntries(p.left,g),p.value&&g.push([p.key,p.value]),p.mid&&this._dfsEntries(p.mid,g),p.right&&this._dfsEntries(p.right,g))}_isBalanced(){const p=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:p(g.left)&&p(g.right)};return p(this._root)}}e.TernarySearchTree=b}),define(Ae[68],Re([1,0,24,13,2]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(m){return JSON.stringify(m,A)}e.stringify=M;function O(m){let R=JSON.parse(m);return R=_(R),R}e.parse=O;function A(m,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,C.regExpFlags)(R)}:R}function _(m,R=0){if(!m||R>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return y.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof i.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let b=0;b<m.length;++b)m[b]=_(m[b],R+1);else for(const b in m)Object.hasOwnProperty.call(m,b)&&(m[b]=_(m[b],R+1))}return m}e.revive=_}),define(Ae[15],Re([1,0,10,21,2]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class O{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${M.vscodeRemoteResource}`}set(R,b,c){this._hosts[R]=b,this._ports[R]=c}setConnectionToken(R,b){this._connectionTokens[R]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(t){return i.onUnexpectedError(t),R}const b=R.authority;let c=this._hosts[b];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const p=this._ports[b],g=this._connectionTokens[b];let d=`path=${encodeURIComponent(R.path)}`;return typeof g=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),y.URI.from({scheme:C.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${c}:${p}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new O,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(R){const b=this.toUri(R,te);return this.uriToBrowserUri(b)}uriToBrowserUri(R){return R.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===M.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${M.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?R.with({scheme:M.vscodeFileResource,authority:R.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const b=this.toUri(R,te);return this.uriToFileUri(b)}uriToFileUri(R){return R.scheme===M.vscodeFileResource?R.with({scheme:M.file,authority:R.authority!==A.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,b){return y.URI.isUri(R)?R:y.URI.parse(b.toUrl(R))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A;var _;(function(m){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(R.get("3"));const b="vscode-coi";function c(g){let d;typeof g=="string"?d=new URL(g).searchParams:g instanceof URL?d=g.searchParams:y.URI.isUri(g)&&(d=new URL(g.toString(!0)).searchParams);const t=d?.get(b);if(t)return R.get(t)}m.getHeadersFromQuery=c;function p(g,d,t){if(!globalThis.crossOriginIsolated)return;const l=d&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(b,l):g[b]=l}m.addSearchParam=p})(_||(e.COI=_={}))}),define(Ae[25],Re([1,0,41,15,19,21,13,2]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(p){return(0,A.uriToFsPath)(p,!0)}e.originalFSPath=_;class m{constructor(g){this._ignorePathCasing=g}compare(g,d,t=!1){return g===d?0:(0,O.compare)(this.getComparisonKey(g,t),this.getComparisonKey(d,t))}isEqual(g,d,t=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,t)===this.getComparisonKey(d,t)}getComparisonKey(g,d=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,d,t=!1){if(g.scheme===d.scheme){if(g.scheme===C.Schemas.file)return i.isEqualOrParent(_(g),_(d),this._ignorePathCasing(g))&&g.query===d.query&&(t||g.fragment===d.fragment);if((0,e.isEqualAuthority)(g.authority,d.authority))return i.isEqualOrParent(g.path,d.path,this._ignorePathCasing(g),"/")&&g.query===d.query&&(t||g.fragment===d.fragment)}return!1}joinPath(g,...d){return A.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return y.posix.basename(g.path)}extname(g){return y.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===C.Schemas.file?d=A.URI.file(y.dirname(_(g))).path:(d=y.posix.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===C.Schemas.file?d=A.URI.file(y.normalize(_(g))).path:d=y.posix.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.isEqualAuthority)(g.authority,d.authority))return;if(g.scheme===C.Schemas.file){const h=y.relative(_(g),_(d));return M.isWindows?i.toSlashes(h):h}let t=g.path||"/";const l=d.path||"/";if(this._ignorePathCasing(g)){let h=0;for(const S=Math.min(t.length,l.length);h<S&&!(t.charCodeAt(h)!==l.charCodeAt(h)&&t.charAt(h).toLowerCase()!==l.charAt(h).toLowerCase());h++);t=l.substr(0,h)+t.substr(h)}return y.posix.relative(t,l)}resolvePath(g,d){if(g.scheme===C.Schemas.file){const t=A.URI.file(y.resolve(_(g),d));return g.with({authority:t.authority,path:t.path})}return d=i.toPosixPath(d),g.with({path:y.posix.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,O.equalsIgnoreCase)(g,d)}hasTrailingPathSeparator(g,d=y.sep){if(g.scheme===C.Schemas.file){const t=_(g);return t.length>i.getRoot(t).length&&t[t.length-1]===d}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=y.sep){return(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=y.sep){let t=!1;if(g.scheme===C.Schemas.file){const l=_(g);t=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===d}else{d="/";const l=g.path;t=l.length===1&&l.charCodeAt(l.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(p=>p.scheme===C.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(p,g){const d=[];for(let t=0;t<p.length;t++){const l=g(p[t]);p.some((h,S)=>S===t?!1:(0,e.isEqualOrParent)(l,g(h)))||d.push(p[t])}return d}e.distinctParents=R;var b;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function g(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(S=>{const[I,v]=S.split(":");I&&v&&t.set(I,v)});const h=d.path.substring(0,d.path.indexOf(";"));return h&&t.set(p.META_DATA_MIME,h),t}p.parseMetaData=g})(b||(e.DataUri=b={}));function c(p,g,d){if(g){let t=p.path;return t&&t[0]!==y.posix.sep&&(t=y.posix.sep+t),p.with({scheme:d,authority:g,path:t})}return p.with({scheme:d})}e.toLocalResource=c}),define(Ae[16],Re([1,0,22,10,5,6,25,21,119]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(Ee){return!!Ee&&typeof Ee.then=="function"}e.isThenable=m;function R(Ee){const P=new i.CancellationTokenSource,K=Ee(P.token),he=new Promise((ye,be)=>{const ge=P.token.onCancellationRequested(()=>{ge.dispose(),P.dispose(),be(new C.CancellationError)});Promise.resolve(K).then(Ce=>{ge.dispose(),P.dispose(),ye(Ce)},Ce=>{ge.dispose(),P.dispose(),be(Ce)})});return new class{cancel(){P.cancel()}then(ye,be){return he.then(ye,be)}catch(ye){return this.then(void 0,ye)}finally(ye){return he.finally(ye)}}}e.createCancelablePromise=R;function b(Ee,P,K){return new Promise((he,ye)=>{const be=P.onCancellationRequested(()=>{be.dispose(),he(K)});Ee.then(he,ye).finally(()=>be.dispose())})}e.raceCancellation=b;function c(Ee,P){return new Promise((K,he)=>{const ye=P.onCancellationRequested(()=>{ye.dispose(),he(new C.CancellationError)});Ee.then(K,he).finally(()=>ye.dispose())})}e.raceCancellationError=c;async function p(Ee){let P=-1;const K=Ee.map((he,ye)=>he.then(be=>(P=ye,be)));try{return await Promise.race(K)}finally{Ee.forEach((he,ye)=>{ye!==P&&he.cancel()})}}e.raceCancellablePromises=p;function g(Ee,P,K){let he;const ye=setTimeout(()=>{he?.(void 0),K?.()},P);return Promise.race([Ee.finally(()=>clearTimeout(ye)),new Promise(be=>he=be)])}e.raceTimeout=g;function d(Ee){return new Promise((P,K)=>{const he=Ee();m(he)?he.then(P,K):P(he)})}e.asPromise=d;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(P){if(this.activePromise){if(this.queuedPromiseFactory=P,!this.queuedPromise){const K=()=>{this.queuedPromise=null;const he=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,he};this.queuedPromise=new Promise(he=>{this.activePromise.then(K,K).then(he)})}return new Promise((K,he)=>{this.queuedPromise.then(K,he)})}return this.activePromise=P(),new Promise((K,he)=>{this.activePromise.then(ye=>{this.activePromise=null,K(ye)},ye=>{this.activePromise=null,he(ye)})})}}e.Throttler=t;class l{constructor(){this.current=Promise.resolve(null)}queue(P){return this.current=this.current.then(()=>P(),()=>P())}}e.Sequencer=l;class h{constructor(){this.promiseMap=new Map}queue(P,K){const ye=(this.promiseMap.get(P)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(P)===ye&&this.promiseMap.delete(P)});return this.promiseMap.set(P,ye),ye}}e.SequencerByKey=h;const S=(Ee,P)=>{let K=!0;const he=setTimeout(()=>{K=!1,P()},Ee);return{isTriggered:()=>K,dispose:()=>{clearTimeout(he),K=!1}}},I=Ee=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,Ee())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};class v{constructor(P){this.defaultDelay=P,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(P,K=this.defaultDelay){this.task=P,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ye,be)=>{this.doResolve=ye,this.doReject=be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ye=this.task;return this.task=null,ye()}}));const he=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=K===_.MicrotaskDelay?I(he):S(K,he),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=v;class n{constructor(P){this.delayer=new v(P),this.throttler=new t}trigger(P,K){return this.delayer.trigger(()=>this.throttler.queue(P),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class u{constructor(){this._isOpen=!1,this._promise=new Promise((P,K)=>{this._completePromise=P})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class r extends u{constructor(P){super(),this._timeout=setTimeout(()=>this.open(),P)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function a(Ee,P){return P?new Promise((K,he)=>{const ye=setTimeout(()=>{be.dispose(),K()},Ee),be=P.onCancellationRequested(()=>{clearTimeout(ye),be.dispose(),he(new C.CancellationError)})}):R(K=>a(Ee,K))}e.timeout=a;function E(Ee,P=0){const K=setTimeout(Ee,P);return(0,M.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=E;function D(Ee){const P=[];let K=0;const he=Ee.length;function ye(){return K<he?Ee[K++]():null}function be(ge){ge!=null&&P.push(ge);const Ce=ye();return Ce?Ce.then(be):Promise.resolve(P)}return Promise.resolve(null).then(be)}e.sequence=D;function f(Ee,P=he=>!!he,K=null){let he=0;const ye=Ee.length,be=()=>{if(he>=ye)return Promise.resolve(K);const ge=Ee[he++];return Promise.resolve(ge()).then(ae=>P(ae)?Promise.resolve(ae):be())};return be()}e.first=f;function T(Ee,P=he=>!!he,K=null){if(Ee.length===0)return Promise.resolve(K);let he=Ee.length;const ye=()=>{he=-1;for(const be of Ee)be.cancel?.()};return new Promise((be,ge)=>{for(const Ce of Ee)Ce.then(ae=>{--he>=0&&P(ae)?(ye(),be(ae)):he===0&&be(K)}).catch(ae=>{--he>=0&&(ye(),ge(ae))})})}e.firstParallel=T;class w{constructor(P){this._size=0,this.maxDegreeOfParalellism=P,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new y.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(P){return this._size++,new Promise((K,he)=>{this.outstandingPromises.push({factory:P,c:K,e:he}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const P=this.outstandingPromises.shift();this.runningPromises++;const K=P.factory();K.then(P.c,P.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=w;class o extends w{constructor(){super(1)}}e.Queue=o;class s{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const P=new oe;return this.drainers.add(P),P.p}isDrained(){for(const[,P]of this.queues)if(P.size>0)return!1;return!0}queueFor(P,K=O.extUri){const he=K.getComparisonKey(P);let ye=this.queues.get(he);return ye||(ye=new o,y.Event.once(ye.onDrained)(()=>{ye?.dispose(),this.queues.delete(he),this.onDidQueueDrain()}),this.queues.set(he,ye)),ye}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const P of this.drainers)P.complete();this.drainers.clear()}dispose(){for(const[,P]of this.queues)P.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=s;class F{constructor(P,K){this._token=-1,typeof P=="function"&&typeof K=="number"&&this.setIfNotSet(P,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(P,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,P()},K)}setIfNotSet(P,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,P()},K))}}e.TimeoutTimer=F;class B{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(P,K){this.cancel(),this._token=setInterval(()=>{P()},K)}}e.IntervalTimer=B;class G{constructor(P,K){this.timeoutToken=-1,this.runner=P,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(P=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,P)}get delay(){return this.timeout}set delay(P){this.timeout=P}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=G;class q{constructor(P,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.runner=P,this.timeout=K,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(P=this.timeout){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(P/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=q;class $ extends G{constructor(P,K){super(P,K),this.units=[]}work(P){this.units.push(P),this.isScheduled()||this.schedule()}doRun(){const P=this.units;this.units=[],this.runner?.(P)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class N extends M.Disposable{constructor(P,K){super(),this.options=P,this.handler=K,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(P){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+P.length>this.options.maxBufferedWork)return!1}else if(this.pending+P.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const K of P)this.pendingWork.push(K);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Ee=>{(0,A.setTimeout0)(()=>{if(P)return;const K=Date.now()+15;Ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,K-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:e.runWhenIdle=(Ee,P)=>{const K=requestIdleCallback(Ee,typeof P=="number"?{timeout:P}:void 0);let he=!1;return{dispose(){he||(he=!0,cancelIdleCallback(K))}}}}();class V{constructor(P){this._didRun=!1,this._executor=()=>{try{this._value=P()}catch(K){this._error=K}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function x(Ee,P,K){let he;for(let ye=0;ye<K;ye++)try{return await Ee()}catch(be){he=be,await a(P)}throw he}e.retry=x;class W{hasPending(P){return this._pending?typeof P=="number"?this._pending.taskId===P:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(P,K,he){return this._pending={taskId:P,cancel:()=>he?.(),promise:K},K.then(()=>this.donePending(P),()=>this.donePending(P)),K}donePending(P){this._pending&&P===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const P=this._next;this._next=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}setNext(P){if(this._next)this._next.run=P;else{let K,he;const ye=new Promise((be,ge)=>{K=be,he=ge});this._next={run:P,promise:ye,promiseResolve:K,promiseReject:he}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class ee{constructor(P,K=()=>Date.now()){this.interval=P,this.nowFn=K,this.lastIncrementTime=0,this.value=0}increment(){const P=this.nowFn();return P-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=P,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;var Ie;(function(Ee){Ee[Ee.Resolved=0]="Resolved",Ee[Ee.Rejected=1]="Rejected"})(Ie||(Ie={}));class oe{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((P,K)=>{this.completeCallback=P,this.errorCallback=K})}complete(P){return new Promise(K=>{this.completeCallback(P),this.outcome={outcome:0,value:P},K()})}error(P){return new Promise(K=>{this.errorCallback(P),this.outcome={outcome:1,value:P},K()})}cancel(){return this.error(new C.CancellationError)}}e.DeferredPromise=oe;var ue;(function(Ee){async function P(he){let ye;const be=await Promise.all(he.map(ge=>ge.then(Ce=>Ce,Ce=>{ye||(ye=Ce)})));if(typeof ye<"u")throw ye;return be}Ee.settled=P;function K(he){return new Promise(async(ye,be)=>{try{await he(ye,be)}catch(ge){be(ge)}})}Ee.withAsyncBody=K})(ue||(e.Promises=ue={}));var X;(function(Ee){Ee[Ee.Initial=0]="Initial",Ee[Ee.DoneOK=1]="DoneOK",Ee[Ee.DoneError=2]="DoneError"})(X||(X={}));class le{static fromArray(P){return new le(K=>{K.emitMany(P)})}static fromPromise(P){return new le(async K=>{K.emitMany(await P)})}static fromPromises(P){return new le(async K=>{await Promise.all(P.map(async he=>K.emitOne(await he)))})}static merge(P){return new le(async K=>{await Promise.all(P.map(async he=>{for await(const ye of he)K.emitOne(ye)}))})}constructor(P){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const K={emitOne:he=>this.emitOne(he),emitMany:he=>this.emitMany(he),reject:he=>this.reject(he)};try{await Promise.resolve(P(K)),this.resolve()}catch(he){this.reject(he)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(P<this._results.length)return{done:!1,value:this._results[P++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(P,K){return new le(async he=>{for await(const ye of P)he.emitOne(K(ye))})}map(P){return le.map(this,P)}static filter(P,K){return new le(async he=>{for await(const ye of P)K(ye)&&he.emitOne(ye)})}filter(P){return le.filter(this,P)}static coalesce(P){return le.filter(P,K=>!!K)}coalesce(){return le.coalesce(this)}static async toPromise(P){const K=[];for await(const he of P)K.push(he);return K}toPromise(){return le.toPromise(this)}emitOne(P){this._state===0&&(this._results.push(P),this._onStateChanged.fire())}emitMany(P){this._state===0&&(this._results=this._results.concat(P),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(P){this._state===0&&(this._state=2,this._error=P,this._onStateChanged.fire())}}e.AsyncIterableObject=le,le.EMPTY=le.fromArray([]);class De extends le{constructor(P,K){super(K),this._source=P}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=De;function Te(Ee){const P=new i.CancellationTokenSource,K=Ee(P.token);return new De(P,async he=>{const ye=P.token.onCancellationRequested(()=>{ye.dispose(),P.dispose(),he.reject(new C.CancellationError)});try{for await(const be of K){if(P.token.isCancellationRequested)return;he.emitOne(be)}ye.dispose(),P.dispose()}catch(be){ye.dispose(),P.dispose(),he.reject(be)}})}e.createCancelableAsyncIterable=Te}),define(Ae[37],Re([1,0,18,16,41,28,19,21,13]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",b="[^/\\\\]",c=/\//g;function p(ee,Ie){switch(ee){case 0:return"";case 1:return`${b}*?`;default:return`(?:${R}|${b}+${R}${Ie?`|${R}${b}+`:""})*?`}}function g(ee,Ie){if(!ee)return[];const oe=[];let ue=!1,X=!1,le="";for(const De of ee){switch(De){case Ie:if(!ue&&!X){oe.push(le),le="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":X=!0;break;case"]":X=!1;break}le+=De}return le&&oe.push(le),oe}e.splitGlobAware=g;function d(ee){if(!ee)return"";let Ie="";const oe=g(ee,e.GLOB_SPLIT);if(oe.every(ue=>ue===e.GLOBSTAR))Ie=".*";else{let ue=!1;oe.forEach((X,le)=>{if(X===e.GLOBSTAR){if(ue)return;Ie+=p(2,le===oe.length-1)}else{let De=!1,Te="",Ee=!1,P="";for(const K of X){if(K!=="}"&&De){Te+=K;continue}if(Ee&&(K!=="]"||!P)){let he;K==="-"?he=K:(K==="^"||K==="!")&&!P?he="^":K===e.GLOB_SPLIT?he="":he=(0,_.escapeRegExpCharacters)(K),P+=he;continue}switch(K){case"{":De=!0;continue;case"[":Ee=!0;continue;case"}":{const ye=`(?:${g(Te,",").map(be=>d(be)).join("|")})`;Ie+=ye,De=!1,Te="";break}case"]":{Ie+="["+P+"]",Ee=!1,P="";break}case"?":Ie+=b;continue;case"*":Ie+=p(1);continue;default:Ie+=(0,_.escapeRegExpCharacters)(K)}}le<oe.length-1&&(oe[le+1]!==e.GLOBSTAR||le+2<oe.length)&&(Ie+=R)}ue=X===e.GLOBSTAR})}return Ie}const t=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.LRUCache(1e4),u=function(){return!1},r=function(){return null};function a(ee,Ie){if(!ee)return r;let oe;typeof ee!="string"?oe=ee.pattern:oe=ee,oe=oe.trim();const ue=`${oe}_${!!Ie.trimForExclusions}`;let X=n.get(ue);if(X)return E(X,ee);let le;return t.test(oe)?X=f(oe.substr(4),oe):(le=l.exec(D(oe,Ie)))?X=T(le[1],oe):(Ie.trimForExclusions?S:h).test(oe)?X=w(oe,Ie):(le=I.exec(D(oe,Ie)))?X=o(le[1].substr(1),oe,!0):(le=v.exec(D(oe,Ie)))?X=o(le[1],oe,!1):X=s(oe),n.set(ue,X),E(X,ee)}function E(ee,Ie){if(typeof Ie=="string")return ee;const oe=function(ue,X){return(0,y.isEqualOrParent)(ue,Ie.base,!A.isLinux)?ee((0,_.ltrim)(ue.substr(Ie.base.length),O.sep),X):null};return oe.allBasenames=ee.allBasenames,oe.allPaths=ee.allPaths,oe.basenames=ee.basenames,oe.patterns=ee.patterns,oe}function D(ee,Ie){return Ie.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function f(ee,Ie){return function(oe,ue){return typeof oe=="string"&&oe.endsWith(ee)?Ie:null}}function T(ee,Ie){const oe=`/${ee}`,ue=`\\${ee}`,X=function(De,Te){return typeof De!="string"?null:Te?Te===ee?Ie:null:De===ee||De.endsWith(oe)||De.endsWith(ue)?Ie:null},le=[ee];return X.basenames=le,X.patterns=[Ie],X.allBasenames=le,X}function w(ee,Ie){const oe=x(ee.slice(1,-1).split(",").map(Te=>a(Te,Ie)).filter(Te=>Te!==r),ee),ue=oe.length;if(!ue)return r;if(ue===1)return oe[0];const X=function(Te,Ee){for(let P=0,K=oe.length;P<K;P++)if(oe[P](Te,Ee))return ee;return null},le=oe.find(Te=>!!Te.allBasenames);le&&(X.allBasenames=le.allBasenames);const De=oe.reduce((Te,Ee)=>Ee.allPaths?Te.concat(Ee.allPaths):Te,[]);return De.length&&(X.allPaths=De),X}function o(ee,Ie,oe){const ue=O.sep===O.posix.sep,X=ue?ee:ee.replace(c,O.sep),le=O.sep+X,De=O.posix.sep+ee;let Te;return oe?Te=function(Ee,P){return typeof Ee=="string"&&(Ee===X||Ee.endsWith(le)||!ue&&(Ee===ee||Ee.endsWith(De)))?Ie:null}:Te=function(Ee,P){return typeof Ee=="string"&&(Ee===X||!ue&&Ee===ee)?Ie:null},Te.allPaths=[(oe?"*/":"./")+ee],Te}function s(ee){try{const Ie=new RegExp(`^${d(ee)}$`);return function(oe){return Ie.lastIndex=0,typeof oe=="string"&&Ie.test(oe)?ee:null}}catch{return r}}function F(ee,Ie,oe){return!ee||typeof Ie!="string"?!1:B(ee)(Ie,void 0,oe)}e.match=F;function B(ee,Ie={}){if(!ee)return u;if(typeof ee=="string"||G(ee)){const oe=a(ee,Ie);if(oe===r)return u;const ue=function(X,le){return!!oe(X,le)};return oe.allBasenames&&(ue.allBasenames=oe.allBasenames),oe.allPaths&&(ue.allPaths=oe.allPaths),ue}return N(ee,Ie)}e.parse=B;function G(ee){const Ie=ee;return Ie?typeof Ie.base=="string"&&typeof Ie.pattern=="string":!1}e.isRelativePattern=G;function q(ee){return ee.allBasenames||[]}e.getBasenameTerms=q;function $(ee){return ee.allPaths||[]}e.getPathTerms=$;function N(ee,Ie){const oe=x(Object.getOwnPropertyNames(ee).map(Te=>V(Te,ee[Te],Ie)).filter(Te=>Te!==r)),ue=oe.length;if(!ue)return r;if(!oe.some(Te=>!!Te.requiresSiblings)){if(ue===1)return oe[0];const Te=function(K,he){let ye;for(let be=0,ge=oe.length;be<ge;be++){const Ce=oe[be](K,he);if(typeof Ce=="string")return Ce;(0,C.isThenable)(Ce)&&(ye||(ye=[]),ye.push(Ce))}return ye?(async()=>{for(const be of ye){const ge=await be;if(typeof ge=="string")return ge}return null})():null},Ee=oe.find(K=>!!K.allBasenames);Ee&&(Te.allBasenames=Ee.allBasenames);const P=oe.reduce((K,he)=>he.allPaths?K.concat(he.allPaths):K,[]);return P.length&&(Te.allPaths=P),Te}const X=function(Te,Ee,P){let K,he;for(let ye=0,be=oe.length;ye<be;ye++){const ge=oe[ye];ge.requiresSiblings&&P&&(Ee||(Ee=(0,O.basename)(Te)),K||(K=Ee.substr(0,Ee.length-(0,O.extname)(Te).length)));const Ce=ge(Te,Ee,K,P);if(typeof Ce=="string")return Ce;(0,C.isThenable)(Ce)&&(he||(he=[]),he.push(Ce))}return he?(async()=>{for(const ye of he){const be=await ye;if(typeof be=="string")return be}return null})():null},le=oe.find(Te=>!!Te.allBasenames);le&&(X.allBasenames=le.allBasenames);const De=oe.reduce((Te,Ee)=>Ee.allPaths?Te.concat(Ee.allPaths):Te,[]);return De.length&&(X.allPaths=De),X}function V(ee,Ie,oe){if(Ie===!1)return r;const ue=a(ee,oe);if(ue===r)return r;if(typeof Ie=="boolean")return ue;if(Ie){const X=Ie.when;if(typeof X=="string"){const le=(De,Te,Ee,P)=>{if(!P||!ue(De,Te))return null;const K=X.replace("$(basename)",()=>Ee),he=P(K);return(0,C.isThenable)(he)?he.then(ye=>ye?ee:null):he?ee:null};return le.requiresSiblings=!0,le}}return ue}function x(ee,Ie){const oe=ee.filter(Te=>!!Te.basenames);if(oe.length<2)return ee;const ue=oe.reduce((Te,Ee)=>{const P=Ee.basenames;return P?Te.concat(P):Te},[]);let X;if(Ie){X=[];for(let Te=0,Ee=ue.length;Te<Ee;Te++)X.push(Ie)}else X=oe.reduce((Te,Ee)=>{const P=Ee.patterns;return P?Te.concat(P):Te},[]);const le=function(Te,Ee){if(typeof Te!="string")return null;if(!Ee){let K;for(K=Te.length;K>0;K--){const he=Te.charCodeAt(K-1);if(he===47||he===92)break}Ee=Te.substr(K)}const P=ue.indexOf(Ee);return P!==-1?X[P]:null};le.basenames=ue,le.patterns=X,le.allBasenames=ue;const De=ee.filter(Te=>!Te.basenames);return De.push(le),De}function W(ee,Ie){return(0,i.equals)(ee,Ie,(oe,ue)=>typeof oe=="string"&&typeof ue=="string"?oe===ue:typeof oe!="string"&&typeof ue!="string"?oe.base===ue.base&&oe.pattern===ue.pattern:!1)}e.patternsEquals=W}),define(Ae[89],Re([1,0,10,131,25,13,2]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class _{constructor(l="",h=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(l,h=0){return this.value+=c(this.supportThemeIcons?(0,C.escapeIcons)(l):l).replace(/([ \t]+)/g,(S,I)=>"&nbsp;".repeat(I.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,h){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(l,h,S){return this.value+="[",this.value+=this._escape(h,"]"),this.value+="](",this.value+=this._escape(String(l),")"),S&&(this.value+=` "${this._escape(this._escape(S,'"'),")")}"`),this.value+=")",this}_escape(l,h){const S=new RegExp((0,M.escapeRegExpCharacters)(h),"g");return l.replace(S,(I,v)=>l.charAt(v-1)!=="\\"?`\\${I}`:I)}}e.MarkdownString=_;function m(t){return R(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.isEmptyMarkdownString=m;function R(t){return t instanceof _?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function b(t,l){return t===l?!0:!t||!l?!1:t.value===l.value&&t.isTrusted===l.isTrusted&&t.supportThemeIcons===l.supportThemeIcons&&t.supportHtml===l.supportHtml&&(t.baseUri===l.baseUri||!!t.baseUri&&!!l.baseUri&&(0,y.isEqual)(O.URI.from(t.baseUri),O.URI.from(l.baseUri)))}e.markdownStringEqual=b;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=c;function p(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function d(t){const l=[],h=t.split("|").map(I=>I.trim());t=h[0];const S=h[1];if(S){const I=/height=(\d+)/.exec(S),v=/width=(\d+)/.exec(S),n=I?I[1]:"",u=v?v[1]:"",r=isFinite(parseInt(u)),a=isFinite(parseInt(n));r&&l.push(`width="${u}"`),a&&l.push(`height="${n}"`)}return{href:t,dimensions:l}}e.parseHrefAndDimensions=d}),define(Ae[90],Re([1,0,18,41,19,21,25,13]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function _(a,E){const{os:D,tildify:f,relative:T}=E;if(T){const s=m(a,T,D);if(typeof s=="string")return s}let w=a.fsPath;if(D===1&&!M.isWindows?w=w.replace(/\//g,"\\"):D!==1&&M.isWindows&&(w=w.replace(/\\/g,"/")),D!==1&&f?.userHome){const s=f.userHome.fsPath;let F;a.scheme!==f.userHome.scheme&&a.path.startsWith(y.posix.sep)?F=f.userHome.with({path:a.path}).fsPath:F=a.fsPath,w=c(F,s,D)}return(D===1?y.win32:y.posix).normalize(R(w,D===1))}e.getPathLabel=_;function m(a,E,D){const f=D===1?y.win32:y.posix,T=D===3?O.extUri:O.extUriIgnorePathCase,w=E.getWorkspace(),o=(0,i.firstOrDefault)(w.folders);if(!o)return;a.scheme!==o.uri.scheme&&a.path.startsWith(y.posix.sep)&&(a=o.uri.with({path:a.path}));const s=E.getWorkspaceFolder(a);if(!s)return;let F;if(T.isEqual(s.uri,a)?F="":F=T.relativePath(s.uri,a)??"",F&&(F=f.normalize(F)),w.folders.length>1&&!E.noPrefix){const B=s.name?s.name:T.basenameOrAuthority(s.uri);F=F?`${B} \u2022 ${F}`:B}return F}function R(a,E=M.isWindows){return(0,C.hasDriveLetter)(a,E)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=R;let b=Object.create(null);function c(a,E,D=M.OS){if(D===1||!a||!E)return a;let f=b.original===E?b.normalized:void 0;f||(f=E,M.isWindows&&(f=(0,C.toSlashes)(f)),f=`${(0,A.rtrim)(f,y.posix.sep)}${y.posix.sep}`,b={original:E,normalized:f});let T=a;return M.isWindows&&(T=(0,C.toSlashes)(T)),(D===3?T.startsWith(f):(0,A.startsWithIgnoreCase)(T,f))?`~/${T.substr(f.length)}`:a}e.tildify=c;function p(a,E){return a.replace(/^~($|\/|\\)/,`${E}$1`)}e.untildify=p;const g="\u2026",d="\\\\",t="~";function l(a,E=y.sep){const D=new Array(a.length);let f=!1;for(let T=0;T<a.length;T++){const w=a[T];if(w===""){D[T]=`.${E}`;continue}if(!w){D[T]=w;continue}f=!0;let o="",s=w;s.indexOf(d)===0?(o=s.substr(0,s.indexOf(d)+d.length),s=s.substr(s.indexOf(d)+d.length)):s.indexOf(E)===0?(o=s.substr(0,s.indexOf(E)+E.length),s=s.substr(s.indexOf(E)+E.length)):s.indexOf(t)===0&&(o=s.substr(0,s.indexOf(t)+t.length),s=s.substr(s.indexOf(t)+t.length));const F=s.split(E);for(let B=1;f&&B<=F.length;B++)for(let G=F.length-B;f&&G>=0;G--){f=!1;let q=F.slice(G,G+B).join(E);for(let $=0;!f&&$<a.length;$++)if($!==T&&a[$]&&a[$].indexOf(q)>-1){const N=G+B===F.length,V=G>0&&a[$].indexOf(E)>-1?E+q:q,x=a[$].endsWith(V);f=!N||x}if(!f){let $="";(F[0].endsWith(":")||o!=="")&&(G===1&&(G=0,B++,q=F[0]+E+q),G>0&&($=F[0]+E),$=o+$),G>0&&($=$+g+E),$=$+q,G+B<F.length&&($=$+E+g),D[T]=$}}f&&(D[T]=w)}return D}e.shorten=l;var h;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function S(a,E=Object.create(null)){const D=[];let f=!1,T="";for(const w of a)if(w==="$"||f&&w==="{")T&&D.push({value:T,type:h.TEXT}),T="",f=!0;else if(w==="}"&&f){const o=E[T];if(typeof o=="string")o.length&&D.push({value:o,type:h.VARIABLE});else if(o){const s=D[D.length-1];(!s||s.type!==h.SEPARATOR)&&D.push({value:o.label,type:h.SEPARATOR})}T="",f=!1}else T+=w;return T&&!f&&D.push({value:T,type:h.TEXT}),D.filter((w,o)=>{if(w.type===h.SEPARATOR){const s=D[o-1],F=D[o+1];return[s,F].every(B=>B&&(B.type===h.VARIABLE||B.type===h.TEXT)&&B.value.length>0)}return!0}).map(w=>w.value).join("")}e.template=S;function I(a,E){return M.isMacintosh||E?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):a.replace(/&&|&/g,D=>D==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function v(a,E){return M.isMacintosh||E?a.replace(/\(&&\w\)|&&/g,""):M.isWindows?a.replace(/&&|&/g,D=>D==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function n(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=n;function u(a){if(a.endsWith("]")){const E=a.lastIndexOf(" [",a.length-2);if(E!==-1){const D=r(a.substring(0,E));return{name:D.name,parentPath:D.parentPath+a.substring(E)}}}return r(a)}e.splitRecentLabel=u;function r(a){const E=a.indexOf("/")!==-1?y.posix:y.win32,D=E.basename(a),f=E.dirname(a);return D.length?{name:D,parentPath:f}:{name:f,parentPath:""}}}),define(Ae[132],Re([1,0,24,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(b){return b.toJSON()}class M{constructor(c){this._uriTransformer=c}transformIncoming(c){const p=this._uriTransformer.transformIncoming(c);return p===c?c:y(C.URI.from(p))}transformOutgoing(c){const p=this._uriTransformer.transformOutgoing(c);return p===c?c:y(C.URI.from(p))}transformOutgoingURI(c){const p=this._uriTransformer.transformOutgoing(c);return p===c?c:C.URI.from(p)}transformOutgoingScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function O(b,c,p){if(!b||p>200)return null;if(typeof b=="object"){if(b instanceof C.URI)return c.transformOutgoing(b);for(const g in b)if(Object.hasOwnProperty.call(b,g)){const d=O(b[g],c,p+1);d!==null&&(b[g]=d)}}return null}function A(b,c){const p=O(b,c,0);return p===null?b:p}e.transformOutgoingURIs=A;function _(b,c,p,g){if(!b||g>200)return null;if(typeof b=="object"){if(b.$mid===1)return p?C.URI.revive(c.transformIncoming(b)):c.transformIncoming(b);if(b instanceof i.VSBuffer)return null;for(const d in b)if(Object.hasOwnProperty.call(b,d)){const t=_(b[d],c,p,g+1);t!==null&&(b[d]=t)}}return null}function m(b,c){const p=_(b,c,!1,0);return p===null?b:p}e.transformIncomingURIs=m;function R(b,c){const p=_(b,c,!0,0);return p===null?b:p}e.transformAndReviveIncomingURIs=R}),define(Ae[133],Re([1,0,37,19]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(M,O,A,_,m,R){if(Array.isArray(M)){let b=0;for(const c of M){const p=y(c,O,A,_,m,R);if(p===10)return p;p>b&&(b=p)}return b}else{if(typeof M=="string")return _?M==="*"?5:M===A?10:0:0;if(M){const{language:b,pattern:c,scheme:p,hasAccessToAllModels:g,notebookType:d}=M;if(!_&&!g)return 0;d&&m&&(O=m);let t=0;if(p)if(p===O.scheme)t=10;else if(p==="*")t=5;else return 0;if(b)if(b===A)t=10;else if(b==="*")t=Math.max(t,5);else return 0;if(d)if(d===R)t=10;else if(d==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(c){let l;if(typeof c=="string"?l=c:l={...c,base:(0,C.normalize)(c.base)},l===O.fsPath||(0,i.match)(l,O.fsPath))t=10;else return 0}return t}else return 0}}e.score=y}),define(Ae[91],Re([1,0,24,21]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(y||(y={}));function M(b){for(let c=0,p=b.length;c<p;c+=4){const g=b[c+0],d=b[c+1],t=b[c+2],l=b[c+3];b[c+0]=l,b[c+1]=t,b[c+2]=d,b[c+3]=g}}function O(b){const c=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return C.isLittleEndian()||M(c),i.VSBuffer.wrap(c)}function A(b){const c=b.buffer;if(C.isLittleEndian()||M(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const p=new Uint8Array(c.byteLength);return p.set(c),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function _(b){const c=new Uint32Array(m(b));let p=0;if(c[p++]=b.id,b.type==="full")c[p++]=1,c[p++]=b.data.length,c.set(b.data,p),p+=b.data.length;else{c[p++]=2,c[p++]=b.deltas.length;for(const g of b.deltas)c[p++]=g.start,c[p++]=g.deleteCount,g.data?(c[p++]=g.data.length,c.set(g.data,p),p+=g.data.length):c[p++]=0}return O(c)}e.encodeSemanticTokensDto=_;function m(b){let c=0;if(c+=1+1,b.type==="full")c+=1+b.data.length;else{c+=1,c+=(1+1+1)*b.deltas.length;for(const p of b.deltas)p.data&&(c+=p.data.length)}return c}function R(b){const c=A(b);let p=0;const g=c[p++];if(c[p++]===1){const h=c[p++],S=c.subarray(p,p+h);return p+=h,{id:g,type:"full",data:S}}const t=c[p++],l=[];for(let h=0;h<t;h++){const S=c[p++],I=c[p++],v=c[p++];let n;v>0&&(n=c.subarray(p,p+v),p+=v),l[h]={start:S,deleteCount:I,data:n}}return{id:g,type:"delta",deltas:l}}e.decodeSemanticTokensDto=R}),define(Ae[134],Re([11,12]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,134,21,136,18,26,121]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(_||(e.EditorAutoIndentStrategy=_={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=m;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class b{constructor(J,fe,Ue,Ve){this.id=J,this.name=fe,this.defaultValue=Ue,this.schema=Ve}applyUpdate(J,fe){return p(J,fe)}compute(J,fe,Ue){return Ue}}class c{constructor(J,fe){this.newValue=J,this.didChange=fe}}e.ApplyUpdateResult=c;function p(Y,J){if(typeof Y!="object"||typeof J!="object"||!Y||!J)return new c(J,Y!==J);if(Array.isArray(Y)||Array.isArray(J)){const Ue=Array.isArray(Y)&&Array.isArray(J)&&M.equals(Y,J);return new c(J,!Ue)}let fe=!1;for(const Ue in J)if(J.hasOwnProperty(Ue)){const Ve=p(Y[Ue],J[Ue]);Ve.didChange&&(Y[Ue]=Ve.newValue,fe=!0)}return new c(Y,fe)}class g{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,fe){return p(J,fe)}validate(J){return this.defaultValue}}class d{constructor(J,fe,Ue,Ve){this.id=J,this.name=fe,this.defaultValue=Ue,this.schema=Ve}applyUpdate(J,fe){return p(J,fe)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,fe,Ue){return Ue}}function t(Y,J){return typeof Y>"u"?J:Y==="false"?!1:!!Y}e.boolean=t;class l extends d{constructor(J,fe,Ue,Ve=void 0){typeof Ve<"u"&&(Ve.type="boolean",Ve.default=Ue),super(J,fe,Ue,Ve)}validate(J){return t(J,this.defaultValue)}}function h(Y,J,fe,Ue){if(typeof Y>"u")return J;let Ve=parseInt(Y,10);return isNaN(Ve)?J:(Ve=Math.max(fe,Ve),Ve=Math.min(Ue,Ve),Ve|0)}e.clampedInt=h;class S extends d{static clampedInt(J,fe,Ue,Ve){return h(J,fe,Ue,Ve)}constructor(J,fe,Ue,Ve,$e,Je=void 0){typeof Je<"u"&&(Je.type="integer",Je.default=Ue,Je.minimum=Ve,Je.maximum=$e),super(J,fe,Ue,Je),this.minimum=Ve,this.maximum=$e}validate(J){return S.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function I(Y,J,fe,Ue){if(typeof Y>"u")return J;const Ve=v.float(Y,J);return v.clamp(Ve,fe,Ue)}e.clampedFloat=I;class v extends d{static clamp(J,fe,Ue){return J<fe?fe:J>Ue?Ue:J}static float(J,fe){if(typeof J=="number")return J;if(typeof J>"u")return fe;const Ue=parseFloat(J);return isNaN(Ue)?fe:Ue}constructor(J,fe,Ue,Ve,$e){typeof $e<"u"&&($e.type="number",$e.default=Ue),super(J,fe,Ue,$e),this.validationFn=Ve}validate(J){return this.validationFn(v.float(J,this.defaultValue))}}class n extends d{static string(J,fe){return typeof J!="string"?fe:J}constructor(J,fe,Ue,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.default=Ue),super(J,fe,Ue,Ve)}validate(J){return n.string(J,this.defaultValue)}}function u(Y,J,fe,Ue){return typeof Y!="string"?J:Ue&&Y in Ue?Ue[Y]:fe.indexOf(Y)===-1?J:Y}e.stringSet=u;class r extends d{constructor(J,fe,Ue,Ve,$e=void 0){typeof $e<"u"&&($e.type="string",$e.enum=Ve,$e.default=Ue),super(J,fe,Ue,$e),this._allowedValues=Ve}validate(J){return u(J,this.defaultValue,this._allowedValues)}}class a extends b{constructor(J,fe,Ue,Ve,$e,Je,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=$e,mt.default=Ve),super(J,fe,Ue,mt),this._allowedValues=$e,this._convert=Je}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function E(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class D extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,fe,Ue){return Ue===0?J.accessibilitySupport:Ue}}class f extends b{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:i.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{insertSpace:t(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var T;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(T||(e.TextEditorCursorBlinkingStyle=T={}));function w(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(o||(e.TextEditorCursorStyle=o={}));function s(Y){switch(Y){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function F(Y){switch(Y){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class B extends g{constructor(){super(137)}compute(J,fe,Ue){const Ve=["monaco-editor"];return fe.get(37)&&Ve.push(fe.get(37)),J.extraEditorClassName&&Ve.push(J.extraEditorClassName),fe.get(71)==="default"?Ve.push("mouse-default"):fe.get(71)==="copy"&&Ve.push("mouse-copy"),fe.get(107)&&Ve.push("showUnused"),fe.get(135)&&Ve.push("showDeprecated"),Ve.join(" ")}}class G extends l{constructor(){super(35,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(J,fe,Ue){return Ue&&J.emptySelectionClipboard}}class q extends b{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:i.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:i.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{cursorMoveOnType:t(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":u(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":u(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(fe.loop,this.defaultValue.loop)}}}class $ extends b{constructor(){super(49,"fontLigatures",$.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?$.OFF:J==="true"?$.ON:J:J?$.ON:$.OFF}}e.EditorFontLigatures=$,$.OFF='"liga" off, "calt" off',$.ON='"liga" on, "calt" on';class N extends b{constructor(){super(52,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?N.OFF:J==="true"?N.TRANSLATE:J:J?N.TRANSLATE:N.OFF}compute(J,fe,Ue){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class V extends g{constructor(){super(48)}compute(J,fe,Ue){return J.fontInfo}}class x extends d{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(J){const fe=v.float(J,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(fe,6,100)}compute(J,fe,Ue){return J.fontInfo.fontSize}}class W extends b{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(S.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class ee extends b{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...fe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...fe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ue,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ue,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ue,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ue,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ue,description:i.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{multiple:u(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??u(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??u(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??u(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??u(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??u(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ie extends b{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:J.above,description:i.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),delay:S.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:t(fe.sticky,this.defaultValue.sticky),above:t(fe.above,this.defaultValue.above)}}}var oe;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(oe||(e.RenderMinimap=oe={}));class ue extends g{constructor(){super(140)}compute(J,fe,Ue){return ue.computeLayout(fe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const fe=J.height/J.lineHeight,Ue=Math.floor(J.paddingTop/J.lineHeight);let Ve=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(Ve=Math.max(Ve,fe-1));const $e=(Ue+J.viewLineCount+Ve)/(J.pixelRatio*J.height),Je=Math.floor(J.viewLineCount/$e);return{typicalViewportLineCount:fe,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Ve,desiredRatio:$e,minimapLineCount:Je}}static _computeMinimapLayout(J,fe){const Ue=J.outerWidth,Ve=J.outerHeight,$e=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Je=fe.stableMinimapLayoutInput,mt=Je&&J.outerHeight===Je.outerHeight&&J.lineHeight===Je.lineHeight&&J.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&J.pixelRatio===Je.pixelRatio&&J.scrollBeyondLastLine===Je.scrollBeyondLastLine&&J.paddingTop===Je.paddingTop&&J.paddingBottom===Je.paddingBottom&&J.minimap.enabled===Je.minimap.enabled&&J.minimap.side===Je.minimap.side&&J.minimap.size===Je.minimap.size&&J.minimap.showSlider===Je.minimap.showSlider&&J.minimap.renderCharacters===Je.minimap.renderCharacters&&J.minimap.maxColumn===Je.minimap.maxColumn&&J.minimap.scale===Je.minimap.scale&&J.verticalScrollbarWidth===Je.verticalScrollbarWidth&&J.isViewportWrapping===Je.isViewportWrapping,_t=J.lineHeight,Ct=J.typicalHalfwidthCharacterWidth,qt=J.scrollBeyondLastLine,Bt=J.minimap.renderCharacters;let St=$e>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const $t=J.minimap.maxColumn,Ft=J.minimap.size,Vt=J.minimap.side,Rt=J.verticalScrollbarWidth,Lt=J.viewLineCount,zt=J.remainingWidth,at=J.isViewportWrapping,ht=Bt?2:3;let Mt=Math.floor($e*Ve);const Nt=Mt/$e;let wt=!1,ut=!1,It=ht*St,Ut=St/$e,Pe=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:ze,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:bt,desiredRatio:Pt,minimapLineCount:kt}=ue.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:qt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:Ve,lineHeight:_t,pixelRatio:$e});if(Lt/kt>1)wt=!0,ut=!0,St=1,It=1,Ut=St/$e;else{let ot=!1,gt=St+1;if(Ft==="fit"){const pt=Math.ceil((et+Lt+bt)*It);at&&mt&&zt<=fe.stableFitRemainingWidth?(ot=!0,gt=fe.stableFitMaxMinimapScale):ot=pt>Mt}if(Ft==="fill"||ot){wt=!0;const pt=St;It=Math.min(_t*$e,Math.max(1,Math.floor(1/Pt))),at&&mt&&zt<=fe.stableFitRemainingWidth&&(gt=fe.stableFitMaxMinimapScale),St=Math.min(gt,Math.max(1,Math.floor(It/ht))),St>pt&&(Pe=Math.min(2,St/pt)),Ut=St/$e/Pe,Mt=Math.ceil(Math.max(ze,et+Lt+bt)*It),at?(fe.stableMinimapLayoutInput=J,fe.stableFitRemainingWidth=zt,fe.stableFitMaxMinimapScale=St):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const we=Math.floor($t*Ut),ve=Math.min(we,Math.max(0,Math.floor((zt-Rt-2)*Ut/(Ct+Ut)))+e.MINIMAP_GUTTER_WIDTH);let Q=Math.floor($e*ve);const Fe=Q/$e;Q=Math.floor(Q*Pe);const xe=Bt?1:2,Ge=Vt==="left"?0:Ue-ve-Rt;return{renderMinimap:xe,minimapLeft:Ge,minimapWidth:ve,minimapHeightIsEditorHeight:wt,minimapIsSampling:ut,minimapScale:St,minimapLineHeight:It,minimapCanvasInnerWidth:Q,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Nt}}static computeLayout(J,fe){const Ue=fe.outerWidth|0,Ve=fe.outerHeight|0,$e=fe.lineHeight|0,Je=fe.lineNumbersDigitCount|0,mt=fe.typicalHalfwidthCharacterWidth,_t=fe.maxDigitWidth,Ct=fe.pixelRatio,qt=fe.viewLineCount,Bt=J.get(132),St=Bt==="inherit"?J.get(131):Bt,$t=St==="inherit"?J.get(127):St,Ft=J.get(130),Vt=fe.isDominatedByLongLines,Rt=J.get(55),Lt=J.get(65).renderType!==0,zt=J.get(66),at=J.get(101),ht=J.get(81),Mt=J.get(70),Nt=J.get(99),wt=Nt.verticalScrollbarSize,ut=Nt.verticalHasArrows,It=Nt.arrowSize,Ut=Nt.horizontalScrollbarSize,Pe=J.get(41),we=J.get(106)!=="never";let ve=J.get(63);Pe&&we&&(ve+=16);let Q=0;if(Lt){const oi=Math.max(Je,zt);Q=Math.round(oi*_t)}let Fe=0;Rt&&(Fe=$e*fe.glyphMarginDecorationLaneCount);let xe=0,Ge=xe+Fe,ze=Ge+Q,et=ze+ve;const bt=Ue-Fe-Q-ve;let Pt=!1,kt=!1,vt=-1;St==="inherit"&&Vt?(Pt=!0,kt=!0):$t==="on"||$t==="bounded"?kt=!0:$t==="wordWrapColumn"&&(vt=Ft);const ot=ue._computeMinimapLayout({outerWidth:Ue,outerHeight:Ve,lineHeight:$e,typicalHalfwidthCharacterWidth:mt,pixelRatio:Ct,scrollBeyondLastLine:at,paddingTop:ht.top,paddingBottom:ht.bottom,minimap:Mt,verticalScrollbarWidth:wt,viewLineCount:qt,remainingWidth:bt,isViewportWrapping:kt},fe.memory||new R);ot.renderMinimap!==0&&ot.minimapLeft===0&&(xe+=ot.minimapWidth,Ge+=ot.minimapWidth,ze+=ot.minimapWidth,et+=ot.minimapWidth);const gt=bt-ot.minimapWidth,pt=Math.max(1,Math.floor((gt-wt-2)/mt)),Et=ut?It:0;return kt&&(vt=Math.max(1,pt),$t==="bounded"&&(vt=Math.min(vt,Ft))),{width:Ue,height:Ve,glyphMarginLeft:xe,glyphMarginWidth:Fe,glyphMarginDecorationLaneCount:fe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:Q,decorationsLeft:ze,decorationsWidth:ve,contentLeft:et,contentWidth:gt,minimap:ot,viewportColumn:pt,isWordWrapMinified:Pt,isViewportWrapping:kt,wrappingColumn:vt,verticalScrollbarWidth:wt,horizontalScrollbarHeight:Ut,overviewRuler:{top:Et,width:wt,height:Ve-2*Et,right:0}}}}e.EditorLayoutInfoComputer=ue;class X extends b{constructor(){super(134,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(J){return u(J,"simple",["simple","advanced"])}compute(J,fe,Ue){return fe.get(2)===2?"advanced":Ue}}class le extends b{constructor(){const J={enabled:!0};super(62,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:i.localize(49,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:t(J.enabled,this.defaultValue.enabled)}}}class De extends b{constructor(){const J={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(111,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:i.localize(52,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(fe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u(fe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class Te extends b{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(136,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:i.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(54,null),i.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:i.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:i.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:i.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:u(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(fe.fontFamily,this.defaultValue.fontFamily),padding:t(fe.padding,this.defaultValue.padding)}}}class Ee extends b{constructor(){super(63,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):S.clampedInt(J,this.defaultValue,0,1e3)}compute(J,fe,Ue){return Ue<0?S.clampedInt(-Ue*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class P extends v{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>v.clamp(J,0,150),{markdownDescription:i.localize(61,null)})}compute(J,fe,Ue){return J.fontInfo.lineHeight}}class K extends b{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:i.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:i.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(64,null),i.localize(65,null),i.localize(66,null)],default:J.size,description:i.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:i.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:i.localize(69,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:i.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:i.localize(72,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),autohide:t(fe.autohide,this.defaultValue.autohide),size:u(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(fe.side,this.defaultValue.side,["right","left"]),showSlider:u(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(fe.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(fe.scale,1,1,3),maxColumn:S.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(Y){return Y==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ye extends b{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(74,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{top:S.clampedInt(fe.top,0,0,1e3),bottom:S.clampedInt(fe.bottom,0,0,1e3)}}}class be extends b{constructor(){const J={enabled:!0,cycle:!0};super(83,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:i.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:i.localize(76,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),cycle:t(fe.cycle,this.defaultValue.cycle)}}}class ge extends g{constructor(){super(138)}compute(J,fe,Ue){return J.pixelRatio}}class Ce extends b{constructor(){const J={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(77,null),i.localize(78,null),i.localize(79,null)]}];super(86,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:J.strings,description:i.localize(80,null)},comments:{anyOf:fe,default:J.comments,description:i.localize(81,null)},other:{anyOf:fe,default:J.other,description:i.localize(82,null)}},default:J,markdownDescription:i.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const Ct=J?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!J||typeof J!="object")return this.defaultValue;const{other:fe,comments:Ue,strings:Ve}=J,$e=["on","inline","off"];let Je,mt,_t;return typeof fe=="boolean"?Je=fe?"on":"off":Je=u(fe,this.defaultValue.other,$e),typeof Ue=="boolean"?mt=Ue?"on":"off":mt=u(Ue,this.defaultValue.comments,$e),typeof Ve=="boolean"?_t=Ve?"on":"off":_t=u(Ve,this.defaultValue.strings,$e),{other:Je,comments:mt,strings:_t}}}var ae;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class de extends b{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(84,null),i.localize(85,null),i.localize(86,null),i.localize(87,null)],default:"on",description:i.localize(88,null)})}validate(J){let fe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(fe=4,Ue=J):J==="interval"?fe=3:J==="relative"?fe=2:J==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ue}}}function Z(Y){const J=Y.get(94);return J==="editable"?Y.get(88):J!=="on"}e.filterValidationDecorations=Z;class ne extends b{constructor(){const J=[],fe={type:"number",description:i.localize(89,null)};super(98,"rulers",J,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:i.localize(90,null),format:"color-hex"}}}]},default:J,description:i.localize(91,null)})}validate(J){if(Array.isArray(J)){const fe=[];for(const Ue of J)if(typeof Ue=="number")fe.push({column:S.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ve=Ue;fe.push({column:S.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return fe.sort((Ue,Ve)=>Ue.column-Ve.column),fe}return this.defaultValue}}function k(Y,J){if(typeof Y!="string")return J;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends b{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(99,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(92,null),i.localize(93,null),i.localize(94,null)],default:"auto",description:i.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(96,null),i.localize(97,null),i.localize(98,null)],default:"auto",description:i.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:i.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:i.localize(102,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J,Ue=S.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=S.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:k(fe.vertical,this.defaultValue.vertical),horizontal:k(fe.horizontal,this.defaultValue.horizontal),useShadows:t(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:S.clampedInt(fe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:S.clampedInt(fe.verticalSliderSize,Ve,0,1e3),scrollByPage:t(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends b{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(121,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:i.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:i.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:i.localize(109,null)}})}applyUpdate(J,fe){let Ue=!1;fe.allowedCharacters&&J&&(O.equals(J.allowedCharacters,fe.allowedCharacters)||(J={...J,allowedCharacters:fe.allowedCharacters},Ue=!0)),fe.allowedLocales&&J&&(O.equals(J.allowedLocales,fe.allowedLocales)||(J={...J,allowedLocales:fe.allowedLocales},Ue=!0));const Ve=super.applyUpdate(J,fe);return Ue?new c(Ve.newValue,!0):Ve}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{nonBasicASCII:ie(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ie(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ie(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(J.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(J,fe){if(typeof J!="object"||!J)return fe;const Ue={};for(const[Ve,$e]of Object.entries(J))$e===!0&&(Ue[Ve]=!0);return Ue}}class j extends b{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:i.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover"],enumDescriptions:[i.localize(111,null),i.localize(112,null)],description:i.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:i.localize(114,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),mode:u(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(fe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(fe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(fe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ce extends b{constructor(){const J={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:i.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:i.localize(116,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class pe extends b{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(117,null),i.localize(118,null),i.localize(119,null)],default:J.bracketPairs,description:i.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(121,null),i.localize(122,null),i.localize(123,null)],default:J.bracketPairsHorizontal,description:i.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:i.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:i.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(127,null),i.localize(128,null),i.localize(129,null)],default:J.highlightActiveIndentation,description:i.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{bracketPairs:ie(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ie(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ie(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ie(Y,J,fe){const Ue=fe.indexOf(Y);return Ue===-1?J:fe[Ue]}class Se extends b{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(114,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(131,null),i.localize(132,null)],default:J.insertMode,description:i.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:i.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:i.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:i.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[i.localize(137,null),i.localize(138,null),i.localize(139,null),i.localize(140,null)],default:J.selectionMode,markdownDescription:i.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:i.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:i.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:i.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:i.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:i.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(178,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{insertMode:u(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(fe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(fe.showIcons,this.defaultValue.showIcons),showStatusBar:t(fe.showStatusBar,this.defaultValue.showStatusBar),preview:t(fe.preview,this.defaultValue.preview),previewMode:u(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(fe.showMethods,this.defaultValue.showMethods),showFunctions:t(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(fe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(fe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(fe.showFields,this.defaultValue.showFields),showVariables:t(fe.showVariables,this.defaultValue.showVariables),showClasses:t(fe.showClasses,this.defaultValue.showClasses),showStructs:t(fe.showStructs,this.defaultValue.showStructs),showInterfaces:t(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(fe.showModules,this.defaultValue.showModules),showProperties:t(fe.showProperties,this.defaultValue.showProperties),showEvents:t(fe.showEvents,this.defaultValue.showEvents),showOperators:t(fe.showOperators,this.defaultValue.showOperators),showUnits:t(fe.showUnits,this.defaultValue.showUnits),showValues:t(fe.showValues,this.defaultValue.showValues),showConstants:t(fe.showConstants,this.defaultValue.showConstants),showEnums:t(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(fe.showKeywords,this.defaultValue.showKeywords),showWords:t(fe.showWords,this.defaultValue.showWords),showColors:t(fe.showColors,this.defaultValue.showColors),showFiles:t(fe.showFiles,this.defaultValue.showFiles),showReferences:t(fe.showReferences,this.defaultValue.showReferences),showFolders:t(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(fe.showSnippets,this.defaultValue.showSnippets),showUsers:t(fe.showUsers,this.defaultValue.showUsers),showIssues:t(fe.showIssues,this.defaultValue.showIssues)}}}class _e extends b{constructor(){super(109,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(179,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Be;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class He extends b{constructor(){super(133,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(180,null),i.localize(181,null),i.localize(182,null),i.localize(183,null)],description:i.localize(184,null),default:"same"}})}validate(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(J,fe,Ue){return fe.get(2)===2?0:Ue}}class Ze extends g{constructor(){super(141)}compute(J,fe,Ue){const Ve=fe.get(140);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}class Xe extends b{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:i.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:i.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[i.localize(187,null),i.localize(188,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),showDropSelector:u(fe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ke extends b{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:i.localize(189,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:i.localize(190,null),enum:["afterPaste","never"],enumDescriptions:[i.localize(191,null),i.localize(192,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:t(fe.enabled,this.defaultValue.enabled),showPasteSelector:u(fe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?st:C.isLinux?tt:it,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var dt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.autoClosingBrackets=5]="autoClosingBrackets",Y[Y.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=7]="autoClosingDelete",Y[Y.autoClosingOvertype=8]="autoClosingOvertype",Y[Y.autoClosingQuotes=9]="autoClosingQuotes",Y[Y.autoIndent=10]="autoIndent",Y[Y.automaticLayout=11]="automaticLayout",Y[Y.autoSurround=12]="autoSurround",Y[Y.bracketPairColorization=13]="bracketPairColorization",Y[Y.guides=14]="guides",Y[Y.codeLens=15]="codeLens",Y[Y.codeLensFontFamily=16]="codeLensFontFamily",Y[Y.codeLensFontSize=17]="codeLensFontSize",Y[Y.colorDecorators=18]="colorDecorators",Y[Y.colorDecoratorsLimit=19]="colorDecoratorsLimit",Y[Y.columnSelection=20]="columnSelection",Y[Y.comments=21]="comments",Y[Y.contextmenu=22]="contextmenu",Y[Y.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=24]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=26]="cursorStyle",Y[Y.cursorSurroundingLines=27]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=29]="cursorWidth",Y[Y.disableLayerHinting=30]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",Y[Y.domReadOnly=32]="domReadOnly",Y[Y.dragAndDrop=33]="dragAndDrop",Y[Y.dropIntoEditor=34]="dropIntoEditor",Y[Y.emptySelectionClipboard=35]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=37]="extraEditorClassName",Y[Y.fastScrollSensitivity=38]="fastScrollSensitivity",Y[Y.find=39]="find",Y[Y.fixedOverflowWidgets=40]="fixedOverflowWidgets",Y[Y.folding=41]="folding",Y[Y.foldingStrategy=42]="foldingStrategy",Y[Y.foldingHighlight=43]="foldingHighlight",Y[Y.foldingImportsByDefault=44]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=45]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=47]="fontFamily",Y[Y.fontInfo=48]="fontInfo",Y[Y.fontLigatures=49]="fontLigatures",Y[Y.fontSize=50]="fontSize",Y[Y.fontWeight=51]="fontWeight",Y[Y.fontVariations=52]="fontVariations",Y[Y.formatOnPaste=53]="formatOnPaste",Y[Y.formatOnType=54]="formatOnType",Y[Y.glyphMargin=55]="glyphMargin",Y[Y.gotoLocation=56]="gotoLocation",Y[Y.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",Y[Y.hover=58]="hover",Y[Y.inDiffEditor=59]="inDiffEditor",Y[Y.inlineSuggest=60]="inlineSuggest",Y[Y.letterSpacing=61]="letterSpacing",Y[Y.lightbulb=62]="lightbulb",Y[Y.lineDecorationsWidth=63]="lineDecorationsWidth",Y[Y.lineHeight=64]="lineHeight",Y[Y.lineNumbers=65]="lineNumbers",Y[Y.lineNumbersMinChars=66]="lineNumbersMinChars",Y[Y.linkedEditing=67]="linkedEditing",Y[Y.links=68]="links",Y[Y.matchBrackets=69]="matchBrackets",Y[Y.minimap=70]="minimap",Y[Y.mouseStyle=71]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=73]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=75]="multiCursorModifier",Y[Y.multiCursorPaste=76]="multiCursorPaste",Y[Y.multiCursorLimit=77]="multiCursorLimit",Y[Y.occurrencesHighlight=78]="occurrencesHighlight",Y[Y.overviewRulerBorder=79]="overviewRulerBorder",Y[Y.overviewRulerLanes=80]="overviewRulerLanes",Y[Y.padding=81]="padding",Y[Y.pasteAs=82]="pasteAs",Y[Y.parameterHints=83]="parameterHints",Y[Y.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=86]="quickSuggestions",Y[Y.quickSuggestionsDelay=87]="quickSuggestionsDelay",Y[Y.readOnly=88]="readOnly",Y[Y.renameOnType=89]="renameOnType",Y[Y.renderControlCharacters=90]="renderControlCharacters",Y[Y.renderFinalNewline=91]="renderFinalNewline",Y[Y.renderLineHighlight=92]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=93]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=94]="renderValidationDecorations",Y[Y.renderWhitespace=95]="renderWhitespace",Y[Y.revealHorizontalRightPadding=96]="revealHorizontalRightPadding",Y[Y.roundedSelection=97]="roundedSelection",Y[Y.rulers=98]="rulers",Y[Y.scrollbar=99]="scrollbar",Y[Y.scrollBeyondLastColumn=100]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=101]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=102]="scrollPredominantAxis",Y[Y.selectionClipboard=103]="selectionClipboard",Y[Y.selectionHighlight=104]="selectionHighlight",Y[Y.selectOnLineNumbers=105]="selectOnLineNumbers",Y[Y.showFoldingControls=106]="showFoldingControls",Y[Y.showUnused=107]="showUnused",Y[Y.snippetSuggestions=108]="snippetSuggestions",Y[Y.smartSelect=109]="smartSelect",Y[Y.smoothScrolling=110]="smoothScrolling",Y[Y.stickyScroll=111]="stickyScroll",Y[Y.stickyTabStops=112]="stickyTabStops",Y[Y.stopRenderingLineAfter=113]="stopRenderingLineAfter",Y[Y.suggest=114]="suggest",Y[Y.suggestFontSize=115]="suggestFontSize",Y[Y.suggestLineHeight=116]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=117]="suggestOnTriggerCharacters",Y[Y.suggestSelection=118]="suggestSelection",Y[Y.tabCompletion=119]="tabCompletion",Y[Y.tabIndex=120]="tabIndex",Y[Y.unicodeHighlighting=121]="unicodeHighlighting",Y[Y.unusualLineTerminators=122]="unusualLineTerminators",Y[Y.useShadowDOM=123]="useShadowDOM",Y[Y.useTabStops=124]="useTabStops",Y[Y.wordBreak=125]="wordBreak",Y[Y.wordSeparators=126]="wordSeparators",Y[Y.wordWrap=127]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=128]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=129]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=130]="wordWrapColumn",Y[Y.wordWrapOverride1=131]="wordWrapOverride1",Y[Y.wordWrapOverride2=132]="wordWrapOverride2",Y[Y.wrappingIndent=133]="wrappingIndent",Y[Y.wrappingStrategy=134]="wrappingStrategy",Y[Y.showDeprecated=135]="showDeprecated",Y[Y.inlayHints=136]="inlayHints",Y[Y.editorClassName=137]="editorClassName",Y[Y.pixelRatio=138]="pixelRatio",Y[Y.tabFocusMode=139]="tabFocusMode",Y[Y.layoutInfo=140]="layoutInfo",Y[Y.wrappingInfo=141]="wrappingInfo",Y[Y.defaultColorDecorators=142]="defaultColorDecorators"})(dt||(e.EditorOption=dt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(193,null)})),acceptSuggestionOnEnter:Me(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(194,null),""],markdownDescription:i.localize(195,null)})),accessibilitySupport:Me(new D),accessibilityPageSize:Me(new S(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(196,null),tags:["accessibility"]})),ariaLabel:Me(new n(4,"ariaLabel",i.localize(197,null))),screenReaderAnnounceInlineSuggestion:Me(new l(6,"screenReaderAnnounceInlineSuggestion",!0,{description:i.localize(198,null),tags:["accessibility"]})),autoClosingBrackets:Me(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(199,null),i.localize(200,null),""],description:i.localize(201,null)})),autoClosingDelete:Me(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(202,null),""],description:i.localize(203,null)})),autoClosingOvertype:Me(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(204,null),""],description:i.localize(205,null)})),autoClosingQuotes:Me(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(206,null),i.localize(207,null),""],description:i.localize(208,null)})),autoIndent:Me(new a(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[i.localize(209,null),i.localize(210,null),i.localize(211,null),i.localize(212,null),i.localize(213,null)],description:i.localize(214,null)})),automaticLayout:Me(new l(11,"automaticLayout",!1)),autoSurround:Me(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(215,null),i.localize(216,null),i.localize(217,null),""],description:i.localize(218,null)})),bracketPairColorization:Me(new ce),bracketPairGuides:Me(new pe),stickyTabStops:Me(new l(112,"stickyTabStops",!1,{description:i.localize(219,null)})),codeLens:Me(new l(15,"codeLens",!0,{description:i.localize(220,null)})),codeLensFontFamily:Me(new n(16,"codeLensFontFamily","",{description:i.localize(221,null)})),codeLensFontSize:Me(new S(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(222,null)})),colorDecorators:Me(new l(18,"colorDecorators",!0,{description:i.localize(223,null)})),colorDecoratorsLimit:Me(new S(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(224,null)})),columnSelection:Me(new l(20,"columnSelection",!1,{description:i.localize(225,null)})),comments:Me(new f),contextmenu:Me(new l(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new l(23,"copyWithSyntaxHighlighting",!0,{description:i.localize(226,null)})),cursorBlinking:Me(new a(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:i.localize(227,null)})),cursorSmoothCaretAnimation:Me(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(228,null),i.localize(229,null),i.localize(230,null)],description:i.localize(231,null)})),cursorStyle:Me(new a(26,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:i.localize(232,null)})),cursorSurroundingLines:Me(new S(27,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(233,null)})),cursorSurroundingLinesStyle:Me(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(234,null),i.localize(235,null)],description:i.localize(236,null)})),cursorWidth:Me(new S(29,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(237,null)})),disableLayerHinting:Me(new l(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new l(31,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new l(32,"domReadOnly",!1)),dragAndDrop:Me(new l(33,"dragAndDrop",!0,{description:i.localize(238,null)})),emptySelectionClipboard:Me(new G),dropIntoEditor:Me(new Xe),stickyScroll:Me(new De),experimentalWhitespaceRendering:Me(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(239,null),i.localize(240,null),i.localize(241,null)],description:i.localize(242,null)})),extraEditorClassName:Me(new n(37,"extraEditorClassName","")),fastScrollSensitivity:Me(new v(38,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:i.localize(243,null)})),find:Me(new q),fixedOverflowWidgets:Me(new l(40,"fixedOverflowWidgets",!1)),folding:Me(new l(41,"folding",!0,{description:i.localize(244,null)})),foldingStrategy:Me(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(245,null),i.localize(246,null)],description:i.localize(247,null)})),foldingHighlight:Me(new l(43,"foldingHighlight",!0,{description:i.localize(248,null)})),foldingImportsByDefault:Me(new l(44,"foldingImportsByDefault",!1,{description:i.localize(249,null)})),foldingMaximumRegions:Me(new S(45,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(250,null)})),unfoldOnClickAfterEndOfLine:Me(new l(46,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(251,null)})),fontFamily:Me(new n(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(252,null)})),fontInfo:Me(new V),fontLigatures2:Me(new $),fontSize:Me(new x),fontWeight:Me(new W),fontVariations:Me(new N),formatOnPaste:Me(new l(53,"formatOnPaste",!1,{description:i.localize(253,null)})),formatOnType:Me(new l(54,"formatOnType",!1,{description:i.localize(254,null)})),glyphMargin:Me(new l(55,"glyphMargin",!0,{description:i.localize(255,null)})),gotoLocation:Me(new ee),hideCursorInOverviewRuler:Me(new l(57,"hideCursorInOverviewRuler",!1,{description:i.localize(256,null)})),hover:Me(new Ie),inDiffEditor:Me(new l(59,"inDiffEditor",!1)),letterSpacing:Me(new v(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>v.clamp(Y,-5,20),{description:i.localize(257,null)})),lightbulb:Me(new le),lineDecorationsWidth:Me(new Ee),lineHeight:Me(new P),lineNumbers:Me(new de),lineNumbersMinChars:Me(new S(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new l(67,"linkedEditing",!1,{description:i.localize(258,null)})),links:Me(new l(68,"links",!0,{description:i.localize(259,null)})),matchBrackets:Me(new r(69,"matchBrackets","always",["always","near","never"],{description:i.localize(260,null)})),minimap:Me(new K),mouseStyle:Me(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new v(72,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:i.localize(261,null)})),mouseWheelZoom:Me(new l(73,"mouseWheelZoom",!1,{markdownDescription:i.localize(262,null)})),multiCursorMergeOverlapping:Me(new l(74,"multiCursorMergeOverlapping",!0,{description:i.localize(263,null)})),multiCursorModifier:Me(new a(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[i.localize(264,null),i.localize(265,null)],markdownDescription:i.localize(266,null)})),multiCursorPaste:Me(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(267,null),i.localize(268,null)],markdownDescription:i.localize(269,null)})),multiCursorLimit:Me(new S(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(270,null)})),occurrencesHighlight:Me(new l(78,"occurrencesHighlight",!0,{description:i.localize(271,null)})),overviewRulerBorder:Me(new l(79,"overviewRulerBorder",!0,{description:i.localize(272,null)})),overviewRulerLanes:Me(new S(80,"overviewRulerLanes",3,0,3)),padding:Me(new ye),pasteAs:Me(new Ke),parameterHints:Me(new be),peekWidgetDefaultFocus:Me(new r(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(273,null),i.localize(274,null)],description:i.localize(275,null)})),definitionLinkOpensInPeek:Me(new l(85,"definitionLinkOpensInPeek",!1,{description:i.localize(276,null)})),quickSuggestions:Me(new Ce),quickSuggestionsDelay:Me(new S(87,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(277,null)})),readOnly:Me(new l(88,"readOnly",!1)),renameOnType:Me(new l(89,"renameOnType",!1,{description:i.localize(278,null),markdownDeprecationMessage:i.localize(279,null)})),renderControlCharacters:Me(new l(90,"renderControlCharacters",!0,{description:i.localize(280,null),restricted:!0})),renderFinalNewline:Me(new r(91,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(281,null)})),renderLineHighlight:Me(new r(92,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(282,null)],description:i.localize(283,null)})),renderLineHighlightOnlyWhenFocus:Me(new l(93,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(284,null)})),renderValidationDecorations:Me(new r(94,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new r(95,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(285,null),i.localize(286,null),i.localize(287,null),""],description:i.localize(288,null)})),revealHorizontalRightPadding:Me(new S(96,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new l(97,"roundedSelection",!0,{description:i.localize(289,null)})),rulers:Me(new ne),scrollbar:Me(new z),scrollBeyondLastColumn:Me(new S(100,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(290,null)})),scrollBeyondLastLine:Me(new l(101,"scrollBeyondLastLine",!0,{description:i.localize(291,null)})),scrollPredominantAxis:Me(new l(102,"scrollPredominantAxis",!0,{description:i.localize(292,null)})),selectionClipboard:Me(new l(103,"selectionClipboard",!0,{description:i.localize(293,null),included:C.isLinux})),selectionHighlight:Me(new l(104,"selectionHighlight",!0,{description:i.localize(294,null)})),selectOnLineNumbers:Me(new l(105,"selectOnLineNumbers",!0)),showFoldingControls:Me(new r(106,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(295,null),i.localize(296,null),i.localize(297,null)],description:i.localize(298,null)})),showUnused:Me(new l(107,"showUnused",!0,{description:i.localize(299,null)})),showDeprecated:Me(new l(135,"showDeprecated",!0,{description:i.localize(300,null)})),inlayHints:Me(new Te),snippetSuggestions:Me(new r(108,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null),i.localize(304,null)],description:i.localize(305,null)})),smartSelect:Me(new _e),smoothScrolling:Me(new l(110,"smoothScrolling",!1,{description:i.localize(306,null)})),stopRenderingLineAfter:Me(new S(113,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new Se),inlineSuggest:Me(new j),suggestFontSize:Me(new S(115,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(307,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new S(116,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(308,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new l(117,"suggestOnTriggerCharacters",!0,{description:i.localize(309,null)})),suggestSelection:Me(new r(118,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(310,null),i.localize(311,null),i.localize(312,null)],description:i.localize(313,null)})),tabCompletion:Me(new r(119,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(314,null),i.localize(315,null),i.localize(316,null)],description:i.localize(317,null)})),tabIndex:Me(new S(120,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new H),unusualLineTerminators:Me(new r(122,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(318,null),i.localize(319,null),i.localize(320,null)],description:i.localize(321,null)})),useShadowDOM:Me(new l(123,"useShadowDOM",!0)),useTabStops:Me(new l(124,"useTabStops",!0,{description:i.localize(322,null)})),wordBreak:Me(new r(125,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(323,null),i.localize(324,null)],description:i.localize(325,null)})),wordSeparators:Me(new n(126,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:i.localize(326,null)})),wordWrap:Me(new r(127,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(327,null),i.localize(328,null),i.localize(329,null),i.localize(330,null)],description:i.localize(331,null)})),wordWrapBreakAfterCharacters:Me(new n(128,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new n(129,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new S(130,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(332,null)})),wordWrapOverride1:Me(new r(131,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new r(132,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new B),defaultColorDecorators:Me(new l(142,"defaultColorDecorators",!1,{markdownDescription:i.localize(333,null)})),pixelRatio:Me(new ge),tabFocusMode:Me(new l(139,"tabFocusMode",!1,{markdownDescription:i.localize(334,null)})),layoutInfo:Me(new ue),wrappingInfo:Me(new Ze),wrappingIndent:Me(new He),wrappingStrategy:Me(new X)}}),define(Ae[137],Re([11,12]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([11,12]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([11,12]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([11,12]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([11,12]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([11,12]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([11,12]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[152],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[153],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[154],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[155],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[156],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[157],Re([11,12]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ae[158],Re([11,12]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ae[159],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[160],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[161],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[162],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[163],Re([11,12]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[164],Re([11,12]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[165],Re([11,12]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[166],Re([1,0,10,139]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var y;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(y||(e.TokenType=y={}));function M(...m){switch(m.length){case 1:return(0,C.localize)(0,null,m[0]);case 2:return(0,C.localize)(1,null,m[0],m[1]);case 3:return(0,C.localize)(2,null,m[0],m[1],m[2]);default:return}}const O=(0,C.localize)(3,null),A=(0,C.localize)(4,null);class _{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,i.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(M("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(M("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const b=this._start,c=this._input.substring(this._start,this._current),p={type:19,offset:this._start,lexeme:c};this._errors.push({offset:b,lexeme:c,additionalInfo:R}),this._tokens.push(p)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const b=this._input.substring(this._start,this._current),c=_._keywords.get(b);c?this._addToken(c):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(O);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,b=!1,c=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(A);return}const g=this._input.charCodeAt(R);if(b)b=!1;else if(g===47&&!c){R++;break}else g===91?c=!0:g===92?b=!0:g===93&&(c=!1);R++}for(;R<this._input.length&&_._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const p=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:p,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=_,_._regexFlags=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),_._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ae[167],Re([1,0,25,29,141,270]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function _(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=_;function m(l){if(!_(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=l.match(O);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=m;function R(l){if(!l)return null;const h=l.majorBase,S=l.majorMustEqual,I=l.minorBase;let v=l.minorMustEqual;const n=l.patchBase;let u=l.patchMustEqual;l.hasCaret&&(h===0||(v=!1),u=!1);let r=0;if(l.preRelease){const a=A.exec(l.preRelease);if(a){const[,E,D,f]=a;r=Date.UTC(Number(E),Number(D)-1,Number(f))}}return{majorBase:h,majorMustEqual:S,minorBase:I,minorMustEqual:v,patchBase:n,patchMustEqual:u,isMinimum:l.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function b(l,h,S){let I;typeof l=="string"?I=R(m(l)):I=l;let v;h instanceof Date?v=h.getTime():typeof h=="string"&&(v=new Date(h).getTime());let n;if(typeof S=="string"?n=R(m(S)):n=S,!I||!n)return!1;const u=I.majorBase,r=I.minorBase,a=I.patchBase;let E=n.majorBase,D=n.minorBase,f=n.patchBase;const T=n.notBefore;let w=n.majorMustEqual,o=n.minorMustEqual,s=n.patchMustEqual;return n.isMinimum?u>E?!0:u<E?!1:r>D?!0:r<D||v&&v<T?!1:a>=f:(u===1&&E===0&&(!w||!o||!s)&&(E=1,D=0,f=0,w=!0,o=!1,s=!1),u<E?!1:u>E?!w:r<D?!1:r>D?!o:a<f?!1:a>f?!s:!(v&&v<T))}e.isValidVersion=b;function c(l,h,S,I,v){const n=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return n.push([C.default.Error,y.localize(0,null)]),n;if(typeof I.name!="string")return n.push([C.default.Error,y.localize(1,null,"name")]),n;if(typeof I.version!="string")return n.push([C.default.Error,y.localize(2,null,"version")]),n;if(!I.engines)return n.push([C.default.Error,y.localize(3,null,"engines")]),n;if(typeof I.engines.vscode!="string")return n.push([C.default.Error,y.localize(4,null,"engines.vscode")]),n;if(typeof I.extensionDependencies<"u"&&!t(I.extensionDependencies))return n.push([C.default.Error,y.localize(5,null,"extensionDependencies")]),n;if(typeof I.activationEvents<"u"){if(!t(I.activationEvents))return n.push([C.default.Error,y.localize(6,null,"activationEvents")]),n;if(typeof I.main>"u"&&typeof I.browser>"u")return n.push([C.default.Error,y.localize(7,null,"activationEvents","main","browser")]),n}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&n.push([C.default.Warning,y.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return n.push([C.default.Error,y.localize(9,null,"main")]),n;{const a=(0,i.joinPath)(S,I.main);(0,i.isEqualOrParent)(a,S)||n.push([C.default.Warning,y.localize(10,null,a.path,S.path)])}}if(typeof I.browser<"u"){if(typeof I.browser!="string")return n.push([C.default.Error,y.localize(11,null,"browser")]),n;{const a=(0,i.joinPath)(S,I.browser);(0,i.isEqualOrParent)(a,S)||n.push([C.default.Warning,y.localize(12,null,a.path,S.path)])}}if(!M.valid(I.version))return n.push([C.default.Error,y.localize(13,null)]),n;const u=[];if(!p(l,h,I,v,u))for(const a of u)n.push([C.default.Error,a]);return n}e.validateExtensionManifest=c;function p(l,h,S,I,v){return I||typeof S.main>"u"&&typeof S.browser>"u"?!0:d(l,h,S.engines.vscode,v)}e.isValidExtensionVersion=p;function g(l,h,S){return l==="*"||d(h,S,l)}e.isEngineValid=g;function d(l,h,S,I=[]){const v=R(m(S));if(!v)return I.push(y.localize(14,null,S)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return I.push(y.localize(15,null,S)),!1}else if(!v.majorMustEqual)return I.push(y.localize(16,null,S)),!1;return b(l,h,v)?!0:(I.push(y.localize(17,null,l,S)),!1)}function t(l){if(!Array.isArray(l))return!1;for(let h=0,S=l.length;h<S;h++)if(typeof l[h]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,M=[],O=!1){this.ctor=y,this.staticArguments=M,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=i}),define(Ae[70],Re([1,0,69]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var y;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(y||(e.InstantiationType=y={}));function M(A,_,m){_ instanceof i.SyncDescriptor||(_=new i.SyncDescriptor(_,[],!!m)),C.push([A,_])}e.registerSingleton=M;function O(){return C}e.getSingletonServiceDescriptors=O}),define(Ae[168],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(M,O){this.key=M,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class C{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const O of this._nodes.values())O.outgoing.size===0&&M.push(O);return M}insertEdge(M,O){const A=this.lookupOrInsertNode(M),_=this.lookupOrInsertNode(O);A.outgoing.set(_.key,_),_.incoming.set(A.key,A)}removeNode(M){const O=this._hashFn(M);this._nodes.delete(O);for(const A of this._nodes.values())A.outgoing.delete(O),A.incoming.delete(O)}lookupOrInsertNode(M){const O=this._hashFn(M);let A=this._nodes.get(O);return A||(A=new i(O,M),this._nodes.set(O,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[O,A]of this._nodes)M.push(`${O}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,O]of this._nodes){const A=new Set([M]),_=this._findCycle(O,A);if(_)return _}}_findCycle(M,O){for(const[A,_]of M.outgoing){if(O.has(A))return[...O,A].join(" -> ");O.add(A);const m=this._findCycle(_,O);if(m)return m;O.delete(A)}}}e.Graph=C}),define(Ae[3],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function A(_){return _[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=A})(i||(e._util=i={})),e.IInstantiationService=y("instantiationService");function C(O,A,_){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:O,index:_}):(A[i.DI_DEPENDENCIES]=[{id:O,index:_}],A[i.DI_TARGET]=A)}function y(O){if(i.serviceIds.has(O))return i.serviceIds.get(O);const A=function(_,m,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,_,R)};return A.toString=()=>O,i.serviceIds.set(O,A),A}e.createDecorator=y;function M(O){return O}e.refineServiceDecorator=M}),define(Ae[42],Re([1,0,9,2,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof C.URI)}e.isConfigurationOverrides=M;function O(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=O;var A;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function _(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=_;function m(t,l){const h=Object.create(null);for(const S in t)R(h,S,t[S],l);return h}e.toValuesTree=m;function R(t,l,h,S){const I=l.split("."),v=I.pop();let n=t;for(let u=0;u<I.length;u++){const r=I[u];let a=n[r];switch(typeof a){case"undefined":a=n[r]=Object.create(null);break;case"object":break;default:S(`Ignoring ${l} as ${I.slice(0,u+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[v]=h}catch{S(`Ignoring ${l} as ${I.join(".")} is ${JSON.stringify(n)}`)}else S(`Ignoring ${l} as ${I.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=R;function b(t,l){const h=l.split(".");c(t,h)}e.removeFromValueTree=b;function c(t,l){const h=l.shift();if(l.length===0){delete t[h];return}if(Object.keys(t).indexOf(h)!==-1){const S=t[h];typeof S=="object"&&!Array.isArray(S)&&(c(S,l),Object.keys(S).length===0&&delete t[h])}}function p(t,l,h){function S(n,u){let r=n;for(const a of u){if(typeof r!="object"||r===null)return;r=r[a]}return r}const I=l.split("."),v=S(t,I);return typeof v>"u"?h:v}e.getConfigurationValue=p;function g(t,l,h){Object.keys(l).forEach(S=>{S!=="__proto__"&&(S in t?i.isObject(t[S])&&i.isObject(l[S])?g(t[S],l[S],h):h&&(t[S]=l[S]):t[S]=l[S])})}e.merge=g;function d(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Ae[31],Re([1,0,21,13,166,3,138,10]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",i.isMacintosh),_.set("isLinux",i.isLinux),_.set("isWindows",i.isWindows),_.set("isWeb",i.isWeb),_.set("isMacNative",i.isMacintosh&&!i.isWeb),_.set("isEdge",i.isEdge),_.set("isFirefox",i.isFirefox),_.set("isChrome",i.isChrome),_.set("isSafari",i.isSafari);function m(Ee,P){if(_.get(Ee)!==void 0)throw(0,A.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");_.set(Ee,P)}e.setConstant=m;const R=Object.prototype.hasOwnProperty;var b;(function(Ee){Ee[Ee.False=0]="False",Ee[Ee.True=1]="True",Ee[Ee.Defined=2]="Defined",Ee[Ee.Not=3]="Not",Ee[Ee.Equals=4]="Equals",Ee[Ee.NotEquals=5]="NotEquals",Ee[Ee.And=6]="And",Ee[Ee.Regex=7]="Regex",Ee[Ee.NotRegex=8]="NotRegex",Ee[Ee.Or=9]="Or",Ee[Ee.In=10]="In",Ee[Ee.NotIn=11]="NotIn",Ee[Ee.Greater=12]="Greater",Ee[Ee.GreaterEquals=13]="GreaterEquals",Ee[Ee.Smaller=14]="Smaller",Ee[Ee.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const c={regexParsingWithErrorRecovery:!0},p=(0,O.localize)(0,null),g=(0,O.localize)(1,null),d=(0,O.localize)(2,null),t=(0,O.localize)(3,null),l=(0,O.localize)(4,null),h=(0,O.localize)(5,null),S=(0,O.localize)(6,null),I=(0,O.localize)(7,null);class v{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(P=c){this._config=P,this._scanner=new y.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(P){if(P===""){this._parsingErrors.push({message:p,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(P).scan(),this._current=0,this._parsingErrors=[];try{const K=this._expr();if(!this._isAtEnd()){const he=this._peek(),ye=he.type===17?h:void 0;throw this._parsingErrors.push({message:l,offset:he.offset,lexeme:y.Scanner.getLexeme(he),additionalInfo:ye}),v._parseError}return K}catch(K){if(K!==v._parseError)throw K;return}}_expr(){return this._or()}_or(){const P=[this._and()];for(;this._matchOne(16);){const K=this._and();P.push(K)}return P.length===1?P[0]:n.or(...P)}_and(){const P=[this._term()];for(;this._matchOne(15);){const K=this._term();P.push(K)}return P.length===1?P[0]:n.and(...P)}_term(){if(this._matchOne(2)){const P=this._peek();switch(P.type){case 11:return this._advance(),E.INSTANCE;case 12:return this._advance(),D.INSTANCE;case 0:{this._advance();const K=this._expr();return this._consume(1,t),K?.negate()}case 17:return this._advance(),F.create(P.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",P)}}return this._primary()}_primary(){const P=this._peek();switch(P.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const K=this._expr();return this._consume(1,t),K}case 17:{const K=P.lexeme;if(this._advance(),this._matchOne(9)){const ye=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ye.type!==10)throw this._errExpectedButGot("REGEX",ye);const be=ye.lexeme,ge=be.lastIndexOf("/"),Ce=ge===be.length-1?void 0:this._removeFlagsGY(be.substring(ge+1));let ae;try{ae=new RegExp(be.substring(1,ge),Ce)}catch{throw this._errExpectedButGot("REGEX",ye)}return V.create(K,ae)}switch(ye.type){case 10:case 19:{const be=[ye.lexeme];this._advance();let ge=this._peek(),Ce=0;for(let k=0;k<ye.lexeme.length;k++)ye.lexeme.charCodeAt(k)===40?Ce++:ye.lexeme.charCodeAt(k)===41&&Ce--;for(;!this._isAtEnd()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:Ce++;break;case 1:Ce--;break;case 10:case 18:for(let k=0;k<ge.lexeme.length;k++)ge.lexeme.charCodeAt(k)===40?Ce++:ye.lexeme.charCodeAt(k)===41&&Ce--}if(Ce<0)break;be.push(y.Scanner.getLexeme(ge)),this._advance(),ge=this._peek()}const ae=be.join(""),de=ae.lastIndexOf("/"),Z=de===ae.length-1?void 0:this._removeFlagsGY(ae.substring(de+1));let ne;try{ne=new RegExp(ae.substring(1,de),Z)}catch{throw this._errExpectedButGot("REGEX",ye)}return n.regex(K,ne)}case 18:{const be=ye.lexeme;this._advance();let ge=null;if(!(0,C.isFalsyOrWhitespace)(be)){const Ce=be.indexOf("/"),ae=be.lastIndexOf("/");if(Ce!==ae&&Ce>=0){const de=be.slice(Ce+1,ae),Z=be[ae+1]==="i"?"i":"";try{ge=new RegExp(de,Z)}catch{throw this._errExpectedButGot("REGEX",ye)}}}if(ge===null)throw this._errExpectedButGot("REGEX",ye);return V.create(K,ge)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,d);const ye=this._value();return n.notIn(K,ye)}switch(this._peek().type){case 3:{this._advance();const ye=this._value();if(this._previous().type===18)return n.equals(K,ye);switch(ye){case"true":return n.has(K);case"false":return n.not(K);default:return n.equals(K,ye)}}case 4:{this._advance();const ye=this._value();if(this._previous().type===18)return n.notEquals(K,ye);switch(ye){case"true":return n.not(K);case"false":return n.has(K);default:return n.notEquals(K,ye)}}case 5:return this._advance(),$.create(K,this._value());case 6:return this._advance(),N.create(K,this._value());case 7:return this._advance(),G.create(K,this._value());case 8:return this._advance(),q.create(K,this._value());case 13:return this._advance(),n.in(K,this._value());default:return n.has(K)}}case 20:throw this._parsingErrors.push({message:S,offset:P.offset,lexeme:"",additionalInfo:I}),v._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const P=this._peek();switch(P.type){case 17:case 18:return this._advance(),P.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(P){return P.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(P){return this._check(P)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(P,K){if(this._check(P))return this._advance();throw this._errExpectedButGot(K,this._peek())}_errExpectedButGot(P,K,he){const ye=(0,O.localize)(8,null,P,y.Scanner.getLexeme(K)),be=K.offset,ge=y.Scanner.getLexeme(K);return this._parsingErrors.push({message:ye,offset:be,lexeme:ge,additionalInfo:he}),v._parseError}_check(P){return this._peek().type===P}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=v,v._parseError=new Error;class n{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(P){return f.create(P)}static equals(P,K){return T.create(P,K)}static notEquals(P,K){return s.create(P,K)}static regex(P,K){return V.create(P,K)}static in(P,K){return w.create(P,K)}static notIn(P,K){return o.create(P,K)}static not(P){return F.create(P)}static and(...P){return ee.create(P,null,!0)}static or(...P){return Ie.create(P,null,!0)}static greater(P,K){return G.create(P,K)}static greaterEquals(P,K){return q.create(P,K)}static smaller(P,K){return $.create(P,K)}static smallerEquals(P,K){return N.create(P,K)}static deserialize(P){return P==null?void 0:this._parser.parse(P)}}e.ContextKeyExpr=n,n._parser=new v({regexParsingWithErrorRecovery:!1});function u(Ee){const P=new v({regexParsingWithErrorRecovery:!1});return Ee.map(K=>(P.parse(K),P.lexingErrors.length>0?P.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,O.localize)(9,null,he.additionalInfo):(0,O.localize)(10,null),offset:he.offset,length:he.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}e.validateWhenClauses=u;function r(Ee,P){const K=Ee?Ee.substituteConstants():void 0,he=P?P.substituteConstants():void 0;return!K&&!he?!0:!K||!he?!1:K.equals(he)}e.expressionsAreEqualWithConstantSubstitution=r;function a(Ee,P){return Ee.cmp(P)}class E{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class D{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=D,D.INSTANCE=new D;class f{static create(P,K=null){const he=_.get(P);return typeof he=="boolean"?he?D.INSTANCE:E.INSTANCE:new f(P,K)}constructor(P,K){this.key=P,this.negated=K,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ue(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=_.get(this.key);return typeof P=="boolean"?P?D.INSTANCE:E.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=F.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class T{static create(P,K,he=null){if(typeof K=="boolean")return K?f.create(P,he):F.create(P,he);const ye=_.get(P);return typeof ye=="boolean"?K===(ye?"true":"false")?D.INSTANCE:E.INSTANCE:new T(P,K,he)}constructor(P,K,he){this.key=P,this.value=K,this.negated=he,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:X(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=_.get(this.key);if(typeof P=="boolean"){const K=P?"true":"false";return this.value===K?D.INSTANCE:E.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=T;class w{static create(P,K){return new w(P,K)}constructor(P,K){this.key=P,this.valueKey=K,this.type=10,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:X(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const K=P.getValue(this.valueKey),he=P.getValue(this.key);return Array.isArray(K)?K.includes(he):typeof he=="string"&&typeof K=="object"&&K!==null?R.call(K,he):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=o.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=w;class o{static create(P,K){return new o(P,K)}constructor(P,K){this.key=P,this.valueKey=K,this.type=11,this._negated=w.create(P,K)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=o;class s{static create(P,K,he=null){if(typeof K=="boolean")return K?F.create(P,he):f.create(P,he);const ye=_.get(P);return typeof ye=="boolean"?K===(ye?"true":"false")?E.INSTANCE:D.INSTANCE:new s(P,K,he)}constructor(P,K,he){this.key=P,this.value=K,this.negated=he,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:X(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=_.get(this.key);if(typeof P=="boolean"){const K=P?"true":"false";return this.value===K?E.INSTANCE:D.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=s;class F{static create(P,K=null){const he=_.get(P);return typeof he=="boolean"?he?E.INSTANCE:D.INSTANCE:new F(P,K)}constructor(P,K){this.key=P,this.negated=K,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ue(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=_.get(this.key);return typeof P=="boolean"?P?E.INSTANCE:D.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=F;function B(Ee,P){if(typeof Ee=="string"){const K=parseFloat(Ee);isNaN(K)||(Ee=K)}return typeof Ee=="string"||typeof Ee=="number"?P(Ee):E.INSTANCE}class G{static create(P,K,he=null){return B(K,ye=>new G(P,ye,he))}constructor(P,K,he){this.key=P,this.value=K,this.negated=he,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:X(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=G;class q{static create(P,K,he=null){return B(K,ye=>new q(P,ye,he))}constructor(P,K,he){this.key=P,this.value=K,this.negated=he,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:X(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=q;class ${static create(P,K,he=null){return B(K,ye=>new $(P,ye,he))}constructor(P,K,he){this.key=P,this.value=K,this.negated=he,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:X(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=$;class N{static create(P,K,he=null){return B(K,ye=>new N(P,ye,he))}constructor(P,K,he){this.key=P,this.value=K,this.negated=he,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:X(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=G.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class V{static create(P,K){return new V(P,K)}constructor(P,K){this.key=P,this.regexp=K,this.type=7,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const K=this.regexp?this.regexp.source:"",he=P.regexp?P.regexp.source:"";return K<he?-1:K>he?1:0}equals(P){if(P.type===this.type){const K=this.regexp?this.regexp.source:"",he=P.regexp?P.regexp.source:"";return this.key===P.key&&K===he}return!1}substituteConstants(){return this}evaluate(P){const K=P.getValue(this.key);return this.regexp?this.regexp.test(K):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=x.create(this)),this.negated}}e.ContextKeyRegexExpr=V;class x{static create(P){return new x(P)}constructor(P){this._actual=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(P){return new x(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=x;function W(Ee){let P=null;for(let K=0,he=Ee.length;K<he;K++){const ye=Ee[K].substituteConstants();if(Ee[K]!==ye&&P===null){P=[];for(let be=0;be<K;be++)P[be]=Ee[be]}P!==null&&(P[K]=ye)}return P===null?Ee:P}class ee{static create(P,K,he){return ee._normalizeArr(P,K,he)}constructor(P,K){this.expr=P,this.negated=K,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let K=0,he=this.expr.length;K<he;K++){const ye=a(this.expr[K],P.expr[K]);if(ye!==0)return ye}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let K=0,he=this.expr.length;K<he;K++)if(!this.expr[K].equals(P.expr[K]))return!1;return!0}return!1}substituteConstants(){const P=W(this.expr);return P===this.expr?this:ee.create(P,this.negated,!1)}evaluate(P){for(let K=0,he=this.expr.length;K<he;K++)if(!this.expr[K].evaluate(P))return!1;return!0}static _normalizeArr(P,K,he){const ye=[];let be=!1;for(const ge of P)if(ge){if(ge.type===1){be=!0;continue}if(ge.type===0)return E.INSTANCE;if(ge.type===6){ye.push(...ge.expr);continue}ye.push(ge)}if(ye.length===0&&be)return D.INSTANCE;if(ye.length!==0){if(ye.length===1)return ye[0];ye.sort(a);for(let ge=1;ge<ye.length;ge++)ye[ge-1].equals(ye[ge])&&(ye.splice(ge,1),ge--);if(ye.length===1)return ye[0];for(;ye.length>1;){const ge=ye[ye.length-1];if(ge.type!==9)break;ye.pop();const Ce=ye.pop(),ae=ye.length===0,de=Ie.create(ge.expr.map(Z=>ee.create([Z,Ce],null,he)),null,ae);de&&(ye.push(de),ye.sort(a))}if(ye.length===1)return ye[0];if(he){for(let ge=0;ge<ye.length;ge++)for(let Ce=ge+1;Ce<ye.length;Ce++)if(ye[ge].negate().equals(ye[Ce]))return E.INSTANCE;if(ye.length===1)return ye[0]}return new ee(ye,K)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const K of this.expr)P.push(...K.keys());return P}map(P){return new ee(this.expr.map(K=>K.map(P)),null)}negate(){if(!this.negated){const P=[];for(const K of this.expr)P.push(K.negate());this.negated=Ie.create(P,this,!0)}return this.negated}}e.ContextKeyAndExpr=ee;class Ie{static create(P,K,he){return Ie._normalizeArr(P,K,he)}constructor(P,K){this.expr=P,this.negated=K,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let K=0,he=this.expr.length;K<he;K++){const ye=a(this.expr[K],P.expr[K]);if(ye!==0)return ye}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let K=0,he=this.expr.length;K<he;K++)if(!this.expr[K].equals(P.expr[K]))return!1;return!0}return!1}substituteConstants(){const P=W(this.expr);return P===this.expr?this:Ie.create(P,this.negated,!1)}evaluate(P){for(let K=0,he=this.expr.length;K<he;K++)if(this.expr[K].evaluate(P))return!0;return!1}static _normalizeArr(P,K,he){let ye=[],be=!1;if(P){for(let ge=0,Ce=P.length;ge<Ce;ge++){const ae=P[ge];if(ae){if(ae.type===0){be=!0;continue}if(ae.type===1)return D.INSTANCE;if(ae.type===9){ye=ye.concat(ae.expr);continue}ye.push(ae)}}if(ye.length===0&&be)return E.INSTANCE;ye.sort(a)}if(ye.length!==0){if(ye.length===1)return ye[0];for(let ge=1;ge<ye.length;ge++)ye[ge-1].equals(ye[ge])&&(ye.splice(ge,1),ge--);if(ye.length===1)return ye[0];if(he){for(let ge=0;ge<ye.length;ge++)for(let Ce=ge+1;Ce<ye.length;Ce++)if(ye[ge].negate().equals(ye[Ce]))return D.INSTANCE;if(ye.length===1)return ye[0]}return new Ie(ye,K)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const K of this.expr)P.push(...K.keys());return P}map(P){return new Ie(this.expr.map(K=>K.map(P)),null)}negate(){if(!this.negated){const P=[];for(const K of this.expr)P.push(K.negate());for(;P.length>1;){const K=P.shift(),he=P.shift(),ye=[];for(const be of Te(K))for(const ge of Te(he))ye.push(ee.create([be,ge],null,!1));P.unshift(Ie.create(ye,null,!1))}this.negated=Ie.create(P,this,!0)}return this.negated}}e.ContextKeyOrExpr=Ie;class oe extends f{static all(){return oe._info.values()}constructor(P,K,he){super(P,null),this._defaultValue=K,typeof he=="object"?oe._info.push({...he,key:P}):he!==!0&&oe._info.push({key:P,description:he,type:K!=null?typeof K:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return T.create(this.key,P)}notEqualsTo(P){return s.create(this.key,P)}}e.RawContextKey=oe,oe._info=[],e.IContextKeyService=(0,M.createDecorator)("contextKeyService");function ue(Ee,P){return Ee<P?-1:Ee>P?1:0}function X(Ee,P,K,he){return Ee<K?-1:Ee>K?1:P<he?-1:P>he?1:0}function le(Ee,P){if(Ee.type===0||P.type===1)return!0;if(Ee.type===9)return P.type===9?De(Ee.expr,P.expr):!1;if(P.type===9){for(const K of P.expr)if(le(Ee,K))return!0;return!1}if(Ee.type===6){if(P.type===6)return De(P.expr,Ee.expr);for(const K of Ee.expr)if(le(K,P))return!0;return!1}return Ee.equals(P)}e.implies=le;function De(Ee,P){let K=0,he=0;for(;K<Ee.length&&he<P.length;){const ye=Ee[K].cmp(P[he]);if(ye<0)return!1;ye===0&&K++,he++}return K===Ee.length}function Te(Ee){return Ee.type===9?Ee.expr:[Ee]}}),define(Ae[169],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ae[92],Re([1,0,140,3]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function y(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function M(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function O(h,S){switch(h){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":S==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function A(h,S){return S==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function _(h,S,I){return A(S,I)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===I?!0:m(I).includes(h)}e.isTargetPlatformCompatible=_;function m(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function R(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=R;var b;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var c;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var p;(function(h){h.Install="install",h.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var g;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var t;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class l extends Error{constructor(S,I){super(S),this.code=I,this.name=I}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,i.localize)(1,null),original:"Preferences"}}),define(Ae[43],Re([1,0,48,19,13,9,2,142,3,21,15]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function b(oe){return oe.create===!0}e.isFileOpenForWriteOptions=b;var c;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var p;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var g;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function d(oe){return!!(oe.capabilities&2)}e.hasReadWriteCapability=d;function t(oe){return!!(oe.capabilities&8)}e.hasFileFolderCopyCapability=t;function l(oe){return!!(oe.capabilities&131072)}e.hasFileCloneCapability=l;function h(oe){return!!(oe.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S(oe){return!!(oe.capabilities&16)}e.hasFileReadStreamCapability=S;function I(oe){return d(oe)?!!(oe.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;function v(oe){return d(oe)?!!(oe.capabilities&32768):!1}e.hasFileAtomicWriteCapability=v;function n(oe){return!!(oe.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;var u;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class r extends Error{static create(ue,X){const le=new r(ue.toString(),X);return D(le,X),le}constructor(ue,X){super(ue),this.code=X}}e.FileSystemProviderError=r;function a(oe,ue){return r.create(oe,ue)}e.createFileSystemProviderError=a;function E(oe){return oe||a((0,A.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=E;function D(oe,ue){return oe.name=ue?`${ue} (FileSystemError)`:"FileSystemError",oe}e.markAsFileSystemProviderError=D;function f(oe){if(!oe)return u.Unknown;if(oe instanceof r)return oe.code;const ue=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!ue)return u.Unknown;switch(ue[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=f;function T(oe){if(oe instanceof G)return oe.fileOperationResult;switch(f(oe)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=T;var w;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(w||(e.FileOperation=w={}));class o{constructor(ue,X,le){this.resource=ue,this.operation=X,this.target=le}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=o;var s;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(s||(e.FileChangeType=s={}));class F{constructor(ue,X){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const le=new Map;for(const De of ue){const Te=le.get(De.type);switch(Te?Te.push([De.resource,De]):le.set(De.type,[[De.resource,De]]),De.type){case 1:this.rawAdded.push(De.resource);break;case 0:this.rawUpdated.push(De.resource);break;case 2:this.rawDeleted.push(De.resource);break}}for(const[De,Te]of le)switch(De){case 1:this.added=i.TernarySearchTree.forUris(()=>X),this.added.fill(Te);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>X),this.updated.fill(Te);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>X),this.deleted.fill(Te);break}}contains(ue,...X){return this.doContains(ue,{includeChildren:!1},...X)}affects(ue,...X){return this.doContains(ue,{includeChildren:!0},...X)}doContains(ue,X,...le){if(!ue)return!1;const De=le.length>0;return!!((!De||le.includes(1))&&(this.added?.get(ue)||X.includeChildren&&this.added?.findSuperstr(ue))||(!De||le.includes(0))&&(this.updated?.get(ue)||X.includeChildren&&this.updated?.findSuperstr(ue))||(!De||le.includes(2))&&(this.deleted?.findSubstr(ue)||X.includeChildren&&this.deleted?.findSuperstr(ue)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=F;function B(oe,ue,X){return!oe||!ue||oe===ue||ue.length>oe.length?!1:(ue.charAt(ue.length-1)!==C.sep&&(ue+=C.sep),X?(0,y.startsWithIgnoreCase)(oe,ue):oe.indexOf(ue)===0)}e.isParent=B;class G extends Error{constructor(ue,X,le){super(ue),this.fileOperationResult=X,this.options=le}}e.FileOperationError=G;class q extends G{constructor(ue,X,le,De){super(ue,X,De),this.fileOperationResult=X,this.size=le}}e.TooLargeFileOperationError=q;class $ extends G{constructor(ue,X,le){super(ue,2,le),this.stat=X}}e.NotModifiedSinceFileOperationError=$;var N;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function x(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}e.etag=x;async function W(oe,ue){if(!ue.hasProvider(O.URI.from({scheme:oe.scheme})))return new Promise(X=>{const le=ue.onDidChangeFileSystemProviderRegistrations(De=>{De.scheme===oe.scheme&&De.added&&(le.dispose(),X())})})}e.whenProviderRegistered=W;class ee{static formatSize(ue){return(0,M.isNumber)(ue)||(ue=0),ue<ee.KB?(0,A.localize)(1,null,ue.toFixed(0)):ue<ee.MB?(0,A.localize)(2,null,(ue/ee.KB).toFixed(2)):ue<ee.GB?(0,A.localize)(3,null,(ue/ee.MB).toFixed(2)):ue<ee.TB?(0,A.localize)(4,null,(ue/ee.GB).toFixed(2)):(0,A.localize)(5,null,(ue/ee.TB).toFixed(2))}}e.ByteSize=ee,ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB;function Ie(oe){const ue=typeof oe=="string"||oe?.scheme===R.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===R.Schemas.file?1024*ee.MB:ue?10*ee.MB:m.isWeb?50*ee.MB:1024*ee.MB}e.getLargeFileConfirmationLimit=Ie}),define(Ae[71],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this._entries=new Map;for(const[M,O]of y)this.set(M,O)}set(y,M){const O=this._entries.get(y);return this._entries.set(y,M),O}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=i}),define(Ae[170],Re([1,0,16,10,6,69,168,3,71,171]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class b extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new _.ServiceCollection,l=!1,h,S=R){this._services=t,this._strict=l,this._parent=h,this._enableTracing=S,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=S?h?._globalGraph??new O.Graph(I=>I):void 0}createChild(t){return new c(t,this._strict,this,this._enableTracing)}invokeFunction(t,...l){const h=g.traceInvocation(this._enableTracing,t);let S=!1;try{return t({get:v=>{if(S)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(v,h);if(!n)throw new Error(`[invokeFunction] unknown service '${v}'`);return n}},...l)}finally{S=!0,h.stop()}}createInstance(t,...l){let h,S;return t instanceof M.SyncDescriptor?(h=g.traceCreation(this._enableTracing,t.ctor),S=this._createInstance(t.ctor,t.staticArguments.concat(l),h)):(h=g.traceCreation(this._enableTracing,t),S=this._createInstance(t,l,h)),h.stop(),S}_createInstance(t,l=[],h){const S=A._util.getServiceDependencies(t).sort((n,u)=>n.index-u.index),I=[];for(const n of S){const u=this._getOrCreateServiceInstance(n.id,h);u||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),I.push(u)}const v=S.length>0?S[0].index:l.length;if(l.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${l.length} static arguments`);const n=v-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,v)}return Reflect.construct(t,l.concat(I))}_setServiceInstance(t,l){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,l);else if(this._parent)this._parent._setServiceInstance(t,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const l=this._services.get(t);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):l}_getOrCreateServiceInstance(t,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const h=this._getServiceInstanceOrDescriptor(t);return h instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,h,l.branch(t,!0)):(l.branch(t,!1),h)}_safeCreateAndCacheServiceInstance(t,l,h){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,l,h)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,l,h){const S=new O.Graph(n=>n.id.toString());let I=0;const v=[{id:t,desc:l,_trace:h}];for(;v.length;){const n=v.pop();if(S.lookupOrInsertNode(n),I++>1e3)throw new b(S);for(const u of A._util.getServiceDependencies(n.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(u.id)),r instanceof M.SyncDescriptor){const a={id:u.id,desc:r,_trace:n._trace.branch(u.id,!0)};S.insertEdge(n,a),v.push(a)}}}for(;;){const n=S.roots();if(n.length===0){if(!S.isEmpty())throw new b(S);break}for(const{data:u}of n){if(this._getServiceInstanceOrDescriptor(u.id)instanceof M.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}S.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,l,h=[],S,I){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(t,l,h,S,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,l,h,S,I);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(t,l,h=[],S,I){if(S){const v=new c(void 0,this._strict,this,this._enableTracing);v._globalGraphImplicitDependency=String(t);const n=new Map,u=new i.IdleValue(()=>{const r=v._createInstance(l,h,I);for(const[a,E]of n){const D=r[a];if(typeof D=="function")for(const f of E)D.apply(r,f)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,a){if(!u.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let f=n.get(a);return f||(f=new m.LinkedList,n.set(a,f)),(w,o,s)=>{const F=f.push([w,o,s]);return(0,y.toDisposable)(F)}}if(a in r)return r[a];const E=u.value;let D=E[a];return typeof D!="function"||(D=D.bind(E),r[a]=D),D},set(r,a,E){return u.value[a]=E,!0},getPrototypeOf(r){return l.prototype}})}else return this._createInstance(l,h,I)}_throwIfStrict(t,l){if(l&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=c;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class g{static traceInvocation(t,l){return t?new g(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(t,l){return t?new g(1,l.name):g._None}constructor(t,l){this.type=t,this.name=l,this._start=Date.now(),this._dep=[]}branch(t,l){const h=new g(3,t.toString());return this._dep.push([t,l,h]),h}stop(){const t=Date.now()-this._start;g._totals+=t;let l=!1;function h(I,v){const n=[],u=new Array(I+1).join("	");for(const[r,a,E]of v._dep)if(a&&E){l=!0,n.push(`${u}CREATES -> ${r}`);const D=h(I+1,E);D&&n.push(D)}else n.push(`${u}uses -> ${r}`);return n.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(t>2||l)&&g.all.add(S.join(`
`))}}e.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g._totals=0}),define(Ae[14],Re([1,0,40,5,93,6,28,21,25,9,2,31,3]),function(te,e,i,C,y,M,O,A,_,m,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function p(){return new Date().toISOString()}function g(w){return(0,m.isNumber)(w)}e.isLogLevel=g;var d;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(d||(e.LogLevel=d={})),e.DEFAULT_LOG_LEVEL=d.Info;function t(w,o,s){switch(o){case d.Trace:w.trace(s);break;case d.Debug:w.debug(s);break;case d.Info:w.info(s);break;case d.Warning:w.warn(s);break;case d.Error:w.error(s);break;case d.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=t;function l(w,o=!1){let s="";for(let F=0;F<w.length;F++){let B=w[F];if(B instanceof Error&&(B=(0,i.toErrorMessage)(B,o)),typeof B=="object")try{B=JSON.stringify(B)}catch{}s+=(F>0?" ":"")+B}return s}class h extends M.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(o){return this.level!==d.Off&&this.level<=o}}e.AbstractLogger=h;class S extends h{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||super.checkLogLevel(o)}trace(o,...s){this.checkLogLevel(d.Trace)&&this.log(d.Trace,l([o,...s],!0))}debug(o,...s){this.checkLogLevel(d.Debug)&&this.log(d.Debug,l([o,...s]))}info(o,...s){this.checkLogLevel(d.Info)&&this.log(d.Info,l([o,...s]))}warn(o,...s){this.checkLogLevel(d.Warning)&&this.log(d.Warning,l([o,...s]))}error(o,...s){if(this.checkLogLevel(d.Error))if(o instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=o.stack,this.log(d.Error,l(F))}else this.log(d.Error,l([o,...s]))}flush(){}}e.AbstractMessageLogger=S;class I extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!A.isWindows}trace(o,...s){this.checkLogLevel(d.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,o,...s):console.log(`[main ${p()}]`,o,...s))}debug(o,...s){this.checkLogLevel(d.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,o,...s):console.log(`[main ${p()}]`,o,...s))}info(o,...s){this.checkLogLevel(d.Info)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,o,...s):console.log(`[main ${p()}]`,o,...s))}warn(o,...s){this.checkLogLevel(d.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,o,...s):console.warn(`[main ${p()}]`,o,...s))}error(o,...s){this.checkLogLevel(d.Error)&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,o,...s):console.error(`[main ${p()}]`,o,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class v extends h{constructor(o=e.DEFAULT_LOG_LEVEL,s=!0){super(),this.useColors=s,this.setLevel(o)}trace(o,...s){this.checkLogLevel(d.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",o,...s):console.log(o,...s))}debug(o,...s){this.checkLogLevel(d.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",o,...s):console.log(o,...s))}info(o,...s){this.checkLogLevel(d.Info)&&(this.useColors?console.log("%c INFO","color: #33f",o,...s):console.log(o,...s))}warn(o,...s){this.checkLogLevel(d.Warning)&&(this.useColors?console.log("%c WARN","color: #993",o,...s):console.log(o,...s))}error(o,...s){this.checkLogLevel(d.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",o,...s):console.error(o,...s))}dispose(){}flush(){}}e.ConsoleLogger=v;class n extends h{constructor(o,s=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(s)}trace(o,...s){this.checkLogLevel(d.Trace)&&this.adapter.log(d.Trace,[this.extractMessage(o),...s])}debug(o,...s){this.checkLogLevel(d.Debug)&&this.adapter.log(d.Debug,[this.extractMessage(o),...s])}info(o,...s){this.checkLogLevel(d.Info)&&this.adapter.log(d.Info,[this.extractMessage(o),...s])}warn(o,...s){this.checkLogLevel(d.Warning)&&this.adapter.log(d.Warning,[this.extractMessage(o),...s])}error(o,...s){this.checkLogLevel(d.Error)&&this.adapter.log(d.Error,[this.extractMessage(o),...s])}extractMessage(o){return typeof o=="string"?o:(0,i.toErrorMessage)(o,this.checkLogLevel(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class u extends h{constructor(o){super(),this.loggers=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const s of this.loggers)s.setLevel(o);super.setLevel(o)}trace(o,...s){for(const F of this.loggers)F.trace(o,...s)}debug(o,...s){for(const F of this.loggers)F.debug(o,...s)}info(o,...s){for(const F of this.loggers)F.info(o,...s)}warn(o,...s){for(const F of this.loggers)F.warn(o,...s)}error(o,...s){for(const F of this.loggers)F.error(o,...s)}flush(){for(const o of this.loggers)o.flush()}dispose(){for(const o of this.loggers)o.dispose()}}e.MultiplexLogger=u;class r extends M.Disposable{constructor(o,s,F){if(super(),this.logLevel=o,this.logsHome=s,this._loggers=new O.ResourceMap,this._onDidChangeLoggers=this._register(new C.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,F)for(const B of F)this._loggers.set(B.resource,{logger:void 0,info:B})}getLoggerEntry(o){return(0,m.isString)(o)?[...this._loggers.values()].find(s=>s.info.id===o):this._loggers.get(o)}getLogger(o){return this.getLoggerEntry(o)?.logger}createLogger(o,s){const F=this.toResource(o),B=(0,m.isString)(o)?o:s?.id??(0,y.hash)(F.toString()).toString(16);let G=this._loggers.get(F)?.logger;const q=s?.logLevel==="always"?d.Trace:s?.logLevel;G||(G=this.doCreateLogger(F,q??this.getLogLevel(F)??this.logLevel,{...s,id:B}));const $={logger:G,info:{resource:F,id:B,logLevel:q,name:s?.name,hidden:s?.hidden,extensionId:s?.extensionId,when:s?.when}};return this.registerLogger($.info),this._loggers.set(F,$),G}toResource(o){return(0,m.isString)(o)?(0,_.joinPath)(this.logsHome,`${o}.log`):o}setLogLevel(o,s){if(R.URI.isUri(o)){const F=o,B=s,G=this._loggers.get(F);G&&B!==G.info.logLevel&&(G.info.logLevel=B===this.logLevel?void 0:B,G.logger?.setLevel(B),this._loggers.set(G.info.resource,G),this._onDidChangeLogLevel.fire([F,B]))}else{this.logLevel=o;for(const[F,B]of this._loggers.entries())this._loggers.get(F)?.info.logLevel===void 0&&B.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(o,s){const F=this.getLoggerEntry(o);F&&s!==!F.info.hidden&&(F.info.hidden=!s,this._loggers.set(F.info.resource,F),this._onDidChangeVisibility.fire([F.info.resource,s]))}getLogLevel(o){let s;return o&&(s=this._loggers.get(o)?.info.logLevel),s??this.logLevel}registerLogger(o){const s=this._loggers.get(o.resource);s?s.info.hidden!==o.hidden&&this.setVisibility(o.resource,!o.hidden):(this._loggers.set(o.resource,{info:o,logger:void 0}),this._onDidChangeLoggers.fire({added:[o],removed:[]}))}deregisterLogger(o){const s=this._loggers.get(o);s&&(s.logger&&s.logger.dispose(),this._loggers.delete(o),this._onDidChangeLoggers.fire({added:[],removed:[s.info]}))}*getRegisteredLoggers(){for(const o of this._loggers.values())yield o.info}getRegisteredLogger(o){return this._loggers.get(o)?.info}dispose(){this._loggers.forEach(o=>o.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class a{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(o){}getLevel(){return d.Info}trace(o,...s){}debug(o,...s){}info(o,...s){}warn(o,...s){}error(o,...s){}critical(o,...s){}dispose(){}flush(){}}e.NullLogger=a;class E extends a{}e.NullLogService=E;function D(w){if(w.verbose)return d.Trace;if(typeof w.logLevel=="string"){const o=T(w.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function f(w){switch(w){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=f;function T(w){switch(w){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=T,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",f(d.Info))}),define(Ae[172],Re([1,0,6,14]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class y extends i.Disposable{constructor(O,A=[]){super(),this.logger=new C.MultiplexLogger([O,...A]),this._register(O.onDidChangeLogLevel(_=>this.setLevel(_)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(O){this.logger.setLevel(O)}getLevel(){return this.logger.getLevel()}trace(O,...A){this.logger.trace(O,...A)}debug(O,...A){this.logger.debug(O,...A)}info(O,...A){this.logger.info(O,...A)}warn(O,...A){this.logger.warn(O,...A)}error(O,...A){this.logger.error(O,...A)}flush(){this.logger.flush()}}e.LogService=y}),define(Ae[94],Re([1,0,29,143,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var O;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(O||(e.MarkerSeverity=O={})),function(_){function m(g,d){return d-g}_.compare=m;const R=Object.create(null);R[_.Error]=(0,C.localize)(0,null),R[_.Warning]=(0,C.localize)(1,null),R[_.Info]=(0,C.localize)(2,null);function b(g){return R[g]||""}_.toString=b;function c(g){switch(g){case i.default.Error:return _.Error;case i.default.Warning:return _.Warning;case i.default.Info:return _.Info;case i.default.Ignore:return _.Hint}}_.fromSeverity=c;function p(g){switch(g){case _.Error:return i.default.Error;case _.Warning:return i.default.Warning;case _.Info:return i.default.Info;case _.Hint:return i.default.Ignore}}_.toSeverity=p}(O||(e.MarkerSeverity=O={}));var A;(function(_){const m="";function R(c){return b(c,!0)}_.makeKey=R;function b(c,p){const g=[m];return c.source?g.push(c.source.replace("\xA6","\\\xA6")):g.push(m),c.code?typeof c.code=="string"?g.push(c.code.replace("\xA6","\\\xA6")):g.push(c.code.value.replace("\xA6","\\\xA6")):g.push(m),c.severity!==void 0&&c.severity!==null?g.push(O.toString(c.severity)):g.push(m),c.message&&p?g.push(c.message.replace("\xA6","\\\xA6")):g.push(m),c.startLineNumber!==void 0&&c.startLineNumber!==null?g.push(c.startLineNumber.toString()):g.push(m),c.startColumn!==void 0&&c.startColumn!==null?g.push(c.startColumn.toString()):g.push(m),c.endLineNumber!==void 0&&c.endLineNumber!==null?g.push(c.endLineNumber.toString()):g.push(m),c.endColumn!==void 0&&c.endColumn!==null?g.push(c.endColumn.toString()):g.push(m),g.push(m),g.join("\xA6")}_.makeKeyOptionalMessage=b})(A||(e.IMarkerData=A={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ae[173],Re([1,0,5,29,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,y.createDecorator)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var O;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(O||(e.NeverShowAgainScope=O={}));var A;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(A||(e.NotificationsFilter=A={}));class _{constructor(){this.progress=new m,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(b){}updateMessage(b){}updateActions(b){}close(){}}e.NoOpNotification=_;class m{infinite(){}done(){}total(b){}worked(b){}}e.NoOpProgress=m}),define(Ae[95],Re([1,0,13,2,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function M(m,R){return C.URI.isUri(m)?(0,i.equalsIgnoreCase)(m.scheme,R):(0,i.startsWithIgnoreCase)(m,R+":")}e.matchesScheme=M;function O(m,...R){return R.some(b=>M(m,b))}e.matchesSomeScheme=O;function A(m,R){return m.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=A;function _(m){let R;const b=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return b&&(R={startLineNumber:parseInt(b[1]),startColumn:b[2]?parseInt(b[2]):1,endLineNumber:b[4]?parseInt(b[4]):void 0,endColumn:b[4]?b[5]?parseInt(b[5]):1:void 0},m=m.with({fragment:""})),{selection:R,uri:m}}e.extractSelection=_}),define(Ae[174],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(te,e,i,C){var y=arguments.length,M=y<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,i):C,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,i,C);else for(var A=te.length-1;A>=0;A--)(O=te[A])&&(M=(y<3?O(M):y>3?O(e,i,M):O(e,i))||M);return y>3&&M&&Object.defineProperty(e,i,M),M},We=this&&this.__param||function(te,e){return function(i,C){e(i,C,te)}};define(Ae[175],Re([1,0,16,22,6,3]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var O;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(O||(e.ProgressLocation=O={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(b){this.callback=b}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let _=e.UnmanagedProgress=class extends y.Disposable{constructor(b,c){super(),this.deferred=new i.DeferredPromise,c.withProgress(b,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};e.UnmanagedProgress=_=je([We(1,e.IProgressService)],_);class m extends y.Disposable{constructor(b){super(),this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(b){this.stop();const c=++this.currentOperationId,p=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:p.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ae[30],Re([1,0,49,9]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(O,A){i.ok(C.isString(O)),i.ok(C.isObject(A)),i.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,A)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new y}),define(Ae[72],Re([1,0,5,30]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,m){this.schemasById[y(_)]=m,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new M;C.Registry.add(e.Extensions.JSONContribution,O)}),define(Ae[96],Re([1,0,18,5,9,137,42,72,30]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=_.Registry.as(A.Extensions.JSONContribution);class c{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,u=!0){this.registerConfigurations([n],u)}registerConfigurations(n,u=!0){const r=new Set;this.doRegisterConfigurations(n,u,r),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(n){const u=new Set;this.doDeregisterConfigurations(n,u),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:n,remove:u}){const r=new Set;this.doDeregisterConfigurations(u,r),this.doRegisterConfigurations(n,!1,r),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(n){const u=new Set;this.doRegisterDefaultConfigurations(n,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,u){const r=[];for(const{overrides:a,source:E}of n)for(const D in a)if(u.add(D),e.OVERRIDE_PROPERTY_REGEX.test(D)){const f=this.configurationDefaultsOverrides.get(D),T=f?.valuesSources??new Map;if(E)for(const F of Object.keys(a[D]))T.set(F,E);const w={...f?.value||{},...a[D]};this.configurationDefaultsOverrides.set(D,{source:E,value:w,valuesSources:T});const o=(0,O.getLanguageTagSettingPlainKey)(D),s={type:"object",default:w,description:M.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:y.isString(E)?void 0:E,defaultValueSource:E};r.push(...d(D)),this.configurationProperties[D]=s,this.defaultLanguageConfigurationOverridesNode.properties[D]=s}else{this.configurationDefaultsOverrides.set(D,{value:a[D],source:E});const f=this.configurationProperties[D];f&&(this.updatePropertyDefaultValue(D,f),this.updateSchema(D,f))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(n){const u=new Set;this.doDeregisterDefaultConfigurations(n,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,u){for(const{overrides:r,source:a}of n)for(const E in r){const D=this.configurationDefaultsOverrides.get(E),f=y.isString(a)?a:a?.id,T=y.isString(D?.source)?D?.source:D?.source?.id;if(f===T)if(u.add(E),this.configurationDefaultsOverrides.delete(E),e.OVERRIDE_PROPERTY_REGEX.test(E))delete this.configurationProperties[E],delete this.defaultLanguageConfigurationOverridesNode.properties[E];else{const w=this.configurationProperties[E];w&&(this.updatePropertyDefaultValue(E,w),this.updateSchema(E,w))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let u=!1;const r=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,r),u=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,r),u=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,r),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const u of n)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,u,r){n.forEach(a=>{this.validateAndRegisterProperties(a,u,a.extensionInfo,a.restrictedProperties,void 0,r),this.configurationContributors.push(a),this.registerJSONConfiguration(a)})}doDeregisterConfigurations(n,u){const r=a=>{if(a.properties)for(const E in a.properties){u.add(E);const D=this.configurationProperties[E];D?.policy?.name&&this.policyConfigurations.delete(D.policy.name),delete this.configurationProperties[E],this.removeFromSchema(E,a.properties[E])}a.allOf?.forEach(E=>r(E))};for(const a of n){r(a);const E=this.configurationContributors.indexOf(a);E!==-1&&this.configurationContributors.splice(E,1)}}validateAndRegisterProperties(n,u=!0,r,a,E=3,D){E=y.isUndefinedOrNull(n.scope)?E:n.scope;const f=n.properties;if(f)for(const w in f){const o=f[w];if(u&&S(w,o)){delete f[w];continue}if(o.source=r,o.defaultDefaultValue=f[w].default,this.updatePropertyDefaultValue(w,o),e.OVERRIDE_PROPERTY_REGEX.test(w)?o.scope=void 0:(o.scope=y.isUndefinedOrNull(o.scope)?E:o.scope,o.restricted=y.isUndefinedOrNull(o.restricted)?!!a?.includes(w):o.restricted),f[w].hasOwnProperty("included")&&!f[w].included){this.excludedConfigurationProperties[w]=f[w],delete f[w];continue}else this.configurationProperties[w]=f[w],f[w].policy?.name&&this.policyConfigurations.set(f[w].policy.name,w);!f[w].deprecationMessage&&f[w].markdownDeprecationMessage&&(f[w].deprecationMessage=f[w].markdownDeprecationMessage),D.add(w)}const T=n.allOf;if(T)for(const w of T)this.validateAndRegisterProperties(w,u,r,a,E,D)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const u=r=>{const a=r.properties;if(a)for(const D in a)this.updateSchema(D,a[D]);r.allOf?.forEach(u)};u(n)}updateSchema(n,u){switch(e.allSettings.properties[n]=u,u.scope){case 1:e.applicationSettings.properties[n]=u;break;case 2:e.machineSettings.properties[n]=u;break;case 6:e.machineOverridableSettings.properties[n]=u;break;case 3:e.windowSettings.properties[n]=u;break;case 4:e.resourceSettings.properties[n]=u;break;case 5:e.resourceSettings.properties[n]=u,this.resourceLanguageSettingsSchema.properties[n]=u;break}}removeFromSchema(n,u){switch(delete e.allSettings.properties[n],u.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const u=`[${n}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,r),e.allSettings.properties[u]=r,e.applicationSettings.properties[u]=r,e.machineSettings.properties[u]=r,e.machineOverridableSettings.properties[u]=r,e.windowSettings.properties[u]=r,e.resourceSettings.properties[u]=r}}registerOverridePropertyPatternKey(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,u){const r=this.configurationDefaultsOverrides.get(n);let a=r?.value,E=r?.source;y.isUndefined(a)&&(a=u.defaultDefaultValue,E=void 0),y.isUndefined(a)&&(a=l(u.type)),u.default=a,u.defaultValueSource=E}}const p="\\[([^\\]]+)\\]",g=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(v){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let u=g.exec(v);for(;u?.length;){const r=u[1].trim();r&&n.push(r),u=g.exec(v)}}return(0,i.distinct)(n)}e.overrideIdentifiersFromKey=d;function t(v){return v.reduce((n,u)=>`${n}[${u}]`,"")}e.keyFromOverrideIdentifiers=t;function l(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const h=new c;_.Registry.add(e.Extensions.Configuration,h);function S(v,n){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):h.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):n.policy?.name&&h.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,v,n.policy?.name,h.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.validateProperty=S;function I(){const v=[],n=h.getConfigurationProperties();for(const u of Object.keys(n))v.push([u,n[u].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=I}),define(Ae[176],Re([1,0,18,5,115,6,28,26,9,2,42,96,30]),function(te,e,i,C,y,M,O,A,_,m,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function p(u){return Object.isFrozen(u)?u:A.deepFreeze(u)}class g{constructor(r={},a=[],E=[],D){this._contents=r,this._keys=a,this._overrides=E,this.raw=D,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof g)return a;const E=new d("");return E.parseRaw(a),E.configurationModel});this._rawConfiguration=r.reduce((a,E)=>E===a?E:a.merge(E),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const E=this.rawConfiguration.getValue(r),D=a?this.rawConfiguration.getOverrideValue(r,a):void 0,f=a?this.rawConfiguration.override(a).getValue(r):E;return{value:E,override:D,merged:f}}getOverrideValue(r,a){const E=this.getContentsForOverrideIdentifer(a);return E?r?(0,R.getConfigurationValue)(E,r):E:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const E of this.overrides)E.identifiers.includes(r)&&a.push(...E.keys);return i.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return i.distinct(r)}override(r){let a=this.overrideConfigurations.get(r);return a||(a=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,a)),a}merge(...r){const a=A.deepClone(this.contents),E=A.deepClone(this.overrides),D=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const T of r)if(f.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.mergeContents(a,T.contents);for(const w of T.overrides){const[o]=E.filter(s=>i.equals(s.identifiers,w.identifiers));o?(this.mergeContents(o.contents,w.contents),o.keys.push(...w.keys),o.keys=i.distinct(o.keys)):E.push(A.deepClone(w))}for(const w of T.keys)D.indexOf(w)===-1&&D.push(w)}return new g(a,D,E,f.every(T=>T instanceof g)?void 0:f)}createOverrideConfigurationModel(r){const a=this.getContentsForOverrideIdentifer(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const E={};for(const D of i.distinct([...Object.keys(this.contents),...Object.keys(a)])){let f=this.contents[D];const T=a[D];T&&(typeof f=="object"&&typeof T=="object"?(f=A.deepClone(f),this.mergeContents(f,T)):f=T),E[D]=f}return new g(E,this.keys,this.overrides)}mergeContents(r,a){for(const E of Object.keys(a)){if(E in r&&_.isObject(r[E])&&_.isObject(a[E])){this.mergeContents(r[E],a[E]);continue}r[E]=A.deepClone(a[E])}}getContentsForOverrideIdentifer(r){let a=null,E=null;const D=f=>{f&&(E?this.mergeContents(E,f):E=A.deepClone(f))};for(const f of this.overrides)i.equals(f.identifiers,[r])?a=f.contents:f.identifiers.includes(r)&&D(f.contents);return D(a),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.updateValue(r,a,!0)}setValue(r,a){this.updateValue(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,R.removeFromValueTree)(this.contents,r),b.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(E=>i.equals(E.identifiers,(0,b.overrideIdentifiersFromKey)(r))),1))}updateValue(r,a,E){(0,R.addToValueTree)(this.contents,r,a,D=>console.error(D)),E=E||this.keys.indexOf(r)===-1,E&&this.keys.push(r),b.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,R.toValuesTree)(this.contents[r],D=>console.error(D))})}}e.ConfigurationModel=g;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,a){if(!_.isUndefinedOrNull(r)){const E=this.doParseContent(r);this.parseRaw(E,a)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,a){this._raw=r;const{contents:E,keys:D,overrides:f,restricted:T,hasExcludedProperties:w}=this.doParseRaw(r,a);this._configurationModel=new g(E,D,f,w?[r]:void 0),this._restrictedConfigurations=T||[]}doParseContent(r){let a={},E=null,D=[];const f=[],T=[];function w(s){Array.isArray(D)?D.push(s):E!==null&&(D[E]=s)}const o={onObjectBegin:()=>{const s={};w(s),f.push(D),D=s,E=null},onObjectProperty:s=>{E=s},onObjectEnd:()=>{D=f.pop()},onArrayBegin:()=>{const s=[];w(s),f.push(D),D=s,E=null},onArrayEnd:()=>{D=f.pop()},onLiteralValue:w,onError:(s,F,B)=>{T.push({error:s,offset:F,length:B})}};if(r)try{y.visit(r,o),a=D[0]||{}}catch(s){console.error(`Error while parsing settings file ${this._name}: ${s}`),this._parseErrors=[s]}return a}doParseRaw(r,a){const E=c.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),D=this.filter(r,E,!0,a);r=D.raw;const f=(0,R.toValuesTree)(r,o=>console.error(`Conflict in settings file ${this._name}: ${o}`)),T=Object.keys(r),w=this.toOverrides(r,o=>console.error(`Conflict in settings file ${this._name}: ${o}`));return{contents:f,keys:T,overrides:w,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}filter(r,a,E,D){let f=!1;if(!D?.scopes&&!D?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:f};const T={},w=[];for(const o in r)if(b.OVERRIDE_PROPERTY_REGEX.test(o)&&E){const s=this.filter(r[o],a,!1,D);T[o]=s.raw,f=f||s.hasExcludedProperties,w.push(...s.restricted)}else{const s=a[o],F=s?typeof s.scope<"u"?s.scope:3:void 0;s?.restricted&&w.push(o),(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&s?.restricted)?T[o]=r[o]:f=!0}return{raw:T,restricted:w,hasExcludedProperties:f}}toOverrides(r,a){const E=[];for(const D of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(D)){const f={};for(const T in r[D])f[T]=r[D][T];E.push({identifiers:(0,b.overrideIdentifiersFromKey)(D),keys:Object.keys(f),contents:(0,R.toValuesTree)(f,a)})}return E}}e.ConfigurationModelParser=d;class t extends M.Disposable{constructor(r,a,E,D){super(),this.userSettingsResource=r,this.scopes=a,this.fileService=D,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(E.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&E.isEqual(f.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class l{constructor(r,a,E,D,f,T,w,o,s,F,B,G,q){this.key=r,this.overrides=a,this._value=E,this.overrideIdentifiers=D,this.defaultConfiguration=f,this.policyConfiguration=T,this.applicationConfiguration=w,this.userConfiguration=o,this.localUserConfiguration=s,this.remoteUserConfiguration=F,this.workspaceConfiguration=B,this.folderConfigurationModel=G,this.memoryConfigurationModel=q}get value(){return p(this._value)}inspect(r,a,E){const D=r.inspect(a,E);return{get value(){return p(D.value)},get override(){return p(D.override)},get merged(){return p(D.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(r,a,E,D,f=new g,T=new g,w=new O.ResourceMap,o=new g,s=new O.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=a,this._applicationConfiguration=E,this._localUserConfiguration=D,this._remoteUserConfiguration=f,this._workspaceConfiguration=T,this._folderConfigurations=w,this._memoryConfiguration=o,this._memoryConfigurationByResource=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(r,a,E){return this.getConsolidatedConfigurationModel(r,a,E).getValue(r)}updateValue(r,a,E={}){let D;E.resource?(D=this._memoryConfigurationByResource.get(E.resource),D||(D=new g,this._memoryConfigurationByResource.set(E.resource,D))):D=this._memoryConfiguration,a===void 0?D.removeValue(r):D.setValue(r,a),E.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,a,E){const D=this.getConsolidatedConfigurationModel(r,a,E),f=this.getFolderConfigurationModelForResource(a.resource,E),T=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,w=new Set;for(const o of D.overrides)for(const s of o.identifiers)D.getOverrideValue(r,s)!==void 0&&w.add(s);return new l(r,a,D.getValue(r),w.size?[...w]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this._workspaceConfiguration:void 0,f||void 0,T)}keys(r){const a=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,a){this._folderConfigurations.set(r,a),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const E=[];if(!a){const{added:D,updated:f,removed:T}=v(this._defaultConfiguration,r);a=[...D,...f,...T]}for(const D of a)for(const f of(0,b.overrideIdentifiersFromKey)(D)){const T=this._defaultConfiguration.getKeysForOverrideIdentifier(f),w=r.getKeysForOverrideIdentifier(f),o=[...w.filter(s=>T.indexOf(s)===-1),...T.filter(s=>w.indexOf(s)===-1),...T.filter(s=>!A.equals(this._defaultConfiguration.override(f).getValue(s),r.override(f).getValue(s)))];E.push([f,o])}return this.updateDefaultConfiguration(r),{keys:a,overrides:E}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:E,removed:D}=v(this._policyConfiguration,r),f=[...a,...E,...D];return f.length&&this.updatePolicyConfiguration(r),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:E,removed:D,overrides:f}=v(this.applicationConfiguration,r),T=[...a,...E,...D];return T.length&&this.updateApplicationConfiguration(r),{keys:T,overrides:f}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:E,removed:D,overrides:f}=v(this.localUserConfiguration,r),T=[...a,...E,...D];return T.length&&this.updateLocalUserConfiguration(r),{keys:T,overrides:f}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:E,removed:D,overrides:f}=v(this.remoteUserConfiguration,r),T=[...a,...E,...D];return T.length&&this.updateRemoteUserConfiguration(r),{keys:T,overrides:f}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:E,removed:D,overrides:f}=v(this.workspaceConfiguration,r),T=[...a,...E,...D];return T.length&&this.updateWorkspaceConfiguration(r),{keys:T,overrides:f}}compareAndUpdateFolderConfiguration(r,a){const E=this.folderConfigurations.get(r),{added:D,updated:f,removed:T,overrides:w}=v(E,a),o=[...D,...f,...T];return(o.length||!E)&&this.updateFolderConfiguration(r,a),{keys:o,overrides:w}}compareAndDeleteFolderConfiguration(r){const a=this.folderConfigurations.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:E,updated:D,removed:f,overrides:T}=v(a,void 0);return{keys:[...E,...D,...f],overrides:T}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,a,E){let D=this.getConsolidatedConfigurationModelForResource(a,E);return a.overrideIdentifier&&(D=D.override(a.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(D=D.merge(this._policyConfiguration)),D}getConsolidatedConfigurationModelForResource({resource:r},a){let E=this.getWorkspaceConsolidatedConfiguration();if(a&&r){const D=a.getFolder(r);D&&(E=this.getFolderConsolidatedConfiguration(D.uri)||E);const f=this._memoryConfigurationByResource.get(r);f&&(E=E.merge(f))}return E}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let a=this._foldersConsolidatedConfigurations.get(r);if(!a){const E=this.getWorkspaceConsolidatedConfiguration(),D=this._folderConfigurations.get(r);D?(a=E.merge(D),this._foldersConsolidatedConfigurations.set(r,a)):a=E}return a}getFolderConfigurationModelForResource(r,a){if(a&&r){const E=a.getFolder(r);if(E)return this._folderConfigurations.get(E.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,a)=>{const{contents:E,overrides:D,keys:f}=this._folderConfigurations.get(a);return r.push([a,{contents:E,overrides:D,keys:f}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this._workspaceConfiguration.keys.forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.keys.forEach(E=>r.add(E))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getAllOverrideIdentifiers().forEach(E=>r.add(E))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(E=>a.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(E=>a.add(E)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(E=>a.add(E)),this._folderConfigurations.forEach(E=>E.getKeysForOverrideIdentifier(r).forEach(D=>a.add(D))),[...a.values()]}static parse(r){const a=this.parseConfigurationModel(r.defaults),E=this.parseConfigurationModel(r.policy),D=this.parseConfigurationModel(r.application),f=this.parseConfigurationModel(r.user),T=this.parseConfigurationModel(r.workspace),w=r.folders.reduce((o,s)=>(o.set(m.URI.revive(s[0]),this.parseConfigurationModel(s[1])),o),new O.ResourceMap);return new h(a,E,D,f,new g,T,w,new g,new O.ResourceMap)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides)}}e.Configuration=h;function S(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,a=new Map;for(const D of u)D.keys.forEach(f=>r.add(f)),D.overrides.forEach(([f,T])=>{const w=(0,O.getOrSet)(a,f,new Set);T.forEach(o=>w.add(o))});const E=[];return a.forEach((D,f)=>E.push([f,[...D.values()]])),{keys:[...r.values()],overrides:E}}e.mergeChanges=S;class I{constructor(r,a,E,D){this.change=r,this.previous=a,this.currentConfiguraiton=E,this.currentWorkspace=D,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const f of r.keys)this.affectedKeys.add(f);for(const[,f]of r.overrides)for(const T of f)this.affectedKeys.add(T);this._affectsConfigStr=this._marker;for(const f of this.affectedKeys)this._affectsConfigStr+=f+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,a){const E=this._marker+r,D=this._affectsConfigStr.indexOf(E);if(D<0)return!1;const f=D+E.length;if(f>=this._affectsConfigStr.length)return!1;const T=this._affectsConfigStr.charCodeAt(f);if(T!==this._markerCode1&&T!==this._markerCode2)return!1;if(a){const w=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,a,this.currentWorkspace);return!A.equals(w,o)}return!0}}e.ConfigurationChangeEvent=I;function v(u,r){const{added:a,removed:E,updated:D}=n(r?.rawConfiguration,u?.rawConfiguration),f=[],T=u?.getAllOverrideIdentifiers()||[],w=r?.getAllOverrideIdentifiers()||[];if(r){const o=w.filter(s=>!T.includes(s));for(const s of o)f.push([s,r.getKeysForOverrideIdentifier(s)])}if(u){const o=T.filter(s=>!w.includes(s));for(const s of o)f.push([s,u.getKeysForOverrideIdentifier(s)])}if(r&&u){for(const o of T)if(w.includes(o)){const s=n({contents:u.getOverrideValue(void 0,o)||{},keys:u.getKeysForOverrideIdentifier(o)},{contents:r.getOverrideValue(void 0,o)||{},keys:r.getKeysForOverrideIdentifier(o)});f.push([o,[...s.added,...s.removed,...s.updated]])}}return{added:a,removed:E,updated:D,overrides:f}}function n(u,r){const a=u?r?u.keys.filter(f=>r.keys.indexOf(f)===-1):[...u.keys]:[],E=r?u?r.keys.filter(f=>u.keys.indexOf(f)===-1):[...r.keys]:[],D=[];if(u&&r){for(const f of r.keys)if(u.keys.indexOf(f)!==-1){const T=(0,R.getConfigurationValue)(r.contents,f),w=(0,R.getConfigurationValue)(u.contents,f);A.equals(T,w)||D.push(f)}}return{added:a,removed:E,updated:D}}}),define(Ae[97],Re([1,0,10,3]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var y;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(y||(e.RemoteConnectionType=y={}));class M{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=M;class O{constructor(b,c){this.host=b,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=O;var A;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class _ extends i.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof _&&b._code===A.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof _&&b._code===A.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof _&&b._code===A.NoResolverFound}static isHandled(b){return b instanceof _&&b.isHandled}constructor(b,c=A.Unknown,p){super(b),this._message=b,this._code=c,this._detail=p,this.isHandled=c===A.NotAvailable&&p===!0,Object.setPrototypeOf(this,_.prototype)}}e.RemoteAuthorityResolverError=_;function m(R){const b=R.indexOf("+");return b===-1?R:R.substring(0,b)}e.getRemoteAuthorityPrefix=m}),define(Ae[50],Re([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(m){return m.scheme===i.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=C;function y(m){if(!m)return;const R=m.indexOf("+");return R<0?m:m.substr(0,R)}e.getRemoteName=y;function M(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=M;function O(m){const{host:R,port:b}=_(m);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:b}}e.parseAuthorityWithPort=O;function A(m,R){let{host:b,port:c}=_(m);return typeof c>"u"&&(c=R),{host:b,port:c}}e.parseAuthorityWithOptionalPort=A;function _(m){const R=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const b=m.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const c=m.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:m,port:void 0}}}),define(Ae[23],Re([1,0,13,3,50]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(O||(e.ExtensionType=O={}));var A;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.LINUX_PPC64LE="linux-ppc64le",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class _{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,l){if(typeof t>"u"||t===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof t=="string"||typeof l=="string"){const h=typeof t=="string"?t:t.value,S=typeof l=="string"?l:l.value;return i.equalsIgnoreCase(h,S)}return t._lower===l._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=_;class m{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const l of t)this.add(l)}add(t){this._set.add(_.toKey(t))}delete(t){return this._set.delete(_.toKey(t))}has(t){return this._set.has(_.toKey(t))}}e.ExtensionIdentifierSet=m;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(_.toKey(t))}get(t){return this._map.get(_.toKey(t))}has(t){return this._map.has(_.toKey(t))}set(t,l){this._map.set(_.toKey(t),l)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function b(d){return c(d)}e.isApplicationScopedExtension=b;function c(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=c;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function g(d,t){if(t){const l=`onResolveRemoteAuthority:${(0,y.getRemoteName)(t)}`;return!!d.activationEvents?.includes(l)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,10,23]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class y{constructor(){this._generators=new Map,this._cache=new WeakMap}register(O,A){this._generators.set(O,A)}readActivationEvents(O){return this._cache.has(O)||this._cache.set(O,this._readActivationEvents(O)),this._cache.get(O)}createActivationEventsMap(O){const A=Object.create(null);for(const _ of O){const m=this.readActivationEvents(_);m.length>0&&(A[C.ExtensionIdentifier.toKey(_.identifier)]=m)}return A}_readActivationEvents(O){if(typeof O.main>"u"&&typeof O.browser>"u")return[];const A=Array.isArray(O.activationEvents)?O.activationEvents.slice(0):[];if(!O.contributes)return A;for(const _ in O.contributes){const m=this._generators.get(_);if(!m)continue;const R=O.contributes[_],b=Array.isArray(R)?R:[R];try{m(b,A)}catch(c){(0,i.onUnexpectedError)(c)}}return A}}e.ImplicitActivationEventsImpl=y,e.ImplicitActivationEvents=new y}),define(Ae[177],Re([1,0,21,51,36]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(_){if(i.platform===2&&/^penguin(\.|$)/i.test(_))return"chromebook"}function O(_,m,R,b,c,p,g,d){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,y.generateUuid)()+Date.now(),t.commitHash=b,t.version=c,t["common.platformVersion"]=(_||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,i.PlatformToString)(i.platform),t["common.nodePlatform"]=C.platform,t["common.nodeArch"]=R,t["common.product"]=d||"desktop",g&&(t["common.msftInternal"]=g);let l=0;const h=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),i.isLinuxSnap&&(t["common.snap"]="true");const S=M(m);return S&&(t["common.platformDetail"]=S),t}e.resolveCommonProperties=O;function A(_){const m=C.env.USERDNSDOMAIN;if(!m)return!1;const R=m.toLowerCase();return _.some(b=>R===b)}e.verifyMicrosoftInternalDomain=A}),define(Ae[178],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var y;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(y||(e.TelemetryConfiguration=y={}))}),define(Ae[52],Re([1,0,26,9,5,42,50,177,178]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(E){this.value=E,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class b{async publicLog(E,D,f){}async publicLogError(E,D,f){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,E){return y.Event.debounce(E.onDidChangeConfiguration,(f,T)=>{const w=f?new Set([...f.affectedKeys,...T.affectedKeys]):T.affectedKeys;return{...T,affectedKeys:w}},1e3,!0)(f=>{f.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(f.source),configurationKeys:Array.from(f.affectedKeys)})})}e.configurationTelemetry=c;function p(a,E){return!E.isBuilt&&!E.disableTelemetry?!0:!(E.disableTelemetry||!a.enableTelemetry||E.extensionTestsLocationURI)}e.supportsTelemetry=p;function g(a,E){return!(E.isBuilt||E.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=g;function d(a){const E=a.getValue(_.TELEMETRY_SETTING_ID),D=a.getValue(_.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||D===!1)return 0;switch(E??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function t(a){const E={},D={},f={};S(a,f);for(let T in f){T=T.length>150?T.substr(T.length-149):T;const w=f[T];typeof w=="number"?D[T]=w:typeof w=="boolean"?D[T]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${T} has been trimmed to 8192, the original length is ${w.length}`),E[T]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(E[T]=w)}return{properties:E,measurements:D}}e.validateTelemetryData=t;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(a){if(!a)return"none";const E=(0,O.getRemoteName)(a);return l.has(E)?E:"other"}e.cleanRemoteAuthority=h;function S(a,E,D=0,f){if(a)for(const T of Object.getOwnPropertyNames(a)){const w=a[T],o=f?f+T:T;Array.isArray(w)?E[o]=(0,i.safeStringify)(w):w instanceof Date?E[o]=w.toISOString():(0,C.isObject)(w)?D<2?S(w,E,D+1,o+"."):E[o]=(0,i.safeStringify)(w):E[o]=w}}function I(a,E){const D=a.msftInternalDomains||[],f=E.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(D)||f}e.isInternalTelemetry=I;function v(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=v;function n(a,E){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let D=a;const f=[];for(const s of E)for(;;){const F=s.exec(a);if(!F)break;f.push([F.index,s.lastIndex])}const T=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(D="";;){const s=w.exec(a);if(!s)break;const F=f.some(([B,G])=>s.index<G&&B<w.lastIndex);!T.test(s[0])&&!F&&(D+=a.substring(o,s.index)+"<REDACTED: user-file-path>",o=w.lastIndex)}return o<a.length&&(D+=a.substr(o)),D}function u(a){if(!a)return a;const E=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const D of E)if(D.regex.test(a))return`<REDACTED: ${D.label}>`;return a}function r(a,E){return(0,i.cloneAndChange)(a,D=>{if(D instanceof m||Object.hasOwnProperty.call(D,"isTrustedTelemetryValue"))return D.value;if(typeof D=="string"){let f=D.replaceAll("%20"," ");f=n(f,E);for(const T of E)f=f.replace(T,"");return f=u(f),f}})}e.cleanData=r}),define(Ae[179],Re([1,0,13,92,23,21,2,10,51,52]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,i.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=R;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(a){const E=a.manifest?a.manifest.version:a.version,D=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new c(a.identifier,E,D)}static parse(a){const E=b.exec(a);return E&&E[1]&&E[2]?new c({id:E[1]},E[2],E[4]||void 0):null}constructor(a,E,D="undefined"){this.version=E,this.targetPlatform=D,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof c?R(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=c;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const a=p.exec(r);return a&&a[1]?[t(a[1]),a[2]]:[t(r),void 0]}e.getIdAndVersion=g;function d(r,a){return`${r}.${a}`}e.getExtensionId=d;function t(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=t;function l(r,a){return t(d(r??y.UNDEFINED_PUBLISHER,a))}e.getGalleryExtensionId=l;function h(r,a){const E=[],D=f=>{for(const T of E)if(T.some(w=>R(a(w),a(f))))return T;return null};for(const f of r){const T=D(f);T?T.push(f):E.push([f])}return E}e.groupByExtension=h;function S(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function I(r){return{id:new m.TelemetryTrustedValue(r.identifier.id),name:new m.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function v(r,a){const E=[],D=a.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const f=D.shift();if(f&&E.every(T=>!R(T.identifier,{id:f}))){const T=r.filter(w=>R(w.identifier,{id:f}));T.length===1&&(E.push(T[0]),D.push(...T[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=v;async function n(r,a){if(!M.isLinux)return!1;let E;try{E=(await r.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await r.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){a.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(f))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,a){const E=await n(r,a),D=(0,C.getTargetPlatform)(E?"alpine":M.platform,_.arch);return a.debug("ComputeTargetPlatform:",D),D}e.computeTargetPlatform=u}),define(Ae[180],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function i(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=i;function C(_){return _?[..._.entries()]:[]}e.serializeEnvironmentDescriptionMap=C;function y(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=y;function M(_){return new Map(_??[])}e.deserializeEnvironmentDescriptionMap=M;function O(_){return Array.from(_.entries()).map(m=>[m[0],i(m[1].map),C(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=O;function A(_){return new Map(_.map(m=>[m[0],{map:y(m[1]),descriptionMap:M(m[2])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Ae[181],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,M,O=5){const A=M(_=>{const m=typeof _=="string"?_:_.data;let R=this._terminalBufferMap.get(y);if(R){R.data.push(m);return}const b=setTimeout(()=>this.flushBuffer(y),O);R={data:[m],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(y),A.dispose()}},this._terminalBufferMap.set(y,R)});return A}stopBuffering(y){this._terminalBufferMap.get(y)?.dispose()}flushBuffer(y){const M=this._terminalBufferMap.get(y);M&&(this._terminalBufferMap.delete(y),this._callback(y,M.data.join("")))}}e.TerminalDataBufferer=i}),define(Ae[182],Re([1,0,16,87,39,5,9,2,144,72,30]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var b;(function(I){function v(n,u){let r=n.defaults;for(;y.ThemeIcon.isThemeIcon(r);){const a=g.getIcon(r.id);if(!a)return;r=a.defaults}return r}I.getDefinition=v})(b||(e.IconContribution=b={}));var c;(function(I){function v(u){return{weight:u.weight,style:u.style,src:u.src.map(r=>({format:r.format,location:r.location.toString()}))}}I.toJSONObject=v;function n(u){const r=a=>(0,O.isString)(a)?a:void 0;if(u&&Array.isArray(u.src)&&u.src.every(a=>(0,O.isString)(a.format)&&(0,O.isString)(a.location)))return{weight:r(u.weight),style:r(u.style),src:u.src.map(a=>({format:a.format,location:A.URI.parse(a.location)}))}}I.fromJSONObject=n})(c||(e.IconFontDefinition=c={}));class p{constructor(){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,n,u,r){const a=this.iconsById[v];if(a){if(u&&!a.description){a.description=u,this.iconSchema.properties[v].markdownDescription=`${u} $(${v})`;const f=this.iconReferenceSchema.enum.indexOf(v);f!==-1&&(this.iconReferenceSchema.enumDescriptions[f]=u),this._onDidChange.fire()}return a}const E={id:v,description:u,defaults:n,deprecationMessage:r};this.iconsById[v]=E;const D={$ref:"#/definitions/icons"};return r&&(D.deprecationMessage=r),u&&(D.markdownDescription=`${u}: $(${v})`),this.iconSchema.properties[v]=D,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const n=this.iconReferenceSchema.enum.indexOf(v);n!==-1&&(this.iconReferenceSchema.enum.splice(n,1),this.iconReferenceSchema.enumDescriptions.splice(n,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,n){const u=this.iconFontsById[v];return u||(this.iconFontsById[v]=n,this._onDidChange.fire(),n)}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(a,E)=>a.id.localeCompare(E.id),n=a=>{for(;y.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of r.filter(E=>!!E.description).sort(v))u.push(`|<i class="${n(a)}"></i>|${a.id}|${y.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const a of r.filter(E=>!y.ThemeIcon.isThemeIcon(E.defaults)).sort(v))u.push(`|<i class="${n(a)}"></i>|${a.id}|`);return u.join(`
`)}}const g=new p;R.Registry.add(e.Extensions.IconContribution,g);function d(I,v,n,u){return g.registerIcon(I,v,n,u)}e.registerIcon=d;function t(){return g}e.getIconRegistry=t;function l(){const I=(0,C.getCodiconFontCharacters)();for(const v in I){const n="\\"+I[v].toString(16);g.registerIcon(v,{fontCharacter:n})}}l(),e.iconsSchemaId="vscode://schemas/icons";const h=R.Registry.as(m.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,g.getIconSchema());const S=new i.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{S.isScheduled()||S.schedule()}),e.widgetClose=d("widget-close",C.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=d("goto-previous-location",C.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=d("goto-next-location",C.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=y.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=y.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(Ae[183],Re([1,0,5,42,3,14]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var O;(function(d){d.Http="http",d.Https="https"})(O||(e.TunnelProtocol=O={}));var A;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(A||(e.TunnelPrivacyId=A={}));var _;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(_||(e.ProvidedOnAutoForward=_={}));function m(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=b;function c(d,t,l,h){if(l===1)return!1;if(l===2&&b(t)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(S?.length===4&&parseInt(S[1])>=18)return!1}return d<1024}e.isPortPrivileged=c;class p{constructor(t,l,h){this.remoteAddress=t,this.localAddress=l,this._dispose=h,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=p;let g=e.AbstractTunnelService=class{constructor(t,l){this.logService=t,this.configurationService=l,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],l=Array.from(this._tunnels.values());for(const h of l){const S=Array.from(h.values());for(const I of S){const v=await I.value;v&&t.push(v)}}return t}async dispose(){for(const t of this._tunnels.values()){for(const{value:l}of t.values())await l.then(h=>h?.dispose());t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,l,h,S,I){this.addTunnelToMap(t,l,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:l,localAddress:h,privacy:S,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,l){(b(t)||R(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const h=this.getTunnelFromMap(t,l);if(h)return++h.refcount,h.value}openTunnel(t,l,h,S,I,v=!1,n,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${h} on local port ${I}.`),!t)return;if(l||(l="localhost"),S||(S=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(h)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(t,l,h,S,I,v,n,u);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(l,h);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.makeTunnel(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==h)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&a.privacy!==n&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(E),E}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const l=this._tunnels.get(t.tunnelRemoteHost);if(l){const h=l.get(t.tunnelRemotePort);h&&(h.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,h))}}}}async tryDisposeTunnel(t,l,h){if(h.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${l}.`);const S=h.value.then(async I=>{I&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(l),S}}async closeTunnel(t,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${l} `);const h=this._tunnels.get(t);if(h&&h.has(l)){const S=h.get(l);S.refcount=0,await this.tryDisposeTunnel(t,l,S)}}addTunnelToMap(t,l,h){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(l,{refcount:1,value:h})}async removeEmptyTunnelFromMap(t,l){const h=this._tunnels.get(t);h&&(await h.get(l)||h.delete(l),h.size===0&&this._tunnels.delete(t))}getTunnelFromMap(t,l){const h=[t];R(t)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):b(t)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const S=h.map(I=>this._tunnels.get(I));for(const I of S){const v=I?.get(l);if(v)return v}}canTunnel(t){return!!m(t)}createWithProvider(t,l,h,S,I,v,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${h} on local port ${S}.`);const u=h;this._factoryInProgress.add(u);const r=S===void 0?h:S,a={elevationRequired:I?this.isPortPrivileged(r):!1},E={remoteAddress:{host:l,port:h},localAddressPort:S,privacy:v,public:v?v!==A.Private:void 0,protocol:n},D=t.forwardPort(E,a);return D?(this.addTunnelToMap(l,h,D),D.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),D}};e.AbstractTunnelService=g=je([We(0,M.ILogService),We(1,C.IConfigurationService)],g)}),define(Ae[184],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var C;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(C||(e.EditSessionIdentityMatch=C={}))}),define(Ae[185],Re([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(_){return _.scheme!==i.Schemas.file&&_.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=C;function y(_){if(_.folders.length)return _.folders.every(m=>C(m.uri))?_.folders[0].uri:void 0;if(_.configuration&&C(_.configuration))return _.configuration}e.getVirtualWorkspaceLocation=y;function M(_){return y(_)?.scheme}e.getVirtualWorkspaceScheme=M;function O(_){return y(_)?.authority}e.getVirtualWorkspaceAuthority=O;function A(_){return y(_)!==void 0}e.isVirtualWorkspace=A}),define(Ae[53],Re([1,0,145,19,48,25,2,3,15]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function m(a){const E=a;return typeof E?.id=="string"&&O.URI.isUri(E.uri)}e.isSingleFolderWorkspaceIdentifier=m;function R(a){return typeof a?.id=="string"&&!m(a)&&!c(a)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(a,E){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,C.basename)(a)}:E?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const D=a;return D.configuration?{id:D.id,configPath:D.configuration}:D.folders.length===1?{id:D.id,uri:D.folders[0].uri}:{id:D.id}}e.toWorkspaceIdentifier=b;function c(a){const E=a;return typeof E?.id=="string"&&O.URI.isUri(E.configPath)}e.isWorkspaceIdentifier=c;function p(a){const E=a;if(E?.uri)return{id:E.id,uri:O.URI.revive(E.uri)};const D=a;if(D?.configPath)return{id:D.id,configPath:O.URI.revive(D.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=p;var g;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function d(a){const E=a;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=d;function t(a){const E=a;return!!(E&&typeof E=="object"&&O.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=t;class l{constructor(E,D,f,T,w){this._id=E,this._transient=f,this._configuration=T,this._ignorePathCasing=w,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=D}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class h{constructor(E,D){this.raw=D,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,M.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function S(a){return new h({uri:a,index:0,name:(0,M.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(a,E){return M.extUriBiasedIgnorePathCase.isEqualOrParent(a,E.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function v(a){let E;return O.URI.isUri(a)?E=a:E=a.configuration,E?.scheme===_.Schemas.tmp}e.isTemporaryWorkspace=v,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(a){return a.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function u(a,E){return!I(a,E)&&!v(a)}e.isSavedWorkspace=u;function r(a){return(typeof a=="string"?(0,C.extname)(a):(0,M.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ae[54],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const M=this._idPool++;return this._data.set(M,y),this.logDebugInfo(),M}get(y,M){return this._data.has(y)?this._data.get(y)[M]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){i.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=i,i.enableDebugLogging=!1}),define(Ae[38],Re([1,0,15,25,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(i.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(A=>{const _=this._providerInfo.get(A.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(A,_){_===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,_)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ae[186],Re([1,0,150,14,172,27]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let O=e.ExtHostLogService=class extends y.LogService{constructor(_,m,R){const b=R.remote.isRemote?"remoteexthost":_?"workerexthost":"exthost",c=R.remote.isRemote?(0,i.localize)(0,null):_?(0,i.localize)(1,null):(0,i.localize)(2,null);super(m.createLogger(b,{name:c}))}};e.ExtHostLogService=O=je([We(1,C.ILoggerService),We(2,M.IExtHostInitDataService)],O)}),define(Ae[187],Re([1,0,16]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(O,A,_){this._deferredPromises=new Map,this._id=O,this._shared=A,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(m=>(this._value=m,this)),this._storageListener=this._storage.onDidChangeStorage(m=>{m.shared===this._shared&&m.key===this._id&&(this._value=m.value)}),this._scheduler=new i.RunOnceScheduler(()=>{const m=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of m.values())R.complete()}catch(R){for(const b of m.values())b.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,O])=>O!==void 0).map(([O])=>O)}get whenReady(){return this._init}get(O,A){let _=this._value[O];return typeof _>"u"&&(_=A),_}update(O,A){this._value[O]=A;const _=this._deferredPromises.get(O);if(_!==void 0)return _.p;const m=new i.DeferredPromise;return this._deferredPromises.set(O,m),this._scheduler.isScheduled()||this._scheduler.schedule(),m.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class y extends C{setKeysForSync(O){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},O)}constructor(O,A){super(O.identifier.value,!0,A),this._extension=O}}e.ExtensionGlobalMemento=y}),define(Ae[188],Re([1,0,5,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(O){this._notebooksAndEditors=O,this._onDidSaveNotebookDocument=new i.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new i.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(O,A,_,m){const b=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(O)).acceptModelChanged(A.value,_,m);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(O,A){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(O)).acceptDirty(A)}$acceptModelSaved(O){const A=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(O));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ae[17],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=C});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[189],Re([1,0,23,5]),function(te,e,i,C){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,_){y.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=i.ExtensionIdentifier.toKey(A.identifier),Qe(this,y,_,"f"),Oe(this,y,"f").onDidChangePassword(m=>{m.extensionId===this._id&&this._onDidChange.fire({key:m.key})})}get(A){return Oe(this,y,"f").get(this._id,A)}store(A,_){return Oe(this,y,"f").store(this._id,A,_)}delete(A){return Oe(this,y,"f").delete(this._id,A)}}e.ExtensionSecrets=M,y=new WeakMap}),define(Ae[73],Re([1,0,3,183,5,17]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var O;(function(_){function m(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:b.protocol}}_.fromApiTunnel=m;function R(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==C.TunnelPrivacyId.ConstantPrivate&&b.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}_.fromServiceTunnel=R})(O||(e.TunnelDtoConverter=O={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let A=e.ExtHostTunnelService=class{constructor(m){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(m){return m}async openTunnel(m,R){}async getTunnels(){return[]}async setTunnelFactory(m){return{dispose:()=>{}}}registerPortsAttributesProvider(m,R){return{dispose:()=>{}}}async $providePortAttributes(m,R,b,c,p){return[]}async $forwardPort(m,R){}async $closeTunnel(m){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=A=je([We(0,M.IExtHostRpcService)],A)}),define(Ae[55],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=O=>O,this.transformOutgoing=O=>O,this.transformOutgoingURI=O=>O,this.transformOutgoingScheme=O=>O)}}e.URITransformerService=C}),define(Ae[190],Re([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(_){let m=this.buffers.indexOf(_);return m<0&&(m=this.buffers.length,this.buffers.push(_)),m}}function y(A,_){if(_.serializeBuffersForPostMessage){const m=new C,b=JSON.stringify(A,(p,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(g)};if(ArrayBuffer.isView(g)){const d=M(g);if(d)return{$$vscode_array_buffer_reference$$:!0,index:m.add(g.buffer),view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),c=m.buffers.map(p=>{const g=new Uint8Array(p);return i.VSBuffer.wrap(g)});return{message:b,buffers:c}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=y;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function O(A,_){const m=_.map(c=>{const p=new ArrayBuffer(c.byteLength);return new Uint8Array(p).set(c.buffer),p}),R=_.length?(c,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const g=p,{index:d}=g,t=m[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(A,R),arrayBuffers:m}}e.deserializeWebviewMessage=O}),define(Ae[99],Re([1,0,157,9,2,6,3,30,43,15,40,129,29]),function(te,e,i,C,y,M,O,A,_,m,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var g;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function d(X){const le=X;return!!le&&typeof le.getSelection=="function"&&!!le.onDidChangeSelection}e.isEditorPaneWithSelection=d;function t(X,le,De){for(const Te of De.visibleEditorPanes)if(Te.group.id===le&&X.matches(Te.input))return Te.getViewState()}e.findViewStateForEditor=t;function l(X){if(D(X))return!1;const le=X;return y.URI.isUri(le?.resource)}e.isResourceEditorInput=l;function h(X){if(D(X))return!1;const le=X;return le?.original!==void 0&&le.modified!==void 0}e.isResourceDiffEditorInput=h;function S(X){if(D(X)||h(X))return!1;const le=X;return le?.primary!==void 0&&le.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function I(X){if(D(X))return!1;const le=X;return le?le.resource===void 0||le.resource.scheme===m.Schemas.untitled||le.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=I;function v(X){if(D(X))return!1;const le=X;return y.URI.isUri(le?.base?.resource)&&y.URI.isUri(le?.input1?.resource)&&y.URI.isUri(le?.input2?.resource)&&y.URI.isUri(le?.result?.resource)}e.isResourceMergeEditorInput=v;var n;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var u;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(le,De){let Te=this.mapIdToSaveSource.get(le);return Te||(Te={source:le,label:De},this.mapIdToSaveSource.set(le,Te)),Te.source}getSourceLabel(le){return this.mapIdToSaveSource.get(le)?.label??le}}e.SaveSourceRegistry=new r;var a;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(a||(e.EditorInputCapabilities=a={}));class E extends M.Disposable{}e.AbstractEditorInput=E;function D(X){return X instanceof E}e.isEditorInput=D;function f(X){const le=X;return y.URI.isUri(le?.preferredResource)}function T(X){const le=X;return D(le?.primary)&&D(le?.secondary)}e.isSideBySideEditorInput=T;function w(X){const le=X;return D(le?.modified)&&D(le?.original)}e.isDiffEditorInput=w;function o(X,le,De,Te,Ee){return ue(Te,[(0,b.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const P={...De,limits:{size:Number.MAX_VALUE}};X.openEditor(le,P)}}),(0,b.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.createTooLargeFileError=o;function s(X){return D(X?.editor)}e.isEditorInputWithOptions=s;function F(X){const le=X;return s(X)&&le?.group!==void 0}e.isEditorInputWithOptionsAndGroup=F;function B(X){const le=X;return typeof le?.groupId=="number"&&D(le.editor)}e.isEditorIdentifier=B;var G;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var q;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var $;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})($||(e.SideBySideEditor=$={}));class N{getOriginalUri(le,De){if(!le)return;if(v(le))return e.EditorResourceAccessor.getOriginalUri(le.result,De);if(De?.supportSideBySide){const{primary:Ee,secondary:P}=this.getSideEditors(le);if(Ee&&P){if(De?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:De.filterByScheme}),secondary:this.getOriginalUri(P,{filterByScheme:De.filterByScheme})};if(De?.supportSideBySide===$.ANY)return this.getOriginalUri(Ee,{filterByScheme:De.filterByScheme})??this.getOriginalUri(P,{filterByScheme:De.filterByScheme});le=De.supportSideBySide===$.PRIMARY?Ee:P}}if(h(le)||S(le)||v(le))return;const Te=f(le)?le.preferredResource:le.resource;return!Te||!De||!De.filterByScheme?Te:this.filterUri(Te,De.filterByScheme)}getSideEditors(le){return T(le)||S(le)?{primary:le.primary,secondary:le.secondary}:w(le)||h(le)?{primary:le.modified,secondary:le.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(le,De){if(!le)return;if(v(le))return e.EditorResourceAccessor.getCanonicalUri(le.result,De);if(De?.supportSideBySide){const{primary:Ee,secondary:P}=this.getSideEditors(le);if(Ee&&P){if(De?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:De.filterByScheme}),secondary:this.getCanonicalUri(P,{filterByScheme:De.filterByScheme})};if(De?.supportSideBySide===$.ANY)return this.getCanonicalUri(Ee,{filterByScheme:De.filterByScheme})??this.getCanonicalUri(P,{filterByScheme:De.filterByScheme});le=De.supportSideBySide===$.PRIMARY?Ee:P}}if(h(le)||S(le)||v(le))return;const Te=le.resource;return!Te||!De||!De.filterByScheme?Te:this.filterUri(Te,De.filterByScheme)}filterUri(le,De){if(Array.isArray(De)){if(De.some(Te=>le.scheme===Te))return le}else if(De===le.scheme)return le}}e.EditorResourceAccessor=new N;var V;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class x{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(le){const De=this.instantiationService=le.get(O.IInstantiationService);for(const[Te,Ee]of this.editorSerializerConstructors)this.createEditorSerializer(Te,Ee,De);this.editorSerializerConstructors.clear()}createEditorSerializer(le,De,Te){const Ee=Te.createInstance(De);this.editorSerializerInstances.set(le,Ee)}registerFileEditorFactory(le){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=le}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(le,De){if(this.editorSerializerConstructors.has(le)||this.editorSerializerInstances.has(le))throw new Error(`A editor serializer with type ID '${le}' was already registered.`);return this.instantiationService?this.createEditorSerializer(le,De,this.instantiationService):this.editorSerializerConstructors.set(le,De),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(le),this.editorSerializerInstances.delete(le)})}getEditorSerializer(le){return this.editorSerializerInstances.get(typeof le=="string"?le:le.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new x);async function W(X,le,De){return!X||!X.length?[]:await Promise.all(X.map(async Te=>{const Ee=y.URI.revive(Te.fileUri);if(!Ee){De.info("Cannot resolve the path because it is not valid.",Te);return}if(!await le.canHandleResource(Ee)){De.info("Cannot resolve the path because it cannot be handled",Te);return}let K=Te.exists,he=Te.type;if(typeof K!="boolean"||typeof he!="number")try{he=(await le.stat(Ee)).isDirectory?_.FileType.Directory:_.FileType.Unknown,K=!0}catch(be){De.error(be),K=!1}if(!K&&Te.openOnlyIfExists){De.info("Cannot resolve the path because it does not exist",Te);return}if(he===_.FileType.Directory){De.info("Cannot resolve the path because it is a directory",Te);return}const ye={...Te.options,pinned:!0};return K?{resource:Ee,options:ye}:{resource:Ee,options:ye,forceUntitled:!0}}))}e.pathsToEditors=W;var ee;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(ee||(e.EditorsOrder=ee={}));function Ie(X){const le=X;if(!le)return!1;const De=le;if(De.modified)return Ie(De.modified);const Te=le;return!!(Te.contributionsState&&Te.viewState&&Array.isArray(Te.cursorState))}e.isTextEditorViewState=Ie;function oe(X){return(0,R.isErrorWithActions)(X)}e.isEditorOpenError=oe;function ue(X,le,De){const Te=(0,R.createErrorWithActions)(X,le);return Te.forceMessage=De?.forceMessage,Te.forceSeverity=De?.forceSeverity,Te.allowDialog=De?.allowDialog,Te}e.createEditorOpenError=ue}),define(Ae[191],Re([1,0,5,158,3,6,28,30,18,64,26,87,182]),function(te,e,i,C,y,M,O,A,_,m,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,c.registerIcon)("default-view-icon",b.Codicon.window,(0,C.localize)(0,null));var p;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var g;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(g||(e.ViewContainerLocation=g={})),e.ViewContainerLocations=[0,1,2];function d(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=d;class t extends M.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new i.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new i.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,_.flatten)([...this.viewContainers.values()])}registerViewContainer(a,E,D){const f=this.get(a.id);if(f)return f;const T=a;return T.openCommandActionDescriptor=D?.doNotRegisterOpenCommand?void 0:T.openCommandActionDescriptor??{id:T.id},(0,O.getOrSet)(this.viewContainers,E,[]).push(T),D?.isDefault&&this.defaultViewContainers.push(T),this._onDidRegister.fire({viewContainer:T,viewContainerLocation:E}),T}deregisterViewContainer(a){for(const E of this.viewContainers.keys()){const D=this.viewContainers.get(E),f=D?.indexOf(a);if(f!==-1){D?.splice(f,1),D.length===0&&this.viewContainers.delete(E),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:E});return}}}get(a){return this.all.filter(E=>E.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(E=>this.getViewContainers(E).filter(D=>D?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(E=>this.getViewContainerLocation(E)===a)}}A.Registry.add(p.ViewContainersRegistry,new t);var l;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(l||(e.ViewContentGroups=l={}));function h(r,a){const E=r.group??l.More,D=a.group??l.More;return E!==D?E.localeCompare(D):(r.order??5)-(a.order??5)}class S extends M.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new i.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new i.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new i.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new i.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new m.SetMap}registerViews(a,E){this.registerViews2([{views:a,viewContainer:E}])}registerViews2(a){a.forEach(({views:E,viewContainer:D})=>this.addViews(E,D)),this._onViewsRegistered.fire(a)}deregisterViews(a,E){const D=this.removeViews(a,E);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:E})}moveViews(a,E){for(const D of this._views.keys())if(D!==E){const f=this.removeViews(a,D);f.length&&(this.addViews(f,E),this._onDidChangeContainer.fire({views:f,from:D,to:E}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const E of this._viewContainers){const D=(this._views.get(E)||[]).filter(f=>f.id===a)[0];if(D)return D}return null}getViewContainer(a){for(const E of this._viewContainers)if((this._views.get(E)||[]).filter(f=>f.id===a)[0])return E;return null}registerViewWelcomeContent(a,E){return this._viewWelcomeContents.add(a,E),this._onDidChangeViewWelcomeContent.fire(a),(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(a,E),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,E){const D=new Map;for(const[f,T]of E)this._viewWelcomeContents.add(a,T),D.set(f,(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(a,T),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),D}getViewWelcomeContent(a){const E=[];return this._viewWelcomeContents.forEach(a,D=>E.push(D)),E.sort(h)}addViews(a,E){let D=this._views.get(E);D||(D=[],this._views.set(E,D),this._viewContainers.push(E));for(const f of a){if(this.getView(f.id)!==null)throw new Error((0,C.localize)(1,null,f.id));D.push(f)}}removeViews(a,E){const D=this._views.get(E);if(!D)return[];const f=[],T=[];for(const w of D)a.includes(w)?f.push(w):T.push(w);return f.length&&(T.length?this._views.set(E,T):(this._views.delete(E),this._viewContainers.splice(this._viewContainers.indexOf(E),1))),f}}A.Registry.add(p.ViewsRegistry,new S),e.IViewsService=(0,y.createDecorator)("viewsService"),e.IViewDescriptorService=(0,y.createDecorator)("viewDescriptorService");var I;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(I||(e.ViewVisibilityState=I={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v||(e.TreeItemCollapsibleState=v={}));class n{constructor(a,E){this.resolved=!1,this._hasResolve=!1,(0,R.mixin)(this,a),this._hasResolve=!!E,this.resolve=async D=>{if(E&&!this.resolved){const f=await E(D);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class u extends Error{constructor(a){super((0,C.localize)(2,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.NoTreeViewError=u}),define(Ae[192],Re([1,0,5,16,159]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,_,m,R){const b={command:A};if(_&&Object.keys(_).length>0&&(b.arguments=_),this.internalSend("request",b),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const p=this.pendingRequests.get(b.seq);if(p){this.pendingRequests.delete(b.seq);const g={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,y.localize)(0,null,R,A)};p(g)}},R)}return m&&this.pendingRequests.set(b.seq,m),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,_){return A.type!=="event"||_.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,C.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const _=A,m=this.pendingRequests.get(_.request_seq);m&&(this.pendingRequests.delete(_.request_seq),m(_));break}}}}internalSend(A,_){_.type=A,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((_,m)=>A.set(m,_)),await(0,C.timeout)(500),A.forEach((_,m)=>{_({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(m)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Ae[193],Re([1,0,160,31,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const M=c=>i.localize(51,null,c);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var O;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(O||(e.State=O={}));function A(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var _;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(_||(e.MemoryRangeType=_={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var R;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.IDebugService=(0,y.createDecorator)("debugService");var b;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(b||(e.BreakpointWidgetContext=b={}))}),define(Ae[194],Re([1,0,13,2,19,26,15,44,22,18]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function b(f,T,w){return f.replace(R,function(o,s){return T&&s.length>0&&s[0]!=="_"?o:w&&w.hasOwnProperty(s)?w[s]:o})}e.formatPII=b;function c(f){const T={};for(const w of Object.keys(f))w.startsWith("!")||(T[w]=f[w]);return T}e.filterExceptionsFromTelemetry=c;function p(f){return f.configuration.request==="attach"&&!g(f)&&(!f.parentSession||p(f.parentSession))}e.isSessionAttach=p;function g(f){let T=f.configuration.type;if(T)return T==="vslsShare"&&(T=f.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(T,"extensionhost")||(0,i.equalsIgnoreCase)(T,"pwa-extensionhost")?f:f.parentSession?g(f.parentSession):void 0}e.getExtensionHostDebugSession=g;function d(f){return f.type&&(f.label||f.program||f.runtime)}e.isDebuggerMainContribution=d;function t(f,T,w){let o,s=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=F.exec(f);){const G=B.index+1,q=G+B[0].length;if(G<=T&&q>=w){o=B[0],s=G;break}}if(o){const G=/\w+/g;let q=null;for(;(q=G.exec(o))&&!(q.index+1+s+q[0].length>=w););q&&(o=o.substring(0,G.lastIndex))}return o?{start:s,end:s+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function l(f,T,w,o){if(f.evaluatableExpressionProvider.has(T)){const s=f.evaluatableExpressionProvider.ordered(T),F=(0,m.coalesce)(await Promise.all(s.map(async B=>{try{return await B.provideEvaluatableExpression(T,w,o??_.CancellationToken.None)}catch{return}})));if(F.length>0){let B=F[0].expression;const G=F[0].range;return B||(B=T.getLineContent(w.lineNumber).substring(G.startColumn-1,G.endColumn-1)),{range:G,matchingExpression:B}}}else{const s=T.getLineContent(w.lineNumber),{start:F,end:B}=t(s,w.column,w.column),G=s.substring(F-1,B);return{matchingExpression:G,range:new A.Range(w.lineNumber,F,w.lineNumber,F+G.length)}}return null}e.getEvaluatableExpressionAtPosition=l;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function S(f){return!!(f&&f.match(h))}e.isUri=S;function I(f){if(typeof f.path=="string"&&!(typeof f.sourceReference=="number"&&f.sourceReference>0)){if(S(f.path))return C.URI.parse(f.path);if((0,y.isAbsolute)(f.path))return C.URI.file(f.path)}return f.path}function v(f){if(typeof f.path=="object"){const T=C.URI.revive(f.path);if(T)return T.scheme===O.Schemas.file?T.fsPath:T.toString()}return f.path}function n(f,T){const w=T?I:v,o=(0,M.deepClone)(f);return r(o,(s,F)=>{s&&F&&(F.path=w(F))}),o}e.convertToDAPaths=n;function u(f,T){const w=T?I:v,o=(0,M.deepClone)(f);return r(o,(s,F)=>{!s&&F&&(F.path=w(F))}),o}e.convertToVSCPaths=u;function r(f,T){switch(f.type){case"event":{const w=f;switch(w.event){case"output":T(!1,w.body.source);break;case"loadedSource":T(!1,w.body.source);break;case"breakpoint":T(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=f;switch(w.command){case"setBreakpoints":T(!0,w.arguments.source);break;case"breakpointLocations":T(!0,w.arguments.source);break;case"source":T(!0,w.arguments.source);break;case"gotoTargets":T(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(o=>T(!1,o));break;default:break}break}case"response":{const w=f;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(o=>T(!1,o.source));break;case"loadedSources":w.body.sources.forEach(o=>T(!1,o));break;case"scopes":w.body.scopes.forEach(o=>T(!1,o.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(o=>T(!1,o.source));break;case"setBreakpoints":w.body.breakpoints.forEach(o=>T(!1,o.source));break;case"disassemble":w.body?.instructions.forEach(s=>T(!1,s.location));break;default:break}break}}}function a(f){return f.filter(T=>!T.presentation?.hidden).sort((T,w)=>T.presentation?w.presentation?T.presentation.group?w.presentation.group?T.presentation.group!==w.presentation.group?T.presentation.group.localeCompare(w.presentation.group):E(T.presentation.order,w.presentation.order):-1:w.presentation.group?1:E(T.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.getVisibleAndSorted=a;function E(f,T){return typeof f!="number"?typeof T!="number"?0:1:typeof T!="number"?-1:f-T}async function D(f,T){const w=f.getValue("debug.saveBeforeStart",{overrideIdentifier:T.activeTextEditorLanguageId});if(w!=="none"&&(await T.saveAll(),w==="allEditorsInActiveGroup")){const o=T.activeEditorPane;o&&o.input.resource?.scheme===O.Schemas.untitled&&await T.save({editor:o.input,groupId:o.group.id})}await f.reloadConfiguration()}e.saveAllBeforeDebugStart=D}),define(Ae[74],Re([1,0,24,37,88,67,15,19,21,31]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(R||(e.CellKind=R={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var b;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var c;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var p;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var g;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var d;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var l;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var h;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var S;(function(x){x.scheme=O.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],ee=new RegExp(`^[${W.join("")}]+`),Ie=7;function oe(Ee,P){const K=P.toString(Ie),ye=`${K.length<W.length?W[K.length-1]:"z"}${K}s${(0,i.encodeBase64)(i.VSBuffer.fromString(Ee.scheme),!0,!0)}`;return Ee.with({scheme:x.scheme,fragment:ye})}x.generate=oe;function ue(Ee){if(Ee.scheme!==x.scheme)return;const P=Ee.fragment.indexOf("s");if(P<0)return;const K=parseInt(Ee.fragment.substring(0,P).replace(ee,""),Ie),he=(0,i.decodeBase64)(Ee.fragment.substring(P+1)).toString();if(!isNaN(K))return{handle:K,notebook:Ee.with({scheme:he,fragment:null})}}x.parse=ue;function X(Ee,P){return Ee.with({scheme:O.Schemas.vscodeNotebookCellOutput,fragment:`op${P??""},${Ee.scheme!==O.Schemas.file?Ee.scheme:""}`})}x.generateCellOutputUri=X;function le(Ee){if(Ee.scheme!==O.Schemas.vscodeNotebookCellOutput)return;const P=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ee.fragment);if(!P)return;const K=P[1]&&P[1]!==""?P[1]:void 0,he=P[2];return{outputId:K,notebook:Ee.with({scheme:he||O.Schemas.file,fragment:null})}}x.parseCellOutputUri=le;function De(Ee,P,K){return x.generate(Ee,P).with({scheme:K})}x.generateCellPropertyUri=De;function Te(Ee,P){if(Ee.scheme===P)return x.parse(Ee.with({scheme:x.scheme}))}x.parseCellPropertyUri=Te})(S||(e.CellUri=S={}));const I=x=>_.isWindows?x.replace(/\//g,"\\"):x;class v{constructor(W=[],ee=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=ee,this.order=[...new Set(W)].map(Ie=>({pattern:Ie,matches:C.parse(I(Ie))}))}sort(W){const ee=new Map(y.Iterable.map(W,oe=>[oe,I(oe)]));let Ie=[];for(const{matches:oe}of this.order)for(const[ue,X]of ee)if(oe(X)){Ie.push(ue),ee.delete(ue);break}return ee.size&&(Ie=Ie.concat([...ee.keys()].sort((oe,ue)=>this.defaultOrder.indexOf(oe)-this.defaultOrder.indexOf(ue)))),Ie}prioritize(W,ee){const Ie=this.findIndex(W);if(Ie===-1){this.order.unshift({pattern:W,matches:C.parse(I(W))});return}const oe=new Set(ee.map(X=>this.findIndex(X,Ie)));oe.delete(-1);const ue=Array.from(oe).sort();this.order.splice(Ie+1,0,...ue.map(X=>this.order[X]));for(let X=ue.length-1;X>=0;X--)this.order.splice(ue[X],1)}toArray(){return this.order.map(W=>W.pattern)}findIndex(W,ee=this.order.length){const Ie=I(W);for(let oe=0;oe<ee;oe++)if(this.order[oe].matches(Ie))return oe;return-1}}e.MimeTypeDisplayOrder=v;function n(x,W,ee,Ie=(oe,ue)=>oe===ue){const oe=[];function ue(De,Te,Ee){if(Te===0&&Ee.length===0)return;const P=oe[oe.length-1];P&&P.start+P.deleteCount===De?(P.deleteCount+=Te,P.toInsert.push(...Ee)):oe.push({start:De,deleteCount:Te,toInsert:Ee})}let X=0,le=0;for(;;){if(X===x.length){ue(X,0,W.slice(le));break}if(le===W.length){ue(X,x.length-X,[]);break}const De=x[X],Te=W[le];if(Ie(De,Te)){X+=1,le+=1;continue}ee(Te)?(ue(X,1,[]),X+=1):(ue(X,0,[Te]),le+=1)}return oe}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(x){x.default="default",x.option="option"})(u||(e.NotebookEditorPriority=u={}));function r(x){const W=x;return!!((typeof W.include=="string"||C.isRelativePattern(W.include))&&(typeof W.exclude=="string"||C.isRelativePattern(W.exclude)))}e.isDocumentExcludePattern=r;function a(x,W,ee){if(Array.isArray(x.viewType)&&x.viewType.indexOf(W)>=0||x.viewType===W)return!0;if(x.filenamePattern){const Ie=r(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,oe=r(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(C.match(Ie,(0,A.basename)(ee.fsPath).toLowerCase()))return!(oe&&C.match(oe,(0,A.basename)(ee.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var E;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(E||(e.CellStatusbarAlignment=E={}));class D{static create(W){return`${D._prefix}${W}`}static parse(W){if(W.startsWith(D._prefix))return W.substring(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D,D._prefix="notebook/";function f(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=f;const T=new TextDecoder;function w(x){const W=[];let ee=!1;for(const Ie of x)(W.length===0||ee)&&(W.push(Ie),ee=!0);return B(W),V(i.VSBuffer.concat(W.map(Ie=>i.VSBuffer.wrap(Ie))))}e.compressOutputItemStreams=w;const o=`${String.fromCharCode(27)}[A`,s=o.split("").map(x=>x.charCodeAt(0)),F=10;function B(x){x.forEach((W,ee)=>{if(ee===0||W.length<o.length)return;const Ie=x[ee-1],oe=W.subarray(0,o.length);if(oe[0]===s[0]&&oe[1]===s[1]&&oe[2]===s[2]){const ue=Ie.lastIndexOf(F);if(ue===-1)return;x[ee-1]=Ie.subarray(0,ue),x[ee]=W.subarray(o.length)}})}function G(x){let W=x;do x=W,W=x.replace(/[^\n]\x08/gm,"");while(W.length<x.length);return x}function q(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const W=x.match(/^(.*)\r+/m)[1];let ee=x.match(/\r+(.*)$/m)[1];ee=ee+W.slice(ee.length,W.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return x}const $="\b".charCodeAt(0),N="\r".charCodeAt(0);function V(x){return!x.buffer.includes($)&&!x.buffer.includes(N)?x:i.VSBuffer.fromString(q(G(T.decode(x.buffer))))}}),define(Ae[195],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(M){M.Delimiter="\0"})(i||(e.TestIdPathParts=i={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class y{static fromExtHostTestItem(O,A,_=O.parent){if(O._isRoot)return new y([A]);const m=[O.id];for(let R=_;R&&R.id!==A;R=R.parent)m.push(R.id);return m.push(A),new y(m.reverse())}static isRoot(O){return!O.includes("\0")}static root(O){const A=O.indexOf("\0");return A===-1?O:O.slice(0,A)}static fromString(O){return new y(O.split("\0"))}static join(O,A){return new y([...O.path,A])}static joinToString(O,A){return O.toString()+"\0"+A}static parentId(O){const A=O.lastIndexOf("\0");return A===-1?void 0:O.slice(0,A)}static localId(O){const A=O.lastIndexOf("\0");return A===-1?O:O.slice(A+1)}static isChild(O,A){return A.startsWith(O)&&A[O.length]==="\0"}static compare(O,A){return O===A?0:y.isChild(O,A)?2:y.isChild(A,O)?3:1}constructor(O,A=O.length){if(this.path=O,this.viewEnd=A,O.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let O=1;O<=this.viewEnd;O++)yield new y(this.path,O)}*idsToRoot(){for(let O=this.viewEnd;O>0;O--)yield new y(this.path,O)}compare(O){if(typeof O=="string")return y.compare(this.toString(),O);for(let A=0;A<O.viewEnd&&A<this.viewEnd;A++)if(O.path[A]!==this.path[A])return 1;return O.viewEnd>this.viewEnd?2:O.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let O=1;O<this.viewEnd;O++)this.stringifed+="\0",this.stringifed+=this.path[O]}return this.stringifed}}e.TestId=y}),define(Ae[56],Re([1,0,2,44,45]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var O;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var A;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable",T[T.SupportsContinuousRun=64]="SupportsContinuousRun"})(A||(e.TestRunProfileBitset=A={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const _=T=>"runId"in T;e.isStartControllerTests=_;var m;(function(T){T.serialize=w=>({range:w.range.toJSON(),uri:w.uri.toJSON()}),T.deserialize=w=>({range:C.Range.lift(w.range),uri:i.URI.revive(w.uri)})})(m||(e.IRichLocation=m={}));var R;(function(T){T[T.Error=0]="Error",T[T.Output=1]="Output"})(R||(e.TestMessageType=R={}));var b;(function(T){T.serialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,location:w.location&&m.serialize(w.location)}),T.deserialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,location:w.location&&m.deserialize(w.location)})})(b||(e.ITestErrorMessage=b={}));const c=(T,w)=>`${w?"s":"e"}${T}`;e.getMarkId=c;var p;(function(T){T.serialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&m.serialize(w.location)}),T.deserialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&m.deserialize(w.location)})})(p||(e.ITestOutputMessage=p={}));var g;(function(T){T.serialize=w=>w.type===0?b.serialize(w):p.serialize(w),T.deserialize=w=>w.type===0?b.deserialize(w):p.deserialize(w)})(g||(e.ITestMessage=g={}));var d;(function(T){T.serializeWithoutMessages=w=>({state:w.state,duration:w.duration,messages:[]}),T.serialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(g.serialize)}),T.deserialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(g.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",l=(T,w)=>T+t+w;e.namespaceTestTag=l;const h=T=>{const w=T.indexOf(t);return{ctrlId:T.slice(0,w),tagId:T.slice(w+1)}};e.denamespaceTestTag=h;var S;(function(T){T.serialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?.toJSON(),range:w.range?.toJSON()||null,description:w.description,error:w.error,sortText:w.sortText}),T.deserialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?i.URI.revive(w.uri):void 0,range:w.range?C.Range.lift(w.range):null,description:w.description,error:w.error,sortText:w.sortText})})(S||(e.ITestItem=S={}));var I;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(I||(e.TestItemExpandState=I={}));var v;(function(T){T.serialize=w=>({expand:w.expand,item:S.serialize(w.item)}),T.deserialize=w=>({controllerId:y.TestId.root(w.item.extId),expand:w.expand,item:S.deserialize(w.item)})})(v||(e.InternalTestItem=v={}));var n;(function(T){T.serialize=w=>{let o;return w.item&&(o={},w.item.label!==void 0&&(o.label=w.item.label),w.item.tags!==void 0&&(o.tags=w.item.tags),w.item.busy!==void 0&&(o.busy=w.item.busy),w.item.uri!==void 0&&(o.uri=w.item.uri?.toJSON()),w.item.range!==void 0&&(o.range=w.item.range?.toJSON()),w.item.description!==void 0&&(o.description=w.item.description),w.item.error!==void 0&&(o.error=w.item.error),w.item.sortText!==void 0&&(o.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:o}},T.deserialize=w=>{let o;return w.item&&(o={},w.item.label!==void 0&&(o.label=w.item.label),w.item.tags!==void 0&&(o.tags=w.item.tags),w.item.busy!==void 0&&(o.busy=w.item.busy),w.item.range!==void 0&&(o.range=w.item.range?C.Range.lift(w.item.range):null),w.item.description!==void 0&&(o.description=w.item.description),w.item.error!==void 0&&(o.error=w.item.error),w.item.sortText!==void 0&&(o.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:o}}})(n||(e.ITestItemUpdate=n={}));const u=(T,w)=>{w.expand!==void 0&&(T.expand=w.expand),w.item!==void 0&&(T.item=T.item?Object.assign(T.item,w.item):w.item)};e.applyTestItemUpdate=u;var r;(function(T){T.serializeWithoutMessages=w=>({...v.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(d.serializeWithoutMessages)}),T.serialize=w=>({...v.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(d.serialize)}),T.deserialize=w=>({...v.deserialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(d.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var a;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(a||(e.DetailType=a={}));var E;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.DocumentSynced=2]="DocumentSynced",T[T.Remove=3]="Remove",T[T.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",T[T.Retire=5]="Retire",T[T.AddTag=6]="AddTag",T[T.RemoveTag=7]="RemoveTag"})(E||(e.TestDiffOpType=E={}));var D;(function(T){T.deserialize=w=>w.op===0?{op:w.op,item:v.deserialize(w.item)}:w.op===1?{op:w.op,item:n.deserialize(w.item)}:w.op===2?{op:w.op,uri:i.URI.revive(w.uri),docv:w.docv}:w,T.serialize=w=>w.op===0?{op:w.op,item:v.serialize(w.item)}:w.op===1?{op:w.op,item:n.serialize(w.item)}:w})(D||(e.TestsDiffOp=D={}));class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(w){const o=this.createChangeCollector();for(const s of w)switch(s.op){case 0:this.add(v.deserialize(s.item),o);break;case 1:this.update(n.deserialize(s.item),o);break;case 3:this.remove(s.itemId,o);break;case 5:this.retireTest(s.itemId);break;case 4:this.updatePendingRoots(s.amount);break;case 6:this._tags.set(s.tag.id,s.tag);break;case 7:this._tags.delete(s.id);break}o.complete?.()}add(w,o){const s=y.TestId.parentId(w.item.extId)?.toString();let F;if(!s)F=this.createItem(w),this.roots.add(F),this.items.set(w.item.extId,F);else if(this.items.has(s)){const B=this.items.get(s);B.children.add(w.item.extId),F=this.createItem(w,B),this.items.set(w.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(w)}`);return}return o.add?.(F),w.expand===2&&this.busyControllerCount++,F}update(w,o){const s=this.items.get(w.extId);if(s)return w.expand!==void 0&&(s.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(s,w),o.update?.(s),s}remove(w,o){const s=this.items.get(w);if(!s)return;const F=y.TestId.parentId(s.item.extId)?.toString();F?this.items.get(F).children.delete(s.item.extId):this.roots.delete(s);const B=[[w]];for(;B.length;)for(const G of B.pop()){const q=this.items.get(G);q&&(B.push(q.children),this.items.delete(G),o.remove?.(q,q!==s),q.expand===2&&this.busyControllerCount--)}}retireTest(w){}updatePendingRoots(w){this.pendingRootCount+=w}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=f}),define(Ae[75],Re([1,0,16,5,6,49,56,45]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var _;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(_||(e.TestItemEventOp=_={}));const m=(h,S)=>h===S,b=Object.entries({range:(h,S)=>h===S?!0:!h||!S?!1:h.equalsRange(S),busy:m,label:m,description:m,error:m,sortText:m,tags:(h,S)=>!(h.length!==S.length||h.some(I=>!S.includes(I)))}),c=(h,S)=>{let I;for(const[v,n]of b)n(h[v],S[v])||(I?I[v]=S[v]:I={[v]:S[v]});return I};class p extends y.Disposable{get root(){return this.options.root}constructor(S){super(),this.options=S,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(S){this._resolveHandler=S;for(const I of this.tree.values())this.updateExpandability(I)}get resolveHandler(){return this._resolveHandler}collectDiff(){const S=this.diff;return this.diff=[],S}pushDiff(S){switch(S.op){case 2:{for(const I of this.diff)if(I.op===2&&I.uri===S.uri){I.docv=S.docv;return}break}case 1:{const I=this.diff[this.diff.length-1];if(I){if(I.op===1&&I.item.extId===S.item.extId){(0,O.applyTestItemUpdate)(I.item,S.item);return}if(I.op===0&&I.item.item.extId===S.item.extId){(0,O.applyTestItemUpdate)(I.item,S.item);return}}break}}this.diff.push(S),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(S,I){const v=this.tree.get(S);if(v){if((v.expandLevels===void 0||I>v.expandLevels)&&(v.expandLevels=I),v.expand===1){const n=this.resolveChildren(v);return n.isOpen()?this.expandChildren(v,I-1):n.wait().then(()=>this.expandChildren(v,I-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.expandChildren(v,I-1)):this.expandChildren(v,I-1)}}dispose(){for(const S of this.tree.values())this.options.getApiFor(S.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(S,I){switch(I.op){case 3:this.removeItem(A.TestId.joinToString(S.fullId,I.id));break;case 0:this.upsertItem(I.item,S);break;case 5:for(const v of I.ops)this.onTestItemEvent(S,v);break;case 1:this.diffTagRefs(I.new,I.old,S.fullId.toString());break;case 2:this.updateExpandability(S);break;case 4:this.pushDiff({op:1,item:{extId:S.fullId.toString(),item:I.update}});break;case 6:this.documentSynced(S.actual.uri);break;default:(0,M.assertNever)(I)}}documentSynced(S){S&&this.pushDiff({op:2,uri:S,docv:this.options.getDocumentVersion(S)})}upsertItem(S,I){const v=A.TestId.fromExtHostTestItem(S,this.root.id,I?.actual),n=this.options.getApiFor(S);n.parent&&n.parent!==I?.actual&&this.options.getChildren(n.parent).delete(S.id);let u=this.tree.get(v.toString());if(!u){u={fullId:v,actual:S,expandLevels:I?.expandLevels?I.expandLevels-1:void 0,expand:0},S.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(S,I),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:u.expand,item:this.options.toITestItem(S)}}),this.connectItemAndChildren(S,u,I);return}if(u.actual===S){this.connectItem(S,u,I);return}if(u.actual.uri?.toString()!==S.uri?.toString())return this.removeItem(v.toString()),this.upsertItem(S,I);const r=this.options.getChildren(u.actual),a=u.actual,E=c(this.options.toITestItem(a),this.options.toITestItem(S));this.options.getApiFor(a).listener=void 0,u.actual=S,u.expand=0,E&&(E.hasOwnProperty("tags")&&(this.diffTagRefs(S.tags,a.tags,v.toString()),delete E.tags),this.onTestItemEvent(u,{op:4,update:E})),this.connectItemAndChildren(S,u,I);for(const[D,f]of r)this.options.getChildren(S).get(f.id)||this.removeItem(A.TestId.joinToString(v,f.id));this.documentSynced(u.actual.uri)}diffTagRefs(S,I,v){const n=new Set(I.map(u=>u.id));for(const u of S)n.delete(u.id)||this.incrementTagRefs(u);this.pushDiff({op:1,item:{extId:v,item:{tags:S.map(u=>(0,O.namespaceTestTag)(this.options.controllerId,u.id))}}}),n.forEach(this.decrementTagRefs,this)}incrementTagRefs(S){const I=this.tags.get(S.id);I?I.refCount++:(this.tags.set(S.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,O.namespaceTestTag)(this.options.controllerId,S.id)}}))}decrementTagRefs(S){const I=this.tags.get(S);I&&!--I.refCount&&(this.tags.delete(S),this.pushDiff({op:7,id:(0,O.namespaceTestTag)(this.options.controllerId,S)}))}setItemParent(S,I){this.options.getApiFor(S).parent=I&&I.actual!==this.root?I.actual:void 0}connectItem(S,I,v){this.setItemParent(S,v);const n=this.options.getApiFor(S);n.parent=v?.actual,n.listener=u=>this.onTestItemEvent(I,u),this.updateExpandability(I)}connectItemAndChildren(S,I,v){this.connectItem(S,I,v);for(const[n,u]of this.options.getChildren(S))this.upsertItem(u,I)}updateExpandability(S){let I;this._resolveHandler?S.resolveBarrier?I=S.resolveBarrier.isOpen()?3:2:I=S.actual.canResolveChildren?1:0:I=0,I!==S.expand&&(S.expand=I,this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:I}}),I===1&&S.expandLevels!==void 0&&this.resolveChildren(S))}expandChildren(S,I){if(I<0)return;const v=[];for(const[n,u]of this.options.getChildren(S.actual)){const r=this.expand(A.TestId.joinToString(S.fullId,u.id),I);(0,i.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}resolveChildren(S){if(S.resolveBarrier)return S.resolveBarrier;if(!this._resolveHandler){const u=new i.Barrier;return u.open(),u}S.expand=2,this.pushExpandStateUpdate(S);const I=S.resolveBarrier=new i.Barrier,v=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,u)};let n;try{n=this._resolveHandler(S.actual===this.root?void 0:S.actual)}catch(u){v(u)}return(0,i.isThenable)(n)?n.catch(v).then(()=>{I.open(),this.updateExpandability(S)}):(I.open(),this.updateExpandability(S)),S.resolveBarrier}pushExpandStateUpdate(S){this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:S.expand}})}removeItem(S){const I=this.tree.get(S);if(!I)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:S});const v=[I];for(;v.length;){const n=v.pop();if(n){this.options.getApiFor(n.actual).listener=void 0;for(const u of n.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(n.fullId.toString());for(const[u,r]of this.options.getChildren(n.actual))v.push(this.tree.get(A.TestId.joinToString(n.fullId,r.id)))}}}flushDiff(){const S=this.collectDiff();S.length&&this.diffOpEmitter.fire(S)}}e.TestItemCollection=p;class g extends Error{constructor(S){super(`Attempted to insert a duplicate test item ID ${S}`)}}e.DuplicateTestItemError=g;class d extends Error{constructor(S){super(`TestItem with ID "${S}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class t extends Error{constructor(S,I,v){super(`TestItem with ID "${S}" is from controller "${I}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=t;const l=(h,S,I)=>{let v=new Map;return{get size(){return v.size},forEach(n,u){for(const r of v.values())n.call(u,r,this)},[Symbol.iterator](){return v.entries()},replace(n){const u=new Map,r=new Set(v.keys()),a={op:5,ops:[]};for(const E of n){if(!(E instanceof I))throw new d(E.id);const D=S(E).controllerId;if(D!==h.controllerId)throw new t(E.id,D,h.controllerId);if(u.has(E.id))throw new g(E.id);u.set(E.id,E),r.delete(E.id),a.ops.push({op:0,item:E})}for(const E of r.keys())a.ops.push({op:3,id:E});h.listener?.(a),v=u},add(n){if(!(n instanceof I))throw new d(n.id);v.set(n.id,n),h.listener?.({op:0,item:n})},delete(n){v.delete(n)&&h.listener?.({op:3,id:n})},get(n){return v.get(n)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=l}),define(Ae[100],Re([1,0,75]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,y=(O,A)=>{const _={controllerId:A};return C.set(O,_),_};e.createPrivateApiFor=y;const M=O=>{const A=C.get(O);if(!A)throw new i.InvalidTestItemError(O?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ae[76],Re([1,0,15,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(A,_){return A.scheme===i.Schemas.http||A.scheme===i.Schemas.https?A:(_&&_.authority&&_.isRemote&&A.scheme===i.Schemas.file&&(A=C.URI.from({scheme:i.Schemas.vscodeRemote,authority:_.authority,path:A.path})),C.URI.from({scheme:i.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=y;function M(A){return A.replace(/./g,_=>{const m=_.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?_:"-"+m.toString(16).padStart(4,"0")})}function O(A){return A.replace(/-([0-9a-f]{4})/g,(_,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=O}),define(Ae[196],Re([1,0,5,6,76]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,_,m){this._proxy=A,this._editors=_,this._remoteInfo=m,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const R=_.getVisibleTextEditors();for(const b of this._insets.values())R.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,_,m,R,b){let c;for(const S of this._editors.getVisibleTextEditors(!0))if(S.value===A){c=S;break}if(!c)throw new Error("not a visible editor");const p=this,g=this._handlePool++,d=new i.Emitter,t=new i.Emitter,l=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(S){return(0,y.asWebviewUri)(S,p._remoteInfo)}get cspSource(){return y.webviewGenericCspSource}set options(S){this._options=S,p._proxy.$setOptions(g,S)}get options(){return this._options}set html(S){this._html=S,p._proxy.$setHtml(g,S)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(S){return p._proxy.$postMessage(g,S)}},h=new class{constructor(){this.editor=A,this.line=_,this.height=m,this.webview=l,this.onDidDispose=t.event}dispose(){p._insets.has(g)&&(p._insets.delete(g),p._proxy.$disposeEditorInset(g),t.fire(),t.dispose(),d.dispose())}};return this._proxy.$createEditorInset(g,c.id,c.value.document.uri,_+1,m,R||{},b.identifier,b.extensionLocation),this._insets.set(g,{editor:A,inset:h,onDidReceiveMessage:d}),h}$onDidDispose(A){const _=this._insets.get(A);_&&_.inset.dispose()}$onDidReceiveMessage(A,_){this._insets.get(A)?.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=M}),define(Ae[197],Re([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(C||(e.VariableKind=C={}));class y extends Error{constructor(O,A){super(A),this.variable=O}}e.VariableError=y}),define(Ae[198],Re([1,0,19,51,9,26,21,90,163,197,13]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(p,g,d,t){this._contributedVariables=new Map,this._context=p,this._labelService=g,this._userHomePromise=d,t&&(this._envVariablesPromise=t.then(l=>this.prepareEnv(l)))}prepareEnv(p){if(O.isWindows){const g=Object.create(null);return Object.keys(p).forEach(d=>{g[d.toLowerCase()]=p[d]}),g}return p}resolveWithEnvironment(p,g,d){return this.recursiveResolve({env:this.prepareEnv(p),userHome:void 0},g?g.uri:void 0,d)}async resolveAsync(p,g){const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,p?p.uri:void 0,g)}async resolveAnyBase(p,g,d,t){const l=M.deepClone(g);O.isWindows&&l.windows?Object.keys(l.windows).forEach(S=>l[S]=l.windows[S]):O.isMacintosh&&l.osx?Object.keys(l.osx).forEach(S=>l[S]=l.osx[S]):O.isLinux&&l.linux&&Object.keys(l.linux).forEach(S=>l[S]=l.linux[S]),delete l.windows,delete l.osx,delete l.linux;const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,p?p.uri:void 0,l,d,t)}async resolveAnyAsync(p,g,d){return this.resolveAnyBase(p,g,d)}async resolveAnyMap(p,g,d){const t=new Map;return{newConfig:await this.resolveAnyBase(p,g,d,t),resolvedVariables:t}}resolveWithInteractionReplace(p,g,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,g,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,g){if(this._contributedVariables.has(p))throw new Error("Variable "+p+" is contributed twice.");this._contributedVariables.set(p,g)}async recursiveResolve(p,g,d,t,l){if(y.isString(d))return this.resolveString(p,g,d,t,l);if(Array.isArray(d))return Promise.all(d.map(h=>this.recursiveResolve(p,g,h,t,l)));if(y.isObject(d)){const h=Object.create(null),S=await Promise.all(Object.keys(d).map(async I=>[await this.resolveString(p,g,I,t,l),await this.recursiveResolve(p,g,d[I],t,l)]));for(const[I,v]of S)h[I]=v;return h}return d}resolveString(p,g,d,t,l){return(0,R.replaceAsync)(d,b.VARIABLE_REGEXP,async(h,S)=>{if(S.includes(b.VARIABLE_LHS))return h;let I=await this.evaluateSingleVariable(p,h,S,g,t);return l?.set(S,I),I!==h&&y.isString(I)&&I.match(b.VARIABLE_REGEXP)&&(I=await this.resolveString(p,g,I,t,l)),I})}fsPath(p){return this._labelService?this._labelService.getUriLabel(p,{noPrefix:!0}):p.fsPath}async evaluateSingleVariable(p,g,d,t,l){let h;const S=d.split(":");S.length>1&&(d=S[0],h=S[1]);const I=u=>{const r=this._context.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new m.VariableError(u,(0,_.localize)(0,null,g))},v=u=>{const r=I(u);if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return(0,A.normalizeDriveLetter)(a)}throw new m.VariableError(u,(0,_.localize)(1,null,g,i.basename(r)))},n=u=>{if(h){const r=this._context.getFolderUri(h);if(r)return r;throw new m.VariableError(u,(0,_.localize)(2,null,g,h))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new m.VariableError(u,(0,_.localize)(3,null,g)):new m.VariableError(u,(0,_.localize)(4,null,g))};switch(d){case"env":if(h){if(p.env){const u=p.env[O.isWindows?h.toLowerCase():h];if(y.isString(u))return u}return""}throw new m.VariableError(m.VariableKind.Env,(0,_.localize)(5,null,g));case"config":if(h){const u=this._context.getConfigurationValue(t,h);if(y.isUndefinedOrNull(u))throw new m.VariableError(m.VariableKind.Config,(0,_.localize)(6,null,g,h));if(y.isObject(u))throw new m.VariableError(m.VariableKind.Config,(0,_.localize)(7,null,g,h));return u}throw new m.VariableError(m.VariableKind.Config,(0,_.localize)(8,null,g));case"command":return this.resolveFromMap(m.VariableKind.Command,g,h,l,"command");case"input":return this.resolveFromMap(m.VariableKind.Input,g,h,l,"input");case"extensionInstallFolder":if(h){const u=await this._context.getExtension(h);if(!u)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,_.localize)(9,null,g,h));return this.fsPath(u.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,_.localize)(10,null,g));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(n(m.VariableKind.WorkspaceFolder)));case"cwd":return t||h?(0,A.normalizeDriveLetter)(this.fsPath(n(m.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(i.basename(this.fsPath(n(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,_.localize)(11,null,g))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new m.VariableError(m.VariableKind.LineNumber,(0,_.localize)(12,null,g))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new m.VariableError(m.VariableKind.SelectedText,(0,_.localize)(13,null,g))}case"file":return I(m.VariableKind.File);case"fileWorkspaceFolder":return v(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||h?i.relative(this.fsPath(n(m.VariableKind.RelativeFile)),I(m.VariableKind.RelativeFile)):I(m.VariableKind.RelativeFile);case"relativeFileDirname":{const u=i.dirname(I(m.VariableKind.RelativeFileDirname));if(t||h){const r=i.relative(this.fsPath(n(m.VariableKind.RelativeFileDirname)),u);return r.length===0?".":r}return u}case"fileDirname":return i.dirname(I(m.VariableKind.FileDirname));case"fileExtname":return i.extname(I(m.VariableKind.FileExtname));case"fileBasename":return i.basename(I(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=i.basename(I(m.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-i.extname(u).length)}case"fileDirnameBasename":return i.basename(i.dirname(I(m.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||g}case"execInstallFolder":{const u=this._context.getAppRoot();return u||g}case"pathSeparator":return i.sep;default:try{const u=h?`${d}:${h}`:d;return this.resolveFromMap(m.VariableKind.Unknown,g,u,l,void 0)}catch{return g}}}}resolveFromMap(p,g,d,t,l){if(d&&t){const h=l===void 0?t[d]:t[l+":"+d];if(typeof h=="string")return h;throw new m.VariableError(p,(0,_.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ae[101],Re([1,0,3,99]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var y;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(y||(e.GroupDirection=y={}));var M;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var O;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(O||(e.GroupLocation=O={}));var A;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(A||(e.GroupsArrangement=A={}));var _;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(_||(e.MergeGroupMode=_={}));function m(g){const d=g;return(0,C.isEditorInput)(d?.editor)&&(0,C.isEditorInput)(d?.replacement)}e.isEditorReplacement=m;var R;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var b;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(b||(e.OpenEditorContext=b={}));function c(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=c;function p(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Ae[199],Re([1,0,3,101]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(M){const O=M;return typeof M=="number"||(0,C.isEditorGroup)(O)}e.isPreferredGroup=y}),define(Ae[200],Re([1,0,3,169]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(C.IEnvironmentService)}),define(Ae[102],Re([1,0,23,5,19,6]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class O{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=O;class A{static isHostExtension(t,l,h){if(l.getExtensionDescription(t))return!1;const S=h.getExtensionDescription(t);return S?!!((S.main||S.browser)&&S.api==="none"):!1}constructor(t,l){this._activationEventsReader=t,this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=l,this._initialize()}_initialize(){this._extensionDescriptions.sort(p),this._extensionsMap=new i.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this._extensionsMap.set(t.identifier,t),this._extensionsArr.push(t);const l=this._activationEventsReader.readActivationEvents(t);if(Array.isArray(l))for(let h of l)h==="onUri"&&(h=`onUri:${i.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(h)||this._activationMap.set(h,[]),this._activationMap.get(h).push(t)}}set(t){this._extensionDescriptions=t,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,l){this._extensionDescriptions=g(this._extensionDescriptions,l),this._extensionDescriptions=this._extensionDescriptions.concat(t);const h=A._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=g(this._extensionDescriptions,h.map(S=>S.identifier)),this._initialize(),this._onDidChange.fire(void 0),new O(h)}static _findLoopingExtensions(t){const l=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(n){this._nodesSet.has(n)||(this._nodesSet.add(n),this._nodesArr.push(n))}addArc(n,u){this.addNode(n),this.addNode(u),this._arcs.has(n)?this._arcs.get(n).push(u):this._arcs.set(n,[u])}getArcs(n){return this._arcs.has(n)?this._arcs.get(n):[]}hasOnlyGoodArcs(n,u){const r=l.getArcs(n);for(let a=0;a<r.length;a++)if(!u.has(r[a]))return!1;return!0}getNodes(){return this._nodesArr}},h=new i.ExtensionIdentifierMap;for(const n of t)if(h.set(n.identifier,n),n.extensionDependencies)for(const u of n.extensionDependencies)l.addArc(i.ExtensionIdentifier.toKey(n.identifier),i.ExtensionIdentifier.toKey(u));const S=new Set;l.getNodes().filter(n=>l.getArcs(n).length===0).forEach(n=>S.add(n));const I=l.getNodes().filter(n=>!S.has(n));let v;do{v=!1;for(let n=0;n<I.length;n++){const u=I[n];l.hasOnlyGoodArcs(u,S)&&(I.splice(n,1),n--,S.add(u),v=!0)}}while(v);return I.map(n=>h.get(n))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(t)}getExtensionDescriptionsForActivationEvent(t){const l=this._activationMap.get(t);return l?l.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const l=this._extensionsMap.get(t);return l||void 0}getExtensionDescriptionByUUID(t){for(const l of this._extensionsArr)if(l.uuid===t)return l}getExtensionDescriptionByIdOrUUID(t,l){return this.getExtensionDescription(t)??(l?this.getExtensionDescriptionByUUID(l):void 0)}}e.ExtensionDescriptionRegistry=A,e.basicActivationEventsReader={readActivationEvents:d=>d.activationEvents};class _{constructor(t){this._lock=new b,this._actual=new A(t,[])}async acquireLock(t){const l=await this._lock.acquire(t);return new m(this,l)}deltaExtensions(t,l,h){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(l,h)}containsActivationEvent(t){return this._actual.containsActivationEvent(t)}containsExtension(t){return this._actual.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this._actual.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(t){return this._actual.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this._actual.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,l){return this._actual.getExtensionDescriptionByIdOrUUID(t,l)}}e.LockableExtensionDescriptionRegistry=_;class m extends M.Disposable{constructor(t,l){super(),this._registry=t,this._isDisposed=!1,this._register(l)}isAcquiredFor(t){return!this._isDisposed&&this._registry===t}}e.ExtensionDescriptionRegistryLock=m;class R{constructor(t){this.name=t,this.promise=new Promise((l,h)=>{this._resolve=l})}resolve(t){this._resolve(t)}}class b{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(t){const l=new R(t);return this._pendingCustomers.push(l),this._advance(),l.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const t=this._pendingCustomers.shift();this._isLocked=!0;let l=!0;const h=setTimeout(()=>{l&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),S=()=>{l&&(clearTimeout(h),l=!1,this._isLocked=!1,this._advance())};t.resolve((0,M.toDisposable)(S))}}var c;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(c||(c={}));function p(d,t){const l=d.isBuiltin?0:d.isUnderDevelopment?2:1,h=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(l!==h)return l-h;const S=y.posix.basename(d.extensionLocation.path),I=y.posix.basename(t.extensionLocation.path);return S<I?-1:S>I?1:0}function g(d,t){const l=new i.ExtensionIdentifierSet(t);return d.filter(h=>!l.has(h.identifier))}}),define(Ae[77],Re([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(C||(e.UIKind=C={}));var y;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(y||(e.ExtensionHostExitCode=y={}));var M;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function O(m){const R=i.VSBuffer.alloc(1);switch(m){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=O;function A(m,R){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A;var _;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(_||(e.NativeLogMarkers=_={}))}),define(Ae[57],Re([1,0,3,5,14,27,77,50,52,26,2,6,153]),function(te,e,i,C,y,M,O,A,_,m,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let p=e.ExtHostTelemetry=class extends b.Disposable{constructor(l,h){super(),this.initData=l,this.loggerService=h,this._onDidChangeTelemetryEnabled=this._register(new C.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new C.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=h.createLogger(this.extHostTelemetryLogFile,{id:_.extensionTelemetryLogChannelId,name:(0,c.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(h.onDidChangeLogLevel(S=>{(0,y.isLogLevel)(S)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===y.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(l,h,S){const I=this.getTelemetryDetails(),v=new g(h,S,l,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(l),{isUsageEnabled:I.isUsageEnabled,isErrorsEnabled:I.isErrorsEnabled}),n=this._telemetryLoggers.get(l.identifier.value)??[];return this._telemetryLoggers.set(l.identifier.value,[...n,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(l,h,S){this._level=l,this._telemetryIsSupported=h,this._productConfig=S??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(l){const h=Object.create(null);switch(h["common.extname"]=`${l.publisher}.${l.name}`,h["common.extversion"]=l.version,h["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,h["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,h["common.vscodeversion"]=this.initData.version,h["common.isnewappinstall"]=d(this.initData.telemetryInfo.firstSessionDate),h["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case O.UIKind.Web:h["common.uikind"]="web";break;case O.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,A.getRemoteName)((0,_.cleanRemoteAuthority)(this.initData.remote.authority)),h}$onDidChangeTelemetryLevel(l){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=l;const h=this.getTelemetryDetails();this._telemetryLoggers.forEach((S,I)=>{const v=S.filter(n=>!n.isDisposed);v.length===0?this._telemetryLoggers.delete(I):this._telemetryLoggers.set(I,v)}),this._telemetryLoggers.forEach(S=>{for(const I of S)I.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(l,h){const I=this._telemetryLoggers.get(l.value)?.filter(n=>!n.isDisposed);if(!I)return this._telemetryLoggers.delete(l.value),!1;let v=!1;for(const n of I)n.ignoreUnhandledExtHostErrors||(n.logError(h),v=!0);return v}};e.ExtHostTelemetry=p=je([We(0,M.IExtHostInitDataService),We(1,y.ILoggerService)],p);class g{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,h,S,I,v,n,u){this._extension=S,this._logger=I,this._inLoggingOnlyMode=v,this._commonProperties=n,this._onDidChangeEnableStates=new C.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=h?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=h?.additionalCommonProperties,this._sender=l,this._telemetryEnablements={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(l,h){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:l,isErrorsEnabled:h},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(l){let h="properties"in l?l.properties??{}:l;return h=(0,_.cleanData)(h,[]),this._additionalCommonProperties&&(h=(0,m.mixin)(h,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(h=(0,m.mixin)(h,this._commonProperties)),"properties"in l?l.properties=h:l=h,l}logEvent(l,h){this._sender&&(this._extension.publisher==="vscode"?l=this._extension.name+"/"+l:l=this._extension.identifier.value+"/"+l,h=this.mixInCommonPropsAndCleanData(h||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(l,h),this._logger.trace(l,h))}logUsage(l,h){this._telemetryEnablements.isUsageEnabled&&this.logEvent(l,h)}logError(l,h){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof l=="string"?this.logEvent(l,h):this._sender.sendErrorData(l,h))}get apiTelemetryLogger(){if(!this._apiObject){const l=this,h={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return l._telemetryEnablements.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l._onDidChangeEnableStates.event.bind(l)};this._apiObject=Object.freeze(h)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let l=this._sender;this._sender=void 0,Promise.resolve(l.flush()).then(l=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=g;function d(t){const l=Date.now()-new Date(t).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.isNewAppInstall=d,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ae[20],Re([1,0,5,2,179,98,23,3]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new O.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class _{constructor(v){this.dependency=v}}e.MissingExtensionDependency=_;var m;(function(I){I[I.EagerAutoStart=1]="EagerAutoStart",I[I.EagerManualStart=2]="EagerManualStart",I[I.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class R{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:M.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(v,n){const u=[],r=[],a=[],E=[],D=b(this._allExtensions),f=b(v),T=(B,G)=>B.extensionLocation.toString()===G.extensionLocation.toString()||B.isBuiltin===G.isBuiltin||B.isUserBuiltin===G.isUserBuiltin||B.isUnderDevelopment===G.isUnderDevelopment;for(const B of this._allExtensions){const G=f.get(B.identifier);if(!G){u.push(B.identifier),D.delete(B.identifier);continue}if(!T(B,G)){u.push(B.identifier),D.delete(B.identifier);continue}}for(const B of v){const G=D.get(B.identifier);if(!G){r.push(B);continue}if(!T(G,B)){u.push(G.identifier),D.delete(G.identifier);continue}}const w=new O.ExtensionIdentifierSet(this._myExtensions),o=new O.ExtensionIdentifierSet(n);for(const B of this._myExtensions)o.has(B)||a.push(B);for(const B of n)w.has(B)||E.push(B);const s=M.ImplicitActivationEvents.createActivationEventsMap(r),F={toRemove:u,toAdd:r,addActivationEvents:s,myToRemove:a,myToAdd:E};return this.delta(F),F}delta(v){const{toRemove:n,toAdd:u,myToRemove:r,myToAdd:a}=v,E=new O.ExtensionIdentifierSet(n),D=new O.ExtensionIdentifierSet(r);for(let f=0;f<this._allExtensions.length;f++)E.has(this._allExtensions[f].identifier)&&(this._allExtensions.splice(f,1),f--);for(let f=0;f<this._myExtensions.length;f++)D.has(this._myExtensions[f])&&(this._myExtensions.splice(f,1),f--);for(const f of u)this._allExtensions.push(f);for(const f of a)this._myExtensions.push(f)}containsExtension(v){for(const n of this._myExtensions)if(O.ExtensionIdentifier.equals(n,v))return!0;return!1}}e.ExtensionHostExtensions=R;function b(I){const v=new O.ExtensionIdentifierMap;for(const n of I)v.set(n.identifier,n);return v}function c(I,v){return I.enabledApiProposals?I.enabledApiProposals.includes(v):!1}e.isProposedApiEnabled=c;function p(I,v){if(!c(I,v))throw new Error(`Extension '${I.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${I.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${I.identifier.value}`)}e.checkProposedApiEnabled=p;class g{constructor(v,n,u,r){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=u,this.activationReason=r}}e.ActivationTimes=g;class d{constructor(v,n){this.description=v,this.value=n}}e.ExtensionPointContribution=d;var t;(function(I){I[I.Normal=0]="Normal",I[I.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function l(I){return{type:I.isBuiltin?0:1,isBuiltin:I.isBuiltin||I.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(I.publisher,I.name),uuid:I.uuid},manifest:I,location:I.extensionLocation,targetPlatform:I.targetPlatform,validations:[],isValid:!0}}e.toExtension=l;function h(I,v){return{identifier:new O.ExtensionIdentifier((0,y.getExtensionId)(I.manifest.publisher,I.manifest.name)),isBuiltin:I.type===0,isUserBuiltin:I.type===1&&I.isBuiltin,isUnderDevelopment:!!v,extensionLocation:I.location,...I.manifest,uuid:I.identifier.uuid,targetPlatform:I.targetPlatform}}e.toExtensionDescription=h;class S{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.onWillStop=i.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=S}),define(Ae[201],Re([1,0,10,102,23,20,14,16]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class _{constructor(l,h,S,I){this.startup=l,this.codeLoadingTime=h,this.activateCallTime=S,this.activateResolvedTime=I}}e.ExtensionActivationTimes=_,_.NONE=new _(!1,-1,-1,-1);class m{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,h){return l===-1||h===-1?-1:h-l}build(){return new _(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=m;class R{constructor(l,h,S,I,v,n){this.activationFailed=l,this.activationFailedError=h,this.activationTimes=S,this.module=I,this.exports=v,this.subscriptions=n}}e.ActivatedExtension=R;class b extends R{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=b;class c extends R{constructor(){super(!1,null,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=c;class p extends R{constructor(l){super(!0,l,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=e.ExtensionsActivator=class{constructor(l,h,S,I){this._logService=I,this._registry=l,this._globalRegistry=h,this._host=S,this._operations=new y.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[l,h]of this._operations)h.dispose()}async waitForActivatingExtensions(){const l=[];for(const[h,S]of this._operations)l.push(S.wait());await Promise.all(l)}isActivated(l){const h=this._operations.get(l);return!!(h&&h.value)}getActivatedExtension(l){const h=this._operations.get(l);if(!h||!h.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return h.value}async activateByEvent(l,h){if(this._alreadyActivatedEvents[l])return;const S=this._registry.getExtensionDescriptionsForActivationEvent(l);await this._activateExtensions(S.map(I=>({id:I.identifier,reason:{startup:h,extensionId:I.identifier,activationEvent:l}}))),this._alreadyActivatedEvents[l]=!0}activateById(l,h){const S=this._registry.getExtensionDescription(l);if(!S)throw new Error(`Extension '${l}' is not known`);return this._activateExtensions([{id:S.identifier,reason:h}])}async _activateExtensions(l){const h=l.filter(S=>!this.isActivated(S.id)).map(S=>this._handleActivationRequest(S));await Promise.all(h.map(S=>S.wait()))}_handleActivationRequest(l){if(this._operations.has(l.id))return this._operations.get(l.id);if(this._isHostExtension(l.id))return this._createAndSaveOperation(l,null,[],null);const h=this._registry.getExtensionDescription(l.id);if(!h){const v=new Error(`Cannot activate unknown extension '${l.id.value}'`),n=this._createAndSaveOperation(l,null,[],new p(v));return this._host.onExtensionActivationError(l.id,v,new M.MissingExtensionDependency(l.id.value)),n}const S=[],I=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const v of I){if(this._isResolvedExtension(v))continue;const n=this._operations.get(v);if(n){S.push(n);continue}if(this._isHostExtension(v)){S.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(v).identifier,reason:l.reason}));continue}const u=this._registry.getExtensionDescription(v);if(u){if(!u.main&&!u.browser)continue;S.push(this._handleActivationRequest({id:u.identifier,reason:l.reason}));continue}const r=h.displayName||h.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),E=this._createAndSaveOperation(l,h.displayName,[],new p(a));return this._host.onExtensionActivationError(h.identifier,a,new M.MissingExtensionDependency(v)),E}return this._createAndSaveOperation(l,h.displayName,S,null)}_createAndSaveOperation(l,h,S,I){const v=new d(l.id,h,l.reason,S,I,this._host,this._logService);return this._operations.set(l.id,v),v}_isHostExtension(l){return C.ExtensionDescriptionRegistry.isHostExtension(l,this._registry,this._globalRegistry)}_isResolvedExtension(l){const h=this._globalRegistry.getExtensionDescription(l);return h?!h.main&&!h.browser:!1}};e.ExtensionsActivator=g=je([We(3,O.ILogService)],g);let d=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(l,h,S,I,v,n,u){this._id=l,this._displayName=h,this._reason=S,this._deps=I,this._value=v,this._host=n,this._logService=u,this._barrier=new A.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let l=0;l<this._deps.length;l++){const h=this._deps[l];if(h.value&&!h.value.activationFailed){this._deps.splice(l,1),l--;continue}if(h.value&&h.value.activationFailed){const S=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);S.detail=h.value.activationFailedError,this._value=new p(S),this._host.onExtensionActivationError(this._id,S,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(l=>l.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(l){const h=new Error;if(l&&l.name&&(h.name=l.name),l&&l.message?h.message=`Activating extension '${this._id.value}' failed: ${l.message}.`:h.message=`Activating extension '${this._id.value}' failed: ${l}.`,l&&l.stack&&(h.stack=l.stack),this._value=new p(h),this._isDisposed&&i.isCancellationError(l))return;this._host.onExtensionActivationError(this._id,h,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(l)}}};d=je([We(6,O.ILogService)],d)});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[7],Re([1,0,18,10,89,28,67,13,9,2,36,23,43,97,74,20]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d){"use strict";var t,l,h,S,I,v,n,u,r,a,E,D,f,T,w,o,s,F,B,G,q,$,N,V,x,W;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function ee(U){return Object.assign(U,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(U,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(U,[]);{const[se,...ke]=arguments;return Reflect.construct(U,ke,se.constructor)}}})}var Ie;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(Ie||(e.TerminalOutputAnchor=Ie={}));var oe;(function(U){U[U.Command=0]="Command",U[U.Opener=1]="Opener"})(oe||(e.TerminalQuickFixType=oe={}));let ue=e.Disposable=r=class{static from(...L){let se=L;return new r(function(){if(se){for(const ke of se)ke&&typeof ke.dispose=="function"&&ke.dispose();se=void 0}})}constructor(L){t.set(this,void 0),Qe(this,t,L,"f")}dispose(){typeof Oe(this,t,"f")=="function"&&(Oe(this,t,"f").call(this),Qe(this,t,void 0,"f"))}};t=new WeakMap,e.Disposable=ue=r=je([ee],ue);let X=e.Position=a=class{static Min(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let ke=1;ke<L.length;ke++){const qe=L[ke];qe.isBefore(se)&&(se=qe)}return se}static Max(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let ke=1;ke<L.length;ke++){const qe=L[ke];qe.isAfter(se)&&(se=qe)}return se}static isPosition(L){if(!L)return!1;if(L instanceof a)return!0;const{line:se,character:ke}=L;return typeof se=="number"&&typeof ke=="number"}static of(L){if(L instanceof a)return L;if(this.isPosition(L))return new a(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,se){if(L<0)throw(0,C.illegalArgument)("line must be non-negative");if(se<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=L,this._character=se}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,se=0){if(L===null||se===null)throw(0,C.illegalArgument)();let ke;return typeof L>"u"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,se=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&se===0?this:new a(this.line+ke,this.character+se)}with(L,se=this.character){if(L===null||se===null)throw(0,C.illegalArgument)();let ke;return typeof L>"u"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,se=typeof L.character=="number"?L.character:this.character),ke===this.line&&se===this.character?this:new a(ke,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=X=a=je([ee],X);let le=e.Range=E=class{static isRange(L){return L instanceof E?!0:L?X.isPosition(L.start)&&X.isPosition(L.end):!1}static of(L){if(L instanceof E)return L;if(this.isRange(L))return new E(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,se,ke,qe){let Ye,rt;if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof qe=="number"?(Ye=new X(L,se),rt=new X(ke,qe)):X.isPosition(L)&&X.isPosition(se)&&(Ye=X.of(L),rt=X.of(se)),!Ye||!rt)throw new Error("Invalid arguments");Ye.isBefore(rt)?(this._start=Ye,this._end=rt):(this._start=rt,this._end=Ye)}contains(L){return E.isRange(L)?this.contains(L.start)&&this.contains(L.end):X.isPosition(L)?!(X.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const se=X.Max(L.start,this._start),ke=X.Min(L.end,this._end);if(!se.isAfter(ke))return new E(se,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const se=X.Min(L.start,this._start),ke=X.Max(L.end,this.end);return new E(se,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,se=this.end){if(L===null||se===null)throw(0,C.illegalArgument)();let ke;return L?X.isPosition(L)?ke=L:(ke=L.start||this.start,se=L.end||this.end):ke=this.start,ke.isEqual(this._start)&&se.isEqual(this.end)?this:new E(ke,se)}toJSON(){return[this.start,this.end]}};e.Range=le=E=je([ee],le);let De=e.Selection=D=class extends le{static isSelection(L){return L instanceof D?!0:L?le.isRange(L)&&X.isPosition(L.anchor)&&X.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,se,ke,qe){let Ye,rt;if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof qe=="number"?(Ye=new X(L,se),rt=new X(ke,qe)):X.isPosition(L)&&X.isPosition(se)&&(Ye=X.of(L),rt=X.of(se)),!Ye||!rt)throw new Error("Invalid arguments");super(Ye,rt),this._anchor=Ye,this._active=rt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=De=D=je([ee],De);const Te=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,C.illegalArgument)("connectionToken")};class Ee{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se,ke){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,C.illegalArgument)("port");typeof ke<"u"&&Te(ke),this.host=L,this.port=Math.round(se),this.connectionToken=ke}}e.ResolvedAuthority=Ee;class P{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se){this.makeConnection=L,this.connectionToken=se,typeof se<"u"&&Te(se)}}e.ManagedResolvedAuthority=P;class K extends Error{static NotAvailable(L,se){return new K(L,p.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(L){return new K(L,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,se=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L),this._message=L,this._code=se,this._detail=ke,Object.setPrototypeOf(this,K.prototype)}}e.RemoteAuthorityResolverError=K;var he;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(he||(e.EndOfLine=he={}));var ye;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ye||(e.EnvironmentVariableMutatorType=ye={}));let be=e.TextEdit=f=class{static isTextEdit(L){return L instanceof f?!0:L?le.isRange(L)&&typeof L.newText=="string":!1}static replace(L,se){return new f(L,se)}static insert(L,se){return f.replace(new le(L,L),se)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const se=new f(new le(new X(0,0),new X(0,0)),"");return se.newEol=L,se}get range(){return this._range}set range(L){if(L&&!le.isRange(L))throw(0,C.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,C.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,C.illegalArgument)("newEol");this._newEol=L}constructor(L,se){this._range=L,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=be=f=je([ee],be);let ge=e.NotebookEdit=T=class{static isNotebookCellEdit(L){return L instanceof T?!0:L?Jt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,se){return new T(L,se)}static insertCells(L,se){return new T(new Jt(L,L),se)}static deleteCells(L){return new T(L,[])}static updateCellMetadata(L,se){const ke=new T(new Jt(L,L),[]);return ke.newCellMetadata=se,ke}static updateNotebookMetadata(L){const se=new T(new Jt(0,0),[]);return se.newNotebookMetadata=L,se}constructor(L,se){this.range=L,this.newCells=se}};e.NotebookEdit=ge=T=je([ee],ge);class Ce{static isSnippetTextEdit(L){return L instanceof Ce?!0:L?le.isRange(L.range)&&Z.isSnippetString(L.snippet):!1}static replace(L,se){return new Ce(L,se)}static insert(L,se){return Ce.replace(new le(L,L),se)}constructor(L,se){this.range=L,this.snippet=se}}e.SnippetTextEdit=Ce;var ae;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let de=e.WorkspaceEdit=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,se,ke,qe){this._edits.push({_type:1,from:L,to:se,options:ke,metadata:qe})}createFile(L,se,ke){this._edits.push({_type:1,from:void 0,to:L,options:se,metadata:ke})}deleteFile(L,se,ke){this._edits.push({_type:1,from:L,to:void 0,options:se,metadata:ke})}replaceNotebookMetadata(L,se,ke){this._edits.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(L,se,ke,qe){const Ye=se.start,rt=se.end;(Ye!==rt||ke.length>0)&&this._edits.push({_type:5,uri:L,index:Ye,count:rt-Ye,cells:ke,metadata:qe})}replaceNotebookCellMetadata(L,se,ke,qe){this._edits.push({_type:3,metadata:qe,uri:L,edit:{editType:8,index:se,metadata:ke}})}replace(L,se,ke,qe){this._edits.push({_type:2,uri:L,edit:new be(se,ke),metadata:qe})}insert(L,se,ke,qe){this.replace(L,new le(se,se),ke,qe)}delete(L,se,ke){this.replace(L,se,"",ke)}has(L){return this._edits.some(se=>se._type===2&&se.uri.toString()===L.toString())}set(L,se){if(se)for(const ke of se){if(!ke)continue;let qe,Ye;Array.isArray(ke)?(qe=ke[0],Ye=ke[1]):qe=ke,ge.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(L,qe.range.start,qe.newCellMetadata,Ye):qe.newNotebookMetadata?this.replaceNotebookMetadata(L,qe.newNotebookMetadata,Ye):this.replaceNotebookCells(L,qe.range,qe.newCells,Ye):Ce.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:L,range:qe.range,edit:qe.snippet,metadata:Ye}):this._edits.push({_type:2,uri:L,edit:qe,metadata:Ye})}else{for(let ke=0;ke<this._edits.length;ke++){const qe=this._edits[ke];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===L.toString()&&(this._edits[ke]=void 0);break}}(0,i.coalesceInPlace)(this._edits)}}get(L){const se=[];for(const ke of this._edits)ke._type===2&&ke.uri.toString()===L.toString()&&se.push(ke.edit);return se}entries(){const L=new M.ResourceMap;for(const se of this._edits)if(se._type===2){let ke=L.get(se.uri);ke||(ke=[se.uri,[]],L.set(se.uri,ke)),ke[1].push(se.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=de=je([ee],de);let Z=e.SnippetString=w=class{static isSnippetString(L){return L instanceof w?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=w._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,se=this._tabstop++){if(typeof L=="function"){const ke=new w;ke._tabstop=this._tabstop,L(ke),this._tabstop=ke._tabstop,L=ke.value}else L=w._escape(L);return this.value+="${",this.value+=se,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,se=this._tabstop++){const ke=L.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,se){if(typeof se=="function"){const ke=new w;ke._tabstop=this._tabstop,se(ke),this._tabstop=ke._tabstop,se=ke.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=Z=w=je([ee],Z);var ne;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var k;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(k||(e.DiagnosticSeverity=k={}));let z=e.Location=o=class{static isLocation(L){return L instanceof o?!0:L?le.isRange(L.range)&&m.URI.isUri(L.uri):!1}constructor(L,se){if(this.uri=L,se)if(le.isRange(se))this.range=le.of(se);else if(X.isPosition(se))this.range=new le(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=z=o=je([ee],z);let H=e.DiagnosticRelatedInformation=class{static is(L){return L?typeof L.message=="string"&&L.location&&le.isRange(L.location.range)&&m.URI.isUri(L.location.uri):!1}constructor(L,se){this.location=L,this.message=se}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.location.range.isEqual(se.location.range)&&L.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=H=je([ee],H);let j=e.Diagnostic=class{constructor(L,se,ke=k.Error){if(!le.isRange(L))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=L,this.message=se,this.severity=ke}toJSON(){return{severity:k[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.severity===se.severity&&L.code===se.code&&L.severity===se.severity&&L.source===se.source&&L.range.isEqual(se.range)&&(0,i.equals)(L.tags,se.tags)&&(0,i.equals)(L.relatedInformation,se.relatedInformation,H.isEqual)}};e.Diagnostic=j=je([ee],j);let ce=e.Hover=class{constructor(L,se){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=se}};e.Hover=ce=je([ee],ce);var pe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let ie=e.DocumentHighlight=class{constructor(L,se=pe.Text){this.range=L,this.kind=se}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.DocumentHighlight=ie=je([ee],ie);var Se;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Se||(e.SymbolKind=Se={}));var _e;(function(U){U[U.Deprecated=1]="Deprecated"})(_e||(e.SymbolTag=_e={}));let Be=e.SymbolInformation=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,se,ke,qe,Ye){this.name=L,this.kind=se,this.containerName=Ye,typeof ke=="string"&&(this.containerName=ke),qe instanceof z?this.location=qe:ke instanceof le&&(this.location=new z(qe,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Be=s=je([ee],Be);let He=e.DocumentSymbol=F=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(F.validate)}constructor(L,se,ke,qe,Ye){this.name=L,this.detail=se,this.kind=ke,this.range=qe,this.selectionRange=Ye,this.children=[],F.validate(this)}};e.DocumentSymbol=He=F=je([ee],He);var Ze;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Ze||(e.CodeActionTriggerKind=Ze={}));let Xe=e.CodeAction=class{constructor(L,se){this.title=L,this.kind=se}};e.CodeAction=Xe=je([ee],Xe);let Ke=e.CodeActionKind=B=class{constructor(L){this.value=L}append(L){return new B(this.value?this.value+B.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+B.sep)}};Ke.sep=".",e.CodeActionKind=Ke=B=je([ee],Ke);class it extends Ke{constructor(L){super(L),this.value=L}}e.NotebookCodeActionKind=it,Ke.Empty=new Ke(""),Ke.QuickFix=Ke.Empty.append("quickfix"),Ke.Refactor=Ke.Empty.append("refactor"),Ke.RefactorExtract=Ke.Refactor.append("extract"),Ke.RefactorInline=Ke.Refactor.append("inline"),Ke.RefactorMove=Ke.Refactor.append("move"),Ke.RefactorRewrite=Ke.Refactor.append("rewrite"),Ke.Source=Ke.Empty.append("source"),Ke.SourceOrganizeImports=Ke.Source.append("organizeImports"),Ke.SourceFixAll=Ke.Source.append("fixAll"),Ke.Notebook=Ke.Empty.append("notebook");let st=e.SelectionRange=class{constructor(L,se){if(this.range=L,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=st=je([ee],st);class tt{constructor(L,se,ke,qe,Ye,rt){this.kind=L,this.name=se,this.detail=ke,this.uri=qe,this.range=Ye,this.selectionRange=rt}}e.CallHierarchyItem=tt;class Me{constructor(L,se){this.fromRanges=se,this.from=L}}e.CallHierarchyIncomingCall=Me;class dt{constructor(L,se){this.fromRanges=se,this.to=L}}e.CallHierarchyOutgoingCall=dt;var Y;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Y||(e.LanguageStatusSeverity=Y={}));let J=e.CodeLens=class{constructor(L,se){this.range=L,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=J=je([ee],J);let fe=e.MarkdownString=G=class{static isMarkdownString(L){return L instanceof G?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,se=!1){l.set(this,void 0),Qe(this,l,new y.MarkdownString(L,{supportThemeIcons:se}),"f")}get value(){return Oe(this,l,"f").value}set value(L){Oe(this,l,"f").value=L}get isTrusted(){return Oe(this,l,"f").isTrusted}set isTrusted(L){Oe(this,l,"f").isTrusted=L}get supportThemeIcons(){return Oe(this,l,"f").supportThemeIcons}set supportThemeIcons(L){Oe(this,l,"f").supportThemeIcons=L}get supportHtml(){return Oe(this,l,"f").supportHtml}set supportHtml(L){Oe(this,l,"f").supportHtml=L}get baseUri(){return Oe(this,l,"f").baseUri}set baseUri(L){Oe(this,l,"f").baseUri=L}appendText(L){return Oe(this,l,"f").appendText(L),this}appendMarkdown(L){return Oe(this,l,"f").appendMarkdown(L),this}appendCodeblock(L,se){return Oe(this,l,"f").appendCodeblock(se??"",L),this}};l=new WeakMap,e.MarkdownString=fe=G=je([ee],fe);let Ue=e.ParameterInformation=class{constructor(L,se){this.label=L,this.documentation=se}};e.ParameterInformation=Ue=je([ee],Ue);let Ve=e.SignatureInformation=class{constructor(L,se){this.label=L,this.documentation=se,this.parameters=[]}};e.SignatureInformation=Ve=je([ee],Ve);let $e=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=$e=je([ee],$e);var Je;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Je||(e.SignatureHelpTriggerKind=Je={}));var mt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(mt||(e.InlayHintKind=mt={}));let _t=e.InlayHintLabelPart=class{constructor(L){this.value=L}};e.InlayHintLabelPart=_t=je([ee],_t);let Ct=e.InlayHint=class{constructor(L,se,ke){this.position=L,this.label=se,this.kind=ke}};e.InlayHint=Ct=je([ee],Ct);var qt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qt||(e.CompletionTriggerKind=qt={}));var Bt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Bt||(e.CompletionItemKind=Bt={}));var St;(function(U){U[U.Deprecated=1]="Deprecated"})(St||(e.CompletionItemTag=St={}));let $t=e.CompletionItem=class{constructor(L,se){this.label=L,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Bt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=$t=je([ee],$t);let Ft=e.CompletionList=class{constructor(L=[],se=!1){this.items=L,this.isIncomplete=se}};e.CompletionList=Ft=je([ee],Ft);let Vt=e.InlineSuggestion=class{constructor(L,se,ke){this.insertText=L,this.range=se,this.command=ke}};e.InlineSuggestion=Vt=je([ee],Vt);let Rt=e.InlineSuggestionList=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.InlineSuggestionList=Rt=je([ee],Rt);var Lt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Lt||(e.ViewColumn=Lt={}));var zt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(zt||(e.StatusBarAlignment=zt={}));function at(U,L){return`${b.ExtensionIdentifier.toKey(U)}.${L}`}e.asStatusBarItemIdentifier=at;var ht;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var Mt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var Nt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Nt||(e.TextEditorRevealType=Nt={}));var wt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var ut;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ut||(e.TextDocumentChangeReason=ut={}));var It;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(It||(e.DecorationRangeBehavior=It={})),function(U){function L(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(wt||(e.TextEditorSelectionChangeKind=wt={}));let Ut=e.DocumentLink=class{constructor(L,se){if(se&&!m.URI.isUri(se))throw(0,C.illegalArgument)("target");if(!le.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.target=se}};e.DocumentLink=Ut=je([ee],Ut);let Pe=e.Color=class{constructor(L,se,ke,qe){this.red=L,this.green=se,this.blue=ke,this.alpha=qe}};e.Color=Pe=je([ee],Pe);let we=e.ColorInformation=class{constructor(L,se){if(se&&!(se instanceof Pe))throw(0,C.illegalArgument)("color");if(!le.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.color=se}};e.ColorInformation=we=je([ee],we);let ve=e.ColorPresentation=class{constructor(L){if(!L||typeof L!="string")throw(0,C.illegalArgument)("label");this.label=L}};e.ColorPresentation=ve=je([ee],ve);var Q;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Q||(e.ColorFormat=Q={}));var Fe;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Fe||(e.SourceControlInputBoxValidationType=Fe={}));var xe;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(xe||(e.TerminalExitReason=xe={}));class Ge{constructor(L,se,ke){if(this.startIndex=L,this.length=se,this.tooltip=ke,typeof L!="number"||L<0)throw(0,C.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,C.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=Ge;class ze{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=ze;class et{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=et;var bt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(bt||(e.TerminalLocation=bt={}));class Pt{constructor(L){if(this.options=L,typeof L!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Pt;var kt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var vt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(vt||(e.TaskPanelKind=vt={}));let ot=e.TaskGroup=q=class{static from(L){switch(L){case"clean":return q.Clean;case"build":return q.Build;case"rebuild":return q.Rebuild;case"test":return q.Test;default:return}}constructor(L,se){if(this.label=se,typeof L!="string"||typeof se!="string")throw(0,C.illegalArgument)("name");this._id=L}get id(){return this._id}};ot.Clean=new q("clean","Clean"),ot.Build=new q("build","Build"),ot.Rebuild=new q("rebuild","Rebuild"),ot.Test=new q("test","Test"),e.TaskGroup=ot=q=je([ee],ot);function gt(U){let L="";for(let se=0;se<U.length;se++)L+=U[se].replace(/,/g,",,")+",";return L}let pt=e.ProcessExecution=class{constructor(L,se,ke){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=L,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ke):this._options=se)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const se of this._args)L.push(se);return gt(L)}};e.ProcessExecution=pt=je([ee],pt);let Et=e.ShellExecution=class{constructor(L,se,ke){if(this._args=[],Array.isArray(se)){if(!L)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L,this._args=se,this._options=ke}else{if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L,this._options=se}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)L.push(typeof se=="string"?se:se.value);return gt(L)}};e.ShellExecution=Et=je([ee],Et);var oi;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(oi||(e.ShellQuoting=oi={}));var Wt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class Oi{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Oi;let Kt=e.Task=$=class{constructor(L,se,ke,qe,Ye,rt){this.__deprecated=!1,this._definition=this.definition=L;let lt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ke,this.execution=qe,lt=Ye,this.__deprecated=!0):se===Wt.Global||se===Wt.Workspace?(this.target=se,this._name=this.name=ke,this._source=this.source=qe,this.execution=Ye,lt=rt):(this.target=se,this._name=this.name=ke,this._source=this.source=qe,this.execution=Ye,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof pt?this._definition={type:$.ProcessType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:$.ShellType,id:this._execution.computeId()}:this._execution instanceof Oi?this._definition={type:$.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:$.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const se=this._definition.type;($.EmptyType===se||$.ProcessType===se||$.ShellType===se||$.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};Kt.ExtensionCallbackType="customExecution",Kt.ProcessType="process",Kt.ShellType="shell",Kt.EmptyType="$empty",e.Task=Kt=$=je([ee],Kt);var wi;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(wi||(e.ProgressLocation=wi={}));var Tt;(function(U){function L(se){const ke=se;return(0,_.isNumber)(ke.value)?ke.tooltip&&!(0,_.isString)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}U.isViewBadge=L})(Tt||(e.ViewBadge=Tt={}));let Fi=e.TreeItem=N=class{static isTreeItem(L,se){const ke=L;if(ke.checkboxState!==void 0){(0,d.checkProposedApiEnabled)(se,"treeItemCheckbox");const qe=(0,_.isNumber)(ke.checkboxState)?ke.checkboxState:(0,_.isObject)(ke.checkboxState)&&(0,_.isNumber)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ye=!(0,_.isNumber)(ke.checkboxState)&&(0,_.isObject)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(qe===void 0||qe!==yt.Checked&&qe!==yt.Unchecked||Ye!==void 0&&!(0,_.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(L instanceof N)return!0;if(ke.label!==void 0&&!(0,_.isString)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,_.isString)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,_.isString)(ke.iconPath)&&!m.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,_.isString)(ke.iconPath.id))){const qe=ke.iconPath;if(!qe||!(0,_.isString)(qe.light)&&!m.URI.isUri(qe.light)&&!(0,_.isString)(qe.dark)&&!m.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,_.isString)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!m.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,_.isString)(ke.tooltip)&&!(ke.tooltip instanceof fe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<ai.None&&ke.collapsibleState>ai.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,_.isString)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(L,se=ai.None){this.collapsibleState=se,m.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.TreeItem=Fi=N=je([ee],Fi);var ai;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(ai||(e.TreeItemCollapsibleState=ai={}));var yt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(yt||(e.TreeItemCheckboxState=yt={}));let di=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.DataTransferItem=di=je([ee],di);class bi extends di{}e.InternalDataTransferItem=bi;class hi extends bi{constructor(L){super(""),h.set(this,void 0),Qe(this,h,L,"f")}asFile(){return Oe(this,h,"f")}}e.InternalFileDataTransferItem=hi,h=new WeakMap;class cn{constructor(L,se,ke,qe){this.name=L,this.uri=se,this._itemId=ke,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=cn;let Li=e.DataTransfer=class{constructor(L){S.add(this),I.set(this,new Map);for(const[se,ke]of L??[]){const qe=Oe(this,I,"f").get(Oe(this,S,"m",v).call(this,se));qe?qe.push(ke):Oe(this,I,"f").set(Oe(this,S,"m",v).call(this,se),[ke])}}get(L){return Oe(this,I,"f").get(Oe(this,S,"m",v).call(this,L))?.[0]}set(L,se){Oe(this,I,"f").set(Oe(this,S,"m",v).call(this,L),[se])}forEach(L,se){for(const[ke,qe]of Oe(this,I,"f"))for(const Ye of qe)L.call(se,Ye,ke,this)}*[(I=new WeakMap,S=new WeakSet,Symbol.iterator)](){for(const[L,se]of Oe(this,I,"f"))for(const ke of se)yield[L,ke]}};v=function(L){return L.toLowerCase()},e.DataTransfer=Li=je([ee],Li);let Ot=e.DocumentDropEdit=class{constructor(L){this.insertText=L}};e.DocumentDropEdit=Ot=je([ee],Ot);let _i=e.DocumentPasteEdit=class{constructor(L,se,ke){this.id=se,this.label=ke,this.insertText=L}};e.DocumentPasteEdit=_i=je([ee],_i);let Qt=e.ThemeIcon=class{constructor(L,se){this.id=L,this.color=se}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.ThemeIcon=Qt=je([ee],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let ci=e.ThemeColor=class{constructor(L){this.id=L}};e.ThemeColor=ci=je([ee],ci);var li;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let ct=e.RelativePattern=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=m.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,se){if(typeof L!="string"&&(!L||!m.URI.isUri(L)&&!m.URI.isUri(L.uri)))throw(0,C.illegalArgument)("base");if(typeof se!="string")throw(0,C.illegalArgument)("pattern");typeof L=="string"?this.baseUri=m.URI.file(L):m.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=ct=je([ee],ct);const Mi=new WeakMap;function ei(U,L){Mi.set(U,L)}e.setBreakpointId=ei;let Gt=e.Breakpoint=class{constructor(L,se,ke,qe){this.enabled=typeof L=="boolean"?L:!0,typeof se=="string"&&(this.condition=se),typeof ke=="string"&&(this.hitCondition=ke),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=Mi.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=Gt=je([ee],Gt);let Si=e.SourceBreakpoint=class extends Gt{constructor(L,se,ke,qe,Ye){if(super(se,ke,qe,Ye),L===null)throw(0,C.illegalArgument)("location");this.location=L}};e.SourceBreakpoint=Si=je([ee],Si);let Ni=e.FunctionBreakpoint=class extends Gt{constructor(L,se,ke,qe,Ye){super(se,ke,qe,Ye),this.functionName=L}};e.FunctionBreakpoint=Ni=je([ee],Ni);let Ui=e.DataBreakpoint=class extends Gt{constructor(L,se,ke,qe,Ye,rt,lt){if(super(qe,Ye,rt,lt),!se)throw(0,C.illegalArgument)("dataId");this.label=L,this.dataId=se,this.canPersist=ke}};e.DataBreakpoint=Ui=je([ee],Ui);let xi=e.DebugAdapterExecutable=class{constructor(L,se,ke){this.command=L,this.args=se||[],this.options=ke}};e.DebugAdapterExecutable=xi=je([ee],xi);let yi=e.DebugAdapterServer=class{constructor(L,se){this.port=L,this.host=se}};e.DebugAdapterServer=yi=je([ee],yi);let Bi=e.DebugAdapterNamedPipeServer=class{constructor(L){this.path=L}};e.DebugAdapterNamedPipeServer=Bi=je([ee],Bi);let Di=e.DebugAdapterInlineImplementation=class{constructor(L){this.implementation=L}};e.DebugAdapterInlineImplementation=Di=je([ee],Di);let ni=e.StackFrameFocus=class{constructor(L,se,ke){this.session=L,this.threadId=se,this.frameId=ke}};e.StackFrameFocus=ni=je([ee],ni);let $i=e.ThreadFocus=class{constructor(L,se){this.session=L,this.threadId=se}};e.ThreadFocus=$i=je([ee],$i);let fi=e.EvaluatableExpression=class{constructor(L,se){this.range=L,this.expression=se}};e.EvaluatableExpression=fi=je([ee],fi);var mi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let zi=e.InlineValueText=class{constructor(L,se){this.range=L,this.text=se}};e.InlineValueText=zi=je([ee],zi);let Wi=e.InlineValueVariableLookup=class{constructor(L,se,ke=!0){this.range=L,this.variableName=se,this.caseSensitiveLookup=ke}};e.InlineValueVariableLookup=Wi=je([ee],Wi);let ri=e.InlineValueEvaluatableExpression=class{constructor(L,se){this.range=L,this.expression=se}};e.InlineValueEvaluatableExpression=ri=je([ee],ri);let Hi=e.InlineValueContext=class{constructor(L,se){this.frameId=L,this.stoppedLocation=se}};e.InlineValueContext=Hi=je([ee],Hi);var Vi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let ji=e.FileSystemError=V=class extends Error{static FileExists(L){return new V(L,c.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(L){return new V(L,c.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(L){return new V(L,c.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(L){return new V(L,c.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(L){return new V(L,c.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(L){return new V(L,c.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(L,se=c.FileSystemProviderErrorCode.Unknown,ke){super(m.URI.isUri(L)?L.toString(!0):L),this.code=ke?.name??"Unknown",(0,c.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.FileSystemError=ji=V=je([ee],ji);let si=e.FoldingRange=class{constructor(L,se,ke){this.start=L,this.end=se,this.kind=ke}};e.FoldingRange=si=je([ee],si);var qi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(qi||(e.FoldingRangeKind=qi={}));var Ki;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ki||(e.CommentThreadCollapsibleState=Ki={}));var Ci;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Ci||(e.CommentMode=Ci={}));var Gi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var Xi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Xi||(e.CommentThreadState=Xi={}));class ln{constructor(L,se=[]){this.tokenTypes=L,this.tokenModifiers=se}}e.SemanticTokensLegend=ln;function Ii(U){return typeof U>"u"||(0,_.isStringArray)(U)}class gi{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let se=0,ke=L.tokenTypes.length;se<ke;se++)this._tokenTypeStrToInt.set(L.tokenTypes[se],se);for(let se=0,ke=L.tokenModifiers.length;se<ke;se++)this._tokenModifierStrToInt.set(L.tokenModifiers[se],se)}}push(L,se,ke,qe,Ye){if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(L,se,ke,qe,Ye);if(le.isRange(L)&&typeof se=="string"&&Ii(ke))return this._push(L,se,ke);throw(0,C.illegalArgument)()}_push(L,se,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const qe=L.start.line,Ye=L.start.character,rt=L.end.character-L.start.character,lt=this._tokenTypeStrToInt.get(se);let xt=0;if(ke)for(const jt of ke){if(!this._tokenModifierStrToInt.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const Xt=this._tokenModifierStrToInt.get(jt);xt|=1<<Xt>>>0}this._pushEncoded(qe,Ye,rt,lt,xt)}_pushEncoded(L,se,ke,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const xt=this._data.length/5|0;let jt=0,Xt=0;for(let Zt=0;Zt<xt;Zt++){let ti=this._data[5*Zt],Ai=this._data[5*Zt+1];ti===0?(ti=jt,Ai+=Xt):ti+=jt,this._data[5*Zt]=ti,this._data[5*Zt+1]=Ai,jt=ti,Xt=Ai}}let rt=L,lt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=L,this._prevChar=se}static _sortAndDeltaEncode(L){const se=[],ke=L.length/5|0;for(let lt=0;lt<ke;lt++)se[lt]=lt;se.sort((lt,xt)=>{const jt=L[5*lt],Xt=L[5*xt];if(jt===Xt){const Zt=L[5*lt+1],ti=L[5*xt+1];return Zt-ti}return jt-Xt});const qe=new Uint32Array(L.length);let Ye=0,rt=0;for(let lt=0;lt<ke;lt++){const xt=5*se[lt],jt=L[xt+0],Xt=L[xt+1],Zt=L[xt+2],ti=L[xt+3],Ai=L[xt+4],An=jt-Ye,Kn=An===0?Xt-rt:Xt,Ri=5*lt;qe[Ri+0]=An,qe[Ri+1]=Kn,qe[Ri+2]=Zt,qe[Ri+3]=ti,qe[Ri+4]=Ai,Ye=jt,rt=Xt}return qe}build(L){return this._dataIsSortedAndDeltaEncoded?new Ne(new Uint32Array(this._data),L):new Ne(gi._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=gi;class Ne{constructor(L,se){this.resultId=se,this.data=L}}e.SemanticTokens=Ne;class Yt{constructor(L,se,ke){this.start=L,this.deleteCount=se,this.data=ke}}e.SemanticTokensEdit=Yt;class Qi{constructor(L,se){this.resultId=se,this.edits=L}}e.SemanticTokensEdits=Qi;var ft;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(ft||(e.DebugConsoleMode=ft={}));let ki=e.QuickInputButtons=class{constructor(){}};ki.Back={iconPath:new Qt("arrow-left")},e.QuickInputButtons=ki=je([ee],ki);var Yi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Ti;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Ti||(e.InputBoxValidationSeverity=Ti={}));var Ji;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Ji||(e.ExtensionKind=Ji={}));class pi{static validate(L){if(typeof L.badge=="string"){let se=(0,A.nextCharLength)(L.badge,0);if(se<L.badge.length&&(se+=(0,A.nextCharLength)(L.badge,se)),L.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Qt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,se,ke){this.badge=L,this.tooltip=se,this.color=ke}}e.FileDecoration=pi;let Zi=e.ColorTheme=class{constructor(L){this.kind=L}};e.ColorTheme=Zi=je([ee],Zi);var en;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class Jt{static isNotebookRange(L){return L instanceof Jt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,se){if(L<0)throw(0,C.illegalArgument)("start must be positive");if(se<0)throw(0,C.illegalArgument)("end must be positive");L<=se?(this._start=L,this._end=se):(this._start=se,this._end=L)}with(L){let se=this._start,ke=this._end;return L.start!==void 0&&(se=L.start),L.end!==void 0&&(ke=L.end),se===this._start&&ke===this._end?this:new Jt(se,ke)}}e.NotebookRange=Jt;class ui{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(se=>ui.isNotebookCellData(se))}static isNotebookCellData(L){return!0}constructor(L,se,ke,qe,Ye,rt,lt){this.kind=L,this.value=se,this.languageId=ke,this.mime=qe,this.outputs=Ye??[],this.metadata=rt,this.executionSummary=lt,ui.validate(this)}}e.NotebookCellData=ui;class un{constructor(L){this.cells=L}}e.NotebookData=un;class Ht{static isNotebookCellOutputItem(L){return L instanceof Ht?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const se={name:L.name,message:L.message,stack:L.stack};return Ht.json(se,"application/vnd.code.notebook.error")}static stdout(L){return Ht.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Ht.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,se="application/octet-stream"){return new Ht(L,se)}static text(L,se=O.Mimes.text){const ke=Oe(Ht,n,"f",u).encode(String(L));return new Ht(ke,se)}static json(L,se="text/x-json"){const ke=JSON.stringify(L,void 0,"	");return Ht.text(ke,se)}constructor(L,se){this.data=L,this.mime=se;const ke=(0,O.normalizeMimeType)(se,!0);if(!ke)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.NotebookCellOutputItem=Ht,n=Ht,u={value:new TextEncoder};class vi{static isNotebookCellOutput(L){return L instanceof vi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,se=!1){const ke=new Set,qe=new Set;for(let Ye=0;Ye<L.length;Ye++){const rt=L[Ye],lt=(0,O.normalizeMimeType)(rt.mime);if(!ke.has(lt)||(0,g.isTextStreamMime)(lt)){ke.add(lt);continue}qe.add(Ye),se&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return qe.size===0?L:L.filter((Ye,rt)=>!qe.has(rt))}constructor(L,se,ke){this.items=vi.ensureUniqueMimeTypes(L,!0),typeof se=="string"?(this.id=se,this.metadata=ke):(this.id=(0,R.generateUuid)(),this.metadata=se??ke)}}e.NotebookCellOutput=vi;var tn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class dn{constructor(L,se){this.text=L,this.alignment=se}}e.NotebookCellStatusBarItem=dn;var on;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var re;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(re||(e.NotebookControllerAffinity2=re={}));class me{constructor(L,se=[]){this.uri=L,this.provides=(0,i.asArray)(se)}}e.NotebookRendererScript=me;class Le{constructor(L){this.label=L}}e.NotebookKernelSourceAction=Le;let nt=e.TimelineItem=class{constructor(L,se){this.label=L,this.timestamp=se}};e.TimelineItem=nt=je([ee],nt);var Dt;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Dt||(e.ExtensionMode=Dt={}));var At;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(At||(e.ExtensionRuntime=At={}));var mn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(mn||(e.StandardTokenType=mn={}));class Mn{constructor(L,se){this.ranges=L,this.wordPattern=se}}e.LinkedEditingRanges=Mn;class Nn{constructor(L){this._autoForwardAction=L}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Nn;var gn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(gn||(e.TestResultState=gn={}));var pn;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(pn||(e.TestRunProfileKind=pn={}));let hn=e.TestRunRequest=class{constructor(L=void 0,se=void 0,ke=void 0,qe=!1){this.include=L,this.exclude=se,this.profile=ke,this.continuous=qe}};e.TestRunRequest=hn=je([ee],hn);let vn=e.TestRunRequest2=class extends hn{};e.TestRunRequest2=vn=je([ee],vn);let En=e.TestMessage=x=class{static diff(L,se,ke){const qe=new x(L);return qe.expectedOutput=se,qe.actualOutput=ke,qe}constructor(L){this.message=L}};e.TestMessage=En=x=je([ee],En);let wn=e.TestTag=class{constructor(L){this.id=L}};e.TestTag=wn=je([ee],wn);let Pi=e.CoveredCount=class{constructor(L,se){this.covered=L,this.total=se}};e.CoveredCount=Pi=je([ee],Pi);let bn=e.FileCoverage=W=class{static fromDetails(L,se){const ke=new Pi(0,0),qe=new Pi(0,0),Ye=new Pi(0,0);for(const lt of se)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const xt of lt.branches)qe.total+=1,qe.covered+=xt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const rt=new W(L,ke,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return rt.detailedCoverage=se,rt}constructor(L,se,ke,qe){this.uri=L,this.statementCoverage=se,this.branchCoverage=ke,this.functionCoverage=qe}};e.FileCoverage=bn=W=je([ee],bn);let _n=e.StatementCoverage=class{constructor(L,se,ke=[]){this.executionCount=L,this.location=se,this.branches=ke}};e.StatementCoverage=_n=je([ee],_n);let Sn=e.BranchCoverage=class{constructor(L,se){this.executionCount=L,this.location=se}};e.BranchCoverage=Sn=je([ee],Sn);let yn=e.FunctionCoverage=class{constructor(L,se){this.executionCount=L,this.location=se}};e.FunctionCoverage=yn=je([ee],yn);var Dn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Dn||(e.ExternalUriOpenerPriority=Dn={}));var Cn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Un{constructor(L,se,ke,qe,Ye,rt){this.kind=L,this.name=se,this.detail=ke,this.uri=qe,this.range=Ye,this.selectionRange=rt}}e.TypeHierarchyItem=Un;class xn{constructor(L){this.uri=L}}e.TextTabInput=xn;class Bn{constructor(L,se){this.original=L,this.modified=se}}e.TextDiffTabInput=Bn;class $n{constructor(L,se,ke,qe){this.base=L,this.input1=se,this.input2=ke,this.result=qe}}e.TextMergeTabInput=$n;class zn{constructor(L,se){this.uri=L,this.viewType=se}}e.CustomEditorTabInput=zn;class Wn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=Wn;class Hn{constructor(L,se){this.uri=L,this.notebookType=se}}e.NotebookEditorTabInput=Hn;class Vn{constructor(L,se,ke){this.original=L,this.modified=se,this.notebookType=ke}}e.NotebookDiffEditorTabInput=Vn;class jn{constructor(){}}e.TerminalEditorTabInput=jn;class qn{constructor(L,se){this.uri=L,this.inputBoxUri=se}}e.InteractiveWindowInput=qn;var kn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Tn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Tn||(e.InteractiveSessionCopyKind=Tn={}));var Pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}))}),define(Ae[103],Re([1,0,49,15,13,271,136,7,18]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function R(g,d){d?m.set(g,d):m.delete(g)}e.setWordDefinitionFor=R;function b(g){return m.get(g)}class c extends M.MirrorTextModel{constructor(d,t,l,h,S,I,v,n){super(t,l,h,S),this._proxy=d,this._languageId=I,this._isDirty=v,this.notebook=n,this._isDisposed=!1}dispose(){(0,i.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,_.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===C.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},save(){return d._save()},getText(t){return t?d._getTextInRange(t):d.getText()},get eol(){return d._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(t){return d._lineAt(t)},offsetAt(t){return d._offsetAt(t)},positionAt(t){return d._positionAt(t)},validateRange(t){return d._validateRange(t)},validatePosition(t){return d._validatePosition(t)},getWordRangeAtPosition(t,l){return d._getWordRangeAtPosition(t,l)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,i.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,i.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const t=this._validateRange(d);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const l=this._eol,h=t.start.line,S=t.end.line,I=[];I.push(this._lines[h].substring(t.start.character));for(let v=h+1;v<S;v++)I.push(this._lines[v]);return I.push(this._lines[S].substring(0,t.end.character)),I.join(l)}_lineAt(d){let t;if(d instanceof A.Position?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this._lines[t],t===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(d),l=this._lines[t.index].length;return new A.Position(t.index,Math.min(t.remainder,l))}_validateRange(d){if(!(d instanceof A.Range))throw new Error("Invalid argument");const t=this._validatePosition(d.start),l=this._validatePosition(d.end);return t===d.start&&l===d.end?d:new A.Range(t.line,t.character,l.line,l.character)}_validatePosition(d){if(!(d instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:t,character:l}=d,h=!1;if(t<0)t=0,l=0,h=!0;else if(t>=this._lines.length)t=this._lines.length-1,l=this._lines[t].length,h=!0;else{const S=this._lines[t].length;l<0?(l=0,h=!0):l>S&&(l=S,h=!0)}return h?new A.Position(t,l):d}_getWordRangeAtPosition(d,t){const l=this._validatePosition(d);if(!t)t=b(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const h=(0,O.getWordAtText)(l.character+1,(0,O.ensureValidWordDefinition)(t),this._lines[l.line],0);if(h)return new A.Range(l.line,h.startColumn-1,l.line,h.endColumn-1)}}e.ExtHostDocumentData=c;class p{constructor(d,t,l){this._line=d,this._text=t,this._isLastLine=l}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(Ae[202],Re([1,0,7,17,5]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=e.ExtHostTheming=class{constructor(A){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let _;switch(A){case"light":_=i.ColorThemeKind.Light;break;case"hcDark":_=i.ColorThemeKind.HighContrast;break;case"hcLight":_=i.ColorThemeKind.HighContrastLight;break;default:_=i.ColorThemeKind.Dark}this._actual=new i.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=M=je([We(0,C.IExtHostRpcService)],M)}),define(Ae[8],Re([1,0,18,24,120,203,89,28,116,68,67,26,9,2,44,78,94,100,99,74,45,56,199,7]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Pe){function we(Q){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:Ge,positionColumn:ze}=Q,et=new u.Position(Fe-1,xe-1),bt=new u.Position(Ge-1,ze-1);return new u.Selection(et,bt)}Pe.to=we;function ve(Q){const{anchor:Fe,active:xe}=Q;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Pe.from=ve})(r||(e.Selection=r={}));var a;(function(Pe){function we(Q){if(!Q)return;const{start:Fe,end:xe}=Q;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Pe.from=we;function ve(Q){if(!Q)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:Ge,endColumn:ze}=Q;return new u.Range(Fe-1,xe-1,Ge-1,ze-1)}Pe.to=ve})(a||(e.Range=a={}));var E;(function(Pe){function we(ve){switch(ve){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Pe.to=we})(E||(e.TokenType=E={}));var D;(function(Pe){function we(Q){return new u.Position(Q.lineNumber-1,Q.column-1)}Pe.to=we;function ve(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Pe.from=ve})(D||(e.Position=D={}));var f;(function(Pe){function we(Fe,xe,Ge){return(0,i.coalesce)((0,i.asArray)(Fe).map(ze=>ve(ze,xe,Ge)))}Pe.from=we;function ve(Fe,xe,Ge){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ge?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:Q(Fe.scheme,xe),pattern:Y.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ge?.isBuiltin}}function Q(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(f||(e.DocumentSelector=f={}));var T;(function(Pe){function we(Q){switch(Q){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Pe.from=we;function ve(Q){switch(Q){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Pe.to=ve})(T||(e.DiagnosticTag=T={}));var w;(function(Pe){function we(Q){let Fe;return Q.code&&((0,c.isString)(Q.code)||(0,c.isNumber)(Q.code)?Fe=String(Q.code):Fe={value:String(Q.code.value),target:Q.code.target}),{...a.from(Q.range),message:Q.message,source:Q.source,code:Fe,severity:s.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(o.from),tags:Array.isArray(Q.tags)?(0,i.coalesce)(Q.tags.map(T.from)):void 0}}Pe.from=we;function ve(Q){const Fe=new u.Diagnostic(a.to(Q),Q.message,s.to(Q.severity));return Fe.source=Q.source,Fe.code=(0,c.isString)(Q.code)?Q.code:Q.code?.value,Fe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(o.to),Fe.tags=Q.tags&&(0,i.coalesce)(Q.tags.map(T.to)),Fe}Pe.to=ve})(w||(e.Diagnostic=w={}));var o;(function(Pe){function we(Q){return{...a.from(Q.location.range),message:Q.message,resource:Q.location.uri}}Pe.from=we;function ve(Q){return new u.DiagnosticRelatedInformation(new u.Location(Q.resource,a.to(Q)),Q.message)}Pe.to=ve})(o||(e.DiagnosticRelatedInformation=o={}));var s;(function(Pe){function we(Q){switch(Q){case u.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=we;function ve(Q){switch(Q){case t.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Pe.to=ve})(s||(e.DiagnosticSeverity=s={}));var F;(function(Pe){function we(Q){return typeof Q=="number"&&Q>=u.ViewColumn.One?Q-1:Q===u.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Pe.from=we;function ve(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=ve})(F||(e.ViewColumn=F={}));function B(Pe){return typeof Pe.range<"u"}function G(Pe){return Pe.length===0?!0:!!B(Pe[0])}e.isDecorationOptionsArr=G;var q;(function(Pe){function we(ze){return ze.map(Pe.from)}Pe.fromMany=we;function ve(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function Q(ze){let et;if(ve(ze)){const{language:vt,value:ot}=ze;et={value:"```"+vt+`
`+ot+"\n```\n"}}else u.MarkdownString.isMarkdownString(ze)?et={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?et={value:ze}:et={value:""};const bt=Object.create(null);et.uris=bt;const Pt=vt=>{try{let ot=p.URI.parse(vt,!0);ot=ot.with({query:Fe(ot.query,bt)}),bt[vt]=ot}catch{}return""},kt=new _.marked.Renderer;return kt.link=Pt,kt.image=vt=>typeof vt=="string"?Pt(O.parseHrefAndDimensions(vt).href):"",(0,_.marked)(et.value,{renderer:kt}),et}Pe.from=Q;function Fe(ze,et){if(!ze)return ze;let bt;try{bt=(0,m.parse)(ze)}catch{}if(!bt)return ze;let Pt=!1;return bt=(0,b.cloneAndChange)(bt,kt=>{if(p.URI.isUri(kt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[vt]=kt,Pt=!0,vt}else return}),Pt?JSON.stringify(bt):ze}function xe(ze){const et=new u.MarkdownString(ze.value,ze.supportThemeIcons);return et.isTrusted=ze.isTrusted,et.supportHtml=ze.supportHtml,et.baseUri=ze.baseUri?p.URI.from(ze.baseUri):void 0,et}Pe.to=xe;function Ge(ze){if(ze)return typeof ze=="string"?ze:Pe.from(ze)}Pe.fromStrict=Ge})(q||(e.MarkdownString=q={}));function $(Pe){return G(Pe)?Pe.map(we=>({range:a.from(we.range),hoverMessage:Array.isArray(we.hoverMessage)?q.fromMany(we.hoverMessage):we.hoverMessage?q.from(we.hoverMessage):void 0,renderOptions:we.renderOptions})):Pe.map(we=>({range:a.from(we)}))}e.fromRangeOrRangeWithMessage=$;function N(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?p.URI.file(Pe):Pe}e.pathOrURIToURI=N;var V;(function(Pe){function we(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?N(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Pe.from=we})(V||(e.ThemableDecorationAttachmentRenderOptions=V={}));var x;(function(Pe){function we(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?N(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?V.from(ve.before):void 0,after:ve.after?V.from(ve.after):void 0}}Pe.from=we})(x||(e.ThemableDecorationRenderOptions=x={}));var W;(function(Pe){function we(ve){if(typeof ve>"u")return ve;switch(ve){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=we})(W||(e.DecorationRangeBehavior=W={}));var ee;(function(Pe){function we(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?W.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?x.from(ve.light):void 0,dark:ve.dark?x.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?N(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?V.from(ve.before):void 0,after:ve.after?V.from(ve.after):void 0}}Pe.from=we})(ee||(e.DecorationRenderOptions=ee={}));var Ie;(function(Pe){function we(Q){return{text:Q.newText,eol:Q.newEol&&it.from(Q.newEol),range:a.from(Q.range)}}Pe.from=we;function ve(Q){const Fe=new u.TextEdit(a.to(Q.range),Q.text);return Fe.newEol=typeof Q.eol>"u"?void 0:it.to(Q.eol),Fe}Pe.to=ve})(Ie||(e.TextEdit=Ie={}));var oe;(function(Pe){function we(Q,Fe){const xe={edits:[]};if(Q instanceof u.WorkspaceEdit){const Ge=new A.ResourceSet;for(const ze of Q._allEntries())ze._type===1&&p.URI.isUri(ze.to)&&ze.from===void 0&&Ge.add(ze.to);for(const ze of Q._allEntries())if(ze._type===1){let et;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?et={type:"base64",value:(0,C.encodeBase64)(C.VSBuffer.wrap(ze.options.contents))}:et={type:"dataTransferItem",id:ze.options.contents._itemId}),xe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:et},metadata:ze.metadata})}else ze._type===2?xe.edits.push({resource:ze.uri,textEdit:Ie.from(ze.edit),versionId:Ge.has(ze.uri)?void 0:Fe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?xe.edits.push({resource:ze.uri,textEdit:{range:a.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Ge.has(ze.uri)?void 0:Fe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?xe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&xe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(mt.from)}})}return xe}Pe.from=we;function ve(Q){const Fe=new u.WorkspaceEdit,xe=new A.ResourceMap;for(const Ge of Q.edits)if(Ge.textEdit){const ze=Ge,et=p.URI.revive(ze.resource),bt=a.to(ze.textEdit.range),Pt=ze.textEdit.text,kt=ze.textEdit.insertAsSnippet;let vt;kt?vt=u.SnippetTextEdit.replace(bt,new u.SnippetString(Pt)):vt=u.TextEdit.replace(bt,Pt);const ot=xe.get(et);ot?ot.push(vt):xe.set(et,[vt])}else Fe.renameFile(p.URI.revive(Ge.oldResource),p.URI.revive(Ge.newResource),Ge.options);for(const[Ge,ze]of xe)Fe.set(Ge,ze);return Fe}Pe.to=ve})(oe||(e.WorkspaceEdit=oe={}));var ue;(function(Pe){const we=Object.create(null);we[u.SymbolKind.File]=0,we[u.SymbolKind.Module]=1,we[u.SymbolKind.Namespace]=2,we[u.SymbolKind.Package]=3,we[u.SymbolKind.Class]=4,we[u.SymbolKind.Method]=5,we[u.SymbolKind.Property]=6,we[u.SymbolKind.Field]=7,we[u.SymbolKind.Constructor]=8,we[u.SymbolKind.Enum]=9,we[u.SymbolKind.Interface]=10,we[u.SymbolKind.Function]=11,we[u.SymbolKind.Variable]=12,we[u.SymbolKind.Constant]=13,we[u.SymbolKind.String]=14,we[u.SymbolKind.Number]=15,we[u.SymbolKind.Boolean]=16,we[u.SymbolKind.Array]=17,we[u.SymbolKind.Object]=18,we[u.SymbolKind.Key]=19,we[u.SymbolKind.Null]=20,we[u.SymbolKind.EnumMember]=21,we[u.SymbolKind.Struct]=22,we[u.SymbolKind.Event]=23,we[u.SymbolKind.Operator]=24,we[u.SymbolKind.TypeParameter]=25;function ve(Fe){return typeof we[Fe]=="number"?we[Fe]:6}Pe.from=ve;function Q(Fe){for(const xe in we)if(we[xe]===Fe)return Number(xe);return u.SymbolKind.Property}Pe.to=Q})(ue||(e.SymbolKind=ue={}));var X;(function(Pe){function we(Q){switch(Q){case u.SymbolTag.Deprecated:return 1}}Pe.from=we;function ve(Q){switch(Q){case 1:return u.SymbolTag.Deprecated}}Pe.to=ve})(X||(e.SymbolTag=X={}));var le;(function(Pe){function we(Q){return{name:Q.name,kind:ue.from(Q.kind),tags:Q.tags&&Q.tags.map(X.from),containerName:Q.containerName,location:K.from(Q.location)}}Pe.from=we;function ve(Q){const Fe=new u.SymbolInformation(Q.name,ue.to(Q.kind),Q.containerName,K.to(Q.location));return Fe.tags=Q.tags&&Q.tags.map(X.to),Fe}Pe.to=ve})(le||(e.WorkspaceSymbol=le={}));var De;(function(Pe){function we(Q){const Fe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:a.from(Q.range),selectionRange:a.from(Q.selectionRange),kind:ue.from(Q.kind),tags:Q.tags?.map(X.from)??[]};return Q.children&&(Fe.children=Q.children.map(we)),Fe}Pe.from=we;function ve(Q){const Fe=new u.DocumentSymbol(Q.name,Q.detail,ue.to(Q.kind),a.to(Q.range),a.to(Q.selectionRange));return(0,i.isNonEmptyArray)(Q.tags)&&(Fe.tags=Q.tags.map(X.to)),Q.children&&(Fe.children=Q.children.map(ve)),Fe}Pe.to=ve})(De||(e.DocumentSymbol=De={}));var Te;(function(Pe){function we(Q){const Fe=new u.CallHierarchyItem(ue.to(Q.kind),Q.name,Q.detail||"",p.URI.revive(Q.uri),a.to(Q.range),a.to(Q.selectionRange));return Fe._sessionId=Q._sessionId,Fe._itemId=Q._itemId,Fe}Pe.to=we;function ve(Q,Fe,xe){if(Fe=Fe??Q._sessionId,xe=xe??Q._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:Q.name,detail:Q.detail,kind:ue.from(Q.kind),uri:Q.uri,range:a.from(Q.range),selectionRange:a.from(Q.selectionRange),tags:Q.tags?.map(X.from)}}Pe.from=ve})(Te||(e.CallHierarchyItem=Te={}));var Ee;(function(Pe){function we(ve){return new u.CallHierarchyIncomingCall(Te.to(ve.from),ve.fromRanges.map(Q=>a.to(Q)))}Pe.to=we})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var P;(function(Pe){function we(ve){return new u.CallHierarchyOutgoingCall(Te.to(ve.to),ve.fromRanges.map(Q=>a.to(Q)))}Pe.to=we})(P||(e.CallHierarchyOutgoingCall=P={}));var K;(function(Pe){function we(Q){return{range:Q.range&&a.from(Q.range),uri:Q.uri}}Pe.from=we;function ve(Q){return new u.Location(p.URI.revive(Q.uri),a.to(Q.range))}Pe.to=ve})(K||(e.location=K={}));var he;(function(Pe){function we(Q){const Fe=Q,xe=Q;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:a.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}Pe.from=we;function ve(Q){return{targetUri:p.URI.revive(Q.uri),targetRange:a.to(Q.range),targetSelectionRange:Q.targetSelectionRange?a.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?a.to(Q.originSelectionRange):void 0}}Pe.to=ve})(he||(e.DefinitionLink=he={}));var ye;(function(Pe){function we(Q){return{range:a.from(Q.range),contents:q.fromMany(Q.contents)}}Pe.from=we;function ve(Q){return new u.Hover(Q.contents.map(q.to),a.to(Q.range))}Pe.to=ve})(ye||(e.Hover=ye={}));var be;(function(Pe){function we(Q){return{range:a.from(Q.range),expression:Q.expression}}Pe.from=we;function ve(Q){return new u.EvaluatableExpression(a.to(Q.range),Q.expression)}Pe.to=ve})(be||(e.EvaluatableExpression=be={}));var ge;(function(Pe){function we(Q){if(Q instanceof u.InlineValueText)return{type:"text",range:a.from(Q.range),text:Q.text};if(Q instanceof u.InlineValueVariableLookup)return{type:"variable",range:a.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=we;function ve(Q){switch(Q.type){case"text":return{range:a.to(Q.range),text:Q.text};case"variable":return{range:a.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:a.to(Q.range),expression:Q.expression}}}Pe.to=ve})(ge||(e.InlineValue=ge={}));var Ce;(function(Pe){function we(Q){return{frameId:Q.frameId,stoppedLocation:a.from(Q.stoppedLocation)}}Pe.from=we;function ve(Q){return new u.InlineValueContext(Q.frameId,a.to(Q.stoppedLocation))}Pe.to=ve})(Ce||(e.InlineValueContext=Ce={}));var ae;(function(Pe){function we(Q){return{range:a.from(Q.range),kind:Q.kind}}Pe.from=we;function ve(Q){return new u.DocumentHighlight(a.to(Q.range),Q.kind)}Pe.to=ve})(ae||(e.DocumentHighlight=ae={}));var de;(function(Pe){function we(ve){switch(ve){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Pe.to=we})(de||(e.CompletionTriggerKind=de={}));var Z;(function(Pe){function we(ve){return{triggerKind:de.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Pe.to=we})(Z||(e.CompletionContext=Z={}));var ne;(function(Pe){function we(Q){switch(Q){case u.CompletionItemTag.Deprecated:return 1}}Pe.from=we;function ve(Q){switch(Q){case 1:return u.CompletionItemTag.Deprecated}}Pe.to=ve})(ne||(e.CompletionItemTag=ne={}));var k;(function(Pe){const we=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ve(xe){return we.get(xe)??9}Pe.from=ve;const Q=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Fe(xe){return Q.get(xe)??u.CompletionItemKind.Property}Pe.to=Fe})(k||(e.CompletionItemKind=k={}));var z;(function(Pe){function we(ve,Q){const Fe=new u.CompletionItem(ve.label);return Fe.insertText=ve.insertText,Fe.kind=k.to(ve.kind),Fe.tags=ve.tags?.map(ne.to),Fe.detail=ve.detail,Fe.documentation=O.isMarkdownString(ve.documentation)?q.to(ve.documentation):ve.documentation,Fe.sortText=ve.sortText,Fe.filterText=ve.filterText,Fe.preselect=ve.preselect,Fe.commitCharacters=ve.commitCharacters,g.Range.isIRange(ve.range)?Fe.range=a.to(ve.range):typeof ve.range=="object"&&(Fe.range={inserting:a.to(ve.range.insert),replacing:a.to(ve.range.replace)}),Fe.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Fe.insertText=new u.SnippetString(ve.insertText):(Fe.insertText=ve.insertText,Fe.textEdit=Fe.range instanceof u.Range?new u.TextEdit(Fe.range,Fe.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ve.additionalTextEdits.map(xe=>Ie.to(xe))),Fe.command=Q&&ve.command?Q.fromInternal(ve.command):void 0,Fe}Pe.to=we})(z||(e.CompletionItem=z={}));var H;(function(Pe){function we(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:q.fromStrict(Q.documentation)}}Pe.from=we;function ve(Q){return{label:Q.label,documentation:O.isMarkdownString(Q.documentation)?q.to(Q.documentation):Q.documentation}}Pe.to=ve})(H||(e.ParameterInformation=H={}));var j;(function(Pe){function we(Q){return{label:Q.label,documentation:q.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.from):[],activeParameter:Q.activeParameter}}Pe.from=we;function ve(Q){return{label:Q.label,documentation:O.isMarkdownString(Q.documentation)?q.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.to):[],activeParameter:Q.activeParameter}}Pe.to=ve})(j||(e.SignatureInformation=j={}));var ce;(function(Pe){function we(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(j.from):[]}}Pe.from=we;function ve(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(j.to):[]}}Pe.to=ve})(ce||(e.SignatureHelp=ce={}));var pe;(function(Pe){function we(ve,Q){const Fe=new u.InlayHint(D.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(ie.to.bind(void 0,ve)),Q.kind&&Se.to(Q.kind));return Fe.textEdits=Q.textEdits&&Q.textEdits.map(Ie.to),Fe.tooltip=O.isMarkdownString(Q.tooltip)?q.to(Q.tooltip):Q.tooltip,Fe.paddingLeft=Q.paddingLeft,Fe.paddingRight=Q.paddingRight,Fe}Pe.to=we})(pe||(e.InlayHint=pe={}));var ie;(function(Pe){function we(ve,Q){const Fe=new u.InlayHintLabelPart(Q.label);return Fe.tooltip=O.isMarkdownString(Q.tooltip)?q.to(Q.tooltip):Q.tooltip,d.Command.is(Q.command)&&(Fe.command=ve.fromInternal(Q.command)),Q.location&&(Fe.location=K.to(Q.location)),Fe}Pe.to=we})(ie||(e.InlayHintLabelPart=ie={}));var Se;(function(Pe){function we(Q){return Q}Pe.from=we;function ve(Q){return Q}Pe.to=ve})(Se||(e.InlayHintKind=Se={}));var _e;(function(Pe){function we(Q){return{range:a.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Pe.from=we;function ve(Q){let Fe;if(Q.url)try{Fe=typeof Q.url=="string"?p.URI.parse(Q.url,!0):p.URI.revive(Q.url)}catch{}return new u.DocumentLink(a.to(Q.range),Fe)}Pe.to=ve})(_e||(e.DocumentLink=_e={}));var Be;(function(Pe){function we(Q){const Fe=new u.ColorPresentation(Q.label);return Q.textEdit&&(Fe.textEdit=Ie.to(Q.textEdit)),Q.additionalTextEdits&&(Fe.additionalTextEdits=Q.additionalTextEdits.map(xe=>Ie.to(xe))),Fe}Pe.to=we;function ve(Q){return{label:Q.label,textEdit:Q.textEdit?Ie.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Fe=>Ie.from(Fe)):void 0}}Pe.from=ve})(Be||(e.ColorPresentation=Be={}));var He;(function(Pe){function we(Q){return new u.Color(Q[0],Q[1],Q[2],Q[3])}Pe.to=we;function ve(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Pe.from=ve})(He||(e.Color=He={}));var Ze;(function(Pe){function we(Q){return{range:a.from(Q.range)}}Pe.from=we;function ve(Q){return new u.SelectionRange(a.to(Q.range))}Pe.to=ve})(Ze||(e.SelectionRange=Ze={}));var Xe;(function(Pe){function we(ve){switch(ve){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Pe.to=we})(Xe||(e.TextDocumentSaveReason=Xe={}));var Ke;(function(Pe){function we(Q){switch(Q){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=we;function ve(Q){switch(Q){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Pe.to=ve})(Ke||(e.TextEditorLineNumbersStyle=Ke={}));var it;(function(Pe){function we(Q){if(Q===u.EndOfLine.CRLF)return 1;if(Q===u.EndOfLine.LF)return 0}Pe.from=we;function ve(Q){if(Q===1)return u.EndOfLine.CRLF;if(Q===0)return u.EndOfLine.LF}Pe.to=ve})(it||(e.EndOfLine=it={}));var st;(function(Pe){function we(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=we})(st||(e.ProgressLocation=st={}));var tt;(function(Pe){function we(Q){const Fe={start:Q.start+1,end:Q.end+1};return Q.kind&&(Fe.kind=Me.from(Q.kind)),Fe}Pe.from=we;function ve(Q){const Fe={start:Q.start-1,end:Q.end-1};return Q.kind&&(Fe.kind=Me.to(Q.kind)),Fe}Pe.to=ve})(tt||(e.FoldingRange=tt={}));var Me;(function(Pe){function we(Q){if(Q)switch(Q){case u.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Pe.from=we;function ve(Q){if(Q)switch(Q.value){case d.FoldingRangeKind.Comment.value:return u.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports.value:return u.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region.value:return u.FoldingRangeKind.Region}}Pe.to=ve})(Me||(e.FoldingRangeKind=Me={}));var dt;(function(Pe){function we(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?a.from(ve.selection):void 0,override:typeof ve.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=we})(dt||(e.TextEditorOpenOptions=dt={}));var Y;(function(Pe){function we(xe){return xe instanceof u.RelativePattern?xe.toJSON():typeof xe=="string"?xe:ve(xe)||Q(xe)?new u.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Pe.from=we;function ve(xe){const Ge=xe;return Ge?p.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function Q(xe){const Ge=xe;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new u.RelativePattern(p.URI.revive(xe.baseUri),xe.pattern)}Pe.to=Fe})(Y||(e.GlobPattern=Y={}));var J;(function(Pe){function we(ve){if(ve){if(Array.isArray(ve))return ve.map(we);if(typeof ve=="string")return ve;{const Q=ve;return{language:Q.language,scheme:Q.scheme,pattern:Y.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}Pe.from=we})(J||(e.LanguageSelector=J={}));var fe;(function(Pe){function we(Q){return{start:Q.start,end:Q.end}}Pe.from=we;function ve(Q){return new u.NotebookRange(Q.start,Q.end)}Pe.to=ve})(fe||(e.NotebookRange=fe={}));var Ue;(function(Pe){function we(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Pe.to=we;function ve(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}Pe.from=ve})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ve;(function(Pe){function we(ve){if(ve===S.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(ve===S.NotebookCellExecutionState.Pending)return;if(ve===S.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Pe.to=we})(Ve||(e.NotebookCellExecutionState=Ve={}));var $e;(function(Pe){function we(Q){switch(Q){case u.NotebookCellKind.Markup:return S.CellKind.Markup;case u.NotebookCellKind.Code:default:return S.CellKind.Code}}Pe.from=we;function ve(Q){switch(Q){case S.CellKind.Markup:return u.NotebookCellKind.Markup;case S.CellKind.Code:default:return u.NotebookCellKind.Code}}Pe.to=ve})($e||(e.NotebookCellKind=$e={}));var Je;(function(Pe){function we(Q){const Fe={metadata:Q.metadata??Object.create(null),cells:[]};for(const xe of Q.cells)u.NotebookCellData.validate(xe),Fe.cells.push(mt.from(xe));return Fe}Pe.from=we;function ve(Q){const Fe=new u.NotebookData(Q.cells.map(mt.to));return(0,c.isEmptyObject)(Q.metadata)||(Fe.metadata=Q.metadata),Fe}Pe.to=ve})(Je||(e.NotebookData=Je={}));var mt;(function(Pe){function we(Q){return{cellKind:$e.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Ue.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Ct.from):[]}}Pe.from=we;function ve(Q){return new u.NotebookCellData($e.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Ct.to):void 0,Q.metadata,Q.internalMetadata?Ue.to(Q.internalMetadata):void 0)}Pe.to=ve})(mt||(e.NotebookCellData=mt={}));var _t;(function(Pe){function we(Q){return{mime:Q.mime,valueBytes:C.VSBuffer.wrap(Q.data)}}Pe.from=we;function ve(Q){return new u.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}Pe.to=ve})(_t||(e.NotebookCellOutputItem=_t={}));var Ct;(function(Pe){function we(Q){return{outputId:Q.id,items:Q.items.map(_t.from),metadata:Q.metadata}}Pe.from=we;function ve(Q){const Fe=Q.items.map(_t.to);return new u.NotebookCellOutput(Fe,Q.outputId,Q.metadata)}Pe.to=ve})(Ct||(e.NotebookCellOutput=Ct={}));var qt;(function(Pe){function we(Fe){return Q(Fe)?{include:(0,c.withNullAsUndefined)(Y.from(Fe.include)),exclude:(0,c.withNullAsUndefined)(Y.from(Fe.exclude))}:(0,c.withNullAsUndefined)(Y.from(Fe))}Pe.from=we;function ve(Fe){return Q(Fe)?{include:Y.to(Fe.include),exclude:Y.to(Fe.exclude)}:Y.to(Fe)}Pe.to=ve;function Q(Fe){const xe=Fe;return xe?!(0,c.isUndefinedOrNull)(xe.include)&&!(0,c.isUndefinedOrNull)(xe.exclude):!1}})(qt||(e.NotebookExclusiveDocumentPattern=qt={}));var Bt;(function(Pe){function we(ve,Q,Fe){const xe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(xe,Fe),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Pe.from=we})(Bt||(e.NotebookStatusBarItem=Bt={}));var St;(function(Pe){function we(ve,Q,Fe){const xe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:Q.toInternal(xe,Fe),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Pe.from=we})(St||(e.NotebookKernelSourceAction=St={}));var $t;(function(Pe){function we(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Pe.from=we})($t||(e.NotebookDocumentContentOptions=$t={}));var Ft;(function(Pe){function we(Q){return{uri:Q.uri,provides:Q.provides}}Pe.from=we;function ve(Q){return new u.NotebookRendererScript(p.URI.revive(Q.uri),Q.provides)}Pe.to=ve})(Ft||(e.NotebookRendererScript=Ft={}));var Vt;(function(Pe){function we(Q){return{message:q.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location&&{range:a.from(Q.location.range),uri:Q.location.uri}}}Pe.from=we;function ve(Q){const Fe=new u.TestMessage(typeof Q.message=="string"?Q.message:q.to(Q.message));return Fe.actualOutput=Q.actual,Fe.expectedOutput=Q.expected,Fe.location=Q.location?K.to(Q.location):void 0,Fe}Pe.to=ve})(Vt||(e.TestMessage=Vt={}));var Rt;(function(Pe){Pe.namespace=v.namespaceTestTag,Pe.denamespace=v.denamespaceTestTag})(Rt||(e.TestTag=Rt={}));var Lt;(function(Pe){function we(Q){const Fe=(0,l.getPrivateApiFor)(Q).controllerId;return{extId:I.TestId.fromExtHostTestItem(Q,Fe).toString(),label:Q.label,uri:p.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(xe=>Rt.namespace(Fe,xe.id)),range:g.Range.lift(a.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&q.fromStrict(Q.error)||null}}Pe.from=we;function ve(Q){return{parent:void 0,error:void 0,id:I.TestId.fromString(Q.extId).localId,label:Q.label,uri:p.URI.revive(Q.uri),tags:(Q.tags||[]).map(Fe=>{const{tagId:xe}=Rt.denamespace(Fe);return new u.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}Pe.toPlain=ve})(Lt||(e.TestItem=Lt={})),function(Pe){function we(Q){return{id:Q.id}}Pe.from=we;function ve(Q){return new u.TestTag(Q.id)}Pe.to=ve}(Rt||(e.TestTag=Rt={}));var zt;(function(Pe){const we=(Q,Fe)=>{const xe=[];for(const[ze,et]of Fe)I.TestId.compare(et.item.extId,ze)===2&&(Fe.delete(ze),xe.push(et));const Ge={...Lt.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(et=>et.type===0).map(Vt.to)})),children:xe.map(ze=>we(ze,Fe))};for(const ze of Ge.children)ze.parent=Ge;return Ge};function ve(Q){const Fe=[],xe=new Map;for(const Ge of Q.items){xe.set(Ge.item.extId,Ge);const ze=I.TestId.root(Ge.item.extId);Q.request.targets.some(et=>et.controllerId===ze&&et.testIds.includes(Ge.item.extId))&&Fe.push(Ge)}return{completedAt:Q.completedAt,results:Fe.map(Ge=>we(Ge,xe))}}Pe.to=ve})(zt||(e.TestResults=zt={}));var at;(function(Pe){function we(xe){return{covered:xe.covered,total:xe.covered}}function ve(xe){return"line"in xe?D.from(xe):a.from(xe)}function Q(xe){return"branches"in xe?{count:xe.executionCount,location:ve(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ve(Ge.location)})):void 0}:{type:0,count:xe.executionCount,location:ve(xe.location)}}Pe.fromDetailed=Q;function Fe(xe){return{uri:xe.uri,statement:we(xe.statementCoverage),branch:xe.branchCoverage&&we(xe.branchCoverage),function:xe.functionCoverage&&we(xe.functionCoverage),details:xe.detailedCoverage?.map(Q)}}Pe.fromFile=Fe})(at||(e.TestCoverage=at={}));var ht;(function(Pe){function we(ve){switch(ve){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Pe.to=we})(ht||(e.CodeActionTriggerKind=ht={}));var Mt;(function(Pe){function we(Q){const Fe=new u.TypeHierarchyItem(ue.to(Q.kind),Q.name,Q.detail||"",p.URI.revive(Q.uri),a.to(Q.range),a.to(Q.selectionRange));return Fe._sessionId=Q._sessionId,Fe._itemId=Q._itemId,Fe}Pe.to=we;function ve(Q,Fe,xe){if(Fe=Fe??Q._sessionId,xe=xe??Q._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:ue.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:a.from(Q.range),selectionRange:a.from(Q.selectionRange),tags:Q.tags?.map(X.from)}}Pe.from=ve})(Mt||(e.TypeHierarchyItem=Mt={}));var Nt;(function(Pe){function we(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Pe.from=we})(Nt||(e.ViewBadge=Nt={}));var wt;(function(Pe){function we(xe,Ge,ze){const et=Ge.fileData;return et?new u.InternalFileDataTransferItem(new u.DataTransferFile(et.name,p.URI.revive(et.uri),et.id,(0,M.once)(()=>ze(et.id)))):xe===R.Mimes.uriList&&Ge.uriListData?new u.InternalDataTransferItem(Fe(Ge.uriListData)):new u.InternalDataTransferItem(Ge.asString)}Pe.to=we;async function ve(xe,Ge){const ze=await Ge.asString();if(xe===R.Mimes.uriList)return{asString:ze,fileData:void 0,uriListData:Q(ze)};const et=Ge.asFile();return{asString:ze,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Pe.from=ve;function Q(xe){return y.UriList.split(xe).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return p.URI.parse(Ge)}catch{}return Ge})}function Fe(xe){return y.UriList.create(xe.map(Ge=>typeof Ge=="string"?Ge:p.URI.revive(Ge)))}})(wt||(e.DataTransferItem=wt={}));var ut;(function(Pe){function we(Q,Fe){const xe=Q.items.map(([Ge,ze])=>[Ge,wt.to(Ge,ze,Fe)]);return new u.DataTransfer(xe)}Pe.toDataTransfer=we;async function ve(Q){const Fe={items:[]},xe=[];for(const[Ge,ze]of Q)xe.push((async()=>{Fe.items.push([Ge,await wt.from(Ge,ze)])})());return await Promise.all(xe),Fe}Pe.from=ve})(ut||(e.DataTransfer=ut={}));var It;(function(Pe){function we(Q){return{message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}Pe.to=we;function ve(Q){return{kind:"reply",message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}Pe.from=ve})(It||(e.ChatReplyFollowup=It={}));var Ut;(function(Pe){function we(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",args:ve.args}:It.from(ve)}Pe.from=we})(Ut||(e.ChatFollowup=Ut={}))}),define(Ae[204],Re([1,0,2,10,7,8,171]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(m,R,b,c={timeout:1500,errors:3}){this._logService=m,this._documents=R,this._mainThreadBulkEdits=b,this._thresholds=c,this._callbacks=new O.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(m){return(R,b,c)=>{const g={dispose:this._callbacks.push([R,b,m])};return Array.isArray(c)&&c.push(g),g}}async $participateInSave(m,R){const b=i.URI.revive(m);let c=!1;const p=setTimeout(()=>c=!0,this._thresholds.timeout),g=[];try{for(const d of[...this._callbacks]){if(c)break;const t=this._documents.getDocument(b),l=await this._deliverEventAsyncAndBlameBadListeners(d,{document:t,reason:M.TextDocumentSaveReason.to(R)});g.push(l)}}finally{clearTimeout(p)}return g}_deliverEventAsyncAndBlameBadListeners([m,R,b],c){const p=this._badListeners.get(m);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,m,R,c).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this._badListeners.get(m);this._badListeners.set(m,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(m,R,b,c){const p=[],g=Date.now(),{document:d,reason:t}=c,{version:l}=d,h=Object.freeze({document:d,reason:t,waitUntil(S){if(Object.isFrozen(p))throw(0,C.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(S))}});try{R.apply(b,[h])}catch(S){return Promise.reject(S)}return Object.freeze(p),new Promise((S,I)=>{const v=setTimeout(()=>I(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(v),S(n)}).catch(n=>{clearTimeout(v),I(n)})}).then(S=>{const I={edits:[]};for(const v of S)if(Array.isArray(v)&&v.every(n=>n instanceof y.TextEdit))for(const{newText:n,newEol:u,range:r}of v)I.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:n,eol:u&&M.EndOfLine.from(u)}});if(I.edits.length!==0)return l===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(I):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ae[205],Re([1,0,15,2,8,7,74]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(b,c,p,g){this.start=b,this.deletedCount=c,this.deletedItems=p,this.items=g}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class _{static asModelAddData(b,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:b}}constructor(b,c,p){this.notebook=b,this._extHostDocument=c,this._cellData=p,this.handle=p.handle,this.uri=C.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=p.internalMetadata??{},this._metadata=Object.freeze(p.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return b._mime},set mime(g){b._mime=g},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(p)}return this._apiCell}setOutputs(b){this._outputs=b.map(y.NotebookCellOutput.to)}setOutputItems(b,c,p){const g=p.map(y.NotebookCellOutputItem.to),d=this._outputs.find(t=>t.id===b);if(d&&(c||(d.items.length=0),d.items.push(...g),d.items.length>1&&d.items.every(t=>O.isTextStreamMime(t.mime)))){const t=new Map,l=[];d.items.forEach(h=>{let S;t.has(h.mime)?S=t.get(h.mime):(S=[],t.set(h.mime,S),l.push(h.mime)),S.push(h.data)}),d.items.length=0,l.forEach(h=>{const S=O.compressOutputItemStreams(t.get(h));d.items.push({mime:h,data:S.buffer})})}}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=_;class m{constructor(b,c,p,g,d){this._proxy=b,this._textDocumentsAndEditors=c,this._textDocuments=p,this.uri=g,this.handle=m._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0,void 0),this._versionId=d.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,c={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===i.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(p){return p=b._validateIndex(p),b._cells[p].apiCell},getCells(p){return(p?b._getCells(p):b._cells).map(d=>d.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(c)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,c,p){this._versionId=b.versionId,this._isDirty=c,this.acceptDocumentPropertiesChanged({metadata:p});const g={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},d=[];for(const l of b.rawEvents)l.kind===O.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1,g.contentChanges):l.kind===O.NotebookCellsChangeType.Move?this._moveCells(l.index,l.length,l.newIdx,g.contentChanges):l.kind===O.NotebookCellsChangeType.Output?(this._setCellOutputs(l.index,l.outputs),d.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===O.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems),d.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===O.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(l.index,l.language),d.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document})):l.kind===O.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document}):l.kind===O.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===O.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(l.index,l.metadata),d.push({cell:this._cells[l.index].apiCell,metadata:this._cells[l.index].apiCell.metadata})):l.kind===O.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(l.index,l.internalMetadata),d.push({cell:this._cells[l.index].apiCell,executionSummary:this._cells[l.index].apiCell.executionSummary}));const t=new Map;for(let l=0;l<d.length;l++){const h=d[l],S=t.get(h.cell);if(S===void 0){const I=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});t.set(h.cell,I-1)}else g.cellChanges[S]={...g.cellChanges[S],...h}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let c=b.start|0,p=b.end|0;return c<0&&(c=0),p>this._cells.length&&(p=this._cells.length),b.with({start:c,end:p})}_getCells(b){b=this._validateRange(b);const c=[];for(let p=b.start;p<b.end;p++)c.push(this._cells[p]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,c,p){if(this._disposed)return;const g=[],d=[],t=[];if(b.reverse().forEach(l=>{const S=l[2].map(n=>{const u=new _(this,this._textDocumentsAndEditors,n);return c||d.push(_.asModelAddData(this.apiNotebook,n)),u}),I=new A(l[0],l[1],[],S),v=this._cells.splice(l[0],l[1],...S);for(const n of v)t.push(n.uri),I.deletedItems.push(n.apiCell);g.push(I)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),p)for(const l of g)p.push(l.asApiEvent())}_moveCells(b,c,p,g){const d=this._cells.splice(b,c);this._cells.splice(p,0,...d);const t=[new A(b,c,d.map(l=>l.apiCell),[]),new A(p,0,[],d)];for(const l of t)g.push(l.asApiEvent())}_setCellOutputs(b,c){this._cells[b].setOutputs(c)}_setCellOutputItems(b,c,p,g){this._cells[b].setOutputItems(c,p,g)}_changeCellLanguage(b,c){const p=this._cells[b];p.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(p.uri,c)}_changeCellMime(b,c){const p=this._cells[b];p.apiCell.mime=c}_changeCellMetadata(b,c){this._cells[b].setMetadata(c)}_changeCellInternalMetadata(b,c){this._cells[b].setInternalMetadata(c)}getCellFromApiCell(b){return this._cells.find(c=>c.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(c=>c.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=m,m._handlePool=0}),define(Ae[206],Re([1,0,5,2,8,7]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class O{constructor(_,m,R,b={timeout:1500,errors:3}){this._logService=_,this._notebooksAndEditors=m,this._mainThreadBulkEdits=R,this._thresholds=b,this._onWillSaveNotebookDocumentEvent=new i.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(_){return(m,R,b)=>{const c=function(g){m.call(R,g)};return c.extension=_,this._onWillSaveNotebookDocumentEvent.event(c,void 0,b)}}async $participateInSave(_,m,R){const b=C.URI.revive(_),c=this._notebooksAndEditors.getNotebookDocument(b);if(!c)throw new Error("Unable to resolve notebook document");const p=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:c.apiNotebook,reason:y.TextDocumentSaveReason.to(m)},R,async(d,t)=>{const l=Date.now(),h=await await Promise.resolve(d);Date.now()-l>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&h&&(h instanceof M.WorkspaceEdit?p.push(h):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const g={edits:[]};for(const d of p){const{edits:t}=y.WorkspaceEdit.from(d);g.edits=g.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g)}}e.ExtHostNotebookDocumentSaveParticipant=O}),define(Ae[104],Re([1,0,10,8,7]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,_,m,R,b,c){this.id=A,this._proxy=_,this.notebookData=m,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=R,this._viewColumn=c}get apiEditor(){if(!this._editor){const A=this;this._editor={get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(_){this.selections=[_]},get selections(){return A._selections},set selections(_){if(!Array.isArray(_)||!_.every(y.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");A._selections=_,A._trySetSelections(_)},get visibleRanges(){return A._visibleRanges},revealRange(_,m){A._proxy.$tryRevealRange(A.id,C.NotebookRange.from(_),m??y.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(C.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ae[207],Re([1,0,10,5,14,8]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let O=e.ExtHostNotebookEditors=class{constructor(_,m){this._logService=_,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new C.Emitter({onListenerError:i.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new C.Emitter({onListenerError:i.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(_,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,m);const R=this._notebooksAndEditors.getEditorById(_);m.visibleRanges&&R._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&R._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const m in _)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(M.ViewColumn.to(_[m]))}};e.ExtHostNotebookEditors=O=je([We(0,y.ILogService)],O)}),define(Ae[208],Re([1,0,8,175,151,22,65,10]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,p,g){const d=this._handles++,{title:t,location:l,cancellable:h}=p,S={label:(0,y.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(d,{location:i.ProgressLocation.from(l),title:t,source:S,cancellable:h},c.isUnderDevelopment?void 0:c.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(d,g,!!h)}_withProgress(c,p,g){let d;g&&(d=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,d));const t=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),d?.dispose()};let l;try{l=p(new R(this._proxy,c),g&&d?d.token:M.CancellationToken.None)}catch(h){throw t(c),h}return l.then(h=>t(c),h=>t(c)),l}$acceptProgressCanceled(c){const p=this._mapHandleToCancellationSource.get(c);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=_;function m(b,c){return b.message=c.message,typeof c.increment=="number"&&(typeof b.increment=="number"?b.increment+=c.increment:b.increment=c.increment),b}class R extends C.Progress{constructor(c,p){super(g=>this.throttledReport(g)),this._proxy=c,this._handle=p}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}je([(0,O.throttle)(100,(b,c)=>m(b,c),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,44,100,45,75,56,8,2]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(S,I,v,n)=>{let u=I;return{enumerable:!0,configurable:!1,get(){return u},set(r){if(!v(u,r)){const a=u;u=r,S.listener?.(n(r,a))}}}},R=(S,I)=>S===I,b={range:(S,I)=>S===I?!0:!S||!I?!1:S.isEqual(I),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(S,I)=>!(S.length!==I.length||S.some(v=>!I.find(n=>v.id===n.id)))},c=S=>I=>({op:4,update:S(I)}),p=(S,I)=>({range:(()=>{let v;const n=c(u=>({range:i.Range.lift(A.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return v},set(u){S.listener?.({op:6}),b.range(v,u)||(v=u,S.listener?.(n(u)))}}})(),label:m(S,I,b.label,c(v=>({label:v}))),description:m(S,void 0,b.description,c(v=>({description:v}))),sortText:m(S,void 0,b.sortText,c(v=>({sortText:v}))),canResolveChildren:m(S,!1,b.canResolveChildren,v=>({op:2,state:v})),busy:m(S,!1,b.busy,c(v=>({busy:v}))),error:m(S,void 0,b.error,c(v=>({error:A.MarkdownString.fromStrict(v)||null}))),tags:m(S,[],b.tags,(v,n)=>({op:1,new:v.map(A.TestTag.from),old:n.map(A.TestTag.from)}))}),g=S=>{const I=y.TestId.fromString(S.extId),v=new t(I.controllerId,I.localId,S.label,_.URI.revive(S.uri)||void 0);return v.range=A.Range.to(S.range||void 0),v.description=S.description||void 0,v.sortText=S.sortText||void 0,v.tags=S.tags.map(n=>A.TestTag.to({id:(0,O.denamespaceTestTag)(n).tagId})),v},d=S=>{let I;for(const v of S.tests){const n=g(v.item);(0,C.getPrivateApiFor)(n).parent=I,I=n}return I};e.toItemFromContext=d;class t{constructor(I,v,n,u){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,C.createPrivateApiFor)(this,I);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof l?void 0:r.parent}},children:{value:(0,M.createTestItemChildren)(r,C.getPrivateApiFor,t),enumerable:!0,writable:!1},...p(r,n)})}}e.TestItemImpl=t;class l extends t{constructor(I,v){super(I,I,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class h extends M.TestItemCollection{constructor(I,v,n){super({controllerId:I,getDocumentVersion:u=>u&&n.getDocument(u)?.version,getApiFor:C.getPrivateApiFor,getChildren:u=>u.children,root:new l(I,v),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(Ae[106],Re([1,0,49,10,86,8,7]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(c,p,g){const d=A._Keys.nextId();c.$registerTextEditorDecorationType(p.identifier,d,M.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){c.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=A,A._Keys=new y.IdGenerator("TextEditorDecorationType");class _{constructor(c,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,p){this._throwIfFinalized();let g=null;if(c instanceof O.Position)g=new O.Range(c,c);else if(c instanceof O.Range)g=c;else throw new Error("Unrecognized location");this._pushEdit(g,p,!1)}insert(c,p){this._throwIfFinalized(),this._pushEdit(new O.Range(c,c),p,!0)}delete(c){this._throwIfFinalized();let p=null;if(c instanceof O.Range)p=c;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(c,p,g){const d=this._document.validateRange(c);this._collectedEdits.push({range:d,text:p,forceMoveMarkers:g})}setEndOfLine(c){if(this._throwIfFinalized(),c!==O.EndOfLine.LF&&c!==O.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=c}}class m{constructor(c,p,g,d){this._proxy=c,this._id=p,this._accept(g),this._logService=d;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(l){t._setTabSize(l)},get indentSize(){return t._indentSize},set indentSize(l){t._setIndentSize(l)},get insertSpaces(){return t._insertSpaces},set insertSpaces(l){t._setInsertSpaces(l)},get cursorStyle(){return t._cursorStyle},set cursorStyle(l){t._setCursorStyle(l)},get lineNumbers(){return t._lineNumbers},set lineNumbers(l){t._setLineNumbers(l)}}}_accept(c){this._tabSize=c.tabSize,this._indentSize=c.indentSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(c){const p=this._validateTabSize(c);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateIndentSize(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}_setIndentSize(c){const p=this._validateIndentSize(c);if(p!==null){if(typeof p=="number"){if(this._indentSize===p)return;this._indentSize=p}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:p}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:!!c}_setInsertSpaces(c){const p=this._validateInsertSpaces(c);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(c)})))}assign(c){const p={};let g=!1;if(typeof c.tabSize<"u"){const d=this._validateTabSize(c.tabSize);d==="auto"?(g=!0,p.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,g=!0,p.tabSize=d)}if(typeof c.indentSize<"u"){const d=this._validateIndentSize(c.indentSize);d==="tabSize"?(g=!0,p.indentSize=d):typeof d=="number"&&this._indentSize!==d&&(this._indentSize=d,g=!0,p.indentSize=d)}if(typeof c.insertSpaces<"u"){const d=this._validateInsertSpaces(c.insertSpaces);d==="auto"?(g=!0,p.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,g=!0,p.insertSpaces=d)}typeof c.cursorStyle<"u"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,g=!0,p.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,g=!0,p.lineNumbers=M.TextEditorLineNumbersStyle.from(c.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,p))}_warnOnError(c,p){p.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=m;class R{constructor(c,p,g,d,t,l,h,S){this.id=c,this._proxy=p,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new m(this._proxy,this.id,l,g),this._visibleRanges=h,this._viewColumn=S;const I=this;this.value=Object.freeze({get document(){return d.value},set document(v){throw(0,C.readonly)("document")},get selection(){return I._selections&&I._selections[0]},set selection(v){if(!(v instanceof O.Selection))throw(0,C.illegalArgument)("selection");I._selections=[v],I._trySetSelection()},get selections(){return I._selections},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof O.Selection)))throw(0,C.illegalArgument)("selections");I._selections=v,I._trySetSelection()},get visibleRanges(){return I._visibleRanges},set visibleRanges(v){throw(0,C.readonly)("visibleRanges")},get options(){return I._options.value},set options(v){I._disposed||I._options.assign(v)},get viewColumn(){return I._viewColumn},set viewColumn(v){throw(0,C.readonly)("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(I._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new _(d.value,n);return v(u),I._applyEdit(u)},insertSnippet(v,n,u={undoStopBefore:!0,undoStopAfter:!0}){if(I._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=I._selections.map(a=>M.Range.from(a));else if(n instanceof O.Position){const{lineNumber:a,column:E}=M.Position.from(n);r=[{startLineNumber:a,startColumn:E,endLineNumber:a,endColumn:E}]}else if(n instanceof O.Range)r=[M.Range.from(n)];else{r=[];for(const a of n)if(a instanceof O.Range)r.push(M.Range.from(a));else{const{lineNumber:E,column:D}=M.Position.from(a);r.push({startLineNumber:E,startColumn:D,endLineNumber:E,endColumn:D})}}return p.$tryInsertSnippet(c,d.value.version,v.value,r,u)},setDecorations(v,n){const u=n.length===0;u&&!I._hasDecorationsForKey.has(v.key)||(u?I._hasDecorationsForKey.delete(v.key):I._hasDecorationsForKey.add(v.key),I._runOnProxy(()=>{if(M.isDecorationOptionsArr(n))return p.$trySetDecorations(c,v.key,M.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let a=0,E=n.length;a<E;a++){const D=n[a];r[4*a]=D.start.line+1,r[4*a+1]=D.start.character+1,r[4*a+2]=D.end.line+1,r[4*a+3]=D.end.character+1}return p.$trySetDecorationsFast(c,v.key,r)}}))},revealRange(v,n){I._runOnProxy(()=>p.$tryRevealRange(c,M.Range.from(v),n||O.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(c,M.ViewColumn.from(v))},hide(){p.$tryHideEditor(c)}})}dispose(){(0,i.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,i.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,i.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,i.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,i.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const p=c.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const g=p.edits.map(t=>t.range);g.sort((t,l)=>t.end.line===l.end.line?t.end.character===l.end.character?t.start.line===l.start.line?t.start.character-l.start.character:t.start.line-l.start.line:t.end.character-l.end.character:t.end.line-l.end.line);for(let t=0,l=g.length-1;t<l;t++){const h=g[t].end;if(g[t+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=p.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,d,{setEndOfLine:typeof p.setEndOfLine=="number"?M.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=R}),define(Ae[209],Re([1,0,155,7,25,2,5,6,191,16,7,9,18,8,22,20,123]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(I,v){if((0,b.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let n;return Array.isArray(I.highlights)&&(n=I.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),n=n.length?n:void 0),{label:I.label,highlights:n}}}class h{constructor(v,n,u){this._proxy=v,this.commands=n,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new t.TreeViewsDnDService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:a=>r(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(E=>r(E)?this.convertArgument(E):E):a})}registerTreeDataProvider(v,n,u){const r=this.createTreeView(v,{treeDataProvider:n},u);return{dispose:()=>r.dispose()}}createTreeView(v,n,u){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=n.dragAndDropController?.dropMimeTypes??[],a=n.dragAndDropController?.dragMimeTypes??[],E=!!n.dragAndDropController?.handleDrag,D=!!n.dragAndDropController?.handleDrop,f=this.createExtHostTreeView(v,n,u),T={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:E,hasHandleDrop:D,manuallyManageCheckboxes:!!n.manuallyManageCheckboxSelection},w=this._proxy.$registerTreeViewDataProvider(v,T);return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(u,"treeItemCheckbox"),f.onDidChangeCheckboxState},get message(){return f.message},set message(o){f.message=o},get title(){return f.title},set title(o){f.title=o},get description(){return f.description},set description(o){f.description=o},get badge(){return f.badge},set badge(o){o!==void 0&&R.ViewBadge.isViewBadge(o)?f.badge={value:Math.floor(Math.abs(o.value)),tooltip:o.tooltip}:o===void 0&&(f.badge=void 0)},reveal:(o,s)=>f.reveal(o,s),dispose:async()=>{await w,this.treeViews.delete(v),f.dispose()}}}$getChildren(v,n){const u=this.treeViews.get(v);return u?u.getChildren(n):Promise.reject(new _.NoTreeViewError(v))}async $handleDrop(v,n,u,r,a,E,D,f){const T=this.treeViews.get(v);if(!T)return Promise.reject(new _.NoTreeViewError(v));const w=p.DataTransfer.toDataTransfer(u,async o=>(await this._proxy.$resolveDropFileData(v,n,o)).buffer);return D===v&&f&&await this.addAdditionalTransferItems(w,T,f,a,E),T.onDrop(w,r,a)}async addAdditionalTransferItems(v,n,u,r,a){const E=this.treeDragAndDropService.removeDragOperationTransfer(a);if(E)(await E)?.forEach((D,f)=>{D&&v.set(f,D)});else if(a&&n.handleDrag){const D=n.handleDrag(u,v,r);this.treeDragAndDropService.addDragOperationTransfer(a,D),await D}return v}async $handleDrag(v,n,u,r){const a=this.treeViews.get(v);if(!a)return Promise.reject(new _.NoTreeViewError(v));const E=await this.addAdditionalTransferItems(new C.DataTransfer,a,n,r,u);if(!(!E||r.isCancellationRequested))return p.DataTransfer.from(E)}async $hasResolve(v){const n=this.treeViews.get(v);if(!n)throw new _.NoTreeViewError(v);return n.hasResolve}$resolve(v,n,u){const r=this.treeViews.get(v);if(!r)throw new _.NoTreeViewError(v);return r.resolveTreeItem(n,u)}$setExpanded(v,n,u){const r=this.treeViews.get(v);if(!r)throw new _.NoTreeViewError(v);r.setExpanded(n,u)}$setSelection(v,n){const u=this.treeViews.get(v);if(!u)throw new _.NoTreeViewError(v);u.setSelection(n)}$setFocus(v,n){const u=this.treeViews.get(v);if(!u)throw new _.NoTreeViewError(v);u.setFocus(n)}$setVisible(v,n){const u=this.treeViews.get(v);if(!u)throw new _.NoTreeViewError(v);u.setVisible(n)}$changeCheckboxState(v,n){const u=this.treeViews.get(v);if(!u)throw new _.NoTreeViewError(v);u.setCheckboxState(n)}createExtHostTreeView(v,n,u){const r=new S(v,n,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(v,r),r}convertArgument(v){const n=this.treeViews.get(v.$treeViewId);return n&&"$treeItemHandle"in v?n.getExtensionElement(v.$treeItemHandle):n&&"$focusedTreeItem"in v&&v.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=h;class S extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,b.isUndefinedOrNull)(v))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(v,n,u,r,a,E){if(super(),this.viewId=v,this.proxy=u,this.commands=r,this.logService=a,this.extension=E,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new O.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new O.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new O.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new O.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new O.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,E.contributes&&E.contributes.views)for(const T in E.contributes.views)for(const w of E.contributes.views[T])w.id===v&&(this._title=w.name);this.dataProvider=n.treeDataProvider,this.dndController=n.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(T=>this._onDidChangeData.fire({message:!1,element:T})));let D,f;this._register(O.Event.debounce(this._onDidChangeData.event,(T,w)=>(T||(T={message:!1,elements:[]}),w.element!==!1&&(D||(D=new Promise(o=>f=o),this.refreshPromise=this.refreshPromise.then(()=>D)),Array.isArray(w.element)?T.elements.push(...w.element):T.elements.push(w.element)),w.message&&(T.message=!0),T),200,!0)(({message:T,elements:w})=>{w.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=f;return D=null,this.refresh(w).then(()=>o())})),T&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(v){const n=v?this.getExtensionElement(v):void 0;if(v&&!n)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(v);return u||(u=await this.fetchChildrenNodes(n)),u?u.map(r=>r.item):void 0}getExtensionElement(v){return this.elements.get(v)}reveal(v,n){n=n||{select:!0,focus:!1};const u=(0,b.isUndefinedOrNull)(n.select)?!0:n.select,r=(0,b.isUndefinedOrNull)(n.focus)?!1:n.focus,a=(0,b.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(E=>this.resolveTreeNode(v,E[E.length-1]).then(D=>this.proxy.$reveal(this.viewId,{item:D.item,parentChain:E.map(f=>f.item)},{select:u,focus:r,expand:a})),E=>this.logService.error(E)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:r,expand:a})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}get badge(){return this._badge}set badge(v){this._badge?.value===v?.value&&this._badge?.tooltip===v?.tooltip||(this._badge=p.ViewBadge.from(v),this.proxy.$setBadge(this.viewId,v))}setExpanded(v,n){const u=this.getExtensionElement(v);u&&(n?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(v){(0,c.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this._focusedHandle=v}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(v){const n=(await Promise.all(v.map(async u=>{const r=this.getExtensionElement(u.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:u.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);n.forEach(u=>{u.treeItem.checkboxState=u.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:n.map(u=>[u.extensionItem,u.newState])})}async handleDrag(v,n,u){const r=[];for(const a of v){const E=this.getExtensionElement(a);E&&r.push(E)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,n,u),n}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(v,n,u){const r=n?this.getExtensionElement(n):void 0;if(!(!r&&n||!this.dndController?.handleDrop))return(0,m.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,v,u):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,n){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(v);if(u){const r=this.nodes.get(u);if(r){const a=await this.dataProvider.resolveTreeItem(r.extensionItem,u,n)??r.extensionItem;return this.validateTreeItem(a),r.item.tooltip=this.getTooltip(a.tooltip),r.item.command=this.getCommand(r.disposableStore,a.command),r.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(n=>n?this.resolveUnknownParentChain(n).then(u=>this.resolveTreeNode(n,u[u.length-1]).then(r=>(u.push(r),u))):Promise.resolve([]))}resolveParent(v){const n=this.nodes.get(v);return n?Promise.resolve(n.parent?this.elements.get(n.parent.item.handle):void 0):(0,m.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,n){const u=this.nodes.get(v);return u?Promise.resolve(u):(0,m.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(r=>this.createHandle(v,r,n,!0)).then(r=>this.getChildren(n?n.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const E=this.nodes.get(a);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(v){if(v){let n;if(typeof v=="string"){const u=this.getExtensionElement(v);n=u?this.nodes.get(u):void 0}else n=v;return n&&n.children||void 0}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const n=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=v?this.nodes.get(v):void 0,r=await this.dataProvider.getChildren(v);if(n.token.isCancellationRequested)return;const a=await Promise.all((0,c.coalesce)(r||[]).map(async E=>{const D=await this.dataProvider.getTreeItem(E);return D&&!n.token.isCancellationRequested?this.createAndRegisterTreeNode(E,D,u):null}));return n.token.isCancellationRequested?void 0:(0,c.coalesce)(a)}finally{n.dispose()}}refresh(v){if(v.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(v);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const n=new Set,u=v.map(a=>this.nodes.get(a));for(const a of u)if(a&&!n.has(a.item.handle)){let E=a;for(;E&&E.parent&&u.findIndex(D=>E&&E.parent&&D&&D.item.handle===E.parent.item.handle)===-1;){const D=this.elements.get(E.parent.item.handle);E=D?this.nodes.get(D):void 0}E&&!E.parent&&n.add(a.item.handle)}const r=[];return n.forEach(a=>{const E=this.elements.get(a);if(E){const D=this.nodes.get(E);D&&(!D.parent||!n.has(D.parent.item.handle))&&r.push(a)}}),r}refreshHandles(v){const n={};return Promise.all(v.map(u=>this.refreshNode(u).then(r=>{r&&(n[u]=r.item)}))).then(()=>Object.keys(n).length?this.proxy.$refresh(this.viewId,n):void 0)}refreshNode(v){const n=this.getExtensionElement(v);if(n){const u=this.nodes.get(n);if(u)return this.clearChildren(n),(0,m.asPromise)(()=>this.dataProvider.getTreeItem(n)).then(r=>{if(r){const a=this.createTreeNode(n,r,u.parent);return this.updateNodeCache(n,a,u,u.parent),u.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,n,u){const r=this.createTreeNode(v,n,u);if(n.id&&this.elements.has(r.item.handle))throw new Error((0,i.localize)(0,null,n.id));return this.addNodeToCache(v,r),this.addNodeToParentCache(r,u),r}getTooltip(v){return R.MarkdownString.isMarkdownString(v)?p.MarkdownString.from(v):v}getCommand(v,n){return n?{...this.commands.toInternal(n,v),originalId:n.command}:void 0}getCheckbox(v){if(v.checkboxState===void 0)return;let n,u,r;return typeof v.checkboxState=="number"?n=v.checkboxState:(n=v.checkboxState.state,u=v.checkboxState.tooltip,r=v.checkboxState.accessibilityInformation),{isChecked:n===R.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:r}}validateTreeItem(v){if(!R.TreeItem.isTreeItem(v,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(v,n,u){this.validateTreeItem(n);const r=new A.DisposableStore,a=this.createHandle(v,n,u),E=this.getLightIconPath(n);return{item:{handle:a,parentHandle:u?u.item.handle:void 0,label:l(n.label,this.extension),description:n.description,resourceUri:n.resourceUri,tooltip:this.getTooltip(n.tooltip),command:this.getCommand(r,n.command),contextValue:n.contextValue,icon:E,iconDark:this.getDarkIconPath(n)||E,themeIcon:this.getThemeIcon(n),collapsibleState:(0,b.isUndefinedOrNull)(n.collapsibleState)?R.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.getCheckbox(n)},extensionItem:n,parent:u,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(v){return v.iconPath instanceof R.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:n,label:u,resourceUri:r},a,E){if(n)return`${S.ID_HANDLE_PREFIX}/${n}`;const D=l(u,this.extension),f=a?a.item.handle:S.LABEL_HANDLE_PREFIX;let T=D?D.label:r?(0,y.basename)(r):"";T=T.indexOf("/")!==-1?T.replace("/","//"):T;const w=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,o=this.getChildrenNodes(a)||[];let s,F=0;do{if(s=`${f}/${F}:${T}`,E||!this.elements.has(s)||w===s)break;F++}while(F<=o.length);return s}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof R.ThemeIcon))return typeof v.iconPath=="string"||M.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof R.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return M.URI.isUri(v)?v:M.URI.file(v)}addNodeToCache(v,n){this.elements.set(n.item.handle,v),this.nodes.set(v,n)}updateNodeCache(v,n,u,r){this.elements.delete(n.item.handle),this.nodes.delete(v),n.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(v,n);const a=this.getChildrenNodes(r)||[],E=a.filter(D=>D.item.handle===u.item.handle)[0];E&&a.splice(a.indexOf(E),1,n)}addNodeToParentCache(v,n){n?(n.children||(n.children=[]),n.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const n=this.nodes.get(v);if(n){if(n.children)for(const u of n.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}n.children=void 0}}else this.clearAll()}clear(v){const n=this.nodes.get(v);if(n){if(n.children)for(const u of n.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}this.nodes.delete(v),this.elements.delete(n.item.handle),n.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(Ae[210],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[211],Re([1,0,164,10,29,92,72,30,23,210,174,98]),function(te,e,i,C,y,M,O,A,_,m,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const c=A.Registry.as(O.Extensions.JSONContribution);class p{constructor(v,n,u){this._messageHandler=v,this._extension=n,this._extensionPointId=u}_msg(v,n){this._messageHandler({type:v,message:n,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(v){this._msg(y.default.Error,v)}warn(v){this._msg(y.default.Warning,v)}info(v){this._msg(y.default.Info,v)}}e.ExtensionMessageCollector=p;class g{static _toSet(v){const n=new _.ExtensionIdentifierSet;for(let u=0,r=v.length;u<r;u++)n.add(v[u].description.identifier);return n}static compute(v,n){if(!v||!v.length)return new g(n,[]);if(!n||!n.length)return new g([],v);const u=this._toSet(v),r=this._toSet(n),a=n.filter(D=>!u.has(D.description.identifier)),E=v.filter(D=>!r.has(D.description.identifier));return new g(a,E)}constructor(v,n){this.added=v,this.removed=n}}e.ExtensionPointUserDelta=g;class d{constructor(v,n){this.name=v,this.defaultExtensionKind=n,this._handler=null,this._users=null,this._delta=null}setHandler(v){if(this._handler!==null)throw new Error("Handler already set!");this._handler=v,this._handle()}acceptUsers(v){this._delta=g.compute(this._users,v),this._users=v,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(v){(0,C.onUnexpectedError)(v)}}}e.ExtensionPoint=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:_.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class h{constructor(){this._extensionPoints=new Map}registerExtensionPoint(v){if(this._extensionPoints.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const n=new d(v.extensionPoint,v.defaultExtensionKind);return this._extensionPoints.set(v.extensionPoint,n),v.activationEventsGenerator&&b.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,c.registerSchema(l,e.schema),n}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=h;const S={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(S.ExtensionsRegistry,new h),e.ExtensionsRegistry=A.Registry.as(S.ExtensionsRegistry),c.registerSchema(l,e.schema),c.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Ae[212],Re([1,0,161,9,26,211,31,5]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const _={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var m;(function(c){function p(g,d,t){if(!g)return;const l=C.isString(g.type)?g.type:void 0;if(!l||l.length===0){t.error(i.localize(3,null));return}const h=[];if(Array.isArray(g.required))for(const S of g.required)C.isString(S)&&h.push(S);return{extensionId:d.value,taskType:l,required:h,properties:g.properties?y.deepClone(g.properties):{},when:g.when?O.ContextKeyExpr.deserialize(g.when):void 0}}c.from=p})(m||(m={}));const R=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,p)=>{for(const g of c)g.type&&p.push(`onTaskType:${g.type}`)},jsonSchema:{description:i.localize(4,null),type:"array",items:_}});class b{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((p,g)=>{R.setHandler((d,t)=>{this._schema=void 0;try{for(const l of t.removed){const h=l.value;for(const S of h)this.taskTypes&&S.type&&this.taskTypes[S.type]&&delete this.taskTypes[S.type]}for(const l of t.added){const h=l.value;for(const S of h){const I=m.from(S,l.description.identifier,l.collector);I&&(this.taskTypes[I.taskType]=I)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}p(void 0)})})}onReady(){return this.readyPromise}get(p){return this.taskTypes[p]}all(){return Object.keys(this.taskTypes).map(p=>this.taskTypes[p])}getJsonSchema(){if(this._schema===void 0){const p=[];for(const g of this.all()){const d={type:"object",additionalProperties:!1};g.required.length>0&&(d.required=g.required.slice(0)),g.properties!==void 0?d.properties=y.deepClone(g.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[g.taskType]},p.push(d)}this._schema={oneOf:p}}return this._schema}}e.TaskDefinitionRegistry=new b}),define(Ae[213],Re([1,0,162,9,25,26,31,212]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new O.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var _;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(_||(e.ShellQuoting=_={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function V(x){if(!x)return N.Strong;switch(x.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=V}(_||(e.ShellQuoting=_={}));var m;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R||(e.RevealKind=R={})),function(N){function V(x){switch(x.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=V}(R||(e.RevealKind=R={}));var b;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(b||(e.RevealProblemKind=b={})),function(N){function V(x){switch(x.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=V}(b||(e.RevealProblemKind=b={}));var c;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(c||(e.PanelKind=c={})),function(N){function V(x){switch(x.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=V}(c||(e.PanelKind=c={}));var p;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:b.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var g;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(N){function V(W){switch(W.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=V;function x(W){switch(W){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=x}(g||(e.RuntimeType=g={}));var d;(function(N){function V(x){return C.isString(x)?x:x.value}N.value=V})(d||(e.CommandString=d={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function V(W){return W===N.Clean._id||W===N.Build._id||W===N.Rebuild._id||W===N.Test._id}N.is=V;function x(W){if(W!==void 0)return C.isString(W)?V(W)?{_id:W,isDefault:!1}:void 0:W}N.from=x})(t||(e.TaskGroup=t={}));var l;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var h;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function V(x){switch(x){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=V})(h||(e.TaskSourceKind=h={}));var S;(function(N){N.parallel="parallel",N.sequence="sequence"})(S||(e.DependsOrder=S={}));var I;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(I||(e.RunOnOptions=I={}));var v;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:I.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class n{constructor(V,x,W,ee,Ie,oe){this._label="",this._id=V,x&&(this._label=x),W&&(this.type=W),this.runOptions=ee,this.configurationProperties=Ie,this._source=oe}getDefinition(V){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const V={folder:this.getFolderId(),id:this._id};return JSON.stringify(V)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,x=!1){if(V===void 0)return!1;if(C.isString(V))return V===this._label||V===this.configurationProperties.identifier||x&&V===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),V&&(this._taskLoadMessages=this._taskLoadMessages.concat(V))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class u extends n{constructor(V,x,W,ee,Ie,oe,ue,X){super(V,W,void 0,ue,X,x),this.command={},this._source=x,this.hasDefinedMatchers=oe,Ie&&(this.command=Ie)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case g.Shell:x="shell";break;case g.Process:x="process";break;case g.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(V){return V instanceof u}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let x=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(x+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:x};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(V){return new u(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.CustomTask=u;class r extends n{constructor(V,x,W,ee,Ie,oe,ue){super(V,W,ee,oe,ue,x),this._source=x,this.configures=Ie}static is(V){return V instanceof r}fromObject(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let x=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(x+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:x};return JSON.stringify(W)}}e.ConfiguringTask=r;class a extends n{constructor(V,x,W,ee,Ie,oe,ue,X,le){super(V,W,ee,X,le,x),this.defines=Ie,this.hasDefinedMatchers=ue,this.command=oe,this.icon=le.icon,this.hide=le.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof a}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.getFolderId(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(V){return new a(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.ContributedTask=a;class E extends n{constructor(V,x,W,ee,Ie,oe){super(V,W,ee,Ie,oe,x),this._source=x}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(V){return new E(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.InMemoryTask=E;var D;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(N){N._default=N.Terminal}(D||(e.ExecutionEngine=D={}));var f;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class T{constructor(V){this._order=new Map;for(let x=0;x<V.length;x++)this._order.set(V[x].uri.toString(),x)}compare(V,x){const W=V.getWorkspaceFolder(),ee=x.getWorkspaceFolder();if(W&&ee){let Ie=this._order.get(W.uri.toString());Ie=Ie===void 0?0:Ie+1;let oe=this._order.get(ee.uri.toString());return oe=oe===void 0?0:oe+1,Ie===oe?V._label.localeCompare(x._label):Ie-oe}else return!W&&ee?-1:W&&!ee?1:0}}e.TaskSorter=T;var w;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(w||(e.TaskEventKind=w={}));var o;(function(N){N.SingleRun="singleRun",N.Background="background"})(o||(e.TaskRunType=o={}));var s;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(s||(e.TaskRunSource=s={}));var F;(function(N){function V(x,W,ee,Ie){if(W){const oe={kind:x,taskId:W._id,taskName:W.configurationProperties.name,runType:W.configurationProperties.isBackground?"background":"singleRun",group:W.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ee,__task:W};return x==="start"?oe.resolvedVariables=Ie:x==="processStarted"?oe.processId=Ie:x==="processEnded"&&(oe.exitCode=Ie),Object.freeze(oe)}else return Object.freeze({kind:"changed"})}N.create=V})(F||(e.TaskEvent=F={}));var B;(function(N){function V(W){const ee=Object.keys(W).sort();let Ie="";for(const oe of ee){let ue=W[oe];ue instanceof Object?ue=V(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),Ie+=oe+","+ue+","}return Ie}function x(W){const Ie={_key:V(W),type:W.taskType};return Object.assign(Ie,W),Ie}N.create=x})(B||(e.KeyedTaskIdentifier=B={}));var G;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(G||(e.TaskSettingId=G={}));var q;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var $;(function(N){function V(x,W){const ee=A.TaskDefinitionRegistry.get(x.type);if(ee===void 0){const X=M.deepClone(x);return delete X._key,B.create(X)}const Ie=Object.create(null);Ie.type=ee.taskType;const oe=new Set;ee.required.forEach(X=>oe.add(X));const ue=ee.properties;for(const X of Object.keys(ue)){const le=x[X];if(le!=null)Ie[X]=le;else if(oe.has(X)){const De=ue[X];if(De.default!==void 0)Ie[X]=M.deepClone(De.default);else switch(De.type){case"boolean":Ie[X]=!1;break;case"number":case"integer":Ie[X]=0;break;case"string":Ie[X]="";break;default:W.error(i.localize(2,null,JSON.stringify(x,void 0,0),X));return}}}return B.create(Ie)}N.createTaskIdentifier=V})($||(e.TaskDefinition=$={}))}),define(Ae[214],Re([1,0,10]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((O,A)=>{this._actualOk=O,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(O){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=O,this._actual&&this._actualOk(O))}resolveErr(O){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=O,this._actual?this._actualErr(O):(0,i.onUnexpectedError)(O))}then(O,A){return this._ensureActual().then(O,A)}catch(O){return this._ensureActual().then(void 0,O)}finally(O){return this._ensureActual().finally(O)}}e.LazyPromise=C;class y extends C{constructor(){super(),this._hasErr=!0,this._err=new i.CancellationError}}e.CanceledLazyPromise=y}),define(Ae[46],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(_){this._proxyIdentifierBrand=void 0,this.sid=_,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const C=[];function y(A){const _=new i(A);return C[_.nid]=_,_}e.createProxyIdentifier=y;function M(A){return C[A].sid}e.getStringIdentifierForProxy=M;class O{constructor(_){this.value=_}}e.SerializableObjectWithBuffers=O}),define(Ae[4],Re([1,0,46]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var y;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(y||(e.TabInputKind=y={}));var M;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var O;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(O||(e.WebviewEditorCapabilities=O={}));var A;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var _;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(_||(e.CellOutputKind=_={}));var m;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class b{static mixin(t){return t._id=b._n++,t}}e.IdObject=b,b._n=0;var c;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var p;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var g;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,i.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,i.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,i.createProxyIdentifier)("MainThreadChat"),MainThreadInteractiveEditor:(0,i.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,i.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,i.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,i.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,i.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,i.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,i.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,i.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostChat:(0,i.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,i.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,i.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,i.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ae[79],Re([1,0,3,14,4,17]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let O=e.ExtHostApiDeprecationService=class{constructor(_,m){this._extHostLogService=m,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,m,R){const b=this.getUsageKey(_,m);this._reportedUsages.has(b)||(this._reportedUsages.add(b),m.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:_}))}getUsageKey(_,m){return`${_}-${m.identifier.value}`}};e.ExtHostApiDeprecationService=O=je([We(0,M.IExtHostRpcService),We(1,C.ILogService)],O),e.NullApiDeprecationService=Object.freeze(new class{report(A,_,m){}})}),define(Ae[215],Re([1,0,5,4,7,23]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class O{constructor(m){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new A,this._getSessionsTaskSingler=new A,this._proxy=m.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(m){return this._providers=m,Promise.resolve()}async getSession(m,R,b,c={}){const p=M.ExtensionIdentifier.toKey(m.identifier),g=[...b].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${p} ${R} ${g}`,async()=>{await this._proxy.$ensureProvider(R);const d=m.displayName||m.name;return this._proxy.$getSession(R,b,p,d,c)})}async getSessions(m,R,b){const c=M.ExtensionIdentifier.toKey(m.identifier),p=[...b].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${c} ${p}`,async()=>{await this._proxy.$ensureProvider(R);const g=m.displayName||m.name;return this._proxy.$getSessions(R,b,c,g)})}async removeSession(m,R){const b=this._authenticationProviders.get(m);return b?b.provider.removeSession(R):this._proxy.$removeSession(m,R)}registerAuthenticationProvider(m,R,b,c){if(this._authenticationProviders.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this._authenticationProviders.set(m,{label:R,provider:b,options:c??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===m)||this._providers.push({id:m,label:R});const p=b.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(m,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(m,R,c?.supportsMultipleAccounts??!1),new y.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(m);const g=this._providers.findIndex(d=>d.id===m);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(m)})}$createSession(m,R,b){const c=this._authenticationProviders.get(m);if(c)return Promise.resolve(c.provider.createSession(R,b));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,R){const b=this._authenticationProviders.get(m);if(b)return Promise.resolve(b.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,R){const b=this._authenticationProviders.get(m);if(b)return Promise.resolve(b.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,R){return this._onDidChangeSessions.fire({provider:{id:m,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=O;class A{constructor(){this._inFlightPromises=new Map}getOrCreate(m,R){const b=this._inFlightPromises.get(m);if(b)return b;const c=R().finally(()=>this._inFlightPromises.delete(m));return this._inFlightPromises.set(m,c),c}}}),define(Ae[216],Re([1,0,4,17,8]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=e.ExtHostBulkEdits=class{constructor(A,_){this._proxy=A.getProxy(i.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:m=>_.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,_,m){const R=y.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,m?.isRefactoring??!1)}};e.ExtHostBulkEdits=M=je([We(0,C.IExtHostRpcService)],M)}),define(Ae[217],Re([1,0,5,6,58,9,146,4,8]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class m{constructor(c,p){this.extension=c,this.provider=p,this.handle=m._pool++}}m._pool=0;class R{constructor(c,p){this.logService=p,this._chatProvider=new Map,this._slashCommandProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new i.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=c.getProxy(A.MainContext.MainThreadChat)}registerChatProvider(c,p,g){const d=new m(c,g);return this._chatProvider.set(d.handle,d),this._proxy.$registerChatProvider(d.handle,p),(0,C.toDisposable)(()=>{this._proxy.$unregisterChatProvider(d.handle),this._chatProvider.delete(d.handle)})}addChatRequest(c){this._proxy.$addRequest(c)}sendInteractiveRequestToProvider(c,p){this._proxy.$sendRequestToProvider(c,p)}async $prepareChat(c,p,g){const d=this._chatProvider.get(c);if(!d)return;const t=await d.provider.prepareSession(p,g);if(!t)return;const l=R._nextId++;return this._chatSessions.set(l,t),{id:l,requesterUsername:t.requester?.name,requesterAvatarIconUri:t.requester?.icon,responderUsername:t.responder?.name,responderAvatarIconUri:t.responder?.icon,inputPlaceholder:t.inputPlaceholder}}async $resolveRequest(c,p,g,d){const t=this._chatProvider.get(c);if(!t)return;const l=this._chatSessions.get(p);if(!l||!t.provider.resolveRequest)return;const h=await t.provider.resolveRequest(l,g,d);if(h)return{message:typeof h.message=="string"?h.message:_.ChatReplyFollowup.from(h.message)}}async $provideWelcomeMessage(c,p){const g=this._chatProvider.get(c);if(!g||!g.provider.provideWelcomeMessage)return;const d=await g.provider.provideWelcomeMessage(p);if(d)return d.map(t=>typeof t=="string"?t:t.map(l=>_.ChatReplyFollowup.from(l)))}async $provideFollowups(c,p,g){const d=this._chatProvider.get(c);if(!d)return;const t=this._chatSessions.get(p);return!t||!d.provider.provideFollowups?void 0:(await d.provider.provideFollowups(t,g))?.map(h=>_.ChatFollowup.from(h))}$removeRequest(c,p,g){const d=this._chatProvider.get(c);if(!d)return;const t=this._chatSessions.get(p);t&&d.provider.removeRequest&&d.provider.removeRequest(t,g)}async $provideReply(c,p,g,d){const t=this._chatProvider.get(c);if(!t)return;const l=this._chatSessions.get(p);if(!l)return;const h={session:l,message:typeof g.message=="string"?g.message:_.ChatReplyFollowup.to(g.message)},S=y.StopWatch.create(!1);let I;const v={report:r=>{if(d.isCancellationRequested)return;typeof I>"u"&&(I=S.elapsed());const a="responseId"in r?{requestId:r.responseId}:r;this._proxy.$acceptResponseProgress(c,p,a)}};let n;try{n=await t.provider.provideResponseWithProgress(h,v,d),n||(n={errorDetails:{message:(0,O.localize)(0,null)}})}catch(r){n={errorDetails:{message:(0,O.localize)(1,null,r.message),responseIsIncomplete:!0}},this.logService.error(r)}try{if(l.saveState&&this._chatSessions.has(p)){const r=l.saveState();this._proxy.$acceptChatState(p,r)}}catch(r){this.logService.warn(r)}const u={firstProgress:I??0,totalElapsed:S.elapsed()};return{errorDetails:n.errorDetails,timings:u}}async $provideSlashCommands(c,p,g){const d=this._chatProvider.get(c);if(!d)return;const t=this._chatSessions.get(p);return!t||!d.provider.provideSlashCommands?void 0:(await d.provider.provideSlashCommands(t,g))?.map(h=>({...h,kind:_.CompletionItemKind.from(h.kind)}))}$releaseSession(c){this._chatSessions.delete(c)}async $onDidPerformUserAction(c){this._onDidPerformUserAction.fire(c)}registerSlashCommandProvider(c,p,g){const d=new m(c,g);return this._slashCommandProvider.set(d.handle,d),this._proxy.$registerSlashCommandProvider(d.handle,p),(0,C.toDisposable)(()=>{this._proxy.$unregisterSlashCommandProvider(d.handle),this._slashCommandProvider.delete(d.handle)})}async $provideProviderSlashCommands(c,p){const g=this._slashCommandProvider.get(c);return g?(await g.provider.provideSlashCommands(p))?.map(t=>({...t,kind:_.CompletionItemKind.from(t.kind)})):void 0}async $resolveSlashCommand(c,p,g){const d=this._slashCommandProvider.get(c);if(!d)return;const t=await d.provider.resolveSlashCommand(p,g);return(0,M.withNullAsUndefined)(t)}}e.ExtHostChat=R,R._nextId=0}),define(Ae[218],Re([1,0,4]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(M){const O=M.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return O.$readText()},writeText(A){return O.$writeText(A)}})}}e.ExtHostClipboard=C});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[32],Re([1,0,9,7,8,26,4,18,14,68,44,272,2,6,3,17,105,24,46,40,58,52,57]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v,n){"use strict";var u,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=e.ExtHostCommands=class{constructor(s,F,B){u.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,r.set(this,void 0),a.set(this,void 0),Qe(this,u,s.getProxy(O.MainContext.MainThreadCommands),"f"),this._logService=F,Qe(this,a,B,"f"),Qe(this,r,s.getProxy(O.MainContext.MainThreadTelemetry),"f"),this.converter=new D(this,G=>{const q=this._apiCommands.get(G);return q?.result===T.Void?q:void 0},F),this._argumentProcessors=[{processArgument(G){return(0,m.revive)(G)}},{processArgument(G){return(0,M.cloneAndChange)(G,function(q){if(R.Range.isIRange(q))return y.Range.to(q);if(b.Position.isIPosition(q))return y.Position.to(q);if(R.Range.isIRange(q.range)&&c.URI.isUri(q.uri))return y.location.to(q);if(q instanceof l.VSBuffer)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const F=this.registerCommand(!1,s.id,async(...B)=>{const G=s.args.map(($,N)=>{if(!$.validate(B[N]))throw new Error(`Invalid argument '${$.name}' when running '${s.id}', received: ${B[N]}`);return $.convert(B[N])}),q=await this.executeCommand(s.internalId,...G);return s.result.convert(q,B,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new C.Disposable(()=>{F.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,F,B,G,q,$){if(this._logService.trace("ExtHostCommands#registerCommand",F),!F.trim().length)throw new Error("invalid id");if(this._commands.has(F))throw new Error(`command '${F}' already exists`);return this._commands.set(F,{callback:B,thisArg:G,description:q,extension:$}),s&&Oe(this,u,"f").$registerCommand(F),new C.Disposable(()=>{this._commands.delete(F)&&s&&Oe(this,u,"f").$unregisterCommand(F)})}executeCommand(s,...F){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,F,!0)}async _doExecuteCommand(s,F,B){if(this._commands.has(s))return Oe(this,u,"f").$fireCommandActivationEvent(s),this._executeContributedCommand(s,F,!1);{let G=!1;const q=(0,M.cloneAndChange)(F,function($){if($ instanceof C.Position)return y.Position.from($);if($ instanceof C.Range)return y.Range.from($);if($ instanceof C.Location)return y.location.from($);if(C.NotebookRange.isNotebookRange($))return y.NotebookRange.from($);if($ instanceof ArrayBuffer)return G=!0,l.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return G=!0,l.VSBuffer.wrap($);if($ instanceof l.VSBuffer)return G=!0,$;if(!Array.isArray($))return $});try{const $=await Oe(this,u,"f").$executeCommand(s,G?new h.SerializableObjectWithBuffers(q):q,B);return(0,m.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this._doExecuteCommand(s,F,!1);throw $}}}async _executeContributedCommand(s,F,B){const G=this._commands.get(s);if(!G)throw new Error("Unknown command");const{callback:q,thisArg:$,description:N}=G;if(N)for(let x=0;x<N.args.length;x++)try{(0,i.validateConstraint)(F[x],N.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${N.args[x].name}' - ${N.args[x].description}`)}const V=I.StopWatch.create();try{return await q.apply($,F)}catch(x){if(s===this.converter.delegatingCommandId){const W=this.converter.getActualCommand(...F);W&&(s=W.command)}if(this._logService.error(x,s,G.extension?.identifier),!B)throw x;if(G.extension?.identifier){const W=Oe(this,a,"f").onExtensionError(G.extension.identifier,x);this._logService.trace("forwarded error to extension?",W,G.extension?.identifier)}throw new class extends Error{constructor(){super((0,S.toErrorMessage)(x)),this.id=s,this.source=G.extension?.displayName??G.extension?.name}}}finally{this._reportTelemetry(G,s,V.elapsed())}}_reportTelemetry(s,F,B){s.extension&&Oe(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:new v.TelemetryTrustedValue(F),duration:B})}$executeContributedCommand(s,...F){this._logService.trace("ExtHostCommands#$executeContributedCommand",s);const B=this._commands.get(s);return B?(F=F.map(G=>this._argumentProcessors.reduce((q,$)=>$.processArgument(q,B.extension?.identifier),G)),this._executeContributedCommand(s,F,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Oe(this,u,"f").$getCommands().then(F=>(s&&(F=F.filter(B=>B[0]!=="_")),F))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[F,B]of this._commands){const{description:G}=B;G&&(s[F]=G)}return Promise.resolve(s)}};u=new WeakMap,r=new WeakMap,a=new WeakMap,e.ExtHostCommands=E=je([We(0,d.IExtHostRpcService),We(1,_.ILogService),We(2,n.IExtHostTelemetry)],E),e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class D{constructor(s,F,B){this._commands=s,this._lookupApiCommand=F,this._logService=B,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,F){if(!s)return;const B={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return B;const G=this._lookupApiCommand(s.command);if(G)B.id=G.internalId,B.arguments=G.args.map((q,$)=>q.convert(s.arguments&&s.arguments[$]));else if((0,A.isNonEmptyArray)(s.arguments)){const q=`${s.command}/${++this._cachIdPool}`;this._cache.set(q,s),F.add((0,p.toDisposable)(()=>{this._cache.delete(q),this._logService.trace("CommandsConverter#DISPOSE",q)})),B.$ident=q,B.id=this.delegatingCommandId,B.arguments=[q],this._logService.trace("CommandsConverter#CREATE",s.command,q)}return B}fromInternal(s){return typeof s.$ident=="string"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const F=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],F?F.command:"MISSING"),F?this._commands.executeCommand(F.command,...F.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${s[0]}`)}}e.CommandsConverter=D;class f{constructor(s,F,B,G){this.name=s,this.description=F,this.validate=B,this.convert=G}optional(){return new f(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,F){return new f(s??this.name,F??this.description,this.validate,this.convert)}}e.ApiCommandArgument=f,f.Uri=new f("uri","Uri of a text document",o=>c.URI.isUri(o),o=>o),f.Position=new f("position","A position in a text document",o=>C.Position.isPosition(o),y.Position.from),f.Range=new f("range","A range in a text document",o=>C.Range.isRange(o),y.Range.from),f.Selection=new f("selection","A selection in a text document",o=>C.Selection.isSelection(o),y.Selection.from),f.Number=new f("number","",o=>typeof o=="number",o=>o),f.String=new f("string","",o=>typeof o=="string",o=>o),f.CallHierarchyItem=new f("item","A call hierarchy item",o=>o instanceof C.CallHierarchyItem,y.CallHierarchyItem.from),f.TypeHierarchyItem=new f("item","A type hierarchy item",o=>o instanceof C.TypeHierarchyItem,y.TypeHierarchyItem.from),f.TestItem=new f("testItem","A VSCodium TestItem",o=>o instanceof t.TestItemImpl,y.TestItem.from);class T{constructor(s,F){this.description=s,this.convert=F}}e.ApiCommandResult=T,T.Void=new T("no result",o=>o);class w{constructor(s,F,B,G,q){this.id=s,this.internalId=F,this.description=B,this.args=G,this.result=q}}e.ApiCommand=w}),define(Ae[219],Re([1,0,18,15,2,78,91,31,95,32,8,7]),function(te,e,i,C,y,M,O,A,_,m,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const c=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(R.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,l)=>{if((0,i.isFalsyOrEmpty)(t))return;class h extends b.SymbolInformation{static to(I){const v=new h(I.name,R.SymbolKind.to(I.kind),I.containerName||"",new b.Location(l[0],R.Range.to(I.range)));return v.detail=I.detail,v.range=v.location.range,v.selectionRange=R.Range.to(I.selectionRange),v.children=I.children?I.children.map(h.to):[],v}}return t.map(h.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(R.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(R.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(l=>b.Position.isPosition(l)),t=>t.map(R.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(l=>{let h;for(const S of l.reverse())h=new b.SelectionRange(R.Range.to(S),h);return h}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new b.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const l=(0,O.decodeSemanticTokensDto)(t);if(l.type==="full")return new b.SemanticTokens(l.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new b.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const l=(0,O.decodeSemanticTokensDto)(t);if(l.type==="full")return new b.SemanticTokens(l.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,l,h)=>{if(!t)return new b.CompletionList([]);const S=t.suggestions.map(I=>R.CompletionItem.to(I,h));return new b.CompletionList(S,t.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,l,h)=>g(S=>new b.CodeLens(R.Range.to(S.range),S.command&&h.fromInternal(S.command)))(t))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>b.Range.isRange(t),t=>b.Selection.isSelection(t)?R.Selection.from(t):R.Range.from(t)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,l,h)=>g(S=>{if(S._isSynthetic){if(!S.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(S.command)}else{const I=new b.CodeAction(S.title,S.kind?new b.CodeActionKind(S.kind):void 0);return S.edit&&(I.edit=R.WorkspaceEdit.to(S.edit)),S.command&&(I.command=h.fromInternal(S.command)),I.isPreferred=S.isPreferred,I}})(t))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(l=>new b.ColorInformation(R.Range.to(l.range),R.Color.to(l.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",t=>t instanceof b.Color,R.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,l,h)=>t.map(R.InlayHint.to.bind(void 0,h)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,l)=>{if(t)return t.map(R.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(l=>R.NotebookExclusiveDocumentPattern.to(l))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>y.URI.isUri(t)||typeof t=="string"&&(0,_.matchesSomeScheme)(t,C.Schemas.http,C.Schemas.https),t=>t),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],m.ApiCommandResult.Void)];class p{static register(l){c.forEach(l.registerApiCommand,l),this._registerValidateWhenClausesCommand(l)}static _registerValidateWhenClausesCommand(l){l.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=p;function g(t){return l=>{if(Array.isArray(l))return l.map(t)}}function d(t){if(!Array.isArray(t))return;const l=[];for(const h of t)M.isLocationLink(h)?l.push(R.DefinitionLink.to(h)):l.push(R.location.to(h));return l}}),define(Ae[220],Re([1,0,16,65,5,6,2,78,23,8,7,4,20,9]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function g(d,t,l){const h=d.getProxy(b.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new _.ExtensionIdentifierMap,t.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const T=this._commentControllers.get(f.handle);return T?T.value:f}else if(f&&f.$mid===7){const T=this._commentControllers.get(f.commentControlHandle);if(!T)return f;const w=T.getCommentThread(f.commentThreadHandle);return w?w.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const T=this._commentControllers.get(f.thread.commentControlHandle);if(!T)return f;const w=T.getCommentThread(f.thread.commentThreadHandle);return w?f.$mid===8?w.value:{thread:w.value,text:f.text}:f}else if(f&&f.$mid===10){const T=this._commentControllers.get(f.thread.commentControlHandle);if(!T)return f;const w=T.getCommentThread(f.thread.commentThreadHandle);if(!w)return f;const o=f.commentUniqueId,s=w.getCommentByUniqueId(o);return s||f}else if(f&&f.$mid===11){const T=this._commentControllers.get(f.thread.commentControlHandle);if(!T)return f;const w=T.getCommentThread(f.thread.commentThreadHandle);if(!w)return f;const o=f.text,s=f.commentUniqueId,F=w.getCommentByUniqueId(s);return F?(typeof F.body=="string"?F.body=o:F.body=new R.MarkdownString(o),F):f}return f}})}createCommentController(f,T,w){const o=S.handlePool++,s=new v(f,o,T,w);this._commentControllers.set(s.handle,s);const F=this._commentControllersByExtension.get(f.identifier)||[];return F.push(s),this._commentControllersByExtension.set(f.identifier,F),s.value}$createCommentThreadTemplate(f,T,w){const o=this._commentControllers.get(f);o&&o.$createCommentThreadTemplate(T,w)}async $updateCommentThreadTemplate(f,T,w){const o=this._commentControllers.get(f);o&&o.$updateCommentThreadTemplate(T,w)}$deleteCommentThread(f,T){this._commentControllers.get(f)?.$deleteCommentThread(T)}$provideCommentingRanges(f,T,w){const o=this._commentControllers.get(f);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const s=l.getDocument(O.URI.revive(T));return(0,i.asPromise)(async()=>{const F=await o.commentingRangeProvider.provideCommentingRanges(s,w);let B;return Array.isArray(F)?B={ranges:F,fileComments:!1}:F?B={ranges:F.ranges||[],fileComments:F.fileComments||!1}:B=(0,p.withNullAsUndefined)(F),B}).then(F=>{let B;return F&&(B={ranges:F.ranges.map(G=>m.Range.from(G)),fileComments:F.fileComments}),B})}$toggleReaction(f,T,w,o,s){const F=this._commentControllers.get(f);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const B=F.getCommentThread(T);if(B){const G=B.getCommentByUniqueId(o.uniqueIdInThread);if(F!==void 0&&G&&F.reactionHandler)return F.reactionHandler(G,r(s))}return Promise.resolve(void 0)})}}S.handlePool=0;class I{set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){(f===void 0!=(this._range===void 0)||!f||!this._range||!f.isEqual(this._range))&&(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(f){this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,T,w,o,s,F,B,G){this._commentControllerHandle=T,this._id=w,this._uri=o,this._range=s,this._comments=F,this.extensionDescription=B,this._isTemplate=G,this.handle=I._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),h.$createCommentThread(T,this.handle,this._id,this._uri,m.Range.from(this._range),B.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(T,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range($){q.range=$},get comments(){return q.comments},set comments($){q.comments=$},get collapsibleState(){return q.collapsibleState},set collapsibleState($){q.collapsibleState=$},get canReply(){return q.canReply},set canReply($){q.canReply=$},get contextValue(){return q.contextValue},set contextValue($){q.contextValue=$},get label(){return q.label},set label($){q.label=$},get state(){return q.state},set state($){q.state=$},dispose:()=>{q.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const f=w=>Object.prototype.hasOwnProperty.call(this.modifications,w),T={};f("range")&&(T.range=m.Range.from(this._range)),f("label")&&(T.label=this.label),f("contextValue")&&(T.contextValue=this.contextValue??null),f("comments")&&(T.comments=this._comments.map(w=>n(this,w,this._commentsMap,this.extensionDescription))),f("collapsibleState")&&(T.collapseState=a(this._collapseState)),f("canReply")&&(T.canReply=this.canReply),f("state")&&(T.state=E(this._state)),f("isTemplate")&&(T.isTemplate=this._isTemplate),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,T)}getCommentByUniqueId(f){for(const T of this._commentsMap){const w=T[0],o=T[1];if(f===o)return w}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}I._handlePool=0,je([(0,C.debounce)(100)],I.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,T,w,o){this._extension=f,this._handle=T,this._id=w,this._label=o,this._threads=new Map,h.$registerCommentController(this.handle,w,o);const s=this;this.value=Object.freeze({id:s.id,label:s.label,get options(){return s.options},set options(F){s.options=F},get commentingRangeProvider(){return s.commentingRangeProvider},set commentingRangeProvider(F){s.commentingRangeProvider=F},get reactionHandler(){return s.reactionHandler},set reactionHandler(F){s.reactionHandler=F},createCommentThread(F,B,G){return s.createCommentThread(F,B,G).value},dispose:()=>{s.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(f,T,w){T===void 0&&(0,c.checkProposedApiEnabled)(this._extension,"fileComments");const o=new I(this.id,this.handle,void 0,f,T,w,this._extension,!1);return this._threads.set(o.handle,o),o}$createCommentThreadTemplate(f,T){const w=new I(this.id,this.handle,void 0,O.URI.revive(f),m.Range.to(T),[],this._extension,!0);return w.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(w.handle,w),w}$updateCommentThreadTemplate(f,T){const w=this._threads.get(f);w&&(w.range=m.Range.to(T))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function n(D,f,T,w){let o=T.get(f);return o||(o=++D.commentHandle,T.set(f,o)),f.state!==void 0&&(0,c.checkProposedApiEnabled)(w,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:o,body:typeof f.body=="string"?f.body:m.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(s=>u(s)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function u(D){return{label:D.label,iconPath:D.iconPath?m.pathOrURIToURI(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted}}function r(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?O.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1}}function a(D){if(D!==void 0)switch(D){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function E(D){if(D!==void 0)switch(D){case R.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new S}e.createExtHostComments=g}),define(Ae[221],Re([1,0,26,4,27,17]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let O=e.AbstractExtHostConsoleForwarder=class{constructor(R,b){this._mainThreadConsole=R.getProxy(C.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,b){const c=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){c._handleConsoleCall(R,b,p,arguments)}})}_handleConsoleCall(R,b,c,p){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:_(p,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,c,p)}};e.AbstractExtHostConsoleForwarder=O=je([We(0,M.IExtHostRpcService),We(1,y.IExtHostInitDataService)],O);const A=1e5;function _(m,R){const b=[];if(m.length)for(let c=0;c<m.length;c++){let p=m[c];if(typeof p>"u")p="undefined";else if(p instanceof Error){const g=p;g.stack?p=g.stack:p=g.toString()}b.push(p)}if(R){const c=new Error().stack;c&&b.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,i.safeStringify)(b);return c.length>A?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Ae[107],Re([1,0,2,4,7,3,17,14,18,13,19,20]),function(te,e,i,C,y,M,O,A,_,m,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let c=e.ExtHostDecorations=class an{constructor(g,d){this._logService=d,this._provider=new Map,this._proxy=g.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,d){const t=an._handlePool++;this._provider.set(t,{provider:g,extensionDescription:d}),this._proxy.$registerDecorationProvider(t,d.identifier.value);const l=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(t,null);return}const S=(0,_.asArray)(h);if(S.length<=an._maxEventSize){this._proxy.$onDidChange(t,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,S.length);const I=S.map(u=>({uri:u,rank:(0,m.count)(u.path,"/")})),v=(0,_.groupBy)(I,(u,r)=>u.rank-r.rank||(0,m.compare)(u.uri.path,r.uri.path)),n=[];e:for(const u of v){let r;for(const a of u){const E=(0,R.dirname)(a.uri.path);if(r!==E&&(r=E,n.push(a.uri)>=an._maxEventSize))break e}}this._proxy.$onDidChange(t,n)});return new y.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(g,d,t){if(!this._provider.has(g))return Object.create(null);const l=Object.create(null),{provider:h,extensionDescription:S}=this._provider.get(g);return await Promise.all(d.map(async I=>{try{const{uri:v,id:n}=I,u=await Promise.resolve(h.provideFileDecoration(i.URI.revive(v),t));if(!u)return;try{y.FileDecoration.validate(u),u.badge&&typeof u.badge!="string"&&(0,b.checkProposedApiEnabled)(S,"codiconDecoration"),l[n]=[u.propagate,u.tooltip,u.badge,u.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${S}': ${r}`)}}catch(v){this._logService.error(v)}})),l}};c._handlePool=0,c._maxEventSize=250,e.ExtHostDecorations=c=je([We(0,O.IExtHostRpcService),We(1,A.ILogService)],c),e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[222],Re([1,0,147,94,2,4,7,8,5,14,28,38]),function(te,e,i,C,y,M,O,A,_,m,R,b){"use strict";var c,p,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(h,S,I,v,n,u,r){this._name=h,this._owner=S,this._maxDiagnosticsPerFile=I,this._modelVersionIdProvider=v,c.set(this,void 0),p.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Qe(this,g,new R.ResourceMap(a=>n.getComparisonKey(a)),"f"),Qe(this,c,u,"f"),Qe(this,p,r,"f")}dispose(){this._isDisposed||(Oe(this,p,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,c,"f")?.$clear(this._owner),Oe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(h,S){if(!h){this.clear();return}this._checkDisposed();let I=[];if(y.URI.isUri(h)){if(!S){this.delete(h);return}Oe(this,g,"f").set(h,S.slice()),I=[h]}else if(Array.isArray(h)){I=[];let n;h=[...h].sort(d._compareIndexedTuplesByUri);for(const u of h){const[r,a]=u;if((!n||r.toString()!==n.toString())&&(n&&Oe(this,g,"f").get(n).length===0&&Oe(this,g,"f").delete(n),n=r,I.push(r),Oe(this,g,"f").set(r,[])),a)Oe(this,g,"f").get(r)?.push(...a);else{const E=Oe(this,g,"f").get(r);E&&(E.length=0)}}}if(Oe(this,p,"f").fire(I),!Oe(this,c,"f"))return;const v=[];for(const n of I){let u=[];const r=Oe(this,g,"f").get(n);if(r)if(r.length>this._maxDiagnosticsPerFile){u=[];const a=[O.DiagnosticSeverity.Error,O.DiagnosticSeverity.Warning,O.DiagnosticSeverity.Information,O.DiagnosticSeverity.Hint];e:for(let E=0;E<4;E++)for(const D of r)if(D.severity===a[E]&&u.push({...A.Diagnostic.from(D),modelVersionId:this._modelVersionIdProvider(n)})===this._maxDiagnosticsPerFile)break e;u.push({severity:C.MarkerSeverity.Info,message:(0,i.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=r.map(a=>({...A.Diagnostic.from(a),modelVersionId:this._modelVersionIdProvider(n)}));v.push([n,u])}Oe(this,c,"f").$changeMany(this._owner,v)}delete(h){this._checkDisposed(),Oe(this,p,"f").fire([h]),Oe(this,g,"f").delete(h),Oe(this,c,"f")?.$changeMany(this._owner,[[h,void 0]])}clear(){this._checkDisposed(),Oe(this,p,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,g,"f").clear(),Oe(this,c,"f")?.$clear(this._owner)}forEach(h,S){this._checkDisposed();for(const[I,v]of this)h.call(S,I,v,this)}*[(c=new WeakMap,p=new WeakMap,g=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const h of Oe(this,g,"f").keys())yield[h,this.get(h)]}get(h){this._checkDisposed();const S=Oe(this,g,"f").get(h);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(h){return this._checkDisposed(),Array.isArray(Oe(this,g,"f").get(h))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(h,S){return h[0].toString()<S[0].toString()?-1:h[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=d;let t=e.ExtHostDiagnostics=class Ei{static _mapper(h){const S=new R.ResourceMap;for(const I of h)S.set(I,I);return{uris:Object.freeze(Array.from(S.values()))}}constructor(h,S,I,v){this._logService=S,this._fileSystemInfoService=I,this._extHostDocumentsAndEditors=v,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Ei._mapper),this._proxy=h.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(h,S){const{_collections:I,_proxy:v,_onDidChangeDiagnostics:n,_logService:u,_fileSystemInfoService:r,_extHostDocumentsAndEditors:a}=this,E=new class{$changeMany(T,w){v.$changeMany(T,w),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,T,w.length===0?"CLEARING":w)}$clear(T){v.$clear(T),u.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,T)}dispose(){v.dispose()}};let D;if(!S)S="_generated_diagnostic_collection_name_#"+Ei._idPool++,D=S;else if(!I.has(S))D=S;else{this._logService.warn(`DiagnosticCollection with name '${S}' does already exist.`);do D=S+Ei._idPool++;while(I.has(D))}return new class extends d{constructor(){super(S,D,Ei._maxDiagnosticsPerFile,T=>a.getDocument(T)?.version,r.extUri,E,n),I.set(D,this)}dispose(){super.dispose(),I.delete(D)}}}getDiagnostics(h){if(h)return this._getDiagnostics(h);{const S=new Map,I=[];for(const v of this._collections.values())v.forEach((n,u)=>{let r=S.get(n.toString());typeof r>"u"&&(r=I.length,S.set(n.toString(),r),I.push([n,[]])),I[r][1]=I[r][1].concat(...u)});return I}}_getDiagnostics(h){let S=[];for(const I of this._collections.values())I.has(h)&&(S=S.concat(I.get(h)));return S}$acceptMarkersChange(h){if(!this._mirrorCollection){const S="_generated_mirror",I=new d(S,S,Ei._maxDiagnosticsPerFile,v=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(S,I),this._mirrorCollection=I}for(const[S,I]of h)this._mirrorCollection.set(y.URI.revive(S),I.map(A.Diagnostic.to))}};t._idPool=0,t._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=t=je([We(1,m.ILogService),We(2,b.IExtHostFileSystemInfo)],t)}),define(Ae[223],Re([1,0,2,4,20]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(A){this._proxy=A.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(A,_){return _?.allowUIResources&&(0,y.checkProposedApiEnabled)(A,"showLocal"),this._proxy.$showOpenDialog(_).then(m=>m?m.map(R=>i.URI.revive(R)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(_=>_?i.URI.revive(_):void 0)}}e.ExtHostDialogs=M}),define(Ae[224],Re([1,0,10,2,7,4,15,22,13]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{constructor(b,c,p){this._documentsAndEditors=c,this._logService=p,this._documentContentProviders=new Map,this._proxy=b.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,c){if(Object.keys(O.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const p=m._handlePool++;this._documentContentProviders.set(p,c),this._proxy.$registerTextContentProvider(p,b);let g;return typeof c.onDidChange=="function"&&(g=c.onDidChange(d=>{if(d.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(p,d).then(t=>{if(!t&&typeof t!="string")return;const l=this._documentsAndEditors.getDocument(d);if(!l)return;const h=(0,_.splitLines)(t);if(!l.equalLines(h))return this._proxy.$onVirtualDocumentChange(d,t)},i.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(b,c){const p=this._documentContentProviders.get(b);return p?Promise.resolve(p.provideTextDocumentContent(C.URI.revive(c),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=m,m._handlePool=0}),define(Ae[225],Re([1,0,5,6,2,4,103,8,9,26,7]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(p,g){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const t of d)this._onDidRemoveDocument.fire(t.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const t of d)this._onDidAddDocument.fire(t.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const g=this._documentsAndEditors.getDocument(p);if(g)return g}getDocument(p){const g=this.getDocumentData(p);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return g.document}ensureDocumentData(p){const g=this._documentsAndEditors.getDocument(p);if(g)return Promise.resolve(g);let d=this._documentLoader.get(p.toString());return d||(d=this._proxy.$tryOpenDocument(p).then(t=>{this._documentLoader.delete(p.toString());const l=y.URI.revive(t);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(l))},t=>(this._documentLoader.delete(p.toString()),Promise.reject(t))),this._documentLoader.set(p.toString(),d)),d}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(g=>y.URI.revive(g))}$acceptModelLanguageChanged(p,g){const d=y.URI.revive(p),t=this._documentsAndEditors.getDocument(d);if(!t)throw new Error("unknown document");this._onDidRemoveDocument.fire(t.document),t._acceptLanguageId(g),this._onDidAddDocument.fire(t.document)}$acceptModelSaved(p){const g=y.URI.revive(p),d=this._documentsAndEditors.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(p,g){const d=y.URI.revive(p),t=this._documentsAndEditors.getDocument(d);if(!t)throw new Error("unknown document");t._acceptIsDirty(g),this._onDidChangeDocument.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,g,d){const t=y.URI.revive(p),l=this._documentsAndEditors.getDocument(t);if(!l)throw new Error("unknown document");l._acceptIsDirty(d),l.onEvents(g);let h;g.isUndoing?h=R.TextDocumentChangeReason.Undo:g.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,m.deepFreeze)({document:l.document,contentChanges:g.changes.map(S=>({range:A.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:h}))}setWordDefinitionFor(p,g){(0,O.setWordDefinitionFor)(p,g)}}e.ExtHostDocuments=b}),define(Ae[59],Re([1,0,49,5,6,2,3,4,103,17,106,8,14,28,15,88,66]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(I){this.value=I,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let h=e.ExtHostDocumentsAndEditors=class{constructor(I,v){this._extHostRpc=I,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(I){this.acceptDocumentsAndEditorsDelta(I)}acceptDocumentsAndEditorsDelta(I){const v=[],n=[],u=[];if(I.removedDocuments)for(const r of I.removedDocuments){const a=M.URI.revive(r),E=this._documents.get(a);E?.unref()&&(this._documents.delete(a),v.push(E.value))}if(I.addedDocuments)for(const r of I.addedDocuments){const a=M.URI.revive(r.uri);let E=this._documents.get(a);if(E&&a.scheme!==g.Schemas.vscodeNotebookCell&&a.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);E||(E=new l(new _.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(a,E),n.push(E.value)),E.ref()}if(I.removedEditors)for(const r of I.removedEditors){const a=this._editors.get(r);this._editors.delete(r),a&&u.push(a)}if(I.addedEditors)for(const r of I.addedEditors){const a=M.URI.revive(r.documentUri);i.ok(this._documents.has(a),`document '${a}' does not exist`),i.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const E=this._documents.get(a).value,D=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>E.document),r.selections.map(b.Selection.to),r.options,r.visibleRanges.map(f=>b.Range.to(f)),typeof r.editorPosition=="number"?b.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,D)}I.newActiveEditor!==void 0&&(i.ok(I.newActiveEditor===null||this._editors.has(I.newActiveEditor),`active editor '${I.newActiveEditor}' does not exist`),this._activeEditorId=I.newActiveEditor),(0,y.dispose)(v),(0,y.dispose)(u),I.removedDocuments&&this._onDidRemoveDocuments.fire(v),I.addedDocuments&&this._onDidAddDocuments.fire(n),(I.removedEditors||I.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),I.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(I){return this._documents.get(I)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),I=>I.value)}getEditor(I){return this._editors.get(I)}activeEditor(I){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return I?v:v?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=h=je([We(0,m.IExtHostRpcService),We(1,c.ILogService)],h),e.IExtHostDocumentsAndEditors=(0,O.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ae[60],Re([1,0,8,4,2,5,3,7,17,9,64]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,O.createDecorator)("IExtHostEditorTabs");class b{constructor(t,l,h){this._activeTabIdGetter=h,this._parentGroup=l,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,l={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(l)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(y.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(y.URI.revive(this._dto.input.base),y.URI.revive(this._dto.input.input1),y.URI.revive(this._dto.input.input2),y.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(y.URI.revive(this._dto.input.uri),y.URI.revive(this._dto.input.inputBoxUri));default:return}}}class c{constructor(t,l){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=l;for(const h of t.tabs)h.isActive&&(this._activeTabId=h.id),this._tabs.push(new b(h,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,l={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return i.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(h=>h.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(h=>h.apiObject))}};this._apiObject=Object.freeze(l)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const h=new b(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,h),t.tabDto.isActive&&(this._activeTabId=h.tabId),h}else if(t.kind===1){const h=this._tabs.splice(t.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return h.tabId===this._activeTabId&&(this._activeTabId=""),h}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this._tabs.splice(t.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,h),h}const l=this._tabs.find(h=>h.tabId===t.tabDto.id);if(!l)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),l.acceptDtoUpdate(t.tabDto),l}activeTabId(){return this._activeTabId}}let p=e.ExtHostEditorTabs=class{constructor(t){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,l={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(h=>h.apiObject))},get activeTabGroup(){const h=t._activeGroupId;return(0,m.assertIsDefined)(t._extHostTabGroups.find(I=>I.groupId===h)?.apiObject)},close:async(h,S)=>{const I=Array.isArray(h)?h:[h];return I.length?g(I[0])?this._closeGroups(I,S):this._closeTabs(I,S):!0}};this._apiObject=Object.freeze(l)}return this._apiObject}$acceptEditorTabModel(t){const l=new Set(this._extHostTabGroups.map(r=>r.groupId)),h=new Set(t.map(r=>r.groupId)),S=(0,R.diffSets)(l,h),I=this._extHostTabGroups.filter(r=>S.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],n=[];this._extHostTabGroups=t.map(r=>{const a=new c(r,()=>this._activeGroupId);return S.added.includes(a.groupId)?v.push(a.apiObject):n.push(a.apiObject),a});const u=(0,m.assertIsDefined)(t.find(r=>r.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:v,closed:I,changed:n}))}$acceptTabGroupUpdate(t){const l=this._extHostTabGroups.find(h=>h.groupId===t.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const l=this._extHostTabGroups.find(S=>S.groupId===t.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const h=l.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}_findExtHostTabFromApi(t){for(const l of this._extHostTabGroups)for(const h of l.tabs)if(h.apiObject===t)return h}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(l=>l.apiObject===t)}async _closeTabs(t,l){const h=[];for(const S of t){const I=this._findExtHostTabFromApi(S);if(!I)throw new Error("Tab close: Invalid tab not found!");h.push(I.tabId)}return this._proxy.$closeTab(h,l)}async _closeGroups(t,l){const h=[];for(const S of t){const I=this._findExtHostTabGroupFromApi(S);if(!I)throw new Error("Group close: Invalid group not found!");h.push(I.groupId)}return this._proxy.$closeGroup(h,l)}};e.ExtHostEditorTabs=p=je([We(0,_.IExtHostRpcService)],p);function g(d){return d.tabs!==void 0}}),define(Ae[226],Re([1,0,2,4,6,7,8,273,13,24,20]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const d=this._schemes.indexOf(g);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),d=[];let t,l,h=14,S=14;for(const I of g){let v=t?(0,_.commonPrefixLength)(t,I):0;for(v===0?l=1:l=S;v<I.length;v++)v+1===I.length?(h=S,S=9):S+=1,d.push([l,I.toUpperCase().charCodeAt(v),S]),d.push([l,I.toLowerCase().charCodeAt(v),S]),l=S;t=I,S=h}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new A.StateMachine(d)}}provideDocumentLinks(g){this._initStateMachine();const d=[],t=A.LinkComputer.computeLinks({getLineContent(l){return g.lineAt(l-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const l of t){const h=O.DocumentLink.to(l);h.target&&d.push(h)}return d}}class c{constructor(g,d){this._extHostLanguageFeatures=d,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,d,t,l={}){if(c._validateFileSystemProvider(t),this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const h=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(h,t);let S=2;l.isCaseSensitive&&(S+=1024),l.isReadonly&&(S+=2048),typeof t.copy=="function"&&(S+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.checkProposedApiEnabled)(g,"fsChunks"),S+=4),this._proxy.$registerFileSystemProvider(h,d,S).catch(v=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(v)});const I=t.onDidChangeFile(v=>{const n=[];for(const u of v){const{uri:r,type:a}=u;if(r.scheme!==d)continue;let E;switch(a){case M.FileChangeType.Changed:E=0;break;case M.FileChangeType.Created:E=1;break;case M.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:r,type:E})}this._proxy.$onFileSystemChange(h,n)});return(0,y.toDisposable)(()=>{I.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(h),this._proxy.$unregisterProvider(h)})}static _validateFileSystemProvider(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(g){const{type:d,ctime:t,mtime:l,size:h,permissions:S}=g;return{type:d,ctime:t,mtime:l,size:h,permissions:S}}$stat(g,d){return Promise.resolve(this._getFsProvider(g).stat(i.URI.revive(d))).then(t=>c._asIStat(t))}$readdir(g,d){return Promise.resolve(this._getFsProvider(g).readDirectory(i.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this._getFsProvider(g).readFile(i.URI.revive(d))).then(t=>m.VSBuffer.wrap(t))}$writeFile(g,d,t,l){return Promise.resolve(this._getFsProvider(g).writeFile(i.URI.revive(d),t.buffer,l))}$delete(g,d,t){return Promise.resolve(this._getFsProvider(g).delete(i.URI.revive(d),t))}$rename(g,d,t,l){return Promise.resolve(this._getFsProvider(g).rename(i.URI.revive(d),i.URI.revive(t),l))}$copy(g,d,t,l){const h=this._getFsProvider(g);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(i.URI.revive(d),i.URI.revive(t),l))}$mkdir(g,d){return Promise.resolve(this._getFsProvider(g).createDirectory(i.URI.revive(d)))}$watch(g,d,t,l){const h=this._getFsProvider(g).watch(i.URI.revive(t),l);this._watches.set(d,h)}$unwatch(g,d){const t=this._watches.get(d);t&&(t.dispose(),this._watches.delete(d))}$open(g,d,t){const l=this._getFsProvider(g);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(i.URI.revive(d),t))}$close(g,d){const t=this._getFsProvider(g);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(d))}$read(g,d,t,l){const h=this._getFsProvider(g);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const S=m.VSBuffer.alloc(l);return Promise.resolve(h.read(d,t,S.buffer,0,l)).then(I=>S.slice(0,I))}$write(g,d,t,l){const h=this._getFsProvider(g);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(d,t,l.buffer,0,l.byteLength))}_getFsProvider(g){const d=this._fsProvider.get(g);if(!d){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return d}}e.ExtHostFileSystem=c}),define(Ae[61],Re([1,0,4,43,7,24,3,17,38,6]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=e.ExtHostConsumerFileSystem=class ii{constructor(c,p){this._fileSystemProvider=new Map,this._proxy=c.getProxy(i.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(d){try{let t;const l=g._fileSystemProvider.get(d.scheme);return l?(await g._proxy.$ensureActivation(d.scheme),t=await l.stat(d)):t=await g._proxy.$stat(d),{type:t.type,ctime:t.ctime,mtime:t.mtime,size:t.size,permissions:t.permissions===C.FilePermission.Readonly?1:void 0}}catch(t){ii._handleError(t)}},async readDirectory(d){try{const t=g._fileSystemProvider.get(d.scheme);return t?(await g._proxy.$ensureActivation(d.scheme),(await t.readDirectory(d)).slice()):await g._proxy.$readdir(d)}catch(t){return ii._handleError(t)}},async createDirectory(d){try{return await g._proxy.$mkdir(d)}catch(t){return ii._handleError(t)}},async readFile(d){try{const t=g._fileSystemProvider.get(d.scheme);return t?(await g._proxy.$ensureActivation(d.scheme),(await t.readFile(d)).slice()):(await g._proxy.$readFile(d)).buffer}catch(t){return ii._handleError(t)}},async writeFile(d,t){try{return await g._proxy.$writeFile(d,M.VSBuffer.wrap(t))}catch(l){return ii._handleError(l)}},async delete(d,t){try{const l=g._fileSystemProvider.get(d.scheme);return l?(await g._proxy.$ensureActivation(d.scheme),await l.delete(d,{recursive:!1,...t})):await g._proxy.$delete(d,{recursive:!1,useTrash:!1,atomic:!1,...t})}catch(l){return ii._handleError(l)}},async rename(d,t,l){try{return await g._proxy.$rename(d,t,{overwrite:!1,...l})}catch(h){return ii._handleError(h)}},async copy(d,t,l){try{return await g._proxy.$copy(d,t,{overwrite:!1,...l})}catch(h){return ii._handleError(h)}},isWritableFileSystem(d){const t=p.getCapabilities(d);if(typeof t=="number")return!(t&2048)}})}static _handleError(c){if(c instanceof y.FileSystemError)throw c;if(c instanceof C.FileSystemProviderError)switch(c.code){case C.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(c.message);case C.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(c.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(c.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(c.message);case C.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(c.message);case C.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(c.message);default:throw new y.FileSystemError(c.message,c.name)}if(!(c instanceof Error))throw new y.FileSystemError(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw y.FileSystemError.Unavailable(c.message);switch(c.name){case C.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(c.message);case C.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(c.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(c.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(c.message);case C.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(c.message);case C.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(c.message);default:throw new y.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,p){return this._fileSystemProvider.set(c,p),(0,m.toDisposable)(()=>this._fileSystemProvider.delete(c))}};e.ExtHostConsumerFileSystem=R=je([We(0,A.IExtHostRpcService),We(1,_.IExtHostFileSystemInfo)],R),e.IExtHostConsumerFileSystem=(0,O.createDecorator)("IExtHostConsumerFileSystem")}),define(Ae[227],Re([1,0,5,37,2,4,8,7]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(b,c,p,g,d,t,l,h){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter;const S=this.ensureWatching(b,p,d);this._config=0,t&&(this._config+=1),l&&(this._config+=2),h&&(this._config+=4);const I=(0,C.parse)(d),v=typeof d=="string",n=g(u=>{if(!t)for(const r of u.created){const a=y.URI.revive(r);I(a.fsPath)&&(!v||c.getWorkspaceFolder(a))&&this._onDidCreate.fire(a)}if(!l)for(const r of u.changed){const a=y.URI.revive(r);I(a.fsPath)&&(!v||c.getWorkspaceFolder(a))&&this._onDidChange.fire(a)}if(!h)for(const r of u.deleted){const a=y.URI.revive(r);I(a.fsPath)&&(!v||c.getWorkspaceFolder(a))&&this._onDidDelete.fire(a)}});this._disposable=A.Disposable.from(S,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(b,c,p){const g=A.Disposable.from();if(typeof p=="string")return g;const d=b.getProxy(M.MainContext.MainThreadFileSystem);let t=!1;(p.pattern.includes(C.GLOBSTAR)||p.pattern.includes(C.GLOB_SPLIT))&&(t=!0);const l=Math.random();return d.$watch(c.identifier.value,l,p.baseUri,{recursive:t,excludes:[]}),A.Disposable.from({dispose:()=>d.$unwatch(l)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class m{constructor(b,c,p){this._mainContext=b,this._logService=c,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,c,p,g,d,t){return new _(this._mainContext,b,c,this._onFileSystemEvent.event,O.GlobPattern.from(p),g,d,t)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,c){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(p=>({oldUri:y.URI.revive(p.source),newUri:y.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(p=>y.URI.revive(p.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:c.map(p=>y.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,c){return(p,g,d)=>{const t=function(h){p.call(g,h)};return t.extension=b,c.event(t,void 0,d)}}async $onWillRunFileOperation(b,c,p,g){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(d=>({oldUri:y.URI.revive(d.source),newUri:y.URI.revive(d.target)}))},p,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(d=>y.URI.revive(d.target))},p,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(d=>y.URI.revive(d.target))},p,g)}}async _fireWillEvent(b,c,p,g){const d=new Set,t=[];if(await b.fireAsync(c,g,async(h,S)=>{const I=Date.now(),v=await Promise.resolve(h);v instanceof A.WorkspaceEdit&&(t.push([S.extension,v]),d.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-I>p&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),g.isCancellationRequested||t.length===0)return;const l={edits:[]};for(const[,h]of t){const{edits:S}=O.WorkspaceEdit.from(h,{getTextDocumentVersion:I=>this._extHostDocumentsAndEditors.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(S)}return{edit:l,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=m}),define(Ae[228],Re([1,0,2,32]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(O,A,_,m,R){this._extHostNotebooks=A,this._textDocumentsAndEditors=_,this._commands=m;const b=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",c=>!0,c=>c),new C.ApiCommandArgument("resource","Interactive resource Uri",c=>!0,c=>c),new C.ApiCommandArgument("controllerId","Notebook controller Id",c=>!0,c=>c),new C.ApiCommandArgument("title","Interactive editor title",c=>!0,c=>c)],new C.ApiCommandResult("Notebook and input URI",c=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(c.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:i.URI.revive(c.notebookUri),inputUri:i.URI.revive(c.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:i.URI.revive(c.notebookUri),inputUri:i.URI.revive(c.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(O,A,_,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:_,uri:O,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(i.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(O,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[O]})}}e.ExtHostInteractive=y}),define(Ae[229],Re([1,0,6,2,4,8,7,32]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class _{constructor(c,p){this.extension=c,this.provider=p,this.handle=_._pool++}}_._pool=0;class m{constructor(c){this.session=c,this.responses=[]}}class R{constructor(c,p,g,d){this._documents=g,this._logService=d,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=c.getProxy(y.MainContext.MainThreadInteractiveEditor),p.registerApiCommand(new A.ApiCommand("vscode.editorChat.start","interactiveEditor.start","Invoke a new editor chat session",[new A.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,message:t.message,autoSend:t.autoSend}})],A.ApiCommandResult.Void))}registerProvider(c,p){const g=new _(c,p);return this._inputProvider.set(g.handle,g),this._proxy.$registerInteractiveEditorProvider(g.handle,c.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,i.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(g.handle),this._inputProvider.delete(g.handle)})}async $prepareInteractiveSession(c,p,g,d){const t=this._inputProvider.get(c);if(!t){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const l=this._documents.getDocument(C.URI.revive(p)),h=M.Selection.to(g),S=await t.provider.prepareInteractiveEditorSession({document:l,selection:h},d);if(!S)return;if(S.wholeRange&&!S.wholeRange.contains(h))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const I=R._nextId++;return this._inputSessions.set(I,new m(S)),{id:I,placeholder:S.placeholder,slashCommands:S.slashCommands?.map(v=>({command:v.command,detail:v.detail,refer:v.refer})),wholeRange:M.Range.from(S.wholeRange)}}async $provideResponse(c,p,g,d){const t=this._inputProvider.get(c);if(!t)return;const l=this._inputSessions.get(p.id);if(!l)return;const h=await t.provider.provideInteractiveEditorResponse({session:l.session,prompt:g.prompt,selection:M.Selection.to(g.selection),wholeRange:M.Range.to(g.wholeRange),attempt:g.attempt},d);if(h){const S=l.responses.push(h)-1,I={wholeRange:M.Range.from(h.wholeRange),placeholder:h.placeholder};if(R._isMessageResponse(h))return{...I,id:S,type:"message",message:M.MarkdownString.from(h.contents)};const{edits:v}=h;if(v instanceof O.WorkspaceEdit)return{...I,id:S,type:"bulkEdit",edits:M.WorkspaceEdit.from(v)};if(Array.isArray(v))return{...I,id:S,type:"editorEdit",edits:v.map(M.TextEdit.from)}}}$handleFeedback(c,p,g,d){const t=this._inputProvider.get(c),l=this._inputSessions.get(p),h=l?.responses[g];if(t&&h){let S;switch(d){case 1:S=O.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:S=O.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:S=O.InteractiveEditorResponseFeedbackKind.Undone;break}t.provider.handleInteractiveEditorResponseFeedback?.(l.session,h,S)}}$releaseSession(c,p){const g=this._inputSessions.get(p),d=this._inputProvider.get(c);g&&d&&d.provider.releaseInteractiveEditorSession?.(g.session),this._inputSessions.delete(p)}static _isMessageResponse(c){return typeof c=="object"&&typeof c.contents=="object"}}e.ExtHostInteractiveEditor=R,R._nextId=0}),define(Ae[230],Re([1,0,4,7]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class y{constructor(O){this._IssueUriRequestHandlers=new Map,this._proxy=O.getProxy(i.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(O,A){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const _=this._IssueUriRequestHandlers.get(O);if(!_)throw new Error("Issue request handler not found");const m=await _.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(O,A){const _=O.identifier.value;return this._IssueUriRequestHandlers.set(_,A),this._proxy.$registerIssueUriRequestHandler(_),new C.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(_),this._IssueUriRequestHandlers.delete(_)})}}e.ExtHostIssueReporter=y}),define(Ae[231],Re([1,0,6,4]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(O){this._handlePool=0,this._proxy=O.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(O){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,O),(0,i.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=y}),define(Ae[232],Re([1,0,2,26,8,7,78,4,13,44,18,9,274,22,6,91,86,54,58,10,16,20,149]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class u{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentSymbols(k,z){const H=this._documents.getDocument(k),j=await this._provider.provideDocumentSymbols(H,z);if(!(0,R.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(y.DocumentSymbol.from):u._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(k){k=k.slice(0).sort((j,ce)=>{let pe=j.location.range.start.compareTo(ce.location.range.start);return pe===0&&(pe=ce.location.range.end.compareTo(j.location.range.end)),pe});const z=[],H=[];for(const j of k){const ce={name:j.name||"!!MISSING: name!!",kind:y.SymbolKind.from(j.kind),tags:j.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:y.Range.from(j.location.range),selectionRange:y.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(ce),z.push(ce);break}const pe=H[H.length-1];if(m.Range.containsRange(pe.range,ce.range)&&!m.Range.equalsRange(pe.range,ce.range)){pe.children?.push(ce),H.push(ce);break}H.pop()}}return z}}class r{constructor(k,z,H){this._documents=k,this._commands=z,this._provider=H,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(k,z){const H=this._documents.getDocument(k),j=await this._provider.provideCodeLenses(H,z);if(!j||z.isCancellationRequested)return;const ce=this._cache.add(j),pe=new g.DisposableStore;this._disposables.set(ce,pe);const ie={cacheId:ce,lenses:[]};for(let Se=0;Se<j.length;Se++)ie.lenses.push({cacheId:[ce,Se],range:y.Range.from(j[Se].range),command:this._commands.toInternal(j[Se].command,pe)});return ie}async resolveCodeLens(k,z){const H=k.cacheId&&this._cache.get(...k.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,z),j||(j=H),z.isCancellationRequested)return;const ce=k.cacheId&&this._disposables.get(k.cacheId[0]);if(ce)return k.command=this._commands.toInternal(j.command??r._badCmd,ce),k}releaseCodeLenses(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(ne){return Array.isArray(ne)?ne.map(y.DefinitionLink.from):ne?[y.DefinitionLink.from(ne)]:[]}class E{constructor(k,z){this._documents=k,this._provider=z}async provideDefinition(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideDefinition(j,ce,H);return a(pe)}}class D{constructor(k,z){this._documents=k,this._provider=z}async provideDeclaration(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideDeclaration(j,ce,H);return a(pe)}}class f{constructor(k,z){this._documents=k,this._provider=z}async provideImplementation(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideImplementation(j,ce,H);return a(pe)}}class T{constructor(k,z){this._documents=k,this._provider=z}async provideTypeDefinition(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideTypeDefinition(j,ce,H);return a(pe)}}class w{constructor(k,z){this._documents=k,this._provider=z}async provideHover(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideHover(j,ce,H);if(!(!pe||(0,R.isFalsyOrEmpty)(pe.contents)))return pe.range||(pe.range=j.getWordRangeAtPosition(ce)),pe.range||(pe.range=new M.Range(ce,ce)),y.Hover.from(pe)}}class o{constructor(k,z){this._documents=k,this._provider=z}async provideEvaluatableExpression(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideEvaluatableExpression(j,ce,H);if(pe)return y.EvaluatableExpression.from(pe)}}class s{constructor(k,z){this._documents=k,this._provider=z}async provideInlineValues(k,z,H,j){const ce=this._documents.getDocument(k),pe=await this._provider.provideInlineValues(ce,y.Range.to(z),y.InlineValueContext.to(H),j);if(Array.isArray(pe))return pe.map(ie=>y.InlineValue.from(ie))}}class F{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentHighlights(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideDocumentHighlights(j,ce,H);if(Array.isArray(pe))return pe.map(y.DocumentHighlight.from)}}class B{constructor(k,z){this._documents=k,this._provider=z}async provideLinkedEditingRanges(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.provideLinkedEditingRanges(j,ce,H);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,R.coalesce)(pe.ranges.map(y.Range.from)),wordPattern:pe.wordPattern}}}class G{constructor(k,z){this._documents=k,this._provider=z}async provideReferences(k,z,H,j){const ce=this._documents.getDocument(k),pe=y.Position.to(z),ie=await this._provider.provideReferences(ce,pe,H,j);if(Array.isArray(ie))return ie.map(y.location.from)}}class q{constructor(k,z,H,j,ce,pe,ie){this._documents=k,this._commands=z,this._diagnostics=H,this._provider=j,this._logService=ce,this._extension=pe,this._apiDeprecation=ie,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(k,z,H,j){const ce=this._documents.getDocument(k),pe=c.Selection.isISelection(z)?y.Selection.to(z):y.Range.to(z),ie=[];for(const Xe of this._diagnostics.getDiagnostics(k))if(pe.intersection(Xe.range)&&ie.push(Xe)>q._maxCodeActionsPerFile)break;const Se={diagnostics:ie,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},_e=await this._provider.provideCodeActions(ce,pe,Se,j);if(!(0,R.isNonEmptyArray)(_e)||j.isCancellationRequested)return;const Be=this._cache.add(_e),He=new g.DisposableStore;this._disposables.set(Be,He);const Ze=[];for(let Xe=0;Xe<_e.length;Xe++){const Ke=_e[Xe];Ke&&(q._isCommand(Ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Ke.title,command:this._commands.toInternal(Ke,He)})):(Se.only&&(Ke.kind?Se.only.contains(Ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Se.only.value} 'requested but returned code action is of kind '${Ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Se.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[Be,Xe],title:Ke.title,command:Ke.command&&this._commands.toInternal(Ke.command,He),diagnostics:Ke.diagnostics&&Ke.diagnostics.map(y.Diagnostic.from),edit:Ke.edit&&y.WorkspaceEdit.from(Ke.edit,void 0),kind:Ke.kind&&Ke.kind.value,isPreferred:Ke.isPreferred,disabled:Ke.disabled?.reason})))}return{cacheId:Be,actions:Ze}}async resolveCodeAction(k,z){const[H,j]=k,ce=this._cache.get(H,j);if(!ce||q._isCommand(ce))return{};if(!this._provider.resolveCodeAction)return{};const pe=await this._provider.resolveCodeAction(ce,z)??ce;let ie;pe.edit&&(ie=y.WorkspaceEdit.from(pe.edit,void 0));let Se;if(pe.command){const _e=this._disposables.get(H);_e&&(Se=this._commands.toInternal(pe.command,_e))}return{edit:ie,command:Se}}releaseCodeActions(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}static _isCommand(k){return typeof k.command=="string"&&typeof k.title=="string"}}q._maxCodeActionsPerFile=1e3;class ${constructor(k,z,H,j,ce){this._proxy=k,this._documents=z,this._provider=H,this._handle=j,this._extension=ce}async prepareDocumentPaste(k,z,H,j){if(!this._provider.prepareDocumentPaste)return;const ce=this._documents.getDocument(k),pe=z.map(_e=>y.Range.to(_e)),ie=y.DataTransfer.toDataTransfer(H,()=>{throw new S.NotImplementedError});if(await this._provider.prepareDocumentPaste(ce,pe,ie,j),j.isCancellationRequested)return;const Se=Array.from(ie).filter(([,_e])=>!(_e instanceof M.InternalDataTransferItem));return y.DataTransfer.from(Se)}async providePasteEdits(k,z,H,j,ce){if(!this._provider.provideDocumentPasteEdits)return;const pe=this._documents.getDocument(z),ie=H.map(Be=>y.Range.to(Be)),Se=y.DataTransfer.toDataTransfer(j,async Be=>(await this._proxy.$resolvePasteFileData(this._handle,k,Be)).buffer),_e=await this._provider.provideDocumentPasteEdits(pe,ie,Se,ce);if(_e)return{id:_e.id?this._extension.identifier.value+"."+_e.id:this._extension.identifier.value,label:_e.label??(0,n.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,priority:_e.priority??0,insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?y.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}}}class N{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentFormattingEdits(k,z,H){const j=this._documents.getDocument(k),ce=await this._provider.provideDocumentFormattingEdits(j,z,H);if(Array.isArray(ce))return ce.map(y.TextEdit.from)}}class V{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentRangeFormattingEdits(k,z,H,j){const ce=this._documents.getDocument(k),pe=y.Range.to(z),ie=await this._provider.provideDocumentRangeFormattingEdits(ce,pe,H,j);if(Array.isArray(ie))return ie.map(y.TextEdit.from)}async provideDocumentRangesFormattingEdits(k,z,H,j){(0,b.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ce=this._documents.getDocument(k),pe=z.map(y.Range.to),ie=await this._provider.provideDocumentRangesFormattingEdits(ce,pe,H,j);if(Array.isArray(ie))return ie.map(y.TextEdit.from)}}class x{constructor(k,z){this._documents=k,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,z,H,j,ce){const pe=this._documents.getDocument(k),ie=y.Position.to(z),Se=await this._provider.provideOnTypeFormattingEdits(pe,ie,H,j,ce);if(Array.isArray(Se))return Se.map(y.TextEdit.from)}}class W{constructor(k,z){this._provider=k,this._logService=z,this._cache=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,z){const H=await this._provider.provideWorkspaceSymbols(k,z);if(!(0,R.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),ce={cacheId:j,symbols:[]};for(let pe=0;pe<H.length;pe++){const ie=H[pe];if(!ie||!ie.name){this._logService.warn("INVALID SymbolInformation",ie);continue}ce.symbols.push({...y.WorkspaceSymbol.from(ie),cacheId:[j,pe]})}return ce}async resolveWorkspaceSymbol(k,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const H=this._cache.get(...k.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,z);return j&&(0,C.mixin)(k,y.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(k){this._cache.delete(k)}}class ee{static supportsResolving(k){return typeof k.prepareRename=="function"}constructor(k,z,H){this._documents=k,this._provider=z,this._logService=H}async provideRenameEdits(k,z,H,j){const ce=this._documents.getDocument(k),pe=y.Position.to(z);try{const ie=await this._provider.provideRenameEdits(ce,pe,H,j);return ie?y.WorkspaceEdit.from(ie):void 0}catch(ie){const Se=ee._asMessage(ie);return Se?{rejectReason:Se,edits:void 0}:Promise.reject(ie)}}async resolveRenameLocation(k,z,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(k),ce=y.Position.to(z);try{const pe=await this._provider.prepareRename(j,ce,H);let ie,Se;if(M.Range.isRange(pe)?(ie=pe,Se=j.getText(pe)):(0,b.isObject)(pe)&&(ie=pe.range,Se=pe.placeholder),!ie||!Se)return;if(ie.start.line>ce.line||ie.end.line<ce.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(ie),text:Se}}catch(pe){const ie=ee._asMessage(pe);return ie?{rejectReason:ie,range:void 0,text:void 0}:Promise.reject(pe)}}static _asMessage(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class Ie{constructor(k,z){this.resultId=k,this.tokens=z}}class oe{constructor(k,z){this._documents=k,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(k,z,H){const j=this._documents.getDocument(k),ce=z!==0?this._previousResults.get(z):null;let pe=typeof ce?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,ce.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return ce&&this._previousResults.delete(z),pe?(pe=oe._fixProvidedSemanticTokens(pe),this._send(oe._convertToEdits(ce,pe),pe)):null}async releaseDocumentSemanticColoring(k){this._previousResults.delete(k)}static _fixProvidedSemanticTokens(k){return oe._isSemanticTokens(k)?oe._isCorrectSemanticTokens(k)?k:new M.SemanticTokens(new Uint32Array(k.data),k.resultId):oe._isSemanticTokensEdits(k)?oe._isCorrectSemanticTokensEdits(k)?k:new M.SemanticTokensEdits(k.edits.map(z=>new M.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),k.resultId):k}static _isSemanticTokens(k){return k&&!!k.data}static _isCorrectSemanticTokens(k){return k.data instanceof Uint32Array}static _isSemanticTokensEdits(k){return k&&Array.isArray(k.edits)}static _isCorrectSemanticTokensEdits(k){for(const z of k.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(k,z){if(!oe._isSemanticTokens(z)||!k||!k.tokens)return z;const H=k.tokens,j=H.length,ce=z.data,pe=ce.length;let ie=0;const Se=Math.min(j,pe);for(;ie<Se&&H[ie]===ce[ie];)ie++;if(ie===j&&ie===pe)return new M.SemanticTokensEdits([],z.resultId);let _e=0;const Be=Se-ie;for(;_e<Be&&H[j-_e-1]===ce[pe-_e-1];)_e++;return new M.SemanticTokensEdits([{start:ie,deleteCount:j-ie-_e,data:ce.subarray(ie,pe-_e)}],z.resultId)}_send(k,z){if(oe._isSemanticTokens(k)){const H=this._nextResultId++;return this._previousResults.set(H,new Ie(k.resultId,k.data)),(0,d.encodeSemanticTokensDto)({id:H,type:"full",data:k.data})}if(oe._isSemanticTokensEdits(k)){const H=this._nextResultId++;return oe._isSemanticTokens(z)?this._previousResults.set(H,new Ie(z.resultId,z.data)):this._previousResults.set(H,new Ie(k.resultId)),(0,d.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(k.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class ue{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentRangeSemanticTokens(k,z,H){const j=this._documents.getDocument(k),ce=await this._provider.provideDocumentRangeSemanticTokens(j,y.Range.to(z),H);return ce?this._send(ce):null}_send(k){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}class X{static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}constructor(k,z,H,j,ce){this._documents=k,this._commands=z,this._provider=H,this._apiDeprecation=j,this._extension=ce,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(k,z,H,j){const ce=this._documents.getDocument(k),pe=y.Position.to(z),ie=ce.getWordRangeAtPosition(pe)||new M.Range(pe,pe),Se=ie.with({end:pe}),_e=new h.StopWatch(!0),Be=await this._provider.provideCompletionItems(ce,pe,j,y.CompletionContext.to(H));if(!Be||j.isCancellationRequested)return;const He=Array.isArray(Be)?new M.CompletionList(Be):Be,Ze=X.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),Xe=new g.DisposableStore;this._disposables.set(Ze,Xe);const Ke=[],it={x:Ze,b:Ke,a:{replace:y.Range.from(ie),insert:y.Range.from(Se)},c:He.isIncomplete||void 0,d:_e.elapsed()};for(let st=0;st<He.items.length;st++){const tt=He.items[st],Me=this._convertCompletionItem(tt,[Ze,st],Se,ie);Ke.push(Me)}return it}async resolveCompletionItem(k,z){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...k);if(!H)return;const j=await this._provider.resolveCompletionItem(H,z);if(!j)return;const ce={...H,documentation:j.documentation,detail:j.detail,additionalTextEdits:j.additionalTextEdits};return H.insertText!==j.insertText&&(this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),ce.insertText=j.insertText),this._convertCompletionItem(ce,k)}releaseCompletionItems(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_convertCompletionItem(k,z,H,j){const ce=this._disposables.get(z[0]);if(!ce)throw Error("DisposableStore is missing...");const pe=this._commands.toInternal(k.command,ce),ie={x:z,a:k.label,b:k.kind!==void 0?y.CompletionItemKind.from(k.kind):void 0,m:k.tags&&k.tags.map(y.CompletionItemTag.from),c:k.detail,d:typeof k.documentation>"u"?void 0:y.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters?.join(""),l:k.additionalTextEdits&&k.additionalTextEdits.map(y.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};k.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=k.textEdit.newText):typeof k.insertText=="string"?ie.h=k.insertText:k.insertText instanceof M.SnippetString&&(ie.h=k.insertText.value,ie.i|=4);let Se;return k.textEdit?Se=k.textEdit.range:k.range&&(Se=k.range),M.Range.isRange(Se)?ie.j=y.Range.from(Se):Se&&(!H?.isEqual(Se.inserting)||!j?.isEqual(Se.replacing))&&(ie.j={insert:y.Range.from(Se.inserting),replace:y.Range.from(Se.replacing)}),ie}}class le{async provideInlineCompletions(k,z,H,j){}disposeCompletions(k){}handleDidShowCompletionItem(k,z,H){}handlePartialAccept(k,z,H){}}class De extends le{constructor(k,z,H,j){super(),this._extension=k,this._documents=z,this._provider=H,this._commands=j,this._references=new Te,this._isAdditionsProposedApiEnabled=(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[O.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[O.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(k,z,H,j){const ce=this._documents.getDocument(k),pe=y.Position.to(z),ie=await this._provider.provideInlineCompletionItems(ce,pe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!ie||j.isCancellationRequested)return;const Se=Array.isArray(ie)?ie:ie.items,_e=this._isAdditionsProposedApiEnabled?Array.isArray(ie)?[]:ie.commands||[]:[],Be=this._isAdditionsProposedApiEnabled&&!Array.isArray(ie)?ie.suppressSuggestions:void 0,He=this._isAdditionsProposedApiEnabled&&!Array.isArray(ie)?ie.enableForwardStability:void 0;let Ze;return{pid:this._references.createReferenceId({dispose(){Ze?.dispose()},items:Se}),items:Se.map((Ke,it)=>{let st;Ke.command&&(Ze||(Ze=new g.DisposableStore),st=this._commands.toInternal(Ke.command,Ze));const tt=Ke.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ke.filterText,range:Ke.range?y.Range.from(Ke.range):void 0,command:st,idx:it,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ke.completeBracketPairs:!1}}),commands:_e.map(Ke=>(Ze||(Ze=new g.DisposableStore),this._commands.toInternal(Ke,Ze))),suppressSuggestions:Be,enableForwardStability:He}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,z,H){const j=this._references.get(k)?.items[z];j&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(j,H)}handlePartialAccept(k,z,H){const j=this._references.get(k)?.items[z];j&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(j,H)}}class Te{constructor(){this._references=new Map,this._idPool=1}createReferenceId(k){const z=this._idPool++;return this._references.set(z,k),z}disposeReferenceId(k){const z=this._references.get(k);return this._references.delete(k),z}get(k){return this._references.get(k)}}class Ee{constructor(k,z){this._documents=k,this._provider=z,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(k,z,H,j){const ce=this._documents.getDocument(k),pe=y.Position.to(z),ie=this.reviveContext(H),Se=await this._provider.provideSignatureHelp(ce,pe,j,ie);if(Se){const _e=this._cache.add([Se]);return{...y.SignatureHelp.from(Se),id:_e}}}reviveContext(k){let z;if(k.activeSignatureHelp){const H=y.SignatureHelp.to(k.activeSignatureHelp),j=this._cache.get(k.activeSignatureHelp.id,0);j?(z=j,z.activeSignature=H.activeSignature,z.activeParameter=H.activeParameter):z=H}return{...k,activeSignatureHelp:z}}releaseSignatureHelp(k){this._cache.delete(k)}}class P{constructor(k,z,H,j,ce){this._documents=k,this._commands=z,this._provider=H,this._logService=j,this._extension=ce,this._cache=new l.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(k,z,H){const j=this._documents.getDocument(k),ce=y.Range.to(z),pe=await this._provider.provideInlayHints(j,ce,H);if(!Array.isArray(pe)||pe.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${z}`);return}if(H.isCancellationRequested)return;const ie=this._cache.add(pe);this._disposables.set(ie,new g.DisposableStore);const Se={hints:[],cacheId:ie};for(let _e=0;_e<pe.length;_e++)this._isValidInlayHint(pe[_e],ce)&&Se.hints.push(this._convertInlayHint(pe[_e],[ie,_e]));return this._logService.trace(`[InlayHints] ${Se.hints.length} inlay hints from '${this._extension.identifier.value}' for ${z}`),Se}async resolveInlayHint(k,z){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...k);if(!H)return;const j=await this._provider.resolveInlayHint(H,z);if(j&&this._isValidInlayHint(j))return this._convertInlayHint(j,k)}releaseHints(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_isValidInlayHint(k,z){return k.label.length===0||Array.isArray(k.label)&&k.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(z&&!z.contains(k.position))}_convertInlayHint(k,z){const H=this._disposables.get(z[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:z,tooltip:y.MarkdownString.fromStrict(k.tooltip),position:y.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(y.TextEdit.from),kind:k.kind&&y.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?j.label=k.label:j.label=k.label.map(ce=>{const pe={label:ce.value};return pe.tooltip=y.MarkdownString.fromStrict(ce.tooltip),M.Location.isLocation(ce.location)&&(pe.location=y.location.from(ce.location)),ce.command&&(pe.command=this._commands.toInternal(ce.command,H)),pe}),j}}class K{constructor(k,z){this._documents=k,this._provider=z,this._cache=new l.Cache("DocumentLink")}async provideLinks(k,z){const H=this._documents.getDocument(k),j=await this._provider.provideDocumentLinks(H,z);if(!(!Array.isArray(j)||j.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(K._validateLink).map(y.DocumentLink.from)};{const ce=this._cache.add(j),pe={links:[],cacheId:ce};for(let ie=0;ie<j.length;ie++){if(!K._validateLink(j[ie]))continue;const Se=y.DocumentLink.from(j[ie]);Se.cacheId=[ce,ie],pe.links.push(Se)}return pe}}}static _validateLink(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,z){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...k);if(!H)return;const j=await this._provider.resolveDocumentLink(H,z);if(!(!j||!K._validateLink(j)))return y.DocumentLink.from(j)}releaseLinks(k){this._cache.delete(k)}}class he{constructor(k,z){this._documents=k,this._provider=z}async provideColors(k,z){const H=this._documents.getDocument(k),j=await this._provider.provideDocumentColors(H,z);return Array.isArray(j)?j.map(pe=>({color:y.Color.from(pe.color),range:y.Range.from(pe.range)})):[]}async provideColorPresentations(k,z,H){const j=this._documents.getDocument(k),ce=y.Range.to(z.range),pe=y.Color.to(z.color),ie=await this._provider.provideColorPresentations(pe,{document:j,range:ce},H);if(Array.isArray(ie))return ie.map(y.ColorPresentation.from)}}class ye{constructor(k,z){this._documents=k,this._provider=z}async provideFoldingRanges(k,z,H){const j=this._documents.getDocument(k),ce=await this._provider.provideFoldingRanges(j,z,H);if(Array.isArray(ce))return ce.map(y.FoldingRange.from)}}class be{constructor(k,z,H){this._documents=k,this._provider=z,this._logService=H}async provideSelectionRanges(k,z,H){const j=this._documents.getDocument(k),ce=z.map(y.Position.to),pe=await this._provider.provideSelectionRanges(j,ce,H);if(!(0,R.isNonEmptyArray)(pe))return[];if(pe.length!==ce.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ie=[];for(let Se=0;Se<ce.length;Se++){const _e=[];ie.push(_e);let Be=ce[Se],He=pe[Se];for(;;){if(!He.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(_e.push(y.SelectionRange.from(He)),!He.parent)break;Be=He.range,He=He.parent}}return ie}}class ge{constructor(k,z){this._documents=k,this._provider=z,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.prepareCallHierarchy(j,ce,H);if(!pe)return;const ie=this._idPool.nextId();return this._cache.set(ie,new Map),Array.isArray(pe)?pe.map(Se=>this._cacheAndConvertItem(ie,Se)):[this._cacheAndConvertItem(ie,pe)]}async provideCallsTo(k,z,H){const j=this._itemFromCache(k,z);if(!j)throw new Error("missing call hierarchy item");const ce=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(ce)return ce.map(pe=>({from:this._cacheAndConvertItem(k,pe.from),fromRanges:pe.fromRanges.map(ie=>y.Range.from(ie))}))}async provideCallsFrom(k,z,H){const j=this._itemFromCache(k,z);if(!j)throw new Error("missing call hierarchy item");const ce=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(ce)return ce.map(pe=>({to:this._cacheAndConvertItem(k,pe.to),fromRanges:pe.fromRanges.map(ie=>y.Range.from(ie))}))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,z){const H=this._cache.get(k),j=y.CallHierarchyItem.from(z,k,H.size.toString(36));return H.set(j._itemId,z),j}_itemFromCache(k,z){return this._cache.get(k)?.get(z)}}class Ce{constructor(k,z){this._documents=k,this._provider=z,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(k,z,H){const j=this._documents.getDocument(k),ce=y.Position.to(z),pe=await this._provider.prepareTypeHierarchy(j,ce,H);if(!pe)return;const ie=this._idPool.nextId();return this._cache.set(ie,new Map),Array.isArray(pe)?pe.map(Se=>this._cacheAndConvertItem(ie,Se)):[this._cacheAndConvertItem(ie,pe)]}async provideSupertypes(k,z,H){const j=this._itemFromCache(k,z);if(!j)throw new Error("missing type hierarchy item");const ce=await this._provider.provideTypeHierarchySupertypes(j,H);if(ce)return ce.map(pe=>this._cacheAndConvertItem(k,pe))}async provideSubtypes(k,z,H){const j=this._itemFromCache(k,z);if(!j)throw new Error("missing type hierarchy item");const ce=await this._provider.provideTypeHierarchySubtypes(j,H);if(ce)return ce.map(pe=>this._cacheAndConvertItem(k,pe))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,z){const H=this._cache.get(k),j=y.TypeHierarchyItem.from(z,k,H.size.toString(36));return H.set(j._itemId,z),j}_itemFromCache(k,z){return this._cache.get(k)?.get(z)}}class ae{constructor(k,z,H,j,ce){this._proxy=k,this._documents=z,this._provider=H,this._handle=j,this._extension=ce}async provideDocumentOnDropEdits(k,z,H,j,ce){const pe=this._documents.getDocument(z),ie=y.Position.to(H),Se=y.DataTransfer.toDataTransfer(j,async Be=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Be)).buffer),_e=await this._provider.provideDocumentDropEdits(pe,ie,Se,ce);if(_e)return{id:_e.id?this._extension.identifier.value+"."+_e.id:this._extension.identifier.value,label:_e.label??(0,n.localize)(1,null,this._extension.displayName||this._extension.name),priority:_e.priority??0,insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?y.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}}}class de{constructor(k,z){this.adapter=k,this.extension=z}}class Z{constructor(k,z,H,j,ce,pe,ie,Se){this._uriTransformer=z,this._documents=H,this._commands=j,this._diagnostics=ce,this._logService=pe,this._apiDeprecation=ie,this._extensionTelemetry=Se,this._adapter=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(k,z){return y.DocumentSelector.from(k,this._uriTransformer,z)}_createDisposable(k){return new M.Disposable(()=>{this._adapter.delete(k),this._proxy.$unregister(k)})}_nextHandle(){return Z._handlePool++}async _withAdapter(k,z,H,j,ce,pe=!1){const ie=this._adapter.get(k);if(!ie||!(ie.adapter instanceof z))return j;const Se=Date.now();pe||this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const _e=H(ie.adapter,ie.extension);return Promise.resolve(_e).catch(Be=>{(0,S.isCancellationError)(Be)||(this._logService.error(`[${ie.extension.identifier.value}] provider FAILED`),this._logService.error(Be),this._extensionTelemetry.onExtensionError(ie.extension.identifier,Be))}).finally(()=>{pe||this._logService.trace(`[${ie.extension.identifier.value}] provider DONE after ${Date.now()-Se}ms`)}),p.CancellationToken.isCancellationToken(ce)?(0,I.raceCancellationError)(_e,ce):_e}_addNewAdapter(k,z){const H=this._nextHandle();return this._adapter.set(H,new de(k,z)),H}static _extLabel(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,z,H,j){const ce=this._addNewAdapter(new u(this._documents,H),k),pe=j&&j.label||Z._extLabel(k);return this._proxy.$registerDocumentSymbolProvider(ce,this._transformDocumentSelector(z,k),pe),this._createDisposable(ce)}$provideDocumentSymbols(k,z,H){return this._withAdapter(k,u,j=>j.provideDocumentSymbols(i.URI.revive(z),H),void 0,H)}registerCodeLensProvider(k,z,H){const j=this._nextHandle(),ce=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new de(new r(this._documents,this._commands.converter,H),k)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(z,k),ce);let pe=this._createDisposable(j);if(ce!==void 0){const ie=H.onDidChangeCodeLenses(Se=>this._proxy.$emitCodeLensEvent(ce));pe=M.Disposable.from(pe,ie)}return pe}$provideCodeLenses(k,z,H){return this._withAdapter(k,r,j=>j.provideCodeLenses(i.URI.revive(z),H),void 0,H)}$resolveCodeLens(k,z,H){return this._withAdapter(k,r,j=>j.resolveCodeLens(z,H),void 0,void 0)}$releaseCodeLenses(k,z){this._withAdapter(k,r,H=>Promise.resolve(H.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(k,z,H){const j=this._addNewAdapter(new E(this._documents,H),k);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideDefinition(k,z,H,j){return this._withAdapter(k,E,ce=>ce.provideDefinition(i.URI.revive(z),H,j),[],j)}registerDeclarationProvider(k,z,H){const j=this._addNewAdapter(new D(this._documents,H),k);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideDeclaration(k,z,H,j){return this._withAdapter(k,D,ce=>ce.provideDeclaration(i.URI.revive(z),H,j),[],j)}registerImplementationProvider(k,z,H){const j=this._addNewAdapter(new f(this._documents,H),k);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideImplementation(k,z,H,j){return this._withAdapter(k,f,ce=>ce.provideImplementation(i.URI.revive(z),H,j),[],j)}registerTypeDefinitionProvider(k,z,H){const j=this._addNewAdapter(new T(this._documents,H),k);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideTypeDefinition(k,z,H,j){return this._withAdapter(k,T,ce=>ce.provideTypeDefinition(i.URI.revive(z),H,j),[],j)}registerHoverProvider(k,z,H,j){const ce=this._addNewAdapter(new w(this._documents,H),k);return this._proxy.$registerHoverProvider(ce,this._transformDocumentSelector(z,k)),this._createDisposable(ce)}$provideHover(k,z,H,j){return this._withAdapter(k,w,ce=>ce.provideHover(i.URI.revive(z),H,j),void 0,j)}registerEvaluatableExpressionProvider(k,z,H,j){const ce=this._addNewAdapter(new o(this._documents,H),k);return this._proxy.$registerEvaluatableExpressionProvider(ce,this._transformDocumentSelector(z,k)),this._createDisposable(ce)}$provideEvaluatableExpression(k,z,H,j){return this._withAdapter(k,o,ce=>ce.provideEvaluatableExpression(i.URI.revive(z),H,j),void 0,j)}registerInlineValuesProvider(k,z,H,j){const ce=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new s(this._documents,H),k);this._proxy.$registerInlineValuesProvider(pe,this._transformDocumentSelector(z,k),ce);let ie=this._createDisposable(pe);if(ce!==void 0){const Se=H.onDidChangeInlineValues(_e=>this._proxy.$emitInlineValuesEvent(ce));ie=M.Disposable.from(ie,Se)}return ie}$provideInlineValues(k,z,H,j,ce){return this._withAdapter(k,s,pe=>pe.provideInlineValues(i.URI.revive(z),H,j,ce),void 0,ce)}registerDocumentHighlightProvider(k,z,H){const j=this._addNewAdapter(new F(this._documents,H),k);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideDocumentHighlights(k,z,H,j){return this._withAdapter(k,F,ce=>ce.provideDocumentHighlights(i.URI.revive(z),H,j),void 0,j)}registerLinkedEditingRangeProvider(k,z,H){const j=this._addNewAdapter(new B(this._documents,H),k);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideLinkedEditingRanges(k,z,H,j){return this._withAdapter(k,B,async ce=>{const pe=await ce.provideLinkedEditingRanges(i.URI.revive(z),H,j);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?Z._serializeRegExp(pe.wordPattern):void 0}},void 0,j)}registerReferenceProvider(k,z,H){const j=this._addNewAdapter(new G(this._documents,H),k);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideReferences(k,z,H,j,ce){return this._withAdapter(k,G,pe=>pe.provideReferences(i.URI.revive(z),H,j,ce),void 0,ce)}registerCodeActionProvider(k,z,H,j){const ce=new g.DisposableStore,pe=this._addNewAdapter(new q(this._documents,this._commands.converter,this._diagnostics,H,this._logService,k,this._apiDeprecation),k);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(z,k),{providedKinds:j?.providedCodeActionKinds?.map(ie=>ie.value),documentation:j?.documentation?.map(ie=>({kind:ie.kind.value,command:this._commands.converter.toInternal(ie.command,ce)}))},Z._extLabel(k),!!H.resolveCodeAction),ce.add(this._createDisposable(pe)),ce}$provideCodeActions(k,z,H,j,ce){return this._withAdapter(k,q,pe=>pe.provideCodeActions(i.URI.revive(z),H,j,ce),void 0,ce)}$resolveCodeAction(k,z,H){return this._withAdapter(k,q,j=>j.resolveCodeAction(z,H),{},void 0)}$releaseCodeActions(k,z){this._withAdapter(k,q,H=>Promise.resolve(H.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(k,z,H){const j=this._addNewAdapter(new N(this._documents,H),k);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(z,k),k.identifier,k.displayName||k.name),this._createDisposable(j)}$provideDocumentFormattingEdits(k,z,H,j){return this._withAdapter(k,N,ce=>ce.provideDocumentFormattingEdits(i.URI.revive(z),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(k,z,H){const j=typeof H.provideDocumentRangesFormattingEdits=="function";j&&(0,v.checkProposedApiEnabled)(k,"formatMultipleRanges");const ce=this._addNewAdapter(new V(this._documents,H),k);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(z,k),k.identifier,k.displayName||k.name,j),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(k,z,H,j,ce){return this._withAdapter(k,V,pe=>pe.provideDocumentRangeFormattingEdits(i.URI.revive(z),H,j,ce),void 0,ce)}$provideDocumentRangesFormattingEdits(k,z,H,j,ce){return this._withAdapter(k,V,pe=>pe.provideDocumentRangesFormattingEdits(i.URI.revive(z),H,j,ce),void 0,ce)}registerOnTypeFormattingEditProvider(k,z,H,j){const ce=this._addNewAdapter(new x(this._documents,H),k);return this._proxy.$registerOnTypeFormattingSupport(ce,this._transformDocumentSelector(z,k),j,k.identifier),this._createDisposable(ce)}$provideOnTypeFormattingEdits(k,z,H,j,ce,pe){return this._withAdapter(k,x,ie=>ie.provideOnTypeFormattingEdits(i.URI.revive(z),H,j,ce,pe),void 0,pe)}registerWorkspaceSymbolProvider(k,z){const H=this._addNewAdapter(new W(z,this._logService),k);return this._proxy.$registerNavigateTypeSupport(H,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(k,z,H){return this._withAdapter(k,W,j=>j.provideWorkspaceSymbols(z,H),{symbols:[]},H)}$resolveWorkspaceSymbol(k,z,H){return this._withAdapter(k,W,j=>j.resolveWorkspaceSymbol(z,H),void 0,void 0)}$releaseWorkspaceSymbols(k,z){this._withAdapter(k,W,H=>H.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(k,z,H){const j=this._addNewAdapter(new ee(this._documents,H,this._logService),k);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(z,k),ee.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(k,z,H,j,ce){return this._withAdapter(k,ee,pe=>pe.provideRenameEdits(i.URI.revive(z),H,j,ce),void 0,ce)}$resolveRenameLocation(k,z,H,j){return this._withAdapter(k,ee,ce=>ce.resolveRenameLocation(i.URI.revive(z),H,j),void 0,j)}registerDocumentSemanticTokensProvider(k,z,H,j){const ce=this._addNewAdapter(new oe(this._documents,H),k),pe=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ce,this._transformDocumentSelector(z,k),j,pe);let ie=this._createDisposable(ce);if(pe){const Se=H.onDidChangeSemanticTokens(_e=>this._proxy.$emitDocumentSemanticTokensEvent(pe));ie=M.Disposable.from(ie,Se)}return ie}$provideDocumentSemanticTokens(k,z,H,j){return this._withAdapter(k,oe,ce=>ce.provideDocumentSemanticTokens(i.URI.revive(z),H,j),null,j)}$releaseDocumentSemanticTokens(k,z){this._withAdapter(k,oe,H=>H.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,z,H,j){const ce=this._addNewAdapter(new ue(this._documents,H),k);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ce,this._transformDocumentSelector(z,k),j),this._createDisposable(ce)}$provideDocumentRangeSemanticTokens(k,z,H,j){return this._withAdapter(k,ue,ce=>ce.provideDocumentRangeSemanticTokens(i.URI.revive(z),H,j),null,j)}registerCompletionItemProvider(k,z,H,j){const ce=this._addNewAdapter(new X(this._documents,this._commands.converter,H,this._apiDeprecation,k),k);return this._proxy.$registerCompletionsProvider(ce,this._transformDocumentSelector(z,k),j,X.supportsResolving(H),`${k.identifier.value}(${j.join("")})`),this._createDisposable(ce)}$provideCompletionItems(k,z,H,j,ce){return this._withAdapter(k,X,pe=>pe.provideCompletionItems(i.URI.revive(z),H,j,ce),void 0,ce)}$resolveCompletionItem(k,z,H){return this._withAdapter(k,X,j=>j.resolveCompletionItem(z,H),void 0,H)}$releaseCompletionItems(k,z){this._withAdapter(k,X,H=>H.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(k,z,H){const j=new De(k,this._documents,H,this._commands.converter),ce=this._addNewAdapter(j,k);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(z,k),j.supportsHandleEvents),this._createDisposable(ce)}$provideInlineCompletions(k,z,H,j,ce){return this._withAdapter(k,le,pe=>pe.provideInlineCompletions(i.URI.revive(z),H,j,ce),void 0,ce)}$handleInlineCompletionDidShow(k,z,H,j){this._withAdapter(k,le,async ce=>{ce.handleDidShowCompletionItem(z,H,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(k,z,H,j){this._withAdapter(k,le,async ce=>{ce.handlePartialAccept(z,H,j)},void 0,void 0)}$freeInlineCompletionsList(k,z){this._withAdapter(k,le,async H=>{H.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(k,z,H,j){const ce=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,pe=this._addNewAdapter(new Ee(this._documents,H),k);return this._proxy.$registerSignatureHelpProvider(pe,this._transformDocumentSelector(z,k),ce),this._createDisposable(pe)}$provideSignatureHelp(k,z,H,j,ce){return this._withAdapter(k,Ee,pe=>pe.provideSignatureHelp(i.URI.revive(z),H,j,ce),void 0,ce)}$releaseSignatureHelp(k,z){this._withAdapter(k,Ee,H=>H.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(k,z,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new P(this._documents,this._commands.converter,H,this._logService,k),k);this._proxy.$registerInlayHintsProvider(ce,this._transformDocumentSelector(z,k),typeof H.resolveInlayHint=="function",j,Z._extLabel(k));let pe=this._createDisposable(ce);if(j!==void 0){const ie=H.onDidChangeInlayHints(Se=>this._proxy.$emitInlayHintsEvent(j));pe=M.Disposable.from(pe,ie)}return pe}$provideInlayHints(k,z,H,j){return this._withAdapter(k,P,ce=>ce.provideInlayHints(i.URI.revive(z),H,j),void 0,j)}$resolveInlayHint(k,z,H){return this._withAdapter(k,P,j=>j.resolveInlayHint(z,H),void 0,H)}$releaseInlayHints(k,z){this._withAdapter(k,P,H=>H.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(k,z,H){const j=this._addNewAdapter(new K(this._documents,H),k);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(z,k),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(k,z,H){return this._withAdapter(k,K,j=>j.provideLinks(i.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveDocumentLink(k,z,H){return this._withAdapter(k,K,j=>j.resolveLink(z,H),void 0,void 0,!0)}$releaseDocumentLinks(k,z){this._withAdapter(k,K,H=>H.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(k,z,H){const j=this._addNewAdapter(new he(this._documents,H),k);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideDocumentColors(k,z,H){return this._withAdapter(k,he,j=>j.provideColors(i.URI.revive(z),H),[],H)}$provideColorPresentations(k,z,H,j){return this._withAdapter(k,he,ce=>ce.provideColorPresentations(i.URI.revive(z),H,j),void 0,j)}registerFoldingRangeProvider(k,z,H){const j=this._nextHandle(),ce=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new de(new ye(this._documents,H),k)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(z,k),k.identifier,ce);let pe=this._createDisposable(j);if(ce!==void 0){const ie=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ce));pe=M.Disposable.from(pe,ie)}return pe}$provideFoldingRanges(k,z,H,j){return this._withAdapter(k,ye,ce=>ce.provideFoldingRanges(i.URI.revive(z),H,j),void 0,j)}registerSelectionRangeProvider(k,z,H){const j=this._addNewAdapter(new be(this._documents,H,this._logService),k);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$provideSelectionRanges(k,z,H,j){return this._withAdapter(k,be,ce=>ce.provideSelectionRanges(i.URI.revive(z),H,j),[],j)}registerCallHierarchyProvider(k,z,H){const j=this._addNewAdapter(new ge(this._documents,H),k);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$prepareCallHierarchy(k,z,H,j){return this._withAdapter(k,ge,ce=>Promise.resolve(ce.prepareSession(i.URI.revive(z),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(k,z,H,j){return this._withAdapter(k,ge,ce=>ce.provideCallsTo(z,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(k,z,H,j){return this._withAdapter(k,ge,ce=>ce.provideCallsFrom(z,H,j),void 0,j)}$releaseCallHierarchy(k,z){this._withAdapter(k,ge,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(k,z,H){const j=this._addNewAdapter(new Ce(this._documents,H),k);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(z,k)),this._createDisposable(j)}$prepareTypeHierarchy(k,z,H,j){return this._withAdapter(k,Ce,ce=>Promise.resolve(ce.prepareSession(i.URI.revive(z),H,j)),void 0,j)}$provideTypeHierarchySupertypes(k,z,H,j){return this._withAdapter(k,Ce,ce=>ce.provideSupertypes(z,H,j),void 0,j)}$provideTypeHierarchySubtypes(k,z,H,j){return this._withAdapter(k,Ce,ce=>ce.provideSubtypes(z,H,j),void 0,j)}$releaseTypeHierarchy(k,z){this._withAdapter(k,Ce,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(k,z,H,j){const ce=this._nextHandle();return this._adapter.set(ce,new de(new ae(this._proxy,this._documents,H,ce,k),k)),this._proxy.$registerDocumentOnDropEditProvider(ce,this._transformDocumentSelector(z,k),(0,v.isProposedApiEnabled)(k,"dropMetadata")?j:void 0),this._createDisposable(ce)}$provideDocumentOnDropEdits(k,z,H,j,ce,pe){return this._withAdapter(k,ae,ie=>Promise.resolve(ie.provideDocumentOnDropEdits(z,i.URI.revive(H),j,ce,pe)),void 0,void 0)}registerDocumentPasteEditProvider(k,z,H,j){const ce=this._nextHandle();return this._adapter.set(ce,new de(new $(this._proxy,this._documents,H,ce,k),k)),this._proxy.$registerPasteEditProvider(ce,this._transformDocumentSelector(z,k),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this._createDisposable(ce)}$prepareDocumentPaste(k,z,H,j,ce){return this._withAdapter(k,$,pe=>pe.prepareDocumentPaste(i.URI.revive(z),H,j,ce),void 0,ce)}$providePasteEdits(k,z,H,j,ce,pe){return this._withAdapter(k,$,ie=>ie.providePasteEdits(z,i.URI.revive(H),j,ce,pe),void 0,pe)}static _serializeRegExp(k){return{pattern:k.source,flags:(0,_.regExpFlags)(k)}}static _serializeIndentationRule(k){return{decreaseIndentPattern:Z._serializeRegExp(k.decreaseIndentPattern),increaseIndentPattern:Z._serializeRegExp(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?Z._serializeRegExp(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?Z._serializeRegExp(k.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(k){return{beforeText:Z._serializeRegExp(k.beforeText),afterText:k.afterText?Z._serializeRegExp(k.afterText):void 0,previousLineText:k.previousLineText?Z._serializeRegExp(k.previousLineText):void 0,action:k.action}}static _serializeOnEnterRules(k){return k.map(Z._serializeOnEnterRule)}setLanguageConfiguration(k,z,H){const{wordPattern:j}=H;if(j&&(0,_.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(z,j):this._documents.setWordDefinitionFor(z,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const ce=this._nextHandle(),pe={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Z._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Z._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Z._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ce,z,pe),this._createDisposable(ce)}$setWordDefinitions(k){for(const z of k)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=Z,Z._handlePool=0}),define(Ae[233],Re([1,0,4,8,7,29,16,6]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(R,b,c,p){this._documents=b,this._commands=c,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,b){await this._proxy.$changeLanguage(R,b);const c=this._documents.getDocumentData(R);if(!c)throw new Error(`document '${R.toString()}' NOT found`);return c.document}async tokenAtPosition(R,b){const c=R.version,p=C.Position.from(b),g=await this._proxy.$tokensAtPosition(R.uri,p),d={type:y.StandardTokenType.Other,range:R.getWordRangeAtPosition(b)??new y.Range(b.line,b.character,b.line,b.character)};if(!g)return d;const t={range:C.Range.to(g.range),type:C.TokenType.to(g.type)};return!t.range.contains(b)||c!==R.version?d:t}createLanguageStatusItem(R,b,c){const p=this._handlePool++,g=this._proxy,d=this._ids,t=`${R.identifier.value}/${b}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);d.add(t);const l={selector:c,id:b,name:R.displayName??R.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let h;const S=new A.DisposableStore,I=()=>{h?.dispose(),h=(0,O.disposableTimeout)(()=>{S.clear(),this._proxy.$setLanguageStatus(p,{id:t,name:l.name??R.displayName??R.name,source:R.displayName??R.name,selector:C.DocumentSelector.from(l.selector,this._uriTransformer),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?M.default.Error:l.severity===y.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:l.command&&this._commands.toInternal(l.command,S),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},v={dispose(){S.dispose(),h?.dispose(),g.$removeLanguageStatus(p),d.delete(t)},get id(){return l.id},get name(){return l.name},set name(n){l.name=n,I()},get selector(){return l.selector},set selector(n){l.selector=n,I()},get text(){return l.text},set text(n){l.text=n,I()},get detail(){return l.detail},set detail(n){l.detail=n,I()},get severity(){return l.severity},set severity(n){l.severity=n,I()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(n){l.accessibilityInformation=n,I()},get command(){return l.command},set command(n){l.command=n,I()},get busy(){return l.busy},set busy(n){l.busy=n,I()}};return I(),v}}e.ExtHostLanguages=_}),define(Ae[80],Re([1,0,21,13,2,3,14,4,27,17]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=e.ExtHostLocalizationService=class{constructor(c,p,g){this.logService=g,this.bundleCache=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=c.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===i.LANGUAGE_DEFAULT}getMessage(c,p){const{message:g,args:d,comment:t}=p;if(this.isDefaultLanguage)return(0,C.format2)(g,d??{});let l=g;t&&t.length>0&&(l+=`/${Array.isArray(t)?t.join(""):t}`);const h=this.bundleCache.get(c)?.contents[l];return h||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,C.format2)(h??g,d??{})}getBundle(c){return this.bundleCache.get(c)?.contents}getBundleUri(c){return this.bundleCache.get(c)?.uri}async initializeLocalizedMessages(c){if(this.isDefaultLanguage||!c.l10n&&!c.isBuiltin||this.bundleCache.has(c.identifier.value))return;let p;const g=await this.getBundleLocation(c);if(!g){this.logService.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const d=await this._proxy.$fetchBundleContents(g),t=JSON.parse(d);p=c.isBuiltin?t.contents?.bundle:t}catch(d){this.logService.error(`Failed to load translations for ${c.identifier.value} from ${g}: ${d.message}`);return}p&&this.bundleCache.set(c.identifier.value,{contents:p,uri:g})}async getBundleLocation(c){if(c.isBuiltin){const p=await this._proxy.$fetchBuiltInBundleUri(c.identifier.value,this.currentLanguage);return y.URI.revive(p)}return c.l10n?y.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R=je([We(0,_.IExtHostInitDataService),We(1,m.IExtHostRpcService),We(2,O.ILogService)],R),e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ae[234],Re([1,0,14,4,27,17,2,68]),function(te,e,i,C,y,M,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let _=e.ExtHostLoggerService=class extends i.AbstractLoggerService{constructor(b,c){super(c.logLevel,c.logsLocation,c.loggers.map(p=>(0,A.revive)(p))),this._proxy=b.getProxy(C.MainContext.MainThreadLogger)}$setLogLevel(b,c){c?this.setLogLevel(O.URI.revive(c),b):this.setLogLevel(b)}setVisibility(b,c){super.setVisibility(b,c),this._proxy.$setVisibility(b,c)}doCreateLogger(b,c,p){return new m(this._proxy,b,c,p)}};e.ExtHostLoggerService=_=je([We(0,M.IExtHostRpcService),We(1,y.IExtHostInitDataService)],_);class m extends i.AbstractMessageLogger{constructor(b,c,p,g){super(g?.logLevel==="always"),this.proxy=b,this.file=c,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(c,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,c){const p=[[b,c]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(b){this.proxy.$log(this.file,b)}flush(){this.proxy.$flush(this.file)}}}),define(Ae[81],Re([1,0,4,3,6,17,24]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,C.createDecorator)("IExtHostManagedSockets");let A=e.ExtHostManagedSockets=class{constructor(b){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=b.getProxy(i.MainContext.MainThreadManagedSockets)}setFactory(b,c){for(const p of this._managedRemoteSockets.values())p.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new _(b,c),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(b){if(!this._factory||this._factory.socketFactoryId!==b)throw new Error(`No socket factory with id ${b}`);const c=++this._remoteSocketIdCounter,p=await this._factory.makeConnection(),g=new y.DisposableStore;return this._managedRemoteSockets.set(c,new m(c,p,g)),g.add((0,y.toDisposable)(()=>this._managedRemoteSockets.delete(c))),g.add(p.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(c),g.dispose()})),g.add(p.onDidClose(d=>{this._proxy.$onDidManagedSocketClose(c,d?.stack??d?.message),g.dispose()})),g.add(p.onDidReceiveMessage(d=>this._proxy.$onDidManagedSocketHaveData(c,O.VSBuffer.wrap(d)))),c}$remoteSocketWrite(b,c){this._managedRemoteSockets.get(b)?.actual.send(c.buffer)}$remoteSocketEnd(b){const c=this._managedRemoteSockets.get(b);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(b){await this._managedRemoteSockets.get(b)?.actual.drain?.()}};e.ExtHostManagedSockets=A=je([We(0,M.IExtHostRpcService)],A);class _{constructor(b,c){this.socketFactoryId=b,this.makeConnection=c}}class m extends y.Disposable{constructor(b,c,p){super(),this.socketId=b,this.actual=c,this._register(p)}}}),define(Ae[235],Re([1,0,4,14,20]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let O=e.ExtHostMessageService=class{constructor(_,m){this._logService=m,this._proxy=_.getProxy(i.MainContext.MainThreadMessageService)}showMessage(_,m,R,b,c){const p={source:{identifier:_.identifier,label:_.displayName||_.name}};let g;typeof b=="string"||M(b)?g=[b,...c]:(p.modal=b?.modal,p.useCustom=b?.useCustom,p.detail=b?.detail,g=c),p.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const d=[];for(let t=0;t<g.length;t++){const l=g[t];if(typeof l=="string")d.push({title:l,handle:t,isCloseAffordance:!1});else if(typeof l=="object"){const{title:h,isCloseAffordance:S}=l;d.push({title:h,isCloseAffordance:!!S,handle:t})}else this._logService.warn("Invalid message item:",l)}return this._proxy.$showMessage(m,R,p,d).then(t=>{if(typeof t=="number")return g[t]})}};e.ExtHostMessageService=O=je([We(1,C.ILogService)],O)}),define(Ae[236],Re([1,0,24,5,6,28,13,9,2,54,4,32,8,7,46,205,104,10]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(I=>I.apiEditor)}constructor(I,v,n,u){this._textDocumentsAndEditors=n,this._textDocuments=u,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter({onListenerError:l.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter({onListenerError:l.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter({onListenerError:l.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter({onListenerError:l.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new m.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=I.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=I.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=I.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=v.converter,v.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,E=r.cell.handle,f=this._documents.get(a)?.getCell(E);if(f)return f.apiCell}if(r&&r.$mid===14){const a=r.uri,E=this._documents.get(a);if(E)return E.apiNotebook}return r}}),h._registerApiCommands(v)}getEditorById(I){const v=this._editors.get(I);if(!v)throw new Error(`unknown text editor: ${I}. known editors: ${[...this._editors.keys()]} `);return v}getIdByEditor(I){for(const[v,n]of this._editors)if(n.apiEditor===I)return v}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(I,v){const n=this._documents.get(I);if(!n&&!v)throw new Error(`NO notebook document for '${I}'`);return n}static _convertNotebookRegistrationData(I,v){if(!v)return;const n=v.filenamePattern.map(u=>c.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(v.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:I.identifier,providerDisplayName:I.displayName||I.name,displayName:v.displayName,filenamePattern:n,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(I,v,n){const u=h._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,r,v);let a;return r!==void 0&&(a=n.onDidChangeCellStatusBarItems(E=>this._notebookProxy.$emitCellStatusBarEvent(r))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,r),a?.dispose()})}async createNotebookDocument(I){const v=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:I.viewType,content:I.content&&c.NotebookData.from(I.content)});return _.URI.revive(v)}async openNotebookDocument(I){const v=this._documents.get(I);if(v)return v.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(I),u=this._documents.get(_.URI.revive(n));return(0,A.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(I,v){_.URI.isUri(I)&&(I=await this.openNotebookDocument(I));let n;typeof v=="object"?n={position:c.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(c.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:n={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(I.uri,I.notebookType,n),r=u&&this._editors.get(u)?.apiEditor;if(r)return r;throw u?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(I,v,n,u){const r=this._notebookStatusBarItemProviders.get(I),a=_.URI.revive(v),E=this._documents.get(a);if(!E||!r)return;const D=E.getCellFromIndex(n);if(!D)return;const f=await r.provideCellStatusBarItems(D.apiCell,u);if(!f)return;const T=new y.DisposableStore,w=this._statusBarCache.add([T]),s=(Array.isArray(f)?f:[f]).map(F=>c.NotebookStatusBarItem.from(F,this._commandsConverter,T));return{cacheId:w,items:s}}$releaseNotebookCellStatusBarItems(I){this._statusBarCache.delete(I)}registerNotebookSerializer(I,v,n,u,r){if((0,O.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,n),this._notebookProxy.$registerNotebookSerializer(a,{id:I.identifier,location:I.extensionLocation},v,c.NotebookDocumentContentOptions.from(u),h._convertNotebookRegistrationData(I,r)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(I,v,n){const u=this._notebookSerializer.get(I);if(!u)throw new Error("NO serializer found");const r=await u.deserializeNotebook(v.buffer,n);return new g.SerializableObjectWithBuffers(c.NotebookData.from(r))}async $notebookToData(I,v,n){const u=this._notebookSerializer.get(I);if(!u)throw new Error("NO serializer found");const r=await u.serializeNotebook(c.NotebookData.to(v.value),n);return i.VSBuffer.wrap(r)}_createExtHostEditor(I,v,n){if(this._editors.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const u=new t.ExtHostNotebookEditor(v,this._notebookEditorsProxy,I,n.visibleRanges.map(c.NotebookRange.to),n.selections.map(c.NotebookRange.to),typeof n.viewColumn=="number"?c.ViewColumn.to(n.viewColumn):void 0);this._editors.set(v,u)}$acceptDocumentAndEditorsDelta(I){if(I.value.removedDocuments)for(const n of I.value.removedDocuments){const u=_.URI.revive(n),r=this._documents.get(u);r&&(r.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===u.toString()&&this._editors.delete(a.id)}if(I.value.addedDocuments){const n=[];for(const u of I.value.addedDocuments){const r=_.URI.revive(u.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,u);n.push(...u.cells.map(E=>d.ExtHostCell.asModelAddData(a.apiNotebook,E))),this._documents.get(r)?.dispose(),this._documents.set(r,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:n}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(I.value.addedEditors)for(const n of I.value.addedEditors){if(this._editors.has(n.id))return;const u=_.URI.revive(n.documentUri),r=this._documents.get(u);r&&this._createExtHostEditor(r,n.id,n)}const v=[];if(I.value.removedEditors)for(const n of I.value.removedEditors){const u=this._editors.get(n);u&&(this._editors.delete(n),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),v.push(u))}if(I.value.visibleEditors){this._visibleNotebookEditors=I.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const n=new Set;this._visibleNotebookEditors.forEach(u=>n.add(u.id));for(const u of this._editors.values()){const r=n.has(u.id);u._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}I.value.newActiveEditor===null?this._activeNotebookEditor=void 0:I.value.newActiveEditor&&(this._editors.get(I.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${I.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(I.value.newActiveEditor)),I.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(I){const v=b.ApiCommandArgument.String.with("notebookType","A notebook type"),n=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new b.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>i.VSBuffer.wrap(r))],new b.ApiCommandResult("Notebook Data",r=>c.NotebookData.to(r.value))),u=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new g.SerializableObjectWithBuffers(c.NotebookData.from(r)))],new b.ApiCommandResult("Bytes",r=>r.buffer));I.registerApiCommand(n),I.registerApiCommand(u)}}e.ExtHostNotebookController=h,h._notebookStatusBarItemProviderHandlePool=0}),define(Ae[237],Re([1,0,18,16,22,5,6,28,2,23,14,54,4,32,8,7,76,195,20,46]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let I=e.ExtHostNotebookKernels=class{constructor(f,T,w,o,s){this._initData=T,this._extHostNotebook=w,this._commands=o,this._logService=s,this._activeExecutions=new A.ResourceMap,this._activeNotebookExecutions=new A.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new b.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=f.getProxy(c.MainContext.MainThreadNotebookKernels);const F=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const G=this._extHostNotebook.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:G}}else if(B&&"notebookEditor"in B){const G=this._extHostNotebook.getIdByEditor(B.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return B})],p.ApiCommandResult.Void);this._commands.registerApiCommand(F)}createNotebookController(f,T,w,o,s,F){for(const De of this._kernelData.values())if(De.controller.id===T&&m.ExtensionIdentifier.equals(f.identifier,De.extensionId))throw new Error(`notebook controller with id '${T}' ALREADY exist`);const B=this._handlePool++,G=this;this._logService.trace(`NotebookController[${B}], CREATED by ${f.identifier.value}, ${T}`);const q=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${f.identifier}'`);let $=!1;const N=new O.DisposableStore,V=new M.Emitter,x=new M.Emitter,W={id:E(f.identifier,T),notebookType:w,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:o||f.identifier.value,preloads:F?F.map(g.NotebookRendererScript.from):[]};let ee=s??q,Ie;this._proxy.$addKernel(B,W).catch(De=>{console.log(De),$=!0});let oe=0;const ue=()=>{if($)return;const De=++oe;Promise.resolve().then(()=>{De===oe&&this._proxy.$updateKernel(B,W)})},X=new A.ResourceMap,le={get id(){return T},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return W.label},set label(De){W.label=De??f.displayName??f.name,ue()},get detail(){return W.detail??""},set detail(De){W.detail=De,ue()},get description(){return W.description??""},set description(De){W.description=De,ue()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(De){W.supportedLanguages=De,ue()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(De){W.supportsExecutionOrder=De,ue()},get rendererScripts(){return W.preloads?W.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(De){ee=De??q},get interruptHandler(){return Ie},set interruptHandler(De){Ie=De,W.supportsInterrupt=!!De,ue()},createNotebookCellExecution(De){if($)throw new Error("notebook controller is DISPOSED");if(!X.has(De.notebook.uri))throw G._logService.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(Te=>Te.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.notebook.uri.toString()}`);return G._createNotebookCellExecution(De,E(f.identifier,this.id))},createNotebookExecution(De){if((0,h.checkProposedApiEnabled)(f,"notebookExecution"),$)throw new Error("notebook controller is DISPOSED");if(!X.has(De.uri))throw G._logService.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(Te=>Te.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.uri.toString()}`);return G._createNotebookExecution(De,E(f.identifier,this.id))},dispose:()=>{$||(this._logService.trace(`NotebookController[${B}], DISPOSED`),$=!0,this._kernelData.delete(B),N.dispose(),V.dispose(),x.dispose(),this._proxy.$removeKernel(B))},updateNotebookAffinity(De,Te){Te===d.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(f,"notebookControllerAffinityHidden"),G._proxy.$updateNotebookPriority(B,De.uri,Te)},onDidReceiveMessage:x.event,postMessage(De,Te){return(0,h.checkProposedApiEnabled)(f,"notebookMessaging"),G._proxy.$postMessage(B,Te&&G._extHostNotebook.getIdByEditor(Te),De)},asWebviewUri(De){return(0,h.checkProposedApiEnabled)(f,"notebookMessaging"),(0,t.asWebviewUri)(De,G._initData.remote)}};return this._kernelData.set(B,{extensionId:f.identifier,controller:le,onDidReceiveMessage:x,onDidChangeSelection:V,associatedNotebooks:X}),le}getIdByController(f){for(const[T,w]of this._kernelData)if(w.controller===f)return E(w.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,T){const w=this._kernelDetectionTaskHandlePool++,o=this;this._logService.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${f.identifier.value}`),this._proxy.$addKernelDetectionTask(w,T);const s={dispose:()=>{this._kernelDetectionTask.delete(w),o._proxy.$removeKernelDetectionTask(w)}};return this._kernelDetectionTask.set(w,s),s}registerKernelSourceActionProvider(f,T,w){const o=this._kernelSourceActionProviderHandlePool++,s=typeof w.onDidChangeNotebookKernelSourceActions=="function"?o:void 0,F=this;this._kernelSourceActionProviders.set(o,w),this._logService.trace(`NotebookKernelSourceActionProvider[${o}], CREATED by ${f.identifier.value}`),this._proxy.$addKernelSourceActionProvider(o,o,T);let B;return s!==void 0&&(B=w.onDidChangeNotebookKernelSourceActions(G=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(s))),{dispose:()=>{this._kernelSourceActionProviders.delete(o),F._proxy.$removeKernelSourceActionProvider(o,o),B?.dispose()}}}async $provideKernelSourceActions(f,T){const w=this._kernelSourceActionProviders.get(f);if(w){const o=new O.DisposableStore;return this._kernelSourceActionProviderCache.add([o]),(await w.provideNotebookKernelSourceActions(T)??[]).map(F=>g.NotebookKernelSourceAction.from(F,this._commands.converter,o))}return[]}$acceptNotebookAssociation(f,T,w){const o=this._kernelData.get(f);if(o){const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(T));w?o.associatedNotebooks.set(s.uri,!0):o.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${f}] ASSOCIATE notebook`,s.uri.toString(),w),o.onDidChangeSelection.fire({selected:w,notebook:s.apiNotebook})}}async $executeCells(f,T,w){const o=this._kernelData.get(f);if(!o)return;const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(T)),F=[];for(const B of w){const G=s.getCell(B);G&&F.push(G.apiCell)}try{this._logService.trace(`NotebookController[${f}] EXECUTE cells`,s.uri.toString(),F.length),await o.controller.executeHandler.call(o.controller,F,s.apiNotebook,o.controller)}catch(B){this._logService.error(`NotebookController[${f}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(f,T,w){const o=this._kernelData.get(f);if(!o)return;const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(T));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,s.apiNotebook);else for(const F of w){const B=s.getCell(F);B&&this._activeExecutions.get(B.uri)?.cancel()}if(o.controller.interruptHandler){const F=this._activeNotebookExecutions.get(s.uri);w.length&&Array.isArray(F)&&F.length&&F.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(f,T,w){const o=this._kernelData.get(f);if(!o)return;const s=this._extHostNotebook.getEditorById(T);o.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:w}))}$cellExecutionChanged(f,T,w){const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(f)).getCell(T);if(s){const F=w?g.NotebookCellExecutionState.to(w):d.NotebookCellExecutionState.Idle;F!==void 0&&this._onDidChangeCellExecutionState.fire({cell:s.apiCell,state:F})}}_createNotebookCellExecution(f,T){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const s=new n(T,o,this._proxy);this._activeExecutions.set(o.uri,s);const F=s.onDidChangeState(()=>{s.state===v.Resolved&&(s.dispose(),F.dispose(),this._activeExecutions.delete(o.uri))});return s.asApiObject()}_createNotebookExecution(f,T){const w=this._extHostNotebook.getNotebookDocument(f.uri),o=f.getCells().find(B=>{const G=w.getCellFromApiCell(B);return G&&this._activeExecutions.has(G.uri)});if(o)throw new Error(`duplicate cell execution for ${o.document.uri}`);if(this._activeNotebookExecutions.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const s=new r(T,w,this._proxy),F=s.onDidChangeState(()=>{s.state===u.Resolved&&(s.dispose(),F.dispose(),this._activeNotebookExecutions.delete(w.uri))});return this._activeNotebookExecutions.set(w.uri,[s,F]),s.asApiObject()}};e.ExtHostNotebookKernels=I=je([We(4,R.ILogService)],I);var v;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(v||(v={}));class n extends O.Disposable{get state(){return this._state}constructor(f,T,w){super(),this._cell=T,this._proxy=w,this._handle=n.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new a(10,o=>this.update(o)),this._executionOrder=T.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,f,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(f){await this._collector.addItem(f)}async update(f){const T=Array.isArray(f)?f:[f];return this._proxy.$updateExecution(this._handle,new S.SerializableObjectWithBuffers(T))}verifyStateForOutput(){if(this._state===v.Init)throw new Error("Must call start before modifying cell output");if(this._state===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(f){let T=this._cell;if(f&&(T=this._cell.notebook.getCellFromApiCell(f)),!T)throw new Error("INVALID cell");return T.handle}validateAndConvertOutputs(f){return f.map(T=>{const w=d.NotebookCellOutput.ensureUniqueMimeTypes(T.items,!0);return w===T.items?g.NotebookCellOutput.from(T):g.NotebookCellOutput.from({items:w,id:T.id,metadata:T.metadata})})}async updateOutputs(f,T,w){const o=this.cellIndexToHandle(T),s=this.validateAndConvertOutputs((0,i.asArray)(f));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,cellHandle:o,append:w,outputs:s})}async updateOutputItems(f,T,w){return f=d.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(f),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,items:f.map(g.NotebookCellOutputItem.from),outputId:T.id,append:w})}asApiObject(){const f=this;return Object.freeze({get token(){return f._tokenSource.token},get cell(){return f._cell.apiCell},get executionOrder(){return f._executionOrder},set executionOrder(w){f._executionOrder=w,f.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:f._executionOrder}])},start(w){if(f._state===v.Resolved||f._state===v.Started)throw new Error("Cannot call start again");f._state=v.Started,f._onDidChangeState.fire(),f.update({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,o){if(f._state===v.Resolved)throw new Error("Cannot call resolve twice");f._state=v.Resolved,f._onDidChangeState.fire(),f._collector.flush(),f._proxy.$completeExecution(f._handle,new S.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:w}))},clearOutput(w){return f.verifyStateForOutput(),f.updateOutputs([],w,!1)},appendOutput(w,o){return f.verifyStateForOutput(),f.updateOutputs(w,o,!0)},replaceOutput(w,o){return f.verifyStateForOutput(),f.updateOutputs(w,o,!1)},appendOutputItems(w,o){return f.verifyStateForOutput(),f.updateOutputItems(w,o,!0)},replaceOutputItems(w,o){return f.verifyStateForOutput(),f.updateOutputItems(w,o,!1)}})}}n.HANDLE=0;var u;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(u||(u={}));class r extends O.Disposable{get state(){return this._state}constructor(f,T,w){super(),this._notebook=T,this._proxy=w,this._handle=r.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,f,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===u.Resolved||this._state===u.Started)throw new Error("Cannot call start again");this._state=u.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===u.Resolved)throw new Error("Cannot call resolve twice");this._state=u.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}r.HANDLE=0;class a{constructor(f,T){this.delay=f,this.callback=T,this.batch=[],this.startedTimer=Date.now()}addItem(f){return this.batch.push(f),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const f=this.currentDeferred;this.currentDeferred=void 0;const T=this.batch;return this.batch=[],this.callback(T).finally(()=>f.complete())}}function E(D,f){return`${D.value}/${f}`}e.createKernelId=E}),define(Ae[238],Re([1,0,5,4,104]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,_,m){const R=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(_)?.fire({editor:R.apiEditor,message:m})}createRendererMessaging(A,_){if(!A.contributes?.notebookRenderer?.some(R=>R.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);return{onDidReceiveMessage:(R,b,c)=>this.getOrCreateEmitterFor(_).event(R,b,c),postMessage:(R,b)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,b]=[b,R]);const c=b&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(c?.id,_,R)}}}getOrCreateEmitterFor(A){let _=this._rendererMessageEmitters.get(A);return _||(_=new i.Emitter({onDidRemoveLastListener:()=>{_?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,_),_)}}e.ExtHostNotebookRenderers=M}),define(Ae[239],Re([1,0,6,9,2,20,4]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(m){this.handlers=new Map,this.proxy=m.getProxy(O.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,R,b){if((0,M.checkProposedApiEnabled)(m,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,b),this.proxy.$registerProfileContentHandler(R,b.name,b.description,m.identifier.value),(0,i.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(m,R,b,c){const p=this.handlers.get(m);if(!p)throw new Error(`Unknown handler with id: ${m}`);return p.saveProfile(R,b,c)}async $readProfile(m,R,b){const c=this.handlers.get(m);if(!c)throw new Error(`Unknown handler with id: ${m}`);return c.readProfile((0,C.isString)(R)?R:y.URI.revive(R),b)}}e.ExtHostProfileContentHandlers=A}),define(Ae[240],Re([1,0,2,4,16,8]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class O{constructor(_,m){this.uriTransformer=m,this.providers=new Map,this.proxy=_.getProxy(C.MainContext.MainThreadQuickDiff)}$provideOriginalResource(_,m,R){const b=i.URI.revive(m),c=this.providers.get(_);return c?(0,y.asPromise)(()=>c.provideOriginalResource(b,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(_,m,R,b){const c=O.handlePool++;return this.providers.set(c,m),this.proxy.$registerQuickDiffProvider(c,M.DocumentSelector.from(_,this.uriTransformer),R,b),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(c),this.providers.delete(c)}}}}e.ExtHostQuickDiff=O,O.handlePool=0}),define(Ae[241],Re([1,0,22,5,6,4,2,7,10,18,29,39,20,8]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(d,t,l){const h=d.getProxy(M.MainContext.MainThreadQuickOpen);class S{constructor(f,T){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=T}showQuickPick(f,T,w,o=i.CancellationToken.None){this._onDidSelectItem=void 0;const s=Promise.resolve(T),F=++this._instances,B=h.$show(F,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},o),G={},q=B.then(()=>G);return Promise.race([q,s]).then($=>{if($===G)return;const N=(0,c.isProposedApiEnabled)(f,"quickPickItemTooltip");return s.then(V=>{const x=[];for(let W=0;W<V.length;W++){const ee=V[W];typeof ee=="string"?x.push({label:ee,handle:W}):ee.kind===A.QuickPickItemKind.Separator?x.push({type:"separator",label:ee.label}):(ee.tooltip&&!N&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`),x.push({label:ee.label,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:N?p.MarkdownString.fromStrict(ee.tooltip):void 0,handle:W}))}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{w.onDidSelectItem(V[W])}),h.$setItems(F,x),B.then(W=>{if(typeof W=="number")return V[W];if(Array.isArray(W))return W.map(ee=>V[ee])})})}).then(void 0,$=>{if(!(0,_.isCancellationError)($))return h.$setError(F,$),Promise.reject($)})}$onItemSelected(f){this._onDidSelectItem?.(f)}showInput(f,T=i.CancellationToken.None){return this._validateInput=f?.validateInput,h.$input(f,typeof this._validateInput=="function",T).then(void 0,w=>{if(!(0,_.isCancellationError)(w))return Promise.reject(w)})}async $validateInput(f){if(!this._validateInput)return;const T=await this._validateInput(f);if(!T||typeof T=="string")return T;let w;switch(T.severity){case A.InputBoxValidationSeverity.Info:w=R.default.Info;break;case A.InputBoxValidationSeverity.Warning:w=R.default.Warning;break;case A.InputBoxValidationSeverity.Error:w=R.default.Error;break;default:w=T.message?R.default.Error:R.default.Ignore;break}return{content:T.message,severity:w}}async showWorkspaceFolderPick(f,T=i.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!w)return;const o=await this._workspace.getWorkspaceFolders2();if(o)return o.find(s=>s.uri.toString()===w.uri.toString())}createQuickPick(f){const T=new a(f,()=>this._sessions.delete(T._id));return this._sessions.set(T._id,T),T}createInputBox(f){const T=new E(f,()=>this._sessions.delete(T._id));return this._sessions.set(T._id,T),T}$onDidChangeValue(f,T){this._sessions.get(f)?._fireDidChangeValue(T)}$onDidAccept(f){this._sessions.get(f)?._fireDidAccept()}$onDidChangeActive(f,T){const w=this._sessions.get(f);w instanceof a&&w._fireDidChangeActive(T)}$onDidChangeSelection(f,T){const w=this._sessions.get(f);w instanceof a&&w._fireDidChangeSelection(T)}$onDidTriggerButton(f,T){this._sessions.get(f)?._fireDidTriggerButton(T)}$onDidTriggerItemButton(f,T,w){const o=this._sessions.get(f);o instanceof a&&o._fireDidTriggerItemButton(T,w)}$onDidHide(f){this._sessions.get(f)?._fireDidHide()}}class I{constructor(f,T){this._extensionId=f,this._onDidDispose=T,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((T,w)=>{const o=T===A.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(o,T)}),this.update({buttons:f.map((T,w)=>({...r(T),tooltip:T.tooltip,handle:T===A.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const T=this._handlesToButtons.get(f);T&&this._onDidTriggerButtonEmitter.fire(T)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(f){if(!this._disposed){for(const T of Object.keys(f)){const w=f[T];this._pendingUpdate[T]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}I._nextId=1;function v(D){if(D instanceof A.ThemeIcon)return{id:D.id};const f=u(D),T=n(D);return{dark:typeof f=="string"?O.URI.file(f):f,light:typeof T=="string"?O.URI.file(T):T}}function n(D){return typeof D=="object"&&"light"in D?D.light:D}function u(D){return typeof D=="object"&&"dark"in D?D.dark:D}function r(D){const f=v(D.iconPath);let T,w;return"id"in f?w=b.ThemeIcon.asClassName(f):T=f,{iconPath:T,iconClass:w}}class a extends I{constructor(f,T){super(f.identifier,T),this.extension=f,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((o,s)=>{this._handlesToItems.set(s,o),this._itemsToHandles.set(o,s)});const T=(0,c.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),w=[];for(let o=0;o<f.length;o++){const s=f[o];s.kind===A.QuickPickItemKind.Separator?w.push({type:"separator",label:s.label}):(s.tooltip&&!T&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),w.push({handle:o,label:s.label,description:s.description,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow,tooltip:T?p.MarkdownString.fromStrict(s.tooltip):void 0,buttons:s.buttons?.map((F,B)=>({...r(F),tooltip:F.tooltip,handle:B}))}))}this.update({items:w})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(f){this._keepScrollPosition=f,this.update({keepScrollPosition:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(T=>this._itemsToHandles.has(T)),this.update({activeItems:this._activeItems.map(T=>this._itemsToHandles.get(T))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(T=>this._itemsToHandles.has(T)),this.update({selectedItems:this._selectedItems.map(T=>this._itemsToHandles.get(T))})}_fireDidChangeActive(f){const T=(0,m.coalesce)(f.map(w=>this._handlesToItems.get(w)));this._activeItems=T,this._onDidChangeActiveEmitter.fire(T)}_fireDidChangeSelection(f){const T=(0,m.coalesce)(f.map(w=>this._handlesToItems.get(w)));this._selectedItems=T,this._onDidChangeSelectionEmitter.fire(T)}_fireDidTriggerItemButton(f,T){const w=this._handlesToItems.get(f);if(!w||!w.buttons||!w.buttons.length)return;const o=w.buttons[T];o&&this._onDidTriggerItemButtonEmitter.fire({button:o,item:w})}}class E extends I{constructor(f,T){super(f.identifier,T),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get valueSelection(){return this._valueSelection}set valueSelection(f){this._valueSelection=f,this.update({valueSelection:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,f?typeof f=="string"?this.update({validationMessage:f,severity:R.default.Error}):this.update({validationMessage:f.message,severity:f.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new S(t,l)}e.createExtHostQuickOpen=g});var Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)},Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i};define(Ae[242],Re([1,0,2,5,65,6,16,4,18,128,14,23,39,8,20,15]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d){"use strict";var t,l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(o){if(o)return typeof o.iconPath=="string"?i.URI.file(o.iconPath):i.URI.isUri(o.iconPath)||c.ThemeIcon.isThemeIcon(o.iconPath)?o.iconPath:void 0}function I(o,s){if(!o.iconPath&&!s.iconPath)return 0;if(o.iconPath){if(!s.iconPath)return 1}else return-1;const F=typeof o.iconPath=="string"?o.iconPath:i.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id,B=typeof s.iconPath=="string"?s.iconPath:i.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,m.comparePaths)(F,B)}function v(o,s){let F=0;if(o.strikeThrough!==s.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==s.faded)return o.faded?1:-1;if(o.tooltip!==s.tooltip)return(o.tooltip||"").localeCompare(s.tooltip||"");if(F=I(o,s),F!==0)return F;if(o.light&&s.light)F=I(o.light,s.light);else{if(o.light)return 1;if(s.light)return-1}if(F!==0)return F;if(o.dark&&s.dark)F=I(o.dark,s.dark);else{if(o.dark)return 1;if(s.dark)return-1}return F}function n(o,s){if(o.command!==s.command)return o.command<s.command?-1:1;if(o.title!==s.title)return o.title<s.title?-1:1;if(o.tooltip!==s.tooltip){if(o.tooltip!==void 0&&s.tooltip!==void 0)return o.tooltip<s.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(o.arguments===s.arguments)return 0;if(o.arguments)if(s.arguments){if(o.arguments.length!==s.arguments.length)return o.arguments.length-s.arguments.length}else return 1;else return-1;for(let F=0;F<o.arguments.length;F++){const B=o.arguments[F],G=s.arguments[F];if(B!==G)return B<G?-1:1}return 0}function u(o,s){let F=(0,m.comparePaths)(o.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(F!==0)return F;if(o.command&&s.command)F=n(o.command,s.command);else{if(o.command)return 1;if(s.command)return-1}if(F!==0)return F;if(o.decorations&&s.decorations)F=v(o.decorations,s.decorations);else{if(o.decorations)return 1;if(s.decorations)return-1}return F}function r(o,s){for(let F=0;F<o.length;F++)if(o[F]!==s[F])return!1;return!0}function a(o,s){return o.command===s.command&&o.title===s.title&&o.tooltip===s.tooltip&&(o.arguments&&s.arguments?r(o.arguments,s.arguments):o.arguments===s.arguments)}function E(o,s){return(0,_.equals)(o,s,a)}class D{get value(){return this._value}set value(s){s=s??"",Oe(this,t,"f").$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){Oe(this,t,"f").$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,Oe(this,t,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get enabled(){return this._enabled}set enabled(s){s=!!s,this._enabled!==s&&(this._enabled=s,Oe(this,t,"f").$setInputBoxEnablement(this._sourceControlHandle,s))}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,Oe(this,t,"f").$setInputBoxVisibility(this._sourceControlHandle,s))}get document(){return(0,g.checkProposedApiEnabled)(this._extension,"scmTextDocument"),Oe(this,l,"f").getDocument(this._documentUri)}constructor(s,F,B,G,q){this._extension=s,this._sourceControlHandle=G,this._documentUri=q,t.set(this,void 0),l.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Qe(this,l,F,"f"),Qe(this,t,B,"f")}showValidationMessage(s,F){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,t,"f").$showValidationMessage(this._sourceControlHandle,s,F)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=D,t=new WeakMap,l=new WeakMap;class f{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}constructor(s,F,B,G,q){this._proxy=s,this._commands=F,this._sourceControlHandle=B,this._id=G,this._label=q,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=f._handlePool++}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,F){const B=this._resourceStatesCommandsMap.get(s);return B?(0,O.asPromise)(()=>this._commands.executeCommand(B.command,...B.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(u),B=(0,_.sortedDiff)(this._resourceSnapshot,s,u).map($=>{const N=$.toInsert.map(V=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,V);const W=V.resourceUri;let ee;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const K=new M.DisposableStore;ee=this._commands.converter.toInternal(V.command,K),this._resourceStatesDisposablesMap.set(x,K)}else this._resourceStatesCommandsMap.set(x,V.command);const Ie=S(V.decorations),oe=V.decorations&&S(V.decorations.light)||Ie,ue=V.decorations&&S(V.decorations.dark)||Ie,X=[oe,ue],le=V.decorations&&V.decorations.tooltip||"",De=V.decorations&&!!V.decorations.strikeThrough,Te=V.decorations&&!!V.decorations.faded,Ee=V.contextValue||"";return{rawResource:[x,W,X,le,De,Te,Ee,ee],handle:x}});return{start:$.start,deleteCount:$.deleteCount,toInsert:N}}),G=B.map(({start:$,deleteCount:N,toInsert:V})=>[$,N,V.map(x=>x.rawResource)]),q=B.reverse();for(const{start:$,deleteCount:N,toInsert:V}of q){const x=V.map(ee=>ee.handle),W=this._handlesSnapshot.splice($,N,...x);for(const ee of W)this._resourceStatesMap.delete(ee),this._resourceStatesCommandsMap.delete(ee),this._resourceStatesDisposablesMap.get(ee)?.dispose(),this._resourceStatesDisposablesMap.delete(ee)}return this._resourceSnapshot=s,G}dispose(){this._disposed=!0,this._onDidDispose.fire()}}f._handlePool=0;class T{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,Oe(this,h,"f").$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s;let F;(0,g.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(F=s?.label),Oe(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s,quickDiffLabel:F})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,Oe(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=s;const F=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);Oe(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:F})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=s;const F=s!==void 0?{command:this._commands.converter.toInternal(s.command,this._actionButtonDisposables.value),secondaryCommands:s.secondaryCommands?.map(B=>B.map(G=>this._commands.converter.toInternal(G,this._actionButtonDisposables.value))),description:s.description,enabled:s.enabled}:void 0;Oe(this,h,"f").$updateSourceControl(this.handle,{actionButton:F??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&E(this._statusBarCommands,s))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=s;const F=(s||[]).map(B=>this._commands.converter.toInternal(B,this._statusBarDisposables.value));Oe(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:F})}get selected(){return this._selected}constructor(s,F,B,G,q,$,N){this._extension=s,this._commands=G,this._id=q,this._label=$,this._rootUri=N,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=T._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Qe(this,h,B,"f");const V=i.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${q}/scm${this.handle}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this._inputBox=new D(s,F,Oe(this,h,"f"),this.handle,V),Oe(this,h,"f").$registerSourceControl(this.handle,q,$,N,V)}createResourceGroup(s,F){const B=new f(Oe(this,h,"f"),this._commands,this.handle,s,F),G=C.Event.once(B.onDidDispose)(()=>this.createdResourceGroups.delete(B));return this.createdResourceGroups.set(B,G),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const s=[],F=[];for(const[B,G]of this.createdResourceGroups){G.dispose();const q=B.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(B),this.eventuallyUpdateResourceStates()});C.Event.once(B.onDidDispose)(()=>{this.updatedResourceGroups.delete(B),q.dispose(),this._groups.delete(B.handle),Oe(this,h,"f").$unregisterGroup(this.handle,B.handle)}),s.push([B.handle,B.id,B.label,B.features]);const $=B._takeResourceStateSnapshot();$.length>0&&F.push([B.handle,$]),this._groups.set(B.handle,B)}Oe(this,h,"f").$registerGroups(this.handle,s,F),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(F=>{const B=F._takeResourceStateSnapshot();B.length!==0&&s.push([F.handle,B])}),s.length>0&&Oe(this,h,"f").$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),Oe(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,T._handlePool=0,je([(0,y.debounce)(100)],T.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],T.prototype,"eventuallyUpdateResourceStates",null);let w=e.ExtHostSCM=class Rn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(s,F,B,G){this._commands=F,this._extHostDocuments=B,this.logService=G,this._sourceControls=new Map,this._sourceControlsByExtension=new b.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=s.getProxy(A.MainContext.MainThreadSCM),this._telemetry=s.getProxy(A.MainContext.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const $=this._sourceControls.get(q.sourceControlHandle);if(!$)return q;const N=$.getResourceGroup(q.groupHandle);return N?N.getResourceState(q.handle):q}else if(q&&q.$mid===4){const $=this._sourceControls.get(q.sourceControlHandle);return $?$.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const $=this._sourceControls.get(q.handle);return $||q}return q}})}createSourceControl(s,F,B,G){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,F,B,G),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const q=Rn._handlePool++,$=new T(s,this._extHostDocuments,this._proxy,this._commands,F,B,G);this._sourceControls.set(q,$);const N=this._sourceControlsByExtension.get(s.identifier)||[];return N.push($),this._sourceControlsByExtension.set(s.identifier,N),$}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const F=this._sourceControlsByExtension.get(s.identifier),B=F&&F[F.length-1];return B&&B.inputBox}$provideOriginalResource(s,F,B){const G=i.URI.revive(F);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,G.toString());const q=this._sourceControls.get(s);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,O.asPromise)(()=>q.quickDiffProvider.provideOriginalResource(G,B)).then($=>$||null)}$onInputBoxValueChange(s,F){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const B=this._sourceControls.get(s);return B&&B.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(s,F,B,G){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,F,B);const q=this._sourceControls.get(s);if(!q)return Promise.resolve(void 0);const $=q.getResourceGroup(F);return $?$.$executeResourceCommand(B,G):Promise.resolve(void 0)}$validateInput(s,F,B){this.logService.trace("ExtHostSCM#$validateInput",s);const G=this._sourceControls.get(s);return!G||!G.inputBox.validateInput?Promise.resolve(void 0):(0,O.asPromise)(()=>G.inputBox.validateInput(F,B)).then(q=>{if(!q)return Promise.resolve(void 0);const $=p.MarkdownString.fromStrict(q.message);return $?Promise.resolve([$,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};w._handlePool=0,e.ExtHostSCM=w=je([We(3,R.ILogService)],w)}),define(Ae[82],Re([1,0,4,5,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,_){return this._proxy.$getPassword(A,_)}store(A,_,m){return this._proxy.$setPassword(A,_,m)}delete(A,_){return this._proxy.$deletePassword(A,_)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(Ae[243],Re([1,0,4,7]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class y{constructor(O){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=O.getProxy(i.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(O,A,_,m){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const R=this._semanticSimilarityProviders.get(O);if(!R)throw new Error("Semantic similarity provider not found");return await R.provideSimilarityScore(A,_,m)}registerSemanticSimilarityProvider(O,A){const _=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(_,A),this._proxy.$registerSemanticSimilarityProvider(_),new C.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(_),this._semanticSimilarityProviders.delete(_)})}}e.ExtHostSemanticSimilarity=y}),define(Ae[244],Re([1,0,4,8,2]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class M{constructor(A,_){this.uriTransformer=_,this.providers=new Map,this.proxy=A.getProxy(i.MainContext.MainThreadShare)}async $provideShare(A,_,m){return await this.providers.get(A)?.provideShare({selection:C.Range.to(_.range),resourceUri:y.URI.revive(_.resourceUri)},m)??void 0}registerShareProvider(A,_){const m=M.handlePool++;return this.providers.set(m,_),this.proxy.$registerShareProvider(m,C.DocumentSelector.from(A,this.uriTransformer),_.id,_.label,_.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(m),this.providers.delete(m)}}}}e.ExtHostShare=M,M.handlePool=0});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[245],Re([1,0,7,4,152,6,8,9]),function(te,e,i,C,y,M,O,A){"use strict";var _,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(g,d,t,l,h,S=i.StatusBarAlignment.Left,I){if(_.set(this,void 0),m.set(this,void 0),this._disposed=!1,this._text="",this._staleCommandRegistrations=new M.DisposableStore,Qe(this,_,g,"f"),Qe(this,m,d,"f"),h&&l){this._entryId=(0,i.asStatusBarItemIdentifier)(l.identifier,h);const v=t.get(this._entryId);v&&(this._visible=!0,this._alignment=v.alignLeft?i.StatusBarAlignment.Left:i.StatusBarAlignment.Right,this._priority=v.priority,this.name=v.name,this.text=v.text,this.command=v.command)}else this._entryId=String(R.ID_GEN++);this._extension=l,this._id=h,this._alignment=S,this._priority=this.validatePriority(I)}validatePriority(g){if((0,A.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!R.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new M.DisposableStore,typeof g=="string"?this._command={fromApi:g,internal:Oe(this,m,"f").toInternal({title:"",command:g},this._latestCommandRegistration)}:g?this._command={fromApi:g,internal:Oe(this,m,"f").toInternal(g,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,_,"f").$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let d;this._name?d=this._name:d=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let t=this._color;this._backgroundColor&&(t=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const l=O.MarkdownString.fromStrict(this._tooltip);Oe(this,_,"f").$setEntry(this._entryId,g,this._extension?.identifier.value,d,this._text,l,this._command?.internal,t,this._backgroundColor,this._alignment===i.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,_=new WeakMap,m=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const d={message:g};return this._messages.unshift(d),this._update(),new i.Disposable(()=>{const t=this._messages.indexOf(d);t>=0&&(this._messages.splice(t,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(g,d){this._existingItems=new Map,this._proxy=g.getProxy(C.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new b(this)}$acceptStaticEntries(g){for(const d of g)this._existingItems.set(d.entryId,d)}createStatusBarEntry(g,d,t,l){return new R(this._proxy,this._commands,this._existingItems,g,d,t,l)}setStatusBarMessage(g,d){const t=this._statusMessage.setMessage(g);let l;return typeof d=="number"?l=setTimeout(()=>t.dispose(),d):typeof d<"u"&&d.then(()=>t.dispose(),()=>t.dispose()),new i.Disposable(()=>{t.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=c}),define(Ae[83],Re([1,0,4,5,3]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A,_){this._logService=_,this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,_){this._proxy.$registerExtensionStorageKeysToSync(A,_)}async initializeExtensionStorage(A,_,m){const R=await this._proxy.$initializeExtensionStorage(A,_);let b;return R&&(b=this.safeParseValue(A,_,R)),b||m}setValue(A,_,m){return this._proxy.$setValue(A,_,m)}$acceptValue(A,_,m){const R=this.safeParseValue(A,_,m);R&&this._onDidChangeStorage.fire({shared:A,key:_,value:R})}safeParseValue(A,_,m){try{return JSON.parse(m)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${_}, global: ${A}): ${R}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ae[84],Re([1,0,3,27,14,61,2]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let A=e.ExtensionStoragePaths=class{constructor(m,R,b){this._logService=R,this._extHostFileSystem=b,this._workspace=m.workspace??void 0,this._environment=m.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(m){return O.URI.joinPath(this._environment.workspaceStorageHome,m)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const m=this._workspace.id,R=await this._getWorkspaceStorageURI(m);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(O.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:O.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(m){if(this._value)return O.URI.joinPath(this._value,m.identifier.value)}globalValue(m){return O.URI.joinPath(this._environment.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=A=je([We(0,C.IExtHostInitDataService),We(1,y.ILogService),We(2,M.IExtHostConsumerFileSystem)],A)}),define(Ae[62],Re([1,0,5,4,3,2,17,6,7,154,10,180,22,36,181,39,9,16,8,20]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class I{constructor(o,s,F,B){this._proxy=o,this._id=s,this._creationOptions=F,this._name=B,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(q=>this._pidPromiseComplete=q);const G=this;this.value={get name(){return G._name||""},get processId(){return G._pidPromise},get creationOptions(){return G._creationOptions},get exitStatus(){return G._exitStatus},get state(){return G._state},sendText(q,$=!0){G._checkDisposed(),G._proxy.$sendText(G._id,q,$)},show(q){G._checkDisposed(),G._proxy.$show(G._id,q)},hide(){G._checkDisposed(),G._proxy.$hide(G._id)},dispose(){G._disposed||(G._disposed=!0,G._proxy.$dispose(G._id))},get dimensions(){if(!(G._cols===void 0||G._rows===void 0))return{columns:G._cols,rows:G._rows}}}}async create(o,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,t.withNullAsUndefined)(o.shellPath),shellArgs:(0,t.withNullAsUndefined)(o.shellArgs),cwd:(0,t.withNullAsUndefined)(o.cwd),env:(0,t.withNullAsUndefined)(o.env),icon:(0,t.withNullAsUndefined)(D(o.iconPath)),color:d.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,t.withNullAsUndefined)(o.message),strictEnv:(0,t.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(o.location,s?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,s,F,B){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:F,color:d.ThemeColor.isThemeColor(B)?B.id:void 0,location:this._serializeParentTerminal(o,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,s){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in o?{viewColumn:h.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,s){this._exitStatus=Object.freeze({code:o,reason:s})}setDimensions(o,s){return o===this._cols&&s===this._rows||o===0||s===0?!1:(this._cols=o,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=I;class v{get onProcessReady(){return this._onProcessReady.event}constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new i.Emitter,this._onDidChangeProperty=new i.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,s){this._pty.setDimensions?.({columns:o,rows:s})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}let n=1,u=e.BaseExtHostTerminalService=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(o,s){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new i.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new i.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new i.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new i.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new i.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new i.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=s.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[F,B]of this._terminalProcesses)B.shutdown(!0)}})}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,s){const F=new I(this._proxy,(0,p.generateUuid)(),o,o.name),B=new v(o.pty);return F.createExtensionTerminal(o.location,this._serializeParentTerminal(o,s).resolvedExtHostIdentifier,D(o.iconPath),f(o.color)).then(G=>{const q=this._setupExtHostProcessListeners(G,B);this._terminalProcessDisposables[G]=q}),this._terminals.push(F),F.value}_serializeParentTerminal(o,s){if(s=s||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const F=o.location.parentTerminal;if(F){const B=this._terminals.find(G=>G.value===F);B&&(s.resolvedExtHostIdentifier=B._id)}}else o.location&&typeof o.location!="object"?s.location=o.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(o,s){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const B=new v(s),G=this._setupExtHostProcessListeners(o,B);this._terminalProcessDisposables[o]=G}async $acceptActiveTerminalChanged(o){const s=this._activeTerminal;if(o===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const F=this._getTerminalById(o);F&&(this._activeTerminal=F,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,s){const F=this._getTerminalById(o);F&&this._onDidWriteTerminalData.fire({terminal:F.value,data:s})}async $acceptTerminalDimensions(o,s,F){const B=this._getTerminalById(o);B&&B.setDimensions(s,F)&&this._onDidChangeTerminalDimensions.fire({terminal:B.value,dimensions:B.value.dimensions})}async $acceptTerminalMaximumDimensions(o,s,F){this._terminalProcesses.get(o)?.resize(s,F)}async $acceptTerminalTitleChange(o,s){const F=this._getTerminalById(o);F&&(F.name=s)}async $acceptTerminalClosed(o,s,F){const B=this._getTerminalObjectIndexById(this._terminals,o);if(B!==null){const G=this._terminals.splice(B,1)[0];G.setExitStatus(s,F),this._onDidCloseTerminal.fire(G.value)}}$acceptTerminalOpened(o,s,F,B){if(s){const $=this._getTerminalObjectIndexById(this._terminals,s);if($!==null){this._terminals[$]._id=o,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const G={name:B.name,shellPath:B.executable,shellArgs:B.args,cwd:typeof B.cwd=="string"?B.cwd:M.URI.revive(B.cwd),env:B.env,hideFromUser:B.hideFromUser},q=new I(this._proxy,o,G,F);this._terminals.push(q),this._onDidOpenTerminal.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(o,s){this._getTerminalById(o)?._setProcessId(s)}async $startExtensionTerminal(o,s){const F=this._getTerminalById(o);if(!F)return{message:(0,m.localize)(0,null,o)};F.isOpen||await new Promise(G=>{const q=this.onDidOpenTerminal(async $=>{$===F.value&&(q.dispose(),G())})});const B=this._terminalProcesses.get(o);B?B.startSendingEvents(s):this._extensionTerminalAwaitingStart[o]={initialDimensions:s}}_setupExtHostProcessListeners(o,s){const F=new A.DisposableStore;F.add(s.onProcessReady(G=>this._proxy.$sendProcessReady(o,G.pid,G.cwd))),F.add(s.onDidChangeProperty(G=>this._proxy.$sendProcessProperty(o,G))),this._bufferer.startBuffering(o,s.onProcessData),F.add(s.onProcessExit(G=>this._onProcessExit(o,G))),this._terminalProcesses.set(o,s);const B=this._extensionTerminalAwaitingStart[o];return B&&s instanceof v&&(s.startSendingEvents(B.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),F}$acceptProcessAckDataEvent(o,s){this._terminalProcesses.get(o)?.acknowledgeDataEvent(s)}$acceptProcessInput(o,s){this._terminalProcesses.get(o)?.input(s)}$acceptTerminalInteraction(o){const s=this._getTerminalById(o);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(o,s,F){try{this._terminalProcesses.get(o)?.resize(s,F)}catch(B){if(B.code!=="EPIPE"&&B.code!=="ERR_IPC_CHANNEL_CLOSED")throw B}}$acceptProcessShutdown(o,s){this._terminalProcesses.get(o)?.shutdown(s)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(s=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:s}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,s,F){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,F),this._proxy.$registerProfileProvider(s,o.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(o,s,F){if(this._quickFixProviders.has(o))throw new Error(`Terminal quick fix provider "${o}" is already registered`);return this._quickFixProviders.set(o,F),this._proxy.$registerQuickFixProvider(o,s),new _.Disposable(()=>{this._quickFixProviders.delete(o),this._proxy.$unregisterQuickFixProvider(o)})}async $provideTerminalQuickFixes(o,s){const F=new c.CancellationTokenSource().token;if(F.isCancellationRequested)return;const B=this._quickFixProviders.get(o);if(!B)return;const G=await B.provideTerminalQuickFixes(s,F);if(G!==null)return G}async $createContributedProfileTerminal(o,s){const F=new c.CancellationTokenSource().token;let B=await this._profileProviders.get(o)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(B&&!("options"in B)&&(B={options:B}),!B||!("options"in B))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in B.options){this.createExtensionTerminal(B.options,s);return}this.createTerminalFromOptions(B.options,s)}}async $provideLinks(o,s){const F=this._getTerminalById(o);if(!F)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const G=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,G);const q=[],$={terminal:F.value,line:s},N=[];for(const W of this._linkProviders)N.push(l.Promises.withAsyncBody(async ee=>{G.token.onCancellationRequested(()=>ee({provider:W,links:[]}));const Ie=await W.provideTerminalLinks($,G.token)||[];G.token.isCancellationRequested||ee({provider:W,links:Ie})}));const V=await Promise.all(N);if(G.token.isCancellationRequested)return[];const x=new Map;for(const W of V)W&&W.links.length>0&&q.push(...W.links.map(ee=>{const Ie={id:n++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return x.set(Ie.id,{provider:W.provider,link:ee}),Ie}));return this._terminalLinkCache.set(o,x),q}$activateLink(o,s){const F=this._terminalLinkCache.get(o)?.get(s);F&&F.provider.handleTerminalLink(F.link)}_onProcessExit(o,s){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const F=this._terminalProcessDisposables[o];F&&(F.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,s)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,s){const F=this._getTerminalObjectIndexById(o,s);return F!==null?o[F]:null}_getTerminalObjectIndexById(o,s){let F=null;return o.some((B,G)=>B._id===s?(F=G,!0):!1),F}getEnvironmentVariableCollection(o){let s=this._environmentVariableCollections.get(o.identifier.value);return s||(s=new r(o),this._setEnvironmentVariableCollection(o.identifier.value,s)),s.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(o,s){const F=(0,b.serializeEnvironmentVariableCollection)(s.map),B=(0,b.serializeEnvironmentDescriptionMap)(s.descriptionMap);this._proxy.$setEnvironmentVariableCollection(o,s.persistent,F.length===0?void 0:F,B)}$initEnvironmentVariableCollections(o){o.forEach(s=>{const F=s[0],B=new r(void 0,s[1]);this._setEnvironmentVariableCollection(F,B)})}$acceptDefaultProfile(o,s){const F=this._defaultProfile;this._defaultProfile=o,this._defaultAutomationProfile=s,F?.path!==o.path&&this._onDidChangeShell.fire(o.path)}_setEnvironmentVariableCollection(o,s){this._environmentVariableCollections.set(o,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,s)})}};e.BaseExtHostTerminalService=u=je([We(1,O.IExtHostRpcService)],u);class r{get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o,s){this._extension=o,this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,this.map=new Map(s)}getScopedEnvironmentVariableCollection(o){this._extension&&o&&(0,S.checkProposedApiEnabled)(this._extension,"envCollectionWorkspace");const s=this.getScopeKey(o);let F=this.scopedCollections.get(s);return F||(F=new a(this,o),this.scopedCollections.set(s,F),F.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),F}replace(o,s,F,B){this._extension&&F&&(0,S.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(o,{value:s,type:_.EnvironmentVariableMutatorType.Replace,options:F??{},scope:B})}append(o,s,F,B){this._extension&&F&&(0,S.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(o,{value:s,type:_.EnvironmentVariableMutatorType.Append,options:F??{},scope:B})}prepend(o,s,F,B){this._extension&&F&&(0,S.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(o,{value:s,type:_.EnvironmentVariableMutatorType.Prepend,options:F??{},scope:B})}_setIfDiffers(o,s){if(s.options&&s.options.applyAtProcessCreation===!1&&!s.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.getKey(o,s.scope),B=this.map.get(F);if(!B||B.value!==s.value||B.type!==s.type||B.options?.applyAtProcessCreation!==(s.options.applyAtProcessCreation??!0)||B.options?.applyAtShellIntegration!==(s.options.applyAtShellIntegration??!1)||B.scope?.workspaceFolder?.index!==s.scope?.workspaceFolder?.index){const G=this.getKey(o,s.scope),q={variable:o,...s,options:{applyAtProcessCreation:s.options.applyAtProcessCreation??!0,applyAtShellIntegration:s.options.applyAtShellIntegration??!1}};this.map.set(G,q),this._onDidChangeCollection.fire()}}get(o,s){const F=this.getKey(o,s),B=this.map.get(F);return B?T(B):void 0}getKey(o,s){const F=this.getScopeKey(s);return F.length?`${o}:::${F}`:o}getScopeKey(o){return this.getWorkspaceKey(o?.workspaceFolder)??""}getWorkspaceKey(o){return o?o.uri.toString():void 0}getVariableMap(o){const s=new Map;for(const[F,B]of this.map)this.getScopeKey(B.scope)===this.getScopeKey(o)&&s.set(F,T(B));return s}delete(o,s){const F=this.getKey(o,s);this.map.delete(F),this._onDidChangeCollection.fire()}clear(o){if(o?.workspaceFolder){for(const[s,F]of this.map)F.scope?.workspaceFolder?.index===o.workspaceFolder.index&&this.map.delete(s);this.clearDescription(o)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(o,s){const F=this.getScopeKey(s),B=this.descriptionMap.get(F);if(!B||B.description!==o){let G;typeof o=="string"?G=o:G=o?.value.split(`

`)[0];const q={description:G,scope:s};this.descriptionMap.set(F,q),this._onDidChangeCollection.fire()}}getDescription(o){const s=this.getScopeKey(o);return this.descriptionMap.get(s)?.description}clearDescription(o){const s=this.getScopeKey(o);this.descriptionMap.delete(s)}}class a{get persistent(){return this.collection.persistent}set persistent(o){this.collection.persistent=o}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o,s){this.collection=o,this.scope=s,this._onDidChangeCollection=new i.Emitter}getScopedEnvironmentVariableCollection(o){return this.collection.getScopedEnvironmentVariableCollection(o)}replace(o,s,F){this.collection.replace(o,s,F,this.scope)}append(o,s,F){this.collection.append(o,s,F,this.scope)}prepend(o,s,F){this.collection.prepend(o,s,F,this.scope)}get(o){return this.collection.get(o,this.scope)}forEach(o,s){this.collection.getVariableMap(this.scope).forEach((F,B)=>o.call(s,B,F,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(o){this.collection.delete(o,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(o){this.collection.setDescription(o,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let E=e.WorkerExtHostTerminalService=class extends u{constructor(o){super(!1,o)}createTerminal(o,s,F){throw new R.NotSupportedError}createTerminalFromOptions(o,s){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=E=je([We(0,O.IExtHostRpcService)],E);function D(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function f(w){return d.ThemeColor.isThemeColor(w)?w:void 0}function T(w){const o={...w};return delete o.scope,o.options=o.options??void 0,delete o.variable,o}});var Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)},Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i};define(Ae[246],Re([1,0,18,16,24,22,5,203,93,6,26,9,36,4,17,105,8,7,45,75,56,20]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v){"use strict";var n,u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=e.ExtHostTesting=class{constructor(N,V,x){this.editors=x,this.resultsChangedEmitter=new O.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(p.MainContext.MainThreadTesting),this.observer=new B(this.proxy),this.runTracker=new f(this.proxy),V.registerArgumentProcessor({processArgument:W=>{if(W?.$mid!==15)return W;const ee=W,Ie=ee.tests[ee.tests.length-1].item.extId;return this.controllers.get(h.TestId.root(Ie))?.collection.tree.get(Ie)?.actual??(0,d.toItemFromContext)(W)}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const W=await V.executeCommand("_testing.getExplorerSelection"),ee=Ie=>{const oe=this.controllers.get(h.TestId.root(Ie));if(oe)return h.TestId.isRoot(Ie)?oe.controller:oe.collection.tree.get(Ie)?.actual};return{include:W?.include.map(ee).filter(b.isDefined)||[],exclude:W?.exclude.map(ee).filter(b.isDefined)||[]}})}createTestController(N,V,x,W){if(this.controllers.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const ee=new m.DisposableStore,Ie=ee.add(new d.ExtHostTestItemCollection(V,x,this.editors));Ie.root.label=x;const oe=new Map,ue=this.proxy,X={items:Ie.root.children,get label(){return x},set label(De){x=De,Ie.root.label=De,ue.$updateController(V,{label:x})},get refreshHandler(){return W},set refreshHandler(De){W=De,ue.$updateController(V,{canRefresh:!!De})},get id(){return V},createRunProfile:(De,Te,Ee,P,K,he)=>{let ye=(0,_.hash)(De);for(;oe.has(ye);)ye++;return new G(this.proxy,oe,V,ye,De,Te,Ee,P,K,he)},createTestItem(De,Te,Ee){return new d.TestItemImpl(V,De,Te,Ee)},createTestRun:(De,Te,Ee=!0)=>this.runTracker.createTestRun(V,Ie,De,Te,Ee),invalidateTestResults:De=>{(0,v.checkProposedApiEnabled)(N,"testInvalidateResults");for(const Te of De instanceof Array?De:[De]){const Ee=Te?h.TestId.fromExtHostTestItem(Te,V).toString():V;this.proxy.$markTestRetired(Ee)}},set resolveHandler(De){Ie.resolveHandler=De},get resolveHandler(){return Ie.resolveHandler},dispose:()=>{ee.dispose()}};ue.$registerTestController(V,x,!!W),ee.add((0,m.toDisposable)(()=>ue.$unregisterTestController(V)));const le={controller:X,collection:Ie,profiles:oe};return this.controllers.set(V,le),ee.add((0,m.toDisposable)(()=>this.controllers.delete(V))),ee.add(Ie.onDidGenerateDiff(De=>ue.$publishDiff(V,De.map(I.TestsDiffOp.serialize)))),X}createTestObserver(){return this.observer.checkout()}async runTests(N,V=M.CancellationToken.None){const x=T(N);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.controllers.get(x.controllerId);if(!W)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(ee=>h.TestId.fromExtHostTestItem(ee,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:q[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:N.exclude?.map(ee=>ee.id)},V)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,V,x){return(0,i.mapFind)(this.runTracker.trackers,ee=>ee.id===N?ee.getCoverage(V):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(N,V,x,W){return(0,i.mapFind)(this.runTracker.trackers,Ie=>Ie.id===N?Ie.getCoverage(V):void 0)?.resolveFileCoverage(x,W)??Promise.resolve([])}$configureRunProfile(N,V){this.controllers.get(N)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(N,V){await this.controllers.get(N)?.controller.refreshHandler?.(V)}$publishTestResults(N){this.results=Object.freeze(N.map(V=>(0,R.deepFreeze)(t.TestResults.to(V))).concat(this.results).sort((V,x)=>x.completedAt-V.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,V){const x=this.controllers.get(h.TestId.fromString(N).controllerId)?.collection;x&&(await x.expand(N,V<0?1/0:V),x.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(I.TestsDiffOp.deserialize))}async $runControllerTests(N,V){return Promise.all(N.map(x=>this.runControllerTestRequest(x,!1,V)))}async $startContinuousRun(N,V){const x=new M.CancellationTokenSource(V),W=await Promise.all(N.map(ee=>this.runControllerTestRequest(ee,!0,x.token)));return!V.isCancellationRequested&&!W.some(ee=>ee.error)&&await new Promise(ee=>V.onCancellationRequested(ee)),x.dispose(!0),W}async runControllerTestRequest(N,V,x){const W=this.controllers.get(N.controllerId);if(!W)return{};const{collection:ee,profiles:Ie}=W,oe=Ie.get(N.profileId);if(!oe)return{};const ue=N.testIds.map(Te=>ee.tree.get(Te)).filter(b.isDefined),X=N.excludeExtIds.map(Te=>W.collection.tree.get(Te)).filter(b.isDefined).filter(Te=>ue.some(Ee=>Ee.fullId.compare(Te.fullId)===2));if(!ue.length)return{};const le=new l.TestRunRequest(ue.some(Te=>Te.actual instanceof d.TestItemRootImpl)?void 0:ue.map(Te=>Te.actual),X.map(Te=>Te.actual),oe,V),De=(0,I.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(le,w.fromInternal(N,W.collection),x);try{return await oe.runHandler(le,x),{}}catch(Te){return{error:String(Te)}}finally{De&&(De.hasRunningTasks&&!x.isCancellationRequested&&await O.Event.toPromise(De.onEnd),De.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};e.ExtHostTesting=r=je([We(0,g.IExtHostRpcService)],r);const a=1e4;var E;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(E||(E={}));class D extends m.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,V,x){super(),this.dto=N,this.proxy=V,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new O.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new M.CancellationTokenSource(x));const W=this._register(new C.RunOnceScheduler(()=>this.forciblyEndTasks(),a));this._register(this.cts.token.onCancellationRequested(()=>W.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const V=this.dto.id,x=this.dto.controllerId,W=(0,c.generateUuid)(),ee=new o(this.proxy,V,W),Ie=le=>(De,...Te)=>{if(ue){console.warn(`Setting the state of test "${De.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(De)&&(this.ensureTestIsKnown(De),le(De,...Te))},oe=(le,De)=>{const Te=De instanceof Array?De.map(t.TestMessage.from):[t.TestMessage.from(De)];if(le.uri&&le.range){const Ee={range:t.Range.from(le.range),uri:le.uri};for(const P of Te)P.location=P.location||Ee}this.proxy.$appendTestMessagesInRun(V,W,h.TestId.fromExtHostTestItem(le,x).toString(),Te)};let ue=!1;const X={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return ee.coverageProvider},set coverageProvider(le){ee.coverageProvider=le},enqueued:Ie(le=>{this.proxy.$updateTestStateInRun(V,W,h.TestId.fromExtHostTestItem(le,x).toString(),1)}),skipped:Ie(le=>{this.proxy.$updateTestStateInRun(V,W,h.TestId.fromExtHostTestItem(le,x).toString(),5)}),started:Ie(le=>{this.proxy.$updateTestStateInRun(V,W,h.TestId.fromExtHostTestItem(le,x).toString(),2)}),errored:Ie((le,De,Te)=>{oe(le,De),this.proxy.$updateTestStateInRun(V,W,h.TestId.fromExtHostTestItem(le,x).toString(),6,Te)}),failed:Ie((le,De,Te)=>{oe(le,De),this.proxy.$updateTestStateInRun(V,W,h.TestId.fromExtHostTestItem(le,x).toString(),4,Te)}),passed:Ie((le,De)=>{this.proxy.$updateTestStateInRun(V,W,h.TestId.fromExtHostTestItem(le,this.dto.controllerId).toString(),3,De)}),appendOutput:(le,De,Te)=>{ue||(Te&&(this.dto.isIncluded(Te)?this.ensureTestIsKnown(Te):Te=void 0),this.proxy.$appendOutputToRun(V,W,y.VSBuffer.fromString(le),De&&t.location.from(De),Te&&h.TestId.fromExtHostTestItem(Te,x).toString()))},end:()=>{ue||(ue=!0,this.proxy.$finishedTestRunTask(V,W),this.tasks.delete(W),this.tasks.size||this.markEnded())}};return this.tasks.set(W,{run:X,coverage:ee}),this.proxy.$startedTestRunTask(V,{id:W,name:N,running:!0}),X}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof d.TestItemImpl))throw new S.InvalidTestItemError(N.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const V=[],x=this.dto.colllection.root;for(;;){const W=t.TestItem.from(N);if(V.unshift(W),this.sharedTestIds.has(W.extId)||(this.sharedTestIds.add(W.extId),N===x))break;N=N.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,V)}}class f{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,V,x){return this.getTracker(N,V,x)}cancelRunById(N){for(const V of this.tracked.values())if(V.id===N){V.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,V,x,W,ee){const Ie=this.tracked.get(x);if(Ie)return Ie.createRun(W);const oe=w.fromPublic(N,V,x,ee),ue=T(x);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!x.continuous,profile:ue&&{group:q[ue.kind],id:ue.profileId},exclude:x.exclude?.map(le=>h.TestId.fromExtHostTestItem(le,V.root.id).toString())??[],id:oe.id,include:x.include?.map(le=>h.TestId.fromExtHostTestItem(le,V.root.id).toString())??[V.root.id],persist:ee});const X=this.getTracker(x,oe);return X.onEnd(()=>{this.proxy.$finishedExtensionTestRun(oe.id),X.dispose()}),X.createRun(W)}getTracker(N,V,x){const W=new D(V,this.proxy,x);return this.tracked.set(N,W),W.onEnd(()=>this.tracked.delete(N)),W}}e.TestRunCoordinator=f;const T=$=>{if($.profile){if(!($.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class w{static fromPublic(N,V,x,W){return new w(N,(0,c.generateUuid)(),x.include?.map(ee=>h.TestId.fromExtHostTestItem(ee,N).toString())??[N],x.exclude?.map(ee=>h.TestId.fromExtHostTestItem(ee,N).toString())??[],W,V)}static fromInternal(N,V){return new w(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,V)}constructor(N,V,x,W,ee,Ie){this.controllerId=N,this.id=V,this.isPersisted=ee,this.colllection=Ie,this.includePrefix=x.map(oe=>oe+"\0"),this.excludePrefix=W.map(oe=>oe+"\0")}isIncluded(N){const V=h.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(V===x||V.startsWith(x))return!1;for(const x of this.includePrefix)if(V===x||V.startsWith(x))return!0;return!1}}e.TestRunDto=w;class o{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,V,x){this.proxy=N,this.runId=V,this.taskId=x}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(V){throw this.fileCoverage=void 0,V}}async resolveFileCoverage(N,V){const x=await this.fileCoverage;let W=x?.[N];return!this._coverageProvider||!x||!W?[]:(W.detailedCoverage||(W=x[N]=await this._coverageProvider.resolveFileCoverage?.(W,V)??W),W.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class s{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,t.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const V=h.TestId.parentId(N.item.extId);if(V&&this.alreadyRemoved.has(V.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:V,removed:x}=this;return{get added(){return[...N].map(W=>W.revived)},get updated(){return[...V].map(W=>W.revived)},get removed(){return[...x].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class F extends I.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new O.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,V){return{...N,revived:t.TestItem.toPlain(N.item),depth:V?V.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}class B{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(V=>V.revived)},dispose:(0,A.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new F;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class G{get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?t.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,V,x,W,ee,Ie,oe,ue=!1,X=void 0,le=!1){this.controllerId=x,this.profileId=W,this._label=ee,this.kind=Ie,this.runHandler=oe,this._isDefault=ue,this._tag=X,this._supportsContinuousRun=le,n.set(this,void 0),u.set(this,void 0),Qe(this,n,N,"f"),Qe(this,u,V,"f"),V.set(W,this);const De=q[Ie];if(typeof De!="number")throw new Error(`Unknown TestRunProfile.group ${Ie}`);Oe(this,n,"f").$publishTestRunProfile({profileId:W,controllerId:x,tag:X?t.TestTag.namespace(this.controllerId,X.id):null,label:ee,group:De,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:le})}dispose(){Oe(this,u,"f")?.delete(this.profileId)&&(Qe(this,u,void 0,"f"),Oe(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=G,n=new WeakMap,u=new WeakMap;const q={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ae[247],Re([1,0,18,10,5,4,106,8,7]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(b,c){this._extHostDocumentsAndEditors=c,this._onDidChangeTextEditorSelection=new y.Emitter({onListenerError:C.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new y.Emitter({onListenerError:C.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new y.Emitter({onListenerError:C.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new y.Emitter({onListenerError:C.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new y.Emitter({onListenerError:C.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new y.Emitter({onListenerError:C.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=b.getProxy(M.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(b){const c=this._extHostDocumentsAndEditors.allEditors();return b?c:c.map(p=>p.value)}async showTextDocument(b,c,p){let g;typeof c=="number"?g={position:A.ViewColumn.from(c),preserveFocus:p}:typeof c=="object"?g={position:A.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?A.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:g={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(b.uri,g),t=d&&this._extHostDocumentsAndEditors.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}createTextEditorDecorationType(b,c){return new O.TextEditorDecorationType(this._proxy,b,c).value}$acceptEditorPropertiesChanged(b,c){const p=this._extHostDocumentsAndEditors.getEditor(b);if(!p)throw new Error("unknown text editor");if(c.options&&p._acceptOptions(c.options),c.selections){const g=c.selections.selections.map(A.Selection.to);p._acceptSelections(g)}if(c.visibleRanges){const g=i.coalesce(c.visibleRanges.map(A.Range.to));p._acceptVisibleRanges(g)}if(c.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...c.options,lineNumbers:A.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const g=_.TextEditorSelectionChangeKind.fromValue(c.selections.source),d=c.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:d,kind:g})}if(c.visibleRanges){const g=i.coalesce(c.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:g})}}$acceptEditorPositionData(b){for(const c in b){const p=this._extHostDocumentsAndEditors.getEditor(c);if(!p)throw new Error("Unknown text editor");const g=A.ViewColumn.to(b[c]);p.value.viewColumn!==g&&(p._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:g}))}}getDiffInformation(b){return Promise.resolve(this._proxy.$getDiffInformation(b))}}e.ExtHostEditors=m}),define(Ae[248],Re([1,0,2,3,4,6,7,8,23,9]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class R{constructor(p,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(y.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this._providers.get(d.source)&&_.ExtensionIdentifier.equals(t,this._providers.get(d.source)?.extension)){const l=d.uri===void 0?void 0:i.URI.revive(d.uri);return this._itemsBySourceAndUriMap.get(d.source)?.get(b(l))?.get(d.handle)}else return;return d}})}async $getTimeline(p,g,d,t){return this._providers.get(p)?.provider.provideTimeline(i.URI.revive(g),d,t)}registerTimelineProvider(p,g,d,t){const l=new M.DisposableStore,h=this.convertTimelineItem(g.id,t,l).bind(this);let S;g.onDidChange&&(S=g.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:g.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:p,onDidChange:void 0,async provideTimeline(v,n,u){n?.resetCache&&(l.clear(),I.get(g.id)?.clear());const r=await g.provideTimeline(v,n,u);if(r==null)return;const a=h(v,n);return{...r,source:g.id,items:r.items.map(a)}},dispose(){for(const v of I.values())v.get(g.id)?.clear();S?.dispose(),l.dispose()}},d)}convertTimelineItem(p,g,d){return(t,l)=>{let h;if(l?.cacheResults){let S=this._itemsBySourceAndUriMap.get(p);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(p,S));const I=b(t);h=S.get(I),h===void 0&&(h=new Map,S.set(I,h))}return S=>{const{iconPath:I,...v}=S,n=`${p}|${S.id??S.timestamp}`;h?.set(n,S);let u,r,a;S.iconPath&&(I instanceof O.ThemeIcon?a={id:I.id,color:I.color}:i.URI.isUri(I)?(u=I,r=I):{light:u,dark:r}=I);let E;return O.MarkdownString.isMarkdownString(v.tooltip)?E=A.MarkdownString.from(v.tooltip):(0,m.isString)(v.tooltip)?E=v.tooltip:O.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=A.MarkdownString.from(v.detail)):(0,m.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=v.detail),{...v,id:v.id??void 0,handle:n,source:p,command:S.command?g.toInternal(S.command,d):void 0,icon:u,iconDark:r,themeIcon:a,tooltip:E,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(p,g){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,{provider:p,extension:g}),(0,M.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=R;function b(c){return c?.toString()}}),define(Ae[249],Re([1,0,6,15,2,4]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class O{constructor(_){this._openers=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,m,R,b){if(this._openers.has(m))throw new Error(`Opener with id '${m}' already registered`);const c=b.schemes.find(p=>!O.supportedSchemes.has(p));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(m,R),this._proxy.$registerUriOpener(m,b.schemes,_,b.label),(0,i.toDisposable)(()=>{this._openers.delete(m),this._proxy.$unregisterUriOpener(m)})}async $canOpenUri(_,m,R){const b=this._openers.get(_);if(!b)throw new Error(`Unknown opener with id: ${_}`);const c=y.URI.revive(m);return b.canOpenExternalUri(c,R)}async $openUri(_,m,R){const b=this._openers.get(_);if(!b)throw new Error(`Unknown opener id: '${_}'`);return b.openExternalUri(y.URI.revive(m.resolvedUri),{sourceUri:y.URI.revive(m.sourceUri)},R)}}e.ExtHostUriOpeners=O,O.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(Ae[250],Re([1,0,4,2,6,10,23]),function(te,e,i,C,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(m){this.handles=new O.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=m.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(m,R){const b=m.identifier;if(this.handles.has(b))throw new Error(`Protocol handler already registered for extension ${b}`);const c=A.HandlePool++;return this.handles.add(b),this.handlers.set(c,R),this._proxy.$registerUriHandler(c,b,m.displayName||m.name),(0,y.toDisposable)(()=>{this.handles.delete(b),this.handlers.delete(c),this._proxy.$unregisterUriHandler(c)})}$handleExternalUri(m,R){const b=this.handlers.get(m);if(!b)return Promise.resolve(void 0);try{b.handleUri(C.URI.revive(R))}catch(c){(0,M.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(m){return C.URI.revive(await this._proxy.$createAppUri(m))}}e.ExtHostUrls=A,A.HandlePool=0});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[63],Re([1,0,5,15,26,2,167,190,76,4]),function(te,e,i,C,y,M,O,A,_,m){"use strict";var R,b,c,p,g,d,t,l,h,S,I,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(s,F,B,G,q,$,N){R.set(this,void 0),b.set(this,void 0),c.set(this,void 0),p.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,""),l.set(this,void 0),h.set(this,!1),S.set(this,!1),I.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new i.Emitter),this._onDidDispose=Oe(this,n,"f").event,Qe(this,R,s,"f"),Qe(this,b,F,"f"),Qe(this,l,B,"f"),Qe(this,p,G,"f"),Qe(this,g,q,"f"),Qe(this,d,$,"f"),Qe(this,I,r($),"f"),Qe(this,v,a($),"f"),Qe(this,c,N,"f")}dispose(){Qe(this,h,!0,"f"),Oe(this,n,"f").fire(),Oe(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return Qe(this,S,!0,"f"),(0,_.asWebviewUri)(s,Oe(this,p,"f"))}get cspSource(){const s=Oe(this,d,"f").extensionLocation;if(s.scheme===C.Schemas.https||s.scheme===C.Schemas.http){let F=s.toString();return F.endsWith("/")||(F+="/"),F+" "+_.webviewGenericCspSource}return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,t,"f")}set html(s){this.assertNotDisposed(),Oe(this,t,"f")!==s&&(Qe(this,t,s,"f"),Oe(this,v,"f")&&!Oe(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(Qe(this,S,!0,"f"),Oe(this,c,"f").report("Webview vscode-resource: uris",Oe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,b,"f").$setHtml(Oe(this,R,"f"),this.rewriteOldResourceUrlsIfNeeded(s)))}get options(){return this.assertNotDisposed(),Oe(this,l,"f")}set options(s){this.assertNotDisposed(),y.equals(Oe(this,l,"f"),s)||Oe(this,b,"f").$setOptions(Oe(this,R,"f"),f(Oe(this,d,"f"),Oe(this,g,"f"),s)),Qe(this,l,s,"f")}async postMessage(s){if(Oe(this,h,"f"))return!1;const F=(0,A.serializeWebviewMessage)(s,{serializeBuffersForPostMessage:Oe(this,I,"f")});return Oe(this,b,"f").$postMessage(Oe(this,R,"f"),F.message,...F.buffers)}assertNotDisposed(){if(Oe(this,h,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(s){if(!Oe(this,v,"f"))return s;const F=Oe(this,d,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,B=Oe(this,d,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Oe(this,d,"f").extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,q,$,N,V,x)=>{const W=M.URI.from({scheme:N||"file",path:decodeURIComponent(V)}),ee=(0,_.asWebviewUri)(W,{isRemote:F,authority:B}).toString();return`${q}${ee}${x}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,q,$,N,V,x)=>{const W=M.URI.from({scheme:N||"file",path:decodeURIComponent(V)}),ee=(0,_.asWebviewUri)(W,{isRemote:F,authority:B}).toString();return`${q}${ee}${x}`})}}e.ExtHostWebview=u,R=new WeakMap,b=new WeakMap,c=new WeakMap,p=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,l=new WeakMap,h=new WeakMap,S=new WeakMap,I=new WeakMap,v=new WeakMap,n=new WeakMap;function r(o){try{const s=(0,O.normalizeVersion)((0,O.parseVersion)(o.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function a(o){try{const s=(0,O.normalizeVersion)((0,O.parseVersion)(o.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class E{constructor(s,F,B,G,q){this.remoteInfo=F,this.workspace=B,this._logService=G,this._deprecationService=q,this._webviews=new Map,this._webviewProxy=s.getProxy(m.MainContext.MainThreadWebviews)}$onMessage(s,F,B){const G=this.getWebview(s);if(G){const{message:q}=(0,A.deserializeWebviewMessage)(F,B.value);G._onMessageEmitter.fire(q)}}$onMissingCsp(s,F){this._logService.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,F,B){const G=new u(s,this._webviewProxy,T(F),this.remoteInfo,this.workspace,B,this._deprecationService);return this._webviews.set(s,G),G._onDidDispose(()=>{this._webviews.delete(s)}),G}deleteWebview(s){this._webviews.delete(s)}getWebview(s){return this._webviews.get(s)}}e.ExtHostWebviews=E;function D(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=D;function f(o,s,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||w(o,s)}}e.serializeWebviewOptions=f;function T(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(s=>M.URI.from(s))}}function w(o,s){return[...(s?.getWorkspaceFolders()||[]).map(F=>F.uri),o.extensionLocation]}}),define(Ae[251],Re([1,0,22,93,6,15,25,2,8,63,54,4,7]),function(te,e,i,C,y,M,O,A,_,m,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(u,r){this.document=u,this._storagePath=r,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,r){await this.getEdit(u).undo(),r||this.disposeBackup()}async redo(u,r){await this.getEdit(u).redo(),r||this.disposeBackup()}disposeEdits(u){for(const r of u)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=v(this.document.uri)+this._backupCounter++;return(0,O.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const r=this._edits.get(u,0);if(!r)throw new Error("No edit found");return r}}class g{constructor(){this._documents=new Map}get(u,r){return this._documents.get(this.key(u,r))}add(u,r,a){const E=this.key(u,r.uri);if(this._documents.has(E))throw new Error(`Document already exists for viewType:${u} resource:${r.uri}`);const D=new p(r,a);return this._documents.set(E,D),D}delete(u,r){const a=this.key(u,r.uri);this._documents.delete(a)}key(u,r){return`${u}@@@${r}`}}var d;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this._providers=new Map}addTextProvider(u,r,a){return this.add(0,u,r,a)}addCustomProvider(u,r,a){return this.add(1,u,r,a)}get(u){return this._providers.get(u)}add(u,r,a,E){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:u,extension:a,provider:E}),new c.Disposable(()=>this._providers.delete(r))}}class l{constructor(u,r,a,E,D){this._extHostDocuments=r,this._extensionStoragePaths=a,this._extHostWebview=E,this._extHostWebviewPanels=D,this._editorProviders=new t,this._documents=new g,this._proxy=u.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,r,a,E){const D=new y.DisposableStore;return S(a)?(D.add(this._editorProviders.addTextProvider(r,u,a)),this._proxy.$registerTextEditorProvider((0,m.toExtensionData)(u),r,E.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(u))):(D.add(this._editorProviders.addCustomProvider(r,u,a)),h(a)&&D.add(a.onDidChangeCustomDocument(f=>{const T=this.getCustomDocumentEntry(r,f.document.uri);if(I(f)){const w=T.addEdit(f);this._proxy.$onDidEdit(f.document.uri,r,w,f.label)}else this._proxy.$onContentChange(f.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,m.toExtensionData)(u),r,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(u))),c.Disposable.from(D,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(u,r,a,E,D){const f=this._editorProviders.get(r);if(!f)throw new Error(`No provider found for '${r}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${r}'`);const T=A.URI.revive(u),w=await f.provider.openCustomDocument(T,{backupId:a,untitledDocumentData:E?.buffer},D);let o;return h(f.provider)&&this._extensionStoragePaths&&(o=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(r,w,o),{editable:h(f.provider)}}async $disposeCustomDocument(u,r){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const E=A.URI.revive(u),{document:D}=this.getCustomDocumentEntry(r,E);this._documents.delete(r,D),D.dispose()}async $resolveCustomEditor(u,r,a,E,D,f){const T=this._editorProviders.get(a);if(!T)throw new Error(`No provider found for '${a}'`);const w=_.ViewColumn.to(D),o=this._extHostWebview.createNewWebview(r,E.contentOptions,T.extension),s=this._extHostWebviewPanels.createNewWebviewPanel(r,a,E.title,w,E.options,o,E.active),F=A.URI.revive(u);switch(T.type){case 1:{const{document:B}=this.getCustomDocumentEntry(a,F);return T.provider.resolveCustomEditor(B,s,f)}case 0:{const B=this._extHostDocuments.getDocument(F);return T.provider.resolveCustomTextEditor(B,s,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,r,a){this.getCustomDocumentEntry(r,u).disposeEdits(a)}async $onMoveCustomEditor(u,r,a){const E=this._editorProviders.get(a);if(!E)throw new Error(`No provider found for '${a}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const D=this._extHostWebviewPanels.getWebviewPanel(u);if(!D)throw new Error("No webview found");const f=A.URI.revive(r),T=this._extHostDocuments.getDocument(f);await E.provider.moveCustomTextEditor(T,D,i.CancellationToken.None)}async $undo(u,r,a,E){return this.getCustomDocumentEntry(r,u).undo(a,E)}async $redo(u,r,a,E){return this.getCustomDocumentEntry(r,u).redo(a,E)}async $revert(u,r,a){const E=this.getCustomDocumentEntry(r,u);await this.getCustomEditorProvider(r).revertCustomDocument(E.document,a),E.disposeBackup()}async $onSave(u,r,a){const E=this.getCustomDocumentEntry(r,u);await this.getCustomEditorProvider(r).saveCustomDocument(E.document,a),E.disposeBackup()}async $onSaveAs(u,r,a,E){const D=this.getCustomDocumentEntry(r,u);return this.getCustomEditorProvider(r).saveCustomDocumentAs(D.document,A.URI.revive(a),E)}async $backup(u,r,a){const E=this.getCustomDocumentEntry(r,u),f=await this.getCustomEditorProvider(r).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},a);return E.updateBackup(f),f.id}getCustomDocumentEntry(u,r){const a=this._documents.get(u,A.URI.revive(r));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(u){const a=this._editorProviders.get(u)?.provider;if(!a||!h(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=l;function h(n){return!!n.onDidChangeCustomDocument}function S(n){return typeof n.resolveCustomTextEditor=="function"}function I(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function v(n){const u=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,C.hash)(u)+""}});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[252],Re([1,0,5,6,2,36,8,63,4,7]),function(te,e,i,C,y,M,O,A,_,m){"use strict";var R,b,c,p,g,d,t,l,h,S,I,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends C.Disposable{constructor(D,f,T,w){super(),R.set(this,void 0),b.set(this,void 0),c.set(this,void 0),p.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),l.set(this,void 0),h.set(this,!0),S.set(this,void 0),I.set(this,!1),v.set(this,this._register(new i.Emitter)),this.onDidDispose=Oe(this,v,"f").event,n.set(this,this._register(new i.Emitter)),this.onDidChangeViewState=Oe(this,n,"f").event,Qe(this,R,D,"f"),Qe(this,b,f,"f"),Qe(this,p,T,"f"),Qe(this,c,w.viewType,"f"),Qe(this,g,w.panelOptions,"f"),Qe(this,l,w.viewColumn,"f"),Qe(this,d,w.title,"f"),Qe(this,S,w.active,"f")}dispose(){Oe(this,I,"f")||(Qe(this,I,!0,"f"),Oe(this,v,"f").fire(),Oe(this,b,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,p,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,c,"f")}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(D){this.assertNotDisposed(),Oe(this,d,"f")!==D&&(Qe(this,d,D,"f"),Oe(this,b,"f").$setTitle(Oe(this,R,"f"),D))}get iconPath(){return this.assertNotDisposed(),Oe(this,t,"f")}set iconPath(D){this.assertNotDisposed(),Oe(this,t,"f")!==D&&(Qe(this,t,D,"f"),Oe(this,b,"f").$setIconPath(Oe(this,R,"f"),y.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return Oe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,l,"f")=="number"&&Oe(this,l,"f")<0))return Oe(this,l,"f")}get active(){return this.assertNotDisposed(),Oe(this,S,"f")}get visible(){return this.assertNotDisposed(),Oe(this,h,"f")}_updateViewState(D){Oe(this,I,"f")||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(Qe(this,S,D.active,"f"),Qe(this,h,D.visible,"f"),Qe(this,l,D.viewColumn,"f"),Oe(this,n,"f").fire({webviewPanel:this}))}reveal(D,f){this.assertNotDisposed(),Oe(this,b,"f").$reveal(Oe(this,R,"f"),{viewColumn:typeof D>"u"?void 0:O.ViewColumn.from(D),preserveFocus:!!f})}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,b=new WeakMap,c=new WeakMap,p=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,l=new WeakMap,h=new WeakMap,S=new WeakMap,I=new WeakMap,v=new WeakMap,n=new WeakMap;class r{static newHandle(){return(0,M.generateUuid)()}constructor(D,f,T){this.webviews=f,this.workspace=T,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=D.getProxy(_.MainContext.MainThreadWebviewPanels)}createWebviewPanel(D,f,T,w,o={}){const s=typeof w=="object"?w.viewColumn:w,F={viewColumn:O.ViewColumn.from(s),preserveFocus:typeof w=="object"&&!!w.preserveFocus},B=(0,A.shouldSerializeBuffersForPostMessage)(D),G=r.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(D),G,f,{title:T,panelOptions:a(o),webviewOptions:(0,A.serializeWebviewOptions)(D,this.workspace,o),serializeBuffersForPostMessage:B},F);const q=this.webviews.createNewWebview(G,o,D);return this.createNewWebviewPanel(G,f,T,s,o,q,!0)}$onDidChangeWebviewPanelViewStates(D){const f=Object.keys(D);f.sort((T,w)=>{const o=D[T],s=D[w];return o.active?1:s.active?-1:+o.visible-+s.visible});for(const T of f){const w=this.getWebviewPanel(T);if(!w)continue;const o=D[T];w._updateViewState({active:o.active,visible:o.visible,viewColumn:O.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this._webviewPanels.delete(D),this.webviews.deleteWebview(D)}registerWebviewPanelSerializer(D,f,T){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:T,extension:D}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(D)}),new m.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(D,f,T,w){const o=this._serializers.get(f);if(!o)throw new Error(`No serializer found for '${f}'`);const{serializer:s,extension:F}=o,B=this.webviews.createNewWebview(D,T.webviewOptions,F),G=this.createNewWebviewPanel(D,f,T.title,w,T.panelOptions,B,T.active);await s.deserializeWebviewPanel(G,T.state)}createNewWebviewPanel(D,f,T,w,o,s,F){const B=new u(D,this._proxy,s,{viewType:f,title:T,viewColumn:w,panelOptions:o,active:F});return this._webviewPanels.set(D,B),B}getWebviewPanel(D){return this._webviewPanels.get(D)}}e.ExtHostWebviewPanels=r;function a(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[253],Re([1,0,5,6,63,8,4,7]),function(te,e,i,C,y,M,O,A){"use strict";var _,m,R,b,c,p,g,d,t,l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends C.Disposable{constructor(n,u,r,a,E,D){super(),_.set(this,void 0),m.set(this,void 0),R.set(this,void 0),b.set(this,void 0),c.set(this,!1),p.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),l.set(this,this._register(new i.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,h.set(this,this._register(new i.Emitter)),this.onDidDispose=Oe(this,h,"f").event,Qe(this,R,r,"f"),Qe(this,g,a,"f"),Qe(this,_,n,"f"),Qe(this,m,u,"f"),Qe(this,b,E,"f"),Qe(this,p,D,"f")}dispose(){Oe(this,c,"f")||(Qe(this,c,!0,"f"),Oe(this,h,"f").fire(),Oe(this,b,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,g,"f")}set title(n){this.assertNotDisposed(),Oe(this,g,"f")!==n&&(Qe(this,g,n,"f"),Oe(this,m,"f").$setWebviewViewTitle(Oe(this,_,"f"),n))}get description(){return this.assertNotDisposed(),Oe(this,d,"f")}set description(n){this.assertNotDisposed(),Oe(this,d,"f")!==n&&(Qe(this,d,n,"f"),Oe(this,m,"f").$setWebviewViewDescription(Oe(this,_,"f"),n))}get visible(){return Oe(this,p,"f")}get webview(){return Oe(this,b,"f")}get viewType(){return Oe(this,R,"f")}_setVisible(n){n===Oe(this,p,"f")||Oe(this,c,"f")||(Qe(this,p,n,"f"),Oe(this,l,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,t,"f")}set badge(n){this.assertNotDisposed(),!(n?.value===Oe(this,t,"f")?.value&&n?.tooltip===Oe(this,t,"f")?.tooltip)&&(Qe(this,t,M.ViewBadge.from(n),"f"),Oe(this,m,"f").$setWebviewViewBadge(Oe(this,_,"f"),n))}show(n){this.assertNotDisposed(),Oe(this,m,"f").$show(Oe(this,_,"f"),!!n)}assertNotDisposed(){if(Oe(this,c,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,m=new WeakMap,R=new WeakMap,b=new WeakMap,c=new WeakMap,p=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,l=new WeakMap,h=new WeakMap;class I{constructor(n,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(O.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,u,r,a){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:r,extension:n}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(n),u,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(n)}),new A.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(n,u,r,a,E){const D=this._viewProviders.get(u);if(!D)throw new Error(`No view provider found for '${u}'`);const{provider:f,extension:T}=D,w=this._extHostWebview.createNewWebview(n,{},T),o=new S(n,this._proxy,u,r,w,!0);this._webviewViews.set(n,o),await f.resolveWebviewView(o,{state:a},E)}async $onDidChangeWebviewViewVisibility(n,u){this.getWebviewView(n)._setVisible(u)}async $disposeWebviewView(n){const u=this.getWebviewView(n);this._webviewViews.delete(n),u.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const u=this._webviewViews.get(n);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=I}),define(Ae[108],Re([1,0,5,4,2,15,13,3,17,20]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=e.ExtHostWindow=class On{getState(c){const p=this._state;return{get focused(){return p.focused},get active(){return(0,m.checkProposedApiEnabled)(c,"windowActivity"),p.active}}}constructor(c){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=On.InitialState,this._proxy=c.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:p,isActive:g})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,p){p!==this._state[c]&&(this._state={...this._state,[c]:p},this._onDidChangeWindowState.fire(this._state))}openUri(c,p){let g;if(typeof c=="string"){g=c;try{c=y.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,O.isFalsyOrWhitespace)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this._proxy.$openUri(c,g,p)}async asExternalUri(c,p){if((0,O.isFalsyOrWhitespace)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(c,p);return y.URI.from(g)}};R.InitialState={focused:!0,active:!0},e.ExtHostWindow=R=je([We(0,_.IExtHostRpcService)],R),e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ae[254],Re([1,0,221,27,17]),function(te,e,i,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=e.ExtHostConsoleForwarder=class extends i.AbstractExtHostConsoleForwarder{constructor(A,_){super(A,_)}_nativeConsoleLogMessage(A,_,m){_.apply(console,m)}};e.ExtHostConsoleForwarder=M=je([We(0,y.IExtHostRpcService),We(1,C.IExtHostInitDataService)],M)}),define(Ae[255],Re([1,0,16,24,22,10,5,6,132,214,46]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(o,s){try{return JSON.stringify(o,s)}catch{return"null"}}const p="$$ref$$",g={[p]:-1};class d{constructor(s,F){this.jsonString=s,this.referencedBuffers=F}}function t(o,s=null,F=!1){const B=[];return{jsonString:(F?c:JSON.stringify)(o,(q,$)=>{if(typeof $>"u")return g;if(typeof $=="object"){if($ instanceof C.VSBuffer){const N=B.push($)-1;return{[p]:N}}if(s)return s(q,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=t;function l(o,s,F){return JSON.parse(o,(B,G)=>{if(G){const q=G[p];if(typeof q=="number")return s[q];if(F&&G.$mid===1)return F.transformIncoming(G)}return G})}e.parseJsonAndRestoreBufferRefs=l;function h(o,s){return JSON.stringify(o,s)}function S(o){return o?(s,F)=>F&&F.$mid===1?o.transformOutgoing(F):F:null}var I;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));var v;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const n=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends A.Disposable{constructor(s,F=null,B=null){super(),this[b]=!0,this._onDidChangeResponsiveState=this._register(new O.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=F,this._uriTransformer=B,this._uriReplacer=S(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let G=0,q=R.ProxyIdentifier.count;G<q;G++)this._locals[G]=null,this._proxies[G]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(G=>this._receiveOneMessage(G))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,_.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:F,sid:B}=s;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,B)),this._proxies[F]}_createProxy(s,F){const B={get:(G,q)=>(typeof q=="string"&&!G[q]&&q.charCodeAt(0)===36&&(G[q]=(...$)=>this._remoteCall(s,q,$)),q===r?F:G[q])};return new Proxy(Object.create(null),B)}set(s,F){return this._locals[s.nid]=F,F}assertRegistered(s){for(let F=0,B=s.length;F<B;F++){const G=s[F];if(!this._locals[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}_receiveOneMessage(s){if(this._isDisposed)return;const F=s.byteLength,B=E.read(s,0),G=B.readUInt8(),q=B.readUInt32();switch(G){case 1:case 2:{let{rpcId:$,method:N,args:V}=f.deserializeRequestJSONArgs(B);this._uriTransformer&&(V=(0,_.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(F,q,$,N,V,G===2);break}case 3:case 4:{let{rpcId:$,method:N,args:V}=f.deserializeRequestMixedArgs(B);this._uriTransformer&&(V=(0,_.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(F,q,$,N,V,G===4);break}case 5:{this._logger?.logIncoming(F,q,0,"ack"),this._onDidReceiveAcknowledge(q);break}case 6:{this._receiveCancel(F,q);break}case 7:{this._receiveReply(F,q,void 0);break}case 9:{let $=f.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(F,q,$);break}case 10:{const $=f.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(F,q,$);break}case 8:{const $=f.deserializeReplyOKVSBuffer(B);this._receiveReply(F,q,$);break}case 11:{let $=f.deserializeReplyErrError(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(F,q,$);break}case 12:{this._receiveReplyErr(F,q,void 0);break}default:console.error("received unexpected message"),console.error(s)}}_receiveRequest(s,F,B,G,q,$){this._logger?.logIncoming(s,F,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(B)}.${G}(`,q);const N=String(F);let V,x;if($){const ee=new y.CancellationTokenSource;q.push(ee.token),V=this._invokeHandler(B,G,q),x=()=>ee.cancel()}else V=this._invokeHandler(B,G,q),x=n;this._cancelInvokedHandlers[N]=x;const W=f.serializeAcknowledged(F);this._logger?.logOutgoing(W.byteLength,F,1,"ack"),this._protocol.send(W),V.then(ee=>{delete this._cancelInvokedHandlers[N];const Ie=f.serializeReplyOK(F,ee,this._uriReplacer);this._logger?.logOutgoing(Ie.byteLength,F,1,"reply:",ee),this._protocol.send(Ie)},ee=>{delete this._cancelInvokedHandlers[N];const Ie=f.serializeReplyErr(F,ee);this._logger?.logOutgoing(Ie.byteLength,F,1,"replyErr:",ee),this._protocol.send(Ie)})}_receiveCancel(s,F){this._logger?.logIncoming(s,F,1,"receiveCancel");const B=String(F);this._cancelInvokedHandlers[B]?.()}_receiveReply(s,F,B){this._logger?.logIncoming(s,F,0,"receiveReply:",B);const G=String(F);if(!this._pendingRPCReplies.hasOwnProperty(G))return;const q=this._pendingRPCReplies[G];delete this._pendingRPCReplies[G],q.resolveOk(B)}_receiveReplyErr(s,F,B){this._logger?.logIncoming(s,F,0,"receiveReplyErr:",B);const G=String(F);if(!this._pendingRPCReplies.hasOwnProperty(G))return;const q=this._pendingRPCReplies[G];delete this._pendingRPCReplies[G];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),q.resolveErr($)}_invokeHandler(s,F,B){try{return Promise.resolve(this._doInvokeHandler(s,F,B))}catch(G){return Promise.reject(G)}}_doInvokeHandler(s,F,B){const G=this._locals[s];if(!G)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(s));const q=G[F];if(typeof q!="function")throw new Error("Unknown method "+F+" on actor "+(0,R.getStringIdentifierForProxy)(s));return q.apply(G,B)}_remoteCall(s,F,B){if(this._isDisposed)return new m.CanceledLazyPromise;let G=null;if(B.length>0&&y.CancellationToken.isCancellationToken(B[B.length-1])&&(G=B.pop()),G&&G.isCancellationRequested)return Promise.reject(M.canceled());const q=f.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,N=String($),V=new m.LazyPromise;G&&G.onCancellationRequested(()=>{const W=f.serializeCancel($);this._logger?.logOutgoing(W.byteLength,$,0,"cancel"),this._protocol.send(f.serializeCancel($))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest($);const x=f.serializeRequest($,s,F,q,!!G);return this._logger?.logOutgoing(x.byteLength,$,0,`request: ${(0,R.getStringIdentifierForProxy)(s)}.${F}(`,B),this._protocol.send(x),V}}e.RPCProtocol=a,b=u,a.UNRESPONSIVE_TIME=3*1e3;class E{static alloc(s,F,B){const G=new E(C.VSBuffer.alloc(B+1+4),0);return G.writeUInt8(s),G.writeUInt32(F),G}static read(s,F){return new E(s,F)}get buffer(){return this._buff}constructor(s,F){this._buff=s,this._offset=F}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,B}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,B}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,F}static sizeMixedArray(s){let F=0;F+=1;for(let B=0,G=s.length;B<G;B++){const q=s[B];switch(F+=1,q.type){case 1:F+=this.sizeLongString(q.value);break;case 2:F+=this.sizeVSBuffer(q.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(q.value);for(let $=0;$<q.buffers.length;++$)F+=this.sizeVSBuffer(q.buffers[$]);break;case 4:break}}return F}writeMixedArray(s){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let F=0,B=s.length;F<B;F++){const G=s[F];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let q=0;q<G.buffers.length;++q)this.writeBuffer(G.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const F=new Array(s);for(let B=0;B<s;B++)switch(this.readUInt8()){case 1:F[B]=this.readLongString();break;case 2:F[B]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),$=this.readLongString(),N=[];for(let V=0;V<q;++V)N.push(this.readVSBuffer());F[B]=new R.SerializableObjectWithBuffers(l($,N,null));break}case 4:F[B]=void 0;break}return F}}E.sizeUInt32=4;var D;(function(o){o[o.Simple=0]="Simple",o[o.Mixed=1]="Mixed"})(D||(D={}));class f{static _useMixedArgSerialization(s){for(let F=0,B=s.length;F<B;F++)if(s[F]instanceof C.VSBuffer||s[F]instanceof R.SerializableObjectWithBuffers||typeof s[F]>"u")return!0;return!1}static serializeRequestArguments(s,F){if(this._useMixedArgSerialization(s)){const B=[];for(let G=0,q=s.length;G<q;G++){const $=s[G];if($ instanceof C.VSBuffer)B[G]={type:2,value:$};else if(typeof $>"u")B[G]={type:4};else if($ instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=t($.value,F);B[G]={type:3,value:C.VSBuffer.fromString(N),buffers:V}}else B[G]={type:1,value:C.VSBuffer.fromString(h($,F))}}return{type:1,args:B}}return{type:0,args:h(s,F)}}static serializeRequest(s,F,B,G,q){switch(G.type){case 0:return this._requestJSONArgs(s,F,B,G.args,q);case 1:return this._requestMixedArgs(s,F,B,G.args,q)}}static _requestJSONArgs(s,F,B,G,q){const $=C.VSBuffer.fromString(B),N=C.VSBuffer.fromString(G);let V=0;V+=E.sizeUInt8(),V+=E.sizeShortString($),V+=E.sizeLongString(N);const x=E.alloc(q?2:1,s,V);return x.writeUInt8(F),x.writeShortString($),x.writeLongString(N),x.buffer}static deserializeRequestJSONArgs(s){const F=s.readUInt8(),B=s.readShortString(),G=s.readLongString();return{rpcId:F,method:B,args:JSON.parse(G)}}static _requestMixedArgs(s,F,B,G,q){const $=C.VSBuffer.fromString(B);let N=0;N+=E.sizeUInt8(),N+=E.sizeShortString($),N+=E.sizeMixedArray(G);const V=E.alloc(q?4:3,s,N);return V.writeUInt8(F),V.writeShortString($),V.writeMixedArray(G),V.buffer}static deserializeRequestMixedArgs(s){const F=s.readUInt8(),B=s.readShortString(),G=s.readMixedArray(),q=new Array(G.length);for(let $=0,N=G.length;$<N;$++){const V=G[$];typeof V=="string"?q[$]=JSON.parse(V):q[$]=V}return{rpcId:F,method:B,args:q}}static serializeAcknowledged(s){return E.alloc(5,s,0).buffer}static serializeCancel(s){return E.alloc(6,s,0).buffer}static serializeReplyOK(s,F,B){if(typeof F>"u")return this._serializeReplyOKEmpty(s);if(F instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(s,F);if(F instanceof R.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:q}=t(F.value,B,!0);return this._serializeReplyOKJSONWithBuffers(s,G,q)}else return this._serializeReplyOKJSON(s,c(F,B))}static _serializeReplyOKEmpty(s){return E.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,F){let B=0;B+=E.sizeVSBuffer(F);const G=E.alloc(8,s,B);return G.writeVSBuffer(F),G.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,F){const B=C.VSBuffer.fromString(F);let G=0;G+=E.sizeLongString(B);const q=E.alloc(9,s,G);return q.writeLongString(B),q.buffer}static _serializeReplyOKJSONWithBuffers(s,F,B){const G=C.VSBuffer.fromString(F);let q=0;q+=E.sizeUInt32,q+=E.sizeLongString(G);for(const N of B)q+=E.sizeVSBuffer(N);const $=E.alloc(10,s,q);$.writeUInt32(B.length),$.writeLongString(G);for(const N of B)$.writeBuffer(N);return $.buffer}static deserializeReplyOKJSON(s){const F=s.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(s,F){const B=s.readUInt32(),G=s.readLongString(),q=[];for(let $=0;$<B;++$)q.push(s.readVSBuffer());return new R.SerializableObjectWithBuffers(l(G,q,F))}static serializeReplyErr(s,F){const B=F?c(M.transformErrorForSerialization(F),null):void 0;if(typeof B!="string")return this._serializeReplyErrEmpty(s);const G=C.VSBuffer.fromString(B);let q=0;q+=E.sizeLongString(G);const $=E.alloc(11,s,q);return $.writeLongString(G),$.buffer}static deserializeReplyErrError(s){const F=s.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(s){return E.alloc(12,s,0).buffer}}var T;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",o[o.ReplyErrError=11]="ReplyErrError",o[o.ReplyErrEmpty=12]="ReplyErrEmpty"})(T||(T={}));var w;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",o[o.Undefined=4]="Undefined"})(w||(w={}))}),define(Ae[256],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(M){const O=A=>{globalThis.removeEventListener("message",O);const _=A.data;Object.defineProperties(globalThis,{postMessage:{value(m,R){_.postMessage(m,R)}},onmessage:{get(){return _.onmessage},set(m){_.onmessage=m}}}),_.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),_.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",O)}.toString();class C extends EventTarget{constructor(M,O,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${i})('${O}'))`,m=new Blob([_],{type:"application/javascript"}),R=URL.createObjectURL(m),b=new MessageChannel,c=R,p={type:"_newWorker",id:c,port:b.port2,url:R,options:A};M(p,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{M({type:"_terminateWorker",id:c}),URL.revokeObjectURL(R),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(g){b.port1.onmessage=g}},onmessageerror:{get(){return b.port1.onmessageerror},set(g){b.port1.onmessageerror=g}}}),b.port1.addEventListener("messageerror",g=>{const d=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(d)}),b.port1.addEventListener("message",g=>{const d=new MessageEvent("message",{data:g.data});this.dispatchEvent(d)}),b.port1.start()}}e.NestedWorker=C}),define(Ae[257],Re([1,0,5,30,31,3]),function(te,e,i,C,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var O;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(O||(e.OutputChannelUpdateMode=O={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new i.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new i.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(R=>m.push(R)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}C.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ae[109],Re([1,0,4,3,17,23,14,257,61,27,38,126,24,9,43,5,6]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends O.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,n,u,r,a){super(),this.id=v,this.name=n,this.logger=u,this.proxy=r,this.extension=a,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(u.getLevel()),this._register(u.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,v)}replace(v){const n=this.offset;this.info(v),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,n),this.visible&&this.logger.flush()}show(v,n){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:n))}hide(){this.proxy.$close(this.id)}log(v,n){this.offset+=c.VSBuffer.fromString(n).byteLength,(0,O.log)(this.logger,v,n),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class h extends l{appendLine(v){this.append(v)}}let S=e.ExtHostOutputService=class{constructor(v,n,u,r,a,E){this.initData=n,this.extHostFileSystem=u,this.extHostFileSystemInfo=r,this.loggerService=a,this.logService=E,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(i.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(n.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[n,u]of this.channels)u.visible=n===this.visibleChannelId}createOutputChannel(v,n,u){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,a=(0,p.isString)(n)?n:void 0;if((0,p.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const D=this.initData.environment.extensionLogLevel?.find(([T])=>M.ExtensionIdentifier.equals(u.identifier,T))?.[1];D&&(E=(0,O.parseLogLevel)(D));const f=r?this.doCreateLogOutputChannel(v,E,u):this.doCreateOutputChannel(v,a,u);return f.then(T=>{this.channels.set(T.id,T),T.visible=T.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(v,E??this.logService.getLevel(),f):this.createExtHostOutputChannel(v,f)}async doCreateOutputChannel(v,n,u){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,a=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.loggerService.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),D=await this.proxy.$register(v,a,n,u.identifier.value);return new l(D,v,E,this.proxy,u)}async doCreateLogOutputChannel(v,n,u){const r=await this.createExtensionLogDirectory(u),a=v.replace(/[\\/:\*\?"<>\|]/g,""),E=this.extHostFileSystemInfo.extUri.joinPath(r,`${a}.log`),D=`${u.identifier.value}.${a}`,f=this.loggerService.createLogger(E,{id:D,name:v,logLevel:n,extensionId:u.identifier.value});return new h(D,v,f,this.proxy,u)}createExtensionLogDirectory(v){let n=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!n){const u=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,n=(async()=>{try{await this.extHostFileSystem.value.createDirectory(u)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}return u})())}return n}createExtHostOutputChannel(v,n){let u=!1;const r=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return v},append(a){r(),n.then(E=>E.append(a))},appendLine(a){r(),n.then(E=>E.appendLine(a))},clear(){r(),n.then(a=>a.clear())},replace(a){r(),n.then(E=>E.replace(a))},show(a,E){r(),n.then(D=>D.show(a,E))},hide(){r(),n.then(a=>a.hide())},dispose(){u=!0,n.then(a=>a.dispose())}}}createExtHostLogOutputChannel(v,n,u){const r=new t.DisposableStore,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},E=r.add(new d.Emitter);function D(f){n=f,E.fire(f)}return u.then(f=>{r.add(f),f.logLevel!==n&&D(f.logLevel),r.add(f.onDidChangeLogLevel(T=>D(T)))}),{...this.createExtHostOutputChannel(v,u),get logLevel(){return n},onDidChangeLogLevel:E.event,trace(f,...T){a(),u.then(w=>w.trace(f,...T))},debug(f,...T){a(),u.then(w=>w.debug(f,...T))},info(f,...T){a(),u.then(w=>w.info(f,...T))},warn(f,...T){a(),u.then(w=>w.warn(f,...T))},error(f,...T){a(),u.then(w=>w.error(f,...T))},dispose(){r.dispose()}}}};e.ExtHostOutputService=S=je([We(0,y.IExtHostRpcService),We(1,m.IExtHostInitDataService),We(2,_.IExtHostConsumerFileSystem),We(3,R.IExtHostFileSystemInfo),We(4,O.ILoggerService),We(5,O.ILogService)],S),e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")});var Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)},Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i};define(Ae[258],Re([1,0,3,16]),function(te,e,i,C){"use strict";var y,M,O,A,_,m,R,b,c,p,g;Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new(g=class{constructor(){y.set(this,5),M.set(this,2e3),O.set(this,[]),A.set(this,3),_.set(this,[]),m.set(this,100),R.set(this,2),b.set(this,500),c.set(this,1500),p.set(this,void 0)}get latency(){return Oe(this,p,"f")}async measure(d){let t=1/0;for(let h=0;h<Oe(this,y,"f");h++){const S=await d.getRoundTripTime();if(S===void 0)return;t=Math.min(t,S/2),await(0,C.timeout)(Oe(this,M,"f"))}Oe(this,_,"f").push(t),Oe(this,_,"f").length>Oe(this,m,"f")&&Oe(this,_,"f").shift();let l;return Oe(this,O,"f").length<Oe(this,A,"f")?Oe(this,O,"f").push(t):l=Oe(this,O,"f").reduce((h,S)=>h+S,0)/Oe(this,O,"f").length,Qe(this,p,{initial:l,current:t,average:Oe(this,_,"f").reduce((h,S)=>h+S,0)/Oe(this,_,"f").length,high:(()=>typeof l>"u"?!1:t>Oe(this,c,"f")||t>Oe(this,b,"f")&&t>l*Oe(this,R,"f"))()},"f"),Oe(this,p,"f")}},y=new WeakMap,M=new WeakMap,O=new WeakMap,A=new WeakMap,_=new WeakMap,m=new WeakMap,R=new WeakMap,b=new WeakMap,c=new WeakMap,p=new WeakMap,g)}),define(Ae[259],Re([1,0,41,15,19,21,25,2,3,185,53,200,258]),function(te,e,i,C,y,M,O,A,_,m,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let p=e.AbstractPathService=class Fn{constructor(d,t,l,h){this.localUserHome=d,this.remoteAgentService=t,this.environmentService=l,this.contextService=h,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome??d})()}hasValidBasename(d,t,l){return typeof t=="string"||typeof t>"u"?this.resolveOS.then(h=>this.doHasValidBasename(d,h,t)):this.doHasValidBasename(d,t,l)}doHasValidBasename(d,t,l){return d.scheme===C.Schemas.file||d.scheme===C.Schemas.vscodeRemote?(0,i.isValidBasename)(l??(0,O.basename)(d),t===1):!0}get defaultUriScheme(){return Fn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,t){if(d.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,m.getVirtualWorkspaceScheme)(t.getWorkspace());if(l)return l;const h=t.getWorkspace().folders[0];if(h)return h.uri.scheme;const S=t.getWorkspace().configuration;return S?S.scheme:C.Schemas.file}userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?y.win32:y.posix)}async fileURI(d){let t="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const h=d.indexOf("/",2);h===-1?(t=d.substring(2),d="/"):(t=d.substring(2,h),d=d.substring(h)||"/")}return A.URI.from({scheme:C.Schemas.file,authority:t,path:d,query:"",fragment:""})}};e.AbstractPathService=p=je([We(1,c.IRemoteAgentService),We(2,b.IWorkbenchEnvironmentService),We(3,R.IWorkspaceContextService)],p)}),define(Ae[110],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(O,A){this.line=O,this.character=A}isBefore(O){return!1}isBeforeOrEqual(O){return!1}isAfter(O){return!1}isAfterOrEqual(O){return!1}isEqual(O){return!1}compareTo(O){return 0}translate(O,A){return new i(0,0)}with(O){return new i(0,0)}}e.Position=i;class C{constructor(O,A,_,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(O,A),this.end=new i(_,m)}contains(O){return!1}isEqual(O){return!1}intersection(O){}union(O){return new C(0,0,0,0)}with(O){return new C(0,0,0,0)}}e.Range=C;var y;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(y||(e.TextSearchCompleteMessageType=y={}))}),define(Ae[47],Re([1,0,18,37,26,41,13,3,19,10,110,16]),function(te,e,i,C,y,M,O,A,_,m,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",p=" characters skipped \u27EB",g=(c.length+p.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var d;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(t||(e.QueryType=t={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function h(ue){return!!ue.resource}e.isFileMatch=h;function S(ue){return!!ue.message}e.isProgressMessage=S;var I;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(I||(e.SearchCompletionExitCode=I={}));class v{constructor(X){this.resource=X,this.results=[]}}e.FileMatch=v;class n{constructor(X,le,De,Te){this.ranges=le,this.webviewIndex=Te;const Ee=Array.isArray(le)?le:[le];if(De&&De.matchLines===1&&u(Ee)){X=(0,O.getNLines)(X,De.matchLines);let P="",K=0,he=0;const ye=Math.floor(De.charsPerLine/5),be=[];for(const ge of Ee){const Ce=Math.max(ge.startColumn-ye,0),ae=ge.startColumn+De.charsPerLine;if(Ce>he+ye+g){const de=c+(Ce-he)+p;P+=de+X.slice(Ce,ae),K+=Ce-(he+de.length)}else P+=X.slice(he,ae);be.push(new a(0,ge.startColumn-K,ge.endColumn-K)),he=ae}this.preview={text:P,matches:Array.isArray(this.ranges)?be:be[0]}}else{const P=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:X,matches:(0,i.mapArrayOrNot)(le,K=>new r(K.startLineNumber-P,K.startColumn,K.endLineNumber-P,K.endColumn))}}}}e.TextSearchMatch=n;function u(ue){const X=ue[0].startLineNumber;for(const le of ue)if(le.startLineNumber!==X||le.endLineNumber!==X)return!1;return!0}class r{constructor(X,le,De,Te){this.startLineNumber=X,this.startColumn=le,this.endLineNumber=De,this.endColumn=Te}}e.SearchRange=r;class a extends r{constructor(X,le,De){super(X,le,X,De)}}e.OneLineRange=a;var E;(function(ue){ue.List="list",ue.Tree="tree"})(E||(e.ViewMode=E={}));var D;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(D||(e.SearchSortOrder=D={}));function f(ue,X=!0){const le=ue&&ue.files&&ue.files.exclude,De=X&&ue&&ue.search&&ue.search.exclude;if(!le&&!De)return;if(!le||!De)return le||De;let Te=Object.create(null);return Te=y.mixin(Te,y.deepClone(le)),Te=y.mixin(Te,y.deepClone(De),!0),Te}e.getExcludes=f;function T(ue,X){return ue.excludePattern&&C.match(ue.excludePattern,X)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&C.match(ue.includePattern,X)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(le=>{const De=le.folder.fsPath;if(M.isEqualOrParent(X,De)){const Te=_.relative(De,X);return!le.includePattern||!!C.match(le.includePattern,Te)}else return!1}):!1:!0}e.pathIncludedInQuery=T;var w;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class o extends Error{constructor(X,le){super(X),this.code=le}}e.SearchError=o;function s(ue){const X=ue.message;if((0,m.isCancellationError)(ue))return new o(X,w.canceled);try{const le=JSON.parse(X);return new o(le.message,le.code)}catch{return new o(X,w.other)}}e.deserializeSearchError=s;function F(ue){const X={message:ue.message,code:ue.code};return new Error(JSON.stringify(X))}e.serializeSearchError=F;function B(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=B;function G(ue){return ue.type==="success"}e.isSerializedSearchSuccess=G;function q(ue){return!!ue.path}e.isSerializedFileMatch=q;function $(ue,X){const le=ue.searchPath?ue.searchPath:ue.relativePath;return(0,O.fuzzyContains)(le,X)}e.isFilePatternMatch=$;class N{constructor(X){this.path=X,this.results=[]}addMatch(X){this.results.push(X)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function V(ue,X){const le={...ue||{},...X||{}};return Object.keys(le).filter(De=>{const Te=le[De];return typeof Te=="boolean"&&Te})}e.resolvePatternsForProvider=V;class x{constructor(X,le){this._parsedIncludeExpression=null,this._excludeExpression={...X.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let De=X.includePattern;le.includePattern&&(De?De={...De,...le.includePattern}:De=le.includePattern),De&&(this._parsedIncludeExpression=C.parse(De))}matchesExcludesSync(X,le,De){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,le,De))}includedInQuerySync(X,le,De){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,le,De)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(X,le,De))}includedInQuery(X,le,De){const Te=this._parsedExcludeExpression(X,le,De),Ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(X,le,De):!0;return(0,b.isThenable)(Te)?Te.then(P=>P?!1:Ee()):Ee()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=x;function W(ue){for(const X in ue)if(typeof ue[X]!="boolean")return!0;return!1}function ee(ue){if(!ue)return;let X;return le=>(X||(X=(ue()||Promise.resolve([])).then(De=>De?oe(De):{})),X.then(De=>!!De[le]))}e.hasSiblingPromiseFn=ee;function Ie(ue){if(!ue)return;let X;return le=>{if(!X){const De=ue();X=De?oe(De):{}}return!!X[le]}}e.hasSiblingFn=Ie;function oe(ue){const X={};for(const le of ue)X[le]=!0;return X}}),define(Ae[33],Re([1,0,18,16,22,5,6,48,15,117,25,13,9,2,156,3,14,173,53,38,27,17,8,7,55,47,4]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v,n,u,r,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function D(G,q,$){return new R.ExtUri(N=>o(N,$)).isEqual(G,q)}function f(G,q,$){return D(G.uri,q.uri,$)?0:(0,b.compare)(G.uri.toString(),q.uri.toString())}function T(G,q,$){return G.index!==q.index?G.index<q.index?-1:1:D(G.uri,q.uri,$)?(0,b.compare)(G.name,q.name):(0,b.compare)(G.uri.toString(),q.uri.toString())}function w(G,q,$,N){const V=G.slice(0).sort((W,ee)=>$(W,ee,N)),x=q.slice(0).sort((W,ee)=>$(W,ee,N));return(0,i.delta)(V,x,(W,ee)=>$(W,ee,N))}function o(G,q){const $=q.getCapabilities(G.scheme);return!($&&$&1024)}class s extends h.Workspace{static toExtHostWorkspace(q,$,N,V){if(!q)return{workspace:null,added:[],removed:[]};const{id:x,name:W,folders:ee,configuration:Ie,transient:oe,isUntitled:ue}=q,X=[],le=$;$?ee.forEach((P,K)=>{const he=p.URI.revive(P.uri),ye=s._findFolder(N||$,he,V);ye?(ye.name=P.name,ye.index=P.index,X.push(ye)):X.push({uri:he,name:P.name,index:K})}):X.push(...ee.map(({uri:P,name:K,index:he})=>({uri:p.URI.revive(P),name:K,index:he}))),X.sort((P,K)=>P.index<K.index?-1:1);const De=new s(x,W,X,!!oe,Ie?p.URI.revive(Ie):null,!!ue,P=>o(P,V)),{added:Te,removed:Ee}=w(le?le.workspaceFolders:[],De.workspaceFolders,f,V);return{workspace:De,added:Te,removed:Ee}}static _findFolder(q,$,N){for(let V=0;V<q.folders.length;V++){const x=q.workspaceFolders[V];if(D(x.uri,$,N))return x}}constructor(q,$,N,V,x,W,ee){super(q,N.map(Ie=>new h.WorkspaceFolder(Ie)),V,x,ee),this._name=$,this._isUntitled=W,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(ee),N.forEach(Ie=>{this._workspaceFolders.push(Ie),this._structure.set(Ie.uri,Ie)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(q,$){return $&&this._structure.get(q)&&(q=(0,R.dirname)(q)),this._structure.findSubstr(q)}resolveWorkspaceFolder(q){return this._structure.get(q)}}let F=e.ExtHostWorkspace=class{constructor(q,$,N,V,x){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new M.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=V,this._extHostFileSystemInfo=N,this._uriTransformerService=x,this._requestIdProvider=new m.Counter,this._barrier=new C.Barrier,this._proxy=q.getProxy(E.MainContext.MainThreadWorkspace),this._messageService=q.getProxy(E.MainContext.MainThreadMessageService);const W=$.workspace;this._confirmedWorkspace=W?new s(W.id,W.name,[],!!W.transient,W.configuration?p.URI.revive(W.configuration):null,!!W.isUntitled,ee=>o(ee,N)):void 0}$initializeWorkspace(q,$){this._trusted=$,this.$acceptWorkspaceData(q),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:_.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(q,$,N,...V){const x=[];if(Array.isArray(V)&&V.forEach(ue=>{p.URI.isUri(ue.uri)&&!x.some(X=>D(X.uri,ue.uri,this._extHostFileSystemInfo))&&x.push({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[$,N].some(ue=>typeof ue!="number"||ue<0)||N===0&&x.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+N>W.length)return!1;const ee=W.slice(0);ee.splice($,N,...x.map(ue=>({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<ee.length;ue++){const X=ee[ue];if(ee.some((le,De)=>De!==ue&&D(X.uri,le.uri,this._extHostFileSystemInfo)))return!1}ee.forEach((ue,X)=>ue.index=X);const{added:Ie,removed:oe}=w(W,ee,T,this._extHostFileSystemInfo);if(Ie.length===0&&oe.length===0)return!1;if(this._proxy){const ue=q.displayName||q.name;this._proxy.$updateWorkspaceFolders(ue,$,N,x).then(void 0,X=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:q.identifier,label:q.displayName||q.name}};this._messageService.$showMessage(l.Severity.Error,(0,g.localize)(0,null,ue,X.toString()),le,[])})}return this.trySetWorkspaceFolders(ee),!0}getWorkspaceFolder(q,$){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(q,$)}async getWorkspaceFolder2(q,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(q,$)}async resolveWorkspaceFolder(q){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(q)}getPath(){if(!this._actualWorkspace)return;const{folders:q}=this._actualWorkspace;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,$){let N,V="";if(typeof q=="string"?(N=p.URI.file(q),V=q):typeof q<"u"&&(N=q,V=q.fsPath),!N)return V;const x=this.getWorkspaceFolder(N,!0);if(!x)return V;typeof $>"u"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let W=(0,R.relativePath)(x.uri,N);return $&&x.name&&(W=`${x.name}/${W}`),W}trySetWorkspaceFolders(q){this._actualWorkspace&&(this._unconfirmedWorkspace=s.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:q,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:$,added:N,removed:V}=s.toExtHostWorkspace(q,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:V}))}findFiles(q,$,N,V,x=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let W;if($===null?W=!1:$&&(typeof $=="string"?W=$:W=$.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:ee,folder:Ie}=B(n.GlobPattern.from(q));return this._proxy.$startFileSearch((0,c.withUndefinedAsNull)(ee),(0,c.withUndefinedAsNull)(Ie),(0,c.withUndefinedAsNull)(W),(0,c.withUndefinedAsNull)(N),x).then(oe=>Array.isArray(oe)?oe.map(ue=>p.URI.revive(ue)):[])}async findTextInFiles(q,$,N,V,x=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),ee=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:Ie,folder:oe}=B(n.GlobPattern.from($.include)),ue=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,X={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:ee,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:Ie,excludePattern:ue},le=!1;if(this._activeSearchCallbacks[W]=De=>{if(le)return;const Te=p.URI.revive(De.resource);De.results.forEach(Ee=>{(0,a.resultIsMatch)(Ee)?N({uri:Te,preview:{text:Ee.preview.text,matches:(0,i.mapArrayOrNot)(Ee.preview.matches,P=>new u.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn))},ranges:(0,i.mapArrayOrNot)(Ee.ranges,P=>new u.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn))}):N({uri:Te,text:Ee.text,lineNumber:Ee.lineNumber})})},x.isCancellationRequested)return{};try{const De=await this._proxy.$startTextSearch(q,(0,c.withUndefinedAsNull)(oe),X,W,x);return delete this._activeSearchCallbacks[W],De||{}}catch(De){throw delete this._activeSearchCallbacks[W],De}}$handleTextSearchResult(q,$){this._activeSearchCallbacks[$]?.(q)}async save(q){const $=await this._proxy.$save(q,{saveAs:!1});return p.URI.revive($)}async saveAs(q){const $=await this._proxy.$save(q,{saveAs:!0});return p.URI.revive($)}saveAll(q){return this._proxy.$saveAll(q)}resolveProxy(q){return this._proxy.$resolveProxy(q)}get trusted(){return this._trusted}requestWorkspaceTrust(q){return this._proxy.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(q,$){if(this._editSessionIdentityProviders.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this._editSessionIdentityProviders.set(q,$);const N=this._uriTransformerService.transformOutgoingScheme(q),V=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(V,N),(0,O.toDisposable)(()=>{this._editSessionIdentityProviders.delete(q),this._proxy.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(q,$){this._logService.info("Getting edit session identifier for workspaceFolder",q);const N=await this.resolveWorkspaceFolder(p.URI.revive(q));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const V=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!V),!V)return;const x=await V.provideEditSessionIdentity(N,$);if(this._logService.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch(q,$,N,V){this._logService.info("Getting edit session identifier for workspaceFolder",q);const x=await this.resolveWorkspaceFolder(p.URI.revive(q));if(!x){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const W=this._editSessionIdentityProviders.get(x.uri.scheme);if(this._logService.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!W),!W)return;const ee=await W.provideEditSessionIdentityMatch?.($,N,V);if(this._logService.info("Provider returned edit session identifier match result: ",ee),!!ee)return ee}getOnWillCreateEditSessionIdentityEvent(q){return($,N,V)=>{const x=function(ee){$.call(N,ee)};return x.extension=q,this._onWillCreateEditSessionIdentityEvent.event(x,void 0,V)}}async $onWillCreateEditSessionIdentity(q,$,N){const V=await this.resolveWorkspaceFolder(p.URI.revive(q));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:V},$,async(x,W)=>{const ee=Date.now();await Promise.resolve(x),Date.now()-ee>N&&this._logService.warn("SLOW edit session create-participant",W.extension.identifier)}),$.isCancellationRequested}registerCanonicalUriProvider(q,$){if(this._canonicalUriProviders.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this._canonicalUriProviders.set(q,$);const N=this._uriTransformerService.transformOutgoingScheme(q),V=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(V,N),(0,O.toDisposable)(()=>{this._canonicalUriProviders.delete(q),this._proxy.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri(q,$,N){const V=this._canonicalUriProviders.get(q.scheme);if(!V)return;const x=await V.provideCanonicalUri?.(p.URI.revive(q),$,N);if(x)return x}async $provideCanonicalUri(q,$,N){return this.provideCanonicalUri(p.URI.revive(q),{targetScheme:$},N)}};e.ExtHostWorkspace=F=je([We(0,v.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,S.IExtHostFileSystemInfo),We(3,t.ILogService),We(4,r.IURITransformerService)],F),e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function B(G){let q,$;return G&&(typeof G=="string"?q=G:(q=G.pattern,$=p.URI.revive(G.baseUri))),{includePattern:q,folder:$}}}),define(Ae[34],Re([1,0,26,5,33,4,7,176,96,9,16,3,17,14,2]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(u,r){if(r){const a=r.split(".");let E=u;for(let D=0;E&&D<a.length;D++)E=E[a[D]];return E}}function t(u){return u instanceof g.URI}function l(u){return u&&u.uri instanceof g.URI&&u.languageId&&typeof u.languageId=="string"}function h(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function S(u){return u&&u.uri instanceof g.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function I(u){if(t(u))return{resource:u};if(l(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(h(u))return{overrideIdentifier:u.languageId};if(S(u))return{resource:u.uri};if(u===null)return{resource:null}}let v=e.ExtHostConfiguration=class{constructor(r,a,E){this._proxy=r.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=E,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(r,a))}};e.ExtHostConfiguration=v=je([We(0,c.IExtHostRpcService),We(1,y.IExtHostWorkspace),We(2,p.ILogService)],v);class n{constructor(r,a,E,D){this._onDidChangeConfiguration=new C.Emitter,this._proxy=r,this._logService=D,this._extHostWorkspace=a,this._configuration=A.Configuration.parse(E),this._configurationScopes=this._toMap(E.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,a){const E={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,E))}getConfiguration(r,a,E){const D=I(a)||{},f=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,D,E?.identifier);function T(o){if(o==null)return null;if(typeof o=="boolean")return o?2:5;switch(o){case O.ConfigurationTarget.Global:return 2;case O.ConfigurationTarget.Workspace:return 5;case O.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(o){return typeof d(f,o)<"u"},get:(o,s)=>{this._validateConfigurationAccess(r?`${r}.${o}`:o,D,E?.identifier);let F=d(f,o);if(typeof F>"u")F=s;else{let B;const G=(q,$)=>{if((0,m.isObject)(q)){let N;const V=()=>{B=B||(0,i.deepClone)(f),N=N||d(B,$)};return new Proxy(q,{get:(x,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return V(),()=>N;if(B)return N=N||d(B,$),N[W];const ee=x[W];return typeof W=="string"?G(ee,`${$}.${W}`):ee},set:(x,W,ee)=>(V(),N&&(N[W]=ee),!0),deleteProperty:(x,W)=>(V(),N&&delete N[W],!0),defineProperty:(x,W,ee)=>(V(),N&&Object.defineProperty(N,W,ee),!0)})}return Array.isArray(q)?(0,i.deepClone)(q):q};F=G(F,o)}return F},update:(o,s,F,B)=>{o=r?`${r}.${o}`:o;const G=T(F);return s!==void 0?this._proxy.$updateConfigurationOption(G,o,s,D,B):this._proxy.$removeConfigurationOption(G,o,D,B)},inspect:o=>{o=r?`${r}.${o}`:o;const s=this._configuration.inspect(o,D,this._extHostWorkspace.workspace);if(s)return{key:o,defaultValue:(0,i.deepClone)(s.policy?.value??s.default?.value),globalValue:(0,i.deepClone)(s.user?.value??s.application?.value),workspaceValue:(0,i.deepClone)(s.workspace?.value),workspaceFolderValue:(0,i.deepClone)(s.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(s.default?.override),globalLanguageValue:(0,i.deepClone)(s.user?.override??s.application?.override),workspaceLanguageValue:(0,i.deepClone)(s.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(s.workspaceFolder?.override),languageIds:(0,i.deepClone)(s.overrideIdentifiers)}}};return typeof f=="object"&&(0,i.mixin)(w,f,!1),Object.freeze(w)}_toReadonlyValue(r){const a=E=>(0,m.isObject)(E)?new Proxy(E,{get:(D,f)=>a(D[f]),set:(D,f,T)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(D,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(D,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return a(r)}_validateConfigurationAccess(r,a,E){const D=_.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),f=E?`[${E.value}] `:"";if(D===4){typeof a?.resource>"u"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(D===3){a?.resource&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,a){const E=new A.ConfigurationChangeEvent(r,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(D,f)=>E.affectsConfiguration(D,I(f))})}_toMap(r){return r.reduce((a,E)=>(a.set(E[0],E[1]),a),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[111],Re([1,0,2,16,5,4,7,33,59,34,22,62,17,27,3,15,21,14,79,213,10]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(q){function $(V){if(V!=null)return V}q.from=$;function N(V){if(V!=null)return V}q.to=N})(n||(n={}));var u;(function(q){function $(V){if(V!=null)return V}q.from=$;function N(V){if(V!=null)return V}q.to=N})(u||(u={}));var r;(function(q){function $(V){if(V!=null)return V}q.from=$;function N(V){if(V!=null)return V}q.to=N})(r||(r={}));var a;(function(q){function $(x){if(x){const W=x;return W&&!!W.process}else return!1}q.is=$;function N(x){if(x==null)return;const W={process:x.process,args:x.args};return x.options&&(W.options=r.from(x.options)),W}q.from=N;function V(x){if(x!=null)return new O.ProcessExecution(x.process,x.args,x.options)}q.to=V})(a||(a={}));var E;(function(q){function $(V){if(V!=null)return V}q.from=$;function N(V){if(V!=null)return V}q.to=N})(E||(E={}));var D;(function(q){function $(x){if(x){const W=x;return W&&(!!W.commandLine||!!W.command)}else return!1}q.is=$;function N(x){if(x==null)return;const W={};return x.commandLine!==void 0?W.commandLine=x.commandLine:(W.command=x.command,W.args=x.args),x.options&&(W.options=E.from(x.options)),W}q.from=N;function V(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new O.ShellExecution(x.commandLine,x.options):new O.ShellExecution(x.command,x.args?x.args:[],x.options)}q.to=V})(D||(D={}));var f;(function(q){function $(x){if(x){const W=x;return W&&W.customExecution==="customExecution"}else return!1}q.is=$;function N(x){return{customExecution:"customExecution"}}q.from=N;function V(x,W){return W.get(x)}q.to=V})(f||(e.CustomExecutionDTO=f={}));var T;(function(q){function $(N,V){let x;return N.scope!==void 0&&typeof N.scope!="number"?x=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===O.TaskScope.Workspace&&V&&V.workspaceFile?x=V.workspaceFile:x=S.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:x}}q.from=$})(T||(e.TaskHandleDTO=T={}));var w;(function(q){function $(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}q.from=$})(w||(w={}));var o;(function(q){function $(x,W){if(x==null)return[];const ee=[];for(const Ie of x){const oe=N(Ie,W);oe&&ee.push(oe)}return ee}q.fromMany=$;function N(x,W){if(x==null)return;let ee;x.execution instanceof O.ProcessExecution?ee=a.from(x.execution):x.execution instanceof O.ShellExecution?ee=D.from(x.execution):x.execution&&x.execution instanceof O.CustomExecution&&(ee=f.from(x.execution));const Ie=n.from(x.definition);let oe;return x.scope?typeof x.scope=="number"?oe=x.scope:oe=x.scope.uri:oe=O.TaskScope.Workspace,!Ie||!oe?void 0:{_id:x._id,definition:Ie,name:x.name,source:{extensionId:W.identifier.value,label:x.source,scope:oe},execution:ee,isBackground:x.isBackground,group:w.from(x.group),presentationOptions:u.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}q.from=N;async function V(x,W,ee){if(x==null)return;let Ie;a.is(x.execution)?Ie=a.to(x.execution):D.is(x.execution)?Ie=D.to(x.execution):f.is(x.execution)&&(Ie=f.to(x._id,ee));const oe=n.to(x.definition);let ue;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?ue=x.source.scope:ue=await W.resolveWorkspaceFolder(i.URI.revive(x.source.scope)):ue=O.TaskScope.Workspace),!oe||!ue)return;const X=new O.Task(oe,ue,x.name,x.source.label,Ie,x.problemMatchers);return x.isBackground!==void 0&&(X.isBackground=x.isBackground),x.group!==void 0&&(X.group=O.TaskGroup.from(x.group._id),X.group&&x.group.isDefault&&(X.group=new O.TaskGroup(X.group.id,X.group.label),x.group.isDefault===!0&&(X.group.isDefault=x.group.isDefault))),x.presentationOptions&&(X.presentationOptions=u.to(x.presentationOptions)),x._id&&(X._id=x._id),x.detail&&(X.detail=x.detail),X}q.to=V})(o||(e.TaskDTO=o={}));var s;(function(q){function $(V){return V}q.from=$;function N(V){if(V)return Object.assign(Object.create(null),V)}q.to=N})(s||(s={}));class F{constructor($,N,V){this._id=N,this._task=V,v.set(this,void 0),Qe(this,v,$,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}v=new WeakMap;let B=e.ExtHostTaskBase=class{constructor($,N,V,x,W,ee,Ie,oe){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=$.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=x,this._configurationService=W,this._terminalService=ee,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Ie,this._deprecationService=oe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,N,V){if(!V)return new O.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:N,provider:V,extension:$}),this._proxy.$registerTaskProvider(x,N),new O.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem($,N){this._proxy.$registerTaskSystem($,N)}fetchTasks($){return this._proxy.$fetchTasks(s.from($)).then(async N=>{const V=[];for(const x of N){const W=await o.to(x,this._workspaceProvider,this._providedCustomExecutions2);W&&V.push(W)}return V})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(N=>$.push(N)),$}terminateTask($){if(!($ instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,N,V){const x=this._providedCustomExecutions2.get($.id);x&&(this._activeCustomExecutions2.set($.id,x),this._terminalService.attachPtyToTerminal(N,await x.callback(V))),this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const N=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const N=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:N,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const N=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:$.exitCode})}$provideTasks($,N){const V=this._handlers.get($);if(!V)return Promise.reject(new Error("no handler found"));const x=[],W=(0,C.asPromise)(()=>V.provider.provideTasks(R.CancellationToken.None)).then(ee=>this.provideTasksInternal(N,x,V,ee));return new Promise(ee=>{W.then(Ie=>{Promise.all(x).then(()=>{ee(Ie)})})})}async $resolveTask($,N){const V=this._handlers.get($);if(!V)return Promise.reject(new Error("no handler found"));if(N.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${V.type}].`);const x=await o.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const W=await V.provider.resolveTask(x,R.CancellationToken.None);if(!W)return;this.checkDeprecation(W,V);const ee=o.from(W,V.extension);if(!ee)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ee.execution)&&await this.addCustomExecution(ee,W,!0),await this.resolveTaskInternal(ee)}nextHandle(){return this._handleCounter++}async addCustomExecution($,N,V){const x=await this._proxy.$createTaskId($);!V&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,N.execution)),this._providedCustomExecutions2.set(x,N.execution)}async getTaskExecution($,N){if(typeof $=="string"){const W=this._taskExecutionPromises.get($);if(!W)throw new I.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return W}const V=this._taskExecutionPromises.get($.id);if(V)return V;const x=new Promise((W,ee)=>{function Ie(oe,ue,X){X?W(new F(oe,ue.id,X)):ee("Unexpected: Task does not exist.")}N?Ie(this,$,N):o.to($.task,this._workspaceProvider,this._providedCustomExecutions2).then(oe=>Ie(this,$,oe))});return this._taskExecutionPromises.set($.id,x),x.then(W=>(this._taskExecutions.set($.id,W),W),W=>Promise.reject(W))}checkDeprecation($,N){$._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));const V=this._notProvidedCustomExecutions.values();let x=V.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=V.next()}};e.ExtHostTaskBase=B=je([We(0,c.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,b.IExtHostTerminalService),We(6,l.ILogService),We(7,h.IExtHostApiDeprecationService)],B);let G=e.WorkerExtHostTask=class extends B{constructor($,N,V,x,W,ee,Ie,oe){super($,N,V,x,W,ee,Ie,oe),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask($,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const V=o.from(N,$);if(V===void 0)throw new Error("Task is not valid");if(f.is(V.execution))await this.addCustomExecution(V,N,!1);else throw new I.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),N);return this._proxy.$executeTask(V).catch(W=>{throw new Error(W)}),x}provideTasksInternal($,N,V,x){const W=[];if(x)for(const ee of x){this.checkDeprecation(ee,V),(!ee.definition||!$[ee.definition.type])&&this._logService.warn(`The task [${ee.source}, ${ee.name}] uses an undefined task type. The task will be ignored in the future.`);const Ie=o.from(ee,V.extension);Ie&&f.is(Ie.execution)?(W.push(Ie),N.push(this.addCustomExecution(Ie,ee,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:V.extension}}async resolveTaskInternal($){if(f.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,N,V){}};e.WorkerExtHostTask=G=je([We(0,c.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,b.IExtHostTerminalService),We(6,l.ILogService),We(7,h.IExtHostApiDeprecationService)],G),e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Ae[260],Re([1,0,19,22,40,37,25,58,47]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(c,p,g){this.config=c,this.provider=p,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&M.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&M.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const p=this.config.folderQueries||[];return new Promise((g,d)=>{const t=l=>{this.resultCount++,c(l)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(l=>{const h=l.toString(),S=i.basename(h);this.globalExcludePattern&&this.globalExcludePattern(h,S)||this.matchFile(t,{base:l,basename:S})}),Promise.all(p.map(l=>this.searchInFolder(l,t))).then(l=>{g({limitHit:this.isLimitHit,stats:l[0]||void 0})},l=>{d(new Error((0,y.toErrorMessage)(l)))})})}async searchInFolder(c,p){const g=new C.CancellationTokenSource,d=this.getSearchOptionsForFolder(c),t=this.initDirectoryTree(),l=new _.QueryGlobTester(this.config,c),h=!l.hasSiblingExcludeClauses();let S;try{this.activeCancellationTokens.add(g),S=A.StopWatch.create();const I=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,g.token),v=S.elapsed(),n=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(I&&I.forEach(u=>{const r=i.posix.relative(c.folder.path,u.path);if(h){const a=i.basename(u.path);this.matchFile(p,{base:c.folder,relativePath:r,basename:a});return}this.addDirectoryEntries(t,c.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,l,p),{providerTime:v,postProcessTime:n.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(c){const p=(0,_.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),g=(0,_.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:g,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},p,g,d){if(g===this.filePattern){const l=i.basename(this.filePattern);this.matchFile(d,{base:p,relativePath:this.filePattern,basename:l})}function t(l){const h=i.basename(l),S=i.dirname(l);let I=c[S];I||(I=c[S]=[],t(S)),I.push({base:p,relativePath:l,basename:h})}t(g)}matchDirectoryTree({rootEntries:c,pathToEntries:p},g,d){const t=this,l=this.filePattern;function h(S){const I=(0,_.hasSiblingFn)(()=>S.map(v=>v.basename));for(let v=0,n=S.length;v<n;v++){const u=S[v],{relativePath:r,basename:a}=u;if(g.matchesExcludesSync(r,a,l!==a?I:void 0))continue;const E=p[r];if(E)h(E);else{if(r===l)continue;t.matchFile(d,u)}if(t.isLimitHit)break}}h(c)}matchFile(c,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(p))}}class R{constructor(){this.sessions=new Map}fileSearch(c,p,g,d){const t=this.getSessionTokenSource(c.cacheKey),l=new m(c,p,t&&t.token);let h=0;const S=I=>{h+=I.length,g(I.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(l,R.BATCH_SIZE,S,d).then(I=>({limitHit:I.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:I.stats}}))}clearCache(c){this.getSessionTokenSource(c)?.cancel()}getSessionTokenSource(c){if(c)return this.sessions.has(c)||this.sessions.set(c,new C.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:O.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,p,g,d){d.onCancellationRequested(()=>{c.cancel()});const t=h=>{h&&(l.push(h),p>0&&l.length>=p&&(g(l),l=[]))};let l=[];return c.search(t).then(h=>(l.length&&g(l),h),h=>(l.length&&g(l),Promise.reject(h)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ae[261],Re([1,0,18,64,37,90,28,15,19,25,13,9,2,275,165,42,14,53,101,259,47]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=e.QueryBuilder=class{constructor(o,s,F,B,G){this.configurationService=o,this.workspaceContextService=s,this.editorGroupsService=F,this.logService=B,this.pathService=G}text(o,s,F={}){o=this.getContentPattern(o,F);const B=this.configurationService.getValue(),G=s&&s.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(s?.map(l.toWorkspaceFolder),F),type:2,contentPattern:o,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:B.search.usePCRE2||G||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}getContentPattern(o,s){const F=this.configurationService.getValue();o.isRegExp&&(o.pattern=o.pattern.replace(/\r?\n/g,"\\n"));const B={...o,wordSeparators:F.editor.wordSeparators};return this.isCaseSensitive(o,s)&&(B.isCaseSensitive=!0),this.isMultiline(o)&&(B.isMultiline=!0),s.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=s.notebookSearchConfig.includeMarkupInput),s.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=s.notebookSearchConfig.includeMarkupPreview),s.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=s.notebookSearchConfig.includeCodeInput),s.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=s.notebookSearchConfig.includeOutput),B}file(o,s={}){return{...this.commonQuery(o,s),type:1,filePattern:s.filePattern?s.filePattern.trim():s.filePattern,exists:s.exists,sortByScore:s.sortByScore,cacheKey:s.cacheKey}}handleIncludeExclude(o,s){return o?(o=Array.isArray(o)?o.map(E):E(o),s?this.parseSearchPaths(o):{pattern:u(...Array.isArray(o)?o:[o])}):{}}commonQuery(o=[],s={}){const F=this.handleIncludeExclude(s.includePattern,s.expandPatterns),B=this.handleIncludeExclude(s.excludePattern,s.expandPatterns),G=o.length>1,q=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,s,B)):o.map(V=>this.getFolderQueryForRoot(V,s,B,G))).filter(V=>!!V),$={_reason:s._reason,folderQueries:q,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:s.extraFileResources,excludePattern:B.pattern,includePattern:F.pattern,onlyOpenEditors:s.onlyOpenEditors,maxResults:s.maxResults};if(s.onlyOpenEditors){const V=i.coalesce(i.flatten(this.editorGroupsService.groups.map(ee=>ee.editors.map(Ie=>Ie.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(V));const x=V.filter(ee=>(0,I.pathIncludedInQuery)($,ee.fsPath)),W=this.commonQueryFromFileList(x);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...$,...W}}const N=s.extraFileResources&&s.extraFileResources.filter(V=>(0,I.pathIncludedInQuery)($,V.fsPath));return $.extraFileResources=N&&N.length?N:void 0,$}commonQueryFromFileList(o){const s=[],F=new O.ResourceMap,B={};let G=!1;return o.forEach(q=>{if(q.scheme===A.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(q)){const N=this.workspaceContextService.getWorkspaceFolder(q)?.uri??q.with({path:_.dirname(q.fsPath)});let V=F.get(N);V||(G=!0,V={folder:N,includePattern:{}},s.push(V),F.set(N,V));const x=_.relative(N.fsPath,q.fsPath);(0,b.assertIsDefined)(V.includePattern)[x.replace(/\\/g,"/")]=!0}else q.fsPath&&(G=!0,B[q.fsPath]=!0)}),{folderQueries:s,includePattern:B,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}isCaseSensitive(o,s){if(s.isSmartCase){if(o.isRegExp){if(R.containsUppercaseCharacter(o.pattern,!0))return!0}else if(R.containsUppercaseCharacter(o.pattern))return!0}return!!o.isCaseSensitive}isMultiline(o){return o.isMultiline||o.isRegExp&&(0,p.isMultilineRegexSource)(o.pattern)||o.pattern.indexOf(`
`)>=0?!0:!!o.isMultiline}parseSearchPaths(o){const s=W=>_.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),B=(Array.isArray(o)?o:r(o)).map(W=>{const ee=this.pathService.resolvedUserHome;return ee?(0,M.untildify)(W,ee.scheme===A.Schemas.file?ee.fsPath:ee.path):W}),G=C.groupBy(B,W=>s(W)?"searchPaths":"exprSegments"),q=(G.exprSegments||[]).map(W=>R.rtrim(W,"/")).map(W=>R.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),a(W))),$={},N=this.expandSearchPathPatterns(G.searchPaths||[]);N&&N.length&&($.searchPaths=N);const V=i.flatten(q),x=u(...V);return x&&($.pattern=x),$}getExcludesForFolder(o,s){return s.disregardExcludeSettings?void 0:(0,I.getExcludes)(o,!s.disregardSearchExcludeSettings)}expandSearchPathPatterns(o){if(!o||!o.length)return[];const s=o.flatMap(B=>{let{pathPortion:G,globPortion:q}=n(B);return q&&(q=D(q)),this.expandOneSearchPath(G).flatMap(N=>this.resolveOneSearchPathPattern(N,q))}),F=new Map;return s.forEach(B=>{const G=B.searchPath.toString(),q=F.get(G);q?B.pattern&&(q.pattern=q.pattern||{},q.pattern[B.pattern]=!0):F.set(G,{searchPath:B.searchPath,pattern:B.pattern?u(B.pattern):void 0})}),Array.from(F.values())}expandOneSearchPath(o){if(_.isAbsolute(o)){const s=this.workspaceContextService.getWorkspace().folders;return s[0]&&s[0].uri.scheme!==A.Schemas.file?[{searchPath:s[0].uri.with({path:o})}]:[{searchPath:c.URI.file(_.normalize(o))}]}if(this.workspaceContextService.getWorkbenchState()===2){const s=this.workspaceContextService.getWorkspace().folders[0].uri;if(o=E(o),o.startsWith("../")||o===".."){const B=_.posix.resolve(s.path,o);return[{searchPath:s.with({path:B})}]}const F=D(o);return[{searchPath:s,pattern:F}]}else{if(o==="./"||o===".\\")return[];{const s=o.replace(/^\.[\/\\]/,""),B=this.workspaceContextService.getWorkspace().folders.map(G=>{const q=s.match(new RegExp(`^${R.escapeRegExpCharacters(G.name)}(?:/(.*)|$)`));return q?{match:q,folder:G}:null}).filter(b.isDefined);if(B.length)return B.map(G=>{const q=G.match[1];return{searchPath:G.folder.uri,pattern:q&&D(q)}});{const G=o.match(/\.[\/\\](.+)[\/\\]?/),q=G?G[1]:o,$=g.localize(0,null,q);throw new Error($)}}}}resolveOneSearchPathPattern(o,s){const F=o.pattern&&s?`${o.pattern}/${s}`:o.pattern||s,B=[{searchPath:o.searchPath,pattern:F}];return F&&!F.endsWith("**")&&B.push({searchPath:o.searchPath,pattern:F+"/**"}),B}getFolderQueryForSearchPath(o,s,F){const B=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(o.searchPath),s,F,!1);return B?{...B,includePattern:o.pattern}:null}getFolderQueryForRoot(o,s,F,B){let G;const q=c.URI.isUri(o)?o:o.uri;if(F.searchPaths){const W=F.searchPaths.filter(ee=>(0,m.isEqual)(ee.searchPath,q))[0];if(W&&!W.pattern)return null;W&&(G=W.pattern)}const $=this.configurationService.getValue({resource:q}),V={...this.getExcludesForFolder($,s)||{},...G||{}},x=c.URI.isUri(o)?(0,m.basename)(o):o.name;return{folder:q,folderName:B?x:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof s.disregardIgnoreFiles=="boolean"?s.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof s.disregardGlobalIgnoreFiles=="boolean"?s.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof s.disregardParentIgnoreFiles=="boolean"?s.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof s.ignoreSymlinks=="boolean"?s.ignoreSymlinks:!$.search.followSymlinks}}};e.QueryBuilder=v=je([We(0,d.IConfigurationService),We(1,l.IWorkspaceContextService),We(2,h.IEditorGroupsService),We(3,t.ILogService),We(4,S.IPathService)],v);function n(w){const o=w.match(/[\*\{\}\(\)\[\]\?]/);if(o){const s=o.index,F=w.substr(0,s).match(/[/|\\][^/\\]*$/);if(F){let B=w.substr(0,F.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:w.substr((F.index||0)+1)}}}return{pathPortion:w}}function u(...w){return w.length?w.reduce((o,s)=>(o[s]=!0,o),Object.create(null)):void 0}function r(w){return y.splitGlobAware(w,",").map(o=>o.trim()).filter(o=>!!o.length)}function a(w){return[`**/${w}/**`,`**/${w}`].map(s=>s.replace(/\*\*\/\*\*/g,"**"))}function E(w){return w.replace(/\\/g,"/")}function D(w){return E(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(w){return w.replace(/([?*[\]])/g,"[$1]")}function T(w,o){w=i.distinct(w,B=>B.toString());const s=[],F=o.getWorkspace();return w&&w.forEach(B=>{let G;if(o.getWorkbenchState()===2)G=(0,m.relativePath)(F.folders[0].uri,B),G&&G!=="."&&(G="./"+G);else{const q=o.getWorkspaceFolder(B);if(q){const $=q.name;if(F.folders.filter(V=>V.name===$).length===1){const V=(0,m.relativePath)(q.uri,B);V===""?G=`./${q.name}`:G=`./${q.name}/${V}`}else G=B.fsPath}}G&&s.push(f(G))}),s}e.resolveResourcesForSearchIncludes=T}),define(Ae[262],Re([1,0,25,2,22,10,3,261,47,53]),function(te,e,i,C,y,M,O,A,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function b(d,t){const l=t.activationEvents;if(!l)return Promise.resolve(void 0);const h=[],S=[];for(const a of l)if(/^workspaceContains:/.test(a)){const E=a.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||d.forceUsingSearch?S.push(E):h.push(E)}if(h.length===0&&S.length===0)return Promise.resolve(void 0);let I;const v=new Promise((a,E)=>{I=a}),n=a=>I({activationEvent:a}),u=Promise.all(h.map(a=>c(d,a,n))).then(()=>{}),r=p(d,t.identifier,S,n);return Promise.all([u,r]).then(()=>{I(void 0)}),v}e.checkActivateWorkspaceContainsExtension=b;async function c(d,t,l){for(const h of d.folders)if(await d.exists(i.joinPath(C.URI.revive(h),t))){l(`workspaceContains:${t}`);return}}async function p(d,t,l,h){if(l.length===0)return Promise.resolve(void 0);const S=new y.CancellationTokenSource,I=d.checkExists(d.folders,l,S.token),v=setTimeout(async()=>{S.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},R);let n=!1;try{n=await I}catch(u){M.isCancellationError(u)||M.onUnexpectedError(u)}S.dispose(),clearTimeout(v),n&&h(`workspaceContains:${l.join(",")}`)}function g(d,t,l,h){const S=d.get(O.IInstantiationService),I=d.get(_.ISearchService),n=S.createInstance(A.QueryBuilder).file(t.map(u=>(0,m.toWorkspaceFolder)(C.URI.revive(u))),{_reason:"checkExists",includePattern:l,exists:!0});return I.fileSearch(n,h).then(u=>!!u.limitHit,u=>M.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=g});var Qe=this&&this.__classPrivateFieldSet||function(te,e,i,C,y){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Oe=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(Ae[35],Re([1,0,148,19,85,25,16,6,48,2,14,4,34,201,83,33,20,102,10,23,24,187,7,97,3,27,84,17,71,73,62,5,262,82,189,15,80,58,21,81]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v,n,u,r,a,E,D,f,T,w,o,s,F,B,G,q,$,N,V){"use strict";var x,W,ee;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Ie=e.AbstractExtHostExtensionService=class Ln extends A.Disposable{constructor(P,K,he,ye,be,ge,Ce,ae,de,Z,ne,k){super(),this._extHostManagedSockets=k,this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=K,this._extHostContext=he,this._initData=Ce,this._extHostWorkspace=ye,this._extHostConfiguration=be,this._logService=ge,this._extHostTunnelService=de,this._extHostTerminalService=Z,this._extHostLocalizationService=ne,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new O.Barrier,this._readyToStartExtensionHost=new O.Barrier,this._readyToRunExtensions=new O.Barrier,this._eagerExtensionsActivated=new O.Barrier,this._activationEventsReader=new Te(this._initData.activationEvents),this._globalRegistry=new l.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const z=new S.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new l.ExtensionDescriptionRegistry(this._activationEventsReader,le(this._globalRegistry,z)),this._storage=new g.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=ae,this._instaService=P.createChild(new f.ServiceCollection([g.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState])),this._activator=this._register(new p.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(H,j,ce)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(H,h.transformErrorForSerialization(j),ce)},actualActivateExtension:async(H,j)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(H,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(H,j),new p.HostExtension;const ce=this._myRegistry.getExtensionDescription(H);return this._activateExtension(ce,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(P){h.onUnexpectedError(P)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let P=[];try{P=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(P)}terminate(P,K=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${P}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),h.setUnexpectedErrorHandler(ye=>{this._logService.error(ye)}),this._extHostContext.dispose();const he=this._deactivateAll();Promise.race([(0,O.timeout)(5e3),he]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`):this._logService.info(`Extension host exiting with code ${K}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(K)})}isActivated(P){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(P):!1}async getExtension(P){const K=await this._mainThreadExtensionsProxy.$getExtension(P);return K&&{...K,identifier:new S.ExtensionIdentifier(K.identifier.value),extensionLocation:m.URI.revive(K.extensionLocation)}}_activateByEvent(P,K){return this._activator.activateByEvent(P,K)}_activateById(P,K){return this._activator.activateById(P,K)}activateByIdWithErrors(P,K){return this._activateById(P,K).then(()=>{const he=this._activator.getActivatedExtension(P);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(P=>this._myRegistry)}getExtensionExports(P){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(P).exports;try{return this._activator.getActivatedExtension(P).exports}catch{return null}}async _realPathExtensionUri(P){if(P.scheme!==G.Schemas.file)return P;const K=await this._hostUtils.realpath(P.fsPath);return m.URI.file(K)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(P=>new De(P))),this._extensionPathIndex}async _createExtensionPathIndex(P){const K=_.TernarySearchTree.forUris(he=>M.extUriBiasedIgnorePathCase.ignorePathCasing(he));return await Promise.all(P.map(async he=>{if(this._getEntryPoint(he)){const ye=await this._realPathExtensionUri(he.extensionLocation);K.set(ye,he)}})),K}_deactivate(P){let K=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(P))return K;const he=this._activator.getActivatedExtension(P);if(!he)return K;try{typeof he.module.deactivate=="function"&&(K=Promise.resolve(he.module.deactivate()).then(void 0,ye=>(this._logService.error(ye),Promise.resolve(void 0))))}catch(ye){this._logService.error(`An error occurred when deactivating the extension '${P.value}':`),this._logService.error(ye)}try{(0,A.dispose)(he.subscriptions)}catch(ye){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${P.value}':`),this._logService.error(ye)}return K}async _activateExtension(P,K){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(P.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(P.identifier),this._doActivateExtension(P,K).then(he=>{const ye=he.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(P.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,K),this._logExtensionActivationTimes(P,K,"success",ye),he},he=>{throw this._logExtensionActivationTimes(P,K,"failure"),he})}_logExtensionActivationTimes(P,K,he,ye){const be=ue(P,K);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...ye||{},outcome:he})}_doActivateExtension(P,K){const he=ue(P,K);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",he);const ye=this._getEntryPoint(P);if(!ye)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${P.identifier.value}, startup: ${K.startup}, activationEvent: '${K.activationEvent}'${P.identifier.value!==K.extensionId.value?`, root cause: ${K.extensionId.value}`:""}`),this._logService.flush();const be=new p.ExtensionActivationTimesBuilder(K.startup);return Promise.all([this._loadCommonJSModule(P,(0,M.joinPath)(P.extensionLocation,ye),be),this._loadExtensionContext(P)]).then(ge=>(y.mark(`code/extHost/willActivateExtension/${P.identifier.value}`),Ln._callActivate(this._logService,P.identifier,ge[0],ge[1],be))).then(ge=>(y.mark(`code/extHost/didActivateExtension/${P.identifier.value}`),ge))}_loadExtensionContext(P){const K=new v.ExtensionGlobalMemento(P,this._storage),he=new v.ExtensionMemento(P.identifier.value,!1,this._storage),ye=new B.ExtensionSecrets(P,this._secretState),be=P.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ge=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${P.identifier.value}`),Promise.all([K.whenReady,he.whenReady,this._storagePath.whenReady]).then(()=>{const Ce=this;let ae,de;const Z=(0,t.isProposedApiEnabled)(P,"ipc")?this._initData.messagePorts?.get(S.ExtensionIdentifier.toKey(P.identifier)):void 0;return Object.freeze({globalState:K,workspaceState:he,secrets:ye,subscriptions:[],get extensionUri(){return P.extensionLocation},get extensionPath(){return P.extensionLocation.fsPath},asAbsolutePath(ne){return C.join(P.extensionLocation.fsPath,ne)},get storagePath(){return Ce._storagePath.workspaceValue(P)?.fsPath},get globalStoragePath(){return Ce._storagePath.globalValue(P).fsPath},get logPath(){return C.join(Ce._initData.logsLocation.fsPath,P.identifier.value)},get logUri(){return m.URI.joinPath(Ce._initData.logsLocation,P.identifier.value)},get storageUri(){return Ce._storagePath.workspaceValue(P)},get globalStorageUri(){return Ce._storagePath.globalValue(P)},get extensionMode(){return be},get extension(){return ae===void 0&&(ae=new X(Ce,P.identifier,P,ge,!1)),ae},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(P,"extensionRuntime"),Ce.extensionRuntime},get environmentVariableCollection(){return Ce._extHostTerminalService.getEnvironmentVariableCollection(P)},get messagePassingProtocol(){if(!de){if(!Z)return;const ne=o.Event.buffer(o.Event.fromDOMEventEmitter(Z,"message",k=>k.data));Z.start(),de={onDidReceiveMessage:ne,postMessage:Z.postMessage.bind(Z)}}return de}})})}static _callActivate(P,K,he,ye,be){return he=he||{activate:void 0,deactivate:void 0},this._callActivateOptional(P,K,he,ye,be).then(ge=>new p.ActivatedExtension(!1,null,be.build(),he,ge,ye.subscriptions))}static _callActivateOptional(P,K,he,ye,be){if(typeof he.activate=="function")try{be.activateCallStart(),P.trace(`ExtensionService#_callActivateOptional ${K.value}`);const ge=typeof global=="object"?global:self,Ce=he.activate.apply(ge,[ye]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Ce).then(ae=>(be.activateResolveStop(),ae))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(he)}_activateOneStartupFinished(P,K){this._activateById(P.identifier,{startup:!1,extensionId:P.identifier,activationEvent:K}).then(void 0,he=>{this._logService.error(he)})}_activateAllStartupFinishedDeferred(P,K=0){const ye=Date.now();(0,N.setTimeout0)(()=>{for(let be=K;be<P.length;be+=1){const ge=P[be];for(const Ce of ge.activationEvents??[])if(Ce==="onStartupFinished")if(Date.now()-ye>50){this._activateAllStartupFinishedDeferred(P,be);break}else this._activateOneStartupFinished(ge,Ce)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks()),this._extHostConfiguration.getConfigProvider().then(P=>{const K=P.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),he=this._myRegistry.getAllExtensionDescriptions();if(K)this._activateAllStartupFinishedDeferred(he);else for(const ye of he)if(ye.activationEvents)for(const be of ye.activationEvents)be==="onStartupFinished"&&this._activateOneStartupFinished(ye,be)})}_handleEagerExtensions(){const P=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const K=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],he=this._handleWorkspaceContainsEagerExtensions(K),ye=this._handleRemoteResolverEagerExtensions(),be=Promise.all([ye,P,he]).then(()=>{});return Promise.race([be,(0,O.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),be}_handleWorkspaceContainsEagerExtensions(P){return P.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(K=>this._handleWorkspaceContainsEagerExtension(P,K))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(P,K){if(this.isActivated(K.identifier))return;const he=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ye={logService:this._logService,folders:P.map(ge=>ge.uri),forceUsingSearch:he,exists:ge=>this._hostUtils.exists(ge.fsPath),checkExists:(ge,Ce,ae)=>this._mainThreadWorkspaceProxy.$checkExists(ge,Ce,ae)},be=await(0,s.checkActivateWorkspaceContainsExtension)(ye,K);if(be)return this._activateById(K.identifier,{startup:!0,extensionId:K.identifier,activationEvent:be.activationEvent}).then(void 0,ge=>this._logService.error(ge))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(P){throw console.error(P),P}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:P,extensionTestsLocationURI:K}=this._initData.environment;if(!P||!K)throw new Error(i.localize(0,null));const he=await this._loadCommonJSModule(null,K,new p.ExtensionActivationTimesBuilder(!1));if(!he||typeof he.run!="function")throw new Error(i.localize(1,null,K.toString()));return new Promise((ye,be)=>{const ge=(de,Z)=>{de?be(de):ye(typeof Z=="number"&&Z>0?1:0)},Ce=(0,M.originalFSPath)(K),ae=he.run(Ce,ge);ae&&ae.then&&ae.then(()=>{ye(0)}).catch(de=>{be(de instanceof Error&&de.stack?de.stack:String(de))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,O.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(P,K){return this._resolvers[P]=K,(0,A.toDisposable)(()=>{delete this._resolvers[P]})}async _activateAndGetResolver(P){const K=P.indexOf("+");if(K===-1)throw new Error("Not an authority that can be resolved!");const he=P.substr(0,K);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this._resolvers[he]}}async $resolveAuthority(P,K){const he=$.StopWatch.create(!1),ye=()=>`[resolveAuthority(${(0,u.getRemoteAuthorityPrefix)(P)},${K})][${he.elapsed()}ms] `,be=Z=>this._logService.info(`${ye()}${Z}`),ge=(Z,ne=void 0)=>this._logService.error(`${ye()}${Z}`,ne);be("activating resolver...");const{authorityPrefix:Ce,resolver:ae}=await this._activateAndGetResolver(P);if(!ae)return ge("no resolver"),{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ce}.`,detail:void 0}};const de=new O.IntervalTimer;try{be("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(ae)),de.cancelAndSet(()=>be("waiting..."),1e3),be("invoking resolve()..."),y.mark(`code/extHost/willResolveAuthority/${Ce}`);const Z=await ae.resolve(P,{resolveAttempt:K});y.mark(`code/extHost/didResolveAuthorityOK/${Ce}`),de.dispose();const ne={environmentTunnels:Z.environmentTunnels,features:Z.tunnelFeatures},k={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted,authenticationSession:Z.authenticationSessionForInitializingExtensions?{id:Z.authenticationSessionForInitializingExtensions.id,providerId:Z.authenticationSessionForInitializingExtensions.providerId}:void 0};be(`returned ${n.ManagedResolvedAuthority.isManagedResolvedAuthority(Z)?"managed authority":`${Z.host}:${Z.port}`}`);let z;if(n.ManagedResolvedAuthority.isManagedResolvedAuthority(Z)){const H=K;this._extHostManagedSockets.setFactory(H,Z.makeConnection),z={authority:P,connectTo:new u.ManagedRemoteConnection(H),connectionToken:Z.connectionToken}}else z={authority:P,connectTo:new u.WebSocketRemoteConnection(Z.host,Z.port),connectionToken:Z.connectionToken};return{type:"ok",value:{authority:z,options:k,tunnelInformation:ne}}}catch(Z){if(y.mark(`code/extHost/didResolveAuthorityError/${Ce}`),de.dispose(),ge("returned an error",Z),Z instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(P,K){this._logService.info(`$getCanonicalURI invoked for authority (${(0,u.getRemoteAuthorityPrefix)(P)})`);const{resolver:he}=await this._activateAndGetResolver(P);if(!he)return null;const ye=m.URI.revive(K);if(typeof he.getCanonicalURI>"u")return ye;const be=await(0,O.asPromise)(()=>he.getCanonicalURI(ye));return be||ye}$startExtensionHost(P){P.toAdd.forEach(ye=>ye.extensionLocation=m.URI.revive(ye.extensionLocation));const{globalRegistry:K,myExtensions:he}=oe(this._activationEventsReader,this._globalRegistry,this._myRegistry,P);return this._globalRegistry.set(K.getAllExtensionDescriptions()),this._myRegistry.set(he),this._startExtensionHost()}$activateByEvent(P,K){return K===1?this._activateByEvent(P,!1):this._readyToRunExtensions.wait().then(he=>this._activateByEvent(P,!1))}async $activate(P,K){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(P)?(await this._activateById(P,K),!0):!1}async $deltaExtensions(P){P.toAdd.forEach(ge=>ge.extensionLocation=m.URI.revive(ge.extensionLocation));const{globalRegistry:K,myExtensions:he}=oe(this._activationEventsReader,this._globalRegistry,this._myRegistry,P),ye=await this._createExtensionPathIndex(he);return(await this.getExtensionPathIndex()).setSearchTree(ye),this._globalRegistry.set(K.getAllExtensionDescriptions()),this._myRegistry.set(he),Promise.resolve(void 0)}async $test_latency(P){return P}async $test_up(P){return P.byteLength}async $test_down(P){const K=I.VSBuffer.alloc(P),he=Math.random()%256;for(let ye=0;ye<P;ye++)K.writeUInt8(he,ye);return K}async $updateRemoteConnectionData(P){this._remoteConnectionData=P,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Ie=je([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,D.IExtHostRpcService),We(3,d.IExtHostWorkspace),We(4,c.IExtHostConfiguration),We(5,R.ILogService),We(6,a.IExtHostInitDataService),We(7,E.IExtensionStoragePaths),We(8,T.IExtHostTunnelService),We(9,w.IExtHostTerminalService),We(10,q.IExtHostLocalizationService),We(11,V.IExtHostManagedSockets)],Ie);function oe(Ee,P,K,he){Ee.addActivationEvents(he.addActivationEvents);const ye=new l.ExtensionDescriptionRegistry(Ee,P.getAllExtensionDescriptions());ye.deltaExtensions(he.toAdd,he.toRemove);const be=new S.ExtensionIdentifierSet(K.getAllExtensionDescriptions().map(Ce=>Ce.identifier));for(const Ce of he.myToRemove)be.delete(Ce);for(const Ce of he.myToAdd)be.add(Ce);const ge=le(ye,be);return{globalRegistry:ye,myExtensions:ge}}function ue(Ee,P){return{id:Ee.identifier.value,name:Ee.name,extensionVersion:Ee.version,publisherDisplayName:Ee.publisher,activationEvents:Ee.activationEvents?Ee.activationEvents.join(","):null,isBuiltin:Ee.isBuiltin,reason:P.activationEvent,reasonId:P.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class X{constructor(P,K,he,ye,be){x.set(this,void 0),W.set(this,void 0),ee.set(this,void 0),Qe(this,x,P,"f"),Qe(this,W,K,"f"),Qe(this,ee,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=C.normalize((0,M.originalFSPath)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=ye,this.isFromDifferentExtensionHost=be}get isActive(){return Oe(this,x,"f").isActivated(Oe(this,ee,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,x,"f").getExtensionExports(Oe(this,ee,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,x,"f").activateByIdWithErrors(Oe(this,ee,"f"),{startup:!1,extensionId:Oe(this,W,"f"),activationEvent:"api"}),this.exports}}e.Extension=X,x=new WeakMap,W=new WeakMap,ee=new WeakMap;function le(Ee,P){return Ee.getAllExtensionDescriptions().filter(K=>P.has(K.identifier))}class De{constructor(P){this._searchTree=P}setSearchTree(P){this._searchTree=P}findSubstr(P){return this._searchTree.findSubstr(P)}forEach(P){return this._searchTree.forEach(P)}}e.ExtensionPaths=De;class Te{constructor(P){this._map=new S.ExtensionIdentifierMap,this.addActivationEvents(P)}readActivationEvents(P){return this._map.get(P.identifier)}addActivationEvents(P){for(const K of Object.keys(P))this._map.set(K,P[K])}}}),define(Ae[263],Re([1,0,85,2,4,34,20,23,17,27,3,35,51,14,13]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=e.RequireInterceptor=class{constructor(v,n,u,r,a,E,D){this._apiFactory=v,this._extensionRegistry=n,this._instaService=u,this._extHostConfiguration=r,this._extHostExtensionService=a,this._initData=E,this._logService=D,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),i.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,n,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(h,n)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,n,this._initData.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const n of v.nodeModuleName)this._factories.set(n,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(n=>v.alternativeModuleName(n))}};e.RequireInterceptor=d=je([We(2,R.IInstantiationService),We(3,M.IExtHostConfiguration),We(4,b.IExtHostExtensionService),We(5,m.IExtHostInitDataService),We(6,p.ILogService)],d);let t=class fn{constructor(v){if(v.environment.appRoot&&fn.aliased.size){const n=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(v.environment.appRoot.fsPath)),u="[a-z0-9_.-]",r=`@${u}+\\/${u}+|${u}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(v));if(!n)return;const[,u,r,a]=n,E=fn.aliased.get(r);if(E!==void 0)return console.warn(`${r} as been renamed to ${E}, please update your imports`),u+E+a}forceForwardSlashes(v){return v.replace(/\\/g,"/")}};t.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=je([We(0,m.IExtHostInitDataService)],t);class l{constructor(v,n,u,r,a){this._apiFactory=v,this._extensionPaths=n,this._extensionRegistry=u,this._configProvider=r,this._logService=a,this.nodeModuleName="vscode",this._extApiImpl=new A.ExtensionIdentifierMap}load(v,n){const u=this._extensionPaths.findSubstr(n);if(u){let r=this._extApiImpl.get(u.identifier);return r||(r=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(u.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((a,E)=>r+=`	${E} -> ${a.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(O.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let h=class{constructor(v,n,u){this._extensionPaths=v,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(y.MainContext.MainThreadTelemetry);const{environment:r}=u,a=n.getProxy(y.MainContext.MainThreadKeytar);if(r.appRoot){let E=r.appRoot.fsPath;c.platform==="win32"&&(E=E.replace(/\\/g,"/")),E[E.length-1]==="/"&&(E=E.substr(0,E.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${E}/node_modules.asar/keytar`),this.alternativeNames.add(`${E}/node_modules/keytar`)}this._impl={getPassword:(E,D)=>a.$getPassword(E,D),setPassword:(E,D,f)=>a.$setPassword(E,D,f),deletePassword:(E,D)=>a.$deletePassword(E,D),findPassword:E=>a.$findPassword(E),findCredentials(E){return a.$findCredentials(E)}}}load(v,n){const u=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(v){const n=v.length;if(n<=7||!this.alternativeNames)return;const u=n-7;if((v.charAt(u)==="/"||v.charAt(u)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}};h=je([We(1,_.IExtHostRpcService),We(2,m.IExtHostInitDataService)],h);let S=class{constructor(v,n,u){this._extensionPaths=v,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(y.MainContext.MainThreadTelemetry);const r=u.getProxy(y.MainContext.MainThreadWindow);this._impl=(a,E)=>{const D=C.URI.parse(a);return E?this.callOriginal(a,E):D.scheme==="http"||D.scheme==="https"?r.$openUri(D,a,{allowTunneling:!0}):D.scheme==="mailto"||D.scheme===this._appUriScheme?r.$openUri(D,a,{}):this.callOriginal(a,E)}}load(v,n,u){const r=this._extensionPaths.findSubstr(n);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=u(v),this._impl}callOriginal(v,n){return this.sendNoForwardTelemetry(),this._original(v,n)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=je([We(2,_.IExtHostRpcService)],S)}),define(Ae[112],Re([1,0,66,6,19,51,3,59,60,35,7,33,198,34]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,O.createDecorator)("IExtHostVariableResolverProvider");class g extends c.AbstractVariableResolverService{constructor(l,h,S,I,v,n,u){function r(){if(S){const a=S.activeEditor();if(a)return a.document.uri;const E=I.tabGroups.all.find(D=>D.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof R.TextDiffTabInput||E.input instanceof R.NotebookDiffEditorTabInput)return E.input.modified;if(E.input instanceof R.TextTabInput||E.input instanceof R.NotebookEditorTabInput||E.input instanceof R.CustomEditorTabInput)return E.input.uri}}}super({getFolderUri:a=>{const E=n.folders.filter(D=>D.name===a);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(a,E)=>v.getConfiguration(void 0,a).get(E),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return y.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const a=r();if(a){const E=h.getWorkspaceFolder(a);if(E)return y.normalize(E.uri.fsPath)}}},getSelectedText:()=>{if(S){const a=S.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(S){const a=S.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>l.getExtension(a)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let d=e.ExtHostVariableResolverProviderService=class extends C.Disposable{constructor(l,h,S,I,v){super(),this.extensionService=l,this.workspaceService=h,this.editorService=S,this.configurationService=I,this.editorTabs=v,this._resolver=new i.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async a=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new g(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=d=je([We(0,m.IExtHostExtensionService),We(1,b.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,p.IExtHostConfiguration),We(4,_.IExtHostEditorTabs)],d)}),define(Ae[113],Re([1,0,16,5,9,2,3,4,60,35,17,7,33,192,194,34,112]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,O.createDecorator)("IExtHostDebugService");let l=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,a,E,D,f,T){this._workspaceService=a,this._extensionService=E,this._configurationService=D,this._editorTabs=f,this._variableResolver=T,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=r.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._onDidChangeStackFrameFocus=new C.Emitter,this._activeDebugConsole=new S(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(w=>{w.onDidChange(o=>{this.registerAllDebugTypes(w)}),this.registerAllDebugTypes(w)})}asDebugSourceUri(r,a){const E=r;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let D=`debug:${encodeURIComponent(E.path||"")}`,f="?";return a&&(D+=`${f}session=${encodeURIComponent(a.id)}`,f="&"),D+=`${f}ref=${E.sourceReference}`,M.URI.parse(D)}else{if(E.path)return M.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const a=[];for(const E of r.getAllExtensionDescriptions())if(E.contributes){const D=E.contributes.debuggers;if(D&&D.length>0)for(const f of D)(0,g.isDebuggerMainContribution)(f)&&a.push(f.type)}this._debugServiceProxy.$registerDebugTypes(a)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(a=>r.push(a)),r}addBreakpoints(r){this.startBreakpoints();const a=r.filter(f=>{const T=f.id;return this._breakpoints.has(T)?!1:(this._breakpoints.set(T,f),!0)});this.fireBreakpointChanges(a,[],[]);const E=[],D=new Map;for(const f of a)if(f instanceof b.SourceBreakpoint){let T=D.get(f.location.uri.toString());T||(T={type:"sourceMulti",uri:f.location.uri,lines:[]},D.set(f.location.uri.toString(),T),E.push(T)),T.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof b.FunctionBreakpoint&&E.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(r){this.startBreakpoints();const a=r.filter(T=>this._breakpoints.delete(T.id));this.fireBreakpointChanges([],a,[]);const E=a.filter(T=>T instanceof b.SourceBreakpoint).map(T=>T.id),D=a.filter(T=>T instanceof b.FunctionBreakpoint).map(T=>T.id),f=a.filter(T=>T instanceof b.DataBreakpoint).map(T=>T.id);return this._debugServiceProxy.$unregisterBreakpoints(E,D,f)}startDebugging(r,a,E){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,a,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,E){if(!a)return new b.Disposable(()=>{});const D=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:D,provider:a}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,E,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,D),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(f=>f.provider!==a),this._debugServiceProxy.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(r,a,E){if(!E)return new b.Disposable(()=>{});if(!this.definesDebugType(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.getAdapterDescriptorFactoryByType(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:a,handle:D,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(a,D),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(f=>f.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new b.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:E,factory:a}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(D=>D.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let E;const D=await this.getFolder(r);return D&&(E={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(E,a)}createDebugAdapter(r,a){if(r.type==="implementation")return new v(r.implementation)}createSignService(){}async $startDASession(r,a){const E=this,D=await this.getSession(a);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(D.type),D).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const T=this.convertToDto(f),w=this.createDebugAdapter(T,D);if(!w)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const o=w;return this._debugAdapters.set(r,o),this.getDebugAdapterTrackers(D).then(s=>(s&&this._debugAdaptersTrackers.set(r,s),o.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const B=F,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const q=await this._signService.sign(B.arguments.value);G.body={signature:q},o.sendResponse(G)}else throw new Error("no signer")}catch(q){G.success=!1,G.message=q.message,o.sendResponse(G)}}else s&&s.onDidSendMessage&&s.onDidSendMessage(F),F=(0,g.convertToVSCPaths)(F,!0),E._debugServiceProxy.$acceptDAMessage(r,F)}),o.onError(F=>{s&&s.onError&&s.onError(F),this._debugServiceProxy.$acceptDAError(r,F.name,F.message,F.stack)}),o.onExit(F=>{s&&s.onExit&&s.onExit((0,y.withNullAsUndefined)(F),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,y.withNullAsUndefined)(F),void 0)}),s&&s.onWillStartSession&&s.onWillStartSession(),o.startSession()))})}$sendDAMessage(r,a){a=(0,g.convertToDAPaths)(a,!1);const E=this._debugAdaptersTrackers.get(r);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(a),this._debugAdapters.get(r)?.sendMessage(a)}$stopDASession(r){const a=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const E=this._debugAdapters.get(r);return this._debugAdapters.delete(r),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],E=[],D=[];if(r.added)for(const f of r.added){const T=f.id;if(T&&!this._breakpoints.has(T)){let w;if(f.type==="function")w=new b.FunctionBreakpoint(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")w=new b.DataBreakpoint(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const o=M.URI.revive(f.uri);w=new b.SourceBreakpoint(new b.Location(o,new b.Position(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,b.setBreakpointId)(w,T),this._breakpoints.set(T,w),a.push(w)}}if(r.removed)for(const f of r.removed){const T=this._breakpoints.get(f);T&&(this._breakpoints.delete(f),E.push(T))}if(r.changed){for(const f of r.changed)if(f.id){const T=this._breakpoints.get(f.id);if(T){if(T instanceof b.FunctionBreakpoint&&f.type==="function"){const w=T;w.enabled=f.enabled,w.condition=f.condition,w.hitCondition=f.hitCondition,w.logMessage=f.logMessage,w.functionName=f.functionName}else if(T instanceof b.SourceBreakpoint&&f.type==="source"){const w=T;w.enabled=f.enabled,w.condition=f.condition,w.hitCondition=f.hitCondition,w.logMessage=f.logMessage,w.location=new b.Location(M.URI.revive(f.uri),new b.Position(f.line,f.character))}D.push(T)}}}this.fireBreakpointChanges(a,E,D)}async $acceptStackFrameFocus(r){let a;const E=r.sessionId?await this.getSession(r.sessionId):void 0;if(!E)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?a=new b.ThreadFocus(E,r.threadId):a=new b.StackFrameFocus(E,r.threadId,r.frameId),this._stackFrameFocus=a,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(r,a,E){return(0,i.asPromise)(async()=>{const D=this.getConfigProviderByHandle(r);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.getFolder(a);return D.provideDebugConfigurations(f,E)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(r,a,E,D){return(0,i.asPromise)(async()=>{const f=this.getConfigProviderByHandle(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.getFolder(a);return f.resolveDebugConfiguration(T,E,D)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,E,D){return(0,i.asPromise)(async()=>{const f=this.getConfigProviderByHandle(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.getFolder(a);return f.resolveDebugConfigurationWithSubstitutedVariables(T,E,D)})}async $provideDebugAdapter(r,a){const E=this.getAdapterDescriptorFactoryByHandle(r);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.getSession(a);return this.getAdapterDescriptor(E,D).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.convertToDto(f)})}async $acceptDebugSessionStarted(r){const a=await this.getSession(r);this._onDidStartDebugSession.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.getSession(r);a&&(this._onDidTerminateDebugSession.fire(a),this._debugSessions.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,a){(await this.getSession(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const D={session:await this.getSession(r),event:a.event,body:a.body};this._onDidReceiveDebugSessionCustomEvent.fire(D)}convertToDto(r){if(r instanceof b.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof b.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const a=this._adapterFactories.filter(E=>E.type===r);if(a.length>0)return a[0].factory}getAdapterDescriptorFactoryByHandle(r){const a=this._adapterFactories.filter(E=>E.handle===r);if(a.length>0)return a[0].factory}getConfigProviderByHandle(r){const a=this._configProviders.filter(E=>E.handle===r);if(a.length>0)return a[0].provider}definesDebugType(r,a){if(r.contributes){const E=r.contributes.debuggers;if(E&&E.length>0){for(const D of E)if(D.label&&D.type&&D.type===a)return!0}}return!1}getDebugAdapterTrackers(r){const E=r.configuration.type,D=this._trackerFactories.filter(f=>f.type===E||f.type==="*").map(f=>(0,i.asPromise)(()=>f.factory.createDebugAdapterTracker(r)).then(T=>T,T=>null));return Promise.race([Promise.all(D).then(f=>{const T=f.filter(w=>!!w);if(T.length>0)return new I(T)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async getAdapterDescriptor(r,a){const E=a.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new b.DebugAdapterServer(E));if(r){const f=await this._extensionService.getExtensionRegistry();return(0,i.asPromise)(()=>r.createDebugAdapterDescriptor(a,this.daExecutableFromPackage(a,f))).then(T=>{if(T)return T})}const D=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(a,D))}daExecutableFromPackage(r,a){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,a,E){(r.length>0||a.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:a,changed:E}))}async getSession(r){if(r)if(typeof r=="string"){const a=this._debugSessions.get(r);if(a)return a}else{let a=this._debugSessions.get(r.id);if(!a){const E=await this.getFolder(r.folderUri),D=r.parent?this._debugSessions.get(r.parent):void 0;a=new h(this._debugServiceProxy,r.id,r.type,r.name,E,r.configuration,D),this._debugSessions.set(a.id,a),this._debugServiceProxy.$sessionCached(a.id)}return a}throw new Error("cannot find session")}getFolder(r){if(r){const a=M.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=l=je([We(0,R.IExtHostRpcService),We(1,c.IExtHostWorkspace),We(2,m.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,_.IExtHostEditorTabs),We(5,t.IExtHostVariableResolverProvider)],l);class h{constructor(r,a,E,D,f,T,w){this._debugServiceProxy=r,this._id=a,this._type=E,this._name=D,this._workspaceFolder=f,this._configuration=T,this._parentSession=w}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,a){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,a)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=h;class S{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=S;class I{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.trackers.forEach(E=>E.onExit?E.onExit(r,a):void 0)}}class v extends p.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=e.WorkerExtHostDebugService=class extends l{constructor(r,a,E,D,f,T){super(r,a,E,D,f,T)}};e.WorkerExtHostDebugService=n=je([We(0,R.IExtHostRpcService),We(1,c.IExtHostWorkspace),We(2,m.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,_.IExtHostEditorTabs),We(5,t.IExtHostVariableResolverProvider)],n)}),define(Ae[264],Re([1,0,10,85,2,4,255,14,70,71,27,170,17,55,35,57]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(S){const I=S.get(A.ILogService),n=S.get(c.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(u=>{I.error(u);const r=i.transformErrorForSerialization(u);n.$onUnexpectedError(r)})}static async installFullHandler(S){const I=S.get(A.ILogService),v=S.get(c.IExtHostRpcService),n=S.get(g.IExtHostExtensionService),u=S.get(d.IExtHostTelemetry),r=v.getProxy(M.MainContext.MainThreadExtensionService),a=v.getProxy(M.MainContext.MainThreadErrors),E=await n.getExtensionPathIndex(),D=new WeakMap;function f(w,o){let s="",F,B;for(const G of o)s+=`
	at ${G.toString()}`,B=G.getFileName(),!F&&B&&(F=E.findSubstr(y.URI.file(B)));return D.set(w,F?.identifier),`${w.name||"Error"}: ${w.message||""}${s}`}let T=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return T},set(w){T=function(o,s){return f(o,s),w.call(Error,o,s)}}}),i.setUnexpectedErrorHandler(w=>{I.error(w);const o=i.transformErrorForSerialization(w),s=D.get(w);if(!s){a.$onUnexpectedError(o);return}r.$onExtensionRuntimeError(s,o);const F=u.onExtensionError(s,w);I.trace("forwarded error to extension?",F,s)})}}Error.stackTraceLimit=100;class l{constructor(S,I,v,n,u){this._hostUtils=v,this._rpcProtocol=new O.RPCProtocol(S,null,n),I=l._transform(I,this._rpcProtocol);const r=new m.ServiceCollection(...(0,_.getSingletonServiceDescriptors)());r.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...I,messagePorts:u}),r.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),r.set(p.IURITransformerService,new p.URITransformerService(n)),r.set(g.IHostUtils,v);const a=new b.InstantiationService(r,!0);a.invokeFunction(t.installEarlyHandler),this._logService=a.invokeFunction(E=>E.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",I),this._extensionService=a.invokeFunction(E=>E.get(g.IExtHostExtensionService)),this._extensionService.initialize(),a.invokeFunction(t.installFullHandler)}async asBrowserUri(S){const I=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return y.URI.revive(await I.$asBrowserUri(S))}terminate(S){this._extensionService.terminate(S)}static _transform(S,I){S.allExtensions.forEach(n=>{n.extensionLocation=y.URI.revive(I.transformIncomingURIs(n.extensionLocation))}),S.environment.appRoot=y.URI.revive(I.transformIncomingURIs(S.environment.appRoot));const v=S.environment.extensionDevelopmentLocationURI;return v&&(S.environment.extensionDevelopmentLocationURI=v.map(n=>y.URI.revive(I.transformIncomingURIs(n)))),S.environment.extensionTestsLocationURI=y.URI.revive(I.transformIncomingURIs(S.environment.extensionTestsLocationURI)),S.environment.globalStorageHome=y.URI.revive(I.transformIncomingURIs(S.environment.globalStorageHome)),S.environment.workspaceStorageHome=y.URI.revive(I.transformIncomingURIs(S.environment.workspaceStorageHome)),S.environment.extensionTelemetryLogResource=y.URI.revive(I.transformIncomingURIs(S.environment.extensionTelemetryLogResource)),S.nlsBaseUrl=y.URI.revive(I.transformIncomingURIs(S.nlsBaseUrl)),S.logsLocation=y.URI.revive(I.transformIncomingURIs(S.logsLocation)),S.workspace=I.transformIncomingURIs(S.workspace),S}}e.ExtensionHostMain=l}),define(Ae[265],Re([1,0,18,16,22,40,15,19,25,2,47]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(h,S,I,v){this.query=h,this.provider=S,this.fileUtils=I,this.processType=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,S){const I=this.query.folderQueries||[],v=new y.CancellationTokenSource;return S.onCancellationRequested(()=>v.cancel()),new Promise((n,u)=>{this.collector=new p(h);let r=!1;const a=(E,D)=>{if(!r&&!this.isLimitHit){const f=this.resultSize(E);d(E)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,r=!0,v.cancel(),E=this.trimResultToSize(E,this.query.maxResults-this.resultCount));const T=this.resultSize(E);this.resultCount+=T,(T>0||!d(E))&&this.collector.add(E,D)}};Promise.all(I.map((E,D)=>this.searchInFolder(E,f=>a(f,D),v.token))).then(E=>{v.dispose(),this.collector.flush();const D=E.some(f=>!!f&&!!f.limitHit);n({limitHit:this.isLimitHit||D,messages:(0,i.flatten)(E.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},E=>{v.dispose();const D=(0,M.toErrorMessage)(E);u(new Error(D))})})}resultSize(h){return d(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,S){const I=Array.isArray(h.ranges)?h.ranges:[h.ranges],v=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:I.slice(0,S),preview:{matches:v.slice(0,S),text:h.preview.text},uri:h.uri}}async searchInFolder(h,S,I){const v=new R.QueryGlobTester(this.query,h),n=[],u={report:E=>{if(!this.validateProviderResult(E))return;const D=h.folder.scheme===O.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(_.dirname(E.uri))):void 0,f=_.relativePath(h.folder,E.uri);if(f){const T=v.includedInQuery(f,A.basename(f),D);(0,C.isThenable)(T)?n.push(T.then(w=>{w&&S(E)})):T&&S(E)}}},r=this.getSearchOptionsForFolder(h),a=await this.provider.provideTextSearchResults(c(this.query.contentPattern),r,u,I);return n.length&&await Promise.all(n),a}validateProviderResult(h){if(d(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const S=(0,R.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),I=(0,R.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),v={folder:m.URI.from(h.folder),excludes:I,includes:S,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return v.usePCRE2=this.query.usePCRE2,v}}e.TextSearchManager=b;function c(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class p{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,S=>this.sendItems(S))}add(h,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!_.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(g(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=p;function g(l){return d(l)?{preview:{matches:(0,i.mapArrayOrNot)(l.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:l.preview.text},ranges:(0,i.mapArrayOrNot)(l.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function d(l){return!!l.preview}e.extensionResultIsMatch=d;class t{constructor(h,S){this.maxBatchSize=h,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,S){h&&this.addItemToBatch(h,S)}addItems(h,S){h&&this.addItemsToBatch(h,S)}addItemToBatch(h,S){this.batch.push(h),this.batchSize+=S,this.onUpdate()}addItemsToBatch(h,S){this.batch=this.batch.concat(h),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t,t.TIMEOUT=4e3,t.START_BATCH_AFTER_COUNT=50}),define(Ae[114],Re([1,0,6,4,3,260,17,55,14,2,265]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let b=e.ExtHostSearch=class{constructor(d,t,l){this.extHostRpc=d,this._uriTransformer=t,this._logService=l,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const l=this._handlePool++;return this._textSearchProvider.set(l,t),this._proxy.$registerTextSearchProvider(l,this._transformScheme(d)),(0,i.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}registerFileSearchProvider(d,t){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const l=this._handlePool++;return this._fileSearchProvider.set(l,t),this._proxy.$registerFileSearchProvider(l,this._transformScheme(d)),(0,i.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(d,t,l,h){const S=c(l),I=this._fileSearchProvider.get(d);if(I)return this._fileSearchManager.fileSearch(S,I,v=>{this._proxy.$handleFileMatch(d,t,v.map(n=>n.resource))},h);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,l,h){const S=this._textSearchProvider.get(d);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const I=c(l);return this.createTextSearchManager(I,S).search(n=>this._proxy.$handleTextMatch(d,t,n),h)}$enableExtensionHostSearch(){}createTextSearchManager(d,t){return new R.TextSearchManager(d,t,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};e.ExtHostSearch=b=je([We(0,O.IExtHostRpcService),We(1,A.IURITransformerService),We(2,_.ILogService)],b);function c(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(p),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>m.URI.revive(d))}}e.reviveQuery=c;function p(g){return{...g,folder:m.URI.revive(g.folder)}}}),define(Ae[266],Re([1,0,22,10,5,29,2,135,276,122,133,43,4,77,219,218,32,220,34,222,223,224,204,225,59,35,226,227,232,233,235,109,208,241,242,245,83,62,247,209,8,7,52,250,63,108,33,23,196,231,50,107,111,113,114,14,55,17,27,236,202,73,79,215,248,84,61,253,251,252,216,38,246,249,82,60,57,237,110,238,15,95,207,188,228,6,20,193,80,184,239,240,217,229,206,243,230,81,244]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v,n,u,r,a,E,D,f,T,w,o,s,F,B,G,q,$,N,V,x,W,ee,Ie,oe,ue,X,le,De,Te,Ee,P,K,he,ye,be,ge,Ce,ae,de,Z,ne,k,z,H,j,ce,pe,ie,Se,_e,Be,He,Ze,Xe,Ke,it,st,tt,Me,dt,Y,J,fe,Ue,Ve,$e,Je,mt,_t,Ct,qt,Bt,St,$t,Ft,Vt,Rt,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function zt(at){const ht=at.get(ae.IExtHostInitDataService),Mt=at.get(Be.IExtHostFileSystemInfo),Nt=at.get(ce.IExtHostConsumerFileSystem),wt=at.get(a.IExtHostExtensionService),ut=at.get(X.IExtHostWorkspace),It=at.get(it.IExtHostTelemetry),Ut=at.get(h.IExtHostConfiguration),Pe=at.get(ge.IURITransformerService),we=at.get(Ce.IExtHostRpcService),ve=at.get(q.IExtHostStorage),Q=at.get(j.IExtensionStoragePaths),Fe=at.get(be.ILoggerService),xe=at.get(be.ILogService),Ge=at.get(ne.IExtHostTunnelService),ze=at.get(k.IExtHostApiDeprecationService),et=at.get(ue.IExtHostWindow),bt=at.get(Xe.IExtHostSecretState),Pt=at.get(Ke.IExtHostEditorTabs),kt=at.get(Rt.IExtHostManagedSockets);we.set(c.ExtHostContext.ExtHostFileSystemInfo,Mt),we.set(c.ExtHostContext.ExtHostLogLevelServiceShape,Fe),we.set(c.ExtHostContext.ExtHostWorkspace,ut),we.set(c.ExtHostContext.ExtHostConfiguration,Ut),we.set(c.ExtHostContext.ExtHostExtensionService,wt),we.set(c.ExtHostContext.ExtHostStorage,ve),we.set(c.ExtHostContext.ExtHostTunnelService,Ge),we.set(c.ExtHostContext.ExtHostWindow,et),we.set(c.ExtHostContext.ExtHostSecretState,bt),we.set(c.ExtHostContext.ExtHostTelemetry,It),we.set(c.ExtHostContext.ExtHostEditorTabs,Pt),we.set(c.ExtHostContext.ExtHostManagedSockets,kt);const vt=we.set(c.ExtHostContext.ExtHostDecorations,at.get(P.IExtHostDecorations)),ot=we.set(c.ExtHostContext.ExtHostDocumentsAndEditors,at.get(r.IExtHostDocumentsAndEditors)),gt=we.set(c.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),pt=we.set(c.ExtHostContext.ExtHostTerminalService,at.get($.IExtHostTerminalService)),Et=we.set(c.ExtHostContext.ExtHostDebugService,at.get(he.IExtHostDebugService)),oi=we.set(c.ExtHostContext.ExtHostSearch,at.get(ye.IExtHostSearch)),Wt=we.set(c.ExtHostContext.ExtHostTask,at.get(K.IExtHostTask)),Oi=we.set(c.ExtHostContext.ExtHostOutputService,at.get(o.IExtHostOutputService)),Kt=we.set(c.ExtHostContext.ExtHostLocalization,at.get(mt.IExtHostLocalizationService)),wi=we.set(c.ExtHostContext.ExtHostUrls,new Ie.ExtHostUrls(we)),Tt=we.set(c.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(we,ot)),Fi=we.set(c.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(we,ot,xe)),ai=we.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(xe,Tt,we.getProxy(c.MainContext.MainThreadBulkEdits))),yt=we.set(c.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(we,gt,ot,Tt)),di=we.set(c.ExtHostContext.ExtHostNotebookDocuments,new fe.ExtHostNotebookDocuments(yt)),bi=we.set(c.ExtHostContext.ExtHostNotebookEditors,new J.ExtHostNotebookEditors(xe,yt)),hi=we.set(c.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(we,ht,yt,gt,xe)),cn=we.set(c.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(we,yt)),Li=we.set(c.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new $t.ExtHostNotebookDocumentSaveParticipant(xe,yt,we.getProxy(c.MainContext.MainThreadBulkEdits))),Ot=we.set(c.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(we,ot)),_i=we.set(c.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(we.getProxy(c.MainContext.MainThreadTreeViews),gt,xe)),Qt=we.set(c.ExtHostContext.ExtHostEditorInsets,new De.ExtHostEditorInsets(we.getProxy(c.MainContext.MainThreadEditorInsets),Ot,ht.remote)),ci=we.set(c.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(we,xe,Mt,ot)),li=we.set(c.ExtHostContext.ExtHostLanguages,new T.ExtHostLanguages(we,Tt,gt.converter,Pe)),ct=we.set(c.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(we,Pe,Tt,gt,ci,xe,ze,It)),Mi=we.set(c.ExtHostContext.ExtHostFileSystem,new E.ExtHostFileSystem(we,ct)),ei=we.set(c.ExtHostContext.ExtHostFileSystemEventService,new D.ExtHostFileSystemEventService(we,xe,ot)),Gt=we.set(c.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(we,ut,gt)),Si=we.set(c.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(we,gt,Tt,xe)),Ni=we.set(c.ExtHostContext.ExtHostQuickDiff,new qt.ExtHostQuickDiff(we,Pe)),Ui=we.set(c.ExtHostContext.ExtHostShare,new Lt.ExtHostShare(we,Pe)),xi=we.set(c.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(we,gt,Tt)),yi=we.set(c.ExtHostContext.ExtHostProgress,new s.ExtHostProgress(we.getProxy(c.MainContext.MainThreadProgress))),Bi=we.set(c.ExtHostContext.ExtHosLabelService,new Te.ExtHostLabelService(we)),Di=we.set(c.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(we)),ni=we.set(c.ExtHostContext.ExtHostAuthentication,new z.ExtHostAuthentication(we)),$i=we.set(c.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(we,gt)),fi=we.set(c.ExtHostContext.ExtHostWebviews,new oe.ExtHostWebviews(we,ht.remote,ut,xe,ze)),mi=we.set(c.ExtHostContext.ExtHostWebviewPanels,new Se.ExtHostWebviewPanels(we,fi,ut)),zi=we.set(c.ExtHostContext.ExtHostCustomEditors,new ie.ExtHostCustomEditors(we,Tt,Q,fi,mi)),Wi=we.set(c.ExtHostContext.ExtHostWebviewViews,new pe.ExtHostWebviewViews(we,fi)),ri=we.set(c.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(we,gt,ot)),Hi=we.set(c.ExtHostContext.ExtHostUriOpeners,new Ze.ExtHostUriOpeners(we)),Vi=we.set(c.ExtHostContext.ExtHostProfileContentHandlers,new Ct.ExtHostProfileContentHandlers(we));we.set(c.ExtHostContext.ExtHostInteractive,new Ue.ExtHostInteractive(we,yt,ot,gt,xe));const ji=we.set(c.ExtHostContext.ExtHostInteractiveEditor,new St.ExtHostInteractiveEditor(we,gt,Tt,xe)),si=we.set(c.ExtHostContext.ExtHostChat,new Bt.ExtHostChat(we,xe)),qi=we.set(c.ExtHostContext.ExtHostSemanticSimilarity,new Ft.ExtHostSemanticSimilarity(we)),Ki=we.set(c.ExtHostContext.ExtHostIssueReporter,new Vt.ExtHostIssueReporter(we)),Ci=we.set(c.ExtHostContext.ExtHostStatusBar,new G.ExtHostStatusBar(we,gt.converter)),Gi=Object.values(c.ExtHostContext);we.assertRegistered(Gi);const Xi=new _e.ExtHostBulkEdits(we,ot),ln=new d.ExtHostClipboard(we),Ii=new w.ExtHostMessageService(we,xe),gi=new I.ExtHostDialogs(we);return g.ExtHostApiCommands.register(gt),function(Ne,Yt,Qi){const ft=function(){let re=!Ne.isUnderDevelopment;function me(){re||(xe.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Le(nt){if(Array.isArray(nt))nt.forEach(Le);else if(typeof nt=="string")me();else{const Dt=nt;typeof Dt.scheme>"u"&&me(),typeof Dt.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return nt}}(),ki={getSession(re,me,Le){return ni.getSession(Ne,re,me,Le)},getSessions(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"authGetSessions"),ni.getSessions(Ne,re,me)},async hasSession(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"authSession"),!!await ni.getSession(Ne,re,me,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(re,me,Le,nt){return ni.registerAuthenticationProvider(re,me,Le,nt)}},Yi={registerCommand(re,me,Le){return gt.registerCommand(!0,re,me,Le,void 0,Ne)},registerTextEditorCommand(re,me,Le){return gt.registerCommand(!0,re,(...nt)=>{const Dt=Ot.getActiveTextEditor();if(!Dt){xe.warn("Cannot execute "+re+" because there is no active text editor.");return}return Dt.edit(At=>{me.apply(Le,[Dt,At,...nt])}).then(At=>{At||xe.warn("Edits from command "+re+" were not applied.")},At=>{xe.warn("An error occurred while running command "+re,At)})},void 0,void 0,Ne)},registerDiffInformationCommand:(re,me,Le)=>((0,$e.checkProposedApiEnabled)(Ne,"diffCommand"),gt.registerCommand(!0,re,async(...nt)=>{const Dt=ot.activeEditor(!0);if(!Dt){xe.warn("Cannot execute "+re+" because there is no active text editor.");return}const At=await Ot.getDiffInformation(Dt.id);me.apply(Le,[At,...nt])},void 0,void 0,Ne)),executeCommand(re,...me){return gt.executeCommand(re,...me)},getCommands(re=!1){return gt.getCommands(re)}},Ti={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return(0,$e.checkProposedApiEnabled)(Ne,"envShellEvent"),pt.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(Ne,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(Ne,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,it.isNewAppInstall)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,me){return it.ExtHostTelemetryLogger.validateSender(re),It.instantiateLogger(Ne,re,me)},openExternal(re,me){return et.openUri(re,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===ht.environment.appUriScheme)return wi.createAppUri(re);try{return await et.asExternalUri(re,{allowTunneling:!!ht.remote.authority})}catch(me){if((0,Y.matchesScheme)(re,dt.Schemas.http)||(0,Y.matchesScheme)(re,dt.Schemas.https))return re;throw me}},get remoteName(){return(0,Ee.getRemoteName)(ht.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(Ne,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return xe.getLevel()},get onDidChangeLogLevel(){return xe.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,$e.checkProposedApiEnabled)(Ne,"handleIssueUri"),Ki.registerIssueUriRequestHandler(Ne,re)},get appQuality(){return(0,$e.checkProposedApiEnabled)(Ne,"resolvers"),ht.quality},get appCommit(){return(0,$e.checkProposedApiEnabled)(Ne,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(Ti);const Ji={createTestController(re,me,Le){return ri.createTestController(Ne,re,me,Le)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(Ne,"testObserver"),ri.createTestObserver()},runTests(re){return(0,$e.checkProposedApiEnabled)(Ne,"testObserver"),ri.runTests(re)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(Ne,"testObserver"),ri.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(Ne,"testObserver"),ri.results}},pi=ht.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Zi={getExtension(re,me){(0,$e.isProposedApiEnabled)(Ne,"extensionsAny")||(me=!1);const Le=Yt.mine.getExtensionDescription(re);if(Le)return new a.Extension(wt,Ne.identifier,Le,pi,!1);if(me){const nt=Yt.all.getExtensionDescription(re);if(nt)return new a.Extension(wt,Ne.identifier,nt,pi,!0)}},get all(){const re=[];for(const me of Yt.mine.getAllExtensionDescriptions())re.push(new a.Extension(wt,Ne.identifier,me,pi,!1));return re},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(Ne,"extensionsAny");const re=new le.ExtensionIdentifierSet(Yt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),me=[];for(const Le of Yt.all.getAllExtensionDescriptions()){const nt=!re.has(Le.identifier);me.push(new a.Extension(wt,Ne.identifier,Le,pi,nt))}return me},get onDidChange(){return(0,$e.isProposedApiEnabled)(Ne,"extensionsAny")?y.Event.any(Yt.mine.onDidChange,Yt.all.onDidChange):Yt.mine.onDidChange}},en={createDiagnosticCollection(re){return ci.createDiagnosticCollection(Ne.identifier,re)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:re=>ci.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,me){return li.changeLanguage(re.uri,me)},match(re,me){const Le=Tt.getDocumentData(me.uri)?.notebook;return(0,R.score)(x.LanguageSelector.from(re),me.uri,me.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(re,me,Le){return ct.registerCodeActionProvider(Ne,ft(re),me,Le)},registerDocumentPasteEditProvider(re,me,Le){return(0,$e.checkProposedApiEnabled)(Ne,"documentPaste"),ct.registerDocumentPasteEditProvider(Ne,ft(re),me,Le)},registerCodeLensProvider(re,me){return ct.registerCodeLensProvider(Ne,ft(re),me)},registerDefinitionProvider(re,me){return ct.registerDefinitionProvider(Ne,ft(re),me)},registerDeclarationProvider(re,me){return ct.registerDeclarationProvider(Ne,ft(re),me)},registerImplementationProvider(re,me){return ct.registerImplementationProvider(Ne,ft(re),me)},registerTypeDefinitionProvider(re,me){return ct.registerTypeDefinitionProvider(Ne,ft(re),me)},registerHoverProvider(re,me){return ct.registerHoverProvider(Ne,ft(re),me,Ne.identifier)},registerEvaluatableExpressionProvider(re,me){return ct.registerEvaluatableExpressionProvider(Ne,ft(re),me,Ne.identifier)},registerInlineValuesProvider(re,me){return ct.registerInlineValuesProvider(Ne,ft(re),me,Ne.identifier)},registerDocumentHighlightProvider(re,me){return ct.registerDocumentHighlightProvider(Ne,ft(re),me)},registerLinkedEditingRangeProvider(re,me){return ct.registerLinkedEditingRangeProvider(Ne,ft(re),me)},registerReferenceProvider(re,me){return ct.registerReferenceProvider(Ne,ft(re),me)},registerRenameProvider(re,me){return ct.registerRenameProvider(Ne,ft(re),me)},registerDocumentSymbolProvider(re,me,Le){return ct.registerDocumentSymbolProvider(Ne,ft(re),me,Le)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Ne,re)},registerDocumentFormattingEditProvider(re,me){return ct.registerDocumentFormattingEditProvider(Ne,ft(re),me)},registerDocumentRangeFormattingEditProvider(re,me){return ct.registerDocumentRangeFormattingEditProvider(Ne,ft(re),me)},registerOnTypeFormattingEditProvider(re,me,Le,...nt){return ct.registerOnTypeFormattingEditProvider(Ne,ft(re),me,[Le].concat(nt))},registerDocumentSemanticTokensProvider(re,me,Le){return ct.registerDocumentSemanticTokensProvider(Ne,ft(re),me,Le)},registerDocumentRangeSemanticTokensProvider(re,me,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ne,ft(re),me,Le)},registerSignatureHelpProvider(re,me,Le,...nt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ne,ft(re),me,Le):ct.registerSignatureHelpProvider(Ne,ft(re),me,typeof Le>"u"?[]:[Le,...nt])},registerCompletionItemProvider(re,me,...Le){return ct.registerCompletionItemProvider(Ne,ft(re),me,Le)},registerInlineCompletionItemProvider(re,me){return me.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),me.handleDidPartiallyAcceptCompletionItem&&(0,$e.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ne,ft(re),me)},registerDocumentLinkProvider(re,me){return ct.registerDocumentLinkProvider(Ne,ft(re),me)},registerColorProvider(re,me){return ct.registerColorProvider(Ne,ft(re),me)},registerFoldingRangeProvider(re,me){return ct.registerFoldingRangeProvider(Ne,ft(re),me)},registerSelectionRangeProvider(re,me){return ct.registerSelectionRangeProvider(Ne,re,me)},registerCallHierarchyProvider(re,me){return ct.registerCallHierarchyProvider(Ne,re,me)},registerTypeHierarchyProvider(re,me){return ct.registerTypeHierarchyProvider(Ne,re,me)},setLanguageConfiguration:(re,me)=>ct.setLanguageConfiguration(Ne,re,me),getTokenInformationAtPosition(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"tokenInformation"),li.tokenAtPosition(re,me)},registerInlayHintsProvider(re,me){return ct.registerInlayHintsProvider(Ne,re,me)},createLanguageStatusItem(re,me){return li.createLanguageStatusItem(Ne,re,me)},registerDocumentDropEditProvider(re,me,Le){return ct.registerDocumentOnDropEditProvider(Ne,re,me,(0,$e.isProposedApiEnabled)(Ne,"dropMetadata")?Le:void 0)}},Jt={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(re,me,Le){const nt=await(O.URI.isUri(re)?Promise.resolve(ui.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(nt,me,Le)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(Ne,re)},onDidChangeActiveTextEditor(re,me,Le){return Ot.onDidChangeActiveTextEditor(re,me,Le)},onDidChangeVisibleTextEditors(re,me,Le){return Ot.onDidChangeVisibleTextEditors(re,me,Le)},onDidChangeTextEditorSelection(re,me,Le){return Ot.onDidChangeTextEditorSelection(re,me,Le)},onDidChangeTextEditorOptions(re,me,Le){return Ot.onDidChangeTextEditorOptions(re,me,Le)},onDidChangeTextEditorVisibleRanges(re,me,Le){return Ot.onDidChangeTextEditorVisibleRanges(re,me,Le)},onDidChangeTextEditorViewColumn(re,me,Le){return Ot.onDidChangeTextEditorViewColumn(re,me,Le)},onDidCloseTerminal(re,me,Le){return pt.onDidCloseTerminal(re,me,Le)},onDidOpenTerminal(re,me,Le){return pt.onDidOpenTerminal(re,me,Le)},onDidChangeActiveTerminal(re,me,Le){return pt.onDidChangeActiveTerminal(re,me,Le)},onDidChangeTerminalDimensions(re,me,Le){return(0,$e.checkProposedApiEnabled)(Ne,"terminalDimensions"),pt.onDidChangeTerminalDimensions(re,me,Le)},onDidChangeTerminalState(re,me,Le){return pt.onDidChangeTerminalState(re,me,Le)},onDidWriteTerminalData(re,me,Le){return(0,$e.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(re,me,Le)},get state(){return et.getState(Ne)},onDidChangeWindowState(re,me,Le){return et.onDidChangeWindowState(re,me,Le)},showInformationMessage(re,...me){return Ii.showMessage(Ne,M.default.Info,re,me[0],me.slice(1))},showWarningMessage(re,...me){return Ii.showMessage(Ne,M.default.Warning,re,me[0],me.slice(1))},showErrorMessage(re,...me){return Ii.showMessage(Ne,M.default.Error,re,me[0],me.slice(1))},showQuickPick(re,me,Le){return Gt.showQuickPick(Ne,re,me,Le)},showWorkspaceFolderPick(re){return Gt.showWorkspaceFolderPick(re)},showInputBox(re,me){return Gt.showInput(re,me)},showOpenDialog(re){return gi.showOpenDialog(Ne,re)},showSaveDialog(re){return gi.showSaveDialog(re)},createStatusBarItem(re,me,Le){let nt,Dt,At;return typeof re=="string"?(nt=re,Dt=me,At=Le):(Dt=re,At=me),Ci.createStatusBarEntry(Ne,nt,Dt,At)},setStatusBarMessage(re,me){return Ci.setStatusBarMessage(re,me)},withScmProgress(re){return ze.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),yi.withProgress(Ne,{location:W.ProgressLocation.SourceControl},(me,Le)=>re({report(nt){}}))},withProgress(re,me){return yi.withProgress(Ne,re,me)},createOutputChannel(re,me){return Oi.createOutputChannel(re,me,Ne)},createWebviewPanel(re,me,Le,nt){return mi.createWebviewPanel(Ne,re,me,Le,nt)},createWebviewTextEditorInset(re,me,Le,nt){return(0,$e.checkProposedApiEnabled)(Ne,"editorInsets"),Qt.createWebviewEditorInset(re,me,Le,nt,Ne)},createTerminal(re,me,Le){return typeof re=="object"?"pty"in re?pt.createExtensionTerminal(re):pt.createTerminalFromOptions(re):pt.createTerminal(re,me,Le)},registerTerminalLinkProvider(re){return pt.registerLinkProvider(re)},registerTerminalProfileProvider(re,me){return pt.registerProfileProvider(Ne,re,me)},registerTerminalQuickFixProvider(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(re,Ne.identifier.value,me)},registerTreeDataProvider(re,me){return _i.registerTreeDataProvider(re,me,Ne)},createTreeView(re,me){return _i.createTreeView(re,me,Ne)},registerWebviewPanelSerializer:(re,me)=>mi.registerWebviewPanelSerializer(Ne,re,me),registerCustomEditorProvider:(re,me,Le={})=>zi.registerCustomEditorProvider(Ne,re,me,Le),registerFileDecorationProvider(re){return vt.registerFileDecorationProvider(re,Ne)},registerUriHandler(re){return wi.registerUriHandler(Ne,re)},createQuickPick(){return Gt.createQuickPick(Ne)},createInputBox(){return Gt.createInputBox(Ne)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(re,me,Le){return Di.onDidChangeActiveColorTheme(re,me,Le)},registerWebviewViewProvider(re,me,Le){return Wi.registerWebviewViewProvider(Ne,re,me,Le?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,me,Le){return yt.onDidChangeActiveNotebookEditor(re,me,Le)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,me,Le){return bi.onDidChangeNotebookEditorSelection(re,me,Le)},onDidChangeNotebookEditorVisibleRanges(re,me,Le){return bi.onDidChangeNotebookEditorVisibleRanges(re,me,Le)},showNotebookDocument(re,me){return yt.showNotebookDocument(re,me)},registerExternalUriOpener(re,me,Le){return(0,$e.checkProposedApiEnabled)(Ne,"externalUriOpener"),Hi.registerExternalUriOpener(Ne.identifier,re,me,Le)},registerProfileContentHandler(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"profileContentHandlers"),Vi.registrProfileContentHandler(Ne,re,me)},registerQuickDiffProvider(re,me,Le,nt){return(0,$e.checkProposedApiEnabled)(Ne,"quickDiffProvider"),Ni.registerQuickDiffProvider(ft(re),me,Le,nt)},get tabGroups(){return Pt.tabGroups},registerShareProvider(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"shareProvider"),Ui.registerShareProvider(ft(re),me)}},ui={get rootPath(){return ze.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ut.getPath()},set rootPath(re){throw C.readonly()},getWorkspaceFolder(re){return ut.getWorkspaceFolder(re)},get workspaceFolders(){return ut.getWorkspaceFolders()},get name(){return ut.name},set name(re){throw C.readonly()},get workspaceFile(){return ut.workspaceFile},set workspaceFile(re){throw C.readonly()},updateWorkspaceFolders:(re,me,...Le)=>ut.updateWorkspaceFolders(Ne,re,me||0,...Le),onDidChangeWorkspaceFolders:function(re,me,Le){return ut.onDidChangeWorkspace(re,me,Le)},asRelativePath:(re,me)=>ut.getRelativePath(re,me),findFiles:(re,me,Le,nt)=>ut.findFiles(re,me,Le,Ne.identifier,nt),findTextInFiles:(re,me,Le,nt)=>{(0,$e.checkProposedApiEnabled)(Ne,"findTextInFiles");let Dt,At;return typeof me=="object"?(Dt=me,At=Le):(Dt={},At=me,nt=Le),ut.findTextInFiles(re,Dt||{},At,Ne.identifier,nt)},save:re=>((0,$e.checkProposedApiEnabled)(Ne,"saveEditor"),ut.save(re)),saveAs:re=>((0,$e.checkProposedApiEnabled)(Ne,"saveEditor"),ut.saveAs(re)),saveAll:re=>ut.saveAll(re),applyEdit(re,me){return Xi.applyWorkspaceEdit(re,Ne,me)},createFileSystemWatcher:(re,me,Le,nt)=>ei.createFileSystemWatcher(ut,Ne,re,me,Le,nt),get textDocuments(){return Tt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw C.readonly()},openTextDocument(re){let me;const Le=re;if(typeof re=="string")me=Promise.resolve(O.URI.file(re));else if(O.URI.isUri(re))me=Promise.resolve(re);else if(!Le||typeof Le=="object")me=Tt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(nt=>Tt.ensureDocumentData(nt).then(Dt=>Dt.document))},onDidOpenTextDocument:(re,me,Le)=>Tt.onDidAddDocument(re,me,Le),onDidCloseTextDocument:(re,me,Le)=>Tt.onDidRemoveDocument(re,me,Le),onDidChangeTextDocument:(re,me,Le)=>Tt.onDidChangeDocument(re,me,Le),onDidSaveTextDocument:(re,me,Le)=>Tt.onDidSaveDocument(re,me,Le),onWillSaveTextDocument:(re,me,Le)=>ai.getOnWillSaveTextDocumentEvent(Ne)(re,me,Le),get notebookDocuments(){return yt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,me){let Le;if(O.URI.isUri(re))Le=re,await yt.openNotebookDocument(re);else if(typeof re=="string")Le=O.URI.revive(await yt.createNotebookDocument({viewType:re,content:me}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(re,me,Le){return di.onDidSaveNotebookDocument(re,me,Le)},onDidChangeNotebookDocument(re,me,Le){return di.onDidChangeNotebookDocument(re,me,Le)},onWillSaveNotebookDocument(re,me,Le){return Li.getOnWillSaveNotebookDocumentEvent(Ne)(re,me,Le)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(re,me,Le,nt){return yt.registerNotebookSerializer(Ne,re,me,Le,(0,$e.isProposedApiEnabled)(Ne,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(re,me,Le)=>Qi.onDidChangeConfiguration(re,me,Le),getConfiguration(re,me){return me=arguments.length===1?void 0:me,Qi.getConfiguration(re,me,Ne)},registerTextDocumentContentProvider(re,me){return Fi.registerTextDocumentContentProvider(re,me)},registerTaskProvider:(re,me)=>(ze.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Wt.registerTaskProvider(Ne,re,me)),registerFileSystemProvider(re,me,Le){return(0,Ve.combinedDisposable)(Mi.registerFileSystemProvider(Ne,re,me,Le),Nt.addFileSystemProvider(re,me))},get fs(){return Nt.value},registerFileSearchProvider:(re,me)=>((0,$e.checkProposedApiEnabled)(Ne,"fileSearchProvider"),oi.registerFileSearchProvider(re,me)),registerTextSearchProvider:(re,me)=>((0,$e.checkProposedApiEnabled)(Ne,"textSearchProvider"),oi.registerTextSearchProvider(re,me)),registerRemoteAuthorityResolver:(re,me)=>((0,$e.checkProposedApiEnabled)(Ne,"resolvers"),wt.registerRemoteAuthorityResolver(re,me)),registerResourceLabelFormatter:re=>((0,$e.checkProposedApiEnabled)(Ne,"resolvers"),Bi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,me,Le)=>ei.onDidCreateFile(re,me,Le),onDidDeleteFiles:(re,me,Le)=>ei.onDidDeleteFile(re,me,Le),onDidRenameFiles:(re,me,Le)=>ei.onDidRenameFile(re,me,Le),onWillCreateFiles:(re,me,Le)=>ei.getOnWillCreateFileEvent(Ne)(re,me,Le),onWillDeleteFiles:(re,me,Le)=>ei.getOnWillDeleteFileEvent(Ne)(re,me,Le),onWillRenameFiles:(re,me,Le)=>ei.getOnWillRenameFileEvent(Ne)(re,me,Le),openTunnel:re=>((0,$e.checkProposedApiEnabled)(Ne,"tunnels"),Ge.openTunnel(Ne,re).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,$e.checkProposedApiEnabled)(Ne,"tunnels"),Ge.getTunnels()},onDidChangeTunnels:(re,me,Le)=>((0,$e.checkProposedApiEnabled)(Ne,"tunnels"),Ge.onDidChangeTunnels(re,me,Le)),registerPortAttributesProvider:(re,me)=>((0,$e.checkProposedApiEnabled)(Ne,"portsAttributes"),Ge.registerPortsAttributesProvider(re,me)),registerTimelineProvider:(re,me)=>((0,$e.checkProposedApiEnabled)(Ne,"timeline"),$i.registerTimelineProvider(re,me,Ne.identifier,gt.converter)),get isTrusted(){return ut.trusted},requestWorkspaceTrust:re=>((0,$e.checkProposedApiEnabled)(Ne,"workspaceTrust"),ut.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,me,Le)=>ut.onDidGrantWorkspaceTrust(re,me,Le),registerEditSessionIdentityProvider:(re,me)=>((0,$e.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ut.registerEditSessionIdentityProvider(re,me)),onWillCreateEditSessionIdentity:(re,me,Le)=>((0,$e.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ut.getOnWillCreateEditSessionIdentityEvent(Ne)(re,me,Le)),registerCanonicalUriProvider:(re,me)=>((0,$e.checkProposedApiEnabled)(Ne,"canonicalUriProvider"),ut.registerCanonicalUriProvider(re,me)),getCanonicalUri:(re,me,Le)=>((0,$e.checkProposedApiEnabled)(Ne,"canonicalUriProvider"),ut.provideCanonicalUri(re,me,Le))},un={get inputBox(){return ze.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Ne)},createSourceControl(re,me,Le){return Si.createSourceControl(Ne,re,me,Le)}},Ht={createCommentController(re,me){return xi.createCommentController(Ne,re,me)}},vi={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get stackFrameFocus(){return Et.stackFrameFocus},onDidStartDebugSession(re,me,Le){return Et.onDidStartDebugSession(re,me,Le)},onDidTerminateDebugSession(re,me,Le){return Et.onDidTerminateDebugSession(re,me,Le)},onDidChangeActiveDebugSession(re,me,Le){return Et.onDidChangeActiveDebugSession(re,me,Le)},onDidReceiveDebugSessionCustomEvent(re,me,Le){return Et.onDidReceiveDebugSessionCustomEvent(re,me,Le)},onDidChangeBreakpoints(re,me,Le){return Et.onDidChangeBreakpoints(re,me,Le)},onDidChangeStackFrameFocus(re,me,Le){return(0,$e.checkProposedApiEnabled)(Ne,"debugFocus"),Et.onDidChangeStackFrameFocus(re,me,Le)},registerDebugConfigurationProvider(re,me,Le){return Et.registerDebugConfigurationProvider(re,me,Le||Je.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,me){return Et.registerDebugAdapterDescriptorFactory(Ne,re,me)},registerDebugAdapterTrackerFactory(re,me){return Et.registerDebugAdapterTrackerFactory(re,me)},startDebugging(re,me,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Et.startDebugging(re,me,{parentSession:Le}):Et.startDebugging(re,me,Le||{})},stopDebugging(re){return Et.stopDebugging(re)},addBreakpoints(re){return Et.addBreakpoints(re)},removeBreakpoints(re){return Et.removeBreakpoints(re)},asDebugSourceUri(re,me){return Et.asDebugSourceUri(re,me)}},tn={registerTaskProvider:(re,me)=>Wt.registerTaskProvider(Ne,re,me),fetchTasks:re=>Wt.fetchTasks(re),executeTask:re=>Wt.executeTask(Ne,re),get taskExecutions(){return Wt.taskExecutions},onDidStartTask:(re,me,Le)=>Wt.onDidStartTask(re,me,Le),onDidEndTask:(re,me,Le)=>Wt.onDidEndTask(re,me,Le),onDidStartTaskProcess:(re,me,Le)=>Wt.onDidStartTaskProcess(re,me,Le),onDidEndTaskProcess:(re,me,Le)=>Wt.onDidEndTaskProcess(re,me,Le)},nn={createNotebookController(re,me,Le,nt,Dt){return hi.createNotebookController(Ne,re,me,Le,nt,(0,$e.isProposedApiEnabled)(Ne,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(re,me)=>yt.registerNotebookCellStatusBarItemProvider(Ne,re,me),createRendererMessaging(re){return cn.createRendererMessaging(Ne,re)},createNotebookControllerDetectionTask(re){return(0,$e.checkProposedApiEnabled)(Ne,"notebookKernelSource"),hi.createNotebookControllerDetectionTask(Ne,re)},registerKernelSourceActionProvider(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"notebookKernelSource"),hi.registerKernelSourceActionProvider(Ne,re,me)},onDidChangeNotebookCellExecutionState(re,me,Le){return(0,$e.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),hi.onDidChangeNotebookCellExecutionState(re,me,Le)}},rn={t(...re){if(typeof re[0]=="string"){const me=re.shift(),Le=!re||typeof re[0]!="object"?re:re[0];return Kt.getMessage(Ne.identifier.value,{message:me,args:Le})}return Kt.getMessage(Ne.identifier.value,re[0])},get bundle(){return Kt.getBundle(Ne.identifier.value)},get uri(){return Kt.getBundleUri(Ne.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(re){return(0,$e.checkProposedApiEnabled)(Ne,"interactive"),ji.registerProvider(Ne,re)},registerInteractiveSessionProvider(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"interactive"),si.registerChatProvider(Ne,re,me)},addInteractiveRequest(re){return(0,$e.checkProposedApiEnabled)(Ne,"interactive"),si.addChatRequest(re)},sendInteractiveRequestToProvider(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"interactive"),si.sendInteractiveRequestToProvider(re,me)},get onDidPerformUserAction(){return(0,$e.checkProposedApiEnabled)(Ne,"interactiveUserActions"),si.onDidPerformUserAction}},dn={registerSlashCommandProvider(re,me){return(0,$e.checkProposedApiEnabled)(Ne,"interactiveSlashCommands"),si.registerSlashCommandProvider(Ne,re,me)}},on={registerSemanticSimilarityProvider(re){return(0,$e.checkProposedApiEnabled)(Ne,"semanticSimilarity"),qi.registerSemanticSimilarityProvider(Ne,re)}};return{version:ht.version,ai:on,authentication:ki,commands:Yi,comments:Ht,debug:vi,env:Ti,extensions:Zi,interactive:sn,interactiveSlashCommands:dn,l10n:rn,languages:en,notebooks:nn,scm:un,tasks:tn,tests:Ji,window:Jt,workspace:ui,Breakpoint:W.Breakpoint,TerminalOutputAnchor:W.TerminalOutputAnchor,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentState:W.CommentState,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Je.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileDecoration2:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestionList,Hover:W.Hover,IndentAction:m.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalQuickFixCommand:W.TerminalQuickFixCommand,TerminalQuickFixOpener:W.TerminalQuickFixOpener,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TerminalExitReason:W.TerminalExitReason,TerminalQuickFixType:W.TerminalQuickFixType,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,SnippetTextEdit:W.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItem2:W.TreeItem,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:p.UIKind,Uri:O.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,DocumentDropEdit:W.DocumentDropEdit,DocumentPasteEdit:W.DocumentPasteEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,ManagedResolvedAuthority:W.ManagedResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.NotebookEdit,NotebookKernelSourceAction:W.NotebookKernelSourceAction,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestRunRequest2:W.TestRunRequest2,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:tt.TextSearchCompleteMessageType,DataTransfer:W.DataTransfer,DataTransferItem:W.DataTransferItem,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.TextTabInput,TabInputTextDiff:W.TextDiffTabInput,TabInputTextMerge:W.TextMergeTabInput,TabInputCustom:W.CustomEditorTabInput,TabInputNotebook:W.NotebookEditorTabInput,TabInputNotebookDiff:W.NotebookDiffEditorTabInput,TabInputWebview:W.WebviewEditorTabInput,TabInputTerminal:W.TerminalEditorTabInput,TabInputInteractiveWindow:W.InteractiveWindowInput,TelemetryTrustedValue:ee.TelemetryTrustedValue,LogLevel:be.LogLevel,EditSessionIdentityMatch:_t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:W.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:W.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:W.InteractiveEditorResponseFeedbackKind,StackFrameFocus:W.StackFrameFocus,ThreadFocus:W.ThreadFocus,NotebookCodeActionKind:W.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=zt}),define(Ae[267],Re([1,0,70,109,33,107,34,32,59,62,111,113,114,83,73,79,108,61,38,82,57,60,234,14,112,80,81]),function(te,e,i,C,y,M,O,A,_,m,R,b,c,p,g,d,t,l,h,S,I,v,n,u,r,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,i.registerSingleton)(u.ILoggerService,n.ExtHostLoggerService,1),(0,i.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,i.registerSingleton)(O.IExtHostConfiguration,O.ExtHostConfiguration,0),(0,i.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,0),(0,i.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,i.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(E.IExtHostManagedSockets,E.ExtHostManagedSockets,0),(0,i.registerSingleton)(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,i.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch,0),(0,i.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,i.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,i.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,i.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,i.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,i.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,0),(0,i.registerSingleton)(I.IExtHostTelemetry,I.ExtHostTelemetry,0),(0,i.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,i.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Ae[268],Re([1,0,266,35,2,263,7,16,254]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends M.RequireInterceptor{_installInterceptor(){}getModule(p,g){for(const d of this._alternatives){const t=d(p);if(t){p=t;break}}if(this._factories.has(p))return this._factories.get(p).load(p,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=O.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(_.ExtHostConsoleForwarder);const p=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(m,p,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(p){return p.browser}async _loadCommonJSModule(p,g,d){g=g.with({path:b(g.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const l=y.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(g)),h=await fetch(l.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),h.status!==200)throw new Error(h.statusText);const S=await h.text(),I=`${g.toString(!0)}#vscode-extension`,v=`${S}
//# sourceURL=${I}`;let n;try{n=new Function("module","exports","require",v)}catch(E){throw console.error(t?`Loading code for extension ${t} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${g.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}p&&await this._extHostLocalizationService.initializeLocalizedMessages(p);const u={},r={exports:u},a=E=>{const D=this._fakeModules.getModule(E,g);if(D===void 0)throw new Error(`Cannot load module '${E}'`);return D};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(r,u,a),r.exports!==u?r.exports:u}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(p){}async _waitForDebuggerAttachment(p=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+p;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=R;function b(c,p){return c.endsWith(p)?c:c+p}}),define(Ae[269],Re([1,0,69,70,14,35,186,84,268]),function(te,e,i,C,y,M,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.registerSingleton)(y.ILogService,new i.SyncDescriptor(O.ExtHostLogService,[!0],!0)),(0,C.registerSingleton)(M.IExtHostExtensionService,_.ExtHostExtensionService,0),(0,C.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths,0)}),define(Ae[277],Re([1,0,24,5,77,264,256,19,85,15,2,267,269]),function(te,e,i,C,y,M,O,A,_,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(n){return/^(file|vscode-remote):/i.test(n)}const g=fetch.bind(self);function d(n){self.fetch=async function(u,r){return u instanceof Request||p(String(u))&&(u=(await n(R.URI.parse(String(u)))).toString(!0)),g(u,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,r,a,E,D){(async()=>(p(r.toString())&&(r=(await n(R.URI.parse(r.toString()))).toString(!0)),super.open(u,r,a??!0,E,D)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(u,r){if(/^file:/i.test(u.toString()))u=m.FileAccess.uriToBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(w){function o(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const s=fetch.bind(self);self.fetch=function(B,G){return B instanceof Request?s(B,G):s(o(B),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,G,q,$,N){return super.open(B,o(G),q??!0,$,N)}};const F=importScripts.bind(self);self.importScripts=(...B)=>{F(...B.map(o))},F(w)}.toString()}('${u}'))`;r=r||{},r.name=r.name||A.basename(u.toString());const D=new Blob([E],{type:"application/javascript"}),f=URL.createObjectURL(D);return new n(f,r)}}else self.Worker=class extends O.NestedWorker{constructor(n,u){super(c,n,{name:A.basename(n.toString()),...u})}};const t=new class{constructor(){this.pid=void 0}exit(n){b()}async exists(n){return!0}async realpath(n){return n}};class l{constructor(){const u=new MessageChannel,r=new C.Emitter;let a=!1;c(u.port2,[u.port2]),u.port1.onmessage=E=>{const{data:D}=E;if(!(D instanceof ArrayBuffer)){console.warn("UNKNOWN data received",D);return}const f=i.VSBuffer.wrap(new Uint8Array(D,0,D.byteLength));if((0,y.isMessageOfType)(f,2)){a=!0,S("received terminate message from renderer");return}r.fire(f)},this.protocol={onMessage:r.event,send:E=>{if(!a){const D=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);u.port1.postMessage(D,[D])}}}}}function h(n){return new Promise(u=>{const r=n.onMessage(a=>{r.dispose();const E=JSON.parse(a.toString());n.send((0,y.createMessageOfType)(0)),u({protocol:n,initData:E})});n.send((0,y.createMessageOfType)(1))})}let S=n=>b();function I(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function v(){_.mark("code/extHost/willConnectToRenderer");const n=new l;return{onmessage(u){I(u)&&h(n.protocol).then(r=>{_.mark("code/extHost/didWaitForInitData");const a=new M.ExtensionHostMain(r.protocol,r.initData,t,null,u.data);d(E=>a.asBrowserUri(E)),S=E=>a.terminate(E)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/workbench/api/worker/extensionHostWorker.js.map
