/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/platform","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],K=function(D){for(var e=[],w=0,S=D.length;w<S;w++)e[w]=q[D[w]];return e};define(q[3],K([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let w;function S(o){w=o}e.setLogger=S;function k(){return w}e.getLogger=k;class L{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(u){return r([h(m("|  ",this.indentation)),u])}formatInfo(u){return u.didChange?[h(" "),i(n(u.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),i(n(u.newValue,60),{color:"green"})]:[h(" (unchanged)")]}handleObservableChanged(u,v){console.log(...this.textToConsoleArgs([t("observable value changed"),i(u.debugName,{color:"BlueViolet"}),...this.formatInfo(v)]))}formatChanges(u){if(u.size!==0)return i(" (changed deps: "+[...u].map(v=>v.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(u){const v=u.handleChange;this.changedObservablesSets.set(u,new Set),u.handleChange=(P,z)=>(this.changedObservablesSets.get(u).add(P),v.apply(u,[P,z]))}handleDerivedRecomputed(u,v){const P=this.changedObservablesSets.get(u);console.log(...this.textToConsoleArgs([t("derived recomputed"),i(u.debugName,{color:"BlueViolet"}),...this.formatInfo(v),this.formatChanges(P)])),P.clear()}handleFromEventObservableTriggered(u,v){console.log(...this.textToConsoleArgs([t("observable from event triggered"),i(u.debugName,{color:"BlueViolet"}),...this.formatInfo(v)]))}handleAutorunCreated(u){const v=u.handleChange;this.changedObservablesSets.set(u,new Set),u.handleChange=(P,z)=>(this.changedObservablesSets.get(u).add(P),v.apply(u,[P,z]))}handleAutorunTriggered(u){const v=this.changedObservablesSets.get(u);console.log(...this.textToConsoleArgs([t("autorun"),i(u.debugName,{color:"BlueViolet"}),this.formatChanges(v)])),v.clear()}handleBeginTransaction(u){let v=u.getDebugName();v===void 0&&(v=""),console.log(...this.textToConsoleArgs([t("transaction"),i(v,{color:"BlueViolet"})])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=L;function r(o){const u=new Array,P={};let z="";function N(d){if("length"in d)for(const g of d)g&&N(g);else"text"in d?(z+=`%c${d.text}`,u.push(d.style),d.data&&Object.assign(P,d.data)):"data"in d&&Object.assign(P,d.data)}N(o);const E=[z,...u];return Object.keys(P).length>0&&E.push(P),E}function h(o){return i(o,{color:"black"})}function t(o){return i(a(`${o}: `,10),{color:"black",bold:!0})}function i(o,u={color:"black"}){function v(z){return Object.entries(z).reduce((N,[E,d])=>`${N}${E}:${d};`,"")}const P={color:u.color};return u.strikeThrough&&(P["text-decoration"]="line-through"),u.bold&&(P["font-weight"]="bold"),{text:o,style:v(P)}}function n(o,u){switch(typeof o){case"number":return""+o;case"string":return o.length+2<=u?`"${o}"`:`"${o.substr(0,u-7)}"+...`;case"boolean":return o?"true":"false";case"undefined":return"undefined";case"object":return o===null?"null":Array.isArray(o)?s(o,u):_(o,u);case"symbol":return o.toString();case"function":return`[[Function${o.name?" "+o.name:""}]]`;default:return""+o}}function s(o,u){let v="[ ",P=!0;for(const z of o){if(P||(v+=", "),v.length-5>u){v+="...";break}P=!1,v+=`${n(z,u-v.length)}`}return v+=" ]",v}function _(o,u){let v="{ ",P=!0;for(const[z,N]of Object.entries(o)){if(P||(v+=", "),v.length-5>u){v+="...";break}P=!1,v+=`${z}: ${n(N,u-v.length)}`}return v+=" }",v}function m(o,u){let v="";for(let P=1;P<=u;P++)v+=o;return v}function a(o,u){for(;o.length<u;)o+=" ";return o}}),define(q[8],K([0,1,39,2,3]),function(D,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunWithStore2=e.autorunHandleChanges=e.autorun=void 0;function L(m,a){return new s(m,a,void 0,void 0)}e.autorun=L;function r(m,a,o){return new s(m,o,a.createEmptyChangeSummary,a.handleChange)}e.autorunHandleChanges=r;function h(m,a){return i(a,m)}e.autorunWithStore2=h;function t(m,a,o){const u=new S.DisposableStore,v=r(m,{createEmptyChangeSummary:a.createEmptyChangeSummary,handleChange:a.handleChange},(P,z)=>{u.clear(),o(P,z,u)});return(0,S.toDisposable)(()=>{v.dispose(),u.dispose()})}e.autorunWithStoreHandleChanges=t;function i(m,a){const o=new S.DisposableStore,u=L(a,v=>{o.clear(),m(v,o)});return(0,S.toDisposable)(()=>{u.dispose(),o.dispose()})}e.autorunWithStore=i;var n;(function(m){m[m.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",m[m.stale=2]="stale",m[m.upToDate=3]="upToDate"})(n||(n={}));class s{constructor(a,o,u,v){this.debugName=a,this.runFn=o,this.createChangeSummary=u,this._handleChange=v,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,k.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded()}dispose(){this.disposed=!0;for(const a of this.dependencies)a.removeObserver(this);this.dependencies.clear()}_runIfNeeded(){if(this.state===3)return;const a=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=a,this.state=3,(0,k.getLogger)()?.handleAutorunTriggered(this);try{const o=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this.runFn(this,o)}finally{for(const o of this.dependenciesToBeRemoved)o.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const a of this.dependencies)if(a.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,w.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(a){this.state===3&&this.dependencies.has(a)&&!this.dependenciesToBeRemoved.has(a)&&(this.state=1)}handleChange(a,o){this.dependencies.has(a)&&!this.dependenciesToBeRemoved.has(a)&&(!this._handleChange||this._handleChange({changedObservable:a,change:o,didChange:v=>v===a},this.changeSummary))&&(this.state=2)}readObservable(a){if(this.disposed)return a.get();a.addObserver(this);const o=a.get();return this.dependencies.add(a),this.dependenciesToBeRemoved.delete(a),o}}e.AutorunObserver=s,function(m){m.Observer=s}(L||(e.autorun=L={}));function _(m,a,o){let u;return L(m,v=>{const P=a.read(v),z=u;u=P,o({lastValue:z,newValue:P})})}e.autorunDelta=_}),define(q[6],K([0,1,3]),function(D,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.TransactionImpl=e.subtransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let S;function k(o){S=o}e._setDerived=k;class L{get TChange(){return null}reportChanges(){this.get()}read(u){return u?u.readObservable(this):this.get()}map(u){return S(()=>{const v=n(u);return v!==void 0?v:`${this.debugName} (mapped)`},v=>u(this.read(v),v))}}e.ConvenientObservable=L;class r extends L{constructor(){super(...arguments),this.observers=new Set}addObserver(u){const v=this.observers.size;this.observers.add(u),v===0&&this.onFirstObserverAdded()}removeObserver(u){this.observers.delete(u)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=r;function h(o,u){const v=new i(o,u);try{(0,w.getLogger)()?.handleBeginTransaction(v),o(v)}finally{v.finish(),(0,w.getLogger)()?.handleEndTransaction()}}e.transaction=h;function t(o,u,v){o?u(o):h(u,v)}e.subtransaction=t;class i{constructor(u,v){this.fn=u,this._getDebugName=v,this.updatingObservers=[]}getDebugName(){return this._getDebugName?this._getDebugName():n(this.fn)}updateObserver(u,v){this.updatingObservers.push({observer:u,observable:v}),u.beginUpdate(v)}finish(){const u=this.updatingObservers;this.updatingObservers=null;for(const{observer:v,observable:P}of u)v.endUpdate(P)}}e.TransactionImpl=i;function n(o){const u=o.toString(),P=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(u);return(P?P[1]:void 0)?.trim()}e.getFunctionName=n;function s(o,u){return new _(o,u)}e.observableValue=s;class _ extends r{constructor(u,v){super(),this.debugName=u,this._value=v}get(){return this._value}set(u,v,P){if(this._value===u)return;let z;v||(v=z=new i(()=>{},()=>`Setting ${this.debugName}`));try{const N=this._value;this._setValue(u),(0,w.getLogger)()?.handleObservableChanged(this,{oldValue:N,newValue:u,change:P,didChange:!0});for(const E of this.observers)v.updateObserver(E,this),E.handleChange(this,P)}finally{z&&z.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(u){this._value=u}}e.ObservableValue=_;function m(o,u){return new a(o,u)}e.disposableObservableValue=m;class a extends _{_setValue(u){this._value!==u&&(this._value&&this._value.dispose(),this._value=u)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=a}),define(q[9],K([0,1,4,6,3]),function(D,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedHandleChanges=e.derived=void 0;function L(i,n){return new t(i,n,void 0,void 0)}e.derived=L;function r(i,n,s){return new t(i,s,n.createEmptyChangeSummary,n.handleChange)}e.derivedHandleChanges=r,(0,S._setDerived)(L);var h;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class t extends S.BaseObservable{get debugName(){return typeof this._debugName=="function"?this._debugName():this._debugName}constructor(n,s,_,m){super(),this._debugName=n,this.computeFn=s,this.createChangeSummary=_,this._handleChange=m,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,k.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear()}get(){if(this.observers.size===0){const n=this.computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),n}else{do{if(this.state===1){this.state=3;for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n;const s=this.state!==0,_=this.value;this.state=3;const m=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this.computeFn(this,m)}finally{for(const o of this.dependenciesToBeRemoved)o.removeObserver(this);this.dependenciesToBeRemoved.clear()}const a=s&&_!==this.value;if((0,k.getLogger)()?.handleDerivedRecomputed(this,{oldValue:_,newValue:this.value,change:void 0,didChange:a}),a)for(const o of this.observers)o.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.updateCount++;const s=this.updateCount===1;if(this.state===3&&(this.state=1,!s))for(const _ of this.observers)_.handlePossibleChange(this);if(s)for(const _ of this.observers)_.beginUpdate(this)}endUpdate(n){if(this.updateCount--,this.updateCount===0){const s=[...this.observers];for(const _ of s)_.endUpdate(this)}if(this.updateCount<0)throw new w.BugIndicatingError}handlePossibleChange(n){if(this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){this.state=1;for(const s of this.observers)s.handlePossibleChange(this)}}handleChange(n,s){if(this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){const _=this._handleChange?this._handleChange({changedObservable:n,change:s,didChange:a=>a===n},this.changeSummary):!0,m=this.state===3;if(_&&(this.state===1||m)&&(this.state=2,m))for(const a of this.observers)a.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const s=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),s}addObserver(n){const s=!this.observers.has(n)&&this.updateCount>0;super.addObserver(n),s&&n.beginUpdate(this)}removeObserver(n){const s=this.observers.has(n)&&this.updateCount>0;super.removeObserver(n),s&&n.endUpdate(this)}}e.Derived=t}),define(q[20],K([0,1,2,8,6,9,3]),function(D,e,w,S,k,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(g){return new t(g)}e.constObservable=h;class t extends k.ConvenientObservable{constructor(b){super(),this.value=b}get debugName(){return this.toString()}get(){return this.value}addObserver(b){}removeObserver(b){}toString(){return`Const: ${this.value}`}}function i(g){const b=(0,k.observableValue)("promiseValue",{});return g.then(I=>{b.set({value:I},void 0)}),b}e.observableFromPromise=i;function n(g,b){return new Promise(I=>{let U=!1,c=!1;const O=(0,S.autorun)("waitForState",M=>{const y=g.read(M);b(y)&&(U?O.dispose():c=!0,I(y))});U=!0,c&&O.dispose()})}e.waitForState=n;function s(g,b){return new _(g,b)}e.observableFromEvent=s;class _ extends k.BaseObservable{constructor(b,I){super(),this.event=b,this.getValue=I,this.hasValue=!1,this.handleEvent=U=>{const c=this.getValue(U),O=!this.hasValue||this.value!==c;(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:c,change:void 0,didChange:O}),O&&(this.value=c,this.hasValue&&(0,k.transaction)(M=>{for(const y of this.observers)M.updateObserver(y,this),y.handleChange(this,void 0)},()=>{const M=this.getDebugName();return"Event fired"+(M?`: ${M}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,k.getFunctionName)(this.getValue)}get debugName(){const b=this.getDebugName();return"From Event"+(b?`: ${b}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this.getValue(void 0)}}e.FromEventObservable=_,function(g){g.Observer=_}(s||(e.observableFromEvent=s={}));function m(g,b){return new a(g,b)}e.observableSignalFromEvent=m;class a extends k.BaseObservable{constructor(b,I){super(),this.debugName=b,this.event=I,this.handleEvent=()=>{(0,k.transaction)(U=>{for(const c of this.observers)U.updateObserver(c,this),c.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function o(g){return new u(g)}e.observableSignal=o;class u extends k.BaseObservable{constructor(b){super(),this.debugName=b}trigger(b,I){if(!b){(0,k.transaction)(U=>{this.trigger(U,I)},()=>`Trigger signal ${this.debugName}`);return}for(const U of this.observers)b.updateObserver(U,this),U.handleChange(this,I)}get(){}}function v(g,b,I){const U=(0,k.observableValue)("debounced",void 0);let c;return I.add((0,S.autorun)("debounce",O=>{const M=g.read(O);c&&clearTimeout(c),c=setTimeout(()=>{(0,k.transaction)(y=>{U.set(M,y)})},b)})),U}e.debouncedObservable=v;function P(g,b,I){const U=(0,k.observableValue)("triggeredRecently",!1);let c;return I.add(g(()=>{U.set(!0,void 0),c&&clearTimeout(c),c=setTimeout(()=>{U.set(!1,void 0)},b)})),U}e.wasEventTriggeredRecently=P;function z(g,b){const I=new N(b??!1);return g.addObserver(I),b&&g.reportChanges(),(0,w.toDisposable)(()=>{g.removeObserver(I)})}e.keepAlive=z;class N{constructor(b){this.forceRecompute=b,this.counter=0}beginUpdate(b){this.counter++}endUpdate(b){this.counter--,this.counter===0&&this.forceRecompute&&b.reportChanges()}handlePossibleChange(b){}handleChange(b,I){}}function E(g,b){let I;return(0,L.derived)(g,c=>(I=b(c,I),I))}e.derivedObservableWithCache=E;function d(g,b){let I;const U=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),c=(0,L.derived)(g,O=>(U.read(O),I=b(O,I),I));return Object.assign(c,{clearCache:O=>{I=void 0,U.set(U.get()+1,O)}})}e.derivedObservableWithWritableCache=d});var re=this&&this.__createBinding||(Object.create?function(D,e,w,S){S===void 0&&(S=w);var k=Object.getOwnPropertyDescriptor(e,w);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(D,S,k)}:function(D,e,w,S){S===void 0&&(S=w),D[S]=e[w]}),se=this&&this.__exportStar||function(D,e){for(var w in D)w!=="default"&&!Object.prototype.hasOwnProperty.call(e,w)&&re(e,D,w)};define(q[10],K([0,1,6,9,8,20,3]),function(D,e,w,S,k,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return w.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return w.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),se(L,e),!1&&(0,r.setLogger)(new r.ConsoleObservableLogger)}),define(q[21],K([0,1,4,2]),function(D,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(N){const E=N;return E?typeof E.read=="function":!1}e.isReadable=k;function L(N){const E=N;return E?[E.on,E.pause,E.resume,E.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=L;function r(N){const E=N;return E?L(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=r;function h(N,E){return new t(N,E)}e.newWriteableStream=h;class t{constructor(E,d){this.reducer=E,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E<"u"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(d=>d(E))}emitError(E){this.listeners.error.length===0?(0,w.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(d=>d(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,d){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(E,d){if(this.state.destroyed)return;let g;switch(E){case"data":g=this.listeners.data;break;case"end":g=this.listeners.end;break;case"error":g=this.listeners.error;break}if(g){const b=g.indexOf(d);b>=0&&g.splice(b,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(g=>g())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function i(N,E){const d=[];let g;for(;(g=N.read())!==null;)d.push(g);return E(d)}e.consumeReadable=i;function n(N,E,d){const g=[];let b;for(;(b=N.read())!==null&&g.length<d;)g.push(b);return b===null&&g.length>0?E(g):{read:()=>{if(g.length>0)return g.shift();if(typeof b<"u"){const I=b;return b=void 0,I}return N.read()}}}e.peekReadable=n;function s(N,E){return new Promise((d,g)=>{const b=[];_(N,{onData:I=>{E&&b.push(I)},onError:I=>{E?g(I):d(void 0)},onEnd:()=>{d(E?E(b):void 0)}})})}e.consumeStream=s;function _(N,E){let d=!1;return N.on("error",g=>{d||E.onError(g)}),N.on("end",()=>{d||E.onEnd()}),N.on("data",g=>{d||E.onData(g)}),(0,S.toDisposable)(()=>d=!0)}e.listenStream=_;function m(N,E){return new Promise((d,g)=>{const b=new S.DisposableStore,I=[],U=M=>{if(I.push(M),I.length>E)return b.dispose(),N.pause(),d({stream:N,buffer:I,ended:!1})},c=M=>g(M),O=()=>d({stream:N,buffer:I,ended:!0});b.add((0,S.toDisposable)(()=>N.removeListener("error",c))),N.on("error",c),b.add((0,S.toDisposable)(()=>N.removeListener("end",O))),N.on("end",O),b.add((0,S.toDisposable)(()=>N.removeListener("data",U))),N.on("data",U)})}e.peekStream=m;function a(N,E){const d=h(E);return d.end(N),d}e.toStream=a;function o(){const N=h(()=>{throw new Error("not supported")});return N.end(),N}e.emptyStream=o;function u(N){let E=!1;return{read:()=>E?null:(E=!0,N)}}e.toReadable=u;function v(N,E,d){const g=h(d);return _(N,{onData:b=>g.write(E.data(b)),onError:b=>g.error(E.error?E.error(b):b),onEnd:()=>g.end()}),g}e.transform=v;function P(N,E,d){let g=!1;return{read:()=>{const b=E.read();return g?b:(g=!0,b!==null?d([N,b]):N)}}}e.prefixedReadable=P;function z(N,E,d){let g=!1;const b=h(d);return _(E,{onData:I=>g?b.write(I):(g=!0,b.write(d([N,I]))),onError:I=>b.error(I),onEnd:()=>{g||(g=!0,b.write(N)),b.end()}}),b}e.prefixedStream=z}),define(q[11],K([0,1,40,21]),function(D,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u",L=new w.Lazy(()=>new Uint8Array(256));let r,h;class t{static alloc(f){return k?new t(Buffer.allocUnsafe(f)):new t(new Uint8Array(f))}static wrap(f){return k&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new t(f)}static fromString(f,R){return!(R?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(f)):(r||(r=new TextEncoder),new t(r.encode(f)))}static fromByteArray(f){const R=t.alloc(f.length);for(let B=0,j=f.length;B<j;B++)R.buffer[B]=f[B];return R}static concat(f,R){if(typeof R>"u"){R=0;for(let G=0,$=f.length;G<$;G++)R+=f[G].byteLength}const B=t.alloc(R);let j=0;for(let G=0,$=f.length;G<$;G++){const W=f[G];B.set(W,j),j+=W.byteLength}return B}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=t.alloc(this.byteLength);return f.set(this),f}toString(){return k?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(f,R){return new t(this.buffer.subarray(f,R))}set(f,R){if(f instanceof t)this.buffer.set(f.buffer,R);else if(f instanceof Uint8Array)this.buffer.set(f,R);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),R);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return s(this.buffer,f)}writeUInt32BE(f,R){_(this.buffer,f,R)}readUInt32LE(f){return m(this.buffer,f)}writeUInt32LE(f,R){a(this.buffer,f,R)}readUInt8(f){return o(this.buffer,f)}writeUInt8(f,R){u(this.buffer,f,R)}indexOf(f){const R=f instanceof t?f.buffer:f,B=R.byteLength,j=this.buffer,G=j.byteLength;if(B===0)return 0;if(B===1)return j.indexOf(R[0]);if(B>G)return-1;const $=L.value;$.fill(R.length);for(let J=0;J<R.length;J++)$[R[J]]=R.length-J-1;let W=R.length-1,V=W,Z=-1;for(;W<G;)if(j[W]===R[V]){if(V===0){Z=W;break}W--,V--}else W+=Math.max(R.length-V,$[j[W]]),V=R.length-1;return Z}}e.VSBuffer=t;function i(y,f){return y[f+0]<<0>>>0|y[f+1]<<8>>>0}e.readUInt16LE=i;function n(y,f,R){y[R+0]=f&255,f=f>>>8,y[R+1]=f&255}e.writeUInt16LE=n;function s(y,f){return y[f]*2**24+y[f+1]*2**16+y[f+2]*2**8+y[f+3]}e.readUInt32BE=s;function _(y,f,R){y[R+3]=f,f=f>>>8,y[R+2]=f,f=f>>>8,y[R+1]=f,f=f>>>8,y[R]=f}e.writeUInt32BE=_;function m(y,f){return y[f+0]<<0>>>0|y[f+1]<<8>>>0|y[f+2]<<16>>>0|y[f+3]<<24>>>0}e.readUInt32LE=m;function a(y,f,R){y[R+0]=f&255,f=f>>>8,y[R+1]=f&255,f=f>>>8,y[R+2]=f&255,f=f>>>8,y[R+3]=f&255}e.writeUInt32LE=a;function o(y,f){return y[f]}e.readUInt8=o;function u(y,f,R){y[R]=f}e.writeUInt8=u;function v(y){return S.consumeReadable(y,f=>t.concat(f))}e.readableToBuffer=v;function P(y){return S.toReadable(y)}e.bufferToReadable=P;function z(y){return S.consumeStream(y,f=>t.concat(f))}e.streamToBuffer=z;async function N(y){return y.ended?t.concat(y.buffer):t.concat([...y.buffer,await z(y.stream)])}e.bufferedStreamToBuffer=N;function E(y){return S.toStream(y,f=>t.concat(f))}e.bufferToStream=E;function d(y){return S.transform(y,{data:f=>typeof f=="string"?t.fromString(f):t.wrap(f)},f=>t.concat(f))}e.streamToBufferReadableStream=d;function g(y){return S.newWriteableStream(f=>t.concat(f),y)}e.newWriteableBufferStream=g;function b(y,f){return S.prefixedReadable(y,f,R=>t.concat(R))}e.prefixedBufferReadable=b;function I(y,f){return S.prefixedStream(y,f,R=>t.concat(R))}e.prefixedBufferStream=I;function U(y){let f=0,R=0,B=0;const j=new Uint8Array(Math.floor(y.length/4*3)),G=W=>{switch(R){case 3:j[B++]=f|W,R=0;break;case 2:j[B++]=f|W>>>2,f=W<<6,R=3;break;case 1:j[B++]=f|W>>>4,f=W<<4,R=2;break;default:f=W<<2,R=1}};for(let W=0;W<y.length;W++){const V=y.charCodeAt(W);if(V>=65&&V<=90)G(V-65);else if(V>=97&&V<=122)G(V-97+26);else if(V>=48&&V<=57)G(V-48+52);else if(V===43||V===45)G(62);else if(V===47||V===95)G(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${y[W]}`)}}const $=B;for(;R>0;)G(0);return t.wrap(j).slice(0,$)}e.decodeBase64=U;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:y},f=!0,R=!1){const B=R?O:c;let j="";const G=y.byteLength%3;let $=0;for(;$<y.byteLength-G;$+=3){const W=y[$+0],V=y[$+1],Z=y[$+2];j+=B[W>>>2],j+=B[(W<<4|V>>>4)&63],j+=B[(V<<2|Z>>>6)&63],j+=B[Z&63]}if(G===1){const W=y[$+0];j+=B[W>>>2],j+=B[W<<4&63],f&&(j+="==")}else if(G===2){const W=y[$+0],V=y[$+1];j+=B[W>>>2],j+=B[(W<<4|V>>>4)&63],j+=B[V<<2&63],f&&(j+="=")}return j}e.encodeBase64=M}),define(q[22],K([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(q[12],K([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var w;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(w||(e.StringEOL=w={}));function S(k){let L=0,r=0,h=0,t=0;for(let i=0,n=k.length;i<n;i++){const s=k.charCodeAt(i);s===13?(L===0&&(r=i),L++,i+1<n&&k.charCodeAt(i+1)===10?(t|=2,i++):t|=3,h=i+1):s===10&&(t|=1,L===0&&(r=i),L++,h=i+1)}return L===0&&(r=k.length),[L,r,k.length-h,t]}e.countEOL=S}),define(q[13],K([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var w;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(w||(e.LanguageId=w={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var L;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(L||(e.StandardTokenType=L={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class h{static getLanguageId(i){return(i&255)>>>0}static getTokenType(i){return(i&768)>>>8}static containsBalancedBrackets(i){return(i&1024)!==0}static getFontStyle(i){return(i&30720)>>>11}static getForeground(i){return(i&16744448)>>>15}static getBackground(i){return(i&4278190080)>>>24}static getClassNameFromMetadata(i){let s="mtk"+this.getForeground(i);const _=this.getFontStyle(i);return _&1&&(s+=" mtki"),_&2&&(s+=" mtkb"),_&4&&(s+=" mtku"),_&8&&(s+=" mtks"),s}static getInlineStyleFromMetadata(i,n){const s=this.getForeground(i),_=this.getFontStyle(i);let m=`color: ${n[s]};`;_&1&&(m+="font-style: italic;"),_&2&&(m+="font-weight: bold;");let a="";return _&4&&(a+=" underline"),_&8&&(a+=" line-through"),a&&(m+=`text-decoration:${a};`),m}static getPresentationFromMetadata(i){const n=this.getForeground(i),s=this.getFontStyle(i);return{foreground:n,italic:!!(s&1),bold:!!(s&2),underline:!!(s&4),strikethrough:!!(s&8)}}}e.TokenMetadata=h}),define(q[23],K([0,1,24]),function(D,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class S{constructor(r){this._default=r,this._store=[]}get(r){return r<this._store.length?this._store[r]:this._default}set(r,h){for(;r>=this._store.length;)this._store[this._store.length]=this._default;this._store[r]=h}replace(r,h,t){if(r>=this._store.length)return;if(h===0){this.insert(r,t);return}else if(t===0){this.delete(r,h);return}const i=this._store.slice(0,r),n=this._store.slice(r+h),s=k(t,this._default);this._store=i.concat(s,n)}delete(r,h){h===0||r>=this._store.length||this._store.splice(r,h)}insert(r,h){if(h===0||r>=this._store.length)return;const t=[];for(let i=0;i<h;i++)t[i]=this._default;this._store=(0,w.arrayInsert)(this._store,r,t)}}e.FixedArray=S;function k(L,r){const h=[];for(let t=0;t<L;t++)h[t]=r;return h}}),define(q[7],K([0,1,13]),function(D,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class S{static createEmpty(r,h){const t=S.defaultTokenMetadata,i=new Uint32Array(2);return i[0]=r.length,i[1]=t,new S(i,r,h)}constructor(r,h,t){this._lineTokensBrand=void 0,this._tokens=r,this._tokensCount=this._tokens.length>>>1,this._text=h,this._languageIdCodec=t}equals(r){return r instanceof S?this.slicedEquals(r,0,this._tokensCount):!1}slicedEquals(r,h,t){if(this._text!==r._text||this._tokensCount!==r._tokensCount)return!1;const i=h<<1,n=i+(t<<1);for(let s=i;s<n;s++)if(this._tokens[s]!==r._tokens[s])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(r){return r>0?this._tokens[r-1<<1]:0}getMetadata(r){return this._tokens[(r<<1)+1]}getLanguageId(r){const h=this._tokens[(r<<1)+1],t=w.TokenMetadata.getLanguageId(h);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(r){const h=this._tokens[(r<<1)+1];return w.TokenMetadata.getTokenType(h)}getForeground(r){const h=this._tokens[(r<<1)+1];return w.TokenMetadata.getForeground(h)}getClassName(r){const h=this._tokens[(r<<1)+1];return w.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(r,h){const t=this._tokens[(r<<1)+1];return w.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(r){const h=this._tokens[(r<<1)+1];return w.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(r){return this._tokens[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this._tokens,r)}inflate(){return this}sliceAndInflate(r,h,t){return new k(this,r,h,t)}static convertToEndOffset(r,h){const i=(r.length>>>1)-1;for(let n=0;n<i;n++)r[n<<1]=r[n+1<<1];r[i<<1]=h}static findIndexInTokensArray(r,h){if(r.length<=2)return 0;let t=0,i=(r.length>>>1)-1;for(;t<i;){const n=t+Math.floor((i-t)/2),s=r[n<<1];if(s===h)return n+1;s<h?t=n+1:s>h&&(i=n)}return t}withInserted(r){if(r.length===0)return this;let h=0,t=0,i="";const n=new Array;let s=0;for(;;){const _=h<this._tokensCount?this._tokens[h<<1]:-1,m=t<r.length?r[t]:null;if(_!==-1&&(m===null||_<=m.offset)){i+=this._text.substring(s,_);const a=this._tokens[(h<<1)+1];n.push(i.length,a),h++,s=_}else if(m){if(m.offset>s){i+=this._text.substring(s,m.offset);const a=this._tokens[(h<<1)+1];n.push(i.length,a),s=m.offset}i+=m.text,n.push(i.length,m.tokenMetadata),t++}else break}return new S(new Uint32Array(n),i,this._languageIdCodec)}}e.LineTokens=S,S.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0;class k{constructor(r,h,t,i){this._source=r,this._startOffset=h,this._endOffset=t,this._deltaOffset=i,this._firstTokenIndex=r.findTokenIndexAtOffset(h),this._tokensCount=0;for(let n=this._firstTokenIndex,s=r.getCount();n<s&&!(r.getStartOffset(n)>=t);n++)this._tokensCount++}getMetadata(r){return this._source.getMetadata(this._firstTokenIndex+r)}getLanguageId(r){return this._source.getLanguageId(this._firstTokenIndex+r)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(r){return r instanceof k?this._startOffset===r._startOffset&&this._endOffset===r._endOffset&&this._deltaOffset===r._deltaOffset&&this._source.slicedEquals(r._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(r){return this._source.getForeground(this._firstTokenIndex+r)}getEndOffset(r){const h=this._source.getEndOffset(this._firstTokenIndex+r);return Math.min(this._endOffset,h)-this._startOffset+this._deltaOffset}getClassName(r){return this._source.getClassName(this._firstTokenIndex+r)}getInlineStyle(r,h){return this._source.getInlineStyle(this._firstTokenIndex+r,h)}getPresentation(r){return this._source.getPresentation(this._firstTokenIndex+r)}findTokenIndexAtOffset(r){return this._source.findTokenIndexAtOffset(r+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(q[25],K([0,1,7]),function(D,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class S{static deleteBeginning(r,h){return r===null||r===e.EMPTY_LINE_TOKENS?r:S.delete(r,0,h)}static deleteEnding(r,h){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const t=k(r),i=t[t.length-2];return S.delete(r,h,i)}static delete(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS||h===t)return r;const i=k(r),n=i.length>>>1;if(h===0&&i[i.length-2]===t)return e.EMPTY_LINE_TOKENS;const s=w.LineTokens.findIndexInTokensArray(i,h),_=s>0?i[s-1<<1]:0,m=i[s<<1];if(t<m){const P=t-h;for(let z=s;z<n;z++)i[z<<1]-=P;return r}let a,o;_!==h?(i[s<<1]=h,a=s+1<<1,o=h):(a=s<<1,o=_);const u=t-h;for(let P=s+1;P<n;P++){const z=i[P<<1]-u;z>o&&(i[a++]=z,i[a++]=i[(P<<1)+1],o=z)}if(a===i.length)return r;const v=new Uint32Array(a);return v.set(i.subarray(0,a),0),v.buffer}static append(r,h){if(h===e.EMPTY_LINE_TOKENS)return r;if(r===e.EMPTY_LINE_TOKENS)return h;if(r===null)return r;if(h===null)return null;const t=k(r),i=k(h),n=i.length>>>1,s=new Uint32Array(t.length+i.length);s.set(t,0);let _=t.length;const m=t[t.length-2];for(let a=0;a<n;a++)s[_++]=i[a<<1]+m,s[_++]=i[(a<<1)+1];return s.buffer}static insert(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const i=k(r),n=i.length>>>1;let s=w.LineTokens.findIndexInTokensArray(i,h);s>0&&i[s-1<<1]===h&&s--;for(let _=s;_<n;_++)i[_<<1]+=t;return r}}e.ContiguousTokensEditing=S;function k(L){return L instanceof Uint32Array?L:new Uint32Array(L)}e.toUint32Array=k}),define(q[26],K([0,1,24,11,41,12,25,14]),function(D,e,w,S,k,L,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(n,s,_){const m=new Uint32Array(n.buffer),a=(0,S.readUInt32BE)(n,s);s+=4;const o=(0,S.readUInt32BE)(n,s);s+=4;const u=[];for(let v=0;v<o;v++){const P=(0,S.readUInt32BE)(n,s);s+=4,u.push(m.subarray(s/4,s/4+P/4)),s+=P}return _.push(new t(a,u)),s}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(n,s){this._startLineNumber=n,this._tokens=s}getLineRange(){return new h.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(n){return this._tokens[n-this._startLineNumber]}appendLineTokens(n){this._tokens.push(n)}serializeSize(){let n=0;n+=4,n+=4;for(let s=0;s<this._tokens.length;s++){const _=this._tokens[s];if(!(_ instanceof Uint32Array))throw new Error("Not supported!");n+=4,n+=_.byteLength}return n}serialize(n,s){(0,S.writeUInt32BE)(n,this._startLineNumber,s),s+=4,(0,S.writeUInt32BE)(n,this._tokens.length,s),s+=4;for(let _=0;_<this._tokens.length;_++){const m=this._tokens[_];if(!(m instanceof Uint32Array))throw new Error("Not supported!");(0,S.writeUInt32BE)(n,m.byteLength,s),s+=4,n.set(new Uint8Array(m.buffer),s),s+=m.byteLength}return s}applyEdit(n,s){const[_,m]=(0,L.countEOL)(s);this._acceptDeleteRange(n),this._acceptInsertText(new k.Position(n.startLineNumber,n.startColumn),_,m)}_acceptDeleteRange(n){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return;const s=n.startLineNumber-this._startLineNumber,_=n.endLineNumber-this._startLineNumber;if(_<0){const m=_-s;this._startLineNumber-=m;return}if(!(s>=this._tokens.length)){if(s<0&&_>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(s===_){this._tokens[s]=r.ContiguousTokensEditing.delete(this._tokens[s],n.startColumn-1,n.endColumn-1);return}if(s>=0)if(this._tokens[s]=r.ContiguousTokensEditing.deleteEnding(this._tokens[s],n.startColumn-1),_<this._tokens.length){const m=r.ContiguousTokensEditing.deleteBeginning(this._tokens[_],n.endColumn-1);this._tokens[s]=r.ContiguousTokensEditing.append(this._tokens[s],m),this._tokens.splice(s+1,_-s)}else this._tokens[s]=r.ContiguousTokensEditing.append(this._tokens[s],null),this._tokens=this._tokens.slice(0,s+1);else{const m=-s;this._startLineNumber-=m,this._tokens[_]=r.ContiguousTokensEditing.deleteBeginning(this._tokens[_],n.endColumn-1),this._tokens=this._tokens.slice(_)}}}_acceptInsertText(n,s,_){if(s===0&&_===0)return;const m=n.lineNumber-this._startLineNumber;if(m<0){this._startLineNumber+=s;return}if(!(m>=this._tokens.length)){if(s===0){this._tokens[m]=r.ContiguousTokensEditing.insert(this._tokens[m],n.column-1,_);return}this._tokens[m]=r.ContiguousTokensEditing.deleteEnding(this._tokens[m],n.column-1),this._tokens[m]=r.ContiguousTokensEditing.insert(this._tokens[m],n.column-1,_),this._insertLines(n.lineNumber,s)}}_insertLines(n,s){if(s===0)return;const _=[];for(let m=0;m<s;m++)_[m]=null;this._tokens=w.arrayInsert(this._tokens,n,_)}}e.ContiguousMultilineTokens=t}),define(q[15],K([0,1,11,26]),function(D,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(r){let h=0;const t=(0,w.readUInt32BE)(r,h);h+=4;const i=[];for(let n=0;n<t;n++)h=S.ContiguousMultilineTokens.deserialize(r,h,i);return i}constructor(){this._tokens=[]}add(r,h){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(h);return}}this._tokens.push(new S.ContiguousMultilineTokens(r,[h]))}finalize(){return this._tokens}serialize(){const r=this._serializeSize(),h=new Uint8Array(r);return this._serialize(h),h}_serializeSize(){let r=0;r+=4;for(let h=0;h<this._tokens.length;h++)r+=this._tokens[h].serializeSize();return r}_serialize(r){let h=0;(0,w.writeUInt32BE)(r,this._tokens.length,h),h+=4;for(let t=0;t<this._tokens.length;t++)h=this._tokens[t].serialize(r,h)}}e.ContiguousMultilineTokensBuilder=k}),define(q[27],K([0,1,28,5,29,42]),function(D,e,w,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(c){return c===47||c===92}e.isPathSeparator=r;function h(c){return c.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=h;function t(c){return c.indexOf("/")===-1&&(c=h(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=t;function i(c,O=w.posix.sep){if(!c)return"";const M=c.length,y=c.charCodeAt(0);if(r(y)){if(r(c.charCodeAt(1))&&!r(c.charCodeAt(2))){let R=3;const B=R;for(;R<M&&!r(c.charCodeAt(R));R++);if(B!==R&&!r(c.charCodeAt(R+1))){for(R+=1;R<M;R++)if(r(c.charCodeAt(R)))return c.slice(0,R+1).replace(/[\\/]/g,O)}}return O}else if(v(y)&&c.charCodeAt(1)===58)return r(c.charCodeAt(2))?c.slice(0,2)+O:c.slice(0,2);let f=c.indexOf("://");if(f!==-1){for(f+=3;f<M;f++)if(r(c.charCodeAt(f)))return c.slice(0,f+1)}return""}e.getRoot=i;function n(c){if(!S.isWindows||!c||c.length<5)return!1;let O=c.charCodeAt(0);if(O!==92||(O=c.charCodeAt(1),O!==92))return!1;let M=2;const y=M;for(;M<c.length&&(O=c.charCodeAt(M),O!==92);M++);return!(y===M||(O=c.charCodeAt(M+1),isNaN(O)||O===92))}e.isUNC=n;const s=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(c,O=S.isWindows){const M=O?s:_;return!(!c||c.length===0||/^\s+$/.test(c)||(M.lastIndex=0,M.test(c))||O&&m.test(c)||c==="."||c===".."||O&&c[c.length-1]==="."||O&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=a;function o(c,O,M){const y=c===O;return!M||y?y:!c||!O?!1:(0,k.equalsIgnoreCase)(c,O)}e.isEqual=o;function u(c,O,M,y=w.sep){if(c===O)return!0;if(!c||!O||O.length>c.length)return!1;if(M){if(!(0,k.startsWithIgnoreCase)(c,O))return!1;if(O.length===c.length)return!0;let R=O.length;return O.charAt(O.length-1)===y&&R--,c.charAt(R)===y}return O.charAt(O.length-1)!==y&&(O+=y),c.indexOf(O)===0}e.isEqualOrParent=u;function v(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=v;function P(c,O){return S.isWindows&&c.endsWith(":")&&(c+=w.sep),(0,w.isAbsolute)(c)||(c=(0,w.join)(O,c)),c=(0,w.normalize)(c),S.isWindows?(c=(0,k.rtrim)(c,w.sep),c.endsWith(":")&&(c+=w.sep)):(c=(0,k.rtrim)(c,w.sep),c||(c=w.sep)),c}e.sanitizeFilePath=P;function z(c){const O=(0,w.normalize)(c);return S.isWindows?c.length>3?!1:N(O)&&(c.length===2||O.charCodeAt(2)===92):O===w.posix.sep}e.isRootOrDriveLetter=z;function N(c,O=S.isWindows){return O?v(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=N;function E(c,O=S.isWindows){return N(c,O)?c[0]:void 0}e.getDriveLetter=E;function d(c,O,M){return O.length>c.length?-1:c===O?0:(M&&(c=c.toLowerCase(),O=O.toLowerCase()),c.indexOf(O))}e.indexOfPath=d;function g(c){const O=c.split(":");let M,y,f;for(const R of O){const B=Number(R);(0,L.isNumber)(B)?y===void 0?y=B:f===void 0&&(f=B):M=M?[M,R].join(":"):R}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:y!==void 0?y:void 0,column:f!==void 0?f:y!==void 0?1:void 0}}e.parseLineAndColumnAware=g;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U(c,O,M=8){let y="";for(let R=0;R<M;R++){let B;R===0&&S.isWindows&&!O&&(M===3||M===4)?B=I:B=b,y+=B.charAt(Math.floor(Math.random()*B.length))}let f;return O?f=`${O}-${y}`:f=y,c?(0,w.join)(c,f):f}e.randomPath=U}),define(q[30],K([0,1,4,5,16]),function(D,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(i){i.inMemory="inmemory",i.vscode="vscode",i.internal="private",i.walkThrough="walkThrough",i.walkThroughSnippet="walkThroughSnippet",i.http="http",i.https="https",i.file="file",i.mailto="mailto",i.untitled="untitled",i.data="data",i.command="command",i.vscodeRemote="vscode-remote",i.vscodeRemoteResource="vscode-remote-resource",i.vscodeUserData="vscode-userdata",i.vscodeCustomEditor="vscode-custom-editor",i.vscodeNotebookCell="vscode-notebook-cell",i.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",i.vscodeNotebookCellOutput="vscode-notebook-cell-output",i.vscodeInteractive="vscode-interactive",i.vscodeInteractiveInput="vscode-interactive-input",i.vscodeSettings="vscode-settings",i.vscodeWorkspaceTrust="vscode-workspace-trust",i.vscodeTerminal="vscode-terminal",i.vscodeChatSesssion="vscode-chat-editor",i.webviewPanel="webview-panel",i.vscodeWebview="vscode-webview",i.extension="extension",i.vscodeFileResource="vscode-file",i.tmp="tmp",i.vsls="vsls",i.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class r{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(n){this._preferredWebSchema=n}setDelegate(n){this._delegate=n}setServerRootPath(n){this._remoteResourcesPath=`${n}/${L.vscodeRemoteResource}`}set(n,s,_){this._hosts[n]=s,this._ports[n]=_}setConnectionToken(n,s){this._connectionTokens[n]=s}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(n){if(this._delegate)try{return this._delegate(n)}catch(u){return w.onUnexpectedError(u),n}const s=n.authority;let _=this._hosts[s];_&&_.indexOf(":")!==-1&&_.indexOf("[")===-1&&(_=`[${_}]`);const m=this._ports[s],a=this._connectionTokens[s];let o=`path=${encodeURIComponent(n.path)}`;return typeof a=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(a)}`),k.URI.from({scheme:S.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${_}:${m}`,path:this._remoteResourcesPath,query:o})}}e.RemoteAuthorities=new r,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{asBrowserUri(n){const s=this.toUri(n,D);return this.uriToBrowserUri(s)}uriToBrowserUri(n){return n.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===L.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${L.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?n.with({scheme:L.vscodeFileResource,authority:n.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(n){const s=this.toUri(n,D);return this.uriToFileUri(s)}uriToFileUri(n){return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==h.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(n,s){return k.URI.isUri(n)?n:k.URI.parse(s.toUrl(n))}}h.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new h;var t;(function(i){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);i.CoopAndCoep=Object.freeze(n.get("3"));const s="vscode-coi";function _(a){let o;typeof a=="string"?o=new URL(a).searchParams:a instanceof URL?o=a.searchParams:k.URI.isUri(a)&&(o=new URL(a.toString(!0)).searchParams);const u=o?.get(s);if(u)return n.get(u)}i.getHeadersFromQuery=_;function m(a,o,u){if(!globalThis.crossOriginIsolated)return;const v=o&&u?"3":u?"2":"1";a instanceof URLSearchParams?a.set(s,v):a[s]=v}i.addSearchParam=m})(t||(e.COI=t={}))}),define(q[17],K([0,1,27,30,28,5,29,16]),function(D,e,w,S,k,L,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(m){return(0,h.uriToFsPath)(m,!0)}e.originalFSPath=t;class i{constructor(a){this._ignorePathCasing=a}compare(a,o,u=!1){return a===o?0:(0,r.compare)(this.getComparisonKey(a,u),this.getComparisonKey(o,u))}isEqual(a,o,u=!1){return a===o?!0:!a||!o?!1:this.getComparisonKey(a,u)===this.getComparisonKey(o,u)}getComparisonKey(a,o=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,o,u=!1){if(a.scheme===o.scheme){if(a.scheme===S.Schemas.file)return w.isEqualOrParent(t(a),t(o),this._ignorePathCasing(a))&&a.query===o.query&&(u||a.fragment===o.fragment);if((0,e.isEqualAuthority)(a.authority,o.authority))return w.isEqualOrParent(a.path,o.path,this._ignorePathCasing(a),"/")&&a.query===o.query&&(u||a.fragment===o.fragment)}return!1}joinPath(a,...o){return h.URI.joinPath(a,...o)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return k.posix.basename(a.path)}extname(a){return k.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let o;return a.scheme===S.Schemas.file?o=h.URI.file(k.dirname(t(a))).path:(o=k.posix.dirname(a.path),a.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),o="/")),a.with({path:o})}normalizePath(a){if(!a.path.length)return a;let o;return a.scheme===S.Schemas.file?o=h.URI.file(k.normalize(t(a))).path:o=k.posix.normalize(a.path),a.with({path:o})}relativePath(a,o){if(a.scheme!==o.scheme||!(0,e.isEqualAuthority)(a.authority,o.authority))return;if(a.scheme===S.Schemas.file){const P=k.relative(t(a),t(o));return L.isWindows?w.toSlashes(P):P}let u=a.path||"/";const v=o.path||"/";if(this._ignorePathCasing(a)){let P=0;for(const z=Math.min(u.length,v.length);P<z&&!(u.charCodeAt(P)!==v.charCodeAt(P)&&u.charAt(P).toLowerCase()!==v.charAt(P).toLowerCase());P++);u=v.substr(0,P)+u.substr(P)}return k.posix.relative(u,v)}resolvePath(a,o){if(a.scheme===S.Schemas.file){const u=h.URI.file(k.resolve(t(a),o));return a.with({authority:u.authority,path:u.path})}return o=w.toPosixPath(o),a.with({path:k.posix.resolve(a.path,o)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,o){return a===o||a!==void 0&&o!==void 0&&(0,r.equalsIgnoreCase)(a,o)}hasTrailingPathSeparator(a,o=k.sep){if(a.scheme===S.Schemas.file){const u=t(a);return u.length>w.getRoot(u).length&&u[u.length-1]===o}else{const u=a.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,o=k.sep){return(0,e.hasTrailingPathSeparator)(a,o)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,o=k.sep){let u=!1;if(a.scheme===S.Schemas.file){const v=t(a);u=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===o}else{o="/";const v=a.path;u=v.length===1&&v.charCodeAt(v.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(a,o)?a.with({path:a.path+"/"}):a}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(m=>m.scheme===S.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new i(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,a){const o=[];for(let u=0;u<m.length;u++){const v=a(m[u]);m.some((P,z)=>z===u?!1:(0,e.isEqualOrParent)(v,a(P)))||o.push(m[u])}return o}e.distinctParents=n;var s;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function a(o){const u=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(z=>{const[N,E]=z.split(":");N&&E&&u.set(N,E)});const P=o.path.substring(0,o.path.indexOf(";"));return P&&u.set(m.META_DATA_MIME,P),u}m.parseMetaData=a})(s||(e.DataUri=s={}));function _(m,a,o){if(a){let u=m.path;return u&&u[0]!==k.posix.sep&&(u=k.posix.sep+u),m.with({scheme:o,authority:a,path:u})}return m.with({scheme:o})}e.toLocalResource=_}),define(q[18],K([0,1,43,4,31,2,17,5,22]),function(D,e,w,S,k,L,r,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function i(p){return!!p&&typeof p.then=="function"}e.isThenable=i;function n(p){const l=new w.CancellationTokenSource,T=p(l.token),C=new Promise((A,F)=>{const H=l.token.onCancellationRequested(()=>{H.dispose(),l.dispose(),F(new S.CancellationError)});Promise.resolve(T).then(Q=>{H.dispose(),l.dispose(),A(Q)},Q=>{H.dispose(),l.dispose(),F(Q)})});return new class{cancel(){l.cancel()}then(A,F){return C.then(A,F)}catch(A){return this.then(void 0,A)}finally(A){return C.finally(A)}}}e.createCancelablePromise=n;function s(p,l,T){return new Promise((C,A)=>{const F=l.onCancellationRequested(()=>{F.dispose(),C(T)});p.then(C,A).finally(()=>F.dispose())})}e.raceCancellation=s;function _(p,l){return new Promise((T,C)=>{const A=l.onCancellationRequested(()=>{A.dispose(),C(new S.CancellationError)});p.then(T,C).finally(()=>A.dispose())})}e.raceCancellationError=_;async function m(p){let l=-1;const T=p.map((C,A)=>C.then(F=>(l=A,F)));try{return await Promise.race(T)}finally{p.forEach((C,A)=>{A!==l&&C.cancel()})}}e.raceCancellablePromises=m;function a(p,l,T){let C;const A=setTimeout(()=>{C?.(void 0),T?.()},l);return Promise.race([p.finally(()=>clearTimeout(A)),new Promise(F=>C=F)])}e.raceTimeout=a;function o(p){return new Promise((l,T)=>{const C=p();i(C)?C.then(l,T):l(C)})}e.asPromise=o;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(T,T).then(C)})}return new Promise((T,C)=>{this.queuedPromise.then(T,C)})}return this.activePromise=l(),new Promise((T,C)=>{this.activePromise.then(A=>{this.activePromise=null,T(A)},A=>{this.activePromise=null,C(A)})})}}e.Throttler=u;class v{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}e.Sequencer=v;class P{constructor(){this.promiseMap=new Map}queue(l,T){const A=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(l)===A&&this.promiseMap.delete(l)});return this.promiseMap.set(l,A),A}}e.SequencerByKey=P;const z=(p,l)=>{let T=!0;const C=setTimeout(()=>{T=!1,l()},p);return{isTriggered:()=>T,dispose:()=>{clearTimeout(C),T=!1}}},N=p=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,p())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class E{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,T=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((A,F)=>{this.doResolve=A,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const A=this.task;return this.task=null,A()}}));const C=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===t.MicrotaskDelay?N(C):z(T,C),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new S.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class d{constructor(l){this.delayer=new E(l),this.throttler=new u}trigger(l,T){return this.delayer.trigger(()=>this.throttler.queue(l),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class g{constructor(){this._isOpen=!1,this._promise=new Promise((l,T)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class b extends g{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=b;function I(p,l){return l?new Promise((T,C)=>{const A=setTimeout(()=>{F.dispose(),T()},p),F=l.onCancellationRequested(()=>{clearTimeout(A),F.dispose(),C(new S.CancellationError)})}):n(T=>I(p,T))}e.timeout=I;function U(p,l=0){const T=setTimeout(p,l);return(0,L.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=U;function c(p){const l=[];let T=0;const C=p.length;function A(){return T<C?p[T++]():null}function F(H){H!=null&&l.push(H);const Q=A();return Q?Q.then(F):Promise.resolve(l)}return Promise.resolve(null).then(F)}e.sequence=c;function O(p,l=C=>!!C,T=null){let C=0;const A=p.length,F=()=>{if(C>=A)return Promise.resolve(T);const H=p[C++];return Promise.resolve(H()).then(X=>l(X)?Promise.resolve(X):F())};return F()}e.first=O;function M(p,l=C=>!!C,T=null){if(p.length===0)return Promise.resolve(T);let C=p.length;const A=()=>{C=-1;for(const F of p)F.cancel?.()};return new Promise((F,H)=>{for(const Q of p)Q.then(X=>{--C>=0&&l(X)?(A(),F(X)):C===0&&F(T)}).catch(X=>{--C>=0&&(A(),H(X))})})}e.firstParallel=M;class y{constructor(l){this._size=0,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){return this._size++,new Promise((T,C)=>{this.outstandingPromises.push({factory:l,c:T,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const T=l.factory();T.then(l.c,l.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class f extends y{constructor(){super(1)}}e.Queue=f;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const l=new ee;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueFor(l,T=r.extUri){const C=T.getComparisonKey(l);let A=this.queues.get(C);return A||(A=new f,k.Event.once(A.onDrained)(()=>{A?.dispose(),this.queues.delete(C),this.onDidQueueDrain()}),this.queues.set(C,A)),A}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class B{constructor(l,T){this._token=-1,typeof l=="function"&&typeof T=="number"&&this.setIfNotSet(l,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},T)}setIfNotSet(l,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},T))}}e.TimeoutTimer=B;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(l,T){this.cancel(),this._token=setInterval(()=>{l()},T)}}e.IntervalTimer=j;class G{constructor(l,T){this.timeoutToken=-1,this.runner=l,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=G;class ${constructor(l,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class W extends G{constructor(l,T){super(l,T),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class V extends L.Disposable{constructor(l,T){super(),this.options=l,this.handler=T,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of l)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=p=>{(0,h.setTimeout0)(()=>{if(l)return;const T=Date.now()+15;p(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:e.runWhenIdle=(p,l)=>{const T=requestIdleCallback(p,typeof l=="number"?{timeout:l}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(T))}}}}();class Z{constructor(l){this._didRun=!1,this._executor=()=>{try{this._value=l()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Z;async function J(p,l,T){let C;for(let A=0;A<T;A++)try{return await p()}catch(F){C=F,await I(l)}throw C}e.retry=J;class oe{hasPending(l){return this._pending?typeof l=="number"?this._pending.taskId===l:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(l,T,C){return this._pending={taskId:l,cancel:()=>C?.(),promise:T},T.then(()=>this.donePending(l),()=>this.donePending(l)),T}donePending(l){this._pending&&l===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const l=this._next;this._next=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}setNext(l){if(this._next)this._next.run=l;else{let T,C;const A=new Promise((F,H)=>{T=F,C=H});this._next={run:l,promise:A,promiseResolve:T,promiseReject:C}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=oe;class ae{constructor(l,T=()=>Date.now()){this.interval=l,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var x;(function(p){p[p.Resolved=0]="Resolved",p[p.Rejected=1]="Rejected"})(x||(x={}));class ee{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,T)=>{this.completeCallback=l,this.errorCallback=T})}complete(l){return new Promise(T=>{this.completeCallback(l),this.outcome={outcome:0,value:l},T()})}error(l){return new Promise(T=>{this.errorCallback(l),this.outcome={outcome:1,value:l},T()})}cancel(){return this.error(new S.CancellationError)}}e.DeferredPromise=ee;var te;(function(p){async function l(C){let A;const F=await Promise.all(C.map(H=>H.then(Q=>Q,Q=>{A||(A=Q)})));if(typeof A<"u")throw A;return F}p.settled=l;function T(C){return new Promise(async(A,F)=>{try{await C(A,F)}catch(H){F(H)}})}p.withAsyncBody=T})(te||(e.Promises=te={}));var ne;(function(p){p[p.Initial=0]="Initial",p[p.DoneOK=1]="DoneOK",p[p.DoneError=2]="DoneError"})(ne||(ne={}));class Y{static fromArray(l){return new Y(T=>{T.emitMany(l)})}static fromPromise(l){return new Y(async T=>{T.emitMany(await l)})}static fromPromises(l){return new Y(async T=>{await Promise.all(l.map(async C=>T.emitOne(await C)))})}static merge(l){return new Y(async T=>{await Promise.all(l.map(async C=>{for await(const A of C)T.emitOne(A)}))})}constructor(l){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const T={emitOne:C=>this.emitOne(C),emitMany:C=>this.emitMany(C),reject:C=>this.reject(C)};try{await Promise.resolve(l(T)),this.resolve()}catch(C){this.reject(C)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(l,T){return new Y(async C=>{for await(const A of l)C.emitOne(T(A))})}map(l){return Y.map(this,l)}static filter(l,T){return new Y(async C=>{for await(const A of l)T(A)&&C.emitOne(A)})}filter(l){return Y.filter(this,l)}static coalesce(l){return Y.filter(l,T=>!!T)}coalesce(){return Y.coalesce(this)}static async toPromise(l){const T=[];for await(const C of l)T.push(C);return T}toPromise(){return Y.toPromise(this)}emitOne(l){this._state===0&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===0&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(l){this._state===0&&(this._state=2,this._error=l,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ie extends Y{constructor(l,T){super(T),this._source=l}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function ue(p){const l=new w.CancellationTokenSource,T=p(l.token);return new ie(l,async C=>{const A=l.token.onCancellationRequested(()=>{A.dispose(),l.dispose(),C.reject(new S.CancellationError)});try{for await(const F of T){if(l.token.isCancellationRequested)return;C.emitOne(F)}A.dispose(),l.dispose()}catch(F){A.dispose(),l.dispose(),C.reject(F)}})}e.createCancelableAsyncIterable=ue}),define(q[19],K([0,1,32]),function(D,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(L){return this===L}};function S(L,r){return new w.TokenizationResult([new w.Token(0,"",L)],r)}e.nullTokenize=S;function k(L,r){const h=new Uint32Array(2);return h[0]=0,h[1]=(L<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new w.EncodedTokenizationResult(h,r===null?e.NullState:r)}e.nullTokenizeEncoded=k}),define(q[33],K([0,1,18,4,5,44,12,14,45,19,23,15,7]),function(D,e,w,S,k,L,r,h,t,i,n,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var m;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(m||(m={}));class a{constructor(d,g){this.tokenizationSupport=g,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new u(d)}getStartState(d){return d===1?this.initialState:this.store.getEndState(d-1)}}e.TokenizerWithStateStore=a;class o extends a{constructor(d,g,b,I){super(d,g),this._textModel=b,this._languageIdCodec=I}updateTokensUntilLine(d,g){const b=this._textModel.getLanguageId();for(;;){const I=this.store.getFirstInvalidEndStateLineNumber();if(!I||I>g)break;const U=this._textModel.getLineContent(I),c=this.getStartState(I),O=z(this._languageIdCodec,b,this.tokenizationSupport,U,!0,c);d.add(I,O.tokens),this.store.setEndState(I,O.endState)}}getTokenTypeIfInsertingCharacter(d,g){const b=this.getStartState(d.lineNumber);if(!b)return 0;const I=this._textModel.getLanguageId(),U=this._textModel.getLineContent(d.lineNumber),c=U.substring(0,d.column-1)+g+U.substring(d.column-1),O=z(this._languageIdCodec,I,this.tokenizationSupport,c,!0,b),M=new _.LineTokens(O.tokens,c,this._languageIdCodec);if(M.getCount()===0)return 0;const y=M.findTokenIndexAtOffset(d.column-1);return M.getStandardTokenType(y)}tokenizeLineWithEdit(d,g,b){const I=d.lineNumber,U=d.column,c=this.getStartState(I);if(!c)return null;const O=this._textModel.getLineContent(I),M=O.substring(0,U-1)+b+O.substring(U-1+g),y=this._textModel.getLanguageIdAtPosition(I,0),f=z(this._languageIdCodec,y,this.tokenizationSupport,M,!0,c);return new _.LineTokens(f.tokens,M,this._languageIdCodec)}isCheapToTokenize(d){const g=this.store.getFirstInvalidEndStateLineNumberOrMax();return d<g||d===g&&this._textModel.getLineLength(d)<2048}tokenizeHeuristically(d,g,b){if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(g<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(d,b),{heuristicTokens:!1};let I=this.guessStartState(g);const U=this._textModel.getLanguageId();for(let c=g;c<=b;c++){const O=this._textModel.getLineContent(c),M=z(this._languageIdCodec,U,this.tokenizationSupport,O,!0,I);d.add(c,M.tokens),I=M.endState}return{heuristicTokens:!0}}guessStartState(d){let g=this._textModel.getLineFirstNonWhitespaceColumn(d);const b=[];let I=null;for(let O=d-1;g>1&&O>=1;O--){const M=this._textModel.getLineFirstNonWhitespaceColumn(O);if(M!==0&&M<g&&(b.push(this._textModel.getLineContent(O)),g=M,I=this.getStartState(O),I))break}I||(I=this.tokenizationSupport.getInitialState()),b.reverse();const U=this._textModel.getLanguageId();let c=I;for(const O of b)c=z(this._languageIdCodec,U,this.tokenizationSupport,O,!1,c).endState;return c}}e.TokenizerWithStateStoreAndTextModel=o;class u{constructor(d){this.lineCount=d,this.tokenizationStateStore=new v,this._invalidEndStatesLineNumbers=new P,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,d+1))}getEndState(d){return this.tokenizationStateStore.getEndState(d)}setEndState(d,g){for(;;){const I=this._invalidEndStatesLineNumbers.min;if(I!==null&&I<=d)this._invalidEndStatesLineNumbers.removeMin();else break}const b=this.tokenizationStateStore.setEndState(d,g);return b&&d<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(d+1,d+2)),b}acceptChange(d,g){this.lineCount+=g-d.length,this.tokenizationStateStore.acceptChange(d,g),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(d.startLineNumber,d.endLineNumberExclusive),g)}acceptChanges(d){for(const g of d){const[b]=(0,r.countEOL)(g.text);this.acceptChange(new h.LineRange(g.range.startLineNumber,g.range.endLineNumber+1),b+1)}}invalidateEndStateRange(d){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(d.startLineNumber,d.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this._invalidEndStatesLineNumbers.min||Number.MAX_SAFE_INTEGER}isTokenizationComplete(){return this._invalidEndStatesLineNumbers.min===null}}e.TrackingTokenizationStateStore=u;class v{constructor(){this._lineEndStates=new n.FixedArray(null)}getEndState(d){return this._lineEndStates.get(d)}setEndState(d,g){const b=this._lineEndStates.get(d);return b&&b.equals(g)?!1:(this._lineEndStates.set(d,g),!0)}acceptChange(d,g){let b=d.length;g>0&&b>0&&(b--,g--),this._lineEndStates.replace(d.startLineNumber,b,g)}acceptChanges(d){for(const g of d){const[b]=(0,r.countEOL)(g.text);this.acceptChange(new h.LineRange(g.range.startLineNumber,g.range.endLineNumber+1),b+1)}}}e.TokenizationStateStore=v;class P{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const d=this._ranges[0];return d.start+1===d.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(d.start+1,d.endExclusive),d.start}addRange(d){t.OffsetRange.addRange(d,this._ranges)}addRangeAndResize(d,g){let b=0;for(;!(b>=this._ranges.length||d.start<=this._ranges[b].endExclusive);)b++;let I=b;for(;!(I>=this._ranges.length||d.endExclusive<this._ranges[I].start);)I++;const U=g-d.length;for(let c=I;c<this._ranges.length;c++)this._ranges[c]=this._ranges[c].delta(U);if(b===I){const c=new t.OffsetRange(d.start,d.start+g);c.isEmpty||this._ranges.splice(b,0,c)}else{const c=Math.min(d.start,this._ranges[b].start),O=Math.max(d.endExclusive,this._ranges[I-1].endExclusive),M=new t.OffsetRange(c,O+U);M.isEmpty?this._ranges.splice(b,I-b):this._ranges.splice(b,I-b,M)}}toString(){return this._ranges.map(d=>d.toString()).join(" + ")}}e.RangePriorityQueueImpl=P;function z(E,d,g,b,I,U){let c=null;if(g)try{c=g.tokenizeEncoded(b,I,U.clone())}catch(O){(0,S.onUnexpectedError)(O)}return c||(c=(0,i.nullTokenizeEncoded)(E.encodeLanguageId(d),U)),_.LineTokens.convertToEndOffset(c.tokens,b.length),c}class N{constructor(d,g){this._tokenizerWithStateStore=d,this._backgroundTokenStore=g,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,w.runWhenIdle)(d=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(d)}))}_backgroundTokenizeWithDeadline(d){const g=Date.now()+d.timeRemaining(),b=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<g?(0,k.setTimeout0)(b):this._beginBackgroundTokenization())};b()}_backgroundTokenizeForAtLeast1ms(){const d=this._tokenizerWithStateStore._textModel.getLineCount(),g=new s.ContiguousMultilineTokensBuilder,b=L.StopWatch.create(!1);do if(b.elapsed()>1||this._tokenizeOneInvalidLine(g)>=d)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(g.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.isTokenizationComplete():!1}_tokenizeOneInvalidLine(d){if(!this._tokenizerWithStateStore||!this._hasLinesToTokenize())return this._tokenizerWithStateStore._textModel.getLineCount()+1;const g=this._tokenizerWithStateStore.store.getFirstInvalidEndStateLineNumber();return this._tokenizerWithStateStore.updateTokensUntilLine(d,g),g}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.isTokenizationComplete()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(d,g){this._tokenizerWithStateStore.store.invalidateEndStateRange(new h.LineRange(d,g))}}e.DefaultBackgroundTokenizer=N}),define(q[34],K([0,1,31,2,13,32]),function(D,e,w,S,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class r extends S.Disposable{constructor(t,i,n,s,_=()=>!1){super(),this._grammar=t,this._initialState=i,this._containsEmbeddedLanguages=n,this._createBackgroundTokenizer=s,this._backgroundTokenizerShouldOnlyVerifyTokens=_,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new w.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(t,i,n){throw new Error("Not supported!")}createBackgroundTokenizer(t,i){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(t,i)}tokenizeEncoded(t,i,n){const s=this._grammar.tokenizeLine2(t,n,500);if(s.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${t.substring(0,100)}`),new L.EncodedTokenizationResult(s.tokens,n);if(this._containsEmbeddedLanguages){const m=this._seenLanguages,a=s.tokens;for(let o=0,u=a.length>>>1;o<u;o++){const v=a[(o<<1)+1],P=k.TokenMetadata.getLanguageId(v);m[P]||(m[P]=!0,this._onDidEncounterLanguage.fire(P))}}let _;return n.equals(s.ruleStack)?_=n:_=s.ruleStack,new L.EncodedTokenizationResult(s.tokens,_)}}e.TextMateTokenizationSupport=r}),define(q[35],K([0,1,19,2,10]),function(D,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class L extends S.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(h,t,i){super(),this._encodedLanguageId=h,this._actual=t,this._maxTokenizationLineLength=i,this._register((0,k.keepAlive)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(h,t,i){throw new Error("Not supported!")}tokenizeEncoded(h,t,i){return h.length>=this._maxTokenizationLineLength.get()?(0,w.nullTokenizeEncoded)(this._encodedLanguageId,i):this._actual.tokenizeEncoded(h,t,i)}createBackgroundTokenizer(h,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=L}),define(q[36],K([0,1,17]),function(D,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class S{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(L){if(this._scopeNameToLanguageRegistration[L.scopeName]){const r=this._scopeNameToLanguageRegistration[L.scopeName];w.isEqual(r.location,L.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${L.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${L.location.toString()}`)}this._scopeNameToLanguageRegistration[L.scopeName]=L}getGrammarDefinition(L){return this._scopeNameToLanguageRegistration[L]||null}}e.TMScopeRegistry=S}),define(q[37],K([0,1,2,36]),function(D,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends w.Disposable{constructor(r,h,t,i){super(),this._host=r,this._initialState=t.INITIAL,this._scopeRegistry=new S.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:i,loadGrammar:async n=>{const s=this._scopeRegistry.getGrammarDefinition(n);if(!s)return this._host.logTrace(`No grammar found for scope ${n}`),null;const _=s.location;try{const m=await this._host.readFile(_);return t.parseRawGrammar(m,_.path)}catch(m){return this._host.logError(`Unable to load and parse grammar for scope ${n} from ${_}`,m),null}},getInjections:n=>{const s=n.split(".");let _=[];for(let m=1;m<=s.length;m++){const a=s.slice(0,m).join(".");_=[..._,...this._injections[a]||[]]}return _}}));for(const n of h){if(this._scopeRegistry.register(n),n.injectTo){for(const s of n.injectTo){let _=this._injections[s];_||(this._injections[s]=_=[]),_.push(n.scopeName)}if(n.embeddedLanguages)for(const s of n.injectTo){let _=this._injectedEmbeddedLanguages[s];_||(this._injectedEmbeddedLanguages[s]=_=[]),_.push(n.embeddedLanguages)}}n.language&&this._languageToScope.set(n.language,n.scopeName)}}has(r){return this._languageToScope.has(r)}setTheme(r,h){this._grammarRegistry.setTheme(r,h)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(r,h){const t=this._languageToScope.get(r);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const i=this._scopeRegistry.getGrammarDefinition(t);if(!i)throw new Error(e.missingTMGrammarErrorMessage);const n=i.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const m=this._injectedEmbeddedLanguages[t];for(const a of m)for(const o of Object.keys(a))n[o]=a[o]}const s=Object.keys(n).length>0;let _;try{_=await this._grammarRegistry.loadGrammarWithConfiguration(t,h,{embeddedLanguages:n,tokenTypes:i.tokenTypes,balancedBracketSelectors:i.balancedBracketSelectors,unbalancedBracketSelectors:i.unbalancedBracketSelectors})}catch(m){throw m.message&&m.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):m}return{languageId:r,grammar:_,initialState:this._initialState,containsEmbeddedLanguages:s}}}e.TMGrammarFactory=k}),define(q[38],K([0,1,46,33,47,15,7,34,18,10,35,14]),function(D,e,w,S,k,L,r,h,t,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class _ extends w.MirrorTextModel{constructor(o,u,v,P,z,N,E,d){super(o,u,v,P),this._worker=z,this._languageId=N,this._encodedLanguageId=E,this._tokenizationStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,i.observableValue)("_maxTokenizationLineLength",-1),this.tokenizeDebouncer=new t.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(d,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(o,u){this._languageId=o,this._encodedLanguageId=u,this._resetTokenization()}onEvents(o){super.onEvents(o),this._tokenizationStateStore&&this._tokenizationStateStore.store.acceptChanges(o.changes),this.tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(o){this._maxTokenizationLineLength.set(o,void 0)}retokenize(o,u){this._tokenizationStateStore&&(this._tokenizationStateStore.store.invalidateEndStateRange(new s.LineRange(o,u)),this.tokenizeDebouncer.schedule())}_resetTokenization(){this._tokenizationStateStore=null;const o=this._languageId,u=this._encodedLanguageId;this._worker.getOrCreateGrammar(o,u).then(v=>{if(!(this._isDisposed||o!==this._languageId||u!==this._encodedLanguageId||!v)){if(v.grammar){const P=new n.TokenizationSupportWithLineLimit(this._encodedLanguageId,new h.TextMateTokenizationSupport(v.grammar,v.initialState,!1),this._maxTokenizationLineLength);this._tokenizationStateStore=new S.TokenizerWithStateStore(this._lines.length,P)}else this._tokenizationStateStore=null;this._tokenize()}})}_tokenize(){if(this._isDisposed||!this._tokenizationStateStore)return;const o=new Date().getTime();for(;;){let u=0;const v=new L.ContiguousMultilineTokensBuilder,P=new m;for(;;){const E=this._tokenizationStateStore.store.getFirstInvalidEndStateLineNumber();if(E===null||u>200)break;u++;const d=this._lines[E-1],g=this._tokenizationStateStore.getStartState(E),b=this._tokenizationStateStore.tokenizationSupport.tokenizeEncoded(d,!0,g);if(this._tokenizationStateStore.store.setEndState(E,b.endState)){const U=(0,k.diffStateStacksRefEq)(g,b.endState);P.setState(E,U)}else P.setState(E,null);if(r.LineTokens.convertToEndOffset(b.tokens,d.length),v.add(E,b.tokens),new Date().getTime()-o>20)break}if(u===0)break;const z=P.getStateDeltas();if(this._worker.setTokensAndStates(this._uri,this._versionId,v.serialize(),z),new Date().getTime()-o>20){setTimeout(()=>this._tokenize(),3);return}}}}e.TextMateWorkerModel=_;class m{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(o,u){o===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(u):this._stateDeltas.push({startLineNumber:o,stateDeltas:[u]}),this._lastStartLineNumber=o}getStateDeltas(){return this._stateDeltas}}}),define(q[48],K([0,1,16,37,38]),function(D,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class L{constructor(t,i){this.createData=i,this._models=Object.create(null),this._grammarCache=[],this._host=t.host;const n=i.grammarDefinitions.map(s=>({location:w.URI.revive(s.location),language:s.language,scopeName:s.scopeName,embeddedLanguages:s.embeddedLanguages,tokenTypes:s.tokenTypes,injectTo:s.injectTo,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors}));this._grammarFactory=this._loadTMGrammarFactory(n)}async _loadTMGrammarFactory(t){const i=this.createData.textmateMainUri,n=await new Promise((o,u)=>{D([i],o,u)}),s=await new Promise((o,u)=>{D([this.createData.onigurumaMainUri],o,u)}),m=await(await fetch(this.createData.onigurumaWASMUri)).arrayBuffer();await s.loadWASM(m);const a=Promise.resolve({createOnigScanner:o=>s.createOnigScanner(o),createOnigString:o=>s.createOnigString(o)});return new S.TMGrammarFactory({logTrace:o=>{},logError:(o,u)=>console.error(o,u),readFile:o=>this._host.readFile(o)},t,n,a)}acceptNewModel(t){const i=w.URI.revive(t.uri),n=i.toString();this._models[n]=new k.TextMateWorkerModel(i,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,i){this._models[t].onEvents(i)}retokenize(t,i,n){this._models[t].retokenize(i,n)}acceptModelLanguageChanged(t,i,n){this._models[t].onLanguageId(i,n)}acceptRemovedModel(t){this._models[t]&&(this._models[t].dispose(),delete this._models[t])}async acceptTheme(t,i){(await this._grammarFactory)?.setTheme(t,i)}acceptMaxTokenizationLineLength(t,i){this._models[t].acceptMaxTokenizationLineLength(i)}async getOrCreateGrammar(t,i){const n=await this._grammarFactory;return n?(this._grammarCache[i]||(this._grammarCache[i]=n.createGrammar(t,i)),this._grammarCache[i]):Promise.resolve(null)}setTokensAndStates(t,i,n,s){this._host.setTokensAndStates(t,i,n,s)}}e.TextMateTokenizationWorker=L;function r(h,t){return new L(h,t)}e.create=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19c0f5cefaeb2637b45a9c7a356151fcfdcda1e9/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
